#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 11098
#define SYMBOL_COUNT 270
#define ALIAS_COUNT 7
#define TOKEN_COUNT 144
#define EXTERNAL_TOKEN_COUNT 22
#define MAX_ALIAS_SEQUENCE_LENGTH 6

enum {
  sym__line_break = 1,
  sym__simple_symbol = 2,
  sym__string_start = 3,
  sym__symbol_start = 4,
  sym__subshell_start = 5,
  sym__regex_start = 6,
  sym__string_array_start = 7,
  sym__symbol_array_start = 8,
  sym__heredoc_body_start = 9,
  sym__string_content = 10,
  sym__heredoc_content = 11,
  sym__string_end = 12,
  sym_heredoc_end = 13,
  sym_heredoc_beginning = 14,
  sym__block_ampersand = 15,
  sym__splat_star = 16,
  sym__unary_minus = 17,
  sym__binary_minus = 18,
  sym__binary_star = 19,
  sym__singleton_class_left_angle_left_langle = 20,
  sym__identifier_hash_key = 21,
  anon_sym___END__ = 22,
  sym_uninterpreted = 23,
  anon_sym_BEGIN = 24,
  anon_sym_LBRACE = 25,
  anon_sym_RBRACE = 26,
  anon_sym_END = 27,
  anon_sym_def = 28,
  anon_sym_LPAREN = 29,
  anon_sym_RPAREN = 30,
  anon_sym_DOT = 31,
  anon_sym_COLON_COLON = 32,
  anon_sym_COMMA = 33,
  anon_sym_PIPE = 34,
  anon_sym_SEMI = 35,
  anon_sym_STAR = 36,
  anon_sym_STAR_STAR = 37,
  anon_sym_AMP = 38,
  anon_sym_COLON = 39,
  anon_sym_EQ = 40,
  anon_sym_class = 41,
  anon_sym_LT = 42,
  anon_sym_module = 43,
  anon_sym_end = 44,
  anon_sym_return = 45,
  anon_sym_yield = 46,
  anon_sym_break = 47,
  anon_sym_next = 48,
  sym_redo = 49,
  sym_retry = 50,
  anon_sym_if = 51,
  anon_sym_unless = 52,
  anon_sym_while = 53,
  anon_sym_until = 54,
  anon_sym_rescue = 55,
  anon_sym_for = 56,
  anon_sym_in = 57,
  anon_sym_do = 58,
  anon_sym_case = 59,
  anon_sym_when = 60,
  anon_sym_elsif = 61,
  anon_sym_else = 62,
  anon_sym_then = 63,
  anon_sym_begin = 64,
  anon_sym_ensure = 65,
  anon_sym_EQ_GT = 66,
  anon_sym_LBRACK = 67,
  anon_sym_RBRACK = 68,
  anon_sym_COLON_COLON2 = 69,
  anon_sym_AMP_DOT = 70,
  anon_sym_LPAREN2 = 71,
  anon_sym_PLUS_EQ = 72,
  anon_sym_DASH_EQ = 73,
  anon_sym_STAR_EQ = 74,
  anon_sym_STAR_STAR_EQ = 75,
  anon_sym_SLASH_EQ = 76,
  anon_sym_PIPE_PIPE_EQ = 77,
  anon_sym_PIPE_EQ = 78,
  anon_sym_AMP_AMP_EQ = 79,
  anon_sym_AMP_EQ = 80,
  anon_sym_PERCENT_EQ = 81,
  anon_sym_GT_GT_EQ = 82,
  anon_sym_LT_LT_EQ = 83,
  anon_sym_CARET_EQ = 84,
  anon_sym_QMARK = 85,
  anon_sym_COLON2 = 86,
  anon_sym_DOT_DOT = 87,
  anon_sym_DOT_DOT_DOT = 88,
  anon_sym_and = 89,
  anon_sym_or = 90,
  anon_sym_PIPE_PIPE = 91,
  anon_sym_AMP_AMP = 92,
  anon_sym_LT_LT = 93,
  anon_sym_GT_GT = 94,
  anon_sym_EQ_EQ = 95,
  anon_sym_BANG_EQ = 96,
  anon_sym_EQ_EQ_EQ = 97,
  anon_sym_LT_EQ_GT = 98,
  anon_sym_EQ_TILDE = 99,
  anon_sym_BANG_TILDE = 100,
  anon_sym_LT_EQ = 101,
  anon_sym_GT = 102,
  anon_sym_GT_EQ = 103,
  anon_sym_CARET = 104,
  anon_sym_PLUS = 105,
  anon_sym_SLASH = 106,
  anon_sym_PERCENT = 107,
  anon_sym_defined_QMARK = 108,
  anon_sym_not = 109,
  anon_sym_BANG = 110,
  anon_sym_TILDE = 111,
  sym_constant = 112,
  sym_identifier = 113,
  sym_instance_variable = 114,
  sym_class_variable = 115,
  sym_global_variable = 116,
  anon_sym_DASH = 117,
  anon_sym_PLUS_AT = 118,
  anon_sym_DASH_AT = 119,
  anon_sym_LBRACK_RBRACK = 120,
  anon_sym_LBRACK_RBRACK_EQ = 121,
  anon_sym_BQUOTE = 122,
  anon_sym_undef = 123,
  anon_sym_alias = 124,
  sym_comment = 125,
  sym_integer = 126,
  sym_float = 127,
  sym_complex = 128,
  anon_sym_r = 129,
  sym_super = 130,
  anon_sym_true = 131,
  anon_sym_TRUE = 132,
  anon_sym_false = 133,
  anon_sym_FALSE = 134,
  sym_self = 135,
  anon_sym_nil = 136,
  anon_sym_NIL = 137,
  sym_character = 138,
  anon_sym_POUND_LBRACE = 139,
  aux_sym_SLASH_BSLASHs_PLUS_SLASH = 140,
  sym_escape_sequence = 141,
  anon_sym_LBRACK2 = 142,
  anon_sym_DASH_GT = 143,
  sym_program = 144,
  sym__statements = 145,
  sym__top_level_statement = 146,
  sym_begin_block = 147,
  sym_end_block = 148,
  sym__statement = 149,
  sym_method = 150,
  sym_singleton_method = 151,
  sym__method_rest = 152,
  sym_method_parameters = 153,
  sym_lambda_parameters = 154,
  sym_block_parameters = 155,
  sym__formal_parameter = 156,
  sym__simple_formal_parameter = 157,
  sym_destructured_parameter = 158,
  sym_splat_parameter = 159,
  sym_hash_splat_parameter = 160,
  sym_block_parameter = 161,
  sym_keyword_parameter = 162,
  sym_optional_parameter = 163,
  sym_class = 164,
  sym_superclass = 165,
  sym_singleton_class = 166,
  sym_module = 167,
  sym_return = 168,
  sym_yield = 169,
  sym_break = 170,
  sym_next = 171,
  sym_if_modifier = 172,
  sym_unless_modifier = 173,
  sym_while_modifier = 174,
  sym_until_modifier = 175,
  sym_rescue_modifier = 176,
  sym_while = 177,
  sym_until = 178,
  sym_for = 179,
  sym_in = 180,
  sym__do = 181,
  sym_case = 182,
  sym_when = 183,
  sym_pattern = 184,
  sym_if = 185,
  sym_unless = 186,
  sym_elsif = 187,
  sym_else = 188,
  sym__then = 189,
  sym__if_tail = 190,
  sym_begin = 191,
  sym_ensure = 192,
  sym_rescue = 193,
  sym_exceptions = 194,
  sym_exception_variable = 195,
  sym__body_statement = 196,
  sym__arg = 197,
  sym__primary = 198,
  sym_parenthesized_statements = 199,
  sym_element_reference = 200,
  sym_scope_resolution = 201,
  sym_call = 202,
  sym_method_call = 203,
  sym_argument_list = 204,
  sym_argument_list_with_parens = 205,
  sym__argument_list_with_parens = 206,
  sym__argument_list_with_trailing_comma = 207,
  sym__argument = 208,
  sym_splat_argument = 209,
  sym_hash_splat_argument = 210,
  sym_block_argument = 211,
  sym_do_block = 212,
  sym_block = 213,
  sym_assignment = 214,
  sym_operator_assignment = 215,
  sym_conditional = 216,
  sym_range = 217,
  sym_binary = 218,
  sym_unary = 219,
  sym_right_assignment_list = 220,
  sym__arg_or_splat_arg = 221,
  sym_left_assignment_list = 222,
  sym__mlhs = 223,
  sym__simple_mlhs = 224,
  sym_destructured_left_assignment = 225,
  sym_rest_assignment = 226,
  sym__lhs = 227,
  sym__variable = 228,
  sym_operator = 229,
  sym__method_name = 230,
  sym_setter = 231,
  sym_undef = 232,
  sym_alias = 233,
  sym_rational = 234,
  sym_true = 235,
  sym_false = 236,
  sym_nil = 237,
  sym_chained_string = 238,
  sym_interpolation = 239,
  sym_string = 240,
  sym_subshell = 241,
  sym_string_array = 242,
  sym_symbol_array = 243,
  sym_symbol = 244,
  sym_regex = 245,
  sym_heredoc_body = 246,
  sym__literal_contents = 247,
  sym_array = 248,
  sym_hash = 249,
  sym__hash_items = 250,
  sym_pair = 251,
  sym_lambda = 252,
  sym_empty_statement = 253,
  sym__terminator = 254,
  aux_sym__statements_repeat1 = 255,
  aux_sym_method_parameters_repeat1 = 256,
  aux_sym_lambda_parameters_repeat1 = 257,
  aux_sym_block_parameters_repeat1 = 258,
  aux_sym_case_repeat1 = 259,
  aux_sym_when_repeat1 = 260,
  aux_sym_exceptions_repeat1 = 261,
  aux_sym_call_repeat1 = 262,
  aux_sym_argument_list_repeat1 = 263,
  aux_sym_undef_repeat1 = 264,
  aux_sym_chained_string_repeat1 = 265,
  aux_sym_string_array_repeat1 = 266,
  aux_sym_symbol_array_repeat1 = 267,
  aux_sym_heredoc_body_repeat1 = 268,
  aux_sym__literal_contents_repeat1 = 269,
  anon_alias_sym_DQUOTE = 270,
  anon_alias_sym_RPAREN = 271,
  anon_alias_sym_SLASH = 272,
  anon_alias_sym_BQUOTE = 273,
  alias_sym_bare_string = 274,
  alias_sym_bare_symbol = 275,
  alias_sym_symbol = 276,
};

static const char *ts_symbol_names[] = {
  [sym__line_break] = "_line_break",
  [sym__simple_symbol] = "_simple_symbol",
  [sym__string_start] = "\"",
  [sym__symbol_start] = ":\"",
  [sym__subshell_start] = "`",
  [sym__regex_start] = "/",
  [sym__string_array_start] = "%w(",
  [sym__symbol_array_start] = "%i(",
  [sym__heredoc_body_start] = "_heredoc_body_start",
  [sym__string_content] = "_string_content",
  [sym__heredoc_content] = "_heredoc_content",
  [sym__string_end] = "_string_end",
  [sym_heredoc_end] = "heredoc_end",
  [sym_heredoc_beginning] = "heredoc_beginning",
  [sym__block_ampersand] = "_block_ampersand",
  [sym__splat_star] = "_splat_star",
  [sym__unary_minus] = "-",
  [sym__binary_minus] = "-",
  [sym__binary_star] = "*",
  [sym__singleton_class_left_angle_left_langle] = "<<",
  [sym__identifier_hash_key] = "symbol",
  [ts_builtin_sym_end] = "END",
  [anon_sym___END__] = "__END__",
  [sym_uninterpreted] = "uninterpreted",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_END] = "END",
  [anon_sym_def] = "def",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_SEMI] = ";",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_AMP] = "&",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_LT] = "<",
  [anon_sym_module] = "module",
  [anon_sym_end] = "end",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_break] = "break",
  [anon_sym_next] = "next",
  [sym_redo] = "redo",
  [sym_retry] = "retry",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [anon_sym_rescue] = "rescue",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_do] = "do",
  [anon_sym_case] = "case",
  [anon_sym_when] = "when",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_begin] = "begin",
  [anon_sym_ensure] = "ensure",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_AMP_DOT] = "&.",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_QMARK] = "?",
  [anon_sym_COLON2] = ":",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_CARET] = "^",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_defined_QMARK] = "defined?",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [sym_constant] = "constant",
  [sym_identifier] = "identifier",
  [sym_instance_variable] = "instance_variable",
  [sym_class_variable] = "class_variable",
  [sym_global_variable] = "global_variable",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_AT] = "+@",
  [anon_sym_DASH_AT] = "-@",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_undef] = "undef",
  [anon_sym_alias] = "alias",
  [sym_comment] = "comment",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_complex] = "complex",
  [anon_sym_r] = "r",
  [sym_super] = "super",
  [anon_sym_true] = "true",
  [anon_sym_TRUE] = "TRUE",
  [anon_sym_false] = "false",
  [anon_sym_FALSE] = "FALSE",
  [sym_self] = "self",
  [anon_sym_nil] = "nil",
  [anon_sym_NIL] = "NIL",
  [sym_character] = "character",
  [anon_sym_POUND_LBRACE] = "#{",
  [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = "/\\s+/",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_DASH_GT] = "->",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym__top_level_statement] = "_top_level_statement",
  [sym_begin_block] = "begin_block",
  [sym_end_block] = "end_block",
  [sym__statement] = "_statement",
  [sym_method] = "method",
  [sym_singleton_method] = "singleton_method",
  [sym__method_rest] = "_method_rest",
  [sym_method_parameters] = "method_parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_block_parameters] = "block_parameters",
  [sym__formal_parameter] = "_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_destructured_parameter] = "destructured_parameter",
  [sym_splat_parameter] = "splat_parameter",
  [sym_hash_splat_parameter] = "hash_splat_parameter",
  [sym_block_parameter] = "block_parameter",
  [sym_keyword_parameter] = "keyword_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_class] = "class",
  [sym_superclass] = "superclass",
  [sym_singleton_class] = "singleton_class",
  [sym_module] = "module",
  [sym_return] = "return",
  [sym_yield] = "yield",
  [sym_break] = "break",
  [sym_next] = "next",
  [sym_if_modifier] = "if_modifier",
  [sym_unless_modifier] = "unless_modifier",
  [sym_while_modifier] = "while_modifier",
  [sym_until_modifier] = "until_modifier",
  [sym_rescue_modifier] = "rescue_modifier",
  [sym_while] = "while",
  [sym_until] = "until",
  [sym_for] = "for",
  [sym_in] = "in",
  [sym__do] = "_do",
  [sym_case] = "case",
  [sym_when] = "when",
  [sym_pattern] = "pattern",
  [sym_if] = "if",
  [sym_unless] = "unless",
  [sym_elsif] = "elsif",
  [sym_else] = "else",
  [sym__then] = "_then",
  [sym__if_tail] = "_if_tail",
  [sym_begin] = "begin",
  [sym_ensure] = "ensure",
  [sym_rescue] = "rescue",
  [sym_exceptions] = "exceptions",
  [sym_exception_variable] = "exception_variable",
  [sym__body_statement] = "_body_statement",
  [sym__arg] = "_arg",
  [sym__primary] = "_primary",
  [sym_parenthesized_statements] = "parenthesized_statements",
  [sym_element_reference] = "element_reference",
  [sym_scope_resolution] = "scope_resolution",
  [sym_call] = "call",
  [sym_method_call] = "method_call",
  [sym_argument_list] = "argument_list",
  [sym_argument_list_with_parens] = "argument_list_with_parens",
  [sym__argument_list_with_parens] = "_argument_list_with_parens",
  [sym__argument_list_with_trailing_comma] = "_argument_list_with_trailing_comma",
  [sym__argument] = "_argument",
  [sym_splat_argument] = "splat_argument",
  [sym_hash_splat_argument] = "hash_splat_argument",
  [sym_block_argument] = "block_argument",
  [sym_do_block] = "do_block",
  [sym_block] = "block",
  [sym_assignment] = "assignment",
  [sym_operator_assignment] = "operator_assignment",
  [sym_conditional] = "conditional",
  [sym_range] = "range",
  [sym_binary] = "binary",
  [sym_unary] = "unary",
  [sym_right_assignment_list] = "right_assignment_list",
  [sym__arg_or_splat_arg] = "_arg_or_splat_arg",
  [sym_left_assignment_list] = "left_assignment_list",
  [sym__mlhs] = "_mlhs",
  [sym__simple_mlhs] = "_simple_mlhs",
  [sym_destructured_left_assignment] = "destructured_left_assignment",
  [sym_rest_assignment] = "rest_assignment",
  [sym__lhs] = "_lhs",
  [sym__variable] = "_variable",
  [sym_operator] = "operator",
  [sym__method_name] = "_method_name",
  [sym_setter] = "setter",
  [sym_undef] = "undef",
  [sym_alias] = "alias",
  [sym_rational] = "rational",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_nil] = "nil",
  [sym_chained_string] = "chained_string",
  [sym_interpolation] = "interpolation",
  [sym_string] = "string",
  [sym_subshell] = "subshell",
  [sym_string_array] = "string_array",
  [sym_symbol_array] = "symbol_array",
  [sym_symbol] = "symbol",
  [sym_regex] = "regex",
  [sym_heredoc_body] = "heredoc_body",
  [sym__literal_contents] = "_literal_contents",
  [sym_array] = "array",
  [sym_hash] = "hash",
  [sym__hash_items] = "_hash_items",
  [sym_pair] = "pair",
  [sym_lambda] = "lambda",
  [sym_empty_statement] = "empty_statement",
  [sym__terminator] = "_terminator",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_method_parameters_repeat1] = "method_parameters_repeat1",
  [aux_sym_lambda_parameters_repeat1] = "lambda_parameters_repeat1",
  [aux_sym_block_parameters_repeat1] = "block_parameters_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_when_repeat1] = "when_repeat1",
  [aux_sym_exceptions_repeat1] = "exceptions_repeat1",
  [aux_sym_call_repeat1] = "call_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_undef_repeat1] = "undef_repeat1",
  [aux_sym_chained_string_repeat1] = "chained_string_repeat1",
  [aux_sym_string_array_repeat1] = "string_array_repeat1",
  [aux_sym_symbol_array_repeat1] = "symbol_array_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym__literal_contents_repeat1] = "_literal_contents_repeat1",
  [anon_alias_sym_DQUOTE] = "\"",
  [anon_alias_sym_RPAREN] = ")",
  [anon_alias_sym_SLASH] = "/",
  [anon_alias_sym_BQUOTE] = "`",
  [alias_sym_bare_string] = "bare_string",
  [alias_sym_bare_symbol] = "bare_symbol",
  [alias_sym_symbol] = "symbol",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_symbol] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_start] = {
    .visible = true,
    .named = false,
  },
  [sym__subshell_start] = {
    .visible = true,
    .named = false,
  },
  [sym__regex_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__symbol_array_start] = {
    .visible = true,
    .named = false,
  },
  [sym__heredoc_body_start] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_beginning] = {
    .visible = true,
    .named = true,
  },
  [sym__block_ampersand] = {
    .visible = false,
    .named = true,
  },
  [sym__splat_star] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_minus] = {
    .visible = true,
    .named = false,
  },
  [sym__binary_star] = {
    .visible = true,
    .named = false,
  },
  [sym__singleton_class_left_angle_left_langle] = {
    .visible = true,
    .named = false,
  },
  [sym__identifier_hash_key] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym___END__] = {
    .visible = true,
    .named = false,
  },
  [sym_uninterpreted] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_next] = {
    .visible = true,
    .named = false,
  },
  [sym_redo] = {
    .visible = true,
    .named = true,
  },
  [sym_retry] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rescue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ensure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_instance_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_class_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_variable] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_r] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TRUE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_FALSE] = {
    .visible = true,
    .named = false,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NIL] = {
    .visible = true,
    .named = false,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_begin_block] = {
    .visible = true,
    .named = true,
  },
  [sym_end_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_method] = {
    .visible = true,
    .named = true,
  },
  [sym__method_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_method_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_if_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_until_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_until] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym__do] = {
    .visible = false,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_unless] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym__then] = {
    .visible = false,
    .named = true,
  },
  [sym__if_tail] = {
    .visible = false,
    .named = true,
  },
  [sym_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_ensure] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptions] = {
    .visible = true,
    .named = true,
  },
  [sym_exception_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__body_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_statements] = {
    .visible = true,
    .named = true,
  },
  [sym_element_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_scope_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_call] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list_with_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list_with_parens] = {
    .visible = false,
    .named = true,
  },
  [sym__argument_list_with_trailing_comma] = {
    .visible = false,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_right_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__arg_or_splat_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_left_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_left_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs] = {
    .visible = false,
    .named = true,
  },
  [sym__variable] = {
    .visible = false,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__method_name] = {
    .visible = false,
    .named = true,
  },
  [sym_setter] = {
    .visible = true,
    .named = true,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_chained_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_string_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym__literal_contents] = {
    .visible = false,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_items] = {
    .visible = false,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_method_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_when_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exceptions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_undef_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_chained_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_symbol_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literal_contents_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_bare_string] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bare_symbol] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_symbol] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[25][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [1] = anon_alias_sym_DQUOTE,
  },
  [2] = {
    [1] = anon_alias_sym_BQUOTE,
  },
  [3] = {
    [1] = anon_alias_sym_SLASH,
  },
  [4] = {
    [1] = anon_alias_sym_RPAREN,
  },
  [5] = {
    [2] = anon_alias_sym_DQUOTE,
  },
  [6] = {
    [2] = anon_alias_sym_BQUOTE,
  },
  [7] = {
    [2] = anon_alias_sym_SLASH,
  },
  [8] = {
    [2] = anon_alias_sym_RPAREN,
  },
  [9] = {
    [1] = alias_sym_bare_string,
    [2] = anon_alias_sym_RPAREN,
  },
  [10] = {
    [1] = alias_sym_bare_symbol,
    [2] = anon_alias_sym_RPAREN,
  },
  [11] = {
    [3] = anon_alias_sym_RPAREN,
  },
  [12] = {
    [2] = alias_sym_bare_string,
    [3] = anon_alias_sym_RPAREN,
  },
  [13] = {
    [1] = alias_sym_bare_string,
    [3] = anon_alias_sym_RPAREN,
  },
  [14] = {
    [1] = alias_sym_bare_string,
  },
  [15] = {
    [2] = alias_sym_bare_symbol,
    [3] = anon_alias_sym_RPAREN,
  },
  [16] = {
    [1] = alias_sym_bare_symbol,
    [3] = anon_alias_sym_RPAREN,
  },
  [17] = {
    [1] = alias_sym_bare_symbol,
  },
  [18] = {
    [0] = alias_sym_symbol,
  },
  [19] = {
    [2] = alias_sym_bare_string,
    [4] = anon_alias_sym_RPAREN,
  },
  [20] = {
    [1] = alias_sym_bare_string,
    [4] = anon_alias_sym_RPAREN,
  },
  [21] = {
    [2] = alias_sym_bare_symbol,
    [4] = anon_alias_sym_RPAREN,
  },
  [22] = {
    [1] = alias_sym_bare_symbol,
    [4] = anon_alias_sym_RPAREN,
  },
  [23] = {
    [2] = alias_sym_bare_string,
    [5] = anon_alias_sym_RPAREN,
  },
  [24] = {
    [2] = alias_sym_bare_symbol,
    [5] = anon_alias_sym_RPAREN,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(26);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(109);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(110);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^'))
        ADVANCE(126);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      if (lookahead == '~')
        ADVANCE(4);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '{')
        ADVANCE(6);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(7);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACE);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(7);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(sym_global_variable);
      if (lookahead == '-')
        ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(10);
      if (lookahead == '!' ||
          lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~')
        ADVANCE(11);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(10);
      if (lookahead == '!' ||
          lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= ',') ||
          ('.' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~')
        ADVANCE(11);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(10);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(sym_global_variable);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(16);
      if (lookahead == '.')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=')
        ADVANCE(17);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_AMP_DOT);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(25);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=')
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(27);
      if (lookahead == '@')
        ADVANCE(28);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_PLUS_AT);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@')
        ADVANCE(31);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_DASH_AT);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'b')
        ADVANCE(45);
      if (lookahead == 'd')
        ADVANCE(47);
      if (lookahead == 'x')
        ADVANCE(49);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(44);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (lookahead == 'O' ||
          lookahead == 'o')
        ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(53);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(38);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(45);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(46);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(48);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(48);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(50);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(50);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(52);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(52);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(54);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(44);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(53);
      END_STATE();
    case 54:
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(53);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':')
        ADVANCE(56);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>')
        ADVANCE(62);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == '>')
        ADVANCE(66);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=')
        ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(69);
      if (lookahead == '>')
        ADVANCE(70);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(71);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(79);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_character);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == '-')
        ADVANCE(75);
      if (lookahead == '{')
        ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 75:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == 'C' ||
          lookahead == 'M')
        ADVANCE(77);
      END_STATE();
    case 77:
      if (lookahead == '-')
        ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(79);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_character);
      END_STATE();
    case 80:
      if (lookahead == '}')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_character);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 82:
      if (lookahead == '@')
        ADVANCE(83);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(85);
      END_STATE();
    case 83:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(84);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_class_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_instance_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(85);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'E')
        ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_constant);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'G')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'I')
        ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'N')
        ADVANCE(91);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'N')
        ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'D')
        ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'A')
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > 'A') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'L')
        ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'S')
        ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'E')
        ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_FALSE);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'I')
        ADVANCE(102);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'L')
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_NIL);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'R')
        ADVANCE(105);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'U')
        ADVANCE(106);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'E')
        ADVANCE(107);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_TRUE);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 109:
      if (lookahead == '\n')
        SKIP(110);
      END_STATE();
    case 110:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(26);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(109);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(110);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^'))
        ADVANCE(126);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':')
        ADVANCE(113);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(117);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '|')
        ADVANCE(122);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=')
        ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!')
        ADVANCE(127);
      if (lookahead == '?')
        ADVANCE(127);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 128:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(155);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(128);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 132:
      if (lookahead == 'i')
        ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_complex);
      END_STATE();
    case 134:
      if (lookahead == '>')
        ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(137);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'b')
        ADVANCE(45);
      if (lookahead == 'd')
        ADVANCE(47);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == 'x')
        ADVANCE(49);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(138);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (lookahead == 'O' ||
          lookahead == 'o')
        ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(139);
      END_STATE();
    case 137:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(137);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(137);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(54);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(138);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(139);
      END_STATE();
    case 140:
      if (lookahead == ':')
        ADVANCE(113);
      END_STATE();
    case 141:
      if (lookahead == 'b')
        ADVANCE(142);
      END_STATE();
    case 142:
      if (lookahead == 'e')
        ADVANCE(143);
      END_STATE();
    case 143:
      if (lookahead == 'g')
        ADVANCE(144);
      END_STATE();
    case 144:
      if (lookahead == 'i')
        ADVANCE(145);
      END_STATE();
    case 145:
      if (lookahead == 'n')
        ADVANCE(146);
      END_STATE();
    case 146:
      if (lookahead == '\n')
        ADVANCE(147);
      if (lookahead == '\r')
        ADVANCE(146);
      if (lookahead != 0)
        ADVANCE(146);
      END_STATE();
    case 147:
      if (lookahead == '=')
        ADVANCE(148);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 148:
      if (lookahead == 'e')
        ADVANCE(149);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 149:
      if (lookahead == 'n')
        ADVANCE(150);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 150:
      if (lookahead == 'd')
        ADVANCE(151);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 151:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '\r')
        ADVANCE(153);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        ADVANCE(152);
      END_STATE();
    case 154:
      if (lookahead == '\\')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(79);
      END_STATE();
    case 155:
      if (lookahead == '\n')
        SKIP(128);
      END_STATE();
    case 156:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 157:
      if (lookahead == '=')
        ADVANCE(3);
      if (lookahead == '~')
        ADVANCE(4);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(160);
      if (lookahead == '.')
        ADVANCE(18);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 161:
      if (lookahead == '*')
        ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 165:
      if (lookahead == ':')
        ADVANCE(56);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(167);
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 168:
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == '>')
        ADVANCE(66);
      if (lookahead == 'b')
        ADVANCE(142);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(69);
      if (lookahead == '>')
        ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 172:
      if (lookahead == '\n')
        SKIP(173);
      END_STATE();
    case 173:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 177:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        ADVANCE(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(177);
      END_STATE();
    case 178:
      if (lookahead == '\n')
        ADVANCE(179);
      if (lookahead == 'u')
        ADVANCE(180);
      if (lookahead == 'x')
        ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(188);
      if (lookahead != 0)
        ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 180:
      if (lookahead == '{')
        ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(183);
      END_STATE();
    case 181:
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(182);
      END_STATE();
    case 182:
      if (lookahead == '}')
        ADVANCE(179);
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(182);
      END_STATE();
    case 183:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(184);
      END_STATE();
    case 184:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(185);
      END_STATE();
    case 185:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(179);
      END_STATE();
    case 186:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(187);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(179);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(189);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(179);
      END_STATE();
    case 190:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        ADVANCE(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(191);
      END_STATE();
    case 192:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(193);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(192);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 193:
      if (lookahead == '\n')
        SKIP(192);
      END_STATE();
    case 194:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(196);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(162);
      END_STATE();
    case 196:
      if (lookahead == '\n')
        SKIP(194);
      END_STATE();
    case 197:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(207);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '~')
        ADVANCE(4);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '@')
        ADVANCE(28);
      END_STATE();
    case 201:
      if (lookahead == '.')
        ADVANCE(202);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 203:
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == 'b')
        ADVANCE(142);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 204:
      if (lookahead == ']')
        ADVANCE(205);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=')
        ADVANCE(206);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        SKIP(197);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 209:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        SKIP(209);
      END_STATE();
    case 211:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(212);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 212:
      if (lookahead == '\n')
        SKIP(211);
      END_STATE();
    case 213:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(215);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(213);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        SKIP(213);
      END_STATE();
    case 216:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(217);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 217:
      if (lookahead == '\n')
        SKIP(216);
      END_STATE();
    case 218:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(219);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(220);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 219:
      if (lookahead == '\n')
        SKIP(220);
      END_STATE();
    case 220:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(219);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(220);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 221:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(222);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 222:
      if (lookahead == '\n')
        SKIP(221);
      END_STATE();
    case 223:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        SKIP(223);
      END_STATE();
    case 225:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(226);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 226:
      if (lookahead == '\n')
        SKIP(225);
      END_STATE();
    case 227:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(233);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 228:
      if (lookahead == '*')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(25);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(27);
      END_STATE();
    case 230:
      if (lookahead == '=')
        ADVANCE(231);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 233:
      if (lookahead == '\n')
        SKIP(234);
      END_STATE();
    case 234:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(233);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 235:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(236);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 236:
      if (lookahead == '\n')
        SKIP(235);
      END_STATE();
    case 237:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 239:
      if (lookahead == '\n')
        SKIP(240);
      END_STATE();
    case 240:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 241:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(242);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      END_STATE();
    case 242:
      if (lookahead == '\n')
        SKIP(241);
      END_STATE();
    case 243:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(244);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(243);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 244:
      if (lookahead == '\n')
        SKIP(243);
      END_STATE();
    case 245:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(246);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(245);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        SKIP(245);
      END_STATE();
    case 247:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(250);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(160);
      END_STATE();
    case 249:
      if (lookahead == '.')
        ADVANCE(33);
      END_STATE();
    case 250:
      if (lookahead == '\n')
        SKIP(247);
      END_STATE();
    case 251:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 252:
      if (lookahead == '\n')
        SKIP(253);
      END_STATE();
    case 253:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 254:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(257);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 256:
      if (lookahead == '=')
        ADVANCE(231);
      if (lookahead == '>')
        ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 257:
      if (lookahead == '\n')
        SKIP(258);
      END_STATE();
    case 258:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(257);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 259:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(260);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 260:
      if (lookahead == '\n')
        SKIP(261);
      END_STATE();
    case 261:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(260);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 262:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(263);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 263:
      if (lookahead == '\n')
        SKIP(264);
      END_STATE();
    case 264:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(263);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 265:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 266:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(267);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(268);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        SKIP(266);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(268);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(270);
      if (lookahead == '#')
        ADVANCE(271);
      if (lookahead == '=')
        ADVANCE(273);
      if (lookahead == '\\')
        ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(270);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(270);
      if (lookahead == '#')
        ADVANCE(271);
      if (lookahead == '=')
        ADVANCE(273);
      if (lookahead == '\\')
        ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(270);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(271);
      if (lookahead != 0)
        ADVANCE(271);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == 'b')
        ADVANCE(274);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == 'e')
        ADVANCE(275);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == 'g')
        ADVANCE(276);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == 'i')
        ADVANCE(277);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == 'n')
        ADVANCE(278);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == '\r')
        ADVANCE(278);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(278);
      if (lookahead != 0)
        ADVANCE(278);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == '=')
        ADVANCE(280);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(279);
      if (lookahead != 0)
        ADVANCE(279);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == 'e')
        ADVANCE(281);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(279);
      if (lookahead != 0)
        ADVANCE(279);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == 'n')
        ADVANCE(282);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(279);
      if (lookahead != 0)
        ADVANCE(279);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == 'd')
        ADVANCE(283);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(279);
      if (lookahead != 0)
        ADVANCE(279);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '\r')
        ADVANCE(284);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(270);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 286:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(287);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 287:
      if (lookahead == '\n')
        SKIP(286);
      END_STATE();
    case 288:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(290);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':')
        ADVANCE(56);
      END_STATE();
    case 290:
      if (lookahead == '\n')
        SKIP(291);
      END_STATE();
    case 291:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(290);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 293:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(294);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(295);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 294:
      if (lookahead == '\n')
        SKIP(295);
      END_STATE();
    case 295:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(294);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(295);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 296:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(297);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 297:
      if (lookahead == '\n')
        SKIP(298);
      END_STATE();
    case 298:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(297);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 299:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(300);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 300:
      if (lookahead == '\n')
        SKIP(301);
      END_STATE();
    case 301:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(300);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 302:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(303);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(302);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 303:
      if (lookahead == '\n')
        SKIP(302);
      END_STATE();
    case 304:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(297);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 305:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(306);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(307);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 306:
      if (lookahead == '\n')
        SKIP(307);
      END_STATE();
    case 307:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(306);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(307);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 308:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(309);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(308);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 309:
      if (lookahead == '\n')
        SKIP(308);
      END_STATE();
    case 310:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(312);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 312:
      if (lookahead == '\n')
        SKIP(310);
      END_STATE();
    case 313:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(314);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(313);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 314:
      if (lookahead == '\n')
        SKIP(313);
      END_STATE();
    case 315:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(316);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(317);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 316:
      if (lookahead == '\n')
        SKIP(317);
      END_STATE();
    case 317:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(316);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(317);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 318:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(319);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 319:
      if (lookahead == '\n')
        SKIP(320);
      END_STATE();
    case 320:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(319);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 321:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(322);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(323);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 322:
      if (lookahead == '\n')
        SKIP(323);
      END_STATE();
    case 323:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(322);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(323);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 324:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(325);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 325:
      if (lookahead == '\n')
        SKIP(326);
      END_STATE();
    case 326:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(325);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 327:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(328);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(329);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 328:
      if (lookahead == '\n')
        SKIP(329);
      END_STATE();
    case 329:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(328);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(329);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 330:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(332);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(333);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 331:
      if (lookahead == '.')
        ADVANCE(18);
      END_STATE();
    case 332:
      if (lookahead == '\n')
        SKIP(333);
      END_STATE();
    case 333:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(332);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(333);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 334:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(335);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(336);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 335:
      if (lookahead == '\n')
        SKIP(336);
      END_STATE();
    case 336:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(335);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(336);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 337:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(338);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(339);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 338:
      if (lookahead == '\n')
        SKIP(339);
      END_STATE();
    case 339:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(338);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(339);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 340:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(341);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(342);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 341:
      if (lookahead == '\n')
        SKIP(342);
      END_STATE();
    case 342:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(341);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(342);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 343:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(344);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(345);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 344:
      if (lookahead == '\n')
        SKIP(345);
      END_STATE();
    case 345:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(344);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(345);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 346:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(347);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(348);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(349);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 348:
      if (lookahead == '\n')
        SKIP(349);
      END_STATE();
    case 349:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(347);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(348);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(349);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 350:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(351);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 351:
      if (lookahead == '\n')
        SKIP(352);
      END_STATE();
    case 352:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(351);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 353:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(354);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(355);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 354:
      if (lookahead == '\n')
        SKIP(355);
      END_STATE();
    case 355:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(354);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(355);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 356:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(357);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(356);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 357:
      if (lookahead == '\n')
        SKIP(356);
      END_STATE();
    case 358:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(359);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(360);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 359:
      if (lookahead == '\n')
        SKIP(360);
      END_STATE();
    case 360:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(359);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(360);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 361:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(362);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(363);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 362:
      if (lookahead == '\n')
        SKIP(363);
      END_STATE();
    case 363:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(362);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(363);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 364:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(359);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(360);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 365:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(366);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(367);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 366:
      if (lookahead == '\n')
        SKIP(367);
      END_STATE();
    case 367:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(366);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(367);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 368:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(369);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(370);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 369:
      if (lookahead == '\n')
        SKIP(370);
      END_STATE();
    case 370:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(369);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(370);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 371:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(362);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(363);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 372:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(373);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(372);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 373:
      if (lookahead == '\n')
        SKIP(372);
      END_STATE();
    case 374:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(375);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(376);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 375:
      if (lookahead == '\n')
        SKIP(376);
      END_STATE();
    case 376:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(375);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(376);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 377:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(378);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(379);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(377);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 378:
      if (lookahead == '>')
        ADVANCE(66);
      if (lookahead == 'b')
        ADVANCE(142);
      END_STATE();
    case 379:
      if (lookahead == '\n')
        SKIP(377);
      END_STATE();
    case 380:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(381);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(380);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 381:
      if (lookahead == '\n')
        SKIP(380);
      END_STATE();
    case 382:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(383);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(382);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 383:
      if (lookahead == '\n')
        SKIP(382);
      END_STATE();
    case 384:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(385);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(384);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 385:
      if (lookahead == '\n')
        SKIP(384);
      END_STATE();
    case 386:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(387);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(386);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 387:
      if (lookahead == '\n')
        SKIP(386);
      END_STATE();
    case 388:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(389);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(390);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 389:
      if (lookahead == '\n')
        SKIP(390);
      END_STATE();
    case 390:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(389);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(390);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 391:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(392);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(393);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 392:
      if (lookahead == '\n')
        SKIP(393);
      END_STATE();
    case 393:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(392);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(393);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 394:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(395);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(396);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 395:
      if (lookahead == '\n')
        SKIP(396);
      END_STATE();
    case 396:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(395);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(396);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 397:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(398);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(399);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 398:
      if (lookahead == '\n')
        SKIP(399);
      END_STATE();
    case 399:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(398);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(399);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 400:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(401);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(400);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 401:
      if (lookahead == '\n')
        SKIP(400);
      END_STATE();
    case 402:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(395);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(396);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 403:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(404);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(405);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 404:
      if (lookahead == '\n')
        SKIP(405);
      END_STATE();
    case 405:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(404);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(405);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 406:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(407);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(408);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 407:
      if (lookahead == '\n')
        SKIP(408);
      END_STATE();
    case 408:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(407);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(408);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 409:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(410);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(409);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 410:
      if (lookahead == '\n')
        SKIP(409);
      END_STATE();
    case 411:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(412);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(413);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 412:
      if (lookahead == '\n')
        SKIP(413);
      END_STATE();
    case 413:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(412);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(413);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 414:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(415);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(414);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 415:
      if (lookahead == '\n')
        SKIP(414);
      END_STATE();
    case 416:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(417);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(418);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 417:
      if (lookahead == '\n')
        SKIP(418);
      END_STATE();
    case 418:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(417);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(418);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 419:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(420);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(419);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 420:
      if (lookahead == '\n')
        SKIP(419);
      END_STATE();
    case 421:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(422);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(423);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 422:
      if (lookahead == '\n')
        SKIP(423);
      END_STATE();
    case 423:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(422);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(423);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 424:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(425);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(426);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 425:
      if (lookahead == '\n')
        SKIP(426);
      END_STATE();
    case 426:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(425);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(426);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 427:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(422);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(423);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 428:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(429);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(428);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 429:
      if (lookahead == '\n')
        SKIP(428);
      END_STATE();
    case 430:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(431);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(432);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 431:
      if (lookahead == '\n')
        SKIP(432);
      END_STATE();
    case 432:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(431);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(432);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 433:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(434);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(435);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 434:
      if (lookahead == '\n')
        SKIP(435);
      END_STATE();
    case 435:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(434);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(435);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 436:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(437);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(436);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 437:
      if (lookahead == '\n')
        SKIP(436);
      END_STATE();
    case 438:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(439);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(440);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 439:
      if (lookahead == '\n')
        SKIP(440);
      END_STATE();
    case 440:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(439);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(440);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 441:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(442);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(443);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 442:
      if (lookahead == '\n')
        SKIP(443);
      END_STATE();
    case 443:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(442);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(443);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 444:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(445);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(446);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 445:
      if (lookahead == '\n')
        SKIP(446);
      END_STATE();
    case 446:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(445);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(446);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 447:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(448);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(449);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 448:
      if (lookahead == '\n')
        SKIP(449);
      END_STATE();
    case 449:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(448);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(449);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 450:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(451);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(452);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 451:
      if (lookahead == '\n')
        SKIP(452);
      END_STATE();
    case 452:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(451);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(452);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 453:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(454);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(453);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 454:
      if (lookahead == '\n')
        SKIP(453);
      END_STATE();
    case 455:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(456);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(457);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 456:
      if (lookahead == '\n')
        SKIP(457);
      END_STATE();
    case 457:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(456);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(457);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 458:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(459);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(460);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 459:
      if (lookahead == '\n')
        SKIP(460);
      END_STATE();
    case 460:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(459);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(460);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 461:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(462);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(463);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 462:
      if (lookahead == '\n')
        SKIP(463);
      END_STATE();
    case 463:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(462);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(463);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 464:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(465);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(466);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 465:
      if (lookahead == '\n')
        SKIP(466);
      END_STATE();
    case 466:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(465);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(466);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 467:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(468);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(469);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 468:
      if (lookahead == '\n')
        SKIP(469);
      END_STATE();
    case 469:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(468);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(469);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 470:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(471);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(472);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 471:
      if (lookahead == '\n')
        SKIP(472);
      END_STATE();
    case 472:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(471);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(472);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 473:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(474);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(473);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 474:
      if (lookahead == '\n')
        SKIP(473);
      END_STATE();
    case 475:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(476);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(477);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 476:
      if (lookahead == '\n')
        SKIP(477);
      END_STATE();
    case 477:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(476);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(477);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 478:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(479);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(480);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 479:
      if (lookahead == '\n')
        SKIP(480);
      END_STATE();
    case 480:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(479);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(480);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 481:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(482);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(483);
      END_STATE();
    case 482:
      if (lookahead == '\n')
        SKIP(483);
      END_STATE();
    case 483:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(482);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(483);
      END_STATE();
    case 484:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(485);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(486);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 485:
      if (lookahead == '\n')
        SKIP(486);
      END_STATE();
    case 486:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(485);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(486);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 487:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(488);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(489);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 488:
      if (lookahead == '\n')
        SKIP(489);
      END_STATE();
    case 489:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(488);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(489);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 490:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(491);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(492);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 491:
      if (lookahead == '\n')
        SKIP(492);
      END_STATE();
    case 492:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(491);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(492);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 493:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(494);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(495);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 494:
      if (lookahead == '\n')
        SKIP(495);
      END_STATE();
    case 495:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(494);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(495);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 496:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(491);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(492);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 497:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(498);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(499);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 498:
      if (lookahead == '\n')
        SKIP(499);
      END_STATE();
    case 499:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(498);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(499);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 500:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(501);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(500);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 501:
      if (lookahead == '\n')
        SKIP(500);
      END_STATE();
    case 502:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(503);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(504);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 503:
      if (lookahead == '\n')
        SKIP(504);
      END_STATE();
    case 504:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(503);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(504);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 505:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(506);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(507);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 506:
      if (lookahead == '\n')
        SKIP(507);
      END_STATE();
    case 507:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(506);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(507);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 508:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(509);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(510);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 509:
      if (lookahead == '\n')
        SKIP(510);
      END_STATE();
    case 510:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(509);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(510);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 511:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(512);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(513);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 512:
      if (lookahead == '\n')
        SKIP(513);
      END_STATE();
    case 513:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(512);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(513);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 514:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(515);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(516);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 515:
      if (lookahead == '\n')
        SKIP(516);
      END_STATE();
    case 516:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(515);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(516);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 517:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(518);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(519);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 518:
      if (lookahead == '\n')
        SKIP(519);
      END_STATE();
    case 519:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(518);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(519);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 520:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(521);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(522);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 521:
      if (lookahead == '\n')
        SKIP(522);
      END_STATE();
    case 522:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(521);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(522);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 523:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(521);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(522);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 524:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(525);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(524);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 525:
      if (lookahead == '\n')
        SKIP(524);
      END_STATE();
    case 526:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(527);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(526);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 527:
      if (lookahead == '\n')
        SKIP(526);
      END_STATE();
    case 528:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(529);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(528);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 529:
      if (lookahead == '\n')
        SKIP(528);
      END_STATE();
    case 530:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(389);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(390);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 531:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(532);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(533);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 532:
      if (lookahead == '\n')
        SKIP(533);
      END_STATE();
    case 533:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(532);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(533);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 534:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(535);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(536);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 535:
      if (lookahead == '\n')
        SKIP(536);
      END_STATE();
    case 536:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(535);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(536);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 537:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(538);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(539);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 538:
      if (lookahead == '\n')
        SKIP(539);
      END_STATE();
    case 539:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(538);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(539);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 540:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(541);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(542);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 541:
      if (lookahead == '\n')
        SKIP(542);
      END_STATE();
    case 542:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(541);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(542);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 543:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(407);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(408);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 544:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(545);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(546);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 545:
      if (lookahead == '\n')
        SKIP(546);
      END_STATE();
    case 546:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(545);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(546);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 547:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(548);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(547);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 548:
      if (lookahead == '\n')
        SKIP(547);
      END_STATE();
    case 549:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(550);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(549);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 550:
      if (lookahead == '\n')
        SKIP(549);
      END_STATE();
    case 551:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(552);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(553);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 552:
      if (lookahead == '\n')
        SKIP(553);
      END_STATE();
    case 553:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(552);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(553);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 554:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(555);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(554);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 555:
      if (lookahead == '\n')
        SKIP(554);
      END_STATE();
    case 556:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(557);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(558);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 557:
      if (lookahead == '\n')
        SKIP(558);
      END_STATE();
    case 558:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(557);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(558);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 559:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(560);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(561);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 560:
      if (lookahead == '\n')
        SKIP(561);
      END_STATE();
    case 561:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(560);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(561);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 562:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(563);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(564);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 563:
      if (lookahead == '\n')
        SKIP(564);
      END_STATE();
    case 564:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(563);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(564);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 565:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(300);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 566:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(567);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(568);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 567:
      if (lookahead == '\n')
        SKIP(568);
      END_STATE();
    case 568:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(567);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(568);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 569:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(570);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(571);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 570:
      if (lookahead == '\n')
        SKIP(571);
      END_STATE();
    case 571:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(570);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(571);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 572:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(570);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(571);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 573:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(574);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(575);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 574:
      if (lookahead == '\n')
        SKIP(575);
      END_STATE();
    case 575:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(574);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(575);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 576:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(456);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(457);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 577:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(578);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(577);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 578:
      if (lookahead == '\n')
        SKIP(577);
      END_STATE();
    case 579:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(580);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(581);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 580:
      if (lookahead == '\n')
        SKIP(581);
      END_STATE();
    case 581:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(580);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(581);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 582:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(583);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(584);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 583:
      if (lookahead == '\n')
        SKIP(584);
      END_STATE();
    case 584:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(583);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(584);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 585:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(586);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(587);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 586:
      if (lookahead == '\n')
        SKIP(587);
      END_STATE();
    case 587:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(586);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(587);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 588:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(589);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(590);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 589:
      if (lookahead == '\n')
        SKIP(590);
      END_STATE();
    case 590:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(589);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(590);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 591:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(586);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(587);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 592:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(593);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(594);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 593:
      if (lookahead == '\n')
        SKIP(594);
      END_STATE();
    case 594:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(593);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(594);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 595:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(596);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(597);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 596:
      if (lookahead == '\n')
        SKIP(597);
      END_STATE();
    case 597:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(596);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(597);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 598:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(398);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(399);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 599:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(600);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(599);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 600:
      if (lookahead == '\n')
        SKIP(599);
      END_STATE();
    case 601:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(602);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(603);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 602:
      if (lookahead == '\n')
        SKIP(603);
      END_STATE();
    case 603:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(602);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(603);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 604:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(605);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(606);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 605:
      if (lookahead == '\n')
        SKIP(606);
      END_STATE();
    case 606:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(605);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(606);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 607:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(608);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(609);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 608:
      if (lookahead == '\n')
        SKIP(609);
      END_STATE();
    case 609:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(608);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(609);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 610:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(611);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(612);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 611:
      if (lookahead == '\n')
        SKIP(612);
      END_STATE();
    case 612:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(611);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(612);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 613:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(494);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(495);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 614:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(498);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(499);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 615:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(616);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(617);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 616:
      if (lookahead == '\n')
        SKIP(617);
      END_STATE();
    case 617:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(616);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(617);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 618:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(619);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(620);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 619:
      if (lookahead == '\n')
        SKIP(620);
      END_STATE();
    case 620:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(619);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(620);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 621:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(622);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(623);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 622:
      if (lookahead == '\n')
        SKIP(623);
      END_STATE();
    case 623:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(622);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(623);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 624:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(625);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(626);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 625:
      if (lookahead == '\n')
        SKIP(626);
      END_STATE();
    case 626:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(625);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(626);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 627:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(628);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(629);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 628:
      if (lookahead == '\n')
        SKIP(629);
      END_STATE();
    case 629:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(628);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(629);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 630:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(506);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(507);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 631:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(632);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(633);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 632:
      if (lookahead == '\n')
        SKIP(633);
      END_STATE();
    case 633:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(632);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(633);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 634:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(509);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(510);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 635:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(636);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(637);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 636:
      if (lookahead == '\n')
        SKIP(637);
      END_STATE();
    case 637:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(636);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(637);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 638:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(639);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(638);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 639:
      if (lookahead == '\n')
        SKIP(638);
      END_STATE();
    case 640:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(404);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(405);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 641:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(642);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(641);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 642:
      if (lookahead == '\n')
        SKIP(641);
      END_STATE();
    case 643:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(644);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(643);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 644:
      if (lookahead == '\n')
        SKIP(643);
      END_STATE();
    case 645:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(646);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(647);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 646:
      if (lookahead == '\n')
        SKIP(647);
      END_STATE();
    case 647:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(646);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(647);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 648:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(649);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(650);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 649:
      if (lookahead == '\n')
        SKIP(650);
      END_STATE();
    case 650:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(649);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(650);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 651:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(652);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(653);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 652:
      if (lookahead == '\n')
        SKIP(653);
      END_STATE();
    case 653:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(652);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(653);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 654:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(655);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(656);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 655:
      if (lookahead == '\n')
        SKIP(656);
      END_STATE();
    case 656:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(655);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(656);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 657:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(652);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(653);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 658:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(659);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(660);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 659:
      if (lookahead == '\n')
        SKIP(660);
      END_STATE();
    case 660:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(659);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(660);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 661:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(655);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(656);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 662:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(659);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(660);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 663:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(589);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(590);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 664:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(574);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(575);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 665:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(666);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(667);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 666:
      if (lookahead == '\n')
        SKIP(667);
      END_STATE();
    case 667:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(666);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(667);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 668:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(669);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(670);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 669:
      if (lookahead == '\n')
        SKIP(670);
      END_STATE();
    case 670:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(669);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(670);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 671:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(672);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(673);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 672:
      if (lookahead == '\n')
        SKIP(673);
      END_STATE();
    case 673:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(672);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(673);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 674:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(605);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(606);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 675:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(676);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(677);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 676:
      if (lookahead == '\n')
        SKIP(677);
      END_STATE();
    case 677:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(676);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(677);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 678:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(679);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(680);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 679:
      if (lookahead == '\n')
        SKIP(680);
      END_STATE();
    case 680:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(679);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(680);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 681:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(682);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(681);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 682:
      if (lookahead == '\n')
        SKIP(681);
      END_STATE();
    case 683:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(684);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(685);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 684:
      if (lookahead == '\n')
        SKIP(685);
      END_STATE();
    case 685:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(684);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(685);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == '_')
        ADVANCE(1);
      if (lookahead == 'a')
        ADVANCE(8);
      if (lookahead == 'b')
        ADVANCE(15);
      if (lookahead == 'c')
        ADVANCE(24);
      if (lookahead == 'd')
        ADVANCE(32);
      if (lookahead == 'e')
        ADVANCE(41);
      if (lookahead == 'f')
        ADVANCE(53);
      if (lookahead == 'i')
        ADVANCE(60);
      if (lookahead == 'm')
        ADVANCE(63);
      if (lookahead == 'n')
        ADVANCE(69);
      if (lookahead == 'o')
        ADVANCE(77);
      if (lookahead == 'r')
        ADVANCE(79);
      if (lookahead == 's')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'u')
        ADVANCE(108);
      if (lookahead == 'w')
        ADVANCE(120);
      if (lookahead == 'y')
        ADVANCE(127);
      END_STATE();
    case 1:
      if (lookahead == '_')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 'E')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'N')
        ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == 'D')
        ADVANCE(5);
      END_STATE();
    case 5:
      if (lookahead == '_')
        ADVANCE(6);
      END_STATE();
    case 6:
      if (lookahead == '_')
        ADVANCE(7);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym___END__);
      END_STATE();
    case 8:
      if (lookahead == 'l')
        ADVANCE(9);
      if (lookahead == 'n')
        ADVANCE(13);
      END_STATE();
    case 9:
      if (lookahead == 'i')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'a')
        ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == 's')
        ADVANCE(12);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 13:
      if (lookahead == 'd')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 15:
      if (lookahead == 'e')
        ADVANCE(16);
      if (lookahead == 'r')
        ADVANCE(20);
      END_STATE();
    case 16:
      if (lookahead == 'g')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 'i')
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == 'n')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 20:
      if (lookahead == 'e')
        ADVANCE(21);
      END_STATE();
    case 21:
      if (lookahead == 'a')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 'k')
        ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 24:
      if (lookahead == 'a')
        ADVANCE(25);
      if (lookahead == 'l')
        ADVANCE(28);
      END_STATE();
    case 25:
      if (lookahead == 's')
        ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == 'e')
        ADVANCE(27);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 28:
      if (lookahead == 'a')
        ADVANCE(29);
      END_STATE();
    case 29:
      if (lookahead == 's')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 's')
        ADVANCE(31);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 32:
      if (lookahead == 'e')
        ADVANCE(33);
      if (lookahead == 'o')
        ADVANCE(40);
      END_STATE();
    case 33:
      if (lookahead == 'f')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'i')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'n')
        ADVANCE(36);
      END_STATE();
    case 36:
      if (lookahead == 'e')
        ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == 'd')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == '?')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_defined_QMARK);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 41:
      if (lookahead == 'l')
        ADVANCE(42);
      if (lookahead == 'n')
        ADVANCE(47);
      END_STATE();
    case 42:
      if (lookahead == 's')
        ADVANCE(43);
      END_STATE();
    case 43:
      if (lookahead == 'e')
        ADVANCE(44);
      if (lookahead == 'i')
        ADVANCE(45);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 45:
      if (lookahead == 'f')
        ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 47:
      if (lookahead == 'd')
        ADVANCE(48);
      if (lookahead == 's')
        ADVANCE(49);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 49:
      if (lookahead == 'u')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 'r')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'e')
        ADVANCE(52);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_ensure);
      END_STATE();
    case 53:
      if (lookahead == 'a')
        ADVANCE(54);
      if (lookahead == 'o')
        ADVANCE(58);
      END_STATE();
    case 54:
      if (lookahead == 'l')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 's')
        ADVANCE(56);
      END_STATE();
    case 56:
      if (lookahead == 'e')
        ADVANCE(57);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 58:
      if (lookahead == 'r')
        ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 60:
      if (lookahead == 'f')
        ADVANCE(61);
      if (lookahead == 'n')
        ADVANCE(62);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 63:
      if (lookahead == 'o')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'd')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'u')
        ADVANCE(66);
      END_STATE();
    case 66:
      if (lookahead == 'l')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'e')
        ADVANCE(68);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 69:
      if (lookahead == 'e')
        ADVANCE(70);
      if (lookahead == 'i')
        ADVANCE(73);
      if (lookahead == 'o')
        ADVANCE(75);
      END_STATE();
    case 70:
      if (lookahead == 'x')
        ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 't')
        ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_next);
      END_STATE();
    case 73:
      if (lookahead == 'l')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 75:
      if (lookahead == 't')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 77:
      if (lookahead == 'r')
        ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_r);
      if (lookahead == 'e')
        ADVANCE(80);
      END_STATE();
    case 80:
      if (lookahead == 'd')
        ADVANCE(81);
      if (lookahead == 's')
        ADVANCE(83);
      if (lookahead == 't')
        ADVANCE(87);
      END_STATE();
    case 81:
      if (lookahead == 'o')
        ADVANCE(82);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_redo);
      END_STATE();
    case 83:
      if (lookahead == 'c')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 'u')
        ADVANCE(85);
      END_STATE();
    case 85:
      if (lookahead == 'e')
        ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_rescue);
      END_STATE();
    case 87:
      if (lookahead == 'r')
        ADVANCE(88);
      if (lookahead == 'u')
        ADVANCE(90);
      END_STATE();
    case 88:
      if (lookahead == 'y')
        ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_retry);
      END_STATE();
    case 90:
      if (lookahead == 'r')
        ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 'n')
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 93:
      if (lookahead == 'e')
        ADVANCE(94);
      if (lookahead == 'u')
        ADVANCE(97);
      END_STATE();
    case 94:
      if (lookahead == 'l')
        ADVANCE(95);
      END_STATE();
    case 95:
      if (lookahead == 'f')
        ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 97:
      if (lookahead == 'p')
        ADVANCE(98);
      END_STATE();
    case 98:
      if (lookahead == 'e')
        ADVANCE(99);
      END_STATE();
    case 99:
      if (lookahead == 'r')
        ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 101:
      if (lookahead == 'h')
        ADVANCE(102);
      if (lookahead == 'r')
        ADVANCE(105);
      END_STATE();
    case 102:
      if (lookahead == 'e')
        ADVANCE(103);
      END_STATE();
    case 103:
      if (lookahead == 'n')
        ADVANCE(104);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 105:
      if (lookahead == 'u')
        ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == 'e')
        ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 108:
      if (lookahead == 'n')
        ADVANCE(109);
      END_STATE();
    case 109:
      if (lookahead == 'd')
        ADVANCE(110);
      if (lookahead == 'l')
        ADVANCE(113);
      if (lookahead == 't')
        ADVANCE(117);
      END_STATE();
    case 110:
      if (lookahead == 'e')
        ADVANCE(111);
      END_STATE();
    case 111:
      if (lookahead == 'f')
        ADVANCE(112);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 113:
      if (lookahead == 'e')
        ADVANCE(114);
      END_STATE();
    case 114:
      if (lookahead == 's')
        ADVANCE(115);
      END_STATE();
    case 115:
      if (lookahead == 's')
        ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 117:
      if (lookahead == 'i')
        ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == 'l')
        ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 120:
      if (lookahead == 'h')
        ADVANCE(121);
      END_STATE();
    case 121:
      if (lookahead == 'e')
        ADVANCE(122);
      if (lookahead == 'i')
        ADVANCE(124);
      END_STATE();
    case 122:
      if (lookahead == 'n')
        ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 124:
      if (lookahead == 'l')
        ADVANCE(125);
      END_STATE();
    case 125:
      if (lookahead == 'e')
        ADVANCE(126);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 127:
      if (lookahead == 'i')
        ADVANCE(128);
      END_STATE();
    case 128:
      if (lookahead == 'e')
        ADVANCE(129);
      END_STATE();
    case 129:
      if (lookahead == 'l')
        ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == 'd')
        ADVANCE(131);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 128, .external_lex_state = 2},
  [2] = {.lex_state = 156, .external_lex_state = 3},
  [3] = {.lex_state = 177, .external_lex_state = 4},
  [4] = {.lex_state = 177, .external_lex_state = 4},
  [5] = {.lex_state = 177, .external_lex_state = 4},
  [6] = {.lex_state = 177, .external_lex_state = 4},
  [7] = {.lex_state = 190, .external_lex_state = 4},
  [8] = {.lex_state = 190, .external_lex_state = 4},
  [9] = {.lex_state = 192, .external_lex_state = 2},
  [10] = {.lex_state = 128, .external_lex_state = 5},
  [11] = {.lex_state = 128},
  [12] = {.lex_state = 194, .external_lex_state = 6},
  [13] = {.lex_state = 128},
  [14] = {.lex_state = 197, .external_lex_state = 7},
  [15] = {.lex_state = 209, .external_lex_state = 2},
  [16] = {.lex_state = 197},
  [17] = {.lex_state = 211, .external_lex_state = 8},
  [18] = {.lex_state = 213, .external_lex_state = 9},
  [19] = {.lex_state = 216, .external_lex_state = 10},
  [20] = {.lex_state = 216, .external_lex_state = 9},
  [21] = {.lex_state = 218, .external_lex_state = 11},
  [22] = {.lex_state = 218, .external_lex_state = 11},
  [23] = {.lex_state = 218, .external_lex_state = 11},
  [24] = {.lex_state = 218, .external_lex_state = 11},
  [25] = {.lex_state = 221, .external_lex_state = 2},
  [26] = {.lex_state = 221, .external_lex_state = 2},
  [27] = {.lex_state = 192, .external_lex_state = 2},
  [28] = {.lex_state = 192, .external_lex_state = 2},
  [29] = {.lex_state = 223, .external_lex_state = 9},
  [30] = {.lex_state = 221, .external_lex_state = 12},
  [31] = {.lex_state = 128, .external_lex_state = 12},
  [32] = {.lex_state = 192, .external_lex_state = 2},
  [33] = {.lex_state = 192, .external_lex_state = 2},
  [34] = {.lex_state = 225, .external_lex_state = 7},
  [35] = {.lex_state = 225, .external_lex_state = 7},
  [36] = {.lex_state = 156, .external_lex_state = 3},
  [37] = {.lex_state = 227, .external_lex_state = 3},
  [38] = {.lex_state = 227, .external_lex_state = 3},
  [39] = {.lex_state = 227, .external_lex_state = 3},
  [40] = {.lex_state = 235, .external_lex_state = 13},
  [41] = {.lex_state = 237},
  [42] = {.lex_state = 241},
  [43] = {.lex_state = 243},
  [44] = {.lex_state = 245, .external_lex_state = 8},
  [45] = {.lex_state = 245, .external_lex_state = 8},
  [46] = {.lex_state = 247, .external_lex_state = 3},
  [47] = {.lex_state = 251, .external_lex_state = 3},
  [48] = {.lex_state = 254, .external_lex_state = 11},
  [49] = {.lex_state = 213},
  [50] = {.lex_state = 213},
  [51] = {.lex_state = 213},
  [52] = {.lex_state = 259, .external_lex_state = 3},
  [53] = {.lex_state = 262, .external_lex_state = 14},
  [54] = {.lex_state = 265, .external_lex_state = 14},
  [55] = {.lex_state = 221, .external_lex_state = 2},
  [56] = {.lex_state = 192, .external_lex_state = 15},
  [57] = {.lex_state = 177, .external_lex_state = 4},
  [58] = {.lex_state = 156, .external_lex_state = 3},
  [59] = {.lex_state = 192, .external_lex_state = 15},
  [60] = {.lex_state = 156, .external_lex_state = 3},
  [61] = {.lex_state = 192, .external_lex_state = 15},
  [62] = {.lex_state = 156, .external_lex_state = 3},
  [63] = {.lex_state = 192, .external_lex_state = 15},
  [64] = {.lex_state = 156, .external_lex_state = 3},
  [65] = {.lex_state = 221, .external_lex_state = 2},
  [66] = {.lex_state = 190, .external_lex_state = 4},
  [67] = {.lex_state = 266, .external_lex_state = 15},
  [68] = {.lex_state = 190, .external_lex_state = 4},
  [69] = {.lex_state = 156, .external_lex_state = 3},
  [70] = {.lex_state = 190, .external_lex_state = 4},
  [71] = {.lex_state = 266, .external_lex_state = 15},
  [72] = {.lex_state = 247, .external_lex_state = 3},
  [73] = {.lex_state = 269},
  [74] = {.lex_state = 286, .external_lex_state = 2},
  [75] = {.lex_state = 288, .external_lex_state = 16},
  [76] = {.lex_state = 177, .external_lex_state = 4},
  [77] = {.lex_state = 177, .external_lex_state = 4},
  [78] = {.lex_state = 177, .external_lex_state = 4},
  [79] = {.lex_state = 177, .external_lex_state = 4},
  [80] = {.lex_state = 190, .external_lex_state = 4},
  [81] = {.lex_state = 190, .external_lex_state = 4},
  [82] = {.lex_state = 177, .external_lex_state = 17},
  [83] = {.lex_state = 192, .external_lex_state = 2},
  [84] = {.lex_state = 237},
  [85] = {.lex_state = 194, .external_lex_state = 6},
  [86] = {.lex_state = 156, .external_lex_state = 3},
  [87] = {.lex_state = 197, .external_lex_state = 7},
  [88] = {.lex_state = 209, .external_lex_state = 2},
  [89] = {.lex_state = 197},
  [90] = {.lex_state = 192, .external_lex_state = 2},
  [91] = {.lex_state = 216, .external_lex_state = 10},
  [92] = {.lex_state = 216, .external_lex_state = 9},
  [93] = {.lex_state = 293, .external_lex_state = 18},
  [94] = {.lex_state = 293, .external_lex_state = 18},
  [95] = {.lex_state = 293, .external_lex_state = 18},
  [96] = {.lex_state = 293, .external_lex_state = 18},
  [97] = {.lex_state = 221, .external_lex_state = 2},
  [98] = {.lex_state = 221, .external_lex_state = 2},
  [99] = {.lex_state = 192, .external_lex_state = 2},
  [100] = {.lex_state = 192, .external_lex_state = 2},
  [101] = {.lex_state = 223, .external_lex_state = 9},
  [102] = {.lex_state = 221, .external_lex_state = 12},
  [103] = {.lex_state = 128, .external_lex_state = 12},
  [104] = {.lex_state = 192, .external_lex_state = 2},
  [105] = {.lex_state = 192, .external_lex_state = 2},
  [106] = {.lex_state = 296, .external_lex_state = 18},
  [107] = {.lex_state = 288, .external_lex_state = 16},
  [108] = {.lex_state = 299, .external_lex_state = 16},
  [109] = {.lex_state = 299, .external_lex_state = 16},
  [110] = {.lex_state = 299, .external_lex_state = 16},
  [111] = {.lex_state = 235, .external_lex_state = 13},
  [112] = {.lex_state = 237},
  [113] = {.lex_state = 302, .external_lex_state = 16},
  [114] = {.lex_state = 156, .external_lex_state = 16},
  [115] = {.lex_state = 304, .external_lex_state = 18},
  [116] = {.lex_state = 237, .external_lex_state = 19},
  [117] = {.lex_state = 213},
  [118] = {.lex_state = 299, .external_lex_state = 16},
  [119] = {.lex_state = 305, .external_lex_state = 20},
  [120] = {.lex_state = 194},
  [121] = {.lex_state = 194, .external_lex_state = 19},
  [122] = {.lex_state = 237, .external_lex_state = 19},
  [123] = {.lex_state = 286, .external_lex_state = 2},
  [124] = {.lex_state = 308, .external_lex_state = 8},
  [125] = {.lex_state = 177, .external_lex_state = 4},
  [126] = {.lex_state = 192, .external_lex_state = 2},
  [127] = {.lex_state = 308, .external_lex_state = 8},
  [128] = {.lex_state = 310, .external_lex_state = 8},
  [129] = {.lex_state = 310, .external_lex_state = 8},
  [130] = {.lex_state = 156, .external_lex_state = 3},
  [131] = {.lex_state = 310},
  [132] = {.lex_state = 310, .external_lex_state = 8},
  [133] = {.lex_state = 192, .external_lex_state = 2},
  [134] = {.lex_state = 156, .external_lex_state = 3},
  [135] = {.lex_state = 313, .external_lex_state = 9},
  [136] = {.lex_state = 315, .external_lex_state = 11},
  [137] = {.lex_state = 315, .external_lex_state = 11},
  [138] = {.lex_state = 315, .external_lex_state = 11},
  [139] = {.lex_state = 315, .external_lex_state = 11},
  [140] = {.lex_state = 192, .external_lex_state = 2},
  [141] = {.lex_state = 192, .external_lex_state = 2},
  [142] = {.lex_state = 225, .external_lex_state = 7},
  [143] = {.lex_state = 209},
  [144] = {.lex_state = 209, .external_lex_state = 8},
  [145] = {.lex_state = 209, .external_lex_state = 8},
  [146] = {.lex_state = 302, .external_lex_state = 3},
  [147] = {.lex_state = 318, .external_lex_state = 11},
  [148] = {.lex_state = 213},
  [149] = {.lex_state = 313},
  [150] = {.lex_state = 313},
  [151] = {.lex_state = 321, .external_lex_state = 3},
  [152] = {.lex_state = 324, .external_lex_state = 14},
  [153] = {.lex_state = 327, .external_lex_state = 11},
  [154] = {.lex_state = 330},
  [155] = {.lex_state = 177, .external_lex_state = 4},
  [156] = {.lex_state = 177, .external_lex_state = 4},
  [157] = {.lex_state = 177, .external_lex_state = 4},
  [158] = {.lex_state = 177, .external_lex_state = 4},
  [159] = {.lex_state = 190, .external_lex_state = 4},
  [160] = {.lex_state = 190, .external_lex_state = 4},
  [161] = {.lex_state = 194, .external_lex_state = 6},
  [162] = {.lex_state = 197, .external_lex_state = 7},
  [163] = {.lex_state = 209, .external_lex_state = 2},
  [164] = {.lex_state = 197},
  [165] = {.lex_state = 216, .external_lex_state = 10},
  [166] = {.lex_state = 216, .external_lex_state = 9},
  [167] = {.lex_state = 334, .external_lex_state = 21},
  [168] = {.lex_state = 334, .external_lex_state = 21},
  [169] = {.lex_state = 334, .external_lex_state = 21},
  [170] = {.lex_state = 334, .external_lex_state = 21},
  [171] = {.lex_state = 221, .external_lex_state = 2},
  [172] = {.lex_state = 221, .external_lex_state = 2},
  [173] = {.lex_state = 192, .external_lex_state = 2},
  [174] = {.lex_state = 192, .external_lex_state = 2},
  [175] = {.lex_state = 223, .external_lex_state = 9},
  [176] = {.lex_state = 221, .external_lex_state = 12},
  [177] = {.lex_state = 128, .external_lex_state = 12},
  [178] = {.lex_state = 330},
  [179] = {.lex_state = 337},
  [180] = {.lex_state = 337},
  [181] = {.lex_state = 337},
  [182] = {.lex_state = 235, .external_lex_state = 13},
  [183] = {.lex_state = 237},
  [184] = {.lex_state = 330},
  [185] = {.lex_state = 340, .external_lex_state = 21},
  [186] = {.lex_state = 337},
  [187] = {.lex_state = 343, .external_lex_state = 22},
  [188] = {.lex_state = 192, .external_lex_state = 2},
  [189] = {.lex_state = 197},
  [190] = {.lex_state = 346, .external_lex_state = 23},
  [191] = {.lex_state = 330},
  [192] = {.lex_state = 346, .external_lex_state = 23},
  [193] = {.lex_state = 334, .external_lex_state = 21},
  [194] = {.lex_state = 350, .external_lex_state = 23},
  [195] = {.lex_state = 350, .external_lex_state = 23},
  [196] = {.lex_state = 192, .external_lex_state = 2},
  [197] = {.lex_state = 192, .external_lex_state = 2},
  [198] = {.lex_state = 192, .external_lex_state = 2},
  [199] = {.lex_state = 237},
  [200] = {.lex_state = 197},
  [201] = {.lex_state = 192, .external_lex_state = 2},
  [202] = {.lex_state = 353, .external_lex_state = 11},
  [203] = {.lex_state = 353, .external_lex_state = 11},
  [204] = {.lex_state = 353, .external_lex_state = 11},
  [205] = {.lex_state = 353, .external_lex_state = 11},
  [206] = {.lex_state = 356, .external_lex_state = 13},
  [207] = {.lex_state = 192, .external_lex_state = 2},
  [208] = {.lex_state = 192, .external_lex_state = 2},
  [209] = {.lex_state = 358, .external_lex_state = 11},
  [210] = {.lex_state = 299, .external_lex_state = 3},
  [211] = {.lex_state = 299, .external_lex_state = 3},
  [212] = {.lex_state = 299, .external_lex_state = 3},
  [213] = {.lex_state = 361, .external_lex_state = 3},
  [214] = {.lex_state = 156, .external_lex_state = 3},
  [215] = {.lex_state = 364, .external_lex_state = 11},
  [216] = {.lex_state = 156, .external_lex_state = 3},
  [217] = {.lex_state = 262, .external_lex_state = 3},
  [218] = {.lex_state = 365, .external_lex_state = 3},
  [219] = {.lex_state = 213},
  [220] = {.lex_state = 368, .external_lex_state = 3},
  [221] = {.lex_state = 371, .external_lex_state = 14},
  [222] = {.lex_state = 156, .external_lex_state = 3},
  [223] = {.lex_state = 156, .external_lex_state = 3},
  [224] = {.lex_state = 156, .external_lex_state = 3},
  [225] = {.lex_state = 192, .external_lex_state = 2},
  [226] = {.lex_state = 218, .external_lex_state = 11},
  [227] = {.lex_state = 218, .external_lex_state = 11},
  [228] = {.lex_state = 218, .external_lex_state = 11},
  [229] = {.lex_state = 218, .external_lex_state = 11},
  [230] = {.lex_state = 192, .external_lex_state = 2},
  [231] = {.lex_state = 192, .external_lex_state = 2},
  [232] = {.lex_state = 225, .external_lex_state = 7},
  [233] = {.lex_state = 128, .external_lex_state = 8},
  [234] = {.lex_state = 247, .external_lex_state = 3},
  [235] = {.lex_state = 254, .external_lex_state = 11},
  [236] = {.lex_state = 213},
  [237] = {.lex_state = 259, .external_lex_state = 3},
  [238] = {.lex_state = 262, .external_lex_state = 14},
  [239] = {.lex_state = 128, .external_lex_state = 8},
  [240] = {.lex_state = 192, .external_lex_state = 2},
  [241] = {.lex_state = 218, .external_lex_state = 11},
  [242] = {.lex_state = 218, .external_lex_state = 11},
  [243] = {.lex_state = 218, .external_lex_state = 11},
  [244] = {.lex_state = 218, .external_lex_state = 11},
  [245] = {.lex_state = 192, .external_lex_state = 2},
  [246] = {.lex_state = 192, .external_lex_state = 2},
  [247] = {.lex_state = 247, .external_lex_state = 3},
  [248] = {.lex_state = 254, .external_lex_state = 11},
  [249] = {.lex_state = 213},
  [250] = {.lex_state = 259, .external_lex_state = 3},
  [251] = {.lex_state = 262, .external_lex_state = 14},
  [252] = {.lex_state = 247, .external_lex_state = 3},
  [253] = {.lex_state = 209, .external_lex_state = 2},
  [254] = {.lex_state = 372, .external_lex_state = 9},
  [255] = {.lex_state = 374, .external_lex_state = 21},
  [256] = {.lex_state = 128},
  [257] = {.lex_state = 156},
  [258] = {.lex_state = 337},
  [259] = {.lex_state = 192, .external_lex_state = 2},
  [260] = {.lex_state = 218, .external_lex_state = 11},
  [261] = {.lex_state = 218, .external_lex_state = 11},
  [262] = {.lex_state = 218, .external_lex_state = 11},
  [263] = {.lex_state = 218, .external_lex_state = 11},
  [264] = {.lex_state = 192, .external_lex_state = 2},
  [265] = {.lex_state = 192, .external_lex_state = 2},
  [266] = {.lex_state = 247, .external_lex_state = 3},
  [267] = {.lex_state = 254, .external_lex_state = 11},
  [268] = {.lex_state = 213},
  [269] = {.lex_state = 259, .external_lex_state = 3},
  [270] = {.lex_state = 262, .external_lex_state = 14},
  [271] = {.lex_state = 128},
  [272] = {.lex_state = 177, .external_lex_state = 17},
  [273] = {.lex_state = 192, .external_lex_state = 2},
  [274] = {.lex_state = 128, .external_lex_state = 12},
  [275] = {.lex_state = 218, .external_lex_state = 11},
  [276] = {.lex_state = 218, .external_lex_state = 11},
  [277] = {.lex_state = 218, .external_lex_state = 11},
  [278] = {.lex_state = 218, .external_lex_state = 11},
  [279] = {.lex_state = 377, .external_lex_state = 24},
  [280] = {.lex_state = 128, .external_lex_state = 12},
  [281] = {.lex_state = 128, .external_lex_state = 2},
  [282] = {.lex_state = 192, .external_lex_state = 2},
  [283] = {.lex_state = 192, .external_lex_state = 2},
  [284] = {.lex_state = 225, .external_lex_state = 7},
  [285] = {.lex_state = 128},
  [286] = {.lex_state = 128, .external_lex_state = 8},
  [287] = {.lex_state = 128, .external_lex_state = 8},
  [288] = {.lex_state = 128},
  [289] = {.lex_state = 128},
  [290] = {.lex_state = 128},
  [291] = {.lex_state = 156, .external_lex_state = 3},
  [292] = {.lex_state = 247, .external_lex_state = 3},
  [293] = {.lex_state = 254, .external_lex_state = 11},
  [294] = {.lex_state = 213},
  [295] = {.lex_state = 259, .external_lex_state = 3},
  [296] = {.lex_state = 262, .external_lex_state = 14},
  [297] = {.lex_state = 128, .external_lex_state = 2},
  [298] = {.lex_state = 247, .external_lex_state = 3},
  [299] = {.lex_state = 380, .external_lex_state = 3},
  [300] = {.lex_state = 382, .external_lex_state = 8},
  [301] = {.lex_state = 384, .external_lex_state = 8},
  [302] = {.lex_state = 225, .external_lex_state = 7},
  [303] = {.lex_state = 177, .external_lex_state = 4},
  [304] = {.lex_state = 225, .external_lex_state = 7},
  [305] = {.lex_state = 386, .external_lex_state = 7},
  [306] = {.lex_state = 225, .external_lex_state = 7},
  [307] = {.lex_state = 156, .external_lex_state = 3},
  [308] = {.lex_state = 388, .external_lex_state = 25},
  [309] = {.lex_state = 177, .external_lex_state = 4},
  [310] = {.lex_state = 177, .external_lex_state = 4},
  [311] = {.lex_state = 177, .external_lex_state = 4},
  [312] = {.lex_state = 177, .external_lex_state = 4},
  [313] = {.lex_state = 190, .external_lex_state = 4},
  [314] = {.lex_state = 190, .external_lex_state = 4},
  [315] = {.lex_state = 192, .external_lex_state = 2},
  [316] = {.lex_state = 192, .external_lex_state = 2},
  [317] = {.lex_state = 192, .external_lex_state = 2},
  [318] = {.lex_state = 237},
  [319] = {.lex_state = 194, .external_lex_state = 6},
  [320] = {.lex_state = 197, .external_lex_state = 7},
  [321] = {.lex_state = 209, .external_lex_state = 2},
  [322] = {.lex_state = 197},
  [323] = {.lex_state = 192, .external_lex_state = 2},
  [324] = {.lex_state = 216, .external_lex_state = 10},
  [325] = {.lex_state = 216, .external_lex_state = 9},
  [326] = {.lex_state = 391, .external_lex_state = 26},
  [327] = {.lex_state = 391, .external_lex_state = 26},
  [328] = {.lex_state = 391, .external_lex_state = 26},
  [329] = {.lex_state = 391, .external_lex_state = 26},
  [330] = {.lex_state = 221, .external_lex_state = 2},
  [331] = {.lex_state = 221, .external_lex_state = 2},
  [332] = {.lex_state = 192, .external_lex_state = 2},
  [333] = {.lex_state = 192, .external_lex_state = 2},
  [334] = {.lex_state = 223, .external_lex_state = 9},
  [335] = {.lex_state = 221, .external_lex_state = 12},
  [336] = {.lex_state = 128, .external_lex_state = 12},
  [337] = {.lex_state = 156, .external_lex_state = 3},
  [338] = {.lex_state = 192, .external_lex_state = 2},
  [339] = {.lex_state = 192, .external_lex_state = 2},
  [340] = {.lex_state = 394, .external_lex_state = 26},
  [341] = {.lex_state = 388, .external_lex_state = 25},
  [342] = {.lex_state = 397, .external_lex_state = 25},
  [343] = {.lex_state = 397, .external_lex_state = 25},
  [344] = {.lex_state = 397, .external_lex_state = 25},
  [345] = {.lex_state = 235, .external_lex_state = 13},
  [346] = {.lex_state = 237},
  [347] = {.lex_state = 400, .external_lex_state = 25},
  [348] = {.lex_state = 388, .external_lex_state = 25},
  [349] = {.lex_state = 402, .external_lex_state = 26},
  [350] = {.lex_state = 235, .external_lex_state = 19},
  [351] = {.lex_state = 391, .external_lex_state = 19},
  [352] = {.lex_state = 213},
  [353] = {.lex_state = 403, .external_lex_state = 25},
  [354] = {.lex_state = 406, .external_lex_state = 27},
  [355] = {.lex_state = 235},
  [356] = {.lex_state = 409, .external_lex_state = 2},
  [357] = {.lex_state = 411},
  [358] = {.lex_state = 337},
  [359] = {.lex_state = 337},
  [360] = {.lex_state = 128},
  [361] = {.lex_state = 414, .external_lex_state = 12},
  [362] = {.lex_state = 237},
  [363] = {.lex_state = 128},
  [364] = {.lex_state = 156},
  [365] = {.lex_state = 156, .external_lex_state = 3},
  [366] = {.lex_state = 128, .external_lex_state = 5},
  [367] = {.lex_state = 128, .external_lex_state = 2},
  [368] = {.lex_state = 245, .external_lex_state = 8},
  [369] = {.lex_state = 192, .external_lex_state = 2},
  [370] = {.lex_state = 192, .external_lex_state = 2},
  [371] = {.lex_state = 192, .external_lex_state = 2},
  [372] = {.lex_state = 192, .external_lex_state = 2},
  [373] = {.lex_state = 192, .external_lex_state = 2},
  [374] = {.lex_state = 192, .external_lex_state = 2},
  [375] = {.lex_state = 192, .external_lex_state = 2},
  [376] = {.lex_state = 192, .external_lex_state = 2},
  [377] = {.lex_state = 192, .external_lex_state = 2},
  [378] = {.lex_state = 192, .external_lex_state = 2},
  [379] = {.lex_state = 192, .external_lex_state = 2},
  [380] = {.lex_state = 192, .external_lex_state = 2},
  [381] = {.lex_state = 192, .external_lex_state = 2},
  [382] = {.lex_state = 192, .external_lex_state = 2},
  [383] = {.lex_state = 192, .external_lex_state = 2},
  [384] = {.lex_state = 416, .external_lex_state = 28},
  [385] = {.lex_state = 235, .external_lex_state = 13},
  [386] = {.lex_state = 197},
  [387] = {.lex_state = 299, .external_lex_state = 3},
  [388] = {.lex_state = 177, .external_lex_state = 4},
  [389] = {.lex_state = 177, .external_lex_state = 4},
  [390] = {.lex_state = 177, .external_lex_state = 4},
  [391] = {.lex_state = 177, .external_lex_state = 4},
  [392] = {.lex_state = 190, .external_lex_state = 4},
  [393] = {.lex_state = 190, .external_lex_state = 4},
  [394] = {.lex_state = 192, .external_lex_state = 2},
  [395] = {.lex_state = 192, .external_lex_state = 2},
  [396] = {.lex_state = 192, .external_lex_state = 2},
  [397] = {.lex_state = 237},
  [398] = {.lex_state = 419, .external_lex_state = 6},
  [399] = {.lex_state = 197, .external_lex_state = 7},
  [400] = {.lex_state = 209, .external_lex_state = 2},
  [401] = {.lex_state = 192, .external_lex_state = 2},
  [402] = {.lex_state = 216, .external_lex_state = 10},
  [403] = {.lex_state = 216, .external_lex_state = 9},
  [404] = {.lex_state = 364, .external_lex_state = 11},
  [405] = {.lex_state = 364, .external_lex_state = 11},
  [406] = {.lex_state = 364, .external_lex_state = 11},
  [407] = {.lex_state = 364, .external_lex_state = 11},
  [408] = {.lex_state = 221, .external_lex_state = 2},
  [409] = {.lex_state = 221, .external_lex_state = 2},
  [410] = {.lex_state = 192, .external_lex_state = 2},
  [411] = {.lex_state = 192, .external_lex_state = 2},
  [412] = {.lex_state = 223, .external_lex_state = 9},
  [413] = {.lex_state = 414, .external_lex_state = 12},
  [414] = {.lex_state = 221, .external_lex_state = 12},
  [415] = {.lex_state = 128, .external_lex_state = 12},
  [416] = {.lex_state = 356, .external_lex_state = 13},
  [417] = {.lex_state = 192, .external_lex_state = 2},
  [418] = {.lex_state = 192, .external_lex_state = 2},
  [419] = {.lex_state = 358, .external_lex_state = 11},
  [420] = {.lex_state = 299, .external_lex_state = 3},
  [421] = {.lex_state = 235, .external_lex_state = 13},
  [422] = {.lex_state = 237},
  [423] = {.lex_state = 421, .external_lex_state = 3},
  [424] = {.lex_state = 299, .external_lex_state = 3},
  [425] = {.lex_state = 364, .external_lex_state = 11},
  [426] = {.lex_state = 227, .external_lex_state = 3},
  [427] = {.lex_state = 424, .external_lex_state = 3},
  [428] = {.lex_state = 424, .external_lex_state = 3},
  [429] = {.lex_state = 227, .external_lex_state = 3},
  [430] = {.lex_state = 213},
  [431] = {.lex_state = 421, .external_lex_state = 3},
  [432] = {.lex_state = 427, .external_lex_state = 14},
  [433] = {.lex_state = 192, .external_lex_state = 29},
  [434] = {.lex_state = 428, .external_lex_state = 9},
  [435] = {.lex_state = 192, .external_lex_state = 2},
  [436] = {.lex_state = 262, .external_lex_state = 14},
  [437] = {.lex_state = 192, .external_lex_state = 2},
  [438] = {.lex_state = 197},
  [439] = {.lex_state = 194},
  [440] = {.lex_state = 430, .external_lex_state = 18},
  [441] = {.lex_state = 430, .external_lex_state = 18},
  [442] = {.lex_state = 430, .external_lex_state = 18},
  [443] = {.lex_state = 430, .external_lex_state = 18},
  [444] = {.lex_state = 192, .external_lex_state = 2},
  [445] = {.lex_state = 192, .external_lex_state = 2},
  [446] = {.lex_state = 225, .external_lex_state = 7},
  [447] = {.lex_state = 225, .external_lex_state = 7},
  [448] = {.lex_state = 433, .external_lex_state = 16},
  [449] = {.lex_state = 433, .external_lex_state = 16},
  [450] = {.lex_state = 433, .external_lex_state = 16},
  [451] = {.lex_state = 194},
  [452] = {.lex_state = 436, .external_lex_state = 16},
  [453] = {.lex_state = 288, .external_lex_state = 16},
  [454] = {.lex_state = 438, .external_lex_state = 18},
  [455] = {.lex_state = 213},
  [456] = {.lex_state = 441, .external_lex_state = 16},
  [457] = {.lex_state = 444, .external_lex_state = 20},
  [458] = {.lex_state = 265, .external_lex_state = 14},
  [459] = {.lex_state = 177, .external_lex_state = 4},
  [460] = {.lex_state = 156, .external_lex_state = 3},
  [461] = {.lex_state = 156, .external_lex_state = 3},
  [462] = {.lex_state = 156, .external_lex_state = 3},
  [463] = {.lex_state = 194},
  [464] = {.lex_state = 156, .external_lex_state = 3},
  [465] = {.lex_state = 192, .external_lex_state = 15},
  [466] = {.lex_state = 266, .external_lex_state = 15},
  [467] = {.lex_state = 156, .external_lex_state = 3},
  [468] = {.lex_state = 177, .external_lex_state = 4},
  [469] = {.lex_state = 266, .external_lex_state = 15},
  [470] = {.lex_state = 190, .external_lex_state = 4},
  [471] = {.lex_state = 156, .external_lex_state = 3},
  [472] = {.lex_state = 192, .external_lex_state = 15},
  [473] = {.lex_state = 266, .external_lex_state = 15},
  [474] = {.lex_state = 156, .external_lex_state = 3},
  [475] = {.lex_state = 177, .external_lex_state = 4},
  [476] = {.lex_state = 266, .external_lex_state = 15},
  [477] = {.lex_state = 241},
  [478] = {.lex_state = 192, .external_lex_state = 2},
  [479] = {.lex_state = 211, .external_lex_state = 8},
  [480] = {.lex_state = 447, .external_lex_state = 11},
  [481] = {.lex_state = 447, .external_lex_state = 11},
  [482] = {.lex_state = 447, .external_lex_state = 11},
  [483] = {.lex_state = 447, .external_lex_state = 11},
  [484] = {.lex_state = 192, .external_lex_state = 2},
  [485] = {.lex_state = 192, .external_lex_state = 2},
  [486] = {.lex_state = 225, .external_lex_state = 7},
  [487] = {.lex_state = 194},
  [488] = {.lex_state = 237, .external_lex_state = 8},
  [489] = {.lex_state = 237, .external_lex_state = 8},
  [490] = {.lex_state = 436, .external_lex_state = 3},
  [491] = {.lex_state = 450, .external_lex_state = 11},
  [492] = {.lex_state = 213},
  [493] = {.lex_state = 441, .external_lex_state = 3},
  [494] = {.lex_state = 444, .external_lex_state = 14},
  [495] = {.lex_state = 265, .external_lex_state = 20},
  [496] = {.lex_state = 192, .external_lex_state = 15},
  [497] = {.lex_state = 288, .external_lex_state = 16},
  [498] = {.lex_state = 192, .external_lex_state = 15},
  [499] = {.lex_state = 288, .external_lex_state = 16},
  [500] = {.lex_state = 192, .external_lex_state = 15},
  [501] = {.lex_state = 288, .external_lex_state = 16},
  [502] = {.lex_state = 192, .external_lex_state = 15},
  [503] = {.lex_state = 288, .external_lex_state = 16},
  [504] = {.lex_state = 190, .external_lex_state = 4},
  [505] = {.lex_state = 266, .external_lex_state = 15},
  [506] = {.lex_state = 288, .external_lex_state = 16},
  [507] = {.lex_state = 190, .external_lex_state = 4},
  [508] = {.lex_state = 266, .external_lex_state = 15},
  [509] = {.lex_state = 453},
  [510] = {.lex_state = 221, .external_lex_state = 2},
  [511] = {.lex_state = 177, .external_lex_state = 17},
  [512] = {.lex_state = 302, .external_lex_state = 16},
  [513] = {.lex_state = 455, .external_lex_state = 20},
  [514] = {.lex_state = 192, .external_lex_state = 2},
  [515] = {.lex_state = 288, .external_lex_state = 16},
  [516] = {.lex_state = 194},
  [517] = {.lex_state = 194, .external_lex_state = 19},
  [518] = {.lex_state = 192, .external_lex_state = 2},
  [519] = {.lex_state = 288, .external_lex_state = 16},
  [520] = {.lex_state = 310},
  [521] = {.lex_state = 310, .external_lex_state = 8},
  [522] = {.lex_state = 288, .external_lex_state = 16},
  [523] = {.lex_state = 209},
  [524] = {.lex_state = 304, .external_lex_state = 18},
  [525] = {.lex_state = 192, .external_lex_state = 2},
  [526] = {.lex_state = 197},
  [527] = {.lex_state = 458, .external_lex_state = 26},
  [528] = {.lex_state = 458, .external_lex_state = 26},
  [529] = {.lex_state = 458, .external_lex_state = 26},
  [530] = {.lex_state = 458, .external_lex_state = 26},
  [531] = {.lex_state = 192, .external_lex_state = 2},
  [532] = {.lex_state = 192, .external_lex_state = 2},
  [533] = {.lex_state = 461, .external_lex_state = 25},
  [534] = {.lex_state = 461, .external_lex_state = 25},
  [535] = {.lex_state = 461, .external_lex_state = 25},
  [536] = {.lex_state = 436, .external_lex_state = 25},
  [537] = {.lex_state = 464, .external_lex_state = 25},
  [538] = {.lex_state = 438, .external_lex_state = 26},
  [539] = {.lex_state = 213},
  [540] = {.lex_state = 441, .external_lex_state = 25},
  [541] = {.lex_state = 467, .external_lex_state = 27},
  [542] = {.lex_state = 192, .external_lex_state = 2},
  [543] = {.lex_state = 346, .external_lex_state = 23},
  [544] = {.lex_state = 346, .external_lex_state = 23},
  [545] = {.lex_state = 350, .external_lex_state = 23},
  [546] = {.lex_state = 350, .external_lex_state = 23},
  [547] = {.lex_state = 192, .external_lex_state = 2},
  [548] = {.lex_state = 192, .external_lex_state = 2},
  [549] = {.lex_state = 192, .external_lex_state = 2},
  [550] = {.lex_state = 237},
  [551] = {.lex_state = 192, .external_lex_state = 2},
  [552] = {.lex_state = 470, .external_lex_state = 26},
  [553] = {.lex_state = 470, .external_lex_state = 26},
  [554] = {.lex_state = 470, .external_lex_state = 26},
  [555] = {.lex_state = 470, .external_lex_state = 26},
  [556] = {.lex_state = 356, .external_lex_state = 13},
  [557] = {.lex_state = 192, .external_lex_state = 2},
  [558] = {.lex_state = 192, .external_lex_state = 2},
  [559] = {.lex_state = 296, .external_lex_state = 26},
  [560] = {.lex_state = 361, .external_lex_state = 25},
  [561] = {.lex_state = 304, .external_lex_state = 26},
  [562] = {.lex_state = 288, .external_lex_state = 16},
  [563] = {.lex_state = 305, .external_lex_state = 25},
  [564] = {.lex_state = 361, .external_lex_state = 25},
  [565] = {.lex_state = 213},
  [566] = {.lex_state = 368, .external_lex_state = 25},
  [567] = {.lex_state = 371, .external_lex_state = 27},
  [568] = {.lex_state = 288, .external_lex_state = 16},
  [569] = {.lex_state = 288, .external_lex_state = 16},
  [570] = {.lex_state = 288, .external_lex_state = 16},
  [571] = {.lex_state = 128, .external_lex_state = 8},
  [572] = {.lex_state = 128, .external_lex_state = 8},
  [573] = {.lex_state = 247, .external_lex_state = 3},
  [574] = {.lex_state = 247, .external_lex_state = 3},
  [575] = {.lex_state = 128},
  [576] = {.lex_state = 247, .external_lex_state = 3},
  [577] = {.lex_state = 128},
  [578] = {.lex_state = 128},
  [579] = {.lex_state = 128},
  [580] = {.lex_state = 128},
  [581] = {.lex_state = 128},
  [582] = {.lex_state = 288, .external_lex_state = 16},
  [583] = {.lex_state = 128, .external_lex_state = 2},
  [584] = {.lex_state = 302, .external_lex_state = 16},
  [585] = {.lex_state = 473, .external_lex_state = 16},
  [586] = {.lex_state = 192, .external_lex_state = 2},
  [587] = {.lex_state = 288, .external_lex_state = 16},
  [588] = {.lex_state = 288, .external_lex_state = 16},
  [589] = {.lex_state = 235, .external_lex_state = 19},
  [590] = {.lex_state = 235},
  [591] = {.lex_state = 409, .external_lex_state = 2},
  [592] = {.lex_state = 414, .external_lex_state = 12},
  [593] = {.lex_state = 128},
  [594] = {.lex_state = 288, .external_lex_state = 16},
  [595] = {.lex_state = 192, .external_lex_state = 2},
  [596] = {.lex_state = 192, .external_lex_state = 2},
  [597] = {.lex_state = 192, .external_lex_state = 2},
  [598] = {.lex_state = 192, .external_lex_state = 2},
  [599] = {.lex_state = 192, .external_lex_state = 2},
  [600] = {.lex_state = 192, .external_lex_state = 2},
  [601] = {.lex_state = 192, .external_lex_state = 2},
  [602] = {.lex_state = 192, .external_lex_state = 2},
  [603] = {.lex_state = 192, .external_lex_state = 2},
  [604] = {.lex_state = 192, .external_lex_state = 2},
  [605] = {.lex_state = 416, .external_lex_state = 28},
  [606] = {.lex_state = 235, .external_lex_state = 13},
  [607] = {.lex_state = 197},
  [608] = {.lex_state = 397, .external_lex_state = 25},
  [609] = {.lex_state = 177, .external_lex_state = 4},
  [610] = {.lex_state = 177, .external_lex_state = 4},
  [611] = {.lex_state = 177, .external_lex_state = 4},
  [612] = {.lex_state = 177, .external_lex_state = 4},
  [613] = {.lex_state = 190, .external_lex_state = 4},
  [614] = {.lex_state = 190, .external_lex_state = 4},
  [615] = {.lex_state = 192, .external_lex_state = 2},
  [616] = {.lex_state = 192, .external_lex_state = 2},
  [617] = {.lex_state = 192, .external_lex_state = 2},
  [618] = {.lex_state = 237},
  [619] = {.lex_state = 419, .external_lex_state = 6},
  [620] = {.lex_state = 197, .external_lex_state = 7},
  [621] = {.lex_state = 209, .external_lex_state = 2},
  [622] = {.lex_state = 192, .external_lex_state = 2},
  [623] = {.lex_state = 216, .external_lex_state = 10},
  [624] = {.lex_state = 216, .external_lex_state = 9},
  [625] = {.lex_state = 304, .external_lex_state = 26},
  [626] = {.lex_state = 304, .external_lex_state = 26},
  [627] = {.lex_state = 304, .external_lex_state = 26},
  [628] = {.lex_state = 304, .external_lex_state = 26},
  [629] = {.lex_state = 221, .external_lex_state = 2},
  [630] = {.lex_state = 221, .external_lex_state = 2},
  [631] = {.lex_state = 192, .external_lex_state = 2},
  [632] = {.lex_state = 192, .external_lex_state = 2},
  [633] = {.lex_state = 223, .external_lex_state = 9},
  [634] = {.lex_state = 414, .external_lex_state = 12},
  [635] = {.lex_state = 221, .external_lex_state = 12},
  [636] = {.lex_state = 128, .external_lex_state = 12},
  [637] = {.lex_state = 356, .external_lex_state = 13},
  [638] = {.lex_state = 192, .external_lex_state = 2},
  [639] = {.lex_state = 192, .external_lex_state = 2},
  [640] = {.lex_state = 296, .external_lex_state = 26},
  [641] = {.lex_state = 397, .external_lex_state = 25},
  [642] = {.lex_state = 235, .external_lex_state = 13},
  [643] = {.lex_state = 237},
  [644] = {.lex_state = 421, .external_lex_state = 25},
  [645] = {.lex_state = 397, .external_lex_state = 25},
  [646] = {.lex_state = 304, .external_lex_state = 26},
  [647] = {.lex_state = 299, .external_lex_state = 16},
  [648] = {.lex_state = 421, .external_lex_state = 25},
  [649] = {.lex_state = 421, .external_lex_state = 25},
  [650] = {.lex_state = 299, .external_lex_state = 16},
  [651] = {.lex_state = 213},
  [652] = {.lex_state = 421, .external_lex_state = 25},
  [653] = {.lex_state = 427, .external_lex_state = 27},
  [654] = {.lex_state = 192, .external_lex_state = 29},
  [655] = {.lex_state = 192, .external_lex_state = 2},
  [656] = {.lex_state = 455, .external_lex_state = 20},
  [657] = {.lex_state = 156, .external_lex_state = 3},
  [658] = {.lex_state = 194},
  [659] = {.lex_state = 194, .external_lex_state = 6},
  [660] = {.lex_state = 211, .external_lex_state = 8},
  [661] = {.lex_state = 194},
  [662] = {.lex_state = 308, .external_lex_state = 8},
  [663] = {.lex_state = 192, .external_lex_state = 15},
  [664] = {.lex_state = 192, .external_lex_state = 2},
  [665] = {.lex_state = 475, .external_lex_state = 18},
  [666] = {.lex_state = 475, .external_lex_state = 18},
  [667] = {.lex_state = 475, .external_lex_state = 18},
  [668] = {.lex_state = 475, .external_lex_state = 18},
  [669] = {.lex_state = 192, .external_lex_state = 2},
  [670] = {.lex_state = 192, .external_lex_state = 2},
  [671] = {.lex_state = 302, .external_lex_state = 16},
  [672] = {.lex_state = 478, .external_lex_state = 18},
  [673] = {.lex_state = 213},
  [674] = {.lex_state = 321, .external_lex_state = 16},
  [675] = {.lex_state = 324, .external_lex_state = 20},
  [676] = {.lex_state = 308, .external_lex_state = 8},
  [677] = {.lex_state = 225, .external_lex_state = 7},
  [678] = {.lex_state = 411},
  [679] = {.lex_state = 254, .external_lex_state = 8},
  [680] = {.lex_state = 254, .external_lex_state = 8},
  [681] = {.lex_state = 128},
  [682] = {.lex_state = 481, .external_lex_state = 8},
  [683] = {.lex_state = 128, .external_lex_state = 2},
  [684] = {.lex_state = 254, .external_lex_state = 8},
  [685] = {.lex_state = 302, .external_lex_state = 3},
  [686] = {.lex_state = 484, .external_lex_state = 21},
  [687] = {.lex_state = 192, .external_lex_state = 2},
  [688] = {.lex_state = 192, .external_lex_state = 2},
  [689] = {.lex_state = 192, .external_lex_state = 2},
  [690] = {.lex_state = 237},
  [691] = {.lex_state = 192, .external_lex_state = 2},
  [692] = {.lex_state = 487, .external_lex_state = 11},
  [693] = {.lex_state = 487, .external_lex_state = 11},
  [694] = {.lex_state = 487, .external_lex_state = 11},
  [695] = {.lex_state = 487, .external_lex_state = 11},
  [696] = {.lex_state = 192, .external_lex_state = 2},
  [697] = {.lex_state = 192, .external_lex_state = 2},
  [698] = {.lex_state = 490, .external_lex_state = 11},
  [699] = {.lex_state = 493, .external_lex_state = 3},
  [700] = {.lex_state = 496, .external_lex_state = 11},
  [701] = {.lex_state = 324, .external_lex_state = 3},
  [702] = {.lex_state = 493, .external_lex_state = 3},
  [703] = {.lex_state = 213},
  [704] = {.lex_state = 497, .external_lex_state = 3},
  [705] = {.lex_state = 493, .external_lex_state = 14},
  [706] = {.lex_state = 302, .external_lex_state = 3},
  [707] = {.lex_state = 302, .external_lex_state = 8},
  [708] = {.lex_state = 156, .external_lex_state = 3},
  [709] = {.lex_state = 209, .external_lex_state = 2},
  [710] = {.lex_state = 209, .external_lex_state = 8},
  [711] = {.lex_state = 192, .external_lex_state = 2},
  [712] = {.lex_state = 192, .external_lex_state = 2},
  [713] = {.lex_state = 192, .external_lex_state = 2},
  [714] = {.lex_state = 192, .external_lex_state = 2},
  [715] = {.lex_state = 192, .external_lex_state = 2},
  [716] = {.lex_state = 192, .external_lex_state = 2},
  [717] = {.lex_state = 192, .external_lex_state = 2},
  [718] = {.lex_state = 192, .external_lex_state = 2},
  [719] = {.lex_state = 192, .external_lex_state = 2},
  [720] = {.lex_state = 192, .external_lex_state = 2},
  [721] = {.lex_state = 192, .external_lex_state = 2},
  [722] = {.lex_state = 192, .external_lex_state = 2},
  [723] = {.lex_state = 192, .external_lex_state = 2},
  [724] = {.lex_state = 192, .external_lex_state = 2},
  [725] = {.lex_state = 192, .external_lex_state = 2},
  [726] = {.lex_state = 192, .external_lex_state = 2},
  [727] = {.lex_state = 192, .external_lex_state = 2},
  [728] = {.lex_state = 192, .external_lex_state = 2},
  [729] = {.lex_state = 237},
  [730] = {.lex_state = 192, .external_lex_state = 2},
  [731] = {.lex_state = 496, .external_lex_state = 11},
  [732] = {.lex_state = 496, .external_lex_state = 11},
  [733] = {.lex_state = 496, .external_lex_state = 11},
  [734] = {.lex_state = 496, .external_lex_state = 11},
  [735] = {.lex_state = 192, .external_lex_state = 2},
  [736] = {.lex_state = 192, .external_lex_state = 2},
  [737] = {.lex_state = 490, .external_lex_state = 11},
  [738] = {.lex_state = 497, .external_lex_state = 3},
  [739] = {.lex_state = 496, .external_lex_state = 11},
  [740] = {.lex_state = 321, .external_lex_state = 3},
  [741] = {.lex_state = 321, .external_lex_state = 3},
  [742] = {.lex_state = 213},
  [743] = {.lex_state = 497, .external_lex_state = 3},
  [744] = {.lex_state = 497, .external_lex_state = 14},
  [745] = {.lex_state = 192, .external_lex_state = 29},
  [746] = {.lex_state = 313},
  [747] = {.lex_state = 500, .external_lex_state = 9},
  [748] = {.lex_state = 192, .external_lex_state = 2},
  [749] = {.lex_state = 324, .external_lex_state = 14},
  [750] = {.lex_state = 343, .external_lex_state = 22},
  [751] = {.lex_state = 192, .external_lex_state = 15},
  [752] = {.lex_state = 330},
  [753] = {.lex_state = 192, .external_lex_state = 15},
  [754] = {.lex_state = 330},
  [755] = {.lex_state = 192, .external_lex_state = 15},
  [756] = {.lex_state = 330},
  [757] = {.lex_state = 192, .external_lex_state = 15},
  [758] = {.lex_state = 330},
  [759] = {.lex_state = 190, .external_lex_state = 4},
  [760] = {.lex_state = 266, .external_lex_state = 15},
  [761] = {.lex_state = 330},
  [762] = {.lex_state = 190, .external_lex_state = 4},
  [763] = {.lex_state = 266, .external_lex_state = 15},
  [764] = {.lex_state = 330},
  [765] = {.lex_state = 194},
  [766] = {.lex_state = 194, .external_lex_state = 19},
  [767] = {.lex_state = 192, .external_lex_state = 2},
  [768] = {.lex_state = 330},
  [769] = {.lex_state = 310},
  [770] = {.lex_state = 310, .external_lex_state = 8},
  [771] = {.lex_state = 330},
  [772] = {.lex_state = 209},
  [773] = {.lex_state = 484, .external_lex_state = 21},
  [774] = {.lex_state = 192, .external_lex_state = 2},
  [775] = {.lex_state = 346, .external_lex_state = 23},
  [776] = {.lex_state = 346, .external_lex_state = 23},
  [777] = {.lex_state = 350, .external_lex_state = 23},
  [778] = {.lex_state = 350, .external_lex_state = 23},
  [779] = {.lex_state = 192, .external_lex_state = 2},
  [780] = {.lex_state = 192, .external_lex_state = 2},
  [781] = {.lex_state = 237},
  [782] = {.lex_state = 192, .external_lex_state = 2},
  [783] = {.lex_state = 356, .external_lex_state = 13},
  [784] = {.lex_state = 296, .external_lex_state = 26},
  [785] = {.lex_state = 361, .external_lex_state = 25},
  [786] = {.lex_state = 330},
  [787] = {.lex_state = 334, .external_lex_state = 19},
  [788] = {.lex_state = 340, .external_lex_state = 19},
  [789] = {.lex_state = 371, .external_lex_state = 27},
  [790] = {.lex_state = 330},
  [791] = {.lex_state = 330},
  [792] = {.lex_state = 330},
  [793] = {.lex_state = 128, .external_lex_state = 8},
  [794] = {.lex_state = 128, .external_lex_state = 8},
  [795] = {.lex_state = 247, .external_lex_state = 3},
  [796] = {.lex_state = 247, .external_lex_state = 3},
  [797] = {.lex_state = 128},
  [798] = {.lex_state = 247, .external_lex_state = 3},
  [799] = {.lex_state = 128},
  [800] = {.lex_state = 128},
  [801] = {.lex_state = 128},
  [802] = {.lex_state = 128},
  [803] = {.lex_state = 128},
  [804] = {.lex_state = 330},
  [805] = {.lex_state = 128, .external_lex_state = 2},
  [806] = {.lex_state = 330},
  [807] = {.lex_state = 330},
  [808] = {.lex_state = 235, .external_lex_state = 19},
  [809] = {.lex_state = 235},
  [810] = {.lex_state = 409, .external_lex_state = 2},
  [811] = {.lex_state = 414, .external_lex_state = 12},
  [812] = {.lex_state = 128},
  [813] = {.lex_state = 337},
  [814] = {.lex_state = 416, .external_lex_state = 28},
  [815] = {.lex_state = 235, .external_lex_state = 13},
  [816] = {.lex_state = 197},
  [817] = {.lex_state = 192, .external_lex_state = 2},
  [818] = {.lex_state = 192, .external_lex_state = 2},
  [819] = {.lex_state = 192, .external_lex_state = 2},
  [820] = {.lex_state = 237},
  [821] = {.lex_state = 419, .external_lex_state = 6},
  [822] = {.lex_state = 192, .external_lex_state = 2},
  [823] = {.lex_state = 502, .external_lex_state = 26},
  [824] = {.lex_state = 502, .external_lex_state = 26},
  [825] = {.lex_state = 502, .external_lex_state = 26},
  [826] = {.lex_state = 502, .external_lex_state = 26},
  [827] = {.lex_state = 192, .external_lex_state = 2},
  [828] = {.lex_state = 192, .external_lex_state = 2},
  [829] = {.lex_state = 296, .external_lex_state = 26},
  [830] = {.lex_state = 505, .external_lex_state = 25},
  [831] = {.lex_state = 337},
  [832] = {.lex_state = 340, .external_lex_state = 19},
  [833] = {.lex_state = 340, .external_lex_state = 19},
  [834] = {.lex_state = 337},
  [835] = {.lex_state = 213},
  [836] = {.lex_state = 421, .external_lex_state = 25},
  [837] = {.lex_state = 505, .external_lex_state = 27},
  [838] = {.lex_state = 343, .external_lex_state = 22},
  [839] = {.lex_state = 247, .external_lex_state = 3},
  [840] = {.lex_state = 346, .external_lex_state = 23},
  [841] = {.lex_state = 192, .external_lex_state = 2},
  [842] = {.lex_state = 128, .external_lex_state = 8},
  [843] = {.lex_state = 128, .external_lex_state = 2},
  [844] = {.lex_state = 197},
  [845] = {.lex_state = 192, .external_lex_state = 2},
  [846] = {.lex_state = 192, .external_lex_state = 2},
  [847] = {.lex_state = 192, .external_lex_state = 2},
  [848] = {.lex_state = 237},
  [849] = {.lex_state = 419, .external_lex_state = 6},
  [850] = {.lex_state = 192, .external_lex_state = 2},
  [851] = {.lex_state = 470, .external_lex_state = 26},
  [852] = {.lex_state = 470, .external_lex_state = 26},
  [853] = {.lex_state = 470, .external_lex_state = 26},
  [854] = {.lex_state = 470, .external_lex_state = 26},
  [855] = {.lex_state = 192, .external_lex_state = 2},
  [856] = {.lex_state = 192, .external_lex_state = 2},
  [857] = {.lex_state = 296, .external_lex_state = 26},
  [858] = {.lex_state = 508, .external_lex_state = 25},
  [859] = {.lex_state = 334, .external_lex_state = 19},
  [860] = {.lex_state = 340, .external_lex_state = 19},
  [861] = {.lex_state = 213},
  [862] = {.lex_state = 421, .external_lex_state = 25},
  [863] = {.lex_state = 508, .external_lex_state = 27},
  [864] = {.lex_state = 156, .external_lex_state = 3},
  [865] = {.lex_state = 128, .external_lex_state = 2},
  [866] = {.lex_state = 192, .external_lex_state = 2},
  [867] = {.lex_state = 511, .external_lex_state = 11},
  [868] = {.lex_state = 511, .external_lex_state = 11},
  [869] = {.lex_state = 511, .external_lex_state = 11},
  [870] = {.lex_state = 511, .external_lex_state = 11},
  [871] = {.lex_state = 192, .external_lex_state = 2},
  [872] = {.lex_state = 192, .external_lex_state = 2},
  [873] = {.lex_state = 365, .external_lex_state = 3},
  [874] = {.lex_state = 213},
  [875] = {.lex_state = 259, .external_lex_state = 3},
  [876] = {.lex_state = 365, .external_lex_state = 14},
  [877] = {.lex_state = 365, .external_lex_state = 3},
  [878] = {.lex_state = 361, .external_lex_state = 3},
  [879] = {.lex_state = 361, .external_lex_state = 14},
  [880] = {.lex_state = 192, .external_lex_state = 2},
  [881] = {.lex_state = 514, .external_lex_state = 11},
  [882] = {.lex_state = 365, .external_lex_state = 3},
  [883] = {.lex_state = 192, .external_lex_state = 2},
  [884] = {.lex_state = 192, .external_lex_state = 2},
  [885] = {.lex_state = 237},
  [886] = {.lex_state = 192, .external_lex_state = 2},
  [887] = {.lex_state = 358, .external_lex_state = 11},
  [888] = {.lex_state = 361, .external_lex_state = 3},
  [889] = {.lex_state = 361, .external_lex_state = 3},
  [890] = {.lex_state = 361, .external_lex_state = 3},
  [891] = {.lex_state = 371, .external_lex_state = 14},
  [892] = {.lex_state = 192, .external_lex_state = 2},
  [893] = {.lex_state = 192, .external_lex_state = 2},
  [894] = {.lex_state = 192, .external_lex_state = 2},
  [895] = {.lex_state = 237},
  [896] = {.lex_state = 156, .external_lex_state = 3},
  [897] = {.lex_state = 192, .external_lex_state = 2},
  [898] = {.lex_state = 517, .external_lex_state = 26},
  [899] = {.lex_state = 517, .external_lex_state = 26},
  [900] = {.lex_state = 517, .external_lex_state = 26},
  [901] = {.lex_state = 517, .external_lex_state = 26},
  [902] = {.lex_state = 192, .external_lex_state = 2},
  [903] = {.lex_state = 192, .external_lex_state = 2},
  [904] = {.lex_state = 520, .external_lex_state = 26},
  [905] = {.lex_state = 302, .external_lex_state = 25},
  [906] = {.lex_state = 523, .external_lex_state = 26},
  [907] = {.lex_state = 209, .external_lex_state = 19},
  [908] = {.lex_state = 302, .external_lex_state = 19},
  [909] = {.lex_state = 213},
  [910] = {.lex_state = 497, .external_lex_state = 25},
  [911] = {.lex_state = 493, .external_lex_state = 27},
  [912] = {.lex_state = 209},
  [913] = {.lex_state = 361, .external_lex_state = 3},
  [914] = {.lex_state = 156, .external_lex_state = 3},
  [915] = {.lex_state = 192, .external_lex_state = 2},
  [916] = {.lex_state = 192, .external_lex_state = 2},
  [917] = {.lex_state = 192, .external_lex_state = 2},
  [918] = {.lex_state = 192, .external_lex_state = 2},
  [919] = {.lex_state = 192, .external_lex_state = 2},
  [920] = {.lex_state = 192, .external_lex_state = 2},
  [921] = {.lex_state = 192, .external_lex_state = 2},
  [922] = {.lex_state = 192, .external_lex_state = 2},
  [923] = {.lex_state = 192, .external_lex_state = 2},
  [924] = {.lex_state = 192, .external_lex_state = 2},
  [925] = {.lex_state = 192, .external_lex_state = 2},
  [926] = {.lex_state = 416, .external_lex_state = 28},
  [927] = {.lex_state = 235, .external_lex_state = 13},
  [928] = {.lex_state = 197},
  [929] = {.lex_state = 192, .external_lex_state = 2},
  [930] = {.lex_state = 192, .external_lex_state = 2},
  [931] = {.lex_state = 237},
  [932] = {.lex_state = 419, .external_lex_state = 6},
  [933] = {.lex_state = 192, .external_lex_state = 2},
  [934] = {.lex_state = 414, .external_lex_state = 12},
  [935] = {.lex_state = 356, .external_lex_state = 13},
  [936] = {.lex_state = 358, .external_lex_state = 11},
  [937] = {.lex_state = 421, .external_lex_state = 3},
  [938] = {.lex_state = 299, .external_lex_state = 3},
  [939] = {.lex_state = 421, .external_lex_state = 3},
  [940] = {.lex_state = 421, .external_lex_state = 3},
  [941] = {.lex_state = 299, .external_lex_state = 3},
  [942] = {.lex_state = 427, .external_lex_state = 14},
  [943] = {.lex_state = 177, .external_lex_state = 17},
  [944] = {.lex_state = 262, .external_lex_state = 3},
  [945] = {.lex_state = 524, .external_lex_state = 13},
  [946] = {.lex_state = 365, .external_lex_state = 3},
  [947] = {.lex_state = 192, .external_lex_state = 29},
  [948] = {.lex_state = 192, .external_lex_state = 2},
  [949] = {.lex_state = 361, .external_lex_state = 14},
  [950] = {.lex_state = 247, .external_lex_state = 3},
  [951] = {.lex_state = 192, .external_lex_state = 2},
  [952] = {.lex_state = 192, .external_lex_state = 2},
  [953] = {.lex_state = 192, .external_lex_state = 2},
  [954] = {.lex_state = 237},
  [955] = {.lex_state = 192, .external_lex_state = 2},
  [956] = {.lex_state = 353, .external_lex_state = 11},
  [957] = {.lex_state = 353, .external_lex_state = 11},
  [958] = {.lex_state = 353, .external_lex_state = 11},
  [959] = {.lex_state = 353, .external_lex_state = 11},
  [960] = {.lex_state = 192, .external_lex_state = 2},
  [961] = {.lex_state = 192, .external_lex_state = 2},
  [962] = {.lex_state = 358, .external_lex_state = 11},
  [963] = {.lex_state = 361, .external_lex_state = 3},
  [964] = {.lex_state = 364, .external_lex_state = 11},
  [965] = {.lex_state = 262, .external_lex_state = 3},
  [966] = {.lex_state = 361, .external_lex_state = 3},
  [967] = {.lex_state = 213},
  [968] = {.lex_state = 368, .external_lex_state = 3},
  [969] = {.lex_state = 371, .external_lex_state = 14},
  [970] = {.lex_state = 247, .external_lex_state = 3},
  [971] = {.lex_state = 254, .external_lex_state = 8},
  [972] = {.lex_state = 177, .external_lex_state = 17},
  [973] = {.lex_state = 192, .external_lex_state = 2},
  [974] = {.lex_state = 192, .external_lex_state = 2},
  [975] = {.lex_state = 192, .external_lex_state = 2},
  [976] = {.lex_state = 192, .external_lex_state = 2},
  [977] = {.lex_state = 192, .external_lex_state = 2},
  [978] = {.lex_state = 128, .external_lex_state = 12},
  [979] = {.lex_state = 128, .external_lex_state = 12},
  [980] = {.lex_state = 192, .external_lex_state = 2},
  [981] = {.lex_state = 192, .external_lex_state = 2},
  [982] = {.lex_state = 192, .external_lex_state = 2},
  [983] = {.lex_state = 192, .external_lex_state = 2},
  [984] = {.lex_state = 192, .external_lex_state = 2},
  [985] = {.lex_state = 192, .external_lex_state = 2},
  [986] = {.lex_state = 192, .external_lex_state = 2},
  [987] = {.lex_state = 192, .external_lex_state = 2},
  [988] = {.lex_state = 192, .external_lex_state = 2},
  [989] = {.lex_state = 192, .external_lex_state = 2},
  [990] = {.lex_state = 192, .external_lex_state = 2},
  [991] = {.lex_state = 192, .external_lex_state = 2},
  [992] = {.lex_state = 192, .external_lex_state = 2},
  [993] = {.lex_state = 237},
  [994] = {.lex_state = 192, .external_lex_state = 2},
  [995] = {.lex_state = 364, .external_lex_state = 11},
  [996] = {.lex_state = 364, .external_lex_state = 11},
  [997] = {.lex_state = 364, .external_lex_state = 11},
  [998] = {.lex_state = 364, .external_lex_state = 11},
  [999] = {.lex_state = 192, .external_lex_state = 2},
  [1000] = {.lex_state = 192, .external_lex_state = 2},
  [1001] = {.lex_state = 358, .external_lex_state = 11},
  [1002] = {.lex_state = 421, .external_lex_state = 3},
  [1003] = {.lex_state = 364, .external_lex_state = 11},
  [1004] = {.lex_state = 424, .external_lex_state = 3},
  [1005] = {.lex_state = 424, .external_lex_state = 3},
  [1006] = {.lex_state = 213},
  [1007] = {.lex_state = 421, .external_lex_state = 3},
  [1008] = {.lex_state = 427, .external_lex_state = 14},
  [1009] = {.lex_state = 192, .external_lex_state = 29},
  [1010] = {.lex_state = 192, .external_lex_state = 2},
  [1011] = {.lex_state = 262, .external_lex_state = 14},
  [1012] = {.lex_state = 128, .external_lex_state = 2},
  [1013] = {.lex_state = 128, .external_lex_state = 2},
  [1014] = {.lex_state = 247, .external_lex_state = 3},
  [1015] = {.lex_state = 192, .external_lex_state = 2},
  [1016] = {.lex_state = 192, .external_lex_state = 2},
  [1017] = {.lex_state = 192, .external_lex_state = 2},
  [1018] = {.lex_state = 237},
  [1019] = {.lex_state = 192, .external_lex_state = 2},
  [1020] = {.lex_state = 353, .external_lex_state = 11},
  [1021] = {.lex_state = 353, .external_lex_state = 11},
  [1022] = {.lex_state = 353, .external_lex_state = 11},
  [1023] = {.lex_state = 353, .external_lex_state = 11},
  [1024] = {.lex_state = 192, .external_lex_state = 2},
  [1025] = {.lex_state = 192, .external_lex_state = 2},
  [1026] = {.lex_state = 358, .external_lex_state = 11},
  [1027] = {.lex_state = 361, .external_lex_state = 3},
  [1028] = {.lex_state = 364, .external_lex_state = 11},
  [1029] = {.lex_state = 262, .external_lex_state = 3},
  [1030] = {.lex_state = 361, .external_lex_state = 3},
  [1031] = {.lex_state = 213},
  [1032] = {.lex_state = 368, .external_lex_state = 3},
  [1033] = {.lex_state = 371, .external_lex_state = 14},
  [1034] = {.lex_state = 247, .external_lex_state = 3},
  [1035] = {.lex_state = 192, .external_lex_state = 2},
  [1036] = {.lex_state = 192, .external_lex_state = 2},
  [1037] = {.lex_state = 192, .external_lex_state = 2},
  [1038] = {.lex_state = 192, .external_lex_state = 2},
  [1039] = {.lex_state = 192, .external_lex_state = 2},
  [1040] = {.lex_state = 192, .external_lex_state = 2},
  [1041] = {.lex_state = 192, .external_lex_state = 2},
  [1042] = {.lex_state = 192, .external_lex_state = 2},
  [1043] = {.lex_state = 192, .external_lex_state = 2},
  [1044] = {.lex_state = 192, .external_lex_state = 2},
  [1045] = {.lex_state = 128, .external_lex_state = 2},
  [1046] = {.lex_state = 192, .external_lex_state = 2},
  [1047] = {.lex_state = 192, .external_lex_state = 2},
  [1048] = {.lex_state = 192, .external_lex_state = 2},
  [1049] = {.lex_state = 237},
  [1050] = {.lex_state = 419, .external_lex_state = 6},
  [1051] = {.lex_state = 192, .external_lex_state = 2},
  [1052] = {.lex_state = 364, .external_lex_state = 11},
  [1053] = {.lex_state = 364, .external_lex_state = 11},
  [1054] = {.lex_state = 364, .external_lex_state = 11},
  [1055] = {.lex_state = 364, .external_lex_state = 11},
  [1056] = {.lex_state = 192, .external_lex_state = 2},
  [1057] = {.lex_state = 192, .external_lex_state = 2},
  [1058] = {.lex_state = 358, .external_lex_state = 11},
  [1059] = {.lex_state = 421, .external_lex_state = 3},
  [1060] = {.lex_state = 364, .external_lex_state = 11},
  [1061] = {.lex_state = 227, .external_lex_state = 3},
  [1062] = {.lex_state = 424, .external_lex_state = 3},
  [1063] = {.lex_state = 424, .external_lex_state = 3},
  [1064] = {.lex_state = 213},
  [1065] = {.lex_state = 421, .external_lex_state = 3},
  [1066] = {.lex_state = 427, .external_lex_state = 14},
  [1067] = {.lex_state = 192, .external_lex_state = 29},
  [1068] = {.lex_state = 192, .external_lex_state = 2},
  [1069] = {.lex_state = 262, .external_lex_state = 14},
  [1070] = {.lex_state = 128, .external_lex_state = 2},
  [1071] = {.lex_state = 192, .external_lex_state = 2},
  [1072] = {.lex_state = 192, .external_lex_state = 2},
  [1073] = {.lex_state = 192, .external_lex_state = 2},
  [1074] = {.lex_state = 237},
  [1075] = {.lex_state = 192, .external_lex_state = 2},
  [1076] = {.lex_state = 470, .external_lex_state = 26},
  [1077] = {.lex_state = 470, .external_lex_state = 26},
  [1078] = {.lex_state = 470, .external_lex_state = 26},
  [1079] = {.lex_state = 470, .external_lex_state = 26},
  [1080] = {.lex_state = 192, .external_lex_state = 2},
  [1081] = {.lex_state = 192, .external_lex_state = 2},
  [1082] = {.lex_state = 296, .external_lex_state = 26},
  [1083] = {.lex_state = 508, .external_lex_state = 25},
  [1084] = {.lex_state = 304, .external_lex_state = 26},
  [1085] = {.lex_state = 340, .external_lex_state = 19},
  [1086] = {.lex_state = 340, .external_lex_state = 19},
  [1087] = {.lex_state = 213},
  [1088] = {.lex_state = 421, .external_lex_state = 25},
  [1089] = {.lex_state = 508, .external_lex_state = 27},
  [1090] = {.lex_state = 192, .external_lex_state = 2},
  [1091] = {.lex_state = 128, .external_lex_state = 8},
  [1092] = {.lex_state = 223, .external_lex_state = 9},
  [1093] = {.lex_state = 247, .external_lex_state = 3},
  [1094] = {.lex_state = 192, .external_lex_state = 2},
  [1095] = {.lex_state = 192, .external_lex_state = 2},
  [1096] = {.lex_state = 192, .external_lex_state = 2},
  [1097] = {.lex_state = 237},
  [1098] = {.lex_state = 192, .external_lex_state = 2},
  [1099] = {.lex_state = 353, .external_lex_state = 11},
  [1100] = {.lex_state = 353, .external_lex_state = 11},
  [1101] = {.lex_state = 353, .external_lex_state = 11},
  [1102] = {.lex_state = 353, .external_lex_state = 11},
  [1103] = {.lex_state = 192, .external_lex_state = 2},
  [1104] = {.lex_state = 192, .external_lex_state = 2},
  [1105] = {.lex_state = 358, .external_lex_state = 11},
  [1106] = {.lex_state = 361, .external_lex_state = 3},
  [1107] = {.lex_state = 364, .external_lex_state = 11},
  [1108] = {.lex_state = 262, .external_lex_state = 3},
  [1109] = {.lex_state = 361, .external_lex_state = 3},
  [1110] = {.lex_state = 213},
  [1111] = {.lex_state = 368, .external_lex_state = 3},
  [1112] = {.lex_state = 371, .external_lex_state = 14},
  [1113] = {.lex_state = 247, .external_lex_state = 3},
  [1114] = {.lex_state = 192, .external_lex_state = 2},
  [1115] = {.lex_state = 192, .external_lex_state = 2},
  [1116] = {.lex_state = 192, .external_lex_state = 2},
  [1117] = {.lex_state = 192, .external_lex_state = 2},
  [1118] = {.lex_state = 192, .external_lex_state = 2},
  [1119] = {.lex_state = 192, .external_lex_state = 2},
  [1120] = {.lex_state = 192, .external_lex_state = 2},
  [1121] = {.lex_state = 192, .external_lex_state = 2},
  [1122] = {.lex_state = 192, .external_lex_state = 2},
  [1123] = {.lex_state = 192, .external_lex_state = 2},
  [1124] = {.lex_state = 128},
  [1125] = {.lex_state = 192, .external_lex_state = 29},
  [1126] = {.lex_state = 192, .external_lex_state = 2},
  [1127] = {.lex_state = 262, .external_lex_state = 14},
  [1128] = {.lex_state = 192, .external_lex_state = 29},
  [1129] = {.lex_state = 128},
  [1130] = {.lex_state = 128},
  [1131] = {.lex_state = 526, .external_lex_state = 2},
  [1132] = {.lex_state = 177, .external_lex_state = 17},
  [1133] = {.lex_state = 247, .external_lex_state = 3},
  [1134] = {.lex_state = 192, .external_lex_state = 2},
  [1135] = {.lex_state = 192, .external_lex_state = 2},
  [1136] = {.lex_state = 192, .external_lex_state = 2},
  [1137] = {.lex_state = 237},
  [1138] = {.lex_state = 192, .external_lex_state = 2},
  [1139] = {.lex_state = 353, .external_lex_state = 11},
  [1140] = {.lex_state = 353, .external_lex_state = 11},
  [1141] = {.lex_state = 353, .external_lex_state = 11},
  [1142] = {.lex_state = 353, .external_lex_state = 11},
  [1143] = {.lex_state = 192, .external_lex_state = 2},
  [1144] = {.lex_state = 192, .external_lex_state = 2},
  [1145] = {.lex_state = 358, .external_lex_state = 11},
  [1146] = {.lex_state = 361, .external_lex_state = 3},
  [1147] = {.lex_state = 364, .external_lex_state = 11},
  [1148] = {.lex_state = 262, .external_lex_state = 3},
  [1149] = {.lex_state = 361, .external_lex_state = 3},
  [1150] = {.lex_state = 213},
  [1151] = {.lex_state = 368, .external_lex_state = 3},
  [1152] = {.lex_state = 371, .external_lex_state = 14},
  [1153] = {.lex_state = 192, .external_lex_state = 2},
  [1154] = {.lex_state = 192, .external_lex_state = 2},
  [1155] = {.lex_state = 353, .external_lex_state = 11},
  [1156] = {.lex_state = 353, .external_lex_state = 11},
  [1157] = {.lex_state = 353, .external_lex_state = 11},
  [1158] = {.lex_state = 353, .external_lex_state = 11},
  [1159] = {.lex_state = 216, .external_lex_state = 9},
  [1160] = {.lex_state = 192, .external_lex_state = 2},
  [1161] = {.lex_state = 192, .external_lex_state = 2},
  [1162] = {.lex_state = 128, .external_lex_state = 2},
  [1163] = {.lex_state = 305, .external_lex_state = 8},
  [1164] = {.lex_state = 128, .external_lex_state = 8},
  [1165] = {.lex_state = 528, .external_lex_state = 3},
  [1166] = {.lex_state = 364, .external_lex_state = 11},
  [1167] = {.lex_state = 353, .external_lex_state = 8},
  [1168] = {.lex_state = 213},
  [1169] = {.lex_state = 368, .external_lex_state = 3},
  [1170] = {.lex_state = 361, .external_lex_state = 14},
  [1171] = {.lex_state = 192, .external_lex_state = 2},
  [1172] = {.lex_state = 414, .external_lex_state = 12},
  [1173] = {.lex_state = 218, .external_lex_state = 11},
  [1174] = {.lex_state = 218, .external_lex_state = 11},
  [1175] = {.lex_state = 218, .external_lex_state = 11},
  [1176] = {.lex_state = 218, .external_lex_state = 11},
  [1177] = {.lex_state = 192, .external_lex_state = 2},
  [1178] = {.lex_state = 192, .external_lex_state = 2},
  [1179] = {.lex_state = 225, .external_lex_state = 7},
  [1180] = {.lex_state = 128},
  [1181] = {.lex_state = 128, .external_lex_state = 8},
  [1182] = {.lex_state = 128, .external_lex_state = 8},
  [1183] = {.lex_state = 247, .external_lex_state = 3},
  [1184] = {.lex_state = 254, .external_lex_state = 11},
  [1185] = {.lex_state = 213},
  [1186] = {.lex_state = 259, .external_lex_state = 3},
  [1187] = {.lex_state = 262, .external_lex_state = 14},
  [1188] = {.lex_state = 128, .external_lex_state = 2},
  [1189] = {.lex_state = 192, .external_lex_state = 2},
  [1190] = {.lex_state = 218, .external_lex_state = 11},
  [1191] = {.lex_state = 218, .external_lex_state = 11},
  [1192] = {.lex_state = 218, .external_lex_state = 11},
  [1193] = {.lex_state = 218, .external_lex_state = 11},
  [1194] = {.lex_state = 192, .external_lex_state = 2},
  [1195] = {.lex_state = 192, .external_lex_state = 2},
  [1196] = {.lex_state = 225, .external_lex_state = 7},
  [1197] = {.lex_state = 128},
  [1198] = {.lex_state = 128, .external_lex_state = 8},
  [1199] = {.lex_state = 128, .external_lex_state = 8},
  [1200] = {.lex_state = 247, .external_lex_state = 3},
  [1201] = {.lex_state = 254, .external_lex_state = 11},
  [1202] = {.lex_state = 213},
  [1203] = {.lex_state = 259, .external_lex_state = 3},
  [1204] = {.lex_state = 262, .external_lex_state = 14},
  [1205] = {.lex_state = 247, .external_lex_state = 3},
  [1206] = {.lex_state = 254, .external_lex_state = 8},
  [1207] = {.lex_state = 156, .external_lex_state = 3},
  [1208] = {.lex_state = 128},
  [1209] = {.lex_state = 128},
  [1210] = {.lex_state = 128},
  [1211] = {.lex_state = 128, .external_lex_state = 2},
  [1212] = {.lex_state = 128, .external_lex_state = 8},
  [1213] = {.lex_state = 192, .external_lex_state = 2},
  [1214] = {.lex_state = 192, .external_lex_state = 2},
  [1215] = {.lex_state = 192, .external_lex_state = 2},
  [1216] = {.lex_state = 192, .external_lex_state = 2},
  [1217] = {.lex_state = 192, .external_lex_state = 2},
  [1218] = {.lex_state = 192, .external_lex_state = 2},
  [1219] = {.lex_state = 192, .external_lex_state = 2},
  [1220] = {.lex_state = 192, .external_lex_state = 2},
  [1221] = {.lex_state = 192, .external_lex_state = 2},
  [1222] = {.lex_state = 192, .external_lex_state = 2},
  [1223] = {.lex_state = 192, .external_lex_state = 2},
  [1224] = {.lex_state = 192, .external_lex_state = 2},
  [1225] = {.lex_state = 192, .external_lex_state = 2},
  [1226] = {.lex_state = 192, .external_lex_state = 2},
  [1227] = {.lex_state = 192, .external_lex_state = 2},
  [1228] = {.lex_state = 192, .external_lex_state = 2},
  [1229] = {.lex_state = 192, .external_lex_state = 2},
  [1230] = {.lex_state = 192, .external_lex_state = 2},
  [1231] = {.lex_state = 237},
  [1232] = {.lex_state = 192, .external_lex_state = 2},
  [1233] = {.lex_state = 364, .external_lex_state = 11},
  [1234] = {.lex_state = 364, .external_lex_state = 11},
  [1235] = {.lex_state = 364, .external_lex_state = 11},
  [1236] = {.lex_state = 364, .external_lex_state = 11},
  [1237] = {.lex_state = 192, .external_lex_state = 2},
  [1238] = {.lex_state = 192, .external_lex_state = 2},
  [1239] = {.lex_state = 358, .external_lex_state = 11},
  [1240] = {.lex_state = 421, .external_lex_state = 3},
  [1241] = {.lex_state = 364, .external_lex_state = 11},
  [1242] = {.lex_state = 424, .external_lex_state = 3},
  [1243] = {.lex_state = 424, .external_lex_state = 3},
  [1244] = {.lex_state = 213},
  [1245] = {.lex_state = 421, .external_lex_state = 3},
  [1246] = {.lex_state = 427, .external_lex_state = 14},
  [1247] = {.lex_state = 192, .external_lex_state = 29},
  [1248] = {.lex_state = 192, .external_lex_state = 2},
  [1249] = {.lex_state = 262, .external_lex_state = 14},
  [1250] = {.lex_state = 156, .external_lex_state = 3},
  [1251] = {.lex_state = 225, .external_lex_state = 7},
  [1252] = {.lex_state = 384, .external_lex_state = 8},
  [1253] = {.lex_state = 225, .external_lex_state = 7},
  [1254] = {.lex_state = 192, .external_lex_state = 15},
  [1255] = {.lex_state = 225, .external_lex_state = 7},
  [1256] = {.lex_state = 211, .external_lex_state = 8},
  [1257] = {.lex_state = 530, .external_lex_state = 27},
  [1258] = {.lex_state = 192, .external_lex_state = 15},
  [1259] = {.lex_state = 388, .external_lex_state = 25},
  [1260] = {.lex_state = 192, .external_lex_state = 15},
  [1261] = {.lex_state = 388, .external_lex_state = 25},
  [1262] = {.lex_state = 192, .external_lex_state = 15},
  [1263] = {.lex_state = 388, .external_lex_state = 25},
  [1264] = {.lex_state = 192, .external_lex_state = 15},
  [1265] = {.lex_state = 388, .external_lex_state = 25},
  [1266] = {.lex_state = 190, .external_lex_state = 4},
  [1267] = {.lex_state = 266, .external_lex_state = 15},
  [1268] = {.lex_state = 388, .external_lex_state = 25},
  [1269] = {.lex_state = 190, .external_lex_state = 4},
  [1270] = {.lex_state = 266, .external_lex_state = 15},
  [1271] = {.lex_state = 192, .external_lex_state = 2},
  [1272] = {.lex_state = 531, .external_lex_state = 26},
  [1273] = {.lex_state = 531, .external_lex_state = 26},
  [1274] = {.lex_state = 531, .external_lex_state = 26},
  [1275] = {.lex_state = 531, .external_lex_state = 26},
  [1276] = {.lex_state = 192, .external_lex_state = 2},
  [1277] = {.lex_state = 192, .external_lex_state = 2},
  [1278] = {.lex_state = 400, .external_lex_state = 25},
  [1279] = {.lex_state = 534, .external_lex_state = 26},
  [1280] = {.lex_state = 213},
  [1281] = {.lex_state = 537, .external_lex_state = 25},
  [1282] = {.lex_state = 540, .external_lex_state = 27},
  [1283] = {.lex_state = 400, .external_lex_state = 25},
  [1284] = {.lex_state = 400, .external_lex_state = 25},
  [1285] = {.lex_state = 543, .external_lex_state = 27},
  [1286] = {.lex_state = 192, .external_lex_state = 2},
  [1287] = {.lex_state = 388, .external_lex_state = 25},
  [1288] = {.lex_state = 194},
  [1289] = {.lex_state = 194, .external_lex_state = 19},
  [1290] = {.lex_state = 192, .external_lex_state = 2},
  [1291] = {.lex_state = 388, .external_lex_state = 25},
  [1292] = {.lex_state = 310},
  [1293] = {.lex_state = 310, .external_lex_state = 8},
  [1294] = {.lex_state = 388, .external_lex_state = 25},
  [1295] = {.lex_state = 209},
  [1296] = {.lex_state = 544, .external_lex_state = 26},
  [1297] = {.lex_state = 400, .external_lex_state = 25},
  [1298] = {.lex_state = 192, .external_lex_state = 2},
  [1299] = {.lex_state = 346, .external_lex_state = 23},
  [1300] = {.lex_state = 346, .external_lex_state = 23},
  [1301] = {.lex_state = 350, .external_lex_state = 23},
  [1302] = {.lex_state = 350, .external_lex_state = 23},
  [1303] = {.lex_state = 192, .external_lex_state = 2},
  [1304] = {.lex_state = 192, .external_lex_state = 2},
  [1305] = {.lex_state = 192, .external_lex_state = 2},
  [1306] = {.lex_state = 237},
  [1307] = {.lex_state = 192, .external_lex_state = 2},
  [1308] = {.lex_state = 192, .external_lex_state = 2},
  [1309] = {.lex_state = 192, .external_lex_state = 2},
  [1310] = {.lex_state = 394, .external_lex_state = 26},
  [1311] = {.lex_state = 406, .external_lex_state = 25},
  [1312] = {.lex_state = 388, .external_lex_state = 25},
  [1313] = {.lex_state = 406, .external_lex_state = 25},
  [1314] = {.lex_state = 406, .external_lex_state = 25},
  [1315] = {.lex_state = 213},
  [1316] = {.lex_state = 403, .external_lex_state = 25},
  [1317] = {.lex_state = 406, .external_lex_state = 27},
  [1318] = {.lex_state = 388, .external_lex_state = 25},
  [1319] = {.lex_state = 388, .external_lex_state = 25},
  [1320] = {.lex_state = 388, .external_lex_state = 25},
  [1321] = {.lex_state = 128, .external_lex_state = 8},
  [1322] = {.lex_state = 128, .external_lex_state = 8},
  [1323] = {.lex_state = 247, .external_lex_state = 3},
  [1324] = {.lex_state = 247, .external_lex_state = 3},
  [1325] = {.lex_state = 128},
  [1326] = {.lex_state = 247, .external_lex_state = 3},
  [1327] = {.lex_state = 128},
  [1328] = {.lex_state = 128},
  [1329] = {.lex_state = 128},
  [1330] = {.lex_state = 128},
  [1331] = {.lex_state = 128},
  [1332] = {.lex_state = 388, .external_lex_state = 25},
  [1333] = {.lex_state = 128, .external_lex_state = 2},
  [1334] = {.lex_state = 400, .external_lex_state = 25},
  [1335] = {.lex_state = 547, .external_lex_state = 25},
  [1336] = {.lex_state = 192, .external_lex_state = 2},
  [1337] = {.lex_state = 388, .external_lex_state = 25},
  [1338] = {.lex_state = 388, .external_lex_state = 25},
  [1339] = {.lex_state = 235, .external_lex_state = 19},
  [1340] = {.lex_state = 235},
  [1341] = {.lex_state = 409, .external_lex_state = 2},
  [1342] = {.lex_state = 414, .external_lex_state = 12},
  [1343] = {.lex_state = 128},
  [1344] = {.lex_state = 388, .external_lex_state = 25},
  [1345] = {.lex_state = 192, .external_lex_state = 2},
  [1346] = {.lex_state = 192, .external_lex_state = 2},
  [1347] = {.lex_state = 192, .external_lex_state = 2},
  [1348] = {.lex_state = 192, .external_lex_state = 2},
  [1349] = {.lex_state = 192, .external_lex_state = 2},
  [1350] = {.lex_state = 192, .external_lex_state = 2},
  [1351] = {.lex_state = 192, .external_lex_state = 2},
  [1352] = {.lex_state = 192, .external_lex_state = 2},
  [1353] = {.lex_state = 192, .external_lex_state = 2},
  [1354] = {.lex_state = 192, .external_lex_state = 2},
  [1355] = {.lex_state = 416, .external_lex_state = 28},
  [1356] = {.lex_state = 235, .external_lex_state = 13},
  [1357] = {.lex_state = 197},
  [1358] = {.lex_state = 192, .external_lex_state = 2},
  [1359] = {.lex_state = 192, .external_lex_state = 2},
  [1360] = {.lex_state = 192, .external_lex_state = 2},
  [1361] = {.lex_state = 237},
  [1362] = {.lex_state = 419, .external_lex_state = 6},
  [1363] = {.lex_state = 192, .external_lex_state = 2},
  [1364] = {.lex_state = 402, .external_lex_state = 26},
  [1365] = {.lex_state = 402, .external_lex_state = 26},
  [1366] = {.lex_state = 402, .external_lex_state = 26},
  [1367] = {.lex_state = 402, .external_lex_state = 26},
  [1368] = {.lex_state = 414, .external_lex_state = 12},
  [1369] = {.lex_state = 192, .external_lex_state = 2},
  [1370] = {.lex_state = 192, .external_lex_state = 2},
  [1371] = {.lex_state = 394, .external_lex_state = 26},
  [1372] = {.lex_state = 403, .external_lex_state = 25},
  [1373] = {.lex_state = 402, .external_lex_state = 26},
  [1374] = {.lex_state = 397, .external_lex_state = 25},
  [1375] = {.lex_state = 403, .external_lex_state = 25},
  [1376] = {.lex_state = 403, .external_lex_state = 25},
  [1377] = {.lex_state = 397, .external_lex_state = 25},
  [1378] = {.lex_state = 213},
  [1379] = {.lex_state = 403, .external_lex_state = 25},
  [1380] = {.lex_state = 403, .external_lex_state = 27},
  [1381] = {.lex_state = 156, .external_lex_state = 3},
  [1382] = {.lex_state = 235},
  [1383] = {.lex_state = 235, .external_lex_state = 13},
  [1384] = {.lex_state = 192, .external_lex_state = 29},
  [1385] = {.lex_state = 192, .external_lex_state = 2},
  [1386] = {.lex_state = 543, .external_lex_state = 27},
  [1387] = {.lex_state = 156, .external_lex_state = 3},
  [1388] = {.lex_state = 237},
  [1389] = {.lex_state = 194},
  [1390] = {.lex_state = 286, .external_lex_state = 2},
  [1391] = {.lex_state = 197},
  [1392] = {.lex_state = 128},
  [1393] = {.lex_state = 411},
  [1394] = {.lex_state = 302},
  [1395] = {.lex_state = 337},
  [1396] = {.lex_state = 337},
  [1397] = {.lex_state = 337},
  [1398] = {.lex_state = 237},
  [1399] = {.lex_state = 156, .external_lex_state = 3},
  [1400] = {.lex_state = 128},
  [1401] = {.lex_state = 128, .external_lex_state = 12},
  [1402] = {.lex_state = 414, .external_lex_state = 2},
  [1403] = {.lex_state = 549, .external_lex_state = 2},
  [1404] = {.lex_state = 192, .external_lex_state = 2},
  [1405] = {.lex_state = 156, .external_lex_state = 3},
  [1406] = {.lex_state = 197},
  [1407] = {.lex_state = 156},
  [1408] = {.lex_state = 269},
  [1409] = {.lex_state = 211, .external_lex_state = 8},
  [1410] = {.lex_state = 128, .external_lex_state = 2},
  [1411] = {.lex_state = 245, .external_lex_state = 8},
  [1412] = {.lex_state = 247, .external_lex_state = 3},
  [1413] = {.lex_state = 247, .external_lex_state = 3},
  [1414] = {.lex_state = 247, .external_lex_state = 3},
  [1415] = {.lex_state = 247, .external_lex_state = 3},
  [1416] = {.lex_state = 247, .external_lex_state = 3},
  [1417] = {.lex_state = 247, .external_lex_state = 3},
  [1418] = {.lex_state = 247, .external_lex_state = 3},
  [1419] = {.lex_state = 247, .external_lex_state = 3},
  [1420] = {.lex_state = 247, .external_lex_state = 3},
  [1421] = {.lex_state = 247, .external_lex_state = 3},
  [1422] = {.lex_state = 177, .external_lex_state = 4},
  [1423] = {.lex_state = 192, .external_lex_state = 2},
  [1424] = {.lex_state = 551, .external_lex_state = 18},
  [1425] = {.lex_state = 551, .external_lex_state = 18},
  [1426] = {.lex_state = 551, .external_lex_state = 18},
  [1427] = {.lex_state = 551, .external_lex_state = 18},
  [1428] = {.lex_state = 192, .external_lex_state = 2},
  [1429] = {.lex_state = 192, .external_lex_state = 2},
  [1430] = {.lex_state = 554, .external_lex_state = 16},
  [1431] = {.lex_state = 556, .external_lex_state = 18},
  [1432] = {.lex_state = 213},
  [1433] = {.lex_state = 559, .external_lex_state = 16},
  [1434] = {.lex_state = 562, .external_lex_state = 20},
  [1435] = {.lex_state = 247, .external_lex_state = 3},
  [1436] = {.lex_state = 247, .external_lex_state = 3},
  [1437] = {.lex_state = 247, .external_lex_state = 3},
  [1438] = {.lex_state = 247, .external_lex_state = 3},
  [1439] = {.lex_state = 177, .external_lex_state = 17},
  [1440] = {.lex_state = 327, .external_lex_state = 11},
  [1441] = {.lex_state = 356, .external_lex_state = 13},
  [1442] = {.lex_state = 327, .external_lex_state = 11},
  [1443] = {.lex_state = 327, .external_lex_state = 11},
  [1444] = {.lex_state = 416, .external_lex_state = 28},
  [1445] = {.lex_state = 227, .external_lex_state = 3},
  [1446] = {.lex_state = 235, .external_lex_state = 19},
  [1447] = {.lex_state = 235},
  [1448] = {.lex_state = 327, .external_lex_state = 11},
  [1449] = {.lex_state = 565, .external_lex_state = 14},
  [1450] = {.lex_state = 192, .external_lex_state = 15},
  [1451] = {.lex_state = 299, .external_lex_state = 3},
  [1452] = {.lex_state = 192, .external_lex_state = 15},
  [1453] = {.lex_state = 299, .external_lex_state = 3},
  [1454] = {.lex_state = 192, .external_lex_state = 15},
  [1455] = {.lex_state = 299, .external_lex_state = 3},
  [1456] = {.lex_state = 192, .external_lex_state = 15},
  [1457] = {.lex_state = 299, .external_lex_state = 3},
  [1458] = {.lex_state = 190, .external_lex_state = 4},
  [1459] = {.lex_state = 266, .external_lex_state = 15},
  [1460] = {.lex_state = 299, .external_lex_state = 3},
  [1461] = {.lex_state = 190, .external_lex_state = 4},
  [1462] = {.lex_state = 266, .external_lex_state = 15},
  [1463] = {.lex_state = 227, .external_lex_state = 3},
  [1464] = {.lex_state = 177, .external_lex_state = 4},
  [1465] = {.lex_state = 177, .external_lex_state = 4},
  [1466] = {.lex_state = 177, .external_lex_state = 4},
  [1467] = {.lex_state = 177, .external_lex_state = 4},
  [1468] = {.lex_state = 190, .external_lex_state = 4},
  [1469] = {.lex_state = 190, .external_lex_state = 4},
  [1470] = {.lex_state = 192, .external_lex_state = 2},
  [1471] = {.lex_state = 194, .external_lex_state = 6},
  [1472] = {.lex_state = 197, .external_lex_state = 7},
  [1473] = {.lex_state = 209, .external_lex_state = 2},
  [1474] = {.lex_state = 216, .external_lex_state = 10},
  [1475] = {.lex_state = 216, .external_lex_state = 9},
  [1476] = {.lex_state = 254, .external_lex_state = 11},
  [1477] = {.lex_state = 254, .external_lex_state = 11},
  [1478] = {.lex_state = 254, .external_lex_state = 11},
  [1479] = {.lex_state = 254, .external_lex_state = 11},
  [1480] = {.lex_state = 221, .external_lex_state = 2},
  [1481] = {.lex_state = 221, .external_lex_state = 2},
  [1482] = {.lex_state = 192, .external_lex_state = 2},
  [1483] = {.lex_state = 192, .external_lex_state = 2},
  [1484] = {.lex_state = 223, .external_lex_state = 9},
  [1485] = {.lex_state = 221, .external_lex_state = 12},
  [1486] = {.lex_state = 128, .external_lex_state = 12},
  [1487] = {.lex_state = 192, .external_lex_state = 2},
  [1488] = {.lex_state = 192, .external_lex_state = 2},
  [1489] = {.lex_state = 227, .external_lex_state = 3},
  [1490] = {.lex_state = 235, .external_lex_state = 13},
  [1491] = {.lex_state = 237},
  [1492] = {.lex_state = 424, .external_lex_state = 3},
  [1493] = {.lex_state = 227, .external_lex_state = 3},
  [1494] = {.lex_state = 254, .external_lex_state = 11},
  [1495] = {.lex_state = 213},
  [1496] = {.lex_state = 424, .external_lex_state = 3},
  [1497] = {.lex_state = 424, .external_lex_state = 14},
  [1498] = {.lex_state = 424, .external_lex_state = 3},
  [1499] = {.lex_state = 194, .external_lex_state = 6},
  [1500] = {.lex_state = 421, .external_lex_state = 3},
  [1501] = {.lex_state = 421, .external_lex_state = 14},
  [1502] = {.lex_state = 192, .external_lex_state = 2},
  [1503] = {.lex_state = 192, .external_lex_state = 2},
  [1504] = {.lex_state = 299, .external_lex_state = 3},
  [1505] = {.lex_state = 566, .external_lex_state = 11},
  [1506] = {.lex_state = 566, .external_lex_state = 11},
  [1507] = {.lex_state = 566, .external_lex_state = 11},
  [1508] = {.lex_state = 566, .external_lex_state = 11},
  [1509] = {.lex_state = 192, .external_lex_state = 2},
  [1510] = {.lex_state = 192, .external_lex_state = 2},
  [1511] = {.lex_state = 569, .external_lex_state = 11},
  [1512] = {.lex_state = 194},
  [1513] = {.lex_state = 286, .external_lex_state = 2},
  [1514] = {.lex_state = 436, .external_lex_state = 3},
  [1515] = {.lex_state = 572, .external_lex_state = 11},
  [1516] = {.lex_state = 213},
  [1517] = {.lex_state = 573, .external_lex_state = 3},
  [1518] = {.lex_state = 576, .external_lex_state = 14},
  [1519] = {.lex_state = 194},
  [1520] = {.lex_state = 194, .external_lex_state = 19},
  [1521] = {.lex_state = 192, .external_lex_state = 2},
  [1522] = {.lex_state = 299, .external_lex_state = 3},
  [1523] = {.lex_state = 310},
  [1524] = {.lex_state = 310, .external_lex_state = 8},
  [1525] = {.lex_state = 299, .external_lex_state = 3},
  [1526] = {.lex_state = 209},
  [1527] = {.lex_state = 424, .external_lex_state = 3},
  [1528] = {.lex_state = 192, .external_lex_state = 2},
  [1529] = {.lex_state = 346, .external_lex_state = 23},
  [1530] = {.lex_state = 346, .external_lex_state = 23},
  [1531] = {.lex_state = 350, .external_lex_state = 23},
  [1532] = {.lex_state = 350, .external_lex_state = 23},
  [1533] = {.lex_state = 299, .external_lex_state = 3},
  [1534] = {.lex_state = 299, .external_lex_state = 3},
  [1535] = {.lex_state = 299, .external_lex_state = 3},
  [1536] = {.lex_state = 299, .external_lex_state = 3},
  [1537] = {.lex_state = 128, .external_lex_state = 8},
  [1538] = {.lex_state = 128, .external_lex_state = 8},
  [1539] = {.lex_state = 247, .external_lex_state = 3},
  [1540] = {.lex_state = 247, .external_lex_state = 3},
  [1541] = {.lex_state = 128},
  [1542] = {.lex_state = 227, .external_lex_state = 3},
  [1543] = {.lex_state = 128},
  [1544] = {.lex_state = 128, .external_lex_state = 12},
  [1545] = {.lex_state = 414, .external_lex_state = 2},
  [1546] = {.lex_state = 247, .external_lex_state = 3},
  [1547] = {.lex_state = 128},
  [1548] = {.lex_state = 128},
  [1549] = {.lex_state = 128},
  [1550] = {.lex_state = 128},
  [1551] = {.lex_state = 128},
  [1552] = {.lex_state = 299, .external_lex_state = 3},
  [1553] = {.lex_state = 128, .external_lex_state = 2},
  [1554] = {.lex_state = 227, .external_lex_state = 3},
  [1555] = {.lex_state = 209, .external_lex_state = 19},
  [1556] = {.lex_state = 209},
  [1557] = {.lex_state = 421, .external_lex_state = 3},
  [1558] = {.lex_state = 299, .external_lex_state = 3},
  [1559] = {.lex_state = 192, .external_lex_state = 2},
  [1560] = {.lex_state = 299, .external_lex_state = 3},
  [1561] = {.lex_state = 299, .external_lex_state = 3},
  [1562] = {.lex_state = 235, .external_lex_state = 19},
  [1563] = {.lex_state = 235},
  [1564] = {.lex_state = 409, .external_lex_state = 2},
  [1565] = {.lex_state = 128},
  [1566] = {.lex_state = 299, .external_lex_state = 3},
  [1567] = {.lex_state = 192, .external_lex_state = 2},
  [1568] = {.lex_state = 192, .external_lex_state = 2},
  [1569] = {.lex_state = 192, .external_lex_state = 2},
  [1570] = {.lex_state = 192, .external_lex_state = 2},
  [1571] = {.lex_state = 192, .external_lex_state = 2},
  [1572] = {.lex_state = 192, .external_lex_state = 2},
  [1573] = {.lex_state = 192, .external_lex_state = 2},
  [1574] = {.lex_state = 192, .external_lex_state = 2},
  [1575] = {.lex_state = 192, .external_lex_state = 2},
  [1576] = {.lex_state = 192, .external_lex_state = 2},
  [1577] = {.lex_state = 419, .external_lex_state = 6},
  [1578] = {.lex_state = 299, .external_lex_state = 3},
  [1579] = {.lex_state = 409, .external_lex_state = 2},
  [1580] = {.lex_state = 227, .external_lex_state = 3},
  [1581] = {.lex_state = 177, .external_lex_state = 17},
  [1582] = {.lex_state = 424, .external_lex_state = 3},
  [1583] = {.lex_state = 524, .external_lex_state = 13},
  [1584] = {.lex_state = 424, .external_lex_state = 3},
  [1585] = {.lex_state = 192, .external_lex_state = 29},
  [1586] = {.lex_state = 192, .external_lex_state = 2},
  [1587] = {.lex_state = 421, .external_lex_state = 14},
  [1588] = {.lex_state = 192, .external_lex_state = 2},
  [1589] = {.lex_state = 192, .external_lex_state = 2},
  [1590] = {.lex_state = 192, .external_lex_state = 2},
  [1591] = {.lex_state = 192, .external_lex_state = 2},
  [1592] = {.lex_state = 577, .external_lex_state = 3},
  [1593] = {.lex_state = 380, .external_lex_state = 3},
  [1594] = {.lex_state = 577, .external_lex_state = 3},
  [1595] = {.lex_state = 213},
  [1596] = {.lex_state = 259, .external_lex_state = 3},
  [1597] = {.lex_state = 313},
  [1598] = {.lex_state = 247, .external_lex_state = 3},
  [1599] = {.lex_state = 262, .external_lex_state = 14},
  [1600] = {.lex_state = 436, .external_lex_state = 16},
  [1601] = {.lex_state = 579, .external_lex_state = 18},
  [1602] = {.lex_state = 192, .external_lex_state = 2},
  [1603] = {.lex_state = 192, .external_lex_state = 2},
  [1604] = {.lex_state = 192, .external_lex_state = 2},
  [1605] = {.lex_state = 237},
  [1606] = {.lex_state = 192, .external_lex_state = 2},
  [1607] = {.lex_state = 582, .external_lex_state = 26},
  [1608] = {.lex_state = 582, .external_lex_state = 26},
  [1609] = {.lex_state = 582, .external_lex_state = 26},
  [1610] = {.lex_state = 582, .external_lex_state = 26},
  [1611] = {.lex_state = 192, .external_lex_state = 2},
  [1612] = {.lex_state = 192, .external_lex_state = 2},
  [1613] = {.lex_state = 585, .external_lex_state = 26},
  [1614] = {.lex_state = 588, .external_lex_state = 25},
  [1615] = {.lex_state = 591, .external_lex_state = 26},
  [1616] = {.lex_state = 444, .external_lex_state = 25},
  [1617] = {.lex_state = 467, .external_lex_state = 25},
  [1618] = {.lex_state = 213},
  [1619] = {.lex_state = 573, .external_lex_state = 25},
  [1620] = {.lex_state = 588, .external_lex_state = 27},
  [1621] = {.lex_state = 436, .external_lex_state = 16},
  [1622] = {.lex_state = 237},
  [1623] = {.lex_state = 237},
  [1624] = {.lex_state = 237},
  [1625] = {.lex_state = 225, .external_lex_state = 7},
  [1626] = {.lex_state = 177, .external_lex_state = 4},
  [1627] = {.lex_state = 192, .external_lex_state = 2},
  [1628] = {.lex_state = 192, .external_lex_state = 2},
  [1629] = {.lex_state = 192, .external_lex_state = 2},
  [1630] = {.lex_state = 192, .external_lex_state = 2},
  [1631] = {.lex_state = 192, .external_lex_state = 2},
  [1632] = {.lex_state = 192, .external_lex_state = 2},
  [1633] = {.lex_state = 192, .external_lex_state = 2},
  [1634] = {.lex_state = 192, .external_lex_state = 2},
  [1635] = {.lex_state = 192, .external_lex_state = 2},
  [1636] = {.lex_state = 192, .external_lex_state = 2},
  [1637] = {.lex_state = 192, .external_lex_state = 2},
  [1638] = {.lex_state = 192, .external_lex_state = 2},
  [1639] = {.lex_state = 192, .external_lex_state = 2},
  [1640] = {.lex_state = 192, .external_lex_state = 2},
  [1641] = {.lex_state = 192, .external_lex_state = 2},
  [1642] = {.lex_state = 416, .external_lex_state = 28},
  [1643] = {.lex_state = 235, .external_lex_state = 13},
  [1644] = {.lex_state = 197},
  [1645] = {.lex_state = 192, .external_lex_state = 2},
  [1646] = {.lex_state = 192, .external_lex_state = 2},
  [1647] = {.lex_state = 192, .external_lex_state = 2},
  [1648] = {.lex_state = 237},
  [1649] = {.lex_state = 419, .external_lex_state = 6},
  [1650] = {.lex_state = 192, .external_lex_state = 2},
  [1651] = {.lex_state = 591, .external_lex_state = 26},
  [1652] = {.lex_state = 591, .external_lex_state = 26},
  [1653] = {.lex_state = 591, .external_lex_state = 26},
  [1654] = {.lex_state = 591, .external_lex_state = 26},
  [1655] = {.lex_state = 414, .external_lex_state = 12},
  [1656] = {.lex_state = 356, .external_lex_state = 13},
  [1657] = {.lex_state = 192, .external_lex_state = 2},
  [1658] = {.lex_state = 192, .external_lex_state = 2},
  [1659] = {.lex_state = 585, .external_lex_state = 26},
  [1660] = {.lex_state = 573, .external_lex_state = 25},
  [1661] = {.lex_state = 591, .external_lex_state = 26},
  [1662] = {.lex_state = 433, .external_lex_state = 16},
  [1663] = {.lex_state = 441, .external_lex_state = 25},
  [1664] = {.lex_state = 441, .external_lex_state = 25},
  [1665] = {.lex_state = 433, .external_lex_state = 16},
  [1666] = {.lex_state = 213},
  [1667] = {.lex_state = 573, .external_lex_state = 25},
  [1668] = {.lex_state = 573, .external_lex_state = 27},
  [1669] = {.lex_state = 192, .external_lex_state = 29},
  [1670] = {.lex_state = 192, .external_lex_state = 2},
  [1671] = {.lex_state = 444, .external_lex_state = 20},
  [1672] = {.lex_state = 190, .external_lex_state = 4},
  [1673] = {.lex_state = 156, .external_lex_state = 3},
  [1674] = {.lex_state = 156, .external_lex_state = 3},
  [1675] = {.lex_state = 177, .external_lex_state = 4},
  [1676] = {.lex_state = 266, .external_lex_state = 15},
  [1677] = {.lex_state = 156, .external_lex_state = 3},
  [1678] = {.lex_state = 266, .external_lex_state = 15},
  [1679] = {.lex_state = 177, .external_lex_state = 4},
  [1680] = {.lex_state = 266, .external_lex_state = 15},
  [1681] = {.lex_state = 156, .external_lex_state = 3},
  [1682] = {.lex_state = 156, .external_lex_state = 3},
  [1683] = {.lex_state = 177, .external_lex_state = 4},
  [1684] = {.lex_state = 266, .external_lex_state = 15},
  [1685] = {.lex_state = 156, .external_lex_state = 3},
  [1686] = {.lex_state = 266, .external_lex_state = 15},
  [1687] = {.lex_state = 177, .external_lex_state = 4},
  [1688] = {.lex_state = 266, .external_lex_state = 15},
  [1689] = {.lex_state = 436, .external_lex_state = 3},
  [1690] = {.lex_state = 192, .external_lex_state = 2},
  [1691] = {.lex_state = 192, .external_lex_state = 2},
  [1692] = {.lex_state = 192, .external_lex_state = 2},
  [1693] = {.lex_state = 237},
  [1694] = {.lex_state = 192, .external_lex_state = 2},
  [1695] = {.lex_state = 592, .external_lex_state = 11},
  [1696] = {.lex_state = 592, .external_lex_state = 11},
  [1697] = {.lex_state = 592, .external_lex_state = 11},
  [1698] = {.lex_state = 592, .external_lex_state = 11},
  [1699] = {.lex_state = 192, .external_lex_state = 2},
  [1700] = {.lex_state = 192, .external_lex_state = 2},
  [1701] = {.lex_state = 569, .external_lex_state = 11},
  [1702] = {.lex_state = 588, .external_lex_state = 3},
  [1703] = {.lex_state = 444, .external_lex_state = 3},
  [1704] = {.lex_state = 467, .external_lex_state = 3},
  [1705] = {.lex_state = 213},
  [1706] = {.lex_state = 573, .external_lex_state = 3},
  [1707] = {.lex_state = 588, .external_lex_state = 14},
  [1708] = {.lex_state = 436, .external_lex_state = 3},
  [1709] = {.lex_state = 237, .external_lex_state = 8},
  [1710] = {.lex_state = 211, .external_lex_state = 8},
  [1711] = {.lex_state = 286, .external_lex_state = 2},
  [1712] = {.lex_state = 237, .external_lex_state = 8},
  [1713] = {.lex_state = 192, .external_lex_state = 2},
  [1714] = {.lex_state = 192, .external_lex_state = 2},
  [1715] = {.lex_state = 192, .external_lex_state = 2},
  [1716] = {.lex_state = 192, .external_lex_state = 2},
  [1717] = {.lex_state = 192, .external_lex_state = 2},
  [1718] = {.lex_state = 192, .external_lex_state = 2},
  [1719] = {.lex_state = 192, .external_lex_state = 2},
  [1720] = {.lex_state = 192, .external_lex_state = 2},
  [1721] = {.lex_state = 192, .external_lex_state = 2},
  [1722] = {.lex_state = 192, .external_lex_state = 2},
  [1723] = {.lex_state = 192, .external_lex_state = 2},
  [1724] = {.lex_state = 192, .external_lex_state = 2},
  [1725] = {.lex_state = 192, .external_lex_state = 2},
  [1726] = {.lex_state = 192, .external_lex_state = 2},
  [1727] = {.lex_state = 192, .external_lex_state = 2},
  [1728] = {.lex_state = 192, .external_lex_state = 2},
  [1729] = {.lex_state = 192, .external_lex_state = 2},
  [1730] = {.lex_state = 192, .external_lex_state = 2},
  [1731] = {.lex_state = 237},
  [1732] = {.lex_state = 192, .external_lex_state = 2},
  [1733] = {.lex_state = 572, .external_lex_state = 11},
  [1734] = {.lex_state = 572, .external_lex_state = 11},
  [1735] = {.lex_state = 572, .external_lex_state = 11},
  [1736] = {.lex_state = 572, .external_lex_state = 11},
  [1737] = {.lex_state = 192, .external_lex_state = 2},
  [1738] = {.lex_state = 192, .external_lex_state = 2},
  [1739] = {.lex_state = 569, .external_lex_state = 11},
  [1740] = {.lex_state = 573, .external_lex_state = 3},
  [1741] = {.lex_state = 572, .external_lex_state = 11},
  [1742] = {.lex_state = 441, .external_lex_state = 3},
  [1743] = {.lex_state = 441, .external_lex_state = 3},
  [1744] = {.lex_state = 213},
  [1745] = {.lex_state = 573, .external_lex_state = 3},
  [1746] = {.lex_state = 573, .external_lex_state = 14},
  [1747] = {.lex_state = 192, .external_lex_state = 29},
  [1748] = {.lex_state = 192, .external_lex_state = 2},
  [1749] = {.lex_state = 444, .external_lex_state = 14},
  [1750] = {.lex_state = 265, .external_lex_state = 20},
  [1751] = {.lex_state = 288, .external_lex_state = 16},
  [1752] = {.lex_state = 288, .external_lex_state = 16},
  [1753] = {.lex_state = 288, .external_lex_state = 16},
  [1754] = {.lex_state = 288, .external_lex_state = 16},
  [1755] = {.lex_state = 192, .external_lex_state = 15},
  [1756] = {.lex_state = 266, .external_lex_state = 15},
  [1757] = {.lex_state = 288, .external_lex_state = 16},
  [1758] = {.lex_state = 177, .external_lex_state = 4},
  [1759] = {.lex_state = 266, .external_lex_state = 15},
  [1760] = {.lex_state = 288, .external_lex_state = 16},
  [1761] = {.lex_state = 192, .external_lex_state = 15},
  [1762] = {.lex_state = 266, .external_lex_state = 15},
  [1763] = {.lex_state = 288, .external_lex_state = 16},
  [1764] = {.lex_state = 177, .external_lex_state = 4},
  [1765] = {.lex_state = 266, .external_lex_state = 15},
  [1766] = {.lex_state = 194},
  [1767] = {.lex_state = 453},
  [1768] = {.lex_state = 177, .external_lex_state = 17},
  [1769] = {.lex_state = 436, .external_lex_state = 25},
  [1770] = {.lex_state = 288, .external_lex_state = 16},
  [1771] = {.lex_state = 194},
  [1772] = {.lex_state = 302, .external_lex_state = 16},
  [1773] = {.lex_state = 225, .external_lex_state = 7},
  [1774] = {.lex_state = 128, .external_lex_state = 2},
  [1775] = {.lex_state = 288, .external_lex_state = 16},
  [1776] = {.lex_state = 436, .external_lex_state = 25},
  [1777] = {.lex_state = 595, .external_lex_state = 26},
  [1778] = {.lex_state = 192, .external_lex_state = 2},
  [1779] = {.lex_state = 192, .external_lex_state = 2},
  [1780] = {.lex_state = 192, .external_lex_state = 2},
  [1781] = {.lex_state = 237},
  [1782] = {.lex_state = 192, .external_lex_state = 2},
  [1783] = {.lex_state = 582, .external_lex_state = 26},
  [1784] = {.lex_state = 582, .external_lex_state = 26},
  [1785] = {.lex_state = 582, .external_lex_state = 26},
  [1786] = {.lex_state = 582, .external_lex_state = 26},
  [1787] = {.lex_state = 192, .external_lex_state = 2},
  [1788] = {.lex_state = 192, .external_lex_state = 2},
  [1789] = {.lex_state = 585, .external_lex_state = 26},
  [1790] = {.lex_state = 588, .external_lex_state = 25},
  [1791] = {.lex_state = 591, .external_lex_state = 26},
  [1792] = {.lex_state = 467, .external_lex_state = 25},
  [1793] = {.lex_state = 467, .external_lex_state = 25},
  [1794] = {.lex_state = 213},
  [1795] = {.lex_state = 573, .external_lex_state = 25},
  [1796] = {.lex_state = 588, .external_lex_state = 27},
  [1797] = {.lex_state = 436, .external_lex_state = 25},
  [1798] = {.lex_state = 192, .external_lex_state = 2},
  [1799] = {.lex_state = 192, .external_lex_state = 2},
  [1800] = {.lex_state = 192, .external_lex_state = 2},
  [1801] = {.lex_state = 192, .external_lex_state = 2},
  [1802] = {.lex_state = 192, .external_lex_state = 2},
  [1803] = {.lex_state = 192, .external_lex_state = 2},
  [1804] = {.lex_state = 192, .external_lex_state = 2},
  [1805] = {.lex_state = 192, .external_lex_state = 2},
  [1806] = {.lex_state = 192, .external_lex_state = 2},
  [1807] = {.lex_state = 192, .external_lex_state = 2},
  [1808] = {.lex_state = 416, .external_lex_state = 28},
  [1809] = {.lex_state = 235, .external_lex_state = 13},
  [1810] = {.lex_state = 197},
  [1811] = {.lex_state = 192, .external_lex_state = 2},
  [1812] = {.lex_state = 192, .external_lex_state = 2},
  [1813] = {.lex_state = 192, .external_lex_state = 2},
  [1814] = {.lex_state = 237},
  [1815] = {.lex_state = 419, .external_lex_state = 6},
  [1816] = {.lex_state = 192, .external_lex_state = 2},
  [1817] = {.lex_state = 591, .external_lex_state = 26},
  [1818] = {.lex_state = 591, .external_lex_state = 26},
  [1819] = {.lex_state = 591, .external_lex_state = 26},
  [1820] = {.lex_state = 591, .external_lex_state = 26},
  [1821] = {.lex_state = 414, .external_lex_state = 12},
  [1822] = {.lex_state = 192, .external_lex_state = 2},
  [1823] = {.lex_state = 192, .external_lex_state = 2},
  [1824] = {.lex_state = 585, .external_lex_state = 26},
  [1825] = {.lex_state = 573, .external_lex_state = 25},
  [1826] = {.lex_state = 591, .external_lex_state = 26},
  [1827] = {.lex_state = 461, .external_lex_state = 25},
  [1828] = {.lex_state = 441, .external_lex_state = 25},
  [1829] = {.lex_state = 441, .external_lex_state = 25},
  [1830] = {.lex_state = 461, .external_lex_state = 25},
  [1831] = {.lex_state = 213},
  [1832] = {.lex_state = 573, .external_lex_state = 25},
  [1833] = {.lex_state = 573, .external_lex_state = 27},
  [1834] = {.lex_state = 192, .external_lex_state = 29},
  [1835] = {.lex_state = 192, .external_lex_state = 2},
  [1836] = {.lex_state = 467, .external_lex_state = 27},
  [1837] = {.lex_state = 247, .external_lex_state = 3},
  [1838] = {.lex_state = 128, .external_lex_state = 8},
  [1839] = {.lex_state = 128, .external_lex_state = 2},
  [1840] = {.lex_state = 288, .external_lex_state = 16},
  [1841] = {.lex_state = 128, .external_lex_state = 2},
  [1842] = {.lex_state = 361, .external_lex_state = 25},
  [1843] = {.lex_state = 361, .external_lex_state = 27},
  [1844] = {.lex_state = 361, .external_lex_state = 25},
  [1845] = {.lex_state = 361, .external_lex_state = 25},
  [1846] = {.lex_state = 192, .external_lex_state = 2},
  [1847] = {.lex_state = 361, .external_lex_state = 25},
  [1848] = {.lex_state = 361, .external_lex_state = 25},
  [1849] = {.lex_state = 361, .external_lex_state = 25},
  [1850] = {.lex_state = 388, .external_lex_state = 25},
  [1851] = {.lex_state = 209, .external_lex_state = 19},
  [1852] = {.lex_state = 209},
  [1853] = {.lex_state = 361, .external_lex_state = 25},
  [1854] = {.lex_state = 388, .external_lex_state = 25},
  [1855] = {.lex_state = 192, .external_lex_state = 2},
  [1856] = {.lex_state = 192, .external_lex_state = 2},
  [1857] = {.lex_state = 192, .external_lex_state = 2},
  [1858] = {.lex_state = 192, .external_lex_state = 2},
  [1859] = {.lex_state = 192, .external_lex_state = 2},
  [1860] = {.lex_state = 192, .external_lex_state = 2},
  [1861] = {.lex_state = 192, .external_lex_state = 2},
  [1862] = {.lex_state = 192, .external_lex_state = 2},
  [1863] = {.lex_state = 192, .external_lex_state = 2},
  [1864] = {.lex_state = 192, .external_lex_state = 2},
  [1865] = {.lex_state = 192, .external_lex_state = 2},
  [1866] = {.lex_state = 177, .external_lex_state = 17},
  [1867] = {.lex_state = 305, .external_lex_state = 25},
  [1868] = {.lex_state = 524, .external_lex_state = 13},
  [1869] = {.lex_state = 361, .external_lex_state = 25},
  [1870] = {.lex_state = 192, .external_lex_state = 29},
  [1871] = {.lex_state = 192, .external_lex_state = 2},
  [1872] = {.lex_state = 361, .external_lex_state = 27},
  [1873] = {.lex_state = 128, .external_lex_state = 12},
  [1874] = {.lex_state = 128, .external_lex_state = 2},
  [1875] = {.lex_state = 128, .external_lex_state = 2},
  [1876] = {.lex_state = 128, .external_lex_state = 2},
  [1877] = {.lex_state = 128, .external_lex_state = 8},
  [1878] = {.lex_state = 128},
  [1879] = {.lex_state = 128},
  [1880] = {.lex_state = 128},
  [1881] = {.lex_state = 288, .external_lex_state = 16},
  [1882] = {.lex_state = 128},
  [1883] = {.lex_state = 128},
  [1884] = {.lex_state = 128},
  [1885] = {.lex_state = 288, .external_lex_state = 16},
  [1886] = {.lex_state = 436, .external_lex_state = 25},
  [1887] = {.lex_state = 288, .external_lex_state = 16},
  [1888] = {.lex_state = 235},
  [1889] = {.lex_state = 288, .external_lex_state = 16},
  [1890] = {.lex_state = 194},
  [1891] = {.lex_state = 286, .external_lex_state = 2},
  [1892] = {.lex_state = 288, .external_lex_state = 16},
  [1893] = {.lex_state = 128},
  [1894] = {.lex_state = 128, .external_lex_state = 12},
  [1895] = {.lex_state = 414, .external_lex_state = 2},
  [1896] = {.lex_state = 288, .external_lex_state = 16},
  [1897] = {.lex_state = 302, .external_lex_state = 16},
  [1898] = {.lex_state = 302, .external_lex_state = 16},
  [1899] = {.lex_state = 302, .external_lex_state = 16},
  [1900] = {.lex_state = 302, .external_lex_state = 16},
  [1901] = {.lex_state = 302, .external_lex_state = 16},
  [1902] = {.lex_state = 554, .external_lex_state = 16},
  [1903] = {.lex_state = 302, .external_lex_state = 16},
  [1904] = {.lex_state = 302, .external_lex_state = 16},
  [1905] = {.lex_state = 302, .external_lex_state = 16},
  [1906] = {.lex_state = 302, .external_lex_state = 16},
  [1907] = {.lex_state = 304, .external_lex_state = 18},
  [1908] = {.lex_state = 356, .external_lex_state = 13},
  [1909] = {.lex_state = 304, .external_lex_state = 18},
  [1910] = {.lex_state = 304, .external_lex_state = 18},
  [1911] = {.lex_state = 416, .external_lex_state = 28},
  [1912] = {.lex_state = 299, .external_lex_state = 16},
  [1913] = {.lex_state = 235, .external_lex_state = 19},
  [1914] = {.lex_state = 235},
  [1915] = {.lex_state = 304, .external_lex_state = 18},
  [1916] = {.lex_state = 598, .external_lex_state = 27},
  [1917] = {.lex_state = 192, .external_lex_state = 15},
  [1918] = {.lex_state = 397, .external_lex_state = 25},
  [1919] = {.lex_state = 192, .external_lex_state = 15},
  [1920] = {.lex_state = 397, .external_lex_state = 25},
  [1921] = {.lex_state = 192, .external_lex_state = 15},
  [1922] = {.lex_state = 397, .external_lex_state = 25},
  [1923] = {.lex_state = 192, .external_lex_state = 15},
  [1924] = {.lex_state = 397, .external_lex_state = 25},
  [1925] = {.lex_state = 190, .external_lex_state = 4},
  [1926] = {.lex_state = 266, .external_lex_state = 15},
  [1927] = {.lex_state = 397, .external_lex_state = 25},
  [1928] = {.lex_state = 190, .external_lex_state = 4},
  [1929] = {.lex_state = 266, .external_lex_state = 15},
  [1930] = {.lex_state = 194, .external_lex_state = 6},
  [1931] = {.lex_state = 421, .external_lex_state = 25},
  [1932] = {.lex_state = 421, .external_lex_state = 27},
  [1933] = {.lex_state = 421, .external_lex_state = 25},
  [1934] = {.lex_state = 421, .external_lex_state = 25},
  [1935] = {.lex_state = 192, .external_lex_state = 2},
  [1936] = {.lex_state = 421, .external_lex_state = 25},
  [1937] = {.lex_state = 194},
  [1938] = {.lex_state = 286, .external_lex_state = 2},
  [1939] = {.lex_state = 194},
  [1940] = {.lex_state = 194, .external_lex_state = 19},
  [1941] = {.lex_state = 192, .external_lex_state = 2},
  [1942] = {.lex_state = 397, .external_lex_state = 25},
  [1943] = {.lex_state = 310},
  [1944] = {.lex_state = 310, .external_lex_state = 8},
  [1945] = {.lex_state = 397, .external_lex_state = 25},
  [1946] = {.lex_state = 209},
  [1947] = {.lex_state = 421, .external_lex_state = 25},
  [1948] = {.lex_state = 192, .external_lex_state = 2},
  [1949] = {.lex_state = 346, .external_lex_state = 23},
  [1950] = {.lex_state = 346, .external_lex_state = 23},
  [1951] = {.lex_state = 350, .external_lex_state = 23},
  [1952] = {.lex_state = 350, .external_lex_state = 23},
  [1953] = {.lex_state = 397, .external_lex_state = 25},
  [1954] = {.lex_state = 397, .external_lex_state = 25},
  [1955] = {.lex_state = 397, .external_lex_state = 25},
  [1956] = {.lex_state = 397, .external_lex_state = 25},
  [1957] = {.lex_state = 128, .external_lex_state = 8},
  [1958] = {.lex_state = 128, .external_lex_state = 8},
  [1959] = {.lex_state = 247, .external_lex_state = 3},
  [1960] = {.lex_state = 247, .external_lex_state = 3},
  [1961] = {.lex_state = 128},
  [1962] = {.lex_state = 299, .external_lex_state = 16},
  [1963] = {.lex_state = 128},
  [1964] = {.lex_state = 128, .external_lex_state = 12},
  [1965] = {.lex_state = 414, .external_lex_state = 2},
  [1966] = {.lex_state = 247, .external_lex_state = 3},
  [1967] = {.lex_state = 128},
  [1968] = {.lex_state = 128},
  [1969] = {.lex_state = 128},
  [1970] = {.lex_state = 128},
  [1971] = {.lex_state = 128},
  [1972] = {.lex_state = 397, .external_lex_state = 25},
  [1973] = {.lex_state = 128, .external_lex_state = 2},
  [1974] = {.lex_state = 397, .external_lex_state = 25},
  [1975] = {.lex_state = 209, .external_lex_state = 19},
  [1976] = {.lex_state = 209},
  [1977] = {.lex_state = 421, .external_lex_state = 25},
  [1978] = {.lex_state = 397, .external_lex_state = 25},
  [1979] = {.lex_state = 192, .external_lex_state = 2},
  [1980] = {.lex_state = 397, .external_lex_state = 25},
  [1981] = {.lex_state = 397, .external_lex_state = 25},
  [1982] = {.lex_state = 235, .external_lex_state = 19},
  [1983] = {.lex_state = 235},
  [1984] = {.lex_state = 409, .external_lex_state = 2},
  [1985] = {.lex_state = 128},
  [1986] = {.lex_state = 397, .external_lex_state = 25},
  [1987] = {.lex_state = 192, .external_lex_state = 2},
  [1988] = {.lex_state = 192, .external_lex_state = 2},
  [1989] = {.lex_state = 192, .external_lex_state = 2},
  [1990] = {.lex_state = 192, .external_lex_state = 2},
  [1991] = {.lex_state = 192, .external_lex_state = 2},
  [1992] = {.lex_state = 192, .external_lex_state = 2},
  [1993] = {.lex_state = 192, .external_lex_state = 2},
  [1994] = {.lex_state = 192, .external_lex_state = 2},
  [1995] = {.lex_state = 192, .external_lex_state = 2},
  [1996] = {.lex_state = 192, .external_lex_state = 2},
  [1997] = {.lex_state = 419, .external_lex_state = 6},
  [1998] = {.lex_state = 397, .external_lex_state = 25},
  [1999] = {.lex_state = 409, .external_lex_state = 2},
  [2000] = {.lex_state = 299, .external_lex_state = 16},
  [2001] = {.lex_state = 177, .external_lex_state = 17},
  [2002] = {.lex_state = 421, .external_lex_state = 25},
  [2003] = {.lex_state = 524, .external_lex_state = 13},
  [2004] = {.lex_state = 421, .external_lex_state = 25},
  [2005] = {.lex_state = 192, .external_lex_state = 29},
  [2006] = {.lex_state = 192, .external_lex_state = 2},
  [2007] = {.lex_state = 421, .external_lex_state = 27},
  [2008] = {.lex_state = 192, .external_lex_state = 2},
  [2009] = {.lex_state = 192, .external_lex_state = 2},
  [2010] = {.lex_state = 470, .external_lex_state = 18},
  [2011] = {.lex_state = 470, .external_lex_state = 18},
  [2012] = {.lex_state = 470, .external_lex_state = 18},
  [2013] = {.lex_state = 470, .external_lex_state = 18},
  [2014] = {.lex_state = 192, .external_lex_state = 2},
  [2015] = {.lex_state = 192, .external_lex_state = 2},
  [2016] = {.lex_state = 302, .external_lex_state = 16},
  [2017] = {.lex_state = 473, .external_lex_state = 16},
  [2018] = {.lex_state = 302, .external_lex_state = 16},
  [2019] = {.lex_state = 213},
  [2020] = {.lex_state = 299, .external_lex_state = 16},
  [2021] = {.lex_state = 156, .external_lex_state = 20},
  [2022] = {.lex_state = 302, .external_lex_state = 16},
  [2023] = {.lex_state = 455, .external_lex_state = 20},
  [2024] = {.lex_state = 156, .external_lex_state = 3},
  [2025] = {.lex_state = 177, .external_lex_state = 17},
  [2026] = {.lex_state = 194, .external_lex_state = 6},
  [2027] = {.lex_state = 194, .external_lex_state = 19},
  [2028] = {.lex_state = 211, .external_lex_state = 8},
  [2029] = {.lex_state = 308, .external_lex_state = 8},
  [2030] = {.lex_state = 302, .external_lex_state = 16},
  [2031] = {.lex_state = 192, .external_lex_state = 2},
  [2032] = {.lex_state = 192, .external_lex_state = 2},
  [2033] = {.lex_state = 192, .external_lex_state = 2},
  [2034] = {.lex_state = 237},
  [2035] = {.lex_state = 192, .external_lex_state = 2},
  [2036] = {.lex_state = 192, .external_lex_state = 2},
  [2037] = {.lex_state = 192, .external_lex_state = 2},
  [2038] = {.lex_state = 520, .external_lex_state = 26},
  [2039] = {.lex_state = 493, .external_lex_state = 25},
  [2040] = {.lex_state = 324, .external_lex_state = 25},
  [2041] = {.lex_state = 493, .external_lex_state = 25},
  [2042] = {.lex_state = 213},
  [2043] = {.lex_state = 497, .external_lex_state = 25},
  [2044] = {.lex_state = 493, .external_lex_state = 27},
  [2045] = {.lex_state = 302, .external_lex_state = 16},
  [2046] = {.lex_state = 192, .external_lex_state = 2},
  [2047] = {.lex_state = 192, .external_lex_state = 2},
  [2048] = {.lex_state = 310},
  [2049] = {.lex_state = 192, .external_lex_state = 2},
  [2050] = {.lex_state = 192, .external_lex_state = 2},
  [2051] = {.lex_state = 192, .external_lex_state = 2},
  [2052] = {.lex_state = 192, .external_lex_state = 2},
  [2053] = {.lex_state = 192, .external_lex_state = 2},
  [2054] = {.lex_state = 192, .external_lex_state = 2},
  [2055] = {.lex_state = 192, .external_lex_state = 2},
  [2056] = {.lex_state = 192, .external_lex_state = 2},
  [2057] = {.lex_state = 192, .external_lex_state = 2},
  [2058] = {.lex_state = 192, .external_lex_state = 2},
  [2059] = {.lex_state = 192, .external_lex_state = 2},
  [2060] = {.lex_state = 237},
  [2061] = {.lex_state = 192, .external_lex_state = 2},
  [2062] = {.lex_state = 523, .external_lex_state = 26},
  [2063] = {.lex_state = 523, .external_lex_state = 26},
  [2064] = {.lex_state = 523, .external_lex_state = 26},
  [2065] = {.lex_state = 523, .external_lex_state = 26},
  [2066] = {.lex_state = 192, .external_lex_state = 2},
  [2067] = {.lex_state = 192, .external_lex_state = 2},
  [2068] = {.lex_state = 520, .external_lex_state = 26},
  [2069] = {.lex_state = 497, .external_lex_state = 25},
  [2070] = {.lex_state = 523, .external_lex_state = 26},
  [2071] = {.lex_state = 321, .external_lex_state = 25},
  [2072] = {.lex_state = 321, .external_lex_state = 25},
  [2073] = {.lex_state = 213},
  [2074] = {.lex_state = 497, .external_lex_state = 25},
  [2075] = {.lex_state = 497, .external_lex_state = 27},
  [2076] = {.lex_state = 192, .external_lex_state = 29},
  [2077] = {.lex_state = 192, .external_lex_state = 2},
  [2078] = {.lex_state = 324, .external_lex_state = 20},
  [2079] = {.lex_state = 156, .external_lex_state = 3},
  [2080] = {.lex_state = 128, .external_lex_state = 12},
  [2081] = {.lex_state = 302},
  [2082] = {.lex_state = 254, .external_lex_state = 8},
  [2083] = {.lex_state = 254, .external_lex_state = 8},
  [2084] = {.lex_state = 254, .external_lex_state = 8},
  [2085] = {.lex_state = 237},
  [2086] = {.lex_state = 599, .external_lex_state = 12},
  [2087] = {.lex_state = 192, .external_lex_state = 2},
  [2088] = {.lex_state = 156, .external_lex_state = 3},
  [2089] = {.lex_state = 197},
  [2090] = {.lex_state = 128, .external_lex_state = 2},
  [2091] = {.lex_state = 192, .external_lex_state = 2},
  [2092] = {.lex_state = 192, .external_lex_state = 2},
  [2093] = {.lex_state = 192, .external_lex_state = 2},
  [2094] = {.lex_state = 237},
  [2095] = {.lex_state = 192, .external_lex_state = 2},
  [2096] = {.lex_state = 601, .external_lex_state = 26},
  [2097] = {.lex_state = 601, .external_lex_state = 26},
  [2098] = {.lex_state = 601, .external_lex_state = 26},
  [2099] = {.lex_state = 601, .external_lex_state = 26},
  [2100] = {.lex_state = 192, .external_lex_state = 2},
  [2101] = {.lex_state = 192, .external_lex_state = 2},
  [2102] = {.lex_state = 520, .external_lex_state = 26},
  [2103] = {.lex_state = 604, .external_lex_state = 25},
  [2104] = {.lex_state = 337, .external_lex_state = 19},
  [2105] = {.lex_state = 337, .external_lex_state = 19},
  [2106] = {.lex_state = 213},
  [2107] = {.lex_state = 497, .external_lex_state = 25},
  [2108] = {.lex_state = 604, .external_lex_state = 27},
  [2109] = {.lex_state = 192, .external_lex_state = 2},
  [2110] = {.lex_state = 607, .external_lex_state = 11},
  [2111] = {.lex_state = 607, .external_lex_state = 11},
  [2112] = {.lex_state = 607, .external_lex_state = 11},
  [2113] = {.lex_state = 607, .external_lex_state = 11},
  [2114] = {.lex_state = 192, .external_lex_state = 2},
  [2115] = {.lex_state = 192, .external_lex_state = 2},
  [2116] = {.lex_state = 493, .external_lex_state = 3},
  [2117] = {.lex_state = 213},
  [2118] = {.lex_state = 321, .external_lex_state = 3},
  [2119] = {.lex_state = 610, .external_lex_state = 14},
  [2120] = {.lex_state = 493, .external_lex_state = 3},
  [2121] = {.lex_state = 493, .external_lex_state = 3},
  [2122] = {.lex_state = 613, .external_lex_state = 14},
  [2123] = {.lex_state = 192, .external_lex_state = 2},
  [2124] = {.lex_state = 493, .external_lex_state = 3},
  [2125] = {.lex_state = 192, .external_lex_state = 2},
  [2126] = {.lex_state = 192, .external_lex_state = 2},
  [2127] = {.lex_state = 237},
  [2128] = {.lex_state = 192, .external_lex_state = 2},
  [2129] = {.lex_state = 490, .external_lex_state = 11},
  [2130] = {.lex_state = 493, .external_lex_state = 3},
  [2131] = {.lex_state = 493, .external_lex_state = 3},
  [2132] = {.lex_state = 493, .external_lex_state = 3},
  [2133] = {.lex_state = 493, .external_lex_state = 14},
  [2134] = {.lex_state = 493, .external_lex_state = 3},
  [2135] = {.lex_state = 192, .external_lex_state = 2},
  [2136] = {.lex_state = 192, .external_lex_state = 2},
  [2137] = {.lex_state = 192, .external_lex_state = 2},
  [2138] = {.lex_state = 192, .external_lex_state = 2},
  [2139] = {.lex_state = 192, .external_lex_state = 2},
  [2140] = {.lex_state = 192, .external_lex_state = 2},
  [2141] = {.lex_state = 192, .external_lex_state = 2},
  [2142] = {.lex_state = 192, .external_lex_state = 2},
  [2143] = {.lex_state = 192, .external_lex_state = 2},
  [2144] = {.lex_state = 192, .external_lex_state = 2},
  [2145] = {.lex_state = 192, .external_lex_state = 2},
  [2146] = {.lex_state = 192, .external_lex_state = 2},
  [2147] = {.lex_state = 192, .external_lex_state = 2},
  [2148] = {.lex_state = 237},
  [2149] = {.lex_state = 192, .external_lex_state = 2},
  [2150] = {.lex_state = 490, .external_lex_state = 11},
  [2151] = {.lex_state = 497, .external_lex_state = 3},
  [2152] = {.lex_state = 497, .external_lex_state = 3},
  [2153] = {.lex_state = 497, .external_lex_state = 3},
  [2154] = {.lex_state = 497, .external_lex_state = 14},
  [2155] = {.lex_state = 324, .external_lex_state = 3},
  [2156] = {.lex_state = 524, .external_lex_state = 13},
  [2157] = {.lex_state = 493, .external_lex_state = 3},
  [2158] = {.lex_state = 192, .external_lex_state = 29},
  [2159] = {.lex_state = 192, .external_lex_state = 2},
  [2160] = {.lex_state = 613, .external_lex_state = 14},
  [2161] = {.lex_state = 302, .external_lex_state = 8},
  [2162] = {.lex_state = 209, .external_lex_state = 2},
  [2163] = {.lex_state = 209, .external_lex_state = 8},
  [2164] = {.lex_state = 302, .external_lex_state = 3},
  [2165] = {.lex_state = 302, .external_lex_state = 3},
  [2166] = {.lex_state = 302, .external_lex_state = 3},
  [2167] = {.lex_state = 302, .external_lex_state = 3},
  [2168] = {.lex_state = 302, .external_lex_state = 3},
  [2169] = {.lex_state = 302, .external_lex_state = 3},
  [2170] = {.lex_state = 302, .external_lex_state = 3},
  [2171] = {.lex_state = 302, .external_lex_state = 3},
  [2172] = {.lex_state = 302, .external_lex_state = 3},
  [2173] = {.lex_state = 302, .external_lex_state = 3},
  [2174] = {.lex_state = 554, .external_lex_state = 16},
  [2175] = {.lex_state = 302, .external_lex_state = 3},
  [2176] = {.lex_state = 302, .external_lex_state = 3},
  [2177] = {.lex_state = 302, .external_lex_state = 3},
  [2178] = {.lex_state = 302, .external_lex_state = 3},
  [2179] = {.lex_state = 192, .external_lex_state = 2},
  [2180] = {.lex_state = 318, .external_lex_state = 11},
  [2181] = {.lex_state = 318, .external_lex_state = 11},
  [2182] = {.lex_state = 318, .external_lex_state = 11},
  [2183] = {.lex_state = 318, .external_lex_state = 11},
  [2184] = {.lex_state = 192, .external_lex_state = 2},
  [2185] = {.lex_state = 192, .external_lex_state = 2},
  [2186] = {.lex_state = 321, .external_lex_state = 3},
  [2187] = {.lex_state = 318, .external_lex_state = 11},
  [2188] = {.lex_state = 213},
  [2189] = {.lex_state = 321, .external_lex_state = 3},
  [2190] = {.lex_state = 321, .external_lex_state = 14},
  [2191] = {.lex_state = 321, .external_lex_state = 3},
  [2192] = {.lex_state = 497, .external_lex_state = 3},
  [2193] = {.lex_state = 614, .external_lex_state = 14},
  [2194] = {.lex_state = 192, .external_lex_state = 2},
  [2195] = {.lex_state = 321, .external_lex_state = 3},
  [2196] = {.lex_state = 497, .external_lex_state = 3},
  [2197] = {.lex_state = 192, .external_lex_state = 2},
  [2198] = {.lex_state = 192, .external_lex_state = 2},
  [2199] = {.lex_state = 192, .external_lex_state = 2},
  [2200] = {.lex_state = 192, .external_lex_state = 2},
  [2201] = {.lex_state = 192, .external_lex_state = 2},
  [2202] = {.lex_state = 192, .external_lex_state = 2},
  [2203] = {.lex_state = 192, .external_lex_state = 2},
  [2204] = {.lex_state = 192, .external_lex_state = 2},
  [2205] = {.lex_state = 192, .external_lex_state = 2},
  [2206] = {.lex_state = 192, .external_lex_state = 2},
  [2207] = {.lex_state = 192, .external_lex_state = 2},
  [2208] = {.lex_state = 321, .external_lex_state = 3},
  [2209] = {.lex_state = 524, .external_lex_state = 13},
  [2210] = {.lex_state = 321, .external_lex_state = 3},
  [2211] = {.lex_state = 192, .external_lex_state = 29},
  [2212] = {.lex_state = 192, .external_lex_state = 2},
  [2213] = {.lex_state = 614, .external_lex_state = 14},
  [2214] = {.lex_state = 192, .external_lex_state = 2},
  [2215] = {.lex_state = 192, .external_lex_state = 2},
  [2216] = {.lex_state = 192, .external_lex_state = 2},
  [2217] = {.lex_state = 192, .external_lex_state = 2},
  [2218] = {.lex_state = 302, .external_lex_state = 3},
  [2219] = {.lex_state = 302, .external_lex_state = 3},
  [2220] = {.lex_state = 213},
  [2221] = {.lex_state = 321, .external_lex_state = 3},
  [2222] = {.lex_state = 302, .external_lex_state = 3},
  [2223] = {.lex_state = 324, .external_lex_state = 14},
  [2224] = {.lex_state = 343, .external_lex_state = 22},
  [2225] = {.lex_state = 330},
  [2226] = {.lex_state = 330},
  [2227] = {.lex_state = 330},
  [2228] = {.lex_state = 330},
  [2229] = {.lex_state = 192, .external_lex_state = 15},
  [2230] = {.lex_state = 266, .external_lex_state = 15},
  [2231] = {.lex_state = 330},
  [2232] = {.lex_state = 177, .external_lex_state = 4},
  [2233] = {.lex_state = 266, .external_lex_state = 15},
  [2234] = {.lex_state = 330},
  [2235] = {.lex_state = 192, .external_lex_state = 15},
  [2236] = {.lex_state = 266, .external_lex_state = 15},
  [2237] = {.lex_state = 330},
  [2238] = {.lex_state = 177, .external_lex_state = 4},
  [2239] = {.lex_state = 266, .external_lex_state = 15},
  [2240] = {.lex_state = 330},
  [2241] = {.lex_state = 194},
  [2242] = {.lex_state = 302, .external_lex_state = 16},
  [2243] = {.lex_state = 225, .external_lex_state = 7},
  [2244] = {.lex_state = 128, .external_lex_state = 2},
  [2245] = {.lex_state = 330},
  [2246] = {.lex_state = 247, .external_lex_state = 3},
  [2247] = {.lex_state = 128, .external_lex_state = 8},
  [2248] = {.lex_state = 128, .external_lex_state = 2},
  [2249] = {.lex_state = 330},
  [2250] = {.lex_state = 128, .external_lex_state = 2},
  [2251] = {.lex_state = 192, .external_lex_state = 2},
  [2252] = {.lex_state = 615, .external_lex_state = 26},
  [2253] = {.lex_state = 615, .external_lex_state = 26},
  [2254] = {.lex_state = 615, .external_lex_state = 26},
  [2255] = {.lex_state = 615, .external_lex_state = 26},
  [2256] = {.lex_state = 192, .external_lex_state = 2},
  [2257] = {.lex_state = 192, .external_lex_state = 2},
  [2258] = {.lex_state = 361, .external_lex_state = 25},
  [2259] = {.lex_state = 618, .external_lex_state = 26},
  [2260] = {.lex_state = 213},
  [2261] = {.lex_state = 259, .external_lex_state = 25},
  [2262] = {.lex_state = 365, .external_lex_state = 27},
  [2263] = {.lex_state = 361, .external_lex_state = 25},
  [2264] = {.lex_state = 192, .external_lex_state = 2},
  [2265] = {.lex_state = 361, .external_lex_state = 25},
  [2266] = {.lex_state = 337, .external_lex_state = 19},
  [2267] = {.lex_state = 209, .external_lex_state = 19},
  [2268] = {.lex_state = 209},
  [2269] = {.lex_state = 192, .external_lex_state = 2},
  [2270] = {.lex_state = 177, .external_lex_state = 17},
  [2271] = {.lex_state = 334, .external_lex_state = 19},
  [2272] = {.lex_state = 524, .external_lex_state = 13},
  [2273] = {.lex_state = 340, .external_lex_state = 19},
  [2274] = {.lex_state = 128, .external_lex_state = 12},
  [2275] = {.lex_state = 128, .external_lex_state = 2},
  [2276] = {.lex_state = 128, .external_lex_state = 2},
  [2277] = {.lex_state = 128, .external_lex_state = 2},
  [2278] = {.lex_state = 128, .external_lex_state = 8},
  [2279] = {.lex_state = 128},
  [2280] = {.lex_state = 128},
  [2281] = {.lex_state = 128},
  [2282] = {.lex_state = 330},
  [2283] = {.lex_state = 128},
  [2284] = {.lex_state = 128},
  [2285] = {.lex_state = 128},
  [2286] = {.lex_state = 330},
  [2287] = {.lex_state = 330},
  [2288] = {.lex_state = 235},
  [2289] = {.lex_state = 337},
  [2290] = {.lex_state = 194},
  [2291] = {.lex_state = 286, .external_lex_state = 2},
  [2292] = {.lex_state = 337},
  [2293] = {.lex_state = 128},
  [2294] = {.lex_state = 128, .external_lex_state = 12},
  [2295] = {.lex_state = 414, .external_lex_state = 2},
  [2296] = {.lex_state = 337},
  [2297] = {.lex_state = 484, .external_lex_state = 21},
  [2298] = {.lex_state = 356, .external_lex_state = 13},
  [2299] = {.lex_state = 484, .external_lex_state = 21},
  [2300] = {.lex_state = 484, .external_lex_state = 21},
  [2301] = {.lex_state = 416, .external_lex_state = 28},
  [2302] = {.lex_state = 337},
  [2303] = {.lex_state = 235, .external_lex_state = 19},
  [2304] = {.lex_state = 235},
  [2305] = {.lex_state = 484, .external_lex_state = 21},
  [2306] = {.lex_state = 621, .external_lex_state = 25},
  [2307] = {.lex_state = 177, .external_lex_state = 4},
  [2308] = {.lex_state = 177, .external_lex_state = 4},
  [2309] = {.lex_state = 177, .external_lex_state = 4},
  [2310] = {.lex_state = 177, .external_lex_state = 4},
  [2311] = {.lex_state = 190, .external_lex_state = 4},
  [2312] = {.lex_state = 190, .external_lex_state = 4},
  [2313] = {.lex_state = 192, .external_lex_state = 2},
  [2314] = {.lex_state = 194, .external_lex_state = 6},
  [2315] = {.lex_state = 197, .external_lex_state = 7},
  [2316] = {.lex_state = 209, .external_lex_state = 2},
  [2317] = {.lex_state = 216, .external_lex_state = 10},
  [2318] = {.lex_state = 216, .external_lex_state = 9},
  [2319] = {.lex_state = 624, .external_lex_state = 26},
  [2320] = {.lex_state = 624, .external_lex_state = 26},
  [2321] = {.lex_state = 624, .external_lex_state = 26},
  [2322] = {.lex_state = 624, .external_lex_state = 26},
  [2323] = {.lex_state = 221, .external_lex_state = 2},
  [2324] = {.lex_state = 221, .external_lex_state = 2},
  [2325] = {.lex_state = 192, .external_lex_state = 2},
  [2326] = {.lex_state = 192, .external_lex_state = 2},
  [2327] = {.lex_state = 223, .external_lex_state = 9},
  [2328] = {.lex_state = 221, .external_lex_state = 12},
  [2329] = {.lex_state = 128, .external_lex_state = 12},
  [2330] = {.lex_state = 192, .external_lex_state = 2},
  [2331] = {.lex_state = 192, .external_lex_state = 2},
  [2332] = {.lex_state = 621, .external_lex_state = 25},
  [2333] = {.lex_state = 235, .external_lex_state = 13},
  [2334] = {.lex_state = 237},
  [2335] = {.lex_state = 627, .external_lex_state = 25},
  [2336] = {.lex_state = 618, .external_lex_state = 26},
  [2337] = {.lex_state = 213},
  [2338] = {.lex_state = 424, .external_lex_state = 25},
  [2339] = {.lex_state = 627, .external_lex_state = 27},
  [2340] = {.lex_state = 627, .external_lex_state = 25},
  [2341] = {.lex_state = 505, .external_lex_state = 25},
  [2342] = {.lex_state = 630, .external_lex_state = 27},
  [2343] = {.lex_state = 192, .external_lex_state = 2},
  [2344] = {.lex_state = 604, .external_lex_state = 25},
  [2345] = {.lex_state = 627, .external_lex_state = 25},
  [2346] = {.lex_state = 192, .external_lex_state = 2},
  [2347] = {.lex_state = 192, .external_lex_state = 2},
  [2348] = {.lex_state = 237},
  [2349] = {.lex_state = 192, .external_lex_state = 2},
  [2350] = {.lex_state = 296, .external_lex_state = 26},
  [2351] = {.lex_state = 505, .external_lex_state = 25},
  [2352] = {.lex_state = 505, .external_lex_state = 25},
  [2353] = {.lex_state = 505, .external_lex_state = 25},
  [2354] = {.lex_state = 505, .external_lex_state = 27},
  [2355] = {.lex_state = 505, .external_lex_state = 25},
  [2356] = {.lex_state = 192, .external_lex_state = 2},
  [2357] = {.lex_state = 192, .external_lex_state = 2},
  [2358] = {.lex_state = 192, .external_lex_state = 2},
  [2359] = {.lex_state = 192, .external_lex_state = 2},
  [2360] = {.lex_state = 192, .external_lex_state = 2},
  [2361] = {.lex_state = 192, .external_lex_state = 2},
  [2362] = {.lex_state = 192, .external_lex_state = 2},
  [2363] = {.lex_state = 192, .external_lex_state = 2},
  [2364] = {.lex_state = 192, .external_lex_state = 2},
  [2365] = {.lex_state = 192, .external_lex_state = 2},
  [2366] = {.lex_state = 192, .external_lex_state = 2},
  [2367] = {.lex_state = 337},
  [2368] = {.lex_state = 340, .external_lex_state = 19},
  [2369] = {.lex_state = 524, .external_lex_state = 13},
  [2370] = {.lex_state = 340, .external_lex_state = 19},
  [2371] = {.lex_state = 192, .external_lex_state = 29},
  [2372] = {.lex_state = 192, .external_lex_state = 2},
  [2373] = {.lex_state = 630, .external_lex_state = 27},
  [2374] = {.lex_state = 343, .external_lex_state = 22},
  [2375] = {.lex_state = 128, .external_lex_state = 2},
  [2376] = {.lex_state = 247, .external_lex_state = 3},
  [2377] = {.lex_state = 128, .external_lex_state = 2},
  [2378] = {.lex_state = 156, .external_lex_state = 3},
  [2379] = {.lex_state = 346, .external_lex_state = 23},
  [2380] = {.lex_state = 192, .external_lex_state = 2},
  [2381] = {.lex_state = 615, .external_lex_state = 26},
  [2382] = {.lex_state = 615, .external_lex_state = 26},
  [2383] = {.lex_state = 615, .external_lex_state = 26},
  [2384] = {.lex_state = 615, .external_lex_state = 26},
  [2385] = {.lex_state = 192, .external_lex_state = 2},
  [2386] = {.lex_state = 192, .external_lex_state = 2},
  [2387] = {.lex_state = 508, .external_lex_state = 25},
  [2388] = {.lex_state = 213},
  [2389] = {.lex_state = 424, .external_lex_state = 25},
  [2390] = {.lex_state = 631, .external_lex_state = 27},
  [2391] = {.lex_state = 508, .external_lex_state = 25},
  [2392] = {.lex_state = 508, .external_lex_state = 25},
  [2393] = {.lex_state = 634, .external_lex_state = 27},
  [2394] = {.lex_state = 192, .external_lex_state = 2},
  [2395] = {.lex_state = 508, .external_lex_state = 25},
  [2396] = {.lex_state = 508, .external_lex_state = 25},
  [2397] = {.lex_state = 192, .external_lex_state = 2},
  [2398] = {.lex_state = 192, .external_lex_state = 2},
  [2399] = {.lex_state = 237},
  [2400] = {.lex_state = 192, .external_lex_state = 2},
  [2401] = {.lex_state = 296, .external_lex_state = 26},
  [2402] = {.lex_state = 508, .external_lex_state = 25},
  [2403] = {.lex_state = 508, .external_lex_state = 25},
  [2404] = {.lex_state = 508, .external_lex_state = 25},
  [2405] = {.lex_state = 508, .external_lex_state = 27},
  [2406] = {.lex_state = 508, .external_lex_state = 25},
  [2407] = {.lex_state = 192, .external_lex_state = 2},
  [2408] = {.lex_state = 192, .external_lex_state = 2},
  [2409] = {.lex_state = 192, .external_lex_state = 2},
  [2410] = {.lex_state = 192, .external_lex_state = 2},
  [2411] = {.lex_state = 192, .external_lex_state = 2},
  [2412] = {.lex_state = 192, .external_lex_state = 2},
  [2413] = {.lex_state = 192, .external_lex_state = 2},
  [2414] = {.lex_state = 192, .external_lex_state = 2},
  [2415] = {.lex_state = 192, .external_lex_state = 2},
  [2416] = {.lex_state = 192, .external_lex_state = 2},
  [2417] = {.lex_state = 192, .external_lex_state = 2},
  [2418] = {.lex_state = 334, .external_lex_state = 19},
  [2419] = {.lex_state = 524, .external_lex_state = 13},
  [2420] = {.lex_state = 340, .external_lex_state = 19},
  [2421] = {.lex_state = 192, .external_lex_state = 29},
  [2422] = {.lex_state = 192, .external_lex_state = 2},
  [2423] = {.lex_state = 634, .external_lex_state = 27},
  [2424] = {.lex_state = 156, .external_lex_state = 3},
  [2425] = {.lex_state = 365, .external_lex_state = 3},
  [2426] = {.lex_state = 365, .external_lex_state = 3},
  [2427] = {.lex_state = 365, .external_lex_state = 3},
  [2428] = {.lex_state = 365, .external_lex_state = 3},
  [2429] = {.lex_state = 192, .external_lex_state = 2},
  [2430] = {.lex_state = 192, .external_lex_state = 2},
  [2431] = {.lex_state = 192, .external_lex_state = 2},
  [2432] = {.lex_state = 192, .external_lex_state = 2},
  [2433] = {.lex_state = 192, .external_lex_state = 2},
  [2434] = {.lex_state = 192, .external_lex_state = 2},
  [2435] = {.lex_state = 192, .external_lex_state = 2},
  [2436] = {.lex_state = 192, .external_lex_state = 2},
  [2437] = {.lex_state = 192, .external_lex_state = 2},
  [2438] = {.lex_state = 192, .external_lex_state = 2},
  [2439] = {.lex_state = 192, .external_lex_state = 29},
  [2440] = {.lex_state = 192, .external_lex_state = 2},
  [2441] = {.lex_state = 365, .external_lex_state = 14},
  [2442] = {.lex_state = 365, .external_lex_state = 3},
  [2443] = {.lex_state = 361, .external_lex_state = 3},
  [2444] = {.lex_state = 361, .external_lex_state = 3},
  [2445] = {.lex_state = 192, .external_lex_state = 2},
  [2446] = {.lex_state = 361, .external_lex_state = 3},
  [2447] = {.lex_state = 192, .external_lex_state = 2},
  [2448] = {.lex_state = 361, .external_lex_state = 3},
  [2449] = {.lex_state = 524, .external_lex_state = 13},
  [2450] = {.lex_state = 361, .external_lex_state = 3},
  [2451] = {.lex_state = 192, .external_lex_state = 2},
  [2452] = {.lex_state = 635, .external_lex_state = 26},
  [2453] = {.lex_state = 635, .external_lex_state = 26},
  [2454] = {.lex_state = 635, .external_lex_state = 26},
  [2455] = {.lex_state = 635, .external_lex_state = 26},
  [2456] = {.lex_state = 192, .external_lex_state = 2},
  [2457] = {.lex_state = 192, .external_lex_state = 2},
  [2458] = {.lex_state = 302, .external_lex_state = 25},
  [2459] = {.lex_state = 478, .external_lex_state = 26},
  [2460] = {.lex_state = 213},
  [2461] = {.lex_state = 321, .external_lex_state = 25},
  [2462] = {.lex_state = 610, .external_lex_state = 27},
  [2463] = {.lex_state = 302, .external_lex_state = 25},
  [2464] = {.lex_state = 302, .external_lex_state = 25},
  [2465] = {.lex_state = 613, .external_lex_state = 27},
  [2466] = {.lex_state = 192, .external_lex_state = 2},
  [2467] = {.lex_state = 302, .external_lex_state = 25},
  [2468] = {.lex_state = 192, .external_lex_state = 2},
  [2469] = {.lex_state = 192, .external_lex_state = 2},
  [2470] = {.lex_state = 237},
  [2471] = {.lex_state = 192, .external_lex_state = 2},
  [2472] = {.lex_state = 520, .external_lex_state = 26},
  [2473] = {.lex_state = 493, .external_lex_state = 25},
  [2474] = {.lex_state = 493, .external_lex_state = 25},
  [2475] = {.lex_state = 493, .external_lex_state = 25},
  [2476] = {.lex_state = 493, .external_lex_state = 27},
  [2477] = {.lex_state = 302, .external_lex_state = 25},
  [2478] = {.lex_state = 192, .external_lex_state = 2},
  [2479] = {.lex_state = 192, .external_lex_state = 2},
  [2480] = {.lex_state = 192, .external_lex_state = 2},
  [2481] = {.lex_state = 192, .external_lex_state = 2},
  [2482] = {.lex_state = 192, .external_lex_state = 2},
  [2483] = {.lex_state = 192, .external_lex_state = 2},
  [2484] = {.lex_state = 192, .external_lex_state = 2},
  [2485] = {.lex_state = 192, .external_lex_state = 2},
  [2486] = {.lex_state = 192, .external_lex_state = 2},
  [2487] = {.lex_state = 192, .external_lex_state = 2},
  [2488] = {.lex_state = 192, .external_lex_state = 2},
  [2489] = {.lex_state = 192, .external_lex_state = 2},
  [2490] = {.lex_state = 192, .external_lex_state = 2},
  [2491] = {.lex_state = 237},
  [2492] = {.lex_state = 192, .external_lex_state = 2},
  [2493] = {.lex_state = 520, .external_lex_state = 26},
  [2494] = {.lex_state = 497, .external_lex_state = 25},
  [2495] = {.lex_state = 497, .external_lex_state = 25},
  [2496] = {.lex_state = 497, .external_lex_state = 25},
  [2497] = {.lex_state = 497, .external_lex_state = 27},
  [2498] = {.lex_state = 156, .external_lex_state = 3},
  [2499] = {.lex_state = 209},
  [2500] = {.lex_state = 356, .external_lex_state = 13},
  [2501] = {.lex_state = 192, .external_lex_state = 29},
  [2502] = {.lex_state = 192, .external_lex_state = 2},
  [2503] = {.lex_state = 613, .external_lex_state = 27},
  [2504] = {.lex_state = 365, .external_lex_state = 3},
  [2505] = {.lex_state = 361, .external_lex_state = 3},
  [2506] = {.lex_state = 361, .external_lex_state = 3},
  [2507] = {.lex_state = 361, .external_lex_state = 3},
  [2508] = {.lex_state = 361, .external_lex_state = 3},
  [2509] = {.lex_state = 361, .external_lex_state = 3},
  [2510] = {.lex_state = 554, .external_lex_state = 16},
  [2511] = {.lex_state = 361, .external_lex_state = 3},
  [2512] = {.lex_state = 361, .external_lex_state = 3},
  [2513] = {.lex_state = 361, .external_lex_state = 3},
  [2514] = {.lex_state = 361, .external_lex_state = 3},
  [2515] = {.lex_state = 514, .external_lex_state = 11},
  [2516] = {.lex_state = 356, .external_lex_state = 13},
  [2517] = {.lex_state = 514, .external_lex_state = 11},
  [2518] = {.lex_state = 514, .external_lex_state = 11},
  [2519] = {.lex_state = 416, .external_lex_state = 28},
  [2520] = {.lex_state = 299, .external_lex_state = 3},
  [2521] = {.lex_state = 235, .external_lex_state = 19},
  [2522] = {.lex_state = 235},
  [2523] = {.lex_state = 514, .external_lex_state = 11},
  [2524] = {.lex_state = 421, .external_lex_state = 3},
  [2525] = {.lex_state = 421, .external_lex_state = 3},
  [2526] = {.lex_state = 192, .external_lex_state = 2},
  [2527] = {.lex_state = 299, .external_lex_state = 3},
  [2528] = {.lex_state = 194},
  [2529] = {.lex_state = 286, .external_lex_state = 2},
  [2530] = {.lex_state = 421, .external_lex_state = 3},
  [2531] = {.lex_state = 299, .external_lex_state = 3},
  [2532] = {.lex_state = 128},
  [2533] = {.lex_state = 128, .external_lex_state = 12},
  [2534] = {.lex_state = 414, .external_lex_state = 2},
  [2535] = {.lex_state = 299, .external_lex_state = 3},
  [2536] = {.lex_state = 209, .external_lex_state = 19},
  [2537] = {.lex_state = 209},
  [2538] = {.lex_state = 192, .external_lex_state = 2},
  [2539] = {.lex_state = 299, .external_lex_state = 3},
  [2540] = {.lex_state = 177, .external_lex_state = 17},
  [2541] = {.lex_state = 421, .external_lex_state = 3},
  [2542] = {.lex_state = 524, .external_lex_state = 13},
  [2543] = {.lex_state = 421, .external_lex_state = 3},
  [2544] = {.lex_state = 156, .external_lex_state = 3},
  [2545] = {.lex_state = 177, .external_lex_state = 17},
  [2546] = {.lex_state = 262, .external_lex_state = 3},
  [2547] = {.lex_state = 177, .external_lex_state = 17},
  [2548] = {.lex_state = 156, .external_lex_state = 3},
  [2549] = {.lex_state = 524, .external_lex_state = 21},
  [2550] = {.lex_state = 262, .external_lex_state = 3},
  [2551] = {.lex_state = 365, .external_lex_state = 3},
  [2552] = {.lex_state = 361, .external_lex_state = 3},
  [2553] = {.lex_state = 156, .external_lex_state = 3},
  [2554] = {.lex_state = 361, .external_lex_state = 3},
  [2555] = {.lex_state = 361, .external_lex_state = 3},
  [2556] = {.lex_state = 361, .external_lex_state = 14},
  [2557] = {.lex_state = 192, .external_lex_state = 2},
  [2558] = {.lex_state = 511, .external_lex_state = 11},
  [2559] = {.lex_state = 511, .external_lex_state = 11},
  [2560] = {.lex_state = 511, .external_lex_state = 11},
  [2561] = {.lex_state = 511, .external_lex_state = 11},
  [2562] = {.lex_state = 192, .external_lex_state = 2},
  [2563] = {.lex_state = 192, .external_lex_state = 2},
  [2564] = {.lex_state = 361, .external_lex_state = 3},
  [2565] = {.lex_state = 213},
  [2566] = {.lex_state = 259, .external_lex_state = 3},
  [2567] = {.lex_state = 365, .external_lex_state = 14},
  [2568] = {.lex_state = 361, .external_lex_state = 3},
  [2569] = {.lex_state = 361, .external_lex_state = 3},
  [2570] = {.lex_state = 361, .external_lex_state = 14},
  [2571] = {.lex_state = 192, .external_lex_state = 2},
  [2572] = {.lex_state = 361, .external_lex_state = 3},
  [2573] = {.lex_state = 192, .external_lex_state = 2},
  [2574] = {.lex_state = 192, .external_lex_state = 2},
  [2575] = {.lex_state = 237},
  [2576] = {.lex_state = 192, .external_lex_state = 2},
  [2577] = {.lex_state = 358, .external_lex_state = 11},
  [2578] = {.lex_state = 361, .external_lex_state = 3},
  [2579] = {.lex_state = 361, .external_lex_state = 3},
  [2580] = {.lex_state = 361, .external_lex_state = 3},
  [2581] = {.lex_state = 371, .external_lex_state = 14},
  [2582] = {.lex_state = 361, .external_lex_state = 3},
  [2583] = {.lex_state = 192, .external_lex_state = 2},
  [2584] = {.lex_state = 192, .external_lex_state = 2},
  [2585] = {.lex_state = 192, .external_lex_state = 2},
  [2586] = {.lex_state = 192, .external_lex_state = 2},
  [2587] = {.lex_state = 192, .external_lex_state = 2},
  [2588] = {.lex_state = 192, .external_lex_state = 2},
  [2589] = {.lex_state = 192, .external_lex_state = 2},
  [2590] = {.lex_state = 192, .external_lex_state = 2},
  [2591] = {.lex_state = 192, .external_lex_state = 2},
  [2592] = {.lex_state = 192, .external_lex_state = 2},
  [2593] = {.lex_state = 192, .external_lex_state = 2},
  [2594] = {.lex_state = 192, .external_lex_state = 2},
  [2595] = {.lex_state = 192, .external_lex_state = 2},
  [2596] = {.lex_state = 237},
  [2597] = {.lex_state = 192, .external_lex_state = 2},
  [2598] = {.lex_state = 358, .external_lex_state = 11},
  [2599] = {.lex_state = 421, .external_lex_state = 3},
  [2600] = {.lex_state = 421, .external_lex_state = 3},
  [2601] = {.lex_state = 421, .external_lex_state = 3},
  [2602] = {.lex_state = 427, .external_lex_state = 14},
  [2603] = {.lex_state = 262, .external_lex_state = 3},
  [2604] = {.lex_state = 524, .external_lex_state = 13},
  [2605] = {.lex_state = 361, .external_lex_state = 3},
  [2606] = {.lex_state = 192, .external_lex_state = 29},
  [2607] = {.lex_state = 192, .external_lex_state = 2},
  [2608] = {.lex_state = 361, .external_lex_state = 14},
  [2609] = {.lex_state = 254, .external_lex_state = 8},
  [2610] = {.lex_state = 128, .external_lex_state = 12},
  [2611] = {.lex_state = 177, .external_lex_state = 17},
  [2612] = {.lex_state = 247, .external_lex_state = 3},
  [2613] = {.lex_state = 247, .external_lex_state = 3},
  [2614] = {.lex_state = 247, .external_lex_state = 3},
  [2615] = {.lex_state = 247, .external_lex_state = 3},
  [2616] = {.lex_state = 247, .external_lex_state = 3},
  [2617] = {.lex_state = 192, .external_lex_state = 2},
  [2618] = {.lex_state = 156, .external_lex_state = 3},
  [2619] = {.lex_state = 218, .external_lex_state = 11},
  [2620] = {.lex_state = 218, .external_lex_state = 11},
  [2621] = {.lex_state = 218, .external_lex_state = 11},
  [2622] = {.lex_state = 218, .external_lex_state = 11},
  [2623] = {.lex_state = 221, .external_lex_state = 2},
  [2624] = {.lex_state = 128, .external_lex_state = 12},
  [2625] = {.lex_state = 192, .external_lex_state = 2},
  [2626] = {.lex_state = 192, .external_lex_state = 2},
  [2627] = {.lex_state = 225, .external_lex_state = 7},
  [2628] = {.lex_state = 128},
  [2629] = {.lex_state = 128, .external_lex_state = 8},
  [2630] = {.lex_state = 128, .external_lex_state = 8},
  [2631] = {.lex_state = 128},
  [2632] = {.lex_state = 247, .external_lex_state = 3},
  [2633] = {.lex_state = 254, .external_lex_state = 11},
  [2634] = {.lex_state = 213},
  [2635] = {.lex_state = 259, .external_lex_state = 3},
  [2636] = {.lex_state = 262, .external_lex_state = 14},
  [2637] = {.lex_state = 128, .external_lex_state = 2},
  [2638] = {.lex_state = 128, .external_lex_state = 12},
  [2639] = {.lex_state = 247, .external_lex_state = 3},
  [2640] = {.lex_state = 247, .external_lex_state = 3},
  [2641] = {.lex_state = 247, .external_lex_state = 3},
  [2642] = {.lex_state = 247, .external_lex_state = 3},
  [2643] = {.lex_state = 247, .external_lex_state = 3},
  [2644] = {.lex_state = 554, .external_lex_state = 16},
  [2645] = {.lex_state = 247, .external_lex_state = 3},
  [2646] = {.lex_state = 247, .external_lex_state = 3},
  [2647] = {.lex_state = 247, .external_lex_state = 3},
  [2648] = {.lex_state = 247, .external_lex_state = 3},
  [2649] = {.lex_state = 192, .external_lex_state = 2},
  [2650] = {.lex_state = 254, .external_lex_state = 11},
  [2651] = {.lex_state = 254, .external_lex_state = 11},
  [2652] = {.lex_state = 254, .external_lex_state = 11},
  [2653] = {.lex_state = 254, .external_lex_state = 11},
  [2654] = {.lex_state = 192, .external_lex_state = 2},
  [2655] = {.lex_state = 192, .external_lex_state = 2},
  [2656] = {.lex_state = 424, .external_lex_state = 3},
  [2657] = {.lex_state = 254, .external_lex_state = 11},
  [2658] = {.lex_state = 213},
  [2659] = {.lex_state = 424, .external_lex_state = 3},
  [2660] = {.lex_state = 424, .external_lex_state = 14},
  [2661] = {.lex_state = 424, .external_lex_state = 3},
  [2662] = {.lex_state = 421, .external_lex_state = 3},
  [2663] = {.lex_state = 421, .external_lex_state = 14},
  [2664] = {.lex_state = 192, .external_lex_state = 2},
  [2665] = {.lex_state = 424, .external_lex_state = 3},
  [2666] = {.lex_state = 421, .external_lex_state = 3},
  [2667] = {.lex_state = 192, .external_lex_state = 2},
  [2668] = {.lex_state = 192, .external_lex_state = 2},
  [2669] = {.lex_state = 192, .external_lex_state = 2},
  [2670] = {.lex_state = 192, .external_lex_state = 2},
  [2671] = {.lex_state = 192, .external_lex_state = 2},
  [2672] = {.lex_state = 192, .external_lex_state = 2},
  [2673] = {.lex_state = 192, .external_lex_state = 2},
  [2674] = {.lex_state = 192, .external_lex_state = 2},
  [2675] = {.lex_state = 192, .external_lex_state = 2},
  [2676] = {.lex_state = 192, .external_lex_state = 2},
  [2677] = {.lex_state = 192, .external_lex_state = 2},
  [2678] = {.lex_state = 424, .external_lex_state = 3},
  [2679] = {.lex_state = 524, .external_lex_state = 13},
  [2680] = {.lex_state = 424, .external_lex_state = 3},
  [2681] = {.lex_state = 192, .external_lex_state = 29},
  [2682] = {.lex_state = 192, .external_lex_state = 2},
  [2683] = {.lex_state = 421, .external_lex_state = 14},
  [2684] = {.lex_state = 192, .external_lex_state = 2},
  [2685] = {.lex_state = 192, .external_lex_state = 2},
  [2686] = {.lex_state = 192, .external_lex_state = 2},
  [2687] = {.lex_state = 192, .external_lex_state = 2},
  [2688] = {.lex_state = 528, .external_lex_state = 3},
  [2689] = {.lex_state = 528, .external_lex_state = 3},
  [2690] = {.lex_state = 213},
  [2691] = {.lex_state = 259, .external_lex_state = 3},
  [2692] = {.lex_state = 247, .external_lex_state = 3},
  [2693] = {.lex_state = 262, .external_lex_state = 14},
  [2694] = {.lex_state = 192, .external_lex_state = 2},
  [2695] = {.lex_state = 156, .external_lex_state = 3},
  [2696] = {.lex_state = 218, .external_lex_state = 11},
  [2697] = {.lex_state = 218, .external_lex_state = 11},
  [2698] = {.lex_state = 218, .external_lex_state = 11},
  [2699] = {.lex_state = 218, .external_lex_state = 11},
  [2700] = {.lex_state = 192, .external_lex_state = 2},
  [2701] = {.lex_state = 192, .external_lex_state = 2},
  [2702] = {.lex_state = 225, .external_lex_state = 7},
  [2703] = {.lex_state = 128},
  [2704] = {.lex_state = 128, .external_lex_state = 8},
  [2705] = {.lex_state = 128, .external_lex_state = 8},
  [2706] = {.lex_state = 128},
  [2707] = {.lex_state = 247, .external_lex_state = 3},
  [2708] = {.lex_state = 254, .external_lex_state = 11},
  [2709] = {.lex_state = 213},
  [2710] = {.lex_state = 259, .external_lex_state = 3},
  [2711] = {.lex_state = 262, .external_lex_state = 14},
  [2712] = {.lex_state = 128, .external_lex_state = 2},
  [2713] = {.lex_state = 192, .external_lex_state = 2},
  [2714] = {.lex_state = 511, .external_lex_state = 11},
  [2715] = {.lex_state = 511, .external_lex_state = 11},
  [2716] = {.lex_state = 511, .external_lex_state = 11},
  [2717] = {.lex_state = 511, .external_lex_state = 11},
  [2718] = {.lex_state = 192, .external_lex_state = 2},
  [2719] = {.lex_state = 192, .external_lex_state = 2},
  [2720] = {.lex_state = 361, .external_lex_state = 3},
  [2721] = {.lex_state = 213},
  [2722] = {.lex_state = 259, .external_lex_state = 3},
  [2723] = {.lex_state = 365, .external_lex_state = 14},
  [2724] = {.lex_state = 361, .external_lex_state = 3},
  [2725] = {.lex_state = 361, .external_lex_state = 3},
  [2726] = {.lex_state = 361, .external_lex_state = 14},
  [2727] = {.lex_state = 192, .external_lex_state = 2},
  [2728] = {.lex_state = 361, .external_lex_state = 3},
  [2729] = {.lex_state = 192, .external_lex_state = 2},
  [2730] = {.lex_state = 192, .external_lex_state = 2},
  [2731] = {.lex_state = 237},
  [2732] = {.lex_state = 192, .external_lex_state = 2},
  [2733] = {.lex_state = 358, .external_lex_state = 11},
  [2734] = {.lex_state = 361, .external_lex_state = 3},
  [2735] = {.lex_state = 361, .external_lex_state = 3},
  [2736] = {.lex_state = 361, .external_lex_state = 3},
  [2737] = {.lex_state = 371, .external_lex_state = 14},
  [2738] = {.lex_state = 361, .external_lex_state = 3},
  [2739] = {.lex_state = 192, .external_lex_state = 2},
  [2740] = {.lex_state = 192, .external_lex_state = 2},
  [2741] = {.lex_state = 192, .external_lex_state = 2},
  [2742] = {.lex_state = 192, .external_lex_state = 2},
  [2743] = {.lex_state = 192, .external_lex_state = 2},
  [2744] = {.lex_state = 192, .external_lex_state = 2},
  [2745] = {.lex_state = 192, .external_lex_state = 2},
  [2746] = {.lex_state = 192, .external_lex_state = 2},
  [2747] = {.lex_state = 192, .external_lex_state = 2},
  [2748] = {.lex_state = 192, .external_lex_state = 2},
  [2749] = {.lex_state = 192, .external_lex_state = 2},
  [2750] = {.lex_state = 192, .external_lex_state = 2},
  [2751] = {.lex_state = 192, .external_lex_state = 2},
  [2752] = {.lex_state = 237},
  [2753] = {.lex_state = 419, .external_lex_state = 6},
  [2754] = {.lex_state = 192, .external_lex_state = 2},
  [2755] = {.lex_state = 358, .external_lex_state = 11},
  [2756] = {.lex_state = 421, .external_lex_state = 3},
  [2757] = {.lex_state = 421, .external_lex_state = 3},
  [2758] = {.lex_state = 421, .external_lex_state = 3},
  [2759] = {.lex_state = 427, .external_lex_state = 14},
  [2760] = {.lex_state = 262, .external_lex_state = 3},
  [2761] = {.lex_state = 524, .external_lex_state = 13},
  [2762] = {.lex_state = 361, .external_lex_state = 3},
  [2763] = {.lex_state = 192, .external_lex_state = 29},
  [2764] = {.lex_state = 192, .external_lex_state = 2},
  [2765] = {.lex_state = 361, .external_lex_state = 14},
  [2766] = {.lex_state = 247, .external_lex_state = 3},
  [2767] = {.lex_state = 247, .external_lex_state = 3},
  [2768] = {.lex_state = 247, .external_lex_state = 3},
  [2769] = {.lex_state = 247, .external_lex_state = 3},
  [2770] = {.lex_state = 247, .external_lex_state = 3},
  [2771] = {.lex_state = 554, .external_lex_state = 16},
  [2772] = {.lex_state = 247, .external_lex_state = 3},
  [2773] = {.lex_state = 247, .external_lex_state = 3},
  [2774] = {.lex_state = 247, .external_lex_state = 3},
  [2775] = {.lex_state = 247, .external_lex_state = 3},
  [2776] = {.lex_state = 156, .external_lex_state = 3},
  [2777] = {.lex_state = 128},
  [2778] = {.lex_state = 192, .external_lex_state = 2},
  [2779] = {.lex_state = 254, .external_lex_state = 11},
  [2780] = {.lex_state = 254, .external_lex_state = 11},
  [2781] = {.lex_state = 254, .external_lex_state = 11},
  [2782] = {.lex_state = 254, .external_lex_state = 11},
  [2783] = {.lex_state = 192, .external_lex_state = 2},
  [2784] = {.lex_state = 192, .external_lex_state = 2},
  [2785] = {.lex_state = 424, .external_lex_state = 3},
  [2786] = {.lex_state = 254, .external_lex_state = 11},
  [2787] = {.lex_state = 213},
  [2788] = {.lex_state = 424, .external_lex_state = 3},
  [2789] = {.lex_state = 424, .external_lex_state = 14},
  [2790] = {.lex_state = 424, .external_lex_state = 3},
  [2791] = {.lex_state = 421, .external_lex_state = 3},
  [2792] = {.lex_state = 421, .external_lex_state = 14},
  [2793] = {.lex_state = 192, .external_lex_state = 2},
  [2794] = {.lex_state = 421, .external_lex_state = 3},
  [2795] = {.lex_state = 424, .external_lex_state = 3},
  [2796] = {.lex_state = 421, .external_lex_state = 3},
  [2797] = {.lex_state = 192, .external_lex_state = 2},
  [2798] = {.lex_state = 192, .external_lex_state = 2},
  [2799] = {.lex_state = 192, .external_lex_state = 2},
  [2800] = {.lex_state = 192, .external_lex_state = 2},
  [2801] = {.lex_state = 192, .external_lex_state = 2},
  [2802] = {.lex_state = 192, .external_lex_state = 2},
  [2803] = {.lex_state = 192, .external_lex_state = 2},
  [2804] = {.lex_state = 192, .external_lex_state = 2},
  [2805] = {.lex_state = 192, .external_lex_state = 2},
  [2806] = {.lex_state = 192, .external_lex_state = 2},
  [2807] = {.lex_state = 192, .external_lex_state = 2},
  [2808] = {.lex_state = 424, .external_lex_state = 3},
  [2809] = {.lex_state = 524, .external_lex_state = 13},
  [2810] = {.lex_state = 424, .external_lex_state = 3},
  [2811] = {.lex_state = 192, .external_lex_state = 29},
  [2812] = {.lex_state = 192, .external_lex_state = 2},
  [2813] = {.lex_state = 421, .external_lex_state = 14},
  [2814] = {.lex_state = 192, .external_lex_state = 2},
  [2815] = {.lex_state = 192, .external_lex_state = 2},
  [2816] = {.lex_state = 192, .external_lex_state = 2},
  [2817] = {.lex_state = 192, .external_lex_state = 2},
  [2818] = {.lex_state = 528, .external_lex_state = 3},
  [2819] = {.lex_state = 528, .external_lex_state = 3},
  [2820] = {.lex_state = 213},
  [2821] = {.lex_state = 259, .external_lex_state = 3},
  [2822] = {.lex_state = 247, .external_lex_state = 3},
  [2823] = {.lex_state = 262, .external_lex_state = 14},
  [2824] = {.lex_state = 156, .external_lex_state = 3},
  [2825] = {.lex_state = 128},
  [2826] = {.lex_state = 192, .external_lex_state = 2},
  [2827] = {.lex_state = 615, .external_lex_state = 26},
  [2828] = {.lex_state = 615, .external_lex_state = 26},
  [2829] = {.lex_state = 615, .external_lex_state = 26},
  [2830] = {.lex_state = 615, .external_lex_state = 26},
  [2831] = {.lex_state = 192, .external_lex_state = 2},
  [2832] = {.lex_state = 192, .external_lex_state = 2},
  [2833] = {.lex_state = 508, .external_lex_state = 25},
  [2834] = {.lex_state = 618, .external_lex_state = 26},
  [2835] = {.lex_state = 213},
  [2836] = {.lex_state = 424, .external_lex_state = 25},
  [2837] = {.lex_state = 631, .external_lex_state = 27},
  [2838] = {.lex_state = 508, .external_lex_state = 25},
  [2839] = {.lex_state = 508, .external_lex_state = 25},
  [2840] = {.lex_state = 634, .external_lex_state = 27},
  [2841] = {.lex_state = 192, .external_lex_state = 2},
  [2842] = {.lex_state = 508, .external_lex_state = 25},
  [2843] = {.lex_state = 192, .external_lex_state = 2},
  [2844] = {.lex_state = 192, .external_lex_state = 2},
  [2845] = {.lex_state = 237},
  [2846] = {.lex_state = 192, .external_lex_state = 2},
  [2847] = {.lex_state = 296, .external_lex_state = 26},
  [2848] = {.lex_state = 508, .external_lex_state = 25},
  [2849] = {.lex_state = 508, .external_lex_state = 25},
  [2850] = {.lex_state = 508, .external_lex_state = 25},
  [2851] = {.lex_state = 508, .external_lex_state = 27},
  [2852] = {.lex_state = 508, .external_lex_state = 25},
  [2853] = {.lex_state = 192, .external_lex_state = 2},
  [2854] = {.lex_state = 192, .external_lex_state = 2},
  [2855] = {.lex_state = 192, .external_lex_state = 2},
  [2856] = {.lex_state = 192, .external_lex_state = 2},
  [2857] = {.lex_state = 192, .external_lex_state = 2},
  [2858] = {.lex_state = 192, .external_lex_state = 2},
  [2859] = {.lex_state = 192, .external_lex_state = 2},
  [2860] = {.lex_state = 192, .external_lex_state = 2},
  [2861] = {.lex_state = 192, .external_lex_state = 2},
  [2862] = {.lex_state = 192, .external_lex_state = 2},
  [2863] = {.lex_state = 192, .external_lex_state = 2},
  [2864] = {.lex_state = 192, .external_lex_state = 2},
  [2865] = {.lex_state = 192, .external_lex_state = 2},
  [2866] = {.lex_state = 192, .external_lex_state = 2},
  [2867] = {.lex_state = 237},
  [2868] = {.lex_state = 192, .external_lex_state = 2},
  [2869] = {.lex_state = 304, .external_lex_state = 26},
  [2870] = {.lex_state = 304, .external_lex_state = 26},
  [2871] = {.lex_state = 304, .external_lex_state = 26},
  [2872] = {.lex_state = 304, .external_lex_state = 26},
  [2873] = {.lex_state = 192, .external_lex_state = 2},
  [2874] = {.lex_state = 192, .external_lex_state = 2},
  [2875] = {.lex_state = 296, .external_lex_state = 26},
  [2876] = {.lex_state = 421, .external_lex_state = 25},
  [2877] = {.lex_state = 421, .external_lex_state = 25},
  [2878] = {.lex_state = 421, .external_lex_state = 25},
  [2879] = {.lex_state = 213},
  [2880] = {.lex_state = 421, .external_lex_state = 25},
  [2881] = {.lex_state = 427, .external_lex_state = 27},
  [2882] = {.lex_state = 340, .external_lex_state = 19},
  [2883] = {.lex_state = 524, .external_lex_state = 13},
  [2884] = {.lex_state = 340, .external_lex_state = 19},
  [2885] = {.lex_state = 192, .external_lex_state = 29},
  [2886] = {.lex_state = 192, .external_lex_state = 2},
  [2887] = {.lex_state = 634, .external_lex_state = 27},
  [2888] = {.lex_state = 247, .external_lex_state = 3},
  [2889] = {.lex_state = 128, .external_lex_state = 2},
  [2890] = {.lex_state = 192, .external_lex_state = 2},
  [2891] = {.lex_state = 511, .external_lex_state = 11},
  [2892] = {.lex_state = 511, .external_lex_state = 11},
  [2893] = {.lex_state = 511, .external_lex_state = 11},
  [2894] = {.lex_state = 511, .external_lex_state = 11},
  [2895] = {.lex_state = 192, .external_lex_state = 2},
  [2896] = {.lex_state = 192, .external_lex_state = 2},
  [2897] = {.lex_state = 361, .external_lex_state = 3},
  [2898] = {.lex_state = 213},
  [2899] = {.lex_state = 259, .external_lex_state = 3},
  [2900] = {.lex_state = 365, .external_lex_state = 14},
  [2901] = {.lex_state = 361, .external_lex_state = 3},
  [2902] = {.lex_state = 361, .external_lex_state = 3},
  [2903] = {.lex_state = 361, .external_lex_state = 14},
  [2904] = {.lex_state = 192, .external_lex_state = 2},
  [2905] = {.lex_state = 361, .external_lex_state = 3},
  [2906] = {.lex_state = 192, .external_lex_state = 2},
  [2907] = {.lex_state = 192, .external_lex_state = 2},
  [2908] = {.lex_state = 237},
  [2909] = {.lex_state = 192, .external_lex_state = 2},
  [2910] = {.lex_state = 358, .external_lex_state = 11},
  [2911] = {.lex_state = 361, .external_lex_state = 3},
  [2912] = {.lex_state = 361, .external_lex_state = 3},
  [2913] = {.lex_state = 361, .external_lex_state = 3},
  [2914] = {.lex_state = 371, .external_lex_state = 14},
  [2915] = {.lex_state = 361, .external_lex_state = 3},
  [2916] = {.lex_state = 192, .external_lex_state = 2},
  [2917] = {.lex_state = 192, .external_lex_state = 2},
  [2918] = {.lex_state = 192, .external_lex_state = 2},
  [2919] = {.lex_state = 192, .external_lex_state = 2},
  [2920] = {.lex_state = 192, .external_lex_state = 2},
  [2921] = {.lex_state = 192, .external_lex_state = 2},
  [2922] = {.lex_state = 192, .external_lex_state = 2},
  [2923] = {.lex_state = 192, .external_lex_state = 2},
  [2924] = {.lex_state = 192, .external_lex_state = 2},
  [2925] = {.lex_state = 192, .external_lex_state = 2},
  [2926] = {.lex_state = 192, .external_lex_state = 2},
  [2927] = {.lex_state = 262, .external_lex_state = 3},
  [2928] = {.lex_state = 524, .external_lex_state = 13},
  [2929] = {.lex_state = 361, .external_lex_state = 3},
  [2930] = {.lex_state = 192, .external_lex_state = 29},
  [2931] = {.lex_state = 192, .external_lex_state = 2},
  [2932] = {.lex_state = 361, .external_lex_state = 14},
  [2933] = {.lex_state = 247, .external_lex_state = 3},
  [2934] = {.lex_state = 247, .external_lex_state = 3},
  [2935] = {.lex_state = 247, .external_lex_state = 3},
  [2936] = {.lex_state = 247, .external_lex_state = 3},
  [2937] = {.lex_state = 247, .external_lex_state = 3},
  [2938] = {.lex_state = 554, .external_lex_state = 16},
  [2939] = {.lex_state = 247, .external_lex_state = 3},
  [2940] = {.lex_state = 247, .external_lex_state = 3},
  [2941] = {.lex_state = 247, .external_lex_state = 3},
  [2942] = {.lex_state = 247, .external_lex_state = 3},
  [2943] = {.lex_state = 128},
  [2944] = {.lex_state = 128},
  [2945] = {.lex_state = 192, .external_lex_state = 2},
  [2946] = {.lex_state = 192, .external_lex_state = 2},
  [2947] = {.lex_state = 192, .external_lex_state = 2},
  [2948] = {.lex_state = 192, .external_lex_state = 2},
  [2949] = {.lex_state = 528, .external_lex_state = 3},
  [2950] = {.lex_state = 528, .external_lex_state = 3},
  [2951] = {.lex_state = 213},
  [2952] = {.lex_state = 259, .external_lex_state = 3},
  [2953] = {.lex_state = 247, .external_lex_state = 3},
  [2954] = {.lex_state = 262, .external_lex_state = 14},
  [2955] = {.lex_state = 192, .external_lex_state = 2},
  [2956] = {.lex_state = 192, .external_lex_state = 2},
  [2957] = {.lex_state = 511, .external_lex_state = 11},
  [2958] = {.lex_state = 511, .external_lex_state = 11},
  [2959] = {.lex_state = 511, .external_lex_state = 11},
  [2960] = {.lex_state = 511, .external_lex_state = 11},
  [2961] = {.lex_state = 192, .external_lex_state = 2},
  [2962] = {.lex_state = 192, .external_lex_state = 2},
  [2963] = {.lex_state = 254, .external_lex_state = 8},
  [2964] = {.lex_state = 528, .external_lex_state = 3},
  [2965] = {.lex_state = 254, .external_lex_state = 11},
  [2966] = {.lex_state = 254, .external_lex_state = 8},
  [2967] = {.lex_state = 213},
  [2968] = {.lex_state = 259, .external_lex_state = 3},
  [2969] = {.lex_state = 365, .external_lex_state = 14},
  [2970] = {.lex_state = 156, .external_lex_state = 3},
  [2971] = {.lex_state = 128},
  [2972] = {.lex_state = 526, .external_lex_state = 2},
  [2973] = {.lex_state = 192, .external_lex_state = 2},
  [2974] = {.lex_state = 511, .external_lex_state = 11},
  [2975] = {.lex_state = 511, .external_lex_state = 11},
  [2976] = {.lex_state = 511, .external_lex_state = 11},
  [2977] = {.lex_state = 511, .external_lex_state = 11},
  [2978] = {.lex_state = 192, .external_lex_state = 2},
  [2979] = {.lex_state = 192, .external_lex_state = 2},
  [2980] = {.lex_state = 361, .external_lex_state = 3},
  [2981] = {.lex_state = 213},
  [2982] = {.lex_state = 259, .external_lex_state = 3},
  [2983] = {.lex_state = 365, .external_lex_state = 14},
  [2984] = {.lex_state = 361, .external_lex_state = 3},
  [2985] = {.lex_state = 361, .external_lex_state = 3},
  [2986] = {.lex_state = 361, .external_lex_state = 14},
  [2987] = {.lex_state = 192, .external_lex_state = 2},
  [2988] = {.lex_state = 361, .external_lex_state = 3},
  [2989] = {.lex_state = 192, .external_lex_state = 2},
  [2990] = {.lex_state = 192, .external_lex_state = 2},
  [2991] = {.lex_state = 237},
  [2992] = {.lex_state = 192, .external_lex_state = 2},
  [2993] = {.lex_state = 358, .external_lex_state = 11},
  [2994] = {.lex_state = 361, .external_lex_state = 3},
  [2995] = {.lex_state = 361, .external_lex_state = 3},
  [2996] = {.lex_state = 361, .external_lex_state = 3},
  [2997] = {.lex_state = 371, .external_lex_state = 14},
  [2998] = {.lex_state = 361, .external_lex_state = 3},
  [2999] = {.lex_state = 192, .external_lex_state = 2},
  [3000] = {.lex_state = 192, .external_lex_state = 2},
  [3001] = {.lex_state = 192, .external_lex_state = 2},
  [3002] = {.lex_state = 192, .external_lex_state = 2},
  [3003] = {.lex_state = 192, .external_lex_state = 2},
  [3004] = {.lex_state = 192, .external_lex_state = 2},
  [3005] = {.lex_state = 192, .external_lex_state = 2},
  [3006] = {.lex_state = 192, .external_lex_state = 2},
  [3007] = {.lex_state = 192, .external_lex_state = 2},
  [3008] = {.lex_state = 192, .external_lex_state = 2},
  [3009] = {.lex_state = 192, .external_lex_state = 2},
  [3010] = {.lex_state = 192, .external_lex_state = 2},
  [3011] = {.lex_state = 192, .external_lex_state = 2},
  [3012] = {.lex_state = 237},
  [3013] = {.lex_state = 192, .external_lex_state = 2},
  [3014] = {.lex_state = 358, .external_lex_state = 11},
  [3015] = {.lex_state = 421, .external_lex_state = 3},
  [3016] = {.lex_state = 421, .external_lex_state = 3},
  [3017] = {.lex_state = 421, .external_lex_state = 3},
  [3018] = {.lex_state = 427, .external_lex_state = 14},
  [3019] = {.lex_state = 262, .external_lex_state = 3},
  [3020] = {.lex_state = 524, .external_lex_state = 13},
  [3021] = {.lex_state = 361, .external_lex_state = 3},
  [3022] = {.lex_state = 192, .external_lex_state = 29},
  [3023] = {.lex_state = 192, .external_lex_state = 2},
  [3024] = {.lex_state = 361, .external_lex_state = 14},
  [3025] = {.lex_state = 528, .external_lex_state = 3},
  [3026] = {.lex_state = 528, .external_lex_state = 3},
  [3027] = {.lex_state = 192, .external_lex_state = 2},
  [3028] = {.lex_state = 192, .external_lex_state = 2},
  [3029] = {.lex_state = 192, .external_lex_state = 2},
  [3030] = {.lex_state = 237},
  [3031] = {.lex_state = 192, .external_lex_state = 2},
  [3032] = {.lex_state = 192, .external_lex_state = 2},
  [3033] = {.lex_state = 192, .external_lex_state = 2},
  [3034] = {.lex_state = 358, .external_lex_state = 11},
  [3035] = {.lex_state = 361, .external_lex_state = 3},
  [3036] = {.lex_state = 361, .external_lex_state = 3},
  [3037] = {.lex_state = 361, .external_lex_state = 3},
  [3038] = {.lex_state = 213},
  [3039] = {.lex_state = 368, .external_lex_state = 3},
  [3040] = {.lex_state = 371, .external_lex_state = 14},
  [3041] = {.lex_state = 343, .external_lex_state = 8},
  [3042] = {.lex_state = 343, .external_lex_state = 8},
  [3043] = {.lex_state = 343, .external_lex_state = 8},
  [3044] = {.lex_state = 330},
  [3045] = {.lex_state = 350, .external_lex_state = 23},
  [3046] = {.lex_state = 343, .external_lex_state = 8},
  [3047] = {.lex_state = 528, .external_lex_state = 3},
  [3048] = {.lex_state = 128},
  [3049] = {.lex_state = 128},
  [3050] = {.lex_state = 128, .external_lex_state = 2},
  [3051] = {.lex_state = 128, .external_lex_state = 8},
  [3052] = {.lex_state = 192, .external_lex_state = 2},
  [3053] = {.lex_state = 192, .external_lex_state = 2},
  [3054] = {.lex_state = 192, .external_lex_state = 2},
  [3055] = {.lex_state = 192, .external_lex_state = 2},
  [3056] = {.lex_state = 192, .external_lex_state = 2},
  [3057] = {.lex_state = 192, .external_lex_state = 2},
  [3058] = {.lex_state = 192, .external_lex_state = 2},
  [3059] = {.lex_state = 192, .external_lex_state = 2},
  [3060] = {.lex_state = 192, .external_lex_state = 2},
  [3061] = {.lex_state = 192, .external_lex_state = 2},
  [3062] = {.lex_state = 192, .external_lex_state = 2},
  [3063] = {.lex_state = 192, .external_lex_state = 2},
  [3064] = {.lex_state = 192, .external_lex_state = 2},
  [3065] = {.lex_state = 237},
  [3066] = {.lex_state = 192, .external_lex_state = 2},
  [3067] = {.lex_state = 364, .external_lex_state = 11},
  [3068] = {.lex_state = 364, .external_lex_state = 11},
  [3069] = {.lex_state = 364, .external_lex_state = 11},
  [3070] = {.lex_state = 364, .external_lex_state = 11},
  [3071] = {.lex_state = 192, .external_lex_state = 2},
  [3072] = {.lex_state = 192, .external_lex_state = 2},
  [3073] = {.lex_state = 358, .external_lex_state = 11},
  [3074] = {.lex_state = 421, .external_lex_state = 3},
  [3075] = {.lex_state = 364, .external_lex_state = 11},
  [3076] = {.lex_state = 421, .external_lex_state = 3},
  [3077] = {.lex_state = 421, .external_lex_state = 3},
  [3078] = {.lex_state = 213},
  [3079] = {.lex_state = 421, .external_lex_state = 3},
  [3080] = {.lex_state = 427, .external_lex_state = 14},
  [3081] = {.lex_state = 192, .external_lex_state = 29},
  [3082] = {.lex_state = 353, .external_lex_state = 8},
  [3083] = {.lex_state = 192, .external_lex_state = 29},
  [3084] = {.lex_state = 192, .external_lex_state = 2},
  [3085] = {.lex_state = 361, .external_lex_state = 14},
  [3086] = {.lex_state = 247, .external_lex_state = 3},
  [3087] = {.lex_state = 192, .external_lex_state = 2},
  [3088] = {.lex_state = 192, .external_lex_state = 2},
  [3089] = {.lex_state = 192, .external_lex_state = 2},
  [3090] = {.lex_state = 237},
  [3091] = {.lex_state = 192, .external_lex_state = 2},
  [3092] = {.lex_state = 353, .external_lex_state = 11},
  [3093] = {.lex_state = 353, .external_lex_state = 11},
  [3094] = {.lex_state = 353, .external_lex_state = 11},
  [3095] = {.lex_state = 353, .external_lex_state = 11},
  [3096] = {.lex_state = 192, .external_lex_state = 2},
  [3097] = {.lex_state = 192, .external_lex_state = 2},
  [3098] = {.lex_state = 358, .external_lex_state = 11},
  [3099] = {.lex_state = 361, .external_lex_state = 3},
  [3100] = {.lex_state = 364, .external_lex_state = 11},
  [3101] = {.lex_state = 262, .external_lex_state = 3},
  [3102] = {.lex_state = 361, .external_lex_state = 3},
  [3103] = {.lex_state = 213},
  [3104] = {.lex_state = 368, .external_lex_state = 3},
  [3105] = {.lex_state = 371, .external_lex_state = 14},
  [3106] = {.lex_state = 247, .external_lex_state = 3},
  [3107] = {.lex_state = 254, .external_lex_state = 8},
  [3108] = {.lex_state = 128, .external_lex_state = 2},
  [3109] = {.lex_state = 128, .external_lex_state = 8},
  [3110] = {.lex_state = 192, .external_lex_state = 2},
  [3111] = {.lex_state = 192, .external_lex_state = 2},
  [3112] = {.lex_state = 192, .external_lex_state = 2},
  [3113] = {.lex_state = 192, .external_lex_state = 2},
  [3114] = {.lex_state = 192, .external_lex_state = 2},
  [3115] = {.lex_state = 192, .external_lex_state = 2},
  [3116] = {.lex_state = 192, .external_lex_state = 2},
  [3117] = {.lex_state = 192, .external_lex_state = 2},
  [3118] = {.lex_state = 192, .external_lex_state = 2},
  [3119] = {.lex_state = 192, .external_lex_state = 2},
  [3120] = {.lex_state = 192, .external_lex_state = 2},
  [3121] = {.lex_state = 192, .external_lex_state = 2},
  [3122] = {.lex_state = 192, .external_lex_state = 2},
  [3123] = {.lex_state = 192, .external_lex_state = 2},
  [3124] = {.lex_state = 192, .external_lex_state = 2},
  [3125] = {.lex_state = 192, .external_lex_state = 2},
  [3126] = {.lex_state = 192, .external_lex_state = 2},
  [3127] = {.lex_state = 192, .external_lex_state = 2},
  [3128] = {.lex_state = 237},
  [3129] = {.lex_state = 192, .external_lex_state = 2},
  [3130] = {.lex_state = 364, .external_lex_state = 11},
  [3131] = {.lex_state = 364, .external_lex_state = 11},
  [3132] = {.lex_state = 364, .external_lex_state = 11},
  [3133] = {.lex_state = 364, .external_lex_state = 11},
  [3134] = {.lex_state = 192, .external_lex_state = 2},
  [3135] = {.lex_state = 192, .external_lex_state = 2},
  [3136] = {.lex_state = 358, .external_lex_state = 11},
  [3137] = {.lex_state = 421, .external_lex_state = 3},
  [3138] = {.lex_state = 364, .external_lex_state = 11},
  [3139] = {.lex_state = 424, .external_lex_state = 3},
  [3140] = {.lex_state = 424, .external_lex_state = 3},
  [3141] = {.lex_state = 213},
  [3142] = {.lex_state = 421, .external_lex_state = 3},
  [3143] = {.lex_state = 427, .external_lex_state = 14},
  [3144] = {.lex_state = 192, .external_lex_state = 29},
  [3145] = {.lex_state = 192, .external_lex_state = 2},
  [3146] = {.lex_state = 262, .external_lex_state = 14},
  [3147] = {.lex_state = 128},
  [3148] = {.lex_state = 247, .external_lex_state = 3},
  [3149] = {.lex_state = 192, .external_lex_state = 2},
  [3150] = {.lex_state = 192, .external_lex_state = 2},
  [3151] = {.lex_state = 192, .external_lex_state = 2},
  [3152] = {.lex_state = 237},
  [3153] = {.lex_state = 192, .external_lex_state = 2},
  [3154] = {.lex_state = 353, .external_lex_state = 11},
  [3155] = {.lex_state = 353, .external_lex_state = 11},
  [3156] = {.lex_state = 353, .external_lex_state = 11},
  [3157] = {.lex_state = 353, .external_lex_state = 11},
  [3158] = {.lex_state = 192, .external_lex_state = 2},
  [3159] = {.lex_state = 192, .external_lex_state = 2},
  [3160] = {.lex_state = 358, .external_lex_state = 11},
  [3161] = {.lex_state = 361, .external_lex_state = 3},
  [3162] = {.lex_state = 364, .external_lex_state = 11},
  [3163] = {.lex_state = 262, .external_lex_state = 3},
  [3164] = {.lex_state = 361, .external_lex_state = 3},
  [3165] = {.lex_state = 213},
  [3166] = {.lex_state = 368, .external_lex_state = 3},
  [3167] = {.lex_state = 371, .external_lex_state = 14},
  [3168] = {.lex_state = 247, .external_lex_state = 3},
  [3169] = {.lex_state = 254, .external_lex_state = 8},
  [3170] = {.lex_state = 128, .external_lex_state = 2},
  [3171] = {.lex_state = 128, .external_lex_state = 8},
  [3172] = {.lex_state = 192, .external_lex_state = 2},
  [3173] = {.lex_state = 192, .external_lex_state = 2},
  [3174] = {.lex_state = 192, .external_lex_state = 2},
  [3175] = {.lex_state = 192, .external_lex_state = 2},
  [3176] = {.lex_state = 192, .external_lex_state = 2},
  [3177] = {.lex_state = 192, .external_lex_state = 2},
  [3178] = {.lex_state = 192, .external_lex_state = 2},
  [3179] = {.lex_state = 192, .external_lex_state = 2},
  [3180] = {.lex_state = 192, .external_lex_state = 2},
  [3181] = {.lex_state = 192, .external_lex_state = 2},
  [3182] = {.lex_state = 192, .external_lex_state = 2},
  [3183] = {.lex_state = 192, .external_lex_state = 2},
  [3184] = {.lex_state = 192, .external_lex_state = 2},
  [3185] = {.lex_state = 192, .external_lex_state = 2},
  [3186] = {.lex_state = 192, .external_lex_state = 2},
  [3187] = {.lex_state = 192, .external_lex_state = 2},
  [3188] = {.lex_state = 192, .external_lex_state = 2},
  [3189] = {.lex_state = 192, .external_lex_state = 2},
  [3190] = {.lex_state = 237},
  [3191] = {.lex_state = 192, .external_lex_state = 2},
  [3192] = {.lex_state = 364, .external_lex_state = 11},
  [3193] = {.lex_state = 364, .external_lex_state = 11},
  [3194] = {.lex_state = 364, .external_lex_state = 11},
  [3195] = {.lex_state = 364, .external_lex_state = 11},
  [3196] = {.lex_state = 192, .external_lex_state = 2},
  [3197] = {.lex_state = 192, .external_lex_state = 2},
  [3198] = {.lex_state = 358, .external_lex_state = 11},
  [3199] = {.lex_state = 421, .external_lex_state = 3},
  [3200] = {.lex_state = 364, .external_lex_state = 11},
  [3201] = {.lex_state = 424, .external_lex_state = 3},
  [3202] = {.lex_state = 424, .external_lex_state = 3},
  [3203] = {.lex_state = 213},
  [3204] = {.lex_state = 421, .external_lex_state = 3},
  [3205] = {.lex_state = 427, .external_lex_state = 14},
  [3206] = {.lex_state = 192, .external_lex_state = 29},
  [3207] = {.lex_state = 192, .external_lex_state = 2},
  [3208] = {.lex_state = 262, .external_lex_state = 14},
  [3209] = {.lex_state = 254, .external_lex_state = 8},
  [3210] = {.lex_state = 156, .external_lex_state = 3},
  [3211] = {.lex_state = 128},
  [3212] = {.lex_state = 128},
  [3213] = {.lex_state = 128, .external_lex_state = 2},
  [3214] = {.lex_state = 128, .external_lex_state = 8},
  [3215] = {.lex_state = 247, .external_lex_state = 3},
  [3216] = {.lex_state = 247, .external_lex_state = 3},
  [3217] = {.lex_state = 247, .external_lex_state = 3},
  [3218] = {.lex_state = 247, .external_lex_state = 3},
  [3219] = {.lex_state = 247, .external_lex_state = 3},
  [3220] = {.lex_state = 247, .external_lex_state = 3},
  [3221] = {.lex_state = 247, .external_lex_state = 3},
  [3222] = {.lex_state = 247, .external_lex_state = 3},
  [3223] = {.lex_state = 247, .external_lex_state = 3},
  [3224] = {.lex_state = 247, .external_lex_state = 3},
  [3225] = {.lex_state = 554, .external_lex_state = 16},
  [3226] = {.lex_state = 247, .external_lex_state = 3},
  [3227] = {.lex_state = 247, .external_lex_state = 3},
  [3228] = {.lex_state = 247, .external_lex_state = 3},
  [3229] = {.lex_state = 247, .external_lex_state = 3},
  [3230] = {.lex_state = 192, .external_lex_state = 2},
  [3231] = {.lex_state = 254, .external_lex_state = 11},
  [3232] = {.lex_state = 254, .external_lex_state = 11},
  [3233] = {.lex_state = 254, .external_lex_state = 11},
  [3234] = {.lex_state = 254, .external_lex_state = 11},
  [3235] = {.lex_state = 192, .external_lex_state = 2},
  [3236] = {.lex_state = 192, .external_lex_state = 2},
  [3237] = {.lex_state = 424, .external_lex_state = 3},
  [3238] = {.lex_state = 254, .external_lex_state = 11},
  [3239] = {.lex_state = 213},
  [3240] = {.lex_state = 424, .external_lex_state = 3},
  [3241] = {.lex_state = 424, .external_lex_state = 14},
  [3242] = {.lex_state = 424, .external_lex_state = 3},
  [3243] = {.lex_state = 421, .external_lex_state = 3},
  [3244] = {.lex_state = 421, .external_lex_state = 14},
  [3245] = {.lex_state = 192, .external_lex_state = 2},
  [3246] = {.lex_state = 424, .external_lex_state = 3},
  [3247] = {.lex_state = 421, .external_lex_state = 3},
  [3248] = {.lex_state = 192, .external_lex_state = 2},
  [3249] = {.lex_state = 192, .external_lex_state = 2},
  [3250] = {.lex_state = 192, .external_lex_state = 2},
  [3251] = {.lex_state = 192, .external_lex_state = 2},
  [3252] = {.lex_state = 192, .external_lex_state = 2},
  [3253] = {.lex_state = 192, .external_lex_state = 2},
  [3254] = {.lex_state = 192, .external_lex_state = 2},
  [3255] = {.lex_state = 192, .external_lex_state = 2},
  [3256] = {.lex_state = 192, .external_lex_state = 2},
  [3257] = {.lex_state = 192, .external_lex_state = 2},
  [3258] = {.lex_state = 192, .external_lex_state = 2},
  [3259] = {.lex_state = 424, .external_lex_state = 3},
  [3260] = {.lex_state = 524, .external_lex_state = 13},
  [3261] = {.lex_state = 424, .external_lex_state = 3},
  [3262] = {.lex_state = 192, .external_lex_state = 29},
  [3263] = {.lex_state = 192, .external_lex_state = 2},
  [3264] = {.lex_state = 421, .external_lex_state = 14},
  [3265] = {.lex_state = 192, .external_lex_state = 2},
  [3266] = {.lex_state = 192, .external_lex_state = 2},
  [3267] = {.lex_state = 192, .external_lex_state = 2},
  [3268] = {.lex_state = 192, .external_lex_state = 2},
  [3269] = {.lex_state = 528, .external_lex_state = 3},
  [3270] = {.lex_state = 528, .external_lex_state = 3},
  [3271] = {.lex_state = 213},
  [3272] = {.lex_state = 259, .external_lex_state = 3},
  [3273] = {.lex_state = 247, .external_lex_state = 3},
  [3274] = {.lex_state = 262, .external_lex_state = 14},
  [3275] = {.lex_state = 638, .external_lex_state = 8},
  [3276] = {.lex_state = 384, .external_lex_state = 8},
  [3277] = {.lex_state = 225, .external_lex_state = 7},
  [3278] = {.lex_state = 530, .external_lex_state = 27},
  [3279] = {.lex_state = 388, .external_lex_state = 25},
  [3280] = {.lex_state = 388, .external_lex_state = 25},
  [3281] = {.lex_state = 388, .external_lex_state = 25},
  [3282] = {.lex_state = 388, .external_lex_state = 25},
  [3283] = {.lex_state = 192, .external_lex_state = 15},
  [3284] = {.lex_state = 266, .external_lex_state = 15},
  [3285] = {.lex_state = 388, .external_lex_state = 25},
  [3286] = {.lex_state = 177, .external_lex_state = 4},
  [3287] = {.lex_state = 266, .external_lex_state = 15},
  [3288] = {.lex_state = 388, .external_lex_state = 25},
  [3289] = {.lex_state = 192, .external_lex_state = 15},
  [3290] = {.lex_state = 266, .external_lex_state = 15},
  [3291] = {.lex_state = 388, .external_lex_state = 25},
  [3292] = {.lex_state = 177, .external_lex_state = 4},
  [3293] = {.lex_state = 266, .external_lex_state = 15},
  [3294] = {.lex_state = 400, .external_lex_state = 25},
  [3295] = {.lex_state = 192, .external_lex_state = 2},
  [3296] = {.lex_state = 192, .external_lex_state = 2},
  [3297] = {.lex_state = 237},
  [3298] = {.lex_state = 192, .external_lex_state = 2},
  [3299] = {.lex_state = 394, .external_lex_state = 26},
  [3300] = {.lex_state = 406, .external_lex_state = 25},
  [3301] = {.lex_state = 406, .external_lex_state = 25},
  [3302] = {.lex_state = 406, .external_lex_state = 25},
  [3303] = {.lex_state = 406, .external_lex_state = 27},
  [3304] = {.lex_state = 400, .external_lex_state = 25},
  [3305] = {.lex_state = 192, .external_lex_state = 2},
  [3306] = {.lex_state = 192, .external_lex_state = 2},
  [3307] = {.lex_state = 192, .external_lex_state = 2},
  [3308] = {.lex_state = 192, .external_lex_state = 2},
  [3309] = {.lex_state = 192, .external_lex_state = 2},
  [3310] = {.lex_state = 192, .external_lex_state = 2},
  [3311] = {.lex_state = 192, .external_lex_state = 2},
  [3312] = {.lex_state = 192, .external_lex_state = 2},
  [3313] = {.lex_state = 192, .external_lex_state = 2},
  [3314] = {.lex_state = 192, .external_lex_state = 2},
  [3315] = {.lex_state = 192, .external_lex_state = 2},
  [3316] = {.lex_state = 192, .external_lex_state = 2},
  [3317] = {.lex_state = 237},
  [3318] = {.lex_state = 192, .external_lex_state = 2},
  [3319] = {.lex_state = 394, .external_lex_state = 26},
  [3320] = {.lex_state = 403, .external_lex_state = 25},
  [3321] = {.lex_state = 537, .external_lex_state = 25},
  [3322] = {.lex_state = 537, .external_lex_state = 25},
  [3323] = {.lex_state = 403, .external_lex_state = 27},
  [3324] = {.lex_state = 192, .external_lex_state = 29},
  [3325] = {.lex_state = 192, .external_lex_state = 2},
  [3326] = {.lex_state = 540, .external_lex_state = 27},
  [3327] = {.lex_state = 400, .external_lex_state = 25},
  [3328] = {.lex_state = 388, .external_lex_state = 25},
  [3329] = {.lex_state = 194},
  [3330] = {.lex_state = 302, .external_lex_state = 16},
  [3331] = {.lex_state = 225, .external_lex_state = 7},
  [3332] = {.lex_state = 128, .external_lex_state = 2},
  [3333] = {.lex_state = 388, .external_lex_state = 25},
  [3334] = {.lex_state = 247, .external_lex_state = 3},
  [3335] = {.lex_state = 128, .external_lex_state = 8},
  [3336] = {.lex_state = 128, .external_lex_state = 2},
  [3337] = {.lex_state = 388, .external_lex_state = 25},
  [3338] = {.lex_state = 128, .external_lex_state = 2},
  [3339] = {.lex_state = 406, .external_lex_state = 25},
  [3340] = {.lex_state = 406, .external_lex_state = 25},
  [3341] = {.lex_state = 406, .external_lex_state = 25},
  [3342] = {.lex_state = 192, .external_lex_state = 2},
  [3343] = {.lex_state = 406, .external_lex_state = 25},
  [3344] = {.lex_state = 406, .external_lex_state = 25},
  [3345] = {.lex_state = 192, .external_lex_state = 2},
  [3346] = {.lex_state = 192, .external_lex_state = 2},
  [3347] = {.lex_state = 192, .external_lex_state = 2},
  [3348] = {.lex_state = 192, .external_lex_state = 2},
  [3349] = {.lex_state = 192, .external_lex_state = 2},
  [3350] = {.lex_state = 192, .external_lex_state = 2},
  [3351] = {.lex_state = 192, .external_lex_state = 2},
  [3352] = {.lex_state = 192, .external_lex_state = 2},
  [3353] = {.lex_state = 192, .external_lex_state = 2},
  [3354] = {.lex_state = 192, .external_lex_state = 2},
  [3355] = {.lex_state = 192, .external_lex_state = 2},
  [3356] = {.lex_state = 406, .external_lex_state = 25},
  [3357] = {.lex_state = 524, .external_lex_state = 13},
  [3358] = {.lex_state = 406, .external_lex_state = 25},
  [3359] = {.lex_state = 192, .external_lex_state = 29},
  [3360] = {.lex_state = 192, .external_lex_state = 2},
  [3361] = {.lex_state = 128, .external_lex_state = 12},
  [3362] = {.lex_state = 128, .external_lex_state = 2},
  [3363] = {.lex_state = 128, .external_lex_state = 2},
  [3364] = {.lex_state = 128, .external_lex_state = 2},
  [3365] = {.lex_state = 128, .external_lex_state = 8},
  [3366] = {.lex_state = 128},
  [3367] = {.lex_state = 128},
  [3368] = {.lex_state = 128},
  [3369] = {.lex_state = 388, .external_lex_state = 25},
  [3370] = {.lex_state = 128},
  [3371] = {.lex_state = 128},
  [3372] = {.lex_state = 128},
  [3373] = {.lex_state = 388, .external_lex_state = 25},
  [3374] = {.lex_state = 400, .external_lex_state = 25},
  [3375] = {.lex_state = 388, .external_lex_state = 25},
  [3376] = {.lex_state = 235},
  [3377] = {.lex_state = 388, .external_lex_state = 25},
  [3378] = {.lex_state = 194},
  [3379] = {.lex_state = 286, .external_lex_state = 2},
  [3380] = {.lex_state = 388, .external_lex_state = 25},
  [3381] = {.lex_state = 128},
  [3382] = {.lex_state = 128, .external_lex_state = 12},
  [3383] = {.lex_state = 414, .external_lex_state = 2},
  [3384] = {.lex_state = 388, .external_lex_state = 25},
  [3385] = {.lex_state = 400, .external_lex_state = 25},
  [3386] = {.lex_state = 400, .external_lex_state = 25},
  [3387] = {.lex_state = 400, .external_lex_state = 25},
  [3388] = {.lex_state = 400, .external_lex_state = 25},
  [3389] = {.lex_state = 400, .external_lex_state = 25},
  [3390] = {.lex_state = 554, .external_lex_state = 16},
  [3391] = {.lex_state = 400, .external_lex_state = 25},
  [3392] = {.lex_state = 400, .external_lex_state = 25},
  [3393] = {.lex_state = 400, .external_lex_state = 25},
  [3394] = {.lex_state = 400, .external_lex_state = 25},
  [3395] = {.lex_state = 544, .external_lex_state = 26},
  [3396] = {.lex_state = 356, .external_lex_state = 13},
  [3397] = {.lex_state = 544, .external_lex_state = 26},
  [3398] = {.lex_state = 544, .external_lex_state = 26},
  [3399] = {.lex_state = 416, .external_lex_state = 28},
  [3400] = {.lex_state = 397, .external_lex_state = 25},
  [3401] = {.lex_state = 235, .external_lex_state = 19},
  [3402] = {.lex_state = 235},
  [3403] = {.lex_state = 544, .external_lex_state = 26},
  [3404] = {.lex_state = 403, .external_lex_state = 25},
  [3405] = {.lex_state = 640, .external_lex_state = 27},
  [3406] = {.lex_state = 403, .external_lex_state = 25},
  [3407] = {.lex_state = 403, .external_lex_state = 25},
  [3408] = {.lex_state = 192, .external_lex_state = 2},
  [3409] = {.lex_state = 397, .external_lex_state = 25},
  [3410] = {.lex_state = 194},
  [3411] = {.lex_state = 286, .external_lex_state = 2},
  [3412] = {.lex_state = 403, .external_lex_state = 25},
  [3413] = {.lex_state = 397, .external_lex_state = 25},
  [3414] = {.lex_state = 128},
  [3415] = {.lex_state = 128, .external_lex_state = 12},
  [3416] = {.lex_state = 414, .external_lex_state = 2},
  [3417] = {.lex_state = 403, .external_lex_state = 25},
  [3418] = {.lex_state = 192, .external_lex_state = 2},
  [3419] = {.lex_state = 192, .external_lex_state = 2},
  [3420] = {.lex_state = 192, .external_lex_state = 2},
  [3421] = {.lex_state = 192, .external_lex_state = 2},
  [3422] = {.lex_state = 192, .external_lex_state = 2},
  [3423] = {.lex_state = 192, .external_lex_state = 2},
  [3424] = {.lex_state = 192, .external_lex_state = 2},
  [3425] = {.lex_state = 192, .external_lex_state = 2},
  [3426] = {.lex_state = 192, .external_lex_state = 2},
  [3427] = {.lex_state = 192, .external_lex_state = 2},
  [3428] = {.lex_state = 192, .external_lex_state = 2},
  [3429] = {.lex_state = 397, .external_lex_state = 25},
  [3430] = {.lex_state = 403, .external_lex_state = 25},
  [3431] = {.lex_state = 524, .external_lex_state = 13},
  [3432] = {.lex_state = 403, .external_lex_state = 25},
  [3433] = {.lex_state = 192, .external_lex_state = 29},
  [3434] = {.lex_state = 192, .external_lex_state = 2},
  [3435] = {.lex_state = 640, .external_lex_state = 27},
  [3436] = {.lex_state = 156, .external_lex_state = 3},
  [3437] = {.lex_state = 177, .external_lex_state = 17},
  [3438] = {.lex_state = 641, .external_lex_state = 19},
  [3439] = {.lex_state = 235, .external_lex_state = 13},
  [3440] = {.lex_state = 192, .external_lex_state = 2},
  [3441] = {.lex_state = 400, .external_lex_state = 25},
  [3442] = {.lex_state = 547, .external_lex_state = 25},
  [3443] = {.lex_state = 400, .external_lex_state = 25},
  [3444] = {.lex_state = 400, .external_lex_state = 25},
  [3445] = {.lex_state = 543, .external_lex_state = 27},
  [3446] = {.lex_state = 237},
  [3447] = {.lex_state = 286, .external_lex_state = 2},
  [3448] = {.lex_state = 128},
  [3449] = {.lex_state = 237},
  [3450] = {.lex_state = 237},
  [3451] = {.lex_state = 156, .external_lex_state = 3},
  [3452] = {.lex_state = 194},
  [3453] = {.lex_state = 302},
  [3454] = {.lex_state = 643, .external_lex_state = 2},
  [3455] = {.lex_state = 192, .external_lex_state = 2},
  [3456] = {.lex_state = 128},
  [3457] = {.lex_state = 197},
  [3458] = {.lex_state = 302},
  [3459] = {.lex_state = 237},
  [3460] = {.lex_state = 128, .external_lex_state = 12},
  [3461] = {.lex_state = 128},
  [3462] = {.lex_state = 237},
  [3463] = {.lex_state = 156, .external_lex_state = 3},
  [3464] = {.lex_state = 128},
  [3465] = {.lex_state = 128, .external_lex_state = 2},
  [3466] = {.lex_state = 128, .external_lex_state = 12},
  [3467] = {.lex_state = 192, .external_lex_state = 2},
  [3468] = {.lex_state = 615, .external_lex_state = 18},
  [3469] = {.lex_state = 615, .external_lex_state = 18},
  [3470] = {.lex_state = 615, .external_lex_state = 18},
  [3471] = {.lex_state = 615, .external_lex_state = 18},
  [3472] = {.lex_state = 192, .external_lex_state = 2},
  [3473] = {.lex_state = 192, .external_lex_state = 2},
  [3474] = {.lex_state = 302, .external_lex_state = 16},
  [3475] = {.lex_state = 618, .external_lex_state = 18},
  [3476] = {.lex_state = 213},
  [3477] = {.lex_state = 227, .external_lex_state = 16},
  [3478] = {.lex_state = 251, .external_lex_state = 20},
  [3479] = {.lex_state = 302, .external_lex_state = 16},
  [3480] = {.lex_state = 156},
  [3481] = {.lex_state = 156},
  [3482] = {.lex_state = 241},
  [3483] = {.lex_state = 128, .external_lex_state = 2},
  [3484] = {.lex_state = 645, .external_lex_state = 20},
  [3485] = {.lex_state = 192, .external_lex_state = 15},
  [3486] = {.lex_state = 554, .external_lex_state = 16},
  [3487] = {.lex_state = 192, .external_lex_state = 2},
  [3488] = {.lex_state = 192, .external_lex_state = 2},
  [3489] = {.lex_state = 192, .external_lex_state = 2},
  [3490] = {.lex_state = 237},
  [3491] = {.lex_state = 192, .external_lex_state = 2},
  [3492] = {.lex_state = 648, .external_lex_state = 26},
  [3493] = {.lex_state = 648, .external_lex_state = 26},
  [3494] = {.lex_state = 648, .external_lex_state = 26},
  [3495] = {.lex_state = 648, .external_lex_state = 26},
  [3496] = {.lex_state = 192, .external_lex_state = 2},
  [3497] = {.lex_state = 192, .external_lex_state = 2},
  [3498] = {.lex_state = 651, .external_lex_state = 26},
  [3499] = {.lex_state = 654, .external_lex_state = 25},
  [3500] = {.lex_state = 657, .external_lex_state = 26},
  [3501] = {.lex_state = 562, .external_lex_state = 25},
  [3502] = {.lex_state = 645, .external_lex_state = 25},
  [3503] = {.lex_state = 213},
  [3504] = {.lex_state = 658, .external_lex_state = 25},
  [3505] = {.lex_state = 661, .external_lex_state = 27},
  [3506] = {.lex_state = 554, .external_lex_state = 16},
  [3507] = {.lex_state = 192, .external_lex_state = 2},
  [3508] = {.lex_state = 192, .external_lex_state = 2},
  [3509] = {.lex_state = 192, .external_lex_state = 2},
  [3510] = {.lex_state = 192, .external_lex_state = 2},
  [3511] = {.lex_state = 192, .external_lex_state = 2},
  [3512] = {.lex_state = 192, .external_lex_state = 2},
  [3513] = {.lex_state = 192, .external_lex_state = 2},
  [3514] = {.lex_state = 192, .external_lex_state = 2},
  [3515] = {.lex_state = 192, .external_lex_state = 2},
  [3516] = {.lex_state = 192, .external_lex_state = 2},
  [3517] = {.lex_state = 192, .external_lex_state = 2},
  [3518] = {.lex_state = 192, .external_lex_state = 2},
  [3519] = {.lex_state = 192, .external_lex_state = 2},
  [3520] = {.lex_state = 192, .external_lex_state = 2},
  [3521] = {.lex_state = 237},
  [3522] = {.lex_state = 192, .external_lex_state = 2},
  [3523] = {.lex_state = 657, .external_lex_state = 26},
  [3524] = {.lex_state = 657, .external_lex_state = 26},
  [3525] = {.lex_state = 657, .external_lex_state = 26},
  [3526] = {.lex_state = 657, .external_lex_state = 26},
  [3527] = {.lex_state = 192, .external_lex_state = 2},
  [3528] = {.lex_state = 192, .external_lex_state = 2},
  [3529] = {.lex_state = 651, .external_lex_state = 26},
  [3530] = {.lex_state = 658, .external_lex_state = 25},
  [3531] = {.lex_state = 657, .external_lex_state = 26},
  [3532] = {.lex_state = 559, .external_lex_state = 25},
  [3533] = {.lex_state = 559, .external_lex_state = 25},
  [3534] = {.lex_state = 213},
  [3535] = {.lex_state = 658, .external_lex_state = 25},
  [3536] = {.lex_state = 662, .external_lex_state = 27},
  [3537] = {.lex_state = 192, .external_lex_state = 29},
  [3538] = {.lex_state = 192, .external_lex_state = 2},
  [3539] = {.lex_state = 562, .external_lex_state = 20},
  [3540] = {.lex_state = 416, .external_lex_state = 28},
  [3541] = {.lex_state = 177, .external_lex_state = 17},
  [3542] = {.lex_state = 327, .external_lex_state = 11},
  [3543] = {.lex_state = 209, .external_lex_state = 19},
  [3544] = {.lex_state = 209},
  [3545] = {.lex_state = 327, .external_lex_state = 11},
  [3546] = {.lex_state = 416, .external_lex_state = 28},
  [3547] = {.lex_state = 227, .external_lex_state = 3},
  [3548] = {.lex_state = 235},
  [3549] = {.lex_state = 565, .external_lex_state = 14},
  [3550] = {.lex_state = 299, .external_lex_state = 3},
  [3551] = {.lex_state = 299, .external_lex_state = 3},
  [3552] = {.lex_state = 299, .external_lex_state = 3},
  [3553] = {.lex_state = 299, .external_lex_state = 3},
  [3554] = {.lex_state = 192, .external_lex_state = 15},
  [3555] = {.lex_state = 266, .external_lex_state = 15},
  [3556] = {.lex_state = 299, .external_lex_state = 3},
  [3557] = {.lex_state = 177, .external_lex_state = 4},
  [3558] = {.lex_state = 266, .external_lex_state = 15},
  [3559] = {.lex_state = 299, .external_lex_state = 3},
  [3560] = {.lex_state = 192, .external_lex_state = 15},
  [3561] = {.lex_state = 266, .external_lex_state = 15},
  [3562] = {.lex_state = 299, .external_lex_state = 3},
  [3563] = {.lex_state = 177, .external_lex_state = 4},
  [3564] = {.lex_state = 266, .external_lex_state = 15},
  [3565] = {.lex_state = 227, .external_lex_state = 14},
  [3566] = {.lex_state = 192, .external_lex_state = 15},
  [3567] = {.lex_state = 227, .external_lex_state = 3},
  [3568] = {.lex_state = 192, .external_lex_state = 15},
  [3569] = {.lex_state = 227, .external_lex_state = 3},
  [3570] = {.lex_state = 192, .external_lex_state = 15},
  [3571] = {.lex_state = 227, .external_lex_state = 3},
  [3572] = {.lex_state = 192, .external_lex_state = 15},
  [3573] = {.lex_state = 227, .external_lex_state = 3},
  [3574] = {.lex_state = 190, .external_lex_state = 4},
  [3575] = {.lex_state = 266, .external_lex_state = 15},
  [3576] = {.lex_state = 227, .external_lex_state = 3},
  [3577] = {.lex_state = 190, .external_lex_state = 4},
  [3578] = {.lex_state = 266, .external_lex_state = 15},
  [3579] = {.lex_state = 424, .external_lex_state = 3},
  [3580] = {.lex_state = 227, .external_lex_state = 3},
  [3581] = {.lex_state = 194},
  [3582] = {.lex_state = 194, .external_lex_state = 19},
  [3583] = {.lex_state = 192, .external_lex_state = 2},
  [3584] = {.lex_state = 227, .external_lex_state = 3},
  [3585] = {.lex_state = 310},
  [3586] = {.lex_state = 310, .external_lex_state = 8},
  [3587] = {.lex_state = 227, .external_lex_state = 3},
  [3588] = {.lex_state = 209},
  [3589] = {.lex_state = 192, .external_lex_state = 2},
  [3590] = {.lex_state = 346, .external_lex_state = 23},
  [3591] = {.lex_state = 346, .external_lex_state = 23},
  [3592] = {.lex_state = 350, .external_lex_state = 23},
  [3593] = {.lex_state = 350, .external_lex_state = 23},
  [3594] = {.lex_state = 227, .external_lex_state = 3},
  [3595] = {.lex_state = 227, .external_lex_state = 3},
  [3596] = {.lex_state = 227, .external_lex_state = 3},
  [3597] = {.lex_state = 227, .external_lex_state = 3},
  [3598] = {.lex_state = 128, .external_lex_state = 8},
  [3599] = {.lex_state = 128, .external_lex_state = 8},
  [3600] = {.lex_state = 247, .external_lex_state = 3},
  [3601] = {.lex_state = 247, .external_lex_state = 3},
  [3602] = {.lex_state = 128},
  [3603] = {.lex_state = 247, .external_lex_state = 3},
  [3604] = {.lex_state = 128},
  [3605] = {.lex_state = 128},
  [3606] = {.lex_state = 128},
  [3607] = {.lex_state = 128},
  [3608] = {.lex_state = 128},
  [3609] = {.lex_state = 227, .external_lex_state = 3},
  [3610] = {.lex_state = 128, .external_lex_state = 2},
  [3611] = {.lex_state = 424, .external_lex_state = 3},
  [3612] = {.lex_state = 227, .external_lex_state = 3},
  [3613] = {.lex_state = 227, .external_lex_state = 3},
  [3614] = {.lex_state = 227, .external_lex_state = 3},
  [3615] = {.lex_state = 235, .external_lex_state = 19},
  [3616] = {.lex_state = 235},
  [3617] = {.lex_state = 128},
  [3618] = {.lex_state = 227, .external_lex_state = 3},
  [3619] = {.lex_state = 192, .external_lex_state = 2},
  [3620] = {.lex_state = 192, .external_lex_state = 2},
  [3621] = {.lex_state = 192, .external_lex_state = 2},
  [3622] = {.lex_state = 192, .external_lex_state = 2},
  [3623] = {.lex_state = 192, .external_lex_state = 2},
  [3624] = {.lex_state = 192, .external_lex_state = 2},
  [3625] = {.lex_state = 192, .external_lex_state = 2},
  [3626] = {.lex_state = 192, .external_lex_state = 2},
  [3627] = {.lex_state = 192, .external_lex_state = 2},
  [3628] = {.lex_state = 192, .external_lex_state = 2},
  [3629] = {.lex_state = 419, .external_lex_state = 6},
  [3630] = {.lex_state = 192, .external_lex_state = 29},
  [3631] = {.lex_state = 192, .external_lex_state = 2},
  [3632] = {.lex_state = 424, .external_lex_state = 14},
  [3633] = {.lex_state = 299, .external_lex_state = 3},
  [3634] = {.lex_state = 424, .external_lex_state = 3},
  [3635] = {.lex_state = 436, .external_lex_state = 3},
  [3636] = {.lex_state = 455, .external_lex_state = 14},
  [3637] = {.lex_state = 192, .external_lex_state = 2},
  [3638] = {.lex_state = 192, .external_lex_state = 2},
  [3639] = {.lex_state = 237},
  [3640] = {.lex_state = 192, .external_lex_state = 2},
  [3641] = {.lex_state = 569, .external_lex_state = 11},
  [3642] = {.lex_state = 588, .external_lex_state = 3},
  [3643] = {.lex_state = 455, .external_lex_state = 3},
  [3644] = {.lex_state = 588, .external_lex_state = 3},
  [3645] = {.lex_state = 588, .external_lex_state = 14},
  [3646] = {.lex_state = 436, .external_lex_state = 3},
  [3647] = {.lex_state = 227, .external_lex_state = 3},
  [3648] = {.lex_state = 194},
  [3649] = {.lex_state = 192, .external_lex_state = 2},
  [3650] = {.lex_state = 192, .external_lex_state = 2},
  [3651] = {.lex_state = 192, .external_lex_state = 2},
  [3652] = {.lex_state = 192, .external_lex_state = 2},
  [3653] = {.lex_state = 192, .external_lex_state = 2},
  [3654] = {.lex_state = 192, .external_lex_state = 2},
  [3655] = {.lex_state = 192, .external_lex_state = 2},
  [3656] = {.lex_state = 192, .external_lex_state = 2},
  [3657] = {.lex_state = 192, .external_lex_state = 2},
  [3658] = {.lex_state = 192, .external_lex_state = 2},
  [3659] = {.lex_state = 192, .external_lex_state = 2},
  [3660] = {.lex_state = 192, .external_lex_state = 2},
  [3661] = {.lex_state = 237},
  [3662] = {.lex_state = 192, .external_lex_state = 2},
  [3663] = {.lex_state = 569, .external_lex_state = 11},
  [3664] = {.lex_state = 573, .external_lex_state = 3},
  [3665] = {.lex_state = 573, .external_lex_state = 3},
  [3666] = {.lex_state = 573, .external_lex_state = 3},
  [3667] = {.lex_state = 573, .external_lex_state = 14},
  [3668] = {.lex_state = 192, .external_lex_state = 29},
  [3669] = {.lex_state = 192, .external_lex_state = 2},
  [3670] = {.lex_state = 455, .external_lex_state = 14},
  [3671] = {.lex_state = 299, .external_lex_state = 3},
  [3672] = {.lex_state = 194},
  [3673] = {.lex_state = 302, .external_lex_state = 16},
  [3674] = {.lex_state = 225, .external_lex_state = 7},
  [3675] = {.lex_state = 128, .external_lex_state = 2},
  [3676] = {.lex_state = 299, .external_lex_state = 3},
  [3677] = {.lex_state = 247, .external_lex_state = 3},
  [3678] = {.lex_state = 128, .external_lex_state = 8},
  [3679] = {.lex_state = 128, .external_lex_state = 2},
  [3680] = {.lex_state = 299, .external_lex_state = 3},
  [3681] = {.lex_state = 128, .external_lex_state = 2},
  [3682] = {.lex_state = 128, .external_lex_state = 12},
  [3683] = {.lex_state = 128, .external_lex_state = 2},
  [3684] = {.lex_state = 128, .external_lex_state = 2},
  [3685] = {.lex_state = 128, .external_lex_state = 2},
  [3686] = {.lex_state = 128, .external_lex_state = 8},
  [3687] = {.lex_state = 227, .external_lex_state = 3},
  [3688] = {.lex_state = 128},
  [3689] = {.lex_state = 128, .external_lex_state = 2},
  [3690] = {.lex_state = 128, .external_lex_state = 12},
  [3691] = {.lex_state = 128},
  [3692] = {.lex_state = 128},
  [3693] = {.lex_state = 128},
  [3694] = {.lex_state = 299, .external_lex_state = 3},
  [3695] = {.lex_state = 128},
  [3696] = {.lex_state = 128},
  [3697] = {.lex_state = 128},
  [3698] = {.lex_state = 299, .external_lex_state = 3},
  [3699] = {.lex_state = 227, .external_lex_state = 3},
  [3700] = {.lex_state = 209},
  [3701] = {.lex_state = 424, .external_lex_state = 3},
  [3702] = {.lex_state = 299, .external_lex_state = 3},
  [3703] = {.lex_state = 235},
  [3704] = {.lex_state = 299, .external_lex_state = 3},
  [3705] = {.lex_state = 299, .external_lex_state = 3},
  [3706] = {.lex_state = 421, .external_lex_state = 3},
  [3707] = {.lex_state = 421, .external_lex_state = 3},
  [3708] = {.lex_state = 421, .external_lex_state = 3},
  [3709] = {.lex_state = 421, .external_lex_state = 3},
  [3710] = {.lex_state = 421, .external_lex_state = 3},
  [3711] = {.lex_state = 554, .external_lex_state = 16},
  [3712] = {.lex_state = 421, .external_lex_state = 3},
  [3713] = {.lex_state = 421, .external_lex_state = 3},
  [3714] = {.lex_state = 421, .external_lex_state = 3},
  [3715] = {.lex_state = 421, .external_lex_state = 3},
  [3716] = {.lex_state = 227, .external_lex_state = 3},
  [3717] = {.lex_state = 227, .external_lex_state = 3},
  [3718] = {.lex_state = 177, .external_lex_state = 17},
  [3719] = {.lex_state = 424, .external_lex_state = 3},
  [3720] = {.lex_state = 227, .external_lex_state = 3},
  [3721] = {.lex_state = 524, .external_lex_state = 21},
  [3722] = {.lex_state = 424, .external_lex_state = 3},
  [3723] = {.lex_state = 424, .external_lex_state = 3},
  [3724] = {.lex_state = 421, .external_lex_state = 3},
  [3725] = {.lex_state = 299, .external_lex_state = 3},
  [3726] = {.lex_state = 421, .external_lex_state = 3},
  [3727] = {.lex_state = 421, .external_lex_state = 3},
  [3728] = {.lex_state = 421, .external_lex_state = 14},
  [3729] = {.lex_state = 577, .external_lex_state = 3},
  [3730] = {.lex_state = 577, .external_lex_state = 3},
  [3731] = {.lex_state = 577, .external_lex_state = 3},
  [3732] = {.lex_state = 192, .external_lex_state = 2},
  [3733] = {.lex_state = 192, .external_lex_state = 2},
  [3734] = {.lex_state = 192, .external_lex_state = 2},
  [3735] = {.lex_state = 192, .external_lex_state = 2},
  [3736] = {.lex_state = 192, .external_lex_state = 2},
  [3737] = {.lex_state = 192, .external_lex_state = 2},
  [3738] = {.lex_state = 192, .external_lex_state = 2},
  [3739] = {.lex_state = 192, .external_lex_state = 2},
  [3740] = {.lex_state = 192, .external_lex_state = 2},
  [3741] = {.lex_state = 192, .external_lex_state = 2},
  [3742] = {.lex_state = 192, .external_lex_state = 29},
  [3743] = {.lex_state = 577, .external_lex_state = 3},
  [3744] = {.lex_state = 192, .external_lex_state = 29},
  [3745] = {.lex_state = 192, .external_lex_state = 2},
  [3746] = {.lex_state = 192, .external_lex_state = 2},
  [3747] = {.lex_state = 458, .external_lex_state = 26},
  [3748] = {.lex_state = 458, .external_lex_state = 26},
  [3749] = {.lex_state = 458, .external_lex_state = 26},
  [3750] = {.lex_state = 458, .external_lex_state = 26},
  [3751] = {.lex_state = 192, .external_lex_state = 2},
  [3752] = {.lex_state = 192, .external_lex_state = 2},
  [3753] = {.lex_state = 467, .external_lex_state = 25},
  [3754] = {.lex_state = 438, .external_lex_state = 26},
  [3755] = {.lex_state = 213},
  [3756] = {.lex_state = 441, .external_lex_state = 25},
  [3757] = {.lex_state = 467, .external_lex_state = 27},
  [3758] = {.lex_state = 467, .external_lex_state = 25},
  [3759] = {.lex_state = 588, .external_lex_state = 25},
  [3760] = {.lex_state = 663, .external_lex_state = 27},
  [3761] = {.lex_state = 192, .external_lex_state = 2},
  [3762] = {.lex_state = 467, .external_lex_state = 25},
  [3763] = {.lex_state = 192, .external_lex_state = 2},
  [3764] = {.lex_state = 192, .external_lex_state = 2},
  [3765] = {.lex_state = 237},
  [3766] = {.lex_state = 192, .external_lex_state = 2},
  [3767] = {.lex_state = 585, .external_lex_state = 26},
  [3768] = {.lex_state = 588, .external_lex_state = 25},
  [3769] = {.lex_state = 588, .external_lex_state = 25},
  [3770] = {.lex_state = 588, .external_lex_state = 25},
  [3771] = {.lex_state = 588, .external_lex_state = 27},
  [3772] = {.lex_state = 588, .external_lex_state = 25},
  [3773] = {.lex_state = 192, .external_lex_state = 2},
  [3774] = {.lex_state = 192, .external_lex_state = 2},
  [3775] = {.lex_state = 192, .external_lex_state = 2},
  [3776] = {.lex_state = 192, .external_lex_state = 2},
  [3777] = {.lex_state = 192, .external_lex_state = 2},
  [3778] = {.lex_state = 192, .external_lex_state = 2},
  [3779] = {.lex_state = 192, .external_lex_state = 2},
  [3780] = {.lex_state = 192, .external_lex_state = 2},
  [3781] = {.lex_state = 192, .external_lex_state = 2},
  [3782] = {.lex_state = 192, .external_lex_state = 2},
  [3783] = {.lex_state = 192, .external_lex_state = 2},
  [3784] = {.lex_state = 192, .external_lex_state = 2},
  [3785] = {.lex_state = 192, .external_lex_state = 2},
  [3786] = {.lex_state = 237},
  [3787] = {.lex_state = 192, .external_lex_state = 2},
  [3788] = {.lex_state = 585, .external_lex_state = 26},
  [3789] = {.lex_state = 573, .external_lex_state = 25},
  [3790] = {.lex_state = 573, .external_lex_state = 25},
  [3791] = {.lex_state = 573, .external_lex_state = 25},
  [3792] = {.lex_state = 573, .external_lex_state = 27},
  [3793] = {.lex_state = 444, .external_lex_state = 25},
  [3794] = {.lex_state = 524, .external_lex_state = 13},
  [3795] = {.lex_state = 467, .external_lex_state = 25},
  [3796] = {.lex_state = 192, .external_lex_state = 29},
  [3797] = {.lex_state = 192, .external_lex_state = 2},
  [3798] = {.lex_state = 663, .external_lex_state = 27},
  [3799] = {.lex_state = 237},
  [3800] = {.lex_state = 225, .external_lex_state = 7},
  [3801] = {.lex_state = 237},
  [3802] = {.lex_state = 194},
  [3803] = {.lex_state = 436, .external_lex_state = 16},
  [3804] = {.lex_state = 436, .external_lex_state = 16},
  [3805] = {.lex_state = 436, .external_lex_state = 16},
  [3806] = {.lex_state = 436, .external_lex_state = 16},
  [3807] = {.lex_state = 436, .external_lex_state = 16},
  [3808] = {.lex_state = 436, .external_lex_state = 16},
  [3809] = {.lex_state = 436, .external_lex_state = 16},
  [3810] = {.lex_state = 436, .external_lex_state = 16},
  [3811] = {.lex_state = 436, .external_lex_state = 16},
  [3812] = {.lex_state = 436, .external_lex_state = 16},
  [3813] = {.lex_state = 554, .external_lex_state = 16},
  [3814] = {.lex_state = 436, .external_lex_state = 16},
  [3815] = {.lex_state = 436, .external_lex_state = 16},
  [3816] = {.lex_state = 436, .external_lex_state = 16},
  [3817] = {.lex_state = 436, .external_lex_state = 16},
  [3818] = {.lex_state = 579, .external_lex_state = 18},
  [3819] = {.lex_state = 356, .external_lex_state = 13},
  [3820] = {.lex_state = 579, .external_lex_state = 18},
  [3821] = {.lex_state = 579, .external_lex_state = 18},
  [3822] = {.lex_state = 416, .external_lex_state = 28},
  [3823] = {.lex_state = 433, .external_lex_state = 16},
  [3824] = {.lex_state = 235, .external_lex_state = 19},
  [3825] = {.lex_state = 235},
  [3826] = {.lex_state = 579, .external_lex_state = 18},
  [3827] = {.lex_state = 461, .external_lex_state = 25},
  [3828] = {.lex_state = 177, .external_lex_state = 4},
  [3829] = {.lex_state = 177, .external_lex_state = 4},
  [3830] = {.lex_state = 177, .external_lex_state = 4},
  [3831] = {.lex_state = 177, .external_lex_state = 4},
  [3832] = {.lex_state = 190, .external_lex_state = 4},
  [3833] = {.lex_state = 190, .external_lex_state = 4},
  [3834] = {.lex_state = 192, .external_lex_state = 2},
  [3835] = {.lex_state = 194, .external_lex_state = 6},
  [3836] = {.lex_state = 197, .external_lex_state = 7},
  [3837] = {.lex_state = 209, .external_lex_state = 2},
  [3838] = {.lex_state = 216, .external_lex_state = 10},
  [3839] = {.lex_state = 216, .external_lex_state = 9},
  [3840] = {.lex_state = 438, .external_lex_state = 26},
  [3841] = {.lex_state = 438, .external_lex_state = 26},
  [3842] = {.lex_state = 438, .external_lex_state = 26},
  [3843] = {.lex_state = 438, .external_lex_state = 26},
  [3844] = {.lex_state = 221, .external_lex_state = 2},
  [3845] = {.lex_state = 221, .external_lex_state = 2},
  [3846] = {.lex_state = 192, .external_lex_state = 2},
  [3847] = {.lex_state = 192, .external_lex_state = 2},
  [3848] = {.lex_state = 223, .external_lex_state = 9},
  [3849] = {.lex_state = 221, .external_lex_state = 12},
  [3850] = {.lex_state = 128, .external_lex_state = 12},
  [3851] = {.lex_state = 192, .external_lex_state = 2},
  [3852] = {.lex_state = 192, .external_lex_state = 2},
  [3853] = {.lex_state = 461, .external_lex_state = 25},
  [3854] = {.lex_state = 235, .external_lex_state = 13},
  [3855] = {.lex_state = 237},
  [3856] = {.lex_state = 441, .external_lex_state = 25},
  [3857] = {.lex_state = 461, .external_lex_state = 25},
  [3858] = {.lex_state = 438, .external_lex_state = 26},
  [3859] = {.lex_state = 213},
  [3860] = {.lex_state = 441, .external_lex_state = 25},
  [3861] = {.lex_state = 441, .external_lex_state = 27},
  [3862] = {.lex_state = 441, .external_lex_state = 25},
  [3863] = {.lex_state = 573, .external_lex_state = 25},
  [3864] = {.lex_state = 664, .external_lex_state = 27},
  [3865] = {.lex_state = 192, .external_lex_state = 2},
  [3866] = {.lex_state = 665, .external_lex_state = 25},
  [3867] = {.lex_state = 194},
  [3868] = {.lex_state = 286, .external_lex_state = 2},
  [3869] = {.lex_state = 441, .external_lex_state = 25},
  [3870] = {.lex_state = 433, .external_lex_state = 16},
  [3871] = {.lex_state = 128},
  [3872] = {.lex_state = 128, .external_lex_state = 12},
  [3873] = {.lex_state = 414, .external_lex_state = 2},
  [3874] = {.lex_state = 461, .external_lex_state = 25},
  [3875] = {.lex_state = 209, .external_lex_state = 19},
  [3876] = {.lex_state = 209},
  [3877] = {.lex_state = 573, .external_lex_state = 25},
  [3878] = {.lex_state = 192, .external_lex_state = 2},
  [3879] = {.lex_state = 192, .external_lex_state = 2},
  [3880] = {.lex_state = 192, .external_lex_state = 2},
  [3881] = {.lex_state = 192, .external_lex_state = 2},
  [3882] = {.lex_state = 192, .external_lex_state = 2},
  [3883] = {.lex_state = 192, .external_lex_state = 2},
  [3884] = {.lex_state = 192, .external_lex_state = 2},
  [3885] = {.lex_state = 192, .external_lex_state = 2},
  [3886] = {.lex_state = 192, .external_lex_state = 2},
  [3887] = {.lex_state = 192, .external_lex_state = 2},
  [3888] = {.lex_state = 192, .external_lex_state = 2},
  [3889] = {.lex_state = 409, .external_lex_state = 2},
  [3890] = {.lex_state = 433, .external_lex_state = 16},
  [3891] = {.lex_state = 177, .external_lex_state = 17},
  [3892] = {.lex_state = 441, .external_lex_state = 25},
  [3893] = {.lex_state = 524, .external_lex_state = 13},
  [3894] = {.lex_state = 441, .external_lex_state = 25},
  [3895] = {.lex_state = 192, .external_lex_state = 29},
  [3896] = {.lex_state = 192, .external_lex_state = 2},
  [3897] = {.lex_state = 664, .external_lex_state = 27},
  [3898] = {.lex_state = 192, .external_lex_state = 2},
  [3899] = {.lex_state = 192, .external_lex_state = 2},
  [3900] = {.lex_state = 458, .external_lex_state = 18},
  [3901] = {.lex_state = 458, .external_lex_state = 18},
  [3902] = {.lex_state = 458, .external_lex_state = 18},
  [3903] = {.lex_state = 458, .external_lex_state = 18},
  [3904] = {.lex_state = 192, .external_lex_state = 2},
  [3905] = {.lex_state = 192, .external_lex_state = 2},
  [3906] = {.lex_state = 436, .external_lex_state = 16},
  [3907] = {.lex_state = 436, .external_lex_state = 16},
  [3908] = {.lex_state = 213},
  [3909] = {.lex_state = 441, .external_lex_state = 16},
  [3910] = {.lex_state = 467, .external_lex_state = 20},
  [3911] = {.lex_state = 436, .external_lex_state = 16},
  [3912] = {.lex_state = 444, .external_lex_state = 20},
  [3913] = {.lex_state = 156, .external_lex_state = 3},
  [3914] = {.lex_state = 177, .external_lex_state = 4},
  [3915] = {.lex_state = 156, .external_lex_state = 3},
  [3916] = {.lex_state = 177, .external_lex_state = 30},
  [3917] = {.lex_state = 156, .external_lex_state = 3},
  [3918] = {.lex_state = 177, .external_lex_state = 4},
  [3919] = {.lex_state = 156, .external_lex_state = 3},
  [3920] = {.lex_state = 177, .external_lex_state = 30},
  [3921] = {.lex_state = 192, .external_lex_state = 2},
  [3922] = {.lex_state = 668, .external_lex_state = 11},
  [3923] = {.lex_state = 668, .external_lex_state = 11},
  [3924] = {.lex_state = 668, .external_lex_state = 11},
  [3925] = {.lex_state = 668, .external_lex_state = 11},
  [3926] = {.lex_state = 192, .external_lex_state = 2},
  [3927] = {.lex_state = 192, .external_lex_state = 2},
  [3928] = {.lex_state = 467, .external_lex_state = 3},
  [3929] = {.lex_state = 213},
  [3930] = {.lex_state = 441, .external_lex_state = 3},
  [3931] = {.lex_state = 467, .external_lex_state = 14},
  [3932] = {.lex_state = 467, .external_lex_state = 3},
  [3933] = {.lex_state = 588, .external_lex_state = 3},
  [3934] = {.lex_state = 663, .external_lex_state = 14},
  [3935] = {.lex_state = 192, .external_lex_state = 2},
  [3936] = {.lex_state = 467, .external_lex_state = 3},
  [3937] = {.lex_state = 588, .external_lex_state = 3},
  [3938] = {.lex_state = 588, .external_lex_state = 3},
  [3939] = {.lex_state = 588, .external_lex_state = 3},
  [3940] = {.lex_state = 192, .external_lex_state = 2},
  [3941] = {.lex_state = 192, .external_lex_state = 2},
  [3942] = {.lex_state = 192, .external_lex_state = 2},
  [3943] = {.lex_state = 192, .external_lex_state = 2},
  [3944] = {.lex_state = 192, .external_lex_state = 2},
  [3945] = {.lex_state = 192, .external_lex_state = 2},
  [3946] = {.lex_state = 192, .external_lex_state = 2},
  [3947] = {.lex_state = 192, .external_lex_state = 2},
  [3948] = {.lex_state = 192, .external_lex_state = 2},
  [3949] = {.lex_state = 192, .external_lex_state = 2},
  [3950] = {.lex_state = 192, .external_lex_state = 2},
  [3951] = {.lex_state = 444, .external_lex_state = 3},
  [3952] = {.lex_state = 524, .external_lex_state = 13},
  [3953] = {.lex_state = 467, .external_lex_state = 3},
  [3954] = {.lex_state = 192, .external_lex_state = 29},
  [3955] = {.lex_state = 192, .external_lex_state = 2},
  [3956] = {.lex_state = 663, .external_lex_state = 14},
  [3957] = {.lex_state = 237, .external_lex_state = 8},
  [3958] = {.lex_state = 286, .external_lex_state = 2},
  [3959] = {.lex_state = 237, .external_lex_state = 8},
  [3960] = {.lex_state = 436, .external_lex_state = 3},
  [3961] = {.lex_state = 436, .external_lex_state = 3},
  [3962] = {.lex_state = 436, .external_lex_state = 3},
  [3963] = {.lex_state = 436, .external_lex_state = 3},
  [3964] = {.lex_state = 436, .external_lex_state = 3},
  [3965] = {.lex_state = 436, .external_lex_state = 3},
  [3966] = {.lex_state = 436, .external_lex_state = 3},
  [3967] = {.lex_state = 436, .external_lex_state = 3},
  [3968] = {.lex_state = 436, .external_lex_state = 3},
  [3969] = {.lex_state = 436, .external_lex_state = 3},
  [3970] = {.lex_state = 554, .external_lex_state = 16},
  [3971] = {.lex_state = 436, .external_lex_state = 3},
  [3972] = {.lex_state = 436, .external_lex_state = 3},
  [3973] = {.lex_state = 436, .external_lex_state = 3},
  [3974] = {.lex_state = 436, .external_lex_state = 3},
  [3975] = {.lex_state = 192, .external_lex_state = 2},
  [3976] = {.lex_state = 450, .external_lex_state = 11},
  [3977] = {.lex_state = 450, .external_lex_state = 11},
  [3978] = {.lex_state = 450, .external_lex_state = 11},
  [3979] = {.lex_state = 450, .external_lex_state = 11},
  [3980] = {.lex_state = 192, .external_lex_state = 2},
  [3981] = {.lex_state = 192, .external_lex_state = 2},
  [3982] = {.lex_state = 441, .external_lex_state = 3},
  [3983] = {.lex_state = 450, .external_lex_state = 11},
  [3984] = {.lex_state = 213},
  [3985] = {.lex_state = 441, .external_lex_state = 3},
  [3986] = {.lex_state = 441, .external_lex_state = 14},
  [3987] = {.lex_state = 441, .external_lex_state = 3},
  [3988] = {.lex_state = 573, .external_lex_state = 3},
  [3989] = {.lex_state = 664, .external_lex_state = 14},
  [3990] = {.lex_state = 192, .external_lex_state = 2},
  [3991] = {.lex_state = 441, .external_lex_state = 3},
  [3992] = {.lex_state = 573, .external_lex_state = 3},
  [3993] = {.lex_state = 192, .external_lex_state = 2},
  [3994] = {.lex_state = 192, .external_lex_state = 2},
  [3995] = {.lex_state = 192, .external_lex_state = 2},
  [3996] = {.lex_state = 192, .external_lex_state = 2},
  [3997] = {.lex_state = 192, .external_lex_state = 2},
  [3998] = {.lex_state = 192, .external_lex_state = 2},
  [3999] = {.lex_state = 192, .external_lex_state = 2},
  [4000] = {.lex_state = 192, .external_lex_state = 2},
  [4001] = {.lex_state = 192, .external_lex_state = 2},
  [4002] = {.lex_state = 192, .external_lex_state = 2},
  [4003] = {.lex_state = 192, .external_lex_state = 2},
  [4004] = {.lex_state = 441, .external_lex_state = 3},
  [4005] = {.lex_state = 524, .external_lex_state = 13},
  [4006] = {.lex_state = 441, .external_lex_state = 3},
  [4007] = {.lex_state = 192, .external_lex_state = 29},
  [4008] = {.lex_state = 192, .external_lex_state = 2},
  [4009] = {.lex_state = 664, .external_lex_state = 14},
  [4010] = {.lex_state = 192, .external_lex_state = 2},
  [4011] = {.lex_state = 192, .external_lex_state = 2},
  [4012] = {.lex_state = 192, .external_lex_state = 2},
  [4013] = {.lex_state = 192, .external_lex_state = 2},
  [4014] = {.lex_state = 436, .external_lex_state = 3},
  [4015] = {.lex_state = 436, .external_lex_state = 3},
  [4016] = {.lex_state = 213},
  [4017] = {.lex_state = 441, .external_lex_state = 3},
  [4018] = {.lex_state = 436, .external_lex_state = 3},
  [4019] = {.lex_state = 444, .external_lex_state = 14},
  [4020] = {.lex_state = 288, .external_lex_state = 16},
  [4021] = {.lex_state = 288, .external_lex_state = 16},
  [4022] = {.lex_state = 177, .external_lex_state = 4},
  [4023] = {.lex_state = 266, .external_lex_state = 15},
  [4024] = {.lex_state = 288, .external_lex_state = 16},
  [4025] = {.lex_state = 177, .external_lex_state = 4},
  [4026] = {.lex_state = 288, .external_lex_state = 16},
  [4027] = {.lex_state = 288, .external_lex_state = 16},
  [4028] = {.lex_state = 177, .external_lex_state = 4},
  [4029] = {.lex_state = 266, .external_lex_state = 15},
  [4030] = {.lex_state = 288, .external_lex_state = 16},
  [4031] = {.lex_state = 177, .external_lex_state = 4},
  [4032] = {.lex_state = 177, .external_lex_state = 17},
  [4033] = {.lex_state = 288, .external_lex_state = 16},
  [4034] = {.lex_state = 310},
  [4035] = {.lex_state = 288, .external_lex_state = 16},
  [4036] = {.lex_state = 288, .external_lex_state = 16},
  [4037] = {.lex_state = 192, .external_lex_state = 2},
  [4038] = {.lex_state = 192, .external_lex_state = 2},
  [4039] = {.lex_state = 192, .external_lex_state = 2},
  [4040] = {.lex_state = 467, .external_lex_state = 25},
  [4041] = {.lex_state = 213},
  [4042] = {.lex_state = 441, .external_lex_state = 25},
  [4043] = {.lex_state = 467, .external_lex_state = 25},
  [4044] = {.lex_state = 588, .external_lex_state = 25},
  [4045] = {.lex_state = 663, .external_lex_state = 27},
  [4046] = {.lex_state = 192, .external_lex_state = 2},
  [4047] = {.lex_state = 467, .external_lex_state = 25},
  [4048] = {.lex_state = 192, .external_lex_state = 2},
  [4049] = {.lex_state = 192, .external_lex_state = 2},
  [4050] = {.lex_state = 237},
  [4051] = {.lex_state = 192, .external_lex_state = 2},
  [4052] = {.lex_state = 585, .external_lex_state = 26},
  [4053] = {.lex_state = 588, .external_lex_state = 25},
  [4054] = {.lex_state = 588, .external_lex_state = 25},
  [4055] = {.lex_state = 588, .external_lex_state = 25},
  [4056] = {.lex_state = 588, .external_lex_state = 27},
  [4057] = {.lex_state = 588, .external_lex_state = 25},
  [4058] = {.lex_state = 192, .external_lex_state = 2},
  [4059] = {.lex_state = 192, .external_lex_state = 2},
  [4060] = {.lex_state = 192, .external_lex_state = 2},
  [4061] = {.lex_state = 192, .external_lex_state = 2},
  [4062] = {.lex_state = 192, .external_lex_state = 2},
  [4063] = {.lex_state = 192, .external_lex_state = 2},
  [4064] = {.lex_state = 192, .external_lex_state = 2},
  [4065] = {.lex_state = 192, .external_lex_state = 2},
  [4066] = {.lex_state = 192, .external_lex_state = 2},
  [4067] = {.lex_state = 192, .external_lex_state = 2},
  [4068] = {.lex_state = 192, .external_lex_state = 2},
  [4069] = {.lex_state = 192, .external_lex_state = 2},
  [4070] = {.lex_state = 192, .external_lex_state = 2},
  [4071] = {.lex_state = 237},
  [4072] = {.lex_state = 192, .external_lex_state = 2},
  [4073] = {.lex_state = 585, .external_lex_state = 26},
  [4074] = {.lex_state = 573, .external_lex_state = 25},
  [4075] = {.lex_state = 573, .external_lex_state = 25},
  [4076] = {.lex_state = 573, .external_lex_state = 25},
  [4077] = {.lex_state = 573, .external_lex_state = 27},
  [4078] = {.lex_state = 467, .external_lex_state = 25},
  [4079] = {.lex_state = 524, .external_lex_state = 13},
  [4080] = {.lex_state = 467, .external_lex_state = 25},
  [4081] = {.lex_state = 192, .external_lex_state = 29},
  [4082] = {.lex_state = 192, .external_lex_state = 2},
  [4083] = {.lex_state = 663, .external_lex_state = 27},
  [4084] = {.lex_state = 436, .external_lex_state = 25},
  [4085] = {.lex_state = 436, .external_lex_state = 25},
  [4086] = {.lex_state = 436, .external_lex_state = 25},
  [4087] = {.lex_state = 436, .external_lex_state = 25},
  [4088] = {.lex_state = 436, .external_lex_state = 25},
  [4089] = {.lex_state = 554, .external_lex_state = 16},
  [4090] = {.lex_state = 436, .external_lex_state = 25},
  [4091] = {.lex_state = 436, .external_lex_state = 25},
  [4092] = {.lex_state = 436, .external_lex_state = 25},
  [4093] = {.lex_state = 436, .external_lex_state = 25},
  [4094] = {.lex_state = 595, .external_lex_state = 26},
  [4095] = {.lex_state = 356, .external_lex_state = 13},
  [4096] = {.lex_state = 595, .external_lex_state = 26},
  [4097] = {.lex_state = 595, .external_lex_state = 26},
  [4098] = {.lex_state = 416, .external_lex_state = 28},
  [4099] = {.lex_state = 461, .external_lex_state = 25},
  [4100] = {.lex_state = 235, .external_lex_state = 19},
  [4101] = {.lex_state = 235},
  [4102] = {.lex_state = 595, .external_lex_state = 26},
  [4103] = {.lex_state = 192, .external_lex_state = 2},
  [4104] = {.lex_state = 438, .external_lex_state = 26},
  [4105] = {.lex_state = 438, .external_lex_state = 26},
  [4106] = {.lex_state = 438, .external_lex_state = 26},
  [4107] = {.lex_state = 438, .external_lex_state = 26},
  [4108] = {.lex_state = 192, .external_lex_state = 2},
  [4109] = {.lex_state = 192, .external_lex_state = 2},
  [4110] = {.lex_state = 441, .external_lex_state = 25},
  [4111] = {.lex_state = 438, .external_lex_state = 26},
  [4112] = {.lex_state = 213},
  [4113] = {.lex_state = 441, .external_lex_state = 25},
  [4114] = {.lex_state = 441, .external_lex_state = 27},
  [4115] = {.lex_state = 441, .external_lex_state = 25},
  [4116] = {.lex_state = 573, .external_lex_state = 25},
  [4117] = {.lex_state = 664, .external_lex_state = 27},
  [4118] = {.lex_state = 192, .external_lex_state = 2},
  [4119] = {.lex_state = 397, .external_lex_state = 25},
  [4120] = {.lex_state = 194},
  [4121] = {.lex_state = 286, .external_lex_state = 2},
  [4122] = {.lex_state = 441, .external_lex_state = 25},
  [4123] = {.lex_state = 461, .external_lex_state = 25},
  [4124] = {.lex_state = 128},
  [4125] = {.lex_state = 128, .external_lex_state = 12},
  [4126] = {.lex_state = 414, .external_lex_state = 2},
  [4127] = {.lex_state = 573, .external_lex_state = 25},
  [4128] = {.lex_state = 192, .external_lex_state = 2},
  [4129] = {.lex_state = 192, .external_lex_state = 2},
  [4130] = {.lex_state = 192, .external_lex_state = 2},
  [4131] = {.lex_state = 192, .external_lex_state = 2},
  [4132] = {.lex_state = 192, .external_lex_state = 2},
  [4133] = {.lex_state = 192, .external_lex_state = 2},
  [4134] = {.lex_state = 192, .external_lex_state = 2},
  [4135] = {.lex_state = 192, .external_lex_state = 2},
  [4136] = {.lex_state = 192, .external_lex_state = 2},
  [4137] = {.lex_state = 192, .external_lex_state = 2},
  [4138] = {.lex_state = 192, .external_lex_state = 2},
  [4139] = {.lex_state = 409, .external_lex_state = 2},
  [4140] = {.lex_state = 461, .external_lex_state = 25},
  [4141] = {.lex_state = 441, .external_lex_state = 25},
  [4142] = {.lex_state = 524, .external_lex_state = 13},
  [4143] = {.lex_state = 441, .external_lex_state = 25},
  [4144] = {.lex_state = 192, .external_lex_state = 29},
  [4145] = {.lex_state = 192, .external_lex_state = 2},
  [4146] = {.lex_state = 664, .external_lex_state = 27},
  [4147] = {.lex_state = 192, .external_lex_state = 2},
  [4148] = {.lex_state = 436, .external_lex_state = 25},
  [4149] = {.lex_state = 436, .external_lex_state = 25},
  [4150] = {.lex_state = 436, .external_lex_state = 25},
  [4151] = {.lex_state = 467, .external_lex_state = 27},
  [4152] = {.lex_state = 128, .external_lex_state = 2},
  [4153] = {.lex_state = 128, .external_lex_state = 2},
  [4154] = {.lex_state = 288, .external_lex_state = 16},
  [4155] = {.lex_state = 288, .external_lex_state = 16},
  [4156] = {.lex_state = 361, .external_lex_state = 25},
  [4157] = {.lex_state = 361, .external_lex_state = 25},
  [4158] = {.lex_state = 361, .external_lex_state = 25},
  [4159] = {.lex_state = 388, .external_lex_state = 25},
  [4160] = {.lex_state = 209},
  [4161] = {.lex_state = 361, .external_lex_state = 25},
  [4162] = {.lex_state = 361, .external_lex_state = 25},
  [4163] = {.lex_state = 361, .external_lex_state = 25},
  [4164] = {.lex_state = 361, .external_lex_state = 25},
  [4165] = {.lex_state = 361, .external_lex_state = 25},
  [4166] = {.lex_state = 361, .external_lex_state = 25},
  [4167] = {.lex_state = 554, .external_lex_state = 16},
  [4168] = {.lex_state = 361, .external_lex_state = 25},
  [4169] = {.lex_state = 361, .external_lex_state = 25},
  [4170] = {.lex_state = 361, .external_lex_state = 25},
  [4171] = {.lex_state = 361, .external_lex_state = 25},
  [4172] = {.lex_state = 388, .external_lex_state = 25},
  [4173] = {.lex_state = 177, .external_lex_state = 17},
  [4174] = {.lex_state = 305, .external_lex_state = 25},
  [4175] = {.lex_state = 388, .external_lex_state = 25},
  [4176] = {.lex_state = 524, .external_lex_state = 21},
  [4177] = {.lex_state = 305, .external_lex_state = 25},
  [4178] = {.lex_state = 361, .external_lex_state = 25},
  [4179] = {.lex_state = 361, .external_lex_state = 25},
  [4180] = {.lex_state = 388, .external_lex_state = 25},
  [4181] = {.lex_state = 361, .external_lex_state = 25},
  [4182] = {.lex_state = 361, .external_lex_state = 25},
  [4183] = {.lex_state = 361, .external_lex_state = 27},
  [4184] = {.lex_state = 288, .external_lex_state = 16},
  [4185] = {.lex_state = 128},
  [4186] = {.lex_state = 128},
  [4187] = {.lex_state = 128, .external_lex_state = 2},
  [4188] = {.lex_state = 288, .external_lex_state = 16},
  [4189] = {.lex_state = 128},
  [4190] = {.lex_state = 128},
  [4191] = {.lex_state = 288, .external_lex_state = 16},
  [4192] = {.lex_state = 128},
  [4193] = {.lex_state = 288, .external_lex_state = 16},
  [4194] = {.lex_state = 128},
  [4195] = {.lex_state = 128, .external_lex_state = 2},
  [4196] = {.lex_state = 128},
  [4197] = {.lex_state = 128},
  [4198] = {.lex_state = 288, .external_lex_state = 16},
  [4199] = {.lex_state = 288, .external_lex_state = 16},
  [4200] = {.lex_state = 128},
  [4201] = {.lex_state = 128},
  [4202] = {.lex_state = 288, .external_lex_state = 16},
  [4203] = {.lex_state = 288, .external_lex_state = 16},
  [4204] = {.lex_state = 194},
  [4205] = {.lex_state = 288, .external_lex_state = 16},
  [4206] = {.lex_state = 128},
  [4207] = {.lex_state = 128, .external_lex_state = 2},
  [4208] = {.lex_state = 128, .external_lex_state = 12},
  [4209] = {.lex_state = 192, .external_lex_state = 2},
  [4210] = {.lex_state = 304, .external_lex_state = 18},
  [4211] = {.lex_state = 209, .external_lex_state = 19},
  [4212] = {.lex_state = 209},
  [4213] = {.lex_state = 304, .external_lex_state = 18},
  [4214] = {.lex_state = 299, .external_lex_state = 16},
  [4215] = {.lex_state = 235},
  [4216] = {.lex_state = 598, .external_lex_state = 27},
  [4217] = {.lex_state = 397, .external_lex_state = 25},
  [4218] = {.lex_state = 397, .external_lex_state = 25},
  [4219] = {.lex_state = 397, .external_lex_state = 25},
  [4220] = {.lex_state = 397, .external_lex_state = 25},
  [4221] = {.lex_state = 192, .external_lex_state = 15},
  [4222] = {.lex_state = 266, .external_lex_state = 15},
  [4223] = {.lex_state = 397, .external_lex_state = 25},
  [4224] = {.lex_state = 177, .external_lex_state = 4},
  [4225] = {.lex_state = 266, .external_lex_state = 15},
  [4226] = {.lex_state = 397, .external_lex_state = 25},
  [4227] = {.lex_state = 192, .external_lex_state = 15},
  [4228] = {.lex_state = 266, .external_lex_state = 15},
  [4229] = {.lex_state = 397, .external_lex_state = 25},
  [4230] = {.lex_state = 177, .external_lex_state = 4},
  [4231] = {.lex_state = 266, .external_lex_state = 15},
  [4232] = {.lex_state = 397, .external_lex_state = 25},
  [4233] = {.lex_state = 421, .external_lex_state = 25},
  [4234] = {.lex_state = 299, .external_lex_state = 16},
  [4235] = {.lex_state = 194},
  [4236] = {.lex_state = 397, .external_lex_state = 25},
  [4237] = {.lex_state = 194},
  [4238] = {.lex_state = 302, .external_lex_state = 16},
  [4239] = {.lex_state = 225, .external_lex_state = 7},
  [4240] = {.lex_state = 128, .external_lex_state = 2},
  [4241] = {.lex_state = 397, .external_lex_state = 25},
  [4242] = {.lex_state = 247, .external_lex_state = 3},
  [4243] = {.lex_state = 128, .external_lex_state = 8},
  [4244] = {.lex_state = 128, .external_lex_state = 2},
  [4245] = {.lex_state = 397, .external_lex_state = 25},
  [4246] = {.lex_state = 128, .external_lex_state = 2},
  [4247] = {.lex_state = 128, .external_lex_state = 12},
  [4248] = {.lex_state = 128, .external_lex_state = 2},
  [4249] = {.lex_state = 128, .external_lex_state = 2},
  [4250] = {.lex_state = 128, .external_lex_state = 2},
  [4251] = {.lex_state = 128, .external_lex_state = 8},
  [4252] = {.lex_state = 299, .external_lex_state = 16},
  [4253] = {.lex_state = 128},
  [4254] = {.lex_state = 128, .external_lex_state = 2},
  [4255] = {.lex_state = 128, .external_lex_state = 12},
  [4256] = {.lex_state = 128},
  [4257] = {.lex_state = 128},
  [4258] = {.lex_state = 128},
  [4259] = {.lex_state = 397, .external_lex_state = 25},
  [4260] = {.lex_state = 128},
  [4261] = {.lex_state = 128},
  [4262] = {.lex_state = 128},
  [4263] = {.lex_state = 397, .external_lex_state = 25},
  [4264] = {.lex_state = 397, .external_lex_state = 25},
  [4265] = {.lex_state = 209},
  [4266] = {.lex_state = 421, .external_lex_state = 25},
  [4267] = {.lex_state = 397, .external_lex_state = 25},
  [4268] = {.lex_state = 235},
  [4269] = {.lex_state = 397, .external_lex_state = 25},
  [4270] = {.lex_state = 397, .external_lex_state = 25},
  [4271] = {.lex_state = 421, .external_lex_state = 25},
  [4272] = {.lex_state = 421, .external_lex_state = 25},
  [4273] = {.lex_state = 421, .external_lex_state = 25},
  [4274] = {.lex_state = 421, .external_lex_state = 25},
  [4275] = {.lex_state = 421, .external_lex_state = 25},
  [4276] = {.lex_state = 554, .external_lex_state = 16},
  [4277] = {.lex_state = 421, .external_lex_state = 25},
  [4278] = {.lex_state = 421, .external_lex_state = 25},
  [4279] = {.lex_state = 421, .external_lex_state = 25},
  [4280] = {.lex_state = 421, .external_lex_state = 25},
  [4281] = {.lex_state = 299, .external_lex_state = 16},
  [4282] = {.lex_state = 397, .external_lex_state = 25},
  [4283] = {.lex_state = 177, .external_lex_state = 17},
  [4284] = {.lex_state = 421, .external_lex_state = 25},
  [4285] = {.lex_state = 397, .external_lex_state = 25},
  [4286] = {.lex_state = 524, .external_lex_state = 21},
  [4287] = {.lex_state = 421, .external_lex_state = 25},
  [4288] = {.lex_state = 421, .external_lex_state = 25},
  [4289] = {.lex_state = 421, .external_lex_state = 25},
  [4290] = {.lex_state = 397, .external_lex_state = 25},
  [4291] = {.lex_state = 421, .external_lex_state = 25},
  [4292] = {.lex_state = 421, .external_lex_state = 25},
  [4293] = {.lex_state = 421, .external_lex_state = 27},
  [4294] = {.lex_state = 302, .external_lex_state = 16},
  [4295] = {.lex_state = 302, .external_lex_state = 16},
  [4296] = {.lex_state = 302, .external_lex_state = 16},
  [4297] = {.lex_state = 192, .external_lex_state = 2},
  [4298] = {.lex_state = 192, .external_lex_state = 2},
  [4299] = {.lex_state = 192, .external_lex_state = 2},
  [4300] = {.lex_state = 192, .external_lex_state = 2},
  [4301] = {.lex_state = 192, .external_lex_state = 2},
  [4302] = {.lex_state = 192, .external_lex_state = 2},
  [4303] = {.lex_state = 192, .external_lex_state = 2},
  [4304] = {.lex_state = 192, .external_lex_state = 2},
  [4305] = {.lex_state = 192, .external_lex_state = 2},
  [4306] = {.lex_state = 192, .external_lex_state = 2},
  [4307] = {.lex_state = 192, .external_lex_state = 29},
  [4308] = {.lex_state = 302, .external_lex_state = 16},
  [4309] = {.lex_state = 192, .external_lex_state = 29},
  [4310] = {.lex_state = 192, .external_lex_state = 2},
  [4311] = {.lex_state = 156, .external_lex_state = 20},
  [4312] = {.lex_state = 194, .external_lex_state = 6},
  [4313] = {.lex_state = 177, .external_lex_state = 17},
  [4314] = {.lex_state = 194, .external_lex_state = 19},
  [4315] = {.lex_state = 192, .external_lex_state = 2},
  [4316] = {.lex_state = 192, .external_lex_state = 2},
  [4317] = {.lex_state = 192, .external_lex_state = 2},
  [4318] = {.lex_state = 493, .external_lex_state = 25},
  [4319] = {.lex_state = 213},
  [4320] = {.lex_state = 321, .external_lex_state = 25},
  [4321] = {.lex_state = 493, .external_lex_state = 25},
  [4322] = {.lex_state = 493, .external_lex_state = 25},
  [4323] = {.lex_state = 192, .external_lex_state = 2},
  [4324] = {.lex_state = 493, .external_lex_state = 25},
  [4325] = {.lex_state = 493, .external_lex_state = 25},
  [4326] = {.lex_state = 192, .external_lex_state = 2},
  [4327] = {.lex_state = 192, .external_lex_state = 2},
  [4328] = {.lex_state = 192, .external_lex_state = 2},
  [4329] = {.lex_state = 192, .external_lex_state = 2},
  [4330] = {.lex_state = 192, .external_lex_state = 2},
  [4331] = {.lex_state = 192, .external_lex_state = 2},
  [4332] = {.lex_state = 192, .external_lex_state = 2},
  [4333] = {.lex_state = 192, .external_lex_state = 2},
  [4334] = {.lex_state = 192, .external_lex_state = 2},
  [4335] = {.lex_state = 192, .external_lex_state = 2},
  [4336] = {.lex_state = 192, .external_lex_state = 2},
  [4337] = {.lex_state = 324, .external_lex_state = 25},
  [4338] = {.lex_state = 524, .external_lex_state = 13},
  [4339] = {.lex_state = 493, .external_lex_state = 25},
  [4340] = {.lex_state = 192, .external_lex_state = 29},
  [4341] = {.lex_state = 192, .external_lex_state = 2},
  [4342] = {.lex_state = 302, .external_lex_state = 16},
  [4343] = {.lex_state = 302, .external_lex_state = 16},
  [4344] = {.lex_state = 225, .external_lex_state = 7},
  [4345] = {.lex_state = 302, .external_lex_state = 16},
  [4346] = {.lex_state = 302, .external_lex_state = 16},
  [4347] = {.lex_state = 302, .external_lex_state = 16},
  [4348] = {.lex_state = 554, .external_lex_state = 16},
  [4349] = {.lex_state = 302, .external_lex_state = 16},
  [4350] = {.lex_state = 302, .external_lex_state = 16},
  [4351] = {.lex_state = 302, .external_lex_state = 16},
  [4352] = {.lex_state = 302, .external_lex_state = 16},
  [4353] = {.lex_state = 192, .external_lex_state = 2},
  [4354] = {.lex_state = 478, .external_lex_state = 26},
  [4355] = {.lex_state = 478, .external_lex_state = 26},
  [4356] = {.lex_state = 478, .external_lex_state = 26},
  [4357] = {.lex_state = 478, .external_lex_state = 26},
  [4358] = {.lex_state = 192, .external_lex_state = 2},
  [4359] = {.lex_state = 192, .external_lex_state = 2},
  [4360] = {.lex_state = 321, .external_lex_state = 25},
  [4361] = {.lex_state = 478, .external_lex_state = 26},
  [4362] = {.lex_state = 213},
  [4363] = {.lex_state = 321, .external_lex_state = 25},
  [4364] = {.lex_state = 321, .external_lex_state = 27},
  [4365] = {.lex_state = 321, .external_lex_state = 25},
  [4366] = {.lex_state = 497, .external_lex_state = 25},
  [4367] = {.lex_state = 614, .external_lex_state = 27},
  [4368] = {.lex_state = 192, .external_lex_state = 2},
  [4369] = {.lex_state = 321, .external_lex_state = 25},
  [4370] = {.lex_state = 497, .external_lex_state = 25},
  [4371] = {.lex_state = 192, .external_lex_state = 2},
  [4372] = {.lex_state = 192, .external_lex_state = 2},
  [4373] = {.lex_state = 192, .external_lex_state = 2},
  [4374] = {.lex_state = 192, .external_lex_state = 2},
  [4375] = {.lex_state = 192, .external_lex_state = 2},
  [4376] = {.lex_state = 192, .external_lex_state = 2},
  [4377] = {.lex_state = 192, .external_lex_state = 2},
  [4378] = {.lex_state = 192, .external_lex_state = 2},
  [4379] = {.lex_state = 192, .external_lex_state = 2},
  [4380] = {.lex_state = 192, .external_lex_state = 2},
  [4381] = {.lex_state = 192, .external_lex_state = 2},
  [4382] = {.lex_state = 321, .external_lex_state = 25},
  [4383] = {.lex_state = 524, .external_lex_state = 13},
  [4384] = {.lex_state = 321, .external_lex_state = 25},
  [4385] = {.lex_state = 192, .external_lex_state = 29},
  [4386] = {.lex_state = 192, .external_lex_state = 2},
  [4387] = {.lex_state = 614, .external_lex_state = 27},
  [4388] = {.lex_state = 192, .external_lex_state = 2},
  [4389] = {.lex_state = 192, .external_lex_state = 2},
  [4390] = {.lex_state = 635, .external_lex_state = 18},
  [4391] = {.lex_state = 635, .external_lex_state = 18},
  [4392] = {.lex_state = 635, .external_lex_state = 18},
  [4393] = {.lex_state = 635, .external_lex_state = 18},
  [4394] = {.lex_state = 192, .external_lex_state = 2},
  [4395] = {.lex_state = 192, .external_lex_state = 2},
  [4396] = {.lex_state = 302, .external_lex_state = 16},
  [4397] = {.lex_state = 302, .external_lex_state = 16},
  [4398] = {.lex_state = 213},
  [4399] = {.lex_state = 321, .external_lex_state = 16},
  [4400] = {.lex_state = 610, .external_lex_state = 20},
  [4401] = {.lex_state = 302, .external_lex_state = 16},
  [4402] = {.lex_state = 324, .external_lex_state = 20},
  [4403] = {.lex_state = 128, .external_lex_state = 2},
  [4404] = {.lex_state = 128, .external_lex_state = 12},
  [4405] = {.lex_state = 302},
  [4406] = {.lex_state = 409, .external_lex_state = 2},
  [4407] = {.lex_state = 414, .external_lex_state = 12},
  [4408] = {.lex_state = 128},
  [4409] = {.lex_state = 254, .external_lex_state = 8},
  [4410] = {.lex_state = 528, .external_lex_state = 3},
  [4411] = {.lex_state = 528, .external_lex_state = 3},
  [4412] = {.lex_state = 197},
  [4413] = {.lex_state = 254, .external_lex_state = 8},
  [4414] = {.lex_state = 192, .external_lex_state = 2},
  [4415] = {.lex_state = 671, .external_lex_state = 26},
  [4416] = {.lex_state = 671, .external_lex_state = 26},
  [4417] = {.lex_state = 671, .external_lex_state = 26},
  [4418] = {.lex_state = 671, .external_lex_state = 26},
  [4419] = {.lex_state = 192, .external_lex_state = 2},
  [4420] = {.lex_state = 192, .external_lex_state = 2},
  [4421] = {.lex_state = 621, .external_lex_state = 25},
  [4422] = {.lex_state = 213},
  [4423] = {.lex_state = 321, .external_lex_state = 25},
  [4424] = {.lex_state = 621, .external_lex_state = 27},
  [4425] = {.lex_state = 621, .external_lex_state = 25},
  [4426] = {.lex_state = 604, .external_lex_state = 25},
  [4427] = {.lex_state = 674, .external_lex_state = 27},
  [4428] = {.lex_state = 192, .external_lex_state = 2},
  [4429] = {.lex_state = 621, .external_lex_state = 25},
  [4430] = {.lex_state = 192, .external_lex_state = 2},
  [4431] = {.lex_state = 192, .external_lex_state = 2},
  [4432] = {.lex_state = 237},
  [4433] = {.lex_state = 192, .external_lex_state = 2},
  [4434] = {.lex_state = 520, .external_lex_state = 26},
  [4435] = {.lex_state = 604, .external_lex_state = 25},
  [4436] = {.lex_state = 604, .external_lex_state = 25},
  [4437] = {.lex_state = 604, .external_lex_state = 25},
  [4438] = {.lex_state = 604, .external_lex_state = 27},
  [4439] = {.lex_state = 604, .external_lex_state = 25},
  [4440] = {.lex_state = 192, .external_lex_state = 2},
  [4441] = {.lex_state = 192, .external_lex_state = 2},
  [4442] = {.lex_state = 192, .external_lex_state = 2},
  [4443] = {.lex_state = 192, .external_lex_state = 2},
  [4444] = {.lex_state = 192, .external_lex_state = 2},
  [4445] = {.lex_state = 192, .external_lex_state = 2},
  [4446] = {.lex_state = 192, .external_lex_state = 2},
  [4447] = {.lex_state = 192, .external_lex_state = 2},
  [4448] = {.lex_state = 192, .external_lex_state = 2},
  [4449] = {.lex_state = 192, .external_lex_state = 2},
  [4450] = {.lex_state = 192, .external_lex_state = 2},
  [4451] = {.lex_state = 337, .external_lex_state = 19},
  [4452] = {.lex_state = 524, .external_lex_state = 13},
  [4453] = {.lex_state = 337, .external_lex_state = 19},
  [4454] = {.lex_state = 192, .external_lex_state = 29},
  [4455] = {.lex_state = 192, .external_lex_state = 2},
  [4456] = {.lex_state = 674, .external_lex_state = 27},
  [4457] = {.lex_state = 493, .external_lex_state = 3},
  [4458] = {.lex_state = 493, .external_lex_state = 3},
  [4459] = {.lex_state = 493, .external_lex_state = 3},
  [4460] = {.lex_state = 493, .external_lex_state = 3},
  [4461] = {.lex_state = 192, .external_lex_state = 2},
  [4462] = {.lex_state = 192, .external_lex_state = 2},
  [4463] = {.lex_state = 192, .external_lex_state = 2},
  [4464] = {.lex_state = 192, .external_lex_state = 2},
  [4465] = {.lex_state = 192, .external_lex_state = 2},
  [4466] = {.lex_state = 192, .external_lex_state = 2},
  [4467] = {.lex_state = 192, .external_lex_state = 2},
  [4468] = {.lex_state = 192, .external_lex_state = 2},
  [4469] = {.lex_state = 192, .external_lex_state = 2},
  [4470] = {.lex_state = 192, .external_lex_state = 2},
  [4471] = {.lex_state = 192, .external_lex_state = 29},
  [4472] = {.lex_state = 192, .external_lex_state = 2},
  [4473] = {.lex_state = 610, .external_lex_state = 14},
  [4474] = {.lex_state = 493, .external_lex_state = 3},
  [4475] = {.lex_state = 493, .external_lex_state = 3},
  [4476] = {.lex_state = 493, .external_lex_state = 3},
  [4477] = {.lex_state = 192, .external_lex_state = 2},
  [4478] = {.lex_state = 493, .external_lex_state = 3},
  [4479] = {.lex_state = 192, .external_lex_state = 2},
  [4480] = {.lex_state = 493, .external_lex_state = 3},
  [4481] = {.lex_state = 524, .external_lex_state = 13},
  [4482] = {.lex_state = 493, .external_lex_state = 3},
  [4483] = {.lex_state = 493, .external_lex_state = 3},
  [4484] = {.lex_state = 493, .external_lex_state = 3},
  [4485] = {.lex_state = 493, .external_lex_state = 3},
  [4486] = {.lex_state = 493, .external_lex_state = 3},
  [4487] = {.lex_state = 493, .external_lex_state = 3},
  [4488] = {.lex_state = 493, .external_lex_state = 3},
  [4489] = {.lex_state = 554, .external_lex_state = 16},
  [4490] = {.lex_state = 493, .external_lex_state = 3},
  [4491] = {.lex_state = 493, .external_lex_state = 3},
  [4492] = {.lex_state = 493, .external_lex_state = 3},
  [4493] = {.lex_state = 493, .external_lex_state = 3},
  [4494] = {.lex_state = 497, .external_lex_state = 3},
  [4495] = {.lex_state = 497, .external_lex_state = 3},
  [4496] = {.lex_state = 192, .external_lex_state = 2},
  [4497] = {.lex_state = 497, .external_lex_state = 3},
  [4498] = {.lex_state = 192, .external_lex_state = 2},
  [4499] = {.lex_state = 497, .external_lex_state = 3},
  [4500] = {.lex_state = 524, .external_lex_state = 13},
  [4501] = {.lex_state = 497, .external_lex_state = 3},
  [4502] = {.lex_state = 324, .external_lex_state = 3},
  [4503] = {.lex_state = 524, .external_lex_state = 21},
  [4504] = {.lex_state = 324, .external_lex_state = 3},
  [4505] = {.lex_state = 493, .external_lex_state = 3},
  [4506] = {.lex_state = 493, .external_lex_state = 3},
  [4507] = {.lex_state = 493, .external_lex_state = 3},
  [4508] = {.lex_state = 493, .external_lex_state = 3},
  [4509] = {.lex_state = 613, .external_lex_state = 14},
  [4510] = {.lex_state = 302, .external_lex_state = 8},
  [4511] = {.lex_state = 128, .external_lex_state = 2},
  [4512] = {.lex_state = 192, .external_lex_state = 2},
  [4513] = {.lex_state = 321, .external_lex_state = 3},
  [4514] = {.lex_state = 321, .external_lex_state = 3},
  [4515] = {.lex_state = 192, .external_lex_state = 2},
  [4516] = {.lex_state = 192, .external_lex_state = 2},
  [4517] = {.lex_state = 192, .external_lex_state = 2},
  [4518] = {.lex_state = 192, .external_lex_state = 2},
  [4519] = {.lex_state = 192, .external_lex_state = 2},
  [4520] = {.lex_state = 192, .external_lex_state = 2},
  [4521] = {.lex_state = 192, .external_lex_state = 2},
  [4522] = {.lex_state = 192, .external_lex_state = 2},
  [4523] = {.lex_state = 192, .external_lex_state = 2},
  [4524] = {.lex_state = 192, .external_lex_state = 2},
  [4525] = {.lex_state = 192, .external_lex_state = 29},
  [4526] = {.lex_state = 192, .external_lex_state = 2},
  [4527] = {.lex_state = 321, .external_lex_state = 14},
  [4528] = {.lex_state = 321, .external_lex_state = 3},
  [4529] = {.lex_state = 321, .external_lex_state = 3},
  [4530] = {.lex_state = 497, .external_lex_state = 3},
  [4531] = {.lex_state = 497, .external_lex_state = 3},
  [4532] = {.lex_state = 497, .external_lex_state = 3},
  [4533] = {.lex_state = 497, .external_lex_state = 3},
  [4534] = {.lex_state = 497, .external_lex_state = 3},
  [4535] = {.lex_state = 554, .external_lex_state = 16},
  [4536] = {.lex_state = 497, .external_lex_state = 3},
  [4537] = {.lex_state = 497, .external_lex_state = 3},
  [4538] = {.lex_state = 497, .external_lex_state = 3},
  [4539] = {.lex_state = 497, .external_lex_state = 3},
  [4540] = {.lex_state = 321, .external_lex_state = 3},
  [4541] = {.lex_state = 524, .external_lex_state = 21},
  [4542] = {.lex_state = 321, .external_lex_state = 3},
  [4543] = {.lex_state = 321, .external_lex_state = 3},
  [4544] = {.lex_state = 497, .external_lex_state = 3},
  [4545] = {.lex_state = 497, .external_lex_state = 3},
  [4546] = {.lex_state = 497, .external_lex_state = 3},
  [4547] = {.lex_state = 614, .external_lex_state = 14},
  [4548] = {.lex_state = 302, .external_lex_state = 3},
  [4549] = {.lex_state = 302, .external_lex_state = 3},
  [4550] = {.lex_state = 302, .external_lex_state = 3},
  [4551] = {.lex_state = 192, .external_lex_state = 2},
  [4552] = {.lex_state = 192, .external_lex_state = 2},
  [4553] = {.lex_state = 192, .external_lex_state = 2},
  [4554] = {.lex_state = 192, .external_lex_state = 2},
  [4555] = {.lex_state = 192, .external_lex_state = 2},
  [4556] = {.lex_state = 192, .external_lex_state = 2},
  [4557] = {.lex_state = 192, .external_lex_state = 2},
  [4558] = {.lex_state = 192, .external_lex_state = 2},
  [4559] = {.lex_state = 192, .external_lex_state = 2},
  [4560] = {.lex_state = 192, .external_lex_state = 2},
  [4561] = {.lex_state = 192, .external_lex_state = 29},
  [4562] = {.lex_state = 302, .external_lex_state = 3},
  [4563] = {.lex_state = 192, .external_lex_state = 29},
  [4564] = {.lex_state = 192, .external_lex_state = 2},
  [4565] = {.lex_state = 330},
  [4566] = {.lex_state = 330},
  [4567] = {.lex_state = 177, .external_lex_state = 4},
  [4568] = {.lex_state = 266, .external_lex_state = 15},
  [4569] = {.lex_state = 330},
  [4570] = {.lex_state = 177, .external_lex_state = 4},
  [4571] = {.lex_state = 330},
  [4572] = {.lex_state = 330},
  [4573] = {.lex_state = 177, .external_lex_state = 4},
  [4574] = {.lex_state = 266, .external_lex_state = 15},
  [4575] = {.lex_state = 330},
  [4576] = {.lex_state = 177, .external_lex_state = 4},
  [4577] = {.lex_state = 330},
  [4578] = {.lex_state = 310},
  [4579] = {.lex_state = 330},
  [4580] = {.lex_state = 330},
  [4581] = {.lex_state = 128, .external_lex_state = 2},
  [4582] = {.lex_state = 128, .external_lex_state = 2},
  [4583] = {.lex_state = 330},
  [4584] = {.lex_state = 330},
  [4585] = {.lex_state = 361, .external_lex_state = 25},
  [4586] = {.lex_state = 192, .external_lex_state = 2},
  [4587] = {.lex_state = 192, .external_lex_state = 2},
  [4588] = {.lex_state = 237},
  [4589] = {.lex_state = 192, .external_lex_state = 2},
  [4590] = {.lex_state = 296, .external_lex_state = 26},
  [4591] = {.lex_state = 361, .external_lex_state = 25},
  [4592] = {.lex_state = 361, .external_lex_state = 25},
  [4593] = {.lex_state = 361, .external_lex_state = 25},
  [4594] = {.lex_state = 371, .external_lex_state = 27},
  [4595] = {.lex_state = 361, .external_lex_state = 25},
  [4596] = {.lex_state = 192, .external_lex_state = 2},
  [4597] = {.lex_state = 192, .external_lex_state = 2},
  [4598] = {.lex_state = 192, .external_lex_state = 2},
  [4599] = {.lex_state = 192, .external_lex_state = 2},
  [4600] = {.lex_state = 192, .external_lex_state = 2},
  [4601] = {.lex_state = 192, .external_lex_state = 2},
  [4602] = {.lex_state = 192, .external_lex_state = 2},
  [4603] = {.lex_state = 192, .external_lex_state = 2},
  [4604] = {.lex_state = 192, .external_lex_state = 2},
  [4605] = {.lex_state = 192, .external_lex_state = 2},
  [4606] = {.lex_state = 192, .external_lex_state = 2},
  [4607] = {.lex_state = 192, .external_lex_state = 2},
  [4608] = {.lex_state = 237},
  [4609] = {.lex_state = 192, .external_lex_state = 2},
  [4610] = {.lex_state = 296, .external_lex_state = 26},
  [4611] = {.lex_state = 421, .external_lex_state = 25},
  [4612] = {.lex_state = 424, .external_lex_state = 25},
  [4613] = {.lex_state = 424, .external_lex_state = 25},
  [4614] = {.lex_state = 427, .external_lex_state = 27},
  [4615] = {.lex_state = 192, .external_lex_state = 29},
  [4616] = {.lex_state = 192, .external_lex_state = 2},
  [4617] = {.lex_state = 365, .external_lex_state = 27},
  [4618] = {.lex_state = 361, .external_lex_state = 25},
  [4619] = {.lex_state = 337, .external_lex_state = 19},
  [4620] = {.lex_state = 209},
  [4621] = {.lex_state = 361, .external_lex_state = 25},
  [4622] = {.lex_state = 337, .external_lex_state = 19},
  [4623] = {.lex_state = 177, .external_lex_state = 17},
  [4624] = {.lex_state = 334, .external_lex_state = 19},
  [4625] = {.lex_state = 337, .external_lex_state = 19},
  [4626] = {.lex_state = 524, .external_lex_state = 21},
  [4627] = {.lex_state = 334, .external_lex_state = 19},
  [4628] = {.lex_state = 340, .external_lex_state = 19},
  [4629] = {.lex_state = 330},
  [4630] = {.lex_state = 128},
  [4631] = {.lex_state = 128},
  [4632] = {.lex_state = 128, .external_lex_state = 2},
  [4633] = {.lex_state = 330},
  [4634] = {.lex_state = 128},
  [4635] = {.lex_state = 128},
  [4636] = {.lex_state = 330},
  [4637] = {.lex_state = 128},
  [4638] = {.lex_state = 330},
  [4639] = {.lex_state = 128},
  [4640] = {.lex_state = 128, .external_lex_state = 2},
  [4641] = {.lex_state = 128},
  [4642] = {.lex_state = 128},
  [4643] = {.lex_state = 330},
  [4644] = {.lex_state = 330},
  [4645] = {.lex_state = 128},
  [4646] = {.lex_state = 128},
  [4647] = {.lex_state = 330},
  [4648] = {.lex_state = 337},
  [4649] = {.lex_state = 194},
  [4650] = {.lex_state = 337},
  [4651] = {.lex_state = 128},
  [4652] = {.lex_state = 128, .external_lex_state = 2},
  [4653] = {.lex_state = 128, .external_lex_state = 12},
  [4654] = {.lex_state = 484, .external_lex_state = 21},
  [4655] = {.lex_state = 209, .external_lex_state = 19},
  [4656] = {.lex_state = 209},
  [4657] = {.lex_state = 484, .external_lex_state = 21},
  [4658] = {.lex_state = 337},
  [4659] = {.lex_state = 235},
  [4660] = {.lex_state = 675, .external_lex_state = 27},
  [4661] = {.lex_state = 192, .external_lex_state = 15},
  [4662] = {.lex_state = 621, .external_lex_state = 25},
  [4663] = {.lex_state = 192, .external_lex_state = 15},
  [4664] = {.lex_state = 621, .external_lex_state = 25},
  [4665] = {.lex_state = 192, .external_lex_state = 15},
  [4666] = {.lex_state = 621, .external_lex_state = 25},
  [4667] = {.lex_state = 192, .external_lex_state = 15},
  [4668] = {.lex_state = 621, .external_lex_state = 25},
  [4669] = {.lex_state = 190, .external_lex_state = 4},
  [4670] = {.lex_state = 266, .external_lex_state = 15},
  [4671] = {.lex_state = 621, .external_lex_state = 25},
  [4672] = {.lex_state = 190, .external_lex_state = 4},
  [4673] = {.lex_state = 266, .external_lex_state = 15},
  [4674] = {.lex_state = 627, .external_lex_state = 25},
  [4675] = {.lex_state = 621, .external_lex_state = 25},
  [4676] = {.lex_state = 194},
  [4677] = {.lex_state = 194, .external_lex_state = 19},
  [4678] = {.lex_state = 192, .external_lex_state = 2},
  [4679] = {.lex_state = 621, .external_lex_state = 25},
  [4680] = {.lex_state = 310},
  [4681] = {.lex_state = 310, .external_lex_state = 8},
  [4682] = {.lex_state = 621, .external_lex_state = 25},
  [4683] = {.lex_state = 209},
  [4684] = {.lex_state = 192, .external_lex_state = 2},
  [4685] = {.lex_state = 346, .external_lex_state = 23},
  [4686] = {.lex_state = 346, .external_lex_state = 23},
  [4687] = {.lex_state = 350, .external_lex_state = 23},
  [4688] = {.lex_state = 350, .external_lex_state = 23},
  [4689] = {.lex_state = 192, .external_lex_state = 2},
  [4690] = {.lex_state = 192, .external_lex_state = 2},
  [4691] = {.lex_state = 237},
  [4692] = {.lex_state = 192, .external_lex_state = 2},
  [4693] = {.lex_state = 356, .external_lex_state = 13},
  [4694] = {.lex_state = 296, .external_lex_state = 26},
  [4695] = {.lex_state = 505, .external_lex_state = 25},
  [4696] = {.lex_state = 621, .external_lex_state = 25},
  [4697] = {.lex_state = 627, .external_lex_state = 25},
  [4698] = {.lex_state = 627, .external_lex_state = 25},
  [4699] = {.lex_state = 505, .external_lex_state = 27},
  [4700] = {.lex_state = 621, .external_lex_state = 25},
  [4701] = {.lex_state = 621, .external_lex_state = 25},
  [4702] = {.lex_state = 621, .external_lex_state = 25},
  [4703] = {.lex_state = 128, .external_lex_state = 8},
  [4704] = {.lex_state = 128, .external_lex_state = 8},
  [4705] = {.lex_state = 247, .external_lex_state = 3},
  [4706] = {.lex_state = 247, .external_lex_state = 3},
  [4707] = {.lex_state = 128},
  [4708] = {.lex_state = 247, .external_lex_state = 3},
  [4709] = {.lex_state = 128},
  [4710] = {.lex_state = 128},
  [4711] = {.lex_state = 128},
  [4712] = {.lex_state = 128},
  [4713] = {.lex_state = 128},
  [4714] = {.lex_state = 621, .external_lex_state = 25},
  [4715] = {.lex_state = 128, .external_lex_state = 2},
  [4716] = {.lex_state = 627, .external_lex_state = 25},
  [4717] = {.lex_state = 621, .external_lex_state = 25},
  [4718] = {.lex_state = 621, .external_lex_state = 25},
  [4719] = {.lex_state = 621, .external_lex_state = 25},
  [4720] = {.lex_state = 235, .external_lex_state = 19},
  [4721] = {.lex_state = 235},
  [4722] = {.lex_state = 409, .external_lex_state = 2},
  [4723] = {.lex_state = 414, .external_lex_state = 12},
  [4724] = {.lex_state = 128},
  [4725] = {.lex_state = 621, .external_lex_state = 25},
  [4726] = {.lex_state = 192, .external_lex_state = 2},
  [4727] = {.lex_state = 192, .external_lex_state = 2},
  [4728] = {.lex_state = 192, .external_lex_state = 2},
  [4729] = {.lex_state = 192, .external_lex_state = 2},
  [4730] = {.lex_state = 192, .external_lex_state = 2},
  [4731] = {.lex_state = 192, .external_lex_state = 2},
  [4732] = {.lex_state = 192, .external_lex_state = 2},
  [4733] = {.lex_state = 192, .external_lex_state = 2},
  [4734] = {.lex_state = 192, .external_lex_state = 2},
  [4735] = {.lex_state = 192, .external_lex_state = 2},
  [4736] = {.lex_state = 419, .external_lex_state = 6},
  [4737] = {.lex_state = 461, .external_lex_state = 25},
  [4738] = {.lex_state = 192, .external_lex_state = 29},
  [4739] = {.lex_state = 192, .external_lex_state = 2},
  [4740] = {.lex_state = 627, .external_lex_state = 27},
  [4741] = {.lex_state = 627, .external_lex_state = 25},
  [4742] = {.lex_state = 505, .external_lex_state = 25},
  [4743] = {.lex_state = 505, .external_lex_state = 25},
  [4744] = {.lex_state = 192, .external_lex_state = 2},
  [4745] = {.lex_state = 505, .external_lex_state = 25},
  [4746] = {.lex_state = 192, .external_lex_state = 2},
  [4747] = {.lex_state = 505, .external_lex_state = 25},
  [4748] = {.lex_state = 524, .external_lex_state = 13},
  [4749] = {.lex_state = 505, .external_lex_state = 25},
  [4750] = {.lex_state = 627, .external_lex_state = 25},
  [4751] = {.lex_state = 505, .external_lex_state = 25},
  [4752] = {.lex_state = 505, .external_lex_state = 25},
  [4753] = {.lex_state = 505, .external_lex_state = 25},
  [4754] = {.lex_state = 505, .external_lex_state = 25},
  [4755] = {.lex_state = 505, .external_lex_state = 25},
  [4756] = {.lex_state = 554, .external_lex_state = 16},
  [4757] = {.lex_state = 505, .external_lex_state = 25},
  [4758] = {.lex_state = 505, .external_lex_state = 25},
  [4759] = {.lex_state = 505, .external_lex_state = 25},
  [4760] = {.lex_state = 505, .external_lex_state = 25},
  [4761] = {.lex_state = 340, .external_lex_state = 19},
  [4762] = {.lex_state = 524, .external_lex_state = 21},
  [4763] = {.lex_state = 340, .external_lex_state = 19},
  [4764] = {.lex_state = 340, .external_lex_state = 19},
  [4765] = {.lex_state = 505, .external_lex_state = 25},
  [4766] = {.lex_state = 505, .external_lex_state = 25},
  [4767] = {.lex_state = 505, .external_lex_state = 25},
  [4768] = {.lex_state = 630, .external_lex_state = 27},
  [4769] = {.lex_state = 156, .external_lex_state = 3},
  [4770] = {.lex_state = 156, .external_lex_state = 3},
  [4771] = {.lex_state = 508, .external_lex_state = 25},
  [4772] = {.lex_state = 192, .external_lex_state = 2},
  [4773] = {.lex_state = 192, .external_lex_state = 2},
  [4774] = {.lex_state = 237},
  [4775] = {.lex_state = 192, .external_lex_state = 2},
  [4776] = {.lex_state = 296, .external_lex_state = 26},
  [4777] = {.lex_state = 508, .external_lex_state = 25},
  [4778] = {.lex_state = 508, .external_lex_state = 25},
  [4779] = {.lex_state = 508, .external_lex_state = 25},
  [4780] = {.lex_state = 508, .external_lex_state = 27},
  [4781] = {.lex_state = 508, .external_lex_state = 25},
  [4782] = {.lex_state = 192, .external_lex_state = 2},
  [4783] = {.lex_state = 192, .external_lex_state = 2},
  [4784] = {.lex_state = 192, .external_lex_state = 2},
  [4785] = {.lex_state = 192, .external_lex_state = 2},
  [4786] = {.lex_state = 192, .external_lex_state = 2},
  [4787] = {.lex_state = 192, .external_lex_state = 2},
  [4788] = {.lex_state = 192, .external_lex_state = 2},
  [4789] = {.lex_state = 192, .external_lex_state = 2},
  [4790] = {.lex_state = 192, .external_lex_state = 2},
  [4791] = {.lex_state = 192, .external_lex_state = 2},
  [4792] = {.lex_state = 192, .external_lex_state = 29},
  [4793] = {.lex_state = 192, .external_lex_state = 2},
  [4794] = {.lex_state = 631, .external_lex_state = 27},
  [4795] = {.lex_state = 508, .external_lex_state = 25},
  [4796] = {.lex_state = 508, .external_lex_state = 25},
  [4797] = {.lex_state = 508, .external_lex_state = 25},
  [4798] = {.lex_state = 192, .external_lex_state = 2},
  [4799] = {.lex_state = 508, .external_lex_state = 25},
  [4800] = {.lex_state = 192, .external_lex_state = 2},
  [4801] = {.lex_state = 508, .external_lex_state = 25},
  [4802] = {.lex_state = 524, .external_lex_state = 13},
  [4803] = {.lex_state = 508, .external_lex_state = 25},
  [4804] = {.lex_state = 508, .external_lex_state = 25},
  [4805] = {.lex_state = 508, .external_lex_state = 25},
  [4806] = {.lex_state = 508, .external_lex_state = 25},
  [4807] = {.lex_state = 508, .external_lex_state = 25},
  [4808] = {.lex_state = 508, .external_lex_state = 25},
  [4809] = {.lex_state = 508, .external_lex_state = 25},
  [4810] = {.lex_state = 554, .external_lex_state = 16},
  [4811] = {.lex_state = 508, .external_lex_state = 25},
  [4812] = {.lex_state = 508, .external_lex_state = 25},
  [4813] = {.lex_state = 508, .external_lex_state = 25},
  [4814] = {.lex_state = 508, .external_lex_state = 25},
  [4815] = {.lex_state = 334, .external_lex_state = 19},
  [4816] = {.lex_state = 524, .external_lex_state = 21},
  [4817] = {.lex_state = 334, .external_lex_state = 19},
  [4818] = {.lex_state = 340, .external_lex_state = 19},
  [4819] = {.lex_state = 508, .external_lex_state = 25},
  [4820] = {.lex_state = 508, .external_lex_state = 25},
  [4821] = {.lex_state = 508, .external_lex_state = 25},
  [4822] = {.lex_state = 634, .external_lex_state = 27},
  [4823] = {.lex_state = 365, .external_lex_state = 3},
  [4824] = {.lex_state = 365, .external_lex_state = 3},
  [4825] = {.lex_state = 365, .external_lex_state = 3},
  [4826] = {.lex_state = 365, .external_lex_state = 3},
  [4827] = {.lex_state = 365, .external_lex_state = 3},
  [4828] = {.lex_state = 365, .external_lex_state = 3},
  [4829] = {.lex_state = 365, .external_lex_state = 3},
  [4830] = {.lex_state = 554, .external_lex_state = 16},
  [4831] = {.lex_state = 365, .external_lex_state = 3},
  [4832] = {.lex_state = 365, .external_lex_state = 3},
  [4833] = {.lex_state = 365, .external_lex_state = 3},
  [4834] = {.lex_state = 365, .external_lex_state = 3},
  [4835] = {.lex_state = 365, .external_lex_state = 3},
  [4836] = {.lex_state = 365, .external_lex_state = 3},
  [4837] = {.lex_state = 365, .external_lex_state = 3},
  [4838] = {.lex_state = 365, .external_lex_state = 14},
  [4839] = {.lex_state = 361, .external_lex_state = 3},
  [4840] = {.lex_state = 361, .external_lex_state = 3},
  [4841] = {.lex_state = 361, .external_lex_state = 3},
  [4842] = {.lex_state = 524, .external_lex_state = 21},
  [4843] = {.lex_state = 361, .external_lex_state = 3},
  [4844] = {.lex_state = 361, .external_lex_state = 3},
  [4845] = {.lex_state = 302, .external_lex_state = 25},
  [4846] = {.lex_state = 493, .external_lex_state = 25},
  [4847] = {.lex_state = 493, .external_lex_state = 25},
  [4848] = {.lex_state = 302, .external_lex_state = 25},
  [4849] = {.lex_state = 192, .external_lex_state = 2},
  [4850] = {.lex_state = 192, .external_lex_state = 2},
  [4851] = {.lex_state = 192, .external_lex_state = 2},
  [4852] = {.lex_state = 192, .external_lex_state = 2},
  [4853] = {.lex_state = 192, .external_lex_state = 2},
  [4854] = {.lex_state = 192, .external_lex_state = 2},
  [4855] = {.lex_state = 192, .external_lex_state = 2},
  [4856] = {.lex_state = 192, .external_lex_state = 2},
  [4857] = {.lex_state = 192, .external_lex_state = 2},
  [4858] = {.lex_state = 192, .external_lex_state = 2},
  [4859] = {.lex_state = 192, .external_lex_state = 29},
  [4860] = {.lex_state = 192, .external_lex_state = 2},
  [4861] = {.lex_state = 610, .external_lex_state = 27},
  [4862] = {.lex_state = 302, .external_lex_state = 25},
  [4863] = {.lex_state = 493, .external_lex_state = 25},
  [4864] = {.lex_state = 493, .external_lex_state = 25},
  [4865] = {.lex_state = 192, .external_lex_state = 2},
  [4866] = {.lex_state = 493, .external_lex_state = 25},
  [4867] = {.lex_state = 192, .external_lex_state = 2},
  [4868] = {.lex_state = 493, .external_lex_state = 25},
  [4869] = {.lex_state = 524, .external_lex_state = 13},
  [4870] = {.lex_state = 493, .external_lex_state = 25},
  [4871] = {.lex_state = 302, .external_lex_state = 25},
  [4872] = {.lex_state = 302, .external_lex_state = 25},
  [4873] = {.lex_state = 302, .external_lex_state = 25},
  [4874] = {.lex_state = 302, .external_lex_state = 25},
  [4875] = {.lex_state = 302, .external_lex_state = 25},
  [4876] = {.lex_state = 302, .external_lex_state = 25},
  [4877] = {.lex_state = 554, .external_lex_state = 16},
  [4878] = {.lex_state = 302, .external_lex_state = 25},
  [4879] = {.lex_state = 302, .external_lex_state = 25},
  [4880] = {.lex_state = 302, .external_lex_state = 25},
  [4881] = {.lex_state = 302, .external_lex_state = 25},
  [4882] = {.lex_state = 497, .external_lex_state = 25},
  [4883] = {.lex_state = 497, .external_lex_state = 25},
  [4884] = {.lex_state = 192, .external_lex_state = 2},
  [4885] = {.lex_state = 497, .external_lex_state = 25},
  [4886] = {.lex_state = 192, .external_lex_state = 2},
  [4887] = {.lex_state = 497, .external_lex_state = 25},
  [4888] = {.lex_state = 524, .external_lex_state = 13},
  [4889] = {.lex_state = 497, .external_lex_state = 25},
  [4890] = {.lex_state = 156, .external_lex_state = 3},
  [4891] = {.lex_state = 356, .external_lex_state = 13},
  [4892] = {.lex_state = 192, .external_lex_state = 2},
  [4893] = {.lex_state = 302, .external_lex_state = 25},
  [4894] = {.lex_state = 302, .external_lex_state = 25},
  [4895] = {.lex_state = 302, .external_lex_state = 25},
  [4896] = {.lex_state = 613, .external_lex_state = 27},
  [4897] = {.lex_state = 192, .external_lex_state = 2},
  [4898] = {.lex_state = 514, .external_lex_state = 11},
  [4899] = {.lex_state = 209, .external_lex_state = 19},
  [4900] = {.lex_state = 209},
  [4901] = {.lex_state = 514, .external_lex_state = 11},
  [4902] = {.lex_state = 299, .external_lex_state = 3},
  [4903] = {.lex_state = 235},
  [4904] = {.lex_state = 421, .external_lex_state = 3},
  [4905] = {.lex_state = 299, .external_lex_state = 3},
  [4906] = {.lex_state = 194},
  [4907] = {.lex_state = 299, .external_lex_state = 3},
  [4908] = {.lex_state = 128},
  [4909] = {.lex_state = 128, .external_lex_state = 2},
  [4910] = {.lex_state = 128, .external_lex_state = 12},
  [4911] = {.lex_state = 299, .external_lex_state = 3},
  [4912] = {.lex_state = 209},
  [4913] = {.lex_state = 421, .external_lex_state = 3},
  [4914] = {.lex_state = 299, .external_lex_state = 3},
  [4915] = {.lex_state = 177, .external_lex_state = 17},
  [4916] = {.lex_state = 421, .external_lex_state = 3},
  [4917] = {.lex_state = 299, .external_lex_state = 3},
  [4918] = {.lex_state = 524, .external_lex_state = 21},
  [4919] = {.lex_state = 421, .external_lex_state = 3},
  [4920] = {.lex_state = 421, .external_lex_state = 3},
  [4921] = {.lex_state = 156, .external_lex_state = 3},
  [4922] = {.lex_state = 524, .external_lex_state = 21},
  [4923] = {.lex_state = 177, .external_lex_state = 17},
  [4924] = {.lex_state = 156, .external_lex_state = 3},
  [4925] = {.lex_state = 192, .external_lex_state = 29},
  [4926] = {.lex_state = 361, .external_lex_state = 3},
  [4927] = {.lex_state = 361, .external_lex_state = 3},
  [4928] = {.lex_state = 361, .external_lex_state = 3},
  [4929] = {.lex_state = 361, .external_lex_state = 3},
  [4930] = {.lex_state = 361, .external_lex_state = 3},
  [4931] = {.lex_state = 192, .external_lex_state = 2},
  [4932] = {.lex_state = 192, .external_lex_state = 2},
  [4933] = {.lex_state = 192, .external_lex_state = 2},
  [4934] = {.lex_state = 192, .external_lex_state = 2},
  [4935] = {.lex_state = 192, .external_lex_state = 2},
  [4936] = {.lex_state = 192, .external_lex_state = 2},
  [4937] = {.lex_state = 192, .external_lex_state = 2},
  [4938] = {.lex_state = 192, .external_lex_state = 2},
  [4939] = {.lex_state = 192, .external_lex_state = 2},
  [4940] = {.lex_state = 192, .external_lex_state = 2},
  [4941] = {.lex_state = 192, .external_lex_state = 29},
  [4942] = {.lex_state = 192, .external_lex_state = 2},
  [4943] = {.lex_state = 365, .external_lex_state = 14},
  [4944] = {.lex_state = 361, .external_lex_state = 3},
  [4945] = {.lex_state = 361, .external_lex_state = 3},
  [4946] = {.lex_state = 361, .external_lex_state = 3},
  [4947] = {.lex_state = 192, .external_lex_state = 2},
  [4948] = {.lex_state = 361, .external_lex_state = 3},
  [4949] = {.lex_state = 192, .external_lex_state = 2},
  [4950] = {.lex_state = 361, .external_lex_state = 3},
  [4951] = {.lex_state = 524, .external_lex_state = 13},
  [4952] = {.lex_state = 361, .external_lex_state = 3},
  [4953] = {.lex_state = 361, .external_lex_state = 3},
  [4954] = {.lex_state = 361, .external_lex_state = 3},
  [4955] = {.lex_state = 361, .external_lex_state = 3},
  [4956] = {.lex_state = 361, .external_lex_state = 3},
  [4957] = {.lex_state = 361, .external_lex_state = 3},
  [4958] = {.lex_state = 361, .external_lex_state = 3},
  [4959] = {.lex_state = 554, .external_lex_state = 16},
  [4960] = {.lex_state = 361, .external_lex_state = 3},
  [4961] = {.lex_state = 361, .external_lex_state = 3},
  [4962] = {.lex_state = 361, .external_lex_state = 3},
  [4963] = {.lex_state = 361, .external_lex_state = 3},
  [4964] = {.lex_state = 421, .external_lex_state = 3},
  [4965] = {.lex_state = 421, .external_lex_state = 3},
  [4966] = {.lex_state = 192, .external_lex_state = 2},
  [4967] = {.lex_state = 421, .external_lex_state = 3},
  [4968] = {.lex_state = 192, .external_lex_state = 2},
  [4969] = {.lex_state = 421, .external_lex_state = 3},
  [4970] = {.lex_state = 524, .external_lex_state = 13},
  [4971] = {.lex_state = 421, .external_lex_state = 3},
  [4972] = {.lex_state = 262, .external_lex_state = 3},
  [4973] = {.lex_state = 524, .external_lex_state = 21},
  [4974] = {.lex_state = 262, .external_lex_state = 3},
  [4975] = {.lex_state = 361, .external_lex_state = 3},
  [4976] = {.lex_state = 361, .external_lex_state = 3},
  [4977] = {.lex_state = 361, .external_lex_state = 3},
  [4978] = {.lex_state = 361, .external_lex_state = 3},
  [4979] = {.lex_state = 361, .external_lex_state = 14},
  [4980] = {.lex_state = 254, .external_lex_state = 8},
  [4981] = {.lex_state = 128, .external_lex_state = 12},
  [4982] = {.lex_state = 247, .external_lex_state = 3},
  [4983] = {.lex_state = 192, .external_lex_state = 2},
  [4984] = {.lex_state = 192, .external_lex_state = 2},
  [4985] = {.lex_state = 192, .external_lex_state = 2},
  [4986] = {.lex_state = 237},
  [4987] = {.lex_state = 192, .external_lex_state = 2},
  [4988] = {.lex_state = 353, .external_lex_state = 11},
  [4989] = {.lex_state = 353, .external_lex_state = 11},
  [4990] = {.lex_state = 353, .external_lex_state = 11},
  [4991] = {.lex_state = 353, .external_lex_state = 11},
  [4992] = {.lex_state = 192, .external_lex_state = 2},
  [4993] = {.lex_state = 192, .external_lex_state = 2},
  [4994] = {.lex_state = 358, .external_lex_state = 11},
  [4995] = {.lex_state = 361, .external_lex_state = 3},
  [4996] = {.lex_state = 364, .external_lex_state = 11},
  [4997] = {.lex_state = 262, .external_lex_state = 3},
  [4998] = {.lex_state = 361, .external_lex_state = 3},
  [4999] = {.lex_state = 213},
  [5000] = {.lex_state = 368, .external_lex_state = 3},
  [5001] = {.lex_state = 371, .external_lex_state = 14},
  [5002] = {.lex_state = 128, .external_lex_state = 8},
  [5003] = {.lex_state = 128, .external_lex_state = 2},
  [5004] = {.lex_state = 247, .external_lex_state = 3},
  [5005] = {.lex_state = 254, .external_lex_state = 8},
  [5006] = {.lex_state = 156, .external_lex_state = 3},
  [5007] = {.lex_state = 128},
  [5008] = {.lex_state = 128, .external_lex_state = 2},
  [5009] = {.lex_state = 128, .external_lex_state = 8},
  [5010] = {.lex_state = 192, .external_lex_state = 2},
  [5011] = {.lex_state = 192, .external_lex_state = 2},
  [5012] = {.lex_state = 192, .external_lex_state = 2},
  [5013] = {.lex_state = 192, .external_lex_state = 2},
  [5014] = {.lex_state = 192, .external_lex_state = 2},
  [5015] = {.lex_state = 192, .external_lex_state = 2},
  [5016] = {.lex_state = 192, .external_lex_state = 2},
  [5017] = {.lex_state = 192, .external_lex_state = 2},
  [5018] = {.lex_state = 192, .external_lex_state = 2},
  [5019] = {.lex_state = 192, .external_lex_state = 2},
  [5020] = {.lex_state = 192, .external_lex_state = 2},
  [5021] = {.lex_state = 192, .external_lex_state = 2},
  [5022] = {.lex_state = 192, .external_lex_state = 2},
  [5023] = {.lex_state = 192, .external_lex_state = 2},
  [5024] = {.lex_state = 192, .external_lex_state = 2},
  [5025] = {.lex_state = 192, .external_lex_state = 2},
  [5026] = {.lex_state = 192, .external_lex_state = 2},
  [5027] = {.lex_state = 192, .external_lex_state = 2},
  [5028] = {.lex_state = 237},
  [5029] = {.lex_state = 192, .external_lex_state = 2},
  [5030] = {.lex_state = 364, .external_lex_state = 11},
  [5031] = {.lex_state = 364, .external_lex_state = 11},
  [5032] = {.lex_state = 364, .external_lex_state = 11},
  [5033] = {.lex_state = 364, .external_lex_state = 11},
  [5034] = {.lex_state = 192, .external_lex_state = 2},
  [5035] = {.lex_state = 192, .external_lex_state = 2},
  [5036] = {.lex_state = 358, .external_lex_state = 11},
  [5037] = {.lex_state = 421, .external_lex_state = 3},
  [5038] = {.lex_state = 364, .external_lex_state = 11},
  [5039] = {.lex_state = 424, .external_lex_state = 3},
  [5040] = {.lex_state = 424, .external_lex_state = 3},
  [5041] = {.lex_state = 213},
  [5042] = {.lex_state = 421, .external_lex_state = 3},
  [5043] = {.lex_state = 427, .external_lex_state = 14},
  [5044] = {.lex_state = 192, .external_lex_state = 29},
  [5045] = {.lex_state = 192, .external_lex_state = 2},
  [5046] = {.lex_state = 262, .external_lex_state = 14},
  [5047] = {.lex_state = 128},
  [5048] = {.lex_state = 192, .external_lex_state = 2},
  [5049] = {.lex_state = 424, .external_lex_state = 3},
  [5050] = {.lex_state = 424, .external_lex_state = 3},
  [5051] = {.lex_state = 192, .external_lex_state = 2},
  [5052] = {.lex_state = 192, .external_lex_state = 2},
  [5053] = {.lex_state = 192, .external_lex_state = 2},
  [5054] = {.lex_state = 192, .external_lex_state = 2},
  [5055] = {.lex_state = 192, .external_lex_state = 2},
  [5056] = {.lex_state = 192, .external_lex_state = 2},
  [5057] = {.lex_state = 192, .external_lex_state = 2},
  [5058] = {.lex_state = 192, .external_lex_state = 2},
  [5059] = {.lex_state = 192, .external_lex_state = 2},
  [5060] = {.lex_state = 192, .external_lex_state = 2},
  [5061] = {.lex_state = 192, .external_lex_state = 29},
  [5062] = {.lex_state = 192, .external_lex_state = 2},
  [5063] = {.lex_state = 424, .external_lex_state = 14},
  [5064] = {.lex_state = 424, .external_lex_state = 3},
  [5065] = {.lex_state = 424, .external_lex_state = 3},
  [5066] = {.lex_state = 421, .external_lex_state = 3},
  [5067] = {.lex_state = 421, .external_lex_state = 3},
  [5068] = {.lex_state = 421, .external_lex_state = 3},
  [5069] = {.lex_state = 421, .external_lex_state = 3},
  [5070] = {.lex_state = 421, .external_lex_state = 3},
  [5071] = {.lex_state = 554, .external_lex_state = 16},
  [5072] = {.lex_state = 421, .external_lex_state = 3},
  [5073] = {.lex_state = 421, .external_lex_state = 3},
  [5074] = {.lex_state = 421, .external_lex_state = 3},
  [5075] = {.lex_state = 421, .external_lex_state = 3},
  [5076] = {.lex_state = 424, .external_lex_state = 3},
  [5077] = {.lex_state = 524, .external_lex_state = 21},
  [5078] = {.lex_state = 424, .external_lex_state = 3},
  [5079] = {.lex_state = 424, .external_lex_state = 3},
  [5080] = {.lex_state = 421, .external_lex_state = 3},
  [5081] = {.lex_state = 421, .external_lex_state = 3},
  [5082] = {.lex_state = 421, .external_lex_state = 3},
  [5083] = {.lex_state = 421, .external_lex_state = 14},
  [5084] = {.lex_state = 528, .external_lex_state = 3},
  [5085] = {.lex_state = 528, .external_lex_state = 3},
  [5086] = {.lex_state = 528, .external_lex_state = 3},
  [5087] = {.lex_state = 192, .external_lex_state = 2},
  [5088] = {.lex_state = 192, .external_lex_state = 2},
  [5089] = {.lex_state = 192, .external_lex_state = 2},
  [5090] = {.lex_state = 192, .external_lex_state = 2},
  [5091] = {.lex_state = 192, .external_lex_state = 2},
  [5092] = {.lex_state = 192, .external_lex_state = 2},
  [5093] = {.lex_state = 192, .external_lex_state = 2},
  [5094] = {.lex_state = 192, .external_lex_state = 2},
  [5095] = {.lex_state = 192, .external_lex_state = 2},
  [5096] = {.lex_state = 192, .external_lex_state = 2},
  [5097] = {.lex_state = 192, .external_lex_state = 29},
  [5098] = {.lex_state = 528, .external_lex_state = 3},
  [5099] = {.lex_state = 192, .external_lex_state = 29},
  [5100] = {.lex_state = 192, .external_lex_state = 2},
  [5101] = {.lex_state = 247, .external_lex_state = 3},
  [5102] = {.lex_state = 192, .external_lex_state = 2},
  [5103] = {.lex_state = 192, .external_lex_state = 2},
  [5104] = {.lex_state = 192, .external_lex_state = 2},
  [5105] = {.lex_state = 237},
  [5106] = {.lex_state = 192, .external_lex_state = 2},
  [5107] = {.lex_state = 353, .external_lex_state = 11},
  [5108] = {.lex_state = 353, .external_lex_state = 11},
  [5109] = {.lex_state = 353, .external_lex_state = 11},
  [5110] = {.lex_state = 353, .external_lex_state = 11},
  [5111] = {.lex_state = 192, .external_lex_state = 2},
  [5112] = {.lex_state = 192, .external_lex_state = 2},
  [5113] = {.lex_state = 358, .external_lex_state = 11},
  [5114] = {.lex_state = 361, .external_lex_state = 3},
  [5115] = {.lex_state = 364, .external_lex_state = 11},
  [5116] = {.lex_state = 262, .external_lex_state = 3},
  [5117] = {.lex_state = 361, .external_lex_state = 3},
  [5118] = {.lex_state = 213},
  [5119] = {.lex_state = 368, .external_lex_state = 3},
  [5120] = {.lex_state = 371, .external_lex_state = 14},
  [5121] = {.lex_state = 247, .external_lex_state = 3},
  [5122] = {.lex_state = 254, .external_lex_state = 8},
  [5123] = {.lex_state = 156, .external_lex_state = 3},
  [5124] = {.lex_state = 128},
  [5125] = {.lex_state = 128, .external_lex_state = 2},
  [5126] = {.lex_state = 128, .external_lex_state = 8},
  [5127] = {.lex_state = 192, .external_lex_state = 2},
  [5128] = {.lex_state = 192, .external_lex_state = 2},
  [5129] = {.lex_state = 192, .external_lex_state = 2},
  [5130] = {.lex_state = 192, .external_lex_state = 2},
  [5131] = {.lex_state = 192, .external_lex_state = 2},
  [5132] = {.lex_state = 192, .external_lex_state = 2},
  [5133] = {.lex_state = 192, .external_lex_state = 2},
  [5134] = {.lex_state = 192, .external_lex_state = 2},
  [5135] = {.lex_state = 192, .external_lex_state = 2},
  [5136] = {.lex_state = 192, .external_lex_state = 2},
  [5137] = {.lex_state = 192, .external_lex_state = 2},
  [5138] = {.lex_state = 192, .external_lex_state = 2},
  [5139] = {.lex_state = 192, .external_lex_state = 2},
  [5140] = {.lex_state = 192, .external_lex_state = 2},
  [5141] = {.lex_state = 192, .external_lex_state = 2},
  [5142] = {.lex_state = 192, .external_lex_state = 2},
  [5143] = {.lex_state = 192, .external_lex_state = 2},
  [5144] = {.lex_state = 192, .external_lex_state = 2},
  [5145] = {.lex_state = 237},
  [5146] = {.lex_state = 192, .external_lex_state = 2},
  [5147] = {.lex_state = 364, .external_lex_state = 11},
  [5148] = {.lex_state = 364, .external_lex_state = 11},
  [5149] = {.lex_state = 364, .external_lex_state = 11},
  [5150] = {.lex_state = 364, .external_lex_state = 11},
  [5151] = {.lex_state = 192, .external_lex_state = 2},
  [5152] = {.lex_state = 192, .external_lex_state = 2},
  [5153] = {.lex_state = 358, .external_lex_state = 11},
  [5154] = {.lex_state = 421, .external_lex_state = 3},
  [5155] = {.lex_state = 364, .external_lex_state = 11},
  [5156] = {.lex_state = 424, .external_lex_state = 3},
  [5157] = {.lex_state = 424, .external_lex_state = 3},
  [5158] = {.lex_state = 213},
  [5159] = {.lex_state = 421, .external_lex_state = 3},
  [5160] = {.lex_state = 427, .external_lex_state = 14},
  [5161] = {.lex_state = 192, .external_lex_state = 29},
  [5162] = {.lex_state = 192, .external_lex_state = 2},
  [5163] = {.lex_state = 262, .external_lex_state = 14},
  [5164] = {.lex_state = 361, .external_lex_state = 3},
  [5165] = {.lex_state = 361, .external_lex_state = 3},
  [5166] = {.lex_state = 361, .external_lex_state = 3},
  [5167] = {.lex_state = 361, .external_lex_state = 3},
  [5168] = {.lex_state = 192, .external_lex_state = 2},
  [5169] = {.lex_state = 192, .external_lex_state = 2},
  [5170] = {.lex_state = 192, .external_lex_state = 2},
  [5171] = {.lex_state = 192, .external_lex_state = 2},
  [5172] = {.lex_state = 192, .external_lex_state = 2},
  [5173] = {.lex_state = 192, .external_lex_state = 2},
  [5174] = {.lex_state = 192, .external_lex_state = 2},
  [5175] = {.lex_state = 192, .external_lex_state = 2},
  [5176] = {.lex_state = 192, .external_lex_state = 2},
  [5177] = {.lex_state = 192, .external_lex_state = 2},
  [5178] = {.lex_state = 192, .external_lex_state = 29},
  [5179] = {.lex_state = 192, .external_lex_state = 2},
  [5180] = {.lex_state = 365, .external_lex_state = 14},
  [5181] = {.lex_state = 361, .external_lex_state = 3},
  [5182] = {.lex_state = 361, .external_lex_state = 3},
  [5183] = {.lex_state = 361, .external_lex_state = 3},
  [5184] = {.lex_state = 192, .external_lex_state = 2},
  [5185] = {.lex_state = 361, .external_lex_state = 3},
  [5186] = {.lex_state = 192, .external_lex_state = 2},
  [5187] = {.lex_state = 361, .external_lex_state = 3},
  [5188] = {.lex_state = 524, .external_lex_state = 13},
  [5189] = {.lex_state = 361, .external_lex_state = 3},
  [5190] = {.lex_state = 361, .external_lex_state = 3},
  [5191] = {.lex_state = 361, .external_lex_state = 3},
  [5192] = {.lex_state = 361, .external_lex_state = 3},
  [5193] = {.lex_state = 361, .external_lex_state = 3},
  [5194] = {.lex_state = 361, .external_lex_state = 3},
  [5195] = {.lex_state = 361, .external_lex_state = 3},
  [5196] = {.lex_state = 554, .external_lex_state = 16},
  [5197] = {.lex_state = 361, .external_lex_state = 3},
  [5198] = {.lex_state = 361, .external_lex_state = 3},
  [5199] = {.lex_state = 361, .external_lex_state = 3},
  [5200] = {.lex_state = 361, .external_lex_state = 3},
  [5201] = {.lex_state = 421, .external_lex_state = 3},
  [5202] = {.lex_state = 421, .external_lex_state = 3},
  [5203] = {.lex_state = 192, .external_lex_state = 2},
  [5204] = {.lex_state = 421, .external_lex_state = 3},
  [5205] = {.lex_state = 421, .external_lex_state = 3},
  [5206] = {.lex_state = 192, .external_lex_state = 2},
  [5207] = {.lex_state = 421, .external_lex_state = 3},
  [5208] = {.lex_state = 524, .external_lex_state = 13},
  [5209] = {.lex_state = 421, .external_lex_state = 3},
  [5210] = {.lex_state = 262, .external_lex_state = 3},
  [5211] = {.lex_state = 524, .external_lex_state = 21},
  [5212] = {.lex_state = 262, .external_lex_state = 3},
  [5213] = {.lex_state = 361, .external_lex_state = 3},
  [5214] = {.lex_state = 361, .external_lex_state = 3},
  [5215] = {.lex_state = 361, .external_lex_state = 3},
  [5216] = {.lex_state = 361, .external_lex_state = 3},
  [5217] = {.lex_state = 361, .external_lex_state = 14},
  [5218] = {.lex_state = 192, .external_lex_state = 2},
  [5219] = {.lex_state = 156, .external_lex_state = 3},
  [5220] = {.lex_state = 424, .external_lex_state = 3},
  [5221] = {.lex_state = 424, .external_lex_state = 3},
  [5222] = {.lex_state = 192, .external_lex_state = 2},
  [5223] = {.lex_state = 192, .external_lex_state = 2},
  [5224] = {.lex_state = 192, .external_lex_state = 2},
  [5225] = {.lex_state = 192, .external_lex_state = 2},
  [5226] = {.lex_state = 192, .external_lex_state = 2},
  [5227] = {.lex_state = 192, .external_lex_state = 2},
  [5228] = {.lex_state = 192, .external_lex_state = 2},
  [5229] = {.lex_state = 192, .external_lex_state = 2},
  [5230] = {.lex_state = 192, .external_lex_state = 2},
  [5231] = {.lex_state = 192, .external_lex_state = 2},
  [5232] = {.lex_state = 192, .external_lex_state = 29},
  [5233] = {.lex_state = 192, .external_lex_state = 2},
  [5234] = {.lex_state = 424, .external_lex_state = 14},
  [5235] = {.lex_state = 424, .external_lex_state = 3},
  [5236] = {.lex_state = 424, .external_lex_state = 3},
  [5237] = {.lex_state = 421, .external_lex_state = 3},
  [5238] = {.lex_state = 421, .external_lex_state = 3},
  [5239] = {.lex_state = 421, .external_lex_state = 3},
  [5240] = {.lex_state = 421, .external_lex_state = 3},
  [5241] = {.lex_state = 421, .external_lex_state = 3},
  [5242] = {.lex_state = 554, .external_lex_state = 16},
  [5243] = {.lex_state = 421, .external_lex_state = 3},
  [5244] = {.lex_state = 421, .external_lex_state = 3},
  [5245] = {.lex_state = 421, .external_lex_state = 3},
  [5246] = {.lex_state = 421, .external_lex_state = 3},
  [5247] = {.lex_state = 424, .external_lex_state = 3},
  [5248] = {.lex_state = 524, .external_lex_state = 21},
  [5249] = {.lex_state = 424, .external_lex_state = 3},
  [5250] = {.lex_state = 424, .external_lex_state = 3},
  [5251] = {.lex_state = 421, .external_lex_state = 3},
  [5252] = {.lex_state = 421, .external_lex_state = 3},
  [5253] = {.lex_state = 421, .external_lex_state = 3},
  [5254] = {.lex_state = 421, .external_lex_state = 14},
  [5255] = {.lex_state = 528, .external_lex_state = 3},
  [5256] = {.lex_state = 528, .external_lex_state = 3},
  [5257] = {.lex_state = 528, .external_lex_state = 3},
  [5258] = {.lex_state = 192, .external_lex_state = 2},
  [5259] = {.lex_state = 192, .external_lex_state = 2},
  [5260] = {.lex_state = 192, .external_lex_state = 2},
  [5261] = {.lex_state = 192, .external_lex_state = 2},
  [5262] = {.lex_state = 192, .external_lex_state = 2},
  [5263] = {.lex_state = 192, .external_lex_state = 2},
  [5264] = {.lex_state = 192, .external_lex_state = 2},
  [5265] = {.lex_state = 192, .external_lex_state = 2},
  [5266] = {.lex_state = 192, .external_lex_state = 2},
  [5267] = {.lex_state = 192, .external_lex_state = 2},
  [5268] = {.lex_state = 192, .external_lex_state = 29},
  [5269] = {.lex_state = 528, .external_lex_state = 3},
  [5270] = {.lex_state = 192, .external_lex_state = 29},
  [5271] = {.lex_state = 192, .external_lex_state = 2},
  [5272] = {.lex_state = 156, .external_lex_state = 3},
  [5273] = {.lex_state = 508, .external_lex_state = 25},
  [5274] = {.lex_state = 192, .external_lex_state = 2},
  [5275] = {.lex_state = 192, .external_lex_state = 2},
  [5276] = {.lex_state = 237},
  [5277] = {.lex_state = 192, .external_lex_state = 2},
  [5278] = {.lex_state = 296, .external_lex_state = 26},
  [5279] = {.lex_state = 508, .external_lex_state = 25},
  [5280] = {.lex_state = 508, .external_lex_state = 25},
  [5281] = {.lex_state = 508, .external_lex_state = 25},
  [5282] = {.lex_state = 508, .external_lex_state = 27},
  [5283] = {.lex_state = 508, .external_lex_state = 25},
  [5284] = {.lex_state = 192, .external_lex_state = 2},
  [5285] = {.lex_state = 192, .external_lex_state = 2},
  [5286] = {.lex_state = 192, .external_lex_state = 2},
  [5287] = {.lex_state = 192, .external_lex_state = 2},
  [5288] = {.lex_state = 192, .external_lex_state = 2},
  [5289] = {.lex_state = 192, .external_lex_state = 2},
  [5290] = {.lex_state = 192, .external_lex_state = 2},
  [5291] = {.lex_state = 192, .external_lex_state = 2},
  [5292] = {.lex_state = 192, .external_lex_state = 2},
  [5293] = {.lex_state = 192, .external_lex_state = 2},
  [5294] = {.lex_state = 192, .external_lex_state = 2},
  [5295] = {.lex_state = 192, .external_lex_state = 2},
  [5296] = {.lex_state = 237},
  [5297] = {.lex_state = 192, .external_lex_state = 2},
  [5298] = {.lex_state = 296, .external_lex_state = 26},
  [5299] = {.lex_state = 421, .external_lex_state = 25},
  [5300] = {.lex_state = 424, .external_lex_state = 25},
  [5301] = {.lex_state = 424, .external_lex_state = 25},
  [5302] = {.lex_state = 427, .external_lex_state = 27},
  [5303] = {.lex_state = 192, .external_lex_state = 29},
  [5304] = {.lex_state = 192, .external_lex_state = 2},
  [5305] = {.lex_state = 631, .external_lex_state = 27},
  [5306] = {.lex_state = 508, .external_lex_state = 25},
  [5307] = {.lex_state = 508, .external_lex_state = 25},
  [5308] = {.lex_state = 508, .external_lex_state = 25},
  [5309] = {.lex_state = 192, .external_lex_state = 2},
  [5310] = {.lex_state = 508, .external_lex_state = 25},
  [5311] = {.lex_state = 192, .external_lex_state = 2},
  [5312] = {.lex_state = 508, .external_lex_state = 25},
  [5313] = {.lex_state = 524, .external_lex_state = 13},
  [5314] = {.lex_state = 508, .external_lex_state = 25},
  [5315] = {.lex_state = 508, .external_lex_state = 25},
  [5316] = {.lex_state = 508, .external_lex_state = 25},
  [5317] = {.lex_state = 508, .external_lex_state = 25},
  [5318] = {.lex_state = 508, .external_lex_state = 25},
  [5319] = {.lex_state = 508, .external_lex_state = 25},
  [5320] = {.lex_state = 508, .external_lex_state = 25},
  [5321] = {.lex_state = 554, .external_lex_state = 16},
  [5322] = {.lex_state = 508, .external_lex_state = 25},
  [5323] = {.lex_state = 508, .external_lex_state = 25},
  [5324] = {.lex_state = 508, .external_lex_state = 25},
  [5325] = {.lex_state = 508, .external_lex_state = 25},
  [5326] = {.lex_state = 421, .external_lex_state = 25},
  [5327] = {.lex_state = 421, .external_lex_state = 27},
  [5328] = {.lex_state = 421, .external_lex_state = 25},
  [5329] = {.lex_state = 421, .external_lex_state = 25},
  [5330] = {.lex_state = 192, .external_lex_state = 2},
  [5331] = {.lex_state = 421, .external_lex_state = 25},
  [5332] = {.lex_state = 421, .external_lex_state = 25},
  [5333] = {.lex_state = 192, .external_lex_state = 2},
  [5334] = {.lex_state = 192, .external_lex_state = 2},
  [5335] = {.lex_state = 192, .external_lex_state = 2},
  [5336] = {.lex_state = 192, .external_lex_state = 2},
  [5337] = {.lex_state = 192, .external_lex_state = 2},
  [5338] = {.lex_state = 192, .external_lex_state = 2},
  [5339] = {.lex_state = 192, .external_lex_state = 2},
  [5340] = {.lex_state = 192, .external_lex_state = 2},
  [5341] = {.lex_state = 192, .external_lex_state = 2},
  [5342] = {.lex_state = 192, .external_lex_state = 2},
  [5343] = {.lex_state = 192, .external_lex_state = 2},
  [5344] = {.lex_state = 421, .external_lex_state = 25},
  [5345] = {.lex_state = 524, .external_lex_state = 13},
  [5346] = {.lex_state = 421, .external_lex_state = 25},
  [5347] = {.lex_state = 192, .external_lex_state = 29},
  [5348] = {.lex_state = 192, .external_lex_state = 2},
  [5349] = {.lex_state = 421, .external_lex_state = 27},
  [5350] = {.lex_state = 340, .external_lex_state = 19},
  [5351] = {.lex_state = 524, .external_lex_state = 21},
  [5352] = {.lex_state = 340, .external_lex_state = 19},
  [5353] = {.lex_state = 340, .external_lex_state = 19},
  [5354] = {.lex_state = 508, .external_lex_state = 25},
  [5355] = {.lex_state = 508, .external_lex_state = 25},
  [5356] = {.lex_state = 508, .external_lex_state = 25},
  [5357] = {.lex_state = 634, .external_lex_state = 27},
  [5358] = {.lex_state = 156, .external_lex_state = 3},
  [5359] = {.lex_state = 128},
  [5360] = {.lex_state = 361, .external_lex_state = 3},
  [5361] = {.lex_state = 361, .external_lex_state = 3},
  [5362] = {.lex_state = 361, .external_lex_state = 3},
  [5363] = {.lex_state = 361, .external_lex_state = 3},
  [5364] = {.lex_state = 192, .external_lex_state = 2},
  [5365] = {.lex_state = 192, .external_lex_state = 2},
  [5366] = {.lex_state = 192, .external_lex_state = 2},
  [5367] = {.lex_state = 192, .external_lex_state = 2},
  [5368] = {.lex_state = 192, .external_lex_state = 2},
  [5369] = {.lex_state = 192, .external_lex_state = 2},
  [5370] = {.lex_state = 192, .external_lex_state = 2},
  [5371] = {.lex_state = 192, .external_lex_state = 2},
  [5372] = {.lex_state = 192, .external_lex_state = 2},
  [5373] = {.lex_state = 192, .external_lex_state = 2},
  [5374] = {.lex_state = 192, .external_lex_state = 29},
  [5375] = {.lex_state = 192, .external_lex_state = 2},
  [5376] = {.lex_state = 365, .external_lex_state = 14},
  [5377] = {.lex_state = 361, .external_lex_state = 3},
  [5378] = {.lex_state = 361, .external_lex_state = 3},
  [5379] = {.lex_state = 361, .external_lex_state = 3},
  [5380] = {.lex_state = 192, .external_lex_state = 2},
  [5381] = {.lex_state = 361, .external_lex_state = 3},
  [5382] = {.lex_state = 192, .external_lex_state = 2},
  [5383] = {.lex_state = 361, .external_lex_state = 3},
  [5384] = {.lex_state = 524, .external_lex_state = 13},
  [5385] = {.lex_state = 361, .external_lex_state = 3},
  [5386] = {.lex_state = 361, .external_lex_state = 3},
  [5387] = {.lex_state = 361, .external_lex_state = 3},
  [5388] = {.lex_state = 361, .external_lex_state = 3},
  [5389] = {.lex_state = 361, .external_lex_state = 3},
  [5390] = {.lex_state = 361, .external_lex_state = 3},
  [5391] = {.lex_state = 361, .external_lex_state = 3},
  [5392] = {.lex_state = 554, .external_lex_state = 16},
  [5393] = {.lex_state = 361, .external_lex_state = 3},
  [5394] = {.lex_state = 361, .external_lex_state = 3},
  [5395] = {.lex_state = 361, .external_lex_state = 3},
  [5396] = {.lex_state = 361, .external_lex_state = 3},
  [5397] = {.lex_state = 262, .external_lex_state = 3},
  [5398] = {.lex_state = 524, .external_lex_state = 21},
  [5399] = {.lex_state = 262, .external_lex_state = 3},
  [5400] = {.lex_state = 361, .external_lex_state = 3},
  [5401] = {.lex_state = 361, .external_lex_state = 3},
  [5402] = {.lex_state = 361, .external_lex_state = 3},
  [5403] = {.lex_state = 361, .external_lex_state = 3},
  [5404] = {.lex_state = 361, .external_lex_state = 14},
  [5405] = {.lex_state = 192, .external_lex_state = 2},
  [5406] = {.lex_state = 156, .external_lex_state = 3},
  [5407] = {.lex_state = 128},
  [5408] = {.lex_state = 528, .external_lex_state = 3},
  [5409] = {.lex_state = 528, .external_lex_state = 3},
  [5410] = {.lex_state = 528, .external_lex_state = 3},
  [5411] = {.lex_state = 192, .external_lex_state = 2},
  [5412] = {.lex_state = 192, .external_lex_state = 2},
  [5413] = {.lex_state = 192, .external_lex_state = 2},
  [5414] = {.lex_state = 192, .external_lex_state = 2},
  [5415] = {.lex_state = 192, .external_lex_state = 2},
  [5416] = {.lex_state = 192, .external_lex_state = 2},
  [5417] = {.lex_state = 192, .external_lex_state = 2},
  [5418] = {.lex_state = 192, .external_lex_state = 2},
  [5419] = {.lex_state = 192, .external_lex_state = 2},
  [5420] = {.lex_state = 192, .external_lex_state = 2},
  [5421] = {.lex_state = 192, .external_lex_state = 29},
  [5422] = {.lex_state = 528, .external_lex_state = 3},
  [5423] = {.lex_state = 192, .external_lex_state = 29},
  [5424] = {.lex_state = 192, .external_lex_state = 2},
  [5425] = {.lex_state = 528, .external_lex_state = 3},
  [5426] = {.lex_state = 528, .external_lex_state = 3},
  [5427] = {.lex_state = 192, .external_lex_state = 2},
  [5428] = {.lex_state = 192, .external_lex_state = 2},
  [5429] = {.lex_state = 237},
  [5430] = {.lex_state = 192, .external_lex_state = 2},
  [5431] = {.lex_state = 358, .external_lex_state = 11},
  [5432] = {.lex_state = 361, .external_lex_state = 3},
  [5433] = {.lex_state = 361, .external_lex_state = 3},
  [5434] = {.lex_state = 361, .external_lex_state = 3},
  [5435] = {.lex_state = 371, .external_lex_state = 14},
  [5436] = {.lex_state = 528, .external_lex_state = 3},
  [5437] = {.lex_state = 192, .external_lex_state = 29},
  [5438] = {.lex_state = 128, .external_lex_state = 2},
  [5439] = {.lex_state = 254, .external_lex_state = 8},
  [5440] = {.lex_state = 192, .external_lex_state = 2},
  [5441] = {.lex_state = 192, .external_lex_state = 2},
  [5442] = {.lex_state = 192, .external_lex_state = 2},
  [5443] = {.lex_state = 192, .external_lex_state = 2},
  [5444] = {.lex_state = 192, .external_lex_state = 2},
  [5445] = {.lex_state = 192, .external_lex_state = 2},
  [5446] = {.lex_state = 192, .external_lex_state = 2},
  [5447] = {.lex_state = 192, .external_lex_state = 2},
  [5448] = {.lex_state = 192, .external_lex_state = 2},
  [5449] = {.lex_state = 192, .external_lex_state = 2},
  [5450] = {.lex_state = 192, .external_lex_state = 2},
  [5451] = {.lex_state = 192, .external_lex_state = 2},
  [5452] = {.lex_state = 237},
  [5453] = {.lex_state = 192, .external_lex_state = 2},
  [5454] = {.lex_state = 358, .external_lex_state = 11},
  [5455] = {.lex_state = 421, .external_lex_state = 3},
  [5456] = {.lex_state = 424, .external_lex_state = 3},
  [5457] = {.lex_state = 424, .external_lex_state = 3},
  [5458] = {.lex_state = 427, .external_lex_state = 14},
  [5459] = {.lex_state = 192, .external_lex_state = 29},
  [5460] = {.lex_state = 192, .external_lex_state = 2},
  [5461] = {.lex_state = 365, .external_lex_state = 14},
  [5462] = {.lex_state = 361, .external_lex_state = 3},
  [5463] = {.lex_state = 361, .external_lex_state = 3},
  [5464] = {.lex_state = 361, .external_lex_state = 3},
  [5465] = {.lex_state = 361, .external_lex_state = 3},
  [5466] = {.lex_state = 192, .external_lex_state = 2},
  [5467] = {.lex_state = 192, .external_lex_state = 2},
  [5468] = {.lex_state = 192, .external_lex_state = 2},
  [5469] = {.lex_state = 192, .external_lex_state = 2},
  [5470] = {.lex_state = 192, .external_lex_state = 2},
  [5471] = {.lex_state = 192, .external_lex_state = 2},
  [5472] = {.lex_state = 192, .external_lex_state = 2},
  [5473] = {.lex_state = 192, .external_lex_state = 2},
  [5474] = {.lex_state = 192, .external_lex_state = 2},
  [5475] = {.lex_state = 192, .external_lex_state = 2},
  [5476] = {.lex_state = 192, .external_lex_state = 29},
  [5477] = {.lex_state = 192, .external_lex_state = 2},
  [5478] = {.lex_state = 365, .external_lex_state = 14},
  [5479] = {.lex_state = 361, .external_lex_state = 3},
  [5480] = {.lex_state = 361, .external_lex_state = 3},
  [5481] = {.lex_state = 361, .external_lex_state = 3},
  [5482] = {.lex_state = 192, .external_lex_state = 2},
  [5483] = {.lex_state = 361, .external_lex_state = 3},
  [5484] = {.lex_state = 192, .external_lex_state = 2},
  [5485] = {.lex_state = 361, .external_lex_state = 3},
  [5486] = {.lex_state = 524, .external_lex_state = 13},
  [5487] = {.lex_state = 361, .external_lex_state = 3},
  [5488] = {.lex_state = 361, .external_lex_state = 3},
  [5489] = {.lex_state = 361, .external_lex_state = 3},
  [5490] = {.lex_state = 361, .external_lex_state = 3},
  [5491] = {.lex_state = 361, .external_lex_state = 3},
  [5492] = {.lex_state = 361, .external_lex_state = 3},
  [5493] = {.lex_state = 361, .external_lex_state = 3},
  [5494] = {.lex_state = 554, .external_lex_state = 16},
  [5495] = {.lex_state = 361, .external_lex_state = 3},
  [5496] = {.lex_state = 361, .external_lex_state = 3},
  [5497] = {.lex_state = 361, .external_lex_state = 3},
  [5498] = {.lex_state = 361, .external_lex_state = 3},
  [5499] = {.lex_state = 421, .external_lex_state = 3},
  [5500] = {.lex_state = 421, .external_lex_state = 3},
  [5501] = {.lex_state = 192, .external_lex_state = 2},
  [5502] = {.lex_state = 421, .external_lex_state = 3},
  [5503] = {.lex_state = 192, .external_lex_state = 2},
  [5504] = {.lex_state = 421, .external_lex_state = 3},
  [5505] = {.lex_state = 524, .external_lex_state = 13},
  [5506] = {.lex_state = 421, .external_lex_state = 3},
  [5507] = {.lex_state = 262, .external_lex_state = 3},
  [5508] = {.lex_state = 524, .external_lex_state = 21},
  [5509] = {.lex_state = 262, .external_lex_state = 3},
  [5510] = {.lex_state = 361, .external_lex_state = 3},
  [5511] = {.lex_state = 361, .external_lex_state = 3},
  [5512] = {.lex_state = 361, .external_lex_state = 3},
  [5513] = {.lex_state = 361, .external_lex_state = 3},
  [5514] = {.lex_state = 361, .external_lex_state = 14},
  [5515] = {.lex_state = 361, .external_lex_state = 3},
  [5516] = {.lex_state = 361, .external_lex_state = 3},
  [5517] = {.lex_state = 361, .external_lex_state = 3},
  [5518] = {.lex_state = 192, .external_lex_state = 2},
  [5519] = {.lex_state = 361, .external_lex_state = 3},
  [5520] = {.lex_state = 361, .external_lex_state = 3},
  [5521] = {.lex_state = 192, .external_lex_state = 2},
  [5522] = {.lex_state = 192, .external_lex_state = 2},
  [5523] = {.lex_state = 192, .external_lex_state = 2},
  [5524] = {.lex_state = 192, .external_lex_state = 2},
  [5525] = {.lex_state = 192, .external_lex_state = 2},
  [5526] = {.lex_state = 192, .external_lex_state = 2},
  [5527] = {.lex_state = 192, .external_lex_state = 2},
  [5528] = {.lex_state = 192, .external_lex_state = 2},
  [5529] = {.lex_state = 192, .external_lex_state = 2},
  [5530] = {.lex_state = 192, .external_lex_state = 2},
  [5531] = {.lex_state = 192, .external_lex_state = 2},
  [5532] = {.lex_state = 361, .external_lex_state = 3},
  [5533] = {.lex_state = 524, .external_lex_state = 13},
  [5534] = {.lex_state = 361, .external_lex_state = 3},
  [5535] = {.lex_state = 192, .external_lex_state = 29},
  [5536] = {.lex_state = 192, .external_lex_state = 2},
  [5537] = {.lex_state = 416, .external_lex_state = 28},
  [5538] = {.lex_state = 235, .external_lex_state = 13},
  [5539] = {.lex_state = 192, .external_lex_state = 2},
  [5540] = {.lex_state = 192, .external_lex_state = 2},
  [5541] = {.lex_state = 192, .external_lex_state = 2},
  [5542] = {.lex_state = 237},
  [5543] = {.lex_state = 419, .external_lex_state = 6},
  [5544] = {.lex_state = 192, .external_lex_state = 2},
  [5545] = {.lex_state = 353, .external_lex_state = 11},
  [5546] = {.lex_state = 353, .external_lex_state = 11},
  [5547] = {.lex_state = 353, .external_lex_state = 11},
  [5548] = {.lex_state = 353, .external_lex_state = 11},
  [5549] = {.lex_state = 356, .external_lex_state = 13},
  [5550] = {.lex_state = 192, .external_lex_state = 2},
  [5551] = {.lex_state = 192, .external_lex_state = 2},
  [5552] = {.lex_state = 358, .external_lex_state = 11},
  [5553] = {.lex_state = 508, .external_lex_state = 3},
  [5554] = {.lex_state = 343, .external_lex_state = 8},
  [5555] = {.lex_state = 343, .external_lex_state = 8},
  [5556] = {.lex_state = 678, .external_lex_state = 8},
  [5557] = {.lex_state = 343, .external_lex_state = 8},
  [5558] = {.lex_state = 213},
  [5559] = {.lex_state = 421, .external_lex_state = 3},
  [5560] = {.lex_state = 508, .external_lex_state = 14},
  [5561] = {.lex_state = 128},
  [5562] = {.lex_state = 128},
  [5563] = {.lex_state = 128, .external_lex_state = 2},
  [5564] = {.lex_state = 528, .external_lex_state = 3},
  [5565] = {.lex_state = 528, .external_lex_state = 3},
  [5566] = {.lex_state = 528, .external_lex_state = 3},
  [5567] = {.lex_state = 528, .external_lex_state = 3},
  [5568] = {.lex_state = 528, .external_lex_state = 3},
  [5569] = {.lex_state = 554, .external_lex_state = 16},
  [5570] = {.lex_state = 528, .external_lex_state = 3},
  [5571] = {.lex_state = 528, .external_lex_state = 3},
  [5572] = {.lex_state = 528, .external_lex_state = 3},
  [5573] = {.lex_state = 528, .external_lex_state = 3},
  [5574] = {.lex_state = 421, .external_lex_state = 3},
  [5575] = {.lex_state = 421, .external_lex_state = 14},
  [5576] = {.lex_state = 421, .external_lex_state = 3},
  [5577] = {.lex_state = 421, .external_lex_state = 3},
  [5578] = {.lex_state = 192, .external_lex_state = 2},
  [5579] = {.lex_state = 421, .external_lex_state = 3},
  [5580] = {.lex_state = 421, .external_lex_state = 3},
  [5581] = {.lex_state = 192, .external_lex_state = 2},
  [5582] = {.lex_state = 192, .external_lex_state = 2},
  [5583] = {.lex_state = 192, .external_lex_state = 2},
  [5584] = {.lex_state = 192, .external_lex_state = 2},
  [5585] = {.lex_state = 192, .external_lex_state = 2},
  [5586] = {.lex_state = 192, .external_lex_state = 2},
  [5587] = {.lex_state = 192, .external_lex_state = 2},
  [5588] = {.lex_state = 192, .external_lex_state = 2},
  [5589] = {.lex_state = 192, .external_lex_state = 2},
  [5590] = {.lex_state = 192, .external_lex_state = 2},
  [5591] = {.lex_state = 192, .external_lex_state = 2},
  [5592] = {.lex_state = 421, .external_lex_state = 3},
  [5593] = {.lex_state = 524, .external_lex_state = 13},
  [5594] = {.lex_state = 421, .external_lex_state = 3},
  [5595] = {.lex_state = 192, .external_lex_state = 29},
  [5596] = {.lex_state = 192, .external_lex_state = 2},
  [5597] = {.lex_state = 421, .external_lex_state = 14},
  [5598] = {.lex_state = 353, .external_lex_state = 8},
  [5599] = {.lex_state = 353, .external_lex_state = 8},
  [5600] = {.lex_state = 192, .external_lex_state = 2},
  [5601] = {.lex_state = 528, .external_lex_state = 3},
  [5602] = {.lex_state = 528, .external_lex_state = 3},
  [5603] = {.lex_state = 528, .external_lex_state = 3},
  [5604] = {.lex_state = 361, .external_lex_state = 14},
  [5605] = {.lex_state = 192, .external_lex_state = 2},
  [5606] = {.lex_state = 511, .external_lex_state = 11},
  [5607] = {.lex_state = 511, .external_lex_state = 11},
  [5608] = {.lex_state = 511, .external_lex_state = 11},
  [5609] = {.lex_state = 511, .external_lex_state = 11},
  [5610] = {.lex_state = 192, .external_lex_state = 2},
  [5611] = {.lex_state = 192, .external_lex_state = 2},
  [5612] = {.lex_state = 361, .external_lex_state = 3},
  [5613] = {.lex_state = 213},
  [5614] = {.lex_state = 259, .external_lex_state = 3},
  [5615] = {.lex_state = 365, .external_lex_state = 14},
  [5616] = {.lex_state = 361, .external_lex_state = 3},
  [5617] = {.lex_state = 361, .external_lex_state = 3},
  [5618] = {.lex_state = 361, .external_lex_state = 14},
  [5619] = {.lex_state = 192, .external_lex_state = 2},
  [5620] = {.lex_state = 361, .external_lex_state = 3},
  [5621] = {.lex_state = 192, .external_lex_state = 2},
  [5622] = {.lex_state = 192, .external_lex_state = 2},
  [5623] = {.lex_state = 237},
  [5624] = {.lex_state = 192, .external_lex_state = 2},
  [5625] = {.lex_state = 358, .external_lex_state = 11},
  [5626] = {.lex_state = 361, .external_lex_state = 3},
  [5627] = {.lex_state = 361, .external_lex_state = 3},
  [5628] = {.lex_state = 361, .external_lex_state = 3},
  [5629] = {.lex_state = 371, .external_lex_state = 14},
  [5630] = {.lex_state = 361, .external_lex_state = 3},
  [5631] = {.lex_state = 192, .external_lex_state = 2},
  [5632] = {.lex_state = 192, .external_lex_state = 2},
  [5633] = {.lex_state = 192, .external_lex_state = 2},
  [5634] = {.lex_state = 192, .external_lex_state = 2},
  [5635] = {.lex_state = 192, .external_lex_state = 2},
  [5636] = {.lex_state = 192, .external_lex_state = 2},
  [5637] = {.lex_state = 192, .external_lex_state = 2},
  [5638] = {.lex_state = 192, .external_lex_state = 2},
  [5639] = {.lex_state = 192, .external_lex_state = 2},
  [5640] = {.lex_state = 192, .external_lex_state = 2},
  [5641] = {.lex_state = 192, .external_lex_state = 2},
  [5642] = {.lex_state = 192, .external_lex_state = 2},
  [5643] = {.lex_state = 192, .external_lex_state = 2},
  [5644] = {.lex_state = 237},
  [5645] = {.lex_state = 192, .external_lex_state = 2},
  [5646] = {.lex_state = 358, .external_lex_state = 11},
  [5647] = {.lex_state = 421, .external_lex_state = 3},
  [5648] = {.lex_state = 421, .external_lex_state = 3},
  [5649] = {.lex_state = 421, .external_lex_state = 3},
  [5650] = {.lex_state = 427, .external_lex_state = 14},
  [5651] = {.lex_state = 262, .external_lex_state = 3},
  [5652] = {.lex_state = 524, .external_lex_state = 13},
  [5653] = {.lex_state = 361, .external_lex_state = 3},
  [5654] = {.lex_state = 192, .external_lex_state = 29},
  [5655] = {.lex_state = 192, .external_lex_state = 2},
  [5656] = {.lex_state = 361, .external_lex_state = 14},
  [5657] = {.lex_state = 254, .external_lex_state = 8},
  [5658] = {.lex_state = 128, .external_lex_state = 2},
  [5659] = {.lex_state = 128, .external_lex_state = 8},
  [5660] = {.lex_state = 247, .external_lex_state = 3},
  [5661] = {.lex_state = 247, .external_lex_state = 3},
  [5662] = {.lex_state = 247, .external_lex_state = 3},
  [5663] = {.lex_state = 247, .external_lex_state = 3},
  [5664] = {.lex_state = 247, .external_lex_state = 3},
  [5665] = {.lex_state = 247, .external_lex_state = 3},
  [5666] = {.lex_state = 247, .external_lex_state = 3},
  [5667] = {.lex_state = 247, .external_lex_state = 3},
  [5668] = {.lex_state = 247, .external_lex_state = 3},
  [5669] = {.lex_state = 247, .external_lex_state = 3},
  [5670] = {.lex_state = 554, .external_lex_state = 16},
  [5671] = {.lex_state = 247, .external_lex_state = 3},
  [5672] = {.lex_state = 247, .external_lex_state = 3},
  [5673] = {.lex_state = 247, .external_lex_state = 3},
  [5674] = {.lex_state = 247, .external_lex_state = 3},
  [5675] = {.lex_state = 192, .external_lex_state = 2},
  [5676] = {.lex_state = 254, .external_lex_state = 11},
  [5677] = {.lex_state = 254, .external_lex_state = 11},
  [5678] = {.lex_state = 254, .external_lex_state = 11},
  [5679] = {.lex_state = 254, .external_lex_state = 11},
  [5680] = {.lex_state = 192, .external_lex_state = 2},
  [5681] = {.lex_state = 192, .external_lex_state = 2},
  [5682] = {.lex_state = 424, .external_lex_state = 3},
  [5683] = {.lex_state = 254, .external_lex_state = 11},
  [5684] = {.lex_state = 213},
  [5685] = {.lex_state = 424, .external_lex_state = 3},
  [5686] = {.lex_state = 424, .external_lex_state = 14},
  [5687] = {.lex_state = 424, .external_lex_state = 3},
  [5688] = {.lex_state = 421, .external_lex_state = 3},
  [5689] = {.lex_state = 421, .external_lex_state = 14},
  [5690] = {.lex_state = 192, .external_lex_state = 2},
  [5691] = {.lex_state = 424, .external_lex_state = 3},
  [5692] = {.lex_state = 421, .external_lex_state = 3},
  [5693] = {.lex_state = 192, .external_lex_state = 2},
  [5694] = {.lex_state = 192, .external_lex_state = 2},
  [5695] = {.lex_state = 192, .external_lex_state = 2},
  [5696] = {.lex_state = 192, .external_lex_state = 2},
  [5697] = {.lex_state = 192, .external_lex_state = 2},
  [5698] = {.lex_state = 192, .external_lex_state = 2},
  [5699] = {.lex_state = 192, .external_lex_state = 2},
  [5700] = {.lex_state = 192, .external_lex_state = 2},
  [5701] = {.lex_state = 192, .external_lex_state = 2},
  [5702] = {.lex_state = 192, .external_lex_state = 2},
  [5703] = {.lex_state = 192, .external_lex_state = 2},
  [5704] = {.lex_state = 424, .external_lex_state = 3},
  [5705] = {.lex_state = 524, .external_lex_state = 13},
  [5706] = {.lex_state = 424, .external_lex_state = 3},
  [5707] = {.lex_state = 192, .external_lex_state = 29},
  [5708] = {.lex_state = 192, .external_lex_state = 2},
  [5709] = {.lex_state = 421, .external_lex_state = 14},
  [5710] = {.lex_state = 192, .external_lex_state = 2},
  [5711] = {.lex_state = 192, .external_lex_state = 2},
  [5712] = {.lex_state = 192, .external_lex_state = 2},
  [5713] = {.lex_state = 192, .external_lex_state = 2},
  [5714] = {.lex_state = 528, .external_lex_state = 3},
  [5715] = {.lex_state = 528, .external_lex_state = 3},
  [5716] = {.lex_state = 213},
  [5717] = {.lex_state = 259, .external_lex_state = 3},
  [5718] = {.lex_state = 247, .external_lex_state = 3},
  [5719] = {.lex_state = 262, .external_lex_state = 14},
  [5720] = {.lex_state = 192, .external_lex_state = 2},
  [5721] = {.lex_state = 511, .external_lex_state = 11},
  [5722] = {.lex_state = 511, .external_lex_state = 11},
  [5723] = {.lex_state = 511, .external_lex_state = 11},
  [5724] = {.lex_state = 511, .external_lex_state = 11},
  [5725] = {.lex_state = 192, .external_lex_state = 2},
  [5726] = {.lex_state = 192, .external_lex_state = 2},
  [5727] = {.lex_state = 361, .external_lex_state = 3},
  [5728] = {.lex_state = 213},
  [5729] = {.lex_state = 259, .external_lex_state = 3},
  [5730] = {.lex_state = 365, .external_lex_state = 14},
  [5731] = {.lex_state = 361, .external_lex_state = 3},
  [5732] = {.lex_state = 361, .external_lex_state = 3},
  [5733] = {.lex_state = 361, .external_lex_state = 14},
  [5734] = {.lex_state = 192, .external_lex_state = 2},
  [5735] = {.lex_state = 361, .external_lex_state = 3},
  [5736] = {.lex_state = 192, .external_lex_state = 2},
  [5737] = {.lex_state = 192, .external_lex_state = 2},
  [5738] = {.lex_state = 237},
  [5739] = {.lex_state = 192, .external_lex_state = 2},
  [5740] = {.lex_state = 358, .external_lex_state = 11},
  [5741] = {.lex_state = 361, .external_lex_state = 3},
  [5742] = {.lex_state = 361, .external_lex_state = 3},
  [5743] = {.lex_state = 361, .external_lex_state = 3},
  [5744] = {.lex_state = 371, .external_lex_state = 14},
  [5745] = {.lex_state = 361, .external_lex_state = 3},
  [5746] = {.lex_state = 192, .external_lex_state = 2},
  [5747] = {.lex_state = 192, .external_lex_state = 2},
  [5748] = {.lex_state = 192, .external_lex_state = 2},
  [5749] = {.lex_state = 192, .external_lex_state = 2},
  [5750] = {.lex_state = 192, .external_lex_state = 2},
  [5751] = {.lex_state = 192, .external_lex_state = 2},
  [5752] = {.lex_state = 192, .external_lex_state = 2},
  [5753] = {.lex_state = 192, .external_lex_state = 2},
  [5754] = {.lex_state = 192, .external_lex_state = 2},
  [5755] = {.lex_state = 192, .external_lex_state = 2},
  [5756] = {.lex_state = 192, .external_lex_state = 2},
  [5757] = {.lex_state = 192, .external_lex_state = 2},
  [5758] = {.lex_state = 192, .external_lex_state = 2},
  [5759] = {.lex_state = 237},
  [5760] = {.lex_state = 192, .external_lex_state = 2},
  [5761] = {.lex_state = 358, .external_lex_state = 11},
  [5762] = {.lex_state = 421, .external_lex_state = 3},
  [5763] = {.lex_state = 421, .external_lex_state = 3},
  [5764] = {.lex_state = 421, .external_lex_state = 3},
  [5765] = {.lex_state = 427, .external_lex_state = 14},
  [5766] = {.lex_state = 262, .external_lex_state = 3},
  [5767] = {.lex_state = 524, .external_lex_state = 13},
  [5768] = {.lex_state = 361, .external_lex_state = 3},
  [5769] = {.lex_state = 192, .external_lex_state = 29},
  [5770] = {.lex_state = 192, .external_lex_state = 2},
  [5771] = {.lex_state = 361, .external_lex_state = 14},
  [5772] = {.lex_state = 254, .external_lex_state = 8},
  [5773] = {.lex_state = 128, .external_lex_state = 2},
  [5774] = {.lex_state = 128, .external_lex_state = 8},
  [5775] = {.lex_state = 247, .external_lex_state = 3},
  [5776] = {.lex_state = 247, .external_lex_state = 3},
  [5777] = {.lex_state = 247, .external_lex_state = 3},
  [5778] = {.lex_state = 247, .external_lex_state = 3},
  [5779] = {.lex_state = 247, .external_lex_state = 3},
  [5780] = {.lex_state = 247, .external_lex_state = 3},
  [5781] = {.lex_state = 247, .external_lex_state = 3},
  [5782] = {.lex_state = 247, .external_lex_state = 3},
  [5783] = {.lex_state = 247, .external_lex_state = 3},
  [5784] = {.lex_state = 247, .external_lex_state = 3},
  [5785] = {.lex_state = 554, .external_lex_state = 16},
  [5786] = {.lex_state = 247, .external_lex_state = 3},
  [5787] = {.lex_state = 247, .external_lex_state = 3},
  [5788] = {.lex_state = 247, .external_lex_state = 3},
  [5789] = {.lex_state = 247, .external_lex_state = 3},
  [5790] = {.lex_state = 192, .external_lex_state = 2},
  [5791] = {.lex_state = 254, .external_lex_state = 11},
  [5792] = {.lex_state = 254, .external_lex_state = 11},
  [5793] = {.lex_state = 254, .external_lex_state = 11},
  [5794] = {.lex_state = 254, .external_lex_state = 11},
  [5795] = {.lex_state = 192, .external_lex_state = 2},
  [5796] = {.lex_state = 192, .external_lex_state = 2},
  [5797] = {.lex_state = 424, .external_lex_state = 3},
  [5798] = {.lex_state = 254, .external_lex_state = 11},
  [5799] = {.lex_state = 213},
  [5800] = {.lex_state = 424, .external_lex_state = 3},
  [5801] = {.lex_state = 424, .external_lex_state = 14},
  [5802] = {.lex_state = 424, .external_lex_state = 3},
  [5803] = {.lex_state = 421, .external_lex_state = 3},
  [5804] = {.lex_state = 421, .external_lex_state = 14},
  [5805] = {.lex_state = 192, .external_lex_state = 2},
  [5806] = {.lex_state = 424, .external_lex_state = 3},
  [5807] = {.lex_state = 421, .external_lex_state = 3},
  [5808] = {.lex_state = 192, .external_lex_state = 2},
  [5809] = {.lex_state = 192, .external_lex_state = 2},
  [5810] = {.lex_state = 192, .external_lex_state = 2},
  [5811] = {.lex_state = 192, .external_lex_state = 2},
  [5812] = {.lex_state = 192, .external_lex_state = 2},
  [5813] = {.lex_state = 192, .external_lex_state = 2},
  [5814] = {.lex_state = 192, .external_lex_state = 2},
  [5815] = {.lex_state = 192, .external_lex_state = 2},
  [5816] = {.lex_state = 192, .external_lex_state = 2},
  [5817] = {.lex_state = 192, .external_lex_state = 2},
  [5818] = {.lex_state = 192, .external_lex_state = 2},
  [5819] = {.lex_state = 424, .external_lex_state = 3},
  [5820] = {.lex_state = 524, .external_lex_state = 13},
  [5821] = {.lex_state = 424, .external_lex_state = 3},
  [5822] = {.lex_state = 192, .external_lex_state = 29},
  [5823] = {.lex_state = 192, .external_lex_state = 2},
  [5824] = {.lex_state = 421, .external_lex_state = 14},
  [5825] = {.lex_state = 192, .external_lex_state = 2},
  [5826] = {.lex_state = 192, .external_lex_state = 2},
  [5827] = {.lex_state = 192, .external_lex_state = 2},
  [5828] = {.lex_state = 192, .external_lex_state = 2},
  [5829] = {.lex_state = 528, .external_lex_state = 3},
  [5830] = {.lex_state = 528, .external_lex_state = 3},
  [5831] = {.lex_state = 213},
  [5832] = {.lex_state = 259, .external_lex_state = 3},
  [5833] = {.lex_state = 247, .external_lex_state = 3},
  [5834] = {.lex_state = 262, .external_lex_state = 14},
  [5835] = {.lex_state = 254, .external_lex_state = 8},
  [5836] = {.lex_state = 156, .external_lex_state = 3},
  [5837] = {.lex_state = 128},
  [5838] = {.lex_state = 128, .external_lex_state = 2},
  [5839] = {.lex_state = 192, .external_lex_state = 2},
  [5840] = {.lex_state = 424, .external_lex_state = 3},
  [5841] = {.lex_state = 424, .external_lex_state = 3},
  [5842] = {.lex_state = 192, .external_lex_state = 2},
  [5843] = {.lex_state = 192, .external_lex_state = 2},
  [5844] = {.lex_state = 192, .external_lex_state = 2},
  [5845] = {.lex_state = 192, .external_lex_state = 2},
  [5846] = {.lex_state = 192, .external_lex_state = 2},
  [5847] = {.lex_state = 192, .external_lex_state = 2},
  [5848] = {.lex_state = 192, .external_lex_state = 2},
  [5849] = {.lex_state = 192, .external_lex_state = 2},
  [5850] = {.lex_state = 192, .external_lex_state = 2},
  [5851] = {.lex_state = 192, .external_lex_state = 2},
  [5852] = {.lex_state = 192, .external_lex_state = 29},
  [5853] = {.lex_state = 192, .external_lex_state = 2},
  [5854] = {.lex_state = 424, .external_lex_state = 14},
  [5855] = {.lex_state = 424, .external_lex_state = 3},
  [5856] = {.lex_state = 424, .external_lex_state = 3},
  [5857] = {.lex_state = 421, .external_lex_state = 3},
  [5858] = {.lex_state = 421, .external_lex_state = 3},
  [5859] = {.lex_state = 421, .external_lex_state = 3},
  [5860] = {.lex_state = 421, .external_lex_state = 3},
  [5861] = {.lex_state = 421, .external_lex_state = 3},
  [5862] = {.lex_state = 554, .external_lex_state = 16},
  [5863] = {.lex_state = 421, .external_lex_state = 3},
  [5864] = {.lex_state = 421, .external_lex_state = 3},
  [5865] = {.lex_state = 421, .external_lex_state = 3},
  [5866] = {.lex_state = 421, .external_lex_state = 3},
  [5867] = {.lex_state = 424, .external_lex_state = 3},
  [5868] = {.lex_state = 524, .external_lex_state = 21},
  [5869] = {.lex_state = 424, .external_lex_state = 3},
  [5870] = {.lex_state = 424, .external_lex_state = 3},
  [5871] = {.lex_state = 421, .external_lex_state = 3},
  [5872] = {.lex_state = 421, .external_lex_state = 3},
  [5873] = {.lex_state = 421, .external_lex_state = 3},
  [5874] = {.lex_state = 421, .external_lex_state = 14},
  [5875] = {.lex_state = 528, .external_lex_state = 3},
  [5876] = {.lex_state = 528, .external_lex_state = 3},
  [5877] = {.lex_state = 528, .external_lex_state = 3},
  [5878] = {.lex_state = 192, .external_lex_state = 2},
  [5879] = {.lex_state = 192, .external_lex_state = 2},
  [5880] = {.lex_state = 192, .external_lex_state = 2},
  [5881] = {.lex_state = 192, .external_lex_state = 2},
  [5882] = {.lex_state = 192, .external_lex_state = 2},
  [5883] = {.lex_state = 192, .external_lex_state = 2},
  [5884] = {.lex_state = 192, .external_lex_state = 2},
  [5885] = {.lex_state = 192, .external_lex_state = 2},
  [5886] = {.lex_state = 192, .external_lex_state = 2},
  [5887] = {.lex_state = 192, .external_lex_state = 2},
  [5888] = {.lex_state = 192, .external_lex_state = 29},
  [5889] = {.lex_state = 528, .external_lex_state = 3},
  [5890] = {.lex_state = 192, .external_lex_state = 29},
  [5891] = {.lex_state = 192, .external_lex_state = 2},
  [5892] = {.lex_state = 388, .external_lex_state = 25},
  [5893] = {.lex_state = 388, .external_lex_state = 25},
  [5894] = {.lex_state = 177, .external_lex_state = 4},
  [5895] = {.lex_state = 266, .external_lex_state = 15},
  [5896] = {.lex_state = 388, .external_lex_state = 25},
  [5897] = {.lex_state = 177, .external_lex_state = 4},
  [5898] = {.lex_state = 388, .external_lex_state = 25},
  [5899] = {.lex_state = 388, .external_lex_state = 25},
  [5900] = {.lex_state = 177, .external_lex_state = 4},
  [5901] = {.lex_state = 266, .external_lex_state = 15},
  [5902] = {.lex_state = 388, .external_lex_state = 25},
  [5903] = {.lex_state = 177, .external_lex_state = 4},
  [5904] = {.lex_state = 192, .external_lex_state = 2},
  [5905] = {.lex_state = 192, .external_lex_state = 2},
  [5906] = {.lex_state = 192, .external_lex_state = 2},
  [5907] = {.lex_state = 406, .external_lex_state = 25},
  [5908] = {.lex_state = 213},
  [5909] = {.lex_state = 537, .external_lex_state = 25},
  [5910] = {.lex_state = 406, .external_lex_state = 25},
  [5911] = {.lex_state = 192, .external_lex_state = 2},
  [5912] = {.lex_state = 406, .external_lex_state = 25},
  [5913] = {.lex_state = 192, .external_lex_state = 2},
  [5914] = {.lex_state = 406, .external_lex_state = 25},
  [5915] = {.lex_state = 524, .external_lex_state = 13},
  [5916] = {.lex_state = 406, .external_lex_state = 25},
  [5917] = {.lex_state = 400, .external_lex_state = 25},
  [5918] = {.lex_state = 400, .external_lex_state = 25},
  [5919] = {.lex_state = 400, .external_lex_state = 25},
  [5920] = {.lex_state = 400, .external_lex_state = 25},
  [5921] = {.lex_state = 400, .external_lex_state = 25},
  [5922] = {.lex_state = 554, .external_lex_state = 16},
  [5923] = {.lex_state = 400, .external_lex_state = 25},
  [5924] = {.lex_state = 400, .external_lex_state = 25},
  [5925] = {.lex_state = 400, .external_lex_state = 25},
  [5926] = {.lex_state = 400, .external_lex_state = 25},
  [5927] = {.lex_state = 192, .external_lex_state = 2},
  [5928] = {.lex_state = 534, .external_lex_state = 26},
  [5929] = {.lex_state = 534, .external_lex_state = 26},
  [5930] = {.lex_state = 534, .external_lex_state = 26},
  [5931] = {.lex_state = 534, .external_lex_state = 26},
  [5932] = {.lex_state = 192, .external_lex_state = 2},
  [5933] = {.lex_state = 192, .external_lex_state = 2},
  [5934] = {.lex_state = 537, .external_lex_state = 25},
  [5935] = {.lex_state = 534, .external_lex_state = 26},
  [5936] = {.lex_state = 213},
  [5937] = {.lex_state = 537, .external_lex_state = 25},
  [5938] = {.lex_state = 537, .external_lex_state = 27},
  [5939] = {.lex_state = 537, .external_lex_state = 25},
  [5940] = {.lex_state = 192, .external_lex_state = 2},
  [5941] = {.lex_state = 537, .external_lex_state = 25},
  [5942] = {.lex_state = 192, .external_lex_state = 2},
  [5943] = {.lex_state = 537, .external_lex_state = 25},
  [5944] = {.lex_state = 524, .external_lex_state = 13},
  [5945] = {.lex_state = 537, .external_lex_state = 25},
  [5946] = {.lex_state = 192, .external_lex_state = 2},
  [5947] = {.lex_state = 400, .external_lex_state = 25},
  [5948] = {.lex_state = 400, .external_lex_state = 25},
  [5949] = {.lex_state = 400, .external_lex_state = 25},
  [5950] = {.lex_state = 540, .external_lex_state = 27},
  [5951] = {.lex_state = 388, .external_lex_state = 25},
  [5952] = {.lex_state = 310},
  [5953] = {.lex_state = 388, .external_lex_state = 25},
  [5954] = {.lex_state = 388, .external_lex_state = 25},
  [5955] = {.lex_state = 128, .external_lex_state = 2},
  [5956] = {.lex_state = 128, .external_lex_state = 2},
  [5957] = {.lex_state = 388, .external_lex_state = 25},
  [5958] = {.lex_state = 388, .external_lex_state = 25},
  [5959] = {.lex_state = 406, .external_lex_state = 25},
  [5960] = {.lex_state = 406, .external_lex_state = 25},
  [5961] = {.lex_state = 406, .external_lex_state = 25},
  [5962] = {.lex_state = 406, .external_lex_state = 25},
  [5963] = {.lex_state = 406, .external_lex_state = 25},
  [5964] = {.lex_state = 406, .external_lex_state = 25},
  [5965] = {.lex_state = 406, .external_lex_state = 25},
  [5966] = {.lex_state = 554, .external_lex_state = 16},
  [5967] = {.lex_state = 406, .external_lex_state = 25},
  [5968] = {.lex_state = 406, .external_lex_state = 25},
  [5969] = {.lex_state = 406, .external_lex_state = 25},
  [5970] = {.lex_state = 406, .external_lex_state = 25},
  [5971] = {.lex_state = 406, .external_lex_state = 25},
  [5972] = {.lex_state = 524, .external_lex_state = 21},
  [5973] = {.lex_state = 406, .external_lex_state = 25},
  [5974] = {.lex_state = 406, .external_lex_state = 25},
  [5975] = {.lex_state = 406, .external_lex_state = 25},
  [5976] = {.lex_state = 406, .external_lex_state = 25},
  [5977] = {.lex_state = 406, .external_lex_state = 25},
  [5978] = {.lex_state = 388, .external_lex_state = 25},
  [5979] = {.lex_state = 128},
  [5980] = {.lex_state = 128},
  [5981] = {.lex_state = 128, .external_lex_state = 2},
  [5982] = {.lex_state = 388, .external_lex_state = 25},
  [5983] = {.lex_state = 128},
  [5984] = {.lex_state = 128},
  [5985] = {.lex_state = 388, .external_lex_state = 25},
  [5986] = {.lex_state = 128},
  [5987] = {.lex_state = 388, .external_lex_state = 25},
  [5988] = {.lex_state = 128},
  [5989] = {.lex_state = 128, .external_lex_state = 2},
  [5990] = {.lex_state = 128},
  [5991] = {.lex_state = 128},
  [5992] = {.lex_state = 388, .external_lex_state = 25},
  [5993] = {.lex_state = 388, .external_lex_state = 25},
  [5994] = {.lex_state = 128},
  [5995] = {.lex_state = 128},
  [5996] = {.lex_state = 388, .external_lex_state = 25},
  [5997] = {.lex_state = 388, .external_lex_state = 25},
  [5998] = {.lex_state = 194},
  [5999] = {.lex_state = 388, .external_lex_state = 25},
  [6000] = {.lex_state = 128},
  [6001] = {.lex_state = 128, .external_lex_state = 2},
  [6002] = {.lex_state = 128, .external_lex_state = 12},
  [6003] = {.lex_state = 192, .external_lex_state = 2},
  [6004] = {.lex_state = 544, .external_lex_state = 26},
  [6005] = {.lex_state = 209, .external_lex_state = 19},
  [6006] = {.lex_state = 209},
  [6007] = {.lex_state = 544, .external_lex_state = 26},
  [6008] = {.lex_state = 397, .external_lex_state = 25},
  [6009] = {.lex_state = 235},
  [6010] = {.lex_state = 403, .external_lex_state = 25},
  [6011] = {.lex_state = 397, .external_lex_state = 25},
  [6012] = {.lex_state = 194},
  [6013] = {.lex_state = 397, .external_lex_state = 25},
  [6014] = {.lex_state = 128},
  [6015] = {.lex_state = 128, .external_lex_state = 2},
  [6016] = {.lex_state = 128, .external_lex_state = 12},
  [6017] = {.lex_state = 403, .external_lex_state = 25},
  [6018] = {.lex_state = 403, .external_lex_state = 25},
  [6019] = {.lex_state = 403, .external_lex_state = 25},
  [6020] = {.lex_state = 403, .external_lex_state = 25},
  [6021] = {.lex_state = 403, .external_lex_state = 25},
  [6022] = {.lex_state = 403, .external_lex_state = 25},
  [6023] = {.lex_state = 554, .external_lex_state = 16},
  [6024] = {.lex_state = 403, .external_lex_state = 25},
  [6025] = {.lex_state = 403, .external_lex_state = 25},
  [6026] = {.lex_state = 403, .external_lex_state = 25},
  [6027] = {.lex_state = 403, .external_lex_state = 25},
  [6028] = {.lex_state = 403, .external_lex_state = 25},
  [6029] = {.lex_state = 524, .external_lex_state = 21},
  [6030] = {.lex_state = 403, .external_lex_state = 25},
  [6031] = {.lex_state = 403, .external_lex_state = 25},
  [6032] = {.lex_state = 403, .external_lex_state = 25},
  [6033] = {.lex_state = 403, .external_lex_state = 25},
  [6034] = {.lex_state = 403, .external_lex_state = 25},
  [6035] = {.lex_state = 640, .external_lex_state = 27},
  [6036] = {.lex_state = 641, .external_lex_state = 13},
  [6037] = {.lex_state = 177, .external_lex_state = 17},
  [6038] = {.lex_state = 641, .external_lex_state = 19},
  [6039] = {.lex_state = 400, .external_lex_state = 25},
  [6040] = {.lex_state = 192, .external_lex_state = 29},
  [6041] = {.lex_state = 400, .external_lex_state = 25},
  [6042] = {.lex_state = 286, .external_lex_state = 2},
  [6043] = {.lex_state = 128},
  [6044] = {.lex_state = 237},
  [6045] = {.lex_state = 681, .external_lex_state = 2},
  [6046] = {.lex_state = 192, .external_lex_state = 2},
  [6047] = {.lex_state = 237},
  [6048] = {.lex_state = 237},
  [6049] = {.lex_state = 156, .external_lex_state = 3},
  [6050] = {.lex_state = 337},
  [6051] = {.lex_state = 302},
  [6052] = {.lex_state = 302, .external_lex_state = 16},
  [6053] = {.lex_state = 302, .external_lex_state = 16},
  [6054] = {.lex_state = 337},
  [6055] = {.lex_state = 128},
  [6056] = {.lex_state = 302},
  [6057] = {.lex_state = 128, .external_lex_state = 12},
  [6058] = {.lex_state = 128},
  [6059] = {.lex_state = 237},
  [6060] = {.lex_state = 237},
  [6061] = {.lex_state = 237},
  [6062] = {.lex_state = 156, .external_lex_state = 3},
  [6063] = {.lex_state = 128},
  [6064] = {.lex_state = 128, .external_lex_state = 2},
  [6065] = {.lex_state = 302, .external_lex_state = 16},
  [6066] = {.lex_state = 302, .external_lex_state = 16},
  [6067] = {.lex_state = 192, .external_lex_state = 2},
  [6068] = {.lex_state = 192, .external_lex_state = 2},
  [6069] = {.lex_state = 192, .external_lex_state = 2},
  [6070] = {.lex_state = 192, .external_lex_state = 2},
  [6071] = {.lex_state = 192, .external_lex_state = 2},
  [6072] = {.lex_state = 192, .external_lex_state = 2},
  [6073] = {.lex_state = 192, .external_lex_state = 2},
  [6074] = {.lex_state = 192, .external_lex_state = 2},
  [6075] = {.lex_state = 192, .external_lex_state = 2},
  [6076] = {.lex_state = 192, .external_lex_state = 2},
  [6077] = {.lex_state = 419, .external_lex_state = 6},
  [6078] = {.lex_state = 227, .external_lex_state = 16},
  [6079] = {.lex_state = 192, .external_lex_state = 29},
  [6080] = {.lex_state = 192, .external_lex_state = 2},
  [6081] = {.lex_state = 251, .external_lex_state = 20},
  [6082] = {.lex_state = 645, .external_lex_state = 20},
  [6083] = {.lex_state = 192, .external_lex_state = 2},
  [6084] = {.lex_state = 683, .external_lex_state = 26},
  [6085] = {.lex_state = 683, .external_lex_state = 26},
  [6086] = {.lex_state = 683, .external_lex_state = 26},
  [6087] = {.lex_state = 683, .external_lex_state = 26},
  [6088] = {.lex_state = 192, .external_lex_state = 2},
  [6089] = {.lex_state = 192, .external_lex_state = 2},
  [6090] = {.lex_state = 645, .external_lex_state = 25},
  [6091] = {.lex_state = 556, .external_lex_state = 26},
  [6092] = {.lex_state = 213},
  [6093] = {.lex_state = 559, .external_lex_state = 25},
  [6094] = {.lex_state = 645, .external_lex_state = 27},
  [6095] = {.lex_state = 645, .external_lex_state = 25},
  [6096] = {.lex_state = 177, .external_lex_state = 4},
  [6097] = {.lex_state = 654, .external_lex_state = 25},
  [6098] = {.lex_state = 654, .external_lex_state = 27},
  [6099] = {.lex_state = 192, .external_lex_state = 2},
  [6100] = {.lex_state = 645, .external_lex_state = 25},
  [6101] = {.lex_state = 192, .external_lex_state = 2},
  [6102] = {.lex_state = 192, .external_lex_state = 2},
  [6103] = {.lex_state = 237},
  [6104] = {.lex_state = 192, .external_lex_state = 2},
  [6105] = {.lex_state = 651, .external_lex_state = 26},
  [6106] = {.lex_state = 654, .external_lex_state = 25},
  [6107] = {.lex_state = 654, .external_lex_state = 25},
  [6108] = {.lex_state = 654, .external_lex_state = 25},
  [6109] = {.lex_state = 661, .external_lex_state = 27},
  [6110] = {.lex_state = 654, .external_lex_state = 25},
  [6111] = {.lex_state = 192, .external_lex_state = 2},
  [6112] = {.lex_state = 192, .external_lex_state = 2},
  [6113] = {.lex_state = 192, .external_lex_state = 2},
  [6114] = {.lex_state = 192, .external_lex_state = 2},
  [6115] = {.lex_state = 192, .external_lex_state = 2},
  [6116] = {.lex_state = 192, .external_lex_state = 2},
  [6117] = {.lex_state = 192, .external_lex_state = 2},
  [6118] = {.lex_state = 192, .external_lex_state = 2},
  [6119] = {.lex_state = 192, .external_lex_state = 2},
  [6120] = {.lex_state = 192, .external_lex_state = 2},
  [6121] = {.lex_state = 192, .external_lex_state = 2},
  [6122] = {.lex_state = 192, .external_lex_state = 2},
  [6123] = {.lex_state = 192, .external_lex_state = 2},
  [6124] = {.lex_state = 237},
  [6125] = {.lex_state = 192, .external_lex_state = 2},
  [6126] = {.lex_state = 651, .external_lex_state = 26},
  [6127] = {.lex_state = 658, .external_lex_state = 25},
  [6128] = {.lex_state = 658, .external_lex_state = 25},
  [6129] = {.lex_state = 658, .external_lex_state = 25},
  [6130] = {.lex_state = 662, .external_lex_state = 27},
  [6131] = {.lex_state = 562, .external_lex_state = 25},
  [6132] = {.lex_state = 524, .external_lex_state = 13},
  [6133] = {.lex_state = 645, .external_lex_state = 25},
  [6134] = {.lex_state = 192, .external_lex_state = 29},
  [6135] = {.lex_state = 192, .external_lex_state = 2},
  [6136] = {.lex_state = 654, .external_lex_state = 27},
  [6137] = {.lex_state = 554, .external_lex_state = 16},
  [6138] = {.lex_state = 554, .external_lex_state = 16},
  [6139] = {.lex_state = 554, .external_lex_state = 16},
  [6140] = {.lex_state = 554, .external_lex_state = 16},
  [6141] = {.lex_state = 554, .external_lex_state = 16},
  [6142] = {.lex_state = 554, .external_lex_state = 16},
  [6143] = {.lex_state = 247, .external_lex_state = 3},
  [6144] = {.lex_state = 554, .external_lex_state = 16},
  [6145] = {.lex_state = 554, .external_lex_state = 16},
  [6146] = {.lex_state = 554, .external_lex_state = 16},
  [6147] = {.lex_state = 554, .external_lex_state = 16},
  [6148] = {.lex_state = 192, .external_lex_state = 2},
  [6149] = {.lex_state = 556, .external_lex_state = 26},
  [6150] = {.lex_state = 556, .external_lex_state = 26},
  [6151] = {.lex_state = 556, .external_lex_state = 26},
  [6152] = {.lex_state = 556, .external_lex_state = 26},
  [6153] = {.lex_state = 192, .external_lex_state = 2},
  [6154] = {.lex_state = 192, .external_lex_state = 2},
  [6155] = {.lex_state = 559, .external_lex_state = 25},
  [6156] = {.lex_state = 556, .external_lex_state = 26},
  [6157] = {.lex_state = 213},
  [6158] = {.lex_state = 559, .external_lex_state = 25},
  [6159] = {.lex_state = 559, .external_lex_state = 27},
  [6160] = {.lex_state = 559, .external_lex_state = 25},
  [6161] = {.lex_state = 177, .external_lex_state = 4},
  [6162] = {.lex_state = 658, .external_lex_state = 25},
  [6163] = {.lex_state = 658, .external_lex_state = 27},
  [6164] = {.lex_state = 192, .external_lex_state = 2},
  [6165] = {.lex_state = 559, .external_lex_state = 25},
  [6166] = {.lex_state = 658, .external_lex_state = 25},
  [6167] = {.lex_state = 192, .external_lex_state = 2},
  [6168] = {.lex_state = 192, .external_lex_state = 2},
  [6169] = {.lex_state = 192, .external_lex_state = 2},
  [6170] = {.lex_state = 192, .external_lex_state = 2},
  [6171] = {.lex_state = 192, .external_lex_state = 2},
  [6172] = {.lex_state = 192, .external_lex_state = 2},
  [6173] = {.lex_state = 192, .external_lex_state = 2},
  [6174] = {.lex_state = 192, .external_lex_state = 2},
  [6175] = {.lex_state = 192, .external_lex_state = 2},
  [6176] = {.lex_state = 192, .external_lex_state = 2},
  [6177] = {.lex_state = 192, .external_lex_state = 2},
  [6178] = {.lex_state = 559, .external_lex_state = 25},
  [6179] = {.lex_state = 524, .external_lex_state = 13},
  [6180] = {.lex_state = 559, .external_lex_state = 25},
  [6181] = {.lex_state = 192, .external_lex_state = 29},
  [6182] = {.lex_state = 192, .external_lex_state = 2},
  [6183] = {.lex_state = 658, .external_lex_state = 27},
  [6184] = {.lex_state = 192, .external_lex_state = 2},
  [6185] = {.lex_state = 192, .external_lex_state = 2},
  [6186] = {.lex_state = 683, .external_lex_state = 18},
  [6187] = {.lex_state = 683, .external_lex_state = 18},
  [6188] = {.lex_state = 683, .external_lex_state = 18},
  [6189] = {.lex_state = 683, .external_lex_state = 18},
  [6190] = {.lex_state = 192, .external_lex_state = 2},
  [6191] = {.lex_state = 192, .external_lex_state = 2},
  [6192] = {.lex_state = 554, .external_lex_state = 16},
  [6193] = {.lex_state = 554, .external_lex_state = 16},
  [6194] = {.lex_state = 213},
  [6195] = {.lex_state = 559, .external_lex_state = 16},
  [6196] = {.lex_state = 645, .external_lex_state = 20},
  [6197] = {.lex_state = 554, .external_lex_state = 16},
  [6198] = {.lex_state = 562, .external_lex_state = 20},
  [6199] = {.lex_state = 416, .external_lex_state = 28},
  [6200] = {.lex_state = 327, .external_lex_state = 11},
  [6201] = {.lex_state = 209},
  [6202] = {.lex_state = 227, .external_lex_state = 3},
  [6203] = {.lex_state = 299, .external_lex_state = 3},
  [6204] = {.lex_state = 299, .external_lex_state = 3},
  [6205] = {.lex_state = 177, .external_lex_state = 4},
  [6206] = {.lex_state = 266, .external_lex_state = 15},
  [6207] = {.lex_state = 299, .external_lex_state = 3},
  [6208] = {.lex_state = 177, .external_lex_state = 4},
  [6209] = {.lex_state = 299, .external_lex_state = 3},
  [6210] = {.lex_state = 299, .external_lex_state = 3},
  [6211] = {.lex_state = 177, .external_lex_state = 4},
  [6212] = {.lex_state = 266, .external_lex_state = 15},
  [6213] = {.lex_state = 299, .external_lex_state = 3},
  [6214] = {.lex_state = 177, .external_lex_state = 4},
  [6215] = {.lex_state = 227, .external_lex_state = 14},
  [6216] = {.lex_state = 227, .external_lex_state = 3},
  [6217] = {.lex_state = 227, .external_lex_state = 3},
  [6218] = {.lex_state = 227, .external_lex_state = 3},
  [6219] = {.lex_state = 227, .external_lex_state = 3},
  [6220] = {.lex_state = 192, .external_lex_state = 15},
  [6221] = {.lex_state = 266, .external_lex_state = 15},
  [6222] = {.lex_state = 227, .external_lex_state = 3},
  [6223] = {.lex_state = 177, .external_lex_state = 4},
  [6224] = {.lex_state = 266, .external_lex_state = 15},
  [6225] = {.lex_state = 227, .external_lex_state = 3},
  [6226] = {.lex_state = 192, .external_lex_state = 15},
  [6227] = {.lex_state = 266, .external_lex_state = 15},
  [6228] = {.lex_state = 227, .external_lex_state = 3},
  [6229] = {.lex_state = 177, .external_lex_state = 4},
  [6230] = {.lex_state = 266, .external_lex_state = 15},
  [6231] = {.lex_state = 227, .external_lex_state = 3},
  [6232] = {.lex_state = 194},
  [6233] = {.lex_state = 302, .external_lex_state = 16},
  [6234] = {.lex_state = 225, .external_lex_state = 7},
  [6235] = {.lex_state = 128, .external_lex_state = 2},
  [6236] = {.lex_state = 227, .external_lex_state = 3},
  [6237] = {.lex_state = 247, .external_lex_state = 3},
  [6238] = {.lex_state = 128, .external_lex_state = 8},
  [6239] = {.lex_state = 128, .external_lex_state = 2},
  [6240] = {.lex_state = 227, .external_lex_state = 3},
  [6241] = {.lex_state = 128, .external_lex_state = 2},
  [6242] = {.lex_state = 128, .external_lex_state = 12},
  [6243] = {.lex_state = 128, .external_lex_state = 2},
  [6244] = {.lex_state = 128, .external_lex_state = 2},
  [6245] = {.lex_state = 128, .external_lex_state = 2},
  [6246] = {.lex_state = 128, .external_lex_state = 8},
  [6247] = {.lex_state = 128},
  [6248] = {.lex_state = 128},
  [6249] = {.lex_state = 128},
  [6250] = {.lex_state = 227, .external_lex_state = 3},
  [6251] = {.lex_state = 128},
  [6252] = {.lex_state = 128},
  [6253] = {.lex_state = 128},
  [6254] = {.lex_state = 227, .external_lex_state = 3},
  [6255] = {.lex_state = 227, .external_lex_state = 3},
  [6256] = {.lex_state = 235},
  [6257] = {.lex_state = 227, .external_lex_state = 3},
  [6258] = {.lex_state = 424, .external_lex_state = 3},
  [6259] = {.lex_state = 424, .external_lex_state = 3},
  [6260] = {.lex_state = 424, .external_lex_state = 3},
  [6261] = {.lex_state = 424, .external_lex_state = 3},
  [6262] = {.lex_state = 424, .external_lex_state = 3},
  [6263] = {.lex_state = 554, .external_lex_state = 16},
  [6264] = {.lex_state = 424, .external_lex_state = 3},
  [6265] = {.lex_state = 424, .external_lex_state = 3},
  [6266] = {.lex_state = 424, .external_lex_state = 3},
  [6267] = {.lex_state = 424, .external_lex_state = 3},
  [6268] = {.lex_state = 299, .external_lex_state = 3},
  [6269] = {.lex_state = 424, .external_lex_state = 3},
  [6270] = {.lex_state = 227, .external_lex_state = 3},
  [6271] = {.lex_state = 424, .external_lex_state = 3},
  [6272] = {.lex_state = 424, .external_lex_state = 3},
  [6273] = {.lex_state = 424, .external_lex_state = 14},
  [6274] = {.lex_state = 588, .external_lex_state = 3},
  [6275] = {.lex_state = 588, .external_lex_state = 3},
  [6276] = {.lex_state = 192, .external_lex_state = 2},
  [6277] = {.lex_state = 588, .external_lex_state = 3},
  [6278] = {.lex_state = 192, .external_lex_state = 2},
  [6279] = {.lex_state = 455, .external_lex_state = 3},
  [6280] = {.lex_state = 524, .external_lex_state = 13},
  [6281] = {.lex_state = 588, .external_lex_state = 3},
  [6282] = {.lex_state = 227, .external_lex_state = 3},
  [6283] = {.lex_state = 436, .external_lex_state = 3},
  [6284] = {.lex_state = 436, .external_lex_state = 3},
  [6285] = {.lex_state = 436, .external_lex_state = 3},
  [6286] = {.lex_state = 436, .external_lex_state = 3},
  [6287] = {.lex_state = 436, .external_lex_state = 3},
  [6288] = {.lex_state = 554, .external_lex_state = 16},
  [6289] = {.lex_state = 436, .external_lex_state = 3},
  [6290] = {.lex_state = 436, .external_lex_state = 3},
  [6291] = {.lex_state = 436, .external_lex_state = 3},
  [6292] = {.lex_state = 436, .external_lex_state = 3},
  [6293] = {.lex_state = 573, .external_lex_state = 3},
  [6294] = {.lex_state = 573, .external_lex_state = 3},
  [6295] = {.lex_state = 192, .external_lex_state = 2},
  [6296] = {.lex_state = 573, .external_lex_state = 3},
  [6297] = {.lex_state = 192, .external_lex_state = 2},
  [6298] = {.lex_state = 573, .external_lex_state = 3},
  [6299] = {.lex_state = 524, .external_lex_state = 13},
  [6300] = {.lex_state = 573, .external_lex_state = 3},
  [6301] = {.lex_state = 192, .external_lex_state = 2},
  [6302] = {.lex_state = 192, .external_lex_state = 2},
  [6303] = {.lex_state = 192, .external_lex_state = 2},
  [6304] = {.lex_state = 192, .external_lex_state = 2},
  [6305] = {.lex_state = 436, .external_lex_state = 3},
  [6306] = {.lex_state = 436, .external_lex_state = 3},
  [6307] = {.lex_state = 213},
  [6308] = {.lex_state = 573, .external_lex_state = 3},
  [6309] = {.lex_state = 436, .external_lex_state = 3},
  [6310] = {.lex_state = 455, .external_lex_state = 14},
  [6311] = {.lex_state = 299, .external_lex_state = 3},
  [6312] = {.lex_state = 310},
  [6313] = {.lex_state = 299, .external_lex_state = 3},
  [6314] = {.lex_state = 299, .external_lex_state = 3},
  [6315] = {.lex_state = 128, .external_lex_state = 2},
  [6316] = {.lex_state = 128, .external_lex_state = 2},
  [6317] = {.lex_state = 299, .external_lex_state = 3},
  [6318] = {.lex_state = 299, .external_lex_state = 3},
  [6319] = {.lex_state = 299, .external_lex_state = 3},
  [6320] = {.lex_state = 128},
  [6321] = {.lex_state = 128},
  [6322] = {.lex_state = 128, .external_lex_state = 2},
  [6323] = {.lex_state = 299, .external_lex_state = 3},
  [6324] = {.lex_state = 128},
  [6325] = {.lex_state = 128},
  [6326] = {.lex_state = 299, .external_lex_state = 3},
  [6327] = {.lex_state = 128},
  [6328] = {.lex_state = 299, .external_lex_state = 3},
  [6329] = {.lex_state = 128},
  [6330] = {.lex_state = 128, .external_lex_state = 2},
  [6331] = {.lex_state = 227, .external_lex_state = 3},
  [6332] = {.lex_state = 128},
  [6333] = {.lex_state = 128, .external_lex_state = 2},
  [6334] = {.lex_state = 128},
  [6335] = {.lex_state = 128},
  [6336] = {.lex_state = 299, .external_lex_state = 3},
  [6337] = {.lex_state = 299, .external_lex_state = 3},
  [6338] = {.lex_state = 128},
  [6339] = {.lex_state = 128},
  [6340] = {.lex_state = 227, .external_lex_state = 3},
  [6341] = {.lex_state = 299, .external_lex_state = 3},
  [6342] = {.lex_state = 192, .external_lex_state = 2},
  [6343] = {.lex_state = 227, .external_lex_state = 3},
  [6344] = {.lex_state = 227, .external_lex_state = 3},
  [6345] = {.lex_state = 192, .external_lex_state = 29},
  [6346] = {.lex_state = 421, .external_lex_state = 3},
  [6347] = {.lex_state = 577, .external_lex_state = 3},
  [6348] = {.lex_state = 577, .external_lex_state = 3},
  [6349] = {.lex_state = 577, .external_lex_state = 3},
  [6350] = {.lex_state = 577, .external_lex_state = 3},
  [6351] = {.lex_state = 577, .external_lex_state = 3},
  [6352] = {.lex_state = 554, .external_lex_state = 16},
  [6353] = {.lex_state = 577, .external_lex_state = 3},
  [6354] = {.lex_state = 577, .external_lex_state = 3},
  [6355] = {.lex_state = 577, .external_lex_state = 3},
  [6356] = {.lex_state = 577, .external_lex_state = 3},
  [6357] = {.lex_state = 380, .external_lex_state = 3},
  [6358] = {.lex_state = 577, .external_lex_state = 3},
  [6359] = {.lex_state = 577, .external_lex_state = 3},
  [6360] = {.lex_state = 577, .external_lex_state = 3},
  [6361] = {.lex_state = 467, .external_lex_state = 25},
  [6362] = {.lex_state = 467, .external_lex_state = 25},
  [6363] = {.lex_state = 467, .external_lex_state = 25},
  [6364] = {.lex_state = 467, .external_lex_state = 25},
  [6365] = {.lex_state = 192, .external_lex_state = 2},
  [6366] = {.lex_state = 192, .external_lex_state = 2},
  [6367] = {.lex_state = 192, .external_lex_state = 2},
  [6368] = {.lex_state = 192, .external_lex_state = 2},
  [6369] = {.lex_state = 192, .external_lex_state = 2},
  [6370] = {.lex_state = 192, .external_lex_state = 2},
  [6371] = {.lex_state = 192, .external_lex_state = 2},
  [6372] = {.lex_state = 192, .external_lex_state = 2},
  [6373] = {.lex_state = 192, .external_lex_state = 2},
  [6374] = {.lex_state = 192, .external_lex_state = 2},
  [6375] = {.lex_state = 192, .external_lex_state = 29},
  [6376] = {.lex_state = 192, .external_lex_state = 2},
  [6377] = {.lex_state = 467, .external_lex_state = 27},
  [6378] = {.lex_state = 467, .external_lex_state = 25},
  [6379] = {.lex_state = 588, .external_lex_state = 25},
  [6380] = {.lex_state = 588, .external_lex_state = 25},
  [6381] = {.lex_state = 192, .external_lex_state = 2},
  [6382] = {.lex_state = 588, .external_lex_state = 25},
  [6383] = {.lex_state = 192, .external_lex_state = 2},
  [6384] = {.lex_state = 588, .external_lex_state = 25},
  [6385] = {.lex_state = 524, .external_lex_state = 13},
  [6386] = {.lex_state = 588, .external_lex_state = 25},
  [6387] = {.lex_state = 467, .external_lex_state = 25},
  [6388] = {.lex_state = 588, .external_lex_state = 25},
  [6389] = {.lex_state = 588, .external_lex_state = 25},
  [6390] = {.lex_state = 588, .external_lex_state = 25},
  [6391] = {.lex_state = 588, .external_lex_state = 25},
  [6392] = {.lex_state = 588, .external_lex_state = 25},
  [6393] = {.lex_state = 554, .external_lex_state = 16},
  [6394] = {.lex_state = 588, .external_lex_state = 25},
  [6395] = {.lex_state = 588, .external_lex_state = 25},
  [6396] = {.lex_state = 588, .external_lex_state = 25},
  [6397] = {.lex_state = 588, .external_lex_state = 25},
  [6398] = {.lex_state = 573, .external_lex_state = 25},
  [6399] = {.lex_state = 573, .external_lex_state = 25},
  [6400] = {.lex_state = 192, .external_lex_state = 2},
  [6401] = {.lex_state = 573, .external_lex_state = 25},
  [6402] = {.lex_state = 192, .external_lex_state = 2},
  [6403] = {.lex_state = 573, .external_lex_state = 25},
  [6404] = {.lex_state = 524, .external_lex_state = 13},
  [6405] = {.lex_state = 573, .external_lex_state = 25},
  [6406] = {.lex_state = 444, .external_lex_state = 25},
  [6407] = {.lex_state = 524, .external_lex_state = 21},
  [6408] = {.lex_state = 444, .external_lex_state = 25},
  [6409] = {.lex_state = 467, .external_lex_state = 25},
  [6410] = {.lex_state = 588, .external_lex_state = 25},
  [6411] = {.lex_state = 588, .external_lex_state = 25},
  [6412] = {.lex_state = 588, .external_lex_state = 25},
  [6413] = {.lex_state = 663, .external_lex_state = 27},
  [6414] = {.lex_state = 237},
  [6415] = {.lex_state = 237},
  [6416] = {.lex_state = 192, .external_lex_state = 2},
  [6417] = {.lex_state = 579, .external_lex_state = 18},
  [6418] = {.lex_state = 209, .external_lex_state = 19},
  [6419] = {.lex_state = 209},
  [6420] = {.lex_state = 579, .external_lex_state = 18},
  [6421] = {.lex_state = 433, .external_lex_state = 16},
  [6422] = {.lex_state = 235},
  [6423] = {.lex_state = 461, .external_lex_state = 27},
  [6424] = {.lex_state = 192, .external_lex_state = 15},
  [6425] = {.lex_state = 461, .external_lex_state = 25},
  [6426] = {.lex_state = 192, .external_lex_state = 15},
  [6427] = {.lex_state = 461, .external_lex_state = 25},
  [6428] = {.lex_state = 192, .external_lex_state = 15},
  [6429] = {.lex_state = 461, .external_lex_state = 25},
  [6430] = {.lex_state = 192, .external_lex_state = 15},
  [6431] = {.lex_state = 461, .external_lex_state = 25},
  [6432] = {.lex_state = 190, .external_lex_state = 4},
  [6433] = {.lex_state = 266, .external_lex_state = 15},
  [6434] = {.lex_state = 461, .external_lex_state = 25},
  [6435] = {.lex_state = 190, .external_lex_state = 4},
  [6436] = {.lex_state = 266, .external_lex_state = 15},
  [6437] = {.lex_state = 441, .external_lex_state = 25},
  [6438] = {.lex_state = 461, .external_lex_state = 25},
  [6439] = {.lex_state = 194},
  [6440] = {.lex_state = 194, .external_lex_state = 19},
  [6441] = {.lex_state = 192, .external_lex_state = 2},
  [6442] = {.lex_state = 461, .external_lex_state = 25},
  [6443] = {.lex_state = 310},
  [6444] = {.lex_state = 310, .external_lex_state = 8},
  [6445] = {.lex_state = 461, .external_lex_state = 25},
  [6446] = {.lex_state = 209},
  [6447] = {.lex_state = 192, .external_lex_state = 2},
  [6448] = {.lex_state = 346, .external_lex_state = 23},
  [6449] = {.lex_state = 346, .external_lex_state = 23},
  [6450] = {.lex_state = 350, .external_lex_state = 23},
  [6451] = {.lex_state = 350, .external_lex_state = 23},
  [6452] = {.lex_state = 461, .external_lex_state = 25},
  [6453] = {.lex_state = 461, .external_lex_state = 25},
  [6454] = {.lex_state = 461, .external_lex_state = 25},
  [6455] = {.lex_state = 461, .external_lex_state = 25},
  [6456] = {.lex_state = 128, .external_lex_state = 8},
  [6457] = {.lex_state = 128, .external_lex_state = 8},
  [6458] = {.lex_state = 247, .external_lex_state = 3},
  [6459] = {.lex_state = 247, .external_lex_state = 3},
  [6460] = {.lex_state = 128},
  [6461] = {.lex_state = 247, .external_lex_state = 3},
  [6462] = {.lex_state = 128},
  [6463] = {.lex_state = 128},
  [6464] = {.lex_state = 128},
  [6465] = {.lex_state = 128},
  [6466] = {.lex_state = 128},
  [6467] = {.lex_state = 461, .external_lex_state = 25},
  [6468] = {.lex_state = 128, .external_lex_state = 2},
  [6469] = {.lex_state = 441, .external_lex_state = 25},
  [6470] = {.lex_state = 461, .external_lex_state = 25},
  [6471] = {.lex_state = 461, .external_lex_state = 25},
  [6472] = {.lex_state = 461, .external_lex_state = 25},
  [6473] = {.lex_state = 235, .external_lex_state = 19},
  [6474] = {.lex_state = 235},
  [6475] = {.lex_state = 128},
  [6476] = {.lex_state = 461, .external_lex_state = 25},
  [6477] = {.lex_state = 192, .external_lex_state = 2},
  [6478] = {.lex_state = 192, .external_lex_state = 2},
  [6479] = {.lex_state = 192, .external_lex_state = 2},
  [6480] = {.lex_state = 192, .external_lex_state = 2},
  [6481] = {.lex_state = 192, .external_lex_state = 2},
  [6482] = {.lex_state = 192, .external_lex_state = 2},
  [6483] = {.lex_state = 192, .external_lex_state = 2},
  [6484] = {.lex_state = 192, .external_lex_state = 2},
  [6485] = {.lex_state = 192, .external_lex_state = 2},
  [6486] = {.lex_state = 192, .external_lex_state = 2},
  [6487] = {.lex_state = 192, .external_lex_state = 29},
  [6488] = {.lex_state = 192, .external_lex_state = 2},
  [6489] = {.lex_state = 441, .external_lex_state = 27},
  [6490] = {.lex_state = 441, .external_lex_state = 25},
  [6491] = {.lex_state = 433, .external_lex_state = 16},
  [6492] = {.lex_state = 194},
  [6493] = {.lex_state = 433, .external_lex_state = 16},
  [6494] = {.lex_state = 128},
  [6495] = {.lex_state = 128, .external_lex_state = 2},
  [6496] = {.lex_state = 128, .external_lex_state = 12},
  [6497] = {.lex_state = 461, .external_lex_state = 25},
  [6498] = {.lex_state = 209},
  [6499] = {.lex_state = 441, .external_lex_state = 25},
  [6500] = {.lex_state = 573, .external_lex_state = 25},
  [6501] = {.lex_state = 573, .external_lex_state = 25},
  [6502] = {.lex_state = 573, .external_lex_state = 25},
  [6503] = {.lex_state = 573, .external_lex_state = 25},
  [6504] = {.lex_state = 573, .external_lex_state = 25},
  [6505] = {.lex_state = 554, .external_lex_state = 16},
  [6506] = {.lex_state = 573, .external_lex_state = 25},
  [6507] = {.lex_state = 573, .external_lex_state = 25},
  [6508] = {.lex_state = 573, .external_lex_state = 25},
  [6509] = {.lex_state = 573, .external_lex_state = 25},
  [6510] = {.lex_state = 433, .external_lex_state = 16},
  [6511] = {.lex_state = 461, .external_lex_state = 25},
  [6512] = {.lex_state = 177, .external_lex_state = 17},
  [6513] = {.lex_state = 441, .external_lex_state = 25},
  [6514] = {.lex_state = 461, .external_lex_state = 25},
  [6515] = {.lex_state = 524, .external_lex_state = 21},
  [6516] = {.lex_state = 441, .external_lex_state = 25},
  [6517] = {.lex_state = 441, .external_lex_state = 25},
  [6518] = {.lex_state = 573, .external_lex_state = 25},
  [6519] = {.lex_state = 573, .external_lex_state = 25},
  [6520] = {.lex_state = 573, .external_lex_state = 25},
  [6521] = {.lex_state = 664, .external_lex_state = 27},
  [6522] = {.lex_state = 436, .external_lex_state = 16},
  [6523] = {.lex_state = 436, .external_lex_state = 16},
  [6524] = {.lex_state = 436, .external_lex_state = 16},
  [6525] = {.lex_state = 192, .external_lex_state = 2},
  [6526] = {.lex_state = 192, .external_lex_state = 2},
  [6527] = {.lex_state = 192, .external_lex_state = 2},
  [6528] = {.lex_state = 192, .external_lex_state = 2},
  [6529] = {.lex_state = 192, .external_lex_state = 2},
  [6530] = {.lex_state = 192, .external_lex_state = 2},
  [6531] = {.lex_state = 192, .external_lex_state = 2},
  [6532] = {.lex_state = 192, .external_lex_state = 2},
  [6533] = {.lex_state = 192, .external_lex_state = 2},
  [6534] = {.lex_state = 192, .external_lex_state = 2},
  [6535] = {.lex_state = 192, .external_lex_state = 29},
  [6536] = {.lex_state = 436, .external_lex_state = 16},
  [6537] = {.lex_state = 192, .external_lex_state = 29},
  [6538] = {.lex_state = 192, .external_lex_state = 2},
  [6539] = {.lex_state = 467, .external_lex_state = 20},
  [6540] = {.lex_state = 156, .external_lex_state = 3},
  [6541] = {.lex_state = 156, .external_lex_state = 3},
  [6542] = {.lex_state = 467, .external_lex_state = 3},
  [6543] = {.lex_state = 467, .external_lex_state = 3},
  [6544] = {.lex_state = 467, .external_lex_state = 3},
  [6545] = {.lex_state = 467, .external_lex_state = 3},
  [6546] = {.lex_state = 192, .external_lex_state = 2},
  [6547] = {.lex_state = 192, .external_lex_state = 2},
  [6548] = {.lex_state = 192, .external_lex_state = 2},
  [6549] = {.lex_state = 192, .external_lex_state = 2},
  [6550] = {.lex_state = 192, .external_lex_state = 2},
  [6551] = {.lex_state = 192, .external_lex_state = 2},
  [6552] = {.lex_state = 192, .external_lex_state = 2},
  [6553] = {.lex_state = 192, .external_lex_state = 2},
  [6554] = {.lex_state = 192, .external_lex_state = 2},
  [6555] = {.lex_state = 192, .external_lex_state = 2},
  [6556] = {.lex_state = 192, .external_lex_state = 29},
  [6557] = {.lex_state = 192, .external_lex_state = 2},
  [6558] = {.lex_state = 467, .external_lex_state = 14},
  [6559] = {.lex_state = 467, .external_lex_state = 3},
  [6560] = {.lex_state = 588, .external_lex_state = 3},
  [6561] = {.lex_state = 588, .external_lex_state = 3},
  [6562] = {.lex_state = 467, .external_lex_state = 3},
  [6563] = {.lex_state = 588, .external_lex_state = 3},
  [6564] = {.lex_state = 588, .external_lex_state = 3},
  [6565] = {.lex_state = 588, .external_lex_state = 3},
  [6566] = {.lex_state = 588, .external_lex_state = 3},
  [6567] = {.lex_state = 588, .external_lex_state = 3},
  [6568] = {.lex_state = 554, .external_lex_state = 16},
  [6569] = {.lex_state = 588, .external_lex_state = 3},
  [6570] = {.lex_state = 588, .external_lex_state = 3},
  [6571] = {.lex_state = 588, .external_lex_state = 3},
  [6572] = {.lex_state = 588, .external_lex_state = 3},
  [6573] = {.lex_state = 444, .external_lex_state = 3},
  [6574] = {.lex_state = 524, .external_lex_state = 21},
  [6575] = {.lex_state = 444, .external_lex_state = 3},
  [6576] = {.lex_state = 467, .external_lex_state = 3},
  [6577] = {.lex_state = 588, .external_lex_state = 3},
  [6578] = {.lex_state = 588, .external_lex_state = 3},
  [6579] = {.lex_state = 588, .external_lex_state = 3},
  [6580] = {.lex_state = 663, .external_lex_state = 14},
  [6581] = {.lex_state = 237, .external_lex_state = 8},
  [6582] = {.lex_state = 128, .external_lex_state = 2},
  [6583] = {.lex_state = 192, .external_lex_state = 2},
  [6584] = {.lex_state = 441, .external_lex_state = 3},
  [6585] = {.lex_state = 441, .external_lex_state = 3},
  [6586] = {.lex_state = 192, .external_lex_state = 2},
  [6587] = {.lex_state = 192, .external_lex_state = 2},
  [6588] = {.lex_state = 192, .external_lex_state = 2},
  [6589] = {.lex_state = 192, .external_lex_state = 2},
  [6590] = {.lex_state = 192, .external_lex_state = 2},
  [6591] = {.lex_state = 192, .external_lex_state = 2},
  [6592] = {.lex_state = 192, .external_lex_state = 2},
  [6593] = {.lex_state = 192, .external_lex_state = 2},
  [6594] = {.lex_state = 192, .external_lex_state = 2},
  [6595] = {.lex_state = 192, .external_lex_state = 2},
  [6596] = {.lex_state = 192, .external_lex_state = 29},
  [6597] = {.lex_state = 192, .external_lex_state = 2},
  [6598] = {.lex_state = 441, .external_lex_state = 14},
  [6599] = {.lex_state = 441, .external_lex_state = 3},
  [6600] = {.lex_state = 441, .external_lex_state = 3},
  [6601] = {.lex_state = 573, .external_lex_state = 3},
  [6602] = {.lex_state = 573, .external_lex_state = 3},
  [6603] = {.lex_state = 573, .external_lex_state = 3},
  [6604] = {.lex_state = 573, .external_lex_state = 3},
  [6605] = {.lex_state = 573, .external_lex_state = 3},
  [6606] = {.lex_state = 554, .external_lex_state = 16},
  [6607] = {.lex_state = 573, .external_lex_state = 3},
  [6608] = {.lex_state = 573, .external_lex_state = 3},
  [6609] = {.lex_state = 573, .external_lex_state = 3},
  [6610] = {.lex_state = 573, .external_lex_state = 3},
  [6611] = {.lex_state = 441, .external_lex_state = 3},
  [6612] = {.lex_state = 524, .external_lex_state = 21},
  [6613] = {.lex_state = 441, .external_lex_state = 3},
  [6614] = {.lex_state = 441, .external_lex_state = 3},
  [6615] = {.lex_state = 573, .external_lex_state = 3},
  [6616] = {.lex_state = 573, .external_lex_state = 3},
  [6617] = {.lex_state = 573, .external_lex_state = 3},
  [6618] = {.lex_state = 664, .external_lex_state = 14},
  [6619] = {.lex_state = 436, .external_lex_state = 3},
  [6620] = {.lex_state = 436, .external_lex_state = 3},
  [6621] = {.lex_state = 436, .external_lex_state = 3},
  [6622] = {.lex_state = 192, .external_lex_state = 2},
  [6623] = {.lex_state = 192, .external_lex_state = 2},
  [6624] = {.lex_state = 192, .external_lex_state = 2},
  [6625] = {.lex_state = 192, .external_lex_state = 2},
  [6626] = {.lex_state = 192, .external_lex_state = 2},
  [6627] = {.lex_state = 192, .external_lex_state = 2},
  [6628] = {.lex_state = 192, .external_lex_state = 2},
  [6629] = {.lex_state = 192, .external_lex_state = 2},
  [6630] = {.lex_state = 192, .external_lex_state = 2},
  [6631] = {.lex_state = 192, .external_lex_state = 2},
  [6632] = {.lex_state = 192, .external_lex_state = 29},
  [6633] = {.lex_state = 436, .external_lex_state = 3},
  [6634] = {.lex_state = 192, .external_lex_state = 29},
  [6635] = {.lex_state = 192, .external_lex_state = 2},
  [6636] = {.lex_state = 288, .external_lex_state = 16},
  [6637] = {.lex_state = 177, .external_lex_state = 4},
  [6638] = {.lex_state = 288, .external_lex_state = 16},
  [6639] = {.lex_state = 288, .external_lex_state = 16},
  [6640] = {.lex_state = 177, .external_lex_state = 4},
  [6641] = {.lex_state = 288, .external_lex_state = 16},
  [6642] = {.lex_state = 225, .external_lex_state = 7},
  [6643] = {.lex_state = 467, .external_lex_state = 25},
  [6644] = {.lex_state = 467, .external_lex_state = 25},
  [6645] = {.lex_state = 192, .external_lex_state = 2},
  [6646] = {.lex_state = 192, .external_lex_state = 2},
  [6647] = {.lex_state = 192, .external_lex_state = 2},
  [6648] = {.lex_state = 192, .external_lex_state = 2},
  [6649] = {.lex_state = 192, .external_lex_state = 2},
  [6650] = {.lex_state = 192, .external_lex_state = 2},
  [6651] = {.lex_state = 192, .external_lex_state = 2},
  [6652] = {.lex_state = 192, .external_lex_state = 2},
  [6653] = {.lex_state = 192, .external_lex_state = 2},
  [6654] = {.lex_state = 192, .external_lex_state = 2},
  [6655] = {.lex_state = 192, .external_lex_state = 29},
  [6656] = {.lex_state = 192, .external_lex_state = 2},
  [6657] = {.lex_state = 467, .external_lex_state = 25},
  [6658] = {.lex_state = 588, .external_lex_state = 25},
  [6659] = {.lex_state = 588, .external_lex_state = 25},
  [6660] = {.lex_state = 192, .external_lex_state = 2},
  [6661] = {.lex_state = 588, .external_lex_state = 25},
  [6662] = {.lex_state = 192, .external_lex_state = 2},
  [6663] = {.lex_state = 588, .external_lex_state = 25},
  [6664] = {.lex_state = 524, .external_lex_state = 13},
  [6665] = {.lex_state = 588, .external_lex_state = 25},
  [6666] = {.lex_state = 467, .external_lex_state = 25},
  [6667] = {.lex_state = 588, .external_lex_state = 25},
  [6668] = {.lex_state = 588, .external_lex_state = 25},
  [6669] = {.lex_state = 588, .external_lex_state = 25},
  [6670] = {.lex_state = 588, .external_lex_state = 25},
  [6671] = {.lex_state = 588, .external_lex_state = 25},
  [6672] = {.lex_state = 554, .external_lex_state = 16},
  [6673] = {.lex_state = 588, .external_lex_state = 25},
  [6674] = {.lex_state = 588, .external_lex_state = 25},
  [6675] = {.lex_state = 588, .external_lex_state = 25},
  [6676] = {.lex_state = 588, .external_lex_state = 25},
  [6677] = {.lex_state = 573, .external_lex_state = 25},
  [6678] = {.lex_state = 573, .external_lex_state = 25},
  [6679] = {.lex_state = 192, .external_lex_state = 2},
  [6680] = {.lex_state = 573, .external_lex_state = 25},
  [6681] = {.lex_state = 192, .external_lex_state = 2},
  [6682] = {.lex_state = 573, .external_lex_state = 25},
  [6683] = {.lex_state = 524, .external_lex_state = 13},
  [6684] = {.lex_state = 573, .external_lex_state = 25},
  [6685] = {.lex_state = 467, .external_lex_state = 25},
  [6686] = {.lex_state = 524, .external_lex_state = 21},
  [6687] = {.lex_state = 467, .external_lex_state = 25},
  [6688] = {.lex_state = 467, .external_lex_state = 25},
  [6689] = {.lex_state = 588, .external_lex_state = 25},
  [6690] = {.lex_state = 588, .external_lex_state = 25},
  [6691] = {.lex_state = 588, .external_lex_state = 25},
  [6692] = {.lex_state = 663, .external_lex_state = 27},
  [6693] = {.lex_state = 192, .external_lex_state = 2},
  [6694] = {.lex_state = 595, .external_lex_state = 26},
  [6695] = {.lex_state = 209, .external_lex_state = 19},
  [6696] = {.lex_state = 209},
  [6697] = {.lex_state = 595, .external_lex_state = 26},
  [6698] = {.lex_state = 461, .external_lex_state = 25},
  [6699] = {.lex_state = 235},
  [6700] = {.lex_state = 441, .external_lex_state = 25},
  [6701] = {.lex_state = 441, .external_lex_state = 25},
  [6702] = {.lex_state = 192, .external_lex_state = 2},
  [6703] = {.lex_state = 192, .external_lex_state = 2},
  [6704] = {.lex_state = 192, .external_lex_state = 2},
  [6705] = {.lex_state = 192, .external_lex_state = 2},
  [6706] = {.lex_state = 192, .external_lex_state = 2},
  [6707] = {.lex_state = 192, .external_lex_state = 2},
  [6708] = {.lex_state = 192, .external_lex_state = 2},
  [6709] = {.lex_state = 192, .external_lex_state = 2},
  [6710] = {.lex_state = 192, .external_lex_state = 2},
  [6711] = {.lex_state = 192, .external_lex_state = 2},
  [6712] = {.lex_state = 192, .external_lex_state = 29},
  [6713] = {.lex_state = 192, .external_lex_state = 2},
  [6714] = {.lex_state = 441, .external_lex_state = 27},
  [6715] = {.lex_state = 441, .external_lex_state = 25},
  [6716] = {.lex_state = 461, .external_lex_state = 25},
  [6717] = {.lex_state = 194},
  [6718] = {.lex_state = 461, .external_lex_state = 25},
  [6719] = {.lex_state = 128},
  [6720] = {.lex_state = 128, .external_lex_state = 2},
  [6721] = {.lex_state = 128, .external_lex_state = 12},
  [6722] = {.lex_state = 441, .external_lex_state = 25},
  [6723] = {.lex_state = 573, .external_lex_state = 25},
  [6724] = {.lex_state = 573, .external_lex_state = 25},
  [6725] = {.lex_state = 573, .external_lex_state = 25},
  [6726] = {.lex_state = 573, .external_lex_state = 25},
  [6727] = {.lex_state = 573, .external_lex_state = 25},
  [6728] = {.lex_state = 554, .external_lex_state = 16},
  [6729] = {.lex_state = 573, .external_lex_state = 25},
  [6730] = {.lex_state = 573, .external_lex_state = 25},
  [6731] = {.lex_state = 573, .external_lex_state = 25},
  [6732] = {.lex_state = 573, .external_lex_state = 25},
  [6733] = {.lex_state = 461, .external_lex_state = 25},
  [6734] = {.lex_state = 441, .external_lex_state = 25},
  [6735] = {.lex_state = 524, .external_lex_state = 21},
  [6736] = {.lex_state = 441, .external_lex_state = 25},
  [6737] = {.lex_state = 441, .external_lex_state = 25},
  [6738] = {.lex_state = 573, .external_lex_state = 25},
  [6739] = {.lex_state = 573, .external_lex_state = 25},
  [6740] = {.lex_state = 573, .external_lex_state = 25},
  [6741] = {.lex_state = 664, .external_lex_state = 27},
  [6742] = {.lex_state = 436, .external_lex_state = 25},
  [6743] = {.lex_state = 192, .external_lex_state = 29},
  [6744] = {.lex_state = 436, .external_lex_state = 25},
  [6745] = {.lex_state = 288, .external_lex_state = 16},
  [6746] = {.lex_state = 288, .external_lex_state = 16},
  [6747] = {.lex_state = 361, .external_lex_state = 25},
  [6748] = {.lex_state = 361, .external_lex_state = 25},
  [6749] = {.lex_state = 388, .external_lex_state = 25},
  [6750] = {.lex_state = 192, .external_lex_state = 2},
  [6751] = {.lex_state = 388, .external_lex_state = 25},
  [6752] = {.lex_state = 388, .external_lex_state = 25},
  [6753] = {.lex_state = 192, .external_lex_state = 29},
  [6754] = {.lex_state = 361, .external_lex_state = 25},
  [6755] = {.lex_state = 288, .external_lex_state = 16},
  [6756] = {.lex_state = 128},
  [6757] = {.lex_state = 128},
  [6758] = {.lex_state = 288, .external_lex_state = 16},
  [6759] = {.lex_state = 128},
  [6760] = {.lex_state = 288, .external_lex_state = 16},
  [6761] = {.lex_state = 288, .external_lex_state = 16},
  [6762] = {.lex_state = 288, .external_lex_state = 16},
  [6763] = {.lex_state = 128},
  [6764] = {.lex_state = 288, .external_lex_state = 16},
  [6765] = {.lex_state = 128},
  [6766] = {.lex_state = 288, .external_lex_state = 16},
  [6767] = {.lex_state = 128},
  [6768] = {.lex_state = 288, .external_lex_state = 16},
  [6769] = {.lex_state = 288, .external_lex_state = 16},
  [6770] = {.lex_state = 128},
  [6771] = {.lex_state = 128, .external_lex_state = 2},
  [6772] = {.lex_state = 302, .external_lex_state = 16},
  [6773] = {.lex_state = 304, .external_lex_state = 18},
  [6774] = {.lex_state = 209},
  [6775] = {.lex_state = 299, .external_lex_state = 16},
  [6776] = {.lex_state = 397, .external_lex_state = 25},
  [6777] = {.lex_state = 397, .external_lex_state = 25},
  [6778] = {.lex_state = 177, .external_lex_state = 4},
  [6779] = {.lex_state = 266, .external_lex_state = 15},
  [6780] = {.lex_state = 397, .external_lex_state = 25},
  [6781] = {.lex_state = 177, .external_lex_state = 4},
  [6782] = {.lex_state = 397, .external_lex_state = 25},
  [6783] = {.lex_state = 397, .external_lex_state = 25},
  [6784] = {.lex_state = 177, .external_lex_state = 4},
  [6785] = {.lex_state = 266, .external_lex_state = 15},
  [6786] = {.lex_state = 397, .external_lex_state = 25},
  [6787] = {.lex_state = 177, .external_lex_state = 4},
  [6788] = {.lex_state = 299, .external_lex_state = 16},
  [6789] = {.lex_state = 397, .external_lex_state = 25},
  [6790] = {.lex_state = 310},
  [6791] = {.lex_state = 397, .external_lex_state = 25},
  [6792] = {.lex_state = 397, .external_lex_state = 25},
  [6793] = {.lex_state = 128, .external_lex_state = 2},
  [6794] = {.lex_state = 128, .external_lex_state = 2},
  [6795] = {.lex_state = 397, .external_lex_state = 25},
  [6796] = {.lex_state = 397, .external_lex_state = 25},
  [6797] = {.lex_state = 397, .external_lex_state = 25},
  [6798] = {.lex_state = 128},
  [6799] = {.lex_state = 128},
  [6800] = {.lex_state = 128, .external_lex_state = 2},
  [6801] = {.lex_state = 397, .external_lex_state = 25},
  [6802] = {.lex_state = 128},
  [6803] = {.lex_state = 128},
  [6804] = {.lex_state = 397, .external_lex_state = 25},
  [6805] = {.lex_state = 128},
  [6806] = {.lex_state = 397, .external_lex_state = 25},
  [6807] = {.lex_state = 128},
  [6808] = {.lex_state = 128, .external_lex_state = 2},
  [6809] = {.lex_state = 299, .external_lex_state = 16},
  [6810] = {.lex_state = 128},
  [6811] = {.lex_state = 128, .external_lex_state = 2},
  [6812] = {.lex_state = 128},
  [6813] = {.lex_state = 128},
  [6814] = {.lex_state = 397, .external_lex_state = 25},
  [6815] = {.lex_state = 397, .external_lex_state = 25},
  [6816] = {.lex_state = 128},
  [6817] = {.lex_state = 128},
  [6818] = {.lex_state = 397, .external_lex_state = 25},
  [6819] = {.lex_state = 397, .external_lex_state = 25},
  [6820] = {.lex_state = 192, .external_lex_state = 2},
  [6821] = {.lex_state = 397, .external_lex_state = 25},
  [6822] = {.lex_state = 397, .external_lex_state = 25},
  [6823] = {.lex_state = 192, .external_lex_state = 29},
  [6824] = {.lex_state = 421, .external_lex_state = 25},
  [6825] = {.lex_state = 302, .external_lex_state = 16},
  [6826] = {.lex_state = 302, .external_lex_state = 16},
  [6827] = {.lex_state = 302, .external_lex_state = 16},
  [6828] = {.lex_state = 302, .external_lex_state = 16},
  [6829] = {.lex_state = 302, .external_lex_state = 16},
  [6830] = {.lex_state = 554, .external_lex_state = 16},
  [6831] = {.lex_state = 302, .external_lex_state = 16},
  [6832] = {.lex_state = 302, .external_lex_state = 16},
  [6833] = {.lex_state = 302, .external_lex_state = 16},
  [6834] = {.lex_state = 302, .external_lex_state = 16},
  [6835] = {.lex_state = 473, .external_lex_state = 16},
  [6836] = {.lex_state = 302, .external_lex_state = 16},
  [6837] = {.lex_state = 302, .external_lex_state = 16},
  [6838] = {.lex_state = 302, .external_lex_state = 16},
  [6839] = {.lex_state = 156, .external_lex_state = 20},
  [6840] = {.lex_state = 194, .external_lex_state = 6},
  [6841] = {.lex_state = 493, .external_lex_state = 25},
  [6842] = {.lex_state = 493, .external_lex_state = 25},
  [6843] = {.lex_state = 192, .external_lex_state = 2},
  [6844] = {.lex_state = 192, .external_lex_state = 2},
  [6845] = {.lex_state = 192, .external_lex_state = 2},
  [6846] = {.lex_state = 192, .external_lex_state = 2},
  [6847] = {.lex_state = 192, .external_lex_state = 2},
  [6848] = {.lex_state = 192, .external_lex_state = 2},
  [6849] = {.lex_state = 192, .external_lex_state = 2},
  [6850] = {.lex_state = 192, .external_lex_state = 2},
  [6851] = {.lex_state = 192, .external_lex_state = 2},
  [6852] = {.lex_state = 192, .external_lex_state = 2},
  [6853] = {.lex_state = 192, .external_lex_state = 29},
  [6854] = {.lex_state = 192, .external_lex_state = 2},
  [6855] = {.lex_state = 493, .external_lex_state = 25},
  [6856] = {.lex_state = 493, .external_lex_state = 25},
  [6857] = {.lex_state = 493, .external_lex_state = 25},
  [6858] = {.lex_state = 493, .external_lex_state = 25},
  [6859] = {.lex_state = 493, .external_lex_state = 25},
  [6860] = {.lex_state = 493, .external_lex_state = 25},
  [6861] = {.lex_state = 493, .external_lex_state = 25},
  [6862] = {.lex_state = 554, .external_lex_state = 16},
  [6863] = {.lex_state = 493, .external_lex_state = 25},
  [6864] = {.lex_state = 493, .external_lex_state = 25},
  [6865] = {.lex_state = 493, .external_lex_state = 25},
  [6866] = {.lex_state = 493, .external_lex_state = 25},
  [6867] = {.lex_state = 324, .external_lex_state = 25},
  [6868] = {.lex_state = 524, .external_lex_state = 21},
  [6869] = {.lex_state = 324, .external_lex_state = 25},
  [6870] = {.lex_state = 493, .external_lex_state = 25},
  [6871] = {.lex_state = 493, .external_lex_state = 25},
  [6872] = {.lex_state = 493, .external_lex_state = 25},
  [6873] = {.lex_state = 493, .external_lex_state = 25},
  [6874] = {.lex_state = 156, .external_lex_state = 3},
  [6875] = {.lex_state = 192, .external_lex_state = 2},
  [6876] = {.lex_state = 321, .external_lex_state = 25},
  [6877] = {.lex_state = 321, .external_lex_state = 25},
  [6878] = {.lex_state = 192, .external_lex_state = 2},
  [6879] = {.lex_state = 192, .external_lex_state = 2},
  [6880] = {.lex_state = 192, .external_lex_state = 2},
  [6881] = {.lex_state = 192, .external_lex_state = 2},
  [6882] = {.lex_state = 192, .external_lex_state = 2},
  [6883] = {.lex_state = 192, .external_lex_state = 2},
  [6884] = {.lex_state = 192, .external_lex_state = 2},
  [6885] = {.lex_state = 192, .external_lex_state = 2},
  [6886] = {.lex_state = 192, .external_lex_state = 2},
  [6887] = {.lex_state = 192, .external_lex_state = 2},
  [6888] = {.lex_state = 192, .external_lex_state = 29},
  [6889] = {.lex_state = 192, .external_lex_state = 2},
  [6890] = {.lex_state = 321, .external_lex_state = 27},
  [6891] = {.lex_state = 321, .external_lex_state = 25},
  [6892] = {.lex_state = 321, .external_lex_state = 25},
  [6893] = {.lex_state = 497, .external_lex_state = 25},
  [6894] = {.lex_state = 497, .external_lex_state = 25},
  [6895] = {.lex_state = 497, .external_lex_state = 25},
  [6896] = {.lex_state = 497, .external_lex_state = 25},
  [6897] = {.lex_state = 497, .external_lex_state = 25},
  [6898] = {.lex_state = 554, .external_lex_state = 16},
  [6899] = {.lex_state = 497, .external_lex_state = 25},
  [6900] = {.lex_state = 497, .external_lex_state = 25},
  [6901] = {.lex_state = 497, .external_lex_state = 25},
  [6902] = {.lex_state = 497, .external_lex_state = 25},
  [6903] = {.lex_state = 321, .external_lex_state = 25},
  [6904] = {.lex_state = 524, .external_lex_state = 21},
  [6905] = {.lex_state = 321, .external_lex_state = 25},
  [6906] = {.lex_state = 321, .external_lex_state = 25},
  [6907] = {.lex_state = 497, .external_lex_state = 25},
  [6908] = {.lex_state = 497, .external_lex_state = 25},
  [6909] = {.lex_state = 497, .external_lex_state = 25},
  [6910] = {.lex_state = 614, .external_lex_state = 27},
  [6911] = {.lex_state = 302, .external_lex_state = 16},
  [6912] = {.lex_state = 302, .external_lex_state = 16},
  [6913] = {.lex_state = 302, .external_lex_state = 16},
  [6914] = {.lex_state = 192, .external_lex_state = 2},
  [6915] = {.lex_state = 192, .external_lex_state = 2},
  [6916] = {.lex_state = 192, .external_lex_state = 2},
  [6917] = {.lex_state = 192, .external_lex_state = 2},
  [6918] = {.lex_state = 192, .external_lex_state = 2},
  [6919] = {.lex_state = 192, .external_lex_state = 2},
  [6920] = {.lex_state = 192, .external_lex_state = 2},
  [6921] = {.lex_state = 192, .external_lex_state = 2},
  [6922] = {.lex_state = 192, .external_lex_state = 2},
  [6923] = {.lex_state = 192, .external_lex_state = 2},
  [6924] = {.lex_state = 192, .external_lex_state = 29},
  [6925] = {.lex_state = 302, .external_lex_state = 16},
  [6926] = {.lex_state = 192, .external_lex_state = 29},
  [6927] = {.lex_state = 192, .external_lex_state = 2},
  [6928] = {.lex_state = 610, .external_lex_state = 20},
  [6929] = {.lex_state = 128, .external_lex_state = 2},
  [6930] = {.lex_state = 128, .external_lex_state = 12},
  [6931] = {.lex_state = 678, .external_lex_state = 8},
  [6932] = {.lex_state = 194},
  [6933] = {.lex_state = 286, .external_lex_state = 2},
  [6934] = {.lex_state = 678, .external_lex_state = 8},
  [6935] = {.lex_state = 128},
  [6936] = {.lex_state = 128, .external_lex_state = 12},
  [6937] = {.lex_state = 414, .external_lex_state = 2},
  [6938] = {.lex_state = 254, .external_lex_state = 8},
  [6939] = {.lex_state = 302},
  [6940] = {.lex_state = 197},
  [6941] = {.lex_state = 254, .external_lex_state = 8},
  [6942] = {.lex_state = 621, .external_lex_state = 25},
  [6943] = {.lex_state = 192, .external_lex_state = 2},
  [6944] = {.lex_state = 192, .external_lex_state = 2},
  [6945] = {.lex_state = 237},
  [6946] = {.lex_state = 192, .external_lex_state = 2},
  [6947] = {.lex_state = 520, .external_lex_state = 26},
  [6948] = {.lex_state = 604, .external_lex_state = 25},
  [6949] = {.lex_state = 621, .external_lex_state = 25},
  [6950] = {.lex_state = 621, .external_lex_state = 25},
  [6951] = {.lex_state = 604, .external_lex_state = 27},
  [6952] = {.lex_state = 621, .external_lex_state = 25},
  [6953] = {.lex_state = 192, .external_lex_state = 2},
  [6954] = {.lex_state = 192, .external_lex_state = 2},
  [6955] = {.lex_state = 192, .external_lex_state = 2},
  [6956] = {.lex_state = 192, .external_lex_state = 2},
  [6957] = {.lex_state = 192, .external_lex_state = 2},
  [6958] = {.lex_state = 192, .external_lex_state = 2},
  [6959] = {.lex_state = 192, .external_lex_state = 2},
  [6960] = {.lex_state = 192, .external_lex_state = 2},
  [6961] = {.lex_state = 192, .external_lex_state = 2},
  [6962] = {.lex_state = 192, .external_lex_state = 2},
  [6963] = {.lex_state = 192, .external_lex_state = 29},
  [6964] = {.lex_state = 192, .external_lex_state = 2},
  [6965] = {.lex_state = 621, .external_lex_state = 27},
  [6966] = {.lex_state = 621, .external_lex_state = 25},
  [6967] = {.lex_state = 604, .external_lex_state = 25},
  [6968] = {.lex_state = 604, .external_lex_state = 25},
  [6969] = {.lex_state = 192, .external_lex_state = 2},
  [6970] = {.lex_state = 604, .external_lex_state = 25},
  [6971] = {.lex_state = 192, .external_lex_state = 2},
  [6972] = {.lex_state = 604, .external_lex_state = 25},
  [6973] = {.lex_state = 524, .external_lex_state = 13},
  [6974] = {.lex_state = 604, .external_lex_state = 25},
  [6975] = {.lex_state = 621, .external_lex_state = 25},
  [6976] = {.lex_state = 604, .external_lex_state = 25},
  [6977] = {.lex_state = 604, .external_lex_state = 25},
  [6978] = {.lex_state = 604, .external_lex_state = 25},
  [6979] = {.lex_state = 604, .external_lex_state = 25},
  [6980] = {.lex_state = 604, .external_lex_state = 25},
  [6981] = {.lex_state = 554, .external_lex_state = 16},
  [6982] = {.lex_state = 604, .external_lex_state = 25},
  [6983] = {.lex_state = 604, .external_lex_state = 25},
  [6984] = {.lex_state = 604, .external_lex_state = 25},
  [6985] = {.lex_state = 604, .external_lex_state = 25},
  [6986] = {.lex_state = 337, .external_lex_state = 19},
  [6987] = {.lex_state = 524, .external_lex_state = 21},
  [6988] = {.lex_state = 337, .external_lex_state = 19},
  [6989] = {.lex_state = 337, .external_lex_state = 19},
  [6990] = {.lex_state = 604, .external_lex_state = 25},
  [6991] = {.lex_state = 604, .external_lex_state = 25},
  [6992] = {.lex_state = 604, .external_lex_state = 25},
  [6993] = {.lex_state = 674, .external_lex_state = 27},
  [6994] = {.lex_state = 493, .external_lex_state = 3},
  [6995] = {.lex_state = 493, .external_lex_state = 3},
  [6996] = {.lex_state = 493, .external_lex_state = 3},
  [6997] = {.lex_state = 493, .external_lex_state = 3},
  [6998] = {.lex_state = 493, .external_lex_state = 3},
  [6999] = {.lex_state = 493, .external_lex_state = 3},
  [7000] = {.lex_state = 493, .external_lex_state = 3},
  [7001] = {.lex_state = 554, .external_lex_state = 16},
  [7002] = {.lex_state = 493, .external_lex_state = 3},
  [7003] = {.lex_state = 493, .external_lex_state = 3},
  [7004] = {.lex_state = 493, .external_lex_state = 3},
  [7005] = {.lex_state = 493, .external_lex_state = 3},
  [7006] = {.lex_state = 493, .external_lex_state = 3},
  [7007] = {.lex_state = 493, .external_lex_state = 3},
  [7008] = {.lex_state = 493, .external_lex_state = 3},
  [7009] = {.lex_state = 610, .external_lex_state = 14},
  [7010] = {.lex_state = 493, .external_lex_state = 3},
  [7011] = {.lex_state = 493, .external_lex_state = 3},
  [7012] = {.lex_state = 493, .external_lex_state = 3},
  [7013] = {.lex_state = 524, .external_lex_state = 21},
  [7014] = {.lex_state = 493, .external_lex_state = 3},
  [7015] = {.lex_state = 493, .external_lex_state = 3},
  [7016] = {.lex_state = 192, .external_lex_state = 2},
  [7017] = {.lex_state = 497, .external_lex_state = 3},
  [7018] = {.lex_state = 497, .external_lex_state = 3},
  [7019] = {.lex_state = 497, .external_lex_state = 3},
  [7020] = {.lex_state = 524, .external_lex_state = 21},
  [7021] = {.lex_state = 497, .external_lex_state = 3},
  [7022] = {.lex_state = 497, .external_lex_state = 3},
  [7023] = {.lex_state = 192, .external_lex_state = 29},
  [7024] = {.lex_state = 493, .external_lex_state = 3},
  [7025] = {.lex_state = 302, .external_lex_state = 3},
  [7026] = {.lex_state = 321, .external_lex_state = 3},
  [7027] = {.lex_state = 321, .external_lex_state = 3},
  [7028] = {.lex_state = 321, .external_lex_state = 3},
  [7029] = {.lex_state = 321, .external_lex_state = 3},
  [7030] = {.lex_state = 321, .external_lex_state = 3},
  [7031] = {.lex_state = 554, .external_lex_state = 16},
  [7032] = {.lex_state = 321, .external_lex_state = 3},
  [7033] = {.lex_state = 321, .external_lex_state = 3},
  [7034] = {.lex_state = 321, .external_lex_state = 3},
  [7035] = {.lex_state = 321, .external_lex_state = 3},
  [7036] = {.lex_state = 321, .external_lex_state = 3},
  [7037] = {.lex_state = 321, .external_lex_state = 3},
  [7038] = {.lex_state = 321, .external_lex_state = 3},
  [7039] = {.lex_state = 321, .external_lex_state = 14},
  [7040] = {.lex_state = 192, .external_lex_state = 2},
  [7041] = {.lex_state = 192, .external_lex_state = 29},
  [7042] = {.lex_state = 497, .external_lex_state = 3},
  [7043] = {.lex_state = 302, .external_lex_state = 3},
  [7044] = {.lex_state = 302, .external_lex_state = 3},
  [7045] = {.lex_state = 302, .external_lex_state = 3},
  [7046] = {.lex_state = 302, .external_lex_state = 3},
  [7047] = {.lex_state = 302, .external_lex_state = 3},
  [7048] = {.lex_state = 554, .external_lex_state = 16},
  [7049] = {.lex_state = 302, .external_lex_state = 3},
  [7050] = {.lex_state = 302, .external_lex_state = 3},
  [7051] = {.lex_state = 302, .external_lex_state = 3},
  [7052] = {.lex_state = 302, .external_lex_state = 3},
  [7053] = {.lex_state = 302, .external_lex_state = 3},
  [7054] = {.lex_state = 302, .external_lex_state = 3},
  [7055] = {.lex_state = 302, .external_lex_state = 3},
  [7056] = {.lex_state = 330},
  [7057] = {.lex_state = 177, .external_lex_state = 4},
  [7058] = {.lex_state = 330},
  [7059] = {.lex_state = 330},
  [7060] = {.lex_state = 177, .external_lex_state = 4},
  [7061] = {.lex_state = 330},
  [7062] = {.lex_state = 225, .external_lex_state = 7},
  [7063] = {.lex_state = 330},
  [7064] = {.lex_state = 330},
  [7065] = {.lex_state = 361, .external_lex_state = 25},
  [7066] = {.lex_state = 361, .external_lex_state = 25},
  [7067] = {.lex_state = 192, .external_lex_state = 2},
  [7068] = {.lex_state = 361, .external_lex_state = 25},
  [7069] = {.lex_state = 192, .external_lex_state = 2},
  [7070] = {.lex_state = 361, .external_lex_state = 25},
  [7071] = {.lex_state = 524, .external_lex_state = 13},
  [7072] = {.lex_state = 361, .external_lex_state = 25},
  [7073] = {.lex_state = 361, .external_lex_state = 25},
  [7074] = {.lex_state = 361, .external_lex_state = 25},
  [7075] = {.lex_state = 361, .external_lex_state = 25},
  [7076] = {.lex_state = 361, .external_lex_state = 25},
  [7077] = {.lex_state = 361, .external_lex_state = 25},
  [7078] = {.lex_state = 554, .external_lex_state = 16},
  [7079] = {.lex_state = 361, .external_lex_state = 25},
  [7080] = {.lex_state = 361, .external_lex_state = 25},
  [7081] = {.lex_state = 361, .external_lex_state = 25},
  [7082] = {.lex_state = 361, .external_lex_state = 25},
  [7083] = {.lex_state = 192, .external_lex_state = 2},
  [7084] = {.lex_state = 618, .external_lex_state = 26},
  [7085] = {.lex_state = 618, .external_lex_state = 26},
  [7086] = {.lex_state = 618, .external_lex_state = 26},
  [7087] = {.lex_state = 618, .external_lex_state = 26},
  [7088] = {.lex_state = 192, .external_lex_state = 2},
  [7089] = {.lex_state = 192, .external_lex_state = 2},
  [7090] = {.lex_state = 424, .external_lex_state = 25},
  [7091] = {.lex_state = 213},
  [7092] = {.lex_state = 424, .external_lex_state = 25},
  [7093] = {.lex_state = 424, .external_lex_state = 27},
  [7094] = {.lex_state = 424, .external_lex_state = 25},
  [7095] = {.lex_state = 192, .external_lex_state = 2},
  [7096] = {.lex_state = 424, .external_lex_state = 25},
  [7097] = {.lex_state = 192, .external_lex_state = 2},
  [7098] = {.lex_state = 424, .external_lex_state = 25},
  [7099] = {.lex_state = 524, .external_lex_state = 13},
  [7100] = {.lex_state = 424, .external_lex_state = 25},
  [7101] = {.lex_state = 361, .external_lex_state = 25},
  [7102] = {.lex_state = 361, .external_lex_state = 25},
  [7103] = {.lex_state = 361, .external_lex_state = 25},
  [7104] = {.lex_state = 365, .external_lex_state = 27},
  [7105] = {.lex_state = 337, .external_lex_state = 19},
  [7106] = {.lex_state = 337, .external_lex_state = 19},
  [7107] = {.lex_state = 337, .external_lex_state = 19},
  [7108] = {.lex_state = 330},
  [7109] = {.lex_state = 128},
  [7110] = {.lex_state = 128},
  [7111] = {.lex_state = 330},
  [7112] = {.lex_state = 128},
  [7113] = {.lex_state = 330},
  [7114] = {.lex_state = 330},
  [7115] = {.lex_state = 330},
  [7116] = {.lex_state = 128},
  [7117] = {.lex_state = 330},
  [7118] = {.lex_state = 128},
  [7119] = {.lex_state = 330},
  [7120] = {.lex_state = 128},
  [7121] = {.lex_state = 337},
  [7122] = {.lex_state = 337},
  [7123] = {.lex_state = 128},
  [7124] = {.lex_state = 128, .external_lex_state = 2},
  [7125] = {.lex_state = 484, .external_lex_state = 21},
  [7126] = {.lex_state = 209},
  [7127] = {.lex_state = 337},
  [7128] = {.lex_state = 675, .external_lex_state = 27},
  [7129] = {.lex_state = 621, .external_lex_state = 25},
  [7130] = {.lex_state = 621, .external_lex_state = 25},
  [7131] = {.lex_state = 621, .external_lex_state = 25},
  [7132] = {.lex_state = 621, .external_lex_state = 25},
  [7133] = {.lex_state = 192, .external_lex_state = 15},
  [7134] = {.lex_state = 266, .external_lex_state = 15},
  [7135] = {.lex_state = 621, .external_lex_state = 25},
  [7136] = {.lex_state = 177, .external_lex_state = 4},
  [7137] = {.lex_state = 266, .external_lex_state = 15},
  [7138] = {.lex_state = 621, .external_lex_state = 25},
  [7139] = {.lex_state = 192, .external_lex_state = 15},
  [7140] = {.lex_state = 266, .external_lex_state = 15},
  [7141] = {.lex_state = 621, .external_lex_state = 25},
  [7142] = {.lex_state = 177, .external_lex_state = 4},
  [7143] = {.lex_state = 266, .external_lex_state = 15},
  [7144] = {.lex_state = 621, .external_lex_state = 25},
  [7145] = {.lex_state = 194},
  [7146] = {.lex_state = 302, .external_lex_state = 16},
  [7147] = {.lex_state = 225, .external_lex_state = 7},
  [7148] = {.lex_state = 128, .external_lex_state = 2},
  [7149] = {.lex_state = 621, .external_lex_state = 25},
  [7150] = {.lex_state = 247, .external_lex_state = 3},
  [7151] = {.lex_state = 128, .external_lex_state = 8},
  [7152] = {.lex_state = 128, .external_lex_state = 2},
  [7153] = {.lex_state = 621, .external_lex_state = 25},
  [7154] = {.lex_state = 128, .external_lex_state = 2},
  [7155] = {.lex_state = 627, .external_lex_state = 25},
  [7156] = {.lex_state = 627, .external_lex_state = 25},
  [7157] = {.lex_state = 192, .external_lex_state = 2},
  [7158] = {.lex_state = 627, .external_lex_state = 25},
  [7159] = {.lex_state = 621, .external_lex_state = 25},
  [7160] = {.lex_state = 209, .external_lex_state = 19},
  [7161] = {.lex_state = 209},
  [7162] = {.lex_state = 192, .external_lex_state = 2},
  [7163] = {.lex_state = 177, .external_lex_state = 17},
  [7164] = {.lex_state = 627, .external_lex_state = 25},
  [7165] = {.lex_state = 524, .external_lex_state = 13},
  [7166] = {.lex_state = 627, .external_lex_state = 25},
  [7167] = {.lex_state = 128, .external_lex_state = 12},
  [7168] = {.lex_state = 128, .external_lex_state = 2},
  [7169] = {.lex_state = 128, .external_lex_state = 2},
  [7170] = {.lex_state = 128, .external_lex_state = 2},
  [7171] = {.lex_state = 128, .external_lex_state = 8},
  [7172] = {.lex_state = 128},
  [7173] = {.lex_state = 128},
  [7174] = {.lex_state = 128},
  [7175] = {.lex_state = 621, .external_lex_state = 25},
  [7176] = {.lex_state = 128},
  [7177] = {.lex_state = 128},
  [7178] = {.lex_state = 128},
  [7179] = {.lex_state = 621, .external_lex_state = 25},
  [7180] = {.lex_state = 621, .external_lex_state = 25},
  [7181] = {.lex_state = 235},
  [7182] = {.lex_state = 621, .external_lex_state = 25},
  [7183] = {.lex_state = 194},
  [7184] = {.lex_state = 286, .external_lex_state = 2},
  [7185] = {.lex_state = 621, .external_lex_state = 25},
  [7186] = {.lex_state = 128},
  [7187] = {.lex_state = 128, .external_lex_state = 12},
  [7188] = {.lex_state = 414, .external_lex_state = 2},
  [7189] = {.lex_state = 621, .external_lex_state = 25},
  [7190] = {.lex_state = 627, .external_lex_state = 25},
  [7191] = {.lex_state = 627, .external_lex_state = 25},
  [7192] = {.lex_state = 627, .external_lex_state = 25},
  [7193] = {.lex_state = 627, .external_lex_state = 25},
  [7194] = {.lex_state = 627, .external_lex_state = 25},
  [7195] = {.lex_state = 554, .external_lex_state = 16},
  [7196] = {.lex_state = 627, .external_lex_state = 25},
  [7197] = {.lex_state = 627, .external_lex_state = 25},
  [7198] = {.lex_state = 627, .external_lex_state = 25},
  [7199] = {.lex_state = 627, .external_lex_state = 25},
  [7200] = {.lex_state = 397, .external_lex_state = 25},
  [7201] = {.lex_state = 627, .external_lex_state = 25},
  [7202] = {.lex_state = 621, .external_lex_state = 25},
  [7203] = {.lex_state = 627, .external_lex_state = 25},
  [7204] = {.lex_state = 627, .external_lex_state = 25},
  [7205] = {.lex_state = 627, .external_lex_state = 27},
  [7206] = {.lex_state = 505, .external_lex_state = 25},
  [7207] = {.lex_state = 505, .external_lex_state = 25},
  [7208] = {.lex_state = 505, .external_lex_state = 25},
  [7209] = {.lex_state = 524, .external_lex_state = 21},
  [7210] = {.lex_state = 505, .external_lex_state = 25},
  [7211] = {.lex_state = 505, .external_lex_state = 25},
  [7212] = {.lex_state = 192, .external_lex_state = 2},
  [7213] = {.lex_state = 192, .external_lex_state = 29},
  [7214] = {.lex_state = 505, .external_lex_state = 25},
  [7215] = {.lex_state = 508, .external_lex_state = 25},
  [7216] = {.lex_state = 508, .external_lex_state = 25},
  [7217] = {.lex_state = 192, .external_lex_state = 2},
  [7218] = {.lex_state = 508, .external_lex_state = 25},
  [7219] = {.lex_state = 192, .external_lex_state = 2},
  [7220] = {.lex_state = 508, .external_lex_state = 25},
  [7221] = {.lex_state = 524, .external_lex_state = 13},
  [7222] = {.lex_state = 508, .external_lex_state = 25},
  [7223] = {.lex_state = 508, .external_lex_state = 25},
  [7224] = {.lex_state = 508, .external_lex_state = 25},
  [7225] = {.lex_state = 508, .external_lex_state = 25},
  [7226] = {.lex_state = 508, .external_lex_state = 25},
  [7227] = {.lex_state = 508, .external_lex_state = 25},
  [7228] = {.lex_state = 554, .external_lex_state = 16},
  [7229] = {.lex_state = 508, .external_lex_state = 25},
  [7230] = {.lex_state = 508, .external_lex_state = 25},
  [7231] = {.lex_state = 508, .external_lex_state = 25},
  [7232] = {.lex_state = 508, .external_lex_state = 25},
  [7233] = {.lex_state = 508, .external_lex_state = 25},
  [7234] = {.lex_state = 508, .external_lex_state = 25},
  [7235] = {.lex_state = 508, .external_lex_state = 25},
  [7236] = {.lex_state = 631, .external_lex_state = 27},
  [7237] = {.lex_state = 508, .external_lex_state = 25},
  [7238] = {.lex_state = 508, .external_lex_state = 25},
  [7239] = {.lex_state = 508, .external_lex_state = 25},
  [7240] = {.lex_state = 524, .external_lex_state = 21},
  [7241] = {.lex_state = 508, .external_lex_state = 25},
  [7242] = {.lex_state = 508, .external_lex_state = 25},
  [7243] = {.lex_state = 192, .external_lex_state = 2},
  [7244] = {.lex_state = 192, .external_lex_state = 29},
  [7245] = {.lex_state = 508, .external_lex_state = 25},
  [7246] = {.lex_state = 365, .external_lex_state = 3},
  [7247] = {.lex_state = 365, .external_lex_state = 3},
  [7248] = {.lex_state = 192, .external_lex_state = 2},
  [7249] = {.lex_state = 192, .external_lex_state = 29},
  [7250] = {.lex_state = 365, .external_lex_state = 3},
  [7251] = {.lex_state = 493, .external_lex_state = 25},
  [7252] = {.lex_state = 493, .external_lex_state = 25},
  [7253] = {.lex_state = 302, .external_lex_state = 25},
  [7254] = {.lex_state = 302, .external_lex_state = 25},
  [7255] = {.lex_state = 302, .external_lex_state = 25},
  [7256] = {.lex_state = 302, .external_lex_state = 25},
  [7257] = {.lex_state = 302, .external_lex_state = 25},
  [7258] = {.lex_state = 554, .external_lex_state = 16},
  [7259] = {.lex_state = 302, .external_lex_state = 25},
  [7260] = {.lex_state = 302, .external_lex_state = 25},
  [7261] = {.lex_state = 302, .external_lex_state = 25},
  [7262] = {.lex_state = 302, .external_lex_state = 25},
  [7263] = {.lex_state = 192, .external_lex_state = 2},
  [7264] = {.lex_state = 302, .external_lex_state = 25},
  [7265] = {.lex_state = 302, .external_lex_state = 25},
  [7266] = {.lex_state = 302, .external_lex_state = 25},
  [7267] = {.lex_state = 610, .external_lex_state = 27},
  [7268] = {.lex_state = 493, .external_lex_state = 25},
  [7269] = {.lex_state = 493, .external_lex_state = 25},
  [7270] = {.lex_state = 493, .external_lex_state = 25},
  [7271] = {.lex_state = 524, .external_lex_state = 21},
  [7272] = {.lex_state = 493, .external_lex_state = 25},
  [7273] = {.lex_state = 493, .external_lex_state = 25},
  [7274] = {.lex_state = 192, .external_lex_state = 2},
  [7275] = {.lex_state = 497, .external_lex_state = 25},
  [7276] = {.lex_state = 497, .external_lex_state = 25},
  [7277] = {.lex_state = 497, .external_lex_state = 25},
  [7278] = {.lex_state = 524, .external_lex_state = 21},
  [7279] = {.lex_state = 497, .external_lex_state = 25},
  [7280] = {.lex_state = 497, .external_lex_state = 25},
  [7281] = {.lex_state = 302, .external_lex_state = 25},
  [7282] = {.lex_state = 192, .external_lex_state = 29},
  [7283] = {.lex_state = 302, .external_lex_state = 25},
  [7284] = {.lex_state = 361, .external_lex_state = 3},
  [7285] = {.lex_state = 514, .external_lex_state = 11},
  [7286] = {.lex_state = 209},
  [7287] = {.lex_state = 299, .external_lex_state = 3},
  [7288] = {.lex_state = 299, .external_lex_state = 3},
  [7289] = {.lex_state = 299, .external_lex_state = 3},
  [7290] = {.lex_state = 128},
  [7291] = {.lex_state = 128, .external_lex_state = 2},
  [7292] = {.lex_state = 299, .external_lex_state = 3},
  [7293] = {.lex_state = 299, .external_lex_state = 3},
  [7294] = {.lex_state = 299, .external_lex_state = 3},
  [7295] = {.lex_state = 524, .external_lex_state = 21},
  [7296] = {.lex_state = 156, .external_lex_state = 3},
  [7297] = {.lex_state = 361, .external_lex_state = 3},
  [7298] = {.lex_state = 361, .external_lex_state = 3},
  [7299] = {.lex_state = 361, .external_lex_state = 3},
  [7300] = {.lex_state = 361, .external_lex_state = 3},
  [7301] = {.lex_state = 361, .external_lex_state = 3},
  [7302] = {.lex_state = 361, .external_lex_state = 3},
  [7303] = {.lex_state = 361, .external_lex_state = 3},
  [7304] = {.lex_state = 361, .external_lex_state = 3},
  [7305] = {.lex_state = 554, .external_lex_state = 16},
  [7306] = {.lex_state = 361, .external_lex_state = 3},
  [7307] = {.lex_state = 361, .external_lex_state = 3},
  [7308] = {.lex_state = 361, .external_lex_state = 3},
  [7309] = {.lex_state = 361, .external_lex_state = 3},
  [7310] = {.lex_state = 361, .external_lex_state = 3},
  [7311] = {.lex_state = 361, .external_lex_state = 3},
  [7312] = {.lex_state = 361, .external_lex_state = 3},
  [7313] = {.lex_state = 365, .external_lex_state = 14},
  [7314] = {.lex_state = 361, .external_lex_state = 3},
  [7315] = {.lex_state = 361, .external_lex_state = 3},
  [7316] = {.lex_state = 361, .external_lex_state = 3},
  [7317] = {.lex_state = 524, .external_lex_state = 21},
  [7318] = {.lex_state = 361, .external_lex_state = 3},
  [7319] = {.lex_state = 361, .external_lex_state = 3},
  [7320] = {.lex_state = 192, .external_lex_state = 2},
  [7321] = {.lex_state = 421, .external_lex_state = 3},
  [7322] = {.lex_state = 421, .external_lex_state = 3},
  [7323] = {.lex_state = 421, .external_lex_state = 3},
  [7324] = {.lex_state = 524, .external_lex_state = 21},
  [7325] = {.lex_state = 421, .external_lex_state = 3},
  [7326] = {.lex_state = 421, .external_lex_state = 3},
  [7327] = {.lex_state = 192, .external_lex_state = 29},
  [7328] = {.lex_state = 361, .external_lex_state = 3},
  [7329] = {.lex_state = 192, .external_lex_state = 2},
  [7330] = {.lex_state = 511, .external_lex_state = 11},
  [7331] = {.lex_state = 511, .external_lex_state = 11},
  [7332] = {.lex_state = 511, .external_lex_state = 11},
  [7333] = {.lex_state = 511, .external_lex_state = 11},
  [7334] = {.lex_state = 192, .external_lex_state = 2},
  [7335] = {.lex_state = 192, .external_lex_state = 2},
  [7336] = {.lex_state = 361, .external_lex_state = 3},
  [7337] = {.lex_state = 213},
  [7338] = {.lex_state = 259, .external_lex_state = 3},
  [7339] = {.lex_state = 365, .external_lex_state = 14},
  [7340] = {.lex_state = 361, .external_lex_state = 3},
  [7341] = {.lex_state = 361, .external_lex_state = 3},
  [7342] = {.lex_state = 361, .external_lex_state = 14},
  [7343] = {.lex_state = 192, .external_lex_state = 2},
  [7344] = {.lex_state = 361, .external_lex_state = 3},
  [7345] = {.lex_state = 192, .external_lex_state = 2},
  [7346] = {.lex_state = 192, .external_lex_state = 2},
  [7347] = {.lex_state = 237},
  [7348] = {.lex_state = 192, .external_lex_state = 2},
  [7349] = {.lex_state = 358, .external_lex_state = 11},
  [7350] = {.lex_state = 361, .external_lex_state = 3},
  [7351] = {.lex_state = 361, .external_lex_state = 3},
  [7352] = {.lex_state = 361, .external_lex_state = 3},
  [7353] = {.lex_state = 371, .external_lex_state = 14},
  [7354] = {.lex_state = 361, .external_lex_state = 3},
  [7355] = {.lex_state = 192, .external_lex_state = 2},
  [7356] = {.lex_state = 192, .external_lex_state = 2},
  [7357] = {.lex_state = 192, .external_lex_state = 2},
  [7358] = {.lex_state = 192, .external_lex_state = 2},
  [7359] = {.lex_state = 192, .external_lex_state = 2},
  [7360] = {.lex_state = 192, .external_lex_state = 2},
  [7361] = {.lex_state = 192, .external_lex_state = 2},
  [7362] = {.lex_state = 192, .external_lex_state = 2},
  [7363] = {.lex_state = 192, .external_lex_state = 2},
  [7364] = {.lex_state = 192, .external_lex_state = 2},
  [7365] = {.lex_state = 192, .external_lex_state = 2},
  [7366] = {.lex_state = 192, .external_lex_state = 2},
  [7367] = {.lex_state = 192, .external_lex_state = 2},
  [7368] = {.lex_state = 237},
  [7369] = {.lex_state = 192, .external_lex_state = 2},
  [7370] = {.lex_state = 358, .external_lex_state = 11},
  [7371] = {.lex_state = 421, .external_lex_state = 3},
  [7372] = {.lex_state = 421, .external_lex_state = 3},
  [7373] = {.lex_state = 421, .external_lex_state = 3},
  [7374] = {.lex_state = 427, .external_lex_state = 14},
  [7375] = {.lex_state = 262, .external_lex_state = 3},
  [7376] = {.lex_state = 524, .external_lex_state = 13},
  [7377] = {.lex_state = 361, .external_lex_state = 3},
  [7378] = {.lex_state = 192, .external_lex_state = 29},
  [7379] = {.lex_state = 192, .external_lex_state = 2},
  [7380] = {.lex_state = 361, .external_lex_state = 14},
  [7381] = {.lex_state = 128, .external_lex_state = 2},
  [7382] = {.lex_state = 254, .external_lex_state = 8},
  [7383] = {.lex_state = 156, .external_lex_state = 3},
  [7384] = {.lex_state = 128, .external_lex_state = 2},
  [7385] = {.lex_state = 128, .external_lex_state = 8},
  [7386] = {.lex_state = 247, .external_lex_state = 3},
  [7387] = {.lex_state = 247, .external_lex_state = 3},
  [7388] = {.lex_state = 247, .external_lex_state = 3},
  [7389] = {.lex_state = 247, .external_lex_state = 3},
  [7390] = {.lex_state = 247, .external_lex_state = 3},
  [7391] = {.lex_state = 247, .external_lex_state = 3},
  [7392] = {.lex_state = 247, .external_lex_state = 3},
  [7393] = {.lex_state = 247, .external_lex_state = 3},
  [7394] = {.lex_state = 247, .external_lex_state = 3},
  [7395] = {.lex_state = 247, .external_lex_state = 3},
  [7396] = {.lex_state = 554, .external_lex_state = 16},
  [7397] = {.lex_state = 247, .external_lex_state = 3},
  [7398] = {.lex_state = 247, .external_lex_state = 3},
  [7399] = {.lex_state = 247, .external_lex_state = 3},
  [7400] = {.lex_state = 247, .external_lex_state = 3},
  [7401] = {.lex_state = 192, .external_lex_state = 2},
  [7402] = {.lex_state = 254, .external_lex_state = 11},
  [7403] = {.lex_state = 254, .external_lex_state = 11},
  [7404] = {.lex_state = 254, .external_lex_state = 11},
  [7405] = {.lex_state = 254, .external_lex_state = 11},
  [7406] = {.lex_state = 192, .external_lex_state = 2},
  [7407] = {.lex_state = 192, .external_lex_state = 2},
  [7408] = {.lex_state = 424, .external_lex_state = 3},
  [7409] = {.lex_state = 254, .external_lex_state = 11},
  [7410] = {.lex_state = 213},
  [7411] = {.lex_state = 424, .external_lex_state = 3},
  [7412] = {.lex_state = 424, .external_lex_state = 14},
  [7413] = {.lex_state = 424, .external_lex_state = 3},
  [7414] = {.lex_state = 421, .external_lex_state = 3},
  [7415] = {.lex_state = 421, .external_lex_state = 14},
  [7416] = {.lex_state = 192, .external_lex_state = 2},
  [7417] = {.lex_state = 424, .external_lex_state = 3},
  [7418] = {.lex_state = 421, .external_lex_state = 3},
  [7419] = {.lex_state = 192, .external_lex_state = 2},
  [7420] = {.lex_state = 192, .external_lex_state = 2},
  [7421] = {.lex_state = 192, .external_lex_state = 2},
  [7422] = {.lex_state = 192, .external_lex_state = 2},
  [7423] = {.lex_state = 192, .external_lex_state = 2},
  [7424] = {.lex_state = 192, .external_lex_state = 2},
  [7425] = {.lex_state = 192, .external_lex_state = 2},
  [7426] = {.lex_state = 192, .external_lex_state = 2},
  [7427] = {.lex_state = 192, .external_lex_state = 2},
  [7428] = {.lex_state = 192, .external_lex_state = 2},
  [7429] = {.lex_state = 192, .external_lex_state = 2},
  [7430] = {.lex_state = 424, .external_lex_state = 3},
  [7431] = {.lex_state = 524, .external_lex_state = 13},
  [7432] = {.lex_state = 424, .external_lex_state = 3},
  [7433] = {.lex_state = 192, .external_lex_state = 29},
  [7434] = {.lex_state = 192, .external_lex_state = 2},
  [7435] = {.lex_state = 421, .external_lex_state = 14},
  [7436] = {.lex_state = 192, .external_lex_state = 2},
  [7437] = {.lex_state = 192, .external_lex_state = 2},
  [7438] = {.lex_state = 192, .external_lex_state = 2},
  [7439] = {.lex_state = 192, .external_lex_state = 2},
  [7440] = {.lex_state = 528, .external_lex_state = 3},
  [7441] = {.lex_state = 528, .external_lex_state = 3},
  [7442] = {.lex_state = 213},
  [7443] = {.lex_state = 259, .external_lex_state = 3},
  [7444] = {.lex_state = 247, .external_lex_state = 3},
  [7445] = {.lex_state = 262, .external_lex_state = 14},
  [7446] = {.lex_state = 128},
  [7447] = {.lex_state = 247, .external_lex_state = 3},
  [7448] = {.lex_state = 424, .external_lex_state = 3},
  [7449] = {.lex_state = 424, .external_lex_state = 3},
  [7450] = {.lex_state = 424, .external_lex_state = 3},
  [7451] = {.lex_state = 424, .external_lex_state = 3},
  [7452] = {.lex_state = 424, .external_lex_state = 3},
  [7453] = {.lex_state = 554, .external_lex_state = 16},
  [7454] = {.lex_state = 424, .external_lex_state = 3},
  [7455] = {.lex_state = 424, .external_lex_state = 3},
  [7456] = {.lex_state = 424, .external_lex_state = 3},
  [7457] = {.lex_state = 424, .external_lex_state = 3},
  [7458] = {.lex_state = 424, .external_lex_state = 3},
  [7459] = {.lex_state = 424, .external_lex_state = 3},
  [7460] = {.lex_state = 424, .external_lex_state = 3},
  [7461] = {.lex_state = 424, .external_lex_state = 14},
  [7462] = {.lex_state = 192, .external_lex_state = 2},
  [7463] = {.lex_state = 192, .external_lex_state = 29},
  [7464] = {.lex_state = 421, .external_lex_state = 3},
  [7465] = {.lex_state = 528, .external_lex_state = 3},
  [7466] = {.lex_state = 528, .external_lex_state = 3},
  [7467] = {.lex_state = 528, .external_lex_state = 3},
  [7468] = {.lex_state = 528, .external_lex_state = 3},
  [7469] = {.lex_state = 528, .external_lex_state = 3},
  [7470] = {.lex_state = 554, .external_lex_state = 16},
  [7471] = {.lex_state = 528, .external_lex_state = 3},
  [7472] = {.lex_state = 528, .external_lex_state = 3},
  [7473] = {.lex_state = 528, .external_lex_state = 3},
  [7474] = {.lex_state = 528, .external_lex_state = 3},
  [7475] = {.lex_state = 528, .external_lex_state = 3},
  [7476] = {.lex_state = 528, .external_lex_state = 3},
  [7477] = {.lex_state = 528, .external_lex_state = 3},
  [7478] = {.lex_state = 192, .external_lex_state = 2},
  [7479] = {.lex_state = 511, .external_lex_state = 11},
  [7480] = {.lex_state = 511, .external_lex_state = 11},
  [7481] = {.lex_state = 511, .external_lex_state = 11},
  [7482] = {.lex_state = 511, .external_lex_state = 11},
  [7483] = {.lex_state = 192, .external_lex_state = 2},
  [7484] = {.lex_state = 192, .external_lex_state = 2},
  [7485] = {.lex_state = 361, .external_lex_state = 3},
  [7486] = {.lex_state = 213},
  [7487] = {.lex_state = 259, .external_lex_state = 3},
  [7488] = {.lex_state = 365, .external_lex_state = 14},
  [7489] = {.lex_state = 361, .external_lex_state = 3},
  [7490] = {.lex_state = 361, .external_lex_state = 3},
  [7491] = {.lex_state = 361, .external_lex_state = 14},
  [7492] = {.lex_state = 192, .external_lex_state = 2},
  [7493] = {.lex_state = 361, .external_lex_state = 3},
  [7494] = {.lex_state = 192, .external_lex_state = 2},
  [7495] = {.lex_state = 192, .external_lex_state = 2},
  [7496] = {.lex_state = 237},
  [7497] = {.lex_state = 192, .external_lex_state = 2},
  [7498] = {.lex_state = 358, .external_lex_state = 11},
  [7499] = {.lex_state = 361, .external_lex_state = 3},
  [7500] = {.lex_state = 361, .external_lex_state = 3},
  [7501] = {.lex_state = 361, .external_lex_state = 3},
  [7502] = {.lex_state = 371, .external_lex_state = 14},
  [7503] = {.lex_state = 361, .external_lex_state = 3},
  [7504] = {.lex_state = 192, .external_lex_state = 2},
  [7505] = {.lex_state = 192, .external_lex_state = 2},
  [7506] = {.lex_state = 192, .external_lex_state = 2},
  [7507] = {.lex_state = 192, .external_lex_state = 2},
  [7508] = {.lex_state = 192, .external_lex_state = 2},
  [7509] = {.lex_state = 192, .external_lex_state = 2},
  [7510] = {.lex_state = 192, .external_lex_state = 2},
  [7511] = {.lex_state = 192, .external_lex_state = 2},
  [7512] = {.lex_state = 192, .external_lex_state = 2},
  [7513] = {.lex_state = 192, .external_lex_state = 2},
  [7514] = {.lex_state = 192, .external_lex_state = 2},
  [7515] = {.lex_state = 192, .external_lex_state = 2},
  [7516] = {.lex_state = 192, .external_lex_state = 2},
  [7517] = {.lex_state = 237},
  [7518] = {.lex_state = 192, .external_lex_state = 2},
  [7519] = {.lex_state = 358, .external_lex_state = 11},
  [7520] = {.lex_state = 421, .external_lex_state = 3},
  [7521] = {.lex_state = 421, .external_lex_state = 3},
  [7522] = {.lex_state = 421, .external_lex_state = 3},
  [7523] = {.lex_state = 427, .external_lex_state = 14},
  [7524] = {.lex_state = 262, .external_lex_state = 3},
  [7525] = {.lex_state = 524, .external_lex_state = 13},
  [7526] = {.lex_state = 361, .external_lex_state = 3},
  [7527] = {.lex_state = 192, .external_lex_state = 29},
  [7528] = {.lex_state = 192, .external_lex_state = 2},
  [7529] = {.lex_state = 361, .external_lex_state = 14},
  [7530] = {.lex_state = 254, .external_lex_state = 8},
  [7531] = {.lex_state = 156, .external_lex_state = 3},
  [7532] = {.lex_state = 128, .external_lex_state = 2},
  [7533] = {.lex_state = 128, .external_lex_state = 8},
  [7534] = {.lex_state = 247, .external_lex_state = 3},
  [7535] = {.lex_state = 247, .external_lex_state = 3},
  [7536] = {.lex_state = 247, .external_lex_state = 3},
  [7537] = {.lex_state = 247, .external_lex_state = 3},
  [7538] = {.lex_state = 247, .external_lex_state = 3},
  [7539] = {.lex_state = 247, .external_lex_state = 3},
  [7540] = {.lex_state = 247, .external_lex_state = 3},
  [7541] = {.lex_state = 247, .external_lex_state = 3},
  [7542] = {.lex_state = 247, .external_lex_state = 3},
  [7543] = {.lex_state = 247, .external_lex_state = 3},
  [7544] = {.lex_state = 554, .external_lex_state = 16},
  [7545] = {.lex_state = 247, .external_lex_state = 3},
  [7546] = {.lex_state = 247, .external_lex_state = 3},
  [7547] = {.lex_state = 247, .external_lex_state = 3},
  [7548] = {.lex_state = 247, .external_lex_state = 3},
  [7549] = {.lex_state = 192, .external_lex_state = 2},
  [7550] = {.lex_state = 254, .external_lex_state = 11},
  [7551] = {.lex_state = 254, .external_lex_state = 11},
  [7552] = {.lex_state = 254, .external_lex_state = 11},
  [7553] = {.lex_state = 254, .external_lex_state = 11},
  [7554] = {.lex_state = 192, .external_lex_state = 2},
  [7555] = {.lex_state = 192, .external_lex_state = 2},
  [7556] = {.lex_state = 424, .external_lex_state = 3},
  [7557] = {.lex_state = 254, .external_lex_state = 11},
  [7558] = {.lex_state = 213},
  [7559] = {.lex_state = 424, .external_lex_state = 3},
  [7560] = {.lex_state = 424, .external_lex_state = 14},
  [7561] = {.lex_state = 424, .external_lex_state = 3},
  [7562] = {.lex_state = 421, .external_lex_state = 3},
  [7563] = {.lex_state = 421, .external_lex_state = 14},
  [7564] = {.lex_state = 192, .external_lex_state = 2},
  [7565] = {.lex_state = 424, .external_lex_state = 3},
  [7566] = {.lex_state = 421, .external_lex_state = 3},
  [7567] = {.lex_state = 192, .external_lex_state = 2},
  [7568] = {.lex_state = 192, .external_lex_state = 2},
  [7569] = {.lex_state = 192, .external_lex_state = 2},
  [7570] = {.lex_state = 192, .external_lex_state = 2},
  [7571] = {.lex_state = 192, .external_lex_state = 2},
  [7572] = {.lex_state = 192, .external_lex_state = 2},
  [7573] = {.lex_state = 192, .external_lex_state = 2},
  [7574] = {.lex_state = 192, .external_lex_state = 2},
  [7575] = {.lex_state = 192, .external_lex_state = 2},
  [7576] = {.lex_state = 192, .external_lex_state = 2},
  [7577] = {.lex_state = 192, .external_lex_state = 2},
  [7578] = {.lex_state = 424, .external_lex_state = 3},
  [7579] = {.lex_state = 524, .external_lex_state = 13},
  [7580] = {.lex_state = 424, .external_lex_state = 3},
  [7581] = {.lex_state = 192, .external_lex_state = 29},
  [7582] = {.lex_state = 192, .external_lex_state = 2},
  [7583] = {.lex_state = 421, .external_lex_state = 14},
  [7584] = {.lex_state = 192, .external_lex_state = 2},
  [7585] = {.lex_state = 192, .external_lex_state = 2},
  [7586] = {.lex_state = 192, .external_lex_state = 2},
  [7587] = {.lex_state = 192, .external_lex_state = 2},
  [7588] = {.lex_state = 528, .external_lex_state = 3},
  [7589] = {.lex_state = 528, .external_lex_state = 3},
  [7590] = {.lex_state = 213},
  [7591] = {.lex_state = 259, .external_lex_state = 3},
  [7592] = {.lex_state = 247, .external_lex_state = 3},
  [7593] = {.lex_state = 262, .external_lex_state = 14},
  [7594] = {.lex_state = 361, .external_lex_state = 3},
  [7595] = {.lex_state = 361, .external_lex_state = 3},
  [7596] = {.lex_state = 361, .external_lex_state = 3},
  [7597] = {.lex_state = 361, .external_lex_state = 3},
  [7598] = {.lex_state = 361, .external_lex_state = 3},
  [7599] = {.lex_state = 361, .external_lex_state = 3},
  [7600] = {.lex_state = 361, .external_lex_state = 3},
  [7601] = {.lex_state = 554, .external_lex_state = 16},
  [7602] = {.lex_state = 361, .external_lex_state = 3},
  [7603] = {.lex_state = 361, .external_lex_state = 3},
  [7604] = {.lex_state = 361, .external_lex_state = 3},
  [7605] = {.lex_state = 361, .external_lex_state = 3},
  [7606] = {.lex_state = 361, .external_lex_state = 3},
  [7607] = {.lex_state = 361, .external_lex_state = 3},
  [7608] = {.lex_state = 361, .external_lex_state = 3},
  [7609] = {.lex_state = 365, .external_lex_state = 14},
  [7610] = {.lex_state = 361, .external_lex_state = 3},
  [7611] = {.lex_state = 361, .external_lex_state = 3},
  [7612] = {.lex_state = 361, .external_lex_state = 3},
  [7613] = {.lex_state = 524, .external_lex_state = 21},
  [7614] = {.lex_state = 361, .external_lex_state = 3},
  [7615] = {.lex_state = 361, .external_lex_state = 3},
  [7616] = {.lex_state = 192, .external_lex_state = 2},
  [7617] = {.lex_state = 421, .external_lex_state = 3},
  [7618] = {.lex_state = 421, .external_lex_state = 3},
  [7619] = {.lex_state = 421, .external_lex_state = 3},
  [7620] = {.lex_state = 524, .external_lex_state = 21},
  [7621] = {.lex_state = 421, .external_lex_state = 3},
  [7622] = {.lex_state = 421, .external_lex_state = 3},
  [7623] = {.lex_state = 192, .external_lex_state = 29},
  [7624] = {.lex_state = 361, .external_lex_state = 3},
  [7625] = {.lex_state = 247, .external_lex_state = 3},
  [7626] = {.lex_state = 424, .external_lex_state = 3},
  [7627] = {.lex_state = 424, .external_lex_state = 3},
  [7628] = {.lex_state = 424, .external_lex_state = 3},
  [7629] = {.lex_state = 424, .external_lex_state = 3},
  [7630] = {.lex_state = 424, .external_lex_state = 3},
  [7631] = {.lex_state = 554, .external_lex_state = 16},
  [7632] = {.lex_state = 424, .external_lex_state = 3},
  [7633] = {.lex_state = 424, .external_lex_state = 3},
  [7634] = {.lex_state = 424, .external_lex_state = 3},
  [7635] = {.lex_state = 424, .external_lex_state = 3},
  [7636] = {.lex_state = 424, .external_lex_state = 3},
  [7637] = {.lex_state = 424, .external_lex_state = 3},
  [7638] = {.lex_state = 424, .external_lex_state = 3},
  [7639] = {.lex_state = 424, .external_lex_state = 14},
  [7640] = {.lex_state = 192, .external_lex_state = 2},
  [7641] = {.lex_state = 192, .external_lex_state = 29},
  [7642] = {.lex_state = 421, .external_lex_state = 3},
  [7643] = {.lex_state = 528, .external_lex_state = 3},
  [7644] = {.lex_state = 528, .external_lex_state = 3},
  [7645] = {.lex_state = 528, .external_lex_state = 3},
  [7646] = {.lex_state = 528, .external_lex_state = 3},
  [7647] = {.lex_state = 528, .external_lex_state = 3},
  [7648] = {.lex_state = 554, .external_lex_state = 16},
  [7649] = {.lex_state = 528, .external_lex_state = 3},
  [7650] = {.lex_state = 528, .external_lex_state = 3},
  [7651] = {.lex_state = 528, .external_lex_state = 3},
  [7652] = {.lex_state = 528, .external_lex_state = 3},
  [7653] = {.lex_state = 528, .external_lex_state = 3},
  [7654] = {.lex_state = 528, .external_lex_state = 3},
  [7655] = {.lex_state = 528, .external_lex_state = 3},
  [7656] = {.lex_state = 508, .external_lex_state = 25},
  [7657] = {.lex_state = 508, .external_lex_state = 25},
  [7658] = {.lex_state = 192, .external_lex_state = 2},
  [7659] = {.lex_state = 508, .external_lex_state = 25},
  [7660] = {.lex_state = 192, .external_lex_state = 2},
  [7661] = {.lex_state = 508, .external_lex_state = 25},
  [7662] = {.lex_state = 524, .external_lex_state = 13},
  [7663] = {.lex_state = 508, .external_lex_state = 25},
  [7664] = {.lex_state = 508, .external_lex_state = 25},
  [7665] = {.lex_state = 508, .external_lex_state = 25},
  [7666] = {.lex_state = 508, .external_lex_state = 25},
  [7667] = {.lex_state = 508, .external_lex_state = 25},
  [7668] = {.lex_state = 508, .external_lex_state = 25},
  [7669] = {.lex_state = 554, .external_lex_state = 16},
  [7670] = {.lex_state = 508, .external_lex_state = 25},
  [7671] = {.lex_state = 508, .external_lex_state = 25},
  [7672] = {.lex_state = 508, .external_lex_state = 25},
  [7673] = {.lex_state = 508, .external_lex_state = 25},
  [7674] = {.lex_state = 192, .external_lex_state = 2},
  [7675] = {.lex_state = 618, .external_lex_state = 26},
  [7676] = {.lex_state = 618, .external_lex_state = 26},
  [7677] = {.lex_state = 618, .external_lex_state = 26},
  [7678] = {.lex_state = 618, .external_lex_state = 26},
  [7679] = {.lex_state = 192, .external_lex_state = 2},
  [7680] = {.lex_state = 192, .external_lex_state = 2},
  [7681] = {.lex_state = 424, .external_lex_state = 25},
  [7682] = {.lex_state = 213},
  [7683] = {.lex_state = 424, .external_lex_state = 25},
  [7684] = {.lex_state = 424, .external_lex_state = 27},
  [7685] = {.lex_state = 424, .external_lex_state = 25},
  [7686] = {.lex_state = 192, .external_lex_state = 2},
  [7687] = {.lex_state = 424, .external_lex_state = 25},
  [7688] = {.lex_state = 192, .external_lex_state = 2},
  [7689] = {.lex_state = 424, .external_lex_state = 25},
  [7690] = {.lex_state = 524, .external_lex_state = 13},
  [7691] = {.lex_state = 424, .external_lex_state = 25},
  [7692] = {.lex_state = 508, .external_lex_state = 25},
  [7693] = {.lex_state = 508, .external_lex_state = 25},
  [7694] = {.lex_state = 508, .external_lex_state = 25},
  [7695] = {.lex_state = 631, .external_lex_state = 27},
  [7696] = {.lex_state = 508, .external_lex_state = 25},
  [7697] = {.lex_state = 508, .external_lex_state = 25},
  [7698] = {.lex_state = 508, .external_lex_state = 25},
  [7699] = {.lex_state = 524, .external_lex_state = 21},
  [7700] = {.lex_state = 508, .external_lex_state = 25},
  [7701] = {.lex_state = 508, .external_lex_state = 25},
  [7702] = {.lex_state = 192, .external_lex_state = 2},
  [7703] = {.lex_state = 421, .external_lex_state = 25},
  [7704] = {.lex_state = 421, .external_lex_state = 25},
  [7705] = {.lex_state = 421, .external_lex_state = 25},
  [7706] = {.lex_state = 421, .external_lex_state = 25},
  [7707] = {.lex_state = 421, .external_lex_state = 25},
  [7708] = {.lex_state = 421, .external_lex_state = 25},
  [7709] = {.lex_state = 421, .external_lex_state = 25},
  [7710] = {.lex_state = 554, .external_lex_state = 16},
  [7711] = {.lex_state = 421, .external_lex_state = 25},
  [7712] = {.lex_state = 421, .external_lex_state = 25},
  [7713] = {.lex_state = 421, .external_lex_state = 25},
  [7714] = {.lex_state = 421, .external_lex_state = 25},
  [7715] = {.lex_state = 421, .external_lex_state = 25},
  [7716] = {.lex_state = 524, .external_lex_state = 21},
  [7717] = {.lex_state = 421, .external_lex_state = 25},
  [7718] = {.lex_state = 421, .external_lex_state = 25},
  [7719] = {.lex_state = 421, .external_lex_state = 25},
  [7720] = {.lex_state = 421, .external_lex_state = 25},
  [7721] = {.lex_state = 421, .external_lex_state = 25},
  [7722] = {.lex_state = 421, .external_lex_state = 27},
  [7723] = {.lex_state = 192, .external_lex_state = 29},
  [7724] = {.lex_state = 508, .external_lex_state = 25},
  [7725] = {.lex_state = 156, .external_lex_state = 3},
  [7726] = {.lex_state = 361, .external_lex_state = 3},
  [7727] = {.lex_state = 361, .external_lex_state = 3},
  [7728] = {.lex_state = 361, .external_lex_state = 3},
  [7729] = {.lex_state = 361, .external_lex_state = 3},
  [7730] = {.lex_state = 361, .external_lex_state = 3},
  [7731] = {.lex_state = 361, .external_lex_state = 3},
  [7732] = {.lex_state = 361, .external_lex_state = 3},
  [7733] = {.lex_state = 554, .external_lex_state = 16},
  [7734] = {.lex_state = 361, .external_lex_state = 3},
  [7735] = {.lex_state = 361, .external_lex_state = 3},
  [7736] = {.lex_state = 361, .external_lex_state = 3},
  [7737] = {.lex_state = 361, .external_lex_state = 3},
  [7738] = {.lex_state = 361, .external_lex_state = 3},
  [7739] = {.lex_state = 361, .external_lex_state = 3},
  [7740] = {.lex_state = 361, .external_lex_state = 3},
  [7741] = {.lex_state = 365, .external_lex_state = 14},
  [7742] = {.lex_state = 361, .external_lex_state = 3},
  [7743] = {.lex_state = 361, .external_lex_state = 3},
  [7744] = {.lex_state = 361, .external_lex_state = 3},
  [7745] = {.lex_state = 524, .external_lex_state = 21},
  [7746] = {.lex_state = 361, .external_lex_state = 3},
  [7747] = {.lex_state = 361, .external_lex_state = 3},
  [7748] = {.lex_state = 192, .external_lex_state = 2},
  [7749] = {.lex_state = 192, .external_lex_state = 29},
  [7750] = {.lex_state = 361, .external_lex_state = 3},
  [7751] = {.lex_state = 247, .external_lex_state = 3},
  [7752] = {.lex_state = 156, .external_lex_state = 3},
  [7753] = {.lex_state = 528, .external_lex_state = 3},
  [7754] = {.lex_state = 528, .external_lex_state = 3},
  [7755] = {.lex_state = 528, .external_lex_state = 3},
  [7756] = {.lex_state = 528, .external_lex_state = 3},
  [7757] = {.lex_state = 528, .external_lex_state = 3},
  [7758] = {.lex_state = 554, .external_lex_state = 16},
  [7759] = {.lex_state = 528, .external_lex_state = 3},
  [7760] = {.lex_state = 528, .external_lex_state = 3},
  [7761] = {.lex_state = 528, .external_lex_state = 3},
  [7762] = {.lex_state = 528, .external_lex_state = 3},
  [7763] = {.lex_state = 528, .external_lex_state = 3},
  [7764] = {.lex_state = 528, .external_lex_state = 3},
  [7765] = {.lex_state = 528, .external_lex_state = 3},
  [7766] = {.lex_state = 192, .external_lex_state = 2},
  [7767] = {.lex_state = 192, .external_lex_state = 2},
  [7768] = {.lex_state = 192, .external_lex_state = 2},
  [7769] = {.lex_state = 361, .external_lex_state = 3},
  [7770] = {.lex_state = 213},
  [7771] = {.lex_state = 259, .external_lex_state = 3},
  [7772] = {.lex_state = 361, .external_lex_state = 3},
  [7773] = {.lex_state = 192, .external_lex_state = 2},
  [7774] = {.lex_state = 361, .external_lex_state = 3},
  [7775] = {.lex_state = 192, .external_lex_state = 2},
  [7776] = {.lex_state = 361, .external_lex_state = 3},
  [7777] = {.lex_state = 524, .external_lex_state = 13},
  [7778] = {.lex_state = 361, .external_lex_state = 3},
  [7779] = {.lex_state = 254, .external_lex_state = 8},
  [7780] = {.lex_state = 192, .external_lex_state = 2},
  [7781] = {.lex_state = 218, .external_lex_state = 11},
  [7782] = {.lex_state = 218, .external_lex_state = 11},
  [7783] = {.lex_state = 218, .external_lex_state = 11},
  [7784] = {.lex_state = 218, .external_lex_state = 11},
  [7785] = {.lex_state = 192, .external_lex_state = 2},
  [7786] = {.lex_state = 192, .external_lex_state = 2},
  [7787] = {.lex_state = 225, .external_lex_state = 7},
  [7788] = {.lex_state = 128},
  [7789] = {.lex_state = 128, .external_lex_state = 8},
  [7790] = {.lex_state = 128, .external_lex_state = 8},
  [7791] = {.lex_state = 128},
  [7792] = {.lex_state = 247, .external_lex_state = 3},
  [7793] = {.lex_state = 254, .external_lex_state = 11},
  [7794] = {.lex_state = 213},
  [7795] = {.lex_state = 259, .external_lex_state = 3},
  [7796] = {.lex_state = 262, .external_lex_state = 14},
  [7797] = {.lex_state = 128, .external_lex_state = 2},
  [7798] = {.lex_state = 254, .external_lex_state = 8},
  [7799] = {.lex_state = 528, .external_lex_state = 3},
  [7800] = {.lex_state = 528, .external_lex_state = 3},
  [7801] = {.lex_state = 528, .external_lex_state = 3},
  [7802] = {.lex_state = 528, .external_lex_state = 3},
  [7803] = {.lex_state = 528, .external_lex_state = 3},
  [7804] = {.lex_state = 554, .external_lex_state = 16},
  [7805] = {.lex_state = 528, .external_lex_state = 3},
  [7806] = {.lex_state = 528, .external_lex_state = 3},
  [7807] = {.lex_state = 528, .external_lex_state = 3},
  [7808] = {.lex_state = 528, .external_lex_state = 3},
  [7809] = {.lex_state = 192, .external_lex_state = 2},
  [7810] = {.lex_state = 254, .external_lex_state = 11},
  [7811] = {.lex_state = 254, .external_lex_state = 11},
  [7812] = {.lex_state = 254, .external_lex_state = 11},
  [7813] = {.lex_state = 254, .external_lex_state = 11},
  [7814] = {.lex_state = 192, .external_lex_state = 2},
  [7815] = {.lex_state = 192, .external_lex_state = 2},
  [7816] = {.lex_state = 424, .external_lex_state = 3},
  [7817] = {.lex_state = 254, .external_lex_state = 11},
  [7818] = {.lex_state = 213},
  [7819] = {.lex_state = 424, .external_lex_state = 3},
  [7820] = {.lex_state = 424, .external_lex_state = 14},
  [7821] = {.lex_state = 424, .external_lex_state = 3},
  [7822] = {.lex_state = 192, .external_lex_state = 2},
  [7823] = {.lex_state = 424, .external_lex_state = 3},
  [7824] = {.lex_state = 192, .external_lex_state = 2},
  [7825] = {.lex_state = 424, .external_lex_state = 3},
  [7826] = {.lex_state = 524, .external_lex_state = 13},
  [7827] = {.lex_state = 424, .external_lex_state = 3},
  [7828] = {.lex_state = 192, .external_lex_state = 2},
  [7829] = {.lex_state = 528, .external_lex_state = 3},
  [7830] = {.lex_state = 528, .external_lex_state = 3},
  [7831] = {.lex_state = 528, .external_lex_state = 3},
  [7832] = {.lex_state = 365, .external_lex_state = 14},
  [7833] = {.lex_state = 361, .external_lex_state = 3},
  [7834] = {.lex_state = 361, .external_lex_state = 3},
  [7835] = {.lex_state = 361, .external_lex_state = 3},
  [7836] = {.lex_state = 361, .external_lex_state = 3},
  [7837] = {.lex_state = 361, .external_lex_state = 3},
  [7838] = {.lex_state = 361, .external_lex_state = 3},
  [7839] = {.lex_state = 361, .external_lex_state = 3},
  [7840] = {.lex_state = 554, .external_lex_state = 16},
  [7841] = {.lex_state = 361, .external_lex_state = 3},
  [7842] = {.lex_state = 361, .external_lex_state = 3},
  [7843] = {.lex_state = 361, .external_lex_state = 3},
  [7844] = {.lex_state = 361, .external_lex_state = 3},
  [7845] = {.lex_state = 361, .external_lex_state = 3},
  [7846] = {.lex_state = 361, .external_lex_state = 3},
  [7847] = {.lex_state = 361, .external_lex_state = 3},
  [7848] = {.lex_state = 365, .external_lex_state = 14},
  [7849] = {.lex_state = 361, .external_lex_state = 3},
  [7850] = {.lex_state = 361, .external_lex_state = 3},
  [7851] = {.lex_state = 361, .external_lex_state = 3},
  [7852] = {.lex_state = 524, .external_lex_state = 21},
  [7853] = {.lex_state = 361, .external_lex_state = 3},
  [7854] = {.lex_state = 361, .external_lex_state = 3},
  [7855] = {.lex_state = 192, .external_lex_state = 2},
  [7856] = {.lex_state = 421, .external_lex_state = 3},
  [7857] = {.lex_state = 421, .external_lex_state = 3},
  [7858] = {.lex_state = 421, .external_lex_state = 3},
  [7859] = {.lex_state = 524, .external_lex_state = 21},
  [7860] = {.lex_state = 421, .external_lex_state = 3},
  [7861] = {.lex_state = 421, .external_lex_state = 3},
  [7862] = {.lex_state = 192, .external_lex_state = 29},
  [7863] = {.lex_state = 361, .external_lex_state = 3},
  [7864] = {.lex_state = 361, .external_lex_state = 3},
  [7865] = {.lex_state = 361, .external_lex_state = 3},
  [7866] = {.lex_state = 361, .external_lex_state = 3},
  [7867] = {.lex_state = 361, .external_lex_state = 3},
  [7868] = {.lex_state = 361, .external_lex_state = 3},
  [7869] = {.lex_state = 361, .external_lex_state = 3},
  [7870] = {.lex_state = 361, .external_lex_state = 3},
  [7871] = {.lex_state = 554, .external_lex_state = 16},
  [7872] = {.lex_state = 361, .external_lex_state = 3},
  [7873] = {.lex_state = 361, .external_lex_state = 3},
  [7874] = {.lex_state = 361, .external_lex_state = 3},
  [7875] = {.lex_state = 361, .external_lex_state = 3},
  [7876] = {.lex_state = 361, .external_lex_state = 3},
  [7877] = {.lex_state = 524, .external_lex_state = 21},
  [7878] = {.lex_state = 361, .external_lex_state = 3},
  [7879] = {.lex_state = 361, .external_lex_state = 3},
  [7880] = {.lex_state = 361, .external_lex_state = 3},
  [7881] = {.lex_state = 361, .external_lex_state = 3},
  [7882] = {.lex_state = 361, .external_lex_state = 3},
  [7883] = {.lex_state = 350, .external_lex_state = 23},
  [7884] = {.lex_state = 356, .external_lex_state = 13},
  [7885] = {.lex_state = 350, .external_lex_state = 23},
  [7886] = {.lex_state = 350, .external_lex_state = 23},
  [7887] = {.lex_state = 416, .external_lex_state = 28},
  [7888] = {.lex_state = 343, .external_lex_state = 8},
  [7889] = {.lex_state = 235, .external_lex_state = 19},
  [7890] = {.lex_state = 235},
  [7891] = {.lex_state = 192, .external_lex_state = 2},
  [7892] = {.lex_state = 511, .external_lex_state = 11},
  [7893] = {.lex_state = 511, .external_lex_state = 11},
  [7894] = {.lex_state = 511, .external_lex_state = 11},
  [7895] = {.lex_state = 511, .external_lex_state = 11},
  [7896] = {.lex_state = 192, .external_lex_state = 2},
  [7897] = {.lex_state = 192, .external_lex_state = 2},
  [7898] = {.lex_state = 508, .external_lex_state = 3},
  [7899] = {.lex_state = 213},
  [7900] = {.lex_state = 424, .external_lex_state = 3},
  [7901] = {.lex_state = 631, .external_lex_state = 14},
  [7902] = {.lex_state = 508, .external_lex_state = 3},
  [7903] = {.lex_state = 508, .external_lex_state = 3},
  [7904] = {.lex_state = 634, .external_lex_state = 14},
  [7905] = {.lex_state = 192, .external_lex_state = 2},
  [7906] = {.lex_state = 508, .external_lex_state = 3},
  [7907] = {.lex_state = 508, .external_lex_state = 3},
  [7908] = {.lex_state = 192, .external_lex_state = 2},
  [7909] = {.lex_state = 192, .external_lex_state = 2},
  [7910] = {.lex_state = 237},
  [7911] = {.lex_state = 192, .external_lex_state = 2},
  [7912] = {.lex_state = 358, .external_lex_state = 11},
  [7913] = {.lex_state = 508, .external_lex_state = 3},
  [7914] = {.lex_state = 508, .external_lex_state = 3},
  [7915] = {.lex_state = 508, .external_lex_state = 3},
  [7916] = {.lex_state = 508, .external_lex_state = 14},
  [7917] = {.lex_state = 343, .external_lex_state = 8},
  [7918] = {.lex_state = 209, .external_lex_state = 19},
  [7919] = {.lex_state = 209},
  [7920] = {.lex_state = 508, .external_lex_state = 3},
  [7921] = {.lex_state = 192, .external_lex_state = 2},
  [7922] = {.lex_state = 192, .external_lex_state = 2},
  [7923] = {.lex_state = 192, .external_lex_state = 2},
  [7924] = {.lex_state = 192, .external_lex_state = 2},
  [7925] = {.lex_state = 192, .external_lex_state = 2},
  [7926] = {.lex_state = 192, .external_lex_state = 2},
  [7927] = {.lex_state = 192, .external_lex_state = 2},
  [7928] = {.lex_state = 192, .external_lex_state = 2},
  [7929] = {.lex_state = 192, .external_lex_state = 2},
  [7930] = {.lex_state = 192, .external_lex_state = 2},
  [7931] = {.lex_state = 192, .external_lex_state = 2},
  [7932] = {.lex_state = 343, .external_lex_state = 8},
  [7933] = {.lex_state = 177, .external_lex_state = 17},
  [7934] = {.lex_state = 343, .external_lex_state = 8},
  [7935] = {.lex_state = 524, .external_lex_state = 13},
  [7936] = {.lex_state = 678, .external_lex_state = 8},
  [7937] = {.lex_state = 192, .external_lex_state = 29},
  [7938] = {.lex_state = 192, .external_lex_state = 2},
  [7939] = {.lex_state = 634, .external_lex_state = 14},
  [7940] = {.lex_state = 128},
  [7941] = {.lex_state = 128},
  [7942] = {.lex_state = 192, .external_lex_state = 2},
  [7943] = {.lex_state = 421, .external_lex_state = 3},
  [7944] = {.lex_state = 421, .external_lex_state = 3},
  [7945] = {.lex_state = 421, .external_lex_state = 3},
  [7946] = {.lex_state = 421, .external_lex_state = 3},
  [7947] = {.lex_state = 421, .external_lex_state = 3},
  [7948] = {.lex_state = 421, .external_lex_state = 3},
  [7949] = {.lex_state = 421, .external_lex_state = 3},
  [7950] = {.lex_state = 554, .external_lex_state = 16},
  [7951] = {.lex_state = 421, .external_lex_state = 3},
  [7952] = {.lex_state = 421, .external_lex_state = 3},
  [7953] = {.lex_state = 421, .external_lex_state = 3},
  [7954] = {.lex_state = 421, .external_lex_state = 3},
  [7955] = {.lex_state = 421, .external_lex_state = 3},
  [7956] = {.lex_state = 524, .external_lex_state = 21},
  [7957] = {.lex_state = 421, .external_lex_state = 3},
  [7958] = {.lex_state = 421, .external_lex_state = 3},
  [7959] = {.lex_state = 421, .external_lex_state = 3},
  [7960] = {.lex_state = 421, .external_lex_state = 3},
  [7961] = {.lex_state = 421, .external_lex_state = 3},
  [7962] = {.lex_state = 421, .external_lex_state = 14},
  [7963] = {.lex_state = 528, .external_lex_state = 3},
  [7964] = {.lex_state = 192, .external_lex_state = 29},
  [7965] = {.lex_state = 528, .external_lex_state = 3},
  [7966] = {.lex_state = 361, .external_lex_state = 3},
  [7967] = {.lex_state = 361, .external_lex_state = 3},
  [7968] = {.lex_state = 361, .external_lex_state = 3},
  [7969] = {.lex_state = 361, .external_lex_state = 3},
  [7970] = {.lex_state = 192, .external_lex_state = 2},
  [7971] = {.lex_state = 192, .external_lex_state = 2},
  [7972] = {.lex_state = 192, .external_lex_state = 2},
  [7973] = {.lex_state = 192, .external_lex_state = 2},
  [7974] = {.lex_state = 192, .external_lex_state = 2},
  [7975] = {.lex_state = 192, .external_lex_state = 2},
  [7976] = {.lex_state = 192, .external_lex_state = 2},
  [7977] = {.lex_state = 192, .external_lex_state = 2},
  [7978] = {.lex_state = 192, .external_lex_state = 2},
  [7979] = {.lex_state = 192, .external_lex_state = 2},
  [7980] = {.lex_state = 192, .external_lex_state = 29},
  [7981] = {.lex_state = 192, .external_lex_state = 2},
  [7982] = {.lex_state = 365, .external_lex_state = 14},
  [7983] = {.lex_state = 361, .external_lex_state = 3},
  [7984] = {.lex_state = 361, .external_lex_state = 3},
  [7985] = {.lex_state = 361, .external_lex_state = 3},
  [7986] = {.lex_state = 192, .external_lex_state = 2},
  [7987] = {.lex_state = 361, .external_lex_state = 3},
  [7988] = {.lex_state = 192, .external_lex_state = 2},
  [7989] = {.lex_state = 361, .external_lex_state = 3},
  [7990] = {.lex_state = 524, .external_lex_state = 13},
  [7991] = {.lex_state = 361, .external_lex_state = 3},
  [7992] = {.lex_state = 361, .external_lex_state = 3},
  [7993] = {.lex_state = 361, .external_lex_state = 3},
  [7994] = {.lex_state = 361, .external_lex_state = 3},
  [7995] = {.lex_state = 361, .external_lex_state = 3},
  [7996] = {.lex_state = 361, .external_lex_state = 3},
  [7997] = {.lex_state = 361, .external_lex_state = 3},
  [7998] = {.lex_state = 554, .external_lex_state = 16},
  [7999] = {.lex_state = 361, .external_lex_state = 3},
  [8000] = {.lex_state = 361, .external_lex_state = 3},
  [8001] = {.lex_state = 361, .external_lex_state = 3},
  [8002] = {.lex_state = 361, .external_lex_state = 3},
  [8003] = {.lex_state = 421, .external_lex_state = 3},
  [8004] = {.lex_state = 421, .external_lex_state = 3},
  [8005] = {.lex_state = 192, .external_lex_state = 2},
  [8006] = {.lex_state = 421, .external_lex_state = 3},
  [8007] = {.lex_state = 192, .external_lex_state = 2},
  [8008] = {.lex_state = 421, .external_lex_state = 3},
  [8009] = {.lex_state = 524, .external_lex_state = 13},
  [8010] = {.lex_state = 421, .external_lex_state = 3},
  [8011] = {.lex_state = 262, .external_lex_state = 3},
  [8012] = {.lex_state = 524, .external_lex_state = 21},
  [8013] = {.lex_state = 262, .external_lex_state = 3},
  [8014] = {.lex_state = 361, .external_lex_state = 3},
  [8015] = {.lex_state = 361, .external_lex_state = 3},
  [8016] = {.lex_state = 361, .external_lex_state = 3},
  [8017] = {.lex_state = 361, .external_lex_state = 3},
  [8018] = {.lex_state = 361, .external_lex_state = 14},
  [8019] = {.lex_state = 254, .external_lex_state = 8},
  [8020] = {.lex_state = 128, .external_lex_state = 2},
  [8021] = {.lex_state = 192, .external_lex_state = 2},
  [8022] = {.lex_state = 424, .external_lex_state = 3},
  [8023] = {.lex_state = 424, .external_lex_state = 3},
  [8024] = {.lex_state = 192, .external_lex_state = 2},
  [8025] = {.lex_state = 192, .external_lex_state = 2},
  [8026] = {.lex_state = 192, .external_lex_state = 2},
  [8027] = {.lex_state = 192, .external_lex_state = 2},
  [8028] = {.lex_state = 192, .external_lex_state = 2},
  [8029] = {.lex_state = 192, .external_lex_state = 2},
  [8030] = {.lex_state = 192, .external_lex_state = 2},
  [8031] = {.lex_state = 192, .external_lex_state = 2},
  [8032] = {.lex_state = 192, .external_lex_state = 2},
  [8033] = {.lex_state = 192, .external_lex_state = 2},
  [8034] = {.lex_state = 192, .external_lex_state = 29},
  [8035] = {.lex_state = 192, .external_lex_state = 2},
  [8036] = {.lex_state = 424, .external_lex_state = 14},
  [8037] = {.lex_state = 424, .external_lex_state = 3},
  [8038] = {.lex_state = 424, .external_lex_state = 3},
  [8039] = {.lex_state = 421, .external_lex_state = 3},
  [8040] = {.lex_state = 421, .external_lex_state = 3},
  [8041] = {.lex_state = 421, .external_lex_state = 3},
  [8042] = {.lex_state = 421, .external_lex_state = 3},
  [8043] = {.lex_state = 421, .external_lex_state = 3},
  [8044] = {.lex_state = 554, .external_lex_state = 16},
  [8045] = {.lex_state = 421, .external_lex_state = 3},
  [8046] = {.lex_state = 421, .external_lex_state = 3},
  [8047] = {.lex_state = 421, .external_lex_state = 3},
  [8048] = {.lex_state = 421, .external_lex_state = 3},
  [8049] = {.lex_state = 424, .external_lex_state = 3},
  [8050] = {.lex_state = 524, .external_lex_state = 21},
  [8051] = {.lex_state = 424, .external_lex_state = 3},
  [8052] = {.lex_state = 424, .external_lex_state = 3},
  [8053] = {.lex_state = 421, .external_lex_state = 3},
  [8054] = {.lex_state = 421, .external_lex_state = 3},
  [8055] = {.lex_state = 421, .external_lex_state = 3},
  [8056] = {.lex_state = 421, .external_lex_state = 14},
  [8057] = {.lex_state = 528, .external_lex_state = 3},
  [8058] = {.lex_state = 528, .external_lex_state = 3},
  [8059] = {.lex_state = 528, .external_lex_state = 3},
  [8060] = {.lex_state = 192, .external_lex_state = 2},
  [8061] = {.lex_state = 192, .external_lex_state = 2},
  [8062] = {.lex_state = 192, .external_lex_state = 2},
  [8063] = {.lex_state = 192, .external_lex_state = 2},
  [8064] = {.lex_state = 192, .external_lex_state = 2},
  [8065] = {.lex_state = 192, .external_lex_state = 2},
  [8066] = {.lex_state = 192, .external_lex_state = 2},
  [8067] = {.lex_state = 192, .external_lex_state = 2},
  [8068] = {.lex_state = 192, .external_lex_state = 2},
  [8069] = {.lex_state = 192, .external_lex_state = 2},
  [8070] = {.lex_state = 192, .external_lex_state = 29},
  [8071] = {.lex_state = 528, .external_lex_state = 3},
  [8072] = {.lex_state = 192, .external_lex_state = 29},
  [8073] = {.lex_state = 192, .external_lex_state = 2},
  [8074] = {.lex_state = 361, .external_lex_state = 3},
  [8075] = {.lex_state = 361, .external_lex_state = 3},
  [8076] = {.lex_state = 361, .external_lex_state = 3},
  [8077] = {.lex_state = 361, .external_lex_state = 3},
  [8078] = {.lex_state = 192, .external_lex_state = 2},
  [8079] = {.lex_state = 192, .external_lex_state = 2},
  [8080] = {.lex_state = 192, .external_lex_state = 2},
  [8081] = {.lex_state = 192, .external_lex_state = 2},
  [8082] = {.lex_state = 192, .external_lex_state = 2},
  [8083] = {.lex_state = 192, .external_lex_state = 2},
  [8084] = {.lex_state = 192, .external_lex_state = 2},
  [8085] = {.lex_state = 192, .external_lex_state = 2},
  [8086] = {.lex_state = 192, .external_lex_state = 2},
  [8087] = {.lex_state = 192, .external_lex_state = 2},
  [8088] = {.lex_state = 192, .external_lex_state = 29},
  [8089] = {.lex_state = 192, .external_lex_state = 2},
  [8090] = {.lex_state = 365, .external_lex_state = 14},
  [8091] = {.lex_state = 361, .external_lex_state = 3},
  [8092] = {.lex_state = 361, .external_lex_state = 3},
  [8093] = {.lex_state = 361, .external_lex_state = 3},
  [8094] = {.lex_state = 192, .external_lex_state = 2},
  [8095] = {.lex_state = 361, .external_lex_state = 3},
  [8096] = {.lex_state = 192, .external_lex_state = 2},
  [8097] = {.lex_state = 361, .external_lex_state = 3},
  [8098] = {.lex_state = 524, .external_lex_state = 13},
  [8099] = {.lex_state = 361, .external_lex_state = 3},
  [8100] = {.lex_state = 361, .external_lex_state = 3},
  [8101] = {.lex_state = 361, .external_lex_state = 3},
  [8102] = {.lex_state = 361, .external_lex_state = 3},
  [8103] = {.lex_state = 361, .external_lex_state = 3},
  [8104] = {.lex_state = 361, .external_lex_state = 3},
  [8105] = {.lex_state = 361, .external_lex_state = 3},
  [8106] = {.lex_state = 554, .external_lex_state = 16},
  [8107] = {.lex_state = 361, .external_lex_state = 3},
  [8108] = {.lex_state = 361, .external_lex_state = 3},
  [8109] = {.lex_state = 361, .external_lex_state = 3},
  [8110] = {.lex_state = 361, .external_lex_state = 3},
  [8111] = {.lex_state = 421, .external_lex_state = 3},
  [8112] = {.lex_state = 421, .external_lex_state = 3},
  [8113] = {.lex_state = 192, .external_lex_state = 2},
  [8114] = {.lex_state = 421, .external_lex_state = 3},
  [8115] = {.lex_state = 192, .external_lex_state = 2},
  [8116] = {.lex_state = 421, .external_lex_state = 3},
  [8117] = {.lex_state = 524, .external_lex_state = 13},
  [8118] = {.lex_state = 421, .external_lex_state = 3},
  [8119] = {.lex_state = 262, .external_lex_state = 3},
  [8120] = {.lex_state = 524, .external_lex_state = 21},
  [8121] = {.lex_state = 262, .external_lex_state = 3},
  [8122] = {.lex_state = 361, .external_lex_state = 3},
  [8123] = {.lex_state = 361, .external_lex_state = 3},
  [8124] = {.lex_state = 361, .external_lex_state = 3},
  [8125] = {.lex_state = 361, .external_lex_state = 3},
  [8126] = {.lex_state = 361, .external_lex_state = 14},
  [8127] = {.lex_state = 254, .external_lex_state = 8},
  [8128] = {.lex_state = 128, .external_lex_state = 2},
  [8129] = {.lex_state = 192, .external_lex_state = 2},
  [8130] = {.lex_state = 424, .external_lex_state = 3},
  [8131] = {.lex_state = 424, .external_lex_state = 3},
  [8132] = {.lex_state = 192, .external_lex_state = 2},
  [8133] = {.lex_state = 192, .external_lex_state = 2},
  [8134] = {.lex_state = 192, .external_lex_state = 2},
  [8135] = {.lex_state = 192, .external_lex_state = 2},
  [8136] = {.lex_state = 192, .external_lex_state = 2},
  [8137] = {.lex_state = 192, .external_lex_state = 2},
  [8138] = {.lex_state = 192, .external_lex_state = 2},
  [8139] = {.lex_state = 192, .external_lex_state = 2},
  [8140] = {.lex_state = 192, .external_lex_state = 2},
  [8141] = {.lex_state = 192, .external_lex_state = 2},
  [8142] = {.lex_state = 192, .external_lex_state = 29},
  [8143] = {.lex_state = 192, .external_lex_state = 2},
  [8144] = {.lex_state = 424, .external_lex_state = 14},
  [8145] = {.lex_state = 424, .external_lex_state = 3},
  [8146] = {.lex_state = 424, .external_lex_state = 3},
  [8147] = {.lex_state = 421, .external_lex_state = 3},
  [8148] = {.lex_state = 421, .external_lex_state = 3},
  [8149] = {.lex_state = 421, .external_lex_state = 3},
  [8150] = {.lex_state = 421, .external_lex_state = 3},
  [8151] = {.lex_state = 421, .external_lex_state = 3},
  [8152] = {.lex_state = 554, .external_lex_state = 16},
  [8153] = {.lex_state = 421, .external_lex_state = 3},
  [8154] = {.lex_state = 421, .external_lex_state = 3},
  [8155] = {.lex_state = 421, .external_lex_state = 3},
  [8156] = {.lex_state = 421, .external_lex_state = 3},
  [8157] = {.lex_state = 424, .external_lex_state = 3},
  [8158] = {.lex_state = 524, .external_lex_state = 21},
  [8159] = {.lex_state = 424, .external_lex_state = 3},
  [8160] = {.lex_state = 424, .external_lex_state = 3},
  [8161] = {.lex_state = 421, .external_lex_state = 3},
  [8162] = {.lex_state = 421, .external_lex_state = 3},
  [8163] = {.lex_state = 421, .external_lex_state = 3},
  [8164] = {.lex_state = 421, .external_lex_state = 14},
  [8165] = {.lex_state = 528, .external_lex_state = 3},
  [8166] = {.lex_state = 528, .external_lex_state = 3},
  [8167] = {.lex_state = 528, .external_lex_state = 3},
  [8168] = {.lex_state = 192, .external_lex_state = 2},
  [8169] = {.lex_state = 192, .external_lex_state = 2},
  [8170] = {.lex_state = 192, .external_lex_state = 2},
  [8171] = {.lex_state = 192, .external_lex_state = 2},
  [8172] = {.lex_state = 192, .external_lex_state = 2},
  [8173] = {.lex_state = 192, .external_lex_state = 2},
  [8174] = {.lex_state = 192, .external_lex_state = 2},
  [8175] = {.lex_state = 192, .external_lex_state = 2},
  [8176] = {.lex_state = 192, .external_lex_state = 2},
  [8177] = {.lex_state = 192, .external_lex_state = 2},
  [8178] = {.lex_state = 192, .external_lex_state = 29},
  [8179] = {.lex_state = 528, .external_lex_state = 3},
  [8180] = {.lex_state = 192, .external_lex_state = 29},
  [8181] = {.lex_state = 192, .external_lex_state = 2},
  [8182] = {.lex_state = 156, .external_lex_state = 3},
  [8183] = {.lex_state = 247, .external_lex_state = 3},
  [8184] = {.lex_state = 424, .external_lex_state = 3},
  [8185] = {.lex_state = 424, .external_lex_state = 3},
  [8186] = {.lex_state = 424, .external_lex_state = 3},
  [8187] = {.lex_state = 424, .external_lex_state = 3},
  [8188] = {.lex_state = 424, .external_lex_state = 3},
  [8189] = {.lex_state = 554, .external_lex_state = 16},
  [8190] = {.lex_state = 424, .external_lex_state = 3},
  [8191] = {.lex_state = 424, .external_lex_state = 3},
  [8192] = {.lex_state = 424, .external_lex_state = 3},
  [8193] = {.lex_state = 424, .external_lex_state = 3},
  [8194] = {.lex_state = 424, .external_lex_state = 3},
  [8195] = {.lex_state = 424, .external_lex_state = 3},
  [8196] = {.lex_state = 424, .external_lex_state = 3},
  [8197] = {.lex_state = 424, .external_lex_state = 14},
  [8198] = {.lex_state = 192, .external_lex_state = 2},
  [8199] = {.lex_state = 192, .external_lex_state = 29},
  [8200] = {.lex_state = 421, .external_lex_state = 3},
  [8201] = {.lex_state = 528, .external_lex_state = 3},
  [8202] = {.lex_state = 528, .external_lex_state = 3},
  [8203] = {.lex_state = 528, .external_lex_state = 3},
  [8204] = {.lex_state = 528, .external_lex_state = 3},
  [8205] = {.lex_state = 528, .external_lex_state = 3},
  [8206] = {.lex_state = 554, .external_lex_state = 16},
  [8207] = {.lex_state = 528, .external_lex_state = 3},
  [8208] = {.lex_state = 528, .external_lex_state = 3},
  [8209] = {.lex_state = 528, .external_lex_state = 3},
  [8210] = {.lex_state = 528, .external_lex_state = 3},
  [8211] = {.lex_state = 528, .external_lex_state = 3},
  [8212] = {.lex_state = 528, .external_lex_state = 3},
  [8213] = {.lex_state = 528, .external_lex_state = 3},
  [8214] = {.lex_state = 388, .external_lex_state = 25},
  [8215] = {.lex_state = 177, .external_lex_state = 4},
  [8216] = {.lex_state = 388, .external_lex_state = 25},
  [8217] = {.lex_state = 388, .external_lex_state = 25},
  [8218] = {.lex_state = 177, .external_lex_state = 4},
  [8219] = {.lex_state = 388, .external_lex_state = 25},
  [8220] = {.lex_state = 406, .external_lex_state = 25},
  [8221] = {.lex_state = 406, .external_lex_state = 25},
  [8222] = {.lex_state = 192, .external_lex_state = 2},
  [8223] = {.lex_state = 192, .external_lex_state = 2},
  [8224] = {.lex_state = 192, .external_lex_state = 2},
  [8225] = {.lex_state = 192, .external_lex_state = 2},
  [8226] = {.lex_state = 192, .external_lex_state = 2},
  [8227] = {.lex_state = 192, .external_lex_state = 2},
  [8228] = {.lex_state = 192, .external_lex_state = 2},
  [8229] = {.lex_state = 192, .external_lex_state = 2},
  [8230] = {.lex_state = 192, .external_lex_state = 2},
  [8231] = {.lex_state = 192, .external_lex_state = 2},
  [8232] = {.lex_state = 192, .external_lex_state = 29},
  [8233] = {.lex_state = 192, .external_lex_state = 2},
  [8234] = {.lex_state = 406, .external_lex_state = 25},
  [8235] = {.lex_state = 406, .external_lex_state = 25},
  [8236] = {.lex_state = 406, .external_lex_state = 25},
  [8237] = {.lex_state = 524, .external_lex_state = 21},
  [8238] = {.lex_state = 406, .external_lex_state = 25},
  [8239] = {.lex_state = 406, .external_lex_state = 25},
  [8240] = {.lex_state = 192, .external_lex_state = 2},
  [8241] = {.lex_state = 537, .external_lex_state = 25},
  [8242] = {.lex_state = 537, .external_lex_state = 25},
  [8243] = {.lex_state = 192, .external_lex_state = 2},
  [8244] = {.lex_state = 192, .external_lex_state = 2},
  [8245] = {.lex_state = 192, .external_lex_state = 2},
  [8246] = {.lex_state = 192, .external_lex_state = 2},
  [8247] = {.lex_state = 192, .external_lex_state = 2},
  [8248] = {.lex_state = 192, .external_lex_state = 2},
  [8249] = {.lex_state = 192, .external_lex_state = 2},
  [8250] = {.lex_state = 192, .external_lex_state = 2},
  [8251] = {.lex_state = 192, .external_lex_state = 2},
  [8252] = {.lex_state = 192, .external_lex_state = 2},
  [8253] = {.lex_state = 192, .external_lex_state = 29},
  [8254] = {.lex_state = 192, .external_lex_state = 2},
  [8255] = {.lex_state = 537, .external_lex_state = 27},
  [8256] = {.lex_state = 537, .external_lex_state = 25},
  [8257] = {.lex_state = 537, .external_lex_state = 25},
  [8258] = {.lex_state = 537, .external_lex_state = 25},
  [8259] = {.lex_state = 524, .external_lex_state = 21},
  [8260] = {.lex_state = 537, .external_lex_state = 25},
  [8261] = {.lex_state = 537, .external_lex_state = 25},
  [8262] = {.lex_state = 400, .external_lex_state = 25},
  [8263] = {.lex_state = 192, .external_lex_state = 29},
  [8264] = {.lex_state = 400, .external_lex_state = 25},
  [8265] = {.lex_state = 225, .external_lex_state = 7},
  [8266] = {.lex_state = 388, .external_lex_state = 25},
  [8267] = {.lex_state = 388, .external_lex_state = 25},
  [8268] = {.lex_state = 192, .external_lex_state = 2},
  [8269] = {.lex_state = 192, .external_lex_state = 29},
  [8270] = {.lex_state = 406, .external_lex_state = 25},
  [8271] = {.lex_state = 388, .external_lex_state = 25},
  [8272] = {.lex_state = 128},
  [8273] = {.lex_state = 128},
  [8274] = {.lex_state = 388, .external_lex_state = 25},
  [8275] = {.lex_state = 128},
  [8276] = {.lex_state = 388, .external_lex_state = 25},
  [8277] = {.lex_state = 388, .external_lex_state = 25},
  [8278] = {.lex_state = 388, .external_lex_state = 25},
  [8279] = {.lex_state = 128},
  [8280] = {.lex_state = 388, .external_lex_state = 25},
  [8281] = {.lex_state = 128},
  [8282] = {.lex_state = 388, .external_lex_state = 25},
  [8283] = {.lex_state = 128},
  [8284] = {.lex_state = 388, .external_lex_state = 25},
  [8285] = {.lex_state = 388, .external_lex_state = 25},
  [8286] = {.lex_state = 128},
  [8287] = {.lex_state = 128, .external_lex_state = 2},
  [8288] = {.lex_state = 400, .external_lex_state = 25},
  [8289] = {.lex_state = 544, .external_lex_state = 26},
  [8290] = {.lex_state = 209},
  [8291] = {.lex_state = 397, .external_lex_state = 25},
  [8292] = {.lex_state = 397, .external_lex_state = 25},
  [8293] = {.lex_state = 397, .external_lex_state = 25},
  [8294] = {.lex_state = 128},
  [8295] = {.lex_state = 128, .external_lex_state = 2},
  [8296] = {.lex_state = 192, .external_lex_state = 2},
  [8297] = {.lex_state = 192, .external_lex_state = 29},
  [8298] = {.lex_state = 403, .external_lex_state = 25},
  [8299] = {.lex_state = 641, .external_lex_state = 13},
  [8300] = {.lex_state = 547, .external_lex_state = 25},
  [8301] = {.lex_state = 400, .external_lex_state = 25},
  [8302] = {.lex_state = 237},
  [8303] = {.lex_state = 128},
  [8304] = {.lex_state = 286, .external_lex_state = 2},
  [8305] = {.lex_state = 237},
  [8306] = {.lex_state = 192, .external_lex_state = 2},
  [8307] = {.lex_state = 511, .external_lex_state = 18},
  [8308] = {.lex_state = 511, .external_lex_state = 18},
  [8309] = {.lex_state = 511, .external_lex_state = 18},
  [8310] = {.lex_state = 511, .external_lex_state = 18},
  [8311] = {.lex_state = 192, .external_lex_state = 2},
  [8312] = {.lex_state = 192, .external_lex_state = 2},
  [8313] = {.lex_state = 302, .external_lex_state = 16},
  [8314] = {.lex_state = 254, .external_lex_state = 18},
  [8315] = {.lex_state = 213},
  [8316] = {.lex_state = 227, .external_lex_state = 16},
  [8317] = {.lex_state = 251, .external_lex_state = 20},
  [8318] = {.lex_state = 302, .external_lex_state = 16},
  [8319] = {.lex_state = 128},
  [8320] = {.lex_state = 237},
  [8321] = {.lex_state = 237},
  [8322] = {.lex_state = 337},
  [8323] = {.lex_state = 237},
  [8324] = {.lex_state = 128, .external_lex_state = 12},
  [8325] = {.lex_state = 237},
  [8326] = {.lex_state = 128},
  [8327] = {.lex_state = 237},
  [8328] = {.lex_state = 156, .external_lex_state = 3},
  [8329] = {.lex_state = 128},
  [8330] = {.lex_state = 302, .external_lex_state = 16},
  [8331] = {.lex_state = 302, .external_lex_state = 16},
  [8332] = {.lex_state = 302, .external_lex_state = 16},
  [8333] = {.lex_state = 302, .external_lex_state = 16},
  [8334] = {.lex_state = 302, .external_lex_state = 16},
  [8335] = {.lex_state = 554, .external_lex_state = 16},
  [8336] = {.lex_state = 302, .external_lex_state = 16},
  [8337] = {.lex_state = 302, .external_lex_state = 16},
  [8338] = {.lex_state = 302, .external_lex_state = 16},
  [8339] = {.lex_state = 302, .external_lex_state = 16},
  [8340] = {.lex_state = 421, .external_lex_state = 25},
  [8341] = {.lex_state = 192, .external_lex_state = 2},
  [8342] = {.lex_state = 302, .external_lex_state = 16},
  [8343] = {.lex_state = 302, .external_lex_state = 16},
  [8344] = {.lex_state = 302, .external_lex_state = 16},
  [8345] = {.lex_state = 251, .external_lex_state = 20},
  [8346] = {.lex_state = 645, .external_lex_state = 25},
  [8347] = {.lex_state = 645, .external_lex_state = 25},
  [8348] = {.lex_state = 645, .external_lex_state = 25},
  [8349] = {.lex_state = 645, .external_lex_state = 25},
  [8350] = {.lex_state = 192, .external_lex_state = 2},
  [8351] = {.lex_state = 192, .external_lex_state = 2},
  [8352] = {.lex_state = 192, .external_lex_state = 2},
  [8353] = {.lex_state = 192, .external_lex_state = 2},
  [8354] = {.lex_state = 192, .external_lex_state = 2},
  [8355] = {.lex_state = 192, .external_lex_state = 2},
  [8356] = {.lex_state = 192, .external_lex_state = 2},
  [8357] = {.lex_state = 192, .external_lex_state = 2},
  [8358] = {.lex_state = 192, .external_lex_state = 2},
  [8359] = {.lex_state = 192, .external_lex_state = 2},
  [8360] = {.lex_state = 192, .external_lex_state = 29},
  [8361] = {.lex_state = 192, .external_lex_state = 2},
  [8362] = {.lex_state = 645, .external_lex_state = 27},
  [8363] = {.lex_state = 654, .external_lex_state = 27},
  [8364] = {.lex_state = 192, .external_lex_state = 15},
  [8365] = {.lex_state = 645, .external_lex_state = 25},
  [8366] = {.lex_state = 654, .external_lex_state = 25},
  [8367] = {.lex_state = 654, .external_lex_state = 25},
  [8368] = {.lex_state = 192, .external_lex_state = 2},
  [8369] = {.lex_state = 654, .external_lex_state = 25},
  [8370] = {.lex_state = 192, .external_lex_state = 2},
  [8371] = {.lex_state = 654, .external_lex_state = 25},
  [8372] = {.lex_state = 524, .external_lex_state = 13},
  [8373] = {.lex_state = 654, .external_lex_state = 25},
  [8374] = {.lex_state = 645, .external_lex_state = 25},
  [8375] = {.lex_state = 654, .external_lex_state = 25},
  [8376] = {.lex_state = 654, .external_lex_state = 25},
  [8377] = {.lex_state = 654, .external_lex_state = 25},
  [8378] = {.lex_state = 654, .external_lex_state = 25},
  [8379] = {.lex_state = 654, .external_lex_state = 25},
  [8380] = {.lex_state = 554, .external_lex_state = 16},
  [8381] = {.lex_state = 654, .external_lex_state = 25},
  [8382] = {.lex_state = 654, .external_lex_state = 25},
  [8383] = {.lex_state = 654, .external_lex_state = 25},
  [8384] = {.lex_state = 654, .external_lex_state = 25},
  [8385] = {.lex_state = 658, .external_lex_state = 25},
  [8386] = {.lex_state = 658, .external_lex_state = 25},
  [8387] = {.lex_state = 192, .external_lex_state = 2},
  [8388] = {.lex_state = 658, .external_lex_state = 25},
  [8389] = {.lex_state = 192, .external_lex_state = 2},
  [8390] = {.lex_state = 658, .external_lex_state = 25},
  [8391] = {.lex_state = 524, .external_lex_state = 13},
  [8392] = {.lex_state = 658, .external_lex_state = 25},
  [8393] = {.lex_state = 562, .external_lex_state = 25},
  [8394] = {.lex_state = 524, .external_lex_state = 21},
  [8395] = {.lex_state = 562, .external_lex_state = 25},
  [8396] = {.lex_state = 645, .external_lex_state = 25},
  [8397] = {.lex_state = 654, .external_lex_state = 25},
  [8398] = {.lex_state = 654, .external_lex_state = 25},
  [8399] = {.lex_state = 654, .external_lex_state = 25},
  [8400] = {.lex_state = 654, .external_lex_state = 27},
  [8401] = {.lex_state = 192, .external_lex_state = 2},
  [8402] = {.lex_state = 559, .external_lex_state = 25},
  [8403] = {.lex_state = 559, .external_lex_state = 25},
  [8404] = {.lex_state = 192, .external_lex_state = 2},
  [8405] = {.lex_state = 192, .external_lex_state = 2},
  [8406] = {.lex_state = 192, .external_lex_state = 2},
  [8407] = {.lex_state = 192, .external_lex_state = 2},
  [8408] = {.lex_state = 192, .external_lex_state = 2},
  [8409] = {.lex_state = 192, .external_lex_state = 2},
  [8410] = {.lex_state = 192, .external_lex_state = 2},
  [8411] = {.lex_state = 192, .external_lex_state = 2},
  [8412] = {.lex_state = 192, .external_lex_state = 2},
  [8413] = {.lex_state = 192, .external_lex_state = 2},
  [8414] = {.lex_state = 192, .external_lex_state = 29},
  [8415] = {.lex_state = 192, .external_lex_state = 2},
  [8416] = {.lex_state = 559, .external_lex_state = 27},
  [8417] = {.lex_state = 658, .external_lex_state = 27},
  [8418] = {.lex_state = 192, .external_lex_state = 15},
  [8419] = {.lex_state = 559, .external_lex_state = 25},
  [8420] = {.lex_state = 559, .external_lex_state = 25},
  [8421] = {.lex_state = 658, .external_lex_state = 25},
  [8422] = {.lex_state = 658, .external_lex_state = 25},
  [8423] = {.lex_state = 658, .external_lex_state = 25},
  [8424] = {.lex_state = 658, .external_lex_state = 25},
  [8425] = {.lex_state = 658, .external_lex_state = 25},
  [8426] = {.lex_state = 554, .external_lex_state = 16},
  [8427] = {.lex_state = 658, .external_lex_state = 25},
  [8428] = {.lex_state = 658, .external_lex_state = 25},
  [8429] = {.lex_state = 658, .external_lex_state = 25},
  [8430] = {.lex_state = 658, .external_lex_state = 25},
  [8431] = {.lex_state = 559, .external_lex_state = 25},
  [8432] = {.lex_state = 524, .external_lex_state = 21},
  [8433] = {.lex_state = 559, .external_lex_state = 25},
  [8434] = {.lex_state = 559, .external_lex_state = 25},
  [8435] = {.lex_state = 658, .external_lex_state = 25},
  [8436] = {.lex_state = 658, .external_lex_state = 25},
  [8437] = {.lex_state = 658, .external_lex_state = 25},
  [8438] = {.lex_state = 658, .external_lex_state = 27},
  [8439] = {.lex_state = 554, .external_lex_state = 16},
  [8440] = {.lex_state = 554, .external_lex_state = 16},
  [8441] = {.lex_state = 554, .external_lex_state = 16},
  [8442] = {.lex_state = 192, .external_lex_state = 2},
  [8443] = {.lex_state = 192, .external_lex_state = 2},
  [8444] = {.lex_state = 192, .external_lex_state = 2},
  [8445] = {.lex_state = 192, .external_lex_state = 2},
  [8446] = {.lex_state = 192, .external_lex_state = 2},
  [8447] = {.lex_state = 192, .external_lex_state = 2},
  [8448] = {.lex_state = 192, .external_lex_state = 2},
  [8449] = {.lex_state = 192, .external_lex_state = 2},
  [8450] = {.lex_state = 192, .external_lex_state = 2},
  [8451] = {.lex_state = 192, .external_lex_state = 2},
  [8452] = {.lex_state = 192, .external_lex_state = 29},
  [8453] = {.lex_state = 554, .external_lex_state = 16},
  [8454] = {.lex_state = 192, .external_lex_state = 29},
  [8455] = {.lex_state = 192, .external_lex_state = 2},
  [8456] = {.lex_state = 645, .external_lex_state = 20},
  [8457] = {.lex_state = 327, .external_lex_state = 11},
  [8458] = {.lex_state = 299, .external_lex_state = 3},
  [8459] = {.lex_state = 177, .external_lex_state = 4},
  [8460] = {.lex_state = 299, .external_lex_state = 3},
  [8461] = {.lex_state = 299, .external_lex_state = 3},
  [8462] = {.lex_state = 177, .external_lex_state = 4},
  [8463] = {.lex_state = 299, .external_lex_state = 3},
  [8464] = {.lex_state = 227, .external_lex_state = 3},
  [8465] = {.lex_state = 227, .external_lex_state = 3},
  [8466] = {.lex_state = 177, .external_lex_state = 4},
  [8467] = {.lex_state = 266, .external_lex_state = 15},
  [8468] = {.lex_state = 227, .external_lex_state = 3},
  [8469] = {.lex_state = 177, .external_lex_state = 4},
  [8470] = {.lex_state = 227, .external_lex_state = 3},
  [8471] = {.lex_state = 227, .external_lex_state = 3},
  [8472] = {.lex_state = 177, .external_lex_state = 4},
  [8473] = {.lex_state = 266, .external_lex_state = 15},
  [8474] = {.lex_state = 227, .external_lex_state = 3},
  [8475] = {.lex_state = 177, .external_lex_state = 4},
  [8476] = {.lex_state = 227, .external_lex_state = 3},
  [8477] = {.lex_state = 310},
  [8478] = {.lex_state = 227, .external_lex_state = 3},
  [8479] = {.lex_state = 227, .external_lex_state = 3},
  [8480] = {.lex_state = 128, .external_lex_state = 2},
  [8481] = {.lex_state = 128, .external_lex_state = 2},
  [8482] = {.lex_state = 227, .external_lex_state = 3},
  [8483] = {.lex_state = 227, .external_lex_state = 3},
  [8484] = {.lex_state = 227, .external_lex_state = 3},
  [8485] = {.lex_state = 128},
  [8486] = {.lex_state = 128},
  [8487] = {.lex_state = 128, .external_lex_state = 2},
  [8488] = {.lex_state = 227, .external_lex_state = 3},
  [8489] = {.lex_state = 128},
  [8490] = {.lex_state = 128},
  [8491] = {.lex_state = 227, .external_lex_state = 3},
  [8492] = {.lex_state = 128},
  [8493] = {.lex_state = 227, .external_lex_state = 3},
  [8494] = {.lex_state = 128},
  [8495] = {.lex_state = 128, .external_lex_state = 2},
  [8496] = {.lex_state = 128},
  [8497] = {.lex_state = 128},
  [8498] = {.lex_state = 227, .external_lex_state = 3},
  [8499] = {.lex_state = 227, .external_lex_state = 3},
  [8500] = {.lex_state = 128},
  [8501] = {.lex_state = 128},
  [8502] = {.lex_state = 227, .external_lex_state = 3},
  [8503] = {.lex_state = 192, .external_lex_state = 2},
  [8504] = {.lex_state = 192, .external_lex_state = 29},
  [8505] = {.lex_state = 424, .external_lex_state = 3},
  [8506] = {.lex_state = 588, .external_lex_state = 3},
  [8507] = {.lex_state = 588, .external_lex_state = 3},
  [8508] = {.lex_state = 455, .external_lex_state = 3},
  [8509] = {.lex_state = 524, .external_lex_state = 21},
  [8510] = {.lex_state = 455, .external_lex_state = 3},
  [8511] = {.lex_state = 588, .external_lex_state = 3},
  [8512] = {.lex_state = 192, .external_lex_state = 2},
  [8513] = {.lex_state = 573, .external_lex_state = 3},
  [8514] = {.lex_state = 573, .external_lex_state = 3},
  [8515] = {.lex_state = 573, .external_lex_state = 3},
  [8516] = {.lex_state = 524, .external_lex_state = 21},
  [8517] = {.lex_state = 573, .external_lex_state = 3},
  [8518] = {.lex_state = 573, .external_lex_state = 3},
  [8519] = {.lex_state = 436, .external_lex_state = 3},
  [8520] = {.lex_state = 436, .external_lex_state = 3},
  [8521] = {.lex_state = 436, .external_lex_state = 3},
  [8522] = {.lex_state = 192, .external_lex_state = 2},
  [8523] = {.lex_state = 192, .external_lex_state = 2},
  [8524] = {.lex_state = 192, .external_lex_state = 2},
  [8525] = {.lex_state = 192, .external_lex_state = 2},
  [8526] = {.lex_state = 192, .external_lex_state = 2},
  [8527] = {.lex_state = 192, .external_lex_state = 2},
  [8528] = {.lex_state = 192, .external_lex_state = 2},
  [8529] = {.lex_state = 192, .external_lex_state = 2},
  [8530] = {.lex_state = 192, .external_lex_state = 2},
  [8531] = {.lex_state = 192, .external_lex_state = 2},
  [8532] = {.lex_state = 192, .external_lex_state = 29},
  [8533] = {.lex_state = 436, .external_lex_state = 3},
  [8534] = {.lex_state = 192, .external_lex_state = 29},
  [8535] = {.lex_state = 192, .external_lex_state = 2},
  [8536] = {.lex_state = 225, .external_lex_state = 7},
  [8537] = {.lex_state = 299, .external_lex_state = 3},
  [8538] = {.lex_state = 299, .external_lex_state = 3},
  [8539] = {.lex_state = 299, .external_lex_state = 3},
  [8540] = {.lex_state = 128},
  [8541] = {.lex_state = 128},
  [8542] = {.lex_state = 299, .external_lex_state = 3},
  [8543] = {.lex_state = 128},
  [8544] = {.lex_state = 299, .external_lex_state = 3},
  [8545] = {.lex_state = 299, .external_lex_state = 3},
  [8546] = {.lex_state = 299, .external_lex_state = 3},
  [8547] = {.lex_state = 128},
  [8548] = {.lex_state = 227, .external_lex_state = 3},
  [8549] = {.lex_state = 128},
  [8550] = {.lex_state = 299, .external_lex_state = 3},
  [8551] = {.lex_state = 128},
  [8552] = {.lex_state = 299, .external_lex_state = 3},
  [8553] = {.lex_state = 128},
  [8554] = {.lex_state = 421, .external_lex_state = 3},
  [8555] = {.lex_state = 299, .external_lex_state = 3},
  [8556] = {.lex_state = 421, .external_lex_state = 3},
  [8557] = {.lex_state = 192, .external_lex_state = 2},
  [8558] = {.lex_state = 467, .external_lex_state = 25},
  [8559] = {.lex_state = 467, .external_lex_state = 25},
  [8560] = {.lex_state = 467, .external_lex_state = 25},
  [8561] = {.lex_state = 467, .external_lex_state = 25},
  [8562] = {.lex_state = 467, .external_lex_state = 25},
  [8563] = {.lex_state = 467, .external_lex_state = 25},
  [8564] = {.lex_state = 467, .external_lex_state = 25},
  [8565] = {.lex_state = 554, .external_lex_state = 16},
  [8566] = {.lex_state = 467, .external_lex_state = 25},
  [8567] = {.lex_state = 467, .external_lex_state = 25},
  [8568] = {.lex_state = 467, .external_lex_state = 25},
  [8569] = {.lex_state = 467, .external_lex_state = 25},
  [8570] = {.lex_state = 467, .external_lex_state = 25},
  [8571] = {.lex_state = 467, .external_lex_state = 25},
  [8572] = {.lex_state = 467, .external_lex_state = 25},
  [8573] = {.lex_state = 467, .external_lex_state = 27},
  [8574] = {.lex_state = 588, .external_lex_state = 25},
  [8575] = {.lex_state = 588, .external_lex_state = 25},
  [8576] = {.lex_state = 588, .external_lex_state = 25},
  [8577] = {.lex_state = 524, .external_lex_state = 21},
  [8578] = {.lex_state = 588, .external_lex_state = 25},
  [8579] = {.lex_state = 588, .external_lex_state = 25},
  [8580] = {.lex_state = 192, .external_lex_state = 2},
  [8581] = {.lex_state = 573, .external_lex_state = 25},
  [8582] = {.lex_state = 573, .external_lex_state = 25},
  [8583] = {.lex_state = 573, .external_lex_state = 25},
  [8584] = {.lex_state = 524, .external_lex_state = 21},
  [8585] = {.lex_state = 573, .external_lex_state = 25},
  [8586] = {.lex_state = 573, .external_lex_state = 25},
  [8587] = {.lex_state = 192, .external_lex_state = 29},
  [8588] = {.lex_state = 588, .external_lex_state = 25},
  [8589] = {.lex_state = 436, .external_lex_state = 16},
  [8590] = {.lex_state = 579, .external_lex_state = 18},
  [8591] = {.lex_state = 209},
  [8592] = {.lex_state = 433, .external_lex_state = 16},
  [8593] = {.lex_state = 461, .external_lex_state = 27},
  [8594] = {.lex_state = 461, .external_lex_state = 25},
  [8595] = {.lex_state = 461, .external_lex_state = 25},
  [8596] = {.lex_state = 461, .external_lex_state = 25},
  [8597] = {.lex_state = 461, .external_lex_state = 25},
  [8598] = {.lex_state = 192, .external_lex_state = 15},
  [8599] = {.lex_state = 266, .external_lex_state = 15},
  [8600] = {.lex_state = 461, .external_lex_state = 25},
  [8601] = {.lex_state = 177, .external_lex_state = 4},
  [8602] = {.lex_state = 266, .external_lex_state = 15},
  [8603] = {.lex_state = 461, .external_lex_state = 25},
  [8604] = {.lex_state = 192, .external_lex_state = 15},
  [8605] = {.lex_state = 266, .external_lex_state = 15},
  [8606] = {.lex_state = 461, .external_lex_state = 25},
  [8607] = {.lex_state = 177, .external_lex_state = 4},
  [8608] = {.lex_state = 266, .external_lex_state = 15},
  [8609] = {.lex_state = 461, .external_lex_state = 25},
  [8610] = {.lex_state = 194},
  [8611] = {.lex_state = 302, .external_lex_state = 16},
  [8612] = {.lex_state = 225, .external_lex_state = 7},
  [8613] = {.lex_state = 128, .external_lex_state = 2},
  [8614] = {.lex_state = 461, .external_lex_state = 25},
  [8615] = {.lex_state = 247, .external_lex_state = 3},
  [8616] = {.lex_state = 128, .external_lex_state = 8},
  [8617] = {.lex_state = 128, .external_lex_state = 2},
  [8618] = {.lex_state = 461, .external_lex_state = 25},
  [8619] = {.lex_state = 128, .external_lex_state = 2},
  [8620] = {.lex_state = 128, .external_lex_state = 12},
  [8621] = {.lex_state = 128, .external_lex_state = 2},
  [8622] = {.lex_state = 128, .external_lex_state = 2},
  [8623] = {.lex_state = 128, .external_lex_state = 2},
  [8624] = {.lex_state = 128, .external_lex_state = 8},
  [8625] = {.lex_state = 128},
  [8626] = {.lex_state = 128},
  [8627] = {.lex_state = 128},
  [8628] = {.lex_state = 461, .external_lex_state = 25},
  [8629] = {.lex_state = 128},
  [8630] = {.lex_state = 128},
  [8631] = {.lex_state = 128},
  [8632] = {.lex_state = 461, .external_lex_state = 25},
  [8633] = {.lex_state = 461, .external_lex_state = 25},
  [8634] = {.lex_state = 235},
  [8635] = {.lex_state = 461, .external_lex_state = 25},
  [8636] = {.lex_state = 441, .external_lex_state = 25},
  [8637] = {.lex_state = 441, .external_lex_state = 25},
  [8638] = {.lex_state = 441, .external_lex_state = 25},
  [8639] = {.lex_state = 441, .external_lex_state = 25},
  [8640] = {.lex_state = 441, .external_lex_state = 25},
  [8641] = {.lex_state = 554, .external_lex_state = 16},
  [8642] = {.lex_state = 441, .external_lex_state = 25},
  [8643] = {.lex_state = 441, .external_lex_state = 25},
  [8644] = {.lex_state = 441, .external_lex_state = 25},
  [8645] = {.lex_state = 441, .external_lex_state = 25},
  [8646] = {.lex_state = 441, .external_lex_state = 25},
  [8647] = {.lex_state = 461, .external_lex_state = 25},
  [8648] = {.lex_state = 441, .external_lex_state = 25},
  [8649] = {.lex_state = 441, .external_lex_state = 25},
  [8650] = {.lex_state = 441, .external_lex_state = 27},
  [8651] = {.lex_state = 433, .external_lex_state = 16},
  [8652] = {.lex_state = 433, .external_lex_state = 16},
  [8653] = {.lex_state = 128},
  [8654] = {.lex_state = 128, .external_lex_state = 2},
  [8655] = {.lex_state = 461, .external_lex_state = 25},
  [8656] = {.lex_state = 192, .external_lex_state = 2},
  [8657] = {.lex_state = 461, .external_lex_state = 25},
  [8658] = {.lex_state = 461, .external_lex_state = 25},
  [8659] = {.lex_state = 192, .external_lex_state = 29},
  [8660] = {.lex_state = 573, .external_lex_state = 25},
  [8661] = {.lex_state = 436, .external_lex_state = 16},
  [8662] = {.lex_state = 436, .external_lex_state = 16},
  [8663] = {.lex_state = 436, .external_lex_state = 16},
  [8664] = {.lex_state = 436, .external_lex_state = 16},
  [8665] = {.lex_state = 436, .external_lex_state = 16},
  [8666] = {.lex_state = 554, .external_lex_state = 16},
  [8667] = {.lex_state = 436, .external_lex_state = 16},
  [8668] = {.lex_state = 436, .external_lex_state = 16},
  [8669] = {.lex_state = 436, .external_lex_state = 16},
  [8670] = {.lex_state = 436, .external_lex_state = 16},
  [8671] = {.lex_state = 436, .external_lex_state = 16},
  [8672] = {.lex_state = 436, .external_lex_state = 16},
  [8673] = {.lex_state = 436, .external_lex_state = 16},
  [8674] = {.lex_state = 467, .external_lex_state = 20},
  [8675] = {.lex_state = 467, .external_lex_state = 3},
  [8676] = {.lex_state = 467, .external_lex_state = 3},
  [8677] = {.lex_state = 467, .external_lex_state = 3},
  [8678] = {.lex_state = 467, .external_lex_state = 3},
  [8679] = {.lex_state = 467, .external_lex_state = 3},
  [8680] = {.lex_state = 467, .external_lex_state = 3},
  [8681] = {.lex_state = 467, .external_lex_state = 3},
  [8682] = {.lex_state = 554, .external_lex_state = 16},
  [8683] = {.lex_state = 467, .external_lex_state = 3},
  [8684] = {.lex_state = 467, .external_lex_state = 3},
  [8685] = {.lex_state = 467, .external_lex_state = 3},
  [8686] = {.lex_state = 467, .external_lex_state = 3},
  [8687] = {.lex_state = 467, .external_lex_state = 3},
  [8688] = {.lex_state = 467, .external_lex_state = 3},
  [8689] = {.lex_state = 467, .external_lex_state = 3},
  [8690] = {.lex_state = 467, .external_lex_state = 14},
  [8691] = {.lex_state = 588, .external_lex_state = 3},
  [8692] = {.lex_state = 588, .external_lex_state = 3},
  [8693] = {.lex_state = 192, .external_lex_state = 2},
  [8694] = {.lex_state = 192, .external_lex_state = 29},
  [8695] = {.lex_state = 588, .external_lex_state = 3},
  [8696] = {.lex_state = 436, .external_lex_state = 3},
  [8697] = {.lex_state = 441, .external_lex_state = 3},
  [8698] = {.lex_state = 441, .external_lex_state = 3},
  [8699] = {.lex_state = 441, .external_lex_state = 3},
  [8700] = {.lex_state = 441, .external_lex_state = 3},
  [8701] = {.lex_state = 441, .external_lex_state = 3},
  [8702] = {.lex_state = 554, .external_lex_state = 16},
  [8703] = {.lex_state = 441, .external_lex_state = 3},
  [8704] = {.lex_state = 441, .external_lex_state = 3},
  [8705] = {.lex_state = 441, .external_lex_state = 3},
  [8706] = {.lex_state = 441, .external_lex_state = 3},
  [8707] = {.lex_state = 441, .external_lex_state = 3},
  [8708] = {.lex_state = 441, .external_lex_state = 3},
  [8709] = {.lex_state = 441, .external_lex_state = 3},
  [8710] = {.lex_state = 441, .external_lex_state = 14},
  [8711] = {.lex_state = 192, .external_lex_state = 2},
  [8712] = {.lex_state = 192, .external_lex_state = 29},
  [8713] = {.lex_state = 573, .external_lex_state = 3},
  [8714] = {.lex_state = 436, .external_lex_state = 3},
  [8715] = {.lex_state = 436, .external_lex_state = 3},
  [8716] = {.lex_state = 436, .external_lex_state = 3},
  [8717] = {.lex_state = 436, .external_lex_state = 3},
  [8718] = {.lex_state = 436, .external_lex_state = 3},
  [8719] = {.lex_state = 554, .external_lex_state = 16},
  [8720] = {.lex_state = 436, .external_lex_state = 3},
  [8721] = {.lex_state = 436, .external_lex_state = 3},
  [8722] = {.lex_state = 436, .external_lex_state = 3},
  [8723] = {.lex_state = 436, .external_lex_state = 3},
  [8724] = {.lex_state = 436, .external_lex_state = 3},
  [8725] = {.lex_state = 436, .external_lex_state = 3},
  [8726] = {.lex_state = 436, .external_lex_state = 3},
  [8727] = {.lex_state = 288, .external_lex_state = 16},
  [8728] = {.lex_state = 288, .external_lex_state = 16},
  [8729] = {.lex_state = 288, .external_lex_state = 16},
  [8730] = {.lex_state = 467, .external_lex_state = 25},
  [8731] = {.lex_state = 467, .external_lex_state = 25},
  [8732] = {.lex_state = 467, .external_lex_state = 25},
  [8733] = {.lex_state = 467, .external_lex_state = 25},
  [8734] = {.lex_state = 467, .external_lex_state = 25},
  [8735] = {.lex_state = 554, .external_lex_state = 16},
  [8736] = {.lex_state = 467, .external_lex_state = 25},
  [8737] = {.lex_state = 467, .external_lex_state = 25},
  [8738] = {.lex_state = 467, .external_lex_state = 25},
  [8739] = {.lex_state = 467, .external_lex_state = 25},
  [8740] = {.lex_state = 467, .external_lex_state = 25},
  [8741] = {.lex_state = 467, .external_lex_state = 25},
  [8742] = {.lex_state = 467, .external_lex_state = 25},
  [8743] = {.lex_state = 588, .external_lex_state = 25},
  [8744] = {.lex_state = 588, .external_lex_state = 25},
  [8745] = {.lex_state = 588, .external_lex_state = 25},
  [8746] = {.lex_state = 524, .external_lex_state = 21},
  [8747] = {.lex_state = 588, .external_lex_state = 25},
  [8748] = {.lex_state = 588, .external_lex_state = 25},
  [8749] = {.lex_state = 192, .external_lex_state = 2},
  [8750] = {.lex_state = 573, .external_lex_state = 25},
  [8751] = {.lex_state = 573, .external_lex_state = 25},
  [8752] = {.lex_state = 573, .external_lex_state = 25},
  [8753] = {.lex_state = 524, .external_lex_state = 21},
  [8754] = {.lex_state = 573, .external_lex_state = 25},
  [8755] = {.lex_state = 573, .external_lex_state = 25},
  [8756] = {.lex_state = 192, .external_lex_state = 29},
  [8757] = {.lex_state = 588, .external_lex_state = 25},
  [8758] = {.lex_state = 436, .external_lex_state = 25},
  [8759] = {.lex_state = 595, .external_lex_state = 26},
  [8760] = {.lex_state = 209},
  [8761] = {.lex_state = 461, .external_lex_state = 25},
  [8762] = {.lex_state = 441, .external_lex_state = 25},
  [8763] = {.lex_state = 441, .external_lex_state = 25},
  [8764] = {.lex_state = 441, .external_lex_state = 25},
  [8765] = {.lex_state = 441, .external_lex_state = 25},
  [8766] = {.lex_state = 441, .external_lex_state = 25},
  [8767] = {.lex_state = 554, .external_lex_state = 16},
  [8768] = {.lex_state = 441, .external_lex_state = 25},
  [8769] = {.lex_state = 441, .external_lex_state = 25},
  [8770] = {.lex_state = 441, .external_lex_state = 25},
  [8771] = {.lex_state = 441, .external_lex_state = 25},
  [8772] = {.lex_state = 441, .external_lex_state = 25},
  [8773] = {.lex_state = 441, .external_lex_state = 25},
  [8774] = {.lex_state = 441, .external_lex_state = 25},
  [8775] = {.lex_state = 441, .external_lex_state = 27},
  [8776] = {.lex_state = 461, .external_lex_state = 25},
  [8777] = {.lex_state = 461, .external_lex_state = 25},
  [8778] = {.lex_state = 128},
  [8779] = {.lex_state = 128, .external_lex_state = 2},
  [8780] = {.lex_state = 192, .external_lex_state = 2},
  [8781] = {.lex_state = 192, .external_lex_state = 29},
  [8782] = {.lex_state = 573, .external_lex_state = 25},
  [8783] = {.lex_state = 436, .external_lex_state = 25},
  [8784] = {.lex_state = 361, .external_lex_state = 25},
  [8785] = {.lex_state = 388, .external_lex_state = 25},
  [8786] = {.lex_state = 361, .external_lex_state = 25},
  [8787] = {.lex_state = 288, .external_lex_state = 16},
  [8788] = {.lex_state = 128},
  [8789] = {.lex_state = 288, .external_lex_state = 16},
  [8790] = {.lex_state = 288, .external_lex_state = 16},
  [8791] = {.lex_state = 288, .external_lex_state = 16},
  [8792] = {.lex_state = 288, .external_lex_state = 16},
  [8793] = {.lex_state = 288, .external_lex_state = 16},
  [8794] = {.lex_state = 128},
  [8795] = {.lex_state = 304, .external_lex_state = 18},
  [8796] = {.lex_state = 397, .external_lex_state = 25},
  [8797] = {.lex_state = 177, .external_lex_state = 4},
  [8798] = {.lex_state = 397, .external_lex_state = 25},
  [8799] = {.lex_state = 397, .external_lex_state = 25},
  [8800] = {.lex_state = 177, .external_lex_state = 4},
  [8801] = {.lex_state = 397, .external_lex_state = 25},
  [8802] = {.lex_state = 225, .external_lex_state = 7},
  [8803] = {.lex_state = 397, .external_lex_state = 25},
  [8804] = {.lex_state = 397, .external_lex_state = 25},
  [8805] = {.lex_state = 397, .external_lex_state = 25},
  [8806] = {.lex_state = 128},
  [8807] = {.lex_state = 128},
  [8808] = {.lex_state = 397, .external_lex_state = 25},
  [8809] = {.lex_state = 128},
  [8810] = {.lex_state = 397, .external_lex_state = 25},
  [8811] = {.lex_state = 397, .external_lex_state = 25},
  [8812] = {.lex_state = 397, .external_lex_state = 25},
  [8813] = {.lex_state = 128},
  [8814] = {.lex_state = 299, .external_lex_state = 16},
  [8815] = {.lex_state = 128},
  [8816] = {.lex_state = 397, .external_lex_state = 25},
  [8817] = {.lex_state = 128},
  [8818] = {.lex_state = 397, .external_lex_state = 25},
  [8819] = {.lex_state = 128},
  [8820] = {.lex_state = 421, .external_lex_state = 25},
  [8821] = {.lex_state = 397, .external_lex_state = 25},
  [8822] = {.lex_state = 421, .external_lex_state = 25},
  [8823] = {.lex_state = 192, .external_lex_state = 2},
  [8824] = {.lex_state = 493, .external_lex_state = 25},
  [8825] = {.lex_state = 493, .external_lex_state = 25},
  [8826] = {.lex_state = 493, .external_lex_state = 25},
  [8827] = {.lex_state = 493, .external_lex_state = 25},
  [8828] = {.lex_state = 493, .external_lex_state = 25},
  [8829] = {.lex_state = 554, .external_lex_state = 16},
  [8830] = {.lex_state = 493, .external_lex_state = 25},
  [8831] = {.lex_state = 493, .external_lex_state = 25},
  [8832] = {.lex_state = 493, .external_lex_state = 25},
  [8833] = {.lex_state = 493, .external_lex_state = 25},
  [8834] = {.lex_state = 493, .external_lex_state = 25},
  [8835] = {.lex_state = 493, .external_lex_state = 25},
  [8836] = {.lex_state = 493, .external_lex_state = 25},
  [8837] = {.lex_state = 192, .external_lex_state = 2},
  [8838] = {.lex_state = 192, .external_lex_state = 29},
  [8839] = {.lex_state = 493, .external_lex_state = 25},
  [8840] = {.lex_state = 302, .external_lex_state = 16},
  [8841] = {.lex_state = 321, .external_lex_state = 25},
  [8842] = {.lex_state = 321, .external_lex_state = 25},
  [8843] = {.lex_state = 321, .external_lex_state = 25},
  [8844] = {.lex_state = 321, .external_lex_state = 25},
  [8845] = {.lex_state = 321, .external_lex_state = 25},
  [8846] = {.lex_state = 554, .external_lex_state = 16},
  [8847] = {.lex_state = 321, .external_lex_state = 25},
  [8848] = {.lex_state = 321, .external_lex_state = 25},
  [8849] = {.lex_state = 321, .external_lex_state = 25},
  [8850] = {.lex_state = 321, .external_lex_state = 25},
  [8851] = {.lex_state = 321, .external_lex_state = 25},
  [8852] = {.lex_state = 321, .external_lex_state = 25},
  [8853] = {.lex_state = 321, .external_lex_state = 25},
  [8854] = {.lex_state = 321, .external_lex_state = 27},
  [8855] = {.lex_state = 192, .external_lex_state = 2},
  [8856] = {.lex_state = 192, .external_lex_state = 29},
  [8857] = {.lex_state = 497, .external_lex_state = 25},
  [8858] = {.lex_state = 302, .external_lex_state = 16},
  [8859] = {.lex_state = 302, .external_lex_state = 16},
  [8860] = {.lex_state = 302, .external_lex_state = 16},
  [8861] = {.lex_state = 302, .external_lex_state = 16},
  [8862] = {.lex_state = 302, .external_lex_state = 16},
  [8863] = {.lex_state = 554, .external_lex_state = 16},
  [8864] = {.lex_state = 302, .external_lex_state = 16},
  [8865] = {.lex_state = 302, .external_lex_state = 16},
  [8866] = {.lex_state = 302, .external_lex_state = 16},
  [8867] = {.lex_state = 302, .external_lex_state = 16},
  [8868] = {.lex_state = 302, .external_lex_state = 16},
  [8869] = {.lex_state = 302, .external_lex_state = 16},
  [8870] = {.lex_state = 302, .external_lex_state = 16},
  [8871] = {.lex_state = 610, .external_lex_state = 20},
  [8872] = {.lex_state = 128, .external_lex_state = 2},
  [8873] = {.lex_state = 678, .external_lex_state = 8},
  [8874] = {.lex_state = 194},
  [8875] = {.lex_state = 678, .external_lex_state = 8},
  [8876] = {.lex_state = 128},
  [8877] = {.lex_state = 128, .external_lex_state = 2},
  [8878] = {.lex_state = 128, .external_lex_state = 12},
  [8879] = {.lex_state = 254, .external_lex_state = 8},
  [8880] = {.lex_state = 302},
  [8881] = {.lex_state = 254, .external_lex_state = 8},
  [8882] = {.lex_state = 254, .external_lex_state = 8},
  [8883] = {.lex_state = 621, .external_lex_state = 25},
  [8884] = {.lex_state = 621, .external_lex_state = 25},
  [8885] = {.lex_state = 192, .external_lex_state = 2},
  [8886] = {.lex_state = 621, .external_lex_state = 25},
  [8887] = {.lex_state = 192, .external_lex_state = 2},
  [8888] = {.lex_state = 621, .external_lex_state = 25},
  [8889] = {.lex_state = 524, .external_lex_state = 13},
  [8890] = {.lex_state = 621, .external_lex_state = 25},
  [8891] = {.lex_state = 621, .external_lex_state = 25},
  [8892] = {.lex_state = 621, .external_lex_state = 25},
  [8893] = {.lex_state = 621, .external_lex_state = 25},
  [8894] = {.lex_state = 621, .external_lex_state = 25},
  [8895] = {.lex_state = 621, .external_lex_state = 25},
  [8896] = {.lex_state = 554, .external_lex_state = 16},
  [8897] = {.lex_state = 621, .external_lex_state = 25},
  [8898] = {.lex_state = 621, .external_lex_state = 25},
  [8899] = {.lex_state = 621, .external_lex_state = 25},
  [8900] = {.lex_state = 621, .external_lex_state = 25},
  [8901] = {.lex_state = 621, .external_lex_state = 25},
  [8902] = {.lex_state = 621, .external_lex_state = 25},
  [8903] = {.lex_state = 621, .external_lex_state = 25},
  [8904] = {.lex_state = 621, .external_lex_state = 27},
  [8905] = {.lex_state = 604, .external_lex_state = 25},
  [8906] = {.lex_state = 604, .external_lex_state = 25},
  [8907] = {.lex_state = 604, .external_lex_state = 25},
  [8908] = {.lex_state = 524, .external_lex_state = 21},
  [8909] = {.lex_state = 604, .external_lex_state = 25},
  [8910] = {.lex_state = 604, .external_lex_state = 25},
  [8911] = {.lex_state = 192, .external_lex_state = 2},
  [8912] = {.lex_state = 192, .external_lex_state = 29},
  [8913] = {.lex_state = 604, .external_lex_state = 25},
  [8914] = {.lex_state = 493, .external_lex_state = 3},
  [8915] = {.lex_state = 493, .external_lex_state = 3},
  [8916] = {.lex_state = 192, .external_lex_state = 2},
  [8917] = {.lex_state = 192, .external_lex_state = 29},
  [8918] = {.lex_state = 493, .external_lex_state = 3},
  [8919] = {.lex_state = 493, .external_lex_state = 3},
  [8920] = {.lex_state = 493, .external_lex_state = 3},
  [8921] = {.lex_state = 192, .external_lex_state = 2},
  [8922] = {.lex_state = 192, .external_lex_state = 29},
  [8923] = {.lex_state = 321, .external_lex_state = 3},
  [8924] = {.lex_state = 497, .external_lex_state = 3},
  [8925] = {.lex_state = 497, .external_lex_state = 3},
  [8926] = {.lex_state = 192, .external_lex_state = 2},
  [8927] = {.lex_state = 330},
  [8928] = {.lex_state = 330},
  [8929] = {.lex_state = 330},
  [8930] = {.lex_state = 361, .external_lex_state = 25},
  [8931] = {.lex_state = 361, .external_lex_state = 25},
  [8932] = {.lex_state = 361, .external_lex_state = 25},
  [8933] = {.lex_state = 524, .external_lex_state = 21},
  [8934] = {.lex_state = 361, .external_lex_state = 25},
  [8935] = {.lex_state = 361, .external_lex_state = 25},
  [8936] = {.lex_state = 192, .external_lex_state = 2},
  [8937] = {.lex_state = 424, .external_lex_state = 25},
  [8938] = {.lex_state = 424, .external_lex_state = 25},
  [8939] = {.lex_state = 192, .external_lex_state = 2},
  [8940] = {.lex_state = 192, .external_lex_state = 2},
  [8941] = {.lex_state = 192, .external_lex_state = 2},
  [8942] = {.lex_state = 192, .external_lex_state = 2},
  [8943] = {.lex_state = 192, .external_lex_state = 2},
  [8944] = {.lex_state = 192, .external_lex_state = 2},
  [8945] = {.lex_state = 192, .external_lex_state = 2},
  [8946] = {.lex_state = 192, .external_lex_state = 2},
  [8947] = {.lex_state = 192, .external_lex_state = 2},
  [8948] = {.lex_state = 192, .external_lex_state = 2},
  [8949] = {.lex_state = 192, .external_lex_state = 29},
  [8950] = {.lex_state = 192, .external_lex_state = 2},
  [8951] = {.lex_state = 424, .external_lex_state = 27},
  [8952] = {.lex_state = 424, .external_lex_state = 25},
  [8953] = {.lex_state = 424, .external_lex_state = 25},
  [8954] = {.lex_state = 424, .external_lex_state = 25},
  [8955] = {.lex_state = 524, .external_lex_state = 21},
  [8956] = {.lex_state = 424, .external_lex_state = 25},
  [8957] = {.lex_state = 424, .external_lex_state = 25},
  [8958] = {.lex_state = 192, .external_lex_state = 29},
  [8959] = {.lex_state = 361, .external_lex_state = 25},
  [8960] = {.lex_state = 330},
  [8961] = {.lex_state = 128},
  [8962] = {.lex_state = 330},
  [8963] = {.lex_state = 330},
  [8964] = {.lex_state = 330},
  [8965] = {.lex_state = 330},
  [8966] = {.lex_state = 337},
  [8967] = {.lex_state = 128},
  [8968] = {.lex_state = 484, .external_lex_state = 21},
  [8969] = {.lex_state = 621, .external_lex_state = 25},
  [8970] = {.lex_state = 621, .external_lex_state = 25},
  [8971] = {.lex_state = 177, .external_lex_state = 4},
  [8972] = {.lex_state = 266, .external_lex_state = 15},
  [8973] = {.lex_state = 621, .external_lex_state = 25},
  [8974] = {.lex_state = 177, .external_lex_state = 4},
  [8975] = {.lex_state = 621, .external_lex_state = 25},
  [8976] = {.lex_state = 621, .external_lex_state = 25},
  [8977] = {.lex_state = 177, .external_lex_state = 4},
  [8978] = {.lex_state = 266, .external_lex_state = 15},
  [8979] = {.lex_state = 621, .external_lex_state = 25},
  [8980] = {.lex_state = 177, .external_lex_state = 4},
  [8981] = {.lex_state = 621, .external_lex_state = 25},
  [8982] = {.lex_state = 310},
  [8983] = {.lex_state = 621, .external_lex_state = 25},
  [8984] = {.lex_state = 621, .external_lex_state = 25},
  [8985] = {.lex_state = 128, .external_lex_state = 2},
  [8986] = {.lex_state = 128, .external_lex_state = 2},
  [8987] = {.lex_state = 621, .external_lex_state = 25},
  [8988] = {.lex_state = 621, .external_lex_state = 25},
  [8989] = {.lex_state = 627, .external_lex_state = 25},
  [8990] = {.lex_state = 621, .external_lex_state = 25},
  [8991] = {.lex_state = 209},
  [8992] = {.lex_state = 627, .external_lex_state = 25},
  [8993] = {.lex_state = 621, .external_lex_state = 25},
  [8994] = {.lex_state = 177, .external_lex_state = 17},
  [8995] = {.lex_state = 627, .external_lex_state = 25},
  [8996] = {.lex_state = 621, .external_lex_state = 25},
  [8997] = {.lex_state = 524, .external_lex_state = 21},
  [8998] = {.lex_state = 627, .external_lex_state = 25},
  [8999] = {.lex_state = 627, .external_lex_state = 25},
  [9000] = {.lex_state = 621, .external_lex_state = 25},
  [9001] = {.lex_state = 128},
  [9002] = {.lex_state = 128},
  [9003] = {.lex_state = 128, .external_lex_state = 2},
  [9004] = {.lex_state = 621, .external_lex_state = 25},
  [9005] = {.lex_state = 128},
  [9006] = {.lex_state = 128},
  [9007] = {.lex_state = 621, .external_lex_state = 25},
  [9008] = {.lex_state = 128},
  [9009] = {.lex_state = 621, .external_lex_state = 25},
  [9010] = {.lex_state = 128},
  [9011] = {.lex_state = 128, .external_lex_state = 2},
  [9012] = {.lex_state = 128},
  [9013] = {.lex_state = 128},
  [9014] = {.lex_state = 621, .external_lex_state = 25},
  [9015] = {.lex_state = 621, .external_lex_state = 25},
  [9016] = {.lex_state = 128},
  [9017] = {.lex_state = 128},
  [9018] = {.lex_state = 621, .external_lex_state = 25},
  [9019] = {.lex_state = 621, .external_lex_state = 25},
  [9020] = {.lex_state = 194},
  [9021] = {.lex_state = 621, .external_lex_state = 25},
  [9022] = {.lex_state = 128},
  [9023] = {.lex_state = 128, .external_lex_state = 2},
  [9024] = {.lex_state = 128, .external_lex_state = 12},
  [9025] = {.lex_state = 192, .external_lex_state = 2},
  [9026] = {.lex_state = 192, .external_lex_state = 29},
  [9027] = {.lex_state = 627, .external_lex_state = 25},
  [9028] = {.lex_state = 505, .external_lex_state = 25},
  [9029] = {.lex_state = 505, .external_lex_state = 25},
  [9030] = {.lex_state = 508, .external_lex_state = 25},
  [9031] = {.lex_state = 508, .external_lex_state = 25},
  [9032] = {.lex_state = 508, .external_lex_state = 25},
  [9033] = {.lex_state = 524, .external_lex_state = 21},
  [9034] = {.lex_state = 508, .external_lex_state = 25},
  [9035] = {.lex_state = 508, .external_lex_state = 25},
  [9036] = {.lex_state = 192, .external_lex_state = 2},
  [9037] = {.lex_state = 192, .external_lex_state = 29},
  [9038] = {.lex_state = 508, .external_lex_state = 25},
  [9039] = {.lex_state = 508, .external_lex_state = 25},
  [9040] = {.lex_state = 508, .external_lex_state = 25},
  [9041] = {.lex_state = 365, .external_lex_state = 3},
  [9042] = {.lex_state = 365, .external_lex_state = 3},
  [9043] = {.lex_state = 493, .external_lex_state = 25},
  [9044] = {.lex_state = 493, .external_lex_state = 25},
  [9045] = {.lex_state = 192, .external_lex_state = 2},
  [9046] = {.lex_state = 302, .external_lex_state = 25},
  [9047] = {.lex_state = 192, .external_lex_state = 29},
  [9048] = {.lex_state = 302, .external_lex_state = 25},
  [9049] = {.lex_state = 302, .external_lex_state = 25},
  [9050] = {.lex_state = 302, .external_lex_state = 25},
  [9051] = {.lex_state = 514, .external_lex_state = 11},
  [9052] = {.lex_state = 299, .external_lex_state = 3},
  [9053] = {.lex_state = 128},
  [9054] = {.lex_state = 361, .external_lex_state = 3},
  [9055] = {.lex_state = 361, .external_lex_state = 3},
  [9056] = {.lex_state = 192, .external_lex_state = 2},
  [9057] = {.lex_state = 192, .external_lex_state = 29},
  [9058] = {.lex_state = 361, .external_lex_state = 3},
  [9059] = {.lex_state = 361, .external_lex_state = 3},
  [9060] = {.lex_state = 361, .external_lex_state = 3},
  [9061] = {.lex_state = 361, .external_lex_state = 3},
  [9062] = {.lex_state = 361, .external_lex_state = 3},
  [9063] = {.lex_state = 361, .external_lex_state = 3},
  [9064] = {.lex_state = 361, .external_lex_state = 3},
  [9065] = {.lex_state = 192, .external_lex_state = 2},
  [9066] = {.lex_state = 192, .external_lex_state = 2},
  [9067] = {.lex_state = 192, .external_lex_state = 2},
  [9068] = {.lex_state = 192, .external_lex_state = 2},
  [9069] = {.lex_state = 192, .external_lex_state = 2},
  [9070] = {.lex_state = 192, .external_lex_state = 2},
  [9071] = {.lex_state = 192, .external_lex_state = 2},
  [9072] = {.lex_state = 192, .external_lex_state = 2},
  [9073] = {.lex_state = 192, .external_lex_state = 2},
  [9074] = {.lex_state = 192, .external_lex_state = 2},
  [9075] = {.lex_state = 192, .external_lex_state = 29},
  [9076] = {.lex_state = 192, .external_lex_state = 2},
  [9077] = {.lex_state = 365, .external_lex_state = 14},
  [9078] = {.lex_state = 361, .external_lex_state = 3},
  [9079] = {.lex_state = 361, .external_lex_state = 3},
  [9080] = {.lex_state = 361, .external_lex_state = 3},
  [9081] = {.lex_state = 192, .external_lex_state = 2},
  [9082] = {.lex_state = 361, .external_lex_state = 3},
  [9083] = {.lex_state = 192, .external_lex_state = 2},
  [9084] = {.lex_state = 361, .external_lex_state = 3},
  [9085] = {.lex_state = 524, .external_lex_state = 13},
  [9086] = {.lex_state = 361, .external_lex_state = 3},
  [9087] = {.lex_state = 361, .external_lex_state = 3},
  [9088] = {.lex_state = 361, .external_lex_state = 3},
  [9089] = {.lex_state = 361, .external_lex_state = 3},
  [9090] = {.lex_state = 361, .external_lex_state = 3},
  [9091] = {.lex_state = 361, .external_lex_state = 3},
  [9092] = {.lex_state = 361, .external_lex_state = 3},
  [9093] = {.lex_state = 554, .external_lex_state = 16},
  [9094] = {.lex_state = 361, .external_lex_state = 3},
  [9095] = {.lex_state = 361, .external_lex_state = 3},
  [9096] = {.lex_state = 361, .external_lex_state = 3},
  [9097] = {.lex_state = 361, .external_lex_state = 3},
  [9098] = {.lex_state = 421, .external_lex_state = 3},
  [9099] = {.lex_state = 421, .external_lex_state = 3},
  [9100] = {.lex_state = 192, .external_lex_state = 2},
  [9101] = {.lex_state = 421, .external_lex_state = 3},
  [9102] = {.lex_state = 192, .external_lex_state = 2},
  [9103] = {.lex_state = 421, .external_lex_state = 3},
  [9104] = {.lex_state = 524, .external_lex_state = 13},
  [9105] = {.lex_state = 421, .external_lex_state = 3},
  [9106] = {.lex_state = 262, .external_lex_state = 3},
  [9107] = {.lex_state = 524, .external_lex_state = 21},
  [9108] = {.lex_state = 262, .external_lex_state = 3},
  [9109] = {.lex_state = 361, .external_lex_state = 3},
  [9110] = {.lex_state = 361, .external_lex_state = 3},
  [9111] = {.lex_state = 361, .external_lex_state = 3},
  [9112] = {.lex_state = 361, .external_lex_state = 3},
  [9113] = {.lex_state = 361, .external_lex_state = 14},
  [9114] = {.lex_state = 128},
  [9115] = {.lex_state = 128},
  [9116] = {.lex_state = 254, .external_lex_state = 8},
  [9117] = {.lex_state = 128, .external_lex_state = 2},
  [9118] = {.lex_state = 192, .external_lex_state = 2},
  [9119] = {.lex_state = 424, .external_lex_state = 3},
  [9120] = {.lex_state = 424, .external_lex_state = 3},
  [9121] = {.lex_state = 192, .external_lex_state = 2},
  [9122] = {.lex_state = 192, .external_lex_state = 2},
  [9123] = {.lex_state = 192, .external_lex_state = 2},
  [9124] = {.lex_state = 192, .external_lex_state = 2},
  [9125] = {.lex_state = 192, .external_lex_state = 2},
  [9126] = {.lex_state = 192, .external_lex_state = 2},
  [9127] = {.lex_state = 192, .external_lex_state = 2},
  [9128] = {.lex_state = 192, .external_lex_state = 2},
  [9129] = {.lex_state = 192, .external_lex_state = 2},
  [9130] = {.lex_state = 192, .external_lex_state = 2},
  [9131] = {.lex_state = 192, .external_lex_state = 29},
  [9132] = {.lex_state = 192, .external_lex_state = 2},
  [9133] = {.lex_state = 424, .external_lex_state = 14},
  [9134] = {.lex_state = 424, .external_lex_state = 3},
  [9135] = {.lex_state = 424, .external_lex_state = 3},
  [9136] = {.lex_state = 421, .external_lex_state = 3},
  [9137] = {.lex_state = 421, .external_lex_state = 3},
  [9138] = {.lex_state = 421, .external_lex_state = 3},
  [9139] = {.lex_state = 421, .external_lex_state = 3},
  [9140] = {.lex_state = 421, .external_lex_state = 3},
  [9141] = {.lex_state = 554, .external_lex_state = 16},
  [9142] = {.lex_state = 421, .external_lex_state = 3},
  [9143] = {.lex_state = 421, .external_lex_state = 3},
  [9144] = {.lex_state = 421, .external_lex_state = 3},
  [9145] = {.lex_state = 421, .external_lex_state = 3},
  [9146] = {.lex_state = 424, .external_lex_state = 3},
  [9147] = {.lex_state = 524, .external_lex_state = 21},
  [9148] = {.lex_state = 424, .external_lex_state = 3},
  [9149] = {.lex_state = 424, .external_lex_state = 3},
  [9150] = {.lex_state = 421, .external_lex_state = 3},
  [9151] = {.lex_state = 421, .external_lex_state = 3},
  [9152] = {.lex_state = 421, .external_lex_state = 3},
  [9153] = {.lex_state = 421, .external_lex_state = 14},
  [9154] = {.lex_state = 528, .external_lex_state = 3},
  [9155] = {.lex_state = 528, .external_lex_state = 3},
  [9156] = {.lex_state = 528, .external_lex_state = 3},
  [9157] = {.lex_state = 192, .external_lex_state = 2},
  [9158] = {.lex_state = 192, .external_lex_state = 2},
  [9159] = {.lex_state = 192, .external_lex_state = 2},
  [9160] = {.lex_state = 192, .external_lex_state = 2},
  [9161] = {.lex_state = 192, .external_lex_state = 2},
  [9162] = {.lex_state = 192, .external_lex_state = 2},
  [9163] = {.lex_state = 192, .external_lex_state = 2},
  [9164] = {.lex_state = 192, .external_lex_state = 2},
  [9165] = {.lex_state = 192, .external_lex_state = 2},
  [9166] = {.lex_state = 192, .external_lex_state = 2},
  [9167] = {.lex_state = 192, .external_lex_state = 29},
  [9168] = {.lex_state = 528, .external_lex_state = 3},
  [9169] = {.lex_state = 192, .external_lex_state = 29},
  [9170] = {.lex_state = 192, .external_lex_state = 2},
  [9171] = {.lex_state = 156, .external_lex_state = 3},
  [9172] = {.lex_state = 192, .external_lex_state = 2},
  [9173] = {.lex_state = 192, .external_lex_state = 29},
  [9174] = {.lex_state = 424, .external_lex_state = 3},
  [9175] = {.lex_state = 421, .external_lex_state = 3},
  [9176] = {.lex_state = 421, .external_lex_state = 3},
  [9177] = {.lex_state = 192, .external_lex_state = 2},
  [9178] = {.lex_state = 361, .external_lex_state = 3},
  [9179] = {.lex_state = 361, .external_lex_state = 3},
  [9180] = {.lex_state = 361, .external_lex_state = 3},
  [9181] = {.lex_state = 361, .external_lex_state = 3},
  [9182] = {.lex_state = 192, .external_lex_state = 2},
  [9183] = {.lex_state = 192, .external_lex_state = 2},
  [9184] = {.lex_state = 192, .external_lex_state = 2},
  [9185] = {.lex_state = 192, .external_lex_state = 2},
  [9186] = {.lex_state = 192, .external_lex_state = 2},
  [9187] = {.lex_state = 192, .external_lex_state = 2},
  [9188] = {.lex_state = 192, .external_lex_state = 2},
  [9189] = {.lex_state = 192, .external_lex_state = 2},
  [9190] = {.lex_state = 192, .external_lex_state = 2},
  [9191] = {.lex_state = 192, .external_lex_state = 2},
  [9192] = {.lex_state = 192, .external_lex_state = 29},
  [9193] = {.lex_state = 192, .external_lex_state = 2},
  [9194] = {.lex_state = 365, .external_lex_state = 14},
  [9195] = {.lex_state = 361, .external_lex_state = 3},
  [9196] = {.lex_state = 361, .external_lex_state = 3},
  [9197] = {.lex_state = 361, .external_lex_state = 3},
  [9198] = {.lex_state = 192, .external_lex_state = 2},
  [9199] = {.lex_state = 361, .external_lex_state = 3},
  [9200] = {.lex_state = 192, .external_lex_state = 2},
  [9201] = {.lex_state = 361, .external_lex_state = 3},
  [9202] = {.lex_state = 524, .external_lex_state = 13},
  [9203] = {.lex_state = 361, .external_lex_state = 3},
  [9204] = {.lex_state = 361, .external_lex_state = 3},
  [9205] = {.lex_state = 361, .external_lex_state = 3},
  [9206] = {.lex_state = 361, .external_lex_state = 3},
  [9207] = {.lex_state = 361, .external_lex_state = 3},
  [9208] = {.lex_state = 361, .external_lex_state = 3},
  [9209] = {.lex_state = 361, .external_lex_state = 3},
  [9210] = {.lex_state = 554, .external_lex_state = 16},
  [9211] = {.lex_state = 361, .external_lex_state = 3},
  [9212] = {.lex_state = 361, .external_lex_state = 3},
  [9213] = {.lex_state = 361, .external_lex_state = 3},
  [9214] = {.lex_state = 361, .external_lex_state = 3},
  [9215] = {.lex_state = 421, .external_lex_state = 3},
  [9216] = {.lex_state = 421, .external_lex_state = 3},
  [9217] = {.lex_state = 192, .external_lex_state = 2},
  [9218] = {.lex_state = 421, .external_lex_state = 3},
  [9219] = {.lex_state = 192, .external_lex_state = 2},
  [9220] = {.lex_state = 421, .external_lex_state = 3},
  [9221] = {.lex_state = 524, .external_lex_state = 13},
  [9222] = {.lex_state = 421, .external_lex_state = 3},
  [9223] = {.lex_state = 262, .external_lex_state = 3},
  [9224] = {.lex_state = 524, .external_lex_state = 21},
  [9225] = {.lex_state = 262, .external_lex_state = 3},
  [9226] = {.lex_state = 361, .external_lex_state = 3},
  [9227] = {.lex_state = 361, .external_lex_state = 3},
  [9228] = {.lex_state = 361, .external_lex_state = 3},
  [9229] = {.lex_state = 361, .external_lex_state = 3},
  [9230] = {.lex_state = 361, .external_lex_state = 14},
  [9231] = {.lex_state = 254, .external_lex_state = 8},
  [9232] = {.lex_state = 128, .external_lex_state = 2},
  [9233] = {.lex_state = 192, .external_lex_state = 2},
  [9234] = {.lex_state = 424, .external_lex_state = 3},
  [9235] = {.lex_state = 424, .external_lex_state = 3},
  [9236] = {.lex_state = 192, .external_lex_state = 2},
  [9237] = {.lex_state = 192, .external_lex_state = 2},
  [9238] = {.lex_state = 192, .external_lex_state = 2},
  [9239] = {.lex_state = 192, .external_lex_state = 2},
  [9240] = {.lex_state = 192, .external_lex_state = 2},
  [9241] = {.lex_state = 192, .external_lex_state = 2},
  [9242] = {.lex_state = 192, .external_lex_state = 2},
  [9243] = {.lex_state = 192, .external_lex_state = 2},
  [9244] = {.lex_state = 192, .external_lex_state = 2},
  [9245] = {.lex_state = 192, .external_lex_state = 2},
  [9246] = {.lex_state = 192, .external_lex_state = 29},
  [9247] = {.lex_state = 192, .external_lex_state = 2},
  [9248] = {.lex_state = 424, .external_lex_state = 14},
  [9249] = {.lex_state = 424, .external_lex_state = 3},
  [9250] = {.lex_state = 424, .external_lex_state = 3},
  [9251] = {.lex_state = 421, .external_lex_state = 3},
  [9252] = {.lex_state = 421, .external_lex_state = 3},
  [9253] = {.lex_state = 421, .external_lex_state = 3},
  [9254] = {.lex_state = 421, .external_lex_state = 3},
  [9255] = {.lex_state = 421, .external_lex_state = 3},
  [9256] = {.lex_state = 554, .external_lex_state = 16},
  [9257] = {.lex_state = 421, .external_lex_state = 3},
  [9258] = {.lex_state = 421, .external_lex_state = 3},
  [9259] = {.lex_state = 421, .external_lex_state = 3},
  [9260] = {.lex_state = 421, .external_lex_state = 3},
  [9261] = {.lex_state = 424, .external_lex_state = 3},
  [9262] = {.lex_state = 524, .external_lex_state = 21},
  [9263] = {.lex_state = 424, .external_lex_state = 3},
  [9264] = {.lex_state = 424, .external_lex_state = 3},
  [9265] = {.lex_state = 421, .external_lex_state = 3},
  [9266] = {.lex_state = 421, .external_lex_state = 3},
  [9267] = {.lex_state = 421, .external_lex_state = 3},
  [9268] = {.lex_state = 421, .external_lex_state = 14},
  [9269] = {.lex_state = 528, .external_lex_state = 3},
  [9270] = {.lex_state = 528, .external_lex_state = 3},
  [9271] = {.lex_state = 528, .external_lex_state = 3},
  [9272] = {.lex_state = 192, .external_lex_state = 2},
  [9273] = {.lex_state = 192, .external_lex_state = 2},
  [9274] = {.lex_state = 192, .external_lex_state = 2},
  [9275] = {.lex_state = 192, .external_lex_state = 2},
  [9276] = {.lex_state = 192, .external_lex_state = 2},
  [9277] = {.lex_state = 192, .external_lex_state = 2},
  [9278] = {.lex_state = 192, .external_lex_state = 2},
  [9279] = {.lex_state = 192, .external_lex_state = 2},
  [9280] = {.lex_state = 192, .external_lex_state = 2},
  [9281] = {.lex_state = 192, .external_lex_state = 2},
  [9282] = {.lex_state = 192, .external_lex_state = 29},
  [9283] = {.lex_state = 528, .external_lex_state = 3},
  [9284] = {.lex_state = 192, .external_lex_state = 29},
  [9285] = {.lex_state = 192, .external_lex_state = 2},
  [9286] = {.lex_state = 361, .external_lex_state = 3},
  [9287] = {.lex_state = 361, .external_lex_state = 3},
  [9288] = {.lex_state = 192, .external_lex_state = 2},
  [9289] = {.lex_state = 192, .external_lex_state = 29},
  [9290] = {.lex_state = 361, .external_lex_state = 3},
  [9291] = {.lex_state = 361, .external_lex_state = 3},
  [9292] = {.lex_state = 361, .external_lex_state = 3},
  [9293] = {.lex_state = 192, .external_lex_state = 2},
  [9294] = {.lex_state = 192, .external_lex_state = 29},
  [9295] = {.lex_state = 424, .external_lex_state = 3},
  [9296] = {.lex_state = 421, .external_lex_state = 3},
  [9297] = {.lex_state = 421, .external_lex_state = 3},
  [9298] = {.lex_state = 192, .external_lex_state = 2},
  [9299] = {.lex_state = 508, .external_lex_state = 25},
  [9300] = {.lex_state = 508, .external_lex_state = 25},
  [9301] = {.lex_state = 508, .external_lex_state = 25},
  [9302] = {.lex_state = 524, .external_lex_state = 21},
  [9303] = {.lex_state = 508, .external_lex_state = 25},
  [9304] = {.lex_state = 508, .external_lex_state = 25},
  [9305] = {.lex_state = 192, .external_lex_state = 2},
  [9306] = {.lex_state = 424, .external_lex_state = 25},
  [9307] = {.lex_state = 424, .external_lex_state = 25},
  [9308] = {.lex_state = 192, .external_lex_state = 2},
  [9309] = {.lex_state = 192, .external_lex_state = 2},
  [9310] = {.lex_state = 192, .external_lex_state = 2},
  [9311] = {.lex_state = 192, .external_lex_state = 2},
  [9312] = {.lex_state = 192, .external_lex_state = 2},
  [9313] = {.lex_state = 192, .external_lex_state = 2},
  [9314] = {.lex_state = 192, .external_lex_state = 2},
  [9315] = {.lex_state = 192, .external_lex_state = 2},
  [9316] = {.lex_state = 192, .external_lex_state = 2},
  [9317] = {.lex_state = 192, .external_lex_state = 2},
  [9318] = {.lex_state = 192, .external_lex_state = 29},
  [9319] = {.lex_state = 192, .external_lex_state = 2},
  [9320] = {.lex_state = 424, .external_lex_state = 27},
  [9321] = {.lex_state = 424, .external_lex_state = 25},
  [9322] = {.lex_state = 424, .external_lex_state = 25},
  [9323] = {.lex_state = 424, .external_lex_state = 25},
  [9324] = {.lex_state = 524, .external_lex_state = 21},
  [9325] = {.lex_state = 424, .external_lex_state = 25},
  [9326] = {.lex_state = 424, .external_lex_state = 25},
  [9327] = {.lex_state = 192, .external_lex_state = 29},
  [9328] = {.lex_state = 508, .external_lex_state = 25},
  [9329] = {.lex_state = 508, .external_lex_state = 25},
  [9330] = {.lex_state = 192, .external_lex_state = 2},
  [9331] = {.lex_state = 192, .external_lex_state = 29},
  [9332] = {.lex_state = 421, .external_lex_state = 25},
  [9333] = {.lex_state = 508, .external_lex_state = 25},
  [9334] = {.lex_state = 361, .external_lex_state = 3},
  [9335] = {.lex_state = 361, .external_lex_state = 3},
  [9336] = {.lex_state = 192, .external_lex_state = 2},
  [9337] = {.lex_state = 192, .external_lex_state = 29},
  [9338] = {.lex_state = 361, .external_lex_state = 3},
  [9339] = {.lex_state = 361, .external_lex_state = 3},
  [9340] = {.lex_state = 361, .external_lex_state = 3},
  [9341] = {.lex_state = 192, .external_lex_state = 2},
  [9342] = {.lex_state = 361, .external_lex_state = 3},
  [9343] = {.lex_state = 361, .external_lex_state = 3},
  [9344] = {.lex_state = 192, .external_lex_state = 2},
  [9345] = {.lex_state = 192, .external_lex_state = 2},
  [9346] = {.lex_state = 192, .external_lex_state = 2},
  [9347] = {.lex_state = 192, .external_lex_state = 2},
  [9348] = {.lex_state = 192, .external_lex_state = 2},
  [9349] = {.lex_state = 192, .external_lex_state = 2},
  [9350] = {.lex_state = 192, .external_lex_state = 2},
  [9351] = {.lex_state = 192, .external_lex_state = 2},
  [9352] = {.lex_state = 192, .external_lex_state = 2},
  [9353] = {.lex_state = 192, .external_lex_state = 2},
  [9354] = {.lex_state = 192, .external_lex_state = 29},
  [9355] = {.lex_state = 192, .external_lex_state = 2},
  [9356] = {.lex_state = 361, .external_lex_state = 3},
  [9357] = {.lex_state = 361, .external_lex_state = 3},
  [9358] = {.lex_state = 361, .external_lex_state = 3},
  [9359] = {.lex_state = 524, .external_lex_state = 21},
  [9360] = {.lex_state = 361, .external_lex_state = 3},
  [9361] = {.lex_state = 361, .external_lex_state = 3},
  [9362] = {.lex_state = 247, .external_lex_state = 3},
  [9363] = {.lex_state = 192, .external_lex_state = 2},
  [9364] = {.lex_state = 192, .external_lex_state = 2},
  [9365] = {.lex_state = 192, .external_lex_state = 2},
  [9366] = {.lex_state = 237},
  [9367] = {.lex_state = 192, .external_lex_state = 2},
  [9368] = {.lex_state = 353, .external_lex_state = 11},
  [9369] = {.lex_state = 353, .external_lex_state = 11},
  [9370] = {.lex_state = 353, .external_lex_state = 11},
  [9371] = {.lex_state = 353, .external_lex_state = 11},
  [9372] = {.lex_state = 192, .external_lex_state = 2},
  [9373] = {.lex_state = 192, .external_lex_state = 2},
  [9374] = {.lex_state = 358, .external_lex_state = 11},
  [9375] = {.lex_state = 361, .external_lex_state = 3},
  [9376] = {.lex_state = 364, .external_lex_state = 11},
  [9377] = {.lex_state = 262, .external_lex_state = 3},
  [9378] = {.lex_state = 361, .external_lex_state = 3},
  [9379] = {.lex_state = 213},
  [9380] = {.lex_state = 368, .external_lex_state = 3},
  [9381] = {.lex_state = 371, .external_lex_state = 14},
  [9382] = {.lex_state = 247, .external_lex_state = 3},
  [9383] = {.lex_state = 254, .external_lex_state = 8},
  [9384] = {.lex_state = 128},
  [9385] = {.lex_state = 128, .external_lex_state = 2},
  [9386] = {.lex_state = 128, .external_lex_state = 8},
  [9387] = {.lex_state = 192, .external_lex_state = 2},
  [9388] = {.lex_state = 192, .external_lex_state = 2},
  [9389] = {.lex_state = 192, .external_lex_state = 2},
  [9390] = {.lex_state = 192, .external_lex_state = 2},
  [9391] = {.lex_state = 192, .external_lex_state = 2},
  [9392] = {.lex_state = 192, .external_lex_state = 2},
  [9393] = {.lex_state = 192, .external_lex_state = 2},
  [9394] = {.lex_state = 192, .external_lex_state = 2},
  [9395] = {.lex_state = 192, .external_lex_state = 2},
  [9396] = {.lex_state = 192, .external_lex_state = 2},
  [9397] = {.lex_state = 192, .external_lex_state = 2},
  [9398] = {.lex_state = 192, .external_lex_state = 2},
  [9399] = {.lex_state = 192, .external_lex_state = 2},
  [9400] = {.lex_state = 192, .external_lex_state = 2},
  [9401] = {.lex_state = 192, .external_lex_state = 2},
  [9402] = {.lex_state = 192, .external_lex_state = 2},
  [9403] = {.lex_state = 192, .external_lex_state = 2},
  [9404] = {.lex_state = 192, .external_lex_state = 2},
  [9405] = {.lex_state = 237},
  [9406] = {.lex_state = 192, .external_lex_state = 2},
  [9407] = {.lex_state = 364, .external_lex_state = 11},
  [9408] = {.lex_state = 364, .external_lex_state = 11},
  [9409] = {.lex_state = 364, .external_lex_state = 11},
  [9410] = {.lex_state = 364, .external_lex_state = 11},
  [9411] = {.lex_state = 192, .external_lex_state = 2},
  [9412] = {.lex_state = 192, .external_lex_state = 2},
  [9413] = {.lex_state = 358, .external_lex_state = 11},
  [9414] = {.lex_state = 421, .external_lex_state = 3},
  [9415] = {.lex_state = 364, .external_lex_state = 11},
  [9416] = {.lex_state = 424, .external_lex_state = 3},
  [9417] = {.lex_state = 424, .external_lex_state = 3},
  [9418] = {.lex_state = 213},
  [9419] = {.lex_state = 421, .external_lex_state = 3},
  [9420] = {.lex_state = 427, .external_lex_state = 14},
  [9421] = {.lex_state = 192, .external_lex_state = 29},
  [9422] = {.lex_state = 192, .external_lex_state = 2},
  [9423] = {.lex_state = 262, .external_lex_state = 14},
  [9424] = {.lex_state = 128},
  [9425] = {.lex_state = 192, .external_lex_state = 2},
  [9426] = {.lex_state = 424, .external_lex_state = 3},
  [9427] = {.lex_state = 424, .external_lex_state = 3},
  [9428] = {.lex_state = 192, .external_lex_state = 2},
  [9429] = {.lex_state = 192, .external_lex_state = 2},
  [9430] = {.lex_state = 192, .external_lex_state = 2},
  [9431] = {.lex_state = 192, .external_lex_state = 2},
  [9432] = {.lex_state = 192, .external_lex_state = 2},
  [9433] = {.lex_state = 192, .external_lex_state = 2},
  [9434] = {.lex_state = 192, .external_lex_state = 2},
  [9435] = {.lex_state = 192, .external_lex_state = 2},
  [9436] = {.lex_state = 192, .external_lex_state = 2},
  [9437] = {.lex_state = 192, .external_lex_state = 2},
  [9438] = {.lex_state = 192, .external_lex_state = 29},
  [9439] = {.lex_state = 192, .external_lex_state = 2},
  [9440] = {.lex_state = 424, .external_lex_state = 14},
  [9441] = {.lex_state = 424, .external_lex_state = 3},
  [9442] = {.lex_state = 424, .external_lex_state = 3},
  [9443] = {.lex_state = 424, .external_lex_state = 3},
  [9444] = {.lex_state = 524, .external_lex_state = 21},
  [9445] = {.lex_state = 424, .external_lex_state = 3},
  [9446] = {.lex_state = 424, .external_lex_state = 3},
  [9447] = {.lex_state = 528, .external_lex_state = 3},
  [9448] = {.lex_state = 192, .external_lex_state = 29},
  [9449] = {.lex_state = 528, .external_lex_state = 3},
  [9450] = {.lex_state = 361, .external_lex_state = 3},
  [9451] = {.lex_state = 361, .external_lex_state = 3},
  [9452] = {.lex_state = 192, .external_lex_state = 2},
  [9453] = {.lex_state = 192, .external_lex_state = 29},
  [9454] = {.lex_state = 361, .external_lex_state = 3},
  [9455] = {.lex_state = 361, .external_lex_state = 3},
  [9456] = {.lex_state = 361, .external_lex_state = 3},
  [9457] = {.lex_state = 192, .external_lex_state = 2},
  [9458] = {.lex_state = 192, .external_lex_state = 29},
  [9459] = {.lex_state = 361, .external_lex_state = 3},
  [9460] = {.lex_state = 350, .external_lex_state = 23},
  [9461] = {.lex_state = 209, .external_lex_state = 19},
  [9462] = {.lex_state = 209},
  [9463] = {.lex_state = 350, .external_lex_state = 23},
  [9464] = {.lex_state = 343, .external_lex_state = 8},
  [9465] = {.lex_state = 235},
  [9466] = {.lex_state = 508, .external_lex_state = 3},
  [9467] = {.lex_state = 192, .external_lex_state = 2},
  [9468] = {.lex_state = 192, .external_lex_state = 2},
  [9469] = {.lex_state = 237},
  [9470] = {.lex_state = 192, .external_lex_state = 2},
  [9471] = {.lex_state = 358, .external_lex_state = 11},
  [9472] = {.lex_state = 508, .external_lex_state = 3},
  [9473] = {.lex_state = 508, .external_lex_state = 3},
  [9474] = {.lex_state = 508, .external_lex_state = 3},
  [9475] = {.lex_state = 508, .external_lex_state = 14},
  [9476] = {.lex_state = 508, .external_lex_state = 3},
  [9477] = {.lex_state = 192, .external_lex_state = 2},
  [9478] = {.lex_state = 192, .external_lex_state = 2},
  [9479] = {.lex_state = 192, .external_lex_state = 2},
  [9480] = {.lex_state = 192, .external_lex_state = 2},
  [9481] = {.lex_state = 192, .external_lex_state = 2},
  [9482] = {.lex_state = 192, .external_lex_state = 2},
  [9483] = {.lex_state = 192, .external_lex_state = 2},
  [9484] = {.lex_state = 192, .external_lex_state = 2},
  [9485] = {.lex_state = 192, .external_lex_state = 2},
  [9486] = {.lex_state = 192, .external_lex_state = 2},
  [9487] = {.lex_state = 192, .external_lex_state = 29},
  [9488] = {.lex_state = 192, .external_lex_state = 2},
  [9489] = {.lex_state = 631, .external_lex_state = 14},
  [9490] = {.lex_state = 508, .external_lex_state = 3},
  [9491] = {.lex_state = 508, .external_lex_state = 3},
  [9492] = {.lex_state = 508, .external_lex_state = 3},
  [9493] = {.lex_state = 192, .external_lex_state = 2},
  [9494] = {.lex_state = 508, .external_lex_state = 3},
  [9495] = {.lex_state = 192, .external_lex_state = 2},
  [9496] = {.lex_state = 508, .external_lex_state = 3},
  [9497] = {.lex_state = 524, .external_lex_state = 13},
  [9498] = {.lex_state = 508, .external_lex_state = 3},
  [9499] = {.lex_state = 343, .external_lex_state = 8},
  [9500] = {.lex_state = 209},
  [9501] = {.lex_state = 508, .external_lex_state = 3},
  [9502] = {.lex_state = 508, .external_lex_state = 3},
  [9503] = {.lex_state = 508, .external_lex_state = 3},
  [9504] = {.lex_state = 508, .external_lex_state = 3},
  [9505] = {.lex_state = 508, .external_lex_state = 3},
  [9506] = {.lex_state = 508, .external_lex_state = 3},
  [9507] = {.lex_state = 554, .external_lex_state = 16},
  [9508] = {.lex_state = 508, .external_lex_state = 3},
  [9509] = {.lex_state = 508, .external_lex_state = 3},
  [9510] = {.lex_state = 508, .external_lex_state = 3},
  [9511] = {.lex_state = 508, .external_lex_state = 3},
  [9512] = {.lex_state = 343, .external_lex_state = 8},
  [9513] = {.lex_state = 177, .external_lex_state = 17},
  [9514] = {.lex_state = 343, .external_lex_state = 8},
  [9515] = {.lex_state = 678, .external_lex_state = 8},
  [9516] = {.lex_state = 524, .external_lex_state = 21},
  [9517] = {.lex_state = 343, .external_lex_state = 8},
  [9518] = {.lex_state = 678, .external_lex_state = 8},
  [9519] = {.lex_state = 508, .external_lex_state = 3},
  [9520] = {.lex_state = 508, .external_lex_state = 3},
  [9521] = {.lex_state = 508, .external_lex_state = 3},
  [9522] = {.lex_state = 634, .external_lex_state = 14},
  [9523] = {.lex_state = 128},
  [9524] = {.lex_state = 528, .external_lex_state = 3},
  [9525] = {.lex_state = 192, .external_lex_state = 2},
  [9526] = {.lex_state = 192, .external_lex_state = 29},
  [9527] = {.lex_state = 421, .external_lex_state = 3},
  [9528] = {.lex_state = 528, .external_lex_state = 3},
  [9529] = {.lex_state = 361, .external_lex_state = 3},
  [9530] = {.lex_state = 361, .external_lex_state = 3},
  [9531] = {.lex_state = 361, .external_lex_state = 3},
  [9532] = {.lex_state = 361, .external_lex_state = 3},
  [9533] = {.lex_state = 361, .external_lex_state = 3},
  [9534] = {.lex_state = 361, .external_lex_state = 3},
  [9535] = {.lex_state = 361, .external_lex_state = 3},
  [9536] = {.lex_state = 554, .external_lex_state = 16},
  [9537] = {.lex_state = 361, .external_lex_state = 3},
  [9538] = {.lex_state = 361, .external_lex_state = 3},
  [9539] = {.lex_state = 361, .external_lex_state = 3},
  [9540] = {.lex_state = 361, .external_lex_state = 3},
  [9541] = {.lex_state = 361, .external_lex_state = 3},
  [9542] = {.lex_state = 361, .external_lex_state = 3},
  [9543] = {.lex_state = 361, .external_lex_state = 3},
  [9544] = {.lex_state = 365, .external_lex_state = 14},
  [9545] = {.lex_state = 361, .external_lex_state = 3},
  [9546] = {.lex_state = 361, .external_lex_state = 3},
  [9547] = {.lex_state = 361, .external_lex_state = 3},
  [9548] = {.lex_state = 524, .external_lex_state = 21},
  [9549] = {.lex_state = 361, .external_lex_state = 3},
  [9550] = {.lex_state = 361, .external_lex_state = 3},
  [9551] = {.lex_state = 192, .external_lex_state = 2},
  [9552] = {.lex_state = 421, .external_lex_state = 3},
  [9553] = {.lex_state = 421, .external_lex_state = 3},
  [9554] = {.lex_state = 421, .external_lex_state = 3},
  [9555] = {.lex_state = 524, .external_lex_state = 21},
  [9556] = {.lex_state = 421, .external_lex_state = 3},
  [9557] = {.lex_state = 421, .external_lex_state = 3},
  [9558] = {.lex_state = 192, .external_lex_state = 29},
  [9559] = {.lex_state = 361, .external_lex_state = 3},
  [9560] = {.lex_state = 247, .external_lex_state = 3},
  [9561] = {.lex_state = 424, .external_lex_state = 3},
  [9562] = {.lex_state = 424, .external_lex_state = 3},
  [9563] = {.lex_state = 424, .external_lex_state = 3},
  [9564] = {.lex_state = 424, .external_lex_state = 3},
  [9565] = {.lex_state = 424, .external_lex_state = 3},
  [9566] = {.lex_state = 554, .external_lex_state = 16},
  [9567] = {.lex_state = 424, .external_lex_state = 3},
  [9568] = {.lex_state = 424, .external_lex_state = 3},
  [9569] = {.lex_state = 424, .external_lex_state = 3},
  [9570] = {.lex_state = 424, .external_lex_state = 3},
  [9571] = {.lex_state = 424, .external_lex_state = 3},
  [9572] = {.lex_state = 424, .external_lex_state = 3},
  [9573] = {.lex_state = 424, .external_lex_state = 3},
  [9574] = {.lex_state = 424, .external_lex_state = 14},
  [9575] = {.lex_state = 192, .external_lex_state = 2},
  [9576] = {.lex_state = 192, .external_lex_state = 29},
  [9577] = {.lex_state = 421, .external_lex_state = 3},
  [9578] = {.lex_state = 528, .external_lex_state = 3},
  [9579] = {.lex_state = 528, .external_lex_state = 3},
  [9580] = {.lex_state = 528, .external_lex_state = 3},
  [9581] = {.lex_state = 528, .external_lex_state = 3},
  [9582] = {.lex_state = 528, .external_lex_state = 3},
  [9583] = {.lex_state = 554, .external_lex_state = 16},
  [9584] = {.lex_state = 528, .external_lex_state = 3},
  [9585] = {.lex_state = 528, .external_lex_state = 3},
  [9586] = {.lex_state = 528, .external_lex_state = 3},
  [9587] = {.lex_state = 528, .external_lex_state = 3},
  [9588] = {.lex_state = 528, .external_lex_state = 3},
  [9589] = {.lex_state = 528, .external_lex_state = 3},
  [9590] = {.lex_state = 528, .external_lex_state = 3},
  [9591] = {.lex_state = 361, .external_lex_state = 3},
  [9592] = {.lex_state = 361, .external_lex_state = 3},
  [9593] = {.lex_state = 361, .external_lex_state = 3},
  [9594] = {.lex_state = 361, .external_lex_state = 3},
  [9595] = {.lex_state = 361, .external_lex_state = 3},
  [9596] = {.lex_state = 361, .external_lex_state = 3},
  [9597] = {.lex_state = 361, .external_lex_state = 3},
  [9598] = {.lex_state = 554, .external_lex_state = 16},
  [9599] = {.lex_state = 361, .external_lex_state = 3},
  [9600] = {.lex_state = 361, .external_lex_state = 3},
  [9601] = {.lex_state = 361, .external_lex_state = 3},
  [9602] = {.lex_state = 361, .external_lex_state = 3},
  [9603] = {.lex_state = 361, .external_lex_state = 3},
  [9604] = {.lex_state = 361, .external_lex_state = 3},
  [9605] = {.lex_state = 361, .external_lex_state = 3},
  [9606] = {.lex_state = 365, .external_lex_state = 14},
  [9607] = {.lex_state = 361, .external_lex_state = 3},
  [9608] = {.lex_state = 361, .external_lex_state = 3},
  [9609] = {.lex_state = 361, .external_lex_state = 3},
  [9610] = {.lex_state = 524, .external_lex_state = 21},
  [9611] = {.lex_state = 361, .external_lex_state = 3},
  [9612] = {.lex_state = 361, .external_lex_state = 3},
  [9613] = {.lex_state = 192, .external_lex_state = 2},
  [9614] = {.lex_state = 421, .external_lex_state = 3},
  [9615] = {.lex_state = 421, .external_lex_state = 3},
  [9616] = {.lex_state = 421, .external_lex_state = 3},
  [9617] = {.lex_state = 524, .external_lex_state = 21},
  [9618] = {.lex_state = 421, .external_lex_state = 3},
  [9619] = {.lex_state = 421, .external_lex_state = 3},
  [9620] = {.lex_state = 192, .external_lex_state = 29},
  [9621] = {.lex_state = 361, .external_lex_state = 3},
  [9622] = {.lex_state = 247, .external_lex_state = 3},
  [9623] = {.lex_state = 424, .external_lex_state = 3},
  [9624] = {.lex_state = 424, .external_lex_state = 3},
  [9625] = {.lex_state = 424, .external_lex_state = 3},
  [9626] = {.lex_state = 424, .external_lex_state = 3},
  [9627] = {.lex_state = 424, .external_lex_state = 3},
  [9628] = {.lex_state = 554, .external_lex_state = 16},
  [9629] = {.lex_state = 424, .external_lex_state = 3},
  [9630] = {.lex_state = 424, .external_lex_state = 3},
  [9631] = {.lex_state = 424, .external_lex_state = 3},
  [9632] = {.lex_state = 424, .external_lex_state = 3},
  [9633] = {.lex_state = 424, .external_lex_state = 3},
  [9634] = {.lex_state = 424, .external_lex_state = 3},
  [9635] = {.lex_state = 424, .external_lex_state = 3},
  [9636] = {.lex_state = 424, .external_lex_state = 14},
  [9637] = {.lex_state = 192, .external_lex_state = 2},
  [9638] = {.lex_state = 192, .external_lex_state = 29},
  [9639] = {.lex_state = 421, .external_lex_state = 3},
  [9640] = {.lex_state = 528, .external_lex_state = 3},
  [9641] = {.lex_state = 528, .external_lex_state = 3},
  [9642] = {.lex_state = 528, .external_lex_state = 3},
  [9643] = {.lex_state = 528, .external_lex_state = 3},
  [9644] = {.lex_state = 528, .external_lex_state = 3},
  [9645] = {.lex_state = 554, .external_lex_state = 16},
  [9646] = {.lex_state = 528, .external_lex_state = 3},
  [9647] = {.lex_state = 528, .external_lex_state = 3},
  [9648] = {.lex_state = 528, .external_lex_state = 3},
  [9649] = {.lex_state = 528, .external_lex_state = 3},
  [9650] = {.lex_state = 528, .external_lex_state = 3},
  [9651] = {.lex_state = 528, .external_lex_state = 3},
  [9652] = {.lex_state = 528, .external_lex_state = 3},
  [9653] = {.lex_state = 192, .external_lex_state = 2},
  [9654] = {.lex_state = 192, .external_lex_state = 29},
  [9655] = {.lex_state = 424, .external_lex_state = 3},
  [9656] = {.lex_state = 421, .external_lex_state = 3},
  [9657] = {.lex_state = 421, .external_lex_state = 3},
  [9658] = {.lex_state = 192, .external_lex_state = 2},
  [9659] = {.lex_state = 388, .external_lex_state = 25},
  [9660] = {.lex_state = 388, .external_lex_state = 25},
  [9661] = {.lex_state = 406, .external_lex_state = 25},
  [9662] = {.lex_state = 406, .external_lex_state = 25},
  [9663] = {.lex_state = 406, .external_lex_state = 25},
  [9664] = {.lex_state = 406, .external_lex_state = 25},
  [9665] = {.lex_state = 406, .external_lex_state = 25},
  [9666] = {.lex_state = 554, .external_lex_state = 16},
  [9667] = {.lex_state = 406, .external_lex_state = 25},
  [9668] = {.lex_state = 406, .external_lex_state = 25},
  [9669] = {.lex_state = 406, .external_lex_state = 25},
  [9670] = {.lex_state = 406, .external_lex_state = 25},
  [9671] = {.lex_state = 406, .external_lex_state = 25},
  [9672] = {.lex_state = 406, .external_lex_state = 25},
  [9673] = {.lex_state = 406, .external_lex_state = 25},
  [9674] = {.lex_state = 400, .external_lex_state = 25},
  [9675] = {.lex_state = 537, .external_lex_state = 25},
  [9676] = {.lex_state = 537, .external_lex_state = 25},
  [9677] = {.lex_state = 537, .external_lex_state = 25},
  [9678] = {.lex_state = 537, .external_lex_state = 25},
  [9679] = {.lex_state = 537, .external_lex_state = 25},
  [9680] = {.lex_state = 554, .external_lex_state = 16},
  [9681] = {.lex_state = 537, .external_lex_state = 25},
  [9682] = {.lex_state = 537, .external_lex_state = 25},
  [9683] = {.lex_state = 537, .external_lex_state = 25},
  [9684] = {.lex_state = 537, .external_lex_state = 25},
  [9685] = {.lex_state = 537, .external_lex_state = 25},
  [9686] = {.lex_state = 537, .external_lex_state = 25},
  [9687] = {.lex_state = 537, .external_lex_state = 25},
  [9688] = {.lex_state = 537, .external_lex_state = 27},
  [9689] = {.lex_state = 400, .external_lex_state = 25},
  [9690] = {.lex_state = 388, .external_lex_state = 25},
  [9691] = {.lex_state = 406, .external_lex_state = 25},
  [9692] = {.lex_state = 406, .external_lex_state = 25},
  [9693] = {.lex_state = 388, .external_lex_state = 25},
  [9694] = {.lex_state = 128},
  [9695] = {.lex_state = 388, .external_lex_state = 25},
  [9696] = {.lex_state = 388, .external_lex_state = 25},
  [9697] = {.lex_state = 388, .external_lex_state = 25},
  [9698] = {.lex_state = 388, .external_lex_state = 25},
  [9699] = {.lex_state = 388, .external_lex_state = 25},
  [9700] = {.lex_state = 128},
  [9701] = {.lex_state = 544, .external_lex_state = 26},
  [9702] = {.lex_state = 397, .external_lex_state = 25},
  [9703] = {.lex_state = 128},
  [9704] = {.lex_state = 403, .external_lex_state = 25},
  [9705] = {.lex_state = 403, .external_lex_state = 25},
  [9706] = {.lex_state = 286, .external_lex_state = 2},
  [9707] = {.lex_state = 237},
  [9708] = {.lex_state = 237},
  [9709] = {.lex_state = 237},
  [9710] = {.lex_state = 302, .external_lex_state = 16},
  [9711] = {.lex_state = 192, .external_lex_state = 2},
  [9712] = {.lex_state = 192, .external_lex_state = 2},
  [9713] = {.lex_state = 192, .external_lex_state = 2},
  [9714] = {.lex_state = 237},
  [9715] = {.lex_state = 192, .external_lex_state = 2},
  [9716] = {.lex_state = 353, .external_lex_state = 26},
  [9717] = {.lex_state = 353, .external_lex_state = 26},
  [9718] = {.lex_state = 353, .external_lex_state = 26},
  [9719] = {.lex_state = 353, .external_lex_state = 26},
  [9720] = {.lex_state = 192, .external_lex_state = 2},
  [9721] = {.lex_state = 192, .external_lex_state = 2},
  [9722] = {.lex_state = 358, .external_lex_state = 26},
  [9723] = {.lex_state = 361, .external_lex_state = 25},
  [9724] = {.lex_state = 364, .external_lex_state = 26},
  [9725] = {.lex_state = 361, .external_lex_state = 25},
  [9726] = {.lex_state = 361, .external_lex_state = 25},
  [9727] = {.lex_state = 213},
  [9728] = {.lex_state = 368, .external_lex_state = 25},
  [9729] = {.lex_state = 371, .external_lex_state = 27},
  [9730] = {.lex_state = 302, .external_lex_state = 16},
  [9731] = {.lex_state = 192, .external_lex_state = 2},
  [9732] = {.lex_state = 192, .external_lex_state = 2},
  [9733] = {.lex_state = 192, .external_lex_state = 2},
  [9734] = {.lex_state = 192, .external_lex_state = 2},
  [9735] = {.lex_state = 192, .external_lex_state = 2},
  [9736] = {.lex_state = 192, .external_lex_state = 2},
  [9737] = {.lex_state = 192, .external_lex_state = 2},
  [9738] = {.lex_state = 192, .external_lex_state = 2},
  [9739] = {.lex_state = 192, .external_lex_state = 2},
  [9740] = {.lex_state = 192, .external_lex_state = 2},
  [9741] = {.lex_state = 192, .external_lex_state = 2},
  [9742] = {.lex_state = 192, .external_lex_state = 2},
  [9743] = {.lex_state = 192, .external_lex_state = 2},
  [9744] = {.lex_state = 237},
  [9745] = {.lex_state = 192, .external_lex_state = 2},
  [9746] = {.lex_state = 364, .external_lex_state = 26},
  [9747] = {.lex_state = 364, .external_lex_state = 26},
  [9748] = {.lex_state = 364, .external_lex_state = 26},
  [9749] = {.lex_state = 364, .external_lex_state = 26},
  [9750] = {.lex_state = 192, .external_lex_state = 2},
  [9751] = {.lex_state = 192, .external_lex_state = 2},
  [9752] = {.lex_state = 358, .external_lex_state = 26},
  [9753] = {.lex_state = 421, .external_lex_state = 25},
  [9754] = {.lex_state = 364, .external_lex_state = 26},
  [9755] = {.lex_state = 424, .external_lex_state = 25},
  [9756] = {.lex_state = 424, .external_lex_state = 25},
  [9757] = {.lex_state = 213},
  [9758] = {.lex_state = 421, .external_lex_state = 25},
  [9759] = {.lex_state = 427, .external_lex_state = 27},
  [9760] = {.lex_state = 192, .external_lex_state = 29},
  [9761] = {.lex_state = 192, .external_lex_state = 2},
  [9762] = {.lex_state = 251, .external_lex_state = 20},
  [9763] = {.lex_state = 237},
  [9764] = {.lex_state = 128},
  [9765] = {.lex_state = 197},
  [9766] = {.lex_state = 128, .external_lex_state = 12},
  [9767] = {.lex_state = 237},
  [9768] = {.lex_state = 237},
  [9769] = {.lex_state = 128},
  [9770] = {.lex_state = 156, .external_lex_state = 3},
  [9771] = {.lex_state = 192, .external_lex_state = 2},
  [9772] = {.lex_state = 302, .external_lex_state = 16},
  [9773] = {.lex_state = 192, .external_lex_state = 29},
  [9774] = {.lex_state = 302, .external_lex_state = 16},
  [9775] = {.lex_state = 645, .external_lex_state = 25},
  [9776] = {.lex_state = 645, .external_lex_state = 25},
  [9777] = {.lex_state = 645, .external_lex_state = 25},
  [9778] = {.lex_state = 645, .external_lex_state = 25},
  [9779] = {.lex_state = 645, .external_lex_state = 25},
  [9780] = {.lex_state = 645, .external_lex_state = 25},
  [9781] = {.lex_state = 645, .external_lex_state = 25},
  [9782] = {.lex_state = 554, .external_lex_state = 16},
  [9783] = {.lex_state = 645, .external_lex_state = 25},
  [9784] = {.lex_state = 645, .external_lex_state = 25},
  [9785] = {.lex_state = 645, .external_lex_state = 25},
  [9786] = {.lex_state = 645, .external_lex_state = 25},
  [9787] = {.lex_state = 645, .external_lex_state = 25},
  [9788] = {.lex_state = 645, .external_lex_state = 25},
  [9789] = {.lex_state = 645, .external_lex_state = 25},
  [9790] = {.lex_state = 645, .external_lex_state = 27},
  [9791] = {.lex_state = 654, .external_lex_state = 27},
  [9792] = {.lex_state = 654, .external_lex_state = 25},
  [9793] = {.lex_state = 654, .external_lex_state = 25},
  [9794] = {.lex_state = 654, .external_lex_state = 25},
  [9795] = {.lex_state = 524, .external_lex_state = 21},
  [9796] = {.lex_state = 654, .external_lex_state = 25},
  [9797] = {.lex_state = 654, .external_lex_state = 25},
  [9798] = {.lex_state = 192, .external_lex_state = 2},
  [9799] = {.lex_state = 658, .external_lex_state = 25},
  [9800] = {.lex_state = 658, .external_lex_state = 25},
  [9801] = {.lex_state = 658, .external_lex_state = 25},
  [9802] = {.lex_state = 524, .external_lex_state = 21},
  [9803] = {.lex_state = 658, .external_lex_state = 25},
  [9804] = {.lex_state = 658, .external_lex_state = 25},
  [9805] = {.lex_state = 192, .external_lex_state = 29},
  [9806] = {.lex_state = 654, .external_lex_state = 25},
  [9807] = {.lex_state = 554, .external_lex_state = 16},
  [9808] = {.lex_state = 559, .external_lex_state = 25},
  [9809] = {.lex_state = 559, .external_lex_state = 25},
  [9810] = {.lex_state = 559, .external_lex_state = 25},
  [9811] = {.lex_state = 559, .external_lex_state = 25},
  [9812] = {.lex_state = 559, .external_lex_state = 25},
  [9813] = {.lex_state = 554, .external_lex_state = 16},
  [9814] = {.lex_state = 559, .external_lex_state = 25},
  [9815] = {.lex_state = 559, .external_lex_state = 25},
  [9816] = {.lex_state = 559, .external_lex_state = 25},
  [9817] = {.lex_state = 559, .external_lex_state = 25},
  [9818] = {.lex_state = 559, .external_lex_state = 25},
  [9819] = {.lex_state = 559, .external_lex_state = 25},
  [9820] = {.lex_state = 559, .external_lex_state = 25},
  [9821] = {.lex_state = 559, .external_lex_state = 27},
  [9822] = {.lex_state = 658, .external_lex_state = 27},
  [9823] = {.lex_state = 192, .external_lex_state = 2},
  [9824] = {.lex_state = 192, .external_lex_state = 29},
  [9825] = {.lex_state = 658, .external_lex_state = 25},
  [9826] = {.lex_state = 554, .external_lex_state = 16},
  [9827] = {.lex_state = 554, .external_lex_state = 16},
  [9828] = {.lex_state = 554, .external_lex_state = 16},
  [9829] = {.lex_state = 554, .external_lex_state = 16},
  [9830] = {.lex_state = 554, .external_lex_state = 16},
  [9831] = {.lex_state = 554, .external_lex_state = 16},
  [9832] = {.lex_state = 554, .external_lex_state = 16},
  [9833] = {.lex_state = 554, .external_lex_state = 16},
  [9834] = {.lex_state = 554, .external_lex_state = 16},
  [9835] = {.lex_state = 554, .external_lex_state = 16},
  [9836] = {.lex_state = 554, .external_lex_state = 16},
  [9837] = {.lex_state = 554, .external_lex_state = 16},
  [9838] = {.lex_state = 554, .external_lex_state = 16},
  [9839] = {.lex_state = 645, .external_lex_state = 20},
  [9840] = {.lex_state = 299, .external_lex_state = 3},
  [9841] = {.lex_state = 299, .external_lex_state = 3},
  [9842] = {.lex_state = 227, .external_lex_state = 3},
  [9843] = {.lex_state = 177, .external_lex_state = 4},
  [9844] = {.lex_state = 227, .external_lex_state = 3},
  [9845] = {.lex_state = 227, .external_lex_state = 3},
  [9846] = {.lex_state = 177, .external_lex_state = 4},
  [9847] = {.lex_state = 227, .external_lex_state = 3},
  [9848] = {.lex_state = 225, .external_lex_state = 7},
  [9849] = {.lex_state = 227, .external_lex_state = 3},
  [9850] = {.lex_state = 227, .external_lex_state = 3},
  [9851] = {.lex_state = 227, .external_lex_state = 3},
  [9852] = {.lex_state = 128},
  [9853] = {.lex_state = 128},
  [9854] = {.lex_state = 227, .external_lex_state = 3},
  [9855] = {.lex_state = 128},
  [9856] = {.lex_state = 227, .external_lex_state = 3},
  [9857] = {.lex_state = 227, .external_lex_state = 3},
  [9858] = {.lex_state = 227, .external_lex_state = 3},
  [9859] = {.lex_state = 128},
  [9860] = {.lex_state = 227, .external_lex_state = 3},
  [9861] = {.lex_state = 128},
  [9862] = {.lex_state = 227, .external_lex_state = 3},
  [9863] = {.lex_state = 128},
  [9864] = {.lex_state = 424, .external_lex_state = 3},
  [9865] = {.lex_state = 227, .external_lex_state = 3},
  [9866] = {.lex_state = 424, .external_lex_state = 3},
  [9867] = {.lex_state = 436, .external_lex_state = 3},
  [9868] = {.lex_state = 436, .external_lex_state = 3},
  [9869] = {.lex_state = 436, .external_lex_state = 3},
  [9870] = {.lex_state = 436, .external_lex_state = 3},
  [9871] = {.lex_state = 436, .external_lex_state = 3},
  [9872] = {.lex_state = 436, .external_lex_state = 3},
  [9873] = {.lex_state = 554, .external_lex_state = 16},
  [9874] = {.lex_state = 436, .external_lex_state = 3},
  [9875] = {.lex_state = 436, .external_lex_state = 3},
  [9876] = {.lex_state = 436, .external_lex_state = 3},
  [9877] = {.lex_state = 436, .external_lex_state = 3},
  [9878] = {.lex_state = 436, .external_lex_state = 3},
  [9879] = {.lex_state = 436, .external_lex_state = 3},
  [9880] = {.lex_state = 436, .external_lex_state = 3},
  [9881] = {.lex_state = 299, .external_lex_state = 3},
  [9882] = {.lex_state = 299, .external_lex_state = 3},
  [9883] = {.lex_state = 128},
  [9884] = {.lex_state = 299, .external_lex_state = 3},
  [9885] = {.lex_state = 299, .external_lex_state = 3},
  [9886] = {.lex_state = 227, .external_lex_state = 3},
  [9887] = {.lex_state = 299, .external_lex_state = 3},
  [9888] = {.lex_state = 299, .external_lex_state = 3},
  [9889] = {.lex_state = 577, .external_lex_state = 3},
  [9890] = {.lex_state = 467, .external_lex_state = 25},
  [9891] = {.lex_state = 467, .external_lex_state = 25},
  [9892] = {.lex_state = 192, .external_lex_state = 2},
  [9893] = {.lex_state = 192, .external_lex_state = 29},
  [9894] = {.lex_state = 467, .external_lex_state = 25},
  [9895] = {.lex_state = 588, .external_lex_state = 25},
  [9896] = {.lex_state = 588, .external_lex_state = 25},
  [9897] = {.lex_state = 579, .external_lex_state = 18},
  [9898] = {.lex_state = 461, .external_lex_state = 25},
  [9899] = {.lex_state = 461, .external_lex_state = 25},
  [9900] = {.lex_state = 177, .external_lex_state = 4},
  [9901] = {.lex_state = 266, .external_lex_state = 15},
  [9902] = {.lex_state = 461, .external_lex_state = 25},
  [9903] = {.lex_state = 177, .external_lex_state = 4},
  [9904] = {.lex_state = 461, .external_lex_state = 25},
  [9905] = {.lex_state = 461, .external_lex_state = 25},
  [9906] = {.lex_state = 177, .external_lex_state = 4},
  [9907] = {.lex_state = 266, .external_lex_state = 15},
  [9908] = {.lex_state = 461, .external_lex_state = 25},
  [9909] = {.lex_state = 177, .external_lex_state = 4},
  [9910] = {.lex_state = 461, .external_lex_state = 25},
  [9911] = {.lex_state = 310},
  [9912] = {.lex_state = 461, .external_lex_state = 25},
  [9913] = {.lex_state = 461, .external_lex_state = 25},
  [9914] = {.lex_state = 128, .external_lex_state = 2},
  [9915] = {.lex_state = 128, .external_lex_state = 2},
  [9916] = {.lex_state = 461, .external_lex_state = 25},
  [9917] = {.lex_state = 461, .external_lex_state = 25},
  [9918] = {.lex_state = 461, .external_lex_state = 25},
  [9919] = {.lex_state = 128},
  [9920] = {.lex_state = 128},
  [9921] = {.lex_state = 128, .external_lex_state = 2},
  [9922] = {.lex_state = 461, .external_lex_state = 25},
  [9923] = {.lex_state = 128},
  [9924] = {.lex_state = 128},
  [9925] = {.lex_state = 461, .external_lex_state = 25},
  [9926] = {.lex_state = 128},
  [9927] = {.lex_state = 461, .external_lex_state = 25},
  [9928] = {.lex_state = 128},
  [9929] = {.lex_state = 128, .external_lex_state = 2},
  [9930] = {.lex_state = 128},
  [9931] = {.lex_state = 128},
  [9932] = {.lex_state = 461, .external_lex_state = 25},
  [9933] = {.lex_state = 461, .external_lex_state = 25},
  [9934] = {.lex_state = 128},
  [9935] = {.lex_state = 128},
  [9936] = {.lex_state = 461, .external_lex_state = 25},
  [9937] = {.lex_state = 192, .external_lex_state = 2},
  [9938] = {.lex_state = 192, .external_lex_state = 29},
  [9939] = {.lex_state = 441, .external_lex_state = 25},
  [9940] = {.lex_state = 433, .external_lex_state = 16},
  [9941] = {.lex_state = 128},
  [9942] = {.lex_state = 573, .external_lex_state = 25},
  [9943] = {.lex_state = 573, .external_lex_state = 25},
  [9944] = {.lex_state = 192, .external_lex_state = 2},
  [9945] = {.lex_state = 467, .external_lex_state = 3},
  [9946] = {.lex_state = 467, .external_lex_state = 3},
  [9947] = {.lex_state = 192, .external_lex_state = 2},
  [9948] = {.lex_state = 192, .external_lex_state = 29},
  [9949] = {.lex_state = 467, .external_lex_state = 3},
  [9950] = {.lex_state = 588, .external_lex_state = 3},
  [9951] = {.lex_state = 588, .external_lex_state = 3},
  [9952] = {.lex_state = 192, .external_lex_state = 2},
  [9953] = {.lex_state = 192, .external_lex_state = 29},
  [9954] = {.lex_state = 441, .external_lex_state = 3},
  [9955] = {.lex_state = 573, .external_lex_state = 3},
  [9956] = {.lex_state = 573, .external_lex_state = 3},
  [9957] = {.lex_state = 192, .external_lex_state = 2},
  [9958] = {.lex_state = 192, .external_lex_state = 2},
  [9959] = {.lex_state = 192, .external_lex_state = 29},
  [9960] = {.lex_state = 467, .external_lex_state = 25},
  [9961] = {.lex_state = 588, .external_lex_state = 25},
  [9962] = {.lex_state = 588, .external_lex_state = 25},
  [9963] = {.lex_state = 595, .external_lex_state = 26},
  [9964] = {.lex_state = 192, .external_lex_state = 2},
  [9965] = {.lex_state = 192, .external_lex_state = 29},
  [9966] = {.lex_state = 441, .external_lex_state = 25},
  [9967] = {.lex_state = 461, .external_lex_state = 25},
  [9968] = {.lex_state = 128},
  [9969] = {.lex_state = 573, .external_lex_state = 25},
  [9970] = {.lex_state = 573, .external_lex_state = 25},
  [9971] = {.lex_state = 288, .external_lex_state = 16},
  [9972] = {.lex_state = 288, .external_lex_state = 16},
  [9973] = {.lex_state = 397, .external_lex_state = 25},
  [9974] = {.lex_state = 397, .external_lex_state = 25},
  [9975] = {.lex_state = 397, .external_lex_state = 25},
  [9976] = {.lex_state = 397, .external_lex_state = 25},
  [9977] = {.lex_state = 128},
  [9978] = {.lex_state = 397, .external_lex_state = 25},
  [9979] = {.lex_state = 397, .external_lex_state = 25},
  [9980] = {.lex_state = 299, .external_lex_state = 16},
  [9981] = {.lex_state = 397, .external_lex_state = 25},
  [9982] = {.lex_state = 397, .external_lex_state = 25},
  [9983] = {.lex_state = 302, .external_lex_state = 16},
  [9984] = {.lex_state = 192, .external_lex_state = 2},
  [9985] = {.lex_state = 192, .external_lex_state = 29},
  [9986] = {.lex_state = 493, .external_lex_state = 25},
  [9987] = {.lex_state = 493, .external_lex_state = 25},
  [9988] = {.lex_state = 493, .external_lex_state = 25},
  [9989] = {.lex_state = 192, .external_lex_state = 2},
  [9990] = {.lex_state = 192, .external_lex_state = 29},
  [9991] = {.lex_state = 321, .external_lex_state = 25},
  [9992] = {.lex_state = 497, .external_lex_state = 25},
  [9993] = {.lex_state = 497, .external_lex_state = 25},
  [9994] = {.lex_state = 192, .external_lex_state = 2},
  [9995] = {.lex_state = 678, .external_lex_state = 8},
  [9996] = {.lex_state = 678, .external_lex_state = 8},
  [9997] = {.lex_state = 128},
  [9998] = {.lex_state = 128, .external_lex_state = 2},
  [9999] = {.lex_state = 254, .external_lex_state = 8},
  [10000] = {.lex_state = 621, .external_lex_state = 25},
  [10001] = {.lex_state = 621, .external_lex_state = 25},
  [10002] = {.lex_state = 621, .external_lex_state = 25},
  [10003] = {.lex_state = 524, .external_lex_state = 21},
  [10004] = {.lex_state = 621, .external_lex_state = 25},
  [10005] = {.lex_state = 621, .external_lex_state = 25},
  [10006] = {.lex_state = 192, .external_lex_state = 2},
  [10007] = {.lex_state = 192, .external_lex_state = 29},
  [10008] = {.lex_state = 621, .external_lex_state = 25},
  [10009] = {.lex_state = 604, .external_lex_state = 25},
  [10010] = {.lex_state = 604, .external_lex_state = 25},
  [10011] = {.lex_state = 493, .external_lex_state = 3},
  [10012] = {.lex_state = 493, .external_lex_state = 3},
  [10013] = {.lex_state = 321, .external_lex_state = 3},
  [10014] = {.lex_state = 321, .external_lex_state = 3},
  [10015] = {.lex_state = 302, .external_lex_state = 3},
  [10016] = {.lex_state = 361, .external_lex_state = 25},
  [10017] = {.lex_state = 424, .external_lex_state = 25},
  [10018] = {.lex_state = 424, .external_lex_state = 25},
  [10019] = {.lex_state = 424, .external_lex_state = 25},
  [10020] = {.lex_state = 424, .external_lex_state = 25},
  [10021] = {.lex_state = 424, .external_lex_state = 25},
  [10022] = {.lex_state = 554, .external_lex_state = 16},
  [10023] = {.lex_state = 424, .external_lex_state = 25},
  [10024] = {.lex_state = 424, .external_lex_state = 25},
  [10025] = {.lex_state = 424, .external_lex_state = 25},
  [10026] = {.lex_state = 424, .external_lex_state = 25},
  [10027] = {.lex_state = 424, .external_lex_state = 25},
  [10028] = {.lex_state = 424, .external_lex_state = 25},
  [10029] = {.lex_state = 424, .external_lex_state = 25},
  [10030] = {.lex_state = 424, .external_lex_state = 27},
  [10031] = {.lex_state = 361, .external_lex_state = 25},
  [10032] = {.lex_state = 330},
  [10033] = {.lex_state = 337},
  [10034] = {.lex_state = 621, .external_lex_state = 25},
  [10035] = {.lex_state = 177, .external_lex_state = 4},
  [10036] = {.lex_state = 621, .external_lex_state = 25},
  [10037] = {.lex_state = 621, .external_lex_state = 25},
  [10038] = {.lex_state = 177, .external_lex_state = 4},
  [10039] = {.lex_state = 621, .external_lex_state = 25},
  [10040] = {.lex_state = 225, .external_lex_state = 7},
  [10041] = {.lex_state = 621, .external_lex_state = 25},
  [10042] = {.lex_state = 621, .external_lex_state = 25},
  [10043] = {.lex_state = 621, .external_lex_state = 25},
  [10044] = {.lex_state = 621, .external_lex_state = 25},
  [10045] = {.lex_state = 621, .external_lex_state = 25},
  [10046] = {.lex_state = 621, .external_lex_state = 25},
  [10047] = {.lex_state = 128},
  [10048] = {.lex_state = 128},
  [10049] = {.lex_state = 621, .external_lex_state = 25},
  [10050] = {.lex_state = 128},
  [10051] = {.lex_state = 621, .external_lex_state = 25},
  [10052] = {.lex_state = 621, .external_lex_state = 25},
  [10053] = {.lex_state = 621, .external_lex_state = 25},
  [10054] = {.lex_state = 128},
  [10055] = {.lex_state = 621, .external_lex_state = 25},
  [10056] = {.lex_state = 128},
  [10057] = {.lex_state = 621, .external_lex_state = 25},
  [10058] = {.lex_state = 128},
  [10059] = {.lex_state = 621, .external_lex_state = 25},
  [10060] = {.lex_state = 621, .external_lex_state = 25},
  [10061] = {.lex_state = 128},
  [10062] = {.lex_state = 128, .external_lex_state = 2},
  [10063] = {.lex_state = 627, .external_lex_state = 25},
  [10064] = {.lex_state = 621, .external_lex_state = 25},
  [10065] = {.lex_state = 627, .external_lex_state = 25},
  [10066] = {.lex_state = 508, .external_lex_state = 25},
  [10067] = {.lex_state = 508, .external_lex_state = 25},
  [10068] = {.lex_state = 302, .external_lex_state = 25},
  [10069] = {.lex_state = 302, .external_lex_state = 25},
  [10070] = {.lex_state = 299, .external_lex_state = 3},
  [10071] = {.lex_state = 361, .external_lex_state = 3},
  [10072] = {.lex_state = 361, .external_lex_state = 3},
  [10073] = {.lex_state = 361, .external_lex_state = 3},
  [10074] = {.lex_state = 361, .external_lex_state = 3},
  [10075] = {.lex_state = 361, .external_lex_state = 3},
  [10076] = {.lex_state = 361, .external_lex_state = 3},
  [10077] = {.lex_state = 361, .external_lex_state = 3},
  [10078] = {.lex_state = 361, .external_lex_state = 3},
  [10079] = {.lex_state = 361, .external_lex_state = 3},
  [10080] = {.lex_state = 554, .external_lex_state = 16},
  [10081] = {.lex_state = 361, .external_lex_state = 3},
  [10082] = {.lex_state = 361, .external_lex_state = 3},
  [10083] = {.lex_state = 361, .external_lex_state = 3},
  [10084] = {.lex_state = 361, .external_lex_state = 3},
  [10085] = {.lex_state = 361, .external_lex_state = 3},
  [10086] = {.lex_state = 361, .external_lex_state = 3},
  [10087] = {.lex_state = 361, .external_lex_state = 3},
  [10088] = {.lex_state = 365, .external_lex_state = 14},
  [10089] = {.lex_state = 361, .external_lex_state = 3},
  [10090] = {.lex_state = 361, .external_lex_state = 3},
  [10091] = {.lex_state = 361, .external_lex_state = 3},
  [10092] = {.lex_state = 524, .external_lex_state = 21},
  [10093] = {.lex_state = 361, .external_lex_state = 3},
  [10094] = {.lex_state = 361, .external_lex_state = 3},
  [10095] = {.lex_state = 192, .external_lex_state = 2},
  [10096] = {.lex_state = 421, .external_lex_state = 3},
  [10097] = {.lex_state = 421, .external_lex_state = 3},
  [10098] = {.lex_state = 421, .external_lex_state = 3},
  [10099] = {.lex_state = 524, .external_lex_state = 21},
  [10100] = {.lex_state = 421, .external_lex_state = 3},
  [10101] = {.lex_state = 421, .external_lex_state = 3},
  [10102] = {.lex_state = 192, .external_lex_state = 29},
  [10103] = {.lex_state = 361, .external_lex_state = 3},
  [10104] = {.lex_state = 128},
  [10105] = {.lex_state = 247, .external_lex_state = 3},
  [10106] = {.lex_state = 424, .external_lex_state = 3},
  [10107] = {.lex_state = 424, .external_lex_state = 3},
  [10108] = {.lex_state = 424, .external_lex_state = 3},
  [10109] = {.lex_state = 424, .external_lex_state = 3},
  [10110] = {.lex_state = 424, .external_lex_state = 3},
  [10111] = {.lex_state = 554, .external_lex_state = 16},
  [10112] = {.lex_state = 424, .external_lex_state = 3},
  [10113] = {.lex_state = 424, .external_lex_state = 3},
  [10114] = {.lex_state = 424, .external_lex_state = 3},
  [10115] = {.lex_state = 424, .external_lex_state = 3},
  [10116] = {.lex_state = 424, .external_lex_state = 3},
  [10117] = {.lex_state = 424, .external_lex_state = 3},
  [10118] = {.lex_state = 424, .external_lex_state = 3},
  [10119] = {.lex_state = 424, .external_lex_state = 14},
  [10120] = {.lex_state = 192, .external_lex_state = 2},
  [10121] = {.lex_state = 192, .external_lex_state = 29},
  [10122] = {.lex_state = 421, .external_lex_state = 3},
  [10123] = {.lex_state = 528, .external_lex_state = 3},
  [10124] = {.lex_state = 528, .external_lex_state = 3},
  [10125] = {.lex_state = 528, .external_lex_state = 3},
  [10126] = {.lex_state = 528, .external_lex_state = 3},
  [10127] = {.lex_state = 528, .external_lex_state = 3},
  [10128] = {.lex_state = 554, .external_lex_state = 16},
  [10129] = {.lex_state = 528, .external_lex_state = 3},
  [10130] = {.lex_state = 528, .external_lex_state = 3},
  [10131] = {.lex_state = 528, .external_lex_state = 3},
  [10132] = {.lex_state = 528, .external_lex_state = 3},
  [10133] = {.lex_state = 528, .external_lex_state = 3},
  [10134] = {.lex_state = 528, .external_lex_state = 3},
  [10135] = {.lex_state = 528, .external_lex_state = 3},
  [10136] = {.lex_state = 424, .external_lex_state = 3},
  [10137] = {.lex_state = 424, .external_lex_state = 3},
  [10138] = {.lex_state = 528, .external_lex_state = 3},
  [10139] = {.lex_state = 361, .external_lex_state = 3},
  [10140] = {.lex_state = 361, .external_lex_state = 3},
  [10141] = {.lex_state = 361, .external_lex_state = 3},
  [10142] = {.lex_state = 361, .external_lex_state = 3},
  [10143] = {.lex_state = 361, .external_lex_state = 3},
  [10144] = {.lex_state = 361, .external_lex_state = 3},
  [10145] = {.lex_state = 361, .external_lex_state = 3},
  [10146] = {.lex_state = 554, .external_lex_state = 16},
  [10147] = {.lex_state = 361, .external_lex_state = 3},
  [10148] = {.lex_state = 361, .external_lex_state = 3},
  [10149] = {.lex_state = 361, .external_lex_state = 3},
  [10150] = {.lex_state = 361, .external_lex_state = 3},
  [10151] = {.lex_state = 361, .external_lex_state = 3},
  [10152] = {.lex_state = 361, .external_lex_state = 3},
  [10153] = {.lex_state = 361, .external_lex_state = 3},
  [10154] = {.lex_state = 365, .external_lex_state = 14},
  [10155] = {.lex_state = 361, .external_lex_state = 3},
  [10156] = {.lex_state = 361, .external_lex_state = 3},
  [10157] = {.lex_state = 361, .external_lex_state = 3},
  [10158] = {.lex_state = 524, .external_lex_state = 21},
  [10159] = {.lex_state = 361, .external_lex_state = 3},
  [10160] = {.lex_state = 361, .external_lex_state = 3},
  [10161] = {.lex_state = 192, .external_lex_state = 2},
  [10162] = {.lex_state = 421, .external_lex_state = 3},
  [10163] = {.lex_state = 421, .external_lex_state = 3},
  [10164] = {.lex_state = 421, .external_lex_state = 3},
  [10165] = {.lex_state = 524, .external_lex_state = 21},
  [10166] = {.lex_state = 421, .external_lex_state = 3},
  [10167] = {.lex_state = 421, .external_lex_state = 3},
  [10168] = {.lex_state = 192, .external_lex_state = 29},
  [10169] = {.lex_state = 361, .external_lex_state = 3},
  [10170] = {.lex_state = 247, .external_lex_state = 3},
  [10171] = {.lex_state = 424, .external_lex_state = 3},
  [10172] = {.lex_state = 424, .external_lex_state = 3},
  [10173] = {.lex_state = 424, .external_lex_state = 3},
  [10174] = {.lex_state = 424, .external_lex_state = 3},
  [10175] = {.lex_state = 424, .external_lex_state = 3},
  [10176] = {.lex_state = 554, .external_lex_state = 16},
  [10177] = {.lex_state = 424, .external_lex_state = 3},
  [10178] = {.lex_state = 424, .external_lex_state = 3},
  [10179] = {.lex_state = 424, .external_lex_state = 3},
  [10180] = {.lex_state = 424, .external_lex_state = 3},
  [10181] = {.lex_state = 424, .external_lex_state = 3},
  [10182] = {.lex_state = 424, .external_lex_state = 3},
  [10183] = {.lex_state = 424, .external_lex_state = 3},
  [10184] = {.lex_state = 424, .external_lex_state = 14},
  [10185] = {.lex_state = 192, .external_lex_state = 2},
  [10186] = {.lex_state = 192, .external_lex_state = 29},
  [10187] = {.lex_state = 421, .external_lex_state = 3},
  [10188] = {.lex_state = 528, .external_lex_state = 3},
  [10189] = {.lex_state = 528, .external_lex_state = 3},
  [10190] = {.lex_state = 528, .external_lex_state = 3},
  [10191] = {.lex_state = 528, .external_lex_state = 3},
  [10192] = {.lex_state = 528, .external_lex_state = 3},
  [10193] = {.lex_state = 554, .external_lex_state = 16},
  [10194] = {.lex_state = 528, .external_lex_state = 3},
  [10195] = {.lex_state = 528, .external_lex_state = 3},
  [10196] = {.lex_state = 528, .external_lex_state = 3},
  [10197] = {.lex_state = 528, .external_lex_state = 3},
  [10198] = {.lex_state = 528, .external_lex_state = 3},
  [10199] = {.lex_state = 528, .external_lex_state = 3},
  [10200] = {.lex_state = 528, .external_lex_state = 3},
  [10201] = {.lex_state = 361, .external_lex_state = 3},
  [10202] = {.lex_state = 361, .external_lex_state = 3},
  [10203] = {.lex_state = 424, .external_lex_state = 3},
  [10204] = {.lex_state = 424, .external_lex_state = 3},
  [10205] = {.lex_state = 528, .external_lex_state = 3},
  [10206] = {.lex_state = 508, .external_lex_state = 25},
  [10207] = {.lex_state = 424, .external_lex_state = 25},
  [10208] = {.lex_state = 424, .external_lex_state = 25},
  [10209] = {.lex_state = 424, .external_lex_state = 25},
  [10210] = {.lex_state = 424, .external_lex_state = 25},
  [10211] = {.lex_state = 424, .external_lex_state = 25},
  [10212] = {.lex_state = 554, .external_lex_state = 16},
  [10213] = {.lex_state = 424, .external_lex_state = 25},
  [10214] = {.lex_state = 424, .external_lex_state = 25},
  [10215] = {.lex_state = 424, .external_lex_state = 25},
  [10216] = {.lex_state = 424, .external_lex_state = 25},
  [10217] = {.lex_state = 424, .external_lex_state = 25},
  [10218] = {.lex_state = 424, .external_lex_state = 25},
  [10219] = {.lex_state = 424, .external_lex_state = 25},
  [10220] = {.lex_state = 424, .external_lex_state = 27},
  [10221] = {.lex_state = 508, .external_lex_state = 25},
  [10222] = {.lex_state = 421, .external_lex_state = 25},
  [10223] = {.lex_state = 421, .external_lex_state = 25},
  [10224] = {.lex_state = 361, .external_lex_state = 3},
  [10225] = {.lex_state = 361, .external_lex_state = 3},
  [10226] = {.lex_state = 528, .external_lex_state = 3},
  [10227] = {.lex_state = 361, .external_lex_state = 3},
  [10228] = {.lex_state = 361, .external_lex_state = 3},
  [10229] = {.lex_state = 361, .external_lex_state = 3},
  [10230] = {.lex_state = 361, .external_lex_state = 3},
  [10231] = {.lex_state = 361, .external_lex_state = 3},
  [10232] = {.lex_state = 554, .external_lex_state = 16},
  [10233] = {.lex_state = 361, .external_lex_state = 3},
  [10234] = {.lex_state = 361, .external_lex_state = 3},
  [10235] = {.lex_state = 361, .external_lex_state = 3},
  [10236] = {.lex_state = 361, .external_lex_state = 3},
  [10237] = {.lex_state = 361, .external_lex_state = 3},
  [10238] = {.lex_state = 361, .external_lex_state = 3},
  [10239] = {.lex_state = 361, .external_lex_state = 3},
  [10240] = {.lex_state = 192, .external_lex_state = 2},
  [10241] = {.lex_state = 511, .external_lex_state = 11},
  [10242] = {.lex_state = 511, .external_lex_state = 11},
  [10243] = {.lex_state = 511, .external_lex_state = 11},
  [10244] = {.lex_state = 511, .external_lex_state = 11},
  [10245] = {.lex_state = 192, .external_lex_state = 2},
  [10246] = {.lex_state = 192, .external_lex_state = 2},
  [10247] = {.lex_state = 361, .external_lex_state = 3},
  [10248] = {.lex_state = 213},
  [10249] = {.lex_state = 259, .external_lex_state = 3},
  [10250] = {.lex_state = 365, .external_lex_state = 14},
  [10251] = {.lex_state = 361, .external_lex_state = 3},
  [10252] = {.lex_state = 361, .external_lex_state = 3},
  [10253] = {.lex_state = 361, .external_lex_state = 14},
  [10254] = {.lex_state = 192, .external_lex_state = 2},
  [10255] = {.lex_state = 361, .external_lex_state = 3},
  [10256] = {.lex_state = 192, .external_lex_state = 2},
  [10257] = {.lex_state = 192, .external_lex_state = 2},
  [10258] = {.lex_state = 237},
  [10259] = {.lex_state = 192, .external_lex_state = 2},
  [10260] = {.lex_state = 358, .external_lex_state = 11},
  [10261] = {.lex_state = 361, .external_lex_state = 3},
  [10262] = {.lex_state = 361, .external_lex_state = 3},
  [10263] = {.lex_state = 361, .external_lex_state = 3},
  [10264] = {.lex_state = 371, .external_lex_state = 14},
  [10265] = {.lex_state = 361, .external_lex_state = 3},
  [10266] = {.lex_state = 192, .external_lex_state = 2},
  [10267] = {.lex_state = 192, .external_lex_state = 2},
  [10268] = {.lex_state = 192, .external_lex_state = 2},
  [10269] = {.lex_state = 192, .external_lex_state = 2},
  [10270] = {.lex_state = 192, .external_lex_state = 2},
  [10271] = {.lex_state = 192, .external_lex_state = 2},
  [10272] = {.lex_state = 192, .external_lex_state = 2},
  [10273] = {.lex_state = 192, .external_lex_state = 2},
  [10274] = {.lex_state = 192, .external_lex_state = 2},
  [10275] = {.lex_state = 192, .external_lex_state = 2},
  [10276] = {.lex_state = 192, .external_lex_state = 2},
  [10277] = {.lex_state = 192, .external_lex_state = 2},
  [10278] = {.lex_state = 192, .external_lex_state = 2},
  [10279] = {.lex_state = 237},
  [10280] = {.lex_state = 192, .external_lex_state = 2},
  [10281] = {.lex_state = 358, .external_lex_state = 11},
  [10282] = {.lex_state = 421, .external_lex_state = 3},
  [10283] = {.lex_state = 421, .external_lex_state = 3},
  [10284] = {.lex_state = 421, .external_lex_state = 3},
  [10285] = {.lex_state = 427, .external_lex_state = 14},
  [10286] = {.lex_state = 262, .external_lex_state = 3},
  [10287] = {.lex_state = 524, .external_lex_state = 13},
  [10288] = {.lex_state = 361, .external_lex_state = 3},
  [10289] = {.lex_state = 192, .external_lex_state = 29},
  [10290] = {.lex_state = 192, .external_lex_state = 2},
  [10291] = {.lex_state = 361, .external_lex_state = 14},
  [10292] = {.lex_state = 254, .external_lex_state = 8},
  [10293] = {.lex_state = 128, .external_lex_state = 2},
  [10294] = {.lex_state = 128, .external_lex_state = 8},
  [10295] = {.lex_state = 247, .external_lex_state = 3},
  [10296] = {.lex_state = 247, .external_lex_state = 3},
  [10297] = {.lex_state = 247, .external_lex_state = 3},
  [10298] = {.lex_state = 247, .external_lex_state = 3},
  [10299] = {.lex_state = 247, .external_lex_state = 3},
  [10300] = {.lex_state = 247, .external_lex_state = 3},
  [10301] = {.lex_state = 247, .external_lex_state = 3},
  [10302] = {.lex_state = 247, .external_lex_state = 3},
  [10303] = {.lex_state = 247, .external_lex_state = 3},
  [10304] = {.lex_state = 247, .external_lex_state = 3},
  [10305] = {.lex_state = 554, .external_lex_state = 16},
  [10306] = {.lex_state = 247, .external_lex_state = 3},
  [10307] = {.lex_state = 247, .external_lex_state = 3},
  [10308] = {.lex_state = 247, .external_lex_state = 3},
  [10309] = {.lex_state = 247, .external_lex_state = 3},
  [10310] = {.lex_state = 192, .external_lex_state = 2},
  [10311] = {.lex_state = 254, .external_lex_state = 11},
  [10312] = {.lex_state = 254, .external_lex_state = 11},
  [10313] = {.lex_state = 254, .external_lex_state = 11},
  [10314] = {.lex_state = 254, .external_lex_state = 11},
  [10315] = {.lex_state = 192, .external_lex_state = 2},
  [10316] = {.lex_state = 192, .external_lex_state = 2},
  [10317] = {.lex_state = 424, .external_lex_state = 3},
  [10318] = {.lex_state = 254, .external_lex_state = 11},
  [10319] = {.lex_state = 213},
  [10320] = {.lex_state = 424, .external_lex_state = 3},
  [10321] = {.lex_state = 424, .external_lex_state = 14},
  [10322] = {.lex_state = 424, .external_lex_state = 3},
  [10323] = {.lex_state = 421, .external_lex_state = 3},
  [10324] = {.lex_state = 421, .external_lex_state = 14},
  [10325] = {.lex_state = 192, .external_lex_state = 2},
  [10326] = {.lex_state = 424, .external_lex_state = 3},
  [10327] = {.lex_state = 421, .external_lex_state = 3},
  [10328] = {.lex_state = 192, .external_lex_state = 2},
  [10329] = {.lex_state = 192, .external_lex_state = 2},
  [10330] = {.lex_state = 192, .external_lex_state = 2},
  [10331] = {.lex_state = 192, .external_lex_state = 2},
  [10332] = {.lex_state = 192, .external_lex_state = 2},
  [10333] = {.lex_state = 192, .external_lex_state = 2},
  [10334] = {.lex_state = 192, .external_lex_state = 2},
  [10335] = {.lex_state = 192, .external_lex_state = 2},
  [10336] = {.lex_state = 192, .external_lex_state = 2},
  [10337] = {.lex_state = 192, .external_lex_state = 2},
  [10338] = {.lex_state = 192, .external_lex_state = 2},
  [10339] = {.lex_state = 424, .external_lex_state = 3},
  [10340] = {.lex_state = 524, .external_lex_state = 13},
  [10341] = {.lex_state = 424, .external_lex_state = 3},
  [10342] = {.lex_state = 192, .external_lex_state = 29},
  [10343] = {.lex_state = 192, .external_lex_state = 2},
  [10344] = {.lex_state = 421, .external_lex_state = 14},
  [10345] = {.lex_state = 192, .external_lex_state = 2},
  [10346] = {.lex_state = 192, .external_lex_state = 2},
  [10347] = {.lex_state = 192, .external_lex_state = 2},
  [10348] = {.lex_state = 192, .external_lex_state = 2},
  [10349] = {.lex_state = 528, .external_lex_state = 3},
  [10350] = {.lex_state = 528, .external_lex_state = 3},
  [10351] = {.lex_state = 213},
  [10352] = {.lex_state = 259, .external_lex_state = 3},
  [10353] = {.lex_state = 247, .external_lex_state = 3},
  [10354] = {.lex_state = 262, .external_lex_state = 14},
  [10355] = {.lex_state = 128},
  [10356] = {.lex_state = 528, .external_lex_state = 3},
  [10357] = {.lex_state = 424, .external_lex_state = 3},
  [10358] = {.lex_state = 424, .external_lex_state = 3},
  [10359] = {.lex_state = 424, .external_lex_state = 3},
  [10360] = {.lex_state = 424, .external_lex_state = 3},
  [10361] = {.lex_state = 424, .external_lex_state = 3},
  [10362] = {.lex_state = 554, .external_lex_state = 16},
  [10363] = {.lex_state = 424, .external_lex_state = 3},
  [10364] = {.lex_state = 424, .external_lex_state = 3},
  [10365] = {.lex_state = 424, .external_lex_state = 3},
  [10366] = {.lex_state = 424, .external_lex_state = 3},
  [10367] = {.lex_state = 424, .external_lex_state = 3},
  [10368] = {.lex_state = 424, .external_lex_state = 3},
  [10369] = {.lex_state = 424, .external_lex_state = 3},
  [10370] = {.lex_state = 424, .external_lex_state = 14},
  [10371] = {.lex_state = 528, .external_lex_state = 3},
  [10372] = {.lex_state = 361, .external_lex_state = 3},
  [10373] = {.lex_state = 361, .external_lex_state = 3},
  [10374] = {.lex_state = 361, .external_lex_state = 3},
  [10375] = {.lex_state = 361, .external_lex_state = 3},
  [10376] = {.lex_state = 350, .external_lex_state = 23},
  [10377] = {.lex_state = 209},
  [10378] = {.lex_state = 343, .external_lex_state = 8},
  [10379] = {.lex_state = 508, .external_lex_state = 3},
  [10380] = {.lex_state = 508, .external_lex_state = 3},
  [10381] = {.lex_state = 192, .external_lex_state = 2},
  [10382] = {.lex_state = 508, .external_lex_state = 3},
  [10383] = {.lex_state = 192, .external_lex_state = 2},
  [10384] = {.lex_state = 508, .external_lex_state = 3},
  [10385] = {.lex_state = 524, .external_lex_state = 13},
  [10386] = {.lex_state = 508, .external_lex_state = 3},
  [10387] = {.lex_state = 508, .external_lex_state = 3},
  [10388] = {.lex_state = 508, .external_lex_state = 3},
  [10389] = {.lex_state = 508, .external_lex_state = 3},
  [10390] = {.lex_state = 508, .external_lex_state = 3},
  [10391] = {.lex_state = 508, .external_lex_state = 3},
  [10392] = {.lex_state = 554, .external_lex_state = 16},
  [10393] = {.lex_state = 508, .external_lex_state = 3},
  [10394] = {.lex_state = 508, .external_lex_state = 3},
  [10395] = {.lex_state = 508, .external_lex_state = 3},
  [10396] = {.lex_state = 508, .external_lex_state = 3},
  [10397] = {.lex_state = 508, .external_lex_state = 3},
  [10398] = {.lex_state = 508, .external_lex_state = 3},
  [10399] = {.lex_state = 508, .external_lex_state = 3},
  [10400] = {.lex_state = 631, .external_lex_state = 14},
  [10401] = {.lex_state = 508, .external_lex_state = 3},
  [10402] = {.lex_state = 508, .external_lex_state = 3},
  [10403] = {.lex_state = 508, .external_lex_state = 3},
  [10404] = {.lex_state = 524, .external_lex_state = 21},
  [10405] = {.lex_state = 508, .external_lex_state = 3},
  [10406] = {.lex_state = 508, .external_lex_state = 3},
  [10407] = {.lex_state = 343, .external_lex_state = 8},
  [10408] = {.lex_state = 192, .external_lex_state = 2},
  [10409] = {.lex_state = 343, .external_lex_state = 8},
  [10410] = {.lex_state = 678, .external_lex_state = 8},
  [10411] = {.lex_state = 192, .external_lex_state = 29},
  [10412] = {.lex_state = 508, .external_lex_state = 3},
  [10413] = {.lex_state = 421, .external_lex_state = 3},
  [10414] = {.lex_state = 421, .external_lex_state = 3},
  [10415] = {.lex_state = 361, .external_lex_state = 3},
  [10416] = {.lex_state = 361, .external_lex_state = 3},
  [10417] = {.lex_state = 192, .external_lex_state = 2},
  [10418] = {.lex_state = 192, .external_lex_state = 29},
  [10419] = {.lex_state = 361, .external_lex_state = 3},
  [10420] = {.lex_state = 361, .external_lex_state = 3},
  [10421] = {.lex_state = 361, .external_lex_state = 3},
  [10422] = {.lex_state = 192, .external_lex_state = 2},
  [10423] = {.lex_state = 192, .external_lex_state = 29},
  [10424] = {.lex_state = 424, .external_lex_state = 3},
  [10425] = {.lex_state = 421, .external_lex_state = 3},
  [10426] = {.lex_state = 421, .external_lex_state = 3},
  [10427] = {.lex_state = 192, .external_lex_state = 2},
  [10428] = {.lex_state = 361, .external_lex_state = 3},
  [10429] = {.lex_state = 361, .external_lex_state = 3},
  [10430] = {.lex_state = 192, .external_lex_state = 2},
  [10431] = {.lex_state = 192, .external_lex_state = 29},
  [10432] = {.lex_state = 361, .external_lex_state = 3},
  [10433] = {.lex_state = 361, .external_lex_state = 3},
  [10434] = {.lex_state = 361, .external_lex_state = 3},
  [10435] = {.lex_state = 192, .external_lex_state = 2},
  [10436] = {.lex_state = 192, .external_lex_state = 29},
  [10437] = {.lex_state = 424, .external_lex_state = 3},
  [10438] = {.lex_state = 421, .external_lex_state = 3},
  [10439] = {.lex_state = 421, .external_lex_state = 3},
  [10440] = {.lex_state = 192, .external_lex_state = 2},
  [10441] = {.lex_state = 424, .external_lex_state = 3},
  [10442] = {.lex_state = 424, .external_lex_state = 3},
  [10443] = {.lex_state = 528, .external_lex_state = 3},
  [10444] = {.lex_state = 192, .external_lex_state = 2},
  [10445] = {.lex_state = 192, .external_lex_state = 29},
  [10446] = {.lex_state = 406, .external_lex_state = 25},
  [10447] = {.lex_state = 192, .external_lex_state = 2},
  [10448] = {.lex_state = 192, .external_lex_state = 29},
  [10449] = {.lex_state = 537, .external_lex_state = 25},
  [10450] = {.lex_state = 388, .external_lex_state = 25},
  [10451] = {.lex_state = 388, .external_lex_state = 25},
  [10452] = {.lex_state = 397, .external_lex_state = 25},
  [10453] = {.lex_state = 286, .external_lex_state = 2},
  [10454] = {.lex_state = 192, .external_lex_state = 2},
  [10455] = {.lex_state = 511, .external_lex_state = 26},
  [10456] = {.lex_state = 511, .external_lex_state = 26},
  [10457] = {.lex_state = 511, .external_lex_state = 26},
  [10458] = {.lex_state = 511, .external_lex_state = 26},
  [10459] = {.lex_state = 192, .external_lex_state = 2},
  [10460] = {.lex_state = 192, .external_lex_state = 2},
  [10461] = {.lex_state = 361, .external_lex_state = 25},
  [10462] = {.lex_state = 254, .external_lex_state = 26},
  [10463] = {.lex_state = 213},
  [10464] = {.lex_state = 259, .external_lex_state = 25},
  [10465] = {.lex_state = 365, .external_lex_state = 27},
  [10466] = {.lex_state = 361, .external_lex_state = 25},
  [10467] = {.lex_state = 361, .external_lex_state = 25},
  [10468] = {.lex_state = 361, .external_lex_state = 27},
  [10469] = {.lex_state = 192, .external_lex_state = 2},
  [10470] = {.lex_state = 361, .external_lex_state = 25},
  [10471] = {.lex_state = 192, .external_lex_state = 2},
  [10472] = {.lex_state = 192, .external_lex_state = 2},
  [10473] = {.lex_state = 237},
  [10474] = {.lex_state = 192, .external_lex_state = 2},
  [10475] = {.lex_state = 358, .external_lex_state = 26},
  [10476] = {.lex_state = 361, .external_lex_state = 25},
  [10477] = {.lex_state = 361, .external_lex_state = 25},
  [10478] = {.lex_state = 361, .external_lex_state = 25},
  [10479] = {.lex_state = 371, .external_lex_state = 27},
  [10480] = {.lex_state = 361, .external_lex_state = 25},
  [10481] = {.lex_state = 192, .external_lex_state = 2},
  [10482] = {.lex_state = 192, .external_lex_state = 2},
  [10483] = {.lex_state = 192, .external_lex_state = 2},
  [10484] = {.lex_state = 192, .external_lex_state = 2},
  [10485] = {.lex_state = 192, .external_lex_state = 2},
  [10486] = {.lex_state = 192, .external_lex_state = 2},
  [10487] = {.lex_state = 192, .external_lex_state = 2},
  [10488] = {.lex_state = 192, .external_lex_state = 2},
  [10489] = {.lex_state = 192, .external_lex_state = 2},
  [10490] = {.lex_state = 192, .external_lex_state = 2},
  [10491] = {.lex_state = 192, .external_lex_state = 2},
  [10492] = {.lex_state = 192, .external_lex_state = 2},
  [10493] = {.lex_state = 192, .external_lex_state = 2},
  [10494] = {.lex_state = 237},
  [10495] = {.lex_state = 192, .external_lex_state = 2},
  [10496] = {.lex_state = 358, .external_lex_state = 26},
  [10497] = {.lex_state = 421, .external_lex_state = 25},
  [10498] = {.lex_state = 421, .external_lex_state = 25},
  [10499] = {.lex_state = 421, .external_lex_state = 25},
  [10500] = {.lex_state = 427, .external_lex_state = 27},
  [10501] = {.lex_state = 361, .external_lex_state = 25},
  [10502] = {.lex_state = 524, .external_lex_state = 13},
  [10503] = {.lex_state = 361, .external_lex_state = 25},
  [10504] = {.lex_state = 192, .external_lex_state = 29},
  [10505] = {.lex_state = 192, .external_lex_state = 2},
  [10506] = {.lex_state = 361, .external_lex_state = 27},
  [10507] = {.lex_state = 302, .external_lex_state = 16},
  [10508] = {.lex_state = 302, .external_lex_state = 16},
  [10509] = {.lex_state = 302, .external_lex_state = 16},
  [10510] = {.lex_state = 302, .external_lex_state = 16},
  [10511] = {.lex_state = 302, .external_lex_state = 16},
  [10512] = {.lex_state = 554, .external_lex_state = 16},
  [10513] = {.lex_state = 302, .external_lex_state = 16},
  [10514] = {.lex_state = 302, .external_lex_state = 16},
  [10515] = {.lex_state = 302, .external_lex_state = 16},
  [10516] = {.lex_state = 302, .external_lex_state = 16},
  [10517] = {.lex_state = 192, .external_lex_state = 2},
  [10518] = {.lex_state = 254, .external_lex_state = 26},
  [10519] = {.lex_state = 254, .external_lex_state = 26},
  [10520] = {.lex_state = 254, .external_lex_state = 26},
  [10521] = {.lex_state = 254, .external_lex_state = 26},
  [10522] = {.lex_state = 192, .external_lex_state = 2},
  [10523] = {.lex_state = 192, .external_lex_state = 2},
  [10524] = {.lex_state = 424, .external_lex_state = 25},
  [10525] = {.lex_state = 254, .external_lex_state = 26},
  [10526] = {.lex_state = 213},
  [10527] = {.lex_state = 424, .external_lex_state = 25},
  [10528] = {.lex_state = 424, .external_lex_state = 27},
  [10529] = {.lex_state = 424, .external_lex_state = 25},
  [10530] = {.lex_state = 421, .external_lex_state = 25},
  [10531] = {.lex_state = 421, .external_lex_state = 27},
  [10532] = {.lex_state = 192, .external_lex_state = 2},
  [10533] = {.lex_state = 424, .external_lex_state = 25},
  [10534] = {.lex_state = 421, .external_lex_state = 25},
  [10535] = {.lex_state = 192, .external_lex_state = 2},
  [10536] = {.lex_state = 192, .external_lex_state = 2},
  [10537] = {.lex_state = 192, .external_lex_state = 2},
  [10538] = {.lex_state = 192, .external_lex_state = 2},
  [10539] = {.lex_state = 192, .external_lex_state = 2},
  [10540] = {.lex_state = 192, .external_lex_state = 2},
  [10541] = {.lex_state = 192, .external_lex_state = 2},
  [10542] = {.lex_state = 192, .external_lex_state = 2},
  [10543] = {.lex_state = 192, .external_lex_state = 2},
  [10544] = {.lex_state = 192, .external_lex_state = 2},
  [10545] = {.lex_state = 192, .external_lex_state = 2},
  [10546] = {.lex_state = 424, .external_lex_state = 25},
  [10547] = {.lex_state = 524, .external_lex_state = 13},
  [10548] = {.lex_state = 424, .external_lex_state = 25},
  [10549] = {.lex_state = 192, .external_lex_state = 29},
  [10550] = {.lex_state = 192, .external_lex_state = 2},
  [10551] = {.lex_state = 421, .external_lex_state = 27},
  [10552] = {.lex_state = 192, .external_lex_state = 2},
  [10553] = {.lex_state = 302, .external_lex_state = 16},
  [10554] = {.lex_state = 302, .external_lex_state = 16},
  [10555] = {.lex_state = 302, .external_lex_state = 16},
  [10556] = {.lex_state = 251, .external_lex_state = 20},
  [10557] = {.lex_state = 237},
  [10558] = {.lex_state = 237},
  [10559] = {.lex_state = 128, .external_lex_state = 12},
  [10560] = {.lex_state = 237},
  [10561] = {.lex_state = 237},
  [10562] = {.lex_state = 302, .external_lex_state = 16},
  [10563] = {.lex_state = 302, .external_lex_state = 16},
  [10564] = {.lex_state = 645, .external_lex_state = 25},
  [10565] = {.lex_state = 645, .external_lex_state = 25},
  [10566] = {.lex_state = 192, .external_lex_state = 2},
  [10567] = {.lex_state = 192, .external_lex_state = 29},
  [10568] = {.lex_state = 645, .external_lex_state = 25},
  [10569] = {.lex_state = 654, .external_lex_state = 25},
  [10570] = {.lex_state = 654, .external_lex_state = 25},
  [10571] = {.lex_state = 192, .external_lex_state = 2},
  [10572] = {.lex_state = 192, .external_lex_state = 29},
  [10573] = {.lex_state = 559, .external_lex_state = 25},
  [10574] = {.lex_state = 658, .external_lex_state = 25},
  [10575] = {.lex_state = 658, .external_lex_state = 25},
  [10576] = {.lex_state = 192, .external_lex_state = 2},
  [10577] = {.lex_state = 227, .external_lex_state = 3},
  [10578] = {.lex_state = 227, .external_lex_state = 3},
  [10579] = {.lex_state = 227, .external_lex_state = 3},
  [10580] = {.lex_state = 227, .external_lex_state = 3},
  [10581] = {.lex_state = 128},
  [10582] = {.lex_state = 227, .external_lex_state = 3},
  [10583] = {.lex_state = 227, .external_lex_state = 3},
  [10584] = {.lex_state = 227, .external_lex_state = 3},
  [10585] = {.lex_state = 227, .external_lex_state = 3},
  [10586] = {.lex_state = 192, .external_lex_state = 2},
  [10587] = {.lex_state = 299, .external_lex_state = 3},
  [10588] = {.lex_state = 467, .external_lex_state = 25},
  [10589] = {.lex_state = 467, .external_lex_state = 25},
  [10590] = {.lex_state = 461, .external_lex_state = 25},
  [10591] = {.lex_state = 177, .external_lex_state = 4},
  [10592] = {.lex_state = 461, .external_lex_state = 25},
  [10593] = {.lex_state = 461, .external_lex_state = 25},
  [10594] = {.lex_state = 177, .external_lex_state = 4},
  [10595] = {.lex_state = 461, .external_lex_state = 25},
  [10596] = {.lex_state = 225, .external_lex_state = 7},
  [10597] = {.lex_state = 461, .external_lex_state = 25},
  [10598] = {.lex_state = 461, .external_lex_state = 25},
  [10599] = {.lex_state = 461, .external_lex_state = 25},
  [10600] = {.lex_state = 128},
  [10601] = {.lex_state = 128},
  [10602] = {.lex_state = 461, .external_lex_state = 25},
  [10603] = {.lex_state = 128},
  [10604] = {.lex_state = 461, .external_lex_state = 25},
  [10605] = {.lex_state = 461, .external_lex_state = 25},
  [10606] = {.lex_state = 461, .external_lex_state = 25},
  [10607] = {.lex_state = 128},
  [10608] = {.lex_state = 461, .external_lex_state = 25},
  [10609] = {.lex_state = 128},
  [10610] = {.lex_state = 461, .external_lex_state = 25},
  [10611] = {.lex_state = 128},
  [10612] = {.lex_state = 441, .external_lex_state = 25},
  [10613] = {.lex_state = 461, .external_lex_state = 25},
  [10614] = {.lex_state = 441, .external_lex_state = 25},
  [10615] = {.lex_state = 433, .external_lex_state = 16},
  [10616] = {.lex_state = 436, .external_lex_state = 16},
  [10617] = {.lex_state = 467, .external_lex_state = 3},
  [10618] = {.lex_state = 467, .external_lex_state = 3},
  [10619] = {.lex_state = 441, .external_lex_state = 3},
  [10620] = {.lex_state = 441, .external_lex_state = 3},
  [10621] = {.lex_state = 436, .external_lex_state = 3},
  [10622] = {.lex_state = 467, .external_lex_state = 25},
  [10623] = {.lex_state = 467, .external_lex_state = 25},
  [10624] = {.lex_state = 441, .external_lex_state = 25},
  [10625] = {.lex_state = 441, .external_lex_state = 25},
  [10626] = {.lex_state = 461, .external_lex_state = 25},
  [10627] = {.lex_state = 397, .external_lex_state = 25},
  [10628] = {.lex_state = 493, .external_lex_state = 25},
  [10629] = {.lex_state = 493, .external_lex_state = 25},
  [10630] = {.lex_state = 321, .external_lex_state = 25},
  [10631] = {.lex_state = 321, .external_lex_state = 25},
  [10632] = {.lex_state = 302, .external_lex_state = 16},
  [10633] = {.lex_state = 678, .external_lex_state = 8},
  [10634] = {.lex_state = 128},
  [10635] = {.lex_state = 621, .external_lex_state = 25},
  [10636] = {.lex_state = 621, .external_lex_state = 25},
  [10637] = {.lex_state = 192, .external_lex_state = 2},
  [10638] = {.lex_state = 192, .external_lex_state = 29},
  [10639] = {.lex_state = 424, .external_lex_state = 25},
  [10640] = {.lex_state = 621, .external_lex_state = 25},
  [10641] = {.lex_state = 621, .external_lex_state = 25},
  [10642] = {.lex_state = 621, .external_lex_state = 25},
  [10643] = {.lex_state = 621, .external_lex_state = 25},
  [10644] = {.lex_state = 128},
  [10645] = {.lex_state = 621, .external_lex_state = 25},
  [10646] = {.lex_state = 621, .external_lex_state = 25},
  [10647] = {.lex_state = 621, .external_lex_state = 25},
  [10648] = {.lex_state = 621, .external_lex_state = 25},
  [10649] = {.lex_state = 621, .external_lex_state = 25},
  [10650] = {.lex_state = 128},
  [10651] = {.lex_state = 361, .external_lex_state = 3},
  [10652] = {.lex_state = 361, .external_lex_state = 3},
  [10653] = {.lex_state = 192, .external_lex_state = 2},
  [10654] = {.lex_state = 192, .external_lex_state = 29},
  [10655] = {.lex_state = 361, .external_lex_state = 3},
  [10656] = {.lex_state = 361, .external_lex_state = 3},
  [10657] = {.lex_state = 361, .external_lex_state = 3},
  [10658] = {.lex_state = 192, .external_lex_state = 2},
  [10659] = {.lex_state = 192, .external_lex_state = 29},
  [10660] = {.lex_state = 424, .external_lex_state = 3},
  [10661] = {.lex_state = 421, .external_lex_state = 3},
  [10662] = {.lex_state = 421, .external_lex_state = 3},
  [10663] = {.lex_state = 192, .external_lex_state = 2},
  [10664] = {.lex_state = 361, .external_lex_state = 3},
  [10665] = {.lex_state = 361, .external_lex_state = 3},
  [10666] = {.lex_state = 192, .external_lex_state = 2},
  [10667] = {.lex_state = 192, .external_lex_state = 29},
  [10668] = {.lex_state = 361, .external_lex_state = 3},
  [10669] = {.lex_state = 361, .external_lex_state = 3},
  [10670] = {.lex_state = 361, .external_lex_state = 3},
  [10671] = {.lex_state = 192, .external_lex_state = 2},
  [10672] = {.lex_state = 192, .external_lex_state = 29},
  [10673] = {.lex_state = 424, .external_lex_state = 3},
  [10674] = {.lex_state = 421, .external_lex_state = 3},
  [10675] = {.lex_state = 421, .external_lex_state = 3},
  [10676] = {.lex_state = 192, .external_lex_state = 2},
  [10677] = {.lex_state = 192, .external_lex_state = 2},
  [10678] = {.lex_state = 192, .external_lex_state = 29},
  [10679] = {.lex_state = 424, .external_lex_state = 25},
  [10680] = {.lex_state = 192, .external_lex_state = 2},
  [10681] = {.lex_state = 192, .external_lex_state = 29},
  [10682] = {.lex_state = 361, .external_lex_state = 3},
  [10683] = {.lex_state = 361, .external_lex_state = 3},
  [10684] = {.lex_state = 361, .external_lex_state = 3},
  [10685] = {.lex_state = 361, .external_lex_state = 3},
  [10686] = {.lex_state = 361, .external_lex_state = 3},
  [10687] = {.lex_state = 192, .external_lex_state = 2},
  [10688] = {.lex_state = 192, .external_lex_state = 2},
  [10689] = {.lex_state = 192, .external_lex_state = 2},
  [10690] = {.lex_state = 192, .external_lex_state = 2},
  [10691] = {.lex_state = 192, .external_lex_state = 2},
  [10692] = {.lex_state = 192, .external_lex_state = 2},
  [10693] = {.lex_state = 192, .external_lex_state = 2},
  [10694] = {.lex_state = 192, .external_lex_state = 2},
  [10695] = {.lex_state = 192, .external_lex_state = 2},
  [10696] = {.lex_state = 192, .external_lex_state = 2},
  [10697] = {.lex_state = 192, .external_lex_state = 29},
  [10698] = {.lex_state = 192, .external_lex_state = 2},
  [10699] = {.lex_state = 365, .external_lex_state = 14},
  [10700] = {.lex_state = 361, .external_lex_state = 3},
  [10701] = {.lex_state = 361, .external_lex_state = 3},
  [10702] = {.lex_state = 361, .external_lex_state = 3},
  [10703] = {.lex_state = 192, .external_lex_state = 2},
  [10704] = {.lex_state = 361, .external_lex_state = 3},
  [10705] = {.lex_state = 192, .external_lex_state = 2},
  [10706] = {.lex_state = 361, .external_lex_state = 3},
  [10707] = {.lex_state = 524, .external_lex_state = 13},
  [10708] = {.lex_state = 361, .external_lex_state = 3},
  [10709] = {.lex_state = 361, .external_lex_state = 3},
  [10710] = {.lex_state = 361, .external_lex_state = 3},
  [10711] = {.lex_state = 361, .external_lex_state = 3},
  [10712] = {.lex_state = 361, .external_lex_state = 3},
  [10713] = {.lex_state = 361, .external_lex_state = 3},
  [10714] = {.lex_state = 361, .external_lex_state = 3},
  [10715] = {.lex_state = 554, .external_lex_state = 16},
  [10716] = {.lex_state = 361, .external_lex_state = 3},
  [10717] = {.lex_state = 361, .external_lex_state = 3},
  [10718] = {.lex_state = 361, .external_lex_state = 3},
  [10719] = {.lex_state = 361, .external_lex_state = 3},
  [10720] = {.lex_state = 421, .external_lex_state = 3},
  [10721] = {.lex_state = 421, .external_lex_state = 3},
  [10722] = {.lex_state = 192, .external_lex_state = 2},
  [10723] = {.lex_state = 421, .external_lex_state = 3},
  [10724] = {.lex_state = 192, .external_lex_state = 2},
  [10725] = {.lex_state = 421, .external_lex_state = 3},
  [10726] = {.lex_state = 524, .external_lex_state = 13},
  [10727] = {.lex_state = 421, .external_lex_state = 3},
  [10728] = {.lex_state = 262, .external_lex_state = 3},
  [10729] = {.lex_state = 524, .external_lex_state = 21},
  [10730] = {.lex_state = 262, .external_lex_state = 3},
  [10731] = {.lex_state = 361, .external_lex_state = 3},
  [10732] = {.lex_state = 361, .external_lex_state = 3},
  [10733] = {.lex_state = 361, .external_lex_state = 3},
  [10734] = {.lex_state = 361, .external_lex_state = 3},
  [10735] = {.lex_state = 361, .external_lex_state = 14},
  [10736] = {.lex_state = 254, .external_lex_state = 8},
  [10737] = {.lex_state = 128, .external_lex_state = 2},
  [10738] = {.lex_state = 192, .external_lex_state = 2},
  [10739] = {.lex_state = 424, .external_lex_state = 3},
  [10740] = {.lex_state = 424, .external_lex_state = 3},
  [10741] = {.lex_state = 192, .external_lex_state = 2},
  [10742] = {.lex_state = 192, .external_lex_state = 2},
  [10743] = {.lex_state = 192, .external_lex_state = 2},
  [10744] = {.lex_state = 192, .external_lex_state = 2},
  [10745] = {.lex_state = 192, .external_lex_state = 2},
  [10746] = {.lex_state = 192, .external_lex_state = 2},
  [10747] = {.lex_state = 192, .external_lex_state = 2},
  [10748] = {.lex_state = 192, .external_lex_state = 2},
  [10749] = {.lex_state = 192, .external_lex_state = 2},
  [10750] = {.lex_state = 192, .external_lex_state = 2},
  [10751] = {.lex_state = 192, .external_lex_state = 29},
  [10752] = {.lex_state = 192, .external_lex_state = 2},
  [10753] = {.lex_state = 424, .external_lex_state = 14},
  [10754] = {.lex_state = 424, .external_lex_state = 3},
  [10755] = {.lex_state = 424, .external_lex_state = 3},
  [10756] = {.lex_state = 421, .external_lex_state = 3},
  [10757] = {.lex_state = 421, .external_lex_state = 3},
  [10758] = {.lex_state = 421, .external_lex_state = 3},
  [10759] = {.lex_state = 421, .external_lex_state = 3},
  [10760] = {.lex_state = 421, .external_lex_state = 3},
  [10761] = {.lex_state = 554, .external_lex_state = 16},
  [10762] = {.lex_state = 421, .external_lex_state = 3},
  [10763] = {.lex_state = 421, .external_lex_state = 3},
  [10764] = {.lex_state = 421, .external_lex_state = 3},
  [10765] = {.lex_state = 421, .external_lex_state = 3},
  [10766] = {.lex_state = 424, .external_lex_state = 3},
  [10767] = {.lex_state = 524, .external_lex_state = 21},
  [10768] = {.lex_state = 424, .external_lex_state = 3},
  [10769] = {.lex_state = 424, .external_lex_state = 3},
  [10770] = {.lex_state = 421, .external_lex_state = 3},
  [10771] = {.lex_state = 421, .external_lex_state = 3},
  [10772] = {.lex_state = 421, .external_lex_state = 3},
  [10773] = {.lex_state = 421, .external_lex_state = 14},
  [10774] = {.lex_state = 528, .external_lex_state = 3},
  [10775] = {.lex_state = 528, .external_lex_state = 3},
  [10776] = {.lex_state = 528, .external_lex_state = 3},
  [10777] = {.lex_state = 192, .external_lex_state = 2},
  [10778] = {.lex_state = 192, .external_lex_state = 2},
  [10779] = {.lex_state = 192, .external_lex_state = 2},
  [10780] = {.lex_state = 192, .external_lex_state = 2},
  [10781] = {.lex_state = 192, .external_lex_state = 2},
  [10782] = {.lex_state = 192, .external_lex_state = 2},
  [10783] = {.lex_state = 192, .external_lex_state = 2},
  [10784] = {.lex_state = 192, .external_lex_state = 2},
  [10785] = {.lex_state = 192, .external_lex_state = 2},
  [10786] = {.lex_state = 192, .external_lex_state = 2},
  [10787] = {.lex_state = 192, .external_lex_state = 29},
  [10788] = {.lex_state = 528, .external_lex_state = 3},
  [10789] = {.lex_state = 192, .external_lex_state = 29},
  [10790] = {.lex_state = 192, .external_lex_state = 2},
  [10791] = {.lex_state = 192, .external_lex_state = 2},
  [10792] = {.lex_state = 192, .external_lex_state = 29},
  [10793] = {.lex_state = 424, .external_lex_state = 3},
  [10794] = {.lex_state = 350, .external_lex_state = 23},
  [10795] = {.lex_state = 508, .external_lex_state = 3},
  [10796] = {.lex_state = 508, .external_lex_state = 3},
  [10797] = {.lex_state = 508, .external_lex_state = 3},
  [10798] = {.lex_state = 524, .external_lex_state = 21},
  [10799] = {.lex_state = 508, .external_lex_state = 3},
  [10800] = {.lex_state = 508, .external_lex_state = 3},
  [10801] = {.lex_state = 192, .external_lex_state = 2},
  [10802] = {.lex_state = 192, .external_lex_state = 29},
  [10803] = {.lex_state = 508, .external_lex_state = 3},
  [10804] = {.lex_state = 508, .external_lex_state = 3},
  [10805] = {.lex_state = 508, .external_lex_state = 3},
  [10806] = {.lex_state = 361, .external_lex_state = 3},
  [10807] = {.lex_state = 361, .external_lex_state = 3},
  [10808] = {.lex_state = 424, .external_lex_state = 3},
  [10809] = {.lex_state = 424, .external_lex_state = 3},
  [10810] = {.lex_state = 528, .external_lex_state = 3},
  [10811] = {.lex_state = 361, .external_lex_state = 3},
  [10812] = {.lex_state = 361, .external_lex_state = 3},
  [10813] = {.lex_state = 424, .external_lex_state = 3},
  [10814] = {.lex_state = 424, .external_lex_state = 3},
  [10815] = {.lex_state = 528, .external_lex_state = 3},
  [10816] = {.lex_state = 406, .external_lex_state = 25},
  [10817] = {.lex_state = 406, .external_lex_state = 25},
  [10818] = {.lex_state = 537, .external_lex_state = 25},
  [10819] = {.lex_state = 537, .external_lex_state = 25},
  [10820] = {.lex_state = 361, .external_lex_state = 25},
  [10821] = {.lex_state = 361, .external_lex_state = 25},
  [10822] = {.lex_state = 192, .external_lex_state = 2},
  [10823] = {.lex_state = 192, .external_lex_state = 2},
  [10824] = {.lex_state = 192, .external_lex_state = 2},
  [10825] = {.lex_state = 192, .external_lex_state = 2},
  [10826] = {.lex_state = 192, .external_lex_state = 2},
  [10827] = {.lex_state = 192, .external_lex_state = 2},
  [10828] = {.lex_state = 192, .external_lex_state = 2},
  [10829] = {.lex_state = 192, .external_lex_state = 2},
  [10830] = {.lex_state = 192, .external_lex_state = 2},
  [10831] = {.lex_state = 192, .external_lex_state = 2},
  [10832] = {.lex_state = 192, .external_lex_state = 29},
  [10833] = {.lex_state = 192, .external_lex_state = 2},
  [10834] = {.lex_state = 365, .external_lex_state = 27},
  [10835] = {.lex_state = 361, .external_lex_state = 25},
  [10836] = {.lex_state = 361, .external_lex_state = 25},
  [10837] = {.lex_state = 361, .external_lex_state = 25},
  [10838] = {.lex_state = 192, .external_lex_state = 2},
  [10839] = {.lex_state = 361, .external_lex_state = 25},
  [10840] = {.lex_state = 192, .external_lex_state = 2},
  [10841] = {.lex_state = 361, .external_lex_state = 25},
  [10842] = {.lex_state = 524, .external_lex_state = 13},
  [10843] = {.lex_state = 361, .external_lex_state = 25},
  [10844] = {.lex_state = 361, .external_lex_state = 25},
  [10845] = {.lex_state = 361, .external_lex_state = 25},
  [10846] = {.lex_state = 361, .external_lex_state = 25},
  [10847] = {.lex_state = 361, .external_lex_state = 25},
  [10848] = {.lex_state = 361, .external_lex_state = 25},
  [10849] = {.lex_state = 361, .external_lex_state = 25},
  [10850] = {.lex_state = 554, .external_lex_state = 16},
  [10851] = {.lex_state = 361, .external_lex_state = 25},
  [10852] = {.lex_state = 361, .external_lex_state = 25},
  [10853] = {.lex_state = 361, .external_lex_state = 25},
  [10854] = {.lex_state = 361, .external_lex_state = 25},
  [10855] = {.lex_state = 421, .external_lex_state = 25},
  [10856] = {.lex_state = 421, .external_lex_state = 25},
  [10857] = {.lex_state = 192, .external_lex_state = 2},
  [10858] = {.lex_state = 421, .external_lex_state = 25},
  [10859] = {.lex_state = 192, .external_lex_state = 2},
  [10860] = {.lex_state = 421, .external_lex_state = 25},
  [10861] = {.lex_state = 524, .external_lex_state = 13},
  [10862] = {.lex_state = 421, .external_lex_state = 25},
  [10863] = {.lex_state = 361, .external_lex_state = 25},
  [10864] = {.lex_state = 524, .external_lex_state = 21},
  [10865] = {.lex_state = 361, .external_lex_state = 25},
  [10866] = {.lex_state = 361, .external_lex_state = 25},
  [10867] = {.lex_state = 361, .external_lex_state = 25},
  [10868] = {.lex_state = 361, .external_lex_state = 25},
  [10869] = {.lex_state = 361, .external_lex_state = 25},
  [10870] = {.lex_state = 361, .external_lex_state = 27},
  [10871] = {.lex_state = 192, .external_lex_state = 2},
  [10872] = {.lex_state = 424, .external_lex_state = 25},
  [10873] = {.lex_state = 424, .external_lex_state = 25},
  [10874] = {.lex_state = 192, .external_lex_state = 2},
  [10875] = {.lex_state = 192, .external_lex_state = 2},
  [10876] = {.lex_state = 192, .external_lex_state = 2},
  [10877] = {.lex_state = 192, .external_lex_state = 2},
  [10878] = {.lex_state = 192, .external_lex_state = 2},
  [10879] = {.lex_state = 192, .external_lex_state = 2},
  [10880] = {.lex_state = 192, .external_lex_state = 2},
  [10881] = {.lex_state = 192, .external_lex_state = 2},
  [10882] = {.lex_state = 192, .external_lex_state = 2},
  [10883] = {.lex_state = 192, .external_lex_state = 2},
  [10884] = {.lex_state = 192, .external_lex_state = 29},
  [10885] = {.lex_state = 192, .external_lex_state = 2},
  [10886] = {.lex_state = 424, .external_lex_state = 27},
  [10887] = {.lex_state = 424, .external_lex_state = 25},
  [10888] = {.lex_state = 424, .external_lex_state = 25},
  [10889] = {.lex_state = 421, .external_lex_state = 25},
  [10890] = {.lex_state = 421, .external_lex_state = 25},
  [10891] = {.lex_state = 421, .external_lex_state = 25},
  [10892] = {.lex_state = 421, .external_lex_state = 25},
  [10893] = {.lex_state = 421, .external_lex_state = 25},
  [10894] = {.lex_state = 554, .external_lex_state = 16},
  [10895] = {.lex_state = 421, .external_lex_state = 25},
  [10896] = {.lex_state = 421, .external_lex_state = 25},
  [10897] = {.lex_state = 421, .external_lex_state = 25},
  [10898] = {.lex_state = 421, .external_lex_state = 25},
  [10899] = {.lex_state = 424, .external_lex_state = 25},
  [10900] = {.lex_state = 524, .external_lex_state = 21},
  [10901] = {.lex_state = 424, .external_lex_state = 25},
  [10902] = {.lex_state = 424, .external_lex_state = 25},
  [10903] = {.lex_state = 421, .external_lex_state = 25},
  [10904] = {.lex_state = 421, .external_lex_state = 25},
  [10905] = {.lex_state = 421, .external_lex_state = 25},
  [10906] = {.lex_state = 421, .external_lex_state = 27},
  [10907] = {.lex_state = 302, .external_lex_state = 16},
  [10908] = {.lex_state = 192, .external_lex_state = 29},
  [10909] = {.lex_state = 302, .external_lex_state = 16},
  [10910] = {.lex_state = 286, .external_lex_state = 2},
  [10911] = {.lex_state = 237},
  [10912] = {.lex_state = 128, .external_lex_state = 12},
  [10913] = {.lex_state = 237},
  [10914] = {.lex_state = 645, .external_lex_state = 25},
  [10915] = {.lex_state = 645, .external_lex_state = 25},
  [10916] = {.lex_state = 559, .external_lex_state = 25},
  [10917] = {.lex_state = 559, .external_lex_state = 25},
  [10918] = {.lex_state = 554, .external_lex_state = 16},
  [10919] = {.lex_state = 227, .external_lex_state = 3},
  [10920] = {.lex_state = 436, .external_lex_state = 3},
  [10921] = {.lex_state = 461, .external_lex_state = 25},
  [10922] = {.lex_state = 461, .external_lex_state = 25},
  [10923] = {.lex_state = 461, .external_lex_state = 25},
  [10924] = {.lex_state = 461, .external_lex_state = 25},
  [10925] = {.lex_state = 128},
  [10926] = {.lex_state = 461, .external_lex_state = 25},
  [10927] = {.lex_state = 461, .external_lex_state = 25},
  [10928] = {.lex_state = 461, .external_lex_state = 25},
  [10929] = {.lex_state = 461, .external_lex_state = 25},
  [10930] = {.lex_state = 678, .external_lex_state = 8},
  [10931] = {.lex_state = 424, .external_lex_state = 25},
  [10932] = {.lex_state = 424, .external_lex_state = 25},
  [10933] = {.lex_state = 621, .external_lex_state = 25},
  [10934] = {.lex_state = 621, .external_lex_state = 25},
  [10935] = {.lex_state = 361, .external_lex_state = 3},
  [10936] = {.lex_state = 361, .external_lex_state = 3},
  [10937] = {.lex_state = 424, .external_lex_state = 3},
  [10938] = {.lex_state = 424, .external_lex_state = 3},
  [10939] = {.lex_state = 528, .external_lex_state = 3},
  [10940] = {.lex_state = 361, .external_lex_state = 3},
  [10941] = {.lex_state = 361, .external_lex_state = 3},
  [10942] = {.lex_state = 424, .external_lex_state = 3},
  [10943] = {.lex_state = 424, .external_lex_state = 3},
  [10944] = {.lex_state = 528, .external_lex_state = 3},
  [10945] = {.lex_state = 424, .external_lex_state = 25},
  [10946] = {.lex_state = 424, .external_lex_state = 25},
  [10947] = {.lex_state = 361, .external_lex_state = 3},
  [10948] = {.lex_state = 361, .external_lex_state = 3},
  [10949] = {.lex_state = 361, .external_lex_state = 3},
  [10950] = {.lex_state = 361, .external_lex_state = 3},
  [10951] = {.lex_state = 361, .external_lex_state = 3},
  [10952] = {.lex_state = 361, .external_lex_state = 3},
  [10953] = {.lex_state = 361, .external_lex_state = 3},
  [10954] = {.lex_state = 361, .external_lex_state = 3},
  [10955] = {.lex_state = 361, .external_lex_state = 3},
  [10956] = {.lex_state = 554, .external_lex_state = 16},
  [10957] = {.lex_state = 361, .external_lex_state = 3},
  [10958] = {.lex_state = 361, .external_lex_state = 3},
  [10959] = {.lex_state = 361, .external_lex_state = 3},
  [10960] = {.lex_state = 361, .external_lex_state = 3},
  [10961] = {.lex_state = 361, .external_lex_state = 3},
  [10962] = {.lex_state = 361, .external_lex_state = 3},
  [10963] = {.lex_state = 361, .external_lex_state = 3},
  [10964] = {.lex_state = 365, .external_lex_state = 14},
  [10965] = {.lex_state = 361, .external_lex_state = 3},
  [10966] = {.lex_state = 361, .external_lex_state = 3},
  [10967] = {.lex_state = 361, .external_lex_state = 3},
  [10968] = {.lex_state = 524, .external_lex_state = 21},
  [10969] = {.lex_state = 361, .external_lex_state = 3},
  [10970] = {.lex_state = 361, .external_lex_state = 3},
  [10971] = {.lex_state = 192, .external_lex_state = 2},
  [10972] = {.lex_state = 421, .external_lex_state = 3},
  [10973] = {.lex_state = 421, .external_lex_state = 3},
  [10974] = {.lex_state = 421, .external_lex_state = 3},
  [10975] = {.lex_state = 524, .external_lex_state = 21},
  [10976] = {.lex_state = 421, .external_lex_state = 3},
  [10977] = {.lex_state = 421, .external_lex_state = 3},
  [10978] = {.lex_state = 192, .external_lex_state = 29},
  [10979] = {.lex_state = 361, .external_lex_state = 3},
  [10980] = {.lex_state = 247, .external_lex_state = 3},
  [10981] = {.lex_state = 424, .external_lex_state = 3},
  [10982] = {.lex_state = 424, .external_lex_state = 3},
  [10983] = {.lex_state = 424, .external_lex_state = 3},
  [10984] = {.lex_state = 424, .external_lex_state = 3},
  [10985] = {.lex_state = 424, .external_lex_state = 3},
  [10986] = {.lex_state = 554, .external_lex_state = 16},
  [10987] = {.lex_state = 424, .external_lex_state = 3},
  [10988] = {.lex_state = 424, .external_lex_state = 3},
  [10989] = {.lex_state = 424, .external_lex_state = 3},
  [10990] = {.lex_state = 424, .external_lex_state = 3},
  [10991] = {.lex_state = 424, .external_lex_state = 3},
  [10992] = {.lex_state = 424, .external_lex_state = 3},
  [10993] = {.lex_state = 424, .external_lex_state = 3},
  [10994] = {.lex_state = 424, .external_lex_state = 14},
  [10995] = {.lex_state = 192, .external_lex_state = 2},
  [10996] = {.lex_state = 192, .external_lex_state = 29},
  [10997] = {.lex_state = 421, .external_lex_state = 3},
  [10998] = {.lex_state = 528, .external_lex_state = 3},
  [10999] = {.lex_state = 528, .external_lex_state = 3},
  [11000] = {.lex_state = 528, .external_lex_state = 3},
  [11001] = {.lex_state = 528, .external_lex_state = 3},
  [11002] = {.lex_state = 528, .external_lex_state = 3},
  [11003] = {.lex_state = 554, .external_lex_state = 16},
  [11004] = {.lex_state = 528, .external_lex_state = 3},
  [11005] = {.lex_state = 528, .external_lex_state = 3},
  [11006] = {.lex_state = 528, .external_lex_state = 3},
  [11007] = {.lex_state = 528, .external_lex_state = 3},
  [11008] = {.lex_state = 528, .external_lex_state = 3},
  [11009] = {.lex_state = 528, .external_lex_state = 3},
  [11010] = {.lex_state = 528, .external_lex_state = 3},
  [11011] = {.lex_state = 424, .external_lex_state = 3},
  [11012] = {.lex_state = 424, .external_lex_state = 3},
  [11013] = {.lex_state = 508, .external_lex_state = 3},
  [11014] = {.lex_state = 508, .external_lex_state = 3},
  [11015] = {.lex_state = 361, .external_lex_state = 25},
  [11016] = {.lex_state = 361, .external_lex_state = 25},
  [11017] = {.lex_state = 361, .external_lex_state = 25},
  [11018] = {.lex_state = 361, .external_lex_state = 25},
  [11019] = {.lex_state = 361, .external_lex_state = 25},
  [11020] = {.lex_state = 554, .external_lex_state = 16},
  [11021] = {.lex_state = 361, .external_lex_state = 25},
  [11022] = {.lex_state = 361, .external_lex_state = 25},
  [11023] = {.lex_state = 361, .external_lex_state = 25},
  [11024] = {.lex_state = 361, .external_lex_state = 25},
  [11025] = {.lex_state = 361, .external_lex_state = 25},
  [11026] = {.lex_state = 361, .external_lex_state = 25},
  [11027] = {.lex_state = 361, .external_lex_state = 25},
  [11028] = {.lex_state = 365, .external_lex_state = 27},
  [11029] = {.lex_state = 361, .external_lex_state = 25},
  [11030] = {.lex_state = 361, .external_lex_state = 25},
  [11031] = {.lex_state = 361, .external_lex_state = 25},
  [11032] = {.lex_state = 524, .external_lex_state = 21},
  [11033] = {.lex_state = 361, .external_lex_state = 25},
  [11034] = {.lex_state = 361, .external_lex_state = 25},
  [11035] = {.lex_state = 192, .external_lex_state = 2},
  [11036] = {.lex_state = 421, .external_lex_state = 25},
  [11037] = {.lex_state = 421, .external_lex_state = 25},
  [11038] = {.lex_state = 421, .external_lex_state = 25},
  [11039] = {.lex_state = 524, .external_lex_state = 21},
  [11040] = {.lex_state = 421, .external_lex_state = 25},
  [11041] = {.lex_state = 421, .external_lex_state = 25},
  [11042] = {.lex_state = 192, .external_lex_state = 29},
  [11043] = {.lex_state = 361, .external_lex_state = 25},
  [11044] = {.lex_state = 302, .external_lex_state = 16},
  [11045] = {.lex_state = 424, .external_lex_state = 25},
  [11046] = {.lex_state = 424, .external_lex_state = 25},
  [11047] = {.lex_state = 424, .external_lex_state = 25},
  [11048] = {.lex_state = 424, .external_lex_state = 25},
  [11049] = {.lex_state = 424, .external_lex_state = 25},
  [11050] = {.lex_state = 554, .external_lex_state = 16},
  [11051] = {.lex_state = 424, .external_lex_state = 25},
  [11052] = {.lex_state = 424, .external_lex_state = 25},
  [11053] = {.lex_state = 424, .external_lex_state = 25},
  [11054] = {.lex_state = 424, .external_lex_state = 25},
  [11055] = {.lex_state = 424, .external_lex_state = 25},
  [11056] = {.lex_state = 424, .external_lex_state = 25},
  [11057] = {.lex_state = 424, .external_lex_state = 25},
  [11058] = {.lex_state = 424, .external_lex_state = 27},
  [11059] = {.lex_state = 192, .external_lex_state = 2},
  [11060] = {.lex_state = 192, .external_lex_state = 29},
  [11061] = {.lex_state = 421, .external_lex_state = 25},
  [11062] = {.lex_state = 302, .external_lex_state = 16},
  [11063] = {.lex_state = 286, .external_lex_state = 2},
  [11064] = {.lex_state = 128, .external_lex_state = 12},
  [11065] = {.lex_state = 461, .external_lex_state = 25},
  [11066] = {.lex_state = 361, .external_lex_state = 3},
  [11067] = {.lex_state = 361, .external_lex_state = 3},
  [11068] = {.lex_state = 192, .external_lex_state = 2},
  [11069] = {.lex_state = 192, .external_lex_state = 29},
  [11070] = {.lex_state = 361, .external_lex_state = 3},
  [11071] = {.lex_state = 361, .external_lex_state = 3},
  [11072] = {.lex_state = 361, .external_lex_state = 3},
  [11073] = {.lex_state = 192, .external_lex_state = 2},
  [11074] = {.lex_state = 192, .external_lex_state = 29},
  [11075] = {.lex_state = 424, .external_lex_state = 3},
  [11076] = {.lex_state = 421, .external_lex_state = 3},
  [11077] = {.lex_state = 421, .external_lex_state = 3},
  [11078] = {.lex_state = 192, .external_lex_state = 2},
  [11079] = {.lex_state = 192, .external_lex_state = 2},
  [11080] = {.lex_state = 192, .external_lex_state = 29},
  [11081] = {.lex_state = 361, .external_lex_state = 25},
  [11082] = {.lex_state = 361, .external_lex_state = 25},
  [11083] = {.lex_state = 361, .external_lex_state = 25},
  [11084] = {.lex_state = 192, .external_lex_state = 2},
  [11085] = {.lex_state = 192, .external_lex_state = 29},
  [11086] = {.lex_state = 424, .external_lex_state = 25},
  [11087] = {.lex_state = 421, .external_lex_state = 25},
  [11088] = {.lex_state = 421, .external_lex_state = 25},
  [11089] = {.lex_state = 361, .external_lex_state = 3},
  [11090] = {.lex_state = 361, .external_lex_state = 3},
  [11091] = {.lex_state = 424, .external_lex_state = 3},
  [11092] = {.lex_state = 424, .external_lex_state = 3},
  [11093] = {.lex_state = 528, .external_lex_state = 3},
  [11094] = {.lex_state = 361, .external_lex_state = 25},
  [11095] = {.lex_state = 361, .external_lex_state = 25},
  [11096] = {.lex_state = 424, .external_lex_state = 25},
  [11097] = {.lex_state = 424, .external_lex_state = 25},
};

enum {
  ts_external_token__line_break,
  ts_external_token__simple_symbol,
  ts_external_token__string_start,
  ts_external_token__symbol_start,
  ts_external_token__subshell_start,
  ts_external_token__regex_start,
  ts_external_token__string_array_start,
  ts_external_token__symbol_array_start,
  ts_external_token__heredoc_body_start,
  ts_external_token__string_content,
  ts_external_token__heredoc_content,
  ts_external_token__string_end,
  ts_external_token_heredoc_end,
  ts_external_token_heredoc_beginning,
  ts_external_token_SLASH,
  ts_external_token__block_ampersand,
  ts_external_token__splat_star,
  ts_external_token__unary_minus,
  ts_external_token__binary_minus,
  ts_external_token__binary_star,
  ts_external_token__singleton_class_left_angle_left_langle,
  ts_external_token__identifier_hash_key,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__line_break] = sym__line_break,
  [ts_external_token__simple_symbol] = sym__simple_symbol,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__symbol_start] = sym__symbol_start,
  [ts_external_token__subshell_start] = sym__subshell_start,
  [ts_external_token__regex_start] = sym__regex_start,
  [ts_external_token__string_array_start] = sym__string_array_start,
  [ts_external_token__symbol_array_start] = sym__symbol_array_start,
  [ts_external_token__heredoc_body_start] = sym__heredoc_body_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__heredoc_content] = sym__heredoc_content,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_heredoc_beginning] = sym_heredoc_beginning,
  [ts_external_token_SLASH] = anon_sym_SLASH,
  [ts_external_token__block_ampersand] = sym__block_ampersand,
  [ts_external_token__splat_star] = sym__splat_star,
  [ts_external_token__unary_minus] = sym__unary_minus,
  [ts_external_token__binary_minus] = sym__binary_minus,
  [ts_external_token__binary_star] = sym__binary_star,
  [ts_external_token__singleton_class_left_angle_left_langle] = sym__singleton_class_left_angle_left_langle,
  [ts_external_token__identifier_hash_key] = sym__identifier_hash_key,
};

static bool ts_external_scanner_states[31][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__heredoc_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [2] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [3] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [4] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [5] = {
    [ts_external_token__line_break] = true,
  },
  [6] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [7] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [8] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [9] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
  },
  [10] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
  },
  [11] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [12] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [13] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [14] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [15] = {
    [ts_external_token__string_end] = true,
  },
  [16] = {
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [17] = {
    [ts_external_token__heredoc_content] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [18] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [19] = {
    [ts_external_token__heredoc_body_start] = true,
  },
  [20] = {
    [ts_external_token__string_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [21] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [22] = {
    [ts_external_token__string_start] = true,
  },
  [23] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [24] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [25] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [26] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [27] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [28] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [29] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [30] = {
    [ts_external_token__string_content] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__line_break] = ACTIONS(1),
    [sym__simple_symbol] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__symbol_start] = ACTIONS(1),
    [sym__subshell_start] = ACTIONS(1),
    [sym__regex_start] = ACTIONS(1),
    [sym__string_array_start] = ACTIONS(1),
    [sym__symbol_array_start] = ACTIONS(1),
    [sym__heredoc_body_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__heredoc_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym_heredoc_beginning] = ACTIONS(1),
    [sym__block_ampersand] = ACTIONS(1),
    [sym__splat_star] = ACTIONS(1),
    [sym__unary_minus] = ACTIONS(1),
    [sym__binary_minus] = ACTIONS(1),
    [sym__binary_star] = ACTIONS(1),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1),
    [sym__identifier_hash_key] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym___END__] = ACTIONS(3),
    [anon_sym_BEGIN] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(3),
    [anon_sym_def] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_STAR_STAR] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_class] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3),
    [anon_sym_end] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_yield] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(3),
    [anon_sym_next] = ACTIONS(3),
    [sym_redo] = ACTIONS(3),
    [sym_retry] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_unless] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(3),
    [anon_sym_rescue] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_when] = ACTIONS(3),
    [anon_sym_elsif] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_then] = ACTIONS(3),
    [anon_sym_begin] = ACTIONS(3),
    [anon_sym_ensure] = ACTIONS(3),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [anon_sym_AMP_DOT] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(3),
    [anon_sym_COLON2] = ACTIONS(3),
    [anon_sym_DOT_DOT] = ACTIONS(3),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(3),
    [anon_sym_or] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_EQ_EQ] = ACTIONS(3),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_defined_QMARK] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [sym_constant] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_instance_variable] = ACTIONS(1),
    [sym_class_variable] = ACTIONS(1),
    [sym_global_variable] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_PLUS_AT] = ACTIONS(1),
    [anon_sym_DASH_AT] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(3),
    [anon_sym_alias] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(3),
    [sym_float] = ACTIONS(3),
    [anon_sym_r] = ACTIONS(3),
    [sym_super] = ACTIONS(3),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_TRUE] = ACTIONS(3),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_FALSE] = ACTIONS(3),
    [sym_self] = ACTIONS(3),
    [anon_sym_nil] = ACTIONS(3),
    [anon_sym_NIL] = ACTIONS(3),
    [sym_character] = ACTIONS(1),
    [anon_sym_POUND_LBRACE] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(42),
    [sym__statements] = STATE(43),
    [sym__top_level_statement] = STATE(44),
    [sym_begin_block] = STATE(44),
    [sym_end_block] = STATE(44),
    [sym__statement] = STATE(45),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(45),
    [sym_unless_modifier] = STATE(45),
    [sym_while_modifier] = STATE(45),
    [sym_until_modifier] = STATE(45),
    [sym_rescue_modifier] = STATE(45),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(46),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(46),
    [sym_operator_assignment] = STATE(46),
    [sym_conditional] = STATE(46),
    [sym_range] = STATE(46),
    [sym_binary] = STATE(46),
    [sym_unary] = STATE(46),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_undef] = STATE(45),
    [sym_alias] = STATE(45),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(45),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [ts_builtin_sym_end] = ACTIONS(23),
    [anon_sym___END__] = ACTIONS(25),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [anon_sym_undef] = ACTIONS(83),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2] = {
    [sym__line_break] = ACTIONS(101),
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_when] = ACTIONS(101),
    [anon_sym_elsif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_then] = ACTIONS(101),
    [anon_sym_ensure] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [3] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(56),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(107),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [4] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(59),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(113),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [5] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(61),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(115),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [6] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(63),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(117),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [7] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(67),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(121),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(125),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [8] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(71),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(129),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(131),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [9] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(72),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(72),
    [sym_operator_assignment] = STATE(72),
    [sym_conditional] = STATE(72),
    [sym_range] = STATE(72),
    [sym_binary] = STATE(72),
    [sym_unary] = STATE(72),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10] = {
    [sym__line_break] = ACTIONS(133),
    [sym_comment] = ACTIONS(87),
  },
  [11] = {
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_comment] = ACTIONS(87),
  },
  [12] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(120),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(121),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(161),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [13] = {
    [anon_sym_LBRACE] = ACTIONS(227),
    [sym_comment] = ACTIONS(87),
  },
  [14] = {
    [sym__method_rest] = STATE(130),
    [sym__variable] = STATE(131),
    [sym_operator] = STATE(132),
    [sym__method_name] = STATE(132),
    [sym_setter] = STATE(132),
    [sym_symbol] = STATE(132),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(243),
    [sym_self] = ACTIONS(243),
  },
  [15] = {
    [sym__statements] = STATE(143),
    [sym__top_level_statement] = STATE(144),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(149),
    [sym__simple_mlhs] = STATE(150),
    [sym_destructured_left_assignment] = STATE(150),
    [sym_rest_assignment] = STATE(150),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [16] = {
    [sym_constant] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_comment] = ACTIONS(87),
  },
  [17] = {
    [sym__line_break] = ACTIONS(275),
    [sym__heredoc_body_start] = ACTIONS(275),
    [ts_builtin_sym_end] = ACTIONS(275),
    [anon_sym___END__] = ACTIONS(275),
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(275),
    [anon_sym_end] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_unless] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_until] = ACTIONS(275),
    [anon_sym_rescue] = ACTIONS(275),
    [anon_sym_when] = ACTIONS(275),
    [anon_sym_elsif] = ACTIONS(275),
    [anon_sym_else] = ACTIONS(275),
    [anon_sym_then] = ACTIONS(275),
    [anon_sym_ensure] = ACTIONS(275),
    [sym_comment] = ACTIONS(87),
  },
  [18] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(186),
    [sym_scope_resolution] = STATE(185),
    [sym_call] = STATE(185),
    [sym_method_call] = STATE(186),
    [sym__lhs] = STATE(186),
    [sym__variable] = STATE(185),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(186),
    [sym_false] = STATE(186),
    [sym_nil] = STATE(186),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_EQ] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(331),
    [sym_identifier] = ACTIONS(331),
    [sym_instance_variable] = ACTIONS(333),
    [sym_class_variable] = ACTIONS(333),
    [sym_global_variable] = ACTIONS(333),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(331),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(331),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [19] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(192),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(355),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [20] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(195),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(361),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [21] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(217),
    [sym__argument] = STATE(218),
    [sym_splat_argument] = STATE(218),
    [sym_hash_splat_argument] = STATE(218),
    [sym_block_argument] = STATE(218),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(218),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(363),
    [anon_sym___END__] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [22] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(217),
    [sym__argument] = STATE(218),
    [sym_splat_argument] = STATE(218),
    [sym_hash_splat_argument] = STATE(218),
    [sym_block_argument] = STATE(218),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(218),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [23] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(217),
    [sym__argument] = STATE(218),
    [sym_splat_argument] = STATE(218),
    [sym_hash_splat_argument] = STATE(218),
    [sym_block_argument] = STATE(218),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(218),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [24] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(217),
    [sym__argument] = STATE(218),
    [sym_splat_argument] = STATE(218),
    [sym_hash_splat_argument] = STATE(218),
    [sym_block_argument] = STATE(218),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(218),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [25] = {
    [sym__statement] = STATE(233),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(233),
    [sym_unless_modifier] = STATE(233),
    [sym_while_modifier] = STATE(233),
    [sym_until_modifier] = STATE(233),
    [sym_rescue_modifier] = STATE(233),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(233),
    [sym_alias] = STATE(233),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(233),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [26] = {
    [sym__statement] = STATE(239),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(239),
    [sym_unless_modifier] = STATE(239),
    [sym_while_modifier] = STATE(239),
    [sym_until_modifier] = STATE(239),
    [sym_rescue_modifier] = STATE(239),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(239),
    [sym_alias] = STATE(239),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(239),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [27] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(247),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(247),
    [sym_operator_assignment] = STATE(247),
    [sym_conditional] = STATE(247),
    [sym_range] = STATE(247),
    [sym_binary] = STATE(247),
    [sym_unary] = STATE(247),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [28] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(252),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(252),
    [sym_operator_assignment] = STATE(252),
    [sym_conditional] = STATE(252),
    [sym_range] = STATE(252),
    [sym_binary] = STATE(252),
    [sym_unary] = STATE(252),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [29] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(256),
    [sym__simple_mlhs] = STATE(257),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [30] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(266),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(266),
    [sym_operator_assignment] = STATE(266),
    [sym_conditional] = STATE(266),
    [sym_range] = STATE(266),
    [sym_binary] = STATE(266),
    [sym_unary] = STATE(266),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(271),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__terminator] = STATE(271),
    [sym__line_break] = ACTIONS(481),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [31] = {
    [sym__statements] = STATE(285),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(288),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(289),
    [sym_rescue] = STATE(290),
    [sym__body_statement] = STATE(291),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(297),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__terminator] = STATE(297),
    [sym__line_break] = ACTIONS(505),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(513),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [32] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(298),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(298),
    [sym_operator_assignment] = STATE(298),
    [sym_conditional] = STATE(298),
    [sym_range] = STATE(298),
    [sym_binary] = STATE(298),
    [sym_unary] = STATE(298),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [33] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [34] = {
    [sym_operator] = STATE(301),
    [sym__method_name] = STATE(301),
    [sym_setter] = STATE(301),
    [sym_symbol] = STATE(301),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(543),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(543),
    [sym_class_variable] = ACTIONS(543),
    [sym_global_variable] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [35] = {
    [sym_operator] = STATE(306),
    [sym__method_name] = STATE(306),
    [sym_setter] = STATE(306),
    [sym_symbol] = STATE(306),
    [sym__simple_symbol] = ACTIONS(547),
    [sym__symbol_start] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_STAR] = ACTIONS(553),
    [anon_sym_STAR_STAR] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_DOT_DOT] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(551),
    [anon_sym_LT_EQ_GT] = ACTIONS(551),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_BANG_TILDE] = ACTIONS(551),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_EQ] = ACTIONS(551),
    [anon_sym_CARET] = ACTIONS(551),
    [anon_sym_PLUS] = ACTIONS(553),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_PERCENT] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(551),
    [sym_constant] = ACTIONS(555),
    [sym_identifier] = ACTIONS(557),
    [sym_instance_variable] = ACTIONS(555),
    [sym_class_variable] = ACTIONS(555),
    [sym_global_variable] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(553),
    [anon_sym_PLUS_AT] = ACTIONS(551),
    [anon_sym_DASH_AT] = ACTIONS(551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(553),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [sym_comment] = ACTIONS(87),
  },
  [36] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(563),
  },
  [37] = {
    [sym__line_break] = ACTIONS(565),
    [sym__heredoc_body_start] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [ts_builtin_sym_end] = ACTIONS(565),
    [anon_sym___END__] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_end] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_when] = ACTIONS(565),
    [anon_sym_elsif] = ACTIONS(565),
    [anon_sym_else] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_ensure] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [38] = {
    [sym__line_break] = ACTIONS(569),
    [sym__heredoc_body_start] = ACTIONS(569),
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [ts_builtin_sym_end] = ACTIONS(569),
    [anon_sym___END__] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_end] = ACTIONS(569),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_when] = ACTIONS(569),
    [anon_sym_elsif] = ACTIONS(569),
    [anon_sym_else] = ACTIONS(569),
    [anon_sym_then] = ACTIONS(569),
    [anon_sym_ensure] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [39] = {
    [sym__line_break] = ACTIONS(573),
    [sym__heredoc_body_start] = ACTIONS(573),
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [ts_builtin_sym_end] = ACTIONS(573),
    [anon_sym___END__] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_end] = ACTIONS(573),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_when] = ACTIONS(573),
    [anon_sym_elsif] = ACTIONS(573),
    [anon_sym_else] = ACTIONS(573),
    [anon_sym_then] = ACTIONS(573),
    [anon_sym_ensure] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [40] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(350),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(355),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [41] = {
    [sym_lambda_parameters] = STATE(363),
    [sym__simple_formal_parameter] = STATE(364),
    [sym_splat_parameter] = STATE(364),
    [sym_hash_splat_parameter] = STATE(364),
    [sym_block_parameter] = STATE(364),
    [sym_keyword_parameter] = STATE(364),
    [sym_optional_parameter] = STATE(364),
    [sym_do_block] = STATE(365),
    [sym_block] = STATE(365),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [42] = {
    [ts_builtin_sym_end] = ACTIONS(681),
    [sym_comment] = ACTIONS(87),
  },
  [43] = {
    [ts_builtin_sym_end] = ACTIONS(683),
    [anon_sym___END__] = ACTIONS(685),
    [sym_comment] = ACTIONS(87),
  },
  [44] = {
    [sym_heredoc_body] = STATE(367),
    [sym__terminator] = STATE(367),
    [aux_sym__statements_repeat1] = STATE(368),
    [sym__line_break] = ACTIONS(687),
    [sym__heredoc_body_start] = ACTIONS(507),
    [ts_builtin_sym_end] = ACTIONS(689),
    [anon_sym___END__] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(687),
    [sym_comment] = ACTIONS(87),
  },
  [45] = {
    [sym__line_break] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(691),
    [ts_builtin_sym_end] = ACTIONS(691),
    [anon_sym___END__] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_unless] = ACTIONS(695),
    [anon_sym_while] = ACTIONS(697),
    [anon_sym_until] = ACTIONS(699),
    [anon_sym_rescue] = ACTIONS(701),
    [sym_comment] = ACTIONS(87),
  },
  [46] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(703),
    [anon_sym___END__] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(721),
    [anon_sym_or] = ACTIONS(721),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [47] = {
    [sym__line_break] = ACTIONS(733),
    [sym__heredoc_body_start] = ACTIONS(733),
    [sym__binary_minus] = ACTIONS(733),
    [sym__binary_star] = ACTIONS(733),
    [ts_builtin_sym_end] = ACTIONS(733),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_COLON_COLON2] = ACTIONS(741),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ_GT] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_BANG_TILDE] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [sym_comment] = ACTIONS(87),
  },
  [48] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(423),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(427),
    [sym__argument] = STATE(428),
    [sym_splat_argument] = STATE(428),
    [sym_hash_splat_argument] = STATE(428),
    [sym_block_argument] = STATE(428),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(423),
    [sym_operator_assignment] = STATE(423),
    [sym_conditional] = STATE(423),
    [sym_range] = STATE(423),
    [sym_binary] = STATE(423),
    [sym_unary] = STATE(423),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(432),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(428),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(763),
    [sym__splat_star] = ACTIONS(765),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(811),
    [sym_identifier] = ACTIONS(811),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [49] = {
    [anon_sym_EQ] = ACTIONS(823),
    [sym_comment] = ACTIONS(87),
  },
  [50] = {
    [anon_sym_EQ] = ACTIONS(825),
    [sym_comment] = ACTIONS(87),
  },
  [51] = {
    [anon_sym_COMMA] = ACTIONS(827),
    [anon_sym_EQ] = ACTIONS(829),
    [sym_comment] = ACTIONS(87),
  },
  [52] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(835),
    [anon_sym_DASH_EQ] = ACTIONS(835),
    [anon_sym_STAR_EQ] = ACTIONS(835),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(835),
    [anon_sym_SLASH_EQ] = ACTIONS(835),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(835),
    [anon_sym_PIPE_EQ] = ACTIONS(835),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(835),
    [anon_sym_AMP_EQ] = ACTIONS(835),
    [anon_sym_PERCENT_EQ] = ACTIONS(835),
    [anon_sym_GT_GT_EQ] = ACTIONS(835),
    [anon_sym_LT_LT_EQ] = ACTIONS(835),
    [anon_sym_CARET_EQ] = ACTIONS(835),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [53] = {
    [sym_string] = STATE(436),
    [aux_sym_chained_string_repeat1] = STATE(436),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [54] = {
    [sym__line_break] = ACTIONS(837),
    [sym__string_start] = ACTIONS(837),
    [sym__heredoc_body_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [ts_builtin_sym_end] = ACTIONS(837),
    [anon_sym___END__] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_unless] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_until] = ACTIONS(837),
    [anon_sym_rescue] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_when] = ACTIONS(837),
    [anon_sym_elsif] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(837),
    [anon_sym_then] = ACTIONS(837),
    [anon_sym_ensure] = ACTIONS(837),
    [anon_sym_EQ_GT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [55] = {
    [sym__statement] = STATE(451),
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_if_modifier] = STATE(451),
    [sym_unless_modifier] = STATE(451),
    [sym_while_modifier] = STATE(451),
    [sym_until_modifier] = STATE(451),
    [sym_rescue_modifier] = STATE(451),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(452),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(452),
    [sym_operator_assignment] = STATE(452),
    [sym_conditional] = STATE(452),
    [sym_range] = STATE(452),
    [sym_binary] = STATE(452),
    [sym_unary] = STATE(452),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_undef] = STATE(451),
    [sym_alias] = STATE(451),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym_empty_statement] = STATE(451),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [anon_sym_undef] = ACTIONS(871),
    [anon_sym_alias] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [56] = {
    [sym__string_end] = ACTIONS(881),
    [sym_comment] = ACTIONS(87),
  },
  [57] = {
    [sym_interpolation] = STATE(459),
    [aux_sym__literal_contents_repeat1] = STATE(459),
    [sym__string_content] = ACTIONS(883),
    [sym__string_end] = ACTIONS(885),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(883),
  },
  [58] = {
    [sym__line_break] = ACTIONS(887),
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [ts_builtin_sym_end] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_end] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_when] = ACTIONS(887),
    [anon_sym_elsif] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_then] = ACTIONS(887),
    [anon_sym_ensure] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [59] = {
    [sym__string_end] = ACTIONS(891),
    [sym_comment] = ACTIONS(87),
  },
  [60] = {
    [sym__line_break] = ACTIONS(893),
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [ts_builtin_sym_end] = ACTIONS(893),
    [anon_sym___END__] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_end] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_when] = ACTIONS(893),
    [anon_sym_elsif] = ACTIONS(893),
    [anon_sym_else] = ACTIONS(893),
    [anon_sym_then] = ACTIONS(893),
    [anon_sym_ensure] = ACTIONS(893),
    [anon_sym_EQ_GT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [61] = {
    [sym__string_end] = ACTIONS(897),
    [sym_comment] = ACTIONS(87),
  },
  [62] = {
    [sym__line_break] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [ts_builtin_sym_end] = ACTIONS(899),
    [anon_sym___END__] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_when] = ACTIONS(899),
    [anon_sym_elsif] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_then] = ACTIONS(899),
    [anon_sym_ensure] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [63] = {
    [sym__string_end] = ACTIONS(903),
    [sym_comment] = ACTIONS(87),
  },
  [64] = {
    [sym__line_break] = ACTIONS(905),
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(905),
    [anon_sym___END__] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(905),
    [anon_sym_elsif] = ACTIONS(905),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_then] = ACTIONS(905),
    [anon_sym_ensure] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [65] = {
    [sym__statement] = STATE(463),
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_if_modifier] = STATE(463),
    [sym_unless_modifier] = STATE(463),
    [sym_while_modifier] = STATE(463),
    [sym_until_modifier] = STATE(463),
    [sym_rescue_modifier] = STATE(463),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(452),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(452),
    [sym_operator_assignment] = STATE(452),
    [sym_conditional] = STATE(452),
    [sym_range] = STATE(452),
    [sym_binary] = STATE(452),
    [sym_unary] = STATE(452),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_undef] = STATE(463),
    [sym_alias] = STATE(463),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym_empty_statement] = STATE(463),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [anon_sym_undef] = ACTIONS(871),
    [anon_sym_alias] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [66] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(466),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(909),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(911),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [67] = {
    [aux_sym_string_array_repeat1] = STATE(469),
    [sym__string_end] = ACTIONS(913),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(915),
  },
  [68] = {
    [sym_interpolation] = STATE(470),
    [aux_sym__literal_contents_repeat1] = STATE(470),
    [sym__string_content] = ACTIONS(917),
    [sym__string_end] = ACTIONS(885),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(919),
    [sym_escape_sequence] = ACTIONS(921),
  },
  [69] = {
    [sym__line_break] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [ts_builtin_sym_end] = ACTIONS(923),
    [anon_sym___END__] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_when] = ACTIONS(923),
    [anon_sym_elsif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_ensure] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_SLASH] = ACTIONS(923),
    [anon_sym_PERCENT] = ACTIONS(923),
    [sym_comment] = ACTIONS(87),
  },
  [70] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(473),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(927),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(929),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [71] = {
    [aux_sym_symbol_array_repeat1] = STATE(476),
    [sym__string_end] = ACTIONS(931),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(933),
  },
  [72] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [73] = {
    [sym_uninterpreted] = ACTIONS(939),
    [sym_comment] = ACTIONS(109),
  },
  [74] = {
    [sym__statements] = STATE(487),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(943),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [75] = {
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [76] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(496),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(967),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [77] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(498),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(969),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [78] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(500),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(971),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [79] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(502),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(973),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [80] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(505),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(975),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(977),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [81] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(508),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(979),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(981),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [82] = {
    [sym_interpolation] = STATE(511),
    [aux_sym_heredoc_body_repeat1] = STATE(511),
    [sym__heredoc_content] = ACTIONS(983),
    [sym_heredoc_end] = ACTIONS(985),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(983),
  },
  [83] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(512),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(512),
    [sym_operator_assignment] = STATE(512),
    [sym_conditional] = STATE(512),
    [sym_range] = STATE(512),
    [sym_binary] = STATE(512),
    [sym_unary] = STATE(512),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [84] = {
    [anon_sym_COLON] = ACTIONS(989),
    [sym_comment] = ACTIONS(87),
  },
  [85] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(516),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(517),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(991),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [86] = {
    [sym__line_break] = ACTIONS(993),
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [ts_builtin_sym_end] = ACTIONS(993),
    [anon_sym___END__] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_end] = ACTIONS(993),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_when] = ACTIONS(993),
    [anon_sym_elsif] = ACTIONS(993),
    [anon_sym_else] = ACTIONS(993),
    [anon_sym_then] = ACTIONS(993),
    [anon_sym_ensure] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [87] = {
    [sym__method_rest] = STATE(519),
    [sym__variable] = STATE(520),
    [sym_operator] = STATE(521),
    [sym__method_name] = STATE(521),
    [sym_setter] = STATE(521),
    [sym_symbol] = STATE(521),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(999),
    [sym_self] = ACTIONS(999),
  },
  [88] = {
    [sym__statements] = STATE(523),
    [sym__top_level_statement] = STATE(144),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(149),
    [sym__simple_mlhs] = STATE(150),
    [sym_destructured_left_assignment] = STATE(150),
    [sym_rest_assignment] = STATE(150),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(1001),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [89] = {
    [sym_constant] = ACTIONS(1003),
    [sym_identifier] = ACTIONS(1003),
    [sym_comment] = ACTIONS(87),
  },
  [90] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(536),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(536),
    [sym_operator_assignment] = STATE(536),
    [sym_conditional] = STATE(536),
    [sym_range] = STATE(536),
    [sym_binary] = STATE(536),
    [sym_unary] = STATE(536),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [91] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(544),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1041),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [92] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(546),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1043),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [93] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(562),
    [sym__argument_list_with_parens] = STATE(563),
    [sym__argument] = STATE(564),
    [sym_splat_argument] = STATE(564),
    [sym_hash_splat_argument] = STATE(564),
    [sym_block_argument] = STATE(564),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(564),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [94] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(568),
    [sym__argument_list_with_parens] = STATE(563),
    [sym__argument] = STATE(564),
    [sym_splat_argument] = STATE(564),
    [sym_hash_splat_argument] = STATE(564),
    [sym_block_argument] = STATE(564),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(564),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [95] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(563),
    [sym__argument] = STATE(564),
    [sym_splat_argument] = STATE(564),
    [sym_hash_splat_argument] = STATE(564),
    [sym_block_argument] = STATE(564),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(564),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [96] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(563),
    [sym__argument] = STATE(564),
    [sym_splat_argument] = STATE(564),
    [sym_hash_splat_argument] = STATE(564),
    [sym_block_argument] = STATE(564),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(564),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [97] = {
    [sym__statement] = STATE(571),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(571),
    [sym_unless_modifier] = STATE(571),
    [sym_while_modifier] = STATE(571),
    [sym_until_modifier] = STATE(571),
    [sym_rescue_modifier] = STATE(571),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(571),
    [sym_alias] = STATE(571),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(571),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [98] = {
    [sym__statement] = STATE(572),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(572),
    [sym_unless_modifier] = STATE(572),
    [sym_while_modifier] = STATE(572),
    [sym_until_modifier] = STATE(572),
    [sym_rescue_modifier] = STATE(572),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(572),
    [sym_alias] = STATE(572),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(572),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [99] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(573),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(573),
    [sym_operator_assignment] = STATE(573),
    [sym_conditional] = STATE(573),
    [sym_range] = STATE(573),
    [sym_binary] = STATE(573),
    [sym_unary] = STATE(573),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [100] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(574),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(574),
    [sym_operator_assignment] = STATE(574),
    [sym_conditional] = STATE(574),
    [sym_range] = STATE(574),
    [sym_binary] = STATE(574),
    [sym_unary] = STATE(574),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [101] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(575),
    [sym__simple_mlhs] = STATE(257),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [102] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(576),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(576),
    [sym_operator_assignment] = STATE(576),
    [sym_conditional] = STATE(576),
    [sym_range] = STATE(576),
    [sym_binary] = STATE(576),
    [sym_unary] = STATE(576),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(577),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__terminator] = STATE(577),
    [sym__line_break] = ACTIONS(1083),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [103] = {
    [sym__statements] = STATE(578),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(579),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(580),
    [sym_rescue] = STATE(581),
    [sym__body_statement] = STATE(582),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(583),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__terminator] = STATE(583),
    [sym__line_break] = ACTIONS(1085),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(1087),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [104] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(584),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(584),
    [sym_operator_assignment] = STATE(584),
    [sym_conditional] = STATE(584),
    [sym_range] = STATE(584),
    [sym_binary] = STATE(584),
    [sym_unary] = STATE(584),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [105] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [106] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1093),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [107] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(1095),
  },
  [108] = {
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_EQ_GT] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [109] = {
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_EQ_GT] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [110] = {
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_EQ_GT] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [111] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(589),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(590),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [112] = {
    [sym_lambda_parameters] = STATE(593),
    [sym__simple_formal_parameter] = STATE(364),
    [sym_splat_parameter] = STATE(364),
    [sym_hash_splat_parameter] = STATE(364),
    [sym_block_parameter] = STATE(364),
    [sym_keyword_parameter] = STATE(364),
    [sym_optional_parameter] = STATE(364),
    [sym_do_block] = STATE(594),
    [sym_block] = STATE(594),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(1101),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [113] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(1119),
    [anon_sym_or] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [114] = {
    [sym__binary_minus] = ACTIONS(733),
    [sym__binary_star] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_STAR_STAR] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_COLON_COLON2] = ACTIONS(1135),
    [anon_sym_AMP_DOT] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ_GT] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_BANG_TILDE] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [sym_comment] = ACTIONS(87),
  },
  [115] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(647),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_do_block] = STATE(650),
    [sym_block] = STATE(650),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(1193),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [116] = {
    [sym__heredoc_body_start] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
  },
  [117] = {
    [anon_sym_EQ] = ACTIONS(1223),
    [sym_comment] = ACTIONS(87),
  },
  [118] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1227),
    [anon_sym_DASH_EQ] = ACTIONS(1227),
    [anon_sym_STAR_EQ] = ACTIONS(1227),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1227),
    [anon_sym_SLASH_EQ] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_PIPE_EQ] = ACTIONS(1227),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1227),
    [anon_sym_AMP_EQ] = ACTIONS(1227),
    [anon_sym_PERCENT_EQ] = ACTIONS(1227),
    [anon_sym_GT_GT_EQ] = ACTIONS(1227),
    [anon_sym_LT_LT_EQ] = ACTIONS(1227),
    [anon_sym_CARET_EQ] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [119] = {
    [sym_string] = STATE(656),
    [aux_sym_chained_string_repeat1] = STATE(656),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [120] = {
    [anon_sym_RBRACE] = ACTIONS(1231),
    [sym_comment] = ACTIONS(87),
  },
  [121] = {
    [sym_heredoc_body] = STATE(658),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [sym_comment] = ACTIONS(87),
  },
  [122] = {
    [sym__heredoc_body_start] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1235),
    [sym_comment] = ACTIONS(87),
  },
  [123] = {
    [sym__statements] = STATE(661),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [124] = {
    [sym__line_break] = ACTIONS(101),
    [sym__heredoc_body_start] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(103),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_unless] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_rescue] = ACTIONS(103),
    [anon_sym_when] = ACTIONS(103),
    [anon_sym_elsif] = ACTIONS(103),
    [anon_sym_else] = ACTIONS(103),
    [anon_sym_then] = ACTIONS(103),
    [anon_sym_ensure] = ACTIONS(103),
    [sym_identifier] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [125] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(663),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(1239),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [126] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(671),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(671),
    [sym_operator_assignment] = STATE(671),
    [sym_conditional] = STATE(671),
    [sym_range] = STATE(671),
    [sym_binary] = STATE(671),
    [sym_unary] = STATE(671),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [127] = {
    [sym__line_break] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym___END__] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_end] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_when] = ACTIONS(1265),
    [anon_sym_elsif] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_then] = ACTIONS(1265),
    [anon_sym_ensure] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_comment] = ACTIONS(87),
  },
  [128] = {
    [sym__line_break] = ACTIONS(1267),
    [sym__heredoc_body_start] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1269),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [sym_identifier] = ACTIONS(1267),
    [sym_comment] = ACTIONS(87),
  },
  [129] = {
    [sym__line_break] = ACTIONS(1267),
    [sym__heredoc_body_start] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1269),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_EQ] = ACTIONS(1271),
    [sym_identifier] = ACTIONS(1267),
    [sym_comment] = ACTIONS(87),
  },
  [130] = {
    [sym__line_break] = ACTIONS(1273),
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym___END__] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_end] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_when] = ACTIONS(1273),
    [anon_sym_elsif] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_then] = ACTIONS(1273),
    [anon_sym_ensure] = ACTIONS(1273),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [131] = {
    [anon_sym_DOT] = ACTIONS(1277),
    [anon_sym_COLON_COLON] = ACTIONS(1277),
    [sym_comment] = ACTIONS(87),
  },
  [132] = {
    [sym_method_parameters] = STATE(683),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(683),
    [sym__terminator] = STATE(683),
    [sym__line_break] = ACTIONS(1279),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [133] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(685),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(685),
    [sym_operator_assignment] = STATE(685),
    [sym_conditional] = STATE(685),
    [sym_range] = STATE(685),
    [sym_binary] = STATE(685),
    [sym_unary] = STATE(685),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [134] = {
    [sym__line_break] = ACTIONS(1291),
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [ts_builtin_sym_end] = ACTIONS(1291),
    [anon_sym___END__] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_end] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_when] = ACTIONS(1291),
    [anon_sym_elsif] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_then] = ACTIONS(1291),
    [anon_sym_ensure] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1291),
    [sym_comment] = ACTIONS(87),
  },
  [135] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(186),
    [sym_scope_resolution] = STATE(686),
    [sym_call] = STATE(686),
    [sym_method_call] = STATE(186),
    [sym__lhs] = STATE(186),
    [sym__variable] = STATE(686),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(186),
    [sym_false] = STATE(186),
    [sym_nil] = STATE(186),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_EQ] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1297),
    [sym_class_variable] = ACTIONS(1297),
    [sym_global_variable] = ACTIONS(1297),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [136] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(701),
    [sym__argument] = STATE(702),
    [sym_splat_argument] = STATE(702),
    [sym_hash_splat_argument] = STATE(702),
    [sym_block_argument] = STATE(702),
    [sym_assignment] = STATE(699),
    [sym_operator_assignment] = STATE(699),
    [sym_conditional] = STATE(699),
    [sym_range] = STATE(699),
    [sym_binary] = STATE(699),
    [sym_unary] = STATE(699),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(705),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(702),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [137] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(701),
    [sym__argument] = STATE(702),
    [sym_splat_argument] = STATE(702),
    [sym_hash_splat_argument] = STATE(702),
    [sym_block_argument] = STATE(702),
    [sym_assignment] = STATE(699),
    [sym_operator_assignment] = STATE(699),
    [sym_conditional] = STATE(699),
    [sym_range] = STATE(699),
    [sym_binary] = STATE(699),
    [sym_unary] = STATE(699),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(705),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(702),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [138] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(701),
    [sym__argument] = STATE(702),
    [sym_splat_argument] = STATE(702),
    [sym_hash_splat_argument] = STATE(702),
    [sym_block_argument] = STATE(702),
    [sym_assignment] = STATE(699),
    [sym_operator_assignment] = STATE(699),
    [sym_conditional] = STATE(699),
    [sym_range] = STATE(699),
    [sym_binary] = STATE(699),
    [sym_unary] = STATE(699),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(705),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(702),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [139] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(701),
    [sym__argument] = STATE(702),
    [sym_splat_argument] = STATE(702),
    [sym_hash_splat_argument] = STATE(702),
    [sym_block_argument] = STATE(702),
    [sym_assignment] = STATE(699),
    [sym_operator_assignment] = STATE(699),
    [sym_conditional] = STATE(699),
    [sym_range] = STATE(699),
    [sym_binary] = STATE(699),
    [sym_unary] = STATE(699),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(705),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(702),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [140] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(706),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(706),
    [sym_operator_assignment] = STATE(706),
    [sym_conditional] = STATE(706),
    [sym_range] = STATE(706),
    [sym_binary] = STATE(706),
    [sym_unary] = STATE(706),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [141] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [142] = {
    [sym_operator] = STATE(707),
    [sym__method_name] = STATE(707),
    [sym_setter] = STATE(707),
    [sym_symbol] = STATE(707),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(1329),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(1329),
    [sym_class_variable] = ACTIONS(1329),
    [sym_global_variable] = ACTIONS(1329),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [143] = {
    [anon_sym_RPAREN] = ACTIONS(1331),
    [sym_comment] = ACTIONS(87),
  },
  [144] = {
    [sym_heredoc_body] = STATE(709),
    [sym__terminator] = STATE(709),
    [aux_sym__statements_repeat1] = STATE(710),
    [sym__line_break] = ACTIONS(1333),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(1333),
    [sym_comment] = ACTIONS(87),
  },
  [145] = {
    [sym__line_break] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(691),
    [anon_sym_RPAREN] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(1335),
    [anon_sym_unless] = ACTIONS(1337),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_until] = ACTIONS(1341),
    [anon_sym_rescue] = ACTIONS(1343),
    [sym_comment] = ACTIONS(87),
  },
  [146] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(1361),
    [anon_sym_or] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [147] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(738),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(740),
    [sym__argument] = STATE(741),
    [sym_splat_argument] = STATE(741),
    [sym_hash_splat_argument] = STATE(741),
    [sym_block_argument] = STATE(741),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(738),
    [sym_operator_assignment] = STATE(738),
    [sym_conditional] = STATE(738),
    [sym_range] = STATE(738),
    [sym_binary] = STATE(738),
    [sym_unary] = STATE(738),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(744),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(741),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1373),
    [sym__splat_star] = ACTIONS(1375),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1397),
    [sym_identifier] = ACTIONS(1397),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [148] = {
    [anon_sym_EQ] = ACTIONS(1403),
    [sym_comment] = ACTIONS(87),
  },
  [149] = {
    [anon_sym_RPAREN] = ACTIONS(1405),
    [anon_sym_EQ] = ACTIONS(825),
    [sym_comment] = ACTIONS(87),
  },
  [150] = {
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_COMMA] = ACTIONS(1407),
    [anon_sym_EQ] = ACTIONS(829),
    [sym_comment] = ACTIONS(87),
  },
  [151] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1409),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1411),
    [anon_sym_DASH_EQ] = ACTIONS(1411),
    [anon_sym_STAR_EQ] = ACTIONS(1411),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1411),
    [anon_sym_SLASH_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_PIPE_EQ] = ACTIONS(1411),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1411),
    [anon_sym_AMP_EQ] = ACTIONS(1411),
    [anon_sym_PERCENT_EQ] = ACTIONS(1411),
    [anon_sym_GT_GT_EQ] = ACTIONS(1411),
    [anon_sym_LT_LT_EQ] = ACTIONS(1411),
    [anon_sym_CARET_EQ] = ACTIONS(1411),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [152] = {
    [sym_string] = STATE(749),
    [aux_sym_chained_string_repeat1] = STATE(749),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [153] = {
    [sym__line_break] = ACTIONS(1413),
    [sym__simple_symbol] = ACTIONS(1413),
    [sym__string_start] = ACTIONS(1413),
    [sym__symbol_start] = ACTIONS(1413),
    [sym__subshell_start] = ACTIONS(1413),
    [sym__regex_start] = ACTIONS(1413),
    [sym__string_array_start] = ACTIONS(1413),
    [sym__symbol_array_start] = ACTIONS(1413),
    [sym__heredoc_body_start] = ACTIONS(1413),
    [sym_heredoc_beginning] = ACTIONS(1413),
    [sym__block_ampersand] = ACTIONS(1413),
    [sym__splat_star] = ACTIONS(1413),
    [sym__unary_minus] = ACTIONS(1413),
    [sym__binary_minus] = ACTIONS(1413),
    [sym__binary_star] = ACTIONS(1413),
    [sym__identifier_hash_key] = ACTIONS(1413),
    [ts_builtin_sym_end] = ACTIONS(1413),
    [anon_sym___END__] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_def] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1415),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_EQ] = ACTIONS(1415),
    [anon_sym_class] = ACTIONS(1415),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_end] = ACTIONS(1415),
    [anon_sym_return] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1415),
    [anon_sym_next] = ACTIONS(1415),
    [sym_redo] = ACTIONS(1415),
    [sym_retry] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_unless] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1415),
    [anon_sym_until] = ACTIONS(1415),
    [anon_sym_rescue] = ACTIONS(1415),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_do] = ACTIONS(1415),
    [anon_sym_case] = ACTIONS(1415),
    [anon_sym_when] = ACTIONS(1415),
    [anon_sym_elsif] = ACTIONS(1415),
    [anon_sym_else] = ACTIONS(1415),
    [anon_sym_then] = ACTIONS(1415),
    [anon_sym_begin] = ACTIONS(1415),
    [anon_sym_ensure] = ACTIONS(1415),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_COLON_COLON2] = ACTIONS(1413),
    [anon_sym_AMP_DOT] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1413),
    [anon_sym_PLUS_EQ] = ACTIONS(1413),
    [anon_sym_DASH_EQ] = ACTIONS(1413),
    [anon_sym_STAR_EQ] = ACTIONS(1413),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1413),
    [anon_sym_SLASH_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1413),
    [anon_sym_AMP_EQ] = ACTIONS(1413),
    [anon_sym_PERCENT_EQ] = ACTIONS(1413),
    [anon_sym_GT_GT_EQ] = ACTIONS(1413),
    [anon_sym_LT_LT_EQ] = ACTIONS(1413),
    [anon_sym_CARET_EQ] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(1415),
    [anon_sym_DOT_DOT] = ACTIONS(1415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1413),
    [anon_sym_and] = ACTIONS(1415),
    [anon_sym_or] = ACTIONS(1415),
    [anon_sym_PIPE_PIPE] = ACTIONS(1415),
    [anon_sym_AMP_AMP] = ACTIONS(1415),
    [anon_sym_LT_LT] = ACTIONS(1415),
    [anon_sym_GT_GT] = ACTIONS(1415),
    [anon_sym_EQ_EQ] = ACTIONS(1415),
    [anon_sym_BANG_EQ] = ACTIONS(1413),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1413),
    [anon_sym_LT_EQ_GT] = ACTIONS(1413),
    [anon_sym_EQ_TILDE] = ACTIONS(1413),
    [anon_sym_BANG_TILDE] = ACTIONS(1413),
    [anon_sym_LT_EQ] = ACTIONS(1415),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_CARET] = ACTIONS(1415),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(1415),
    [anon_sym_PERCENT] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1413),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1415),
    [sym_float] = ACTIONS(1415),
    [sym_complex] = ACTIONS(1413),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1415),
    [anon_sym_TRUE] = ACTIONS(1415),
    [anon_sym_false] = ACTIONS(1415),
    [anon_sym_FALSE] = ACTIONS(1415),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(1415),
    [anon_sym_NIL] = ACTIONS(1415),
    [sym_character] = ACTIONS(1413),
    [anon_sym_LBRACK2] = ACTIONS(1415),
    [anon_sym_DASH_GT] = ACTIONS(1413),
  },
  [154] = {
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [155] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(751),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(1417),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [156] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(753),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(1419),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [157] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(755),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(1421),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [158] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(757),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(1423),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [159] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(760),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(1425),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1427),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [160] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(763),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(1429),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1431),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [161] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(765),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(766),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [162] = {
    [sym__method_rest] = STATE(768),
    [sym__variable] = STATE(769),
    [sym_operator] = STATE(770),
    [sym__method_name] = STATE(770),
    [sym_setter] = STATE(770),
    [sym_symbol] = STATE(770),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(1437),
    [sym_self] = ACTIONS(1437),
  },
  [163] = {
    [sym__statements] = STATE(772),
    [sym__top_level_statement] = STATE(144),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(1439),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [164] = {
    [sym_constant] = ACTIONS(1441),
    [sym_identifier] = ACTIONS(1441),
    [sym_comment] = ACTIONS(87),
  },
  [165] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(776),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1445),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [166] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(778),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1447),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [167] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(785),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(786),
    [sym__argument_list_with_parens] = STATE(787),
    [sym__argument] = STATE(788),
    [sym_splat_argument] = STATE(788),
    [sym_hash_splat_argument] = STATE(788),
    [sym_block_argument] = STATE(788),
    [sym_assignment] = STATE(785),
    [sym_operator_assignment] = STATE(785),
    [sym_conditional] = STATE(785),
    [sym_range] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(789),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(788),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1449),
    [sym__splat_star] = ACTIONS(1451),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1455),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1461),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [168] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(785),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(790),
    [sym__argument_list_with_parens] = STATE(787),
    [sym__argument] = STATE(788),
    [sym_splat_argument] = STATE(788),
    [sym_hash_splat_argument] = STATE(788),
    [sym_block_argument] = STATE(788),
    [sym_assignment] = STATE(785),
    [sym_operator_assignment] = STATE(785),
    [sym_conditional] = STATE(785),
    [sym_range] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(789),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(788),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1449),
    [sym__splat_star] = ACTIONS(1451),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(415),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1455),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1461),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [169] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(785),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(791),
    [sym__argument_list_with_parens] = STATE(787),
    [sym__argument] = STATE(788),
    [sym_splat_argument] = STATE(788),
    [sym_hash_splat_argument] = STATE(788),
    [sym_block_argument] = STATE(788),
    [sym_assignment] = STATE(785),
    [sym_operator_assignment] = STATE(785),
    [sym_conditional] = STATE(785),
    [sym_range] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(789),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(788),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1449),
    [sym__splat_star] = ACTIONS(1451),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1455),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1461),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [170] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(785),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(792),
    [sym__argument_list_with_parens] = STATE(787),
    [sym__argument] = STATE(788),
    [sym_splat_argument] = STATE(788),
    [sym_hash_splat_argument] = STATE(788),
    [sym_block_argument] = STATE(788),
    [sym_assignment] = STATE(785),
    [sym_operator_assignment] = STATE(785),
    [sym_conditional] = STATE(785),
    [sym_range] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(789),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(788),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1449),
    [sym__splat_star] = ACTIONS(1451),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1455),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1461),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [171] = {
    [sym__statement] = STATE(793),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(793),
    [sym_unless_modifier] = STATE(793),
    [sym_while_modifier] = STATE(793),
    [sym_until_modifier] = STATE(793),
    [sym_rescue_modifier] = STATE(793),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(793),
    [sym_alias] = STATE(793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(793),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [172] = {
    [sym__statement] = STATE(794),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(794),
    [sym_unless_modifier] = STATE(794),
    [sym_while_modifier] = STATE(794),
    [sym_until_modifier] = STATE(794),
    [sym_rescue_modifier] = STATE(794),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(794),
    [sym_alias] = STATE(794),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(794),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [173] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(795),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(795),
    [sym_operator_assignment] = STATE(795),
    [sym_conditional] = STATE(795),
    [sym_range] = STATE(795),
    [sym_binary] = STATE(795),
    [sym_unary] = STATE(795),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [174] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(796),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(796),
    [sym_operator_assignment] = STATE(796),
    [sym_conditional] = STATE(796),
    [sym_range] = STATE(796),
    [sym_binary] = STATE(796),
    [sym_unary] = STATE(796),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [175] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(797),
    [sym__simple_mlhs] = STATE(257),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [176] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(798),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(798),
    [sym_operator_assignment] = STATE(798),
    [sym_conditional] = STATE(798),
    [sym_range] = STATE(798),
    [sym_binary] = STATE(798),
    [sym_unary] = STATE(798),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(799),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__terminator] = STATE(799),
    [sym__line_break] = ACTIONS(1463),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [177] = {
    [sym__statements] = STATE(800),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(801),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(802),
    [sym_rescue] = STATE(803),
    [sym__body_statement] = STATE(804),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(805),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__terminator] = STATE(805),
    [sym__line_break] = ACTIONS(1465),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(1467),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [178] = {
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(1469),
  },
  [179] = {
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(565),
    [anon_sym_in] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [sym_comment] = ACTIONS(87),
  },
  [180] = {
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(569),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_EQ] = ACTIONS(569),
    [anon_sym_in] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [sym_comment] = ACTIONS(87),
  },
  [181] = {
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_EQ] = ACTIONS(573),
    [anon_sym_in] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [sym_comment] = ACTIONS(87),
  },
  [182] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(808),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(809),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [183] = {
    [sym_lambda_parameters] = STATE(812),
    [sym__simple_formal_parameter] = STATE(364),
    [sym_splat_parameter] = STATE(364),
    [sym_hash_splat_parameter] = STATE(364),
    [sym_block_parameter] = STATE(364),
    [sym_keyword_parameter] = STATE(364),
    [sym_optional_parameter] = STATE(364),
    [sym_do_block] = STATE(813),
    [sym_block] = STATE(813),
    [anon_sym_LBRACE] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [184] = {
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [anon_sym_COLON_COLON2] = ACTIONS(1481),
    [anon_sym_AMP_DOT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(87),
  },
  [185] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(830),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(832),
    [sym__argument] = STATE(833),
    [sym_splat_argument] = STATE(833),
    [sym_hash_splat_argument] = STATE(833),
    [sym_block_argument] = STATE(833),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(830),
    [sym_operator_assignment] = STATE(830),
    [sym_conditional] = STATE(830),
    [sym_range] = STATE(830),
    [sym_binary] = STATE(830),
    [sym_unary] = STATE(830),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(837),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(833),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1483),
    [sym__splat_star] = ACTIONS(1485),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__identifier_hash_key] = ACTIONS(1489),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1493),
    [anon_sym_EQ] = ACTIONS(745),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1511),
    [sym_identifier] = ACTIONS(1511),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [186] = {
    [anon_sym_RPAREN] = ACTIONS(1513),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(1513),
    [anon_sym_EQ] = ACTIONS(1513),
    [anon_sym_in] = ACTIONS(1513),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [187] = {
    [sym_string] = STATE(838),
    [aux_sym_chained_string_repeat1] = STATE(838),
    [sym__string_start] = ACTIONS(279),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [188] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(839),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(839),
    [sym_operator_assignment] = STATE(839),
    [sym_conditional] = STATE(839),
    [sym_range] = STATE(839),
    [sym_binary] = STATE(839),
    [sym_unary] = STATE(839),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [189] = {
    [sym_constant] = ACTIONS(1515),
    [sym_identifier] = ACTIONS(1515),
    [sym_comment] = ACTIONS(87),
  },
  [190] = {
    [sym_superclass] = STATE(842),
    [sym_heredoc_body] = STATE(843),
    [sym__terminator] = STATE(843),
    [sym__line_break] = ACTIONS(1517),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [191] = {
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [anon_sym_COLON_COLON2] = ACTIONS(1521),
    [anon_sym_AMP_DOT] = ACTIONS(1477),
    [sym_comment] = ACTIONS(87),
  },
  [192] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_superclass] = STATE(842),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(843),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(843),
    [sym__line_break] = ACTIONS(1517),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [193] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [194] = {
    [sym_heredoc_body] = STATE(865),
    [sym__terminator] = STATE(865),
    [sym__line_break] = ACTIONS(1553),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1555),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [195] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(865),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(865),
    [sym__line_break] = ACTIONS(1553),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(1555),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [196] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(873),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(873),
    [sym_operator_assignment] = STATE(873),
    [sym_conditional] = STATE(873),
    [sym_range] = STATE(873),
    [sym_binary] = STATE(873),
    [sym_unary] = STATE(873),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [197] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(877),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(877),
    [sym_operator_assignment] = STATE(877),
    [sym_conditional] = STATE(877),
    [sym_range] = STATE(877),
    [sym_binary] = STATE(877),
    [sym_unary] = STATE(877),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [198] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(878),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(878),
    [sym_operator_assignment] = STATE(878),
    [sym_conditional] = STATE(878),
    [sym_range] = STATE(878),
    [sym_binary] = STATE(878),
    [sym_unary] = STATE(878),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [199] = {
    [anon_sym_COLON] = ACTIONS(1579),
    [sym_comment] = ACTIONS(87),
  },
  [200] = {
    [sym_constant] = ACTIONS(1581),
    [sym_identifier] = ACTIONS(1581),
    [sym_comment] = ACTIONS(87),
  },
  [201] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(882),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(882),
    [sym_operator_assignment] = STATE(882),
    [sym_conditional] = STATE(882),
    [sym_range] = STATE(882),
    [sym_binary] = STATE(882),
    [sym_unary] = STATE(882),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [202] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(888),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(889),
    [sym__argument] = STATE(890),
    [sym_splat_argument] = STATE(890),
    [sym_hash_splat_argument] = STATE(890),
    [sym_block_argument] = STATE(890),
    [sym_assignment] = STATE(888),
    [sym_operator_assignment] = STATE(888),
    [sym_conditional] = STATE(888),
    [sym_range] = STATE(888),
    [sym_binary] = STATE(888),
    [sym_unary] = STATE(888),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(891),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(890),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1583),
    [sym__splat_star] = ACTIONS(1585),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1587),
    [ts_builtin_sym_end] = ACTIONS(363),
    [anon_sym___END__] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1589),
    [sym_identifier] = ACTIONS(1589),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [203] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(888),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(889),
    [sym__argument] = STATE(890),
    [sym_splat_argument] = STATE(890),
    [sym_hash_splat_argument] = STATE(890),
    [sym_block_argument] = STATE(890),
    [sym_assignment] = STATE(888),
    [sym_operator_assignment] = STATE(888),
    [sym_conditional] = STATE(888),
    [sym_range] = STATE(888),
    [sym_binary] = STATE(888),
    [sym_unary] = STATE(888),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(891),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(890),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1583),
    [sym__splat_star] = ACTIONS(1585),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1587),
    [ts_builtin_sym_end] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1589),
    [sym_identifier] = ACTIONS(1589),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [204] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(888),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(889),
    [sym__argument] = STATE(890),
    [sym_splat_argument] = STATE(890),
    [sym_hash_splat_argument] = STATE(890),
    [sym_block_argument] = STATE(890),
    [sym_assignment] = STATE(888),
    [sym_operator_assignment] = STATE(888),
    [sym_conditional] = STATE(888),
    [sym_range] = STATE(888),
    [sym_binary] = STATE(888),
    [sym_unary] = STATE(888),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(891),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(890),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1583),
    [sym__splat_star] = ACTIONS(1585),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1587),
    [ts_builtin_sym_end] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1589),
    [sym_identifier] = ACTIONS(1589),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [205] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(888),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(889),
    [sym__argument] = STATE(890),
    [sym_splat_argument] = STATE(890),
    [sym_hash_splat_argument] = STATE(890),
    [sym_block_argument] = STATE(890),
    [sym_assignment] = STATE(888),
    [sym_operator_assignment] = STATE(888),
    [sym_conditional] = STATE(888),
    [sym_range] = STATE(888),
    [sym_binary] = STATE(888),
    [sym_unary] = STATE(888),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(891),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(890),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1583),
    [sym__splat_star] = ACTIONS(1585),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1587),
    [ts_builtin_sym_end] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1589),
    [sym_identifier] = ACTIONS(1589),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [206] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(907),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(912),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [207] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(913),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(913),
    [sym_operator_assignment] = STATE(913),
    [sym_conditional] = STATE(913),
    [sym_range] = STATE(913),
    [sym_binary] = STATE(913),
    [sym_unary] = STATE(913),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [208] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [209] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym___END__] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1625),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [210] = {
    [sym__line_break] = ACTIONS(565),
    [sym__heredoc_body_start] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [ts_builtin_sym_end] = ACTIONS(565),
    [anon_sym___END__] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_end] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_when] = ACTIONS(565),
    [anon_sym_elsif] = ACTIONS(565),
    [anon_sym_else] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_ensure] = ACTIONS(565),
    [anon_sym_EQ_GT] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [211] = {
    [sym__line_break] = ACTIONS(569),
    [sym__heredoc_body_start] = ACTIONS(569),
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [ts_builtin_sym_end] = ACTIONS(569),
    [anon_sym___END__] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_end] = ACTIONS(569),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_when] = ACTIONS(569),
    [anon_sym_elsif] = ACTIONS(569),
    [anon_sym_else] = ACTIONS(569),
    [anon_sym_then] = ACTIONS(569),
    [anon_sym_ensure] = ACTIONS(569),
    [anon_sym_EQ_GT] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [212] = {
    [sym__line_break] = ACTIONS(573),
    [sym__heredoc_body_start] = ACTIONS(573),
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [ts_builtin_sym_end] = ACTIONS(573),
    [anon_sym___END__] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_end] = ACTIONS(573),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_when] = ACTIONS(573),
    [anon_sym_elsif] = ACTIONS(573),
    [anon_sym_else] = ACTIONS(573),
    [anon_sym_then] = ACTIONS(573),
    [anon_sym_ensure] = ACTIONS(573),
    [anon_sym_EQ_GT] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [213] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(1627),
    [anon_sym___END__] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1579),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [214] = {
    [sym__line_break] = ACTIONS(733),
    [sym__heredoc_body_start] = ACTIONS(733),
    [sym__binary_minus] = ACTIONS(733),
    [sym__binary_star] = ACTIONS(733),
    [ts_builtin_sym_end] = ACTIONS(733),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(1657),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(1659),
    [anon_sym_COLON_COLON2] = ACTIONS(1661),
    [anon_sym_AMP_DOT] = ACTIONS(1663),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ_GT] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_BANG_TILDE] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [sym_comment] = ACTIONS(87),
  },
  [215] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1665),
    [sym__splat_star] = ACTIONS(1667),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1669),
    [ts_builtin_sym_end] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1677),
    [sym_identifier] = ACTIONS(1677),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [216] = {
    [sym__line_break] = ACTIONS(1679),
    [sym__heredoc_body_start] = ACTIONS(1679),
    [sym__binary_minus] = ACTIONS(1679),
    [sym__binary_star] = ACTIONS(1679),
    [ts_builtin_sym_end] = ACTIONS(1679),
    [anon_sym___END__] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(1679),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_end] = ACTIONS(1679),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_unless] = ACTIONS(1679),
    [anon_sym_while] = ACTIONS(1679),
    [anon_sym_until] = ACTIONS(1679),
    [anon_sym_rescue] = ACTIONS(1679),
    [anon_sym_do] = ACTIONS(1679),
    [anon_sym_when] = ACTIONS(1679),
    [anon_sym_elsif] = ACTIONS(1679),
    [anon_sym_else] = ACTIONS(1679),
    [anon_sym_then] = ACTIONS(1679),
    [anon_sym_ensure] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1679),
    [anon_sym_AMP_DOT] = ACTIONS(1679),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_DOT_DOT] = ACTIONS(1681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1679),
    [anon_sym_and] = ACTIONS(1679),
    [anon_sym_or] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE] = ACTIONS(1679),
    [anon_sym_AMP_AMP] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(1679),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_BANG_EQ] = ACTIONS(1679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1679),
    [anon_sym_LT_EQ_GT] = ACTIONS(1679),
    [anon_sym_EQ_TILDE] = ACTIONS(1679),
    [anon_sym_BANG_TILDE] = ACTIONS(1679),
    [anon_sym_LT_EQ] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1679),
    [anon_sym_CARET] = ACTIONS(1679),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_SLASH] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(1679),
    [sym_comment] = ACTIONS(87),
  },
  [217] = {
    [sym_heredoc_body] = STATE(944),
    [aux_sym_call_repeat1] = STATE(944),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym___END__] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [218] = {
    [sym_heredoc_body] = STATE(944),
    [aux_sym_call_repeat1] = STATE(944),
    [aux_sym_argument_list_repeat1] = STATE(946),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym___END__] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [219] = {
    [anon_sym_EQ] = ACTIONS(1691),
    [sym_comment] = ACTIONS(87),
  },
  [220] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [221] = {
    [sym_string] = STATE(949),
    [aux_sym_chained_string_repeat1] = STATE(949),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [222] = {
    [sym__line_break] = ACTIONS(1699),
    [sym__heredoc_body_start] = ACTIONS(1699),
    [sym__binary_minus] = ACTIONS(1699),
    [sym__binary_star] = ACTIONS(1699),
    [ts_builtin_sym_end] = ACTIONS(1699),
    [anon_sym___END__] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_end] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_when] = ACTIONS(1699),
    [anon_sym_elsif] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_then] = ACTIONS(1699),
    [anon_sym_ensure] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [223] = {
    [sym__line_break] = ACTIONS(1703),
    [sym__heredoc_body_start] = ACTIONS(1703),
    [sym__binary_minus] = ACTIONS(1703),
    [sym__binary_star] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1705),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [224] = {
    [sym__line_break] = ACTIONS(1707),
    [sym__heredoc_body_start] = ACTIONS(1707),
    [sym__binary_minus] = ACTIONS(1707),
    [sym__binary_star] = ACTIONS(1707),
    [ts_builtin_sym_end] = ACTIONS(1707),
    [anon_sym___END__] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_DOT] = ACTIONS(1709),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_end] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1707),
    [anon_sym_unless] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(1707),
    [anon_sym_until] = ACTIONS(1707),
    [anon_sym_rescue] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1707),
    [anon_sym_when] = ACTIONS(1707),
    [anon_sym_elsif] = ACTIONS(1707),
    [anon_sym_else] = ACTIONS(1707),
    [anon_sym_then] = ACTIONS(1707),
    [anon_sym_ensure] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_COLON_COLON2] = ACTIONS(1707),
    [anon_sym_AMP_DOT] = ACTIONS(1707),
    [anon_sym_QMARK] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1707),
    [anon_sym_and] = ACTIONS(1707),
    [anon_sym_or] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1709),
    [anon_sym_BANG_EQ] = ACTIONS(1707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1707),
    [anon_sym_LT_EQ_GT] = ACTIONS(1707),
    [anon_sym_EQ_TILDE] = ACTIONS(1707),
    [anon_sym_BANG_TILDE] = ACTIONS(1707),
    [anon_sym_LT_EQ] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_GT_EQ] = ACTIONS(1707),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [225] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(950),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(950),
    [sym_operator_assignment] = STATE(950),
    [sym_conditional] = STATE(950),
    [sym_range] = STATE(950),
    [sym_binary] = STATE(950),
    [sym_unary] = STATE(950),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [226] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(965),
    [sym__argument] = STATE(966),
    [sym_splat_argument] = STATE(966),
    [sym_hash_splat_argument] = STATE(966),
    [sym_block_argument] = STATE(966),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(966),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1711),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1735),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [227] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(965),
    [sym__argument] = STATE(966),
    [sym_splat_argument] = STATE(966),
    [sym_hash_splat_argument] = STATE(966),
    [sym_block_argument] = STATE(966),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(966),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1711),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1735),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [228] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(965),
    [sym__argument] = STATE(966),
    [sym_splat_argument] = STATE(966),
    [sym_hash_splat_argument] = STATE(966),
    [sym_block_argument] = STATE(966),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(966),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1711),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1735),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [229] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(965),
    [sym__argument] = STATE(966),
    [sym_splat_argument] = STATE(966),
    [sym_hash_splat_argument] = STATE(966),
    [sym_block_argument] = STATE(966),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(966),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1711),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1735),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [230] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(970),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(970),
    [sym_operator_assignment] = STATE(970),
    [sym_conditional] = STATE(970),
    [sym_range] = STATE(970),
    [sym_binary] = STATE(970),
    [sym_unary] = STATE(970),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [231] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [232] = {
    [sym_operator] = STATE(971),
    [sym__method_name] = STATE(971),
    [sym_setter] = STATE(971),
    [sym_symbol] = STATE(971),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(1741),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(1741),
    [sym_class_variable] = ACTIONS(1741),
    [sym_global_variable] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [233] = {
    [sym__then] = STATE(978),
    [sym_heredoc_body] = STATE(979),
    [sym__terminator] = STATE(979),
    [sym__line_break] = ACTIONS(1743),
    [sym__heredoc_body_start] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
  },
  [234] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_then] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(1775),
    [anon_sym_or] = ACTIONS(1775),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [235] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1787),
    [sym__splat_star] = ACTIONS(1789),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [236] = {
    [anon_sym_EQ] = ACTIONS(1817),
    [sym_comment] = ACTIONS(87),
  },
  [237] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1821),
    [anon_sym_DASH_EQ] = ACTIONS(1821),
    [anon_sym_STAR_EQ] = ACTIONS(1821),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1821),
    [anon_sym_SLASH_EQ] = ACTIONS(1821),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1821),
    [anon_sym_PIPE_EQ] = ACTIONS(1821),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1821),
    [anon_sym_AMP_EQ] = ACTIONS(1821),
    [anon_sym_PERCENT_EQ] = ACTIONS(1821),
    [anon_sym_GT_GT_EQ] = ACTIONS(1821),
    [anon_sym_LT_LT_EQ] = ACTIONS(1821),
    [anon_sym_CARET_EQ] = ACTIONS(1821),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [238] = {
    [sym_string] = STATE(1011),
    [aux_sym_chained_string_repeat1] = STATE(1011),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [239] = {
    [sym__then] = STATE(1012),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(1825),
    [sym_comment] = ACTIONS(87),
  },
  [240] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1014),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1014),
    [sym_operator_assignment] = STATE(1014),
    [sym_conditional] = STATE(1014),
    [sym_range] = STATE(1014),
    [sym_binary] = STATE(1014),
    [sym_unary] = STATE(1014),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [241] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1027),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(1029),
    [sym__argument] = STATE(1030),
    [sym_splat_argument] = STATE(1030),
    [sym_hash_splat_argument] = STATE(1030),
    [sym_block_argument] = STATE(1030),
    [sym_assignment] = STATE(1027),
    [sym_operator_assignment] = STATE(1027),
    [sym_conditional] = STATE(1027),
    [sym_range] = STATE(1027),
    [sym_binary] = STATE(1027),
    [sym_unary] = STATE(1027),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1033),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1030),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1827),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [242] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1027),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1029),
    [sym__argument] = STATE(1030),
    [sym_splat_argument] = STATE(1030),
    [sym_hash_splat_argument] = STATE(1030),
    [sym_block_argument] = STATE(1030),
    [sym_assignment] = STATE(1027),
    [sym_operator_assignment] = STATE(1027),
    [sym_conditional] = STATE(1027),
    [sym_range] = STATE(1027),
    [sym_binary] = STATE(1027),
    [sym_unary] = STATE(1027),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1033),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1030),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1827),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [243] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1027),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(1029),
    [sym__argument] = STATE(1030),
    [sym_splat_argument] = STATE(1030),
    [sym_hash_splat_argument] = STATE(1030),
    [sym_block_argument] = STATE(1030),
    [sym_assignment] = STATE(1027),
    [sym_operator_assignment] = STATE(1027),
    [sym_conditional] = STATE(1027),
    [sym_range] = STATE(1027),
    [sym_binary] = STATE(1027),
    [sym_unary] = STATE(1027),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1033),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1030),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1827),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [244] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1027),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(1029),
    [sym__argument] = STATE(1030),
    [sym_splat_argument] = STATE(1030),
    [sym_hash_splat_argument] = STATE(1030),
    [sym_block_argument] = STATE(1030),
    [sym_assignment] = STATE(1027),
    [sym_operator_assignment] = STATE(1027),
    [sym_conditional] = STATE(1027),
    [sym_range] = STATE(1027),
    [sym_binary] = STATE(1027),
    [sym_unary] = STATE(1027),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1033),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1030),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1827),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [245] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1034),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1034),
    [sym_operator_assignment] = STATE(1034),
    [sym_conditional] = STATE(1034),
    [sym_range] = STATE(1034),
    [sym_binary] = STATE(1034),
    [sym_unary] = STATE(1034),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [246] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [247] = {
    [sym__do] = STATE(1045),
    [sym_heredoc_body] = STATE(1045),
    [sym__terminator] = STATE(1045),
    [sym__line_break] = ACTIONS(1857),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(1857),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [248] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1059),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(1062),
    [sym__argument] = STATE(1063),
    [sym_splat_argument] = STATE(1063),
    [sym_hash_splat_argument] = STATE(1063),
    [sym_block_argument] = STATE(1063),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(1059),
    [sym_operator_assignment] = STATE(1059),
    [sym_conditional] = STATE(1059),
    [sym_range] = STATE(1059),
    [sym_binary] = STATE(1059),
    [sym_unary] = STATE(1059),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1066),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1063),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1887),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [249] = {
    [anon_sym_EQ] = ACTIONS(1927),
    [sym_comment] = ACTIONS(87),
  },
  [250] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1929),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1931),
    [anon_sym_DASH_EQ] = ACTIONS(1931),
    [anon_sym_STAR_EQ] = ACTIONS(1931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1931),
    [anon_sym_SLASH_EQ] = ACTIONS(1931),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1931),
    [anon_sym_PIPE_EQ] = ACTIONS(1931),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1931),
    [anon_sym_AMP_EQ] = ACTIONS(1931),
    [anon_sym_PERCENT_EQ] = ACTIONS(1931),
    [anon_sym_GT_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_LT_EQ] = ACTIONS(1931),
    [anon_sym_CARET_EQ] = ACTIONS(1931),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [251] = {
    [sym_string] = STATE(1069),
    [aux_sym_chained_string_repeat1] = STATE(1069),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [252] = {
    [sym__do] = STATE(1070),
    [sym_heredoc_body] = STATE(1070),
    [sym__terminator] = STATE(1070),
    [sym__line_break] = ACTIONS(1933),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(1933),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(1933),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [253] = {
    [sym__statements] = STATE(772),
    [sym__top_level_statement] = STATE(144),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(149),
    [sym__simple_mlhs] = STATE(150),
    [sym_destructured_left_assignment] = STATE(150),
    [sym_rest_assignment] = STATE(150),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(1439),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [254] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(186),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(186),
    [sym__lhs] = STATE(186),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(186),
    [sym_false] = STATE(186),
    [sym_nil] = STATE(186),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_in] = ACTIONS(1935),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [255] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1083),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(1085),
    [sym__argument] = STATE(1086),
    [sym_splat_argument] = STATE(1086),
    [sym_hash_splat_argument] = STATE(1086),
    [sym_block_argument] = STATE(1086),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(1083),
    [sym_operator_assignment] = STATE(1083),
    [sym_conditional] = STATE(1083),
    [sym_range] = STATE(1083),
    [sym_binary] = STATE(1083),
    [sym_unary] = STATE(1083),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1089),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1086),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1937),
    [sym__splat_star] = ACTIONS(1939),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__identifier_hash_key] = ACTIONS(1943),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [256] = {
    [sym_in] = STATE(1091),
    [anon_sym_in] = ACTIONS(1969),
    [sym_comment] = ACTIONS(87),
  },
  [257] = {
    [anon_sym_COMMA] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(829),
    [sym_comment] = ACTIONS(87),
  },
  [258] = {
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_EQ] = ACTIONS(831),
    [anon_sym_in] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [259] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1093),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1093),
    [sym_operator_assignment] = STATE(1093),
    [sym_conditional] = STATE(1093),
    [sym_range] = STATE(1093),
    [sym_binary] = STATE(1093),
    [sym_unary] = STATE(1093),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [260] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(1108),
    [sym__argument] = STATE(1109),
    [sym_splat_argument] = STATE(1109),
    [sym_hash_splat_argument] = STATE(1109),
    [sym_block_argument] = STATE(1109),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1112),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1109),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1973),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [261] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1108),
    [sym__argument] = STATE(1109),
    [sym_splat_argument] = STATE(1109),
    [sym_hash_splat_argument] = STATE(1109),
    [sym_block_argument] = STATE(1109),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1112),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1109),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1973),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [262] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(1108),
    [sym__argument] = STATE(1109),
    [sym_splat_argument] = STATE(1109),
    [sym_hash_splat_argument] = STATE(1109),
    [sym_block_argument] = STATE(1109),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1112),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1109),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1973),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [263] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(1108),
    [sym__argument] = STATE(1109),
    [sym_splat_argument] = STATE(1109),
    [sym_hash_splat_argument] = STATE(1109),
    [sym_block_argument] = STATE(1109),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1112),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1109),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1973),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [264] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1113),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1113),
    [sym_operator_assignment] = STATE(1113),
    [sym_conditional] = STATE(1113),
    [sym_range] = STATE(1113),
    [sym_binary] = STATE(1113),
    [sym_unary] = STATE(1113),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [265] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [266] = {
    [sym_heredoc_body] = STATE(1124),
    [sym__terminator] = STATE(1124),
    [sym__line_break] = ACTIONS(2003),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [267] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1059),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(1062),
    [sym__argument] = STATE(1063),
    [sym_splat_argument] = STATE(1063),
    [sym_hash_splat_argument] = STATE(1063),
    [sym_block_argument] = STATE(1063),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(1059),
    [sym_operator_assignment] = STATE(1059),
    [sym_conditional] = STATE(1059),
    [sym_range] = STATE(1059),
    [sym_binary] = STATE(1059),
    [sym_unary] = STATE(1059),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1066),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1063),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1887),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [268] = {
    [anon_sym_EQ] = ACTIONS(2033),
    [sym_comment] = ACTIONS(87),
  },
  [269] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2035),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2037),
    [anon_sym_DASH_EQ] = ACTIONS(2037),
    [anon_sym_STAR_EQ] = ACTIONS(2037),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2037),
    [anon_sym_SLASH_EQ] = ACTIONS(2037),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2037),
    [anon_sym_PIPE_EQ] = ACTIONS(2037),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2037),
    [anon_sym_AMP_EQ] = ACTIONS(2037),
    [anon_sym_PERCENT_EQ] = ACTIONS(2037),
    [anon_sym_GT_GT_EQ] = ACTIONS(2037),
    [anon_sym_LT_LT_EQ] = ACTIONS(2037),
    [anon_sym_CARET_EQ] = ACTIONS(2037),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [270] = {
    [sym_string] = STATE(1127),
    [aux_sym_chained_string_repeat1] = STATE(1127),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [271] = {
    [sym_when] = STATE(1129),
    [aux_sym_case_repeat1] = STATE(1130),
    [anon_sym_SEMI] = ACTIONS(2039),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [272] = {
    [sym_interpolation] = STATE(1132),
    [aux_sym_heredoc_body_repeat1] = STATE(1132),
    [sym__heredoc_content] = ACTIONS(2043),
    [sym_heredoc_end] = ACTIONS(2045),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(2043),
  },
  [273] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1133),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(1133),
    [sym_operator_assignment] = STATE(1133),
    [sym_conditional] = STATE(1133),
    [sym_range] = STATE(1133),
    [sym_binary] = STATE(1133),
    [sym_unary] = STATE(1133),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [274] = {
    [sym__line_break] = ACTIONS(275),
    [sym__simple_symbol] = ACTIONS(2047),
    [sym__string_start] = ACTIONS(2047),
    [sym__symbol_start] = ACTIONS(2047),
    [sym__subshell_start] = ACTIONS(2047),
    [sym__regex_start] = ACTIONS(2047),
    [sym__string_array_start] = ACTIONS(2047),
    [sym__symbol_array_start] = ACTIONS(2047),
    [sym__heredoc_body_start] = ACTIONS(275),
    [sym_heredoc_beginning] = ACTIONS(2047),
    [sym__unary_minus] = ACTIONS(2047),
    [anon_sym_BEGIN] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_END] = ACTIONS(2049),
    [anon_sym_def] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_COLON_COLON] = ACTIONS(2047),
    [anon_sym_SEMI] = ACTIONS(2047),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_class] = ACTIONS(2049),
    [anon_sym_module] = ACTIONS(2049),
    [anon_sym_end] = ACTIONS(2049),
    [anon_sym_return] = ACTIONS(2049),
    [anon_sym_yield] = ACTIONS(2049),
    [anon_sym_break] = ACTIONS(2049),
    [anon_sym_next] = ACTIONS(2049),
    [sym_redo] = ACTIONS(2049),
    [sym_retry] = ACTIONS(2049),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_unless] = ACTIONS(2049),
    [anon_sym_while] = ACTIONS(2049),
    [anon_sym_until] = ACTIONS(2049),
    [anon_sym_rescue] = ACTIONS(2049),
    [anon_sym_for] = ACTIONS(2049),
    [anon_sym_case] = ACTIONS(2049),
    [anon_sym_else] = ACTIONS(2049),
    [anon_sym_begin] = ACTIONS(2049),
    [anon_sym_ensure] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2049),
    [anon_sym_defined_QMARK] = ACTIONS(2047),
    [anon_sym_not] = ACTIONS(2049),
    [anon_sym_BANG] = ACTIONS(2047),
    [anon_sym_TILDE] = ACTIONS(2047),
    [sym_constant] = ACTIONS(2049),
    [sym_identifier] = ACTIONS(2049),
    [sym_instance_variable] = ACTIONS(2047),
    [sym_class_variable] = ACTIONS(2047),
    [sym_global_variable] = ACTIONS(2047),
    [anon_sym_undef] = ACTIONS(2049),
    [anon_sym_alias] = ACTIONS(2049),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2049),
    [sym_float] = ACTIONS(2049),
    [sym_complex] = ACTIONS(2047),
    [sym_super] = ACTIONS(2049),
    [anon_sym_true] = ACTIONS(2049),
    [anon_sym_TRUE] = ACTIONS(2049),
    [anon_sym_false] = ACTIONS(2049),
    [anon_sym_FALSE] = ACTIONS(2049),
    [sym_self] = ACTIONS(2049),
    [anon_sym_nil] = ACTIONS(2049),
    [anon_sym_NIL] = ACTIONS(2049),
    [sym_character] = ACTIONS(2047),
    [anon_sym_LBRACK2] = ACTIONS(2047),
    [anon_sym_DASH_GT] = ACTIONS(2047),
  },
  [275] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1146),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(1148),
    [sym__argument] = STATE(1149),
    [sym_splat_argument] = STATE(1149),
    [sym_hash_splat_argument] = STATE(1149),
    [sym_block_argument] = STATE(1149),
    [sym_assignment] = STATE(1146),
    [sym_operator_assignment] = STATE(1146),
    [sym_conditional] = STATE(1146),
    [sym_range] = STATE(1146),
    [sym_binary] = STATE(1146),
    [sym_unary] = STATE(1146),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1152),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1149),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2051),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [276] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1146),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1148),
    [sym__argument] = STATE(1149),
    [sym_splat_argument] = STATE(1149),
    [sym_hash_splat_argument] = STATE(1149),
    [sym_block_argument] = STATE(1149),
    [sym_assignment] = STATE(1146),
    [sym_operator_assignment] = STATE(1146),
    [sym_conditional] = STATE(1146),
    [sym_range] = STATE(1146),
    [sym_binary] = STATE(1146),
    [sym_unary] = STATE(1146),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1152),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1149),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2051),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [277] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1146),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(1148),
    [sym__argument] = STATE(1149),
    [sym_splat_argument] = STATE(1149),
    [sym_hash_splat_argument] = STATE(1149),
    [sym_block_argument] = STATE(1149),
    [sym_assignment] = STATE(1146),
    [sym_operator_assignment] = STATE(1146),
    [sym_conditional] = STATE(1146),
    [sym_range] = STATE(1146),
    [sym_binary] = STATE(1146),
    [sym_unary] = STATE(1146),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1152),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1149),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2051),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [278] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1146),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(1148),
    [sym__argument] = STATE(1149),
    [sym_splat_argument] = STATE(1149),
    [sym_hash_splat_argument] = STATE(1149),
    [sym_block_argument] = STATE(1149),
    [sym_assignment] = STATE(1146),
    [sym_operator_assignment] = STATE(1146),
    [sym_conditional] = STATE(1146),
    [sym_range] = STATE(1146),
    [sym_binary] = STATE(1146),
    [sym_unary] = STATE(1146),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1152),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1149),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2051),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [279] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym__then] = STATE(1162),
    [sym_begin] = STATE(214),
    [sym_exceptions] = STATE(1163),
    [sym_exception_variable] = STATE(1164),
    [sym__arg] = STATE(1165),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_splat_argument] = STATE(1167),
    [sym_assignment] = STATE(1165),
    [sym_operator_assignment] = STATE(1165),
    [sym_conditional] = STATE(1165),
    [sym_range] = STATE(1165),
    [sym_binary] = STATE(1165),
    [sym_unary] = STATE(1165),
    [sym__arg_or_splat_arg] = STATE(1167),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1013),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(2081),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(2093),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(2095),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [280] = {
    [sym__statements] = STATE(1180),
    [sym__top_level_statement] = STATE(1181),
    [sym_begin_block] = STATE(1181),
    [sym_end_block] = STATE(1181),
    [sym__statement] = STATE(1182),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1182),
    [sym_unless_modifier] = STATE(1182),
    [sym_while_modifier] = STATE(1182),
    [sym_until_modifier] = STATE(1182),
    [sym_rescue_modifier] = STATE(1182),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1183),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(1183),
    [sym_operator_assignment] = STATE(1183),
    [sym_conditional] = STATE(1183),
    [sym_range] = STATE(1183),
    [sym_binary] = STATE(1183),
    [sym_unary] = STATE(1183),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_undef] = STATE(1182),
    [sym_alias] = STATE(1182),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1188),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1182),
    [sym__terminator] = STATE(1188),
    [sym__line_break] = ACTIONS(2109),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2115),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [anon_sym_undef] = ACTIONS(2137),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [281] = {
    [sym__statements] = STATE(1197),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2141),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [282] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1205),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(1205),
    [sym_operator_assignment] = STATE(1205),
    [sym_conditional] = STATE(1205),
    [sym_range] = STATE(1205),
    [sym_binary] = STATE(1205),
    [sym_unary] = STATE(1205),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [283] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [284] = {
    [sym_operator] = STATE(1206),
    [sym__method_name] = STATE(1206),
    [sym_setter] = STATE(1206),
    [sym_symbol] = STATE(1206),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(2165),
    [sym_class_variable] = ACTIONS(2165),
    [sym_global_variable] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [285] = {
    [sym_else] = STATE(1208),
    [sym_ensure] = STATE(1209),
    [sym_rescue] = STATE(1210),
    [anon_sym_end] = ACTIONS(2167),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [286] = {
    [sym_heredoc_body] = STATE(1211),
    [sym__terminator] = STATE(1211),
    [aux_sym__statements_repeat1] = STATE(1212),
    [sym__line_break] = ACTIONS(2175),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [anon_sym_ensure] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [287] = {
    [sym__line_break] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(2177),
    [anon_sym_unless] = ACTIONS(2179),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_until] = ACTIONS(2183),
    [anon_sym_rescue] = ACTIONS(2185),
    [anon_sym_else] = ACTIONS(691),
    [anon_sym_ensure] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [288] = {
    [sym_ensure] = STATE(1209),
    [anon_sym_end] = ACTIONS(2167),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [289] = {
    [anon_sym_end] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
  },
  [290] = {
    [sym_else] = STATE(1208),
    [sym_ensure] = STATE(1209),
    [anon_sym_end] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [291] = {
    [sym__line_break] = ACTIONS(2187),
    [sym__heredoc_body_start] = ACTIONS(2187),
    [sym__binary_minus] = ACTIONS(2187),
    [sym__binary_star] = ACTIONS(2187),
    [ts_builtin_sym_end] = ACTIONS(2187),
    [anon_sym___END__] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_end] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_unless] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_until] = ACTIONS(2187),
    [anon_sym_rescue] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(2187),
    [anon_sym_elsif] = ACTIONS(2187),
    [anon_sym_else] = ACTIONS(2187),
    [anon_sym_then] = ACTIONS(2187),
    [anon_sym_ensure] = ACTIONS(2187),
    [anon_sym_EQ_GT] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_COLON_COLON2] = ACTIONS(2187),
    [anon_sym_AMP_DOT] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_DOT_DOT] = ACTIONS(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2189),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_EQ_TILDE] = ACTIONS(2187),
    [anon_sym_BANG_TILDE] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2189),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [292] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_else] = ACTIONS(703),
    [anon_sym_ensure] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(2207),
    [anon_sym_or] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [293] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1240),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(1242),
    [sym__argument] = STATE(1243),
    [sym_splat_argument] = STATE(1243),
    [sym_hash_splat_argument] = STATE(1243),
    [sym_block_argument] = STATE(1243),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(1240),
    [sym_operator_assignment] = STATE(1240),
    [sym_conditional] = STATE(1240),
    [sym_range] = STATE(1240),
    [sym_binary] = STATE(1240),
    [sym_unary] = STATE(1240),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1246),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1243),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(2219),
    [sym__splat_star] = ACTIONS(2221),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(2243),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [294] = {
    [anon_sym_EQ] = ACTIONS(2249),
    [sym_comment] = ACTIONS(87),
  },
  [295] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2251),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2253),
    [anon_sym_DASH_EQ] = ACTIONS(2253),
    [anon_sym_STAR_EQ] = ACTIONS(2253),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2253),
    [anon_sym_SLASH_EQ] = ACTIONS(2253),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2253),
    [anon_sym_PIPE_EQ] = ACTIONS(2253),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2253),
    [anon_sym_AMP_EQ] = ACTIONS(2253),
    [anon_sym_PERCENT_EQ] = ACTIONS(2253),
    [anon_sym_GT_GT_EQ] = ACTIONS(2253),
    [anon_sym_LT_LT_EQ] = ACTIONS(2253),
    [anon_sym_CARET_EQ] = ACTIONS(2253),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [296] = {
    [sym_string] = STATE(1249),
    [aux_sym_chained_string_repeat1] = STATE(1249),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [297] = {
    [sym__statements] = STATE(285),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(288),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(289),
    [sym_rescue] = STATE(290),
    [sym__body_statement] = STATE(1250),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [298] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [299] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [300] = {
    [sym__line_break] = ACTIONS(1267),
    [sym__heredoc_body_start] = ACTIONS(1267),
    [ts_builtin_sym_end] = ACTIONS(1267),
    [anon_sym___END__] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1269),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_EQ] = ACTIONS(1271),
    [anon_sym_end] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1269),
    [anon_sym_unless] = ACTIONS(1269),
    [anon_sym_while] = ACTIONS(1269),
    [anon_sym_until] = ACTIONS(1269),
    [anon_sym_rescue] = ACTIONS(1269),
    [anon_sym_when] = ACTIONS(1269),
    [anon_sym_elsif] = ACTIONS(1269),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_then] = ACTIONS(1269),
    [anon_sym_ensure] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_comment] = ACTIONS(87),
  },
  [301] = {
    [aux_sym_undef_repeat1] = STATE(1252),
    [sym__line_break] = ACTIONS(2257),
    [sym__heredoc_body_start] = ACTIONS(2257),
    [ts_builtin_sym_end] = ACTIONS(2257),
    [anon_sym___END__] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [302] = {
    [sym__simple_symbol] = ACTIONS(101),
    [sym__symbol_start] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_constant] = ACTIONS(101),
    [sym_identifier] = ACTIONS(101),
    [sym_instance_variable] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(101),
    [sym_global_variable] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_PLUS_AT] = ACTIONS(101),
    [anon_sym_DASH_AT] = ACTIONS(101),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [303] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1254),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2261),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [304] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_PERCENT] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1263),
    [sym_identifier] = ACTIONS(1263),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PLUS_AT] = ACTIONS(1263),
    [anon_sym_DASH_AT] = ACTIONS(1263),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1265),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
  },
  [305] = {
    [sym__simple_symbol] = ACTIONS(1267),
    [sym__symbol_start] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1269),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_EQ] = ACTIONS(2263),
    [anon_sym_LT] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_EQ_EQ] = ACTIONS(1269),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1267),
    [anon_sym_LT_EQ_GT] = ACTIONS(1267),
    [anon_sym_EQ_TILDE] = ACTIONS(1267),
    [anon_sym_BANG_TILDE] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1269),
    [anon_sym_GT] = ACTIONS(1269),
    [anon_sym_GT_EQ] = ACTIONS(1267),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_SLASH] = ACTIONS(1267),
    [anon_sym_PERCENT] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1267),
    [sym_identifier] = ACTIONS(1267),
    [sym_instance_variable] = ACTIONS(1267),
    [sym_class_variable] = ACTIONS(1267),
    [sym_global_variable] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS_AT] = ACTIONS(1267),
    [anon_sym_DASH_AT] = ACTIONS(1267),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1269),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(1267),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [sym_comment] = ACTIONS(87),
  },
  [306] = {
    [sym_operator] = STATE(1256),
    [sym__method_name] = STATE(1256),
    [sym_setter] = STATE(1256),
    [sym_symbol] = STATE(1256),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(2265),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(2265),
    [sym_class_variable] = ACTIONS(2265),
    [sym_global_variable] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [307] = {
    [sym__line_break] = ACTIONS(2267),
    [sym__heredoc_body_start] = ACTIONS(2267),
    [sym__binary_minus] = ACTIONS(2267),
    [sym__binary_star] = ACTIONS(2267),
    [ts_builtin_sym_end] = ACTIONS(2267),
    [anon_sym___END__] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_RPAREN] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2269),
    [anon_sym_COMMA] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_STAR_STAR] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_end] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_unless] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_until] = ACTIONS(2267),
    [anon_sym_rescue] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_when] = ACTIONS(2267),
    [anon_sym_elsif] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_then] = ACTIONS(2267),
    [anon_sym_ensure] = ACTIONS(2267),
    [anon_sym_EQ_GT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_COLON_COLON2] = ACTIONS(2267),
    [anon_sym_AMP_DOT] = ACTIONS(2267),
    [anon_sym_QMARK] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2267),
    [anon_sym_and] = ACTIONS(2267),
    [anon_sym_or] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2267),
    [anon_sym_AMP_AMP] = ACTIONS(2267),
    [anon_sym_LT_LT] = ACTIONS(2267),
    [anon_sym_GT_GT] = ACTIONS(2267),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2267),
    [anon_sym_LT_EQ_GT] = ACTIONS(2267),
    [anon_sym_EQ_TILDE] = ACTIONS(2267),
    [anon_sym_BANG_TILDE] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2267),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_PERCENT] = ACTIONS(2267),
    [sym_comment] = ACTIONS(87),
  },
  [308] = {
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [309] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1258),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2271),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [310] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1260),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2273),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [311] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1262),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2275),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [312] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1264),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2277),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [313] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1267),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(2279),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2281),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [314] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1270),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(2283),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2285),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [315] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1278),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(1278),
    [sym_operator_assignment] = STATE(1278),
    [sym_conditional] = STATE(1278),
    [sym_range] = STATE(1278),
    [sym_binary] = STATE(1278),
    [sym_unary] = STATE(1278),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [316] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1283),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(1283),
    [sym_operator_assignment] = STATE(1283),
    [sym_conditional] = STATE(1283),
    [sym_range] = STATE(1283),
    [sym_binary] = STATE(1283),
    [sym_unary] = STATE(1283),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [317] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1284),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(1284),
    [sym_operator_assignment] = STATE(1284),
    [sym_conditional] = STATE(1284),
    [sym_range] = STATE(1284),
    [sym_binary] = STATE(1284),
    [sym_unary] = STATE(1284),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [318] = {
    [anon_sym_COLON] = ACTIONS(2309),
    [sym_comment] = ACTIONS(87),
  },
  [319] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(1288),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(1289),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [320] = {
    [sym__method_rest] = STATE(1291),
    [sym__variable] = STATE(1292),
    [sym_operator] = STATE(1293),
    [sym__method_name] = STATE(1293),
    [sym_setter] = STATE(1293),
    [sym_symbol] = STATE(1293),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(2315),
    [sym_self] = ACTIONS(2315),
  },
  [321] = {
    [sym__statements] = STATE(1295),
    [sym__top_level_statement] = STATE(144),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(149),
    [sym__simple_mlhs] = STATE(150),
    [sym_destructured_left_assignment] = STATE(150),
    [sym_rest_assignment] = STATE(150),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(2317),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [322] = {
    [sym_constant] = ACTIONS(2319),
    [sym_identifier] = ACTIONS(2319),
    [sym_comment] = ACTIONS(87),
  },
  [323] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1297),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(1297),
    [sym_operator_assignment] = STATE(1297),
    [sym_conditional] = STATE(1297),
    [sym_range] = STATE(1297),
    [sym_binary] = STATE(1297),
    [sym_unary] = STATE(1297),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [324] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1300),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(2323),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [325] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1302),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(2325),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [326] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1311),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(1313),
    [sym__argument] = STATE(1314),
    [sym_splat_argument] = STATE(1314),
    [sym_hash_splat_argument] = STATE(1314),
    [sym_block_argument] = STATE(1314),
    [sym_assignment] = STATE(1311),
    [sym_operator_assignment] = STATE(1311),
    [sym_conditional] = STATE(1311),
    [sym_range] = STATE(1311),
    [sym_binary] = STATE(1311),
    [sym_unary] = STATE(1311),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1317),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1314),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2327),
    [sym__splat_star] = ACTIONS(2329),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2343),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [327] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1311),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(1313),
    [sym__argument] = STATE(1314),
    [sym_splat_argument] = STATE(1314),
    [sym_hash_splat_argument] = STATE(1314),
    [sym_block_argument] = STATE(1314),
    [sym_assignment] = STATE(1311),
    [sym_operator_assignment] = STATE(1311),
    [sym_conditional] = STATE(1311),
    [sym_range] = STATE(1311),
    [sym_binary] = STATE(1311),
    [sym_unary] = STATE(1311),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1317),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1314),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2327),
    [sym__splat_star] = ACTIONS(2329),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2343),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [328] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1311),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(1313),
    [sym__argument] = STATE(1314),
    [sym_splat_argument] = STATE(1314),
    [sym_hash_splat_argument] = STATE(1314),
    [sym_block_argument] = STATE(1314),
    [sym_assignment] = STATE(1311),
    [sym_operator_assignment] = STATE(1311),
    [sym_conditional] = STATE(1311),
    [sym_range] = STATE(1311),
    [sym_binary] = STATE(1311),
    [sym_unary] = STATE(1311),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1317),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1314),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2327),
    [sym__splat_star] = ACTIONS(2329),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2343),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [329] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1311),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(1313),
    [sym__argument] = STATE(1314),
    [sym_splat_argument] = STATE(1314),
    [sym_hash_splat_argument] = STATE(1314),
    [sym_block_argument] = STATE(1314),
    [sym_assignment] = STATE(1311),
    [sym_operator_assignment] = STATE(1311),
    [sym_conditional] = STATE(1311),
    [sym_range] = STATE(1311),
    [sym_binary] = STATE(1311),
    [sym_unary] = STATE(1311),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1317),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1314),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2327),
    [sym__splat_star] = ACTIONS(2329),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2343),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [330] = {
    [sym__statement] = STATE(1321),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1321),
    [sym_unless_modifier] = STATE(1321),
    [sym_while_modifier] = STATE(1321),
    [sym_until_modifier] = STATE(1321),
    [sym_rescue_modifier] = STATE(1321),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1321),
    [sym_alias] = STATE(1321),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1321),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [331] = {
    [sym__statement] = STATE(1322),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1322),
    [sym_unless_modifier] = STATE(1322),
    [sym_while_modifier] = STATE(1322),
    [sym_until_modifier] = STATE(1322),
    [sym_rescue_modifier] = STATE(1322),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1322),
    [sym_alias] = STATE(1322),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1322),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [332] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1323),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1323),
    [sym_operator_assignment] = STATE(1323),
    [sym_conditional] = STATE(1323),
    [sym_range] = STATE(1323),
    [sym_binary] = STATE(1323),
    [sym_unary] = STATE(1323),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [333] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1324),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1324),
    [sym_operator_assignment] = STATE(1324),
    [sym_conditional] = STATE(1324),
    [sym_range] = STATE(1324),
    [sym_binary] = STATE(1324),
    [sym_unary] = STATE(1324),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [334] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(1325),
    [sym__simple_mlhs] = STATE(257),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [335] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1326),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1326),
    [sym_operator_assignment] = STATE(1326),
    [sym_conditional] = STATE(1326),
    [sym_range] = STATE(1326),
    [sym_binary] = STATE(1326),
    [sym_unary] = STATE(1326),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1327),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__terminator] = STATE(1327),
    [sym__line_break] = ACTIONS(2345),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [336] = {
    [sym__statements] = STATE(1328),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1329),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1330),
    [sym_rescue] = STATE(1331),
    [sym__body_statement] = STATE(1332),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1333),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__terminator] = STATE(1333),
    [sym__line_break] = ACTIONS(2347),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2349),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [337] = {
    [sym__line_break] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(2351),
    [sym__binary_minus] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2351),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [anon_sym___END__] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2353),
    [anon_sym_COMMA] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_end] = ACTIONS(2351),
    [anon_sym_if] = ACTIONS(2351),
    [anon_sym_unless] = ACTIONS(2351),
    [anon_sym_while] = ACTIONS(2351),
    [anon_sym_until] = ACTIONS(2351),
    [anon_sym_rescue] = ACTIONS(2351),
    [anon_sym_do] = ACTIONS(2351),
    [anon_sym_when] = ACTIONS(2351),
    [anon_sym_elsif] = ACTIONS(2351),
    [anon_sym_else] = ACTIONS(2351),
    [anon_sym_then] = ACTIONS(2351),
    [anon_sym_ensure] = ACTIONS(2351),
    [anon_sym_EQ_GT] = ACTIONS(2351),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_COLON_COLON2] = ACTIONS(2351),
    [anon_sym_AMP_DOT] = ACTIONS(2351),
    [anon_sym_QMARK] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2351),
    [anon_sym_or] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_CARET] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_SLASH] = ACTIONS(2351),
    [anon_sym_PERCENT] = ACTIONS(2351),
    [sym_comment] = ACTIONS(87),
  },
  [338] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1334),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(1334),
    [sym_operator_assignment] = STATE(1334),
    [sym_conditional] = STATE(1334),
    [sym_range] = STATE(1334),
    [sym_binary] = STATE(1334),
    [sym_unary] = STATE(1334),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [339] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1335),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(1335),
    [sym_operator_assignment] = STATE(1335),
    [sym_conditional] = STATE(1335),
    [sym_range] = STATE(1335),
    [sym_binary] = STATE(1335),
    [sym_unary] = STATE(1335),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [340] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(2355),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [341] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(2357),
  },
  [342] = {
    [sym__heredoc_body_start] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_in] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_EQ_GT] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_COLON2] = ACTIONS(567),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [343] = {
    [sym__heredoc_body_start] = ACTIONS(569),
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_in] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_EQ_GT] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_COLON2] = ACTIONS(571),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [344] = {
    [sym__heredoc_body_start] = ACTIONS(573),
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_in] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_EQ_GT] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(575),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [345] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(1339),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(1340),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(2359),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [346] = {
    [sym_lambda_parameters] = STATE(1343),
    [sym__simple_formal_parameter] = STATE(364),
    [sym_splat_parameter] = STATE(364),
    [sym_hash_splat_parameter] = STATE(364),
    [sym_block_parameter] = STATE(364),
    [sym_keyword_parameter] = STATE(364),
    [sym_optional_parameter] = STATE(364),
    [sym_do_block] = STATE(1344),
    [sym_block] = STATE(1344),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(2363),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [347] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_EQ_GT] = ACTIONS(2309),
    [anon_sym_RBRACK] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(2375),
    [anon_sym_DOT_DOT] = ACTIONS(2377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2379),
    [anon_sym_and] = ACTIONS(2381),
    [anon_sym_or] = ACTIONS(2381),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ_GT] = ACTIONS(2383),
    [anon_sym_EQ_TILDE] = ACTIONS(2383),
    [anon_sym_BANG_TILDE] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [348] = {
    [sym__heredoc_body_start] = ACTIONS(733),
    [sym__binary_minus] = ACTIONS(733),
    [sym__binary_star] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(2397),
    [anon_sym_AMP_DOT] = ACTIONS(2399),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_COLON2] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ_GT] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_BANG_TILDE] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [sym_comment] = ACTIONS(87),
  },
  [349] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1372),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(1375),
    [sym__argument] = STATE(1376),
    [sym_splat_argument] = STATE(1376),
    [sym_hash_splat_argument] = STATE(1376),
    [sym_block_argument] = STATE(1376),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(1372),
    [sym_operator_assignment] = STATE(1372),
    [sym_conditional] = STATE(1372),
    [sym_range] = STATE(1372),
    [sym_binary] = STATE(1372),
    [sym_unary] = STATE(1372),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1380),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1376),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2401),
    [sym__splat_star] = ACTIONS(2403),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_identifier] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [350] = {
    [sym_heredoc_body] = STATE(1382),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(2435),
    [sym_comment] = ACTIONS(87),
  },
  [351] = {
    [sym__heredoc_body_start] = ACTIONS(2437),
    [anon_sym_COMMA] = ACTIONS(2439),
    [anon_sym_RBRACK] = ACTIONS(2437),
    [sym_comment] = ACTIONS(87),
  },
  [352] = {
    [anon_sym_EQ] = ACTIONS(2441),
    [sym_comment] = ACTIONS(87),
  },
  [353] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2443),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2445),
    [anon_sym_DASH_EQ] = ACTIONS(2445),
    [anon_sym_STAR_EQ] = ACTIONS(2445),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2445),
    [anon_sym_SLASH_EQ] = ACTIONS(2445),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2445),
    [anon_sym_PIPE_EQ] = ACTIONS(2445),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2445),
    [anon_sym_AMP_EQ] = ACTIONS(2445),
    [anon_sym_PERCENT_EQ] = ACTIONS(2445),
    [anon_sym_GT_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_LT_EQ] = ACTIONS(2445),
    [anon_sym_CARET_EQ] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [354] = {
    [sym_string] = STATE(1386),
    [aux_sym_chained_string_repeat1] = STATE(1386),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(2447),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [355] = {
    [anon_sym_RBRACK] = ACTIONS(2435),
    [sym_comment] = ACTIONS(87),
  },
  [356] = {
    [sym__statements] = STATE(1389),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(1390),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2449),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [357] = {
    [sym__formal_parameter] = STATE(1394),
    [sym__simple_formal_parameter] = STATE(1394),
    [sym_destructured_parameter] = STATE(1394),
    [sym_splat_parameter] = STATE(1394),
    [sym_hash_splat_parameter] = STATE(1394),
    [sym_block_parameter] = STATE(1394),
    [sym_keyword_parameter] = STATE(1394),
    [sym_optional_parameter] = STATE(1394),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_RPAREN] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2457),
    [sym_comment] = ACTIONS(87),
  },
  [358] = {
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_RPAREN] = ACTIONS(2459),
    [anon_sym_COMMA] = ACTIONS(2459),
    [anon_sym_PIPE] = ACTIONS(2459),
    [anon_sym_SEMI] = ACTIONS(2459),
    [anon_sym_do] = ACTIONS(2461),
    [sym_identifier] = ACTIONS(2463),
    [sym_comment] = ACTIONS(87),
  },
  [359] = {
    [anon_sym_LBRACE] = ACTIONS(2465),
    [anon_sym_RPAREN] = ACTIONS(2465),
    [anon_sym_COMMA] = ACTIONS(2465),
    [anon_sym_PIPE] = ACTIONS(2465),
    [anon_sym_SEMI] = ACTIONS(2465),
    [anon_sym_do] = ACTIONS(2467),
    [sym_identifier] = ACTIONS(2469),
    [sym_comment] = ACTIONS(87),
  },
  [360] = {
    [sym_lambda] = STATE(1397),
    [sym_identifier] = ACTIONS(2471),
    [sym_comment] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [361] = {
    [sym__statements] = STATE(1400),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(1401),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1402),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(1402),
    [sym__line_break] = ACTIONS(2473),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [362] = {
    [anon_sym_LBRACE] = ACTIONS(2479),
    [anon_sym_COMMA] = ACTIONS(2479),
    [anon_sym_COLON] = ACTIONS(2481),
    [anon_sym_EQ] = ACTIONS(2483),
    [anon_sym_do] = ACTIONS(2479),
    [sym_comment] = ACTIONS(87),
  },
  [363] = {
    [sym_do_block] = STATE(1405),
    [sym_block] = STATE(1405),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(2485),
    [sym_comment] = ACTIONS(87),
  },
  [364] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(1407),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_do] = ACTIONS(2487),
    [sym_comment] = ACTIONS(87),
  },
  [365] = {
    [sym__line_break] = ACTIONS(2491),
    [sym__heredoc_body_start] = ACTIONS(2491),
    [sym__binary_minus] = ACTIONS(2491),
    [sym__binary_star] = ACTIONS(2491),
    [ts_builtin_sym_end] = ACTIONS(2491),
    [anon_sym___END__] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2493),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_STAR_STAR] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_end] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_unless] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_until] = ACTIONS(2491),
    [anon_sym_rescue] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_when] = ACTIONS(2491),
    [anon_sym_elsif] = ACTIONS(2491),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_then] = ACTIONS(2491),
    [anon_sym_ensure] = ACTIONS(2491),
    [anon_sym_EQ_GT] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_COLON_COLON2] = ACTIONS(2491),
    [anon_sym_AMP_DOT] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2491),
    [anon_sym_DOT_DOT] = ACTIONS(2493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2491),
    [anon_sym_and] = ACTIONS(2491),
    [anon_sym_or] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2491),
    [anon_sym_AMP_AMP] = ACTIONS(2491),
    [anon_sym_LT_LT] = ACTIONS(2491),
    [anon_sym_GT_GT] = ACTIONS(2491),
    [anon_sym_EQ_EQ] = ACTIONS(2493),
    [anon_sym_BANG_EQ] = ACTIONS(2491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ_GT] = ACTIONS(2491),
    [anon_sym_EQ_TILDE] = ACTIONS(2491),
    [anon_sym_BANG_TILDE] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_SLASH] = ACTIONS(2491),
    [anon_sym_PERCENT] = ACTIONS(2491),
    [sym_comment] = ACTIONS(87),
  },
  [366] = {
    [sym__line_break] = ACTIONS(2495),
    [sym_comment] = ACTIONS(87),
  },
  [367] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(45),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(45),
    [sym_unless_modifier] = STATE(45),
    [sym_while_modifier] = STATE(45),
    [sym_until_modifier] = STATE(45),
    [sym_rescue_modifier] = STATE(45),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(46),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(46),
    [sym_operator_assignment] = STATE(46),
    [sym_conditional] = STATE(46),
    [sym_range] = STATE(46),
    [sym_binary] = STATE(46),
    [sym_unary] = STATE(46),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_undef] = STATE(45),
    [sym_alias] = STATE(45),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(45),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [ts_builtin_sym_end] = ACTIONS(2497),
    [anon_sym___END__] = ACTIONS(2499),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [anon_sym_undef] = ACTIONS(83),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [368] = {
    [sym_heredoc_body] = STATE(1410),
    [sym__terminator] = STATE(1410),
    [aux_sym__statements_repeat1] = STATE(1411),
    [sym__line_break] = ACTIONS(2501),
    [sym__heredoc_body_start] = ACTIONS(507),
    [ts_builtin_sym_end] = ACTIONS(2497),
    [anon_sym___END__] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(2501),
    [sym_comment] = ACTIONS(87),
  },
  [369] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1412),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1412),
    [sym_operator_assignment] = STATE(1412),
    [sym_conditional] = STATE(1412),
    [sym_range] = STATE(1412),
    [sym_binary] = STATE(1412),
    [sym_unary] = STATE(1412),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [370] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1413),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1413),
    [sym_operator_assignment] = STATE(1413),
    [sym_conditional] = STATE(1413),
    [sym_range] = STATE(1413),
    [sym_binary] = STATE(1413),
    [sym_unary] = STATE(1413),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [371] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1414),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1414),
    [sym_operator_assignment] = STATE(1414),
    [sym_conditional] = STATE(1414),
    [sym_range] = STATE(1414),
    [sym_binary] = STATE(1414),
    [sym_unary] = STATE(1414),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [372] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1415),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1415),
    [sym_operator_assignment] = STATE(1415),
    [sym_conditional] = STATE(1415),
    [sym_range] = STATE(1415),
    [sym_binary] = STATE(1415),
    [sym_unary] = STATE(1415),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [373] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1416),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1416),
    [sym_operator_assignment] = STATE(1416),
    [sym_conditional] = STATE(1416),
    [sym_range] = STATE(1416),
    [sym_binary] = STATE(1416),
    [sym_unary] = STATE(1416),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [374] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1417),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1417),
    [sym_operator_assignment] = STATE(1417),
    [sym_conditional] = STATE(1417),
    [sym_range] = STATE(1417),
    [sym_binary] = STATE(1417),
    [sym_unary] = STATE(1417),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [375] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1418),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1418),
    [sym_operator_assignment] = STATE(1418),
    [sym_conditional] = STATE(1418),
    [sym_range] = STATE(1418),
    [sym_binary] = STATE(1418),
    [sym_unary] = STATE(1418),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [376] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1419),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1419),
    [sym_operator_assignment] = STATE(1419),
    [sym_conditional] = STATE(1419),
    [sym_range] = STATE(1419),
    [sym_binary] = STATE(1419),
    [sym_unary] = STATE(1419),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [377] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1420),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1420),
    [sym_operator_assignment] = STATE(1420),
    [sym_conditional] = STATE(1420),
    [sym_range] = STATE(1420),
    [sym_binary] = STATE(1420),
    [sym_unary] = STATE(1420),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [378] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1421),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1421),
    [sym_operator_assignment] = STATE(1421),
    [sym_conditional] = STATE(1421),
    [sym_range] = STATE(1421),
    [sym_binary] = STATE(1421),
    [sym_unary] = STATE(1421),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [379] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(1430),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(1430),
    [sym_operator_assignment] = STATE(1430),
    [sym_conditional] = STATE(1430),
    [sym_range] = STATE(1430),
    [sym_binary] = STATE(1430),
    [sym_unary] = STATE(1430),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [380] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1435),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1435),
    [sym_operator_assignment] = STATE(1435),
    [sym_conditional] = STATE(1435),
    [sym_range] = STATE(1435),
    [sym_binary] = STATE(1435),
    [sym_unary] = STATE(1435),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [381] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1436),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1436),
    [sym_operator_assignment] = STATE(1436),
    [sym_conditional] = STATE(1436),
    [sym_range] = STATE(1436),
    [sym_binary] = STATE(1436),
    [sym_unary] = STATE(1436),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [382] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1437),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1437),
    [sym_operator_assignment] = STATE(1437),
    [sym_conditional] = STATE(1437),
    [sym_range] = STATE(1437),
    [sym_binary] = STATE(1437),
    [sym_unary] = STATE(1437),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [383] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1438),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1438),
    [sym_operator_assignment] = STATE(1438),
    [sym_conditional] = STATE(1438),
    [sym_range] = STATE(1438),
    [sym_binary] = STATE(1438),
    [sym_unary] = STATE(1438),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [384] = {
    [sym_argument_list_with_parens] = STATE(1442),
    [sym__argument_list_with_parens] = STATE(1443),
    [sym_operator] = STATE(1442),
    [sym_heredoc_body] = STATE(1444),
    [aux_sym_call_repeat1] = STATE(1444),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(2531),
    [anon_sym_STAR_STAR] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_LPAREN2] = ACTIONS(2533),
    [anon_sym_DOT_DOT] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2529),
    [anon_sym_GT_GT] = ACTIONS(2529),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2529),
    [anon_sym_LT_EQ_GT] = ACTIONS(2529),
    [anon_sym_EQ_TILDE] = ACTIONS(2529),
    [anon_sym_BANG_TILDE] = ACTIONS(2529),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_CARET] = ACTIONS(2529),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2529),
    [anon_sym_PERCENT] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(2531),
    [anon_sym_TILDE] = ACTIONS(2529),
    [sym_constant] = ACTIONS(2535),
    [sym_identifier] = ACTIONS(2535),
    [anon_sym_DASH] = ACTIONS(2531),
    [anon_sym_PLUS_AT] = ACTIONS(2529),
    [anon_sym_DASH_AT] = ACTIONS(2529),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2531),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2529),
    [anon_sym_BQUOTE] = ACTIONS(2529),
    [sym_comment] = ACTIONS(87),
  },
  [385] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(1446),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(1447),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(2537),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [386] = {
    [sym_constant] = ACTIONS(2539),
    [sym_identifier] = ACTIONS(2539),
    [sym_comment] = ACTIONS(87),
  },
  [387] = {
    [sym__line_break] = ACTIONS(101),
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_when] = ACTIONS(101),
    [anon_sym_elsif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_then] = ACTIONS(101),
    [anon_sym_ensure] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [388] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1450),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2541),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [389] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1452),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2543),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [390] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1454),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2545),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [391] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1456),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(2547),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [392] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1459),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(2549),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2551),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [393] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1462),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(2553),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2555),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [394] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(1492),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(1492),
    [sym_operator_assignment] = STATE(1492),
    [sym_conditional] = STATE(1492),
    [sym_range] = STATE(1492),
    [sym_binary] = STATE(1492),
    [sym_unary] = STATE(1492),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [395] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(1498),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(1498),
    [sym_operator_assignment] = STATE(1498),
    [sym_conditional] = STATE(1498),
    [sym_range] = STATE(1498),
    [sym_binary] = STATE(1498),
    [sym_unary] = STATE(1498),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [396] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1500),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(1500),
    [sym_operator_assignment] = STATE(1500),
    [sym_conditional] = STATE(1500),
    [sym_range] = STATE(1500),
    [sym_binary] = STATE(1500),
    [sym_unary] = STATE(1500),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [397] = {
    [anon_sym_COLON] = ACTIONS(2635),
    [sym_comment] = ACTIONS(87),
  },
  [398] = {
    [sym__statements] = STATE(1512),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(1513),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1519),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1520),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [399] = {
    [sym__method_rest] = STATE(1522),
    [sym__variable] = STATE(1523),
    [sym_operator] = STATE(1524),
    [sym__method_name] = STATE(1524),
    [sym_setter] = STATE(1524),
    [sym_symbol] = STATE(1524),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(2663),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(2665),
    [sym_self] = ACTIONS(2665),
  },
  [400] = {
    [sym__statements] = STATE(1526),
    [sym__top_level_statement] = STATE(144),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(149),
    [sym__simple_mlhs] = STATE(150),
    [sym_destructured_left_assignment] = STATE(150),
    [sym_rest_assignment] = STATE(150),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(2667),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [401] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(1527),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(1527),
    [sym_operator_assignment] = STATE(1527),
    [sym_conditional] = STATE(1527),
    [sym_range] = STATE(1527),
    [sym_binary] = STATE(1527),
    [sym_unary] = STATE(1527),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [402] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1530),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(2671),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [403] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1532),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(2673),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [404] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1665),
    [sym__splat_star] = ACTIONS(1667),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1669),
    [ts_builtin_sym_end] = ACTIONS(363),
    [anon_sym___END__] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1677),
    [sym_identifier] = ACTIONS(1677),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [405] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1665),
    [sym__splat_star] = ACTIONS(1667),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1669),
    [ts_builtin_sym_end] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1677),
    [sym_identifier] = ACTIONS(1677),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [406] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1665),
    [sym__splat_star] = ACTIONS(1667),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1669),
    [ts_builtin_sym_end] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1677),
    [sym_identifier] = ACTIONS(1677),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [407] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1665),
    [sym__splat_star] = ACTIONS(1667),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1669),
    [ts_builtin_sym_end] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1677),
    [sym_identifier] = ACTIONS(1677),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [408] = {
    [sym__statement] = STATE(1537),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1537),
    [sym_unless_modifier] = STATE(1537),
    [sym_while_modifier] = STATE(1537),
    [sym_until_modifier] = STATE(1537),
    [sym_rescue_modifier] = STATE(1537),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1537),
    [sym_alias] = STATE(1537),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1537),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [409] = {
    [sym__statement] = STATE(1538),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1538),
    [sym_unless_modifier] = STATE(1538),
    [sym_while_modifier] = STATE(1538),
    [sym_until_modifier] = STATE(1538),
    [sym_rescue_modifier] = STATE(1538),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1538),
    [sym_alias] = STATE(1538),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1538),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [410] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1539),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1539),
    [sym_operator_assignment] = STATE(1539),
    [sym_conditional] = STATE(1539),
    [sym_range] = STATE(1539),
    [sym_binary] = STATE(1539),
    [sym_unary] = STATE(1539),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [411] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1540),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1540),
    [sym_operator_assignment] = STATE(1540),
    [sym_conditional] = STATE(1540),
    [sym_range] = STATE(1540),
    [sym_binary] = STATE(1540),
    [sym_unary] = STATE(1540),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [412] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(1541),
    [sym__simple_mlhs] = STATE(257),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [413] = {
    [sym__statements] = STATE(1543),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(1544),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1545),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(1545),
    [sym__line_break] = ACTIONS(2675),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [414] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1546),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1546),
    [sym_operator_assignment] = STATE(1546),
    [sym_conditional] = STATE(1546),
    [sym_range] = STATE(1546),
    [sym_binary] = STATE(1546),
    [sym_unary] = STATE(1546),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1547),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__terminator] = STATE(1547),
    [sym__line_break] = ACTIONS(2679),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [415] = {
    [sym__statements] = STATE(1548),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1549),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1550),
    [sym_rescue] = STATE(1551),
    [sym__body_statement] = STATE(1552),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1553),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__terminator] = STATE(1553),
    [sym__line_break] = ACTIONS(2681),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2683),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [416] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(1555),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(1556),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [417] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1557),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(1557),
    [sym_operator_assignment] = STATE(1557),
    [sym_conditional] = STATE(1557),
    [sym_range] = STATE(1557),
    [sym_binary] = STATE(1557),
    [sym_unary] = STATE(1557),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [418] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [419] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym___END__] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(2687),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [420] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(2689),
  },
  [421] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(1562),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(1563),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(2691),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [422] = {
    [sym_lambda_parameters] = STATE(1565),
    [sym__simple_formal_parameter] = STATE(364),
    [sym_splat_parameter] = STATE(364),
    [sym_hash_splat_parameter] = STATE(364),
    [sym_block_parameter] = STATE(364),
    [sym_keyword_parameter] = STATE(364),
    [sym_optional_parameter] = STATE(364),
    [sym_do_block] = STATE(1566),
    [sym_block] = STATE(1566),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(1673),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [423] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(1627),
    [anon_sym___END__] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [424] = {
    [sym__line_break] = ACTIONS(733),
    [sym__heredoc_body_start] = ACTIONS(733),
    [sym__binary_minus] = ACTIONS(733),
    [sym__binary_star] = ACTIONS(733),
    [ts_builtin_sym_end] = ACTIONS(733),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(1657),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(1659),
    [anon_sym_COLON_COLON2] = ACTIONS(1661),
    [anon_sym_AMP_DOT] = ACTIONS(1663),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ_GT] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_BANG_TILDE] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_comment] = ACTIONS(87),
  },
  [425] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(939),
    [sym__argument] = STATE(940),
    [sym_splat_argument] = STATE(940),
    [sym_hash_splat_argument] = STATE(940),
    [sym_block_argument] = STATE(940),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(940),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1665),
    [sym__splat_star] = ACTIONS(1667),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1669),
    [ts_builtin_sym_end] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1677),
    [sym_identifier] = ACTIONS(1677),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [426] = {
    [sym_do_block] = STATE(1580),
    [sym_block] = STATE(1580),
    [sym__line_break] = ACTIONS(2725),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [ts_builtin_sym_end] = ACTIONS(2725),
    [anon_sym___END__] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2727),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_end] = ACTIONS(2725),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_when] = ACTIONS(2725),
    [anon_sym_elsif] = ACTIONS(2725),
    [anon_sym_else] = ACTIONS(2725),
    [anon_sym_then] = ACTIONS(2725),
    [anon_sym_ensure] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [427] = {
    [sym_heredoc_body] = STATE(1582),
    [aux_sym_call_repeat1] = STATE(1582),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym___END__] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [428] = {
    [sym_heredoc_body] = STATE(1582),
    [aux_sym_call_repeat1] = STATE(1582),
    [aux_sym_argument_list_repeat1] = STATE(1584),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym___END__] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(2735),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [429] = {
    [sym__line_break] = ACTIONS(2725),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [ts_builtin_sym_end] = ACTIONS(2725),
    [anon_sym___END__] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_end] = ACTIONS(2725),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_when] = ACTIONS(2725),
    [anon_sym_elsif] = ACTIONS(2725),
    [anon_sym_else] = ACTIONS(2725),
    [anon_sym_then] = ACTIONS(2725),
    [anon_sym_ensure] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [430] = {
    [anon_sym_EQ] = ACTIONS(2737),
    [sym_comment] = ACTIONS(87),
  },
  [431] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2739),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2741),
    [anon_sym_DASH_EQ] = ACTIONS(2741),
    [anon_sym_STAR_EQ] = ACTIONS(2741),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2741),
    [anon_sym_SLASH_EQ] = ACTIONS(2741),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2741),
    [anon_sym_PIPE_EQ] = ACTIONS(2741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2741),
    [anon_sym_AMP_EQ] = ACTIONS(2741),
    [anon_sym_PERCENT_EQ] = ACTIONS(2741),
    [anon_sym_GT_GT_EQ] = ACTIONS(2741),
    [anon_sym_LT_LT_EQ] = ACTIONS(2741),
    [anon_sym_CARET_EQ] = ACTIONS(2741),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [432] = {
    [sym_string] = STATE(1587),
    [aux_sym_chained_string_repeat1] = STATE(1587),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(2743),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [433] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1592),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_splat_argument] = STATE(1594),
    [sym_assignment] = STATE(1592),
    [sym_operator_assignment] = STATE(1592),
    [sym_conditional] = STATE(1592),
    [sym_range] = STATE(1592),
    [sym_binary] = STATE(1592),
    [sym_unary] = STATE(1592),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(1594),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2745),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [434] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(185),
    [sym_call] = STATE(185),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(1597),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(185),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_EQ] = ACTIONS(2757),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(331),
    [sym_identifier] = ACTIONS(331),
    [sym_instance_variable] = ACTIONS(333),
    [sym_class_variable] = ACTIONS(333),
    [sym_global_variable] = ACTIONS(333),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(331),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(331),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [435] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1598),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(1598),
    [sym_operator_assignment] = STATE(1598),
    [sym_conditional] = STATE(1598),
    [sym_range] = STATE(1598),
    [sym_binary] = STATE(1598),
    [sym_unary] = STATE(1598),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [436] = {
    [sym_string] = STATE(1599),
    [aux_sym_chained_string_repeat1] = STATE(1599),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [ts_builtin_sym_end] = ACTIONS(2759),
    [anon_sym___END__] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [437] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(1600),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(1600),
    [sym_operator_assignment] = STATE(1600),
    [sym_conditional] = STATE(1600),
    [sym_range] = STATE(1600),
    [sym_binary] = STATE(1600),
    [sym_unary] = STATE(1600),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [438] = {
    [sym_constant] = ACTIONS(2763),
    [sym_identifier] = ACTIONS(2763),
    [sym_comment] = ACTIONS(87),
  },
  [439] = {
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_unless] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_until] = ACTIONS(275),
    [anon_sym_rescue] = ACTIONS(275),
    [sym_comment] = ACTIONS(87),
  },
  [440] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(562),
    [sym__argument_list_with_parens] = STATE(1616),
    [sym__argument] = STATE(1617),
    [sym_splat_argument] = STATE(1617),
    [sym_hash_splat_argument] = STATE(1617),
    [sym_block_argument] = STATE(1617),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1617),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [441] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(568),
    [sym__argument_list_with_parens] = STATE(1616),
    [sym__argument] = STATE(1617),
    [sym_splat_argument] = STATE(1617),
    [sym_hash_splat_argument] = STATE(1617),
    [sym_block_argument] = STATE(1617),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1617),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [442] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(1616),
    [sym__argument] = STATE(1617),
    [sym_splat_argument] = STATE(1617),
    [sym_hash_splat_argument] = STATE(1617),
    [sym_block_argument] = STATE(1617),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1617),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [443] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(1616),
    [sym__argument] = STATE(1617),
    [sym_splat_argument] = STATE(1617),
    [sym_hash_splat_argument] = STATE(1617),
    [sym_block_argument] = STATE(1617),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1617),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [444] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(1621),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(1621),
    [sym_operator_assignment] = STATE(1621),
    [sym_conditional] = STATE(1621),
    [sym_range] = STATE(1621),
    [sym_binary] = STATE(1621),
    [sym_unary] = STATE(1621),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [445] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [446] = {
    [sym_operator] = STATE(1624),
    [sym__method_name] = STATE(1624),
    [sym_setter] = STATE(1624),
    [sym_symbol] = STATE(1624),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__symbol_start] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_STAR_STAR] = ACTIONS(2795),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_LT] = ACTIONS(2797),
    [anon_sym_DOT_DOT] = ACTIONS(2795),
    [anon_sym_LT_LT] = ACTIONS(2795),
    [anon_sym_GT_GT] = ACTIONS(2795),
    [anon_sym_EQ_EQ] = ACTIONS(2797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2795),
    [anon_sym_LT_EQ_GT] = ACTIONS(2795),
    [anon_sym_EQ_TILDE] = ACTIONS(2795),
    [anon_sym_BANG_TILDE] = ACTIONS(2795),
    [anon_sym_LT_EQ] = ACTIONS(2797),
    [anon_sym_GT] = ACTIONS(2797),
    [anon_sym_GT_EQ] = ACTIONS(2795),
    [anon_sym_CARET] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_SLASH] = ACTIONS(2795),
    [anon_sym_PERCENT] = ACTIONS(2795),
    [anon_sym_BANG] = ACTIONS(2797),
    [anon_sym_TILDE] = ACTIONS(2795),
    [sym_constant] = ACTIONS(2799),
    [sym_identifier] = ACTIONS(2801),
    [sym_instance_variable] = ACTIONS(2799),
    [sym_class_variable] = ACTIONS(2799),
    [sym_global_variable] = ACTIONS(2799),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_PLUS_AT] = ACTIONS(2795),
    [anon_sym_DASH_AT] = ACTIONS(2795),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2797),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2795),
    [anon_sym_BQUOTE] = ACTIONS(2795),
    [sym_comment] = ACTIONS(87),
  },
  [447] = {
    [sym_operator] = STATE(1625),
    [sym__method_name] = STATE(1625),
    [sym_setter] = STATE(1625),
    [sym_symbol] = STATE(1625),
    [sym__simple_symbol] = ACTIONS(547),
    [sym__symbol_start] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_STAR] = ACTIONS(553),
    [anon_sym_STAR_STAR] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_DOT_DOT] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(551),
    [anon_sym_LT_EQ_GT] = ACTIONS(551),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_BANG_TILDE] = ACTIONS(551),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_EQ] = ACTIONS(551),
    [anon_sym_CARET] = ACTIONS(551),
    [anon_sym_PLUS] = ACTIONS(553),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_PERCENT] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(551),
    [sym_constant] = ACTIONS(2803),
    [sym_identifier] = ACTIONS(557),
    [sym_instance_variable] = ACTIONS(2803),
    [sym_class_variable] = ACTIONS(2803),
    [sym_global_variable] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(553),
    [anon_sym_PLUS_AT] = ACTIONS(551),
    [anon_sym_DASH_AT] = ACTIONS(551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(553),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [sym_comment] = ACTIONS(87),
  },
  [448] = {
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_COLON2] = ACTIONS(567),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [449] = {
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_COLON2] = ACTIONS(571),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [450] = {
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(575),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [451] = {
    [anon_sym_RBRACE] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2811),
    [anon_sym_until] = ACTIONS(2813),
    [anon_sym_rescue] = ACTIONS(2815),
    [sym_comment] = ACTIONS(87),
  },
  [452] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [453] = {
    [sym__binary_minus] = ACTIONS(733),
    [sym__binary_star] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(2845),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_COLON_COLON2] = ACTIONS(2849),
    [anon_sym_AMP_DOT] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_COLON2] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ_GT] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_BANG_TILDE] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [sym_comment] = ACTIONS(87),
  },
  [454] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(1662),
    [sym__argument_list_with_parens] = STATE(1663),
    [sym__argument] = STATE(1664),
    [sym_splat_argument] = STATE(1664),
    [sym_hash_splat_argument] = STATE(1664),
    [sym_block_argument] = STATE(1664),
    [sym_do_block] = STATE(1665),
    [sym_block] = STATE(1665),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1668),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1664),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2853),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2883),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [455] = {
    [anon_sym_EQ] = ACTIONS(2889),
    [sym_comment] = ACTIONS(87),
  },
  [456] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2893),
    [anon_sym_DASH_EQ] = ACTIONS(2893),
    [anon_sym_STAR_EQ] = ACTIONS(2893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2893),
    [anon_sym_SLASH_EQ] = ACTIONS(2893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2893),
    [anon_sym_PIPE_EQ] = ACTIONS(2893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2893),
    [anon_sym_AMP_EQ] = ACTIONS(2893),
    [anon_sym_PERCENT_EQ] = ACTIONS(2893),
    [anon_sym_GT_GT_EQ] = ACTIONS(2893),
    [anon_sym_LT_LT_EQ] = ACTIONS(2893),
    [anon_sym_CARET_EQ] = ACTIONS(2893),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [457] = {
    [sym_string] = STATE(1671),
    [aux_sym_chained_string_repeat1] = STATE(1671),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [458] = {
    [sym__line_break] = ACTIONS(2895),
    [sym__string_start] = ACTIONS(2895),
    [sym__heredoc_body_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [ts_builtin_sym_end] = ACTIONS(2895),
    [anon_sym___END__] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_STAR_STAR] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_end] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_unless] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_until] = ACTIONS(2895),
    [anon_sym_rescue] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_when] = ACTIONS(2895),
    [anon_sym_elsif] = ACTIONS(2895),
    [anon_sym_else] = ACTIONS(2895),
    [anon_sym_then] = ACTIONS(2895),
    [anon_sym_ensure] = ACTIONS(2895),
    [anon_sym_EQ_GT] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_LT_LT] = ACTIONS(2895),
    [anon_sym_GT_GT] = ACTIONS(2895),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(87),
  },
  [459] = {
    [sym_interpolation] = STATE(459),
    [aux_sym__literal_contents_repeat1] = STATE(459),
    [sym__string_content] = ACTIONS(2899),
    [sym__string_end] = ACTIONS(2902),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(2904),
    [sym_escape_sequence] = ACTIONS(2899),
  },
  [460] = {
    [sym__line_break] = ACTIONS(2907),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [sym__binary_minus] = ACTIONS(2907),
    [sym__binary_star] = ACTIONS(2907),
    [ts_builtin_sym_end] = ACTIONS(2907),
    [anon_sym___END__] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_STAR_STAR] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_end] = ACTIONS(2907),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_unless] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_until] = ACTIONS(2907),
    [anon_sym_rescue] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_when] = ACTIONS(2907),
    [anon_sym_elsif] = ACTIONS(2907),
    [anon_sym_else] = ACTIONS(2907),
    [anon_sym_then] = ACTIONS(2907),
    [anon_sym_ensure] = ACTIONS(2907),
    [anon_sym_EQ_GT] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_COLON_COLON2] = ACTIONS(2907),
    [anon_sym_AMP_DOT] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_and] = ACTIONS(2907),
    [anon_sym_or] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2907),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_CARET] = ACTIONS(2907),
    [anon_sym_PLUS] = ACTIONS(2907),
    [anon_sym_SLASH] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2907),
    [sym_comment] = ACTIONS(87),
  },
  [461] = {
    [sym__line_break] = ACTIONS(2911),
    [sym__heredoc_body_start] = ACTIONS(2911),
    [sym__binary_minus] = ACTIONS(2911),
    [sym__binary_star] = ACTIONS(2911),
    [ts_builtin_sym_end] = ACTIONS(2911),
    [anon_sym___END__] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_RPAREN] = ACTIONS(2911),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_STAR_STAR] = ACTIONS(2911),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_end] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_unless] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_until] = ACTIONS(2911),
    [anon_sym_rescue] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_when] = ACTIONS(2911),
    [anon_sym_elsif] = ACTIONS(2911),
    [anon_sym_else] = ACTIONS(2911),
    [anon_sym_then] = ACTIONS(2911),
    [anon_sym_ensure] = ACTIONS(2911),
    [anon_sym_EQ_GT] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_COLON_COLON2] = ACTIONS(2911),
    [anon_sym_AMP_DOT] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE] = ACTIONS(2911),
    [anon_sym_AMP_AMP] = ACTIONS(2911),
    [anon_sym_LT_LT] = ACTIONS(2911),
    [anon_sym_GT_GT] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_CARET] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_SLASH] = ACTIONS(2911),
    [anon_sym_PERCENT] = ACTIONS(2911),
    [sym_comment] = ACTIONS(87),
  },
  [462] = {
    [sym__line_break] = ACTIONS(2915),
    [sym__heredoc_body_start] = ACTIONS(2915),
    [sym__binary_minus] = ACTIONS(2915),
    [sym__binary_star] = ACTIONS(2915),
    [ts_builtin_sym_end] = ACTIONS(2915),
    [anon_sym___END__] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_STAR_STAR] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_end] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_unless] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_until] = ACTIONS(2915),
    [anon_sym_rescue] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_when] = ACTIONS(2915),
    [anon_sym_elsif] = ACTIONS(2915),
    [anon_sym_else] = ACTIONS(2915),
    [anon_sym_then] = ACTIONS(2915),
    [anon_sym_ensure] = ACTIONS(2915),
    [anon_sym_EQ_GT] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_COLON_COLON2] = ACTIONS(2915),
    [anon_sym_AMP_DOT] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_AMP_AMP] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2915),
    [anon_sym_EQ_TILDE] = ACTIONS(2915),
    [anon_sym_BANG_TILDE] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [sym_comment] = ACTIONS(87),
  },
  [463] = {
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2811),
    [anon_sym_until] = ACTIONS(2813),
    [anon_sym_rescue] = ACTIONS(2815),
    [sym_comment] = ACTIONS(87),
  },
  [464] = {
    [sym__line_break] = ACTIONS(2921),
    [sym__heredoc_body_start] = ACTIONS(2921),
    [sym__binary_minus] = ACTIONS(2921),
    [sym__binary_star] = ACTIONS(2921),
    [ts_builtin_sym_end] = ACTIONS(2921),
    [anon_sym___END__] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_STAR_STAR] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_end] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_unless] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_until] = ACTIONS(2921),
    [anon_sym_rescue] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_elsif] = ACTIONS(2921),
    [anon_sym_else] = ACTIONS(2921),
    [anon_sym_then] = ACTIONS(2921),
    [anon_sym_ensure] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_COLON_COLON2] = ACTIONS(2921),
    [anon_sym_AMP_DOT] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_and] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [sym_comment] = ACTIONS(87),
  },
  [465] = {
    [sym__string_end] = ACTIONS(2925),
    [sym_comment] = ACTIONS(87),
  },
  [466] = {
    [aux_sym_string_array_repeat1] = STATE(1676),
    [sym__string_end] = ACTIONS(2927),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2929),
  },
  [467] = {
    [sym__line_break] = ACTIONS(2931),
    [sym__heredoc_body_start] = ACTIONS(2931),
    [sym__binary_minus] = ACTIONS(2931),
    [sym__binary_star] = ACTIONS(2931),
    [ts_builtin_sym_end] = ACTIONS(2931),
    [anon_sym___END__] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_STAR_STAR] = ACTIONS(2931),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_end] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_unless] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_until] = ACTIONS(2931),
    [anon_sym_rescue] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_when] = ACTIONS(2931),
    [anon_sym_elsif] = ACTIONS(2931),
    [anon_sym_else] = ACTIONS(2931),
    [anon_sym_then] = ACTIONS(2931),
    [anon_sym_ensure] = ACTIONS(2931),
    [anon_sym_EQ_GT] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_COLON_COLON2] = ACTIONS(2931),
    [anon_sym_AMP_DOT] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2931),
    [anon_sym_DOT_DOT] = ACTIONS(2933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2931),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2931),
    [anon_sym_LT_LT] = ACTIONS(2931),
    [anon_sym_GT_GT] = ACTIONS(2931),
    [anon_sym_EQ_EQ] = ACTIONS(2933),
    [anon_sym_BANG_EQ] = ACTIONS(2931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2931),
    [anon_sym_EQ_TILDE] = ACTIONS(2931),
    [anon_sym_BANG_TILDE] = ACTIONS(2931),
    [anon_sym_LT_EQ] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_GT_EQ] = ACTIONS(2931),
    [anon_sym_CARET] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2931),
    [anon_sym_PERCENT] = ACTIONS(2931),
    [sym_comment] = ACTIONS(87),
  },
  [468] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(2935),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [469] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(2935),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2937),
  },
  [470] = {
    [sym_interpolation] = STATE(470),
    [aux_sym__literal_contents_repeat1] = STATE(470),
    [sym__string_content] = ACTIONS(2939),
    [sym__string_end] = ACTIONS(2902),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(2942),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2945),
    [sym_escape_sequence] = ACTIONS(2947),
  },
  [471] = {
    [sym__line_break] = ACTIONS(2950),
    [sym__heredoc_body_start] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym__binary_star] = ACTIONS(2950),
    [ts_builtin_sym_end] = ACTIONS(2950),
    [anon_sym___END__] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_STAR_STAR] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_end] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_unless] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_until] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_when] = ACTIONS(2950),
    [anon_sym_elsif] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_then] = ACTIONS(2950),
    [anon_sym_ensure] = ACTIONS(2950),
    [anon_sym_EQ_GT] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_COLON_COLON2] = ACTIONS(2950),
    [anon_sym_AMP_DOT] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_LT_LT] = ACTIONS(2950),
    [anon_sym_GT_GT] = ACTIONS(2950),
    [anon_sym_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ_GT] = ACTIONS(2950),
    [anon_sym_EQ_TILDE] = ACTIONS(2950),
    [anon_sym_BANG_TILDE] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [sym_comment] = ACTIONS(87),
  },
  [472] = {
    [sym__string_end] = ACTIONS(2954),
    [sym_comment] = ACTIONS(87),
  },
  [473] = {
    [aux_sym_symbol_array_repeat1] = STATE(1684),
    [sym__string_end] = ACTIONS(2956),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2958),
  },
  [474] = {
    [sym__line_break] = ACTIONS(2960),
    [sym__heredoc_body_start] = ACTIONS(2960),
    [sym__binary_minus] = ACTIONS(2960),
    [sym__binary_star] = ACTIONS(2960),
    [ts_builtin_sym_end] = ACTIONS(2960),
    [anon_sym___END__] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_RPAREN] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_STAR_STAR] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_end] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_unless] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_until] = ACTIONS(2960),
    [anon_sym_rescue] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_when] = ACTIONS(2960),
    [anon_sym_elsif] = ACTIONS(2960),
    [anon_sym_else] = ACTIONS(2960),
    [anon_sym_then] = ACTIONS(2960),
    [anon_sym_ensure] = ACTIONS(2960),
    [anon_sym_EQ_GT] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_COLON_COLON2] = ACTIONS(2960),
    [anon_sym_AMP_DOT] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2960),
    [anon_sym_DOT_DOT] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_LT_LT] = ACTIONS(2960),
    [anon_sym_GT_GT] = ACTIONS(2960),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2960),
    [anon_sym_LT_EQ_GT] = ACTIONS(2960),
    [anon_sym_EQ_TILDE] = ACTIONS(2960),
    [anon_sym_BANG_TILDE] = ACTIONS(2960),
    [anon_sym_LT_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_SLASH] = ACTIONS(2960),
    [anon_sym_PERCENT] = ACTIONS(2960),
    [sym_comment] = ACTIONS(87),
  },
  [475] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(2964),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [476] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(2964),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2966),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(2968),
    [sym_comment] = ACTIONS(87),
  },
  [478] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1689),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(1689),
    [sym_operator_assignment] = STATE(1689),
    [sym_conditional] = STATE(1689),
    [sym_range] = STATE(1689),
    [sym_binary] = STATE(1689),
    [sym_unary] = STATE(1689),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [479] = {
    [sym__line_break] = ACTIONS(2970),
    [sym__heredoc_body_start] = ACTIONS(2970),
    [ts_builtin_sym_end] = ACTIONS(2970),
    [anon_sym___END__] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2970),
    [anon_sym_RPAREN] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym_end] = ACTIONS(2970),
    [anon_sym_rescue] = ACTIONS(2970),
    [anon_sym_when] = ACTIONS(2970),
    [anon_sym_elsif] = ACTIONS(2970),
    [anon_sym_else] = ACTIONS(2970),
    [anon_sym_ensure] = ACTIONS(2970),
    [sym_comment] = ACTIONS(87),
  },
  [480] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(1703),
    [sym__argument] = STATE(1704),
    [sym_splat_argument] = STATE(1704),
    [sym_hash_splat_argument] = STATE(1704),
    [sym_block_argument] = STATE(1704),
    [sym_assignment] = STATE(1702),
    [sym_operator_assignment] = STATE(1702),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_unary] = STATE(1702),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1707),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1704),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2972),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2996),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [481] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1703),
    [sym__argument] = STATE(1704),
    [sym_splat_argument] = STATE(1704),
    [sym_hash_splat_argument] = STATE(1704),
    [sym_block_argument] = STATE(1704),
    [sym_assignment] = STATE(1702),
    [sym_operator_assignment] = STATE(1702),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_unary] = STATE(1702),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1707),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1704),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2972),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2996),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [482] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(1703),
    [sym__argument] = STATE(1704),
    [sym_splat_argument] = STATE(1704),
    [sym_hash_splat_argument] = STATE(1704),
    [sym_block_argument] = STATE(1704),
    [sym_assignment] = STATE(1702),
    [sym_operator_assignment] = STATE(1702),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_unary] = STATE(1702),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1707),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1704),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2972),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2996),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [483] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(1703),
    [sym__argument] = STATE(1704),
    [sym_splat_argument] = STATE(1704),
    [sym_hash_splat_argument] = STATE(1704),
    [sym_block_argument] = STATE(1704),
    [sym_assignment] = STATE(1702),
    [sym_operator_assignment] = STATE(1702),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_unary] = STATE(1702),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1707),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(1704),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2972),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2996),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [484] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1708),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(1708),
    [sym_operator_assignment] = STATE(1708),
    [sym_conditional] = STATE(1708),
    [sym_range] = STATE(1708),
    [sym_binary] = STATE(1708),
    [sym_unary] = STATE(1708),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [485] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [486] = {
    [sym_operator] = STATE(1709),
    [sym__method_name] = STATE(1709),
    [sym_setter] = STATE(1709),
    [sym_symbol] = STATE(1709),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(2998),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(2998),
    [sym_class_variable] = ACTIONS(2998),
    [sym_global_variable] = ACTIONS(2998),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [487] = {
    [anon_sym_RBRACE] = ACTIONS(3000),
    [sym_comment] = ACTIONS(87),
  },
  [488] = {
    [sym_heredoc_body] = STATE(1711),
    [sym__terminator] = STATE(1711),
    [aux_sym__statements_repeat1] = STATE(1712),
    [sym__line_break] = ACTIONS(3002),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(3002),
    [sym_comment] = ACTIONS(87),
  },
  [489] = {
    [sym__line_break] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(691),
    [anon_sym_RBRACE] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(3004),
    [anon_sym_unless] = ACTIONS(3006),
    [anon_sym_while] = ACTIONS(3008),
    [anon_sym_until] = ACTIONS(3010),
    [anon_sym_rescue] = ACTIONS(3012),
    [sym_comment] = ACTIONS(87),
  },
  [490] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [491] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(1742),
    [sym__argument] = STATE(1743),
    [sym_splat_argument] = STATE(1743),
    [sym_hash_splat_argument] = STATE(1743),
    [sym_block_argument] = STATE(1743),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1746),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1743),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3042),
    [sym__splat_star] = ACTIONS(3044),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3066),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [492] = {
    [anon_sym_EQ] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [493] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3076),
    [anon_sym_DASH_EQ] = ACTIONS(3076),
    [anon_sym_STAR_EQ] = ACTIONS(3076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3076),
    [anon_sym_SLASH_EQ] = ACTIONS(3076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3076),
    [anon_sym_PIPE_EQ] = ACTIONS(3076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3076),
    [anon_sym_AMP_EQ] = ACTIONS(3076),
    [anon_sym_PERCENT_EQ] = ACTIONS(3076),
    [anon_sym_GT_GT_EQ] = ACTIONS(3076),
    [anon_sym_LT_LT_EQ] = ACTIONS(3076),
    [anon_sym_CARET_EQ] = ACTIONS(3076),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [494] = {
    [sym_string] = STATE(1749),
    [aux_sym_chained_string_repeat1] = STATE(1749),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [495] = {
    [sym__string_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_unless] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_until] = ACTIONS(837),
    [anon_sym_rescue] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_EQ_GT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [496] = {
    [sym__string_end] = ACTIONS(3078),
    [sym_comment] = ACTIONS(87),
  },
  [497] = {
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_COLON2] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [498] = {
    [sym__string_end] = ACTIONS(3080),
    [sym_comment] = ACTIONS(87),
  },
  [499] = {
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_EQ_GT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_COLON2] = ACTIONS(895),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [500] = {
    [sym__string_end] = ACTIONS(3082),
    [sym_comment] = ACTIONS(87),
  },
  [501] = {
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_COLON2] = ACTIONS(901),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [502] = {
    [sym__string_end] = ACTIONS(3084),
    [sym_comment] = ACTIONS(87),
  },
  [503] = {
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_COLON2] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [504] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1756),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3086),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3088),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [505] = {
    [aux_sym_string_array_repeat1] = STATE(1759),
    [sym__string_end] = ACTIONS(3090),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3092),
  },
  [506] = {
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_COLON2] = ACTIONS(925),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_SLASH] = ACTIONS(923),
    [anon_sym_PERCENT] = ACTIONS(923),
    [sym_comment] = ACTIONS(87),
  },
  [507] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1762),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3094),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3096),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [508] = {
    [aux_sym_symbol_array_repeat1] = STATE(1765),
    [sym__string_end] = ACTIONS(3098),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3100),
  },
  [509] = {
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_when] = ACTIONS(3102),
    [anon_sym_RBRACK] = ACTIONS(3102),
    [sym_comment] = ACTIONS(87),
  },
  [510] = {
    [sym__statement] = STATE(1766),
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_if_modifier] = STATE(1766),
    [sym_unless_modifier] = STATE(1766),
    [sym_while_modifier] = STATE(1766),
    [sym_until_modifier] = STATE(1766),
    [sym_rescue_modifier] = STATE(1766),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(452),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(452),
    [sym_operator_assignment] = STATE(452),
    [sym_conditional] = STATE(452),
    [sym_range] = STATE(452),
    [sym_binary] = STATE(452),
    [sym_unary] = STATE(452),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_undef] = STATE(1766),
    [sym_alias] = STATE(1766),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym_empty_statement] = STATE(1766),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_SEMI] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [anon_sym_undef] = ACTIONS(871),
    [anon_sym_alias] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [511] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(3106),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [512] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [513] = {
    [sym_string] = STATE(656),
    [aux_sym_chained_string_repeat1] = STATE(656),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [514] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1769),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(1769),
    [sym_operator_assignment] = STATE(1769),
    [sym_conditional] = STATE(1769),
    [sym_range] = STATE(1769),
    [sym_binary] = STATE(1769),
    [sym_unary] = STATE(1769),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [515] = {
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_COLON2] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [516] = {
    [anon_sym_RBRACE] = ACTIONS(3108),
    [sym_comment] = ACTIONS(87),
  },
  [517] = {
    [sym_heredoc_body] = STATE(1771),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(3108),
    [sym_comment] = ACTIONS(87),
  },
  [518] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(1772),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(1772),
    [sym_operator_assignment] = STATE(1772),
    [sym_conditional] = STATE(1772),
    [sym_range] = STATE(1772),
    [sym_binary] = STATE(1772),
    [sym_unary] = STATE(1772),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [519] = {
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [520] = {
    [anon_sym_DOT] = ACTIONS(3110),
    [anon_sym_COLON_COLON] = ACTIONS(3110),
    [sym_comment] = ACTIONS(87),
  },
  [521] = {
    [sym_method_parameters] = STATE(1774),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(1774),
    [sym__terminator] = STATE(1774),
    [sym__line_break] = ACTIONS(3112),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(3112),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [522] = {
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_COLON2] = ACTIONS(1293),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1291),
    [sym_comment] = ACTIONS(87),
  },
  [523] = {
    [anon_sym_RPAREN] = ACTIONS(3114),
    [sym_comment] = ACTIONS(87),
  },
  [524] = {
    [sym__simple_symbol] = ACTIONS(1413),
    [sym__string_start] = ACTIONS(1413),
    [sym__symbol_start] = ACTIONS(1413),
    [sym__subshell_start] = ACTIONS(1413),
    [sym__regex_start] = ACTIONS(1413),
    [sym__string_array_start] = ACTIONS(1413),
    [sym__symbol_array_start] = ACTIONS(1413),
    [sym_heredoc_beginning] = ACTIONS(1413),
    [sym__block_ampersand] = ACTIONS(1413),
    [sym__splat_star] = ACTIONS(1413),
    [sym__unary_minus] = ACTIONS(1413),
    [sym__binary_minus] = ACTIONS(1413),
    [sym__binary_star] = ACTIONS(1413),
    [sym__identifier_hash_key] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_def] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_DOT] = ACTIONS(1415),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_EQ] = ACTIONS(1415),
    [anon_sym_class] = ACTIONS(1415),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_return] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1415),
    [anon_sym_next] = ACTIONS(1415),
    [sym_redo] = ACTIONS(1415),
    [sym_retry] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_unless] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1415),
    [anon_sym_until] = ACTIONS(1415),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_do] = ACTIONS(1415),
    [anon_sym_case] = ACTIONS(1415),
    [anon_sym_begin] = ACTIONS(1415),
    [anon_sym_EQ_GT] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_COLON_COLON2] = ACTIONS(1413),
    [anon_sym_AMP_DOT] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1413),
    [anon_sym_PLUS_EQ] = ACTIONS(1413),
    [anon_sym_DASH_EQ] = ACTIONS(1413),
    [anon_sym_STAR_EQ] = ACTIONS(1413),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1413),
    [anon_sym_SLASH_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1413),
    [anon_sym_AMP_EQ] = ACTIONS(1413),
    [anon_sym_PERCENT_EQ] = ACTIONS(1413),
    [anon_sym_GT_GT_EQ] = ACTIONS(1413),
    [anon_sym_LT_LT_EQ] = ACTIONS(1413),
    [anon_sym_CARET_EQ] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(1415),
    [anon_sym_DOT_DOT] = ACTIONS(1415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1413),
    [anon_sym_and] = ACTIONS(1415),
    [anon_sym_or] = ACTIONS(1415),
    [anon_sym_PIPE_PIPE] = ACTIONS(1415),
    [anon_sym_AMP_AMP] = ACTIONS(1415),
    [anon_sym_LT_LT] = ACTIONS(1415),
    [anon_sym_GT_GT] = ACTIONS(1415),
    [anon_sym_EQ_EQ] = ACTIONS(1415),
    [anon_sym_BANG_EQ] = ACTIONS(1413),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1413),
    [anon_sym_LT_EQ_GT] = ACTIONS(1413),
    [anon_sym_EQ_TILDE] = ACTIONS(1413),
    [anon_sym_BANG_TILDE] = ACTIONS(1413),
    [anon_sym_LT_EQ] = ACTIONS(1415),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_CARET] = ACTIONS(1415),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(1415),
    [anon_sym_PERCENT] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1413),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1415),
    [sym_float] = ACTIONS(1415),
    [sym_complex] = ACTIONS(1413),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1415),
    [anon_sym_TRUE] = ACTIONS(1415),
    [anon_sym_false] = ACTIONS(1415),
    [anon_sym_FALSE] = ACTIONS(1415),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(1415),
    [anon_sym_NIL] = ACTIONS(1415),
    [sym_character] = ACTIONS(1413),
    [anon_sym_LBRACK2] = ACTIONS(1415),
    [anon_sym_DASH_GT] = ACTIONS(1413),
  },
  [525] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1776),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(1776),
    [sym_operator_assignment] = STATE(1776),
    [sym_conditional] = STATE(1776),
    [sym_range] = STATE(1776),
    [sym_binary] = STATE(1776),
    [sym_unary] = STATE(1776),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [526] = {
    [sym_constant] = ACTIONS(3116),
    [sym_identifier] = ACTIONS(3116),
    [sym_comment] = ACTIONS(87),
  },
  [527] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1790),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(1792),
    [sym__argument] = STATE(1793),
    [sym_splat_argument] = STATE(1793),
    [sym_hash_splat_argument] = STATE(1793),
    [sym_block_argument] = STATE(1793),
    [sym_assignment] = STATE(1790),
    [sym_operator_assignment] = STATE(1790),
    [sym_conditional] = STATE(1790),
    [sym_range] = STATE(1790),
    [sym_binary] = STATE(1790),
    [sym_unary] = STATE(1790),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1796),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1793),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3118),
    [sym__splat_star] = ACTIONS(3120),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3142),
    [sym_identifier] = ACTIONS(3142),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [528] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1790),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(1792),
    [sym__argument] = STATE(1793),
    [sym_splat_argument] = STATE(1793),
    [sym_hash_splat_argument] = STATE(1793),
    [sym_block_argument] = STATE(1793),
    [sym_assignment] = STATE(1790),
    [sym_operator_assignment] = STATE(1790),
    [sym_conditional] = STATE(1790),
    [sym_range] = STATE(1790),
    [sym_binary] = STATE(1790),
    [sym_unary] = STATE(1790),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1796),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1793),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3118),
    [sym__splat_star] = ACTIONS(3120),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3142),
    [sym_identifier] = ACTIONS(3142),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [529] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1790),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(1792),
    [sym__argument] = STATE(1793),
    [sym_splat_argument] = STATE(1793),
    [sym_hash_splat_argument] = STATE(1793),
    [sym_block_argument] = STATE(1793),
    [sym_assignment] = STATE(1790),
    [sym_operator_assignment] = STATE(1790),
    [sym_conditional] = STATE(1790),
    [sym_range] = STATE(1790),
    [sym_binary] = STATE(1790),
    [sym_unary] = STATE(1790),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1796),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1793),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3118),
    [sym__splat_star] = ACTIONS(3120),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3142),
    [sym_identifier] = ACTIONS(3142),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [530] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1790),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(1792),
    [sym__argument] = STATE(1793),
    [sym_splat_argument] = STATE(1793),
    [sym_hash_splat_argument] = STATE(1793),
    [sym_block_argument] = STATE(1793),
    [sym_assignment] = STATE(1790),
    [sym_operator_assignment] = STATE(1790),
    [sym_conditional] = STATE(1790),
    [sym_range] = STATE(1790),
    [sym_binary] = STATE(1790),
    [sym_unary] = STATE(1790),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1796),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1793),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3118),
    [sym__splat_star] = ACTIONS(3120),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3142),
    [sym_identifier] = ACTIONS(3142),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [531] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1797),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(1797),
    [sym_operator_assignment] = STATE(1797),
    [sym_conditional] = STATE(1797),
    [sym_range] = STATE(1797),
    [sym_binary] = STATE(1797),
    [sym_unary] = STATE(1797),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [532] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1335),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(1335),
    [sym_operator_assignment] = STATE(1335),
    [sym_conditional] = STATE(1335),
    [sym_range] = STATE(1335),
    [sym_binary] = STATE(1335),
    [sym_unary] = STATE(1335),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [533] = {
    [sym__heredoc_body_start] = ACTIONS(565),
    [sym__binary_minus] = ACTIONS(565),
    [sym__binary_star] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_in] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_COLON2] = ACTIONS(567),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [534] = {
    [sym__heredoc_body_start] = ACTIONS(569),
    [sym__binary_minus] = ACTIONS(569),
    [sym__binary_star] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_in] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_COLON2] = ACTIONS(571),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [535] = {
    [sym__heredoc_body_start] = ACTIONS(573),
    [sym__binary_minus] = ACTIONS(573),
    [sym__binary_star] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_in] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(575),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [536] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_DOT_DOT] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(3166),
    [anon_sym_or] = ACTIONS(3166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [537] = {
    [sym__heredoc_body_start] = ACTIONS(733),
    [sym__binary_minus] = ACTIONS(733),
    [sym__binary_star] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(3180),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(3182),
    [anon_sym_AMP_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_COLON2] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(733),
    [anon_sym_AMP_AMP] = ACTIONS(733),
    [anon_sym_LT_LT] = ACTIONS(733),
    [anon_sym_GT_GT] = ACTIONS(733),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ_GT] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_BANG_TILDE] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_SLASH] = ACTIONS(733),
    [anon_sym_PERCENT] = ACTIONS(733),
    [sym_comment] = ACTIONS(87),
  },
  [538] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(1827),
    [sym__argument_list_with_parens] = STATE(1828),
    [sym__argument] = STATE(1829),
    [sym_splat_argument] = STATE(1829),
    [sym_hash_splat_argument] = STATE(1829),
    [sym_block_argument] = STATE(1829),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1833),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1829),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3186),
    [sym__splat_star] = ACTIONS(3188),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [539] = {
    [anon_sym_EQ] = ACTIONS(3220),
    [sym_comment] = ACTIONS(87),
  },
  [540] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3222),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3224),
    [anon_sym_DASH_EQ] = ACTIONS(3224),
    [anon_sym_STAR_EQ] = ACTIONS(3224),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3224),
    [anon_sym_SLASH_EQ] = ACTIONS(3224),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3224),
    [anon_sym_PIPE_EQ] = ACTIONS(3224),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3224),
    [anon_sym_AMP_EQ] = ACTIONS(3224),
    [anon_sym_PERCENT_EQ] = ACTIONS(3224),
    [anon_sym_GT_GT_EQ] = ACTIONS(3224),
    [anon_sym_LT_LT_EQ] = ACTIONS(3224),
    [anon_sym_CARET_EQ] = ACTIONS(3224),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [541] = {
    [sym_string] = STATE(1836),
    [aux_sym_chained_string_repeat1] = STATE(1836),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [542] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1837),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1837),
    [sym_operator_assignment] = STATE(1837),
    [sym_conditional] = STATE(1837),
    [sym_range] = STATE(1837),
    [sym_binary] = STATE(1837),
    [sym_unary] = STATE(1837),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [543] = {
    [sym_superclass] = STATE(1838),
    [sym_heredoc_body] = STATE(1839),
    [sym__terminator] = STATE(1839),
    [sym__line_break] = ACTIONS(3226),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [544] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_superclass] = STATE(1838),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(1839),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(1839),
    [sym__line_break] = ACTIONS(3226),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [545] = {
    [sym_heredoc_body] = STATE(1841),
    [sym__terminator] = STATE(1841),
    [sym__line_break] = ACTIONS(3228),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [546] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(1841),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(1841),
    [sym__line_break] = ACTIONS(3228),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(3230),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [547] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1842),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(1842),
    [sym_operator_assignment] = STATE(1842),
    [sym_conditional] = STATE(1842),
    [sym_range] = STATE(1842),
    [sym_binary] = STATE(1842),
    [sym_unary] = STATE(1842),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [548] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1844),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(1844),
    [sym_operator_assignment] = STATE(1844),
    [sym_conditional] = STATE(1844),
    [sym_range] = STATE(1844),
    [sym_binary] = STATE(1844),
    [sym_unary] = STATE(1844),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [549] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1845),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(1845),
    [sym_operator_assignment] = STATE(1845),
    [sym_conditional] = STATE(1845),
    [sym_range] = STATE(1845),
    [sym_binary] = STATE(1845),
    [sym_unary] = STATE(1845),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [550] = {
    [anon_sym_COLON] = ACTIONS(3232),
    [sym_comment] = ACTIONS(87),
  },
  [551] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1847),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(1847),
    [sym_operator_assignment] = STATE(1847),
    [sym_conditional] = STATE(1847),
    [sym_range] = STATE(1847),
    [sym_binary] = STATE(1847),
    [sym_unary] = STATE(1847),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [552] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(1848),
    [sym__argument] = STATE(1849),
    [sym_splat_argument] = STATE(1849),
    [sym_hash_splat_argument] = STATE(1849),
    [sym_block_argument] = STATE(1849),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1849),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [553] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(1848),
    [sym__argument] = STATE(1849),
    [sym_splat_argument] = STATE(1849),
    [sym_hash_splat_argument] = STATE(1849),
    [sym_block_argument] = STATE(1849),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1849),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [554] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(1848),
    [sym__argument] = STATE(1849),
    [sym_splat_argument] = STATE(1849),
    [sym_hash_splat_argument] = STATE(1849),
    [sym_block_argument] = STATE(1849),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1849),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [555] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(1848),
    [sym__argument] = STATE(1849),
    [sym_splat_argument] = STATE(1849),
    [sym_hash_splat_argument] = STATE(1849),
    [sym_block_argument] = STATE(1849),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1849),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [556] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(1851),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(1852),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(3234),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [557] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1853),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(1853),
    [sym_operator_assignment] = STATE(1853),
    [sym_conditional] = STATE(1853),
    [sym_range] = STATE(1853),
    [sym_binary] = STATE(1853),
    [sym_unary] = STATE(1853),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [558] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [559] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [560] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [561] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [562] = {
    [sym__binary_minus] = ACTIONS(1679),
    [sym__binary_star] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(1679),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_unless] = ACTIONS(1679),
    [anon_sym_while] = ACTIONS(1679),
    [anon_sym_until] = ACTIONS(1679),
    [anon_sym_rescue] = ACTIONS(1679),
    [anon_sym_do] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1679),
    [anon_sym_AMP_DOT] = ACTIONS(1679),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_COLON2] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1679),
    [anon_sym_and] = ACTIONS(1679),
    [anon_sym_or] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE] = ACTIONS(1679),
    [anon_sym_AMP_AMP] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(1679),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_BANG_EQ] = ACTIONS(1679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1679),
    [anon_sym_LT_EQ_GT] = ACTIONS(1679),
    [anon_sym_EQ_TILDE] = ACTIONS(1679),
    [anon_sym_BANG_TILDE] = ACTIONS(1679),
    [anon_sym_LT_EQ] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1679),
    [anon_sym_CARET] = ACTIONS(1679),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_SLASH] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(1679),
    [sym_comment] = ACTIONS(87),
  },
  [563] = {
    [sym_heredoc_body] = STATE(1867),
    [aux_sym_call_repeat1] = STATE(1867),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [564] = {
    [sym_heredoc_body] = STATE(1867),
    [aux_sym_call_repeat1] = STATE(1867),
    [aux_sym_argument_list_repeat1] = STATE(1869),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [565] = {
    [anon_sym_EQ] = ACTIONS(3268),
    [sym_comment] = ACTIONS(87),
  },
  [566] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3270),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3272),
    [anon_sym_DASH_EQ] = ACTIONS(3272),
    [anon_sym_STAR_EQ] = ACTIONS(3272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3272),
    [anon_sym_SLASH_EQ] = ACTIONS(3272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3272),
    [anon_sym_PIPE_EQ] = ACTIONS(3272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3272),
    [anon_sym_AMP_EQ] = ACTIONS(3272),
    [anon_sym_PERCENT_EQ] = ACTIONS(3272),
    [anon_sym_GT_GT_EQ] = ACTIONS(3272),
    [anon_sym_LT_LT_EQ] = ACTIONS(3272),
    [anon_sym_CARET_EQ] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [567] = {
    [sym_string] = STATE(1872),
    [aux_sym_chained_string_repeat1] = STATE(1872),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [568] = {
    [sym__binary_minus] = ACTIONS(1699),
    [sym__binary_star] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_COLON2] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [569] = {
    [sym__binary_minus] = ACTIONS(1703),
    [sym__binary_star] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1705),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [570] = {
    [sym__binary_minus] = ACTIONS(1707),
    [sym__binary_star] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_DOT] = ACTIONS(1709),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_if] = ACTIONS(1707),
    [anon_sym_unless] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(1707),
    [anon_sym_until] = ACTIONS(1707),
    [anon_sym_rescue] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_COLON_COLON2] = ACTIONS(1707),
    [anon_sym_AMP_DOT] = ACTIONS(1707),
    [anon_sym_QMARK] = ACTIONS(1707),
    [anon_sym_COLON2] = ACTIONS(1709),
    [anon_sym_DOT_DOT] = ACTIONS(1709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1707),
    [anon_sym_and] = ACTIONS(1707),
    [anon_sym_or] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1709),
    [anon_sym_BANG_EQ] = ACTIONS(1707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1707),
    [anon_sym_LT_EQ_GT] = ACTIONS(1707),
    [anon_sym_EQ_TILDE] = ACTIONS(1707),
    [anon_sym_BANG_TILDE] = ACTIONS(1707),
    [anon_sym_LT_EQ] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_GT_EQ] = ACTIONS(1707),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [571] = {
    [sym__then] = STATE(1873),
    [sym_heredoc_body] = STATE(979),
    [sym__terminator] = STATE(979),
    [sym__line_break] = ACTIONS(1743),
    [sym__heredoc_body_start] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
  },
  [572] = {
    [sym__then] = STATE(1874),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(3278),
    [sym_comment] = ACTIONS(87),
  },
  [573] = {
    [sym__do] = STATE(1875),
    [sym_heredoc_body] = STATE(1875),
    [sym__terminator] = STATE(1875),
    [sym__line_break] = ACTIONS(3280),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(3280),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(3280),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [574] = {
    [sym__do] = STATE(1876),
    [sym_heredoc_body] = STATE(1876),
    [sym__terminator] = STATE(1876),
    [sym__line_break] = ACTIONS(3282),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(3282),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(3282),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [575] = {
    [sym_in] = STATE(1877),
    [anon_sym_in] = ACTIONS(1969),
    [sym_comment] = ACTIONS(87),
  },
  [576] = {
    [sym_heredoc_body] = STATE(1878),
    [sym__terminator] = STATE(1878),
    [sym__line_break] = ACTIONS(3284),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(3284),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [577] = {
    [sym_when] = STATE(1879),
    [aux_sym_case_repeat1] = STATE(1880),
    [anon_sym_SEMI] = ACTIONS(3286),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [578] = {
    [sym_else] = STATE(1882),
    [sym_ensure] = STATE(1883),
    [sym_rescue] = STATE(1884),
    [anon_sym_end] = ACTIONS(3288),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [579] = {
    [sym_ensure] = STATE(1883),
    [anon_sym_end] = ACTIONS(3288),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [580] = {
    [anon_sym_end] = ACTIONS(3288),
    [sym_comment] = ACTIONS(87),
  },
  [581] = {
    [sym_else] = STATE(1882),
    [sym_ensure] = STATE(1883),
    [anon_sym_end] = ACTIONS(3288),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [582] = {
    [sym__binary_minus] = ACTIONS(2187),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_unless] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_until] = ACTIONS(2187),
    [anon_sym_rescue] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_EQ_GT] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_COLON_COLON2] = ACTIONS(2187),
    [anon_sym_AMP_DOT] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_COLON2] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2189),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_EQ_TILDE] = ACTIONS(2187),
    [anon_sym_BANG_TILDE] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2189),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [583] = {
    [sym__statements] = STATE(578),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(579),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(580),
    [sym_rescue] = STATE(581),
    [sym__body_statement] = STATE(1885),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3290),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [584] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [585] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [586] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1886),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(1886),
    [sym_operator_assignment] = STATE(1886),
    [sym_conditional] = STATE(1886),
    [sym_range] = STATE(1886),
    [sym_binary] = STATE(1886),
    [sym_unary] = STATE(1886),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [587] = {
    [sym__binary_minus] = ACTIONS(2267),
    [sym__binary_star] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_RPAREN] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2269),
    [anon_sym_COMMA] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_STAR_STAR] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_unless] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_until] = ACTIONS(2267),
    [anon_sym_rescue] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_EQ_GT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_COLON_COLON2] = ACTIONS(2267),
    [anon_sym_AMP_DOT] = ACTIONS(2267),
    [anon_sym_QMARK] = ACTIONS(2267),
    [anon_sym_COLON2] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2267),
    [anon_sym_and] = ACTIONS(2267),
    [anon_sym_or] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2267),
    [anon_sym_AMP_AMP] = ACTIONS(2267),
    [anon_sym_LT_LT] = ACTIONS(2267),
    [anon_sym_GT_GT] = ACTIONS(2267),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2267),
    [anon_sym_LT_EQ_GT] = ACTIONS(2267),
    [anon_sym_EQ_TILDE] = ACTIONS(2267),
    [anon_sym_BANG_TILDE] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2267),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_PERCENT] = ACTIONS(2267),
    [sym_comment] = ACTIONS(87),
  },
  [588] = {
    [sym__binary_minus] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2353),
    [anon_sym_COMMA] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_if] = ACTIONS(2351),
    [anon_sym_unless] = ACTIONS(2351),
    [anon_sym_while] = ACTIONS(2351),
    [anon_sym_until] = ACTIONS(2351),
    [anon_sym_rescue] = ACTIONS(2351),
    [anon_sym_do] = ACTIONS(2351),
    [anon_sym_EQ_GT] = ACTIONS(2351),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_COLON_COLON2] = ACTIONS(2351),
    [anon_sym_AMP_DOT] = ACTIONS(2351),
    [anon_sym_QMARK] = ACTIONS(2351),
    [anon_sym_COLON2] = ACTIONS(2353),
    [anon_sym_DOT_DOT] = ACTIONS(2353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2351),
    [anon_sym_or] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_CARET] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_SLASH] = ACTIONS(2351),
    [anon_sym_PERCENT] = ACTIONS(2351),
    [sym_comment] = ACTIONS(87),
  },
  [589] = {
    [sym_heredoc_body] = STATE(1888),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(3292),
    [sym_comment] = ACTIONS(87),
  },
  [590] = {
    [anon_sym_RBRACK] = ACTIONS(3292),
    [sym_comment] = ACTIONS(87),
  },
  [591] = {
    [sym__statements] = STATE(1890),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(1891),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(3294),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [592] = {
    [sym__statements] = STATE(1893),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(1894),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1895),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(1895),
    [sym__line_break] = ACTIONS(3296),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3298),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [593] = {
    [sym_do_block] = STATE(1896),
    [sym_block] = STATE(1896),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_do] = ACTIONS(3300),
    [sym_comment] = ACTIONS(87),
  },
  [594] = {
    [sym__binary_minus] = ACTIONS(2491),
    [sym__binary_star] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2493),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_STAR_STAR] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_unless] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_until] = ACTIONS(2491),
    [anon_sym_rescue] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_EQ_GT] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_COLON_COLON2] = ACTIONS(2491),
    [anon_sym_AMP_DOT] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2491),
    [anon_sym_COLON2] = ACTIONS(2493),
    [anon_sym_DOT_DOT] = ACTIONS(2493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2491),
    [anon_sym_and] = ACTIONS(2491),
    [anon_sym_or] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2491),
    [anon_sym_AMP_AMP] = ACTIONS(2491),
    [anon_sym_LT_LT] = ACTIONS(2491),
    [anon_sym_GT_GT] = ACTIONS(2491),
    [anon_sym_EQ_EQ] = ACTIONS(2493),
    [anon_sym_BANG_EQ] = ACTIONS(2491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ_GT] = ACTIONS(2491),
    [anon_sym_EQ_TILDE] = ACTIONS(2491),
    [anon_sym_BANG_TILDE] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_SLASH] = ACTIONS(2491),
    [anon_sym_PERCENT] = ACTIONS(2491),
    [sym_comment] = ACTIONS(87),
  },
  [595] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1897),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1897),
    [sym_operator_assignment] = STATE(1897),
    [sym_conditional] = STATE(1897),
    [sym_range] = STATE(1897),
    [sym_binary] = STATE(1897),
    [sym_unary] = STATE(1897),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [596] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1898),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1898),
    [sym_operator_assignment] = STATE(1898),
    [sym_conditional] = STATE(1898),
    [sym_range] = STATE(1898),
    [sym_binary] = STATE(1898),
    [sym_unary] = STATE(1898),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [597] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1899),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1899),
    [sym_operator_assignment] = STATE(1899),
    [sym_conditional] = STATE(1899),
    [sym_range] = STATE(1899),
    [sym_binary] = STATE(1899),
    [sym_unary] = STATE(1899),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [598] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1900),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1900),
    [sym_operator_assignment] = STATE(1900),
    [sym_conditional] = STATE(1900),
    [sym_range] = STATE(1900),
    [sym_binary] = STATE(1900),
    [sym_unary] = STATE(1900),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [599] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1901),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1901),
    [sym_operator_assignment] = STATE(1901),
    [sym_conditional] = STATE(1901),
    [sym_range] = STATE(1901),
    [sym_binary] = STATE(1901),
    [sym_unary] = STATE(1901),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [600] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(1902),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(1902),
    [sym_operator_assignment] = STATE(1902),
    [sym_conditional] = STATE(1902),
    [sym_range] = STATE(1902),
    [sym_binary] = STATE(1902),
    [sym_unary] = STATE(1902),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [601] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1903),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1903),
    [sym_operator_assignment] = STATE(1903),
    [sym_conditional] = STATE(1903),
    [sym_range] = STATE(1903),
    [sym_binary] = STATE(1903),
    [sym_unary] = STATE(1903),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [602] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1904),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1904),
    [sym_operator_assignment] = STATE(1904),
    [sym_conditional] = STATE(1904),
    [sym_range] = STATE(1904),
    [sym_binary] = STATE(1904),
    [sym_unary] = STATE(1904),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [603] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1905),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1905),
    [sym_operator_assignment] = STATE(1905),
    [sym_conditional] = STATE(1905),
    [sym_range] = STATE(1905),
    [sym_binary] = STATE(1905),
    [sym_unary] = STATE(1905),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [604] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(1906),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(1906),
    [sym_operator_assignment] = STATE(1906),
    [sym_conditional] = STATE(1906),
    [sym_range] = STATE(1906),
    [sym_binary] = STATE(1906),
    [sym_unary] = STATE(1906),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [605] = {
    [sym_argument_list_with_parens] = STATE(1909),
    [sym__argument_list_with_parens] = STATE(1910),
    [sym_operator] = STATE(1909),
    [sym_heredoc_body] = STATE(1911),
    [aux_sym_call_repeat1] = STATE(1911),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_STAR_STAR] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_DOT_DOT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_GT_GT] = ACTIONS(3302),
    [anon_sym_EQ_EQ] = ACTIONS(3304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3302),
    [anon_sym_LT_EQ_GT] = ACTIONS(3302),
    [anon_sym_EQ_TILDE] = ACTIONS(3302),
    [anon_sym_BANG_TILDE] = ACTIONS(3302),
    [anon_sym_LT_EQ] = ACTIONS(3304),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_GT_EQ] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3302),
    [sym_constant] = ACTIONS(3308),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_AT] = ACTIONS(3302),
    [anon_sym_DASH_AT] = ACTIONS(3302),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3302),
    [anon_sym_BQUOTE] = ACTIONS(3302),
    [sym_comment] = ACTIONS(87),
  },
  [606] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(1913),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(1914),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [607] = {
    [sym_constant] = ACTIONS(3312),
    [sym_identifier] = ACTIONS(3312),
    [sym_comment] = ACTIONS(87),
  },
  [608] = {
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [609] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1917),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(3314),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [610] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1919),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(3316),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [611] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1921),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(3318),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [612] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(1923),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(3320),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [613] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1926),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3322),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3324),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [614] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1929),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3326),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3328),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [615] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1931),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1931),
    [sym_operator_assignment] = STATE(1931),
    [sym_conditional] = STATE(1931),
    [sym_range] = STATE(1931),
    [sym_binary] = STATE(1931),
    [sym_unary] = STATE(1931),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [616] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1933),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1933),
    [sym_operator_assignment] = STATE(1933),
    [sym_conditional] = STATE(1933),
    [sym_range] = STATE(1933),
    [sym_binary] = STATE(1933),
    [sym_unary] = STATE(1933),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [617] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1934),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1934),
    [sym_operator_assignment] = STATE(1934),
    [sym_conditional] = STATE(1934),
    [sym_range] = STATE(1934),
    [sym_binary] = STATE(1934),
    [sym_unary] = STATE(1934),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [618] = {
    [anon_sym_COLON] = ACTIONS(3338),
    [sym_comment] = ACTIONS(87),
  },
  [619] = {
    [sym__statements] = STATE(1937),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(1938),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1939),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1940),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(3340),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [620] = {
    [sym__method_rest] = STATE(1942),
    [sym__variable] = STATE(1943),
    [sym_operator] = STATE(1944),
    [sym__method_name] = STATE(1944),
    [sym_setter] = STATE(1944),
    [sym_symbol] = STATE(1944),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(3342),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(3344),
    [sym_self] = ACTIONS(3344),
  },
  [621] = {
    [sym__statements] = STATE(1946),
    [sym__top_level_statement] = STATE(144),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(149),
    [sym__simple_mlhs] = STATE(150),
    [sym_destructured_left_assignment] = STATE(150),
    [sym_rest_assignment] = STATE(150),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [622] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1947),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1947),
    [sym_operator_assignment] = STATE(1947),
    [sym_conditional] = STATE(1947),
    [sym_range] = STATE(1947),
    [sym_binary] = STATE(1947),
    [sym_unary] = STATE(1947),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [623] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1950),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(3348),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(3350),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [624] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(1952),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(3352),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [625] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1953),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [626] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1954),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [627] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1955),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [628] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1956),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [629] = {
    [sym__statement] = STATE(1957),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1957),
    [sym_unless_modifier] = STATE(1957),
    [sym_while_modifier] = STATE(1957),
    [sym_until_modifier] = STATE(1957),
    [sym_rescue_modifier] = STATE(1957),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1957),
    [sym_alias] = STATE(1957),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1957),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [630] = {
    [sym__statement] = STATE(1958),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1958),
    [sym_unless_modifier] = STATE(1958),
    [sym_while_modifier] = STATE(1958),
    [sym_until_modifier] = STATE(1958),
    [sym_rescue_modifier] = STATE(1958),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(1958),
    [sym_alias] = STATE(1958),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1958),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [631] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1959),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1959),
    [sym_operator_assignment] = STATE(1959),
    [sym_conditional] = STATE(1959),
    [sym_range] = STATE(1959),
    [sym_binary] = STATE(1959),
    [sym_unary] = STATE(1959),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [632] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1960),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(1960),
    [sym_operator_assignment] = STATE(1960),
    [sym_conditional] = STATE(1960),
    [sym_range] = STATE(1960),
    [sym_binary] = STATE(1960),
    [sym_unary] = STATE(1960),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [633] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(1961),
    [sym__simple_mlhs] = STATE(257),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [634] = {
    [sym__statements] = STATE(1963),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(1964),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1965),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(1965),
    [sym__line_break] = ACTIONS(3354),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3356),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [635] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1966),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(1966),
    [sym_operator_assignment] = STATE(1966),
    [sym_conditional] = STATE(1966),
    [sym_range] = STATE(1966),
    [sym_binary] = STATE(1966),
    [sym_unary] = STATE(1966),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1967),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__terminator] = STATE(1967),
    [sym__line_break] = ACTIONS(3358),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [636] = {
    [sym__statements] = STATE(1968),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1969),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1970),
    [sym_rescue] = STATE(1971),
    [sym__body_statement] = STATE(1972),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(1973),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__terminator] = STATE(1973),
    [sym__line_break] = ACTIONS(3360),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3362),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [637] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(1975),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(1976),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(3364),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [638] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1977),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1977),
    [sym_operator_assignment] = STATE(1977),
    [sym_conditional] = STATE(1977),
    [sym_range] = STATE(1977),
    [sym_binary] = STATE(1977),
    [sym_unary] = STATE(1977),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [639] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1978),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(1978),
    [sym_operator_assignment] = STATE(1978),
    [sym_conditional] = STATE(1978),
    [sym_range] = STATE(1978),
    [sym_binary] = STATE(1978),
    [sym_unary] = STATE(1978),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [640] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3366),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [641] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(3368),
  },
  [642] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(1982),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(1983),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(3370),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [643] = {
    [sym_lambda_parameters] = STATE(1985),
    [sym__simple_formal_parameter] = STATE(364),
    [sym_splat_parameter] = STATE(364),
    [sym_hash_splat_parameter] = STATE(364),
    [sym_block_parameter] = STATE(364),
    [sym_keyword_parameter] = STATE(364),
    [sym_optional_parameter] = STATE(364),
    [sym_do_block] = STATE(1986),
    [sym_block] = STATE(1986),
    [anon_sym_LBRACE] = ACTIONS(3372),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(2419),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [644] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [645] = {
    [sym__heredoc_body_start] = ACTIONS(733),
    [sym__binary_minus] = ACTIONS(733),
    [sym__binary_star] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(2397),
    [anon_sym_AMP_DOT] = ACTIONS(2399),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_COLON2] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ_GT] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_BANG_TILDE] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_comment] = ACTIONS(87),
  },
  [646] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(648),
    [sym__argument] = STATE(649),
    [sym_splat_argument] = STATE(649),
    [sym_hash_splat_argument] = STATE(649),
    [sym_block_argument] = STATE(649),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(649),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [647] = {
    [sym_do_block] = STATE(2000),
    [sym_block] = STATE(2000),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(3406),
    [anon_sym_EQ_GT] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [648] = {
    [sym_heredoc_body] = STATE(2002),
    [aux_sym_call_repeat1] = STATE(2002),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [649] = {
    [sym_heredoc_body] = STATE(2002),
    [aux_sym_call_repeat1] = STATE(2002),
    [aux_sym_argument_list_repeat1] = STATE(2004),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [650] = {
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [651] = {
    [anon_sym_EQ] = ACTIONS(3412),
    [sym_comment] = ACTIONS(87),
  },
  [652] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3414),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3416),
    [anon_sym_DASH_EQ] = ACTIONS(3416),
    [anon_sym_STAR_EQ] = ACTIONS(3416),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3416),
    [anon_sym_SLASH_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_PIPE_EQ] = ACTIONS(3416),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3416),
    [anon_sym_AMP_EQ] = ACTIONS(3416),
    [anon_sym_PERCENT_EQ] = ACTIONS(3416),
    [anon_sym_GT_GT_EQ] = ACTIONS(3416),
    [anon_sym_LT_LT_EQ] = ACTIONS(3416),
    [anon_sym_CARET_EQ] = ACTIONS(3416),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [653] = {
    [sym_string] = STATE(2007),
    [aux_sym_chained_string_repeat1] = STATE(2007),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3418),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [654] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(2016),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_splat_argument] = STATE(2018),
    [sym_assignment] = STATE(2016),
    [sym_operator_assignment] = STATE(2016),
    [sym_conditional] = STATE(2016),
    [sym_range] = STATE(2016),
    [sym_binary] = STATE(2016),
    [sym_unary] = STATE(2016),
    [sym_right_assignment_list] = STATE(2017),
    [sym__arg_or_splat_arg] = STATE(2018),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__splat_star] = ACTIONS(3420),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [655] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(2022),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(2022),
    [sym_operator_assignment] = STATE(2022),
    [sym_conditional] = STATE(2022),
    [sym_range] = STATE(2022),
    [sym_binary] = STATE(2022),
    [sym_unary] = STATE(2022),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [656] = {
    [sym_string] = STATE(2023),
    [aux_sym_chained_string_repeat1] = STATE(2023),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [657] = {
    [sym__line_break] = ACTIONS(3440),
    [sym__heredoc_body_start] = ACTIONS(3440),
    [sym__binary_minus] = ACTIONS(3440),
    [sym__binary_star] = ACTIONS(3440),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [anon_sym___END__] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3440),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_end] = ACTIONS(3440),
    [anon_sym_if] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3440),
    [anon_sym_while] = ACTIONS(3440),
    [anon_sym_until] = ACTIONS(3440),
    [anon_sym_rescue] = ACTIONS(3440),
    [anon_sym_do] = ACTIONS(3440),
    [anon_sym_when] = ACTIONS(3440),
    [anon_sym_elsif] = ACTIONS(3440),
    [anon_sym_else] = ACTIONS(3440),
    [anon_sym_then] = ACTIONS(3440),
    [anon_sym_ensure] = ACTIONS(3440),
    [anon_sym_EQ_GT] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3440),
    [anon_sym_COLON_COLON2] = ACTIONS(3440),
    [anon_sym_AMP_DOT] = ACTIONS(3440),
    [anon_sym_QMARK] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3440),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_GT_GT] = ACTIONS(3440),
    [anon_sym_EQ_EQ] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3440),
    [anon_sym_BANG_TILDE] = ACTIONS(3440),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3440),
    [anon_sym_CARET] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [sym_comment] = ACTIONS(87),
  },
  [658] = {
    [anon_sym_RBRACE] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [659] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(2026),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(2027),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(3446),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(3448),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [660] = {
    [sym__line_break] = ACTIONS(3450),
    [sym__heredoc_body_start] = ACTIONS(3450),
    [ts_builtin_sym_end] = ACTIONS(3450),
    [anon_sym___END__] = ACTIONS(3450),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_RPAREN] = ACTIONS(3450),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym_end] = ACTIONS(3450),
    [anon_sym_rescue] = ACTIONS(3450),
    [anon_sym_when] = ACTIONS(3450),
    [anon_sym_elsif] = ACTIONS(3450),
    [anon_sym_else] = ACTIONS(3450),
    [anon_sym_ensure] = ACTIONS(3450),
    [sym_comment] = ACTIONS(87),
  },
  [661] = {
    [anon_sym_RBRACE] = ACTIONS(3452),
    [sym_comment] = ACTIONS(87),
  },
  [662] = {
    [sym__line_break] = ACTIONS(887),
    [sym__heredoc_body_start] = ACTIONS(887),
    [ts_builtin_sym_end] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_LPAREN] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_end] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(889),
    [anon_sym_unless] = ACTIONS(889),
    [anon_sym_while] = ACTIONS(889),
    [anon_sym_until] = ACTIONS(889),
    [anon_sym_rescue] = ACTIONS(889),
    [anon_sym_when] = ACTIONS(889),
    [anon_sym_elsif] = ACTIONS(889),
    [anon_sym_else] = ACTIONS(889),
    [anon_sym_then] = ACTIONS(889),
    [anon_sym_ensure] = ACTIONS(889),
    [sym_identifier] = ACTIONS(889),
    [sym_comment] = ACTIONS(87),
  },
  [663] = {
    [sym__string_end] = ACTIONS(3454),
    [sym_comment] = ACTIONS(87),
  },
  [664] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(2030),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(2030),
    [sym_operator_assignment] = STATE(2030),
    [sym_conditional] = STATE(2030),
    [sym_range] = STATE(2030),
    [sym_binary] = STATE(2030),
    [sym_unary] = STATE(2030),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [665] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(562),
    [sym__argument_list_with_parens] = STATE(2040),
    [sym__argument] = STATE(2041),
    [sym_splat_argument] = STATE(2041),
    [sym_hash_splat_argument] = STATE(2041),
    [sym_block_argument] = STATE(2041),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2041),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [666] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(568),
    [sym__argument_list_with_parens] = STATE(2040),
    [sym__argument] = STATE(2041),
    [sym_splat_argument] = STATE(2041),
    [sym_hash_splat_argument] = STATE(2041),
    [sym_block_argument] = STATE(2041),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2041),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [667] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(2040),
    [sym__argument] = STATE(2041),
    [sym_splat_argument] = STATE(2041),
    [sym_hash_splat_argument] = STATE(2041),
    [sym_block_argument] = STATE(2041),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2041),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [668] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(2040),
    [sym__argument] = STATE(2041),
    [sym_splat_argument] = STATE(2041),
    [sym_hash_splat_argument] = STATE(2041),
    [sym_block_argument] = STATE(2041),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2041),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [669] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(2045),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(2045),
    [sym_operator_assignment] = STATE(2045),
    [sym_conditional] = STATE(2045),
    [sym_range] = STATE(2045),
    [sym_binary] = STATE(2045),
    [sym_unary] = STATE(2045),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [670] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [671] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(3478),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [672] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(1662),
    [sym__argument_list_with_parens] = STATE(2071),
    [sym__argument] = STATE(2072),
    [sym_splat_argument] = STATE(2072),
    [sym_hash_splat_argument] = STATE(2072),
    [sym_block_argument] = STATE(2072),
    [sym_do_block] = STATE(1665),
    [sym_block] = STATE(1665),
    [sym_assignment] = STATE(2069),
    [sym_operator_assignment] = STATE(2069),
    [sym_conditional] = STATE(2069),
    [sym_range] = STATE(2069),
    [sym_binary] = STATE(2069),
    [sym_unary] = STATE(2069),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2075),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2072),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3504),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3528),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [673] = {
    [anon_sym_EQ] = ACTIONS(3534),
    [sym_comment] = ACTIONS(87),
  },
  [674] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3536),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3538),
    [anon_sym_DASH_EQ] = ACTIONS(3538),
    [anon_sym_STAR_EQ] = ACTIONS(3538),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3538),
    [anon_sym_SLASH_EQ] = ACTIONS(3538),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3538),
    [anon_sym_PIPE_EQ] = ACTIONS(3538),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3538),
    [anon_sym_AMP_EQ] = ACTIONS(3538),
    [anon_sym_PERCENT_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_LT_LT_EQ] = ACTIONS(3538),
    [anon_sym_CARET_EQ] = ACTIONS(3538),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [675] = {
    [sym_string] = STATE(2078),
    [aux_sym_chained_string_repeat1] = STATE(2078),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [676] = {
    [sym__line_break] = ACTIONS(3540),
    [sym__heredoc_body_start] = ACTIONS(3540),
    [ts_builtin_sym_end] = ACTIONS(3540),
    [anon_sym___END__] = ACTIONS(3542),
    [anon_sym_RBRACE] = ACTIONS(3540),
    [anon_sym_LPAREN] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(3540),
    [anon_sym_COMMA] = ACTIONS(3540),
    [anon_sym_SEMI] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3542),
    [anon_sym_STAR_STAR] = ACTIONS(3540),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_end] = ACTIONS(3542),
    [anon_sym_if] = ACTIONS(3542),
    [anon_sym_unless] = ACTIONS(3542),
    [anon_sym_while] = ACTIONS(3542),
    [anon_sym_until] = ACTIONS(3542),
    [anon_sym_rescue] = ACTIONS(3542),
    [anon_sym_when] = ACTIONS(3542),
    [anon_sym_elsif] = ACTIONS(3542),
    [anon_sym_else] = ACTIONS(3542),
    [anon_sym_then] = ACTIONS(3542),
    [anon_sym_ensure] = ACTIONS(3542),
    [sym_identifier] = ACTIONS(3542),
    [sym_comment] = ACTIONS(87),
  },
  [677] = {
    [sym__method_rest] = STATE(2079),
    [sym_operator] = STATE(132),
    [sym__method_name] = STATE(132),
    [sym_setter] = STATE(132),
    [sym_symbol] = STATE(132),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(3544),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(3544),
    [sym_class_variable] = ACTIONS(3544),
    [sym_global_variable] = ACTIONS(3544),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [678] = {
    [sym__formal_parameter] = STATE(2081),
    [sym__simple_formal_parameter] = STATE(2081),
    [sym_destructured_parameter] = STATE(2081),
    [sym_splat_parameter] = STATE(2081),
    [sym_hash_splat_parameter] = STATE(2081),
    [sym_block_parameter] = STATE(2081),
    [sym_keyword_parameter] = STATE(2081),
    [sym_optional_parameter] = STATE(2081),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_RPAREN] = ACTIONS(3546),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2457),
    [sym_comment] = ACTIONS(87),
  },
  [679] = {
    [sym__line_break] = ACTIONS(2459),
    [sym__heredoc_body_start] = ACTIONS(2459),
    [anon_sym_COMMA] = ACTIONS(2459),
    [anon_sym_SEMI] = ACTIONS(2459),
    [sym_identifier] = ACTIONS(3548),
    [sym_comment] = ACTIONS(87),
  },
  [680] = {
    [sym__line_break] = ACTIONS(2465),
    [sym__heredoc_body_start] = ACTIONS(2465),
    [anon_sym_COMMA] = ACTIONS(2465),
    [anon_sym_SEMI] = ACTIONS(2465),
    [sym_identifier] = ACTIONS(3550),
    [sym_comment] = ACTIONS(87),
  },
  [681] = {
    [sym_lambda] = STATE(2084),
    [sym_identifier] = ACTIONS(3552),
    [sym_comment] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(3554),
  },
  [682] = {
    [sym__line_break] = ACTIONS(2479),
    [sym__heredoc_body_start] = ACTIONS(2479),
    [anon_sym_COMMA] = ACTIONS(2479),
    [anon_sym_SEMI] = ACTIONS(2479),
    [anon_sym_COLON] = ACTIONS(3556),
    [anon_sym_EQ] = ACTIONS(3558),
    [sym_comment] = ACTIONS(87),
  },
  [683] = {
    [sym__statements] = STATE(285),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(288),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(289),
    [sym_rescue] = STATE(290),
    [sym__body_statement] = STATE(2088),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3560),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [684] = {
    [sym_heredoc_body] = STATE(2090),
    [sym__terminator] = STATE(2090),
    [sym__line_break] = ACTIONS(3562),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(3564),
    [anon_sym_SEMI] = ACTIONS(3562),
    [sym_comment] = ACTIONS(87),
  },
  [685] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [686] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2103),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(2104),
    [sym__argument] = STATE(2105),
    [sym_splat_argument] = STATE(2105),
    [sym_hash_splat_argument] = STATE(2105),
    [sym_block_argument] = STATE(2105),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(2103),
    [sym_operator_assignment] = STATE(2103),
    [sym_conditional] = STATE(2103),
    [sym_range] = STATE(2103),
    [sym_binary] = STATE(2103),
    [sym_unary] = STATE(2103),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2108),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2105),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3566),
    [sym__splat_star] = ACTIONS(3568),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__identifier_hash_key] = ACTIONS(3572),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(3574),
    [anon_sym_EQ] = ACTIONS(745),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3592),
    [sym_identifier] = ACTIONS(3592),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [687] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2116),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(2116),
    [sym_operator_assignment] = STATE(2116),
    [sym_conditional] = STATE(2116),
    [sym_range] = STATE(2116),
    [sym_binary] = STATE(2116),
    [sym_unary] = STATE(2116),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [688] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2120),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(2120),
    [sym_operator_assignment] = STATE(2120),
    [sym_conditional] = STATE(2120),
    [sym_range] = STATE(2120),
    [sym_binary] = STATE(2120),
    [sym_unary] = STATE(2120),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [689] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2121),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(2121),
    [sym_operator_assignment] = STATE(2121),
    [sym_conditional] = STATE(2121),
    [sym_range] = STATE(2121),
    [sym_binary] = STATE(2121),
    [sym_unary] = STATE(2121),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [690] = {
    [anon_sym_COLON] = ACTIONS(3614),
    [sym_comment] = ACTIONS(87),
  },
  [691] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2124),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(2124),
    [sym_operator_assignment] = STATE(2124),
    [sym_conditional] = STATE(2124),
    [sym_range] = STATE(2124),
    [sym_binary] = STATE(2124),
    [sym_unary] = STATE(2124),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [692] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2130),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2131),
    [sym__argument] = STATE(2132),
    [sym_splat_argument] = STATE(2132),
    [sym_hash_splat_argument] = STATE(2132),
    [sym_block_argument] = STATE(2132),
    [sym_assignment] = STATE(2130),
    [sym_operator_assignment] = STATE(2130),
    [sym_conditional] = STATE(2130),
    [sym_range] = STATE(2130),
    [sym_binary] = STATE(2130),
    [sym_unary] = STATE(2130),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2133),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2132),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(3616),
    [sym__splat_star] = ACTIONS(3618),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(3620),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3622),
    [sym_identifier] = ACTIONS(3622),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [693] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2130),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2131),
    [sym__argument] = STATE(2132),
    [sym_splat_argument] = STATE(2132),
    [sym_hash_splat_argument] = STATE(2132),
    [sym_block_argument] = STATE(2132),
    [sym_assignment] = STATE(2130),
    [sym_operator_assignment] = STATE(2130),
    [sym_conditional] = STATE(2130),
    [sym_range] = STATE(2130),
    [sym_binary] = STATE(2130),
    [sym_unary] = STATE(2130),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2133),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2132),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(3616),
    [sym__splat_star] = ACTIONS(3618),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(3620),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3622),
    [sym_identifier] = ACTIONS(3622),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [694] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2130),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2131),
    [sym__argument] = STATE(2132),
    [sym_splat_argument] = STATE(2132),
    [sym_hash_splat_argument] = STATE(2132),
    [sym_block_argument] = STATE(2132),
    [sym_assignment] = STATE(2130),
    [sym_operator_assignment] = STATE(2130),
    [sym_conditional] = STATE(2130),
    [sym_range] = STATE(2130),
    [sym_binary] = STATE(2130),
    [sym_unary] = STATE(2130),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2133),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2132),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(3616),
    [sym__splat_star] = ACTIONS(3618),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(3620),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3622),
    [sym_identifier] = ACTIONS(3622),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [695] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2130),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2131),
    [sym__argument] = STATE(2132),
    [sym_splat_argument] = STATE(2132),
    [sym_hash_splat_argument] = STATE(2132),
    [sym_block_argument] = STATE(2132),
    [sym_assignment] = STATE(2130),
    [sym_operator_assignment] = STATE(2130),
    [sym_conditional] = STATE(2130),
    [sym_range] = STATE(2130),
    [sym_binary] = STATE(2130),
    [sym_unary] = STATE(2130),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2133),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2132),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(3616),
    [sym__splat_star] = ACTIONS(3618),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(3620),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3622),
    [sym_identifier] = ACTIONS(3622),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [696] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2134),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(2134),
    [sym_operator_assignment] = STATE(2134),
    [sym_conditional] = STATE(2134),
    [sym_range] = STATE(2134),
    [sym_binary] = STATE(2134),
    [sym_unary] = STATE(2134),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [697] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [698] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [699] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(3614),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [700] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2151),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(2152),
    [sym__argument] = STATE(2153),
    [sym_splat_argument] = STATE(2153),
    [sym_hash_splat_argument] = STATE(2153),
    [sym_block_argument] = STATE(2153),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2151),
    [sym_operator_assignment] = STATE(2151),
    [sym_conditional] = STATE(2151),
    [sym_range] = STATE(2151),
    [sym_binary] = STATE(2151),
    [sym_unary] = STATE(2151),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2154),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2153),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3652),
    [sym__splat_star] = ACTIONS(3654),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(3656),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(3658),
    [sym_identifier] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [701] = {
    [sym_heredoc_body] = STATE(2155),
    [aux_sym_call_repeat1] = STATE(2155),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [702] = {
    [sym_heredoc_body] = STATE(2155),
    [aux_sym_call_repeat1] = STATE(2155),
    [aux_sym_argument_list_repeat1] = STATE(2157),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [703] = {
    [anon_sym_EQ] = ACTIONS(3662),
    [sym_comment] = ACTIONS(87),
  },
  [704] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3664),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3666),
    [anon_sym_DASH_EQ] = ACTIONS(3666),
    [anon_sym_STAR_EQ] = ACTIONS(3666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3666),
    [anon_sym_SLASH_EQ] = ACTIONS(3666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3666),
    [anon_sym_PIPE_EQ] = ACTIONS(3666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3666),
    [anon_sym_AMP_EQ] = ACTIONS(3666),
    [anon_sym_PERCENT_EQ] = ACTIONS(3666),
    [anon_sym_GT_GT_EQ] = ACTIONS(3666),
    [anon_sym_LT_LT_EQ] = ACTIONS(3666),
    [anon_sym_CARET_EQ] = ACTIONS(3666),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [705] = {
    [sym_string] = STATE(2160),
    [aux_sym_chained_string_repeat1] = STATE(2160),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3668),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [706] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [707] = {
    [aux_sym_undef_repeat1] = STATE(2161),
    [sym__line_break] = ACTIONS(2257),
    [sym__heredoc_body_start] = ACTIONS(2257),
    [anon_sym_RPAREN] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [708] = {
    [sym__line_break] = ACTIONS(3670),
    [sym__heredoc_body_start] = ACTIONS(3670),
    [sym__binary_minus] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [ts_builtin_sym_end] = ACTIONS(3670),
    [anon_sym___END__] = ACTIONS(3670),
    [anon_sym_LBRACE] = ACTIONS(3670),
    [anon_sym_RBRACE] = ACTIONS(3670),
    [anon_sym_RPAREN] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_SEMI] = ACTIONS(3670),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3672),
    [anon_sym_end] = ACTIONS(3670),
    [anon_sym_if] = ACTIONS(3670),
    [anon_sym_unless] = ACTIONS(3670),
    [anon_sym_while] = ACTIONS(3670),
    [anon_sym_until] = ACTIONS(3670),
    [anon_sym_rescue] = ACTIONS(3670),
    [anon_sym_do] = ACTIONS(3670),
    [anon_sym_when] = ACTIONS(3670),
    [anon_sym_elsif] = ACTIONS(3670),
    [anon_sym_else] = ACTIONS(3670),
    [anon_sym_then] = ACTIONS(3670),
    [anon_sym_ensure] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3670),
    [anon_sym_COLON_COLON2] = ACTIONS(3670),
    [anon_sym_AMP_DOT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3670),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LT_EQ_GT] = ACTIONS(3670),
    [anon_sym_EQ_TILDE] = ACTIONS(3670),
    [anon_sym_BANG_TILDE] = ACTIONS(3670),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym_comment] = ACTIONS(87),
  },
  [709] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(2497),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [710] = {
    [sym_heredoc_body] = STATE(2162),
    [sym__terminator] = STATE(2162),
    [aux_sym__statements_repeat1] = STATE(2163),
    [sym__line_break] = ACTIONS(3674),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(3674),
    [sym_comment] = ACTIONS(87),
  },
  [711] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2164),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2164),
    [sym_operator_assignment] = STATE(2164),
    [sym_conditional] = STATE(2164),
    [sym_range] = STATE(2164),
    [sym_binary] = STATE(2164),
    [sym_unary] = STATE(2164),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [712] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2165),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2165),
    [sym_operator_assignment] = STATE(2165),
    [sym_conditional] = STATE(2165),
    [sym_range] = STATE(2165),
    [sym_binary] = STATE(2165),
    [sym_unary] = STATE(2165),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [713] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2166),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2166),
    [sym_operator_assignment] = STATE(2166),
    [sym_conditional] = STATE(2166),
    [sym_range] = STATE(2166),
    [sym_binary] = STATE(2166),
    [sym_unary] = STATE(2166),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [714] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2167),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2167),
    [sym_operator_assignment] = STATE(2167),
    [sym_conditional] = STATE(2167),
    [sym_range] = STATE(2167),
    [sym_binary] = STATE(2167),
    [sym_unary] = STATE(2167),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [715] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2168),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2168),
    [sym_operator_assignment] = STATE(2168),
    [sym_conditional] = STATE(2168),
    [sym_range] = STATE(2168),
    [sym_binary] = STATE(2168),
    [sym_unary] = STATE(2168),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [716] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2169),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2169),
    [sym_operator_assignment] = STATE(2169),
    [sym_conditional] = STATE(2169),
    [sym_range] = STATE(2169),
    [sym_binary] = STATE(2169),
    [sym_unary] = STATE(2169),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [717] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2170),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2170),
    [sym_operator_assignment] = STATE(2170),
    [sym_conditional] = STATE(2170),
    [sym_range] = STATE(2170),
    [sym_binary] = STATE(2170),
    [sym_unary] = STATE(2170),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [718] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2171),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2171),
    [sym_operator_assignment] = STATE(2171),
    [sym_conditional] = STATE(2171),
    [sym_range] = STATE(2171),
    [sym_binary] = STATE(2171),
    [sym_unary] = STATE(2171),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [719] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2172),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2172),
    [sym_operator_assignment] = STATE(2172),
    [sym_conditional] = STATE(2172),
    [sym_range] = STATE(2172),
    [sym_binary] = STATE(2172),
    [sym_unary] = STATE(2172),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [720] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2173),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [721] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(2174),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(2174),
    [sym_operator_assignment] = STATE(2174),
    [sym_conditional] = STATE(2174),
    [sym_range] = STATE(2174),
    [sym_binary] = STATE(2174),
    [sym_unary] = STATE(2174),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [722] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2175),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2175),
    [sym_operator_assignment] = STATE(2175),
    [sym_conditional] = STATE(2175),
    [sym_range] = STATE(2175),
    [sym_binary] = STATE(2175),
    [sym_unary] = STATE(2175),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [723] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2176),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2176),
    [sym_operator_assignment] = STATE(2176),
    [sym_conditional] = STATE(2176),
    [sym_range] = STATE(2176),
    [sym_binary] = STATE(2176),
    [sym_unary] = STATE(2176),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [724] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2177),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2177),
    [sym_operator_assignment] = STATE(2177),
    [sym_conditional] = STATE(2177),
    [sym_range] = STATE(2177),
    [sym_binary] = STATE(2177),
    [sym_unary] = STATE(2177),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [725] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2178),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2178),
    [sym_operator_assignment] = STATE(2178),
    [sym_conditional] = STATE(2178),
    [sym_range] = STATE(2178),
    [sym_binary] = STATE(2178),
    [sym_unary] = STATE(2178),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [726] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(2186),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(2186),
    [sym_operator_assignment] = STATE(2186),
    [sym_conditional] = STATE(2186),
    [sym_range] = STATE(2186),
    [sym_binary] = STATE(2186),
    [sym_unary] = STATE(2186),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [727] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(2191),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(2191),
    [sym_operator_assignment] = STATE(2191),
    [sym_conditional] = STATE(2191),
    [sym_range] = STATE(2191),
    [sym_binary] = STATE(2191),
    [sym_unary] = STATE(2191),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [728] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2192),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(2192),
    [sym_operator_assignment] = STATE(2192),
    [sym_conditional] = STATE(2192),
    [sym_range] = STATE(2192),
    [sym_binary] = STATE(2192),
    [sym_unary] = STATE(2192),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [729] = {
    [anon_sym_COLON] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [730] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(2195),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(2195),
    [sym_operator_assignment] = STATE(2195),
    [sym_conditional] = STATE(2195),
    [sym_range] = STATE(2195),
    [sym_binary] = STATE(2195),
    [sym_unary] = STATE(2195),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [731] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2151),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(2152),
    [sym__argument] = STATE(2153),
    [sym_splat_argument] = STATE(2153),
    [sym_hash_splat_argument] = STATE(2153),
    [sym_block_argument] = STATE(2153),
    [sym_assignment] = STATE(2151),
    [sym_operator_assignment] = STATE(2151),
    [sym_conditional] = STATE(2151),
    [sym_range] = STATE(2151),
    [sym_binary] = STATE(2151),
    [sym_unary] = STATE(2151),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2154),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2153),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3652),
    [sym__splat_star] = ACTIONS(3654),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(3656),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(3658),
    [sym_identifier] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [732] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2151),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(2152),
    [sym__argument] = STATE(2153),
    [sym_splat_argument] = STATE(2153),
    [sym_hash_splat_argument] = STATE(2153),
    [sym_block_argument] = STATE(2153),
    [sym_assignment] = STATE(2151),
    [sym_operator_assignment] = STATE(2151),
    [sym_conditional] = STATE(2151),
    [sym_range] = STATE(2151),
    [sym_binary] = STATE(2151),
    [sym_unary] = STATE(2151),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2154),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2153),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3652),
    [sym__splat_star] = ACTIONS(3654),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(3656),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(3658),
    [sym_identifier] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [733] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2151),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(2152),
    [sym__argument] = STATE(2153),
    [sym_splat_argument] = STATE(2153),
    [sym_hash_splat_argument] = STATE(2153),
    [sym_block_argument] = STATE(2153),
    [sym_assignment] = STATE(2151),
    [sym_operator_assignment] = STATE(2151),
    [sym_conditional] = STATE(2151),
    [sym_range] = STATE(2151),
    [sym_binary] = STATE(2151),
    [sym_unary] = STATE(2151),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2154),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2153),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3652),
    [sym__splat_star] = ACTIONS(3654),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(3656),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(3658),
    [sym_identifier] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [734] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2151),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(2152),
    [sym__argument] = STATE(2153),
    [sym_splat_argument] = STATE(2153),
    [sym_hash_splat_argument] = STATE(2153),
    [sym_block_argument] = STATE(2153),
    [sym_assignment] = STATE(2151),
    [sym_operator_assignment] = STATE(2151),
    [sym_conditional] = STATE(2151),
    [sym_range] = STATE(2151),
    [sym_binary] = STATE(2151),
    [sym_unary] = STATE(2151),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2154),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2153),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3652),
    [sym__splat_star] = ACTIONS(3654),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(3656),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(3658),
    [sym_identifier] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [735] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2196),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(2196),
    [sym_operator_assignment] = STATE(2196),
    [sym_conditional] = STATE(2196),
    [sym_range] = STATE(2196),
    [sym_binary] = STATE(2196),
    [sym_unary] = STATE(2196),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [736] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [737] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3702),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [738] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [739] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2151),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(2152),
    [sym__argument] = STATE(2153),
    [sym_splat_argument] = STATE(2153),
    [sym_hash_splat_argument] = STATE(2153),
    [sym_block_argument] = STATE(2153),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2151),
    [sym_operator_assignment] = STATE(2151),
    [sym_conditional] = STATE(2151),
    [sym_range] = STATE(2151),
    [sym_binary] = STATE(2151),
    [sym_unary] = STATE(2151),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2154),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2153),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3652),
    [sym__splat_star] = ACTIONS(3654),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(3656),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(3658),
    [sym_identifier] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [740] = {
    [sym_heredoc_body] = STATE(2208),
    [aux_sym_call_repeat1] = STATE(2208),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [741] = {
    [sym_heredoc_body] = STATE(2208),
    [aux_sym_call_repeat1] = STATE(2208),
    [aux_sym_argument_list_repeat1] = STATE(2210),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [742] = {
    [anon_sym_EQ] = ACTIONS(3734),
    [sym_comment] = ACTIONS(87),
  },
  [743] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3738),
    [anon_sym_DASH_EQ] = ACTIONS(3738),
    [anon_sym_STAR_EQ] = ACTIONS(3738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3738),
    [anon_sym_SLASH_EQ] = ACTIONS(3738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3738),
    [anon_sym_PIPE_EQ] = ACTIONS(3738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3738),
    [anon_sym_AMP_EQ] = ACTIONS(3738),
    [anon_sym_PERCENT_EQ] = ACTIONS(3738),
    [anon_sym_GT_GT_EQ] = ACTIONS(3738),
    [anon_sym_LT_LT_EQ] = ACTIONS(3738),
    [anon_sym_CARET_EQ] = ACTIONS(3738),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [744] = {
    [sym_string] = STATE(2213),
    [aux_sym_chained_string_repeat1] = STATE(2213),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3740),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [745] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2218),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_splat_argument] = STATE(2219),
    [sym_assignment] = STATE(2218),
    [sym_operator_assignment] = STATE(2218),
    [sym_conditional] = STATE(2218),
    [sym_range] = STATE(2218),
    [sym_binary] = STATE(2218),
    [sym_unary] = STATE(2218),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(2219),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(3742),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [746] = {
    [anon_sym_RPAREN] = ACTIONS(3754),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_EQ] = ACTIONS(3754),
    [anon_sym_in] = ACTIONS(3754),
    [sym_comment] = ACTIONS(87),
  },
  [747] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(686),
    [sym_call] = STATE(686),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(1597),
    [sym__simple_mlhs] = STATE(150),
    [sym_destructured_left_assignment] = STATE(150),
    [sym_rest_assignment] = STATE(150),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(686),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(2757),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_EQ] = ACTIONS(2757),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [sym_instance_variable] = ACTIONS(1297),
    [sym_class_variable] = ACTIONS(1297),
    [sym_global_variable] = ACTIONS(1297),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(1295),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [748] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2222),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(2222),
    [sym_operator_assignment] = STATE(2222),
    [sym_conditional] = STATE(2222),
    [sym_range] = STATE(2222),
    [sym_binary] = STATE(2222),
    [sym_unary] = STATE(2222),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [749] = {
    [sym_string] = STATE(2223),
    [aux_sym_chained_string_repeat1] = STATE(2223),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [750] = {
    [sym__string_start] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [751] = {
    [sym__string_end] = ACTIONS(3756),
    [sym_comment] = ACTIONS(87),
  },
  [752] = {
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(887),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [753] = {
    [sym__string_end] = ACTIONS(3758),
    [sym_comment] = ACTIONS(87),
  },
  [754] = {
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [755] = {
    [sym__string_end] = ACTIONS(3760),
    [sym_comment] = ACTIONS(87),
  },
  [756] = {
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [757] = {
    [sym__string_end] = ACTIONS(3762),
    [sym_comment] = ACTIONS(87),
  },
  [758] = {
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [759] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(2230),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3764),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3766),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [760] = {
    [aux_sym_string_array_repeat1] = STATE(2233),
    [sym__string_end] = ACTIONS(3768),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3770),
  },
  [761] = {
    [anon_sym_DOT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [sym_comment] = ACTIONS(87),
  },
  [762] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(2236),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(3772),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3774),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [763] = {
    [aux_sym_symbol_array_repeat1] = STATE(2239),
    [sym__string_end] = ACTIONS(3776),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3778),
  },
  [764] = {
    [anon_sym_DOT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [765] = {
    [anon_sym_RBRACE] = ACTIONS(3780),
    [sym_comment] = ACTIONS(87),
  },
  [766] = {
    [sym_heredoc_body] = STATE(2241),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(3780),
    [sym_comment] = ACTIONS(87),
  },
  [767] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(2242),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(2242),
    [sym_operator_assignment] = STATE(2242),
    [sym_conditional] = STATE(2242),
    [sym_range] = STATE(2242),
    [sym_binary] = STATE(2242),
    [sym_unary] = STATE(2242),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [768] = {
    [anon_sym_DOT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [769] = {
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_COLON_COLON] = ACTIONS(3782),
    [sym_comment] = ACTIONS(87),
  },
  [770] = {
    [sym_method_parameters] = STATE(2244),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(2244),
    [sym__terminator] = STATE(2244),
    [sym__line_break] = ACTIONS(3784),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [771] = {
    [anon_sym_DOT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [sym_comment] = ACTIONS(87),
  },
  [772] = {
    [anon_sym_RPAREN] = ACTIONS(3786),
    [sym_comment] = ACTIONS(87),
  },
  [773] = {
    [sym__simple_symbol] = ACTIONS(1413),
    [sym__string_start] = ACTIONS(1413),
    [sym__symbol_start] = ACTIONS(1413),
    [sym__subshell_start] = ACTIONS(1413),
    [sym__regex_start] = ACTIONS(1413),
    [sym__string_array_start] = ACTIONS(1413),
    [sym__symbol_array_start] = ACTIONS(1413),
    [sym_heredoc_beginning] = ACTIONS(1413),
    [sym__block_ampersand] = ACTIONS(1413),
    [sym__splat_star] = ACTIONS(1413),
    [sym__unary_minus] = ACTIONS(1413),
    [sym__identifier_hash_key] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_def] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1413),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_class] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_return] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1415),
    [anon_sym_next] = ACTIONS(1415),
    [sym_redo] = ACTIONS(1415),
    [sym_retry] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_unless] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1415),
    [anon_sym_until] = ACTIONS(1415),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_in] = ACTIONS(1415),
    [anon_sym_do] = ACTIONS(1415),
    [anon_sym_case] = ACTIONS(1415),
    [anon_sym_begin] = ACTIONS(1415),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_COLON_COLON2] = ACTIONS(1413),
    [anon_sym_AMP_DOT] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1413),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1415),
    [sym_float] = ACTIONS(1415),
    [sym_complex] = ACTIONS(1413),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1415),
    [anon_sym_TRUE] = ACTIONS(1415),
    [anon_sym_false] = ACTIONS(1415),
    [anon_sym_FALSE] = ACTIONS(1415),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(1415),
    [anon_sym_NIL] = ACTIONS(1415),
    [sym_character] = ACTIONS(1413),
    [anon_sym_LBRACK2] = ACTIONS(1415),
    [anon_sym_DASH_GT] = ACTIONS(1413),
  },
  [774] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2246),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2246),
    [sym_operator_assignment] = STATE(2246),
    [sym_conditional] = STATE(2246),
    [sym_range] = STATE(2246),
    [sym_binary] = STATE(2246),
    [sym_unary] = STATE(2246),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [775] = {
    [sym_superclass] = STATE(2247),
    [sym_heredoc_body] = STATE(2248),
    [sym__terminator] = STATE(2248),
    [sym__line_break] = ACTIONS(3788),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(3788),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [776] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_superclass] = STATE(2247),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(2248),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(2248),
    [sym__line_break] = ACTIONS(3788),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3788),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [777] = {
    [sym_heredoc_body] = STATE(2250),
    [sym__terminator] = STATE(2250),
    [sym__line_break] = ACTIONS(3790),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(3792),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [778] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(2250),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(2250),
    [sym__line_break] = ACTIONS(3790),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(3792),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [779] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2258),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(2258),
    [sym_operator_assignment] = STATE(2258),
    [sym_conditional] = STATE(2258),
    [sym_range] = STATE(2258),
    [sym_binary] = STATE(2258),
    [sym_unary] = STATE(2258),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [780] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2263),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(2263),
    [sym_operator_assignment] = STATE(2263),
    [sym_conditional] = STATE(2263),
    [sym_range] = STATE(2263),
    [sym_binary] = STATE(2263),
    [sym_unary] = STATE(2263),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [781] = {
    [anon_sym_COLON] = ACTIONS(3816),
    [sym_comment] = ACTIONS(87),
  },
  [782] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2265),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(2265),
    [sym_operator_assignment] = STATE(2265),
    [sym_conditional] = STATE(2265),
    [sym_range] = STATE(2265),
    [sym_binary] = STATE(2265),
    [sym_unary] = STATE(2265),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [783] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(2267),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(2268),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [784] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3820),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [785] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(3822),
    [anon_sym_or] = ACTIONS(3822),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [786] = {
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1679),
    [anon_sym_AMP_DOT] = ACTIONS(1679),
    [sym_comment] = ACTIONS(87),
  },
  [787] = {
    [sym_heredoc_body] = STATE(2271),
    [aux_sym_call_repeat1] = STATE(2271),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [788] = {
    [sym_heredoc_body] = STATE(2271),
    [aux_sym_call_repeat1] = STATE(2271),
    [aux_sym_argument_list_repeat1] = STATE(2273),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [789] = {
    [sym_string] = STATE(1872),
    [aux_sym_chained_string_repeat1] = STATE(1872),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [790] = {
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [791] = {
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [792] = {
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_COLON_COLON2] = ACTIONS(1707),
    [anon_sym_AMP_DOT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [793] = {
    [sym__then] = STATE(2274),
    [sym_heredoc_body] = STATE(979),
    [sym__terminator] = STATE(979),
    [sym__line_break] = ACTIONS(1743),
    [sym__heredoc_body_start] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(3830),
    [sym_comment] = ACTIONS(87),
  },
  [794] = {
    [sym__then] = STATE(2275),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(3832),
    [sym_comment] = ACTIONS(87),
  },
  [795] = {
    [sym__do] = STATE(2276),
    [sym_heredoc_body] = STATE(2276),
    [sym__terminator] = STATE(2276),
    [sym__line_break] = ACTIONS(3834),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(3834),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [796] = {
    [sym__do] = STATE(2277),
    [sym_heredoc_body] = STATE(2277),
    [sym__terminator] = STATE(2277),
    [sym__line_break] = ACTIONS(3836),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(3836),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [797] = {
    [sym_in] = STATE(2278),
    [anon_sym_in] = ACTIONS(1969),
    [sym_comment] = ACTIONS(87),
  },
  [798] = {
    [sym_heredoc_body] = STATE(2279),
    [sym__terminator] = STATE(2279),
    [sym__line_break] = ACTIONS(3838),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(3838),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [799] = {
    [sym_when] = STATE(2280),
    [aux_sym_case_repeat1] = STATE(2281),
    [anon_sym_SEMI] = ACTIONS(3840),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [800] = {
    [sym_else] = STATE(2283),
    [sym_ensure] = STATE(2284),
    [sym_rescue] = STATE(2285),
    [anon_sym_end] = ACTIONS(3842),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [801] = {
    [sym_ensure] = STATE(2284),
    [anon_sym_end] = ACTIONS(3842),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [802] = {
    [anon_sym_end] = ACTIONS(3842),
    [sym_comment] = ACTIONS(87),
  },
  [803] = {
    [sym_else] = STATE(2283),
    [sym_ensure] = STATE(2284),
    [anon_sym_end] = ACTIONS(3842),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [804] = {
    [anon_sym_DOT] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_COLON_COLON2] = ACTIONS(2187),
    [anon_sym_AMP_DOT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [805] = {
    [sym__statements] = STATE(800),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(801),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(802),
    [sym_rescue] = STATE(803),
    [sym__body_statement] = STATE(2286),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3844),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [806] = {
    [anon_sym_DOT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_COLON_COLON2] = ACTIONS(2267),
    [anon_sym_AMP_DOT] = ACTIONS(2267),
    [sym_comment] = ACTIONS(87),
  },
  [807] = {
    [anon_sym_DOT] = ACTIONS(2351),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_COLON_COLON2] = ACTIONS(2351),
    [anon_sym_AMP_DOT] = ACTIONS(2351),
    [sym_comment] = ACTIONS(87),
  },
  [808] = {
    [sym_heredoc_body] = STATE(2288),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(3846),
    [sym_comment] = ACTIONS(87),
  },
  [809] = {
    [anon_sym_RBRACK] = ACTIONS(3846),
    [sym_comment] = ACTIONS(87),
  },
  [810] = {
    [sym__statements] = STATE(2290),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(2291),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(3848),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [811] = {
    [sym__statements] = STATE(2293),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(2294),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(2295),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(2295),
    [sym__line_break] = ACTIONS(3850),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3852),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [812] = {
    [sym_do_block] = STATE(2296),
    [sym_block] = STATE(2296),
    [anon_sym_LBRACE] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(3854),
    [sym_comment] = ACTIONS(87),
  },
  [813] = {
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2491),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_COLON_COLON2] = ACTIONS(2491),
    [anon_sym_AMP_DOT] = ACTIONS(2491),
    [sym_comment] = ACTIONS(87),
  },
  [814] = {
    [sym_argument_list_with_parens] = STATE(2299),
    [sym__argument_list_with_parens] = STATE(2300),
    [sym_operator] = STATE(2299),
    [sym_heredoc_body] = STATE(2301),
    [aux_sym_call_repeat1] = STATE(2301),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(3856),
    [anon_sym_STAR] = ACTIONS(3858),
    [anon_sym_STAR_STAR] = ACTIONS(3856),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(3858),
    [anon_sym_LPAREN2] = ACTIONS(3860),
    [anon_sym_DOT_DOT] = ACTIONS(3856),
    [anon_sym_LT_LT] = ACTIONS(3856),
    [anon_sym_GT_GT] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_LT_EQ_GT] = ACTIONS(3856),
    [anon_sym_EQ_TILDE] = ACTIONS(3856),
    [anon_sym_BANG_TILDE] = ACTIONS(3856),
    [anon_sym_LT_EQ] = ACTIONS(3858),
    [anon_sym_GT] = ACTIONS(3858),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_CARET] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3858),
    [anon_sym_SLASH] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_TILDE] = ACTIONS(3856),
    [sym_constant] = ACTIONS(3862),
    [sym_identifier] = ACTIONS(3862),
    [anon_sym_DASH] = ACTIONS(3858),
    [anon_sym_PLUS_AT] = ACTIONS(3856),
    [anon_sym_DASH_AT] = ACTIONS(3856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3858),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3856),
    [anon_sym_BQUOTE] = ACTIONS(3856),
    [sym_comment] = ACTIONS(87),
  },
  [815] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(2303),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(2304),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(3864),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [816] = {
    [sym_constant] = ACTIONS(3866),
    [sym_identifier] = ACTIONS(3866),
    [sym_comment] = ACTIONS(87),
  },
  [817] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2335),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(2335),
    [sym_operator_assignment] = STATE(2335),
    [sym_conditional] = STATE(2335),
    [sym_range] = STATE(2335),
    [sym_binary] = STATE(2335),
    [sym_unary] = STATE(2335),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [818] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2340),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(2340),
    [sym_operator_assignment] = STATE(2340),
    [sym_conditional] = STATE(2340),
    [sym_range] = STATE(2340),
    [sym_binary] = STATE(2340),
    [sym_unary] = STATE(2340),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [819] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2341),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(2341),
    [sym_operator_assignment] = STATE(2341),
    [sym_conditional] = STATE(2341),
    [sym_range] = STATE(2341),
    [sym_binary] = STATE(2341),
    [sym_unary] = STATE(2341),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [820] = {
    [anon_sym_COLON] = ACTIONS(3934),
    [sym_comment] = ACTIONS(87),
  },
  [821] = {
    [sym__statements] = STATE(2290),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(2291),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1288),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1289),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(3936),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [822] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2345),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(2345),
    [sym_operator_assignment] = STATE(2345),
    [sym_conditional] = STATE(2345),
    [sym_range] = STATE(2345),
    [sym_binary] = STATE(2345),
    [sym_unary] = STATE(2345),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [823] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2351),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(2352),
    [sym__argument] = STATE(2353),
    [sym_splat_argument] = STATE(2353),
    [sym_hash_splat_argument] = STATE(2353),
    [sym_block_argument] = STATE(2353),
    [sym_assignment] = STATE(2351),
    [sym_operator_assignment] = STATE(2351),
    [sym_conditional] = STATE(2351),
    [sym_range] = STATE(2351),
    [sym_binary] = STATE(2351),
    [sym_unary] = STATE(2351),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2353),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3938),
    [sym__splat_star] = ACTIONS(3940),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(3946),
    [sym_identifier] = ACTIONS(3946),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [824] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2351),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(2352),
    [sym__argument] = STATE(2353),
    [sym_splat_argument] = STATE(2353),
    [sym_hash_splat_argument] = STATE(2353),
    [sym_block_argument] = STATE(2353),
    [sym_assignment] = STATE(2351),
    [sym_operator_assignment] = STATE(2351),
    [sym_conditional] = STATE(2351),
    [sym_range] = STATE(2351),
    [sym_binary] = STATE(2351),
    [sym_unary] = STATE(2351),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2353),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3938),
    [sym__splat_star] = ACTIONS(3940),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(3946),
    [sym_identifier] = ACTIONS(3946),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [825] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2351),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(2352),
    [sym__argument] = STATE(2353),
    [sym_splat_argument] = STATE(2353),
    [sym_hash_splat_argument] = STATE(2353),
    [sym_block_argument] = STATE(2353),
    [sym_assignment] = STATE(2351),
    [sym_operator_assignment] = STATE(2351),
    [sym_conditional] = STATE(2351),
    [sym_range] = STATE(2351),
    [sym_binary] = STATE(2351),
    [sym_unary] = STATE(2351),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2353),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3938),
    [sym__splat_star] = ACTIONS(3940),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(3946),
    [sym_identifier] = ACTIONS(3946),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [826] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2351),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(2352),
    [sym__argument] = STATE(2353),
    [sym_splat_argument] = STATE(2353),
    [sym_hash_splat_argument] = STATE(2353),
    [sym_block_argument] = STATE(2353),
    [sym_assignment] = STATE(2351),
    [sym_operator_assignment] = STATE(2351),
    [sym_conditional] = STATE(2351),
    [sym_range] = STATE(2351),
    [sym_binary] = STATE(2351),
    [sym_unary] = STATE(2351),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2353),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3938),
    [sym__splat_star] = ACTIONS(3940),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(3946),
    [sym_identifier] = ACTIONS(3946),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [827] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2355),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(2355),
    [sym_operator_assignment] = STATE(2355),
    [sym_conditional] = STATE(2355),
    [sym_range] = STATE(2355),
    [sym_binary] = STATE(2355),
    [sym_unary] = STATE(2355),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [828] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [829] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(3948),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [830] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(3934),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(3966),
    [anon_sym_or] = ACTIONS(3966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [831] = {
    [sym_do_block] = STATE(2367),
    [sym_block] = STATE(2367),
    [anon_sym_LBRACE] = ACTIONS(1473),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2725),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_in] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(3854),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [sym_comment] = ACTIONS(87),
  },
  [832] = {
    [sym_heredoc_body] = STATE(2368),
    [aux_sym_call_repeat1] = STATE(2368),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_EQ] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [833] = {
    [sym_heredoc_body] = STATE(2368),
    [aux_sym_call_repeat1] = STATE(2368),
    [aux_sym_argument_list_repeat1] = STATE(2370),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_EQ] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [834] = {
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2725),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_EQ] = ACTIONS(2725),
    [anon_sym_in] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [sym_comment] = ACTIONS(87),
  },
  [835] = {
    [anon_sym_EQ] = ACTIONS(3980),
    [sym_comment] = ACTIONS(87),
  },
  [836] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3984),
    [anon_sym_DASH_EQ] = ACTIONS(3984),
    [anon_sym_STAR_EQ] = ACTIONS(3984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3984),
    [anon_sym_SLASH_EQ] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3984),
    [anon_sym_PIPE_EQ] = ACTIONS(3984),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3984),
    [anon_sym_AMP_EQ] = ACTIONS(3984),
    [anon_sym_PERCENT_EQ] = ACTIONS(3984),
    [anon_sym_GT_GT_EQ] = ACTIONS(3984),
    [anon_sym_LT_LT_EQ] = ACTIONS(3984),
    [anon_sym_CARET_EQ] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [837] = {
    [sym_string] = STATE(2373),
    [aux_sym_chained_string_repeat1] = STATE(2373),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3986),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [838] = {
    [sym_string] = STATE(2374),
    [aux_sym_chained_string_repeat1] = STATE(2374),
    [sym__string_start] = ACTIONS(279),
    [anon_sym_DOT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [839] = {
    [sym_heredoc_body] = STATE(2375),
    [sym__terminator] = STATE(2375),
    [sym__line_break] = ACTIONS(3988),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(3988),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [840] = {
    [sym__line_break] = ACTIONS(1413),
    [sym__simple_symbol] = ACTIONS(1413),
    [sym__string_start] = ACTIONS(1413),
    [sym__symbol_start] = ACTIONS(1413),
    [sym__subshell_start] = ACTIONS(1413),
    [sym__regex_start] = ACTIONS(1413),
    [sym__string_array_start] = ACTIONS(1413),
    [sym__symbol_array_start] = ACTIONS(1413),
    [sym__heredoc_body_start] = ACTIONS(1413),
    [sym_heredoc_beginning] = ACTIONS(1413),
    [sym__block_ampersand] = ACTIONS(1413),
    [sym__splat_star] = ACTIONS(1413),
    [sym__unary_minus] = ACTIONS(1413),
    [sym__identifier_hash_key] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_def] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_DOT] = ACTIONS(1413),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_class] = ACTIONS(1415),
    [anon_sym_LT] = ACTIONS(1413),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_end] = ACTIONS(1415),
    [anon_sym_return] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1415),
    [anon_sym_next] = ACTIONS(1415),
    [sym_redo] = ACTIONS(1415),
    [sym_retry] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_unless] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1415),
    [anon_sym_until] = ACTIONS(1415),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_do] = ACTIONS(1415),
    [anon_sym_case] = ACTIONS(1415),
    [anon_sym_then] = ACTIONS(1415),
    [anon_sym_begin] = ACTIONS(1415),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_COLON_COLON2] = ACTIONS(1413),
    [anon_sym_AMP_DOT] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1413),
    [anon_sym_TILDE] = ACTIONS(1413),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1415),
    [sym_float] = ACTIONS(1415),
    [sym_complex] = ACTIONS(1413),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1415),
    [anon_sym_TRUE] = ACTIONS(1415),
    [anon_sym_false] = ACTIONS(1415),
    [anon_sym_FALSE] = ACTIONS(1415),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(1415),
    [anon_sym_NIL] = ACTIONS(1415),
    [sym_character] = ACTIONS(1413),
    [anon_sym_LBRACK2] = ACTIONS(1415),
    [anon_sym_DASH_GT] = ACTIONS(1413),
  },
  [841] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2376),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2376),
    [sym_operator_assignment] = STATE(2376),
    [sym_conditional] = STATE(2376),
    [sym_range] = STATE(2376),
    [sym_binary] = STATE(2376),
    [sym_unary] = STATE(2376),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [842] = {
    [sym_heredoc_body] = STATE(2377),
    [sym__terminator] = STATE(2377),
    [sym__line_break] = ACTIONS(3990),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(3990),
    [sym_comment] = ACTIONS(87),
  },
  [843] = {
    [sym__statements] = STATE(285),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(288),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(289),
    [sym_rescue] = STATE(290),
    [sym__body_statement] = STATE(2378),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3992),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [844] = {
    [sym_constant] = ACTIONS(3994),
    [sym_identifier] = ACTIONS(3994),
    [sym_comment] = ACTIONS(87),
  },
  [845] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2387),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(2387),
    [sym_operator_assignment] = STATE(2387),
    [sym_conditional] = STATE(2387),
    [sym_range] = STATE(2387),
    [sym_binary] = STATE(2387),
    [sym_unary] = STATE(2387),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [846] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2391),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(2391),
    [sym_operator_assignment] = STATE(2391),
    [sym_conditional] = STATE(2391),
    [sym_range] = STATE(2391),
    [sym_binary] = STATE(2391),
    [sym_unary] = STATE(2391),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [847] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2392),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(2392),
    [sym_operator_assignment] = STATE(2392),
    [sym_conditional] = STATE(2392),
    [sym_range] = STATE(2392),
    [sym_binary] = STATE(2392),
    [sym_unary] = STATE(2392),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [848] = {
    [anon_sym_COLON] = ACTIONS(4014),
    [sym_comment] = ACTIONS(87),
  },
  [849] = {
    [sym__statements] = STATE(2290),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(2291),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1288),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1289),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4016),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [850] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2396),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(2396),
    [sym_operator_assignment] = STATE(2396),
    [sym_conditional] = STATE(2396),
    [sym_range] = STATE(2396),
    [sym_binary] = STATE(2396),
    [sym_unary] = STATE(2396),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [851] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2402),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(2403),
    [sym__argument] = STATE(2404),
    [sym_splat_argument] = STATE(2404),
    [sym_hash_splat_argument] = STATE(2404),
    [sym_block_argument] = STATE(2404),
    [sym_assignment] = STATE(2402),
    [sym_operator_assignment] = STATE(2402),
    [sym_conditional] = STATE(2402),
    [sym_range] = STATE(2402),
    [sym_binary] = STATE(2402),
    [sym_unary] = STATE(2402),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2405),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2404),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4018),
    [sym__splat_star] = ACTIONS(4020),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(4026),
    [sym_identifier] = ACTIONS(4026),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [852] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2402),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(2403),
    [sym__argument] = STATE(2404),
    [sym_splat_argument] = STATE(2404),
    [sym_hash_splat_argument] = STATE(2404),
    [sym_block_argument] = STATE(2404),
    [sym_assignment] = STATE(2402),
    [sym_operator_assignment] = STATE(2402),
    [sym_conditional] = STATE(2402),
    [sym_range] = STATE(2402),
    [sym_binary] = STATE(2402),
    [sym_unary] = STATE(2402),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2405),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2404),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4018),
    [sym__splat_star] = ACTIONS(4020),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(4026),
    [sym_identifier] = ACTIONS(4026),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [853] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2402),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(2403),
    [sym__argument] = STATE(2404),
    [sym_splat_argument] = STATE(2404),
    [sym_hash_splat_argument] = STATE(2404),
    [sym_block_argument] = STATE(2404),
    [sym_assignment] = STATE(2402),
    [sym_operator_assignment] = STATE(2402),
    [sym_conditional] = STATE(2402),
    [sym_range] = STATE(2402),
    [sym_binary] = STATE(2402),
    [sym_unary] = STATE(2402),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2405),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2404),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4018),
    [sym__splat_star] = ACTIONS(4020),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(4026),
    [sym_identifier] = ACTIONS(4026),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [854] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2402),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(2403),
    [sym__argument] = STATE(2404),
    [sym_splat_argument] = STATE(2404),
    [sym_hash_splat_argument] = STATE(2404),
    [sym_block_argument] = STATE(2404),
    [sym_assignment] = STATE(2402),
    [sym_operator_assignment] = STATE(2402),
    [sym_conditional] = STATE(2402),
    [sym_range] = STATE(2402),
    [sym_binary] = STATE(2402),
    [sym_unary] = STATE(2402),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2405),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2404),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4018),
    [sym__splat_star] = ACTIONS(4020),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(4026),
    [sym_identifier] = ACTIONS(4026),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [855] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2406),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(2406),
    [sym_operator_assignment] = STATE(2406),
    [sym_conditional] = STATE(2406),
    [sym_range] = STATE(2406),
    [sym_binary] = STATE(2406),
    [sym_unary] = STATE(2406),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [856] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [857] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4028),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [858] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(4014),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4046),
    [anon_sym_or] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [859] = {
    [sym_heredoc_body] = STATE(2418),
    [aux_sym_call_repeat1] = STATE(2418),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [860] = {
    [sym_heredoc_body] = STATE(2418),
    [aux_sym_call_repeat1] = STATE(2418),
    [aux_sym_argument_list_repeat1] = STATE(2420),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [861] = {
    [anon_sym_EQ] = ACTIONS(4060),
    [sym_comment] = ACTIONS(87),
  },
  [862] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4064),
    [anon_sym_DASH_EQ] = ACTIONS(4064),
    [anon_sym_STAR_EQ] = ACTIONS(4064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4064),
    [anon_sym_SLASH_EQ] = ACTIONS(4064),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4064),
    [anon_sym_PIPE_EQ] = ACTIONS(4064),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4064),
    [anon_sym_AMP_EQ] = ACTIONS(4064),
    [anon_sym_PERCENT_EQ] = ACTIONS(4064),
    [anon_sym_GT_GT_EQ] = ACTIONS(4064),
    [anon_sym_LT_LT_EQ] = ACTIONS(4064),
    [anon_sym_CARET_EQ] = ACTIONS(4064),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [863] = {
    [sym_string] = STATE(2423),
    [aux_sym_chained_string_repeat1] = STATE(2423),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4066),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [864] = {
    [sym__line_break] = ACTIONS(4068),
    [sym__heredoc_body_start] = ACTIONS(4068),
    [sym__binary_minus] = ACTIONS(4068),
    [sym__binary_star] = ACTIONS(4068),
    [ts_builtin_sym_end] = ACTIONS(4068),
    [anon_sym___END__] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_STAR_STAR] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_end] = ACTIONS(4068),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_unless] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_until] = ACTIONS(4068),
    [anon_sym_rescue] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_when] = ACTIONS(4068),
    [anon_sym_elsif] = ACTIONS(4068),
    [anon_sym_else] = ACTIONS(4068),
    [anon_sym_then] = ACTIONS(4068),
    [anon_sym_ensure] = ACTIONS(4068),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON_COLON2] = ACTIONS(4068),
    [anon_sym_AMP_DOT] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(4068),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ_GT] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_BANG_TILDE] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4068),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [sym_comment] = ACTIONS(87),
  },
  [865] = {
    [sym__statements] = STATE(285),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(288),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(289),
    [sym_rescue] = STATE(290),
    [sym__body_statement] = STATE(2424),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4072),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [866] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2425),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(2425),
    [sym_operator_assignment] = STATE(2425),
    [sym_conditional] = STATE(2425),
    [sym_range] = STATE(2425),
    [sym_binary] = STATE(2425),
    [sym_unary] = STATE(2425),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [867] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2426),
    [sym__argument] = STATE(2427),
    [sym_splat_argument] = STATE(2427),
    [sym_hash_splat_argument] = STATE(2427),
    [sym_block_argument] = STATE(2427),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2427),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(363),
    [anon_sym___END__] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [868] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2426),
    [sym__argument] = STATE(2427),
    [sym_splat_argument] = STATE(2427),
    [sym_hash_splat_argument] = STATE(2427),
    [sym_block_argument] = STATE(2427),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2427),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [869] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2426),
    [sym__argument] = STATE(2427),
    [sym_splat_argument] = STATE(2427),
    [sym_hash_splat_argument] = STATE(2427),
    [sym_block_argument] = STATE(2427),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2427),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [870] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2426),
    [sym__argument] = STATE(2427),
    [sym_splat_argument] = STATE(2427),
    [sym_hash_splat_argument] = STATE(2427),
    [sym_block_argument] = STATE(2427),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2427),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(371),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [871] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2428),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(2428),
    [sym_operator_assignment] = STATE(2428),
    [sym_conditional] = STATE(2428),
    [sym_range] = STATE(2428),
    [sym_binary] = STATE(2428),
    [sym_unary] = STATE(2428),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [872] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [873] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(4074),
    [anon_sym___END__] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [874] = {
    [anon_sym_EQ] = ACTIONS(4104),
    [sym_comment] = ACTIONS(87),
  },
  [875] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4106),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4108),
    [anon_sym_DASH_EQ] = ACTIONS(4108),
    [anon_sym_STAR_EQ] = ACTIONS(4108),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4108),
    [anon_sym_SLASH_EQ] = ACTIONS(4108),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4108),
    [anon_sym_PIPE_EQ] = ACTIONS(4108),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4108),
    [anon_sym_AMP_EQ] = ACTIONS(4108),
    [anon_sym_PERCENT_EQ] = ACTIONS(4108),
    [anon_sym_GT_GT_EQ] = ACTIONS(4108),
    [anon_sym_LT_LT_EQ] = ACTIONS(4108),
    [anon_sym_CARET_EQ] = ACTIONS(4108),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [876] = {
    [sym_string] = STATE(2441),
    [aux_sym_chained_string_repeat1] = STATE(2441),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [877] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(4110),
    [anon_sym___END__] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [878] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [879] = {
    [sym_string] = STATE(949),
    [aux_sym_chained_string_repeat1] = STATE(949),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [880] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2442),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(2442),
    [sym_operator_assignment] = STATE(2442),
    [sym_conditional] = STATE(2442),
    [sym_range] = STATE(2442),
    [sym_binary] = STATE(2442),
    [sym_unary] = STATE(2442),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [881] = {
    [sym__line_break] = ACTIONS(1413),
    [sym__simple_symbol] = ACTIONS(1413),
    [sym__string_start] = ACTIONS(1413),
    [sym__symbol_start] = ACTIONS(1413),
    [sym__subshell_start] = ACTIONS(1413),
    [sym__regex_start] = ACTIONS(1413),
    [sym__string_array_start] = ACTIONS(1413),
    [sym__symbol_array_start] = ACTIONS(1413),
    [sym__heredoc_body_start] = ACTIONS(1413),
    [sym_heredoc_beginning] = ACTIONS(1413),
    [sym__block_ampersand] = ACTIONS(1413),
    [sym__splat_star] = ACTIONS(1413),
    [sym__unary_minus] = ACTIONS(1413),
    [sym__binary_minus] = ACTIONS(1413),
    [sym__binary_star] = ACTIONS(1413),
    [sym__identifier_hash_key] = ACTIONS(1413),
    [ts_builtin_sym_end] = ACTIONS(1413),
    [anon_sym___END__] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_def] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1415),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_EQ] = ACTIONS(1415),
    [anon_sym_class] = ACTIONS(1415),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_end] = ACTIONS(1415),
    [anon_sym_return] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1415),
    [anon_sym_next] = ACTIONS(1415),
    [sym_redo] = ACTIONS(1415),
    [sym_retry] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_unless] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1415),
    [anon_sym_until] = ACTIONS(1415),
    [anon_sym_rescue] = ACTIONS(1415),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_do] = ACTIONS(1415),
    [anon_sym_case] = ACTIONS(1415),
    [anon_sym_when] = ACTIONS(1415),
    [anon_sym_elsif] = ACTIONS(1415),
    [anon_sym_else] = ACTIONS(1415),
    [anon_sym_then] = ACTIONS(1415),
    [anon_sym_begin] = ACTIONS(1415),
    [anon_sym_ensure] = ACTIONS(1415),
    [anon_sym_EQ_GT] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_COLON_COLON2] = ACTIONS(1413),
    [anon_sym_AMP_DOT] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1413),
    [anon_sym_PLUS_EQ] = ACTIONS(1413),
    [anon_sym_DASH_EQ] = ACTIONS(1413),
    [anon_sym_STAR_EQ] = ACTIONS(1413),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1413),
    [anon_sym_SLASH_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1413),
    [anon_sym_AMP_EQ] = ACTIONS(1413),
    [anon_sym_PERCENT_EQ] = ACTIONS(1413),
    [anon_sym_GT_GT_EQ] = ACTIONS(1413),
    [anon_sym_LT_LT_EQ] = ACTIONS(1413),
    [anon_sym_CARET_EQ] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(1415),
    [anon_sym_DOT_DOT] = ACTIONS(1415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1413),
    [anon_sym_and] = ACTIONS(1415),
    [anon_sym_or] = ACTIONS(1415),
    [anon_sym_PIPE_PIPE] = ACTIONS(1415),
    [anon_sym_AMP_AMP] = ACTIONS(1415),
    [anon_sym_LT_LT] = ACTIONS(1415),
    [anon_sym_GT_GT] = ACTIONS(1415),
    [anon_sym_EQ_EQ] = ACTIONS(1415),
    [anon_sym_BANG_EQ] = ACTIONS(1413),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1413),
    [anon_sym_LT_EQ_GT] = ACTIONS(1413),
    [anon_sym_EQ_TILDE] = ACTIONS(1413),
    [anon_sym_BANG_TILDE] = ACTIONS(1413),
    [anon_sym_LT_EQ] = ACTIONS(1415),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_CARET] = ACTIONS(1415),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(1415),
    [anon_sym_PERCENT] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1413),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1415),
    [sym_float] = ACTIONS(1415),
    [sym_complex] = ACTIONS(1413),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1415),
    [anon_sym_TRUE] = ACTIONS(1415),
    [anon_sym_false] = ACTIONS(1415),
    [anon_sym_FALSE] = ACTIONS(1415),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(1415),
    [anon_sym_NIL] = ACTIONS(1415),
    [sym_character] = ACTIONS(1413),
    [anon_sym_LBRACK2] = ACTIONS(1415),
    [anon_sym_DASH_GT] = ACTIONS(1413),
  },
  [882] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(3148),
    [anon_sym___END__] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [883] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2443),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2443),
    [sym_operator_assignment] = STATE(2443),
    [sym_conditional] = STATE(2443),
    [sym_range] = STATE(2443),
    [sym_binary] = STATE(2443),
    [sym_unary] = STATE(2443),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [884] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2444),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2444),
    [sym_operator_assignment] = STATE(2444),
    [sym_conditional] = STATE(2444),
    [sym_range] = STATE(2444),
    [sym_binary] = STATE(2444),
    [sym_unary] = STATE(2444),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [885] = {
    [anon_sym_COLON] = ACTIONS(4116),
    [sym_comment] = ACTIONS(87),
  },
  [886] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2446),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2446),
    [sym_operator_assignment] = STATE(2446),
    [sym_conditional] = STATE(2446),
    [sym_range] = STATE(2446),
    [sym_binary] = STATE(2446),
    [sym_unary] = STATE(2446),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [887] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym___END__] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4118),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [888] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(1627),
    [anon_sym___END__] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [889] = {
    [sym_heredoc_body] = STATE(2448),
    [aux_sym_call_repeat1] = STATE(2448),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym___END__] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [890] = {
    [sym_heredoc_body] = STATE(2448),
    [aux_sym_call_repeat1] = STATE(2448),
    [aux_sym_argument_list_repeat1] = STATE(2450),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym___END__] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [891] = {
    [sym_string] = STATE(949),
    [aux_sym_chained_string_repeat1] = STATE(949),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [892] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2458),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(2458),
    [sym_operator_assignment] = STATE(2458),
    [sym_conditional] = STATE(2458),
    [sym_range] = STATE(2458),
    [sym_binary] = STATE(2458),
    [sym_unary] = STATE(2458),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [893] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2463),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(2463),
    [sym_operator_assignment] = STATE(2463),
    [sym_conditional] = STATE(2463),
    [sym_range] = STATE(2463),
    [sym_binary] = STATE(2463),
    [sym_unary] = STATE(2463),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [894] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2464),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(2464),
    [sym_operator_assignment] = STATE(2464),
    [sym_conditional] = STATE(2464),
    [sym_range] = STATE(2464),
    [sym_binary] = STATE(2464),
    [sym_unary] = STATE(2464),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [895] = {
    [anon_sym_COLON] = ACTIONS(4146),
    [sym_comment] = ACTIONS(87),
  },
  [896] = {
    [sym__line_break] = ACTIONS(4148),
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [ts_builtin_sym_end] = ACTIONS(4148),
    [anon_sym___END__] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR_STAR] = ACTIONS(4148),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_end] = ACTIONS(4148),
    [anon_sym_if] = ACTIONS(4148),
    [anon_sym_unless] = ACTIONS(4148),
    [anon_sym_while] = ACTIONS(4148),
    [anon_sym_until] = ACTIONS(4148),
    [anon_sym_rescue] = ACTIONS(4148),
    [anon_sym_do] = ACTIONS(4148),
    [anon_sym_when] = ACTIONS(4148),
    [anon_sym_elsif] = ACTIONS(4148),
    [anon_sym_else] = ACTIONS(4148),
    [anon_sym_then] = ACTIONS(4148),
    [anon_sym_ensure] = ACTIONS(4148),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4148),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
  },
  [897] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2467),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(2467),
    [sym_operator_assignment] = STATE(2467),
    [sym_conditional] = STATE(2467),
    [sym_range] = STATE(2467),
    [sym_binary] = STATE(2467),
    [sym_unary] = STATE(2467),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [898] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2473),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(2474),
    [sym__argument] = STATE(2475),
    [sym_splat_argument] = STATE(2475),
    [sym_hash_splat_argument] = STATE(2475),
    [sym_block_argument] = STATE(2475),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2476),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2475),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4152),
    [sym__splat_star] = ACTIONS(4154),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(4158),
    [sym_identifier] = ACTIONS(4158),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [899] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2473),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(2474),
    [sym__argument] = STATE(2475),
    [sym_splat_argument] = STATE(2475),
    [sym_hash_splat_argument] = STATE(2475),
    [sym_block_argument] = STATE(2475),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2476),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2475),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4152),
    [sym__splat_star] = ACTIONS(4154),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(4158),
    [sym_identifier] = ACTIONS(4158),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [900] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2473),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(2474),
    [sym__argument] = STATE(2475),
    [sym_splat_argument] = STATE(2475),
    [sym_hash_splat_argument] = STATE(2475),
    [sym_block_argument] = STATE(2475),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2476),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2475),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4152),
    [sym__splat_star] = ACTIONS(4154),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(4158),
    [sym_identifier] = ACTIONS(4158),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [901] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2473),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(2474),
    [sym__argument] = STATE(2475),
    [sym_splat_argument] = STATE(2475),
    [sym_hash_splat_argument] = STATE(2475),
    [sym_block_argument] = STATE(2475),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2476),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2475),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4152),
    [sym__splat_star] = ACTIONS(4154),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(4158),
    [sym_identifier] = ACTIONS(4158),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [902] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2477),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(2477),
    [sym_operator_assignment] = STATE(2477),
    [sym_conditional] = STATE(2477),
    [sym_range] = STATE(2477),
    [sym_binary] = STATE(2477),
    [sym_unary] = STATE(2477),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [903] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1335),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(1335),
    [sym_operator_assignment] = STATE(1335),
    [sym_conditional] = STATE(1335),
    [sym_range] = STATE(1335),
    [sym_binary] = STATE(1335),
    [sym_unary] = STATE(1335),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [904] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [905] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(4146),
    [anon_sym_QMARK] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4176),
    [anon_sym_and] = ACTIONS(4178),
    [anon_sym_or] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4180),
    [anon_sym_BANG_TILDE] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [906] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2494),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(2495),
    [sym__argument] = STATE(2496),
    [sym_splat_argument] = STATE(2496),
    [sym_hash_splat_argument] = STATE(2496),
    [sym_block_argument] = STATE(2496),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(2494),
    [sym_operator_assignment] = STATE(2494),
    [sym_conditional] = STATE(2494),
    [sym_range] = STATE(2494),
    [sym_binary] = STATE(2494),
    [sym_unary] = STATE(2494),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2497),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2496),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4190),
    [sym__splat_star] = ACTIONS(4192),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(4196),
    [sym_identifier] = ACTIONS(4196),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [907] = {
    [sym_heredoc_body] = STATE(2499),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [sym_comment] = ACTIONS(87),
  },
  [908] = {
    [sym__heredoc_body_start] = ACTIONS(2437),
    [anon_sym_RPAREN] = ACTIONS(2437),
    [anon_sym_COMMA] = ACTIONS(4200),
    [sym_comment] = ACTIONS(87),
  },
  [909] = {
    [anon_sym_EQ] = ACTIONS(4202),
    [sym_comment] = ACTIONS(87),
  },
  [910] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4204),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4206),
    [anon_sym_DASH_EQ] = ACTIONS(4206),
    [anon_sym_STAR_EQ] = ACTIONS(4206),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4206),
    [anon_sym_SLASH_EQ] = ACTIONS(4206),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4206),
    [anon_sym_PIPE_EQ] = ACTIONS(4206),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4206),
    [anon_sym_AMP_EQ] = ACTIONS(4206),
    [anon_sym_PERCENT_EQ] = ACTIONS(4206),
    [anon_sym_GT_GT_EQ] = ACTIONS(4206),
    [anon_sym_LT_LT_EQ] = ACTIONS(4206),
    [anon_sym_CARET_EQ] = ACTIONS(4206),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [911] = {
    [sym_string] = STATE(2503),
    [aux_sym_chained_string_repeat1] = STATE(2503),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [912] = {
    [anon_sym_RPAREN] = ACTIONS(4198),
    [sym_comment] = ACTIONS(87),
  },
  [913] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [914] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [915] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2504),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(2504),
    [sym_operator_assignment] = STATE(2504),
    [sym_conditional] = STATE(2504),
    [sym_range] = STATE(2504),
    [sym_binary] = STATE(2504),
    [sym_unary] = STATE(2504),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [916] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2505),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2505),
    [sym_operator_assignment] = STATE(2505),
    [sym_conditional] = STATE(2505),
    [sym_range] = STATE(2505),
    [sym_binary] = STATE(2505),
    [sym_unary] = STATE(2505),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [917] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2506),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2506),
    [sym_operator_assignment] = STATE(2506),
    [sym_conditional] = STATE(2506),
    [sym_range] = STATE(2506),
    [sym_binary] = STATE(2506),
    [sym_unary] = STATE(2506),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [918] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2507),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2507),
    [sym_operator_assignment] = STATE(2507),
    [sym_conditional] = STATE(2507),
    [sym_range] = STATE(2507),
    [sym_binary] = STATE(2507),
    [sym_unary] = STATE(2507),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [919] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2508),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2508),
    [sym_operator_assignment] = STATE(2508),
    [sym_conditional] = STATE(2508),
    [sym_range] = STATE(2508),
    [sym_binary] = STATE(2508),
    [sym_unary] = STATE(2508),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [920] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2509),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2509),
    [sym_operator_assignment] = STATE(2509),
    [sym_conditional] = STATE(2509),
    [sym_range] = STATE(2509),
    [sym_binary] = STATE(2509),
    [sym_unary] = STATE(2509),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [921] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(2510),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(2510),
    [sym_operator_assignment] = STATE(2510),
    [sym_conditional] = STATE(2510),
    [sym_range] = STATE(2510),
    [sym_binary] = STATE(2510),
    [sym_unary] = STATE(2510),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [922] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2511),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2511),
    [sym_operator_assignment] = STATE(2511),
    [sym_conditional] = STATE(2511),
    [sym_range] = STATE(2511),
    [sym_binary] = STATE(2511),
    [sym_unary] = STATE(2511),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [923] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2512),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2512),
    [sym_operator_assignment] = STATE(2512),
    [sym_conditional] = STATE(2512),
    [sym_range] = STATE(2512),
    [sym_binary] = STATE(2512),
    [sym_unary] = STATE(2512),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [924] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2513),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2513),
    [sym_operator_assignment] = STATE(2513),
    [sym_conditional] = STATE(2513),
    [sym_range] = STATE(2513),
    [sym_binary] = STATE(2513),
    [sym_unary] = STATE(2513),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [925] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2514),
    [sym_operator_assignment] = STATE(2514),
    [sym_conditional] = STATE(2514),
    [sym_range] = STATE(2514),
    [sym_binary] = STATE(2514),
    [sym_unary] = STATE(2514),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [926] = {
    [sym_argument_list_with_parens] = STATE(2517),
    [sym__argument_list_with_parens] = STATE(2518),
    [sym_operator] = STATE(2517),
    [sym_heredoc_body] = STATE(2519),
    [aux_sym_call_repeat1] = STATE(2519),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(4210),
    [anon_sym_STAR] = ACTIONS(4212),
    [anon_sym_STAR_STAR] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4214),
    [anon_sym_DOT_DOT] = ACTIONS(4210),
    [anon_sym_LT_LT] = ACTIONS(4210),
    [anon_sym_GT_GT] = ACTIONS(4210),
    [anon_sym_EQ_EQ] = ACTIONS(4212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4210),
    [anon_sym_LT_EQ_GT] = ACTIONS(4210),
    [anon_sym_EQ_TILDE] = ACTIONS(4210),
    [anon_sym_BANG_TILDE] = ACTIONS(4210),
    [anon_sym_LT_EQ] = ACTIONS(4212),
    [anon_sym_GT] = ACTIONS(4212),
    [anon_sym_GT_EQ] = ACTIONS(4210),
    [anon_sym_CARET] = ACTIONS(4210),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_SLASH] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4210),
    [anon_sym_BANG] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [sym_constant] = ACTIONS(4216),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_AT] = ACTIONS(4210),
    [anon_sym_DASH_AT] = ACTIONS(4210),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4210),
    [anon_sym_BQUOTE] = ACTIONS(4210),
    [sym_comment] = ACTIONS(87),
  },
  [927] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(2521),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(2522),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(4218),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [928] = {
    [sym_constant] = ACTIONS(4220),
    [sym_identifier] = ACTIONS(4220),
    [sym_comment] = ACTIONS(87),
  },
  [929] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2524),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(2524),
    [sym_operator_assignment] = STATE(2524),
    [sym_conditional] = STATE(2524),
    [sym_range] = STATE(2524),
    [sym_binary] = STATE(2524),
    [sym_unary] = STATE(2524),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [930] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2525),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(2525),
    [sym_operator_assignment] = STATE(2525),
    [sym_conditional] = STATE(2525),
    [sym_range] = STATE(2525),
    [sym_binary] = STATE(2525),
    [sym_unary] = STATE(2525),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [931] = {
    [anon_sym_COLON] = ACTIONS(4222),
    [sym_comment] = ACTIONS(87),
  },
  [932] = {
    [sym__statements] = STATE(2528),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(2529),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1519),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1520),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4224),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [933] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2530),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(2530),
    [sym_operator_assignment] = STATE(2530),
    [sym_conditional] = STATE(2530),
    [sym_range] = STATE(2530),
    [sym_binary] = STATE(2530),
    [sym_unary] = STATE(2530),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [934] = {
    [sym__statements] = STATE(2532),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(2533),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(2534),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(2534),
    [sym__line_break] = ACTIONS(4226),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4228),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [935] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(2536),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(2537),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(4230),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [936] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym___END__] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4232),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [937] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(1627),
    [anon_sym___END__] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [938] = {
    [sym_do_block] = STATE(2539),
    [sym_block] = STATE(2539),
    [sym__line_break] = ACTIONS(2725),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [ts_builtin_sym_end] = ACTIONS(2725),
    [anon_sym___END__] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_end] = ACTIONS(2725),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(4234),
    [anon_sym_when] = ACTIONS(2725),
    [anon_sym_elsif] = ACTIONS(2725),
    [anon_sym_else] = ACTIONS(2725),
    [anon_sym_then] = ACTIONS(2725),
    [anon_sym_ensure] = ACTIONS(2725),
    [anon_sym_EQ_GT] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [939] = {
    [sym_heredoc_body] = STATE(2541),
    [aux_sym_call_repeat1] = STATE(2541),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym___END__] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [940] = {
    [sym_heredoc_body] = STATE(2541),
    [aux_sym_call_repeat1] = STATE(2541),
    [aux_sym_argument_list_repeat1] = STATE(2543),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym___END__] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [941] = {
    [sym__line_break] = ACTIONS(2725),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [ts_builtin_sym_end] = ACTIONS(2725),
    [anon_sym___END__] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_end] = ACTIONS(2725),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_when] = ACTIONS(2725),
    [anon_sym_elsif] = ACTIONS(2725),
    [anon_sym_else] = ACTIONS(2725),
    [anon_sym_then] = ACTIONS(2725),
    [anon_sym_ensure] = ACTIONS(2725),
    [anon_sym_EQ_GT] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [942] = {
    [sym_string] = STATE(1587),
    [aux_sym_chained_string_repeat1] = STATE(1587),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4240),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [943] = {
    [sym_interpolation] = STATE(2545),
    [aux_sym_heredoc_body_repeat1] = STATE(2545),
    [sym__heredoc_content] = ACTIONS(4242),
    [sym_heredoc_end] = ACTIONS(4244),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(4242),
  },
  [944] = {
    [sym_heredoc_body] = STATE(2546),
    [aux_sym_call_repeat1] = STATE(2546),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [945] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(2549),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(371),
    [sym__identifier_hash_key] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(4252),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [946] = {
    [sym_heredoc_body] = STATE(2550),
    [aux_sym_call_repeat1] = STATE(2550),
    [aux_sym_argument_list_repeat1] = STATE(2551),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [947] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2552),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_splat_argument] = STATE(2554),
    [sym_assignment] = STATE(2552),
    [sym_operator_assignment] = STATE(2552),
    [sym_conditional] = STATE(2552),
    [sym_range] = STATE(2552),
    [sym_binary] = STATE(2552),
    [sym_unary] = STATE(2552),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(2554),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(1585),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [948] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2555),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(2555),
    [sym_operator_assignment] = STATE(2555),
    [sym_conditional] = STATE(2555),
    [sym_range] = STATE(2555),
    [sym_binary] = STATE(2555),
    [sym_unary] = STATE(2555),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [949] = {
    [sym_string] = STATE(2556),
    [aux_sym_chained_string_repeat1] = STATE(2556),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [ts_builtin_sym_end] = ACTIONS(2759),
    [anon_sym___END__] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [950] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [951] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2564),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(2564),
    [sym_operator_assignment] = STATE(2564),
    [sym_conditional] = STATE(2564),
    [sym_range] = STATE(2564),
    [sym_binary] = STATE(2564),
    [sym_unary] = STATE(2564),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [952] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2568),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(2568),
    [sym_operator_assignment] = STATE(2568),
    [sym_conditional] = STATE(2568),
    [sym_range] = STATE(2568),
    [sym_binary] = STATE(2568),
    [sym_unary] = STATE(2568),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [953] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2569),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(2569),
    [sym_operator_assignment] = STATE(2569),
    [sym_conditional] = STATE(2569),
    [sym_range] = STATE(2569),
    [sym_binary] = STATE(2569),
    [sym_unary] = STATE(2569),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [954] = {
    [anon_sym_COLON] = ACTIONS(4274),
    [sym_comment] = ACTIONS(87),
  },
  [955] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2572),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(2572),
    [sym_operator_assignment] = STATE(2572),
    [sym_conditional] = STATE(2572),
    [sym_range] = STATE(2572),
    [sym_binary] = STATE(2572),
    [sym_unary] = STATE(2572),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [956] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2578),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2579),
    [sym__argument] = STATE(2580),
    [sym_splat_argument] = STATE(2580),
    [sym_hash_splat_argument] = STATE(2580),
    [sym_block_argument] = STATE(2580),
    [sym_assignment] = STATE(2578),
    [sym_operator_assignment] = STATE(2578),
    [sym_conditional] = STATE(2578),
    [sym_range] = STATE(2578),
    [sym_binary] = STATE(2578),
    [sym_unary] = STATE(2578),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2581),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2580),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4276),
    [sym__splat_star] = ACTIONS(4278),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(4282),
    [sym_identifier] = ACTIONS(4282),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [957] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2578),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2579),
    [sym__argument] = STATE(2580),
    [sym_splat_argument] = STATE(2580),
    [sym_hash_splat_argument] = STATE(2580),
    [sym_block_argument] = STATE(2580),
    [sym_assignment] = STATE(2578),
    [sym_operator_assignment] = STATE(2578),
    [sym_conditional] = STATE(2578),
    [sym_range] = STATE(2578),
    [sym_binary] = STATE(2578),
    [sym_unary] = STATE(2578),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2581),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2580),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4276),
    [sym__splat_star] = ACTIONS(4278),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(4282),
    [sym_identifier] = ACTIONS(4282),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [958] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2578),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2579),
    [sym__argument] = STATE(2580),
    [sym_splat_argument] = STATE(2580),
    [sym_hash_splat_argument] = STATE(2580),
    [sym_block_argument] = STATE(2580),
    [sym_assignment] = STATE(2578),
    [sym_operator_assignment] = STATE(2578),
    [sym_conditional] = STATE(2578),
    [sym_range] = STATE(2578),
    [sym_binary] = STATE(2578),
    [sym_unary] = STATE(2578),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2581),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2580),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4276),
    [sym__splat_star] = ACTIONS(4278),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(4282),
    [sym_identifier] = ACTIONS(4282),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [959] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2578),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2579),
    [sym__argument] = STATE(2580),
    [sym_splat_argument] = STATE(2580),
    [sym_hash_splat_argument] = STATE(2580),
    [sym_block_argument] = STATE(2580),
    [sym_assignment] = STATE(2578),
    [sym_operator_assignment] = STATE(2578),
    [sym_conditional] = STATE(2578),
    [sym_range] = STATE(2578),
    [sym_binary] = STATE(2578),
    [sym_unary] = STATE(2578),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2581),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2580),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4276),
    [sym__splat_star] = ACTIONS(4278),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(4282),
    [sym_identifier] = ACTIONS(4282),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [960] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2582),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(2582),
    [sym_operator_assignment] = STATE(2582),
    [sym_conditional] = STATE(2582),
    [sym_range] = STATE(2582),
    [sym_binary] = STATE(2582),
    [sym_unary] = STATE(2582),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [961] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [962] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4284),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [963] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [964] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2599),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(2600),
    [sym__argument] = STATE(2601),
    [sym_splat_argument] = STATE(2601),
    [sym_hash_splat_argument] = STATE(2601),
    [sym_block_argument] = STATE(2601),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2599),
    [sym_operator_assignment] = STATE(2599),
    [sym_conditional] = STATE(2599),
    [sym_range] = STATE(2599),
    [sym_binary] = STATE(2599),
    [sym_unary] = STATE(2599),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2602),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2601),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4312),
    [sym__splat_star] = ACTIONS(4314),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(4316),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(4318),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [965] = {
    [sym_heredoc_body] = STATE(2603),
    [aux_sym_call_repeat1] = STATE(2603),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [966] = {
    [sym_heredoc_body] = STATE(2603),
    [aux_sym_call_repeat1] = STATE(2603),
    [aux_sym_argument_list_repeat1] = STATE(2605),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4320),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [967] = {
    [anon_sym_EQ] = ACTIONS(4322),
    [sym_comment] = ACTIONS(87),
  },
  [968] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4324),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4326),
    [anon_sym_DASH_EQ] = ACTIONS(4326),
    [anon_sym_STAR_EQ] = ACTIONS(4326),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4326),
    [anon_sym_SLASH_EQ] = ACTIONS(4326),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4326),
    [anon_sym_PIPE_EQ] = ACTIONS(4326),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4326),
    [anon_sym_AMP_EQ] = ACTIONS(4326),
    [anon_sym_PERCENT_EQ] = ACTIONS(4326),
    [anon_sym_GT_GT_EQ] = ACTIONS(4326),
    [anon_sym_LT_LT_EQ] = ACTIONS(4326),
    [anon_sym_CARET_EQ] = ACTIONS(4326),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [969] = {
    [sym_string] = STATE(2608),
    [aux_sym_chained_string_repeat1] = STATE(2608),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4328),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [970] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [971] = {
    [aux_sym_undef_repeat1] = STATE(2609),
    [sym__line_break] = ACTIONS(2257),
    [sym__heredoc_body_start] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [anon_sym_then] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [972] = {
    [sym_interpolation] = STATE(2611),
    [aux_sym_heredoc_body_repeat1] = STATE(2611),
    [sym__heredoc_content] = ACTIONS(4330),
    [sym_heredoc_end] = ACTIONS(4332),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(4330),
  },
  [973] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2612),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2612),
    [sym_operator_assignment] = STATE(2612),
    [sym_conditional] = STATE(2612),
    [sym_range] = STATE(2612),
    [sym_binary] = STATE(2612),
    [sym_unary] = STATE(2612),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [974] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2613),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2613),
    [sym_operator_assignment] = STATE(2613),
    [sym_conditional] = STATE(2613),
    [sym_range] = STATE(2613),
    [sym_binary] = STATE(2613),
    [sym_unary] = STATE(2613),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [975] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2614),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2614),
    [sym_operator_assignment] = STATE(2614),
    [sym_conditional] = STATE(2614),
    [sym_range] = STATE(2614),
    [sym_binary] = STATE(2614),
    [sym_unary] = STATE(2614),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [976] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2615),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2615),
    [sym_operator_assignment] = STATE(2615),
    [sym_conditional] = STATE(2615),
    [sym_range] = STATE(2615),
    [sym_binary] = STATE(2615),
    [sym_unary] = STATE(2615),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [977] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2616),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2616),
    [sym_operator_assignment] = STATE(2616),
    [sym_conditional] = STATE(2616),
    [sym_range] = STATE(2616),
    [sym_binary] = STATE(2616),
    [sym_unary] = STATE(2616),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [978] = {
    [sym__statements] = STATE(2628),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(2631),
    [sym_else] = STATE(2631),
    [sym__if_tail] = STATE(2631),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(2637),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__terminator] = STATE(2637),
    [sym__line_break] = ACTIONS(4334),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4338),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [979] = {
    [sym__line_break] = ACTIONS(4366),
    [sym__simple_symbol] = ACTIONS(4366),
    [sym__string_start] = ACTIONS(4366),
    [sym__symbol_start] = ACTIONS(4366),
    [sym__subshell_start] = ACTIONS(4366),
    [sym__regex_start] = ACTIONS(4366),
    [sym__string_array_start] = ACTIONS(4366),
    [sym__symbol_array_start] = ACTIONS(4366),
    [sym__heredoc_body_start] = ACTIONS(4366),
    [sym_heredoc_beginning] = ACTIONS(4366),
    [sym__unary_minus] = ACTIONS(4366),
    [anon_sym_BEGIN] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(4366),
    [anon_sym_END] = ACTIONS(4368),
    [anon_sym_def] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4366),
    [anon_sym_COLON_COLON] = ACTIONS(4366),
    [anon_sym_SEMI] = ACTIONS(4366),
    [anon_sym_STAR] = ACTIONS(4366),
    [anon_sym_class] = ACTIONS(4368),
    [anon_sym_module] = ACTIONS(4368),
    [anon_sym_end] = ACTIONS(4368),
    [anon_sym_return] = ACTIONS(4368),
    [anon_sym_yield] = ACTIONS(4368),
    [anon_sym_break] = ACTIONS(4368),
    [anon_sym_next] = ACTIONS(4368),
    [sym_redo] = ACTIONS(4368),
    [sym_retry] = ACTIONS(4368),
    [anon_sym_if] = ACTIONS(4368),
    [anon_sym_unless] = ACTIONS(4368),
    [anon_sym_while] = ACTIONS(4368),
    [anon_sym_until] = ACTIONS(4368),
    [anon_sym_for] = ACTIONS(4368),
    [anon_sym_case] = ACTIONS(4368),
    [anon_sym_elsif] = ACTIONS(4368),
    [anon_sym_else] = ACTIONS(4368),
    [anon_sym_then] = ACTIONS(4370),
    [anon_sym_begin] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4368),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4366),
    [anon_sym_TILDE] = ACTIONS(4366),
    [sym_constant] = ACTIONS(4368),
    [sym_identifier] = ACTIONS(4368),
    [sym_instance_variable] = ACTIONS(4366),
    [sym_class_variable] = ACTIONS(4366),
    [sym_global_variable] = ACTIONS(4366),
    [anon_sym_undef] = ACTIONS(4368),
    [anon_sym_alias] = ACTIONS(4368),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4368),
    [sym_float] = ACTIONS(4368),
    [sym_complex] = ACTIONS(4366),
    [sym_super] = ACTIONS(4368),
    [anon_sym_true] = ACTIONS(4368),
    [anon_sym_TRUE] = ACTIONS(4368),
    [anon_sym_false] = ACTIONS(4368),
    [anon_sym_FALSE] = ACTIONS(4368),
    [sym_self] = ACTIONS(4368),
    [anon_sym_nil] = ACTIONS(4368),
    [anon_sym_NIL] = ACTIONS(4368),
    [sym_character] = ACTIONS(4366),
    [anon_sym_LBRACK2] = ACTIONS(4366),
    [anon_sym_DASH_GT] = ACTIONS(4366),
  },
  [980] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2639),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2639),
    [sym_operator_assignment] = STATE(2639),
    [sym_conditional] = STATE(2639),
    [sym_range] = STATE(2639),
    [sym_binary] = STATE(2639),
    [sym_unary] = STATE(2639),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [981] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2640),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2640),
    [sym_operator_assignment] = STATE(2640),
    [sym_conditional] = STATE(2640),
    [sym_range] = STATE(2640),
    [sym_binary] = STATE(2640),
    [sym_unary] = STATE(2640),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [982] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2641),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2641),
    [sym_operator_assignment] = STATE(2641),
    [sym_conditional] = STATE(2641),
    [sym_range] = STATE(2641),
    [sym_binary] = STATE(2641),
    [sym_unary] = STATE(2641),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [983] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [984] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2643),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2643),
    [sym_operator_assignment] = STATE(2643),
    [sym_conditional] = STATE(2643),
    [sym_range] = STATE(2643),
    [sym_binary] = STATE(2643),
    [sym_unary] = STATE(2643),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [985] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(2644),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(2644),
    [sym_operator_assignment] = STATE(2644),
    [sym_conditional] = STATE(2644),
    [sym_range] = STATE(2644),
    [sym_binary] = STATE(2644),
    [sym_unary] = STATE(2644),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [986] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2645),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2645),
    [sym_operator_assignment] = STATE(2645),
    [sym_conditional] = STATE(2645),
    [sym_range] = STATE(2645),
    [sym_binary] = STATE(2645),
    [sym_unary] = STATE(2645),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [987] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2646),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2646),
    [sym_operator_assignment] = STATE(2646),
    [sym_conditional] = STATE(2646),
    [sym_range] = STATE(2646),
    [sym_binary] = STATE(2646),
    [sym_unary] = STATE(2646),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [988] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2647),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2647),
    [sym_operator_assignment] = STATE(2647),
    [sym_conditional] = STATE(2647),
    [sym_range] = STATE(2647),
    [sym_binary] = STATE(2647),
    [sym_unary] = STATE(2647),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [989] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2648),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2648),
    [sym_operator_assignment] = STATE(2648),
    [sym_conditional] = STATE(2648),
    [sym_range] = STATE(2648),
    [sym_binary] = STATE(2648),
    [sym_unary] = STATE(2648),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [990] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(2656),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(2656),
    [sym_operator_assignment] = STATE(2656),
    [sym_conditional] = STATE(2656),
    [sym_range] = STATE(2656),
    [sym_binary] = STATE(2656),
    [sym_unary] = STATE(2656),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [991] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(2661),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(2661),
    [sym_operator_assignment] = STATE(2661),
    [sym_conditional] = STATE(2661),
    [sym_range] = STATE(2661),
    [sym_binary] = STATE(2661),
    [sym_unary] = STATE(2661),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [992] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2662),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(2662),
    [sym_operator_assignment] = STATE(2662),
    [sym_conditional] = STATE(2662),
    [sym_range] = STATE(2662),
    [sym_binary] = STATE(2662),
    [sym_unary] = STATE(2662),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [993] = {
    [anon_sym_COLON] = ACTIONS(4396),
    [sym_comment] = ACTIONS(87),
  },
  [994] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(2665),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(2665),
    [sym_operator_assignment] = STATE(2665),
    [sym_conditional] = STATE(2665),
    [sym_range] = STATE(2665),
    [sym_binary] = STATE(2665),
    [sym_unary] = STATE(2665),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [995] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2599),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(2600),
    [sym__argument] = STATE(2601),
    [sym_splat_argument] = STATE(2601),
    [sym_hash_splat_argument] = STATE(2601),
    [sym_block_argument] = STATE(2601),
    [sym_assignment] = STATE(2599),
    [sym_operator_assignment] = STATE(2599),
    [sym_conditional] = STATE(2599),
    [sym_range] = STATE(2599),
    [sym_binary] = STATE(2599),
    [sym_unary] = STATE(2599),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2602),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2601),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4312),
    [sym__splat_star] = ACTIONS(4314),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4316),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(4318),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [996] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2599),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(2600),
    [sym__argument] = STATE(2601),
    [sym_splat_argument] = STATE(2601),
    [sym_hash_splat_argument] = STATE(2601),
    [sym_block_argument] = STATE(2601),
    [sym_assignment] = STATE(2599),
    [sym_operator_assignment] = STATE(2599),
    [sym_conditional] = STATE(2599),
    [sym_range] = STATE(2599),
    [sym_binary] = STATE(2599),
    [sym_unary] = STATE(2599),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2602),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2601),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4312),
    [sym__splat_star] = ACTIONS(4314),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4316),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(4318),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [997] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2599),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(2600),
    [sym__argument] = STATE(2601),
    [sym_splat_argument] = STATE(2601),
    [sym_hash_splat_argument] = STATE(2601),
    [sym_block_argument] = STATE(2601),
    [sym_assignment] = STATE(2599),
    [sym_operator_assignment] = STATE(2599),
    [sym_conditional] = STATE(2599),
    [sym_range] = STATE(2599),
    [sym_binary] = STATE(2599),
    [sym_unary] = STATE(2599),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2602),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2601),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4312),
    [sym__splat_star] = ACTIONS(4314),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4316),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(4318),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [998] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2599),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(2600),
    [sym__argument] = STATE(2601),
    [sym_splat_argument] = STATE(2601),
    [sym_hash_splat_argument] = STATE(2601),
    [sym_block_argument] = STATE(2601),
    [sym_assignment] = STATE(2599),
    [sym_operator_assignment] = STATE(2599),
    [sym_conditional] = STATE(2599),
    [sym_range] = STATE(2599),
    [sym_binary] = STATE(2599),
    [sym_unary] = STATE(2599),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2602),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2601),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4312),
    [sym__splat_star] = ACTIONS(4314),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4316),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(4318),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [999] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2666),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(2666),
    [sym_operator_assignment] = STATE(2666),
    [sym_conditional] = STATE(2666),
    [sym_range] = STATE(2666),
    [sym_binary] = STATE(2666),
    [sym_unary] = STATE(2666),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1000] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1001] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4398),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1002] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(4396),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [1003] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2599),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(2600),
    [sym__argument] = STATE(2601),
    [sym_splat_argument] = STATE(2601),
    [sym_hash_splat_argument] = STATE(2601),
    [sym_block_argument] = STATE(2601),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2599),
    [sym_operator_assignment] = STATE(2599),
    [sym_conditional] = STATE(2599),
    [sym_range] = STATE(2599),
    [sym_binary] = STATE(2599),
    [sym_unary] = STATE(2599),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2602),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2601),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4312),
    [sym__splat_star] = ACTIONS(4314),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(4316),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(4318),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1004] = {
    [sym_heredoc_body] = STATE(2678),
    [aux_sym_call_repeat1] = STATE(2678),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1005] = {
    [sym_heredoc_body] = STATE(2678),
    [aux_sym_call_repeat1] = STATE(2678),
    [aux_sym_argument_list_repeat1] = STATE(2680),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1006] = {
    [anon_sym_EQ] = ACTIONS(4430),
    [sym_comment] = ACTIONS(87),
  },
  [1007] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4432),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4434),
    [anon_sym_DASH_EQ] = ACTIONS(4434),
    [anon_sym_STAR_EQ] = ACTIONS(4434),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4434),
    [anon_sym_SLASH_EQ] = ACTIONS(4434),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4434),
    [anon_sym_PIPE_EQ] = ACTIONS(4434),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4434),
    [anon_sym_AMP_EQ] = ACTIONS(4434),
    [anon_sym_PERCENT_EQ] = ACTIONS(4434),
    [anon_sym_GT_GT_EQ] = ACTIONS(4434),
    [anon_sym_LT_LT_EQ] = ACTIONS(4434),
    [anon_sym_CARET_EQ] = ACTIONS(4434),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1008] = {
    [sym_string] = STATE(2683),
    [aux_sym_chained_string_repeat1] = STATE(2683),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4436),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1009] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2688),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_splat_argument] = STATE(2689),
    [sym_assignment] = STATE(2688),
    [sym_operator_assignment] = STATE(2688),
    [sym_conditional] = STATE(2688),
    [sym_range] = STATE(2688),
    [sym_binary] = STATE(2688),
    [sym_unary] = STATE(2688),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(2689),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4438),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1010] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2692),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(2692),
    [sym_operator_assignment] = STATE(2692),
    [sym_conditional] = STATE(2692),
    [sym_range] = STATE(2692),
    [sym_binary] = STATE(2692),
    [sym_unary] = STATE(2692),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1011] = {
    [sym_string] = STATE(2693),
    [aux_sym_chained_string_repeat1] = STATE(2693),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [1012] = {
    [sym__statements] = STATE(2703),
    [sym__top_level_statement] = STATE(2704),
    [sym_begin_block] = STATE(2704),
    [sym_end_block] = STATE(2704),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(2706),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4452),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1013] = {
    [sym__simple_symbol] = ACTIONS(4366),
    [sym__string_start] = ACTIONS(4366),
    [sym__symbol_start] = ACTIONS(4366),
    [sym__subshell_start] = ACTIONS(4366),
    [sym__regex_start] = ACTIONS(4366),
    [sym__string_array_start] = ACTIONS(4366),
    [sym__symbol_array_start] = ACTIONS(4366),
    [sym_heredoc_beginning] = ACTIONS(4366),
    [sym__unary_minus] = ACTIONS(4366),
    [anon_sym_BEGIN] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(4366),
    [anon_sym_END] = ACTIONS(4368),
    [anon_sym_def] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4366),
    [anon_sym_COLON_COLON] = ACTIONS(4366),
    [anon_sym_SEMI] = ACTIONS(4366),
    [anon_sym_STAR] = ACTIONS(4366),
    [anon_sym_class] = ACTIONS(4368),
    [anon_sym_module] = ACTIONS(4368),
    [anon_sym_end] = ACTIONS(4368),
    [anon_sym_return] = ACTIONS(4368),
    [anon_sym_yield] = ACTIONS(4368),
    [anon_sym_break] = ACTIONS(4368),
    [anon_sym_next] = ACTIONS(4368),
    [sym_redo] = ACTIONS(4368),
    [sym_retry] = ACTIONS(4368),
    [anon_sym_if] = ACTIONS(4368),
    [anon_sym_unless] = ACTIONS(4368),
    [anon_sym_while] = ACTIONS(4368),
    [anon_sym_until] = ACTIONS(4368),
    [anon_sym_rescue] = ACTIONS(4368),
    [anon_sym_for] = ACTIONS(4368),
    [anon_sym_case] = ACTIONS(4368),
    [anon_sym_when] = ACTIONS(4368),
    [anon_sym_elsif] = ACTIONS(4368),
    [anon_sym_else] = ACTIONS(4368),
    [anon_sym_then] = ACTIONS(4476),
    [anon_sym_begin] = ACTIONS(4368),
    [anon_sym_ensure] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4368),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4366),
    [anon_sym_TILDE] = ACTIONS(4366),
    [sym_constant] = ACTIONS(4368),
    [sym_identifier] = ACTIONS(4368),
    [sym_instance_variable] = ACTIONS(4366),
    [sym_class_variable] = ACTIONS(4366),
    [sym_global_variable] = ACTIONS(4366),
    [anon_sym_undef] = ACTIONS(4368),
    [anon_sym_alias] = ACTIONS(4368),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4368),
    [sym_float] = ACTIONS(4368),
    [sym_complex] = ACTIONS(4366),
    [sym_super] = ACTIONS(4368),
    [anon_sym_true] = ACTIONS(4368),
    [anon_sym_TRUE] = ACTIONS(4368),
    [anon_sym_false] = ACTIONS(4368),
    [anon_sym_FALSE] = ACTIONS(4368),
    [sym_self] = ACTIONS(4368),
    [anon_sym_nil] = ACTIONS(4368),
    [anon_sym_NIL] = ACTIONS(4368),
    [sym_character] = ACTIONS(4366),
    [anon_sym_LBRACK2] = ACTIONS(4366),
    [anon_sym_DASH_GT] = ACTIONS(4366),
  },
  [1014] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1015] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2720),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(2720),
    [sym_operator_assignment] = STATE(2720),
    [sym_conditional] = STATE(2720),
    [sym_range] = STATE(2720),
    [sym_binary] = STATE(2720),
    [sym_unary] = STATE(2720),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1016] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2724),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(2724),
    [sym_operator_assignment] = STATE(2724),
    [sym_conditional] = STATE(2724),
    [sym_range] = STATE(2724),
    [sym_binary] = STATE(2724),
    [sym_unary] = STATE(2724),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1017] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2725),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(2725),
    [sym_operator_assignment] = STATE(2725),
    [sym_conditional] = STATE(2725),
    [sym_range] = STATE(2725),
    [sym_binary] = STATE(2725),
    [sym_unary] = STATE(2725),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1018] = {
    [anon_sym_COLON] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
  },
  [1019] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2728),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(2728),
    [sym_operator_assignment] = STATE(2728),
    [sym_conditional] = STATE(2728),
    [sym_range] = STATE(2728),
    [sym_binary] = STATE(2728),
    [sym_unary] = STATE(2728),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1020] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2734),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2735),
    [sym__argument] = STATE(2736),
    [sym_splat_argument] = STATE(2736),
    [sym_hash_splat_argument] = STATE(2736),
    [sym_block_argument] = STATE(2736),
    [sym_assignment] = STATE(2734),
    [sym_operator_assignment] = STATE(2734),
    [sym_conditional] = STATE(2734),
    [sym_range] = STATE(2734),
    [sym_binary] = STATE(2734),
    [sym_unary] = STATE(2734),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2737),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2736),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4500),
    [sym__splat_star] = ACTIONS(4502),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(4506),
    [sym_identifier] = ACTIONS(4506),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1021] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2734),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2735),
    [sym__argument] = STATE(2736),
    [sym_splat_argument] = STATE(2736),
    [sym_hash_splat_argument] = STATE(2736),
    [sym_block_argument] = STATE(2736),
    [sym_assignment] = STATE(2734),
    [sym_operator_assignment] = STATE(2734),
    [sym_conditional] = STATE(2734),
    [sym_range] = STATE(2734),
    [sym_binary] = STATE(2734),
    [sym_unary] = STATE(2734),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2737),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2736),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4500),
    [sym__splat_star] = ACTIONS(4502),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(4506),
    [sym_identifier] = ACTIONS(4506),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1022] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2734),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2735),
    [sym__argument] = STATE(2736),
    [sym_splat_argument] = STATE(2736),
    [sym_hash_splat_argument] = STATE(2736),
    [sym_block_argument] = STATE(2736),
    [sym_assignment] = STATE(2734),
    [sym_operator_assignment] = STATE(2734),
    [sym_conditional] = STATE(2734),
    [sym_range] = STATE(2734),
    [sym_binary] = STATE(2734),
    [sym_unary] = STATE(2734),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2737),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2736),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4500),
    [sym__splat_star] = ACTIONS(4502),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(4506),
    [sym_identifier] = ACTIONS(4506),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1023] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2734),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2735),
    [sym__argument] = STATE(2736),
    [sym_splat_argument] = STATE(2736),
    [sym_hash_splat_argument] = STATE(2736),
    [sym_block_argument] = STATE(2736),
    [sym_assignment] = STATE(2734),
    [sym_operator_assignment] = STATE(2734),
    [sym_conditional] = STATE(2734),
    [sym_range] = STATE(2734),
    [sym_binary] = STATE(2734),
    [sym_unary] = STATE(2734),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2737),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2736),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4500),
    [sym__splat_star] = ACTIONS(4502),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(4506),
    [sym_identifier] = ACTIONS(4506),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1024] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2738),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(2738),
    [sym_operator_assignment] = STATE(2738),
    [sym_conditional] = STATE(2738),
    [sym_range] = STATE(2738),
    [sym_binary] = STATE(2738),
    [sym_unary] = STATE(2738),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1025] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1026] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4508),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1027] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [1028] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2756),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(2757),
    [sym__argument] = STATE(2758),
    [sym_splat_argument] = STATE(2758),
    [sym_hash_splat_argument] = STATE(2758),
    [sym_block_argument] = STATE(2758),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2756),
    [sym_operator_assignment] = STATE(2756),
    [sym_conditional] = STATE(2756),
    [sym_range] = STATE(2756),
    [sym_binary] = STATE(2756),
    [sym_unary] = STATE(2756),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2759),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2758),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4536),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(4542),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4544),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1029] = {
    [sym_heredoc_body] = STATE(2760),
    [aux_sym_call_repeat1] = STATE(2760),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1030] = {
    [sym_heredoc_body] = STATE(2760),
    [aux_sym_call_repeat1] = STATE(2760),
    [aux_sym_argument_list_repeat1] = STATE(2762),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4546),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1031] = {
    [anon_sym_EQ] = ACTIONS(4548),
    [sym_comment] = ACTIONS(87),
  },
  [1032] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4550),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4552),
    [anon_sym_DASH_EQ] = ACTIONS(4552),
    [anon_sym_STAR_EQ] = ACTIONS(4552),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4552),
    [anon_sym_SLASH_EQ] = ACTIONS(4552),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4552),
    [anon_sym_PIPE_EQ] = ACTIONS(4552),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4552),
    [anon_sym_AMP_EQ] = ACTIONS(4552),
    [anon_sym_PERCENT_EQ] = ACTIONS(4552),
    [anon_sym_GT_GT_EQ] = ACTIONS(4552),
    [anon_sym_LT_LT_EQ] = ACTIONS(4552),
    [anon_sym_CARET_EQ] = ACTIONS(4552),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1033] = {
    [sym_string] = STATE(2765),
    [aux_sym_chained_string_repeat1] = STATE(2765),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4554),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1034] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [1035] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2766),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2766),
    [sym_operator_assignment] = STATE(2766),
    [sym_conditional] = STATE(2766),
    [sym_range] = STATE(2766),
    [sym_binary] = STATE(2766),
    [sym_unary] = STATE(2766),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1036] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2767),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2767),
    [sym_operator_assignment] = STATE(2767),
    [sym_conditional] = STATE(2767),
    [sym_range] = STATE(2767),
    [sym_binary] = STATE(2767),
    [sym_unary] = STATE(2767),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1037] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2768),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2768),
    [sym_operator_assignment] = STATE(2768),
    [sym_conditional] = STATE(2768),
    [sym_range] = STATE(2768),
    [sym_binary] = STATE(2768),
    [sym_unary] = STATE(2768),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1038] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2769),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2769),
    [sym_operator_assignment] = STATE(2769),
    [sym_conditional] = STATE(2769),
    [sym_range] = STATE(2769),
    [sym_binary] = STATE(2769),
    [sym_unary] = STATE(2769),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1039] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2770),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2770),
    [sym_operator_assignment] = STATE(2770),
    [sym_conditional] = STATE(2770),
    [sym_range] = STATE(2770),
    [sym_binary] = STATE(2770),
    [sym_unary] = STATE(2770),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1040] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1041] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2772),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2772),
    [sym_operator_assignment] = STATE(2772),
    [sym_conditional] = STATE(2772),
    [sym_range] = STATE(2772),
    [sym_binary] = STATE(2772),
    [sym_unary] = STATE(2772),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1042] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2773),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2773),
    [sym_operator_assignment] = STATE(2773),
    [sym_conditional] = STATE(2773),
    [sym_range] = STATE(2773),
    [sym_binary] = STATE(2773),
    [sym_unary] = STATE(2773),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1043] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2774),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2774),
    [sym_operator_assignment] = STATE(2774),
    [sym_conditional] = STATE(2774),
    [sym_range] = STATE(2774),
    [sym_binary] = STATE(2774),
    [sym_unary] = STATE(2774),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1044] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2775),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2775),
    [sym_operator_assignment] = STATE(2775),
    [sym_conditional] = STATE(2775),
    [sym_range] = STATE(2775),
    [sym_binary] = STATE(2775),
    [sym_unary] = STATE(2775),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1045] = {
    [sym__statements] = STATE(2777),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4556),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1046] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(2785),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(2785),
    [sym_operator_assignment] = STATE(2785),
    [sym_conditional] = STATE(2785),
    [sym_range] = STATE(2785),
    [sym_binary] = STATE(2785),
    [sym_unary] = STATE(2785),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1047] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(2790),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(2790),
    [sym_operator_assignment] = STATE(2790),
    [sym_conditional] = STATE(2790),
    [sym_range] = STATE(2790),
    [sym_binary] = STATE(2790),
    [sym_unary] = STATE(2790),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1048] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2791),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(2791),
    [sym_operator_assignment] = STATE(2791),
    [sym_conditional] = STATE(2791),
    [sym_range] = STATE(2791),
    [sym_binary] = STATE(2791),
    [sym_unary] = STATE(2791),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1049] = {
    [anon_sym_COLON] = ACTIONS(4582),
    [sym_comment] = ACTIONS(87),
  },
  [1050] = {
    [sym__statements] = STATE(1512),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(1513),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1519),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1520),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4584),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1051] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(2795),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(2795),
    [sym_operator_assignment] = STATE(2795),
    [sym_conditional] = STATE(2795),
    [sym_range] = STATE(2795),
    [sym_binary] = STATE(2795),
    [sym_unary] = STATE(2795),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1052] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2756),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(2757),
    [sym__argument] = STATE(2758),
    [sym_splat_argument] = STATE(2758),
    [sym_hash_splat_argument] = STATE(2758),
    [sym_block_argument] = STATE(2758),
    [sym_assignment] = STATE(2756),
    [sym_operator_assignment] = STATE(2756),
    [sym_conditional] = STATE(2756),
    [sym_range] = STATE(2756),
    [sym_binary] = STATE(2756),
    [sym_unary] = STATE(2756),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2759),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2758),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4536),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4544),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1053] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2756),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(2757),
    [sym__argument] = STATE(2758),
    [sym_splat_argument] = STATE(2758),
    [sym_hash_splat_argument] = STATE(2758),
    [sym_block_argument] = STATE(2758),
    [sym_assignment] = STATE(2756),
    [sym_operator_assignment] = STATE(2756),
    [sym_conditional] = STATE(2756),
    [sym_range] = STATE(2756),
    [sym_binary] = STATE(2756),
    [sym_unary] = STATE(2756),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2759),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2758),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4536),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4544),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1054] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2756),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(2757),
    [sym__argument] = STATE(2758),
    [sym_splat_argument] = STATE(2758),
    [sym_hash_splat_argument] = STATE(2758),
    [sym_block_argument] = STATE(2758),
    [sym_assignment] = STATE(2756),
    [sym_operator_assignment] = STATE(2756),
    [sym_conditional] = STATE(2756),
    [sym_range] = STATE(2756),
    [sym_binary] = STATE(2756),
    [sym_unary] = STATE(2756),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2759),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2758),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4536),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4544),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1055] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2756),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(2757),
    [sym__argument] = STATE(2758),
    [sym_splat_argument] = STATE(2758),
    [sym_hash_splat_argument] = STATE(2758),
    [sym_block_argument] = STATE(2758),
    [sym_assignment] = STATE(2756),
    [sym_operator_assignment] = STATE(2756),
    [sym_conditional] = STATE(2756),
    [sym_range] = STATE(2756),
    [sym_binary] = STATE(2756),
    [sym_unary] = STATE(2756),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2759),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2758),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4536),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4544),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1056] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2796),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(2796),
    [sym_operator_assignment] = STATE(2796),
    [sym_conditional] = STATE(2796),
    [sym_range] = STATE(2796),
    [sym_binary] = STATE(2796),
    [sym_unary] = STATE(2796),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1057] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1058] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1059] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [1060] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2756),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(2757),
    [sym__argument] = STATE(2758),
    [sym_splat_argument] = STATE(2758),
    [sym_hash_splat_argument] = STATE(2758),
    [sym_block_argument] = STATE(2758),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2756),
    [sym_operator_assignment] = STATE(2756),
    [sym_conditional] = STATE(2756),
    [sym_range] = STATE(2756),
    [sym_binary] = STATE(2756),
    [sym_unary] = STATE(2756),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2759),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2758),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4536),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4544),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1061] = {
    [sym_do_block] = STATE(1580),
    [sym_block] = STATE(1580),
    [sym__line_break] = ACTIONS(2725),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [ts_builtin_sym_end] = ACTIONS(2725),
    [anon_sym___END__] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2727),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_end] = ACTIONS(2725),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_when] = ACTIONS(2725),
    [anon_sym_elsif] = ACTIONS(2725),
    [anon_sym_else] = ACTIONS(2725),
    [anon_sym_then] = ACTIONS(2725),
    [anon_sym_ensure] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [1062] = {
    [sym_heredoc_body] = STATE(2808),
    [aux_sym_call_repeat1] = STATE(2808),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1063] = {
    [sym_heredoc_body] = STATE(2808),
    [aux_sym_call_repeat1] = STATE(2808),
    [aux_sym_argument_list_repeat1] = STATE(2810),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4616),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1064] = {
    [anon_sym_EQ] = ACTIONS(4618),
    [sym_comment] = ACTIONS(87),
  },
  [1065] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4620),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4622),
    [anon_sym_DASH_EQ] = ACTIONS(4622),
    [anon_sym_STAR_EQ] = ACTIONS(4622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4622),
    [anon_sym_SLASH_EQ] = ACTIONS(4622),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4622),
    [anon_sym_PIPE_EQ] = ACTIONS(4622),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4622),
    [anon_sym_AMP_EQ] = ACTIONS(4622),
    [anon_sym_PERCENT_EQ] = ACTIONS(4622),
    [anon_sym_GT_GT_EQ] = ACTIONS(4622),
    [anon_sym_LT_LT_EQ] = ACTIONS(4622),
    [anon_sym_CARET_EQ] = ACTIONS(4622),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1066] = {
    [sym_string] = STATE(2813),
    [aux_sym_chained_string_repeat1] = STATE(2813),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4624),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1067] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2818),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_splat_argument] = STATE(2819),
    [sym_assignment] = STATE(2818),
    [sym_operator_assignment] = STATE(2818),
    [sym_conditional] = STATE(2818),
    [sym_range] = STATE(2818),
    [sym_binary] = STATE(2818),
    [sym_unary] = STATE(2818),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(2819),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4626),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1068] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2822),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2822),
    [sym_operator_assignment] = STATE(2822),
    [sym_conditional] = STATE(2822),
    [sym_range] = STATE(2822),
    [sym_binary] = STATE(2822),
    [sym_unary] = STATE(2822),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1069] = {
    [sym_string] = STATE(2823),
    [aux_sym_chained_string_repeat1] = STATE(2823),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [1070] = {
    [sym__statements] = STATE(2825),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4638),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1071] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2833),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(2833),
    [sym_operator_assignment] = STATE(2833),
    [sym_conditional] = STATE(2833),
    [sym_range] = STATE(2833),
    [sym_binary] = STATE(2833),
    [sym_unary] = STATE(2833),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1072] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2838),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(2838),
    [sym_operator_assignment] = STATE(2838),
    [sym_conditional] = STATE(2838),
    [sym_range] = STATE(2838),
    [sym_binary] = STATE(2838),
    [sym_unary] = STATE(2838),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1073] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2839),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(2839),
    [sym_operator_assignment] = STATE(2839),
    [sym_conditional] = STATE(2839),
    [sym_range] = STATE(2839),
    [sym_binary] = STATE(2839),
    [sym_unary] = STATE(2839),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1074] = {
    [anon_sym_COLON] = ACTIONS(4662),
    [sym_comment] = ACTIONS(87),
  },
  [1075] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(2842),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(2842),
    [sym_operator_assignment] = STATE(2842),
    [sym_conditional] = STATE(2842),
    [sym_range] = STATE(2842),
    [sym_binary] = STATE(2842),
    [sym_unary] = STATE(2842),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1076] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2848),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(2849),
    [sym__argument] = STATE(2850),
    [sym_splat_argument] = STATE(2850),
    [sym_hash_splat_argument] = STATE(2850),
    [sym_block_argument] = STATE(2850),
    [sym_assignment] = STATE(2848),
    [sym_operator_assignment] = STATE(2848),
    [sym_conditional] = STATE(2848),
    [sym_range] = STATE(2848),
    [sym_binary] = STATE(2848),
    [sym_unary] = STATE(2848),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2851),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2850),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4664),
    [sym__splat_star] = ACTIONS(4666),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4668),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(4672),
    [sym_identifier] = ACTIONS(4672),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1077] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2848),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(2849),
    [sym__argument] = STATE(2850),
    [sym_splat_argument] = STATE(2850),
    [sym_hash_splat_argument] = STATE(2850),
    [sym_block_argument] = STATE(2850),
    [sym_assignment] = STATE(2848),
    [sym_operator_assignment] = STATE(2848),
    [sym_conditional] = STATE(2848),
    [sym_range] = STATE(2848),
    [sym_binary] = STATE(2848),
    [sym_unary] = STATE(2848),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2851),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2850),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4664),
    [sym__splat_star] = ACTIONS(4666),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4668),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(4672),
    [sym_identifier] = ACTIONS(4672),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1078] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2848),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(2849),
    [sym__argument] = STATE(2850),
    [sym_splat_argument] = STATE(2850),
    [sym_hash_splat_argument] = STATE(2850),
    [sym_block_argument] = STATE(2850),
    [sym_assignment] = STATE(2848),
    [sym_operator_assignment] = STATE(2848),
    [sym_conditional] = STATE(2848),
    [sym_range] = STATE(2848),
    [sym_binary] = STATE(2848),
    [sym_unary] = STATE(2848),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2851),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2850),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4664),
    [sym__splat_star] = ACTIONS(4666),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4668),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(4672),
    [sym_identifier] = ACTIONS(4672),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1079] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2848),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(2849),
    [sym__argument] = STATE(2850),
    [sym_splat_argument] = STATE(2850),
    [sym_hash_splat_argument] = STATE(2850),
    [sym_block_argument] = STATE(2850),
    [sym_assignment] = STATE(2848),
    [sym_operator_assignment] = STATE(2848),
    [sym_conditional] = STATE(2848),
    [sym_range] = STATE(2848),
    [sym_binary] = STATE(2848),
    [sym_unary] = STATE(2848),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2851),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(2850),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4664),
    [sym__splat_star] = ACTIONS(4666),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4668),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(4672),
    [sym_identifier] = ACTIONS(4672),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1080] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2852),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(2852),
    [sym_operator_assignment] = STATE(2852),
    [sym_conditional] = STATE(2852),
    [sym_range] = STATE(2852),
    [sym_binary] = STATE(2852),
    [sym_unary] = STATE(2852),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1081] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1082] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4674),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1083] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(4662),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(4692),
    [anon_sym_or] = ACTIONS(4692),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [1084] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2876),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_argument_list] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(2877),
    [sym__argument] = STATE(2878),
    [sym_splat_argument] = STATE(2878),
    [sym_hash_splat_argument] = STATE(2878),
    [sym_block_argument] = STATE(2878),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(2876),
    [sym_operator_assignment] = STATE(2876),
    [sym_conditional] = STATE(2876),
    [sym_range] = STATE(2876),
    [sym_binary] = STATE(2876),
    [sym_unary] = STATE(2876),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2881),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2878),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4704),
    [sym__splat_star] = ACTIONS(4706),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(4710),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4724),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(4728),
    [sym_identifier] = ACTIONS(4728),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1085] = {
    [sym_heredoc_body] = STATE(2882),
    [aux_sym_call_repeat1] = STATE(2882),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1086] = {
    [sym_heredoc_body] = STATE(2882),
    [aux_sym_call_repeat1] = STATE(2882),
    [aux_sym_argument_list_repeat1] = STATE(2884),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_COMMA] = ACTIONS(4730),
    [anon_sym_in] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1087] = {
    [anon_sym_EQ] = ACTIONS(4732),
    [sym_comment] = ACTIONS(87),
  },
  [1088] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4734),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4736),
    [anon_sym_DASH_EQ] = ACTIONS(4736),
    [anon_sym_STAR_EQ] = ACTIONS(4736),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4736),
    [anon_sym_SLASH_EQ] = ACTIONS(4736),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4736),
    [anon_sym_PIPE_EQ] = ACTIONS(4736),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4736),
    [anon_sym_AMP_EQ] = ACTIONS(4736),
    [anon_sym_PERCENT_EQ] = ACTIONS(4736),
    [anon_sym_GT_GT_EQ] = ACTIONS(4736),
    [anon_sym_LT_LT_EQ] = ACTIONS(4736),
    [anon_sym_CARET_EQ] = ACTIONS(4736),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1089] = {
    [sym_string] = STATE(2887),
    [aux_sym_chained_string_repeat1] = STATE(2887),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4738),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1090] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2888),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(2888),
    [sym_operator_assignment] = STATE(2888),
    [sym_conditional] = STATE(2888),
    [sym_range] = STATE(2888),
    [sym_binary] = STATE(2888),
    [sym_unary] = STATE(2888),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1091] = {
    [sym__do] = STATE(2889),
    [sym_heredoc_body] = STATE(2889),
    [sym__terminator] = STATE(2889),
    [sym__line_break] = ACTIONS(4740),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(4740),
    [anon_sym_do] = ACTIONS(4740),
    [sym_comment] = ACTIONS(87),
  },
  [1092] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(1597),
    [sym__simple_mlhs] = STATE(257),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_in] = ACTIONS(4742),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [1093] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1094] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2897),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(2897),
    [sym_operator_assignment] = STATE(2897),
    [sym_conditional] = STATE(2897),
    [sym_range] = STATE(2897),
    [sym_binary] = STATE(2897),
    [sym_unary] = STATE(2897),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1095] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2901),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(2901),
    [sym_operator_assignment] = STATE(2901),
    [sym_conditional] = STATE(2901),
    [sym_range] = STATE(2901),
    [sym_binary] = STATE(2901),
    [sym_unary] = STATE(2901),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1096] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2902),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(2902),
    [sym_operator_assignment] = STATE(2902),
    [sym_conditional] = STATE(2902),
    [sym_range] = STATE(2902),
    [sym_binary] = STATE(2902),
    [sym_unary] = STATE(2902),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1097] = {
    [anon_sym_COLON] = ACTIONS(4764),
    [sym_comment] = ACTIONS(87),
  },
  [1098] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2905),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(2905),
    [sym_operator_assignment] = STATE(2905),
    [sym_conditional] = STATE(2905),
    [sym_range] = STATE(2905),
    [sym_binary] = STATE(2905),
    [sym_unary] = STATE(2905),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1099] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2911),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2912),
    [sym__argument] = STATE(2913),
    [sym_splat_argument] = STATE(2913),
    [sym_hash_splat_argument] = STATE(2913),
    [sym_block_argument] = STATE(2913),
    [sym_assignment] = STATE(2911),
    [sym_operator_assignment] = STATE(2911),
    [sym_conditional] = STATE(2911),
    [sym_range] = STATE(2911),
    [sym_binary] = STATE(2911),
    [sym_unary] = STATE(2911),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2913),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4766),
    [sym__splat_star] = ACTIONS(4768),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4770),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(4772),
    [sym_identifier] = ACTIONS(4772),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1100] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2911),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2912),
    [sym__argument] = STATE(2913),
    [sym_splat_argument] = STATE(2913),
    [sym_hash_splat_argument] = STATE(2913),
    [sym_block_argument] = STATE(2913),
    [sym_assignment] = STATE(2911),
    [sym_operator_assignment] = STATE(2911),
    [sym_conditional] = STATE(2911),
    [sym_range] = STATE(2911),
    [sym_binary] = STATE(2911),
    [sym_unary] = STATE(2911),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2913),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4766),
    [sym__splat_star] = ACTIONS(4768),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4770),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(4772),
    [sym_identifier] = ACTIONS(4772),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1101] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2911),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2912),
    [sym__argument] = STATE(2913),
    [sym_splat_argument] = STATE(2913),
    [sym_hash_splat_argument] = STATE(2913),
    [sym_block_argument] = STATE(2913),
    [sym_assignment] = STATE(2911),
    [sym_operator_assignment] = STATE(2911),
    [sym_conditional] = STATE(2911),
    [sym_range] = STATE(2911),
    [sym_binary] = STATE(2911),
    [sym_unary] = STATE(2911),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2913),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4766),
    [sym__splat_star] = ACTIONS(4768),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4770),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(4772),
    [sym_identifier] = ACTIONS(4772),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1102] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2911),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2912),
    [sym__argument] = STATE(2913),
    [sym_splat_argument] = STATE(2913),
    [sym_hash_splat_argument] = STATE(2913),
    [sym_block_argument] = STATE(2913),
    [sym_assignment] = STATE(2911),
    [sym_operator_assignment] = STATE(2911),
    [sym_conditional] = STATE(2911),
    [sym_range] = STATE(2911),
    [sym_binary] = STATE(2911),
    [sym_unary] = STATE(2911),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2913),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4766),
    [sym__splat_star] = ACTIONS(4768),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4770),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(4772),
    [sym_identifier] = ACTIONS(4772),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1103] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2915),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(2915),
    [sym_operator_assignment] = STATE(2915),
    [sym_conditional] = STATE(2915),
    [sym_range] = STATE(2915),
    [sym_binary] = STATE(2915),
    [sym_unary] = STATE(2915),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1104] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1105] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4774),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1106] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(4764),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [1107] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2756),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(2757),
    [sym__argument] = STATE(2758),
    [sym_splat_argument] = STATE(2758),
    [sym_hash_splat_argument] = STATE(2758),
    [sym_block_argument] = STATE(2758),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(2756),
    [sym_operator_assignment] = STATE(2756),
    [sym_conditional] = STATE(2756),
    [sym_range] = STATE(2756),
    [sym_binary] = STATE(2756),
    [sym_unary] = STATE(2756),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2759),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(2758),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4536),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4544),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1108] = {
    [sym_heredoc_body] = STATE(2927),
    [aux_sym_call_repeat1] = STATE(2927),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1109] = {
    [sym_heredoc_body] = STATE(2927),
    [aux_sym_call_repeat1] = STATE(2927),
    [aux_sym_argument_list_repeat1] = STATE(2929),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4802),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1110] = {
    [anon_sym_EQ] = ACTIONS(4804),
    [sym_comment] = ACTIONS(87),
  },
  [1111] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4806),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4808),
    [anon_sym_DASH_EQ] = ACTIONS(4808),
    [anon_sym_STAR_EQ] = ACTIONS(4808),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4808),
    [anon_sym_SLASH_EQ] = ACTIONS(4808),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4808),
    [anon_sym_PIPE_EQ] = ACTIONS(4808),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4808),
    [anon_sym_AMP_EQ] = ACTIONS(4808),
    [anon_sym_PERCENT_EQ] = ACTIONS(4808),
    [anon_sym_GT_GT_EQ] = ACTIONS(4808),
    [anon_sym_LT_LT_EQ] = ACTIONS(4808),
    [anon_sym_CARET_EQ] = ACTIONS(4808),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1112] = {
    [sym_string] = STATE(2932),
    [aux_sym_chained_string_repeat1] = STATE(2932),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1113] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [1114] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2933),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2933),
    [sym_operator_assignment] = STATE(2933),
    [sym_conditional] = STATE(2933),
    [sym_range] = STATE(2933),
    [sym_binary] = STATE(2933),
    [sym_unary] = STATE(2933),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1115] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2934),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2934),
    [sym_operator_assignment] = STATE(2934),
    [sym_conditional] = STATE(2934),
    [sym_range] = STATE(2934),
    [sym_binary] = STATE(2934),
    [sym_unary] = STATE(2934),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1116] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2935),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2935),
    [sym_operator_assignment] = STATE(2935),
    [sym_conditional] = STATE(2935),
    [sym_range] = STATE(2935),
    [sym_binary] = STATE(2935),
    [sym_unary] = STATE(2935),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1117] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2936),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2936),
    [sym_operator_assignment] = STATE(2936),
    [sym_conditional] = STATE(2936),
    [sym_range] = STATE(2936),
    [sym_binary] = STATE(2936),
    [sym_unary] = STATE(2936),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1118] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2937),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2937),
    [sym_operator_assignment] = STATE(2937),
    [sym_conditional] = STATE(2937),
    [sym_range] = STATE(2937),
    [sym_binary] = STATE(2937),
    [sym_unary] = STATE(2937),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1119] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(2938),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(2938),
    [sym_operator_assignment] = STATE(2938),
    [sym_conditional] = STATE(2938),
    [sym_range] = STATE(2938),
    [sym_binary] = STATE(2938),
    [sym_unary] = STATE(2938),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1120] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2939),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2939),
    [sym_operator_assignment] = STATE(2939),
    [sym_conditional] = STATE(2939),
    [sym_range] = STATE(2939),
    [sym_binary] = STATE(2939),
    [sym_unary] = STATE(2939),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1121] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2940),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2940),
    [sym_operator_assignment] = STATE(2940),
    [sym_conditional] = STATE(2940),
    [sym_range] = STATE(2940),
    [sym_binary] = STATE(2940),
    [sym_unary] = STATE(2940),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1122] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2941),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2941),
    [sym_operator_assignment] = STATE(2941),
    [sym_conditional] = STATE(2941),
    [sym_range] = STATE(2941),
    [sym_binary] = STATE(2941),
    [sym_unary] = STATE(2941),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1123] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2942),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2942),
    [sym_operator_assignment] = STATE(2942),
    [sym_conditional] = STATE(2942),
    [sym_range] = STATE(2942),
    [sym_binary] = STATE(2942),
    [sym_unary] = STATE(2942),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1124] = {
    [sym_when] = STATE(2943),
    [aux_sym_case_repeat1] = STATE(2944),
    [anon_sym_SEMI] = ACTIONS(4812),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1125] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2949),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_splat_argument] = STATE(2950),
    [sym_assignment] = STATE(2949),
    [sym_operator_assignment] = STATE(2949),
    [sym_conditional] = STATE(2949),
    [sym_range] = STATE(2949),
    [sym_binary] = STATE(2949),
    [sym_unary] = STATE(2949),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(2950),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4814),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1126] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2953),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(2953),
    [sym_operator_assignment] = STATE(2953),
    [sym_conditional] = STATE(2953),
    [sym_range] = STATE(2953),
    [sym_binary] = STATE(2953),
    [sym_unary] = STATE(2953),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1127] = {
    [sym_string] = STATE(2954),
    [aux_sym_chained_string_repeat1] = STATE(2954),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [1128] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_pattern] = STATE(2963),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2964),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_splat_argument] = STATE(2966),
    [sym_assignment] = STATE(2964),
    [sym_operator_assignment] = STATE(2964),
    [sym_conditional] = STATE(2964),
    [sym_range] = STATE(2964),
    [sym_binary] = STATE(2964),
    [sym_unary] = STATE(2964),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4826),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1129] = {
    [anon_sym_end] = ACTIONS(4850),
    [sym_comment] = ACTIONS(87),
  },
  [1130] = {
    [sym_when] = STATE(2943),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1131] = {
    [sym__simple_symbol] = ACTIONS(3102),
    [sym__string_start] = ACTIONS(3102),
    [sym__symbol_start] = ACTIONS(3102),
    [sym__subshell_start] = ACTIONS(3102),
    [sym__regex_start] = ACTIONS(3102),
    [sym__string_array_start] = ACTIONS(3102),
    [sym__symbol_array_start] = ACTIONS(3102),
    [sym_heredoc_beginning] = ACTIONS(3102),
    [sym__unary_minus] = ACTIONS(3102),
    [ts_builtin_sym_end] = ACTIONS(3102),
    [anon_sym___END__] = ACTIONS(4854),
    [anon_sym_BEGIN] = ACTIONS(4854),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_END] = ACTIONS(4854),
    [anon_sym_def] = ACTIONS(4854),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(4854),
    [anon_sym_module] = ACTIONS(4854),
    [anon_sym_end] = ACTIONS(4854),
    [anon_sym_return] = ACTIONS(4854),
    [anon_sym_yield] = ACTIONS(4854),
    [anon_sym_break] = ACTIONS(4854),
    [anon_sym_next] = ACTIONS(4854),
    [sym_redo] = ACTIONS(4854),
    [sym_retry] = ACTIONS(4854),
    [anon_sym_if] = ACTIONS(4854),
    [anon_sym_unless] = ACTIONS(4854),
    [anon_sym_while] = ACTIONS(4854),
    [anon_sym_until] = ACTIONS(4854),
    [anon_sym_rescue] = ACTIONS(4854),
    [anon_sym_for] = ACTIONS(4854),
    [anon_sym_case] = ACTIONS(4854),
    [anon_sym_when] = ACTIONS(4854),
    [anon_sym_elsif] = ACTIONS(4854),
    [anon_sym_else] = ACTIONS(4854),
    [anon_sym_then] = ACTIONS(4854),
    [anon_sym_begin] = ACTIONS(4854),
    [anon_sym_ensure] = ACTIONS(4854),
    [anon_sym_PLUS] = ACTIONS(4854),
    [anon_sym_defined_QMARK] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(4854),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [sym_constant] = ACTIONS(4854),
    [sym_identifier] = ACTIONS(4854),
    [sym_instance_variable] = ACTIONS(3102),
    [sym_class_variable] = ACTIONS(3102),
    [sym_global_variable] = ACTIONS(3102),
    [anon_sym_undef] = ACTIONS(4854),
    [anon_sym_alias] = ACTIONS(4854),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4854),
    [sym_float] = ACTIONS(4854),
    [sym_complex] = ACTIONS(3102),
    [sym_super] = ACTIONS(4854),
    [anon_sym_true] = ACTIONS(4854),
    [anon_sym_TRUE] = ACTIONS(4854),
    [anon_sym_false] = ACTIONS(4854),
    [anon_sym_FALSE] = ACTIONS(4854),
    [sym_self] = ACTIONS(4854),
    [anon_sym_nil] = ACTIONS(4854),
    [anon_sym_NIL] = ACTIONS(4854),
    [sym_character] = ACTIONS(3102),
    [anon_sym_LBRACK2] = ACTIONS(3102),
    [anon_sym_DASH_GT] = ACTIONS(3102),
  },
  [1132] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(4856),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [1133] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1134] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2980),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(2980),
    [sym_operator_assignment] = STATE(2980),
    [sym_conditional] = STATE(2980),
    [sym_range] = STATE(2980),
    [sym_binary] = STATE(2980),
    [sym_unary] = STATE(2980),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1135] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2984),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(2984),
    [sym_operator_assignment] = STATE(2984),
    [sym_conditional] = STATE(2984),
    [sym_range] = STATE(2984),
    [sym_binary] = STATE(2984),
    [sym_unary] = STATE(2984),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1136] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2985),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(2985),
    [sym_operator_assignment] = STATE(2985),
    [sym_conditional] = STATE(2985),
    [sym_range] = STATE(2985),
    [sym_binary] = STATE(2985),
    [sym_unary] = STATE(2985),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1137] = {
    [anon_sym_COLON] = ACTIONS(4878),
    [sym_comment] = ACTIONS(87),
  },
  [1138] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2988),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(2988),
    [sym_operator_assignment] = STATE(2988),
    [sym_conditional] = STATE(2988),
    [sym_range] = STATE(2988),
    [sym_binary] = STATE(2988),
    [sym_unary] = STATE(2988),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1139] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2994),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(2995),
    [sym__argument] = STATE(2996),
    [sym_splat_argument] = STATE(2996),
    [sym_hash_splat_argument] = STATE(2996),
    [sym_block_argument] = STATE(2996),
    [sym_assignment] = STATE(2994),
    [sym_operator_assignment] = STATE(2994),
    [sym_conditional] = STATE(2994),
    [sym_range] = STATE(2994),
    [sym_binary] = STATE(2994),
    [sym_unary] = STATE(2994),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2997),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2996),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4880),
    [sym__splat_star] = ACTIONS(4882),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4884),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(4886),
    [sym_identifier] = ACTIONS(4886),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1140] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2994),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2995),
    [sym__argument] = STATE(2996),
    [sym_splat_argument] = STATE(2996),
    [sym_hash_splat_argument] = STATE(2996),
    [sym_block_argument] = STATE(2996),
    [sym_assignment] = STATE(2994),
    [sym_operator_assignment] = STATE(2994),
    [sym_conditional] = STATE(2994),
    [sym_range] = STATE(2994),
    [sym_binary] = STATE(2994),
    [sym_unary] = STATE(2994),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2997),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2996),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4880),
    [sym__splat_star] = ACTIONS(4882),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4884),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(4886),
    [sym_identifier] = ACTIONS(4886),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1141] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2994),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(2995),
    [sym__argument] = STATE(2996),
    [sym_splat_argument] = STATE(2996),
    [sym_hash_splat_argument] = STATE(2996),
    [sym_block_argument] = STATE(2996),
    [sym_assignment] = STATE(2994),
    [sym_operator_assignment] = STATE(2994),
    [sym_conditional] = STATE(2994),
    [sym_range] = STATE(2994),
    [sym_binary] = STATE(2994),
    [sym_unary] = STATE(2994),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2997),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2996),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4880),
    [sym__splat_star] = ACTIONS(4882),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4884),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(4886),
    [sym_identifier] = ACTIONS(4886),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1142] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2994),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(2995),
    [sym__argument] = STATE(2996),
    [sym_splat_argument] = STATE(2996),
    [sym_hash_splat_argument] = STATE(2996),
    [sym_block_argument] = STATE(2996),
    [sym_assignment] = STATE(2994),
    [sym_operator_assignment] = STATE(2994),
    [sym_conditional] = STATE(2994),
    [sym_range] = STATE(2994),
    [sym_binary] = STATE(2994),
    [sym_unary] = STATE(2994),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2997),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2996),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4880),
    [sym__splat_star] = ACTIONS(4882),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4884),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(4886),
    [sym_identifier] = ACTIONS(4886),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1143] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2998),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(2998),
    [sym_operator_assignment] = STATE(2998),
    [sym_conditional] = STATE(2998),
    [sym_range] = STATE(2998),
    [sym_binary] = STATE(2998),
    [sym_unary] = STATE(2998),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1144] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1145] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(4888),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1146] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_ensure] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(4878),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [1147] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3015),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(3016),
    [sym__argument] = STATE(3017),
    [sym_splat_argument] = STATE(3017),
    [sym_hash_splat_argument] = STATE(3017),
    [sym_block_argument] = STATE(3017),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3015),
    [sym_operator_assignment] = STATE(3015),
    [sym_conditional] = STATE(3015),
    [sym_range] = STATE(3015),
    [sym_binary] = STATE(3015),
    [sym_unary] = STATE(3015),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3018),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3017),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4916),
    [sym__splat_star] = ACTIONS(4918),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(771),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(4922),
    [sym_identifier] = ACTIONS(4922),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1148] = {
    [sym_heredoc_body] = STATE(3019),
    [aux_sym_call_repeat1] = STATE(3019),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1149] = {
    [sym_heredoc_body] = STATE(3019),
    [aux_sym_call_repeat1] = STATE(3019),
    [aux_sym_argument_list_repeat1] = STATE(3021),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4924),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1150] = {
    [anon_sym_EQ] = ACTIONS(4926),
    [sym_comment] = ACTIONS(87),
  },
  [1151] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4928),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4930),
    [anon_sym_DASH_EQ] = ACTIONS(4930),
    [anon_sym_STAR_EQ] = ACTIONS(4930),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4930),
    [anon_sym_SLASH_EQ] = ACTIONS(4930),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4930),
    [anon_sym_PIPE_EQ] = ACTIONS(4930),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4930),
    [anon_sym_AMP_EQ] = ACTIONS(4930),
    [anon_sym_PERCENT_EQ] = ACTIONS(4930),
    [anon_sym_GT_GT_EQ] = ACTIONS(4930),
    [anon_sym_LT_LT_EQ] = ACTIONS(4930),
    [anon_sym_CARET_EQ] = ACTIONS(4930),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1152] = {
    [sym_string] = STATE(3024),
    [aux_sym_chained_string_repeat1] = STATE(3024),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4932),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1153] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3025),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(3025),
    [sym_operator_assignment] = STATE(3025),
    [sym_conditional] = STATE(3025),
    [sym_range] = STATE(3025),
    [sym_binary] = STATE(3025),
    [sym_unary] = STATE(3025),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1154] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3026),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(3026),
    [sym_operator_assignment] = STATE(3026),
    [sym_conditional] = STATE(3026),
    [sym_range] = STATE(3026),
    [sym_binary] = STATE(3026),
    [sym_unary] = STATE(3026),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1155] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3036),
    [sym__argument] = STATE(3037),
    [sym_splat_argument] = STATE(3037),
    [sym_hash_splat_argument] = STATE(3037),
    [sym_block_argument] = STATE(3037),
    [sym_assignment] = STATE(3035),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3040),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3037),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4934),
    [sym__splat_star] = ACTIONS(4936),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4940),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(4950),
    [sym_identifier] = ACTIONS(4950),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1156] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3036),
    [sym__argument] = STATE(3037),
    [sym_splat_argument] = STATE(3037),
    [sym_hash_splat_argument] = STATE(3037),
    [sym_block_argument] = STATE(3037),
    [sym_assignment] = STATE(3035),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3040),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3037),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4934),
    [sym__splat_star] = ACTIONS(4936),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4940),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(4950),
    [sym_identifier] = ACTIONS(4950),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1157] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3036),
    [sym__argument] = STATE(3037),
    [sym_splat_argument] = STATE(3037),
    [sym_hash_splat_argument] = STATE(3037),
    [sym_block_argument] = STATE(3037),
    [sym_assignment] = STATE(3035),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3040),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3037),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4934),
    [sym__splat_star] = ACTIONS(4936),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4940),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(4950),
    [sym_identifier] = ACTIONS(4950),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1158] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3036),
    [sym__argument] = STATE(3037),
    [sym_splat_argument] = STATE(3037),
    [sym_hash_splat_argument] = STATE(3037),
    [sym_block_argument] = STATE(3037),
    [sym_assignment] = STATE(3035),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3040),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3037),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4934),
    [sym__splat_star] = ACTIONS(4936),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4940),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(4950),
    [sym_identifier] = ACTIONS(4950),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1159] = {
    [sym_method] = STATE(3044),
    [sym_singleton_method] = STATE(3044),
    [sym_class] = STATE(3044),
    [sym_singleton_class] = STATE(3044),
    [sym_module] = STATE(3044),
    [sym_return] = STATE(3044),
    [sym_yield] = STATE(3044),
    [sym_break] = STATE(3044),
    [sym_next] = STATE(3044),
    [sym_while] = STATE(3044),
    [sym_until] = STATE(3044),
    [sym_for] = STATE(3044),
    [sym_case] = STATE(3044),
    [sym_if] = STATE(3044),
    [sym_unless] = STATE(3044),
    [sym_begin] = STATE(3044),
    [sym__primary] = STATE(3044),
    [sym_parenthesized_statements] = STATE(3044),
    [sym_element_reference] = STATE(3046),
    [sym_scope_resolution] = STATE(3045),
    [sym_call] = STATE(3045),
    [sym_method_call] = STATE(3046),
    [sym__lhs] = STATE(3046),
    [sym__variable] = STATE(3045),
    [sym_rational] = STATE(3044),
    [sym_true] = STATE(3046),
    [sym_false] = STATE(3046),
    [sym_nil] = STATE(3046),
    [sym_chained_string] = STATE(3044),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(3044),
    [sym_string_array] = STATE(3044),
    [sym_symbol_array] = STATE(3044),
    [sym_symbol] = STATE(3044),
    [sym_regex] = STATE(3044),
    [sym_array] = STATE(3044),
    [sym_hash] = STATE(3044),
    [sym_lambda] = STATE(3044),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(4952),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(4954),
    [sym_retry] = ACTIONS(4954),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(4956),
    [sym_identifier] = ACTIONS(4956),
    [sym_instance_variable] = ACTIONS(4958),
    [sym_class_variable] = ACTIONS(4958),
    [sym_global_variable] = ACTIONS(4958),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(4954),
    [sym_complex] = ACTIONS(4952),
    [sym_super] = ACTIONS(4956),
    [anon_sym_true] = ACTIONS(4960),
    [anon_sym_TRUE] = ACTIONS(4960),
    [anon_sym_false] = ACTIONS(4962),
    [anon_sym_FALSE] = ACTIONS(4962),
    [sym_self] = ACTIONS(4956),
    [anon_sym_nil] = ACTIONS(4964),
    [anon_sym_NIL] = ACTIONS(4964),
    [sym_character] = ACTIONS(4952),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [1160] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3047),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(3047),
    [sym_operator_assignment] = STATE(3047),
    [sym_conditional] = STATE(3047),
    [sym_range] = STATE(3047),
    [sym_binary] = STATE(3047),
    [sym_unary] = STATE(3047),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1161] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1162] = {
    [sym__statements] = STATE(3048),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym_rescue] = STATE(3049),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4966),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(4966),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1163] = {
    [sym__then] = STATE(3050),
    [sym_exception_variable] = STATE(3051),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_then] = ACTIONS(4968),
    [anon_sym_EQ_GT] = ACTIONS(2095),
    [sym_comment] = ACTIONS(87),
  },
  [1164] = {
    [sym__then] = STATE(3050),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_then] = ACTIONS(4968),
    [sym_comment] = ACTIONS(87),
  },
  [1165] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_and] = ACTIONS(4988),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_EQ_TILDE] = ACTIONS(4990),
    [anon_sym_BANG_TILDE] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [1166] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3074),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(3076),
    [sym__argument] = STATE(3077),
    [sym_splat_argument] = STATE(3077),
    [sym_hash_splat_argument] = STATE(3077),
    [sym_block_argument] = STATE(3077),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3074),
    [sym_operator_assignment] = STATE(3074),
    [sym_conditional] = STATE(3074),
    [sym_range] = STATE(3074),
    [sym_binary] = STATE(3074),
    [sym_unary] = STATE(3074),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3080),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3077),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5000),
    [sym__splat_star] = ACTIONS(5002),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5024),
    [sym_identifier] = ACTIONS(5024),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1167] = {
    [aux_sym_exceptions_repeat1] = STATE(3082),
    [sym__line_break] = ACTIONS(5030),
    [sym__heredoc_body_start] = ACTIONS(5030),
    [anon_sym_COMMA] = ACTIONS(5032),
    [anon_sym_SEMI] = ACTIONS(5030),
    [anon_sym_then] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [sym_comment] = ACTIONS(87),
  },
  [1168] = {
    [anon_sym_EQ] = ACTIONS(5034),
    [sym_comment] = ACTIONS(87),
  },
  [1169] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5036),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5038),
    [anon_sym_DASH_EQ] = ACTIONS(5038),
    [anon_sym_STAR_EQ] = ACTIONS(5038),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5038),
    [anon_sym_SLASH_EQ] = ACTIONS(5038),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5038),
    [anon_sym_PIPE_EQ] = ACTIONS(5038),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5038),
    [anon_sym_AMP_EQ] = ACTIONS(5038),
    [anon_sym_PERCENT_EQ] = ACTIONS(5038),
    [anon_sym_GT_GT_EQ] = ACTIONS(5038),
    [anon_sym_LT_LT_EQ] = ACTIONS(5038),
    [anon_sym_CARET_EQ] = ACTIONS(5038),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1170] = {
    [sym_string] = STATE(3085),
    [aux_sym_chained_string_repeat1] = STATE(3085),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1171] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3086),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(3086),
    [sym_operator_assignment] = STATE(3086),
    [sym_conditional] = STATE(3086),
    [sym_range] = STATE(3086),
    [sym_binary] = STATE(3086),
    [sym_unary] = STATE(3086),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1172] = {
    [sym__line_break] = ACTIONS(275),
    [sym__simple_symbol] = ACTIONS(2047),
    [sym__string_start] = ACTIONS(2047),
    [sym__symbol_start] = ACTIONS(2047),
    [sym__subshell_start] = ACTIONS(2047),
    [sym__regex_start] = ACTIONS(2047),
    [sym__string_array_start] = ACTIONS(2047),
    [sym__symbol_array_start] = ACTIONS(2047),
    [sym__heredoc_body_start] = ACTIONS(275),
    [sym_heredoc_beginning] = ACTIONS(2047),
    [sym__unary_minus] = ACTIONS(2047),
    [anon_sym_BEGIN] = ACTIONS(2049),
    [anon_sym_LBRACE] = ACTIONS(2047),
    [anon_sym_END] = ACTIONS(2049),
    [anon_sym_def] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(2047),
    [anon_sym_COLON_COLON] = ACTIONS(2047),
    [anon_sym_PIPE] = ACTIONS(2047),
    [anon_sym_SEMI] = ACTIONS(2047),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_class] = ACTIONS(2049),
    [anon_sym_module] = ACTIONS(2049),
    [anon_sym_end] = ACTIONS(2049),
    [anon_sym_return] = ACTIONS(2049),
    [anon_sym_yield] = ACTIONS(2049),
    [anon_sym_break] = ACTIONS(2049),
    [anon_sym_next] = ACTIONS(2049),
    [sym_redo] = ACTIONS(2049),
    [sym_retry] = ACTIONS(2049),
    [anon_sym_if] = ACTIONS(2049),
    [anon_sym_unless] = ACTIONS(2049),
    [anon_sym_while] = ACTIONS(2049),
    [anon_sym_until] = ACTIONS(2049),
    [anon_sym_rescue] = ACTIONS(5040),
    [anon_sym_for] = ACTIONS(2049),
    [anon_sym_case] = ACTIONS(2049),
    [anon_sym_elsif] = ACTIONS(2049),
    [anon_sym_else] = ACTIONS(2049),
    [anon_sym_begin] = ACTIONS(2049),
    [anon_sym_ensure] = ACTIONS(2049),
    [anon_sym_PLUS] = ACTIONS(2049),
    [anon_sym_defined_QMARK] = ACTIONS(2047),
    [anon_sym_not] = ACTIONS(2049),
    [anon_sym_BANG] = ACTIONS(2047),
    [anon_sym_TILDE] = ACTIONS(2047),
    [sym_constant] = ACTIONS(2049),
    [sym_identifier] = ACTIONS(2049),
    [sym_instance_variable] = ACTIONS(2047),
    [sym_class_variable] = ACTIONS(2047),
    [sym_global_variable] = ACTIONS(2047),
    [anon_sym_undef] = ACTIONS(2049),
    [anon_sym_alias] = ACTIONS(2049),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2049),
    [sym_float] = ACTIONS(2049),
    [sym_complex] = ACTIONS(2047),
    [sym_super] = ACTIONS(2049),
    [anon_sym_true] = ACTIONS(2049),
    [anon_sym_TRUE] = ACTIONS(2049),
    [anon_sym_false] = ACTIONS(2049),
    [anon_sym_FALSE] = ACTIONS(2049),
    [sym_self] = ACTIONS(2049),
    [anon_sym_nil] = ACTIONS(2049),
    [anon_sym_NIL] = ACTIONS(2049),
    [sym_character] = ACTIONS(2047),
    [anon_sym_LBRACK2] = ACTIONS(2047),
    [anon_sym_DASH_GT] = ACTIONS(2047),
  },
  [1173] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3099),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3101),
    [sym__argument] = STATE(3102),
    [sym_splat_argument] = STATE(3102),
    [sym_hash_splat_argument] = STATE(3102),
    [sym_block_argument] = STATE(3102),
    [sym_assignment] = STATE(3099),
    [sym_operator_assignment] = STATE(3099),
    [sym_conditional] = STATE(3099),
    [sym_range] = STATE(3099),
    [sym_binary] = STATE(3099),
    [sym_unary] = STATE(3099),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3105),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3102),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5042),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5066),
    [sym_identifier] = ACTIONS(5066),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1174] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3099),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3101),
    [sym__argument] = STATE(3102),
    [sym_splat_argument] = STATE(3102),
    [sym_hash_splat_argument] = STATE(3102),
    [sym_block_argument] = STATE(3102),
    [sym_assignment] = STATE(3099),
    [sym_operator_assignment] = STATE(3099),
    [sym_conditional] = STATE(3099),
    [sym_range] = STATE(3099),
    [sym_binary] = STATE(3099),
    [sym_unary] = STATE(3099),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3105),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3102),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5042),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5066),
    [sym_identifier] = ACTIONS(5066),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1175] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3099),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3101),
    [sym__argument] = STATE(3102),
    [sym_splat_argument] = STATE(3102),
    [sym_hash_splat_argument] = STATE(3102),
    [sym_block_argument] = STATE(3102),
    [sym_assignment] = STATE(3099),
    [sym_operator_assignment] = STATE(3099),
    [sym_conditional] = STATE(3099),
    [sym_range] = STATE(3099),
    [sym_binary] = STATE(3099),
    [sym_unary] = STATE(3099),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3105),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3102),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5042),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5066),
    [sym_identifier] = ACTIONS(5066),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1176] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3099),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3101),
    [sym__argument] = STATE(3102),
    [sym_splat_argument] = STATE(3102),
    [sym_hash_splat_argument] = STATE(3102),
    [sym_block_argument] = STATE(3102),
    [sym_assignment] = STATE(3099),
    [sym_operator_assignment] = STATE(3099),
    [sym_conditional] = STATE(3099),
    [sym_range] = STATE(3099),
    [sym_binary] = STATE(3099),
    [sym_unary] = STATE(3099),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3105),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3102),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5042),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5066),
    [sym_identifier] = ACTIONS(5066),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1177] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3106),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(3106),
    [sym_operator_assignment] = STATE(3106),
    [sym_conditional] = STATE(3106),
    [sym_range] = STATE(3106),
    [sym_binary] = STATE(3106),
    [sym_unary] = STATE(3106),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1178] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1179] = {
    [sym_operator] = STATE(3107),
    [sym__method_name] = STATE(3107),
    [sym_setter] = STATE(3107),
    [sym_symbol] = STATE(3107),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(5072),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(5072),
    [sym_class_variable] = ACTIONS(5072),
    [sym_global_variable] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1180] = {
    [anon_sym_end] = ACTIONS(5074),
    [anon_sym_ensure] = ACTIONS(5074),
    [sym_comment] = ACTIONS(87),
  },
  [1181] = {
    [sym_heredoc_body] = STATE(3108),
    [sym__terminator] = STATE(3108),
    [aux_sym__statements_repeat1] = STATE(3109),
    [sym__line_break] = ACTIONS(5076),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(5076),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_ensure] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [1182] = {
    [sym__line_break] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(5078),
    [anon_sym_unless] = ACTIONS(5080),
    [anon_sym_while] = ACTIONS(5082),
    [anon_sym_until] = ACTIONS(5084),
    [anon_sym_rescue] = ACTIONS(5086),
    [anon_sym_ensure] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [1183] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_ensure] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [1184] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3137),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(3139),
    [sym__argument] = STATE(3140),
    [sym_splat_argument] = STATE(3140),
    [sym_hash_splat_argument] = STATE(3140),
    [sym_block_argument] = STATE(3140),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(3137),
    [sym_operator_assignment] = STATE(3137),
    [sym_conditional] = STATE(3137),
    [sym_range] = STATE(3137),
    [sym_binary] = STATE(3137),
    [sym_unary] = STATE(3137),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3143),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3140),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5116),
    [sym__splat_star] = ACTIONS(5118),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5140),
    [sym_identifier] = ACTIONS(5140),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1185] = {
    [anon_sym_EQ] = ACTIONS(5146),
    [sym_comment] = ACTIONS(87),
  },
  [1186] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5148),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5150),
    [anon_sym_DASH_EQ] = ACTIONS(5150),
    [anon_sym_STAR_EQ] = ACTIONS(5150),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5150),
    [anon_sym_SLASH_EQ] = ACTIONS(5150),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5150),
    [anon_sym_PIPE_EQ] = ACTIONS(5150),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5150),
    [anon_sym_AMP_EQ] = ACTIONS(5150),
    [anon_sym_PERCENT_EQ] = ACTIONS(5150),
    [anon_sym_GT_GT_EQ] = ACTIONS(5150),
    [anon_sym_LT_LT_EQ] = ACTIONS(5150),
    [anon_sym_CARET_EQ] = ACTIONS(5150),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1187] = {
    [sym_string] = STATE(3146),
    [aux_sym_chained_string_repeat1] = STATE(3146),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1188] = {
    [sym__statements] = STATE(3147),
    [sym__top_level_statement] = STATE(1181),
    [sym_begin_block] = STATE(1181),
    [sym_end_block] = STATE(1181),
    [sym__statement] = STATE(1182),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1182),
    [sym_unless_modifier] = STATE(1182),
    [sym_while_modifier] = STATE(1182),
    [sym_until_modifier] = STATE(1182),
    [sym_rescue_modifier] = STATE(1182),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1183),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(1183),
    [sym_operator_assignment] = STATE(1183),
    [sym_conditional] = STATE(1183),
    [sym_range] = STATE(1183),
    [sym_binary] = STATE(1183),
    [sym_unary] = STATE(1183),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_undef] = STATE(1182),
    [sym_alias] = STATE(1182),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1182),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5152),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(5152),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [anon_sym_undef] = ACTIONS(2137),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1189] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3148),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(3148),
    [sym_operator_assignment] = STATE(3148),
    [sym_conditional] = STATE(3148),
    [sym_range] = STATE(3148),
    [sym_binary] = STATE(3148),
    [sym_unary] = STATE(3148),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1190] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3161),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3163),
    [sym__argument] = STATE(3164),
    [sym_splat_argument] = STATE(3164),
    [sym_hash_splat_argument] = STATE(3164),
    [sym_block_argument] = STATE(3164),
    [sym_assignment] = STATE(3161),
    [sym_operator_assignment] = STATE(3161),
    [sym_conditional] = STATE(3161),
    [sym_range] = STATE(3161),
    [sym_binary] = STATE(3161),
    [sym_unary] = STATE(3161),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3167),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3164),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5154),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5178),
    [sym_identifier] = ACTIONS(5178),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1191] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3161),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3163),
    [sym__argument] = STATE(3164),
    [sym_splat_argument] = STATE(3164),
    [sym_hash_splat_argument] = STATE(3164),
    [sym_block_argument] = STATE(3164),
    [sym_assignment] = STATE(3161),
    [sym_operator_assignment] = STATE(3161),
    [sym_conditional] = STATE(3161),
    [sym_range] = STATE(3161),
    [sym_binary] = STATE(3161),
    [sym_unary] = STATE(3161),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3167),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3164),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5154),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5178),
    [sym_identifier] = ACTIONS(5178),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1192] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3161),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3163),
    [sym__argument] = STATE(3164),
    [sym_splat_argument] = STATE(3164),
    [sym_hash_splat_argument] = STATE(3164),
    [sym_block_argument] = STATE(3164),
    [sym_assignment] = STATE(3161),
    [sym_operator_assignment] = STATE(3161),
    [sym_conditional] = STATE(3161),
    [sym_range] = STATE(3161),
    [sym_binary] = STATE(3161),
    [sym_unary] = STATE(3161),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3167),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3164),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5154),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5178),
    [sym_identifier] = ACTIONS(5178),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1193] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3161),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3163),
    [sym__argument] = STATE(3164),
    [sym_splat_argument] = STATE(3164),
    [sym_hash_splat_argument] = STATE(3164),
    [sym_block_argument] = STATE(3164),
    [sym_assignment] = STATE(3161),
    [sym_operator_assignment] = STATE(3161),
    [sym_conditional] = STATE(3161),
    [sym_range] = STATE(3161),
    [sym_binary] = STATE(3161),
    [sym_unary] = STATE(3161),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3167),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3164),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5154),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5178),
    [sym_identifier] = ACTIONS(5178),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1194] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3168),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(3168),
    [sym_operator_assignment] = STATE(3168),
    [sym_conditional] = STATE(3168),
    [sym_range] = STATE(3168),
    [sym_binary] = STATE(3168),
    [sym_unary] = STATE(3168),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1195] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1196] = {
    [sym_operator] = STATE(3169),
    [sym__method_name] = STATE(3169),
    [sym_setter] = STATE(3169),
    [sym_symbol] = STATE(3169),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(5184),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(5184),
    [sym_class_variable] = ACTIONS(5184),
    [sym_global_variable] = ACTIONS(5184),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1197] = {
    [anon_sym_end] = ACTIONS(5186),
    [sym_comment] = ACTIONS(87),
  },
  [1198] = {
    [sym_heredoc_body] = STATE(3170),
    [sym__terminator] = STATE(3170),
    [aux_sym__statements_repeat1] = STATE(3171),
    [sym__line_break] = ACTIONS(5188),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(5188),
    [anon_sym_end] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [1199] = {
    [sym__line_break] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(5190),
    [anon_sym_unless] = ACTIONS(5192),
    [anon_sym_while] = ACTIONS(5194),
    [anon_sym_until] = ACTIONS(5196),
    [anon_sym_rescue] = ACTIONS(5198),
    [sym_comment] = ACTIONS(87),
  },
  [1200] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(5216),
    [anon_sym_or] = ACTIONS(5216),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [1201] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3199),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(3201),
    [sym__argument] = STATE(3202),
    [sym_splat_argument] = STATE(3202),
    [sym_hash_splat_argument] = STATE(3202),
    [sym_block_argument] = STATE(3202),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(3199),
    [sym_operator_assignment] = STATE(3199),
    [sym_conditional] = STATE(3199),
    [sym_range] = STATE(3199),
    [sym_binary] = STATE(3199),
    [sym_unary] = STATE(3199),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3205),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3202),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5228),
    [sym__splat_star] = ACTIONS(5230),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5252),
    [sym_identifier] = ACTIONS(5252),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1202] = {
    [anon_sym_EQ] = ACTIONS(5258),
    [sym_comment] = ACTIONS(87),
  },
  [1203] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5260),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5262),
    [anon_sym_DASH_EQ] = ACTIONS(5262),
    [anon_sym_STAR_EQ] = ACTIONS(5262),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5262),
    [anon_sym_SLASH_EQ] = ACTIONS(5262),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5262),
    [anon_sym_PIPE_EQ] = ACTIONS(5262),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5262),
    [anon_sym_AMP_EQ] = ACTIONS(5262),
    [anon_sym_PERCENT_EQ] = ACTIONS(5262),
    [anon_sym_GT_GT_EQ] = ACTIONS(5262),
    [anon_sym_LT_LT_EQ] = ACTIONS(5262),
    [anon_sym_CARET_EQ] = ACTIONS(5262),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1204] = {
    [sym_string] = STATE(3208),
    [aux_sym_chained_string_repeat1] = STATE(3208),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1205] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [1206] = {
    [aux_sym_undef_repeat1] = STATE(3209),
    [sym__line_break] = ACTIONS(2257),
    [sym__heredoc_body_start] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_end] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [anon_sym_else] = ACTIONS(2257),
    [anon_sym_ensure] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [1207] = {
    [sym__line_break] = ACTIONS(5264),
    [sym__heredoc_body_start] = ACTIONS(5264),
    [sym__binary_minus] = ACTIONS(5264),
    [sym__binary_star] = ACTIONS(5264),
    [ts_builtin_sym_end] = ACTIONS(5264),
    [anon_sym___END__] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5264),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_RPAREN] = ACTIONS(5264),
    [anon_sym_DOT] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5264),
    [anon_sym_PIPE] = ACTIONS(5266),
    [anon_sym_SEMI] = ACTIONS(5264),
    [anon_sym_STAR_STAR] = ACTIONS(5264),
    [anon_sym_AMP] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5266),
    [anon_sym_end] = ACTIONS(5264),
    [anon_sym_if] = ACTIONS(5264),
    [anon_sym_unless] = ACTIONS(5264),
    [anon_sym_while] = ACTIONS(5264),
    [anon_sym_until] = ACTIONS(5264),
    [anon_sym_rescue] = ACTIONS(5264),
    [anon_sym_do] = ACTIONS(5264),
    [anon_sym_when] = ACTIONS(5264),
    [anon_sym_elsif] = ACTIONS(5264),
    [anon_sym_else] = ACTIONS(5264),
    [anon_sym_then] = ACTIONS(5264),
    [anon_sym_ensure] = ACTIONS(5264),
    [anon_sym_EQ_GT] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5264),
    [anon_sym_COLON_COLON2] = ACTIONS(5264),
    [anon_sym_AMP_DOT] = ACTIONS(5264),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5264),
    [anon_sym_and] = ACTIONS(5264),
    [anon_sym_or] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE] = ACTIONS(5264),
    [anon_sym_AMP_AMP] = ACTIONS(5264),
    [anon_sym_LT_LT] = ACTIONS(5264),
    [anon_sym_GT_GT] = ACTIONS(5264),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5264),
    [anon_sym_LT_EQ_GT] = ACTIONS(5264),
    [anon_sym_EQ_TILDE] = ACTIONS(5264),
    [anon_sym_BANG_TILDE] = ACTIONS(5264),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_GT] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5264),
    [anon_sym_CARET] = ACTIONS(5264),
    [anon_sym_PLUS] = ACTIONS(5264),
    [anon_sym_SLASH] = ACTIONS(5264),
    [anon_sym_PERCENT] = ACTIONS(5264),
    [sym_comment] = ACTIONS(87),
  },
  [1208] = {
    [sym_ensure] = STATE(3211),
    [anon_sym_end] = ACTIONS(5268),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1209] = {
    [anon_sym_end] = ACTIONS(5268),
    [sym_comment] = ACTIONS(87),
  },
  [1210] = {
    [sym_else] = STATE(3212),
    [sym_ensure] = STATE(3211),
    [anon_sym_end] = ACTIONS(5268),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1211] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2499),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(2499),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(2499),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(2499),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1212] = {
    [sym_heredoc_body] = STATE(3213),
    [sym__terminator] = STATE(3213),
    [aux_sym__statements_repeat1] = STATE(3214),
    [sym__line_break] = ACTIONS(5270),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(5270),
    [anon_sym_end] = ACTIONS(2497),
    [anon_sym_rescue] = ACTIONS(2497),
    [anon_sym_else] = ACTIONS(2497),
    [anon_sym_ensure] = ACTIONS(2497),
    [sym_comment] = ACTIONS(87),
  },
  [1213] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3215),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3215),
    [sym_operator_assignment] = STATE(3215),
    [sym_conditional] = STATE(3215),
    [sym_range] = STATE(3215),
    [sym_binary] = STATE(3215),
    [sym_unary] = STATE(3215),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1214] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3216),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3216),
    [sym_operator_assignment] = STATE(3216),
    [sym_conditional] = STATE(3216),
    [sym_range] = STATE(3216),
    [sym_binary] = STATE(3216),
    [sym_unary] = STATE(3216),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1215] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3217),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3217),
    [sym_operator_assignment] = STATE(3217),
    [sym_conditional] = STATE(3217),
    [sym_range] = STATE(3217),
    [sym_binary] = STATE(3217),
    [sym_unary] = STATE(3217),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1216] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3218),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3218),
    [sym_operator_assignment] = STATE(3218),
    [sym_conditional] = STATE(3218),
    [sym_range] = STATE(3218),
    [sym_binary] = STATE(3218),
    [sym_unary] = STATE(3218),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1217] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3219),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3219),
    [sym_operator_assignment] = STATE(3219),
    [sym_conditional] = STATE(3219),
    [sym_range] = STATE(3219),
    [sym_binary] = STATE(3219),
    [sym_unary] = STATE(3219),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1218] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3220),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3220),
    [sym_operator_assignment] = STATE(3220),
    [sym_conditional] = STATE(3220),
    [sym_range] = STATE(3220),
    [sym_binary] = STATE(3220),
    [sym_unary] = STATE(3220),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1219] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3221),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3221),
    [sym_operator_assignment] = STATE(3221),
    [sym_conditional] = STATE(3221),
    [sym_range] = STATE(3221),
    [sym_binary] = STATE(3221),
    [sym_unary] = STATE(3221),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1220] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3222),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3222),
    [sym_operator_assignment] = STATE(3222),
    [sym_conditional] = STATE(3222),
    [sym_range] = STATE(3222),
    [sym_binary] = STATE(3222),
    [sym_unary] = STATE(3222),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1221] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3223),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3223),
    [sym_operator_assignment] = STATE(3223),
    [sym_conditional] = STATE(3223),
    [sym_range] = STATE(3223),
    [sym_binary] = STATE(3223),
    [sym_unary] = STATE(3223),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1222] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3224),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3224),
    [sym_operator_assignment] = STATE(3224),
    [sym_conditional] = STATE(3224),
    [sym_range] = STATE(3224),
    [sym_binary] = STATE(3224),
    [sym_unary] = STATE(3224),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1223] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3225),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(3225),
    [sym_operator_assignment] = STATE(3225),
    [sym_conditional] = STATE(3225),
    [sym_range] = STATE(3225),
    [sym_binary] = STATE(3225),
    [sym_unary] = STATE(3225),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1224] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3226),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3226),
    [sym_operator_assignment] = STATE(3226),
    [sym_conditional] = STATE(3226),
    [sym_range] = STATE(3226),
    [sym_binary] = STATE(3226),
    [sym_unary] = STATE(3226),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1225] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3227),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3227),
    [sym_operator_assignment] = STATE(3227),
    [sym_conditional] = STATE(3227),
    [sym_range] = STATE(3227),
    [sym_binary] = STATE(3227),
    [sym_unary] = STATE(3227),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1226] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3228),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3228),
    [sym_operator_assignment] = STATE(3228),
    [sym_conditional] = STATE(3228),
    [sym_range] = STATE(3228),
    [sym_binary] = STATE(3228),
    [sym_unary] = STATE(3228),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1227] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3229),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3229),
    [sym_operator_assignment] = STATE(3229),
    [sym_conditional] = STATE(3229),
    [sym_range] = STATE(3229),
    [sym_binary] = STATE(3229),
    [sym_unary] = STATE(3229),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1228] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3237),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(3237),
    [sym_operator_assignment] = STATE(3237),
    [sym_conditional] = STATE(3237),
    [sym_range] = STATE(3237),
    [sym_binary] = STATE(3237),
    [sym_unary] = STATE(3237),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1229] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3242),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(3242),
    [sym_operator_assignment] = STATE(3242),
    [sym_conditional] = STATE(3242),
    [sym_range] = STATE(3242),
    [sym_binary] = STATE(3242),
    [sym_unary] = STATE(3242),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1230] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3243),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(3243),
    [sym_operator_assignment] = STATE(3243),
    [sym_conditional] = STATE(3243),
    [sym_range] = STATE(3243),
    [sym_binary] = STATE(3243),
    [sym_unary] = STATE(3243),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1231] = {
    [anon_sym_COLON] = ACTIONS(5296),
    [sym_comment] = ACTIONS(87),
  },
  [1232] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3246),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(3246),
    [sym_operator_assignment] = STATE(3246),
    [sym_conditional] = STATE(3246),
    [sym_range] = STATE(3246),
    [sym_binary] = STATE(3246),
    [sym_unary] = STATE(3246),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1233] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3015),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(3016),
    [sym__argument] = STATE(3017),
    [sym_splat_argument] = STATE(3017),
    [sym_hash_splat_argument] = STATE(3017),
    [sym_block_argument] = STATE(3017),
    [sym_assignment] = STATE(3015),
    [sym_operator_assignment] = STATE(3015),
    [sym_conditional] = STATE(3015),
    [sym_range] = STATE(3015),
    [sym_binary] = STATE(3015),
    [sym_unary] = STATE(3015),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3018),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3017),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4916),
    [sym__splat_star] = ACTIONS(4918),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(4922),
    [sym_identifier] = ACTIONS(4922),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1234] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3015),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(3016),
    [sym__argument] = STATE(3017),
    [sym_splat_argument] = STATE(3017),
    [sym_hash_splat_argument] = STATE(3017),
    [sym_block_argument] = STATE(3017),
    [sym_assignment] = STATE(3015),
    [sym_operator_assignment] = STATE(3015),
    [sym_conditional] = STATE(3015),
    [sym_range] = STATE(3015),
    [sym_binary] = STATE(3015),
    [sym_unary] = STATE(3015),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3018),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3017),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4916),
    [sym__splat_star] = ACTIONS(4918),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(4922),
    [sym_identifier] = ACTIONS(4922),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1235] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3015),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(3016),
    [sym__argument] = STATE(3017),
    [sym_splat_argument] = STATE(3017),
    [sym_hash_splat_argument] = STATE(3017),
    [sym_block_argument] = STATE(3017),
    [sym_assignment] = STATE(3015),
    [sym_operator_assignment] = STATE(3015),
    [sym_conditional] = STATE(3015),
    [sym_range] = STATE(3015),
    [sym_binary] = STATE(3015),
    [sym_unary] = STATE(3015),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3018),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3017),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4916),
    [sym__splat_star] = ACTIONS(4918),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(4922),
    [sym_identifier] = ACTIONS(4922),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1236] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3015),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(3016),
    [sym__argument] = STATE(3017),
    [sym_splat_argument] = STATE(3017),
    [sym_hash_splat_argument] = STATE(3017),
    [sym_block_argument] = STATE(3017),
    [sym_assignment] = STATE(3015),
    [sym_operator_assignment] = STATE(3015),
    [sym_conditional] = STATE(3015),
    [sym_range] = STATE(3015),
    [sym_binary] = STATE(3015),
    [sym_unary] = STATE(3015),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3018),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3017),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4916),
    [sym__splat_star] = ACTIONS(4918),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(4922),
    [sym_identifier] = ACTIONS(4922),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1237] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3247),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(3247),
    [sym_operator_assignment] = STATE(3247),
    [sym_conditional] = STATE(3247),
    [sym_range] = STATE(3247),
    [sym_binary] = STATE(3247),
    [sym_unary] = STATE(3247),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1238] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1239] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(5298),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1240] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_ensure] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(5296),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [1241] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3015),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(3016),
    [sym__argument] = STATE(3017),
    [sym_splat_argument] = STATE(3017),
    [sym_hash_splat_argument] = STATE(3017),
    [sym_block_argument] = STATE(3017),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3015),
    [sym_operator_assignment] = STATE(3015),
    [sym_conditional] = STATE(3015),
    [sym_range] = STATE(3015),
    [sym_binary] = STATE(3015),
    [sym_unary] = STATE(3015),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3018),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3017),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4916),
    [sym__splat_star] = ACTIONS(4918),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(771),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(4922),
    [sym_identifier] = ACTIONS(4922),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1242] = {
    [sym_heredoc_body] = STATE(3259),
    [aux_sym_call_repeat1] = STATE(3259),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1243] = {
    [sym_heredoc_body] = STATE(3259),
    [aux_sym_call_repeat1] = STATE(3259),
    [aux_sym_argument_list_repeat1] = STATE(3261),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(5328),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1244] = {
    [anon_sym_EQ] = ACTIONS(5330),
    [sym_comment] = ACTIONS(87),
  },
  [1245] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5332),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5334),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1246] = {
    [sym_string] = STATE(3264),
    [aux_sym_chained_string_repeat1] = STATE(3264),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5336),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1247] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3269),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_splat_argument] = STATE(3270),
    [sym_assignment] = STATE(3269),
    [sym_operator_assignment] = STATE(3269),
    [sym_conditional] = STATE(3269),
    [sym_range] = STATE(3269),
    [sym_binary] = STATE(3269),
    [sym_unary] = STATE(3269),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(3270),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5338),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1248] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3273),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(3273),
    [sym_operator_assignment] = STATE(3273),
    [sym_conditional] = STATE(3273),
    [sym_range] = STATE(3273),
    [sym_binary] = STATE(3273),
    [sym_unary] = STATE(3273),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1249] = {
    [sym_string] = STATE(3274),
    [aux_sym_chained_string_repeat1] = STATE(3274),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_ensure] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [1250] = {
    [sym__line_break] = ACTIONS(5350),
    [sym__heredoc_body_start] = ACTIONS(5350),
    [sym__binary_minus] = ACTIONS(5350),
    [sym__binary_star] = ACTIONS(5350),
    [ts_builtin_sym_end] = ACTIONS(5350),
    [anon_sym___END__] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_RPAREN] = ACTIONS(5350),
    [anon_sym_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5350),
    [anon_sym_PIPE] = ACTIONS(5352),
    [anon_sym_SEMI] = ACTIONS(5350),
    [anon_sym_STAR_STAR] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5352),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5350),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_unless] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_until] = ACTIONS(5350),
    [anon_sym_rescue] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_when] = ACTIONS(5350),
    [anon_sym_elsif] = ACTIONS(5350),
    [anon_sym_else] = ACTIONS(5350),
    [anon_sym_then] = ACTIONS(5350),
    [anon_sym_ensure] = ACTIONS(5350),
    [anon_sym_EQ_GT] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_COLON_COLON2] = ACTIONS(5350),
    [anon_sym_AMP_DOT] = ACTIONS(5350),
    [anon_sym_QMARK] = ACTIONS(5350),
    [anon_sym_DOT_DOT] = ACTIONS(5352),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5350),
    [anon_sym_AMP_AMP] = ACTIONS(5350),
    [anon_sym_LT_LT] = ACTIONS(5350),
    [anon_sym_GT_GT] = ACTIONS(5350),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5350),
    [anon_sym_LT_EQ_GT] = ACTIONS(5350),
    [anon_sym_EQ_TILDE] = ACTIONS(5350),
    [anon_sym_BANG_TILDE] = ACTIONS(5350),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5350),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_SLASH] = ACTIONS(5350),
    [anon_sym_PERCENT] = ACTIONS(5350),
    [sym_comment] = ACTIONS(87),
  },
  [1251] = {
    [sym_operator] = STATE(3275),
    [sym__method_name] = STATE(3275),
    [sym_setter] = STATE(3275),
    [sym_symbol] = STATE(3275),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(5354),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(5354),
    [sym_class_variable] = ACTIONS(5354),
    [sym_global_variable] = ACTIONS(5354),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1252] = {
    [aux_sym_undef_repeat1] = STATE(3276),
    [sym__line_break] = ACTIONS(5356),
    [sym__heredoc_body_start] = ACTIONS(5356),
    [ts_builtin_sym_end] = ACTIONS(5356),
    [anon_sym___END__] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [1253] = {
    [sym__simple_symbol] = ACTIONS(887),
    [sym__symbol_start] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(887),
    [anon_sym_STAR] = ACTIONS(889),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(887),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(887),
    [sym_constant] = ACTIONS(887),
    [sym_identifier] = ACTIONS(887),
    [sym_instance_variable] = ACTIONS(887),
    [sym_class_variable] = ACTIONS(887),
    [sym_global_variable] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_PLUS_AT] = ACTIONS(887),
    [anon_sym_DASH_AT] = ACTIONS(887),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(889),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(887),
    [anon_sym_BQUOTE] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [1254] = {
    [sym__string_end] = ACTIONS(5358),
    [sym_comment] = ACTIONS(87),
  },
  [1255] = {
    [sym__simple_symbol] = ACTIONS(3540),
    [sym__symbol_start] = ACTIONS(3540),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3542),
    [anon_sym_STAR_STAR] = ACTIONS(3540),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3542),
    [anon_sym_DOT_DOT] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3540),
    [anon_sym_GT_GT] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3540),
    [anon_sym_LT_EQ_GT] = ACTIONS(3540),
    [anon_sym_EQ_TILDE] = ACTIONS(3540),
    [anon_sym_BANG_TILDE] = ACTIONS(3540),
    [anon_sym_LT_EQ] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3542),
    [anon_sym_GT_EQ] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3540),
    [anon_sym_PLUS] = ACTIONS(3542),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3540),
    [anon_sym_BANG] = ACTIONS(3542),
    [anon_sym_TILDE] = ACTIONS(3540),
    [sym_constant] = ACTIONS(3540),
    [sym_identifier] = ACTIONS(3540),
    [sym_instance_variable] = ACTIONS(3540),
    [sym_class_variable] = ACTIONS(3540),
    [sym_global_variable] = ACTIONS(3540),
    [anon_sym_DASH] = ACTIONS(3542),
    [anon_sym_PLUS_AT] = ACTIONS(3540),
    [anon_sym_DASH_AT] = ACTIONS(3540),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3542),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3540),
    [anon_sym_BQUOTE] = ACTIONS(3540),
    [sym_comment] = ACTIONS(87),
  },
  [1256] = {
    [sym__line_break] = ACTIONS(5360),
    [sym__heredoc_body_start] = ACTIONS(5360),
    [ts_builtin_sym_end] = ACTIONS(5360),
    [anon_sym___END__] = ACTIONS(5360),
    [anon_sym_RBRACE] = ACTIONS(5360),
    [anon_sym_RPAREN] = ACTIONS(5360),
    [anon_sym_SEMI] = ACTIONS(5360),
    [anon_sym_end] = ACTIONS(5360),
    [anon_sym_if] = ACTIONS(5360),
    [anon_sym_unless] = ACTIONS(5360),
    [anon_sym_while] = ACTIONS(5360),
    [anon_sym_until] = ACTIONS(5360),
    [anon_sym_rescue] = ACTIONS(5360),
    [anon_sym_when] = ACTIONS(5360),
    [anon_sym_elsif] = ACTIONS(5360),
    [anon_sym_else] = ACTIONS(5360),
    [anon_sym_then] = ACTIONS(5360),
    [anon_sym_ensure] = ACTIONS(5360),
    [sym_comment] = ACTIONS(87),
  },
  [1257] = {
    [sym__string_start] = ACTIONS(837),
    [sym__heredoc_body_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_unless] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_until] = ACTIONS(837),
    [anon_sym_rescue] = ACTIONS(837),
    [anon_sym_in] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_EQ_GT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_COLON2] = ACTIONS(839),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [1258] = {
    [sym__string_end] = ACTIONS(5362),
    [sym_comment] = ACTIONS(87),
  },
  [1259] = {
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_in] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_RBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_COLON2] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [1260] = {
    [sym__string_end] = ACTIONS(5364),
    [sym_comment] = ACTIONS(87),
  },
  [1261] = {
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_EQ_GT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_COLON2] = ACTIONS(895),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [1262] = {
    [sym__string_end] = ACTIONS(5366),
    [sym_comment] = ACTIONS(87),
  },
  [1263] = {
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_in] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_RBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_COLON2] = ACTIONS(901),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [1264] = {
    [sym__string_end] = ACTIONS(5368),
    [sym_comment] = ACTIONS(87),
  },
  [1265] = {
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_in] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_COLON2] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [1266] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3284),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5370),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5372),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1267] = {
    [aux_sym_string_array_repeat1] = STATE(3287),
    [sym__string_end] = ACTIONS(5374),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5376),
  },
  [1268] = {
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_in] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_COLON2] = ACTIONS(925),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_SLASH] = ACTIONS(923),
    [anon_sym_PERCENT] = ACTIONS(923),
    [sym_comment] = ACTIONS(87),
  },
  [1269] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3290),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5378),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5380),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1270] = {
    [aux_sym_symbol_array_repeat1] = STATE(3293),
    [sym__string_end] = ACTIONS(5382),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5384),
  },
  [1271] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(3294),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(3294),
    [sym_operator_assignment] = STATE(3294),
    [sym_conditional] = STATE(3294),
    [sym_range] = STATE(3294),
    [sym_binary] = STATE(3294),
    [sym_unary] = STATE(3294),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1272] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3300),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(3301),
    [sym__argument] = STATE(3302),
    [sym_splat_argument] = STATE(3302),
    [sym_hash_splat_argument] = STATE(3302),
    [sym_block_argument] = STATE(3302),
    [sym_assignment] = STATE(3300),
    [sym_operator_assignment] = STATE(3300),
    [sym_conditional] = STATE(3300),
    [sym_range] = STATE(3300),
    [sym_binary] = STATE(3300),
    [sym_unary] = STATE(3300),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3303),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3302),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5386),
    [sym__splat_star] = ACTIONS(5388),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5390),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(5392),
    [sym_identifier] = ACTIONS(5392),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1273] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3300),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(3301),
    [sym__argument] = STATE(3302),
    [sym_splat_argument] = STATE(3302),
    [sym_hash_splat_argument] = STATE(3302),
    [sym_block_argument] = STATE(3302),
    [sym_assignment] = STATE(3300),
    [sym_operator_assignment] = STATE(3300),
    [sym_conditional] = STATE(3300),
    [sym_range] = STATE(3300),
    [sym_binary] = STATE(3300),
    [sym_unary] = STATE(3300),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3303),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3302),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5386),
    [sym__splat_star] = ACTIONS(5388),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5390),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(5392),
    [sym_identifier] = ACTIONS(5392),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1274] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3300),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(3301),
    [sym__argument] = STATE(3302),
    [sym_splat_argument] = STATE(3302),
    [sym_hash_splat_argument] = STATE(3302),
    [sym_block_argument] = STATE(3302),
    [sym_assignment] = STATE(3300),
    [sym_operator_assignment] = STATE(3300),
    [sym_conditional] = STATE(3300),
    [sym_range] = STATE(3300),
    [sym_binary] = STATE(3300),
    [sym_unary] = STATE(3300),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3303),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3302),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5386),
    [sym__splat_star] = ACTIONS(5388),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5390),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(5392),
    [sym_identifier] = ACTIONS(5392),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1275] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3300),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(3301),
    [sym__argument] = STATE(3302),
    [sym_splat_argument] = STATE(3302),
    [sym_hash_splat_argument] = STATE(3302),
    [sym_block_argument] = STATE(3302),
    [sym_assignment] = STATE(3300),
    [sym_operator_assignment] = STATE(3300),
    [sym_conditional] = STATE(3300),
    [sym_range] = STATE(3300),
    [sym_binary] = STATE(3300),
    [sym_unary] = STATE(3300),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3303),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3302),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5386),
    [sym__splat_star] = ACTIONS(5388),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5390),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2339),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(5392),
    [sym_identifier] = ACTIONS(5392),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1276] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(3304),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(3304),
    [sym_operator_assignment] = STATE(3304),
    [sym_conditional] = STATE(3304),
    [sym_range] = STATE(3304),
    [sym_binary] = STATE(3304),
    [sym_unary] = STATE(3304),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1277] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1335),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(1335),
    [sym_operator_assignment] = STATE(1335),
    [sym_conditional] = STATE(1335),
    [sym_range] = STATE(1335),
    [sym_binary] = STATE(1335),
    [sym_unary] = STATE(1335),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1278] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [1279] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3320),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(1827),
    [sym__argument_list_with_parens] = STATE(3321),
    [sym__argument] = STATE(3322),
    [sym_splat_argument] = STATE(3322),
    [sym_hash_splat_argument] = STATE(3322),
    [sym_block_argument] = STATE(3322),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(3320),
    [sym_operator_assignment] = STATE(3320),
    [sym_conditional] = STATE(3320),
    [sym_range] = STATE(3320),
    [sym_binary] = STATE(3320),
    [sym_unary] = STATE(3320),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3323),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3322),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5422),
    [sym__splat_star] = ACTIONS(5424),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5426),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(5428),
    [sym_identifier] = ACTIONS(5428),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1280] = {
    [anon_sym_EQ] = ACTIONS(5430),
    [sym_comment] = ACTIONS(87),
  },
  [1281] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5432),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5434),
    [anon_sym_DASH_EQ] = ACTIONS(5434),
    [anon_sym_STAR_EQ] = ACTIONS(5434),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5434),
    [anon_sym_SLASH_EQ] = ACTIONS(5434),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5434),
    [anon_sym_PIPE_EQ] = ACTIONS(5434),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5434),
    [anon_sym_AMP_EQ] = ACTIONS(5434),
    [anon_sym_PERCENT_EQ] = ACTIONS(5434),
    [anon_sym_GT_GT_EQ] = ACTIONS(5434),
    [anon_sym_LT_LT_EQ] = ACTIONS(5434),
    [anon_sym_CARET_EQ] = ACTIONS(5434),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1282] = {
    [sym_string] = STATE(3326),
    [aux_sym_chained_string_repeat1] = STATE(3326),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1283] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [1284] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1285] = {
    [sym_string] = STATE(1386),
    [aux_sym_chained_string_repeat1] = STATE(1386),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1286] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(3327),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(3327),
    [sym_operator_assignment] = STATE(3327),
    [sym_conditional] = STATE(3327),
    [sym_range] = STATE(3327),
    [sym_binary] = STATE(3327),
    [sym_unary] = STATE(3327),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1287] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_in] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_RBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_COLON2] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [1288] = {
    [anon_sym_RBRACE] = ACTIONS(5436),
    [sym_comment] = ACTIONS(87),
  },
  [1289] = {
    [sym_heredoc_body] = STATE(3329),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [sym_comment] = ACTIONS(87),
  },
  [1290] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3330),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(3330),
    [sym_operator_assignment] = STATE(3330),
    [sym_conditional] = STATE(3330),
    [sym_range] = STATE(3330),
    [sym_binary] = STATE(3330),
    [sym_unary] = STATE(3330),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1291] = {
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [1292] = {
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_COLON_COLON] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
  },
  [1293] = {
    [sym_method_parameters] = STATE(3332),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(3332),
    [sym__terminator] = STATE(3332),
    [sym__line_break] = ACTIONS(5440),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [1294] = {
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_RBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_COLON2] = ACTIONS(1293),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1291),
    [sym_comment] = ACTIONS(87),
  },
  [1295] = {
    [anon_sym_RPAREN] = ACTIONS(5442),
    [sym_comment] = ACTIONS(87),
  },
  [1296] = {
    [sym__simple_symbol] = ACTIONS(1413),
    [sym__string_start] = ACTIONS(1413),
    [sym__symbol_start] = ACTIONS(1413),
    [sym__subshell_start] = ACTIONS(1413),
    [sym__regex_start] = ACTIONS(1413),
    [sym__string_array_start] = ACTIONS(1413),
    [sym__symbol_array_start] = ACTIONS(1413),
    [sym__heredoc_body_start] = ACTIONS(1413),
    [sym_heredoc_beginning] = ACTIONS(1413),
    [sym__block_ampersand] = ACTIONS(1413),
    [sym__splat_star] = ACTIONS(1413),
    [sym__unary_minus] = ACTIONS(1413),
    [sym__binary_minus] = ACTIONS(1413),
    [sym__binary_star] = ACTIONS(1413),
    [sym__identifier_hash_key] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_def] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1415),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_EQ] = ACTIONS(1415),
    [anon_sym_class] = ACTIONS(1415),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_return] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1415),
    [anon_sym_next] = ACTIONS(1415),
    [sym_redo] = ACTIONS(1415),
    [sym_retry] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_unless] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1415),
    [anon_sym_until] = ACTIONS(1415),
    [anon_sym_rescue] = ACTIONS(1415),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_in] = ACTIONS(1415),
    [anon_sym_do] = ACTIONS(1415),
    [anon_sym_case] = ACTIONS(1415),
    [anon_sym_begin] = ACTIONS(1415),
    [anon_sym_EQ_GT] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_RBRACK] = ACTIONS(1413),
    [anon_sym_COLON_COLON2] = ACTIONS(1413),
    [anon_sym_AMP_DOT] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1413),
    [anon_sym_PLUS_EQ] = ACTIONS(1413),
    [anon_sym_DASH_EQ] = ACTIONS(1413),
    [anon_sym_STAR_EQ] = ACTIONS(1413),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1413),
    [anon_sym_SLASH_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1413),
    [anon_sym_AMP_EQ] = ACTIONS(1413),
    [anon_sym_PERCENT_EQ] = ACTIONS(1413),
    [anon_sym_GT_GT_EQ] = ACTIONS(1413),
    [anon_sym_LT_LT_EQ] = ACTIONS(1413),
    [anon_sym_CARET_EQ] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(1415),
    [anon_sym_COLON2] = ACTIONS(1415),
    [anon_sym_DOT_DOT] = ACTIONS(1415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1413),
    [anon_sym_and] = ACTIONS(1415),
    [anon_sym_or] = ACTIONS(1415),
    [anon_sym_PIPE_PIPE] = ACTIONS(1415),
    [anon_sym_AMP_AMP] = ACTIONS(1415),
    [anon_sym_LT_LT] = ACTIONS(1415),
    [anon_sym_GT_GT] = ACTIONS(1415),
    [anon_sym_EQ_EQ] = ACTIONS(1415),
    [anon_sym_BANG_EQ] = ACTIONS(1413),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1413),
    [anon_sym_LT_EQ_GT] = ACTIONS(1413),
    [anon_sym_EQ_TILDE] = ACTIONS(1413),
    [anon_sym_BANG_TILDE] = ACTIONS(1413),
    [anon_sym_LT_EQ] = ACTIONS(1415),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_CARET] = ACTIONS(1415),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(1415),
    [anon_sym_PERCENT] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1413),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1415),
    [sym_float] = ACTIONS(1415),
    [sym_complex] = ACTIONS(1413),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1415),
    [anon_sym_TRUE] = ACTIONS(1415),
    [anon_sym_false] = ACTIONS(1415),
    [anon_sym_FALSE] = ACTIONS(1415),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(1415),
    [anon_sym_NIL] = ACTIONS(1415),
    [sym_character] = ACTIONS(1413),
    [anon_sym_LBRACK2] = ACTIONS(1415),
    [anon_sym_DASH_GT] = ACTIONS(1413),
  },
  [1297] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [1298] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3334),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(3334),
    [sym_operator_assignment] = STATE(3334),
    [sym_conditional] = STATE(3334),
    [sym_range] = STATE(3334),
    [sym_binary] = STATE(3334),
    [sym_unary] = STATE(3334),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1299] = {
    [sym_superclass] = STATE(3335),
    [sym_heredoc_body] = STATE(3336),
    [sym__terminator] = STATE(3336),
    [sym__line_break] = ACTIONS(5444),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1300] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_superclass] = STATE(3335),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(3336),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(3336),
    [sym__line_break] = ACTIONS(5444),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1301] = {
    [sym_heredoc_body] = STATE(3338),
    [sym__terminator] = STATE(3338),
    [sym__line_break] = ACTIONS(5446),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(5448),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1302] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(3338),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(3338),
    [sym__line_break] = ACTIONS(5446),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(5448),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1303] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3339),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(3339),
    [sym_operator_assignment] = STATE(3339),
    [sym_conditional] = STATE(3339),
    [sym_range] = STATE(3339),
    [sym_binary] = STATE(3339),
    [sym_unary] = STATE(3339),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1304] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3340),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(3340),
    [sym_operator_assignment] = STATE(3340),
    [sym_conditional] = STATE(3340),
    [sym_range] = STATE(3340),
    [sym_binary] = STATE(3340),
    [sym_unary] = STATE(3340),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1305] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3341),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(3341),
    [sym_operator_assignment] = STATE(3341),
    [sym_conditional] = STATE(3341),
    [sym_range] = STATE(3341),
    [sym_binary] = STATE(3341),
    [sym_unary] = STATE(3341),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1306] = {
    [anon_sym_COLON] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [1307] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3343),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(3343),
    [sym_operator_assignment] = STATE(3343),
    [sym_conditional] = STATE(3343),
    [sym_range] = STATE(3343),
    [sym_binary] = STATE(3343),
    [sym_unary] = STATE(3343),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1308] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3344),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(3344),
    [sym_operator_assignment] = STATE(3344),
    [sym_conditional] = STATE(3344),
    [sym_range] = STATE(3344),
    [sym_binary] = STATE(3344),
    [sym_unary] = STATE(3344),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1309] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1310] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1311] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_RBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [1312] = {
    [sym__heredoc_body_start] = ACTIONS(1679),
    [sym__binary_minus] = ACTIONS(1679),
    [sym__binary_star] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(1679),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_unless] = ACTIONS(1679),
    [anon_sym_while] = ACTIONS(1679),
    [anon_sym_until] = ACTIONS(1679),
    [anon_sym_rescue] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(1679),
    [anon_sym_do] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_RBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1679),
    [anon_sym_AMP_DOT] = ACTIONS(1679),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_COLON2] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1679),
    [anon_sym_and] = ACTIONS(1679),
    [anon_sym_or] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE] = ACTIONS(1679),
    [anon_sym_AMP_AMP] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(1679),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_BANG_EQ] = ACTIONS(1679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1679),
    [anon_sym_LT_EQ_GT] = ACTIONS(1679),
    [anon_sym_EQ_TILDE] = ACTIONS(1679),
    [anon_sym_BANG_TILDE] = ACTIONS(1679),
    [anon_sym_LT_EQ] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1679),
    [anon_sym_CARET] = ACTIONS(1679),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_SLASH] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(1679),
    [sym_comment] = ACTIONS(87),
  },
  [1313] = {
    [sym_heredoc_body] = STATE(3356),
    [aux_sym_call_repeat1] = STATE(3356),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1314] = {
    [sym_heredoc_body] = STATE(3356),
    [aux_sym_call_repeat1] = STATE(3356),
    [aux_sym_argument_list_repeat1] = STATE(3358),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1315] = {
    [anon_sym_EQ] = ACTIONS(5484),
    [sym_comment] = ACTIONS(87),
  },
  [1316] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5486),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5488),
    [anon_sym_DASH_EQ] = ACTIONS(5488),
    [anon_sym_STAR_EQ] = ACTIONS(5488),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5488),
    [anon_sym_SLASH_EQ] = ACTIONS(5488),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5488),
    [anon_sym_PIPE_EQ] = ACTIONS(5488),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5488),
    [anon_sym_AMP_EQ] = ACTIONS(5488),
    [anon_sym_PERCENT_EQ] = ACTIONS(5488),
    [anon_sym_GT_GT_EQ] = ACTIONS(5488),
    [anon_sym_LT_LT_EQ] = ACTIONS(5488),
    [anon_sym_CARET_EQ] = ACTIONS(5488),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1317] = {
    [sym_string] = STATE(1386),
    [aux_sym_chained_string_repeat1] = STATE(1386),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5490),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1318] = {
    [sym__heredoc_body_start] = ACTIONS(1699),
    [sym__binary_minus] = ACTIONS(1699),
    [sym__binary_star] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_in] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_COLON2] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [1319] = {
    [sym__heredoc_body_start] = ACTIONS(1703),
    [sym__binary_minus] = ACTIONS(1703),
    [sym__binary_star] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1705),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1320] = {
    [sym__heredoc_body_start] = ACTIONS(1707),
    [sym__binary_minus] = ACTIONS(1707),
    [sym__binary_star] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_DOT] = ACTIONS(1709),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_EQ] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_if] = ACTIONS(1707),
    [anon_sym_unless] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(1707),
    [anon_sym_until] = ACTIONS(1707),
    [anon_sym_rescue] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1707),
    [anon_sym_COLON_COLON2] = ACTIONS(1707),
    [anon_sym_AMP_DOT] = ACTIONS(1707),
    [anon_sym_QMARK] = ACTIONS(1707),
    [anon_sym_COLON2] = ACTIONS(1709),
    [anon_sym_DOT_DOT] = ACTIONS(1709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1707),
    [anon_sym_and] = ACTIONS(1707),
    [anon_sym_or] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1709),
    [anon_sym_BANG_EQ] = ACTIONS(1707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1707),
    [anon_sym_LT_EQ_GT] = ACTIONS(1707),
    [anon_sym_EQ_TILDE] = ACTIONS(1707),
    [anon_sym_BANG_TILDE] = ACTIONS(1707),
    [anon_sym_LT_EQ] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_GT_EQ] = ACTIONS(1707),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1321] = {
    [sym__then] = STATE(3361),
    [sym_heredoc_body] = STATE(979),
    [sym__terminator] = STATE(979),
    [sym__line_break] = ACTIONS(1743),
    [sym__heredoc_body_start] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(5492),
    [sym_comment] = ACTIONS(87),
  },
  [1322] = {
    [sym__then] = STATE(3362),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(5494),
    [sym_comment] = ACTIONS(87),
  },
  [1323] = {
    [sym__do] = STATE(3363),
    [sym_heredoc_body] = STATE(3363),
    [sym__terminator] = STATE(3363),
    [sym__line_break] = ACTIONS(5496),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [1324] = {
    [sym__do] = STATE(3364),
    [sym_heredoc_body] = STATE(3364),
    [sym__terminator] = STATE(3364),
    [sym__line_break] = ACTIONS(5498),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [1325] = {
    [sym_in] = STATE(3365),
    [anon_sym_in] = ACTIONS(1969),
    [sym_comment] = ACTIONS(87),
  },
  [1326] = {
    [sym_heredoc_body] = STATE(3366),
    [sym__terminator] = STATE(3366),
    [sym__line_break] = ACTIONS(5500),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [1327] = {
    [sym_when] = STATE(3367),
    [aux_sym_case_repeat1] = STATE(3368),
    [anon_sym_SEMI] = ACTIONS(5502),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1328] = {
    [sym_else] = STATE(3370),
    [sym_ensure] = STATE(3371),
    [sym_rescue] = STATE(3372),
    [anon_sym_end] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1329] = {
    [sym_ensure] = STATE(3371),
    [anon_sym_end] = ACTIONS(5504),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1330] = {
    [anon_sym_end] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [1331] = {
    [sym_else] = STATE(3370),
    [sym_ensure] = STATE(3371),
    [anon_sym_end] = ACTIONS(5504),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1332] = {
    [sym__heredoc_body_start] = ACTIONS(2187),
    [sym__binary_minus] = ACTIONS(2187),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_EQ] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_unless] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_until] = ACTIONS(2187),
    [anon_sym_rescue] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_EQ_GT] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_RBRACK] = ACTIONS(2187),
    [anon_sym_COLON_COLON2] = ACTIONS(2187),
    [anon_sym_AMP_DOT] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_COLON2] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2189),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_EQ_TILDE] = ACTIONS(2187),
    [anon_sym_BANG_TILDE] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2189),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [1333] = {
    [sym__statements] = STATE(1328),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1329),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1330),
    [sym_rescue] = STATE(1331),
    [sym__body_statement] = STATE(3373),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5506),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1334] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(2375),
    [anon_sym_DOT_DOT] = ACTIONS(2377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2379),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ_GT] = ACTIONS(2383),
    [anon_sym_EQ_TILDE] = ACTIONS(2383),
    [anon_sym_BANG_TILDE] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [1335] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1336] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(3374),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(3374),
    [sym_operator_assignment] = STATE(3374),
    [sym_conditional] = STATE(3374),
    [sym_range] = STATE(3374),
    [sym_binary] = STATE(3374),
    [sym_unary] = STATE(3374),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1337] = {
    [sym__heredoc_body_start] = ACTIONS(2267),
    [sym__binary_minus] = ACTIONS(2267),
    [sym__binary_star] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_RPAREN] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2269),
    [anon_sym_COMMA] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_STAR_STAR] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_unless] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_until] = ACTIONS(2267),
    [anon_sym_rescue] = ACTIONS(2267),
    [anon_sym_in] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_EQ_GT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_RBRACK] = ACTIONS(2267),
    [anon_sym_COLON_COLON2] = ACTIONS(2267),
    [anon_sym_AMP_DOT] = ACTIONS(2267),
    [anon_sym_QMARK] = ACTIONS(2267),
    [anon_sym_COLON2] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2267),
    [anon_sym_and] = ACTIONS(2267),
    [anon_sym_or] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2267),
    [anon_sym_AMP_AMP] = ACTIONS(2267),
    [anon_sym_LT_LT] = ACTIONS(2267),
    [anon_sym_GT_GT] = ACTIONS(2267),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2267),
    [anon_sym_LT_EQ_GT] = ACTIONS(2267),
    [anon_sym_EQ_TILDE] = ACTIONS(2267),
    [anon_sym_BANG_TILDE] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2267),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_PERCENT] = ACTIONS(2267),
    [sym_comment] = ACTIONS(87),
  },
  [1338] = {
    [sym__heredoc_body_start] = ACTIONS(2351),
    [sym__binary_minus] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2353),
    [anon_sym_COMMA] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_if] = ACTIONS(2351),
    [anon_sym_unless] = ACTIONS(2351),
    [anon_sym_while] = ACTIONS(2351),
    [anon_sym_until] = ACTIONS(2351),
    [anon_sym_rescue] = ACTIONS(2351),
    [anon_sym_in] = ACTIONS(2351),
    [anon_sym_do] = ACTIONS(2351),
    [anon_sym_EQ_GT] = ACTIONS(2351),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_RBRACK] = ACTIONS(2351),
    [anon_sym_COLON_COLON2] = ACTIONS(2351),
    [anon_sym_AMP_DOT] = ACTIONS(2351),
    [anon_sym_QMARK] = ACTIONS(2351),
    [anon_sym_COLON2] = ACTIONS(2353),
    [anon_sym_DOT_DOT] = ACTIONS(2353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2351),
    [anon_sym_or] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_CARET] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_SLASH] = ACTIONS(2351),
    [anon_sym_PERCENT] = ACTIONS(2351),
    [sym_comment] = ACTIONS(87),
  },
  [1339] = {
    [sym_heredoc_body] = STATE(3376),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(5508),
    [sym_comment] = ACTIONS(87),
  },
  [1340] = {
    [anon_sym_RBRACK] = ACTIONS(5508),
    [sym_comment] = ACTIONS(87),
  },
  [1341] = {
    [sym__statements] = STATE(3378),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(3379),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5510),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1342] = {
    [sym__statements] = STATE(3381),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(3382),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(3383),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(3383),
    [sym__line_break] = ACTIONS(5512),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5514),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1343] = {
    [sym_do_block] = STATE(3384),
    [sym_block] = STATE(3384),
    [anon_sym_LBRACE] = ACTIONS(2361),
    [anon_sym_do] = ACTIONS(5516),
    [sym_comment] = ACTIONS(87),
  },
  [1344] = {
    [sym__heredoc_body_start] = ACTIONS(2491),
    [sym__binary_minus] = ACTIONS(2491),
    [sym__binary_star] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2493),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_STAR_STAR] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_EQ] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_unless] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_until] = ACTIONS(2491),
    [anon_sym_rescue] = ACTIONS(2491),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_EQ_GT] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_RBRACK] = ACTIONS(2491),
    [anon_sym_COLON_COLON2] = ACTIONS(2491),
    [anon_sym_AMP_DOT] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2491),
    [anon_sym_COLON2] = ACTIONS(2493),
    [anon_sym_DOT_DOT] = ACTIONS(2493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2491),
    [anon_sym_and] = ACTIONS(2491),
    [anon_sym_or] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2491),
    [anon_sym_AMP_AMP] = ACTIONS(2491),
    [anon_sym_LT_LT] = ACTIONS(2491),
    [anon_sym_GT_GT] = ACTIONS(2491),
    [anon_sym_EQ_EQ] = ACTIONS(2493),
    [anon_sym_BANG_EQ] = ACTIONS(2491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ_GT] = ACTIONS(2491),
    [anon_sym_EQ_TILDE] = ACTIONS(2491),
    [anon_sym_BANG_TILDE] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_SLASH] = ACTIONS(2491),
    [anon_sym_PERCENT] = ACTIONS(2491),
    [sym_comment] = ACTIONS(87),
  },
  [1345] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3385),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(3385),
    [sym_operator_assignment] = STATE(3385),
    [sym_conditional] = STATE(3385),
    [sym_range] = STATE(3385),
    [sym_binary] = STATE(3385),
    [sym_unary] = STATE(3385),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1346] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3386),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(3386),
    [sym_operator_assignment] = STATE(3386),
    [sym_conditional] = STATE(3386),
    [sym_range] = STATE(3386),
    [sym_binary] = STATE(3386),
    [sym_unary] = STATE(3386),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1347] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3387),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(3387),
    [sym_operator_assignment] = STATE(3387),
    [sym_conditional] = STATE(3387),
    [sym_range] = STATE(3387),
    [sym_binary] = STATE(3387),
    [sym_unary] = STATE(3387),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1348] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3388),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(3388),
    [sym_operator_assignment] = STATE(3388),
    [sym_conditional] = STATE(3388),
    [sym_range] = STATE(3388),
    [sym_binary] = STATE(3388),
    [sym_unary] = STATE(3388),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1349] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3389),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(3389),
    [sym_operator_assignment] = STATE(3389),
    [sym_conditional] = STATE(3389),
    [sym_range] = STATE(3389),
    [sym_binary] = STATE(3389),
    [sym_unary] = STATE(3389),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1350] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3390),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(3390),
    [sym_operator_assignment] = STATE(3390),
    [sym_conditional] = STATE(3390),
    [sym_range] = STATE(3390),
    [sym_binary] = STATE(3390),
    [sym_unary] = STATE(3390),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1351] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3391),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(3391),
    [sym_operator_assignment] = STATE(3391),
    [sym_conditional] = STATE(3391),
    [sym_range] = STATE(3391),
    [sym_binary] = STATE(3391),
    [sym_unary] = STATE(3391),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1352] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3392),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(3392),
    [sym_operator_assignment] = STATE(3392),
    [sym_conditional] = STATE(3392),
    [sym_range] = STATE(3392),
    [sym_binary] = STATE(3392),
    [sym_unary] = STATE(3392),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1353] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3393),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(3393),
    [sym_operator_assignment] = STATE(3393),
    [sym_conditional] = STATE(3393),
    [sym_range] = STATE(3393),
    [sym_binary] = STATE(3393),
    [sym_unary] = STATE(3393),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1354] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3394),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(3394),
    [sym_operator_assignment] = STATE(3394),
    [sym_conditional] = STATE(3394),
    [sym_range] = STATE(3394),
    [sym_binary] = STATE(3394),
    [sym_unary] = STATE(3394),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1355] = {
    [sym_argument_list_with_parens] = STATE(3397),
    [sym__argument_list_with_parens] = STATE(3398),
    [sym_operator] = STATE(3397),
    [sym_heredoc_body] = STATE(3399),
    [aux_sym_call_repeat1] = STATE(3399),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(5518),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_STAR_STAR] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym_LT] = ACTIONS(5520),
    [anon_sym_LPAREN2] = ACTIONS(5522),
    [anon_sym_DOT_DOT] = ACTIONS(5518),
    [anon_sym_LT_LT] = ACTIONS(5518),
    [anon_sym_GT_GT] = ACTIONS(5518),
    [anon_sym_EQ_EQ] = ACTIONS(5520),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5518),
    [anon_sym_LT_EQ_GT] = ACTIONS(5518),
    [anon_sym_EQ_TILDE] = ACTIONS(5518),
    [anon_sym_BANG_TILDE] = ACTIONS(5518),
    [anon_sym_LT_EQ] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5520),
    [anon_sym_GT_EQ] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5518),
    [anon_sym_PLUS] = ACTIONS(5520),
    [anon_sym_SLASH] = ACTIONS(5518),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_BANG] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5518),
    [sym_constant] = ACTIONS(5524),
    [sym_identifier] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_PLUS_AT] = ACTIONS(5518),
    [anon_sym_DASH_AT] = ACTIONS(5518),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5520),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5518),
    [anon_sym_BQUOTE] = ACTIONS(5518),
    [sym_comment] = ACTIONS(87),
  },
  [1356] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(3401),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(3402),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1357] = {
    [sym_constant] = ACTIONS(5528),
    [sym_identifier] = ACTIONS(5528),
    [sym_comment] = ACTIONS(87),
  },
  [1358] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3404),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(3404),
    [sym_operator_assignment] = STATE(3404),
    [sym_conditional] = STATE(3404),
    [sym_range] = STATE(3404),
    [sym_binary] = STATE(3404),
    [sym_unary] = STATE(3404),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1359] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3406),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(3406),
    [sym_operator_assignment] = STATE(3406),
    [sym_conditional] = STATE(3406),
    [sym_range] = STATE(3406),
    [sym_binary] = STATE(3406),
    [sym_unary] = STATE(3406),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1360] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3407),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1361] = {
    [anon_sym_COLON] = ACTIONS(5532),
    [sym_comment] = ACTIONS(87),
  },
  [1362] = {
    [sym__statements] = STATE(3410),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(3411),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1939),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1940),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5534),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1363] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3412),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(3412),
    [sym_operator_assignment] = STATE(3412),
    [sym_conditional] = STATE(3412),
    [sym_range] = STATE(3412),
    [sym_binary] = STATE(3412),
    [sym_unary] = STATE(3412),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1364] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1372),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(1953),
    [sym__argument_list_with_parens] = STATE(1375),
    [sym__argument] = STATE(1376),
    [sym_splat_argument] = STATE(1376),
    [sym_hash_splat_argument] = STATE(1376),
    [sym_block_argument] = STATE(1376),
    [sym_assignment] = STATE(1372),
    [sym_operator_assignment] = STATE(1372),
    [sym_conditional] = STATE(1372),
    [sym_range] = STATE(1372),
    [sym_binary] = STATE(1372),
    [sym_unary] = STATE(1372),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1380),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1376),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2401),
    [sym__splat_star] = ACTIONS(2403),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_identifier] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1365] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1372),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(1954),
    [sym__argument_list_with_parens] = STATE(1375),
    [sym__argument] = STATE(1376),
    [sym_splat_argument] = STATE(1376),
    [sym_hash_splat_argument] = STATE(1376),
    [sym_block_argument] = STATE(1376),
    [sym_assignment] = STATE(1372),
    [sym_operator_assignment] = STATE(1372),
    [sym_conditional] = STATE(1372),
    [sym_range] = STATE(1372),
    [sym_binary] = STATE(1372),
    [sym_unary] = STATE(1372),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1380),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1376),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2401),
    [sym__splat_star] = ACTIONS(2403),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_identifier] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1366] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1372),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(1955),
    [sym__argument_list_with_parens] = STATE(1375),
    [sym__argument] = STATE(1376),
    [sym_splat_argument] = STATE(1376),
    [sym_hash_splat_argument] = STATE(1376),
    [sym_block_argument] = STATE(1376),
    [sym_assignment] = STATE(1372),
    [sym_operator_assignment] = STATE(1372),
    [sym_conditional] = STATE(1372),
    [sym_range] = STATE(1372),
    [sym_binary] = STATE(1372),
    [sym_unary] = STATE(1372),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1380),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1376),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2401),
    [sym__splat_star] = ACTIONS(2403),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_identifier] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1367] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1372),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(1956),
    [sym__argument_list_with_parens] = STATE(1375),
    [sym__argument] = STATE(1376),
    [sym_splat_argument] = STATE(1376),
    [sym_hash_splat_argument] = STATE(1376),
    [sym_block_argument] = STATE(1376),
    [sym_assignment] = STATE(1372),
    [sym_operator_assignment] = STATE(1372),
    [sym_conditional] = STATE(1372),
    [sym_range] = STATE(1372),
    [sym_binary] = STATE(1372),
    [sym_unary] = STATE(1372),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1380),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1376),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2401),
    [sym__splat_star] = ACTIONS(2403),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_identifier] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1368] = {
    [sym__statements] = STATE(3414),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(3415),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(3416),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(3416),
    [sym__line_break] = ACTIONS(5536),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5538),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1369] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3417),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(3417),
    [sym_operator_assignment] = STATE(3417),
    [sym_conditional] = STATE(3417),
    [sym_range] = STATE(3417),
    [sym_binary] = STATE(3417),
    [sym_unary] = STATE(3417),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1370] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1978),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(1978),
    [sym_operator_assignment] = STATE(1978),
    [sym_conditional] = STATE(1978),
    [sym_range] = STATE(1978),
    [sym_binary] = STATE(1978),
    [sym_unary] = STATE(1978),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1371] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(5540),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1372] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_RBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [1373] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1372),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(1375),
    [sym__argument] = STATE(1376),
    [sym_splat_argument] = STATE(1376),
    [sym_hash_splat_argument] = STATE(1376),
    [sym_block_argument] = STATE(1376),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(1372),
    [sym_operator_assignment] = STATE(1372),
    [sym_conditional] = STATE(1372),
    [sym_range] = STATE(1372),
    [sym_binary] = STATE(1372),
    [sym_unary] = STATE(1372),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1380),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1376),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2401),
    [sym__splat_star] = ACTIONS(2403),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_identifier] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1374] = {
    [sym_do_block] = STATE(3429),
    [sym_block] = STATE(3429),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(3372),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(5570),
    [anon_sym_EQ_GT] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_RBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_COLON2] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [1375] = {
    [sym_heredoc_body] = STATE(3430),
    [aux_sym_call_repeat1] = STATE(3430),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1376] = {
    [sym_heredoc_body] = STATE(3430),
    [aux_sym_call_repeat1] = STATE(3430),
    [aux_sym_argument_list_repeat1] = STATE(3432),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(5572),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1377] = {
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_in] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_EQ_GT] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_RBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_COLON2] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [1378] = {
    [anon_sym_EQ] = ACTIONS(5574),
    [sym_comment] = ACTIONS(87),
  },
  [1379] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5576),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5578),
    [anon_sym_DASH_EQ] = ACTIONS(5578),
    [anon_sym_STAR_EQ] = ACTIONS(5578),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5578),
    [anon_sym_SLASH_EQ] = ACTIONS(5578),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5578),
    [anon_sym_PIPE_EQ] = ACTIONS(5578),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5578),
    [anon_sym_AMP_EQ] = ACTIONS(5578),
    [anon_sym_PERCENT_EQ] = ACTIONS(5578),
    [anon_sym_GT_GT_EQ] = ACTIONS(5578),
    [anon_sym_LT_LT_EQ] = ACTIONS(5578),
    [anon_sym_CARET_EQ] = ACTIONS(5578),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1380] = {
    [sym_string] = STATE(3435),
    [aux_sym_chained_string_repeat1] = STATE(3435),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5580),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1381] = {
    [sym__line_break] = ACTIONS(5582),
    [sym__heredoc_body_start] = ACTIONS(5582),
    [sym__binary_minus] = ACTIONS(5582),
    [sym__binary_star] = ACTIONS(5582),
    [ts_builtin_sym_end] = ACTIONS(5582),
    [anon_sym___END__] = ACTIONS(5582),
    [anon_sym_LBRACE] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_STAR_STAR] = ACTIONS(5582),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_end] = ACTIONS(5582),
    [anon_sym_if] = ACTIONS(5582),
    [anon_sym_unless] = ACTIONS(5582),
    [anon_sym_while] = ACTIONS(5582),
    [anon_sym_until] = ACTIONS(5582),
    [anon_sym_rescue] = ACTIONS(5582),
    [anon_sym_do] = ACTIONS(5582),
    [anon_sym_when] = ACTIONS(5582),
    [anon_sym_elsif] = ACTIONS(5582),
    [anon_sym_else] = ACTIONS(5582),
    [anon_sym_then] = ACTIONS(5582),
    [anon_sym_ensure] = ACTIONS(5582),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON_COLON2] = ACTIONS(5582),
    [anon_sym_AMP_DOT] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5584),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ_GT] = ACTIONS(5582),
    [anon_sym_EQ_TILDE] = ACTIONS(5582),
    [anon_sym_BANG_TILDE] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5582),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [sym_comment] = ACTIONS(87),
  },
  [1382] = {
    [anon_sym_RBRACK] = ACTIONS(5586),
    [sym_comment] = ACTIONS(87),
  },
  [1383] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(3438),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(3439),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(5588),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(5590),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1384] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3441),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_splat_argument] = STATE(3443),
    [sym_assignment] = STATE(3441),
    [sym_operator_assignment] = STATE(3441),
    [sym_conditional] = STATE(3441),
    [sym_range] = STATE(3441),
    [sym_binary] = STATE(3441),
    [sym_unary] = STATE(3441),
    [sym_right_assignment_list] = STATE(3442),
    [sym__arg_or_splat_arg] = STATE(3443),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(5592),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1385] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3444),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(3444),
    [sym_operator_assignment] = STATE(3444),
    [sym_conditional] = STATE(3444),
    [sym_range] = STATE(3444),
    [sym_binary] = STATE(3444),
    [sym_unary] = STATE(3444),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1386] = {
    [sym_string] = STATE(3445),
    [aux_sym_chained_string_repeat1] = STATE(3445),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_RBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [1387] = {
    [sym__line_break] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [ts_builtin_sym_end] = ACTIONS(5594),
    [anon_sym___END__] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5594),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_end] = ACTIONS(5594),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_when] = ACTIONS(5594),
    [anon_sym_elsif] = ACTIONS(5594),
    [anon_sym_else] = ACTIONS(5594),
    [anon_sym_then] = ACTIONS(5594),
    [anon_sym_ensure] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5594),
    [anon_sym_AMP_AMP] = ACTIONS(5594),
    [anon_sym_LT_LT] = ACTIONS(5594),
    [anon_sym_GT_GT] = ACTIONS(5594),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5594),
    [anon_sym_PLUS] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5594),
    [anon_sym_PERCENT] = ACTIONS(5594),
    [sym_comment] = ACTIONS(87),
  },
  [1388] = {
    [sym__formal_parameter] = STATE(3450),
    [sym__simple_formal_parameter] = STATE(3450),
    [sym_destructured_parameter] = STATE(3450),
    [sym_splat_parameter] = STATE(3450),
    [sym_hash_splat_parameter] = STATE(3450),
    [sym_block_parameter] = STATE(3450),
    [sym_keyword_parameter] = STATE(3450),
    [sym_optional_parameter] = STATE(3450),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(5598),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI] = ACTIONS(5602),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5604),
    [sym_comment] = ACTIONS(87),
  },
  [1389] = {
    [anon_sym_RBRACE] = ACTIONS(5606),
    [sym_comment] = ACTIONS(87),
  },
  [1390] = {
    [sym__statements] = STATE(3452),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5606),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1391] = {
    [sym__formal_parameter] = STATE(3453),
    [sym__simple_formal_parameter] = STATE(3453),
    [sym_destructured_parameter] = STATE(3453),
    [sym_splat_parameter] = STATE(3453),
    [sym_hash_splat_parameter] = STATE(3453),
    [sym_block_parameter] = STATE(3453),
    [sym_keyword_parameter] = STATE(3453),
    [sym_optional_parameter] = STATE(3453),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2457),
    [sym_comment] = ACTIONS(87),
  },
  [1392] = {
    [anon_sym_LBRACE] = ACTIONS(5608),
    [anon_sym_do] = ACTIONS(5608),
    [sym_comment] = ACTIONS(87),
  },
  [1393] = {
    [anon_sym_RPAREN] = ACTIONS(2479),
    [anon_sym_COMMA] = ACTIONS(2479),
    [anon_sym_COLON] = ACTIONS(5610),
    [anon_sym_EQ] = ACTIONS(5612),
    [sym_comment] = ACTIONS(87),
  },
  [1394] = {
    [aux_sym_method_parameters_repeat1] = STATE(3458),
    [anon_sym_RPAREN] = ACTIONS(5614),
    [anon_sym_COMMA] = ACTIONS(5616),
    [sym_comment] = ACTIONS(87),
  },
  [1395] = {
    [anon_sym_LBRACE] = ACTIONS(5618),
    [anon_sym_RPAREN] = ACTIONS(5618),
    [anon_sym_COMMA] = ACTIONS(5618),
    [anon_sym_PIPE] = ACTIONS(5618),
    [anon_sym_SEMI] = ACTIONS(5618),
    [anon_sym_do] = ACTIONS(5618),
    [sym_comment] = ACTIONS(87),
  },
  [1396] = {
    [anon_sym_LBRACE] = ACTIONS(5620),
    [anon_sym_RPAREN] = ACTIONS(5620),
    [anon_sym_COMMA] = ACTIONS(5620),
    [anon_sym_PIPE] = ACTIONS(5620),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym_do] = ACTIONS(5620),
    [sym_comment] = ACTIONS(87),
  },
  [1397] = {
    [anon_sym_LBRACE] = ACTIONS(5622),
    [anon_sym_RPAREN] = ACTIONS(5622),
    [anon_sym_COMMA] = ACTIONS(5622),
    [anon_sym_PIPE] = ACTIONS(5622),
    [anon_sym_SEMI] = ACTIONS(5622),
    [anon_sym_do] = ACTIONS(5622),
    [sym_comment] = ACTIONS(87),
  },
  [1398] = {
    [sym__formal_parameter] = STATE(3462),
    [sym__simple_formal_parameter] = STATE(3462),
    [sym_destructured_parameter] = STATE(3462),
    [sym_splat_parameter] = STATE(3462),
    [sym_hash_splat_parameter] = STATE(3462),
    [sym_block_parameter] = STATE(3462),
    [sym_keyword_parameter] = STATE(3462),
    [sym_optional_parameter] = STATE(3462),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5604),
    [sym_comment] = ACTIONS(87),
  },
  [1399] = {
    [sym__line_break] = ACTIONS(5630),
    [sym__heredoc_body_start] = ACTIONS(5630),
    [sym__binary_minus] = ACTIONS(5630),
    [sym__binary_star] = ACTIONS(5630),
    [ts_builtin_sym_end] = ACTIONS(5630),
    [anon_sym___END__] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5630),
    [anon_sym_RPAREN] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_STAR_STAR] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5632),
    [anon_sym_end] = ACTIONS(5630),
    [anon_sym_if] = ACTIONS(5630),
    [anon_sym_unless] = ACTIONS(5630),
    [anon_sym_while] = ACTIONS(5630),
    [anon_sym_until] = ACTIONS(5630),
    [anon_sym_rescue] = ACTIONS(5630),
    [anon_sym_do] = ACTIONS(5630),
    [anon_sym_when] = ACTIONS(5630),
    [anon_sym_elsif] = ACTIONS(5630),
    [anon_sym_else] = ACTIONS(5630),
    [anon_sym_then] = ACTIONS(5630),
    [anon_sym_ensure] = ACTIONS(5630),
    [anon_sym_EQ_GT] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5630),
    [anon_sym_AMP_AMP] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5630),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5630),
    [anon_sym_EQ_TILDE] = ACTIONS(5630),
    [anon_sym_BANG_TILDE] = ACTIONS(5630),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5630),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5630),
    [sym_comment] = ACTIONS(87),
  },
  [1400] = {
    [anon_sym_end] = ACTIONS(5634),
    [sym_comment] = ACTIONS(87),
  },
  [1401] = {
    [sym__statements] = STATE(3464),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(3465),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(3465),
    [sym__line_break] = ACTIONS(5636),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5638),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1402] = {
    [sym__statements] = STATE(3464),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(3466),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5638),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1403] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3474),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(3474),
    [sym_operator_assignment] = STATE(3474),
    [sym_conditional] = STATE(3474),
    [sym_range] = STATE(3474),
    [sym_binary] = STATE(3474),
    [sym_unary] = STATE(3474),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(5652),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1404] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3479),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(3479),
    [sym_operator_assignment] = STATE(3479),
    [sym_conditional] = STATE(3479),
    [sym_range] = STATE(3479),
    [sym_binary] = STATE(3479),
    [sym_unary] = STATE(3479),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1405] = {
    [sym__line_break] = ACTIONS(5666),
    [sym__heredoc_body_start] = ACTIONS(5666),
    [sym__binary_minus] = ACTIONS(5666),
    [sym__binary_star] = ACTIONS(5666),
    [ts_builtin_sym_end] = ACTIONS(5666),
    [anon_sym___END__] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_STAR_STAR] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_end] = ACTIONS(5666),
    [anon_sym_if] = ACTIONS(5666),
    [anon_sym_unless] = ACTIONS(5666),
    [anon_sym_while] = ACTIONS(5666),
    [anon_sym_until] = ACTIONS(5666),
    [anon_sym_rescue] = ACTIONS(5666),
    [anon_sym_do] = ACTIONS(5666),
    [anon_sym_when] = ACTIONS(5666),
    [anon_sym_elsif] = ACTIONS(5666),
    [anon_sym_else] = ACTIONS(5666),
    [anon_sym_then] = ACTIONS(5666),
    [anon_sym_ensure] = ACTIONS(5666),
    [anon_sym_EQ_GT] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_COLON_COLON2] = ACTIONS(5666),
    [anon_sym_AMP_DOT] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_and] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5666),
    [anon_sym_LT_LT] = ACTIONS(5666),
    [anon_sym_GT_GT] = ACTIONS(5666),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_EQ_TILDE] = ACTIONS(5666),
    [anon_sym_BANG_TILDE] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_CARET] = ACTIONS(5666),
    [anon_sym_PLUS] = ACTIONS(5666),
    [anon_sym_SLASH] = ACTIONS(5666),
    [anon_sym_PERCENT] = ACTIONS(5666),
    [sym_comment] = ACTIONS(87),
  },
  [1406] = {
    [sym__simple_formal_parameter] = STATE(3480),
    [sym_splat_parameter] = STATE(3480),
    [sym_hash_splat_parameter] = STATE(3480),
    [sym_block_parameter] = STATE(3480),
    [sym_keyword_parameter] = STATE(3480),
    [sym_optional_parameter] = STATE(3480),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5670),
    [sym_comment] = ACTIONS(87),
  },
  [1407] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(3481),
    [anon_sym_LBRACE] = ACTIONS(5608),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_do] = ACTIONS(5608),
    [sym_comment] = ACTIONS(87),
  },
  [1408] = {
    [sym_uninterpreted] = ACTIONS(5672),
    [sym_comment] = ACTIONS(109),
  },
  [1409] = {
    [sym__line_break] = ACTIONS(5674),
    [sym__heredoc_body_start] = ACTIONS(5674),
    [ts_builtin_sym_end] = ACTIONS(5674),
    [anon_sym___END__] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5674),
    [anon_sym_end] = ACTIONS(5674),
    [anon_sym_rescue] = ACTIONS(5674),
    [anon_sym_when] = ACTIONS(5674),
    [anon_sym_elsif] = ACTIONS(5674),
    [anon_sym_else] = ACTIONS(5674),
    [anon_sym_ensure] = ACTIONS(5674),
    [sym_comment] = ACTIONS(87),
  },
  [1410] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(45),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(45),
    [sym_unless_modifier] = STATE(45),
    [sym_while_modifier] = STATE(45),
    [sym_until_modifier] = STATE(45),
    [sym_rescue_modifier] = STATE(45),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(46),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(46),
    [sym_operator_assignment] = STATE(46),
    [sym_conditional] = STATE(46),
    [sym_range] = STATE(46),
    [sym_binary] = STATE(46),
    [sym_unary] = STATE(46),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_undef] = STATE(45),
    [sym_alias] = STATE(45),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(45),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [ts_builtin_sym_end] = ACTIONS(5676),
    [anon_sym___END__] = ACTIONS(5678),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [anon_sym_undef] = ACTIONS(83),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1411] = {
    [sym_heredoc_body] = STATE(3483),
    [sym__terminator] = STATE(3483),
    [aux_sym__statements_repeat1] = STATE(1411),
    [sym__line_break] = ACTIONS(5680),
    [sym__heredoc_body_start] = ACTIONS(5683),
    [ts_builtin_sym_end] = ACTIONS(5674),
    [anon_sym___END__] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5680),
    [sym_comment] = ACTIONS(87),
  },
  [1412] = {
    [sym__line_break] = ACTIONS(5686),
    [sym__heredoc_body_start] = ACTIONS(5686),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5686),
    [anon_sym___END__] = ACTIONS(5686),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(721),
    [anon_sym_or] = ACTIONS(721),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1413] = {
    [sym__line_break] = ACTIONS(5688),
    [sym__heredoc_body_start] = ACTIONS(5688),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5688),
    [anon_sym___END__] = ACTIONS(5688),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(721),
    [anon_sym_or] = ACTIONS(721),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1414] = {
    [sym__line_break] = ACTIONS(5690),
    [sym__heredoc_body_start] = ACTIONS(5690),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5690),
    [anon_sym___END__] = ACTIONS(5690),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(721),
    [anon_sym_or] = ACTIONS(721),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1415] = {
    [sym__line_break] = ACTIONS(5692),
    [sym__heredoc_body_start] = ACTIONS(5692),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5692),
    [anon_sym___END__] = ACTIONS(5692),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(721),
    [anon_sym_or] = ACTIONS(721),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1416] = {
    [sym__line_break] = ACTIONS(5694),
    [sym__heredoc_body_start] = ACTIONS(5694),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5694),
    [anon_sym___END__] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(721),
    [anon_sym_or] = ACTIONS(721),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1417] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1418] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [1419] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1420] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1421] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1422] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(3485),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(5700),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1423] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3486),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(3486),
    [sym_operator_assignment] = STATE(3486),
    [sym_conditional] = STATE(3486),
    [sym_range] = STATE(3486),
    [sym_binary] = STATE(3486),
    [sym_unary] = STATE(3486),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1424] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(562),
    [sym__argument_list_with_parens] = STATE(3501),
    [sym__argument] = STATE(3502),
    [sym_splat_argument] = STATE(3502),
    [sym_hash_splat_argument] = STATE(3502),
    [sym_block_argument] = STATE(3502),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3502),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1425] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(568),
    [sym__argument_list_with_parens] = STATE(3501),
    [sym__argument] = STATE(3502),
    [sym_splat_argument] = STATE(3502),
    [sym_hash_splat_argument] = STATE(3502),
    [sym_block_argument] = STATE(3502),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3502),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1426] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(3501),
    [sym__argument] = STATE(3502),
    [sym_splat_argument] = STATE(3502),
    [sym_hash_splat_argument] = STATE(3502),
    [sym_block_argument] = STATE(3502),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3502),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1427] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(3501),
    [sym__argument] = STATE(3502),
    [sym_splat_argument] = STATE(3502),
    [sym_hash_splat_argument] = STATE(3502),
    [sym_block_argument] = STATE(3502),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3502),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1428] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3506),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(3506),
    [sym_operator_assignment] = STATE(3506),
    [sym_conditional] = STATE(3506),
    [sym_range] = STATE(3506),
    [sym_binary] = STATE(3506),
    [sym_unary] = STATE(3506),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1429] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1430] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(5744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [1431] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3530),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(1662),
    [sym__argument_list_with_parens] = STATE(3532),
    [sym__argument] = STATE(3533),
    [sym_splat_argument] = STATE(3533),
    [sym_hash_splat_argument] = STATE(3533),
    [sym_block_argument] = STATE(3533),
    [sym_do_block] = STATE(1665),
    [sym_block] = STATE(1665),
    [sym_assignment] = STATE(3530),
    [sym_operator_assignment] = STATE(3530),
    [sym_conditional] = STATE(3530),
    [sym_range] = STATE(3530),
    [sym_binary] = STATE(3530),
    [sym_unary] = STATE(3530),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3536),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3533),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5762),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_COLON2] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5786),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1432] = {
    [anon_sym_EQ] = ACTIONS(5792),
    [sym_comment] = ACTIONS(87),
  },
  [1433] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5794),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5796),
    [anon_sym_DASH_EQ] = ACTIONS(5796),
    [anon_sym_STAR_EQ] = ACTIONS(5796),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5796),
    [anon_sym_SLASH_EQ] = ACTIONS(5796),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5796),
    [anon_sym_PIPE_EQ] = ACTIONS(5796),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5796),
    [anon_sym_AMP_EQ] = ACTIONS(5796),
    [anon_sym_PERCENT_EQ] = ACTIONS(5796),
    [anon_sym_GT_GT_EQ] = ACTIONS(5796),
    [anon_sym_LT_LT_EQ] = ACTIONS(5796),
    [anon_sym_CARET_EQ] = ACTIONS(5796),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1434] = {
    [sym_string] = STATE(3539),
    [aux_sym_chained_string_repeat1] = STATE(3539),
    [sym__string_start] = ACTIONS(2503),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1435] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5798),
    [anon_sym___END__] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1436] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1437] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1438] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1439] = {
    [sym_interpolation] = STATE(3541),
    [aux_sym_heredoc_body_repeat1] = STATE(3541),
    [sym__heredoc_content] = ACTIONS(5800),
    [sym_heredoc_end] = ACTIONS(5802),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(5800),
  },
  [1440] = {
    [sym__line_break] = ACTIONS(1263),
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym___END__] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_end] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_when] = ACTIONS(1265),
    [anon_sym_elsif] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_then] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_ensure] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [1441] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(3543),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(3544),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(5804),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1442] = {
    [sym__line_break] = ACTIONS(5806),
    [sym__simple_symbol] = ACTIONS(5806),
    [sym__string_start] = ACTIONS(5806),
    [sym__symbol_start] = ACTIONS(5806),
    [sym__subshell_start] = ACTIONS(5806),
    [sym__regex_start] = ACTIONS(5806),
    [sym__string_array_start] = ACTIONS(5806),
    [sym__symbol_array_start] = ACTIONS(5806),
    [sym__heredoc_body_start] = ACTIONS(5806),
    [sym_heredoc_beginning] = ACTIONS(5806),
    [sym__block_ampersand] = ACTIONS(5806),
    [sym__splat_star] = ACTIONS(5806),
    [sym__unary_minus] = ACTIONS(5806),
    [sym__binary_minus] = ACTIONS(5806),
    [sym__binary_star] = ACTIONS(5806),
    [sym__identifier_hash_key] = ACTIONS(5806),
    [ts_builtin_sym_end] = ACTIONS(5806),
    [anon_sym___END__] = ACTIONS(5808),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_RBRACE] = ACTIONS(5806),
    [anon_sym_def] = ACTIONS(5808),
    [anon_sym_LPAREN] = ACTIONS(5808),
    [anon_sym_RPAREN] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_COLON_COLON] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_SEMI] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5808),
    [anon_sym_AMP] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_class] = ACTIONS(5808),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_module] = ACTIONS(5808),
    [anon_sym_end] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_yield] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_next] = ACTIONS(5808),
    [sym_redo] = ACTIONS(5808),
    [sym_retry] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_unless] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_until] = ACTIONS(5808),
    [anon_sym_rescue] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_when] = ACTIONS(5808),
    [anon_sym_elsif] = ACTIONS(5808),
    [anon_sym_else] = ACTIONS(5808),
    [anon_sym_then] = ACTIONS(5808),
    [anon_sym_begin] = ACTIONS(5808),
    [anon_sym_ensure] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_COLON_COLON2] = ACTIONS(5806),
    [anon_sym_AMP_DOT] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_PLUS_EQ] = ACTIONS(5806),
    [anon_sym_DASH_EQ] = ACTIONS(5806),
    [anon_sym_STAR_EQ] = ACTIONS(5806),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5806),
    [anon_sym_AMP_EQ] = ACTIONS(5806),
    [anon_sym_PERCENT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_LT_LT_EQ] = ACTIONS(5806),
    [anon_sym_CARET_EQ] = ACTIONS(5806),
    [anon_sym_QMARK] = ACTIONS(5808),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_and] = ACTIONS(5808),
    [anon_sym_or] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_AMP_AMP] = ACTIONS(5808),
    [anon_sym_LT_LT] = ACTIONS(5808),
    [anon_sym_GT_GT] = ACTIONS(5808),
    [anon_sym_EQ_EQ] = ACTIONS(5808),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5806),
    [anon_sym_BANG_TILDE] = ACTIONS(5806),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_SLASH] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5808),
    [anon_sym_defined_QMARK] = ACTIONS(5806),
    [anon_sym_not] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_TILDE] = ACTIONS(5806),
    [sym_constant] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_instance_variable] = ACTIONS(5806),
    [sym_class_variable] = ACTIONS(5806),
    [sym_global_variable] = ACTIONS(5806),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5808),
    [sym_float] = ACTIONS(5808),
    [sym_complex] = ACTIONS(5806),
    [sym_super] = ACTIONS(5808),
    [anon_sym_true] = ACTIONS(5808),
    [anon_sym_TRUE] = ACTIONS(5808),
    [anon_sym_false] = ACTIONS(5808),
    [anon_sym_FALSE] = ACTIONS(5808),
    [sym_self] = ACTIONS(5808),
    [anon_sym_nil] = ACTIONS(5808),
    [anon_sym_NIL] = ACTIONS(5808),
    [sym_character] = ACTIONS(5806),
    [anon_sym_LBRACK2] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5806),
  },
  [1443] = {
    [sym__line_break] = ACTIONS(5810),
    [sym__simple_symbol] = ACTIONS(5810),
    [sym__string_start] = ACTIONS(5810),
    [sym__symbol_start] = ACTIONS(5810),
    [sym__subshell_start] = ACTIONS(5810),
    [sym__regex_start] = ACTIONS(5810),
    [sym__string_array_start] = ACTIONS(5810),
    [sym__symbol_array_start] = ACTIONS(5810),
    [sym__heredoc_body_start] = ACTIONS(5810),
    [sym_heredoc_beginning] = ACTIONS(5810),
    [sym__block_ampersand] = ACTIONS(5810),
    [sym__splat_star] = ACTIONS(5810),
    [sym__unary_minus] = ACTIONS(5810),
    [sym__binary_minus] = ACTIONS(5810),
    [sym__binary_star] = ACTIONS(5810),
    [sym__identifier_hash_key] = ACTIONS(5810),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [anon_sym___END__] = ACTIONS(5812),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [anon_sym_def] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(5812),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_COLON_COLON] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_PIPE] = ACTIONS(5812),
    [anon_sym_SEMI] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_STAR_STAR] = ACTIONS(5812),
    [anon_sym_AMP] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_class] = ACTIONS(5812),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_module] = ACTIONS(5812),
    [anon_sym_end] = ACTIONS(5812),
    [anon_sym_return] = ACTIONS(5812),
    [anon_sym_yield] = ACTIONS(5812),
    [anon_sym_break] = ACTIONS(5812),
    [anon_sym_next] = ACTIONS(5812),
    [sym_redo] = ACTIONS(5812),
    [sym_retry] = ACTIONS(5812),
    [anon_sym_if] = ACTIONS(5812),
    [anon_sym_unless] = ACTIONS(5812),
    [anon_sym_while] = ACTIONS(5812),
    [anon_sym_until] = ACTIONS(5812),
    [anon_sym_rescue] = ACTIONS(5812),
    [anon_sym_for] = ACTIONS(5812),
    [anon_sym_do] = ACTIONS(5812),
    [anon_sym_case] = ACTIONS(5812),
    [anon_sym_when] = ACTIONS(5812),
    [anon_sym_elsif] = ACTIONS(5812),
    [anon_sym_else] = ACTIONS(5812),
    [anon_sym_then] = ACTIONS(5812),
    [anon_sym_begin] = ACTIONS(5812),
    [anon_sym_ensure] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_COLON_COLON2] = ACTIONS(5810),
    [anon_sym_AMP_DOT] = ACTIONS(5810),
    [anon_sym_LPAREN2] = ACTIONS(5810),
    [anon_sym_PLUS_EQ] = ACTIONS(5810),
    [anon_sym_DASH_EQ] = ACTIONS(5810),
    [anon_sym_STAR_EQ] = ACTIONS(5810),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5810),
    [anon_sym_AMP_EQ] = ACTIONS(5810),
    [anon_sym_PERCENT_EQ] = ACTIONS(5810),
    [anon_sym_GT_GT_EQ] = ACTIONS(5810),
    [anon_sym_LT_LT_EQ] = ACTIONS(5810),
    [anon_sym_CARET_EQ] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5812),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(5812),
    [anon_sym_or] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_GT_GT] = ACTIONS(5812),
    [anon_sym_EQ_EQ] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5810),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_EQ_TILDE] = ACTIONS(5810),
    [anon_sym_BANG_TILDE] = ACTIONS(5810),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_GT] = ACTIONS(5812),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5812),
    [anon_sym_PLUS] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5812),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_defined_QMARK] = ACTIONS(5810),
    [anon_sym_not] = ACTIONS(5812),
    [anon_sym_BANG] = ACTIONS(5812),
    [anon_sym_TILDE] = ACTIONS(5810),
    [sym_constant] = ACTIONS(5812),
    [sym_identifier] = ACTIONS(5812),
    [sym_instance_variable] = ACTIONS(5810),
    [sym_class_variable] = ACTIONS(5810),
    [sym_global_variable] = ACTIONS(5810),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5812),
    [sym_float] = ACTIONS(5812),
    [sym_complex] = ACTIONS(5810),
    [sym_super] = ACTIONS(5812),
    [anon_sym_true] = ACTIONS(5812),
    [anon_sym_TRUE] = ACTIONS(5812),
    [anon_sym_false] = ACTIONS(5812),
    [anon_sym_FALSE] = ACTIONS(5812),
    [sym_self] = ACTIONS(5812),
    [anon_sym_nil] = ACTIONS(5812),
    [anon_sym_NIL] = ACTIONS(5812),
    [sym_character] = ACTIONS(5810),
    [anon_sym_LBRACK2] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5810),
  },
  [1444] = {
    [sym_argument_list_with_parens] = STATE(3545),
    [sym__argument_list_with_parens] = STATE(1443),
    [sym_operator] = STATE(3545),
    [sym_heredoc_body] = STATE(3546),
    [aux_sym_call_repeat1] = STATE(3546),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(2531),
    [anon_sym_STAR_STAR] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_LPAREN2] = ACTIONS(2533),
    [anon_sym_DOT_DOT] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2529),
    [anon_sym_GT_GT] = ACTIONS(2529),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2529),
    [anon_sym_LT_EQ_GT] = ACTIONS(2529),
    [anon_sym_EQ_TILDE] = ACTIONS(2529),
    [anon_sym_BANG_TILDE] = ACTIONS(2529),
    [anon_sym_LT_EQ] = ACTIONS(2531),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_CARET] = ACTIONS(2529),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2529),
    [anon_sym_PERCENT] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(2531),
    [anon_sym_TILDE] = ACTIONS(2529),
    [sym_constant] = ACTIONS(5814),
    [sym_identifier] = ACTIONS(5814),
    [anon_sym_DASH] = ACTIONS(2531),
    [anon_sym_PLUS_AT] = ACTIONS(2529),
    [anon_sym_DASH_AT] = ACTIONS(2529),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2531),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2529),
    [anon_sym_BQUOTE] = ACTIONS(2529),
    [sym_comment] = ACTIONS(87),
  },
  [1445] = {
    [sym__line_break] = ACTIONS(5816),
    [sym__heredoc_body_start] = ACTIONS(5816),
    [sym__binary_minus] = ACTIONS(5816),
    [sym__binary_star] = ACTIONS(5816),
    [ts_builtin_sym_end] = ACTIONS(5816),
    [anon_sym___END__] = ACTIONS(5816),
    [anon_sym_LBRACE] = ACTIONS(5816),
    [anon_sym_RBRACE] = ACTIONS(5816),
    [anon_sym_RPAREN] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5816),
    [anon_sym_PIPE] = ACTIONS(5818),
    [anon_sym_SEMI] = ACTIONS(5816),
    [anon_sym_STAR_STAR] = ACTIONS(5818),
    [anon_sym_AMP] = ACTIONS(5818),
    [anon_sym_EQ] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5818),
    [anon_sym_end] = ACTIONS(5816),
    [anon_sym_if] = ACTIONS(5816),
    [anon_sym_unless] = ACTIONS(5816),
    [anon_sym_while] = ACTIONS(5816),
    [anon_sym_until] = ACTIONS(5816),
    [anon_sym_rescue] = ACTIONS(5816),
    [anon_sym_do] = ACTIONS(5816),
    [anon_sym_when] = ACTIONS(5816),
    [anon_sym_elsif] = ACTIONS(5816),
    [anon_sym_else] = ACTIONS(5816),
    [anon_sym_then] = ACTIONS(5816),
    [anon_sym_ensure] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_COLON_COLON2] = ACTIONS(5816),
    [anon_sym_AMP_DOT] = ACTIONS(5816),
    [anon_sym_PLUS_EQ] = ACTIONS(5816),
    [anon_sym_DASH_EQ] = ACTIONS(5816),
    [anon_sym_STAR_EQ] = ACTIONS(5816),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5816),
    [anon_sym_SLASH_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5816),
    [anon_sym_AMP_EQ] = ACTIONS(5816),
    [anon_sym_PERCENT_EQ] = ACTIONS(5816),
    [anon_sym_GT_GT_EQ] = ACTIONS(5816),
    [anon_sym_LT_LT_EQ] = ACTIONS(5816),
    [anon_sym_CARET_EQ] = ACTIONS(5816),
    [anon_sym_QMARK] = ACTIONS(5816),
    [anon_sym_DOT_DOT] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5816),
    [anon_sym_and] = ACTIONS(5816),
    [anon_sym_or] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_AMP_AMP] = ACTIONS(5818),
    [anon_sym_LT_LT] = ACTIONS(5818),
    [anon_sym_GT_GT] = ACTIONS(5818),
    [anon_sym_EQ_EQ] = ACTIONS(5818),
    [anon_sym_BANG_EQ] = ACTIONS(5816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5816),
    [anon_sym_LT_EQ_GT] = ACTIONS(5816),
    [anon_sym_EQ_TILDE] = ACTIONS(5816),
    [anon_sym_BANG_TILDE] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5818),
    [anon_sym_GT] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5816),
    [anon_sym_CARET] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5818),
    [anon_sym_SLASH] = ACTIONS(5818),
    [anon_sym_PERCENT] = ACTIONS(5818),
    [sym_comment] = ACTIONS(87),
  },
  [1446] = {
    [sym_heredoc_body] = STATE(3548),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
  },
  [1447] = {
    [anon_sym_RBRACK] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
  },
  [1448] = {
    [sym__line_break] = ACTIONS(5822),
    [sym__simple_symbol] = ACTIONS(5822),
    [sym__string_start] = ACTIONS(5822),
    [sym__symbol_start] = ACTIONS(5822),
    [sym__subshell_start] = ACTIONS(5822),
    [sym__regex_start] = ACTIONS(5822),
    [sym__string_array_start] = ACTIONS(5822),
    [sym__symbol_array_start] = ACTIONS(5822),
    [sym__heredoc_body_start] = ACTIONS(5822),
    [sym_heredoc_beginning] = ACTIONS(5822),
    [sym__block_ampersand] = ACTIONS(5822),
    [sym__splat_star] = ACTIONS(5822),
    [sym__unary_minus] = ACTIONS(5822),
    [sym__binary_minus] = ACTIONS(5822),
    [sym__binary_star] = ACTIONS(5822),
    [sym__identifier_hash_key] = ACTIONS(5822),
    [ts_builtin_sym_end] = ACTIONS(5822),
    [anon_sym___END__] = ACTIONS(5824),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_def] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COLON_COLON] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_STAR_STAR] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_class] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_module] = ACTIONS(5824),
    [anon_sym_end] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(5824),
    [anon_sym_break] = ACTIONS(5824),
    [anon_sym_next] = ACTIONS(5824),
    [sym_redo] = ACTIONS(5824),
    [sym_retry] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5824),
    [anon_sym_unless] = ACTIONS(5824),
    [anon_sym_while] = ACTIONS(5824),
    [anon_sym_until] = ACTIONS(5824),
    [anon_sym_rescue] = ACTIONS(5824),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_do] = ACTIONS(5824),
    [anon_sym_case] = ACTIONS(5824),
    [anon_sym_when] = ACTIONS(5824),
    [anon_sym_elsif] = ACTIONS(5824),
    [anon_sym_else] = ACTIONS(5824),
    [anon_sym_then] = ACTIONS(5824),
    [anon_sym_begin] = ACTIONS(5824),
    [anon_sym_ensure] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_LPAREN2] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [anon_sym_DASH_EQ] = ACTIONS(5822),
    [anon_sym_STAR_EQ] = ACTIONS(5822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5822),
    [anon_sym_AMP_EQ] = ACTIONS(5822),
    [anon_sym_PERCENT_EQ] = ACTIONS(5822),
    [anon_sym_GT_GT_EQ] = ACTIONS(5822),
    [anon_sym_LT_LT_EQ] = ACTIONS(5822),
    [anon_sym_CARET_EQ] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5824),
    [anon_sym_or] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [anon_sym_defined_QMARK] = ACTIONS(5822),
    [anon_sym_not] = ACTIONS(5824),
    [anon_sym_BANG] = ACTIONS(5824),
    [anon_sym_TILDE] = ACTIONS(5822),
    [sym_constant] = ACTIONS(5824),
    [sym_identifier] = ACTIONS(5824),
    [sym_instance_variable] = ACTIONS(5822),
    [sym_class_variable] = ACTIONS(5822),
    [sym_global_variable] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5824),
    [sym_float] = ACTIONS(5824),
    [sym_complex] = ACTIONS(5822),
    [sym_super] = ACTIONS(5824),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_TRUE] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [anon_sym_FALSE] = ACTIONS(5824),
    [sym_self] = ACTIONS(5824),
    [anon_sym_nil] = ACTIONS(5824),
    [anon_sym_NIL] = ACTIONS(5824),
    [sym_character] = ACTIONS(5822),
    [anon_sym_LBRACK2] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5822),
  },
  [1449] = {
    [sym__line_break] = ACTIONS(837),
    [sym__string_start] = ACTIONS(837),
    [sym__heredoc_body_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [ts_builtin_sym_end] = ACTIONS(837),
    [anon_sym___END__] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_unless] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_until] = ACTIONS(837),
    [anon_sym_rescue] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_when] = ACTIONS(837),
    [anon_sym_elsif] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(837),
    [anon_sym_then] = ACTIONS(837),
    [anon_sym_ensure] = ACTIONS(837),
    [anon_sym_EQ_GT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [sym_comment] = ACTIONS(87),
  },
  [1450] = {
    [sym__string_end] = ACTIONS(5826),
    [sym_comment] = ACTIONS(87),
  },
  [1451] = {
    [sym__line_break] = ACTIONS(887),
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [ts_builtin_sym_end] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_end] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_when] = ACTIONS(887),
    [anon_sym_elsif] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_then] = ACTIONS(887),
    [anon_sym_ensure] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_PLUS_EQ] = ACTIONS(887),
    [anon_sym_DASH_EQ] = ACTIONS(887),
    [anon_sym_STAR_EQ] = ACTIONS(887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(887),
    [anon_sym_SLASH_EQ] = ACTIONS(887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(887),
    [anon_sym_PIPE_EQ] = ACTIONS(887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(887),
    [anon_sym_AMP_EQ] = ACTIONS(887),
    [anon_sym_PERCENT_EQ] = ACTIONS(887),
    [anon_sym_GT_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_LT_EQ] = ACTIONS(887),
    [anon_sym_CARET_EQ] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(889),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [sym_comment] = ACTIONS(87),
  },
  [1452] = {
    [sym__string_end] = ACTIONS(5828),
    [sym_comment] = ACTIONS(87),
  },
  [1453] = {
    [sym__line_break] = ACTIONS(893),
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [ts_builtin_sym_end] = ACTIONS(893),
    [anon_sym___END__] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_end] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_when] = ACTIONS(893),
    [anon_sym_elsif] = ACTIONS(893),
    [anon_sym_else] = ACTIONS(893),
    [anon_sym_then] = ACTIONS(893),
    [anon_sym_ensure] = ACTIONS(893),
    [anon_sym_EQ_GT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [anon_sym_DASH_EQ] = ACTIONS(893),
    [anon_sym_STAR_EQ] = ACTIONS(893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(893),
    [anon_sym_SLASH_EQ] = ACTIONS(893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(893),
    [anon_sym_PIPE_EQ] = ACTIONS(893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(893),
    [anon_sym_AMP_EQ] = ACTIONS(893),
    [anon_sym_PERCENT_EQ] = ACTIONS(893),
    [anon_sym_GT_GT_EQ] = ACTIONS(893),
    [anon_sym_LT_LT_EQ] = ACTIONS(893),
    [anon_sym_CARET_EQ] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(895),
    [anon_sym_PERCENT] = ACTIONS(895),
    [sym_comment] = ACTIONS(87),
  },
  [1454] = {
    [sym__string_end] = ACTIONS(5830),
    [sym_comment] = ACTIONS(87),
  },
  [1455] = {
    [sym__line_break] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [ts_builtin_sym_end] = ACTIONS(899),
    [anon_sym___END__] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(901),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_when] = ACTIONS(899),
    [anon_sym_elsif] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_then] = ACTIONS(899),
    [anon_sym_ensure] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_PLUS_EQ] = ACTIONS(899),
    [anon_sym_DASH_EQ] = ACTIONS(899),
    [anon_sym_STAR_EQ] = ACTIONS(899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(899),
    [anon_sym_SLASH_EQ] = ACTIONS(899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(899),
    [anon_sym_PIPE_EQ] = ACTIONS(899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(899),
    [anon_sym_AMP_EQ] = ACTIONS(899),
    [anon_sym_PERCENT_EQ] = ACTIONS(899),
    [anon_sym_GT_GT_EQ] = ACTIONS(899),
    [anon_sym_LT_LT_EQ] = ACTIONS(899),
    [anon_sym_CARET_EQ] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [sym_comment] = ACTIONS(87),
  },
  [1456] = {
    [sym__string_end] = ACTIONS(5832),
    [sym_comment] = ACTIONS(87),
  },
  [1457] = {
    [sym__line_break] = ACTIONS(905),
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(905),
    [anon_sym___END__] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(905),
    [anon_sym_elsif] = ACTIONS(905),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_then] = ACTIONS(905),
    [anon_sym_ensure] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [sym_comment] = ACTIONS(87),
  },
  [1458] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3555),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5834),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5836),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1459] = {
    [aux_sym_string_array_repeat1] = STATE(3558),
    [sym__string_end] = ACTIONS(5838),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5840),
  },
  [1460] = {
    [sym__line_break] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [ts_builtin_sym_end] = ACTIONS(923),
    [anon_sym___END__] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_when] = ACTIONS(923),
    [anon_sym_elsif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_ensure] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [sym_comment] = ACTIONS(87),
  },
  [1461] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3561),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5842),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5844),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1462] = {
    [aux_sym_symbol_array_repeat1] = STATE(3564),
    [sym__string_end] = ACTIONS(5846),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5848),
  },
  [1463] = {
    [sym__line_break] = ACTIONS(101),
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_when] = ACTIONS(101),
    [anon_sym_elsif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_then] = ACTIONS(101),
    [anon_sym_ensure] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [1464] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(3566),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(5850),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1465] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(3568),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(5852),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1466] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(3570),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(5854),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1467] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(3572),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(5856),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1468] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3575),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5858),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5860),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1469] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(3578),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(5862),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5864),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1470] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3579),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(3579),
    [sym_operator_assignment] = STATE(3579),
    [sym_conditional] = STATE(3579),
    [sym_range] = STATE(3579),
    [sym_binary] = STATE(3579),
    [sym_unary] = STATE(3579),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1471] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(3581),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(3582),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(5866),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1472] = {
    [sym__method_rest] = STATE(3584),
    [sym__variable] = STATE(3585),
    [sym_operator] = STATE(3586),
    [sym__method_name] = STATE(3586),
    [sym_setter] = STATE(3586),
    [sym_symbol] = STATE(3586),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(5868),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(5870),
    [sym_self] = ACTIONS(5870),
  },
  [1473] = {
    [sym__statements] = STATE(3588),
    [sym__top_level_statement] = STATE(144),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(149),
    [sym__simple_mlhs] = STATE(150),
    [sym_destructured_left_assignment] = STATE(150),
    [sym_rest_assignment] = STATE(150),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(5872),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1474] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(3591),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(5874),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(5876),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [1475] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(3593),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(5878),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [1476] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(423),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(427),
    [sym__argument] = STATE(428),
    [sym_splat_argument] = STATE(428),
    [sym_hash_splat_argument] = STATE(428),
    [sym_block_argument] = STATE(428),
    [sym_assignment] = STATE(423),
    [sym_operator_assignment] = STATE(423),
    [sym_conditional] = STATE(423),
    [sym_range] = STATE(423),
    [sym_binary] = STATE(423),
    [sym_unary] = STATE(423),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(432),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(428),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(763),
    [sym__splat_star] = ACTIONS(765),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(363),
    [anon_sym___END__] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(811),
    [sym_identifier] = ACTIONS(811),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1477] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(423),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(427),
    [sym__argument] = STATE(428),
    [sym_splat_argument] = STATE(428),
    [sym_hash_splat_argument] = STATE(428),
    [sym_block_argument] = STATE(428),
    [sym_assignment] = STATE(423),
    [sym_operator_assignment] = STATE(423),
    [sym_conditional] = STATE(423),
    [sym_range] = STATE(423),
    [sym_binary] = STATE(423),
    [sym_unary] = STATE(423),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(432),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(428),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(763),
    [sym__splat_star] = ACTIONS(765),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(811),
    [sym_identifier] = ACTIONS(811),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1478] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(423),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(427),
    [sym__argument] = STATE(428),
    [sym_splat_argument] = STATE(428),
    [sym_hash_splat_argument] = STATE(428),
    [sym_block_argument] = STATE(428),
    [sym_assignment] = STATE(423),
    [sym_operator_assignment] = STATE(423),
    [sym_conditional] = STATE(423),
    [sym_range] = STATE(423),
    [sym_binary] = STATE(423),
    [sym_unary] = STATE(423),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(432),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(428),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(763),
    [sym__splat_star] = ACTIONS(765),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(811),
    [sym_identifier] = ACTIONS(811),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1479] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(423),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(427),
    [sym__argument] = STATE(428),
    [sym_splat_argument] = STATE(428),
    [sym_hash_splat_argument] = STATE(428),
    [sym_block_argument] = STATE(428),
    [sym_assignment] = STATE(423),
    [sym_operator_assignment] = STATE(423),
    [sym_conditional] = STATE(423),
    [sym_range] = STATE(423),
    [sym_binary] = STATE(423),
    [sym_unary] = STATE(423),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(432),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(428),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(763),
    [sym__splat_star] = ACTIONS(765),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(811),
    [sym_identifier] = ACTIONS(811),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1480] = {
    [sym__statement] = STATE(3598),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(3598),
    [sym_unless_modifier] = STATE(3598),
    [sym_while_modifier] = STATE(3598),
    [sym_until_modifier] = STATE(3598),
    [sym_rescue_modifier] = STATE(3598),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(3598),
    [sym_alias] = STATE(3598),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(3598),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1481] = {
    [sym__statement] = STATE(3599),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(3599),
    [sym_unless_modifier] = STATE(3599),
    [sym_while_modifier] = STATE(3599),
    [sym_until_modifier] = STATE(3599),
    [sym_rescue_modifier] = STATE(3599),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(3599),
    [sym_alias] = STATE(3599),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(3599),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1482] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3600),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(3600),
    [sym_operator_assignment] = STATE(3600),
    [sym_conditional] = STATE(3600),
    [sym_range] = STATE(3600),
    [sym_binary] = STATE(3600),
    [sym_unary] = STATE(3600),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1483] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3601),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(3601),
    [sym_operator_assignment] = STATE(3601),
    [sym_conditional] = STATE(3601),
    [sym_range] = STATE(3601),
    [sym_binary] = STATE(3601),
    [sym_unary] = STATE(3601),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1484] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(3602),
    [sym__simple_mlhs] = STATE(257),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [1485] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3603),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(3603),
    [sym_operator_assignment] = STATE(3603),
    [sym_conditional] = STATE(3603),
    [sym_range] = STATE(3603),
    [sym_binary] = STATE(3603),
    [sym_unary] = STATE(3603),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(3604),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__terminator] = STATE(3604),
    [sym__line_break] = ACTIONS(5880),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(5880),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1486] = {
    [sym__statements] = STATE(3605),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(3606),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(3607),
    [sym_rescue] = STATE(3608),
    [sym__body_statement] = STATE(3609),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(3610),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__terminator] = STATE(3610),
    [sym__line_break] = ACTIONS(5882),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5884),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1487] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3611),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(3611),
    [sym_operator_assignment] = STATE(3611),
    [sym_conditional] = STATE(3611),
    [sym_range] = STATE(3611),
    [sym_binary] = STATE(3611),
    [sym_unary] = STATE(3611),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1488] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1489] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(5886),
  },
  [1490] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(3615),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(3616),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(5888),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1491] = {
    [sym_lambda_parameters] = STATE(3617),
    [sym__simple_formal_parameter] = STATE(364),
    [sym_splat_parameter] = STATE(364),
    [sym_hash_splat_parameter] = STATE(364),
    [sym_block_parameter] = STATE(364),
    [sym_keyword_parameter] = STATE(364),
    [sym_optional_parameter] = STATE(364),
    [sym_do_block] = STATE(3618),
    [sym_block] = STATE(3618),
    [anon_sym_LBRACE] = ACTIONS(2727),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(795),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [1492] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(4074),
    [anon_sym___END__] = ACTIONS(4074),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [1493] = {
    [sym__line_break] = ACTIONS(733),
    [sym__heredoc_body_start] = ACTIONS(733),
    [sym__binary_minus] = ACTIONS(733),
    [sym__binary_star] = ACTIONS(733),
    [ts_builtin_sym_end] = ACTIONS(733),
    [anon_sym___END__] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_end] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_when] = ACTIONS(733),
    [anon_sym_elsif] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_then] = ACTIONS(733),
    [anon_sym_ensure] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_COLON_COLON2] = ACTIONS(741),
    [anon_sym_AMP_DOT] = ACTIONS(743),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ_GT] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_BANG_TILDE] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_comment] = ACTIONS(87),
  },
  [1494] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(423),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(427),
    [sym__argument] = STATE(428),
    [sym_splat_argument] = STATE(428),
    [sym_hash_splat_argument] = STATE(428),
    [sym_block_argument] = STATE(428),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(423),
    [sym_operator_assignment] = STATE(423),
    [sym_conditional] = STATE(423),
    [sym_range] = STATE(423),
    [sym_binary] = STATE(423),
    [sym_unary] = STATE(423),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(432),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(428),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(763),
    [sym__splat_star] = ACTIONS(765),
    [sym__unary_minus] = ACTIONS(767),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(769),
    [ts_builtin_sym_end] = ACTIONS(745),
    [anon_sym___END__] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(811),
    [sym_identifier] = ACTIONS(811),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1495] = {
    [anon_sym_EQ] = ACTIONS(5920),
    [sym_comment] = ACTIONS(87),
  },
  [1496] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5924),
    [anon_sym_DASH_EQ] = ACTIONS(5924),
    [anon_sym_STAR_EQ] = ACTIONS(5924),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5924),
    [anon_sym_SLASH_EQ] = ACTIONS(5924),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5924),
    [anon_sym_PIPE_EQ] = ACTIONS(5924),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5924),
    [anon_sym_AMP_EQ] = ACTIONS(5924),
    [anon_sym_PERCENT_EQ] = ACTIONS(5924),
    [anon_sym_GT_GT_EQ] = ACTIONS(5924),
    [anon_sym_LT_LT_EQ] = ACTIONS(5924),
    [anon_sym_CARET_EQ] = ACTIONS(5924),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1497] = {
    [sym_string] = STATE(3632),
    [aux_sym_chained_string_repeat1] = STATE(3632),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1498] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(4110),
    [anon_sym___END__] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [1499] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(1519),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(1520),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(5926),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1500] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [1501] = {
    [sym_string] = STATE(1587),
    [aux_sym_chained_string_repeat1] = STATE(1587),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1502] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3634),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(3634),
    [sym_operator_assignment] = STATE(3634),
    [sym_conditional] = STATE(3634),
    [sym_range] = STATE(3634),
    [sym_binary] = STATE(3634),
    [sym_unary] = STATE(3634),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1503] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3635),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(3635),
    [sym_operator_assignment] = STATE(3635),
    [sym_conditional] = STATE(3635),
    [sym_range] = STATE(3635),
    [sym_binary] = STATE(3635),
    [sym_unary] = STATE(3635),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1504] = {
    [sym__line_break] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [ts_builtin_sym_end] = ACTIONS(5594),
    [anon_sym___END__] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_end] = ACTIONS(5594),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_when] = ACTIONS(5594),
    [anon_sym_elsif] = ACTIONS(5594),
    [anon_sym_else] = ACTIONS(5594),
    [anon_sym_then] = ACTIONS(5594),
    [anon_sym_ensure] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [1505] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3642),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3643),
    [sym__argument] = STATE(3644),
    [sym_splat_argument] = STATE(3644),
    [sym_hash_splat_argument] = STATE(3644),
    [sym_block_argument] = STATE(3644),
    [sym_assignment] = STATE(3642),
    [sym_operator_assignment] = STATE(3642),
    [sym_conditional] = STATE(3642),
    [sym_range] = STATE(3642),
    [sym_binary] = STATE(3642),
    [sym_unary] = STATE(3642),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3645),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3644),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5928),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5934),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1506] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3642),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3643),
    [sym__argument] = STATE(3644),
    [sym_splat_argument] = STATE(3644),
    [sym_hash_splat_argument] = STATE(3644),
    [sym_block_argument] = STATE(3644),
    [sym_assignment] = STATE(3642),
    [sym_operator_assignment] = STATE(3642),
    [sym_conditional] = STATE(3642),
    [sym_range] = STATE(3642),
    [sym_binary] = STATE(3642),
    [sym_unary] = STATE(3642),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3645),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3644),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5928),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5934),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1507] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3642),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3643),
    [sym__argument] = STATE(3644),
    [sym_splat_argument] = STATE(3644),
    [sym_hash_splat_argument] = STATE(3644),
    [sym_block_argument] = STATE(3644),
    [sym_assignment] = STATE(3642),
    [sym_operator_assignment] = STATE(3642),
    [sym_conditional] = STATE(3642),
    [sym_range] = STATE(3642),
    [sym_binary] = STATE(3642),
    [sym_unary] = STATE(3642),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3645),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3644),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5928),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5934),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1508] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3642),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3643),
    [sym__argument] = STATE(3644),
    [sym_splat_argument] = STATE(3644),
    [sym_hash_splat_argument] = STATE(3644),
    [sym_block_argument] = STATE(3644),
    [sym_assignment] = STATE(3642),
    [sym_operator_assignment] = STATE(3642),
    [sym_conditional] = STATE(3642),
    [sym_range] = STATE(3642),
    [sym_binary] = STATE(3642),
    [sym_unary] = STATE(3642),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3645),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3644),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5928),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5934),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1509] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3646),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(3646),
    [sym_operator_assignment] = STATE(3646),
    [sym_conditional] = STATE(3646),
    [sym_range] = STATE(3646),
    [sym_binary] = STATE(3646),
    [sym_unary] = STATE(3646),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1510] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1511] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1093),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1512] = {
    [anon_sym_RBRACE] = ACTIONS(5936),
    [sym_comment] = ACTIONS(87),
  },
  [1513] = {
    [sym__statements] = STATE(3648),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5936),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1514] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5946),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_EQ_GT] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(5948),
    [anon_sym_DOT_DOT] = ACTIONS(5950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5952),
    [anon_sym_and] = ACTIONS(5954),
    [anon_sym_or] = ACTIONS(5954),
    [anon_sym_PIPE_PIPE] = ACTIONS(5956),
    [anon_sym_AMP_AMP] = ACTIONS(5956),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5956),
    [anon_sym_LT_EQ_GT] = ACTIONS(5956),
    [anon_sym_EQ_TILDE] = ACTIONS(5956),
    [anon_sym_BANG_TILDE] = ACTIONS(5956),
    [anon_sym_LT_EQ] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5946),
    [anon_sym_GT_EQ] = ACTIONS(5962),
    [anon_sym_CARET] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [1515] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3664),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(3665),
    [sym__argument] = STATE(3666),
    [sym_splat_argument] = STATE(3666),
    [sym_hash_splat_argument] = STATE(3666),
    [sym_block_argument] = STATE(3666),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3664),
    [sym_operator_assignment] = STATE(3664),
    [sym_conditional] = STATE(3664),
    [sym_range] = STATE(3664),
    [sym_binary] = STATE(3664),
    [sym_unary] = STATE(3664),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3667),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3666),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5966),
    [sym__splat_star] = ACTIONS(5968),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5970),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(5972),
    [sym_identifier] = ACTIONS(5972),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1516] = {
    [anon_sym_EQ] = ACTIONS(5974),
    [sym_comment] = ACTIONS(87),
  },
  [1517] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5978),
    [anon_sym_DASH_EQ] = ACTIONS(5978),
    [anon_sym_STAR_EQ] = ACTIONS(5978),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5978),
    [anon_sym_SLASH_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5978),
    [anon_sym_AMP_EQ] = ACTIONS(5978),
    [anon_sym_PERCENT_EQ] = ACTIONS(5978),
    [anon_sym_GT_GT_EQ] = ACTIONS(5978),
    [anon_sym_LT_LT_EQ] = ACTIONS(5978),
    [anon_sym_CARET_EQ] = ACTIONS(5978),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1518] = {
    [sym_string] = STATE(3670),
    [aux_sym_chained_string_repeat1] = STATE(3670),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1519] = {
    [anon_sym_RBRACE] = ACTIONS(5980),
    [sym_comment] = ACTIONS(87),
  },
  [1520] = {
    [sym_heredoc_body] = STATE(3672),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(5980),
    [sym_comment] = ACTIONS(87),
  },
  [1521] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3673),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(3673),
    [sym_operator_assignment] = STATE(3673),
    [sym_conditional] = STATE(3673),
    [sym_range] = STATE(3673),
    [sym_binary] = STATE(3673),
    [sym_unary] = STATE(3673),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1522] = {
    [sym__line_break] = ACTIONS(1273),
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym___END__] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_end] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_when] = ACTIONS(1273),
    [anon_sym_elsif] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_then] = ACTIONS(1273),
    [anon_sym_ensure] = ACTIONS(1273),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [sym_comment] = ACTIONS(87),
  },
  [1523] = {
    [anon_sym_DOT] = ACTIONS(5982),
    [anon_sym_COLON_COLON] = ACTIONS(5982),
    [sym_comment] = ACTIONS(87),
  },
  [1524] = {
    [sym_method_parameters] = STATE(3675),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(3675),
    [sym__terminator] = STATE(3675),
    [sym__line_break] = ACTIONS(5984),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [1525] = {
    [sym__line_break] = ACTIONS(1291),
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [ts_builtin_sym_end] = ACTIONS(1291),
    [anon_sym___END__] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_end] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_when] = ACTIONS(1291),
    [anon_sym_elsif] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_then] = ACTIONS(1291),
    [anon_sym_ensure] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_PLUS_EQ] = ACTIONS(1291),
    [anon_sym_DASH_EQ] = ACTIONS(1291),
    [anon_sym_STAR_EQ] = ACTIONS(1291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1291),
    [anon_sym_SLASH_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1291),
    [anon_sym_AMP_EQ] = ACTIONS(1291),
    [anon_sym_PERCENT_EQ] = ACTIONS(1291),
    [anon_sym_GT_GT_EQ] = ACTIONS(1291),
    [anon_sym_LT_LT_EQ] = ACTIONS(1291),
    [anon_sym_CARET_EQ] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [sym_comment] = ACTIONS(87),
  },
  [1526] = {
    [anon_sym_RPAREN] = ACTIONS(5986),
    [sym_comment] = ACTIONS(87),
  },
  [1527] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(3148),
    [anon_sym___END__] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [1528] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3677),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(3677),
    [sym_operator_assignment] = STATE(3677),
    [sym_conditional] = STATE(3677),
    [sym_range] = STATE(3677),
    [sym_binary] = STATE(3677),
    [sym_unary] = STATE(3677),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1529] = {
    [sym_superclass] = STATE(3678),
    [sym_heredoc_body] = STATE(3679),
    [sym__terminator] = STATE(3679),
    [sym__line_break] = ACTIONS(5988),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(5988),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1530] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_superclass] = STATE(3678),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(3679),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(3679),
    [sym__line_break] = ACTIONS(5988),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(5988),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1531] = {
    [sym_heredoc_body] = STATE(3681),
    [sym__terminator] = STATE(3681),
    [sym__line_break] = ACTIONS(5990),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(5992),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1532] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(3681),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(3681),
    [sym__line_break] = ACTIONS(5990),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(5992),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1533] = {
    [sym__line_break] = ACTIONS(1679),
    [sym__heredoc_body_start] = ACTIONS(1679),
    [sym__binary_minus] = ACTIONS(1679),
    [sym__binary_star] = ACTIONS(1679),
    [ts_builtin_sym_end] = ACTIONS(1679),
    [anon_sym___END__] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_end] = ACTIONS(1679),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_unless] = ACTIONS(1679),
    [anon_sym_while] = ACTIONS(1679),
    [anon_sym_until] = ACTIONS(1679),
    [anon_sym_rescue] = ACTIONS(1679),
    [anon_sym_do] = ACTIONS(1679),
    [anon_sym_when] = ACTIONS(1679),
    [anon_sym_elsif] = ACTIONS(1679),
    [anon_sym_else] = ACTIONS(1679),
    [anon_sym_then] = ACTIONS(1679),
    [anon_sym_ensure] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1679),
    [anon_sym_AMP_DOT] = ACTIONS(1679),
    [anon_sym_PLUS_EQ] = ACTIONS(1679),
    [anon_sym_DASH_EQ] = ACTIONS(1679),
    [anon_sym_STAR_EQ] = ACTIONS(1679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1679),
    [anon_sym_SLASH_EQ] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1679),
    [anon_sym_PIPE_EQ] = ACTIONS(1679),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1679),
    [anon_sym_AMP_EQ] = ACTIONS(1679),
    [anon_sym_PERCENT_EQ] = ACTIONS(1679),
    [anon_sym_GT_GT_EQ] = ACTIONS(1679),
    [anon_sym_LT_LT_EQ] = ACTIONS(1679),
    [anon_sym_CARET_EQ] = ACTIONS(1679),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_DOT_DOT] = ACTIONS(1681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1679),
    [anon_sym_and] = ACTIONS(1679),
    [anon_sym_or] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_BANG_EQ] = ACTIONS(1679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1679),
    [anon_sym_LT_EQ_GT] = ACTIONS(1679),
    [anon_sym_EQ_TILDE] = ACTIONS(1679),
    [anon_sym_BANG_TILDE] = ACTIONS(1679),
    [anon_sym_LT_EQ] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1679),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1534] = {
    [sym__line_break] = ACTIONS(1699),
    [sym__heredoc_body_start] = ACTIONS(1699),
    [sym__binary_minus] = ACTIONS(1699),
    [sym__binary_star] = ACTIONS(1699),
    [ts_builtin_sym_end] = ACTIONS(1699),
    [anon_sym___END__] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_end] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_when] = ACTIONS(1699),
    [anon_sym_elsif] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_then] = ACTIONS(1699),
    [anon_sym_ensure] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_PLUS_EQ] = ACTIONS(1699),
    [anon_sym_DASH_EQ] = ACTIONS(1699),
    [anon_sym_STAR_EQ] = ACTIONS(1699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1699),
    [anon_sym_SLASH_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1699),
    [anon_sym_AMP_EQ] = ACTIONS(1699),
    [anon_sym_PERCENT_EQ] = ACTIONS(1699),
    [anon_sym_GT_GT_EQ] = ACTIONS(1699),
    [anon_sym_LT_LT_EQ] = ACTIONS(1699),
    [anon_sym_CARET_EQ] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [1535] = {
    [sym__line_break] = ACTIONS(1703),
    [sym__heredoc_body_start] = ACTIONS(1703),
    [sym__binary_minus] = ACTIONS(1703),
    [sym__binary_star] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1705),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1705),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_SLASH] = ACTIONS(1705),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(87),
  },
  [1536] = {
    [sym__line_break] = ACTIONS(1707),
    [sym__heredoc_body_start] = ACTIONS(1707),
    [sym__binary_minus] = ACTIONS(1707),
    [sym__binary_star] = ACTIONS(1707),
    [ts_builtin_sym_end] = ACTIONS(1707),
    [anon_sym___END__] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_DOT] = ACTIONS(1709),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_EQ] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_end] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1707),
    [anon_sym_unless] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(1707),
    [anon_sym_until] = ACTIONS(1707),
    [anon_sym_rescue] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1707),
    [anon_sym_when] = ACTIONS(1707),
    [anon_sym_elsif] = ACTIONS(1707),
    [anon_sym_else] = ACTIONS(1707),
    [anon_sym_then] = ACTIONS(1707),
    [anon_sym_ensure] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_COLON_COLON2] = ACTIONS(1707),
    [anon_sym_AMP_DOT] = ACTIONS(1707),
    [anon_sym_PLUS_EQ] = ACTIONS(1707),
    [anon_sym_DASH_EQ] = ACTIONS(1707),
    [anon_sym_STAR_EQ] = ACTIONS(1707),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1707),
    [anon_sym_SLASH_EQ] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1707),
    [anon_sym_PIPE_EQ] = ACTIONS(1707),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1707),
    [anon_sym_AMP_EQ] = ACTIONS(1707),
    [anon_sym_PERCENT_EQ] = ACTIONS(1707),
    [anon_sym_GT_GT_EQ] = ACTIONS(1707),
    [anon_sym_LT_LT_EQ] = ACTIONS(1707),
    [anon_sym_CARET_EQ] = ACTIONS(1707),
    [anon_sym_QMARK] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1707),
    [anon_sym_and] = ACTIONS(1707),
    [anon_sym_or] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(1709),
    [anon_sym_GT_GT] = ACTIONS(1709),
    [anon_sym_EQ_EQ] = ACTIONS(1709),
    [anon_sym_BANG_EQ] = ACTIONS(1707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1707),
    [anon_sym_LT_EQ_GT] = ACTIONS(1707),
    [anon_sym_EQ_TILDE] = ACTIONS(1707),
    [anon_sym_BANG_TILDE] = ACTIONS(1707),
    [anon_sym_LT_EQ] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_GT_EQ] = ACTIONS(1707),
    [anon_sym_CARET] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_SLASH] = ACTIONS(1709),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [sym_comment] = ACTIONS(87),
  },
  [1537] = {
    [sym__then] = STATE(3682),
    [sym_heredoc_body] = STATE(979),
    [sym__terminator] = STATE(979),
    [sym__line_break] = ACTIONS(1743),
    [sym__heredoc_body_start] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(5994),
    [sym_comment] = ACTIONS(87),
  },
  [1538] = {
    [sym__then] = STATE(3683),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(5996),
    [sym_comment] = ACTIONS(87),
  },
  [1539] = {
    [sym__do] = STATE(3684),
    [sym_heredoc_body] = STATE(3684),
    [sym__terminator] = STATE(3684),
    [sym__line_break] = ACTIONS(5998),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(5998),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(5998),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [1540] = {
    [sym__do] = STATE(3685),
    [sym_heredoc_body] = STATE(3685),
    [sym__terminator] = STATE(3685),
    [sym__line_break] = ACTIONS(6000),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(6000),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(6000),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [1541] = {
    [sym_in] = STATE(3686),
    [anon_sym_in] = ACTIONS(1969),
    [sym_comment] = ACTIONS(87),
  },
  [1542] = {
    [sym__line_break] = ACTIONS(5630),
    [sym__heredoc_body_start] = ACTIONS(5630),
    [sym__binary_minus] = ACTIONS(5630),
    [sym__binary_star] = ACTIONS(5630),
    [ts_builtin_sym_end] = ACTIONS(5630),
    [anon_sym___END__] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5630),
    [anon_sym_RPAREN] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_STAR_STAR] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5632),
    [anon_sym_end] = ACTIONS(5630),
    [anon_sym_if] = ACTIONS(5630),
    [anon_sym_unless] = ACTIONS(5630),
    [anon_sym_while] = ACTIONS(5630),
    [anon_sym_until] = ACTIONS(5630),
    [anon_sym_rescue] = ACTIONS(5630),
    [anon_sym_do] = ACTIONS(5630),
    [anon_sym_when] = ACTIONS(5630),
    [anon_sym_elsif] = ACTIONS(5630),
    [anon_sym_else] = ACTIONS(5630),
    [anon_sym_then] = ACTIONS(5630),
    [anon_sym_ensure] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [anon_sym_PLUS_EQ] = ACTIONS(5630),
    [anon_sym_DASH_EQ] = ACTIONS(5630),
    [anon_sym_STAR_EQ] = ACTIONS(5630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5630),
    [anon_sym_SLASH_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5630),
    [anon_sym_AMP_EQ] = ACTIONS(5630),
    [anon_sym_PERCENT_EQ] = ACTIONS(5630),
    [anon_sym_GT_GT_EQ] = ACTIONS(5630),
    [anon_sym_LT_LT_EQ] = ACTIONS(5630),
    [anon_sym_CARET_EQ] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5632),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5630),
    [anon_sym_EQ_TILDE] = ACTIONS(5630),
    [anon_sym_BANG_TILDE] = ACTIONS(5630),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5632),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [sym_comment] = ACTIONS(87),
  },
  [1543] = {
    [anon_sym_end] = ACTIONS(6002),
    [sym_comment] = ACTIONS(87),
  },
  [1544] = {
    [sym__statements] = STATE(3688),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(3689),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(3689),
    [sym__line_break] = ACTIONS(6004),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6006),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1545] = {
    [sym__statements] = STATE(3688),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(3690),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6006),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1546] = {
    [sym_heredoc_body] = STATE(3691),
    [sym__terminator] = STATE(3691),
    [sym__line_break] = ACTIONS(6008),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(6008),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [1547] = {
    [sym_when] = STATE(3692),
    [aux_sym_case_repeat1] = STATE(3693),
    [anon_sym_SEMI] = ACTIONS(6010),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1548] = {
    [sym_else] = STATE(3695),
    [sym_ensure] = STATE(3696),
    [sym_rescue] = STATE(3697),
    [anon_sym_end] = ACTIONS(6012),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1549] = {
    [sym_ensure] = STATE(3696),
    [anon_sym_end] = ACTIONS(6012),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1550] = {
    [anon_sym_end] = ACTIONS(6012),
    [sym_comment] = ACTIONS(87),
  },
  [1551] = {
    [sym_else] = STATE(3695),
    [sym_ensure] = STATE(3696),
    [anon_sym_end] = ACTIONS(6012),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1552] = {
    [sym__line_break] = ACTIONS(2187),
    [sym__heredoc_body_start] = ACTIONS(2187),
    [sym__binary_minus] = ACTIONS(2187),
    [sym__binary_star] = ACTIONS(2187),
    [ts_builtin_sym_end] = ACTIONS(2187),
    [anon_sym___END__] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_STAR_STAR] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_EQ] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_end] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_unless] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_until] = ACTIONS(2187),
    [anon_sym_rescue] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(2187),
    [anon_sym_elsif] = ACTIONS(2187),
    [anon_sym_else] = ACTIONS(2187),
    [anon_sym_then] = ACTIONS(2187),
    [anon_sym_ensure] = ACTIONS(2187),
    [anon_sym_EQ_GT] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_COLON_COLON2] = ACTIONS(2187),
    [anon_sym_AMP_DOT] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_DOT_DOT] = ACTIONS(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_LT_LT] = ACTIONS(2189),
    [anon_sym_GT_GT] = ACTIONS(2189),
    [anon_sym_EQ_EQ] = ACTIONS(2189),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_EQ_TILDE] = ACTIONS(2187),
    [anon_sym_BANG_TILDE] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2189),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_PERCENT] = ACTIONS(2189),
    [sym_comment] = ACTIONS(87),
  },
  [1553] = {
    [sym__statements] = STATE(1548),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1549),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1550),
    [sym_rescue] = STATE(1551),
    [sym__body_statement] = STATE(3698),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6014),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1554] = {
    [sym__line_break] = ACTIONS(4148),
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [ts_builtin_sym_end] = ACTIONS(4148),
    [anon_sym___END__] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR_STAR] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_end] = ACTIONS(4148),
    [anon_sym_if] = ACTIONS(4148),
    [anon_sym_unless] = ACTIONS(4148),
    [anon_sym_while] = ACTIONS(4148),
    [anon_sym_until] = ACTIONS(4148),
    [anon_sym_rescue] = ACTIONS(4148),
    [anon_sym_do] = ACTIONS(4148),
    [anon_sym_when] = ACTIONS(4148),
    [anon_sym_elsif] = ACTIONS(4148),
    [anon_sym_else] = ACTIONS(4148),
    [anon_sym_then] = ACTIONS(4148),
    [anon_sym_ensure] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [sym_comment] = ACTIONS(87),
  },
  [1555] = {
    [sym_heredoc_body] = STATE(3700),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(6016),
    [sym_comment] = ACTIONS(87),
  },
  [1556] = {
    [anon_sym_RPAREN] = ACTIONS(6016),
    [sym_comment] = ACTIONS(87),
  },
  [1557] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [1558] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [1559] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3701),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(3701),
    [sym_operator_assignment] = STATE(3701),
    [sym_conditional] = STATE(3701),
    [sym_range] = STATE(3701),
    [sym_binary] = STATE(3701),
    [sym_unary] = STATE(3701),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1560] = {
    [sym__line_break] = ACTIONS(2267),
    [sym__heredoc_body_start] = ACTIONS(2267),
    [sym__binary_minus] = ACTIONS(2267),
    [sym__binary_star] = ACTIONS(2267),
    [ts_builtin_sym_end] = ACTIONS(2267),
    [anon_sym___END__] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_RPAREN] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2269),
    [anon_sym_COMMA] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_STAR_STAR] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_end] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_unless] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_until] = ACTIONS(2267),
    [anon_sym_rescue] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_when] = ACTIONS(2267),
    [anon_sym_elsif] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_then] = ACTIONS(2267),
    [anon_sym_ensure] = ACTIONS(2267),
    [anon_sym_EQ_GT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_COLON_COLON2] = ACTIONS(2267),
    [anon_sym_AMP_DOT] = ACTIONS(2267),
    [anon_sym_PLUS_EQ] = ACTIONS(2267),
    [anon_sym_DASH_EQ] = ACTIONS(2267),
    [anon_sym_STAR_EQ] = ACTIONS(2267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2267),
    [anon_sym_SLASH_EQ] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2267),
    [anon_sym_PIPE_EQ] = ACTIONS(2267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2267),
    [anon_sym_AMP_EQ] = ACTIONS(2267),
    [anon_sym_PERCENT_EQ] = ACTIONS(2267),
    [anon_sym_GT_GT_EQ] = ACTIONS(2267),
    [anon_sym_LT_LT_EQ] = ACTIONS(2267),
    [anon_sym_CARET_EQ] = ACTIONS(2267),
    [anon_sym_QMARK] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2267),
    [anon_sym_and] = ACTIONS(2267),
    [anon_sym_or] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_LT_LT] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2269),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2267),
    [anon_sym_LT_EQ_GT] = ACTIONS(2267),
    [anon_sym_EQ_TILDE] = ACTIONS(2267),
    [anon_sym_BANG_TILDE] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2267),
    [anon_sym_CARET] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2269),
    [sym_comment] = ACTIONS(87),
  },
  [1561] = {
    [sym__line_break] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(2351),
    [sym__binary_minus] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2351),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [anon_sym___END__] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2353),
    [anon_sym_COMMA] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2353),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_end] = ACTIONS(2351),
    [anon_sym_if] = ACTIONS(2351),
    [anon_sym_unless] = ACTIONS(2351),
    [anon_sym_while] = ACTIONS(2351),
    [anon_sym_until] = ACTIONS(2351),
    [anon_sym_rescue] = ACTIONS(2351),
    [anon_sym_do] = ACTIONS(2351),
    [anon_sym_when] = ACTIONS(2351),
    [anon_sym_elsif] = ACTIONS(2351),
    [anon_sym_else] = ACTIONS(2351),
    [anon_sym_then] = ACTIONS(2351),
    [anon_sym_ensure] = ACTIONS(2351),
    [anon_sym_EQ_GT] = ACTIONS(2351),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_COLON_COLON2] = ACTIONS(2351),
    [anon_sym_AMP_DOT] = ACTIONS(2351),
    [anon_sym_PLUS_EQ] = ACTIONS(2351),
    [anon_sym_DASH_EQ] = ACTIONS(2351),
    [anon_sym_STAR_EQ] = ACTIONS(2351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2351),
    [anon_sym_SLASH_EQ] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2351),
    [anon_sym_PIPE_EQ] = ACTIONS(2351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2351),
    [anon_sym_AMP_EQ] = ACTIONS(2351),
    [anon_sym_PERCENT_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT_EQ] = ACTIONS(2351),
    [anon_sym_LT_LT_EQ] = ACTIONS(2351),
    [anon_sym_CARET_EQ] = ACTIONS(2351),
    [anon_sym_QMARK] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2351),
    [anon_sym_or] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_CARET] = ACTIONS(2353),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_SLASH] = ACTIONS(2353),
    [anon_sym_PERCENT] = ACTIONS(2353),
    [sym_comment] = ACTIONS(87),
  },
  [1562] = {
    [sym_heredoc_body] = STATE(3703),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(6018),
    [sym_comment] = ACTIONS(87),
  },
  [1563] = {
    [anon_sym_RBRACK] = ACTIONS(6018),
    [sym_comment] = ACTIONS(87),
  },
  [1564] = {
    [sym__statements] = STATE(2528),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(2529),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6020),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1565] = {
    [sym_do_block] = STATE(3705),
    [sym_block] = STATE(3705),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_do] = ACTIONS(4234),
    [sym_comment] = ACTIONS(87),
  },
  [1566] = {
    [sym__line_break] = ACTIONS(2491),
    [sym__heredoc_body_start] = ACTIONS(2491),
    [sym__binary_minus] = ACTIONS(2491),
    [sym__binary_star] = ACTIONS(2491),
    [ts_builtin_sym_end] = ACTIONS(2491),
    [anon_sym___END__] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2493),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_STAR_STAR] = ACTIONS(2493),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_EQ] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_end] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_unless] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_until] = ACTIONS(2491),
    [anon_sym_rescue] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_when] = ACTIONS(2491),
    [anon_sym_elsif] = ACTIONS(2491),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_then] = ACTIONS(2491),
    [anon_sym_ensure] = ACTIONS(2491),
    [anon_sym_EQ_GT] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_COLON_COLON2] = ACTIONS(2491),
    [anon_sym_AMP_DOT] = ACTIONS(2491),
    [anon_sym_PLUS_EQ] = ACTIONS(2491),
    [anon_sym_DASH_EQ] = ACTIONS(2491),
    [anon_sym_STAR_EQ] = ACTIONS(2491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2491),
    [anon_sym_SLASH_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_EQ] = ACTIONS(2491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2491),
    [anon_sym_AMP_EQ] = ACTIONS(2491),
    [anon_sym_PERCENT_EQ] = ACTIONS(2491),
    [anon_sym_GT_GT_EQ] = ACTIONS(2491),
    [anon_sym_LT_LT_EQ] = ACTIONS(2491),
    [anon_sym_CARET_EQ] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2491),
    [anon_sym_DOT_DOT] = ACTIONS(2493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2491),
    [anon_sym_and] = ACTIONS(2491),
    [anon_sym_or] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2493),
    [anon_sym_AMP_AMP] = ACTIONS(2493),
    [anon_sym_LT_LT] = ACTIONS(2493),
    [anon_sym_GT_GT] = ACTIONS(2493),
    [anon_sym_EQ_EQ] = ACTIONS(2493),
    [anon_sym_BANG_EQ] = ACTIONS(2491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ_GT] = ACTIONS(2491),
    [anon_sym_EQ_TILDE] = ACTIONS(2491),
    [anon_sym_BANG_TILDE] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2493),
    [anon_sym_PLUS] = ACTIONS(2493),
    [anon_sym_SLASH] = ACTIONS(2493),
    [anon_sym_PERCENT] = ACTIONS(2493),
    [sym_comment] = ACTIONS(87),
  },
  [1567] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3706),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(3706),
    [sym_operator_assignment] = STATE(3706),
    [sym_conditional] = STATE(3706),
    [sym_range] = STATE(3706),
    [sym_binary] = STATE(3706),
    [sym_unary] = STATE(3706),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1568] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3707),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(3707),
    [sym_operator_assignment] = STATE(3707),
    [sym_conditional] = STATE(3707),
    [sym_range] = STATE(3707),
    [sym_binary] = STATE(3707),
    [sym_unary] = STATE(3707),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1569] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3708),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(3708),
    [sym_operator_assignment] = STATE(3708),
    [sym_conditional] = STATE(3708),
    [sym_range] = STATE(3708),
    [sym_binary] = STATE(3708),
    [sym_unary] = STATE(3708),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1570] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1571] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3710),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(3710),
    [sym_operator_assignment] = STATE(3710),
    [sym_conditional] = STATE(3710),
    [sym_range] = STATE(3710),
    [sym_binary] = STATE(3710),
    [sym_unary] = STATE(3710),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1572] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3711),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(3711),
    [sym_operator_assignment] = STATE(3711),
    [sym_conditional] = STATE(3711),
    [sym_range] = STATE(3711),
    [sym_binary] = STATE(3711),
    [sym_unary] = STATE(3711),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1573] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3712),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(3712),
    [sym_operator_assignment] = STATE(3712),
    [sym_conditional] = STATE(3712),
    [sym_range] = STATE(3712),
    [sym_binary] = STATE(3712),
    [sym_unary] = STATE(3712),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1574] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3713),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(3713),
    [sym_operator_assignment] = STATE(3713),
    [sym_conditional] = STATE(3713),
    [sym_range] = STATE(3713),
    [sym_binary] = STATE(3713),
    [sym_unary] = STATE(3713),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1575] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3714),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(3714),
    [sym_operator_assignment] = STATE(3714),
    [sym_conditional] = STATE(3714),
    [sym_range] = STATE(3714),
    [sym_binary] = STATE(3714),
    [sym_unary] = STATE(3714),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1576] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3715),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(3715),
    [sym_operator_assignment] = STATE(3715),
    [sym_conditional] = STATE(3715),
    [sym_range] = STATE(3715),
    [sym_binary] = STATE(3715),
    [sym_unary] = STATE(3715),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1577] = {
    [sym__statements] = STATE(2528),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(2529),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1519),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1520),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6020),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1578] = {
    [sym_do_block] = STATE(2539),
    [sym_block] = STATE(2539),
    [sym__line_break] = ACTIONS(2725),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [ts_builtin_sym_end] = ACTIONS(2725),
    [anon_sym___END__] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2693),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_end] = ACTIONS(2725),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_when] = ACTIONS(2725),
    [anon_sym_elsif] = ACTIONS(2725),
    [anon_sym_else] = ACTIONS(2725),
    [anon_sym_then] = ACTIONS(2725),
    [anon_sym_ensure] = ACTIONS(2725),
    [anon_sym_EQ_GT] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [1579] = {
    [sym__statements] = STATE(1512),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(1513),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6022),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1580] = {
    [sym__line_break] = ACTIONS(6024),
    [sym__heredoc_body_start] = ACTIONS(6024),
    [sym__binary_minus] = ACTIONS(6024),
    [sym__binary_star] = ACTIONS(6024),
    [ts_builtin_sym_end] = ACTIONS(6024),
    [anon_sym___END__] = ACTIONS(6024),
    [anon_sym_LBRACE] = ACTIONS(6024),
    [anon_sym_RBRACE] = ACTIONS(6024),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_DOT] = ACTIONS(6026),
    [anon_sym_COMMA] = ACTIONS(6024),
    [anon_sym_PIPE] = ACTIONS(6026),
    [anon_sym_SEMI] = ACTIONS(6024),
    [anon_sym_STAR_STAR] = ACTIONS(6026),
    [anon_sym_AMP] = ACTIONS(6026),
    [anon_sym_EQ] = ACTIONS(6026),
    [anon_sym_LT] = ACTIONS(6026),
    [anon_sym_end] = ACTIONS(6024),
    [anon_sym_if] = ACTIONS(6024),
    [anon_sym_unless] = ACTIONS(6024),
    [anon_sym_while] = ACTIONS(6024),
    [anon_sym_until] = ACTIONS(6024),
    [anon_sym_rescue] = ACTIONS(6024),
    [anon_sym_do] = ACTIONS(6024),
    [anon_sym_when] = ACTIONS(6024),
    [anon_sym_elsif] = ACTIONS(6024),
    [anon_sym_else] = ACTIONS(6024),
    [anon_sym_then] = ACTIONS(6024),
    [anon_sym_ensure] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_COLON_COLON2] = ACTIONS(6024),
    [anon_sym_AMP_DOT] = ACTIONS(6024),
    [anon_sym_PLUS_EQ] = ACTIONS(6024),
    [anon_sym_DASH_EQ] = ACTIONS(6024),
    [anon_sym_STAR_EQ] = ACTIONS(6024),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6024),
    [anon_sym_SLASH_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6024),
    [anon_sym_AMP_EQ] = ACTIONS(6024),
    [anon_sym_PERCENT_EQ] = ACTIONS(6024),
    [anon_sym_GT_GT_EQ] = ACTIONS(6024),
    [anon_sym_LT_LT_EQ] = ACTIONS(6024),
    [anon_sym_CARET_EQ] = ACTIONS(6024),
    [anon_sym_QMARK] = ACTIONS(6024),
    [anon_sym_DOT_DOT] = ACTIONS(6026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_or] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(6026),
    [anon_sym_LT_LT] = ACTIONS(6026),
    [anon_sym_GT_GT] = ACTIONS(6026),
    [anon_sym_EQ_EQ] = ACTIONS(6026),
    [anon_sym_BANG_EQ] = ACTIONS(6024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6024),
    [anon_sym_LT_EQ_GT] = ACTIONS(6024),
    [anon_sym_EQ_TILDE] = ACTIONS(6024),
    [anon_sym_BANG_TILDE] = ACTIONS(6024),
    [anon_sym_LT_EQ] = ACTIONS(6026),
    [anon_sym_GT] = ACTIONS(6026),
    [anon_sym_GT_EQ] = ACTIONS(6024),
    [anon_sym_CARET] = ACTIONS(6026),
    [anon_sym_PLUS] = ACTIONS(6026),
    [anon_sym_SLASH] = ACTIONS(6026),
    [anon_sym_PERCENT] = ACTIONS(6026),
    [sym_comment] = ACTIONS(87),
  },
  [1581] = {
    [sym_interpolation] = STATE(3718),
    [aux_sym_heredoc_body_repeat1] = STATE(3718),
    [sym__heredoc_content] = ACTIONS(6028),
    [sym_heredoc_end] = ACTIONS(6030),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(6028),
  },
  [1582] = {
    [sym_heredoc_body] = STATE(3719),
    [aux_sym_call_repeat1] = STATE(3719),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [1583] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(423),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(423),
    [sym_operator_assignment] = STATE(423),
    [sym_conditional] = STATE(423),
    [sym_range] = STATE(423),
    [sym_binary] = STATE(423),
    [sym_unary] = STATE(423),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(432),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(3721),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(763),
    [sym__splat_star] = ACTIONS(765),
    [sym__unary_minus] = ACTIONS(767),
    [sym__identifier_hash_key] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6032),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(811),
    [sym_identifier] = ACTIONS(811),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1584] = {
    [sym_heredoc_body] = STATE(3722),
    [aux_sym_call_repeat1] = STATE(3722),
    [aux_sym_argument_list_repeat1] = STATE(3723),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(2735),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [1585] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3724),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_splat_argument] = STATE(3726),
    [sym_assignment] = STATE(3724),
    [sym_operator_assignment] = STATE(3724),
    [sym_conditional] = STATE(3724),
    [sym_range] = STATE(3724),
    [sym_binary] = STATE(3724),
    [sym_unary] = STATE(3724),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(3726),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(1667),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1586] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3727),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(3727),
    [sym_operator_assignment] = STATE(3727),
    [sym_conditional] = STATE(3727),
    [sym_range] = STATE(3727),
    [sym_binary] = STATE(3727),
    [sym_unary] = STATE(3727),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1587] = {
    [sym_string] = STATE(3728),
    [aux_sym_chained_string_repeat1] = STATE(3728),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [ts_builtin_sym_end] = ACTIONS(2759),
    [anon_sym___END__] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [1588] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3729),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(3729),
    [sym_operator_assignment] = STATE(3729),
    [sym_conditional] = STATE(3729),
    [sym_range] = STATE(3729),
    [sym_binary] = STATE(3729),
    [sym_unary] = STATE(3729),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1589] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3730),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(3730),
    [sym_operator_assignment] = STATE(3730),
    [sym_conditional] = STATE(3730),
    [sym_range] = STATE(3730),
    [sym_binary] = STATE(3730),
    [sym_unary] = STATE(3730),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1590] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3731),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(3731),
    [sym_operator_assignment] = STATE(3731),
    [sym_conditional] = STATE(3731),
    [sym_range] = STATE(3731),
    [sym_binary] = STATE(3731),
    [sym_unary] = STATE(3731),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1591] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1592] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(4970),
    [anon_sym___END__] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(6042),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(6044),
    [anon_sym_DOT_DOT] = ACTIONS(6046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6048),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(6050),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6050),
    [anon_sym_LT_EQ_GT] = ACTIONS(6050),
    [anon_sym_EQ_TILDE] = ACTIONS(6050),
    [anon_sym_BANG_TILDE] = ACTIONS(6050),
    [anon_sym_LT_EQ] = ACTIONS(6042),
    [anon_sym_GT] = ACTIONS(6042),
    [anon_sym_GT_EQ] = ACTIONS(6056),
    [anon_sym_CARET] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [1593] = {
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6060),
    [anon_sym___END__] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_elsif] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [1594] = {
    [aux_sym_exceptions_repeat1] = STATE(3743),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6060),
    [anon_sym___END__] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6064),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [1595] = {
    [anon_sym_EQ] = ACTIONS(6066),
    [sym_comment] = ACTIONS(87),
  },
  [1596] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6068),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6070),
    [anon_sym_DASH_EQ] = ACTIONS(6070),
    [anon_sym_STAR_EQ] = ACTIONS(6070),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6070),
    [anon_sym_SLASH_EQ] = ACTIONS(6070),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6070),
    [anon_sym_PIPE_EQ] = ACTIONS(6070),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6070),
    [anon_sym_AMP_EQ] = ACTIONS(6070),
    [anon_sym_PERCENT_EQ] = ACTIONS(6070),
    [anon_sym_GT_GT_EQ] = ACTIONS(6070),
    [anon_sym_LT_LT_EQ] = ACTIONS(6070),
    [anon_sym_CARET_EQ] = ACTIONS(6070),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1597] = {
    [anon_sym_RPAREN] = ACTIONS(6072),
    [anon_sym_EQ] = ACTIONS(6072),
    [anon_sym_in] = ACTIONS(6072),
    [sym_comment] = ACTIONS(87),
  },
  [1598] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(6074),
    [anon_sym___END__] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [1599] = {
    [sym_string] = STATE(1599),
    [aux_sym_chained_string_repeat1] = STATE(1599),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [ts_builtin_sym_end] = ACTIONS(6076),
    [anon_sym___END__] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [1600] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1601] = {
    [sym__simple_symbol] = ACTIONS(1413),
    [sym__string_start] = ACTIONS(1413),
    [sym__symbol_start] = ACTIONS(1413),
    [sym__subshell_start] = ACTIONS(1413),
    [sym__regex_start] = ACTIONS(1413),
    [sym__string_array_start] = ACTIONS(1413),
    [sym__symbol_array_start] = ACTIONS(1413),
    [sym_heredoc_beginning] = ACTIONS(1413),
    [sym__block_ampersand] = ACTIONS(1413),
    [sym__splat_star] = ACTIONS(1413),
    [sym__unary_minus] = ACTIONS(1413),
    [sym__binary_minus] = ACTIONS(1413),
    [sym__binary_star] = ACTIONS(1413),
    [sym__identifier_hash_key] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_def] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1415),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_EQ] = ACTIONS(1415),
    [anon_sym_class] = ACTIONS(1415),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_return] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1415),
    [anon_sym_next] = ACTIONS(1415),
    [sym_redo] = ACTIONS(1415),
    [sym_retry] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_unless] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1415),
    [anon_sym_until] = ACTIONS(1415),
    [anon_sym_rescue] = ACTIONS(1415),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_do] = ACTIONS(1415),
    [anon_sym_case] = ACTIONS(1415),
    [anon_sym_begin] = ACTIONS(1415),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_COLON_COLON2] = ACTIONS(1413),
    [anon_sym_AMP_DOT] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1413),
    [anon_sym_PLUS_EQ] = ACTIONS(1413),
    [anon_sym_DASH_EQ] = ACTIONS(1413),
    [anon_sym_STAR_EQ] = ACTIONS(1413),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1413),
    [anon_sym_SLASH_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1413),
    [anon_sym_AMP_EQ] = ACTIONS(1413),
    [anon_sym_PERCENT_EQ] = ACTIONS(1413),
    [anon_sym_GT_GT_EQ] = ACTIONS(1413),
    [anon_sym_LT_LT_EQ] = ACTIONS(1413),
    [anon_sym_CARET_EQ] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(1415),
    [anon_sym_COLON2] = ACTIONS(1415),
    [anon_sym_DOT_DOT] = ACTIONS(1415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1413),
    [anon_sym_and] = ACTIONS(1415),
    [anon_sym_or] = ACTIONS(1415),
    [anon_sym_PIPE_PIPE] = ACTIONS(1415),
    [anon_sym_AMP_AMP] = ACTIONS(1415),
    [anon_sym_LT_LT] = ACTIONS(1415),
    [anon_sym_GT_GT] = ACTIONS(1415),
    [anon_sym_EQ_EQ] = ACTIONS(1415),
    [anon_sym_BANG_EQ] = ACTIONS(1413),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1413),
    [anon_sym_LT_EQ_GT] = ACTIONS(1413),
    [anon_sym_EQ_TILDE] = ACTIONS(1413),
    [anon_sym_BANG_TILDE] = ACTIONS(1413),
    [anon_sym_LT_EQ] = ACTIONS(1415),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_CARET] = ACTIONS(1415),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(1415),
    [anon_sym_PERCENT] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1413),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1415),
    [sym_float] = ACTIONS(1415),
    [sym_complex] = ACTIONS(1413),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1415),
    [anon_sym_TRUE] = ACTIONS(1415),
    [anon_sym_false] = ACTIONS(1415),
    [anon_sym_FALSE] = ACTIONS(1415),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(1415),
    [anon_sym_NIL] = ACTIONS(1415),
    [sym_character] = ACTIONS(1413),
    [anon_sym_LBRACK2] = ACTIONS(1415),
    [anon_sym_DASH_GT] = ACTIONS(1413),
  },
  [1602] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(3753),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(3753),
    [sym_operator_assignment] = STATE(3753),
    [sym_conditional] = STATE(3753),
    [sym_range] = STATE(3753),
    [sym_binary] = STATE(3753),
    [sym_unary] = STATE(3753),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1603] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(3758),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(3758),
    [sym_operator_assignment] = STATE(3758),
    [sym_conditional] = STATE(3758),
    [sym_range] = STATE(3758),
    [sym_binary] = STATE(3758),
    [sym_unary] = STATE(3758),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1604] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3759),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(3759),
    [sym_operator_assignment] = STATE(3759),
    [sym_conditional] = STATE(3759),
    [sym_range] = STATE(3759),
    [sym_binary] = STATE(3759),
    [sym_unary] = STATE(3759),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1605] = {
    [anon_sym_COLON] = ACTIONS(6107),
    [sym_comment] = ACTIONS(87),
  },
  [1606] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(3762),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(3762),
    [sym_operator_assignment] = STATE(3762),
    [sym_conditional] = STATE(3762),
    [sym_range] = STATE(3762),
    [sym_binary] = STATE(3762),
    [sym_unary] = STATE(3762),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1607] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3768),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(3769),
    [sym__argument] = STATE(3770),
    [sym_splat_argument] = STATE(3770),
    [sym_hash_splat_argument] = STATE(3770),
    [sym_block_argument] = STATE(3770),
    [sym_assignment] = STATE(3768),
    [sym_operator_assignment] = STATE(3768),
    [sym_conditional] = STATE(3768),
    [sym_range] = STATE(3768),
    [sym_binary] = STATE(3768),
    [sym_unary] = STATE(3768),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3771),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3770),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6109),
    [sym__splat_star] = ACTIONS(6111),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(6113),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(6115),
    [sym_identifier] = ACTIONS(6115),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1608] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3768),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(3769),
    [sym__argument] = STATE(3770),
    [sym_splat_argument] = STATE(3770),
    [sym_hash_splat_argument] = STATE(3770),
    [sym_block_argument] = STATE(3770),
    [sym_assignment] = STATE(3768),
    [sym_operator_assignment] = STATE(3768),
    [sym_conditional] = STATE(3768),
    [sym_range] = STATE(3768),
    [sym_binary] = STATE(3768),
    [sym_unary] = STATE(3768),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3771),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3770),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6109),
    [sym__splat_star] = ACTIONS(6111),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(6113),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(6115),
    [sym_identifier] = ACTIONS(6115),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1609] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3768),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(3769),
    [sym__argument] = STATE(3770),
    [sym_splat_argument] = STATE(3770),
    [sym_hash_splat_argument] = STATE(3770),
    [sym_block_argument] = STATE(3770),
    [sym_assignment] = STATE(3768),
    [sym_operator_assignment] = STATE(3768),
    [sym_conditional] = STATE(3768),
    [sym_range] = STATE(3768),
    [sym_binary] = STATE(3768),
    [sym_unary] = STATE(3768),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3771),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3770),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6109),
    [sym__splat_star] = ACTIONS(6111),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(6113),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(6115),
    [sym_identifier] = ACTIONS(6115),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1610] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3768),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(3769),
    [sym__argument] = STATE(3770),
    [sym_splat_argument] = STATE(3770),
    [sym_hash_splat_argument] = STATE(3770),
    [sym_block_argument] = STATE(3770),
    [sym_assignment] = STATE(3768),
    [sym_operator_assignment] = STATE(3768),
    [sym_conditional] = STATE(3768),
    [sym_range] = STATE(3768),
    [sym_binary] = STATE(3768),
    [sym_unary] = STATE(3768),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3771),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(3770),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6109),
    [sym__splat_star] = ACTIONS(6111),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(6113),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(6115),
    [sym_identifier] = ACTIONS(6115),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1611] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3772),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(3772),
    [sym_operator_assignment] = STATE(3772),
    [sym_conditional] = STATE(3772),
    [sym_range] = STATE(3772),
    [sym_binary] = STATE(3772),
    [sym_unary] = STATE(3772),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1612] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1613] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6117),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1614] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(6107),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [1615] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3789),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(3790),
    [sym__argument] = STATE(3791),
    [sym_splat_argument] = STATE(3791),
    [sym_hash_splat_argument] = STATE(3791),
    [sym_block_argument] = STATE(3791),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(3789),
    [sym_operator_assignment] = STATE(3789),
    [sym_conditional] = STATE(3789),
    [sym_range] = STATE(3789),
    [sym_binary] = STATE(3789),
    [sym_unary] = STATE(3789),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3792),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3791),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6145),
    [sym__splat_star] = ACTIONS(6147),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(6149),
    [anon_sym_LBRACE] = ACTIONS(2409),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(6151),
    [sym_identifier] = ACTIONS(6151),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1616] = {
    [sym_heredoc_body] = STATE(3793),
    [aux_sym_call_repeat1] = STATE(3793),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1617] = {
    [sym_heredoc_body] = STATE(3793),
    [aux_sym_call_repeat1] = STATE(3793),
    [aux_sym_argument_list_repeat1] = STATE(3795),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(6153),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1618] = {
    [anon_sym_EQ] = ACTIONS(6155),
    [sym_comment] = ACTIONS(87),
  },
  [1619] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6157),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6159),
    [anon_sym_DASH_EQ] = ACTIONS(6159),
    [anon_sym_STAR_EQ] = ACTIONS(6159),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6159),
    [anon_sym_SLASH_EQ] = ACTIONS(6159),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6159),
    [anon_sym_PIPE_EQ] = ACTIONS(6159),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6159),
    [anon_sym_AMP_EQ] = ACTIONS(6159),
    [anon_sym_PERCENT_EQ] = ACTIONS(6159),
    [anon_sym_GT_GT_EQ] = ACTIONS(6159),
    [anon_sym_LT_LT_EQ] = ACTIONS(6159),
    [anon_sym_CARET_EQ] = ACTIONS(6159),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1620] = {
    [sym_string] = STATE(3798),
    [aux_sym_chained_string_repeat1] = STATE(3798),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6161),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1621] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [1622] = {
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_unless] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_until] = ACTIONS(1263),
    [anon_sym_rescue] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
  },
  [1623] = {
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_EQ] = ACTIONS(6163),
    [anon_sym_if] = ACTIONS(1267),
    [anon_sym_unless] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1267),
    [anon_sym_until] = ACTIONS(1267),
    [anon_sym_rescue] = ACTIONS(1267),
    [sym_comment] = ACTIONS(87),
  },
  [1624] = {
    [aux_sym_undef_repeat1] = STATE(3801),
    [anon_sym_RBRACE] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(6165),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [1625] = {
    [sym_operator] = STATE(3802),
    [sym__method_name] = STATE(3802),
    [sym_setter] = STATE(3802),
    [sym_symbol] = STATE(3802),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__symbol_start] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_STAR_STAR] = ACTIONS(2795),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_LT] = ACTIONS(2797),
    [anon_sym_DOT_DOT] = ACTIONS(2795),
    [anon_sym_LT_LT] = ACTIONS(2795),
    [anon_sym_GT_GT] = ACTIONS(2795),
    [anon_sym_EQ_EQ] = ACTIONS(2797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2795),
    [anon_sym_LT_EQ_GT] = ACTIONS(2795),
    [anon_sym_EQ_TILDE] = ACTIONS(2795),
    [anon_sym_BANG_TILDE] = ACTIONS(2795),
    [anon_sym_LT_EQ] = ACTIONS(2797),
    [anon_sym_GT] = ACTIONS(2797),
    [anon_sym_GT_EQ] = ACTIONS(2795),
    [anon_sym_CARET] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_SLASH] = ACTIONS(2795),
    [anon_sym_PERCENT] = ACTIONS(2795),
    [anon_sym_BANG] = ACTIONS(2797),
    [anon_sym_TILDE] = ACTIONS(2795),
    [sym_constant] = ACTIONS(6167),
    [sym_identifier] = ACTIONS(2801),
    [sym_instance_variable] = ACTIONS(6167),
    [sym_class_variable] = ACTIONS(6167),
    [sym_global_variable] = ACTIONS(6167),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_PLUS_AT] = ACTIONS(2795),
    [anon_sym_DASH_AT] = ACTIONS(2795),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2797),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2795),
    [anon_sym_BQUOTE] = ACTIONS(2795),
    [sym_comment] = ACTIONS(87),
  },
  [1626] = {
    [sym__string_content] = ACTIONS(6169),
    [sym__string_end] = ACTIONS(6169),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6171),
    [sym_escape_sequence] = ACTIONS(6169),
  },
  [1627] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3803),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3803),
    [sym_operator_assignment] = STATE(3803),
    [sym_conditional] = STATE(3803),
    [sym_range] = STATE(3803),
    [sym_binary] = STATE(3803),
    [sym_unary] = STATE(3803),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1628] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3804),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3804),
    [sym_operator_assignment] = STATE(3804),
    [sym_conditional] = STATE(3804),
    [sym_range] = STATE(3804),
    [sym_binary] = STATE(3804),
    [sym_unary] = STATE(3804),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1629] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3805),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3805),
    [sym_operator_assignment] = STATE(3805),
    [sym_conditional] = STATE(3805),
    [sym_range] = STATE(3805),
    [sym_binary] = STATE(3805),
    [sym_unary] = STATE(3805),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1630] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3806),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3806),
    [sym_operator_assignment] = STATE(3806),
    [sym_conditional] = STATE(3806),
    [sym_range] = STATE(3806),
    [sym_binary] = STATE(3806),
    [sym_unary] = STATE(3806),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1631] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3807),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3807),
    [sym_operator_assignment] = STATE(3807),
    [sym_conditional] = STATE(3807),
    [sym_range] = STATE(3807),
    [sym_binary] = STATE(3807),
    [sym_unary] = STATE(3807),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1632] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3808),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3808),
    [sym_operator_assignment] = STATE(3808),
    [sym_conditional] = STATE(3808),
    [sym_range] = STATE(3808),
    [sym_binary] = STATE(3808),
    [sym_unary] = STATE(3808),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1633] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3809),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3809),
    [sym_operator_assignment] = STATE(3809),
    [sym_conditional] = STATE(3809),
    [sym_range] = STATE(3809),
    [sym_binary] = STATE(3809),
    [sym_unary] = STATE(3809),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1634] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3810),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3810),
    [sym_operator_assignment] = STATE(3810),
    [sym_conditional] = STATE(3810),
    [sym_range] = STATE(3810),
    [sym_binary] = STATE(3810),
    [sym_unary] = STATE(3810),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1635] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3811),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3811),
    [sym_operator_assignment] = STATE(3811),
    [sym_conditional] = STATE(3811),
    [sym_range] = STATE(3811),
    [sym_binary] = STATE(3811),
    [sym_unary] = STATE(3811),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1636] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3812),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3812),
    [sym_operator_assignment] = STATE(3812),
    [sym_conditional] = STATE(3812),
    [sym_range] = STATE(3812),
    [sym_binary] = STATE(3812),
    [sym_unary] = STATE(3812),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1637] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3813),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(3813),
    [sym_operator_assignment] = STATE(3813),
    [sym_conditional] = STATE(3813),
    [sym_range] = STATE(3813),
    [sym_binary] = STATE(3813),
    [sym_unary] = STATE(3813),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1638] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3814),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3814),
    [sym_operator_assignment] = STATE(3814),
    [sym_conditional] = STATE(3814),
    [sym_range] = STATE(3814),
    [sym_binary] = STATE(3814),
    [sym_unary] = STATE(3814),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1639] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3815),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3815),
    [sym_operator_assignment] = STATE(3815),
    [sym_conditional] = STATE(3815),
    [sym_range] = STATE(3815),
    [sym_binary] = STATE(3815),
    [sym_unary] = STATE(3815),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1640] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3816),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3816),
    [sym_operator_assignment] = STATE(3816),
    [sym_conditional] = STATE(3816),
    [sym_range] = STATE(3816),
    [sym_binary] = STATE(3816),
    [sym_unary] = STATE(3816),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1641] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3817),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3817),
    [sym_operator_assignment] = STATE(3817),
    [sym_conditional] = STATE(3817),
    [sym_range] = STATE(3817),
    [sym_binary] = STATE(3817),
    [sym_unary] = STATE(3817),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1642] = {
    [sym_argument_list_with_parens] = STATE(3820),
    [sym__argument_list_with_parens] = STATE(3821),
    [sym_operator] = STATE(3820),
    [sym_heredoc_body] = STATE(3822),
    [aux_sym_call_repeat1] = STATE(3822),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(6173),
    [anon_sym_STAR] = ACTIONS(6175),
    [anon_sym_STAR_STAR] = ACTIONS(6173),
    [anon_sym_AMP] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6175),
    [anon_sym_LPAREN2] = ACTIONS(6177),
    [anon_sym_DOT_DOT] = ACTIONS(6173),
    [anon_sym_LT_LT] = ACTIONS(6173),
    [anon_sym_GT_GT] = ACTIONS(6173),
    [anon_sym_EQ_EQ] = ACTIONS(6175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LT_EQ_GT] = ACTIONS(6173),
    [anon_sym_EQ_TILDE] = ACTIONS(6173),
    [anon_sym_BANG_TILDE] = ACTIONS(6173),
    [anon_sym_LT_EQ] = ACTIONS(6175),
    [anon_sym_GT] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_CARET] = ACTIONS(6173),
    [anon_sym_PLUS] = ACTIONS(6175),
    [anon_sym_SLASH] = ACTIONS(6173),
    [anon_sym_PERCENT] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(6175),
    [anon_sym_TILDE] = ACTIONS(6173),
    [sym_constant] = ACTIONS(6179),
    [sym_identifier] = ACTIONS(6179),
    [anon_sym_DASH] = ACTIONS(6175),
    [anon_sym_PLUS_AT] = ACTIONS(6173),
    [anon_sym_DASH_AT] = ACTIONS(6173),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6175),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6173),
    [anon_sym_BQUOTE] = ACTIONS(6173),
    [sym_comment] = ACTIONS(87),
  },
  [1643] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(3824),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(3825),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(6181),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1644] = {
    [sym_constant] = ACTIONS(6183),
    [sym_identifier] = ACTIONS(6183),
    [sym_comment] = ACTIONS(87),
  },
  [1645] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(3856),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(3856),
    [sym_operator_assignment] = STATE(3856),
    [sym_conditional] = STATE(3856),
    [sym_range] = STATE(3856),
    [sym_binary] = STATE(3856),
    [sym_unary] = STATE(3856),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [1646] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(3862),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(3862),
    [sym_operator_assignment] = STATE(3862),
    [sym_conditional] = STATE(3862),
    [sym_range] = STATE(3862),
    [sym_binary] = STATE(3862),
    [sym_unary] = STATE(3862),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [1647] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3863),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(3863),
    [sym_operator_assignment] = STATE(3863),
    [sym_conditional] = STATE(3863),
    [sym_range] = STATE(3863),
    [sym_binary] = STATE(3863),
    [sym_unary] = STATE(3863),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1648] = {
    [anon_sym_COLON] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [1649] = {
    [sym__statements] = STATE(3867),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(3868),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1939),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1940),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6259),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1650] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(3869),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(3869),
    [sym_operator_assignment] = STATE(3869),
    [sym_conditional] = STATE(3869),
    [sym_range] = STATE(3869),
    [sym_binary] = STATE(3869),
    [sym_unary] = STATE(3869),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [1651] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3789),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(1953),
    [sym__argument_list_with_parens] = STATE(3790),
    [sym__argument] = STATE(3791),
    [sym_splat_argument] = STATE(3791),
    [sym_hash_splat_argument] = STATE(3791),
    [sym_block_argument] = STATE(3791),
    [sym_assignment] = STATE(3789),
    [sym_operator_assignment] = STATE(3789),
    [sym_conditional] = STATE(3789),
    [sym_range] = STATE(3789),
    [sym_binary] = STATE(3789),
    [sym_unary] = STATE(3789),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3792),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3791),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6145),
    [sym__splat_star] = ACTIONS(6147),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(6149),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(6151),
    [sym_identifier] = ACTIONS(6151),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1652] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3789),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(1954),
    [sym__argument_list_with_parens] = STATE(3790),
    [sym__argument] = STATE(3791),
    [sym_splat_argument] = STATE(3791),
    [sym_hash_splat_argument] = STATE(3791),
    [sym_block_argument] = STATE(3791),
    [sym_assignment] = STATE(3789),
    [sym_operator_assignment] = STATE(3789),
    [sym_conditional] = STATE(3789),
    [sym_range] = STATE(3789),
    [sym_binary] = STATE(3789),
    [sym_unary] = STATE(3789),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3792),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3791),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6145),
    [sym__splat_star] = ACTIONS(6147),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(6149),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(6151),
    [sym_identifier] = ACTIONS(6151),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1653] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3789),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(1955),
    [sym__argument_list_with_parens] = STATE(3790),
    [sym__argument] = STATE(3791),
    [sym_splat_argument] = STATE(3791),
    [sym_hash_splat_argument] = STATE(3791),
    [sym_block_argument] = STATE(3791),
    [sym_assignment] = STATE(3789),
    [sym_operator_assignment] = STATE(3789),
    [sym_conditional] = STATE(3789),
    [sym_range] = STATE(3789),
    [sym_binary] = STATE(3789),
    [sym_unary] = STATE(3789),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3792),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3791),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6145),
    [sym__splat_star] = ACTIONS(6147),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(6149),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(6151),
    [sym_identifier] = ACTIONS(6151),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1654] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3789),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(1956),
    [sym__argument_list_with_parens] = STATE(3790),
    [sym__argument] = STATE(3791),
    [sym_splat_argument] = STATE(3791),
    [sym_hash_splat_argument] = STATE(3791),
    [sym_block_argument] = STATE(3791),
    [sym_assignment] = STATE(3789),
    [sym_operator_assignment] = STATE(3789),
    [sym_conditional] = STATE(3789),
    [sym_range] = STATE(3789),
    [sym_binary] = STATE(3789),
    [sym_unary] = STATE(3789),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3792),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3791),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6145),
    [sym__splat_star] = ACTIONS(6147),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(6149),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(6151),
    [sym_identifier] = ACTIONS(6151),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1655] = {
    [sym__statements] = STATE(3871),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(3872),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(3873),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(3873),
    [sym__line_break] = ACTIONS(6261),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6263),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1656] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(3875),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(3876),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(6265),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1657] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3877),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(3877),
    [sym_operator_assignment] = STATE(3877),
    [sym_conditional] = STATE(3877),
    [sym_range] = STATE(3877),
    [sym_binary] = STATE(3877),
    [sym_unary] = STATE(3877),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1658] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1978),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(1978),
    [sym_operator_assignment] = STATE(1978),
    [sym_conditional] = STATE(1978),
    [sym_range] = STATE(1978),
    [sym_binary] = STATE(1978),
    [sym_unary] = STATE(1978),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1659] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6267),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1660] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [1661] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3789),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(3790),
    [sym__argument] = STATE(3791),
    [sym_splat_argument] = STATE(3791),
    [sym_hash_splat_argument] = STATE(3791),
    [sym_block_argument] = STATE(3791),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(3789),
    [sym_operator_assignment] = STATE(3789),
    [sym_conditional] = STATE(3789),
    [sym_range] = STATE(3789),
    [sym_binary] = STATE(3789),
    [sym_unary] = STATE(3789),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3792),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3791),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6145),
    [sym__splat_star] = ACTIONS(6147),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(6149),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(6151),
    [sym_identifier] = ACTIONS(6151),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1662] = {
    [sym_do_block] = STATE(3890),
    [sym_block] = STATE(3890),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(6299),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_COLON2] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [1663] = {
    [sym_heredoc_body] = STATE(3892),
    [aux_sym_call_repeat1] = STATE(3892),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1664] = {
    [sym_heredoc_body] = STATE(3892),
    [aux_sym_call_repeat1] = STATE(3892),
    [aux_sym_argument_list_repeat1] = STATE(3894),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(6303),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1665] = {
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_COLON2] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [1666] = {
    [anon_sym_EQ] = ACTIONS(6305),
    [sym_comment] = ACTIONS(87),
  },
  [1667] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6307),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6309),
    [anon_sym_DASH_EQ] = ACTIONS(6309),
    [anon_sym_STAR_EQ] = ACTIONS(6309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6309),
    [anon_sym_SLASH_EQ] = ACTIONS(6309),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6309),
    [anon_sym_PIPE_EQ] = ACTIONS(6309),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6309),
    [anon_sym_AMP_EQ] = ACTIONS(6309),
    [anon_sym_PERCENT_EQ] = ACTIONS(6309),
    [anon_sym_GT_GT_EQ] = ACTIONS(6309),
    [anon_sym_LT_LT_EQ] = ACTIONS(6309),
    [anon_sym_CARET_EQ] = ACTIONS(6309),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1668] = {
    [sym_string] = STATE(3897),
    [aux_sym_chained_string_repeat1] = STATE(3897),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6311),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1669] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3906),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_splat_argument] = STATE(3907),
    [sym_assignment] = STATE(3906),
    [sym_operator_assignment] = STATE(3906),
    [sym_conditional] = STATE(3906),
    [sym_range] = STATE(3906),
    [sym_binary] = STATE(3906),
    [sym_unary] = STATE(3906),
    [sym_right_assignment_list] = STATE(2017),
    [sym__arg_or_splat_arg] = STATE(3907),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1670] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3911),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(3911),
    [sym_operator_assignment] = STATE(3911),
    [sym_conditional] = STATE(3911),
    [sym_range] = STATE(3911),
    [sym_binary] = STATE(3911),
    [sym_unary] = STATE(3911),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1671] = {
    [sym_string] = STATE(3912),
    [aux_sym_chained_string_repeat1] = STATE(3912),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [1672] = {
    [sym__string_content] = ACTIONS(6169),
    [sym__string_end] = ACTIONS(6169),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6171),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6171),
    [sym_escape_sequence] = ACTIONS(6171),
  },
  [1673] = {
    [sym__line_break] = ACTIONS(6333),
    [sym__heredoc_body_start] = ACTIONS(6333),
    [sym__binary_minus] = ACTIONS(6333),
    [sym__binary_star] = ACTIONS(6333),
    [ts_builtin_sym_end] = ACTIONS(6333),
    [anon_sym___END__] = ACTIONS(6333),
    [anon_sym_LBRACE] = ACTIONS(6333),
    [anon_sym_RBRACE] = ACTIONS(6333),
    [anon_sym_RPAREN] = ACTIONS(6333),
    [anon_sym_DOT] = ACTIONS(6335),
    [anon_sym_COMMA] = ACTIONS(6333),
    [anon_sym_PIPE] = ACTIONS(6335),
    [anon_sym_SEMI] = ACTIONS(6333),
    [anon_sym_STAR_STAR] = ACTIONS(6333),
    [anon_sym_AMP] = ACTIONS(6335),
    [anon_sym_LT] = ACTIONS(6335),
    [anon_sym_end] = ACTIONS(6333),
    [anon_sym_if] = ACTIONS(6333),
    [anon_sym_unless] = ACTIONS(6333),
    [anon_sym_while] = ACTIONS(6333),
    [anon_sym_until] = ACTIONS(6333),
    [anon_sym_rescue] = ACTIONS(6333),
    [anon_sym_do] = ACTIONS(6333),
    [anon_sym_when] = ACTIONS(6333),
    [anon_sym_elsif] = ACTIONS(6333),
    [anon_sym_else] = ACTIONS(6333),
    [anon_sym_then] = ACTIONS(6333),
    [anon_sym_ensure] = ACTIONS(6333),
    [anon_sym_EQ_GT] = ACTIONS(6333),
    [anon_sym_LBRACK] = ACTIONS(6333),
    [anon_sym_COLON_COLON2] = ACTIONS(6333),
    [anon_sym_AMP_DOT] = ACTIONS(6333),
    [anon_sym_QMARK] = ACTIONS(6333),
    [anon_sym_DOT_DOT] = ACTIONS(6335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6333),
    [anon_sym_and] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE] = ACTIONS(6333),
    [anon_sym_AMP_AMP] = ACTIONS(6333),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_EQ_EQ] = ACTIONS(6335),
    [anon_sym_BANG_EQ] = ACTIONS(6333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6333),
    [anon_sym_LT_EQ_GT] = ACTIONS(6333),
    [anon_sym_EQ_TILDE] = ACTIONS(6333),
    [anon_sym_BANG_TILDE] = ACTIONS(6333),
    [anon_sym_LT_EQ] = ACTIONS(6335),
    [anon_sym_GT] = ACTIONS(6335),
    [anon_sym_GT_EQ] = ACTIONS(6333),
    [anon_sym_CARET] = ACTIONS(6333),
    [anon_sym_PLUS] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6333),
    [anon_sym_PERCENT] = ACTIONS(6333),
    [sym_comment] = ACTIONS(87),
  },
  [1674] = {
    [sym__line_break] = ACTIONS(6337),
    [sym__heredoc_body_start] = ACTIONS(6337),
    [sym__binary_minus] = ACTIONS(6337),
    [sym__binary_star] = ACTIONS(6337),
    [ts_builtin_sym_end] = ACTIONS(6337),
    [anon_sym___END__] = ACTIONS(6337),
    [anon_sym_LBRACE] = ACTIONS(6337),
    [anon_sym_RBRACE] = ACTIONS(6337),
    [anon_sym_RPAREN] = ACTIONS(6337),
    [anon_sym_DOT] = ACTIONS(6339),
    [anon_sym_COMMA] = ACTIONS(6337),
    [anon_sym_PIPE] = ACTIONS(6339),
    [anon_sym_SEMI] = ACTIONS(6337),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_AMP] = ACTIONS(6339),
    [anon_sym_LT] = ACTIONS(6339),
    [anon_sym_end] = ACTIONS(6337),
    [anon_sym_if] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6337),
    [anon_sym_while] = ACTIONS(6337),
    [anon_sym_until] = ACTIONS(6337),
    [anon_sym_rescue] = ACTIONS(6337),
    [anon_sym_do] = ACTIONS(6337),
    [anon_sym_when] = ACTIONS(6337),
    [anon_sym_elsif] = ACTIONS(6337),
    [anon_sym_else] = ACTIONS(6337),
    [anon_sym_then] = ACTIONS(6337),
    [anon_sym_ensure] = ACTIONS(6337),
    [anon_sym_EQ_GT] = ACTIONS(6337),
    [anon_sym_LBRACK] = ACTIONS(6337),
    [anon_sym_COLON_COLON2] = ACTIONS(6337),
    [anon_sym_AMP_DOT] = ACTIONS(6337),
    [anon_sym_QMARK] = ACTIONS(6337),
    [anon_sym_DOT_DOT] = ACTIONS(6339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6337),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6337),
    [anon_sym_AMP_AMP] = ACTIONS(6337),
    [anon_sym_LT_LT] = ACTIONS(6337),
    [anon_sym_GT_GT] = ACTIONS(6337),
    [anon_sym_EQ_EQ] = ACTIONS(6339),
    [anon_sym_BANG_EQ] = ACTIONS(6337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6337),
    [anon_sym_LT_EQ_GT] = ACTIONS(6337),
    [anon_sym_EQ_TILDE] = ACTIONS(6337),
    [anon_sym_BANG_TILDE] = ACTIONS(6337),
    [anon_sym_LT_EQ] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6339),
    [anon_sym_GT_EQ] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [anon_sym_PLUS] = ACTIONS(6337),
    [anon_sym_SLASH] = ACTIONS(6337),
    [anon_sym_PERCENT] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
  },
  [1675] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6341),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1676] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(6341),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6343),
  },
  [1677] = {
    [sym__line_break] = ACTIONS(6345),
    [sym__heredoc_body_start] = ACTIONS(6345),
    [sym__binary_minus] = ACTIONS(6345),
    [sym__binary_star] = ACTIONS(6345),
    [ts_builtin_sym_end] = ACTIONS(6345),
    [anon_sym___END__] = ACTIONS(6345),
    [anon_sym_LBRACE] = ACTIONS(6345),
    [anon_sym_RBRACE] = ACTIONS(6345),
    [anon_sym_RPAREN] = ACTIONS(6345),
    [anon_sym_DOT] = ACTIONS(6347),
    [anon_sym_COMMA] = ACTIONS(6345),
    [anon_sym_PIPE] = ACTIONS(6347),
    [anon_sym_SEMI] = ACTIONS(6345),
    [anon_sym_STAR_STAR] = ACTIONS(6345),
    [anon_sym_AMP] = ACTIONS(6347),
    [anon_sym_LT] = ACTIONS(6347),
    [anon_sym_end] = ACTIONS(6345),
    [anon_sym_if] = ACTIONS(6345),
    [anon_sym_unless] = ACTIONS(6345),
    [anon_sym_while] = ACTIONS(6345),
    [anon_sym_until] = ACTIONS(6345),
    [anon_sym_rescue] = ACTIONS(6345),
    [anon_sym_do] = ACTIONS(6345),
    [anon_sym_when] = ACTIONS(6345),
    [anon_sym_elsif] = ACTIONS(6345),
    [anon_sym_else] = ACTIONS(6345),
    [anon_sym_then] = ACTIONS(6345),
    [anon_sym_ensure] = ACTIONS(6345),
    [anon_sym_EQ_GT] = ACTIONS(6345),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_COLON_COLON2] = ACTIONS(6345),
    [anon_sym_AMP_DOT] = ACTIONS(6345),
    [anon_sym_QMARK] = ACTIONS(6345),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6345),
    [anon_sym_and] = ACTIONS(6345),
    [anon_sym_or] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE] = ACTIONS(6345),
    [anon_sym_AMP_AMP] = ACTIONS(6345),
    [anon_sym_LT_LT] = ACTIONS(6345),
    [anon_sym_GT_GT] = ACTIONS(6345),
    [anon_sym_EQ_EQ] = ACTIONS(6347),
    [anon_sym_BANG_EQ] = ACTIONS(6345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6345),
    [anon_sym_LT_EQ_GT] = ACTIONS(6345),
    [anon_sym_EQ_TILDE] = ACTIONS(6345),
    [anon_sym_BANG_TILDE] = ACTIONS(6345),
    [anon_sym_LT_EQ] = ACTIONS(6347),
    [anon_sym_GT] = ACTIONS(6347),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_CARET] = ACTIONS(6345),
    [anon_sym_PLUS] = ACTIONS(6345),
    [anon_sym_SLASH] = ACTIONS(6345),
    [anon_sym_PERCENT] = ACTIONS(6345),
    [sym_comment] = ACTIONS(87),
  },
  [1678] = {
    [sym__string_end] = ACTIONS(6349),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6349),
  },
  [1679] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6351),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1680] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(6353),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6355),
  },
  [1681] = {
    [sym__line_break] = ACTIONS(6358),
    [sym__heredoc_body_start] = ACTIONS(6358),
    [sym__binary_minus] = ACTIONS(6358),
    [sym__binary_star] = ACTIONS(6358),
    [ts_builtin_sym_end] = ACTIONS(6358),
    [anon_sym___END__] = ACTIONS(6358),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RBRACE] = ACTIONS(6358),
    [anon_sym_RPAREN] = ACTIONS(6358),
    [anon_sym_DOT] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6360),
    [anon_sym_SEMI] = ACTIONS(6358),
    [anon_sym_STAR_STAR] = ACTIONS(6358),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6360),
    [anon_sym_end] = ACTIONS(6358),
    [anon_sym_if] = ACTIONS(6358),
    [anon_sym_unless] = ACTIONS(6358),
    [anon_sym_while] = ACTIONS(6358),
    [anon_sym_until] = ACTIONS(6358),
    [anon_sym_rescue] = ACTIONS(6358),
    [anon_sym_do] = ACTIONS(6358),
    [anon_sym_when] = ACTIONS(6358),
    [anon_sym_elsif] = ACTIONS(6358),
    [anon_sym_else] = ACTIONS(6358),
    [anon_sym_then] = ACTIONS(6358),
    [anon_sym_ensure] = ACTIONS(6358),
    [anon_sym_EQ_GT] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6358),
    [anon_sym_COLON_COLON2] = ACTIONS(6358),
    [anon_sym_AMP_DOT] = ACTIONS(6358),
    [anon_sym_QMARK] = ACTIONS(6358),
    [anon_sym_DOT_DOT] = ACTIONS(6360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6358),
    [anon_sym_and] = ACTIONS(6358),
    [anon_sym_or] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE] = ACTIONS(6358),
    [anon_sym_AMP_AMP] = ACTIONS(6358),
    [anon_sym_LT_LT] = ACTIONS(6358),
    [anon_sym_GT_GT] = ACTIONS(6358),
    [anon_sym_EQ_EQ] = ACTIONS(6360),
    [anon_sym_BANG_EQ] = ACTIONS(6358),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6358),
    [anon_sym_LT_EQ_GT] = ACTIONS(6358),
    [anon_sym_EQ_TILDE] = ACTIONS(6358),
    [anon_sym_BANG_TILDE] = ACTIONS(6358),
    [anon_sym_LT_EQ] = ACTIONS(6360),
    [anon_sym_GT] = ACTIONS(6360),
    [anon_sym_GT_EQ] = ACTIONS(6358),
    [anon_sym_CARET] = ACTIONS(6358),
    [anon_sym_PLUS] = ACTIONS(6358),
    [anon_sym_SLASH] = ACTIONS(6358),
    [anon_sym_PERCENT] = ACTIONS(6358),
    [sym_comment] = ACTIONS(87),
  },
  [1682] = {
    [sym__line_break] = ACTIONS(6362),
    [sym__heredoc_body_start] = ACTIONS(6362),
    [sym__binary_minus] = ACTIONS(6362),
    [sym__binary_star] = ACTIONS(6362),
    [ts_builtin_sym_end] = ACTIONS(6362),
    [anon_sym___END__] = ACTIONS(6362),
    [anon_sym_LBRACE] = ACTIONS(6362),
    [anon_sym_RBRACE] = ACTIONS(6362),
    [anon_sym_RPAREN] = ACTIONS(6362),
    [anon_sym_DOT] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6364),
    [anon_sym_SEMI] = ACTIONS(6362),
    [anon_sym_STAR_STAR] = ACTIONS(6362),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6364),
    [anon_sym_end] = ACTIONS(6362),
    [anon_sym_if] = ACTIONS(6362),
    [anon_sym_unless] = ACTIONS(6362),
    [anon_sym_while] = ACTIONS(6362),
    [anon_sym_until] = ACTIONS(6362),
    [anon_sym_rescue] = ACTIONS(6362),
    [anon_sym_do] = ACTIONS(6362),
    [anon_sym_when] = ACTIONS(6362),
    [anon_sym_elsif] = ACTIONS(6362),
    [anon_sym_else] = ACTIONS(6362),
    [anon_sym_then] = ACTIONS(6362),
    [anon_sym_ensure] = ACTIONS(6362),
    [anon_sym_EQ_GT] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6362),
    [anon_sym_COLON_COLON2] = ACTIONS(6362),
    [anon_sym_AMP_DOT] = ACTIONS(6362),
    [anon_sym_QMARK] = ACTIONS(6362),
    [anon_sym_DOT_DOT] = ACTIONS(6364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6362),
    [anon_sym_and] = ACTIONS(6362),
    [anon_sym_or] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE] = ACTIONS(6362),
    [anon_sym_AMP_AMP] = ACTIONS(6362),
    [anon_sym_LT_LT] = ACTIONS(6362),
    [anon_sym_GT_GT] = ACTIONS(6362),
    [anon_sym_EQ_EQ] = ACTIONS(6364),
    [anon_sym_BANG_EQ] = ACTIONS(6362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6362),
    [anon_sym_LT_EQ_GT] = ACTIONS(6362),
    [anon_sym_EQ_TILDE] = ACTIONS(6362),
    [anon_sym_BANG_TILDE] = ACTIONS(6362),
    [anon_sym_LT_EQ] = ACTIONS(6364),
    [anon_sym_GT] = ACTIONS(6364),
    [anon_sym_GT_EQ] = ACTIONS(6362),
    [anon_sym_CARET] = ACTIONS(6362),
    [anon_sym_PLUS] = ACTIONS(6362),
    [anon_sym_SLASH] = ACTIONS(6362),
    [anon_sym_PERCENT] = ACTIONS(6362),
    [sym_comment] = ACTIONS(87),
  },
  [1683] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6366),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1684] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(6366),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6368),
  },
  [1685] = {
    [sym__line_break] = ACTIONS(6370),
    [sym__heredoc_body_start] = ACTIONS(6370),
    [sym__binary_minus] = ACTIONS(6370),
    [sym__binary_star] = ACTIONS(6370),
    [ts_builtin_sym_end] = ACTIONS(6370),
    [anon_sym___END__] = ACTIONS(6370),
    [anon_sym_LBRACE] = ACTIONS(6370),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_RPAREN] = ACTIONS(6370),
    [anon_sym_DOT] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym_STAR_STAR] = ACTIONS(6370),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_end] = ACTIONS(6370),
    [anon_sym_if] = ACTIONS(6370),
    [anon_sym_unless] = ACTIONS(6370),
    [anon_sym_while] = ACTIONS(6370),
    [anon_sym_until] = ACTIONS(6370),
    [anon_sym_rescue] = ACTIONS(6370),
    [anon_sym_do] = ACTIONS(6370),
    [anon_sym_when] = ACTIONS(6370),
    [anon_sym_elsif] = ACTIONS(6370),
    [anon_sym_else] = ACTIONS(6370),
    [anon_sym_then] = ACTIONS(6370),
    [anon_sym_ensure] = ACTIONS(6370),
    [anon_sym_EQ_GT] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6370),
    [anon_sym_COLON_COLON2] = ACTIONS(6370),
    [anon_sym_AMP_DOT] = ACTIONS(6370),
    [anon_sym_QMARK] = ACTIONS(6370),
    [anon_sym_DOT_DOT] = ACTIONS(6372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6370),
    [anon_sym_and] = ACTIONS(6370),
    [anon_sym_or] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_LT_LT] = ACTIONS(6370),
    [anon_sym_GT_GT] = ACTIONS(6370),
    [anon_sym_EQ_EQ] = ACTIONS(6372),
    [anon_sym_BANG_EQ] = ACTIONS(6370),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6370),
    [anon_sym_LT_EQ_GT] = ACTIONS(6370),
    [anon_sym_EQ_TILDE] = ACTIONS(6370),
    [anon_sym_BANG_TILDE] = ACTIONS(6370),
    [anon_sym_LT_EQ] = ACTIONS(6372),
    [anon_sym_GT] = ACTIONS(6372),
    [anon_sym_GT_EQ] = ACTIONS(6370),
    [anon_sym_CARET] = ACTIONS(6370),
    [anon_sym_PLUS] = ACTIONS(6370),
    [anon_sym_SLASH] = ACTIONS(6370),
    [anon_sym_PERCENT] = ACTIONS(6370),
    [sym_comment] = ACTIONS(87),
  },
  [1686] = {
    [sym__string_end] = ACTIONS(6374),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6374),
  },
  [1687] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6376),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1688] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(6378),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6380),
  },
  [1689] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1690] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3928),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(3928),
    [sym_operator_assignment] = STATE(3928),
    [sym_conditional] = STATE(3928),
    [sym_range] = STATE(3928),
    [sym_binary] = STATE(3928),
    [sym_unary] = STATE(3928),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1691] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3932),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(3932),
    [sym_operator_assignment] = STATE(3932),
    [sym_conditional] = STATE(3932),
    [sym_range] = STATE(3932),
    [sym_binary] = STATE(3932),
    [sym_unary] = STATE(3932),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1692] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3933),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(3933),
    [sym_operator_assignment] = STATE(3933),
    [sym_conditional] = STATE(3933),
    [sym_range] = STATE(3933),
    [sym_binary] = STATE(3933),
    [sym_unary] = STATE(3933),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1693] = {
    [anon_sym_COLON] = ACTIONS(6403),
    [sym_comment] = ACTIONS(87),
  },
  [1694] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3936),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(3936),
    [sym_operator_assignment] = STATE(3936),
    [sym_conditional] = STATE(3936),
    [sym_range] = STATE(3936),
    [sym_binary] = STATE(3936),
    [sym_unary] = STATE(3936),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1695] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3642),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(3937),
    [sym__argument] = STATE(3938),
    [sym_splat_argument] = STATE(3938),
    [sym_hash_splat_argument] = STATE(3938),
    [sym_block_argument] = STATE(3938),
    [sym_assignment] = STATE(3642),
    [sym_operator_assignment] = STATE(3642),
    [sym_conditional] = STATE(3642),
    [sym_range] = STATE(3642),
    [sym_binary] = STATE(3642),
    [sym_unary] = STATE(3642),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3645),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3938),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5928),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5934),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1696] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3642),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3937),
    [sym__argument] = STATE(3938),
    [sym_splat_argument] = STATE(3938),
    [sym_hash_splat_argument] = STATE(3938),
    [sym_block_argument] = STATE(3938),
    [sym_assignment] = STATE(3642),
    [sym_operator_assignment] = STATE(3642),
    [sym_conditional] = STATE(3642),
    [sym_range] = STATE(3642),
    [sym_binary] = STATE(3642),
    [sym_unary] = STATE(3642),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3645),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3938),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5928),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5934),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1697] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3642),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(3937),
    [sym__argument] = STATE(3938),
    [sym_splat_argument] = STATE(3938),
    [sym_hash_splat_argument] = STATE(3938),
    [sym_block_argument] = STATE(3938),
    [sym_assignment] = STATE(3642),
    [sym_operator_assignment] = STATE(3642),
    [sym_conditional] = STATE(3642),
    [sym_range] = STATE(3642),
    [sym_binary] = STATE(3642),
    [sym_unary] = STATE(3642),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3645),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3938),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5928),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5934),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1698] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3642),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(3937),
    [sym__argument] = STATE(3938),
    [sym_splat_argument] = STATE(3938),
    [sym_hash_splat_argument] = STATE(3938),
    [sym_block_argument] = STATE(3938),
    [sym_assignment] = STATE(3642),
    [sym_operator_assignment] = STATE(3642),
    [sym_conditional] = STATE(3642),
    [sym_range] = STATE(3642),
    [sym_binary] = STATE(3642),
    [sym_unary] = STATE(3642),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3645),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(3938),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5928),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5934),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1699] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3939),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(3939),
    [sym_operator_assignment] = STATE(3939),
    [sym_conditional] = STATE(3939),
    [sym_range] = STATE(3939),
    [sym_binary] = STATE(3939),
    [sym_unary] = STATE(3939),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1700] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1701] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6405),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1702] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(6403),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [1703] = {
    [sym_heredoc_body] = STATE(3951),
    [aux_sym_call_repeat1] = STATE(3951),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1704] = {
    [sym_heredoc_body] = STATE(3951),
    [aux_sym_call_repeat1] = STATE(3951),
    [aux_sym_argument_list_repeat1] = STATE(3953),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1705] = {
    [anon_sym_EQ] = ACTIONS(6435),
    [sym_comment] = ACTIONS(87),
  },
  [1706] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6437),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6439),
    [anon_sym_DASH_EQ] = ACTIONS(6439),
    [anon_sym_STAR_EQ] = ACTIONS(6439),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6439),
    [anon_sym_SLASH_EQ] = ACTIONS(6439),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6439),
    [anon_sym_PIPE_EQ] = ACTIONS(6439),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6439),
    [anon_sym_AMP_EQ] = ACTIONS(6439),
    [anon_sym_PERCENT_EQ] = ACTIONS(6439),
    [anon_sym_GT_GT_EQ] = ACTIONS(6439),
    [anon_sym_LT_LT_EQ] = ACTIONS(6439),
    [anon_sym_CARET_EQ] = ACTIONS(6439),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1707] = {
    [sym_string] = STATE(3956),
    [aux_sym_chained_string_repeat1] = STATE(3956),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6441),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1708] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [1709] = {
    [aux_sym_undef_repeat1] = STATE(3957),
    [sym__line_break] = ACTIONS(2257),
    [sym__heredoc_body_start] = ACTIONS(2257),
    [anon_sym_RBRACE] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [1710] = {
    [sym__line_break] = ACTIONS(6443),
    [sym__heredoc_body_start] = ACTIONS(6443),
    [ts_builtin_sym_end] = ACTIONS(6443),
    [anon_sym___END__] = ACTIONS(6443),
    [anon_sym_RBRACE] = ACTIONS(6443),
    [anon_sym_RPAREN] = ACTIONS(6443),
    [anon_sym_SEMI] = ACTIONS(6443),
    [anon_sym_end] = ACTIONS(6443),
    [anon_sym_rescue] = ACTIONS(6443),
    [anon_sym_when] = ACTIONS(6443),
    [anon_sym_elsif] = ACTIONS(6443),
    [anon_sym_else] = ACTIONS(6443),
    [anon_sym_ensure] = ACTIONS(6443),
    [sym_comment] = ACTIONS(87),
  },
  [1711] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2497),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1712] = {
    [sym_heredoc_body] = STATE(3958),
    [sym__terminator] = STATE(3958),
    [aux_sym__statements_repeat1] = STATE(3959),
    [sym__line_break] = ACTIONS(6445),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_RBRACE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(6445),
    [sym_comment] = ACTIONS(87),
  },
  [1713] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3960),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3960),
    [sym_operator_assignment] = STATE(3960),
    [sym_conditional] = STATE(3960),
    [sym_range] = STATE(3960),
    [sym_binary] = STATE(3960),
    [sym_unary] = STATE(3960),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1714] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3961),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3961),
    [sym_operator_assignment] = STATE(3961),
    [sym_conditional] = STATE(3961),
    [sym_range] = STATE(3961),
    [sym_binary] = STATE(3961),
    [sym_unary] = STATE(3961),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1715] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3962),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3962),
    [sym_operator_assignment] = STATE(3962),
    [sym_conditional] = STATE(3962),
    [sym_range] = STATE(3962),
    [sym_binary] = STATE(3962),
    [sym_unary] = STATE(3962),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1716] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3963),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3963),
    [sym_operator_assignment] = STATE(3963),
    [sym_conditional] = STATE(3963),
    [sym_range] = STATE(3963),
    [sym_binary] = STATE(3963),
    [sym_unary] = STATE(3963),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1717] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3964),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3964),
    [sym_operator_assignment] = STATE(3964),
    [sym_conditional] = STATE(3964),
    [sym_range] = STATE(3964),
    [sym_binary] = STATE(3964),
    [sym_unary] = STATE(3964),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1718] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3965),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3965),
    [sym_operator_assignment] = STATE(3965),
    [sym_conditional] = STATE(3965),
    [sym_range] = STATE(3965),
    [sym_binary] = STATE(3965),
    [sym_unary] = STATE(3965),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1719] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3966),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3966),
    [sym_operator_assignment] = STATE(3966),
    [sym_conditional] = STATE(3966),
    [sym_range] = STATE(3966),
    [sym_binary] = STATE(3966),
    [sym_unary] = STATE(3966),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1720] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3967),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3967),
    [sym_operator_assignment] = STATE(3967),
    [sym_conditional] = STATE(3967),
    [sym_range] = STATE(3967),
    [sym_binary] = STATE(3967),
    [sym_unary] = STATE(3967),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1721] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3968),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3968),
    [sym_operator_assignment] = STATE(3968),
    [sym_conditional] = STATE(3968),
    [sym_range] = STATE(3968),
    [sym_binary] = STATE(3968),
    [sym_unary] = STATE(3968),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1722] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3969),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3969),
    [sym_operator_assignment] = STATE(3969),
    [sym_conditional] = STATE(3969),
    [sym_range] = STATE(3969),
    [sym_binary] = STATE(3969),
    [sym_unary] = STATE(3969),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1723] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3970),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(3970),
    [sym_operator_assignment] = STATE(3970),
    [sym_conditional] = STATE(3970),
    [sym_range] = STATE(3970),
    [sym_binary] = STATE(3970),
    [sym_unary] = STATE(3970),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1724] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3971),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3971),
    [sym_operator_assignment] = STATE(3971),
    [sym_conditional] = STATE(3971),
    [sym_range] = STATE(3971),
    [sym_binary] = STATE(3971),
    [sym_unary] = STATE(3971),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1725] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3972),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3972),
    [sym_operator_assignment] = STATE(3972),
    [sym_conditional] = STATE(3972),
    [sym_range] = STATE(3972),
    [sym_binary] = STATE(3972),
    [sym_unary] = STATE(3972),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1726] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3973),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3973),
    [sym_operator_assignment] = STATE(3973),
    [sym_conditional] = STATE(3973),
    [sym_range] = STATE(3973),
    [sym_binary] = STATE(3973),
    [sym_unary] = STATE(3973),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1727] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3974),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(3974),
    [sym_operator_assignment] = STATE(3974),
    [sym_conditional] = STATE(3974),
    [sym_range] = STATE(3974),
    [sym_binary] = STATE(3974),
    [sym_unary] = STATE(3974),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1728] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3982),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(3982),
    [sym_operator_assignment] = STATE(3982),
    [sym_conditional] = STATE(3982),
    [sym_range] = STATE(3982),
    [sym_binary] = STATE(3982),
    [sym_unary] = STATE(3982),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1729] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3987),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(3987),
    [sym_operator_assignment] = STATE(3987),
    [sym_conditional] = STATE(3987),
    [sym_range] = STATE(3987),
    [sym_binary] = STATE(3987),
    [sym_unary] = STATE(3987),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1730] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3988),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(3988),
    [sym_operator_assignment] = STATE(3988),
    [sym_conditional] = STATE(3988),
    [sym_range] = STATE(3988),
    [sym_binary] = STATE(3988),
    [sym_unary] = STATE(3988),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1731] = {
    [anon_sym_COLON] = ACTIONS(6471),
    [sym_comment] = ACTIONS(87),
  },
  [1732] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3991),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(3991),
    [sym_operator_assignment] = STATE(3991),
    [sym_conditional] = STATE(3991),
    [sym_range] = STATE(3991),
    [sym_binary] = STATE(3991),
    [sym_unary] = STATE(3991),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [1733] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3664),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(3665),
    [sym__argument] = STATE(3666),
    [sym_splat_argument] = STATE(3666),
    [sym_hash_splat_argument] = STATE(3666),
    [sym_block_argument] = STATE(3666),
    [sym_assignment] = STATE(3664),
    [sym_operator_assignment] = STATE(3664),
    [sym_conditional] = STATE(3664),
    [sym_range] = STATE(3664),
    [sym_binary] = STATE(3664),
    [sym_unary] = STATE(3664),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3667),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3666),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5966),
    [sym__splat_star] = ACTIONS(5968),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5970),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(5972),
    [sym_identifier] = ACTIONS(5972),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1734] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3664),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(3665),
    [sym__argument] = STATE(3666),
    [sym_splat_argument] = STATE(3666),
    [sym_hash_splat_argument] = STATE(3666),
    [sym_block_argument] = STATE(3666),
    [sym_assignment] = STATE(3664),
    [sym_operator_assignment] = STATE(3664),
    [sym_conditional] = STATE(3664),
    [sym_range] = STATE(3664),
    [sym_binary] = STATE(3664),
    [sym_unary] = STATE(3664),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3667),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3666),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5966),
    [sym__splat_star] = ACTIONS(5968),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5970),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(5972),
    [sym_identifier] = ACTIONS(5972),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1735] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3664),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(3665),
    [sym__argument] = STATE(3666),
    [sym_splat_argument] = STATE(3666),
    [sym_hash_splat_argument] = STATE(3666),
    [sym_block_argument] = STATE(3666),
    [sym_assignment] = STATE(3664),
    [sym_operator_assignment] = STATE(3664),
    [sym_conditional] = STATE(3664),
    [sym_range] = STATE(3664),
    [sym_binary] = STATE(3664),
    [sym_unary] = STATE(3664),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3667),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3666),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5966),
    [sym__splat_star] = ACTIONS(5968),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5970),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(5972),
    [sym_identifier] = ACTIONS(5972),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1736] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3664),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(3665),
    [sym__argument] = STATE(3666),
    [sym_splat_argument] = STATE(3666),
    [sym_hash_splat_argument] = STATE(3666),
    [sym_block_argument] = STATE(3666),
    [sym_assignment] = STATE(3664),
    [sym_operator_assignment] = STATE(3664),
    [sym_conditional] = STATE(3664),
    [sym_range] = STATE(3664),
    [sym_binary] = STATE(3664),
    [sym_unary] = STATE(3664),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3667),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3666),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5966),
    [sym__splat_star] = ACTIONS(5968),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5970),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(5972),
    [sym_identifier] = ACTIONS(5972),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1737] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3992),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(3992),
    [sym_operator_assignment] = STATE(3992),
    [sym_conditional] = STATE(3992),
    [sym_range] = STATE(3992),
    [sym_binary] = STATE(3992),
    [sym_unary] = STATE(3992),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1738] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1739] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6473),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1740] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(6471),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [1741] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3664),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(3665),
    [sym__argument] = STATE(3666),
    [sym_splat_argument] = STATE(3666),
    [sym_hash_splat_argument] = STATE(3666),
    [sym_block_argument] = STATE(3666),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3664),
    [sym_operator_assignment] = STATE(3664),
    [sym_conditional] = STATE(3664),
    [sym_range] = STATE(3664),
    [sym_binary] = STATE(3664),
    [sym_unary] = STATE(3664),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3667),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3666),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5966),
    [sym__splat_star] = ACTIONS(5968),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5970),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(5972),
    [sym_identifier] = ACTIONS(5972),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [1742] = {
    [sym_heredoc_body] = STATE(4004),
    [aux_sym_call_repeat1] = STATE(4004),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1743] = {
    [sym_heredoc_body] = STATE(4004),
    [aux_sym_call_repeat1] = STATE(4004),
    [aux_sym_argument_list_repeat1] = STATE(4006),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(6503),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1744] = {
    [anon_sym_EQ] = ACTIONS(6505),
    [sym_comment] = ACTIONS(87),
  },
  [1745] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6507),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6509),
    [anon_sym_DASH_EQ] = ACTIONS(6509),
    [anon_sym_STAR_EQ] = ACTIONS(6509),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6509),
    [anon_sym_SLASH_EQ] = ACTIONS(6509),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6509),
    [anon_sym_PIPE_EQ] = ACTIONS(6509),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6509),
    [anon_sym_AMP_EQ] = ACTIONS(6509),
    [anon_sym_PERCENT_EQ] = ACTIONS(6509),
    [anon_sym_GT_GT_EQ] = ACTIONS(6509),
    [anon_sym_LT_LT_EQ] = ACTIONS(6509),
    [anon_sym_CARET_EQ] = ACTIONS(6509),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1746] = {
    [sym_string] = STATE(4009),
    [aux_sym_chained_string_repeat1] = STATE(4009),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6511),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1747] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4014),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_splat_argument] = STATE(4015),
    [sym_assignment] = STATE(4014),
    [sym_operator_assignment] = STATE(4014),
    [sym_conditional] = STATE(4014),
    [sym_range] = STATE(4014),
    [sym_binary] = STATE(4014),
    [sym_unary] = STATE(4014),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(4015),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(6513),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1748] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4018),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(4018),
    [sym_operator_assignment] = STATE(4018),
    [sym_conditional] = STATE(4018),
    [sym_range] = STATE(4018),
    [sym_binary] = STATE(4018),
    [sym_unary] = STATE(4018),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1749] = {
    [sym_string] = STATE(4019),
    [aux_sym_chained_string_repeat1] = STATE(4019),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [1750] = {
    [sym__string_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_STAR_STAR] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_unless] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_until] = ACTIONS(2895),
    [anon_sym_rescue] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_EQ_GT] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_LT_LT] = ACTIONS(2895),
    [anon_sym_GT_GT] = ACTIONS(2895),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(87),
  },
  [1751] = {
    [sym__binary_minus] = ACTIONS(2907),
    [sym__binary_star] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_STAR_STAR] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_unless] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_until] = ACTIONS(2907),
    [anon_sym_rescue] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_EQ_GT] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_COLON_COLON2] = ACTIONS(2907),
    [anon_sym_AMP_DOT] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_COLON2] = ACTIONS(2909),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_and] = ACTIONS(2907),
    [anon_sym_or] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2907),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_CARET] = ACTIONS(2907),
    [anon_sym_PLUS] = ACTIONS(2907),
    [anon_sym_SLASH] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2907),
    [sym_comment] = ACTIONS(87),
  },
  [1752] = {
    [sym__binary_minus] = ACTIONS(2911),
    [sym__binary_star] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_RPAREN] = ACTIONS(2911),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_STAR_STAR] = ACTIONS(2911),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_unless] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_until] = ACTIONS(2911),
    [anon_sym_rescue] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_EQ_GT] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_COLON_COLON2] = ACTIONS(2911),
    [anon_sym_AMP_DOT] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_COLON2] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE] = ACTIONS(2911),
    [anon_sym_AMP_AMP] = ACTIONS(2911),
    [anon_sym_LT_LT] = ACTIONS(2911),
    [anon_sym_GT_GT] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_CARET] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_SLASH] = ACTIONS(2911),
    [anon_sym_PERCENT] = ACTIONS(2911),
    [sym_comment] = ACTIONS(87),
  },
  [1753] = {
    [sym__binary_minus] = ACTIONS(2915),
    [sym__binary_star] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_STAR_STAR] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_unless] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_until] = ACTIONS(2915),
    [anon_sym_rescue] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_EQ_GT] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_COLON_COLON2] = ACTIONS(2915),
    [anon_sym_AMP_DOT] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_COLON2] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_AMP_AMP] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2915),
    [anon_sym_EQ_TILDE] = ACTIONS(2915),
    [anon_sym_BANG_TILDE] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [sym_comment] = ACTIONS(87),
  },
  [1754] = {
    [sym__binary_minus] = ACTIONS(2921),
    [sym__binary_star] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_STAR_STAR] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_unless] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_until] = ACTIONS(2921),
    [anon_sym_rescue] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_COLON_COLON2] = ACTIONS(2921),
    [anon_sym_AMP_DOT] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_COLON2] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_and] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [sym_comment] = ACTIONS(87),
  },
  [1755] = {
    [sym__string_end] = ACTIONS(6525),
    [sym_comment] = ACTIONS(87),
  },
  [1756] = {
    [aux_sym_string_array_repeat1] = STATE(4023),
    [sym__string_end] = ACTIONS(6527),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6529),
  },
  [1757] = {
    [sym__binary_minus] = ACTIONS(2931),
    [sym__binary_star] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_STAR_STAR] = ACTIONS(2931),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_unless] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_until] = ACTIONS(2931),
    [anon_sym_rescue] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_EQ_GT] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_COLON_COLON2] = ACTIONS(2931),
    [anon_sym_AMP_DOT] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2931),
    [anon_sym_COLON2] = ACTIONS(2933),
    [anon_sym_DOT_DOT] = ACTIONS(2933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2931),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2931),
    [anon_sym_LT_LT] = ACTIONS(2931),
    [anon_sym_GT_GT] = ACTIONS(2931),
    [anon_sym_EQ_EQ] = ACTIONS(2933),
    [anon_sym_BANG_EQ] = ACTIONS(2931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2931),
    [anon_sym_EQ_TILDE] = ACTIONS(2931),
    [anon_sym_BANG_TILDE] = ACTIONS(2931),
    [anon_sym_LT_EQ] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_GT_EQ] = ACTIONS(2931),
    [anon_sym_CARET] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2931),
    [anon_sym_PERCENT] = ACTIONS(2931),
    [sym_comment] = ACTIONS(87),
  },
  [1758] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6531),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1759] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(6531),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6533),
  },
  [1760] = {
    [sym__binary_minus] = ACTIONS(2950),
    [sym__binary_star] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_STAR_STAR] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_unless] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_until] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_EQ_GT] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_COLON_COLON2] = ACTIONS(2950),
    [anon_sym_AMP_DOT] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON2] = ACTIONS(2952),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_LT_LT] = ACTIONS(2950),
    [anon_sym_GT_GT] = ACTIONS(2950),
    [anon_sym_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ_GT] = ACTIONS(2950),
    [anon_sym_EQ_TILDE] = ACTIONS(2950),
    [anon_sym_BANG_TILDE] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [sym_comment] = ACTIONS(87),
  },
  [1761] = {
    [sym__string_end] = ACTIONS(6535),
    [sym_comment] = ACTIONS(87),
  },
  [1762] = {
    [aux_sym_symbol_array_repeat1] = STATE(4029),
    [sym__string_end] = ACTIONS(6537),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6539),
  },
  [1763] = {
    [sym__binary_minus] = ACTIONS(2960),
    [sym__binary_star] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_RPAREN] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_STAR_STAR] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_unless] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_until] = ACTIONS(2960),
    [anon_sym_rescue] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_EQ_GT] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_COLON_COLON2] = ACTIONS(2960),
    [anon_sym_AMP_DOT] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2960),
    [anon_sym_COLON2] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_LT_LT] = ACTIONS(2960),
    [anon_sym_GT_GT] = ACTIONS(2960),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2960),
    [anon_sym_LT_EQ_GT] = ACTIONS(2960),
    [anon_sym_EQ_TILDE] = ACTIONS(2960),
    [anon_sym_BANG_TILDE] = ACTIONS(2960),
    [anon_sym_LT_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_SLASH] = ACTIONS(2960),
    [anon_sym_PERCENT] = ACTIONS(2960),
    [sym_comment] = ACTIONS(87),
  },
  [1764] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6541),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1765] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(6541),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6543),
  },
  [1766] = {
    [anon_sym_RBRACE] = ACTIONS(6545),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2811),
    [anon_sym_until] = ACTIONS(2813),
    [anon_sym_rescue] = ACTIONS(2815),
    [sym_comment] = ACTIONS(87),
  },
  [1767] = {
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym_when] = ACTIONS(6547),
    [anon_sym_RBRACK] = ACTIONS(6547),
    [sym_comment] = ACTIONS(87),
  },
  [1768] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(6549),
    [sym_heredoc_end] = ACTIONS(6552),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6554),
    [sym_escape_sequence] = ACTIONS(6549),
  },
  [1769] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_DOT_DOT] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(3166),
    [anon_sym_or] = ACTIONS(3166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [1770] = {
    [sym__binary_minus] = ACTIONS(3440),
    [sym__binary_star] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3440),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3440),
    [anon_sym_while] = ACTIONS(3440),
    [anon_sym_until] = ACTIONS(3440),
    [anon_sym_rescue] = ACTIONS(3440),
    [anon_sym_do] = ACTIONS(3440),
    [anon_sym_EQ_GT] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3440),
    [anon_sym_COLON_COLON2] = ACTIONS(3440),
    [anon_sym_AMP_DOT] = ACTIONS(3440),
    [anon_sym_QMARK] = ACTIONS(3440),
    [anon_sym_COLON2] = ACTIONS(3442),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3440),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_GT_GT] = ACTIONS(3440),
    [anon_sym_EQ_EQ] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3440),
    [anon_sym_BANG_TILDE] = ACTIONS(3440),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3440),
    [anon_sym_CARET] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [sym_comment] = ACTIONS(87),
  },
  [1771] = {
    [anon_sym_RBRACE] = ACTIONS(6559),
    [sym_comment] = ACTIONS(87),
  },
  [1772] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(6561),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [1773] = {
    [sym__method_rest] = STATE(4035),
    [sym_operator] = STATE(521),
    [sym__method_name] = STATE(521),
    [sym_setter] = STATE(521),
    [sym_symbol] = STATE(521),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(6563),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(6563),
    [sym_class_variable] = ACTIONS(6563),
    [sym_global_variable] = ACTIONS(6563),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1774] = {
    [sym__statements] = STATE(578),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(579),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(580),
    [sym_rescue] = STATE(581),
    [sym__body_statement] = STATE(4036),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6565),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1775] = {
    [sym__binary_minus] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_LBRACE] = ACTIONS(3670),
    [anon_sym_RBRACE] = ACTIONS(3670),
    [anon_sym_RPAREN] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_SEMI] = ACTIONS(3670),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3672),
    [anon_sym_if] = ACTIONS(3670),
    [anon_sym_unless] = ACTIONS(3670),
    [anon_sym_while] = ACTIONS(3670),
    [anon_sym_until] = ACTIONS(3670),
    [anon_sym_rescue] = ACTIONS(3670),
    [anon_sym_do] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3670),
    [anon_sym_COLON_COLON2] = ACTIONS(3670),
    [anon_sym_AMP_DOT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_COLON2] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3670),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LT_EQ_GT] = ACTIONS(3670),
    [anon_sym_EQ_TILDE] = ACTIONS(3670),
    [anon_sym_BANG_TILDE] = ACTIONS(3670),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym_comment] = ACTIONS(87),
  },
  [1776] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1777] = {
    [sym__simple_symbol] = ACTIONS(1413),
    [sym__string_start] = ACTIONS(1413),
    [sym__symbol_start] = ACTIONS(1413),
    [sym__subshell_start] = ACTIONS(1413),
    [sym__regex_start] = ACTIONS(1413),
    [sym__string_array_start] = ACTIONS(1413),
    [sym__symbol_array_start] = ACTIONS(1413),
    [sym__heredoc_body_start] = ACTIONS(1413),
    [sym_heredoc_beginning] = ACTIONS(1413),
    [sym__block_ampersand] = ACTIONS(1413),
    [sym__splat_star] = ACTIONS(1413),
    [sym__unary_minus] = ACTIONS(1413),
    [sym__binary_minus] = ACTIONS(1413),
    [sym__binary_star] = ACTIONS(1413),
    [sym__identifier_hash_key] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_def] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1415),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_EQ] = ACTIONS(1415),
    [anon_sym_class] = ACTIONS(1415),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_module] = ACTIONS(1415),
    [anon_sym_return] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1415),
    [anon_sym_break] = ACTIONS(1415),
    [anon_sym_next] = ACTIONS(1415),
    [sym_redo] = ACTIONS(1415),
    [sym_retry] = ACTIONS(1415),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_unless] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1415),
    [anon_sym_until] = ACTIONS(1415),
    [anon_sym_rescue] = ACTIONS(1415),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_in] = ACTIONS(1415),
    [anon_sym_do] = ACTIONS(1415),
    [anon_sym_case] = ACTIONS(1415),
    [anon_sym_begin] = ACTIONS(1415),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_RBRACK] = ACTIONS(1413),
    [anon_sym_COLON_COLON2] = ACTIONS(1413),
    [anon_sym_AMP_DOT] = ACTIONS(1413),
    [anon_sym_LPAREN2] = ACTIONS(1413),
    [anon_sym_PLUS_EQ] = ACTIONS(1413),
    [anon_sym_DASH_EQ] = ACTIONS(1413),
    [anon_sym_STAR_EQ] = ACTIONS(1413),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1413),
    [anon_sym_SLASH_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1413),
    [anon_sym_AMP_EQ] = ACTIONS(1413),
    [anon_sym_PERCENT_EQ] = ACTIONS(1413),
    [anon_sym_GT_GT_EQ] = ACTIONS(1413),
    [anon_sym_LT_LT_EQ] = ACTIONS(1413),
    [anon_sym_CARET_EQ] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(1415),
    [anon_sym_COLON2] = ACTIONS(1415),
    [anon_sym_DOT_DOT] = ACTIONS(1415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1413),
    [anon_sym_and] = ACTIONS(1415),
    [anon_sym_or] = ACTIONS(1415),
    [anon_sym_PIPE_PIPE] = ACTIONS(1415),
    [anon_sym_AMP_AMP] = ACTIONS(1415),
    [anon_sym_LT_LT] = ACTIONS(1415),
    [anon_sym_GT_GT] = ACTIONS(1415),
    [anon_sym_EQ_EQ] = ACTIONS(1415),
    [anon_sym_BANG_EQ] = ACTIONS(1413),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1413),
    [anon_sym_LT_EQ_GT] = ACTIONS(1413),
    [anon_sym_EQ_TILDE] = ACTIONS(1413),
    [anon_sym_BANG_TILDE] = ACTIONS(1413),
    [anon_sym_LT_EQ] = ACTIONS(1415),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_CARET] = ACTIONS(1415),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_SLASH] = ACTIONS(1415),
    [anon_sym_PERCENT] = ACTIONS(1415),
    [anon_sym_defined_QMARK] = ACTIONS(1413),
    [anon_sym_not] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_TILDE] = ACTIONS(1413),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1415),
    [sym_float] = ACTIONS(1415),
    [sym_complex] = ACTIONS(1413),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1415),
    [anon_sym_TRUE] = ACTIONS(1415),
    [anon_sym_false] = ACTIONS(1415),
    [anon_sym_FALSE] = ACTIONS(1415),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(1415),
    [anon_sym_NIL] = ACTIONS(1415),
    [sym_character] = ACTIONS(1413),
    [anon_sym_LBRACK2] = ACTIONS(1415),
    [anon_sym_DASH_GT] = ACTIONS(1413),
  },
  [1778] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4040),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(4040),
    [sym_operator_assignment] = STATE(4040),
    [sym_conditional] = STATE(4040),
    [sym_range] = STATE(4040),
    [sym_binary] = STATE(4040),
    [sym_unary] = STATE(4040),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1779] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4043),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(4043),
    [sym_operator_assignment] = STATE(4043),
    [sym_conditional] = STATE(4043),
    [sym_range] = STATE(4043),
    [sym_binary] = STATE(4043),
    [sym_unary] = STATE(4043),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1780] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4044),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(4044),
    [sym_operator_assignment] = STATE(4044),
    [sym_conditional] = STATE(4044),
    [sym_range] = STATE(4044),
    [sym_binary] = STATE(4044),
    [sym_unary] = STATE(4044),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1781] = {
    [anon_sym_COLON] = ACTIONS(6579),
    [sym_comment] = ACTIONS(87),
  },
  [1782] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4047),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(4047),
    [sym_operator_assignment] = STATE(4047),
    [sym_conditional] = STATE(4047),
    [sym_range] = STATE(4047),
    [sym_binary] = STATE(4047),
    [sym_unary] = STATE(4047),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1783] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4053),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(4054),
    [sym__argument] = STATE(4055),
    [sym_splat_argument] = STATE(4055),
    [sym_hash_splat_argument] = STATE(4055),
    [sym_block_argument] = STATE(4055),
    [sym_assignment] = STATE(4053),
    [sym_operator_assignment] = STATE(4053),
    [sym_conditional] = STATE(4053),
    [sym_range] = STATE(4053),
    [sym_binary] = STATE(4053),
    [sym_unary] = STATE(4053),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4056),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4055),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6581),
    [sym__splat_star] = ACTIONS(6583),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(6585),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(6587),
    [sym_identifier] = ACTIONS(6587),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1784] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4053),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(4054),
    [sym__argument] = STATE(4055),
    [sym_splat_argument] = STATE(4055),
    [sym_hash_splat_argument] = STATE(4055),
    [sym_block_argument] = STATE(4055),
    [sym_assignment] = STATE(4053),
    [sym_operator_assignment] = STATE(4053),
    [sym_conditional] = STATE(4053),
    [sym_range] = STATE(4053),
    [sym_binary] = STATE(4053),
    [sym_unary] = STATE(4053),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4056),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4055),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6581),
    [sym__splat_star] = ACTIONS(6583),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(6585),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(6587),
    [sym_identifier] = ACTIONS(6587),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1785] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4053),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(4054),
    [sym__argument] = STATE(4055),
    [sym_splat_argument] = STATE(4055),
    [sym_hash_splat_argument] = STATE(4055),
    [sym_block_argument] = STATE(4055),
    [sym_assignment] = STATE(4053),
    [sym_operator_assignment] = STATE(4053),
    [sym_conditional] = STATE(4053),
    [sym_range] = STATE(4053),
    [sym_binary] = STATE(4053),
    [sym_unary] = STATE(4053),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4056),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4055),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6581),
    [sym__splat_star] = ACTIONS(6583),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(6585),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(6587),
    [sym_identifier] = ACTIONS(6587),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1786] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4053),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(4054),
    [sym__argument] = STATE(4055),
    [sym_splat_argument] = STATE(4055),
    [sym_hash_splat_argument] = STATE(4055),
    [sym_block_argument] = STATE(4055),
    [sym_assignment] = STATE(4053),
    [sym_operator_assignment] = STATE(4053),
    [sym_conditional] = STATE(4053),
    [sym_range] = STATE(4053),
    [sym_binary] = STATE(4053),
    [sym_unary] = STATE(4053),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4056),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4055),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6581),
    [sym__splat_star] = ACTIONS(6583),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(6585),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3138),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(6587),
    [sym_identifier] = ACTIONS(6587),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1787] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4057),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(4057),
    [sym_operator_assignment] = STATE(4057),
    [sym_conditional] = STATE(4057),
    [sym_range] = STATE(4057),
    [sym_binary] = STATE(4057),
    [sym_unary] = STATE(4057),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1788] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1789] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6589),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1790] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(6579),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [1791] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4074),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(4075),
    [sym__argument] = STATE(4076),
    [sym_splat_argument] = STATE(4076),
    [sym_hash_splat_argument] = STATE(4076),
    [sym_block_argument] = STATE(4076),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(4074),
    [sym_operator_assignment] = STATE(4074),
    [sym_conditional] = STATE(4074),
    [sym_range] = STATE(4074),
    [sym_binary] = STATE(4074),
    [sym_unary] = STATE(4074),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4077),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4076),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6617),
    [sym__splat_star] = ACTIONS(6619),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(2409),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(6623),
    [sym_identifier] = ACTIONS(6623),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1792] = {
    [sym_heredoc_body] = STATE(4078),
    [aux_sym_call_repeat1] = STATE(4078),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1793] = {
    [sym_heredoc_body] = STATE(4078),
    [aux_sym_call_repeat1] = STATE(4078),
    [aux_sym_argument_list_repeat1] = STATE(4080),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(6625),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1794] = {
    [anon_sym_EQ] = ACTIONS(6627),
    [sym_comment] = ACTIONS(87),
  },
  [1795] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6629),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6631),
    [anon_sym_DASH_EQ] = ACTIONS(6631),
    [anon_sym_STAR_EQ] = ACTIONS(6631),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6631),
    [anon_sym_SLASH_EQ] = ACTIONS(6631),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6631),
    [anon_sym_PIPE_EQ] = ACTIONS(6631),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6631),
    [anon_sym_AMP_EQ] = ACTIONS(6631),
    [anon_sym_PERCENT_EQ] = ACTIONS(6631),
    [anon_sym_GT_GT_EQ] = ACTIONS(6631),
    [anon_sym_LT_LT_EQ] = ACTIONS(6631),
    [anon_sym_CARET_EQ] = ACTIONS(6631),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1796] = {
    [sym_string] = STATE(4083),
    [aux_sym_chained_string_repeat1] = STATE(4083),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6633),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1797] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_DOT_DOT] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [1798] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4084),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(4084),
    [sym_operator_assignment] = STATE(4084),
    [sym_conditional] = STATE(4084),
    [sym_range] = STATE(4084),
    [sym_binary] = STATE(4084),
    [sym_unary] = STATE(4084),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1799] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4085),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(4085),
    [sym_operator_assignment] = STATE(4085),
    [sym_conditional] = STATE(4085),
    [sym_range] = STATE(4085),
    [sym_binary] = STATE(4085),
    [sym_unary] = STATE(4085),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1800] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4086),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(4086),
    [sym_operator_assignment] = STATE(4086),
    [sym_conditional] = STATE(4086),
    [sym_range] = STATE(4086),
    [sym_binary] = STATE(4086),
    [sym_unary] = STATE(4086),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1801] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4087),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(4087),
    [sym_operator_assignment] = STATE(4087),
    [sym_conditional] = STATE(4087),
    [sym_range] = STATE(4087),
    [sym_binary] = STATE(4087),
    [sym_unary] = STATE(4087),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1802] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4088),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(4088),
    [sym_operator_assignment] = STATE(4088),
    [sym_conditional] = STATE(4088),
    [sym_range] = STATE(4088),
    [sym_binary] = STATE(4088),
    [sym_unary] = STATE(4088),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1803] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4089),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4089),
    [sym_operator_assignment] = STATE(4089),
    [sym_conditional] = STATE(4089),
    [sym_range] = STATE(4089),
    [sym_binary] = STATE(4089),
    [sym_unary] = STATE(4089),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1804] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4090),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(4090),
    [sym_operator_assignment] = STATE(4090),
    [sym_conditional] = STATE(4090),
    [sym_range] = STATE(4090),
    [sym_binary] = STATE(4090),
    [sym_unary] = STATE(4090),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1805] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4091),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(4091),
    [sym_operator_assignment] = STATE(4091),
    [sym_conditional] = STATE(4091),
    [sym_range] = STATE(4091),
    [sym_binary] = STATE(4091),
    [sym_unary] = STATE(4091),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1806] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4092),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(4092),
    [sym_operator_assignment] = STATE(4092),
    [sym_conditional] = STATE(4092),
    [sym_range] = STATE(4092),
    [sym_binary] = STATE(4092),
    [sym_unary] = STATE(4092),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1807] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4093),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(4093),
    [sym_operator_assignment] = STATE(4093),
    [sym_conditional] = STATE(4093),
    [sym_range] = STATE(4093),
    [sym_binary] = STATE(4093),
    [sym_unary] = STATE(4093),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1808] = {
    [sym_argument_list_with_parens] = STATE(4096),
    [sym__argument_list_with_parens] = STATE(4097),
    [sym_operator] = STATE(4096),
    [sym_heredoc_body] = STATE(4098),
    [aux_sym_call_repeat1] = STATE(4098),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(6635),
    [anon_sym_STAR] = ACTIONS(6637),
    [anon_sym_STAR_STAR] = ACTIONS(6635),
    [anon_sym_AMP] = ACTIONS(6635),
    [anon_sym_LT] = ACTIONS(6637),
    [anon_sym_LPAREN2] = ACTIONS(6639),
    [anon_sym_DOT_DOT] = ACTIONS(6635),
    [anon_sym_LT_LT] = ACTIONS(6635),
    [anon_sym_GT_GT] = ACTIONS(6635),
    [anon_sym_EQ_EQ] = ACTIONS(6637),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6635),
    [anon_sym_LT_EQ_GT] = ACTIONS(6635),
    [anon_sym_EQ_TILDE] = ACTIONS(6635),
    [anon_sym_BANG_TILDE] = ACTIONS(6635),
    [anon_sym_LT_EQ] = ACTIONS(6637),
    [anon_sym_GT] = ACTIONS(6637),
    [anon_sym_GT_EQ] = ACTIONS(6635),
    [anon_sym_CARET] = ACTIONS(6635),
    [anon_sym_PLUS] = ACTIONS(6637),
    [anon_sym_SLASH] = ACTIONS(6635),
    [anon_sym_PERCENT] = ACTIONS(6635),
    [anon_sym_BANG] = ACTIONS(6637),
    [anon_sym_TILDE] = ACTIONS(6635),
    [sym_constant] = ACTIONS(6641),
    [sym_identifier] = ACTIONS(6641),
    [anon_sym_DASH] = ACTIONS(6637),
    [anon_sym_PLUS_AT] = ACTIONS(6635),
    [anon_sym_DASH_AT] = ACTIONS(6635),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6637),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6635),
    [anon_sym_BQUOTE] = ACTIONS(6635),
    [sym_comment] = ACTIONS(87),
  },
  [1809] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(4100),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4101),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(6643),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1810] = {
    [sym_constant] = ACTIONS(6645),
    [sym_identifier] = ACTIONS(6645),
    [sym_comment] = ACTIONS(87),
  },
  [1811] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(4110),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(4110),
    [sym_operator_assignment] = STATE(4110),
    [sym_conditional] = STATE(4110),
    [sym_range] = STATE(4110),
    [sym_binary] = STATE(4110),
    [sym_unary] = STATE(4110),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [1812] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(4115),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(4115),
    [sym_operator_assignment] = STATE(4115),
    [sym_conditional] = STATE(4115),
    [sym_range] = STATE(4115),
    [sym_binary] = STATE(4115),
    [sym_unary] = STATE(4115),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [1813] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4116),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(4116),
    [sym_operator_assignment] = STATE(4116),
    [sym_conditional] = STATE(4116),
    [sym_range] = STATE(4116),
    [sym_binary] = STATE(4116),
    [sym_unary] = STATE(4116),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1814] = {
    [anon_sym_COLON] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [1815] = {
    [sym__statements] = STATE(4120),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(4121),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1939),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1940),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6673),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1816] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(4122),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(4122),
    [sym_operator_assignment] = STATE(4122),
    [sym_conditional] = STATE(4122),
    [sym_range] = STATE(4122),
    [sym_binary] = STATE(4122),
    [sym_unary] = STATE(4122),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [1817] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4074),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(1953),
    [sym__argument_list_with_parens] = STATE(4075),
    [sym__argument] = STATE(4076),
    [sym_splat_argument] = STATE(4076),
    [sym_hash_splat_argument] = STATE(4076),
    [sym_block_argument] = STATE(4076),
    [sym_assignment] = STATE(4074),
    [sym_operator_assignment] = STATE(4074),
    [sym_conditional] = STATE(4074),
    [sym_range] = STATE(4074),
    [sym_binary] = STATE(4074),
    [sym_unary] = STATE(4074),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4077),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4076),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6617),
    [sym__splat_star] = ACTIONS(6619),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(6623),
    [sym_identifier] = ACTIONS(6623),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1818] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4074),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(1954),
    [sym__argument_list_with_parens] = STATE(4075),
    [sym__argument] = STATE(4076),
    [sym_splat_argument] = STATE(4076),
    [sym_hash_splat_argument] = STATE(4076),
    [sym_block_argument] = STATE(4076),
    [sym_assignment] = STATE(4074),
    [sym_operator_assignment] = STATE(4074),
    [sym_conditional] = STATE(4074),
    [sym_range] = STATE(4074),
    [sym_binary] = STATE(4074),
    [sym_unary] = STATE(4074),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4077),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4076),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6617),
    [sym__splat_star] = ACTIONS(6619),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(6623),
    [sym_identifier] = ACTIONS(6623),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1819] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4074),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(1955),
    [sym__argument_list_with_parens] = STATE(4075),
    [sym__argument] = STATE(4076),
    [sym_splat_argument] = STATE(4076),
    [sym_hash_splat_argument] = STATE(4076),
    [sym_block_argument] = STATE(4076),
    [sym_assignment] = STATE(4074),
    [sym_operator_assignment] = STATE(4074),
    [sym_conditional] = STATE(4074),
    [sym_range] = STATE(4074),
    [sym_binary] = STATE(4074),
    [sym_unary] = STATE(4074),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4077),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4076),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6617),
    [sym__splat_star] = ACTIONS(6619),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(6623),
    [sym_identifier] = ACTIONS(6623),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1820] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4074),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(1956),
    [sym__argument_list_with_parens] = STATE(4075),
    [sym__argument] = STATE(4076),
    [sym_splat_argument] = STATE(4076),
    [sym_hash_splat_argument] = STATE(4076),
    [sym_block_argument] = STATE(4076),
    [sym_assignment] = STATE(4074),
    [sym_operator_assignment] = STATE(4074),
    [sym_conditional] = STATE(4074),
    [sym_range] = STATE(4074),
    [sym_binary] = STATE(4074),
    [sym_unary] = STATE(4074),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4077),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4076),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6617),
    [sym__splat_star] = ACTIONS(6619),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(6623),
    [sym_identifier] = ACTIONS(6623),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1821] = {
    [sym__statements] = STATE(4124),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(4125),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(4126),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(4126),
    [sym__line_break] = ACTIONS(6675),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6677),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1822] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4127),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(4127),
    [sym_operator_assignment] = STATE(4127),
    [sym_conditional] = STATE(4127),
    [sym_range] = STATE(4127),
    [sym_binary] = STATE(4127),
    [sym_unary] = STATE(4127),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1823] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1978),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(1978),
    [sym_operator_assignment] = STATE(1978),
    [sym_conditional] = STATE(1978),
    [sym_range] = STATE(1978),
    [sym_binary] = STATE(1978),
    [sym_unary] = STATE(1978),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1824] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6679),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1825] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(6671),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [1826] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4074),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(4075),
    [sym__argument] = STATE(4076),
    [sym_splat_argument] = STATE(4076),
    [sym_hash_splat_argument] = STATE(4076),
    [sym_block_argument] = STATE(4076),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(4074),
    [sym_operator_assignment] = STATE(4074),
    [sym_conditional] = STATE(4074),
    [sym_range] = STATE(4074),
    [sym_binary] = STATE(4074),
    [sym_unary] = STATE(4074),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4077),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4076),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6617),
    [sym__splat_star] = ACTIONS(6619),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(6623),
    [sym_identifier] = ACTIONS(6623),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1827] = {
    [sym_do_block] = STATE(4140),
    [sym_block] = STATE(4140),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(6709),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(6711),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_RBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_COLON2] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [1828] = {
    [sym_heredoc_body] = STATE(4141),
    [aux_sym_call_repeat1] = STATE(4141),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1829] = {
    [sym_heredoc_body] = STATE(4141),
    [aux_sym_call_repeat1] = STATE(4141),
    [aux_sym_argument_list_repeat1] = STATE(4143),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(6713),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [1830] = {
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_in] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_RBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_COLON2] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [1831] = {
    [anon_sym_EQ] = ACTIONS(6715),
    [sym_comment] = ACTIONS(87),
  },
  [1832] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6717),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6719),
    [anon_sym_DASH_EQ] = ACTIONS(6719),
    [anon_sym_STAR_EQ] = ACTIONS(6719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6719),
    [anon_sym_SLASH_EQ] = ACTIONS(6719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6719),
    [anon_sym_PIPE_EQ] = ACTIONS(6719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6719),
    [anon_sym_AMP_EQ] = ACTIONS(6719),
    [anon_sym_PERCENT_EQ] = ACTIONS(6719),
    [anon_sym_GT_GT_EQ] = ACTIONS(6719),
    [anon_sym_LT_LT_EQ] = ACTIONS(6719),
    [anon_sym_CARET_EQ] = ACTIONS(6719),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1833] = {
    [sym_string] = STATE(4146),
    [aux_sym_chained_string_repeat1] = STATE(4146),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6721),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1834] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4148),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_splat_argument] = STATE(4149),
    [sym_assignment] = STATE(4148),
    [sym_operator_assignment] = STATE(4148),
    [sym_conditional] = STATE(4148),
    [sym_range] = STATE(4148),
    [sym_binary] = STATE(4148),
    [sym_unary] = STATE(4148),
    [sym_right_assignment_list] = STATE(3442),
    [sym__arg_or_splat_arg] = STATE(4149),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(6723),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1835] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4150),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(4150),
    [sym_operator_assignment] = STATE(4150),
    [sym_conditional] = STATE(4150),
    [sym_range] = STATE(4150),
    [sym_binary] = STATE(4150),
    [sym_unary] = STATE(4150),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1836] = {
    [sym_string] = STATE(4151),
    [aux_sym_chained_string_repeat1] = STATE(4151),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [1837] = {
    [sym_heredoc_body] = STATE(4152),
    [sym__terminator] = STATE(4152),
    [sym__line_break] = ACTIONS(6725),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(6725),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [1838] = {
    [sym_heredoc_body] = STATE(4153),
    [sym__terminator] = STATE(4153),
    [sym__line_break] = ACTIONS(6727),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(6727),
    [sym_comment] = ACTIONS(87),
  },
  [1839] = {
    [sym__statements] = STATE(578),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(579),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(580),
    [sym_rescue] = STATE(581),
    [sym__body_statement] = STATE(4154),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6729),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1840] = {
    [sym__binary_minus] = ACTIONS(4068),
    [sym__binary_star] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_STAR_STAR] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_unless] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_until] = ACTIONS(4068),
    [anon_sym_rescue] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON_COLON2] = ACTIONS(4068),
    [anon_sym_AMP_DOT] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4068),
    [anon_sym_COLON2] = ACTIONS(4070),
    [anon_sym_DOT_DOT] = ACTIONS(4070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(4068),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ_GT] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_BANG_TILDE] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4068),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [sym_comment] = ACTIONS(87),
  },
  [1841] = {
    [sym__statements] = STATE(578),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(579),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(580),
    [sym_rescue] = STATE(581),
    [sym__body_statement] = STATE(4155),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6731),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1842] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [1843] = {
    [sym_string] = STATE(1872),
    [aux_sym_chained_string_repeat1] = STATE(1872),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1844] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [1845] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1846] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4156),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4156),
    [sym_operator_assignment] = STATE(4156),
    [sym_conditional] = STATE(4156),
    [sym_range] = STATE(4156),
    [sym_binary] = STATE(4156),
    [sym_unary] = STATE(4156),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1847] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [1848] = {
    [sym_heredoc_body] = STATE(4157),
    [aux_sym_call_repeat1] = STATE(4157),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1849] = {
    [sym_heredoc_body] = STATE(4157),
    [aux_sym_call_repeat1] = STATE(4157),
    [aux_sym_argument_list_repeat1] = STATE(4158),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [1850] = {
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR_STAR] = ACTIONS(4148),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4148),
    [anon_sym_unless] = ACTIONS(4148),
    [anon_sym_while] = ACTIONS(4148),
    [anon_sym_until] = ACTIONS(4148),
    [anon_sym_rescue] = ACTIONS(4148),
    [anon_sym_in] = ACTIONS(4148),
    [anon_sym_do] = ACTIONS(4148),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_COLON2] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4148),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
  },
  [1851] = {
    [sym_heredoc_body] = STATE(4160),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
  },
  [1852] = {
    [anon_sym_RPAREN] = ACTIONS(6733),
    [sym_comment] = ACTIONS(87),
  },
  [1853] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [1854] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [1855] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4161),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4161),
    [sym_operator_assignment] = STATE(4161),
    [sym_conditional] = STATE(4161),
    [sym_range] = STATE(4161),
    [sym_binary] = STATE(4161),
    [sym_unary] = STATE(4161),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1856] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4162),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4162),
    [sym_operator_assignment] = STATE(4162),
    [sym_conditional] = STATE(4162),
    [sym_range] = STATE(4162),
    [sym_binary] = STATE(4162),
    [sym_unary] = STATE(4162),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1857] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4163),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4163),
    [sym_operator_assignment] = STATE(4163),
    [sym_conditional] = STATE(4163),
    [sym_range] = STATE(4163),
    [sym_binary] = STATE(4163),
    [sym_unary] = STATE(4163),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1858] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4164),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4164),
    [sym_operator_assignment] = STATE(4164),
    [sym_conditional] = STATE(4164),
    [sym_range] = STATE(4164),
    [sym_binary] = STATE(4164),
    [sym_unary] = STATE(4164),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1859] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4165),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4165),
    [sym_operator_assignment] = STATE(4165),
    [sym_conditional] = STATE(4165),
    [sym_range] = STATE(4165),
    [sym_binary] = STATE(4165),
    [sym_unary] = STATE(4165),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1860] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4166),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4166),
    [sym_operator_assignment] = STATE(4166),
    [sym_conditional] = STATE(4166),
    [sym_range] = STATE(4166),
    [sym_binary] = STATE(4166),
    [sym_unary] = STATE(4166),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1861] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4167),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4167),
    [sym_operator_assignment] = STATE(4167),
    [sym_conditional] = STATE(4167),
    [sym_range] = STATE(4167),
    [sym_binary] = STATE(4167),
    [sym_unary] = STATE(4167),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1862] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4168),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4168),
    [sym_operator_assignment] = STATE(4168),
    [sym_conditional] = STATE(4168),
    [sym_range] = STATE(4168),
    [sym_binary] = STATE(4168),
    [sym_unary] = STATE(4168),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1863] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4169),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4169),
    [sym_operator_assignment] = STATE(4169),
    [sym_conditional] = STATE(4169),
    [sym_range] = STATE(4169),
    [sym_binary] = STATE(4169),
    [sym_unary] = STATE(4169),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1864] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4170),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4170),
    [sym_operator_assignment] = STATE(4170),
    [sym_conditional] = STATE(4170),
    [sym_range] = STATE(4170),
    [sym_binary] = STATE(4170),
    [sym_unary] = STATE(4170),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1865] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4171),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4171),
    [sym_operator_assignment] = STATE(4171),
    [sym_conditional] = STATE(4171),
    [sym_range] = STATE(4171),
    [sym_binary] = STATE(4171),
    [sym_unary] = STATE(4171),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1866] = {
    [sym_interpolation] = STATE(4173),
    [aux_sym_heredoc_body_repeat1] = STATE(4173),
    [sym__heredoc_content] = ACTIONS(6735),
    [sym_heredoc_end] = ACTIONS(6737),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(6735),
  },
  [1867] = {
    [sym_heredoc_body] = STATE(4174),
    [aux_sym_call_repeat1] = STATE(4174),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [1868] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4176),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1869] = {
    [sym_heredoc_body] = STATE(4177),
    [aux_sym_call_repeat1] = STATE(4177),
    [aux_sym_argument_list_repeat1] = STATE(4178),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [1870] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4179),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_splat_argument] = STATE(4181),
    [sym_assignment] = STATE(4179),
    [sym_operator_assignment] = STATE(4179),
    [sym_conditional] = STATE(4179),
    [sym_range] = STATE(4179),
    [sym_binary] = STATE(4179),
    [sym_unary] = STATE(4179),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(4181),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1871] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4182),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(4182),
    [sym_operator_assignment] = STATE(4182),
    [sym_conditional] = STATE(4182),
    [sym_range] = STATE(4182),
    [sym_binary] = STATE(4182),
    [sym_unary] = STATE(4182),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1872] = {
    [sym_string] = STATE(4183),
    [aux_sym_chained_string_repeat1] = STATE(4183),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [1873] = {
    [sym__statements] = STATE(4185),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(4186),
    [sym_else] = STATE(4186),
    [sym__if_tail] = STATE(4186),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(4187),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__terminator] = STATE(4187),
    [sym__line_break] = ACTIONS(6741),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6743),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1874] = {
    [sym__statements] = STATE(4189),
    [sym__top_level_statement] = STATE(2704),
    [sym_begin_block] = STATE(2704),
    [sym_end_block] = STATE(2704),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(4190),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6745),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1875] = {
    [sym__statements] = STATE(4192),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6747),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1876] = {
    [sym__statements] = STATE(4194),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1877] = {
    [sym__do] = STATE(4195),
    [sym_heredoc_body] = STATE(4195),
    [sym__terminator] = STATE(4195),
    [sym__line_break] = ACTIONS(6751),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(6751),
    [anon_sym_do] = ACTIONS(6751),
    [sym_comment] = ACTIONS(87),
  },
  [1878] = {
    [sym_when] = STATE(4196),
    [aux_sym_case_repeat1] = STATE(4197),
    [anon_sym_SEMI] = ACTIONS(6753),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1879] = {
    [anon_sym_end] = ACTIONS(6755),
    [sym_comment] = ACTIONS(87),
  },
  [1880] = {
    [sym_when] = STATE(4196),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1881] = {
    [sym__binary_minus] = ACTIONS(5264),
    [sym__binary_star] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5264),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_RPAREN] = ACTIONS(5264),
    [anon_sym_DOT] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5264),
    [anon_sym_PIPE] = ACTIONS(5266),
    [anon_sym_SEMI] = ACTIONS(5264),
    [anon_sym_STAR_STAR] = ACTIONS(5264),
    [anon_sym_AMP] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5266),
    [anon_sym_if] = ACTIONS(5264),
    [anon_sym_unless] = ACTIONS(5264),
    [anon_sym_while] = ACTIONS(5264),
    [anon_sym_until] = ACTIONS(5264),
    [anon_sym_rescue] = ACTIONS(5264),
    [anon_sym_do] = ACTIONS(5264),
    [anon_sym_EQ_GT] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5264),
    [anon_sym_COLON_COLON2] = ACTIONS(5264),
    [anon_sym_AMP_DOT] = ACTIONS(5264),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_COLON2] = ACTIONS(5266),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5264),
    [anon_sym_and] = ACTIONS(5264),
    [anon_sym_or] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE] = ACTIONS(5264),
    [anon_sym_AMP_AMP] = ACTIONS(5264),
    [anon_sym_LT_LT] = ACTIONS(5264),
    [anon_sym_GT_GT] = ACTIONS(5264),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5264),
    [anon_sym_LT_EQ_GT] = ACTIONS(5264),
    [anon_sym_EQ_TILDE] = ACTIONS(5264),
    [anon_sym_BANG_TILDE] = ACTIONS(5264),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_GT] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5264),
    [anon_sym_CARET] = ACTIONS(5264),
    [anon_sym_PLUS] = ACTIONS(5264),
    [anon_sym_SLASH] = ACTIONS(5264),
    [anon_sym_PERCENT] = ACTIONS(5264),
    [sym_comment] = ACTIONS(87),
  },
  [1882] = {
    [sym_ensure] = STATE(4200),
    [anon_sym_end] = ACTIONS(6757),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1883] = {
    [anon_sym_end] = ACTIONS(6757),
    [sym_comment] = ACTIONS(87),
  },
  [1884] = {
    [sym_else] = STATE(4201),
    [sym_ensure] = STATE(4200),
    [anon_sym_end] = ACTIONS(6757),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1885] = {
    [sym__binary_minus] = ACTIONS(5350),
    [sym__binary_star] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_RPAREN] = ACTIONS(5350),
    [anon_sym_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5350),
    [anon_sym_PIPE] = ACTIONS(5352),
    [anon_sym_SEMI] = ACTIONS(5350),
    [anon_sym_STAR_STAR] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5352),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_unless] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_until] = ACTIONS(5350),
    [anon_sym_rescue] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_EQ_GT] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_COLON_COLON2] = ACTIONS(5350),
    [anon_sym_AMP_DOT] = ACTIONS(5350),
    [anon_sym_QMARK] = ACTIONS(5350),
    [anon_sym_COLON2] = ACTIONS(5352),
    [anon_sym_DOT_DOT] = ACTIONS(5352),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5350),
    [anon_sym_AMP_AMP] = ACTIONS(5350),
    [anon_sym_LT_LT] = ACTIONS(5350),
    [anon_sym_GT_GT] = ACTIONS(5350),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5350),
    [anon_sym_LT_EQ_GT] = ACTIONS(5350),
    [anon_sym_EQ_TILDE] = ACTIONS(5350),
    [anon_sym_BANG_TILDE] = ACTIONS(5350),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5350),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_SLASH] = ACTIONS(5350),
    [anon_sym_PERCENT] = ACTIONS(5350),
    [sym_comment] = ACTIONS(87),
  },
  [1886] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_DOT_DOT] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(3166),
    [anon_sym_or] = ACTIONS(3166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [1887] = {
    [sym__binary_minus] = ACTIONS(5582),
    [sym__binary_star] = ACTIONS(5582),
    [anon_sym_LBRACE] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_STAR_STAR] = ACTIONS(5582),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_if] = ACTIONS(5582),
    [anon_sym_unless] = ACTIONS(5582),
    [anon_sym_while] = ACTIONS(5582),
    [anon_sym_until] = ACTIONS(5582),
    [anon_sym_rescue] = ACTIONS(5582),
    [anon_sym_do] = ACTIONS(5582),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON_COLON2] = ACTIONS(5582),
    [anon_sym_AMP_DOT] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5582),
    [anon_sym_COLON2] = ACTIONS(5584),
    [anon_sym_DOT_DOT] = ACTIONS(5584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5584),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ_GT] = ACTIONS(5582),
    [anon_sym_EQ_TILDE] = ACTIONS(5582),
    [anon_sym_BANG_TILDE] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5582),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [sym_comment] = ACTIONS(87),
  },
  [1888] = {
    [anon_sym_RBRACK] = ACTIONS(6761),
    [sym_comment] = ACTIONS(87),
  },
  [1889] = {
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5594),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_COLON2] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5594),
    [anon_sym_AMP_AMP] = ACTIONS(5594),
    [anon_sym_LT_LT] = ACTIONS(5594),
    [anon_sym_GT_GT] = ACTIONS(5594),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5594),
    [anon_sym_PLUS] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5594),
    [anon_sym_PERCENT] = ACTIONS(5594),
    [sym_comment] = ACTIONS(87),
  },
  [1890] = {
    [anon_sym_RBRACE] = ACTIONS(6763),
    [sym_comment] = ACTIONS(87),
  },
  [1891] = {
    [sym__statements] = STATE(4204),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6763),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1892] = {
    [sym__binary_minus] = ACTIONS(5630),
    [sym__binary_star] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5630),
    [anon_sym_RPAREN] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_STAR_STAR] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5632),
    [anon_sym_if] = ACTIONS(5630),
    [anon_sym_unless] = ACTIONS(5630),
    [anon_sym_while] = ACTIONS(5630),
    [anon_sym_until] = ACTIONS(5630),
    [anon_sym_rescue] = ACTIONS(5630),
    [anon_sym_do] = ACTIONS(5630),
    [anon_sym_EQ_GT] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_COLON2] = ACTIONS(5632),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5630),
    [anon_sym_AMP_AMP] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5630),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5630),
    [anon_sym_EQ_TILDE] = ACTIONS(5630),
    [anon_sym_BANG_TILDE] = ACTIONS(5630),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5630),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5630),
    [sym_comment] = ACTIONS(87),
  },
  [1893] = {
    [anon_sym_end] = ACTIONS(6765),
    [sym_comment] = ACTIONS(87),
  },
  [1894] = {
    [sym__statements] = STATE(4206),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(4207),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(4207),
    [sym__line_break] = ACTIONS(6767),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6769),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1895] = {
    [sym__statements] = STATE(4206),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(4208),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6769),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1896] = {
    [sym__binary_minus] = ACTIONS(5666),
    [sym__binary_star] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_STAR_STAR] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_if] = ACTIONS(5666),
    [anon_sym_unless] = ACTIONS(5666),
    [anon_sym_while] = ACTIONS(5666),
    [anon_sym_until] = ACTIONS(5666),
    [anon_sym_rescue] = ACTIONS(5666),
    [anon_sym_do] = ACTIONS(5666),
    [anon_sym_EQ_GT] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_COLON_COLON2] = ACTIONS(5666),
    [anon_sym_AMP_DOT] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_COLON2] = ACTIONS(5668),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_and] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5666),
    [anon_sym_LT_LT] = ACTIONS(5666),
    [anon_sym_GT_GT] = ACTIONS(5666),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_EQ_TILDE] = ACTIONS(5666),
    [anon_sym_BANG_TILDE] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_CARET] = ACTIONS(5666),
    [anon_sym_PLUS] = ACTIONS(5666),
    [anon_sym_SLASH] = ACTIONS(5666),
    [anon_sym_PERCENT] = ACTIONS(5666),
    [sym_comment] = ACTIONS(87),
  },
  [1897] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1898] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [1899] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1900] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1901] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1902] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(6771),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [1903] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1904] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1905] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1906] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [1907] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_EQ_GT] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [1908] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(4211),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4212),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(6773),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1909] = {
    [sym__simple_symbol] = ACTIONS(5806),
    [sym__string_start] = ACTIONS(5806),
    [sym__symbol_start] = ACTIONS(5806),
    [sym__subshell_start] = ACTIONS(5806),
    [sym__regex_start] = ACTIONS(5806),
    [sym__string_array_start] = ACTIONS(5806),
    [sym__symbol_array_start] = ACTIONS(5806),
    [sym_heredoc_beginning] = ACTIONS(5806),
    [sym__block_ampersand] = ACTIONS(5806),
    [sym__splat_star] = ACTIONS(5806),
    [sym__unary_minus] = ACTIONS(5806),
    [sym__binary_minus] = ACTIONS(5806),
    [sym__binary_star] = ACTIONS(5806),
    [sym__identifier_hash_key] = ACTIONS(5806),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_def] = ACTIONS(5808),
    [anon_sym_LPAREN] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_COLON_COLON] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5808),
    [anon_sym_AMP] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_class] = ACTIONS(5808),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_module] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_yield] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_next] = ACTIONS(5808),
    [sym_redo] = ACTIONS(5808),
    [sym_retry] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_unless] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_until] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_begin] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_COLON_COLON2] = ACTIONS(5806),
    [anon_sym_AMP_DOT] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_PLUS_EQ] = ACTIONS(5806),
    [anon_sym_DASH_EQ] = ACTIONS(5806),
    [anon_sym_STAR_EQ] = ACTIONS(5806),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5806),
    [anon_sym_AMP_EQ] = ACTIONS(5806),
    [anon_sym_PERCENT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_LT_LT_EQ] = ACTIONS(5806),
    [anon_sym_CARET_EQ] = ACTIONS(5806),
    [anon_sym_QMARK] = ACTIONS(5808),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_and] = ACTIONS(5808),
    [anon_sym_or] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_AMP_AMP] = ACTIONS(5808),
    [anon_sym_LT_LT] = ACTIONS(5808),
    [anon_sym_GT_GT] = ACTIONS(5808),
    [anon_sym_EQ_EQ] = ACTIONS(5808),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5806),
    [anon_sym_BANG_TILDE] = ACTIONS(5806),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_SLASH] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5808),
    [anon_sym_defined_QMARK] = ACTIONS(5806),
    [anon_sym_not] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_TILDE] = ACTIONS(5806),
    [sym_constant] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_instance_variable] = ACTIONS(5806),
    [sym_class_variable] = ACTIONS(5806),
    [sym_global_variable] = ACTIONS(5806),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5808),
    [sym_float] = ACTIONS(5808),
    [sym_complex] = ACTIONS(5806),
    [sym_super] = ACTIONS(5808),
    [anon_sym_true] = ACTIONS(5808),
    [anon_sym_TRUE] = ACTIONS(5808),
    [anon_sym_false] = ACTIONS(5808),
    [anon_sym_FALSE] = ACTIONS(5808),
    [sym_self] = ACTIONS(5808),
    [anon_sym_nil] = ACTIONS(5808),
    [anon_sym_NIL] = ACTIONS(5808),
    [sym_character] = ACTIONS(5806),
    [anon_sym_LBRACK2] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5806),
  },
  [1910] = {
    [sym__simple_symbol] = ACTIONS(5810),
    [sym__string_start] = ACTIONS(5810),
    [sym__symbol_start] = ACTIONS(5810),
    [sym__subshell_start] = ACTIONS(5810),
    [sym__regex_start] = ACTIONS(5810),
    [sym__string_array_start] = ACTIONS(5810),
    [sym__symbol_array_start] = ACTIONS(5810),
    [sym_heredoc_beginning] = ACTIONS(5810),
    [sym__block_ampersand] = ACTIONS(5810),
    [sym__splat_star] = ACTIONS(5810),
    [sym__unary_minus] = ACTIONS(5810),
    [sym__binary_minus] = ACTIONS(5810),
    [sym__binary_star] = ACTIONS(5810),
    [sym__identifier_hash_key] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_def] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_COLON_COLON] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_PIPE] = ACTIONS(5812),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_STAR_STAR] = ACTIONS(5812),
    [anon_sym_AMP] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_class] = ACTIONS(5812),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_module] = ACTIONS(5812),
    [anon_sym_return] = ACTIONS(5812),
    [anon_sym_yield] = ACTIONS(5812),
    [anon_sym_break] = ACTIONS(5812),
    [anon_sym_next] = ACTIONS(5812),
    [sym_redo] = ACTIONS(5812),
    [sym_retry] = ACTIONS(5812),
    [anon_sym_if] = ACTIONS(5812),
    [anon_sym_unless] = ACTIONS(5812),
    [anon_sym_while] = ACTIONS(5812),
    [anon_sym_until] = ACTIONS(5812),
    [anon_sym_for] = ACTIONS(5812),
    [anon_sym_do] = ACTIONS(5812),
    [anon_sym_case] = ACTIONS(5812),
    [anon_sym_begin] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_COLON_COLON2] = ACTIONS(5810),
    [anon_sym_AMP_DOT] = ACTIONS(5810),
    [anon_sym_LPAREN2] = ACTIONS(5810),
    [anon_sym_PLUS_EQ] = ACTIONS(5810),
    [anon_sym_DASH_EQ] = ACTIONS(5810),
    [anon_sym_STAR_EQ] = ACTIONS(5810),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5810),
    [anon_sym_AMP_EQ] = ACTIONS(5810),
    [anon_sym_PERCENT_EQ] = ACTIONS(5810),
    [anon_sym_GT_GT_EQ] = ACTIONS(5810),
    [anon_sym_LT_LT_EQ] = ACTIONS(5810),
    [anon_sym_CARET_EQ] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5812),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(5812),
    [anon_sym_or] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_GT_GT] = ACTIONS(5812),
    [anon_sym_EQ_EQ] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5810),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_EQ_TILDE] = ACTIONS(5810),
    [anon_sym_BANG_TILDE] = ACTIONS(5810),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_GT] = ACTIONS(5812),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5812),
    [anon_sym_PLUS] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5812),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_defined_QMARK] = ACTIONS(5810),
    [anon_sym_not] = ACTIONS(5812),
    [anon_sym_BANG] = ACTIONS(5812),
    [anon_sym_TILDE] = ACTIONS(5810),
    [sym_constant] = ACTIONS(5812),
    [sym_identifier] = ACTIONS(5812),
    [sym_instance_variable] = ACTIONS(5810),
    [sym_class_variable] = ACTIONS(5810),
    [sym_global_variable] = ACTIONS(5810),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5812),
    [sym_float] = ACTIONS(5812),
    [sym_complex] = ACTIONS(5810),
    [sym_super] = ACTIONS(5812),
    [anon_sym_true] = ACTIONS(5812),
    [anon_sym_TRUE] = ACTIONS(5812),
    [anon_sym_false] = ACTIONS(5812),
    [anon_sym_FALSE] = ACTIONS(5812),
    [sym_self] = ACTIONS(5812),
    [anon_sym_nil] = ACTIONS(5812),
    [anon_sym_NIL] = ACTIONS(5812),
    [sym_character] = ACTIONS(5810),
    [anon_sym_LBRACK2] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5810),
  },
  [1911] = {
    [sym_argument_list_with_parens] = STATE(4213),
    [sym__argument_list_with_parens] = STATE(1910),
    [sym_operator] = STATE(4213),
    [sym_heredoc_body] = STATE(3546),
    [aux_sym_call_repeat1] = STATE(3546),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_STAR_STAR] = ACTIONS(3302),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_LPAREN2] = ACTIONS(3306),
    [anon_sym_DOT_DOT] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_GT_GT] = ACTIONS(3302),
    [anon_sym_EQ_EQ] = ACTIONS(3304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3302),
    [anon_sym_LT_EQ_GT] = ACTIONS(3302),
    [anon_sym_EQ_TILDE] = ACTIONS(3302),
    [anon_sym_BANG_TILDE] = ACTIONS(3302),
    [anon_sym_LT_EQ] = ACTIONS(3304),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_GT_EQ] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_TILDE] = ACTIONS(3302),
    [sym_constant] = ACTIONS(6775),
    [sym_identifier] = ACTIONS(6775),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_PLUS_AT] = ACTIONS(3302),
    [anon_sym_DASH_AT] = ACTIONS(3302),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3304),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3302),
    [anon_sym_BQUOTE] = ACTIONS(3302),
    [sym_comment] = ACTIONS(87),
  },
  [1912] = {
    [sym__binary_minus] = ACTIONS(5816),
    [sym__binary_star] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5816),
    [anon_sym_PIPE] = ACTIONS(5818),
    [anon_sym_STAR_STAR] = ACTIONS(5818),
    [anon_sym_AMP] = ACTIONS(5818),
    [anon_sym_EQ] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5818),
    [anon_sym_EQ_GT] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_COLON_COLON2] = ACTIONS(5816),
    [anon_sym_AMP_DOT] = ACTIONS(5816),
    [anon_sym_PLUS_EQ] = ACTIONS(5816),
    [anon_sym_DASH_EQ] = ACTIONS(5816),
    [anon_sym_STAR_EQ] = ACTIONS(5816),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5816),
    [anon_sym_SLASH_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5816),
    [anon_sym_AMP_EQ] = ACTIONS(5816),
    [anon_sym_PERCENT_EQ] = ACTIONS(5816),
    [anon_sym_GT_GT_EQ] = ACTIONS(5816),
    [anon_sym_LT_LT_EQ] = ACTIONS(5816),
    [anon_sym_CARET_EQ] = ACTIONS(5816),
    [anon_sym_QMARK] = ACTIONS(5816),
    [anon_sym_DOT_DOT] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5816),
    [anon_sym_and] = ACTIONS(5816),
    [anon_sym_or] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_AMP_AMP] = ACTIONS(5818),
    [anon_sym_LT_LT] = ACTIONS(5818),
    [anon_sym_GT_GT] = ACTIONS(5818),
    [anon_sym_EQ_EQ] = ACTIONS(5818),
    [anon_sym_BANG_EQ] = ACTIONS(5816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5816),
    [anon_sym_LT_EQ_GT] = ACTIONS(5816),
    [anon_sym_EQ_TILDE] = ACTIONS(5816),
    [anon_sym_BANG_TILDE] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5818),
    [anon_sym_GT] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5816),
    [anon_sym_CARET] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5818),
    [anon_sym_SLASH] = ACTIONS(5818),
    [anon_sym_PERCENT] = ACTIONS(5818),
    [sym_comment] = ACTIONS(87),
  },
  [1913] = {
    [sym_heredoc_body] = STATE(4215),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(6777),
    [sym_comment] = ACTIONS(87),
  },
  [1914] = {
    [anon_sym_RBRACK] = ACTIONS(6777),
    [sym_comment] = ACTIONS(87),
  },
  [1915] = {
    [sym__simple_symbol] = ACTIONS(5822),
    [sym__string_start] = ACTIONS(5822),
    [sym__symbol_start] = ACTIONS(5822),
    [sym__subshell_start] = ACTIONS(5822),
    [sym__regex_start] = ACTIONS(5822),
    [sym__string_array_start] = ACTIONS(5822),
    [sym__symbol_array_start] = ACTIONS(5822),
    [sym_heredoc_beginning] = ACTIONS(5822),
    [sym__block_ampersand] = ACTIONS(5822),
    [sym__splat_star] = ACTIONS(5822),
    [sym__unary_minus] = ACTIONS(5822),
    [sym__binary_minus] = ACTIONS(5822),
    [sym__binary_star] = ACTIONS(5822),
    [sym__identifier_hash_key] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_def] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COLON_COLON] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_STAR_STAR] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_class] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_module] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(5824),
    [anon_sym_break] = ACTIONS(5824),
    [anon_sym_next] = ACTIONS(5824),
    [sym_redo] = ACTIONS(5824),
    [sym_retry] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5824),
    [anon_sym_unless] = ACTIONS(5824),
    [anon_sym_while] = ACTIONS(5824),
    [anon_sym_until] = ACTIONS(5824),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_do] = ACTIONS(5824),
    [anon_sym_case] = ACTIONS(5824),
    [anon_sym_begin] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_LPAREN2] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [anon_sym_DASH_EQ] = ACTIONS(5822),
    [anon_sym_STAR_EQ] = ACTIONS(5822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5822),
    [anon_sym_AMP_EQ] = ACTIONS(5822),
    [anon_sym_PERCENT_EQ] = ACTIONS(5822),
    [anon_sym_GT_GT_EQ] = ACTIONS(5822),
    [anon_sym_LT_LT_EQ] = ACTIONS(5822),
    [anon_sym_CARET_EQ] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5824),
    [anon_sym_or] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [anon_sym_defined_QMARK] = ACTIONS(5822),
    [anon_sym_not] = ACTIONS(5824),
    [anon_sym_BANG] = ACTIONS(5824),
    [anon_sym_TILDE] = ACTIONS(5822),
    [sym_constant] = ACTIONS(5824),
    [sym_identifier] = ACTIONS(5824),
    [sym_instance_variable] = ACTIONS(5822),
    [sym_class_variable] = ACTIONS(5822),
    [sym_global_variable] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5824),
    [sym_float] = ACTIONS(5824),
    [sym_complex] = ACTIONS(5822),
    [sym_super] = ACTIONS(5824),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_TRUE] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [anon_sym_FALSE] = ACTIONS(5824),
    [sym_self] = ACTIONS(5824),
    [anon_sym_nil] = ACTIONS(5824),
    [anon_sym_NIL] = ACTIONS(5824),
    [sym_character] = ACTIONS(5822),
    [anon_sym_LBRACK2] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5822),
  },
  [1916] = {
    [sym__string_start] = ACTIONS(837),
    [sym__heredoc_body_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_unless] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_until] = ACTIONS(837),
    [anon_sym_rescue] = ACTIONS(837),
    [anon_sym_in] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_EQ_GT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_COLON2] = ACTIONS(839),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [sym_comment] = ACTIONS(87),
  },
  [1917] = {
    [sym__string_end] = ACTIONS(6779),
    [sym_comment] = ACTIONS(87),
  },
  [1918] = {
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_in] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_RBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_PLUS_EQ] = ACTIONS(887),
    [anon_sym_DASH_EQ] = ACTIONS(887),
    [anon_sym_STAR_EQ] = ACTIONS(887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(887),
    [anon_sym_SLASH_EQ] = ACTIONS(887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(887),
    [anon_sym_PIPE_EQ] = ACTIONS(887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(887),
    [anon_sym_AMP_EQ] = ACTIONS(887),
    [anon_sym_PERCENT_EQ] = ACTIONS(887),
    [anon_sym_GT_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_LT_EQ] = ACTIONS(887),
    [anon_sym_CARET_EQ] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_COLON2] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(889),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [sym_comment] = ACTIONS(87),
  },
  [1919] = {
    [sym__string_end] = ACTIONS(6781),
    [sym_comment] = ACTIONS(87),
  },
  [1920] = {
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_EQ_GT] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [anon_sym_DASH_EQ] = ACTIONS(893),
    [anon_sym_STAR_EQ] = ACTIONS(893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(893),
    [anon_sym_SLASH_EQ] = ACTIONS(893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(893),
    [anon_sym_PIPE_EQ] = ACTIONS(893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(893),
    [anon_sym_AMP_EQ] = ACTIONS(893),
    [anon_sym_PERCENT_EQ] = ACTIONS(893),
    [anon_sym_GT_GT_EQ] = ACTIONS(893),
    [anon_sym_LT_LT_EQ] = ACTIONS(893),
    [anon_sym_CARET_EQ] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_COLON2] = ACTIONS(895),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(895),
    [anon_sym_PERCENT] = ACTIONS(895),
    [sym_comment] = ACTIONS(87),
  },
  [1921] = {
    [sym__string_end] = ACTIONS(6783),
    [sym_comment] = ACTIONS(87),
  },
  [1922] = {
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(901),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_in] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_EQ_GT] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_RBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_PLUS_EQ] = ACTIONS(899),
    [anon_sym_DASH_EQ] = ACTIONS(899),
    [anon_sym_STAR_EQ] = ACTIONS(899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(899),
    [anon_sym_SLASH_EQ] = ACTIONS(899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(899),
    [anon_sym_PIPE_EQ] = ACTIONS(899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(899),
    [anon_sym_AMP_EQ] = ACTIONS(899),
    [anon_sym_PERCENT_EQ] = ACTIONS(899),
    [anon_sym_GT_GT_EQ] = ACTIONS(899),
    [anon_sym_LT_LT_EQ] = ACTIONS(899),
    [anon_sym_CARET_EQ] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_COLON2] = ACTIONS(901),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [sym_comment] = ACTIONS(87),
  },
  [1923] = {
    [sym__string_end] = ACTIONS(6785),
    [sym_comment] = ACTIONS(87),
  },
  [1924] = {
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_in] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_EQ_GT] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_COLON2] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [sym_comment] = ACTIONS(87),
  },
  [1925] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(4222),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6787),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6789),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1926] = {
    [aux_sym_string_array_repeat1] = STATE(4225),
    [sym__string_end] = ACTIONS(6791),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6793),
  },
  [1927] = {
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_in] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_EQ_GT] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_COLON2] = ACTIONS(925),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [sym_comment] = ACTIONS(87),
  },
  [1928] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(4228),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(6795),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6797),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1929] = {
    [aux_sym_symbol_array_repeat1] = STATE(4231),
    [sym__string_end] = ACTIONS(6799),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6801),
  },
  [1930] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(1939),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(1940),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(6803),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1931] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [1932] = {
    [sym_string] = STATE(2007),
    [aux_sym_chained_string_repeat1] = STATE(2007),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1933] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [1934] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [1935] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4233),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4233),
    [sym_operator_assignment] = STATE(4233),
    [sym_conditional] = STATE(4233),
    [sym_range] = STATE(4233),
    [sym_binary] = STATE(4233),
    [sym_unary] = STATE(4233),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1936] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [1937] = {
    [anon_sym_RBRACE] = ACTIONS(6805),
    [sym_comment] = ACTIONS(87),
  },
  [1938] = {
    [sym__statements] = STATE(4235),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6805),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1939] = {
    [anon_sym_RBRACE] = ACTIONS(6807),
    [sym_comment] = ACTIONS(87),
  },
  [1940] = {
    [sym_heredoc_body] = STATE(4237),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(6807),
    [sym_comment] = ACTIONS(87),
  },
  [1941] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4238),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4238),
    [sym_operator_assignment] = STATE(4238),
    [sym_conditional] = STATE(4238),
    [sym_range] = STATE(4238),
    [sym_binary] = STATE(4238),
    [sym_unary] = STATE(4238),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1942] = {
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [sym_comment] = ACTIONS(87),
  },
  [1943] = {
    [anon_sym_DOT] = ACTIONS(6809),
    [anon_sym_COLON_COLON] = ACTIONS(6809),
    [sym_comment] = ACTIONS(87),
  },
  [1944] = {
    [sym_method_parameters] = STATE(4240),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(4240),
    [sym__terminator] = STATE(4240),
    [sym__line_break] = ACTIONS(6811),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(6811),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [1945] = {
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_RBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_PLUS_EQ] = ACTIONS(1291),
    [anon_sym_DASH_EQ] = ACTIONS(1291),
    [anon_sym_STAR_EQ] = ACTIONS(1291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1291),
    [anon_sym_SLASH_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1291),
    [anon_sym_AMP_EQ] = ACTIONS(1291),
    [anon_sym_PERCENT_EQ] = ACTIONS(1291),
    [anon_sym_GT_GT_EQ] = ACTIONS(1291),
    [anon_sym_LT_LT_EQ] = ACTIONS(1291),
    [anon_sym_CARET_EQ] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_COLON2] = ACTIONS(1293),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [sym_comment] = ACTIONS(87),
  },
  [1946] = {
    [anon_sym_RPAREN] = ACTIONS(6813),
    [sym_comment] = ACTIONS(87),
  },
  [1947] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [1948] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4242),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(4242),
    [sym_operator_assignment] = STATE(4242),
    [sym_conditional] = STATE(4242),
    [sym_range] = STATE(4242),
    [sym_binary] = STATE(4242),
    [sym_unary] = STATE(4242),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1949] = {
    [sym_superclass] = STATE(4243),
    [sym_heredoc_body] = STATE(4244),
    [sym__terminator] = STATE(4244),
    [sym__line_break] = ACTIONS(6815),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(6815),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1950] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_superclass] = STATE(4243),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4244),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(4244),
    [sym__line_break] = ACTIONS(6815),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(6815),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1951] = {
    [sym_heredoc_body] = STATE(4246),
    [sym__terminator] = STATE(4246),
    [sym__line_break] = ACTIONS(6817),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(6817),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(6819),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [1952] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4246),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(4246),
    [sym__line_break] = ACTIONS(6817),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(6817),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(6819),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1953] = {
    [sym__heredoc_body_start] = ACTIONS(1679),
    [sym__binary_minus] = ACTIONS(1679),
    [sym__binary_star] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_unless] = ACTIONS(1679),
    [anon_sym_while] = ACTIONS(1679),
    [anon_sym_until] = ACTIONS(1679),
    [anon_sym_rescue] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(1679),
    [anon_sym_do] = ACTIONS(1679),
    [anon_sym_EQ_GT] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_RBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1679),
    [anon_sym_AMP_DOT] = ACTIONS(1679),
    [anon_sym_PLUS_EQ] = ACTIONS(1679),
    [anon_sym_DASH_EQ] = ACTIONS(1679),
    [anon_sym_STAR_EQ] = ACTIONS(1679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1679),
    [anon_sym_SLASH_EQ] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1679),
    [anon_sym_PIPE_EQ] = ACTIONS(1679),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1679),
    [anon_sym_AMP_EQ] = ACTIONS(1679),
    [anon_sym_PERCENT_EQ] = ACTIONS(1679),
    [anon_sym_GT_GT_EQ] = ACTIONS(1679),
    [anon_sym_LT_LT_EQ] = ACTIONS(1679),
    [anon_sym_CARET_EQ] = ACTIONS(1679),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_COLON2] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1679),
    [anon_sym_and] = ACTIONS(1679),
    [anon_sym_or] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_BANG_EQ] = ACTIONS(1679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1679),
    [anon_sym_LT_EQ_GT] = ACTIONS(1679),
    [anon_sym_EQ_TILDE] = ACTIONS(1679),
    [anon_sym_BANG_TILDE] = ACTIONS(1679),
    [anon_sym_LT_EQ] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1679),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [1954] = {
    [sym__heredoc_body_start] = ACTIONS(1699),
    [sym__binary_minus] = ACTIONS(1699),
    [sym__binary_star] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_in] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_PLUS_EQ] = ACTIONS(1699),
    [anon_sym_DASH_EQ] = ACTIONS(1699),
    [anon_sym_STAR_EQ] = ACTIONS(1699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1699),
    [anon_sym_SLASH_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1699),
    [anon_sym_AMP_EQ] = ACTIONS(1699),
    [anon_sym_PERCENT_EQ] = ACTIONS(1699),
    [anon_sym_GT_GT_EQ] = ACTIONS(1699),
    [anon_sym_LT_LT_EQ] = ACTIONS(1699),
    [anon_sym_CARET_EQ] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_COLON2] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [1955] = {
    [sym__heredoc_body_start] = ACTIONS(1703),
    [sym__binary_minus] = ACTIONS(1703),
    [sym__binary_star] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1705),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1705),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_SLASH] = ACTIONS(1705),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(87),
  },
  [1956] = {
    [sym__heredoc_body_start] = ACTIONS(1707),
    [sym__binary_minus] = ACTIONS(1707),
    [sym__binary_star] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_DOT] = ACTIONS(1709),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_EQ] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_if] = ACTIONS(1707),
    [anon_sym_unless] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(1707),
    [anon_sym_until] = ACTIONS(1707),
    [anon_sym_rescue] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1707),
    [anon_sym_COLON_COLON2] = ACTIONS(1707),
    [anon_sym_AMP_DOT] = ACTIONS(1707),
    [anon_sym_PLUS_EQ] = ACTIONS(1707),
    [anon_sym_DASH_EQ] = ACTIONS(1707),
    [anon_sym_STAR_EQ] = ACTIONS(1707),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1707),
    [anon_sym_SLASH_EQ] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1707),
    [anon_sym_PIPE_EQ] = ACTIONS(1707),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1707),
    [anon_sym_AMP_EQ] = ACTIONS(1707),
    [anon_sym_PERCENT_EQ] = ACTIONS(1707),
    [anon_sym_GT_GT_EQ] = ACTIONS(1707),
    [anon_sym_LT_LT_EQ] = ACTIONS(1707),
    [anon_sym_CARET_EQ] = ACTIONS(1707),
    [anon_sym_QMARK] = ACTIONS(1707),
    [anon_sym_COLON2] = ACTIONS(1709),
    [anon_sym_DOT_DOT] = ACTIONS(1709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1707),
    [anon_sym_and] = ACTIONS(1707),
    [anon_sym_or] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(1709),
    [anon_sym_GT_GT] = ACTIONS(1709),
    [anon_sym_EQ_EQ] = ACTIONS(1709),
    [anon_sym_BANG_EQ] = ACTIONS(1707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1707),
    [anon_sym_LT_EQ_GT] = ACTIONS(1707),
    [anon_sym_EQ_TILDE] = ACTIONS(1707),
    [anon_sym_BANG_TILDE] = ACTIONS(1707),
    [anon_sym_LT_EQ] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_GT_EQ] = ACTIONS(1707),
    [anon_sym_CARET] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_SLASH] = ACTIONS(1709),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [sym_comment] = ACTIONS(87),
  },
  [1957] = {
    [sym__then] = STATE(4247),
    [sym_heredoc_body] = STATE(979),
    [sym__terminator] = STATE(979),
    [sym__line_break] = ACTIONS(1743),
    [sym__heredoc_body_start] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(6821),
    [sym_comment] = ACTIONS(87),
  },
  [1958] = {
    [sym__then] = STATE(4248),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(6823),
    [sym_comment] = ACTIONS(87),
  },
  [1959] = {
    [sym__do] = STATE(4249),
    [sym_heredoc_body] = STATE(4249),
    [sym__terminator] = STATE(4249),
    [sym__line_break] = ACTIONS(6825),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(6825),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(6825),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [1960] = {
    [sym__do] = STATE(4250),
    [sym_heredoc_body] = STATE(4250),
    [sym__terminator] = STATE(4250),
    [sym__line_break] = ACTIONS(6827),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(6827),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(6827),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [1961] = {
    [sym_in] = STATE(4251),
    [anon_sym_in] = ACTIONS(1969),
    [sym_comment] = ACTIONS(87),
  },
  [1962] = {
    [sym__binary_minus] = ACTIONS(5630),
    [sym__binary_star] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5632),
    [anon_sym_STAR_STAR] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5632),
    [anon_sym_EQ_GT] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [anon_sym_PLUS_EQ] = ACTIONS(5630),
    [anon_sym_DASH_EQ] = ACTIONS(5630),
    [anon_sym_STAR_EQ] = ACTIONS(5630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5630),
    [anon_sym_SLASH_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5630),
    [anon_sym_AMP_EQ] = ACTIONS(5630),
    [anon_sym_PERCENT_EQ] = ACTIONS(5630),
    [anon_sym_GT_GT_EQ] = ACTIONS(5630),
    [anon_sym_LT_LT_EQ] = ACTIONS(5630),
    [anon_sym_CARET_EQ] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5632),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5630),
    [anon_sym_EQ_TILDE] = ACTIONS(5630),
    [anon_sym_BANG_TILDE] = ACTIONS(5630),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5632),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [sym_comment] = ACTIONS(87),
  },
  [1963] = {
    [anon_sym_end] = ACTIONS(6829),
    [sym_comment] = ACTIONS(87),
  },
  [1964] = {
    [sym__statements] = STATE(4253),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(4254),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(4254),
    [sym__line_break] = ACTIONS(6831),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6833),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1965] = {
    [sym__statements] = STATE(4253),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(4255),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6833),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1966] = {
    [sym_heredoc_body] = STATE(4256),
    [sym__terminator] = STATE(4256),
    [sym__line_break] = ACTIONS(6835),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(6835),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [1967] = {
    [sym_when] = STATE(4257),
    [aux_sym_case_repeat1] = STATE(4258),
    [anon_sym_SEMI] = ACTIONS(6837),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [1968] = {
    [sym_else] = STATE(4260),
    [sym_ensure] = STATE(4261),
    [sym_rescue] = STATE(4262),
    [anon_sym_end] = ACTIONS(6839),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1969] = {
    [sym_ensure] = STATE(4261),
    [anon_sym_end] = ACTIONS(6839),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1970] = {
    [anon_sym_end] = ACTIONS(6839),
    [sym_comment] = ACTIONS(87),
  },
  [1971] = {
    [sym_else] = STATE(4260),
    [sym_ensure] = STATE(4261),
    [anon_sym_end] = ACTIONS(6839),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [1972] = {
    [sym__heredoc_body_start] = ACTIONS(2187),
    [sym__binary_minus] = ACTIONS(2187),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_STAR_STAR] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_EQ] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_unless] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_until] = ACTIONS(2187),
    [anon_sym_rescue] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_EQ_GT] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_RBRACK] = ACTIONS(2187),
    [anon_sym_COLON_COLON2] = ACTIONS(2187),
    [anon_sym_AMP_DOT] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_COLON2] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_LT_LT] = ACTIONS(2189),
    [anon_sym_GT_GT] = ACTIONS(2189),
    [anon_sym_EQ_EQ] = ACTIONS(2189),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_EQ_TILDE] = ACTIONS(2187),
    [anon_sym_BANG_TILDE] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2189),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_PERCENT] = ACTIONS(2189),
    [sym_comment] = ACTIONS(87),
  },
  [1973] = {
    [sym__statements] = STATE(1968),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1969),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1970),
    [sym_rescue] = STATE(1971),
    [sym__body_statement] = STATE(4263),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6841),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1974] = {
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR_STAR] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4148),
    [anon_sym_unless] = ACTIONS(4148),
    [anon_sym_while] = ACTIONS(4148),
    [anon_sym_until] = ACTIONS(4148),
    [anon_sym_rescue] = ACTIONS(4148),
    [anon_sym_in] = ACTIONS(4148),
    [anon_sym_do] = ACTIONS(4148),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_COLON2] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [sym_comment] = ACTIONS(87),
  },
  [1975] = {
    [sym_heredoc_body] = STATE(4265),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(6843),
    [sym_comment] = ACTIONS(87),
  },
  [1976] = {
    [anon_sym_RPAREN] = ACTIONS(6843),
    [sym_comment] = ACTIONS(87),
  },
  [1977] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [1978] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [1979] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4266),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4266),
    [sym_operator_assignment] = STATE(4266),
    [sym_conditional] = STATE(4266),
    [sym_range] = STATE(4266),
    [sym_binary] = STATE(4266),
    [sym_unary] = STATE(4266),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1980] = {
    [sym__heredoc_body_start] = ACTIONS(2267),
    [sym__binary_minus] = ACTIONS(2267),
    [sym__binary_star] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_RPAREN] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2269),
    [anon_sym_COMMA] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_STAR_STAR] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_unless] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_until] = ACTIONS(2267),
    [anon_sym_rescue] = ACTIONS(2267),
    [anon_sym_in] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_EQ_GT] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_RBRACK] = ACTIONS(2267),
    [anon_sym_COLON_COLON2] = ACTIONS(2267),
    [anon_sym_AMP_DOT] = ACTIONS(2267),
    [anon_sym_PLUS_EQ] = ACTIONS(2267),
    [anon_sym_DASH_EQ] = ACTIONS(2267),
    [anon_sym_STAR_EQ] = ACTIONS(2267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2267),
    [anon_sym_SLASH_EQ] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2267),
    [anon_sym_PIPE_EQ] = ACTIONS(2267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2267),
    [anon_sym_AMP_EQ] = ACTIONS(2267),
    [anon_sym_PERCENT_EQ] = ACTIONS(2267),
    [anon_sym_GT_GT_EQ] = ACTIONS(2267),
    [anon_sym_LT_LT_EQ] = ACTIONS(2267),
    [anon_sym_CARET_EQ] = ACTIONS(2267),
    [anon_sym_QMARK] = ACTIONS(2267),
    [anon_sym_COLON2] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2267),
    [anon_sym_and] = ACTIONS(2267),
    [anon_sym_or] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_LT_LT] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2269),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2267),
    [anon_sym_LT_EQ_GT] = ACTIONS(2267),
    [anon_sym_EQ_TILDE] = ACTIONS(2267),
    [anon_sym_BANG_TILDE] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2267),
    [anon_sym_CARET] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2269),
    [sym_comment] = ACTIONS(87),
  },
  [1981] = {
    [sym__heredoc_body_start] = ACTIONS(2351),
    [sym__binary_minus] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2353),
    [anon_sym_COMMA] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2353),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_if] = ACTIONS(2351),
    [anon_sym_unless] = ACTIONS(2351),
    [anon_sym_while] = ACTIONS(2351),
    [anon_sym_until] = ACTIONS(2351),
    [anon_sym_rescue] = ACTIONS(2351),
    [anon_sym_in] = ACTIONS(2351),
    [anon_sym_do] = ACTIONS(2351),
    [anon_sym_EQ_GT] = ACTIONS(2351),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_RBRACK] = ACTIONS(2351),
    [anon_sym_COLON_COLON2] = ACTIONS(2351),
    [anon_sym_AMP_DOT] = ACTIONS(2351),
    [anon_sym_PLUS_EQ] = ACTIONS(2351),
    [anon_sym_DASH_EQ] = ACTIONS(2351),
    [anon_sym_STAR_EQ] = ACTIONS(2351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2351),
    [anon_sym_SLASH_EQ] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2351),
    [anon_sym_PIPE_EQ] = ACTIONS(2351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2351),
    [anon_sym_AMP_EQ] = ACTIONS(2351),
    [anon_sym_PERCENT_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT_EQ] = ACTIONS(2351),
    [anon_sym_LT_LT_EQ] = ACTIONS(2351),
    [anon_sym_CARET_EQ] = ACTIONS(2351),
    [anon_sym_QMARK] = ACTIONS(2351),
    [anon_sym_COLON2] = ACTIONS(2353),
    [anon_sym_DOT_DOT] = ACTIONS(2353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2351),
    [anon_sym_or] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_CARET] = ACTIONS(2353),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_SLASH] = ACTIONS(2353),
    [anon_sym_PERCENT] = ACTIONS(2353),
    [sym_comment] = ACTIONS(87),
  },
  [1982] = {
    [sym_heredoc_body] = STATE(4268),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(6845),
    [sym_comment] = ACTIONS(87),
  },
  [1983] = {
    [anon_sym_RBRACK] = ACTIONS(6845),
    [sym_comment] = ACTIONS(87),
  },
  [1984] = {
    [sym__statements] = STATE(3410),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(3411),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6847),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1985] = {
    [sym_do_block] = STATE(4270),
    [sym_block] = STATE(4270),
    [anon_sym_LBRACE] = ACTIONS(3372),
    [anon_sym_do] = ACTIONS(5570),
    [sym_comment] = ACTIONS(87),
  },
  [1986] = {
    [sym__heredoc_body_start] = ACTIONS(2491),
    [sym__binary_minus] = ACTIONS(2491),
    [sym__binary_star] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2493),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_STAR_STAR] = ACTIONS(2493),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_EQ] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_unless] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_until] = ACTIONS(2491),
    [anon_sym_rescue] = ACTIONS(2491),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_EQ_GT] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_RBRACK] = ACTIONS(2491),
    [anon_sym_COLON_COLON2] = ACTIONS(2491),
    [anon_sym_AMP_DOT] = ACTIONS(2491),
    [anon_sym_PLUS_EQ] = ACTIONS(2491),
    [anon_sym_DASH_EQ] = ACTIONS(2491),
    [anon_sym_STAR_EQ] = ACTIONS(2491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2491),
    [anon_sym_SLASH_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_EQ] = ACTIONS(2491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2491),
    [anon_sym_AMP_EQ] = ACTIONS(2491),
    [anon_sym_PERCENT_EQ] = ACTIONS(2491),
    [anon_sym_GT_GT_EQ] = ACTIONS(2491),
    [anon_sym_LT_LT_EQ] = ACTIONS(2491),
    [anon_sym_CARET_EQ] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2491),
    [anon_sym_COLON2] = ACTIONS(2493),
    [anon_sym_DOT_DOT] = ACTIONS(2493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2491),
    [anon_sym_and] = ACTIONS(2491),
    [anon_sym_or] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2493),
    [anon_sym_AMP_AMP] = ACTIONS(2493),
    [anon_sym_LT_LT] = ACTIONS(2493),
    [anon_sym_GT_GT] = ACTIONS(2493),
    [anon_sym_EQ_EQ] = ACTIONS(2493),
    [anon_sym_BANG_EQ] = ACTIONS(2491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ_GT] = ACTIONS(2491),
    [anon_sym_EQ_TILDE] = ACTIONS(2491),
    [anon_sym_BANG_TILDE] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2493),
    [anon_sym_PLUS] = ACTIONS(2493),
    [anon_sym_SLASH] = ACTIONS(2493),
    [anon_sym_PERCENT] = ACTIONS(2493),
    [sym_comment] = ACTIONS(87),
  },
  [1987] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4271),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4271),
    [sym_operator_assignment] = STATE(4271),
    [sym_conditional] = STATE(4271),
    [sym_range] = STATE(4271),
    [sym_binary] = STATE(4271),
    [sym_unary] = STATE(4271),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1988] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4272),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4272),
    [sym_operator_assignment] = STATE(4272),
    [sym_conditional] = STATE(4272),
    [sym_range] = STATE(4272),
    [sym_binary] = STATE(4272),
    [sym_unary] = STATE(4272),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1989] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4273),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4273),
    [sym_operator_assignment] = STATE(4273),
    [sym_conditional] = STATE(4273),
    [sym_range] = STATE(4273),
    [sym_binary] = STATE(4273),
    [sym_unary] = STATE(4273),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1990] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4274),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4274),
    [sym_operator_assignment] = STATE(4274),
    [sym_conditional] = STATE(4274),
    [sym_range] = STATE(4274),
    [sym_binary] = STATE(4274),
    [sym_unary] = STATE(4274),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1991] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4275),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4275),
    [sym_operator_assignment] = STATE(4275),
    [sym_conditional] = STATE(4275),
    [sym_range] = STATE(4275),
    [sym_binary] = STATE(4275),
    [sym_unary] = STATE(4275),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1992] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4276),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4276),
    [sym_operator_assignment] = STATE(4276),
    [sym_conditional] = STATE(4276),
    [sym_range] = STATE(4276),
    [sym_binary] = STATE(4276),
    [sym_unary] = STATE(4276),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1993] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4277),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4277),
    [sym_operator_assignment] = STATE(4277),
    [sym_conditional] = STATE(4277),
    [sym_range] = STATE(4277),
    [sym_binary] = STATE(4277),
    [sym_unary] = STATE(4277),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1994] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4278),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4278),
    [sym_operator_assignment] = STATE(4278),
    [sym_conditional] = STATE(4278),
    [sym_range] = STATE(4278),
    [sym_binary] = STATE(4278),
    [sym_unary] = STATE(4278),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1995] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4279),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4279),
    [sym_operator_assignment] = STATE(4279),
    [sym_conditional] = STATE(4279),
    [sym_range] = STATE(4279),
    [sym_binary] = STATE(4279),
    [sym_unary] = STATE(4279),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1996] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4280),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4280),
    [sym_operator_assignment] = STATE(4280),
    [sym_conditional] = STATE(4280),
    [sym_range] = STATE(4280),
    [sym_binary] = STATE(4280),
    [sym_unary] = STATE(4280),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [1997] = {
    [sym__statements] = STATE(3410),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(3411),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1939),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1940),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6847),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1998] = {
    [sym_do_block] = STATE(3429),
    [sym_block] = STATE(3429),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(3372),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_in] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_EQ_GT] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_RBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_COLON2] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [1999] = {
    [sym__statements] = STATE(1937),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(1938),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6849),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2000] = {
    [sym__binary_minus] = ACTIONS(6024),
    [sym__binary_star] = ACTIONS(6024),
    [anon_sym_DOT] = ACTIONS(6026),
    [anon_sym_COMMA] = ACTIONS(6024),
    [anon_sym_PIPE] = ACTIONS(6026),
    [anon_sym_STAR_STAR] = ACTIONS(6026),
    [anon_sym_AMP] = ACTIONS(6026),
    [anon_sym_EQ] = ACTIONS(6026),
    [anon_sym_LT] = ACTIONS(6026),
    [anon_sym_EQ_GT] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_COLON_COLON2] = ACTIONS(6024),
    [anon_sym_AMP_DOT] = ACTIONS(6024),
    [anon_sym_PLUS_EQ] = ACTIONS(6024),
    [anon_sym_DASH_EQ] = ACTIONS(6024),
    [anon_sym_STAR_EQ] = ACTIONS(6024),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6024),
    [anon_sym_SLASH_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6024),
    [anon_sym_AMP_EQ] = ACTIONS(6024),
    [anon_sym_PERCENT_EQ] = ACTIONS(6024),
    [anon_sym_GT_GT_EQ] = ACTIONS(6024),
    [anon_sym_LT_LT_EQ] = ACTIONS(6024),
    [anon_sym_CARET_EQ] = ACTIONS(6024),
    [anon_sym_QMARK] = ACTIONS(6024),
    [anon_sym_DOT_DOT] = ACTIONS(6026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_or] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(6026),
    [anon_sym_LT_LT] = ACTIONS(6026),
    [anon_sym_GT_GT] = ACTIONS(6026),
    [anon_sym_EQ_EQ] = ACTIONS(6026),
    [anon_sym_BANG_EQ] = ACTIONS(6024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6024),
    [anon_sym_LT_EQ_GT] = ACTIONS(6024),
    [anon_sym_EQ_TILDE] = ACTIONS(6024),
    [anon_sym_BANG_TILDE] = ACTIONS(6024),
    [anon_sym_LT_EQ] = ACTIONS(6026),
    [anon_sym_GT] = ACTIONS(6026),
    [anon_sym_GT_EQ] = ACTIONS(6024),
    [anon_sym_CARET] = ACTIONS(6026),
    [anon_sym_PLUS] = ACTIONS(6026),
    [anon_sym_SLASH] = ACTIONS(6026),
    [anon_sym_PERCENT] = ACTIONS(6026),
    [sym_comment] = ACTIONS(87),
  },
  [2001] = {
    [sym_interpolation] = STATE(4283),
    [aux_sym_heredoc_body_repeat1] = STATE(4283),
    [sym__heredoc_content] = ACTIONS(6851),
    [sym_heredoc_end] = ACTIONS(6853),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(6851),
  },
  [2002] = {
    [sym_heredoc_body] = STATE(4284),
    [aux_sym_call_repeat1] = STATE(4284),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [2003] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym__argument] = STATE(4285),
    [sym_splat_argument] = STATE(4285),
    [sym_hash_splat_argument] = STATE(4285),
    [sym_block_argument] = STATE(4285),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(4286),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4285),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6855),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2004] = {
    [sym_heredoc_body] = STATE(4287),
    [aux_sym_call_repeat1] = STATE(4287),
    [aux_sym_argument_list_repeat1] = STATE(4288),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(3410),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [2005] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4289),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_splat_argument] = STATE(4291),
    [sym_assignment] = STATE(4289),
    [sym_operator_assignment] = STATE(4289),
    [sym_conditional] = STATE(4289),
    [sym_range] = STATE(4289),
    [sym_binary] = STATE(4289),
    [sym_unary] = STATE(4289),
    [sym_right_assignment_list] = STATE(4290),
    [sym__arg_or_splat_arg] = STATE(4291),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2006] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4292),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(4292),
    [sym_operator_assignment] = STATE(4292),
    [sym_conditional] = STATE(4292),
    [sym_range] = STATE(4292),
    [sym_binary] = STATE(4292),
    [sym_unary] = STATE(4292),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2007] = {
    [sym_string] = STATE(4293),
    [aux_sym_chained_string_repeat1] = STATE(4293),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [2008] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(4294),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(4294),
    [sym_operator_assignment] = STATE(4294),
    [sym_conditional] = STATE(4294),
    [sym_range] = STATE(4294),
    [sym_binary] = STATE(4294),
    [sym_unary] = STATE(4294),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2009] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(4295),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(4295),
    [sym_operator_assignment] = STATE(4295),
    [sym_conditional] = STATE(4295),
    [sym_range] = STATE(4295),
    [sym_binary] = STATE(4295),
    [sym_unary] = STATE(4295),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2010] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(562),
    [sym__argument_list_with_parens] = STATE(1848),
    [sym__argument] = STATE(1849),
    [sym_splat_argument] = STATE(1849),
    [sym_hash_splat_argument] = STATE(1849),
    [sym_block_argument] = STATE(1849),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1849),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2011] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(568),
    [sym__argument_list_with_parens] = STATE(1848),
    [sym__argument] = STATE(1849),
    [sym_splat_argument] = STATE(1849),
    [sym_hash_splat_argument] = STATE(1849),
    [sym_block_argument] = STATE(1849),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1849),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2012] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(1848),
    [sym__argument] = STATE(1849),
    [sym_splat_argument] = STATE(1849),
    [sym_hash_splat_argument] = STATE(1849),
    [sym_block_argument] = STATE(1849),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1849),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2013] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(1848),
    [sym__argument] = STATE(1849),
    [sym_splat_argument] = STATE(1849),
    [sym_hash_splat_argument] = STATE(1849),
    [sym_block_argument] = STATE(1849),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(1849),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2014] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(4296),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(4296),
    [sym_operator_assignment] = STATE(4296),
    [sym_conditional] = STATE(4296),
    [sym_range] = STATE(4296),
    [sym_binary] = STATE(4296),
    [sym_unary] = STATE(4296),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2015] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2016] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [2017] = {
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_COLON2] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [2018] = {
    [aux_sym_exceptions_repeat1] = STATE(4308),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6883),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [2019] = {
    [anon_sym_EQ] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [2020] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6887),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6889),
    [anon_sym_DASH_EQ] = ACTIONS(6889),
    [anon_sym_STAR_EQ] = ACTIONS(6889),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6889),
    [anon_sym_SLASH_EQ] = ACTIONS(6889),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6889),
    [anon_sym_PIPE_EQ] = ACTIONS(6889),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6889),
    [anon_sym_AMP_EQ] = ACTIONS(6889),
    [anon_sym_PERCENT_EQ] = ACTIONS(6889),
    [anon_sym_GT_GT_EQ] = ACTIONS(6889),
    [anon_sym_LT_LT_EQ] = ACTIONS(6889),
    [anon_sym_CARET_EQ] = ACTIONS(6889),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2021] = {
    [sym_string] = STATE(4311),
    [aux_sym_chained_string_repeat1] = STATE(4311),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2022] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [2023] = {
    [sym_string] = STATE(2023),
    [aux_sym_chained_string_repeat1] = STATE(2023),
    [sym__string_start] = ACTIONS(6891),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [2024] = {
    [sym__line_break] = ACTIONS(6894),
    [sym__heredoc_body_start] = ACTIONS(6894),
    [sym__binary_minus] = ACTIONS(6894),
    [sym__binary_star] = ACTIONS(6894),
    [ts_builtin_sym_end] = ACTIONS(6894),
    [anon_sym___END__] = ACTIONS(6894),
    [anon_sym_LBRACE] = ACTIONS(6894),
    [anon_sym_RBRACE] = ACTIONS(6894),
    [anon_sym_RPAREN] = ACTIONS(6894),
    [anon_sym_DOT] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_SEMI] = ACTIONS(6894),
    [anon_sym_STAR_STAR] = ACTIONS(6894),
    [anon_sym_AMP] = ACTIONS(6896),
    [anon_sym_LT] = ACTIONS(6896),
    [anon_sym_end] = ACTIONS(6894),
    [anon_sym_if] = ACTIONS(6894),
    [anon_sym_unless] = ACTIONS(6894),
    [anon_sym_while] = ACTIONS(6894),
    [anon_sym_until] = ACTIONS(6894),
    [anon_sym_rescue] = ACTIONS(6894),
    [anon_sym_do] = ACTIONS(6894),
    [anon_sym_when] = ACTIONS(6894),
    [anon_sym_elsif] = ACTIONS(6894),
    [anon_sym_else] = ACTIONS(6894),
    [anon_sym_then] = ACTIONS(6894),
    [anon_sym_ensure] = ACTIONS(6894),
    [anon_sym_EQ_GT] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6894),
    [anon_sym_COLON_COLON2] = ACTIONS(6894),
    [anon_sym_AMP_DOT] = ACTIONS(6894),
    [anon_sym_QMARK] = ACTIONS(6894),
    [anon_sym_DOT_DOT] = ACTIONS(6896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6894),
    [anon_sym_and] = ACTIONS(6894),
    [anon_sym_or] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE] = ACTIONS(6894),
    [anon_sym_AMP_AMP] = ACTIONS(6894),
    [anon_sym_LT_LT] = ACTIONS(6894),
    [anon_sym_GT_GT] = ACTIONS(6894),
    [anon_sym_EQ_EQ] = ACTIONS(6896),
    [anon_sym_BANG_EQ] = ACTIONS(6894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6894),
    [anon_sym_LT_EQ_GT] = ACTIONS(6894),
    [anon_sym_EQ_TILDE] = ACTIONS(6894),
    [anon_sym_BANG_TILDE] = ACTIONS(6894),
    [anon_sym_LT_EQ] = ACTIONS(6896),
    [anon_sym_GT] = ACTIONS(6896),
    [anon_sym_GT_EQ] = ACTIONS(6894),
    [anon_sym_CARET] = ACTIONS(6894),
    [anon_sym_PLUS] = ACTIONS(6894),
    [anon_sym_SLASH] = ACTIONS(6894),
    [anon_sym_PERCENT] = ACTIONS(6894),
    [sym_comment] = ACTIONS(87),
  },
  [2025] = {
    [sym_interpolation] = STATE(4313),
    [aux_sym_heredoc_body_repeat1] = STATE(4313),
    [sym__heredoc_content] = ACTIONS(6898),
    [sym_heredoc_end] = ACTIONS(6900),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(6898),
  },
  [2026] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(4314),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(6902),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(6902),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2027] = {
    [sym__heredoc_body_start] = ACTIONS(6902),
    [anon_sym_RBRACE] = ACTIONS(6902),
    [sym_comment] = ACTIONS(87),
  },
  [2028] = {
    [sym__line_break] = ACTIONS(6904),
    [sym__heredoc_body_start] = ACTIONS(6904),
    [ts_builtin_sym_end] = ACTIONS(6904),
    [anon_sym___END__] = ACTIONS(6904),
    [anon_sym_RBRACE] = ACTIONS(6904),
    [anon_sym_RPAREN] = ACTIONS(6904),
    [anon_sym_SEMI] = ACTIONS(6904),
    [anon_sym_end] = ACTIONS(6904),
    [anon_sym_rescue] = ACTIONS(6904),
    [anon_sym_when] = ACTIONS(6904),
    [anon_sym_elsif] = ACTIONS(6904),
    [anon_sym_else] = ACTIONS(6904),
    [anon_sym_ensure] = ACTIONS(6904),
    [sym_comment] = ACTIONS(87),
  },
  [2029] = {
    [sym__line_break] = ACTIONS(2907),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [ts_builtin_sym_end] = ACTIONS(2907),
    [anon_sym___END__] = ACTIONS(2909),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_STAR_STAR] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_end] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_unless] = ACTIONS(2909),
    [anon_sym_while] = ACTIONS(2909),
    [anon_sym_until] = ACTIONS(2909),
    [anon_sym_rescue] = ACTIONS(2909),
    [anon_sym_when] = ACTIONS(2909),
    [anon_sym_elsif] = ACTIONS(2909),
    [anon_sym_else] = ACTIONS(2909),
    [anon_sym_then] = ACTIONS(2909),
    [anon_sym_ensure] = ACTIONS(2909),
    [sym_identifier] = ACTIONS(2909),
    [sym_comment] = ACTIONS(87),
  },
  [2030] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2031] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4318),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(4318),
    [sym_operator_assignment] = STATE(4318),
    [sym_conditional] = STATE(4318),
    [sym_range] = STATE(4318),
    [sym_binary] = STATE(4318),
    [sym_unary] = STATE(4318),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2032] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4321),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(4321),
    [sym_operator_assignment] = STATE(4321),
    [sym_conditional] = STATE(4321),
    [sym_range] = STATE(4321),
    [sym_binary] = STATE(4321),
    [sym_unary] = STATE(4321),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2033] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4322),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(4322),
    [sym_operator_assignment] = STATE(4322),
    [sym_conditional] = STATE(4322),
    [sym_range] = STATE(4322),
    [sym_binary] = STATE(4322),
    [sym_unary] = STATE(4322),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2034] = {
    [anon_sym_COLON] = ACTIONS(6918),
    [sym_comment] = ACTIONS(87),
  },
  [2035] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4324),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(4324),
    [sym_operator_assignment] = STATE(4324),
    [sym_conditional] = STATE(4324),
    [sym_range] = STATE(4324),
    [sym_binary] = STATE(4324),
    [sym_unary] = STATE(4324),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2036] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4325),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(4325),
    [sym_operator_assignment] = STATE(4325),
    [sym_conditional] = STATE(4325),
    [sym_range] = STATE(4325),
    [sym_binary] = STATE(4325),
    [sym_unary] = STATE(4325),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2037] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2038] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6920),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2039] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(6918),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [2040] = {
    [sym_heredoc_body] = STATE(4337),
    [aux_sym_call_repeat1] = STATE(4337),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2041] = {
    [sym_heredoc_body] = STATE(4337),
    [aux_sym_call_repeat1] = STATE(4337),
    [aux_sym_argument_list_repeat1] = STATE(4339),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(6948),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2042] = {
    [anon_sym_EQ] = ACTIONS(6950),
    [sym_comment] = ACTIONS(87),
  },
  [2043] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6952),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6954),
    [anon_sym_DASH_EQ] = ACTIONS(6954),
    [anon_sym_STAR_EQ] = ACTIONS(6954),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6954),
    [anon_sym_SLASH_EQ] = ACTIONS(6954),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6954),
    [anon_sym_PIPE_EQ] = ACTIONS(6954),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6954),
    [anon_sym_AMP_EQ] = ACTIONS(6954),
    [anon_sym_PERCENT_EQ] = ACTIONS(6954),
    [anon_sym_GT_GT_EQ] = ACTIONS(6954),
    [anon_sym_LT_LT_EQ] = ACTIONS(6954),
    [anon_sym_CARET_EQ] = ACTIONS(6954),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2044] = {
    [sym_string] = STATE(2503),
    [aux_sym_chained_string_repeat1] = STATE(2503),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6956),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2045] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [2046] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4342),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4342),
    [sym_operator_assignment] = STATE(4342),
    [sym_conditional] = STATE(4342),
    [sym_range] = STATE(4342),
    [sym_binary] = STATE(4342),
    [sym_unary] = STATE(4342),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2047] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4343),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4343),
    [sym_operator_assignment] = STATE(4343),
    [sym_conditional] = STATE(4343),
    [sym_range] = STATE(4343),
    [sym_binary] = STATE(4343),
    [sym_unary] = STATE(4343),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2048] = {
    [anon_sym_DOT] = ACTIONS(6958),
    [anon_sym_COLON_COLON] = ACTIONS(6958),
    [sym_comment] = ACTIONS(87),
  },
  [2049] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4345),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4345),
    [sym_operator_assignment] = STATE(4345),
    [sym_conditional] = STATE(4345),
    [sym_range] = STATE(4345),
    [sym_binary] = STATE(4345),
    [sym_unary] = STATE(4345),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2050] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4346),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4346),
    [sym_operator_assignment] = STATE(4346),
    [sym_conditional] = STATE(4346),
    [sym_range] = STATE(4346),
    [sym_binary] = STATE(4346),
    [sym_unary] = STATE(4346),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2051] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4347),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4347),
    [sym_operator_assignment] = STATE(4347),
    [sym_conditional] = STATE(4347),
    [sym_range] = STATE(4347),
    [sym_binary] = STATE(4347),
    [sym_unary] = STATE(4347),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2052] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4348),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4348),
    [sym_operator_assignment] = STATE(4348),
    [sym_conditional] = STATE(4348),
    [sym_range] = STATE(4348),
    [sym_binary] = STATE(4348),
    [sym_unary] = STATE(4348),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2053] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4349),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4349),
    [sym_operator_assignment] = STATE(4349),
    [sym_conditional] = STATE(4349),
    [sym_range] = STATE(4349),
    [sym_binary] = STATE(4349),
    [sym_unary] = STATE(4349),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2054] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4350),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4350),
    [sym_operator_assignment] = STATE(4350),
    [sym_conditional] = STATE(4350),
    [sym_range] = STATE(4350),
    [sym_binary] = STATE(4350),
    [sym_unary] = STATE(4350),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2055] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4351),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4351),
    [sym_operator_assignment] = STATE(4351),
    [sym_conditional] = STATE(4351),
    [sym_range] = STATE(4351),
    [sym_binary] = STATE(4351),
    [sym_unary] = STATE(4351),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2056] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4352),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4352),
    [sym_operator_assignment] = STATE(4352),
    [sym_conditional] = STATE(4352),
    [sym_range] = STATE(4352),
    [sym_binary] = STATE(4352),
    [sym_unary] = STATE(4352),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2057] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(4360),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(4360),
    [sym_operator_assignment] = STATE(4360),
    [sym_conditional] = STATE(4360),
    [sym_range] = STATE(4360),
    [sym_binary] = STATE(4360),
    [sym_unary] = STATE(4360),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [2058] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(4365),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(4365),
    [sym_operator_assignment] = STATE(4365),
    [sym_conditional] = STATE(4365),
    [sym_range] = STATE(4365),
    [sym_binary] = STATE(4365),
    [sym_unary] = STATE(4365),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [2059] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4366),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(4366),
    [sym_operator_assignment] = STATE(4366),
    [sym_conditional] = STATE(4366),
    [sym_range] = STATE(4366),
    [sym_binary] = STATE(4366),
    [sym_unary] = STATE(4366),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2060] = {
    [anon_sym_COLON] = ACTIONS(6984),
    [sym_comment] = ACTIONS(87),
  },
  [2061] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(4369),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(4369),
    [sym_operator_assignment] = STATE(4369),
    [sym_conditional] = STATE(4369),
    [sym_range] = STATE(4369),
    [sym_binary] = STATE(4369),
    [sym_unary] = STATE(4369),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [2062] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2494),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(1953),
    [sym__argument_list_with_parens] = STATE(2495),
    [sym__argument] = STATE(2496),
    [sym_splat_argument] = STATE(2496),
    [sym_hash_splat_argument] = STATE(2496),
    [sym_block_argument] = STATE(2496),
    [sym_assignment] = STATE(2494),
    [sym_operator_assignment] = STATE(2494),
    [sym_conditional] = STATE(2494),
    [sym_range] = STATE(2494),
    [sym_binary] = STATE(2494),
    [sym_unary] = STATE(2494),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2497),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2496),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4190),
    [sym__splat_star] = ACTIONS(4192),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(4196),
    [sym_identifier] = ACTIONS(4196),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2063] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2494),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(1954),
    [sym__argument_list_with_parens] = STATE(2495),
    [sym__argument] = STATE(2496),
    [sym_splat_argument] = STATE(2496),
    [sym_hash_splat_argument] = STATE(2496),
    [sym_block_argument] = STATE(2496),
    [sym_assignment] = STATE(2494),
    [sym_operator_assignment] = STATE(2494),
    [sym_conditional] = STATE(2494),
    [sym_range] = STATE(2494),
    [sym_binary] = STATE(2494),
    [sym_unary] = STATE(2494),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2497),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2496),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4190),
    [sym__splat_star] = ACTIONS(4192),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(4196),
    [sym_identifier] = ACTIONS(4196),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2064] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2494),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(1955),
    [sym__argument_list_with_parens] = STATE(2495),
    [sym__argument] = STATE(2496),
    [sym_splat_argument] = STATE(2496),
    [sym_hash_splat_argument] = STATE(2496),
    [sym_block_argument] = STATE(2496),
    [sym_assignment] = STATE(2494),
    [sym_operator_assignment] = STATE(2494),
    [sym_conditional] = STATE(2494),
    [sym_range] = STATE(2494),
    [sym_binary] = STATE(2494),
    [sym_unary] = STATE(2494),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2497),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2496),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4190),
    [sym__splat_star] = ACTIONS(4192),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(4196),
    [sym_identifier] = ACTIONS(4196),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2065] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2494),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(1956),
    [sym__argument_list_with_parens] = STATE(2495),
    [sym__argument] = STATE(2496),
    [sym_splat_argument] = STATE(2496),
    [sym_hash_splat_argument] = STATE(2496),
    [sym_block_argument] = STATE(2496),
    [sym_assignment] = STATE(2494),
    [sym_operator_assignment] = STATE(2494),
    [sym_conditional] = STATE(2494),
    [sym_range] = STATE(2494),
    [sym_binary] = STATE(2494),
    [sym_unary] = STATE(2494),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2497),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2496),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4190),
    [sym__splat_star] = ACTIONS(4192),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(4196),
    [sym_identifier] = ACTIONS(4196),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2066] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4370),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(4370),
    [sym_operator_assignment] = STATE(4370),
    [sym_conditional] = STATE(4370),
    [sym_range] = STATE(4370),
    [sym_binary] = STATE(4370),
    [sym_unary] = STATE(4370),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2067] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1978),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(1978),
    [sym_operator_assignment] = STATE(1978),
    [sym_conditional] = STATE(1978),
    [sym_range] = STATE(1978),
    [sym_binary] = STATE(1978),
    [sym_unary] = STATE(1978),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2068] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(6986),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2069] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(6984),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [2070] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2494),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(2495),
    [sym__argument] = STATE(2496),
    [sym_splat_argument] = STATE(2496),
    [sym_hash_splat_argument] = STATE(2496),
    [sym_block_argument] = STATE(2496),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(2494),
    [sym_operator_assignment] = STATE(2494),
    [sym_conditional] = STATE(2494),
    [sym_range] = STATE(2494),
    [sym_binary] = STATE(2494),
    [sym_unary] = STATE(2494),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2497),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2496),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4190),
    [sym__splat_star] = ACTIONS(4192),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(4196),
    [sym_identifier] = ACTIONS(4196),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2071] = {
    [sym_heredoc_body] = STATE(4382),
    [aux_sym_call_repeat1] = STATE(4382),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2072] = {
    [sym_heredoc_body] = STATE(4382),
    [aux_sym_call_repeat1] = STATE(4382),
    [aux_sym_argument_list_repeat1] = STATE(4384),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(7016),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2073] = {
    [anon_sym_EQ] = ACTIONS(7018),
    [sym_comment] = ACTIONS(87),
  },
  [2074] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7020),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7022),
    [anon_sym_DASH_EQ] = ACTIONS(7022),
    [anon_sym_STAR_EQ] = ACTIONS(7022),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7022),
    [anon_sym_SLASH_EQ] = ACTIONS(7022),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7022),
    [anon_sym_PIPE_EQ] = ACTIONS(7022),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7022),
    [anon_sym_AMP_EQ] = ACTIONS(7022),
    [anon_sym_PERCENT_EQ] = ACTIONS(7022),
    [anon_sym_GT_GT_EQ] = ACTIONS(7022),
    [anon_sym_LT_LT_EQ] = ACTIONS(7022),
    [anon_sym_CARET_EQ] = ACTIONS(7022),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2075] = {
    [sym_string] = STATE(4387),
    [aux_sym_chained_string_repeat1] = STATE(4387),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7024),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2076] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4396),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_splat_argument] = STATE(4397),
    [sym_assignment] = STATE(4396),
    [sym_operator_assignment] = STATE(4396),
    [sym_conditional] = STATE(4396),
    [sym_range] = STATE(4396),
    [sym_binary] = STATE(4396),
    [sym_unary] = STATE(4396),
    [sym_right_assignment_list] = STATE(2017),
    [sym__arg_or_splat_arg] = STATE(4397),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(7026),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2077] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4401),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(4401),
    [sym_operator_assignment] = STATE(4401),
    [sym_conditional] = STATE(4401),
    [sym_range] = STATE(4401),
    [sym_binary] = STATE(4401),
    [sym_unary] = STATE(4401),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2078] = {
    [sym_string] = STATE(4402),
    [aux_sym_chained_string_repeat1] = STATE(4402),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [2079] = {
    [sym__line_break] = ACTIONS(7046),
    [sym__heredoc_body_start] = ACTIONS(7046),
    [sym__binary_minus] = ACTIONS(7046),
    [sym__binary_star] = ACTIONS(7046),
    [ts_builtin_sym_end] = ACTIONS(7046),
    [anon_sym___END__] = ACTIONS(7046),
    [anon_sym_LBRACE] = ACTIONS(7046),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7046),
    [anon_sym_DOT] = ACTIONS(7048),
    [anon_sym_COMMA] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_STAR_STAR] = ACTIONS(7046),
    [anon_sym_AMP] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7048),
    [anon_sym_end] = ACTIONS(7046),
    [anon_sym_if] = ACTIONS(7046),
    [anon_sym_unless] = ACTIONS(7046),
    [anon_sym_while] = ACTIONS(7046),
    [anon_sym_until] = ACTIONS(7046),
    [anon_sym_rescue] = ACTIONS(7046),
    [anon_sym_do] = ACTIONS(7046),
    [anon_sym_when] = ACTIONS(7046),
    [anon_sym_elsif] = ACTIONS(7046),
    [anon_sym_else] = ACTIONS(7046),
    [anon_sym_then] = ACTIONS(7046),
    [anon_sym_ensure] = ACTIONS(7046),
    [anon_sym_EQ_GT] = ACTIONS(7046),
    [anon_sym_LBRACK] = ACTIONS(7046),
    [anon_sym_COLON_COLON2] = ACTIONS(7046),
    [anon_sym_AMP_DOT] = ACTIONS(7046),
    [anon_sym_QMARK] = ACTIONS(7046),
    [anon_sym_DOT_DOT] = ACTIONS(7048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7046),
    [anon_sym_and] = ACTIONS(7046),
    [anon_sym_or] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE] = ACTIONS(7046),
    [anon_sym_AMP_AMP] = ACTIONS(7046),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_BANG_EQ] = ACTIONS(7046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT_EQ_GT] = ACTIONS(7046),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_BANG_TILDE] = ACTIONS(7046),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7046),
    [anon_sym_CARET] = ACTIONS(7046),
    [anon_sym_PLUS] = ACTIONS(7046),
    [anon_sym_SLASH] = ACTIONS(7046),
    [anon_sym_PERCENT] = ACTIONS(7046),
    [sym_comment] = ACTIONS(87),
  },
  [2080] = {
    [sym_heredoc_body] = STATE(4403),
    [sym__terminator] = STATE(4403),
    [sym__line_break] = ACTIONS(7050),
    [sym__simple_symbol] = ACTIONS(7052),
    [sym__string_start] = ACTIONS(7052),
    [sym__symbol_start] = ACTIONS(7052),
    [sym__subshell_start] = ACTIONS(7052),
    [sym__regex_start] = ACTIONS(7052),
    [sym__string_array_start] = ACTIONS(7052),
    [sym__symbol_array_start] = ACTIONS(7052),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(7052),
    [sym__unary_minus] = ACTIONS(7052),
    [anon_sym_BEGIN] = ACTIONS(7054),
    [anon_sym_LBRACE] = ACTIONS(7052),
    [anon_sym_END] = ACTIONS(7054),
    [anon_sym_def] = ACTIONS(7054),
    [anon_sym_LPAREN] = ACTIONS(7052),
    [anon_sym_COLON_COLON] = ACTIONS(7052),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_STAR] = ACTIONS(7052),
    [anon_sym_class] = ACTIONS(7054),
    [anon_sym_module] = ACTIONS(7054),
    [anon_sym_end] = ACTIONS(7054),
    [anon_sym_return] = ACTIONS(7054),
    [anon_sym_yield] = ACTIONS(7054),
    [anon_sym_break] = ACTIONS(7054),
    [anon_sym_next] = ACTIONS(7054),
    [sym_redo] = ACTIONS(7054),
    [sym_retry] = ACTIONS(7054),
    [anon_sym_if] = ACTIONS(7054),
    [anon_sym_unless] = ACTIONS(7054),
    [anon_sym_while] = ACTIONS(7054),
    [anon_sym_until] = ACTIONS(7054),
    [anon_sym_rescue] = ACTIONS(7054),
    [anon_sym_for] = ACTIONS(7054),
    [anon_sym_case] = ACTIONS(7054),
    [anon_sym_else] = ACTIONS(7054),
    [anon_sym_begin] = ACTIONS(7054),
    [anon_sym_ensure] = ACTIONS(7054),
    [anon_sym_PLUS] = ACTIONS(7054),
    [anon_sym_defined_QMARK] = ACTIONS(7052),
    [anon_sym_not] = ACTIONS(7054),
    [anon_sym_BANG] = ACTIONS(7052),
    [anon_sym_TILDE] = ACTIONS(7052),
    [sym_constant] = ACTIONS(7054),
    [sym_identifier] = ACTIONS(7054),
    [sym_instance_variable] = ACTIONS(7052),
    [sym_class_variable] = ACTIONS(7052),
    [sym_global_variable] = ACTIONS(7052),
    [anon_sym_undef] = ACTIONS(7054),
    [anon_sym_alias] = ACTIONS(7054),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7054),
    [sym_float] = ACTIONS(7054),
    [sym_complex] = ACTIONS(7052),
    [sym_super] = ACTIONS(7054),
    [anon_sym_true] = ACTIONS(7054),
    [anon_sym_TRUE] = ACTIONS(7054),
    [anon_sym_false] = ACTIONS(7054),
    [anon_sym_FALSE] = ACTIONS(7054),
    [sym_self] = ACTIONS(7054),
    [anon_sym_nil] = ACTIONS(7054),
    [anon_sym_NIL] = ACTIONS(7054),
    [sym_character] = ACTIONS(7052),
    [anon_sym_LBRACK2] = ACTIONS(7052),
    [anon_sym_DASH_GT] = ACTIONS(7052),
  },
  [2081] = {
    [aux_sym_method_parameters_repeat1] = STATE(4405),
    [anon_sym_RPAREN] = ACTIONS(7056),
    [anon_sym_COMMA] = ACTIONS(5616),
    [sym_comment] = ACTIONS(87),
  },
  [2082] = {
    [sym__line_break] = ACTIONS(5618),
    [sym__heredoc_body_start] = ACTIONS(5618),
    [anon_sym_COMMA] = ACTIONS(5618),
    [anon_sym_SEMI] = ACTIONS(5618),
    [sym_comment] = ACTIONS(87),
  },
  [2083] = {
    [sym__line_break] = ACTIONS(5620),
    [sym__heredoc_body_start] = ACTIONS(5620),
    [anon_sym_COMMA] = ACTIONS(5620),
    [anon_sym_SEMI] = ACTIONS(5620),
    [sym_comment] = ACTIONS(87),
  },
  [2084] = {
    [sym__line_break] = ACTIONS(5622),
    [sym__heredoc_body_start] = ACTIONS(5622),
    [anon_sym_COMMA] = ACTIONS(5622),
    [anon_sym_SEMI] = ACTIONS(5622),
    [sym_comment] = ACTIONS(87),
  },
  [2085] = {
    [sym_lambda_parameters] = STATE(4408),
    [sym__simple_formal_parameter] = STATE(364),
    [sym_splat_parameter] = STATE(364),
    [sym_hash_splat_parameter] = STATE(364),
    [sym_block_parameter] = STATE(364),
    [sym_keyword_parameter] = STATE(364),
    [sym_optional_parameter] = STATE(364),
    [sym_do_block] = STATE(4409),
    [sym_block] = STATE(4409),
    [anon_sym_LBRACE] = ACTIONS(7058),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(7060),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [2086] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4410),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(4410),
    [sym_operator_assignment] = STATE(4410),
    [sym_conditional] = STATE(4410),
    [sym_range] = STATE(4410),
    [sym_binary] = STATE(4410),
    [sym_unary] = STATE(4410),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__line_break] = ACTIONS(5642),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(5642),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(5642),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2087] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4411),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(4411),
    [sym_operator_assignment] = STATE(4411),
    [sym_conditional] = STATE(4411),
    [sym_range] = STATE(4411),
    [sym_binary] = STATE(4411),
    [sym_unary] = STATE(4411),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2088] = {
    [sym__line_break] = ACTIONS(7062),
    [sym__heredoc_body_start] = ACTIONS(7062),
    [sym__binary_minus] = ACTIONS(7062),
    [sym__binary_star] = ACTIONS(7062),
    [ts_builtin_sym_end] = ACTIONS(7062),
    [anon_sym___END__] = ACTIONS(7062),
    [anon_sym_LBRACE] = ACTIONS(7062),
    [anon_sym_RBRACE] = ACTIONS(7062),
    [anon_sym_RPAREN] = ACTIONS(7062),
    [anon_sym_DOT] = ACTIONS(7064),
    [anon_sym_COMMA] = ACTIONS(7062),
    [anon_sym_PIPE] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(7062),
    [anon_sym_STAR_STAR] = ACTIONS(7062),
    [anon_sym_AMP] = ACTIONS(7064),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_end] = ACTIONS(7062),
    [anon_sym_if] = ACTIONS(7062),
    [anon_sym_unless] = ACTIONS(7062),
    [anon_sym_while] = ACTIONS(7062),
    [anon_sym_until] = ACTIONS(7062),
    [anon_sym_rescue] = ACTIONS(7062),
    [anon_sym_do] = ACTIONS(7062),
    [anon_sym_when] = ACTIONS(7062),
    [anon_sym_elsif] = ACTIONS(7062),
    [anon_sym_else] = ACTIONS(7062),
    [anon_sym_then] = ACTIONS(7062),
    [anon_sym_ensure] = ACTIONS(7062),
    [anon_sym_EQ_GT] = ACTIONS(7062),
    [anon_sym_LBRACK] = ACTIONS(7062),
    [anon_sym_COLON_COLON2] = ACTIONS(7062),
    [anon_sym_AMP_DOT] = ACTIONS(7062),
    [anon_sym_QMARK] = ACTIONS(7062),
    [anon_sym_DOT_DOT] = ACTIONS(7064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7062),
    [anon_sym_and] = ACTIONS(7062),
    [anon_sym_or] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE] = ACTIONS(7062),
    [anon_sym_AMP_AMP] = ACTIONS(7062),
    [anon_sym_LT_LT] = ACTIONS(7062),
    [anon_sym_GT_GT] = ACTIONS(7062),
    [anon_sym_EQ_EQ] = ACTIONS(7064),
    [anon_sym_BANG_EQ] = ACTIONS(7062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7062),
    [anon_sym_LT_EQ_GT] = ACTIONS(7062),
    [anon_sym_EQ_TILDE] = ACTIONS(7062),
    [anon_sym_BANG_TILDE] = ACTIONS(7062),
    [anon_sym_LT_EQ] = ACTIONS(7064),
    [anon_sym_GT] = ACTIONS(7064),
    [anon_sym_GT_EQ] = ACTIONS(7062),
    [anon_sym_CARET] = ACTIONS(7062),
    [anon_sym_PLUS] = ACTIONS(7062),
    [anon_sym_SLASH] = ACTIONS(7062),
    [anon_sym_PERCENT] = ACTIONS(7062),
    [sym_comment] = ACTIONS(87),
  },
  [2089] = {
    [sym__formal_parameter] = STATE(4413),
    [sym__simple_formal_parameter] = STATE(4413),
    [sym_destructured_parameter] = STATE(4413),
    [sym_splat_parameter] = STATE(4413),
    [sym_hash_splat_parameter] = STATE(4413),
    [sym_block_parameter] = STATE(4413),
    [sym_keyword_parameter] = STATE(4413),
    [sym_optional_parameter] = STATE(4413),
    [anon_sym_LPAREN] = ACTIONS(7066),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [2090] = {
    [sym__simple_symbol] = ACTIONS(7052),
    [sym__string_start] = ACTIONS(7052),
    [sym__symbol_start] = ACTIONS(7052),
    [sym__subshell_start] = ACTIONS(7052),
    [sym__regex_start] = ACTIONS(7052),
    [sym__string_array_start] = ACTIONS(7052),
    [sym__symbol_array_start] = ACTIONS(7052),
    [sym_heredoc_beginning] = ACTIONS(7052),
    [sym__unary_minus] = ACTIONS(7052),
    [anon_sym_BEGIN] = ACTIONS(7054),
    [anon_sym_LBRACE] = ACTIONS(7052),
    [anon_sym_END] = ACTIONS(7054),
    [anon_sym_def] = ACTIONS(7054),
    [anon_sym_LPAREN] = ACTIONS(7052),
    [anon_sym_COLON_COLON] = ACTIONS(7052),
    [anon_sym_SEMI] = ACTIONS(7052),
    [anon_sym_STAR] = ACTIONS(7052),
    [anon_sym_class] = ACTIONS(7054),
    [anon_sym_module] = ACTIONS(7054),
    [anon_sym_end] = ACTIONS(7054),
    [anon_sym_return] = ACTIONS(7054),
    [anon_sym_yield] = ACTIONS(7054),
    [anon_sym_break] = ACTIONS(7054),
    [anon_sym_next] = ACTIONS(7054),
    [sym_redo] = ACTIONS(7054),
    [sym_retry] = ACTIONS(7054),
    [anon_sym_if] = ACTIONS(7054),
    [anon_sym_unless] = ACTIONS(7054),
    [anon_sym_while] = ACTIONS(7054),
    [anon_sym_until] = ACTIONS(7054),
    [anon_sym_rescue] = ACTIONS(7054),
    [anon_sym_for] = ACTIONS(7054),
    [anon_sym_case] = ACTIONS(7054),
    [anon_sym_else] = ACTIONS(7054),
    [anon_sym_begin] = ACTIONS(7054),
    [anon_sym_ensure] = ACTIONS(7054),
    [anon_sym_PLUS] = ACTIONS(7054),
    [anon_sym_defined_QMARK] = ACTIONS(7052),
    [anon_sym_not] = ACTIONS(7054),
    [anon_sym_BANG] = ACTIONS(7052),
    [anon_sym_TILDE] = ACTIONS(7052),
    [sym_constant] = ACTIONS(7054),
    [sym_identifier] = ACTIONS(7054),
    [sym_instance_variable] = ACTIONS(7052),
    [sym_class_variable] = ACTIONS(7052),
    [sym_global_variable] = ACTIONS(7052),
    [anon_sym_undef] = ACTIONS(7054),
    [anon_sym_alias] = ACTIONS(7054),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7054),
    [sym_float] = ACTIONS(7054),
    [sym_complex] = ACTIONS(7052),
    [sym_super] = ACTIONS(7054),
    [anon_sym_true] = ACTIONS(7054),
    [anon_sym_TRUE] = ACTIONS(7054),
    [anon_sym_false] = ACTIONS(7054),
    [anon_sym_FALSE] = ACTIONS(7054),
    [sym_self] = ACTIONS(7054),
    [anon_sym_nil] = ACTIONS(7054),
    [anon_sym_NIL] = ACTIONS(7054),
    [sym_character] = ACTIONS(7052),
    [anon_sym_LBRACK2] = ACTIONS(7052),
    [anon_sym_DASH_GT] = ACTIONS(7052),
  },
  [2091] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4421),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(4421),
    [sym_operator_assignment] = STATE(4421),
    [sym_conditional] = STATE(4421),
    [sym_range] = STATE(4421),
    [sym_binary] = STATE(4421),
    [sym_unary] = STATE(4421),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [2092] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4425),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(4425),
    [sym_operator_assignment] = STATE(4425),
    [sym_conditional] = STATE(4425),
    [sym_range] = STATE(4425),
    [sym_binary] = STATE(4425),
    [sym_unary] = STATE(4425),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [2093] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4426),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(4426),
    [sym_operator_assignment] = STATE(4426),
    [sym_conditional] = STATE(4426),
    [sym_range] = STATE(4426),
    [sym_binary] = STATE(4426),
    [sym_unary] = STATE(4426),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2094] = {
    [anon_sym_COLON] = ACTIONS(7086),
    [sym_comment] = ACTIONS(87),
  },
  [2095] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4429),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(4429),
    [sym_operator_assignment] = STATE(4429),
    [sym_conditional] = STATE(4429),
    [sym_range] = STATE(4429),
    [sym_binary] = STATE(4429),
    [sym_unary] = STATE(4429),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [2096] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4435),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(4436),
    [sym__argument] = STATE(4437),
    [sym_splat_argument] = STATE(4437),
    [sym_hash_splat_argument] = STATE(4437),
    [sym_block_argument] = STATE(4437),
    [sym_assignment] = STATE(4435),
    [sym_operator_assignment] = STATE(4435),
    [sym_conditional] = STATE(4435),
    [sym_range] = STATE(4435),
    [sym_binary] = STATE(4435),
    [sym_unary] = STATE(4435),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4438),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4437),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7088),
    [sym__splat_star] = ACTIONS(7090),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7092),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(7094),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(7096),
    [sym_identifier] = ACTIONS(7096),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2097] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4435),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(4436),
    [sym__argument] = STATE(4437),
    [sym_splat_argument] = STATE(4437),
    [sym_hash_splat_argument] = STATE(4437),
    [sym_block_argument] = STATE(4437),
    [sym_assignment] = STATE(4435),
    [sym_operator_assignment] = STATE(4435),
    [sym_conditional] = STATE(4435),
    [sym_range] = STATE(4435),
    [sym_binary] = STATE(4435),
    [sym_unary] = STATE(4435),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4438),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4437),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7088),
    [sym__splat_star] = ACTIONS(7090),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7092),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(7094),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(7096),
    [sym_identifier] = ACTIONS(7096),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2098] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4435),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(4436),
    [sym__argument] = STATE(4437),
    [sym_splat_argument] = STATE(4437),
    [sym_hash_splat_argument] = STATE(4437),
    [sym_block_argument] = STATE(4437),
    [sym_assignment] = STATE(4435),
    [sym_operator_assignment] = STATE(4435),
    [sym_conditional] = STATE(4435),
    [sym_range] = STATE(4435),
    [sym_binary] = STATE(4435),
    [sym_unary] = STATE(4435),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4438),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4437),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7088),
    [sym__splat_star] = ACTIONS(7090),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7092),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(7094),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(7096),
    [sym_identifier] = ACTIONS(7096),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2099] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4435),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(4436),
    [sym__argument] = STATE(4437),
    [sym_splat_argument] = STATE(4437),
    [sym_hash_splat_argument] = STATE(4437),
    [sym_block_argument] = STATE(4437),
    [sym_assignment] = STATE(4435),
    [sym_operator_assignment] = STATE(4435),
    [sym_conditional] = STATE(4435),
    [sym_range] = STATE(4435),
    [sym_binary] = STATE(4435),
    [sym_unary] = STATE(4435),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4438),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4437),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7088),
    [sym__splat_star] = ACTIONS(7090),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7092),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(7094),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(7096),
    [sym_identifier] = ACTIONS(7096),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2100] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4439),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(4439),
    [sym_operator_assignment] = STATE(4439),
    [sym_conditional] = STATE(4439),
    [sym_range] = STATE(4439),
    [sym_binary] = STATE(4439),
    [sym_unary] = STATE(4439),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2101] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2102] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7098),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2103] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(7086),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(7116),
    [anon_sym_or] = ACTIONS(7116),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [2104] = {
    [sym_heredoc_body] = STATE(4451),
    [aux_sym_call_repeat1] = STATE(4451),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_EQ] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2105] = {
    [sym_heredoc_body] = STATE(4451),
    [aux_sym_call_repeat1] = STATE(4451),
    [aux_sym_argument_list_repeat1] = STATE(4453),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_COMMA] = ACTIONS(7128),
    [anon_sym_EQ] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2106] = {
    [anon_sym_EQ] = ACTIONS(7130),
    [sym_comment] = ACTIONS(87),
  },
  [2107] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7132),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7134),
    [anon_sym_DASH_EQ] = ACTIONS(7134),
    [anon_sym_STAR_EQ] = ACTIONS(7134),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7134),
    [anon_sym_SLASH_EQ] = ACTIONS(7134),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7134),
    [anon_sym_PIPE_EQ] = ACTIONS(7134),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7134),
    [anon_sym_AMP_EQ] = ACTIONS(7134),
    [anon_sym_PERCENT_EQ] = ACTIONS(7134),
    [anon_sym_GT_GT_EQ] = ACTIONS(7134),
    [anon_sym_LT_LT_EQ] = ACTIONS(7134),
    [anon_sym_CARET_EQ] = ACTIONS(7134),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2108] = {
    [sym_string] = STATE(4456),
    [aux_sym_chained_string_repeat1] = STATE(4456),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7136),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2109] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4457),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(4457),
    [sym_operator_assignment] = STATE(4457),
    [sym_conditional] = STATE(4457),
    [sym_range] = STATE(4457),
    [sym_binary] = STATE(4457),
    [sym_unary] = STATE(4457),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2110] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(4458),
    [sym__argument] = STATE(4459),
    [sym_splat_argument] = STATE(4459),
    [sym_hash_splat_argument] = STATE(4459),
    [sym_block_argument] = STATE(4459),
    [sym_assignment] = STATE(699),
    [sym_operator_assignment] = STATE(699),
    [sym_conditional] = STATE(699),
    [sym_range] = STATE(699),
    [sym_binary] = STATE(699),
    [sym_unary] = STATE(699),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(705),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4459),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2111] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(4458),
    [sym__argument] = STATE(4459),
    [sym_splat_argument] = STATE(4459),
    [sym_hash_splat_argument] = STATE(4459),
    [sym_block_argument] = STATE(4459),
    [sym_assignment] = STATE(699),
    [sym_operator_assignment] = STATE(699),
    [sym_conditional] = STATE(699),
    [sym_range] = STATE(699),
    [sym_binary] = STATE(699),
    [sym_unary] = STATE(699),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(705),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4459),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2112] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(4458),
    [sym__argument] = STATE(4459),
    [sym_splat_argument] = STATE(4459),
    [sym_hash_splat_argument] = STATE(4459),
    [sym_block_argument] = STATE(4459),
    [sym_assignment] = STATE(699),
    [sym_operator_assignment] = STATE(699),
    [sym_conditional] = STATE(699),
    [sym_range] = STATE(699),
    [sym_binary] = STATE(699),
    [sym_unary] = STATE(699),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(705),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4459),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2113] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(4458),
    [sym__argument] = STATE(4459),
    [sym_splat_argument] = STATE(4459),
    [sym_hash_splat_argument] = STATE(4459),
    [sym_block_argument] = STATE(4459),
    [sym_assignment] = STATE(699),
    [sym_operator_assignment] = STATE(699),
    [sym_conditional] = STATE(699),
    [sym_range] = STATE(699),
    [sym_binary] = STATE(699),
    [sym_unary] = STATE(699),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(705),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4459),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2114] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4460),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(4460),
    [sym_operator_assignment] = STATE(4460),
    [sym_conditional] = STATE(4460),
    [sym_range] = STATE(4460),
    [sym_binary] = STATE(4460),
    [sym_unary] = STATE(4460),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2115] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2116] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7148),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [2117] = {
    [anon_sym_EQ] = ACTIONS(7164),
    [sym_comment] = ACTIONS(87),
  },
  [2118] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7166),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7168),
    [anon_sym_DASH_EQ] = ACTIONS(7168),
    [anon_sym_STAR_EQ] = ACTIONS(7168),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7168),
    [anon_sym_SLASH_EQ] = ACTIONS(7168),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7168),
    [anon_sym_PIPE_EQ] = ACTIONS(7168),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7168),
    [anon_sym_AMP_EQ] = ACTIONS(7168),
    [anon_sym_PERCENT_EQ] = ACTIONS(7168),
    [anon_sym_GT_GT_EQ] = ACTIONS(7168),
    [anon_sym_LT_LT_EQ] = ACTIONS(7168),
    [anon_sym_CARET_EQ] = ACTIONS(7168),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2119] = {
    [sym_string] = STATE(4473),
    [aux_sym_chained_string_repeat1] = STATE(4473),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2120] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7148),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [2121] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2122] = {
    [sym_string] = STATE(2160),
    [aux_sym_chained_string_repeat1] = STATE(2160),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2123] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4474),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(4474),
    [sym_operator_assignment] = STATE(4474),
    [sym_conditional] = STATE(4474),
    [sym_range] = STATE(4474),
    [sym_binary] = STATE(4474),
    [sym_unary] = STATE(4474),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2124] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7148),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [2125] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4475),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4475),
    [sym_operator_assignment] = STATE(4475),
    [sym_conditional] = STATE(4475),
    [sym_range] = STATE(4475),
    [sym_binary] = STATE(4475),
    [sym_unary] = STATE(4475),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2126] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4476),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4476),
    [sym_operator_assignment] = STATE(4476),
    [sym_conditional] = STATE(4476),
    [sym_range] = STATE(4476),
    [sym_binary] = STATE(4476),
    [sym_unary] = STATE(4476),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2127] = {
    [anon_sym_COLON] = ACTIONS(7170),
    [sym_comment] = ACTIONS(87),
  },
  [2128] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4478),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4478),
    [sym_operator_assignment] = STATE(4478),
    [sym_conditional] = STATE(4478),
    [sym_range] = STATE(4478),
    [sym_binary] = STATE(4478),
    [sym_unary] = STATE(4478),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2129] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7172),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2130] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [2131] = {
    [sym_heredoc_body] = STATE(4480),
    [aux_sym_call_repeat1] = STATE(4480),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2132] = {
    [sym_heredoc_body] = STATE(4480),
    [aux_sym_call_repeat1] = STATE(4480),
    [aux_sym_argument_list_repeat1] = STATE(4482),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(7174),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2133] = {
    [sym_string] = STATE(2160),
    [aux_sym_chained_string_repeat1] = STATE(2160),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7176),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2134] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [2135] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4483),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(4483),
    [sym_operator_assignment] = STATE(4483),
    [sym_conditional] = STATE(4483),
    [sym_range] = STATE(4483),
    [sym_binary] = STATE(4483),
    [sym_unary] = STATE(4483),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2136] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4484),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4484),
    [sym_operator_assignment] = STATE(4484),
    [sym_conditional] = STATE(4484),
    [sym_range] = STATE(4484),
    [sym_binary] = STATE(4484),
    [sym_unary] = STATE(4484),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2137] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4485),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4485),
    [sym_operator_assignment] = STATE(4485),
    [sym_conditional] = STATE(4485),
    [sym_range] = STATE(4485),
    [sym_binary] = STATE(4485),
    [sym_unary] = STATE(4485),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2138] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4486),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4486),
    [sym_operator_assignment] = STATE(4486),
    [sym_conditional] = STATE(4486),
    [sym_range] = STATE(4486),
    [sym_binary] = STATE(4486),
    [sym_unary] = STATE(4486),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2139] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4487),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4487),
    [sym_operator_assignment] = STATE(4487),
    [sym_conditional] = STATE(4487),
    [sym_range] = STATE(4487),
    [sym_binary] = STATE(4487),
    [sym_unary] = STATE(4487),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2140] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4488),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4488),
    [sym_operator_assignment] = STATE(4488),
    [sym_conditional] = STATE(4488),
    [sym_range] = STATE(4488),
    [sym_binary] = STATE(4488),
    [sym_unary] = STATE(4488),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2141] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4489),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4489),
    [sym_operator_assignment] = STATE(4489),
    [sym_conditional] = STATE(4489),
    [sym_range] = STATE(4489),
    [sym_binary] = STATE(4489),
    [sym_unary] = STATE(4489),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2142] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4490),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4490),
    [sym_operator_assignment] = STATE(4490),
    [sym_conditional] = STATE(4490),
    [sym_range] = STATE(4490),
    [sym_binary] = STATE(4490),
    [sym_unary] = STATE(4490),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2143] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4491),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4491),
    [sym_operator_assignment] = STATE(4491),
    [sym_conditional] = STATE(4491),
    [sym_range] = STATE(4491),
    [sym_binary] = STATE(4491),
    [sym_unary] = STATE(4491),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2144] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4492),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4492),
    [sym_operator_assignment] = STATE(4492),
    [sym_conditional] = STATE(4492),
    [sym_range] = STATE(4492),
    [sym_binary] = STATE(4492),
    [sym_unary] = STATE(4492),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2145] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4493),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4493),
    [sym_operator_assignment] = STATE(4493),
    [sym_conditional] = STATE(4493),
    [sym_range] = STATE(4493),
    [sym_binary] = STATE(4493),
    [sym_unary] = STATE(4493),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2146] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4494),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4494),
    [sym_operator_assignment] = STATE(4494),
    [sym_conditional] = STATE(4494),
    [sym_range] = STATE(4494),
    [sym_binary] = STATE(4494),
    [sym_unary] = STATE(4494),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2147] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4495),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4495),
    [sym_operator_assignment] = STATE(4495),
    [sym_conditional] = STATE(4495),
    [sym_range] = STATE(4495),
    [sym_binary] = STATE(4495),
    [sym_unary] = STATE(4495),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2148] = {
    [anon_sym_COLON] = ACTIONS(7178),
    [sym_comment] = ACTIONS(87),
  },
  [2149] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4497),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4497),
    [sym_operator_assignment] = STATE(4497),
    [sym_conditional] = STATE(4497),
    [sym_range] = STATE(4497),
    [sym_binary] = STATE(4497),
    [sym_unary] = STATE(4497),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2150] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7180),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2151] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [2152] = {
    [sym_heredoc_body] = STATE(4499),
    [aux_sym_call_repeat1] = STATE(4499),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2153] = {
    [sym_heredoc_body] = STATE(4499),
    [aux_sym_call_repeat1] = STATE(4499),
    [aux_sym_argument_list_repeat1] = STATE(4501),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(7182),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2154] = {
    [sym_string] = STATE(2213),
    [aux_sym_chained_string_repeat1] = STATE(2213),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7184),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2155] = {
    [sym_heredoc_body] = STATE(4502),
    [aux_sym_call_repeat1] = STATE(4502),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2156] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(699),
    [sym_operator_assignment] = STATE(699),
    [sym_conditional] = STATE(699),
    [sym_range] = STATE(699),
    [sym_binary] = STATE(699),
    [sym_unary] = STATE(699),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(705),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(4503),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7186),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2157] = {
    [sym_heredoc_body] = STATE(4504),
    [aux_sym_call_repeat1] = STATE(4504),
    [aux_sym_argument_list_repeat1] = STATE(4505),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2158] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4506),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_splat_argument] = STATE(4507),
    [sym_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(4506),
    [sym_range] = STATE(4506),
    [sym_binary] = STATE(4506),
    [sym_unary] = STATE(4506),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(4507),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(3618),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2159] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4508),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(4508),
    [sym_operator_assignment] = STATE(4508),
    [sym_conditional] = STATE(4508),
    [sym_range] = STATE(4508),
    [sym_binary] = STATE(4508),
    [sym_unary] = STATE(4508),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2160] = {
    [sym_string] = STATE(4509),
    [aux_sym_chained_string_repeat1] = STATE(4509),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [2161] = {
    [aux_sym_undef_repeat1] = STATE(4510),
    [sym__line_break] = ACTIONS(5356),
    [sym__heredoc_body_start] = ACTIONS(5356),
    [anon_sym_RPAREN] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [2162] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(5676),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2163] = {
    [sym_heredoc_body] = STATE(4511),
    [sym__terminator] = STATE(4511),
    [aux_sym__statements_repeat1] = STATE(2163),
    [sym__line_break] = ACTIONS(7188),
    [sym__heredoc_body_start] = ACTIONS(5683),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(7188),
    [sym_comment] = ACTIONS(87),
  },
  [2164] = {
    [sym__line_break] = ACTIONS(5686),
    [sym__heredoc_body_start] = ACTIONS(5686),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5686),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(1361),
    [anon_sym_or] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2165] = {
    [sym__line_break] = ACTIONS(5688),
    [sym__heredoc_body_start] = ACTIONS(5688),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5688),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(1361),
    [anon_sym_or] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2166] = {
    [sym__line_break] = ACTIONS(5690),
    [sym__heredoc_body_start] = ACTIONS(5690),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5690),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(1361),
    [anon_sym_or] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2167] = {
    [sym__line_break] = ACTIONS(5692),
    [sym__heredoc_body_start] = ACTIONS(5692),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5692),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(1361),
    [anon_sym_or] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2168] = {
    [sym__line_break] = ACTIONS(5694),
    [sym__heredoc_body_start] = ACTIONS(5694),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(1361),
    [anon_sym_or] = ACTIONS(1361),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2169] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2170] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [2171] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2172] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2173] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2174] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(7191),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [2175] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2176] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2177] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2178] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2179] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(4513),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(4513),
    [sym_operator_assignment] = STATE(4513),
    [sym_conditional] = STATE(4513),
    [sym_range] = STATE(4513),
    [sym_binary] = STATE(4513),
    [sym_unary] = STATE(4513),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2180] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(738),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(740),
    [sym__argument] = STATE(741),
    [sym_splat_argument] = STATE(741),
    [sym_hash_splat_argument] = STATE(741),
    [sym_block_argument] = STATE(741),
    [sym_assignment] = STATE(738),
    [sym_operator_assignment] = STATE(738),
    [sym_conditional] = STATE(738),
    [sym_range] = STATE(738),
    [sym_binary] = STATE(738),
    [sym_unary] = STATE(738),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(744),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(741),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1373),
    [sym__splat_star] = ACTIONS(1375),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1397),
    [sym_identifier] = ACTIONS(1397),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2181] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(738),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(740),
    [sym__argument] = STATE(741),
    [sym_splat_argument] = STATE(741),
    [sym_hash_splat_argument] = STATE(741),
    [sym_block_argument] = STATE(741),
    [sym_assignment] = STATE(738),
    [sym_operator_assignment] = STATE(738),
    [sym_conditional] = STATE(738),
    [sym_range] = STATE(738),
    [sym_binary] = STATE(738),
    [sym_unary] = STATE(738),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(744),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(741),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1373),
    [sym__splat_star] = ACTIONS(1375),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1397),
    [sym_identifier] = ACTIONS(1397),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2182] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(738),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(740),
    [sym__argument] = STATE(741),
    [sym_splat_argument] = STATE(741),
    [sym_hash_splat_argument] = STATE(741),
    [sym_block_argument] = STATE(741),
    [sym_assignment] = STATE(738),
    [sym_operator_assignment] = STATE(738),
    [sym_conditional] = STATE(738),
    [sym_range] = STATE(738),
    [sym_binary] = STATE(738),
    [sym_unary] = STATE(738),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(744),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(741),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1373),
    [sym__splat_star] = ACTIONS(1375),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1397),
    [sym_identifier] = ACTIONS(1397),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2183] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(738),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(740),
    [sym__argument] = STATE(741),
    [sym_splat_argument] = STATE(741),
    [sym_hash_splat_argument] = STATE(741),
    [sym_block_argument] = STATE(741),
    [sym_assignment] = STATE(738),
    [sym_operator_assignment] = STATE(738),
    [sym_conditional] = STATE(738),
    [sym_range] = STATE(738),
    [sym_binary] = STATE(738),
    [sym_unary] = STATE(738),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(744),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(741),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1373),
    [sym__splat_star] = ACTIONS(1375),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1397),
    [sym_identifier] = ACTIONS(1397),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2184] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(4514),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(4514),
    [sym_operator_assignment] = STATE(4514),
    [sym_conditional] = STATE(4514),
    [sym_range] = STATE(4514),
    [sym_binary] = STATE(4514),
    [sym_unary] = STATE(4514),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2185] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2186] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [2187] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(738),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(740),
    [sym__argument] = STATE(741),
    [sym_splat_argument] = STATE(741),
    [sym_hash_splat_argument] = STATE(741),
    [sym_block_argument] = STATE(741),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(738),
    [sym_operator_assignment] = STATE(738),
    [sym_conditional] = STATE(738),
    [sym_range] = STATE(738),
    [sym_binary] = STATE(738),
    [sym_unary] = STATE(738),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(744),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(741),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1373),
    [sym__splat_star] = ACTIONS(1375),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1397),
    [sym_identifier] = ACTIONS(1397),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2188] = {
    [anon_sym_EQ] = ACTIONS(7221),
    [sym_comment] = ACTIONS(87),
  },
  [2189] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7223),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7225),
    [anon_sym_DASH_EQ] = ACTIONS(7225),
    [anon_sym_STAR_EQ] = ACTIONS(7225),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7225),
    [anon_sym_SLASH_EQ] = ACTIONS(7225),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7225),
    [anon_sym_PIPE_EQ] = ACTIONS(7225),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7225),
    [anon_sym_AMP_EQ] = ACTIONS(7225),
    [anon_sym_PERCENT_EQ] = ACTIONS(7225),
    [anon_sym_GT_GT_EQ] = ACTIONS(7225),
    [anon_sym_LT_LT_EQ] = ACTIONS(7225),
    [anon_sym_CARET_EQ] = ACTIONS(7225),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2190] = {
    [sym_string] = STATE(4527),
    [aux_sym_chained_string_repeat1] = STATE(4527),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2191] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [2192] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [2193] = {
    [sym_string] = STATE(2213),
    [aux_sym_chained_string_repeat1] = STATE(2213),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2194] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(4528),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(4528),
    [sym_operator_assignment] = STATE(4528),
    [sym_conditional] = STATE(4528),
    [sym_range] = STATE(4528),
    [sym_binary] = STATE(4528),
    [sym_unary] = STATE(4528),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2195] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [2196] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [2197] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(4529),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(4529),
    [sym_operator_assignment] = STATE(4529),
    [sym_conditional] = STATE(4529),
    [sym_range] = STATE(4529),
    [sym_binary] = STATE(4529),
    [sym_unary] = STATE(4529),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2198] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4530),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4530),
    [sym_operator_assignment] = STATE(4530),
    [sym_conditional] = STATE(4530),
    [sym_range] = STATE(4530),
    [sym_binary] = STATE(4530),
    [sym_unary] = STATE(4530),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2199] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4531),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4531),
    [sym_operator_assignment] = STATE(4531),
    [sym_conditional] = STATE(4531),
    [sym_range] = STATE(4531),
    [sym_binary] = STATE(4531),
    [sym_unary] = STATE(4531),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2200] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4532),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4532),
    [sym_operator_assignment] = STATE(4532),
    [sym_conditional] = STATE(4532),
    [sym_range] = STATE(4532),
    [sym_binary] = STATE(4532),
    [sym_unary] = STATE(4532),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2201] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4533),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4533),
    [sym_operator_assignment] = STATE(4533),
    [sym_conditional] = STATE(4533),
    [sym_range] = STATE(4533),
    [sym_binary] = STATE(4533),
    [sym_unary] = STATE(4533),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2202] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4534),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4534),
    [sym_operator_assignment] = STATE(4534),
    [sym_conditional] = STATE(4534),
    [sym_range] = STATE(4534),
    [sym_binary] = STATE(4534),
    [sym_unary] = STATE(4534),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2203] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4535),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4535),
    [sym_operator_assignment] = STATE(4535),
    [sym_conditional] = STATE(4535),
    [sym_range] = STATE(4535),
    [sym_binary] = STATE(4535),
    [sym_unary] = STATE(4535),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2204] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4536),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4536),
    [sym_operator_assignment] = STATE(4536),
    [sym_conditional] = STATE(4536),
    [sym_range] = STATE(4536),
    [sym_binary] = STATE(4536),
    [sym_unary] = STATE(4536),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2205] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4537),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4537),
    [sym_operator_assignment] = STATE(4537),
    [sym_conditional] = STATE(4537),
    [sym_range] = STATE(4537),
    [sym_binary] = STATE(4537),
    [sym_unary] = STATE(4537),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2206] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4538),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4538),
    [sym_operator_assignment] = STATE(4538),
    [sym_conditional] = STATE(4538),
    [sym_range] = STATE(4538),
    [sym_binary] = STATE(4538),
    [sym_unary] = STATE(4538),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2207] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4539),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4539),
    [sym_operator_assignment] = STATE(4539),
    [sym_conditional] = STATE(4539),
    [sym_range] = STATE(4539),
    [sym_binary] = STATE(4539),
    [sym_unary] = STATE(4539),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2208] = {
    [sym_heredoc_body] = STATE(4540),
    [aux_sym_call_repeat1] = STATE(4540),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [2209] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(738),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(738),
    [sym_operator_assignment] = STATE(738),
    [sym_conditional] = STATE(738),
    [sym_range] = STATE(738),
    [sym_binary] = STATE(738),
    [sym_unary] = STATE(738),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(744),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(4541),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1373),
    [sym__splat_star] = ACTIONS(1375),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7227),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1397),
    [sym_identifier] = ACTIONS(1397),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2210] = {
    [sym_heredoc_body] = STATE(4542),
    [aux_sym_call_repeat1] = STATE(4542),
    [aux_sym_argument_list_repeat1] = STATE(4543),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(3732),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [2211] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4544),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_splat_argument] = STATE(4545),
    [sym_assignment] = STATE(4544),
    [sym_operator_assignment] = STATE(4544),
    [sym_conditional] = STATE(4544),
    [sym_range] = STATE(4544),
    [sym_binary] = STATE(4544),
    [sym_unary] = STATE(4544),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(4545),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(3654),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2212] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4546),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(4546),
    [sym_operator_assignment] = STATE(4546),
    [sym_conditional] = STATE(4546),
    [sym_range] = STATE(4546),
    [sym_binary] = STATE(4546),
    [sym_unary] = STATE(4546),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2213] = {
    [sym_string] = STATE(4547),
    [aux_sym_chained_string_repeat1] = STATE(4547),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [2214] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4548),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(4548),
    [sym_operator_assignment] = STATE(4548),
    [sym_conditional] = STATE(4548),
    [sym_range] = STATE(4548),
    [sym_binary] = STATE(4548),
    [sym_unary] = STATE(4548),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2215] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4549),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(4549),
    [sym_operator_assignment] = STATE(4549),
    [sym_conditional] = STATE(4549),
    [sym_range] = STATE(4549),
    [sym_binary] = STATE(4549),
    [sym_unary] = STATE(4549),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2216] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4550),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(4550),
    [sym_operator_assignment] = STATE(4550),
    [sym_conditional] = STATE(4550),
    [sym_range] = STATE(4550),
    [sym_binary] = STATE(4550),
    [sym_unary] = STATE(4550),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2217] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2218] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7233),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(7235),
    [anon_sym_LT] = ACTIONS(7237),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7239),
    [anon_sym_DOT_DOT] = ACTIONS(7241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7243),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7245),
    [anon_sym_AMP_AMP] = ACTIONS(7245),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(7249),
    [anon_sym_BANG_EQ] = ACTIONS(7245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7245),
    [anon_sym_LT_EQ_GT] = ACTIONS(7245),
    [anon_sym_EQ_TILDE] = ACTIONS(7245),
    [anon_sym_BANG_TILDE] = ACTIONS(7245),
    [anon_sym_LT_EQ] = ACTIONS(7237),
    [anon_sym_GT] = ACTIONS(7237),
    [anon_sym_GT_EQ] = ACTIONS(7251),
    [anon_sym_CARET] = ACTIONS(7253),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [2219] = {
    [aux_sym_exceptions_repeat1] = STATE(4562),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(7255),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [2220] = {
    [anon_sym_EQ] = ACTIONS(7257),
    [sym_comment] = ACTIONS(87),
  },
  [2221] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7259),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7261),
    [anon_sym_DASH_EQ] = ACTIONS(7261),
    [anon_sym_STAR_EQ] = ACTIONS(7261),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7261),
    [anon_sym_SLASH_EQ] = ACTIONS(7261),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7261),
    [anon_sym_PIPE_EQ] = ACTIONS(7261),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7261),
    [anon_sym_AMP_EQ] = ACTIONS(7261),
    [anon_sym_PERCENT_EQ] = ACTIONS(7261),
    [anon_sym_GT_GT_EQ] = ACTIONS(7261),
    [anon_sym_LT_LT_EQ] = ACTIONS(7261),
    [anon_sym_CARET_EQ] = ACTIONS(7261),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2222] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [2223] = {
    [sym_string] = STATE(2223),
    [aux_sym_chained_string_repeat1] = STATE(2223),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [2224] = {
    [sym__string_start] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(87),
  },
  [2225] = {
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_DOT] = ACTIONS(2907),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_unless] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_until] = ACTIONS(2907),
    [anon_sym_rescue] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_COLON_COLON2] = ACTIONS(2907),
    [anon_sym_AMP_DOT] = ACTIONS(2907),
    [sym_comment] = ACTIONS(87),
  },
  [2226] = {
    [anon_sym_DOT] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_COLON_COLON2] = ACTIONS(2911),
    [anon_sym_AMP_DOT] = ACTIONS(2911),
    [sym_comment] = ACTIONS(87),
  },
  [2227] = {
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_COLON_COLON2] = ACTIONS(2915),
    [anon_sym_AMP_DOT] = ACTIONS(2915),
    [sym_comment] = ACTIONS(87),
  },
  [2228] = {
    [anon_sym_DOT] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_COLON_COLON2] = ACTIONS(2921),
    [anon_sym_AMP_DOT] = ACTIONS(2921),
    [sym_comment] = ACTIONS(87),
  },
  [2229] = {
    [sym__string_end] = ACTIONS(7263),
    [sym_comment] = ACTIONS(87),
  },
  [2230] = {
    [aux_sym_string_array_repeat1] = STATE(4568),
    [sym__string_end] = ACTIONS(7265),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7267),
  },
  [2231] = {
    [anon_sym_DOT] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_COLON_COLON2] = ACTIONS(2931),
    [anon_sym_AMP_DOT] = ACTIONS(2931),
    [sym_comment] = ACTIONS(87),
  },
  [2232] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(7269),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [2233] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(7269),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7271),
  },
  [2234] = {
    [anon_sym_DOT] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_COLON_COLON2] = ACTIONS(2950),
    [anon_sym_AMP_DOT] = ACTIONS(2950),
    [sym_comment] = ACTIONS(87),
  },
  [2235] = {
    [sym__string_end] = ACTIONS(7273),
    [sym_comment] = ACTIONS(87),
  },
  [2236] = {
    [aux_sym_symbol_array_repeat1] = STATE(4574),
    [sym__string_end] = ACTIONS(7275),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7277),
  },
  [2237] = {
    [anon_sym_DOT] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_COLON_COLON2] = ACTIONS(2960),
    [anon_sym_AMP_DOT] = ACTIONS(2960),
    [sym_comment] = ACTIONS(87),
  },
  [2238] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(7279),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [2239] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(7279),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7281),
  },
  [2240] = {
    [anon_sym_DOT] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3440),
    [anon_sym_COLON_COLON2] = ACTIONS(3440),
    [anon_sym_AMP_DOT] = ACTIONS(3440),
    [sym_comment] = ACTIONS(87),
  },
  [2241] = {
    [anon_sym_RBRACE] = ACTIONS(7283),
    [sym_comment] = ACTIONS(87),
  },
  [2242] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(7285),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [2243] = {
    [sym__method_rest] = STATE(4579),
    [sym_operator] = STATE(770),
    [sym__method_name] = STATE(770),
    [sym_setter] = STATE(770),
    [sym_symbol] = STATE(770),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(7287),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(7287),
    [sym_class_variable] = ACTIONS(7287),
    [sym_global_variable] = ACTIONS(7287),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [2244] = {
    [sym__statements] = STATE(800),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(801),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(802),
    [sym_rescue] = STATE(803),
    [sym__body_statement] = STATE(4580),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7289),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2245] = {
    [anon_sym_DOT] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3670),
    [anon_sym_COLON_COLON2] = ACTIONS(3670),
    [anon_sym_AMP_DOT] = ACTIONS(3670),
    [sym_comment] = ACTIONS(87),
  },
  [2246] = {
    [sym_heredoc_body] = STATE(4581),
    [sym__terminator] = STATE(4581),
    [sym__line_break] = ACTIONS(7291),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(7291),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2247] = {
    [sym_heredoc_body] = STATE(4582),
    [sym__terminator] = STATE(4582),
    [sym__line_break] = ACTIONS(7293),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(7293),
    [sym_comment] = ACTIONS(87),
  },
  [2248] = {
    [sym__statements] = STATE(800),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(801),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(802),
    [sym_rescue] = STATE(803),
    [sym__body_statement] = STATE(4583),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7295),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2249] = {
    [anon_sym_DOT] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON_COLON2] = ACTIONS(4068),
    [anon_sym_AMP_DOT] = ACTIONS(4068),
    [sym_comment] = ACTIONS(87),
  },
  [2250] = {
    [sym__statements] = STATE(800),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(801),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(802),
    [sym_rescue] = STATE(803),
    [sym__body_statement] = STATE(4584),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7297),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2251] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4585),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(4585),
    [sym_operator_assignment] = STATE(4585),
    [sym_conditional] = STATE(4585),
    [sym_range] = STATE(4585),
    [sym_binary] = STATE(4585),
    [sym_unary] = STATE(4585),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2252] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4591),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(4592),
    [sym__argument] = STATE(4593),
    [sym_splat_argument] = STATE(4593),
    [sym_hash_splat_argument] = STATE(4593),
    [sym_block_argument] = STATE(4593),
    [sym_assignment] = STATE(4591),
    [sym_operator_assignment] = STATE(4591),
    [sym_conditional] = STATE(4591),
    [sym_range] = STATE(4591),
    [sym_binary] = STATE(4591),
    [sym_unary] = STATE(4591),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4594),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4593),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7299),
    [sym__splat_star] = ACTIONS(7301),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7303),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7305),
    [sym_identifier] = ACTIONS(7305),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2253] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4591),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(4592),
    [sym__argument] = STATE(4593),
    [sym_splat_argument] = STATE(4593),
    [sym_hash_splat_argument] = STATE(4593),
    [sym_block_argument] = STATE(4593),
    [sym_assignment] = STATE(4591),
    [sym_operator_assignment] = STATE(4591),
    [sym_conditional] = STATE(4591),
    [sym_range] = STATE(4591),
    [sym_binary] = STATE(4591),
    [sym_unary] = STATE(4591),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4594),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4593),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7299),
    [sym__splat_star] = ACTIONS(7301),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7303),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7305),
    [sym_identifier] = ACTIONS(7305),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2254] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4591),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(4592),
    [sym__argument] = STATE(4593),
    [sym_splat_argument] = STATE(4593),
    [sym_hash_splat_argument] = STATE(4593),
    [sym_block_argument] = STATE(4593),
    [sym_assignment] = STATE(4591),
    [sym_operator_assignment] = STATE(4591),
    [sym_conditional] = STATE(4591),
    [sym_range] = STATE(4591),
    [sym_binary] = STATE(4591),
    [sym_unary] = STATE(4591),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4594),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4593),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7299),
    [sym__splat_star] = ACTIONS(7301),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7303),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7305),
    [sym_identifier] = ACTIONS(7305),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2255] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4591),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(4592),
    [sym__argument] = STATE(4593),
    [sym_splat_argument] = STATE(4593),
    [sym_hash_splat_argument] = STATE(4593),
    [sym_block_argument] = STATE(4593),
    [sym_assignment] = STATE(4591),
    [sym_operator_assignment] = STATE(4591),
    [sym_conditional] = STATE(4591),
    [sym_range] = STATE(4591),
    [sym_binary] = STATE(4591),
    [sym_unary] = STATE(4591),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4594),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4593),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7299),
    [sym__splat_star] = ACTIONS(7301),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7303),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7305),
    [sym_identifier] = ACTIONS(7305),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2256] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4595),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(4595),
    [sym_operator_assignment] = STATE(4595),
    [sym_conditional] = STATE(4595),
    [sym_range] = STATE(4595),
    [sym_binary] = STATE(4595),
    [sym_unary] = STATE(4595),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2257] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2258] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(7323),
    [anon_sym_or] = ACTIONS(7323),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [2259] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4611),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(1827),
    [sym__argument_list_with_parens] = STATE(4612),
    [sym__argument] = STATE(4613),
    [sym_splat_argument] = STATE(4613),
    [sym_hash_splat_argument] = STATE(4613),
    [sym_block_argument] = STATE(4613),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(4611),
    [sym_operator_assignment] = STATE(4611),
    [sym_conditional] = STATE(4611),
    [sym_range] = STATE(4611),
    [sym_binary] = STATE(4611),
    [sym_unary] = STATE(4611),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4614),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4613),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7335),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(7339),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7341),
    [sym_identifier] = ACTIONS(7341),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2260] = {
    [anon_sym_EQ] = ACTIONS(7343),
    [sym_comment] = ACTIONS(87),
  },
  [2261] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7345),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7347),
    [anon_sym_DASH_EQ] = ACTIONS(7347),
    [anon_sym_STAR_EQ] = ACTIONS(7347),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7347),
    [anon_sym_SLASH_EQ] = ACTIONS(7347),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7347),
    [anon_sym_PIPE_EQ] = ACTIONS(7347),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7347),
    [anon_sym_AMP_EQ] = ACTIONS(7347),
    [anon_sym_PERCENT_EQ] = ACTIONS(7347),
    [anon_sym_GT_GT_EQ] = ACTIONS(7347),
    [anon_sym_LT_LT_EQ] = ACTIONS(7347),
    [anon_sym_CARET_EQ] = ACTIONS(7347),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2262] = {
    [sym_string] = STATE(4617),
    [aux_sym_chained_string_repeat1] = STATE(4617),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2263] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(7323),
    [anon_sym_or] = ACTIONS(7323),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [2264] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4618),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(4618),
    [sym_operator_assignment] = STATE(4618),
    [sym_conditional] = STATE(4618),
    [sym_range] = STATE(4618),
    [sym_binary] = STATE(4618),
    [sym_unary] = STATE(4618),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2265] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(7323),
    [anon_sym_or] = ACTIONS(7323),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [2266] = {
    [sym__heredoc_body_start] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4148),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4148),
    [anon_sym_in] = ACTIONS(4148),
    [anon_sym_do] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
  },
  [2267] = {
    [sym_heredoc_body] = STATE(4620),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(7349),
    [sym_comment] = ACTIONS(87),
  },
  [2268] = {
    [anon_sym_RPAREN] = ACTIONS(7349),
    [sym_comment] = ACTIONS(87),
  },
  [2269] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4621),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(4621),
    [sym_operator_assignment] = STATE(4621),
    [sym_conditional] = STATE(4621),
    [sym_range] = STATE(4621),
    [sym_binary] = STATE(4621),
    [sym_unary] = STATE(4621),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2270] = {
    [sym_interpolation] = STATE(4623),
    [aux_sym_heredoc_body_repeat1] = STATE(4623),
    [sym__heredoc_content] = ACTIONS(7351),
    [sym_heredoc_end] = ACTIONS(7353),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(7351),
  },
  [2271] = {
    [sym_heredoc_body] = STATE(4624),
    [aux_sym_call_repeat1] = STATE(4624),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2272] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(785),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym__argument] = STATE(4625),
    [sym_splat_argument] = STATE(4625),
    [sym_hash_splat_argument] = STATE(4625),
    [sym_block_argument] = STATE(4625),
    [sym_assignment] = STATE(785),
    [sym_operator_assignment] = STATE(785),
    [sym_conditional] = STATE(785),
    [sym_range] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(789),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4626),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4625),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1449),
    [sym__splat_star] = ACTIONS(1451),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1455),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1461),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2273] = {
    [sym_heredoc_body] = STATE(4627),
    [aux_sym_call_repeat1] = STATE(4627),
    [aux_sym_argument_list_repeat1] = STATE(4628),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(3826),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2274] = {
    [sym__statements] = STATE(4630),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(4631),
    [sym_else] = STATE(4631),
    [sym__if_tail] = STATE(4631),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(4632),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__terminator] = STATE(4632),
    [sym__line_break] = ACTIONS(7355),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7357),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2275] = {
    [sym__statements] = STATE(4634),
    [sym__top_level_statement] = STATE(2704),
    [sym_begin_block] = STATE(2704),
    [sym_end_block] = STATE(2704),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(4635),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7359),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2276] = {
    [sym__statements] = STATE(4637),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7361),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2277] = {
    [sym__statements] = STATE(4639),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7363),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2278] = {
    [sym__do] = STATE(4640),
    [sym_heredoc_body] = STATE(4640),
    [sym__terminator] = STATE(4640),
    [sym__line_break] = ACTIONS(7365),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(7365),
    [anon_sym_do] = ACTIONS(7365),
    [sym_comment] = ACTIONS(87),
  },
  [2279] = {
    [sym_when] = STATE(4641),
    [aux_sym_case_repeat1] = STATE(4642),
    [anon_sym_SEMI] = ACTIONS(7367),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [2280] = {
    [anon_sym_end] = ACTIONS(7369),
    [sym_comment] = ACTIONS(87),
  },
  [2281] = {
    [sym_when] = STATE(4641),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [2282] = {
    [anon_sym_DOT] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5264),
    [anon_sym_COLON_COLON2] = ACTIONS(5264),
    [anon_sym_AMP_DOT] = ACTIONS(5264),
    [sym_comment] = ACTIONS(87),
  },
  [2283] = {
    [sym_ensure] = STATE(4645),
    [anon_sym_end] = ACTIONS(7371),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [2284] = {
    [anon_sym_end] = ACTIONS(7371),
    [sym_comment] = ACTIONS(87),
  },
  [2285] = {
    [sym_else] = STATE(4646),
    [sym_ensure] = STATE(4645),
    [anon_sym_end] = ACTIONS(7371),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [2286] = {
    [anon_sym_DOT] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_COLON_COLON2] = ACTIONS(5350),
    [anon_sym_AMP_DOT] = ACTIONS(5350),
    [sym_comment] = ACTIONS(87),
  },
  [2287] = {
    [anon_sym_DOT] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON_COLON2] = ACTIONS(5582),
    [anon_sym_AMP_DOT] = ACTIONS(5582),
    [sym_comment] = ACTIONS(87),
  },
  [2288] = {
    [anon_sym_RBRACK] = ACTIONS(7373),
    [sym_comment] = ACTIONS(87),
  },
  [2289] = {
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5594),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5594),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_EQ] = ACTIONS(5594),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [sym_comment] = ACTIONS(87),
  },
  [2290] = {
    [anon_sym_RBRACE] = ACTIONS(7375),
    [sym_comment] = ACTIONS(87),
  },
  [2291] = {
    [sym__statements] = STATE(4649),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7375),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2292] = {
    [anon_sym_LBRACE] = ACTIONS(5630),
    [anon_sym_RPAREN] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_EQ] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5630),
    [anon_sym_do] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [sym_comment] = ACTIONS(87),
  },
  [2293] = {
    [anon_sym_end] = ACTIONS(7377),
    [sym_comment] = ACTIONS(87),
  },
  [2294] = {
    [sym__statements] = STATE(4651),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(4652),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(4652),
    [sym__line_break] = ACTIONS(7379),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7381),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2295] = {
    [sym__statements] = STATE(4651),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(4653),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7381),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2296] = {
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5666),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5666),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_do] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_COLON_COLON2] = ACTIONS(5666),
    [anon_sym_AMP_DOT] = ACTIONS(5666),
    [sym_comment] = ACTIONS(87),
  },
  [2297] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1263),
    [anon_sym_EQ] = ACTIONS(1263),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [2298] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(4655),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4656),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(7383),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2299] = {
    [sym__simple_symbol] = ACTIONS(5806),
    [sym__string_start] = ACTIONS(5806),
    [sym__symbol_start] = ACTIONS(5806),
    [sym__subshell_start] = ACTIONS(5806),
    [sym__regex_start] = ACTIONS(5806),
    [sym__string_array_start] = ACTIONS(5806),
    [sym__symbol_array_start] = ACTIONS(5806),
    [sym_heredoc_beginning] = ACTIONS(5806),
    [sym__block_ampersand] = ACTIONS(5806),
    [sym__splat_star] = ACTIONS(5806),
    [sym__unary_minus] = ACTIONS(5806),
    [sym__identifier_hash_key] = ACTIONS(5806),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_def] = ACTIONS(5808),
    [anon_sym_LPAREN] = ACTIONS(5808),
    [anon_sym_RPAREN] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5806),
    [anon_sym_COLON_COLON] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5806),
    [anon_sym_EQ] = ACTIONS(5806),
    [anon_sym_class] = ACTIONS(5808),
    [anon_sym_module] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_yield] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_next] = ACTIONS(5808),
    [sym_redo] = ACTIONS(5808),
    [sym_retry] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_unless] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_until] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_in] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_begin] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_COLON_COLON2] = ACTIONS(5806),
    [anon_sym_AMP_DOT] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_defined_QMARK] = ACTIONS(5806),
    [anon_sym_not] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5806),
    [sym_constant] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_instance_variable] = ACTIONS(5806),
    [sym_class_variable] = ACTIONS(5806),
    [sym_global_variable] = ACTIONS(5806),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5808),
    [sym_float] = ACTIONS(5808),
    [sym_complex] = ACTIONS(5806),
    [sym_super] = ACTIONS(5808),
    [anon_sym_true] = ACTIONS(5808),
    [anon_sym_TRUE] = ACTIONS(5808),
    [anon_sym_false] = ACTIONS(5808),
    [anon_sym_FALSE] = ACTIONS(5808),
    [sym_self] = ACTIONS(5808),
    [anon_sym_nil] = ACTIONS(5808),
    [anon_sym_NIL] = ACTIONS(5808),
    [sym_character] = ACTIONS(5806),
    [anon_sym_LBRACK2] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5806),
  },
  [2300] = {
    [sym__simple_symbol] = ACTIONS(5810),
    [sym__string_start] = ACTIONS(5810),
    [sym__symbol_start] = ACTIONS(5810),
    [sym__subshell_start] = ACTIONS(5810),
    [sym__regex_start] = ACTIONS(5810),
    [sym__string_array_start] = ACTIONS(5810),
    [sym__symbol_array_start] = ACTIONS(5810),
    [sym_heredoc_beginning] = ACTIONS(5810),
    [sym__block_ampersand] = ACTIONS(5810),
    [sym__splat_star] = ACTIONS(5810),
    [sym__unary_minus] = ACTIONS(5810),
    [sym__identifier_hash_key] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_def] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(5812),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5810),
    [anon_sym_COLON_COLON] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_STAR_STAR] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_class] = ACTIONS(5812),
    [anon_sym_module] = ACTIONS(5812),
    [anon_sym_return] = ACTIONS(5812),
    [anon_sym_yield] = ACTIONS(5812),
    [anon_sym_break] = ACTIONS(5812),
    [anon_sym_next] = ACTIONS(5812),
    [sym_redo] = ACTIONS(5812),
    [sym_retry] = ACTIONS(5812),
    [anon_sym_if] = ACTIONS(5812),
    [anon_sym_unless] = ACTIONS(5812),
    [anon_sym_while] = ACTIONS(5812),
    [anon_sym_until] = ACTIONS(5812),
    [anon_sym_for] = ACTIONS(5812),
    [anon_sym_in] = ACTIONS(5812),
    [anon_sym_do] = ACTIONS(5812),
    [anon_sym_case] = ACTIONS(5812),
    [anon_sym_begin] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_COLON_COLON2] = ACTIONS(5810),
    [anon_sym_AMP_DOT] = ACTIONS(5810),
    [anon_sym_LPAREN2] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [anon_sym_defined_QMARK] = ACTIONS(5810),
    [anon_sym_not] = ACTIONS(5812),
    [anon_sym_BANG] = ACTIONS(5810),
    [anon_sym_TILDE] = ACTIONS(5810),
    [sym_constant] = ACTIONS(5812),
    [sym_identifier] = ACTIONS(5812),
    [sym_instance_variable] = ACTIONS(5810),
    [sym_class_variable] = ACTIONS(5810),
    [sym_global_variable] = ACTIONS(5810),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5812),
    [sym_float] = ACTIONS(5812),
    [sym_complex] = ACTIONS(5810),
    [sym_super] = ACTIONS(5812),
    [anon_sym_true] = ACTIONS(5812),
    [anon_sym_TRUE] = ACTIONS(5812),
    [anon_sym_false] = ACTIONS(5812),
    [anon_sym_FALSE] = ACTIONS(5812),
    [sym_self] = ACTIONS(5812),
    [anon_sym_nil] = ACTIONS(5812),
    [anon_sym_NIL] = ACTIONS(5812),
    [sym_character] = ACTIONS(5810),
    [anon_sym_LBRACK2] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5810),
  },
  [2301] = {
    [sym_argument_list_with_parens] = STATE(4657),
    [sym__argument_list_with_parens] = STATE(2300),
    [sym_operator] = STATE(4657),
    [sym_heredoc_body] = STATE(3546),
    [aux_sym_call_repeat1] = STATE(3546),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(3856),
    [anon_sym_STAR] = ACTIONS(3858),
    [anon_sym_STAR_STAR] = ACTIONS(3856),
    [anon_sym_AMP] = ACTIONS(3856),
    [anon_sym_LT] = ACTIONS(3858),
    [anon_sym_LPAREN2] = ACTIONS(3860),
    [anon_sym_DOT_DOT] = ACTIONS(3856),
    [anon_sym_LT_LT] = ACTIONS(3856),
    [anon_sym_GT_GT] = ACTIONS(3856),
    [anon_sym_EQ_EQ] = ACTIONS(3858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3856),
    [anon_sym_LT_EQ_GT] = ACTIONS(3856),
    [anon_sym_EQ_TILDE] = ACTIONS(3856),
    [anon_sym_BANG_TILDE] = ACTIONS(3856),
    [anon_sym_LT_EQ] = ACTIONS(3858),
    [anon_sym_GT] = ACTIONS(3858),
    [anon_sym_GT_EQ] = ACTIONS(3856),
    [anon_sym_CARET] = ACTIONS(3856),
    [anon_sym_PLUS] = ACTIONS(3858),
    [anon_sym_SLASH] = ACTIONS(3856),
    [anon_sym_PERCENT] = ACTIONS(3856),
    [anon_sym_BANG] = ACTIONS(3858),
    [anon_sym_TILDE] = ACTIONS(3856),
    [sym_constant] = ACTIONS(7385),
    [sym_identifier] = ACTIONS(7385),
    [anon_sym_DASH] = ACTIONS(3858),
    [anon_sym_PLUS_AT] = ACTIONS(3856),
    [anon_sym_DASH_AT] = ACTIONS(3856),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3858),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3856),
    [anon_sym_BQUOTE] = ACTIONS(3856),
    [sym_comment] = ACTIONS(87),
  },
  [2302] = {
    [anon_sym_RPAREN] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_COMMA] = ACTIONS(5816),
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_in] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_COLON_COLON2] = ACTIONS(5816),
    [anon_sym_AMP_DOT] = ACTIONS(5816),
    [sym_comment] = ACTIONS(87),
  },
  [2303] = {
    [sym_heredoc_body] = STATE(4659),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(7387),
    [sym_comment] = ACTIONS(87),
  },
  [2304] = {
    [anon_sym_RBRACK] = ACTIONS(7387),
    [sym_comment] = ACTIONS(87),
  },
  [2305] = {
    [sym__simple_symbol] = ACTIONS(5822),
    [sym__string_start] = ACTIONS(5822),
    [sym__symbol_start] = ACTIONS(5822),
    [sym__subshell_start] = ACTIONS(5822),
    [sym__regex_start] = ACTIONS(5822),
    [sym__string_array_start] = ACTIONS(5822),
    [sym__symbol_array_start] = ACTIONS(5822),
    [sym_heredoc_beginning] = ACTIONS(5822),
    [sym__block_ampersand] = ACTIONS(5822),
    [sym__splat_star] = ACTIONS(5822),
    [sym__unary_minus] = ACTIONS(5822),
    [sym__identifier_hash_key] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_def] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5822),
    [anon_sym_COLON_COLON] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_STAR_STAR] = ACTIONS(5822),
    [anon_sym_EQ] = ACTIONS(5822),
    [anon_sym_class] = ACTIONS(5824),
    [anon_sym_module] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(5824),
    [anon_sym_break] = ACTIONS(5824),
    [anon_sym_next] = ACTIONS(5824),
    [sym_redo] = ACTIONS(5824),
    [sym_retry] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5824),
    [anon_sym_unless] = ACTIONS(5824),
    [anon_sym_while] = ACTIONS(5824),
    [anon_sym_until] = ACTIONS(5824),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_in] = ACTIONS(5824),
    [anon_sym_do] = ACTIONS(5824),
    [anon_sym_case] = ACTIONS(5824),
    [anon_sym_begin] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_LPAREN2] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_defined_QMARK] = ACTIONS(5822),
    [anon_sym_not] = ACTIONS(5824),
    [anon_sym_BANG] = ACTIONS(5822),
    [anon_sym_TILDE] = ACTIONS(5822),
    [sym_constant] = ACTIONS(5824),
    [sym_identifier] = ACTIONS(5824),
    [sym_instance_variable] = ACTIONS(5822),
    [sym_class_variable] = ACTIONS(5822),
    [sym_global_variable] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5824),
    [sym_float] = ACTIONS(5824),
    [sym_complex] = ACTIONS(5822),
    [sym_super] = ACTIONS(5824),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_TRUE] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [anon_sym_FALSE] = ACTIONS(5824),
    [sym_self] = ACTIONS(5824),
    [anon_sym_nil] = ACTIONS(5824),
    [anon_sym_NIL] = ACTIONS(5824),
    [sym_character] = ACTIONS(5822),
    [anon_sym_LBRACK2] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5822),
  },
  [2306] = {
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [2307] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(4661),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(7389),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2308] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(4663),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(7391),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2309] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(4665),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(7393),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2310] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(4667),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(7395),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2311] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(4670),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(7397),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7399),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [2312] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(4673),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(7401),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7403),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [2313] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4674),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(4674),
    [sym_operator_assignment] = STATE(4674),
    [sym_conditional] = STATE(4674),
    [sym_range] = STATE(4674),
    [sym_binary] = STATE(4674),
    [sym_unary] = STATE(4674),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [2314] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(4676),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(4677),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(7405),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2315] = {
    [sym__method_rest] = STATE(4679),
    [sym__variable] = STATE(4680),
    [sym_operator] = STATE(4681),
    [sym__method_name] = STATE(4681),
    [sym_setter] = STATE(4681),
    [sym_symbol] = STATE(4681),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(7407),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(7409),
    [sym_self] = ACTIONS(7409),
  },
  [2316] = {
    [sym__statements] = STATE(4683),
    [sym__top_level_statement] = STATE(144),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(149),
    [sym__simple_mlhs] = STATE(150),
    [sym_destructured_left_assignment] = STATE(150),
    [sym_rest_assignment] = STATE(150),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(7411),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2317] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(4686),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(7413),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(7415),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [2318] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(4688),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(7417),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [2319] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4695),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_argument_list] = STATE(4696),
    [sym__argument_list_with_parens] = STATE(4697),
    [sym__argument] = STATE(4698),
    [sym_splat_argument] = STATE(4698),
    [sym_hash_splat_argument] = STATE(4698),
    [sym_block_argument] = STATE(4698),
    [sym_assignment] = STATE(4695),
    [sym_operator_assignment] = STATE(4695),
    [sym_conditional] = STATE(4695),
    [sym_range] = STATE(4695),
    [sym_binary] = STATE(4695),
    [sym_unary] = STATE(4695),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4699),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4698),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7419),
    [sym__splat_star] = ACTIONS(7421),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7423),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(7425),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(7427),
    [sym_identifier] = ACTIONS(7427),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2320] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4695),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_argument_list] = STATE(4700),
    [sym__argument_list_with_parens] = STATE(4697),
    [sym__argument] = STATE(4698),
    [sym_splat_argument] = STATE(4698),
    [sym_hash_splat_argument] = STATE(4698),
    [sym_block_argument] = STATE(4698),
    [sym_assignment] = STATE(4695),
    [sym_operator_assignment] = STATE(4695),
    [sym_conditional] = STATE(4695),
    [sym_range] = STATE(4695),
    [sym_binary] = STATE(4695),
    [sym_unary] = STATE(4695),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4699),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4698),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7419),
    [sym__splat_star] = ACTIONS(7421),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7423),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(7425),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(7427),
    [sym_identifier] = ACTIONS(7427),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2321] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4695),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_argument_list] = STATE(4701),
    [sym__argument_list_with_parens] = STATE(4697),
    [sym__argument] = STATE(4698),
    [sym_splat_argument] = STATE(4698),
    [sym_hash_splat_argument] = STATE(4698),
    [sym_block_argument] = STATE(4698),
    [sym_assignment] = STATE(4695),
    [sym_operator_assignment] = STATE(4695),
    [sym_conditional] = STATE(4695),
    [sym_range] = STATE(4695),
    [sym_binary] = STATE(4695),
    [sym_unary] = STATE(4695),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4699),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4698),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7419),
    [sym__splat_star] = ACTIONS(7421),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7423),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(7425),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(7427),
    [sym_identifier] = ACTIONS(7427),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2322] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4695),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_argument_list] = STATE(4702),
    [sym__argument_list_with_parens] = STATE(4697),
    [sym__argument] = STATE(4698),
    [sym_splat_argument] = STATE(4698),
    [sym_hash_splat_argument] = STATE(4698),
    [sym_block_argument] = STATE(4698),
    [sym_assignment] = STATE(4695),
    [sym_operator_assignment] = STATE(4695),
    [sym_conditional] = STATE(4695),
    [sym_range] = STATE(4695),
    [sym_binary] = STATE(4695),
    [sym_unary] = STATE(4695),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4699),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4698),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7419),
    [sym__splat_star] = ACTIONS(7421),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7423),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(7425),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(3944),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(7427),
    [sym_identifier] = ACTIONS(7427),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2323] = {
    [sym__statement] = STATE(4703),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(4703),
    [sym_unless_modifier] = STATE(4703),
    [sym_while_modifier] = STATE(4703),
    [sym_until_modifier] = STATE(4703),
    [sym_rescue_modifier] = STATE(4703),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(4703),
    [sym_alias] = STATE(4703),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(4703),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2324] = {
    [sym__statement] = STATE(4704),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(4704),
    [sym_unless_modifier] = STATE(4704),
    [sym_while_modifier] = STATE(4704),
    [sym_until_modifier] = STATE(4704),
    [sym_rescue_modifier] = STATE(4704),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(4704),
    [sym_alias] = STATE(4704),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(4704),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2325] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4705),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(4705),
    [sym_operator_assignment] = STATE(4705),
    [sym_conditional] = STATE(4705),
    [sym_range] = STATE(4705),
    [sym_binary] = STATE(4705),
    [sym_unary] = STATE(4705),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2326] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4706),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(4706),
    [sym_operator_assignment] = STATE(4706),
    [sym_conditional] = STATE(4706),
    [sym_range] = STATE(4706),
    [sym_binary] = STATE(4706),
    [sym_unary] = STATE(4706),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2327] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(4707),
    [sym__simple_mlhs] = STATE(257),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [2328] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4708),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(4708),
    [sym_operator_assignment] = STATE(4708),
    [sym_conditional] = STATE(4708),
    [sym_range] = STATE(4708),
    [sym_binary] = STATE(4708),
    [sym_unary] = STATE(4708),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(4709),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__terminator] = STATE(4709),
    [sym__line_break] = ACTIONS(7429),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(7429),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2329] = {
    [sym__statements] = STATE(4710),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(4711),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(4712),
    [sym_rescue] = STATE(4713),
    [sym__body_statement] = STATE(4714),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(4715),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__terminator] = STATE(4715),
    [sym__line_break] = ACTIONS(7431),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7433),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2330] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4716),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(4716),
    [sym_operator_assignment] = STATE(4716),
    [sym_conditional] = STATE(4716),
    [sym_range] = STATE(4716),
    [sym_binary] = STATE(4716),
    [sym_unary] = STATE(4716),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [2331] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4717),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(4717),
    [sym_operator_assignment] = STATE(4717),
    [sym_conditional] = STATE(4717),
    [sym_range] = STATE(4717),
    [sym_binary] = STATE(4717),
    [sym_unary] = STATE(4717),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [2332] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(7435),
  },
  [2333] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(4720),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4721),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(7437),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2334] = {
    [sym_lambda_parameters] = STATE(4724),
    [sym__simple_formal_parameter] = STATE(364),
    [sym_splat_parameter] = STATE(364),
    [sym_hash_splat_parameter] = STATE(364),
    [sym_block_parameter] = STATE(364),
    [sym_keyword_parameter] = STATE(364),
    [sym_optional_parameter] = STATE(364),
    [sym_do_block] = STATE(4725),
    [sym_block] = STATE(4725),
    [anon_sym_LBRACE] = ACTIONS(7439),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(7441),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [2335] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(7459),
    [anon_sym_or] = ACTIONS(7459),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [2336] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4611),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(4737),
    [sym__argument_list_with_parens] = STATE(4612),
    [sym__argument] = STATE(4613),
    [sym_splat_argument] = STATE(4613),
    [sym_hash_splat_argument] = STATE(4613),
    [sym_block_argument] = STATE(4613),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(4611),
    [sym_operator_assignment] = STATE(4611),
    [sym_conditional] = STATE(4611),
    [sym_range] = STATE(4611),
    [sym_binary] = STATE(4611),
    [sym_unary] = STATE(4611),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4614),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4613),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7335),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(7339),
    [anon_sym_LBRACE] = ACTIONS(7471),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7341),
    [sym_identifier] = ACTIONS(7341),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2337] = {
    [anon_sym_EQ] = ACTIONS(7473),
    [sym_comment] = ACTIONS(87),
  },
  [2338] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7475),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7477),
    [anon_sym_DASH_EQ] = ACTIONS(7477),
    [anon_sym_STAR_EQ] = ACTIONS(7477),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7477),
    [anon_sym_SLASH_EQ] = ACTIONS(7477),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7477),
    [anon_sym_PIPE_EQ] = ACTIONS(7477),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7477),
    [anon_sym_AMP_EQ] = ACTIONS(7477),
    [anon_sym_PERCENT_EQ] = ACTIONS(7477),
    [anon_sym_GT_GT_EQ] = ACTIONS(7477),
    [anon_sym_LT_LT_EQ] = ACTIONS(7477),
    [anon_sym_CARET_EQ] = ACTIONS(7477),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2339] = {
    [sym_string] = STATE(4740),
    [aux_sym_chained_string_repeat1] = STATE(4740),
    [sym__string_start] = ACTIONS(3870),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2340] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(7459),
    [anon_sym_or] = ACTIONS(7459),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [2341] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2342] = {
    [sym_string] = STATE(2373),
    [aux_sym_chained_string_repeat1] = STATE(2373),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2343] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4741),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(4741),
    [sym_operator_assignment] = STATE(4741),
    [sym_conditional] = STATE(4741),
    [sym_range] = STATE(4741),
    [sym_binary] = STATE(4741),
    [sym_unary] = STATE(4741),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [2344] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [2345] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(7459),
    [anon_sym_or] = ACTIONS(7459),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [2346] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4742),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4742),
    [sym_operator_assignment] = STATE(4742),
    [sym_conditional] = STATE(4742),
    [sym_range] = STATE(4742),
    [sym_binary] = STATE(4742),
    [sym_unary] = STATE(4742),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2347] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4743),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4743),
    [sym_operator_assignment] = STATE(4743),
    [sym_conditional] = STATE(4743),
    [sym_range] = STATE(4743),
    [sym_binary] = STATE(4743),
    [sym_unary] = STATE(4743),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2348] = {
    [anon_sym_COLON] = ACTIONS(7479),
    [sym_comment] = ACTIONS(87),
  },
  [2349] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4745),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4745),
    [sym_operator_assignment] = STATE(4745),
    [sym_conditional] = STATE(4745),
    [sym_range] = STATE(4745),
    [sym_binary] = STATE(4745),
    [sym_unary] = STATE(4745),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2350] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7481),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2351] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [2352] = {
    [sym_heredoc_body] = STATE(4747),
    [aux_sym_call_repeat1] = STATE(4747),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2353] = {
    [sym_heredoc_body] = STATE(4747),
    [aux_sym_call_repeat1] = STATE(4747),
    [aux_sym_argument_list_repeat1] = STATE(4749),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(7483),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2354] = {
    [sym_string] = STATE(2373),
    [aux_sym_chained_string_repeat1] = STATE(2373),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7485),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2355] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [2356] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4750),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(4750),
    [sym_operator_assignment] = STATE(4750),
    [sym_conditional] = STATE(4750),
    [sym_range] = STATE(4750),
    [sym_binary] = STATE(4750),
    [sym_unary] = STATE(4750),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [2357] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4751),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4751),
    [sym_operator_assignment] = STATE(4751),
    [sym_conditional] = STATE(4751),
    [sym_range] = STATE(4751),
    [sym_binary] = STATE(4751),
    [sym_unary] = STATE(4751),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2358] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4752),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4752),
    [sym_operator_assignment] = STATE(4752),
    [sym_conditional] = STATE(4752),
    [sym_range] = STATE(4752),
    [sym_binary] = STATE(4752),
    [sym_unary] = STATE(4752),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2359] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4753),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4753),
    [sym_operator_assignment] = STATE(4753),
    [sym_conditional] = STATE(4753),
    [sym_range] = STATE(4753),
    [sym_binary] = STATE(4753),
    [sym_unary] = STATE(4753),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2360] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4754),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4754),
    [sym_operator_assignment] = STATE(4754),
    [sym_conditional] = STATE(4754),
    [sym_range] = STATE(4754),
    [sym_binary] = STATE(4754),
    [sym_unary] = STATE(4754),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2361] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4755),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4755),
    [sym_operator_assignment] = STATE(4755),
    [sym_conditional] = STATE(4755),
    [sym_range] = STATE(4755),
    [sym_binary] = STATE(4755),
    [sym_unary] = STATE(4755),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2362] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4756),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4756),
    [sym_operator_assignment] = STATE(4756),
    [sym_conditional] = STATE(4756),
    [sym_range] = STATE(4756),
    [sym_binary] = STATE(4756),
    [sym_unary] = STATE(4756),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2363] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4757),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4757),
    [sym_operator_assignment] = STATE(4757),
    [sym_conditional] = STATE(4757),
    [sym_range] = STATE(4757),
    [sym_binary] = STATE(4757),
    [sym_unary] = STATE(4757),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2364] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4758),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4758),
    [sym_operator_assignment] = STATE(4758),
    [sym_conditional] = STATE(4758),
    [sym_range] = STATE(4758),
    [sym_binary] = STATE(4758),
    [sym_unary] = STATE(4758),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2365] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4759),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4759),
    [sym_operator_assignment] = STATE(4759),
    [sym_conditional] = STATE(4759),
    [sym_range] = STATE(4759),
    [sym_binary] = STATE(4759),
    [sym_unary] = STATE(4759),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2366] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4760),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4760),
    [sym_operator_assignment] = STATE(4760),
    [sym_conditional] = STATE(4760),
    [sym_range] = STATE(4760),
    [sym_binary] = STATE(4760),
    [sym_unary] = STATE(4760),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2367] = {
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_DOT] = ACTIONS(6024),
    [anon_sym_COMMA] = ACTIONS(6024),
    [anon_sym_EQ] = ACTIONS(6024),
    [anon_sym_in] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_COLON_COLON2] = ACTIONS(6024),
    [anon_sym_AMP_DOT] = ACTIONS(6024),
    [sym_comment] = ACTIONS(87),
  },
  [2368] = {
    [sym_heredoc_body] = STATE(4761),
    [aux_sym_call_repeat1] = STATE(4761),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2369] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(830),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym__argument] = STATE(4625),
    [sym_splat_argument] = STATE(4625),
    [sym_hash_splat_argument] = STATE(4625),
    [sym_block_argument] = STATE(4625),
    [sym_assignment] = STATE(830),
    [sym_operator_assignment] = STATE(830),
    [sym_conditional] = STATE(830),
    [sym_range] = STATE(830),
    [sym_binary] = STATE(830),
    [sym_unary] = STATE(830),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(837),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4762),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4625),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1483),
    [sym__splat_star] = ACTIONS(1485),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__identifier_hash_key] = ACTIONS(1489),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1493),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1511),
    [sym_identifier] = ACTIONS(1511),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2370] = {
    [sym_heredoc_body] = STATE(4763),
    [aux_sym_call_repeat1] = STATE(4763),
    [aux_sym_argument_list_repeat1] = STATE(4764),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(3978),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2371] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4765),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_splat_argument] = STATE(4766),
    [sym_assignment] = STATE(4765),
    [sym_operator_assignment] = STATE(4765),
    [sym_conditional] = STATE(4765),
    [sym_range] = STATE(4765),
    [sym_binary] = STATE(4765),
    [sym_unary] = STATE(4765),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(4766),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(3940),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2372] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4767),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(4767),
    [sym_operator_assignment] = STATE(4767),
    [sym_conditional] = STATE(4767),
    [sym_range] = STATE(4767),
    [sym_binary] = STATE(4767),
    [sym_unary] = STATE(4767),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2373] = {
    [sym_string] = STATE(4768),
    [aux_sym_chained_string_repeat1] = STATE(4768),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [2374] = {
    [sym_string] = STATE(2374),
    [aux_sym_chained_string_repeat1] = STATE(2374),
    [sym__string_start] = ACTIONS(7487),
    [anon_sym_DOT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [2375] = {
    [sym__statements] = STATE(285),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(288),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(289),
    [sym_rescue] = STATE(290),
    [sym__body_statement] = STATE(4769),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7490),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2376] = {
    [sym__line_break] = ACTIONS(7492),
    [sym__heredoc_body_start] = ACTIONS(7492),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(7492),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2377] = {
    [sym__statements] = STATE(285),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(288),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(289),
    [sym_rescue] = STATE(290),
    [sym__body_statement] = STATE(4770),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7494),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2378] = {
    [sym__line_break] = ACTIONS(7496),
    [sym__heredoc_body_start] = ACTIONS(7496),
    [sym__binary_minus] = ACTIONS(7496),
    [sym__binary_star] = ACTIONS(7496),
    [ts_builtin_sym_end] = ACTIONS(7496),
    [anon_sym___END__] = ACTIONS(7496),
    [anon_sym_LBRACE] = ACTIONS(7496),
    [anon_sym_RBRACE] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(7496),
    [anon_sym_DOT] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_end] = ACTIONS(7496),
    [anon_sym_if] = ACTIONS(7496),
    [anon_sym_unless] = ACTIONS(7496),
    [anon_sym_while] = ACTIONS(7496),
    [anon_sym_until] = ACTIONS(7496),
    [anon_sym_rescue] = ACTIONS(7496),
    [anon_sym_do] = ACTIONS(7496),
    [anon_sym_when] = ACTIONS(7496),
    [anon_sym_elsif] = ACTIONS(7496),
    [anon_sym_else] = ACTIONS(7496),
    [anon_sym_then] = ACTIONS(7496),
    [anon_sym_ensure] = ACTIONS(7496),
    [anon_sym_EQ_GT] = ACTIONS(7496),
    [anon_sym_LBRACK] = ACTIONS(7496),
    [anon_sym_COLON_COLON2] = ACTIONS(7496),
    [anon_sym_AMP_DOT] = ACTIONS(7496),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_DOT_DOT] = ACTIONS(7498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7496),
    [anon_sym_and] = ACTIONS(7496),
    [anon_sym_or] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT_LT] = ACTIONS(7496),
    [anon_sym_GT_GT] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7498),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7496),
    [anon_sym_LT_EQ_GT] = ACTIONS(7496),
    [anon_sym_EQ_TILDE] = ACTIONS(7496),
    [anon_sym_BANG_TILDE] = ACTIONS(7496),
    [anon_sym_LT_EQ] = ACTIONS(7498),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [2379] = {
    [sym__line_break] = ACTIONS(5822),
    [sym__simple_symbol] = ACTIONS(5822),
    [sym__string_start] = ACTIONS(5822),
    [sym__symbol_start] = ACTIONS(5822),
    [sym__subshell_start] = ACTIONS(5822),
    [sym__regex_start] = ACTIONS(5822),
    [sym__string_array_start] = ACTIONS(5822),
    [sym__symbol_array_start] = ACTIONS(5822),
    [sym__heredoc_body_start] = ACTIONS(5822),
    [sym_heredoc_beginning] = ACTIONS(5822),
    [sym__block_ampersand] = ACTIONS(5822),
    [sym__splat_star] = ACTIONS(5822),
    [sym__unary_minus] = ACTIONS(5822),
    [sym__identifier_hash_key] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_def] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5822),
    [anon_sym_COLON_COLON] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_STAR_STAR] = ACTIONS(5822),
    [anon_sym_class] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5822),
    [anon_sym_module] = ACTIONS(5824),
    [anon_sym_end] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(5824),
    [anon_sym_break] = ACTIONS(5824),
    [anon_sym_next] = ACTIONS(5824),
    [sym_redo] = ACTIONS(5824),
    [sym_retry] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5824),
    [anon_sym_unless] = ACTIONS(5824),
    [anon_sym_while] = ACTIONS(5824),
    [anon_sym_until] = ACTIONS(5824),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_do] = ACTIONS(5824),
    [anon_sym_case] = ACTIONS(5824),
    [anon_sym_then] = ACTIONS(5824),
    [anon_sym_begin] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_LPAREN2] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_defined_QMARK] = ACTIONS(5822),
    [anon_sym_not] = ACTIONS(5824),
    [anon_sym_BANG] = ACTIONS(5822),
    [anon_sym_TILDE] = ACTIONS(5822),
    [sym_constant] = ACTIONS(5824),
    [sym_identifier] = ACTIONS(5824),
    [sym_instance_variable] = ACTIONS(5822),
    [sym_class_variable] = ACTIONS(5822),
    [sym_global_variable] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5824),
    [sym_float] = ACTIONS(5824),
    [sym_complex] = ACTIONS(5822),
    [sym_super] = ACTIONS(5824),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_TRUE] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [anon_sym_FALSE] = ACTIONS(5824),
    [sym_self] = ACTIONS(5824),
    [anon_sym_nil] = ACTIONS(5824),
    [anon_sym_NIL] = ACTIONS(5824),
    [sym_character] = ACTIONS(5822),
    [anon_sym_LBRACK2] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5822),
  },
  [2380] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4771),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(4771),
    [sym_operator_assignment] = STATE(4771),
    [sym_conditional] = STATE(4771),
    [sym_range] = STATE(4771),
    [sym_binary] = STATE(4771),
    [sym_unary] = STATE(4771),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2381] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(4778),
    [sym__argument] = STATE(4779),
    [sym_splat_argument] = STATE(4779),
    [sym_hash_splat_argument] = STATE(4779),
    [sym_block_argument] = STATE(4779),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4780),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4779),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7500),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7506),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2382] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(4778),
    [sym__argument] = STATE(4779),
    [sym_splat_argument] = STATE(4779),
    [sym_hash_splat_argument] = STATE(4779),
    [sym_block_argument] = STATE(4779),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4780),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4779),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7500),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7506),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2383] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(4778),
    [sym__argument] = STATE(4779),
    [sym_splat_argument] = STATE(4779),
    [sym_hash_splat_argument] = STATE(4779),
    [sym_block_argument] = STATE(4779),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4780),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4779),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7500),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7506),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2384] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(4778),
    [sym__argument] = STATE(4779),
    [sym_splat_argument] = STATE(4779),
    [sym_hash_splat_argument] = STATE(4779),
    [sym_block_argument] = STATE(4779),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4780),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4779),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7500),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7506),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2385] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4781),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(4781),
    [sym_operator_assignment] = STATE(4781),
    [sym_conditional] = STATE(4781),
    [sym_range] = STATE(4781),
    [sym_binary] = STATE(4781),
    [sym_unary] = STATE(4781),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2386] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2387] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(7524),
    [anon_sym_or] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [2388] = {
    [anon_sym_EQ] = ACTIONS(7536),
    [sym_comment] = ACTIONS(87),
  },
  [2389] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7538),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7540),
    [anon_sym_DASH_EQ] = ACTIONS(7540),
    [anon_sym_STAR_EQ] = ACTIONS(7540),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7540),
    [anon_sym_SLASH_EQ] = ACTIONS(7540),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7540),
    [anon_sym_PIPE_EQ] = ACTIONS(7540),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7540),
    [anon_sym_AMP_EQ] = ACTIONS(7540),
    [anon_sym_PERCENT_EQ] = ACTIONS(7540),
    [anon_sym_GT_GT_EQ] = ACTIONS(7540),
    [anon_sym_LT_LT_EQ] = ACTIONS(7540),
    [anon_sym_CARET_EQ] = ACTIONS(7540),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2390] = {
    [sym_string] = STATE(4794),
    [aux_sym_chained_string_repeat1] = STATE(4794),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2391] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(7524),
    [anon_sym_or] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [2392] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2393] = {
    [sym_string] = STATE(2423),
    [aux_sym_chained_string_repeat1] = STATE(2423),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2394] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4795),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(4795),
    [sym_operator_assignment] = STATE(4795),
    [sym_conditional] = STATE(4795),
    [sym_range] = STATE(4795),
    [sym_binary] = STATE(4795),
    [sym_unary] = STATE(4795),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2395] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [2396] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(7524),
    [anon_sym_or] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [2397] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4796),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4796),
    [sym_operator_assignment] = STATE(4796),
    [sym_conditional] = STATE(4796),
    [sym_range] = STATE(4796),
    [sym_binary] = STATE(4796),
    [sym_unary] = STATE(4796),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2398] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4797),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4797),
    [sym_operator_assignment] = STATE(4797),
    [sym_conditional] = STATE(4797),
    [sym_range] = STATE(4797),
    [sym_binary] = STATE(4797),
    [sym_unary] = STATE(4797),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2399] = {
    [anon_sym_COLON] = ACTIONS(7542),
    [sym_comment] = ACTIONS(87),
  },
  [2400] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4799),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4799),
    [sym_operator_assignment] = STATE(4799),
    [sym_conditional] = STATE(4799),
    [sym_range] = STATE(4799),
    [sym_binary] = STATE(4799),
    [sym_unary] = STATE(4799),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2401] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7544),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2402] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [2403] = {
    [sym_heredoc_body] = STATE(4801),
    [aux_sym_call_repeat1] = STATE(4801),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2404] = {
    [sym_heredoc_body] = STATE(4801),
    [aux_sym_call_repeat1] = STATE(4801),
    [aux_sym_argument_list_repeat1] = STATE(4803),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(7546),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2405] = {
    [sym_string] = STATE(2423),
    [aux_sym_chained_string_repeat1] = STATE(2423),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7548),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2406] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [2407] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4804),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(4804),
    [sym_operator_assignment] = STATE(4804),
    [sym_conditional] = STATE(4804),
    [sym_range] = STATE(4804),
    [sym_binary] = STATE(4804),
    [sym_unary] = STATE(4804),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2408] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4805),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4805),
    [sym_operator_assignment] = STATE(4805),
    [sym_conditional] = STATE(4805),
    [sym_range] = STATE(4805),
    [sym_binary] = STATE(4805),
    [sym_unary] = STATE(4805),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2409] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4806),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4806),
    [sym_operator_assignment] = STATE(4806),
    [sym_conditional] = STATE(4806),
    [sym_range] = STATE(4806),
    [sym_binary] = STATE(4806),
    [sym_unary] = STATE(4806),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2410] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4807),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4807),
    [sym_operator_assignment] = STATE(4807),
    [sym_conditional] = STATE(4807),
    [sym_range] = STATE(4807),
    [sym_binary] = STATE(4807),
    [sym_unary] = STATE(4807),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2411] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4808),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4808),
    [sym_operator_assignment] = STATE(4808),
    [sym_conditional] = STATE(4808),
    [sym_range] = STATE(4808),
    [sym_binary] = STATE(4808),
    [sym_unary] = STATE(4808),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2412] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4809),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4809),
    [sym_operator_assignment] = STATE(4809),
    [sym_conditional] = STATE(4809),
    [sym_range] = STATE(4809),
    [sym_binary] = STATE(4809),
    [sym_unary] = STATE(4809),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2413] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4810),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4810),
    [sym_operator_assignment] = STATE(4810),
    [sym_conditional] = STATE(4810),
    [sym_range] = STATE(4810),
    [sym_binary] = STATE(4810),
    [sym_unary] = STATE(4810),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2414] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4811),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4811),
    [sym_operator_assignment] = STATE(4811),
    [sym_conditional] = STATE(4811),
    [sym_range] = STATE(4811),
    [sym_binary] = STATE(4811),
    [sym_unary] = STATE(4811),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2415] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4812),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4812),
    [sym_operator_assignment] = STATE(4812),
    [sym_conditional] = STATE(4812),
    [sym_range] = STATE(4812),
    [sym_binary] = STATE(4812),
    [sym_unary] = STATE(4812),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2416] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4813),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4813),
    [sym_operator_assignment] = STATE(4813),
    [sym_conditional] = STATE(4813),
    [sym_range] = STATE(4813),
    [sym_binary] = STATE(4813),
    [sym_unary] = STATE(4813),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2417] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4814),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4814),
    [sym_operator_assignment] = STATE(4814),
    [sym_conditional] = STATE(4814),
    [sym_range] = STATE(4814),
    [sym_binary] = STATE(4814),
    [sym_unary] = STATE(4814),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2418] = {
    [sym_heredoc_body] = STATE(4815),
    [aux_sym_call_repeat1] = STATE(4815),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2419] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym__argument] = STATE(4625),
    [sym_splat_argument] = STATE(4625),
    [sym_hash_splat_argument] = STATE(4625),
    [sym_block_argument] = STATE(4625),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4816),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4625),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2420] = {
    [sym_heredoc_body] = STATE(4817),
    [aux_sym_call_repeat1] = STATE(4817),
    [aux_sym_argument_list_repeat1] = STATE(4818),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(4058),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2421] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4819),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_splat_argument] = STATE(4820),
    [sym_assignment] = STATE(4819),
    [sym_operator_assignment] = STATE(4819),
    [sym_conditional] = STATE(4819),
    [sym_range] = STATE(4819),
    [sym_binary] = STATE(4819),
    [sym_unary] = STATE(4819),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(4820),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4020),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2422] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4821),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(4821),
    [sym_operator_assignment] = STATE(4821),
    [sym_conditional] = STATE(4821),
    [sym_range] = STATE(4821),
    [sym_binary] = STATE(4821),
    [sym_unary] = STATE(4821),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2423] = {
    [sym_string] = STATE(4822),
    [aux_sym_chained_string_repeat1] = STATE(4822),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [2424] = {
    [sym__line_break] = ACTIONS(7550),
    [sym__heredoc_body_start] = ACTIONS(7550),
    [sym__binary_minus] = ACTIONS(7550),
    [sym__binary_star] = ACTIONS(7550),
    [ts_builtin_sym_end] = ACTIONS(7550),
    [anon_sym___END__] = ACTIONS(7550),
    [anon_sym_LBRACE] = ACTIONS(7550),
    [anon_sym_RBRACE] = ACTIONS(7550),
    [anon_sym_RPAREN] = ACTIONS(7550),
    [anon_sym_DOT] = ACTIONS(7552),
    [anon_sym_COMMA] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_SEMI] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_end] = ACTIONS(7550),
    [anon_sym_if] = ACTIONS(7550),
    [anon_sym_unless] = ACTIONS(7550),
    [anon_sym_while] = ACTIONS(7550),
    [anon_sym_until] = ACTIONS(7550),
    [anon_sym_rescue] = ACTIONS(7550),
    [anon_sym_do] = ACTIONS(7550),
    [anon_sym_when] = ACTIONS(7550),
    [anon_sym_elsif] = ACTIONS(7550),
    [anon_sym_else] = ACTIONS(7550),
    [anon_sym_then] = ACTIONS(7550),
    [anon_sym_ensure] = ACTIONS(7550),
    [anon_sym_EQ_GT] = ACTIONS(7550),
    [anon_sym_LBRACK] = ACTIONS(7550),
    [anon_sym_COLON_COLON2] = ACTIONS(7550),
    [anon_sym_AMP_DOT] = ACTIONS(7550),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_DOT_DOT] = ACTIONS(7552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7550),
    [anon_sym_and] = ACTIONS(7550),
    [anon_sym_or] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT_LT] = ACTIONS(7550),
    [anon_sym_GT_GT] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7552),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7550),
    [anon_sym_LT_EQ_GT] = ACTIONS(7550),
    [anon_sym_EQ_TILDE] = ACTIONS(7550),
    [anon_sym_BANG_TILDE] = ACTIONS(7550),
    [anon_sym_LT_EQ] = ACTIONS(7552),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_PERCENT] = ACTIONS(7550),
    [sym_comment] = ACTIONS(87),
  },
  [2425] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2426] = {
    [sym_heredoc_body] = STATE(4823),
    [aux_sym_call_repeat1] = STATE(4823),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym___END__] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2427] = {
    [sym_heredoc_body] = STATE(4823),
    [aux_sym_call_repeat1] = STATE(4823),
    [aux_sym_argument_list_repeat1] = STATE(4824),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym___END__] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2428] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [2429] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4825),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(4825),
    [sym_operator_assignment] = STATE(4825),
    [sym_conditional] = STATE(4825),
    [sym_range] = STATE(4825),
    [sym_binary] = STATE(4825),
    [sym_unary] = STATE(4825),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2430] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4826),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(4826),
    [sym_operator_assignment] = STATE(4826),
    [sym_conditional] = STATE(4826),
    [sym_range] = STATE(4826),
    [sym_binary] = STATE(4826),
    [sym_unary] = STATE(4826),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2431] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4827),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(4827),
    [sym_operator_assignment] = STATE(4827),
    [sym_conditional] = STATE(4827),
    [sym_range] = STATE(4827),
    [sym_binary] = STATE(4827),
    [sym_unary] = STATE(4827),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2432] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4828),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(4828),
    [sym_operator_assignment] = STATE(4828),
    [sym_conditional] = STATE(4828),
    [sym_range] = STATE(4828),
    [sym_binary] = STATE(4828),
    [sym_unary] = STATE(4828),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2433] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4829),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(4829),
    [sym_operator_assignment] = STATE(4829),
    [sym_conditional] = STATE(4829),
    [sym_range] = STATE(4829),
    [sym_binary] = STATE(4829),
    [sym_unary] = STATE(4829),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2434] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4830),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4830),
    [sym_operator_assignment] = STATE(4830),
    [sym_conditional] = STATE(4830),
    [sym_range] = STATE(4830),
    [sym_binary] = STATE(4830),
    [sym_unary] = STATE(4830),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2435] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4831),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(4831),
    [sym_operator_assignment] = STATE(4831),
    [sym_conditional] = STATE(4831),
    [sym_range] = STATE(4831),
    [sym_binary] = STATE(4831),
    [sym_unary] = STATE(4831),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2436] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4832),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(4832),
    [sym_operator_assignment] = STATE(4832),
    [sym_conditional] = STATE(4832),
    [sym_range] = STATE(4832),
    [sym_binary] = STATE(4832),
    [sym_unary] = STATE(4832),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2437] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4833),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(4833),
    [sym_operator_assignment] = STATE(4833),
    [sym_conditional] = STATE(4833),
    [sym_range] = STATE(4833),
    [sym_binary] = STATE(4833),
    [sym_unary] = STATE(4833),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2438] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4834),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(4834),
    [sym_operator_assignment] = STATE(4834),
    [sym_conditional] = STATE(4834),
    [sym_range] = STATE(4834),
    [sym_binary] = STATE(4834),
    [sym_unary] = STATE(4834),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2439] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4835),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_splat_argument] = STATE(4836),
    [sym_assignment] = STATE(4835),
    [sym_operator_assignment] = STATE(4835),
    [sym_conditional] = STATE(4835),
    [sym_range] = STATE(4835),
    [sym_binary] = STATE(4835),
    [sym_unary] = STATE(4835),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(4836),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2440] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4837),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(4837),
    [sym_operator_assignment] = STATE(4837),
    [sym_conditional] = STATE(4837),
    [sym_range] = STATE(4837),
    [sym_binary] = STATE(4837),
    [sym_unary] = STATE(4837),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2441] = {
    [sym_string] = STATE(4838),
    [aux_sym_chained_string_repeat1] = STATE(4838),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [ts_builtin_sym_end] = ACTIONS(2759),
    [anon_sym___END__] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [2442] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(6557),
    [anon_sym___END__] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [2443] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(4074),
    [anon_sym___END__] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2444] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(4110),
    [anon_sym___END__] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2445] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4839),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(4839),
    [sym_operator_assignment] = STATE(4839),
    [sym_conditional] = STATE(4839),
    [sym_range] = STATE(4839),
    [sym_binary] = STATE(4839),
    [sym_unary] = STATE(4839),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2446] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(3148),
    [anon_sym___END__] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2447] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4840),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(4840),
    [sym_operator_assignment] = STATE(4840),
    [sym_conditional] = STATE(4840),
    [sym_range] = STATE(4840),
    [sym_binary] = STATE(4840),
    [sym_unary] = STATE(4840),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2448] = {
    [sym_heredoc_body] = STATE(4841),
    [aux_sym_call_repeat1] = STATE(4841),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2449] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(888),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(888),
    [sym_operator_assignment] = STATE(888),
    [sym_conditional] = STATE(888),
    [sym_range] = STATE(888),
    [sym_binary] = STATE(888),
    [sym_unary] = STATE(888),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(891),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(4842),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1583),
    [sym__splat_star] = ACTIONS(1585),
    [sym__unary_minus] = ACTIONS(371),
    [sym__identifier_hash_key] = ACTIONS(1587),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7556),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1589),
    [sym_identifier] = ACTIONS(1589),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2450] = {
    [sym_heredoc_body] = STATE(4843),
    [aux_sym_call_repeat1] = STATE(4843),
    [aux_sym_argument_list_repeat1] = STATE(4844),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4120),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2451] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4845),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(4845),
    [sym_operator_assignment] = STATE(4845),
    [sym_conditional] = STATE(4845),
    [sym_range] = STATE(4845),
    [sym_binary] = STATE(4845),
    [sym_unary] = STATE(4845),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2452] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(4846),
    [sym__argument] = STATE(4847),
    [sym_splat_argument] = STATE(4847),
    [sym_hash_splat_argument] = STATE(4847),
    [sym_block_argument] = STATE(4847),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4847),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2453] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(4846),
    [sym__argument] = STATE(4847),
    [sym_splat_argument] = STATE(4847),
    [sym_hash_splat_argument] = STATE(4847),
    [sym_block_argument] = STATE(4847),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4847),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2454] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(4846),
    [sym__argument] = STATE(4847),
    [sym_splat_argument] = STATE(4847),
    [sym_hash_splat_argument] = STATE(4847),
    [sym_block_argument] = STATE(4847),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4847),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2455] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(4846),
    [sym__argument] = STATE(4847),
    [sym_splat_argument] = STATE(4847),
    [sym_hash_splat_argument] = STATE(4847),
    [sym_block_argument] = STATE(4847),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4847),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2456] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4848),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(4848),
    [sym_operator_assignment] = STATE(4848),
    [sym_conditional] = STATE(4848),
    [sym_range] = STATE(4848),
    [sym_binary] = STATE(4848),
    [sym_unary] = STATE(4848),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2457] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1335),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(1335),
    [sym_operator_assignment] = STATE(1335),
    [sym_conditional] = STATE(1335),
    [sym_range] = STATE(1335),
    [sym_binary] = STATE(1335),
    [sym_unary] = STATE(1335),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2458] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(7574),
    [anon_sym_or] = ACTIONS(7574),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [2459] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(1827),
    [sym__argument_list_with_parens] = STATE(2071),
    [sym__argument] = STATE(2072),
    [sym_splat_argument] = STATE(2072),
    [sym_hash_splat_argument] = STATE(2072),
    [sym_block_argument] = STATE(2072),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(2069),
    [sym_operator_assignment] = STATE(2069),
    [sym_conditional] = STATE(2069),
    [sym_range] = STATE(2069),
    [sym_binary] = STATE(2069),
    [sym_unary] = STATE(2069),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2075),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2072),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3504),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3528),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2460] = {
    [anon_sym_EQ] = ACTIONS(7586),
    [sym_comment] = ACTIONS(87),
  },
  [2461] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7588),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7590),
    [anon_sym_DASH_EQ] = ACTIONS(7590),
    [anon_sym_STAR_EQ] = ACTIONS(7590),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7590),
    [anon_sym_SLASH_EQ] = ACTIONS(7590),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7590),
    [anon_sym_PIPE_EQ] = ACTIONS(7590),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7590),
    [anon_sym_AMP_EQ] = ACTIONS(7590),
    [anon_sym_PERCENT_EQ] = ACTIONS(7590),
    [anon_sym_GT_GT_EQ] = ACTIONS(7590),
    [anon_sym_LT_LT_EQ] = ACTIONS(7590),
    [anon_sym_CARET_EQ] = ACTIONS(7590),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2462] = {
    [sym_string] = STATE(4861),
    [aux_sym_chained_string_repeat1] = STATE(4861),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2463] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(7574),
    [anon_sym_or] = ACTIONS(7574),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [2464] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2465] = {
    [sym_string] = STATE(2503),
    [aux_sym_chained_string_repeat1] = STATE(2503),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2466] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4862),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(4862),
    [sym_operator_assignment] = STATE(4862),
    [sym_conditional] = STATE(4862),
    [sym_range] = STATE(4862),
    [sym_binary] = STATE(4862),
    [sym_unary] = STATE(4862),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2467] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(7574),
    [anon_sym_or] = ACTIONS(7574),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [2468] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4863),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(4863),
    [sym_operator_assignment] = STATE(4863),
    [sym_conditional] = STATE(4863),
    [sym_range] = STATE(4863),
    [sym_binary] = STATE(4863),
    [sym_unary] = STATE(4863),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2469] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4864),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(4864),
    [sym_operator_assignment] = STATE(4864),
    [sym_conditional] = STATE(4864),
    [sym_range] = STATE(4864),
    [sym_binary] = STATE(4864),
    [sym_unary] = STATE(4864),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2470] = {
    [anon_sym_COLON] = ACTIONS(7592),
    [sym_comment] = ACTIONS(87),
  },
  [2471] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4866),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(4866),
    [sym_operator_assignment] = STATE(4866),
    [sym_conditional] = STATE(4866),
    [sym_range] = STATE(4866),
    [sym_binary] = STATE(4866),
    [sym_unary] = STATE(4866),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2472] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7594),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2473] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [2474] = {
    [sym_heredoc_body] = STATE(4868),
    [aux_sym_call_repeat1] = STATE(4868),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2475] = {
    [sym_heredoc_body] = STATE(4868),
    [aux_sym_call_repeat1] = STATE(4868),
    [aux_sym_argument_list_repeat1] = STATE(4870),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(7596),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2476] = {
    [sym_string] = STATE(2503),
    [aux_sym_chained_string_repeat1] = STATE(2503),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7598),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2477] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4176),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4180),
    [anon_sym_BANG_TILDE] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [2478] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4871),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(4871),
    [sym_operator_assignment] = STATE(4871),
    [sym_conditional] = STATE(4871),
    [sym_range] = STATE(4871),
    [sym_binary] = STATE(4871),
    [sym_unary] = STATE(4871),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2479] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4872),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(4872),
    [sym_operator_assignment] = STATE(4872),
    [sym_conditional] = STATE(4872),
    [sym_range] = STATE(4872),
    [sym_binary] = STATE(4872),
    [sym_unary] = STATE(4872),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2480] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4873),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(4873),
    [sym_operator_assignment] = STATE(4873),
    [sym_conditional] = STATE(4873),
    [sym_range] = STATE(4873),
    [sym_binary] = STATE(4873),
    [sym_unary] = STATE(4873),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2481] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4874),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(4874),
    [sym_operator_assignment] = STATE(4874),
    [sym_conditional] = STATE(4874),
    [sym_range] = STATE(4874),
    [sym_binary] = STATE(4874),
    [sym_unary] = STATE(4874),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2482] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4875),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(4875),
    [sym_operator_assignment] = STATE(4875),
    [sym_conditional] = STATE(4875),
    [sym_range] = STATE(4875),
    [sym_binary] = STATE(4875),
    [sym_unary] = STATE(4875),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2483] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4876),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(4876),
    [sym_operator_assignment] = STATE(4876),
    [sym_conditional] = STATE(4876),
    [sym_range] = STATE(4876),
    [sym_binary] = STATE(4876),
    [sym_unary] = STATE(4876),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2484] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4877),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4877),
    [sym_operator_assignment] = STATE(4877),
    [sym_conditional] = STATE(4877),
    [sym_range] = STATE(4877),
    [sym_binary] = STATE(4877),
    [sym_unary] = STATE(4877),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2485] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4878),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(4878),
    [sym_operator_assignment] = STATE(4878),
    [sym_conditional] = STATE(4878),
    [sym_range] = STATE(4878),
    [sym_binary] = STATE(4878),
    [sym_unary] = STATE(4878),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2486] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4879),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(4879),
    [sym_operator_assignment] = STATE(4879),
    [sym_conditional] = STATE(4879),
    [sym_range] = STATE(4879),
    [sym_binary] = STATE(4879),
    [sym_unary] = STATE(4879),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2487] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4880),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(4880),
    [sym_operator_assignment] = STATE(4880),
    [sym_conditional] = STATE(4880),
    [sym_range] = STATE(4880),
    [sym_binary] = STATE(4880),
    [sym_unary] = STATE(4880),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2488] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4881),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(4881),
    [sym_operator_assignment] = STATE(4881),
    [sym_conditional] = STATE(4881),
    [sym_range] = STATE(4881),
    [sym_binary] = STATE(4881),
    [sym_unary] = STATE(4881),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2489] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4882),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(4882),
    [sym_operator_assignment] = STATE(4882),
    [sym_conditional] = STATE(4882),
    [sym_range] = STATE(4882),
    [sym_binary] = STATE(4882),
    [sym_unary] = STATE(4882),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2490] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4883),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(4883),
    [sym_operator_assignment] = STATE(4883),
    [sym_conditional] = STATE(4883),
    [sym_range] = STATE(4883),
    [sym_binary] = STATE(4883),
    [sym_unary] = STATE(4883),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2491] = {
    [anon_sym_COLON] = ACTIONS(7600),
    [sym_comment] = ACTIONS(87),
  },
  [2492] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4885),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(4885),
    [sym_operator_assignment] = STATE(4885),
    [sym_conditional] = STATE(4885),
    [sym_range] = STATE(4885),
    [sym_binary] = STATE(4885),
    [sym_unary] = STATE(4885),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2493] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7602),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2494] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [2495] = {
    [sym_heredoc_body] = STATE(4887),
    [aux_sym_call_repeat1] = STATE(4887),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2496] = {
    [sym_heredoc_body] = STATE(4887),
    [aux_sym_call_repeat1] = STATE(4887),
    [aux_sym_argument_list_repeat1] = STATE(4889),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(7604),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2497] = {
    [sym_string] = STATE(4387),
    [aux_sym_chained_string_repeat1] = STATE(4387),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7606),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2498] = {
    [sym__line_break] = ACTIONS(7608),
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [ts_builtin_sym_end] = ACTIONS(7608),
    [anon_sym___END__] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_end] = ACTIONS(7608),
    [anon_sym_if] = ACTIONS(7608),
    [anon_sym_unless] = ACTIONS(7608),
    [anon_sym_while] = ACTIONS(7608),
    [anon_sym_until] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7608),
    [anon_sym_do] = ACTIONS(7608),
    [anon_sym_when] = ACTIONS(7608),
    [anon_sym_elsif] = ACTIONS(7608),
    [anon_sym_else] = ACTIONS(7608),
    [anon_sym_then] = ACTIONS(7608),
    [anon_sym_ensure] = ACTIONS(7608),
    [anon_sym_EQ_GT] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7608),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7608),
    [anon_sym_or] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE] = ACTIONS(7608),
    [anon_sym_AMP_AMP] = ACTIONS(7608),
    [anon_sym_LT_LT] = ACTIONS(7608),
    [anon_sym_GT_GT] = ACTIONS(7608),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7608),
    [anon_sym_PLUS] = ACTIONS(7608),
    [anon_sym_SLASH] = ACTIONS(7608),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
  },
  [2499] = {
    [anon_sym_RPAREN] = ACTIONS(7612),
    [sym_comment] = ACTIONS(87),
  },
  [2500] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(3438),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4891),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(5588),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(5590),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2501] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4893),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_splat_argument] = STATE(4894),
    [sym_assignment] = STATE(4893),
    [sym_operator_assignment] = STATE(4893),
    [sym_conditional] = STATE(4893),
    [sym_range] = STATE(4893),
    [sym_binary] = STATE(4893),
    [sym_unary] = STATE(4893),
    [sym_right_assignment_list] = STATE(3442),
    [sym__arg_or_splat_arg] = STATE(4894),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(7614),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2502] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4895),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(4895),
    [sym_operator_assignment] = STATE(4895),
    [sym_conditional] = STATE(4895),
    [sym_range] = STATE(4895),
    [sym_binary] = STATE(4895),
    [sym_unary] = STATE(4895),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2503] = {
    [sym_string] = STATE(4896),
    [aux_sym_chained_string_repeat1] = STATE(4896),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [2504] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(6759),
    [anon_sym___END__] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [2505] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2506] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [2507] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2508] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2509] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2510] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(7618),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [2511] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(5798),
    [anon_sym___END__] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2512] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2513] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2514] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2515] = {
    [sym__line_break] = ACTIONS(1263),
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym___END__] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_end] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_when] = ACTIONS(1265),
    [anon_sym_elsif] = ACTIONS(1265),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_then] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_ensure] = ACTIONS(1265),
    [anon_sym_EQ_GT] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [2516] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(4899),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(4900),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(7622),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2517] = {
    [sym__line_break] = ACTIONS(5806),
    [sym__simple_symbol] = ACTIONS(5806),
    [sym__string_start] = ACTIONS(5806),
    [sym__symbol_start] = ACTIONS(5806),
    [sym__subshell_start] = ACTIONS(5806),
    [sym__regex_start] = ACTIONS(5806),
    [sym__string_array_start] = ACTIONS(5806),
    [sym__symbol_array_start] = ACTIONS(5806),
    [sym__heredoc_body_start] = ACTIONS(5806),
    [sym_heredoc_beginning] = ACTIONS(5806),
    [sym__block_ampersand] = ACTIONS(5806),
    [sym__splat_star] = ACTIONS(5806),
    [sym__unary_minus] = ACTIONS(5806),
    [sym__binary_minus] = ACTIONS(5806),
    [sym__binary_star] = ACTIONS(5806),
    [sym__identifier_hash_key] = ACTIONS(5806),
    [ts_builtin_sym_end] = ACTIONS(5806),
    [anon_sym___END__] = ACTIONS(5808),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_RBRACE] = ACTIONS(5806),
    [anon_sym_def] = ACTIONS(5808),
    [anon_sym_LPAREN] = ACTIONS(5808),
    [anon_sym_RPAREN] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_COLON_COLON] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_SEMI] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5808),
    [anon_sym_AMP] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_class] = ACTIONS(5808),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_module] = ACTIONS(5808),
    [anon_sym_end] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_yield] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_next] = ACTIONS(5808),
    [sym_redo] = ACTIONS(5808),
    [sym_retry] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_unless] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_until] = ACTIONS(5808),
    [anon_sym_rescue] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_when] = ACTIONS(5808),
    [anon_sym_elsif] = ACTIONS(5808),
    [anon_sym_else] = ACTIONS(5808),
    [anon_sym_then] = ACTIONS(5808),
    [anon_sym_begin] = ACTIONS(5808),
    [anon_sym_ensure] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_COLON_COLON2] = ACTIONS(5806),
    [anon_sym_AMP_DOT] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_PLUS_EQ] = ACTIONS(5806),
    [anon_sym_DASH_EQ] = ACTIONS(5806),
    [anon_sym_STAR_EQ] = ACTIONS(5806),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5806),
    [anon_sym_AMP_EQ] = ACTIONS(5806),
    [anon_sym_PERCENT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_LT_LT_EQ] = ACTIONS(5806),
    [anon_sym_CARET_EQ] = ACTIONS(5806),
    [anon_sym_QMARK] = ACTIONS(5808),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_and] = ACTIONS(5808),
    [anon_sym_or] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_AMP_AMP] = ACTIONS(5808),
    [anon_sym_LT_LT] = ACTIONS(5808),
    [anon_sym_GT_GT] = ACTIONS(5808),
    [anon_sym_EQ_EQ] = ACTIONS(5808),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5806),
    [anon_sym_BANG_TILDE] = ACTIONS(5806),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_SLASH] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5808),
    [anon_sym_defined_QMARK] = ACTIONS(5806),
    [anon_sym_not] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_TILDE] = ACTIONS(5806),
    [sym_constant] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_instance_variable] = ACTIONS(5806),
    [sym_class_variable] = ACTIONS(5806),
    [sym_global_variable] = ACTIONS(5806),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5808),
    [sym_float] = ACTIONS(5808),
    [sym_complex] = ACTIONS(5806),
    [sym_super] = ACTIONS(5808),
    [anon_sym_true] = ACTIONS(5808),
    [anon_sym_TRUE] = ACTIONS(5808),
    [anon_sym_false] = ACTIONS(5808),
    [anon_sym_FALSE] = ACTIONS(5808),
    [sym_self] = ACTIONS(5808),
    [anon_sym_nil] = ACTIONS(5808),
    [anon_sym_NIL] = ACTIONS(5808),
    [sym_character] = ACTIONS(5806),
    [anon_sym_LBRACK2] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5806),
  },
  [2518] = {
    [sym__line_break] = ACTIONS(5810),
    [sym__simple_symbol] = ACTIONS(5810),
    [sym__string_start] = ACTIONS(5810),
    [sym__symbol_start] = ACTIONS(5810),
    [sym__subshell_start] = ACTIONS(5810),
    [sym__regex_start] = ACTIONS(5810),
    [sym__string_array_start] = ACTIONS(5810),
    [sym__symbol_array_start] = ACTIONS(5810),
    [sym__heredoc_body_start] = ACTIONS(5810),
    [sym_heredoc_beginning] = ACTIONS(5810),
    [sym__block_ampersand] = ACTIONS(5810),
    [sym__splat_star] = ACTIONS(5810),
    [sym__unary_minus] = ACTIONS(5810),
    [sym__binary_minus] = ACTIONS(5810),
    [sym__binary_star] = ACTIONS(5810),
    [sym__identifier_hash_key] = ACTIONS(5810),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [anon_sym___END__] = ACTIONS(5812),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [anon_sym_def] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(5812),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_COLON_COLON] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_PIPE] = ACTIONS(5812),
    [anon_sym_SEMI] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_STAR_STAR] = ACTIONS(5812),
    [anon_sym_AMP] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_class] = ACTIONS(5812),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_module] = ACTIONS(5812),
    [anon_sym_end] = ACTIONS(5812),
    [anon_sym_return] = ACTIONS(5812),
    [anon_sym_yield] = ACTIONS(5812),
    [anon_sym_break] = ACTIONS(5812),
    [anon_sym_next] = ACTIONS(5812),
    [sym_redo] = ACTIONS(5812),
    [sym_retry] = ACTIONS(5812),
    [anon_sym_if] = ACTIONS(5812),
    [anon_sym_unless] = ACTIONS(5812),
    [anon_sym_while] = ACTIONS(5812),
    [anon_sym_until] = ACTIONS(5812),
    [anon_sym_rescue] = ACTIONS(5812),
    [anon_sym_for] = ACTIONS(5812),
    [anon_sym_do] = ACTIONS(5812),
    [anon_sym_case] = ACTIONS(5812),
    [anon_sym_when] = ACTIONS(5812),
    [anon_sym_elsif] = ACTIONS(5812),
    [anon_sym_else] = ACTIONS(5812),
    [anon_sym_then] = ACTIONS(5812),
    [anon_sym_begin] = ACTIONS(5812),
    [anon_sym_ensure] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_COLON_COLON2] = ACTIONS(5810),
    [anon_sym_AMP_DOT] = ACTIONS(5810),
    [anon_sym_LPAREN2] = ACTIONS(5810),
    [anon_sym_PLUS_EQ] = ACTIONS(5810),
    [anon_sym_DASH_EQ] = ACTIONS(5810),
    [anon_sym_STAR_EQ] = ACTIONS(5810),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5810),
    [anon_sym_AMP_EQ] = ACTIONS(5810),
    [anon_sym_PERCENT_EQ] = ACTIONS(5810),
    [anon_sym_GT_GT_EQ] = ACTIONS(5810),
    [anon_sym_LT_LT_EQ] = ACTIONS(5810),
    [anon_sym_CARET_EQ] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5812),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(5812),
    [anon_sym_or] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_GT_GT] = ACTIONS(5812),
    [anon_sym_EQ_EQ] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5810),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_EQ_TILDE] = ACTIONS(5810),
    [anon_sym_BANG_TILDE] = ACTIONS(5810),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_GT] = ACTIONS(5812),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5812),
    [anon_sym_PLUS] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5812),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_defined_QMARK] = ACTIONS(5810),
    [anon_sym_not] = ACTIONS(5812),
    [anon_sym_BANG] = ACTIONS(5812),
    [anon_sym_TILDE] = ACTIONS(5810),
    [sym_constant] = ACTIONS(5812),
    [sym_identifier] = ACTIONS(5812),
    [sym_instance_variable] = ACTIONS(5810),
    [sym_class_variable] = ACTIONS(5810),
    [sym_global_variable] = ACTIONS(5810),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5812),
    [sym_float] = ACTIONS(5812),
    [sym_complex] = ACTIONS(5810),
    [sym_super] = ACTIONS(5812),
    [anon_sym_true] = ACTIONS(5812),
    [anon_sym_TRUE] = ACTIONS(5812),
    [anon_sym_false] = ACTIONS(5812),
    [anon_sym_FALSE] = ACTIONS(5812),
    [sym_self] = ACTIONS(5812),
    [anon_sym_nil] = ACTIONS(5812),
    [anon_sym_NIL] = ACTIONS(5812),
    [sym_character] = ACTIONS(5810),
    [anon_sym_LBRACK2] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5810),
  },
  [2519] = {
    [sym_argument_list_with_parens] = STATE(4901),
    [sym__argument_list_with_parens] = STATE(2518),
    [sym_operator] = STATE(4901),
    [sym_heredoc_body] = STATE(3546),
    [aux_sym_call_repeat1] = STATE(3546),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(4210),
    [anon_sym_STAR] = ACTIONS(4212),
    [anon_sym_STAR_STAR] = ACTIONS(4210),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_LT] = ACTIONS(4212),
    [anon_sym_LPAREN2] = ACTIONS(4214),
    [anon_sym_DOT_DOT] = ACTIONS(4210),
    [anon_sym_LT_LT] = ACTIONS(4210),
    [anon_sym_GT_GT] = ACTIONS(4210),
    [anon_sym_EQ_EQ] = ACTIONS(4212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4210),
    [anon_sym_LT_EQ_GT] = ACTIONS(4210),
    [anon_sym_EQ_TILDE] = ACTIONS(4210),
    [anon_sym_BANG_TILDE] = ACTIONS(4210),
    [anon_sym_LT_EQ] = ACTIONS(4212),
    [anon_sym_GT] = ACTIONS(4212),
    [anon_sym_GT_EQ] = ACTIONS(4210),
    [anon_sym_CARET] = ACTIONS(4210),
    [anon_sym_PLUS] = ACTIONS(4212),
    [anon_sym_SLASH] = ACTIONS(4210),
    [anon_sym_PERCENT] = ACTIONS(4210),
    [anon_sym_BANG] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4210),
    [sym_constant] = ACTIONS(7624),
    [sym_identifier] = ACTIONS(7624),
    [anon_sym_DASH] = ACTIONS(4212),
    [anon_sym_PLUS_AT] = ACTIONS(4210),
    [anon_sym_DASH_AT] = ACTIONS(4210),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4212),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4210),
    [anon_sym_BQUOTE] = ACTIONS(4210),
    [sym_comment] = ACTIONS(87),
  },
  [2520] = {
    [sym__line_break] = ACTIONS(5816),
    [sym__heredoc_body_start] = ACTIONS(5816),
    [sym__binary_minus] = ACTIONS(5816),
    [sym__binary_star] = ACTIONS(5816),
    [ts_builtin_sym_end] = ACTIONS(5816),
    [anon_sym___END__] = ACTIONS(5816),
    [anon_sym_LBRACE] = ACTIONS(5816),
    [anon_sym_RBRACE] = ACTIONS(5816),
    [anon_sym_RPAREN] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5816),
    [anon_sym_PIPE] = ACTIONS(5818),
    [anon_sym_SEMI] = ACTIONS(5816),
    [anon_sym_STAR_STAR] = ACTIONS(5818),
    [anon_sym_AMP] = ACTIONS(5818),
    [anon_sym_EQ] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5818),
    [anon_sym_end] = ACTIONS(5816),
    [anon_sym_if] = ACTIONS(5816),
    [anon_sym_unless] = ACTIONS(5816),
    [anon_sym_while] = ACTIONS(5816),
    [anon_sym_until] = ACTIONS(5816),
    [anon_sym_rescue] = ACTIONS(5816),
    [anon_sym_do] = ACTIONS(5816),
    [anon_sym_when] = ACTIONS(5816),
    [anon_sym_elsif] = ACTIONS(5816),
    [anon_sym_else] = ACTIONS(5816),
    [anon_sym_then] = ACTIONS(5816),
    [anon_sym_ensure] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_COLON_COLON2] = ACTIONS(5816),
    [anon_sym_AMP_DOT] = ACTIONS(5816),
    [anon_sym_PLUS_EQ] = ACTIONS(5816),
    [anon_sym_DASH_EQ] = ACTIONS(5816),
    [anon_sym_STAR_EQ] = ACTIONS(5816),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5816),
    [anon_sym_SLASH_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5816),
    [anon_sym_AMP_EQ] = ACTIONS(5816),
    [anon_sym_PERCENT_EQ] = ACTIONS(5816),
    [anon_sym_GT_GT_EQ] = ACTIONS(5816),
    [anon_sym_LT_LT_EQ] = ACTIONS(5816),
    [anon_sym_CARET_EQ] = ACTIONS(5816),
    [anon_sym_QMARK] = ACTIONS(5816),
    [anon_sym_DOT_DOT] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5816),
    [anon_sym_and] = ACTIONS(5816),
    [anon_sym_or] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_AMP_AMP] = ACTIONS(5818),
    [anon_sym_LT_LT] = ACTIONS(5818),
    [anon_sym_GT_GT] = ACTIONS(5818),
    [anon_sym_EQ_EQ] = ACTIONS(5818),
    [anon_sym_BANG_EQ] = ACTIONS(5816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5816),
    [anon_sym_LT_EQ_GT] = ACTIONS(5816),
    [anon_sym_EQ_TILDE] = ACTIONS(5816),
    [anon_sym_BANG_TILDE] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5818),
    [anon_sym_GT] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5816),
    [anon_sym_CARET] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5818),
    [anon_sym_SLASH] = ACTIONS(5818),
    [anon_sym_PERCENT] = ACTIONS(5818),
    [sym_comment] = ACTIONS(87),
  },
  [2521] = {
    [sym_heredoc_body] = STATE(4903),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(7626),
    [sym_comment] = ACTIONS(87),
  },
  [2522] = {
    [anon_sym_RBRACK] = ACTIONS(7626),
    [sym_comment] = ACTIONS(87),
  },
  [2523] = {
    [sym__line_break] = ACTIONS(5822),
    [sym__simple_symbol] = ACTIONS(5822),
    [sym__string_start] = ACTIONS(5822),
    [sym__symbol_start] = ACTIONS(5822),
    [sym__subshell_start] = ACTIONS(5822),
    [sym__regex_start] = ACTIONS(5822),
    [sym__string_array_start] = ACTIONS(5822),
    [sym__symbol_array_start] = ACTIONS(5822),
    [sym__heredoc_body_start] = ACTIONS(5822),
    [sym_heredoc_beginning] = ACTIONS(5822),
    [sym__block_ampersand] = ACTIONS(5822),
    [sym__splat_star] = ACTIONS(5822),
    [sym__unary_minus] = ACTIONS(5822),
    [sym__binary_minus] = ACTIONS(5822),
    [sym__binary_star] = ACTIONS(5822),
    [sym__identifier_hash_key] = ACTIONS(5822),
    [ts_builtin_sym_end] = ACTIONS(5822),
    [anon_sym___END__] = ACTIONS(5824),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_def] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COLON_COLON] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_STAR_STAR] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_class] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_module] = ACTIONS(5824),
    [anon_sym_end] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(5824),
    [anon_sym_break] = ACTIONS(5824),
    [anon_sym_next] = ACTIONS(5824),
    [sym_redo] = ACTIONS(5824),
    [sym_retry] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5824),
    [anon_sym_unless] = ACTIONS(5824),
    [anon_sym_while] = ACTIONS(5824),
    [anon_sym_until] = ACTIONS(5824),
    [anon_sym_rescue] = ACTIONS(5824),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_do] = ACTIONS(5824),
    [anon_sym_case] = ACTIONS(5824),
    [anon_sym_when] = ACTIONS(5824),
    [anon_sym_elsif] = ACTIONS(5824),
    [anon_sym_else] = ACTIONS(5824),
    [anon_sym_then] = ACTIONS(5824),
    [anon_sym_begin] = ACTIONS(5824),
    [anon_sym_ensure] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_LPAREN2] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [anon_sym_DASH_EQ] = ACTIONS(5822),
    [anon_sym_STAR_EQ] = ACTIONS(5822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5822),
    [anon_sym_AMP_EQ] = ACTIONS(5822),
    [anon_sym_PERCENT_EQ] = ACTIONS(5822),
    [anon_sym_GT_GT_EQ] = ACTIONS(5822),
    [anon_sym_LT_LT_EQ] = ACTIONS(5822),
    [anon_sym_CARET_EQ] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5824),
    [anon_sym_or] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [anon_sym_defined_QMARK] = ACTIONS(5822),
    [anon_sym_not] = ACTIONS(5824),
    [anon_sym_BANG] = ACTIONS(5824),
    [anon_sym_TILDE] = ACTIONS(5822),
    [sym_constant] = ACTIONS(5824),
    [sym_identifier] = ACTIONS(5824),
    [sym_instance_variable] = ACTIONS(5822),
    [sym_class_variable] = ACTIONS(5822),
    [sym_global_variable] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5824),
    [sym_float] = ACTIONS(5824),
    [sym_complex] = ACTIONS(5822),
    [sym_super] = ACTIONS(5824),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_TRUE] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [anon_sym_FALSE] = ACTIONS(5824),
    [sym_self] = ACTIONS(5824),
    [anon_sym_nil] = ACTIONS(5824),
    [anon_sym_NIL] = ACTIONS(5824),
    [sym_character] = ACTIONS(5822),
    [anon_sym_LBRACK2] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5822),
  },
  [2524] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(4074),
    [anon_sym___END__] = ACTIONS(4074),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [2525] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(4110),
    [anon_sym___END__] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [2526] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4904),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(4904),
    [sym_operator_assignment] = STATE(4904),
    [sym_conditional] = STATE(4904),
    [sym_range] = STATE(4904),
    [sym_binary] = STATE(4904),
    [sym_unary] = STATE(4904),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2527] = {
    [sym__line_break] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [ts_builtin_sym_end] = ACTIONS(5594),
    [anon_sym___END__] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_end] = ACTIONS(5594),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_when] = ACTIONS(5594),
    [anon_sym_elsif] = ACTIONS(5594),
    [anon_sym_else] = ACTIONS(5594),
    [anon_sym_then] = ACTIONS(5594),
    [anon_sym_ensure] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [2528] = {
    [anon_sym_RBRACE] = ACTIONS(7628),
    [sym_comment] = ACTIONS(87),
  },
  [2529] = {
    [sym__statements] = STATE(4906),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7628),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2530] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(3148),
    [anon_sym___END__] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [2531] = {
    [sym__line_break] = ACTIONS(5630),
    [sym__heredoc_body_start] = ACTIONS(5630),
    [sym__binary_minus] = ACTIONS(5630),
    [sym__binary_star] = ACTIONS(5630),
    [ts_builtin_sym_end] = ACTIONS(5630),
    [anon_sym___END__] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5630),
    [anon_sym_RPAREN] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_STAR_STAR] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5632),
    [anon_sym_end] = ACTIONS(5630),
    [anon_sym_if] = ACTIONS(5630),
    [anon_sym_unless] = ACTIONS(5630),
    [anon_sym_while] = ACTIONS(5630),
    [anon_sym_until] = ACTIONS(5630),
    [anon_sym_rescue] = ACTIONS(5630),
    [anon_sym_do] = ACTIONS(5630),
    [anon_sym_when] = ACTIONS(5630),
    [anon_sym_elsif] = ACTIONS(5630),
    [anon_sym_else] = ACTIONS(5630),
    [anon_sym_then] = ACTIONS(5630),
    [anon_sym_ensure] = ACTIONS(5630),
    [anon_sym_EQ_GT] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [anon_sym_PLUS_EQ] = ACTIONS(5630),
    [anon_sym_DASH_EQ] = ACTIONS(5630),
    [anon_sym_STAR_EQ] = ACTIONS(5630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5630),
    [anon_sym_SLASH_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5630),
    [anon_sym_AMP_EQ] = ACTIONS(5630),
    [anon_sym_PERCENT_EQ] = ACTIONS(5630),
    [anon_sym_GT_GT_EQ] = ACTIONS(5630),
    [anon_sym_LT_LT_EQ] = ACTIONS(5630),
    [anon_sym_CARET_EQ] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5632),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5630),
    [anon_sym_EQ_TILDE] = ACTIONS(5630),
    [anon_sym_BANG_TILDE] = ACTIONS(5630),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5632),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [sym_comment] = ACTIONS(87),
  },
  [2532] = {
    [anon_sym_end] = ACTIONS(7630),
    [sym_comment] = ACTIONS(87),
  },
  [2533] = {
    [sym__statements] = STATE(4908),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(4909),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(4909),
    [sym__line_break] = ACTIONS(7632),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7634),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2534] = {
    [sym__statements] = STATE(4908),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(4910),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7634),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2535] = {
    [sym__line_break] = ACTIONS(4148),
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [ts_builtin_sym_end] = ACTIONS(4148),
    [anon_sym___END__] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR_STAR] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_end] = ACTIONS(4148),
    [anon_sym_if] = ACTIONS(4148),
    [anon_sym_unless] = ACTIONS(4148),
    [anon_sym_while] = ACTIONS(4148),
    [anon_sym_until] = ACTIONS(4148),
    [anon_sym_rescue] = ACTIONS(4148),
    [anon_sym_do] = ACTIONS(4148),
    [anon_sym_when] = ACTIONS(4148),
    [anon_sym_elsif] = ACTIONS(4148),
    [anon_sym_else] = ACTIONS(4148),
    [anon_sym_then] = ACTIONS(4148),
    [anon_sym_ensure] = ACTIONS(4148),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [sym_comment] = ACTIONS(87),
  },
  [2536] = {
    [sym_heredoc_body] = STATE(4912),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(7636),
    [sym_comment] = ACTIONS(87),
  },
  [2537] = {
    [anon_sym_RPAREN] = ACTIONS(7636),
    [sym_comment] = ACTIONS(87),
  },
  [2538] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4913),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(4913),
    [sym_operator_assignment] = STATE(4913),
    [sym_conditional] = STATE(4913),
    [sym_range] = STATE(4913),
    [sym_binary] = STATE(4913),
    [sym_unary] = STATE(4913),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2539] = {
    [sym__line_break] = ACTIONS(6024),
    [sym__heredoc_body_start] = ACTIONS(6024),
    [sym__binary_minus] = ACTIONS(6024),
    [sym__binary_star] = ACTIONS(6024),
    [ts_builtin_sym_end] = ACTIONS(6024),
    [anon_sym___END__] = ACTIONS(6024),
    [anon_sym_LBRACE] = ACTIONS(6024),
    [anon_sym_RBRACE] = ACTIONS(6024),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_DOT] = ACTIONS(6026),
    [anon_sym_COMMA] = ACTIONS(6024),
    [anon_sym_PIPE] = ACTIONS(6026),
    [anon_sym_SEMI] = ACTIONS(6024),
    [anon_sym_STAR_STAR] = ACTIONS(6026),
    [anon_sym_AMP] = ACTIONS(6026),
    [anon_sym_EQ] = ACTIONS(6026),
    [anon_sym_LT] = ACTIONS(6026),
    [anon_sym_end] = ACTIONS(6024),
    [anon_sym_if] = ACTIONS(6024),
    [anon_sym_unless] = ACTIONS(6024),
    [anon_sym_while] = ACTIONS(6024),
    [anon_sym_until] = ACTIONS(6024),
    [anon_sym_rescue] = ACTIONS(6024),
    [anon_sym_do] = ACTIONS(6024),
    [anon_sym_when] = ACTIONS(6024),
    [anon_sym_elsif] = ACTIONS(6024),
    [anon_sym_else] = ACTIONS(6024),
    [anon_sym_then] = ACTIONS(6024),
    [anon_sym_ensure] = ACTIONS(6024),
    [anon_sym_EQ_GT] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_COLON_COLON2] = ACTIONS(6024),
    [anon_sym_AMP_DOT] = ACTIONS(6024),
    [anon_sym_PLUS_EQ] = ACTIONS(6024),
    [anon_sym_DASH_EQ] = ACTIONS(6024),
    [anon_sym_STAR_EQ] = ACTIONS(6024),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6024),
    [anon_sym_SLASH_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6024),
    [anon_sym_AMP_EQ] = ACTIONS(6024),
    [anon_sym_PERCENT_EQ] = ACTIONS(6024),
    [anon_sym_GT_GT_EQ] = ACTIONS(6024),
    [anon_sym_LT_LT_EQ] = ACTIONS(6024),
    [anon_sym_CARET_EQ] = ACTIONS(6024),
    [anon_sym_QMARK] = ACTIONS(6024),
    [anon_sym_DOT_DOT] = ACTIONS(6026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_or] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(6026),
    [anon_sym_LT_LT] = ACTIONS(6026),
    [anon_sym_GT_GT] = ACTIONS(6026),
    [anon_sym_EQ_EQ] = ACTIONS(6026),
    [anon_sym_BANG_EQ] = ACTIONS(6024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6024),
    [anon_sym_LT_EQ_GT] = ACTIONS(6024),
    [anon_sym_EQ_TILDE] = ACTIONS(6024),
    [anon_sym_BANG_TILDE] = ACTIONS(6024),
    [anon_sym_LT_EQ] = ACTIONS(6026),
    [anon_sym_GT] = ACTIONS(6026),
    [anon_sym_GT_EQ] = ACTIONS(6024),
    [anon_sym_CARET] = ACTIONS(6026),
    [anon_sym_PLUS] = ACTIONS(6026),
    [anon_sym_SLASH] = ACTIONS(6026),
    [anon_sym_PERCENT] = ACTIONS(6026),
    [sym_comment] = ACTIONS(87),
  },
  [2540] = {
    [sym_interpolation] = STATE(4915),
    [aux_sym_heredoc_body_repeat1] = STATE(4915),
    [sym__heredoc_content] = ACTIONS(7638),
    [sym_heredoc_end] = ACTIONS(7640),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(7638),
  },
  [2541] = {
    [sym_heredoc_body] = STATE(4916),
    [aux_sym_call_repeat1] = STATE(4916),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [2542] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(4918),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1665),
    [sym__splat_star] = ACTIONS(1667),
    [sym__unary_minus] = ACTIONS(767),
    [sym__identifier_hash_key] = ACTIONS(1669),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7642),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1677),
    [sym_identifier] = ACTIONS(1677),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2543] = {
    [sym_heredoc_body] = STATE(4919),
    [aux_sym_call_repeat1] = STATE(4919),
    [aux_sym_argument_list_repeat1] = STATE(4920),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4238),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [2544] = {
    [sym__line_break] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__binary_star] = ACTIONS(3102),
    [ts_builtin_sym_end] = ACTIONS(3102),
    [anon_sym___END__] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(4854),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(4854),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_STAR_STAR] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(4854),
    [anon_sym_LT] = ACTIONS(4854),
    [anon_sym_end] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_unless] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_until] = ACTIONS(3102),
    [anon_sym_rescue] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_when] = ACTIONS(3102),
    [anon_sym_elsif] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_then] = ACTIONS(3102),
    [anon_sym_ensure] = ACTIONS(3102),
    [anon_sym_EQ_GT] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_COLON_COLON2] = ACTIONS(3102),
    [anon_sym_AMP_DOT] = ACTIONS(3102),
    [anon_sym_QMARK] = ACTIONS(3102),
    [anon_sym_DOT_DOT] = ACTIONS(4854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_and] = ACTIONS(3102),
    [anon_sym_or] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(3102),
    [anon_sym_AMP_AMP] = ACTIONS(3102),
    [anon_sym_LT_LT] = ACTIONS(3102),
    [anon_sym_GT_GT] = ACTIONS(3102),
    [anon_sym_EQ_EQ] = ACTIONS(4854),
    [anon_sym_BANG_EQ] = ACTIONS(3102),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
    [anon_sym_LT_EQ_GT] = ACTIONS(3102),
    [anon_sym_EQ_TILDE] = ACTIONS(3102),
    [anon_sym_BANG_TILDE] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(4854),
    [anon_sym_GT] = ACTIONS(4854),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_PERCENT] = ACTIONS(3102),
    [sym_comment] = ACTIONS(87),
  },
  [2545] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(7644),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [2546] = {
    [sym_heredoc_body] = STATE(2546),
    [aux_sym_call_repeat1] = STATE(2546),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [ts_builtin_sym_end] = ACTIONS(7646),
    [anon_sym___END__] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [2547] = {
    [sym_interpolation] = STATE(4923),
    [aux_sym_heredoc_body_repeat1] = STATE(4923),
    [sym__heredoc_content] = ACTIONS(7653),
    [sym_heredoc_end] = ACTIONS(7655),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(7653),
  },
  [2548] = {
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [ts_builtin_sym_end] = ACTIONS(7657),
    [anon_sym___END__] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(7657),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_when] = ACTIONS(7657),
    [anon_sym_elsif] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [2549] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(213),
    [sym_operator_assignment] = STATE(213),
    [sym_conditional] = STATE(213),
    [sym_range] = STATE(213),
    [sym_binary] = STATE(213),
    [sym_unary] = STATE(213),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(221),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(367),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(371),
    [sym__identifier_hash_key] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(4252),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2550] = {
    [sym_heredoc_body] = STATE(2546),
    [aux_sym_call_repeat1] = STATE(2546),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [ts_builtin_sym_end] = ACTIONS(7661),
    [anon_sym___END__] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [2551] = {
    [aux_sym_argument_list_repeat1] = STATE(2551),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [ts_builtin_sym_end] = ACTIONS(7657),
    [anon_sym___END__] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(7665),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [2552] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(4970),
    [anon_sym___END__] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2553] = {
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6060),
    [anon_sym___END__] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_elsif] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [2554] = {
    [aux_sym_exceptions_repeat1] = STATE(4926),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6060),
    [anon_sym___END__] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [2555] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(6074),
    [anon_sym___END__] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [2556] = {
    [sym_string] = STATE(2556),
    [aux_sym_chained_string_repeat1] = STATE(2556),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [ts_builtin_sym_end] = ACTIONS(6076),
    [anon_sym___END__] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [2557] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4927),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(4927),
    [sym_operator_assignment] = STATE(4927),
    [sym_conditional] = STATE(4927),
    [sym_range] = STATE(4927),
    [sym_binary] = STATE(4927),
    [sym_unary] = STATE(4927),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2558] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(4928),
    [sym__argument] = STATE(4929),
    [sym_splat_argument] = STATE(4929),
    [sym_hash_splat_argument] = STATE(4929),
    [sym_block_argument] = STATE(4929),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4929),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1711),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1735),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2559] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(4928),
    [sym__argument] = STATE(4929),
    [sym_splat_argument] = STATE(4929),
    [sym_hash_splat_argument] = STATE(4929),
    [sym_block_argument] = STATE(4929),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4929),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1711),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1735),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2560] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(4928),
    [sym__argument] = STATE(4929),
    [sym_splat_argument] = STATE(4929),
    [sym_hash_splat_argument] = STATE(4929),
    [sym_block_argument] = STATE(4929),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4929),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1711),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1735),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2561] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(4928),
    [sym__argument] = STATE(4929),
    [sym_splat_argument] = STATE(4929),
    [sym_hash_splat_argument] = STATE(4929),
    [sym_block_argument] = STATE(4929),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4929),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1711),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1735),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2562] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4930),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(4930),
    [sym_operator_assignment] = STATE(4930),
    [sym_conditional] = STATE(4930),
    [sym_range] = STATE(4930),
    [sym_binary] = STATE(4930),
    [sym_unary] = STATE(4930),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2563] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2564] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7682),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [2565] = {
    [anon_sym_EQ] = ACTIONS(7698),
    [sym_comment] = ACTIONS(87),
  },
  [2566] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7700),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7702),
    [anon_sym_DASH_EQ] = ACTIONS(7702),
    [anon_sym_STAR_EQ] = ACTIONS(7702),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7702),
    [anon_sym_SLASH_EQ] = ACTIONS(7702),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7702),
    [anon_sym_PIPE_EQ] = ACTIONS(7702),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7702),
    [anon_sym_AMP_EQ] = ACTIONS(7702),
    [anon_sym_PERCENT_EQ] = ACTIONS(7702),
    [anon_sym_GT_GT_EQ] = ACTIONS(7702),
    [anon_sym_LT_LT_EQ] = ACTIONS(7702),
    [anon_sym_CARET_EQ] = ACTIONS(7702),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2567] = {
    [sym_string] = STATE(4943),
    [aux_sym_chained_string_repeat1] = STATE(4943),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2568] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7682),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [2569] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2570] = {
    [sym_string] = STATE(2608),
    [aux_sym_chained_string_repeat1] = STATE(2608),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2571] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4944),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(4944),
    [sym_operator_assignment] = STATE(4944),
    [sym_conditional] = STATE(4944),
    [sym_range] = STATE(4944),
    [sym_binary] = STATE(4944),
    [sym_unary] = STATE(4944),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2572] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7682),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [2573] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4945),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4945),
    [sym_operator_assignment] = STATE(4945),
    [sym_conditional] = STATE(4945),
    [sym_range] = STATE(4945),
    [sym_binary] = STATE(4945),
    [sym_unary] = STATE(4945),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2574] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4946),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4946),
    [sym_operator_assignment] = STATE(4946),
    [sym_conditional] = STATE(4946),
    [sym_range] = STATE(4946),
    [sym_binary] = STATE(4946),
    [sym_unary] = STATE(4946),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2575] = {
    [anon_sym_COLON] = ACTIONS(7704),
    [sym_comment] = ACTIONS(87),
  },
  [2576] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4948),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4948),
    [sym_operator_assignment] = STATE(4948),
    [sym_conditional] = STATE(4948),
    [sym_range] = STATE(4948),
    [sym_binary] = STATE(4948),
    [sym_unary] = STATE(4948),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2577] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7706),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2578] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [2579] = {
    [sym_heredoc_body] = STATE(4950),
    [aux_sym_call_repeat1] = STATE(4950),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2580] = {
    [sym_heredoc_body] = STATE(4950),
    [aux_sym_call_repeat1] = STATE(4950),
    [aux_sym_argument_list_repeat1] = STATE(4952),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(7708),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2581] = {
    [sym_string] = STATE(2608),
    [aux_sym_chained_string_repeat1] = STATE(2608),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7710),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2582] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [2583] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4953),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(4953),
    [sym_operator_assignment] = STATE(4953),
    [sym_conditional] = STATE(4953),
    [sym_range] = STATE(4953),
    [sym_binary] = STATE(4953),
    [sym_unary] = STATE(4953),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2584] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4954),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4954),
    [sym_operator_assignment] = STATE(4954),
    [sym_conditional] = STATE(4954),
    [sym_range] = STATE(4954),
    [sym_binary] = STATE(4954),
    [sym_unary] = STATE(4954),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2585] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4955),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4955),
    [sym_operator_assignment] = STATE(4955),
    [sym_conditional] = STATE(4955),
    [sym_range] = STATE(4955),
    [sym_binary] = STATE(4955),
    [sym_unary] = STATE(4955),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2586] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4956),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4956),
    [sym_operator_assignment] = STATE(4956),
    [sym_conditional] = STATE(4956),
    [sym_range] = STATE(4956),
    [sym_binary] = STATE(4956),
    [sym_unary] = STATE(4956),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2587] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4957),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4957),
    [sym_operator_assignment] = STATE(4957),
    [sym_conditional] = STATE(4957),
    [sym_range] = STATE(4957),
    [sym_binary] = STATE(4957),
    [sym_unary] = STATE(4957),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2588] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4958),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4958),
    [sym_operator_assignment] = STATE(4958),
    [sym_conditional] = STATE(4958),
    [sym_range] = STATE(4958),
    [sym_binary] = STATE(4958),
    [sym_unary] = STATE(4958),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2589] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4959),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(4959),
    [sym_operator_assignment] = STATE(4959),
    [sym_conditional] = STATE(4959),
    [sym_range] = STATE(4959),
    [sym_binary] = STATE(4959),
    [sym_unary] = STATE(4959),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2590] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4960),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4960),
    [sym_operator_assignment] = STATE(4960),
    [sym_conditional] = STATE(4960),
    [sym_range] = STATE(4960),
    [sym_binary] = STATE(4960),
    [sym_unary] = STATE(4960),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2591] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4961),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4961),
    [sym_operator_assignment] = STATE(4961),
    [sym_conditional] = STATE(4961),
    [sym_range] = STATE(4961),
    [sym_binary] = STATE(4961),
    [sym_unary] = STATE(4961),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2592] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4962),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4962),
    [sym_operator_assignment] = STATE(4962),
    [sym_conditional] = STATE(4962),
    [sym_range] = STATE(4962),
    [sym_binary] = STATE(4962),
    [sym_unary] = STATE(4962),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2593] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4963),
    [sym_operator_assignment] = STATE(4963),
    [sym_conditional] = STATE(4963),
    [sym_range] = STATE(4963),
    [sym_binary] = STATE(4963),
    [sym_unary] = STATE(4963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2594] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4964),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(4964),
    [sym_operator_assignment] = STATE(4964),
    [sym_conditional] = STATE(4964),
    [sym_range] = STATE(4964),
    [sym_binary] = STATE(4964),
    [sym_unary] = STATE(4964),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2595] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4965),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(4965),
    [sym_operator_assignment] = STATE(4965),
    [sym_conditional] = STATE(4965),
    [sym_range] = STATE(4965),
    [sym_binary] = STATE(4965),
    [sym_unary] = STATE(4965),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2596] = {
    [anon_sym_COLON] = ACTIONS(7712),
    [sym_comment] = ACTIONS(87),
  },
  [2597] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4967),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(4967),
    [sym_operator_assignment] = STATE(4967),
    [sym_conditional] = STATE(4967),
    [sym_range] = STATE(4967),
    [sym_binary] = STATE(4967),
    [sym_unary] = STATE(4967),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2598] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(7714),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2599] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [2600] = {
    [sym_heredoc_body] = STATE(4969),
    [aux_sym_call_repeat1] = STATE(4969),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2601] = {
    [sym_heredoc_body] = STATE(4969),
    [aux_sym_call_repeat1] = STATE(4969),
    [aux_sym_argument_list_repeat1] = STATE(4971),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(7716),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2602] = {
    [sym_string] = STATE(2683),
    [aux_sym_chained_string_repeat1] = STATE(2683),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7718),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2603] = {
    [sym_heredoc_body] = STATE(4972),
    [aux_sym_call_repeat1] = STATE(4972),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2604] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(4973),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1711),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__identifier_hash_key] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7720),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1735),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2605] = {
    [sym_heredoc_body] = STATE(4974),
    [aux_sym_call_repeat1] = STATE(4974),
    [aux_sym_argument_list_repeat1] = STATE(4975),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4320),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2606] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4976),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_splat_argument] = STATE(4977),
    [sym_assignment] = STATE(4976),
    [sym_operator_assignment] = STATE(4976),
    [sym_conditional] = STATE(4976),
    [sym_range] = STATE(4976),
    [sym_binary] = STATE(4976),
    [sym_unary] = STATE(4976),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(4977),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(4278),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2607] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4978),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(4978),
    [sym_operator_assignment] = STATE(4978),
    [sym_conditional] = STATE(4978),
    [sym_range] = STATE(4978),
    [sym_binary] = STATE(4978),
    [sym_unary] = STATE(4978),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2608] = {
    [sym_string] = STATE(4979),
    [aux_sym_chained_string_repeat1] = STATE(4979),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [2609] = {
    [aux_sym_undef_repeat1] = STATE(4980),
    [sym__line_break] = ACTIONS(5356),
    [sym__heredoc_body_start] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [anon_sym_then] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [2610] = {
    [sym__line_break] = ACTIONS(3102),
    [sym__simple_symbol] = ACTIONS(3102),
    [sym__string_start] = ACTIONS(3102),
    [sym__symbol_start] = ACTIONS(3102),
    [sym__subshell_start] = ACTIONS(3102),
    [sym__regex_start] = ACTIONS(3102),
    [sym__string_array_start] = ACTIONS(3102),
    [sym__symbol_array_start] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(3102),
    [sym_heredoc_beginning] = ACTIONS(3102),
    [sym__unary_minus] = ACTIONS(3102),
    [anon_sym_BEGIN] = ACTIONS(4854),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_END] = ACTIONS(4854),
    [anon_sym_def] = ACTIONS(4854),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(4854),
    [anon_sym_module] = ACTIONS(4854),
    [anon_sym_end] = ACTIONS(4854),
    [anon_sym_return] = ACTIONS(4854),
    [anon_sym_yield] = ACTIONS(4854),
    [anon_sym_break] = ACTIONS(4854),
    [anon_sym_next] = ACTIONS(4854),
    [sym_redo] = ACTIONS(4854),
    [sym_retry] = ACTIONS(4854),
    [anon_sym_if] = ACTIONS(4854),
    [anon_sym_unless] = ACTIONS(4854),
    [anon_sym_while] = ACTIONS(4854),
    [anon_sym_until] = ACTIONS(4854),
    [anon_sym_for] = ACTIONS(4854),
    [anon_sym_case] = ACTIONS(4854),
    [anon_sym_elsif] = ACTIONS(4854),
    [anon_sym_else] = ACTIONS(4854),
    [anon_sym_then] = ACTIONS(4854),
    [anon_sym_begin] = ACTIONS(4854),
    [anon_sym_PLUS] = ACTIONS(4854),
    [anon_sym_defined_QMARK] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(4854),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [sym_constant] = ACTIONS(4854),
    [sym_identifier] = ACTIONS(4854),
    [sym_instance_variable] = ACTIONS(3102),
    [sym_class_variable] = ACTIONS(3102),
    [sym_global_variable] = ACTIONS(3102),
    [anon_sym_undef] = ACTIONS(4854),
    [anon_sym_alias] = ACTIONS(4854),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4854),
    [sym_float] = ACTIONS(4854),
    [sym_complex] = ACTIONS(3102),
    [sym_super] = ACTIONS(4854),
    [anon_sym_true] = ACTIONS(4854),
    [anon_sym_TRUE] = ACTIONS(4854),
    [anon_sym_false] = ACTIONS(4854),
    [anon_sym_FALSE] = ACTIONS(4854),
    [sym_self] = ACTIONS(4854),
    [anon_sym_nil] = ACTIONS(4854),
    [anon_sym_NIL] = ACTIONS(4854),
    [sym_character] = ACTIONS(3102),
    [anon_sym_LBRACK2] = ACTIONS(3102),
    [anon_sym_DASH_GT] = ACTIONS(3102),
  },
  [2611] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(7722),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [2612] = {
    [sym__line_break] = ACTIONS(5686),
    [sym__heredoc_body_start] = ACTIONS(5686),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_then] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(1775),
    [anon_sym_or] = ACTIONS(1775),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2613] = {
    [sym__line_break] = ACTIONS(5688),
    [sym__heredoc_body_start] = ACTIONS(5688),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_then] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(1775),
    [anon_sym_or] = ACTIONS(1775),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2614] = {
    [sym__line_break] = ACTIONS(5690),
    [sym__heredoc_body_start] = ACTIONS(5690),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_then] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(1775),
    [anon_sym_or] = ACTIONS(1775),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2615] = {
    [sym__line_break] = ACTIONS(5692),
    [sym__heredoc_body_start] = ACTIONS(5692),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_then] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(1775),
    [anon_sym_or] = ACTIONS(1775),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2616] = {
    [sym__line_break] = ACTIONS(5694),
    [sym__heredoc_body_start] = ACTIONS(5694),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_then] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(1775),
    [anon_sym_or] = ACTIONS(1775),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2617] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4982),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(4982),
    [sym_operator_assignment] = STATE(4982),
    [sym_conditional] = STATE(4982),
    [sym_range] = STATE(4982),
    [sym_binary] = STATE(4982),
    [sym_unary] = STATE(4982),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2618] = {
    [sym__line_break] = ACTIONS(7724),
    [sym__heredoc_body_start] = ACTIONS(7724),
    [sym__binary_minus] = ACTIONS(7724),
    [sym__binary_star] = ACTIONS(7724),
    [ts_builtin_sym_end] = ACTIONS(7724),
    [anon_sym___END__] = ACTIONS(7724),
    [anon_sym_LBRACE] = ACTIONS(7724),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_DOT] = ACTIONS(7726),
    [anon_sym_COMMA] = ACTIONS(7724),
    [anon_sym_PIPE] = ACTIONS(7726),
    [anon_sym_SEMI] = ACTIONS(7724),
    [anon_sym_STAR_STAR] = ACTIONS(7724),
    [anon_sym_AMP] = ACTIONS(7726),
    [anon_sym_LT] = ACTIONS(7726),
    [anon_sym_end] = ACTIONS(7724),
    [anon_sym_if] = ACTIONS(7724),
    [anon_sym_unless] = ACTIONS(7724),
    [anon_sym_while] = ACTIONS(7724),
    [anon_sym_until] = ACTIONS(7724),
    [anon_sym_rescue] = ACTIONS(7724),
    [anon_sym_do] = ACTIONS(7724),
    [anon_sym_when] = ACTIONS(7724),
    [anon_sym_elsif] = ACTIONS(7724),
    [anon_sym_else] = ACTIONS(7724),
    [anon_sym_then] = ACTIONS(7724),
    [anon_sym_ensure] = ACTIONS(7724),
    [anon_sym_EQ_GT] = ACTIONS(7724),
    [anon_sym_LBRACK] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(7724),
    [anon_sym_AMP_DOT] = ACTIONS(7724),
    [anon_sym_QMARK] = ACTIONS(7724),
    [anon_sym_DOT_DOT] = ACTIONS(7726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7724),
    [anon_sym_and] = ACTIONS(7724),
    [anon_sym_or] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE] = ACTIONS(7724),
    [anon_sym_AMP_AMP] = ACTIONS(7724),
    [anon_sym_LT_LT] = ACTIONS(7724),
    [anon_sym_GT_GT] = ACTIONS(7724),
    [anon_sym_EQ_EQ] = ACTIONS(7726),
    [anon_sym_BANG_EQ] = ACTIONS(7724),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7724),
    [anon_sym_LT_EQ_GT] = ACTIONS(7724),
    [anon_sym_EQ_TILDE] = ACTIONS(7724),
    [anon_sym_BANG_TILDE] = ACTIONS(7724),
    [anon_sym_LT_EQ] = ACTIONS(7726),
    [anon_sym_GT] = ACTIONS(7726),
    [anon_sym_GT_EQ] = ACTIONS(7724),
    [anon_sym_CARET] = ACTIONS(7724),
    [anon_sym_PLUS] = ACTIONS(7724),
    [anon_sym_SLASH] = ACTIONS(7724),
    [anon_sym_PERCENT] = ACTIONS(7724),
    [sym_comment] = ACTIONS(87),
  },
  [2619] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(4997),
    [sym__argument] = STATE(4998),
    [sym_splat_argument] = STATE(4998),
    [sym_hash_splat_argument] = STATE(4998),
    [sym_block_argument] = STATE(4998),
    [sym_assignment] = STATE(4995),
    [sym_operator_assignment] = STATE(4995),
    [sym_conditional] = STATE(4995),
    [sym_range] = STATE(4995),
    [sym_binary] = STATE(4995),
    [sym_unary] = STATE(4995),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5001),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4998),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7728),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7734),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7752),
    [sym_identifier] = ACTIONS(7752),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2620] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(4997),
    [sym__argument] = STATE(4998),
    [sym_splat_argument] = STATE(4998),
    [sym_hash_splat_argument] = STATE(4998),
    [sym_block_argument] = STATE(4998),
    [sym_assignment] = STATE(4995),
    [sym_operator_assignment] = STATE(4995),
    [sym_conditional] = STATE(4995),
    [sym_range] = STATE(4995),
    [sym_binary] = STATE(4995),
    [sym_unary] = STATE(4995),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5001),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4998),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7728),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7734),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7752),
    [sym_identifier] = ACTIONS(7752),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2621] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(4997),
    [sym__argument] = STATE(4998),
    [sym_splat_argument] = STATE(4998),
    [sym_hash_splat_argument] = STATE(4998),
    [sym_block_argument] = STATE(4998),
    [sym_assignment] = STATE(4995),
    [sym_operator_assignment] = STATE(4995),
    [sym_conditional] = STATE(4995),
    [sym_range] = STATE(4995),
    [sym_binary] = STATE(4995),
    [sym_unary] = STATE(4995),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5001),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4998),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7728),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7734),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7752),
    [sym_identifier] = ACTIONS(7752),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2622] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(4997),
    [sym__argument] = STATE(4998),
    [sym_splat_argument] = STATE(4998),
    [sym_hash_splat_argument] = STATE(4998),
    [sym_block_argument] = STATE(4998),
    [sym_assignment] = STATE(4995),
    [sym_operator_assignment] = STATE(4995),
    [sym_conditional] = STATE(4995),
    [sym_range] = STATE(4995),
    [sym_binary] = STATE(4995),
    [sym_unary] = STATE(4995),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5001),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4998),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7728),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7734),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7752),
    [sym_identifier] = ACTIONS(7752),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2623] = {
    [sym__statement] = STATE(5002),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(5002),
    [sym_unless_modifier] = STATE(5002),
    [sym_while_modifier] = STATE(5002),
    [sym_until_modifier] = STATE(5002),
    [sym_rescue_modifier] = STATE(5002),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(5002),
    [sym_alias] = STATE(5002),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(5002),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2624] = {
    [sym__statements] = STATE(1180),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(5003),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(5003),
    [sym__line_break] = ACTIONS(7758),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2115),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2625] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5004),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(5004),
    [sym_operator_assignment] = STATE(5004),
    [sym_conditional] = STATE(5004),
    [sym_range] = STATE(5004),
    [sym_binary] = STATE(5004),
    [sym_unary] = STATE(5004),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2626] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2627] = {
    [sym_operator] = STATE(5005),
    [sym__method_name] = STATE(5005),
    [sym_setter] = STATE(5005),
    [sym_symbol] = STATE(5005),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(7760),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(7760),
    [sym_class_variable] = ACTIONS(7760),
    [sym_global_variable] = ACTIONS(7760),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [2628] = {
    [sym_elsif] = STATE(5007),
    [sym_else] = STATE(5007),
    [sym__if_tail] = STATE(5007),
    [anon_sym_end] = ACTIONS(7762),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [2629] = {
    [sym_heredoc_body] = STATE(5008),
    [sym__terminator] = STATE(5008),
    [aux_sym__statements_repeat1] = STATE(5009),
    [sym__line_break] = ACTIONS(7768),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(7768),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_elsif] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [2630] = {
    [sym__line_break] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(7770),
    [anon_sym_unless] = ACTIONS(7772),
    [anon_sym_while] = ACTIONS(7774),
    [anon_sym_until] = ACTIONS(7776),
    [anon_sym_rescue] = ACTIONS(7778),
    [anon_sym_elsif] = ACTIONS(691),
    [anon_sym_else] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [2631] = {
    [anon_sym_end] = ACTIONS(7762),
    [sym_comment] = ACTIONS(87),
  },
  [2632] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_elsif] = ACTIONS(703),
    [anon_sym_else] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(7796),
    [anon_sym_or] = ACTIONS(7796),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [2633] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5037),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(5039),
    [sym__argument] = STATE(5040),
    [sym_splat_argument] = STATE(5040),
    [sym_hash_splat_argument] = STATE(5040),
    [sym_block_argument] = STATE(5040),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(5037),
    [sym_operator_assignment] = STATE(5037),
    [sym_conditional] = STATE(5037),
    [sym_range] = STATE(5037),
    [sym_binary] = STATE(5037),
    [sym_unary] = STATE(5037),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5043),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5040),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(7808),
    [sym__splat_star] = ACTIONS(7810),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(7814),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7832),
    [sym_identifier] = ACTIONS(7832),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2634] = {
    [anon_sym_EQ] = ACTIONS(7838),
    [sym_comment] = ACTIONS(87),
  },
  [2635] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7840),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7842),
    [anon_sym_DASH_EQ] = ACTIONS(7842),
    [anon_sym_STAR_EQ] = ACTIONS(7842),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7842),
    [anon_sym_SLASH_EQ] = ACTIONS(7842),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7842),
    [anon_sym_PIPE_EQ] = ACTIONS(7842),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7842),
    [anon_sym_AMP_EQ] = ACTIONS(7842),
    [anon_sym_PERCENT_EQ] = ACTIONS(7842),
    [anon_sym_GT_GT_EQ] = ACTIONS(7842),
    [anon_sym_LT_LT_EQ] = ACTIONS(7842),
    [anon_sym_CARET_EQ] = ACTIONS(7842),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2636] = {
    [sym_string] = STATE(5046),
    [aux_sym_chained_string_repeat1] = STATE(5046),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2637] = {
    [sym__statements] = STATE(5047),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(5007),
    [sym_else] = STATE(5007),
    [sym__if_tail] = STATE(5007),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7844),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2638] = {
    [sym__line_break] = ACTIONS(7846),
    [sym__simple_symbol] = ACTIONS(7846),
    [sym__string_start] = ACTIONS(7846),
    [sym__symbol_start] = ACTIONS(7846),
    [sym__subshell_start] = ACTIONS(7846),
    [sym__regex_start] = ACTIONS(7846),
    [sym__string_array_start] = ACTIONS(7846),
    [sym__symbol_array_start] = ACTIONS(7846),
    [sym__heredoc_body_start] = ACTIONS(7846),
    [sym_heredoc_beginning] = ACTIONS(7846),
    [sym__unary_minus] = ACTIONS(7846),
    [anon_sym_BEGIN] = ACTIONS(7848),
    [anon_sym_LBRACE] = ACTIONS(7846),
    [anon_sym_END] = ACTIONS(7848),
    [anon_sym_def] = ACTIONS(7848),
    [anon_sym_LPAREN] = ACTIONS(7846),
    [anon_sym_COLON_COLON] = ACTIONS(7846),
    [anon_sym_SEMI] = ACTIONS(7846),
    [anon_sym_STAR] = ACTIONS(7846),
    [anon_sym_class] = ACTIONS(7848),
    [anon_sym_module] = ACTIONS(7848),
    [anon_sym_end] = ACTIONS(7848),
    [anon_sym_return] = ACTIONS(7848),
    [anon_sym_yield] = ACTIONS(7848),
    [anon_sym_break] = ACTIONS(7848),
    [anon_sym_next] = ACTIONS(7848),
    [sym_redo] = ACTIONS(7848),
    [sym_retry] = ACTIONS(7848),
    [anon_sym_if] = ACTIONS(7848),
    [anon_sym_unless] = ACTIONS(7848),
    [anon_sym_while] = ACTIONS(7848),
    [anon_sym_until] = ACTIONS(7848),
    [anon_sym_for] = ACTIONS(7848),
    [anon_sym_case] = ACTIONS(7848),
    [anon_sym_elsif] = ACTIONS(7848),
    [anon_sym_else] = ACTIONS(7848),
    [anon_sym_begin] = ACTIONS(7848),
    [anon_sym_PLUS] = ACTIONS(7848),
    [anon_sym_defined_QMARK] = ACTIONS(7846),
    [anon_sym_not] = ACTIONS(7848),
    [anon_sym_BANG] = ACTIONS(7846),
    [anon_sym_TILDE] = ACTIONS(7846),
    [sym_constant] = ACTIONS(7848),
    [sym_identifier] = ACTIONS(7848),
    [sym_instance_variable] = ACTIONS(7846),
    [sym_class_variable] = ACTIONS(7846),
    [sym_global_variable] = ACTIONS(7846),
    [anon_sym_undef] = ACTIONS(7848),
    [anon_sym_alias] = ACTIONS(7848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7848),
    [sym_float] = ACTIONS(7848),
    [sym_complex] = ACTIONS(7846),
    [sym_super] = ACTIONS(7848),
    [anon_sym_true] = ACTIONS(7848),
    [anon_sym_TRUE] = ACTIONS(7848),
    [anon_sym_false] = ACTIONS(7848),
    [anon_sym_FALSE] = ACTIONS(7848),
    [sym_self] = ACTIONS(7848),
    [anon_sym_nil] = ACTIONS(7848),
    [anon_sym_NIL] = ACTIONS(7848),
    [sym_character] = ACTIONS(7846),
    [anon_sym_LBRACK2] = ACTIONS(7846),
    [anon_sym_DASH_GT] = ACTIONS(7846),
  },
  [2639] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2640] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [2641] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2642] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2643] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2644] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [2645] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2646] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2647] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2648] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2649] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5049),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(5049),
    [sym_operator_assignment] = STATE(5049),
    [sym_conditional] = STATE(5049),
    [sym_range] = STATE(5049),
    [sym_binary] = STATE(5049),
    [sym_unary] = STATE(5049),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2650] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1787),
    [sym__splat_star] = ACTIONS(1789),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2651] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1787),
    [sym__splat_star] = ACTIONS(1789),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2652] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1787),
    [sym__splat_star] = ACTIONS(1789),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2653] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1787),
    [sym__splat_star] = ACTIONS(1789),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2654] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5050),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(5050),
    [sym_operator_assignment] = STATE(5050),
    [sym_conditional] = STATE(5050),
    [sym_range] = STATE(5050),
    [sym_binary] = STATE(5050),
    [sym_unary] = STATE(5050),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2655] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2656] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7864),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [2657] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(1004),
    [sym__argument] = STATE(1005),
    [sym_splat_argument] = STATE(1005),
    [sym_hash_splat_argument] = STATE(1005),
    [sym_block_argument] = STATE(1005),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1005),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1787),
    [sym__splat_star] = ACTIONS(1789),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2658] = {
    [anon_sym_EQ] = ACTIONS(7880),
    [sym_comment] = ACTIONS(87),
  },
  [2659] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7882),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7884),
    [anon_sym_DASH_EQ] = ACTIONS(7884),
    [anon_sym_STAR_EQ] = ACTIONS(7884),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7884),
    [anon_sym_SLASH_EQ] = ACTIONS(7884),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7884),
    [anon_sym_PIPE_EQ] = ACTIONS(7884),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7884),
    [anon_sym_AMP_EQ] = ACTIONS(7884),
    [anon_sym_PERCENT_EQ] = ACTIONS(7884),
    [anon_sym_GT_GT_EQ] = ACTIONS(7884),
    [anon_sym_LT_LT_EQ] = ACTIONS(7884),
    [anon_sym_CARET_EQ] = ACTIONS(7884),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2660] = {
    [sym_string] = STATE(5063),
    [aux_sym_chained_string_repeat1] = STATE(5063),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2661] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7864),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [2662] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [2663] = {
    [sym_string] = STATE(2683),
    [aux_sym_chained_string_repeat1] = STATE(2683),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2664] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5064),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(5064),
    [sym_operator_assignment] = STATE(5064),
    [sym_conditional] = STATE(5064),
    [sym_range] = STATE(5064),
    [sym_binary] = STATE(5064),
    [sym_unary] = STATE(5064),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2665] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7864),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [2666] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [2667] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5065),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(5065),
    [sym_operator_assignment] = STATE(5065),
    [sym_conditional] = STATE(5065),
    [sym_range] = STATE(5065),
    [sym_binary] = STATE(5065),
    [sym_unary] = STATE(5065),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2668] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5066),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5066),
    [sym_operator_assignment] = STATE(5066),
    [sym_conditional] = STATE(5066),
    [sym_range] = STATE(5066),
    [sym_binary] = STATE(5066),
    [sym_unary] = STATE(5066),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2669] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5067),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5067),
    [sym_operator_assignment] = STATE(5067),
    [sym_conditional] = STATE(5067),
    [sym_range] = STATE(5067),
    [sym_binary] = STATE(5067),
    [sym_unary] = STATE(5067),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2670] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5068),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5068),
    [sym_operator_assignment] = STATE(5068),
    [sym_conditional] = STATE(5068),
    [sym_range] = STATE(5068),
    [sym_binary] = STATE(5068),
    [sym_unary] = STATE(5068),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2671] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5069),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5069),
    [sym_operator_assignment] = STATE(5069),
    [sym_conditional] = STATE(5069),
    [sym_range] = STATE(5069),
    [sym_binary] = STATE(5069),
    [sym_unary] = STATE(5069),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2672] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5070),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5070),
    [sym_operator_assignment] = STATE(5070),
    [sym_conditional] = STATE(5070),
    [sym_range] = STATE(5070),
    [sym_binary] = STATE(5070),
    [sym_unary] = STATE(5070),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2673] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5071),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5071),
    [sym_operator_assignment] = STATE(5071),
    [sym_conditional] = STATE(5071),
    [sym_range] = STATE(5071),
    [sym_binary] = STATE(5071),
    [sym_unary] = STATE(5071),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2674] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5072),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5072),
    [sym_operator_assignment] = STATE(5072),
    [sym_conditional] = STATE(5072),
    [sym_range] = STATE(5072),
    [sym_binary] = STATE(5072),
    [sym_unary] = STATE(5072),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2675] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5073),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5073),
    [sym_operator_assignment] = STATE(5073),
    [sym_conditional] = STATE(5073),
    [sym_range] = STATE(5073),
    [sym_binary] = STATE(5073),
    [sym_unary] = STATE(5073),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2676] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5074),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5074),
    [sym_operator_assignment] = STATE(5074),
    [sym_conditional] = STATE(5074),
    [sym_range] = STATE(5074),
    [sym_binary] = STATE(5074),
    [sym_unary] = STATE(5074),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2677] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5075),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5075),
    [sym_operator_assignment] = STATE(5075),
    [sym_conditional] = STATE(5075),
    [sym_range] = STATE(5075),
    [sym_binary] = STATE(5075),
    [sym_unary] = STATE(5075),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2678] = {
    [sym_heredoc_body] = STATE(5076),
    [aux_sym_call_repeat1] = STATE(5076),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [2679] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(5077),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1787),
    [sym__splat_star] = ACTIONS(1789),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__identifier_hash_key] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7886),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2680] = {
    [sym_heredoc_body] = STATE(5078),
    [aux_sym_call_repeat1] = STATE(5078),
    [aux_sym_argument_list_repeat1] = STATE(5079),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [2681] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5080),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_splat_argument] = STATE(5081),
    [sym_assignment] = STATE(5080),
    [sym_operator_assignment] = STATE(5080),
    [sym_conditional] = STATE(5080),
    [sym_range] = STATE(5080),
    [sym_binary] = STATE(5080),
    [sym_unary] = STATE(5080),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(5081),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(4314),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2682] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5082),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(5082),
    [sym_operator_assignment] = STATE(5082),
    [sym_conditional] = STATE(5082),
    [sym_range] = STATE(5082),
    [sym_binary] = STATE(5082),
    [sym_unary] = STATE(5082),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2683] = {
    [sym_string] = STATE(5083),
    [aux_sym_chained_string_repeat1] = STATE(5083),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [2684] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5084),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(5084),
    [sym_operator_assignment] = STATE(5084),
    [sym_conditional] = STATE(5084),
    [sym_range] = STATE(5084),
    [sym_binary] = STATE(5084),
    [sym_unary] = STATE(5084),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2685] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5085),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(5085),
    [sym_operator_assignment] = STATE(5085),
    [sym_conditional] = STATE(5085),
    [sym_range] = STATE(5085),
    [sym_binary] = STATE(5085),
    [sym_unary] = STATE(5085),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2686] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5086),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(5086),
    [sym_operator_assignment] = STATE(5086),
    [sym_conditional] = STATE(5086),
    [sym_range] = STATE(5086),
    [sym_binary] = STATE(5086),
    [sym_unary] = STATE(5086),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2687] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2688] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7892),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(7894),
    [anon_sym_LT] = ACTIONS(7896),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7898),
    [anon_sym_DOT_DOT] = ACTIONS(7900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7902),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7904),
    [anon_sym_AMP_AMP] = ACTIONS(7904),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(7908),
    [anon_sym_BANG_EQ] = ACTIONS(7904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7904),
    [anon_sym_LT_EQ_GT] = ACTIONS(7904),
    [anon_sym_EQ_TILDE] = ACTIONS(7904),
    [anon_sym_BANG_TILDE] = ACTIONS(7904),
    [anon_sym_LT_EQ] = ACTIONS(7896),
    [anon_sym_GT] = ACTIONS(7896),
    [anon_sym_GT_EQ] = ACTIONS(7910),
    [anon_sym_CARET] = ACTIONS(7912),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [2689] = {
    [aux_sym_exceptions_repeat1] = STATE(5098),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [2690] = {
    [anon_sym_EQ] = ACTIONS(7916),
    [sym_comment] = ACTIONS(87),
  },
  [2691] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7918),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7920),
    [anon_sym_DASH_EQ] = ACTIONS(7920),
    [anon_sym_STAR_EQ] = ACTIONS(7920),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7920),
    [anon_sym_SLASH_EQ] = ACTIONS(7920),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7920),
    [anon_sym_PIPE_EQ] = ACTIONS(7920),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7920),
    [anon_sym_AMP_EQ] = ACTIONS(7920),
    [anon_sym_PERCENT_EQ] = ACTIONS(7920),
    [anon_sym_GT_GT_EQ] = ACTIONS(7920),
    [anon_sym_LT_LT_EQ] = ACTIONS(7920),
    [anon_sym_CARET_EQ] = ACTIONS(7920),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2692] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [2693] = {
    [sym_string] = STATE(2693),
    [aux_sym_chained_string_repeat1] = STATE(2693),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [2694] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5101),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(5101),
    [sym_operator_assignment] = STATE(5101),
    [sym_conditional] = STATE(5101),
    [sym_range] = STATE(5101),
    [sym_binary] = STATE(5101),
    [sym_unary] = STATE(5101),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2695] = {
    [sym__line_break] = ACTIONS(7922),
    [sym__heredoc_body_start] = ACTIONS(7922),
    [sym__binary_minus] = ACTIONS(7922),
    [sym__binary_star] = ACTIONS(7922),
    [ts_builtin_sym_end] = ACTIONS(7922),
    [anon_sym___END__] = ACTIONS(7922),
    [anon_sym_LBRACE] = ACTIONS(7922),
    [anon_sym_RBRACE] = ACTIONS(7922),
    [anon_sym_RPAREN] = ACTIONS(7922),
    [anon_sym_DOT] = ACTIONS(7924),
    [anon_sym_COMMA] = ACTIONS(7922),
    [anon_sym_PIPE] = ACTIONS(7924),
    [anon_sym_SEMI] = ACTIONS(7922),
    [anon_sym_STAR_STAR] = ACTIONS(7922),
    [anon_sym_AMP] = ACTIONS(7924),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_end] = ACTIONS(7922),
    [anon_sym_if] = ACTIONS(7922),
    [anon_sym_unless] = ACTIONS(7922),
    [anon_sym_while] = ACTIONS(7922),
    [anon_sym_until] = ACTIONS(7922),
    [anon_sym_rescue] = ACTIONS(7922),
    [anon_sym_do] = ACTIONS(7922),
    [anon_sym_when] = ACTIONS(7922),
    [anon_sym_elsif] = ACTIONS(7922),
    [anon_sym_else] = ACTIONS(7922),
    [anon_sym_then] = ACTIONS(7922),
    [anon_sym_ensure] = ACTIONS(7922),
    [anon_sym_EQ_GT] = ACTIONS(7922),
    [anon_sym_LBRACK] = ACTIONS(7922),
    [anon_sym_COLON_COLON2] = ACTIONS(7922),
    [anon_sym_AMP_DOT] = ACTIONS(7922),
    [anon_sym_QMARK] = ACTIONS(7922),
    [anon_sym_DOT_DOT] = ACTIONS(7924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7922),
    [anon_sym_and] = ACTIONS(7922),
    [anon_sym_or] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE] = ACTIONS(7922),
    [anon_sym_AMP_AMP] = ACTIONS(7922),
    [anon_sym_LT_LT] = ACTIONS(7922),
    [anon_sym_GT_GT] = ACTIONS(7922),
    [anon_sym_EQ_EQ] = ACTIONS(7924),
    [anon_sym_BANG_EQ] = ACTIONS(7922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7922),
    [anon_sym_LT_EQ_GT] = ACTIONS(7922),
    [anon_sym_EQ_TILDE] = ACTIONS(7922),
    [anon_sym_BANG_TILDE] = ACTIONS(7922),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7922),
    [anon_sym_CARET] = ACTIONS(7922),
    [anon_sym_PLUS] = ACTIONS(7922),
    [anon_sym_SLASH] = ACTIONS(7922),
    [anon_sym_PERCENT] = ACTIONS(7922),
    [sym_comment] = ACTIONS(87),
  },
  [2696] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5116),
    [sym__argument] = STATE(5117),
    [sym_splat_argument] = STATE(5117),
    [sym_hash_splat_argument] = STATE(5117),
    [sym_block_argument] = STATE(5117),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5120),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5117),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7926),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7950),
    [sym_identifier] = ACTIONS(7950),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2697] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5116),
    [sym__argument] = STATE(5117),
    [sym_splat_argument] = STATE(5117),
    [sym_hash_splat_argument] = STATE(5117),
    [sym_block_argument] = STATE(5117),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5120),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5117),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7926),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7950),
    [sym_identifier] = ACTIONS(7950),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2698] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5116),
    [sym__argument] = STATE(5117),
    [sym_splat_argument] = STATE(5117),
    [sym_hash_splat_argument] = STATE(5117),
    [sym_block_argument] = STATE(5117),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5120),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5117),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7926),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7950),
    [sym_identifier] = ACTIONS(7950),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2699] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5116),
    [sym__argument] = STATE(5117),
    [sym_splat_argument] = STATE(5117),
    [sym_hash_splat_argument] = STATE(5117),
    [sym_block_argument] = STATE(5117),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5120),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5117),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7926),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7950),
    [sym_identifier] = ACTIONS(7950),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2700] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5121),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(5121),
    [sym_operator_assignment] = STATE(5121),
    [sym_conditional] = STATE(5121),
    [sym_range] = STATE(5121),
    [sym_binary] = STATE(5121),
    [sym_unary] = STATE(5121),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2701] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2702] = {
    [sym_operator] = STATE(5122),
    [sym__method_name] = STATE(5122),
    [sym_setter] = STATE(5122),
    [sym_symbol] = STATE(5122),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(7956),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(7956),
    [sym_class_variable] = ACTIONS(7956),
    [sym_global_variable] = ACTIONS(7956),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [2703] = {
    [sym_else] = STATE(5124),
    [anon_sym_end] = ACTIONS(7958),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [2704] = {
    [sym_heredoc_body] = STATE(5125),
    [sym__terminator] = STATE(5125),
    [aux_sym__statements_repeat1] = STATE(5126),
    [sym__line_break] = ACTIONS(7960),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(7960),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [2705] = {
    [sym__line_break] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(7962),
    [anon_sym_unless] = ACTIONS(7964),
    [anon_sym_while] = ACTIONS(7966),
    [anon_sym_until] = ACTIONS(7968),
    [anon_sym_rescue] = ACTIONS(7970),
    [anon_sym_else] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [2706] = {
    [anon_sym_end] = ACTIONS(7958),
    [sym_comment] = ACTIONS(87),
  },
  [2707] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_else] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(7988),
    [anon_sym_or] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [2708] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5154),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(5156),
    [sym__argument] = STATE(5157),
    [sym_splat_argument] = STATE(5157),
    [sym_hash_splat_argument] = STATE(5157),
    [sym_block_argument] = STATE(5157),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(5154),
    [sym_operator_assignment] = STATE(5154),
    [sym_conditional] = STATE(5154),
    [sym_range] = STATE(5154),
    [sym_binary] = STATE(5154),
    [sym_unary] = STATE(5154),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5160),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5157),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8000),
    [sym__splat_star] = ACTIONS(8002),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(8006),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8024),
    [sym_identifier] = ACTIONS(8024),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2709] = {
    [anon_sym_EQ] = ACTIONS(8030),
    [sym_comment] = ACTIONS(87),
  },
  [2710] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8032),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8034),
    [anon_sym_DASH_EQ] = ACTIONS(8034),
    [anon_sym_STAR_EQ] = ACTIONS(8034),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8034),
    [anon_sym_SLASH_EQ] = ACTIONS(8034),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8034),
    [anon_sym_PIPE_EQ] = ACTIONS(8034),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8034),
    [anon_sym_AMP_EQ] = ACTIONS(8034),
    [anon_sym_PERCENT_EQ] = ACTIONS(8034),
    [anon_sym_GT_GT_EQ] = ACTIONS(8034),
    [anon_sym_LT_LT_EQ] = ACTIONS(8034),
    [anon_sym_CARET_EQ] = ACTIONS(8034),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2711] = {
    [sym_string] = STATE(5163),
    [aux_sym_chained_string_repeat1] = STATE(5163),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2712] = {
    [sym__simple_symbol] = ACTIONS(7846),
    [sym__string_start] = ACTIONS(7846),
    [sym__symbol_start] = ACTIONS(7846),
    [sym__subshell_start] = ACTIONS(7846),
    [sym__regex_start] = ACTIONS(7846),
    [sym__string_array_start] = ACTIONS(7846),
    [sym__symbol_array_start] = ACTIONS(7846),
    [sym_heredoc_beginning] = ACTIONS(7846),
    [sym__unary_minus] = ACTIONS(7846),
    [anon_sym_BEGIN] = ACTIONS(7848),
    [anon_sym_LBRACE] = ACTIONS(7846),
    [anon_sym_END] = ACTIONS(7848),
    [anon_sym_def] = ACTIONS(7848),
    [anon_sym_LPAREN] = ACTIONS(7846),
    [anon_sym_COLON_COLON] = ACTIONS(7846),
    [anon_sym_SEMI] = ACTIONS(7846),
    [anon_sym_STAR] = ACTIONS(7846),
    [anon_sym_class] = ACTIONS(7848),
    [anon_sym_module] = ACTIONS(7848),
    [anon_sym_end] = ACTIONS(7848),
    [anon_sym_return] = ACTIONS(7848),
    [anon_sym_yield] = ACTIONS(7848),
    [anon_sym_break] = ACTIONS(7848),
    [anon_sym_next] = ACTIONS(7848),
    [sym_redo] = ACTIONS(7848),
    [sym_retry] = ACTIONS(7848),
    [anon_sym_if] = ACTIONS(7848),
    [anon_sym_unless] = ACTIONS(7848),
    [anon_sym_while] = ACTIONS(7848),
    [anon_sym_until] = ACTIONS(7848),
    [anon_sym_rescue] = ACTIONS(7848),
    [anon_sym_for] = ACTIONS(7848),
    [anon_sym_case] = ACTIONS(7848),
    [anon_sym_when] = ACTIONS(7848),
    [anon_sym_elsif] = ACTIONS(7848),
    [anon_sym_else] = ACTIONS(7848),
    [anon_sym_begin] = ACTIONS(7848),
    [anon_sym_ensure] = ACTIONS(7848),
    [anon_sym_PLUS] = ACTIONS(7848),
    [anon_sym_defined_QMARK] = ACTIONS(7846),
    [anon_sym_not] = ACTIONS(7848),
    [anon_sym_BANG] = ACTIONS(7846),
    [anon_sym_TILDE] = ACTIONS(7846),
    [sym_constant] = ACTIONS(7848),
    [sym_identifier] = ACTIONS(7848),
    [sym_instance_variable] = ACTIONS(7846),
    [sym_class_variable] = ACTIONS(7846),
    [sym_global_variable] = ACTIONS(7846),
    [anon_sym_undef] = ACTIONS(7848),
    [anon_sym_alias] = ACTIONS(7848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7848),
    [sym_float] = ACTIONS(7848),
    [sym_complex] = ACTIONS(7846),
    [sym_super] = ACTIONS(7848),
    [anon_sym_true] = ACTIONS(7848),
    [anon_sym_TRUE] = ACTIONS(7848),
    [anon_sym_false] = ACTIONS(7848),
    [anon_sym_FALSE] = ACTIONS(7848),
    [sym_self] = ACTIONS(7848),
    [anon_sym_nil] = ACTIONS(7848),
    [anon_sym_NIL] = ACTIONS(7848),
    [sym_character] = ACTIONS(7846),
    [anon_sym_LBRACK2] = ACTIONS(7846),
    [anon_sym_DASH_GT] = ACTIONS(7846),
  },
  [2713] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5164),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(5164),
    [sym_operator_assignment] = STATE(5164),
    [sym_conditional] = STATE(5164),
    [sym_range] = STATE(5164),
    [sym_binary] = STATE(5164),
    [sym_unary] = STATE(5164),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2714] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1027),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5165),
    [sym__argument] = STATE(5166),
    [sym_splat_argument] = STATE(5166),
    [sym_hash_splat_argument] = STATE(5166),
    [sym_block_argument] = STATE(5166),
    [sym_assignment] = STATE(1027),
    [sym_operator_assignment] = STATE(1027),
    [sym_conditional] = STATE(1027),
    [sym_range] = STATE(1027),
    [sym_binary] = STATE(1027),
    [sym_unary] = STATE(1027),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1033),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5166),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1827),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2715] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1027),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5165),
    [sym__argument] = STATE(5166),
    [sym_splat_argument] = STATE(5166),
    [sym_hash_splat_argument] = STATE(5166),
    [sym_block_argument] = STATE(5166),
    [sym_assignment] = STATE(1027),
    [sym_operator_assignment] = STATE(1027),
    [sym_conditional] = STATE(1027),
    [sym_range] = STATE(1027),
    [sym_binary] = STATE(1027),
    [sym_unary] = STATE(1027),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1033),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5166),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1827),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2716] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1027),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5165),
    [sym__argument] = STATE(5166),
    [sym_splat_argument] = STATE(5166),
    [sym_hash_splat_argument] = STATE(5166),
    [sym_block_argument] = STATE(5166),
    [sym_assignment] = STATE(1027),
    [sym_operator_assignment] = STATE(1027),
    [sym_conditional] = STATE(1027),
    [sym_range] = STATE(1027),
    [sym_binary] = STATE(1027),
    [sym_unary] = STATE(1027),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1033),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5166),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1827),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2717] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1027),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5165),
    [sym__argument] = STATE(5166),
    [sym_splat_argument] = STATE(5166),
    [sym_hash_splat_argument] = STATE(5166),
    [sym_block_argument] = STATE(5166),
    [sym_assignment] = STATE(1027),
    [sym_operator_assignment] = STATE(1027),
    [sym_conditional] = STATE(1027),
    [sym_range] = STATE(1027),
    [sym_binary] = STATE(1027),
    [sym_unary] = STATE(1027),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1033),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5166),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1827),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2718] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5167),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(5167),
    [sym_operator_assignment] = STATE(5167),
    [sym_conditional] = STATE(5167),
    [sym_range] = STATE(5167),
    [sym_binary] = STATE(5167),
    [sym_unary] = STATE(5167),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2719] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2720] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8046),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [2721] = {
    [anon_sym_EQ] = ACTIONS(8062),
    [sym_comment] = ACTIONS(87),
  },
  [2722] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8064),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8066),
    [anon_sym_DASH_EQ] = ACTIONS(8066),
    [anon_sym_STAR_EQ] = ACTIONS(8066),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8066),
    [anon_sym_SLASH_EQ] = ACTIONS(8066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8066),
    [anon_sym_PIPE_EQ] = ACTIONS(8066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8066),
    [anon_sym_AMP_EQ] = ACTIONS(8066),
    [anon_sym_PERCENT_EQ] = ACTIONS(8066),
    [anon_sym_GT_GT_EQ] = ACTIONS(8066),
    [anon_sym_LT_LT_EQ] = ACTIONS(8066),
    [anon_sym_CARET_EQ] = ACTIONS(8066),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2723] = {
    [sym_string] = STATE(5180),
    [aux_sym_chained_string_repeat1] = STATE(5180),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2724] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8046),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [2725] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2726] = {
    [sym_string] = STATE(2765),
    [aux_sym_chained_string_repeat1] = STATE(2765),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2727] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5181),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(5181),
    [sym_operator_assignment] = STATE(5181),
    [sym_conditional] = STATE(5181),
    [sym_range] = STATE(5181),
    [sym_binary] = STATE(5181),
    [sym_unary] = STATE(5181),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2728] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8046),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [2729] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5182),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5182),
    [sym_operator_assignment] = STATE(5182),
    [sym_conditional] = STATE(5182),
    [sym_range] = STATE(5182),
    [sym_binary] = STATE(5182),
    [sym_unary] = STATE(5182),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2730] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5183),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5183),
    [sym_operator_assignment] = STATE(5183),
    [sym_conditional] = STATE(5183),
    [sym_range] = STATE(5183),
    [sym_binary] = STATE(5183),
    [sym_unary] = STATE(5183),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2731] = {
    [anon_sym_COLON] = ACTIONS(8068),
    [sym_comment] = ACTIONS(87),
  },
  [2732] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5185),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5185),
    [sym_operator_assignment] = STATE(5185),
    [sym_conditional] = STATE(5185),
    [sym_range] = STATE(5185),
    [sym_binary] = STATE(5185),
    [sym_unary] = STATE(5185),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2733] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8070),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2734] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [2735] = {
    [sym_heredoc_body] = STATE(5187),
    [aux_sym_call_repeat1] = STATE(5187),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2736] = {
    [sym_heredoc_body] = STATE(5187),
    [aux_sym_call_repeat1] = STATE(5187),
    [aux_sym_argument_list_repeat1] = STATE(5189),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8072),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2737] = {
    [sym_string] = STATE(2765),
    [aux_sym_chained_string_repeat1] = STATE(2765),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8074),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2738] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [2739] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5190),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(5190),
    [sym_operator_assignment] = STATE(5190),
    [sym_conditional] = STATE(5190),
    [sym_range] = STATE(5190),
    [sym_binary] = STATE(5190),
    [sym_unary] = STATE(5190),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2740] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5191),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5191),
    [sym_operator_assignment] = STATE(5191),
    [sym_conditional] = STATE(5191),
    [sym_range] = STATE(5191),
    [sym_binary] = STATE(5191),
    [sym_unary] = STATE(5191),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2741] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5192),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5192),
    [sym_operator_assignment] = STATE(5192),
    [sym_conditional] = STATE(5192),
    [sym_range] = STATE(5192),
    [sym_binary] = STATE(5192),
    [sym_unary] = STATE(5192),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2742] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5193),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5193),
    [sym_operator_assignment] = STATE(5193),
    [sym_conditional] = STATE(5193),
    [sym_range] = STATE(5193),
    [sym_binary] = STATE(5193),
    [sym_unary] = STATE(5193),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2743] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5194),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5194),
    [sym_operator_assignment] = STATE(5194),
    [sym_conditional] = STATE(5194),
    [sym_range] = STATE(5194),
    [sym_binary] = STATE(5194),
    [sym_unary] = STATE(5194),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2744] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5195),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5195),
    [sym_operator_assignment] = STATE(5195),
    [sym_conditional] = STATE(5195),
    [sym_range] = STATE(5195),
    [sym_binary] = STATE(5195),
    [sym_unary] = STATE(5195),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2745] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5196),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5196),
    [sym_operator_assignment] = STATE(5196),
    [sym_conditional] = STATE(5196),
    [sym_range] = STATE(5196),
    [sym_binary] = STATE(5196),
    [sym_unary] = STATE(5196),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2746] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5197),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5197),
    [sym_operator_assignment] = STATE(5197),
    [sym_conditional] = STATE(5197),
    [sym_range] = STATE(5197),
    [sym_binary] = STATE(5197),
    [sym_unary] = STATE(5197),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2747] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5198),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5198),
    [sym_operator_assignment] = STATE(5198),
    [sym_conditional] = STATE(5198),
    [sym_range] = STATE(5198),
    [sym_binary] = STATE(5198),
    [sym_unary] = STATE(5198),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2748] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5199),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5199),
    [sym_operator_assignment] = STATE(5199),
    [sym_conditional] = STATE(5199),
    [sym_range] = STATE(5199),
    [sym_binary] = STATE(5199),
    [sym_unary] = STATE(5199),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2749] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5200),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5200),
    [sym_operator_assignment] = STATE(5200),
    [sym_conditional] = STATE(5200),
    [sym_range] = STATE(5200),
    [sym_binary] = STATE(5200),
    [sym_unary] = STATE(5200),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2750] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5201),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5201),
    [sym_operator_assignment] = STATE(5201),
    [sym_conditional] = STATE(5201),
    [sym_range] = STATE(5201),
    [sym_binary] = STATE(5201),
    [sym_unary] = STATE(5201),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2751] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5202),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5202),
    [sym_operator_assignment] = STATE(5202),
    [sym_conditional] = STATE(5202),
    [sym_range] = STATE(5202),
    [sym_binary] = STATE(5202),
    [sym_unary] = STATE(5202),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2752] = {
    [anon_sym_COLON] = ACTIONS(8076),
    [sym_comment] = ACTIONS(87),
  },
  [2753] = {
    [sym__statements] = STATE(2528),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(2529),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1519),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1520),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(8078),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2754] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5205),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5205),
    [sym_operator_assignment] = STATE(5205),
    [sym_conditional] = STATE(5205),
    [sym_range] = STATE(5205),
    [sym_binary] = STATE(5205),
    [sym_unary] = STATE(5205),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2755] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8080),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2756] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [2757] = {
    [sym_heredoc_body] = STATE(5207),
    [aux_sym_call_repeat1] = STATE(5207),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2758] = {
    [sym_heredoc_body] = STATE(5207),
    [aux_sym_call_repeat1] = STATE(5207),
    [aux_sym_argument_list_repeat1] = STATE(5209),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8082),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2759] = {
    [sym_string] = STATE(2813),
    [aux_sym_chained_string_repeat1] = STATE(2813),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8084),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2760] = {
    [sym_heredoc_body] = STATE(5210),
    [aux_sym_call_repeat1] = STATE(5210),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2761] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1027),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(1027),
    [sym_operator_assignment] = STATE(1027),
    [sym_conditional] = STATE(1027),
    [sym_range] = STATE(1027),
    [sym_binary] = STATE(1027),
    [sym_unary] = STATE(1027),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1033),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(5211),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1827),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__identifier_hash_key] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2762] = {
    [sym_heredoc_body] = STATE(5212),
    [aux_sym_call_repeat1] = STATE(5212),
    [aux_sym_argument_list_repeat1] = STATE(5213),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4546),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2763] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5214),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_splat_argument] = STATE(5215),
    [sym_assignment] = STATE(5214),
    [sym_operator_assignment] = STATE(5214),
    [sym_conditional] = STATE(5214),
    [sym_range] = STATE(5214),
    [sym_binary] = STATE(5214),
    [sym_unary] = STATE(5214),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(5215),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(4502),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2764] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5216),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(5216),
    [sym_operator_assignment] = STATE(5216),
    [sym_conditional] = STATE(5216),
    [sym_range] = STATE(5216),
    [sym_binary] = STATE(5216),
    [sym_unary] = STATE(5216),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2765] = {
    [sym_string] = STATE(5217),
    [aux_sym_chained_string_repeat1] = STATE(5217),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [2766] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [2767] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [2768] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [2769] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [2770] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [2771] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(8088),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [2772] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [2773] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [2774] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [2775] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [2776] = {
    [sym__line_break] = ACTIONS(8090),
    [sym__heredoc_body_start] = ACTIONS(8090),
    [sym__binary_minus] = ACTIONS(8090),
    [sym__binary_star] = ACTIONS(8090),
    [ts_builtin_sym_end] = ACTIONS(8090),
    [anon_sym___END__] = ACTIONS(8090),
    [anon_sym_LBRACE] = ACTIONS(8090),
    [anon_sym_RBRACE] = ACTIONS(8090),
    [anon_sym_RPAREN] = ACTIONS(8090),
    [anon_sym_DOT] = ACTIONS(8092),
    [anon_sym_COMMA] = ACTIONS(8090),
    [anon_sym_PIPE] = ACTIONS(8092),
    [anon_sym_SEMI] = ACTIONS(8090),
    [anon_sym_STAR_STAR] = ACTIONS(8090),
    [anon_sym_AMP] = ACTIONS(8092),
    [anon_sym_LT] = ACTIONS(8092),
    [anon_sym_end] = ACTIONS(8090),
    [anon_sym_if] = ACTIONS(8090),
    [anon_sym_unless] = ACTIONS(8090),
    [anon_sym_while] = ACTIONS(8090),
    [anon_sym_until] = ACTIONS(8090),
    [anon_sym_rescue] = ACTIONS(8090),
    [anon_sym_do] = ACTIONS(8090),
    [anon_sym_when] = ACTIONS(8090),
    [anon_sym_elsif] = ACTIONS(8090),
    [anon_sym_else] = ACTIONS(8090),
    [anon_sym_then] = ACTIONS(8090),
    [anon_sym_ensure] = ACTIONS(8090),
    [anon_sym_EQ_GT] = ACTIONS(8090),
    [anon_sym_LBRACK] = ACTIONS(8090),
    [anon_sym_COLON_COLON2] = ACTIONS(8090),
    [anon_sym_AMP_DOT] = ACTIONS(8090),
    [anon_sym_QMARK] = ACTIONS(8090),
    [anon_sym_DOT_DOT] = ACTIONS(8092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8090),
    [anon_sym_and] = ACTIONS(8090),
    [anon_sym_or] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE] = ACTIONS(8090),
    [anon_sym_AMP_AMP] = ACTIONS(8090),
    [anon_sym_LT_LT] = ACTIONS(8090),
    [anon_sym_GT_GT] = ACTIONS(8090),
    [anon_sym_EQ_EQ] = ACTIONS(8092),
    [anon_sym_BANG_EQ] = ACTIONS(8090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8090),
    [anon_sym_LT_EQ_GT] = ACTIONS(8090),
    [anon_sym_EQ_TILDE] = ACTIONS(8090),
    [anon_sym_BANG_TILDE] = ACTIONS(8090),
    [anon_sym_LT_EQ] = ACTIONS(8092),
    [anon_sym_GT] = ACTIONS(8092),
    [anon_sym_GT_EQ] = ACTIONS(8090),
    [anon_sym_CARET] = ACTIONS(8090),
    [anon_sym_PLUS] = ACTIONS(8090),
    [anon_sym_SLASH] = ACTIONS(8090),
    [anon_sym_PERCENT] = ACTIONS(8090),
    [sym_comment] = ACTIONS(87),
  },
  [2777] = {
    [anon_sym_end] = ACTIONS(8094),
    [sym_comment] = ACTIONS(87),
  },
  [2778] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5220),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(5220),
    [sym_operator_assignment] = STATE(5220),
    [sym_conditional] = STATE(5220),
    [sym_range] = STATE(5220),
    [sym_binary] = STATE(5220),
    [sym_unary] = STATE(5220),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2779] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1059),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(1062),
    [sym__argument] = STATE(1063),
    [sym_splat_argument] = STATE(1063),
    [sym_hash_splat_argument] = STATE(1063),
    [sym_block_argument] = STATE(1063),
    [sym_assignment] = STATE(1059),
    [sym_operator_assignment] = STATE(1059),
    [sym_conditional] = STATE(1059),
    [sym_range] = STATE(1059),
    [sym_binary] = STATE(1059),
    [sym_unary] = STATE(1059),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1066),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1063),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1887),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2780] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1059),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(1062),
    [sym__argument] = STATE(1063),
    [sym_splat_argument] = STATE(1063),
    [sym_hash_splat_argument] = STATE(1063),
    [sym_block_argument] = STATE(1063),
    [sym_assignment] = STATE(1059),
    [sym_operator_assignment] = STATE(1059),
    [sym_conditional] = STATE(1059),
    [sym_range] = STATE(1059),
    [sym_binary] = STATE(1059),
    [sym_unary] = STATE(1059),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1066),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1063),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1887),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2781] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1059),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(1062),
    [sym__argument] = STATE(1063),
    [sym_splat_argument] = STATE(1063),
    [sym_hash_splat_argument] = STATE(1063),
    [sym_block_argument] = STATE(1063),
    [sym_assignment] = STATE(1059),
    [sym_operator_assignment] = STATE(1059),
    [sym_conditional] = STATE(1059),
    [sym_range] = STATE(1059),
    [sym_binary] = STATE(1059),
    [sym_unary] = STATE(1059),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1066),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1063),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1887),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2782] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1059),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(1062),
    [sym__argument] = STATE(1063),
    [sym_splat_argument] = STATE(1063),
    [sym_hash_splat_argument] = STATE(1063),
    [sym_block_argument] = STATE(1063),
    [sym_assignment] = STATE(1059),
    [sym_operator_assignment] = STATE(1059),
    [sym_conditional] = STATE(1059),
    [sym_range] = STATE(1059),
    [sym_binary] = STATE(1059),
    [sym_unary] = STATE(1059),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1066),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1063),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1887),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2783] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5221),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(5221),
    [sym_operator_assignment] = STATE(5221),
    [sym_conditional] = STATE(5221),
    [sym_range] = STATE(5221),
    [sym_binary] = STATE(5221),
    [sym_unary] = STATE(5221),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2784] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2785] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8108),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [2786] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1059),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(1062),
    [sym__argument] = STATE(1063),
    [sym_splat_argument] = STATE(1063),
    [sym_hash_splat_argument] = STATE(1063),
    [sym_block_argument] = STATE(1063),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(1059),
    [sym_operator_assignment] = STATE(1059),
    [sym_conditional] = STATE(1059),
    [sym_range] = STATE(1059),
    [sym_binary] = STATE(1059),
    [sym_unary] = STATE(1059),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1066),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1063),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1887),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2787] = {
    [anon_sym_EQ] = ACTIONS(8124),
    [sym_comment] = ACTIONS(87),
  },
  [2788] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8126),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8128),
    [anon_sym_DASH_EQ] = ACTIONS(8128),
    [anon_sym_STAR_EQ] = ACTIONS(8128),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8128),
    [anon_sym_SLASH_EQ] = ACTIONS(8128),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8128),
    [anon_sym_PIPE_EQ] = ACTIONS(8128),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8128),
    [anon_sym_AMP_EQ] = ACTIONS(8128),
    [anon_sym_PERCENT_EQ] = ACTIONS(8128),
    [anon_sym_GT_GT_EQ] = ACTIONS(8128),
    [anon_sym_LT_LT_EQ] = ACTIONS(8128),
    [anon_sym_CARET_EQ] = ACTIONS(8128),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2789] = {
    [sym_string] = STATE(5234),
    [aux_sym_chained_string_repeat1] = STATE(5234),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2790] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8108),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [2791] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [2792] = {
    [sym_string] = STATE(2813),
    [aux_sym_chained_string_repeat1] = STATE(2813),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2793] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5235),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(5235),
    [sym_operator_assignment] = STATE(5235),
    [sym_conditional] = STATE(5235),
    [sym_range] = STATE(5235),
    [sym_binary] = STATE(5235),
    [sym_unary] = STATE(5235),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2794] = {
    [sym__line_break] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [2795] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8108),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [2796] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [2797] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5236),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(5236),
    [sym_operator_assignment] = STATE(5236),
    [sym_conditional] = STATE(5236),
    [sym_range] = STATE(5236),
    [sym_binary] = STATE(5236),
    [sym_unary] = STATE(5236),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [2798] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5237),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5237),
    [sym_operator_assignment] = STATE(5237),
    [sym_conditional] = STATE(5237),
    [sym_range] = STATE(5237),
    [sym_binary] = STATE(5237),
    [sym_unary] = STATE(5237),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2799] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5238),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5238),
    [sym_operator_assignment] = STATE(5238),
    [sym_conditional] = STATE(5238),
    [sym_range] = STATE(5238),
    [sym_binary] = STATE(5238),
    [sym_unary] = STATE(5238),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2800] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5239),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5239),
    [sym_operator_assignment] = STATE(5239),
    [sym_conditional] = STATE(5239),
    [sym_range] = STATE(5239),
    [sym_binary] = STATE(5239),
    [sym_unary] = STATE(5239),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2801] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5240),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5240),
    [sym_operator_assignment] = STATE(5240),
    [sym_conditional] = STATE(5240),
    [sym_range] = STATE(5240),
    [sym_binary] = STATE(5240),
    [sym_unary] = STATE(5240),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2802] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5241),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5241),
    [sym_operator_assignment] = STATE(5241),
    [sym_conditional] = STATE(5241),
    [sym_range] = STATE(5241),
    [sym_binary] = STATE(5241),
    [sym_unary] = STATE(5241),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2803] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5242),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5242),
    [sym_operator_assignment] = STATE(5242),
    [sym_conditional] = STATE(5242),
    [sym_range] = STATE(5242),
    [sym_binary] = STATE(5242),
    [sym_unary] = STATE(5242),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2804] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5243),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5243),
    [sym_operator_assignment] = STATE(5243),
    [sym_conditional] = STATE(5243),
    [sym_range] = STATE(5243),
    [sym_binary] = STATE(5243),
    [sym_unary] = STATE(5243),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2805] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5244),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5244),
    [sym_operator_assignment] = STATE(5244),
    [sym_conditional] = STATE(5244),
    [sym_range] = STATE(5244),
    [sym_binary] = STATE(5244),
    [sym_unary] = STATE(5244),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2806] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5245),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5245),
    [sym_operator_assignment] = STATE(5245),
    [sym_conditional] = STATE(5245),
    [sym_range] = STATE(5245),
    [sym_binary] = STATE(5245),
    [sym_unary] = STATE(5245),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2807] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5246),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5246),
    [sym_operator_assignment] = STATE(5246),
    [sym_conditional] = STATE(5246),
    [sym_range] = STATE(5246),
    [sym_binary] = STATE(5246),
    [sym_unary] = STATE(5246),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2808] = {
    [sym_heredoc_body] = STATE(5247),
    [aux_sym_call_repeat1] = STATE(5247),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [2809] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1059),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(1059),
    [sym_operator_assignment] = STATE(1059),
    [sym_conditional] = STATE(1059),
    [sym_range] = STATE(1059),
    [sym_binary] = STATE(1059),
    [sym_unary] = STATE(1059),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1066),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(5248),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1887),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__identifier_hash_key] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8130),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2810] = {
    [sym_heredoc_body] = STATE(5249),
    [aux_sym_call_repeat1] = STATE(5249),
    [aux_sym_argument_list_repeat1] = STATE(5250),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4616),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [2811] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5251),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_splat_argument] = STATE(5252),
    [sym_assignment] = STATE(5251),
    [sym_operator_assignment] = STATE(5251),
    [sym_conditional] = STATE(5251),
    [sym_range] = STATE(5251),
    [sym_binary] = STATE(5251),
    [sym_unary] = STATE(5251),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(5252),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2812] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5253),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(5253),
    [sym_operator_assignment] = STATE(5253),
    [sym_conditional] = STATE(5253),
    [sym_range] = STATE(5253),
    [sym_binary] = STATE(5253),
    [sym_unary] = STATE(5253),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2813] = {
    [sym_string] = STATE(5254),
    [aux_sym_chained_string_repeat1] = STATE(5254),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [2814] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5255),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(5255),
    [sym_operator_assignment] = STATE(5255),
    [sym_conditional] = STATE(5255),
    [sym_range] = STATE(5255),
    [sym_binary] = STATE(5255),
    [sym_unary] = STATE(5255),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2815] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5256),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(5256),
    [sym_operator_assignment] = STATE(5256),
    [sym_conditional] = STATE(5256),
    [sym_range] = STATE(5256),
    [sym_binary] = STATE(5256),
    [sym_unary] = STATE(5256),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2816] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5257),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(5257),
    [sym_operator_assignment] = STATE(5257),
    [sym_conditional] = STATE(5257),
    [sym_range] = STATE(5257),
    [sym_binary] = STATE(5257),
    [sym_unary] = STATE(5257),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2817] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2818] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(8140),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8142),
    [anon_sym_DOT_DOT] = ACTIONS(8144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8146),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8152),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ_GT] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_BANG_TILDE] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8140),
    [anon_sym_GT] = ACTIONS(8140),
    [anon_sym_GT_EQ] = ACTIONS(8154),
    [anon_sym_CARET] = ACTIONS(8156),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [2819] = {
    [aux_sym_exceptions_repeat1] = STATE(5269),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(8158),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [2820] = {
    [anon_sym_EQ] = ACTIONS(8160),
    [sym_comment] = ACTIONS(87),
  },
  [2821] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8162),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8164),
    [anon_sym_DASH_EQ] = ACTIONS(8164),
    [anon_sym_STAR_EQ] = ACTIONS(8164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8164),
    [anon_sym_SLASH_EQ] = ACTIONS(8164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8164),
    [anon_sym_PIPE_EQ] = ACTIONS(8164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8164),
    [anon_sym_AMP_EQ] = ACTIONS(8164),
    [anon_sym_PERCENT_EQ] = ACTIONS(8164),
    [anon_sym_GT_GT_EQ] = ACTIONS(8164),
    [anon_sym_LT_LT_EQ] = ACTIONS(8164),
    [anon_sym_CARET_EQ] = ACTIONS(8164),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2822] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [2823] = {
    [sym_string] = STATE(2823),
    [aux_sym_chained_string_repeat1] = STATE(2823),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [2824] = {
    [sym__line_break] = ACTIONS(8166),
    [sym__heredoc_body_start] = ACTIONS(8166),
    [sym__binary_minus] = ACTIONS(8166),
    [sym__binary_star] = ACTIONS(8166),
    [ts_builtin_sym_end] = ACTIONS(8166),
    [anon_sym___END__] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_DOT] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8166),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI] = ACTIONS(8166),
    [anon_sym_STAR_STAR] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_end] = ACTIONS(8166),
    [anon_sym_if] = ACTIONS(8166),
    [anon_sym_unless] = ACTIONS(8166),
    [anon_sym_while] = ACTIONS(8166),
    [anon_sym_until] = ACTIONS(8166),
    [anon_sym_rescue] = ACTIONS(8166),
    [anon_sym_do] = ACTIONS(8166),
    [anon_sym_when] = ACTIONS(8166),
    [anon_sym_elsif] = ACTIONS(8166),
    [anon_sym_else] = ACTIONS(8166),
    [anon_sym_then] = ACTIONS(8166),
    [anon_sym_ensure] = ACTIONS(8166),
    [anon_sym_EQ_GT] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_COLON_COLON2] = ACTIONS(8166),
    [anon_sym_AMP_DOT] = ACTIONS(8166),
    [anon_sym_QMARK] = ACTIONS(8166),
    [anon_sym_DOT_DOT] = ACTIONS(8168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8166),
    [anon_sym_and] = ACTIONS(8166),
    [anon_sym_or] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8166),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ_GT] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_BANG_TILDE] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8166),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8166),
    [anon_sym_PERCENT] = ACTIONS(8166),
    [sym_comment] = ACTIONS(87),
  },
  [2825] = {
    [anon_sym_end] = ACTIONS(8170),
    [sym_comment] = ACTIONS(87),
  },
  [2826] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5273),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(5273),
    [sym_operator_assignment] = STATE(5273),
    [sym_conditional] = STATE(5273),
    [sym_range] = STATE(5273),
    [sym_binary] = STATE(5273),
    [sym_unary] = STATE(5273),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2827] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5279),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(5280),
    [sym__argument] = STATE(5281),
    [sym_splat_argument] = STATE(5281),
    [sym_hash_splat_argument] = STATE(5281),
    [sym_block_argument] = STATE(5281),
    [sym_assignment] = STATE(5279),
    [sym_operator_assignment] = STATE(5279),
    [sym_conditional] = STATE(5279),
    [sym_range] = STATE(5279),
    [sym_binary] = STATE(5279),
    [sym_unary] = STATE(5279),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(5282),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(5281),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8172),
    [sym__splat_star] = ACTIONS(8174),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(8178),
    [sym_identifier] = ACTIONS(8178),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2828] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5279),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(5280),
    [sym__argument] = STATE(5281),
    [sym_splat_argument] = STATE(5281),
    [sym_hash_splat_argument] = STATE(5281),
    [sym_block_argument] = STATE(5281),
    [sym_assignment] = STATE(5279),
    [sym_operator_assignment] = STATE(5279),
    [sym_conditional] = STATE(5279),
    [sym_range] = STATE(5279),
    [sym_binary] = STATE(5279),
    [sym_unary] = STATE(5279),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(5282),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(5281),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8172),
    [sym__splat_star] = ACTIONS(8174),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(8178),
    [sym_identifier] = ACTIONS(8178),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2829] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5279),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(5280),
    [sym__argument] = STATE(5281),
    [sym_splat_argument] = STATE(5281),
    [sym_hash_splat_argument] = STATE(5281),
    [sym_block_argument] = STATE(5281),
    [sym_assignment] = STATE(5279),
    [sym_operator_assignment] = STATE(5279),
    [sym_conditional] = STATE(5279),
    [sym_range] = STATE(5279),
    [sym_binary] = STATE(5279),
    [sym_unary] = STATE(5279),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(5282),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(5281),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8172),
    [sym__splat_star] = ACTIONS(8174),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(8178),
    [sym_identifier] = ACTIONS(8178),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2830] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5279),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(5280),
    [sym__argument] = STATE(5281),
    [sym_splat_argument] = STATE(5281),
    [sym_hash_splat_argument] = STATE(5281),
    [sym_block_argument] = STATE(5281),
    [sym_assignment] = STATE(5279),
    [sym_operator_assignment] = STATE(5279),
    [sym_conditional] = STATE(5279),
    [sym_range] = STATE(5279),
    [sym_binary] = STATE(5279),
    [sym_unary] = STATE(5279),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(5282),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(5281),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8172),
    [sym__splat_star] = ACTIONS(8174),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(8178),
    [sym_identifier] = ACTIONS(8178),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2831] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5283),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(5283),
    [sym_operator_assignment] = STATE(5283),
    [sym_conditional] = STATE(5283),
    [sym_range] = STATE(5283),
    [sym_binary] = STATE(5283),
    [sym_unary] = STATE(5283),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2832] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2833] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(8196),
    [anon_sym_or] = ACTIONS(8196),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [2834] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_argument_list] = STATE(4737),
    [sym__argument_list_with_parens] = STATE(5300),
    [sym__argument] = STATE(5301),
    [sym_splat_argument] = STATE(5301),
    [sym_hash_splat_argument] = STATE(5301),
    [sym_block_argument] = STATE(5301),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(5299),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5302),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(5301),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8208),
    [sym__splat_star] = ACTIONS(8210),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(8212),
    [anon_sym_LBRACE] = ACTIONS(7471),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4724),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(8214),
    [sym_identifier] = ACTIONS(8214),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2835] = {
    [anon_sym_EQ] = ACTIONS(8216),
    [sym_comment] = ACTIONS(87),
  },
  [2836] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8218),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8220),
    [anon_sym_DASH_EQ] = ACTIONS(8220),
    [anon_sym_STAR_EQ] = ACTIONS(8220),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8220),
    [anon_sym_SLASH_EQ] = ACTIONS(8220),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8220),
    [anon_sym_PIPE_EQ] = ACTIONS(8220),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8220),
    [anon_sym_AMP_EQ] = ACTIONS(8220),
    [anon_sym_PERCENT_EQ] = ACTIONS(8220),
    [anon_sym_GT_GT_EQ] = ACTIONS(8220),
    [anon_sym_LT_LT_EQ] = ACTIONS(8220),
    [anon_sym_CARET_EQ] = ACTIONS(8220),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2837] = {
    [sym_string] = STATE(5305),
    [aux_sym_chained_string_repeat1] = STATE(5305),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2838] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(8196),
    [anon_sym_or] = ACTIONS(8196),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [2839] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2840] = {
    [sym_string] = STATE(2887),
    [aux_sym_chained_string_repeat1] = STATE(2887),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2841] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5306),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(5306),
    [sym_operator_assignment] = STATE(5306),
    [sym_conditional] = STATE(5306),
    [sym_range] = STATE(5306),
    [sym_binary] = STATE(5306),
    [sym_unary] = STATE(5306),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2842] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(8196),
    [anon_sym_or] = ACTIONS(8196),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [2843] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5307),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5307),
    [sym_operator_assignment] = STATE(5307),
    [sym_conditional] = STATE(5307),
    [sym_range] = STATE(5307),
    [sym_binary] = STATE(5307),
    [sym_unary] = STATE(5307),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2844] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5308),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5308),
    [sym_operator_assignment] = STATE(5308),
    [sym_conditional] = STATE(5308),
    [sym_range] = STATE(5308),
    [sym_binary] = STATE(5308),
    [sym_unary] = STATE(5308),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2845] = {
    [anon_sym_COLON] = ACTIONS(8222),
    [sym_comment] = ACTIONS(87),
  },
  [2846] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5310),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5310),
    [sym_operator_assignment] = STATE(5310),
    [sym_conditional] = STATE(5310),
    [sym_range] = STATE(5310),
    [sym_binary] = STATE(5310),
    [sym_unary] = STATE(5310),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2847] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8224),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2848] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [2849] = {
    [sym_heredoc_body] = STATE(5312),
    [aux_sym_call_repeat1] = STATE(5312),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_in] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2850] = {
    [sym_heredoc_body] = STATE(5312),
    [aux_sym_call_repeat1] = STATE(5312),
    [aux_sym_argument_list_repeat1] = STATE(5314),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8226),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_in] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2851] = {
    [sym_string] = STATE(2887),
    [aux_sym_chained_string_repeat1] = STATE(2887),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8228),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2852] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [2853] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5315),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(5315),
    [sym_operator_assignment] = STATE(5315),
    [sym_conditional] = STATE(5315),
    [sym_range] = STATE(5315),
    [sym_binary] = STATE(5315),
    [sym_unary] = STATE(5315),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2854] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5316),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5316),
    [sym_operator_assignment] = STATE(5316),
    [sym_conditional] = STATE(5316),
    [sym_range] = STATE(5316),
    [sym_binary] = STATE(5316),
    [sym_unary] = STATE(5316),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2855] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5317),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5317),
    [sym_operator_assignment] = STATE(5317),
    [sym_conditional] = STATE(5317),
    [sym_range] = STATE(5317),
    [sym_binary] = STATE(5317),
    [sym_unary] = STATE(5317),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2856] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5318),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5318),
    [sym_operator_assignment] = STATE(5318),
    [sym_conditional] = STATE(5318),
    [sym_range] = STATE(5318),
    [sym_binary] = STATE(5318),
    [sym_unary] = STATE(5318),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2857] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5319),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5319),
    [sym_operator_assignment] = STATE(5319),
    [sym_conditional] = STATE(5319),
    [sym_range] = STATE(5319),
    [sym_binary] = STATE(5319),
    [sym_unary] = STATE(5319),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2858] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5320),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5320),
    [sym_operator_assignment] = STATE(5320),
    [sym_conditional] = STATE(5320),
    [sym_range] = STATE(5320),
    [sym_binary] = STATE(5320),
    [sym_unary] = STATE(5320),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2859] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5321),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5321),
    [sym_operator_assignment] = STATE(5321),
    [sym_conditional] = STATE(5321),
    [sym_range] = STATE(5321),
    [sym_binary] = STATE(5321),
    [sym_unary] = STATE(5321),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2860] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5322),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5322),
    [sym_operator_assignment] = STATE(5322),
    [sym_conditional] = STATE(5322),
    [sym_range] = STATE(5322),
    [sym_binary] = STATE(5322),
    [sym_unary] = STATE(5322),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2861] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5323),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5323),
    [sym_operator_assignment] = STATE(5323),
    [sym_conditional] = STATE(5323),
    [sym_range] = STATE(5323),
    [sym_binary] = STATE(5323),
    [sym_unary] = STATE(5323),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2862] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5324),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5324),
    [sym_operator_assignment] = STATE(5324),
    [sym_conditional] = STATE(5324),
    [sym_range] = STATE(5324),
    [sym_binary] = STATE(5324),
    [sym_unary] = STATE(5324),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2863] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5325),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5325),
    [sym_operator_assignment] = STATE(5325),
    [sym_conditional] = STATE(5325),
    [sym_range] = STATE(5325),
    [sym_binary] = STATE(5325),
    [sym_unary] = STATE(5325),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2864] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5326),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(5326),
    [sym_operator_assignment] = STATE(5326),
    [sym_conditional] = STATE(5326),
    [sym_range] = STATE(5326),
    [sym_binary] = STATE(5326),
    [sym_unary] = STATE(5326),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2865] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5328),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(5328),
    [sym_operator_assignment] = STATE(5328),
    [sym_conditional] = STATE(5328),
    [sym_range] = STATE(5328),
    [sym_binary] = STATE(5328),
    [sym_unary] = STATE(5328),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2866] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5329),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(5329),
    [sym_operator_assignment] = STATE(5329),
    [sym_conditional] = STATE(5329),
    [sym_range] = STATE(5329),
    [sym_binary] = STATE(5329),
    [sym_unary] = STATE(5329),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2867] = {
    [anon_sym_COLON] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [2868] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5331),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(5331),
    [sym_operator_assignment] = STATE(5331),
    [sym_conditional] = STATE(5331),
    [sym_range] = STATE(5331),
    [sym_binary] = STATE(5331),
    [sym_unary] = STATE(5331),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2869] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2876),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_argument_list] = STATE(1953),
    [sym__argument_list_with_parens] = STATE(2877),
    [sym__argument] = STATE(2878),
    [sym_splat_argument] = STATE(2878),
    [sym_hash_splat_argument] = STATE(2878),
    [sym_block_argument] = STATE(2878),
    [sym_assignment] = STATE(2876),
    [sym_operator_assignment] = STATE(2876),
    [sym_conditional] = STATE(2876),
    [sym_range] = STATE(2876),
    [sym_binary] = STATE(2876),
    [sym_unary] = STATE(2876),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2881),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2878),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4704),
    [sym__splat_star] = ACTIONS(4706),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(4710),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4724),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(4728),
    [sym_identifier] = ACTIONS(4728),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2870] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2876),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_argument_list] = STATE(1954),
    [sym__argument_list_with_parens] = STATE(2877),
    [sym__argument] = STATE(2878),
    [sym_splat_argument] = STATE(2878),
    [sym_hash_splat_argument] = STATE(2878),
    [sym_block_argument] = STATE(2878),
    [sym_assignment] = STATE(2876),
    [sym_operator_assignment] = STATE(2876),
    [sym_conditional] = STATE(2876),
    [sym_range] = STATE(2876),
    [sym_binary] = STATE(2876),
    [sym_unary] = STATE(2876),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2881),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2878),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4704),
    [sym__splat_star] = ACTIONS(4706),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(4710),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4724),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(4728),
    [sym_identifier] = ACTIONS(4728),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2871] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2876),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_argument_list] = STATE(1955),
    [sym__argument_list_with_parens] = STATE(2877),
    [sym__argument] = STATE(2878),
    [sym_splat_argument] = STATE(2878),
    [sym_hash_splat_argument] = STATE(2878),
    [sym_block_argument] = STATE(2878),
    [sym_assignment] = STATE(2876),
    [sym_operator_assignment] = STATE(2876),
    [sym_conditional] = STATE(2876),
    [sym_range] = STATE(2876),
    [sym_binary] = STATE(2876),
    [sym_unary] = STATE(2876),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2881),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2878),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4704),
    [sym__splat_star] = ACTIONS(4706),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(4710),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4724),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(4728),
    [sym_identifier] = ACTIONS(4728),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2872] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2876),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_argument_list] = STATE(1956),
    [sym__argument_list_with_parens] = STATE(2877),
    [sym__argument] = STATE(2878),
    [sym_splat_argument] = STATE(2878),
    [sym_hash_splat_argument] = STATE(2878),
    [sym_block_argument] = STATE(2878),
    [sym_assignment] = STATE(2876),
    [sym_operator_assignment] = STATE(2876),
    [sym_conditional] = STATE(2876),
    [sym_range] = STATE(2876),
    [sym_binary] = STATE(2876),
    [sym_unary] = STATE(2876),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2881),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2878),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4704),
    [sym__splat_star] = ACTIONS(4706),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(4710),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4724),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(4728),
    [sym_identifier] = ACTIONS(4728),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2873] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5332),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(5332),
    [sym_operator_assignment] = STATE(5332),
    [sym_conditional] = STATE(5332),
    [sym_range] = STATE(5332),
    [sym_binary] = STATE(5332),
    [sym_unary] = STATE(5332),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2874] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1978),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(1978),
    [sym_operator_assignment] = STATE(1978),
    [sym_conditional] = STATE(1978),
    [sym_range] = STATE(1978),
    [sym_binary] = STATE(1978),
    [sym_unary] = STATE(1978),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [2875] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8234),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2876] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [2877] = {
    [sym_heredoc_body] = STATE(5344),
    [aux_sym_call_repeat1] = STATE(5344),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_in] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2878] = {
    [sym_heredoc_body] = STATE(5344),
    [aux_sym_call_repeat1] = STATE(5344),
    [aux_sym_argument_list_repeat1] = STATE(5346),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8264),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_in] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [2879] = {
    [anon_sym_EQ] = ACTIONS(8266),
    [sym_comment] = ACTIONS(87),
  },
  [2880] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8268),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8270),
    [anon_sym_DASH_EQ] = ACTIONS(8270),
    [anon_sym_STAR_EQ] = ACTIONS(8270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8270),
    [anon_sym_SLASH_EQ] = ACTIONS(8270),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8270),
    [anon_sym_PIPE_EQ] = ACTIONS(8270),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8270),
    [anon_sym_AMP_EQ] = ACTIONS(8270),
    [anon_sym_PERCENT_EQ] = ACTIONS(8270),
    [anon_sym_GT_GT_EQ] = ACTIONS(8270),
    [anon_sym_LT_LT_EQ] = ACTIONS(8270),
    [anon_sym_CARET_EQ] = ACTIONS(8270),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2881] = {
    [sym_string] = STATE(5349),
    [aux_sym_chained_string_repeat1] = STATE(5349),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8272),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2882] = {
    [sym_heredoc_body] = STATE(5350),
    [aux_sym_call_repeat1] = STATE(5350),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_in] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2883] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1083),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym__argument] = STATE(4625),
    [sym_splat_argument] = STATE(4625),
    [sym_hash_splat_argument] = STATE(4625),
    [sym_block_argument] = STATE(4625),
    [sym_assignment] = STATE(1083),
    [sym_operator_assignment] = STATE(1083),
    [sym_conditional] = STATE(1083),
    [sym_range] = STATE(1083),
    [sym_binary] = STATE(1083),
    [sym_unary] = STATE(1083),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1089),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(5351),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4625),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1937),
    [sym__splat_star] = ACTIONS(1939),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__identifier_hash_key] = ACTIONS(1943),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2884] = {
    [sym_heredoc_body] = STATE(5352),
    [aux_sym_call_repeat1] = STATE(5352),
    [aux_sym_argument_list_repeat1] = STATE(5353),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(4730),
    [anon_sym_in] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2885] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5354),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_splat_argument] = STATE(5355),
    [sym_assignment] = STATE(5354),
    [sym_operator_assignment] = STATE(5354),
    [sym_conditional] = STATE(5354),
    [sym_range] = STATE(5354),
    [sym_binary] = STATE(5354),
    [sym_unary] = STATE(5354),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(5355),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4666),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2886] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5356),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(5356),
    [sym_operator_assignment] = STATE(5356),
    [sym_conditional] = STATE(5356),
    [sym_range] = STATE(5356),
    [sym_binary] = STATE(5356),
    [sym_unary] = STATE(5356),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2887] = {
    [sym_string] = STATE(5357),
    [aux_sym_chained_string_repeat1] = STATE(5357),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_in] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [2888] = {
    [sym__line_break] = ACTIONS(8274),
    [sym__heredoc_body_start] = ACTIONS(8274),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(8274),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(8274),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [2889] = {
    [sym__statements] = STATE(5359),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8276),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2890] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5360),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(5360),
    [sym_operator_assignment] = STATE(5360),
    [sym_conditional] = STATE(5360),
    [sym_range] = STATE(5360),
    [sym_binary] = STATE(5360),
    [sym_unary] = STATE(5360),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2891] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5361),
    [sym__argument] = STATE(5362),
    [sym_splat_argument] = STATE(5362),
    [sym_hash_splat_argument] = STATE(5362),
    [sym_block_argument] = STATE(5362),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1112),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5362),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1973),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2892] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5361),
    [sym__argument] = STATE(5362),
    [sym_splat_argument] = STATE(5362),
    [sym_hash_splat_argument] = STATE(5362),
    [sym_block_argument] = STATE(5362),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1112),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5362),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1973),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2893] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5361),
    [sym__argument] = STATE(5362),
    [sym_splat_argument] = STATE(5362),
    [sym_hash_splat_argument] = STATE(5362),
    [sym_block_argument] = STATE(5362),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1112),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5362),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1973),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2894] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5361),
    [sym__argument] = STATE(5362),
    [sym_splat_argument] = STATE(5362),
    [sym_hash_splat_argument] = STATE(5362),
    [sym_block_argument] = STATE(5362),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1112),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5362),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1973),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2895] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5363),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(5363),
    [sym_operator_assignment] = STATE(5363),
    [sym_conditional] = STATE(5363),
    [sym_range] = STATE(5363),
    [sym_binary] = STATE(5363),
    [sym_unary] = STATE(5363),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2896] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2897] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8288),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [2898] = {
    [anon_sym_EQ] = ACTIONS(8304),
    [sym_comment] = ACTIONS(87),
  },
  [2899] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8306),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8308),
    [anon_sym_DASH_EQ] = ACTIONS(8308),
    [anon_sym_STAR_EQ] = ACTIONS(8308),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8308),
    [anon_sym_SLASH_EQ] = ACTIONS(8308),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8308),
    [anon_sym_PIPE_EQ] = ACTIONS(8308),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8308),
    [anon_sym_AMP_EQ] = ACTIONS(8308),
    [anon_sym_PERCENT_EQ] = ACTIONS(8308),
    [anon_sym_GT_GT_EQ] = ACTIONS(8308),
    [anon_sym_LT_LT_EQ] = ACTIONS(8308),
    [anon_sym_CARET_EQ] = ACTIONS(8308),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2900] = {
    [sym_string] = STATE(5376),
    [aux_sym_chained_string_repeat1] = STATE(5376),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2901] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8288),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [2902] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2903] = {
    [sym_string] = STATE(2932),
    [aux_sym_chained_string_repeat1] = STATE(2932),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2904] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5377),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(5377),
    [sym_operator_assignment] = STATE(5377),
    [sym_conditional] = STATE(5377),
    [sym_range] = STATE(5377),
    [sym_binary] = STATE(5377),
    [sym_unary] = STATE(5377),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2905] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8288),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [2906] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5378),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5378),
    [sym_operator_assignment] = STATE(5378),
    [sym_conditional] = STATE(5378),
    [sym_range] = STATE(5378),
    [sym_binary] = STATE(5378),
    [sym_unary] = STATE(5378),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2907] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5379),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5379),
    [sym_operator_assignment] = STATE(5379),
    [sym_conditional] = STATE(5379),
    [sym_range] = STATE(5379),
    [sym_binary] = STATE(5379),
    [sym_unary] = STATE(5379),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2908] = {
    [anon_sym_COLON] = ACTIONS(8310),
    [sym_comment] = ACTIONS(87),
  },
  [2909] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5381),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5381),
    [sym_operator_assignment] = STATE(5381),
    [sym_conditional] = STATE(5381),
    [sym_range] = STATE(5381),
    [sym_binary] = STATE(5381),
    [sym_unary] = STATE(5381),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2910] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8312),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2911] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [2912] = {
    [sym_heredoc_body] = STATE(5383),
    [aux_sym_call_repeat1] = STATE(5383),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2913] = {
    [sym_heredoc_body] = STATE(5383),
    [aux_sym_call_repeat1] = STATE(5383),
    [aux_sym_argument_list_repeat1] = STATE(5385),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8314),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2914] = {
    [sym_string] = STATE(2932),
    [aux_sym_chained_string_repeat1] = STATE(2932),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8316),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2915] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [2916] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5386),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(5386),
    [sym_operator_assignment] = STATE(5386),
    [sym_conditional] = STATE(5386),
    [sym_range] = STATE(5386),
    [sym_binary] = STATE(5386),
    [sym_unary] = STATE(5386),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2917] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5387),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5387),
    [sym_operator_assignment] = STATE(5387),
    [sym_conditional] = STATE(5387),
    [sym_range] = STATE(5387),
    [sym_binary] = STATE(5387),
    [sym_unary] = STATE(5387),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2918] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5388),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5388),
    [sym_operator_assignment] = STATE(5388),
    [sym_conditional] = STATE(5388),
    [sym_range] = STATE(5388),
    [sym_binary] = STATE(5388),
    [sym_unary] = STATE(5388),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2919] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5389),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5389),
    [sym_operator_assignment] = STATE(5389),
    [sym_conditional] = STATE(5389),
    [sym_range] = STATE(5389),
    [sym_binary] = STATE(5389),
    [sym_unary] = STATE(5389),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2920] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5390),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5390),
    [sym_operator_assignment] = STATE(5390),
    [sym_conditional] = STATE(5390),
    [sym_range] = STATE(5390),
    [sym_binary] = STATE(5390),
    [sym_unary] = STATE(5390),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2921] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5391),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5391),
    [sym_operator_assignment] = STATE(5391),
    [sym_conditional] = STATE(5391),
    [sym_range] = STATE(5391),
    [sym_binary] = STATE(5391),
    [sym_unary] = STATE(5391),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2922] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5392),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5392),
    [sym_operator_assignment] = STATE(5392),
    [sym_conditional] = STATE(5392),
    [sym_range] = STATE(5392),
    [sym_binary] = STATE(5392),
    [sym_unary] = STATE(5392),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2923] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5393),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5393),
    [sym_operator_assignment] = STATE(5393),
    [sym_conditional] = STATE(5393),
    [sym_range] = STATE(5393),
    [sym_binary] = STATE(5393),
    [sym_unary] = STATE(5393),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2924] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5394),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5394),
    [sym_operator_assignment] = STATE(5394),
    [sym_conditional] = STATE(5394),
    [sym_range] = STATE(5394),
    [sym_binary] = STATE(5394),
    [sym_unary] = STATE(5394),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2925] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5395),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5395),
    [sym_operator_assignment] = STATE(5395),
    [sym_conditional] = STATE(5395),
    [sym_range] = STATE(5395),
    [sym_binary] = STATE(5395),
    [sym_unary] = STATE(5395),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2926] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5396),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5396),
    [sym_operator_assignment] = STATE(5396),
    [sym_conditional] = STATE(5396),
    [sym_range] = STATE(5396),
    [sym_binary] = STATE(5396),
    [sym_unary] = STATE(5396),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2927] = {
    [sym_heredoc_body] = STATE(5397),
    [aux_sym_call_repeat1] = STATE(5397),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2928] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1112),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(5398),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1973),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__identifier_hash_key] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8318),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2929] = {
    [sym_heredoc_body] = STATE(5399),
    [aux_sym_call_repeat1] = STATE(5399),
    [aux_sym_argument_list_repeat1] = STATE(5400),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4802),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [2930] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5401),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_splat_argument] = STATE(5402),
    [sym_assignment] = STATE(5401),
    [sym_operator_assignment] = STATE(5401),
    [sym_conditional] = STATE(5401),
    [sym_range] = STATE(5401),
    [sym_binary] = STATE(5401),
    [sym_unary] = STATE(5401),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(5402),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(4768),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2931] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5403),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(5403),
    [sym_operator_assignment] = STATE(5403),
    [sym_conditional] = STATE(5403),
    [sym_range] = STATE(5403),
    [sym_binary] = STATE(5403),
    [sym_unary] = STATE(5403),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2932] = {
    [sym_string] = STATE(5404),
    [aux_sym_chained_string_repeat1] = STATE(5404),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [2933] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2934] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [2935] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2936] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2937] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2938] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(8320),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [2939] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2940] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2941] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2942] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2943] = {
    [anon_sym_end] = ACTIONS(8322),
    [sym_comment] = ACTIONS(87),
  },
  [2944] = {
    [sym_when] = STATE(5407),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [2945] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5408),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(5408),
    [sym_operator_assignment] = STATE(5408),
    [sym_conditional] = STATE(5408),
    [sym_range] = STATE(5408),
    [sym_binary] = STATE(5408),
    [sym_unary] = STATE(5408),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2946] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5409),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(5409),
    [sym_operator_assignment] = STATE(5409),
    [sym_conditional] = STATE(5409),
    [sym_range] = STATE(5409),
    [sym_binary] = STATE(5409),
    [sym_unary] = STATE(5409),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2947] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5410),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(5410),
    [sym_operator_assignment] = STATE(5410),
    [sym_conditional] = STATE(5410),
    [sym_range] = STATE(5410),
    [sym_binary] = STATE(5410),
    [sym_unary] = STATE(5410),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2948] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2949] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(8332),
    [anon_sym_QMARK] = ACTIONS(8334),
    [anon_sym_DOT_DOT] = ACTIONS(8336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8338),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ_GT] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_BANG_TILDE] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8332),
    [anon_sym_GT] = ACTIONS(8332),
    [anon_sym_GT_EQ] = ACTIONS(8346),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [2950] = {
    [aux_sym_exceptions_repeat1] = STATE(5422),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(8350),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [2951] = {
    [anon_sym_EQ] = ACTIONS(8352),
    [sym_comment] = ACTIONS(87),
  },
  [2952] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8356),
    [anon_sym_DASH_EQ] = ACTIONS(8356),
    [anon_sym_STAR_EQ] = ACTIONS(8356),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8356),
    [anon_sym_SLASH_EQ] = ACTIONS(8356),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8356),
    [anon_sym_PIPE_EQ] = ACTIONS(8356),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8356),
    [anon_sym_AMP_EQ] = ACTIONS(8356),
    [anon_sym_PERCENT_EQ] = ACTIONS(8356),
    [anon_sym_GT_GT_EQ] = ACTIONS(8356),
    [anon_sym_LT_LT_EQ] = ACTIONS(8356),
    [anon_sym_CARET_EQ] = ACTIONS(8356),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2953] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [2954] = {
    [sym_string] = STATE(2954),
    [aux_sym_chained_string_repeat1] = STATE(2954),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [2955] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5425),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(5425),
    [sym_operator_assignment] = STATE(5425),
    [sym_conditional] = STATE(5425),
    [sym_range] = STATE(5425),
    [sym_binary] = STATE(5425),
    [sym_unary] = STATE(5425),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2956] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5426),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(5426),
    [sym_operator_assignment] = STATE(5426),
    [sym_conditional] = STATE(5426),
    [sym_range] = STATE(5426),
    [sym_binary] = STATE(5426),
    [sym_unary] = STATE(5426),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2957] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5432),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5433),
    [sym__argument] = STATE(5434),
    [sym_splat_argument] = STATE(5434),
    [sym_hash_splat_argument] = STATE(5434),
    [sym_block_argument] = STATE(5434),
    [sym_assignment] = STATE(5432),
    [sym_operator_assignment] = STATE(5432),
    [sym_conditional] = STATE(5432),
    [sym_range] = STATE(5432),
    [sym_binary] = STATE(5432),
    [sym_unary] = STATE(5432),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5435),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5434),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8358),
    [sym__splat_star] = ACTIONS(8360),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(8362),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(8364),
    [sym_identifier] = ACTIONS(8364),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2958] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5432),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5433),
    [sym__argument] = STATE(5434),
    [sym_splat_argument] = STATE(5434),
    [sym_hash_splat_argument] = STATE(5434),
    [sym_block_argument] = STATE(5434),
    [sym_assignment] = STATE(5432),
    [sym_operator_assignment] = STATE(5432),
    [sym_conditional] = STATE(5432),
    [sym_range] = STATE(5432),
    [sym_binary] = STATE(5432),
    [sym_unary] = STATE(5432),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5435),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5434),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8358),
    [sym__splat_star] = ACTIONS(8360),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(8362),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(8364),
    [sym_identifier] = ACTIONS(8364),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2959] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5432),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5433),
    [sym__argument] = STATE(5434),
    [sym_splat_argument] = STATE(5434),
    [sym_hash_splat_argument] = STATE(5434),
    [sym_block_argument] = STATE(5434),
    [sym_assignment] = STATE(5432),
    [sym_operator_assignment] = STATE(5432),
    [sym_conditional] = STATE(5432),
    [sym_range] = STATE(5432),
    [sym_binary] = STATE(5432),
    [sym_unary] = STATE(5432),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5435),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5434),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8358),
    [sym__splat_star] = ACTIONS(8360),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(8362),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(8364),
    [sym_identifier] = ACTIONS(8364),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2960] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5432),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5433),
    [sym__argument] = STATE(5434),
    [sym_splat_argument] = STATE(5434),
    [sym_hash_splat_argument] = STATE(5434),
    [sym_block_argument] = STATE(5434),
    [sym_assignment] = STATE(5432),
    [sym_operator_assignment] = STATE(5432),
    [sym_conditional] = STATE(5432),
    [sym_range] = STATE(5432),
    [sym_binary] = STATE(5432),
    [sym_unary] = STATE(5432),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5435),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5434),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8358),
    [sym__splat_star] = ACTIONS(8360),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(8362),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(8364),
    [sym_identifier] = ACTIONS(8364),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2961] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5436),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(5436),
    [sym_operator_assignment] = STATE(5436),
    [sym_conditional] = STATE(5436),
    [sym_range] = STATE(5436),
    [sym_binary] = STATE(5436),
    [sym_unary] = STATE(5436),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2962] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2963] = {
    [sym__then] = STATE(5438),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [aux_sym_when_repeat1] = STATE(5439),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_then] = ACTIONS(8368),
    [sym_comment] = ACTIONS(87),
  },
  [2964] = {
    [sym__line_break] = ACTIONS(8370),
    [sym__heredoc_body_start] = ACTIONS(8370),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(8370),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(8370),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(8380),
    [anon_sym_then] = ACTIONS(8370),
    [anon_sym_QMARK] = ACTIONS(8382),
    [anon_sym_DOT_DOT] = ACTIONS(8384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8386),
    [anon_sym_and] = ACTIONS(8388),
    [anon_sym_or] = ACTIONS(8388),
    [anon_sym_PIPE_PIPE] = ACTIONS(8390),
    [anon_sym_AMP_AMP] = ACTIONS(8390),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(8394),
    [anon_sym_BANG_EQ] = ACTIONS(8390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8390),
    [anon_sym_LT_EQ_GT] = ACTIONS(8390),
    [anon_sym_EQ_TILDE] = ACTIONS(8390),
    [anon_sym_BANG_TILDE] = ACTIONS(8390),
    [anon_sym_LT_EQ] = ACTIONS(8380),
    [anon_sym_GT] = ACTIONS(8380),
    [anon_sym_GT_EQ] = ACTIONS(8396),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [2965] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5455),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(5456),
    [sym__argument] = STATE(5457),
    [sym_splat_argument] = STATE(5457),
    [sym_hash_splat_argument] = STATE(5457),
    [sym_block_argument] = STATE(5457),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(5455),
    [sym_operator_assignment] = STATE(5455),
    [sym_conditional] = STATE(5455),
    [sym_range] = STATE(5455),
    [sym_binary] = STATE(5455),
    [sym_unary] = STATE(5455),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5458),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5457),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8400),
    [sym__splat_star] = ACTIONS(8402),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(8404),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(8406),
    [sym_identifier] = ACTIONS(8406),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [2966] = {
    [sym__line_break] = ACTIONS(8370),
    [sym__heredoc_body_start] = ACTIONS(8370),
    [anon_sym_COMMA] = ACTIONS(8370),
    [anon_sym_SEMI] = ACTIONS(8370),
    [anon_sym_then] = ACTIONS(8370),
    [sym_comment] = ACTIONS(87),
  },
  [2967] = {
    [anon_sym_EQ] = ACTIONS(8408),
    [sym_comment] = ACTIONS(87),
  },
  [2968] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8410),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8412),
    [anon_sym_DASH_EQ] = ACTIONS(8412),
    [anon_sym_STAR_EQ] = ACTIONS(8412),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8412),
    [anon_sym_SLASH_EQ] = ACTIONS(8412),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8412),
    [anon_sym_PIPE_EQ] = ACTIONS(8412),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8412),
    [anon_sym_AMP_EQ] = ACTIONS(8412),
    [anon_sym_PERCENT_EQ] = ACTIONS(8412),
    [anon_sym_GT_GT_EQ] = ACTIONS(8412),
    [anon_sym_LT_LT_EQ] = ACTIONS(8412),
    [anon_sym_CARET_EQ] = ACTIONS(8412),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2969] = {
    [sym_string] = STATE(5461),
    [aux_sym_chained_string_repeat1] = STATE(5461),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2970] = {
    [sym__line_break] = ACTIONS(8414),
    [sym__heredoc_body_start] = ACTIONS(8414),
    [sym__binary_minus] = ACTIONS(8414),
    [sym__binary_star] = ACTIONS(8414),
    [ts_builtin_sym_end] = ACTIONS(8414),
    [anon_sym___END__] = ACTIONS(8414),
    [anon_sym_LBRACE] = ACTIONS(8414),
    [anon_sym_RBRACE] = ACTIONS(8414),
    [anon_sym_RPAREN] = ACTIONS(8414),
    [anon_sym_DOT] = ACTIONS(8416),
    [anon_sym_COMMA] = ACTIONS(8414),
    [anon_sym_PIPE] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8414),
    [anon_sym_STAR_STAR] = ACTIONS(8414),
    [anon_sym_AMP] = ACTIONS(8416),
    [anon_sym_LT] = ACTIONS(8416),
    [anon_sym_end] = ACTIONS(8414),
    [anon_sym_if] = ACTIONS(8414),
    [anon_sym_unless] = ACTIONS(8414),
    [anon_sym_while] = ACTIONS(8414),
    [anon_sym_until] = ACTIONS(8414),
    [anon_sym_rescue] = ACTIONS(8414),
    [anon_sym_do] = ACTIONS(8414),
    [anon_sym_when] = ACTIONS(8414),
    [anon_sym_elsif] = ACTIONS(8414),
    [anon_sym_else] = ACTIONS(8414),
    [anon_sym_then] = ACTIONS(8414),
    [anon_sym_ensure] = ACTIONS(8414),
    [anon_sym_EQ_GT] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8414),
    [anon_sym_COLON_COLON2] = ACTIONS(8414),
    [anon_sym_AMP_DOT] = ACTIONS(8414),
    [anon_sym_QMARK] = ACTIONS(8414),
    [anon_sym_DOT_DOT] = ACTIONS(8416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8414),
    [anon_sym_and] = ACTIONS(8414),
    [anon_sym_or] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE] = ACTIONS(8414),
    [anon_sym_AMP_AMP] = ACTIONS(8414),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8414),
    [anon_sym_LT_EQ_GT] = ACTIONS(8414),
    [anon_sym_EQ_TILDE] = ACTIONS(8414),
    [anon_sym_BANG_TILDE] = ACTIONS(8414),
    [anon_sym_LT_EQ] = ACTIONS(8416),
    [anon_sym_GT] = ACTIONS(8416),
    [anon_sym_GT_EQ] = ACTIONS(8414),
    [anon_sym_CARET] = ACTIONS(8414),
    [anon_sym_PLUS] = ACTIONS(8414),
    [anon_sym_SLASH] = ACTIONS(8414),
    [anon_sym_PERCENT] = ACTIONS(8414),
    [sym_comment] = ACTIONS(87),
  },
  [2971] = {
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(8418),
    [anon_sym_when] = ACTIONS(8421),
    [sym_comment] = ACTIONS(87),
  },
  [2972] = {
    [sym__simple_symbol] = ACTIONS(6547),
    [sym__string_start] = ACTIONS(6547),
    [sym__symbol_start] = ACTIONS(6547),
    [sym__subshell_start] = ACTIONS(6547),
    [sym__regex_start] = ACTIONS(6547),
    [sym__string_array_start] = ACTIONS(6547),
    [sym__symbol_array_start] = ACTIONS(6547),
    [sym_heredoc_beginning] = ACTIONS(6547),
    [sym__unary_minus] = ACTIONS(6547),
    [ts_builtin_sym_end] = ACTIONS(6547),
    [anon_sym___END__] = ACTIONS(8423),
    [anon_sym_BEGIN] = ACTIONS(8423),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_END] = ACTIONS(8423),
    [anon_sym_def] = ACTIONS(8423),
    [anon_sym_LPAREN] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_COLON_COLON] = ACTIONS(6547),
    [anon_sym_PIPE] = ACTIONS(6547),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym_STAR] = ACTIONS(6547),
    [anon_sym_class] = ACTIONS(8423),
    [anon_sym_module] = ACTIONS(8423),
    [anon_sym_end] = ACTIONS(8423),
    [anon_sym_return] = ACTIONS(8423),
    [anon_sym_yield] = ACTIONS(8423),
    [anon_sym_break] = ACTIONS(8423),
    [anon_sym_next] = ACTIONS(8423),
    [sym_redo] = ACTIONS(8423),
    [sym_retry] = ACTIONS(8423),
    [anon_sym_if] = ACTIONS(8423),
    [anon_sym_unless] = ACTIONS(8423),
    [anon_sym_while] = ACTIONS(8423),
    [anon_sym_until] = ACTIONS(8423),
    [anon_sym_rescue] = ACTIONS(8423),
    [anon_sym_for] = ACTIONS(8423),
    [anon_sym_case] = ACTIONS(8423),
    [anon_sym_when] = ACTIONS(8423),
    [anon_sym_elsif] = ACTIONS(8423),
    [anon_sym_else] = ACTIONS(8423),
    [anon_sym_then] = ACTIONS(8423),
    [anon_sym_begin] = ACTIONS(8423),
    [anon_sym_ensure] = ACTIONS(8423),
    [anon_sym_PLUS] = ACTIONS(8423),
    [anon_sym_defined_QMARK] = ACTIONS(6547),
    [anon_sym_not] = ACTIONS(8423),
    [anon_sym_BANG] = ACTIONS(6547),
    [anon_sym_TILDE] = ACTIONS(6547),
    [sym_constant] = ACTIONS(8423),
    [sym_identifier] = ACTIONS(8423),
    [sym_instance_variable] = ACTIONS(6547),
    [sym_class_variable] = ACTIONS(6547),
    [sym_global_variable] = ACTIONS(6547),
    [anon_sym_undef] = ACTIONS(8423),
    [anon_sym_alias] = ACTIONS(8423),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8423),
    [sym_float] = ACTIONS(8423),
    [sym_complex] = ACTIONS(6547),
    [sym_super] = ACTIONS(8423),
    [anon_sym_true] = ACTIONS(8423),
    [anon_sym_TRUE] = ACTIONS(8423),
    [anon_sym_false] = ACTIONS(8423),
    [anon_sym_FALSE] = ACTIONS(8423),
    [sym_self] = ACTIONS(8423),
    [anon_sym_nil] = ACTIONS(8423),
    [anon_sym_NIL] = ACTIONS(8423),
    [sym_character] = ACTIONS(6547),
    [anon_sym_LBRACK2] = ACTIONS(6547),
    [anon_sym_DASH_GT] = ACTIONS(6547),
  },
  [2973] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5462),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(5462),
    [sym_operator_assignment] = STATE(5462),
    [sym_conditional] = STATE(5462),
    [sym_range] = STATE(5462),
    [sym_binary] = STATE(5462),
    [sym_unary] = STATE(5462),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2974] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1146),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5463),
    [sym__argument] = STATE(5464),
    [sym_splat_argument] = STATE(5464),
    [sym_hash_splat_argument] = STATE(5464),
    [sym_block_argument] = STATE(5464),
    [sym_assignment] = STATE(1146),
    [sym_operator_assignment] = STATE(1146),
    [sym_conditional] = STATE(1146),
    [sym_range] = STATE(1146),
    [sym_binary] = STATE(1146),
    [sym_unary] = STATE(1146),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1152),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5464),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2051),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2975] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1146),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5463),
    [sym__argument] = STATE(5464),
    [sym_splat_argument] = STATE(5464),
    [sym_hash_splat_argument] = STATE(5464),
    [sym_block_argument] = STATE(5464),
    [sym_assignment] = STATE(1146),
    [sym_operator_assignment] = STATE(1146),
    [sym_conditional] = STATE(1146),
    [sym_range] = STATE(1146),
    [sym_binary] = STATE(1146),
    [sym_unary] = STATE(1146),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1152),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5464),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2051),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2976] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1146),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5463),
    [sym__argument] = STATE(5464),
    [sym_splat_argument] = STATE(5464),
    [sym_hash_splat_argument] = STATE(5464),
    [sym_block_argument] = STATE(5464),
    [sym_assignment] = STATE(1146),
    [sym_operator_assignment] = STATE(1146),
    [sym_conditional] = STATE(1146),
    [sym_range] = STATE(1146),
    [sym_binary] = STATE(1146),
    [sym_unary] = STATE(1146),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1152),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5464),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2051),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2977] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1146),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5463),
    [sym__argument] = STATE(5464),
    [sym_splat_argument] = STATE(5464),
    [sym_hash_splat_argument] = STATE(5464),
    [sym_block_argument] = STATE(5464),
    [sym_assignment] = STATE(1146),
    [sym_operator_assignment] = STATE(1146),
    [sym_conditional] = STATE(1146),
    [sym_range] = STATE(1146),
    [sym_binary] = STATE(1146),
    [sym_unary] = STATE(1146),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1152),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5464),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2051),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2978] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5465),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(5465),
    [sym_operator_assignment] = STATE(5465),
    [sym_conditional] = STATE(5465),
    [sym_range] = STATE(5465),
    [sym_binary] = STATE(5465),
    [sym_unary] = STATE(5465),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2979] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2980] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_ensure] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8435),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [2981] = {
    [anon_sym_EQ] = ACTIONS(8451),
    [sym_comment] = ACTIONS(87),
  },
  [2982] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8453),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8455),
    [anon_sym_DASH_EQ] = ACTIONS(8455),
    [anon_sym_STAR_EQ] = ACTIONS(8455),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8455),
    [anon_sym_SLASH_EQ] = ACTIONS(8455),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8455),
    [anon_sym_PIPE_EQ] = ACTIONS(8455),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8455),
    [anon_sym_AMP_EQ] = ACTIONS(8455),
    [anon_sym_PERCENT_EQ] = ACTIONS(8455),
    [anon_sym_GT_GT_EQ] = ACTIONS(8455),
    [anon_sym_LT_LT_EQ] = ACTIONS(8455),
    [anon_sym_CARET_EQ] = ACTIONS(8455),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2983] = {
    [sym_string] = STATE(5478),
    [aux_sym_chained_string_repeat1] = STATE(5478),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2984] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_ensure] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8435),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [2985] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [2986] = {
    [sym_string] = STATE(3024),
    [aux_sym_chained_string_repeat1] = STATE(3024),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2987] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5479),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(5479),
    [sym_operator_assignment] = STATE(5479),
    [sym_conditional] = STATE(5479),
    [sym_range] = STATE(5479),
    [sym_binary] = STATE(5479),
    [sym_unary] = STATE(5479),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2988] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_ensure] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8435),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [2989] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5480),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5480),
    [sym_operator_assignment] = STATE(5480),
    [sym_conditional] = STATE(5480),
    [sym_range] = STATE(5480),
    [sym_binary] = STATE(5480),
    [sym_unary] = STATE(5480),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2990] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5481),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5481),
    [sym_operator_assignment] = STATE(5481),
    [sym_conditional] = STATE(5481),
    [sym_range] = STATE(5481),
    [sym_binary] = STATE(5481),
    [sym_unary] = STATE(5481),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2991] = {
    [anon_sym_COLON] = ACTIONS(8457),
    [sym_comment] = ACTIONS(87),
  },
  [2992] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5483),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5483),
    [sym_operator_assignment] = STATE(5483),
    [sym_conditional] = STATE(5483),
    [sym_range] = STATE(5483),
    [sym_binary] = STATE(5483),
    [sym_unary] = STATE(5483),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2993] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8459),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [2994] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_ensure] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [2995] = {
    [sym_heredoc_body] = STATE(5485),
    [aux_sym_call_repeat1] = STATE(5485),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2996] = {
    [sym_heredoc_body] = STATE(5485),
    [aux_sym_call_repeat1] = STATE(5485),
    [aux_sym_argument_list_repeat1] = STATE(5487),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8461),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [2997] = {
    [sym_string] = STATE(3024),
    [aux_sym_chained_string_repeat1] = STATE(3024),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8463),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2998] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [2999] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5488),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(5488),
    [sym_operator_assignment] = STATE(5488),
    [sym_conditional] = STATE(5488),
    [sym_range] = STATE(5488),
    [sym_binary] = STATE(5488),
    [sym_unary] = STATE(5488),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3000] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5489),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5489),
    [sym_operator_assignment] = STATE(5489),
    [sym_conditional] = STATE(5489),
    [sym_range] = STATE(5489),
    [sym_binary] = STATE(5489),
    [sym_unary] = STATE(5489),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3001] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5490),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5490),
    [sym_operator_assignment] = STATE(5490),
    [sym_conditional] = STATE(5490),
    [sym_range] = STATE(5490),
    [sym_binary] = STATE(5490),
    [sym_unary] = STATE(5490),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3002] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5491),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5491),
    [sym_operator_assignment] = STATE(5491),
    [sym_conditional] = STATE(5491),
    [sym_range] = STATE(5491),
    [sym_binary] = STATE(5491),
    [sym_unary] = STATE(5491),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3003] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5492),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5492),
    [sym_operator_assignment] = STATE(5492),
    [sym_conditional] = STATE(5492),
    [sym_range] = STATE(5492),
    [sym_binary] = STATE(5492),
    [sym_unary] = STATE(5492),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3004] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5493),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5493),
    [sym_operator_assignment] = STATE(5493),
    [sym_conditional] = STATE(5493),
    [sym_range] = STATE(5493),
    [sym_binary] = STATE(5493),
    [sym_unary] = STATE(5493),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3005] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5494),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5494),
    [sym_operator_assignment] = STATE(5494),
    [sym_conditional] = STATE(5494),
    [sym_range] = STATE(5494),
    [sym_binary] = STATE(5494),
    [sym_unary] = STATE(5494),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3006] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5495),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5495),
    [sym_operator_assignment] = STATE(5495),
    [sym_conditional] = STATE(5495),
    [sym_range] = STATE(5495),
    [sym_binary] = STATE(5495),
    [sym_unary] = STATE(5495),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3007] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5496),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5496),
    [sym_operator_assignment] = STATE(5496),
    [sym_conditional] = STATE(5496),
    [sym_range] = STATE(5496),
    [sym_binary] = STATE(5496),
    [sym_unary] = STATE(5496),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3008] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5497),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5497),
    [sym_operator_assignment] = STATE(5497),
    [sym_conditional] = STATE(5497),
    [sym_range] = STATE(5497),
    [sym_binary] = STATE(5497),
    [sym_unary] = STATE(5497),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3009] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5498),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5498),
    [sym_operator_assignment] = STATE(5498),
    [sym_conditional] = STATE(5498),
    [sym_range] = STATE(5498),
    [sym_binary] = STATE(5498),
    [sym_unary] = STATE(5498),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3010] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5499),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5499),
    [sym_operator_assignment] = STATE(5499),
    [sym_conditional] = STATE(5499),
    [sym_range] = STATE(5499),
    [sym_binary] = STATE(5499),
    [sym_unary] = STATE(5499),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3011] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5500),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5500),
    [sym_operator_assignment] = STATE(5500),
    [sym_conditional] = STATE(5500),
    [sym_range] = STATE(5500),
    [sym_binary] = STATE(5500),
    [sym_unary] = STATE(5500),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3012] = {
    [anon_sym_COLON] = ACTIONS(8465),
    [sym_comment] = ACTIONS(87),
  },
  [3013] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5502),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5502),
    [sym_operator_assignment] = STATE(5502),
    [sym_conditional] = STATE(5502),
    [sym_range] = STATE(5502),
    [sym_binary] = STATE(5502),
    [sym_unary] = STATE(5502),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3014] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8467),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3015] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_ensure] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [3016] = {
    [sym_heredoc_body] = STATE(5504),
    [aux_sym_call_repeat1] = STATE(5504),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3017] = {
    [sym_heredoc_body] = STATE(5504),
    [aux_sym_call_repeat1] = STATE(5504),
    [aux_sym_argument_list_repeat1] = STATE(5506),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8469),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3018] = {
    [sym_string] = STATE(3264),
    [aux_sym_chained_string_repeat1] = STATE(3264),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8471),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3019] = {
    [sym_heredoc_body] = STATE(5507),
    [aux_sym_call_repeat1] = STATE(5507),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [3020] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1146),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(1146),
    [sym_operator_assignment] = STATE(1146),
    [sym_conditional] = STATE(1146),
    [sym_range] = STATE(1146),
    [sym_binary] = STATE(1146),
    [sym_unary] = STATE(1146),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1152),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(5508),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2051),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8473),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3021] = {
    [sym_heredoc_body] = STATE(5509),
    [aux_sym_call_repeat1] = STATE(5509),
    [aux_sym_argument_list_repeat1] = STATE(5510),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4924),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [3022] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5511),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_splat_argument] = STATE(5512),
    [sym_assignment] = STATE(5511),
    [sym_operator_assignment] = STATE(5511),
    [sym_conditional] = STATE(5511),
    [sym_range] = STATE(5511),
    [sym_binary] = STATE(5511),
    [sym_unary] = STATE(5511),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(5512),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(4882),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3023] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5513),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(5513),
    [sym_operator_assignment] = STATE(5513),
    [sym_conditional] = STATE(5513),
    [sym_range] = STATE(5513),
    [sym_binary] = STATE(5513),
    [sym_unary] = STATE(5513),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3024] = {
    [sym_string] = STATE(5514),
    [aux_sym_chained_string_repeat1] = STATE(5514),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_ensure] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [3025] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_and] = ACTIONS(4988),
    [anon_sym_or] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_EQ_TILDE] = ACTIONS(4990),
    [anon_sym_BANG_TILDE] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [3026] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3027] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5515),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(5515),
    [sym_operator_assignment] = STATE(5515),
    [sym_conditional] = STATE(5515),
    [sym_range] = STATE(5515),
    [sym_binary] = STATE(5515),
    [sym_unary] = STATE(5515),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3028] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5516),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(5516),
    [sym_operator_assignment] = STATE(5516),
    [sym_conditional] = STATE(5516),
    [sym_range] = STATE(5516),
    [sym_binary] = STATE(5516),
    [sym_unary] = STATE(5516),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3029] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5517),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(5517),
    [sym_operator_assignment] = STATE(5517),
    [sym_conditional] = STATE(5517),
    [sym_range] = STATE(5517),
    [sym_binary] = STATE(5517),
    [sym_unary] = STATE(5517),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3030] = {
    [anon_sym_COLON] = ACTIONS(8477),
    [sym_comment] = ACTIONS(87),
  },
  [3031] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5519),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(5519),
    [sym_operator_assignment] = STATE(5519),
    [sym_conditional] = STATE(5519),
    [sym_range] = STATE(5519),
    [sym_binary] = STATE(5519),
    [sym_unary] = STATE(5519),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3032] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5520),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(5520),
    [sym_operator_assignment] = STATE(5520),
    [sym_conditional] = STATE(5520),
    [sym_range] = STATE(5520),
    [sym_binary] = STATE(5520),
    [sym_unary] = STATE(5520),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3033] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3034] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8479),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3035] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [3036] = {
    [sym_heredoc_body] = STATE(5532),
    [aux_sym_call_repeat1] = STATE(5532),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3037] = {
    [sym_heredoc_body] = STATE(5532),
    [aux_sym_call_repeat1] = STATE(5532),
    [aux_sym_argument_list_repeat1] = STATE(5534),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8507),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3038] = {
    [anon_sym_EQ] = ACTIONS(8509),
    [sym_comment] = ACTIONS(87),
  },
  [3039] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8511),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8513),
    [anon_sym_DASH_EQ] = ACTIONS(8513),
    [anon_sym_STAR_EQ] = ACTIONS(8513),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8513),
    [anon_sym_SLASH_EQ] = ACTIONS(8513),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8513),
    [anon_sym_PIPE_EQ] = ACTIONS(8513),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8513),
    [anon_sym_AMP_EQ] = ACTIONS(8513),
    [anon_sym_PERCENT_EQ] = ACTIONS(8513),
    [anon_sym_GT_GT_EQ] = ACTIONS(8513),
    [anon_sym_LT_LT_EQ] = ACTIONS(8513),
    [anon_sym_CARET_EQ] = ACTIONS(8513),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3040] = {
    [sym_string] = STATE(3085),
    [aux_sym_chained_string_repeat1] = STATE(3085),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8515),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3041] = {
    [sym__line_break] = ACTIONS(565),
    [sym__heredoc_body_start] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(565),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [sym_comment] = ACTIONS(87),
  },
  [3042] = {
    [sym__line_break] = ACTIONS(569),
    [sym__heredoc_body_start] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(569),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_then] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [sym_comment] = ACTIONS(87),
  },
  [3043] = {
    [sym__line_break] = ACTIONS(573),
    [sym__heredoc_body_start] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_then] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [sym_comment] = ACTIONS(87),
  },
  [3044] = {
    [anon_sym_DOT] = ACTIONS(8517),
    [anon_sym_LBRACK] = ACTIONS(8519),
    [anon_sym_COLON_COLON2] = ACTIONS(1521),
    [anon_sym_AMP_DOT] = ACTIONS(8517),
    [sym_comment] = ACTIONS(87),
  },
  [3045] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5553),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_argument_list] = STATE(5554),
    [sym__argument_list_with_parens] = STATE(5555),
    [sym__argument] = STATE(5556),
    [sym_splat_argument] = STATE(5556),
    [sym_hash_splat_argument] = STATE(5556),
    [sym_block_argument] = STATE(5556),
    [sym_do_block] = STATE(5557),
    [sym_block] = STATE(5557),
    [sym_assignment] = STATE(5553),
    [sym_operator_assignment] = STATE(5553),
    [sym_conditional] = STATE(5553),
    [sym_range] = STATE(5553),
    [sym_binary] = STATE(5553),
    [sym_unary] = STATE(5553),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5560),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5556),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8521),
    [sym__splat_star] = ACTIONS(8523),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__identifier_hash_key] = ACTIONS(8527),
    [anon_sym_LBRACE] = ACTIONS(8529),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8531),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(7060),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(8541),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(8551),
    [sym_identifier] = ACTIONS(8551),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3046] = {
    [sym__line_break] = ACTIONS(8553),
    [sym__heredoc_body_start] = ACTIONS(8553),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_SEMI] = ACTIONS(8553),
    [anon_sym_then] = ACTIONS(8553),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3047] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_EQ_TILDE] = ACTIONS(4990),
    [anon_sym_BANG_TILDE] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [3048] = {
    [sym_rescue] = STATE(5561),
    [anon_sym_end] = ACTIONS(8555),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(8555),
    [anon_sym_ensure] = ACTIONS(8555),
    [sym_comment] = ACTIONS(87),
  },
  [3049] = {
    [anon_sym_end] = ACTIONS(8555),
    [anon_sym_else] = ACTIONS(8555),
    [anon_sym_ensure] = ACTIONS(8555),
    [sym_comment] = ACTIONS(87),
  },
  [3050] = {
    [sym__statements] = STATE(5562),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym_rescue] = STATE(5561),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8557),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(8557),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(8557),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3051] = {
    [sym__then] = STATE(5563),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_then] = ACTIONS(8559),
    [sym_comment] = ACTIONS(87),
  },
  [3052] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5564),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(5564),
    [sym_operator_assignment] = STATE(5564),
    [sym_conditional] = STATE(5564),
    [sym_range] = STATE(5564),
    [sym_binary] = STATE(5564),
    [sym_unary] = STATE(5564),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3053] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5565),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(5565),
    [sym_operator_assignment] = STATE(5565),
    [sym_conditional] = STATE(5565),
    [sym_range] = STATE(5565),
    [sym_binary] = STATE(5565),
    [sym_unary] = STATE(5565),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3054] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5566),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(5566),
    [sym_operator_assignment] = STATE(5566),
    [sym_conditional] = STATE(5566),
    [sym_range] = STATE(5566),
    [sym_binary] = STATE(5566),
    [sym_unary] = STATE(5566),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3055] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5567),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(5567),
    [sym_operator_assignment] = STATE(5567),
    [sym_conditional] = STATE(5567),
    [sym_range] = STATE(5567),
    [sym_binary] = STATE(5567),
    [sym_unary] = STATE(5567),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3056] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5568),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(5568),
    [sym_operator_assignment] = STATE(5568),
    [sym_conditional] = STATE(5568),
    [sym_range] = STATE(5568),
    [sym_binary] = STATE(5568),
    [sym_unary] = STATE(5568),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3057] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5569),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5569),
    [sym_operator_assignment] = STATE(5569),
    [sym_conditional] = STATE(5569),
    [sym_range] = STATE(5569),
    [sym_binary] = STATE(5569),
    [sym_unary] = STATE(5569),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3058] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5570),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(5570),
    [sym_operator_assignment] = STATE(5570),
    [sym_conditional] = STATE(5570),
    [sym_range] = STATE(5570),
    [sym_binary] = STATE(5570),
    [sym_unary] = STATE(5570),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3059] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5571),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(5571),
    [sym_operator_assignment] = STATE(5571),
    [sym_conditional] = STATE(5571),
    [sym_range] = STATE(5571),
    [sym_binary] = STATE(5571),
    [sym_unary] = STATE(5571),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3060] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5572),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(5572),
    [sym_operator_assignment] = STATE(5572),
    [sym_conditional] = STATE(5572),
    [sym_range] = STATE(5572),
    [sym_binary] = STATE(5572),
    [sym_unary] = STATE(5572),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3061] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5573),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(5573),
    [sym_operator_assignment] = STATE(5573),
    [sym_conditional] = STATE(5573),
    [sym_range] = STATE(5573),
    [sym_binary] = STATE(5573),
    [sym_unary] = STATE(5573),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3062] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5574),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(5574),
    [sym_operator_assignment] = STATE(5574),
    [sym_conditional] = STATE(5574),
    [sym_range] = STATE(5574),
    [sym_binary] = STATE(5574),
    [sym_unary] = STATE(5574),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3063] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5576),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(5576),
    [sym_operator_assignment] = STATE(5576),
    [sym_conditional] = STATE(5576),
    [sym_range] = STATE(5576),
    [sym_binary] = STATE(5576),
    [sym_unary] = STATE(5576),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3064] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5577),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(5577),
    [sym_operator_assignment] = STATE(5577),
    [sym_conditional] = STATE(5577),
    [sym_range] = STATE(5577),
    [sym_binary] = STATE(5577),
    [sym_unary] = STATE(5577),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3065] = {
    [anon_sym_COLON] = ACTIONS(8563),
    [sym_comment] = ACTIONS(87),
  },
  [3066] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5579),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(5579),
    [sym_operator_assignment] = STATE(5579),
    [sym_conditional] = STATE(5579),
    [sym_range] = STATE(5579),
    [sym_binary] = STATE(5579),
    [sym_unary] = STATE(5579),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3067] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3074),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(3076),
    [sym__argument] = STATE(3077),
    [sym_splat_argument] = STATE(3077),
    [sym_hash_splat_argument] = STATE(3077),
    [sym_block_argument] = STATE(3077),
    [sym_assignment] = STATE(3074),
    [sym_operator_assignment] = STATE(3074),
    [sym_conditional] = STATE(3074),
    [sym_range] = STATE(3074),
    [sym_binary] = STATE(3074),
    [sym_unary] = STATE(3074),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3080),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3077),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5000),
    [sym__splat_star] = ACTIONS(5002),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5024),
    [sym_identifier] = ACTIONS(5024),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3068] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3074),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(3076),
    [sym__argument] = STATE(3077),
    [sym_splat_argument] = STATE(3077),
    [sym_hash_splat_argument] = STATE(3077),
    [sym_block_argument] = STATE(3077),
    [sym_assignment] = STATE(3074),
    [sym_operator_assignment] = STATE(3074),
    [sym_conditional] = STATE(3074),
    [sym_range] = STATE(3074),
    [sym_binary] = STATE(3074),
    [sym_unary] = STATE(3074),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3080),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3077),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5000),
    [sym__splat_star] = ACTIONS(5002),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5024),
    [sym_identifier] = ACTIONS(5024),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3069] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3074),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(3076),
    [sym__argument] = STATE(3077),
    [sym_splat_argument] = STATE(3077),
    [sym_hash_splat_argument] = STATE(3077),
    [sym_block_argument] = STATE(3077),
    [sym_assignment] = STATE(3074),
    [sym_operator_assignment] = STATE(3074),
    [sym_conditional] = STATE(3074),
    [sym_range] = STATE(3074),
    [sym_binary] = STATE(3074),
    [sym_unary] = STATE(3074),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3080),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3077),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5000),
    [sym__splat_star] = ACTIONS(5002),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5024),
    [sym_identifier] = ACTIONS(5024),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3070] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3074),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(3076),
    [sym__argument] = STATE(3077),
    [sym_splat_argument] = STATE(3077),
    [sym_hash_splat_argument] = STATE(3077),
    [sym_block_argument] = STATE(3077),
    [sym_assignment] = STATE(3074),
    [sym_operator_assignment] = STATE(3074),
    [sym_conditional] = STATE(3074),
    [sym_range] = STATE(3074),
    [sym_binary] = STATE(3074),
    [sym_unary] = STATE(3074),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3080),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3077),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5000),
    [sym__splat_star] = ACTIONS(5002),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5024),
    [sym_identifier] = ACTIONS(5024),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3071] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5580),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(5580),
    [sym_operator_assignment] = STATE(5580),
    [sym_conditional] = STATE(5580),
    [sym_range] = STATE(5580),
    [sym_binary] = STATE(5580),
    [sym_unary] = STATE(5580),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3072] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3073] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8565),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3074] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [3075] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3074),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(3076),
    [sym__argument] = STATE(3077),
    [sym_splat_argument] = STATE(3077),
    [sym_hash_splat_argument] = STATE(3077),
    [sym_block_argument] = STATE(3077),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(3074),
    [sym_operator_assignment] = STATE(3074),
    [sym_conditional] = STATE(3074),
    [sym_range] = STATE(3074),
    [sym_binary] = STATE(3074),
    [sym_unary] = STATE(3074),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3080),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3077),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5000),
    [sym__splat_star] = ACTIONS(5002),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5024),
    [sym_identifier] = ACTIONS(5024),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3076] = {
    [sym_heredoc_body] = STATE(5592),
    [aux_sym_call_repeat1] = STATE(5592),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3077] = {
    [sym_heredoc_body] = STATE(5592),
    [aux_sym_call_repeat1] = STATE(5592),
    [aux_sym_argument_list_repeat1] = STATE(5594),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8595),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3078] = {
    [anon_sym_EQ] = ACTIONS(8597),
    [sym_comment] = ACTIONS(87),
  },
  [3079] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8599),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8601),
    [anon_sym_DASH_EQ] = ACTIONS(8601),
    [anon_sym_STAR_EQ] = ACTIONS(8601),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8601),
    [anon_sym_SLASH_EQ] = ACTIONS(8601),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8601),
    [anon_sym_PIPE_EQ] = ACTIONS(8601),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8601),
    [anon_sym_AMP_EQ] = ACTIONS(8601),
    [anon_sym_PERCENT_EQ] = ACTIONS(8601),
    [anon_sym_GT_GT_EQ] = ACTIONS(8601),
    [anon_sym_LT_LT_EQ] = ACTIONS(8601),
    [anon_sym_CARET_EQ] = ACTIONS(8601),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3080] = {
    [sym_string] = STATE(5597),
    [aux_sym_chained_string_repeat1] = STATE(5597),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8603),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3081] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1165),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_splat_argument] = STATE(5598),
    [sym_assignment] = STATE(1165),
    [sym_operator_assignment] = STATE(1165),
    [sym_conditional] = STATE(1165),
    [sym_range] = STATE(1165),
    [sym_binary] = STATE(1165),
    [sym_unary] = STATE(1165),
    [sym__arg_or_splat_arg] = STATE(5598),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(2081),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3082] = {
    [aux_sym_exceptions_repeat1] = STATE(5599),
    [sym__line_break] = ACTIONS(8605),
    [sym__heredoc_body_start] = ACTIONS(8605),
    [anon_sym_COMMA] = ACTIONS(5032),
    [anon_sym_SEMI] = ACTIONS(8605),
    [anon_sym_then] = ACTIONS(8605),
    [anon_sym_EQ_GT] = ACTIONS(8605),
    [sym_comment] = ACTIONS(87),
  },
  [3083] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5601),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_splat_argument] = STATE(5602),
    [sym_assignment] = STATE(5601),
    [sym_operator_assignment] = STATE(5601),
    [sym_conditional] = STATE(5601),
    [sym_range] = STATE(5601),
    [sym_binary] = STATE(5601),
    [sym_unary] = STATE(5601),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(5602),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(8607),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3084] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5603),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(5603),
    [sym_operator_assignment] = STATE(5603),
    [sym_conditional] = STATE(5603),
    [sym_range] = STATE(5603),
    [sym_binary] = STATE(5603),
    [sym_unary] = STATE(5603),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3085] = {
    [sym_string] = STATE(5604),
    [aux_sym_chained_string_repeat1] = STATE(5604),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [3086] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3087] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5612),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(5612),
    [sym_operator_assignment] = STATE(5612),
    [sym_conditional] = STATE(5612),
    [sym_range] = STATE(5612),
    [sym_binary] = STATE(5612),
    [sym_unary] = STATE(5612),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3088] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5616),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(5616),
    [sym_operator_assignment] = STATE(5616),
    [sym_conditional] = STATE(5616),
    [sym_range] = STATE(5616),
    [sym_binary] = STATE(5616),
    [sym_unary] = STATE(5616),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3089] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5617),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(5617),
    [sym_operator_assignment] = STATE(5617),
    [sym_conditional] = STATE(5617),
    [sym_range] = STATE(5617),
    [sym_binary] = STATE(5617),
    [sym_unary] = STATE(5617),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3090] = {
    [anon_sym_COLON] = ACTIONS(8629),
    [sym_comment] = ACTIONS(87),
  },
  [3091] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5620),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(5620),
    [sym_operator_assignment] = STATE(5620),
    [sym_conditional] = STATE(5620),
    [sym_range] = STATE(5620),
    [sym_binary] = STATE(5620),
    [sym_unary] = STATE(5620),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3092] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5626),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5627),
    [sym__argument] = STATE(5628),
    [sym_splat_argument] = STATE(5628),
    [sym_hash_splat_argument] = STATE(5628),
    [sym_block_argument] = STATE(5628),
    [sym_assignment] = STATE(5626),
    [sym_operator_assignment] = STATE(5626),
    [sym_conditional] = STATE(5626),
    [sym_range] = STATE(5626),
    [sym_binary] = STATE(5626),
    [sym_unary] = STATE(5626),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5629),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5628),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8631),
    [sym__splat_star] = ACTIONS(8633),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(8635),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(8637),
    [sym_identifier] = ACTIONS(8637),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3093] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5626),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5627),
    [sym__argument] = STATE(5628),
    [sym_splat_argument] = STATE(5628),
    [sym_hash_splat_argument] = STATE(5628),
    [sym_block_argument] = STATE(5628),
    [sym_assignment] = STATE(5626),
    [sym_operator_assignment] = STATE(5626),
    [sym_conditional] = STATE(5626),
    [sym_range] = STATE(5626),
    [sym_binary] = STATE(5626),
    [sym_unary] = STATE(5626),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5629),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5628),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8631),
    [sym__splat_star] = ACTIONS(8633),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(8635),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(8637),
    [sym_identifier] = ACTIONS(8637),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3094] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5626),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5627),
    [sym__argument] = STATE(5628),
    [sym_splat_argument] = STATE(5628),
    [sym_hash_splat_argument] = STATE(5628),
    [sym_block_argument] = STATE(5628),
    [sym_assignment] = STATE(5626),
    [sym_operator_assignment] = STATE(5626),
    [sym_conditional] = STATE(5626),
    [sym_range] = STATE(5626),
    [sym_binary] = STATE(5626),
    [sym_unary] = STATE(5626),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5629),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5628),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8631),
    [sym__splat_star] = ACTIONS(8633),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(8635),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(8637),
    [sym_identifier] = ACTIONS(8637),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3095] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5626),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5627),
    [sym__argument] = STATE(5628),
    [sym_splat_argument] = STATE(5628),
    [sym_hash_splat_argument] = STATE(5628),
    [sym_block_argument] = STATE(5628),
    [sym_assignment] = STATE(5626),
    [sym_operator_assignment] = STATE(5626),
    [sym_conditional] = STATE(5626),
    [sym_range] = STATE(5626),
    [sym_binary] = STATE(5626),
    [sym_unary] = STATE(5626),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5629),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5628),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8631),
    [sym__splat_star] = ACTIONS(8633),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(8635),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(8637),
    [sym_identifier] = ACTIONS(8637),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3096] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5630),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(5630),
    [sym_operator_assignment] = STATE(5630),
    [sym_conditional] = STATE(5630),
    [sym_range] = STATE(5630),
    [sym_binary] = STATE(5630),
    [sym_unary] = STATE(5630),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3097] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3098] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8639),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3099] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_ensure] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(8629),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [3100] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5647),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(5648),
    [sym__argument] = STATE(5649),
    [sym_splat_argument] = STATE(5649),
    [sym_hash_splat_argument] = STATE(5649),
    [sym_block_argument] = STATE(5649),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(5647),
    [sym_operator_assignment] = STATE(5647),
    [sym_conditional] = STATE(5647),
    [sym_range] = STATE(5647),
    [sym_binary] = STATE(5647),
    [sym_unary] = STATE(5647),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5650),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5649),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8667),
    [sym__splat_star] = ACTIONS(8669),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(8671),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(771),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(8673),
    [sym_identifier] = ACTIONS(8673),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3101] = {
    [sym_heredoc_body] = STATE(5651),
    [aux_sym_call_repeat1] = STATE(5651),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3102] = {
    [sym_heredoc_body] = STATE(5651),
    [aux_sym_call_repeat1] = STATE(5651),
    [aux_sym_argument_list_repeat1] = STATE(5653),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8675),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3103] = {
    [anon_sym_EQ] = ACTIONS(8677),
    [sym_comment] = ACTIONS(87),
  },
  [3104] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8679),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8681),
    [anon_sym_DASH_EQ] = ACTIONS(8681),
    [anon_sym_STAR_EQ] = ACTIONS(8681),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8681),
    [anon_sym_SLASH_EQ] = ACTIONS(8681),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8681),
    [anon_sym_PIPE_EQ] = ACTIONS(8681),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8681),
    [anon_sym_AMP_EQ] = ACTIONS(8681),
    [anon_sym_PERCENT_EQ] = ACTIONS(8681),
    [anon_sym_GT_GT_EQ] = ACTIONS(8681),
    [anon_sym_LT_LT_EQ] = ACTIONS(8681),
    [anon_sym_CARET_EQ] = ACTIONS(8681),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3105] = {
    [sym_string] = STATE(5656),
    [aux_sym_chained_string_repeat1] = STATE(5656),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8683),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3106] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [3107] = {
    [aux_sym_undef_repeat1] = STATE(5657),
    [sym__line_break] = ACTIONS(2257),
    [sym__heredoc_body_start] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_end] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [anon_sym_ensure] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [3108] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(1182),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1182),
    [sym_unless_modifier] = STATE(1182),
    [sym_while_modifier] = STATE(1182),
    [sym_until_modifier] = STATE(1182),
    [sym_rescue_modifier] = STATE(1182),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1183),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(1183),
    [sym_operator_assignment] = STATE(1183),
    [sym_conditional] = STATE(1183),
    [sym_range] = STATE(1183),
    [sym_binary] = STATE(1183),
    [sym_unary] = STATE(1183),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_undef] = STATE(1182),
    [sym_alias] = STATE(1182),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1182),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2499),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(2499),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [anon_sym_undef] = ACTIONS(2137),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3109] = {
    [sym_heredoc_body] = STATE(5658),
    [sym__terminator] = STATE(5658),
    [aux_sym__statements_repeat1] = STATE(5659),
    [sym__line_break] = ACTIONS(8685),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(8685),
    [anon_sym_end] = ACTIONS(2497),
    [anon_sym_ensure] = ACTIONS(2497),
    [sym_comment] = ACTIONS(87),
  },
  [3110] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5660),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5660),
    [sym_operator_assignment] = STATE(5660),
    [sym_conditional] = STATE(5660),
    [sym_range] = STATE(5660),
    [sym_binary] = STATE(5660),
    [sym_unary] = STATE(5660),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3111] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5661),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5661),
    [sym_operator_assignment] = STATE(5661),
    [sym_conditional] = STATE(5661),
    [sym_range] = STATE(5661),
    [sym_binary] = STATE(5661),
    [sym_unary] = STATE(5661),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3112] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5662),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5662),
    [sym_operator_assignment] = STATE(5662),
    [sym_conditional] = STATE(5662),
    [sym_range] = STATE(5662),
    [sym_binary] = STATE(5662),
    [sym_unary] = STATE(5662),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3113] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5663),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5663),
    [sym_operator_assignment] = STATE(5663),
    [sym_conditional] = STATE(5663),
    [sym_range] = STATE(5663),
    [sym_binary] = STATE(5663),
    [sym_unary] = STATE(5663),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3114] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5664),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5664),
    [sym_operator_assignment] = STATE(5664),
    [sym_conditional] = STATE(5664),
    [sym_range] = STATE(5664),
    [sym_binary] = STATE(5664),
    [sym_unary] = STATE(5664),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3115] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5665),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5665),
    [sym_operator_assignment] = STATE(5665),
    [sym_conditional] = STATE(5665),
    [sym_range] = STATE(5665),
    [sym_binary] = STATE(5665),
    [sym_unary] = STATE(5665),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3116] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5666),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5666),
    [sym_operator_assignment] = STATE(5666),
    [sym_conditional] = STATE(5666),
    [sym_range] = STATE(5666),
    [sym_binary] = STATE(5666),
    [sym_unary] = STATE(5666),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3117] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5667),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5667),
    [sym_operator_assignment] = STATE(5667),
    [sym_conditional] = STATE(5667),
    [sym_range] = STATE(5667),
    [sym_binary] = STATE(5667),
    [sym_unary] = STATE(5667),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3118] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5668),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5668),
    [sym_operator_assignment] = STATE(5668),
    [sym_conditional] = STATE(5668),
    [sym_range] = STATE(5668),
    [sym_binary] = STATE(5668),
    [sym_unary] = STATE(5668),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3119] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5669),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5669),
    [sym_operator_assignment] = STATE(5669),
    [sym_conditional] = STATE(5669),
    [sym_range] = STATE(5669),
    [sym_binary] = STATE(5669),
    [sym_unary] = STATE(5669),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3120] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5670),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5670),
    [sym_operator_assignment] = STATE(5670),
    [sym_conditional] = STATE(5670),
    [sym_range] = STATE(5670),
    [sym_binary] = STATE(5670),
    [sym_unary] = STATE(5670),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3121] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5671),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5671),
    [sym_operator_assignment] = STATE(5671),
    [sym_conditional] = STATE(5671),
    [sym_range] = STATE(5671),
    [sym_binary] = STATE(5671),
    [sym_unary] = STATE(5671),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3122] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5672),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5672),
    [sym_operator_assignment] = STATE(5672),
    [sym_conditional] = STATE(5672),
    [sym_range] = STATE(5672),
    [sym_binary] = STATE(5672),
    [sym_unary] = STATE(5672),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3123] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5673),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5673),
    [sym_operator_assignment] = STATE(5673),
    [sym_conditional] = STATE(5673),
    [sym_range] = STATE(5673),
    [sym_binary] = STATE(5673),
    [sym_unary] = STATE(5673),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3124] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5674),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5674),
    [sym_operator_assignment] = STATE(5674),
    [sym_conditional] = STATE(5674),
    [sym_range] = STATE(5674),
    [sym_binary] = STATE(5674),
    [sym_unary] = STATE(5674),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3125] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5682),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(5682),
    [sym_operator_assignment] = STATE(5682),
    [sym_conditional] = STATE(5682),
    [sym_range] = STATE(5682),
    [sym_binary] = STATE(5682),
    [sym_unary] = STATE(5682),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3126] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5687),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(5687),
    [sym_operator_assignment] = STATE(5687),
    [sym_conditional] = STATE(5687),
    [sym_range] = STATE(5687),
    [sym_binary] = STATE(5687),
    [sym_unary] = STATE(5687),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3127] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5688),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(5688),
    [sym_operator_assignment] = STATE(5688),
    [sym_conditional] = STATE(5688),
    [sym_range] = STATE(5688),
    [sym_binary] = STATE(5688),
    [sym_unary] = STATE(5688),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3128] = {
    [anon_sym_COLON] = ACTIONS(8711),
    [sym_comment] = ACTIONS(87),
  },
  [3129] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5691),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(5691),
    [sym_operator_assignment] = STATE(5691),
    [sym_conditional] = STATE(5691),
    [sym_range] = STATE(5691),
    [sym_binary] = STATE(5691),
    [sym_unary] = STATE(5691),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3130] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5647),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(5648),
    [sym__argument] = STATE(5649),
    [sym_splat_argument] = STATE(5649),
    [sym_hash_splat_argument] = STATE(5649),
    [sym_block_argument] = STATE(5649),
    [sym_assignment] = STATE(5647),
    [sym_operator_assignment] = STATE(5647),
    [sym_conditional] = STATE(5647),
    [sym_range] = STATE(5647),
    [sym_binary] = STATE(5647),
    [sym_unary] = STATE(5647),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5650),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5649),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8667),
    [sym__splat_star] = ACTIONS(8669),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(8671),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(8673),
    [sym_identifier] = ACTIONS(8673),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3131] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5647),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(5648),
    [sym__argument] = STATE(5649),
    [sym_splat_argument] = STATE(5649),
    [sym_hash_splat_argument] = STATE(5649),
    [sym_block_argument] = STATE(5649),
    [sym_assignment] = STATE(5647),
    [sym_operator_assignment] = STATE(5647),
    [sym_conditional] = STATE(5647),
    [sym_range] = STATE(5647),
    [sym_binary] = STATE(5647),
    [sym_unary] = STATE(5647),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5650),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5649),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8667),
    [sym__splat_star] = ACTIONS(8669),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(8671),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(8673),
    [sym_identifier] = ACTIONS(8673),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3132] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5647),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(5648),
    [sym__argument] = STATE(5649),
    [sym_splat_argument] = STATE(5649),
    [sym_hash_splat_argument] = STATE(5649),
    [sym_block_argument] = STATE(5649),
    [sym_assignment] = STATE(5647),
    [sym_operator_assignment] = STATE(5647),
    [sym_conditional] = STATE(5647),
    [sym_range] = STATE(5647),
    [sym_binary] = STATE(5647),
    [sym_unary] = STATE(5647),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5650),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5649),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8667),
    [sym__splat_star] = ACTIONS(8669),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(8671),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(8673),
    [sym_identifier] = ACTIONS(8673),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3133] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5647),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(5648),
    [sym__argument] = STATE(5649),
    [sym_splat_argument] = STATE(5649),
    [sym_hash_splat_argument] = STATE(5649),
    [sym_block_argument] = STATE(5649),
    [sym_assignment] = STATE(5647),
    [sym_operator_assignment] = STATE(5647),
    [sym_conditional] = STATE(5647),
    [sym_range] = STATE(5647),
    [sym_binary] = STATE(5647),
    [sym_unary] = STATE(5647),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5650),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5649),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8667),
    [sym__splat_star] = ACTIONS(8669),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(8671),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(8673),
    [sym_identifier] = ACTIONS(8673),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3134] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5692),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(5692),
    [sym_operator_assignment] = STATE(5692),
    [sym_conditional] = STATE(5692),
    [sym_range] = STATE(5692),
    [sym_binary] = STATE(5692),
    [sym_unary] = STATE(5692),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3135] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3136] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8713),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3137] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_ensure] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(8711),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [3138] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5647),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(5648),
    [sym__argument] = STATE(5649),
    [sym_splat_argument] = STATE(5649),
    [sym_hash_splat_argument] = STATE(5649),
    [sym_block_argument] = STATE(5649),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(5647),
    [sym_operator_assignment] = STATE(5647),
    [sym_conditional] = STATE(5647),
    [sym_range] = STATE(5647),
    [sym_binary] = STATE(5647),
    [sym_unary] = STATE(5647),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5650),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5649),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8667),
    [sym__splat_star] = ACTIONS(8669),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(8671),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(771),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(8673),
    [sym_identifier] = ACTIONS(8673),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3139] = {
    [sym_heredoc_body] = STATE(5704),
    [aux_sym_call_repeat1] = STATE(5704),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3140] = {
    [sym_heredoc_body] = STATE(5704),
    [aux_sym_call_repeat1] = STATE(5704),
    [aux_sym_argument_list_repeat1] = STATE(5706),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8743),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3141] = {
    [anon_sym_EQ] = ACTIONS(8745),
    [sym_comment] = ACTIONS(87),
  },
  [3142] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8747),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8749),
    [anon_sym_DASH_EQ] = ACTIONS(8749),
    [anon_sym_STAR_EQ] = ACTIONS(8749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8749),
    [anon_sym_SLASH_EQ] = ACTIONS(8749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8749),
    [anon_sym_PIPE_EQ] = ACTIONS(8749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8749),
    [anon_sym_AMP_EQ] = ACTIONS(8749),
    [anon_sym_PERCENT_EQ] = ACTIONS(8749),
    [anon_sym_GT_GT_EQ] = ACTIONS(8749),
    [anon_sym_LT_LT_EQ] = ACTIONS(8749),
    [anon_sym_CARET_EQ] = ACTIONS(8749),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3143] = {
    [sym_string] = STATE(5709),
    [aux_sym_chained_string_repeat1] = STATE(5709),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8751),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3144] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5714),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_splat_argument] = STATE(5715),
    [sym_assignment] = STATE(5714),
    [sym_operator_assignment] = STATE(5714),
    [sym_conditional] = STATE(5714),
    [sym_range] = STATE(5714),
    [sym_binary] = STATE(5714),
    [sym_unary] = STATE(5714),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(5715),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8753),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3145] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5718),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(5718),
    [sym_operator_assignment] = STATE(5718),
    [sym_conditional] = STATE(5718),
    [sym_range] = STATE(5718),
    [sym_binary] = STATE(5718),
    [sym_unary] = STATE(5718),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3146] = {
    [sym_string] = STATE(5719),
    [aux_sym_chained_string_repeat1] = STATE(5719),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_ensure] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [3147] = {
    [anon_sym_end] = ACTIONS(8765),
    [anon_sym_ensure] = ACTIONS(8765),
    [sym_comment] = ACTIONS(87),
  },
  [3148] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3149] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5727),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(5727),
    [sym_operator_assignment] = STATE(5727),
    [sym_conditional] = STATE(5727),
    [sym_range] = STATE(5727),
    [sym_binary] = STATE(5727),
    [sym_unary] = STATE(5727),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3150] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5731),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(5731),
    [sym_operator_assignment] = STATE(5731),
    [sym_conditional] = STATE(5731),
    [sym_range] = STATE(5731),
    [sym_binary] = STATE(5731),
    [sym_unary] = STATE(5731),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3151] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5732),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(5732),
    [sym_operator_assignment] = STATE(5732),
    [sym_conditional] = STATE(5732),
    [sym_range] = STATE(5732),
    [sym_binary] = STATE(5732),
    [sym_unary] = STATE(5732),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3152] = {
    [anon_sym_COLON] = ACTIONS(8787),
    [sym_comment] = ACTIONS(87),
  },
  [3153] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5735),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(5735),
    [sym_operator_assignment] = STATE(5735),
    [sym_conditional] = STATE(5735),
    [sym_range] = STATE(5735),
    [sym_binary] = STATE(5735),
    [sym_unary] = STATE(5735),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3154] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5741),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(5742),
    [sym__argument] = STATE(5743),
    [sym_splat_argument] = STATE(5743),
    [sym_hash_splat_argument] = STATE(5743),
    [sym_block_argument] = STATE(5743),
    [sym_assignment] = STATE(5741),
    [sym_operator_assignment] = STATE(5741),
    [sym_conditional] = STATE(5741),
    [sym_range] = STATE(5741),
    [sym_binary] = STATE(5741),
    [sym_unary] = STATE(5741),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5744),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5743),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8789),
    [sym__splat_star] = ACTIONS(8791),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(8795),
    [sym_identifier] = ACTIONS(8795),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3155] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5741),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5742),
    [sym__argument] = STATE(5743),
    [sym_splat_argument] = STATE(5743),
    [sym_hash_splat_argument] = STATE(5743),
    [sym_block_argument] = STATE(5743),
    [sym_assignment] = STATE(5741),
    [sym_operator_assignment] = STATE(5741),
    [sym_conditional] = STATE(5741),
    [sym_range] = STATE(5741),
    [sym_binary] = STATE(5741),
    [sym_unary] = STATE(5741),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5744),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5743),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8789),
    [sym__splat_star] = ACTIONS(8791),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(8795),
    [sym_identifier] = ACTIONS(8795),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3156] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5741),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(5742),
    [sym__argument] = STATE(5743),
    [sym_splat_argument] = STATE(5743),
    [sym_hash_splat_argument] = STATE(5743),
    [sym_block_argument] = STATE(5743),
    [sym_assignment] = STATE(5741),
    [sym_operator_assignment] = STATE(5741),
    [sym_conditional] = STATE(5741),
    [sym_range] = STATE(5741),
    [sym_binary] = STATE(5741),
    [sym_unary] = STATE(5741),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5744),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5743),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8789),
    [sym__splat_star] = ACTIONS(8791),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(8795),
    [sym_identifier] = ACTIONS(8795),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3157] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5741),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(5742),
    [sym__argument] = STATE(5743),
    [sym_splat_argument] = STATE(5743),
    [sym_hash_splat_argument] = STATE(5743),
    [sym_block_argument] = STATE(5743),
    [sym_assignment] = STATE(5741),
    [sym_operator_assignment] = STATE(5741),
    [sym_conditional] = STATE(5741),
    [sym_range] = STATE(5741),
    [sym_binary] = STATE(5741),
    [sym_unary] = STATE(5741),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5744),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(5743),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8789),
    [sym__splat_star] = ACTIONS(8791),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(8795),
    [sym_identifier] = ACTIONS(8795),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3158] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5745),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(5745),
    [sym_operator_assignment] = STATE(5745),
    [sym_conditional] = STATE(5745),
    [sym_range] = STATE(5745),
    [sym_binary] = STATE(5745),
    [sym_unary] = STATE(5745),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3159] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3160] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8797),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3161] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(8787),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [3162] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(5763),
    [sym__argument] = STATE(5764),
    [sym_splat_argument] = STATE(5764),
    [sym_hash_splat_argument] = STATE(5764),
    [sym_block_argument] = STATE(5764),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(5762),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5765),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5764),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8825),
    [sym__splat_star] = ACTIONS(8827),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(8829),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(8831),
    [sym_identifier] = ACTIONS(8831),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3163] = {
    [sym_heredoc_body] = STATE(5766),
    [aux_sym_call_repeat1] = STATE(5766),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3164] = {
    [sym_heredoc_body] = STATE(5766),
    [aux_sym_call_repeat1] = STATE(5766),
    [aux_sym_argument_list_repeat1] = STATE(5768),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8833),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3165] = {
    [anon_sym_EQ] = ACTIONS(8835),
    [sym_comment] = ACTIONS(87),
  },
  [3166] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8837),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8839),
    [anon_sym_DASH_EQ] = ACTIONS(8839),
    [anon_sym_STAR_EQ] = ACTIONS(8839),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8839),
    [anon_sym_SLASH_EQ] = ACTIONS(8839),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8839),
    [anon_sym_PIPE_EQ] = ACTIONS(8839),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8839),
    [anon_sym_AMP_EQ] = ACTIONS(8839),
    [anon_sym_PERCENT_EQ] = ACTIONS(8839),
    [anon_sym_GT_GT_EQ] = ACTIONS(8839),
    [anon_sym_LT_LT_EQ] = ACTIONS(8839),
    [anon_sym_CARET_EQ] = ACTIONS(8839),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3167] = {
    [sym_string] = STATE(5771),
    [aux_sym_chained_string_repeat1] = STATE(5771),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8841),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3168] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [3169] = {
    [aux_sym_undef_repeat1] = STATE(5772),
    [sym__line_break] = ACTIONS(2257),
    [sym__heredoc_body_start] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_end] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [3170] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2499),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3171] = {
    [sym_heredoc_body] = STATE(5773),
    [sym__terminator] = STATE(5773),
    [aux_sym__statements_repeat1] = STATE(5774),
    [sym__line_break] = ACTIONS(8843),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(8843),
    [anon_sym_end] = ACTIONS(2497),
    [sym_comment] = ACTIONS(87),
  },
  [3172] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5775),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5775),
    [sym_operator_assignment] = STATE(5775),
    [sym_conditional] = STATE(5775),
    [sym_range] = STATE(5775),
    [sym_binary] = STATE(5775),
    [sym_unary] = STATE(5775),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3173] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5776),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5776),
    [sym_operator_assignment] = STATE(5776),
    [sym_conditional] = STATE(5776),
    [sym_range] = STATE(5776),
    [sym_binary] = STATE(5776),
    [sym_unary] = STATE(5776),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3174] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5777),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5777),
    [sym_operator_assignment] = STATE(5777),
    [sym_conditional] = STATE(5777),
    [sym_range] = STATE(5777),
    [sym_binary] = STATE(5777),
    [sym_unary] = STATE(5777),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3175] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5778),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5778),
    [sym_operator_assignment] = STATE(5778),
    [sym_conditional] = STATE(5778),
    [sym_range] = STATE(5778),
    [sym_binary] = STATE(5778),
    [sym_unary] = STATE(5778),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3176] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5779),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5779),
    [sym_operator_assignment] = STATE(5779),
    [sym_conditional] = STATE(5779),
    [sym_range] = STATE(5779),
    [sym_binary] = STATE(5779),
    [sym_unary] = STATE(5779),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3177] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5780),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5780),
    [sym_operator_assignment] = STATE(5780),
    [sym_conditional] = STATE(5780),
    [sym_range] = STATE(5780),
    [sym_binary] = STATE(5780),
    [sym_unary] = STATE(5780),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3178] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5781),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5781),
    [sym_operator_assignment] = STATE(5781),
    [sym_conditional] = STATE(5781),
    [sym_range] = STATE(5781),
    [sym_binary] = STATE(5781),
    [sym_unary] = STATE(5781),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3179] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5782),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5782),
    [sym_operator_assignment] = STATE(5782),
    [sym_conditional] = STATE(5782),
    [sym_range] = STATE(5782),
    [sym_binary] = STATE(5782),
    [sym_unary] = STATE(5782),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3180] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5783),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5783),
    [sym_operator_assignment] = STATE(5783),
    [sym_conditional] = STATE(5783),
    [sym_range] = STATE(5783),
    [sym_binary] = STATE(5783),
    [sym_unary] = STATE(5783),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3181] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5784),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5784),
    [sym_operator_assignment] = STATE(5784),
    [sym_conditional] = STATE(5784),
    [sym_range] = STATE(5784),
    [sym_binary] = STATE(5784),
    [sym_unary] = STATE(5784),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3182] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5785),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5785),
    [sym_operator_assignment] = STATE(5785),
    [sym_conditional] = STATE(5785),
    [sym_range] = STATE(5785),
    [sym_binary] = STATE(5785),
    [sym_unary] = STATE(5785),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3183] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5786),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5786),
    [sym_operator_assignment] = STATE(5786),
    [sym_conditional] = STATE(5786),
    [sym_range] = STATE(5786),
    [sym_binary] = STATE(5786),
    [sym_unary] = STATE(5786),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3184] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5787),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5787),
    [sym_operator_assignment] = STATE(5787),
    [sym_conditional] = STATE(5787),
    [sym_range] = STATE(5787),
    [sym_binary] = STATE(5787),
    [sym_unary] = STATE(5787),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3185] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5788),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5788),
    [sym_operator_assignment] = STATE(5788),
    [sym_conditional] = STATE(5788),
    [sym_range] = STATE(5788),
    [sym_binary] = STATE(5788),
    [sym_unary] = STATE(5788),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3186] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5789),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5789),
    [sym_operator_assignment] = STATE(5789),
    [sym_conditional] = STATE(5789),
    [sym_range] = STATE(5789),
    [sym_binary] = STATE(5789),
    [sym_unary] = STATE(5789),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3187] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5797),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(5797),
    [sym_operator_assignment] = STATE(5797),
    [sym_conditional] = STATE(5797),
    [sym_range] = STATE(5797),
    [sym_binary] = STATE(5797),
    [sym_unary] = STATE(5797),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3188] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5802),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(5802),
    [sym_operator_assignment] = STATE(5802),
    [sym_conditional] = STATE(5802),
    [sym_range] = STATE(5802),
    [sym_binary] = STATE(5802),
    [sym_unary] = STATE(5802),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3189] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5803),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(5803),
    [sym_operator_assignment] = STATE(5803),
    [sym_conditional] = STATE(5803),
    [sym_range] = STATE(5803),
    [sym_binary] = STATE(5803),
    [sym_unary] = STATE(5803),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3190] = {
    [anon_sym_COLON] = ACTIONS(8869),
    [sym_comment] = ACTIONS(87),
  },
  [3191] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5806),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(5806),
    [sym_operator_assignment] = STATE(5806),
    [sym_conditional] = STATE(5806),
    [sym_range] = STATE(5806),
    [sym_binary] = STATE(5806),
    [sym_unary] = STATE(5806),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3192] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(5763),
    [sym__argument] = STATE(5764),
    [sym_splat_argument] = STATE(5764),
    [sym_hash_splat_argument] = STATE(5764),
    [sym_block_argument] = STATE(5764),
    [sym_assignment] = STATE(5762),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5765),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5764),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8825),
    [sym__splat_star] = ACTIONS(8827),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(8829),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(8831),
    [sym_identifier] = ACTIONS(8831),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3193] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(5763),
    [sym__argument] = STATE(5764),
    [sym_splat_argument] = STATE(5764),
    [sym_hash_splat_argument] = STATE(5764),
    [sym_block_argument] = STATE(5764),
    [sym_assignment] = STATE(5762),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5765),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5764),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8825),
    [sym__splat_star] = ACTIONS(8827),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(8829),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(8831),
    [sym_identifier] = ACTIONS(8831),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3194] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(5763),
    [sym__argument] = STATE(5764),
    [sym_splat_argument] = STATE(5764),
    [sym_hash_splat_argument] = STATE(5764),
    [sym_block_argument] = STATE(5764),
    [sym_assignment] = STATE(5762),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5765),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5764),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8825),
    [sym__splat_star] = ACTIONS(8827),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(8829),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(8831),
    [sym_identifier] = ACTIONS(8831),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3195] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(5763),
    [sym__argument] = STATE(5764),
    [sym_splat_argument] = STATE(5764),
    [sym_hash_splat_argument] = STATE(5764),
    [sym_block_argument] = STATE(5764),
    [sym_assignment] = STATE(5762),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5765),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5764),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8825),
    [sym__splat_star] = ACTIONS(8827),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(8829),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(8831),
    [sym_identifier] = ACTIONS(8831),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3196] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5807),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(5807),
    [sym_operator_assignment] = STATE(5807),
    [sym_conditional] = STATE(5807),
    [sym_range] = STATE(5807),
    [sym_binary] = STATE(5807),
    [sym_unary] = STATE(5807),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3197] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3198] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(8871),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3199] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(8869),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [3200] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(5763),
    [sym__argument] = STATE(5764),
    [sym_splat_argument] = STATE(5764),
    [sym_hash_splat_argument] = STATE(5764),
    [sym_block_argument] = STATE(5764),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(5762),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5765),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5764),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8825),
    [sym__splat_star] = ACTIONS(8827),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(8829),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(8831),
    [sym_identifier] = ACTIONS(8831),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3201] = {
    [sym_heredoc_body] = STATE(5819),
    [aux_sym_call_repeat1] = STATE(5819),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3202] = {
    [sym_heredoc_body] = STATE(5819),
    [aux_sym_call_repeat1] = STATE(5819),
    [aux_sym_argument_list_repeat1] = STATE(5821),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8901),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3203] = {
    [anon_sym_EQ] = ACTIONS(8903),
    [sym_comment] = ACTIONS(87),
  },
  [3204] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8905),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8907),
    [anon_sym_DASH_EQ] = ACTIONS(8907),
    [anon_sym_STAR_EQ] = ACTIONS(8907),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8907),
    [anon_sym_SLASH_EQ] = ACTIONS(8907),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8907),
    [anon_sym_PIPE_EQ] = ACTIONS(8907),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8907),
    [anon_sym_AMP_EQ] = ACTIONS(8907),
    [anon_sym_PERCENT_EQ] = ACTIONS(8907),
    [anon_sym_GT_GT_EQ] = ACTIONS(8907),
    [anon_sym_LT_LT_EQ] = ACTIONS(8907),
    [anon_sym_CARET_EQ] = ACTIONS(8907),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3205] = {
    [sym_string] = STATE(5824),
    [aux_sym_chained_string_repeat1] = STATE(5824),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8909),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3206] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5829),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_splat_argument] = STATE(5830),
    [sym_assignment] = STATE(5829),
    [sym_operator_assignment] = STATE(5829),
    [sym_conditional] = STATE(5829),
    [sym_range] = STATE(5829),
    [sym_binary] = STATE(5829),
    [sym_unary] = STATE(5829),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(5830),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8911),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3207] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5833),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(5833),
    [sym_operator_assignment] = STATE(5833),
    [sym_conditional] = STATE(5833),
    [sym_range] = STATE(5833),
    [sym_binary] = STATE(5833),
    [sym_unary] = STATE(5833),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3208] = {
    [sym_string] = STATE(5834),
    [aux_sym_chained_string_repeat1] = STATE(5834),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [3209] = {
    [aux_sym_undef_repeat1] = STATE(5835),
    [sym__line_break] = ACTIONS(5356),
    [sym__heredoc_body_start] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym_end] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [anon_sym_else] = ACTIONS(5356),
    [anon_sym_ensure] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [3210] = {
    [sym__line_break] = ACTIONS(8923),
    [sym__heredoc_body_start] = ACTIONS(8923),
    [sym__binary_minus] = ACTIONS(8923),
    [sym__binary_star] = ACTIONS(8923),
    [ts_builtin_sym_end] = ACTIONS(8923),
    [anon_sym___END__] = ACTIONS(8923),
    [anon_sym_LBRACE] = ACTIONS(8923),
    [anon_sym_RBRACE] = ACTIONS(8923),
    [anon_sym_RPAREN] = ACTIONS(8923),
    [anon_sym_DOT] = ACTIONS(8925),
    [anon_sym_COMMA] = ACTIONS(8923),
    [anon_sym_PIPE] = ACTIONS(8925),
    [anon_sym_SEMI] = ACTIONS(8923),
    [anon_sym_STAR_STAR] = ACTIONS(8923),
    [anon_sym_AMP] = ACTIONS(8925),
    [anon_sym_LT] = ACTIONS(8925),
    [anon_sym_end] = ACTIONS(8923),
    [anon_sym_if] = ACTIONS(8923),
    [anon_sym_unless] = ACTIONS(8923),
    [anon_sym_while] = ACTIONS(8923),
    [anon_sym_until] = ACTIONS(8923),
    [anon_sym_rescue] = ACTIONS(8923),
    [anon_sym_do] = ACTIONS(8923),
    [anon_sym_when] = ACTIONS(8923),
    [anon_sym_elsif] = ACTIONS(8923),
    [anon_sym_else] = ACTIONS(8923),
    [anon_sym_then] = ACTIONS(8923),
    [anon_sym_ensure] = ACTIONS(8923),
    [anon_sym_EQ_GT] = ACTIONS(8923),
    [anon_sym_LBRACK] = ACTIONS(8923),
    [anon_sym_COLON_COLON2] = ACTIONS(8923),
    [anon_sym_AMP_DOT] = ACTIONS(8923),
    [anon_sym_QMARK] = ACTIONS(8923),
    [anon_sym_DOT_DOT] = ACTIONS(8925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8923),
    [anon_sym_and] = ACTIONS(8923),
    [anon_sym_or] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8923),
    [anon_sym_GT_GT] = ACTIONS(8923),
    [anon_sym_EQ_EQ] = ACTIONS(8925),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8925),
    [anon_sym_GT] = ACTIONS(8925),
    [anon_sym_GT_EQ] = ACTIONS(8923),
    [anon_sym_CARET] = ACTIONS(8923),
    [anon_sym_PLUS] = ACTIONS(8923),
    [anon_sym_SLASH] = ACTIONS(8923),
    [anon_sym_PERCENT] = ACTIONS(8923),
    [sym_comment] = ACTIONS(87),
  },
  [3211] = {
    [anon_sym_end] = ACTIONS(8927),
    [sym_comment] = ACTIONS(87),
  },
  [3212] = {
    [sym_ensure] = STATE(5837),
    [anon_sym_end] = ACTIONS(8927),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [3213] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5678),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(5678),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(5678),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3214] = {
    [sym_heredoc_body] = STATE(5838),
    [sym__terminator] = STATE(5838),
    [aux_sym__statements_repeat1] = STATE(3214),
    [sym__line_break] = ACTIONS(8929),
    [sym__heredoc_body_start] = ACTIONS(5683),
    [anon_sym_SEMI] = ACTIONS(8929),
    [anon_sym_end] = ACTIONS(5674),
    [anon_sym_rescue] = ACTIONS(5674),
    [anon_sym_else] = ACTIONS(5674),
    [anon_sym_ensure] = ACTIONS(5674),
    [sym_comment] = ACTIONS(87),
  },
  [3215] = {
    [sym__line_break] = ACTIONS(5686),
    [sym__heredoc_body_start] = ACTIONS(5686),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(5686),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_else] = ACTIONS(5686),
    [anon_sym_ensure] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(2207),
    [anon_sym_or] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3216] = {
    [sym__line_break] = ACTIONS(5688),
    [sym__heredoc_body_start] = ACTIONS(5688),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(5688),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_else] = ACTIONS(5688),
    [anon_sym_ensure] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(2207),
    [anon_sym_or] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3217] = {
    [sym__line_break] = ACTIONS(5690),
    [sym__heredoc_body_start] = ACTIONS(5690),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(5690),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_else] = ACTIONS(5690),
    [anon_sym_ensure] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(2207),
    [anon_sym_or] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3218] = {
    [sym__line_break] = ACTIONS(5692),
    [sym__heredoc_body_start] = ACTIONS(5692),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(5692),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_else] = ACTIONS(5692),
    [anon_sym_ensure] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(2207),
    [anon_sym_or] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3219] = {
    [sym__line_break] = ACTIONS(5694),
    [sym__heredoc_body_start] = ACTIONS(5694),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(5694),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_else] = ACTIONS(5694),
    [anon_sym_ensure] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(2207),
    [anon_sym_or] = ACTIONS(2207),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3220] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3221] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [3222] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3223] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3224] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3225] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(8932),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [3226] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3227] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3228] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3229] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3230] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5840),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(5840),
    [sym_operator_assignment] = STATE(5840),
    [sym_conditional] = STATE(5840),
    [sym_range] = STATE(5840),
    [sym_binary] = STATE(5840),
    [sym_unary] = STATE(5840),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3231] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1240),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(1242),
    [sym__argument] = STATE(1243),
    [sym_splat_argument] = STATE(1243),
    [sym_hash_splat_argument] = STATE(1243),
    [sym_block_argument] = STATE(1243),
    [sym_assignment] = STATE(1240),
    [sym_operator_assignment] = STATE(1240),
    [sym_conditional] = STATE(1240),
    [sym_range] = STATE(1240),
    [sym_binary] = STATE(1240),
    [sym_unary] = STATE(1240),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1246),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1243),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(2219),
    [sym__splat_star] = ACTIONS(2221),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(2243),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3232] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1240),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(1242),
    [sym__argument] = STATE(1243),
    [sym_splat_argument] = STATE(1243),
    [sym_hash_splat_argument] = STATE(1243),
    [sym_block_argument] = STATE(1243),
    [sym_assignment] = STATE(1240),
    [sym_operator_assignment] = STATE(1240),
    [sym_conditional] = STATE(1240),
    [sym_range] = STATE(1240),
    [sym_binary] = STATE(1240),
    [sym_unary] = STATE(1240),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1246),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1243),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(2219),
    [sym__splat_star] = ACTIONS(2221),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(2243),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3233] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1240),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(1242),
    [sym__argument] = STATE(1243),
    [sym_splat_argument] = STATE(1243),
    [sym_hash_splat_argument] = STATE(1243),
    [sym_block_argument] = STATE(1243),
    [sym_assignment] = STATE(1240),
    [sym_operator_assignment] = STATE(1240),
    [sym_conditional] = STATE(1240),
    [sym_range] = STATE(1240),
    [sym_binary] = STATE(1240),
    [sym_unary] = STATE(1240),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1246),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1243),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(2219),
    [sym__splat_star] = ACTIONS(2221),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(2243),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3234] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1240),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(1242),
    [sym__argument] = STATE(1243),
    [sym_splat_argument] = STATE(1243),
    [sym_hash_splat_argument] = STATE(1243),
    [sym_block_argument] = STATE(1243),
    [sym_assignment] = STATE(1240),
    [sym_operator_assignment] = STATE(1240),
    [sym_conditional] = STATE(1240),
    [sym_range] = STATE(1240),
    [sym_binary] = STATE(1240),
    [sym_unary] = STATE(1240),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1246),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1243),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(2219),
    [sym__splat_star] = ACTIONS(2221),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(2243),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3235] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5841),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(5841),
    [sym_operator_assignment] = STATE(5841),
    [sym_conditional] = STATE(5841),
    [sym_range] = STATE(5841),
    [sym_binary] = STATE(5841),
    [sym_unary] = STATE(5841),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3236] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3237] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_ensure] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8946),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [3238] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1240),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(1242),
    [sym__argument] = STATE(1243),
    [sym_splat_argument] = STATE(1243),
    [sym_hash_splat_argument] = STATE(1243),
    [sym_block_argument] = STATE(1243),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(1240),
    [sym_operator_assignment] = STATE(1240),
    [sym_conditional] = STATE(1240),
    [sym_range] = STATE(1240),
    [sym_binary] = STATE(1240),
    [sym_unary] = STATE(1240),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1246),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1243),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(2219),
    [sym__splat_star] = ACTIONS(2221),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2239),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(2243),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3239] = {
    [anon_sym_EQ] = ACTIONS(8962),
    [sym_comment] = ACTIONS(87),
  },
  [3240] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8964),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8966),
    [anon_sym_DASH_EQ] = ACTIONS(8966),
    [anon_sym_STAR_EQ] = ACTIONS(8966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8966),
    [anon_sym_SLASH_EQ] = ACTIONS(8966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8966),
    [anon_sym_PIPE_EQ] = ACTIONS(8966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8966),
    [anon_sym_AMP_EQ] = ACTIONS(8966),
    [anon_sym_PERCENT_EQ] = ACTIONS(8966),
    [anon_sym_GT_GT_EQ] = ACTIONS(8966),
    [anon_sym_LT_LT_EQ] = ACTIONS(8966),
    [anon_sym_CARET_EQ] = ACTIONS(8966),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3241] = {
    [sym_string] = STATE(5854),
    [aux_sym_chained_string_repeat1] = STATE(5854),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3242] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_ensure] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8946),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [3243] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3244] = {
    [sym_string] = STATE(3264),
    [aux_sym_chained_string_repeat1] = STATE(3264),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3245] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5855),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(5855),
    [sym_operator_assignment] = STATE(5855),
    [sym_conditional] = STATE(5855),
    [sym_range] = STATE(5855),
    [sym_binary] = STATE(5855),
    [sym_unary] = STATE(5855),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3246] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_ensure] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8946),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [3247] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [3248] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(5856),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(5856),
    [sym_operator_assignment] = STATE(5856),
    [sym_conditional] = STATE(5856),
    [sym_range] = STATE(5856),
    [sym_binary] = STATE(5856),
    [sym_unary] = STATE(5856),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3249] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5857),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5857),
    [sym_operator_assignment] = STATE(5857),
    [sym_conditional] = STATE(5857),
    [sym_range] = STATE(5857),
    [sym_binary] = STATE(5857),
    [sym_unary] = STATE(5857),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3250] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5858),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5858),
    [sym_operator_assignment] = STATE(5858),
    [sym_conditional] = STATE(5858),
    [sym_range] = STATE(5858),
    [sym_binary] = STATE(5858),
    [sym_unary] = STATE(5858),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3251] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5859),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5859),
    [sym_operator_assignment] = STATE(5859),
    [sym_conditional] = STATE(5859),
    [sym_range] = STATE(5859),
    [sym_binary] = STATE(5859),
    [sym_unary] = STATE(5859),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3252] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5860),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5860),
    [sym_operator_assignment] = STATE(5860),
    [sym_conditional] = STATE(5860),
    [sym_range] = STATE(5860),
    [sym_binary] = STATE(5860),
    [sym_unary] = STATE(5860),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3253] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5861),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5861),
    [sym_operator_assignment] = STATE(5861),
    [sym_conditional] = STATE(5861),
    [sym_range] = STATE(5861),
    [sym_binary] = STATE(5861),
    [sym_unary] = STATE(5861),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3254] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5862),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5862),
    [sym_operator_assignment] = STATE(5862),
    [sym_conditional] = STATE(5862),
    [sym_range] = STATE(5862),
    [sym_binary] = STATE(5862),
    [sym_unary] = STATE(5862),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3255] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5863),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5863),
    [sym_operator_assignment] = STATE(5863),
    [sym_conditional] = STATE(5863),
    [sym_range] = STATE(5863),
    [sym_binary] = STATE(5863),
    [sym_unary] = STATE(5863),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3256] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5864),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5864),
    [sym_operator_assignment] = STATE(5864),
    [sym_conditional] = STATE(5864),
    [sym_range] = STATE(5864),
    [sym_binary] = STATE(5864),
    [sym_unary] = STATE(5864),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3257] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5865),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5865),
    [sym_operator_assignment] = STATE(5865),
    [sym_conditional] = STATE(5865),
    [sym_range] = STATE(5865),
    [sym_binary] = STATE(5865),
    [sym_unary] = STATE(5865),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3258] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5866),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5866),
    [sym_operator_assignment] = STATE(5866),
    [sym_conditional] = STATE(5866),
    [sym_range] = STATE(5866),
    [sym_binary] = STATE(5866),
    [sym_unary] = STATE(5866),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3259] = {
    [sym_heredoc_body] = STATE(5867),
    [aux_sym_call_repeat1] = STATE(5867),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [3260] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1240),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(1240),
    [sym_operator_assignment] = STATE(1240),
    [sym_conditional] = STATE(1240),
    [sym_range] = STATE(1240),
    [sym_binary] = STATE(1240),
    [sym_unary] = STATE(1240),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1246),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(5868),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(2219),
    [sym__splat_star] = ACTIONS(2221),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__identifier_hash_key] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8968),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(2243),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3261] = {
    [sym_heredoc_body] = STATE(5869),
    [aux_sym_call_repeat1] = STATE(5869),
    [aux_sym_argument_list_repeat1] = STATE(5870),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(5328),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [3262] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5871),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_splat_argument] = STATE(5872),
    [sym_assignment] = STATE(5871),
    [sym_operator_assignment] = STATE(5871),
    [sym_conditional] = STATE(5871),
    [sym_range] = STATE(5871),
    [sym_binary] = STATE(5871),
    [sym_unary] = STATE(5871),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(5872),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(4918),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3263] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5873),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(5873),
    [sym_operator_assignment] = STATE(5873),
    [sym_conditional] = STATE(5873),
    [sym_range] = STATE(5873),
    [sym_binary] = STATE(5873),
    [sym_unary] = STATE(5873),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3264] = {
    [sym_string] = STATE(5874),
    [aux_sym_chained_string_repeat1] = STATE(5874),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_ensure] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [3265] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5875),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(5875),
    [sym_operator_assignment] = STATE(5875),
    [sym_conditional] = STATE(5875),
    [sym_range] = STATE(5875),
    [sym_binary] = STATE(5875),
    [sym_unary] = STATE(5875),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3266] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5876),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(5876),
    [sym_operator_assignment] = STATE(5876),
    [sym_conditional] = STATE(5876),
    [sym_range] = STATE(5876),
    [sym_binary] = STATE(5876),
    [sym_unary] = STATE(5876),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3267] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5877),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(5877),
    [sym_operator_assignment] = STATE(5877),
    [sym_conditional] = STATE(5877),
    [sym_range] = STATE(5877),
    [sym_binary] = STATE(5877),
    [sym_unary] = STATE(5877),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3268] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3269] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8974),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(8976),
    [anon_sym_LT] = ACTIONS(8978),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_ensure] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8980),
    [anon_sym_DOT_DOT] = ACTIONS(8982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8984),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8986),
    [anon_sym_AMP_AMP] = ACTIONS(8986),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(8990),
    [anon_sym_BANG_EQ] = ACTIONS(8986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8986),
    [anon_sym_LT_EQ_GT] = ACTIONS(8986),
    [anon_sym_EQ_TILDE] = ACTIONS(8986),
    [anon_sym_BANG_TILDE] = ACTIONS(8986),
    [anon_sym_LT_EQ] = ACTIONS(8978),
    [anon_sym_GT] = ACTIONS(8978),
    [anon_sym_GT_EQ] = ACTIONS(8992),
    [anon_sym_CARET] = ACTIONS(8994),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [3270] = {
    [aux_sym_exceptions_repeat1] = STATE(5889),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(8996),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [3271] = {
    [anon_sym_EQ] = ACTIONS(8998),
    [sym_comment] = ACTIONS(87),
  },
  [3272] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9000),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9002),
    [anon_sym_DASH_EQ] = ACTIONS(9002),
    [anon_sym_STAR_EQ] = ACTIONS(9002),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9002),
    [anon_sym_SLASH_EQ] = ACTIONS(9002),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9002),
    [anon_sym_PIPE_EQ] = ACTIONS(9002),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9002),
    [anon_sym_AMP_EQ] = ACTIONS(9002),
    [anon_sym_PERCENT_EQ] = ACTIONS(9002),
    [anon_sym_GT_GT_EQ] = ACTIONS(9002),
    [anon_sym_LT_LT_EQ] = ACTIONS(9002),
    [anon_sym_CARET_EQ] = ACTIONS(9002),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3273] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [3274] = {
    [sym_string] = STATE(3274),
    [aux_sym_chained_string_repeat1] = STATE(3274),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_ensure] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [3275] = {
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [ts_builtin_sym_end] = ACTIONS(9004),
    [anon_sym___END__] = ACTIONS(9004),
    [anon_sym_RBRACE] = ACTIONS(9004),
    [anon_sym_RPAREN] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9004),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_end] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [anon_sym_when] = ACTIONS(9004),
    [anon_sym_elsif] = ACTIONS(9004),
    [anon_sym_else] = ACTIONS(9004),
    [anon_sym_then] = ACTIONS(9004),
    [anon_sym_ensure] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [3276] = {
    [aux_sym_undef_repeat1] = STATE(3276),
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [ts_builtin_sym_end] = ACTIONS(9004),
    [anon_sym___END__] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9006),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [3277] = {
    [sym__simple_symbol] = ACTIONS(2907),
    [sym__symbol_start] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2907),
    [anon_sym_STAR] = ACTIONS(2909),
    [anon_sym_STAR_STAR] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_DOT_DOT] = ACTIONS(2907),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2907),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_CARET] = ACTIONS(2907),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2907),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2907),
    [sym_constant] = ACTIONS(2907),
    [sym_identifier] = ACTIONS(2907),
    [sym_instance_variable] = ACTIONS(2907),
    [sym_class_variable] = ACTIONS(2907),
    [sym_global_variable] = ACTIONS(2907),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_PLUS_AT] = ACTIONS(2907),
    [anon_sym_DASH_AT] = ACTIONS(2907),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2909),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2907),
    [anon_sym_BQUOTE] = ACTIONS(2907),
    [sym_comment] = ACTIONS(87),
  },
  [3278] = {
    [sym__string_start] = ACTIONS(2895),
    [sym__heredoc_body_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_STAR_STAR] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_unless] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_until] = ACTIONS(2895),
    [anon_sym_rescue] = ACTIONS(2895),
    [anon_sym_in] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_EQ_GT] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_RBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON2] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_LT_LT] = ACTIONS(2895),
    [anon_sym_GT_GT] = ACTIONS(2895),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(87),
  },
  [3279] = {
    [sym__heredoc_body_start] = ACTIONS(2907),
    [sym__binary_minus] = ACTIONS(2907),
    [sym__binary_star] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_STAR_STAR] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_unless] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_until] = ACTIONS(2907),
    [anon_sym_rescue] = ACTIONS(2907),
    [anon_sym_in] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_EQ_GT] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_RBRACK] = ACTIONS(2907),
    [anon_sym_COLON_COLON2] = ACTIONS(2907),
    [anon_sym_AMP_DOT] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_COLON2] = ACTIONS(2909),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_and] = ACTIONS(2907),
    [anon_sym_or] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2907),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_CARET] = ACTIONS(2907),
    [anon_sym_PLUS] = ACTIONS(2907),
    [anon_sym_SLASH] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2907),
    [sym_comment] = ACTIONS(87),
  },
  [3280] = {
    [sym__heredoc_body_start] = ACTIONS(2911),
    [sym__binary_minus] = ACTIONS(2911),
    [sym__binary_star] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_RPAREN] = ACTIONS(2911),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_STAR_STAR] = ACTIONS(2911),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_unless] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_until] = ACTIONS(2911),
    [anon_sym_rescue] = ACTIONS(2911),
    [anon_sym_in] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_EQ_GT] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_RBRACK] = ACTIONS(2911),
    [anon_sym_COLON_COLON2] = ACTIONS(2911),
    [anon_sym_AMP_DOT] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_COLON2] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE] = ACTIONS(2911),
    [anon_sym_AMP_AMP] = ACTIONS(2911),
    [anon_sym_LT_LT] = ACTIONS(2911),
    [anon_sym_GT_GT] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_CARET] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_SLASH] = ACTIONS(2911),
    [anon_sym_PERCENT] = ACTIONS(2911),
    [sym_comment] = ACTIONS(87),
  },
  [3281] = {
    [sym__heredoc_body_start] = ACTIONS(2915),
    [sym__binary_minus] = ACTIONS(2915),
    [sym__binary_star] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_STAR_STAR] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_unless] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_until] = ACTIONS(2915),
    [anon_sym_rescue] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_EQ_GT] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_RBRACK] = ACTIONS(2915),
    [anon_sym_COLON_COLON2] = ACTIONS(2915),
    [anon_sym_AMP_DOT] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_COLON2] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_AMP_AMP] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2915),
    [anon_sym_EQ_TILDE] = ACTIONS(2915),
    [anon_sym_BANG_TILDE] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [sym_comment] = ACTIONS(87),
  },
  [3282] = {
    [sym__heredoc_body_start] = ACTIONS(2921),
    [sym__binary_minus] = ACTIONS(2921),
    [sym__binary_star] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_STAR_STAR] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_unless] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_until] = ACTIONS(2921),
    [anon_sym_rescue] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_RBRACK] = ACTIONS(2921),
    [anon_sym_COLON_COLON2] = ACTIONS(2921),
    [anon_sym_AMP_DOT] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_COLON2] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_and] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [sym_comment] = ACTIONS(87),
  },
  [3283] = {
    [sym__string_end] = ACTIONS(9009),
    [sym_comment] = ACTIONS(87),
  },
  [3284] = {
    [aux_sym_string_array_repeat1] = STATE(5895),
    [sym__string_end] = ACTIONS(9011),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9013),
  },
  [3285] = {
    [sym__heredoc_body_start] = ACTIONS(2931),
    [sym__binary_minus] = ACTIONS(2931),
    [sym__binary_star] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_STAR_STAR] = ACTIONS(2931),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_unless] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_until] = ACTIONS(2931),
    [anon_sym_rescue] = ACTIONS(2931),
    [anon_sym_in] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_EQ_GT] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_RBRACK] = ACTIONS(2931),
    [anon_sym_COLON_COLON2] = ACTIONS(2931),
    [anon_sym_AMP_DOT] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2931),
    [anon_sym_COLON2] = ACTIONS(2933),
    [anon_sym_DOT_DOT] = ACTIONS(2933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2931),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2931),
    [anon_sym_LT_LT] = ACTIONS(2931),
    [anon_sym_GT_GT] = ACTIONS(2931),
    [anon_sym_EQ_EQ] = ACTIONS(2933),
    [anon_sym_BANG_EQ] = ACTIONS(2931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2931),
    [anon_sym_EQ_TILDE] = ACTIONS(2931),
    [anon_sym_BANG_TILDE] = ACTIONS(2931),
    [anon_sym_LT_EQ] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_GT_EQ] = ACTIONS(2931),
    [anon_sym_CARET] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2931),
    [anon_sym_PERCENT] = ACTIONS(2931),
    [sym_comment] = ACTIONS(87),
  },
  [3286] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9015),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3287] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(9015),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9017),
  },
  [3288] = {
    [sym__heredoc_body_start] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym__binary_star] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_STAR_STAR] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_unless] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_until] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2950),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_EQ_GT] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_COLON_COLON2] = ACTIONS(2950),
    [anon_sym_AMP_DOT] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON2] = ACTIONS(2952),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_LT_LT] = ACTIONS(2950),
    [anon_sym_GT_GT] = ACTIONS(2950),
    [anon_sym_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ_GT] = ACTIONS(2950),
    [anon_sym_EQ_TILDE] = ACTIONS(2950),
    [anon_sym_BANG_TILDE] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [sym_comment] = ACTIONS(87),
  },
  [3289] = {
    [sym__string_end] = ACTIONS(9019),
    [sym_comment] = ACTIONS(87),
  },
  [3290] = {
    [aux_sym_symbol_array_repeat1] = STATE(5901),
    [sym__string_end] = ACTIONS(9021),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9023),
  },
  [3291] = {
    [sym__heredoc_body_start] = ACTIONS(2960),
    [sym__binary_minus] = ACTIONS(2960),
    [sym__binary_star] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_RPAREN] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_STAR_STAR] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_unless] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_until] = ACTIONS(2960),
    [anon_sym_rescue] = ACTIONS(2960),
    [anon_sym_in] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_EQ_GT] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_RBRACK] = ACTIONS(2960),
    [anon_sym_COLON_COLON2] = ACTIONS(2960),
    [anon_sym_AMP_DOT] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2960),
    [anon_sym_COLON2] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_LT_LT] = ACTIONS(2960),
    [anon_sym_GT_GT] = ACTIONS(2960),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2960),
    [anon_sym_LT_EQ_GT] = ACTIONS(2960),
    [anon_sym_EQ_TILDE] = ACTIONS(2960),
    [anon_sym_BANG_TILDE] = ACTIONS(2960),
    [anon_sym_LT_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_SLASH] = ACTIONS(2960),
    [anon_sym_PERCENT] = ACTIONS(2960),
    [sym_comment] = ACTIONS(87),
  },
  [3292] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9025),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3293] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(9025),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9027),
  },
  [3294] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3295] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5907),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(5907),
    [sym_operator_assignment] = STATE(5907),
    [sym_conditional] = STATE(5907),
    [sym_range] = STATE(5907),
    [sym_binary] = STATE(5907),
    [sym_unary] = STATE(5907),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3296] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5910),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(5910),
    [sym_operator_assignment] = STATE(5910),
    [sym_conditional] = STATE(5910),
    [sym_range] = STATE(5910),
    [sym_binary] = STATE(5910),
    [sym_unary] = STATE(5910),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3297] = {
    [anon_sym_COLON] = ACTIONS(9039),
    [sym_comment] = ACTIONS(87),
  },
  [3298] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5912),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(5912),
    [sym_operator_assignment] = STATE(5912),
    [sym_conditional] = STATE(5912),
    [sym_range] = STATE(5912),
    [sym_binary] = STATE(5912),
    [sym_unary] = STATE(5912),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3299] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9041),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3300] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(9039),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_RBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [3301] = {
    [sym_heredoc_body] = STATE(5914),
    [aux_sym_call_repeat1] = STATE(5914),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3302] = {
    [sym_heredoc_body] = STATE(5914),
    [aux_sym_call_repeat1] = STATE(5914),
    [aux_sym_argument_list_repeat1] = STATE(5916),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9043),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3303] = {
    [sym_string] = STATE(1386),
    [aux_sym_chained_string_repeat1] = STATE(1386),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9045),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3304] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [3305] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5917),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(5917),
    [sym_operator_assignment] = STATE(5917),
    [sym_conditional] = STATE(5917),
    [sym_range] = STATE(5917),
    [sym_binary] = STATE(5917),
    [sym_unary] = STATE(5917),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3306] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5918),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(5918),
    [sym_operator_assignment] = STATE(5918),
    [sym_conditional] = STATE(5918),
    [sym_range] = STATE(5918),
    [sym_binary] = STATE(5918),
    [sym_unary] = STATE(5918),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3307] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5919),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(5919),
    [sym_operator_assignment] = STATE(5919),
    [sym_conditional] = STATE(5919),
    [sym_range] = STATE(5919),
    [sym_binary] = STATE(5919),
    [sym_unary] = STATE(5919),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3308] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5920),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(5920),
    [sym_operator_assignment] = STATE(5920),
    [sym_conditional] = STATE(5920),
    [sym_range] = STATE(5920),
    [sym_binary] = STATE(5920),
    [sym_unary] = STATE(5920),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3309] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5921),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(5921),
    [sym_operator_assignment] = STATE(5921),
    [sym_conditional] = STATE(5921),
    [sym_range] = STATE(5921),
    [sym_binary] = STATE(5921),
    [sym_unary] = STATE(5921),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3310] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5922),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5922),
    [sym_operator_assignment] = STATE(5922),
    [sym_conditional] = STATE(5922),
    [sym_range] = STATE(5922),
    [sym_binary] = STATE(5922),
    [sym_unary] = STATE(5922),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3311] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5923),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(5923),
    [sym_operator_assignment] = STATE(5923),
    [sym_conditional] = STATE(5923),
    [sym_range] = STATE(5923),
    [sym_binary] = STATE(5923),
    [sym_unary] = STATE(5923),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3312] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5924),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(5924),
    [sym_operator_assignment] = STATE(5924),
    [sym_conditional] = STATE(5924),
    [sym_range] = STATE(5924),
    [sym_binary] = STATE(5924),
    [sym_unary] = STATE(5924),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3313] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5925),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(5925),
    [sym_operator_assignment] = STATE(5925),
    [sym_conditional] = STATE(5925),
    [sym_range] = STATE(5925),
    [sym_binary] = STATE(5925),
    [sym_unary] = STATE(5925),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3314] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5926),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(5926),
    [sym_operator_assignment] = STATE(5926),
    [sym_conditional] = STATE(5926),
    [sym_range] = STATE(5926),
    [sym_binary] = STATE(5926),
    [sym_unary] = STATE(5926),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3315] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(5934),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(5934),
    [sym_operator_assignment] = STATE(5934),
    [sym_conditional] = STATE(5934),
    [sym_range] = STATE(5934),
    [sym_binary] = STATE(5934),
    [sym_unary] = STATE(5934),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3316] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(5939),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(5939),
    [sym_operator_assignment] = STATE(5939),
    [sym_conditional] = STATE(5939),
    [sym_range] = STATE(5939),
    [sym_binary] = STATE(5939),
    [sym_unary] = STATE(5939),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3317] = {
    [anon_sym_COLON] = ACTIONS(9069),
    [sym_comment] = ACTIONS(87),
  },
  [3318] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(5941),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(5941),
    [sym_operator_assignment] = STATE(5941),
    [sym_conditional] = STATE(5941),
    [sym_range] = STATE(5941),
    [sym_binary] = STATE(5941),
    [sym_unary] = STATE(5941),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3319] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9071),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3320] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(9069),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_RBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [3321] = {
    [sym_heredoc_body] = STATE(5943),
    [aux_sym_call_repeat1] = STATE(5943),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3322] = {
    [sym_heredoc_body] = STATE(5943),
    [aux_sym_call_repeat1] = STATE(5943),
    [aux_sym_argument_list_repeat1] = STATE(5945),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9073),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3323] = {
    [sym_string] = STATE(3435),
    [aux_sym_chained_string_repeat1] = STATE(3435),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9075),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3324] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5947),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_splat_argument] = STATE(5948),
    [sym_assignment] = STATE(5947),
    [sym_operator_assignment] = STATE(5947),
    [sym_conditional] = STATE(5947),
    [sym_range] = STATE(5947),
    [sym_binary] = STATE(5947),
    [sym_unary] = STATE(5947),
    [sym_right_assignment_list] = STATE(3442),
    [sym__arg_or_splat_arg] = STATE(5948),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(9077),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3325] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5949),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(5949),
    [sym_operator_assignment] = STATE(5949),
    [sym_conditional] = STATE(5949),
    [sym_range] = STATE(5949),
    [sym_binary] = STATE(5949),
    [sym_unary] = STATE(5949),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3326] = {
    [sym_string] = STATE(5950),
    [aux_sym_chained_string_repeat1] = STATE(5950),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_RBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [3327] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [3328] = {
    [sym__heredoc_body_start] = ACTIONS(3440),
    [sym__binary_minus] = ACTIONS(3440),
    [sym__binary_star] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3440),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3440),
    [anon_sym_while] = ACTIONS(3440),
    [anon_sym_until] = ACTIONS(3440),
    [anon_sym_rescue] = ACTIONS(3440),
    [anon_sym_in] = ACTIONS(3440),
    [anon_sym_do] = ACTIONS(3440),
    [anon_sym_EQ_GT] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3440),
    [anon_sym_RBRACK] = ACTIONS(3440),
    [anon_sym_COLON_COLON2] = ACTIONS(3440),
    [anon_sym_AMP_DOT] = ACTIONS(3440),
    [anon_sym_QMARK] = ACTIONS(3440),
    [anon_sym_COLON2] = ACTIONS(3442),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3440),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_GT_GT] = ACTIONS(3440),
    [anon_sym_EQ_EQ] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3440),
    [anon_sym_BANG_TILDE] = ACTIONS(3440),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3440),
    [anon_sym_CARET] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [sym_comment] = ACTIONS(87),
  },
  [3329] = {
    [anon_sym_RBRACE] = ACTIONS(9079),
    [sym_comment] = ACTIONS(87),
  },
  [3330] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(9081),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [3331] = {
    [sym__method_rest] = STATE(5953),
    [sym_operator] = STATE(1293),
    [sym__method_name] = STATE(1293),
    [sym_setter] = STATE(1293),
    [sym_symbol] = STATE(1293),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9083),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9083),
    [sym_class_variable] = ACTIONS(9083),
    [sym_global_variable] = ACTIONS(9083),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [3332] = {
    [sym__statements] = STATE(1328),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1329),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1330),
    [sym_rescue] = STATE(1331),
    [sym__body_statement] = STATE(5954),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9085),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3333] = {
    [sym__heredoc_body_start] = ACTIONS(3670),
    [sym__binary_minus] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_LBRACE] = ACTIONS(3670),
    [anon_sym_RBRACE] = ACTIONS(3670),
    [anon_sym_RPAREN] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_SEMI] = ACTIONS(3670),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3672),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3672),
    [anon_sym_if] = ACTIONS(3670),
    [anon_sym_unless] = ACTIONS(3670),
    [anon_sym_while] = ACTIONS(3670),
    [anon_sym_until] = ACTIONS(3670),
    [anon_sym_rescue] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3670),
    [anon_sym_do] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3670),
    [anon_sym_RBRACK] = ACTIONS(3670),
    [anon_sym_COLON_COLON2] = ACTIONS(3670),
    [anon_sym_AMP_DOT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_COLON2] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3670),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LT_EQ_GT] = ACTIONS(3670),
    [anon_sym_EQ_TILDE] = ACTIONS(3670),
    [anon_sym_BANG_TILDE] = ACTIONS(3670),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym_comment] = ACTIONS(87),
  },
  [3334] = {
    [sym_heredoc_body] = STATE(5955),
    [sym__terminator] = STATE(5955),
    [sym__line_break] = ACTIONS(9087),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(9087),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [3335] = {
    [sym_heredoc_body] = STATE(5956),
    [sym__terminator] = STATE(5956),
    [sym__line_break] = ACTIONS(9089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(9089),
    [sym_comment] = ACTIONS(87),
  },
  [3336] = {
    [sym__statements] = STATE(1328),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1329),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1330),
    [sym_rescue] = STATE(1331),
    [sym__body_statement] = STATE(5957),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9091),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3337] = {
    [sym__heredoc_body_start] = ACTIONS(4068),
    [sym__binary_minus] = ACTIONS(4068),
    [sym__binary_star] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_STAR_STAR] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_unless] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_until] = ACTIONS(4068),
    [anon_sym_rescue] = ACTIONS(4068),
    [anon_sym_in] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_COLON_COLON2] = ACTIONS(4068),
    [anon_sym_AMP_DOT] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4068),
    [anon_sym_COLON2] = ACTIONS(4070),
    [anon_sym_DOT_DOT] = ACTIONS(4070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(4068),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ_GT] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_BANG_TILDE] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4068),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [sym_comment] = ACTIONS(87),
  },
  [3338] = {
    [sym__statements] = STATE(1328),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1329),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1330),
    [sym_rescue] = STATE(1331),
    [sym__body_statement] = STATE(5958),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9093),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3339] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_RBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [3340] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_RBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [3341] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3342] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5959),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5959),
    [sym_operator_assignment] = STATE(5959),
    [sym_conditional] = STATE(5959),
    [sym_range] = STATE(5959),
    [sym_binary] = STATE(5959),
    [sym_unary] = STATE(5959),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3343] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_RBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [3344] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [3345] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5960),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5960),
    [sym_operator_assignment] = STATE(5960),
    [sym_conditional] = STATE(5960),
    [sym_range] = STATE(5960),
    [sym_binary] = STATE(5960),
    [sym_unary] = STATE(5960),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3346] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5961),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5961),
    [sym_operator_assignment] = STATE(5961),
    [sym_conditional] = STATE(5961),
    [sym_range] = STATE(5961),
    [sym_binary] = STATE(5961),
    [sym_unary] = STATE(5961),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3347] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5962),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5962),
    [sym_operator_assignment] = STATE(5962),
    [sym_conditional] = STATE(5962),
    [sym_range] = STATE(5962),
    [sym_binary] = STATE(5962),
    [sym_unary] = STATE(5962),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3348] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5963),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5963),
    [sym_operator_assignment] = STATE(5963),
    [sym_conditional] = STATE(5963),
    [sym_range] = STATE(5963),
    [sym_binary] = STATE(5963),
    [sym_unary] = STATE(5963),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3349] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5964),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5964),
    [sym_operator_assignment] = STATE(5964),
    [sym_conditional] = STATE(5964),
    [sym_range] = STATE(5964),
    [sym_binary] = STATE(5964),
    [sym_unary] = STATE(5964),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3350] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5965),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5965),
    [sym_operator_assignment] = STATE(5965),
    [sym_conditional] = STATE(5965),
    [sym_range] = STATE(5965),
    [sym_binary] = STATE(5965),
    [sym_unary] = STATE(5965),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3351] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(5966),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(5966),
    [sym_operator_assignment] = STATE(5966),
    [sym_conditional] = STATE(5966),
    [sym_range] = STATE(5966),
    [sym_binary] = STATE(5966),
    [sym_unary] = STATE(5966),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3352] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5967),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5967),
    [sym_operator_assignment] = STATE(5967),
    [sym_conditional] = STATE(5967),
    [sym_range] = STATE(5967),
    [sym_binary] = STATE(5967),
    [sym_unary] = STATE(5967),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3353] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5968),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5968),
    [sym_operator_assignment] = STATE(5968),
    [sym_conditional] = STATE(5968),
    [sym_range] = STATE(5968),
    [sym_binary] = STATE(5968),
    [sym_unary] = STATE(5968),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3354] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5969),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5969),
    [sym_operator_assignment] = STATE(5969),
    [sym_conditional] = STATE(5969),
    [sym_range] = STATE(5969),
    [sym_binary] = STATE(5969),
    [sym_unary] = STATE(5969),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3355] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5970),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5970),
    [sym_operator_assignment] = STATE(5970),
    [sym_conditional] = STATE(5970),
    [sym_range] = STATE(5970),
    [sym_binary] = STATE(5970),
    [sym_unary] = STATE(5970),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3356] = {
    [sym_heredoc_body] = STATE(5971),
    [aux_sym_call_repeat1] = STATE(5971),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [3357] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1311),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(1311),
    [sym_operator_assignment] = STATE(1311),
    [sym_conditional] = STATE(1311),
    [sym_range] = STATE(1311),
    [sym_binary] = STATE(1311),
    [sym_unary] = STATE(1311),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1317),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(5972),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2327),
    [sym__splat_star] = ACTIONS(2329),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__identifier_hash_key] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9095),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2343),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3358] = {
    [sym_heredoc_body] = STATE(5973),
    [aux_sym_call_repeat1] = STATE(5973),
    [aux_sym_argument_list_repeat1] = STATE(5974),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [3359] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5975),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_splat_argument] = STATE(5976),
    [sym_assignment] = STATE(5975),
    [sym_operator_assignment] = STATE(5975),
    [sym_conditional] = STATE(5975),
    [sym_range] = STATE(5975),
    [sym_binary] = STATE(5975),
    [sym_unary] = STATE(5975),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(5976),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(2329),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3360] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5977),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(5977),
    [sym_operator_assignment] = STATE(5977),
    [sym_conditional] = STATE(5977),
    [sym_range] = STATE(5977),
    [sym_binary] = STATE(5977),
    [sym_unary] = STATE(5977),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3361] = {
    [sym__statements] = STATE(5979),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(5980),
    [sym_else] = STATE(5980),
    [sym__if_tail] = STATE(5980),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(5981),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__terminator] = STATE(5981),
    [sym__line_break] = ACTIONS(9097),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9099),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3362] = {
    [sym__statements] = STATE(5983),
    [sym__top_level_statement] = STATE(2704),
    [sym_begin_block] = STATE(2704),
    [sym_end_block] = STATE(2704),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(5984),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9101),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3363] = {
    [sym__statements] = STATE(5986),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9103),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3364] = {
    [sym__statements] = STATE(5988),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9105),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3365] = {
    [sym__do] = STATE(5989),
    [sym_heredoc_body] = STATE(5989),
    [sym__terminator] = STATE(5989),
    [sym__line_break] = ACTIONS(9107),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(9107),
    [anon_sym_do] = ACTIONS(9107),
    [sym_comment] = ACTIONS(87),
  },
  [3366] = {
    [sym_when] = STATE(5990),
    [aux_sym_case_repeat1] = STATE(5991),
    [anon_sym_SEMI] = ACTIONS(9109),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3367] = {
    [anon_sym_end] = ACTIONS(9111),
    [sym_comment] = ACTIONS(87),
  },
  [3368] = {
    [sym_when] = STATE(5990),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3369] = {
    [sym__heredoc_body_start] = ACTIONS(5264),
    [sym__binary_minus] = ACTIONS(5264),
    [sym__binary_star] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5264),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_RPAREN] = ACTIONS(5264),
    [anon_sym_DOT] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5264),
    [anon_sym_PIPE] = ACTIONS(5266),
    [anon_sym_SEMI] = ACTIONS(5264),
    [anon_sym_STAR_STAR] = ACTIONS(5264),
    [anon_sym_AMP] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5266),
    [anon_sym_if] = ACTIONS(5264),
    [anon_sym_unless] = ACTIONS(5264),
    [anon_sym_while] = ACTIONS(5264),
    [anon_sym_until] = ACTIONS(5264),
    [anon_sym_rescue] = ACTIONS(5264),
    [anon_sym_in] = ACTIONS(5264),
    [anon_sym_do] = ACTIONS(5264),
    [anon_sym_EQ_GT] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5264),
    [anon_sym_RBRACK] = ACTIONS(5264),
    [anon_sym_COLON_COLON2] = ACTIONS(5264),
    [anon_sym_AMP_DOT] = ACTIONS(5264),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_COLON2] = ACTIONS(5266),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5264),
    [anon_sym_and] = ACTIONS(5264),
    [anon_sym_or] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE] = ACTIONS(5264),
    [anon_sym_AMP_AMP] = ACTIONS(5264),
    [anon_sym_LT_LT] = ACTIONS(5264),
    [anon_sym_GT_GT] = ACTIONS(5264),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5264),
    [anon_sym_LT_EQ_GT] = ACTIONS(5264),
    [anon_sym_EQ_TILDE] = ACTIONS(5264),
    [anon_sym_BANG_TILDE] = ACTIONS(5264),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_GT] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5264),
    [anon_sym_CARET] = ACTIONS(5264),
    [anon_sym_PLUS] = ACTIONS(5264),
    [anon_sym_SLASH] = ACTIONS(5264),
    [anon_sym_PERCENT] = ACTIONS(5264),
    [sym_comment] = ACTIONS(87),
  },
  [3370] = {
    [sym_ensure] = STATE(5994),
    [anon_sym_end] = ACTIONS(9113),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [3371] = {
    [anon_sym_end] = ACTIONS(9113),
    [sym_comment] = ACTIONS(87),
  },
  [3372] = {
    [sym_else] = STATE(5995),
    [sym_ensure] = STATE(5994),
    [anon_sym_end] = ACTIONS(9113),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [3373] = {
    [sym__heredoc_body_start] = ACTIONS(5350),
    [sym__binary_minus] = ACTIONS(5350),
    [sym__binary_star] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_RPAREN] = ACTIONS(5350),
    [anon_sym_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5350),
    [anon_sym_PIPE] = ACTIONS(5352),
    [anon_sym_SEMI] = ACTIONS(5350),
    [anon_sym_STAR_STAR] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5352),
    [anon_sym_EQ] = ACTIONS(5352),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_unless] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_until] = ACTIONS(5350),
    [anon_sym_rescue] = ACTIONS(5350),
    [anon_sym_in] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_EQ_GT] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_RBRACK] = ACTIONS(5350),
    [anon_sym_COLON_COLON2] = ACTIONS(5350),
    [anon_sym_AMP_DOT] = ACTIONS(5350),
    [anon_sym_QMARK] = ACTIONS(5350),
    [anon_sym_COLON2] = ACTIONS(5352),
    [anon_sym_DOT_DOT] = ACTIONS(5352),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5350),
    [anon_sym_AMP_AMP] = ACTIONS(5350),
    [anon_sym_LT_LT] = ACTIONS(5350),
    [anon_sym_GT_GT] = ACTIONS(5350),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5350),
    [anon_sym_LT_EQ_GT] = ACTIONS(5350),
    [anon_sym_EQ_TILDE] = ACTIONS(5350),
    [anon_sym_BANG_TILDE] = ACTIONS(5350),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5350),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_SLASH] = ACTIONS(5350),
    [anon_sym_PERCENT] = ACTIONS(5350),
    [sym_comment] = ACTIONS(87),
  },
  [3374] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [3375] = {
    [sym__heredoc_body_start] = ACTIONS(5582),
    [sym__binary_minus] = ACTIONS(5582),
    [sym__binary_star] = ACTIONS(5582),
    [anon_sym_LBRACE] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_STAR_STAR] = ACTIONS(5582),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_EQ] = ACTIONS(5584),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_if] = ACTIONS(5582),
    [anon_sym_unless] = ACTIONS(5582),
    [anon_sym_while] = ACTIONS(5582),
    [anon_sym_until] = ACTIONS(5582),
    [anon_sym_rescue] = ACTIONS(5582),
    [anon_sym_in] = ACTIONS(5582),
    [anon_sym_do] = ACTIONS(5582),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_COLON_COLON2] = ACTIONS(5582),
    [anon_sym_AMP_DOT] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5582),
    [anon_sym_COLON2] = ACTIONS(5584),
    [anon_sym_DOT_DOT] = ACTIONS(5584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5584),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ_GT] = ACTIONS(5582),
    [anon_sym_EQ_TILDE] = ACTIONS(5582),
    [anon_sym_BANG_TILDE] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5582),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [sym_comment] = ACTIONS(87),
  },
  [3376] = {
    [anon_sym_RBRACK] = ACTIONS(9115),
    [sym_comment] = ACTIONS(87),
  },
  [3377] = {
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5594),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_COLON2] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5594),
    [anon_sym_AMP_AMP] = ACTIONS(5594),
    [anon_sym_LT_LT] = ACTIONS(5594),
    [anon_sym_GT_GT] = ACTIONS(5594),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5594),
    [anon_sym_PLUS] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5594),
    [anon_sym_PERCENT] = ACTIONS(5594),
    [sym_comment] = ACTIONS(87),
  },
  [3378] = {
    [anon_sym_RBRACE] = ACTIONS(9117),
    [sym_comment] = ACTIONS(87),
  },
  [3379] = {
    [sym__statements] = STATE(5998),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9117),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3380] = {
    [sym__heredoc_body_start] = ACTIONS(5630),
    [sym__binary_minus] = ACTIONS(5630),
    [sym__binary_star] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5630),
    [anon_sym_RPAREN] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_STAR_STAR] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5632),
    [anon_sym_if] = ACTIONS(5630),
    [anon_sym_unless] = ACTIONS(5630),
    [anon_sym_while] = ACTIONS(5630),
    [anon_sym_until] = ACTIONS(5630),
    [anon_sym_rescue] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5630),
    [anon_sym_do] = ACTIONS(5630),
    [anon_sym_EQ_GT] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_RBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_COLON2] = ACTIONS(5632),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5630),
    [anon_sym_AMP_AMP] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5630),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5630),
    [anon_sym_EQ_TILDE] = ACTIONS(5630),
    [anon_sym_BANG_TILDE] = ACTIONS(5630),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5630),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5630),
    [sym_comment] = ACTIONS(87),
  },
  [3381] = {
    [anon_sym_end] = ACTIONS(9119),
    [sym_comment] = ACTIONS(87),
  },
  [3382] = {
    [sym__statements] = STATE(6000),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6001),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(6001),
    [sym__line_break] = ACTIONS(9121),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9123),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3383] = {
    [sym__statements] = STATE(6000),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(6002),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9123),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3384] = {
    [sym__heredoc_body_start] = ACTIONS(5666),
    [sym__binary_minus] = ACTIONS(5666),
    [sym__binary_star] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_STAR_STAR] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_EQ] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_if] = ACTIONS(5666),
    [anon_sym_unless] = ACTIONS(5666),
    [anon_sym_while] = ACTIONS(5666),
    [anon_sym_until] = ACTIONS(5666),
    [anon_sym_rescue] = ACTIONS(5666),
    [anon_sym_in] = ACTIONS(5666),
    [anon_sym_do] = ACTIONS(5666),
    [anon_sym_EQ_GT] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_RBRACK] = ACTIONS(5666),
    [anon_sym_COLON_COLON2] = ACTIONS(5666),
    [anon_sym_AMP_DOT] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_COLON2] = ACTIONS(5668),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_and] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5666),
    [anon_sym_LT_LT] = ACTIONS(5666),
    [anon_sym_GT_GT] = ACTIONS(5666),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_EQ_TILDE] = ACTIONS(5666),
    [anon_sym_BANG_TILDE] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_CARET] = ACTIONS(5666),
    [anon_sym_PLUS] = ACTIONS(5666),
    [anon_sym_SLASH] = ACTIONS(5666),
    [anon_sym_PERCENT] = ACTIONS(5666),
    [sym_comment] = ACTIONS(87),
  },
  [3385] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [3386] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [3387] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [3388] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [3389] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [3390] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(9125),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [3391] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_RBRACK] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(2377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2379),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ_GT] = ACTIONS(2383),
    [anon_sym_EQ_TILDE] = ACTIONS(2383),
    [anon_sym_BANG_TILDE] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [3392] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(2375),
    [anon_sym_DOT_DOT] = ACTIONS(2377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2379),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ_GT] = ACTIONS(2383),
    [anon_sym_EQ_TILDE] = ACTIONS(2383),
    [anon_sym_BANG_TILDE] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [3393] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ_GT] = ACTIONS(2383),
    [anon_sym_EQ_TILDE] = ACTIONS(2383),
    [anon_sym_BANG_TILDE] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [3394] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [3395] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_EQ_GT] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_RBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [3396] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(6005),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(6006),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(9127),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3397] = {
    [sym__simple_symbol] = ACTIONS(5806),
    [sym__string_start] = ACTIONS(5806),
    [sym__symbol_start] = ACTIONS(5806),
    [sym__subshell_start] = ACTIONS(5806),
    [sym__regex_start] = ACTIONS(5806),
    [sym__string_array_start] = ACTIONS(5806),
    [sym__symbol_array_start] = ACTIONS(5806),
    [sym__heredoc_body_start] = ACTIONS(5806),
    [sym_heredoc_beginning] = ACTIONS(5806),
    [sym__block_ampersand] = ACTIONS(5806),
    [sym__splat_star] = ACTIONS(5806),
    [sym__unary_minus] = ACTIONS(5806),
    [sym__binary_minus] = ACTIONS(5806),
    [sym__binary_star] = ACTIONS(5806),
    [sym__identifier_hash_key] = ACTIONS(5806),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_RBRACE] = ACTIONS(5806),
    [anon_sym_def] = ACTIONS(5808),
    [anon_sym_LPAREN] = ACTIONS(5808),
    [anon_sym_RPAREN] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_COLON_COLON] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_SEMI] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5808),
    [anon_sym_AMP] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_class] = ACTIONS(5808),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_module] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_yield] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_next] = ACTIONS(5808),
    [sym_redo] = ACTIONS(5808),
    [sym_retry] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_unless] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_until] = ACTIONS(5808),
    [anon_sym_rescue] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_in] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_begin] = ACTIONS(5808),
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_RBRACK] = ACTIONS(5806),
    [anon_sym_COLON_COLON2] = ACTIONS(5806),
    [anon_sym_AMP_DOT] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_PLUS_EQ] = ACTIONS(5806),
    [anon_sym_DASH_EQ] = ACTIONS(5806),
    [anon_sym_STAR_EQ] = ACTIONS(5806),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5806),
    [anon_sym_AMP_EQ] = ACTIONS(5806),
    [anon_sym_PERCENT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_LT_LT_EQ] = ACTIONS(5806),
    [anon_sym_CARET_EQ] = ACTIONS(5806),
    [anon_sym_QMARK] = ACTIONS(5808),
    [anon_sym_COLON2] = ACTIONS(5808),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_and] = ACTIONS(5808),
    [anon_sym_or] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_AMP_AMP] = ACTIONS(5808),
    [anon_sym_LT_LT] = ACTIONS(5808),
    [anon_sym_GT_GT] = ACTIONS(5808),
    [anon_sym_EQ_EQ] = ACTIONS(5808),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5806),
    [anon_sym_BANG_TILDE] = ACTIONS(5806),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_SLASH] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5808),
    [anon_sym_defined_QMARK] = ACTIONS(5806),
    [anon_sym_not] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_TILDE] = ACTIONS(5806),
    [sym_constant] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_instance_variable] = ACTIONS(5806),
    [sym_class_variable] = ACTIONS(5806),
    [sym_global_variable] = ACTIONS(5806),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5808),
    [sym_float] = ACTIONS(5808),
    [sym_complex] = ACTIONS(5806),
    [sym_super] = ACTIONS(5808),
    [anon_sym_true] = ACTIONS(5808),
    [anon_sym_TRUE] = ACTIONS(5808),
    [anon_sym_false] = ACTIONS(5808),
    [anon_sym_FALSE] = ACTIONS(5808),
    [sym_self] = ACTIONS(5808),
    [anon_sym_nil] = ACTIONS(5808),
    [anon_sym_NIL] = ACTIONS(5808),
    [sym_character] = ACTIONS(5806),
    [anon_sym_LBRACK2] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5806),
  },
  [3398] = {
    [sym__simple_symbol] = ACTIONS(5810),
    [sym__string_start] = ACTIONS(5810),
    [sym__symbol_start] = ACTIONS(5810),
    [sym__subshell_start] = ACTIONS(5810),
    [sym__regex_start] = ACTIONS(5810),
    [sym__string_array_start] = ACTIONS(5810),
    [sym__symbol_array_start] = ACTIONS(5810),
    [sym__heredoc_body_start] = ACTIONS(5810),
    [sym_heredoc_beginning] = ACTIONS(5810),
    [sym__block_ampersand] = ACTIONS(5810),
    [sym__splat_star] = ACTIONS(5810),
    [sym__unary_minus] = ACTIONS(5810),
    [sym__binary_minus] = ACTIONS(5810),
    [sym__binary_star] = ACTIONS(5810),
    [sym__identifier_hash_key] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [anon_sym_def] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(5812),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_COLON_COLON] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_PIPE] = ACTIONS(5812),
    [anon_sym_SEMI] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_STAR_STAR] = ACTIONS(5812),
    [anon_sym_AMP] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_class] = ACTIONS(5812),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_module] = ACTIONS(5812),
    [anon_sym_return] = ACTIONS(5812),
    [anon_sym_yield] = ACTIONS(5812),
    [anon_sym_break] = ACTIONS(5812),
    [anon_sym_next] = ACTIONS(5812),
    [sym_redo] = ACTIONS(5812),
    [sym_retry] = ACTIONS(5812),
    [anon_sym_if] = ACTIONS(5812),
    [anon_sym_unless] = ACTIONS(5812),
    [anon_sym_while] = ACTIONS(5812),
    [anon_sym_until] = ACTIONS(5812),
    [anon_sym_rescue] = ACTIONS(5812),
    [anon_sym_for] = ACTIONS(5812),
    [anon_sym_in] = ACTIONS(5812),
    [anon_sym_do] = ACTIONS(5812),
    [anon_sym_case] = ACTIONS(5812),
    [anon_sym_begin] = ACTIONS(5812),
    [anon_sym_EQ_GT] = ACTIONS(5810),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COLON_COLON2] = ACTIONS(5810),
    [anon_sym_AMP_DOT] = ACTIONS(5810),
    [anon_sym_LPAREN2] = ACTIONS(5810),
    [anon_sym_PLUS_EQ] = ACTIONS(5810),
    [anon_sym_DASH_EQ] = ACTIONS(5810),
    [anon_sym_STAR_EQ] = ACTIONS(5810),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5810),
    [anon_sym_AMP_EQ] = ACTIONS(5810),
    [anon_sym_PERCENT_EQ] = ACTIONS(5810),
    [anon_sym_GT_GT_EQ] = ACTIONS(5810),
    [anon_sym_LT_LT_EQ] = ACTIONS(5810),
    [anon_sym_CARET_EQ] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5812),
    [anon_sym_COLON2] = ACTIONS(5812),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(5812),
    [anon_sym_or] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_GT_GT] = ACTIONS(5812),
    [anon_sym_EQ_EQ] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5810),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_EQ_TILDE] = ACTIONS(5810),
    [anon_sym_BANG_TILDE] = ACTIONS(5810),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_GT] = ACTIONS(5812),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5812),
    [anon_sym_PLUS] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5812),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_defined_QMARK] = ACTIONS(5810),
    [anon_sym_not] = ACTIONS(5812),
    [anon_sym_BANG] = ACTIONS(5812),
    [anon_sym_TILDE] = ACTIONS(5810),
    [sym_constant] = ACTIONS(5812),
    [sym_identifier] = ACTIONS(5812),
    [sym_instance_variable] = ACTIONS(5810),
    [sym_class_variable] = ACTIONS(5810),
    [sym_global_variable] = ACTIONS(5810),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5812),
    [sym_float] = ACTIONS(5812),
    [sym_complex] = ACTIONS(5810),
    [sym_super] = ACTIONS(5812),
    [anon_sym_true] = ACTIONS(5812),
    [anon_sym_TRUE] = ACTIONS(5812),
    [anon_sym_false] = ACTIONS(5812),
    [anon_sym_FALSE] = ACTIONS(5812),
    [sym_self] = ACTIONS(5812),
    [anon_sym_nil] = ACTIONS(5812),
    [anon_sym_NIL] = ACTIONS(5812),
    [sym_character] = ACTIONS(5810),
    [anon_sym_LBRACK2] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5810),
  },
  [3399] = {
    [sym_argument_list_with_parens] = STATE(6007),
    [sym__argument_list_with_parens] = STATE(3398),
    [sym_operator] = STATE(6007),
    [sym_heredoc_body] = STATE(3546),
    [aux_sym_call_repeat1] = STATE(3546),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(5518),
    [anon_sym_STAR] = ACTIONS(5520),
    [anon_sym_STAR_STAR] = ACTIONS(5518),
    [anon_sym_AMP] = ACTIONS(5518),
    [anon_sym_LT] = ACTIONS(5520),
    [anon_sym_LPAREN2] = ACTIONS(5522),
    [anon_sym_DOT_DOT] = ACTIONS(5518),
    [anon_sym_LT_LT] = ACTIONS(5518),
    [anon_sym_GT_GT] = ACTIONS(5518),
    [anon_sym_EQ_EQ] = ACTIONS(5520),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5518),
    [anon_sym_LT_EQ_GT] = ACTIONS(5518),
    [anon_sym_EQ_TILDE] = ACTIONS(5518),
    [anon_sym_BANG_TILDE] = ACTIONS(5518),
    [anon_sym_LT_EQ] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5520),
    [anon_sym_GT_EQ] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5518),
    [anon_sym_PLUS] = ACTIONS(5520),
    [anon_sym_SLASH] = ACTIONS(5518),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_BANG] = ACTIONS(5520),
    [anon_sym_TILDE] = ACTIONS(5518),
    [sym_constant] = ACTIONS(9129),
    [sym_identifier] = ACTIONS(9129),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_PLUS_AT] = ACTIONS(5518),
    [anon_sym_DASH_AT] = ACTIONS(5518),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5520),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5518),
    [anon_sym_BQUOTE] = ACTIONS(5518),
    [sym_comment] = ACTIONS(87),
  },
  [3400] = {
    [sym__heredoc_body_start] = ACTIONS(5816),
    [sym__binary_minus] = ACTIONS(5816),
    [sym__binary_star] = ACTIONS(5816),
    [anon_sym_LBRACE] = ACTIONS(5816),
    [anon_sym_RBRACE] = ACTIONS(5816),
    [anon_sym_RPAREN] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5816),
    [anon_sym_PIPE] = ACTIONS(5818),
    [anon_sym_SEMI] = ACTIONS(5816),
    [anon_sym_STAR_STAR] = ACTIONS(5818),
    [anon_sym_AMP] = ACTIONS(5818),
    [anon_sym_EQ] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5818),
    [anon_sym_if] = ACTIONS(5816),
    [anon_sym_unless] = ACTIONS(5816),
    [anon_sym_while] = ACTIONS(5816),
    [anon_sym_until] = ACTIONS(5816),
    [anon_sym_rescue] = ACTIONS(5816),
    [anon_sym_in] = ACTIONS(5816),
    [anon_sym_do] = ACTIONS(5816),
    [anon_sym_EQ_GT] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_RBRACK] = ACTIONS(5816),
    [anon_sym_COLON_COLON2] = ACTIONS(5816),
    [anon_sym_AMP_DOT] = ACTIONS(5816),
    [anon_sym_PLUS_EQ] = ACTIONS(5816),
    [anon_sym_DASH_EQ] = ACTIONS(5816),
    [anon_sym_STAR_EQ] = ACTIONS(5816),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5816),
    [anon_sym_SLASH_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5816),
    [anon_sym_AMP_EQ] = ACTIONS(5816),
    [anon_sym_PERCENT_EQ] = ACTIONS(5816),
    [anon_sym_GT_GT_EQ] = ACTIONS(5816),
    [anon_sym_LT_LT_EQ] = ACTIONS(5816),
    [anon_sym_CARET_EQ] = ACTIONS(5816),
    [anon_sym_QMARK] = ACTIONS(5816),
    [anon_sym_COLON2] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5816),
    [anon_sym_and] = ACTIONS(5816),
    [anon_sym_or] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_AMP_AMP] = ACTIONS(5818),
    [anon_sym_LT_LT] = ACTIONS(5818),
    [anon_sym_GT_GT] = ACTIONS(5818),
    [anon_sym_EQ_EQ] = ACTIONS(5818),
    [anon_sym_BANG_EQ] = ACTIONS(5816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5816),
    [anon_sym_LT_EQ_GT] = ACTIONS(5816),
    [anon_sym_EQ_TILDE] = ACTIONS(5816),
    [anon_sym_BANG_TILDE] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5818),
    [anon_sym_GT] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5816),
    [anon_sym_CARET] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5818),
    [anon_sym_SLASH] = ACTIONS(5818),
    [anon_sym_PERCENT] = ACTIONS(5818),
    [sym_comment] = ACTIONS(87),
  },
  [3401] = {
    [sym_heredoc_body] = STATE(6009),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(9131),
    [sym_comment] = ACTIONS(87),
  },
  [3402] = {
    [anon_sym_RBRACK] = ACTIONS(9131),
    [sym_comment] = ACTIONS(87),
  },
  [3403] = {
    [sym__simple_symbol] = ACTIONS(5822),
    [sym__string_start] = ACTIONS(5822),
    [sym__symbol_start] = ACTIONS(5822),
    [sym__subshell_start] = ACTIONS(5822),
    [sym__regex_start] = ACTIONS(5822),
    [sym__string_array_start] = ACTIONS(5822),
    [sym__symbol_array_start] = ACTIONS(5822),
    [sym__heredoc_body_start] = ACTIONS(5822),
    [sym_heredoc_beginning] = ACTIONS(5822),
    [sym__block_ampersand] = ACTIONS(5822),
    [sym__splat_star] = ACTIONS(5822),
    [sym__unary_minus] = ACTIONS(5822),
    [sym__binary_minus] = ACTIONS(5822),
    [sym__binary_star] = ACTIONS(5822),
    [sym__identifier_hash_key] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_def] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COLON_COLON] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_STAR_STAR] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_class] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_module] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(5824),
    [anon_sym_break] = ACTIONS(5824),
    [anon_sym_next] = ACTIONS(5824),
    [sym_redo] = ACTIONS(5824),
    [sym_retry] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5824),
    [anon_sym_unless] = ACTIONS(5824),
    [anon_sym_while] = ACTIONS(5824),
    [anon_sym_until] = ACTIONS(5824),
    [anon_sym_rescue] = ACTIONS(5824),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_in] = ACTIONS(5824),
    [anon_sym_do] = ACTIONS(5824),
    [anon_sym_case] = ACTIONS(5824),
    [anon_sym_begin] = ACTIONS(5824),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_RBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_LPAREN2] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [anon_sym_DASH_EQ] = ACTIONS(5822),
    [anon_sym_STAR_EQ] = ACTIONS(5822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5822),
    [anon_sym_AMP_EQ] = ACTIONS(5822),
    [anon_sym_PERCENT_EQ] = ACTIONS(5822),
    [anon_sym_GT_GT_EQ] = ACTIONS(5822),
    [anon_sym_LT_LT_EQ] = ACTIONS(5822),
    [anon_sym_CARET_EQ] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5824),
    [anon_sym_COLON2] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5824),
    [anon_sym_or] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [anon_sym_defined_QMARK] = ACTIONS(5822),
    [anon_sym_not] = ACTIONS(5824),
    [anon_sym_BANG] = ACTIONS(5824),
    [anon_sym_TILDE] = ACTIONS(5822),
    [sym_constant] = ACTIONS(5824),
    [sym_identifier] = ACTIONS(5824),
    [sym_instance_variable] = ACTIONS(5822),
    [sym_class_variable] = ACTIONS(5822),
    [sym_global_variable] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5824),
    [sym_float] = ACTIONS(5824),
    [sym_complex] = ACTIONS(5822),
    [sym_super] = ACTIONS(5824),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_TRUE] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [anon_sym_FALSE] = ACTIONS(5824),
    [sym_self] = ACTIONS(5824),
    [anon_sym_nil] = ACTIONS(5824),
    [anon_sym_NIL] = ACTIONS(5824),
    [sym_character] = ACTIONS(5822),
    [anon_sym_LBRACK2] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5822),
  },
  [3404] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_RBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [3405] = {
    [sym_string] = STATE(3435),
    [aux_sym_chained_string_repeat1] = STATE(3435),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3406] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_RBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [3407] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3408] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6010),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6010),
    [sym_operator_assignment] = STATE(6010),
    [sym_conditional] = STATE(6010),
    [sym_range] = STATE(6010),
    [sym_binary] = STATE(6010),
    [sym_unary] = STATE(6010),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3409] = {
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_COLON2] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [3410] = {
    [anon_sym_RBRACE] = ACTIONS(9133),
    [sym_comment] = ACTIONS(87),
  },
  [3411] = {
    [sym__statements] = STATE(6012),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9133),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3412] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_RBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [3413] = {
    [sym__heredoc_body_start] = ACTIONS(5630),
    [sym__binary_minus] = ACTIONS(5630),
    [sym__binary_star] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5630),
    [anon_sym_RPAREN] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_STAR_STAR] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5632),
    [anon_sym_if] = ACTIONS(5630),
    [anon_sym_unless] = ACTIONS(5630),
    [anon_sym_while] = ACTIONS(5630),
    [anon_sym_until] = ACTIONS(5630),
    [anon_sym_rescue] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5630),
    [anon_sym_do] = ACTIONS(5630),
    [anon_sym_EQ_GT] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_RBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [anon_sym_PLUS_EQ] = ACTIONS(5630),
    [anon_sym_DASH_EQ] = ACTIONS(5630),
    [anon_sym_STAR_EQ] = ACTIONS(5630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5630),
    [anon_sym_SLASH_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5630),
    [anon_sym_AMP_EQ] = ACTIONS(5630),
    [anon_sym_PERCENT_EQ] = ACTIONS(5630),
    [anon_sym_GT_GT_EQ] = ACTIONS(5630),
    [anon_sym_LT_LT_EQ] = ACTIONS(5630),
    [anon_sym_CARET_EQ] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_COLON2] = ACTIONS(5632),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5632),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5630),
    [anon_sym_EQ_TILDE] = ACTIONS(5630),
    [anon_sym_BANG_TILDE] = ACTIONS(5630),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5632),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [sym_comment] = ACTIONS(87),
  },
  [3414] = {
    [anon_sym_end] = ACTIONS(9135),
    [sym_comment] = ACTIONS(87),
  },
  [3415] = {
    [sym__statements] = STATE(6014),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6015),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(6015),
    [sym__line_break] = ACTIONS(9137),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9139),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3416] = {
    [sym__statements] = STATE(6014),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(6016),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9139),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3417] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [3418] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6017),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6017),
    [sym_operator_assignment] = STATE(6017),
    [sym_conditional] = STATE(6017),
    [sym_range] = STATE(6017),
    [sym_binary] = STATE(6017),
    [sym_unary] = STATE(6017),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3419] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6018),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6018),
    [sym_operator_assignment] = STATE(6018),
    [sym_conditional] = STATE(6018),
    [sym_range] = STATE(6018),
    [sym_binary] = STATE(6018),
    [sym_unary] = STATE(6018),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3420] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6019),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6019),
    [sym_operator_assignment] = STATE(6019),
    [sym_conditional] = STATE(6019),
    [sym_range] = STATE(6019),
    [sym_binary] = STATE(6019),
    [sym_unary] = STATE(6019),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3421] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6020),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6020),
    [sym_operator_assignment] = STATE(6020),
    [sym_conditional] = STATE(6020),
    [sym_range] = STATE(6020),
    [sym_binary] = STATE(6020),
    [sym_unary] = STATE(6020),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3422] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6021),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6021),
    [sym_operator_assignment] = STATE(6021),
    [sym_conditional] = STATE(6021),
    [sym_range] = STATE(6021),
    [sym_binary] = STATE(6021),
    [sym_unary] = STATE(6021),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3423] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6022),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6022),
    [sym_operator_assignment] = STATE(6022),
    [sym_conditional] = STATE(6022),
    [sym_range] = STATE(6022),
    [sym_binary] = STATE(6022),
    [sym_unary] = STATE(6022),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3424] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6023),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6023),
    [sym_operator_assignment] = STATE(6023),
    [sym_conditional] = STATE(6023),
    [sym_range] = STATE(6023),
    [sym_binary] = STATE(6023),
    [sym_unary] = STATE(6023),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3425] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6024),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6024),
    [sym_operator_assignment] = STATE(6024),
    [sym_conditional] = STATE(6024),
    [sym_range] = STATE(6024),
    [sym_binary] = STATE(6024),
    [sym_unary] = STATE(6024),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3426] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6025),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6025),
    [sym_operator_assignment] = STATE(6025),
    [sym_conditional] = STATE(6025),
    [sym_range] = STATE(6025),
    [sym_binary] = STATE(6025),
    [sym_unary] = STATE(6025),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3427] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6026),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6026),
    [sym_operator_assignment] = STATE(6026),
    [sym_conditional] = STATE(6026),
    [sym_range] = STATE(6026),
    [sym_binary] = STATE(6026),
    [sym_unary] = STATE(6026),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3428] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6027),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6027),
    [sym_operator_assignment] = STATE(6027),
    [sym_conditional] = STATE(6027),
    [sym_range] = STATE(6027),
    [sym_binary] = STATE(6027),
    [sym_unary] = STATE(6027),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3429] = {
    [sym__heredoc_body_start] = ACTIONS(6024),
    [sym__binary_minus] = ACTIONS(6024),
    [sym__binary_star] = ACTIONS(6024),
    [anon_sym_LBRACE] = ACTIONS(6024),
    [anon_sym_RBRACE] = ACTIONS(6024),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_DOT] = ACTIONS(6026),
    [anon_sym_COMMA] = ACTIONS(6024),
    [anon_sym_PIPE] = ACTIONS(6026),
    [anon_sym_SEMI] = ACTIONS(6024),
    [anon_sym_STAR_STAR] = ACTIONS(6026),
    [anon_sym_AMP] = ACTIONS(6026),
    [anon_sym_EQ] = ACTIONS(6026),
    [anon_sym_LT] = ACTIONS(6026),
    [anon_sym_if] = ACTIONS(6024),
    [anon_sym_unless] = ACTIONS(6024),
    [anon_sym_while] = ACTIONS(6024),
    [anon_sym_until] = ACTIONS(6024),
    [anon_sym_rescue] = ACTIONS(6024),
    [anon_sym_in] = ACTIONS(6024),
    [anon_sym_do] = ACTIONS(6024),
    [anon_sym_EQ_GT] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_RBRACK] = ACTIONS(6024),
    [anon_sym_COLON_COLON2] = ACTIONS(6024),
    [anon_sym_AMP_DOT] = ACTIONS(6024),
    [anon_sym_PLUS_EQ] = ACTIONS(6024),
    [anon_sym_DASH_EQ] = ACTIONS(6024),
    [anon_sym_STAR_EQ] = ACTIONS(6024),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6024),
    [anon_sym_SLASH_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6024),
    [anon_sym_AMP_EQ] = ACTIONS(6024),
    [anon_sym_PERCENT_EQ] = ACTIONS(6024),
    [anon_sym_GT_GT_EQ] = ACTIONS(6024),
    [anon_sym_LT_LT_EQ] = ACTIONS(6024),
    [anon_sym_CARET_EQ] = ACTIONS(6024),
    [anon_sym_QMARK] = ACTIONS(6024),
    [anon_sym_COLON2] = ACTIONS(6026),
    [anon_sym_DOT_DOT] = ACTIONS(6026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_or] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(6026),
    [anon_sym_LT_LT] = ACTIONS(6026),
    [anon_sym_GT_GT] = ACTIONS(6026),
    [anon_sym_EQ_EQ] = ACTIONS(6026),
    [anon_sym_BANG_EQ] = ACTIONS(6024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6024),
    [anon_sym_LT_EQ_GT] = ACTIONS(6024),
    [anon_sym_EQ_TILDE] = ACTIONS(6024),
    [anon_sym_BANG_TILDE] = ACTIONS(6024),
    [anon_sym_LT_EQ] = ACTIONS(6026),
    [anon_sym_GT] = ACTIONS(6026),
    [anon_sym_GT_EQ] = ACTIONS(6024),
    [anon_sym_CARET] = ACTIONS(6026),
    [anon_sym_PLUS] = ACTIONS(6026),
    [anon_sym_SLASH] = ACTIONS(6026),
    [anon_sym_PERCENT] = ACTIONS(6026),
    [sym_comment] = ACTIONS(87),
  },
  [3430] = {
    [sym_heredoc_body] = STATE(6028),
    [aux_sym_call_repeat1] = STATE(6028),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [3431] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1372),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym__argument] = STATE(4285),
    [sym_splat_argument] = STATE(4285),
    [sym_hash_splat_argument] = STATE(4285),
    [sym_block_argument] = STATE(4285),
    [sym_assignment] = STATE(1372),
    [sym_operator_assignment] = STATE(1372),
    [sym_conditional] = STATE(1372),
    [sym_range] = STATE(1372),
    [sym_binary] = STATE(1372),
    [sym_unary] = STATE(1372),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1380),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(6029),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4285),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2401),
    [sym__splat_star] = ACTIONS(2403),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__identifier_hash_key] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_identifier] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3432] = {
    [sym_heredoc_body] = STATE(6030),
    [aux_sym_call_repeat1] = STATE(6030),
    [aux_sym_argument_list_repeat1] = STATE(6031),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(5572),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [3433] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_splat_argument] = STATE(6033),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_right_assignment_list] = STATE(4290),
    [sym__arg_or_splat_arg] = STATE(6033),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(2403),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3434] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6034),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(6034),
    [sym_operator_assignment] = STATE(6034),
    [sym_conditional] = STATE(6034),
    [sym_range] = STATE(6034),
    [sym_binary] = STATE(6034),
    [sym_unary] = STATE(6034),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3435] = {
    [sym_string] = STATE(6035),
    [aux_sym_chained_string_repeat1] = STATE(6035),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_RBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [3436] = {
    [sym__line_break] = ACTIONS(9143),
    [sym__heredoc_body_start] = ACTIONS(9143),
    [sym__binary_minus] = ACTIONS(9143),
    [sym__binary_star] = ACTIONS(9143),
    [ts_builtin_sym_end] = ACTIONS(9143),
    [anon_sym___END__] = ACTIONS(9143),
    [anon_sym_LBRACE] = ACTIONS(9143),
    [anon_sym_RBRACE] = ACTIONS(9143),
    [anon_sym_RPAREN] = ACTIONS(9143),
    [anon_sym_DOT] = ACTIONS(9145),
    [anon_sym_COMMA] = ACTIONS(9143),
    [anon_sym_PIPE] = ACTIONS(9145),
    [anon_sym_SEMI] = ACTIONS(9143),
    [anon_sym_STAR_STAR] = ACTIONS(9143),
    [anon_sym_AMP] = ACTIONS(9145),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(9143),
    [anon_sym_if] = ACTIONS(9143),
    [anon_sym_unless] = ACTIONS(9143),
    [anon_sym_while] = ACTIONS(9143),
    [anon_sym_until] = ACTIONS(9143),
    [anon_sym_rescue] = ACTIONS(9143),
    [anon_sym_do] = ACTIONS(9143),
    [anon_sym_when] = ACTIONS(9143),
    [anon_sym_elsif] = ACTIONS(9143),
    [anon_sym_else] = ACTIONS(9143),
    [anon_sym_then] = ACTIONS(9143),
    [anon_sym_ensure] = ACTIONS(9143),
    [anon_sym_EQ_GT] = ACTIONS(9143),
    [anon_sym_LBRACK] = ACTIONS(9143),
    [anon_sym_COLON_COLON2] = ACTIONS(9143),
    [anon_sym_AMP_DOT] = ACTIONS(9143),
    [anon_sym_QMARK] = ACTIONS(9143),
    [anon_sym_DOT_DOT] = ACTIONS(9145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9143),
    [anon_sym_and] = ACTIONS(9143),
    [anon_sym_or] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE] = ACTIONS(9143),
    [anon_sym_AMP_AMP] = ACTIONS(9143),
    [anon_sym_LT_LT] = ACTIONS(9143),
    [anon_sym_GT_GT] = ACTIONS(9143),
    [anon_sym_EQ_EQ] = ACTIONS(9145),
    [anon_sym_BANG_EQ] = ACTIONS(9143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9143),
    [anon_sym_LT_EQ_GT] = ACTIONS(9143),
    [anon_sym_EQ_TILDE] = ACTIONS(9143),
    [anon_sym_BANG_TILDE] = ACTIONS(9143),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9143),
    [anon_sym_CARET] = ACTIONS(9143),
    [anon_sym_PLUS] = ACTIONS(9143),
    [anon_sym_SLASH] = ACTIONS(9143),
    [anon_sym_PERCENT] = ACTIONS(9143),
    [sym_comment] = ACTIONS(87),
  },
  [3437] = {
    [sym_interpolation] = STATE(6037),
    [aux_sym_heredoc_body_repeat1] = STATE(6037),
    [sym__heredoc_content] = ACTIONS(9147),
    [sym_heredoc_end] = ACTIONS(9149),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(9147),
  },
  [3438] = {
    [sym__heredoc_body_start] = ACTIONS(9151),
    [anon_sym_RPAREN] = ACTIONS(9151),
    [anon_sym_RBRACK] = ACTIONS(9151),
    [sym_comment] = ACTIONS(87),
  },
  [3439] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(6038),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(9151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(9151),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3440] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(6039),
    [sym_operator_assignment] = STATE(6039),
    [sym_conditional] = STATE(6039),
    [sym_range] = STATE(6039),
    [sym_binary] = STATE(6039),
    [sym_unary] = STATE(6039),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3441] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_RBRACK] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(2375),
    [anon_sym_DOT_DOT] = ACTIONS(2377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2379),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ_GT] = ACTIONS(2383),
    [anon_sym_EQ_TILDE] = ACTIONS(2383),
    [anon_sym_BANG_TILDE] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [3442] = {
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [3443] = {
    [aux_sym_exceptions_repeat1] = STATE(6041),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [3444] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_RBRACK] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(2375),
    [anon_sym_DOT_DOT] = ACTIONS(2377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2379),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ_GT] = ACTIONS(2383),
    [anon_sym_EQ_TILDE] = ACTIONS(2383),
    [anon_sym_BANG_TILDE] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [3445] = {
    [sym_string] = STATE(3445),
    [aux_sym_chained_string_repeat1] = STATE(3445),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_RBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [3446] = {
    [anon_sym_PIPE] = ACTIONS(9156),
    [anon_sym_SEMI] = ACTIONS(9158),
    [sym_comment] = ACTIONS(87),
  },
  [3447] = {
    [sym__simple_symbol] = ACTIONS(9160),
    [sym__string_start] = ACTIONS(9160),
    [sym__symbol_start] = ACTIONS(9160),
    [sym__subshell_start] = ACTIONS(9160),
    [sym__regex_start] = ACTIONS(9160),
    [sym__string_array_start] = ACTIONS(9160),
    [sym__symbol_array_start] = ACTIONS(9160),
    [sym_heredoc_beginning] = ACTIONS(9160),
    [sym__unary_minus] = ACTIONS(9160),
    [anon_sym_BEGIN] = ACTIONS(9162),
    [anon_sym_LBRACE] = ACTIONS(9160),
    [anon_sym_RBRACE] = ACTIONS(9160),
    [anon_sym_END] = ACTIONS(9162),
    [anon_sym_def] = ACTIONS(9162),
    [anon_sym_LPAREN] = ACTIONS(9160),
    [anon_sym_COLON_COLON] = ACTIONS(9160),
    [anon_sym_SEMI] = ACTIONS(9160),
    [anon_sym_STAR] = ACTIONS(9160),
    [anon_sym_class] = ACTIONS(9162),
    [anon_sym_module] = ACTIONS(9162),
    [anon_sym_return] = ACTIONS(9162),
    [anon_sym_yield] = ACTIONS(9162),
    [anon_sym_break] = ACTIONS(9162),
    [anon_sym_next] = ACTIONS(9162),
    [sym_redo] = ACTIONS(9162),
    [sym_retry] = ACTIONS(9162),
    [anon_sym_if] = ACTIONS(9162),
    [anon_sym_unless] = ACTIONS(9162),
    [anon_sym_while] = ACTIONS(9162),
    [anon_sym_until] = ACTIONS(9162),
    [anon_sym_for] = ACTIONS(9162),
    [anon_sym_case] = ACTIONS(9162),
    [anon_sym_begin] = ACTIONS(9162),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_defined_QMARK] = ACTIONS(9160),
    [anon_sym_not] = ACTIONS(9162),
    [anon_sym_BANG] = ACTIONS(9160),
    [anon_sym_TILDE] = ACTIONS(9160),
    [sym_constant] = ACTIONS(9162),
    [sym_identifier] = ACTIONS(9162),
    [sym_instance_variable] = ACTIONS(9160),
    [sym_class_variable] = ACTIONS(9160),
    [sym_global_variable] = ACTIONS(9160),
    [anon_sym_undef] = ACTIONS(9162),
    [anon_sym_alias] = ACTIONS(9162),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9162),
    [sym_float] = ACTIONS(9162),
    [sym_complex] = ACTIONS(9160),
    [sym_super] = ACTIONS(9162),
    [anon_sym_true] = ACTIONS(9162),
    [anon_sym_TRUE] = ACTIONS(9162),
    [anon_sym_false] = ACTIONS(9162),
    [anon_sym_FALSE] = ACTIONS(9162),
    [sym_self] = ACTIONS(9162),
    [anon_sym_nil] = ACTIONS(9162),
    [anon_sym_NIL] = ACTIONS(9162),
    [sym_character] = ACTIONS(9160),
    [anon_sym_LBRACK2] = ACTIONS(9160),
    [anon_sym_DASH_GT] = ACTIONS(9160),
  },
  [3448] = {
    [sym_identifier] = ACTIONS(9164),
    [sym_comment] = ACTIONS(87),
  },
  [3449] = {
    [anon_sym_COMMA] = ACTIONS(2479),
    [anon_sym_PIPE] = ACTIONS(2479),
    [anon_sym_SEMI] = ACTIONS(2479),
    [anon_sym_COLON] = ACTIONS(9166),
    [anon_sym_EQ] = ACTIONS(9168),
    [sym_comment] = ACTIONS(87),
  },
  [3450] = {
    [aux_sym_method_parameters_repeat1] = STATE(6048),
    [anon_sym_COMMA] = ACTIONS(9170),
    [anon_sym_PIPE] = ACTIONS(9156),
    [anon_sym_SEMI] = ACTIONS(9158),
    [sym_comment] = ACTIONS(87),
  },
  [3451] = {
    [sym__line_break] = ACTIONS(9172),
    [sym__heredoc_body_start] = ACTIONS(9172),
    [sym__binary_minus] = ACTIONS(9172),
    [sym__binary_star] = ACTIONS(9172),
    [ts_builtin_sym_end] = ACTIONS(9172),
    [anon_sym___END__] = ACTIONS(9172),
    [anon_sym_LBRACE] = ACTIONS(9172),
    [anon_sym_RBRACE] = ACTIONS(9172),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9174),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9174),
    [anon_sym_SEMI] = ACTIONS(9172),
    [anon_sym_STAR_STAR] = ACTIONS(9172),
    [anon_sym_AMP] = ACTIONS(9174),
    [anon_sym_LT] = ACTIONS(9174),
    [anon_sym_end] = ACTIONS(9172),
    [anon_sym_if] = ACTIONS(9172),
    [anon_sym_unless] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(9172),
    [anon_sym_until] = ACTIONS(9172),
    [anon_sym_rescue] = ACTIONS(9172),
    [anon_sym_do] = ACTIONS(9172),
    [anon_sym_when] = ACTIONS(9172),
    [anon_sym_elsif] = ACTIONS(9172),
    [anon_sym_else] = ACTIONS(9172),
    [anon_sym_then] = ACTIONS(9172),
    [anon_sym_ensure] = ACTIONS(9172),
    [anon_sym_EQ_GT] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [anon_sym_QMARK] = ACTIONS(9172),
    [anon_sym_DOT_DOT] = ACTIONS(9174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9172),
    [anon_sym_and] = ACTIONS(9172),
    [anon_sym_or] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE] = ACTIONS(9172),
    [anon_sym_AMP_AMP] = ACTIONS(9172),
    [anon_sym_LT_LT] = ACTIONS(9172),
    [anon_sym_GT_GT] = ACTIONS(9172),
    [anon_sym_EQ_EQ] = ACTIONS(9174),
    [anon_sym_BANG_EQ] = ACTIONS(9172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9172),
    [anon_sym_LT_EQ_GT] = ACTIONS(9172),
    [anon_sym_EQ_TILDE] = ACTIONS(9172),
    [anon_sym_BANG_TILDE] = ACTIONS(9172),
    [anon_sym_LT_EQ] = ACTIONS(9174),
    [anon_sym_GT] = ACTIONS(9174),
    [anon_sym_GT_EQ] = ACTIONS(9172),
    [anon_sym_CARET] = ACTIONS(9172),
    [anon_sym_PLUS] = ACTIONS(9172),
    [anon_sym_SLASH] = ACTIONS(9172),
    [anon_sym_PERCENT] = ACTIONS(9172),
    [sym_comment] = ACTIONS(87),
  },
  [3452] = {
    [anon_sym_RBRACE] = ACTIONS(9176),
    [sym_comment] = ACTIONS(87),
  },
  [3453] = {
    [aux_sym_method_parameters_repeat1] = STATE(6051),
    [anon_sym_RPAREN] = ACTIONS(9178),
    [anon_sym_COMMA] = ACTIONS(5616),
    [sym_comment] = ACTIONS(87),
  },
  [3454] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6052),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(6052),
    [sym_operator_assignment] = STATE(6052),
    [sym_conditional] = STATE(6052),
    [sym_range] = STATE(6052),
    [sym_binary] = STATE(6052),
    [sym_unary] = STATE(6052),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_RPAREN] = ACTIONS(5642),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3455] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6053),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(6053),
    [sym_operator_assignment] = STATE(6053),
    [sym_conditional] = STATE(6053),
    [sym_range] = STATE(6053),
    [sym_binary] = STATE(6053),
    [sym_unary] = STATE(6053),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3456] = {
    [anon_sym_LBRACE] = ACTIONS(9180),
    [anon_sym_do] = ACTIONS(9180),
    [sym_comment] = ACTIONS(87),
  },
  [3457] = {
    [sym__formal_parameter] = STATE(6054),
    [sym__simple_formal_parameter] = STATE(6054),
    [sym_destructured_parameter] = STATE(6054),
    [sym_splat_parameter] = STATE(6054),
    [sym_hash_splat_parameter] = STATE(6054),
    [sym_block_parameter] = STATE(6054),
    [sym_keyword_parameter] = STATE(6054),
    [sym_optional_parameter] = STATE(6054),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2457),
    [sym_comment] = ACTIONS(87),
  },
  [3458] = {
    [aux_sym_method_parameters_repeat1] = STATE(6056),
    [anon_sym_RPAREN] = ACTIONS(9182),
    [anon_sym_COMMA] = ACTIONS(5616),
    [sym_comment] = ACTIONS(87),
  },
  [3459] = {
    [anon_sym_PIPE] = ACTIONS(9184),
    [anon_sym_SEMI] = ACTIONS(9186),
    [sym_comment] = ACTIONS(87),
  },
  [3460] = {
    [sym__line_break] = ACTIONS(9160),
    [sym__simple_symbol] = ACTIONS(9160),
    [sym__string_start] = ACTIONS(9160),
    [sym__symbol_start] = ACTIONS(9160),
    [sym__subshell_start] = ACTIONS(9160),
    [sym__regex_start] = ACTIONS(9160),
    [sym__string_array_start] = ACTIONS(9160),
    [sym__symbol_array_start] = ACTIONS(9160),
    [sym__heredoc_body_start] = ACTIONS(9160),
    [sym_heredoc_beginning] = ACTIONS(9160),
    [sym__unary_minus] = ACTIONS(9160),
    [anon_sym_BEGIN] = ACTIONS(9162),
    [anon_sym_LBRACE] = ACTIONS(9160),
    [anon_sym_END] = ACTIONS(9162),
    [anon_sym_def] = ACTIONS(9162),
    [anon_sym_LPAREN] = ACTIONS(9160),
    [anon_sym_COLON_COLON] = ACTIONS(9160),
    [anon_sym_SEMI] = ACTIONS(9160),
    [anon_sym_STAR] = ACTIONS(9160),
    [anon_sym_class] = ACTIONS(9162),
    [anon_sym_module] = ACTIONS(9162),
    [anon_sym_end] = ACTIONS(9162),
    [anon_sym_return] = ACTIONS(9162),
    [anon_sym_yield] = ACTIONS(9162),
    [anon_sym_break] = ACTIONS(9162),
    [anon_sym_next] = ACTIONS(9162),
    [sym_redo] = ACTIONS(9162),
    [sym_retry] = ACTIONS(9162),
    [anon_sym_if] = ACTIONS(9162),
    [anon_sym_unless] = ACTIONS(9162),
    [anon_sym_while] = ACTIONS(9162),
    [anon_sym_until] = ACTIONS(9162),
    [anon_sym_for] = ACTIONS(9162),
    [anon_sym_case] = ACTIONS(9162),
    [anon_sym_begin] = ACTIONS(9162),
    [anon_sym_PLUS] = ACTIONS(9162),
    [anon_sym_defined_QMARK] = ACTIONS(9160),
    [anon_sym_not] = ACTIONS(9162),
    [anon_sym_BANG] = ACTIONS(9160),
    [anon_sym_TILDE] = ACTIONS(9160),
    [sym_constant] = ACTIONS(9162),
    [sym_identifier] = ACTIONS(9162),
    [sym_instance_variable] = ACTIONS(9160),
    [sym_class_variable] = ACTIONS(9160),
    [sym_global_variable] = ACTIONS(9160),
    [anon_sym_undef] = ACTIONS(9162),
    [anon_sym_alias] = ACTIONS(9162),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9162),
    [sym_float] = ACTIONS(9162),
    [sym_complex] = ACTIONS(9160),
    [sym_super] = ACTIONS(9162),
    [anon_sym_true] = ACTIONS(9162),
    [anon_sym_TRUE] = ACTIONS(9162),
    [anon_sym_false] = ACTIONS(9162),
    [anon_sym_FALSE] = ACTIONS(9162),
    [sym_self] = ACTIONS(9162),
    [anon_sym_nil] = ACTIONS(9162),
    [anon_sym_NIL] = ACTIONS(9162),
    [sym_character] = ACTIONS(9160),
    [anon_sym_LBRACK2] = ACTIONS(9160),
    [anon_sym_DASH_GT] = ACTIONS(9160),
  },
  [3461] = {
    [sym_identifier] = ACTIONS(9188),
    [sym_comment] = ACTIONS(87),
  },
  [3462] = {
    [aux_sym_method_parameters_repeat1] = STATE(6061),
    [anon_sym_COMMA] = ACTIONS(9190),
    [anon_sym_PIPE] = ACTIONS(9184),
    [anon_sym_SEMI] = ACTIONS(9186),
    [sym_comment] = ACTIONS(87),
  },
  [3463] = {
    [sym__line_break] = ACTIONS(9192),
    [sym__heredoc_body_start] = ACTIONS(9192),
    [sym__binary_minus] = ACTIONS(9192),
    [sym__binary_star] = ACTIONS(9192),
    [ts_builtin_sym_end] = ACTIONS(9192),
    [anon_sym___END__] = ACTIONS(9192),
    [anon_sym_LBRACE] = ACTIONS(9192),
    [anon_sym_RBRACE] = ACTIONS(9192),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9194),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9194),
    [anon_sym_SEMI] = ACTIONS(9192),
    [anon_sym_STAR_STAR] = ACTIONS(9192),
    [anon_sym_AMP] = ACTIONS(9194),
    [anon_sym_LT] = ACTIONS(9194),
    [anon_sym_end] = ACTIONS(9192),
    [anon_sym_if] = ACTIONS(9192),
    [anon_sym_unless] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(9192),
    [anon_sym_until] = ACTIONS(9192),
    [anon_sym_rescue] = ACTIONS(9192),
    [anon_sym_do] = ACTIONS(9192),
    [anon_sym_when] = ACTIONS(9192),
    [anon_sym_elsif] = ACTIONS(9192),
    [anon_sym_else] = ACTIONS(9192),
    [anon_sym_then] = ACTIONS(9192),
    [anon_sym_ensure] = ACTIONS(9192),
    [anon_sym_EQ_GT] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [anon_sym_QMARK] = ACTIONS(9192),
    [anon_sym_DOT_DOT] = ACTIONS(9194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9192),
    [anon_sym_and] = ACTIONS(9192),
    [anon_sym_or] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE] = ACTIONS(9192),
    [anon_sym_AMP_AMP] = ACTIONS(9192),
    [anon_sym_LT_LT] = ACTIONS(9192),
    [anon_sym_GT_GT] = ACTIONS(9192),
    [anon_sym_EQ_EQ] = ACTIONS(9194),
    [anon_sym_BANG_EQ] = ACTIONS(9192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9192),
    [anon_sym_LT_EQ_GT] = ACTIONS(9192),
    [anon_sym_EQ_TILDE] = ACTIONS(9192),
    [anon_sym_BANG_TILDE] = ACTIONS(9192),
    [anon_sym_LT_EQ] = ACTIONS(9194),
    [anon_sym_GT] = ACTIONS(9194),
    [anon_sym_GT_EQ] = ACTIONS(9192),
    [anon_sym_CARET] = ACTIONS(9192),
    [anon_sym_PLUS] = ACTIONS(9192),
    [anon_sym_SLASH] = ACTIONS(9192),
    [anon_sym_PERCENT] = ACTIONS(9192),
    [sym_comment] = ACTIONS(87),
  },
  [3464] = {
    [anon_sym_end] = ACTIONS(9196),
    [sym_comment] = ACTIONS(87),
  },
  [3465] = {
    [sym__statements] = STATE(6063),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9198),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3466] = {
    [sym__statements] = STATE(6063),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6064),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(6064),
    [sym__line_break] = ACTIONS(9200),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9198),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3467] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6065),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(6065),
    [sym_operator_assignment] = STATE(6065),
    [sym_conditional] = STATE(6065),
    [sym_range] = STATE(6065),
    [sym_binary] = STATE(6065),
    [sym_unary] = STATE(6065),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3468] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(562),
    [sym__argument_list_with_parens] = STATE(4778),
    [sym__argument] = STATE(4779),
    [sym_splat_argument] = STATE(4779),
    [sym_hash_splat_argument] = STATE(4779),
    [sym_block_argument] = STATE(4779),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4780),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4779),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7500),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7506),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3469] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(568),
    [sym__argument_list_with_parens] = STATE(4778),
    [sym__argument] = STATE(4779),
    [sym_splat_argument] = STATE(4779),
    [sym_hash_splat_argument] = STATE(4779),
    [sym_block_argument] = STATE(4779),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4780),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4779),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7500),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7506),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3470] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(4778),
    [sym__argument] = STATE(4779),
    [sym_splat_argument] = STATE(4779),
    [sym_hash_splat_argument] = STATE(4779),
    [sym_block_argument] = STATE(4779),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4780),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4779),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7500),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7506),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3471] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(4778),
    [sym__argument] = STATE(4779),
    [sym_splat_argument] = STATE(4779),
    [sym_hash_splat_argument] = STATE(4779),
    [sym_block_argument] = STATE(4779),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4780),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4779),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7500),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(4024),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7506),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3472] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6066),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(6066),
    [sym_operator_assignment] = STATE(6066),
    [sym_conditional] = STATE(6066),
    [sym_range] = STATE(6066),
    [sym_binary] = STATE(6066),
    [sym_unary] = STATE(6066),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3473] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3474] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(9206),
    [anon_sym_COMMA] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(9212),
    [anon_sym_do] = ACTIONS(9206),
    [anon_sym_QMARK] = ACTIONS(9214),
    [anon_sym_DOT_DOT] = ACTIONS(9216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9218),
    [anon_sym_and] = ACTIONS(9220),
    [anon_sym_or] = ACTIONS(9220),
    [anon_sym_PIPE_PIPE] = ACTIONS(9222),
    [anon_sym_AMP_AMP] = ACTIONS(9222),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(9226),
    [anon_sym_BANG_EQ] = ACTIONS(9222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9222),
    [anon_sym_LT_EQ_GT] = ACTIONS(9222),
    [anon_sym_EQ_TILDE] = ACTIONS(9222),
    [anon_sym_BANG_TILDE] = ACTIONS(9222),
    [anon_sym_LT_EQ] = ACTIONS(9212),
    [anon_sym_GT] = ACTIONS(9212),
    [anon_sym_GT_EQ] = ACTIONS(9228),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [3475] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4611),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(6078),
    [sym__argument_list_with_parens] = STATE(4612),
    [sym__argument] = STATE(4613),
    [sym_splat_argument] = STATE(4613),
    [sym_hash_splat_argument] = STATE(4613),
    [sym_block_argument] = STATE(4613),
    [sym_do_block] = STATE(1665),
    [sym_block] = STATE(1665),
    [sym_assignment] = STATE(4611),
    [sym_operator_assignment] = STATE(4611),
    [sym_conditional] = STATE(4611),
    [sym_range] = STATE(4611),
    [sym_binary] = STATE(4611),
    [sym_unary] = STATE(4611),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4614),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4613),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7335),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(7339),
    [anon_sym_LBRACE] = ACTIONS(9232),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7341),
    [sym_identifier] = ACTIONS(7341),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3476] = {
    [anon_sym_EQ] = ACTIONS(9234),
    [sym_comment] = ACTIONS(87),
  },
  [3477] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9236),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9238),
    [anon_sym_DASH_EQ] = ACTIONS(9238),
    [anon_sym_STAR_EQ] = ACTIONS(9238),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9238),
    [anon_sym_SLASH_EQ] = ACTIONS(9238),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9238),
    [anon_sym_PIPE_EQ] = ACTIONS(9238),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9238),
    [anon_sym_AMP_EQ] = ACTIONS(9238),
    [anon_sym_PERCENT_EQ] = ACTIONS(9238),
    [anon_sym_GT_GT_EQ] = ACTIONS(9238),
    [anon_sym_LT_LT_EQ] = ACTIONS(9238),
    [anon_sym_CARET_EQ] = ACTIONS(9238),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3478] = {
    [sym_string] = STATE(6081),
    [aux_sym_chained_string_repeat1] = STATE(6081),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3479] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(9240),
    [anon_sym_COMMA] = ACTIONS(9240),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(9212),
    [anon_sym_do] = ACTIONS(9240),
    [anon_sym_QMARK] = ACTIONS(9214),
    [anon_sym_DOT_DOT] = ACTIONS(9216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9218),
    [anon_sym_and] = ACTIONS(9220),
    [anon_sym_or] = ACTIONS(9220),
    [anon_sym_PIPE_PIPE] = ACTIONS(9222),
    [anon_sym_AMP_AMP] = ACTIONS(9222),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(9226),
    [anon_sym_BANG_EQ] = ACTIONS(9222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9222),
    [anon_sym_LT_EQ_GT] = ACTIONS(9222),
    [anon_sym_EQ_TILDE] = ACTIONS(9222),
    [anon_sym_BANG_TILDE] = ACTIONS(9222),
    [anon_sym_LT_EQ] = ACTIONS(9212),
    [anon_sym_GT] = ACTIONS(9212),
    [anon_sym_GT_EQ] = ACTIONS(9228),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [3480] = {
    [anon_sym_LBRACE] = ACTIONS(9242),
    [anon_sym_COMMA] = ACTIONS(9242),
    [anon_sym_do] = ACTIONS(9242),
    [sym_comment] = ACTIONS(87),
  },
  [3481] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(3481),
    [anon_sym_LBRACE] = ACTIONS(9242),
    [anon_sym_COMMA] = ACTIONS(9244),
    [anon_sym_do] = ACTIONS(9242),
    [sym_comment] = ACTIONS(87),
  },
  [3482] = {
    [ts_builtin_sym_end] = ACTIONS(9247),
    [sym_comment] = ACTIONS(87),
  },
  [3483] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(45),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(45),
    [sym_unless_modifier] = STATE(45),
    [sym_while_modifier] = STATE(45),
    [sym_until_modifier] = STATE(45),
    [sym_rescue_modifier] = STATE(45),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(46),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(46),
    [sym_operator_assignment] = STATE(46),
    [sym_conditional] = STATE(46),
    [sym_range] = STATE(46),
    [sym_binary] = STATE(46),
    [sym_unary] = STATE(46),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_undef] = STATE(45),
    [sym_alias] = STATE(45),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(45),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [anon_sym_undef] = ACTIONS(83),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3484] = {
    [sym__string_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_COLON2] = ACTIONS(839),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [3485] = {
    [sym__string_end] = ACTIONS(9249),
    [sym_comment] = ACTIONS(87),
  },
  [3486] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3487] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6090),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(6090),
    [sym_operator_assignment] = STATE(6090),
    [sym_conditional] = STATE(6090),
    [sym_range] = STATE(6090),
    [sym_binary] = STATE(6090),
    [sym_unary] = STATE(6090),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3488] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6095),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(6095),
    [sym_operator_assignment] = STATE(6095),
    [sym_conditional] = STATE(6095),
    [sym_range] = STATE(6095),
    [sym_binary] = STATE(6095),
    [sym_unary] = STATE(6095),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3489] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6097),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(6097),
    [sym_operator_assignment] = STATE(6097),
    [sym_conditional] = STATE(6097),
    [sym_range] = STATE(6097),
    [sym_binary] = STATE(6097),
    [sym_unary] = STATE(6097),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3490] = {
    [anon_sym_COLON] = ACTIONS(9277),
    [sym_comment] = ACTIONS(87),
  },
  [3491] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6100),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(6100),
    [sym_operator_assignment] = STATE(6100),
    [sym_conditional] = STATE(6100),
    [sym_range] = STATE(6100),
    [sym_binary] = STATE(6100),
    [sym_unary] = STATE(6100),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3492] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6106),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(6107),
    [sym__argument] = STATE(6108),
    [sym_splat_argument] = STATE(6108),
    [sym_hash_splat_argument] = STATE(6108),
    [sym_block_argument] = STATE(6108),
    [sym_assignment] = STATE(6106),
    [sym_operator_assignment] = STATE(6106),
    [sym_conditional] = STATE(6106),
    [sym_range] = STATE(6106),
    [sym_binary] = STATE(6106),
    [sym_unary] = STATE(6106),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6109),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6108),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9279),
    [sym__splat_star] = ACTIONS(9281),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(9283),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(9285),
    [sym_identifier] = ACTIONS(9285),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3493] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6106),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(6107),
    [sym__argument] = STATE(6108),
    [sym_splat_argument] = STATE(6108),
    [sym_hash_splat_argument] = STATE(6108),
    [sym_block_argument] = STATE(6108),
    [sym_assignment] = STATE(6106),
    [sym_operator_assignment] = STATE(6106),
    [sym_conditional] = STATE(6106),
    [sym_range] = STATE(6106),
    [sym_binary] = STATE(6106),
    [sym_unary] = STATE(6106),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6109),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6108),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9279),
    [sym__splat_star] = ACTIONS(9281),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(9283),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(9285),
    [sym_identifier] = ACTIONS(9285),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3494] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6106),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(6107),
    [sym__argument] = STATE(6108),
    [sym_splat_argument] = STATE(6108),
    [sym_hash_splat_argument] = STATE(6108),
    [sym_block_argument] = STATE(6108),
    [sym_assignment] = STATE(6106),
    [sym_operator_assignment] = STATE(6106),
    [sym_conditional] = STATE(6106),
    [sym_range] = STATE(6106),
    [sym_binary] = STATE(6106),
    [sym_unary] = STATE(6106),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6109),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6108),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9279),
    [sym__splat_star] = ACTIONS(9281),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(9283),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(9285),
    [sym_identifier] = ACTIONS(9285),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3495] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6106),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(6107),
    [sym__argument] = STATE(6108),
    [sym_splat_argument] = STATE(6108),
    [sym_hash_splat_argument] = STATE(6108),
    [sym_block_argument] = STATE(6108),
    [sym_assignment] = STATE(6106),
    [sym_operator_assignment] = STATE(6106),
    [sym_conditional] = STATE(6106),
    [sym_range] = STATE(6106),
    [sym_binary] = STATE(6106),
    [sym_unary] = STATE(6106),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6109),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6108),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9279),
    [sym__splat_star] = ACTIONS(9281),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(9283),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(9285),
    [sym_identifier] = ACTIONS(9285),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3496] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6110),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(6110),
    [sym_operator_assignment] = STATE(6110),
    [sym_conditional] = STATE(6110),
    [sym_range] = STATE(6110),
    [sym_binary] = STATE(6110),
    [sym_unary] = STATE(6110),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3497] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3498] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9287),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_COLON2] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3499] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(9277),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [3500] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6127),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(6128),
    [sym__argument] = STATE(6129),
    [sym_splat_argument] = STATE(6129),
    [sym_hash_splat_argument] = STATE(6129),
    [sym_block_argument] = STATE(6129),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(6127),
    [sym_operator_assignment] = STATE(6127),
    [sym_conditional] = STATE(6127),
    [sym_range] = STATE(6127),
    [sym_binary] = STATE(6127),
    [sym_unary] = STATE(6127),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6130),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6129),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9315),
    [sym__splat_star] = ACTIONS(9317),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(9319),
    [anon_sym_LBRACE] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_COLON2] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(9321),
    [sym_identifier] = ACTIONS(9321),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3501] = {
    [sym_heredoc_body] = STATE(6131),
    [aux_sym_call_repeat1] = STATE(6131),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_COLON2] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3502] = {
    [sym_heredoc_body] = STATE(6131),
    [aux_sym_call_repeat1] = STATE(6131),
    [aux_sym_argument_list_repeat1] = STATE(6133),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9323),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_COLON2] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3503] = {
    [anon_sym_EQ] = ACTIONS(9325),
    [sym_comment] = ACTIONS(87),
  },
  [3504] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9327),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9329),
    [anon_sym_DASH_EQ] = ACTIONS(9329),
    [anon_sym_STAR_EQ] = ACTIONS(9329),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9329),
    [anon_sym_SLASH_EQ] = ACTIONS(9329),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9329),
    [anon_sym_PIPE_EQ] = ACTIONS(9329),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9329),
    [anon_sym_AMP_EQ] = ACTIONS(9329),
    [anon_sym_PERCENT_EQ] = ACTIONS(9329),
    [anon_sym_GT_GT_EQ] = ACTIONS(9329),
    [anon_sym_LT_LT_EQ] = ACTIONS(9329),
    [anon_sym_CARET_EQ] = ACTIONS(9329),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3505] = {
    [sym_string] = STATE(6136),
    [aux_sym_chained_string_repeat1] = STATE(6136),
    [sym__string_start] = ACTIONS(9273),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9331),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3506] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [3507] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6137),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6137),
    [sym_operator_assignment] = STATE(6137),
    [sym_conditional] = STATE(6137),
    [sym_range] = STATE(6137),
    [sym_binary] = STATE(6137),
    [sym_unary] = STATE(6137),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3508] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6138),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6138),
    [sym_operator_assignment] = STATE(6138),
    [sym_conditional] = STATE(6138),
    [sym_range] = STATE(6138),
    [sym_binary] = STATE(6138),
    [sym_unary] = STATE(6138),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3509] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6139),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6139),
    [sym_operator_assignment] = STATE(6139),
    [sym_conditional] = STATE(6139),
    [sym_range] = STATE(6139),
    [sym_binary] = STATE(6139),
    [sym_unary] = STATE(6139),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3510] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6140),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6140),
    [sym_operator_assignment] = STATE(6140),
    [sym_conditional] = STATE(6140),
    [sym_range] = STATE(6140),
    [sym_binary] = STATE(6140),
    [sym_unary] = STATE(6140),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3511] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6141),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6141),
    [sym_operator_assignment] = STATE(6141),
    [sym_conditional] = STATE(6141),
    [sym_range] = STATE(6141),
    [sym_binary] = STATE(6141),
    [sym_unary] = STATE(6141),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3512] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6142),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6142),
    [sym_operator_assignment] = STATE(6142),
    [sym_conditional] = STATE(6142),
    [sym_range] = STATE(6142),
    [sym_binary] = STATE(6142),
    [sym_unary] = STATE(6142),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3513] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6143),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(52),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(52),
    [sym_assignment] = STATE(6143),
    [sym_operator_assignment] = STATE(6143),
    [sym_conditional] = STATE(6143),
    [sym_range] = STATE(6143),
    [sym_binary] = STATE(6143),
    [sym_unary] = STATE(6143),
    [sym_left_assignment_list] = STATE(49),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(52),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(52),
    [sym_false] = STATE(52),
    [sym_nil] = STATE(52),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(53),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3514] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6144),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6144),
    [sym_operator_assignment] = STATE(6144),
    [sym_conditional] = STATE(6144),
    [sym_range] = STATE(6144),
    [sym_binary] = STATE(6144),
    [sym_unary] = STATE(6144),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3515] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6145),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6145),
    [sym_operator_assignment] = STATE(6145),
    [sym_conditional] = STATE(6145),
    [sym_range] = STATE(6145),
    [sym_binary] = STATE(6145),
    [sym_unary] = STATE(6145),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3516] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6146),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6146),
    [sym_operator_assignment] = STATE(6146),
    [sym_conditional] = STATE(6146),
    [sym_range] = STATE(6146),
    [sym_binary] = STATE(6146),
    [sym_unary] = STATE(6146),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3517] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6147),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6147),
    [sym_operator_assignment] = STATE(6147),
    [sym_conditional] = STATE(6147),
    [sym_range] = STATE(6147),
    [sym_binary] = STATE(6147),
    [sym_unary] = STATE(6147),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3518] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6155),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(6155),
    [sym_operator_assignment] = STATE(6155),
    [sym_conditional] = STATE(6155),
    [sym_range] = STATE(6155),
    [sym_binary] = STATE(6155),
    [sym_unary] = STATE(6155),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3519] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6160),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(6160),
    [sym_operator_assignment] = STATE(6160),
    [sym_conditional] = STATE(6160),
    [sym_range] = STATE(6160),
    [sym_binary] = STATE(6160),
    [sym_unary] = STATE(6160),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3520] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6162),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(6162),
    [sym_operator_assignment] = STATE(6162),
    [sym_conditional] = STATE(6162),
    [sym_range] = STATE(6162),
    [sym_binary] = STATE(6162),
    [sym_unary] = STATE(6162),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3521] = {
    [anon_sym_COLON] = ACTIONS(9359),
    [sym_comment] = ACTIONS(87),
  },
  [3522] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6165),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(6165),
    [sym_operator_assignment] = STATE(6165),
    [sym_conditional] = STATE(6165),
    [sym_range] = STATE(6165),
    [sym_binary] = STATE(6165),
    [sym_unary] = STATE(6165),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3523] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6127),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(1953),
    [sym__argument_list_with_parens] = STATE(6128),
    [sym__argument] = STATE(6129),
    [sym_splat_argument] = STATE(6129),
    [sym_hash_splat_argument] = STATE(6129),
    [sym_block_argument] = STATE(6129),
    [sym_assignment] = STATE(6127),
    [sym_operator_assignment] = STATE(6127),
    [sym_conditional] = STATE(6127),
    [sym_range] = STATE(6127),
    [sym_binary] = STATE(6127),
    [sym_unary] = STATE(6127),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6130),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6129),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9315),
    [sym__splat_star] = ACTIONS(9317),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(9319),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(9321),
    [sym_identifier] = ACTIONS(9321),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3524] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6127),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(1954),
    [sym__argument_list_with_parens] = STATE(6128),
    [sym__argument] = STATE(6129),
    [sym_splat_argument] = STATE(6129),
    [sym_hash_splat_argument] = STATE(6129),
    [sym_block_argument] = STATE(6129),
    [sym_assignment] = STATE(6127),
    [sym_operator_assignment] = STATE(6127),
    [sym_conditional] = STATE(6127),
    [sym_range] = STATE(6127),
    [sym_binary] = STATE(6127),
    [sym_unary] = STATE(6127),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6130),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6129),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9315),
    [sym__splat_star] = ACTIONS(9317),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(9319),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(9321),
    [sym_identifier] = ACTIONS(9321),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3525] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6127),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(1955),
    [sym__argument_list_with_parens] = STATE(6128),
    [sym__argument] = STATE(6129),
    [sym_splat_argument] = STATE(6129),
    [sym_hash_splat_argument] = STATE(6129),
    [sym_block_argument] = STATE(6129),
    [sym_assignment] = STATE(6127),
    [sym_operator_assignment] = STATE(6127),
    [sym_conditional] = STATE(6127),
    [sym_range] = STATE(6127),
    [sym_binary] = STATE(6127),
    [sym_unary] = STATE(6127),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6130),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6129),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9315),
    [sym__splat_star] = ACTIONS(9317),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(9319),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(9321),
    [sym_identifier] = ACTIONS(9321),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3526] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6127),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(1956),
    [sym__argument_list_with_parens] = STATE(6128),
    [sym__argument] = STATE(6129),
    [sym_splat_argument] = STATE(6129),
    [sym_hash_splat_argument] = STATE(6129),
    [sym_block_argument] = STATE(6129),
    [sym_assignment] = STATE(6127),
    [sym_operator_assignment] = STATE(6127),
    [sym_conditional] = STATE(6127),
    [sym_range] = STATE(6127),
    [sym_binary] = STATE(6127),
    [sym_unary] = STATE(6127),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6130),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6129),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9315),
    [sym__splat_star] = ACTIONS(9317),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(9319),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(9321),
    [sym_identifier] = ACTIONS(9321),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3527] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6166),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(6166),
    [sym_operator_assignment] = STATE(6166),
    [sym_conditional] = STATE(6166),
    [sym_range] = STATE(6166),
    [sym_binary] = STATE(6166),
    [sym_unary] = STATE(6166),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3528] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1978),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(1978),
    [sym_operator_assignment] = STATE(1978),
    [sym_conditional] = STATE(1978),
    [sym_range] = STATE(1978),
    [sym_binary] = STATE(1978),
    [sym_unary] = STATE(1978),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3529] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9361),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_COLON2] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3530] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(9359),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [3531] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6127),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(6128),
    [sym__argument] = STATE(6129),
    [sym_splat_argument] = STATE(6129),
    [sym_hash_splat_argument] = STATE(6129),
    [sym_block_argument] = STATE(6129),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(6127),
    [sym_operator_assignment] = STATE(6127),
    [sym_conditional] = STATE(6127),
    [sym_range] = STATE(6127),
    [sym_binary] = STATE(6127),
    [sym_unary] = STATE(6127),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6130),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6129),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9315),
    [sym__splat_star] = ACTIONS(9317),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(9319),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_COLON2] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(9321),
    [sym_identifier] = ACTIONS(9321),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3532] = {
    [sym_heredoc_body] = STATE(6178),
    [aux_sym_call_repeat1] = STATE(6178),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_COLON2] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3533] = {
    [sym_heredoc_body] = STATE(6178),
    [aux_sym_call_repeat1] = STATE(6178),
    [aux_sym_argument_list_repeat1] = STATE(6180),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9391),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_COLON2] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3534] = {
    [anon_sym_EQ] = ACTIONS(9393),
    [sym_comment] = ACTIONS(87),
  },
  [3535] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9395),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9397),
    [anon_sym_DASH_EQ] = ACTIONS(9397),
    [anon_sym_STAR_EQ] = ACTIONS(9397),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9397),
    [anon_sym_SLASH_EQ] = ACTIONS(9397),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9397),
    [anon_sym_PIPE_EQ] = ACTIONS(9397),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9397),
    [anon_sym_AMP_EQ] = ACTIONS(9397),
    [anon_sym_PERCENT_EQ] = ACTIONS(9397),
    [anon_sym_GT_GT_EQ] = ACTIONS(9397),
    [anon_sym_LT_LT_EQ] = ACTIONS(9397),
    [anon_sym_CARET_EQ] = ACTIONS(9397),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3536] = {
    [sym_string] = STATE(6183),
    [aux_sym_chained_string_repeat1] = STATE(6183),
    [sym__string_start] = ACTIONS(9355),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9399),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3537] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6192),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_splat_argument] = STATE(6193),
    [sym_assignment] = STATE(6192),
    [sym_operator_assignment] = STATE(6192),
    [sym_conditional] = STATE(6192),
    [sym_range] = STATE(6192),
    [sym_binary] = STATE(6192),
    [sym_unary] = STATE(6192),
    [sym_right_assignment_list] = STATE(2017),
    [sym__arg_or_splat_arg] = STATE(6193),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(9401),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3538] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6197),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6197),
    [sym_operator_assignment] = STATE(6197),
    [sym_conditional] = STATE(6197),
    [sym_range] = STATE(6197),
    [sym_binary] = STATE(6197),
    [sym_unary] = STATE(6197),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3539] = {
    [sym_string] = STATE(6198),
    [aux_sym_chained_string_repeat1] = STATE(6198),
    [sym__string_start] = ACTIONS(2503),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_COLON2] = ACTIONS(2761),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [3540] = {
    [sym__heredoc_body_start] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(4854),
    [anon_sym_STAR_STAR] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_LT] = ACTIONS(4854),
    [anon_sym_LPAREN2] = ACTIONS(3102),
    [anon_sym_DOT_DOT] = ACTIONS(3102),
    [anon_sym_LT_LT] = ACTIONS(3102),
    [anon_sym_GT_GT] = ACTIONS(3102),
    [anon_sym_EQ_EQ] = ACTIONS(4854),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
    [anon_sym_LT_EQ_GT] = ACTIONS(3102),
    [anon_sym_EQ_TILDE] = ACTIONS(3102),
    [anon_sym_BANG_TILDE] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(4854),
    [anon_sym_GT] = ACTIONS(4854),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(4854),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_PERCENT] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(4854),
    [anon_sym_TILDE] = ACTIONS(3102),
    [sym_constant] = ACTIONS(3102),
    [sym_identifier] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(4854),
    [anon_sym_PLUS_AT] = ACTIONS(3102),
    [anon_sym_DASH_AT] = ACTIONS(3102),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4854),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3102),
    [anon_sym_BQUOTE] = ACTIONS(3102),
    [sym_comment] = ACTIONS(87),
  },
  [3541] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(9421),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [3542] = {
    [sym__line_break] = ACTIONS(4148),
    [sym__simple_symbol] = ACTIONS(4148),
    [sym__string_start] = ACTIONS(4148),
    [sym__symbol_start] = ACTIONS(4148),
    [sym__subshell_start] = ACTIONS(4148),
    [sym__regex_start] = ACTIONS(4148),
    [sym__string_array_start] = ACTIONS(4148),
    [sym__symbol_array_start] = ACTIONS(4148),
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym_heredoc_beginning] = ACTIONS(4148),
    [sym__block_ampersand] = ACTIONS(4148),
    [sym__splat_star] = ACTIONS(4148),
    [sym__unary_minus] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [sym__identifier_hash_key] = ACTIONS(4148),
    [ts_builtin_sym_end] = ACTIONS(4148),
    [anon_sym___END__] = ACTIONS(4150),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_def] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(4150),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COLON_COLON] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_STAR_STAR] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_class] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_module] = ACTIONS(4150),
    [anon_sym_end] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_yield] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_next] = ACTIONS(4150),
    [sym_redo] = ACTIONS(4150),
    [sym_retry] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_unless] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [anon_sym_until] = ACTIONS(4150),
    [anon_sym_rescue] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_do] = ACTIONS(4150),
    [anon_sym_case] = ACTIONS(4150),
    [anon_sym_when] = ACTIONS(4150),
    [anon_sym_elsif] = ACTIONS(4150),
    [anon_sym_else] = ACTIONS(4150),
    [anon_sym_then] = ACTIONS(4150),
    [anon_sym_begin] = ACTIONS(4150),
    [anon_sym_ensure] = ACTIONS(4150),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4150),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_defined_QMARK] = ACTIONS(4148),
    [anon_sym_not] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_TILDE] = ACTIONS(4148),
    [sym_constant] = ACTIONS(4150),
    [sym_identifier] = ACTIONS(4150),
    [sym_instance_variable] = ACTIONS(4148),
    [sym_class_variable] = ACTIONS(4148),
    [sym_global_variable] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4150),
    [sym_float] = ACTIONS(4150),
    [sym_complex] = ACTIONS(4148),
    [sym_super] = ACTIONS(4150),
    [anon_sym_true] = ACTIONS(4150),
    [anon_sym_TRUE] = ACTIONS(4150),
    [anon_sym_false] = ACTIONS(4150),
    [anon_sym_FALSE] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [anon_sym_nil] = ACTIONS(4150),
    [anon_sym_NIL] = ACTIONS(4150),
    [sym_character] = ACTIONS(4148),
    [anon_sym_LBRACK2] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4148),
  },
  [3543] = {
    [sym_heredoc_body] = STATE(6201),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(9423),
    [sym_comment] = ACTIONS(87),
  },
  [3544] = {
    [anon_sym_RPAREN] = ACTIONS(9423),
    [sym_comment] = ACTIONS(87),
  },
  [3545] = {
    [sym__line_break] = ACTIONS(9425),
    [sym__simple_symbol] = ACTIONS(9425),
    [sym__string_start] = ACTIONS(9425),
    [sym__symbol_start] = ACTIONS(9425),
    [sym__subshell_start] = ACTIONS(9425),
    [sym__regex_start] = ACTIONS(9425),
    [sym__string_array_start] = ACTIONS(9425),
    [sym__symbol_array_start] = ACTIONS(9425),
    [sym__heredoc_body_start] = ACTIONS(9425),
    [sym_heredoc_beginning] = ACTIONS(9425),
    [sym__block_ampersand] = ACTIONS(9425),
    [sym__splat_star] = ACTIONS(9425),
    [sym__unary_minus] = ACTIONS(9425),
    [sym__binary_minus] = ACTIONS(9425),
    [sym__binary_star] = ACTIONS(9425),
    [sym__identifier_hash_key] = ACTIONS(9425),
    [ts_builtin_sym_end] = ACTIONS(9425),
    [anon_sym___END__] = ACTIONS(9427),
    [anon_sym_LBRACE] = ACTIONS(9425),
    [anon_sym_RBRACE] = ACTIONS(9425),
    [anon_sym_def] = ACTIONS(9427),
    [anon_sym_LPAREN] = ACTIONS(9427),
    [anon_sym_RPAREN] = ACTIONS(9425),
    [anon_sym_DOT] = ACTIONS(9427),
    [anon_sym_COLON_COLON] = ACTIONS(9427),
    [anon_sym_COMMA] = ACTIONS(9425),
    [anon_sym_PIPE] = ACTIONS(9427),
    [anon_sym_SEMI] = ACTIONS(9425),
    [anon_sym_STAR] = ACTIONS(9427),
    [anon_sym_STAR_STAR] = ACTIONS(9427),
    [anon_sym_AMP] = ACTIONS(9427),
    [anon_sym_EQ] = ACTIONS(9427),
    [anon_sym_class] = ACTIONS(9427),
    [anon_sym_LT] = ACTIONS(9427),
    [anon_sym_module] = ACTIONS(9427),
    [anon_sym_end] = ACTIONS(9427),
    [anon_sym_return] = ACTIONS(9427),
    [anon_sym_yield] = ACTIONS(9427),
    [anon_sym_break] = ACTIONS(9427),
    [anon_sym_next] = ACTIONS(9427),
    [sym_redo] = ACTIONS(9427),
    [sym_retry] = ACTIONS(9427),
    [anon_sym_if] = ACTIONS(9427),
    [anon_sym_unless] = ACTIONS(9427),
    [anon_sym_while] = ACTIONS(9427),
    [anon_sym_until] = ACTIONS(9427),
    [anon_sym_rescue] = ACTIONS(9427),
    [anon_sym_for] = ACTIONS(9427),
    [anon_sym_do] = ACTIONS(9427),
    [anon_sym_case] = ACTIONS(9427),
    [anon_sym_when] = ACTIONS(9427),
    [anon_sym_elsif] = ACTIONS(9427),
    [anon_sym_else] = ACTIONS(9427),
    [anon_sym_then] = ACTIONS(9427),
    [anon_sym_begin] = ACTIONS(9427),
    [anon_sym_ensure] = ACTIONS(9427),
    [anon_sym_LBRACK] = ACTIONS(9425),
    [anon_sym_COLON_COLON2] = ACTIONS(9425),
    [anon_sym_AMP_DOT] = ACTIONS(9425),
    [anon_sym_LPAREN2] = ACTIONS(9425),
    [anon_sym_PLUS_EQ] = ACTIONS(9425),
    [anon_sym_DASH_EQ] = ACTIONS(9425),
    [anon_sym_STAR_EQ] = ACTIONS(9425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9425),
    [anon_sym_SLASH_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9425),
    [anon_sym_AMP_EQ] = ACTIONS(9425),
    [anon_sym_PERCENT_EQ] = ACTIONS(9425),
    [anon_sym_GT_GT_EQ] = ACTIONS(9425),
    [anon_sym_LT_LT_EQ] = ACTIONS(9425),
    [anon_sym_CARET_EQ] = ACTIONS(9425),
    [anon_sym_QMARK] = ACTIONS(9427),
    [anon_sym_DOT_DOT] = ACTIONS(9427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9425),
    [anon_sym_and] = ACTIONS(9427),
    [anon_sym_or] = ACTIONS(9427),
    [anon_sym_PIPE_PIPE] = ACTIONS(9427),
    [anon_sym_AMP_AMP] = ACTIONS(9427),
    [anon_sym_LT_LT] = ACTIONS(9427),
    [anon_sym_GT_GT] = ACTIONS(9427),
    [anon_sym_EQ_EQ] = ACTIONS(9427),
    [anon_sym_BANG_EQ] = ACTIONS(9425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9425),
    [anon_sym_LT_EQ_GT] = ACTIONS(9425),
    [anon_sym_EQ_TILDE] = ACTIONS(9425),
    [anon_sym_BANG_TILDE] = ACTIONS(9425),
    [anon_sym_LT_EQ] = ACTIONS(9427),
    [anon_sym_GT] = ACTIONS(9427),
    [anon_sym_GT_EQ] = ACTIONS(9425),
    [anon_sym_CARET] = ACTIONS(9427),
    [anon_sym_PLUS] = ACTIONS(9427),
    [anon_sym_SLASH] = ACTIONS(9427),
    [anon_sym_PERCENT] = ACTIONS(9427),
    [anon_sym_defined_QMARK] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [anon_sym_BANG] = ACTIONS(9427),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_constant] = ACTIONS(9427),
    [sym_identifier] = ACTIONS(9427),
    [sym_instance_variable] = ACTIONS(9425),
    [sym_class_variable] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(9425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9427),
    [sym_float] = ACTIONS(9427),
    [sym_complex] = ACTIONS(9425),
    [sym_super] = ACTIONS(9427),
    [anon_sym_true] = ACTIONS(9427),
    [anon_sym_TRUE] = ACTIONS(9427),
    [anon_sym_false] = ACTIONS(9427),
    [anon_sym_FALSE] = ACTIONS(9427),
    [sym_self] = ACTIONS(9427),
    [anon_sym_nil] = ACTIONS(9427),
    [anon_sym_NIL] = ACTIONS(9427),
    [sym_character] = ACTIONS(9425),
    [anon_sym_LBRACK2] = ACTIONS(9427),
    [anon_sym_DASH_GT] = ACTIONS(9425),
  },
  [3546] = {
    [sym_heredoc_body] = STATE(3546),
    [aux_sym_call_repeat1] = STATE(3546),
    [sym__heredoc_body_start] = ACTIONS(9429),
    [anon_sym_PIPE] = ACTIONS(7646),
    [anon_sym_STAR] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7646),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LPAREN2] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [anon_sym_BANG] = ACTIONS(7651),
    [anon_sym_TILDE] = ACTIONS(7646),
    [sym_constant] = ACTIONS(7646),
    [sym_identifier] = ACTIONS(7646),
    [anon_sym_DASH] = ACTIONS(7651),
    [anon_sym_PLUS_AT] = ACTIONS(7646),
    [anon_sym_DASH_AT] = ACTIONS(7646),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7651),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(7646),
    [anon_sym_BQUOTE] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [3547] = {
    [sym__line_break] = ACTIONS(9432),
    [sym__heredoc_body_start] = ACTIONS(9432),
    [sym__binary_minus] = ACTIONS(9432),
    [sym__binary_star] = ACTIONS(9432),
    [ts_builtin_sym_end] = ACTIONS(9432),
    [anon_sym___END__] = ACTIONS(9432),
    [anon_sym_LBRACE] = ACTIONS(9432),
    [anon_sym_RBRACE] = ACTIONS(9432),
    [anon_sym_RPAREN] = ACTIONS(9432),
    [anon_sym_DOT] = ACTIONS(9434),
    [anon_sym_COMMA] = ACTIONS(9432),
    [anon_sym_PIPE] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(9432),
    [anon_sym_STAR_STAR] = ACTIONS(9434),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_EQ] = ACTIONS(9434),
    [anon_sym_LT] = ACTIONS(9434),
    [anon_sym_end] = ACTIONS(9432),
    [anon_sym_if] = ACTIONS(9432),
    [anon_sym_unless] = ACTIONS(9432),
    [anon_sym_while] = ACTIONS(9432),
    [anon_sym_until] = ACTIONS(9432),
    [anon_sym_rescue] = ACTIONS(9432),
    [anon_sym_do] = ACTIONS(9432),
    [anon_sym_when] = ACTIONS(9432),
    [anon_sym_elsif] = ACTIONS(9432),
    [anon_sym_else] = ACTIONS(9432),
    [anon_sym_then] = ACTIONS(9432),
    [anon_sym_ensure] = ACTIONS(9432),
    [anon_sym_LBRACK] = ACTIONS(9432),
    [anon_sym_COLON_COLON2] = ACTIONS(9432),
    [anon_sym_AMP_DOT] = ACTIONS(9432),
    [anon_sym_PLUS_EQ] = ACTIONS(9432),
    [anon_sym_DASH_EQ] = ACTIONS(9432),
    [anon_sym_STAR_EQ] = ACTIONS(9432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9432),
    [anon_sym_SLASH_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9432),
    [anon_sym_AMP_EQ] = ACTIONS(9432),
    [anon_sym_PERCENT_EQ] = ACTIONS(9432),
    [anon_sym_GT_GT_EQ] = ACTIONS(9432),
    [anon_sym_LT_LT_EQ] = ACTIONS(9432),
    [anon_sym_CARET_EQ] = ACTIONS(9432),
    [anon_sym_QMARK] = ACTIONS(9432),
    [anon_sym_DOT_DOT] = ACTIONS(9434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9432),
    [anon_sym_and] = ACTIONS(9432),
    [anon_sym_or] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE] = ACTIONS(9434),
    [anon_sym_AMP_AMP] = ACTIONS(9434),
    [anon_sym_LT_LT] = ACTIONS(9434),
    [anon_sym_GT_GT] = ACTIONS(9434),
    [anon_sym_EQ_EQ] = ACTIONS(9434),
    [anon_sym_BANG_EQ] = ACTIONS(9432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9432),
    [anon_sym_LT_EQ_GT] = ACTIONS(9432),
    [anon_sym_EQ_TILDE] = ACTIONS(9432),
    [anon_sym_BANG_TILDE] = ACTIONS(9432),
    [anon_sym_LT_EQ] = ACTIONS(9434),
    [anon_sym_GT] = ACTIONS(9434),
    [anon_sym_GT_EQ] = ACTIONS(9432),
    [anon_sym_CARET] = ACTIONS(9434),
    [anon_sym_PLUS] = ACTIONS(9434),
    [anon_sym_SLASH] = ACTIONS(9434),
    [anon_sym_PERCENT] = ACTIONS(9434),
    [sym_comment] = ACTIONS(87),
  },
  [3548] = {
    [anon_sym_RBRACK] = ACTIONS(9436),
    [sym_comment] = ACTIONS(87),
  },
  [3549] = {
    [sym__line_break] = ACTIONS(2895),
    [sym__string_start] = ACTIONS(2895),
    [sym__heredoc_body_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [ts_builtin_sym_end] = ACTIONS(2895),
    [anon_sym___END__] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_end] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_unless] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_until] = ACTIONS(2895),
    [anon_sym_rescue] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_when] = ACTIONS(2895),
    [anon_sym_elsif] = ACTIONS(2895),
    [anon_sym_else] = ACTIONS(2895),
    [anon_sym_then] = ACTIONS(2895),
    [anon_sym_ensure] = ACTIONS(2895),
    [anon_sym_EQ_GT] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2895),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [sym_comment] = ACTIONS(87),
  },
  [3550] = {
    [sym__line_break] = ACTIONS(2907),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [sym__binary_minus] = ACTIONS(2907),
    [sym__binary_star] = ACTIONS(2907),
    [ts_builtin_sym_end] = ACTIONS(2907),
    [anon_sym___END__] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_STAR_STAR] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_end] = ACTIONS(2907),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_unless] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_until] = ACTIONS(2907),
    [anon_sym_rescue] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_when] = ACTIONS(2907),
    [anon_sym_elsif] = ACTIONS(2907),
    [anon_sym_else] = ACTIONS(2907),
    [anon_sym_then] = ACTIONS(2907),
    [anon_sym_ensure] = ACTIONS(2907),
    [anon_sym_EQ_GT] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_COLON_COLON2] = ACTIONS(2907),
    [anon_sym_AMP_DOT] = ACTIONS(2907),
    [anon_sym_PLUS_EQ] = ACTIONS(2907),
    [anon_sym_DASH_EQ] = ACTIONS(2907),
    [anon_sym_STAR_EQ] = ACTIONS(2907),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2907),
    [anon_sym_SLASH_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2907),
    [anon_sym_AMP_EQ] = ACTIONS(2907),
    [anon_sym_PERCENT_EQ] = ACTIONS(2907),
    [anon_sym_GT_GT_EQ] = ACTIONS(2907),
    [anon_sym_LT_LT_EQ] = ACTIONS(2907),
    [anon_sym_CARET_EQ] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_and] = ACTIONS(2907),
    [anon_sym_or] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_LT_LT] = ACTIONS(2909),
    [anon_sym_GT_GT] = ACTIONS(2909),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_CARET] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_PERCENT] = ACTIONS(2909),
    [sym_comment] = ACTIONS(87),
  },
  [3551] = {
    [sym__line_break] = ACTIONS(2911),
    [sym__heredoc_body_start] = ACTIONS(2911),
    [sym__binary_minus] = ACTIONS(2911),
    [sym__binary_star] = ACTIONS(2911),
    [ts_builtin_sym_end] = ACTIONS(2911),
    [anon_sym___END__] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_RPAREN] = ACTIONS(2911),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_end] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_unless] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_until] = ACTIONS(2911),
    [anon_sym_rescue] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_when] = ACTIONS(2911),
    [anon_sym_elsif] = ACTIONS(2911),
    [anon_sym_else] = ACTIONS(2911),
    [anon_sym_then] = ACTIONS(2911),
    [anon_sym_ensure] = ACTIONS(2911),
    [anon_sym_EQ_GT] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_COLON_COLON2] = ACTIONS(2911),
    [anon_sym_AMP_DOT] = ACTIONS(2911),
    [anon_sym_PLUS_EQ] = ACTIONS(2911),
    [anon_sym_DASH_EQ] = ACTIONS(2911),
    [anon_sym_STAR_EQ] = ACTIONS(2911),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2911),
    [anon_sym_SLASH_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2911),
    [anon_sym_AMP_EQ] = ACTIONS(2911),
    [anon_sym_PERCENT_EQ] = ACTIONS(2911),
    [anon_sym_GT_GT_EQ] = ACTIONS(2911),
    [anon_sym_LT_LT_EQ] = ACTIONS(2911),
    [anon_sym_CARET_EQ] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_CARET] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(87),
  },
  [3552] = {
    [sym__line_break] = ACTIONS(2915),
    [sym__heredoc_body_start] = ACTIONS(2915),
    [sym__binary_minus] = ACTIONS(2915),
    [sym__binary_star] = ACTIONS(2915),
    [ts_builtin_sym_end] = ACTIONS(2915),
    [anon_sym___END__] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_STAR_STAR] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_end] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_unless] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_until] = ACTIONS(2915),
    [anon_sym_rescue] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_when] = ACTIONS(2915),
    [anon_sym_elsif] = ACTIONS(2915),
    [anon_sym_else] = ACTIONS(2915),
    [anon_sym_then] = ACTIONS(2915),
    [anon_sym_ensure] = ACTIONS(2915),
    [anon_sym_EQ_GT] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_COLON_COLON2] = ACTIONS(2915),
    [anon_sym_AMP_DOT] = ACTIONS(2915),
    [anon_sym_PLUS_EQ] = ACTIONS(2915),
    [anon_sym_DASH_EQ] = ACTIONS(2915),
    [anon_sym_STAR_EQ] = ACTIONS(2915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2915),
    [anon_sym_SLASH_EQ] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2915),
    [anon_sym_PIPE_EQ] = ACTIONS(2915),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2915),
    [anon_sym_AMP_EQ] = ACTIONS(2915),
    [anon_sym_PERCENT_EQ] = ACTIONS(2915),
    [anon_sym_GT_GT_EQ] = ACTIONS(2915),
    [anon_sym_LT_LT_EQ] = ACTIONS(2915),
    [anon_sym_CARET_EQ] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_LT_LT] = ACTIONS(2917),
    [anon_sym_GT_GT] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2915),
    [anon_sym_EQ_TILDE] = ACTIONS(2915),
    [anon_sym_BANG_TILDE] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2917),
    [sym_comment] = ACTIONS(87),
  },
  [3553] = {
    [sym__line_break] = ACTIONS(2921),
    [sym__heredoc_body_start] = ACTIONS(2921),
    [sym__binary_minus] = ACTIONS(2921),
    [sym__binary_star] = ACTIONS(2921),
    [ts_builtin_sym_end] = ACTIONS(2921),
    [anon_sym___END__] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_end] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_unless] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_until] = ACTIONS(2921),
    [anon_sym_rescue] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_elsif] = ACTIONS(2921),
    [anon_sym_else] = ACTIONS(2921),
    [anon_sym_then] = ACTIONS(2921),
    [anon_sym_ensure] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_COLON_COLON2] = ACTIONS(2921),
    [anon_sym_AMP_DOT] = ACTIONS(2921),
    [anon_sym_PLUS_EQ] = ACTIONS(2921),
    [anon_sym_DASH_EQ] = ACTIONS(2921),
    [anon_sym_STAR_EQ] = ACTIONS(2921),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2921),
    [anon_sym_AMP_EQ] = ACTIONS(2921),
    [anon_sym_PERCENT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_LT_LT_EQ] = ACTIONS(2921),
    [anon_sym_CARET_EQ] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_and] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [sym_comment] = ACTIONS(87),
  },
  [3554] = {
    [sym__string_end] = ACTIONS(9438),
    [sym_comment] = ACTIONS(87),
  },
  [3555] = {
    [aux_sym_string_array_repeat1] = STATE(6206),
    [sym__string_end] = ACTIONS(9440),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9442),
  },
  [3556] = {
    [sym__line_break] = ACTIONS(2931),
    [sym__heredoc_body_start] = ACTIONS(2931),
    [sym__binary_minus] = ACTIONS(2931),
    [sym__binary_star] = ACTIONS(2931),
    [ts_builtin_sym_end] = ACTIONS(2931),
    [anon_sym___END__] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_STAR_STAR] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_end] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_unless] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_until] = ACTIONS(2931),
    [anon_sym_rescue] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_when] = ACTIONS(2931),
    [anon_sym_elsif] = ACTIONS(2931),
    [anon_sym_else] = ACTIONS(2931),
    [anon_sym_then] = ACTIONS(2931),
    [anon_sym_ensure] = ACTIONS(2931),
    [anon_sym_EQ_GT] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_COLON_COLON2] = ACTIONS(2931),
    [anon_sym_AMP_DOT] = ACTIONS(2931),
    [anon_sym_PLUS_EQ] = ACTIONS(2931),
    [anon_sym_DASH_EQ] = ACTIONS(2931),
    [anon_sym_STAR_EQ] = ACTIONS(2931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2931),
    [anon_sym_SLASH_EQ] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2931),
    [anon_sym_PIPE_EQ] = ACTIONS(2931),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2931),
    [anon_sym_AMP_EQ] = ACTIONS(2931),
    [anon_sym_PERCENT_EQ] = ACTIONS(2931),
    [anon_sym_GT_GT_EQ] = ACTIONS(2931),
    [anon_sym_LT_LT_EQ] = ACTIONS(2931),
    [anon_sym_CARET_EQ] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2931),
    [anon_sym_DOT_DOT] = ACTIONS(2933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2931),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_EQ_EQ] = ACTIONS(2933),
    [anon_sym_BANG_EQ] = ACTIONS(2931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2931),
    [anon_sym_EQ_TILDE] = ACTIONS(2931),
    [anon_sym_BANG_TILDE] = ACTIONS(2931),
    [anon_sym_LT_EQ] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_GT_EQ] = ACTIONS(2931),
    [anon_sym_CARET] = ACTIONS(2933),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(87),
  },
  [3557] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9444),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3558] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(9444),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9446),
  },
  [3559] = {
    [sym__line_break] = ACTIONS(2950),
    [sym__heredoc_body_start] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym__binary_star] = ACTIONS(2950),
    [ts_builtin_sym_end] = ACTIONS(2950),
    [anon_sym___END__] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_STAR_STAR] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_end] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_unless] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_until] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_when] = ACTIONS(2950),
    [anon_sym_elsif] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_then] = ACTIONS(2950),
    [anon_sym_ensure] = ACTIONS(2950),
    [anon_sym_EQ_GT] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_COLON_COLON2] = ACTIONS(2950),
    [anon_sym_AMP_DOT] = ACTIONS(2950),
    [anon_sym_PLUS_EQ] = ACTIONS(2950),
    [anon_sym_DASH_EQ] = ACTIONS(2950),
    [anon_sym_STAR_EQ] = ACTIONS(2950),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2950),
    [anon_sym_SLASH_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2950),
    [anon_sym_AMP_EQ] = ACTIONS(2950),
    [anon_sym_PERCENT_EQ] = ACTIONS(2950),
    [anon_sym_GT_GT_EQ] = ACTIONS(2950),
    [anon_sym_LT_LT_EQ] = ACTIONS(2950),
    [anon_sym_CARET_EQ] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_LT_LT] = ACTIONS(2952),
    [anon_sym_GT_GT] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ_GT] = ACTIONS(2950),
    [anon_sym_EQ_TILDE] = ACTIONS(2950),
    [anon_sym_BANG_TILDE] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_PERCENT] = ACTIONS(2952),
    [sym_comment] = ACTIONS(87),
  },
  [3560] = {
    [sym__string_end] = ACTIONS(9448),
    [sym_comment] = ACTIONS(87),
  },
  [3561] = {
    [aux_sym_symbol_array_repeat1] = STATE(6212),
    [sym__string_end] = ACTIONS(9450),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9452),
  },
  [3562] = {
    [sym__line_break] = ACTIONS(2960),
    [sym__heredoc_body_start] = ACTIONS(2960),
    [sym__binary_minus] = ACTIONS(2960),
    [sym__binary_star] = ACTIONS(2960),
    [ts_builtin_sym_end] = ACTIONS(2960),
    [anon_sym___END__] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_RPAREN] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_STAR_STAR] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_end] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_unless] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_until] = ACTIONS(2960),
    [anon_sym_rescue] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_when] = ACTIONS(2960),
    [anon_sym_elsif] = ACTIONS(2960),
    [anon_sym_else] = ACTIONS(2960),
    [anon_sym_then] = ACTIONS(2960),
    [anon_sym_ensure] = ACTIONS(2960),
    [anon_sym_EQ_GT] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_COLON_COLON2] = ACTIONS(2960),
    [anon_sym_AMP_DOT] = ACTIONS(2960),
    [anon_sym_PLUS_EQ] = ACTIONS(2960),
    [anon_sym_DASH_EQ] = ACTIONS(2960),
    [anon_sym_STAR_EQ] = ACTIONS(2960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2960),
    [anon_sym_SLASH_EQ] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2960),
    [anon_sym_PIPE_EQ] = ACTIONS(2960),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2960),
    [anon_sym_AMP_EQ] = ACTIONS(2960),
    [anon_sym_PERCENT_EQ] = ACTIONS(2960),
    [anon_sym_GT_GT_EQ] = ACTIONS(2960),
    [anon_sym_LT_LT_EQ] = ACTIONS(2960),
    [anon_sym_CARET_EQ] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2960),
    [anon_sym_DOT_DOT] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_LT_LT] = ACTIONS(2962),
    [anon_sym_GT_GT] = ACTIONS(2962),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2960),
    [anon_sym_LT_EQ_GT] = ACTIONS(2960),
    [anon_sym_EQ_TILDE] = ACTIONS(2960),
    [anon_sym_BANG_TILDE] = ACTIONS(2960),
    [anon_sym_LT_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [sym_comment] = ACTIONS(87),
  },
  [3563] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9454),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3564] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(9454),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9456),
  },
  [3565] = {
    [sym__line_break] = ACTIONS(837),
    [sym__string_start] = ACTIONS(837),
    [sym__heredoc_body_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [ts_builtin_sym_end] = ACTIONS(837),
    [anon_sym___END__] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_end] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_unless] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_until] = ACTIONS(837),
    [anon_sym_rescue] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_when] = ACTIONS(837),
    [anon_sym_elsif] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(837),
    [anon_sym_then] = ACTIONS(837),
    [anon_sym_ensure] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [sym_comment] = ACTIONS(87),
  },
  [3566] = {
    [sym__string_end] = ACTIONS(9458),
    [sym_comment] = ACTIONS(87),
  },
  [3567] = {
    [sym__line_break] = ACTIONS(887),
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [ts_builtin_sym_end] = ACTIONS(887),
    [anon_sym___END__] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_end] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_when] = ACTIONS(887),
    [anon_sym_elsif] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_then] = ACTIONS(887),
    [anon_sym_ensure] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_PLUS_EQ] = ACTIONS(887),
    [anon_sym_DASH_EQ] = ACTIONS(887),
    [anon_sym_STAR_EQ] = ACTIONS(887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(887),
    [anon_sym_SLASH_EQ] = ACTIONS(887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(887),
    [anon_sym_PIPE_EQ] = ACTIONS(887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(887),
    [anon_sym_AMP_EQ] = ACTIONS(887),
    [anon_sym_PERCENT_EQ] = ACTIONS(887),
    [anon_sym_GT_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_LT_EQ] = ACTIONS(887),
    [anon_sym_CARET_EQ] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(889),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [sym_comment] = ACTIONS(87),
  },
  [3568] = {
    [sym__string_end] = ACTIONS(9460),
    [sym_comment] = ACTIONS(87),
  },
  [3569] = {
    [sym__line_break] = ACTIONS(893),
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [ts_builtin_sym_end] = ACTIONS(893),
    [anon_sym___END__] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_end] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_when] = ACTIONS(893),
    [anon_sym_elsif] = ACTIONS(893),
    [anon_sym_else] = ACTIONS(893),
    [anon_sym_then] = ACTIONS(893),
    [anon_sym_ensure] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [anon_sym_DASH_EQ] = ACTIONS(893),
    [anon_sym_STAR_EQ] = ACTIONS(893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(893),
    [anon_sym_SLASH_EQ] = ACTIONS(893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(893),
    [anon_sym_PIPE_EQ] = ACTIONS(893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(893),
    [anon_sym_AMP_EQ] = ACTIONS(893),
    [anon_sym_PERCENT_EQ] = ACTIONS(893),
    [anon_sym_GT_GT_EQ] = ACTIONS(893),
    [anon_sym_LT_LT_EQ] = ACTIONS(893),
    [anon_sym_CARET_EQ] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(895),
    [anon_sym_PERCENT] = ACTIONS(895),
    [sym_comment] = ACTIONS(87),
  },
  [3570] = {
    [sym__string_end] = ACTIONS(9462),
    [sym_comment] = ACTIONS(87),
  },
  [3571] = {
    [sym__line_break] = ACTIONS(899),
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [ts_builtin_sym_end] = ACTIONS(899),
    [anon_sym___END__] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(901),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_end] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_when] = ACTIONS(899),
    [anon_sym_elsif] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_then] = ACTIONS(899),
    [anon_sym_ensure] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_PLUS_EQ] = ACTIONS(899),
    [anon_sym_DASH_EQ] = ACTIONS(899),
    [anon_sym_STAR_EQ] = ACTIONS(899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(899),
    [anon_sym_SLASH_EQ] = ACTIONS(899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(899),
    [anon_sym_PIPE_EQ] = ACTIONS(899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(899),
    [anon_sym_AMP_EQ] = ACTIONS(899),
    [anon_sym_PERCENT_EQ] = ACTIONS(899),
    [anon_sym_GT_GT_EQ] = ACTIONS(899),
    [anon_sym_LT_LT_EQ] = ACTIONS(899),
    [anon_sym_CARET_EQ] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [sym_comment] = ACTIONS(87),
  },
  [3572] = {
    [sym__string_end] = ACTIONS(9464),
    [sym_comment] = ACTIONS(87),
  },
  [3573] = {
    [sym__line_break] = ACTIONS(905),
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [ts_builtin_sym_end] = ACTIONS(905),
    [anon_sym___END__] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_end] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(905),
    [anon_sym_elsif] = ACTIONS(905),
    [anon_sym_else] = ACTIONS(905),
    [anon_sym_then] = ACTIONS(905),
    [anon_sym_ensure] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [sym_comment] = ACTIONS(87),
  },
  [3574] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(6221),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9466),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9468),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [3575] = {
    [aux_sym_string_array_repeat1] = STATE(6224),
    [sym__string_end] = ACTIONS(9470),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9472),
  },
  [3576] = {
    [sym__line_break] = ACTIONS(923),
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [ts_builtin_sym_end] = ACTIONS(923),
    [anon_sym___END__] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_when] = ACTIONS(923),
    [anon_sym_elsif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_then] = ACTIONS(923),
    [anon_sym_ensure] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [sym_comment] = ACTIONS(87),
  },
  [3577] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(6227),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9474),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9476),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [3578] = {
    [aux_sym_symbol_array_repeat1] = STATE(6230),
    [sym__string_end] = ACTIONS(9478),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9480),
  },
  [3579] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3580] = {
    [sym__line_break] = ACTIONS(993),
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [ts_builtin_sym_end] = ACTIONS(993),
    [anon_sym___END__] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_end] = ACTIONS(993),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_when] = ACTIONS(993),
    [anon_sym_elsif] = ACTIONS(993),
    [anon_sym_else] = ACTIONS(993),
    [anon_sym_then] = ACTIONS(993),
    [anon_sym_ensure] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_PLUS_EQ] = ACTIONS(993),
    [anon_sym_DASH_EQ] = ACTIONS(993),
    [anon_sym_STAR_EQ] = ACTIONS(993),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(993),
    [anon_sym_SLASH_EQ] = ACTIONS(993),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(993),
    [anon_sym_PIPE_EQ] = ACTIONS(993),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(993),
    [anon_sym_AMP_EQ] = ACTIONS(993),
    [anon_sym_PERCENT_EQ] = ACTIONS(993),
    [anon_sym_GT_GT_EQ] = ACTIONS(993),
    [anon_sym_LT_LT_EQ] = ACTIONS(993),
    [anon_sym_CARET_EQ] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [sym_comment] = ACTIONS(87),
  },
  [3581] = {
    [anon_sym_RBRACE] = ACTIONS(9482),
    [sym_comment] = ACTIONS(87),
  },
  [3582] = {
    [sym_heredoc_body] = STATE(6232),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(9482),
    [sym_comment] = ACTIONS(87),
  },
  [3583] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6233),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(6233),
    [sym_operator_assignment] = STATE(6233),
    [sym_conditional] = STATE(6233),
    [sym_range] = STATE(6233),
    [sym_binary] = STATE(6233),
    [sym_unary] = STATE(6233),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3584] = {
    [sym__line_break] = ACTIONS(1273),
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym___END__] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_end] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_when] = ACTIONS(1273),
    [anon_sym_elsif] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_then] = ACTIONS(1273),
    [anon_sym_ensure] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [sym_comment] = ACTIONS(87),
  },
  [3585] = {
    [anon_sym_DOT] = ACTIONS(9484),
    [anon_sym_COLON_COLON] = ACTIONS(9484),
    [sym_comment] = ACTIONS(87),
  },
  [3586] = {
    [sym_method_parameters] = STATE(6235),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(6235),
    [sym__terminator] = STATE(6235),
    [sym__line_break] = ACTIONS(9486),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [3587] = {
    [sym__line_break] = ACTIONS(1291),
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [ts_builtin_sym_end] = ACTIONS(1291),
    [anon_sym___END__] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_end] = ACTIONS(1291),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_when] = ACTIONS(1291),
    [anon_sym_elsif] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_then] = ACTIONS(1291),
    [anon_sym_ensure] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_PLUS_EQ] = ACTIONS(1291),
    [anon_sym_DASH_EQ] = ACTIONS(1291),
    [anon_sym_STAR_EQ] = ACTIONS(1291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1291),
    [anon_sym_SLASH_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1291),
    [anon_sym_AMP_EQ] = ACTIONS(1291),
    [anon_sym_PERCENT_EQ] = ACTIONS(1291),
    [anon_sym_GT_GT_EQ] = ACTIONS(1291),
    [anon_sym_LT_LT_EQ] = ACTIONS(1291),
    [anon_sym_CARET_EQ] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [sym_comment] = ACTIONS(87),
  },
  [3588] = {
    [anon_sym_RPAREN] = ACTIONS(9488),
    [sym_comment] = ACTIONS(87),
  },
  [3589] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6237),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(6237),
    [sym_operator_assignment] = STATE(6237),
    [sym_conditional] = STATE(6237),
    [sym_range] = STATE(6237),
    [sym_binary] = STATE(6237),
    [sym_unary] = STATE(6237),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3590] = {
    [sym_superclass] = STATE(6238),
    [sym_heredoc_body] = STATE(6239),
    [sym__terminator] = STATE(6239),
    [sym__line_break] = ACTIONS(9490),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(9490),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3591] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_superclass] = STATE(6238),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(6239),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(6239),
    [sym__line_break] = ACTIONS(9490),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(9490),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3592] = {
    [sym_heredoc_body] = STATE(6241),
    [sym__terminator] = STATE(6241),
    [sym__line_break] = ACTIONS(9492),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(9492),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(9494),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3593] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(6241),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(6241),
    [sym__line_break] = ACTIONS(9492),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(9492),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(9494),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3594] = {
    [sym__line_break] = ACTIONS(1679),
    [sym__heredoc_body_start] = ACTIONS(1679),
    [sym__binary_minus] = ACTIONS(1679),
    [sym__binary_star] = ACTIONS(1679),
    [ts_builtin_sym_end] = ACTIONS(1679),
    [anon_sym___END__] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_end] = ACTIONS(1679),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_unless] = ACTIONS(1679),
    [anon_sym_while] = ACTIONS(1679),
    [anon_sym_until] = ACTIONS(1679),
    [anon_sym_rescue] = ACTIONS(1679),
    [anon_sym_do] = ACTIONS(1679),
    [anon_sym_when] = ACTIONS(1679),
    [anon_sym_elsif] = ACTIONS(1679),
    [anon_sym_else] = ACTIONS(1679),
    [anon_sym_then] = ACTIONS(1679),
    [anon_sym_ensure] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1679),
    [anon_sym_AMP_DOT] = ACTIONS(1679),
    [anon_sym_PLUS_EQ] = ACTIONS(1679),
    [anon_sym_DASH_EQ] = ACTIONS(1679),
    [anon_sym_STAR_EQ] = ACTIONS(1679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1679),
    [anon_sym_SLASH_EQ] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1679),
    [anon_sym_PIPE_EQ] = ACTIONS(1679),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1679),
    [anon_sym_AMP_EQ] = ACTIONS(1679),
    [anon_sym_PERCENT_EQ] = ACTIONS(1679),
    [anon_sym_GT_GT_EQ] = ACTIONS(1679),
    [anon_sym_LT_LT_EQ] = ACTIONS(1679),
    [anon_sym_CARET_EQ] = ACTIONS(1679),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_DOT_DOT] = ACTIONS(1681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1679),
    [anon_sym_and] = ACTIONS(1679),
    [anon_sym_or] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_BANG_EQ] = ACTIONS(1679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1679),
    [anon_sym_LT_EQ_GT] = ACTIONS(1679),
    [anon_sym_EQ_TILDE] = ACTIONS(1679),
    [anon_sym_BANG_TILDE] = ACTIONS(1679),
    [anon_sym_LT_EQ] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1679),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [3595] = {
    [sym__line_break] = ACTIONS(1699),
    [sym__heredoc_body_start] = ACTIONS(1699),
    [sym__binary_minus] = ACTIONS(1699),
    [sym__binary_star] = ACTIONS(1699),
    [ts_builtin_sym_end] = ACTIONS(1699),
    [anon_sym___END__] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_end] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_when] = ACTIONS(1699),
    [anon_sym_elsif] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_then] = ACTIONS(1699),
    [anon_sym_ensure] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_PLUS_EQ] = ACTIONS(1699),
    [anon_sym_DASH_EQ] = ACTIONS(1699),
    [anon_sym_STAR_EQ] = ACTIONS(1699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1699),
    [anon_sym_SLASH_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1699),
    [anon_sym_AMP_EQ] = ACTIONS(1699),
    [anon_sym_PERCENT_EQ] = ACTIONS(1699),
    [anon_sym_GT_GT_EQ] = ACTIONS(1699),
    [anon_sym_LT_LT_EQ] = ACTIONS(1699),
    [anon_sym_CARET_EQ] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [3596] = {
    [sym__line_break] = ACTIONS(1703),
    [sym__heredoc_body_start] = ACTIONS(1703),
    [sym__binary_minus] = ACTIONS(1703),
    [sym__binary_star] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1705),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1705),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_SLASH] = ACTIONS(1705),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(87),
  },
  [3597] = {
    [sym__line_break] = ACTIONS(1707),
    [sym__heredoc_body_start] = ACTIONS(1707),
    [sym__binary_minus] = ACTIONS(1707),
    [sym__binary_star] = ACTIONS(1707),
    [ts_builtin_sym_end] = ACTIONS(1707),
    [anon_sym___END__] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_DOT] = ACTIONS(1709),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_EQ] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_end] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1707),
    [anon_sym_unless] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(1707),
    [anon_sym_until] = ACTIONS(1707),
    [anon_sym_rescue] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1707),
    [anon_sym_when] = ACTIONS(1707),
    [anon_sym_elsif] = ACTIONS(1707),
    [anon_sym_else] = ACTIONS(1707),
    [anon_sym_then] = ACTIONS(1707),
    [anon_sym_ensure] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_COLON_COLON2] = ACTIONS(1707),
    [anon_sym_AMP_DOT] = ACTIONS(1707),
    [anon_sym_PLUS_EQ] = ACTIONS(1707),
    [anon_sym_DASH_EQ] = ACTIONS(1707),
    [anon_sym_STAR_EQ] = ACTIONS(1707),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1707),
    [anon_sym_SLASH_EQ] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1707),
    [anon_sym_PIPE_EQ] = ACTIONS(1707),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1707),
    [anon_sym_AMP_EQ] = ACTIONS(1707),
    [anon_sym_PERCENT_EQ] = ACTIONS(1707),
    [anon_sym_GT_GT_EQ] = ACTIONS(1707),
    [anon_sym_LT_LT_EQ] = ACTIONS(1707),
    [anon_sym_CARET_EQ] = ACTIONS(1707),
    [anon_sym_QMARK] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1707),
    [anon_sym_and] = ACTIONS(1707),
    [anon_sym_or] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(1709),
    [anon_sym_GT_GT] = ACTIONS(1709),
    [anon_sym_EQ_EQ] = ACTIONS(1709),
    [anon_sym_BANG_EQ] = ACTIONS(1707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1707),
    [anon_sym_LT_EQ_GT] = ACTIONS(1707),
    [anon_sym_EQ_TILDE] = ACTIONS(1707),
    [anon_sym_BANG_TILDE] = ACTIONS(1707),
    [anon_sym_LT_EQ] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_GT_EQ] = ACTIONS(1707),
    [anon_sym_CARET] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_SLASH] = ACTIONS(1709),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [sym_comment] = ACTIONS(87),
  },
  [3598] = {
    [sym__then] = STATE(6242),
    [sym_heredoc_body] = STATE(979),
    [sym__terminator] = STATE(979),
    [sym__line_break] = ACTIONS(1743),
    [sym__heredoc_body_start] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(9496),
    [sym_comment] = ACTIONS(87),
  },
  [3599] = {
    [sym__then] = STATE(6243),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(9498),
    [sym_comment] = ACTIONS(87),
  },
  [3600] = {
    [sym__do] = STATE(6244),
    [sym_heredoc_body] = STATE(6244),
    [sym__terminator] = STATE(6244),
    [sym__line_break] = ACTIONS(9500),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(9500),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(9500),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [3601] = {
    [sym__do] = STATE(6245),
    [sym_heredoc_body] = STATE(6245),
    [sym__terminator] = STATE(6245),
    [sym__line_break] = ACTIONS(9502),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(9502),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(9502),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [3602] = {
    [sym_in] = STATE(6246),
    [anon_sym_in] = ACTIONS(1969),
    [sym_comment] = ACTIONS(87),
  },
  [3603] = {
    [sym_heredoc_body] = STATE(6247),
    [sym__terminator] = STATE(6247),
    [sym__line_break] = ACTIONS(9504),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(9504),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [3604] = {
    [sym_when] = STATE(6248),
    [aux_sym_case_repeat1] = STATE(6249),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3605] = {
    [sym_else] = STATE(6251),
    [sym_ensure] = STATE(6252),
    [sym_rescue] = STATE(6253),
    [anon_sym_end] = ACTIONS(9508),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [3606] = {
    [sym_ensure] = STATE(6252),
    [anon_sym_end] = ACTIONS(9508),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [3607] = {
    [anon_sym_end] = ACTIONS(9508),
    [sym_comment] = ACTIONS(87),
  },
  [3608] = {
    [sym_else] = STATE(6251),
    [sym_ensure] = STATE(6252),
    [anon_sym_end] = ACTIONS(9508),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [3609] = {
    [sym__line_break] = ACTIONS(2187),
    [sym__heredoc_body_start] = ACTIONS(2187),
    [sym__binary_minus] = ACTIONS(2187),
    [sym__binary_star] = ACTIONS(2187),
    [ts_builtin_sym_end] = ACTIONS(2187),
    [anon_sym___END__] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_STAR_STAR] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_EQ] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_end] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_unless] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_until] = ACTIONS(2187),
    [anon_sym_rescue] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_when] = ACTIONS(2187),
    [anon_sym_elsif] = ACTIONS(2187),
    [anon_sym_else] = ACTIONS(2187),
    [anon_sym_then] = ACTIONS(2187),
    [anon_sym_ensure] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_COLON_COLON2] = ACTIONS(2187),
    [anon_sym_AMP_DOT] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_DOT_DOT] = ACTIONS(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_LT_LT] = ACTIONS(2189),
    [anon_sym_GT_GT] = ACTIONS(2189),
    [anon_sym_EQ_EQ] = ACTIONS(2189),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_EQ_TILDE] = ACTIONS(2187),
    [anon_sym_BANG_TILDE] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2189),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_PERCENT] = ACTIONS(2189),
    [sym_comment] = ACTIONS(87),
  },
  [3610] = {
    [sym__statements] = STATE(3605),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(3606),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(3607),
    [sym_rescue] = STATE(3608),
    [sym__body_statement] = STATE(6254),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9510),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3611] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [3612] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3613] = {
    [sym__line_break] = ACTIONS(2267),
    [sym__heredoc_body_start] = ACTIONS(2267),
    [sym__binary_minus] = ACTIONS(2267),
    [sym__binary_star] = ACTIONS(2267),
    [ts_builtin_sym_end] = ACTIONS(2267),
    [anon_sym___END__] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_RPAREN] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2269),
    [anon_sym_COMMA] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_STAR_STAR] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_end] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_unless] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_until] = ACTIONS(2267),
    [anon_sym_rescue] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_when] = ACTIONS(2267),
    [anon_sym_elsif] = ACTIONS(2267),
    [anon_sym_else] = ACTIONS(2267),
    [anon_sym_then] = ACTIONS(2267),
    [anon_sym_ensure] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_COLON_COLON2] = ACTIONS(2267),
    [anon_sym_AMP_DOT] = ACTIONS(2267),
    [anon_sym_PLUS_EQ] = ACTIONS(2267),
    [anon_sym_DASH_EQ] = ACTIONS(2267),
    [anon_sym_STAR_EQ] = ACTIONS(2267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2267),
    [anon_sym_SLASH_EQ] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2267),
    [anon_sym_PIPE_EQ] = ACTIONS(2267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2267),
    [anon_sym_AMP_EQ] = ACTIONS(2267),
    [anon_sym_PERCENT_EQ] = ACTIONS(2267),
    [anon_sym_GT_GT_EQ] = ACTIONS(2267),
    [anon_sym_LT_LT_EQ] = ACTIONS(2267),
    [anon_sym_CARET_EQ] = ACTIONS(2267),
    [anon_sym_QMARK] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2267),
    [anon_sym_and] = ACTIONS(2267),
    [anon_sym_or] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_LT_LT] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2269),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2267),
    [anon_sym_LT_EQ_GT] = ACTIONS(2267),
    [anon_sym_EQ_TILDE] = ACTIONS(2267),
    [anon_sym_BANG_TILDE] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2267),
    [anon_sym_CARET] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2269),
    [sym_comment] = ACTIONS(87),
  },
  [3614] = {
    [sym__line_break] = ACTIONS(2351),
    [sym__heredoc_body_start] = ACTIONS(2351),
    [sym__binary_minus] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2351),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [anon_sym___END__] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2353),
    [anon_sym_COMMA] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2353),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_end] = ACTIONS(2351),
    [anon_sym_if] = ACTIONS(2351),
    [anon_sym_unless] = ACTIONS(2351),
    [anon_sym_while] = ACTIONS(2351),
    [anon_sym_until] = ACTIONS(2351),
    [anon_sym_rescue] = ACTIONS(2351),
    [anon_sym_do] = ACTIONS(2351),
    [anon_sym_when] = ACTIONS(2351),
    [anon_sym_elsif] = ACTIONS(2351),
    [anon_sym_else] = ACTIONS(2351),
    [anon_sym_then] = ACTIONS(2351),
    [anon_sym_ensure] = ACTIONS(2351),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_COLON_COLON2] = ACTIONS(2351),
    [anon_sym_AMP_DOT] = ACTIONS(2351),
    [anon_sym_PLUS_EQ] = ACTIONS(2351),
    [anon_sym_DASH_EQ] = ACTIONS(2351),
    [anon_sym_STAR_EQ] = ACTIONS(2351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2351),
    [anon_sym_SLASH_EQ] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2351),
    [anon_sym_PIPE_EQ] = ACTIONS(2351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2351),
    [anon_sym_AMP_EQ] = ACTIONS(2351),
    [anon_sym_PERCENT_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT_EQ] = ACTIONS(2351),
    [anon_sym_LT_LT_EQ] = ACTIONS(2351),
    [anon_sym_CARET_EQ] = ACTIONS(2351),
    [anon_sym_QMARK] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2351),
    [anon_sym_or] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_CARET] = ACTIONS(2353),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_SLASH] = ACTIONS(2353),
    [anon_sym_PERCENT] = ACTIONS(2353),
    [sym_comment] = ACTIONS(87),
  },
  [3615] = {
    [sym_heredoc_body] = STATE(6256),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(9512),
    [sym_comment] = ACTIONS(87),
  },
  [3616] = {
    [anon_sym_RBRACK] = ACTIONS(9512),
    [sym_comment] = ACTIONS(87),
  },
  [3617] = {
    [sym_do_block] = STATE(6257),
    [sym_block] = STATE(6257),
    [anon_sym_LBRACE] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2731),
    [sym_comment] = ACTIONS(87),
  },
  [3618] = {
    [sym__line_break] = ACTIONS(2491),
    [sym__heredoc_body_start] = ACTIONS(2491),
    [sym__binary_minus] = ACTIONS(2491),
    [sym__binary_star] = ACTIONS(2491),
    [ts_builtin_sym_end] = ACTIONS(2491),
    [anon_sym___END__] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2493),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_STAR_STAR] = ACTIONS(2493),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_EQ] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_end] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_unless] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_until] = ACTIONS(2491),
    [anon_sym_rescue] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_when] = ACTIONS(2491),
    [anon_sym_elsif] = ACTIONS(2491),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_then] = ACTIONS(2491),
    [anon_sym_ensure] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_COLON_COLON2] = ACTIONS(2491),
    [anon_sym_AMP_DOT] = ACTIONS(2491),
    [anon_sym_PLUS_EQ] = ACTIONS(2491),
    [anon_sym_DASH_EQ] = ACTIONS(2491),
    [anon_sym_STAR_EQ] = ACTIONS(2491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2491),
    [anon_sym_SLASH_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_EQ] = ACTIONS(2491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2491),
    [anon_sym_AMP_EQ] = ACTIONS(2491),
    [anon_sym_PERCENT_EQ] = ACTIONS(2491),
    [anon_sym_GT_GT_EQ] = ACTIONS(2491),
    [anon_sym_LT_LT_EQ] = ACTIONS(2491),
    [anon_sym_CARET_EQ] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2491),
    [anon_sym_DOT_DOT] = ACTIONS(2493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2491),
    [anon_sym_and] = ACTIONS(2491),
    [anon_sym_or] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2493),
    [anon_sym_AMP_AMP] = ACTIONS(2493),
    [anon_sym_LT_LT] = ACTIONS(2493),
    [anon_sym_GT_GT] = ACTIONS(2493),
    [anon_sym_EQ_EQ] = ACTIONS(2493),
    [anon_sym_BANG_EQ] = ACTIONS(2491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ_GT] = ACTIONS(2491),
    [anon_sym_EQ_TILDE] = ACTIONS(2491),
    [anon_sym_BANG_TILDE] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2493),
    [anon_sym_PLUS] = ACTIONS(2493),
    [anon_sym_SLASH] = ACTIONS(2493),
    [anon_sym_PERCENT] = ACTIONS(2493),
    [sym_comment] = ACTIONS(87),
  },
  [3619] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6258),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(6258),
    [sym_operator_assignment] = STATE(6258),
    [sym_conditional] = STATE(6258),
    [sym_range] = STATE(6258),
    [sym_binary] = STATE(6258),
    [sym_unary] = STATE(6258),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3620] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6259),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(6259),
    [sym_operator_assignment] = STATE(6259),
    [sym_conditional] = STATE(6259),
    [sym_range] = STATE(6259),
    [sym_binary] = STATE(6259),
    [sym_unary] = STATE(6259),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3621] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6260),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(6260),
    [sym_operator_assignment] = STATE(6260),
    [sym_conditional] = STATE(6260),
    [sym_range] = STATE(6260),
    [sym_binary] = STATE(6260),
    [sym_unary] = STATE(6260),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3622] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6261),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(6261),
    [sym_operator_assignment] = STATE(6261),
    [sym_conditional] = STATE(6261),
    [sym_range] = STATE(6261),
    [sym_binary] = STATE(6261),
    [sym_unary] = STATE(6261),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3623] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6262),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(6262),
    [sym_operator_assignment] = STATE(6262),
    [sym_conditional] = STATE(6262),
    [sym_range] = STATE(6262),
    [sym_binary] = STATE(6262),
    [sym_unary] = STATE(6262),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3624] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6263),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6263),
    [sym_operator_assignment] = STATE(6263),
    [sym_conditional] = STATE(6263),
    [sym_range] = STATE(6263),
    [sym_binary] = STATE(6263),
    [sym_unary] = STATE(6263),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3625] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6264),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(6264),
    [sym_operator_assignment] = STATE(6264),
    [sym_conditional] = STATE(6264),
    [sym_range] = STATE(6264),
    [sym_binary] = STATE(6264),
    [sym_unary] = STATE(6264),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3626] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6265),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(6265),
    [sym_operator_assignment] = STATE(6265),
    [sym_conditional] = STATE(6265),
    [sym_range] = STATE(6265),
    [sym_binary] = STATE(6265),
    [sym_unary] = STATE(6265),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3627] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6266),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(6266),
    [sym_operator_assignment] = STATE(6266),
    [sym_conditional] = STATE(6266),
    [sym_range] = STATE(6266),
    [sym_binary] = STATE(6266),
    [sym_unary] = STATE(6266),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3628] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6267),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(6267),
    [sym_operator_assignment] = STATE(6267),
    [sym_conditional] = STATE(6267),
    [sym_range] = STATE(6267),
    [sym_binary] = STATE(6267),
    [sym_unary] = STATE(6267),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3629] = {
    [sym__statements] = STATE(1512),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(1513),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1519),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1520),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9514),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3630] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6269),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_splat_argument] = STATE(6271),
    [sym_assignment] = STATE(6269),
    [sym_operator_assignment] = STATE(6269),
    [sym_conditional] = STATE(6269),
    [sym_range] = STATE(6269),
    [sym_binary] = STATE(6269),
    [sym_unary] = STATE(6269),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(6271),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(765),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3631] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6272),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(6272),
    [sym_operator_assignment] = STATE(6272),
    [sym_conditional] = STATE(6272),
    [sym_range] = STATE(6272),
    [sym_binary] = STATE(6272),
    [sym_unary] = STATE(6272),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3632] = {
    [sym_string] = STATE(6273),
    [aux_sym_chained_string_repeat1] = STATE(6273),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [ts_builtin_sym_end] = ACTIONS(2759),
    [anon_sym___END__] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [3633] = {
    [sym__line_break] = ACTIONS(993),
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [ts_builtin_sym_end] = ACTIONS(993),
    [anon_sym___END__] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_end] = ACTIONS(993),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_when] = ACTIONS(993),
    [anon_sym_elsif] = ACTIONS(993),
    [anon_sym_else] = ACTIONS(993),
    [anon_sym_then] = ACTIONS(993),
    [anon_sym_ensure] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_PLUS_EQ] = ACTIONS(993),
    [anon_sym_DASH_EQ] = ACTIONS(993),
    [anon_sym_STAR_EQ] = ACTIONS(993),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(993),
    [anon_sym_SLASH_EQ] = ACTIONS(993),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(993),
    [anon_sym_PIPE_EQ] = ACTIONS(993),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(993),
    [anon_sym_AMP_EQ] = ACTIONS(993),
    [anon_sym_PERCENT_EQ] = ACTIONS(993),
    [anon_sym_GT_GT_EQ] = ACTIONS(993),
    [anon_sym_LT_LT_EQ] = ACTIONS(993),
    [anon_sym_CARET_EQ] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [sym_comment] = ACTIONS(87),
  },
  [3634] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(6557),
    [anon_sym___END__] = ACTIONS(6557),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [3635] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3636] = {
    [sym_string] = STATE(3670),
    [aux_sym_chained_string_repeat1] = STATE(3670),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3637] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6274),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6274),
    [sym_operator_assignment] = STATE(6274),
    [sym_conditional] = STATE(6274),
    [sym_range] = STATE(6274),
    [sym_binary] = STATE(6274),
    [sym_unary] = STATE(6274),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3638] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6275),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6275),
    [sym_operator_assignment] = STATE(6275),
    [sym_conditional] = STATE(6275),
    [sym_range] = STATE(6275),
    [sym_binary] = STATE(6275),
    [sym_unary] = STATE(6275),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3639] = {
    [anon_sym_COLON] = ACTIONS(9516),
    [sym_comment] = ACTIONS(87),
  },
  [3640] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6277),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6277),
    [sym_operator_assignment] = STATE(6277),
    [sym_conditional] = STATE(6277),
    [sym_range] = STATE(6277),
    [sym_binary] = STATE(6277),
    [sym_unary] = STATE(6277),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3641] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9518),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3642] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [3643] = {
    [sym_heredoc_body] = STATE(6279),
    [aux_sym_call_repeat1] = STATE(6279),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3644] = {
    [sym_heredoc_body] = STATE(6279),
    [aux_sym_call_repeat1] = STATE(6279),
    [aux_sym_argument_list_repeat1] = STATE(6281),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9520),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3645] = {
    [sym_string] = STATE(3956),
    [aux_sym_chained_string_repeat1] = STATE(3956),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9522),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3646] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5946),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(5948),
    [anon_sym_DOT_DOT] = ACTIONS(5950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5952),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5956),
    [anon_sym_AMP_AMP] = ACTIONS(5956),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5956),
    [anon_sym_LT_EQ_GT] = ACTIONS(5956),
    [anon_sym_EQ_TILDE] = ACTIONS(5956),
    [anon_sym_BANG_TILDE] = ACTIONS(5956),
    [anon_sym_LT_EQ] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5946),
    [anon_sym_GT_EQ] = ACTIONS(5962),
    [anon_sym_CARET] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [3647] = {
    [sym__line_break] = ACTIONS(9172),
    [sym__heredoc_body_start] = ACTIONS(9172),
    [sym__binary_minus] = ACTIONS(9172),
    [sym__binary_star] = ACTIONS(9172),
    [ts_builtin_sym_end] = ACTIONS(9172),
    [anon_sym___END__] = ACTIONS(9172),
    [anon_sym_LBRACE] = ACTIONS(9172),
    [anon_sym_RBRACE] = ACTIONS(9172),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9174),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9174),
    [anon_sym_SEMI] = ACTIONS(9172),
    [anon_sym_STAR_STAR] = ACTIONS(9174),
    [anon_sym_AMP] = ACTIONS(9174),
    [anon_sym_EQ] = ACTIONS(9174),
    [anon_sym_LT] = ACTIONS(9174),
    [anon_sym_end] = ACTIONS(9172),
    [anon_sym_if] = ACTIONS(9172),
    [anon_sym_unless] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(9172),
    [anon_sym_until] = ACTIONS(9172),
    [anon_sym_rescue] = ACTIONS(9172),
    [anon_sym_do] = ACTIONS(9172),
    [anon_sym_when] = ACTIONS(9172),
    [anon_sym_elsif] = ACTIONS(9172),
    [anon_sym_else] = ACTIONS(9172),
    [anon_sym_then] = ACTIONS(9172),
    [anon_sym_ensure] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [anon_sym_PLUS_EQ] = ACTIONS(9172),
    [anon_sym_DASH_EQ] = ACTIONS(9172),
    [anon_sym_STAR_EQ] = ACTIONS(9172),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9172),
    [anon_sym_SLASH_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9172),
    [anon_sym_AMP_EQ] = ACTIONS(9172),
    [anon_sym_PERCENT_EQ] = ACTIONS(9172),
    [anon_sym_GT_GT_EQ] = ACTIONS(9172),
    [anon_sym_LT_LT_EQ] = ACTIONS(9172),
    [anon_sym_CARET_EQ] = ACTIONS(9172),
    [anon_sym_QMARK] = ACTIONS(9172),
    [anon_sym_DOT_DOT] = ACTIONS(9174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9172),
    [anon_sym_and] = ACTIONS(9172),
    [anon_sym_or] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE] = ACTIONS(9174),
    [anon_sym_AMP_AMP] = ACTIONS(9174),
    [anon_sym_LT_LT] = ACTIONS(9174),
    [anon_sym_GT_GT] = ACTIONS(9174),
    [anon_sym_EQ_EQ] = ACTIONS(9174),
    [anon_sym_BANG_EQ] = ACTIONS(9172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9172),
    [anon_sym_LT_EQ_GT] = ACTIONS(9172),
    [anon_sym_EQ_TILDE] = ACTIONS(9172),
    [anon_sym_BANG_TILDE] = ACTIONS(9172),
    [anon_sym_LT_EQ] = ACTIONS(9174),
    [anon_sym_GT] = ACTIONS(9174),
    [anon_sym_GT_EQ] = ACTIONS(9172),
    [anon_sym_CARET] = ACTIONS(9174),
    [anon_sym_PLUS] = ACTIONS(9174),
    [anon_sym_SLASH] = ACTIONS(9174),
    [anon_sym_PERCENT] = ACTIONS(9174),
    [sym_comment] = ACTIONS(87),
  },
  [3648] = {
    [anon_sym_RBRACE] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [3649] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6283),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(6283),
    [sym_operator_assignment] = STATE(6283),
    [sym_conditional] = STATE(6283),
    [sym_range] = STATE(6283),
    [sym_binary] = STATE(6283),
    [sym_unary] = STATE(6283),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3650] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6284),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(6284),
    [sym_operator_assignment] = STATE(6284),
    [sym_conditional] = STATE(6284),
    [sym_range] = STATE(6284),
    [sym_binary] = STATE(6284),
    [sym_unary] = STATE(6284),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3651] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6285),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(6285),
    [sym_operator_assignment] = STATE(6285),
    [sym_conditional] = STATE(6285),
    [sym_range] = STATE(6285),
    [sym_binary] = STATE(6285),
    [sym_unary] = STATE(6285),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3652] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6286),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(6286),
    [sym_operator_assignment] = STATE(6286),
    [sym_conditional] = STATE(6286),
    [sym_range] = STATE(6286),
    [sym_binary] = STATE(6286),
    [sym_unary] = STATE(6286),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3653] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6287),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(6287),
    [sym_operator_assignment] = STATE(6287),
    [sym_conditional] = STATE(6287),
    [sym_range] = STATE(6287),
    [sym_binary] = STATE(6287),
    [sym_unary] = STATE(6287),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3654] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6288),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6288),
    [sym_operator_assignment] = STATE(6288),
    [sym_conditional] = STATE(6288),
    [sym_range] = STATE(6288),
    [sym_binary] = STATE(6288),
    [sym_unary] = STATE(6288),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3655] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6289),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(6289),
    [sym_operator_assignment] = STATE(6289),
    [sym_conditional] = STATE(6289),
    [sym_range] = STATE(6289),
    [sym_binary] = STATE(6289),
    [sym_unary] = STATE(6289),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3656] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6290),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(6290),
    [sym_operator_assignment] = STATE(6290),
    [sym_conditional] = STATE(6290),
    [sym_range] = STATE(6290),
    [sym_binary] = STATE(6290),
    [sym_unary] = STATE(6290),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3657] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6291),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(6291),
    [sym_operator_assignment] = STATE(6291),
    [sym_conditional] = STATE(6291),
    [sym_range] = STATE(6291),
    [sym_binary] = STATE(6291),
    [sym_unary] = STATE(6291),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3658] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6292),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(6292),
    [sym_operator_assignment] = STATE(6292),
    [sym_conditional] = STATE(6292),
    [sym_range] = STATE(6292),
    [sym_binary] = STATE(6292),
    [sym_unary] = STATE(6292),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3659] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6293),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6293),
    [sym_operator_assignment] = STATE(6293),
    [sym_conditional] = STATE(6293),
    [sym_range] = STATE(6293),
    [sym_binary] = STATE(6293),
    [sym_unary] = STATE(6293),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3660] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6294),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6294),
    [sym_operator_assignment] = STATE(6294),
    [sym_conditional] = STATE(6294),
    [sym_range] = STATE(6294),
    [sym_binary] = STATE(6294),
    [sym_unary] = STATE(6294),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3661] = {
    [anon_sym_COLON] = ACTIONS(9526),
    [sym_comment] = ACTIONS(87),
  },
  [3662] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6296),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6296),
    [sym_operator_assignment] = STATE(6296),
    [sym_conditional] = STATE(6296),
    [sym_range] = STATE(6296),
    [sym_binary] = STATE(6296),
    [sym_unary] = STATE(6296),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3663] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9528),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3664] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [3665] = {
    [sym_heredoc_body] = STATE(6298),
    [aux_sym_call_repeat1] = STATE(6298),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3666] = {
    [sym_heredoc_body] = STATE(6298),
    [aux_sym_call_repeat1] = STATE(6298),
    [aux_sym_argument_list_repeat1] = STATE(6300),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9530),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3667] = {
    [sym_string] = STATE(4009),
    [aux_sym_chained_string_repeat1] = STATE(4009),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9532),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3668] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6305),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_splat_argument] = STATE(6306),
    [sym_assignment] = STATE(6305),
    [sym_operator_assignment] = STATE(6305),
    [sym_conditional] = STATE(6305),
    [sym_range] = STATE(6305),
    [sym_binary] = STATE(6305),
    [sym_unary] = STATE(6305),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(6306),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(9534),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3669] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6309),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(6309),
    [sym_operator_assignment] = STATE(6309),
    [sym_conditional] = STATE(6309),
    [sym_range] = STATE(6309),
    [sym_binary] = STATE(6309),
    [sym_unary] = STATE(6309),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3670] = {
    [sym_string] = STATE(6310),
    [aux_sym_chained_string_repeat1] = STATE(6310),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [3671] = {
    [sym__line_break] = ACTIONS(3440),
    [sym__heredoc_body_start] = ACTIONS(3440),
    [sym__binary_minus] = ACTIONS(3440),
    [sym__binary_star] = ACTIONS(3440),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [anon_sym___END__] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3440),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_end] = ACTIONS(3440),
    [anon_sym_if] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3440),
    [anon_sym_while] = ACTIONS(3440),
    [anon_sym_until] = ACTIONS(3440),
    [anon_sym_rescue] = ACTIONS(3440),
    [anon_sym_do] = ACTIONS(3440),
    [anon_sym_when] = ACTIONS(3440),
    [anon_sym_elsif] = ACTIONS(3440),
    [anon_sym_else] = ACTIONS(3440),
    [anon_sym_then] = ACTIONS(3440),
    [anon_sym_ensure] = ACTIONS(3440),
    [anon_sym_EQ_GT] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3440),
    [anon_sym_COLON_COLON2] = ACTIONS(3440),
    [anon_sym_AMP_DOT] = ACTIONS(3440),
    [anon_sym_PLUS_EQ] = ACTIONS(3440),
    [anon_sym_DASH_EQ] = ACTIONS(3440),
    [anon_sym_STAR_EQ] = ACTIONS(3440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3440),
    [anon_sym_SLASH_EQ] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3440),
    [anon_sym_PIPE_EQ] = ACTIONS(3440),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3440),
    [anon_sym_AMP_EQ] = ACTIONS(3440),
    [anon_sym_PERCENT_EQ] = ACTIONS(3440),
    [anon_sym_GT_GT_EQ] = ACTIONS(3440),
    [anon_sym_LT_LT_EQ] = ACTIONS(3440),
    [anon_sym_CARET_EQ] = ACTIONS(3440),
    [anon_sym_QMARK] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3440),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_LT_LT] = ACTIONS(3442),
    [anon_sym_GT_GT] = ACTIONS(3442),
    [anon_sym_EQ_EQ] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3440),
    [anon_sym_BANG_TILDE] = ACTIONS(3440),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3440),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_SLASH] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [sym_comment] = ACTIONS(87),
  },
  [3672] = {
    [anon_sym_RBRACE] = ACTIONS(9546),
    [sym_comment] = ACTIONS(87),
  },
  [3673] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(9548),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [3674] = {
    [sym__method_rest] = STATE(6313),
    [sym_operator] = STATE(1524),
    [sym__method_name] = STATE(1524),
    [sym_setter] = STATE(1524),
    [sym_symbol] = STATE(1524),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9550),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9550),
    [sym_class_variable] = ACTIONS(9550),
    [sym_global_variable] = ACTIONS(9550),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [3675] = {
    [sym__statements] = STATE(1548),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1549),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1550),
    [sym_rescue] = STATE(1551),
    [sym__body_statement] = STATE(6314),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9552),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3676] = {
    [sym__line_break] = ACTIONS(3670),
    [sym__heredoc_body_start] = ACTIONS(3670),
    [sym__binary_minus] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [ts_builtin_sym_end] = ACTIONS(3670),
    [anon_sym___END__] = ACTIONS(3670),
    [anon_sym_LBRACE] = ACTIONS(3670),
    [anon_sym_RBRACE] = ACTIONS(3670),
    [anon_sym_RPAREN] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_SEMI] = ACTIONS(3670),
    [anon_sym_STAR_STAR] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3672),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3672),
    [anon_sym_end] = ACTIONS(3670),
    [anon_sym_if] = ACTIONS(3670),
    [anon_sym_unless] = ACTIONS(3670),
    [anon_sym_while] = ACTIONS(3670),
    [anon_sym_until] = ACTIONS(3670),
    [anon_sym_rescue] = ACTIONS(3670),
    [anon_sym_do] = ACTIONS(3670),
    [anon_sym_when] = ACTIONS(3670),
    [anon_sym_elsif] = ACTIONS(3670),
    [anon_sym_else] = ACTIONS(3670),
    [anon_sym_then] = ACTIONS(3670),
    [anon_sym_ensure] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3670),
    [anon_sym_COLON_COLON2] = ACTIONS(3670),
    [anon_sym_AMP_DOT] = ACTIONS(3670),
    [anon_sym_PLUS_EQ] = ACTIONS(3670),
    [anon_sym_DASH_EQ] = ACTIONS(3670),
    [anon_sym_STAR_EQ] = ACTIONS(3670),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3670),
    [anon_sym_SLASH_EQ] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3670),
    [anon_sym_PIPE_EQ] = ACTIONS(3670),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3670),
    [anon_sym_AMP_EQ] = ACTIONS(3670),
    [anon_sym_PERCENT_EQ] = ACTIONS(3670),
    [anon_sym_GT_GT_EQ] = ACTIONS(3670),
    [anon_sym_LT_LT_EQ] = ACTIONS(3670),
    [anon_sym_CARET_EQ] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3670),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3672),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LT_EQ_GT] = ACTIONS(3670),
    [anon_sym_EQ_TILDE] = ACTIONS(3670),
    [anon_sym_BANG_TILDE] = ACTIONS(3670),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3672),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [sym_comment] = ACTIONS(87),
  },
  [3677] = {
    [sym_heredoc_body] = STATE(6315),
    [sym__terminator] = STATE(6315),
    [sym__line_break] = ACTIONS(9554),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(9554),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [3678] = {
    [sym_heredoc_body] = STATE(6316),
    [sym__terminator] = STATE(6316),
    [sym__line_break] = ACTIONS(9556),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(9556),
    [sym_comment] = ACTIONS(87),
  },
  [3679] = {
    [sym__statements] = STATE(1548),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1549),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1550),
    [sym_rescue] = STATE(1551),
    [sym__body_statement] = STATE(6317),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9558),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3680] = {
    [sym__line_break] = ACTIONS(4068),
    [sym__heredoc_body_start] = ACTIONS(4068),
    [sym__binary_minus] = ACTIONS(4068),
    [sym__binary_star] = ACTIONS(4068),
    [ts_builtin_sym_end] = ACTIONS(4068),
    [anon_sym___END__] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_STAR_STAR] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_end] = ACTIONS(4068),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_unless] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_until] = ACTIONS(4068),
    [anon_sym_rescue] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_when] = ACTIONS(4068),
    [anon_sym_elsif] = ACTIONS(4068),
    [anon_sym_else] = ACTIONS(4068),
    [anon_sym_then] = ACTIONS(4068),
    [anon_sym_ensure] = ACTIONS(4068),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON_COLON2] = ACTIONS(4068),
    [anon_sym_AMP_DOT] = ACTIONS(4068),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ_GT] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_BANG_TILDE] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [sym_comment] = ACTIONS(87),
  },
  [3681] = {
    [sym__statements] = STATE(1548),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1549),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1550),
    [sym_rescue] = STATE(1551),
    [sym__body_statement] = STATE(6318),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9560),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3682] = {
    [sym__statements] = STATE(6320),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(6321),
    [sym_else] = STATE(6321),
    [sym__if_tail] = STATE(6321),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6322),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__terminator] = STATE(6322),
    [sym__line_break] = ACTIONS(9562),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9564),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3683] = {
    [sym__statements] = STATE(6324),
    [sym__top_level_statement] = STATE(2704),
    [sym_begin_block] = STATE(2704),
    [sym_end_block] = STATE(2704),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(6325),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9566),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3684] = {
    [sym__statements] = STATE(6327),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9568),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3685] = {
    [sym__statements] = STATE(6329),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9570),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3686] = {
    [sym__do] = STATE(6330),
    [sym_heredoc_body] = STATE(6330),
    [sym__terminator] = STATE(6330),
    [sym__line_break] = ACTIONS(9572),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(9572),
    [anon_sym_do] = ACTIONS(9572),
    [sym_comment] = ACTIONS(87),
  },
  [3687] = {
    [sym__line_break] = ACTIONS(9192),
    [sym__heredoc_body_start] = ACTIONS(9192),
    [sym__binary_minus] = ACTIONS(9192),
    [sym__binary_star] = ACTIONS(9192),
    [ts_builtin_sym_end] = ACTIONS(9192),
    [anon_sym___END__] = ACTIONS(9192),
    [anon_sym_LBRACE] = ACTIONS(9192),
    [anon_sym_RBRACE] = ACTIONS(9192),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9194),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9194),
    [anon_sym_SEMI] = ACTIONS(9192),
    [anon_sym_STAR_STAR] = ACTIONS(9194),
    [anon_sym_AMP] = ACTIONS(9194),
    [anon_sym_EQ] = ACTIONS(9194),
    [anon_sym_LT] = ACTIONS(9194),
    [anon_sym_end] = ACTIONS(9192),
    [anon_sym_if] = ACTIONS(9192),
    [anon_sym_unless] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(9192),
    [anon_sym_until] = ACTIONS(9192),
    [anon_sym_rescue] = ACTIONS(9192),
    [anon_sym_do] = ACTIONS(9192),
    [anon_sym_when] = ACTIONS(9192),
    [anon_sym_elsif] = ACTIONS(9192),
    [anon_sym_else] = ACTIONS(9192),
    [anon_sym_then] = ACTIONS(9192),
    [anon_sym_ensure] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [anon_sym_PLUS_EQ] = ACTIONS(9192),
    [anon_sym_DASH_EQ] = ACTIONS(9192),
    [anon_sym_STAR_EQ] = ACTIONS(9192),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9192),
    [anon_sym_SLASH_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9192),
    [anon_sym_AMP_EQ] = ACTIONS(9192),
    [anon_sym_PERCENT_EQ] = ACTIONS(9192),
    [anon_sym_GT_GT_EQ] = ACTIONS(9192),
    [anon_sym_LT_LT_EQ] = ACTIONS(9192),
    [anon_sym_CARET_EQ] = ACTIONS(9192),
    [anon_sym_QMARK] = ACTIONS(9192),
    [anon_sym_DOT_DOT] = ACTIONS(9194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9192),
    [anon_sym_and] = ACTIONS(9192),
    [anon_sym_or] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE] = ACTIONS(9194),
    [anon_sym_AMP_AMP] = ACTIONS(9194),
    [anon_sym_LT_LT] = ACTIONS(9194),
    [anon_sym_GT_GT] = ACTIONS(9194),
    [anon_sym_EQ_EQ] = ACTIONS(9194),
    [anon_sym_BANG_EQ] = ACTIONS(9192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9192),
    [anon_sym_LT_EQ_GT] = ACTIONS(9192),
    [anon_sym_EQ_TILDE] = ACTIONS(9192),
    [anon_sym_BANG_TILDE] = ACTIONS(9192),
    [anon_sym_LT_EQ] = ACTIONS(9194),
    [anon_sym_GT] = ACTIONS(9194),
    [anon_sym_GT_EQ] = ACTIONS(9192),
    [anon_sym_CARET] = ACTIONS(9194),
    [anon_sym_PLUS] = ACTIONS(9194),
    [anon_sym_SLASH] = ACTIONS(9194),
    [anon_sym_PERCENT] = ACTIONS(9194),
    [sym_comment] = ACTIONS(87),
  },
  [3688] = {
    [anon_sym_end] = ACTIONS(9574),
    [sym_comment] = ACTIONS(87),
  },
  [3689] = {
    [sym__statements] = STATE(6332),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9576),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3690] = {
    [sym__statements] = STATE(6332),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6333),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(6333),
    [sym__line_break] = ACTIONS(9578),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9576),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3691] = {
    [sym_when] = STATE(6334),
    [aux_sym_case_repeat1] = STATE(6335),
    [anon_sym_SEMI] = ACTIONS(9580),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3692] = {
    [anon_sym_end] = ACTIONS(9582),
    [sym_comment] = ACTIONS(87),
  },
  [3693] = {
    [sym_when] = STATE(6334),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [3694] = {
    [sym__line_break] = ACTIONS(5264),
    [sym__heredoc_body_start] = ACTIONS(5264),
    [sym__binary_minus] = ACTIONS(5264),
    [sym__binary_star] = ACTIONS(5264),
    [ts_builtin_sym_end] = ACTIONS(5264),
    [anon_sym___END__] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5264),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_RPAREN] = ACTIONS(5264),
    [anon_sym_DOT] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5264),
    [anon_sym_PIPE] = ACTIONS(5266),
    [anon_sym_SEMI] = ACTIONS(5264),
    [anon_sym_STAR_STAR] = ACTIONS(5266),
    [anon_sym_AMP] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5266),
    [anon_sym_end] = ACTIONS(5264),
    [anon_sym_if] = ACTIONS(5264),
    [anon_sym_unless] = ACTIONS(5264),
    [anon_sym_while] = ACTIONS(5264),
    [anon_sym_until] = ACTIONS(5264),
    [anon_sym_rescue] = ACTIONS(5264),
    [anon_sym_do] = ACTIONS(5264),
    [anon_sym_when] = ACTIONS(5264),
    [anon_sym_elsif] = ACTIONS(5264),
    [anon_sym_else] = ACTIONS(5264),
    [anon_sym_then] = ACTIONS(5264),
    [anon_sym_ensure] = ACTIONS(5264),
    [anon_sym_EQ_GT] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5264),
    [anon_sym_COLON_COLON2] = ACTIONS(5264),
    [anon_sym_AMP_DOT] = ACTIONS(5264),
    [anon_sym_PLUS_EQ] = ACTIONS(5264),
    [anon_sym_DASH_EQ] = ACTIONS(5264),
    [anon_sym_STAR_EQ] = ACTIONS(5264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5264),
    [anon_sym_SLASH_EQ] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5264),
    [anon_sym_PIPE_EQ] = ACTIONS(5264),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5264),
    [anon_sym_AMP_EQ] = ACTIONS(5264),
    [anon_sym_PERCENT_EQ] = ACTIONS(5264),
    [anon_sym_GT_GT_EQ] = ACTIONS(5264),
    [anon_sym_LT_LT_EQ] = ACTIONS(5264),
    [anon_sym_CARET_EQ] = ACTIONS(5264),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5264),
    [anon_sym_and] = ACTIONS(5264),
    [anon_sym_or] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE] = ACTIONS(5266),
    [anon_sym_AMP_AMP] = ACTIONS(5266),
    [anon_sym_LT_LT] = ACTIONS(5266),
    [anon_sym_GT_GT] = ACTIONS(5266),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5264),
    [anon_sym_LT_EQ_GT] = ACTIONS(5264),
    [anon_sym_EQ_TILDE] = ACTIONS(5264),
    [anon_sym_BANG_TILDE] = ACTIONS(5264),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_GT] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5264),
    [anon_sym_CARET] = ACTIONS(5266),
    [anon_sym_PLUS] = ACTIONS(5266),
    [anon_sym_SLASH] = ACTIONS(5266),
    [anon_sym_PERCENT] = ACTIONS(5266),
    [sym_comment] = ACTIONS(87),
  },
  [3695] = {
    [sym_ensure] = STATE(6338),
    [anon_sym_end] = ACTIONS(9584),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [3696] = {
    [anon_sym_end] = ACTIONS(9584),
    [sym_comment] = ACTIONS(87),
  },
  [3697] = {
    [sym_else] = STATE(6339),
    [sym_ensure] = STATE(6338),
    [anon_sym_end] = ACTIONS(9584),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [3698] = {
    [sym__line_break] = ACTIONS(5350),
    [sym__heredoc_body_start] = ACTIONS(5350),
    [sym__binary_minus] = ACTIONS(5350),
    [sym__binary_star] = ACTIONS(5350),
    [ts_builtin_sym_end] = ACTIONS(5350),
    [anon_sym___END__] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_RPAREN] = ACTIONS(5350),
    [anon_sym_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5350),
    [anon_sym_PIPE] = ACTIONS(5352),
    [anon_sym_SEMI] = ACTIONS(5350),
    [anon_sym_STAR_STAR] = ACTIONS(5352),
    [anon_sym_AMP] = ACTIONS(5352),
    [anon_sym_EQ] = ACTIONS(5352),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5350),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_unless] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_until] = ACTIONS(5350),
    [anon_sym_rescue] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_when] = ACTIONS(5350),
    [anon_sym_elsif] = ACTIONS(5350),
    [anon_sym_else] = ACTIONS(5350),
    [anon_sym_then] = ACTIONS(5350),
    [anon_sym_ensure] = ACTIONS(5350),
    [anon_sym_EQ_GT] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_COLON_COLON2] = ACTIONS(5350),
    [anon_sym_AMP_DOT] = ACTIONS(5350),
    [anon_sym_PLUS_EQ] = ACTIONS(5350),
    [anon_sym_DASH_EQ] = ACTIONS(5350),
    [anon_sym_STAR_EQ] = ACTIONS(5350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5350),
    [anon_sym_SLASH_EQ] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5350),
    [anon_sym_PIPE_EQ] = ACTIONS(5350),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5350),
    [anon_sym_AMP_EQ] = ACTIONS(5350),
    [anon_sym_PERCENT_EQ] = ACTIONS(5350),
    [anon_sym_GT_GT_EQ] = ACTIONS(5350),
    [anon_sym_LT_LT_EQ] = ACTIONS(5350),
    [anon_sym_CARET_EQ] = ACTIONS(5350),
    [anon_sym_QMARK] = ACTIONS(5350),
    [anon_sym_DOT_DOT] = ACTIONS(5352),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5352),
    [anon_sym_AMP_AMP] = ACTIONS(5352),
    [anon_sym_LT_LT] = ACTIONS(5352),
    [anon_sym_GT_GT] = ACTIONS(5352),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5350),
    [anon_sym_LT_EQ_GT] = ACTIONS(5350),
    [anon_sym_EQ_TILDE] = ACTIONS(5350),
    [anon_sym_BANG_TILDE] = ACTIONS(5350),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5352),
    [anon_sym_PLUS] = ACTIONS(5352),
    [anon_sym_SLASH] = ACTIONS(5352),
    [anon_sym_PERCENT] = ACTIONS(5352),
    [sym_comment] = ACTIONS(87),
  },
  [3699] = {
    [sym__line_break] = ACTIONS(7608),
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [ts_builtin_sym_end] = ACTIONS(7608),
    [anon_sym___END__] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR_STAR] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_end] = ACTIONS(7608),
    [anon_sym_if] = ACTIONS(7608),
    [anon_sym_unless] = ACTIONS(7608),
    [anon_sym_while] = ACTIONS(7608),
    [anon_sym_until] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7608),
    [anon_sym_do] = ACTIONS(7608),
    [anon_sym_when] = ACTIONS(7608),
    [anon_sym_elsif] = ACTIONS(7608),
    [anon_sym_else] = ACTIONS(7608),
    [anon_sym_then] = ACTIONS(7608),
    [anon_sym_ensure] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_PLUS_EQ] = ACTIONS(7608),
    [anon_sym_DASH_EQ] = ACTIONS(7608),
    [anon_sym_STAR_EQ] = ACTIONS(7608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7608),
    [anon_sym_SLASH_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7608),
    [anon_sym_AMP_EQ] = ACTIONS(7608),
    [anon_sym_PERCENT_EQ] = ACTIONS(7608),
    [anon_sym_GT_GT_EQ] = ACTIONS(7608),
    [anon_sym_LT_LT_EQ] = ACTIONS(7608),
    [anon_sym_CARET_EQ] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7608),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7608),
    [anon_sym_or] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE] = ACTIONS(7610),
    [anon_sym_AMP_AMP] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [sym_comment] = ACTIONS(87),
  },
  [3700] = {
    [anon_sym_RPAREN] = ACTIONS(9586),
    [sym_comment] = ACTIONS(87),
  },
  [3701] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(6759),
    [anon_sym___END__] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [3702] = {
    [sym__line_break] = ACTIONS(5582),
    [sym__heredoc_body_start] = ACTIONS(5582),
    [sym__binary_minus] = ACTIONS(5582),
    [sym__binary_star] = ACTIONS(5582),
    [ts_builtin_sym_end] = ACTIONS(5582),
    [anon_sym___END__] = ACTIONS(5582),
    [anon_sym_LBRACE] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_STAR_STAR] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_EQ] = ACTIONS(5584),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_end] = ACTIONS(5582),
    [anon_sym_if] = ACTIONS(5582),
    [anon_sym_unless] = ACTIONS(5582),
    [anon_sym_while] = ACTIONS(5582),
    [anon_sym_until] = ACTIONS(5582),
    [anon_sym_rescue] = ACTIONS(5582),
    [anon_sym_do] = ACTIONS(5582),
    [anon_sym_when] = ACTIONS(5582),
    [anon_sym_elsif] = ACTIONS(5582),
    [anon_sym_else] = ACTIONS(5582),
    [anon_sym_then] = ACTIONS(5582),
    [anon_sym_ensure] = ACTIONS(5582),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON_COLON2] = ACTIONS(5582),
    [anon_sym_AMP_DOT] = ACTIONS(5582),
    [anon_sym_PLUS_EQ] = ACTIONS(5582),
    [anon_sym_DASH_EQ] = ACTIONS(5582),
    [anon_sym_STAR_EQ] = ACTIONS(5582),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5582),
    [anon_sym_SLASH_EQ] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5582),
    [anon_sym_PIPE_EQ] = ACTIONS(5582),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5582),
    [anon_sym_AMP_EQ] = ACTIONS(5582),
    [anon_sym_PERCENT_EQ] = ACTIONS(5582),
    [anon_sym_GT_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_LT_EQ] = ACTIONS(5582),
    [anon_sym_CARET_EQ] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5584),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_EQ_EQ] = ACTIONS(5584),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ_GT] = ACTIONS(5582),
    [anon_sym_EQ_TILDE] = ACTIONS(5582),
    [anon_sym_BANG_TILDE] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5584),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5584),
    [sym_comment] = ACTIONS(87),
  },
  [3703] = {
    [anon_sym_RBRACK] = ACTIONS(9588),
    [sym_comment] = ACTIONS(87),
  },
  [3704] = {
    [sym__line_break] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [ts_builtin_sym_end] = ACTIONS(5594),
    [anon_sym___END__] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_end] = ACTIONS(5594),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_when] = ACTIONS(5594),
    [anon_sym_elsif] = ACTIONS(5594),
    [anon_sym_else] = ACTIONS(5594),
    [anon_sym_then] = ACTIONS(5594),
    [anon_sym_ensure] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [3705] = {
    [sym__line_break] = ACTIONS(5666),
    [sym__heredoc_body_start] = ACTIONS(5666),
    [sym__binary_minus] = ACTIONS(5666),
    [sym__binary_star] = ACTIONS(5666),
    [ts_builtin_sym_end] = ACTIONS(5666),
    [anon_sym___END__] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_STAR_STAR] = ACTIONS(5668),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_EQ] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_end] = ACTIONS(5666),
    [anon_sym_if] = ACTIONS(5666),
    [anon_sym_unless] = ACTIONS(5666),
    [anon_sym_while] = ACTIONS(5666),
    [anon_sym_until] = ACTIONS(5666),
    [anon_sym_rescue] = ACTIONS(5666),
    [anon_sym_do] = ACTIONS(5666),
    [anon_sym_when] = ACTIONS(5666),
    [anon_sym_elsif] = ACTIONS(5666),
    [anon_sym_else] = ACTIONS(5666),
    [anon_sym_then] = ACTIONS(5666),
    [anon_sym_ensure] = ACTIONS(5666),
    [anon_sym_EQ_GT] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_COLON_COLON2] = ACTIONS(5666),
    [anon_sym_AMP_DOT] = ACTIONS(5666),
    [anon_sym_PLUS_EQ] = ACTIONS(5666),
    [anon_sym_DASH_EQ] = ACTIONS(5666),
    [anon_sym_STAR_EQ] = ACTIONS(5666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5666),
    [anon_sym_SLASH_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5666),
    [anon_sym_AMP_EQ] = ACTIONS(5666),
    [anon_sym_PERCENT_EQ] = ACTIONS(5666),
    [anon_sym_GT_GT_EQ] = ACTIONS(5666),
    [anon_sym_LT_LT_EQ] = ACTIONS(5666),
    [anon_sym_CARET_EQ] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_and] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_LT_LT] = ACTIONS(5668),
    [anon_sym_GT_GT] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_EQ_TILDE] = ACTIONS(5666),
    [anon_sym_BANG_TILDE] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_PLUS] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [sym_comment] = ACTIONS(87),
  },
  [3706] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [3707] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [3708] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [3709] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [3710] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [3711] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(9590),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [3712] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(5798),
    [anon_sym___END__] = ACTIONS(5798),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [3713] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [3714] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [3715] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [3716] = {
    [sym__line_break] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [ts_builtin_sym_end] = ACTIONS(5594),
    [anon_sym___END__] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_end] = ACTIONS(5594),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_when] = ACTIONS(5594),
    [anon_sym_elsif] = ACTIONS(5594),
    [anon_sym_else] = ACTIONS(5594),
    [anon_sym_then] = ACTIONS(5594),
    [anon_sym_ensure] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [3717] = {
    [sym__line_break] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__binary_star] = ACTIONS(3102),
    [ts_builtin_sym_end] = ACTIONS(3102),
    [anon_sym___END__] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(4854),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(4854),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_STAR_STAR] = ACTIONS(4854),
    [anon_sym_AMP] = ACTIONS(4854),
    [anon_sym_EQ] = ACTIONS(4854),
    [anon_sym_LT] = ACTIONS(4854),
    [anon_sym_end] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_unless] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_until] = ACTIONS(3102),
    [anon_sym_rescue] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_when] = ACTIONS(3102),
    [anon_sym_elsif] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_then] = ACTIONS(3102),
    [anon_sym_ensure] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_COLON_COLON2] = ACTIONS(3102),
    [anon_sym_AMP_DOT] = ACTIONS(3102),
    [anon_sym_PLUS_EQ] = ACTIONS(3102),
    [anon_sym_DASH_EQ] = ACTIONS(3102),
    [anon_sym_STAR_EQ] = ACTIONS(3102),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3102),
    [anon_sym_SLASH_EQ] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3102),
    [anon_sym_PIPE_EQ] = ACTIONS(3102),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3102),
    [anon_sym_AMP_EQ] = ACTIONS(3102),
    [anon_sym_PERCENT_EQ] = ACTIONS(3102),
    [anon_sym_GT_GT_EQ] = ACTIONS(3102),
    [anon_sym_LT_LT_EQ] = ACTIONS(3102),
    [anon_sym_CARET_EQ] = ACTIONS(3102),
    [anon_sym_QMARK] = ACTIONS(3102),
    [anon_sym_DOT_DOT] = ACTIONS(4854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_and] = ACTIONS(3102),
    [anon_sym_or] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(4854),
    [anon_sym_AMP_AMP] = ACTIONS(4854),
    [anon_sym_LT_LT] = ACTIONS(4854),
    [anon_sym_GT_GT] = ACTIONS(4854),
    [anon_sym_EQ_EQ] = ACTIONS(4854),
    [anon_sym_BANG_EQ] = ACTIONS(3102),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
    [anon_sym_LT_EQ_GT] = ACTIONS(3102),
    [anon_sym_EQ_TILDE] = ACTIONS(3102),
    [anon_sym_BANG_TILDE] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(4854),
    [anon_sym_GT] = ACTIONS(4854),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(4854),
    [anon_sym_PLUS] = ACTIONS(4854),
    [anon_sym_SLASH] = ACTIONS(4854),
    [anon_sym_PERCENT] = ACTIONS(4854),
    [sym_comment] = ACTIONS(87),
  },
  [3718] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(9592),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [3719] = {
    [sym_heredoc_body] = STATE(3719),
    [aux_sym_call_repeat1] = STATE(3719),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [ts_builtin_sym_end] = ACTIONS(7646),
    [anon_sym___END__] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [3720] = {
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [ts_builtin_sym_end] = ACTIONS(7657),
    [anon_sym___END__] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(7657),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_when] = ACTIONS(7657),
    [anon_sym_elsif] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [3721] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(423),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(423),
    [sym_operator_assignment] = STATE(423),
    [sym_conditional] = STATE(423),
    [sym_range] = STATE(423),
    [sym_binary] = STATE(423),
    [sym_unary] = STATE(423),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(432),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(763),
    [sym__splat_star] = ACTIONS(765),
    [sym__unary_minus] = ACTIONS(767),
    [sym__identifier_hash_key] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6032),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(811),
    [sym_identifier] = ACTIONS(811),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3722] = {
    [sym_heredoc_body] = STATE(3719),
    [aux_sym_call_repeat1] = STATE(3719),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [ts_builtin_sym_end] = ACTIONS(7661),
    [anon_sym___END__] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [3723] = {
    [aux_sym_argument_list_repeat1] = STATE(3723),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [ts_builtin_sym_end] = ACTIONS(7657),
    [anon_sym___END__] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(9597),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [3724] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(4970),
    [anon_sym___END__] = ACTIONS(4970),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [3725] = {
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6060),
    [anon_sym___END__] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_elsif] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [3726] = {
    [aux_sym_exceptions_repeat1] = STATE(6346),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6060),
    [anon_sym___END__] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [3727] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(6074),
    [anon_sym___END__] = ACTIONS(6074),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [3728] = {
    [sym_string] = STATE(3728),
    [aux_sym_chained_string_repeat1] = STATE(3728),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [ts_builtin_sym_end] = ACTIONS(6076),
    [anon_sym___END__] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [3729] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(4110),
    [anon_sym___END__] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(6042),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(6044),
    [anon_sym_DOT_DOT] = ACTIONS(6046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6048),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(6050),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6050),
    [anon_sym_LT_EQ_GT] = ACTIONS(6050),
    [anon_sym_EQ_TILDE] = ACTIONS(6050),
    [anon_sym_BANG_TILDE] = ACTIONS(6050),
    [anon_sym_LT_EQ] = ACTIONS(6042),
    [anon_sym_GT] = ACTIONS(6042),
    [anon_sym_GT_EQ] = ACTIONS(6056),
    [anon_sym_CARET] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [3730] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3731] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(935),
    [anon_sym___END__] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(6042),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6044),
    [anon_sym_DOT_DOT] = ACTIONS(6046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6048),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6050),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6050),
    [anon_sym_LT_EQ_GT] = ACTIONS(6050),
    [anon_sym_EQ_TILDE] = ACTIONS(6050),
    [anon_sym_BANG_TILDE] = ACTIONS(6050),
    [anon_sym_LT_EQ] = ACTIONS(6042),
    [anon_sym_GT] = ACTIONS(6042),
    [anon_sym_GT_EQ] = ACTIONS(6056),
    [anon_sym_CARET] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [3732] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6347),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6347),
    [sym_operator_assignment] = STATE(6347),
    [sym_conditional] = STATE(6347),
    [sym_range] = STATE(6347),
    [sym_binary] = STATE(6347),
    [sym_unary] = STATE(6347),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3733] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6348),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6348),
    [sym_operator_assignment] = STATE(6348),
    [sym_conditional] = STATE(6348),
    [sym_range] = STATE(6348),
    [sym_binary] = STATE(6348),
    [sym_unary] = STATE(6348),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3734] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6349),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6349),
    [sym_operator_assignment] = STATE(6349),
    [sym_conditional] = STATE(6349),
    [sym_range] = STATE(6349),
    [sym_binary] = STATE(6349),
    [sym_unary] = STATE(6349),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3735] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6350),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6350),
    [sym_operator_assignment] = STATE(6350),
    [sym_conditional] = STATE(6350),
    [sym_range] = STATE(6350),
    [sym_binary] = STATE(6350),
    [sym_unary] = STATE(6350),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3736] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6351),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6351),
    [sym_operator_assignment] = STATE(6351),
    [sym_conditional] = STATE(6351),
    [sym_range] = STATE(6351),
    [sym_binary] = STATE(6351),
    [sym_unary] = STATE(6351),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3737] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6352),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6352),
    [sym_operator_assignment] = STATE(6352),
    [sym_conditional] = STATE(6352),
    [sym_range] = STATE(6352),
    [sym_binary] = STATE(6352),
    [sym_unary] = STATE(6352),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3738] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6353),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6353),
    [sym_operator_assignment] = STATE(6353),
    [sym_conditional] = STATE(6353),
    [sym_range] = STATE(6353),
    [sym_binary] = STATE(6353),
    [sym_unary] = STATE(6353),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3739] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6354),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6354),
    [sym_operator_assignment] = STATE(6354),
    [sym_conditional] = STATE(6354),
    [sym_range] = STATE(6354),
    [sym_binary] = STATE(6354),
    [sym_unary] = STATE(6354),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3740] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6355),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6355),
    [sym_operator_assignment] = STATE(6355),
    [sym_conditional] = STATE(6355),
    [sym_range] = STATE(6355),
    [sym_binary] = STATE(6355),
    [sym_unary] = STATE(6355),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3741] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6356),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6356),
    [sym_operator_assignment] = STATE(6356),
    [sym_conditional] = STATE(6356),
    [sym_range] = STATE(6356),
    [sym_binary] = STATE(6356),
    [sym_unary] = STATE(6356),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3742] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1592),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(1592),
    [sym_operator_assignment] = STATE(1592),
    [sym_conditional] = STATE(1592),
    [sym_range] = STATE(1592),
    [sym_binary] = STATE(1592),
    [sym_unary] = STATE(1592),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2745),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3743] = {
    [aux_sym_exceptions_repeat1] = STATE(6358),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [ts_builtin_sym_end] = ACTIONS(9603),
    [anon_sym___END__] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(6064),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [3744] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1592),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_splat_argument] = STATE(6359),
    [sym_assignment] = STATE(1592),
    [sym_operator_assignment] = STATE(1592),
    [sym_conditional] = STATE(1592),
    [sym_range] = STATE(1592),
    [sym_binary] = STATE(1592),
    [sym_unary] = STATE(1592),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(6359),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2745),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3745] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6360),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(6360),
    [sym_operator_assignment] = STATE(6360),
    [sym_conditional] = STATE(6360),
    [sym_range] = STATE(6360),
    [sym_binary] = STATE(6360),
    [sym_unary] = STATE(6360),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3746] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6361),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(6361),
    [sym_operator_assignment] = STATE(6361),
    [sym_conditional] = STATE(6361),
    [sym_range] = STATE(6361),
    [sym_binary] = STATE(6361),
    [sym_unary] = STATE(6361),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3747] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(6362),
    [sym__argument] = STATE(6363),
    [sym_splat_argument] = STATE(6363),
    [sym_hash_splat_argument] = STATE(6363),
    [sym_block_argument] = STATE(6363),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6363),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3748] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(6362),
    [sym__argument] = STATE(6363),
    [sym_splat_argument] = STATE(6363),
    [sym_hash_splat_argument] = STATE(6363),
    [sym_block_argument] = STATE(6363),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6363),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3749] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(6362),
    [sym__argument] = STATE(6363),
    [sym_splat_argument] = STATE(6363),
    [sym_hash_splat_argument] = STATE(6363),
    [sym_block_argument] = STATE(6363),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6363),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3750] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(6362),
    [sym__argument] = STATE(6363),
    [sym_splat_argument] = STATE(6363),
    [sym_hash_splat_argument] = STATE(6363),
    [sym_block_argument] = STATE(6363),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6363),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3751] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6364),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(6364),
    [sym_operator_assignment] = STATE(6364),
    [sym_conditional] = STATE(6364),
    [sym_range] = STATE(6364),
    [sym_binary] = STATE(6364),
    [sym_unary] = STATE(6364),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3752] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3753] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(9617),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [3754] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(1827),
    [sym__argument_list_with_parens] = STATE(1663),
    [sym__argument] = STATE(1664),
    [sym_splat_argument] = STATE(1664),
    [sym_hash_splat_argument] = STATE(1664),
    [sym_block_argument] = STATE(1664),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1668),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1664),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2853),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2883),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3755] = {
    [anon_sym_EQ] = ACTIONS(9633),
    [sym_comment] = ACTIONS(87),
  },
  [3756] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9635),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9637),
    [anon_sym_DASH_EQ] = ACTIONS(9637),
    [anon_sym_STAR_EQ] = ACTIONS(9637),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9637),
    [anon_sym_SLASH_EQ] = ACTIONS(9637),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9637),
    [anon_sym_PIPE_EQ] = ACTIONS(9637),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9637),
    [anon_sym_AMP_EQ] = ACTIONS(9637),
    [anon_sym_PERCENT_EQ] = ACTIONS(9637),
    [anon_sym_GT_GT_EQ] = ACTIONS(9637),
    [anon_sym_LT_LT_EQ] = ACTIONS(9637),
    [anon_sym_CARET_EQ] = ACTIONS(9637),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3757] = {
    [sym_string] = STATE(6377),
    [aux_sym_chained_string_repeat1] = STATE(6377),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3758] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(9617),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [3759] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3760] = {
    [sym_string] = STATE(3798),
    [aux_sym_chained_string_repeat1] = STATE(3798),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3761] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6378),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(6378),
    [sym_operator_assignment] = STATE(6378),
    [sym_conditional] = STATE(6378),
    [sym_range] = STATE(6378),
    [sym_binary] = STATE(6378),
    [sym_unary] = STATE(6378),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3762] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(9617),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [3763] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6379),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6379),
    [sym_operator_assignment] = STATE(6379),
    [sym_conditional] = STATE(6379),
    [sym_range] = STATE(6379),
    [sym_binary] = STATE(6379),
    [sym_unary] = STATE(6379),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3764] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6380),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6380),
    [sym_operator_assignment] = STATE(6380),
    [sym_conditional] = STATE(6380),
    [sym_range] = STATE(6380),
    [sym_binary] = STATE(6380),
    [sym_unary] = STATE(6380),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3765] = {
    [anon_sym_COLON] = ACTIONS(9639),
    [sym_comment] = ACTIONS(87),
  },
  [3766] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6382),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6382),
    [sym_operator_assignment] = STATE(6382),
    [sym_conditional] = STATE(6382),
    [sym_range] = STATE(6382),
    [sym_binary] = STATE(6382),
    [sym_unary] = STATE(6382),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3767] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9641),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3768] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [3769] = {
    [sym_heredoc_body] = STATE(6384),
    [aux_sym_call_repeat1] = STATE(6384),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3770] = {
    [sym_heredoc_body] = STATE(6384),
    [aux_sym_call_repeat1] = STATE(6384),
    [aux_sym_argument_list_repeat1] = STATE(6386),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9643),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3771] = {
    [sym_string] = STATE(3798),
    [aux_sym_chained_string_repeat1] = STATE(3798),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9645),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3772] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [3773] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6387),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(6387),
    [sym_operator_assignment] = STATE(6387),
    [sym_conditional] = STATE(6387),
    [sym_range] = STATE(6387),
    [sym_binary] = STATE(6387),
    [sym_unary] = STATE(6387),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3774] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6388),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6388),
    [sym_operator_assignment] = STATE(6388),
    [sym_conditional] = STATE(6388),
    [sym_range] = STATE(6388),
    [sym_binary] = STATE(6388),
    [sym_unary] = STATE(6388),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3775] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6389),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6389),
    [sym_operator_assignment] = STATE(6389),
    [sym_conditional] = STATE(6389),
    [sym_range] = STATE(6389),
    [sym_binary] = STATE(6389),
    [sym_unary] = STATE(6389),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3776] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6390),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6390),
    [sym_operator_assignment] = STATE(6390),
    [sym_conditional] = STATE(6390),
    [sym_range] = STATE(6390),
    [sym_binary] = STATE(6390),
    [sym_unary] = STATE(6390),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3777] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6391),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6391),
    [sym_operator_assignment] = STATE(6391),
    [sym_conditional] = STATE(6391),
    [sym_range] = STATE(6391),
    [sym_binary] = STATE(6391),
    [sym_unary] = STATE(6391),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3778] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6392),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6392),
    [sym_operator_assignment] = STATE(6392),
    [sym_conditional] = STATE(6392),
    [sym_range] = STATE(6392),
    [sym_binary] = STATE(6392),
    [sym_unary] = STATE(6392),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3779] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6393),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6393),
    [sym_operator_assignment] = STATE(6393),
    [sym_conditional] = STATE(6393),
    [sym_range] = STATE(6393),
    [sym_binary] = STATE(6393),
    [sym_unary] = STATE(6393),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3780] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6394),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6394),
    [sym_operator_assignment] = STATE(6394),
    [sym_conditional] = STATE(6394),
    [sym_range] = STATE(6394),
    [sym_binary] = STATE(6394),
    [sym_unary] = STATE(6394),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3781] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6395),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6395),
    [sym_operator_assignment] = STATE(6395),
    [sym_conditional] = STATE(6395),
    [sym_range] = STATE(6395),
    [sym_binary] = STATE(6395),
    [sym_unary] = STATE(6395),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3782] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6396),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6396),
    [sym_operator_assignment] = STATE(6396),
    [sym_conditional] = STATE(6396),
    [sym_range] = STATE(6396),
    [sym_binary] = STATE(6396),
    [sym_unary] = STATE(6396),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3783] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6397),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6397),
    [sym_operator_assignment] = STATE(6397),
    [sym_conditional] = STATE(6397),
    [sym_range] = STATE(6397),
    [sym_binary] = STATE(6397),
    [sym_unary] = STATE(6397),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3784] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6398),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6398),
    [sym_operator_assignment] = STATE(6398),
    [sym_conditional] = STATE(6398),
    [sym_range] = STATE(6398),
    [sym_binary] = STATE(6398),
    [sym_unary] = STATE(6398),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3785] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6399),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6399),
    [sym_operator_assignment] = STATE(6399),
    [sym_conditional] = STATE(6399),
    [sym_range] = STATE(6399),
    [sym_binary] = STATE(6399),
    [sym_unary] = STATE(6399),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3786] = {
    [anon_sym_COLON] = ACTIONS(9647),
    [sym_comment] = ACTIONS(87),
  },
  [3787] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6401),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6401),
    [sym_operator_assignment] = STATE(6401),
    [sym_conditional] = STATE(6401),
    [sym_range] = STATE(6401),
    [sym_binary] = STATE(6401),
    [sym_unary] = STATE(6401),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3788] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9649),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [3789] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [3790] = {
    [sym_heredoc_body] = STATE(6403),
    [aux_sym_call_repeat1] = STATE(6403),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3791] = {
    [sym_heredoc_body] = STATE(6403),
    [aux_sym_call_repeat1] = STATE(6403),
    [aux_sym_argument_list_repeat1] = STATE(6405),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9651),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [3792] = {
    [sym_string] = STATE(3897),
    [aux_sym_chained_string_repeat1] = STATE(3897),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9653),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3793] = {
    [sym_heredoc_body] = STATE(6406),
    [aux_sym_call_repeat1] = STATE(6406),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [3794] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(6407),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9655),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3795] = {
    [sym_heredoc_body] = STATE(6408),
    [aux_sym_call_repeat1] = STATE(6408),
    [aux_sym_argument_list_repeat1] = STATE(6409),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(6153),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [3796] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6410),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_splat_argument] = STATE(6411),
    [sym_assignment] = STATE(6410),
    [sym_operator_assignment] = STATE(6410),
    [sym_conditional] = STATE(6410),
    [sym_range] = STATE(6410),
    [sym_binary] = STATE(6410),
    [sym_unary] = STATE(6410),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(6411),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(6111),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3797] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6412),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(6412),
    [sym_operator_assignment] = STATE(6412),
    [sym_conditional] = STATE(6412),
    [sym_range] = STATE(6412),
    [sym_binary] = STATE(6412),
    [sym_unary] = STATE(6412),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3798] = {
    [sym_string] = STATE(6413),
    [aux_sym_chained_string_repeat1] = STATE(6413),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [3799] = {
    [anon_sym_RBRACE] = ACTIONS(3540),
    [anon_sym_COMMA] = ACTIONS(3540),
    [anon_sym_if] = ACTIONS(3540),
    [anon_sym_unless] = ACTIONS(3540),
    [anon_sym_while] = ACTIONS(3540),
    [anon_sym_until] = ACTIONS(3540),
    [anon_sym_rescue] = ACTIONS(3540),
    [sym_comment] = ACTIONS(87),
  },
  [3800] = {
    [sym_operator] = STATE(6414),
    [sym__method_name] = STATE(6414),
    [sym_setter] = STATE(6414),
    [sym_symbol] = STATE(6414),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__symbol_start] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_STAR_STAR] = ACTIONS(2795),
    [anon_sym_AMP] = ACTIONS(2795),
    [anon_sym_LT] = ACTIONS(2797),
    [anon_sym_DOT_DOT] = ACTIONS(2795),
    [anon_sym_LT_LT] = ACTIONS(2795),
    [anon_sym_GT_GT] = ACTIONS(2795),
    [anon_sym_EQ_EQ] = ACTIONS(2797),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2795),
    [anon_sym_LT_EQ_GT] = ACTIONS(2795),
    [anon_sym_EQ_TILDE] = ACTIONS(2795),
    [anon_sym_BANG_TILDE] = ACTIONS(2795),
    [anon_sym_LT_EQ] = ACTIONS(2797),
    [anon_sym_GT] = ACTIONS(2797),
    [anon_sym_GT_EQ] = ACTIONS(2795),
    [anon_sym_CARET] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_SLASH] = ACTIONS(2795),
    [anon_sym_PERCENT] = ACTIONS(2795),
    [anon_sym_BANG] = ACTIONS(2797),
    [anon_sym_TILDE] = ACTIONS(2795),
    [sym_constant] = ACTIONS(9657),
    [sym_identifier] = ACTIONS(2801),
    [sym_instance_variable] = ACTIONS(9657),
    [sym_class_variable] = ACTIONS(9657),
    [sym_global_variable] = ACTIONS(9657),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_PLUS_AT] = ACTIONS(2795),
    [anon_sym_DASH_AT] = ACTIONS(2795),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2797),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2795),
    [anon_sym_BQUOTE] = ACTIONS(2795),
    [sym_comment] = ACTIONS(87),
  },
  [3801] = {
    [aux_sym_undef_repeat1] = STATE(6415),
    [anon_sym_RBRACE] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(6165),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [3802] = {
    [anon_sym_RBRACE] = ACTIONS(5360),
    [anon_sym_if] = ACTIONS(5360),
    [anon_sym_unless] = ACTIONS(5360),
    [anon_sym_while] = ACTIONS(5360),
    [anon_sym_until] = ACTIONS(5360),
    [anon_sym_rescue] = ACTIONS(5360),
    [sym_comment] = ACTIONS(87),
  },
  [3803] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3804] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5688),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3805] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3806] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5692),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3807] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3808] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3809] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [3810] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3811] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3812] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3813] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(9659),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [3814] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3815] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3816] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3817] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3818] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [3819] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(6418),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(6419),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(9661),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3820] = {
    [sym__simple_symbol] = ACTIONS(5806),
    [sym__string_start] = ACTIONS(5806),
    [sym__symbol_start] = ACTIONS(5806),
    [sym__subshell_start] = ACTIONS(5806),
    [sym__regex_start] = ACTIONS(5806),
    [sym__string_array_start] = ACTIONS(5806),
    [sym__symbol_array_start] = ACTIONS(5806),
    [sym_heredoc_beginning] = ACTIONS(5806),
    [sym__block_ampersand] = ACTIONS(5806),
    [sym__splat_star] = ACTIONS(5806),
    [sym__unary_minus] = ACTIONS(5806),
    [sym__binary_minus] = ACTIONS(5806),
    [sym__binary_star] = ACTIONS(5806),
    [sym__identifier_hash_key] = ACTIONS(5806),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_RBRACE] = ACTIONS(5806),
    [anon_sym_def] = ACTIONS(5808),
    [anon_sym_LPAREN] = ACTIONS(5808),
    [anon_sym_RPAREN] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_COLON_COLON] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_SEMI] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5808),
    [anon_sym_AMP] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_class] = ACTIONS(5808),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_module] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_yield] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_next] = ACTIONS(5808),
    [sym_redo] = ACTIONS(5808),
    [sym_retry] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_unless] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_until] = ACTIONS(5808),
    [anon_sym_rescue] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_begin] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_COLON_COLON2] = ACTIONS(5806),
    [anon_sym_AMP_DOT] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_PLUS_EQ] = ACTIONS(5806),
    [anon_sym_DASH_EQ] = ACTIONS(5806),
    [anon_sym_STAR_EQ] = ACTIONS(5806),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5806),
    [anon_sym_AMP_EQ] = ACTIONS(5806),
    [anon_sym_PERCENT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_LT_LT_EQ] = ACTIONS(5806),
    [anon_sym_CARET_EQ] = ACTIONS(5806),
    [anon_sym_QMARK] = ACTIONS(5808),
    [anon_sym_COLON2] = ACTIONS(5808),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_and] = ACTIONS(5808),
    [anon_sym_or] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_AMP_AMP] = ACTIONS(5808),
    [anon_sym_LT_LT] = ACTIONS(5808),
    [anon_sym_GT_GT] = ACTIONS(5808),
    [anon_sym_EQ_EQ] = ACTIONS(5808),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5806),
    [anon_sym_BANG_TILDE] = ACTIONS(5806),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_SLASH] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5808),
    [anon_sym_defined_QMARK] = ACTIONS(5806),
    [anon_sym_not] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_TILDE] = ACTIONS(5806),
    [sym_constant] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_instance_variable] = ACTIONS(5806),
    [sym_class_variable] = ACTIONS(5806),
    [sym_global_variable] = ACTIONS(5806),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5808),
    [sym_float] = ACTIONS(5808),
    [sym_complex] = ACTIONS(5806),
    [sym_super] = ACTIONS(5808),
    [anon_sym_true] = ACTIONS(5808),
    [anon_sym_TRUE] = ACTIONS(5808),
    [anon_sym_false] = ACTIONS(5808),
    [anon_sym_FALSE] = ACTIONS(5808),
    [sym_self] = ACTIONS(5808),
    [anon_sym_nil] = ACTIONS(5808),
    [anon_sym_NIL] = ACTIONS(5808),
    [sym_character] = ACTIONS(5806),
    [anon_sym_LBRACK2] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5806),
  },
  [3821] = {
    [sym__simple_symbol] = ACTIONS(5810),
    [sym__string_start] = ACTIONS(5810),
    [sym__symbol_start] = ACTIONS(5810),
    [sym__subshell_start] = ACTIONS(5810),
    [sym__regex_start] = ACTIONS(5810),
    [sym__string_array_start] = ACTIONS(5810),
    [sym__symbol_array_start] = ACTIONS(5810),
    [sym_heredoc_beginning] = ACTIONS(5810),
    [sym__block_ampersand] = ACTIONS(5810),
    [sym__splat_star] = ACTIONS(5810),
    [sym__unary_minus] = ACTIONS(5810),
    [sym__binary_minus] = ACTIONS(5810),
    [sym__binary_star] = ACTIONS(5810),
    [sym__identifier_hash_key] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [anon_sym_def] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(5812),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_COLON_COLON] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_PIPE] = ACTIONS(5812),
    [anon_sym_SEMI] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_STAR_STAR] = ACTIONS(5812),
    [anon_sym_AMP] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_class] = ACTIONS(5812),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_module] = ACTIONS(5812),
    [anon_sym_return] = ACTIONS(5812),
    [anon_sym_yield] = ACTIONS(5812),
    [anon_sym_break] = ACTIONS(5812),
    [anon_sym_next] = ACTIONS(5812),
    [sym_redo] = ACTIONS(5812),
    [sym_retry] = ACTIONS(5812),
    [anon_sym_if] = ACTIONS(5812),
    [anon_sym_unless] = ACTIONS(5812),
    [anon_sym_while] = ACTIONS(5812),
    [anon_sym_until] = ACTIONS(5812),
    [anon_sym_rescue] = ACTIONS(5812),
    [anon_sym_for] = ACTIONS(5812),
    [anon_sym_do] = ACTIONS(5812),
    [anon_sym_case] = ACTIONS(5812),
    [anon_sym_begin] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_COLON_COLON2] = ACTIONS(5810),
    [anon_sym_AMP_DOT] = ACTIONS(5810),
    [anon_sym_LPAREN2] = ACTIONS(5810),
    [anon_sym_PLUS_EQ] = ACTIONS(5810),
    [anon_sym_DASH_EQ] = ACTIONS(5810),
    [anon_sym_STAR_EQ] = ACTIONS(5810),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5810),
    [anon_sym_AMP_EQ] = ACTIONS(5810),
    [anon_sym_PERCENT_EQ] = ACTIONS(5810),
    [anon_sym_GT_GT_EQ] = ACTIONS(5810),
    [anon_sym_LT_LT_EQ] = ACTIONS(5810),
    [anon_sym_CARET_EQ] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5812),
    [anon_sym_COLON2] = ACTIONS(5812),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(5812),
    [anon_sym_or] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_GT_GT] = ACTIONS(5812),
    [anon_sym_EQ_EQ] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5810),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_EQ_TILDE] = ACTIONS(5810),
    [anon_sym_BANG_TILDE] = ACTIONS(5810),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_GT] = ACTIONS(5812),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5812),
    [anon_sym_PLUS] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5812),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_defined_QMARK] = ACTIONS(5810),
    [anon_sym_not] = ACTIONS(5812),
    [anon_sym_BANG] = ACTIONS(5812),
    [anon_sym_TILDE] = ACTIONS(5810),
    [sym_constant] = ACTIONS(5812),
    [sym_identifier] = ACTIONS(5812),
    [sym_instance_variable] = ACTIONS(5810),
    [sym_class_variable] = ACTIONS(5810),
    [sym_global_variable] = ACTIONS(5810),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5812),
    [sym_float] = ACTIONS(5812),
    [sym_complex] = ACTIONS(5810),
    [sym_super] = ACTIONS(5812),
    [anon_sym_true] = ACTIONS(5812),
    [anon_sym_TRUE] = ACTIONS(5812),
    [anon_sym_false] = ACTIONS(5812),
    [anon_sym_FALSE] = ACTIONS(5812),
    [sym_self] = ACTIONS(5812),
    [anon_sym_nil] = ACTIONS(5812),
    [anon_sym_NIL] = ACTIONS(5812),
    [sym_character] = ACTIONS(5810),
    [anon_sym_LBRACK2] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5810),
  },
  [3822] = {
    [sym_argument_list_with_parens] = STATE(6420),
    [sym__argument_list_with_parens] = STATE(3821),
    [sym_operator] = STATE(6420),
    [sym_heredoc_body] = STATE(3546),
    [aux_sym_call_repeat1] = STATE(3546),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(6173),
    [anon_sym_STAR] = ACTIONS(6175),
    [anon_sym_STAR_STAR] = ACTIONS(6173),
    [anon_sym_AMP] = ACTIONS(6173),
    [anon_sym_LT] = ACTIONS(6175),
    [anon_sym_LPAREN2] = ACTIONS(6177),
    [anon_sym_DOT_DOT] = ACTIONS(6173),
    [anon_sym_LT_LT] = ACTIONS(6173),
    [anon_sym_GT_GT] = ACTIONS(6173),
    [anon_sym_EQ_EQ] = ACTIONS(6175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6173),
    [anon_sym_LT_EQ_GT] = ACTIONS(6173),
    [anon_sym_EQ_TILDE] = ACTIONS(6173),
    [anon_sym_BANG_TILDE] = ACTIONS(6173),
    [anon_sym_LT_EQ] = ACTIONS(6175),
    [anon_sym_GT] = ACTIONS(6175),
    [anon_sym_GT_EQ] = ACTIONS(6173),
    [anon_sym_CARET] = ACTIONS(6173),
    [anon_sym_PLUS] = ACTIONS(6175),
    [anon_sym_SLASH] = ACTIONS(6173),
    [anon_sym_PERCENT] = ACTIONS(6173),
    [anon_sym_BANG] = ACTIONS(6175),
    [anon_sym_TILDE] = ACTIONS(6173),
    [sym_constant] = ACTIONS(9663),
    [sym_identifier] = ACTIONS(9663),
    [anon_sym_DASH] = ACTIONS(6175),
    [anon_sym_PLUS_AT] = ACTIONS(6173),
    [anon_sym_DASH_AT] = ACTIONS(6173),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6175),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6173),
    [anon_sym_BQUOTE] = ACTIONS(6173),
    [sym_comment] = ACTIONS(87),
  },
  [3823] = {
    [sym__binary_minus] = ACTIONS(5816),
    [sym__binary_star] = ACTIONS(5816),
    [anon_sym_LBRACE] = ACTIONS(5816),
    [anon_sym_RBRACE] = ACTIONS(5816),
    [anon_sym_RPAREN] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5816),
    [anon_sym_PIPE] = ACTIONS(5818),
    [anon_sym_SEMI] = ACTIONS(5816),
    [anon_sym_STAR_STAR] = ACTIONS(5818),
    [anon_sym_AMP] = ACTIONS(5818),
    [anon_sym_EQ] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5818),
    [anon_sym_if] = ACTIONS(5816),
    [anon_sym_unless] = ACTIONS(5816),
    [anon_sym_while] = ACTIONS(5816),
    [anon_sym_until] = ACTIONS(5816),
    [anon_sym_rescue] = ACTIONS(5816),
    [anon_sym_do] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_COLON_COLON2] = ACTIONS(5816),
    [anon_sym_AMP_DOT] = ACTIONS(5816),
    [anon_sym_PLUS_EQ] = ACTIONS(5816),
    [anon_sym_DASH_EQ] = ACTIONS(5816),
    [anon_sym_STAR_EQ] = ACTIONS(5816),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5816),
    [anon_sym_SLASH_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5816),
    [anon_sym_AMP_EQ] = ACTIONS(5816),
    [anon_sym_PERCENT_EQ] = ACTIONS(5816),
    [anon_sym_GT_GT_EQ] = ACTIONS(5816),
    [anon_sym_LT_LT_EQ] = ACTIONS(5816),
    [anon_sym_CARET_EQ] = ACTIONS(5816),
    [anon_sym_QMARK] = ACTIONS(5816),
    [anon_sym_COLON2] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5816),
    [anon_sym_and] = ACTIONS(5816),
    [anon_sym_or] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_AMP_AMP] = ACTIONS(5818),
    [anon_sym_LT_LT] = ACTIONS(5818),
    [anon_sym_GT_GT] = ACTIONS(5818),
    [anon_sym_EQ_EQ] = ACTIONS(5818),
    [anon_sym_BANG_EQ] = ACTIONS(5816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5816),
    [anon_sym_LT_EQ_GT] = ACTIONS(5816),
    [anon_sym_EQ_TILDE] = ACTIONS(5816),
    [anon_sym_BANG_TILDE] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5818),
    [anon_sym_GT] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5816),
    [anon_sym_CARET] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5818),
    [anon_sym_SLASH] = ACTIONS(5818),
    [anon_sym_PERCENT] = ACTIONS(5818),
    [sym_comment] = ACTIONS(87),
  },
  [3824] = {
    [sym_heredoc_body] = STATE(6422),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(9665),
    [sym_comment] = ACTIONS(87),
  },
  [3825] = {
    [anon_sym_RBRACK] = ACTIONS(9665),
    [sym_comment] = ACTIONS(87),
  },
  [3826] = {
    [sym__simple_symbol] = ACTIONS(5822),
    [sym__string_start] = ACTIONS(5822),
    [sym__symbol_start] = ACTIONS(5822),
    [sym__subshell_start] = ACTIONS(5822),
    [sym__regex_start] = ACTIONS(5822),
    [sym__string_array_start] = ACTIONS(5822),
    [sym__symbol_array_start] = ACTIONS(5822),
    [sym_heredoc_beginning] = ACTIONS(5822),
    [sym__block_ampersand] = ACTIONS(5822),
    [sym__splat_star] = ACTIONS(5822),
    [sym__unary_minus] = ACTIONS(5822),
    [sym__binary_minus] = ACTIONS(5822),
    [sym__binary_star] = ACTIONS(5822),
    [sym__identifier_hash_key] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_def] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COLON_COLON] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_STAR_STAR] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_class] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_module] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(5824),
    [anon_sym_break] = ACTIONS(5824),
    [anon_sym_next] = ACTIONS(5824),
    [sym_redo] = ACTIONS(5824),
    [sym_retry] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5824),
    [anon_sym_unless] = ACTIONS(5824),
    [anon_sym_while] = ACTIONS(5824),
    [anon_sym_until] = ACTIONS(5824),
    [anon_sym_rescue] = ACTIONS(5824),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_do] = ACTIONS(5824),
    [anon_sym_case] = ACTIONS(5824),
    [anon_sym_begin] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_LPAREN2] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [anon_sym_DASH_EQ] = ACTIONS(5822),
    [anon_sym_STAR_EQ] = ACTIONS(5822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5822),
    [anon_sym_AMP_EQ] = ACTIONS(5822),
    [anon_sym_PERCENT_EQ] = ACTIONS(5822),
    [anon_sym_GT_GT_EQ] = ACTIONS(5822),
    [anon_sym_LT_LT_EQ] = ACTIONS(5822),
    [anon_sym_CARET_EQ] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5824),
    [anon_sym_COLON2] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5824),
    [anon_sym_or] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [anon_sym_defined_QMARK] = ACTIONS(5822),
    [anon_sym_not] = ACTIONS(5824),
    [anon_sym_BANG] = ACTIONS(5824),
    [anon_sym_TILDE] = ACTIONS(5822),
    [sym_constant] = ACTIONS(5824),
    [sym_identifier] = ACTIONS(5824),
    [sym_instance_variable] = ACTIONS(5822),
    [sym_class_variable] = ACTIONS(5822),
    [sym_global_variable] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5824),
    [sym_float] = ACTIONS(5824),
    [sym_complex] = ACTIONS(5822),
    [sym_super] = ACTIONS(5824),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_TRUE] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [anon_sym_FALSE] = ACTIONS(5824),
    [sym_self] = ACTIONS(5824),
    [anon_sym_nil] = ACTIONS(5824),
    [anon_sym_NIL] = ACTIONS(5824),
    [sym_character] = ACTIONS(5822),
    [anon_sym_LBRACK2] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5822),
  },
  [3827] = {
    [sym__heredoc_body_start] = ACTIONS(101),
    [sym__binary_minus] = ACTIONS(101),
    [sym__binary_star] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [3828] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(6424),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(9667),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [3829] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(6426),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(9669),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [3830] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(6428),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(9671),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [3831] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(6430),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(9673),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [3832] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(6433),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9675),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9677),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [3833] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(6436),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9679),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9681),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [3834] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6437),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(6437),
    [sym_operator_assignment] = STATE(6437),
    [sym_conditional] = STATE(6437),
    [sym_range] = STATE(6437),
    [sym_binary] = STATE(6437),
    [sym_unary] = STATE(6437),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3835] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(113),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(113),
    [sym_operator_assignment] = STATE(113),
    [sym_conditional] = STATE(113),
    [sym_range] = STATE(113),
    [sym_binary] = STATE(113),
    [sym_unary] = STATE(113),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(119),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_heredoc_body] = STATE(6439),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym__hash_items] = STATE(6440),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(9683),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3836] = {
    [sym__method_rest] = STATE(6442),
    [sym__variable] = STATE(6443),
    [sym_operator] = STATE(6444),
    [sym__method_name] = STATE(6444),
    [sym_setter] = STATE(6444),
    [sym_symbol] = STATE(6444),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(9685),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(9687),
    [sym_self] = ACTIONS(9687),
  },
  [3837] = {
    [sym__statements] = STATE(6446),
    [sym__top_level_statement] = STATE(144),
    [sym_begin_block] = STATE(144),
    [sym_end_block] = STATE(144),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(149),
    [sym__simple_mlhs] = STATE(150),
    [sym_destructured_left_assignment] = STATE(150),
    [sym_rest_assignment] = STATE(150),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(9689),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3838] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(6449),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle] = ACTIONS(9691),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(9693),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [3839] = {
    [sym_method] = STATE(191),
    [sym_singleton_method] = STATE(191),
    [sym_class] = STATE(191),
    [sym_singleton_class] = STATE(191),
    [sym_module] = STATE(191),
    [sym_return] = STATE(191),
    [sym_yield] = STATE(191),
    [sym_break] = STATE(191),
    [sym_next] = STATE(191),
    [sym_while] = STATE(191),
    [sym_until] = STATE(191),
    [sym_for] = STATE(191),
    [sym_case] = STATE(191),
    [sym_if] = STATE(191),
    [sym_unless] = STATE(191),
    [sym_begin] = STATE(191),
    [sym__primary] = STATE(191),
    [sym_parenthesized_statements] = STATE(191),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(6451),
    [sym_call] = STATE(193),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(193),
    [sym_rational] = STATE(191),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(191),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(191),
    [sym_string_array] = STATE(191),
    [sym_symbol_array] = STATE(191),
    [sym_symbol] = STATE(191),
    [sym_regex] = STATE(191),
    [sym_array] = STATE(191),
    [sym_hash] = STATE(191),
    [sym_lambda] = STATE(191),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(9695),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [3840] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(6452),
    [sym__argument_list_with_parens] = STATE(1663),
    [sym__argument] = STATE(1664),
    [sym_splat_argument] = STATE(1664),
    [sym_hash_splat_argument] = STATE(1664),
    [sym_block_argument] = STATE(1664),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1668),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1664),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2853),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2883),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3841] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(6453),
    [sym__argument_list_with_parens] = STATE(1663),
    [sym__argument] = STATE(1664),
    [sym_splat_argument] = STATE(1664),
    [sym_hash_splat_argument] = STATE(1664),
    [sym_block_argument] = STATE(1664),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1668),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1664),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2853),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2883),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3842] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(6454),
    [sym__argument_list_with_parens] = STATE(1663),
    [sym__argument] = STATE(1664),
    [sym_splat_argument] = STATE(1664),
    [sym_hash_splat_argument] = STATE(1664),
    [sym_block_argument] = STATE(1664),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1668),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1664),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2853),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2883),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3843] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(6455),
    [sym__argument_list_with_parens] = STATE(1663),
    [sym__argument] = STATE(1664),
    [sym_splat_argument] = STATE(1664),
    [sym_hash_splat_argument] = STATE(1664),
    [sym_block_argument] = STATE(1664),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1668),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1664),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2853),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2883),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3844] = {
    [sym__statement] = STATE(6456),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(6456),
    [sym_unless_modifier] = STATE(6456),
    [sym_while_modifier] = STATE(6456),
    [sym_until_modifier] = STATE(6456),
    [sym_rescue_modifier] = STATE(6456),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(6456),
    [sym_alias] = STATE(6456),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(6456),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3845] = {
    [sym__statement] = STATE(6457),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(6457),
    [sym_unless_modifier] = STATE(6457),
    [sym_while_modifier] = STATE(6457),
    [sym_until_modifier] = STATE(6457),
    [sym_rescue_modifier] = STATE(6457),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(234),
    [sym_operator_assignment] = STATE(234),
    [sym_conditional] = STATE(234),
    [sym_range] = STATE(234),
    [sym_binary] = STATE(234),
    [sym_unary] = STATE(234),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_undef] = STATE(6457),
    [sym_alias] = STATE(6457),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(6457),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3846] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6458),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(6458),
    [sym_operator_assignment] = STATE(6458),
    [sym_conditional] = STATE(6458),
    [sym_range] = STATE(6458),
    [sym_binary] = STATE(6458),
    [sym_unary] = STATE(6458),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3847] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6459),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(6459),
    [sym_operator_assignment] = STATE(6459),
    [sym_conditional] = STATE(6459),
    [sym_range] = STATE(6459),
    [sym_binary] = STATE(6459),
    [sym_unary] = STATE(6459),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3848] = {
    [sym_method] = STATE(184),
    [sym_singleton_method] = STATE(184),
    [sym_class] = STATE(184),
    [sym_singleton_class] = STATE(184),
    [sym_module] = STATE(184),
    [sym_return] = STATE(184),
    [sym_yield] = STATE(184),
    [sym_break] = STATE(184),
    [sym_next] = STATE(184),
    [sym_while] = STATE(184),
    [sym_until] = STATE(184),
    [sym_for] = STATE(184),
    [sym_case] = STATE(184),
    [sym_if] = STATE(184),
    [sym_unless] = STATE(184),
    [sym_begin] = STATE(184),
    [sym__primary] = STATE(184),
    [sym_parenthesized_statements] = STATE(184),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(255),
    [sym_call] = STATE(255),
    [sym_method_call] = STATE(258),
    [sym__mlhs] = STATE(6460),
    [sym__simple_mlhs] = STATE(257),
    [sym_destructured_left_assignment] = STATE(257),
    [sym_rest_assignment] = STATE(257),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(255),
    [sym_rational] = STATE(184),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(184),
    [sym_string] = STATE(187),
    [sym_subshell] = STATE(184),
    [sym_string_array] = STATE(184),
    [sym_symbol_array] = STATE(184),
    [sym_symbol] = STATE(184),
    [sym_regex] = STATE(184),
    [sym_array] = STATE(184),
    [sym_hash] = STATE(184),
    [sym_lambda] = STATE(184),
    [sym__simple_symbol] = ACTIONS(277),
    [sym__string_start] = ACTIONS(279),
    [sym__symbol_start] = ACTIONS(281),
    [sym__subshell_start] = ACTIONS(283),
    [sym__regex_start] = ACTIONS(285),
    [sym__string_array_start] = ACTIONS(287),
    [sym__symbol_array_start] = ACTIONS(289),
    [sym_heredoc_beginning] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [3849] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6461),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(6461),
    [sym_operator_assignment] = STATE(6461),
    [sym_conditional] = STATE(6461),
    [sym_range] = STATE(6461),
    [sym_binary] = STATE(6461),
    [sym_unary] = STATE(6461),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6462),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__terminator] = STATE(6462),
    [sym__line_break] = ACTIONS(9697),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(9697),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3850] = {
    [sym__statements] = STATE(6463),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(6464),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(6465),
    [sym_rescue] = STATE(6466),
    [sym__body_statement] = STATE(6467),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6468),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__terminator] = STATE(6468),
    [sym__line_break] = ACTIONS(9699),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9701),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3851] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6469),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(6469),
    [sym_operator_assignment] = STATE(6469),
    [sym_conditional] = STATE(6469),
    [sym_range] = STATE(6469),
    [sym_binary] = STATE(6469),
    [sym_unary] = STATE(6469),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3852] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6470),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(6470),
    [sym_operator_assignment] = STATE(6470),
    [sym_conditional] = STATE(6470),
    [sym_range] = STATE(6470),
    [sym_binary] = STATE(6470),
    [sym_unary] = STATE(6470),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3853] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(9703),
  },
  [3854] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(6473),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(6474),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(9705),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3855] = {
    [sym_lambda_parameters] = STATE(6475),
    [sym__simple_formal_parameter] = STATE(364),
    [sym_splat_parameter] = STATE(364),
    [sym_hash_splat_parameter] = STATE(364),
    [sym_block_parameter] = STATE(364),
    [sym_keyword_parameter] = STATE(364),
    [sym_optional_parameter] = STATE(364),
    [sym_do_block] = STATE(6476),
    [sym_block] = STATE(6476),
    [anon_sym_LBRACE] = ACTIONS(6709),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(3204),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [3856] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(9719),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [3857] = {
    [sym__heredoc_body_start] = ACTIONS(733),
    [sym__binary_minus] = ACTIONS(733),
    [sym__binary_star] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_COMMA] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(737),
    [anon_sym_EQ] = ACTIONS(737),
    [anon_sym_LT] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_unless] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_until] = ACTIONS(733),
    [anon_sym_rescue] = ACTIONS(733),
    [anon_sym_in] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_LBRACK] = ACTIONS(3180),
    [anon_sym_RBRACK] = ACTIONS(733),
    [anon_sym_COLON_COLON2] = ACTIONS(3182),
    [anon_sym_AMP_DOT] = ACTIONS(3184),
    [anon_sym_PLUS_EQ] = ACTIONS(733),
    [anon_sym_DASH_EQ] = ACTIONS(733),
    [anon_sym_STAR_EQ] = ACTIONS(733),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(733),
    [anon_sym_SLASH_EQ] = ACTIONS(733),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(733),
    [anon_sym_PIPE_EQ] = ACTIONS(733),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(733),
    [anon_sym_AMP_EQ] = ACTIONS(733),
    [anon_sym_PERCENT_EQ] = ACTIONS(733),
    [anon_sym_GT_GT_EQ] = ACTIONS(733),
    [anon_sym_LT_LT_EQ] = ACTIONS(733),
    [anon_sym_CARET_EQ] = ACTIONS(733),
    [anon_sym_QMARK] = ACTIONS(733),
    [anon_sym_COLON2] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(733),
    [anon_sym_and] = ACTIONS(733),
    [anon_sym_or] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(737),
    [anon_sym_BANG_EQ] = ACTIONS(733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(733),
    [anon_sym_LT_EQ_GT] = ACTIONS(733),
    [anon_sym_EQ_TILDE] = ACTIONS(733),
    [anon_sym_BANG_TILDE] = ACTIONS(733),
    [anon_sym_LT_EQ] = ACTIONS(737),
    [anon_sym_GT] = ACTIONS(737),
    [anon_sym_GT_EQ] = ACTIONS(733),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_comment] = ACTIONS(87),
  },
  [3858] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_argument_list] = STATE(4737),
    [sym__argument_list_with_parens] = STATE(1663),
    [sym__argument] = STATE(1664),
    [sym_splat_argument] = STATE(1664),
    [sym_hash_splat_argument] = STATE(1664),
    [sym_block_argument] = STATE(1664),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1668),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1664),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2853),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(7471),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2883),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3859] = {
    [anon_sym_EQ] = ACTIONS(9735),
    [sym_comment] = ACTIONS(87),
  },
  [3860] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9737),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9739),
    [anon_sym_DASH_EQ] = ACTIONS(9739),
    [anon_sym_STAR_EQ] = ACTIONS(9739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9739),
    [anon_sym_SLASH_EQ] = ACTIONS(9739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9739),
    [anon_sym_PIPE_EQ] = ACTIONS(9739),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9739),
    [anon_sym_AMP_EQ] = ACTIONS(9739),
    [anon_sym_PERCENT_EQ] = ACTIONS(9739),
    [anon_sym_GT_GT_EQ] = ACTIONS(9739),
    [anon_sym_LT_LT_EQ] = ACTIONS(9739),
    [anon_sym_CARET_EQ] = ACTIONS(9739),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3861] = {
    [sym_string] = STATE(6489),
    [aux_sym_chained_string_repeat1] = STATE(6489),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3862] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(9719),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [3863] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3864] = {
    [sym_string] = STATE(3897),
    [aux_sym_chained_string_repeat1] = STATE(3897),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3865] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6490),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(6490),
    [sym_operator_assignment] = STATE(6490),
    [sym_conditional] = STATE(6490),
    [sym_range] = STATE(6490),
    [sym_binary] = STATE(6490),
    [sym_unary] = STATE(6490),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3866] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_COLON2] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [3867] = {
    [anon_sym_RBRACE] = ACTIONS(9741),
    [sym_comment] = ACTIONS(87),
  },
  [3868] = {
    [sym__statements] = STATE(6492),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9741),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3869] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(9719),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [3870] = {
    [sym__binary_minus] = ACTIONS(5630),
    [sym__binary_star] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5630),
    [anon_sym_RPAREN] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_STAR_STAR] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5632),
    [anon_sym_if] = ACTIONS(5630),
    [anon_sym_unless] = ACTIONS(5630),
    [anon_sym_while] = ACTIONS(5630),
    [anon_sym_until] = ACTIONS(5630),
    [anon_sym_rescue] = ACTIONS(5630),
    [anon_sym_do] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [anon_sym_PLUS_EQ] = ACTIONS(5630),
    [anon_sym_DASH_EQ] = ACTIONS(5630),
    [anon_sym_STAR_EQ] = ACTIONS(5630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5630),
    [anon_sym_SLASH_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5630),
    [anon_sym_AMP_EQ] = ACTIONS(5630),
    [anon_sym_PERCENT_EQ] = ACTIONS(5630),
    [anon_sym_GT_GT_EQ] = ACTIONS(5630),
    [anon_sym_LT_LT_EQ] = ACTIONS(5630),
    [anon_sym_CARET_EQ] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_COLON2] = ACTIONS(5632),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5632),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5630),
    [anon_sym_EQ_TILDE] = ACTIONS(5630),
    [anon_sym_BANG_TILDE] = ACTIONS(5630),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5632),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [sym_comment] = ACTIONS(87),
  },
  [3871] = {
    [anon_sym_end] = ACTIONS(9743),
    [sym_comment] = ACTIONS(87),
  },
  [3872] = {
    [sym__statements] = STATE(6494),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6495),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(6495),
    [sym__line_break] = ACTIONS(9745),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9747),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3873] = {
    [sym__statements] = STATE(6494),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(6496),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9747),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3874] = {
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR_STAR] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4148),
    [anon_sym_unless] = ACTIONS(4148),
    [anon_sym_while] = ACTIONS(4148),
    [anon_sym_until] = ACTIONS(4148),
    [anon_sym_rescue] = ACTIONS(4148),
    [anon_sym_in] = ACTIONS(4148),
    [anon_sym_do] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_COLON2] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [sym_comment] = ACTIONS(87),
  },
  [3875] = {
    [sym_heredoc_body] = STATE(6498),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(9749),
    [sym_comment] = ACTIONS(87),
  },
  [3876] = {
    [anon_sym_RPAREN] = ACTIONS(9749),
    [sym_comment] = ACTIONS(87),
  },
  [3877] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [3878] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6499),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(6499),
    [sym_operator_assignment] = STATE(6499),
    [sym_conditional] = STATE(6499),
    [sym_range] = STATE(6499),
    [sym_binary] = STATE(6499),
    [sym_unary] = STATE(6499),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [3879] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6500),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6500),
    [sym_operator_assignment] = STATE(6500),
    [sym_conditional] = STATE(6500),
    [sym_range] = STATE(6500),
    [sym_binary] = STATE(6500),
    [sym_unary] = STATE(6500),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3880] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6501),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6501),
    [sym_operator_assignment] = STATE(6501),
    [sym_conditional] = STATE(6501),
    [sym_range] = STATE(6501),
    [sym_binary] = STATE(6501),
    [sym_unary] = STATE(6501),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3881] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6502),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6502),
    [sym_operator_assignment] = STATE(6502),
    [sym_conditional] = STATE(6502),
    [sym_range] = STATE(6502),
    [sym_binary] = STATE(6502),
    [sym_unary] = STATE(6502),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3882] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6503),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6503),
    [sym_operator_assignment] = STATE(6503),
    [sym_conditional] = STATE(6503),
    [sym_range] = STATE(6503),
    [sym_binary] = STATE(6503),
    [sym_unary] = STATE(6503),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3883] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6504),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6504),
    [sym_operator_assignment] = STATE(6504),
    [sym_conditional] = STATE(6504),
    [sym_range] = STATE(6504),
    [sym_binary] = STATE(6504),
    [sym_unary] = STATE(6504),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3884] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6505),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6505),
    [sym_operator_assignment] = STATE(6505),
    [sym_conditional] = STATE(6505),
    [sym_range] = STATE(6505),
    [sym_binary] = STATE(6505),
    [sym_unary] = STATE(6505),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3885] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6506),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6506),
    [sym_operator_assignment] = STATE(6506),
    [sym_conditional] = STATE(6506),
    [sym_range] = STATE(6506),
    [sym_binary] = STATE(6506),
    [sym_unary] = STATE(6506),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3886] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6507),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6507),
    [sym_operator_assignment] = STATE(6507),
    [sym_conditional] = STATE(6507),
    [sym_range] = STATE(6507),
    [sym_binary] = STATE(6507),
    [sym_unary] = STATE(6507),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3887] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6508),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6508),
    [sym_operator_assignment] = STATE(6508),
    [sym_conditional] = STATE(6508),
    [sym_range] = STATE(6508),
    [sym_binary] = STATE(6508),
    [sym_unary] = STATE(6508),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3888] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6509),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6509),
    [sym_operator_assignment] = STATE(6509),
    [sym_conditional] = STATE(6509),
    [sym_range] = STATE(6509),
    [sym_binary] = STATE(6509),
    [sym_unary] = STATE(6509),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3889] = {
    [sym__statements] = STATE(3867),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(3868),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9751),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3890] = {
    [sym__binary_minus] = ACTIONS(6024),
    [sym__binary_star] = ACTIONS(6024),
    [anon_sym_LBRACE] = ACTIONS(6024),
    [anon_sym_RBRACE] = ACTIONS(6024),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_DOT] = ACTIONS(6026),
    [anon_sym_COMMA] = ACTIONS(6024),
    [anon_sym_PIPE] = ACTIONS(6026),
    [anon_sym_SEMI] = ACTIONS(6024),
    [anon_sym_STAR_STAR] = ACTIONS(6026),
    [anon_sym_AMP] = ACTIONS(6026),
    [anon_sym_EQ] = ACTIONS(6026),
    [anon_sym_LT] = ACTIONS(6026),
    [anon_sym_if] = ACTIONS(6024),
    [anon_sym_unless] = ACTIONS(6024),
    [anon_sym_while] = ACTIONS(6024),
    [anon_sym_until] = ACTIONS(6024),
    [anon_sym_rescue] = ACTIONS(6024),
    [anon_sym_do] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_COLON_COLON2] = ACTIONS(6024),
    [anon_sym_AMP_DOT] = ACTIONS(6024),
    [anon_sym_PLUS_EQ] = ACTIONS(6024),
    [anon_sym_DASH_EQ] = ACTIONS(6024),
    [anon_sym_STAR_EQ] = ACTIONS(6024),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6024),
    [anon_sym_SLASH_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6024),
    [anon_sym_AMP_EQ] = ACTIONS(6024),
    [anon_sym_PERCENT_EQ] = ACTIONS(6024),
    [anon_sym_GT_GT_EQ] = ACTIONS(6024),
    [anon_sym_LT_LT_EQ] = ACTIONS(6024),
    [anon_sym_CARET_EQ] = ACTIONS(6024),
    [anon_sym_QMARK] = ACTIONS(6024),
    [anon_sym_COLON2] = ACTIONS(6026),
    [anon_sym_DOT_DOT] = ACTIONS(6026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_or] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(6026),
    [anon_sym_LT_LT] = ACTIONS(6026),
    [anon_sym_GT_GT] = ACTIONS(6026),
    [anon_sym_EQ_EQ] = ACTIONS(6026),
    [anon_sym_BANG_EQ] = ACTIONS(6024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6024),
    [anon_sym_LT_EQ_GT] = ACTIONS(6024),
    [anon_sym_EQ_TILDE] = ACTIONS(6024),
    [anon_sym_BANG_TILDE] = ACTIONS(6024),
    [anon_sym_LT_EQ] = ACTIONS(6026),
    [anon_sym_GT] = ACTIONS(6026),
    [anon_sym_GT_EQ] = ACTIONS(6024),
    [anon_sym_CARET] = ACTIONS(6026),
    [anon_sym_PLUS] = ACTIONS(6026),
    [anon_sym_SLASH] = ACTIONS(6026),
    [anon_sym_PERCENT] = ACTIONS(6026),
    [sym_comment] = ACTIONS(87),
  },
  [3891] = {
    [sym_interpolation] = STATE(6512),
    [aux_sym_heredoc_body_repeat1] = STATE(6512),
    [sym__heredoc_content] = ACTIONS(9753),
    [sym_heredoc_end] = ACTIONS(9755),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(9753),
  },
  [3892] = {
    [sym_heredoc_body] = STATE(6513),
    [aux_sym_call_repeat1] = STATE(6513),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [3893] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym__argument] = STATE(6514),
    [sym_splat_argument] = STATE(6514),
    [sym_hash_splat_argument] = STATE(6514),
    [sym_block_argument] = STATE(6514),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1668),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(6515),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6514),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2853),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__identifier_hash_key] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9757),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2883),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3894] = {
    [sym_heredoc_body] = STATE(6516),
    [aux_sym_call_repeat1] = STATE(6516),
    [aux_sym_argument_list_repeat1] = STATE(6517),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(6303),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [3895] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6518),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_splat_argument] = STATE(6519),
    [sym_assignment] = STATE(6518),
    [sym_operator_assignment] = STATE(6518),
    [sym_conditional] = STATE(6518),
    [sym_range] = STATE(6518),
    [sym_binary] = STATE(6518),
    [sym_unary] = STATE(6518),
    [sym_right_assignment_list] = STATE(4290),
    [sym__arg_or_splat_arg] = STATE(6519),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(6147),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3896] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6520),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(6520),
    [sym_operator_assignment] = STATE(6520),
    [sym_conditional] = STATE(6520),
    [sym_range] = STATE(6520),
    [sym_binary] = STATE(6520),
    [sym_unary] = STATE(6520),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [3897] = {
    [sym_string] = STATE(6521),
    [aux_sym_chained_string_repeat1] = STATE(6521),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [3898] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6522),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(6522),
    [sym_operator_assignment] = STATE(6522),
    [sym_conditional] = STATE(6522),
    [sym_range] = STATE(6522),
    [sym_binary] = STATE(6522),
    [sym_unary] = STATE(6522),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3899] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6523),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(6523),
    [sym_operator_assignment] = STATE(6523),
    [sym_conditional] = STATE(6523),
    [sym_range] = STATE(6523),
    [sym_binary] = STATE(6523),
    [sym_unary] = STATE(6523),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3900] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(562),
    [sym__argument_list_with_parens] = STATE(6362),
    [sym__argument] = STATE(6363),
    [sym_splat_argument] = STATE(6363),
    [sym_hash_splat_argument] = STATE(6363),
    [sym_block_argument] = STATE(6363),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6363),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3901] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(568),
    [sym__argument_list_with_parens] = STATE(6362),
    [sym__argument] = STATE(6363),
    [sym_splat_argument] = STATE(6363),
    [sym_hash_splat_argument] = STATE(6363),
    [sym_block_argument] = STATE(6363),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6363),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3902] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(6362),
    [sym__argument] = STATE(6363),
    [sym_splat_argument] = STATE(6363),
    [sym_hash_splat_argument] = STATE(6363),
    [sym_block_argument] = STATE(6363),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6363),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3903] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(6362),
    [sym__argument] = STATE(6363),
    [sym_splat_argument] = STATE(6363),
    [sym_hash_splat_argument] = STATE(6363),
    [sym_block_argument] = STATE(6363),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6363),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2785),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3904] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6524),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(6524),
    [sym_operator_assignment] = STATE(6524),
    [sym_conditional] = STATE(6524),
    [sym_range] = STATE(6524),
    [sym_binary] = STATE(6524),
    [sym_unary] = STATE(6524),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3905] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3906] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9763),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(9765),
    [anon_sym_LT] = ACTIONS(9767),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(9769),
    [anon_sym_DOT_DOT] = ACTIONS(9771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9773),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(9775),
    [anon_sym_AMP_AMP] = ACTIONS(9775),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_BANG_EQ] = ACTIONS(9775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9775),
    [anon_sym_LT_EQ_GT] = ACTIONS(9775),
    [anon_sym_EQ_TILDE] = ACTIONS(9775),
    [anon_sym_BANG_TILDE] = ACTIONS(9775),
    [anon_sym_LT_EQ] = ACTIONS(9767),
    [anon_sym_GT] = ACTIONS(9767),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9783),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [3907] = {
    [aux_sym_exceptions_repeat1] = STATE(6536),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(9785),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [3908] = {
    [anon_sym_EQ] = ACTIONS(9787),
    [sym_comment] = ACTIONS(87),
  },
  [3909] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9789),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9791),
    [anon_sym_DASH_EQ] = ACTIONS(9791),
    [anon_sym_STAR_EQ] = ACTIONS(9791),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9791),
    [anon_sym_SLASH_EQ] = ACTIONS(9791),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9791),
    [anon_sym_PIPE_EQ] = ACTIONS(9791),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9791),
    [anon_sym_AMP_EQ] = ACTIONS(9791),
    [anon_sym_PERCENT_EQ] = ACTIONS(9791),
    [anon_sym_GT_GT_EQ] = ACTIONS(9791),
    [anon_sym_LT_LT_EQ] = ACTIONS(9791),
    [anon_sym_CARET_EQ] = ACTIONS(9791),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3910] = {
    [sym_string] = STATE(6539),
    [aux_sym_chained_string_repeat1] = STATE(6539),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3911] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [3912] = {
    [sym_string] = STATE(3912),
    [aux_sym_chained_string_repeat1] = STATE(3912),
    [sym__string_start] = ACTIONS(6891),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [3913] = {
    [sym__line_break] = ACTIONS(9793),
    [sym__heredoc_body_start] = ACTIONS(9793),
    [sym__binary_minus] = ACTIONS(9793),
    [sym__binary_star] = ACTIONS(9793),
    [ts_builtin_sym_end] = ACTIONS(9793),
    [anon_sym___END__] = ACTIONS(9793),
    [anon_sym_LBRACE] = ACTIONS(9793),
    [anon_sym_RBRACE] = ACTIONS(9793),
    [anon_sym_RPAREN] = ACTIONS(9793),
    [anon_sym_DOT] = ACTIONS(9795),
    [anon_sym_COMMA] = ACTIONS(9793),
    [anon_sym_PIPE] = ACTIONS(9795),
    [anon_sym_SEMI] = ACTIONS(9793),
    [anon_sym_STAR_STAR] = ACTIONS(9793),
    [anon_sym_AMP] = ACTIONS(9795),
    [anon_sym_LT] = ACTIONS(9795),
    [anon_sym_end] = ACTIONS(9793),
    [anon_sym_if] = ACTIONS(9793),
    [anon_sym_unless] = ACTIONS(9793),
    [anon_sym_while] = ACTIONS(9793),
    [anon_sym_until] = ACTIONS(9793),
    [anon_sym_rescue] = ACTIONS(9793),
    [anon_sym_do] = ACTIONS(9793),
    [anon_sym_when] = ACTIONS(9793),
    [anon_sym_elsif] = ACTIONS(9793),
    [anon_sym_else] = ACTIONS(9793),
    [anon_sym_then] = ACTIONS(9793),
    [anon_sym_ensure] = ACTIONS(9793),
    [anon_sym_EQ_GT] = ACTIONS(9793),
    [anon_sym_LBRACK] = ACTIONS(9793),
    [anon_sym_COLON_COLON2] = ACTIONS(9793),
    [anon_sym_AMP_DOT] = ACTIONS(9793),
    [anon_sym_QMARK] = ACTIONS(9793),
    [anon_sym_DOT_DOT] = ACTIONS(9795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9793),
    [anon_sym_and] = ACTIONS(9793),
    [anon_sym_or] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE] = ACTIONS(9793),
    [anon_sym_AMP_AMP] = ACTIONS(9793),
    [anon_sym_LT_LT] = ACTIONS(9793),
    [anon_sym_GT_GT] = ACTIONS(9793),
    [anon_sym_EQ_EQ] = ACTIONS(9795),
    [anon_sym_BANG_EQ] = ACTIONS(9793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9793),
    [anon_sym_LT_EQ_GT] = ACTIONS(9793),
    [anon_sym_EQ_TILDE] = ACTIONS(9793),
    [anon_sym_BANG_TILDE] = ACTIONS(9793),
    [anon_sym_LT_EQ] = ACTIONS(9795),
    [anon_sym_GT] = ACTIONS(9795),
    [anon_sym_GT_EQ] = ACTIONS(9793),
    [anon_sym_CARET] = ACTIONS(9793),
    [anon_sym_PLUS] = ACTIONS(9793),
    [anon_sym_SLASH] = ACTIONS(9793),
    [anon_sym_PERCENT] = ACTIONS(9793),
    [sym_comment] = ACTIONS(87),
  },
  [3914] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9797),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3915] = {
    [sym__line_break] = ACTIONS(9799),
    [sym__heredoc_body_start] = ACTIONS(9799),
    [sym__binary_minus] = ACTIONS(9799),
    [sym__binary_star] = ACTIONS(9799),
    [ts_builtin_sym_end] = ACTIONS(9799),
    [anon_sym___END__] = ACTIONS(9799),
    [anon_sym_LBRACE] = ACTIONS(9799),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [anon_sym_RPAREN] = ACTIONS(9799),
    [anon_sym_DOT] = ACTIONS(9801),
    [anon_sym_COMMA] = ACTIONS(9799),
    [anon_sym_PIPE] = ACTIONS(9801),
    [anon_sym_SEMI] = ACTIONS(9799),
    [anon_sym_STAR_STAR] = ACTIONS(9799),
    [anon_sym_AMP] = ACTIONS(9801),
    [anon_sym_LT] = ACTIONS(9801),
    [anon_sym_end] = ACTIONS(9799),
    [anon_sym_if] = ACTIONS(9799),
    [anon_sym_unless] = ACTIONS(9799),
    [anon_sym_while] = ACTIONS(9799),
    [anon_sym_until] = ACTIONS(9799),
    [anon_sym_rescue] = ACTIONS(9799),
    [anon_sym_do] = ACTIONS(9799),
    [anon_sym_when] = ACTIONS(9799),
    [anon_sym_elsif] = ACTIONS(9799),
    [anon_sym_else] = ACTIONS(9799),
    [anon_sym_then] = ACTIONS(9799),
    [anon_sym_ensure] = ACTIONS(9799),
    [anon_sym_EQ_GT] = ACTIONS(9799),
    [anon_sym_LBRACK] = ACTIONS(9799),
    [anon_sym_COLON_COLON2] = ACTIONS(9799),
    [anon_sym_AMP_DOT] = ACTIONS(9799),
    [anon_sym_QMARK] = ACTIONS(9799),
    [anon_sym_DOT_DOT] = ACTIONS(9801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9799),
    [anon_sym_and] = ACTIONS(9799),
    [anon_sym_or] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE] = ACTIONS(9799),
    [anon_sym_AMP_AMP] = ACTIONS(9799),
    [anon_sym_LT_LT] = ACTIONS(9799),
    [anon_sym_GT_GT] = ACTIONS(9799),
    [anon_sym_EQ_EQ] = ACTIONS(9801),
    [anon_sym_BANG_EQ] = ACTIONS(9799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9799),
    [anon_sym_LT_EQ_GT] = ACTIONS(9799),
    [anon_sym_EQ_TILDE] = ACTIONS(9799),
    [anon_sym_BANG_TILDE] = ACTIONS(9799),
    [anon_sym_LT_EQ] = ACTIONS(9801),
    [anon_sym_GT] = ACTIONS(9801),
    [anon_sym_GT_EQ] = ACTIONS(9799),
    [anon_sym_CARET] = ACTIONS(9799),
    [anon_sym_PLUS] = ACTIONS(9799),
    [anon_sym_SLASH] = ACTIONS(9799),
    [anon_sym_PERCENT] = ACTIONS(9799),
    [sym_comment] = ACTIONS(87),
  },
  [3916] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3917] = {
    [sym__line_break] = ACTIONS(9803),
    [sym__heredoc_body_start] = ACTIONS(9803),
    [sym__binary_minus] = ACTIONS(9803),
    [sym__binary_star] = ACTIONS(9803),
    [ts_builtin_sym_end] = ACTIONS(9803),
    [anon_sym___END__] = ACTIONS(9803),
    [anon_sym_LBRACE] = ACTIONS(9803),
    [anon_sym_RBRACE] = ACTIONS(9803),
    [anon_sym_RPAREN] = ACTIONS(9803),
    [anon_sym_DOT] = ACTIONS(9805),
    [anon_sym_COMMA] = ACTIONS(9803),
    [anon_sym_PIPE] = ACTIONS(9805),
    [anon_sym_SEMI] = ACTIONS(9803),
    [anon_sym_STAR_STAR] = ACTIONS(9803),
    [anon_sym_AMP] = ACTIONS(9805),
    [anon_sym_LT] = ACTIONS(9805),
    [anon_sym_end] = ACTIONS(9803),
    [anon_sym_if] = ACTIONS(9803),
    [anon_sym_unless] = ACTIONS(9803),
    [anon_sym_while] = ACTIONS(9803),
    [anon_sym_until] = ACTIONS(9803),
    [anon_sym_rescue] = ACTIONS(9803),
    [anon_sym_do] = ACTIONS(9803),
    [anon_sym_when] = ACTIONS(9803),
    [anon_sym_elsif] = ACTIONS(9803),
    [anon_sym_else] = ACTIONS(9803),
    [anon_sym_then] = ACTIONS(9803),
    [anon_sym_ensure] = ACTIONS(9803),
    [anon_sym_EQ_GT] = ACTIONS(9803),
    [anon_sym_LBRACK] = ACTIONS(9803),
    [anon_sym_COLON_COLON2] = ACTIONS(9803),
    [anon_sym_AMP_DOT] = ACTIONS(9803),
    [anon_sym_QMARK] = ACTIONS(9803),
    [anon_sym_DOT_DOT] = ACTIONS(9805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9803),
    [anon_sym_and] = ACTIONS(9803),
    [anon_sym_or] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE] = ACTIONS(9803),
    [anon_sym_AMP_AMP] = ACTIONS(9803),
    [anon_sym_LT_LT] = ACTIONS(9803),
    [anon_sym_GT_GT] = ACTIONS(9803),
    [anon_sym_EQ_EQ] = ACTIONS(9805),
    [anon_sym_BANG_EQ] = ACTIONS(9803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9803),
    [anon_sym_LT_EQ_GT] = ACTIONS(9803),
    [anon_sym_EQ_TILDE] = ACTIONS(9803),
    [anon_sym_BANG_TILDE] = ACTIONS(9803),
    [anon_sym_LT_EQ] = ACTIONS(9805),
    [anon_sym_GT] = ACTIONS(9805),
    [anon_sym_GT_EQ] = ACTIONS(9803),
    [anon_sym_CARET] = ACTIONS(9803),
    [anon_sym_PLUS] = ACTIONS(9803),
    [anon_sym_SLASH] = ACTIONS(9803),
    [anon_sym_PERCENT] = ACTIONS(9803),
    [sym_comment] = ACTIONS(87),
  },
  [3918] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9807),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3919] = {
    [sym__line_break] = ACTIONS(9809),
    [sym__heredoc_body_start] = ACTIONS(9809),
    [sym__binary_minus] = ACTIONS(9809),
    [sym__binary_star] = ACTIONS(9809),
    [ts_builtin_sym_end] = ACTIONS(9809),
    [anon_sym___END__] = ACTIONS(9809),
    [anon_sym_LBRACE] = ACTIONS(9809),
    [anon_sym_RBRACE] = ACTIONS(9809),
    [anon_sym_RPAREN] = ACTIONS(9809),
    [anon_sym_DOT] = ACTIONS(9811),
    [anon_sym_COMMA] = ACTIONS(9809),
    [anon_sym_PIPE] = ACTIONS(9811),
    [anon_sym_SEMI] = ACTIONS(9809),
    [anon_sym_STAR_STAR] = ACTIONS(9809),
    [anon_sym_AMP] = ACTIONS(9811),
    [anon_sym_LT] = ACTIONS(9811),
    [anon_sym_end] = ACTIONS(9809),
    [anon_sym_if] = ACTIONS(9809),
    [anon_sym_unless] = ACTIONS(9809),
    [anon_sym_while] = ACTIONS(9809),
    [anon_sym_until] = ACTIONS(9809),
    [anon_sym_rescue] = ACTIONS(9809),
    [anon_sym_do] = ACTIONS(9809),
    [anon_sym_when] = ACTIONS(9809),
    [anon_sym_elsif] = ACTIONS(9809),
    [anon_sym_else] = ACTIONS(9809),
    [anon_sym_then] = ACTIONS(9809),
    [anon_sym_ensure] = ACTIONS(9809),
    [anon_sym_EQ_GT] = ACTIONS(9809),
    [anon_sym_LBRACK] = ACTIONS(9809),
    [anon_sym_COLON_COLON2] = ACTIONS(9809),
    [anon_sym_AMP_DOT] = ACTIONS(9809),
    [anon_sym_QMARK] = ACTIONS(9809),
    [anon_sym_DOT_DOT] = ACTIONS(9811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9809),
    [anon_sym_and] = ACTIONS(9809),
    [anon_sym_or] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE] = ACTIONS(9809),
    [anon_sym_AMP_AMP] = ACTIONS(9809),
    [anon_sym_LT_LT] = ACTIONS(9809),
    [anon_sym_GT_GT] = ACTIONS(9809),
    [anon_sym_EQ_EQ] = ACTIONS(9811),
    [anon_sym_BANG_EQ] = ACTIONS(9809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9809),
    [anon_sym_LT_EQ_GT] = ACTIONS(9809),
    [anon_sym_EQ_TILDE] = ACTIONS(9809),
    [anon_sym_BANG_TILDE] = ACTIONS(9809),
    [anon_sym_LT_EQ] = ACTIONS(9811),
    [anon_sym_GT] = ACTIONS(9811),
    [anon_sym_GT_EQ] = ACTIONS(9809),
    [anon_sym_CARET] = ACTIONS(9809),
    [anon_sym_PLUS] = ACTIONS(9809),
    [anon_sym_SLASH] = ACTIONS(9809),
    [anon_sym_PERCENT] = ACTIONS(9809),
    [sym_comment] = ACTIONS(87),
  },
  [3920] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3921] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6542),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(6542),
    [sym_operator_assignment] = STATE(6542),
    [sym_conditional] = STATE(6542),
    [sym_range] = STATE(6542),
    [sym_binary] = STATE(6542),
    [sym_unary] = STATE(6542),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3922] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(6543),
    [sym__argument] = STATE(6544),
    [sym_splat_argument] = STATE(6544),
    [sym_hash_splat_argument] = STATE(6544),
    [sym_block_argument] = STATE(6544),
    [sym_assignment] = STATE(1702),
    [sym_operator_assignment] = STATE(1702),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_unary] = STATE(1702),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1707),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6544),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2972),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2996),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3923] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(6543),
    [sym__argument] = STATE(6544),
    [sym_splat_argument] = STATE(6544),
    [sym_hash_splat_argument] = STATE(6544),
    [sym_block_argument] = STATE(6544),
    [sym_assignment] = STATE(1702),
    [sym_operator_assignment] = STATE(1702),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_unary] = STATE(1702),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1707),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6544),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2972),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2996),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3924] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(6543),
    [sym__argument] = STATE(6544),
    [sym_splat_argument] = STATE(6544),
    [sym_hash_splat_argument] = STATE(6544),
    [sym_block_argument] = STATE(6544),
    [sym_assignment] = STATE(1702),
    [sym_operator_assignment] = STATE(1702),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_unary] = STATE(1702),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1707),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6544),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2972),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2996),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3925] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(6543),
    [sym__argument] = STATE(6544),
    [sym_splat_argument] = STATE(6544),
    [sym_hash_splat_argument] = STATE(6544),
    [sym_block_argument] = STATE(6544),
    [sym_assignment] = STATE(1702),
    [sym_operator_assignment] = STATE(1702),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_unary] = STATE(1702),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1707),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(6544),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2972),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2992),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2996),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3926] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6545),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(6545),
    [sym_operator_assignment] = STATE(6545),
    [sym_conditional] = STATE(6545),
    [sym_range] = STATE(6545),
    [sym_binary] = STATE(6545),
    [sym_unary] = STATE(6545),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3927] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3928] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(9823),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [3929] = {
    [anon_sym_EQ] = ACTIONS(9839),
    [sym_comment] = ACTIONS(87),
  },
  [3930] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9841),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9843),
    [anon_sym_DASH_EQ] = ACTIONS(9843),
    [anon_sym_STAR_EQ] = ACTIONS(9843),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9843),
    [anon_sym_SLASH_EQ] = ACTIONS(9843),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9843),
    [anon_sym_PIPE_EQ] = ACTIONS(9843),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9843),
    [anon_sym_AMP_EQ] = ACTIONS(9843),
    [anon_sym_PERCENT_EQ] = ACTIONS(9843),
    [anon_sym_GT_GT_EQ] = ACTIONS(9843),
    [anon_sym_LT_LT_EQ] = ACTIONS(9843),
    [anon_sym_CARET_EQ] = ACTIONS(9843),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3931] = {
    [sym_string] = STATE(6558),
    [aux_sym_chained_string_repeat1] = STATE(6558),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3932] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(9823),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [3933] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [3934] = {
    [sym_string] = STATE(3956),
    [aux_sym_chained_string_repeat1] = STATE(3956),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3935] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6559),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(6559),
    [sym_operator_assignment] = STATE(6559),
    [sym_conditional] = STATE(6559),
    [sym_range] = STATE(6559),
    [sym_binary] = STATE(6559),
    [sym_unary] = STATE(6559),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3936] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(9823),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [3937] = {
    [sym_heredoc_body] = STATE(6560),
    [aux_sym_call_repeat1] = STATE(6560),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3938] = {
    [sym_heredoc_body] = STATE(6560),
    [aux_sym_call_repeat1] = STATE(6560),
    [aux_sym_argument_list_repeat1] = STATE(6561),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9520),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [3939] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [3940] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6562),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(6562),
    [sym_operator_assignment] = STATE(6562),
    [sym_conditional] = STATE(6562),
    [sym_range] = STATE(6562),
    [sym_binary] = STATE(6562),
    [sym_unary] = STATE(6562),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3941] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6563),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6563),
    [sym_operator_assignment] = STATE(6563),
    [sym_conditional] = STATE(6563),
    [sym_range] = STATE(6563),
    [sym_binary] = STATE(6563),
    [sym_unary] = STATE(6563),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3942] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6564),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6564),
    [sym_operator_assignment] = STATE(6564),
    [sym_conditional] = STATE(6564),
    [sym_range] = STATE(6564),
    [sym_binary] = STATE(6564),
    [sym_unary] = STATE(6564),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3943] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6565),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6565),
    [sym_operator_assignment] = STATE(6565),
    [sym_conditional] = STATE(6565),
    [sym_range] = STATE(6565),
    [sym_binary] = STATE(6565),
    [sym_unary] = STATE(6565),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3944] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6566),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6566),
    [sym_operator_assignment] = STATE(6566),
    [sym_conditional] = STATE(6566),
    [sym_range] = STATE(6566),
    [sym_binary] = STATE(6566),
    [sym_unary] = STATE(6566),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3945] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6567),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6567),
    [sym_operator_assignment] = STATE(6567),
    [sym_conditional] = STATE(6567),
    [sym_range] = STATE(6567),
    [sym_binary] = STATE(6567),
    [sym_unary] = STATE(6567),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3946] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6568),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6568),
    [sym_operator_assignment] = STATE(6568),
    [sym_conditional] = STATE(6568),
    [sym_range] = STATE(6568),
    [sym_binary] = STATE(6568),
    [sym_unary] = STATE(6568),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3947] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6569),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6569),
    [sym_operator_assignment] = STATE(6569),
    [sym_conditional] = STATE(6569),
    [sym_range] = STATE(6569),
    [sym_binary] = STATE(6569),
    [sym_unary] = STATE(6569),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3948] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6570),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6570),
    [sym_operator_assignment] = STATE(6570),
    [sym_conditional] = STATE(6570),
    [sym_range] = STATE(6570),
    [sym_binary] = STATE(6570),
    [sym_unary] = STATE(6570),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3949] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6571),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6571),
    [sym_operator_assignment] = STATE(6571),
    [sym_conditional] = STATE(6571),
    [sym_range] = STATE(6571),
    [sym_binary] = STATE(6571),
    [sym_unary] = STATE(6571),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3950] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6572),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6572),
    [sym_operator_assignment] = STATE(6572),
    [sym_conditional] = STATE(6572),
    [sym_range] = STATE(6572),
    [sym_binary] = STATE(6572),
    [sym_unary] = STATE(6572),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3951] = {
    [sym_heredoc_body] = STATE(6573),
    [aux_sym_call_repeat1] = STATE(6573),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [3952] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(1702),
    [sym_operator_assignment] = STATE(1702),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_unary] = STATE(1702),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1707),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(6574),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2972),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__identifier_hash_key] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9845),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2996),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3953] = {
    [sym_heredoc_body] = STATE(6575),
    [aux_sym_call_repeat1] = STATE(6575),
    [aux_sym_argument_list_repeat1] = STATE(6576),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [3954] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6577),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_splat_argument] = STATE(6578),
    [sym_assignment] = STATE(6577),
    [sym_operator_assignment] = STATE(6577),
    [sym_conditional] = STATE(6577),
    [sym_range] = STATE(6577),
    [sym_binary] = STATE(6577),
    [sym_unary] = STATE(6577),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(6578),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3955] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6579),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(6579),
    [sym_operator_assignment] = STATE(6579),
    [sym_conditional] = STATE(6579),
    [sym_range] = STATE(6579),
    [sym_binary] = STATE(6579),
    [sym_unary] = STATE(6579),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3956] = {
    [sym_string] = STATE(6580),
    [aux_sym_chained_string_repeat1] = STATE(6580),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [3957] = {
    [aux_sym_undef_repeat1] = STATE(6581),
    [sym__line_break] = ACTIONS(5356),
    [sym__heredoc_body_start] = ACTIONS(5356),
    [anon_sym_RBRACE] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [3958] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5676),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3959] = {
    [sym_heredoc_body] = STATE(6582),
    [sym__terminator] = STATE(6582),
    [aux_sym__statements_repeat1] = STATE(3959),
    [sym__line_break] = ACTIONS(9847),
    [sym__heredoc_body_start] = ACTIONS(5683),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(9847),
    [sym_comment] = ACTIONS(87),
  },
  [3960] = {
    [sym__line_break] = ACTIONS(5686),
    [sym__heredoc_body_start] = ACTIONS(5686),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3961] = {
    [sym__line_break] = ACTIONS(5688),
    [sym__heredoc_body_start] = ACTIONS(5688),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5688),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3962] = {
    [sym__line_break] = ACTIONS(5690),
    [sym__heredoc_body_start] = ACTIONS(5690),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3963] = {
    [sym__line_break] = ACTIONS(5692),
    [sym__heredoc_body_start] = ACTIONS(5692),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5692),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3964] = {
    [sym__line_break] = ACTIONS(5694),
    [sym__heredoc_body_start] = ACTIONS(5694),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(3030),
    [anon_sym_or] = ACTIONS(3030),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3965] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3966] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [3967] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3968] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3969] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3970] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(9850),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [3971] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3972] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3973] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3974] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [3975] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6584),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(6584),
    [sym_operator_assignment] = STATE(6584),
    [sym_conditional] = STATE(6584),
    [sym_range] = STATE(6584),
    [sym_binary] = STATE(6584),
    [sym_unary] = STATE(6584),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3976] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(1742),
    [sym__argument] = STATE(1743),
    [sym_splat_argument] = STATE(1743),
    [sym_hash_splat_argument] = STATE(1743),
    [sym_block_argument] = STATE(1743),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1746),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1743),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3042),
    [sym__splat_star] = ACTIONS(3044),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3066),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3977] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(1742),
    [sym__argument] = STATE(1743),
    [sym_splat_argument] = STATE(1743),
    [sym_hash_splat_argument] = STATE(1743),
    [sym_block_argument] = STATE(1743),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1746),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1743),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3042),
    [sym__splat_star] = ACTIONS(3044),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3066),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3978] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(1742),
    [sym__argument] = STATE(1743),
    [sym_splat_argument] = STATE(1743),
    [sym_hash_splat_argument] = STATE(1743),
    [sym_block_argument] = STATE(1743),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1746),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1743),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3042),
    [sym__splat_star] = ACTIONS(3044),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3066),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3979] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(1742),
    [sym__argument] = STATE(1743),
    [sym_splat_argument] = STATE(1743),
    [sym_hash_splat_argument] = STATE(1743),
    [sym_block_argument] = STATE(1743),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1746),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1743),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3042),
    [sym__splat_star] = ACTIONS(3044),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3066),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3980] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6585),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(6585),
    [sym_operator_assignment] = STATE(6585),
    [sym_conditional] = STATE(6585),
    [sym_range] = STATE(6585),
    [sym_binary] = STATE(6585),
    [sym_unary] = STATE(6585),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3981] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3982] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(9864),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [3983] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(1742),
    [sym__argument] = STATE(1743),
    [sym_splat_argument] = STATE(1743),
    [sym_hash_splat_argument] = STATE(1743),
    [sym_block_argument] = STATE(1743),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1746),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(1743),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3042),
    [sym__splat_star] = ACTIONS(3044),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3066),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3984] = {
    [anon_sym_EQ] = ACTIONS(9880),
    [sym_comment] = ACTIONS(87),
  },
  [3985] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9882),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9884),
    [anon_sym_DASH_EQ] = ACTIONS(9884),
    [anon_sym_STAR_EQ] = ACTIONS(9884),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9884),
    [anon_sym_SLASH_EQ] = ACTIONS(9884),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9884),
    [anon_sym_PIPE_EQ] = ACTIONS(9884),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9884),
    [anon_sym_AMP_EQ] = ACTIONS(9884),
    [anon_sym_PERCENT_EQ] = ACTIONS(9884),
    [anon_sym_GT_GT_EQ] = ACTIONS(9884),
    [anon_sym_LT_LT_EQ] = ACTIONS(9884),
    [anon_sym_CARET_EQ] = ACTIONS(9884),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3986] = {
    [sym_string] = STATE(6598),
    [aux_sym_chained_string_repeat1] = STATE(6598),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3987] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(9864),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [3988] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [3989] = {
    [sym_string] = STATE(4009),
    [aux_sym_chained_string_repeat1] = STATE(4009),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3990] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6599),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(6599),
    [sym_operator_assignment] = STATE(6599),
    [sym_conditional] = STATE(6599),
    [sym_range] = STATE(6599),
    [sym_binary] = STATE(6599),
    [sym_unary] = STATE(6599),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3991] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(9864),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [3992] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [3993] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6600),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(6600),
    [sym_operator_assignment] = STATE(6600),
    [sym_conditional] = STATE(6600),
    [sym_range] = STATE(6600),
    [sym_binary] = STATE(6600),
    [sym_unary] = STATE(6600),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [3994] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6601),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6601),
    [sym_operator_assignment] = STATE(6601),
    [sym_conditional] = STATE(6601),
    [sym_range] = STATE(6601),
    [sym_binary] = STATE(6601),
    [sym_unary] = STATE(6601),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3995] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6602),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6602),
    [sym_operator_assignment] = STATE(6602),
    [sym_conditional] = STATE(6602),
    [sym_range] = STATE(6602),
    [sym_binary] = STATE(6602),
    [sym_unary] = STATE(6602),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3996] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6603),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6603),
    [sym_operator_assignment] = STATE(6603),
    [sym_conditional] = STATE(6603),
    [sym_range] = STATE(6603),
    [sym_binary] = STATE(6603),
    [sym_unary] = STATE(6603),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3997] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6604),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6604),
    [sym_operator_assignment] = STATE(6604),
    [sym_conditional] = STATE(6604),
    [sym_range] = STATE(6604),
    [sym_binary] = STATE(6604),
    [sym_unary] = STATE(6604),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3998] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6605),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6605),
    [sym_operator_assignment] = STATE(6605),
    [sym_conditional] = STATE(6605),
    [sym_range] = STATE(6605),
    [sym_binary] = STATE(6605),
    [sym_unary] = STATE(6605),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [3999] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6606),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6606),
    [sym_operator_assignment] = STATE(6606),
    [sym_conditional] = STATE(6606),
    [sym_range] = STATE(6606),
    [sym_binary] = STATE(6606),
    [sym_unary] = STATE(6606),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4000] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6607),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6607),
    [sym_operator_assignment] = STATE(6607),
    [sym_conditional] = STATE(6607),
    [sym_range] = STATE(6607),
    [sym_binary] = STATE(6607),
    [sym_unary] = STATE(6607),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4001] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6608),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6608),
    [sym_operator_assignment] = STATE(6608),
    [sym_conditional] = STATE(6608),
    [sym_range] = STATE(6608),
    [sym_binary] = STATE(6608),
    [sym_unary] = STATE(6608),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4002] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6609),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6609),
    [sym_operator_assignment] = STATE(6609),
    [sym_conditional] = STATE(6609),
    [sym_range] = STATE(6609),
    [sym_binary] = STATE(6609),
    [sym_unary] = STATE(6609),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4003] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6610),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6610),
    [sym_operator_assignment] = STATE(6610),
    [sym_conditional] = STATE(6610),
    [sym_range] = STATE(6610),
    [sym_binary] = STATE(6610),
    [sym_unary] = STATE(6610),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4004] = {
    [sym_heredoc_body] = STATE(6611),
    [aux_sym_call_repeat1] = STATE(6611),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4005] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1746),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(6612),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3042),
    [sym__splat_star] = ACTIONS(3044),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__identifier_hash_key] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9886),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3066),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4006] = {
    [sym_heredoc_body] = STATE(6613),
    [aux_sym_call_repeat1] = STATE(6613),
    [aux_sym_argument_list_repeat1] = STATE(6614),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(6503),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4007] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6615),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_splat_argument] = STATE(6616),
    [sym_assignment] = STATE(6615),
    [sym_operator_assignment] = STATE(6615),
    [sym_conditional] = STATE(6615),
    [sym_range] = STATE(6615),
    [sym_binary] = STATE(6615),
    [sym_unary] = STATE(6615),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(6616),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(5968),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4008] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6617),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(6617),
    [sym_operator_assignment] = STATE(6617),
    [sym_conditional] = STATE(6617),
    [sym_range] = STATE(6617),
    [sym_binary] = STATE(6617),
    [sym_unary] = STATE(6617),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4009] = {
    [sym_string] = STATE(6618),
    [aux_sym_chained_string_repeat1] = STATE(6618),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [4010] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6619),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(6619),
    [sym_operator_assignment] = STATE(6619),
    [sym_conditional] = STATE(6619),
    [sym_range] = STATE(6619),
    [sym_binary] = STATE(6619),
    [sym_unary] = STATE(6619),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4011] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6620),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(6620),
    [sym_operator_assignment] = STATE(6620),
    [sym_conditional] = STATE(6620),
    [sym_range] = STATE(6620),
    [sym_binary] = STATE(6620),
    [sym_unary] = STATE(6620),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4012] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6621),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(6621),
    [sym_operator_assignment] = STATE(6621),
    [sym_conditional] = STATE(6621),
    [sym_range] = STATE(6621),
    [sym_binary] = STATE(6621),
    [sym_unary] = STATE(6621),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4013] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4014] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9892),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(9894),
    [anon_sym_LT] = ACTIONS(9896),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DOT_DOT] = ACTIONS(9900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9902),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(9904),
    [anon_sym_AMP_AMP] = ACTIONS(9904),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(9908),
    [anon_sym_BANG_EQ] = ACTIONS(9904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9904),
    [anon_sym_LT_EQ_GT] = ACTIONS(9904),
    [anon_sym_EQ_TILDE] = ACTIONS(9904),
    [anon_sym_BANG_TILDE] = ACTIONS(9904),
    [anon_sym_LT_EQ] = ACTIONS(9896),
    [anon_sym_GT] = ACTIONS(9896),
    [anon_sym_GT_EQ] = ACTIONS(9910),
    [anon_sym_CARET] = ACTIONS(9912),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [4015] = {
    [aux_sym_exceptions_repeat1] = STATE(6633),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4016] = {
    [anon_sym_EQ] = ACTIONS(9916),
    [sym_comment] = ACTIONS(87),
  },
  [4017] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9918),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9920),
    [anon_sym_DASH_EQ] = ACTIONS(9920),
    [anon_sym_STAR_EQ] = ACTIONS(9920),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9920),
    [anon_sym_SLASH_EQ] = ACTIONS(9920),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9920),
    [anon_sym_PIPE_EQ] = ACTIONS(9920),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9920),
    [anon_sym_AMP_EQ] = ACTIONS(9920),
    [anon_sym_PERCENT_EQ] = ACTIONS(9920),
    [anon_sym_GT_GT_EQ] = ACTIONS(9920),
    [anon_sym_LT_LT_EQ] = ACTIONS(9920),
    [anon_sym_CARET_EQ] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4018] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [4019] = {
    [sym_string] = STATE(4019),
    [aux_sym_chained_string_repeat1] = STATE(4019),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [4020] = {
    [sym__binary_minus] = ACTIONS(6333),
    [sym__binary_star] = ACTIONS(6333),
    [anon_sym_LBRACE] = ACTIONS(6333),
    [anon_sym_RBRACE] = ACTIONS(6333),
    [anon_sym_RPAREN] = ACTIONS(6333),
    [anon_sym_DOT] = ACTIONS(6335),
    [anon_sym_COMMA] = ACTIONS(6333),
    [anon_sym_PIPE] = ACTIONS(6335),
    [anon_sym_SEMI] = ACTIONS(6333),
    [anon_sym_STAR_STAR] = ACTIONS(6333),
    [anon_sym_AMP] = ACTIONS(6335),
    [anon_sym_LT] = ACTIONS(6335),
    [anon_sym_if] = ACTIONS(6333),
    [anon_sym_unless] = ACTIONS(6333),
    [anon_sym_while] = ACTIONS(6333),
    [anon_sym_until] = ACTIONS(6333),
    [anon_sym_rescue] = ACTIONS(6333),
    [anon_sym_do] = ACTIONS(6333),
    [anon_sym_EQ_GT] = ACTIONS(6333),
    [anon_sym_LBRACK] = ACTIONS(6333),
    [anon_sym_COLON_COLON2] = ACTIONS(6333),
    [anon_sym_AMP_DOT] = ACTIONS(6333),
    [anon_sym_QMARK] = ACTIONS(6333),
    [anon_sym_COLON2] = ACTIONS(6335),
    [anon_sym_DOT_DOT] = ACTIONS(6335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6333),
    [anon_sym_and] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE] = ACTIONS(6333),
    [anon_sym_AMP_AMP] = ACTIONS(6333),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_EQ_EQ] = ACTIONS(6335),
    [anon_sym_BANG_EQ] = ACTIONS(6333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6333),
    [anon_sym_LT_EQ_GT] = ACTIONS(6333),
    [anon_sym_EQ_TILDE] = ACTIONS(6333),
    [anon_sym_BANG_TILDE] = ACTIONS(6333),
    [anon_sym_LT_EQ] = ACTIONS(6335),
    [anon_sym_GT] = ACTIONS(6335),
    [anon_sym_GT_EQ] = ACTIONS(6333),
    [anon_sym_CARET] = ACTIONS(6333),
    [anon_sym_PLUS] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6333),
    [anon_sym_PERCENT] = ACTIONS(6333),
    [sym_comment] = ACTIONS(87),
  },
  [4021] = {
    [sym__binary_minus] = ACTIONS(6337),
    [sym__binary_star] = ACTIONS(6337),
    [anon_sym_LBRACE] = ACTIONS(6337),
    [anon_sym_RBRACE] = ACTIONS(6337),
    [anon_sym_RPAREN] = ACTIONS(6337),
    [anon_sym_DOT] = ACTIONS(6339),
    [anon_sym_COMMA] = ACTIONS(6337),
    [anon_sym_PIPE] = ACTIONS(6339),
    [anon_sym_SEMI] = ACTIONS(6337),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_AMP] = ACTIONS(6339),
    [anon_sym_LT] = ACTIONS(6339),
    [anon_sym_if] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6337),
    [anon_sym_while] = ACTIONS(6337),
    [anon_sym_until] = ACTIONS(6337),
    [anon_sym_rescue] = ACTIONS(6337),
    [anon_sym_do] = ACTIONS(6337),
    [anon_sym_EQ_GT] = ACTIONS(6337),
    [anon_sym_LBRACK] = ACTIONS(6337),
    [anon_sym_COLON_COLON2] = ACTIONS(6337),
    [anon_sym_AMP_DOT] = ACTIONS(6337),
    [anon_sym_QMARK] = ACTIONS(6337),
    [anon_sym_COLON2] = ACTIONS(6339),
    [anon_sym_DOT_DOT] = ACTIONS(6339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6337),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6337),
    [anon_sym_AMP_AMP] = ACTIONS(6337),
    [anon_sym_LT_LT] = ACTIONS(6337),
    [anon_sym_GT_GT] = ACTIONS(6337),
    [anon_sym_EQ_EQ] = ACTIONS(6339),
    [anon_sym_BANG_EQ] = ACTIONS(6337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6337),
    [anon_sym_LT_EQ_GT] = ACTIONS(6337),
    [anon_sym_EQ_TILDE] = ACTIONS(6337),
    [anon_sym_BANG_TILDE] = ACTIONS(6337),
    [anon_sym_LT_EQ] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6339),
    [anon_sym_GT_EQ] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [anon_sym_PLUS] = ACTIONS(6337),
    [anon_sym_SLASH] = ACTIONS(6337),
    [anon_sym_PERCENT] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
  },
  [4022] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9922),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4023] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(9922),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9924),
  },
  [4024] = {
    [sym__binary_minus] = ACTIONS(6345),
    [sym__binary_star] = ACTIONS(6345),
    [anon_sym_LBRACE] = ACTIONS(6345),
    [anon_sym_RBRACE] = ACTIONS(6345),
    [anon_sym_RPAREN] = ACTIONS(6345),
    [anon_sym_DOT] = ACTIONS(6347),
    [anon_sym_COMMA] = ACTIONS(6345),
    [anon_sym_PIPE] = ACTIONS(6347),
    [anon_sym_SEMI] = ACTIONS(6345),
    [anon_sym_STAR_STAR] = ACTIONS(6345),
    [anon_sym_AMP] = ACTIONS(6347),
    [anon_sym_LT] = ACTIONS(6347),
    [anon_sym_if] = ACTIONS(6345),
    [anon_sym_unless] = ACTIONS(6345),
    [anon_sym_while] = ACTIONS(6345),
    [anon_sym_until] = ACTIONS(6345),
    [anon_sym_rescue] = ACTIONS(6345),
    [anon_sym_do] = ACTIONS(6345),
    [anon_sym_EQ_GT] = ACTIONS(6345),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_COLON_COLON2] = ACTIONS(6345),
    [anon_sym_AMP_DOT] = ACTIONS(6345),
    [anon_sym_QMARK] = ACTIONS(6345),
    [anon_sym_COLON2] = ACTIONS(6347),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6345),
    [anon_sym_and] = ACTIONS(6345),
    [anon_sym_or] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE] = ACTIONS(6345),
    [anon_sym_AMP_AMP] = ACTIONS(6345),
    [anon_sym_LT_LT] = ACTIONS(6345),
    [anon_sym_GT_GT] = ACTIONS(6345),
    [anon_sym_EQ_EQ] = ACTIONS(6347),
    [anon_sym_BANG_EQ] = ACTIONS(6345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6345),
    [anon_sym_LT_EQ_GT] = ACTIONS(6345),
    [anon_sym_EQ_TILDE] = ACTIONS(6345),
    [anon_sym_BANG_TILDE] = ACTIONS(6345),
    [anon_sym_LT_EQ] = ACTIONS(6347),
    [anon_sym_GT] = ACTIONS(6347),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_CARET] = ACTIONS(6345),
    [anon_sym_PLUS] = ACTIONS(6345),
    [anon_sym_SLASH] = ACTIONS(6345),
    [anon_sym_PERCENT] = ACTIONS(6345),
    [sym_comment] = ACTIONS(87),
  },
  [4025] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9926),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4026] = {
    [sym__binary_minus] = ACTIONS(6358),
    [sym__binary_star] = ACTIONS(6358),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RBRACE] = ACTIONS(6358),
    [anon_sym_RPAREN] = ACTIONS(6358),
    [anon_sym_DOT] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6360),
    [anon_sym_SEMI] = ACTIONS(6358),
    [anon_sym_STAR_STAR] = ACTIONS(6358),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6360),
    [anon_sym_if] = ACTIONS(6358),
    [anon_sym_unless] = ACTIONS(6358),
    [anon_sym_while] = ACTIONS(6358),
    [anon_sym_until] = ACTIONS(6358),
    [anon_sym_rescue] = ACTIONS(6358),
    [anon_sym_do] = ACTIONS(6358),
    [anon_sym_EQ_GT] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6358),
    [anon_sym_COLON_COLON2] = ACTIONS(6358),
    [anon_sym_AMP_DOT] = ACTIONS(6358),
    [anon_sym_QMARK] = ACTIONS(6358),
    [anon_sym_COLON2] = ACTIONS(6360),
    [anon_sym_DOT_DOT] = ACTIONS(6360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6358),
    [anon_sym_and] = ACTIONS(6358),
    [anon_sym_or] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE] = ACTIONS(6358),
    [anon_sym_AMP_AMP] = ACTIONS(6358),
    [anon_sym_LT_LT] = ACTIONS(6358),
    [anon_sym_GT_GT] = ACTIONS(6358),
    [anon_sym_EQ_EQ] = ACTIONS(6360),
    [anon_sym_BANG_EQ] = ACTIONS(6358),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6358),
    [anon_sym_LT_EQ_GT] = ACTIONS(6358),
    [anon_sym_EQ_TILDE] = ACTIONS(6358),
    [anon_sym_BANG_TILDE] = ACTIONS(6358),
    [anon_sym_LT_EQ] = ACTIONS(6360),
    [anon_sym_GT] = ACTIONS(6360),
    [anon_sym_GT_EQ] = ACTIONS(6358),
    [anon_sym_CARET] = ACTIONS(6358),
    [anon_sym_PLUS] = ACTIONS(6358),
    [anon_sym_SLASH] = ACTIONS(6358),
    [anon_sym_PERCENT] = ACTIONS(6358),
    [sym_comment] = ACTIONS(87),
  },
  [4027] = {
    [sym__binary_minus] = ACTIONS(6362),
    [sym__binary_star] = ACTIONS(6362),
    [anon_sym_LBRACE] = ACTIONS(6362),
    [anon_sym_RBRACE] = ACTIONS(6362),
    [anon_sym_RPAREN] = ACTIONS(6362),
    [anon_sym_DOT] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6364),
    [anon_sym_SEMI] = ACTIONS(6362),
    [anon_sym_STAR_STAR] = ACTIONS(6362),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6364),
    [anon_sym_if] = ACTIONS(6362),
    [anon_sym_unless] = ACTIONS(6362),
    [anon_sym_while] = ACTIONS(6362),
    [anon_sym_until] = ACTIONS(6362),
    [anon_sym_rescue] = ACTIONS(6362),
    [anon_sym_do] = ACTIONS(6362),
    [anon_sym_EQ_GT] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6362),
    [anon_sym_COLON_COLON2] = ACTIONS(6362),
    [anon_sym_AMP_DOT] = ACTIONS(6362),
    [anon_sym_QMARK] = ACTIONS(6362),
    [anon_sym_COLON2] = ACTIONS(6364),
    [anon_sym_DOT_DOT] = ACTIONS(6364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6362),
    [anon_sym_and] = ACTIONS(6362),
    [anon_sym_or] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE] = ACTIONS(6362),
    [anon_sym_AMP_AMP] = ACTIONS(6362),
    [anon_sym_LT_LT] = ACTIONS(6362),
    [anon_sym_GT_GT] = ACTIONS(6362),
    [anon_sym_EQ_EQ] = ACTIONS(6364),
    [anon_sym_BANG_EQ] = ACTIONS(6362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6362),
    [anon_sym_LT_EQ_GT] = ACTIONS(6362),
    [anon_sym_EQ_TILDE] = ACTIONS(6362),
    [anon_sym_BANG_TILDE] = ACTIONS(6362),
    [anon_sym_LT_EQ] = ACTIONS(6364),
    [anon_sym_GT] = ACTIONS(6364),
    [anon_sym_GT_EQ] = ACTIONS(6362),
    [anon_sym_CARET] = ACTIONS(6362),
    [anon_sym_PLUS] = ACTIONS(6362),
    [anon_sym_SLASH] = ACTIONS(6362),
    [anon_sym_PERCENT] = ACTIONS(6362),
    [sym_comment] = ACTIONS(87),
  },
  [4028] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9928),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4029] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(9928),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9930),
  },
  [4030] = {
    [sym__binary_minus] = ACTIONS(6370),
    [sym__binary_star] = ACTIONS(6370),
    [anon_sym_LBRACE] = ACTIONS(6370),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_RPAREN] = ACTIONS(6370),
    [anon_sym_DOT] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym_STAR_STAR] = ACTIONS(6370),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_if] = ACTIONS(6370),
    [anon_sym_unless] = ACTIONS(6370),
    [anon_sym_while] = ACTIONS(6370),
    [anon_sym_until] = ACTIONS(6370),
    [anon_sym_rescue] = ACTIONS(6370),
    [anon_sym_do] = ACTIONS(6370),
    [anon_sym_EQ_GT] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6370),
    [anon_sym_COLON_COLON2] = ACTIONS(6370),
    [anon_sym_AMP_DOT] = ACTIONS(6370),
    [anon_sym_QMARK] = ACTIONS(6370),
    [anon_sym_COLON2] = ACTIONS(6372),
    [anon_sym_DOT_DOT] = ACTIONS(6372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6370),
    [anon_sym_and] = ACTIONS(6370),
    [anon_sym_or] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_LT_LT] = ACTIONS(6370),
    [anon_sym_GT_GT] = ACTIONS(6370),
    [anon_sym_EQ_EQ] = ACTIONS(6372),
    [anon_sym_BANG_EQ] = ACTIONS(6370),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6370),
    [anon_sym_LT_EQ_GT] = ACTIONS(6370),
    [anon_sym_EQ_TILDE] = ACTIONS(6370),
    [anon_sym_BANG_TILDE] = ACTIONS(6370),
    [anon_sym_LT_EQ] = ACTIONS(6372),
    [anon_sym_GT] = ACTIONS(6372),
    [anon_sym_GT_EQ] = ACTIONS(6370),
    [anon_sym_CARET] = ACTIONS(6370),
    [anon_sym_PLUS] = ACTIONS(6370),
    [anon_sym_SLASH] = ACTIONS(6370),
    [anon_sym_PERCENT] = ACTIONS(6370),
    [sym_comment] = ACTIONS(87),
  },
  [4031] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(9932),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4032] = {
    [sym__heredoc_content] = ACTIONS(6169),
    [sym_heredoc_end] = ACTIONS(6169),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6171),
    [sym_escape_sequence] = ACTIONS(6169),
  },
  [4033] = {
    [sym__binary_minus] = ACTIONS(6894),
    [sym__binary_star] = ACTIONS(6894),
    [anon_sym_LBRACE] = ACTIONS(6894),
    [anon_sym_RBRACE] = ACTIONS(6894),
    [anon_sym_RPAREN] = ACTIONS(6894),
    [anon_sym_DOT] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_SEMI] = ACTIONS(6894),
    [anon_sym_STAR_STAR] = ACTIONS(6894),
    [anon_sym_AMP] = ACTIONS(6896),
    [anon_sym_LT] = ACTIONS(6896),
    [anon_sym_if] = ACTIONS(6894),
    [anon_sym_unless] = ACTIONS(6894),
    [anon_sym_while] = ACTIONS(6894),
    [anon_sym_until] = ACTIONS(6894),
    [anon_sym_rescue] = ACTIONS(6894),
    [anon_sym_do] = ACTIONS(6894),
    [anon_sym_EQ_GT] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6894),
    [anon_sym_COLON_COLON2] = ACTIONS(6894),
    [anon_sym_AMP_DOT] = ACTIONS(6894),
    [anon_sym_QMARK] = ACTIONS(6894),
    [anon_sym_COLON2] = ACTIONS(6896),
    [anon_sym_DOT_DOT] = ACTIONS(6896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6894),
    [anon_sym_and] = ACTIONS(6894),
    [anon_sym_or] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE] = ACTIONS(6894),
    [anon_sym_AMP_AMP] = ACTIONS(6894),
    [anon_sym_LT_LT] = ACTIONS(6894),
    [anon_sym_GT_GT] = ACTIONS(6894),
    [anon_sym_EQ_EQ] = ACTIONS(6896),
    [anon_sym_BANG_EQ] = ACTIONS(6894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6894),
    [anon_sym_LT_EQ_GT] = ACTIONS(6894),
    [anon_sym_EQ_TILDE] = ACTIONS(6894),
    [anon_sym_BANG_TILDE] = ACTIONS(6894),
    [anon_sym_LT_EQ] = ACTIONS(6896),
    [anon_sym_GT] = ACTIONS(6896),
    [anon_sym_GT_EQ] = ACTIONS(6894),
    [anon_sym_CARET] = ACTIONS(6894),
    [anon_sym_PLUS] = ACTIONS(6894),
    [anon_sym_SLASH] = ACTIONS(6894),
    [anon_sym_PERCENT] = ACTIONS(6894),
    [sym_comment] = ACTIONS(87),
  },
  [4034] = {
    [anon_sym_DOT] = ACTIONS(9934),
    [anon_sym_COLON_COLON] = ACTIONS(9934),
    [sym_comment] = ACTIONS(87),
  },
  [4035] = {
    [sym__binary_minus] = ACTIONS(7046),
    [sym__binary_star] = ACTIONS(7046),
    [anon_sym_LBRACE] = ACTIONS(7046),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7046),
    [anon_sym_DOT] = ACTIONS(7048),
    [anon_sym_COMMA] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_STAR_STAR] = ACTIONS(7046),
    [anon_sym_AMP] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7048),
    [anon_sym_if] = ACTIONS(7046),
    [anon_sym_unless] = ACTIONS(7046),
    [anon_sym_while] = ACTIONS(7046),
    [anon_sym_until] = ACTIONS(7046),
    [anon_sym_rescue] = ACTIONS(7046),
    [anon_sym_do] = ACTIONS(7046),
    [anon_sym_EQ_GT] = ACTIONS(7046),
    [anon_sym_LBRACK] = ACTIONS(7046),
    [anon_sym_COLON_COLON2] = ACTIONS(7046),
    [anon_sym_AMP_DOT] = ACTIONS(7046),
    [anon_sym_QMARK] = ACTIONS(7046),
    [anon_sym_COLON2] = ACTIONS(7048),
    [anon_sym_DOT_DOT] = ACTIONS(7048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7046),
    [anon_sym_and] = ACTIONS(7046),
    [anon_sym_or] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE] = ACTIONS(7046),
    [anon_sym_AMP_AMP] = ACTIONS(7046),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_BANG_EQ] = ACTIONS(7046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT_EQ_GT] = ACTIONS(7046),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_BANG_TILDE] = ACTIONS(7046),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7046),
    [anon_sym_CARET] = ACTIONS(7046),
    [anon_sym_PLUS] = ACTIONS(7046),
    [anon_sym_SLASH] = ACTIONS(7046),
    [anon_sym_PERCENT] = ACTIONS(7046),
    [sym_comment] = ACTIONS(87),
  },
  [4036] = {
    [sym__binary_minus] = ACTIONS(7062),
    [sym__binary_star] = ACTIONS(7062),
    [anon_sym_LBRACE] = ACTIONS(7062),
    [anon_sym_RBRACE] = ACTIONS(7062),
    [anon_sym_RPAREN] = ACTIONS(7062),
    [anon_sym_DOT] = ACTIONS(7064),
    [anon_sym_COMMA] = ACTIONS(7062),
    [anon_sym_PIPE] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(7062),
    [anon_sym_STAR_STAR] = ACTIONS(7062),
    [anon_sym_AMP] = ACTIONS(7064),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_if] = ACTIONS(7062),
    [anon_sym_unless] = ACTIONS(7062),
    [anon_sym_while] = ACTIONS(7062),
    [anon_sym_until] = ACTIONS(7062),
    [anon_sym_rescue] = ACTIONS(7062),
    [anon_sym_do] = ACTIONS(7062),
    [anon_sym_EQ_GT] = ACTIONS(7062),
    [anon_sym_LBRACK] = ACTIONS(7062),
    [anon_sym_COLON_COLON2] = ACTIONS(7062),
    [anon_sym_AMP_DOT] = ACTIONS(7062),
    [anon_sym_QMARK] = ACTIONS(7062),
    [anon_sym_COLON2] = ACTIONS(7064),
    [anon_sym_DOT_DOT] = ACTIONS(7064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7062),
    [anon_sym_and] = ACTIONS(7062),
    [anon_sym_or] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE] = ACTIONS(7062),
    [anon_sym_AMP_AMP] = ACTIONS(7062),
    [anon_sym_LT_LT] = ACTIONS(7062),
    [anon_sym_GT_GT] = ACTIONS(7062),
    [anon_sym_EQ_EQ] = ACTIONS(7064),
    [anon_sym_BANG_EQ] = ACTIONS(7062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7062),
    [anon_sym_LT_EQ_GT] = ACTIONS(7062),
    [anon_sym_EQ_TILDE] = ACTIONS(7062),
    [anon_sym_BANG_TILDE] = ACTIONS(7062),
    [anon_sym_LT_EQ] = ACTIONS(7064),
    [anon_sym_GT] = ACTIONS(7064),
    [anon_sym_GT_EQ] = ACTIONS(7062),
    [anon_sym_CARET] = ACTIONS(7062),
    [anon_sym_PLUS] = ACTIONS(7062),
    [anon_sym_SLASH] = ACTIONS(7062),
    [anon_sym_PERCENT] = ACTIONS(7062),
    [sym_comment] = ACTIONS(87),
  },
  [4037] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6643),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(6643),
    [sym_operator_assignment] = STATE(6643),
    [sym_conditional] = STATE(6643),
    [sym_range] = STATE(6643),
    [sym_binary] = STATE(6643),
    [sym_unary] = STATE(6643),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4038] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6644),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(6644),
    [sym_operator_assignment] = STATE(6644),
    [sym_conditional] = STATE(6644),
    [sym_range] = STATE(6644),
    [sym_binary] = STATE(6644),
    [sym_unary] = STATE(6644),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4039] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4040] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(9946),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [4041] = {
    [anon_sym_EQ] = ACTIONS(9962),
    [sym_comment] = ACTIONS(87),
  },
  [4042] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9964),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9966),
    [anon_sym_DASH_EQ] = ACTIONS(9966),
    [anon_sym_STAR_EQ] = ACTIONS(9966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9966),
    [anon_sym_SLASH_EQ] = ACTIONS(9966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9966),
    [anon_sym_PIPE_EQ] = ACTIONS(9966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9966),
    [anon_sym_AMP_EQ] = ACTIONS(9966),
    [anon_sym_PERCENT_EQ] = ACTIONS(9966),
    [anon_sym_GT_GT_EQ] = ACTIONS(9966),
    [anon_sym_LT_LT_EQ] = ACTIONS(9966),
    [anon_sym_CARET_EQ] = ACTIONS(9966),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4043] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(9946),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [4044] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4045] = {
    [sym_string] = STATE(4083),
    [aux_sym_chained_string_repeat1] = STATE(4083),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4046] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6657),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(6657),
    [sym_operator_assignment] = STATE(6657),
    [sym_conditional] = STATE(6657),
    [sym_range] = STATE(6657),
    [sym_binary] = STATE(6657),
    [sym_unary] = STATE(6657),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4047] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(9946),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [4048] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6658),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6658),
    [sym_operator_assignment] = STATE(6658),
    [sym_conditional] = STATE(6658),
    [sym_range] = STATE(6658),
    [sym_binary] = STATE(6658),
    [sym_unary] = STATE(6658),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4049] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6659),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6659),
    [sym_operator_assignment] = STATE(6659),
    [sym_conditional] = STATE(6659),
    [sym_range] = STATE(6659),
    [sym_binary] = STATE(6659),
    [sym_unary] = STATE(6659),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4050] = {
    [anon_sym_COLON] = ACTIONS(9968),
    [sym_comment] = ACTIONS(87),
  },
  [4051] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6661),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6661),
    [sym_operator_assignment] = STATE(6661),
    [sym_conditional] = STATE(6661),
    [sym_range] = STATE(6661),
    [sym_binary] = STATE(6661),
    [sym_unary] = STATE(6661),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4052] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9970),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4053] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [4054] = {
    [sym_heredoc_body] = STATE(6663),
    [aux_sym_call_repeat1] = STATE(6663),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4055] = {
    [sym_heredoc_body] = STATE(6663),
    [aux_sym_call_repeat1] = STATE(6663),
    [aux_sym_argument_list_repeat1] = STATE(6665),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9972),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4056] = {
    [sym_string] = STATE(4083),
    [aux_sym_chained_string_repeat1] = STATE(4083),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9974),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4057] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [4058] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6666),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(6666),
    [sym_operator_assignment] = STATE(6666),
    [sym_conditional] = STATE(6666),
    [sym_range] = STATE(6666),
    [sym_binary] = STATE(6666),
    [sym_unary] = STATE(6666),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4059] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6667),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6667),
    [sym_operator_assignment] = STATE(6667),
    [sym_conditional] = STATE(6667),
    [sym_range] = STATE(6667),
    [sym_binary] = STATE(6667),
    [sym_unary] = STATE(6667),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4060] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6668),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6668),
    [sym_operator_assignment] = STATE(6668),
    [sym_conditional] = STATE(6668),
    [sym_range] = STATE(6668),
    [sym_binary] = STATE(6668),
    [sym_unary] = STATE(6668),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4061] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6669),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6669),
    [sym_operator_assignment] = STATE(6669),
    [sym_conditional] = STATE(6669),
    [sym_range] = STATE(6669),
    [sym_binary] = STATE(6669),
    [sym_unary] = STATE(6669),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4062] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6670),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6670),
    [sym_operator_assignment] = STATE(6670),
    [sym_conditional] = STATE(6670),
    [sym_range] = STATE(6670),
    [sym_binary] = STATE(6670),
    [sym_unary] = STATE(6670),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4063] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6671),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6671),
    [sym_operator_assignment] = STATE(6671),
    [sym_conditional] = STATE(6671),
    [sym_range] = STATE(6671),
    [sym_binary] = STATE(6671),
    [sym_unary] = STATE(6671),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4064] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6672),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6672),
    [sym_operator_assignment] = STATE(6672),
    [sym_conditional] = STATE(6672),
    [sym_range] = STATE(6672),
    [sym_binary] = STATE(6672),
    [sym_unary] = STATE(6672),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4065] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6673),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6673),
    [sym_operator_assignment] = STATE(6673),
    [sym_conditional] = STATE(6673),
    [sym_range] = STATE(6673),
    [sym_binary] = STATE(6673),
    [sym_unary] = STATE(6673),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4066] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6674),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6674),
    [sym_operator_assignment] = STATE(6674),
    [sym_conditional] = STATE(6674),
    [sym_range] = STATE(6674),
    [sym_binary] = STATE(6674),
    [sym_unary] = STATE(6674),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4067] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6675),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6675),
    [sym_operator_assignment] = STATE(6675),
    [sym_conditional] = STATE(6675),
    [sym_range] = STATE(6675),
    [sym_binary] = STATE(6675),
    [sym_unary] = STATE(6675),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4068] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6676),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6676),
    [sym_operator_assignment] = STATE(6676),
    [sym_conditional] = STATE(6676),
    [sym_range] = STATE(6676),
    [sym_binary] = STATE(6676),
    [sym_unary] = STATE(6676),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4069] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6677),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6677),
    [sym_operator_assignment] = STATE(6677),
    [sym_conditional] = STATE(6677),
    [sym_range] = STATE(6677),
    [sym_binary] = STATE(6677),
    [sym_unary] = STATE(6677),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4070] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6678),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6678),
    [sym_operator_assignment] = STATE(6678),
    [sym_conditional] = STATE(6678),
    [sym_range] = STATE(6678),
    [sym_binary] = STATE(6678),
    [sym_unary] = STATE(6678),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4071] = {
    [anon_sym_COLON] = ACTIONS(9976),
    [sym_comment] = ACTIONS(87),
  },
  [4072] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6680),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6680),
    [sym_operator_assignment] = STATE(6680),
    [sym_conditional] = STATE(6680),
    [sym_range] = STATE(6680),
    [sym_binary] = STATE(6680),
    [sym_unary] = STATE(6680),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4073] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4074] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [4075] = {
    [sym_heredoc_body] = STATE(6682),
    [aux_sym_call_repeat1] = STATE(6682),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [4076] = {
    [sym_heredoc_body] = STATE(6682),
    [aux_sym_call_repeat1] = STATE(6682),
    [aux_sym_argument_list_repeat1] = STATE(6684),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9980),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [4077] = {
    [sym_string] = STATE(4146),
    [aux_sym_chained_string_repeat1] = STATE(4146),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4078] = {
    [sym_heredoc_body] = STATE(6685),
    [aux_sym_call_repeat1] = STATE(6685),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4079] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1790),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(1790),
    [sym_operator_assignment] = STATE(1790),
    [sym_conditional] = STATE(1790),
    [sym_range] = STATE(1790),
    [sym_binary] = STATE(1790),
    [sym_unary] = STATE(1790),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1796),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(6686),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3118),
    [sym__splat_star] = ACTIONS(3120),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__identifier_hash_key] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9984),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3142),
    [sym_identifier] = ACTIONS(3142),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4080] = {
    [sym_heredoc_body] = STATE(6687),
    [aux_sym_call_repeat1] = STATE(6687),
    [aux_sym_argument_list_repeat1] = STATE(6688),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(6625),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4081] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6689),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_splat_argument] = STATE(6690),
    [sym_assignment] = STATE(6689),
    [sym_operator_assignment] = STATE(6689),
    [sym_conditional] = STATE(6689),
    [sym_range] = STATE(6689),
    [sym_binary] = STATE(6689),
    [sym_unary] = STATE(6689),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(6690),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(6583),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4082] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6691),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(6691),
    [sym_operator_assignment] = STATE(6691),
    [sym_conditional] = STATE(6691),
    [sym_range] = STATE(6691),
    [sym_binary] = STATE(6691),
    [sym_unary] = STATE(6691),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4083] = {
    [sym_string] = STATE(6692),
    [aux_sym_chained_string_repeat1] = STATE(6692),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [4084] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [4085] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [4086] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [4087] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [4088] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [4089] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4090] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [4091] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_DOT_DOT] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [4092] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [4093] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [4094] = {
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__binary_minus] = ACTIONS(1263),
    [sym__binary_star] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_rescue] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_RBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_STAR_EQ] = ACTIONS(1263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1263),
    [anon_sym_SLASH_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1263),
    [anon_sym_AMP_EQ] = ACTIONS(1263),
    [anon_sym_PERCENT_EQ] = ACTIONS(1263),
    [anon_sym_GT_GT_EQ] = ACTIONS(1263),
    [anon_sym_LT_LT_EQ] = ACTIONS(1263),
    [anon_sym_CARET_EQ] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_COLON2] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT_EQ_GT] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_BANG_TILDE] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [4095] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(6695),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(6696),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(9988),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4096] = {
    [sym__simple_symbol] = ACTIONS(5806),
    [sym__string_start] = ACTIONS(5806),
    [sym__symbol_start] = ACTIONS(5806),
    [sym__subshell_start] = ACTIONS(5806),
    [sym__regex_start] = ACTIONS(5806),
    [sym__string_array_start] = ACTIONS(5806),
    [sym__symbol_array_start] = ACTIONS(5806),
    [sym__heredoc_body_start] = ACTIONS(5806),
    [sym_heredoc_beginning] = ACTIONS(5806),
    [sym__block_ampersand] = ACTIONS(5806),
    [sym__splat_star] = ACTIONS(5806),
    [sym__unary_minus] = ACTIONS(5806),
    [sym__binary_minus] = ACTIONS(5806),
    [sym__binary_star] = ACTIONS(5806),
    [sym__identifier_hash_key] = ACTIONS(5806),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_RBRACE] = ACTIONS(5806),
    [anon_sym_def] = ACTIONS(5808),
    [anon_sym_LPAREN] = ACTIONS(5808),
    [anon_sym_RPAREN] = ACTIONS(5806),
    [anon_sym_DOT] = ACTIONS(5808),
    [anon_sym_COLON_COLON] = ACTIONS(5808),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_SEMI] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5808),
    [anon_sym_AMP] = ACTIONS(5808),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_class] = ACTIONS(5808),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_module] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_yield] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_next] = ACTIONS(5808),
    [sym_redo] = ACTIONS(5808),
    [sym_retry] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_unless] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_until] = ACTIONS(5808),
    [anon_sym_rescue] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_in] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_begin] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_RBRACK] = ACTIONS(5806),
    [anon_sym_COLON_COLON2] = ACTIONS(5806),
    [anon_sym_AMP_DOT] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_PLUS_EQ] = ACTIONS(5806),
    [anon_sym_DASH_EQ] = ACTIONS(5806),
    [anon_sym_STAR_EQ] = ACTIONS(5806),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5806),
    [anon_sym_AMP_EQ] = ACTIONS(5806),
    [anon_sym_PERCENT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_LT_LT_EQ] = ACTIONS(5806),
    [anon_sym_CARET_EQ] = ACTIONS(5806),
    [anon_sym_QMARK] = ACTIONS(5808),
    [anon_sym_COLON2] = ACTIONS(5808),
    [anon_sym_DOT_DOT] = ACTIONS(5808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5806),
    [anon_sym_and] = ACTIONS(5808),
    [anon_sym_or] = ACTIONS(5808),
    [anon_sym_PIPE_PIPE] = ACTIONS(5808),
    [anon_sym_AMP_AMP] = ACTIONS(5808),
    [anon_sym_LT_LT] = ACTIONS(5808),
    [anon_sym_GT_GT] = ACTIONS(5808),
    [anon_sym_EQ_EQ] = ACTIONS(5808),
    [anon_sym_BANG_EQ] = ACTIONS(5806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(5806),
    [anon_sym_EQ_TILDE] = ACTIONS(5806),
    [anon_sym_BANG_TILDE] = ACTIONS(5806),
    [anon_sym_LT_EQ] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_GT_EQ] = ACTIONS(5806),
    [anon_sym_CARET] = ACTIONS(5808),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_SLASH] = ACTIONS(5808),
    [anon_sym_PERCENT] = ACTIONS(5808),
    [anon_sym_defined_QMARK] = ACTIONS(5806),
    [anon_sym_not] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_TILDE] = ACTIONS(5806),
    [sym_constant] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_instance_variable] = ACTIONS(5806),
    [sym_class_variable] = ACTIONS(5806),
    [sym_global_variable] = ACTIONS(5806),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5808),
    [sym_float] = ACTIONS(5808),
    [sym_complex] = ACTIONS(5806),
    [sym_super] = ACTIONS(5808),
    [anon_sym_true] = ACTIONS(5808),
    [anon_sym_TRUE] = ACTIONS(5808),
    [anon_sym_false] = ACTIONS(5808),
    [anon_sym_FALSE] = ACTIONS(5808),
    [sym_self] = ACTIONS(5808),
    [anon_sym_nil] = ACTIONS(5808),
    [anon_sym_NIL] = ACTIONS(5808),
    [sym_character] = ACTIONS(5806),
    [anon_sym_LBRACK2] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5806),
  },
  [4097] = {
    [sym__simple_symbol] = ACTIONS(5810),
    [sym__string_start] = ACTIONS(5810),
    [sym__symbol_start] = ACTIONS(5810),
    [sym__subshell_start] = ACTIONS(5810),
    [sym__regex_start] = ACTIONS(5810),
    [sym__string_array_start] = ACTIONS(5810),
    [sym__symbol_array_start] = ACTIONS(5810),
    [sym__heredoc_body_start] = ACTIONS(5810),
    [sym_heredoc_beginning] = ACTIONS(5810),
    [sym__block_ampersand] = ACTIONS(5810),
    [sym__splat_star] = ACTIONS(5810),
    [sym__unary_minus] = ACTIONS(5810),
    [sym__binary_minus] = ACTIONS(5810),
    [sym__binary_star] = ACTIONS(5810),
    [sym__identifier_hash_key] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [anon_sym_def] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(5812),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_COLON_COLON] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_PIPE] = ACTIONS(5812),
    [anon_sym_SEMI] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_STAR_STAR] = ACTIONS(5812),
    [anon_sym_AMP] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_class] = ACTIONS(5812),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_module] = ACTIONS(5812),
    [anon_sym_return] = ACTIONS(5812),
    [anon_sym_yield] = ACTIONS(5812),
    [anon_sym_break] = ACTIONS(5812),
    [anon_sym_next] = ACTIONS(5812),
    [sym_redo] = ACTIONS(5812),
    [sym_retry] = ACTIONS(5812),
    [anon_sym_if] = ACTIONS(5812),
    [anon_sym_unless] = ACTIONS(5812),
    [anon_sym_while] = ACTIONS(5812),
    [anon_sym_until] = ACTIONS(5812),
    [anon_sym_rescue] = ACTIONS(5812),
    [anon_sym_for] = ACTIONS(5812),
    [anon_sym_in] = ACTIONS(5812),
    [anon_sym_do] = ACTIONS(5812),
    [anon_sym_case] = ACTIONS(5812),
    [anon_sym_begin] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COLON_COLON2] = ACTIONS(5810),
    [anon_sym_AMP_DOT] = ACTIONS(5810),
    [anon_sym_LPAREN2] = ACTIONS(5810),
    [anon_sym_PLUS_EQ] = ACTIONS(5810),
    [anon_sym_DASH_EQ] = ACTIONS(5810),
    [anon_sym_STAR_EQ] = ACTIONS(5810),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5810),
    [anon_sym_AMP_EQ] = ACTIONS(5810),
    [anon_sym_PERCENT_EQ] = ACTIONS(5810),
    [anon_sym_GT_GT_EQ] = ACTIONS(5810),
    [anon_sym_LT_LT_EQ] = ACTIONS(5810),
    [anon_sym_CARET_EQ] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5812),
    [anon_sym_COLON2] = ACTIONS(5812),
    [anon_sym_DOT_DOT] = ACTIONS(5812),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5810),
    [anon_sym_and] = ACTIONS(5812),
    [anon_sym_or] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_GT_GT] = ACTIONS(5812),
    [anon_sym_EQ_EQ] = ACTIONS(5812),
    [anon_sym_BANG_EQ] = ACTIONS(5810),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(5810),
    [anon_sym_EQ_TILDE] = ACTIONS(5810),
    [anon_sym_BANG_TILDE] = ACTIONS(5810),
    [anon_sym_LT_EQ] = ACTIONS(5812),
    [anon_sym_GT] = ACTIONS(5812),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5812),
    [anon_sym_PLUS] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5812),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_defined_QMARK] = ACTIONS(5810),
    [anon_sym_not] = ACTIONS(5812),
    [anon_sym_BANG] = ACTIONS(5812),
    [anon_sym_TILDE] = ACTIONS(5810),
    [sym_constant] = ACTIONS(5812),
    [sym_identifier] = ACTIONS(5812),
    [sym_instance_variable] = ACTIONS(5810),
    [sym_class_variable] = ACTIONS(5810),
    [sym_global_variable] = ACTIONS(5810),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5812),
    [sym_float] = ACTIONS(5812),
    [sym_complex] = ACTIONS(5810),
    [sym_super] = ACTIONS(5812),
    [anon_sym_true] = ACTIONS(5812),
    [anon_sym_TRUE] = ACTIONS(5812),
    [anon_sym_false] = ACTIONS(5812),
    [anon_sym_FALSE] = ACTIONS(5812),
    [sym_self] = ACTIONS(5812),
    [anon_sym_nil] = ACTIONS(5812),
    [anon_sym_NIL] = ACTIONS(5812),
    [sym_character] = ACTIONS(5810),
    [anon_sym_LBRACK2] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5810),
  },
  [4098] = {
    [sym_argument_list_with_parens] = STATE(6697),
    [sym__argument_list_with_parens] = STATE(4097),
    [sym_operator] = STATE(6697),
    [sym_heredoc_body] = STATE(3546),
    [aux_sym_call_repeat1] = STATE(3546),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(6635),
    [anon_sym_STAR] = ACTIONS(6637),
    [anon_sym_STAR_STAR] = ACTIONS(6635),
    [anon_sym_AMP] = ACTIONS(6635),
    [anon_sym_LT] = ACTIONS(6637),
    [anon_sym_LPAREN2] = ACTIONS(6639),
    [anon_sym_DOT_DOT] = ACTIONS(6635),
    [anon_sym_LT_LT] = ACTIONS(6635),
    [anon_sym_GT_GT] = ACTIONS(6635),
    [anon_sym_EQ_EQ] = ACTIONS(6637),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6635),
    [anon_sym_LT_EQ_GT] = ACTIONS(6635),
    [anon_sym_EQ_TILDE] = ACTIONS(6635),
    [anon_sym_BANG_TILDE] = ACTIONS(6635),
    [anon_sym_LT_EQ] = ACTIONS(6637),
    [anon_sym_GT] = ACTIONS(6637),
    [anon_sym_GT_EQ] = ACTIONS(6635),
    [anon_sym_CARET] = ACTIONS(6635),
    [anon_sym_PLUS] = ACTIONS(6637),
    [anon_sym_SLASH] = ACTIONS(6635),
    [anon_sym_PERCENT] = ACTIONS(6635),
    [anon_sym_BANG] = ACTIONS(6637),
    [anon_sym_TILDE] = ACTIONS(6635),
    [sym_constant] = ACTIONS(9990),
    [sym_identifier] = ACTIONS(9990),
    [anon_sym_DASH] = ACTIONS(6637),
    [anon_sym_PLUS_AT] = ACTIONS(6635),
    [anon_sym_DASH_AT] = ACTIONS(6635),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6637),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6635),
    [anon_sym_BQUOTE] = ACTIONS(6635),
    [sym_comment] = ACTIONS(87),
  },
  [4099] = {
    [sym__heredoc_body_start] = ACTIONS(5816),
    [sym__binary_minus] = ACTIONS(5816),
    [sym__binary_star] = ACTIONS(5816),
    [anon_sym_LBRACE] = ACTIONS(5816),
    [anon_sym_RBRACE] = ACTIONS(5816),
    [anon_sym_RPAREN] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5818),
    [anon_sym_COMMA] = ACTIONS(5816),
    [anon_sym_PIPE] = ACTIONS(5818),
    [anon_sym_SEMI] = ACTIONS(5816),
    [anon_sym_STAR_STAR] = ACTIONS(5818),
    [anon_sym_AMP] = ACTIONS(5818),
    [anon_sym_EQ] = ACTIONS(5818),
    [anon_sym_LT] = ACTIONS(5818),
    [anon_sym_if] = ACTIONS(5816),
    [anon_sym_unless] = ACTIONS(5816),
    [anon_sym_while] = ACTIONS(5816),
    [anon_sym_until] = ACTIONS(5816),
    [anon_sym_rescue] = ACTIONS(5816),
    [anon_sym_in] = ACTIONS(5816),
    [anon_sym_do] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_RBRACK] = ACTIONS(5816),
    [anon_sym_COLON_COLON2] = ACTIONS(5816),
    [anon_sym_AMP_DOT] = ACTIONS(5816),
    [anon_sym_PLUS_EQ] = ACTIONS(5816),
    [anon_sym_DASH_EQ] = ACTIONS(5816),
    [anon_sym_STAR_EQ] = ACTIONS(5816),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5816),
    [anon_sym_SLASH_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_PIPE_EQ] = ACTIONS(5816),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5816),
    [anon_sym_AMP_EQ] = ACTIONS(5816),
    [anon_sym_PERCENT_EQ] = ACTIONS(5816),
    [anon_sym_GT_GT_EQ] = ACTIONS(5816),
    [anon_sym_LT_LT_EQ] = ACTIONS(5816),
    [anon_sym_CARET_EQ] = ACTIONS(5816),
    [anon_sym_QMARK] = ACTIONS(5816),
    [anon_sym_COLON2] = ACTIONS(5818),
    [anon_sym_DOT_DOT] = ACTIONS(5818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5816),
    [anon_sym_and] = ACTIONS(5816),
    [anon_sym_or] = ACTIONS(5816),
    [anon_sym_PIPE_PIPE] = ACTIONS(5818),
    [anon_sym_AMP_AMP] = ACTIONS(5818),
    [anon_sym_LT_LT] = ACTIONS(5818),
    [anon_sym_GT_GT] = ACTIONS(5818),
    [anon_sym_EQ_EQ] = ACTIONS(5818),
    [anon_sym_BANG_EQ] = ACTIONS(5816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5816),
    [anon_sym_LT_EQ_GT] = ACTIONS(5816),
    [anon_sym_EQ_TILDE] = ACTIONS(5816),
    [anon_sym_BANG_TILDE] = ACTIONS(5816),
    [anon_sym_LT_EQ] = ACTIONS(5818),
    [anon_sym_GT] = ACTIONS(5818),
    [anon_sym_GT_EQ] = ACTIONS(5816),
    [anon_sym_CARET] = ACTIONS(5818),
    [anon_sym_PLUS] = ACTIONS(5818),
    [anon_sym_SLASH] = ACTIONS(5818),
    [anon_sym_PERCENT] = ACTIONS(5818),
    [sym_comment] = ACTIONS(87),
  },
  [4100] = {
    [sym_heredoc_body] = STATE(6699),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(9992),
    [sym_comment] = ACTIONS(87),
  },
  [4101] = {
    [anon_sym_RBRACK] = ACTIONS(9992),
    [sym_comment] = ACTIONS(87),
  },
  [4102] = {
    [sym__simple_symbol] = ACTIONS(5822),
    [sym__string_start] = ACTIONS(5822),
    [sym__symbol_start] = ACTIONS(5822),
    [sym__subshell_start] = ACTIONS(5822),
    [sym__regex_start] = ACTIONS(5822),
    [sym__string_array_start] = ACTIONS(5822),
    [sym__symbol_array_start] = ACTIONS(5822),
    [sym__heredoc_body_start] = ACTIONS(5822),
    [sym_heredoc_beginning] = ACTIONS(5822),
    [sym__block_ampersand] = ACTIONS(5822),
    [sym__splat_star] = ACTIONS(5822),
    [sym__unary_minus] = ACTIONS(5822),
    [sym__binary_minus] = ACTIONS(5822),
    [sym__binary_star] = ACTIONS(5822),
    [sym__identifier_hash_key] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_def] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COLON_COLON] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_STAR_STAR] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_class] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_module] = ACTIONS(5824),
    [anon_sym_return] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(5824),
    [anon_sym_break] = ACTIONS(5824),
    [anon_sym_next] = ACTIONS(5824),
    [sym_redo] = ACTIONS(5824),
    [sym_retry] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5824),
    [anon_sym_unless] = ACTIONS(5824),
    [anon_sym_while] = ACTIONS(5824),
    [anon_sym_until] = ACTIONS(5824),
    [anon_sym_rescue] = ACTIONS(5824),
    [anon_sym_for] = ACTIONS(5824),
    [anon_sym_in] = ACTIONS(5824),
    [anon_sym_do] = ACTIONS(5824),
    [anon_sym_case] = ACTIONS(5824),
    [anon_sym_begin] = ACTIONS(5824),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_RBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_LPAREN2] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [anon_sym_DASH_EQ] = ACTIONS(5822),
    [anon_sym_STAR_EQ] = ACTIONS(5822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5822),
    [anon_sym_AMP_EQ] = ACTIONS(5822),
    [anon_sym_PERCENT_EQ] = ACTIONS(5822),
    [anon_sym_GT_GT_EQ] = ACTIONS(5822),
    [anon_sym_LT_LT_EQ] = ACTIONS(5822),
    [anon_sym_CARET_EQ] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5824),
    [anon_sym_COLON2] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5824),
    [anon_sym_or] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [anon_sym_defined_QMARK] = ACTIONS(5822),
    [anon_sym_not] = ACTIONS(5824),
    [anon_sym_BANG] = ACTIONS(5824),
    [anon_sym_TILDE] = ACTIONS(5822),
    [sym_constant] = ACTIONS(5824),
    [sym_identifier] = ACTIONS(5824),
    [sym_instance_variable] = ACTIONS(5822),
    [sym_class_variable] = ACTIONS(5822),
    [sym_global_variable] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5824),
    [sym_float] = ACTIONS(5824),
    [sym_complex] = ACTIONS(5822),
    [sym_super] = ACTIONS(5824),
    [anon_sym_true] = ACTIONS(5824),
    [anon_sym_TRUE] = ACTIONS(5824),
    [anon_sym_false] = ACTIONS(5824),
    [anon_sym_FALSE] = ACTIONS(5824),
    [sym_self] = ACTIONS(5824),
    [anon_sym_nil] = ACTIONS(5824),
    [anon_sym_NIL] = ACTIONS(5824),
    [sym_character] = ACTIONS(5822),
    [anon_sym_LBRACK2] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5822),
  },
  [4103] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6700),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(6700),
    [sym_operator_assignment] = STATE(6700),
    [sym_conditional] = STATE(6700),
    [sym_range] = STATE(6700),
    [sym_binary] = STATE(6700),
    [sym_unary] = STATE(6700),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4104] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(6452),
    [sym__argument_list_with_parens] = STATE(1828),
    [sym__argument] = STATE(1829),
    [sym_splat_argument] = STATE(1829),
    [sym_hash_splat_argument] = STATE(1829),
    [sym_block_argument] = STATE(1829),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1833),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1829),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3186),
    [sym__splat_star] = ACTIONS(3188),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4105] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(6453),
    [sym__argument_list_with_parens] = STATE(1828),
    [sym__argument] = STATE(1829),
    [sym_splat_argument] = STATE(1829),
    [sym_hash_splat_argument] = STATE(1829),
    [sym_block_argument] = STATE(1829),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1833),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1829),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3186),
    [sym__splat_star] = ACTIONS(3188),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4106] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(6454),
    [sym__argument_list_with_parens] = STATE(1828),
    [sym__argument] = STATE(1829),
    [sym_splat_argument] = STATE(1829),
    [sym_hash_splat_argument] = STATE(1829),
    [sym_block_argument] = STATE(1829),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1833),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1829),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3186),
    [sym__splat_star] = ACTIONS(3188),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4107] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(6455),
    [sym__argument_list_with_parens] = STATE(1828),
    [sym__argument] = STATE(1829),
    [sym_splat_argument] = STATE(1829),
    [sym_hash_splat_argument] = STATE(1829),
    [sym_block_argument] = STATE(1829),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1833),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1829),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3186),
    [sym__splat_star] = ACTIONS(3188),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4108] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6701),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(6701),
    [sym_operator_assignment] = STATE(6701),
    [sym_conditional] = STATE(6701),
    [sym_range] = STATE(6701),
    [sym_binary] = STATE(6701),
    [sym_unary] = STATE(6701),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4109] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6470),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(6470),
    [sym_operator_assignment] = STATE(6470),
    [sym_conditional] = STATE(6470),
    [sym_range] = STATE(6470),
    [sym_binary] = STATE(6470),
    [sym_unary] = STATE(6470),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4110] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [4111] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_argument_list] = STATE(4737),
    [sym__argument_list_with_parens] = STATE(1828),
    [sym__argument] = STATE(1829),
    [sym_splat_argument] = STATE(1829),
    [sym_hash_splat_argument] = STATE(1829),
    [sym_block_argument] = STATE(1829),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1833),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(1829),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3186),
    [sym__splat_star] = ACTIONS(3188),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(7471),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4112] = {
    [anon_sym_EQ] = ACTIONS(10022),
    [sym_comment] = ACTIONS(87),
  },
  [4113] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10024),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10026),
    [anon_sym_DASH_EQ] = ACTIONS(10026),
    [anon_sym_STAR_EQ] = ACTIONS(10026),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10026),
    [anon_sym_SLASH_EQ] = ACTIONS(10026),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10026),
    [anon_sym_PIPE_EQ] = ACTIONS(10026),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10026),
    [anon_sym_AMP_EQ] = ACTIONS(10026),
    [anon_sym_PERCENT_EQ] = ACTIONS(10026),
    [anon_sym_GT_GT_EQ] = ACTIONS(10026),
    [anon_sym_LT_LT_EQ] = ACTIONS(10026),
    [anon_sym_CARET_EQ] = ACTIONS(10026),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4114] = {
    [sym_string] = STATE(6714),
    [aux_sym_chained_string_repeat1] = STATE(6714),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4115] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [4116] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [4117] = {
    [sym_string] = STATE(4146),
    [aux_sym_chained_string_repeat1] = STATE(4146),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4118] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6715),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(6715),
    [sym_operator_assignment] = STATE(6715),
    [sym_conditional] = STATE(6715),
    [sym_range] = STATE(6715),
    [sym_binary] = STATE(6715),
    [sym_unary] = STATE(6715),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4119] = {
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_COLON2] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [4120] = {
    [anon_sym_RBRACE] = ACTIONS(10028),
    [sym_comment] = ACTIONS(87),
  },
  [4121] = {
    [sym__statements] = STATE(6717),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10028),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4122] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [4123] = {
    [sym__heredoc_body_start] = ACTIONS(5630),
    [sym__binary_minus] = ACTIONS(5630),
    [sym__binary_star] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5630),
    [anon_sym_RPAREN] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_STAR_STAR] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5632),
    [anon_sym_if] = ACTIONS(5630),
    [anon_sym_unless] = ACTIONS(5630),
    [anon_sym_while] = ACTIONS(5630),
    [anon_sym_until] = ACTIONS(5630),
    [anon_sym_rescue] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5630),
    [anon_sym_do] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_RBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [anon_sym_PLUS_EQ] = ACTIONS(5630),
    [anon_sym_DASH_EQ] = ACTIONS(5630),
    [anon_sym_STAR_EQ] = ACTIONS(5630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5630),
    [anon_sym_SLASH_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_PIPE_EQ] = ACTIONS(5630),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5630),
    [anon_sym_AMP_EQ] = ACTIONS(5630),
    [anon_sym_PERCENT_EQ] = ACTIONS(5630),
    [anon_sym_GT_GT_EQ] = ACTIONS(5630),
    [anon_sym_LT_LT_EQ] = ACTIONS(5630),
    [anon_sym_CARET_EQ] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_COLON2] = ACTIONS(5632),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5632),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5630),
    [anon_sym_EQ_TILDE] = ACTIONS(5630),
    [anon_sym_BANG_TILDE] = ACTIONS(5630),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5632),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [sym_comment] = ACTIONS(87),
  },
  [4124] = {
    [anon_sym_end] = ACTIONS(10030),
    [sym_comment] = ACTIONS(87),
  },
  [4125] = {
    [sym__statements] = STATE(6719),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6720),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(6720),
    [sym__line_break] = ACTIONS(10032),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10034),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4126] = {
    [sym__statements] = STATE(6719),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(6721),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10034),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4127] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [4128] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6722),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(6722),
    [sym_operator_assignment] = STATE(6722),
    [sym_conditional] = STATE(6722),
    [sym_range] = STATE(6722),
    [sym_binary] = STATE(6722),
    [sym_unary] = STATE(6722),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4129] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6723),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6723),
    [sym_operator_assignment] = STATE(6723),
    [sym_conditional] = STATE(6723),
    [sym_range] = STATE(6723),
    [sym_binary] = STATE(6723),
    [sym_unary] = STATE(6723),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4130] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6724),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6724),
    [sym_operator_assignment] = STATE(6724),
    [sym_conditional] = STATE(6724),
    [sym_range] = STATE(6724),
    [sym_binary] = STATE(6724),
    [sym_unary] = STATE(6724),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4131] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6725),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6725),
    [sym_operator_assignment] = STATE(6725),
    [sym_conditional] = STATE(6725),
    [sym_range] = STATE(6725),
    [sym_binary] = STATE(6725),
    [sym_unary] = STATE(6725),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4132] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6726),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6726),
    [sym_operator_assignment] = STATE(6726),
    [sym_conditional] = STATE(6726),
    [sym_range] = STATE(6726),
    [sym_binary] = STATE(6726),
    [sym_unary] = STATE(6726),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4133] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6727),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6727),
    [sym_operator_assignment] = STATE(6727),
    [sym_conditional] = STATE(6727),
    [sym_range] = STATE(6727),
    [sym_binary] = STATE(6727),
    [sym_unary] = STATE(6727),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4134] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6728),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6728),
    [sym_operator_assignment] = STATE(6728),
    [sym_conditional] = STATE(6728),
    [sym_range] = STATE(6728),
    [sym_binary] = STATE(6728),
    [sym_unary] = STATE(6728),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4135] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6729),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6729),
    [sym_operator_assignment] = STATE(6729),
    [sym_conditional] = STATE(6729),
    [sym_range] = STATE(6729),
    [sym_binary] = STATE(6729),
    [sym_unary] = STATE(6729),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4136] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6730),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6730),
    [sym_operator_assignment] = STATE(6730),
    [sym_conditional] = STATE(6730),
    [sym_range] = STATE(6730),
    [sym_binary] = STATE(6730),
    [sym_unary] = STATE(6730),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4137] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6731),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6731),
    [sym_operator_assignment] = STATE(6731),
    [sym_conditional] = STATE(6731),
    [sym_range] = STATE(6731),
    [sym_binary] = STATE(6731),
    [sym_unary] = STATE(6731),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4138] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6732),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6732),
    [sym_operator_assignment] = STATE(6732),
    [sym_conditional] = STATE(6732),
    [sym_range] = STATE(6732),
    [sym_binary] = STATE(6732),
    [sym_unary] = STATE(6732),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4139] = {
    [sym__statements] = STATE(4120),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(4121),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10036),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4140] = {
    [sym__heredoc_body_start] = ACTIONS(6024),
    [sym__binary_minus] = ACTIONS(6024),
    [sym__binary_star] = ACTIONS(6024),
    [anon_sym_LBRACE] = ACTIONS(6024),
    [anon_sym_RBRACE] = ACTIONS(6024),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_DOT] = ACTIONS(6026),
    [anon_sym_COMMA] = ACTIONS(6024),
    [anon_sym_PIPE] = ACTIONS(6026),
    [anon_sym_SEMI] = ACTIONS(6024),
    [anon_sym_STAR_STAR] = ACTIONS(6026),
    [anon_sym_AMP] = ACTIONS(6026),
    [anon_sym_EQ] = ACTIONS(6026),
    [anon_sym_LT] = ACTIONS(6026),
    [anon_sym_if] = ACTIONS(6024),
    [anon_sym_unless] = ACTIONS(6024),
    [anon_sym_while] = ACTIONS(6024),
    [anon_sym_until] = ACTIONS(6024),
    [anon_sym_rescue] = ACTIONS(6024),
    [anon_sym_in] = ACTIONS(6024),
    [anon_sym_do] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_RBRACK] = ACTIONS(6024),
    [anon_sym_COLON_COLON2] = ACTIONS(6024),
    [anon_sym_AMP_DOT] = ACTIONS(6024),
    [anon_sym_PLUS_EQ] = ACTIONS(6024),
    [anon_sym_DASH_EQ] = ACTIONS(6024),
    [anon_sym_STAR_EQ] = ACTIONS(6024),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6024),
    [anon_sym_SLASH_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_PIPE_EQ] = ACTIONS(6024),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6024),
    [anon_sym_AMP_EQ] = ACTIONS(6024),
    [anon_sym_PERCENT_EQ] = ACTIONS(6024),
    [anon_sym_GT_GT_EQ] = ACTIONS(6024),
    [anon_sym_LT_LT_EQ] = ACTIONS(6024),
    [anon_sym_CARET_EQ] = ACTIONS(6024),
    [anon_sym_QMARK] = ACTIONS(6024),
    [anon_sym_COLON2] = ACTIONS(6026),
    [anon_sym_DOT_DOT] = ACTIONS(6026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_or] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(6026),
    [anon_sym_LT_LT] = ACTIONS(6026),
    [anon_sym_GT_GT] = ACTIONS(6026),
    [anon_sym_EQ_EQ] = ACTIONS(6026),
    [anon_sym_BANG_EQ] = ACTIONS(6024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6024),
    [anon_sym_LT_EQ_GT] = ACTIONS(6024),
    [anon_sym_EQ_TILDE] = ACTIONS(6024),
    [anon_sym_BANG_TILDE] = ACTIONS(6024),
    [anon_sym_LT_EQ] = ACTIONS(6026),
    [anon_sym_GT] = ACTIONS(6026),
    [anon_sym_GT_EQ] = ACTIONS(6024),
    [anon_sym_CARET] = ACTIONS(6026),
    [anon_sym_PLUS] = ACTIONS(6026),
    [anon_sym_SLASH] = ACTIONS(6026),
    [anon_sym_PERCENT] = ACTIONS(6026),
    [sym_comment] = ACTIONS(87),
  },
  [4141] = {
    [sym_heredoc_body] = STATE(6734),
    [aux_sym_call_repeat1] = STATE(6734),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4142] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym__argument] = STATE(6514),
    [sym_splat_argument] = STATE(6514),
    [sym_hash_splat_argument] = STATE(6514),
    [sym_block_argument] = STATE(6514),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1833),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(6735),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6514),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3186),
    [sym__splat_star] = ACTIONS(3188),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__identifier_hash_key] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10038),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4143] = {
    [sym_heredoc_body] = STATE(6736),
    [aux_sym_call_repeat1] = STATE(6736),
    [aux_sym_argument_list_repeat1] = STATE(6737),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(6713),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4144] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6738),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_splat_argument] = STATE(6739),
    [sym_assignment] = STATE(6738),
    [sym_operator_assignment] = STATE(6738),
    [sym_conditional] = STATE(6738),
    [sym_range] = STATE(6738),
    [sym_binary] = STATE(6738),
    [sym_unary] = STATE(6738),
    [sym_right_assignment_list] = STATE(4290),
    [sym__arg_or_splat_arg] = STATE(6739),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(6619),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4145] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6740),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(6740),
    [sym_operator_assignment] = STATE(6740),
    [sym_conditional] = STATE(6740),
    [sym_range] = STATE(6740),
    [sym_binary] = STATE(6740),
    [sym_unary] = STATE(6740),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4146] = {
    [sym_string] = STATE(6741),
    [aux_sym_chained_string_repeat1] = STATE(6741),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [4147] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6742),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(6742),
    [sym_operator_assignment] = STATE(6742),
    [sym_conditional] = STATE(6742),
    [sym_range] = STATE(6742),
    [sym_binary] = STATE(6742),
    [sym_unary] = STATE(6742),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4148] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_DOT_DOT] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [4149] = {
    [aux_sym_exceptions_repeat1] = STATE(6744),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4150] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_DOT_DOT] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [4151] = {
    [sym_string] = STATE(4151),
    [aux_sym_chained_string_repeat1] = STATE(4151),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [4152] = {
    [sym__statements] = STATE(578),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(579),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(580),
    [sym_rescue] = STATE(581),
    [sym__body_statement] = STATE(6745),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4153] = {
    [sym__statements] = STATE(578),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(579),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(580),
    [sym_rescue] = STATE(581),
    [sym__body_statement] = STATE(6746),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10042),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4154] = {
    [sym__binary_minus] = ACTIONS(7496),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_LBRACE] = ACTIONS(7496),
    [anon_sym_RBRACE] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(7496),
    [anon_sym_DOT] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7496),
    [anon_sym_unless] = ACTIONS(7496),
    [anon_sym_while] = ACTIONS(7496),
    [anon_sym_until] = ACTIONS(7496),
    [anon_sym_rescue] = ACTIONS(7496),
    [anon_sym_do] = ACTIONS(7496),
    [anon_sym_EQ_GT] = ACTIONS(7496),
    [anon_sym_LBRACK] = ACTIONS(7496),
    [anon_sym_COLON_COLON2] = ACTIONS(7496),
    [anon_sym_AMP_DOT] = ACTIONS(7496),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_COLON2] = ACTIONS(7498),
    [anon_sym_DOT_DOT] = ACTIONS(7498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7496),
    [anon_sym_and] = ACTIONS(7496),
    [anon_sym_or] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT_LT] = ACTIONS(7496),
    [anon_sym_GT_GT] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7498),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7496),
    [anon_sym_LT_EQ_GT] = ACTIONS(7496),
    [anon_sym_EQ_TILDE] = ACTIONS(7496),
    [anon_sym_BANG_TILDE] = ACTIONS(7496),
    [anon_sym_LT_EQ] = ACTIONS(7498),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [4155] = {
    [sym__binary_minus] = ACTIONS(7550),
    [sym__binary_star] = ACTIONS(7550),
    [anon_sym_LBRACE] = ACTIONS(7550),
    [anon_sym_RBRACE] = ACTIONS(7550),
    [anon_sym_RPAREN] = ACTIONS(7550),
    [anon_sym_DOT] = ACTIONS(7552),
    [anon_sym_COMMA] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_SEMI] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7550),
    [anon_sym_unless] = ACTIONS(7550),
    [anon_sym_while] = ACTIONS(7550),
    [anon_sym_until] = ACTIONS(7550),
    [anon_sym_rescue] = ACTIONS(7550),
    [anon_sym_do] = ACTIONS(7550),
    [anon_sym_EQ_GT] = ACTIONS(7550),
    [anon_sym_LBRACK] = ACTIONS(7550),
    [anon_sym_COLON_COLON2] = ACTIONS(7550),
    [anon_sym_AMP_DOT] = ACTIONS(7550),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_COLON2] = ACTIONS(7552),
    [anon_sym_DOT_DOT] = ACTIONS(7552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7550),
    [anon_sym_and] = ACTIONS(7550),
    [anon_sym_or] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT_LT] = ACTIONS(7550),
    [anon_sym_GT_GT] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7552),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7550),
    [anon_sym_LT_EQ_GT] = ACTIONS(7550),
    [anon_sym_EQ_TILDE] = ACTIONS(7550),
    [anon_sym_BANG_TILDE] = ACTIONS(7550),
    [anon_sym_LT_EQ] = ACTIONS(7552),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_PERCENT] = ACTIONS(7550),
    [sym_comment] = ACTIONS(87),
  },
  [4156] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4157] = {
    [sym_heredoc_body] = STATE(6747),
    [aux_sym_call_repeat1] = STATE(6747),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4158] = {
    [sym_heredoc_body] = STATE(6748),
    [aux_sym_call_repeat1] = STATE(6748),
    [aux_sym_argument_list_repeat1] = STATE(4178),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4159] = {
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7608),
    [anon_sym_unless] = ACTIONS(7608),
    [anon_sym_while] = ACTIONS(7608),
    [anon_sym_until] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7608),
    [anon_sym_in] = ACTIONS(7608),
    [anon_sym_do] = ACTIONS(7608),
    [anon_sym_EQ_GT] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_RBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7608),
    [anon_sym_COLON2] = ACTIONS(7610),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7608),
    [anon_sym_or] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE] = ACTIONS(7608),
    [anon_sym_AMP_AMP] = ACTIONS(7608),
    [anon_sym_LT_LT] = ACTIONS(7608),
    [anon_sym_GT_GT] = ACTIONS(7608),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7608),
    [anon_sym_PLUS] = ACTIONS(7608),
    [anon_sym_SLASH] = ACTIONS(7608),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
  },
  [4160] = {
    [anon_sym_RPAREN] = ACTIONS(10044),
    [sym_comment] = ACTIONS(87),
  },
  [4161] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4162] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4163] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [4164] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4165] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4166] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4167] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10046),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4168] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4169] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4170] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4171] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4172] = {
    [sym__heredoc_body_start] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__binary_star] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(4854),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(4854),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_STAR_STAR] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(4854),
    [anon_sym_EQ] = ACTIONS(4854),
    [anon_sym_LT] = ACTIONS(4854),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_unless] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_until] = ACTIONS(3102),
    [anon_sym_rescue] = ACTIONS(3102),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_EQ_GT] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_RBRACK] = ACTIONS(3102),
    [anon_sym_COLON_COLON2] = ACTIONS(3102),
    [anon_sym_AMP_DOT] = ACTIONS(3102),
    [anon_sym_QMARK] = ACTIONS(3102),
    [anon_sym_COLON2] = ACTIONS(4854),
    [anon_sym_DOT_DOT] = ACTIONS(4854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_and] = ACTIONS(3102),
    [anon_sym_or] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(3102),
    [anon_sym_AMP_AMP] = ACTIONS(3102),
    [anon_sym_LT_LT] = ACTIONS(3102),
    [anon_sym_GT_GT] = ACTIONS(3102),
    [anon_sym_EQ_EQ] = ACTIONS(4854),
    [anon_sym_BANG_EQ] = ACTIONS(3102),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
    [anon_sym_LT_EQ_GT] = ACTIONS(3102),
    [anon_sym_EQ_TILDE] = ACTIONS(3102),
    [anon_sym_BANG_TILDE] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(4854),
    [anon_sym_GT] = ACTIONS(4854),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_PERCENT] = ACTIONS(3102),
    [sym_comment] = ACTIONS(87),
  },
  [4173] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(10048),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [4174] = {
    [sym_heredoc_body] = STATE(4174),
    [aux_sym_call_repeat1] = STATE(4174),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [4175] = {
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(7657),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_in] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_RBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_COLON2] = ACTIONS(7659),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [4176] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(560),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(560),
    [sym_operator_assignment] = STATE(560),
    [sym_conditional] = STATE(560),
    [sym_range] = STATE(560),
    [sym_binary] = STATE(560),
    [sym_unary] = STATE(560),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(567),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1045),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4177] = {
    [sym_heredoc_body] = STATE(4174),
    [aux_sym_call_repeat1] = STATE(4174),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [4178] = {
    [aux_sym_argument_list_repeat1] = STATE(4178),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(10053),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [4179] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4180] = {
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_in] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_COLON2] = ACTIONS(6062),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4181] = {
    [aux_sym_exceptions_repeat1] = STATE(6754),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4182] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4183] = {
    [sym_string] = STATE(4183),
    [aux_sym_chained_string_repeat1] = STATE(4183),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [4184] = {
    [sym__binary_minus] = ACTIONS(7724),
    [sym__binary_star] = ACTIONS(7724),
    [anon_sym_LBRACE] = ACTIONS(7724),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_DOT] = ACTIONS(7726),
    [anon_sym_COMMA] = ACTIONS(7724),
    [anon_sym_PIPE] = ACTIONS(7726),
    [anon_sym_SEMI] = ACTIONS(7724),
    [anon_sym_STAR_STAR] = ACTIONS(7724),
    [anon_sym_AMP] = ACTIONS(7726),
    [anon_sym_LT] = ACTIONS(7726),
    [anon_sym_if] = ACTIONS(7724),
    [anon_sym_unless] = ACTIONS(7724),
    [anon_sym_while] = ACTIONS(7724),
    [anon_sym_until] = ACTIONS(7724),
    [anon_sym_rescue] = ACTIONS(7724),
    [anon_sym_do] = ACTIONS(7724),
    [anon_sym_EQ_GT] = ACTIONS(7724),
    [anon_sym_LBRACK] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(7724),
    [anon_sym_AMP_DOT] = ACTIONS(7724),
    [anon_sym_QMARK] = ACTIONS(7724),
    [anon_sym_COLON2] = ACTIONS(7726),
    [anon_sym_DOT_DOT] = ACTIONS(7726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7724),
    [anon_sym_and] = ACTIONS(7724),
    [anon_sym_or] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE] = ACTIONS(7724),
    [anon_sym_AMP_AMP] = ACTIONS(7724),
    [anon_sym_LT_LT] = ACTIONS(7724),
    [anon_sym_GT_GT] = ACTIONS(7724),
    [anon_sym_EQ_EQ] = ACTIONS(7726),
    [anon_sym_BANG_EQ] = ACTIONS(7724),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7724),
    [anon_sym_LT_EQ_GT] = ACTIONS(7724),
    [anon_sym_EQ_TILDE] = ACTIONS(7724),
    [anon_sym_BANG_TILDE] = ACTIONS(7724),
    [anon_sym_LT_EQ] = ACTIONS(7726),
    [anon_sym_GT] = ACTIONS(7726),
    [anon_sym_GT_EQ] = ACTIONS(7724),
    [anon_sym_CARET] = ACTIONS(7724),
    [anon_sym_PLUS] = ACTIONS(7724),
    [anon_sym_SLASH] = ACTIONS(7724),
    [anon_sym_PERCENT] = ACTIONS(7724),
    [sym_comment] = ACTIONS(87),
  },
  [4185] = {
    [sym_elsif] = STATE(6756),
    [sym_else] = STATE(6756),
    [sym__if_tail] = STATE(6756),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [4186] = {
    [anon_sym_end] = ACTIONS(10056),
    [sym_comment] = ACTIONS(87),
  },
  [4187] = {
    [sym__statements] = STATE(6757),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(6756),
    [sym_else] = STATE(6756),
    [sym__if_tail] = STATE(6756),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10058),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4188] = {
    [sym__binary_minus] = ACTIONS(7922),
    [sym__binary_star] = ACTIONS(7922),
    [anon_sym_LBRACE] = ACTIONS(7922),
    [anon_sym_RBRACE] = ACTIONS(7922),
    [anon_sym_RPAREN] = ACTIONS(7922),
    [anon_sym_DOT] = ACTIONS(7924),
    [anon_sym_COMMA] = ACTIONS(7922),
    [anon_sym_PIPE] = ACTIONS(7924),
    [anon_sym_SEMI] = ACTIONS(7922),
    [anon_sym_STAR_STAR] = ACTIONS(7922),
    [anon_sym_AMP] = ACTIONS(7924),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(7922),
    [anon_sym_unless] = ACTIONS(7922),
    [anon_sym_while] = ACTIONS(7922),
    [anon_sym_until] = ACTIONS(7922),
    [anon_sym_rescue] = ACTIONS(7922),
    [anon_sym_do] = ACTIONS(7922),
    [anon_sym_EQ_GT] = ACTIONS(7922),
    [anon_sym_LBRACK] = ACTIONS(7922),
    [anon_sym_COLON_COLON2] = ACTIONS(7922),
    [anon_sym_AMP_DOT] = ACTIONS(7922),
    [anon_sym_QMARK] = ACTIONS(7922),
    [anon_sym_COLON2] = ACTIONS(7924),
    [anon_sym_DOT_DOT] = ACTIONS(7924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7922),
    [anon_sym_and] = ACTIONS(7922),
    [anon_sym_or] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE] = ACTIONS(7922),
    [anon_sym_AMP_AMP] = ACTIONS(7922),
    [anon_sym_LT_LT] = ACTIONS(7922),
    [anon_sym_GT_GT] = ACTIONS(7922),
    [anon_sym_EQ_EQ] = ACTIONS(7924),
    [anon_sym_BANG_EQ] = ACTIONS(7922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7922),
    [anon_sym_LT_EQ_GT] = ACTIONS(7922),
    [anon_sym_EQ_TILDE] = ACTIONS(7922),
    [anon_sym_BANG_TILDE] = ACTIONS(7922),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7922),
    [anon_sym_CARET] = ACTIONS(7922),
    [anon_sym_PLUS] = ACTIONS(7922),
    [anon_sym_SLASH] = ACTIONS(7922),
    [anon_sym_PERCENT] = ACTIONS(7922),
    [sym_comment] = ACTIONS(87),
  },
  [4189] = {
    [sym_else] = STATE(6759),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [4190] = {
    [anon_sym_end] = ACTIONS(10060),
    [sym_comment] = ACTIONS(87),
  },
  [4191] = {
    [sym__binary_minus] = ACTIONS(8090),
    [sym__binary_star] = ACTIONS(8090),
    [anon_sym_LBRACE] = ACTIONS(8090),
    [anon_sym_RBRACE] = ACTIONS(8090),
    [anon_sym_RPAREN] = ACTIONS(8090),
    [anon_sym_DOT] = ACTIONS(8092),
    [anon_sym_COMMA] = ACTIONS(8090),
    [anon_sym_PIPE] = ACTIONS(8092),
    [anon_sym_SEMI] = ACTIONS(8090),
    [anon_sym_STAR_STAR] = ACTIONS(8090),
    [anon_sym_AMP] = ACTIONS(8092),
    [anon_sym_LT] = ACTIONS(8092),
    [anon_sym_if] = ACTIONS(8090),
    [anon_sym_unless] = ACTIONS(8090),
    [anon_sym_while] = ACTIONS(8090),
    [anon_sym_until] = ACTIONS(8090),
    [anon_sym_rescue] = ACTIONS(8090),
    [anon_sym_do] = ACTIONS(8090),
    [anon_sym_EQ_GT] = ACTIONS(8090),
    [anon_sym_LBRACK] = ACTIONS(8090),
    [anon_sym_COLON_COLON2] = ACTIONS(8090),
    [anon_sym_AMP_DOT] = ACTIONS(8090),
    [anon_sym_QMARK] = ACTIONS(8090),
    [anon_sym_COLON2] = ACTIONS(8092),
    [anon_sym_DOT_DOT] = ACTIONS(8092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8090),
    [anon_sym_and] = ACTIONS(8090),
    [anon_sym_or] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE] = ACTIONS(8090),
    [anon_sym_AMP_AMP] = ACTIONS(8090),
    [anon_sym_LT_LT] = ACTIONS(8090),
    [anon_sym_GT_GT] = ACTIONS(8090),
    [anon_sym_EQ_EQ] = ACTIONS(8092),
    [anon_sym_BANG_EQ] = ACTIONS(8090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8090),
    [anon_sym_LT_EQ_GT] = ACTIONS(8090),
    [anon_sym_EQ_TILDE] = ACTIONS(8090),
    [anon_sym_BANG_TILDE] = ACTIONS(8090),
    [anon_sym_LT_EQ] = ACTIONS(8092),
    [anon_sym_GT] = ACTIONS(8092),
    [anon_sym_GT_EQ] = ACTIONS(8090),
    [anon_sym_CARET] = ACTIONS(8090),
    [anon_sym_PLUS] = ACTIONS(8090),
    [anon_sym_SLASH] = ACTIONS(8090),
    [anon_sym_PERCENT] = ACTIONS(8090),
    [sym_comment] = ACTIONS(87),
  },
  [4192] = {
    [anon_sym_end] = ACTIONS(10062),
    [sym_comment] = ACTIONS(87),
  },
  [4193] = {
    [sym__binary_minus] = ACTIONS(8166),
    [sym__binary_star] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_DOT] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8166),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI] = ACTIONS(8166),
    [anon_sym_STAR_STAR] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_if] = ACTIONS(8166),
    [anon_sym_unless] = ACTIONS(8166),
    [anon_sym_while] = ACTIONS(8166),
    [anon_sym_until] = ACTIONS(8166),
    [anon_sym_rescue] = ACTIONS(8166),
    [anon_sym_do] = ACTIONS(8166),
    [anon_sym_EQ_GT] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_COLON_COLON2] = ACTIONS(8166),
    [anon_sym_AMP_DOT] = ACTIONS(8166),
    [anon_sym_QMARK] = ACTIONS(8166),
    [anon_sym_COLON2] = ACTIONS(8168),
    [anon_sym_DOT_DOT] = ACTIONS(8168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8166),
    [anon_sym_and] = ACTIONS(8166),
    [anon_sym_or] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8166),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ_GT] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_BANG_TILDE] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8166),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8166),
    [anon_sym_PERCENT] = ACTIONS(8166),
    [sym_comment] = ACTIONS(87),
  },
  [4194] = {
    [anon_sym_end] = ACTIONS(10064),
    [sym_comment] = ACTIONS(87),
  },
  [4195] = {
    [sym__statements] = STATE(6763),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10066),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4196] = {
    [anon_sym_end] = ACTIONS(10068),
    [sym_comment] = ACTIONS(87),
  },
  [4197] = {
    [sym_when] = STATE(6765),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4198] = {
    [sym__binary_minus] = ACTIONS(8414),
    [sym__binary_star] = ACTIONS(8414),
    [anon_sym_LBRACE] = ACTIONS(8414),
    [anon_sym_RBRACE] = ACTIONS(8414),
    [anon_sym_RPAREN] = ACTIONS(8414),
    [anon_sym_DOT] = ACTIONS(8416),
    [anon_sym_COMMA] = ACTIONS(8414),
    [anon_sym_PIPE] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8414),
    [anon_sym_STAR_STAR] = ACTIONS(8414),
    [anon_sym_AMP] = ACTIONS(8416),
    [anon_sym_LT] = ACTIONS(8416),
    [anon_sym_if] = ACTIONS(8414),
    [anon_sym_unless] = ACTIONS(8414),
    [anon_sym_while] = ACTIONS(8414),
    [anon_sym_until] = ACTIONS(8414),
    [anon_sym_rescue] = ACTIONS(8414),
    [anon_sym_do] = ACTIONS(8414),
    [anon_sym_EQ_GT] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8414),
    [anon_sym_COLON_COLON2] = ACTIONS(8414),
    [anon_sym_AMP_DOT] = ACTIONS(8414),
    [anon_sym_QMARK] = ACTIONS(8414),
    [anon_sym_COLON2] = ACTIONS(8416),
    [anon_sym_DOT_DOT] = ACTIONS(8416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8414),
    [anon_sym_and] = ACTIONS(8414),
    [anon_sym_or] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE] = ACTIONS(8414),
    [anon_sym_AMP_AMP] = ACTIONS(8414),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8414),
    [anon_sym_LT_EQ_GT] = ACTIONS(8414),
    [anon_sym_EQ_TILDE] = ACTIONS(8414),
    [anon_sym_BANG_TILDE] = ACTIONS(8414),
    [anon_sym_LT_EQ] = ACTIONS(8416),
    [anon_sym_GT] = ACTIONS(8416),
    [anon_sym_GT_EQ] = ACTIONS(8414),
    [anon_sym_CARET] = ACTIONS(8414),
    [anon_sym_PLUS] = ACTIONS(8414),
    [anon_sym_SLASH] = ACTIONS(8414),
    [anon_sym_PERCENT] = ACTIONS(8414),
    [sym_comment] = ACTIONS(87),
  },
  [4199] = {
    [sym__binary_minus] = ACTIONS(8923),
    [sym__binary_star] = ACTIONS(8923),
    [anon_sym_LBRACE] = ACTIONS(8923),
    [anon_sym_RBRACE] = ACTIONS(8923),
    [anon_sym_RPAREN] = ACTIONS(8923),
    [anon_sym_DOT] = ACTIONS(8925),
    [anon_sym_COMMA] = ACTIONS(8923),
    [anon_sym_PIPE] = ACTIONS(8925),
    [anon_sym_SEMI] = ACTIONS(8923),
    [anon_sym_STAR_STAR] = ACTIONS(8923),
    [anon_sym_AMP] = ACTIONS(8925),
    [anon_sym_LT] = ACTIONS(8925),
    [anon_sym_if] = ACTIONS(8923),
    [anon_sym_unless] = ACTIONS(8923),
    [anon_sym_while] = ACTIONS(8923),
    [anon_sym_until] = ACTIONS(8923),
    [anon_sym_rescue] = ACTIONS(8923),
    [anon_sym_do] = ACTIONS(8923),
    [anon_sym_EQ_GT] = ACTIONS(8923),
    [anon_sym_LBRACK] = ACTIONS(8923),
    [anon_sym_COLON_COLON2] = ACTIONS(8923),
    [anon_sym_AMP_DOT] = ACTIONS(8923),
    [anon_sym_QMARK] = ACTIONS(8923),
    [anon_sym_COLON2] = ACTIONS(8925),
    [anon_sym_DOT_DOT] = ACTIONS(8925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8923),
    [anon_sym_and] = ACTIONS(8923),
    [anon_sym_or] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8923),
    [anon_sym_GT_GT] = ACTIONS(8923),
    [anon_sym_EQ_EQ] = ACTIONS(8925),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8925),
    [anon_sym_GT] = ACTIONS(8925),
    [anon_sym_GT_EQ] = ACTIONS(8923),
    [anon_sym_CARET] = ACTIONS(8923),
    [anon_sym_PLUS] = ACTIONS(8923),
    [anon_sym_SLASH] = ACTIONS(8923),
    [anon_sym_PERCENT] = ACTIONS(8923),
    [sym_comment] = ACTIONS(87),
  },
  [4200] = {
    [anon_sym_end] = ACTIONS(10070),
    [sym_comment] = ACTIONS(87),
  },
  [4201] = {
    [sym_ensure] = STATE(6767),
    [anon_sym_end] = ACTIONS(10070),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [4202] = {
    [sym__binary_minus] = ACTIONS(9143),
    [sym__binary_star] = ACTIONS(9143),
    [anon_sym_LBRACE] = ACTIONS(9143),
    [anon_sym_RBRACE] = ACTIONS(9143),
    [anon_sym_RPAREN] = ACTIONS(9143),
    [anon_sym_DOT] = ACTIONS(9145),
    [anon_sym_COMMA] = ACTIONS(9143),
    [anon_sym_PIPE] = ACTIONS(9145),
    [anon_sym_SEMI] = ACTIONS(9143),
    [anon_sym_STAR_STAR] = ACTIONS(9143),
    [anon_sym_AMP] = ACTIONS(9145),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_if] = ACTIONS(9143),
    [anon_sym_unless] = ACTIONS(9143),
    [anon_sym_while] = ACTIONS(9143),
    [anon_sym_until] = ACTIONS(9143),
    [anon_sym_rescue] = ACTIONS(9143),
    [anon_sym_do] = ACTIONS(9143),
    [anon_sym_EQ_GT] = ACTIONS(9143),
    [anon_sym_LBRACK] = ACTIONS(9143),
    [anon_sym_COLON_COLON2] = ACTIONS(9143),
    [anon_sym_AMP_DOT] = ACTIONS(9143),
    [anon_sym_QMARK] = ACTIONS(9143),
    [anon_sym_COLON2] = ACTIONS(9145),
    [anon_sym_DOT_DOT] = ACTIONS(9145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9143),
    [anon_sym_and] = ACTIONS(9143),
    [anon_sym_or] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE] = ACTIONS(9143),
    [anon_sym_AMP_AMP] = ACTIONS(9143),
    [anon_sym_LT_LT] = ACTIONS(9143),
    [anon_sym_GT_GT] = ACTIONS(9143),
    [anon_sym_EQ_EQ] = ACTIONS(9145),
    [anon_sym_BANG_EQ] = ACTIONS(9143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9143),
    [anon_sym_LT_EQ_GT] = ACTIONS(9143),
    [anon_sym_EQ_TILDE] = ACTIONS(9143),
    [anon_sym_BANG_TILDE] = ACTIONS(9143),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9143),
    [anon_sym_CARET] = ACTIONS(9143),
    [anon_sym_PLUS] = ACTIONS(9143),
    [anon_sym_SLASH] = ACTIONS(9143),
    [anon_sym_PERCENT] = ACTIONS(9143),
    [sym_comment] = ACTIONS(87),
  },
  [4203] = {
    [sym__binary_minus] = ACTIONS(9172),
    [sym__binary_star] = ACTIONS(9172),
    [anon_sym_LBRACE] = ACTIONS(9172),
    [anon_sym_RBRACE] = ACTIONS(9172),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9174),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9174),
    [anon_sym_SEMI] = ACTIONS(9172),
    [anon_sym_STAR_STAR] = ACTIONS(9172),
    [anon_sym_AMP] = ACTIONS(9174),
    [anon_sym_LT] = ACTIONS(9174),
    [anon_sym_if] = ACTIONS(9172),
    [anon_sym_unless] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(9172),
    [anon_sym_until] = ACTIONS(9172),
    [anon_sym_rescue] = ACTIONS(9172),
    [anon_sym_do] = ACTIONS(9172),
    [anon_sym_EQ_GT] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [anon_sym_QMARK] = ACTIONS(9172),
    [anon_sym_COLON2] = ACTIONS(9174),
    [anon_sym_DOT_DOT] = ACTIONS(9174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9172),
    [anon_sym_and] = ACTIONS(9172),
    [anon_sym_or] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE] = ACTIONS(9172),
    [anon_sym_AMP_AMP] = ACTIONS(9172),
    [anon_sym_LT_LT] = ACTIONS(9172),
    [anon_sym_GT_GT] = ACTIONS(9172),
    [anon_sym_EQ_EQ] = ACTIONS(9174),
    [anon_sym_BANG_EQ] = ACTIONS(9172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9172),
    [anon_sym_LT_EQ_GT] = ACTIONS(9172),
    [anon_sym_EQ_TILDE] = ACTIONS(9172),
    [anon_sym_BANG_TILDE] = ACTIONS(9172),
    [anon_sym_LT_EQ] = ACTIONS(9174),
    [anon_sym_GT] = ACTIONS(9174),
    [anon_sym_GT_EQ] = ACTIONS(9172),
    [anon_sym_CARET] = ACTIONS(9172),
    [anon_sym_PLUS] = ACTIONS(9172),
    [anon_sym_SLASH] = ACTIONS(9172),
    [anon_sym_PERCENT] = ACTIONS(9172),
    [sym_comment] = ACTIONS(87),
  },
  [4204] = {
    [anon_sym_RBRACE] = ACTIONS(10072),
    [sym_comment] = ACTIONS(87),
  },
  [4205] = {
    [sym__binary_minus] = ACTIONS(9192),
    [sym__binary_star] = ACTIONS(9192),
    [anon_sym_LBRACE] = ACTIONS(9192),
    [anon_sym_RBRACE] = ACTIONS(9192),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9194),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9194),
    [anon_sym_SEMI] = ACTIONS(9192),
    [anon_sym_STAR_STAR] = ACTIONS(9192),
    [anon_sym_AMP] = ACTIONS(9194),
    [anon_sym_LT] = ACTIONS(9194),
    [anon_sym_if] = ACTIONS(9192),
    [anon_sym_unless] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(9192),
    [anon_sym_until] = ACTIONS(9192),
    [anon_sym_rescue] = ACTIONS(9192),
    [anon_sym_do] = ACTIONS(9192),
    [anon_sym_EQ_GT] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [anon_sym_QMARK] = ACTIONS(9192),
    [anon_sym_COLON2] = ACTIONS(9194),
    [anon_sym_DOT_DOT] = ACTIONS(9194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9192),
    [anon_sym_and] = ACTIONS(9192),
    [anon_sym_or] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE] = ACTIONS(9192),
    [anon_sym_AMP_AMP] = ACTIONS(9192),
    [anon_sym_LT_LT] = ACTIONS(9192),
    [anon_sym_GT_GT] = ACTIONS(9192),
    [anon_sym_EQ_EQ] = ACTIONS(9194),
    [anon_sym_BANG_EQ] = ACTIONS(9192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9192),
    [anon_sym_LT_EQ_GT] = ACTIONS(9192),
    [anon_sym_EQ_TILDE] = ACTIONS(9192),
    [anon_sym_BANG_TILDE] = ACTIONS(9192),
    [anon_sym_LT_EQ] = ACTIONS(9194),
    [anon_sym_GT] = ACTIONS(9194),
    [anon_sym_GT_EQ] = ACTIONS(9192),
    [anon_sym_CARET] = ACTIONS(9192),
    [anon_sym_PLUS] = ACTIONS(9192),
    [anon_sym_SLASH] = ACTIONS(9192),
    [anon_sym_PERCENT] = ACTIONS(9192),
    [sym_comment] = ACTIONS(87),
  },
  [4206] = {
    [anon_sym_end] = ACTIONS(10074),
    [sym_comment] = ACTIONS(87),
  },
  [4207] = {
    [sym__statements] = STATE(6770),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4208] = {
    [sym__statements] = STATE(6770),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6771),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(6771),
    [sym__line_break] = ACTIONS(10078),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4209] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6772),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(118),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(118),
    [sym_assignment] = STATE(6772),
    [sym_operator_assignment] = STATE(6772),
    [sym_conditional] = STATE(6772),
    [sym_range] = STATE(6772),
    [sym_binary] = STATE(6772),
    [sym_unary] = STATE(6772),
    [sym_left_assignment_list] = STATE(117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(118),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(118),
    [sym_false] = STATE(118),
    [sym_nil] = STATE(118),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(513),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4210] = {
    [sym__simple_symbol] = ACTIONS(4148),
    [sym__string_start] = ACTIONS(4148),
    [sym__symbol_start] = ACTIONS(4148),
    [sym__subshell_start] = ACTIONS(4148),
    [sym__regex_start] = ACTIONS(4148),
    [sym__string_array_start] = ACTIONS(4148),
    [sym__symbol_array_start] = ACTIONS(4148),
    [sym_heredoc_beginning] = ACTIONS(4148),
    [sym__block_ampersand] = ACTIONS(4148),
    [sym__splat_star] = ACTIONS(4148),
    [sym__unary_minus] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [sym__identifier_hash_key] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_def] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(4150),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COLON_COLON] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_STAR_STAR] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_class] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_module] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_yield] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_next] = ACTIONS(4150),
    [sym_redo] = ACTIONS(4150),
    [sym_retry] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_unless] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [anon_sym_until] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_do] = ACTIONS(4150),
    [anon_sym_case] = ACTIONS(4150),
    [anon_sym_begin] = ACTIONS(4150),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4150),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_defined_QMARK] = ACTIONS(4148),
    [anon_sym_not] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_TILDE] = ACTIONS(4148),
    [sym_constant] = ACTIONS(4150),
    [sym_identifier] = ACTIONS(4150),
    [sym_instance_variable] = ACTIONS(4148),
    [sym_class_variable] = ACTIONS(4148),
    [sym_global_variable] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4150),
    [sym_float] = ACTIONS(4150),
    [sym_complex] = ACTIONS(4148),
    [sym_super] = ACTIONS(4150),
    [anon_sym_true] = ACTIONS(4150),
    [anon_sym_TRUE] = ACTIONS(4150),
    [anon_sym_false] = ACTIONS(4150),
    [anon_sym_FALSE] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [anon_sym_nil] = ACTIONS(4150),
    [anon_sym_NIL] = ACTIONS(4150),
    [sym_character] = ACTIONS(4148),
    [anon_sym_LBRACK2] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4148),
  },
  [4211] = {
    [sym_heredoc_body] = STATE(6774),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(10080),
    [sym_comment] = ACTIONS(87),
  },
  [4212] = {
    [anon_sym_RPAREN] = ACTIONS(10080),
    [sym_comment] = ACTIONS(87),
  },
  [4213] = {
    [sym__simple_symbol] = ACTIONS(9425),
    [sym__string_start] = ACTIONS(9425),
    [sym__symbol_start] = ACTIONS(9425),
    [sym__subshell_start] = ACTIONS(9425),
    [sym__regex_start] = ACTIONS(9425),
    [sym__string_array_start] = ACTIONS(9425),
    [sym__symbol_array_start] = ACTIONS(9425),
    [sym_heredoc_beginning] = ACTIONS(9425),
    [sym__block_ampersand] = ACTIONS(9425),
    [sym__splat_star] = ACTIONS(9425),
    [sym__unary_minus] = ACTIONS(9425),
    [sym__binary_minus] = ACTIONS(9425),
    [sym__binary_star] = ACTIONS(9425),
    [sym__identifier_hash_key] = ACTIONS(9425),
    [anon_sym_LBRACE] = ACTIONS(9425),
    [anon_sym_def] = ACTIONS(9427),
    [anon_sym_LPAREN] = ACTIONS(9427),
    [anon_sym_DOT] = ACTIONS(9427),
    [anon_sym_COLON_COLON] = ACTIONS(9427),
    [anon_sym_COMMA] = ACTIONS(9425),
    [anon_sym_PIPE] = ACTIONS(9427),
    [anon_sym_STAR] = ACTIONS(9427),
    [anon_sym_STAR_STAR] = ACTIONS(9427),
    [anon_sym_AMP] = ACTIONS(9427),
    [anon_sym_EQ] = ACTIONS(9427),
    [anon_sym_class] = ACTIONS(9427),
    [anon_sym_LT] = ACTIONS(9427),
    [anon_sym_module] = ACTIONS(9427),
    [anon_sym_return] = ACTIONS(9427),
    [anon_sym_yield] = ACTIONS(9427),
    [anon_sym_break] = ACTIONS(9427),
    [anon_sym_next] = ACTIONS(9427),
    [sym_redo] = ACTIONS(9427),
    [sym_retry] = ACTIONS(9427),
    [anon_sym_if] = ACTIONS(9427),
    [anon_sym_unless] = ACTIONS(9427),
    [anon_sym_while] = ACTIONS(9427),
    [anon_sym_until] = ACTIONS(9427),
    [anon_sym_for] = ACTIONS(9427),
    [anon_sym_do] = ACTIONS(9427),
    [anon_sym_case] = ACTIONS(9427),
    [anon_sym_begin] = ACTIONS(9427),
    [anon_sym_EQ_GT] = ACTIONS(9425),
    [anon_sym_LBRACK] = ACTIONS(9425),
    [anon_sym_COLON_COLON2] = ACTIONS(9425),
    [anon_sym_AMP_DOT] = ACTIONS(9425),
    [anon_sym_LPAREN2] = ACTIONS(9425),
    [anon_sym_PLUS_EQ] = ACTIONS(9425),
    [anon_sym_DASH_EQ] = ACTIONS(9425),
    [anon_sym_STAR_EQ] = ACTIONS(9425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9425),
    [anon_sym_SLASH_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9425),
    [anon_sym_AMP_EQ] = ACTIONS(9425),
    [anon_sym_PERCENT_EQ] = ACTIONS(9425),
    [anon_sym_GT_GT_EQ] = ACTIONS(9425),
    [anon_sym_LT_LT_EQ] = ACTIONS(9425),
    [anon_sym_CARET_EQ] = ACTIONS(9425),
    [anon_sym_QMARK] = ACTIONS(9427),
    [anon_sym_DOT_DOT] = ACTIONS(9427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9425),
    [anon_sym_and] = ACTIONS(9427),
    [anon_sym_or] = ACTIONS(9427),
    [anon_sym_PIPE_PIPE] = ACTIONS(9427),
    [anon_sym_AMP_AMP] = ACTIONS(9427),
    [anon_sym_LT_LT] = ACTIONS(9427),
    [anon_sym_GT_GT] = ACTIONS(9427),
    [anon_sym_EQ_EQ] = ACTIONS(9427),
    [anon_sym_BANG_EQ] = ACTIONS(9425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9425),
    [anon_sym_LT_EQ_GT] = ACTIONS(9425),
    [anon_sym_EQ_TILDE] = ACTIONS(9425),
    [anon_sym_BANG_TILDE] = ACTIONS(9425),
    [anon_sym_LT_EQ] = ACTIONS(9427),
    [anon_sym_GT] = ACTIONS(9427),
    [anon_sym_GT_EQ] = ACTIONS(9425),
    [anon_sym_CARET] = ACTIONS(9427),
    [anon_sym_PLUS] = ACTIONS(9427),
    [anon_sym_SLASH] = ACTIONS(9427),
    [anon_sym_PERCENT] = ACTIONS(9427),
    [anon_sym_defined_QMARK] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [anon_sym_BANG] = ACTIONS(9427),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_constant] = ACTIONS(9427),
    [sym_identifier] = ACTIONS(9427),
    [sym_instance_variable] = ACTIONS(9425),
    [sym_class_variable] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(9425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9427),
    [sym_float] = ACTIONS(9427),
    [sym_complex] = ACTIONS(9425),
    [sym_super] = ACTIONS(9427),
    [anon_sym_true] = ACTIONS(9427),
    [anon_sym_TRUE] = ACTIONS(9427),
    [anon_sym_false] = ACTIONS(9427),
    [anon_sym_FALSE] = ACTIONS(9427),
    [sym_self] = ACTIONS(9427),
    [anon_sym_nil] = ACTIONS(9427),
    [anon_sym_NIL] = ACTIONS(9427),
    [sym_character] = ACTIONS(9425),
    [anon_sym_LBRACK2] = ACTIONS(9427),
    [anon_sym_DASH_GT] = ACTIONS(9425),
  },
  [4214] = {
    [sym__binary_minus] = ACTIONS(9432),
    [sym__binary_star] = ACTIONS(9432),
    [anon_sym_DOT] = ACTIONS(9434),
    [anon_sym_COMMA] = ACTIONS(9432),
    [anon_sym_PIPE] = ACTIONS(9434),
    [anon_sym_STAR_STAR] = ACTIONS(9434),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_EQ] = ACTIONS(9434),
    [anon_sym_LT] = ACTIONS(9434),
    [anon_sym_EQ_GT] = ACTIONS(9432),
    [anon_sym_LBRACK] = ACTIONS(9432),
    [anon_sym_COLON_COLON2] = ACTIONS(9432),
    [anon_sym_AMP_DOT] = ACTIONS(9432),
    [anon_sym_PLUS_EQ] = ACTIONS(9432),
    [anon_sym_DASH_EQ] = ACTIONS(9432),
    [anon_sym_STAR_EQ] = ACTIONS(9432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9432),
    [anon_sym_SLASH_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9432),
    [anon_sym_AMP_EQ] = ACTIONS(9432),
    [anon_sym_PERCENT_EQ] = ACTIONS(9432),
    [anon_sym_GT_GT_EQ] = ACTIONS(9432),
    [anon_sym_LT_LT_EQ] = ACTIONS(9432),
    [anon_sym_CARET_EQ] = ACTIONS(9432),
    [anon_sym_QMARK] = ACTIONS(9432),
    [anon_sym_DOT_DOT] = ACTIONS(9434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9432),
    [anon_sym_and] = ACTIONS(9432),
    [anon_sym_or] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE] = ACTIONS(9434),
    [anon_sym_AMP_AMP] = ACTIONS(9434),
    [anon_sym_LT_LT] = ACTIONS(9434),
    [anon_sym_GT_GT] = ACTIONS(9434),
    [anon_sym_EQ_EQ] = ACTIONS(9434),
    [anon_sym_BANG_EQ] = ACTIONS(9432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9432),
    [anon_sym_LT_EQ_GT] = ACTIONS(9432),
    [anon_sym_EQ_TILDE] = ACTIONS(9432),
    [anon_sym_BANG_TILDE] = ACTIONS(9432),
    [anon_sym_LT_EQ] = ACTIONS(9434),
    [anon_sym_GT] = ACTIONS(9434),
    [anon_sym_GT_EQ] = ACTIONS(9432),
    [anon_sym_CARET] = ACTIONS(9434),
    [anon_sym_PLUS] = ACTIONS(9434),
    [anon_sym_SLASH] = ACTIONS(9434),
    [anon_sym_PERCENT] = ACTIONS(9434),
    [sym_comment] = ACTIONS(87),
  },
  [4215] = {
    [anon_sym_RBRACK] = ACTIONS(10082),
    [sym_comment] = ACTIONS(87),
  },
  [4216] = {
    [sym__string_start] = ACTIONS(2895),
    [sym__heredoc_body_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_COLON] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_unless] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_until] = ACTIONS(2895),
    [anon_sym_rescue] = ACTIONS(2895),
    [anon_sym_in] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_EQ_GT] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_RBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2895),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON2] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [sym_comment] = ACTIONS(87),
  },
  [4217] = {
    [sym__heredoc_body_start] = ACTIONS(2907),
    [sym__binary_minus] = ACTIONS(2907),
    [sym__binary_star] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_STAR_STAR] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_unless] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_until] = ACTIONS(2907),
    [anon_sym_rescue] = ACTIONS(2907),
    [anon_sym_in] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_EQ_GT] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_RBRACK] = ACTIONS(2907),
    [anon_sym_COLON_COLON2] = ACTIONS(2907),
    [anon_sym_AMP_DOT] = ACTIONS(2907),
    [anon_sym_PLUS_EQ] = ACTIONS(2907),
    [anon_sym_DASH_EQ] = ACTIONS(2907),
    [anon_sym_STAR_EQ] = ACTIONS(2907),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2907),
    [anon_sym_SLASH_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2907),
    [anon_sym_AMP_EQ] = ACTIONS(2907),
    [anon_sym_PERCENT_EQ] = ACTIONS(2907),
    [anon_sym_GT_GT_EQ] = ACTIONS(2907),
    [anon_sym_LT_LT_EQ] = ACTIONS(2907),
    [anon_sym_CARET_EQ] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_COLON2] = ACTIONS(2909),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_and] = ACTIONS(2907),
    [anon_sym_or] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_LT_LT] = ACTIONS(2909),
    [anon_sym_GT_GT] = ACTIONS(2909),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_CARET] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_PERCENT] = ACTIONS(2909),
    [sym_comment] = ACTIONS(87),
  },
  [4218] = {
    [sym__heredoc_body_start] = ACTIONS(2911),
    [sym__binary_minus] = ACTIONS(2911),
    [sym__binary_star] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_RPAREN] = ACTIONS(2911),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_unless] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_until] = ACTIONS(2911),
    [anon_sym_rescue] = ACTIONS(2911),
    [anon_sym_in] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_EQ_GT] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_RBRACK] = ACTIONS(2911),
    [anon_sym_COLON_COLON2] = ACTIONS(2911),
    [anon_sym_AMP_DOT] = ACTIONS(2911),
    [anon_sym_PLUS_EQ] = ACTIONS(2911),
    [anon_sym_DASH_EQ] = ACTIONS(2911),
    [anon_sym_STAR_EQ] = ACTIONS(2911),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2911),
    [anon_sym_SLASH_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2911),
    [anon_sym_AMP_EQ] = ACTIONS(2911),
    [anon_sym_PERCENT_EQ] = ACTIONS(2911),
    [anon_sym_GT_GT_EQ] = ACTIONS(2911),
    [anon_sym_LT_LT_EQ] = ACTIONS(2911),
    [anon_sym_CARET_EQ] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_COLON2] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_CARET] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(87),
  },
  [4219] = {
    [sym__heredoc_body_start] = ACTIONS(2915),
    [sym__binary_minus] = ACTIONS(2915),
    [sym__binary_star] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_STAR_STAR] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_unless] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_until] = ACTIONS(2915),
    [anon_sym_rescue] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_EQ_GT] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_RBRACK] = ACTIONS(2915),
    [anon_sym_COLON_COLON2] = ACTIONS(2915),
    [anon_sym_AMP_DOT] = ACTIONS(2915),
    [anon_sym_PLUS_EQ] = ACTIONS(2915),
    [anon_sym_DASH_EQ] = ACTIONS(2915),
    [anon_sym_STAR_EQ] = ACTIONS(2915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2915),
    [anon_sym_SLASH_EQ] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2915),
    [anon_sym_PIPE_EQ] = ACTIONS(2915),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2915),
    [anon_sym_AMP_EQ] = ACTIONS(2915),
    [anon_sym_PERCENT_EQ] = ACTIONS(2915),
    [anon_sym_GT_GT_EQ] = ACTIONS(2915),
    [anon_sym_LT_LT_EQ] = ACTIONS(2915),
    [anon_sym_CARET_EQ] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_COLON2] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_LT_LT] = ACTIONS(2917),
    [anon_sym_GT_GT] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2915),
    [anon_sym_EQ_TILDE] = ACTIONS(2915),
    [anon_sym_BANG_TILDE] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2917),
    [sym_comment] = ACTIONS(87),
  },
  [4220] = {
    [sym__heredoc_body_start] = ACTIONS(2921),
    [sym__binary_minus] = ACTIONS(2921),
    [sym__binary_star] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_unless] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_until] = ACTIONS(2921),
    [anon_sym_rescue] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_RBRACK] = ACTIONS(2921),
    [anon_sym_COLON_COLON2] = ACTIONS(2921),
    [anon_sym_AMP_DOT] = ACTIONS(2921),
    [anon_sym_PLUS_EQ] = ACTIONS(2921),
    [anon_sym_DASH_EQ] = ACTIONS(2921),
    [anon_sym_STAR_EQ] = ACTIONS(2921),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2921),
    [anon_sym_AMP_EQ] = ACTIONS(2921),
    [anon_sym_PERCENT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_LT_LT_EQ] = ACTIONS(2921),
    [anon_sym_CARET_EQ] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_COLON2] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_and] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [sym_comment] = ACTIONS(87),
  },
  [4221] = {
    [sym__string_end] = ACTIONS(10084),
    [sym_comment] = ACTIONS(87),
  },
  [4222] = {
    [aux_sym_string_array_repeat1] = STATE(6779),
    [sym__string_end] = ACTIONS(10086),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10088),
  },
  [4223] = {
    [sym__heredoc_body_start] = ACTIONS(2931),
    [sym__binary_minus] = ACTIONS(2931),
    [sym__binary_star] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_STAR_STAR] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_unless] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_until] = ACTIONS(2931),
    [anon_sym_rescue] = ACTIONS(2931),
    [anon_sym_in] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_EQ_GT] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_RBRACK] = ACTIONS(2931),
    [anon_sym_COLON_COLON2] = ACTIONS(2931),
    [anon_sym_AMP_DOT] = ACTIONS(2931),
    [anon_sym_PLUS_EQ] = ACTIONS(2931),
    [anon_sym_DASH_EQ] = ACTIONS(2931),
    [anon_sym_STAR_EQ] = ACTIONS(2931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2931),
    [anon_sym_SLASH_EQ] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2931),
    [anon_sym_PIPE_EQ] = ACTIONS(2931),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2931),
    [anon_sym_AMP_EQ] = ACTIONS(2931),
    [anon_sym_PERCENT_EQ] = ACTIONS(2931),
    [anon_sym_GT_GT_EQ] = ACTIONS(2931),
    [anon_sym_LT_LT_EQ] = ACTIONS(2931),
    [anon_sym_CARET_EQ] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2931),
    [anon_sym_COLON2] = ACTIONS(2933),
    [anon_sym_DOT_DOT] = ACTIONS(2933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2931),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_EQ_EQ] = ACTIONS(2933),
    [anon_sym_BANG_EQ] = ACTIONS(2931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2931),
    [anon_sym_EQ_TILDE] = ACTIONS(2931),
    [anon_sym_BANG_TILDE] = ACTIONS(2931),
    [anon_sym_LT_EQ] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_GT_EQ] = ACTIONS(2931),
    [anon_sym_CARET] = ACTIONS(2933),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(87),
  },
  [4224] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10090),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4225] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(10090),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10092),
  },
  [4226] = {
    [sym__heredoc_body_start] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym__binary_star] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_STAR_STAR] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_unless] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_until] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2950),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_EQ_GT] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_COLON_COLON2] = ACTIONS(2950),
    [anon_sym_AMP_DOT] = ACTIONS(2950),
    [anon_sym_PLUS_EQ] = ACTIONS(2950),
    [anon_sym_DASH_EQ] = ACTIONS(2950),
    [anon_sym_STAR_EQ] = ACTIONS(2950),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2950),
    [anon_sym_SLASH_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2950),
    [anon_sym_AMP_EQ] = ACTIONS(2950),
    [anon_sym_PERCENT_EQ] = ACTIONS(2950),
    [anon_sym_GT_GT_EQ] = ACTIONS(2950),
    [anon_sym_LT_LT_EQ] = ACTIONS(2950),
    [anon_sym_CARET_EQ] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON2] = ACTIONS(2952),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_LT_LT] = ACTIONS(2952),
    [anon_sym_GT_GT] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ_GT] = ACTIONS(2950),
    [anon_sym_EQ_TILDE] = ACTIONS(2950),
    [anon_sym_BANG_TILDE] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_PERCENT] = ACTIONS(2952),
    [sym_comment] = ACTIONS(87),
  },
  [4227] = {
    [sym__string_end] = ACTIONS(10094),
    [sym_comment] = ACTIONS(87),
  },
  [4228] = {
    [aux_sym_symbol_array_repeat1] = STATE(6785),
    [sym__string_end] = ACTIONS(10096),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10098),
  },
  [4229] = {
    [sym__heredoc_body_start] = ACTIONS(2960),
    [sym__binary_minus] = ACTIONS(2960),
    [sym__binary_star] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_RPAREN] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_STAR_STAR] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_unless] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_until] = ACTIONS(2960),
    [anon_sym_rescue] = ACTIONS(2960),
    [anon_sym_in] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_EQ_GT] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_RBRACK] = ACTIONS(2960),
    [anon_sym_COLON_COLON2] = ACTIONS(2960),
    [anon_sym_AMP_DOT] = ACTIONS(2960),
    [anon_sym_PLUS_EQ] = ACTIONS(2960),
    [anon_sym_DASH_EQ] = ACTIONS(2960),
    [anon_sym_STAR_EQ] = ACTIONS(2960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2960),
    [anon_sym_SLASH_EQ] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2960),
    [anon_sym_PIPE_EQ] = ACTIONS(2960),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2960),
    [anon_sym_AMP_EQ] = ACTIONS(2960),
    [anon_sym_PERCENT_EQ] = ACTIONS(2960),
    [anon_sym_GT_GT_EQ] = ACTIONS(2960),
    [anon_sym_LT_LT_EQ] = ACTIONS(2960),
    [anon_sym_CARET_EQ] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2960),
    [anon_sym_COLON2] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_LT_LT] = ACTIONS(2962),
    [anon_sym_GT_GT] = ACTIONS(2962),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2960),
    [anon_sym_LT_EQ_GT] = ACTIONS(2960),
    [anon_sym_EQ_TILDE] = ACTIONS(2960),
    [anon_sym_BANG_TILDE] = ACTIONS(2960),
    [anon_sym_LT_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [sym_comment] = ACTIONS(87),
  },
  [4230] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10100),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4231] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(10100),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10102),
  },
  [4232] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_in] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_RBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_PLUS_EQ] = ACTIONS(993),
    [anon_sym_DASH_EQ] = ACTIONS(993),
    [anon_sym_STAR_EQ] = ACTIONS(993),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(993),
    [anon_sym_SLASH_EQ] = ACTIONS(993),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(993),
    [anon_sym_PIPE_EQ] = ACTIONS(993),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(993),
    [anon_sym_AMP_EQ] = ACTIONS(993),
    [anon_sym_PERCENT_EQ] = ACTIONS(993),
    [anon_sym_GT_GT_EQ] = ACTIONS(993),
    [anon_sym_LT_LT_EQ] = ACTIONS(993),
    [anon_sym_CARET_EQ] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_COLON2] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [sym_comment] = ACTIONS(87),
  },
  [4233] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4234] = {
    [sym__binary_minus] = ACTIONS(9172),
    [sym__binary_star] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9174),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9174),
    [anon_sym_STAR_STAR] = ACTIONS(9174),
    [anon_sym_AMP] = ACTIONS(9174),
    [anon_sym_EQ] = ACTIONS(9174),
    [anon_sym_LT] = ACTIONS(9174),
    [anon_sym_EQ_GT] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [anon_sym_PLUS_EQ] = ACTIONS(9172),
    [anon_sym_DASH_EQ] = ACTIONS(9172),
    [anon_sym_STAR_EQ] = ACTIONS(9172),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9172),
    [anon_sym_SLASH_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9172),
    [anon_sym_AMP_EQ] = ACTIONS(9172),
    [anon_sym_PERCENT_EQ] = ACTIONS(9172),
    [anon_sym_GT_GT_EQ] = ACTIONS(9172),
    [anon_sym_LT_LT_EQ] = ACTIONS(9172),
    [anon_sym_CARET_EQ] = ACTIONS(9172),
    [anon_sym_QMARK] = ACTIONS(9172),
    [anon_sym_DOT_DOT] = ACTIONS(9174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9172),
    [anon_sym_and] = ACTIONS(9172),
    [anon_sym_or] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE] = ACTIONS(9174),
    [anon_sym_AMP_AMP] = ACTIONS(9174),
    [anon_sym_LT_LT] = ACTIONS(9174),
    [anon_sym_GT_GT] = ACTIONS(9174),
    [anon_sym_EQ_EQ] = ACTIONS(9174),
    [anon_sym_BANG_EQ] = ACTIONS(9172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9172),
    [anon_sym_LT_EQ_GT] = ACTIONS(9172),
    [anon_sym_EQ_TILDE] = ACTIONS(9172),
    [anon_sym_BANG_TILDE] = ACTIONS(9172),
    [anon_sym_LT_EQ] = ACTIONS(9174),
    [anon_sym_GT] = ACTIONS(9174),
    [anon_sym_GT_EQ] = ACTIONS(9172),
    [anon_sym_CARET] = ACTIONS(9174),
    [anon_sym_PLUS] = ACTIONS(9174),
    [anon_sym_SLASH] = ACTIONS(9174),
    [anon_sym_PERCENT] = ACTIONS(9174),
    [sym_comment] = ACTIONS(87),
  },
  [4235] = {
    [anon_sym_RBRACE] = ACTIONS(10104),
    [sym_comment] = ACTIONS(87),
  },
  [4236] = {
    [sym__heredoc_body_start] = ACTIONS(3440),
    [sym__binary_minus] = ACTIONS(3440),
    [sym__binary_star] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3440),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3440),
    [anon_sym_while] = ACTIONS(3440),
    [anon_sym_until] = ACTIONS(3440),
    [anon_sym_rescue] = ACTIONS(3440),
    [anon_sym_in] = ACTIONS(3440),
    [anon_sym_do] = ACTIONS(3440),
    [anon_sym_EQ_GT] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3440),
    [anon_sym_RBRACK] = ACTIONS(3440),
    [anon_sym_COLON_COLON2] = ACTIONS(3440),
    [anon_sym_AMP_DOT] = ACTIONS(3440),
    [anon_sym_PLUS_EQ] = ACTIONS(3440),
    [anon_sym_DASH_EQ] = ACTIONS(3440),
    [anon_sym_STAR_EQ] = ACTIONS(3440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3440),
    [anon_sym_SLASH_EQ] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3440),
    [anon_sym_PIPE_EQ] = ACTIONS(3440),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3440),
    [anon_sym_AMP_EQ] = ACTIONS(3440),
    [anon_sym_PERCENT_EQ] = ACTIONS(3440),
    [anon_sym_GT_GT_EQ] = ACTIONS(3440),
    [anon_sym_LT_LT_EQ] = ACTIONS(3440),
    [anon_sym_CARET_EQ] = ACTIONS(3440),
    [anon_sym_QMARK] = ACTIONS(3440),
    [anon_sym_COLON2] = ACTIONS(3442),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3440),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_LT_LT] = ACTIONS(3442),
    [anon_sym_GT_GT] = ACTIONS(3442),
    [anon_sym_EQ_EQ] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3440),
    [anon_sym_BANG_TILDE] = ACTIONS(3440),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3440),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_SLASH] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [sym_comment] = ACTIONS(87),
  },
  [4237] = {
    [anon_sym_RBRACE] = ACTIONS(10106),
    [sym_comment] = ACTIONS(87),
  },
  [4238] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(10108),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [4239] = {
    [sym__method_rest] = STATE(6791),
    [sym_operator] = STATE(1944),
    [sym__method_name] = STATE(1944),
    [sym_setter] = STATE(1944),
    [sym_symbol] = STATE(1944),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(10110),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(10110),
    [sym_class_variable] = ACTIONS(10110),
    [sym_global_variable] = ACTIONS(10110),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [4240] = {
    [sym__statements] = STATE(1968),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1969),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1970),
    [sym_rescue] = STATE(1971),
    [sym__body_statement] = STATE(6792),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10112),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4241] = {
    [sym__heredoc_body_start] = ACTIONS(3670),
    [sym__binary_minus] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_LBRACE] = ACTIONS(3670),
    [anon_sym_RBRACE] = ACTIONS(3670),
    [anon_sym_RPAREN] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_SEMI] = ACTIONS(3670),
    [anon_sym_STAR_STAR] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3672),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3672),
    [anon_sym_if] = ACTIONS(3670),
    [anon_sym_unless] = ACTIONS(3670),
    [anon_sym_while] = ACTIONS(3670),
    [anon_sym_until] = ACTIONS(3670),
    [anon_sym_rescue] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3670),
    [anon_sym_do] = ACTIONS(3670),
    [anon_sym_EQ_GT] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3670),
    [anon_sym_RBRACK] = ACTIONS(3670),
    [anon_sym_COLON_COLON2] = ACTIONS(3670),
    [anon_sym_AMP_DOT] = ACTIONS(3670),
    [anon_sym_PLUS_EQ] = ACTIONS(3670),
    [anon_sym_DASH_EQ] = ACTIONS(3670),
    [anon_sym_STAR_EQ] = ACTIONS(3670),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3670),
    [anon_sym_SLASH_EQ] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3670),
    [anon_sym_PIPE_EQ] = ACTIONS(3670),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3670),
    [anon_sym_AMP_EQ] = ACTIONS(3670),
    [anon_sym_PERCENT_EQ] = ACTIONS(3670),
    [anon_sym_GT_GT_EQ] = ACTIONS(3670),
    [anon_sym_LT_LT_EQ] = ACTIONS(3670),
    [anon_sym_CARET_EQ] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_COLON2] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3670),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3672),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LT_EQ_GT] = ACTIONS(3670),
    [anon_sym_EQ_TILDE] = ACTIONS(3670),
    [anon_sym_BANG_TILDE] = ACTIONS(3670),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3672),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [sym_comment] = ACTIONS(87),
  },
  [4242] = {
    [sym_heredoc_body] = STATE(6793),
    [sym__terminator] = STATE(6793),
    [sym__line_break] = ACTIONS(10114),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(10114),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [4243] = {
    [sym_heredoc_body] = STATE(6794),
    [sym__terminator] = STATE(6794),
    [sym__line_break] = ACTIONS(10116),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(10116),
    [sym_comment] = ACTIONS(87),
  },
  [4244] = {
    [sym__statements] = STATE(1968),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1969),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1970),
    [sym_rescue] = STATE(1971),
    [sym__body_statement] = STATE(6795),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10118),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4245] = {
    [sym__heredoc_body_start] = ACTIONS(4068),
    [sym__binary_minus] = ACTIONS(4068),
    [sym__binary_star] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_STAR_STAR] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_unless] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_until] = ACTIONS(4068),
    [anon_sym_rescue] = ACTIONS(4068),
    [anon_sym_in] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_EQ_GT] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_COLON_COLON2] = ACTIONS(4068),
    [anon_sym_AMP_DOT] = ACTIONS(4068),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4068),
    [anon_sym_COLON2] = ACTIONS(4070),
    [anon_sym_DOT_DOT] = ACTIONS(4070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ_GT] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_BANG_TILDE] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [sym_comment] = ACTIONS(87),
  },
  [4246] = {
    [sym__statements] = STATE(1968),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1969),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1970),
    [sym_rescue] = STATE(1971),
    [sym__body_statement] = STATE(6796),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10120),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4247] = {
    [sym__statements] = STATE(6798),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(6799),
    [sym_else] = STATE(6799),
    [sym__if_tail] = STATE(6799),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6800),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__terminator] = STATE(6800),
    [sym__line_break] = ACTIONS(10122),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10124),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4248] = {
    [sym__statements] = STATE(6802),
    [sym__top_level_statement] = STATE(2704),
    [sym_begin_block] = STATE(2704),
    [sym_end_block] = STATE(2704),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(6803),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10126),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4249] = {
    [sym__statements] = STATE(6805),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4250] = {
    [sym__statements] = STATE(6807),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10130),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4251] = {
    [sym__do] = STATE(6808),
    [sym_heredoc_body] = STATE(6808),
    [sym__terminator] = STATE(6808),
    [sym__line_break] = ACTIONS(10132),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(10132),
    [anon_sym_do] = ACTIONS(10132),
    [sym_comment] = ACTIONS(87),
  },
  [4252] = {
    [sym__binary_minus] = ACTIONS(9192),
    [sym__binary_star] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9194),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9194),
    [anon_sym_STAR_STAR] = ACTIONS(9194),
    [anon_sym_AMP] = ACTIONS(9194),
    [anon_sym_EQ] = ACTIONS(9194),
    [anon_sym_LT] = ACTIONS(9194),
    [anon_sym_EQ_GT] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [anon_sym_PLUS_EQ] = ACTIONS(9192),
    [anon_sym_DASH_EQ] = ACTIONS(9192),
    [anon_sym_STAR_EQ] = ACTIONS(9192),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9192),
    [anon_sym_SLASH_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9192),
    [anon_sym_AMP_EQ] = ACTIONS(9192),
    [anon_sym_PERCENT_EQ] = ACTIONS(9192),
    [anon_sym_GT_GT_EQ] = ACTIONS(9192),
    [anon_sym_LT_LT_EQ] = ACTIONS(9192),
    [anon_sym_CARET_EQ] = ACTIONS(9192),
    [anon_sym_QMARK] = ACTIONS(9192),
    [anon_sym_DOT_DOT] = ACTIONS(9194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9192),
    [anon_sym_and] = ACTIONS(9192),
    [anon_sym_or] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE] = ACTIONS(9194),
    [anon_sym_AMP_AMP] = ACTIONS(9194),
    [anon_sym_LT_LT] = ACTIONS(9194),
    [anon_sym_GT_GT] = ACTIONS(9194),
    [anon_sym_EQ_EQ] = ACTIONS(9194),
    [anon_sym_BANG_EQ] = ACTIONS(9192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9192),
    [anon_sym_LT_EQ_GT] = ACTIONS(9192),
    [anon_sym_EQ_TILDE] = ACTIONS(9192),
    [anon_sym_BANG_TILDE] = ACTIONS(9192),
    [anon_sym_LT_EQ] = ACTIONS(9194),
    [anon_sym_GT] = ACTIONS(9194),
    [anon_sym_GT_EQ] = ACTIONS(9192),
    [anon_sym_CARET] = ACTIONS(9194),
    [anon_sym_PLUS] = ACTIONS(9194),
    [anon_sym_SLASH] = ACTIONS(9194),
    [anon_sym_PERCENT] = ACTIONS(9194),
    [sym_comment] = ACTIONS(87),
  },
  [4253] = {
    [anon_sym_end] = ACTIONS(10134),
    [sym_comment] = ACTIONS(87),
  },
  [4254] = {
    [sym__statements] = STATE(6810),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10136),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4255] = {
    [sym__statements] = STATE(6810),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6811),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(6811),
    [sym__line_break] = ACTIONS(10138),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10136),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4256] = {
    [sym_when] = STATE(6812),
    [aux_sym_case_repeat1] = STATE(6813),
    [anon_sym_SEMI] = ACTIONS(10140),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4257] = {
    [anon_sym_end] = ACTIONS(10142),
    [sym_comment] = ACTIONS(87),
  },
  [4258] = {
    [sym_when] = STATE(6812),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4259] = {
    [sym__heredoc_body_start] = ACTIONS(5264),
    [sym__binary_minus] = ACTIONS(5264),
    [sym__binary_star] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5264),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_RPAREN] = ACTIONS(5264),
    [anon_sym_DOT] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5264),
    [anon_sym_PIPE] = ACTIONS(5266),
    [anon_sym_SEMI] = ACTIONS(5264),
    [anon_sym_STAR_STAR] = ACTIONS(5266),
    [anon_sym_AMP] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5266),
    [anon_sym_if] = ACTIONS(5264),
    [anon_sym_unless] = ACTIONS(5264),
    [anon_sym_while] = ACTIONS(5264),
    [anon_sym_until] = ACTIONS(5264),
    [anon_sym_rescue] = ACTIONS(5264),
    [anon_sym_in] = ACTIONS(5264),
    [anon_sym_do] = ACTIONS(5264),
    [anon_sym_EQ_GT] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5264),
    [anon_sym_RBRACK] = ACTIONS(5264),
    [anon_sym_COLON_COLON2] = ACTIONS(5264),
    [anon_sym_AMP_DOT] = ACTIONS(5264),
    [anon_sym_PLUS_EQ] = ACTIONS(5264),
    [anon_sym_DASH_EQ] = ACTIONS(5264),
    [anon_sym_STAR_EQ] = ACTIONS(5264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5264),
    [anon_sym_SLASH_EQ] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5264),
    [anon_sym_PIPE_EQ] = ACTIONS(5264),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5264),
    [anon_sym_AMP_EQ] = ACTIONS(5264),
    [anon_sym_PERCENT_EQ] = ACTIONS(5264),
    [anon_sym_GT_GT_EQ] = ACTIONS(5264),
    [anon_sym_LT_LT_EQ] = ACTIONS(5264),
    [anon_sym_CARET_EQ] = ACTIONS(5264),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_COLON2] = ACTIONS(5266),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5264),
    [anon_sym_and] = ACTIONS(5264),
    [anon_sym_or] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE] = ACTIONS(5266),
    [anon_sym_AMP_AMP] = ACTIONS(5266),
    [anon_sym_LT_LT] = ACTIONS(5266),
    [anon_sym_GT_GT] = ACTIONS(5266),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5264),
    [anon_sym_LT_EQ_GT] = ACTIONS(5264),
    [anon_sym_EQ_TILDE] = ACTIONS(5264),
    [anon_sym_BANG_TILDE] = ACTIONS(5264),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_GT] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5264),
    [anon_sym_CARET] = ACTIONS(5266),
    [anon_sym_PLUS] = ACTIONS(5266),
    [anon_sym_SLASH] = ACTIONS(5266),
    [anon_sym_PERCENT] = ACTIONS(5266),
    [sym_comment] = ACTIONS(87),
  },
  [4260] = {
    [sym_ensure] = STATE(6816),
    [anon_sym_end] = ACTIONS(10144),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [4261] = {
    [anon_sym_end] = ACTIONS(10144),
    [sym_comment] = ACTIONS(87),
  },
  [4262] = {
    [sym_else] = STATE(6817),
    [sym_ensure] = STATE(6816),
    [anon_sym_end] = ACTIONS(10144),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [4263] = {
    [sym__heredoc_body_start] = ACTIONS(5350),
    [sym__binary_minus] = ACTIONS(5350),
    [sym__binary_star] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_RPAREN] = ACTIONS(5350),
    [anon_sym_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5350),
    [anon_sym_PIPE] = ACTIONS(5352),
    [anon_sym_SEMI] = ACTIONS(5350),
    [anon_sym_STAR_STAR] = ACTIONS(5352),
    [anon_sym_AMP] = ACTIONS(5352),
    [anon_sym_EQ] = ACTIONS(5352),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_unless] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_until] = ACTIONS(5350),
    [anon_sym_rescue] = ACTIONS(5350),
    [anon_sym_in] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_EQ_GT] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_RBRACK] = ACTIONS(5350),
    [anon_sym_COLON_COLON2] = ACTIONS(5350),
    [anon_sym_AMP_DOT] = ACTIONS(5350),
    [anon_sym_PLUS_EQ] = ACTIONS(5350),
    [anon_sym_DASH_EQ] = ACTIONS(5350),
    [anon_sym_STAR_EQ] = ACTIONS(5350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5350),
    [anon_sym_SLASH_EQ] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5350),
    [anon_sym_PIPE_EQ] = ACTIONS(5350),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5350),
    [anon_sym_AMP_EQ] = ACTIONS(5350),
    [anon_sym_PERCENT_EQ] = ACTIONS(5350),
    [anon_sym_GT_GT_EQ] = ACTIONS(5350),
    [anon_sym_LT_LT_EQ] = ACTIONS(5350),
    [anon_sym_CARET_EQ] = ACTIONS(5350),
    [anon_sym_QMARK] = ACTIONS(5350),
    [anon_sym_COLON2] = ACTIONS(5352),
    [anon_sym_DOT_DOT] = ACTIONS(5352),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5352),
    [anon_sym_AMP_AMP] = ACTIONS(5352),
    [anon_sym_LT_LT] = ACTIONS(5352),
    [anon_sym_GT_GT] = ACTIONS(5352),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5350),
    [anon_sym_LT_EQ_GT] = ACTIONS(5350),
    [anon_sym_EQ_TILDE] = ACTIONS(5350),
    [anon_sym_BANG_TILDE] = ACTIONS(5350),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5352),
    [anon_sym_PLUS] = ACTIONS(5352),
    [anon_sym_SLASH] = ACTIONS(5352),
    [anon_sym_PERCENT] = ACTIONS(5352),
    [sym_comment] = ACTIONS(87),
  },
  [4264] = {
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR_STAR] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7608),
    [anon_sym_unless] = ACTIONS(7608),
    [anon_sym_while] = ACTIONS(7608),
    [anon_sym_until] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7608),
    [anon_sym_in] = ACTIONS(7608),
    [anon_sym_do] = ACTIONS(7608),
    [anon_sym_EQ_GT] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_RBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_PLUS_EQ] = ACTIONS(7608),
    [anon_sym_DASH_EQ] = ACTIONS(7608),
    [anon_sym_STAR_EQ] = ACTIONS(7608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7608),
    [anon_sym_SLASH_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7608),
    [anon_sym_AMP_EQ] = ACTIONS(7608),
    [anon_sym_PERCENT_EQ] = ACTIONS(7608),
    [anon_sym_GT_GT_EQ] = ACTIONS(7608),
    [anon_sym_LT_LT_EQ] = ACTIONS(7608),
    [anon_sym_CARET_EQ] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7608),
    [anon_sym_COLON2] = ACTIONS(7610),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7608),
    [anon_sym_or] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE] = ACTIONS(7610),
    [anon_sym_AMP_AMP] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [sym_comment] = ACTIONS(87),
  },
  [4265] = {
    [anon_sym_RPAREN] = ACTIONS(10146),
    [sym_comment] = ACTIONS(87),
  },
  [4266] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4267] = {
    [sym__heredoc_body_start] = ACTIONS(5582),
    [sym__binary_minus] = ACTIONS(5582),
    [sym__binary_star] = ACTIONS(5582),
    [anon_sym_LBRACE] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_STAR_STAR] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_EQ] = ACTIONS(5584),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_if] = ACTIONS(5582),
    [anon_sym_unless] = ACTIONS(5582),
    [anon_sym_while] = ACTIONS(5582),
    [anon_sym_until] = ACTIONS(5582),
    [anon_sym_rescue] = ACTIONS(5582),
    [anon_sym_in] = ACTIONS(5582),
    [anon_sym_do] = ACTIONS(5582),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_COLON_COLON2] = ACTIONS(5582),
    [anon_sym_AMP_DOT] = ACTIONS(5582),
    [anon_sym_PLUS_EQ] = ACTIONS(5582),
    [anon_sym_DASH_EQ] = ACTIONS(5582),
    [anon_sym_STAR_EQ] = ACTIONS(5582),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5582),
    [anon_sym_SLASH_EQ] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5582),
    [anon_sym_PIPE_EQ] = ACTIONS(5582),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5582),
    [anon_sym_AMP_EQ] = ACTIONS(5582),
    [anon_sym_PERCENT_EQ] = ACTIONS(5582),
    [anon_sym_GT_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_LT_EQ] = ACTIONS(5582),
    [anon_sym_CARET_EQ] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5582),
    [anon_sym_COLON2] = ACTIONS(5584),
    [anon_sym_DOT_DOT] = ACTIONS(5584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5584),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_EQ_EQ] = ACTIONS(5584),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ_GT] = ACTIONS(5582),
    [anon_sym_EQ_TILDE] = ACTIONS(5582),
    [anon_sym_BANG_TILDE] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5584),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5584),
    [sym_comment] = ACTIONS(87),
  },
  [4268] = {
    [anon_sym_RBRACK] = ACTIONS(10148),
    [sym_comment] = ACTIONS(87),
  },
  [4269] = {
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_COLON2] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [4270] = {
    [sym__heredoc_body_start] = ACTIONS(5666),
    [sym__binary_minus] = ACTIONS(5666),
    [sym__binary_star] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_STAR_STAR] = ACTIONS(5668),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_EQ] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_if] = ACTIONS(5666),
    [anon_sym_unless] = ACTIONS(5666),
    [anon_sym_while] = ACTIONS(5666),
    [anon_sym_until] = ACTIONS(5666),
    [anon_sym_rescue] = ACTIONS(5666),
    [anon_sym_in] = ACTIONS(5666),
    [anon_sym_do] = ACTIONS(5666),
    [anon_sym_EQ_GT] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_RBRACK] = ACTIONS(5666),
    [anon_sym_COLON_COLON2] = ACTIONS(5666),
    [anon_sym_AMP_DOT] = ACTIONS(5666),
    [anon_sym_PLUS_EQ] = ACTIONS(5666),
    [anon_sym_DASH_EQ] = ACTIONS(5666),
    [anon_sym_STAR_EQ] = ACTIONS(5666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5666),
    [anon_sym_SLASH_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5666),
    [anon_sym_AMP_EQ] = ACTIONS(5666),
    [anon_sym_PERCENT_EQ] = ACTIONS(5666),
    [anon_sym_GT_GT_EQ] = ACTIONS(5666),
    [anon_sym_LT_LT_EQ] = ACTIONS(5666),
    [anon_sym_CARET_EQ] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_COLON2] = ACTIONS(5668),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_and] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_LT_LT] = ACTIONS(5668),
    [anon_sym_GT_GT] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_EQ_TILDE] = ACTIONS(5666),
    [anon_sym_BANG_TILDE] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_PLUS] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [sym_comment] = ACTIONS(87),
  },
  [4271] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4272] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [4273] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4274] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4275] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4276] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10150),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4277] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4278] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4279] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4280] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4281] = {
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [4282] = {
    [sym__heredoc_body_start] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__binary_star] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(4854),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(4854),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_STAR_STAR] = ACTIONS(4854),
    [anon_sym_AMP] = ACTIONS(4854),
    [anon_sym_EQ] = ACTIONS(4854),
    [anon_sym_LT] = ACTIONS(4854),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_unless] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_until] = ACTIONS(3102),
    [anon_sym_rescue] = ACTIONS(3102),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_EQ_GT] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_RBRACK] = ACTIONS(3102),
    [anon_sym_COLON_COLON2] = ACTIONS(3102),
    [anon_sym_AMP_DOT] = ACTIONS(3102),
    [anon_sym_PLUS_EQ] = ACTIONS(3102),
    [anon_sym_DASH_EQ] = ACTIONS(3102),
    [anon_sym_STAR_EQ] = ACTIONS(3102),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3102),
    [anon_sym_SLASH_EQ] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3102),
    [anon_sym_PIPE_EQ] = ACTIONS(3102),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3102),
    [anon_sym_AMP_EQ] = ACTIONS(3102),
    [anon_sym_PERCENT_EQ] = ACTIONS(3102),
    [anon_sym_GT_GT_EQ] = ACTIONS(3102),
    [anon_sym_LT_LT_EQ] = ACTIONS(3102),
    [anon_sym_CARET_EQ] = ACTIONS(3102),
    [anon_sym_QMARK] = ACTIONS(3102),
    [anon_sym_COLON2] = ACTIONS(4854),
    [anon_sym_DOT_DOT] = ACTIONS(4854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_and] = ACTIONS(3102),
    [anon_sym_or] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(4854),
    [anon_sym_AMP_AMP] = ACTIONS(4854),
    [anon_sym_LT_LT] = ACTIONS(4854),
    [anon_sym_GT_GT] = ACTIONS(4854),
    [anon_sym_EQ_EQ] = ACTIONS(4854),
    [anon_sym_BANG_EQ] = ACTIONS(3102),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
    [anon_sym_LT_EQ_GT] = ACTIONS(3102),
    [anon_sym_EQ_TILDE] = ACTIONS(3102),
    [anon_sym_BANG_TILDE] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(4854),
    [anon_sym_GT] = ACTIONS(4854),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(4854),
    [anon_sym_PLUS] = ACTIONS(4854),
    [anon_sym_SLASH] = ACTIONS(4854),
    [anon_sym_PERCENT] = ACTIONS(4854),
    [sym_comment] = ACTIONS(87),
  },
  [4283] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(10152),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [4284] = {
    [sym_heredoc_body] = STATE(4284),
    [aux_sym_call_repeat1] = STATE(4284),
    [sym__heredoc_body_start] = ACTIONS(10154),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [4285] = {
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(7657),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_in] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_RBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_COLON2] = ACTIONS(7659),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [4286] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(644),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym__argument] = STATE(6822),
    [sym_splat_argument] = STATE(6822),
    [sym_hash_splat_argument] = STATE(6822),
    [sym_block_argument] = STATE(6822),
    [sym_assignment] = STATE(644),
    [sym_operator_assignment] = STATE(644),
    [sym_conditional] = STATE(644),
    [sym_range] = STATE(644),
    [sym_binary] = STATE(644),
    [sym_unary] = STATE(644),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(653),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6822),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(1155),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__identifier_hash_key] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6855),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1209),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4287] = {
    [sym_heredoc_body] = STATE(4284),
    [aux_sym_call_repeat1] = STATE(4284),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [4288] = {
    [aux_sym_argument_list_repeat1] = STATE(4288),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(10157),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [4289] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4290] = {
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_in] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_COLON2] = ACTIONS(6062),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [4291] = {
    [aux_sym_exceptions_repeat1] = STATE(6824),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [4292] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4293] = {
    [sym_string] = STATE(4293),
    [aux_sym_chained_string_repeat1] = STATE(4293),
    [sym__string_start] = ACTIONS(10160),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [4294] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [4295] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4296] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [4297] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6825),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(6825),
    [sym_operator_assignment] = STATE(6825),
    [sym_conditional] = STATE(6825),
    [sym_range] = STATE(6825),
    [sym_binary] = STATE(6825),
    [sym_unary] = STATE(6825),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4298] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6826),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(6826),
    [sym_operator_assignment] = STATE(6826),
    [sym_conditional] = STATE(6826),
    [sym_range] = STATE(6826),
    [sym_binary] = STATE(6826),
    [sym_unary] = STATE(6826),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4299] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6827),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(6827),
    [sym_operator_assignment] = STATE(6827),
    [sym_conditional] = STATE(6827),
    [sym_range] = STATE(6827),
    [sym_binary] = STATE(6827),
    [sym_unary] = STATE(6827),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4300] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6828),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(6828),
    [sym_operator_assignment] = STATE(6828),
    [sym_conditional] = STATE(6828),
    [sym_range] = STATE(6828),
    [sym_binary] = STATE(6828),
    [sym_unary] = STATE(6828),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4301] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6829),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(6829),
    [sym_operator_assignment] = STATE(6829),
    [sym_conditional] = STATE(6829),
    [sym_range] = STATE(6829),
    [sym_binary] = STATE(6829),
    [sym_unary] = STATE(6829),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4302] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6830),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6830),
    [sym_operator_assignment] = STATE(6830),
    [sym_conditional] = STATE(6830),
    [sym_range] = STATE(6830),
    [sym_binary] = STATE(6830),
    [sym_unary] = STATE(6830),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4303] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6831),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(6831),
    [sym_operator_assignment] = STATE(6831),
    [sym_conditional] = STATE(6831),
    [sym_range] = STATE(6831),
    [sym_binary] = STATE(6831),
    [sym_unary] = STATE(6831),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4304] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6832),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(6832),
    [sym_operator_assignment] = STATE(6832),
    [sym_conditional] = STATE(6832),
    [sym_range] = STATE(6832),
    [sym_binary] = STATE(6832),
    [sym_unary] = STATE(6832),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4305] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6833),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(6833),
    [sym_operator_assignment] = STATE(6833),
    [sym_conditional] = STATE(6833),
    [sym_range] = STATE(6833),
    [sym_binary] = STATE(6833),
    [sym_unary] = STATE(6833),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4306] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6834),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(6834),
    [sym_operator_assignment] = STATE(6834),
    [sym_conditional] = STATE(6834),
    [sym_range] = STATE(6834),
    [sym_binary] = STATE(6834),
    [sym_unary] = STATE(6834),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4307] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(2016),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_splat_argument] = STATE(6835),
    [sym_assignment] = STATE(2016),
    [sym_operator_assignment] = STATE(2016),
    [sym_conditional] = STATE(2016),
    [sym_range] = STATE(2016),
    [sym_binary] = STATE(2016),
    [sym_unary] = STATE(2016),
    [sym__arg_or_splat_arg] = STATE(6835),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__splat_star] = ACTIONS(3420),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4308] = {
    [aux_sym_exceptions_repeat1] = STATE(6836),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(6883),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [4309] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(2016),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_splat_argument] = STATE(6837),
    [sym_assignment] = STATE(2016),
    [sym_operator_assignment] = STATE(2016),
    [sym_conditional] = STATE(2016),
    [sym_range] = STATE(2016),
    [sym_binary] = STATE(2016),
    [sym_unary] = STATE(2016),
    [sym_right_assignment_list] = STATE(2017),
    [sym__arg_or_splat_arg] = STATE(6837),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__splat_star] = ACTIONS(3420),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4310] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(6838),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(6838),
    [sym_operator_assignment] = STATE(6838),
    [sym_conditional] = STATE(6838),
    [sym_range] = STATE(6838),
    [sym_binary] = STATE(6838),
    [sym_unary] = STATE(6838),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4311] = {
    [sym_string] = STATE(6839),
    [aux_sym_chained_string_repeat1] = STATE(6839),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [4312] = {
    [sym__simple_symbol] = ACTIONS(3102),
    [sym__string_start] = ACTIONS(3102),
    [sym__symbol_start] = ACTIONS(3102),
    [sym__subshell_start] = ACTIONS(3102),
    [sym__regex_start] = ACTIONS(3102),
    [sym__string_array_start] = ACTIONS(3102),
    [sym__symbol_array_start] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(3102),
    [sym_heredoc_beginning] = ACTIONS(3102),
    [sym__unary_minus] = ACTIONS(3102),
    [sym__identifier_hash_key] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_def] = ACTIONS(4854),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(4854),
    [anon_sym_STAR_STAR] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(4854),
    [anon_sym_module] = ACTIONS(4854),
    [anon_sym_return] = ACTIONS(4854),
    [anon_sym_yield] = ACTIONS(4854),
    [anon_sym_break] = ACTIONS(4854),
    [anon_sym_next] = ACTIONS(4854),
    [sym_redo] = ACTIONS(4854),
    [sym_retry] = ACTIONS(4854),
    [anon_sym_if] = ACTIONS(4854),
    [anon_sym_unless] = ACTIONS(4854),
    [anon_sym_while] = ACTIONS(4854),
    [anon_sym_until] = ACTIONS(4854),
    [anon_sym_for] = ACTIONS(4854),
    [anon_sym_case] = ACTIONS(4854),
    [anon_sym_begin] = ACTIONS(4854),
    [anon_sym_PLUS] = ACTIONS(4854),
    [anon_sym_defined_QMARK] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(4854),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [sym_constant] = ACTIONS(4854),
    [sym_identifier] = ACTIONS(4854),
    [sym_instance_variable] = ACTIONS(3102),
    [sym_class_variable] = ACTIONS(3102),
    [sym_global_variable] = ACTIONS(3102),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4854),
    [sym_float] = ACTIONS(4854),
    [sym_complex] = ACTIONS(3102),
    [sym_super] = ACTIONS(4854),
    [anon_sym_true] = ACTIONS(4854),
    [anon_sym_TRUE] = ACTIONS(4854),
    [anon_sym_false] = ACTIONS(4854),
    [anon_sym_FALSE] = ACTIONS(4854),
    [sym_self] = ACTIONS(4854),
    [anon_sym_nil] = ACTIONS(4854),
    [anon_sym_NIL] = ACTIONS(4854),
    [sym_character] = ACTIONS(3102),
    [anon_sym_LBRACK2] = ACTIONS(3102),
    [anon_sym_DASH_GT] = ACTIONS(3102),
  },
  [4313] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(10163),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [4314] = {
    [sym__heredoc_body_start] = ACTIONS(10165),
    [anon_sym_RBRACE] = ACTIONS(10165),
    [sym_comment] = ACTIONS(87),
  },
  [4315] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6841),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(6841),
    [sym_operator_assignment] = STATE(6841),
    [sym_conditional] = STATE(6841),
    [sym_range] = STATE(6841),
    [sym_binary] = STATE(6841),
    [sym_unary] = STATE(6841),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4316] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6842),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(6842),
    [sym_operator_assignment] = STATE(6842),
    [sym_conditional] = STATE(6842),
    [sym_range] = STATE(6842),
    [sym_binary] = STATE(6842),
    [sym_unary] = STATE(6842),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4317] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4318] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(10177),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [4319] = {
    [anon_sym_EQ] = ACTIONS(10193),
    [sym_comment] = ACTIONS(87),
  },
  [4320] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10195),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10197),
    [anon_sym_DASH_EQ] = ACTIONS(10197),
    [anon_sym_STAR_EQ] = ACTIONS(10197),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10197),
    [anon_sym_SLASH_EQ] = ACTIONS(10197),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10197),
    [anon_sym_PIPE_EQ] = ACTIONS(10197),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10197),
    [anon_sym_AMP_EQ] = ACTIONS(10197),
    [anon_sym_PERCENT_EQ] = ACTIONS(10197),
    [anon_sym_GT_GT_EQ] = ACTIONS(10197),
    [anon_sym_LT_LT_EQ] = ACTIONS(10197),
    [anon_sym_CARET_EQ] = ACTIONS(10197),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4321] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(10177),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [4322] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4323] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6855),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(6855),
    [sym_operator_assignment] = STATE(6855),
    [sym_conditional] = STATE(6855),
    [sym_range] = STATE(6855),
    [sym_binary] = STATE(6855),
    [sym_unary] = STATE(6855),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4324] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(10177),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [4325] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [4326] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6856),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(6856),
    [sym_operator_assignment] = STATE(6856),
    [sym_conditional] = STATE(6856),
    [sym_range] = STATE(6856),
    [sym_binary] = STATE(6856),
    [sym_unary] = STATE(6856),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4327] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6857),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(6857),
    [sym_operator_assignment] = STATE(6857),
    [sym_conditional] = STATE(6857),
    [sym_range] = STATE(6857),
    [sym_binary] = STATE(6857),
    [sym_unary] = STATE(6857),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4328] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(6858),
    [sym_operator_assignment] = STATE(6858),
    [sym_conditional] = STATE(6858),
    [sym_range] = STATE(6858),
    [sym_binary] = STATE(6858),
    [sym_unary] = STATE(6858),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4329] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6859),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(6859),
    [sym_operator_assignment] = STATE(6859),
    [sym_conditional] = STATE(6859),
    [sym_range] = STATE(6859),
    [sym_binary] = STATE(6859),
    [sym_unary] = STATE(6859),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4330] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6860),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(6860),
    [sym_operator_assignment] = STATE(6860),
    [sym_conditional] = STATE(6860),
    [sym_range] = STATE(6860),
    [sym_binary] = STATE(6860),
    [sym_unary] = STATE(6860),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4331] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6861),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(6861),
    [sym_operator_assignment] = STATE(6861),
    [sym_conditional] = STATE(6861),
    [sym_range] = STATE(6861),
    [sym_binary] = STATE(6861),
    [sym_unary] = STATE(6861),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4332] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6862),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6862),
    [sym_operator_assignment] = STATE(6862),
    [sym_conditional] = STATE(6862),
    [sym_range] = STATE(6862),
    [sym_binary] = STATE(6862),
    [sym_unary] = STATE(6862),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4333] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6863),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(6863),
    [sym_operator_assignment] = STATE(6863),
    [sym_conditional] = STATE(6863),
    [sym_range] = STATE(6863),
    [sym_binary] = STATE(6863),
    [sym_unary] = STATE(6863),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4334] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6864),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(6864),
    [sym_operator_assignment] = STATE(6864),
    [sym_conditional] = STATE(6864),
    [sym_range] = STATE(6864),
    [sym_binary] = STATE(6864),
    [sym_unary] = STATE(6864),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4335] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6865),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(6865),
    [sym_operator_assignment] = STATE(6865),
    [sym_conditional] = STATE(6865),
    [sym_range] = STATE(6865),
    [sym_binary] = STATE(6865),
    [sym_unary] = STATE(6865),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4336] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6866),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(6866),
    [sym_operator_assignment] = STATE(6866),
    [sym_conditional] = STATE(6866),
    [sym_range] = STATE(6866),
    [sym_binary] = STATE(6866),
    [sym_unary] = STATE(6866),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4337] = {
    [sym_heredoc_body] = STATE(6867),
    [aux_sym_call_repeat1] = STATE(6867),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4338] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(6868),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10199),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4339] = {
    [sym_heredoc_body] = STATE(6869),
    [aux_sym_call_repeat1] = STATE(6869),
    [aux_sym_argument_list_repeat1] = STATE(6870),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(6948),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4340] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6871),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_splat_argument] = STATE(6872),
    [sym_assignment] = STATE(6871),
    [sym_operator_assignment] = STATE(6871),
    [sym_conditional] = STATE(6871),
    [sym_range] = STATE(6871),
    [sym_binary] = STATE(6871),
    [sym_unary] = STATE(6871),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(6872),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4154),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4341] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6873),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(6873),
    [sym_operator_assignment] = STATE(6873),
    [sym_conditional] = STATE(6873),
    [sym_range] = STATE(6873),
    [sym_binary] = STATE(6873),
    [sym_unary] = STATE(6873),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4342] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [4343] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [4344] = {
    [sym__method_rest] = STATE(6874),
    [sym_operator] = STATE(132),
    [sym__method_name] = STATE(132),
    [sym_setter] = STATE(132),
    [sym_symbol] = STATE(132),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(3544),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(3544),
    [sym_class_variable] = ACTIONS(3544),
    [sym_global_variable] = ACTIONS(3544),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [4345] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [4346] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [4347] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [4348] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10201),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4349] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [4350] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [4351] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [4352] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [4353] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6876),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(6876),
    [sym_operator_assignment] = STATE(6876),
    [sym_conditional] = STATE(6876),
    [sym_range] = STATE(6876),
    [sym_binary] = STATE(6876),
    [sym_unary] = STATE(6876),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4354] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(6452),
    [sym__argument_list_with_parens] = STATE(2071),
    [sym__argument] = STATE(2072),
    [sym_splat_argument] = STATE(2072),
    [sym_hash_splat_argument] = STATE(2072),
    [sym_block_argument] = STATE(2072),
    [sym_assignment] = STATE(2069),
    [sym_operator_assignment] = STATE(2069),
    [sym_conditional] = STATE(2069),
    [sym_range] = STATE(2069),
    [sym_binary] = STATE(2069),
    [sym_unary] = STATE(2069),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2075),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2072),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3504),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3528),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4355] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(6453),
    [sym__argument_list_with_parens] = STATE(2071),
    [sym__argument] = STATE(2072),
    [sym_splat_argument] = STATE(2072),
    [sym_hash_splat_argument] = STATE(2072),
    [sym_block_argument] = STATE(2072),
    [sym_assignment] = STATE(2069),
    [sym_operator_assignment] = STATE(2069),
    [sym_conditional] = STATE(2069),
    [sym_range] = STATE(2069),
    [sym_binary] = STATE(2069),
    [sym_unary] = STATE(2069),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2075),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2072),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3504),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3528),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4356] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(6454),
    [sym__argument_list_with_parens] = STATE(2071),
    [sym__argument] = STATE(2072),
    [sym_splat_argument] = STATE(2072),
    [sym_hash_splat_argument] = STATE(2072),
    [sym_block_argument] = STATE(2072),
    [sym_assignment] = STATE(2069),
    [sym_operator_assignment] = STATE(2069),
    [sym_conditional] = STATE(2069),
    [sym_range] = STATE(2069),
    [sym_binary] = STATE(2069),
    [sym_unary] = STATE(2069),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2075),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2072),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3504),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3528),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4357] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(6455),
    [sym__argument_list_with_parens] = STATE(2071),
    [sym__argument] = STATE(2072),
    [sym_splat_argument] = STATE(2072),
    [sym_hash_splat_argument] = STATE(2072),
    [sym_block_argument] = STATE(2072),
    [sym_assignment] = STATE(2069),
    [sym_operator_assignment] = STATE(2069),
    [sym_conditional] = STATE(2069),
    [sym_range] = STATE(2069),
    [sym_binary] = STATE(2069),
    [sym_unary] = STATE(2069),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2075),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2072),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3504),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3528),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4358] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6877),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(6877),
    [sym_operator_assignment] = STATE(6877),
    [sym_conditional] = STATE(6877),
    [sym_range] = STATE(6877),
    [sym_binary] = STATE(6877),
    [sym_unary] = STATE(6877),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4359] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6470),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(6470),
    [sym_operator_assignment] = STATE(6470),
    [sym_conditional] = STATE(6470),
    [sym_range] = STATE(6470),
    [sym_binary] = STATE(6470),
    [sym_unary] = STATE(6470),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4360] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [4361] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_argument_list] = STATE(4737),
    [sym__argument_list_with_parens] = STATE(2071),
    [sym__argument] = STATE(2072),
    [sym_splat_argument] = STATE(2072),
    [sym_hash_splat_argument] = STATE(2072),
    [sym_block_argument] = STATE(2072),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(2069),
    [sym_operator_assignment] = STATE(2069),
    [sym_conditional] = STATE(2069),
    [sym_range] = STATE(2069),
    [sym_binary] = STATE(2069),
    [sym_unary] = STATE(2069),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2075),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(2072),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3504),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(7471),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3528),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4362] = {
    [anon_sym_EQ] = ACTIONS(10231),
    [sym_comment] = ACTIONS(87),
  },
  [4363] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10233),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10235),
    [anon_sym_DASH_EQ] = ACTIONS(10235),
    [anon_sym_STAR_EQ] = ACTIONS(10235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10235),
    [anon_sym_SLASH_EQ] = ACTIONS(10235),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10235),
    [anon_sym_PIPE_EQ] = ACTIONS(10235),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10235),
    [anon_sym_AMP_EQ] = ACTIONS(10235),
    [anon_sym_PERCENT_EQ] = ACTIONS(10235),
    [anon_sym_GT_GT_EQ] = ACTIONS(10235),
    [anon_sym_LT_LT_EQ] = ACTIONS(10235),
    [anon_sym_CARET_EQ] = ACTIONS(10235),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4364] = {
    [sym_string] = STATE(6890),
    [aux_sym_chained_string_repeat1] = STATE(6890),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4365] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [4366] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [4367] = {
    [sym_string] = STATE(4387),
    [aux_sym_chained_string_repeat1] = STATE(4387),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4368] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6891),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(6891),
    [sym_operator_assignment] = STATE(6891),
    [sym_conditional] = STATE(6891),
    [sym_range] = STATE(6891),
    [sym_binary] = STATE(6891),
    [sym_unary] = STATE(6891),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4369] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [4370] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [4371] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6892),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(6892),
    [sym_operator_assignment] = STATE(6892),
    [sym_conditional] = STATE(6892),
    [sym_range] = STATE(6892),
    [sym_binary] = STATE(6892),
    [sym_unary] = STATE(6892),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4372] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6893),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(6893),
    [sym_operator_assignment] = STATE(6893),
    [sym_conditional] = STATE(6893),
    [sym_range] = STATE(6893),
    [sym_binary] = STATE(6893),
    [sym_unary] = STATE(6893),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4373] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6894),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(6894),
    [sym_operator_assignment] = STATE(6894),
    [sym_conditional] = STATE(6894),
    [sym_range] = STATE(6894),
    [sym_binary] = STATE(6894),
    [sym_unary] = STATE(6894),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4374] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6895),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(6895),
    [sym_operator_assignment] = STATE(6895),
    [sym_conditional] = STATE(6895),
    [sym_range] = STATE(6895),
    [sym_binary] = STATE(6895),
    [sym_unary] = STATE(6895),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4375] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6896),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(6896),
    [sym_operator_assignment] = STATE(6896),
    [sym_conditional] = STATE(6896),
    [sym_range] = STATE(6896),
    [sym_binary] = STATE(6896),
    [sym_unary] = STATE(6896),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4376] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6897),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(6897),
    [sym_operator_assignment] = STATE(6897),
    [sym_conditional] = STATE(6897),
    [sym_range] = STATE(6897),
    [sym_binary] = STATE(6897),
    [sym_unary] = STATE(6897),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4377] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6898),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6898),
    [sym_operator_assignment] = STATE(6898),
    [sym_conditional] = STATE(6898),
    [sym_range] = STATE(6898),
    [sym_binary] = STATE(6898),
    [sym_unary] = STATE(6898),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4378] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6899),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(6899),
    [sym_operator_assignment] = STATE(6899),
    [sym_conditional] = STATE(6899),
    [sym_range] = STATE(6899),
    [sym_binary] = STATE(6899),
    [sym_unary] = STATE(6899),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4379] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6900),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(6900),
    [sym_operator_assignment] = STATE(6900),
    [sym_conditional] = STATE(6900),
    [sym_range] = STATE(6900),
    [sym_binary] = STATE(6900),
    [sym_unary] = STATE(6900),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4380] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6901),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(6901),
    [sym_operator_assignment] = STATE(6901),
    [sym_conditional] = STATE(6901),
    [sym_range] = STATE(6901),
    [sym_binary] = STATE(6901),
    [sym_unary] = STATE(6901),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4381] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6902),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(6902),
    [sym_operator_assignment] = STATE(6902),
    [sym_conditional] = STATE(6902),
    [sym_range] = STATE(6902),
    [sym_binary] = STATE(6902),
    [sym_unary] = STATE(6902),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4382] = {
    [sym_heredoc_body] = STATE(6903),
    [aux_sym_call_repeat1] = STATE(6903),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4383] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym__argument] = STATE(6514),
    [sym_splat_argument] = STATE(6514),
    [sym_hash_splat_argument] = STATE(6514),
    [sym_block_argument] = STATE(6514),
    [sym_assignment] = STATE(2069),
    [sym_operator_assignment] = STATE(2069),
    [sym_conditional] = STATE(2069),
    [sym_range] = STATE(2069),
    [sym_binary] = STATE(2069),
    [sym_unary] = STATE(2069),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2075),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(6904),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6514),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3504),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__identifier_hash_key] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10237),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3528),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4384] = {
    [sym_heredoc_body] = STATE(6905),
    [aux_sym_call_repeat1] = STATE(6905),
    [aux_sym_argument_list_repeat1] = STATE(6906),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(7016),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4385] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6907),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_splat_argument] = STATE(6908),
    [sym_assignment] = STATE(6907),
    [sym_operator_assignment] = STATE(6907),
    [sym_conditional] = STATE(6907),
    [sym_range] = STATE(6907),
    [sym_binary] = STATE(6907),
    [sym_unary] = STATE(6907),
    [sym_right_assignment_list] = STATE(4290),
    [sym__arg_or_splat_arg] = STATE(6908),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(4192),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4386] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6909),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(6909),
    [sym_operator_assignment] = STATE(6909),
    [sym_conditional] = STATE(6909),
    [sym_range] = STATE(6909),
    [sym_binary] = STATE(6909),
    [sym_unary] = STATE(6909),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4387] = {
    [sym_string] = STATE(6910),
    [aux_sym_chained_string_repeat1] = STATE(6910),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [4388] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6911),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(6911),
    [sym_operator_assignment] = STATE(6911),
    [sym_conditional] = STATE(6911),
    [sym_range] = STATE(6911),
    [sym_binary] = STATE(6911),
    [sym_unary] = STATE(6911),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4389] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6912),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(6912),
    [sym_operator_assignment] = STATE(6912),
    [sym_conditional] = STATE(6912),
    [sym_range] = STATE(6912),
    [sym_binary] = STATE(6912),
    [sym_unary] = STATE(6912),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4390] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(562),
    [sym__argument_list_with_parens] = STATE(4846),
    [sym__argument] = STATE(4847),
    [sym_splat_argument] = STATE(4847),
    [sym_hash_splat_argument] = STATE(4847),
    [sym_block_argument] = STATE(4847),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4847),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4391] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(568),
    [sym__argument_list_with_parens] = STATE(4846),
    [sym__argument] = STATE(4847),
    [sym_splat_argument] = STATE(4847),
    [sym_hash_splat_argument] = STATE(4847),
    [sym_block_argument] = STATE(4847),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4847),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4392] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(4846),
    [sym__argument] = STATE(4847),
    [sym_splat_argument] = STATE(4847),
    [sym_hash_splat_argument] = STATE(4847),
    [sym_block_argument] = STATE(4847),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4847),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4393] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(4846),
    [sym__argument] = STATE(4847),
    [sym_splat_argument] = STATE(4847),
    [sym_hash_splat_argument] = STATE(4847),
    [sym_block_argument] = STATE(4847),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4847),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4394] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6913),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(6913),
    [sym_operator_assignment] = STATE(6913),
    [sym_conditional] = STATE(6913),
    [sym_range] = STATE(6913),
    [sym_binary] = STATE(6913),
    [sym_unary] = STATE(6913),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4395] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4396] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(10247),
    [anon_sym_QMARK] = ACTIONS(10249),
    [anon_sym_DOT_DOT] = ACTIONS(10251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10253),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(10255),
    [anon_sym_AMP_AMP] = ACTIONS(10255),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(10259),
    [anon_sym_BANG_EQ] = ACTIONS(10255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10255),
    [anon_sym_LT_EQ_GT] = ACTIONS(10255),
    [anon_sym_EQ_TILDE] = ACTIONS(10255),
    [anon_sym_BANG_TILDE] = ACTIONS(10255),
    [anon_sym_LT_EQ] = ACTIONS(10247),
    [anon_sym_GT] = ACTIONS(10247),
    [anon_sym_GT_EQ] = ACTIONS(10261),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [4397] = {
    [aux_sym_exceptions_repeat1] = STATE(6925),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(10265),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4398] = {
    [anon_sym_EQ] = ACTIONS(10267),
    [sym_comment] = ACTIONS(87),
  },
  [4399] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10269),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10271),
    [anon_sym_DASH_EQ] = ACTIONS(10271),
    [anon_sym_STAR_EQ] = ACTIONS(10271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10271),
    [anon_sym_SLASH_EQ] = ACTIONS(10271),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10271),
    [anon_sym_PIPE_EQ] = ACTIONS(10271),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10271),
    [anon_sym_AMP_EQ] = ACTIONS(10271),
    [anon_sym_PERCENT_EQ] = ACTIONS(10271),
    [anon_sym_GT_GT_EQ] = ACTIONS(10271),
    [anon_sym_LT_LT_EQ] = ACTIONS(10271),
    [anon_sym_CARET_EQ] = ACTIONS(10271),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4400] = {
    [sym_string] = STATE(6928),
    [aux_sym_chained_string_repeat1] = STATE(6928),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4401] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [4402] = {
    [sym_string] = STATE(4402),
    [aux_sym_chained_string_repeat1] = STATE(4402),
    [sym__string_start] = ACTIONS(6891),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [4403] = {
    [sym__simple_symbol] = ACTIONS(10273),
    [sym__string_start] = ACTIONS(10273),
    [sym__symbol_start] = ACTIONS(10273),
    [sym__subshell_start] = ACTIONS(10273),
    [sym__regex_start] = ACTIONS(10273),
    [sym__string_array_start] = ACTIONS(10273),
    [sym__symbol_array_start] = ACTIONS(10273),
    [sym_heredoc_beginning] = ACTIONS(10273),
    [sym__unary_minus] = ACTIONS(10273),
    [anon_sym_BEGIN] = ACTIONS(10275),
    [anon_sym_LBRACE] = ACTIONS(10273),
    [anon_sym_END] = ACTIONS(10275),
    [anon_sym_def] = ACTIONS(10275),
    [anon_sym_LPAREN] = ACTIONS(10273),
    [anon_sym_COLON_COLON] = ACTIONS(10273),
    [anon_sym_SEMI] = ACTIONS(10273),
    [anon_sym_STAR] = ACTIONS(10273),
    [anon_sym_class] = ACTIONS(10275),
    [anon_sym_module] = ACTIONS(10275),
    [anon_sym_end] = ACTIONS(10275),
    [anon_sym_return] = ACTIONS(10275),
    [anon_sym_yield] = ACTIONS(10275),
    [anon_sym_break] = ACTIONS(10275),
    [anon_sym_next] = ACTIONS(10275),
    [sym_redo] = ACTIONS(10275),
    [sym_retry] = ACTIONS(10275),
    [anon_sym_if] = ACTIONS(10275),
    [anon_sym_unless] = ACTIONS(10275),
    [anon_sym_while] = ACTIONS(10275),
    [anon_sym_until] = ACTIONS(10275),
    [anon_sym_rescue] = ACTIONS(10275),
    [anon_sym_for] = ACTIONS(10275),
    [anon_sym_case] = ACTIONS(10275),
    [anon_sym_else] = ACTIONS(10275),
    [anon_sym_begin] = ACTIONS(10275),
    [anon_sym_ensure] = ACTIONS(10275),
    [anon_sym_PLUS] = ACTIONS(10275),
    [anon_sym_defined_QMARK] = ACTIONS(10273),
    [anon_sym_not] = ACTIONS(10275),
    [anon_sym_BANG] = ACTIONS(10273),
    [anon_sym_TILDE] = ACTIONS(10273),
    [sym_constant] = ACTIONS(10275),
    [sym_identifier] = ACTIONS(10275),
    [sym_instance_variable] = ACTIONS(10273),
    [sym_class_variable] = ACTIONS(10273),
    [sym_global_variable] = ACTIONS(10273),
    [anon_sym_undef] = ACTIONS(10275),
    [anon_sym_alias] = ACTIONS(10275),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10275),
    [sym_float] = ACTIONS(10275),
    [sym_complex] = ACTIONS(10273),
    [sym_super] = ACTIONS(10275),
    [anon_sym_true] = ACTIONS(10275),
    [anon_sym_TRUE] = ACTIONS(10275),
    [anon_sym_false] = ACTIONS(10275),
    [anon_sym_FALSE] = ACTIONS(10275),
    [sym_self] = ACTIONS(10275),
    [anon_sym_nil] = ACTIONS(10275),
    [anon_sym_NIL] = ACTIONS(10275),
    [sym_character] = ACTIONS(10273),
    [anon_sym_LBRACK2] = ACTIONS(10273),
    [anon_sym_DASH_GT] = ACTIONS(10273),
  },
  [4404] = {
    [sym_heredoc_body] = STATE(6929),
    [sym__terminator] = STATE(6929),
    [sym__line_break] = ACTIONS(10277),
    [sym__simple_symbol] = ACTIONS(10273),
    [sym__string_start] = ACTIONS(10273),
    [sym__symbol_start] = ACTIONS(10273),
    [sym__subshell_start] = ACTIONS(10273),
    [sym__regex_start] = ACTIONS(10273),
    [sym__string_array_start] = ACTIONS(10273),
    [sym__symbol_array_start] = ACTIONS(10273),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(10273),
    [sym__unary_minus] = ACTIONS(10273),
    [anon_sym_BEGIN] = ACTIONS(10275),
    [anon_sym_LBRACE] = ACTIONS(10273),
    [anon_sym_END] = ACTIONS(10275),
    [anon_sym_def] = ACTIONS(10275),
    [anon_sym_LPAREN] = ACTIONS(10273),
    [anon_sym_COLON_COLON] = ACTIONS(10273),
    [anon_sym_SEMI] = ACTIONS(10277),
    [anon_sym_STAR] = ACTIONS(10273),
    [anon_sym_class] = ACTIONS(10275),
    [anon_sym_module] = ACTIONS(10275),
    [anon_sym_end] = ACTIONS(10275),
    [anon_sym_return] = ACTIONS(10275),
    [anon_sym_yield] = ACTIONS(10275),
    [anon_sym_break] = ACTIONS(10275),
    [anon_sym_next] = ACTIONS(10275),
    [sym_redo] = ACTIONS(10275),
    [sym_retry] = ACTIONS(10275),
    [anon_sym_if] = ACTIONS(10275),
    [anon_sym_unless] = ACTIONS(10275),
    [anon_sym_while] = ACTIONS(10275),
    [anon_sym_until] = ACTIONS(10275),
    [anon_sym_rescue] = ACTIONS(10275),
    [anon_sym_for] = ACTIONS(10275),
    [anon_sym_case] = ACTIONS(10275),
    [anon_sym_else] = ACTIONS(10275),
    [anon_sym_begin] = ACTIONS(10275),
    [anon_sym_ensure] = ACTIONS(10275),
    [anon_sym_PLUS] = ACTIONS(10275),
    [anon_sym_defined_QMARK] = ACTIONS(10273),
    [anon_sym_not] = ACTIONS(10275),
    [anon_sym_BANG] = ACTIONS(10273),
    [anon_sym_TILDE] = ACTIONS(10273),
    [sym_constant] = ACTIONS(10275),
    [sym_identifier] = ACTIONS(10275),
    [sym_instance_variable] = ACTIONS(10273),
    [sym_class_variable] = ACTIONS(10273),
    [sym_global_variable] = ACTIONS(10273),
    [anon_sym_undef] = ACTIONS(10275),
    [anon_sym_alias] = ACTIONS(10275),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10275),
    [sym_float] = ACTIONS(10275),
    [sym_complex] = ACTIONS(10273),
    [sym_super] = ACTIONS(10275),
    [anon_sym_true] = ACTIONS(10275),
    [anon_sym_TRUE] = ACTIONS(10275),
    [anon_sym_false] = ACTIONS(10275),
    [anon_sym_FALSE] = ACTIONS(10275),
    [sym_self] = ACTIONS(10275),
    [anon_sym_nil] = ACTIONS(10275),
    [anon_sym_NIL] = ACTIONS(10275),
    [sym_character] = ACTIONS(10273),
    [anon_sym_LBRACK2] = ACTIONS(10273),
    [anon_sym_DASH_GT] = ACTIONS(10273),
  },
  [4405] = {
    [aux_sym_method_parameters_repeat1] = STATE(6056),
    [anon_sym_RPAREN] = ACTIONS(10279),
    [anon_sym_COMMA] = ACTIONS(5616),
    [sym_comment] = ACTIONS(87),
  },
  [4406] = {
    [sym__statements] = STATE(6932),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(6933),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10281),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4407] = {
    [sym__statements] = STATE(6935),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(6936),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(6937),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(6937),
    [sym__line_break] = ACTIONS(10283),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10285),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4408] = {
    [sym_do_block] = STATE(6938),
    [sym_block] = STATE(6938),
    [anon_sym_LBRACE] = ACTIONS(7058),
    [anon_sym_do] = ACTIONS(10287),
    [sym_comment] = ACTIONS(87),
  },
  [4409] = {
    [sym__line_break] = ACTIONS(2491),
    [sym__heredoc_body_start] = ACTIONS(2491),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2491),
    [sym_comment] = ACTIONS(87),
  },
  [4410] = {
    [sym__line_break] = ACTIONS(9206),
    [sym__heredoc_body_start] = ACTIONS(9206),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(9206),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(8332),
    [anon_sym_QMARK] = ACTIONS(8334),
    [anon_sym_DOT_DOT] = ACTIONS(8336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8338),
    [anon_sym_and] = ACTIONS(10289),
    [anon_sym_or] = ACTIONS(10289),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ_GT] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_BANG_TILDE] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8332),
    [anon_sym_GT] = ACTIONS(8332),
    [anon_sym_GT_EQ] = ACTIONS(8346),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [4411] = {
    [sym__line_break] = ACTIONS(9240),
    [sym__heredoc_body_start] = ACTIONS(9240),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(9240),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(9240),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(8332),
    [anon_sym_QMARK] = ACTIONS(8334),
    [anon_sym_DOT_DOT] = ACTIONS(8336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8338),
    [anon_sym_and] = ACTIONS(10289),
    [anon_sym_or] = ACTIONS(10289),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ_GT] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_BANG_TILDE] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8332),
    [anon_sym_GT] = ACTIONS(8332),
    [anon_sym_GT_EQ] = ACTIONS(8346),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [4412] = {
    [sym__formal_parameter] = STATE(6939),
    [sym__simple_formal_parameter] = STATE(6939),
    [sym_destructured_parameter] = STATE(6939),
    [sym_splat_parameter] = STATE(6939),
    [sym_hash_splat_parameter] = STATE(6939),
    [sym_block_parameter] = STATE(6939),
    [sym_keyword_parameter] = STATE(6939),
    [sym_optional_parameter] = STATE(6939),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2457),
    [sym_comment] = ACTIONS(87),
  },
  [4413] = {
    [sym_heredoc_body] = STATE(6929),
    [sym__terminator] = STATE(6929),
    [aux_sym_method_parameters_repeat1] = STATE(6941),
    [sym__line_break] = ACTIONS(10277),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(10291),
    [anon_sym_SEMI] = ACTIONS(10277),
    [sym_comment] = ACTIONS(87),
  },
  [4414] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6942),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(6942),
    [sym_operator_assignment] = STATE(6942),
    [sym_conditional] = STATE(6942),
    [sym_range] = STATE(6942),
    [sym_binary] = STATE(6942),
    [sym_unary] = STATE(6942),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4415] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6948),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_argument_list] = STATE(4696),
    [sym__argument_list_with_parens] = STATE(6949),
    [sym__argument] = STATE(6950),
    [sym_splat_argument] = STATE(6950),
    [sym_hash_splat_argument] = STATE(6950),
    [sym_block_argument] = STATE(6950),
    [sym_assignment] = STATE(6948),
    [sym_operator_assignment] = STATE(6948),
    [sym_conditional] = STATE(6948),
    [sym_range] = STATE(6948),
    [sym_binary] = STATE(6948),
    [sym_unary] = STATE(6948),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6951),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6950),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10293),
    [sym__splat_star] = ACTIONS(10295),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(10297),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(7425),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(7094),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(10299),
    [sym_identifier] = ACTIONS(10299),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4416] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6948),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_argument_list] = STATE(4700),
    [sym__argument_list_with_parens] = STATE(6949),
    [sym__argument] = STATE(6950),
    [sym_splat_argument] = STATE(6950),
    [sym_hash_splat_argument] = STATE(6950),
    [sym_block_argument] = STATE(6950),
    [sym_assignment] = STATE(6948),
    [sym_operator_assignment] = STATE(6948),
    [sym_conditional] = STATE(6948),
    [sym_range] = STATE(6948),
    [sym_binary] = STATE(6948),
    [sym_unary] = STATE(6948),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6951),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6950),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10293),
    [sym__splat_star] = ACTIONS(10295),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(10297),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(7425),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(7094),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(10299),
    [sym_identifier] = ACTIONS(10299),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4417] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6948),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_argument_list] = STATE(4701),
    [sym__argument_list_with_parens] = STATE(6949),
    [sym__argument] = STATE(6950),
    [sym_splat_argument] = STATE(6950),
    [sym_hash_splat_argument] = STATE(6950),
    [sym_block_argument] = STATE(6950),
    [sym_assignment] = STATE(6948),
    [sym_operator_assignment] = STATE(6948),
    [sym_conditional] = STATE(6948),
    [sym_range] = STATE(6948),
    [sym_binary] = STATE(6948),
    [sym_unary] = STATE(6948),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6951),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6950),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10293),
    [sym__splat_star] = ACTIONS(10295),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(10297),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(7425),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(7094),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(10299),
    [sym_identifier] = ACTIONS(10299),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4418] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6948),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_argument_list] = STATE(4702),
    [sym__argument_list_with_parens] = STATE(6949),
    [sym__argument] = STATE(6950),
    [sym_splat_argument] = STATE(6950),
    [sym_hash_splat_argument] = STATE(6950),
    [sym_block_argument] = STATE(6950),
    [sym_assignment] = STATE(6948),
    [sym_operator_assignment] = STATE(6948),
    [sym_conditional] = STATE(6948),
    [sym_range] = STATE(6948),
    [sym_binary] = STATE(6948),
    [sym_unary] = STATE(6948),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6951),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6950),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10293),
    [sym__splat_star] = ACTIONS(10295),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(10297),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(7425),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(7094),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(10299),
    [sym_identifier] = ACTIONS(10299),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4419] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6952),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(6952),
    [sym_operator_assignment] = STATE(6952),
    [sym_conditional] = STATE(6952),
    [sym_range] = STATE(6952),
    [sym_binary] = STATE(6952),
    [sym_unary] = STATE(6952),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4420] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4717),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(4717),
    [sym_operator_assignment] = STATE(4717),
    [sym_conditional] = STATE(4717),
    [sym_range] = STATE(4717),
    [sym_binary] = STATE(4717),
    [sym_unary] = STATE(4717),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4421] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(10317),
    [anon_sym_or] = ACTIONS(10317),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [4422] = {
    [anon_sym_EQ] = ACTIONS(10329),
    [sym_comment] = ACTIONS(87),
  },
  [4423] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10331),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10333),
    [anon_sym_DASH_EQ] = ACTIONS(10333),
    [anon_sym_STAR_EQ] = ACTIONS(10333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10333),
    [anon_sym_SLASH_EQ] = ACTIONS(10333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10333),
    [anon_sym_PIPE_EQ] = ACTIONS(10333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10333),
    [anon_sym_AMP_EQ] = ACTIONS(10333),
    [anon_sym_PERCENT_EQ] = ACTIONS(10333),
    [anon_sym_GT_GT_EQ] = ACTIONS(10333),
    [anon_sym_LT_LT_EQ] = ACTIONS(10333),
    [anon_sym_CARET_EQ] = ACTIONS(10333),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4424] = {
    [sym_string] = STATE(6965),
    [aux_sym_chained_string_repeat1] = STATE(6965),
    [sym__string_start] = ACTIONS(3870),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4425] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(10317),
    [anon_sym_or] = ACTIONS(10317),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [4426] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4427] = {
    [sym_string] = STATE(4456),
    [aux_sym_chained_string_repeat1] = STATE(4456),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4428] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6966),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(6966),
    [sym_operator_assignment] = STATE(6966),
    [sym_conditional] = STATE(6966),
    [sym_range] = STATE(6966),
    [sym_binary] = STATE(6966),
    [sym_unary] = STATE(6966),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4429] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(10317),
    [anon_sym_or] = ACTIONS(10317),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [4430] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6967),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6967),
    [sym_operator_assignment] = STATE(6967),
    [sym_conditional] = STATE(6967),
    [sym_range] = STATE(6967),
    [sym_binary] = STATE(6967),
    [sym_unary] = STATE(6967),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4431] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6968),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6968),
    [sym_operator_assignment] = STATE(6968),
    [sym_conditional] = STATE(6968),
    [sym_range] = STATE(6968),
    [sym_binary] = STATE(6968),
    [sym_unary] = STATE(6968),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4432] = {
    [anon_sym_COLON] = ACTIONS(10335),
    [sym_comment] = ACTIONS(87),
  },
  [4433] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6970),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6970),
    [sym_operator_assignment] = STATE(6970),
    [sym_conditional] = STATE(6970),
    [sym_range] = STATE(6970),
    [sym_binary] = STATE(6970),
    [sym_unary] = STATE(6970),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4434] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10337),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4435] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [4436] = {
    [sym_heredoc_body] = STATE(6972),
    [aux_sym_call_repeat1] = STATE(6972),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4437] = {
    [sym_heredoc_body] = STATE(6972),
    [aux_sym_call_repeat1] = STATE(6972),
    [aux_sym_argument_list_repeat1] = STATE(6974),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10339),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4438] = {
    [sym_string] = STATE(4456),
    [aux_sym_chained_string_repeat1] = STATE(4456),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10341),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4439] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [4440] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(6975),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(6975),
    [sym_operator_assignment] = STATE(6975),
    [sym_conditional] = STATE(6975),
    [sym_range] = STATE(6975),
    [sym_binary] = STATE(6975),
    [sym_unary] = STATE(6975),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4441] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6976),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6976),
    [sym_operator_assignment] = STATE(6976),
    [sym_conditional] = STATE(6976),
    [sym_range] = STATE(6976),
    [sym_binary] = STATE(6976),
    [sym_unary] = STATE(6976),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4442] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6977),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6977),
    [sym_operator_assignment] = STATE(6977),
    [sym_conditional] = STATE(6977),
    [sym_range] = STATE(6977),
    [sym_binary] = STATE(6977),
    [sym_unary] = STATE(6977),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4443] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6978),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6978),
    [sym_operator_assignment] = STATE(6978),
    [sym_conditional] = STATE(6978),
    [sym_range] = STATE(6978),
    [sym_binary] = STATE(6978),
    [sym_unary] = STATE(6978),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4444] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6979),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6979),
    [sym_operator_assignment] = STATE(6979),
    [sym_conditional] = STATE(6979),
    [sym_range] = STATE(6979),
    [sym_binary] = STATE(6979),
    [sym_unary] = STATE(6979),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4445] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6980),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6980),
    [sym_operator_assignment] = STATE(6980),
    [sym_conditional] = STATE(6980),
    [sym_range] = STATE(6980),
    [sym_binary] = STATE(6980),
    [sym_unary] = STATE(6980),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4446] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6981),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(6981),
    [sym_operator_assignment] = STATE(6981),
    [sym_conditional] = STATE(6981),
    [sym_range] = STATE(6981),
    [sym_binary] = STATE(6981),
    [sym_unary] = STATE(6981),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4447] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6982),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6982),
    [sym_operator_assignment] = STATE(6982),
    [sym_conditional] = STATE(6982),
    [sym_range] = STATE(6982),
    [sym_binary] = STATE(6982),
    [sym_unary] = STATE(6982),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4448] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6983),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6983),
    [sym_operator_assignment] = STATE(6983),
    [sym_conditional] = STATE(6983),
    [sym_range] = STATE(6983),
    [sym_binary] = STATE(6983),
    [sym_unary] = STATE(6983),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4449] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6984),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6984),
    [sym_operator_assignment] = STATE(6984),
    [sym_conditional] = STATE(6984),
    [sym_range] = STATE(6984),
    [sym_binary] = STATE(6984),
    [sym_unary] = STATE(6984),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4450] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6985),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6985),
    [sym_operator_assignment] = STATE(6985),
    [sym_conditional] = STATE(6985),
    [sym_range] = STATE(6985),
    [sym_binary] = STATE(6985),
    [sym_unary] = STATE(6985),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4451] = {
    [sym_heredoc_body] = STATE(6986),
    [aux_sym_call_repeat1] = STATE(6986),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4452] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2103),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym__argument] = STATE(4625),
    [sym_splat_argument] = STATE(4625),
    [sym_hash_splat_argument] = STATE(4625),
    [sym_block_argument] = STATE(4625),
    [sym_assignment] = STATE(2103),
    [sym_operator_assignment] = STATE(2103),
    [sym_conditional] = STATE(2103),
    [sym_range] = STATE(2103),
    [sym_binary] = STATE(2103),
    [sym_unary] = STATE(2103),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2108),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(6987),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4625),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3566),
    [sym__splat_star] = ACTIONS(3568),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__identifier_hash_key] = ACTIONS(3572),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(3574),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3592),
    [sym_identifier] = ACTIONS(3592),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4453] = {
    [sym_heredoc_body] = STATE(6988),
    [aux_sym_call_repeat1] = STATE(6988),
    [aux_sym_argument_list_repeat1] = STATE(6989),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(7128),
    [anon_sym_EQ] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4454] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6990),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_splat_argument] = STATE(6991),
    [sym_assignment] = STATE(6990),
    [sym_operator_assignment] = STATE(6990),
    [sym_conditional] = STATE(6990),
    [sym_range] = STATE(6990),
    [sym_binary] = STATE(6990),
    [sym_unary] = STATE(6990),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(6991),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(7090),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4455] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6992),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(6992),
    [sym_operator_assignment] = STATE(6992),
    [sym_conditional] = STATE(6992),
    [sym_range] = STATE(6992),
    [sym_binary] = STATE(6992),
    [sym_unary] = STATE(6992),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4456] = {
    [sym_string] = STATE(6993),
    [aux_sym_chained_string_repeat1] = STATE(6993),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [4457] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4458] = {
    [sym_heredoc_body] = STATE(6994),
    [aux_sym_call_repeat1] = STATE(6994),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4459] = {
    [sym_heredoc_body] = STATE(6994),
    [aux_sym_call_repeat1] = STATE(6994),
    [aux_sym_argument_list_repeat1] = STATE(6995),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4460] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7148),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [4461] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6996),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(6996),
    [sym_operator_assignment] = STATE(6996),
    [sym_conditional] = STATE(6996),
    [sym_range] = STATE(6996),
    [sym_binary] = STATE(6996),
    [sym_unary] = STATE(6996),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4462] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6997),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(6997),
    [sym_operator_assignment] = STATE(6997),
    [sym_conditional] = STATE(6997),
    [sym_range] = STATE(6997),
    [sym_binary] = STATE(6997),
    [sym_unary] = STATE(6997),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4463] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6998),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(6998),
    [sym_operator_assignment] = STATE(6998),
    [sym_conditional] = STATE(6998),
    [sym_range] = STATE(6998),
    [sym_binary] = STATE(6998),
    [sym_unary] = STATE(6998),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4464] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(6999),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(6999),
    [sym_operator_assignment] = STATE(6999),
    [sym_conditional] = STATE(6999),
    [sym_range] = STATE(6999),
    [sym_binary] = STATE(6999),
    [sym_unary] = STATE(6999),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4465] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7000),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(7000),
    [sym_operator_assignment] = STATE(7000),
    [sym_conditional] = STATE(7000),
    [sym_range] = STATE(7000),
    [sym_binary] = STATE(7000),
    [sym_unary] = STATE(7000),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4466] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7001),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7001),
    [sym_operator_assignment] = STATE(7001),
    [sym_conditional] = STATE(7001),
    [sym_range] = STATE(7001),
    [sym_binary] = STATE(7001),
    [sym_unary] = STATE(7001),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4467] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7002),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(7002),
    [sym_operator_assignment] = STATE(7002),
    [sym_conditional] = STATE(7002),
    [sym_range] = STATE(7002),
    [sym_binary] = STATE(7002),
    [sym_unary] = STATE(7002),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4468] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7003),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(7003),
    [sym_operator_assignment] = STATE(7003),
    [sym_conditional] = STATE(7003),
    [sym_range] = STATE(7003),
    [sym_binary] = STATE(7003),
    [sym_unary] = STATE(7003),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4469] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7004),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(7004),
    [sym_operator_assignment] = STATE(7004),
    [sym_conditional] = STATE(7004),
    [sym_range] = STATE(7004),
    [sym_binary] = STATE(7004),
    [sym_unary] = STATE(7004),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4470] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7005),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(7005),
    [sym_operator_assignment] = STATE(7005),
    [sym_conditional] = STATE(7005),
    [sym_range] = STATE(7005),
    [sym_binary] = STATE(7005),
    [sym_unary] = STATE(7005),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4471] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7006),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_splat_argument] = STATE(7007),
    [sym_assignment] = STATE(7006),
    [sym_operator_assignment] = STATE(7006),
    [sym_conditional] = STATE(7006),
    [sym_range] = STATE(7006),
    [sym_binary] = STATE(7006),
    [sym_unary] = STATE(7006),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(7007),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4472] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7008),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(7008),
    [sym_operator_assignment] = STATE(7008),
    [sym_conditional] = STATE(7008),
    [sym_range] = STATE(7008),
    [sym_binary] = STATE(7008),
    [sym_unary] = STATE(7008),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4473] = {
    [sym_string] = STATE(7009),
    [aux_sym_chained_string_repeat1] = STATE(7009),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [4474] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7148),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [4475] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4476] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4477] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7010),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(7010),
    [sym_operator_assignment] = STATE(7010),
    [sym_conditional] = STATE(7010),
    [sym_range] = STATE(7010),
    [sym_binary] = STATE(7010),
    [sym_unary] = STATE(7010),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4478] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4479] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7011),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(7011),
    [sym_operator_assignment] = STATE(7011),
    [sym_conditional] = STATE(7011),
    [sym_range] = STATE(7011),
    [sym_binary] = STATE(7011),
    [sym_unary] = STATE(7011),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4480] = {
    [sym_heredoc_body] = STATE(7012),
    [aux_sym_call_repeat1] = STATE(7012),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4481] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2130),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(2130),
    [sym_operator_assignment] = STATE(2130),
    [sym_conditional] = STATE(2130),
    [sym_range] = STATE(2130),
    [sym_binary] = STATE(2130),
    [sym_unary] = STATE(2130),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2133),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7013),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(3616),
    [sym__splat_star] = ACTIONS(3618),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__identifier_hash_key] = ACTIONS(3620),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10343),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3622),
    [sym_identifier] = ACTIONS(3622),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4482] = {
    [sym_heredoc_body] = STATE(7014),
    [aux_sym_call_repeat1] = STATE(7014),
    [aux_sym_argument_list_repeat1] = STATE(7015),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(7174),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4483] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7148),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [4484] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4485] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [4486] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4487] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4488] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4489] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10345),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4490] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4491] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4492] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4493] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4494] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4495] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4496] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7017),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(7017),
    [sym_operator_assignment] = STATE(7017),
    [sym_conditional] = STATE(7017),
    [sym_range] = STATE(7017),
    [sym_binary] = STATE(7017),
    [sym_unary] = STATE(7017),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4497] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4498] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7018),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(7018),
    [sym_operator_assignment] = STATE(7018),
    [sym_conditional] = STATE(7018),
    [sym_range] = STATE(7018),
    [sym_binary] = STATE(7018),
    [sym_unary] = STATE(7018),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4499] = {
    [sym_heredoc_body] = STATE(7019),
    [aux_sym_call_repeat1] = STATE(7019),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4500] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2151),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(2151),
    [sym_operator_assignment] = STATE(2151),
    [sym_conditional] = STATE(2151),
    [sym_range] = STATE(2151),
    [sym_binary] = STATE(2151),
    [sym_unary] = STATE(2151),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2154),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(7020),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3652),
    [sym__splat_star] = ACTIONS(3654),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__identifier_hash_key] = ACTIONS(3656),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10347),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(3658),
    [sym_identifier] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4501] = {
    [sym_heredoc_body] = STATE(7021),
    [aux_sym_call_repeat1] = STATE(7021),
    [aux_sym_argument_list_repeat1] = STATE(7022),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(7182),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4502] = {
    [sym_heredoc_body] = STATE(4502),
    [aux_sym_call_repeat1] = STATE(4502),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [4503] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(699),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(699),
    [sym_operator_assignment] = STATE(699),
    [sym_conditional] = STATE(699),
    [sym_range] = STATE(699),
    [sym_binary] = STATE(699),
    [sym_unary] = STATE(699),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(705),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1299),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__identifier_hash_key] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7186),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1323),
    [sym_identifier] = ACTIONS(1323),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4504] = {
    [sym_heredoc_body] = STATE(4502),
    [aux_sym_call_repeat1] = STATE(4502),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [4505] = {
    [aux_sym_argument_list_repeat1] = STATE(4505),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(10349),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [4506] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4507] = {
    [aux_sym_exceptions_repeat1] = STATE(7024),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4508] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [4509] = {
    [sym_string] = STATE(4509),
    [aux_sym_chained_string_repeat1] = STATE(4509),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [4510] = {
    [aux_sym_undef_repeat1] = STATE(4510),
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [anon_sym_RPAREN] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9006),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [4511] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(145),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(145),
    [sym_unless_modifier] = STATE(145),
    [sym_while_modifier] = STATE(145),
    [sym_until_modifier] = STATE(145),
    [sym_rescue_modifier] = STATE(145),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(146),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(146),
    [sym_operator_assignment] = STATE(146),
    [sym_conditional] = STATE(146),
    [sym_range] = STATE(146),
    [sym_binary] = STATE(146),
    [sym_unary] = STATE(146),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_undef] = STATE(145),
    [sym_alias] = STATE(145),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(145),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4512] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7025),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(151),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(151),
    [sym_assignment] = STATE(7025),
    [sym_operator_assignment] = STATE(7025),
    [sym_conditional] = STATE(7025),
    [sym_range] = STATE(7025),
    [sym_binary] = STATE(7025),
    [sym_unary] = STATE(7025),
    [sym_left_assignment_list] = STATE(148),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(151),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(151),
    [sym_false] = STATE(151),
    [sym_nil] = STATE(151),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(152),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4513] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [4514] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [4515] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7026),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(7026),
    [sym_operator_assignment] = STATE(7026),
    [sym_conditional] = STATE(7026),
    [sym_range] = STATE(7026),
    [sym_binary] = STATE(7026),
    [sym_unary] = STATE(7026),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4516] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7027),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(7027),
    [sym_operator_assignment] = STATE(7027),
    [sym_conditional] = STATE(7027),
    [sym_range] = STATE(7027),
    [sym_binary] = STATE(7027),
    [sym_unary] = STATE(7027),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4517] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7028),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(7028),
    [sym_operator_assignment] = STATE(7028),
    [sym_conditional] = STATE(7028),
    [sym_range] = STATE(7028),
    [sym_binary] = STATE(7028),
    [sym_unary] = STATE(7028),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4518] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7029),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(7029),
    [sym_operator_assignment] = STATE(7029),
    [sym_conditional] = STATE(7029),
    [sym_range] = STATE(7029),
    [sym_binary] = STATE(7029),
    [sym_unary] = STATE(7029),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4519] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7030),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(7030),
    [sym_operator_assignment] = STATE(7030),
    [sym_conditional] = STATE(7030),
    [sym_range] = STATE(7030),
    [sym_binary] = STATE(7030),
    [sym_unary] = STATE(7030),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4520] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7031),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7031),
    [sym_operator_assignment] = STATE(7031),
    [sym_conditional] = STATE(7031),
    [sym_range] = STATE(7031),
    [sym_binary] = STATE(7031),
    [sym_unary] = STATE(7031),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4521] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7032),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(7032),
    [sym_operator_assignment] = STATE(7032),
    [sym_conditional] = STATE(7032),
    [sym_range] = STATE(7032),
    [sym_binary] = STATE(7032),
    [sym_unary] = STATE(7032),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4522] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7033),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(7033),
    [sym_operator_assignment] = STATE(7033),
    [sym_conditional] = STATE(7033),
    [sym_range] = STATE(7033),
    [sym_binary] = STATE(7033),
    [sym_unary] = STATE(7033),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4523] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7034),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(7034),
    [sym_operator_assignment] = STATE(7034),
    [sym_conditional] = STATE(7034),
    [sym_range] = STATE(7034),
    [sym_binary] = STATE(7034),
    [sym_unary] = STATE(7034),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4524] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7035),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(7035),
    [sym_operator_assignment] = STATE(7035),
    [sym_conditional] = STATE(7035),
    [sym_range] = STATE(7035),
    [sym_binary] = STATE(7035),
    [sym_unary] = STATE(7035),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4525] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7036),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_splat_argument] = STATE(7037),
    [sym_assignment] = STATE(7036),
    [sym_operator_assignment] = STATE(7036),
    [sym_conditional] = STATE(7036),
    [sym_range] = STATE(7036),
    [sym_binary] = STATE(7036),
    [sym_unary] = STATE(7036),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(7037),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(1375),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4526] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7038),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(7038),
    [sym_operator_assignment] = STATE(7038),
    [sym_conditional] = STATE(7038),
    [sym_range] = STATE(7038),
    [sym_binary] = STATE(7038),
    [sym_unary] = STATE(7038),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [4527] = {
    [sym_string] = STATE(7039),
    [aux_sym_chained_string_repeat1] = STATE(7039),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [4528] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [4529] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [4530] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4531] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [4532] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4533] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4534] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4535] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4536] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4537] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4538] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4539] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4540] = {
    [sym_heredoc_body] = STATE(4540),
    [aux_sym_call_repeat1] = STATE(4540),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [4541] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(738),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(738),
    [sym_operator_assignment] = STATE(738),
    [sym_conditional] = STATE(738),
    [sym_range] = STATE(738),
    [sym_binary] = STATE(738),
    [sym_unary] = STATE(738),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(744),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1373),
    [sym__splat_star] = ACTIONS(1375),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__identifier_hash_key] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7227),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1397),
    [sym_identifier] = ACTIONS(1397),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4542] = {
    [sym_heredoc_body] = STATE(4540),
    [aux_sym_call_repeat1] = STATE(4540),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [4543] = {
    [aux_sym_argument_list_repeat1] = STATE(4543),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(10354),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [4544] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4545] = {
    [aux_sym_exceptions_repeat1] = STATE(7042),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [4546] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [4547] = {
    [sym_string] = STATE(4547),
    [aux_sym_chained_string_repeat1] = STATE(4547),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [4548] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7233),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(7235),
    [anon_sym_LT] = ACTIONS(7237),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7239),
    [anon_sym_DOT_DOT] = ACTIONS(7241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7243),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7245),
    [anon_sym_AMP_AMP] = ACTIONS(7245),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(7249),
    [anon_sym_BANG_EQ] = ACTIONS(7245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7245),
    [anon_sym_LT_EQ_GT] = ACTIONS(7245),
    [anon_sym_EQ_TILDE] = ACTIONS(7245),
    [anon_sym_BANG_TILDE] = ACTIONS(7245),
    [anon_sym_LT_EQ] = ACTIONS(7237),
    [anon_sym_GT] = ACTIONS(7237),
    [anon_sym_GT_EQ] = ACTIONS(7251),
    [anon_sym_CARET] = ACTIONS(7253),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [4549] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4550] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7233),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(7235),
    [anon_sym_LT] = ACTIONS(7237),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7239),
    [anon_sym_DOT_DOT] = ACTIONS(7241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7243),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7245),
    [anon_sym_AMP_AMP] = ACTIONS(7245),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(7249),
    [anon_sym_BANG_EQ] = ACTIONS(7245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7245),
    [anon_sym_LT_EQ_GT] = ACTIONS(7245),
    [anon_sym_EQ_TILDE] = ACTIONS(7245),
    [anon_sym_BANG_TILDE] = ACTIONS(7245),
    [anon_sym_LT_EQ] = ACTIONS(7237),
    [anon_sym_GT] = ACTIONS(7237),
    [anon_sym_GT_EQ] = ACTIONS(7251),
    [anon_sym_CARET] = ACTIONS(7253),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [4551] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7043),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(7043),
    [sym_operator_assignment] = STATE(7043),
    [sym_conditional] = STATE(7043),
    [sym_range] = STATE(7043),
    [sym_binary] = STATE(7043),
    [sym_unary] = STATE(7043),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4552] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7044),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(7044),
    [sym_operator_assignment] = STATE(7044),
    [sym_conditional] = STATE(7044),
    [sym_range] = STATE(7044),
    [sym_binary] = STATE(7044),
    [sym_unary] = STATE(7044),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4553] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7045),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(7045),
    [sym_operator_assignment] = STATE(7045),
    [sym_conditional] = STATE(7045),
    [sym_range] = STATE(7045),
    [sym_binary] = STATE(7045),
    [sym_unary] = STATE(7045),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4554] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7046),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(7046),
    [sym_operator_assignment] = STATE(7046),
    [sym_conditional] = STATE(7046),
    [sym_range] = STATE(7046),
    [sym_binary] = STATE(7046),
    [sym_unary] = STATE(7046),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4555] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7047),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(7047),
    [sym_operator_assignment] = STATE(7047),
    [sym_conditional] = STATE(7047),
    [sym_range] = STATE(7047),
    [sym_binary] = STATE(7047),
    [sym_unary] = STATE(7047),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4556] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7048),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7048),
    [sym_operator_assignment] = STATE(7048),
    [sym_conditional] = STATE(7048),
    [sym_range] = STATE(7048),
    [sym_binary] = STATE(7048),
    [sym_unary] = STATE(7048),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4557] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7049),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(7049),
    [sym_operator_assignment] = STATE(7049),
    [sym_conditional] = STATE(7049),
    [sym_range] = STATE(7049),
    [sym_binary] = STATE(7049),
    [sym_unary] = STATE(7049),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4558] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7050),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(7050),
    [sym_operator_assignment] = STATE(7050),
    [sym_conditional] = STATE(7050),
    [sym_range] = STATE(7050),
    [sym_binary] = STATE(7050),
    [sym_unary] = STATE(7050),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4559] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7051),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(7051),
    [sym_operator_assignment] = STATE(7051),
    [sym_conditional] = STATE(7051),
    [sym_range] = STATE(7051),
    [sym_binary] = STATE(7051),
    [sym_unary] = STATE(7051),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4560] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7052),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(7052),
    [sym_operator_assignment] = STATE(7052),
    [sym_conditional] = STATE(7052),
    [sym_range] = STATE(7052),
    [sym_binary] = STATE(7052),
    [sym_unary] = STATE(7052),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4561] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2218),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(2218),
    [sym_operator_assignment] = STATE(2218),
    [sym_conditional] = STATE(2218),
    [sym_range] = STATE(2218),
    [sym_binary] = STATE(2218),
    [sym_unary] = STATE(2218),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(3742),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4562] = {
    [aux_sym_exceptions_repeat1] = STATE(7053),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(7255),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [4563] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2218),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_splat_argument] = STATE(7054),
    [sym_assignment] = STATE(2218),
    [sym_operator_assignment] = STATE(2218),
    [sym_conditional] = STATE(2218),
    [sym_range] = STATE(2218),
    [sym_binary] = STATE(2218),
    [sym_unary] = STATE(2218),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7054),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(3742),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4564] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7055),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(7055),
    [sym_operator_assignment] = STATE(7055),
    [sym_conditional] = STATE(7055),
    [sym_range] = STATE(7055),
    [sym_binary] = STATE(7055),
    [sym_unary] = STATE(7055),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4565] = {
    [anon_sym_DOT] = ACTIONS(6333),
    [anon_sym_LBRACK] = ACTIONS(6333),
    [anon_sym_COLON_COLON2] = ACTIONS(6333),
    [anon_sym_AMP_DOT] = ACTIONS(6333),
    [sym_comment] = ACTIONS(87),
  },
  [4566] = {
    [anon_sym_DOT] = ACTIONS(6337),
    [anon_sym_LBRACK] = ACTIONS(6337),
    [anon_sym_COLON_COLON2] = ACTIONS(6337),
    [anon_sym_AMP_DOT] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
  },
  [4567] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10357),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4568] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(10357),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10359),
  },
  [4569] = {
    [anon_sym_DOT] = ACTIONS(6345),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_COLON_COLON2] = ACTIONS(6345),
    [anon_sym_AMP_DOT] = ACTIONS(6345),
    [sym_comment] = ACTIONS(87),
  },
  [4570] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10361),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4571] = {
    [anon_sym_DOT] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6358),
    [anon_sym_COLON_COLON2] = ACTIONS(6358),
    [anon_sym_AMP_DOT] = ACTIONS(6358),
    [sym_comment] = ACTIONS(87),
  },
  [4572] = {
    [anon_sym_DOT] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6362),
    [anon_sym_COLON_COLON2] = ACTIONS(6362),
    [anon_sym_AMP_DOT] = ACTIONS(6362),
    [sym_comment] = ACTIONS(87),
  },
  [4573] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10363),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4574] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(10363),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10365),
  },
  [4575] = {
    [anon_sym_DOT] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6370),
    [anon_sym_COLON_COLON2] = ACTIONS(6370),
    [anon_sym_AMP_DOT] = ACTIONS(6370),
    [sym_comment] = ACTIONS(87),
  },
  [4576] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10367),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4577] = {
    [anon_sym_DOT] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6894),
    [anon_sym_COLON_COLON2] = ACTIONS(6894),
    [anon_sym_AMP_DOT] = ACTIONS(6894),
    [sym_comment] = ACTIONS(87),
  },
  [4578] = {
    [anon_sym_DOT] = ACTIONS(10369),
    [anon_sym_COLON_COLON] = ACTIONS(10369),
    [sym_comment] = ACTIONS(87),
  },
  [4579] = {
    [anon_sym_DOT] = ACTIONS(7046),
    [anon_sym_LBRACK] = ACTIONS(7046),
    [anon_sym_COLON_COLON2] = ACTIONS(7046),
    [anon_sym_AMP_DOT] = ACTIONS(7046),
    [sym_comment] = ACTIONS(87),
  },
  [4580] = {
    [anon_sym_DOT] = ACTIONS(7062),
    [anon_sym_LBRACK] = ACTIONS(7062),
    [anon_sym_COLON_COLON2] = ACTIONS(7062),
    [anon_sym_AMP_DOT] = ACTIONS(7062),
    [sym_comment] = ACTIONS(87),
  },
  [4581] = {
    [sym__statements] = STATE(800),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(801),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(802),
    [sym_rescue] = STATE(803),
    [sym__body_statement] = STATE(7063),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10371),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4582] = {
    [sym__statements] = STATE(800),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(801),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(802),
    [sym_rescue] = STATE(803),
    [sym__body_statement] = STATE(7064),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10373),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4583] = {
    [anon_sym_DOT] = ACTIONS(7496),
    [anon_sym_LBRACK] = ACTIONS(7496),
    [anon_sym_COLON_COLON2] = ACTIONS(7496),
    [anon_sym_AMP_DOT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [4584] = {
    [anon_sym_DOT] = ACTIONS(7550),
    [anon_sym_LBRACK] = ACTIONS(7550),
    [anon_sym_COLON_COLON2] = ACTIONS(7550),
    [anon_sym_AMP_DOT] = ACTIONS(7550),
    [sym_comment] = ACTIONS(87),
  },
  [4585] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4586] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7065),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7065),
    [sym_operator_assignment] = STATE(7065),
    [sym_conditional] = STATE(7065),
    [sym_range] = STATE(7065),
    [sym_binary] = STATE(7065),
    [sym_unary] = STATE(7065),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4587] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7066),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7066),
    [sym_operator_assignment] = STATE(7066),
    [sym_conditional] = STATE(7066),
    [sym_range] = STATE(7066),
    [sym_binary] = STATE(7066),
    [sym_unary] = STATE(7066),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4588] = {
    [anon_sym_COLON] = ACTIONS(10375),
    [sym_comment] = ACTIONS(87),
  },
  [4589] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7068),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7068),
    [sym_operator_assignment] = STATE(7068),
    [sym_conditional] = STATE(7068),
    [sym_range] = STATE(7068),
    [sym_binary] = STATE(7068),
    [sym_unary] = STATE(7068),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4590] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10377),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4591] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(10375),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [4592] = {
    [sym_heredoc_body] = STATE(7070),
    [aux_sym_call_repeat1] = STATE(7070),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4593] = {
    [sym_heredoc_body] = STATE(7070),
    [aux_sym_call_repeat1] = STATE(7070),
    [aux_sym_argument_list_repeat1] = STATE(7072),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10379),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4594] = {
    [sym_string] = STATE(1872),
    [aux_sym_chained_string_repeat1] = STATE(1872),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10381),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4595] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [4596] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7073),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7073),
    [sym_operator_assignment] = STATE(7073),
    [sym_conditional] = STATE(7073),
    [sym_range] = STATE(7073),
    [sym_binary] = STATE(7073),
    [sym_unary] = STATE(7073),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4597] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7074),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7074),
    [sym_operator_assignment] = STATE(7074),
    [sym_conditional] = STATE(7074),
    [sym_range] = STATE(7074),
    [sym_binary] = STATE(7074),
    [sym_unary] = STATE(7074),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4598] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7075),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7075),
    [sym_operator_assignment] = STATE(7075),
    [sym_conditional] = STATE(7075),
    [sym_range] = STATE(7075),
    [sym_binary] = STATE(7075),
    [sym_unary] = STATE(7075),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4599] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7076),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7076),
    [sym_operator_assignment] = STATE(7076),
    [sym_conditional] = STATE(7076),
    [sym_range] = STATE(7076),
    [sym_binary] = STATE(7076),
    [sym_unary] = STATE(7076),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4600] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7077),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7077),
    [sym_operator_assignment] = STATE(7077),
    [sym_conditional] = STATE(7077),
    [sym_range] = STATE(7077),
    [sym_binary] = STATE(7077),
    [sym_unary] = STATE(7077),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4601] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7078),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7078),
    [sym_operator_assignment] = STATE(7078),
    [sym_conditional] = STATE(7078),
    [sym_range] = STATE(7078),
    [sym_binary] = STATE(7078),
    [sym_unary] = STATE(7078),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4602] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7079),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7079),
    [sym_operator_assignment] = STATE(7079),
    [sym_conditional] = STATE(7079),
    [sym_range] = STATE(7079),
    [sym_binary] = STATE(7079),
    [sym_unary] = STATE(7079),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4603] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7080),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7080),
    [sym_operator_assignment] = STATE(7080),
    [sym_conditional] = STATE(7080),
    [sym_range] = STATE(7080),
    [sym_binary] = STATE(7080),
    [sym_unary] = STATE(7080),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4604] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7081),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7081),
    [sym_operator_assignment] = STATE(7081),
    [sym_conditional] = STATE(7081),
    [sym_range] = STATE(7081),
    [sym_binary] = STATE(7081),
    [sym_unary] = STATE(7081),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4605] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7082),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7082),
    [sym_operator_assignment] = STATE(7082),
    [sym_conditional] = STATE(7082),
    [sym_range] = STATE(7082),
    [sym_binary] = STATE(7082),
    [sym_unary] = STATE(7082),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4606] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(7090),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(7090),
    [sym_operator_assignment] = STATE(7090),
    [sym_conditional] = STATE(7090),
    [sym_range] = STATE(7090),
    [sym_binary] = STATE(7090),
    [sym_unary] = STATE(7090),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4607] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(7094),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(7094),
    [sym_operator_assignment] = STATE(7094),
    [sym_conditional] = STATE(7094),
    [sym_range] = STATE(7094),
    [sym_binary] = STATE(7094),
    [sym_unary] = STATE(7094),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4608] = {
    [anon_sym_COLON] = ACTIONS(10401),
    [sym_comment] = ACTIONS(87),
  },
  [4609] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(7096),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(7096),
    [sym_operator_assignment] = STATE(7096),
    [sym_conditional] = STATE(7096),
    [sym_range] = STATE(7096),
    [sym_binary] = STATE(7096),
    [sym_unary] = STATE(7096),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [4610] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10403),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4611] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(10401),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [4612] = {
    [sym_heredoc_body] = STATE(7098),
    [aux_sym_call_repeat1] = STATE(7098),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [4613] = {
    [sym_heredoc_body] = STATE(7098),
    [aux_sym_call_repeat1] = STATE(7098),
    [aux_sym_argument_list_repeat1] = STATE(7100),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10405),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [4614] = {
    [sym_string] = STATE(2007),
    [aux_sym_chained_string_repeat1] = STATE(2007),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10407),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4615] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7101),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_splat_argument] = STATE(7102),
    [sym_assignment] = STATE(7101),
    [sym_operator_assignment] = STATE(7101),
    [sym_conditional] = STATE(7101),
    [sym_range] = STATE(7101),
    [sym_binary] = STATE(7101),
    [sym_unary] = STATE(7101),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(7102),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7301),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4616] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7103),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(7103),
    [sym_operator_assignment] = STATE(7103),
    [sym_conditional] = STATE(7103),
    [sym_range] = STATE(7103),
    [sym_binary] = STATE(7103),
    [sym_unary] = STATE(7103),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4617] = {
    [sym_string] = STATE(7104),
    [aux_sym_chained_string_repeat1] = STATE(7104),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [4618] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(7323),
    [anon_sym_or] = ACTIONS(7323),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [4619] = {
    [sym__heredoc_body_start] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7608),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_EQ] = ACTIONS(7608),
    [anon_sym_in] = ACTIONS(7608),
    [anon_sym_do] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
  },
  [4620] = {
    [anon_sym_RPAREN] = ACTIONS(10409),
    [sym_comment] = ACTIONS(87),
  },
  [4621] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(7323),
    [anon_sym_or] = ACTIONS(7323),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [4622] = {
    [sym__heredoc_body_start] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(3102),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_EQ] = ACTIONS(3102),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_COLON_COLON2] = ACTIONS(3102),
    [anon_sym_AMP_DOT] = ACTIONS(3102),
    [sym_comment] = ACTIONS(87),
  },
  [4623] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(10411),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [4624] = {
    [sym_heredoc_body] = STATE(4624),
    [aux_sym_call_repeat1] = STATE(4624),
    [sym__heredoc_body_start] = ACTIONS(10413),
    [anon_sym_DOT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [4625] = {
    [sym__heredoc_body_start] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7657),
    [anon_sym_COMMA] = ACTIONS(7657),
    [anon_sym_EQ] = ACTIONS(7657),
    [anon_sym_in] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [4626] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(785),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym__argument] = STATE(7107),
    [sym_splat_argument] = STATE(7107),
    [sym_hash_splat_argument] = STATE(7107),
    [sym_block_argument] = STATE(7107),
    [sym_assignment] = STATE(785),
    [sym_operator_assignment] = STATE(785),
    [sym_conditional] = STATE(785),
    [sym_range] = STATE(785),
    [sym_binary] = STATE(785),
    [sym_unary] = STATE(785),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(789),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(7107),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1449),
    [sym__splat_star] = ACTIONS(1451),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1455),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(1461),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4627] = {
    [sym_heredoc_body] = STATE(4624),
    [aux_sym_call_repeat1] = STATE(4624),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [4628] = {
    [aux_sym_argument_list_repeat1] = STATE(4628),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7657),
    [anon_sym_COMMA] = ACTIONS(10416),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [4629] = {
    [anon_sym_DOT] = ACTIONS(7724),
    [anon_sym_LBRACK] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(7724),
    [anon_sym_AMP_DOT] = ACTIONS(7724),
    [sym_comment] = ACTIONS(87),
  },
  [4630] = {
    [sym_elsif] = STATE(7109),
    [sym_else] = STATE(7109),
    [sym__if_tail] = STATE(7109),
    [anon_sym_end] = ACTIONS(10419),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [4631] = {
    [anon_sym_end] = ACTIONS(10419),
    [sym_comment] = ACTIONS(87),
  },
  [4632] = {
    [sym__statements] = STATE(7110),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(7109),
    [sym_else] = STATE(7109),
    [sym__if_tail] = STATE(7109),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10421),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4633] = {
    [anon_sym_DOT] = ACTIONS(7922),
    [anon_sym_LBRACK] = ACTIONS(7922),
    [anon_sym_COLON_COLON2] = ACTIONS(7922),
    [anon_sym_AMP_DOT] = ACTIONS(7922),
    [sym_comment] = ACTIONS(87),
  },
  [4634] = {
    [sym_else] = STATE(7112),
    [anon_sym_end] = ACTIONS(10423),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [4635] = {
    [anon_sym_end] = ACTIONS(10423),
    [sym_comment] = ACTIONS(87),
  },
  [4636] = {
    [anon_sym_DOT] = ACTIONS(8090),
    [anon_sym_LBRACK] = ACTIONS(8090),
    [anon_sym_COLON_COLON2] = ACTIONS(8090),
    [anon_sym_AMP_DOT] = ACTIONS(8090),
    [sym_comment] = ACTIONS(87),
  },
  [4637] = {
    [anon_sym_end] = ACTIONS(10425),
    [sym_comment] = ACTIONS(87),
  },
  [4638] = {
    [anon_sym_DOT] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_COLON_COLON2] = ACTIONS(8166),
    [anon_sym_AMP_DOT] = ACTIONS(8166),
    [sym_comment] = ACTIONS(87),
  },
  [4639] = {
    [anon_sym_end] = ACTIONS(10427),
    [sym_comment] = ACTIONS(87),
  },
  [4640] = {
    [sym__statements] = STATE(7116),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10429),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4641] = {
    [anon_sym_end] = ACTIONS(10431),
    [sym_comment] = ACTIONS(87),
  },
  [4642] = {
    [sym_when] = STATE(7118),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4643] = {
    [anon_sym_DOT] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8414),
    [anon_sym_COLON_COLON2] = ACTIONS(8414),
    [anon_sym_AMP_DOT] = ACTIONS(8414),
    [sym_comment] = ACTIONS(87),
  },
  [4644] = {
    [anon_sym_DOT] = ACTIONS(8923),
    [anon_sym_LBRACK] = ACTIONS(8923),
    [anon_sym_COLON_COLON2] = ACTIONS(8923),
    [anon_sym_AMP_DOT] = ACTIONS(8923),
    [sym_comment] = ACTIONS(87),
  },
  [4645] = {
    [anon_sym_end] = ACTIONS(10433),
    [sym_comment] = ACTIONS(87),
  },
  [4646] = {
    [sym_ensure] = STATE(7120),
    [anon_sym_end] = ACTIONS(10433),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [4647] = {
    [anon_sym_DOT] = ACTIONS(9143),
    [anon_sym_LBRACK] = ACTIONS(9143),
    [anon_sym_COLON_COLON2] = ACTIONS(9143),
    [anon_sym_AMP_DOT] = ACTIONS(9143),
    [sym_comment] = ACTIONS(87),
  },
  [4648] = {
    [anon_sym_LBRACE] = ACTIONS(9172),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9172),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9172),
    [anon_sym_SEMI] = ACTIONS(9172),
    [anon_sym_EQ] = ACTIONS(9172),
    [anon_sym_in] = ACTIONS(9172),
    [anon_sym_do] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [sym_comment] = ACTIONS(87),
  },
  [4649] = {
    [anon_sym_RBRACE] = ACTIONS(10435),
    [sym_comment] = ACTIONS(87),
  },
  [4650] = {
    [anon_sym_LBRACE] = ACTIONS(9192),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9192),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9192),
    [anon_sym_SEMI] = ACTIONS(9192),
    [anon_sym_EQ] = ACTIONS(9192),
    [anon_sym_in] = ACTIONS(9192),
    [anon_sym_do] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [sym_comment] = ACTIONS(87),
  },
  [4651] = {
    [anon_sym_end] = ACTIONS(10437),
    [sym_comment] = ACTIONS(87),
  },
  [4652] = {
    [sym__statements] = STATE(7123),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10439),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4653] = {
    [sym__statements] = STATE(7123),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(7124),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(7124),
    [sym__line_break] = ACTIONS(10441),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10439),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4654] = {
    [sym__simple_symbol] = ACTIONS(4148),
    [sym__string_start] = ACTIONS(4148),
    [sym__symbol_start] = ACTIONS(4148),
    [sym__subshell_start] = ACTIONS(4148),
    [sym__regex_start] = ACTIONS(4148),
    [sym__string_array_start] = ACTIONS(4148),
    [sym__symbol_array_start] = ACTIONS(4148),
    [sym_heredoc_beginning] = ACTIONS(4148),
    [sym__block_ampersand] = ACTIONS(4148),
    [sym__splat_star] = ACTIONS(4148),
    [sym__unary_minus] = ACTIONS(4148),
    [sym__identifier_hash_key] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_def] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(4150),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4148),
    [anon_sym_COLON_COLON] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_STAR_STAR] = ACTIONS(4148),
    [anon_sym_EQ] = ACTIONS(4148),
    [anon_sym_class] = ACTIONS(4150),
    [anon_sym_module] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_yield] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_next] = ACTIONS(4150),
    [sym_redo] = ACTIONS(4150),
    [sym_retry] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_unless] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [anon_sym_until] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_in] = ACTIONS(4150),
    [anon_sym_do] = ACTIONS(4150),
    [anon_sym_case] = ACTIONS(4150),
    [anon_sym_begin] = ACTIONS(4150),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_defined_QMARK] = ACTIONS(4148),
    [anon_sym_not] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4148),
    [sym_constant] = ACTIONS(4150),
    [sym_identifier] = ACTIONS(4150),
    [sym_instance_variable] = ACTIONS(4148),
    [sym_class_variable] = ACTIONS(4148),
    [sym_global_variable] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4150),
    [sym_float] = ACTIONS(4150),
    [sym_complex] = ACTIONS(4148),
    [sym_super] = ACTIONS(4150),
    [anon_sym_true] = ACTIONS(4150),
    [anon_sym_TRUE] = ACTIONS(4150),
    [anon_sym_false] = ACTIONS(4150),
    [anon_sym_FALSE] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [anon_sym_nil] = ACTIONS(4150),
    [anon_sym_NIL] = ACTIONS(4150),
    [sym_character] = ACTIONS(4148),
    [anon_sym_LBRACK2] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4148),
  },
  [4655] = {
    [sym_heredoc_body] = STATE(7126),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(10443),
    [sym_comment] = ACTIONS(87),
  },
  [4656] = {
    [anon_sym_RPAREN] = ACTIONS(10443),
    [sym_comment] = ACTIONS(87),
  },
  [4657] = {
    [sym__simple_symbol] = ACTIONS(9425),
    [sym__string_start] = ACTIONS(9425),
    [sym__symbol_start] = ACTIONS(9425),
    [sym__subshell_start] = ACTIONS(9425),
    [sym__regex_start] = ACTIONS(9425),
    [sym__string_array_start] = ACTIONS(9425),
    [sym__symbol_array_start] = ACTIONS(9425),
    [sym_heredoc_beginning] = ACTIONS(9425),
    [sym__block_ampersand] = ACTIONS(9425),
    [sym__splat_star] = ACTIONS(9425),
    [sym__unary_minus] = ACTIONS(9425),
    [sym__identifier_hash_key] = ACTIONS(9425),
    [anon_sym_LBRACE] = ACTIONS(9425),
    [anon_sym_def] = ACTIONS(9427),
    [anon_sym_LPAREN] = ACTIONS(9427),
    [anon_sym_RPAREN] = ACTIONS(9425),
    [anon_sym_DOT] = ACTIONS(9425),
    [anon_sym_COLON_COLON] = ACTIONS(9427),
    [anon_sym_COMMA] = ACTIONS(9425),
    [anon_sym_STAR] = ACTIONS(9427),
    [anon_sym_STAR_STAR] = ACTIONS(9425),
    [anon_sym_EQ] = ACTIONS(9425),
    [anon_sym_class] = ACTIONS(9427),
    [anon_sym_module] = ACTIONS(9427),
    [anon_sym_return] = ACTIONS(9427),
    [anon_sym_yield] = ACTIONS(9427),
    [anon_sym_break] = ACTIONS(9427),
    [anon_sym_next] = ACTIONS(9427),
    [sym_redo] = ACTIONS(9427),
    [sym_retry] = ACTIONS(9427),
    [anon_sym_if] = ACTIONS(9427),
    [anon_sym_unless] = ACTIONS(9427),
    [anon_sym_while] = ACTIONS(9427),
    [anon_sym_until] = ACTIONS(9427),
    [anon_sym_for] = ACTIONS(9427),
    [anon_sym_in] = ACTIONS(9427),
    [anon_sym_do] = ACTIONS(9427),
    [anon_sym_case] = ACTIONS(9427),
    [anon_sym_begin] = ACTIONS(9427),
    [anon_sym_LBRACK] = ACTIONS(9425),
    [anon_sym_COLON_COLON2] = ACTIONS(9425),
    [anon_sym_AMP_DOT] = ACTIONS(9425),
    [anon_sym_LPAREN2] = ACTIONS(9425),
    [anon_sym_PLUS] = ACTIONS(9427),
    [anon_sym_defined_QMARK] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_constant] = ACTIONS(9427),
    [sym_identifier] = ACTIONS(9427),
    [sym_instance_variable] = ACTIONS(9425),
    [sym_class_variable] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(9425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9427),
    [sym_float] = ACTIONS(9427),
    [sym_complex] = ACTIONS(9425),
    [sym_super] = ACTIONS(9427),
    [anon_sym_true] = ACTIONS(9427),
    [anon_sym_TRUE] = ACTIONS(9427),
    [anon_sym_false] = ACTIONS(9427),
    [anon_sym_FALSE] = ACTIONS(9427),
    [sym_self] = ACTIONS(9427),
    [anon_sym_nil] = ACTIONS(9427),
    [anon_sym_NIL] = ACTIONS(9427),
    [sym_character] = ACTIONS(9425),
    [anon_sym_LBRACK2] = ACTIONS(9427),
    [anon_sym_DASH_GT] = ACTIONS(9425),
  },
  [4658] = {
    [anon_sym_RPAREN] = ACTIONS(9432),
    [anon_sym_DOT] = ACTIONS(9432),
    [anon_sym_COMMA] = ACTIONS(9432),
    [anon_sym_EQ] = ACTIONS(9432),
    [anon_sym_in] = ACTIONS(9432),
    [anon_sym_LBRACK] = ACTIONS(9432),
    [anon_sym_COLON_COLON2] = ACTIONS(9432),
    [anon_sym_AMP_DOT] = ACTIONS(9432),
    [sym_comment] = ACTIONS(87),
  },
  [4659] = {
    [anon_sym_RBRACK] = ACTIONS(10445),
    [sym_comment] = ACTIONS(87),
  },
  [4660] = {
    [sym__string_start] = ACTIONS(837),
    [sym__heredoc_body_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_COLON2] = ACTIONS(839),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [4661] = {
    [sym__string_end] = ACTIONS(10447),
    [sym_comment] = ACTIONS(87),
  },
  [4662] = {
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_STAR_STAR] = ACTIONS(887),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(887),
    [anon_sym_AMP_AMP] = ACTIONS(887),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_GT_GT] = ACTIONS(887),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_PERCENT] = ACTIONS(887),
    [sym_comment] = ACTIONS(87),
  },
  [4663] = {
    [sym__string_end] = ACTIONS(10449),
    [sym_comment] = ACTIONS(87),
  },
  [4664] = {
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [4665] = {
    [sym__string_end] = ACTIONS(10451),
    [sym_comment] = ACTIONS(87),
  },
  [4666] = {
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [4667] = {
    [sym__string_end] = ACTIONS(10453),
    [sym_comment] = ACTIONS(87),
  },
  [4668] = {
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [4669] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(7134),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10455),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10457),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [4670] = {
    [aux_sym_string_array_repeat1] = STATE(7137),
    [sym__string_end] = ACTIONS(10459),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10461),
  },
  [4671] = {
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_STAR_STAR] = ACTIONS(923),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_GT_GT] = ACTIONS(923),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_SLASH] = ACTIONS(923),
    [anon_sym_PERCENT] = ACTIONS(923),
    [sym_comment] = ACTIONS(87),
  },
  [4672] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(7140),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(10463),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10465),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [4673] = {
    [aux_sym_symbol_array_repeat1] = STATE(7143),
    [sym__string_end] = ACTIONS(10467),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10469),
  },
  [4674] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4675] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [4676] = {
    [anon_sym_RBRACE] = ACTIONS(10471),
    [sym_comment] = ACTIONS(87),
  },
  [4677] = {
    [sym_heredoc_body] = STATE(7145),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(10471),
    [sym_comment] = ACTIONS(87),
  },
  [4678] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7146),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(7146),
    [sym_operator_assignment] = STATE(7146),
    [sym_conditional] = STATE(7146),
    [sym_range] = STATE(7146),
    [sym_binary] = STATE(7146),
    [sym_unary] = STATE(7146),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4679] = {
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [4680] = {
    [anon_sym_DOT] = ACTIONS(10473),
    [anon_sym_COLON_COLON] = ACTIONS(10473),
    [sym_comment] = ACTIONS(87),
  },
  [4681] = {
    [sym_method_parameters] = STATE(7148),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(7148),
    [sym__terminator] = STATE(7148),
    [sym__line_break] = ACTIONS(10475),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(10475),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [4682] = {
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1291),
    [anon_sym_AMP_AMP] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1291),
    [sym_comment] = ACTIONS(87),
  },
  [4683] = {
    [anon_sym_RPAREN] = ACTIONS(10477),
    [sym_comment] = ACTIONS(87),
  },
  [4684] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7150),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(7150),
    [sym_operator_assignment] = STATE(7150),
    [sym_conditional] = STATE(7150),
    [sym_range] = STATE(7150),
    [sym_binary] = STATE(7150),
    [sym_unary] = STATE(7150),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4685] = {
    [sym_superclass] = STATE(7151),
    [sym_heredoc_body] = STATE(7152),
    [sym__terminator] = STATE(7152),
    [sym__line_break] = ACTIONS(10479),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(10479),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4686] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_superclass] = STATE(7151),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(7152),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(7152),
    [sym__line_break] = ACTIONS(10479),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(10479),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4687] = {
    [sym_heredoc_body] = STATE(7154),
    [sym__terminator] = STATE(7154),
    [sym__line_break] = ACTIONS(10481),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(10481),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(10483),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4688] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(7154),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(7154),
    [sym__line_break] = ACTIONS(10481),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(10481),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(10483),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4689] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7155),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7155),
    [sym_operator_assignment] = STATE(7155),
    [sym_conditional] = STATE(7155),
    [sym_range] = STATE(7155),
    [sym_binary] = STATE(7155),
    [sym_unary] = STATE(7155),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4690] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7156),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7156),
    [sym_operator_assignment] = STATE(7156),
    [sym_conditional] = STATE(7156),
    [sym_range] = STATE(7156),
    [sym_binary] = STATE(7156),
    [sym_unary] = STATE(7156),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4691] = {
    [anon_sym_COLON] = ACTIONS(10485),
    [sym_comment] = ACTIONS(87),
  },
  [4692] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7158),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7158),
    [sym_operator_assignment] = STATE(7158),
    [sym_conditional] = STATE(7158),
    [sym_range] = STATE(7158),
    [sym_binary] = STATE(7158),
    [sym_unary] = STATE(7158),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4693] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(7160),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(7161),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(10487),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4694] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10489),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4695] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(10485),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4696] = {
    [sym__heredoc_body_start] = ACTIONS(1679),
    [sym__binary_minus] = ACTIONS(1679),
    [sym__binary_star] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_STAR_STAR] = ACTIONS(1679),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1679),
    [anon_sym_AMP_DOT] = ACTIONS(1679),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_DOT_DOT] = ACTIONS(1681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1679),
    [anon_sym_and] = ACTIONS(1679),
    [anon_sym_or] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE] = ACTIONS(1679),
    [anon_sym_AMP_AMP] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(1679),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_BANG_EQ] = ACTIONS(1679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1679),
    [anon_sym_LT_EQ_GT] = ACTIONS(1679),
    [anon_sym_EQ_TILDE] = ACTIONS(1679),
    [anon_sym_BANG_TILDE] = ACTIONS(1679),
    [anon_sym_LT_EQ] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1679),
    [anon_sym_CARET] = ACTIONS(1679),
    [anon_sym_PLUS] = ACTIONS(1679),
    [anon_sym_SLASH] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(1679),
    [sym_comment] = ACTIONS(87),
  },
  [4697] = {
    [sym_heredoc_body] = STATE(7164),
    [aux_sym_call_repeat1] = STATE(7164),
    [sym__heredoc_body_start] = ACTIONS(10491),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4698] = {
    [sym_heredoc_body] = STATE(7164),
    [aux_sym_call_repeat1] = STATE(7164),
    [aux_sym_argument_list_repeat1] = STATE(7166),
    [sym__heredoc_body_start] = ACTIONS(10491),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10493),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4699] = {
    [sym_string] = STATE(2373),
    [aux_sym_chained_string_repeat1] = STATE(2373),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10495),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4700] = {
    [sym__heredoc_body_start] = ACTIONS(1699),
    [sym__binary_minus] = ACTIONS(1699),
    [sym__binary_star] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [4701] = {
    [sym__heredoc_body_start] = ACTIONS(1703),
    [sym__binary_minus] = ACTIONS(1703),
    [sym__binary_star] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1705),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4702] = {
    [sym__heredoc_body_start] = ACTIONS(1707),
    [sym__binary_minus] = ACTIONS(1707),
    [sym__binary_star] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_DOT] = ACTIONS(1709),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_EQ] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_do] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_COLON_COLON2] = ACTIONS(1707),
    [anon_sym_AMP_DOT] = ACTIONS(1707),
    [anon_sym_QMARK] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1707),
    [anon_sym_and] = ACTIONS(1707),
    [anon_sym_or] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1709),
    [anon_sym_BANG_EQ] = ACTIONS(1707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1707),
    [anon_sym_LT_EQ_GT] = ACTIONS(1707),
    [anon_sym_EQ_TILDE] = ACTIONS(1707),
    [anon_sym_BANG_TILDE] = ACTIONS(1707),
    [anon_sym_LT_EQ] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_GT_EQ] = ACTIONS(1707),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [4703] = {
    [sym__then] = STATE(7167),
    [sym_heredoc_body] = STATE(979),
    [sym__terminator] = STATE(979),
    [sym__line_break] = ACTIONS(1743),
    [sym__heredoc_body_start] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(10497),
    [sym_comment] = ACTIONS(87),
  },
  [4704] = {
    [sym__then] = STATE(7168),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(10499),
    [sym_comment] = ACTIONS(87),
  },
  [4705] = {
    [sym__do] = STATE(7169),
    [sym_heredoc_body] = STATE(7169),
    [sym__terminator] = STATE(7169),
    [sym__line_break] = ACTIONS(10501),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(10501),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(10501),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [4706] = {
    [sym__do] = STATE(7170),
    [sym_heredoc_body] = STATE(7170),
    [sym__terminator] = STATE(7170),
    [sym__line_break] = ACTIONS(10503),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(10503),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(10503),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [4707] = {
    [sym_in] = STATE(7171),
    [anon_sym_in] = ACTIONS(1969),
    [sym_comment] = ACTIONS(87),
  },
  [4708] = {
    [sym_heredoc_body] = STATE(7172),
    [sym__terminator] = STATE(7172),
    [sym__line_break] = ACTIONS(10505),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(10505),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [4709] = {
    [sym_when] = STATE(7173),
    [aux_sym_case_repeat1] = STATE(7174),
    [anon_sym_SEMI] = ACTIONS(10507),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [4710] = {
    [sym_else] = STATE(7176),
    [sym_ensure] = STATE(7177),
    [sym_rescue] = STATE(7178),
    [anon_sym_end] = ACTIONS(10509),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [4711] = {
    [sym_ensure] = STATE(7177),
    [anon_sym_end] = ACTIONS(10509),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [4712] = {
    [anon_sym_end] = ACTIONS(10509),
    [sym_comment] = ACTIONS(87),
  },
  [4713] = {
    [sym_else] = STATE(7176),
    [sym_ensure] = STATE(7177),
    [anon_sym_end] = ACTIONS(10509),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [4714] = {
    [sym__heredoc_body_start] = ACTIONS(2187),
    [sym__binary_minus] = ACTIONS(2187),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_STAR_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_EQ] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_COLON_COLON2] = ACTIONS(2187),
    [anon_sym_AMP_DOT] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_DOT_DOT] = ACTIONS(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_EQ_EQ] = ACTIONS(2189),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_EQ_TILDE] = ACTIONS(2187),
    [anon_sym_BANG_TILDE] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2189),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2187),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(87),
  },
  [4715] = {
    [sym__statements] = STATE(4710),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(4711),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(4712),
    [sym_rescue] = STATE(4713),
    [sym__body_statement] = STATE(7179),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10511),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4716] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [4717] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4718] = {
    [sym__heredoc_body_start] = ACTIONS(2267),
    [sym__binary_minus] = ACTIONS(2267),
    [sym__binary_star] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RPAREN] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2269),
    [anon_sym_COMMA] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(2269),
    [anon_sym_STAR_STAR] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_COLON_COLON2] = ACTIONS(2267),
    [anon_sym_AMP_DOT] = ACTIONS(2267),
    [anon_sym_QMARK] = ACTIONS(2267),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2267),
    [anon_sym_and] = ACTIONS(2267),
    [anon_sym_or] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2267),
    [anon_sym_AMP_AMP] = ACTIONS(2267),
    [anon_sym_LT_LT] = ACTIONS(2267),
    [anon_sym_GT_GT] = ACTIONS(2267),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2267),
    [anon_sym_LT_EQ_GT] = ACTIONS(2267),
    [anon_sym_EQ_TILDE] = ACTIONS(2267),
    [anon_sym_BANG_TILDE] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2267),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_SLASH] = ACTIONS(2267),
    [anon_sym_PERCENT] = ACTIONS(2267),
    [sym_comment] = ACTIONS(87),
  },
  [4719] = {
    [sym__heredoc_body_start] = ACTIONS(2351),
    [sym__binary_minus] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2353),
    [anon_sym_COMMA] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_STAR_STAR] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_do] = ACTIONS(2351),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_COLON_COLON2] = ACTIONS(2351),
    [anon_sym_AMP_DOT] = ACTIONS(2351),
    [anon_sym_QMARK] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2351),
    [anon_sym_or] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2351),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_CARET] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_SLASH] = ACTIONS(2351),
    [anon_sym_PERCENT] = ACTIONS(2351),
    [sym_comment] = ACTIONS(87),
  },
  [4720] = {
    [sym_heredoc_body] = STATE(7181),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(10513),
    [sym_comment] = ACTIONS(87),
  },
  [4721] = {
    [anon_sym_RBRACK] = ACTIONS(10513),
    [sym_comment] = ACTIONS(87),
  },
  [4722] = {
    [sym__statements] = STATE(7183),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(7184),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10515),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4723] = {
    [sym__statements] = STATE(7186),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(7187),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(7188),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(7188),
    [sym__line_break] = ACTIONS(10517),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10519),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4724] = {
    [sym_do_block] = STATE(7189),
    [sym_block] = STATE(7189),
    [anon_sym_LBRACE] = ACTIONS(7439),
    [anon_sym_do] = ACTIONS(10521),
    [sym_comment] = ACTIONS(87),
  },
  [4725] = {
    [sym__heredoc_body_start] = ACTIONS(2491),
    [sym__binary_minus] = ACTIONS(2491),
    [sym__binary_star] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2493),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_STAR_STAR] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_EQ] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_COLON_COLON2] = ACTIONS(2491),
    [anon_sym_AMP_DOT] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2491),
    [anon_sym_DOT_DOT] = ACTIONS(2493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2491),
    [anon_sym_and] = ACTIONS(2491),
    [anon_sym_or] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2491),
    [anon_sym_AMP_AMP] = ACTIONS(2491),
    [anon_sym_LT_LT] = ACTIONS(2491),
    [anon_sym_GT_GT] = ACTIONS(2491),
    [anon_sym_EQ_EQ] = ACTIONS(2493),
    [anon_sym_BANG_EQ] = ACTIONS(2491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ_GT] = ACTIONS(2491),
    [anon_sym_EQ_TILDE] = ACTIONS(2491),
    [anon_sym_BANG_TILDE] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_SLASH] = ACTIONS(2491),
    [anon_sym_PERCENT] = ACTIONS(2491),
    [sym_comment] = ACTIONS(87),
  },
  [4726] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7190),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7190),
    [sym_operator_assignment] = STATE(7190),
    [sym_conditional] = STATE(7190),
    [sym_range] = STATE(7190),
    [sym_binary] = STATE(7190),
    [sym_unary] = STATE(7190),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4727] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7191),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7191),
    [sym_operator_assignment] = STATE(7191),
    [sym_conditional] = STATE(7191),
    [sym_range] = STATE(7191),
    [sym_binary] = STATE(7191),
    [sym_unary] = STATE(7191),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4728] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7192),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7192),
    [sym_operator_assignment] = STATE(7192),
    [sym_conditional] = STATE(7192),
    [sym_range] = STATE(7192),
    [sym_binary] = STATE(7192),
    [sym_unary] = STATE(7192),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4729] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7193),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7193),
    [sym_operator_assignment] = STATE(7193),
    [sym_conditional] = STATE(7193),
    [sym_range] = STATE(7193),
    [sym_binary] = STATE(7193),
    [sym_unary] = STATE(7193),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4730] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7194),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7194),
    [sym_operator_assignment] = STATE(7194),
    [sym_conditional] = STATE(7194),
    [sym_range] = STATE(7194),
    [sym_binary] = STATE(7194),
    [sym_unary] = STATE(7194),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4731] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7195),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7195),
    [sym_operator_assignment] = STATE(7195),
    [sym_conditional] = STATE(7195),
    [sym_range] = STATE(7195),
    [sym_binary] = STATE(7195),
    [sym_unary] = STATE(7195),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4732] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7196),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7196),
    [sym_operator_assignment] = STATE(7196),
    [sym_conditional] = STATE(7196),
    [sym_range] = STATE(7196),
    [sym_binary] = STATE(7196),
    [sym_unary] = STATE(7196),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4733] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7197),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7197),
    [sym_operator_assignment] = STATE(7197),
    [sym_conditional] = STATE(7197),
    [sym_range] = STATE(7197),
    [sym_binary] = STATE(7197),
    [sym_unary] = STATE(7197),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4734] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7198),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7198),
    [sym_operator_assignment] = STATE(7198),
    [sym_conditional] = STATE(7198),
    [sym_range] = STATE(7198),
    [sym_binary] = STATE(7198),
    [sym_unary] = STATE(7198),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4735] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7199),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7199),
    [sym_operator_assignment] = STATE(7199),
    [sym_conditional] = STATE(7199),
    [sym_range] = STATE(7199),
    [sym_binary] = STATE(7199),
    [sym_unary] = STATE(7199),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4736] = {
    [sym__statements] = STATE(4120),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(4121),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1939),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1940),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10523),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4737] = {
    [sym_do_block] = STATE(4140),
    [sym_block] = STATE(4140),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(6709),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_RPAREN] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_if] = ACTIONS(2725),
    [anon_sym_unless] = ACTIONS(2725),
    [anon_sym_while] = ACTIONS(2725),
    [anon_sym_until] = ACTIONS(2725),
    [anon_sym_rescue] = ACTIONS(2725),
    [anon_sym_in] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_RBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_COLON2] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [4738] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7201),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_splat_argument] = STATE(7203),
    [sym_assignment] = STATE(7201),
    [sym_operator_assignment] = STATE(7201),
    [sym_conditional] = STATE(7201),
    [sym_range] = STATE(7201),
    [sym_binary] = STATE(7201),
    [sym_unary] = STATE(7201),
    [sym_right_assignment_list] = STATE(7202),
    [sym__arg_or_splat_arg] = STATE(7203),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7421),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4739] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7204),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(7204),
    [sym_operator_assignment] = STATE(7204),
    [sym_conditional] = STATE(7204),
    [sym_range] = STATE(7204),
    [sym_binary] = STATE(7204),
    [sym_unary] = STATE(7204),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [4740] = {
    [sym_string] = STATE(7205),
    [aux_sym_chained_string_repeat1] = STATE(7205),
    [sym__string_start] = ACTIONS(3870),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [4741] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(7459),
    [anon_sym_or] = ACTIONS(7459),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [4742] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4743] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4744] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(7206),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(7206),
    [sym_operator_assignment] = STATE(7206),
    [sym_conditional] = STATE(7206),
    [sym_range] = STATE(7206),
    [sym_binary] = STATE(7206),
    [sym_unary] = STATE(7206),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4745] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4746] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(7207),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(7207),
    [sym_operator_assignment] = STATE(7207),
    [sym_conditional] = STATE(7207),
    [sym_range] = STATE(7207),
    [sym_binary] = STATE(7207),
    [sym_unary] = STATE(7207),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4747] = {
    [sym_heredoc_body] = STATE(7208),
    [aux_sym_call_repeat1] = STATE(7208),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4748] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2351),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(2351),
    [sym_operator_assignment] = STATE(2351),
    [sym_conditional] = STATE(2351),
    [sym_range] = STATE(2351),
    [sym_binary] = STATE(2351),
    [sym_unary] = STATE(2351),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(7209),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3938),
    [sym__splat_star] = ACTIONS(3940),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__identifier_hash_key] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10525),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(3946),
    [sym_identifier] = ACTIONS(3946),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4749] = {
    [sym_heredoc_body] = STATE(7210),
    [aux_sym_call_repeat1] = STATE(7210),
    [aux_sym_argument_list_repeat1] = STATE(7211),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(7483),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4750] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(7459),
    [anon_sym_or] = ACTIONS(7459),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [4751] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4752] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [4753] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4754] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4755] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4756] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10527),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4757] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4758] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4759] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4760] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4761] = {
    [sym_heredoc_body] = STATE(4761),
    [aux_sym_call_repeat1] = STATE(4761),
    [sym__heredoc_body_start] = ACTIONS(10413),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7646),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_EQ] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [4762] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(830),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym__argument] = STATE(7107),
    [sym_splat_argument] = STATE(7107),
    [sym_hash_splat_argument] = STATE(7107),
    [sym_block_argument] = STATE(7107),
    [sym_assignment] = STATE(830),
    [sym_operator_assignment] = STATE(830),
    [sym_conditional] = STATE(830),
    [sym_range] = STATE(830),
    [sym_binary] = STATE(830),
    [sym_unary] = STATE(830),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(837),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(7107),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1483),
    [sym__splat_star] = ACTIONS(1485),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__identifier_hash_key] = ACTIONS(1489),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1493),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1511),
    [sym_identifier] = ACTIONS(1511),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4763] = {
    [sym_heredoc_body] = STATE(4761),
    [aux_sym_call_repeat1] = STATE(4761),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7661),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_EQ] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [4764] = {
    [aux_sym_argument_list_repeat1] = STATE(4764),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7657),
    [anon_sym_COMMA] = ACTIONS(10529),
    [anon_sym_EQ] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [4765] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4766] = {
    [aux_sym_exceptions_repeat1] = STATE(7214),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4767] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [4768] = {
    [sym_string] = STATE(4768),
    [aux_sym_chained_string_repeat1] = STATE(4768),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [4769] = {
    [sym__line_break] = ACTIONS(10532),
    [sym__heredoc_body_start] = ACTIONS(10532),
    [sym__binary_minus] = ACTIONS(10532),
    [sym__binary_star] = ACTIONS(10532),
    [ts_builtin_sym_end] = ACTIONS(10532),
    [anon_sym___END__] = ACTIONS(10532),
    [anon_sym_LBRACE] = ACTIONS(10532),
    [anon_sym_RBRACE] = ACTIONS(10532),
    [anon_sym_RPAREN] = ACTIONS(10532),
    [anon_sym_DOT] = ACTIONS(10534),
    [anon_sym_COMMA] = ACTIONS(10532),
    [anon_sym_PIPE] = ACTIONS(10534),
    [anon_sym_SEMI] = ACTIONS(10532),
    [anon_sym_STAR_STAR] = ACTIONS(10532),
    [anon_sym_AMP] = ACTIONS(10534),
    [anon_sym_LT] = ACTIONS(10534),
    [anon_sym_end] = ACTIONS(10532),
    [anon_sym_if] = ACTIONS(10532),
    [anon_sym_unless] = ACTIONS(10532),
    [anon_sym_while] = ACTIONS(10532),
    [anon_sym_until] = ACTIONS(10532),
    [anon_sym_rescue] = ACTIONS(10532),
    [anon_sym_do] = ACTIONS(10532),
    [anon_sym_when] = ACTIONS(10532),
    [anon_sym_elsif] = ACTIONS(10532),
    [anon_sym_else] = ACTIONS(10532),
    [anon_sym_then] = ACTIONS(10532),
    [anon_sym_ensure] = ACTIONS(10532),
    [anon_sym_EQ_GT] = ACTIONS(10532),
    [anon_sym_LBRACK] = ACTIONS(10532),
    [anon_sym_COLON_COLON2] = ACTIONS(10532),
    [anon_sym_AMP_DOT] = ACTIONS(10532),
    [anon_sym_QMARK] = ACTIONS(10532),
    [anon_sym_DOT_DOT] = ACTIONS(10534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10532),
    [anon_sym_and] = ACTIONS(10532),
    [anon_sym_or] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE] = ACTIONS(10532),
    [anon_sym_AMP_AMP] = ACTIONS(10532),
    [anon_sym_LT_LT] = ACTIONS(10532),
    [anon_sym_GT_GT] = ACTIONS(10532),
    [anon_sym_EQ_EQ] = ACTIONS(10534),
    [anon_sym_BANG_EQ] = ACTIONS(10532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10532),
    [anon_sym_LT_EQ_GT] = ACTIONS(10532),
    [anon_sym_EQ_TILDE] = ACTIONS(10532),
    [anon_sym_BANG_TILDE] = ACTIONS(10532),
    [anon_sym_LT_EQ] = ACTIONS(10534),
    [anon_sym_GT] = ACTIONS(10534),
    [anon_sym_GT_EQ] = ACTIONS(10532),
    [anon_sym_CARET] = ACTIONS(10532),
    [anon_sym_PLUS] = ACTIONS(10532),
    [anon_sym_SLASH] = ACTIONS(10532),
    [anon_sym_PERCENT] = ACTIONS(10532),
    [sym_comment] = ACTIONS(87),
  },
  [4770] = {
    [sym__line_break] = ACTIONS(10536),
    [sym__heredoc_body_start] = ACTIONS(10536),
    [sym__binary_minus] = ACTIONS(10536),
    [sym__binary_star] = ACTIONS(10536),
    [ts_builtin_sym_end] = ACTIONS(10536),
    [anon_sym___END__] = ACTIONS(10536),
    [anon_sym_LBRACE] = ACTIONS(10536),
    [anon_sym_RBRACE] = ACTIONS(10536),
    [anon_sym_RPAREN] = ACTIONS(10536),
    [anon_sym_DOT] = ACTIONS(10538),
    [anon_sym_COMMA] = ACTIONS(10536),
    [anon_sym_PIPE] = ACTIONS(10538),
    [anon_sym_SEMI] = ACTIONS(10536),
    [anon_sym_STAR_STAR] = ACTIONS(10536),
    [anon_sym_AMP] = ACTIONS(10538),
    [anon_sym_LT] = ACTIONS(10538),
    [anon_sym_end] = ACTIONS(10536),
    [anon_sym_if] = ACTIONS(10536),
    [anon_sym_unless] = ACTIONS(10536),
    [anon_sym_while] = ACTIONS(10536),
    [anon_sym_until] = ACTIONS(10536),
    [anon_sym_rescue] = ACTIONS(10536),
    [anon_sym_do] = ACTIONS(10536),
    [anon_sym_when] = ACTIONS(10536),
    [anon_sym_elsif] = ACTIONS(10536),
    [anon_sym_else] = ACTIONS(10536),
    [anon_sym_then] = ACTIONS(10536),
    [anon_sym_ensure] = ACTIONS(10536),
    [anon_sym_EQ_GT] = ACTIONS(10536),
    [anon_sym_LBRACK] = ACTIONS(10536),
    [anon_sym_COLON_COLON2] = ACTIONS(10536),
    [anon_sym_AMP_DOT] = ACTIONS(10536),
    [anon_sym_QMARK] = ACTIONS(10536),
    [anon_sym_DOT_DOT] = ACTIONS(10538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10536),
    [anon_sym_and] = ACTIONS(10536),
    [anon_sym_or] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE] = ACTIONS(10536),
    [anon_sym_AMP_AMP] = ACTIONS(10536),
    [anon_sym_LT_LT] = ACTIONS(10536),
    [anon_sym_GT_GT] = ACTIONS(10536),
    [anon_sym_EQ_EQ] = ACTIONS(10538),
    [anon_sym_BANG_EQ] = ACTIONS(10536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10536),
    [anon_sym_LT_EQ_GT] = ACTIONS(10536),
    [anon_sym_EQ_TILDE] = ACTIONS(10536),
    [anon_sym_BANG_TILDE] = ACTIONS(10536),
    [anon_sym_LT_EQ] = ACTIONS(10538),
    [anon_sym_GT] = ACTIONS(10538),
    [anon_sym_GT_EQ] = ACTIONS(10536),
    [anon_sym_CARET] = ACTIONS(10536),
    [anon_sym_PLUS] = ACTIONS(10536),
    [anon_sym_SLASH] = ACTIONS(10536),
    [anon_sym_PERCENT] = ACTIONS(10536),
    [sym_comment] = ACTIONS(87),
  },
  [4771] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4772] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7215),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7215),
    [sym_operator_assignment] = STATE(7215),
    [sym_conditional] = STATE(7215),
    [sym_range] = STATE(7215),
    [sym_binary] = STATE(7215),
    [sym_unary] = STATE(7215),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4773] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7216),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7216),
    [sym_operator_assignment] = STATE(7216),
    [sym_conditional] = STATE(7216),
    [sym_range] = STATE(7216),
    [sym_binary] = STATE(7216),
    [sym_unary] = STATE(7216),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4774] = {
    [anon_sym_COLON] = ACTIONS(10540),
    [sym_comment] = ACTIONS(87),
  },
  [4775] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7218),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7218),
    [sym_operator_assignment] = STATE(7218),
    [sym_conditional] = STATE(7218),
    [sym_range] = STATE(7218),
    [sym_binary] = STATE(7218),
    [sym_unary] = STATE(7218),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4776] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10542),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4777] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(10540),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4778] = {
    [sym_heredoc_body] = STATE(7220),
    [aux_sym_call_repeat1] = STATE(7220),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4779] = {
    [sym_heredoc_body] = STATE(7220),
    [aux_sym_call_repeat1] = STATE(7220),
    [aux_sym_argument_list_repeat1] = STATE(7222),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10544),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4780] = {
    [sym_string] = STATE(2423),
    [aux_sym_chained_string_repeat1] = STATE(2423),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10546),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4781] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [4782] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7223),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7223),
    [sym_operator_assignment] = STATE(7223),
    [sym_conditional] = STATE(7223),
    [sym_range] = STATE(7223),
    [sym_binary] = STATE(7223),
    [sym_unary] = STATE(7223),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4783] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7224),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7224),
    [sym_operator_assignment] = STATE(7224),
    [sym_conditional] = STATE(7224),
    [sym_range] = STATE(7224),
    [sym_binary] = STATE(7224),
    [sym_unary] = STATE(7224),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4784] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7225),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7225),
    [sym_operator_assignment] = STATE(7225),
    [sym_conditional] = STATE(7225),
    [sym_range] = STATE(7225),
    [sym_binary] = STATE(7225),
    [sym_unary] = STATE(7225),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4785] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7226),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7226),
    [sym_operator_assignment] = STATE(7226),
    [sym_conditional] = STATE(7226),
    [sym_range] = STATE(7226),
    [sym_binary] = STATE(7226),
    [sym_unary] = STATE(7226),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4786] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7227),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7227),
    [sym_operator_assignment] = STATE(7227),
    [sym_conditional] = STATE(7227),
    [sym_range] = STATE(7227),
    [sym_binary] = STATE(7227),
    [sym_unary] = STATE(7227),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4787] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7228),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7228),
    [sym_operator_assignment] = STATE(7228),
    [sym_conditional] = STATE(7228),
    [sym_range] = STATE(7228),
    [sym_binary] = STATE(7228),
    [sym_unary] = STATE(7228),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4788] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7229),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7229),
    [sym_operator_assignment] = STATE(7229),
    [sym_conditional] = STATE(7229),
    [sym_range] = STATE(7229),
    [sym_binary] = STATE(7229),
    [sym_unary] = STATE(7229),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4789] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7230),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7230),
    [sym_operator_assignment] = STATE(7230),
    [sym_conditional] = STATE(7230),
    [sym_range] = STATE(7230),
    [sym_binary] = STATE(7230),
    [sym_unary] = STATE(7230),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4790] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7231),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7231),
    [sym_operator_assignment] = STATE(7231),
    [sym_conditional] = STATE(7231),
    [sym_range] = STATE(7231),
    [sym_binary] = STATE(7231),
    [sym_unary] = STATE(7231),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4791] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7232),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7232),
    [sym_operator_assignment] = STATE(7232),
    [sym_conditional] = STATE(7232),
    [sym_range] = STATE(7232),
    [sym_binary] = STATE(7232),
    [sym_unary] = STATE(7232),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4792] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7233),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_splat_argument] = STATE(7234),
    [sym_assignment] = STATE(7233),
    [sym_operator_assignment] = STATE(7233),
    [sym_conditional] = STATE(7233),
    [sym_range] = STATE(7233),
    [sym_binary] = STATE(7233),
    [sym_unary] = STATE(7233),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(7234),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4793] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7235),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(7235),
    [sym_operator_assignment] = STATE(7235),
    [sym_conditional] = STATE(7235),
    [sym_range] = STATE(7235),
    [sym_binary] = STATE(7235),
    [sym_unary] = STATE(7235),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4794] = {
    [sym_string] = STATE(7236),
    [aux_sym_chained_string_repeat1] = STATE(7236),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [4795] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(7524),
    [anon_sym_or] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [4796] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4797] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4798] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(7237),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(7237),
    [sym_operator_assignment] = STATE(7237),
    [sym_conditional] = STATE(7237),
    [sym_range] = STATE(7237),
    [sym_binary] = STATE(7237),
    [sym_unary] = STATE(7237),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4799] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4800] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(7238),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(7238),
    [sym_operator_assignment] = STATE(7238),
    [sym_conditional] = STATE(7238),
    [sym_range] = STATE(7238),
    [sym_binary] = STATE(7238),
    [sym_unary] = STATE(7238),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4801] = {
    [sym_heredoc_body] = STATE(7239),
    [aux_sym_call_repeat1] = STATE(7239),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4802] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2402),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(2402),
    [sym_operator_assignment] = STATE(2402),
    [sym_conditional] = STATE(2402),
    [sym_range] = STATE(2402),
    [sym_binary] = STATE(2402),
    [sym_unary] = STATE(2402),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2405),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(7240),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4018),
    [sym__splat_star] = ACTIONS(4020),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10548),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(4026),
    [sym_identifier] = ACTIONS(4026),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4803] = {
    [sym_heredoc_body] = STATE(7241),
    [aux_sym_call_repeat1] = STATE(7241),
    [aux_sym_argument_list_repeat1] = STATE(7242),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(7546),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4804] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(7524),
    [anon_sym_or] = ACTIONS(7524),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [4805] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4806] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [4807] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4808] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4809] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4810] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10550),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4811] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4812] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4813] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4814] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4815] = {
    [sym_heredoc_body] = STATE(4815),
    [aux_sym_call_repeat1] = STATE(4815),
    [sym__heredoc_body_start] = ACTIONS(10413),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [4816] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym__argument] = STATE(7107),
    [sym_splat_argument] = STATE(7107),
    [sym_hash_splat_argument] = STATE(7107),
    [sym_block_argument] = STATE(7107),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(7107),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4817] = {
    [sym_heredoc_body] = STATE(4815),
    [aux_sym_call_repeat1] = STATE(4815),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [4818] = {
    [aux_sym_argument_list_repeat1] = STATE(4818),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7657),
    [anon_sym_COMMA] = ACTIONS(10552),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [4819] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4820] = {
    [aux_sym_exceptions_repeat1] = STATE(7245),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4821] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [4822] = {
    [sym_string] = STATE(4822),
    [aux_sym_chained_string_repeat1] = STATE(4822),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [4823] = {
    [sym_heredoc_body] = STATE(7246),
    [aux_sym_call_repeat1] = STATE(7246),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4824] = {
    [sym_heredoc_body] = STATE(7247),
    [aux_sym_call_repeat1] = STATE(7247),
    [aux_sym_argument_list_repeat1] = STATE(2551),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [ts_builtin_sym_end] = ACTIONS(4246),
    [anon_sym___END__] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4825] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [4826] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [4827] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [4828] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [4829] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [4830] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10555),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4831] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(5798),
    [anon_sym___END__] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [4832] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [4833] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [4834] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [4835] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(4970),
    [anon_sym___END__] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [4836] = {
    [aux_sym_exceptions_repeat1] = STATE(7250),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6060),
    [anon_sym___END__] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4837] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(6074),
    [anon_sym___END__] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [4838] = {
    [sym_string] = STATE(4838),
    [aux_sym_chained_string_repeat1] = STATE(4838),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [ts_builtin_sym_end] = ACTIONS(6076),
    [anon_sym___END__] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [4839] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(6557),
    [anon_sym___END__] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [4840] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(6759),
    [anon_sym___END__] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [4841] = {
    [sym_heredoc_body] = STATE(4841),
    [aux_sym_call_repeat1] = STATE(4841),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [ts_builtin_sym_end] = ACTIONS(7646),
    [anon_sym___END__] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [4842] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(888),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(888),
    [sym_operator_assignment] = STATE(888),
    [sym_conditional] = STATE(888),
    [sym_range] = STATE(888),
    [sym_binary] = STATE(888),
    [sym_unary] = STATE(888),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(891),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1583),
    [sym__splat_star] = ACTIONS(1585),
    [sym__unary_minus] = ACTIONS(371),
    [sym__identifier_hash_key] = ACTIONS(1587),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7556),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1589),
    [sym_identifier] = ACTIONS(1589),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4843] = {
    [sym_heredoc_body] = STATE(4841),
    [aux_sym_call_repeat1] = STATE(4841),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [ts_builtin_sym_end] = ACTIONS(7661),
    [anon_sym___END__] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [4844] = {
    [aux_sym_argument_list_repeat1] = STATE(4844),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [ts_builtin_sym_end] = ACTIONS(7657),
    [anon_sym___END__] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(10557),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [4845] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4846] = {
    [sym_heredoc_body] = STATE(7251),
    [aux_sym_call_repeat1] = STATE(7251),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4847] = {
    [sym_heredoc_body] = STATE(7251),
    [aux_sym_call_repeat1] = STATE(7251),
    [aux_sym_argument_list_repeat1] = STATE(7252),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(6948),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4848] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [4849] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7253),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(7253),
    [sym_operator_assignment] = STATE(7253),
    [sym_conditional] = STATE(7253),
    [sym_range] = STATE(7253),
    [sym_binary] = STATE(7253),
    [sym_unary] = STATE(7253),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4850] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7254),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(7254),
    [sym_operator_assignment] = STATE(7254),
    [sym_conditional] = STATE(7254),
    [sym_range] = STATE(7254),
    [sym_binary] = STATE(7254),
    [sym_unary] = STATE(7254),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4851] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7255),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(7255),
    [sym_operator_assignment] = STATE(7255),
    [sym_conditional] = STATE(7255),
    [sym_range] = STATE(7255),
    [sym_binary] = STATE(7255),
    [sym_unary] = STATE(7255),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4852] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7256),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(7256),
    [sym_operator_assignment] = STATE(7256),
    [sym_conditional] = STATE(7256),
    [sym_range] = STATE(7256),
    [sym_binary] = STATE(7256),
    [sym_unary] = STATE(7256),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4853] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7257),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(7257),
    [sym_operator_assignment] = STATE(7257),
    [sym_conditional] = STATE(7257),
    [sym_range] = STATE(7257),
    [sym_binary] = STATE(7257),
    [sym_unary] = STATE(7257),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4854] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7258),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7258),
    [sym_operator_assignment] = STATE(7258),
    [sym_conditional] = STATE(7258),
    [sym_range] = STATE(7258),
    [sym_binary] = STATE(7258),
    [sym_unary] = STATE(7258),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4855] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7259),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(7259),
    [sym_operator_assignment] = STATE(7259),
    [sym_conditional] = STATE(7259),
    [sym_range] = STATE(7259),
    [sym_binary] = STATE(7259),
    [sym_unary] = STATE(7259),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4856] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7260),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(7260),
    [sym_operator_assignment] = STATE(7260),
    [sym_conditional] = STATE(7260),
    [sym_range] = STATE(7260),
    [sym_binary] = STATE(7260),
    [sym_unary] = STATE(7260),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4857] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7261),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(7261),
    [sym_operator_assignment] = STATE(7261),
    [sym_conditional] = STATE(7261),
    [sym_range] = STATE(7261),
    [sym_binary] = STATE(7261),
    [sym_unary] = STATE(7261),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4858] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7262),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(7262),
    [sym_operator_assignment] = STATE(7262),
    [sym_conditional] = STATE(7262),
    [sym_range] = STATE(7262),
    [sym_binary] = STATE(7262),
    [sym_unary] = STATE(7262),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4859] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7264),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_splat_argument] = STATE(7265),
    [sym_assignment] = STATE(7264),
    [sym_operator_assignment] = STATE(7264),
    [sym_conditional] = STATE(7264),
    [sym_range] = STATE(7264),
    [sym_binary] = STATE(7264),
    [sym_unary] = STATE(7264),
    [sym_right_assignment_list] = STATE(3442),
    [sym__arg_or_splat_arg] = STATE(7265),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(10560),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4860] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7266),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(7266),
    [sym_operator_assignment] = STATE(7266),
    [sym_conditional] = STATE(7266),
    [sym_range] = STATE(7266),
    [sym_binary] = STATE(7266),
    [sym_unary] = STATE(7266),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4861] = {
    [sym_string] = STATE(7267),
    [aux_sym_chained_string_repeat1] = STATE(7267),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [4862] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(7574),
    [anon_sym_or] = ACTIONS(7574),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [4863] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [4864] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [4865] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(7268),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(7268),
    [sym_operator_assignment] = STATE(7268),
    [sym_conditional] = STATE(7268),
    [sym_range] = STATE(7268),
    [sym_binary] = STATE(7268),
    [sym_unary] = STATE(7268),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4866] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [4867] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(7269),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(7269),
    [sym_operator_assignment] = STATE(7269),
    [sym_conditional] = STATE(7269),
    [sym_range] = STATE(7269),
    [sym_binary] = STATE(7269),
    [sym_unary] = STATE(7269),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4868] = {
    [sym_heredoc_body] = STATE(7270),
    [aux_sym_call_repeat1] = STATE(7270),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4869] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2473),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2476),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(7271),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4152),
    [sym__splat_star] = ACTIONS(4154),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__identifier_hash_key] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10562),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(4158),
    [sym_identifier] = ACTIONS(4158),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4870] = {
    [sym_heredoc_body] = STATE(7272),
    [aux_sym_call_repeat1] = STATE(7272),
    [aux_sym_argument_list_repeat1] = STATE(7273),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(7596),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4871] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(7574),
    [anon_sym_or] = ACTIONS(7574),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [4872] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [4873] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [4874] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [4875] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [4876] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [4877] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10564),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4878] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4176),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4180),
    [anon_sym_BANG_TILDE] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [4879] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4176),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4180),
    [anon_sym_BANG_TILDE] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [4880] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4180),
    [anon_sym_BANG_TILDE] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [4881] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [4882] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [4883] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [4884] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7275),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(7275),
    [sym_operator_assignment] = STATE(7275),
    [sym_conditional] = STATE(7275),
    [sym_range] = STATE(7275),
    [sym_binary] = STATE(7275),
    [sym_unary] = STATE(7275),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4885] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [4886] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7276),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(7276),
    [sym_operator_assignment] = STATE(7276),
    [sym_conditional] = STATE(7276),
    [sym_range] = STATE(7276),
    [sym_binary] = STATE(7276),
    [sym_unary] = STATE(7276),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4887] = {
    [sym_heredoc_body] = STATE(7277),
    [aux_sym_call_repeat1] = STATE(7277),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4888] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2494),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym__argument] = STATE(4285),
    [sym_splat_argument] = STATE(4285),
    [sym_hash_splat_argument] = STATE(4285),
    [sym_block_argument] = STATE(4285),
    [sym_assignment] = STATE(2494),
    [sym_operator_assignment] = STATE(2494),
    [sym_conditional] = STATE(2494),
    [sym_range] = STATE(2494),
    [sym_binary] = STATE(2494),
    [sym_unary] = STATE(2494),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2497),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(7278),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4285),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4190),
    [sym__splat_star] = ACTIONS(4192),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__identifier_hash_key] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(4196),
    [sym_identifier] = ACTIONS(4196),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [4889] = {
    [sym_heredoc_body] = STATE(7279),
    [aux_sym_call_repeat1] = STATE(7279),
    [aux_sym_argument_list_repeat1] = STATE(7280),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(7604),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4890] = {
    [sym__line_break] = ACTIONS(10568),
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [ts_builtin_sym_end] = ACTIONS(10568),
    [anon_sym___END__] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_end] = ACTIONS(10568),
    [anon_sym_if] = ACTIONS(10568),
    [anon_sym_unless] = ACTIONS(10568),
    [anon_sym_while] = ACTIONS(10568),
    [anon_sym_until] = ACTIONS(10568),
    [anon_sym_rescue] = ACTIONS(10568),
    [anon_sym_do] = ACTIONS(10568),
    [anon_sym_when] = ACTIONS(10568),
    [anon_sym_elsif] = ACTIONS(10568),
    [anon_sym_else] = ACTIONS(10568),
    [anon_sym_then] = ACTIONS(10568),
    [anon_sym_ensure] = ACTIONS(10568),
    [anon_sym_EQ_GT] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10568),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10568),
    [anon_sym_or] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10568),
    [anon_sym_GT_GT] = ACTIONS(10568),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10568),
    [anon_sym_PLUS] = ACTIONS(10568),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [4891] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(6038),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(9151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(9151),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4892] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(7281),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(7281),
    [sym_operator_assignment] = STATE(7281),
    [sym_conditional] = STATE(7281),
    [sym_range] = STATE(7281),
    [sym_binary] = STATE(7281),
    [sym_unary] = STATE(7281),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4893] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4176),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4180),
    [anon_sym_BANG_TILDE] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [4894] = {
    [aux_sym_exceptions_repeat1] = STATE(7283),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4895] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4176),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4180),
    [anon_sym_BANG_TILDE] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [4896] = {
    [sym_string] = STATE(4896),
    [aux_sym_chained_string_repeat1] = STATE(4896),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [4897] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7284),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_assignment] = STATE(7284),
    [sym_operator_assignment] = STATE(7284),
    [sym_conditional] = STATE(7284),
    [sym_range] = STATE(7284),
    [sym_binary] = STATE(7284),
    [sym_unary] = STATE(7284),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4898] = {
    [sym__line_break] = ACTIONS(4148),
    [sym__simple_symbol] = ACTIONS(4148),
    [sym__string_start] = ACTIONS(4148),
    [sym__symbol_start] = ACTIONS(4148),
    [sym__subshell_start] = ACTIONS(4148),
    [sym__regex_start] = ACTIONS(4148),
    [sym__string_array_start] = ACTIONS(4148),
    [sym__symbol_array_start] = ACTIONS(4148),
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym_heredoc_beginning] = ACTIONS(4148),
    [sym__block_ampersand] = ACTIONS(4148),
    [sym__splat_star] = ACTIONS(4148),
    [sym__unary_minus] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [sym__identifier_hash_key] = ACTIONS(4148),
    [ts_builtin_sym_end] = ACTIONS(4148),
    [anon_sym___END__] = ACTIONS(4150),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_def] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(4150),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COLON_COLON] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_STAR_STAR] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_class] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_module] = ACTIONS(4150),
    [anon_sym_end] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_yield] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_next] = ACTIONS(4150),
    [sym_redo] = ACTIONS(4150),
    [sym_retry] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_unless] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [anon_sym_until] = ACTIONS(4150),
    [anon_sym_rescue] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_do] = ACTIONS(4150),
    [anon_sym_case] = ACTIONS(4150),
    [anon_sym_when] = ACTIONS(4150),
    [anon_sym_elsif] = ACTIONS(4150),
    [anon_sym_else] = ACTIONS(4150),
    [anon_sym_then] = ACTIONS(4150),
    [anon_sym_begin] = ACTIONS(4150),
    [anon_sym_ensure] = ACTIONS(4150),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4150),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_defined_QMARK] = ACTIONS(4148),
    [anon_sym_not] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_TILDE] = ACTIONS(4148),
    [sym_constant] = ACTIONS(4150),
    [sym_identifier] = ACTIONS(4150),
    [sym_instance_variable] = ACTIONS(4148),
    [sym_class_variable] = ACTIONS(4148),
    [sym_global_variable] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4150),
    [sym_float] = ACTIONS(4150),
    [sym_complex] = ACTIONS(4148),
    [sym_super] = ACTIONS(4150),
    [anon_sym_true] = ACTIONS(4150),
    [anon_sym_TRUE] = ACTIONS(4150),
    [anon_sym_false] = ACTIONS(4150),
    [anon_sym_FALSE] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [anon_sym_nil] = ACTIONS(4150),
    [anon_sym_NIL] = ACTIONS(4150),
    [sym_character] = ACTIONS(4148),
    [anon_sym_LBRACK2] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4148),
  },
  [4899] = {
    [sym_heredoc_body] = STATE(7286),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(10572),
    [sym_comment] = ACTIONS(87),
  },
  [4900] = {
    [anon_sym_RPAREN] = ACTIONS(10572),
    [sym_comment] = ACTIONS(87),
  },
  [4901] = {
    [sym__line_break] = ACTIONS(9425),
    [sym__simple_symbol] = ACTIONS(9425),
    [sym__string_start] = ACTIONS(9425),
    [sym__symbol_start] = ACTIONS(9425),
    [sym__subshell_start] = ACTIONS(9425),
    [sym__regex_start] = ACTIONS(9425),
    [sym__string_array_start] = ACTIONS(9425),
    [sym__symbol_array_start] = ACTIONS(9425),
    [sym__heredoc_body_start] = ACTIONS(9425),
    [sym_heredoc_beginning] = ACTIONS(9425),
    [sym__block_ampersand] = ACTIONS(9425),
    [sym__splat_star] = ACTIONS(9425),
    [sym__unary_minus] = ACTIONS(9425),
    [sym__binary_minus] = ACTIONS(9425),
    [sym__binary_star] = ACTIONS(9425),
    [sym__identifier_hash_key] = ACTIONS(9425),
    [ts_builtin_sym_end] = ACTIONS(9425),
    [anon_sym___END__] = ACTIONS(9427),
    [anon_sym_LBRACE] = ACTIONS(9425),
    [anon_sym_RBRACE] = ACTIONS(9425),
    [anon_sym_def] = ACTIONS(9427),
    [anon_sym_LPAREN] = ACTIONS(9427),
    [anon_sym_RPAREN] = ACTIONS(9425),
    [anon_sym_DOT] = ACTIONS(9427),
    [anon_sym_COLON_COLON] = ACTIONS(9427),
    [anon_sym_COMMA] = ACTIONS(9425),
    [anon_sym_PIPE] = ACTIONS(9427),
    [anon_sym_SEMI] = ACTIONS(9425),
    [anon_sym_STAR] = ACTIONS(9427),
    [anon_sym_STAR_STAR] = ACTIONS(9427),
    [anon_sym_AMP] = ACTIONS(9427),
    [anon_sym_EQ] = ACTIONS(9427),
    [anon_sym_class] = ACTIONS(9427),
    [anon_sym_LT] = ACTIONS(9427),
    [anon_sym_module] = ACTIONS(9427),
    [anon_sym_end] = ACTIONS(9427),
    [anon_sym_return] = ACTIONS(9427),
    [anon_sym_yield] = ACTIONS(9427),
    [anon_sym_break] = ACTIONS(9427),
    [anon_sym_next] = ACTIONS(9427),
    [sym_redo] = ACTIONS(9427),
    [sym_retry] = ACTIONS(9427),
    [anon_sym_if] = ACTIONS(9427),
    [anon_sym_unless] = ACTIONS(9427),
    [anon_sym_while] = ACTIONS(9427),
    [anon_sym_until] = ACTIONS(9427),
    [anon_sym_rescue] = ACTIONS(9427),
    [anon_sym_for] = ACTIONS(9427),
    [anon_sym_do] = ACTIONS(9427),
    [anon_sym_case] = ACTIONS(9427),
    [anon_sym_when] = ACTIONS(9427),
    [anon_sym_elsif] = ACTIONS(9427),
    [anon_sym_else] = ACTIONS(9427),
    [anon_sym_then] = ACTIONS(9427),
    [anon_sym_begin] = ACTIONS(9427),
    [anon_sym_ensure] = ACTIONS(9427),
    [anon_sym_EQ_GT] = ACTIONS(9425),
    [anon_sym_LBRACK] = ACTIONS(9425),
    [anon_sym_COLON_COLON2] = ACTIONS(9425),
    [anon_sym_AMP_DOT] = ACTIONS(9425),
    [anon_sym_LPAREN2] = ACTIONS(9425),
    [anon_sym_PLUS_EQ] = ACTIONS(9425),
    [anon_sym_DASH_EQ] = ACTIONS(9425),
    [anon_sym_STAR_EQ] = ACTIONS(9425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9425),
    [anon_sym_SLASH_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9425),
    [anon_sym_AMP_EQ] = ACTIONS(9425),
    [anon_sym_PERCENT_EQ] = ACTIONS(9425),
    [anon_sym_GT_GT_EQ] = ACTIONS(9425),
    [anon_sym_LT_LT_EQ] = ACTIONS(9425),
    [anon_sym_CARET_EQ] = ACTIONS(9425),
    [anon_sym_QMARK] = ACTIONS(9427),
    [anon_sym_DOT_DOT] = ACTIONS(9427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9425),
    [anon_sym_and] = ACTIONS(9427),
    [anon_sym_or] = ACTIONS(9427),
    [anon_sym_PIPE_PIPE] = ACTIONS(9427),
    [anon_sym_AMP_AMP] = ACTIONS(9427),
    [anon_sym_LT_LT] = ACTIONS(9427),
    [anon_sym_GT_GT] = ACTIONS(9427),
    [anon_sym_EQ_EQ] = ACTIONS(9427),
    [anon_sym_BANG_EQ] = ACTIONS(9425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9425),
    [anon_sym_LT_EQ_GT] = ACTIONS(9425),
    [anon_sym_EQ_TILDE] = ACTIONS(9425),
    [anon_sym_BANG_TILDE] = ACTIONS(9425),
    [anon_sym_LT_EQ] = ACTIONS(9427),
    [anon_sym_GT] = ACTIONS(9427),
    [anon_sym_GT_EQ] = ACTIONS(9425),
    [anon_sym_CARET] = ACTIONS(9427),
    [anon_sym_PLUS] = ACTIONS(9427),
    [anon_sym_SLASH] = ACTIONS(9427),
    [anon_sym_PERCENT] = ACTIONS(9427),
    [anon_sym_defined_QMARK] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [anon_sym_BANG] = ACTIONS(9427),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_constant] = ACTIONS(9427),
    [sym_identifier] = ACTIONS(9427),
    [sym_instance_variable] = ACTIONS(9425),
    [sym_class_variable] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(9425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9427),
    [sym_float] = ACTIONS(9427),
    [sym_complex] = ACTIONS(9425),
    [sym_super] = ACTIONS(9427),
    [anon_sym_true] = ACTIONS(9427),
    [anon_sym_TRUE] = ACTIONS(9427),
    [anon_sym_false] = ACTIONS(9427),
    [anon_sym_FALSE] = ACTIONS(9427),
    [sym_self] = ACTIONS(9427),
    [anon_sym_nil] = ACTIONS(9427),
    [anon_sym_NIL] = ACTIONS(9427),
    [sym_character] = ACTIONS(9425),
    [anon_sym_LBRACK2] = ACTIONS(9427),
    [anon_sym_DASH_GT] = ACTIONS(9425),
  },
  [4902] = {
    [sym__line_break] = ACTIONS(9432),
    [sym__heredoc_body_start] = ACTIONS(9432),
    [sym__binary_minus] = ACTIONS(9432),
    [sym__binary_star] = ACTIONS(9432),
    [ts_builtin_sym_end] = ACTIONS(9432),
    [anon_sym___END__] = ACTIONS(9432),
    [anon_sym_LBRACE] = ACTIONS(9432),
    [anon_sym_RBRACE] = ACTIONS(9432),
    [anon_sym_RPAREN] = ACTIONS(9432),
    [anon_sym_DOT] = ACTIONS(9434),
    [anon_sym_COMMA] = ACTIONS(9432),
    [anon_sym_PIPE] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(9432),
    [anon_sym_STAR_STAR] = ACTIONS(9434),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_EQ] = ACTIONS(9434),
    [anon_sym_LT] = ACTIONS(9434),
    [anon_sym_end] = ACTIONS(9432),
    [anon_sym_if] = ACTIONS(9432),
    [anon_sym_unless] = ACTIONS(9432),
    [anon_sym_while] = ACTIONS(9432),
    [anon_sym_until] = ACTIONS(9432),
    [anon_sym_rescue] = ACTIONS(9432),
    [anon_sym_do] = ACTIONS(9432),
    [anon_sym_when] = ACTIONS(9432),
    [anon_sym_elsif] = ACTIONS(9432),
    [anon_sym_else] = ACTIONS(9432),
    [anon_sym_then] = ACTIONS(9432),
    [anon_sym_ensure] = ACTIONS(9432),
    [anon_sym_EQ_GT] = ACTIONS(9432),
    [anon_sym_LBRACK] = ACTIONS(9432),
    [anon_sym_COLON_COLON2] = ACTIONS(9432),
    [anon_sym_AMP_DOT] = ACTIONS(9432),
    [anon_sym_PLUS_EQ] = ACTIONS(9432),
    [anon_sym_DASH_EQ] = ACTIONS(9432),
    [anon_sym_STAR_EQ] = ACTIONS(9432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9432),
    [anon_sym_SLASH_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9432),
    [anon_sym_AMP_EQ] = ACTIONS(9432),
    [anon_sym_PERCENT_EQ] = ACTIONS(9432),
    [anon_sym_GT_GT_EQ] = ACTIONS(9432),
    [anon_sym_LT_LT_EQ] = ACTIONS(9432),
    [anon_sym_CARET_EQ] = ACTIONS(9432),
    [anon_sym_QMARK] = ACTIONS(9432),
    [anon_sym_DOT_DOT] = ACTIONS(9434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9432),
    [anon_sym_and] = ACTIONS(9432),
    [anon_sym_or] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE] = ACTIONS(9434),
    [anon_sym_AMP_AMP] = ACTIONS(9434),
    [anon_sym_LT_LT] = ACTIONS(9434),
    [anon_sym_GT_GT] = ACTIONS(9434),
    [anon_sym_EQ_EQ] = ACTIONS(9434),
    [anon_sym_BANG_EQ] = ACTIONS(9432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9432),
    [anon_sym_LT_EQ_GT] = ACTIONS(9432),
    [anon_sym_EQ_TILDE] = ACTIONS(9432),
    [anon_sym_BANG_TILDE] = ACTIONS(9432),
    [anon_sym_LT_EQ] = ACTIONS(9434),
    [anon_sym_GT] = ACTIONS(9434),
    [anon_sym_GT_EQ] = ACTIONS(9432),
    [anon_sym_CARET] = ACTIONS(9434),
    [anon_sym_PLUS] = ACTIONS(9434),
    [anon_sym_SLASH] = ACTIONS(9434),
    [anon_sym_PERCENT] = ACTIONS(9434),
    [sym_comment] = ACTIONS(87),
  },
  [4903] = {
    [anon_sym_RBRACK] = ACTIONS(10574),
    [sym_comment] = ACTIONS(87),
  },
  [4904] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(6557),
    [anon_sym___END__] = ACTIONS(6557),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [4905] = {
    [sym__line_break] = ACTIONS(9172),
    [sym__heredoc_body_start] = ACTIONS(9172),
    [sym__binary_minus] = ACTIONS(9172),
    [sym__binary_star] = ACTIONS(9172),
    [ts_builtin_sym_end] = ACTIONS(9172),
    [anon_sym___END__] = ACTIONS(9172),
    [anon_sym_LBRACE] = ACTIONS(9172),
    [anon_sym_RBRACE] = ACTIONS(9172),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9174),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9174),
    [anon_sym_SEMI] = ACTIONS(9172),
    [anon_sym_STAR_STAR] = ACTIONS(9174),
    [anon_sym_AMP] = ACTIONS(9174),
    [anon_sym_EQ] = ACTIONS(9174),
    [anon_sym_LT] = ACTIONS(9174),
    [anon_sym_end] = ACTIONS(9172),
    [anon_sym_if] = ACTIONS(9172),
    [anon_sym_unless] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(9172),
    [anon_sym_until] = ACTIONS(9172),
    [anon_sym_rescue] = ACTIONS(9172),
    [anon_sym_do] = ACTIONS(9172),
    [anon_sym_when] = ACTIONS(9172),
    [anon_sym_elsif] = ACTIONS(9172),
    [anon_sym_else] = ACTIONS(9172),
    [anon_sym_then] = ACTIONS(9172),
    [anon_sym_ensure] = ACTIONS(9172),
    [anon_sym_EQ_GT] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [anon_sym_PLUS_EQ] = ACTIONS(9172),
    [anon_sym_DASH_EQ] = ACTIONS(9172),
    [anon_sym_STAR_EQ] = ACTIONS(9172),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9172),
    [anon_sym_SLASH_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9172),
    [anon_sym_AMP_EQ] = ACTIONS(9172),
    [anon_sym_PERCENT_EQ] = ACTIONS(9172),
    [anon_sym_GT_GT_EQ] = ACTIONS(9172),
    [anon_sym_LT_LT_EQ] = ACTIONS(9172),
    [anon_sym_CARET_EQ] = ACTIONS(9172),
    [anon_sym_QMARK] = ACTIONS(9172),
    [anon_sym_DOT_DOT] = ACTIONS(9174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9172),
    [anon_sym_and] = ACTIONS(9172),
    [anon_sym_or] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE] = ACTIONS(9174),
    [anon_sym_AMP_AMP] = ACTIONS(9174),
    [anon_sym_LT_LT] = ACTIONS(9174),
    [anon_sym_GT_GT] = ACTIONS(9174),
    [anon_sym_EQ_EQ] = ACTIONS(9174),
    [anon_sym_BANG_EQ] = ACTIONS(9172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9172),
    [anon_sym_LT_EQ_GT] = ACTIONS(9172),
    [anon_sym_EQ_TILDE] = ACTIONS(9172),
    [anon_sym_BANG_TILDE] = ACTIONS(9172),
    [anon_sym_LT_EQ] = ACTIONS(9174),
    [anon_sym_GT] = ACTIONS(9174),
    [anon_sym_GT_EQ] = ACTIONS(9172),
    [anon_sym_CARET] = ACTIONS(9174),
    [anon_sym_PLUS] = ACTIONS(9174),
    [anon_sym_SLASH] = ACTIONS(9174),
    [anon_sym_PERCENT] = ACTIONS(9174),
    [sym_comment] = ACTIONS(87),
  },
  [4906] = {
    [anon_sym_RBRACE] = ACTIONS(10576),
    [sym_comment] = ACTIONS(87),
  },
  [4907] = {
    [sym__line_break] = ACTIONS(9192),
    [sym__heredoc_body_start] = ACTIONS(9192),
    [sym__binary_minus] = ACTIONS(9192),
    [sym__binary_star] = ACTIONS(9192),
    [ts_builtin_sym_end] = ACTIONS(9192),
    [anon_sym___END__] = ACTIONS(9192),
    [anon_sym_LBRACE] = ACTIONS(9192),
    [anon_sym_RBRACE] = ACTIONS(9192),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9194),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9194),
    [anon_sym_SEMI] = ACTIONS(9192),
    [anon_sym_STAR_STAR] = ACTIONS(9194),
    [anon_sym_AMP] = ACTIONS(9194),
    [anon_sym_EQ] = ACTIONS(9194),
    [anon_sym_LT] = ACTIONS(9194),
    [anon_sym_end] = ACTIONS(9192),
    [anon_sym_if] = ACTIONS(9192),
    [anon_sym_unless] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(9192),
    [anon_sym_until] = ACTIONS(9192),
    [anon_sym_rescue] = ACTIONS(9192),
    [anon_sym_do] = ACTIONS(9192),
    [anon_sym_when] = ACTIONS(9192),
    [anon_sym_elsif] = ACTIONS(9192),
    [anon_sym_else] = ACTIONS(9192),
    [anon_sym_then] = ACTIONS(9192),
    [anon_sym_ensure] = ACTIONS(9192),
    [anon_sym_EQ_GT] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [anon_sym_PLUS_EQ] = ACTIONS(9192),
    [anon_sym_DASH_EQ] = ACTIONS(9192),
    [anon_sym_STAR_EQ] = ACTIONS(9192),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9192),
    [anon_sym_SLASH_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9192),
    [anon_sym_AMP_EQ] = ACTIONS(9192),
    [anon_sym_PERCENT_EQ] = ACTIONS(9192),
    [anon_sym_GT_GT_EQ] = ACTIONS(9192),
    [anon_sym_LT_LT_EQ] = ACTIONS(9192),
    [anon_sym_CARET_EQ] = ACTIONS(9192),
    [anon_sym_QMARK] = ACTIONS(9192),
    [anon_sym_DOT_DOT] = ACTIONS(9194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9192),
    [anon_sym_and] = ACTIONS(9192),
    [anon_sym_or] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE] = ACTIONS(9194),
    [anon_sym_AMP_AMP] = ACTIONS(9194),
    [anon_sym_LT_LT] = ACTIONS(9194),
    [anon_sym_GT_GT] = ACTIONS(9194),
    [anon_sym_EQ_EQ] = ACTIONS(9194),
    [anon_sym_BANG_EQ] = ACTIONS(9192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9192),
    [anon_sym_LT_EQ_GT] = ACTIONS(9192),
    [anon_sym_EQ_TILDE] = ACTIONS(9192),
    [anon_sym_BANG_TILDE] = ACTIONS(9192),
    [anon_sym_LT_EQ] = ACTIONS(9194),
    [anon_sym_GT] = ACTIONS(9194),
    [anon_sym_GT_EQ] = ACTIONS(9192),
    [anon_sym_CARET] = ACTIONS(9194),
    [anon_sym_PLUS] = ACTIONS(9194),
    [anon_sym_SLASH] = ACTIONS(9194),
    [anon_sym_PERCENT] = ACTIONS(9194),
    [sym_comment] = ACTIONS(87),
  },
  [4908] = {
    [anon_sym_end] = ACTIONS(10578),
    [sym_comment] = ACTIONS(87),
  },
  [4909] = {
    [sym__statements] = STATE(7290),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10580),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4910] = {
    [sym__statements] = STATE(7290),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(7291),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(7291),
    [sym__line_break] = ACTIONS(10582),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10580),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4911] = {
    [sym__line_break] = ACTIONS(7608),
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [ts_builtin_sym_end] = ACTIONS(7608),
    [anon_sym___END__] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR_STAR] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_end] = ACTIONS(7608),
    [anon_sym_if] = ACTIONS(7608),
    [anon_sym_unless] = ACTIONS(7608),
    [anon_sym_while] = ACTIONS(7608),
    [anon_sym_until] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7608),
    [anon_sym_do] = ACTIONS(7608),
    [anon_sym_when] = ACTIONS(7608),
    [anon_sym_elsif] = ACTIONS(7608),
    [anon_sym_else] = ACTIONS(7608),
    [anon_sym_then] = ACTIONS(7608),
    [anon_sym_ensure] = ACTIONS(7608),
    [anon_sym_EQ_GT] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_PLUS_EQ] = ACTIONS(7608),
    [anon_sym_DASH_EQ] = ACTIONS(7608),
    [anon_sym_STAR_EQ] = ACTIONS(7608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7608),
    [anon_sym_SLASH_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7608),
    [anon_sym_AMP_EQ] = ACTIONS(7608),
    [anon_sym_PERCENT_EQ] = ACTIONS(7608),
    [anon_sym_GT_GT_EQ] = ACTIONS(7608),
    [anon_sym_LT_LT_EQ] = ACTIONS(7608),
    [anon_sym_CARET_EQ] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7608),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7608),
    [anon_sym_or] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE] = ACTIONS(7610),
    [anon_sym_AMP_AMP] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [sym_comment] = ACTIONS(87),
  },
  [4912] = {
    [anon_sym_RPAREN] = ACTIONS(10584),
    [sym_comment] = ACTIONS(87),
  },
  [4913] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(6759),
    [anon_sym___END__] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [4914] = {
    [sym__line_break] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__binary_star] = ACTIONS(3102),
    [ts_builtin_sym_end] = ACTIONS(3102),
    [anon_sym___END__] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(4854),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(4854),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_STAR_STAR] = ACTIONS(4854),
    [anon_sym_AMP] = ACTIONS(4854),
    [anon_sym_EQ] = ACTIONS(4854),
    [anon_sym_LT] = ACTIONS(4854),
    [anon_sym_end] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_unless] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_until] = ACTIONS(3102),
    [anon_sym_rescue] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_when] = ACTIONS(3102),
    [anon_sym_elsif] = ACTIONS(3102),
    [anon_sym_else] = ACTIONS(3102),
    [anon_sym_then] = ACTIONS(3102),
    [anon_sym_ensure] = ACTIONS(3102),
    [anon_sym_EQ_GT] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_COLON_COLON2] = ACTIONS(3102),
    [anon_sym_AMP_DOT] = ACTIONS(3102),
    [anon_sym_PLUS_EQ] = ACTIONS(3102),
    [anon_sym_DASH_EQ] = ACTIONS(3102),
    [anon_sym_STAR_EQ] = ACTIONS(3102),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3102),
    [anon_sym_SLASH_EQ] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3102),
    [anon_sym_PIPE_EQ] = ACTIONS(3102),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3102),
    [anon_sym_AMP_EQ] = ACTIONS(3102),
    [anon_sym_PERCENT_EQ] = ACTIONS(3102),
    [anon_sym_GT_GT_EQ] = ACTIONS(3102),
    [anon_sym_LT_LT_EQ] = ACTIONS(3102),
    [anon_sym_CARET_EQ] = ACTIONS(3102),
    [anon_sym_QMARK] = ACTIONS(3102),
    [anon_sym_DOT_DOT] = ACTIONS(4854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_and] = ACTIONS(3102),
    [anon_sym_or] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(4854),
    [anon_sym_AMP_AMP] = ACTIONS(4854),
    [anon_sym_LT_LT] = ACTIONS(4854),
    [anon_sym_GT_GT] = ACTIONS(4854),
    [anon_sym_EQ_EQ] = ACTIONS(4854),
    [anon_sym_BANG_EQ] = ACTIONS(3102),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
    [anon_sym_LT_EQ_GT] = ACTIONS(3102),
    [anon_sym_EQ_TILDE] = ACTIONS(3102),
    [anon_sym_BANG_TILDE] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(4854),
    [anon_sym_GT] = ACTIONS(4854),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(4854),
    [anon_sym_PLUS] = ACTIONS(4854),
    [anon_sym_SLASH] = ACTIONS(4854),
    [anon_sym_PERCENT] = ACTIONS(4854),
    [sym_comment] = ACTIONS(87),
  },
  [4915] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(10586),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [4916] = {
    [sym_heredoc_body] = STATE(4916),
    [aux_sym_call_repeat1] = STATE(4916),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [ts_builtin_sym_end] = ACTIONS(7646),
    [anon_sym___END__] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [4917] = {
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [ts_builtin_sym_end] = ACTIONS(7657),
    [anon_sym___END__] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(7657),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_when] = ACTIONS(7657),
    [anon_sym_elsif] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [4918] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(937),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(937),
    [sym_operator_assignment] = STATE(937),
    [sym_conditional] = STATE(937),
    [sym_range] = STATE(937),
    [sym_binary] = STATE(937),
    [sym_unary] = STATE(937),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(942),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1665),
    [sym__splat_star] = ACTIONS(1667),
    [sym__unary_minus] = ACTIONS(767),
    [sym__identifier_hash_key] = ACTIONS(1669),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7642),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(1677),
    [sym_identifier] = ACTIONS(1677),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4919] = {
    [sym_heredoc_body] = STATE(4916),
    [aux_sym_call_repeat1] = STATE(4916),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [ts_builtin_sym_end] = ACTIONS(7661),
    [anon_sym___END__] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [4920] = {
    [aux_sym_argument_list_repeat1] = STATE(4920),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [ts_builtin_sym_end] = ACTIONS(7657),
    [anon_sym___END__] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(10591),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [4921] = {
    [sym__line_break] = ACTIONS(6547),
    [sym__heredoc_body_start] = ACTIONS(6547),
    [sym__binary_minus] = ACTIONS(6547),
    [sym__binary_star] = ACTIONS(6547),
    [ts_builtin_sym_end] = ACTIONS(6547),
    [anon_sym___END__] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_DOT] = ACTIONS(8423),
    [anon_sym_COMMA] = ACTIONS(6547),
    [anon_sym_PIPE] = ACTIONS(8423),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym_STAR_STAR] = ACTIONS(6547),
    [anon_sym_AMP] = ACTIONS(8423),
    [anon_sym_LT] = ACTIONS(8423),
    [anon_sym_end] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(6547),
    [anon_sym_unless] = ACTIONS(6547),
    [anon_sym_while] = ACTIONS(6547),
    [anon_sym_until] = ACTIONS(6547),
    [anon_sym_rescue] = ACTIONS(6547),
    [anon_sym_do] = ACTIONS(6547),
    [anon_sym_when] = ACTIONS(6547),
    [anon_sym_elsif] = ACTIONS(6547),
    [anon_sym_else] = ACTIONS(6547),
    [anon_sym_then] = ACTIONS(6547),
    [anon_sym_ensure] = ACTIONS(6547),
    [anon_sym_EQ_GT] = ACTIONS(6547),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_COLON_COLON2] = ACTIONS(6547),
    [anon_sym_AMP_DOT] = ACTIONS(6547),
    [anon_sym_QMARK] = ACTIONS(6547),
    [anon_sym_DOT_DOT] = ACTIONS(8423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6547),
    [anon_sym_and] = ACTIONS(6547),
    [anon_sym_or] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE] = ACTIONS(6547),
    [anon_sym_AMP_AMP] = ACTIONS(6547),
    [anon_sym_LT_LT] = ACTIONS(6547),
    [anon_sym_GT_GT] = ACTIONS(6547),
    [anon_sym_EQ_EQ] = ACTIONS(8423),
    [anon_sym_BANG_EQ] = ACTIONS(6547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6547),
    [anon_sym_LT_EQ_GT] = ACTIONS(6547),
    [anon_sym_EQ_TILDE] = ACTIONS(6547),
    [anon_sym_BANG_TILDE] = ACTIONS(6547),
    [anon_sym_LT_EQ] = ACTIONS(8423),
    [anon_sym_GT] = ACTIONS(8423),
    [anon_sym_GT_EQ] = ACTIONS(6547),
    [anon_sym_CARET] = ACTIONS(6547),
    [anon_sym_PLUS] = ACTIONS(6547),
    [anon_sym_SLASH] = ACTIONS(6547),
    [anon_sym_PERCENT] = ACTIONS(6547),
    [sym_comment] = ACTIONS(87),
  },
  [4922] = {
    [sym__simple_symbol] = ACTIONS(3102),
    [sym__string_start] = ACTIONS(3102),
    [sym__symbol_start] = ACTIONS(3102),
    [sym__subshell_start] = ACTIONS(3102),
    [sym__regex_start] = ACTIONS(3102),
    [sym__string_array_start] = ACTIONS(3102),
    [sym__symbol_array_start] = ACTIONS(3102),
    [sym_heredoc_beginning] = ACTIONS(3102),
    [sym__block_ampersand] = ACTIONS(3102),
    [sym__splat_star] = ACTIONS(3102),
    [sym__unary_minus] = ACTIONS(3102),
    [sym__identifier_hash_key] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_def] = ACTIONS(4854),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(4854),
    [anon_sym_STAR_STAR] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(4854),
    [anon_sym_module] = ACTIONS(4854),
    [anon_sym_return] = ACTIONS(4854),
    [anon_sym_yield] = ACTIONS(4854),
    [anon_sym_break] = ACTIONS(4854),
    [anon_sym_next] = ACTIONS(4854),
    [sym_redo] = ACTIONS(4854),
    [sym_retry] = ACTIONS(4854),
    [anon_sym_if] = ACTIONS(4854),
    [anon_sym_unless] = ACTIONS(4854),
    [anon_sym_while] = ACTIONS(4854),
    [anon_sym_until] = ACTIONS(4854),
    [anon_sym_for] = ACTIONS(4854),
    [anon_sym_case] = ACTIONS(4854),
    [anon_sym_begin] = ACTIONS(4854),
    [anon_sym_PLUS] = ACTIONS(4854),
    [anon_sym_defined_QMARK] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(4854),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [sym_constant] = ACTIONS(4854),
    [sym_identifier] = ACTIONS(4854),
    [sym_instance_variable] = ACTIONS(3102),
    [sym_class_variable] = ACTIONS(3102),
    [sym_global_variable] = ACTIONS(3102),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4854),
    [sym_float] = ACTIONS(4854),
    [sym_complex] = ACTIONS(3102),
    [sym_super] = ACTIONS(4854),
    [anon_sym_true] = ACTIONS(4854),
    [anon_sym_TRUE] = ACTIONS(4854),
    [anon_sym_false] = ACTIONS(4854),
    [anon_sym_FALSE] = ACTIONS(4854),
    [sym_self] = ACTIONS(4854),
    [anon_sym_nil] = ACTIONS(4854),
    [anon_sym_NIL] = ACTIONS(4854),
    [sym_character] = ACTIONS(3102),
    [anon_sym_LBRACK2] = ACTIONS(3102),
    [anon_sym_DASH_GT] = ACTIONS(3102),
  },
  [4923] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(10594),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [4924] = {
    [sym__line_break] = ACTIONS(10596),
    [sym__heredoc_body_start] = ACTIONS(10596),
    [sym__binary_minus] = ACTIONS(10596),
    [sym__binary_star] = ACTIONS(10596),
    [ts_builtin_sym_end] = ACTIONS(10596),
    [anon_sym___END__] = ACTIONS(10596),
    [anon_sym_LBRACE] = ACTIONS(10596),
    [anon_sym_RBRACE] = ACTIONS(10596),
    [anon_sym_RPAREN] = ACTIONS(10596),
    [anon_sym_DOT] = ACTIONS(10598),
    [anon_sym_COMMA] = ACTIONS(10596),
    [anon_sym_PIPE] = ACTIONS(10598),
    [anon_sym_SEMI] = ACTIONS(10596),
    [anon_sym_STAR_STAR] = ACTIONS(10596),
    [anon_sym_AMP] = ACTIONS(10598),
    [anon_sym_LT] = ACTIONS(10598),
    [anon_sym_end] = ACTIONS(10596),
    [anon_sym_if] = ACTIONS(10596),
    [anon_sym_unless] = ACTIONS(10596),
    [anon_sym_while] = ACTIONS(10596),
    [anon_sym_until] = ACTIONS(10596),
    [anon_sym_rescue] = ACTIONS(10596),
    [anon_sym_do] = ACTIONS(10596),
    [anon_sym_when] = ACTIONS(10596),
    [anon_sym_elsif] = ACTIONS(10596),
    [anon_sym_else] = ACTIONS(10596),
    [anon_sym_then] = ACTIONS(10596),
    [anon_sym_ensure] = ACTIONS(10596),
    [anon_sym_EQ_GT] = ACTIONS(10596),
    [anon_sym_LBRACK] = ACTIONS(10596),
    [anon_sym_COLON_COLON2] = ACTIONS(10596),
    [anon_sym_AMP_DOT] = ACTIONS(10596),
    [anon_sym_QMARK] = ACTIONS(10596),
    [anon_sym_DOT_DOT] = ACTIONS(10598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10596),
    [anon_sym_and] = ACTIONS(10596),
    [anon_sym_or] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE] = ACTIONS(10596),
    [anon_sym_AMP_AMP] = ACTIONS(10596),
    [anon_sym_LT_LT] = ACTIONS(10596),
    [anon_sym_GT_GT] = ACTIONS(10596),
    [anon_sym_EQ_EQ] = ACTIONS(10598),
    [anon_sym_BANG_EQ] = ACTIONS(10596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10596),
    [anon_sym_LT_EQ_GT] = ACTIONS(10596),
    [anon_sym_EQ_TILDE] = ACTIONS(10596),
    [anon_sym_BANG_TILDE] = ACTIONS(10596),
    [anon_sym_LT_EQ] = ACTIONS(10598),
    [anon_sym_GT] = ACTIONS(10598),
    [anon_sym_GT_EQ] = ACTIONS(10596),
    [anon_sym_CARET] = ACTIONS(10596),
    [anon_sym_PLUS] = ACTIONS(10596),
    [anon_sym_SLASH] = ACTIONS(10596),
    [anon_sym_PERCENT] = ACTIONS(10596),
    [sym_comment] = ACTIONS(87),
  },
  [4925] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2552),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(220),
    [sym_scope_resolution] = STATE(215),
    [sym_call] = STATE(215),
    [sym_method_call] = STATE(220),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(2552),
    [sym_operator_assignment] = STATE(2552),
    [sym_conditional] = STATE(2552),
    [sym_range] = STATE(2552),
    [sym_binary] = STATE(2552),
    [sym_unary] = STATE(2552),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(219),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(220),
    [sym__variable] = STATE(215),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(220),
    [sym_false] = STATE(220),
    [sym_nil] = STATE(220),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(879),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(1585),
    [sym__unary_minus] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4926] = {
    [aux_sym_exceptions_repeat1] = STATE(7297),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [ts_builtin_sym_end] = ACTIONS(9603),
    [anon_sym___END__] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(10600),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [4927] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4928] = {
    [sym_heredoc_body] = STATE(7298),
    [aux_sym_call_repeat1] = STATE(7298),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4929] = {
    [sym_heredoc_body] = STATE(7298),
    [aux_sym_call_repeat1] = STATE(7298),
    [aux_sym_argument_list_repeat1] = STATE(7299),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4320),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4930] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7682),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [4931] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7300),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(7300),
    [sym_operator_assignment] = STATE(7300),
    [sym_conditional] = STATE(7300),
    [sym_range] = STATE(7300),
    [sym_binary] = STATE(7300),
    [sym_unary] = STATE(7300),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4932] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7301),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(7301),
    [sym_operator_assignment] = STATE(7301),
    [sym_conditional] = STATE(7301),
    [sym_range] = STATE(7301),
    [sym_binary] = STATE(7301),
    [sym_unary] = STATE(7301),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4933] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7302),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(7302),
    [sym_operator_assignment] = STATE(7302),
    [sym_conditional] = STATE(7302),
    [sym_range] = STATE(7302),
    [sym_binary] = STATE(7302),
    [sym_unary] = STATE(7302),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4934] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7303),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(7303),
    [sym_operator_assignment] = STATE(7303),
    [sym_conditional] = STATE(7303),
    [sym_range] = STATE(7303),
    [sym_binary] = STATE(7303),
    [sym_unary] = STATE(7303),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4935] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7304),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(7304),
    [sym_operator_assignment] = STATE(7304),
    [sym_conditional] = STATE(7304),
    [sym_range] = STATE(7304),
    [sym_binary] = STATE(7304),
    [sym_unary] = STATE(7304),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4936] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7305),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7305),
    [sym_operator_assignment] = STATE(7305),
    [sym_conditional] = STATE(7305),
    [sym_range] = STATE(7305),
    [sym_binary] = STATE(7305),
    [sym_unary] = STATE(7305),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4937] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7306),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(7306),
    [sym_operator_assignment] = STATE(7306),
    [sym_conditional] = STATE(7306),
    [sym_range] = STATE(7306),
    [sym_binary] = STATE(7306),
    [sym_unary] = STATE(7306),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4938] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7307),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(7307),
    [sym_operator_assignment] = STATE(7307),
    [sym_conditional] = STATE(7307),
    [sym_range] = STATE(7307),
    [sym_binary] = STATE(7307),
    [sym_unary] = STATE(7307),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4939] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7308),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(7308),
    [sym_operator_assignment] = STATE(7308),
    [sym_conditional] = STATE(7308),
    [sym_range] = STATE(7308),
    [sym_binary] = STATE(7308),
    [sym_unary] = STATE(7308),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4940] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7309),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(7309),
    [sym_operator_assignment] = STATE(7309),
    [sym_conditional] = STATE(7309),
    [sym_range] = STATE(7309),
    [sym_binary] = STATE(7309),
    [sym_unary] = STATE(7309),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4941] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7310),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_splat_argument] = STATE(7311),
    [sym_assignment] = STATE(7310),
    [sym_operator_assignment] = STATE(7310),
    [sym_conditional] = STATE(7310),
    [sym_range] = STATE(7310),
    [sym_binary] = STATE(7310),
    [sym_unary] = STATE(7310),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(7311),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4942] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7312),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(7312),
    [sym_operator_assignment] = STATE(7312),
    [sym_conditional] = STATE(7312),
    [sym_range] = STATE(7312),
    [sym_binary] = STATE(7312),
    [sym_unary] = STATE(7312),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4943] = {
    [sym_string] = STATE(7313),
    [aux_sym_chained_string_repeat1] = STATE(7313),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [4944] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7682),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [4945] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4946] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4947] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7314),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(7314),
    [sym_operator_assignment] = STATE(7314),
    [sym_conditional] = STATE(7314),
    [sym_range] = STATE(7314),
    [sym_binary] = STATE(7314),
    [sym_unary] = STATE(7314),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4948] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4949] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7315),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(7315),
    [sym_operator_assignment] = STATE(7315),
    [sym_conditional] = STATE(7315),
    [sym_range] = STATE(7315),
    [sym_binary] = STATE(7315),
    [sym_unary] = STATE(7315),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4950] = {
    [sym_heredoc_body] = STATE(7316),
    [aux_sym_call_repeat1] = STATE(7316),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4951] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2578),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(2578),
    [sym_operator_assignment] = STATE(2578),
    [sym_conditional] = STATE(2578),
    [sym_range] = STATE(2578),
    [sym_binary] = STATE(2578),
    [sym_unary] = STATE(2578),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2581),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7317),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4276),
    [sym__splat_star] = ACTIONS(4278),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__identifier_hash_key] = ACTIONS(4280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10602),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(4282),
    [sym_identifier] = ACTIONS(4282),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4952] = {
    [sym_heredoc_body] = STATE(7318),
    [aux_sym_call_repeat1] = STATE(7318),
    [aux_sym_argument_list_repeat1] = STATE(7319),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(7708),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [4953] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7682),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [4954] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4955] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [4956] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4957] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4958] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4959] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10604),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [4960] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4961] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4962] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4963] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4964] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [4965] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [4966] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7321),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(7321),
    [sym_operator_assignment] = STATE(7321),
    [sym_conditional] = STATE(7321),
    [sym_range] = STATE(7321),
    [sym_binary] = STATE(7321),
    [sym_unary] = STATE(7321),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4967] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [4968] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7322),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(7322),
    [sym_operator_assignment] = STATE(7322),
    [sym_conditional] = STATE(7322),
    [sym_range] = STATE(7322),
    [sym_binary] = STATE(7322),
    [sym_unary] = STATE(7322),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4969] = {
    [sym_heredoc_body] = STATE(7323),
    [aux_sym_call_repeat1] = STATE(7323),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4970] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2599),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(2599),
    [sym_operator_assignment] = STATE(2599),
    [sym_conditional] = STATE(2599),
    [sym_range] = STATE(2599),
    [sym_binary] = STATE(2599),
    [sym_unary] = STATE(2599),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2602),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(7324),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4312),
    [sym__splat_star] = ACTIONS(4314),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__identifier_hash_key] = ACTIONS(4316),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10606),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(4318),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4971] = {
    [sym_heredoc_body] = STATE(7325),
    [aux_sym_call_repeat1] = STATE(7325),
    [aux_sym_argument_list_repeat1] = STATE(7326),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(7716),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [4972] = {
    [sym_heredoc_body] = STATE(4972),
    [aux_sym_call_repeat1] = STATE(4972),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [4973] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(963),
    [sym_operator_assignment] = STATE(963),
    [sym_conditional] = STATE(963),
    [sym_range] = STATE(963),
    [sym_binary] = STATE(963),
    [sym_unary] = STATE(963),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(969),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1711),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__identifier_hash_key] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7720),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1735),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4974] = {
    [sym_heredoc_body] = STATE(4972),
    [aux_sym_call_repeat1] = STATE(4972),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [4975] = {
    [aux_sym_argument_list_repeat1] = STATE(4975),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(10608),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [4976] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4977] = {
    [aux_sym_exceptions_repeat1] = STATE(7328),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [4978] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [4979] = {
    [sym_string] = STATE(4979),
    [aux_sym_chained_string_repeat1] = STATE(4979),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [4980] = {
    [aux_sym_undef_repeat1] = STATE(4980),
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9006),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [anon_sym_then] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [4981] = {
    [sym__line_break] = ACTIONS(6547),
    [sym__simple_symbol] = ACTIONS(6547),
    [sym__string_start] = ACTIONS(6547),
    [sym__symbol_start] = ACTIONS(6547),
    [sym__subshell_start] = ACTIONS(6547),
    [sym__regex_start] = ACTIONS(6547),
    [sym__string_array_start] = ACTIONS(6547),
    [sym__symbol_array_start] = ACTIONS(6547),
    [sym__heredoc_body_start] = ACTIONS(6547),
    [sym_heredoc_beginning] = ACTIONS(6547),
    [sym__unary_minus] = ACTIONS(6547),
    [anon_sym_BEGIN] = ACTIONS(8423),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_END] = ACTIONS(8423),
    [anon_sym_def] = ACTIONS(8423),
    [anon_sym_LPAREN] = ACTIONS(6547),
    [anon_sym_COLON_COLON] = ACTIONS(6547),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym_STAR] = ACTIONS(6547),
    [anon_sym_class] = ACTIONS(8423),
    [anon_sym_module] = ACTIONS(8423),
    [anon_sym_end] = ACTIONS(8423),
    [anon_sym_return] = ACTIONS(8423),
    [anon_sym_yield] = ACTIONS(8423),
    [anon_sym_break] = ACTIONS(8423),
    [anon_sym_next] = ACTIONS(8423),
    [sym_redo] = ACTIONS(8423),
    [sym_retry] = ACTIONS(8423),
    [anon_sym_if] = ACTIONS(8423),
    [anon_sym_unless] = ACTIONS(8423),
    [anon_sym_while] = ACTIONS(8423),
    [anon_sym_until] = ACTIONS(8423),
    [anon_sym_for] = ACTIONS(8423),
    [anon_sym_case] = ACTIONS(8423),
    [anon_sym_elsif] = ACTIONS(8423),
    [anon_sym_else] = ACTIONS(8423),
    [anon_sym_then] = ACTIONS(8423),
    [anon_sym_begin] = ACTIONS(8423),
    [anon_sym_PLUS] = ACTIONS(8423),
    [anon_sym_defined_QMARK] = ACTIONS(6547),
    [anon_sym_not] = ACTIONS(8423),
    [anon_sym_BANG] = ACTIONS(6547),
    [anon_sym_TILDE] = ACTIONS(6547),
    [sym_constant] = ACTIONS(8423),
    [sym_identifier] = ACTIONS(8423),
    [sym_instance_variable] = ACTIONS(6547),
    [sym_class_variable] = ACTIONS(6547),
    [sym_global_variable] = ACTIONS(6547),
    [anon_sym_undef] = ACTIONS(8423),
    [anon_sym_alias] = ACTIONS(8423),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8423),
    [sym_float] = ACTIONS(8423),
    [sym_complex] = ACTIONS(6547),
    [sym_super] = ACTIONS(8423),
    [anon_sym_true] = ACTIONS(8423),
    [anon_sym_TRUE] = ACTIONS(8423),
    [anon_sym_false] = ACTIONS(8423),
    [anon_sym_FALSE] = ACTIONS(8423),
    [sym_self] = ACTIONS(8423),
    [anon_sym_nil] = ACTIONS(8423),
    [anon_sym_NIL] = ACTIONS(8423),
    [sym_character] = ACTIONS(6547),
    [anon_sym_LBRACK2] = ACTIONS(6547),
    [anon_sym_DASH_GT] = ACTIONS(6547),
  },
  [4982] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [4983] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7336),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(7336),
    [sym_operator_assignment] = STATE(7336),
    [sym_conditional] = STATE(7336),
    [sym_range] = STATE(7336),
    [sym_binary] = STATE(7336),
    [sym_unary] = STATE(7336),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4984] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7340),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(7340),
    [sym_operator_assignment] = STATE(7340),
    [sym_conditional] = STATE(7340),
    [sym_range] = STATE(7340),
    [sym_binary] = STATE(7340),
    [sym_unary] = STATE(7340),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4985] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7341),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(7341),
    [sym_operator_assignment] = STATE(7341),
    [sym_conditional] = STATE(7341),
    [sym_range] = STATE(7341),
    [sym_binary] = STATE(7341),
    [sym_unary] = STATE(7341),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4986] = {
    [anon_sym_COLON] = ACTIONS(10631),
    [sym_comment] = ACTIONS(87),
  },
  [4987] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7344),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(7344),
    [sym_operator_assignment] = STATE(7344),
    [sym_conditional] = STATE(7344),
    [sym_range] = STATE(7344),
    [sym_binary] = STATE(7344),
    [sym_unary] = STATE(7344),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4988] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7350),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(7351),
    [sym__argument] = STATE(7352),
    [sym_splat_argument] = STATE(7352),
    [sym_hash_splat_argument] = STATE(7352),
    [sym_block_argument] = STATE(7352),
    [sym_assignment] = STATE(7350),
    [sym_operator_assignment] = STATE(7350),
    [sym_conditional] = STATE(7350),
    [sym_range] = STATE(7350),
    [sym_binary] = STATE(7350),
    [sym_unary] = STATE(7350),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7353),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7352),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10633),
    [sym__splat_star] = ACTIONS(10635),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(10637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(10639),
    [sym_identifier] = ACTIONS(10639),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4989] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7350),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(7351),
    [sym__argument] = STATE(7352),
    [sym_splat_argument] = STATE(7352),
    [sym_hash_splat_argument] = STATE(7352),
    [sym_block_argument] = STATE(7352),
    [sym_assignment] = STATE(7350),
    [sym_operator_assignment] = STATE(7350),
    [sym_conditional] = STATE(7350),
    [sym_range] = STATE(7350),
    [sym_binary] = STATE(7350),
    [sym_unary] = STATE(7350),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7353),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7352),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10633),
    [sym__splat_star] = ACTIONS(10635),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(10637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(10639),
    [sym_identifier] = ACTIONS(10639),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4990] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7350),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(7351),
    [sym__argument] = STATE(7352),
    [sym_splat_argument] = STATE(7352),
    [sym_hash_splat_argument] = STATE(7352),
    [sym_block_argument] = STATE(7352),
    [sym_assignment] = STATE(7350),
    [sym_operator_assignment] = STATE(7350),
    [sym_conditional] = STATE(7350),
    [sym_range] = STATE(7350),
    [sym_binary] = STATE(7350),
    [sym_unary] = STATE(7350),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7353),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7352),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10633),
    [sym__splat_star] = ACTIONS(10635),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(10637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(10639),
    [sym_identifier] = ACTIONS(10639),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4991] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7350),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(7351),
    [sym__argument] = STATE(7352),
    [sym_splat_argument] = STATE(7352),
    [sym_hash_splat_argument] = STATE(7352),
    [sym_block_argument] = STATE(7352),
    [sym_assignment] = STATE(7350),
    [sym_operator_assignment] = STATE(7350),
    [sym_conditional] = STATE(7350),
    [sym_range] = STATE(7350),
    [sym_binary] = STATE(7350),
    [sym_unary] = STATE(7350),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7353),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7352),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10633),
    [sym__splat_star] = ACTIONS(10635),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(10637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(10639),
    [sym_identifier] = ACTIONS(10639),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4992] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7354),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(7354),
    [sym_operator_assignment] = STATE(7354),
    [sym_conditional] = STATE(7354),
    [sym_range] = STATE(7354),
    [sym_binary] = STATE(7354),
    [sym_unary] = STATE(7354),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4993] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4994] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10641),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_elsif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [4995] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_elsif] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(10631),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [4996] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7371),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(7372),
    [sym__argument] = STATE(7373),
    [sym_splat_argument] = STATE(7373),
    [sym_hash_splat_argument] = STATE(7373),
    [sym_block_argument] = STATE(7373),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(7371),
    [sym_operator_assignment] = STATE(7371),
    [sym_conditional] = STATE(7371),
    [sym_range] = STATE(7371),
    [sym_binary] = STATE(7371),
    [sym_unary] = STATE(7371),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7374),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7373),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10669),
    [sym__splat_star] = ACTIONS(10671),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(10673),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(10675),
    [sym_identifier] = ACTIONS(10675),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [4997] = {
    [sym_heredoc_body] = STATE(7375),
    [aux_sym_call_repeat1] = STATE(7375),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_elsif] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4998] = {
    [sym_heredoc_body] = STATE(7375),
    [aux_sym_call_repeat1] = STATE(7375),
    [aux_sym_argument_list_repeat1] = STATE(7377),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10677),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_elsif] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [4999] = {
    [anon_sym_EQ] = ACTIONS(10679),
    [sym_comment] = ACTIONS(87),
  },
  [5000] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10681),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10683),
    [anon_sym_DASH_EQ] = ACTIONS(10683),
    [anon_sym_STAR_EQ] = ACTIONS(10683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10683),
    [anon_sym_SLASH_EQ] = ACTIONS(10683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10683),
    [anon_sym_PIPE_EQ] = ACTIONS(10683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10683),
    [anon_sym_AMP_EQ] = ACTIONS(10683),
    [anon_sym_PERCENT_EQ] = ACTIONS(10683),
    [anon_sym_GT_GT_EQ] = ACTIONS(10683),
    [anon_sym_LT_LT_EQ] = ACTIONS(10683),
    [anon_sym_CARET_EQ] = ACTIONS(10683),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5001] = {
    [sym_string] = STATE(7380),
    [aux_sym_chained_string_repeat1] = STATE(7380),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10685),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5002] = {
    [sym__then] = STATE(7381),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(10687),
    [sym_comment] = ACTIONS(87),
  },
  [5003] = {
    [sym__statements] = STATE(3147),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5152),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5004] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [5005] = {
    [aux_sym_undef_repeat1] = STATE(7382),
    [sym__line_break] = ACTIONS(2257),
    [sym__heredoc_body_start] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_end] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [anon_sym_elsif] = ACTIONS(2257),
    [anon_sym_else] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [5006] = {
    [sym__line_break] = ACTIONS(10689),
    [sym__heredoc_body_start] = ACTIONS(10689),
    [sym__binary_minus] = ACTIONS(10689),
    [sym__binary_star] = ACTIONS(10689),
    [ts_builtin_sym_end] = ACTIONS(10689),
    [anon_sym___END__] = ACTIONS(10689),
    [anon_sym_LBRACE] = ACTIONS(10689),
    [anon_sym_RBRACE] = ACTIONS(10689),
    [anon_sym_RPAREN] = ACTIONS(10689),
    [anon_sym_DOT] = ACTIONS(10691),
    [anon_sym_COMMA] = ACTIONS(10689),
    [anon_sym_PIPE] = ACTIONS(10691),
    [anon_sym_SEMI] = ACTIONS(10689),
    [anon_sym_STAR_STAR] = ACTIONS(10689),
    [anon_sym_AMP] = ACTIONS(10691),
    [anon_sym_LT] = ACTIONS(10691),
    [anon_sym_end] = ACTIONS(10689),
    [anon_sym_if] = ACTIONS(10689),
    [anon_sym_unless] = ACTIONS(10689),
    [anon_sym_while] = ACTIONS(10689),
    [anon_sym_until] = ACTIONS(10689),
    [anon_sym_rescue] = ACTIONS(10689),
    [anon_sym_do] = ACTIONS(10689),
    [anon_sym_when] = ACTIONS(10689),
    [anon_sym_elsif] = ACTIONS(10689),
    [anon_sym_else] = ACTIONS(10689),
    [anon_sym_then] = ACTIONS(10689),
    [anon_sym_ensure] = ACTIONS(10689),
    [anon_sym_EQ_GT] = ACTIONS(10689),
    [anon_sym_LBRACK] = ACTIONS(10689),
    [anon_sym_COLON_COLON2] = ACTIONS(10689),
    [anon_sym_AMP_DOT] = ACTIONS(10689),
    [anon_sym_QMARK] = ACTIONS(10689),
    [anon_sym_DOT_DOT] = ACTIONS(10691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10689),
    [anon_sym_and] = ACTIONS(10689),
    [anon_sym_or] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10689),
    [anon_sym_LT_LT] = ACTIONS(10689),
    [anon_sym_GT_GT] = ACTIONS(10689),
    [anon_sym_EQ_EQ] = ACTIONS(10691),
    [anon_sym_BANG_EQ] = ACTIONS(10689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10689),
    [anon_sym_LT_EQ_GT] = ACTIONS(10689),
    [anon_sym_EQ_TILDE] = ACTIONS(10689),
    [anon_sym_BANG_TILDE] = ACTIONS(10689),
    [anon_sym_LT_EQ] = ACTIONS(10691),
    [anon_sym_GT] = ACTIONS(10691),
    [anon_sym_GT_EQ] = ACTIONS(10689),
    [anon_sym_CARET] = ACTIONS(10689),
    [anon_sym_PLUS] = ACTIONS(10689),
    [anon_sym_SLASH] = ACTIONS(10689),
    [anon_sym_PERCENT] = ACTIONS(10689),
    [sym_comment] = ACTIONS(87),
  },
  [5007] = {
    [anon_sym_end] = ACTIONS(10693),
    [sym_comment] = ACTIONS(87),
  },
  [5008] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2499),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(2499),
    [anon_sym_else] = ACTIONS(2499),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5009] = {
    [sym_heredoc_body] = STATE(7384),
    [sym__terminator] = STATE(7384),
    [aux_sym__statements_repeat1] = STATE(7385),
    [sym__line_break] = ACTIONS(10695),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(10695),
    [anon_sym_end] = ACTIONS(2497),
    [anon_sym_elsif] = ACTIONS(2497),
    [anon_sym_else] = ACTIONS(2497),
    [sym_comment] = ACTIONS(87),
  },
  [5010] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7386),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7386),
    [sym_operator_assignment] = STATE(7386),
    [sym_conditional] = STATE(7386),
    [sym_range] = STATE(7386),
    [sym_binary] = STATE(7386),
    [sym_unary] = STATE(7386),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5011] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7387),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7387),
    [sym_operator_assignment] = STATE(7387),
    [sym_conditional] = STATE(7387),
    [sym_range] = STATE(7387),
    [sym_binary] = STATE(7387),
    [sym_unary] = STATE(7387),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5012] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7388),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7388),
    [sym_operator_assignment] = STATE(7388),
    [sym_conditional] = STATE(7388),
    [sym_range] = STATE(7388),
    [sym_binary] = STATE(7388),
    [sym_unary] = STATE(7388),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5013] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7389),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7389),
    [sym_operator_assignment] = STATE(7389),
    [sym_conditional] = STATE(7389),
    [sym_range] = STATE(7389),
    [sym_binary] = STATE(7389),
    [sym_unary] = STATE(7389),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5014] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7390),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7390),
    [sym_operator_assignment] = STATE(7390),
    [sym_conditional] = STATE(7390),
    [sym_range] = STATE(7390),
    [sym_binary] = STATE(7390),
    [sym_unary] = STATE(7390),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5015] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7391),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7391),
    [sym_operator_assignment] = STATE(7391),
    [sym_conditional] = STATE(7391),
    [sym_range] = STATE(7391),
    [sym_binary] = STATE(7391),
    [sym_unary] = STATE(7391),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5016] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7392),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7392),
    [sym_operator_assignment] = STATE(7392),
    [sym_conditional] = STATE(7392),
    [sym_range] = STATE(7392),
    [sym_binary] = STATE(7392),
    [sym_unary] = STATE(7392),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5017] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7393),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7393),
    [sym_operator_assignment] = STATE(7393),
    [sym_conditional] = STATE(7393),
    [sym_range] = STATE(7393),
    [sym_binary] = STATE(7393),
    [sym_unary] = STATE(7393),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5018] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7394),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7394),
    [sym_operator_assignment] = STATE(7394),
    [sym_conditional] = STATE(7394),
    [sym_range] = STATE(7394),
    [sym_binary] = STATE(7394),
    [sym_unary] = STATE(7394),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5019] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7395),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7395),
    [sym_operator_assignment] = STATE(7395),
    [sym_conditional] = STATE(7395),
    [sym_range] = STATE(7395),
    [sym_binary] = STATE(7395),
    [sym_unary] = STATE(7395),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5020] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7396),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7396),
    [sym_operator_assignment] = STATE(7396),
    [sym_conditional] = STATE(7396),
    [sym_range] = STATE(7396),
    [sym_binary] = STATE(7396),
    [sym_unary] = STATE(7396),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5021] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7397),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7397),
    [sym_operator_assignment] = STATE(7397),
    [sym_conditional] = STATE(7397),
    [sym_range] = STATE(7397),
    [sym_binary] = STATE(7397),
    [sym_unary] = STATE(7397),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5022] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7398),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7398),
    [sym_operator_assignment] = STATE(7398),
    [sym_conditional] = STATE(7398),
    [sym_range] = STATE(7398),
    [sym_binary] = STATE(7398),
    [sym_unary] = STATE(7398),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5023] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7399),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7399),
    [sym_operator_assignment] = STATE(7399),
    [sym_conditional] = STATE(7399),
    [sym_range] = STATE(7399),
    [sym_binary] = STATE(7399),
    [sym_unary] = STATE(7399),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5024] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7400),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7400),
    [sym_operator_assignment] = STATE(7400),
    [sym_conditional] = STATE(7400),
    [sym_range] = STATE(7400),
    [sym_binary] = STATE(7400),
    [sym_unary] = STATE(7400),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5025] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7408),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(7408),
    [sym_operator_assignment] = STATE(7408),
    [sym_conditional] = STATE(7408),
    [sym_range] = STATE(7408),
    [sym_binary] = STATE(7408),
    [sym_unary] = STATE(7408),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5026] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7413),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(7413),
    [sym_operator_assignment] = STATE(7413),
    [sym_conditional] = STATE(7413),
    [sym_range] = STATE(7413),
    [sym_binary] = STATE(7413),
    [sym_unary] = STATE(7413),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5027] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7414),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(7414),
    [sym_operator_assignment] = STATE(7414),
    [sym_conditional] = STATE(7414),
    [sym_range] = STATE(7414),
    [sym_binary] = STATE(7414),
    [sym_unary] = STATE(7414),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5028] = {
    [anon_sym_COLON] = ACTIONS(10721),
    [sym_comment] = ACTIONS(87),
  },
  [5029] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7417),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(7417),
    [sym_operator_assignment] = STATE(7417),
    [sym_conditional] = STATE(7417),
    [sym_range] = STATE(7417),
    [sym_binary] = STATE(7417),
    [sym_unary] = STATE(7417),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5030] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7371),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(7372),
    [sym__argument] = STATE(7373),
    [sym_splat_argument] = STATE(7373),
    [sym_hash_splat_argument] = STATE(7373),
    [sym_block_argument] = STATE(7373),
    [sym_assignment] = STATE(7371),
    [sym_operator_assignment] = STATE(7371),
    [sym_conditional] = STATE(7371),
    [sym_range] = STATE(7371),
    [sym_binary] = STATE(7371),
    [sym_unary] = STATE(7371),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7374),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7373),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10669),
    [sym__splat_star] = ACTIONS(10671),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(10673),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(10675),
    [sym_identifier] = ACTIONS(10675),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5031] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7371),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(7372),
    [sym__argument] = STATE(7373),
    [sym_splat_argument] = STATE(7373),
    [sym_hash_splat_argument] = STATE(7373),
    [sym_block_argument] = STATE(7373),
    [sym_assignment] = STATE(7371),
    [sym_operator_assignment] = STATE(7371),
    [sym_conditional] = STATE(7371),
    [sym_range] = STATE(7371),
    [sym_binary] = STATE(7371),
    [sym_unary] = STATE(7371),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7374),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7373),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10669),
    [sym__splat_star] = ACTIONS(10671),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(10673),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(10675),
    [sym_identifier] = ACTIONS(10675),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5032] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7371),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(7372),
    [sym__argument] = STATE(7373),
    [sym_splat_argument] = STATE(7373),
    [sym_hash_splat_argument] = STATE(7373),
    [sym_block_argument] = STATE(7373),
    [sym_assignment] = STATE(7371),
    [sym_operator_assignment] = STATE(7371),
    [sym_conditional] = STATE(7371),
    [sym_range] = STATE(7371),
    [sym_binary] = STATE(7371),
    [sym_unary] = STATE(7371),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7374),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7373),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10669),
    [sym__splat_star] = ACTIONS(10671),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(10673),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(10675),
    [sym_identifier] = ACTIONS(10675),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5033] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7371),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(7372),
    [sym__argument] = STATE(7373),
    [sym_splat_argument] = STATE(7373),
    [sym_hash_splat_argument] = STATE(7373),
    [sym_block_argument] = STATE(7373),
    [sym_assignment] = STATE(7371),
    [sym_operator_assignment] = STATE(7371),
    [sym_conditional] = STATE(7371),
    [sym_range] = STATE(7371),
    [sym_binary] = STATE(7371),
    [sym_unary] = STATE(7371),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7374),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7373),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10669),
    [sym__splat_star] = ACTIONS(10671),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(10673),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(10675),
    [sym_identifier] = ACTIONS(10675),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5034] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7418),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(7418),
    [sym_operator_assignment] = STATE(7418),
    [sym_conditional] = STATE(7418),
    [sym_range] = STATE(7418),
    [sym_binary] = STATE(7418),
    [sym_unary] = STATE(7418),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5035] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5036] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10723),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_elsif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5037] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_elsif] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(10721),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [5038] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7371),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(7372),
    [sym__argument] = STATE(7373),
    [sym_splat_argument] = STATE(7373),
    [sym_hash_splat_argument] = STATE(7373),
    [sym_block_argument] = STATE(7373),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(7371),
    [sym_operator_assignment] = STATE(7371),
    [sym_conditional] = STATE(7371),
    [sym_range] = STATE(7371),
    [sym_binary] = STATE(7371),
    [sym_unary] = STATE(7371),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7374),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7373),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10669),
    [sym__splat_star] = ACTIONS(10671),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(10673),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(10675),
    [sym_identifier] = ACTIONS(10675),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5039] = {
    [sym_heredoc_body] = STATE(7430),
    [aux_sym_call_repeat1] = STATE(7430),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_elsif] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5040] = {
    [sym_heredoc_body] = STATE(7430),
    [aux_sym_call_repeat1] = STATE(7430),
    [aux_sym_argument_list_repeat1] = STATE(7432),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10753),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_elsif] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5041] = {
    [anon_sym_EQ] = ACTIONS(10755),
    [sym_comment] = ACTIONS(87),
  },
  [5042] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10759),
    [anon_sym_DASH_EQ] = ACTIONS(10759),
    [anon_sym_STAR_EQ] = ACTIONS(10759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10759),
    [anon_sym_SLASH_EQ] = ACTIONS(10759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10759),
    [anon_sym_PIPE_EQ] = ACTIONS(10759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10759),
    [anon_sym_AMP_EQ] = ACTIONS(10759),
    [anon_sym_PERCENT_EQ] = ACTIONS(10759),
    [anon_sym_GT_GT_EQ] = ACTIONS(10759),
    [anon_sym_LT_LT_EQ] = ACTIONS(10759),
    [anon_sym_CARET_EQ] = ACTIONS(10759),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5043] = {
    [sym_string] = STATE(7435),
    [aux_sym_chained_string_repeat1] = STATE(7435),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5044] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7440),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_splat_argument] = STATE(7441),
    [sym_assignment] = STATE(7440),
    [sym_operator_assignment] = STATE(7440),
    [sym_conditional] = STATE(7440),
    [sym_range] = STATE(7440),
    [sym_binary] = STATE(7440),
    [sym_unary] = STATE(7440),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7441),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(10763),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5045] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7444),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(7444),
    [sym_operator_assignment] = STATE(7444),
    [sym_conditional] = STATE(7444),
    [sym_range] = STATE(7444),
    [sym_binary] = STATE(7444),
    [sym_unary] = STATE(7444),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5046] = {
    [sym_string] = STATE(7445),
    [aux_sym_chained_string_repeat1] = STATE(7445),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_elsif] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [5047] = {
    [sym_elsif] = STATE(7446),
    [sym_else] = STATE(7446),
    [sym__if_tail] = STATE(7446),
    [anon_sym_end] = ACTIONS(10693),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [5048] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7447),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(237),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(237),
    [sym_assignment] = STATE(7447),
    [sym_operator_assignment] = STATE(7447),
    [sym_conditional] = STATE(7447),
    [sym_range] = STATE(7447),
    [sym_binary] = STATE(7447),
    [sym_unary] = STATE(7447),
    [sym_left_assignment_list] = STATE(236),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(237),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(237),
    [sym_false] = STATE(237),
    [sym_nil] = STATE(237),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(238),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5049] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5050] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7864),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [5051] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7448),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(7448),
    [sym_operator_assignment] = STATE(7448),
    [sym_conditional] = STATE(7448),
    [sym_range] = STATE(7448),
    [sym_binary] = STATE(7448),
    [sym_unary] = STATE(7448),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5052] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7449),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(7449),
    [sym_operator_assignment] = STATE(7449),
    [sym_conditional] = STATE(7449),
    [sym_range] = STATE(7449),
    [sym_binary] = STATE(7449),
    [sym_unary] = STATE(7449),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5053] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7450),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(7450),
    [sym_operator_assignment] = STATE(7450),
    [sym_conditional] = STATE(7450),
    [sym_range] = STATE(7450),
    [sym_binary] = STATE(7450),
    [sym_unary] = STATE(7450),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5054] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7451),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(7451),
    [sym_operator_assignment] = STATE(7451),
    [sym_conditional] = STATE(7451),
    [sym_range] = STATE(7451),
    [sym_binary] = STATE(7451),
    [sym_unary] = STATE(7451),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5055] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7452),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(7452),
    [sym_operator_assignment] = STATE(7452),
    [sym_conditional] = STATE(7452),
    [sym_range] = STATE(7452),
    [sym_binary] = STATE(7452),
    [sym_unary] = STATE(7452),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5056] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7453),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7453),
    [sym_operator_assignment] = STATE(7453),
    [sym_conditional] = STATE(7453),
    [sym_range] = STATE(7453),
    [sym_binary] = STATE(7453),
    [sym_unary] = STATE(7453),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5057] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7454),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(7454),
    [sym_operator_assignment] = STATE(7454),
    [sym_conditional] = STATE(7454),
    [sym_range] = STATE(7454),
    [sym_binary] = STATE(7454),
    [sym_unary] = STATE(7454),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5058] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7455),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(7455),
    [sym_operator_assignment] = STATE(7455),
    [sym_conditional] = STATE(7455),
    [sym_range] = STATE(7455),
    [sym_binary] = STATE(7455),
    [sym_unary] = STATE(7455),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5059] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7456),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(7456),
    [sym_operator_assignment] = STATE(7456),
    [sym_conditional] = STATE(7456),
    [sym_range] = STATE(7456),
    [sym_binary] = STATE(7456),
    [sym_unary] = STATE(7456),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5060] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7457),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(7457),
    [sym_operator_assignment] = STATE(7457),
    [sym_conditional] = STATE(7457),
    [sym_range] = STATE(7457),
    [sym_binary] = STATE(7457),
    [sym_unary] = STATE(7457),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5061] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7458),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_splat_argument] = STATE(7459),
    [sym_assignment] = STATE(7458),
    [sym_operator_assignment] = STATE(7458),
    [sym_conditional] = STATE(7458),
    [sym_range] = STATE(7458),
    [sym_binary] = STATE(7458),
    [sym_unary] = STATE(7458),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(7459),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(1789),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5062] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7460),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(7460),
    [sym_operator_assignment] = STATE(7460),
    [sym_conditional] = STATE(7460),
    [sym_range] = STATE(7460),
    [sym_binary] = STATE(7460),
    [sym_unary] = STATE(7460),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5063] = {
    [sym_string] = STATE(7461),
    [aux_sym_chained_string_repeat1] = STATE(7461),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [5064] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7864),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [5065] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7864),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [5066] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [5067] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [5068] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [5069] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [5070] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [5071] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10775),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5072] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [5073] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [5074] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [5075] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [5076] = {
    [sym_heredoc_body] = STATE(5076),
    [aux_sym_call_repeat1] = STATE(5076),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [5077] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1002),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(1002),
    [sym_operator_assignment] = STATE(1002),
    [sym_conditional] = STATE(1002),
    [sym_range] = STATE(1002),
    [sym_binary] = STATE(1002),
    [sym_unary] = STATE(1002),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1008),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1787),
    [sym__splat_star] = ACTIONS(1789),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__identifier_hash_key] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7886),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1811),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5078] = {
    [sym_heredoc_body] = STATE(5076),
    [aux_sym_call_repeat1] = STATE(5076),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [5079] = {
    [aux_sym_argument_list_repeat1] = STATE(5079),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(10777),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [5080] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [5081] = {
    [aux_sym_exceptions_repeat1] = STATE(7464),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [5082] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [5083] = {
    [sym_string] = STATE(5083),
    [aux_sym_chained_string_repeat1] = STATE(5083),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [5084] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7892),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(7894),
    [anon_sym_LT] = ACTIONS(7896),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7898),
    [anon_sym_DOT_DOT] = ACTIONS(7900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7902),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7904),
    [anon_sym_AMP_AMP] = ACTIONS(7904),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(7908),
    [anon_sym_BANG_EQ] = ACTIONS(7904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7904),
    [anon_sym_LT_EQ_GT] = ACTIONS(7904),
    [anon_sym_EQ_TILDE] = ACTIONS(7904),
    [anon_sym_BANG_TILDE] = ACTIONS(7904),
    [anon_sym_LT_EQ] = ACTIONS(7896),
    [anon_sym_GT] = ACTIONS(7896),
    [anon_sym_GT_EQ] = ACTIONS(7910),
    [anon_sym_CARET] = ACTIONS(7912),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [5085] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5086] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(7892),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(7894),
    [anon_sym_LT] = ACTIONS(7896),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7898),
    [anon_sym_DOT_DOT] = ACTIONS(7900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7902),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7904),
    [anon_sym_AMP_AMP] = ACTIONS(7904),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(7908),
    [anon_sym_BANG_EQ] = ACTIONS(7904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7904),
    [anon_sym_LT_EQ_GT] = ACTIONS(7904),
    [anon_sym_EQ_TILDE] = ACTIONS(7904),
    [anon_sym_BANG_TILDE] = ACTIONS(7904),
    [anon_sym_LT_EQ] = ACTIONS(7896),
    [anon_sym_GT] = ACTIONS(7896),
    [anon_sym_GT_EQ] = ACTIONS(7910),
    [anon_sym_CARET] = ACTIONS(7912),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [5087] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7465),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(7465),
    [sym_operator_assignment] = STATE(7465),
    [sym_conditional] = STATE(7465),
    [sym_range] = STATE(7465),
    [sym_binary] = STATE(7465),
    [sym_unary] = STATE(7465),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5088] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7466),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(7466),
    [sym_operator_assignment] = STATE(7466),
    [sym_conditional] = STATE(7466),
    [sym_range] = STATE(7466),
    [sym_binary] = STATE(7466),
    [sym_unary] = STATE(7466),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5089] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7467),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(7467),
    [sym_operator_assignment] = STATE(7467),
    [sym_conditional] = STATE(7467),
    [sym_range] = STATE(7467),
    [sym_binary] = STATE(7467),
    [sym_unary] = STATE(7467),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5090] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7468),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(7468),
    [sym_operator_assignment] = STATE(7468),
    [sym_conditional] = STATE(7468),
    [sym_range] = STATE(7468),
    [sym_binary] = STATE(7468),
    [sym_unary] = STATE(7468),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5091] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7469),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(7469),
    [sym_operator_assignment] = STATE(7469),
    [sym_conditional] = STATE(7469),
    [sym_range] = STATE(7469),
    [sym_binary] = STATE(7469),
    [sym_unary] = STATE(7469),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5092] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7470),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7470),
    [sym_operator_assignment] = STATE(7470),
    [sym_conditional] = STATE(7470),
    [sym_range] = STATE(7470),
    [sym_binary] = STATE(7470),
    [sym_unary] = STATE(7470),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5093] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7471),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(7471),
    [sym_operator_assignment] = STATE(7471),
    [sym_conditional] = STATE(7471),
    [sym_range] = STATE(7471),
    [sym_binary] = STATE(7471),
    [sym_unary] = STATE(7471),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5094] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7472),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(7472),
    [sym_operator_assignment] = STATE(7472),
    [sym_conditional] = STATE(7472),
    [sym_range] = STATE(7472),
    [sym_binary] = STATE(7472),
    [sym_unary] = STATE(7472),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5095] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7473),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(7473),
    [sym_operator_assignment] = STATE(7473),
    [sym_conditional] = STATE(7473),
    [sym_range] = STATE(7473),
    [sym_binary] = STATE(7473),
    [sym_unary] = STATE(7473),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5096] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7474),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(7474),
    [sym_operator_assignment] = STATE(7474),
    [sym_conditional] = STATE(7474),
    [sym_range] = STATE(7474),
    [sym_binary] = STATE(7474),
    [sym_unary] = STATE(7474),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5097] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2688),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(2688),
    [sym_operator_assignment] = STATE(2688),
    [sym_conditional] = STATE(2688),
    [sym_range] = STATE(2688),
    [sym_binary] = STATE(2688),
    [sym_unary] = STATE(2688),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4438),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5098] = {
    [aux_sym_exceptions_repeat1] = STATE(7475),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(7914),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [5099] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2688),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_splat_argument] = STATE(7476),
    [sym_assignment] = STATE(2688),
    [sym_operator_assignment] = STATE(2688),
    [sym_conditional] = STATE(2688),
    [sym_range] = STATE(2688),
    [sym_binary] = STATE(2688),
    [sym_unary] = STATE(2688),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7476),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4438),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5100] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7477),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(7477),
    [sym_operator_assignment] = STATE(7477),
    [sym_conditional] = STATE(7477),
    [sym_range] = STATE(7477),
    [sym_binary] = STATE(7477),
    [sym_unary] = STATE(7477),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5101] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5102] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7485),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(7485),
    [sym_operator_assignment] = STATE(7485),
    [sym_conditional] = STATE(7485),
    [sym_range] = STATE(7485),
    [sym_binary] = STATE(7485),
    [sym_unary] = STATE(7485),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5103] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7489),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(7489),
    [sym_operator_assignment] = STATE(7489),
    [sym_conditional] = STATE(7489),
    [sym_range] = STATE(7489),
    [sym_binary] = STATE(7489),
    [sym_unary] = STATE(7489),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5104] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7490),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(7490),
    [sym_operator_assignment] = STATE(7490),
    [sym_conditional] = STATE(7490),
    [sym_range] = STATE(7490),
    [sym_binary] = STATE(7490),
    [sym_unary] = STATE(7490),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5105] = {
    [anon_sym_COLON] = ACTIONS(10800),
    [sym_comment] = ACTIONS(87),
  },
  [5106] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7493),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(7493),
    [sym_operator_assignment] = STATE(7493),
    [sym_conditional] = STATE(7493),
    [sym_range] = STATE(7493),
    [sym_binary] = STATE(7493),
    [sym_unary] = STATE(7493),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5107] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7499),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(7500),
    [sym__argument] = STATE(7501),
    [sym_splat_argument] = STATE(7501),
    [sym_hash_splat_argument] = STATE(7501),
    [sym_block_argument] = STATE(7501),
    [sym_assignment] = STATE(7499),
    [sym_operator_assignment] = STATE(7499),
    [sym_conditional] = STATE(7499),
    [sym_range] = STATE(7499),
    [sym_binary] = STATE(7499),
    [sym_unary] = STATE(7499),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7502),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7501),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10802),
    [sym__splat_star] = ACTIONS(10804),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(10806),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(10808),
    [sym_identifier] = ACTIONS(10808),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5108] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7499),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(7500),
    [sym__argument] = STATE(7501),
    [sym_splat_argument] = STATE(7501),
    [sym_hash_splat_argument] = STATE(7501),
    [sym_block_argument] = STATE(7501),
    [sym_assignment] = STATE(7499),
    [sym_operator_assignment] = STATE(7499),
    [sym_conditional] = STATE(7499),
    [sym_range] = STATE(7499),
    [sym_binary] = STATE(7499),
    [sym_unary] = STATE(7499),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7502),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7501),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10802),
    [sym__splat_star] = ACTIONS(10804),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(10806),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(10808),
    [sym_identifier] = ACTIONS(10808),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5109] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7499),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(7500),
    [sym__argument] = STATE(7501),
    [sym_splat_argument] = STATE(7501),
    [sym_hash_splat_argument] = STATE(7501),
    [sym_block_argument] = STATE(7501),
    [sym_assignment] = STATE(7499),
    [sym_operator_assignment] = STATE(7499),
    [sym_conditional] = STATE(7499),
    [sym_range] = STATE(7499),
    [sym_binary] = STATE(7499),
    [sym_unary] = STATE(7499),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7502),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7501),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10802),
    [sym__splat_star] = ACTIONS(10804),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(10806),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(10808),
    [sym_identifier] = ACTIONS(10808),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5110] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7499),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(7500),
    [sym__argument] = STATE(7501),
    [sym_splat_argument] = STATE(7501),
    [sym_hash_splat_argument] = STATE(7501),
    [sym_block_argument] = STATE(7501),
    [sym_assignment] = STATE(7499),
    [sym_operator_assignment] = STATE(7499),
    [sym_conditional] = STATE(7499),
    [sym_range] = STATE(7499),
    [sym_binary] = STATE(7499),
    [sym_unary] = STATE(7499),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7502),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7501),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10802),
    [sym__splat_star] = ACTIONS(10804),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(10806),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(10808),
    [sym_identifier] = ACTIONS(10808),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5111] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7503),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(7503),
    [sym_operator_assignment] = STATE(7503),
    [sym_conditional] = STATE(7503),
    [sym_range] = STATE(7503),
    [sym_binary] = STATE(7503),
    [sym_unary] = STATE(7503),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5112] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5113] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10810),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5114] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(10800),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [5115] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7520),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(7521),
    [sym__argument] = STATE(7522),
    [sym_splat_argument] = STATE(7522),
    [sym_hash_splat_argument] = STATE(7522),
    [sym_block_argument] = STATE(7522),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(7520),
    [sym_operator_assignment] = STATE(7520),
    [sym_conditional] = STATE(7520),
    [sym_range] = STATE(7520),
    [sym_binary] = STATE(7520),
    [sym_unary] = STATE(7520),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7523),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7522),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10838),
    [sym__splat_star] = ACTIONS(10840),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(10842),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(10844),
    [sym_identifier] = ACTIONS(10844),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5116] = {
    [sym_heredoc_body] = STATE(7524),
    [aux_sym_call_repeat1] = STATE(7524),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5117] = {
    [sym_heredoc_body] = STATE(7524),
    [aux_sym_call_repeat1] = STATE(7524),
    [aux_sym_argument_list_repeat1] = STATE(7526),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10846),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5118] = {
    [anon_sym_EQ] = ACTIONS(10848),
    [sym_comment] = ACTIONS(87),
  },
  [5119] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10852),
    [anon_sym_DASH_EQ] = ACTIONS(10852),
    [anon_sym_STAR_EQ] = ACTIONS(10852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10852),
    [anon_sym_SLASH_EQ] = ACTIONS(10852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10852),
    [anon_sym_PIPE_EQ] = ACTIONS(10852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10852),
    [anon_sym_AMP_EQ] = ACTIONS(10852),
    [anon_sym_PERCENT_EQ] = ACTIONS(10852),
    [anon_sym_GT_GT_EQ] = ACTIONS(10852),
    [anon_sym_LT_LT_EQ] = ACTIONS(10852),
    [anon_sym_CARET_EQ] = ACTIONS(10852),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5120] = {
    [sym_string] = STATE(7529),
    [aux_sym_chained_string_repeat1] = STATE(7529),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10854),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5121] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [5122] = {
    [aux_sym_undef_repeat1] = STATE(7530),
    [sym__line_break] = ACTIONS(2257),
    [sym__heredoc_body_start] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_end] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [anon_sym_else] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [5123] = {
    [sym__line_break] = ACTIONS(10856),
    [sym__heredoc_body_start] = ACTIONS(10856),
    [sym__binary_minus] = ACTIONS(10856),
    [sym__binary_star] = ACTIONS(10856),
    [ts_builtin_sym_end] = ACTIONS(10856),
    [anon_sym___END__] = ACTIONS(10856),
    [anon_sym_LBRACE] = ACTIONS(10856),
    [anon_sym_RBRACE] = ACTIONS(10856),
    [anon_sym_RPAREN] = ACTIONS(10856),
    [anon_sym_DOT] = ACTIONS(10858),
    [anon_sym_COMMA] = ACTIONS(10856),
    [anon_sym_PIPE] = ACTIONS(10858),
    [anon_sym_SEMI] = ACTIONS(10856),
    [anon_sym_STAR_STAR] = ACTIONS(10856),
    [anon_sym_AMP] = ACTIONS(10858),
    [anon_sym_LT] = ACTIONS(10858),
    [anon_sym_end] = ACTIONS(10856),
    [anon_sym_if] = ACTIONS(10856),
    [anon_sym_unless] = ACTIONS(10856),
    [anon_sym_while] = ACTIONS(10856),
    [anon_sym_until] = ACTIONS(10856),
    [anon_sym_rescue] = ACTIONS(10856),
    [anon_sym_do] = ACTIONS(10856),
    [anon_sym_when] = ACTIONS(10856),
    [anon_sym_elsif] = ACTIONS(10856),
    [anon_sym_else] = ACTIONS(10856),
    [anon_sym_then] = ACTIONS(10856),
    [anon_sym_ensure] = ACTIONS(10856),
    [anon_sym_EQ_GT] = ACTIONS(10856),
    [anon_sym_LBRACK] = ACTIONS(10856),
    [anon_sym_COLON_COLON2] = ACTIONS(10856),
    [anon_sym_AMP_DOT] = ACTIONS(10856),
    [anon_sym_QMARK] = ACTIONS(10856),
    [anon_sym_DOT_DOT] = ACTIONS(10858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10856),
    [anon_sym_and] = ACTIONS(10856),
    [anon_sym_or] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE] = ACTIONS(10856),
    [anon_sym_AMP_AMP] = ACTIONS(10856),
    [anon_sym_LT_LT] = ACTIONS(10856),
    [anon_sym_GT_GT] = ACTIONS(10856),
    [anon_sym_EQ_EQ] = ACTIONS(10858),
    [anon_sym_BANG_EQ] = ACTIONS(10856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10856),
    [anon_sym_LT_EQ_GT] = ACTIONS(10856),
    [anon_sym_EQ_TILDE] = ACTIONS(10856),
    [anon_sym_BANG_TILDE] = ACTIONS(10856),
    [anon_sym_LT_EQ] = ACTIONS(10858),
    [anon_sym_GT] = ACTIONS(10858),
    [anon_sym_GT_EQ] = ACTIONS(10856),
    [anon_sym_CARET] = ACTIONS(10856),
    [anon_sym_PLUS] = ACTIONS(10856),
    [anon_sym_SLASH] = ACTIONS(10856),
    [anon_sym_PERCENT] = ACTIONS(10856),
    [sym_comment] = ACTIONS(87),
  },
  [5124] = {
    [anon_sym_end] = ACTIONS(10860),
    [sym_comment] = ACTIONS(87),
  },
  [5125] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2499),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(2499),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5126] = {
    [sym_heredoc_body] = STATE(7532),
    [sym__terminator] = STATE(7532),
    [aux_sym__statements_repeat1] = STATE(7533),
    [sym__line_break] = ACTIONS(10862),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(10862),
    [anon_sym_end] = ACTIONS(2497),
    [anon_sym_else] = ACTIONS(2497),
    [sym_comment] = ACTIONS(87),
  },
  [5127] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7534),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7534),
    [sym_operator_assignment] = STATE(7534),
    [sym_conditional] = STATE(7534),
    [sym_range] = STATE(7534),
    [sym_binary] = STATE(7534),
    [sym_unary] = STATE(7534),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5128] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7535),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7535),
    [sym_operator_assignment] = STATE(7535),
    [sym_conditional] = STATE(7535),
    [sym_range] = STATE(7535),
    [sym_binary] = STATE(7535),
    [sym_unary] = STATE(7535),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5129] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7536),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7536),
    [sym_operator_assignment] = STATE(7536),
    [sym_conditional] = STATE(7536),
    [sym_range] = STATE(7536),
    [sym_binary] = STATE(7536),
    [sym_unary] = STATE(7536),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5130] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7537),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7537),
    [sym_operator_assignment] = STATE(7537),
    [sym_conditional] = STATE(7537),
    [sym_range] = STATE(7537),
    [sym_binary] = STATE(7537),
    [sym_unary] = STATE(7537),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5131] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7538),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7538),
    [sym_operator_assignment] = STATE(7538),
    [sym_conditional] = STATE(7538),
    [sym_range] = STATE(7538),
    [sym_binary] = STATE(7538),
    [sym_unary] = STATE(7538),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5132] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7539),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7539),
    [sym_operator_assignment] = STATE(7539),
    [sym_conditional] = STATE(7539),
    [sym_range] = STATE(7539),
    [sym_binary] = STATE(7539),
    [sym_unary] = STATE(7539),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5133] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7540),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7540),
    [sym_operator_assignment] = STATE(7540),
    [sym_conditional] = STATE(7540),
    [sym_range] = STATE(7540),
    [sym_binary] = STATE(7540),
    [sym_unary] = STATE(7540),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5134] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7541),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7541),
    [sym_operator_assignment] = STATE(7541),
    [sym_conditional] = STATE(7541),
    [sym_range] = STATE(7541),
    [sym_binary] = STATE(7541),
    [sym_unary] = STATE(7541),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5135] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7542),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7542),
    [sym_operator_assignment] = STATE(7542),
    [sym_conditional] = STATE(7542),
    [sym_range] = STATE(7542),
    [sym_binary] = STATE(7542),
    [sym_unary] = STATE(7542),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5136] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7543),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7543),
    [sym_operator_assignment] = STATE(7543),
    [sym_conditional] = STATE(7543),
    [sym_range] = STATE(7543),
    [sym_binary] = STATE(7543),
    [sym_unary] = STATE(7543),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5137] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7544),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7544),
    [sym_operator_assignment] = STATE(7544),
    [sym_conditional] = STATE(7544),
    [sym_range] = STATE(7544),
    [sym_binary] = STATE(7544),
    [sym_unary] = STATE(7544),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5138] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7545),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7545),
    [sym_operator_assignment] = STATE(7545),
    [sym_conditional] = STATE(7545),
    [sym_range] = STATE(7545),
    [sym_binary] = STATE(7545),
    [sym_unary] = STATE(7545),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5139] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7546),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7546),
    [sym_operator_assignment] = STATE(7546),
    [sym_conditional] = STATE(7546),
    [sym_range] = STATE(7546),
    [sym_binary] = STATE(7546),
    [sym_unary] = STATE(7546),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5140] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7547),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7547),
    [sym_operator_assignment] = STATE(7547),
    [sym_conditional] = STATE(7547),
    [sym_range] = STATE(7547),
    [sym_binary] = STATE(7547),
    [sym_unary] = STATE(7547),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5141] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7548),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7548),
    [sym_operator_assignment] = STATE(7548),
    [sym_conditional] = STATE(7548),
    [sym_range] = STATE(7548),
    [sym_binary] = STATE(7548),
    [sym_unary] = STATE(7548),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5142] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7556),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(7556),
    [sym_operator_assignment] = STATE(7556),
    [sym_conditional] = STATE(7556),
    [sym_range] = STATE(7556),
    [sym_binary] = STATE(7556),
    [sym_unary] = STATE(7556),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5143] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7561),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(7561),
    [sym_operator_assignment] = STATE(7561),
    [sym_conditional] = STATE(7561),
    [sym_range] = STATE(7561),
    [sym_binary] = STATE(7561),
    [sym_unary] = STATE(7561),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5144] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7562),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(7562),
    [sym_operator_assignment] = STATE(7562),
    [sym_conditional] = STATE(7562),
    [sym_range] = STATE(7562),
    [sym_binary] = STATE(7562),
    [sym_unary] = STATE(7562),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5145] = {
    [anon_sym_COLON] = ACTIONS(10888),
    [sym_comment] = ACTIONS(87),
  },
  [5146] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7565),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(7565),
    [sym_operator_assignment] = STATE(7565),
    [sym_conditional] = STATE(7565),
    [sym_range] = STATE(7565),
    [sym_binary] = STATE(7565),
    [sym_unary] = STATE(7565),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5147] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7520),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(7521),
    [sym__argument] = STATE(7522),
    [sym_splat_argument] = STATE(7522),
    [sym_hash_splat_argument] = STATE(7522),
    [sym_block_argument] = STATE(7522),
    [sym_assignment] = STATE(7520),
    [sym_operator_assignment] = STATE(7520),
    [sym_conditional] = STATE(7520),
    [sym_range] = STATE(7520),
    [sym_binary] = STATE(7520),
    [sym_unary] = STATE(7520),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7523),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7522),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10838),
    [sym__splat_star] = ACTIONS(10840),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(10842),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(10844),
    [sym_identifier] = ACTIONS(10844),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5148] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7520),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(7521),
    [sym__argument] = STATE(7522),
    [sym_splat_argument] = STATE(7522),
    [sym_hash_splat_argument] = STATE(7522),
    [sym_block_argument] = STATE(7522),
    [sym_assignment] = STATE(7520),
    [sym_operator_assignment] = STATE(7520),
    [sym_conditional] = STATE(7520),
    [sym_range] = STATE(7520),
    [sym_binary] = STATE(7520),
    [sym_unary] = STATE(7520),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7523),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7522),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10838),
    [sym__splat_star] = ACTIONS(10840),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(10842),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(10844),
    [sym_identifier] = ACTIONS(10844),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5149] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7520),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(7521),
    [sym__argument] = STATE(7522),
    [sym_splat_argument] = STATE(7522),
    [sym_hash_splat_argument] = STATE(7522),
    [sym_block_argument] = STATE(7522),
    [sym_assignment] = STATE(7520),
    [sym_operator_assignment] = STATE(7520),
    [sym_conditional] = STATE(7520),
    [sym_range] = STATE(7520),
    [sym_binary] = STATE(7520),
    [sym_unary] = STATE(7520),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7523),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7522),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10838),
    [sym__splat_star] = ACTIONS(10840),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(10842),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(10844),
    [sym_identifier] = ACTIONS(10844),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5150] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7520),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(7521),
    [sym__argument] = STATE(7522),
    [sym_splat_argument] = STATE(7522),
    [sym_hash_splat_argument] = STATE(7522),
    [sym_block_argument] = STATE(7522),
    [sym_assignment] = STATE(7520),
    [sym_operator_assignment] = STATE(7520),
    [sym_conditional] = STATE(7520),
    [sym_range] = STATE(7520),
    [sym_binary] = STATE(7520),
    [sym_unary] = STATE(7520),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7523),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7522),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10838),
    [sym__splat_star] = ACTIONS(10840),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(10842),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(10844),
    [sym_identifier] = ACTIONS(10844),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5151] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7566),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(7566),
    [sym_operator_assignment] = STATE(7566),
    [sym_conditional] = STATE(7566),
    [sym_range] = STATE(7566),
    [sym_binary] = STATE(7566),
    [sym_unary] = STATE(7566),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5152] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5153] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10890),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5154] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(10888),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [5155] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7520),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(7521),
    [sym__argument] = STATE(7522),
    [sym_splat_argument] = STATE(7522),
    [sym_hash_splat_argument] = STATE(7522),
    [sym_block_argument] = STATE(7522),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(7520),
    [sym_operator_assignment] = STATE(7520),
    [sym_conditional] = STATE(7520),
    [sym_range] = STATE(7520),
    [sym_binary] = STATE(7520),
    [sym_unary] = STATE(7520),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7523),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7522),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10838),
    [sym__splat_star] = ACTIONS(10840),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(10842),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(10844),
    [sym_identifier] = ACTIONS(10844),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5156] = {
    [sym_heredoc_body] = STATE(7578),
    [aux_sym_call_repeat1] = STATE(7578),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5157] = {
    [sym_heredoc_body] = STATE(7578),
    [aux_sym_call_repeat1] = STATE(7578),
    [aux_sym_argument_list_repeat1] = STATE(7580),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10920),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5158] = {
    [anon_sym_EQ] = ACTIONS(10922),
    [sym_comment] = ACTIONS(87),
  },
  [5159] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10924),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10926),
    [anon_sym_DASH_EQ] = ACTIONS(10926),
    [anon_sym_STAR_EQ] = ACTIONS(10926),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10926),
    [anon_sym_SLASH_EQ] = ACTIONS(10926),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10926),
    [anon_sym_PIPE_EQ] = ACTIONS(10926),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10926),
    [anon_sym_AMP_EQ] = ACTIONS(10926),
    [anon_sym_PERCENT_EQ] = ACTIONS(10926),
    [anon_sym_GT_GT_EQ] = ACTIONS(10926),
    [anon_sym_LT_LT_EQ] = ACTIONS(10926),
    [anon_sym_CARET_EQ] = ACTIONS(10926),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5160] = {
    [sym_string] = STATE(7583),
    [aux_sym_chained_string_repeat1] = STATE(7583),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5161] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7588),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_splat_argument] = STATE(7589),
    [sym_assignment] = STATE(7588),
    [sym_operator_assignment] = STATE(7588),
    [sym_conditional] = STATE(7588),
    [sym_range] = STATE(7588),
    [sym_binary] = STATE(7588),
    [sym_unary] = STATE(7588),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7589),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(10930),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5162] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7592),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(7592),
    [sym_operator_assignment] = STATE(7592),
    [sym_conditional] = STATE(7592),
    [sym_range] = STATE(7592),
    [sym_binary] = STATE(7592),
    [sym_unary] = STATE(7592),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5163] = {
    [sym_string] = STATE(7593),
    [aux_sym_chained_string_repeat1] = STATE(7593),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [5164] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5165] = {
    [sym_heredoc_body] = STATE(7594),
    [aux_sym_call_repeat1] = STATE(7594),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5166] = {
    [sym_heredoc_body] = STATE(7594),
    [aux_sym_call_repeat1] = STATE(7594),
    [aux_sym_argument_list_repeat1] = STATE(7595),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4546),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5167] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8046),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [5168] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7596),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(7596),
    [sym_operator_assignment] = STATE(7596),
    [sym_conditional] = STATE(7596),
    [sym_range] = STATE(7596),
    [sym_binary] = STATE(7596),
    [sym_unary] = STATE(7596),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5169] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7597),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(7597),
    [sym_operator_assignment] = STATE(7597),
    [sym_conditional] = STATE(7597),
    [sym_range] = STATE(7597),
    [sym_binary] = STATE(7597),
    [sym_unary] = STATE(7597),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5170] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7598),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(7598),
    [sym_operator_assignment] = STATE(7598),
    [sym_conditional] = STATE(7598),
    [sym_range] = STATE(7598),
    [sym_binary] = STATE(7598),
    [sym_unary] = STATE(7598),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5171] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7599),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(7599),
    [sym_operator_assignment] = STATE(7599),
    [sym_conditional] = STATE(7599),
    [sym_range] = STATE(7599),
    [sym_binary] = STATE(7599),
    [sym_unary] = STATE(7599),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5172] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7600),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(7600),
    [sym_operator_assignment] = STATE(7600),
    [sym_conditional] = STATE(7600),
    [sym_range] = STATE(7600),
    [sym_binary] = STATE(7600),
    [sym_unary] = STATE(7600),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5173] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7601),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7601),
    [sym_operator_assignment] = STATE(7601),
    [sym_conditional] = STATE(7601),
    [sym_range] = STATE(7601),
    [sym_binary] = STATE(7601),
    [sym_unary] = STATE(7601),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5174] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7602),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(7602),
    [sym_operator_assignment] = STATE(7602),
    [sym_conditional] = STATE(7602),
    [sym_range] = STATE(7602),
    [sym_binary] = STATE(7602),
    [sym_unary] = STATE(7602),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5175] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7603),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(7603),
    [sym_operator_assignment] = STATE(7603),
    [sym_conditional] = STATE(7603),
    [sym_range] = STATE(7603),
    [sym_binary] = STATE(7603),
    [sym_unary] = STATE(7603),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5176] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7604),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(7604),
    [sym_operator_assignment] = STATE(7604),
    [sym_conditional] = STATE(7604),
    [sym_range] = STATE(7604),
    [sym_binary] = STATE(7604),
    [sym_unary] = STATE(7604),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5177] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7605),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(7605),
    [sym_operator_assignment] = STATE(7605),
    [sym_conditional] = STATE(7605),
    [sym_range] = STATE(7605),
    [sym_binary] = STATE(7605),
    [sym_unary] = STATE(7605),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5178] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7606),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_splat_argument] = STATE(7607),
    [sym_assignment] = STATE(7606),
    [sym_operator_assignment] = STATE(7606),
    [sym_conditional] = STATE(7606),
    [sym_range] = STATE(7606),
    [sym_binary] = STATE(7606),
    [sym_unary] = STATE(7606),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(7607),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5179] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7608),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(7608),
    [sym_operator_assignment] = STATE(7608),
    [sym_conditional] = STATE(7608),
    [sym_range] = STATE(7608),
    [sym_binary] = STATE(7608),
    [sym_unary] = STATE(7608),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5180] = {
    [sym_string] = STATE(7609),
    [aux_sym_chained_string_repeat1] = STATE(7609),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [5181] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8046),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [5182] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5183] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5184] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7610),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(7610),
    [sym_operator_assignment] = STATE(7610),
    [sym_conditional] = STATE(7610),
    [sym_range] = STATE(7610),
    [sym_binary] = STATE(7610),
    [sym_unary] = STATE(7610),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5185] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5186] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7611),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(7611),
    [sym_operator_assignment] = STATE(7611),
    [sym_conditional] = STATE(7611),
    [sym_range] = STATE(7611),
    [sym_binary] = STATE(7611),
    [sym_unary] = STATE(7611),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5187] = {
    [sym_heredoc_body] = STATE(7612),
    [aux_sym_call_repeat1] = STATE(7612),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5188] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2734),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(2734),
    [sym_operator_assignment] = STATE(2734),
    [sym_conditional] = STATE(2734),
    [sym_range] = STATE(2734),
    [sym_binary] = STATE(2734),
    [sym_unary] = STATE(2734),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2737),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7613),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4500),
    [sym__splat_star] = ACTIONS(4502),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__identifier_hash_key] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10942),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(4506),
    [sym_identifier] = ACTIONS(4506),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5189] = {
    [sym_heredoc_body] = STATE(7614),
    [aux_sym_call_repeat1] = STATE(7614),
    [aux_sym_argument_list_repeat1] = STATE(7615),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8072),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5190] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8046),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [5191] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5192] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [5193] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5194] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5195] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5196] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10944),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5197] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5198] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5199] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5200] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5201] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5202] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5203] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7617),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(7617),
    [sym_operator_assignment] = STATE(7617),
    [sym_conditional] = STATE(7617),
    [sym_range] = STATE(7617),
    [sym_binary] = STATE(7617),
    [sym_unary] = STATE(7617),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5204] = {
    [sym__line_break] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [5205] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5206] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7618),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(7618),
    [sym_operator_assignment] = STATE(7618),
    [sym_conditional] = STATE(7618),
    [sym_range] = STATE(7618),
    [sym_binary] = STATE(7618),
    [sym_unary] = STATE(7618),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5207] = {
    [sym_heredoc_body] = STATE(7619),
    [aux_sym_call_repeat1] = STATE(7619),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5208] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2756),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(2756),
    [sym_operator_assignment] = STATE(2756),
    [sym_conditional] = STATE(2756),
    [sym_range] = STATE(2756),
    [sym_binary] = STATE(2756),
    [sym_unary] = STATE(2756),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2759),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(7620),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4536),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__identifier_hash_key] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10946),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4544),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5209] = {
    [sym_heredoc_body] = STATE(7621),
    [aux_sym_call_repeat1] = STATE(7621),
    [aux_sym_argument_list_repeat1] = STATE(7622),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8082),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5210] = {
    [sym_heredoc_body] = STATE(5210),
    [aux_sym_call_repeat1] = STATE(5210),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [5211] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1027),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(1027),
    [sym_operator_assignment] = STATE(1027),
    [sym_conditional] = STATE(1027),
    [sym_range] = STATE(1027),
    [sym_binary] = STATE(1027),
    [sym_unary] = STATE(1027),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1033),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1827),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__identifier_hash_key] = ACTIONS(1833),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8086),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1851),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5212] = {
    [sym_heredoc_body] = STATE(5210),
    [aux_sym_call_repeat1] = STATE(5210),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [5213] = {
    [aux_sym_argument_list_repeat1] = STATE(5213),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(10948),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [5214] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5215] = {
    [aux_sym_exceptions_repeat1] = STATE(7624),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [5216] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5217] = {
    [sym_string] = STATE(5217),
    [aux_sym_chained_string_repeat1] = STATE(5217),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [5218] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7625),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(250),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(250),
    [sym_assignment] = STATE(7625),
    [sym_operator_assignment] = STATE(7625),
    [sym_conditional] = STATE(7625),
    [sym_range] = STATE(7625),
    [sym_binary] = STATE(7625),
    [sym_unary] = STATE(7625),
    [sym_left_assignment_list] = STATE(249),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(250),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(250),
    [sym_false] = STATE(250),
    [sym_nil] = STATE(250),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(251),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5219] = {
    [sym__line_break] = ACTIONS(10951),
    [sym__heredoc_body_start] = ACTIONS(10951),
    [sym__binary_minus] = ACTIONS(10951),
    [sym__binary_star] = ACTIONS(10951),
    [ts_builtin_sym_end] = ACTIONS(10951),
    [anon_sym___END__] = ACTIONS(10951),
    [anon_sym_LBRACE] = ACTIONS(10951),
    [anon_sym_RBRACE] = ACTIONS(10951),
    [anon_sym_RPAREN] = ACTIONS(10951),
    [anon_sym_DOT] = ACTIONS(10953),
    [anon_sym_COMMA] = ACTIONS(10951),
    [anon_sym_PIPE] = ACTIONS(10953),
    [anon_sym_SEMI] = ACTIONS(10951),
    [anon_sym_STAR_STAR] = ACTIONS(10951),
    [anon_sym_AMP] = ACTIONS(10953),
    [anon_sym_LT] = ACTIONS(10953),
    [anon_sym_end] = ACTIONS(10951),
    [anon_sym_if] = ACTIONS(10951),
    [anon_sym_unless] = ACTIONS(10951),
    [anon_sym_while] = ACTIONS(10951),
    [anon_sym_until] = ACTIONS(10951),
    [anon_sym_rescue] = ACTIONS(10951),
    [anon_sym_do] = ACTIONS(10951),
    [anon_sym_when] = ACTIONS(10951),
    [anon_sym_elsif] = ACTIONS(10951),
    [anon_sym_else] = ACTIONS(10951),
    [anon_sym_then] = ACTIONS(10951),
    [anon_sym_ensure] = ACTIONS(10951),
    [anon_sym_EQ_GT] = ACTIONS(10951),
    [anon_sym_LBRACK] = ACTIONS(10951),
    [anon_sym_COLON_COLON2] = ACTIONS(10951),
    [anon_sym_AMP_DOT] = ACTIONS(10951),
    [anon_sym_QMARK] = ACTIONS(10951),
    [anon_sym_DOT_DOT] = ACTIONS(10953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10951),
    [anon_sym_and] = ACTIONS(10951),
    [anon_sym_or] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE] = ACTIONS(10951),
    [anon_sym_AMP_AMP] = ACTIONS(10951),
    [anon_sym_LT_LT] = ACTIONS(10951),
    [anon_sym_GT_GT] = ACTIONS(10951),
    [anon_sym_EQ_EQ] = ACTIONS(10953),
    [anon_sym_BANG_EQ] = ACTIONS(10951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10951),
    [anon_sym_LT_EQ_GT] = ACTIONS(10951),
    [anon_sym_EQ_TILDE] = ACTIONS(10951),
    [anon_sym_BANG_TILDE] = ACTIONS(10951),
    [anon_sym_LT_EQ] = ACTIONS(10953),
    [anon_sym_GT] = ACTIONS(10953),
    [anon_sym_GT_EQ] = ACTIONS(10951),
    [anon_sym_CARET] = ACTIONS(10951),
    [anon_sym_PLUS] = ACTIONS(10951),
    [anon_sym_SLASH] = ACTIONS(10951),
    [anon_sym_PERCENT] = ACTIONS(10951),
    [sym_comment] = ACTIONS(87),
  },
  [5220] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5221] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8108),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [5222] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7626),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(7626),
    [sym_operator_assignment] = STATE(7626),
    [sym_conditional] = STATE(7626),
    [sym_range] = STATE(7626),
    [sym_binary] = STATE(7626),
    [sym_unary] = STATE(7626),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5223] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7627),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(7627),
    [sym_operator_assignment] = STATE(7627),
    [sym_conditional] = STATE(7627),
    [sym_range] = STATE(7627),
    [sym_binary] = STATE(7627),
    [sym_unary] = STATE(7627),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5224] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7628),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(7628),
    [sym_operator_assignment] = STATE(7628),
    [sym_conditional] = STATE(7628),
    [sym_range] = STATE(7628),
    [sym_binary] = STATE(7628),
    [sym_unary] = STATE(7628),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5225] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7629),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(7629),
    [sym_operator_assignment] = STATE(7629),
    [sym_conditional] = STATE(7629),
    [sym_range] = STATE(7629),
    [sym_binary] = STATE(7629),
    [sym_unary] = STATE(7629),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5226] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7630),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(7630),
    [sym_operator_assignment] = STATE(7630),
    [sym_conditional] = STATE(7630),
    [sym_range] = STATE(7630),
    [sym_binary] = STATE(7630),
    [sym_unary] = STATE(7630),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5227] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7631),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7631),
    [sym_operator_assignment] = STATE(7631),
    [sym_conditional] = STATE(7631),
    [sym_range] = STATE(7631),
    [sym_binary] = STATE(7631),
    [sym_unary] = STATE(7631),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5228] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7632),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(7632),
    [sym_operator_assignment] = STATE(7632),
    [sym_conditional] = STATE(7632),
    [sym_range] = STATE(7632),
    [sym_binary] = STATE(7632),
    [sym_unary] = STATE(7632),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5229] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7633),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(7633),
    [sym_operator_assignment] = STATE(7633),
    [sym_conditional] = STATE(7633),
    [sym_range] = STATE(7633),
    [sym_binary] = STATE(7633),
    [sym_unary] = STATE(7633),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5230] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7634),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(7634),
    [sym_operator_assignment] = STATE(7634),
    [sym_conditional] = STATE(7634),
    [sym_range] = STATE(7634),
    [sym_binary] = STATE(7634),
    [sym_unary] = STATE(7634),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5231] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7635),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(7635),
    [sym_operator_assignment] = STATE(7635),
    [sym_conditional] = STATE(7635),
    [sym_range] = STATE(7635),
    [sym_binary] = STATE(7635),
    [sym_unary] = STATE(7635),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5232] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7636),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_splat_argument] = STATE(7637),
    [sym_assignment] = STATE(7636),
    [sym_operator_assignment] = STATE(7636),
    [sym_conditional] = STATE(7636),
    [sym_range] = STATE(7636),
    [sym_binary] = STATE(7636),
    [sym_unary] = STATE(7636),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(7637),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5233] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7638),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(7638),
    [sym_operator_assignment] = STATE(7638),
    [sym_conditional] = STATE(7638),
    [sym_range] = STATE(7638),
    [sym_binary] = STATE(7638),
    [sym_unary] = STATE(7638),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5234] = {
    [sym_string] = STATE(7639),
    [aux_sym_chained_string_repeat1] = STATE(7639),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [5235] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8108),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [5236] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8108),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [5237] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5238] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [5239] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5240] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5241] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5242] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(10955),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5243] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5244] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5245] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5246] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5247] = {
    [sym_heredoc_body] = STATE(5247),
    [aux_sym_call_repeat1] = STATE(5247),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [5248] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1059),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(1059),
    [sym_operator_assignment] = STATE(1059),
    [sym_conditional] = STATE(1059),
    [sym_range] = STATE(1059),
    [sym_binary] = STATE(1059),
    [sym_unary] = STATE(1059),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1066),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(1887),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__identifier_hash_key] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8130),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1921),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5249] = {
    [sym_heredoc_body] = STATE(5247),
    [aux_sym_call_repeat1] = STATE(5247),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [5250] = {
    [aux_sym_argument_list_repeat1] = STATE(5250),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(10957),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [5251] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5252] = {
    [aux_sym_exceptions_repeat1] = STATE(7642),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [5253] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [5254] = {
    [sym_string] = STATE(5254),
    [aux_sym_chained_string_repeat1] = STATE(5254),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [5255] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(8140),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8142),
    [anon_sym_DOT_DOT] = ACTIONS(8144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8146),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8152),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ_GT] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_BANG_TILDE] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8140),
    [anon_sym_GT] = ACTIONS(8140),
    [anon_sym_GT_EQ] = ACTIONS(8154),
    [anon_sym_CARET] = ACTIONS(8156),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [5256] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5257] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(8140),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8142),
    [anon_sym_DOT_DOT] = ACTIONS(8144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8146),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8152),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ_GT] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_BANG_TILDE] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8140),
    [anon_sym_GT] = ACTIONS(8140),
    [anon_sym_GT_EQ] = ACTIONS(8154),
    [anon_sym_CARET] = ACTIONS(8156),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [5258] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7643),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(7643),
    [sym_operator_assignment] = STATE(7643),
    [sym_conditional] = STATE(7643),
    [sym_range] = STATE(7643),
    [sym_binary] = STATE(7643),
    [sym_unary] = STATE(7643),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5259] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7644),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(7644),
    [sym_operator_assignment] = STATE(7644),
    [sym_conditional] = STATE(7644),
    [sym_range] = STATE(7644),
    [sym_binary] = STATE(7644),
    [sym_unary] = STATE(7644),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5260] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7645),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(7645),
    [sym_operator_assignment] = STATE(7645),
    [sym_conditional] = STATE(7645),
    [sym_range] = STATE(7645),
    [sym_binary] = STATE(7645),
    [sym_unary] = STATE(7645),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5261] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7646),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(7646),
    [sym_operator_assignment] = STATE(7646),
    [sym_conditional] = STATE(7646),
    [sym_range] = STATE(7646),
    [sym_binary] = STATE(7646),
    [sym_unary] = STATE(7646),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5262] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7647),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(7647),
    [sym_operator_assignment] = STATE(7647),
    [sym_conditional] = STATE(7647),
    [sym_range] = STATE(7647),
    [sym_binary] = STATE(7647),
    [sym_unary] = STATE(7647),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5263] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7648),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7648),
    [sym_operator_assignment] = STATE(7648),
    [sym_conditional] = STATE(7648),
    [sym_range] = STATE(7648),
    [sym_binary] = STATE(7648),
    [sym_unary] = STATE(7648),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5264] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7649),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(7649),
    [sym_operator_assignment] = STATE(7649),
    [sym_conditional] = STATE(7649),
    [sym_range] = STATE(7649),
    [sym_binary] = STATE(7649),
    [sym_unary] = STATE(7649),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5265] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7650),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(7650),
    [sym_operator_assignment] = STATE(7650),
    [sym_conditional] = STATE(7650),
    [sym_range] = STATE(7650),
    [sym_binary] = STATE(7650),
    [sym_unary] = STATE(7650),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5266] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7651),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(7651),
    [sym_operator_assignment] = STATE(7651),
    [sym_conditional] = STATE(7651),
    [sym_range] = STATE(7651),
    [sym_binary] = STATE(7651),
    [sym_unary] = STATE(7651),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5267] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7652),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(7652),
    [sym_operator_assignment] = STATE(7652),
    [sym_conditional] = STATE(7652),
    [sym_range] = STATE(7652),
    [sym_binary] = STATE(7652),
    [sym_unary] = STATE(7652),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5268] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2818),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(2818),
    [sym_operator_assignment] = STATE(2818),
    [sym_conditional] = STATE(2818),
    [sym_range] = STATE(2818),
    [sym_binary] = STATE(2818),
    [sym_unary] = STATE(2818),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4626),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5269] = {
    [aux_sym_exceptions_repeat1] = STATE(7653),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(8158),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [5270] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2818),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_splat_argument] = STATE(7654),
    [sym_assignment] = STATE(2818),
    [sym_operator_assignment] = STATE(2818),
    [sym_conditional] = STATE(2818),
    [sym_range] = STATE(2818),
    [sym_binary] = STATE(2818),
    [sym_unary] = STATE(2818),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7654),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4626),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5271] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7655),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(7655),
    [sym_operator_assignment] = STATE(7655),
    [sym_conditional] = STATE(7655),
    [sym_range] = STATE(7655),
    [sym_binary] = STATE(7655),
    [sym_unary] = STATE(7655),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5272] = {
    [sym__line_break] = ACTIONS(10960),
    [sym__heredoc_body_start] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10960),
    [ts_builtin_sym_end] = ACTIONS(10960),
    [anon_sym___END__] = ACTIONS(10960),
    [anon_sym_LBRACE] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10960),
    [anon_sym_RPAREN] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_when] = ACTIONS(10960),
    [anon_sym_elsif] = ACTIONS(10960),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_then] = ACTIONS(10960),
    [anon_sym_ensure] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10960),
    [anon_sym_COLON_COLON2] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_EQ_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10962),
    [anon_sym_GT] = ACTIONS(10962),
    [anon_sym_GT_EQ] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_SLASH] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_comment] = ACTIONS(87),
  },
  [5273] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5274] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7656),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7656),
    [sym_operator_assignment] = STATE(7656),
    [sym_conditional] = STATE(7656),
    [sym_range] = STATE(7656),
    [sym_binary] = STATE(7656),
    [sym_unary] = STATE(7656),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5275] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7657),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7657),
    [sym_operator_assignment] = STATE(7657),
    [sym_conditional] = STATE(7657),
    [sym_range] = STATE(7657),
    [sym_binary] = STATE(7657),
    [sym_unary] = STATE(7657),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5276] = {
    [anon_sym_COLON] = ACTIONS(10964),
    [sym_comment] = ACTIONS(87),
  },
  [5277] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7659),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7659),
    [sym_operator_assignment] = STATE(7659),
    [sym_conditional] = STATE(7659),
    [sym_range] = STATE(7659),
    [sym_binary] = STATE(7659),
    [sym_unary] = STATE(7659),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5278] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5279] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(10964),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5280] = {
    [sym_heredoc_body] = STATE(7661),
    [aux_sym_call_repeat1] = STATE(7661),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_in] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5281] = {
    [sym_heredoc_body] = STATE(7661),
    [aux_sym_call_repeat1] = STATE(7661),
    [aux_sym_argument_list_repeat1] = STATE(7663),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10968),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_in] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5282] = {
    [sym_string] = STATE(2887),
    [aux_sym_chained_string_repeat1] = STATE(2887),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5283] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [5284] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7664),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7664),
    [sym_operator_assignment] = STATE(7664),
    [sym_conditional] = STATE(7664),
    [sym_range] = STATE(7664),
    [sym_binary] = STATE(7664),
    [sym_unary] = STATE(7664),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5285] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7665),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7665),
    [sym_operator_assignment] = STATE(7665),
    [sym_conditional] = STATE(7665),
    [sym_range] = STATE(7665),
    [sym_binary] = STATE(7665),
    [sym_unary] = STATE(7665),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5286] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7666),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7666),
    [sym_operator_assignment] = STATE(7666),
    [sym_conditional] = STATE(7666),
    [sym_range] = STATE(7666),
    [sym_binary] = STATE(7666),
    [sym_unary] = STATE(7666),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5287] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7667),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7667),
    [sym_operator_assignment] = STATE(7667),
    [sym_conditional] = STATE(7667),
    [sym_range] = STATE(7667),
    [sym_binary] = STATE(7667),
    [sym_unary] = STATE(7667),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5288] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7668),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7668),
    [sym_operator_assignment] = STATE(7668),
    [sym_conditional] = STATE(7668),
    [sym_range] = STATE(7668),
    [sym_binary] = STATE(7668),
    [sym_unary] = STATE(7668),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5289] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7669),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7669),
    [sym_operator_assignment] = STATE(7669),
    [sym_conditional] = STATE(7669),
    [sym_range] = STATE(7669),
    [sym_binary] = STATE(7669),
    [sym_unary] = STATE(7669),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5290] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7670),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7670),
    [sym_operator_assignment] = STATE(7670),
    [sym_conditional] = STATE(7670),
    [sym_range] = STATE(7670),
    [sym_binary] = STATE(7670),
    [sym_unary] = STATE(7670),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5291] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7671),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7671),
    [sym_operator_assignment] = STATE(7671),
    [sym_conditional] = STATE(7671),
    [sym_range] = STATE(7671),
    [sym_binary] = STATE(7671),
    [sym_unary] = STATE(7671),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5292] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7672),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7672),
    [sym_operator_assignment] = STATE(7672),
    [sym_conditional] = STATE(7672),
    [sym_range] = STATE(7672),
    [sym_binary] = STATE(7672),
    [sym_unary] = STATE(7672),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5293] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7673),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7673),
    [sym_operator_assignment] = STATE(7673),
    [sym_conditional] = STATE(7673),
    [sym_range] = STATE(7673),
    [sym_binary] = STATE(7673),
    [sym_unary] = STATE(7673),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5294] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(7681),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(7681),
    [sym_operator_assignment] = STATE(7681),
    [sym_conditional] = STATE(7681),
    [sym_range] = STATE(7681),
    [sym_binary] = STATE(7681),
    [sym_unary] = STATE(7681),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [5295] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(7685),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(7685),
    [sym_operator_assignment] = STATE(7685),
    [sym_conditional] = STATE(7685),
    [sym_range] = STATE(7685),
    [sym_binary] = STATE(7685),
    [sym_unary] = STATE(7685),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [5296] = {
    [anon_sym_COLON] = ACTIONS(10990),
    [sym_comment] = ACTIONS(87),
  },
  [5297] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(7687),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(7687),
    [sym_operator_assignment] = STATE(7687),
    [sym_conditional] = STATE(7687),
    [sym_range] = STATE(7687),
    [sym_binary] = STATE(7687),
    [sym_unary] = STATE(7687),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [5298] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(10992),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5299] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(10990),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [5300] = {
    [sym_heredoc_body] = STATE(7689),
    [aux_sym_call_repeat1] = STATE(7689),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_in] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5301] = {
    [sym_heredoc_body] = STATE(7689),
    [aux_sym_call_repeat1] = STATE(7689),
    [aux_sym_argument_list_repeat1] = STATE(7691),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10994),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_in] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5302] = {
    [sym_string] = STATE(5349),
    [aux_sym_chained_string_repeat1] = STATE(5349),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10996),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5303] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7692),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_splat_argument] = STATE(7693),
    [sym_assignment] = STATE(7692),
    [sym_operator_assignment] = STATE(7692),
    [sym_conditional] = STATE(7692),
    [sym_range] = STATE(7692),
    [sym_binary] = STATE(7692),
    [sym_unary] = STATE(7692),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(7693),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(8174),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5304] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7694),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(7694),
    [sym_operator_assignment] = STATE(7694),
    [sym_conditional] = STATE(7694),
    [sym_range] = STATE(7694),
    [sym_binary] = STATE(7694),
    [sym_unary] = STATE(7694),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5305] = {
    [sym_string] = STATE(7695),
    [aux_sym_chained_string_repeat1] = STATE(7695),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_in] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [5306] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(8196),
    [anon_sym_or] = ACTIONS(8196),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [5307] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5308] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5309] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(7696),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(7696),
    [sym_operator_assignment] = STATE(7696),
    [sym_conditional] = STATE(7696),
    [sym_range] = STATE(7696),
    [sym_binary] = STATE(7696),
    [sym_unary] = STATE(7696),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5310] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5311] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(7697),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(7697),
    [sym_operator_assignment] = STATE(7697),
    [sym_conditional] = STATE(7697),
    [sym_range] = STATE(7697),
    [sym_binary] = STATE(7697),
    [sym_unary] = STATE(7697),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5312] = {
    [sym_heredoc_body] = STATE(7698),
    [aux_sym_call_repeat1] = STATE(7698),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5313] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2848),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(2848),
    [sym_operator_assignment] = STATE(2848),
    [sym_conditional] = STATE(2848),
    [sym_range] = STATE(2848),
    [sym_binary] = STATE(2848),
    [sym_unary] = STATE(2848),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2851),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(7699),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4664),
    [sym__splat_star] = ACTIONS(4666),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__identifier_hash_key] = ACTIONS(4668),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10998),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(4672),
    [sym_identifier] = ACTIONS(4672),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5314] = {
    [sym_heredoc_body] = STATE(7700),
    [aux_sym_call_repeat1] = STATE(7700),
    [aux_sym_argument_list_repeat1] = STATE(7701),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8226),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5315] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(8196),
    [anon_sym_or] = ACTIONS(8196),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [5316] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5317] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [5318] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5319] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5320] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5321] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11000),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5322] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5323] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5324] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5325] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5326] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [5327] = {
    [sym_string] = STATE(5349),
    [aux_sym_chained_string_repeat1] = STATE(5349),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5328] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [5329] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5330] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7703),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7703),
    [sym_operator_assignment] = STATE(7703),
    [sym_conditional] = STATE(7703),
    [sym_range] = STATE(7703),
    [sym_binary] = STATE(7703),
    [sym_unary] = STATE(7703),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5331] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [5332] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [5333] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7704),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7704),
    [sym_operator_assignment] = STATE(7704),
    [sym_conditional] = STATE(7704),
    [sym_range] = STATE(7704),
    [sym_binary] = STATE(7704),
    [sym_unary] = STATE(7704),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5334] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7705),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7705),
    [sym_operator_assignment] = STATE(7705),
    [sym_conditional] = STATE(7705),
    [sym_range] = STATE(7705),
    [sym_binary] = STATE(7705),
    [sym_unary] = STATE(7705),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5335] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7706),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7706),
    [sym_operator_assignment] = STATE(7706),
    [sym_conditional] = STATE(7706),
    [sym_range] = STATE(7706),
    [sym_binary] = STATE(7706),
    [sym_unary] = STATE(7706),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5336] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7707),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7707),
    [sym_operator_assignment] = STATE(7707),
    [sym_conditional] = STATE(7707),
    [sym_range] = STATE(7707),
    [sym_binary] = STATE(7707),
    [sym_unary] = STATE(7707),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5337] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7708),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7708),
    [sym_operator_assignment] = STATE(7708),
    [sym_conditional] = STATE(7708),
    [sym_range] = STATE(7708),
    [sym_binary] = STATE(7708),
    [sym_unary] = STATE(7708),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5338] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7709),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7709),
    [sym_operator_assignment] = STATE(7709),
    [sym_conditional] = STATE(7709),
    [sym_range] = STATE(7709),
    [sym_binary] = STATE(7709),
    [sym_unary] = STATE(7709),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5339] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7710),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7710),
    [sym_operator_assignment] = STATE(7710),
    [sym_conditional] = STATE(7710),
    [sym_range] = STATE(7710),
    [sym_binary] = STATE(7710),
    [sym_unary] = STATE(7710),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5340] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7711),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7711),
    [sym_operator_assignment] = STATE(7711),
    [sym_conditional] = STATE(7711),
    [sym_range] = STATE(7711),
    [sym_binary] = STATE(7711),
    [sym_unary] = STATE(7711),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5341] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7712),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7712),
    [sym_operator_assignment] = STATE(7712),
    [sym_conditional] = STATE(7712),
    [sym_range] = STATE(7712),
    [sym_binary] = STATE(7712),
    [sym_unary] = STATE(7712),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5342] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7713),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7713),
    [sym_operator_assignment] = STATE(7713),
    [sym_conditional] = STATE(7713),
    [sym_range] = STATE(7713),
    [sym_binary] = STATE(7713),
    [sym_unary] = STATE(7713),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5343] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7714),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7714),
    [sym_operator_assignment] = STATE(7714),
    [sym_conditional] = STATE(7714),
    [sym_range] = STATE(7714),
    [sym_binary] = STATE(7714),
    [sym_unary] = STATE(7714),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5344] = {
    [sym_heredoc_body] = STATE(7715),
    [aux_sym_call_repeat1] = STATE(7715),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5345] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2876),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym__argument] = STATE(4285),
    [sym_splat_argument] = STATE(4285),
    [sym_hash_splat_argument] = STATE(4285),
    [sym_block_argument] = STATE(4285),
    [sym_assignment] = STATE(2876),
    [sym_operator_assignment] = STATE(2876),
    [sym_conditional] = STATE(2876),
    [sym_range] = STATE(2876),
    [sym_binary] = STATE(2876),
    [sym_unary] = STATE(2876),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2881),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(7716),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4285),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4704),
    [sym__splat_star] = ACTIONS(4706),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__identifier_hash_key] = ACTIONS(4710),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11002),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(4728),
    [sym_identifier] = ACTIONS(4728),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5346] = {
    [sym_heredoc_body] = STATE(7717),
    [aux_sym_call_repeat1] = STATE(7717),
    [aux_sym_argument_list_repeat1] = STATE(7718),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8264),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5347] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7719),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_splat_argument] = STATE(7720),
    [sym_assignment] = STATE(7719),
    [sym_operator_assignment] = STATE(7719),
    [sym_conditional] = STATE(7719),
    [sym_range] = STATE(7719),
    [sym_binary] = STATE(7719),
    [sym_unary] = STATE(7719),
    [sym_right_assignment_list] = STATE(4290),
    [sym__arg_or_splat_arg] = STATE(7720),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(4706),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5348] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7721),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(7721),
    [sym_operator_assignment] = STATE(7721),
    [sym_conditional] = STATE(7721),
    [sym_range] = STATE(7721),
    [sym_binary] = STATE(7721),
    [sym_unary] = STATE(7721),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5349] = {
    [sym_string] = STATE(7722),
    [aux_sym_chained_string_repeat1] = STATE(7722),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_in] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [5350] = {
    [sym_heredoc_body] = STATE(5350),
    [aux_sym_call_repeat1] = STATE(5350),
    [sym__heredoc_body_start] = ACTIONS(10413),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7646),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_in] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [5351] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1083),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym__argument] = STATE(7107),
    [sym_splat_argument] = STATE(7107),
    [sym_hash_splat_argument] = STATE(7107),
    [sym_block_argument] = STATE(7107),
    [sym_assignment] = STATE(1083),
    [sym_operator_assignment] = STATE(1083),
    [sym_conditional] = STATE(1083),
    [sym_range] = STATE(1083),
    [sym_binary] = STATE(1083),
    [sym_unary] = STATE(1083),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1089),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(7107),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1937),
    [sym__splat_star] = ACTIONS(1939),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__identifier_hash_key] = ACTIONS(1943),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1963),
    [sym_identifier] = ACTIONS(1963),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5352] = {
    [sym_heredoc_body] = STATE(5350),
    [aux_sym_call_repeat1] = STATE(5350),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7661),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_in] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [5353] = {
    [aux_sym_argument_list_repeat1] = STATE(5353),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7657),
    [anon_sym_COMMA] = ACTIONS(11004),
    [anon_sym_in] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [5354] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5355] = {
    [aux_sym_exceptions_repeat1] = STATE(7724),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_in] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [5356] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [5357] = {
    [sym_string] = STATE(5357),
    [aux_sym_chained_string_repeat1] = STATE(5357),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_in] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [5358] = {
    [sym__line_break] = ACTIONS(11007),
    [sym__heredoc_body_start] = ACTIONS(11007),
    [sym__binary_minus] = ACTIONS(11007),
    [sym__binary_star] = ACTIONS(11007),
    [ts_builtin_sym_end] = ACTIONS(11007),
    [anon_sym___END__] = ACTIONS(11007),
    [anon_sym_LBRACE] = ACTIONS(11007),
    [anon_sym_RBRACE] = ACTIONS(11007),
    [anon_sym_RPAREN] = ACTIONS(11007),
    [anon_sym_DOT] = ACTIONS(11009),
    [anon_sym_COMMA] = ACTIONS(11007),
    [anon_sym_PIPE] = ACTIONS(11009),
    [anon_sym_SEMI] = ACTIONS(11007),
    [anon_sym_STAR_STAR] = ACTIONS(11007),
    [anon_sym_AMP] = ACTIONS(11009),
    [anon_sym_LT] = ACTIONS(11009),
    [anon_sym_end] = ACTIONS(11007),
    [anon_sym_if] = ACTIONS(11007),
    [anon_sym_unless] = ACTIONS(11007),
    [anon_sym_while] = ACTIONS(11007),
    [anon_sym_until] = ACTIONS(11007),
    [anon_sym_rescue] = ACTIONS(11007),
    [anon_sym_do] = ACTIONS(11007),
    [anon_sym_when] = ACTIONS(11007),
    [anon_sym_elsif] = ACTIONS(11007),
    [anon_sym_else] = ACTIONS(11007),
    [anon_sym_then] = ACTIONS(11007),
    [anon_sym_ensure] = ACTIONS(11007),
    [anon_sym_EQ_GT] = ACTIONS(11007),
    [anon_sym_LBRACK] = ACTIONS(11007),
    [anon_sym_COLON_COLON2] = ACTIONS(11007),
    [anon_sym_AMP_DOT] = ACTIONS(11007),
    [anon_sym_QMARK] = ACTIONS(11007),
    [anon_sym_DOT_DOT] = ACTIONS(11009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11007),
    [anon_sym_and] = ACTIONS(11007),
    [anon_sym_or] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE] = ACTIONS(11007),
    [anon_sym_AMP_AMP] = ACTIONS(11007),
    [anon_sym_LT_LT] = ACTIONS(11007),
    [anon_sym_GT_GT] = ACTIONS(11007),
    [anon_sym_EQ_EQ] = ACTIONS(11009),
    [anon_sym_BANG_EQ] = ACTIONS(11007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11007),
    [anon_sym_LT_EQ_GT] = ACTIONS(11007),
    [anon_sym_EQ_TILDE] = ACTIONS(11007),
    [anon_sym_BANG_TILDE] = ACTIONS(11007),
    [anon_sym_LT_EQ] = ACTIONS(11009),
    [anon_sym_GT] = ACTIONS(11009),
    [anon_sym_GT_EQ] = ACTIONS(11007),
    [anon_sym_CARET] = ACTIONS(11007),
    [anon_sym_PLUS] = ACTIONS(11007),
    [anon_sym_SLASH] = ACTIONS(11007),
    [anon_sym_PERCENT] = ACTIONS(11007),
    [sym_comment] = ACTIONS(87),
  },
  [5359] = {
    [anon_sym_end] = ACTIONS(11011),
    [sym_comment] = ACTIONS(87),
  },
  [5360] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5361] = {
    [sym_heredoc_body] = STATE(7726),
    [aux_sym_call_repeat1] = STATE(7726),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5362] = {
    [sym_heredoc_body] = STATE(7726),
    [aux_sym_call_repeat1] = STATE(7726),
    [aux_sym_argument_list_repeat1] = STATE(7727),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4802),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5363] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8288),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [5364] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7728),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(7728),
    [sym_operator_assignment] = STATE(7728),
    [sym_conditional] = STATE(7728),
    [sym_range] = STATE(7728),
    [sym_binary] = STATE(7728),
    [sym_unary] = STATE(7728),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5365] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7729),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(7729),
    [sym_operator_assignment] = STATE(7729),
    [sym_conditional] = STATE(7729),
    [sym_range] = STATE(7729),
    [sym_binary] = STATE(7729),
    [sym_unary] = STATE(7729),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5366] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7730),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(7730),
    [sym_operator_assignment] = STATE(7730),
    [sym_conditional] = STATE(7730),
    [sym_range] = STATE(7730),
    [sym_binary] = STATE(7730),
    [sym_unary] = STATE(7730),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5367] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7731),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(7731),
    [sym_operator_assignment] = STATE(7731),
    [sym_conditional] = STATE(7731),
    [sym_range] = STATE(7731),
    [sym_binary] = STATE(7731),
    [sym_unary] = STATE(7731),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5368] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7732),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(7732),
    [sym_operator_assignment] = STATE(7732),
    [sym_conditional] = STATE(7732),
    [sym_range] = STATE(7732),
    [sym_binary] = STATE(7732),
    [sym_unary] = STATE(7732),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5369] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7733),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7733),
    [sym_operator_assignment] = STATE(7733),
    [sym_conditional] = STATE(7733),
    [sym_range] = STATE(7733),
    [sym_binary] = STATE(7733),
    [sym_unary] = STATE(7733),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5370] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7734),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(7734),
    [sym_operator_assignment] = STATE(7734),
    [sym_conditional] = STATE(7734),
    [sym_range] = STATE(7734),
    [sym_binary] = STATE(7734),
    [sym_unary] = STATE(7734),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5371] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7735),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(7735),
    [sym_operator_assignment] = STATE(7735),
    [sym_conditional] = STATE(7735),
    [sym_range] = STATE(7735),
    [sym_binary] = STATE(7735),
    [sym_unary] = STATE(7735),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5372] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7736),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(7736),
    [sym_operator_assignment] = STATE(7736),
    [sym_conditional] = STATE(7736),
    [sym_range] = STATE(7736),
    [sym_binary] = STATE(7736),
    [sym_unary] = STATE(7736),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5373] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7737),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(7737),
    [sym_operator_assignment] = STATE(7737),
    [sym_conditional] = STATE(7737),
    [sym_range] = STATE(7737),
    [sym_binary] = STATE(7737),
    [sym_unary] = STATE(7737),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5374] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7738),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_splat_argument] = STATE(7739),
    [sym_assignment] = STATE(7738),
    [sym_operator_assignment] = STATE(7738),
    [sym_conditional] = STATE(7738),
    [sym_range] = STATE(7738),
    [sym_binary] = STATE(7738),
    [sym_unary] = STATE(7738),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(7739),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5375] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7740),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(7740),
    [sym_operator_assignment] = STATE(7740),
    [sym_conditional] = STATE(7740),
    [sym_range] = STATE(7740),
    [sym_binary] = STATE(7740),
    [sym_unary] = STATE(7740),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5376] = {
    [sym_string] = STATE(7741),
    [aux_sym_chained_string_repeat1] = STATE(7741),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [5377] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8288),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [5378] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5379] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5380] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7742),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(7742),
    [sym_operator_assignment] = STATE(7742),
    [sym_conditional] = STATE(7742),
    [sym_range] = STATE(7742),
    [sym_binary] = STATE(7742),
    [sym_unary] = STATE(7742),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5381] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5382] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7743),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(7743),
    [sym_operator_assignment] = STATE(7743),
    [sym_conditional] = STATE(7743),
    [sym_range] = STATE(7743),
    [sym_binary] = STATE(7743),
    [sym_unary] = STATE(7743),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5383] = {
    [sym_heredoc_body] = STATE(7744),
    [aux_sym_call_repeat1] = STATE(7744),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5384] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2911),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(2911),
    [sym_operator_assignment] = STATE(2911),
    [sym_conditional] = STATE(2911),
    [sym_range] = STATE(2911),
    [sym_binary] = STATE(2911),
    [sym_unary] = STATE(2911),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7745),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4766),
    [sym__splat_star] = ACTIONS(4768),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__identifier_hash_key] = ACTIONS(4770),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11013),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(4772),
    [sym_identifier] = ACTIONS(4772),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5385] = {
    [sym_heredoc_body] = STATE(7746),
    [aux_sym_call_repeat1] = STATE(7746),
    [aux_sym_argument_list_repeat1] = STATE(7747),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8314),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5386] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8288),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [5387] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5388] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [5389] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5390] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5391] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5392] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11015),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5393] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5394] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5395] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5396] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5397] = {
    [sym_heredoc_body] = STATE(5397),
    [aux_sym_call_repeat1] = STATE(5397),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [5398] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1112),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(1973),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__identifier_hash_key] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8318),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1997),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5399] = {
    [sym_heredoc_body] = STATE(5397),
    [aux_sym_call_repeat1] = STATE(5397),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [5400] = {
    [aux_sym_argument_list_repeat1] = STATE(5400),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(11017),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [5401] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5402] = {
    [aux_sym_exceptions_repeat1] = STATE(7750),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [5403] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [5404] = {
    [sym_string] = STATE(5404),
    [aux_sym_chained_string_repeat1] = STATE(5404),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [5405] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7751),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(7751),
    [sym_operator_assignment] = STATE(7751),
    [sym_conditional] = STATE(7751),
    [sym_range] = STATE(7751),
    [sym_binary] = STATE(7751),
    [sym_unary] = STATE(7751),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5406] = {
    [sym__line_break] = ACTIONS(11020),
    [sym__heredoc_body_start] = ACTIONS(11020),
    [sym__binary_minus] = ACTIONS(11020),
    [sym__binary_star] = ACTIONS(11020),
    [ts_builtin_sym_end] = ACTIONS(11020),
    [anon_sym___END__] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_RBRACE] = ACTIONS(11020),
    [anon_sym_RPAREN] = ACTIONS(11020),
    [anon_sym_DOT] = ACTIONS(11022),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_PIPE] = ACTIONS(11022),
    [anon_sym_SEMI] = ACTIONS(11020),
    [anon_sym_STAR_STAR] = ACTIONS(11020),
    [anon_sym_AMP] = ACTIONS(11022),
    [anon_sym_LT] = ACTIONS(11022),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_unless] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [anon_sym_until] = ACTIONS(11020),
    [anon_sym_rescue] = ACTIONS(11020),
    [anon_sym_do] = ACTIONS(11020),
    [anon_sym_when] = ACTIONS(11020),
    [anon_sym_elsif] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_then] = ACTIONS(11020),
    [anon_sym_ensure] = ACTIONS(11020),
    [anon_sym_EQ_GT] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_COLON_COLON2] = ACTIONS(11020),
    [anon_sym_AMP_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_DOT_DOT] = ACTIONS(11022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_and] = ACTIONS(11020),
    [anon_sym_or] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE] = ACTIONS(11020),
    [anon_sym_AMP_AMP] = ACTIONS(11020),
    [anon_sym_LT_LT] = ACTIONS(11020),
    [anon_sym_GT_GT] = ACTIONS(11020),
    [anon_sym_EQ_EQ] = ACTIONS(11022),
    [anon_sym_BANG_EQ] = ACTIONS(11020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11020),
    [anon_sym_LT_EQ_GT] = ACTIONS(11020),
    [anon_sym_EQ_TILDE] = ACTIONS(11020),
    [anon_sym_BANG_TILDE] = ACTIONS(11020),
    [anon_sym_LT_EQ] = ACTIONS(11022),
    [anon_sym_GT] = ACTIONS(11022),
    [anon_sym_GT_EQ] = ACTIONS(11020),
    [anon_sym_CARET] = ACTIONS(11020),
    [anon_sym_PLUS] = ACTIONS(11020),
    [anon_sym_SLASH] = ACTIONS(11020),
    [anon_sym_PERCENT] = ACTIONS(11020),
    [sym_comment] = ACTIONS(87),
  },
  [5407] = {
    [anon_sym_end] = ACTIONS(11024),
    [sym_comment] = ACTIONS(87),
  },
  [5408] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(8332),
    [anon_sym_QMARK] = ACTIONS(8334),
    [anon_sym_DOT_DOT] = ACTIONS(8336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8338),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ_GT] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_BANG_TILDE] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8332),
    [anon_sym_GT] = ACTIONS(8332),
    [anon_sym_GT_EQ] = ACTIONS(8346),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [5409] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5410] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(8332),
    [anon_sym_QMARK] = ACTIONS(8334),
    [anon_sym_DOT_DOT] = ACTIONS(8336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8338),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ_GT] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_BANG_TILDE] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8332),
    [anon_sym_GT] = ACTIONS(8332),
    [anon_sym_GT_EQ] = ACTIONS(8346),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [5411] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7753),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(7753),
    [sym_operator_assignment] = STATE(7753),
    [sym_conditional] = STATE(7753),
    [sym_range] = STATE(7753),
    [sym_binary] = STATE(7753),
    [sym_unary] = STATE(7753),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5412] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7754),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(7754),
    [sym_operator_assignment] = STATE(7754),
    [sym_conditional] = STATE(7754),
    [sym_range] = STATE(7754),
    [sym_binary] = STATE(7754),
    [sym_unary] = STATE(7754),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5413] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7755),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(7755),
    [sym_operator_assignment] = STATE(7755),
    [sym_conditional] = STATE(7755),
    [sym_range] = STATE(7755),
    [sym_binary] = STATE(7755),
    [sym_unary] = STATE(7755),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5414] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7756),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(7756),
    [sym_operator_assignment] = STATE(7756),
    [sym_conditional] = STATE(7756),
    [sym_range] = STATE(7756),
    [sym_binary] = STATE(7756),
    [sym_unary] = STATE(7756),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5415] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7757),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(7757),
    [sym_operator_assignment] = STATE(7757),
    [sym_conditional] = STATE(7757),
    [sym_range] = STATE(7757),
    [sym_binary] = STATE(7757),
    [sym_unary] = STATE(7757),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5416] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7758),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7758),
    [sym_operator_assignment] = STATE(7758),
    [sym_conditional] = STATE(7758),
    [sym_range] = STATE(7758),
    [sym_binary] = STATE(7758),
    [sym_unary] = STATE(7758),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5417] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7759),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(7759),
    [sym_operator_assignment] = STATE(7759),
    [sym_conditional] = STATE(7759),
    [sym_range] = STATE(7759),
    [sym_binary] = STATE(7759),
    [sym_unary] = STATE(7759),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5418] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7760),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(7760),
    [sym_operator_assignment] = STATE(7760),
    [sym_conditional] = STATE(7760),
    [sym_range] = STATE(7760),
    [sym_binary] = STATE(7760),
    [sym_unary] = STATE(7760),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5419] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7761),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(7761),
    [sym_operator_assignment] = STATE(7761),
    [sym_conditional] = STATE(7761),
    [sym_range] = STATE(7761),
    [sym_binary] = STATE(7761),
    [sym_unary] = STATE(7761),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5420] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7762),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(7762),
    [sym_operator_assignment] = STATE(7762),
    [sym_conditional] = STATE(7762),
    [sym_range] = STATE(7762),
    [sym_binary] = STATE(7762),
    [sym_unary] = STATE(7762),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5421] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2949),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(2949),
    [sym_operator_assignment] = STATE(2949),
    [sym_conditional] = STATE(2949),
    [sym_range] = STATE(2949),
    [sym_binary] = STATE(2949),
    [sym_unary] = STATE(2949),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4814),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5422] = {
    [aux_sym_exceptions_repeat1] = STATE(7763),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(8350),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [5423] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2949),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_splat_argument] = STATE(7764),
    [sym_assignment] = STATE(2949),
    [sym_operator_assignment] = STATE(2949),
    [sym_conditional] = STATE(2949),
    [sym_range] = STATE(2949),
    [sym_binary] = STATE(2949),
    [sym_unary] = STATE(2949),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7764),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4814),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5424] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7765),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(7765),
    [sym_operator_assignment] = STATE(7765),
    [sym_conditional] = STATE(7765),
    [sym_range] = STATE(7765),
    [sym_binary] = STATE(7765),
    [sym_unary] = STATE(7765),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5425] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(8380),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8382),
    [anon_sym_DOT_DOT] = ACTIONS(8384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8386),
    [anon_sym_and] = ACTIONS(8388),
    [anon_sym_or] = ACTIONS(8388),
    [anon_sym_PIPE_PIPE] = ACTIONS(8390),
    [anon_sym_AMP_AMP] = ACTIONS(8390),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(8394),
    [anon_sym_BANG_EQ] = ACTIONS(8390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8390),
    [anon_sym_LT_EQ_GT] = ACTIONS(8390),
    [anon_sym_EQ_TILDE] = ACTIONS(8390),
    [anon_sym_BANG_TILDE] = ACTIONS(8390),
    [anon_sym_LT_EQ] = ACTIONS(8380),
    [anon_sym_GT] = ACTIONS(8380),
    [anon_sym_GT_EQ] = ACTIONS(8396),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [5426] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5427] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7769),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(7769),
    [sym_operator_assignment] = STATE(7769),
    [sym_conditional] = STATE(7769),
    [sym_range] = STATE(7769),
    [sym_binary] = STATE(7769),
    [sym_unary] = STATE(7769),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5428] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7772),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(7772),
    [sym_operator_assignment] = STATE(7772),
    [sym_conditional] = STATE(7772),
    [sym_range] = STATE(7772),
    [sym_binary] = STATE(7772),
    [sym_unary] = STATE(7772),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5429] = {
    [anon_sym_COLON] = ACTIONS(11036),
    [sym_comment] = ACTIONS(87),
  },
  [5430] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7774),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(7774),
    [sym_operator_assignment] = STATE(7774),
    [sym_conditional] = STATE(7774),
    [sym_range] = STATE(7774),
    [sym_binary] = STATE(7774),
    [sym_unary] = STATE(7774),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5431] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11038),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5432] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(11036),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [5433] = {
    [sym_heredoc_body] = STATE(7776),
    [aux_sym_call_repeat1] = STATE(7776),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5434] = {
    [sym_heredoc_body] = STATE(7776),
    [aux_sym_call_repeat1] = STATE(7776),
    [aux_sym_argument_list_repeat1] = STATE(7778),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(11040),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5435] = {
    [sym_string] = STATE(3085),
    [aux_sym_chained_string_repeat1] = STATE(3085),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11042),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5436] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(8380),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8382),
    [anon_sym_DOT_DOT] = ACTIONS(8384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8386),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8390),
    [anon_sym_AMP_AMP] = ACTIONS(8390),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(8394),
    [anon_sym_BANG_EQ] = ACTIONS(8390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8390),
    [anon_sym_LT_EQ_GT] = ACTIONS(8390),
    [anon_sym_EQ_TILDE] = ACTIONS(8390),
    [anon_sym_BANG_TILDE] = ACTIONS(8390),
    [anon_sym_LT_EQ] = ACTIONS(8380),
    [anon_sym_GT] = ACTIONS(8380),
    [anon_sym_GT_EQ] = ACTIONS(8396),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [5437] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_pattern] = STATE(7779),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2964),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_splat_argument] = STATE(2966),
    [sym_assignment] = STATE(2964),
    [sym_operator_assignment] = STATE(2964),
    [sym_conditional] = STATE(2964),
    [sym_range] = STATE(2964),
    [sym_binary] = STATE(2964),
    [sym_unary] = STATE(2964),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(4826),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5438] = {
    [sym__statements] = STATE(7788),
    [sym__top_level_statement] = STATE(7789),
    [sym_begin_block] = STATE(7789),
    [sym_end_block] = STATE(7789),
    [sym__statement] = STATE(7790),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(7790),
    [sym_unless_modifier] = STATE(7790),
    [sym_while_modifier] = STATE(7790),
    [sym_until_modifier] = STATE(7790),
    [sym_rescue_modifier] = STATE(7790),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_when] = STATE(7791),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(7791),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7792),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(7792),
    [sym_operator_assignment] = STATE(7792),
    [sym_conditional] = STATE(7792),
    [sym_range] = STATE(7792),
    [sym_binary] = STATE(7792),
    [sym_unary] = STATE(7792),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_undef] = STATE(7790),
    [sym_alias] = STATE(7790),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(7790),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11046),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(11056),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [anon_sym_undef] = ACTIONS(11070),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5439] = {
    [sym__then] = STATE(7797),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [aux_sym_when_repeat1] = STATE(7798),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(8366),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_then] = ACTIONS(11072),
    [sym_comment] = ACTIONS(87),
  },
  [5440] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7799),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7799),
    [sym_operator_assignment] = STATE(7799),
    [sym_conditional] = STATE(7799),
    [sym_range] = STATE(7799),
    [sym_binary] = STATE(7799),
    [sym_unary] = STATE(7799),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5441] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7800),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7800),
    [sym_operator_assignment] = STATE(7800),
    [sym_conditional] = STATE(7800),
    [sym_range] = STATE(7800),
    [sym_binary] = STATE(7800),
    [sym_unary] = STATE(7800),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5442] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7801),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7801),
    [sym_operator_assignment] = STATE(7801),
    [sym_conditional] = STATE(7801),
    [sym_range] = STATE(7801),
    [sym_binary] = STATE(7801),
    [sym_unary] = STATE(7801),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5443] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7802),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7802),
    [sym_operator_assignment] = STATE(7802),
    [sym_conditional] = STATE(7802),
    [sym_range] = STATE(7802),
    [sym_binary] = STATE(7802),
    [sym_unary] = STATE(7802),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5444] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7803),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7803),
    [sym_operator_assignment] = STATE(7803),
    [sym_conditional] = STATE(7803),
    [sym_range] = STATE(7803),
    [sym_binary] = STATE(7803),
    [sym_unary] = STATE(7803),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5445] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7804),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7804),
    [sym_operator_assignment] = STATE(7804),
    [sym_conditional] = STATE(7804),
    [sym_range] = STATE(7804),
    [sym_binary] = STATE(7804),
    [sym_unary] = STATE(7804),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5446] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7805),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7805),
    [sym_operator_assignment] = STATE(7805),
    [sym_conditional] = STATE(7805),
    [sym_range] = STATE(7805),
    [sym_binary] = STATE(7805),
    [sym_unary] = STATE(7805),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5447] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7806),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7806),
    [sym_operator_assignment] = STATE(7806),
    [sym_conditional] = STATE(7806),
    [sym_range] = STATE(7806),
    [sym_binary] = STATE(7806),
    [sym_unary] = STATE(7806),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5448] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7807),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7807),
    [sym_operator_assignment] = STATE(7807),
    [sym_conditional] = STATE(7807),
    [sym_range] = STATE(7807),
    [sym_binary] = STATE(7807),
    [sym_unary] = STATE(7807),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5449] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7808),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7808),
    [sym_operator_assignment] = STATE(7808),
    [sym_conditional] = STATE(7808),
    [sym_range] = STATE(7808),
    [sym_binary] = STATE(7808),
    [sym_unary] = STATE(7808),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5450] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7816),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(7816),
    [sym_operator_assignment] = STATE(7816),
    [sym_conditional] = STATE(7816),
    [sym_range] = STATE(7816),
    [sym_binary] = STATE(7816),
    [sym_unary] = STATE(7816),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5451] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7821),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(7821),
    [sym_operator_assignment] = STATE(7821),
    [sym_conditional] = STATE(7821),
    [sym_range] = STATE(7821),
    [sym_binary] = STATE(7821),
    [sym_unary] = STATE(7821),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5452] = {
    [anon_sym_COLON] = ACTIONS(11096),
    [sym_comment] = ACTIONS(87),
  },
  [5453] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7823),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(7823),
    [sym_operator_assignment] = STATE(7823),
    [sym_conditional] = STATE(7823),
    [sym_range] = STATE(7823),
    [sym_binary] = STATE(7823),
    [sym_unary] = STATE(7823),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5454] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11098),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5455] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(11096),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [5456] = {
    [sym_heredoc_body] = STATE(7825),
    [aux_sym_call_repeat1] = STATE(7825),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5457] = {
    [sym_heredoc_body] = STATE(7825),
    [aux_sym_call_repeat1] = STATE(7825),
    [aux_sym_argument_list_repeat1] = STATE(7827),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(11100),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5458] = {
    [sym_string] = STATE(5597),
    [aux_sym_chained_string_repeat1] = STATE(5597),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11102),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5459] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7829),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_splat_argument] = STATE(7830),
    [sym_assignment] = STATE(7829),
    [sym_operator_assignment] = STATE(7829),
    [sym_conditional] = STATE(7829),
    [sym_range] = STATE(7829),
    [sym_binary] = STATE(7829),
    [sym_unary] = STATE(7829),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(7830),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(11104),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5460] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7831),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(7831),
    [sym_operator_assignment] = STATE(7831),
    [sym_conditional] = STATE(7831),
    [sym_range] = STATE(7831),
    [sym_binary] = STATE(7831),
    [sym_unary] = STATE(7831),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5461] = {
    [sym_string] = STATE(7832),
    [aux_sym_chained_string_repeat1] = STATE(7832),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [5462] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5463] = {
    [sym_heredoc_body] = STATE(7833),
    [aux_sym_call_repeat1] = STATE(7833),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5464] = {
    [sym_heredoc_body] = STATE(7833),
    [aux_sym_call_repeat1] = STATE(7833),
    [aux_sym_argument_list_repeat1] = STATE(7834),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(4924),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5465] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8435),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [5466] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7835),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(7835),
    [sym_operator_assignment] = STATE(7835),
    [sym_conditional] = STATE(7835),
    [sym_range] = STATE(7835),
    [sym_binary] = STATE(7835),
    [sym_unary] = STATE(7835),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5467] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7836),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(7836),
    [sym_operator_assignment] = STATE(7836),
    [sym_conditional] = STATE(7836),
    [sym_range] = STATE(7836),
    [sym_binary] = STATE(7836),
    [sym_unary] = STATE(7836),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5468] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7837),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(7837),
    [sym_operator_assignment] = STATE(7837),
    [sym_conditional] = STATE(7837),
    [sym_range] = STATE(7837),
    [sym_binary] = STATE(7837),
    [sym_unary] = STATE(7837),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5469] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7838),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(7838),
    [sym_operator_assignment] = STATE(7838),
    [sym_conditional] = STATE(7838),
    [sym_range] = STATE(7838),
    [sym_binary] = STATE(7838),
    [sym_unary] = STATE(7838),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5470] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7839),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(7839),
    [sym_operator_assignment] = STATE(7839),
    [sym_conditional] = STATE(7839),
    [sym_range] = STATE(7839),
    [sym_binary] = STATE(7839),
    [sym_unary] = STATE(7839),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5471] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7840),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7840),
    [sym_operator_assignment] = STATE(7840),
    [sym_conditional] = STATE(7840),
    [sym_range] = STATE(7840),
    [sym_binary] = STATE(7840),
    [sym_unary] = STATE(7840),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5472] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7841),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(7841),
    [sym_operator_assignment] = STATE(7841),
    [sym_conditional] = STATE(7841),
    [sym_range] = STATE(7841),
    [sym_binary] = STATE(7841),
    [sym_unary] = STATE(7841),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5473] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7842),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(7842),
    [sym_operator_assignment] = STATE(7842),
    [sym_conditional] = STATE(7842),
    [sym_range] = STATE(7842),
    [sym_binary] = STATE(7842),
    [sym_unary] = STATE(7842),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5474] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7843),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(7843),
    [sym_operator_assignment] = STATE(7843),
    [sym_conditional] = STATE(7843),
    [sym_range] = STATE(7843),
    [sym_binary] = STATE(7843),
    [sym_unary] = STATE(7843),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5475] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7844),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(7844),
    [sym_operator_assignment] = STATE(7844),
    [sym_conditional] = STATE(7844),
    [sym_range] = STATE(7844),
    [sym_binary] = STATE(7844),
    [sym_unary] = STATE(7844),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5476] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7845),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_splat_argument] = STATE(7846),
    [sym_assignment] = STATE(7845),
    [sym_operator_assignment] = STATE(7845),
    [sym_conditional] = STATE(7845),
    [sym_range] = STATE(7845),
    [sym_binary] = STATE(7845),
    [sym_unary] = STATE(7845),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(7846),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5477] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7847),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(7847),
    [sym_operator_assignment] = STATE(7847),
    [sym_conditional] = STATE(7847),
    [sym_range] = STATE(7847),
    [sym_binary] = STATE(7847),
    [sym_unary] = STATE(7847),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5478] = {
    [sym_string] = STATE(7848),
    [aux_sym_chained_string_repeat1] = STATE(7848),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_ensure] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [5479] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_ensure] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8435),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [5480] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_ensure] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5481] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_ensure] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5482] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7849),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(7849),
    [sym_operator_assignment] = STATE(7849),
    [sym_conditional] = STATE(7849),
    [sym_range] = STATE(7849),
    [sym_binary] = STATE(7849),
    [sym_unary] = STATE(7849),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5483] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_ensure] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5484] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7850),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(7850),
    [sym_operator_assignment] = STATE(7850),
    [sym_conditional] = STATE(7850),
    [sym_range] = STATE(7850),
    [sym_binary] = STATE(7850),
    [sym_unary] = STATE(7850),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5485] = {
    [sym_heredoc_body] = STATE(7851),
    [aux_sym_call_repeat1] = STATE(7851),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5486] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2994),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(2994),
    [sym_operator_assignment] = STATE(2994),
    [sym_conditional] = STATE(2994),
    [sym_range] = STATE(2994),
    [sym_binary] = STATE(2994),
    [sym_unary] = STATE(2994),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2997),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7852),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4880),
    [sym__splat_star] = ACTIONS(4882),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(4884),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11106),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(4886),
    [sym_identifier] = ACTIONS(4886),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5487] = {
    [sym_heredoc_body] = STATE(7853),
    [aux_sym_call_repeat1] = STATE(7853),
    [aux_sym_argument_list_repeat1] = STATE(7854),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8461),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5488] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_ensure] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8435),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [5489] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5490] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [5491] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5492] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5493] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5494] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5495] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5496] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5497] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5498] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5499] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_ensure] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5500] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_ensure] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5501] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7856),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(7856),
    [sym_operator_assignment] = STATE(7856),
    [sym_conditional] = STATE(7856),
    [sym_range] = STATE(7856),
    [sym_binary] = STATE(7856),
    [sym_unary] = STATE(7856),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5502] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_ensure] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5503] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7857),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(7857),
    [sym_operator_assignment] = STATE(7857),
    [sym_conditional] = STATE(7857),
    [sym_range] = STATE(7857),
    [sym_binary] = STATE(7857),
    [sym_unary] = STATE(7857),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5504] = {
    [sym_heredoc_body] = STATE(7858),
    [aux_sym_call_repeat1] = STATE(7858),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5505] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3015),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(3015),
    [sym_operator_assignment] = STATE(3015),
    [sym_conditional] = STATE(3015),
    [sym_range] = STATE(3015),
    [sym_binary] = STATE(3015),
    [sym_unary] = STATE(3015),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3018),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(7859),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4916),
    [sym__splat_star] = ACTIONS(4918),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__identifier_hash_key] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11110),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(4922),
    [sym_identifier] = ACTIONS(4922),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5506] = {
    [sym_heredoc_body] = STATE(7860),
    [aux_sym_call_repeat1] = STATE(7860),
    [aux_sym_argument_list_repeat1] = STATE(7861),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8469),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5507] = {
    [sym_heredoc_body] = STATE(5507),
    [aux_sym_call_repeat1] = STATE(5507),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_ensure] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [5508] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1146),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(1146),
    [sym_operator_assignment] = STATE(1146),
    [sym_conditional] = STATE(1146),
    [sym_range] = STATE(1146),
    [sym_binary] = STATE(1146),
    [sym_unary] = STATE(1146),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1152),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2051),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(2057),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8473),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5509] = {
    [sym_heredoc_body] = STATE(5507),
    [aux_sym_call_repeat1] = STATE(5507),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_ensure] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [5510] = {
    [aux_sym_argument_list_repeat1] = STATE(5510),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [5511] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_ensure] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5512] = {
    [aux_sym_exceptions_repeat1] = STATE(7863),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [5513] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [5514] = {
    [sym_string] = STATE(5514),
    [aux_sym_chained_string_repeat1] = STATE(5514),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_ensure] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [5515] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [5516] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [5517] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5518] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7864),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7864),
    [sym_operator_assignment] = STATE(7864),
    [sym_conditional] = STATE(7864),
    [sym_range] = STATE(7864),
    [sym_binary] = STATE(7864),
    [sym_unary] = STATE(7864),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5519] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [5520] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [5521] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7865),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7865),
    [sym_operator_assignment] = STATE(7865),
    [sym_conditional] = STATE(7865),
    [sym_range] = STATE(7865),
    [sym_binary] = STATE(7865),
    [sym_unary] = STATE(7865),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5522] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7866),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7866),
    [sym_operator_assignment] = STATE(7866),
    [sym_conditional] = STATE(7866),
    [sym_range] = STATE(7866),
    [sym_binary] = STATE(7866),
    [sym_unary] = STATE(7866),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5523] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7867),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7867),
    [sym_operator_assignment] = STATE(7867),
    [sym_conditional] = STATE(7867),
    [sym_range] = STATE(7867),
    [sym_binary] = STATE(7867),
    [sym_unary] = STATE(7867),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5524] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7868),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7868),
    [sym_operator_assignment] = STATE(7868),
    [sym_conditional] = STATE(7868),
    [sym_range] = STATE(7868),
    [sym_binary] = STATE(7868),
    [sym_unary] = STATE(7868),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5525] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7869),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7869),
    [sym_operator_assignment] = STATE(7869),
    [sym_conditional] = STATE(7869),
    [sym_range] = STATE(7869),
    [sym_binary] = STATE(7869),
    [sym_unary] = STATE(7869),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5526] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7870),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7870),
    [sym_operator_assignment] = STATE(7870),
    [sym_conditional] = STATE(7870),
    [sym_range] = STATE(7870),
    [sym_binary] = STATE(7870),
    [sym_unary] = STATE(7870),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5527] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7871),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7871),
    [sym_operator_assignment] = STATE(7871),
    [sym_conditional] = STATE(7871),
    [sym_range] = STATE(7871),
    [sym_binary] = STATE(7871),
    [sym_unary] = STATE(7871),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5528] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7872),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7872),
    [sym_operator_assignment] = STATE(7872),
    [sym_conditional] = STATE(7872),
    [sym_range] = STATE(7872),
    [sym_binary] = STATE(7872),
    [sym_unary] = STATE(7872),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5529] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7873),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7873),
    [sym_operator_assignment] = STATE(7873),
    [sym_conditional] = STATE(7873),
    [sym_range] = STATE(7873),
    [sym_binary] = STATE(7873),
    [sym_unary] = STATE(7873),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5530] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7874),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7874),
    [sym_operator_assignment] = STATE(7874),
    [sym_conditional] = STATE(7874),
    [sym_range] = STATE(7874),
    [sym_binary] = STATE(7874),
    [sym_unary] = STATE(7874),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5531] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7875),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7875),
    [sym_operator_assignment] = STATE(7875),
    [sym_conditional] = STATE(7875),
    [sym_range] = STATE(7875),
    [sym_binary] = STATE(7875),
    [sym_unary] = STATE(7875),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5532] = {
    [sym_heredoc_body] = STATE(7876),
    [aux_sym_call_repeat1] = STATE(7876),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5533] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(3035),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3040),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(7877),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4934),
    [sym__splat_star] = ACTIONS(4936),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__identifier_hash_key] = ACTIONS(4940),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11115),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(4950),
    [sym_identifier] = ACTIONS(4950),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5534] = {
    [sym_heredoc_body] = STATE(7878),
    [aux_sym_call_repeat1] = STATE(7878),
    [aux_sym_argument_list_repeat1] = STATE(7879),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8507),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5535] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7880),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_splat_argument] = STATE(7881),
    [sym_assignment] = STATE(7880),
    [sym_operator_assignment] = STATE(7880),
    [sym_conditional] = STATE(7880),
    [sym_range] = STATE(7880),
    [sym_binary] = STATE(7880),
    [sym_unary] = STATE(7880),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(7881),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(4936),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5536] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7882),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(7882),
    [sym_operator_assignment] = STATE(7882),
    [sym_conditional] = STATE(7882),
    [sym_range] = STATE(7882),
    [sym_binary] = STATE(7882),
    [sym_unary] = STATE(7882),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5537] = {
    [sym_argument_list_with_parens] = STATE(7885),
    [sym__argument_list_with_parens] = STATE(7886),
    [sym_operator] = STATE(7885),
    [sym_heredoc_body] = STATE(7887),
    [aux_sym_call_repeat1] = STATE(7887),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(11117),
    [anon_sym_STAR] = ACTIONS(11119),
    [anon_sym_STAR_STAR] = ACTIONS(11117),
    [anon_sym_AMP] = ACTIONS(11117),
    [anon_sym_LT] = ACTIONS(11119),
    [anon_sym_LPAREN2] = ACTIONS(11121),
    [anon_sym_DOT_DOT] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11117),
    [anon_sym_GT_GT] = ACTIONS(11117),
    [anon_sym_EQ_EQ] = ACTIONS(11119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11117),
    [anon_sym_LT_EQ_GT] = ACTIONS(11117),
    [anon_sym_EQ_TILDE] = ACTIONS(11117),
    [anon_sym_BANG_TILDE] = ACTIONS(11117),
    [anon_sym_LT_EQ] = ACTIONS(11119),
    [anon_sym_GT] = ACTIONS(11119),
    [anon_sym_GT_EQ] = ACTIONS(11117),
    [anon_sym_CARET] = ACTIONS(11117),
    [anon_sym_PLUS] = ACTIONS(11119),
    [anon_sym_SLASH] = ACTIONS(11117),
    [anon_sym_PERCENT] = ACTIONS(11117),
    [anon_sym_BANG] = ACTIONS(11119),
    [anon_sym_TILDE] = ACTIONS(11117),
    [sym_constant] = ACTIONS(11123),
    [sym_identifier] = ACTIONS(11123),
    [anon_sym_DASH] = ACTIONS(11119),
    [anon_sym_PLUS_AT] = ACTIONS(11117),
    [anon_sym_DASH_AT] = ACTIONS(11117),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11119),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11117),
    [anon_sym_BQUOTE] = ACTIONS(11117),
    [sym_comment] = ACTIONS(87),
  },
  [5538] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(347),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym__argument_list_with_trailing_comma] = STATE(7889),
    [sym__argument] = STATE(351),
    [sym_splat_argument] = STATE(351),
    [sym_hash_splat_argument] = STATE(351),
    [sym_block_argument] = STATE(351),
    [sym_assignment] = STATE(347),
    [sym_operator_assignment] = STATE(347),
    [sym_conditional] = STATE(347),
    [sym_range] = STATE(347),
    [sym_binary] = STATE(347),
    [sym_unary] = STATE(347),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(7890),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(351),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(593),
    [sym__splat_star] = ACTIONS(595),
    [sym__unary_minus] = ACTIONS(597),
    [sym__identifier_hash_key] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(11125),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5539] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7898),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(7898),
    [sym_operator_assignment] = STATE(7898),
    [sym_conditional] = STATE(7898),
    [sym_range] = STATE(7898),
    [sym_binary] = STATE(7898),
    [sym_unary] = STATE(7898),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5540] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7902),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(7902),
    [sym_operator_assignment] = STATE(7902),
    [sym_conditional] = STATE(7902),
    [sym_range] = STATE(7902),
    [sym_binary] = STATE(7902),
    [sym_unary] = STATE(7902),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5541] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7903),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(7903),
    [sym_operator_assignment] = STATE(7903),
    [sym_conditional] = STATE(7903),
    [sym_range] = STATE(7903),
    [sym_binary] = STATE(7903),
    [sym_unary] = STATE(7903),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5542] = {
    [anon_sym_COLON] = ACTIONS(11145),
    [sym_comment] = ACTIONS(87),
  },
  [5543] = {
    [sym__statements] = STATE(6932),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(6933),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(120),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(121),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(11147),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5544] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7907),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(7907),
    [sym_operator_assignment] = STATE(7907),
    [sym_conditional] = STATE(7907),
    [sym_range] = STATE(7907),
    [sym_binary] = STATE(7907),
    [sym_unary] = STATE(7907),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5545] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7913),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(7914),
    [sym__argument] = STATE(7915),
    [sym_splat_argument] = STATE(7915),
    [sym_hash_splat_argument] = STATE(7915),
    [sym_block_argument] = STATE(7915),
    [sym_assignment] = STATE(7913),
    [sym_operator_assignment] = STATE(7913),
    [sym_conditional] = STATE(7913),
    [sym_range] = STATE(7913),
    [sym_binary] = STATE(7913),
    [sym_unary] = STATE(7913),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7916),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7915),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(11149),
    [sym__splat_star] = ACTIONS(11151),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(11153),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(11155),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(11157),
    [sym_identifier] = ACTIONS(11157),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5546] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7913),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(7914),
    [sym__argument] = STATE(7915),
    [sym_splat_argument] = STATE(7915),
    [sym_hash_splat_argument] = STATE(7915),
    [sym_block_argument] = STATE(7915),
    [sym_assignment] = STATE(7913),
    [sym_operator_assignment] = STATE(7913),
    [sym_conditional] = STATE(7913),
    [sym_range] = STATE(7913),
    [sym_binary] = STATE(7913),
    [sym_unary] = STATE(7913),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7916),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7915),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(11149),
    [sym__splat_star] = ACTIONS(11151),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(11153),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(11155),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(11157),
    [sym_identifier] = ACTIONS(11157),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5547] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7913),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(7914),
    [sym__argument] = STATE(7915),
    [sym_splat_argument] = STATE(7915),
    [sym_hash_splat_argument] = STATE(7915),
    [sym_block_argument] = STATE(7915),
    [sym_assignment] = STATE(7913),
    [sym_operator_assignment] = STATE(7913),
    [sym_conditional] = STATE(7913),
    [sym_range] = STATE(7913),
    [sym_binary] = STATE(7913),
    [sym_unary] = STATE(7913),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7916),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7915),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(11149),
    [sym__splat_star] = ACTIONS(11151),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(11153),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(11155),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(11157),
    [sym_identifier] = ACTIONS(11157),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5548] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7913),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(7914),
    [sym__argument] = STATE(7915),
    [sym_splat_argument] = STATE(7915),
    [sym_hash_splat_argument] = STATE(7915),
    [sym_block_argument] = STATE(7915),
    [sym_assignment] = STATE(7913),
    [sym_operator_assignment] = STATE(7913),
    [sym_conditional] = STATE(7913),
    [sym_range] = STATE(7913),
    [sym_binary] = STATE(7913),
    [sym_unary] = STATE(7913),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7916),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7915),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(11149),
    [sym__splat_star] = ACTIONS(11151),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(11153),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(11155),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(11157),
    [sym_identifier] = ACTIONS(11157),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5549] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(7918),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(7919),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(11159),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5550] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7920),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(7920),
    [sym_operator_assignment] = STATE(7920),
    [sym_conditional] = STATE(7920),
    [sym_range] = STATE(7920),
    [sym_binary] = STATE(7920),
    [sym_unary] = STATE(7920),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5551] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5552] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11161),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5553] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(11145),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(11179),
    [anon_sym_or] = ACTIONS(11179),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [5554] = {
    [sym_do_block] = STATE(7932),
    [sym_block] = STATE(7932),
    [sym__line_break] = ACTIONS(2725),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(7058),
    [anon_sym_DOT] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_do] = ACTIONS(10287),
    [anon_sym_then] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [sym_comment] = ACTIONS(87),
  },
  [5555] = {
    [sym_heredoc_body] = STATE(7934),
    [aux_sym_call_repeat1] = STATE(7934),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(11191),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5556] = {
    [sym_heredoc_body] = STATE(7934),
    [aux_sym_call_repeat1] = STATE(7934),
    [aux_sym_argument_list_repeat1] = STATE(7936),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(11191),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_COMMA] = ACTIONS(11193),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5557] = {
    [sym__line_break] = ACTIONS(2725),
    [sym__heredoc_body_start] = ACTIONS(2725),
    [anon_sym_DOT] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_then] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [sym_comment] = ACTIONS(87),
  },
  [5558] = {
    [anon_sym_EQ] = ACTIONS(11195),
    [sym_comment] = ACTIONS(87),
  },
  [5559] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11197),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11199),
    [anon_sym_DASH_EQ] = ACTIONS(11199),
    [anon_sym_STAR_EQ] = ACTIONS(11199),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11199),
    [anon_sym_SLASH_EQ] = ACTIONS(11199),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11199),
    [anon_sym_PIPE_EQ] = ACTIONS(11199),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11199),
    [anon_sym_AMP_EQ] = ACTIONS(11199),
    [anon_sym_PERCENT_EQ] = ACTIONS(11199),
    [anon_sym_GT_GT_EQ] = ACTIONS(11199),
    [anon_sym_LT_LT_EQ] = ACTIONS(11199),
    [anon_sym_CARET_EQ] = ACTIONS(11199),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5560] = {
    [sym_string] = STATE(7939),
    [aux_sym_chained_string_repeat1] = STATE(7939),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11201),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5561] = {
    [anon_sym_end] = ACTIONS(11203),
    [anon_sym_else] = ACTIONS(11203),
    [anon_sym_ensure] = ACTIONS(11203),
    [sym_comment] = ACTIONS(87),
  },
  [5562] = {
    [sym_rescue] = STATE(7940),
    [anon_sym_end] = ACTIONS(11203),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(11203),
    [anon_sym_ensure] = ACTIONS(11203),
    [sym_comment] = ACTIONS(87),
  },
  [5563] = {
    [sym__statements] = STATE(7941),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym_rescue] = STATE(7940),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11205),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(11205),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(11205),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5564] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [5565] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [5566] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [5567] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [5568] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [5569] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11207),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5570] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_EQ_TILDE] = ACTIONS(4990),
    [anon_sym_BANG_TILDE] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [5571] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_EQ_TILDE] = ACTIONS(4990),
    [anon_sym_BANG_TILDE] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [5572] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_EQ_TILDE] = ACTIONS(4990),
    [anon_sym_BANG_TILDE] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [5573] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [5574] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [5575] = {
    [sym_string] = STATE(5597),
    [aux_sym_chained_string_repeat1] = STATE(5597),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5576] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [5577] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5578] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7943),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7943),
    [sym_operator_assignment] = STATE(7943),
    [sym_conditional] = STATE(7943),
    [sym_range] = STATE(7943),
    [sym_binary] = STATE(7943),
    [sym_unary] = STATE(7943),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5579] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [5580] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [5581] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7944),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7944),
    [sym_operator_assignment] = STATE(7944),
    [sym_conditional] = STATE(7944),
    [sym_range] = STATE(7944),
    [sym_binary] = STATE(7944),
    [sym_unary] = STATE(7944),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5582] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7945),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7945),
    [sym_operator_assignment] = STATE(7945),
    [sym_conditional] = STATE(7945),
    [sym_range] = STATE(7945),
    [sym_binary] = STATE(7945),
    [sym_unary] = STATE(7945),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5583] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7946),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7946),
    [sym_operator_assignment] = STATE(7946),
    [sym_conditional] = STATE(7946),
    [sym_range] = STATE(7946),
    [sym_binary] = STATE(7946),
    [sym_unary] = STATE(7946),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5584] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7947),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7947),
    [sym_operator_assignment] = STATE(7947),
    [sym_conditional] = STATE(7947),
    [sym_range] = STATE(7947),
    [sym_binary] = STATE(7947),
    [sym_unary] = STATE(7947),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5585] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7948),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7948),
    [sym_operator_assignment] = STATE(7948),
    [sym_conditional] = STATE(7948),
    [sym_range] = STATE(7948),
    [sym_binary] = STATE(7948),
    [sym_unary] = STATE(7948),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5586] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7949),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7949),
    [sym_operator_assignment] = STATE(7949),
    [sym_conditional] = STATE(7949),
    [sym_range] = STATE(7949),
    [sym_binary] = STATE(7949),
    [sym_unary] = STATE(7949),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5587] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7950),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7950),
    [sym_operator_assignment] = STATE(7950),
    [sym_conditional] = STATE(7950),
    [sym_range] = STATE(7950),
    [sym_binary] = STATE(7950),
    [sym_unary] = STATE(7950),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5588] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7951),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7951),
    [sym_operator_assignment] = STATE(7951),
    [sym_conditional] = STATE(7951),
    [sym_range] = STATE(7951),
    [sym_binary] = STATE(7951),
    [sym_unary] = STATE(7951),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5589] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7952),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7952),
    [sym_operator_assignment] = STATE(7952),
    [sym_conditional] = STATE(7952),
    [sym_range] = STATE(7952),
    [sym_binary] = STATE(7952),
    [sym_unary] = STATE(7952),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5590] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7953),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7953),
    [sym_operator_assignment] = STATE(7953),
    [sym_conditional] = STATE(7953),
    [sym_range] = STATE(7953),
    [sym_binary] = STATE(7953),
    [sym_unary] = STATE(7953),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5591] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7954),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7954),
    [sym_operator_assignment] = STATE(7954),
    [sym_conditional] = STATE(7954),
    [sym_range] = STATE(7954),
    [sym_binary] = STATE(7954),
    [sym_unary] = STATE(7954),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5592] = {
    [sym_heredoc_body] = STATE(7955),
    [aux_sym_call_repeat1] = STATE(7955),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5593] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3074),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(3074),
    [sym_operator_assignment] = STATE(3074),
    [sym_conditional] = STATE(3074),
    [sym_range] = STATE(3074),
    [sym_binary] = STATE(3074),
    [sym_unary] = STATE(3074),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3080),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(7956),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5000),
    [sym__splat_star] = ACTIONS(5002),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__identifier_hash_key] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11209),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5024),
    [sym_identifier] = ACTIONS(5024),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5594] = {
    [sym_heredoc_body] = STATE(7957),
    [aux_sym_call_repeat1] = STATE(7957),
    [aux_sym_argument_list_repeat1] = STATE(7958),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8595),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5595] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7959),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_splat_argument] = STATE(7960),
    [sym_assignment] = STATE(7959),
    [sym_operator_assignment] = STATE(7959),
    [sym_conditional] = STATE(7959),
    [sym_range] = STATE(7959),
    [sym_binary] = STATE(7959),
    [sym_unary] = STATE(7959),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(7960),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(5002),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5596] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7961),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(7961),
    [sym_operator_assignment] = STATE(7961),
    [sym_conditional] = STATE(7961),
    [sym_range] = STATE(7961),
    [sym_binary] = STATE(7961),
    [sym_unary] = STATE(7961),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5597] = {
    [sym_string] = STATE(7962),
    [aux_sym_chained_string_repeat1] = STATE(7962),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [5598] = {
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [5599] = {
    [aux_sym_exceptions_repeat1] = STATE(5599),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11213),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [5600] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7963),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(7963),
    [sym_operator_assignment] = STATE(7963),
    [sym_conditional] = STATE(7963),
    [sym_range] = STATE(7963),
    [sym_binary] = STATE(7963),
    [sym_unary] = STATE(7963),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5601] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_EQ_TILDE] = ACTIONS(4990),
    [anon_sym_BANG_TILDE] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [5602] = {
    [aux_sym_exceptions_repeat1] = STATE(7965),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [5603] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_EQ_TILDE] = ACTIONS(4990),
    [anon_sym_BANG_TILDE] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [5604] = {
    [sym_string] = STATE(5604),
    [aux_sym_chained_string_repeat1] = STATE(5604),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [5605] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7966),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(7966),
    [sym_operator_assignment] = STATE(7966),
    [sym_conditional] = STATE(7966),
    [sym_range] = STATE(7966),
    [sym_binary] = STATE(7966),
    [sym_unary] = STATE(7966),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5606] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3099),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(7967),
    [sym__argument] = STATE(7968),
    [sym_splat_argument] = STATE(7968),
    [sym_hash_splat_argument] = STATE(7968),
    [sym_block_argument] = STATE(7968),
    [sym_assignment] = STATE(3099),
    [sym_operator_assignment] = STATE(3099),
    [sym_conditional] = STATE(3099),
    [sym_range] = STATE(3099),
    [sym_binary] = STATE(3099),
    [sym_unary] = STATE(3099),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3105),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7968),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5042),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5066),
    [sym_identifier] = ACTIONS(5066),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5607] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3099),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(7967),
    [sym__argument] = STATE(7968),
    [sym_splat_argument] = STATE(7968),
    [sym_hash_splat_argument] = STATE(7968),
    [sym_block_argument] = STATE(7968),
    [sym_assignment] = STATE(3099),
    [sym_operator_assignment] = STATE(3099),
    [sym_conditional] = STATE(3099),
    [sym_range] = STATE(3099),
    [sym_binary] = STATE(3099),
    [sym_unary] = STATE(3099),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3105),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7968),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5042),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5066),
    [sym_identifier] = ACTIONS(5066),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5608] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3099),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(7967),
    [sym__argument] = STATE(7968),
    [sym_splat_argument] = STATE(7968),
    [sym_hash_splat_argument] = STATE(7968),
    [sym_block_argument] = STATE(7968),
    [sym_assignment] = STATE(3099),
    [sym_operator_assignment] = STATE(3099),
    [sym_conditional] = STATE(3099),
    [sym_range] = STATE(3099),
    [sym_binary] = STATE(3099),
    [sym_unary] = STATE(3099),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3105),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7968),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5042),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5066),
    [sym_identifier] = ACTIONS(5066),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5609] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3099),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(7967),
    [sym__argument] = STATE(7968),
    [sym_splat_argument] = STATE(7968),
    [sym_hash_splat_argument] = STATE(7968),
    [sym_block_argument] = STATE(7968),
    [sym_assignment] = STATE(3099),
    [sym_operator_assignment] = STATE(3099),
    [sym_conditional] = STATE(3099),
    [sym_range] = STATE(3099),
    [sym_binary] = STATE(3099),
    [sym_unary] = STATE(3099),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3105),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(7968),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5042),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5066),
    [sym_identifier] = ACTIONS(5066),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5610] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7969),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(7969),
    [sym_operator_assignment] = STATE(7969),
    [sym_conditional] = STATE(7969),
    [sym_range] = STATE(7969),
    [sym_binary] = STATE(7969),
    [sym_unary] = STATE(7969),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5611] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5612] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_ensure] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(11226),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [5613] = {
    [anon_sym_EQ] = ACTIONS(11242),
    [sym_comment] = ACTIONS(87),
  },
  [5614] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11244),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11246),
    [anon_sym_DASH_EQ] = ACTIONS(11246),
    [anon_sym_STAR_EQ] = ACTIONS(11246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11246),
    [anon_sym_SLASH_EQ] = ACTIONS(11246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11246),
    [anon_sym_PIPE_EQ] = ACTIONS(11246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11246),
    [anon_sym_AMP_EQ] = ACTIONS(11246),
    [anon_sym_PERCENT_EQ] = ACTIONS(11246),
    [anon_sym_GT_GT_EQ] = ACTIONS(11246),
    [anon_sym_LT_LT_EQ] = ACTIONS(11246),
    [anon_sym_CARET_EQ] = ACTIONS(11246),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5615] = {
    [sym_string] = STATE(7982),
    [aux_sym_chained_string_repeat1] = STATE(7982),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5616] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_ensure] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11226),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [5617] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5618] = {
    [sym_string] = STATE(5656),
    [aux_sym_chained_string_repeat1] = STATE(5656),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5619] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7983),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(7983),
    [sym_operator_assignment] = STATE(7983),
    [sym_conditional] = STATE(7983),
    [sym_range] = STATE(7983),
    [sym_binary] = STATE(7983),
    [sym_unary] = STATE(7983),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5620] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_ensure] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(11226),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [5621] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7984),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(7984),
    [sym_operator_assignment] = STATE(7984),
    [sym_conditional] = STATE(7984),
    [sym_range] = STATE(7984),
    [sym_binary] = STATE(7984),
    [sym_unary] = STATE(7984),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5622] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7985),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(7985),
    [sym_operator_assignment] = STATE(7985),
    [sym_conditional] = STATE(7985),
    [sym_range] = STATE(7985),
    [sym_binary] = STATE(7985),
    [sym_unary] = STATE(7985),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5623] = {
    [anon_sym_COLON] = ACTIONS(11248),
    [sym_comment] = ACTIONS(87),
  },
  [5624] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7987),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(7987),
    [sym_operator_assignment] = STATE(7987),
    [sym_conditional] = STATE(7987),
    [sym_range] = STATE(7987),
    [sym_binary] = STATE(7987),
    [sym_unary] = STATE(7987),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5625] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11250),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5626] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_ensure] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [5627] = {
    [sym_heredoc_body] = STATE(7989),
    [aux_sym_call_repeat1] = STATE(7989),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5628] = {
    [sym_heredoc_body] = STATE(7989),
    [aux_sym_call_repeat1] = STATE(7989),
    [aux_sym_argument_list_repeat1] = STATE(7991),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(11252),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5629] = {
    [sym_string] = STATE(5656),
    [aux_sym_chained_string_repeat1] = STATE(5656),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11254),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5630] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [5631] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7992),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(7992),
    [sym_operator_assignment] = STATE(7992),
    [sym_conditional] = STATE(7992),
    [sym_range] = STATE(7992),
    [sym_binary] = STATE(7992),
    [sym_unary] = STATE(7992),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5632] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7993),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(7993),
    [sym_operator_assignment] = STATE(7993),
    [sym_conditional] = STATE(7993),
    [sym_range] = STATE(7993),
    [sym_binary] = STATE(7993),
    [sym_unary] = STATE(7993),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5633] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7994),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(7994),
    [sym_operator_assignment] = STATE(7994),
    [sym_conditional] = STATE(7994),
    [sym_range] = STATE(7994),
    [sym_binary] = STATE(7994),
    [sym_unary] = STATE(7994),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5634] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(7995),
    [sym_operator_assignment] = STATE(7995),
    [sym_conditional] = STATE(7995),
    [sym_range] = STATE(7995),
    [sym_binary] = STATE(7995),
    [sym_unary] = STATE(7995),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5635] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7996),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(7996),
    [sym_operator_assignment] = STATE(7996),
    [sym_conditional] = STATE(7996),
    [sym_range] = STATE(7996),
    [sym_binary] = STATE(7996),
    [sym_unary] = STATE(7996),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5636] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7997),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(7997),
    [sym_operator_assignment] = STATE(7997),
    [sym_conditional] = STATE(7997),
    [sym_range] = STATE(7997),
    [sym_binary] = STATE(7997),
    [sym_unary] = STATE(7997),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5637] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(7998),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(7998),
    [sym_operator_assignment] = STATE(7998),
    [sym_conditional] = STATE(7998),
    [sym_range] = STATE(7998),
    [sym_binary] = STATE(7998),
    [sym_unary] = STATE(7998),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5638] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7999),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(7999),
    [sym_operator_assignment] = STATE(7999),
    [sym_conditional] = STATE(7999),
    [sym_range] = STATE(7999),
    [sym_binary] = STATE(7999),
    [sym_unary] = STATE(7999),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5639] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8000),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(8000),
    [sym_operator_assignment] = STATE(8000),
    [sym_conditional] = STATE(8000),
    [sym_range] = STATE(8000),
    [sym_binary] = STATE(8000),
    [sym_unary] = STATE(8000),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5640] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8001),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(8001),
    [sym_operator_assignment] = STATE(8001),
    [sym_conditional] = STATE(8001),
    [sym_range] = STATE(8001),
    [sym_binary] = STATE(8001),
    [sym_unary] = STATE(8001),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5641] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8002),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(8002),
    [sym_operator_assignment] = STATE(8002),
    [sym_conditional] = STATE(8002),
    [sym_range] = STATE(8002),
    [sym_binary] = STATE(8002),
    [sym_unary] = STATE(8002),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5642] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8003),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8003),
    [sym_operator_assignment] = STATE(8003),
    [sym_conditional] = STATE(8003),
    [sym_range] = STATE(8003),
    [sym_binary] = STATE(8003),
    [sym_unary] = STATE(8003),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5643] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8004),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8004),
    [sym_operator_assignment] = STATE(8004),
    [sym_conditional] = STATE(8004),
    [sym_range] = STATE(8004),
    [sym_binary] = STATE(8004),
    [sym_unary] = STATE(8004),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5644] = {
    [anon_sym_COLON] = ACTIONS(11256),
    [sym_comment] = ACTIONS(87),
  },
  [5645] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8006),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8006),
    [sym_operator_assignment] = STATE(8006),
    [sym_conditional] = STATE(8006),
    [sym_range] = STATE(8006),
    [sym_binary] = STATE(8006),
    [sym_unary] = STATE(8006),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5646] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11258),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_ensure] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5647] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_ensure] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [5648] = {
    [sym_heredoc_body] = STATE(8008),
    [aux_sym_call_repeat1] = STATE(8008),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5649] = {
    [sym_heredoc_body] = STATE(8008),
    [aux_sym_call_repeat1] = STATE(8008),
    [aux_sym_argument_list_repeat1] = STATE(8010),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(11260),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5650] = {
    [sym_string] = STATE(5709),
    [aux_sym_chained_string_repeat1] = STATE(5709),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11262),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5651] = {
    [sym_heredoc_body] = STATE(8011),
    [aux_sym_call_repeat1] = STATE(8011),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5652] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3099),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(3099),
    [sym_operator_assignment] = STATE(3099),
    [sym_conditional] = STATE(3099),
    [sym_range] = STATE(3099),
    [sym_binary] = STATE(3099),
    [sym_unary] = STATE(3099),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3105),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(8012),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5042),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__identifier_hash_key] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11264),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5066),
    [sym_identifier] = ACTIONS(5066),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5653] = {
    [sym_heredoc_body] = STATE(8013),
    [aux_sym_call_repeat1] = STATE(8013),
    [aux_sym_argument_list_repeat1] = STATE(8014),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8675),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5654] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8015),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_splat_argument] = STATE(8016),
    [sym_assignment] = STATE(8015),
    [sym_operator_assignment] = STATE(8015),
    [sym_conditional] = STATE(8015),
    [sym_range] = STATE(8015),
    [sym_binary] = STATE(8015),
    [sym_unary] = STATE(8015),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(8016),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(8633),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5655] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8017),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(8017),
    [sym_operator_assignment] = STATE(8017),
    [sym_conditional] = STATE(8017),
    [sym_range] = STATE(8017),
    [sym_binary] = STATE(8017),
    [sym_unary] = STATE(8017),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5656] = {
    [sym_string] = STATE(8018),
    [aux_sym_chained_string_repeat1] = STATE(8018),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_ensure] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [5657] = {
    [aux_sym_undef_repeat1] = STATE(8019),
    [sym__line_break] = ACTIONS(5356),
    [sym__heredoc_body_start] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym_end] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [anon_sym_ensure] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [5658] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(1182),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1182),
    [sym_unless_modifier] = STATE(1182),
    [sym_while_modifier] = STATE(1182),
    [sym_until_modifier] = STATE(1182),
    [sym_rescue_modifier] = STATE(1182),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1183),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(1183),
    [sym_operator_assignment] = STATE(1183),
    [sym_conditional] = STATE(1183),
    [sym_range] = STATE(1183),
    [sym_binary] = STATE(1183),
    [sym_unary] = STATE(1183),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_undef] = STATE(1182),
    [sym_alias] = STATE(1182),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1182),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5678),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(5678),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [anon_sym_undef] = ACTIONS(2137),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5659] = {
    [sym_heredoc_body] = STATE(8020),
    [sym__terminator] = STATE(8020),
    [aux_sym__statements_repeat1] = STATE(5659),
    [sym__line_break] = ACTIONS(11266),
    [sym__heredoc_body_start] = ACTIONS(5683),
    [anon_sym_SEMI] = ACTIONS(11266),
    [anon_sym_end] = ACTIONS(5674),
    [anon_sym_ensure] = ACTIONS(5674),
    [sym_comment] = ACTIONS(87),
  },
  [5660] = {
    [sym__line_break] = ACTIONS(5686),
    [sym__heredoc_body_start] = ACTIONS(5686),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(5686),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_ensure] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5661] = {
    [sym__line_break] = ACTIONS(5688),
    [sym__heredoc_body_start] = ACTIONS(5688),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(5688),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_ensure] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5662] = {
    [sym__line_break] = ACTIONS(5690),
    [sym__heredoc_body_start] = ACTIONS(5690),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(5690),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_ensure] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5663] = {
    [sym__line_break] = ACTIONS(5692),
    [sym__heredoc_body_start] = ACTIONS(5692),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(5692),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_ensure] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5664] = {
    [sym__line_break] = ACTIONS(5694),
    [sym__heredoc_body_start] = ACTIONS(5694),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(5694),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_ensure] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5665] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5666] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [5667] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5668] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5669] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5670] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11269),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5671] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5672] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5673] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5674] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5675] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8022),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(8022),
    [sym_operator_assignment] = STATE(8022),
    [sym_conditional] = STATE(8022),
    [sym_range] = STATE(8022),
    [sym_binary] = STATE(8022),
    [sym_unary] = STATE(8022),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5676] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3137),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(3139),
    [sym__argument] = STATE(3140),
    [sym_splat_argument] = STATE(3140),
    [sym_hash_splat_argument] = STATE(3140),
    [sym_block_argument] = STATE(3140),
    [sym_assignment] = STATE(3137),
    [sym_operator_assignment] = STATE(3137),
    [sym_conditional] = STATE(3137),
    [sym_range] = STATE(3137),
    [sym_binary] = STATE(3137),
    [sym_unary] = STATE(3137),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3143),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3140),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5116),
    [sym__splat_star] = ACTIONS(5118),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5140),
    [sym_identifier] = ACTIONS(5140),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5677] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3137),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(3139),
    [sym__argument] = STATE(3140),
    [sym_splat_argument] = STATE(3140),
    [sym_hash_splat_argument] = STATE(3140),
    [sym_block_argument] = STATE(3140),
    [sym_assignment] = STATE(3137),
    [sym_operator_assignment] = STATE(3137),
    [sym_conditional] = STATE(3137),
    [sym_range] = STATE(3137),
    [sym_binary] = STATE(3137),
    [sym_unary] = STATE(3137),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3143),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3140),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5116),
    [sym__splat_star] = ACTIONS(5118),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5140),
    [sym_identifier] = ACTIONS(5140),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5678] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3137),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(3139),
    [sym__argument] = STATE(3140),
    [sym_splat_argument] = STATE(3140),
    [sym_hash_splat_argument] = STATE(3140),
    [sym_block_argument] = STATE(3140),
    [sym_assignment] = STATE(3137),
    [sym_operator_assignment] = STATE(3137),
    [sym_conditional] = STATE(3137),
    [sym_range] = STATE(3137),
    [sym_binary] = STATE(3137),
    [sym_unary] = STATE(3137),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3143),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3140),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5116),
    [sym__splat_star] = ACTIONS(5118),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5140),
    [sym_identifier] = ACTIONS(5140),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5679] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3137),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(3139),
    [sym__argument] = STATE(3140),
    [sym_splat_argument] = STATE(3140),
    [sym_hash_splat_argument] = STATE(3140),
    [sym_block_argument] = STATE(3140),
    [sym_assignment] = STATE(3137),
    [sym_operator_assignment] = STATE(3137),
    [sym_conditional] = STATE(3137),
    [sym_range] = STATE(3137),
    [sym_binary] = STATE(3137),
    [sym_unary] = STATE(3137),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3143),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3140),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5116),
    [sym__splat_star] = ACTIONS(5118),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5140),
    [sym_identifier] = ACTIONS(5140),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5680] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8023),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(8023),
    [sym_operator_assignment] = STATE(8023),
    [sym_conditional] = STATE(8023),
    [sym_range] = STATE(8023),
    [sym_binary] = STATE(8023),
    [sym_unary] = STATE(8023),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5681] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5682] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_ensure] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [5683] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3137),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(3139),
    [sym__argument] = STATE(3140),
    [sym_splat_argument] = STATE(3140),
    [sym_hash_splat_argument] = STATE(3140),
    [sym_block_argument] = STATE(3140),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(3137),
    [sym_operator_assignment] = STATE(3137),
    [sym_conditional] = STATE(3137),
    [sym_range] = STATE(3137),
    [sym_binary] = STATE(3137),
    [sym_unary] = STATE(3137),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3143),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3140),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5116),
    [sym__splat_star] = ACTIONS(5118),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_ensure] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5140),
    [sym_identifier] = ACTIONS(5140),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5684] = {
    [anon_sym_EQ] = ACTIONS(11299),
    [sym_comment] = ACTIONS(87),
  },
  [5685] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11301),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11303),
    [anon_sym_DASH_EQ] = ACTIONS(11303),
    [anon_sym_STAR_EQ] = ACTIONS(11303),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11303),
    [anon_sym_SLASH_EQ] = ACTIONS(11303),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11303),
    [anon_sym_PIPE_EQ] = ACTIONS(11303),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11303),
    [anon_sym_AMP_EQ] = ACTIONS(11303),
    [anon_sym_PERCENT_EQ] = ACTIONS(11303),
    [anon_sym_GT_GT_EQ] = ACTIONS(11303),
    [anon_sym_LT_LT_EQ] = ACTIONS(11303),
    [anon_sym_CARET_EQ] = ACTIONS(11303),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5686] = {
    [sym_string] = STATE(8036),
    [aux_sym_chained_string_repeat1] = STATE(8036),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5687] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_ensure] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [5688] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5689] = {
    [sym_string] = STATE(5709),
    [aux_sym_chained_string_repeat1] = STATE(5709),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5690] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8037),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(8037),
    [sym_operator_assignment] = STATE(8037),
    [sym_conditional] = STATE(8037),
    [sym_range] = STATE(8037),
    [sym_binary] = STATE(8037),
    [sym_unary] = STATE(8037),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5691] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_ensure] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [5692] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [5693] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8038),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(8038),
    [sym_operator_assignment] = STATE(8038),
    [sym_conditional] = STATE(8038),
    [sym_range] = STATE(8038),
    [sym_binary] = STATE(8038),
    [sym_unary] = STATE(8038),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5694] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8039),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8039),
    [sym_operator_assignment] = STATE(8039),
    [sym_conditional] = STATE(8039),
    [sym_range] = STATE(8039),
    [sym_binary] = STATE(8039),
    [sym_unary] = STATE(8039),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5695] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8040),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8040),
    [sym_operator_assignment] = STATE(8040),
    [sym_conditional] = STATE(8040),
    [sym_range] = STATE(8040),
    [sym_binary] = STATE(8040),
    [sym_unary] = STATE(8040),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5696] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8041),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8041),
    [sym_operator_assignment] = STATE(8041),
    [sym_conditional] = STATE(8041),
    [sym_range] = STATE(8041),
    [sym_binary] = STATE(8041),
    [sym_unary] = STATE(8041),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5697] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8042),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8042),
    [sym_operator_assignment] = STATE(8042),
    [sym_conditional] = STATE(8042),
    [sym_range] = STATE(8042),
    [sym_binary] = STATE(8042),
    [sym_unary] = STATE(8042),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5698] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8043),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8043),
    [sym_operator_assignment] = STATE(8043),
    [sym_conditional] = STATE(8043),
    [sym_range] = STATE(8043),
    [sym_binary] = STATE(8043),
    [sym_unary] = STATE(8043),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5699] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8044),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8044),
    [sym_operator_assignment] = STATE(8044),
    [sym_conditional] = STATE(8044),
    [sym_range] = STATE(8044),
    [sym_binary] = STATE(8044),
    [sym_unary] = STATE(8044),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5700] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8045),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8045),
    [sym_operator_assignment] = STATE(8045),
    [sym_conditional] = STATE(8045),
    [sym_range] = STATE(8045),
    [sym_binary] = STATE(8045),
    [sym_unary] = STATE(8045),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5701] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8046),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8046),
    [sym_operator_assignment] = STATE(8046),
    [sym_conditional] = STATE(8046),
    [sym_range] = STATE(8046),
    [sym_binary] = STATE(8046),
    [sym_unary] = STATE(8046),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5702] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8047),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8047),
    [sym_operator_assignment] = STATE(8047),
    [sym_conditional] = STATE(8047),
    [sym_range] = STATE(8047),
    [sym_binary] = STATE(8047),
    [sym_unary] = STATE(8047),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5703] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8048),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8048),
    [sym_operator_assignment] = STATE(8048),
    [sym_conditional] = STATE(8048),
    [sym_range] = STATE(8048),
    [sym_binary] = STATE(8048),
    [sym_unary] = STATE(8048),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5704] = {
    [sym_heredoc_body] = STATE(8049),
    [aux_sym_call_repeat1] = STATE(8049),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5705] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3137),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(3137),
    [sym_operator_assignment] = STATE(3137),
    [sym_conditional] = STATE(3137),
    [sym_range] = STATE(3137),
    [sym_binary] = STATE(3137),
    [sym_unary] = STATE(3137),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3143),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(8050),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5116),
    [sym__splat_star] = ACTIONS(5118),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11305),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5140),
    [sym_identifier] = ACTIONS(5140),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5706] = {
    [sym_heredoc_body] = STATE(8051),
    [aux_sym_call_repeat1] = STATE(8051),
    [aux_sym_argument_list_repeat1] = STATE(8052),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8743),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5707] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8053),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_splat_argument] = STATE(8054),
    [sym_assignment] = STATE(8053),
    [sym_operator_assignment] = STATE(8053),
    [sym_conditional] = STATE(8053),
    [sym_range] = STATE(8053),
    [sym_binary] = STATE(8053),
    [sym_unary] = STATE(8053),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(8054),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(8669),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5708] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8055),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(8055),
    [sym_operator_assignment] = STATE(8055),
    [sym_conditional] = STATE(8055),
    [sym_range] = STATE(8055),
    [sym_binary] = STATE(8055),
    [sym_unary] = STATE(8055),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5709] = {
    [sym_string] = STATE(8056),
    [aux_sym_chained_string_repeat1] = STATE(8056),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_ensure] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [5710] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8057),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(8057),
    [sym_operator_assignment] = STATE(8057),
    [sym_conditional] = STATE(8057),
    [sym_range] = STATE(8057),
    [sym_binary] = STATE(8057),
    [sym_unary] = STATE(8057),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5711] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8058),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(8058),
    [sym_operator_assignment] = STATE(8058),
    [sym_conditional] = STATE(8058),
    [sym_range] = STATE(8058),
    [sym_binary] = STATE(8058),
    [sym_unary] = STATE(8058),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5712] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8059),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(8059),
    [sym_operator_assignment] = STATE(8059),
    [sym_conditional] = STATE(8059),
    [sym_range] = STATE(8059),
    [sym_binary] = STATE(8059),
    [sym_unary] = STATE(8059),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5713] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5714] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11311),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(11313),
    [anon_sym_LT] = ACTIONS(11315),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_ensure] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_DOT_DOT] = ACTIONS(11319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11321),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11323),
    [anon_sym_AMP_AMP] = ACTIONS(11323),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(11327),
    [anon_sym_BANG_EQ] = ACTIONS(11323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11323),
    [anon_sym_LT_EQ_GT] = ACTIONS(11323),
    [anon_sym_EQ_TILDE] = ACTIONS(11323),
    [anon_sym_BANG_TILDE] = ACTIONS(11323),
    [anon_sym_LT_EQ] = ACTIONS(11315),
    [anon_sym_GT] = ACTIONS(11315),
    [anon_sym_GT_EQ] = ACTIONS(11329),
    [anon_sym_CARET] = ACTIONS(11331),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [5715] = {
    [aux_sym_exceptions_repeat1] = STATE(8071),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [5716] = {
    [anon_sym_EQ] = ACTIONS(11335),
    [sym_comment] = ACTIONS(87),
  },
  [5717] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11337),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11339),
    [anon_sym_DASH_EQ] = ACTIONS(11339),
    [anon_sym_STAR_EQ] = ACTIONS(11339),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11339),
    [anon_sym_SLASH_EQ] = ACTIONS(11339),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11339),
    [anon_sym_PIPE_EQ] = ACTIONS(11339),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11339),
    [anon_sym_AMP_EQ] = ACTIONS(11339),
    [anon_sym_PERCENT_EQ] = ACTIONS(11339),
    [anon_sym_GT_GT_EQ] = ACTIONS(11339),
    [anon_sym_LT_LT_EQ] = ACTIONS(11339),
    [anon_sym_CARET_EQ] = ACTIONS(11339),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5718] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [5719] = {
    [sym_string] = STATE(5719),
    [aux_sym_chained_string_repeat1] = STATE(5719),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_ensure] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [5720] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8074),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(8074),
    [sym_operator_assignment] = STATE(8074),
    [sym_conditional] = STATE(8074),
    [sym_range] = STATE(8074),
    [sym_binary] = STATE(8074),
    [sym_unary] = STATE(8074),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5721] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3161),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(8075),
    [sym__argument] = STATE(8076),
    [sym_splat_argument] = STATE(8076),
    [sym_hash_splat_argument] = STATE(8076),
    [sym_block_argument] = STATE(8076),
    [sym_assignment] = STATE(3161),
    [sym_operator_assignment] = STATE(3161),
    [sym_conditional] = STATE(3161),
    [sym_range] = STATE(3161),
    [sym_binary] = STATE(3161),
    [sym_unary] = STATE(3161),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3167),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8076),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5154),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5178),
    [sym_identifier] = ACTIONS(5178),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5722] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3161),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(8075),
    [sym__argument] = STATE(8076),
    [sym_splat_argument] = STATE(8076),
    [sym_hash_splat_argument] = STATE(8076),
    [sym_block_argument] = STATE(8076),
    [sym_assignment] = STATE(3161),
    [sym_operator_assignment] = STATE(3161),
    [sym_conditional] = STATE(3161),
    [sym_range] = STATE(3161),
    [sym_binary] = STATE(3161),
    [sym_unary] = STATE(3161),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3167),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8076),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5154),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5178),
    [sym_identifier] = ACTIONS(5178),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5723] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3161),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(8075),
    [sym__argument] = STATE(8076),
    [sym_splat_argument] = STATE(8076),
    [sym_hash_splat_argument] = STATE(8076),
    [sym_block_argument] = STATE(8076),
    [sym_assignment] = STATE(3161),
    [sym_operator_assignment] = STATE(3161),
    [sym_conditional] = STATE(3161),
    [sym_range] = STATE(3161),
    [sym_binary] = STATE(3161),
    [sym_unary] = STATE(3161),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3167),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8076),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5154),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5178),
    [sym_identifier] = ACTIONS(5178),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5724] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3161),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(8075),
    [sym__argument] = STATE(8076),
    [sym_splat_argument] = STATE(8076),
    [sym_hash_splat_argument] = STATE(8076),
    [sym_block_argument] = STATE(8076),
    [sym_assignment] = STATE(3161),
    [sym_operator_assignment] = STATE(3161),
    [sym_conditional] = STATE(3161),
    [sym_range] = STATE(3161),
    [sym_binary] = STATE(3161),
    [sym_unary] = STATE(3161),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3167),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(8076),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5154),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5178),
    [sym_identifier] = ACTIONS(5178),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5725] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8077),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(8077),
    [sym_operator_assignment] = STATE(8077),
    [sym_conditional] = STATE(8077),
    [sym_range] = STATE(8077),
    [sym_binary] = STATE(8077),
    [sym_unary] = STATE(8077),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5726] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5727] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [5728] = {
    [anon_sym_EQ] = ACTIONS(11367),
    [sym_comment] = ACTIONS(87),
  },
  [5729] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11369),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11371),
    [anon_sym_DASH_EQ] = ACTIONS(11371),
    [anon_sym_STAR_EQ] = ACTIONS(11371),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11371),
    [anon_sym_SLASH_EQ] = ACTIONS(11371),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11371),
    [anon_sym_PIPE_EQ] = ACTIONS(11371),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11371),
    [anon_sym_AMP_EQ] = ACTIONS(11371),
    [anon_sym_PERCENT_EQ] = ACTIONS(11371),
    [anon_sym_GT_GT_EQ] = ACTIONS(11371),
    [anon_sym_LT_LT_EQ] = ACTIONS(11371),
    [anon_sym_CARET_EQ] = ACTIONS(11371),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5730] = {
    [sym_string] = STATE(8090),
    [aux_sym_chained_string_repeat1] = STATE(8090),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5731] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [5732] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5733] = {
    [sym_string] = STATE(5771),
    [aux_sym_chained_string_repeat1] = STATE(5771),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5734] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8091),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(8091),
    [sym_operator_assignment] = STATE(8091),
    [sym_conditional] = STATE(8091),
    [sym_range] = STATE(8091),
    [sym_binary] = STATE(8091),
    [sym_unary] = STATE(8091),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5735] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [5736] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8092),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8092),
    [sym_operator_assignment] = STATE(8092),
    [sym_conditional] = STATE(8092),
    [sym_range] = STATE(8092),
    [sym_binary] = STATE(8092),
    [sym_unary] = STATE(8092),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5737] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8093),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8093),
    [sym_operator_assignment] = STATE(8093),
    [sym_conditional] = STATE(8093),
    [sym_range] = STATE(8093),
    [sym_binary] = STATE(8093),
    [sym_unary] = STATE(8093),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5738] = {
    [anon_sym_COLON] = ACTIONS(11373),
    [sym_comment] = ACTIONS(87),
  },
  [5739] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8095),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8095),
    [sym_operator_assignment] = STATE(8095),
    [sym_conditional] = STATE(8095),
    [sym_range] = STATE(8095),
    [sym_binary] = STATE(8095),
    [sym_unary] = STATE(8095),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5740] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11375),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5741] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [5742] = {
    [sym_heredoc_body] = STATE(8097),
    [aux_sym_call_repeat1] = STATE(8097),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5743] = {
    [sym_heredoc_body] = STATE(8097),
    [aux_sym_call_repeat1] = STATE(8097),
    [aux_sym_argument_list_repeat1] = STATE(8099),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(11377),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [5744] = {
    [sym_string] = STATE(5771),
    [aux_sym_chained_string_repeat1] = STATE(5771),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11379),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5745] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [5746] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8100),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(8100),
    [sym_operator_assignment] = STATE(8100),
    [sym_conditional] = STATE(8100),
    [sym_range] = STATE(8100),
    [sym_binary] = STATE(8100),
    [sym_unary] = STATE(8100),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5747] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8101),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8101),
    [sym_operator_assignment] = STATE(8101),
    [sym_conditional] = STATE(8101),
    [sym_range] = STATE(8101),
    [sym_binary] = STATE(8101),
    [sym_unary] = STATE(8101),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5748] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8102),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8102),
    [sym_operator_assignment] = STATE(8102),
    [sym_conditional] = STATE(8102),
    [sym_range] = STATE(8102),
    [sym_binary] = STATE(8102),
    [sym_unary] = STATE(8102),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5749] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8103),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8103),
    [sym_operator_assignment] = STATE(8103),
    [sym_conditional] = STATE(8103),
    [sym_range] = STATE(8103),
    [sym_binary] = STATE(8103),
    [sym_unary] = STATE(8103),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5750] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8104),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8104),
    [sym_operator_assignment] = STATE(8104),
    [sym_conditional] = STATE(8104),
    [sym_range] = STATE(8104),
    [sym_binary] = STATE(8104),
    [sym_unary] = STATE(8104),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5751] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8105),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8105),
    [sym_operator_assignment] = STATE(8105),
    [sym_conditional] = STATE(8105),
    [sym_range] = STATE(8105),
    [sym_binary] = STATE(8105),
    [sym_unary] = STATE(8105),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5752] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8106),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8106),
    [sym_operator_assignment] = STATE(8106),
    [sym_conditional] = STATE(8106),
    [sym_range] = STATE(8106),
    [sym_binary] = STATE(8106),
    [sym_unary] = STATE(8106),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5753] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8107),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8107),
    [sym_operator_assignment] = STATE(8107),
    [sym_conditional] = STATE(8107),
    [sym_range] = STATE(8107),
    [sym_binary] = STATE(8107),
    [sym_unary] = STATE(8107),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5754] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8108),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8108),
    [sym_operator_assignment] = STATE(8108),
    [sym_conditional] = STATE(8108),
    [sym_range] = STATE(8108),
    [sym_binary] = STATE(8108),
    [sym_unary] = STATE(8108),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5755] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8109),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8109),
    [sym_operator_assignment] = STATE(8109),
    [sym_conditional] = STATE(8109),
    [sym_range] = STATE(8109),
    [sym_binary] = STATE(8109),
    [sym_unary] = STATE(8109),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5756] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8110),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8110),
    [sym_operator_assignment] = STATE(8110),
    [sym_conditional] = STATE(8110),
    [sym_range] = STATE(8110),
    [sym_binary] = STATE(8110),
    [sym_unary] = STATE(8110),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5757] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8111),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8111),
    [sym_operator_assignment] = STATE(8111),
    [sym_conditional] = STATE(8111),
    [sym_range] = STATE(8111),
    [sym_binary] = STATE(8111),
    [sym_unary] = STATE(8111),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5758] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8112),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8112),
    [sym_operator_assignment] = STATE(8112),
    [sym_conditional] = STATE(8112),
    [sym_range] = STATE(8112),
    [sym_binary] = STATE(8112),
    [sym_unary] = STATE(8112),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5759] = {
    [anon_sym_COLON] = ACTIONS(11381),
    [sym_comment] = ACTIONS(87),
  },
  [5760] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8114),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8114),
    [sym_operator_assignment] = STATE(8114),
    [sym_conditional] = STATE(8114),
    [sym_range] = STATE(8114),
    [sym_binary] = STATE(8114),
    [sym_unary] = STATE(8114),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5761] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11383),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [5762] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [5763] = {
    [sym_heredoc_body] = STATE(8116),
    [aux_sym_call_repeat1] = STATE(8116),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5764] = {
    [sym_heredoc_body] = STATE(8116),
    [aux_sym_call_repeat1] = STATE(8116),
    [aux_sym_argument_list_repeat1] = STATE(8118),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(11385),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [5765] = {
    [sym_string] = STATE(5824),
    [aux_sym_chained_string_repeat1] = STATE(5824),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11387),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5766] = {
    [sym_heredoc_body] = STATE(8119),
    [aux_sym_call_repeat1] = STATE(8119),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5767] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3161),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(3161),
    [sym_operator_assignment] = STATE(3161),
    [sym_conditional] = STATE(3161),
    [sym_range] = STATE(3161),
    [sym_binary] = STATE(3161),
    [sym_unary] = STATE(3161),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3167),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(8120),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5154),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__identifier_hash_key] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11389),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5178),
    [sym_identifier] = ACTIONS(5178),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5768] = {
    [sym_heredoc_body] = STATE(8121),
    [aux_sym_call_repeat1] = STATE(8121),
    [aux_sym_argument_list_repeat1] = STATE(8122),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8833),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5769] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8123),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_splat_argument] = STATE(8124),
    [sym_assignment] = STATE(8123),
    [sym_operator_assignment] = STATE(8123),
    [sym_conditional] = STATE(8123),
    [sym_range] = STATE(8123),
    [sym_binary] = STATE(8123),
    [sym_unary] = STATE(8123),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(8124),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(8791),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5770] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8125),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(8125),
    [sym_operator_assignment] = STATE(8125),
    [sym_conditional] = STATE(8125),
    [sym_range] = STATE(8125),
    [sym_binary] = STATE(8125),
    [sym_unary] = STATE(8125),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5771] = {
    [sym_string] = STATE(8126),
    [aux_sym_chained_string_repeat1] = STATE(8126),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [5772] = {
    [aux_sym_undef_repeat1] = STATE(8127),
    [sym__line_break] = ACTIONS(5356),
    [sym__heredoc_body_start] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym_end] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [5773] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5678),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5774] = {
    [sym_heredoc_body] = STATE(8128),
    [sym__terminator] = STATE(8128),
    [aux_sym__statements_repeat1] = STATE(5774),
    [sym__line_break] = ACTIONS(11391),
    [sym__heredoc_body_start] = ACTIONS(5683),
    [anon_sym_SEMI] = ACTIONS(11391),
    [anon_sym_end] = ACTIONS(5674),
    [sym_comment] = ACTIONS(87),
  },
  [5775] = {
    [sym__line_break] = ACTIONS(5686),
    [sym__heredoc_body_start] = ACTIONS(5686),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(5686),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(5216),
    [anon_sym_or] = ACTIONS(5216),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5776] = {
    [sym__line_break] = ACTIONS(5688),
    [sym__heredoc_body_start] = ACTIONS(5688),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(5688),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(5216),
    [anon_sym_or] = ACTIONS(5216),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5777] = {
    [sym__line_break] = ACTIONS(5690),
    [sym__heredoc_body_start] = ACTIONS(5690),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(5690),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(5216),
    [anon_sym_or] = ACTIONS(5216),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5778] = {
    [sym__line_break] = ACTIONS(5692),
    [sym__heredoc_body_start] = ACTIONS(5692),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(5692),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(5216),
    [anon_sym_or] = ACTIONS(5216),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5779] = {
    [sym__line_break] = ACTIONS(5694),
    [sym__heredoc_body_start] = ACTIONS(5694),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(5694),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(5216),
    [anon_sym_or] = ACTIONS(5216),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5780] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5781] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [5782] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5783] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5784] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5785] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11394),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5786] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5787] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5788] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5789] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5790] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8130),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(8130),
    [sym_operator_assignment] = STATE(8130),
    [sym_conditional] = STATE(8130),
    [sym_range] = STATE(8130),
    [sym_binary] = STATE(8130),
    [sym_unary] = STATE(8130),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5791] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3199),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(3201),
    [sym__argument] = STATE(3202),
    [sym_splat_argument] = STATE(3202),
    [sym_hash_splat_argument] = STATE(3202),
    [sym_block_argument] = STATE(3202),
    [sym_assignment] = STATE(3199),
    [sym_operator_assignment] = STATE(3199),
    [sym_conditional] = STATE(3199),
    [sym_range] = STATE(3199),
    [sym_binary] = STATE(3199),
    [sym_unary] = STATE(3199),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3205),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3202),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5228),
    [sym__splat_star] = ACTIONS(5230),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5252),
    [sym_identifier] = ACTIONS(5252),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5792] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3199),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(3201),
    [sym__argument] = STATE(3202),
    [sym_splat_argument] = STATE(3202),
    [sym_hash_splat_argument] = STATE(3202),
    [sym_block_argument] = STATE(3202),
    [sym_assignment] = STATE(3199),
    [sym_operator_assignment] = STATE(3199),
    [sym_conditional] = STATE(3199),
    [sym_range] = STATE(3199),
    [sym_binary] = STATE(3199),
    [sym_unary] = STATE(3199),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3205),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3202),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5228),
    [sym__splat_star] = ACTIONS(5230),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5252),
    [sym_identifier] = ACTIONS(5252),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5793] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3199),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(3201),
    [sym__argument] = STATE(3202),
    [sym_splat_argument] = STATE(3202),
    [sym_hash_splat_argument] = STATE(3202),
    [sym_block_argument] = STATE(3202),
    [sym_assignment] = STATE(3199),
    [sym_operator_assignment] = STATE(3199),
    [sym_conditional] = STATE(3199),
    [sym_range] = STATE(3199),
    [sym_binary] = STATE(3199),
    [sym_unary] = STATE(3199),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3205),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3202),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5228),
    [sym__splat_star] = ACTIONS(5230),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5252),
    [sym_identifier] = ACTIONS(5252),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5794] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3199),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(3201),
    [sym__argument] = STATE(3202),
    [sym_splat_argument] = STATE(3202),
    [sym_hash_splat_argument] = STATE(3202),
    [sym_block_argument] = STATE(3202),
    [sym_assignment] = STATE(3199),
    [sym_operator_assignment] = STATE(3199),
    [sym_conditional] = STATE(3199),
    [sym_range] = STATE(3199),
    [sym_binary] = STATE(3199),
    [sym_unary] = STATE(3199),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3205),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3202),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5228),
    [sym__splat_star] = ACTIONS(5230),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5252),
    [sym_identifier] = ACTIONS(5252),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5795] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8131),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(8131),
    [sym_operator_assignment] = STATE(8131),
    [sym_conditional] = STATE(8131),
    [sym_range] = STATE(8131),
    [sym_binary] = STATE(8131),
    [sym_unary] = STATE(8131),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5796] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5797] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [5798] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3199),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(3201),
    [sym__argument] = STATE(3202),
    [sym_splat_argument] = STATE(3202),
    [sym_hash_splat_argument] = STATE(3202),
    [sym_block_argument] = STATE(3202),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(3199),
    [sym_operator_assignment] = STATE(3199),
    [sym_conditional] = STATE(3199),
    [sym_range] = STATE(3199),
    [sym_binary] = STATE(3199),
    [sym_unary] = STATE(3199),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3205),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3202),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5228),
    [sym__splat_star] = ACTIONS(5230),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5252),
    [sym_identifier] = ACTIONS(5252),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5799] = {
    [anon_sym_EQ] = ACTIONS(11424),
    [sym_comment] = ACTIONS(87),
  },
  [5800] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11426),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11428),
    [anon_sym_DASH_EQ] = ACTIONS(11428),
    [anon_sym_STAR_EQ] = ACTIONS(11428),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11428),
    [anon_sym_SLASH_EQ] = ACTIONS(11428),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11428),
    [anon_sym_PIPE_EQ] = ACTIONS(11428),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11428),
    [anon_sym_AMP_EQ] = ACTIONS(11428),
    [anon_sym_PERCENT_EQ] = ACTIONS(11428),
    [anon_sym_GT_GT_EQ] = ACTIONS(11428),
    [anon_sym_LT_LT_EQ] = ACTIONS(11428),
    [anon_sym_CARET_EQ] = ACTIONS(11428),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5801] = {
    [sym_string] = STATE(8144),
    [aux_sym_chained_string_repeat1] = STATE(8144),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5802] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [5803] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5804] = {
    [sym_string] = STATE(5824),
    [aux_sym_chained_string_repeat1] = STATE(5824),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5805] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8145),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(8145),
    [sym_operator_assignment] = STATE(8145),
    [sym_conditional] = STATE(8145),
    [sym_range] = STATE(8145),
    [sym_binary] = STATE(8145),
    [sym_unary] = STATE(8145),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5806] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [5807] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [5808] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8146),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(8146),
    [sym_operator_assignment] = STATE(8146),
    [sym_conditional] = STATE(8146),
    [sym_range] = STATE(8146),
    [sym_binary] = STATE(8146),
    [sym_unary] = STATE(8146),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5809] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8147),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8147),
    [sym_operator_assignment] = STATE(8147),
    [sym_conditional] = STATE(8147),
    [sym_range] = STATE(8147),
    [sym_binary] = STATE(8147),
    [sym_unary] = STATE(8147),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5810] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8148),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8148),
    [sym_operator_assignment] = STATE(8148),
    [sym_conditional] = STATE(8148),
    [sym_range] = STATE(8148),
    [sym_binary] = STATE(8148),
    [sym_unary] = STATE(8148),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5811] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8149),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8149),
    [sym_operator_assignment] = STATE(8149),
    [sym_conditional] = STATE(8149),
    [sym_range] = STATE(8149),
    [sym_binary] = STATE(8149),
    [sym_unary] = STATE(8149),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5812] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8150),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8150),
    [sym_operator_assignment] = STATE(8150),
    [sym_conditional] = STATE(8150),
    [sym_range] = STATE(8150),
    [sym_binary] = STATE(8150),
    [sym_unary] = STATE(8150),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5813] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8151),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8151),
    [sym_operator_assignment] = STATE(8151),
    [sym_conditional] = STATE(8151),
    [sym_range] = STATE(8151),
    [sym_binary] = STATE(8151),
    [sym_unary] = STATE(8151),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5814] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8152),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8152),
    [sym_operator_assignment] = STATE(8152),
    [sym_conditional] = STATE(8152),
    [sym_range] = STATE(8152),
    [sym_binary] = STATE(8152),
    [sym_unary] = STATE(8152),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5815] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8153),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8153),
    [sym_operator_assignment] = STATE(8153),
    [sym_conditional] = STATE(8153),
    [sym_range] = STATE(8153),
    [sym_binary] = STATE(8153),
    [sym_unary] = STATE(8153),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5816] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8154),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8154),
    [sym_operator_assignment] = STATE(8154),
    [sym_conditional] = STATE(8154),
    [sym_range] = STATE(8154),
    [sym_binary] = STATE(8154),
    [sym_unary] = STATE(8154),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5817] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8155),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8155),
    [sym_operator_assignment] = STATE(8155),
    [sym_conditional] = STATE(8155),
    [sym_range] = STATE(8155),
    [sym_binary] = STATE(8155),
    [sym_unary] = STATE(8155),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5818] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8156),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8156),
    [sym_operator_assignment] = STATE(8156),
    [sym_conditional] = STATE(8156),
    [sym_range] = STATE(8156),
    [sym_binary] = STATE(8156),
    [sym_unary] = STATE(8156),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5819] = {
    [sym_heredoc_body] = STATE(8157),
    [aux_sym_call_repeat1] = STATE(8157),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5820] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3199),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(3199),
    [sym_operator_assignment] = STATE(3199),
    [sym_conditional] = STATE(3199),
    [sym_range] = STATE(3199),
    [sym_binary] = STATE(3199),
    [sym_unary] = STATE(3199),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3205),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(8158),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5228),
    [sym__splat_star] = ACTIONS(5230),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__identifier_hash_key] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11430),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5252),
    [sym_identifier] = ACTIONS(5252),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5821] = {
    [sym_heredoc_body] = STATE(8159),
    [aux_sym_call_repeat1] = STATE(8159),
    [aux_sym_argument_list_repeat1] = STATE(8160),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8901),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5822] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8161),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_splat_argument] = STATE(8162),
    [sym_assignment] = STATE(8161),
    [sym_operator_assignment] = STATE(8161),
    [sym_conditional] = STATE(8161),
    [sym_range] = STATE(8161),
    [sym_binary] = STATE(8161),
    [sym_unary] = STATE(8161),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(8162),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(8827),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5823] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8163),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(8163),
    [sym_operator_assignment] = STATE(8163),
    [sym_conditional] = STATE(8163),
    [sym_range] = STATE(8163),
    [sym_binary] = STATE(8163),
    [sym_unary] = STATE(8163),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5824] = {
    [sym_string] = STATE(8164),
    [aux_sym_chained_string_repeat1] = STATE(8164),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [5825] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8165),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(8165),
    [sym_operator_assignment] = STATE(8165),
    [sym_conditional] = STATE(8165),
    [sym_range] = STATE(8165),
    [sym_binary] = STATE(8165),
    [sym_unary] = STATE(8165),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5826] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8166),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(8166),
    [sym_operator_assignment] = STATE(8166),
    [sym_conditional] = STATE(8166),
    [sym_range] = STATE(8166),
    [sym_binary] = STATE(8166),
    [sym_unary] = STATE(8166),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5827] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8167),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(8167),
    [sym_operator_assignment] = STATE(8167),
    [sym_conditional] = STATE(8167),
    [sym_range] = STATE(8167),
    [sym_binary] = STATE(8167),
    [sym_unary] = STATE(8167),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5828] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5829] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11436),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(11438),
    [anon_sym_LT] = ACTIONS(11440),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11442),
    [anon_sym_DOT_DOT] = ACTIONS(11444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11446),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11448),
    [anon_sym_AMP_AMP] = ACTIONS(11448),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(11452),
    [anon_sym_BANG_EQ] = ACTIONS(11448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11448),
    [anon_sym_LT_EQ_GT] = ACTIONS(11448),
    [anon_sym_EQ_TILDE] = ACTIONS(11448),
    [anon_sym_BANG_TILDE] = ACTIONS(11448),
    [anon_sym_LT_EQ] = ACTIONS(11440),
    [anon_sym_GT] = ACTIONS(11440),
    [anon_sym_GT_EQ] = ACTIONS(11454),
    [anon_sym_CARET] = ACTIONS(11456),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [5830] = {
    [aux_sym_exceptions_repeat1] = STATE(8179),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(11458),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [5831] = {
    [anon_sym_EQ] = ACTIONS(11460),
    [sym_comment] = ACTIONS(87),
  },
  [5832] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11462),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11464),
    [anon_sym_DASH_EQ] = ACTIONS(11464),
    [anon_sym_STAR_EQ] = ACTIONS(11464),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11464),
    [anon_sym_SLASH_EQ] = ACTIONS(11464),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11464),
    [anon_sym_PIPE_EQ] = ACTIONS(11464),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11464),
    [anon_sym_AMP_EQ] = ACTIONS(11464),
    [anon_sym_PERCENT_EQ] = ACTIONS(11464),
    [anon_sym_GT_GT_EQ] = ACTIONS(11464),
    [anon_sym_LT_LT_EQ] = ACTIONS(11464),
    [anon_sym_CARET_EQ] = ACTIONS(11464),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5833] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [5834] = {
    [sym_string] = STATE(5834),
    [aux_sym_chained_string_repeat1] = STATE(5834),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [5835] = {
    [aux_sym_undef_repeat1] = STATE(5835),
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9006),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_end] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [anon_sym_else] = ACTIONS(9004),
    [anon_sym_ensure] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [5836] = {
    [sym__line_break] = ACTIONS(11466),
    [sym__heredoc_body_start] = ACTIONS(11466),
    [sym__binary_minus] = ACTIONS(11466),
    [sym__binary_star] = ACTIONS(11466),
    [ts_builtin_sym_end] = ACTIONS(11466),
    [anon_sym___END__] = ACTIONS(11466),
    [anon_sym_LBRACE] = ACTIONS(11466),
    [anon_sym_RBRACE] = ACTIONS(11466),
    [anon_sym_RPAREN] = ACTIONS(11466),
    [anon_sym_DOT] = ACTIONS(11468),
    [anon_sym_COMMA] = ACTIONS(11466),
    [anon_sym_PIPE] = ACTIONS(11468),
    [anon_sym_SEMI] = ACTIONS(11466),
    [anon_sym_STAR_STAR] = ACTIONS(11466),
    [anon_sym_AMP] = ACTIONS(11468),
    [anon_sym_LT] = ACTIONS(11468),
    [anon_sym_end] = ACTIONS(11466),
    [anon_sym_if] = ACTIONS(11466),
    [anon_sym_unless] = ACTIONS(11466),
    [anon_sym_while] = ACTIONS(11466),
    [anon_sym_until] = ACTIONS(11466),
    [anon_sym_rescue] = ACTIONS(11466),
    [anon_sym_do] = ACTIONS(11466),
    [anon_sym_when] = ACTIONS(11466),
    [anon_sym_elsif] = ACTIONS(11466),
    [anon_sym_else] = ACTIONS(11466),
    [anon_sym_then] = ACTIONS(11466),
    [anon_sym_ensure] = ACTIONS(11466),
    [anon_sym_EQ_GT] = ACTIONS(11466),
    [anon_sym_LBRACK] = ACTIONS(11466),
    [anon_sym_COLON_COLON2] = ACTIONS(11466),
    [anon_sym_AMP_DOT] = ACTIONS(11466),
    [anon_sym_QMARK] = ACTIONS(11466),
    [anon_sym_DOT_DOT] = ACTIONS(11468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11466),
    [anon_sym_and] = ACTIONS(11466),
    [anon_sym_or] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE] = ACTIONS(11466),
    [anon_sym_AMP_AMP] = ACTIONS(11466),
    [anon_sym_LT_LT] = ACTIONS(11466),
    [anon_sym_GT_GT] = ACTIONS(11466),
    [anon_sym_EQ_EQ] = ACTIONS(11468),
    [anon_sym_BANG_EQ] = ACTIONS(11466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11466),
    [anon_sym_LT_EQ_GT] = ACTIONS(11466),
    [anon_sym_EQ_TILDE] = ACTIONS(11466),
    [anon_sym_BANG_TILDE] = ACTIONS(11466),
    [anon_sym_LT_EQ] = ACTIONS(11468),
    [anon_sym_GT] = ACTIONS(11468),
    [anon_sym_GT_EQ] = ACTIONS(11466),
    [anon_sym_CARET] = ACTIONS(11466),
    [anon_sym_PLUS] = ACTIONS(11466),
    [anon_sym_SLASH] = ACTIONS(11466),
    [anon_sym_PERCENT] = ACTIONS(11466),
    [sym_comment] = ACTIONS(87),
  },
  [5837] = {
    [anon_sym_end] = ACTIONS(11470),
    [sym_comment] = ACTIONS(87),
  },
  [5838] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5839] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8183),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(8183),
    [sym_operator_assignment] = STATE(8183),
    [sym_conditional] = STATE(8183),
    [sym_range] = STATE(8183),
    [sym_binary] = STATE(8183),
    [sym_unary] = STATE(8183),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5840] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [5841] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8946),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [5842] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8184),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(8184),
    [sym_operator_assignment] = STATE(8184),
    [sym_conditional] = STATE(8184),
    [sym_range] = STATE(8184),
    [sym_binary] = STATE(8184),
    [sym_unary] = STATE(8184),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5843] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8185),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(8185),
    [sym_operator_assignment] = STATE(8185),
    [sym_conditional] = STATE(8185),
    [sym_range] = STATE(8185),
    [sym_binary] = STATE(8185),
    [sym_unary] = STATE(8185),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5844] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8186),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(8186),
    [sym_operator_assignment] = STATE(8186),
    [sym_conditional] = STATE(8186),
    [sym_range] = STATE(8186),
    [sym_binary] = STATE(8186),
    [sym_unary] = STATE(8186),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5845] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8187),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(8187),
    [sym_operator_assignment] = STATE(8187),
    [sym_conditional] = STATE(8187),
    [sym_range] = STATE(8187),
    [sym_binary] = STATE(8187),
    [sym_unary] = STATE(8187),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5846] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8188),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(8188),
    [sym_operator_assignment] = STATE(8188),
    [sym_conditional] = STATE(8188),
    [sym_range] = STATE(8188),
    [sym_binary] = STATE(8188),
    [sym_unary] = STATE(8188),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5847] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8189),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8189),
    [sym_operator_assignment] = STATE(8189),
    [sym_conditional] = STATE(8189),
    [sym_range] = STATE(8189),
    [sym_binary] = STATE(8189),
    [sym_unary] = STATE(8189),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5848] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8190),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(8190),
    [sym_operator_assignment] = STATE(8190),
    [sym_conditional] = STATE(8190),
    [sym_range] = STATE(8190),
    [sym_binary] = STATE(8190),
    [sym_unary] = STATE(8190),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5849] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8191),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(8191),
    [sym_operator_assignment] = STATE(8191),
    [sym_conditional] = STATE(8191),
    [sym_range] = STATE(8191),
    [sym_binary] = STATE(8191),
    [sym_unary] = STATE(8191),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5850] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8192),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(8192),
    [sym_operator_assignment] = STATE(8192),
    [sym_conditional] = STATE(8192),
    [sym_range] = STATE(8192),
    [sym_binary] = STATE(8192),
    [sym_unary] = STATE(8192),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5851] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8193),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(8193),
    [sym_operator_assignment] = STATE(8193),
    [sym_conditional] = STATE(8193),
    [sym_range] = STATE(8193),
    [sym_binary] = STATE(8193),
    [sym_unary] = STATE(8193),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5852] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8194),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_splat_argument] = STATE(8195),
    [sym_assignment] = STATE(8194),
    [sym_operator_assignment] = STATE(8194),
    [sym_conditional] = STATE(8194),
    [sym_range] = STATE(8194),
    [sym_binary] = STATE(8194),
    [sym_unary] = STATE(8194),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(8195),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(2221),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5853] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8196),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(8196),
    [sym_operator_assignment] = STATE(8196),
    [sym_conditional] = STATE(8196),
    [sym_range] = STATE(8196),
    [sym_binary] = STATE(8196),
    [sym_unary] = STATE(8196),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [5854] = {
    [sym_string] = STATE(8197),
    [aux_sym_chained_string_repeat1] = STATE(8197),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_ensure] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [5855] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_ensure] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8946),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [5856] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_ensure] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8946),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [5857] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5858] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [5859] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5860] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5861] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5862] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11472),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5863] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5864] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5865] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5866] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5867] = {
    [sym_heredoc_body] = STATE(5867),
    [aux_sym_call_repeat1] = STATE(5867),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_ensure] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [5868] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1240),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(1240),
    [sym_operator_assignment] = STATE(1240),
    [sym_conditional] = STATE(1240),
    [sym_range] = STATE(1240),
    [sym_binary] = STATE(1240),
    [sym_unary] = STATE(1240),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1246),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(2219),
    [sym__splat_star] = ACTIONS(2221),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__identifier_hash_key] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8968),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2243),
    [sym_identifier] = ACTIONS(2243),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [5869] = {
    [sym_heredoc_body] = STATE(5867),
    [aux_sym_call_repeat1] = STATE(5867),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_ensure] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [5870] = {
    [aux_sym_argument_list_repeat1] = STATE(5870),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(11474),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [5871] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_ensure] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5872] = {
    [aux_sym_exceptions_repeat1] = STATE(8200),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [5873] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [5874] = {
    [sym_string] = STATE(5874),
    [aux_sym_chained_string_repeat1] = STATE(5874),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_ensure] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [5875] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8974),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(8976),
    [anon_sym_LT] = ACTIONS(8978),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_ensure] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8980),
    [anon_sym_DOT_DOT] = ACTIONS(8982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8984),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8986),
    [anon_sym_AMP_AMP] = ACTIONS(8986),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(8990),
    [anon_sym_BANG_EQ] = ACTIONS(8986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8986),
    [anon_sym_LT_EQ_GT] = ACTIONS(8986),
    [anon_sym_EQ_TILDE] = ACTIONS(8986),
    [anon_sym_BANG_TILDE] = ACTIONS(8986),
    [anon_sym_LT_EQ] = ACTIONS(8978),
    [anon_sym_GT] = ACTIONS(8978),
    [anon_sym_GT_EQ] = ACTIONS(8992),
    [anon_sym_CARET] = ACTIONS(8994),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [5876] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [5877] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(8974),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(8976),
    [anon_sym_LT] = ACTIONS(8978),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(8980),
    [anon_sym_DOT_DOT] = ACTIONS(8982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8984),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(8986),
    [anon_sym_AMP_AMP] = ACTIONS(8986),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(8990),
    [anon_sym_BANG_EQ] = ACTIONS(8986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8986),
    [anon_sym_LT_EQ_GT] = ACTIONS(8986),
    [anon_sym_EQ_TILDE] = ACTIONS(8986),
    [anon_sym_BANG_TILDE] = ACTIONS(8986),
    [anon_sym_LT_EQ] = ACTIONS(8978),
    [anon_sym_GT] = ACTIONS(8978),
    [anon_sym_GT_EQ] = ACTIONS(8992),
    [anon_sym_CARET] = ACTIONS(8994),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [5878] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8201),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(8201),
    [sym_operator_assignment] = STATE(8201),
    [sym_conditional] = STATE(8201),
    [sym_range] = STATE(8201),
    [sym_binary] = STATE(8201),
    [sym_unary] = STATE(8201),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5879] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8202),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(8202),
    [sym_operator_assignment] = STATE(8202),
    [sym_conditional] = STATE(8202),
    [sym_range] = STATE(8202),
    [sym_binary] = STATE(8202),
    [sym_unary] = STATE(8202),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5880] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8203),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(8203),
    [sym_operator_assignment] = STATE(8203),
    [sym_conditional] = STATE(8203),
    [sym_range] = STATE(8203),
    [sym_binary] = STATE(8203),
    [sym_unary] = STATE(8203),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5881] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8204),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(8204),
    [sym_operator_assignment] = STATE(8204),
    [sym_conditional] = STATE(8204),
    [sym_range] = STATE(8204),
    [sym_binary] = STATE(8204),
    [sym_unary] = STATE(8204),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5882] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8205),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(8205),
    [sym_operator_assignment] = STATE(8205),
    [sym_conditional] = STATE(8205),
    [sym_range] = STATE(8205),
    [sym_binary] = STATE(8205),
    [sym_unary] = STATE(8205),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5883] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8206),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8206),
    [sym_operator_assignment] = STATE(8206),
    [sym_conditional] = STATE(8206),
    [sym_range] = STATE(8206),
    [sym_binary] = STATE(8206),
    [sym_unary] = STATE(8206),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5884] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8207),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(8207),
    [sym_operator_assignment] = STATE(8207),
    [sym_conditional] = STATE(8207),
    [sym_range] = STATE(8207),
    [sym_binary] = STATE(8207),
    [sym_unary] = STATE(8207),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5885] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8208),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(8208),
    [sym_operator_assignment] = STATE(8208),
    [sym_conditional] = STATE(8208),
    [sym_range] = STATE(8208),
    [sym_binary] = STATE(8208),
    [sym_unary] = STATE(8208),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5886] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8209),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(8209),
    [sym_operator_assignment] = STATE(8209),
    [sym_conditional] = STATE(8209),
    [sym_range] = STATE(8209),
    [sym_binary] = STATE(8209),
    [sym_unary] = STATE(8209),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5887] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8210),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(8210),
    [sym_operator_assignment] = STATE(8210),
    [sym_conditional] = STATE(8210),
    [sym_range] = STATE(8210),
    [sym_binary] = STATE(8210),
    [sym_unary] = STATE(8210),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5888] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3269),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(3269),
    [sym_operator_assignment] = STATE(3269),
    [sym_conditional] = STATE(3269),
    [sym_range] = STATE(3269),
    [sym_binary] = STATE(3269),
    [sym_unary] = STATE(3269),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5338),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5889] = {
    [aux_sym_exceptions_repeat1] = STATE(8211),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(8996),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_ensure] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [5890] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(3269),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_splat_argument] = STATE(8212),
    [sym_assignment] = STATE(3269),
    [sym_operator_assignment] = STATE(3269),
    [sym_conditional] = STATE(3269),
    [sym_range] = STATE(3269),
    [sym_binary] = STATE(3269),
    [sym_unary] = STATE(3269),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(8212),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5338),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5891] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8213),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(8213),
    [sym_operator_assignment] = STATE(8213),
    [sym_conditional] = STATE(8213),
    [sym_range] = STATE(8213),
    [sym_binary] = STATE(8213),
    [sym_unary] = STATE(8213),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5892] = {
    [sym__heredoc_body_start] = ACTIONS(6333),
    [sym__binary_minus] = ACTIONS(6333),
    [sym__binary_star] = ACTIONS(6333),
    [anon_sym_LBRACE] = ACTIONS(6333),
    [anon_sym_RBRACE] = ACTIONS(6333),
    [anon_sym_RPAREN] = ACTIONS(6333),
    [anon_sym_DOT] = ACTIONS(6335),
    [anon_sym_COMMA] = ACTIONS(6333),
    [anon_sym_PIPE] = ACTIONS(6335),
    [anon_sym_SEMI] = ACTIONS(6333),
    [anon_sym_STAR_STAR] = ACTIONS(6333),
    [anon_sym_AMP] = ACTIONS(6335),
    [anon_sym_EQ] = ACTIONS(6335),
    [anon_sym_LT] = ACTIONS(6335),
    [anon_sym_if] = ACTIONS(6333),
    [anon_sym_unless] = ACTIONS(6333),
    [anon_sym_while] = ACTIONS(6333),
    [anon_sym_until] = ACTIONS(6333),
    [anon_sym_rescue] = ACTIONS(6333),
    [anon_sym_in] = ACTIONS(6333),
    [anon_sym_do] = ACTIONS(6333),
    [anon_sym_EQ_GT] = ACTIONS(6333),
    [anon_sym_LBRACK] = ACTIONS(6333),
    [anon_sym_RBRACK] = ACTIONS(6333),
    [anon_sym_COLON_COLON2] = ACTIONS(6333),
    [anon_sym_AMP_DOT] = ACTIONS(6333),
    [anon_sym_QMARK] = ACTIONS(6333),
    [anon_sym_COLON2] = ACTIONS(6335),
    [anon_sym_DOT_DOT] = ACTIONS(6335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6333),
    [anon_sym_and] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE] = ACTIONS(6333),
    [anon_sym_AMP_AMP] = ACTIONS(6333),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_EQ_EQ] = ACTIONS(6335),
    [anon_sym_BANG_EQ] = ACTIONS(6333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6333),
    [anon_sym_LT_EQ_GT] = ACTIONS(6333),
    [anon_sym_EQ_TILDE] = ACTIONS(6333),
    [anon_sym_BANG_TILDE] = ACTIONS(6333),
    [anon_sym_LT_EQ] = ACTIONS(6335),
    [anon_sym_GT] = ACTIONS(6335),
    [anon_sym_GT_EQ] = ACTIONS(6333),
    [anon_sym_CARET] = ACTIONS(6333),
    [anon_sym_PLUS] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6333),
    [anon_sym_PERCENT] = ACTIONS(6333),
    [sym_comment] = ACTIONS(87),
  },
  [5893] = {
    [sym__heredoc_body_start] = ACTIONS(6337),
    [sym__binary_minus] = ACTIONS(6337),
    [sym__binary_star] = ACTIONS(6337),
    [anon_sym_LBRACE] = ACTIONS(6337),
    [anon_sym_RBRACE] = ACTIONS(6337),
    [anon_sym_RPAREN] = ACTIONS(6337),
    [anon_sym_DOT] = ACTIONS(6339),
    [anon_sym_COMMA] = ACTIONS(6337),
    [anon_sym_PIPE] = ACTIONS(6339),
    [anon_sym_SEMI] = ACTIONS(6337),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_AMP] = ACTIONS(6339),
    [anon_sym_EQ] = ACTIONS(6339),
    [anon_sym_LT] = ACTIONS(6339),
    [anon_sym_if] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6337),
    [anon_sym_while] = ACTIONS(6337),
    [anon_sym_until] = ACTIONS(6337),
    [anon_sym_rescue] = ACTIONS(6337),
    [anon_sym_in] = ACTIONS(6337),
    [anon_sym_do] = ACTIONS(6337),
    [anon_sym_EQ_GT] = ACTIONS(6337),
    [anon_sym_LBRACK] = ACTIONS(6337),
    [anon_sym_RBRACK] = ACTIONS(6337),
    [anon_sym_COLON_COLON2] = ACTIONS(6337),
    [anon_sym_AMP_DOT] = ACTIONS(6337),
    [anon_sym_QMARK] = ACTIONS(6337),
    [anon_sym_COLON2] = ACTIONS(6339),
    [anon_sym_DOT_DOT] = ACTIONS(6339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6337),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6337),
    [anon_sym_AMP_AMP] = ACTIONS(6337),
    [anon_sym_LT_LT] = ACTIONS(6337),
    [anon_sym_GT_GT] = ACTIONS(6337),
    [anon_sym_EQ_EQ] = ACTIONS(6339),
    [anon_sym_BANG_EQ] = ACTIONS(6337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6337),
    [anon_sym_LT_EQ_GT] = ACTIONS(6337),
    [anon_sym_EQ_TILDE] = ACTIONS(6337),
    [anon_sym_BANG_TILDE] = ACTIONS(6337),
    [anon_sym_LT_EQ] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6339),
    [anon_sym_GT_EQ] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [anon_sym_PLUS] = ACTIONS(6337),
    [anon_sym_SLASH] = ACTIONS(6337),
    [anon_sym_PERCENT] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
  },
  [5894] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11477),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [5895] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(11477),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11479),
  },
  [5896] = {
    [sym__heredoc_body_start] = ACTIONS(6345),
    [sym__binary_minus] = ACTIONS(6345),
    [sym__binary_star] = ACTIONS(6345),
    [anon_sym_LBRACE] = ACTIONS(6345),
    [anon_sym_RBRACE] = ACTIONS(6345),
    [anon_sym_RPAREN] = ACTIONS(6345),
    [anon_sym_DOT] = ACTIONS(6347),
    [anon_sym_COMMA] = ACTIONS(6345),
    [anon_sym_PIPE] = ACTIONS(6347),
    [anon_sym_SEMI] = ACTIONS(6345),
    [anon_sym_STAR_STAR] = ACTIONS(6345),
    [anon_sym_AMP] = ACTIONS(6347),
    [anon_sym_EQ] = ACTIONS(6347),
    [anon_sym_LT] = ACTIONS(6347),
    [anon_sym_if] = ACTIONS(6345),
    [anon_sym_unless] = ACTIONS(6345),
    [anon_sym_while] = ACTIONS(6345),
    [anon_sym_until] = ACTIONS(6345),
    [anon_sym_rescue] = ACTIONS(6345),
    [anon_sym_in] = ACTIONS(6345),
    [anon_sym_do] = ACTIONS(6345),
    [anon_sym_EQ_GT] = ACTIONS(6345),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_RBRACK] = ACTIONS(6345),
    [anon_sym_COLON_COLON2] = ACTIONS(6345),
    [anon_sym_AMP_DOT] = ACTIONS(6345),
    [anon_sym_QMARK] = ACTIONS(6345),
    [anon_sym_COLON2] = ACTIONS(6347),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6345),
    [anon_sym_and] = ACTIONS(6345),
    [anon_sym_or] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE] = ACTIONS(6345),
    [anon_sym_AMP_AMP] = ACTIONS(6345),
    [anon_sym_LT_LT] = ACTIONS(6345),
    [anon_sym_GT_GT] = ACTIONS(6345),
    [anon_sym_EQ_EQ] = ACTIONS(6347),
    [anon_sym_BANG_EQ] = ACTIONS(6345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6345),
    [anon_sym_LT_EQ_GT] = ACTIONS(6345),
    [anon_sym_EQ_TILDE] = ACTIONS(6345),
    [anon_sym_BANG_TILDE] = ACTIONS(6345),
    [anon_sym_LT_EQ] = ACTIONS(6347),
    [anon_sym_GT] = ACTIONS(6347),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_CARET] = ACTIONS(6345),
    [anon_sym_PLUS] = ACTIONS(6345),
    [anon_sym_SLASH] = ACTIONS(6345),
    [anon_sym_PERCENT] = ACTIONS(6345),
    [sym_comment] = ACTIONS(87),
  },
  [5897] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11481),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [5898] = {
    [sym__heredoc_body_start] = ACTIONS(6358),
    [sym__binary_minus] = ACTIONS(6358),
    [sym__binary_star] = ACTIONS(6358),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RBRACE] = ACTIONS(6358),
    [anon_sym_RPAREN] = ACTIONS(6358),
    [anon_sym_DOT] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6360),
    [anon_sym_SEMI] = ACTIONS(6358),
    [anon_sym_STAR_STAR] = ACTIONS(6358),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6360),
    [anon_sym_if] = ACTIONS(6358),
    [anon_sym_unless] = ACTIONS(6358),
    [anon_sym_while] = ACTIONS(6358),
    [anon_sym_until] = ACTIONS(6358),
    [anon_sym_rescue] = ACTIONS(6358),
    [anon_sym_in] = ACTIONS(6358),
    [anon_sym_do] = ACTIONS(6358),
    [anon_sym_EQ_GT] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6358),
    [anon_sym_RBRACK] = ACTIONS(6358),
    [anon_sym_COLON_COLON2] = ACTIONS(6358),
    [anon_sym_AMP_DOT] = ACTIONS(6358),
    [anon_sym_QMARK] = ACTIONS(6358),
    [anon_sym_COLON2] = ACTIONS(6360),
    [anon_sym_DOT_DOT] = ACTIONS(6360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6358),
    [anon_sym_and] = ACTIONS(6358),
    [anon_sym_or] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE] = ACTIONS(6358),
    [anon_sym_AMP_AMP] = ACTIONS(6358),
    [anon_sym_LT_LT] = ACTIONS(6358),
    [anon_sym_GT_GT] = ACTIONS(6358),
    [anon_sym_EQ_EQ] = ACTIONS(6360),
    [anon_sym_BANG_EQ] = ACTIONS(6358),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6358),
    [anon_sym_LT_EQ_GT] = ACTIONS(6358),
    [anon_sym_EQ_TILDE] = ACTIONS(6358),
    [anon_sym_BANG_TILDE] = ACTIONS(6358),
    [anon_sym_LT_EQ] = ACTIONS(6360),
    [anon_sym_GT] = ACTIONS(6360),
    [anon_sym_GT_EQ] = ACTIONS(6358),
    [anon_sym_CARET] = ACTIONS(6358),
    [anon_sym_PLUS] = ACTIONS(6358),
    [anon_sym_SLASH] = ACTIONS(6358),
    [anon_sym_PERCENT] = ACTIONS(6358),
    [sym_comment] = ACTIONS(87),
  },
  [5899] = {
    [sym__heredoc_body_start] = ACTIONS(6362),
    [sym__binary_minus] = ACTIONS(6362),
    [sym__binary_star] = ACTIONS(6362),
    [anon_sym_LBRACE] = ACTIONS(6362),
    [anon_sym_RBRACE] = ACTIONS(6362),
    [anon_sym_RPAREN] = ACTIONS(6362),
    [anon_sym_DOT] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6364),
    [anon_sym_SEMI] = ACTIONS(6362),
    [anon_sym_STAR_STAR] = ACTIONS(6362),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6364),
    [anon_sym_if] = ACTIONS(6362),
    [anon_sym_unless] = ACTIONS(6362),
    [anon_sym_while] = ACTIONS(6362),
    [anon_sym_until] = ACTIONS(6362),
    [anon_sym_rescue] = ACTIONS(6362),
    [anon_sym_in] = ACTIONS(6362),
    [anon_sym_do] = ACTIONS(6362),
    [anon_sym_EQ_GT] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6362),
    [anon_sym_RBRACK] = ACTIONS(6362),
    [anon_sym_COLON_COLON2] = ACTIONS(6362),
    [anon_sym_AMP_DOT] = ACTIONS(6362),
    [anon_sym_QMARK] = ACTIONS(6362),
    [anon_sym_COLON2] = ACTIONS(6364),
    [anon_sym_DOT_DOT] = ACTIONS(6364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6362),
    [anon_sym_and] = ACTIONS(6362),
    [anon_sym_or] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE] = ACTIONS(6362),
    [anon_sym_AMP_AMP] = ACTIONS(6362),
    [anon_sym_LT_LT] = ACTIONS(6362),
    [anon_sym_GT_GT] = ACTIONS(6362),
    [anon_sym_EQ_EQ] = ACTIONS(6364),
    [anon_sym_BANG_EQ] = ACTIONS(6362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6362),
    [anon_sym_LT_EQ_GT] = ACTIONS(6362),
    [anon_sym_EQ_TILDE] = ACTIONS(6362),
    [anon_sym_BANG_TILDE] = ACTIONS(6362),
    [anon_sym_LT_EQ] = ACTIONS(6364),
    [anon_sym_GT] = ACTIONS(6364),
    [anon_sym_GT_EQ] = ACTIONS(6362),
    [anon_sym_CARET] = ACTIONS(6362),
    [anon_sym_PLUS] = ACTIONS(6362),
    [anon_sym_SLASH] = ACTIONS(6362),
    [anon_sym_PERCENT] = ACTIONS(6362),
    [sym_comment] = ACTIONS(87),
  },
  [5900] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11483),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [5901] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(11483),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11485),
  },
  [5902] = {
    [sym__heredoc_body_start] = ACTIONS(6370),
    [sym__binary_minus] = ACTIONS(6370),
    [sym__binary_star] = ACTIONS(6370),
    [anon_sym_LBRACE] = ACTIONS(6370),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_RPAREN] = ACTIONS(6370),
    [anon_sym_DOT] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym_STAR_STAR] = ACTIONS(6370),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_if] = ACTIONS(6370),
    [anon_sym_unless] = ACTIONS(6370),
    [anon_sym_while] = ACTIONS(6370),
    [anon_sym_until] = ACTIONS(6370),
    [anon_sym_rescue] = ACTIONS(6370),
    [anon_sym_in] = ACTIONS(6370),
    [anon_sym_do] = ACTIONS(6370),
    [anon_sym_EQ_GT] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6370),
    [anon_sym_RBRACK] = ACTIONS(6370),
    [anon_sym_COLON_COLON2] = ACTIONS(6370),
    [anon_sym_AMP_DOT] = ACTIONS(6370),
    [anon_sym_QMARK] = ACTIONS(6370),
    [anon_sym_COLON2] = ACTIONS(6372),
    [anon_sym_DOT_DOT] = ACTIONS(6372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6370),
    [anon_sym_and] = ACTIONS(6370),
    [anon_sym_or] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_LT_LT] = ACTIONS(6370),
    [anon_sym_GT_GT] = ACTIONS(6370),
    [anon_sym_EQ_EQ] = ACTIONS(6372),
    [anon_sym_BANG_EQ] = ACTIONS(6370),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6370),
    [anon_sym_LT_EQ_GT] = ACTIONS(6370),
    [anon_sym_EQ_TILDE] = ACTIONS(6370),
    [anon_sym_BANG_TILDE] = ACTIONS(6370),
    [anon_sym_LT_EQ] = ACTIONS(6372),
    [anon_sym_GT] = ACTIONS(6372),
    [anon_sym_GT_EQ] = ACTIONS(6370),
    [anon_sym_CARET] = ACTIONS(6370),
    [anon_sym_PLUS] = ACTIONS(6370),
    [anon_sym_SLASH] = ACTIONS(6370),
    [anon_sym_PERCENT] = ACTIONS(6370),
    [sym_comment] = ACTIONS(87),
  },
  [5903] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11487),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [5904] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8220),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(8220),
    [sym_operator_assignment] = STATE(8220),
    [sym_conditional] = STATE(8220),
    [sym_range] = STATE(8220),
    [sym_binary] = STATE(8220),
    [sym_unary] = STATE(8220),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5905] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8221),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(8221),
    [sym_operator_assignment] = STATE(8221),
    [sym_conditional] = STATE(8221),
    [sym_range] = STATE(8221),
    [sym_binary] = STATE(8221),
    [sym_unary] = STATE(8221),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5906] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5907] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_RBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [5908] = {
    [anon_sym_EQ] = ACTIONS(11515),
    [sym_comment] = ACTIONS(87),
  },
  [5909] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11517),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11519),
    [anon_sym_DASH_EQ] = ACTIONS(11519),
    [anon_sym_STAR_EQ] = ACTIONS(11519),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11519),
    [anon_sym_SLASH_EQ] = ACTIONS(11519),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11519),
    [anon_sym_PIPE_EQ] = ACTIONS(11519),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11519),
    [anon_sym_AMP_EQ] = ACTIONS(11519),
    [anon_sym_PERCENT_EQ] = ACTIONS(11519),
    [anon_sym_GT_GT_EQ] = ACTIONS(11519),
    [anon_sym_LT_LT_EQ] = ACTIONS(11519),
    [anon_sym_CARET_EQ] = ACTIONS(11519),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5910] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_RBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [5911] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8234),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(8234),
    [sym_operator_assignment] = STATE(8234),
    [sym_conditional] = STATE(8234),
    [sym_range] = STATE(8234),
    [sym_binary] = STATE(8234),
    [sym_unary] = STATE(8234),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5912] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_RBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [5913] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8235),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(8235),
    [sym_operator_assignment] = STATE(8235),
    [sym_conditional] = STATE(8235),
    [sym_range] = STATE(8235),
    [sym_binary] = STATE(8235),
    [sym_unary] = STATE(8235),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5914] = {
    [sym_heredoc_body] = STATE(8236),
    [aux_sym_call_repeat1] = STATE(8236),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5915] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3300),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(3300),
    [sym_operator_assignment] = STATE(3300),
    [sym_conditional] = STATE(3300),
    [sym_range] = STATE(3300),
    [sym_binary] = STATE(3300),
    [sym_unary] = STATE(3300),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3303),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(8237),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5386),
    [sym__splat_star] = ACTIONS(5388),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__identifier_hash_key] = ACTIONS(5390),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11521),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(5392),
    [sym_identifier] = ACTIONS(5392),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5916] = {
    [sym_heredoc_body] = STATE(8238),
    [aux_sym_call_repeat1] = STATE(8238),
    [aux_sym_argument_list_repeat1] = STATE(8239),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9043),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [5917] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [5918] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [5919] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [5920] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [5921] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [5922] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11523),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5923] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [5924] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [5925] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [5926] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [5927] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8241),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(8241),
    [sym_operator_assignment] = STATE(8241),
    [sym_conditional] = STATE(8241),
    [sym_range] = STATE(8241),
    [sym_binary] = STATE(8241),
    [sym_unary] = STATE(8241),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [5928] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3320),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(6452),
    [sym__argument_list_with_parens] = STATE(3321),
    [sym__argument] = STATE(3322),
    [sym_splat_argument] = STATE(3322),
    [sym_hash_splat_argument] = STATE(3322),
    [sym_block_argument] = STATE(3322),
    [sym_assignment] = STATE(3320),
    [sym_operator_assignment] = STATE(3320),
    [sym_conditional] = STATE(3320),
    [sym_range] = STATE(3320),
    [sym_binary] = STATE(3320),
    [sym_unary] = STATE(3320),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3323),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3322),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5422),
    [sym__splat_star] = ACTIONS(5424),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5426),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(5428),
    [sym_identifier] = ACTIONS(5428),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5929] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3320),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(6453),
    [sym__argument_list_with_parens] = STATE(3321),
    [sym__argument] = STATE(3322),
    [sym_splat_argument] = STATE(3322),
    [sym_hash_splat_argument] = STATE(3322),
    [sym_block_argument] = STATE(3322),
    [sym_assignment] = STATE(3320),
    [sym_operator_assignment] = STATE(3320),
    [sym_conditional] = STATE(3320),
    [sym_range] = STATE(3320),
    [sym_binary] = STATE(3320),
    [sym_unary] = STATE(3320),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3323),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3322),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5422),
    [sym__splat_star] = ACTIONS(5424),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5426),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(5428),
    [sym_identifier] = ACTIONS(5428),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5930] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3320),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(6454),
    [sym__argument_list_with_parens] = STATE(3321),
    [sym__argument] = STATE(3322),
    [sym_splat_argument] = STATE(3322),
    [sym_hash_splat_argument] = STATE(3322),
    [sym_block_argument] = STATE(3322),
    [sym_assignment] = STATE(3320),
    [sym_operator_assignment] = STATE(3320),
    [sym_conditional] = STATE(3320),
    [sym_range] = STATE(3320),
    [sym_binary] = STATE(3320),
    [sym_unary] = STATE(3320),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3323),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3322),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5422),
    [sym__splat_star] = ACTIONS(5424),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5426),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(5428),
    [sym_identifier] = ACTIONS(5428),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5931] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3320),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(6455),
    [sym__argument_list_with_parens] = STATE(3321),
    [sym__argument] = STATE(3322),
    [sym_splat_argument] = STATE(3322),
    [sym_hash_splat_argument] = STATE(3322),
    [sym_block_argument] = STATE(3322),
    [sym_assignment] = STATE(3320),
    [sym_operator_assignment] = STATE(3320),
    [sym_conditional] = STATE(3320),
    [sym_range] = STATE(3320),
    [sym_binary] = STATE(3320),
    [sym_unary] = STATE(3320),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3323),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3322),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5422),
    [sym__splat_star] = ACTIONS(5424),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5426),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(5428),
    [sym_identifier] = ACTIONS(5428),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5932] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8242),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(8242),
    [sym_operator_assignment] = STATE(8242),
    [sym_conditional] = STATE(8242),
    [sym_range] = STATE(8242),
    [sym_binary] = STATE(8242),
    [sym_unary] = STATE(8242),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [5933] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6470),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(6470),
    [sym_operator_assignment] = STATE(6470),
    [sym_conditional] = STATE(6470),
    [sym_range] = STATE(6470),
    [sym_binary] = STATE(6470),
    [sym_unary] = STATE(6470),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [5934] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_RBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(11537),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [5935] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3320),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_argument_list] = STATE(4737),
    [sym__argument_list_with_parens] = STATE(3321),
    [sym__argument] = STATE(3322),
    [sym_splat_argument] = STATE(3322),
    [sym_hash_splat_argument] = STATE(3322),
    [sym_block_argument] = STATE(3322),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(3320),
    [sym_operator_assignment] = STATE(3320),
    [sym_conditional] = STATE(3320),
    [sym_range] = STATE(3320),
    [sym_binary] = STATE(3320),
    [sym_unary] = STATE(3320),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3323),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3322),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5422),
    [sym__splat_star] = ACTIONS(5424),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5426),
    [anon_sym_LBRACE] = ACTIONS(7471),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_RBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(5428),
    [sym_identifier] = ACTIONS(5428),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5936] = {
    [anon_sym_EQ] = ACTIONS(11553),
    [sym_comment] = ACTIONS(87),
  },
  [5937] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11555),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11557),
    [anon_sym_DASH_EQ] = ACTIONS(11557),
    [anon_sym_STAR_EQ] = ACTIONS(11557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11557),
    [anon_sym_SLASH_EQ] = ACTIONS(11557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11557),
    [anon_sym_PIPE_EQ] = ACTIONS(11557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11557),
    [anon_sym_AMP_EQ] = ACTIONS(11557),
    [anon_sym_PERCENT_EQ] = ACTIONS(11557),
    [anon_sym_GT_GT_EQ] = ACTIONS(11557),
    [anon_sym_LT_LT_EQ] = ACTIONS(11557),
    [anon_sym_CARET_EQ] = ACTIONS(11557),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5938] = {
    [sym_string] = STATE(8255),
    [aux_sym_chained_string_repeat1] = STATE(8255),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5939] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_RBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11537),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [5940] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8256),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(8256),
    [sym_operator_assignment] = STATE(8256),
    [sym_conditional] = STATE(8256),
    [sym_range] = STATE(8256),
    [sym_binary] = STATE(8256),
    [sym_unary] = STATE(8256),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [5941] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_RBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(11537),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [5942] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8257),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(8257),
    [sym_operator_assignment] = STATE(8257),
    [sym_conditional] = STATE(8257),
    [sym_range] = STATE(8257),
    [sym_binary] = STATE(8257),
    [sym_unary] = STATE(8257),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [5943] = {
    [sym_heredoc_body] = STATE(8258),
    [aux_sym_call_repeat1] = STATE(8258),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5944] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3320),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym__argument] = STATE(6514),
    [sym_splat_argument] = STATE(6514),
    [sym_hash_splat_argument] = STATE(6514),
    [sym_block_argument] = STATE(6514),
    [sym_assignment] = STATE(3320),
    [sym_operator_assignment] = STATE(3320),
    [sym_conditional] = STATE(3320),
    [sym_range] = STATE(3320),
    [sym_binary] = STATE(3320),
    [sym_unary] = STATE(3320),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3323),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(8259),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6514),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5422),
    [sym__splat_star] = ACTIONS(5424),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__identifier_hash_key] = ACTIONS(5426),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(5428),
    [sym_identifier] = ACTIONS(5428),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [5945] = {
    [sym_heredoc_body] = STATE(8260),
    [aux_sym_call_repeat1] = STATE(8260),
    [aux_sym_argument_list_repeat1] = STATE(8261),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9073),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_RBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [5946] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8262),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(8262),
    [sym_operator_assignment] = STATE(8262),
    [sym_conditional] = STATE(8262),
    [sym_range] = STATE(8262),
    [sym_binary] = STATE(8262),
    [sym_unary] = STATE(8262),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5947] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [5948] = {
    [aux_sym_exceptions_repeat1] = STATE(8264),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [5949] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [5950] = {
    [sym_string] = STATE(5950),
    [aux_sym_chained_string_repeat1] = STATE(5950),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_RBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [5951] = {
    [sym__heredoc_body_start] = ACTIONS(6894),
    [sym__binary_minus] = ACTIONS(6894),
    [sym__binary_star] = ACTIONS(6894),
    [anon_sym_LBRACE] = ACTIONS(6894),
    [anon_sym_RBRACE] = ACTIONS(6894),
    [anon_sym_RPAREN] = ACTIONS(6894),
    [anon_sym_DOT] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_SEMI] = ACTIONS(6894),
    [anon_sym_STAR_STAR] = ACTIONS(6894),
    [anon_sym_AMP] = ACTIONS(6896),
    [anon_sym_EQ] = ACTIONS(6896),
    [anon_sym_LT] = ACTIONS(6896),
    [anon_sym_if] = ACTIONS(6894),
    [anon_sym_unless] = ACTIONS(6894),
    [anon_sym_while] = ACTIONS(6894),
    [anon_sym_until] = ACTIONS(6894),
    [anon_sym_rescue] = ACTIONS(6894),
    [anon_sym_in] = ACTIONS(6894),
    [anon_sym_do] = ACTIONS(6894),
    [anon_sym_EQ_GT] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6894),
    [anon_sym_RBRACK] = ACTIONS(6894),
    [anon_sym_COLON_COLON2] = ACTIONS(6894),
    [anon_sym_AMP_DOT] = ACTIONS(6894),
    [anon_sym_QMARK] = ACTIONS(6894),
    [anon_sym_COLON2] = ACTIONS(6896),
    [anon_sym_DOT_DOT] = ACTIONS(6896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6894),
    [anon_sym_and] = ACTIONS(6894),
    [anon_sym_or] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE] = ACTIONS(6894),
    [anon_sym_AMP_AMP] = ACTIONS(6894),
    [anon_sym_LT_LT] = ACTIONS(6894),
    [anon_sym_GT_GT] = ACTIONS(6894),
    [anon_sym_EQ_EQ] = ACTIONS(6896),
    [anon_sym_BANG_EQ] = ACTIONS(6894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6894),
    [anon_sym_LT_EQ_GT] = ACTIONS(6894),
    [anon_sym_EQ_TILDE] = ACTIONS(6894),
    [anon_sym_BANG_TILDE] = ACTIONS(6894),
    [anon_sym_LT_EQ] = ACTIONS(6896),
    [anon_sym_GT] = ACTIONS(6896),
    [anon_sym_GT_EQ] = ACTIONS(6894),
    [anon_sym_CARET] = ACTIONS(6894),
    [anon_sym_PLUS] = ACTIONS(6894),
    [anon_sym_SLASH] = ACTIONS(6894),
    [anon_sym_PERCENT] = ACTIONS(6894),
    [sym_comment] = ACTIONS(87),
  },
  [5952] = {
    [anon_sym_DOT] = ACTIONS(11561),
    [anon_sym_COLON_COLON] = ACTIONS(11561),
    [sym_comment] = ACTIONS(87),
  },
  [5953] = {
    [sym__heredoc_body_start] = ACTIONS(7046),
    [sym__binary_minus] = ACTIONS(7046),
    [sym__binary_star] = ACTIONS(7046),
    [anon_sym_LBRACE] = ACTIONS(7046),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7046),
    [anon_sym_DOT] = ACTIONS(7048),
    [anon_sym_COMMA] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_STAR_STAR] = ACTIONS(7046),
    [anon_sym_AMP] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7048),
    [anon_sym_if] = ACTIONS(7046),
    [anon_sym_unless] = ACTIONS(7046),
    [anon_sym_while] = ACTIONS(7046),
    [anon_sym_until] = ACTIONS(7046),
    [anon_sym_rescue] = ACTIONS(7046),
    [anon_sym_in] = ACTIONS(7046),
    [anon_sym_do] = ACTIONS(7046),
    [anon_sym_EQ_GT] = ACTIONS(7046),
    [anon_sym_LBRACK] = ACTIONS(7046),
    [anon_sym_RBRACK] = ACTIONS(7046),
    [anon_sym_COLON_COLON2] = ACTIONS(7046),
    [anon_sym_AMP_DOT] = ACTIONS(7046),
    [anon_sym_QMARK] = ACTIONS(7046),
    [anon_sym_COLON2] = ACTIONS(7048),
    [anon_sym_DOT_DOT] = ACTIONS(7048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7046),
    [anon_sym_and] = ACTIONS(7046),
    [anon_sym_or] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE] = ACTIONS(7046),
    [anon_sym_AMP_AMP] = ACTIONS(7046),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_BANG_EQ] = ACTIONS(7046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT_EQ_GT] = ACTIONS(7046),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_BANG_TILDE] = ACTIONS(7046),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7046),
    [anon_sym_CARET] = ACTIONS(7046),
    [anon_sym_PLUS] = ACTIONS(7046),
    [anon_sym_SLASH] = ACTIONS(7046),
    [anon_sym_PERCENT] = ACTIONS(7046),
    [sym_comment] = ACTIONS(87),
  },
  [5954] = {
    [sym__heredoc_body_start] = ACTIONS(7062),
    [sym__binary_minus] = ACTIONS(7062),
    [sym__binary_star] = ACTIONS(7062),
    [anon_sym_LBRACE] = ACTIONS(7062),
    [anon_sym_RBRACE] = ACTIONS(7062),
    [anon_sym_RPAREN] = ACTIONS(7062),
    [anon_sym_DOT] = ACTIONS(7064),
    [anon_sym_COMMA] = ACTIONS(7062),
    [anon_sym_PIPE] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(7062),
    [anon_sym_STAR_STAR] = ACTIONS(7062),
    [anon_sym_AMP] = ACTIONS(7064),
    [anon_sym_EQ] = ACTIONS(7064),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_if] = ACTIONS(7062),
    [anon_sym_unless] = ACTIONS(7062),
    [anon_sym_while] = ACTIONS(7062),
    [anon_sym_until] = ACTIONS(7062),
    [anon_sym_rescue] = ACTIONS(7062),
    [anon_sym_in] = ACTIONS(7062),
    [anon_sym_do] = ACTIONS(7062),
    [anon_sym_EQ_GT] = ACTIONS(7062),
    [anon_sym_LBRACK] = ACTIONS(7062),
    [anon_sym_RBRACK] = ACTIONS(7062),
    [anon_sym_COLON_COLON2] = ACTIONS(7062),
    [anon_sym_AMP_DOT] = ACTIONS(7062),
    [anon_sym_QMARK] = ACTIONS(7062),
    [anon_sym_COLON2] = ACTIONS(7064),
    [anon_sym_DOT_DOT] = ACTIONS(7064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7062),
    [anon_sym_and] = ACTIONS(7062),
    [anon_sym_or] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE] = ACTIONS(7062),
    [anon_sym_AMP_AMP] = ACTIONS(7062),
    [anon_sym_LT_LT] = ACTIONS(7062),
    [anon_sym_GT_GT] = ACTIONS(7062),
    [anon_sym_EQ_EQ] = ACTIONS(7064),
    [anon_sym_BANG_EQ] = ACTIONS(7062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7062),
    [anon_sym_LT_EQ_GT] = ACTIONS(7062),
    [anon_sym_EQ_TILDE] = ACTIONS(7062),
    [anon_sym_BANG_TILDE] = ACTIONS(7062),
    [anon_sym_LT_EQ] = ACTIONS(7064),
    [anon_sym_GT] = ACTIONS(7064),
    [anon_sym_GT_EQ] = ACTIONS(7062),
    [anon_sym_CARET] = ACTIONS(7062),
    [anon_sym_PLUS] = ACTIONS(7062),
    [anon_sym_SLASH] = ACTIONS(7062),
    [anon_sym_PERCENT] = ACTIONS(7062),
    [sym_comment] = ACTIONS(87),
  },
  [5955] = {
    [sym__statements] = STATE(1328),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1329),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1330),
    [sym_rescue] = STATE(1331),
    [sym__body_statement] = STATE(8266),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11563),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5956] = {
    [sym__statements] = STATE(1328),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1329),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1330),
    [sym_rescue] = STATE(1331),
    [sym__body_statement] = STATE(8267),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11565),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5957] = {
    [sym__heredoc_body_start] = ACTIONS(7496),
    [sym__binary_minus] = ACTIONS(7496),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_LBRACE] = ACTIONS(7496),
    [anon_sym_RBRACE] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(7496),
    [anon_sym_DOT] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7496),
    [anon_sym_unless] = ACTIONS(7496),
    [anon_sym_while] = ACTIONS(7496),
    [anon_sym_until] = ACTIONS(7496),
    [anon_sym_rescue] = ACTIONS(7496),
    [anon_sym_in] = ACTIONS(7496),
    [anon_sym_do] = ACTIONS(7496),
    [anon_sym_EQ_GT] = ACTIONS(7496),
    [anon_sym_LBRACK] = ACTIONS(7496),
    [anon_sym_RBRACK] = ACTIONS(7496),
    [anon_sym_COLON_COLON2] = ACTIONS(7496),
    [anon_sym_AMP_DOT] = ACTIONS(7496),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_COLON2] = ACTIONS(7498),
    [anon_sym_DOT_DOT] = ACTIONS(7498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7496),
    [anon_sym_and] = ACTIONS(7496),
    [anon_sym_or] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT_LT] = ACTIONS(7496),
    [anon_sym_GT_GT] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7498),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7496),
    [anon_sym_LT_EQ_GT] = ACTIONS(7496),
    [anon_sym_EQ_TILDE] = ACTIONS(7496),
    [anon_sym_BANG_TILDE] = ACTIONS(7496),
    [anon_sym_LT_EQ] = ACTIONS(7498),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [5958] = {
    [sym__heredoc_body_start] = ACTIONS(7550),
    [sym__binary_minus] = ACTIONS(7550),
    [sym__binary_star] = ACTIONS(7550),
    [anon_sym_LBRACE] = ACTIONS(7550),
    [anon_sym_RBRACE] = ACTIONS(7550),
    [anon_sym_RPAREN] = ACTIONS(7550),
    [anon_sym_DOT] = ACTIONS(7552),
    [anon_sym_COMMA] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_SEMI] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7550),
    [anon_sym_unless] = ACTIONS(7550),
    [anon_sym_while] = ACTIONS(7550),
    [anon_sym_until] = ACTIONS(7550),
    [anon_sym_rescue] = ACTIONS(7550),
    [anon_sym_in] = ACTIONS(7550),
    [anon_sym_do] = ACTIONS(7550),
    [anon_sym_EQ_GT] = ACTIONS(7550),
    [anon_sym_LBRACK] = ACTIONS(7550),
    [anon_sym_RBRACK] = ACTIONS(7550),
    [anon_sym_COLON_COLON2] = ACTIONS(7550),
    [anon_sym_AMP_DOT] = ACTIONS(7550),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_COLON2] = ACTIONS(7552),
    [anon_sym_DOT_DOT] = ACTIONS(7552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7550),
    [anon_sym_and] = ACTIONS(7550),
    [anon_sym_or] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT_LT] = ACTIONS(7550),
    [anon_sym_GT_GT] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7552),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7550),
    [anon_sym_LT_EQ_GT] = ACTIONS(7550),
    [anon_sym_EQ_TILDE] = ACTIONS(7550),
    [anon_sym_BANG_TILDE] = ACTIONS(7550),
    [anon_sym_LT_EQ] = ACTIONS(7552),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_PERCENT] = ACTIONS(7550),
    [sym_comment] = ACTIONS(87),
  },
  [5959] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_RBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5960] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_RBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5961] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5962] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [5963] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5964] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5965] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5966] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [5967] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_RBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5968] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5969] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5970] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5971] = {
    [sym_heredoc_body] = STATE(5971),
    [aux_sym_call_repeat1] = STATE(5971),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_RBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [5972] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1311),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(1311),
    [sym_operator_assignment] = STATE(1311),
    [sym_conditional] = STATE(1311),
    [sym_range] = STATE(1311),
    [sym_binary] = STATE(1311),
    [sym_unary] = STATE(1311),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1317),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2327),
    [sym__splat_star] = ACTIONS(2329),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__identifier_hash_key] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9095),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(2343),
    [sym_identifier] = ACTIONS(2343),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5973] = {
    [sym_heredoc_body] = STATE(5971),
    [aux_sym_call_repeat1] = STATE(5971),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_RBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [5974] = {
    [aux_sym_argument_list_repeat1] = STATE(5974),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(11569),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_RBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [5975] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_RBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5976] = {
    [aux_sym_exceptions_repeat1] = STATE(8270),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [5977] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_RBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [5978] = {
    [sym__heredoc_body_start] = ACTIONS(7724),
    [sym__binary_minus] = ACTIONS(7724),
    [sym__binary_star] = ACTIONS(7724),
    [anon_sym_LBRACE] = ACTIONS(7724),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_DOT] = ACTIONS(7726),
    [anon_sym_COMMA] = ACTIONS(7724),
    [anon_sym_PIPE] = ACTIONS(7726),
    [anon_sym_SEMI] = ACTIONS(7724),
    [anon_sym_STAR_STAR] = ACTIONS(7724),
    [anon_sym_AMP] = ACTIONS(7726),
    [anon_sym_EQ] = ACTIONS(7726),
    [anon_sym_LT] = ACTIONS(7726),
    [anon_sym_if] = ACTIONS(7724),
    [anon_sym_unless] = ACTIONS(7724),
    [anon_sym_while] = ACTIONS(7724),
    [anon_sym_until] = ACTIONS(7724),
    [anon_sym_rescue] = ACTIONS(7724),
    [anon_sym_in] = ACTIONS(7724),
    [anon_sym_do] = ACTIONS(7724),
    [anon_sym_EQ_GT] = ACTIONS(7724),
    [anon_sym_LBRACK] = ACTIONS(7724),
    [anon_sym_RBRACK] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(7724),
    [anon_sym_AMP_DOT] = ACTIONS(7724),
    [anon_sym_QMARK] = ACTIONS(7724),
    [anon_sym_COLON2] = ACTIONS(7726),
    [anon_sym_DOT_DOT] = ACTIONS(7726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7724),
    [anon_sym_and] = ACTIONS(7724),
    [anon_sym_or] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE] = ACTIONS(7724),
    [anon_sym_AMP_AMP] = ACTIONS(7724),
    [anon_sym_LT_LT] = ACTIONS(7724),
    [anon_sym_GT_GT] = ACTIONS(7724),
    [anon_sym_EQ_EQ] = ACTIONS(7726),
    [anon_sym_BANG_EQ] = ACTIONS(7724),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7724),
    [anon_sym_LT_EQ_GT] = ACTIONS(7724),
    [anon_sym_EQ_TILDE] = ACTIONS(7724),
    [anon_sym_BANG_TILDE] = ACTIONS(7724),
    [anon_sym_LT_EQ] = ACTIONS(7726),
    [anon_sym_GT] = ACTIONS(7726),
    [anon_sym_GT_EQ] = ACTIONS(7724),
    [anon_sym_CARET] = ACTIONS(7724),
    [anon_sym_PLUS] = ACTIONS(7724),
    [anon_sym_SLASH] = ACTIONS(7724),
    [anon_sym_PERCENT] = ACTIONS(7724),
    [sym_comment] = ACTIONS(87),
  },
  [5979] = {
    [sym_elsif] = STATE(8272),
    [sym_else] = STATE(8272),
    [sym__if_tail] = STATE(8272),
    [anon_sym_end] = ACTIONS(11572),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [5980] = {
    [anon_sym_end] = ACTIONS(11572),
    [sym_comment] = ACTIONS(87),
  },
  [5981] = {
    [sym__statements] = STATE(8273),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(8272),
    [sym_else] = STATE(8272),
    [sym__if_tail] = STATE(8272),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11574),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5982] = {
    [sym__heredoc_body_start] = ACTIONS(7922),
    [sym__binary_minus] = ACTIONS(7922),
    [sym__binary_star] = ACTIONS(7922),
    [anon_sym_LBRACE] = ACTIONS(7922),
    [anon_sym_RBRACE] = ACTIONS(7922),
    [anon_sym_RPAREN] = ACTIONS(7922),
    [anon_sym_DOT] = ACTIONS(7924),
    [anon_sym_COMMA] = ACTIONS(7922),
    [anon_sym_PIPE] = ACTIONS(7924),
    [anon_sym_SEMI] = ACTIONS(7922),
    [anon_sym_STAR_STAR] = ACTIONS(7922),
    [anon_sym_AMP] = ACTIONS(7924),
    [anon_sym_EQ] = ACTIONS(7924),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(7922),
    [anon_sym_unless] = ACTIONS(7922),
    [anon_sym_while] = ACTIONS(7922),
    [anon_sym_until] = ACTIONS(7922),
    [anon_sym_rescue] = ACTIONS(7922),
    [anon_sym_in] = ACTIONS(7922),
    [anon_sym_do] = ACTIONS(7922),
    [anon_sym_EQ_GT] = ACTIONS(7922),
    [anon_sym_LBRACK] = ACTIONS(7922),
    [anon_sym_RBRACK] = ACTIONS(7922),
    [anon_sym_COLON_COLON2] = ACTIONS(7922),
    [anon_sym_AMP_DOT] = ACTIONS(7922),
    [anon_sym_QMARK] = ACTIONS(7922),
    [anon_sym_COLON2] = ACTIONS(7924),
    [anon_sym_DOT_DOT] = ACTIONS(7924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7922),
    [anon_sym_and] = ACTIONS(7922),
    [anon_sym_or] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE] = ACTIONS(7922),
    [anon_sym_AMP_AMP] = ACTIONS(7922),
    [anon_sym_LT_LT] = ACTIONS(7922),
    [anon_sym_GT_GT] = ACTIONS(7922),
    [anon_sym_EQ_EQ] = ACTIONS(7924),
    [anon_sym_BANG_EQ] = ACTIONS(7922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7922),
    [anon_sym_LT_EQ_GT] = ACTIONS(7922),
    [anon_sym_EQ_TILDE] = ACTIONS(7922),
    [anon_sym_BANG_TILDE] = ACTIONS(7922),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7922),
    [anon_sym_CARET] = ACTIONS(7922),
    [anon_sym_PLUS] = ACTIONS(7922),
    [anon_sym_SLASH] = ACTIONS(7922),
    [anon_sym_PERCENT] = ACTIONS(7922),
    [sym_comment] = ACTIONS(87),
  },
  [5983] = {
    [sym_else] = STATE(8275),
    [anon_sym_end] = ACTIONS(11576),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [5984] = {
    [anon_sym_end] = ACTIONS(11576),
    [sym_comment] = ACTIONS(87),
  },
  [5985] = {
    [sym__heredoc_body_start] = ACTIONS(8090),
    [sym__binary_minus] = ACTIONS(8090),
    [sym__binary_star] = ACTIONS(8090),
    [anon_sym_LBRACE] = ACTIONS(8090),
    [anon_sym_RBRACE] = ACTIONS(8090),
    [anon_sym_RPAREN] = ACTIONS(8090),
    [anon_sym_DOT] = ACTIONS(8092),
    [anon_sym_COMMA] = ACTIONS(8090),
    [anon_sym_PIPE] = ACTIONS(8092),
    [anon_sym_SEMI] = ACTIONS(8090),
    [anon_sym_STAR_STAR] = ACTIONS(8090),
    [anon_sym_AMP] = ACTIONS(8092),
    [anon_sym_EQ] = ACTIONS(8092),
    [anon_sym_LT] = ACTIONS(8092),
    [anon_sym_if] = ACTIONS(8090),
    [anon_sym_unless] = ACTIONS(8090),
    [anon_sym_while] = ACTIONS(8090),
    [anon_sym_until] = ACTIONS(8090),
    [anon_sym_rescue] = ACTIONS(8090),
    [anon_sym_in] = ACTIONS(8090),
    [anon_sym_do] = ACTIONS(8090),
    [anon_sym_EQ_GT] = ACTIONS(8090),
    [anon_sym_LBRACK] = ACTIONS(8090),
    [anon_sym_RBRACK] = ACTIONS(8090),
    [anon_sym_COLON_COLON2] = ACTIONS(8090),
    [anon_sym_AMP_DOT] = ACTIONS(8090),
    [anon_sym_QMARK] = ACTIONS(8090),
    [anon_sym_COLON2] = ACTIONS(8092),
    [anon_sym_DOT_DOT] = ACTIONS(8092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8090),
    [anon_sym_and] = ACTIONS(8090),
    [anon_sym_or] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE] = ACTIONS(8090),
    [anon_sym_AMP_AMP] = ACTIONS(8090),
    [anon_sym_LT_LT] = ACTIONS(8090),
    [anon_sym_GT_GT] = ACTIONS(8090),
    [anon_sym_EQ_EQ] = ACTIONS(8092),
    [anon_sym_BANG_EQ] = ACTIONS(8090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8090),
    [anon_sym_LT_EQ_GT] = ACTIONS(8090),
    [anon_sym_EQ_TILDE] = ACTIONS(8090),
    [anon_sym_BANG_TILDE] = ACTIONS(8090),
    [anon_sym_LT_EQ] = ACTIONS(8092),
    [anon_sym_GT] = ACTIONS(8092),
    [anon_sym_GT_EQ] = ACTIONS(8090),
    [anon_sym_CARET] = ACTIONS(8090),
    [anon_sym_PLUS] = ACTIONS(8090),
    [anon_sym_SLASH] = ACTIONS(8090),
    [anon_sym_PERCENT] = ACTIONS(8090),
    [sym_comment] = ACTIONS(87),
  },
  [5986] = {
    [anon_sym_end] = ACTIONS(11578),
    [sym_comment] = ACTIONS(87),
  },
  [5987] = {
    [sym__heredoc_body_start] = ACTIONS(8166),
    [sym__binary_minus] = ACTIONS(8166),
    [sym__binary_star] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_DOT] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8166),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI] = ACTIONS(8166),
    [anon_sym_STAR_STAR] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_if] = ACTIONS(8166),
    [anon_sym_unless] = ACTIONS(8166),
    [anon_sym_while] = ACTIONS(8166),
    [anon_sym_until] = ACTIONS(8166),
    [anon_sym_rescue] = ACTIONS(8166),
    [anon_sym_in] = ACTIONS(8166),
    [anon_sym_do] = ACTIONS(8166),
    [anon_sym_EQ_GT] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_RBRACK] = ACTIONS(8166),
    [anon_sym_COLON_COLON2] = ACTIONS(8166),
    [anon_sym_AMP_DOT] = ACTIONS(8166),
    [anon_sym_QMARK] = ACTIONS(8166),
    [anon_sym_COLON2] = ACTIONS(8168),
    [anon_sym_DOT_DOT] = ACTIONS(8168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8166),
    [anon_sym_and] = ACTIONS(8166),
    [anon_sym_or] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8166),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ_GT] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_BANG_TILDE] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8166),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8166),
    [anon_sym_PERCENT] = ACTIONS(8166),
    [sym_comment] = ACTIONS(87),
  },
  [5988] = {
    [anon_sym_end] = ACTIONS(11580),
    [sym_comment] = ACTIONS(87),
  },
  [5989] = {
    [sym__statements] = STATE(8279),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11582),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5990] = {
    [anon_sym_end] = ACTIONS(11584),
    [sym_comment] = ACTIONS(87),
  },
  [5991] = {
    [sym_when] = STATE(8281),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [5992] = {
    [sym__heredoc_body_start] = ACTIONS(8414),
    [sym__binary_minus] = ACTIONS(8414),
    [sym__binary_star] = ACTIONS(8414),
    [anon_sym_LBRACE] = ACTIONS(8414),
    [anon_sym_RBRACE] = ACTIONS(8414),
    [anon_sym_RPAREN] = ACTIONS(8414),
    [anon_sym_DOT] = ACTIONS(8416),
    [anon_sym_COMMA] = ACTIONS(8414),
    [anon_sym_PIPE] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8414),
    [anon_sym_STAR_STAR] = ACTIONS(8414),
    [anon_sym_AMP] = ACTIONS(8416),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LT] = ACTIONS(8416),
    [anon_sym_if] = ACTIONS(8414),
    [anon_sym_unless] = ACTIONS(8414),
    [anon_sym_while] = ACTIONS(8414),
    [anon_sym_until] = ACTIONS(8414),
    [anon_sym_rescue] = ACTIONS(8414),
    [anon_sym_in] = ACTIONS(8414),
    [anon_sym_do] = ACTIONS(8414),
    [anon_sym_EQ_GT] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8414),
    [anon_sym_RBRACK] = ACTIONS(8414),
    [anon_sym_COLON_COLON2] = ACTIONS(8414),
    [anon_sym_AMP_DOT] = ACTIONS(8414),
    [anon_sym_QMARK] = ACTIONS(8414),
    [anon_sym_COLON2] = ACTIONS(8416),
    [anon_sym_DOT_DOT] = ACTIONS(8416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8414),
    [anon_sym_and] = ACTIONS(8414),
    [anon_sym_or] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE] = ACTIONS(8414),
    [anon_sym_AMP_AMP] = ACTIONS(8414),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8414),
    [anon_sym_LT_EQ_GT] = ACTIONS(8414),
    [anon_sym_EQ_TILDE] = ACTIONS(8414),
    [anon_sym_BANG_TILDE] = ACTIONS(8414),
    [anon_sym_LT_EQ] = ACTIONS(8416),
    [anon_sym_GT] = ACTIONS(8416),
    [anon_sym_GT_EQ] = ACTIONS(8414),
    [anon_sym_CARET] = ACTIONS(8414),
    [anon_sym_PLUS] = ACTIONS(8414),
    [anon_sym_SLASH] = ACTIONS(8414),
    [anon_sym_PERCENT] = ACTIONS(8414),
    [sym_comment] = ACTIONS(87),
  },
  [5993] = {
    [sym__heredoc_body_start] = ACTIONS(8923),
    [sym__binary_minus] = ACTIONS(8923),
    [sym__binary_star] = ACTIONS(8923),
    [anon_sym_LBRACE] = ACTIONS(8923),
    [anon_sym_RBRACE] = ACTIONS(8923),
    [anon_sym_RPAREN] = ACTIONS(8923),
    [anon_sym_DOT] = ACTIONS(8925),
    [anon_sym_COMMA] = ACTIONS(8923),
    [anon_sym_PIPE] = ACTIONS(8925),
    [anon_sym_SEMI] = ACTIONS(8923),
    [anon_sym_STAR_STAR] = ACTIONS(8923),
    [anon_sym_AMP] = ACTIONS(8925),
    [anon_sym_EQ] = ACTIONS(8925),
    [anon_sym_LT] = ACTIONS(8925),
    [anon_sym_if] = ACTIONS(8923),
    [anon_sym_unless] = ACTIONS(8923),
    [anon_sym_while] = ACTIONS(8923),
    [anon_sym_until] = ACTIONS(8923),
    [anon_sym_rescue] = ACTIONS(8923),
    [anon_sym_in] = ACTIONS(8923),
    [anon_sym_do] = ACTIONS(8923),
    [anon_sym_EQ_GT] = ACTIONS(8923),
    [anon_sym_LBRACK] = ACTIONS(8923),
    [anon_sym_RBRACK] = ACTIONS(8923),
    [anon_sym_COLON_COLON2] = ACTIONS(8923),
    [anon_sym_AMP_DOT] = ACTIONS(8923),
    [anon_sym_QMARK] = ACTIONS(8923),
    [anon_sym_COLON2] = ACTIONS(8925),
    [anon_sym_DOT_DOT] = ACTIONS(8925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8923),
    [anon_sym_and] = ACTIONS(8923),
    [anon_sym_or] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8923),
    [anon_sym_GT_GT] = ACTIONS(8923),
    [anon_sym_EQ_EQ] = ACTIONS(8925),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8925),
    [anon_sym_GT] = ACTIONS(8925),
    [anon_sym_GT_EQ] = ACTIONS(8923),
    [anon_sym_CARET] = ACTIONS(8923),
    [anon_sym_PLUS] = ACTIONS(8923),
    [anon_sym_SLASH] = ACTIONS(8923),
    [anon_sym_PERCENT] = ACTIONS(8923),
    [sym_comment] = ACTIONS(87),
  },
  [5994] = {
    [anon_sym_end] = ACTIONS(11586),
    [sym_comment] = ACTIONS(87),
  },
  [5995] = {
    [sym_ensure] = STATE(8283),
    [anon_sym_end] = ACTIONS(11586),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [5996] = {
    [sym__heredoc_body_start] = ACTIONS(9143),
    [sym__binary_minus] = ACTIONS(9143),
    [sym__binary_star] = ACTIONS(9143),
    [anon_sym_LBRACE] = ACTIONS(9143),
    [anon_sym_RBRACE] = ACTIONS(9143),
    [anon_sym_RPAREN] = ACTIONS(9143),
    [anon_sym_DOT] = ACTIONS(9145),
    [anon_sym_COMMA] = ACTIONS(9143),
    [anon_sym_PIPE] = ACTIONS(9145),
    [anon_sym_SEMI] = ACTIONS(9143),
    [anon_sym_STAR_STAR] = ACTIONS(9143),
    [anon_sym_AMP] = ACTIONS(9145),
    [anon_sym_EQ] = ACTIONS(9145),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_if] = ACTIONS(9143),
    [anon_sym_unless] = ACTIONS(9143),
    [anon_sym_while] = ACTIONS(9143),
    [anon_sym_until] = ACTIONS(9143),
    [anon_sym_rescue] = ACTIONS(9143),
    [anon_sym_in] = ACTIONS(9143),
    [anon_sym_do] = ACTIONS(9143),
    [anon_sym_EQ_GT] = ACTIONS(9143),
    [anon_sym_LBRACK] = ACTIONS(9143),
    [anon_sym_RBRACK] = ACTIONS(9143),
    [anon_sym_COLON_COLON2] = ACTIONS(9143),
    [anon_sym_AMP_DOT] = ACTIONS(9143),
    [anon_sym_QMARK] = ACTIONS(9143),
    [anon_sym_COLON2] = ACTIONS(9145),
    [anon_sym_DOT_DOT] = ACTIONS(9145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9143),
    [anon_sym_and] = ACTIONS(9143),
    [anon_sym_or] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE] = ACTIONS(9143),
    [anon_sym_AMP_AMP] = ACTIONS(9143),
    [anon_sym_LT_LT] = ACTIONS(9143),
    [anon_sym_GT_GT] = ACTIONS(9143),
    [anon_sym_EQ_EQ] = ACTIONS(9145),
    [anon_sym_BANG_EQ] = ACTIONS(9143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9143),
    [anon_sym_LT_EQ_GT] = ACTIONS(9143),
    [anon_sym_EQ_TILDE] = ACTIONS(9143),
    [anon_sym_BANG_TILDE] = ACTIONS(9143),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9143),
    [anon_sym_CARET] = ACTIONS(9143),
    [anon_sym_PLUS] = ACTIONS(9143),
    [anon_sym_SLASH] = ACTIONS(9143),
    [anon_sym_PERCENT] = ACTIONS(9143),
    [sym_comment] = ACTIONS(87),
  },
  [5997] = {
    [sym__heredoc_body_start] = ACTIONS(9172),
    [sym__binary_minus] = ACTIONS(9172),
    [sym__binary_star] = ACTIONS(9172),
    [anon_sym_LBRACE] = ACTIONS(9172),
    [anon_sym_RBRACE] = ACTIONS(9172),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9174),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9174),
    [anon_sym_SEMI] = ACTIONS(9172),
    [anon_sym_STAR_STAR] = ACTIONS(9172),
    [anon_sym_AMP] = ACTIONS(9174),
    [anon_sym_EQ] = ACTIONS(9174),
    [anon_sym_LT] = ACTIONS(9174),
    [anon_sym_if] = ACTIONS(9172),
    [anon_sym_unless] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(9172),
    [anon_sym_until] = ACTIONS(9172),
    [anon_sym_rescue] = ACTIONS(9172),
    [anon_sym_in] = ACTIONS(9172),
    [anon_sym_do] = ACTIONS(9172),
    [anon_sym_EQ_GT] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_RBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [anon_sym_QMARK] = ACTIONS(9172),
    [anon_sym_COLON2] = ACTIONS(9174),
    [anon_sym_DOT_DOT] = ACTIONS(9174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9172),
    [anon_sym_and] = ACTIONS(9172),
    [anon_sym_or] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE] = ACTIONS(9172),
    [anon_sym_AMP_AMP] = ACTIONS(9172),
    [anon_sym_LT_LT] = ACTIONS(9172),
    [anon_sym_GT_GT] = ACTIONS(9172),
    [anon_sym_EQ_EQ] = ACTIONS(9174),
    [anon_sym_BANG_EQ] = ACTIONS(9172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9172),
    [anon_sym_LT_EQ_GT] = ACTIONS(9172),
    [anon_sym_EQ_TILDE] = ACTIONS(9172),
    [anon_sym_BANG_TILDE] = ACTIONS(9172),
    [anon_sym_LT_EQ] = ACTIONS(9174),
    [anon_sym_GT] = ACTIONS(9174),
    [anon_sym_GT_EQ] = ACTIONS(9172),
    [anon_sym_CARET] = ACTIONS(9172),
    [anon_sym_PLUS] = ACTIONS(9172),
    [anon_sym_SLASH] = ACTIONS(9172),
    [anon_sym_PERCENT] = ACTIONS(9172),
    [sym_comment] = ACTIONS(87),
  },
  [5998] = {
    [anon_sym_RBRACE] = ACTIONS(11588),
    [sym_comment] = ACTIONS(87),
  },
  [5999] = {
    [sym__heredoc_body_start] = ACTIONS(9192),
    [sym__binary_minus] = ACTIONS(9192),
    [sym__binary_star] = ACTIONS(9192),
    [anon_sym_LBRACE] = ACTIONS(9192),
    [anon_sym_RBRACE] = ACTIONS(9192),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9194),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9194),
    [anon_sym_SEMI] = ACTIONS(9192),
    [anon_sym_STAR_STAR] = ACTIONS(9192),
    [anon_sym_AMP] = ACTIONS(9194),
    [anon_sym_EQ] = ACTIONS(9194),
    [anon_sym_LT] = ACTIONS(9194),
    [anon_sym_if] = ACTIONS(9192),
    [anon_sym_unless] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(9192),
    [anon_sym_until] = ACTIONS(9192),
    [anon_sym_rescue] = ACTIONS(9192),
    [anon_sym_in] = ACTIONS(9192),
    [anon_sym_do] = ACTIONS(9192),
    [anon_sym_EQ_GT] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_RBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [anon_sym_QMARK] = ACTIONS(9192),
    [anon_sym_COLON2] = ACTIONS(9194),
    [anon_sym_DOT_DOT] = ACTIONS(9194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9192),
    [anon_sym_and] = ACTIONS(9192),
    [anon_sym_or] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE] = ACTIONS(9192),
    [anon_sym_AMP_AMP] = ACTIONS(9192),
    [anon_sym_LT_LT] = ACTIONS(9192),
    [anon_sym_GT_GT] = ACTIONS(9192),
    [anon_sym_EQ_EQ] = ACTIONS(9194),
    [anon_sym_BANG_EQ] = ACTIONS(9192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9192),
    [anon_sym_LT_EQ_GT] = ACTIONS(9192),
    [anon_sym_EQ_TILDE] = ACTIONS(9192),
    [anon_sym_BANG_TILDE] = ACTIONS(9192),
    [anon_sym_LT_EQ] = ACTIONS(9194),
    [anon_sym_GT] = ACTIONS(9194),
    [anon_sym_GT_EQ] = ACTIONS(9192),
    [anon_sym_CARET] = ACTIONS(9192),
    [anon_sym_PLUS] = ACTIONS(9192),
    [anon_sym_SLASH] = ACTIONS(9192),
    [anon_sym_PERCENT] = ACTIONS(9192),
    [sym_comment] = ACTIONS(87),
  },
  [6000] = {
    [anon_sym_end] = ACTIONS(11590),
    [sym_comment] = ACTIONS(87),
  },
  [6001] = {
    [sym__statements] = STATE(8286),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11592),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6002] = {
    [sym__statements] = STATE(8286),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(8287),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(8287),
    [sym__line_break] = ACTIONS(11594),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11592),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6003] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8288),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_assignment] = STATE(8288),
    [sym_operator_assignment] = STATE(8288),
    [sym_conditional] = STATE(8288),
    [sym_range] = STATE(8288),
    [sym_binary] = STATE(8288),
    [sym_unary] = STATE(8288),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6004] = {
    [sym__simple_symbol] = ACTIONS(4148),
    [sym__string_start] = ACTIONS(4148),
    [sym__symbol_start] = ACTIONS(4148),
    [sym__subshell_start] = ACTIONS(4148),
    [sym__regex_start] = ACTIONS(4148),
    [sym__string_array_start] = ACTIONS(4148),
    [sym__symbol_array_start] = ACTIONS(4148),
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym_heredoc_beginning] = ACTIONS(4148),
    [sym__block_ampersand] = ACTIONS(4148),
    [sym__splat_star] = ACTIONS(4148),
    [sym__unary_minus] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [sym__identifier_hash_key] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_def] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(4150),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COLON_COLON] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_STAR_STAR] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_class] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_module] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_yield] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_next] = ACTIONS(4150),
    [sym_redo] = ACTIONS(4150),
    [sym_retry] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_unless] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [anon_sym_until] = ACTIONS(4150),
    [anon_sym_rescue] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_in] = ACTIONS(4150),
    [anon_sym_do] = ACTIONS(4150),
    [anon_sym_case] = ACTIONS(4150),
    [anon_sym_begin] = ACTIONS(4150),
    [anon_sym_EQ_GT] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_COLON2] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4150),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_defined_QMARK] = ACTIONS(4148),
    [anon_sym_not] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_TILDE] = ACTIONS(4148),
    [sym_constant] = ACTIONS(4150),
    [sym_identifier] = ACTIONS(4150),
    [sym_instance_variable] = ACTIONS(4148),
    [sym_class_variable] = ACTIONS(4148),
    [sym_global_variable] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4150),
    [sym_float] = ACTIONS(4150),
    [sym_complex] = ACTIONS(4148),
    [sym_super] = ACTIONS(4150),
    [anon_sym_true] = ACTIONS(4150),
    [anon_sym_TRUE] = ACTIONS(4150),
    [anon_sym_false] = ACTIONS(4150),
    [anon_sym_FALSE] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [anon_sym_nil] = ACTIONS(4150),
    [anon_sym_NIL] = ACTIONS(4150),
    [sym_character] = ACTIONS(4148),
    [anon_sym_LBRACK2] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4148),
  },
  [6005] = {
    [sym_heredoc_body] = STATE(8290),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(11596),
    [sym_comment] = ACTIONS(87),
  },
  [6006] = {
    [anon_sym_RPAREN] = ACTIONS(11596),
    [sym_comment] = ACTIONS(87),
  },
  [6007] = {
    [sym__simple_symbol] = ACTIONS(9425),
    [sym__string_start] = ACTIONS(9425),
    [sym__symbol_start] = ACTIONS(9425),
    [sym__subshell_start] = ACTIONS(9425),
    [sym__regex_start] = ACTIONS(9425),
    [sym__string_array_start] = ACTIONS(9425),
    [sym__symbol_array_start] = ACTIONS(9425),
    [sym__heredoc_body_start] = ACTIONS(9425),
    [sym_heredoc_beginning] = ACTIONS(9425),
    [sym__block_ampersand] = ACTIONS(9425),
    [sym__splat_star] = ACTIONS(9425),
    [sym__unary_minus] = ACTIONS(9425),
    [sym__binary_minus] = ACTIONS(9425),
    [sym__binary_star] = ACTIONS(9425),
    [sym__identifier_hash_key] = ACTIONS(9425),
    [anon_sym_LBRACE] = ACTIONS(9425),
    [anon_sym_RBRACE] = ACTIONS(9425),
    [anon_sym_def] = ACTIONS(9427),
    [anon_sym_LPAREN] = ACTIONS(9427),
    [anon_sym_RPAREN] = ACTIONS(9425),
    [anon_sym_DOT] = ACTIONS(9427),
    [anon_sym_COLON_COLON] = ACTIONS(9427),
    [anon_sym_COMMA] = ACTIONS(9425),
    [anon_sym_PIPE] = ACTIONS(9427),
    [anon_sym_SEMI] = ACTIONS(9425),
    [anon_sym_STAR] = ACTIONS(9427),
    [anon_sym_STAR_STAR] = ACTIONS(9427),
    [anon_sym_AMP] = ACTIONS(9427),
    [anon_sym_EQ] = ACTIONS(9427),
    [anon_sym_class] = ACTIONS(9427),
    [anon_sym_LT] = ACTIONS(9427),
    [anon_sym_module] = ACTIONS(9427),
    [anon_sym_return] = ACTIONS(9427),
    [anon_sym_yield] = ACTIONS(9427),
    [anon_sym_break] = ACTIONS(9427),
    [anon_sym_next] = ACTIONS(9427),
    [sym_redo] = ACTIONS(9427),
    [sym_retry] = ACTIONS(9427),
    [anon_sym_if] = ACTIONS(9427),
    [anon_sym_unless] = ACTIONS(9427),
    [anon_sym_while] = ACTIONS(9427),
    [anon_sym_until] = ACTIONS(9427),
    [anon_sym_rescue] = ACTIONS(9427),
    [anon_sym_for] = ACTIONS(9427),
    [anon_sym_in] = ACTIONS(9427),
    [anon_sym_do] = ACTIONS(9427),
    [anon_sym_case] = ACTIONS(9427),
    [anon_sym_begin] = ACTIONS(9427),
    [anon_sym_EQ_GT] = ACTIONS(9425),
    [anon_sym_LBRACK] = ACTIONS(9425),
    [anon_sym_RBRACK] = ACTIONS(9425),
    [anon_sym_COLON_COLON2] = ACTIONS(9425),
    [anon_sym_AMP_DOT] = ACTIONS(9425),
    [anon_sym_LPAREN2] = ACTIONS(9425),
    [anon_sym_PLUS_EQ] = ACTIONS(9425),
    [anon_sym_DASH_EQ] = ACTIONS(9425),
    [anon_sym_STAR_EQ] = ACTIONS(9425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9425),
    [anon_sym_SLASH_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9425),
    [anon_sym_AMP_EQ] = ACTIONS(9425),
    [anon_sym_PERCENT_EQ] = ACTIONS(9425),
    [anon_sym_GT_GT_EQ] = ACTIONS(9425),
    [anon_sym_LT_LT_EQ] = ACTIONS(9425),
    [anon_sym_CARET_EQ] = ACTIONS(9425),
    [anon_sym_QMARK] = ACTIONS(9427),
    [anon_sym_COLON2] = ACTIONS(9427),
    [anon_sym_DOT_DOT] = ACTIONS(9427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9425),
    [anon_sym_and] = ACTIONS(9427),
    [anon_sym_or] = ACTIONS(9427),
    [anon_sym_PIPE_PIPE] = ACTIONS(9427),
    [anon_sym_AMP_AMP] = ACTIONS(9427),
    [anon_sym_LT_LT] = ACTIONS(9427),
    [anon_sym_GT_GT] = ACTIONS(9427),
    [anon_sym_EQ_EQ] = ACTIONS(9427),
    [anon_sym_BANG_EQ] = ACTIONS(9425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9425),
    [anon_sym_LT_EQ_GT] = ACTIONS(9425),
    [anon_sym_EQ_TILDE] = ACTIONS(9425),
    [anon_sym_BANG_TILDE] = ACTIONS(9425),
    [anon_sym_LT_EQ] = ACTIONS(9427),
    [anon_sym_GT] = ACTIONS(9427),
    [anon_sym_GT_EQ] = ACTIONS(9425),
    [anon_sym_CARET] = ACTIONS(9427),
    [anon_sym_PLUS] = ACTIONS(9427),
    [anon_sym_SLASH] = ACTIONS(9427),
    [anon_sym_PERCENT] = ACTIONS(9427),
    [anon_sym_defined_QMARK] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [anon_sym_BANG] = ACTIONS(9427),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_constant] = ACTIONS(9427),
    [sym_identifier] = ACTIONS(9427),
    [sym_instance_variable] = ACTIONS(9425),
    [sym_class_variable] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(9425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9427),
    [sym_float] = ACTIONS(9427),
    [sym_complex] = ACTIONS(9425),
    [sym_super] = ACTIONS(9427),
    [anon_sym_true] = ACTIONS(9427),
    [anon_sym_TRUE] = ACTIONS(9427),
    [anon_sym_false] = ACTIONS(9427),
    [anon_sym_FALSE] = ACTIONS(9427),
    [sym_self] = ACTIONS(9427),
    [anon_sym_nil] = ACTIONS(9427),
    [anon_sym_NIL] = ACTIONS(9427),
    [sym_character] = ACTIONS(9425),
    [anon_sym_LBRACK2] = ACTIONS(9427),
    [anon_sym_DASH_GT] = ACTIONS(9425),
  },
  [6008] = {
    [sym__heredoc_body_start] = ACTIONS(9432),
    [sym__binary_minus] = ACTIONS(9432),
    [sym__binary_star] = ACTIONS(9432),
    [anon_sym_LBRACE] = ACTIONS(9432),
    [anon_sym_RBRACE] = ACTIONS(9432),
    [anon_sym_RPAREN] = ACTIONS(9432),
    [anon_sym_DOT] = ACTIONS(9434),
    [anon_sym_COMMA] = ACTIONS(9432),
    [anon_sym_PIPE] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(9432),
    [anon_sym_STAR_STAR] = ACTIONS(9434),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_EQ] = ACTIONS(9434),
    [anon_sym_LT] = ACTIONS(9434),
    [anon_sym_if] = ACTIONS(9432),
    [anon_sym_unless] = ACTIONS(9432),
    [anon_sym_while] = ACTIONS(9432),
    [anon_sym_until] = ACTIONS(9432),
    [anon_sym_rescue] = ACTIONS(9432),
    [anon_sym_in] = ACTIONS(9432),
    [anon_sym_do] = ACTIONS(9432),
    [anon_sym_EQ_GT] = ACTIONS(9432),
    [anon_sym_LBRACK] = ACTIONS(9432),
    [anon_sym_RBRACK] = ACTIONS(9432),
    [anon_sym_COLON_COLON2] = ACTIONS(9432),
    [anon_sym_AMP_DOT] = ACTIONS(9432),
    [anon_sym_PLUS_EQ] = ACTIONS(9432),
    [anon_sym_DASH_EQ] = ACTIONS(9432),
    [anon_sym_STAR_EQ] = ACTIONS(9432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9432),
    [anon_sym_SLASH_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9432),
    [anon_sym_AMP_EQ] = ACTIONS(9432),
    [anon_sym_PERCENT_EQ] = ACTIONS(9432),
    [anon_sym_GT_GT_EQ] = ACTIONS(9432),
    [anon_sym_LT_LT_EQ] = ACTIONS(9432),
    [anon_sym_CARET_EQ] = ACTIONS(9432),
    [anon_sym_QMARK] = ACTIONS(9432),
    [anon_sym_COLON2] = ACTIONS(9434),
    [anon_sym_DOT_DOT] = ACTIONS(9434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9432),
    [anon_sym_and] = ACTIONS(9432),
    [anon_sym_or] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE] = ACTIONS(9434),
    [anon_sym_AMP_AMP] = ACTIONS(9434),
    [anon_sym_LT_LT] = ACTIONS(9434),
    [anon_sym_GT_GT] = ACTIONS(9434),
    [anon_sym_EQ_EQ] = ACTIONS(9434),
    [anon_sym_BANG_EQ] = ACTIONS(9432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9432),
    [anon_sym_LT_EQ_GT] = ACTIONS(9432),
    [anon_sym_EQ_TILDE] = ACTIONS(9432),
    [anon_sym_BANG_TILDE] = ACTIONS(9432),
    [anon_sym_LT_EQ] = ACTIONS(9434),
    [anon_sym_GT] = ACTIONS(9434),
    [anon_sym_GT_EQ] = ACTIONS(9432),
    [anon_sym_CARET] = ACTIONS(9434),
    [anon_sym_PLUS] = ACTIONS(9434),
    [anon_sym_SLASH] = ACTIONS(9434),
    [anon_sym_PERCENT] = ACTIONS(9434),
    [sym_comment] = ACTIONS(87),
  },
  [6009] = {
    [anon_sym_RBRACK] = ACTIONS(11598),
    [sym_comment] = ACTIONS(87),
  },
  [6010] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_RBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6011] = {
    [sym__heredoc_body_start] = ACTIONS(9172),
    [sym__binary_minus] = ACTIONS(9172),
    [sym__binary_star] = ACTIONS(9172),
    [anon_sym_LBRACE] = ACTIONS(9172),
    [anon_sym_RBRACE] = ACTIONS(9172),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9174),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9174),
    [anon_sym_SEMI] = ACTIONS(9172),
    [anon_sym_STAR_STAR] = ACTIONS(9174),
    [anon_sym_AMP] = ACTIONS(9174),
    [anon_sym_EQ] = ACTIONS(9174),
    [anon_sym_LT] = ACTIONS(9174),
    [anon_sym_if] = ACTIONS(9172),
    [anon_sym_unless] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(9172),
    [anon_sym_until] = ACTIONS(9172),
    [anon_sym_rescue] = ACTIONS(9172),
    [anon_sym_in] = ACTIONS(9172),
    [anon_sym_do] = ACTIONS(9172),
    [anon_sym_EQ_GT] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_RBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [anon_sym_PLUS_EQ] = ACTIONS(9172),
    [anon_sym_DASH_EQ] = ACTIONS(9172),
    [anon_sym_STAR_EQ] = ACTIONS(9172),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9172),
    [anon_sym_SLASH_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9172),
    [anon_sym_AMP_EQ] = ACTIONS(9172),
    [anon_sym_PERCENT_EQ] = ACTIONS(9172),
    [anon_sym_GT_GT_EQ] = ACTIONS(9172),
    [anon_sym_LT_LT_EQ] = ACTIONS(9172),
    [anon_sym_CARET_EQ] = ACTIONS(9172),
    [anon_sym_QMARK] = ACTIONS(9172),
    [anon_sym_COLON2] = ACTIONS(9174),
    [anon_sym_DOT_DOT] = ACTIONS(9174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9172),
    [anon_sym_and] = ACTIONS(9172),
    [anon_sym_or] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE] = ACTIONS(9174),
    [anon_sym_AMP_AMP] = ACTIONS(9174),
    [anon_sym_LT_LT] = ACTIONS(9174),
    [anon_sym_GT_GT] = ACTIONS(9174),
    [anon_sym_EQ_EQ] = ACTIONS(9174),
    [anon_sym_BANG_EQ] = ACTIONS(9172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9172),
    [anon_sym_LT_EQ_GT] = ACTIONS(9172),
    [anon_sym_EQ_TILDE] = ACTIONS(9172),
    [anon_sym_BANG_TILDE] = ACTIONS(9172),
    [anon_sym_LT_EQ] = ACTIONS(9174),
    [anon_sym_GT] = ACTIONS(9174),
    [anon_sym_GT_EQ] = ACTIONS(9172),
    [anon_sym_CARET] = ACTIONS(9174),
    [anon_sym_PLUS] = ACTIONS(9174),
    [anon_sym_SLASH] = ACTIONS(9174),
    [anon_sym_PERCENT] = ACTIONS(9174),
    [sym_comment] = ACTIONS(87),
  },
  [6012] = {
    [anon_sym_RBRACE] = ACTIONS(11600),
    [sym_comment] = ACTIONS(87),
  },
  [6013] = {
    [sym__heredoc_body_start] = ACTIONS(9192),
    [sym__binary_minus] = ACTIONS(9192),
    [sym__binary_star] = ACTIONS(9192),
    [anon_sym_LBRACE] = ACTIONS(9192),
    [anon_sym_RBRACE] = ACTIONS(9192),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9194),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9194),
    [anon_sym_SEMI] = ACTIONS(9192),
    [anon_sym_STAR_STAR] = ACTIONS(9194),
    [anon_sym_AMP] = ACTIONS(9194),
    [anon_sym_EQ] = ACTIONS(9194),
    [anon_sym_LT] = ACTIONS(9194),
    [anon_sym_if] = ACTIONS(9192),
    [anon_sym_unless] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(9192),
    [anon_sym_until] = ACTIONS(9192),
    [anon_sym_rescue] = ACTIONS(9192),
    [anon_sym_in] = ACTIONS(9192),
    [anon_sym_do] = ACTIONS(9192),
    [anon_sym_EQ_GT] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_RBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [anon_sym_PLUS_EQ] = ACTIONS(9192),
    [anon_sym_DASH_EQ] = ACTIONS(9192),
    [anon_sym_STAR_EQ] = ACTIONS(9192),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9192),
    [anon_sym_SLASH_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9192),
    [anon_sym_AMP_EQ] = ACTIONS(9192),
    [anon_sym_PERCENT_EQ] = ACTIONS(9192),
    [anon_sym_GT_GT_EQ] = ACTIONS(9192),
    [anon_sym_LT_LT_EQ] = ACTIONS(9192),
    [anon_sym_CARET_EQ] = ACTIONS(9192),
    [anon_sym_QMARK] = ACTIONS(9192),
    [anon_sym_COLON2] = ACTIONS(9194),
    [anon_sym_DOT_DOT] = ACTIONS(9194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9192),
    [anon_sym_and] = ACTIONS(9192),
    [anon_sym_or] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE] = ACTIONS(9194),
    [anon_sym_AMP_AMP] = ACTIONS(9194),
    [anon_sym_LT_LT] = ACTIONS(9194),
    [anon_sym_GT_GT] = ACTIONS(9194),
    [anon_sym_EQ_EQ] = ACTIONS(9194),
    [anon_sym_BANG_EQ] = ACTIONS(9192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9192),
    [anon_sym_LT_EQ_GT] = ACTIONS(9192),
    [anon_sym_EQ_TILDE] = ACTIONS(9192),
    [anon_sym_BANG_TILDE] = ACTIONS(9192),
    [anon_sym_LT_EQ] = ACTIONS(9194),
    [anon_sym_GT] = ACTIONS(9194),
    [anon_sym_GT_EQ] = ACTIONS(9192),
    [anon_sym_CARET] = ACTIONS(9194),
    [anon_sym_PLUS] = ACTIONS(9194),
    [anon_sym_SLASH] = ACTIONS(9194),
    [anon_sym_PERCENT] = ACTIONS(9194),
    [sym_comment] = ACTIONS(87),
  },
  [6014] = {
    [anon_sym_end] = ACTIONS(11602),
    [sym_comment] = ACTIONS(87),
  },
  [6015] = {
    [sym__statements] = STATE(8294),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11604),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6016] = {
    [sym__statements] = STATE(8294),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(8295),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(8295),
    [sym__line_break] = ACTIONS(11606),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11604),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6017] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_RBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6018] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6019] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [6020] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6021] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6022] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6023] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11608),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6024] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_RBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6025] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6026] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6027] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6028] = {
    [sym_heredoc_body] = STATE(6028),
    [aux_sym_call_repeat1] = STATE(6028),
    [sym__heredoc_body_start] = ACTIONS(10154),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_RBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [6029] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1372),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym__argument] = STATE(6822),
    [sym_splat_argument] = STATE(6822),
    [sym_hash_splat_argument] = STATE(6822),
    [sym_block_argument] = STATE(6822),
    [sym_assignment] = STATE(1372),
    [sym_operator_assignment] = STATE(1372),
    [sym_conditional] = STATE(1372),
    [sym_range] = STATE(1372),
    [sym_binary] = STATE(1372),
    [sym_unary] = STATE(1372),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1380),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6822),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2401),
    [sym__splat_star] = ACTIONS(2403),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__identifier_hash_key] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9141),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2429),
    [sym_identifier] = ACTIONS(2429),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6030] = {
    [sym_heredoc_body] = STATE(6028),
    [aux_sym_call_repeat1] = STATE(6028),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_RBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [6031] = {
    [aux_sym_argument_list_repeat1] = STATE(6031),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(11610),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_RBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [6032] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_RBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6033] = {
    [aux_sym_exceptions_repeat1] = STATE(8298),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [6034] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_RBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6035] = {
    [sym_string] = STATE(6035),
    [aux_sym_chained_string_repeat1] = STATE(6035),
    [sym__string_start] = ACTIONS(10160),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_RBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [6036] = {
    [sym__simple_symbol] = ACTIONS(3102),
    [sym__string_start] = ACTIONS(3102),
    [sym__symbol_start] = ACTIONS(3102),
    [sym__subshell_start] = ACTIONS(3102),
    [sym__regex_start] = ACTIONS(3102),
    [sym__string_array_start] = ACTIONS(3102),
    [sym__symbol_array_start] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(3102),
    [sym_heredoc_beginning] = ACTIONS(3102),
    [sym__block_ampersand] = ACTIONS(3102),
    [sym__splat_star] = ACTIONS(3102),
    [sym__unary_minus] = ACTIONS(3102),
    [sym__identifier_hash_key] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_def] = ACTIONS(4854),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_COLON_COLON] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(4854),
    [anon_sym_STAR_STAR] = ACTIONS(3102),
    [anon_sym_class] = ACTIONS(4854),
    [anon_sym_module] = ACTIONS(4854),
    [anon_sym_return] = ACTIONS(4854),
    [anon_sym_yield] = ACTIONS(4854),
    [anon_sym_break] = ACTIONS(4854),
    [anon_sym_next] = ACTIONS(4854),
    [sym_redo] = ACTIONS(4854),
    [sym_retry] = ACTIONS(4854),
    [anon_sym_if] = ACTIONS(4854),
    [anon_sym_unless] = ACTIONS(4854),
    [anon_sym_while] = ACTIONS(4854),
    [anon_sym_until] = ACTIONS(4854),
    [anon_sym_for] = ACTIONS(4854),
    [anon_sym_case] = ACTIONS(4854),
    [anon_sym_begin] = ACTIONS(4854),
    [anon_sym_RBRACK] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(4854),
    [anon_sym_defined_QMARK] = ACTIONS(3102),
    [anon_sym_not] = ACTIONS(4854),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_TILDE] = ACTIONS(3102),
    [sym_constant] = ACTIONS(4854),
    [sym_identifier] = ACTIONS(4854),
    [sym_instance_variable] = ACTIONS(3102),
    [sym_class_variable] = ACTIONS(3102),
    [sym_global_variable] = ACTIONS(3102),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4854),
    [sym_float] = ACTIONS(4854),
    [sym_complex] = ACTIONS(3102),
    [sym_super] = ACTIONS(4854),
    [anon_sym_true] = ACTIONS(4854),
    [anon_sym_TRUE] = ACTIONS(4854),
    [anon_sym_false] = ACTIONS(4854),
    [anon_sym_FALSE] = ACTIONS(4854),
    [sym_self] = ACTIONS(4854),
    [anon_sym_nil] = ACTIONS(4854),
    [anon_sym_NIL] = ACTIONS(4854),
    [sym_character] = ACTIONS(3102),
    [anon_sym_LBRACK2] = ACTIONS(3102),
    [anon_sym_DASH_GT] = ACTIONS(3102),
  },
  [6037] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(11613),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [6038] = {
    [sym__heredoc_body_start] = ACTIONS(11615),
    [anon_sym_RPAREN] = ACTIONS(11615),
    [anon_sym_RBRACK] = ACTIONS(11615),
    [sym_comment] = ACTIONS(87),
  },
  [6039] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_RBRACK] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(2375),
    [anon_sym_DOT_DOT] = ACTIONS(2377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2379),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ_GT] = ACTIONS(2383),
    [anon_sym_EQ_TILDE] = ACTIONS(2383),
    [anon_sym_BANG_TILDE] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [6040] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3441),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(353),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(353),
    [sym_splat_argument] = STATE(8300),
    [sym_assignment] = STATE(3441),
    [sym_operator_assignment] = STATE(3441),
    [sym_conditional] = STATE(3441),
    [sym_range] = STATE(3441),
    [sym_binary] = STATE(3441),
    [sym_unary] = STATE(3441),
    [sym__arg_or_splat_arg] = STATE(8300),
    [sym_left_assignment_list] = STATE(352),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(353),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(353),
    [sym_false] = STATE(353),
    [sym_nil] = STATE(353),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(5592),
    [sym__unary_minus] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6041] = {
    [aux_sym_exceptions_repeat1] = STATE(8301),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(11617),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_RBRACK] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [6042] = {
    [sym__simple_symbol] = ACTIONS(11619),
    [sym__string_start] = ACTIONS(11619),
    [sym__symbol_start] = ACTIONS(11619),
    [sym__subshell_start] = ACTIONS(11619),
    [sym__regex_start] = ACTIONS(11619),
    [sym__string_array_start] = ACTIONS(11619),
    [sym__symbol_array_start] = ACTIONS(11619),
    [sym_heredoc_beginning] = ACTIONS(11619),
    [sym__unary_minus] = ACTIONS(11619),
    [anon_sym_BEGIN] = ACTIONS(11621),
    [anon_sym_LBRACE] = ACTIONS(11619),
    [anon_sym_RBRACE] = ACTIONS(11619),
    [anon_sym_END] = ACTIONS(11621),
    [anon_sym_def] = ACTIONS(11621),
    [anon_sym_LPAREN] = ACTIONS(11619),
    [anon_sym_COLON_COLON] = ACTIONS(11619),
    [anon_sym_SEMI] = ACTIONS(11619),
    [anon_sym_STAR] = ACTIONS(11619),
    [anon_sym_class] = ACTIONS(11621),
    [anon_sym_module] = ACTIONS(11621),
    [anon_sym_return] = ACTIONS(11621),
    [anon_sym_yield] = ACTIONS(11621),
    [anon_sym_break] = ACTIONS(11621),
    [anon_sym_next] = ACTIONS(11621),
    [sym_redo] = ACTIONS(11621),
    [sym_retry] = ACTIONS(11621),
    [anon_sym_if] = ACTIONS(11621),
    [anon_sym_unless] = ACTIONS(11621),
    [anon_sym_while] = ACTIONS(11621),
    [anon_sym_until] = ACTIONS(11621),
    [anon_sym_for] = ACTIONS(11621),
    [anon_sym_case] = ACTIONS(11621),
    [anon_sym_begin] = ACTIONS(11621),
    [anon_sym_PLUS] = ACTIONS(11621),
    [anon_sym_defined_QMARK] = ACTIONS(11619),
    [anon_sym_not] = ACTIONS(11621),
    [anon_sym_BANG] = ACTIONS(11619),
    [anon_sym_TILDE] = ACTIONS(11619),
    [sym_constant] = ACTIONS(11621),
    [sym_identifier] = ACTIONS(11621),
    [sym_instance_variable] = ACTIONS(11619),
    [sym_class_variable] = ACTIONS(11619),
    [sym_global_variable] = ACTIONS(11619),
    [anon_sym_undef] = ACTIONS(11621),
    [anon_sym_alias] = ACTIONS(11621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(11621),
    [sym_float] = ACTIONS(11621),
    [sym_complex] = ACTIONS(11619),
    [sym_super] = ACTIONS(11621),
    [anon_sym_true] = ACTIONS(11621),
    [anon_sym_TRUE] = ACTIONS(11621),
    [anon_sym_false] = ACTIONS(11621),
    [anon_sym_FALSE] = ACTIONS(11621),
    [sym_self] = ACTIONS(11621),
    [anon_sym_nil] = ACTIONS(11621),
    [anon_sym_NIL] = ACTIONS(11621),
    [sym_character] = ACTIONS(11619),
    [anon_sym_LBRACK2] = ACTIONS(11619),
    [anon_sym_DASH_GT] = ACTIONS(11619),
  },
  [6043] = {
    [sym_identifier] = ACTIONS(11623),
    [sym_comment] = ACTIONS(87),
  },
  [6044] = {
    [aux_sym_block_parameters_repeat1] = STATE(8305),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(11627),
    [sym_comment] = ACTIONS(87),
  },
  [6045] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8313),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(8313),
    [sym_operator_assignment] = STATE(8313),
    [sym_conditional] = STATE(8313),
    [sym_range] = STATE(8313),
    [sym_binary] = STATE(8313),
    [sym_unary] = STATE(8313),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_COMMA] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6046] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8318),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(8318),
    [sym_operator_assignment] = STATE(8318),
    [sym_conditional] = STATE(8318),
    [sym_range] = STATE(8318),
    [sym_binary] = STATE(8318),
    [sym_unary] = STATE(8318),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6047] = {
    [sym__formal_parameter] = STATE(6054),
    [sym__simple_formal_parameter] = STATE(6054),
    [sym_destructured_parameter] = STATE(6054),
    [sym_splat_parameter] = STATE(6054),
    [sym_hash_splat_parameter] = STATE(6054),
    [sym_block_parameter] = STATE(6054),
    [sym_keyword_parameter] = STATE(6054),
    [sym_optional_parameter] = STATE(6054),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(11627),
    [anon_sym_SEMI] = ACTIONS(11651),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5604),
    [sym_comment] = ACTIONS(87),
  },
  [6048] = {
    [aux_sym_method_parameters_repeat1] = STATE(8321),
    [anon_sym_COMMA] = ACTIONS(11653),
    [anon_sym_PIPE] = ACTIONS(11627),
    [anon_sym_SEMI] = ACTIONS(11651),
    [sym_comment] = ACTIONS(87),
  },
  [6049] = {
    [sym__line_break] = ACTIONS(11655),
    [sym__heredoc_body_start] = ACTIONS(11655),
    [sym__binary_minus] = ACTIONS(11655),
    [sym__binary_star] = ACTIONS(11655),
    [ts_builtin_sym_end] = ACTIONS(11655),
    [anon_sym___END__] = ACTIONS(11655),
    [anon_sym_LBRACE] = ACTIONS(11655),
    [anon_sym_RBRACE] = ACTIONS(11655),
    [anon_sym_RPAREN] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11657),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11657),
    [anon_sym_SEMI] = ACTIONS(11655),
    [anon_sym_STAR_STAR] = ACTIONS(11655),
    [anon_sym_AMP] = ACTIONS(11657),
    [anon_sym_LT] = ACTIONS(11657),
    [anon_sym_end] = ACTIONS(11655),
    [anon_sym_if] = ACTIONS(11655),
    [anon_sym_unless] = ACTIONS(11655),
    [anon_sym_while] = ACTIONS(11655),
    [anon_sym_until] = ACTIONS(11655),
    [anon_sym_rescue] = ACTIONS(11655),
    [anon_sym_do] = ACTIONS(11655),
    [anon_sym_when] = ACTIONS(11655),
    [anon_sym_elsif] = ACTIONS(11655),
    [anon_sym_else] = ACTIONS(11655),
    [anon_sym_then] = ACTIONS(11655),
    [anon_sym_ensure] = ACTIONS(11655),
    [anon_sym_EQ_GT] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [anon_sym_QMARK] = ACTIONS(11655),
    [anon_sym_DOT_DOT] = ACTIONS(11657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11655),
    [anon_sym_and] = ACTIONS(11655),
    [anon_sym_or] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE] = ACTIONS(11655),
    [anon_sym_AMP_AMP] = ACTIONS(11655),
    [anon_sym_LT_LT] = ACTIONS(11655),
    [anon_sym_GT_GT] = ACTIONS(11655),
    [anon_sym_EQ_EQ] = ACTIONS(11657),
    [anon_sym_BANG_EQ] = ACTIONS(11655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11655),
    [anon_sym_LT_EQ_GT] = ACTIONS(11655),
    [anon_sym_EQ_TILDE] = ACTIONS(11655),
    [anon_sym_BANG_TILDE] = ACTIONS(11655),
    [anon_sym_LT_EQ] = ACTIONS(11657),
    [anon_sym_GT] = ACTIONS(11657),
    [anon_sym_GT_EQ] = ACTIONS(11655),
    [anon_sym_CARET] = ACTIONS(11655),
    [anon_sym_PLUS] = ACTIONS(11655),
    [anon_sym_SLASH] = ACTIONS(11655),
    [anon_sym_PERCENT] = ACTIONS(11655),
    [sym_comment] = ACTIONS(87),
  },
  [6050] = {
    [anon_sym_RPAREN] = ACTIONS(11659),
    [anon_sym_COMMA] = ACTIONS(11659),
    [anon_sym_PIPE] = ACTIONS(11659),
    [anon_sym_SEMI] = ACTIONS(11659),
    [sym_comment] = ACTIONS(87),
  },
  [6051] = {
    [aux_sym_method_parameters_repeat1] = STATE(6056),
    [anon_sym_RPAREN] = ACTIONS(11661),
    [anon_sym_COMMA] = ACTIONS(5616),
    [sym_comment] = ACTIONS(87),
  },
  [6052] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(9206),
    [anon_sym_COMMA] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(10247),
    [anon_sym_QMARK] = ACTIONS(10249),
    [anon_sym_DOT_DOT] = ACTIONS(10251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10253),
    [anon_sym_and] = ACTIONS(11663),
    [anon_sym_or] = ACTIONS(11663),
    [anon_sym_PIPE_PIPE] = ACTIONS(10255),
    [anon_sym_AMP_AMP] = ACTIONS(10255),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(10259),
    [anon_sym_BANG_EQ] = ACTIONS(10255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10255),
    [anon_sym_LT_EQ_GT] = ACTIONS(10255),
    [anon_sym_EQ_TILDE] = ACTIONS(10255),
    [anon_sym_BANG_TILDE] = ACTIONS(10255),
    [anon_sym_LT_EQ] = ACTIONS(10247),
    [anon_sym_GT] = ACTIONS(10247),
    [anon_sym_GT_EQ] = ACTIONS(10261),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [6053] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(9240),
    [anon_sym_COMMA] = ACTIONS(9240),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(10247),
    [anon_sym_QMARK] = ACTIONS(10249),
    [anon_sym_DOT_DOT] = ACTIONS(10251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10253),
    [anon_sym_and] = ACTIONS(11663),
    [anon_sym_or] = ACTIONS(11663),
    [anon_sym_PIPE_PIPE] = ACTIONS(10255),
    [anon_sym_AMP_AMP] = ACTIONS(10255),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(10259),
    [anon_sym_BANG_EQ] = ACTIONS(10255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10255),
    [anon_sym_LT_EQ_GT] = ACTIONS(10255),
    [anon_sym_EQ_TILDE] = ACTIONS(10255),
    [anon_sym_BANG_TILDE] = ACTIONS(10255),
    [anon_sym_LT_EQ] = ACTIONS(10247),
    [anon_sym_GT] = ACTIONS(10247),
    [anon_sym_GT_EQ] = ACTIONS(10261),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [6054] = {
    [anon_sym_RPAREN] = ACTIONS(11665),
    [anon_sym_COMMA] = ACTIONS(11665),
    [anon_sym_PIPE] = ACTIONS(11665),
    [anon_sym_SEMI] = ACTIONS(11665),
    [sym_comment] = ACTIONS(87),
  },
  [6055] = {
    [anon_sym_LBRACE] = ACTIONS(11667),
    [anon_sym_do] = ACTIONS(11667),
    [sym_comment] = ACTIONS(87),
  },
  [6056] = {
    [aux_sym_method_parameters_repeat1] = STATE(6056),
    [anon_sym_RPAREN] = ACTIONS(11665),
    [anon_sym_COMMA] = ACTIONS(11669),
    [sym_comment] = ACTIONS(87),
  },
  [6057] = {
    [sym__line_break] = ACTIONS(11619),
    [sym__simple_symbol] = ACTIONS(11619),
    [sym__string_start] = ACTIONS(11619),
    [sym__symbol_start] = ACTIONS(11619),
    [sym__subshell_start] = ACTIONS(11619),
    [sym__regex_start] = ACTIONS(11619),
    [sym__string_array_start] = ACTIONS(11619),
    [sym__symbol_array_start] = ACTIONS(11619),
    [sym__heredoc_body_start] = ACTIONS(11619),
    [sym_heredoc_beginning] = ACTIONS(11619),
    [sym__unary_minus] = ACTIONS(11619),
    [anon_sym_BEGIN] = ACTIONS(11621),
    [anon_sym_LBRACE] = ACTIONS(11619),
    [anon_sym_END] = ACTIONS(11621),
    [anon_sym_def] = ACTIONS(11621),
    [anon_sym_LPAREN] = ACTIONS(11619),
    [anon_sym_COLON_COLON] = ACTIONS(11619),
    [anon_sym_SEMI] = ACTIONS(11619),
    [anon_sym_STAR] = ACTIONS(11619),
    [anon_sym_class] = ACTIONS(11621),
    [anon_sym_module] = ACTIONS(11621),
    [anon_sym_end] = ACTIONS(11621),
    [anon_sym_return] = ACTIONS(11621),
    [anon_sym_yield] = ACTIONS(11621),
    [anon_sym_break] = ACTIONS(11621),
    [anon_sym_next] = ACTIONS(11621),
    [sym_redo] = ACTIONS(11621),
    [sym_retry] = ACTIONS(11621),
    [anon_sym_if] = ACTIONS(11621),
    [anon_sym_unless] = ACTIONS(11621),
    [anon_sym_while] = ACTIONS(11621),
    [anon_sym_until] = ACTIONS(11621),
    [anon_sym_for] = ACTIONS(11621),
    [anon_sym_case] = ACTIONS(11621),
    [anon_sym_begin] = ACTIONS(11621),
    [anon_sym_PLUS] = ACTIONS(11621),
    [anon_sym_defined_QMARK] = ACTIONS(11619),
    [anon_sym_not] = ACTIONS(11621),
    [anon_sym_BANG] = ACTIONS(11619),
    [anon_sym_TILDE] = ACTIONS(11619),
    [sym_constant] = ACTIONS(11621),
    [sym_identifier] = ACTIONS(11621),
    [sym_instance_variable] = ACTIONS(11619),
    [sym_class_variable] = ACTIONS(11619),
    [sym_global_variable] = ACTIONS(11619),
    [anon_sym_undef] = ACTIONS(11621),
    [anon_sym_alias] = ACTIONS(11621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(11621),
    [sym_float] = ACTIONS(11621),
    [sym_complex] = ACTIONS(11619),
    [sym_super] = ACTIONS(11621),
    [anon_sym_true] = ACTIONS(11621),
    [anon_sym_TRUE] = ACTIONS(11621),
    [anon_sym_false] = ACTIONS(11621),
    [anon_sym_FALSE] = ACTIONS(11621),
    [sym_self] = ACTIONS(11621),
    [anon_sym_nil] = ACTIONS(11621),
    [anon_sym_NIL] = ACTIONS(11621),
    [sym_character] = ACTIONS(11619),
    [anon_sym_LBRACK2] = ACTIONS(11619),
    [anon_sym_DASH_GT] = ACTIONS(11619),
  },
  [6058] = {
    [sym_identifier] = ACTIONS(11672),
    [sym_comment] = ACTIONS(87),
  },
  [6059] = {
    [aux_sym_block_parameters_repeat1] = STATE(8325),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(11674),
    [sym_comment] = ACTIONS(87),
  },
  [6060] = {
    [sym__formal_parameter] = STATE(6054),
    [sym__simple_formal_parameter] = STATE(6054),
    [sym_destructured_parameter] = STATE(6054),
    [sym_splat_parameter] = STATE(6054),
    [sym_hash_splat_parameter] = STATE(6054),
    [sym_block_parameter] = STATE(6054),
    [sym_keyword_parameter] = STATE(6054),
    [sym_optional_parameter] = STATE(6054),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(11674),
    [anon_sym_SEMI] = ACTIONS(11676),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5604),
    [sym_comment] = ACTIONS(87),
  },
  [6061] = {
    [aux_sym_method_parameters_repeat1] = STATE(8321),
    [anon_sym_COMMA] = ACTIONS(11678),
    [anon_sym_PIPE] = ACTIONS(11674),
    [anon_sym_SEMI] = ACTIONS(11676),
    [sym_comment] = ACTIONS(87),
  },
  [6062] = {
    [sym__line_break] = ACTIONS(11680),
    [sym__heredoc_body_start] = ACTIONS(11680),
    [sym__binary_minus] = ACTIONS(11680),
    [sym__binary_star] = ACTIONS(11680),
    [ts_builtin_sym_end] = ACTIONS(11680),
    [anon_sym___END__] = ACTIONS(11680),
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RBRACE] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11682),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11682),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_STAR_STAR] = ACTIONS(11680),
    [anon_sym_AMP] = ACTIONS(11682),
    [anon_sym_LT] = ACTIONS(11682),
    [anon_sym_end] = ACTIONS(11680),
    [anon_sym_if] = ACTIONS(11680),
    [anon_sym_unless] = ACTIONS(11680),
    [anon_sym_while] = ACTIONS(11680),
    [anon_sym_until] = ACTIONS(11680),
    [anon_sym_rescue] = ACTIONS(11680),
    [anon_sym_do] = ACTIONS(11680),
    [anon_sym_when] = ACTIONS(11680),
    [anon_sym_elsif] = ACTIONS(11680),
    [anon_sym_else] = ACTIONS(11680),
    [anon_sym_then] = ACTIONS(11680),
    [anon_sym_ensure] = ACTIONS(11680),
    [anon_sym_EQ_GT] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_DOT_DOT] = ACTIONS(11682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_and] = ACTIONS(11680),
    [anon_sym_or] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE] = ACTIONS(11680),
    [anon_sym_AMP_AMP] = ACTIONS(11680),
    [anon_sym_LT_LT] = ACTIONS(11680),
    [anon_sym_GT_GT] = ACTIONS(11680),
    [anon_sym_EQ_EQ] = ACTIONS(11682),
    [anon_sym_BANG_EQ] = ACTIONS(11680),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11680),
    [anon_sym_LT_EQ_GT] = ACTIONS(11680),
    [anon_sym_EQ_TILDE] = ACTIONS(11680),
    [anon_sym_BANG_TILDE] = ACTIONS(11680),
    [anon_sym_LT_EQ] = ACTIONS(11682),
    [anon_sym_GT] = ACTIONS(11682),
    [anon_sym_GT_EQ] = ACTIONS(11680),
    [anon_sym_CARET] = ACTIONS(11680),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11680),
    [anon_sym_PERCENT] = ACTIONS(11680),
    [sym_comment] = ACTIONS(87),
  },
  [6063] = {
    [anon_sym_end] = ACTIONS(11684),
    [sym_comment] = ACTIONS(87),
  },
  [6064] = {
    [sym__statements] = STATE(8329),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11686),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6065] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6066] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(9212),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9214),
    [anon_sym_DOT_DOT] = ACTIONS(9216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9218),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9222),
    [anon_sym_AMP_AMP] = ACTIONS(9222),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(9226),
    [anon_sym_BANG_EQ] = ACTIONS(9222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9222),
    [anon_sym_LT_EQ_GT] = ACTIONS(9222),
    [anon_sym_EQ_TILDE] = ACTIONS(9222),
    [anon_sym_BANG_TILDE] = ACTIONS(9222),
    [anon_sym_LT_EQ] = ACTIONS(9212),
    [anon_sym_GT] = ACTIONS(9212),
    [anon_sym_GT_EQ] = ACTIONS(9228),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [6067] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8330),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(8330),
    [sym_operator_assignment] = STATE(8330),
    [sym_conditional] = STATE(8330),
    [sym_range] = STATE(8330),
    [sym_binary] = STATE(8330),
    [sym_unary] = STATE(8330),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6068] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8331),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(8331),
    [sym_operator_assignment] = STATE(8331),
    [sym_conditional] = STATE(8331),
    [sym_range] = STATE(8331),
    [sym_binary] = STATE(8331),
    [sym_unary] = STATE(8331),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6069] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8332),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(8332),
    [sym_operator_assignment] = STATE(8332),
    [sym_conditional] = STATE(8332),
    [sym_range] = STATE(8332),
    [sym_binary] = STATE(8332),
    [sym_unary] = STATE(8332),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6070] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8333),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(8333),
    [sym_operator_assignment] = STATE(8333),
    [sym_conditional] = STATE(8333),
    [sym_range] = STATE(8333),
    [sym_binary] = STATE(8333),
    [sym_unary] = STATE(8333),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6071] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8334),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(8334),
    [sym_operator_assignment] = STATE(8334),
    [sym_conditional] = STATE(8334),
    [sym_range] = STATE(8334),
    [sym_binary] = STATE(8334),
    [sym_unary] = STATE(8334),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6072] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8335),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8335),
    [sym_operator_assignment] = STATE(8335),
    [sym_conditional] = STATE(8335),
    [sym_range] = STATE(8335),
    [sym_binary] = STATE(8335),
    [sym_unary] = STATE(8335),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6073] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8336),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(8336),
    [sym_operator_assignment] = STATE(8336),
    [sym_conditional] = STATE(8336),
    [sym_range] = STATE(8336),
    [sym_binary] = STATE(8336),
    [sym_unary] = STATE(8336),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6074] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8337),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(8337),
    [sym_operator_assignment] = STATE(8337),
    [sym_conditional] = STATE(8337),
    [sym_range] = STATE(8337),
    [sym_binary] = STATE(8337),
    [sym_unary] = STATE(8337),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6075] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8338),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(8338),
    [sym_operator_assignment] = STATE(8338),
    [sym_conditional] = STATE(8338),
    [sym_range] = STATE(8338),
    [sym_binary] = STATE(8338),
    [sym_unary] = STATE(8338),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6076] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8339),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(8339),
    [sym_operator_assignment] = STATE(8339),
    [sym_conditional] = STATE(8339),
    [sym_range] = STATE(8339),
    [sym_binary] = STATE(8339),
    [sym_unary] = STATE(8339),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6077] = {
    [sym__statements] = STATE(3867),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_block_parameters] = STATE(3868),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1514),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_hash_splat_argument] = STATE(116),
    [sym_assignment] = STATE(1514),
    [sym_operator_assignment] = STATE(1514),
    [sym_conditional] = STATE(1514),
    [sym_range] = STATE(1514),
    [sym_binary] = STATE(1514),
    [sym_unary] = STATE(1514),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1518),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(1939),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym__hash_items] = STATE(1940),
    [sym_pair] = STATE(122),
    [sym_lambda] = STATE(214),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [sym__identifier_hash_key] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(11688),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6078] = {
    [sym_do_block] = STATE(3890),
    [sym_block] = STATE(3890),
    [sym__binary_minus] = ACTIONS(2725),
    [sym__binary_star] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(6297),
    [anon_sym_DOT] = ACTIONS(2729),
    [anon_sym_COMMA] = ACTIONS(2725),
    [anon_sym_PIPE] = ACTIONS(2729),
    [anon_sym_STAR_STAR] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2729),
    [anon_sym_do] = ACTIONS(2725),
    [anon_sym_LBRACK] = ACTIONS(2725),
    [anon_sym_COLON_COLON2] = ACTIONS(2725),
    [anon_sym_AMP_DOT] = ACTIONS(2725),
    [anon_sym_PLUS_EQ] = ACTIONS(2725),
    [anon_sym_DASH_EQ] = ACTIONS(2725),
    [anon_sym_STAR_EQ] = ACTIONS(2725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2725),
    [anon_sym_SLASH_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_PIPE_EQ] = ACTIONS(2725),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2725),
    [anon_sym_AMP_EQ] = ACTIONS(2725),
    [anon_sym_PERCENT_EQ] = ACTIONS(2725),
    [anon_sym_GT_GT_EQ] = ACTIONS(2725),
    [anon_sym_LT_LT_EQ] = ACTIONS(2725),
    [anon_sym_CARET_EQ] = ACTIONS(2725),
    [anon_sym_QMARK] = ACTIONS(2725),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2725),
    [anon_sym_and] = ACTIONS(2725),
    [anon_sym_or] = ACTIONS(2725),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_LT_LT] = ACTIONS(2729),
    [anon_sym_GT_GT] = ACTIONS(2729),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2725),
    [anon_sym_LT_EQ_GT] = ACTIONS(2725),
    [anon_sym_EQ_TILDE] = ACTIONS(2725),
    [anon_sym_BANG_TILDE] = ACTIONS(2725),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2725),
    [anon_sym_CARET] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2729),
    [anon_sym_SLASH] = ACTIONS(2729),
    [anon_sym_PERCENT] = ACTIONS(2729),
    [sym_comment] = ACTIONS(87),
  },
  [6079] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8342),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_splat_argument] = STATE(8343),
    [sym_assignment] = STATE(8342),
    [sym_operator_assignment] = STATE(8342),
    [sym_conditional] = STATE(8342),
    [sym_range] = STATE(8342),
    [sym_binary] = STATE(8342),
    [sym_unary] = STATE(8342),
    [sym_right_assignment_list] = STATE(2017),
    [sym__arg_or_splat_arg] = STATE(8343),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(11690),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6080] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8344),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(8344),
    [sym_operator_assignment] = STATE(8344),
    [sym_conditional] = STATE(8344),
    [sym_range] = STATE(8344),
    [sym_binary] = STATE(8344),
    [sym_unary] = STATE(8344),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6081] = {
    [sym_string] = STATE(8345),
    [aux_sym_chained_string_repeat1] = STATE(8345),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [6082] = {
    [sym__string_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_STAR_STAR] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON2] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_LT_LT] = ACTIONS(2895),
    [anon_sym_GT_GT] = ACTIONS(2895),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(87),
  },
  [6083] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8346),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(8346),
    [sym_operator_assignment] = STATE(8346),
    [sym_conditional] = STATE(8346),
    [sym_range] = STATE(8346),
    [sym_binary] = STATE(8346),
    [sym_unary] = STATE(8346),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6084] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(8347),
    [sym__argument] = STATE(8348),
    [sym_splat_argument] = STATE(8348),
    [sym_hash_splat_argument] = STATE(8348),
    [sym_block_argument] = STATE(8348),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(8348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6085] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(8347),
    [sym__argument] = STATE(8348),
    [sym_splat_argument] = STATE(8348),
    [sym_hash_splat_argument] = STATE(8348),
    [sym_block_argument] = STATE(8348),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(8348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6086] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(8347),
    [sym__argument] = STATE(8348),
    [sym_splat_argument] = STATE(8348),
    [sym_hash_splat_argument] = STATE(8348),
    [sym_block_argument] = STATE(8348),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(8348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6087] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(8347),
    [sym__argument] = STATE(8348),
    [sym_splat_argument] = STATE(8348),
    [sym_hash_splat_argument] = STATE(8348),
    [sym_block_argument] = STATE(8348),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(8348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6088] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8349),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(8349),
    [sym_operator_assignment] = STATE(8349),
    [sym_conditional] = STATE(8349),
    [sym_range] = STATE(8349),
    [sym_binary] = STATE(8349),
    [sym_unary] = STATE(8349),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6089] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6090] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(11702),
    [anon_sym_COLON2] = ACTIONS(4080),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [6091] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3530),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(1827),
    [sym__argument_list_with_parens] = STATE(3532),
    [sym__argument] = STATE(3533),
    [sym_splat_argument] = STATE(3533),
    [sym_hash_splat_argument] = STATE(3533),
    [sym_block_argument] = STATE(3533),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(3530),
    [sym_operator_assignment] = STATE(3530),
    [sym_conditional] = STATE(3530),
    [sym_range] = STATE(3530),
    [sym_binary] = STATE(3530),
    [sym_unary] = STATE(3530),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3536),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3533),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5762),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_COLON2] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5786),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6092] = {
    [anon_sym_EQ] = ACTIONS(11718),
    [sym_comment] = ACTIONS(87),
  },
  [6093] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11720),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11722),
    [anon_sym_DASH_EQ] = ACTIONS(11722),
    [anon_sym_STAR_EQ] = ACTIONS(11722),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11722),
    [anon_sym_SLASH_EQ] = ACTIONS(11722),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11722),
    [anon_sym_PIPE_EQ] = ACTIONS(11722),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11722),
    [anon_sym_AMP_EQ] = ACTIONS(11722),
    [anon_sym_PERCENT_EQ] = ACTIONS(11722),
    [anon_sym_GT_GT_EQ] = ACTIONS(11722),
    [anon_sym_LT_LT_EQ] = ACTIONS(11722),
    [anon_sym_CARET_EQ] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6094] = {
    [sym_string] = STATE(8362),
    [aux_sym_chained_string_repeat1] = STATE(8362),
    [sym__string_start] = ACTIONS(3870),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6095] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11702),
    [anon_sym_COLON2] = ACTIONS(4112),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [6096] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(8364),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(11724),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [6097] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6098] = {
    [sym_string] = STATE(6136),
    [aux_sym_chained_string_repeat1] = STATE(6136),
    [sym__string_start] = ACTIONS(9273),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6099] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8365),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(8365),
    [sym_operator_assignment] = STATE(8365),
    [sym_conditional] = STATE(8365),
    [sym_range] = STATE(8365),
    [sym_binary] = STATE(8365),
    [sym_unary] = STATE(8365),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6100] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(11702),
    [anon_sym_COLON2] = ACTIONS(4114),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [6101] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8366),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8366),
    [sym_operator_assignment] = STATE(8366),
    [sym_conditional] = STATE(8366),
    [sym_range] = STATE(8366),
    [sym_binary] = STATE(8366),
    [sym_unary] = STATE(8366),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6102] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8367),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8367),
    [sym_operator_assignment] = STATE(8367),
    [sym_conditional] = STATE(8367),
    [sym_range] = STATE(8367),
    [sym_binary] = STATE(8367),
    [sym_unary] = STATE(8367),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6103] = {
    [anon_sym_COLON] = ACTIONS(11726),
    [sym_comment] = ACTIONS(87),
  },
  [6104] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8369),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8369),
    [sym_operator_assignment] = STATE(8369),
    [sym_conditional] = STATE(8369),
    [sym_range] = STATE(8369),
    [sym_binary] = STATE(8369),
    [sym_unary] = STATE(8369),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6105] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11728),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_COLON2] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6106] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [6107] = {
    [sym_heredoc_body] = STATE(8371),
    [aux_sym_call_repeat1] = STATE(8371),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_COLON2] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [6108] = {
    [sym_heredoc_body] = STATE(8371),
    [aux_sym_call_repeat1] = STATE(8371),
    [aux_sym_argument_list_repeat1] = STATE(8373),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(11730),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_COLON2] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [6109] = {
    [sym_string] = STATE(6136),
    [aux_sym_chained_string_repeat1] = STATE(6136),
    [sym__string_start] = ACTIONS(9273),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11732),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6110] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [6111] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8374),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(8374),
    [sym_operator_assignment] = STATE(8374),
    [sym_conditional] = STATE(8374),
    [sym_range] = STATE(8374),
    [sym_binary] = STATE(8374),
    [sym_unary] = STATE(8374),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6112] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8375),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8375),
    [sym_operator_assignment] = STATE(8375),
    [sym_conditional] = STATE(8375),
    [sym_range] = STATE(8375),
    [sym_binary] = STATE(8375),
    [sym_unary] = STATE(8375),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6113] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8376),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8376),
    [sym_operator_assignment] = STATE(8376),
    [sym_conditional] = STATE(8376),
    [sym_range] = STATE(8376),
    [sym_binary] = STATE(8376),
    [sym_unary] = STATE(8376),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6114] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8377),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8377),
    [sym_operator_assignment] = STATE(8377),
    [sym_conditional] = STATE(8377),
    [sym_range] = STATE(8377),
    [sym_binary] = STATE(8377),
    [sym_unary] = STATE(8377),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6115] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8378),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8378),
    [sym_operator_assignment] = STATE(8378),
    [sym_conditional] = STATE(8378),
    [sym_range] = STATE(8378),
    [sym_binary] = STATE(8378),
    [sym_unary] = STATE(8378),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6116] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8379),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8379),
    [sym_operator_assignment] = STATE(8379),
    [sym_conditional] = STATE(8379),
    [sym_range] = STATE(8379),
    [sym_binary] = STATE(8379),
    [sym_unary] = STATE(8379),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6117] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8380),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8380),
    [sym_operator_assignment] = STATE(8380),
    [sym_conditional] = STATE(8380),
    [sym_range] = STATE(8380),
    [sym_binary] = STATE(8380),
    [sym_unary] = STATE(8380),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6118] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8381),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8381),
    [sym_operator_assignment] = STATE(8381),
    [sym_conditional] = STATE(8381),
    [sym_range] = STATE(8381),
    [sym_binary] = STATE(8381),
    [sym_unary] = STATE(8381),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6119] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8382),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8382),
    [sym_operator_assignment] = STATE(8382),
    [sym_conditional] = STATE(8382),
    [sym_range] = STATE(8382),
    [sym_binary] = STATE(8382),
    [sym_unary] = STATE(8382),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6120] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8383),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8383),
    [sym_operator_assignment] = STATE(8383),
    [sym_conditional] = STATE(8383),
    [sym_range] = STATE(8383),
    [sym_binary] = STATE(8383),
    [sym_unary] = STATE(8383),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6121] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8384),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8384),
    [sym_operator_assignment] = STATE(8384),
    [sym_conditional] = STATE(8384),
    [sym_range] = STATE(8384),
    [sym_binary] = STATE(8384),
    [sym_unary] = STATE(8384),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6122] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8385),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8385),
    [sym_operator_assignment] = STATE(8385),
    [sym_conditional] = STATE(8385),
    [sym_range] = STATE(8385),
    [sym_binary] = STATE(8385),
    [sym_unary] = STATE(8385),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6123] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8386),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8386),
    [sym_operator_assignment] = STATE(8386),
    [sym_conditional] = STATE(8386),
    [sym_range] = STATE(8386),
    [sym_binary] = STATE(8386),
    [sym_unary] = STATE(8386),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6124] = {
    [anon_sym_COLON] = ACTIONS(11734),
    [sym_comment] = ACTIONS(87),
  },
  [6125] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8388),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8388),
    [sym_operator_assignment] = STATE(8388),
    [sym_conditional] = STATE(8388),
    [sym_range] = STATE(8388),
    [sym_binary] = STATE(8388),
    [sym_unary] = STATE(8388),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6126] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(11736),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_COLON2] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6127] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [6128] = {
    [sym_heredoc_body] = STATE(8390),
    [aux_sym_call_repeat1] = STATE(8390),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_COLON2] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [6129] = {
    [sym_heredoc_body] = STATE(8390),
    [aux_sym_call_repeat1] = STATE(8390),
    [aux_sym_argument_list_repeat1] = STATE(8392),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(11738),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_COLON2] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [6130] = {
    [sym_string] = STATE(6183),
    [aux_sym_chained_string_repeat1] = STATE(6183),
    [sym__string_start] = ACTIONS(9355),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11740),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6131] = {
    [sym_heredoc_body] = STATE(8393),
    [aux_sym_call_repeat1] = STATE(8393),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_COLON2] = ACTIONS(4248),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6132] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(8394),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11742),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6133] = {
    [sym_heredoc_body] = STATE(8395),
    [aux_sym_call_repeat1] = STATE(8395),
    [aux_sym_argument_list_repeat1] = STATE(8396),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9323),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_COLON2] = ACTIONS(4248),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6134] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8397),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_splat_argument] = STATE(8398),
    [sym_assignment] = STATE(8397),
    [sym_operator_assignment] = STATE(8397),
    [sym_conditional] = STATE(8397),
    [sym_range] = STATE(8397),
    [sym_binary] = STATE(8397),
    [sym_unary] = STATE(8397),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(8398),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(9281),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6135] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8399),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(8399),
    [sym_operator_assignment] = STATE(8399),
    [sym_conditional] = STATE(8399),
    [sym_range] = STATE(8399),
    [sym_binary] = STATE(8399),
    [sym_unary] = STATE(8399),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6136] = {
    [sym_string] = STATE(8400),
    [aux_sym_chained_string_repeat1] = STATE(8400),
    [sym__string_start] = ACTIONS(9273),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_COLON2] = ACTIONS(2761),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [6137] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6138] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [6139] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6140] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6141] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6142] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11744),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6143] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(705),
    [sym__binary_star] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(11746),
    [anon_sym___END__] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(711),
    [anon_sym_LT] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_DOT_DOT] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(727),
    [anon_sym_BANG_EQ] = ACTIONS(723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_LT_EQ_GT] = ACTIONS(723),
    [anon_sym_EQ_TILDE] = ACTIONS(723),
    [anon_sym_BANG_TILDE] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(713),
    [anon_sym_GT] = ACTIONS(713),
    [anon_sym_GT_EQ] = ACTIONS(729),
    [anon_sym_CARET] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_SLASH] = ACTIONS(707),
    [anon_sym_PERCENT] = ACTIONS(707),
    [sym_comment] = ACTIONS(87),
  },
  [6144] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COLON2] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6145] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6146] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6147] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6148] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8402),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(8402),
    [sym_operator_assignment] = STATE(8402),
    [sym_conditional] = STATE(8402),
    [sym_range] = STATE(8402),
    [sym_binary] = STATE(8402),
    [sym_unary] = STATE(8402),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6149] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3530),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(6452),
    [sym__argument_list_with_parens] = STATE(3532),
    [sym__argument] = STATE(3533),
    [sym_splat_argument] = STATE(3533),
    [sym_hash_splat_argument] = STATE(3533),
    [sym_block_argument] = STATE(3533),
    [sym_assignment] = STATE(3530),
    [sym_operator_assignment] = STATE(3530),
    [sym_conditional] = STATE(3530),
    [sym_range] = STATE(3530),
    [sym_binary] = STATE(3530),
    [sym_unary] = STATE(3530),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3536),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3533),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5762),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5786),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6150] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3530),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(6453),
    [sym__argument_list_with_parens] = STATE(3532),
    [sym__argument] = STATE(3533),
    [sym_splat_argument] = STATE(3533),
    [sym_hash_splat_argument] = STATE(3533),
    [sym_block_argument] = STATE(3533),
    [sym_assignment] = STATE(3530),
    [sym_operator_assignment] = STATE(3530),
    [sym_conditional] = STATE(3530),
    [sym_range] = STATE(3530),
    [sym_binary] = STATE(3530),
    [sym_unary] = STATE(3530),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3536),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3533),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5762),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5786),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6151] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3530),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(6454),
    [sym__argument_list_with_parens] = STATE(3532),
    [sym__argument] = STATE(3533),
    [sym_splat_argument] = STATE(3533),
    [sym_hash_splat_argument] = STATE(3533),
    [sym_block_argument] = STATE(3533),
    [sym_assignment] = STATE(3530),
    [sym_operator_assignment] = STATE(3530),
    [sym_conditional] = STATE(3530),
    [sym_range] = STATE(3530),
    [sym_binary] = STATE(3530),
    [sym_unary] = STATE(3530),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3536),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3533),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5762),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5786),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6152] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3530),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(6455),
    [sym__argument_list_with_parens] = STATE(3532),
    [sym__argument] = STATE(3533),
    [sym_splat_argument] = STATE(3533),
    [sym_hash_splat_argument] = STATE(3533),
    [sym_block_argument] = STATE(3533),
    [sym_assignment] = STATE(3530),
    [sym_operator_assignment] = STATE(3530),
    [sym_conditional] = STATE(3530),
    [sym_range] = STATE(3530),
    [sym_binary] = STATE(3530),
    [sym_unary] = STATE(3530),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3536),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3533),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5762),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5786),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6153] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8403),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(8403),
    [sym_operator_assignment] = STATE(8403),
    [sym_conditional] = STATE(8403),
    [sym_range] = STATE(8403),
    [sym_binary] = STATE(8403),
    [sym_unary] = STATE(8403),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6154] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6470),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(6470),
    [sym_operator_assignment] = STATE(6470),
    [sym_conditional] = STATE(6470),
    [sym_range] = STATE(6470),
    [sym_binary] = STATE(6470),
    [sym_unary] = STATE(6470),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6155] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(11760),
    [anon_sym_COLON2] = ACTIONS(4080),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [6156] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3530),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_argument_list] = STATE(4737),
    [sym__argument_list_with_parens] = STATE(3532),
    [sym__argument] = STATE(3533),
    [sym_splat_argument] = STATE(3533),
    [sym_hash_splat_argument] = STATE(3533),
    [sym_block_argument] = STATE(3533),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(3530),
    [sym_operator_assignment] = STATE(3530),
    [sym_conditional] = STATE(3530),
    [sym_range] = STATE(3530),
    [sym_binary] = STATE(3530),
    [sym_unary] = STATE(3530),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3536),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(3533),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5762),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(7471),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_COLON2] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5782),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5786),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6157] = {
    [anon_sym_EQ] = ACTIONS(11776),
    [sym_comment] = ACTIONS(87),
  },
  [6158] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11778),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11780),
    [anon_sym_DASH_EQ] = ACTIONS(11780),
    [anon_sym_STAR_EQ] = ACTIONS(11780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11780),
    [anon_sym_SLASH_EQ] = ACTIONS(11780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11780),
    [anon_sym_PIPE_EQ] = ACTIONS(11780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11780),
    [anon_sym_AMP_EQ] = ACTIONS(11780),
    [anon_sym_PERCENT_EQ] = ACTIONS(11780),
    [anon_sym_GT_GT_EQ] = ACTIONS(11780),
    [anon_sym_LT_LT_EQ] = ACTIONS(11780),
    [anon_sym_CARET_EQ] = ACTIONS(11780),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6159] = {
    [sym_string] = STATE(8416),
    [aux_sym_chained_string_repeat1] = STATE(8416),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6160] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11760),
    [anon_sym_COLON2] = ACTIONS(4112),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [6161] = {
    [sym_interpolation] = STATE(57),
    [sym__literal_contents] = STATE(8418),
    [aux_sym__literal_contents_repeat1] = STATE(57),
    [sym__string_content] = ACTIONS(105),
    [sym__string_end] = ACTIONS(11782),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [6162] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6163] = {
    [sym_string] = STATE(6183),
    [aux_sym_chained_string_repeat1] = STATE(6183),
    [sym__string_start] = ACTIONS(9355),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6164] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8419),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(8419),
    [sym_operator_assignment] = STATE(8419),
    [sym_conditional] = STATE(8419),
    [sym_range] = STATE(8419),
    [sym_binary] = STATE(8419),
    [sym_unary] = STATE(8419),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6165] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(11760),
    [anon_sym_COLON2] = ACTIONS(4114),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [6166] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [6167] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8420),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(8420),
    [sym_operator_assignment] = STATE(8420),
    [sym_conditional] = STATE(8420),
    [sym_range] = STATE(8420),
    [sym_binary] = STATE(8420),
    [sym_unary] = STATE(8420),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6168] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8421),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8421),
    [sym_operator_assignment] = STATE(8421),
    [sym_conditional] = STATE(8421),
    [sym_range] = STATE(8421),
    [sym_binary] = STATE(8421),
    [sym_unary] = STATE(8421),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6169] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8422),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8422),
    [sym_operator_assignment] = STATE(8422),
    [sym_conditional] = STATE(8422),
    [sym_range] = STATE(8422),
    [sym_binary] = STATE(8422),
    [sym_unary] = STATE(8422),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6170] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8423),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8423),
    [sym_operator_assignment] = STATE(8423),
    [sym_conditional] = STATE(8423),
    [sym_range] = STATE(8423),
    [sym_binary] = STATE(8423),
    [sym_unary] = STATE(8423),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6171] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8424),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8424),
    [sym_operator_assignment] = STATE(8424),
    [sym_conditional] = STATE(8424),
    [sym_range] = STATE(8424),
    [sym_binary] = STATE(8424),
    [sym_unary] = STATE(8424),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6172] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8425),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8425),
    [sym_operator_assignment] = STATE(8425),
    [sym_conditional] = STATE(8425),
    [sym_range] = STATE(8425),
    [sym_binary] = STATE(8425),
    [sym_unary] = STATE(8425),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6173] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8426),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8426),
    [sym_operator_assignment] = STATE(8426),
    [sym_conditional] = STATE(8426),
    [sym_range] = STATE(8426),
    [sym_binary] = STATE(8426),
    [sym_unary] = STATE(8426),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6174] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8427),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8427),
    [sym_operator_assignment] = STATE(8427),
    [sym_conditional] = STATE(8427),
    [sym_range] = STATE(8427),
    [sym_binary] = STATE(8427),
    [sym_unary] = STATE(8427),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6175] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8428),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8428),
    [sym_operator_assignment] = STATE(8428),
    [sym_conditional] = STATE(8428),
    [sym_range] = STATE(8428),
    [sym_binary] = STATE(8428),
    [sym_unary] = STATE(8428),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6176] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8429),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8429),
    [sym_operator_assignment] = STATE(8429),
    [sym_conditional] = STATE(8429),
    [sym_range] = STATE(8429),
    [sym_binary] = STATE(8429),
    [sym_unary] = STATE(8429),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6177] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8430),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8430),
    [sym_operator_assignment] = STATE(8430),
    [sym_conditional] = STATE(8430),
    [sym_range] = STATE(8430),
    [sym_binary] = STATE(8430),
    [sym_unary] = STATE(8430),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6178] = {
    [sym_heredoc_body] = STATE(8431),
    [aux_sym_call_repeat1] = STATE(8431),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_COLON2] = ACTIONS(4248),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [6179] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3530),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym__argument] = STATE(6514),
    [sym_splat_argument] = STATE(6514),
    [sym_hash_splat_argument] = STATE(6514),
    [sym_block_argument] = STATE(6514),
    [sym_assignment] = STATE(3530),
    [sym_operator_assignment] = STATE(3530),
    [sym_conditional] = STATE(3530),
    [sym_range] = STATE(3530),
    [sym_binary] = STATE(3530),
    [sym_unary] = STATE(3530),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3536),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(8432),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6514),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5762),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__identifier_hash_key] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11784),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5786),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6180] = {
    [sym_heredoc_body] = STATE(8433),
    [aux_sym_call_repeat1] = STATE(8433),
    [aux_sym_argument_list_repeat1] = STATE(8434),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9391),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_COLON2] = ACTIONS(4248),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [6181] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8435),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_splat_argument] = STATE(8436),
    [sym_assignment] = STATE(8435),
    [sym_operator_assignment] = STATE(8435),
    [sym_conditional] = STATE(8435),
    [sym_range] = STATE(8435),
    [sym_binary] = STATE(8435),
    [sym_unary] = STATE(8435),
    [sym_right_assignment_list] = STATE(4290),
    [sym__arg_or_splat_arg] = STATE(8436),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(9317),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6182] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8437),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(8437),
    [sym_operator_assignment] = STATE(8437),
    [sym_conditional] = STATE(8437),
    [sym_range] = STATE(8437),
    [sym_binary] = STATE(8437),
    [sym_unary] = STATE(8437),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6183] = {
    [sym_string] = STATE(8438),
    [aux_sym_chained_string_repeat1] = STATE(8438),
    [sym__string_start] = ACTIONS(9355),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_COLON2] = ACTIONS(2761),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [6184] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8439),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(8439),
    [sym_operator_assignment] = STATE(8439),
    [sym_conditional] = STATE(8439),
    [sym_range] = STATE(8439),
    [sym_binary] = STATE(8439),
    [sym_unary] = STATE(8439),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6185] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8440),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(8440),
    [sym_operator_assignment] = STATE(8440),
    [sym_conditional] = STATE(8440),
    [sym_range] = STATE(8440),
    [sym_binary] = STATE(8440),
    [sym_unary] = STATE(8440),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6186] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(562),
    [sym__argument_list_with_parens] = STATE(8347),
    [sym__argument] = STATE(8348),
    [sym_splat_argument] = STATE(8348),
    [sym_hash_splat_argument] = STATE(8348),
    [sym_block_argument] = STATE(8348),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(8348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6187] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(568),
    [sym__argument_list_with_parens] = STATE(8347),
    [sym__argument] = STATE(8348),
    [sym_splat_argument] = STATE(8348),
    [sym_hash_splat_argument] = STATE(8348),
    [sym_block_argument] = STATE(8348),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(8348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6188] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(8347),
    [sym__argument] = STATE(8348),
    [sym_splat_argument] = STATE(8348),
    [sym_hash_splat_argument] = STATE(8348),
    [sym_block_argument] = STATE(8348),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(8348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6189] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(8347),
    [sym__argument] = STATE(8348),
    [sym_splat_argument] = STATE(8348),
    [sym_hash_splat_argument] = STATE(8348),
    [sym_block_argument] = STATE(8348),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(8348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5722),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6190] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8441),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(8441),
    [sym_operator_assignment] = STATE(8441),
    [sym_conditional] = STATE(8441),
    [sym_range] = STATE(8441),
    [sym_binary] = STATE(8441),
    [sym_unary] = STATE(8441),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6191] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6192] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11790),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(11792),
    [anon_sym_LT] = ACTIONS(11794),
    [anon_sym_QMARK] = ACTIONS(11796),
    [anon_sym_COLON2] = ACTIONS(4970),
    [anon_sym_DOT_DOT] = ACTIONS(11798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11800),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11802),
    [anon_sym_AMP_AMP] = ACTIONS(11802),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(11806),
    [anon_sym_BANG_EQ] = ACTIONS(11802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11802),
    [anon_sym_LT_EQ_GT] = ACTIONS(11802),
    [anon_sym_EQ_TILDE] = ACTIONS(11802),
    [anon_sym_BANG_TILDE] = ACTIONS(11802),
    [anon_sym_LT_EQ] = ACTIONS(11794),
    [anon_sym_GT] = ACTIONS(11794),
    [anon_sym_GT_EQ] = ACTIONS(11808),
    [anon_sym_CARET] = ACTIONS(11810),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [6193] = {
    [aux_sym_exceptions_repeat1] = STATE(8453),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(11812),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_COLON2] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [6194] = {
    [anon_sym_EQ] = ACTIONS(11814),
    [sym_comment] = ACTIONS(87),
  },
  [6195] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11816),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11818),
    [anon_sym_DASH_EQ] = ACTIONS(11818),
    [anon_sym_STAR_EQ] = ACTIONS(11818),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11818),
    [anon_sym_SLASH_EQ] = ACTIONS(11818),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11818),
    [anon_sym_PIPE_EQ] = ACTIONS(11818),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11818),
    [anon_sym_AMP_EQ] = ACTIONS(11818),
    [anon_sym_PERCENT_EQ] = ACTIONS(11818),
    [anon_sym_GT_GT_EQ] = ACTIONS(11818),
    [anon_sym_LT_LT_EQ] = ACTIONS(11818),
    [anon_sym_CARET_EQ] = ACTIONS(11818),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6196] = {
    [sym_string] = STATE(8456),
    [aux_sym_chained_string_repeat1] = STATE(8456),
    [sym__string_start] = ACTIONS(2503),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6197] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(6074),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6198] = {
    [sym_string] = STATE(6198),
    [aux_sym_chained_string_repeat1] = STATE(6198),
    [sym__string_start] = ACTIONS(11820),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_COLON2] = ACTIONS(6081),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [6199] = {
    [sym__heredoc_body_start] = ACTIONS(6547),
    [anon_sym_PIPE] = ACTIONS(6547),
    [anon_sym_STAR] = ACTIONS(8423),
    [anon_sym_STAR_STAR] = ACTIONS(6547),
    [anon_sym_AMP] = ACTIONS(6547),
    [anon_sym_LT] = ACTIONS(8423),
    [anon_sym_LPAREN2] = ACTIONS(6547),
    [anon_sym_DOT_DOT] = ACTIONS(6547),
    [anon_sym_LT_LT] = ACTIONS(6547),
    [anon_sym_GT_GT] = ACTIONS(6547),
    [anon_sym_EQ_EQ] = ACTIONS(8423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6547),
    [anon_sym_LT_EQ_GT] = ACTIONS(6547),
    [anon_sym_EQ_TILDE] = ACTIONS(6547),
    [anon_sym_BANG_TILDE] = ACTIONS(6547),
    [anon_sym_LT_EQ] = ACTIONS(8423),
    [anon_sym_GT] = ACTIONS(8423),
    [anon_sym_GT_EQ] = ACTIONS(6547),
    [anon_sym_CARET] = ACTIONS(6547),
    [anon_sym_PLUS] = ACTIONS(8423),
    [anon_sym_SLASH] = ACTIONS(6547),
    [anon_sym_PERCENT] = ACTIONS(6547),
    [anon_sym_BANG] = ACTIONS(8423),
    [anon_sym_TILDE] = ACTIONS(6547),
    [sym_constant] = ACTIONS(6547),
    [sym_identifier] = ACTIONS(6547),
    [anon_sym_DASH] = ACTIONS(8423),
    [anon_sym_PLUS_AT] = ACTIONS(6547),
    [anon_sym_DASH_AT] = ACTIONS(6547),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8423),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6547),
    [anon_sym_BQUOTE] = ACTIONS(6547),
    [sym_comment] = ACTIONS(87),
  },
  [6200] = {
    [sym__line_break] = ACTIONS(7608),
    [sym__simple_symbol] = ACTIONS(7608),
    [sym__string_start] = ACTIONS(7608),
    [sym__symbol_start] = ACTIONS(7608),
    [sym__subshell_start] = ACTIONS(7608),
    [sym__regex_start] = ACTIONS(7608),
    [sym__string_array_start] = ACTIONS(7608),
    [sym__symbol_array_start] = ACTIONS(7608),
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym_heredoc_beginning] = ACTIONS(7608),
    [sym__block_ampersand] = ACTIONS(7608),
    [sym__splat_star] = ACTIONS(7608),
    [sym__unary_minus] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [sym__identifier_hash_key] = ACTIONS(7608),
    [ts_builtin_sym_end] = ACTIONS(7608),
    [anon_sym___END__] = ACTIONS(7610),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_def] = ACTIONS(7610),
    [anon_sym_LPAREN] = ACTIONS(7610),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COLON_COLON] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR] = ACTIONS(7610),
    [anon_sym_STAR_STAR] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_class] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_module] = ACTIONS(7610),
    [anon_sym_end] = ACTIONS(7610),
    [anon_sym_return] = ACTIONS(7610),
    [anon_sym_yield] = ACTIONS(7610),
    [anon_sym_break] = ACTIONS(7610),
    [anon_sym_next] = ACTIONS(7610),
    [sym_redo] = ACTIONS(7610),
    [sym_retry] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7610),
    [anon_sym_unless] = ACTIONS(7610),
    [anon_sym_while] = ACTIONS(7610),
    [anon_sym_until] = ACTIONS(7610),
    [anon_sym_rescue] = ACTIONS(7610),
    [anon_sym_for] = ACTIONS(7610),
    [anon_sym_do] = ACTIONS(7610),
    [anon_sym_case] = ACTIONS(7610),
    [anon_sym_when] = ACTIONS(7610),
    [anon_sym_elsif] = ACTIONS(7610),
    [anon_sym_else] = ACTIONS(7610),
    [anon_sym_then] = ACTIONS(7610),
    [anon_sym_begin] = ACTIONS(7610),
    [anon_sym_ensure] = ACTIONS(7610),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_LPAREN2] = ACTIONS(7608),
    [anon_sym_PLUS_EQ] = ACTIONS(7608),
    [anon_sym_DASH_EQ] = ACTIONS(7608),
    [anon_sym_STAR_EQ] = ACTIONS(7608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7608),
    [anon_sym_SLASH_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7608),
    [anon_sym_AMP_EQ] = ACTIONS(7608),
    [anon_sym_PERCENT_EQ] = ACTIONS(7608),
    [anon_sym_GT_GT_EQ] = ACTIONS(7608),
    [anon_sym_LT_LT_EQ] = ACTIONS(7608),
    [anon_sym_CARET_EQ] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7610),
    [anon_sym_or] = ACTIONS(7610),
    [anon_sym_PIPE_PIPE] = ACTIONS(7610),
    [anon_sym_AMP_AMP] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [anon_sym_defined_QMARK] = ACTIONS(7608),
    [anon_sym_not] = ACTIONS(7610),
    [anon_sym_BANG] = ACTIONS(7610),
    [anon_sym_TILDE] = ACTIONS(7608),
    [sym_constant] = ACTIONS(7610),
    [sym_identifier] = ACTIONS(7610),
    [sym_instance_variable] = ACTIONS(7608),
    [sym_class_variable] = ACTIONS(7608),
    [sym_global_variable] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7610),
    [sym_float] = ACTIONS(7610),
    [sym_complex] = ACTIONS(7608),
    [sym_super] = ACTIONS(7610),
    [anon_sym_true] = ACTIONS(7610),
    [anon_sym_TRUE] = ACTIONS(7610),
    [anon_sym_false] = ACTIONS(7610),
    [anon_sym_FALSE] = ACTIONS(7610),
    [sym_self] = ACTIONS(7610),
    [anon_sym_nil] = ACTIONS(7610),
    [anon_sym_NIL] = ACTIONS(7610),
    [sym_character] = ACTIONS(7608),
    [anon_sym_LBRACK2] = ACTIONS(7610),
    [anon_sym_DASH_GT] = ACTIONS(7608),
  },
  [6201] = {
    [anon_sym_RPAREN] = ACTIONS(11823),
    [sym_comment] = ACTIONS(87),
  },
  [6202] = {
    [sym__line_break] = ACTIONS(11825),
    [sym__heredoc_body_start] = ACTIONS(11825),
    [sym__binary_minus] = ACTIONS(11825),
    [sym__binary_star] = ACTIONS(11825),
    [ts_builtin_sym_end] = ACTIONS(11825),
    [anon_sym___END__] = ACTIONS(11825),
    [anon_sym_LBRACE] = ACTIONS(11825),
    [anon_sym_RBRACE] = ACTIONS(11825),
    [anon_sym_RPAREN] = ACTIONS(11825),
    [anon_sym_DOT] = ACTIONS(11827),
    [anon_sym_COMMA] = ACTIONS(11825),
    [anon_sym_PIPE] = ACTIONS(11827),
    [anon_sym_SEMI] = ACTIONS(11825),
    [anon_sym_STAR_STAR] = ACTIONS(11827),
    [anon_sym_AMP] = ACTIONS(11827),
    [anon_sym_EQ] = ACTIONS(11827),
    [anon_sym_LT] = ACTIONS(11827),
    [anon_sym_end] = ACTIONS(11825),
    [anon_sym_if] = ACTIONS(11825),
    [anon_sym_unless] = ACTIONS(11825),
    [anon_sym_while] = ACTIONS(11825),
    [anon_sym_until] = ACTIONS(11825),
    [anon_sym_rescue] = ACTIONS(11825),
    [anon_sym_do] = ACTIONS(11825),
    [anon_sym_when] = ACTIONS(11825),
    [anon_sym_elsif] = ACTIONS(11825),
    [anon_sym_else] = ACTIONS(11825),
    [anon_sym_then] = ACTIONS(11825),
    [anon_sym_ensure] = ACTIONS(11825),
    [anon_sym_LBRACK] = ACTIONS(11825),
    [anon_sym_COLON_COLON2] = ACTIONS(11825),
    [anon_sym_AMP_DOT] = ACTIONS(11825),
    [anon_sym_PLUS_EQ] = ACTIONS(11825),
    [anon_sym_DASH_EQ] = ACTIONS(11825),
    [anon_sym_STAR_EQ] = ACTIONS(11825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11825),
    [anon_sym_SLASH_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11825),
    [anon_sym_AMP_EQ] = ACTIONS(11825),
    [anon_sym_PERCENT_EQ] = ACTIONS(11825),
    [anon_sym_GT_GT_EQ] = ACTIONS(11825),
    [anon_sym_LT_LT_EQ] = ACTIONS(11825),
    [anon_sym_CARET_EQ] = ACTIONS(11825),
    [anon_sym_QMARK] = ACTIONS(11825),
    [anon_sym_DOT_DOT] = ACTIONS(11827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11825),
    [anon_sym_and] = ACTIONS(11825),
    [anon_sym_or] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11827),
    [anon_sym_AMP_AMP] = ACTIONS(11827),
    [anon_sym_LT_LT] = ACTIONS(11827),
    [anon_sym_GT_GT] = ACTIONS(11827),
    [anon_sym_EQ_EQ] = ACTIONS(11827),
    [anon_sym_BANG_EQ] = ACTIONS(11825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11825),
    [anon_sym_LT_EQ_GT] = ACTIONS(11825),
    [anon_sym_EQ_TILDE] = ACTIONS(11825),
    [anon_sym_BANG_TILDE] = ACTIONS(11825),
    [anon_sym_LT_EQ] = ACTIONS(11827),
    [anon_sym_GT] = ACTIONS(11827),
    [anon_sym_GT_EQ] = ACTIONS(11825),
    [anon_sym_CARET] = ACTIONS(11827),
    [anon_sym_PLUS] = ACTIONS(11827),
    [anon_sym_SLASH] = ACTIONS(11827),
    [anon_sym_PERCENT] = ACTIONS(11827),
    [sym_comment] = ACTIONS(87),
  },
  [6203] = {
    [sym__line_break] = ACTIONS(6333),
    [sym__heredoc_body_start] = ACTIONS(6333),
    [sym__binary_minus] = ACTIONS(6333),
    [sym__binary_star] = ACTIONS(6333),
    [ts_builtin_sym_end] = ACTIONS(6333),
    [anon_sym___END__] = ACTIONS(6333),
    [anon_sym_LBRACE] = ACTIONS(6333),
    [anon_sym_RBRACE] = ACTIONS(6333),
    [anon_sym_RPAREN] = ACTIONS(6333),
    [anon_sym_DOT] = ACTIONS(6335),
    [anon_sym_COMMA] = ACTIONS(6333),
    [anon_sym_PIPE] = ACTIONS(6335),
    [anon_sym_SEMI] = ACTIONS(6333),
    [anon_sym_STAR_STAR] = ACTIONS(6335),
    [anon_sym_AMP] = ACTIONS(6335),
    [anon_sym_EQ] = ACTIONS(6335),
    [anon_sym_LT] = ACTIONS(6335),
    [anon_sym_end] = ACTIONS(6333),
    [anon_sym_if] = ACTIONS(6333),
    [anon_sym_unless] = ACTIONS(6333),
    [anon_sym_while] = ACTIONS(6333),
    [anon_sym_until] = ACTIONS(6333),
    [anon_sym_rescue] = ACTIONS(6333),
    [anon_sym_do] = ACTIONS(6333),
    [anon_sym_when] = ACTIONS(6333),
    [anon_sym_elsif] = ACTIONS(6333),
    [anon_sym_else] = ACTIONS(6333),
    [anon_sym_then] = ACTIONS(6333),
    [anon_sym_ensure] = ACTIONS(6333),
    [anon_sym_EQ_GT] = ACTIONS(6333),
    [anon_sym_LBRACK] = ACTIONS(6333),
    [anon_sym_COLON_COLON2] = ACTIONS(6333),
    [anon_sym_AMP_DOT] = ACTIONS(6333),
    [anon_sym_PLUS_EQ] = ACTIONS(6333),
    [anon_sym_DASH_EQ] = ACTIONS(6333),
    [anon_sym_STAR_EQ] = ACTIONS(6333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6333),
    [anon_sym_SLASH_EQ] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6333),
    [anon_sym_PIPE_EQ] = ACTIONS(6333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6333),
    [anon_sym_AMP_EQ] = ACTIONS(6333),
    [anon_sym_PERCENT_EQ] = ACTIONS(6333),
    [anon_sym_GT_GT_EQ] = ACTIONS(6333),
    [anon_sym_LT_LT_EQ] = ACTIONS(6333),
    [anon_sym_CARET_EQ] = ACTIONS(6333),
    [anon_sym_QMARK] = ACTIONS(6333),
    [anon_sym_DOT_DOT] = ACTIONS(6335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6333),
    [anon_sym_and] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE] = ACTIONS(6335),
    [anon_sym_AMP_AMP] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6335),
    [anon_sym_GT_GT] = ACTIONS(6335),
    [anon_sym_EQ_EQ] = ACTIONS(6335),
    [anon_sym_BANG_EQ] = ACTIONS(6333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6333),
    [anon_sym_LT_EQ_GT] = ACTIONS(6333),
    [anon_sym_EQ_TILDE] = ACTIONS(6333),
    [anon_sym_BANG_TILDE] = ACTIONS(6333),
    [anon_sym_LT_EQ] = ACTIONS(6335),
    [anon_sym_GT] = ACTIONS(6335),
    [anon_sym_GT_EQ] = ACTIONS(6333),
    [anon_sym_CARET] = ACTIONS(6335),
    [anon_sym_PLUS] = ACTIONS(6335),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_PERCENT] = ACTIONS(6335),
    [sym_comment] = ACTIONS(87),
  },
  [6204] = {
    [sym__line_break] = ACTIONS(6337),
    [sym__heredoc_body_start] = ACTIONS(6337),
    [sym__binary_minus] = ACTIONS(6337),
    [sym__binary_star] = ACTIONS(6337),
    [ts_builtin_sym_end] = ACTIONS(6337),
    [anon_sym___END__] = ACTIONS(6337),
    [anon_sym_LBRACE] = ACTIONS(6337),
    [anon_sym_RBRACE] = ACTIONS(6337),
    [anon_sym_RPAREN] = ACTIONS(6337),
    [anon_sym_DOT] = ACTIONS(6339),
    [anon_sym_COMMA] = ACTIONS(6337),
    [anon_sym_PIPE] = ACTIONS(6339),
    [anon_sym_SEMI] = ACTIONS(6337),
    [anon_sym_STAR_STAR] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6339),
    [anon_sym_EQ] = ACTIONS(6339),
    [anon_sym_LT] = ACTIONS(6339),
    [anon_sym_end] = ACTIONS(6337),
    [anon_sym_if] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6337),
    [anon_sym_while] = ACTIONS(6337),
    [anon_sym_until] = ACTIONS(6337),
    [anon_sym_rescue] = ACTIONS(6337),
    [anon_sym_do] = ACTIONS(6337),
    [anon_sym_when] = ACTIONS(6337),
    [anon_sym_elsif] = ACTIONS(6337),
    [anon_sym_else] = ACTIONS(6337),
    [anon_sym_then] = ACTIONS(6337),
    [anon_sym_ensure] = ACTIONS(6337),
    [anon_sym_EQ_GT] = ACTIONS(6337),
    [anon_sym_LBRACK] = ACTIONS(6337),
    [anon_sym_COLON_COLON2] = ACTIONS(6337),
    [anon_sym_AMP_DOT] = ACTIONS(6337),
    [anon_sym_PLUS_EQ] = ACTIONS(6337),
    [anon_sym_DASH_EQ] = ACTIONS(6337),
    [anon_sym_STAR_EQ] = ACTIONS(6337),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6337),
    [anon_sym_SLASH_EQ] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6337),
    [anon_sym_PIPE_EQ] = ACTIONS(6337),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6337),
    [anon_sym_AMP_EQ] = ACTIONS(6337),
    [anon_sym_PERCENT_EQ] = ACTIONS(6337),
    [anon_sym_GT_GT_EQ] = ACTIONS(6337),
    [anon_sym_LT_LT_EQ] = ACTIONS(6337),
    [anon_sym_CARET_EQ] = ACTIONS(6337),
    [anon_sym_QMARK] = ACTIONS(6337),
    [anon_sym_DOT_DOT] = ACTIONS(6339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6337),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6339),
    [anon_sym_AMP_AMP] = ACTIONS(6339),
    [anon_sym_LT_LT] = ACTIONS(6339),
    [anon_sym_GT_GT] = ACTIONS(6339),
    [anon_sym_EQ_EQ] = ACTIONS(6339),
    [anon_sym_BANG_EQ] = ACTIONS(6337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6337),
    [anon_sym_LT_EQ_GT] = ACTIONS(6337),
    [anon_sym_EQ_TILDE] = ACTIONS(6337),
    [anon_sym_BANG_TILDE] = ACTIONS(6337),
    [anon_sym_LT_EQ] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6339),
    [anon_sym_GT_EQ] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6339),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_SLASH] = ACTIONS(6339),
    [anon_sym_PERCENT] = ACTIONS(6339),
    [sym_comment] = ACTIONS(87),
  },
  [6205] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11829),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6206] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(11829),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11831),
  },
  [6207] = {
    [sym__line_break] = ACTIONS(6345),
    [sym__heredoc_body_start] = ACTIONS(6345),
    [sym__binary_minus] = ACTIONS(6345),
    [sym__binary_star] = ACTIONS(6345),
    [ts_builtin_sym_end] = ACTIONS(6345),
    [anon_sym___END__] = ACTIONS(6345),
    [anon_sym_LBRACE] = ACTIONS(6345),
    [anon_sym_RBRACE] = ACTIONS(6345),
    [anon_sym_RPAREN] = ACTIONS(6345),
    [anon_sym_DOT] = ACTIONS(6347),
    [anon_sym_COMMA] = ACTIONS(6345),
    [anon_sym_PIPE] = ACTIONS(6347),
    [anon_sym_SEMI] = ACTIONS(6345),
    [anon_sym_STAR_STAR] = ACTIONS(6347),
    [anon_sym_AMP] = ACTIONS(6347),
    [anon_sym_EQ] = ACTIONS(6347),
    [anon_sym_LT] = ACTIONS(6347),
    [anon_sym_end] = ACTIONS(6345),
    [anon_sym_if] = ACTIONS(6345),
    [anon_sym_unless] = ACTIONS(6345),
    [anon_sym_while] = ACTIONS(6345),
    [anon_sym_until] = ACTIONS(6345),
    [anon_sym_rescue] = ACTIONS(6345),
    [anon_sym_do] = ACTIONS(6345),
    [anon_sym_when] = ACTIONS(6345),
    [anon_sym_elsif] = ACTIONS(6345),
    [anon_sym_else] = ACTIONS(6345),
    [anon_sym_then] = ACTIONS(6345),
    [anon_sym_ensure] = ACTIONS(6345),
    [anon_sym_EQ_GT] = ACTIONS(6345),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_COLON_COLON2] = ACTIONS(6345),
    [anon_sym_AMP_DOT] = ACTIONS(6345),
    [anon_sym_PLUS_EQ] = ACTIONS(6345),
    [anon_sym_DASH_EQ] = ACTIONS(6345),
    [anon_sym_STAR_EQ] = ACTIONS(6345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6345),
    [anon_sym_SLASH_EQ] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6345),
    [anon_sym_PIPE_EQ] = ACTIONS(6345),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6345),
    [anon_sym_AMP_EQ] = ACTIONS(6345),
    [anon_sym_PERCENT_EQ] = ACTIONS(6345),
    [anon_sym_GT_GT_EQ] = ACTIONS(6345),
    [anon_sym_LT_LT_EQ] = ACTIONS(6345),
    [anon_sym_CARET_EQ] = ACTIONS(6345),
    [anon_sym_QMARK] = ACTIONS(6345),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6345),
    [anon_sym_and] = ACTIONS(6345),
    [anon_sym_or] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6347),
    [anon_sym_LT_LT] = ACTIONS(6347),
    [anon_sym_GT_GT] = ACTIONS(6347),
    [anon_sym_EQ_EQ] = ACTIONS(6347),
    [anon_sym_BANG_EQ] = ACTIONS(6345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6345),
    [anon_sym_LT_EQ_GT] = ACTIONS(6345),
    [anon_sym_EQ_TILDE] = ACTIONS(6345),
    [anon_sym_BANG_TILDE] = ACTIONS(6345),
    [anon_sym_LT_EQ] = ACTIONS(6347),
    [anon_sym_GT] = ACTIONS(6347),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_CARET] = ACTIONS(6347),
    [anon_sym_PLUS] = ACTIONS(6347),
    [anon_sym_SLASH] = ACTIONS(6347),
    [anon_sym_PERCENT] = ACTIONS(6347),
    [sym_comment] = ACTIONS(87),
  },
  [6208] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11833),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6209] = {
    [sym__line_break] = ACTIONS(6358),
    [sym__heredoc_body_start] = ACTIONS(6358),
    [sym__binary_minus] = ACTIONS(6358),
    [sym__binary_star] = ACTIONS(6358),
    [ts_builtin_sym_end] = ACTIONS(6358),
    [anon_sym___END__] = ACTIONS(6358),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RBRACE] = ACTIONS(6358),
    [anon_sym_RPAREN] = ACTIONS(6358),
    [anon_sym_DOT] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6360),
    [anon_sym_SEMI] = ACTIONS(6358),
    [anon_sym_STAR_STAR] = ACTIONS(6360),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6360),
    [anon_sym_end] = ACTIONS(6358),
    [anon_sym_if] = ACTIONS(6358),
    [anon_sym_unless] = ACTIONS(6358),
    [anon_sym_while] = ACTIONS(6358),
    [anon_sym_until] = ACTIONS(6358),
    [anon_sym_rescue] = ACTIONS(6358),
    [anon_sym_do] = ACTIONS(6358),
    [anon_sym_when] = ACTIONS(6358),
    [anon_sym_elsif] = ACTIONS(6358),
    [anon_sym_else] = ACTIONS(6358),
    [anon_sym_then] = ACTIONS(6358),
    [anon_sym_ensure] = ACTIONS(6358),
    [anon_sym_EQ_GT] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6358),
    [anon_sym_COLON_COLON2] = ACTIONS(6358),
    [anon_sym_AMP_DOT] = ACTIONS(6358),
    [anon_sym_PLUS_EQ] = ACTIONS(6358),
    [anon_sym_DASH_EQ] = ACTIONS(6358),
    [anon_sym_STAR_EQ] = ACTIONS(6358),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6358),
    [anon_sym_SLASH_EQ] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6358),
    [anon_sym_PIPE_EQ] = ACTIONS(6358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6358),
    [anon_sym_AMP_EQ] = ACTIONS(6358),
    [anon_sym_PERCENT_EQ] = ACTIONS(6358),
    [anon_sym_GT_GT_EQ] = ACTIONS(6358),
    [anon_sym_LT_LT_EQ] = ACTIONS(6358),
    [anon_sym_CARET_EQ] = ACTIONS(6358),
    [anon_sym_QMARK] = ACTIONS(6358),
    [anon_sym_DOT_DOT] = ACTIONS(6360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6358),
    [anon_sym_and] = ACTIONS(6358),
    [anon_sym_or] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE] = ACTIONS(6360),
    [anon_sym_AMP_AMP] = ACTIONS(6360),
    [anon_sym_LT_LT] = ACTIONS(6360),
    [anon_sym_GT_GT] = ACTIONS(6360),
    [anon_sym_EQ_EQ] = ACTIONS(6360),
    [anon_sym_BANG_EQ] = ACTIONS(6358),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6358),
    [anon_sym_LT_EQ_GT] = ACTIONS(6358),
    [anon_sym_EQ_TILDE] = ACTIONS(6358),
    [anon_sym_BANG_TILDE] = ACTIONS(6358),
    [anon_sym_LT_EQ] = ACTIONS(6360),
    [anon_sym_GT] = ACTIONS(6360),
    [anon_sym_GT_EQ] = ACTIONS(6358),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_PERCENT] = ACTIONS(6360),
    [sym_comment] = ACTIONS(87),
  },
  [6210] = {
    [sym__line_break] = ACTIONS(6362),
    [sym__heredoc_body_start] = ACTIONS(6362),
    [sym__binary_minus] = ACTIONS(6362),
    [sym__binary_star] = ACTIONS(6362),
    [ts_builtin_sym_end] = ACTIONS(6362),
    [anon_sym___END__] = ACTIONS(6362),
    [anon_sym_LBRACE] = ACTIONS(6362),
    [anon_sym_RBRACE] = ACTIONS(6362),
    [anon_sym_RPAREN] = ACTIONS(6362),
    [anon_sym_DOT] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6364),
    [anon_sym_SEMI] = ACTIONS(6362),
    [anon_sym_STAR_STAR] = ACTIONS(6364),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6364),
    [anon_sym_end] = ACTIONS(6362),
    [anon_sym_if] = ACTIONS(6362),
    [anon_sym_unless] = ACTIONS(6362),
    [anon_sym_while] = ACTIONS(6362),
    [anon_sym_until] = ACTIONS(6362),
    [anon_sym_rescue] = ACTIONS(6362),
    [anon_sym_do] = ACTIONS(6362),
    [anon_sym_when] = ACTIONS(6362),
    [anon_sym_elsif] = ACTIONS(6362),
    [anon_sym_else] = ACTIONS(6362),
    [anon_sym_then] = ACTIONS(6362),
    [anon_sym_ensure] = ACTIONS(6362),
    [anon_sym_EQ_GT] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6362),
    [anon_sym_COLON_COLON2] = ACTIONS(6362),
    [anon_sym_AMP_DOT] = ACTIONS(6362),
    [anon_sym_PLUS_EQ] = ACTIONS(6362),
    [anon_sym_DASH_EQ] = ACTIONS(6362),
    [anon_sym_STAR_EQ] = ACTIONS(6362),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6362),
    [anon_sym_SLASH_EQ] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6362),
    [anon_sym_PIPE_EQ] = ACTIONS(6362),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6362),
    [anon_sym_AMP_EQ] = ACTIONS(6362),
    [anon_sym_PERCENT_EQ] = ACTIONS(6362),
    [anon_sym_GT_GT_EQ] = ACTIONS(6362),
    [anon_sym_LT_LT_EQ] = ACTIONS(6362),
    [anon_sym_CARET_EQ] = ACTIONS(6362),
    [anon_sym_QMARK] = ACTIONS(6362),
    [anon_sym_DOT_DOT] = ACTIONS(6364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6362),
    [anon_sym_and] = ACTIONS(6362),
    [anon_sym_or] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE] = ACTIONS(6364),
    [anon_sym_AMP_AMP] = ACTIONS(6364),
    [anon_sym_LT_LT] = ACTIONS(6364),
    [anon_sym_GT_GT] = ACTIONS(6364),
    [anon_sym_EQ_EQ] = ACTIONS(6364),
    [anon_sym_BANG_EQ] = ACTIONS(6362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6362),
    [anon_sym_LT_EQ_GT] = ACTIONS(6362),
    [anon_sym_EQ_TILDE] = ACTIONS(6362),
    [anon_sym_BANG_TILDE] = ACTIONS(6362),
    [anon_sym_LT_EQ] = ACTIONS(6364),
    [anon_sym_GT] = ACTIONS(6364),
    [anon_sym_GT_EQ] = ACTIONS(6362),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_PERCENT] = ACTIONS(6364),
    [sym_comment] = ACTIONS(87),
  },
  [6211] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11835),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6212] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(11835),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11837),
  },
  [6213] = {
    [sym__line_break] = ACTIONS(6370),
    [sym__heredoc_body_start] = ACTIONS(6370),
    [sym__binary_minus] = ACTIONS(6370),
    [sym__binary_star] = ACTIONS(6370),
    [ts_builtin_sym_end] = ACTIONS(6370),
    [anon_sym___END__] = ACTIONS(6370),
    [anon_sym_LBRACE] = ACTIONS(6370),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_RPAREN] = ACTIONS(6370),
    [anon_sym_DOT] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym_STAR_STAR] = ACTIONS(6372),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_end] = ACTIONS(6370),
    [anon_sym_if] = ACTIONS(6370),
    [anon_sym_unless] = ACTIONS(6370),
    [anon_sym_while] = ACTIONS(6370),
    [anon_sym_until] = ACTIONS(6370),
    [anon_sym_rescue] = ACTIONS(6370),
    [anon_sym_do] = ACTIONS(6370),
    [anon_sym_when] = ACTIONS(6370),
    [anon_sym_elsif] = ACTIONS(6370),
    [anon_sym_else] = ACTIONS(6370),
    [anon_sym_then] = ACTIONS(6370),
    [anon_sym_ensure] = ACTIONS(6370),
    [anon_sym_EQ_GT] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6370),
    [anon_sym_COLON_COLON2] = ACTIONS(6370),
    [anon_sym_AMP_DOT] = ACTIONS(6370),
    [anon_sym_PLUS_EQ] = ACTIONS(6370),
    [anon_sym_DASH_EQ] = ACTIONS(6370),
    [anon_sym_STAR_EQ] = ACTIONS(6370),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6370),
    [anon_sym_SLASH_EQ] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6370),
    [anon_sym_PIPE_EQ] = ACTIONS(6370),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6370),
    [anon_sym_AMP_EQ] = ACTIONS(6370),
    [anon_sym_PERCENT_EQ] = ACTIONS(6370),
    [anon_sym_GT_GT_EQ] = ACTIONS(6370),
    [anon_sym_LT_LT_EQ] = ACTIONS(6370),
    [anon_sym_CARET_EQ] = ACTIONS(6370),
    [anon_sym_QMARK] = ACTIONS(6370),
    [anon_sym_DOT_DOT] = ACTIONS(6372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6370),
    [anon_sym_and] = ACTIONS(6370),
    [anon_sym_or] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE] = ACTIONS(6372),
    [anon_sym_AMP_AMP] = ACTIONS(6372),
    [anon_sym_LT_LT] = ACTIONS(6372),
    [anon_sym_GT_GT] = ACTIONS(6372),
    [anon_sym_EQ_EQ] = ACTIONS(6372),
    [anon_sym_BANG_EQ] = ACTIONS(6370),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6370),
    [anon_sym_LT_EQ_GT] = ACTIONS(6370),
    [anon_sym_EQ_TILDE] = ACTIONS(6370),
    [anon_sym_BANG_TILDE] = ACTIONS(6370),
    [anon_sym_LT_EQ] = ACTIONS(6372),
    [anon_sym_GT] = ACTIONS(6372),
    [anon_sym_GT_EQ] = ACTIONS(6370),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_PERCENT] = ACTIONS(6372),
    [sym_comment] = ACTIONS(87),
  },
  [6214] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11839),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6215] = {
    [sym__line_break] = ACTIONS(2895),
    [sym__string_start] = ACTIONS(2895),
    [sym__heredoc_body_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [ts_builtin_sym_end] = ACTIONS(2895),
    [anon_sym___END__] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_end] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_unless] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_until] = ACTIONS(2895),
    [anon_sym_rescue] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_when] = ACTIONS(2895),
    [anon_sym_elsif] = ACTIONS(2895),
    [anon_sym_else] = ACTIONS(2895),
    [anon_sym_then] = ACTIONS(2895),
    [anon_sym_ensure] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2895),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [sym_comment] = ACTIONS(87),
  },
  [6216] = {
    [sym__line_break] = ACTIONS(2907),
    [sym__heredoc_body_start] = ACTIONS(2907),
    [sym__binary_minus] = ACTIONS(2907),
    [sym__binary_star] = ACTIONS(2907),
    [ts_builtin_sym_end] = ACTIONS(2907),
    [anon_sym___END__] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_STAR_STAR] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_end] = ACTIONS(2907),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_unless] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_until] = ACTIONS(2907),
    [anon_sym_rescue] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_when] = ACTIONS(2907),
    [anon_sym_elsif] = ACTIONS(2907),
    [anon_sym_else] = ACTIONS(2907),
    [anon_sym_then] = ACTIONS(2907),
    [anon_sym_ensure] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_COLON_COLON2] = ACTIONS(2907),
    [anon_sym_AMP_DOT] = ACTIONS(2907),
    [anon_sym_PLUS_EQ] = ACTIONS(2907),
    [anon_sym_DASH_EQ] = ACTIONS(2907),
    [anon_sym_STAR_EQ] = ACTIONS(2907),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2907),
    [anon_sym_SLASH_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2907),
    [anon_sym_AMP_EQ] = ACTIONS(2907),
    [anon_sym_PERCENT_EQ] = ACTIONS(2907),
    [anon_sym_GT_GT_EQ] = ACTIONS(2907),
    [anon_sym_LT_LT_EQ] = ACTIONS(2907),
    [anon_sym_CARET_EQ] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_and] = ACTIONS(2907),
    [anon_sym_or] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_LT_LT] = ACTIONS(2909),
    [anon_sym_GT_GT] = ACTIONS(2909),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_CARET] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_PERCENT] = ACTIONS(2909),
    [sym_comment] = ACTIONS(87),
  },
  [6217] = {
    [sym__line_break] = ACTIONS(2911),
    [sym__heredoc_body_start] = ACTIONS(2911),
    [sym__binary_minus] = ACTIONS(2911),
    [sym__binary_star] = ACTIONS(2911),
    [ts_builtin_sym_end] = ACTIONS(2911),
    [anon_sym___END__] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_RPAREN] = ACTIONS(2911),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_end] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_unless] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_until] = ACTIONS(2911),
    [anon_sym_rescue] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_when] = ACTIONS(2911),
    [anon_sym_elsif] = ACTIONS(2911),
    [anon_sym_else] = ACTIONS(2911),
    [anon_sym_then] = ACTIONS(2911),
    [anon_sym_ensure] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_COLON_COLON2] = ACTIONS(2911),
    [anon_sym_AMP_DOT] = ACTIONS(2911),
    [anon_sym_PLUS_EQ] = ACTIONS(2911),
    [anon_sym_DASH_EQ] = ACTIONS(2911),
    [anon_sym_STAR_EQ] = ACTIONS(2911),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2911),
    [anon_sym_SLASH_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2911),
    [anon_sym_AMP_EQ] = ACTIONS(2911),
    [anon_sym_PERCENT_EQ] = ACTIONS(2911),
    [anon_sym_GT_GT_EQ] = ACTIONS(2911),
    [anon_sym_LT_LT_EQ] = ACTIONS(2911),
    [anon_sym_CARET_EQ] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_CARET] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(87),
  },
  [6218] = {
    [sym__line_break] = ACTIONS(2915),
    [sym__heredoc_body_start] = ACTIONS(2915),
    [sym__binary_minus] = ACTIONS(2915),
    [sym__binary_star] = ACTIONS(2915),
    [ts_builtin_sym_end] = ACTIONS(2915),
    [anon_sym___END__] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_STAR_STAR] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_end] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_unless] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_until] = ACTIONS(2915),
    [anon_sym_rescue] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_when] = ACTIONS(2915),
    [anon_sym_elsif] = ACTIONS(2915),
    [anon_sym_else] = ACTIONS(2915),
    [anon_sym_then] = ACTIONS(2915),
    [anon_sym_ensure] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_COLON_COLON2] = ACTIONS(2915),
    [anon_sym_AMP_DOT] = ACTIONS(2915),
    [anon_sym_PLUS_EQ] = ACTIONS(2915),
    [anon_sym_DASH_EQ] = ACTIONS(2915),
    [anon_sym_STAR_EQ] = ACTIONS(2915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2915),
    [anon_sym_SLASH_EQ] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2915),
    [anon_sym_PIPE_EQ] = ACTIONS(2915),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2915),
    [anon_sym_AMP_EQ] = ACTIONS(2915),
    [anon_sym_PERCENT_EQ] = ACTIONS(2915),
    [anon_sym_GT_GT_EQ] = ACTIONS(2915),
    [anon_sym_LT_LT_EQ] = ACTIONS(2915),
    [anon_sym_CARET_EQ] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_LT_LT] = ACTIONS(2917),
    [anon_sym_GT_GT] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2915),
    [anon_sym_EQ_TILDE] = ACTIONS(2915),
    [anon_sym_BANG_TILDE] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2917),
    [sym_comment] = ACTIONS(87),
  },
  [6219] = {
    [sym__line_break] = ACTIONS(2921),
    [sym__heredoc_body_start] = ACTIONS(2921),
    [sym__binary_minus] = ACTIONS(2921),
    [sym__binary_star] = ACTIONS(2921),
    [ts_builtin_sym_end] = ACTIONS(2921),
    [anon_sym___END__] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_end] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_unless] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_until] = ACTIONS(2921),
    [anon_sym_rescue] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_when] = ACTIONS(2921),
    [anon_sym_elsif] = ACTIONS(2921),
    [anon_sym_else] = ACTIONS(2921),
    [anon_sym_then] = ACTIONS(2921),
    [anon_sym_ensure] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_COLON_COLON2] = ACTIONS(2921),
    [anon_sym_AMP_DOT] = ACTIONS(2921),
    [anon_sym_PLUS_EQ] = ACTIONS(2921),
    [anon_sym_DASH_EQ] = ACTIONS(2921),
    [anon_sym_STAR_EQ] = ACTIONS(2921),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2921),
    [anon_sym_AMP_EQ] = ACTIONS(2921),
    [anon_sym_PERCENT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_LT_LT_EQ] = ACTIONS(2921),
    [anon_sym_CARET_EQ] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_and] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [sym_comment] = ACTIONS(87),
  },
  [6220] = {
    [sym__string_end] = ACTIONS(11841),
    [sym_comment] = ACTIONS(87),
  },
  [6221] = {
    [aux_sym_string_array_repeat1] = STATE(8467),
    [sym__string_end] = ACTIONS(11843),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11845),
  },
  [6222] = {
    [sym__line_break] = ACTIONS(2931),
    [sym__heredoc_body_start] = ACTIONS(2931),
    [sym__binary_minus] = ACTIONS(2931),
    [sym__binary_star] = ACTIONS(2931),
    [ts_builtin_sym_end] = ACTIONS(2931),
    [anon_sym___END__] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_STAR_STAR] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_end] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_unless] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_until] = ACTIONS(2931),
    [anon_sym_rescue] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_when] = ACTIONS(2931),
    [anon_sym_elsif] = ACTIONS(2931),
    [anon_sym_else] = ACTIONS(2931),
    [anon_sym_then] = ACTIONS(2931),
    [anon_sym_ensure] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_COLON_COLON2] = ACTIONS(2931),
    [anon_sym_AMP_DOT] = ACTIONS(2931),
    [anon_sym_PLUS_EQ] = ACTIONS(2931),
    [anon_sym_DASH_EQ] = ACTIONS(2931),
    [anon_sym_STAR_EQ] = ACTIONS(2931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2931),
    [anon_sym_SLASH_EQ] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2931),
    [anon_sym_PIPE_EQ] = ACTIONS(2931),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2931),
    [anon_sym_AMP_EQ] = ACTIONS(2931),
    [anon_sym_PERCENT_EQ] = ACTIONS(2931),
    [anon_sym_GT_GT_EQ] = ACTIONS(2931),
    [anon_sym_LT_LT_EQ] = ACTIONS(2931),
    [anon_sym_CARET_EQ] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2931),
    [anon_sym_DOT_DOT] = ACTIONS(2933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2931),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_EQ_EQ] = ACTIONS(2933),
    [anon_sym_BANG_EQ] = ACTIONS(2931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2931),
    [anon_sym_EQ_TILDE] = ACTIONS(2931),
    [anon_sym_BANG_TILDE] = ACTIONS(2931),
    [anon_sym_LT_EQ] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_GT_EQ] = ACTIONS(2931),
    [anon_sym_CARET] = ACTIONS(2933),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(87),
  },
  [6223] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11847),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6224] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(11847),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11849),
  },
  [6225] = {
    [sym__line_break] = ACTIONS(2950),
    [sym__heredoc_body_start] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym__binary_star] = ACTIONS(2950),
    [ts_builtin_sym_end] = ACTIONS(2950),
    [anon_sym___END__] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_STAR_STAR] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_end] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_unless] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_until] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_when] = ACTIONS(2950),
    [anon_sym_elsif] = ACTIONS(2950),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_then] = ACTIONS(2950),
    [anon_sym_ensure] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_COLON_COLON2] = ACTIONS(2950),
    [anon_sym_AMP_DOT] = ACTIONS(2950),
    [anon_sym_PLUS_EQ] = ACTIONS(2950),
    [anon_sym_DASH_EQ] = ACTIONS(2950),
    [anon_sym_STAR_EQ] = ACTIONS(2950),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2950),
    [anon_sym_SLASH_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2950),
    [anon_sym_AMP_EQ] = ACTIONS(2950),
    [anon_sym_PERCENT_EQ] = ACTIONS(2950),
    [anon_sym_GT_GT_EQ] = ACTIONS(2950),
    [anon_sym_LT_LT_EQ] = ACTIONS(2950),
    [anon_sym_CARET_EQ] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_LT_LT] = ACTIONS(2952),
    [anon_sym_GT_GT] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ_GT] = ACTIONS(2950),
    [anon_sym_EQ_TILDE] = ACTIONS(2950),
    [anon_sym_BANG_TILDE] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_PERCENT] = ACTIONS(2952),
    [sym_comment] = ACTIONS(87),
  },
  [6226] = {
    [sym__string_end] = ACTIONS(11851),
    [sym_comment] = ACTIONS(87),
  },
  [6227] = {
    [aux_sym_symbol_array_repeat1] = STATE(8473),
    [sym__string_end] = ACTIONS(11853),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11855),
  },
  [6228] = {
    [sym__line_break] = ACTIONS(2960),
    [sym__heredoc_body_start] = ACTIONS(2960),
    [sym__binary_minus] = ACTIONS(2960),
    [sym__binary_star] = ACTIONS(2960),
    [ts_builtin_sym_end] = ACTIONS(2960),
    [anon_sym___END__] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_RPAREN] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_STAR_STAR] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_end] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_unless] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_until] = ACTIONS(2960),
    [anon_sym_rescue] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_when] = ACTIONS(2960),
    [anon_sym_elsif] = ACTIONS(2960),
    [anon_sym_else] = ACTIONS(2960),
    [anon_sym_then] = ACTIONS(2960),
    [anon_sym_ensure] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_COLON_COLON2] = ACTIONS(2960),
    [anon_sym_AMP_DOT] = ACTIONS(2960),
    [anon_sym_PLUS_EQ] = ACTIONS(2960),
    [anon_sym_DASH_EQ] = ACTIONS(2960),
    [anon_sym_STAR_EQ] = ACTIONS(2960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2960),
    [anon_sym_SLASH_EQ] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2960),
    [anon_sym_PIPE_EQ] = ACTIONS(2960),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2960),
    [anon_sym_AMP_EQ] = ACTIONS(2960),
    [anon_sym_PERCENT_EQ] = ACTIONS(2960),
    [anon_sym_GT_GT_EQ] = ACTIONS(2960),
    [anon_sym_LT_LT_EQ] = ACTIONS(2960),
    [anon_sym_CARET_EQ] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2960),
    [anon_sym_DOT_DOT] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_LT_LT] = ACTIONS(2962),
    [anon_sym_GT_GT] = ACTIONS(2962),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2960),
    [anon_sym_LT_EQ_GT] = ACTIONS(2960),
    [anon_sym_EQ_TILDE] = ACTIONS(2960),
    [anon_sym_BANG_TILDE] = ACTIONS(2960),
    [anon_sym_LT_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [sym_comment] = ACTIONS(87),
  },
  [6229] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(11857),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6230] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(11857),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11859),
  },
  [6231] = {
    [sym__line_break] = ACTIONS(3440),
    [sym__heredoc_body_start] = ACTIONS(3440),
    [sym__binary_minus] = ACTIONS(3440),
    [sym__binary_star] = ACTIONS(3440),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [anon_sym___END__] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3440),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_end] = ACTIONS(3440),
    [anon_sym_if] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3440),
    [anon_sym_while] = ACTIONS(3440),
    [anon_sym_until] = ACTIONS(3440),
    [anon_sym_rescue] = ACTIONS(3440),
    [anon_sym_do] = ACTIONS(3440),
    [anon_sym_when] = ACTIONS(3440),
    [anon_sym_elsif] = ACTIONS(3440),
    [anon_sym_else] = ACTIONS(3440),
    [anon_sym_then] = ACTIONS(3440),
    [anon_sym_ensure] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3440),
    [anon_sym_COLON_COLON2] = ACTIONS(3440),
    [anon_sym_AMP_DOT] = ACTIONS(3440),
    [anon_sym_PLUS_EQ] = ACTIONS(3440),
    [anon_sym_DASH_EQ] = ACTIONS(3440),
    [anon_sym_STAR_EQ] = ACTIONS(3440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3440),
    [anon_sym_SLASH_EQ] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3440),
    [anon_sym_PIPE_EQ] = ACTIONS(3440),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3440),
    [anon_sym_AMP_EQ] = ACTIONS(3440),
    [anon_sym_PERCENT_EQ] = ACTIONS(3440),
    [anon_sym_GT_GT_EQ] = ACTIONS(3440),
    [anon_sym_LT_LT_EQ] = ACTIONS(3440),
    [anon_sym_CARET_EQ] = ACTIONS(3440),
    [anon_sym_QMARK] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3440),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_LT_LT] = ACTIONS(3442),
    [anon_sym_GT_GT] = ACTIONS(3442),
    [anon_sym_EQ_EQ] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3440),
    [anon_sym_BANG_TILDE] = ACTIONS(3440),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3440),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_SLASH] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [sym_comment] = ACTIONS(87),
  },
  [6232] = {
    [anon_sym_RBRACE] = ACTIONS(11861),
    [sym_comment] = ACTIONS(87),
  },
  [6233] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(11863),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [6234] = {
    [sym__method_rest] = STATE(8478),
    [sym_operator] = STATE(3586),
    [sym__method_name] = STATE(3586),
    [sym_setter] = STATE(3586),
    [sym_symbol] = STATE(3586),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(11865),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(11865),
    [sym_class_variable] = ACTIONS(11865),
    [sym_global_variable] = ACTIONS(11865),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [6235] = {
    [sym__statements] = STATE(3605),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(3606),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(3607),
    [sym_rescue] = STATE(3608),
    [sym__body_statement] = STATE(8479),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11867),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6236] = {
    [sym__line_break] = ACTIONS(3670),
    [sym__heredoc_body_start] = ACTIONS(3670),
    [sym__binary_minus] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [ts_builtin_sym_end] = ACTIONS(3670),
    [anon_sym___END__] = ACTIONS(3670),
    [anon_sym_LBRACE] = ACTIONS(3670),
    [anon_sym_RBRACE] = ACTIONS(3670),
    [anon_sym_RPAREN] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_SEMI] = ACTIONS(3670),
    [anon_sym_STAR_STAR] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3672),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3672),
    [anon_sym_end] = ACTIONS(3670),
    [anon_sym_if] = ACTIONS(3670),
    [anon_sym_unless] = ACTIONS(3670),
    [anon_sym_while] = ACTIONS(3670),
    [anon_sym_until] = ACTIONS(3670),
    [anon_sym_rescue] = ACTIONS(3670),
    [anon_sym_do] = ACTIONS(3670),
    [anon_sym_when] = ACTIONS(3670),
    [anon_sym_elsif] = ACTIONS(3670),
    [anon_sym_else] = ACTIONS(3670),
    [anon_sym_then] = ACTIONS(3670),
    [anon_sym_ensure] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3670),
    [anon_sym_COLON_COLON2] = ACTIONS(3670),
    [anon_sym_AMP_DOT] = ACTIONS(3670),
    [anon_sym_PLUS_EQ] = ACTIONS(3670),
    [anon_sym_DASH_EQ] = ACTIONS(3670),
    [anon_sym_STAR_EQ] = ACTIONS(3670),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3670),
    [anon_sym_SLASH_EQ] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3670),
    [anon_sym_PIPE_EQ] = ACTIONS(3670),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3670),
    [anon_sym_AMP_EQ] = ACTIONS(3670),
    [anon_sym_PERCENT_EQ] = ACTIONS(3670),
    [anon_sym_GT_GT_EQ] = ACTIONS(3670),
    [anon_sym_LT_LT_EQ] = ACTIONS(3670),
    [anon_sym_CARET_EQ] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3670),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3672),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LT_EQ_GT] = ACTIONS(3670),
    [anon_sym_EQ_TILDE] = ACTIONS(3670),
    [anon_sym_BANG_TILDE] = ACTIONS(3670),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3672),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [sym_comment] = ACTIONS(87),
  },
  [6237] = {
    [sym_heredoc_body] = STATE(8480),
    [sym__terminator] = STATE(8480),
    [sym__line_break] = ACTIONS(11869),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(11869),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [6238] = {
    [sym_heredoc_body] = STATE(8481),
    [sym__terminator] = STATE(8481),
    [sym__line_break] = ACTIONS(11871),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(11871),
    [sym_comment] = ACTIONS(87),
  },
  [6239] = {
    [sym__statements] = STATE(3605),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(3606),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(3607),
    [sym_rescue] = STATE(3608),
    [sym__body_statement] = STATE(8482),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11873),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6240] = {
    [sym__line_break] = ACTIONS(4068),
    [sym__heredoc_body_start] = ACTIONS(4068),
    [sym__binary_minus] = ACTIONS(4068),
    [sym__binary_star] = ACTIONS(4068),
    [ts_builtin_sym_end] = ACTIONS(4068),
    [anon_sym___END__] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_STAR_STAR] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_end] = ACTIONS(4068),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_unless] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_until] = ACTIONS(4068),
    [anon_sym_rescue] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_when] = ACTIONS(4068),
    [anon_sym_elsif] = ACTIONS(4068),
    [anon_sym_else] = ACTIONS(4068),
    [anon_sym_then] = ACTIONS(4068),
    [anon_sym_ensure] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON_COLON2] = ACTIONS(4068),
    [anon_sym_AMP_DOT] = ACTIONS(4068),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ_GT] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_BANG_TILDE] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [sym_comment] = ACTIONS(87),
  },
  [6241] = {
    [sym__statements] = STATE(3605),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(3606),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(3607),
    [sym_rescue] = STATE(3608),
    [sym__body_statement] = STATE(8483),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11875),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6242] = {
    [sym__statements] = STATE(8485),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(8486),
    [sym_else] = STATE(8486),
    [sym__if_tail] = STATE(8486),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(8487),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__terminator] = STATE(8487),
    [sym__line_break] = ACTIONS(11877),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11879),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6243] = {
    [sym__statements] = STATE(8489),
    [sym__top_level_statement] = STATE(2704),
    [sym_begin_block] = STATE(2704),
    [sym_end_block] = STATE(2704),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(8490),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11881),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6244] = {
    [sym__statements] = STATE(8492),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11883),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6245] = {
    [sym__statements] = STATE(8494),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11885),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6246] = {
    [sym__do] = STATE(8495),
    [sym_heredoc_body] = STATE(8495),
    [sym__terminator] = STATE(8495),
    [sym__line_break] = ACTIONS(11887),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(11887),
    [anon_sym_do] = ACTIONS(11887),
    [sym_comment] = ACTIONS(87),
  },
  [6247] = {
    [sym_when] = STATE(8496),
    [aux_sym_case_repeat1] = STATE(8497),
    [anon_sym_SEMI] = ACTIONS(11889),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6248] = {
    [anon_sym_end] = ACTIONS(11891),
    [sym_comment] = ACTIONS(87),
  },
  [6249] = {
    [sym_when] = STATE(8496),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6250] = {
    [sym__line_break] = ACTIONS(5264),
    [sym__heredoc_body_start] = ACTIONS(5264),
    [sym__binary_minus] = ACTIONS(5264),
    [sym__binary_star] = ACTIONS(5264),
    [ts_builtin_sym_end] = ACTIONS(5264),
    [anon_sym___END__] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5264),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_RPAREN] = ACTIONS(5264),
    [anon_sym_DOT] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5264),
    [anon_sym_PIPE] = ACTIONS(5266),
    [anon_sym_SEMI] = ACTIONS(5264),
    [anon_sym_STAR_STAR] = ACTIONS(5266),
    [anon_sym_AMP] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5266),
    [anon_sym_end] = ACTIONS(5264),
    [anon_sym_if] = ACTIONS(5264),
    [anon_sym_unless] = ACTIONS(5264),
    [anon_sym_while] = ACTIONS(5264),
    [anon_sym_until] = ACTIONS(5264),
    [anon_sym_rescue] = ACTIONS(5264),
    [anon_sym_do] = ACTIONS(5264),
    [anon_sym_when] = ACTIONS(5264),
    [anon_sym_elsif] = ACTIONS(5264),
    [anon_sym_else] = ACTIONS(5264),
    [anon_sym_then] = ACTIONS(5264),
    [anon_sym_ensure] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5264),
    [anon_sym_COLON_COLON2] = ACTIONS(5264),
    [anon_sym_AMP_DOT] = ACTIONS(5264),
    [anon_sym_PLUS_EQ] = ACTIONS(5264),
    [anon_sym_DASH_EQ] = ACTIONS(5264),
    [anon_sym_STAR_EQ] = ACTIONS(5264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5264),
    [anon_sym_SLASH_EQ] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5264),
    [anon_sym_PIPE_EQ] = ACTIONS(5264),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5264),
    [anon_sym_AMP_EQ] = ACTIONS(5264),
    [anon_sym_PERCENT_EQ] = ACTIONS(5264),
    [anon_sym_GT_GT_EQ] = ACTIONS(5264),
    [anon_sym_LT_LT_EQ] = ACTIONS(5264),
    [anon_sym_CARET_EQ] = ACTIONS(5264),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5264),
    [anon_sym_and] = ACTIONS(5264),
    [anon_sym_or] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE] = ACTIONS(5266),
    [anon_sym_AMP_AMP] = ACTIONS(5266),
    [anon_sym_LT_LT] = ACTIONS(5266),
    [anon_sym_GT_GT] = ACTIONS(5266),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5264),
    [anon_sym_LT_EQ_GT] = ACTIONS(5264),
    [anon_sym_EQ_TILDE] = ACTIONS(5264),
    [anon_sym_BANG_TILDE] = ACTIONS(5264),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_GT] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5264),
    [anon_sym_CARET] = ACTIONS(5266),
    [anon_sym_PLUS] = ACTIONS(5266),
    [anon_sym_SLASH] = ACTIONS(5266),
    [anon_sym_PERCENT] = ACTIONS(5266),
    [sym_comment] = ACTIONS(87),
  },
  [6251] = {
    [sym_ensure] = STATE(8500),
    [anon_sym_end] = ACTIONS(11893),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [6252] = {
    [anon_sym_end] = ACTIONS(11893),
    [sym_comment] = ACTIONS(87),
  },
  [6253] = {
    [sym_else] = STATE(8501),
    [sym_ensure] = STATE(8500),
    [anon_sym_end] = ACTIONS(11893),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [6254] = {
    [sym__line_break] = ACTIONS(5350),
    [sym__heredoc_body_start] = ACTIONS(5350),
    [sym__binary_minus] = ACTIONS(5350),
    [sym__binary_star] = ACTIONS(5350),
    [ts_builtin_sym_end] = ACTIONS(5350),
    [anon_sym___END__] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_RPAREN] = ACTIONS(5350),
    [anon_sym_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5350),
    [anon_sym_PIPE] = ACTIONS(5352),
    [anon_sym_SEMI] = ACTIONS(5350),
    [anon_sym_STAR_STAR] = ACTIONS(5352),
    [anon_sym_AMP] = ACTIONS(5352),
    [anon_sym_EQ] = ACTIONS(5352),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5350),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_unless] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_until] = ACTIONS(5350),
    [anon_sym_rescue] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_when] = ACTIONS(5350),
    [anon_sym_elsif] = ACTIONS(5350),
    [anon_sym_else] = ACTIONS(5350),
    [anon_sym_then] = ACTIONS(5350),
    [anon_sym_ensure] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_COLON_COLON2] = ACTIONS(5350),
    [anon_sym_AMP_DOT] = ACTIONS(5350),
    [anon_sym_PLUS_EQ] = ACTIONS(5350),
    [anon_sym_DASH_EQ] = ACTIONS(5350),
    [anon_sym_STAR_EQ] = ACTIONS(5350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5350),
    [anon_sym_SLASH_EQ] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5350),
    [anon_sym_PIPE_EQ] = ACTIONS(5350),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5350),
    [anon_sym_AMP_EQ] = ACTIONS(5350),
    [anon_sym_PERCENT_EQ] = ACTIONS(5350),
    [anon_sym_GT_GT_EQ] = ACTIONS(5350),
    [anon_sym_LT_LT_EQ] = ACTIONS(5350),
    [anon_sym_CARET_EQ] = ACTIONS(5350),
    [anon_sym_QMARK] = ACTIONS(5350),
    [anon_sym_DOT_DOT] = ACTIONS(5352),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5352),
    [anon_sym_AMP_AMP] = ACTIONS(5352),
    [anon_sym_LT_LT] = ACTIONS(5352),
    [anon_sym_GT_GT] = ACTIONS(5352),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5350),
    [anon_sym_LT_EQ_GT] = ACTIONS(5350),
    [anon_sym_EQ_TILDE] = ACTIONS(5350),
    [anon_sym_BANG_TILDE] = ACTIONS(5350),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5352),
    [anon_sym_PLUS] = ACTIONS(5352),
    [anon_sym_SLASH] = ACTIONS(5352),
    [anon_sym_PERCENT] = ACTIONS(5352),
    [sym_comment] = ACTIONS(87),
  },
  [6255] = {
    [sym__line_break] = ACTIONS(5582),
    [sym__heredoc_body_start] = ACTIONS(5582),
    [sym__binary_minus] = ACTIONS(5582),
    [sym__binary_star] = ACTIONS(5582),
    [ts_builtin_sym_end] = ACTIONS(5582),
    [anon_sym___END__] = ACTIONS(5582),
    [anon_sym_LBRACE] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_STAR_STAR] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_EQ] = ACTIONS(5584),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_end] = ACTIONS(5582),
    [anon_sym_if] = ACTIONS(5582),
    [anon_sym_unless] = ACTIONS(5582),
    [anon_sym_while] = ACTIONS(5582),
    [anon_sym_until] = ACTIONS(5582),
    [anon_sym_rescue] = ACTIONS(5582),
    [anon_sym_do] = ACTIONS(5582),
    [anon_sym_when] = ACTIONS(5582),
    [anon_sym_elsif] = ACTIONS(5582),
    [anon_sym_else] = ACTIONS(5582),
    [anon_sym_then] = ACTIONS(5582),
    [anon_sym_ensure] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON_COLON2] = ACTIONS(5582),
    [anon_sym_AMP_DOT] = ACTIONS(5582),
    [anon_sym_PLUS_EQ] = ACTIONS(5582),
    [anon_sym_DASH_EQ] = ACTIONS(5582),
    [anon_sym_STAR_EQ] = ACTIONS(5582),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5582),
    [anon_sym_SLASH_EQ] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5582),
    [anon_sym_PIPE_EQ] = ACTIONS(5582),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5582),
    [anon_sym_AMP_EQ] = ACTIONS(5582),
    [anon_sym_PERCENT_EQ] = ACTIONS(5582),
    [anon_sym_GT_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_LT_EQ] = ACTIONS(5582),
    [anon_sym_CARET_EQ] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5584),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_EQ_EQ] = ACTIONS(5584),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ_GT] = ACTIONS(5582),
    [anon_sym_EQ_TILDE] = ACTIONS(5582),
    [anon_sym_BANG_TILDE] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5584),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5584),
    [sym_comment] = ACTIONS(87),
  },
  [6256] = {
    [anon_sym_RBRACK] = ACTIONS(11895),
    [sym_comment] = ACTIONS(87),
  },
  [6257] = {
    [sym__line_break] = ACTIONS(5666),
    [sym__heredoc_body_start] = ACTIONS(5666),
    [sym__binary_minus] = ACTIONS(5666),
    [sym__binary_star] = ACTIONS(5666),
    [ts_builtin_sym_end] = ACTIONS(5666),
    [anon_sym___END__] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_STAR_STAR] = ACTIONS(5668),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_EQ] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_end] = ACTIONS(5666),
    [anon_sym_if] = ACTIONS(5666),
    [anon_sym_unless] = ACTIONS(5666),
    [anon_sym_while] = ACTIONS(5666),
    [anon_sym_until] = ACTIONS(5666),
    [anon_sym_rescue] = ACTIONS(5666),
    [anon_sym_do] = ACTIONS(5666),
    [anon_sym_when] = ACTIONS(5666),
    [anon_sym_elsif] = ACTIONS(5666),
    [anon_sym_else] = ACTIONS(5666),
    [anon_sym_then] = ACTIONS(5666),
    [anon_sym_ensure] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_COLON_COLON2] = ACTIONS(5666),
    [anon_sym_AMP_DOT] = ACTIONS(5666),
    [anon_sym_PLUS_EQ] = ACTIONS(5666),
    [anon_sym_DASH_EQ] = ACTIONS(5666),
    [anon_sym_STAR_EQ] = ACTIONS(5666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5666),
    [anon_sym_SLASH_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5666),
    [anon_sym_AMP_EQ] = ACTIONS(5666),
    [anon_sym_PERCENT_EQ] = ACTIONS(5666),
    [anon_sym_GT_GT_EQ] = ACTIONS(5666),
    [anon_sym_LT_LT_EQ] = ACTIONS(5666),
    [anon_sym_CARET_EQ] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_and] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_LT_LT] = ACTIONS(5668),
    [anon_sym_GT_GT] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_EQ_TILDE] = ACTIONS(5666),
    [anon_sym_BANG_TILDE] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_PLUS] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [sym_comment] = ACTIONS(87),
  },
  [6258] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [6259] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [6260] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [6261] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [6262] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [6263] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11897),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6264] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(5798),
    [anon_sym___END__] = ACTIONS(5798),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [6265] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [6266] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [6267] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [6268] = {
    [sym__line_break] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [ts_builtin_sym_end] = ACTIONS(5594),
    [anon_sym___END__] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_end] = ACTIONS(5594),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_when] = ACTIONS(5594),
    [anon_sym_elsif] = ACTIONS(5594),
    [anon_sym_else] = ACTIONS(5594),
    [anon_sym_then] = ACTIONS(5594),
    [anon_sym_ensure] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [6269] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(4970),
    [anon_sym___END__] = ACTIONS(4970),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [6270] = {
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6060),
    [anon_sym___END__] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_elsif] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [6271] = {
    [aux_sym_exceptions_repeat1] = STATE(8505),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6060),
    [anon_sym___END__] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [6272] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(6074),
    [anon_sym___END__] = ACTIONS(6074),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [6273] = {
    [sym_string] = STATE(6273),
    [aux_sym_chained_string_repeat1] = STATE(6273),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [ts_builtin_sym_end] = ACTIONS(6076),
    [anon_sym___END__] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [6274] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6275] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6276] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8506),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(8506),
    [sym_operator_assignment] = STATE(8506),
    [sym_conditional] = STATE(8506),
    [sym_range] = STATE(8506),
    [sym_binary] = STATE(8506),
    [sym_unary] = STATE(8506),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6277] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6278] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8507),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(8507),
    [sym_operator_assignment] = STATE(8507),
    [sym_conditional] = STATE(8507),
    [sym_range] = STATE(8507),
    [sym_binary] = STATE(8507),
    [sym_unary] = STATE(8507),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6279] = {
    [sym_heredoc_body] = STATE(8508),
    [aux_sym_call_repeat1] = STATE(8508),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6280] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3642),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(3642),
    [sym_operator_assignment] = STATE(3642),
    [sym_conditional] = STATE(3642),
    [sym_range] = STATE(3642),
    [sym_binary] = STATE(3642),
    [sym_unary] = STATE(3642),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3645),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(8509),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5928),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__identifier_hash_key] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11902),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5934),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6281] = {
    [sym_heredoc_body] = STATE(8510),
    [aux_sym_call_repeat1] = STATE(8510),
    [aux_sym_argument_list_repeat1] = STATE(8511),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9520),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6282] = {
    [sym__line_break] = ACTIONS(11655),
    [sym__heredoc_body_start] = ACTIONS(11655),
    [sym__binary_minus] = ACTIONS(11655),
    [sym__binary_star] = ACTIONS(11655),
    [ts_builtin_sym_end] = ACTIONS(11655),
    [anon_sym___END__] = ACTIONS(11655),
    [anon_sym_LBRACE] = ACTIONS(11655),
    [anon_sym_RBRACE] = ACTIONS(11655),
    [anon_sym_RPAREN] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11657),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11657),
    [anon_sym_SEMI] = ACTIONS(11655),
    [anon_sym_STAR_STAR] = ACTIONS(11657),
    [anon_sym_AMP] = ACTIONS(11657),
    [anon_sym_EQ] = ACTIONS(11657),
    [anon_sym_LT] = ACTIONS(11657),
    [anon_sym_end] = ACTIONS(11655),
    [anon_sym_if] = ACTIONS(11655),
    [anon_sym_unless] = ACTIONS(11655),
    [anon_sym_while] = ACTIONS(11655),
    [anon_sym_until] = ACTIONS(11655),
    [anon_sym_rescue] = ACTIONS(11655),
    [anon_sym_do] = ACTIONS(11655),
    [anon_sym_when] = ACTIONS(11655),
    [anon_sym_elsif] = ACTIONS(11655),
    [anon_sym_else] = ACTIONS(11655),
    [anon_sym_then] = ACTIONS(11655),
    [anon_sym_ensure] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [anon_sym_PLUS_EQ] = ACTIONS(11655),
    [anon_sym_DASH_EQ] = ACTIONS(11655),
    [anon_sym_STAR_EQ] = ACTIONS(11655),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11655),
    [anon_sym_SLASH_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11655),
    [anon_sym_AMP_EQ] = ACTIONS(11655),
    [anon_sym_PERCENT_EQ] = ACTIONS(11655),
    [anon_sym_GT_GT_EQ] = ACTIONS(11655),
    [anon_sym_LT_LT_EQ] = ACTIONS(11655),
    [anon_sym_CARET_EQ] = ACTIONS(11655),
    [anon_sym_QMARK] = ACTIONS(11655),
    [anon_sym_DOT_DOT] = ACTIONS(11657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11655),
    [anon_sym_and] = ACTIONS(11655),
    [anon_sym_or] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE] = ACTIONS(11657),
    [anon_sym_AMP_AMP] = ACTIONS(11657),
    [anon_sym_LT_LT] = ACTIONS(11657),
    [anon_sym_GT_GT] = ACTIONS(11657),
    [anon_sym_EQ_EQ] = ACTIONS(11657),
    [anon_sym_BANG_EQ] = ACTIONS(11655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11655),
    [anon_sym_LT_EQ_GT] = ACTIONS(11655),
    [anon_sym_EQ_TILDE] = ACTIONS(11655),
    [anon_sym_BANG_TILDE] = ACTIONS(11655),
    [anon_sym_LT_EQ] = ACTIONS(11657),
    [anon_sym_GT] = ACTIONS(11657),
    [anon_sym_GT_EQ] = ACTIONS(11655),
    [anon_sym_CARET] = ACTIONS(11657),
    [anon_sym_PLUS] = ACTIONS(11657),
    [anon_sym_SLASH] = ACTIONS(11657),
    [anon_sym_PERCENT] = ACTIONS(11657),
    [sym_comment] = ACTIONS(87),
  },
  [6283] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [6284] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [6285] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [6286] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [6287] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [6288] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11904),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6289] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5946),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(5950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5952),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(5956),
    [anon_sym_AMP_AMP] = ACTIONS(5956),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5956),
    [anon_sym_LT_EQ_GT] = ACTIONS(5956),
    [anon_sym_EQ_TILDE] = ACTIONS(5956),
    [anon_sym_BANG_TILDE] = ACTIONS(5956),
    [anon_sym_LT_EQ] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5946),
    [anon_sym_GT_EQ] = ACTIONS(5962),
    [anon_sym_CARET] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [6290] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5946),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5948),
    [anon_sym_DOT_DOT] = ACTIONS(5950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5952),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5956),
    [anon_sym_AMP_AMP] = ACTIONS(5956),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5956),
    [anon_sym_LT_EQ_GT] = ACTIONS(5956),
    [anon_sym_EQ_TILDE] = ACTIONS(5956),
    [anon_sym_BANG_TILDE] = ACTIONS(5956),
    [anon_sym_LT_EQ] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5946),
    [anon_sym_GT_EQ] = ACTIONS(5962),
    [anon_sym_CARET] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [6291] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5946),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5956),
    [anon_sym_LT_EQ_GT] = ACTIONS(5956),
    [anon_sym_EQ_TILDE] = ACTIONS(5956),
    [anon_sym_BANG_TILDE] = ACTIONS(5956),
    [anon_sym_LT_EQ] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5946),
    [anon_sym_GT_EQ] = ACTIONS(5962),
    [anon_sym_CARET] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [6292] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [6293] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6294] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6295] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8513),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(8513),
    [sym_operator_assignment] = STATE(8513),
    [sym_conditional] = STATE(8513),
    [sym_range] = STATE(8513),
    [sym_binary] = STATE(8513),
    [sym_unary] = STATE(8513),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [6296] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6297] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8514),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(8514),
    [sym_operator_assignment] = STATE(8514),
    [sym_conditional] = STATE(8514),
    [sym_range] = STATE(8514),
    [sym_binary] = STATE(8514),
    [sym_unary] = STATE(8514),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [6298] = {
    [sym_heredoc_body] = STATE(8515),
    [aux_sym_call_repeat1] = STATE(8515),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [6299] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3664),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(3664),
    [sym_operator_assignment] = STATE(3664),
    [sym_conditional] = STATE(3664),
    [sym_range] = STATE(3664),
    [sym_binary] = STATE(3664),
    [sym_unary] = STATE(3664),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3667),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(8516),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5966),
    [sym__splat_star] = ACTIONS(5968),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__identifier_hash_key] = ACTIONS(5970),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11906),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(5972),
    [sym_identifier] = ACTIONS(5972),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [6300] = {
    [sym_heredoc_body] = STATE(8517),
    [aux_sym_call_repeat1] = STATE(8517),
    [aux_sym_argument_list_repeat1] = STATE(8518),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9530),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [6301] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8519),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(8519),
    [sym_operator_assignment] = STATE(8519),
    [sym_conditional] = STATE(8519),
    [sym_range] = STATE(8519),
    [sym_binary] = STATE(8519),
    [sym_unary] = STATE(8519),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6302] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8520),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(8520),
    [sym_operator_assignment] = STATE(8520),
    [sym_conditional] = STATE(8520),
    [sym_range] = STATE(8520),
    [sym_binary] = STATE(8520),
    [sym_unary] = STATE(8520),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6303] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8521),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(8521),
    [sym_operator_assignment] = STATE(8521),
    [sym_conditional] = STATE(8521),
    [sym_range] = STATE(8521),
    [sym_binary] = STATE(8521),
    [sym_unary] = STATE(8521),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6304] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6305] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11912),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(11914),
    [anon_sym_LT] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11918),
    [anon_sym_DOT_DOT] = ACTIONS(11920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11922),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11924),
    [anon_sym_AMP_AMP] = ACTIONS(11924),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(11928),
    [anon_sym_BANG_EQ] = ACTIONS(11924),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11924),
    [anon_sym_LT_EQ_GT] = ACTIONS(11924),
    [anon_sym_EQ_TILDE] = ACTIONS(11924),
    [anon_sym_BANG_TILDE] = ACTIONS(11924),
    [anon_sym_LT_EQ] = ACTIONS(11916),
    [anon_sym_GT] = ACTIONS(11916),
    [anon_sym_GT_EQ] = ACTIONS(11930),
    [anon_sym_CARET] = ACTIONS(11932),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [6306] = {
    [aux_sym_exceptions_repeat1] = STATE(8533),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(11934),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [6307] = {
    [anon_sym_EQ] = ACTIONS(11936),
    [sym_comment] = ACTIONS(87),
  },
  [6308] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11938),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11940),
    [anon_sym_DASH_EQ] = ACTIONS(11940),
    [anon_sym_STAR_EQ] = ACTIONS(11940),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11940),
    [anon_sym_SLASH_EQ] = ACTIONS(11940),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11940),
    [anon_sym_PIPE_EQ] = ACTIONS(11940),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11940),
    [anon_sym_AMP_EQ] = ACTIONS(11940),
    [anon_sym_PERCENT_EQ] = ACTIONS(11940),
    [anon_sym_GT_GT_EQ] = ACTIONS(11940),
    [anon_sym_LT_LT_EQ] = ACTIONS(11940),
    [anon_sym_CARET_EQ] = ACTIONS(11940),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6309] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5946),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(5948),
    [anon_sym_DOT_DOT] = ACTIONS(5950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5952),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(5956),
    [anon_sym_AMP_AMP] = ACTIONS(5956),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5956),
    [anon_sym_LT_EQ_GT] = ACTIONS(5956),
    [anon_sym_EQ_TILDE] = ACTIONS(5956),
    [anon_sym_BANG_TILDE] = ACTIONS(5956),
    [anon_sym_LT_EQ] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5946),
    [anon_sym_GT_EQ] = ACTIONS(5962),
    [anon_sym_CARET] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [6310] = {
    [sym_string] = STATE(6310),
    [aux_sym_chained_string_repeat1] = STATE(6310),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [6311] = {
    [sym__line_break] = ACTIONS(6894),
    [sym__heredoc_body_start] = ACTIONS(6894),
    [sym__binary_minus] = ACTIONS(6894),
    [sym__binary_star] = ACTIONS(6894),
    [ts_builtin_sym_end] = ACTIONS(6894),
    [anon_sym___END__] = ACTIONS(6894),
    [anon_sym_LBRACE] = ACTIONS(6894),
    [anon_sym_RBRACE] = ACTIONS(6894),
    [anon_sym_RPAREN] = ACTIONS(6894),
    [anon_sym_DOT] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_SEMI] = ACTIONS(6894),
    [anon_sym_STAR_STAR] = ACTIONS(6896),
    [anon_sym_AMP] = ACTIONS(6896),
    [anon_sym_EQ] = ACTIONS(6896),
    [anon_sym_LT] = ACTIONS(6896),
    [anon_sym_end] = ACTIONS(6894),
    [anon_sym_if] = ACTIONS(6894),
    [anon_sym_unless] = ACTIONS(6894),
    [anon_sym_while] = ACTIONS(6894),
    [anon_sym_until] = ACTIONS(6894),
    [anon_sym_rescue] = ACTIONS(6894),
    [anon_sym_do] = ACTIONS(6894),
    [anon_sym_when] = ACTIONS(6894),
    [anon_sym_elsif] = ACTIONS(6894),
    [anon_sym_else] = ACTIONS(6894),
    [anon_sym_then] = ACTIONS(6894),
    [anon_sym_ensure] = ACTIONS(6894),
    [anon_sym_EQ_GT] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6894),
    [anon_sym_COLON_COLON2] = ACTIONS(6894),
    [anon_sym_AMP_DOT] = ACTIONS(6894),
    [anon_sym_PLUS_EQ] = ACTIONS(6894),
    [anon_sym_DASH_EQ] = ACTIONS(6894),
    [anon_sym_STAR_EQ] = ACTIONS(6894),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6894),
    [anon_sym_SLASH_EQ] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6894),
    [anon_sym_PIPE_EQ] = ACTIONS(6894),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6894),
    [anon_sym_AMP_EQ] = ACTIONS(6894),
    [anon_sym_PERCENT_EQ] = ACTIONS(6894),
    [anon_sym_GT_GT_EQ] = ACTIONS(6894),
    [anon_sym_LT_LT_EQ] = ACTIONS(6894),
    [anon_sym_CARET_EQ] = ACTIONS(6894),
    [anon_sym_QMARK] = ACTIONS(6894),
    [anon_sym_DOT_DOT] = ACTIONS(6896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6894),
    [anon_sym_and] = ACTIONS(6894),
    [anon_sym_or] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE] = ACTIONS(6896),
    [anon_sym_AMP_AMP] = ACTIONS(6896),
    [anon_sym_LT_LT] = ACTIONS(6896),
    [anon_sym_GT_GT] = ACTIONS(6896),
    [anon_sym_EQ_EQ] = ACTIONS(6896),
    [anon_sym_BANG_EQ] = ACTIONS(6894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6894),
    [anon_sym_LT_EQ_GT] = ACTIONS(6894),
    [anon_sym_EQ_TILDE] = ACTIONS(6894),
    [anon_sym_BANG_TILDE] = ACTIONS(6894),
    [anon_sym_LT_EQ] = ACTIONS(6896),
    [anon_sym_GT] = ACTIONS(6896),
    [anon_sym_GT_EQ] = ACTIONS(6894),
    [anon_sym_CARET] = ACTIONS(6896),
    [anon_sym_PLUS] = ACTIONS(6896),
    [anon_sym_SLASH] = ACTIONS(6896),
    [anon_sym_PERCENT] = ACTIONS(6896),
    [sym_comment] = ACTIONS(87),
  },
  [6312] = {
    [anon_sym_DOT] = ACTIONS(11942),
    [anon_sym_COLON_COLON] = ACTIONS(11942),
    [sym_comment] = ACTIONS(87),
  },
  [6313] = {
    [sym__line_break] = ACTIONS(7046),
    [sym__heredoc_body_start] = ACTIONS(7046),
    [sym__binary_minus] = ACTIONS(7046),
    [sym__binary_star] = ACTIONS(7046),
    [ts_builtin_sym_end] = ACTIONS(7046),
    [anon_sym___END__] = ACTIONS(7046),
    [anon_sym_LBRACE] = ACTIONS(7046),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7046),
    [anon_sym_DOT] = ACTIONS(7048),
    [anon_sym_COMMA] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_STAR_STAR] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7048),
    [anon_sym_end] = ACTIONS(7046),
    [anon_sym_if] = ACTIONS(7046),
    [anon_sym_unless] = ACTIONS(7046),
    [anon_sym_while] = ACTIONS(7046),
    [anon_sym_until] = ACTIONS(7046),
    [anon_sym_rescue] = ACTIONS(7046),
    [anon_sym_do] = ACTIONS(7046),
    [anon_sym_when] = ACTIONS(7046),
    [anon_sym_elsif] = ACTIONS(7046),
    [anon_sym_else] = ACTIONS(7046),
    [anon_sym_then] = ACTIONS(7046),
    [anon_sym_ensure] = ACTIONS(7046),
    [anon_sym_EQ_GT] = ACTIONS(7046),
    [anon_sym_LBRACK] = ACTIONS(7046),
    [anon_sym_COLON_COLON2] = ACTIONS(7046),
    [anon_sym_AMP_DOT] = ACTIONS(7046),
    [anon_sym_PLUS_EQ] = ACTIONS(7046),
    [anon_sym_DASH_EQ] = ACTIONS(7046),
    [anon_sym_STAR_EQ] = ACTIONS(7046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7046),
    [anon_sym_SLASH_EQ] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7046),
    [anon_sym_PIPE_EQ] = ACTIONS(7046),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7046),
    [anon_sym_AMP_EQ] = ACTIONS(7046),
    [anon_sym_PERCENT_EQ] = ACTIONS(7046),
    [anon_sym_GT_GT_EQ] = ACTIONS(7046),
    [anon_sym_LT_LT_EQ] = ACTIONS(7046),
    [anon_sym_CARET_EQ] = ACTIONS(7046),
    [anon_sym_QMARK] = ACTIONS(7046),
    [anon_sym_DOT_DOT] = ACTIONS(7048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7046),
    [anon_sym_and] = ACTIONS(7046),
    [anon_sym_or] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7048),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_BANG_EQ] = ACTIONS(7046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT_EQ_GT] = ACTIONS(7046),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_BANG_TILDE] = ACTIONS(7046),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7046),
    [anon_sym_CARET] = ACTIONS(7048),
    [anon_sym_PLUS] = ACTIONS(7048),
    [anon_sym_SLASH] = ACTIONS(7048),
    [anon_sym_PERCENT] = ACTIONS(7048),
    [sym_comment] = ACTIONS(87),
  },
  [6314] = {
    [sym__line_break] = ACTIONS(7062),
    [sym__heredoc_body_start] = ACTIONS(7062),
    [sym__binary_minus] = ACTIONS(7062),
    [sym__binary_star] = ACTIONS(7062),
    [ts_builtin_sym_end] = ACTIONS(7062),
    [anon_sym___END__] = ACTIONS(7062),
    [anon_sym_LBRACE] = ACTIONS(7062),
    [anon_sym_RBRACE] = ACTIONS(7062),
    [anon_sym_RPAREN] = ACTIONS(7062),
    [anon_sym_DOT] = ACTIONS(7064),
    [anon_sym_COMMA] = ACTIONS(7062),
    [anon_sym_PIPE] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(7062),
    [anon_sym_STAR_STAR] = ACTIONS(7064),
    [anon_sym_AMP] = ACTIONS(7064),
    [anon_sym_EQ] = ACTIONS(7064),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_end] = ACTIONS(7062),
    [anon_sym_if] = ACTIONS(7062),
    [anon_sym_unless] = ACTIONS(7062),
    [anon_sym_while] = ACTIONS(7062),
    [anon_sym_until] = ACTIONS(7062),
    [anon_sym_rescue] = ACTIONS(7062),
    [anon_sym_do] = ACTIONS(7062),
    [anon_sym_when] = ACTIONS(7062),
    [anon_sym_elsif] = ACTIONS(7062),
    [anon_sym_else] = ACTIONS(7062),
    [anon_sym_then] = ACTIONS(7062),
    [anon_sym_ensure] = ACTIONS(7062),
    [anon_sym_EQ_GT] = ACTIONS(7062),
    [anon_sym_LBRACK] = ACTIONS(7062),
    [anon_sym_COLON_COLON2] = ACTIONS(7062),
    [anon_sym_AMP_DOT] = ACTIONS(7062),
    [anon_sym_PLUS_EQ] = ACTIONS(7062),
    [anon_sym_DASH_EQ] = ACTIONS(7062),
    [anon_sym_STAR_EQ] = ACTIONS(7062),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7062),
    [anon_sym_SLASH_EQ] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7062),
    [anon_sym_PIPE_EQ] = ACTIONS(7062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7062),
    [anon_sym_AMP_EQ] = ACTIONS(7062),
    [anon_sym_PERCENT_EQ] = ACTIONS(7062),
    [anon_sym_GT_GT_EQ] = ACTIONS(7062),
    [anon_sym_LT_LT_EQ] = ACTIONS(7062),
    [anon_sym_CARET_EQ] = ACTIONS(7062),
    [anon_sym_QMARK] = ACTIONS(7062),
    [anon_sym_DOT_DOT] = ACTIONS(7064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7062),
    [anon_sym_and] = ACTIONS(7062),
    [anon_sym_or] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE] = ACTIONS(7064),
    [anon_sym_AMP_AMP] = ACTIONS(7064),
    [anon_sym_LT_LT] = ACTIONS(7064),
    [anon_sym_GT_GT] = ACTIONS(7064),
    [anon_sym_EQ_EQ] = ACTIONS(7064),
    [anon_sym_BANG_EQ] = ACTIONS(7062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7062),
    [anon_sym_LT_EQ_GT] = ACTIONS(7062),
    [anon_sym_EQ_TILDE] = ACTIONS(7062),
    [anon_sym_BANG_TILDE] = ACTIONS(7062),
    [anon_sym_LT_EQ] = ACTIONS(7064),
    [anon_sym_GT] = ACTIONS(7064),
    [anon_sym_GT_EQ] = ACTIONS(7062),
    [anon_sym_CARET] = ACTIONS(7064),
    [anon_sym_PLUS] = ACTIONS(7064),
    [anon_sym_SLASH] = ACTIONS(7064),
    [anon_sym_PERCENT] = ACTIONS(7064),
    [sym_comment] = ACTIONS(87),
  },
  [6315] = {
    [sym__statements] = STATE(1548),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1549),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1550),
    [sym_rescue] = STATE(1551),
    [sym__body_statement] = STATE(8537),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11944),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6316] = {
    [sym__statements] = STATE(1548),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1549),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1550),
    [sym_rescue] = STATE(1551),
    [sym__body_statement] = STATE(8538),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11946),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6317] = {
    [sym__line_break] = ACTIONS(7496),
    [sym__heredoc_body_start] = ACTIONS(7496),
    [sym__binary_minus] = ACTIONS(7496),
    [sym__binary_star] = ACTIONS(7496),
    [ts_builtin_sym_end] = ACTIONS(7496),
    [anon_sym___END__] = ACTIONS(7496),
    [anon_sym_LBRACE] = ACTIONS(7496),
    [anon_sym_RBRACE] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(7496),
    [anon_sym_DOT] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_end] = ACTIONS(7496),
    [anon_sym_if] = ACTIONS(7496),
    [anon_sym_unless] = ACTIONS(7496),
    [anon_sym_while] = ACTIONS(7496),
    [anon_sym_until] = ACTIONS(7496),
    [anon_sym_rescue] = ACTIONS(7496),
    [anon_sym_do] = ACTIONS(7496),
    [anon_sym_when] = ACTIONS(7496),
    [anon_sym_elsif] = ACTIONS(7496),
    [anon_sym_else] = ACTIONS(7496),
    [anon_sym_then] = ACTIONS(7496),
    [anon_sym_ensure] = ACTIONS(7496),
    [anon_sym_EQ_GT] = ACTIONS(7496),
    [anon_sym_LBRACK] = ACTIONS(7496),
    [anon_sym_COLON_COLON2] = ACTIONS(7496),
    [anon_sym_AMP_DOT] = ACTIONS(7496),
    [anon_sym_PLUS_EQ] = ACTIONS(7496),
    [anon_sym_DASH_EQ] = ACTIONS(7496),
    [anon_sym_STAR_EQ] = ACTIONS(7496),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7496),
    [anon_sym_SLASH_EQ] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7496),
    [anon_sym_PIPE_EQ] = ACTIONS(7496),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7496),
    [anon_sym_AMP_EQ] = ACTIONS(7496),
    [anon_sym_PERCENT_EQ] = ACTIONS(7496),
    [anon_sym_GT_GT_EQ] = ACTIONS(7496),
    [anon_sym_LT_LT_EQ] = ACTIONS(7496),
    [anon_sym_CARET_EQ] = ACTIONS(7496),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_DOT_DOT] = ACTIONS(7498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7496),
    [anon_sym_and] = ACTIONS(7496),
    [anon_sym_or] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE] = ACTIONS(7498),
    [anon_sym_AMP_AMP] = ACTIONS(7498),
    [anon_sym_LT_LT] = ACTIONS(7498),
    [anon_sym_GT_GT] = ACTIONS(7498),
    [anon_sym_EQ_EQ] = ACTIONS(7498),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7496),
    [anon_sym_LT_EQ_GT] = ACTIONS(7496),
    [anon_sym_EQ_TILDE] = ACTIONS(7496),
    [anon_sym_BANG_TILDE] = ACTIONS(7496),
    [anon_sym_LT_EQ] = ACTIONS(7498),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7498),
    [anon_sym_PERCENT] = ACTIONS(7498),
    [sym_comment] = ACTIONS(87),
  },
  [6318] = {
    [sym__line_break] = ACTIONS(7550),
    [sym__heredoc_body_start] = ACTIONS(7550),
    [sym__binary_minus] = ACTIONS(7550),
    [sym__binary_star] = ACTIONS(7550),
    [ts_builtin_sym_end] = ACTIONS(7550),
    [anon_sym___END__] = ACTIONS(7550),
    [anon_sym_LBRACE] = ACTIONS(7550),
    [anon_sym_RBRACE] = ACTIONS(7550),
    [anon_sym_RPAREN] = ACTIONS(7550),
    [anon_sym_DOT] = ACTIONS(7552),
    [anon_sym_COMMA] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_SEMI] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_end] = ACTIONS(7550),
    [anon_sym_if] = ACTIONS(7550),
    [anon_sym_unless] = ACTIONS(7550),
    [anon_sym_while] = ACTIONS(7550),
    [anon_sym_until] = ACTIONS(7550),
    [anon_sym_rescue] = ACTIONS(7550),
    [anon_sym_do] = ACTIONS(7550),
    [anon_sym_when] = ACTIONS(7550),
    [anon_sym_elsif] = ACTIONS(7550),
    [anon_sym_else] = ACTIONS(7550),
    [anon_sym_then] = ACTIONS(7550),
    [anon_sym_ensure] = ACTIONS(7550),
    [anon_sym_EQ_GT] = ACTIONS(7550),
    [anon_sym_LBRACK] = ACTIONS(7550),
    [anon_sym_COLON_COLON2] = ACTIONS(7550),
    [anon_sym_AMP_DOT] = ACTIONS(7550),
    [anon_sym_PLUS_EQ] = ACTIONS(7550),
    [anon_sym_DASH_EQ] = ACTIONS(7550),
    [anon_sym_STAR_EQ] = ACTIONS(7550),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7550),
    [anon_sym_SLASH_EQ] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7550),
    [anon_sym_PIPE_EQ] = ACTIONS(7550),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7550),
    [anon_sym_AMP_EQ] = ACTIONS(7550),
    [anon_sym_PERCENT_EQ] = ACTIONS(7550),
    [anon_sym_GT_GT_EQ] = ACTIONS(7550),
    [anon_sym_LT_LT_EQ] = ACTIONS(7550),
    [anon_sym_CARET_EQ] = ACTIONS(7550),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_DOT_DOT] = ACTIONS(7552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7550),
    [anon_sym_and] = ACTIONS(7550),
    [anon_sym_or] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE] = ACTIONS(7552),
    [anon_sym_AMP_AMP] = ACTIONS(7552),
    [anon_sym_LT_LT] = ACTIONS(7552),
    [anon_sym_GT_GT] = ACTIONS(7552),
    [anon_sym_EQ_EQ] = ACTIONS(7552),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7550),
    [anon_sym_LT_EQ_GT] = ACTIONS(7550),
    [anon_sym_EQ_TILDE] = ACTIONS(7550),
    [anon_sym_BANG_TILDE] = ACTIONS(7550),
    [anon_sym_LT_EQ] = ACTIONS(7552),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7552),
    [anon_sym_PERCENT] = ACTIONS(7552),
    [sym_comment] = ACTIONS(87),
  },
  [6319] = {
    [sym__line_break] = ACTIONS(7724),
    [sym__heredoc_body_start] = ACTIONS(7724),
    [sym__binary_minus] = ACTIONS(7724),
    [sym__binary_star] = ACTIONS(7724),
    [ts_builtin_sym_end] = ACTIONS(7724),
    [anon_sym___END__] = ACTIONS(7724),
    [anon_sym_LBRACE] = ACTIONS(7724),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_DOT] = ACTIONS(7726),
    [anon_sym_COMMA] = ACTIONS(7724),
    [anon_sym_PIPE] = ACTIONS(7726),
    [anon_sym_SEMI] = ACTIONS(7724),
    [anon_sym_STAR_STAR] = ACTIONS(7726),
    [anon_sym_AMP] = ACTIONS(7726),
    [anon_sym_EQ] = ACTIONS(7726),
    [anon_sym_LT] = ACTIONS(7726),
    [anon_sym_end] = ACTIONS(7724),
    [anon_sym_if] = ACTIONS(7724),
    [anon_sym_unless] = ACTIONS(7724),
    [anon_sym_while] = ACTIONS(7724),
    [anon_sym_until] = ACTIONS(7724),
    [anon_sym_rescue] = ACTIONS(7724),
    [anon_sym_do] = ACTIONS(7724),
    [anon_sym_when] = ACTIONS(7724),
    [anon_sym_elsif] = ACTIONS(7724),
    [anon_sym_else] = ACTIONS(7724),
    [anon_sym_then] = ACTIONS(7724),
    [anon_sym_ensure] = ACTIONS(7724),
    [anon_sym_EQ_GT] = ACTIONS(7724),
    [anon_sym_LBRACK] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(7724),
    [anon_sym_AMP_DOT] = ACTIONS(7724),
    [anon_sym_PLUS_EQ] = ACTIONS(7724),
    [anon_sym_DASH_EQ] = ACTIONS(7724),
    [anon_sym_STAR_EQ] = ACTIONS(7724),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7724),
    [anon_sym_SLASH_EQ] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7724),
    [anon_sym_PIPE_EQ] = ACTIONS(7724),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7724),
    [anon_sym_AMP_EQ] = ACTIONS(7724),
    [anon_sym_PERCENT_EQ] = ACTIONS(7724),
    [anon_sym_GT_GT_EQ] = ACTIONS(7724),
    [anon_sym_LT_LT_EQ] = ACTIONS(7724),
    [anon_sym_CARET_EQ] = ACTIONS(7724),
    [anon_sym_QMARK] = ACTIONS(7724),
    [anon_sym_DOT_DOT] = ACTIONS(7726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7724),
    [anon_sym_and] = ACTIONS(7724),
    [anon_sym_or] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE] = ACTIONS(7726),
    [anon_sym_AMP_AMP] = ACTIONS(7726),
    [anon_sym_LT_LT] = ACTIONS(7726),
    [anon_sym_GT_GT] = ACTIONS(7726),
    [anon_sym_EQ_EQ] = ACTIONS(7726),
    [anon_sym_BANG_EQ] = ACTIONS(7724),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7724),
    [anon_sym_LT_EQ_GT] = ACTIONS(7724),
    [anon_sym_EQ_TILDE] = ACTIONS(7724),
    [anon_sym_BANG_TILDE] = ACTIONS(7724),
    [anon_sym_LT_EQ] = ACTIONS(7726),
    [anon_sym_GT] = ACTIONS(7726),
    [anon_sym_GT_EQ] = ACTIONS(7724),
    [anon_sym_CARET] = ACTIONS(7726),
    [anon_sym_PLUS] = ACTIONS(7726),
    [anon_sym_SLASH] = ACTIONS(7726),
    [anon_sym_PERCENT] = ACTIONS(7726),
    [sym_comment] = ACTIONS(87),
  },
  [6320] = {
    [sym_elsif] = STATE(8540),
    [sym_else] = STATE(8540),
    [sym__if_tail] = STATE(8540),
    [anon_sym_end] = ACTIONS(11948),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [6321] = {
    [anon_sym_end] = ACTIONS(11948),
    [sym_comment] = ACTIONS(87),
  },
  [6322] = {
    [sym__statements] = STATE(8541),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(8540),
    [sym_else] = STATE(8540),
    [sym__if_tail] = STATE(8540),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11950),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6323] = {
    [sym__line_break] = ACTIONS(7922),
    [sym__heredoc_body_start] = ACTIONS(7922),
    [sym__binary_minus] = ACTIONS(7922),
    [sym__binary_star] = ACTIONS(7922),
    [ts_builtin_sym_end] = ACTIONS(7922),
    [anon_sym___END__] = ACTIONS(7922),
    [anon_sym_LBRACE] = ACTIONS(7922),
    [anon_sym_RBRACE] = ACTIONS(7922),
    [anon_sym_RPAREN] = ACTIONS(7922),
    [anon_sym_DOT] = ACTIONS(7924),
    [anon_sym_COMMA] = ACTIONS(7922),
    [anon_sym_PIPE] = ACTIONS(7924),
    [anon_sym_SEMI] = ACTIONS(7922),
    [anon_sym_STAR_STAR] = ACTIONS(7924),
    [anon_sym_AMP] = ACTIONS(7924),
    [anon_sym_EQ] = ACTIONS(7924),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_end] = ACTIONS(7922),
    [anon_sym_if] = ACTIONS(7922),
    [anon_sym_unless] = ACTIONS(7922),
    [anon_sym_while] = ACTIONS(7922),
    [anon_sym_until] = ACTIONS(7922),
    [anon_sym_rescue] = ACTIONS(7922),
    [anon_sym_do] = ACTIONS(7922),
    [anon_sym_when] = ACTIONS(7922),
    [anon_sym_elsif] = ACTIONS(7922),
    [anon_sym_else] = ACTIONS(7922),
    [anon_sym_then] = ACTIONS(7922),
    [anon_sym_ensure] = ACTIONS(7922),
    [anon_sym_EQ_GT] = ACTIONS(7922),
    [anon_sym_LBRACK] = ACTIONS(7922),
    [anon_sym_COLON_COLON2] = ACTIONS(7922),
    [anon_sym_AMP_DOT] = ACTIONS(7922),
    [anon_sym_PLUS_EQ] = ACTIONS(7922),
    [anon_sym_DASH_EQ] = ACTIONS(7922),
    [anon_sym_STAR_EQ] = ACTIONS(7922),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7922),
    [anon_sym_SLASH_EQ] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7922),
    [anon_sym_PIPE_EQ] = ACTIONS(7922),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7922),
    [anon_sym_AMP_EQ] = ACTIONS(7922),
    [anon_sym_PERCENT_EQ] = ACTIONS(7922),
    [anon_sym_GT_GT_EQ] = ACTIONS(7922),
    [anon_sym_LT_LT_EQ] = ACTIONS(7922),
    [anon_sym_CARET_EQ] = ACTIONS(7922),
    [anon_sym_QMARK] = ACTIONS(7922),
    [anon_sym_DOT_DOT] = ACTIONS(7924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7922),
    [anon_sym_and] = ACTIONS(7922),
    [anon_sym_or] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE] = ACTIONS(7924),
    [anon_sym_AMP_AMP] = ACTIONS(7924),
    [anon_sym_LT_LT] = ACTIONS(7924),
    [anon_sym_GT_GT] = ACTIONS(7924),
    [anon_sym_EQ_EQ] = ACTIONS(7924),
    [anon_sym_BANG_EQ] = ACTIONS(7922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7922),
    [anon_sym_LT_EQ_GT] = ACTIONS(7922),
    [anon_sym_EQ_TILDE] = ACTIONS(7922),
    [anon_sym_BANG_TILDE] = ACTIONS(7922),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7922),
    [anon_sym_CARET] = ACTIONS(7924),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_SLASH] = ACTIONS(7924),
    [anon_sym_PERCENT] = ACTIONS(7924),
    [sym_comment] = ACTIONS(87),
  },
  [6324] = {
    [sym_else] = STATE(8543),
    [anon_sym_end] = ACTIONS(11952),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [6325] = {
    [anon_sym_end] = ACTIONS(11952),
    [sym_comment] = ACTIONS(87),
  },
  [6326] = {
    [sym__line_break] = ACTIONS(8090),
    [sym__heredoc_body_start] = ACTIONS(8090),
    [sym__binary_minus] = ACTIONS(8090),
    [sym__binary_star] = ACTIONS(8090),
    [ts_builtin_sym_end] = ACTIONS(8090),
    [anon_sym___END__] = ACTIONS(8090),
    [anon_sym_LBRACE] = ACTIONS(8090),
    [anon_sym_RBRACE] = ACTIONS(8090),
    [anon_sym_RPAREN] = ACTIONS(8090),
    [anon_sym_DOT] = ACTIONS(8092),
    [anon_sym_COMMA] = ACTIONS(8090),
    [anon_sym_PIPE] = ACTIONS(8092),
    [anon_sym_SEMI] = ACTIONS(8090),
    [anon_sym_STAR_STAR] = ACTIONS(8092),
    [anon_sym_AMP] = ACTIONS(8092),
    [anon_sym_EQ] = ACTIONS(8092),
    [anon_sym_LT] = ACTIONS(8092),
    [anon_sym_end] = ACTIONS(8090),
    [anon_sym_if] = ACTIONS(8090),
    [anon_sym_unless] = ACTIONS(8090),
    [anon_sym_while] = ACTIONS(8090),
    [anon_sym_until] = ACTIONS(8090),
    [anon_sym_rescue] = ACTIONS(8090),
    [anon_sym_do] = ACTIONS(8090),
    [anon_sym_when] = ACTIONS(8090),
    [anon_sym_elsif] = ACTIONS(8090),
    [anon_sym_else] = ACTIONS(8090),
    [anon_sym_then] = ACTIONS(8090),
    [anon_sym_ensure] = ACTIONS(8090),
    [anon_sym_EQ_GT] = ACTIONS(8090),
    [anon_sym_LBRACK] = ACTIONS(8090),
    [anon_sym_COLON_COLON2] = ACTIONS(8090),
    [anon_sym_AMP_DOT] = ACTIONS(8090),
    [anon_sym_PLUS_EQ] = ACTIONS(8090),
    [anon_sym_DASH_EQ] = ACTIONS(8090),
    [anon_sym_STAR_EQ] = ACTIONS(8090),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8090),
    [anon_sym_SLASH_EQ] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8090),
    [anon_sym_PIPE_EQ] = ACTIONS(8090),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8090),
    [anon_sym_AMP_EQ] = ACTIONS(8090),
    [anon_sym_PERCENT_EQ] = ACTIONS(8090),
    [anon_sym_GT_GT_EQ] = ACTIONS(8090),
    [anon_sym_LT_LT_EQ] = ACTIONS(8090),
    [anon_sym_CARET_EQ] = ACTIONS(8090),
    [anon_sym_QMARK] = ACTIONS(8090),
    [anon_sym_DOT_DOT] = ACTIONS(8092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8090),
    [anon_sym_and] = ACTIONS(8090),
    [anon_sym_or] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE] = ACTIONS(8092),
    [anon_sym_AMP_AMP] = ACTIONS(8092),
    [anon_sym_LT_LT] = ACTIONS(8092),
    [anon_sym_GT_GT] = ACTIONS(8092),
    [anon_sym_EQ_EQ] = ACTIONS(8092),
    [anon_sym_BANG_EQ] = ACTIONS(8090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8090),
    [anon_sym_LT_EQ_GT] = ACTIONS(8090),
    [anon_sym_EQ_TILDE] = ACTIONS(8090),
    [anon_sym_BANG_TILDE] = ACTIONS(8090),
    [anon_sym_LT_EQ] = ACTIONS(8092),
    [anon_sym_GT] = ACTIONS(8092),
    [anon_sym_GT_EQ] = ACTIONS(8090),
    [anon_sym_CARET] = ACTIONS(8092),
    [anon_sym_PLUS] = ACTIONS(8092),
    [anon_sym_SLASH] = ACTIONS(8092),
    [anon_sym_PERCENT] = ACTIONS(8092),
    [sym_comment] = ACTIONS(87),
  },
  [6327] = {
    [anon_sym_end] = ACTIONS(11954),
    [sym_comment] = ACTIONS(87),
  },
  [6328] = {
    [sym__line_break] = ACTIONS(8166),
    [sym__heredoc_body_start] = ACTIONS(8166),
    [sym__binary_minus] = ACTIONS(8166),
    [sym__binary_star] = ACTIONS(8166),
    [ts_builtin_sym_end] = ACTIONS(8166),
    [anon_sym___END__] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_DOT] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8166),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI] = ACTIONS(8166),
    [anon_sym_STAR_STAR] = ACTIONS(8168),
    [anon_sym_AMP] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_end] = ACTIONS(8166),
    [anon_sym_if] = ACTIONS(8166),
    [anon_sym_unless] = ACTIONS(8166),
    [anon_sym_while] = ACTIONS(8166),
    [anon_sym_until] = ACTIONS(8166),
    [anon_sym_rescue] = ACTIONS(8166),
    [anon_sym_do] = ACTIONS(8166),
    [anon_sym_when] = ACTIONS(8166),
    [anon_sym_elsif] = ACTIONS(8166),
    [anon_sym_else] = ACTIONS(8166),
    [anon_sym_then] = ACTIONS(8166),
    [anon_sym_ensure] = ACTIONS(8166),
    [anon_sym_EQ_GT] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_COLON_COLON2] = ACTIONS(8166),
    [anon_sym_AMP_DOT] = ACTIONS(8166),
    [anon_sym_PLUS_EQ] = ACTIONS(8166),
    [anon_sym_DASH_EQ] = ACTIONS(8166),
    [anon_sym_STAR_EQ] = ACTIONS(8166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8166),
    [anon_sym_SLASH_EQ] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8166),
    [anon_sym_PIPE_EQ] = ACTIONS(8166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8166),
    [anon_sym_AMP_EQ] = ACTIONS(8166),
    [anon_sym_PERCENT_EQ] = ACTIONS(8166),
    [anon_sym_GT_GT_EQ] = ACTIONS(8166),
    [anon_sym_LT_LT_EQ] = ACTIONS(8166),
    [anon_sym_CARET_EQ] = ACTIONS(8166),
    [anon_sym_QMARK] = ACTIONS(8166),
    [anon_sym_DOT_DOT] = ACTIONS(8168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8166),
    [anon_sym_and] = ACTIONS(8166),
    [anon_sym_or] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8168),
    [anon_sym_AMP_AMP] = ACTIONS(8168),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ_GT] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_BANG_TILDE] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8168),
    [anon_sym_SLASH] = ACTIONS(8168),
    [anon_sym_PERCENT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(87),
  },
  [6329] = {
    [anon_sym_end] = ACTIONS(11956),
    [sym_comment] = ACTIONS(87),
  },
  [6330] = {
    [sym__statements] = STATE(8547),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11958),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6331] = {
    [sym__line_break] = ACTIONS(11680),
    [sym__heredoc_body_start] = ACTIONS(11680),
    [sym__binary_minus] = ACTIONS(11680),
    [sym__binary_star] = ACTIONS(11680),
    [ts_builtin_sym_end] = ACTIONS(11680),
    [anon_sym___END__] = ACTIONS(11680),
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RBRACE] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11682),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11682),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_STAR_STAR] = ACTIONS(11682),
    [anon_sym_AMP] = ACTIONS(11682),
    [anon_sym_EQ] = ACTIONS(11682),
    [anon_sym_LT] = ACTIONS(11682),
    [anon_sym_end] = ACTIONS(11680),
    [anon_sym_if] = ACTIONS(11680),
    [anon_sym_unless] = ACTIONS(11680),
    [anon_sym_while] = ACTIONS(11680),
    [anon_sym_until] = ACTIONS(11680),
    [anon_sym_rescue] = ACTIONS(11680),
    [anon_sym_do] = ACTIONS(11680),
    [anon_sym_when] = ACTIONS(11680),
    [anon_sym_elsif] = ACTIONS(11680),
    [anon_sym_else] = ACTIONS(11680),
    [anon_sym_then] = ACTIONS(11680),
    [anon_sym_ensure] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [anon_sym_PLUS_EQ] = ACTIONS(11680),
    [anon_sym_DASH_EQ] = ACTIONS(11680),
    [anon_sym_STAR_EQ] = ACTIONS(11680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11680),
    [anon_sym_SLASH_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11680),
    [anon_sym_AMP_EQ] = ACTIONS(11680),
    [anon_sym_PERCENT_EQ] = ACTIONS(11680),
    [anon_sym_GT_GT_EQ] = ACTIONS(11680),
    [anon_sym_LT_LT_EQ] = ACTIONS(11680),
    [anon_sym_CARET_EQ] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_DOT_DOT] = ACTIONS(11682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_and] = ACTIONS(11680),
    [anon_sym_or] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE] = ACTIONS(11682),
    [anon_sym_AMP_AMP] = ACTIONS(11682),
    [anon_sym_LT_LT] = ACTIONS(11682),
    [anon_sym_GT_GT] = ACTIONS(11682),
    [anon_sym_EQ_EQ] = ACTIONS(11682),
    [anon_sym_BANG_EQ] = ACTIONS(11680),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11680),
    [anon_sym_LT_EQ_GT] = ACTIONS(11680),
    [anon_sym_EQ_TILDE] = ACTIONS(11680),
    [anon_sym_BANG_TILDE] = ACTIONS(11680),
    [anon_sym_LT_EQ] = ACTIONS(11682),
    [anon_sym_GT] = ACTIONS(11682),
    [anon_sym_GT_EQ] = ACTIONS(11680),
    [anon_sym_CARET] = ACTIONS(11682),
    [anon_sym_PLUS] = ACTIONS(11682),
    [anon_sym_SLASH] = ACTIONS(11682),
    [anon_sym_PERCENT] = ACTIONS(11682),
    [sym_comment] = ACTIONS(87),
  },
  [6332] = {
    [anon_sym_end] = ACTIONS(11960),
    [sym_comment] = ACTIONS(87),
  },
  [6333] = {
    [sym__statements] = STATE(8549),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11962),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6334] = {
    [anon_sym_end] = ACTIONS(11964),
    [sym_comment] = ACTIONS(87),
  },
  [6335] = {
    [sym_when] = STATE(8551),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6336] = {
    [sym__line_break] = ACTIONS(8414),
    [sym__heredoc_body_start] = ACTIONS(8414),
    [sym__binary_minus] = ACTIONS(8414),
    [sym__binary_star] = ACTIONS(8414),
    [ts_builtin_sym_end] = ACTIONS(8414),
    [anon_sym___END__] = ACTIONS(8414),
    [anon_sym_LBRACE] = ACTIONS(8414),
    [anon_sym_RBRACE] = ACTIONS(8414),
    [anon_sym_RPAREN] = ACTIONS(8414),
    [anon_sym_DOT] = ACTIONS(8416),
    [anon_sym_COMMA] = ACTIONS(8414),
    [anon_sym_PIPE] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8414),
    [anon_sym_STAR_STAR] = ACTIONS(8416),
    [anon_sym_AMP] = ACTIONS(8416),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LT] = ACTIONS(8416),
    [anon_sym_end] = ACTIONS(8414),
    [anon_sym_if] = ACTIONS(8414),
    [anon_sym_unless] = ACTIONS(8414),
    [anon_sym_while] = ACTIONS(8414),
    [anon_sym_until] = ACTIONS(8414),
    [anon_sym_rescue] = ACTIONS(8414),
    [anon_sym_do] = ACTIONS(8414),
    [anon_sym_when] = ACTIONS(8414),
    [anon_sym_elsif] = ACTIONS(8414),
    [anon_sym_else] = ACTIONS(8414),
    [anon_sym_then] = ACTIONS(8414),
    [anon_sym_ensure] = ACTIONS(8414),
    [anon_sym_EQ_GT] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8414),
    [anon_sym_COLON_COLON2] = ACTIONS(8414),
    [anon_sym_AMP_DOT] = ACTIONS(8414),
    [anon_sym_PLUS_EQ] = ACTIONS(8414),
    [anon_sym_DASH_EQ] = ACTIONS(8414),
    [anon_sym_STAR_EQ] = ACTIONS(8414),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8414),
    [anon_sym_SLASH_EQ] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8414),
    [anon_sym_PIPE_EQ] = ACTIONS(8414),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8414),
    [anon_sym_AMP_EQ] = ACTIONS(8414),
    [anon_sym_PERCENT_EQ] = ACTIONS(8414),
    [anon_sym_GT_GT_EQ] = ACTIONS(8414),
    [anon_sym_LT_LT_EQ] = ACTIONS(8414),
    [anon_sym_CARET_EQ] = ACTIONS(8414),
    [anon_sym_QMARK] = ACTIONS(8414),
    [anon_sym_DOT_DOT] = ACTIONS(8416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8414),
    [anon_sym_and] = ACTIONS(8414),
    [anon_sym_or] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE] = ACTIONS(8416),
    [anon_sym_AMP_AMP] = ACTIONS(8416),
    [anon_sym_LT_LT] = ACTIONS(8416),
    [anon_sym_GT_GT] = ACTIONS(8416),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8414),
    [anon_sym_LT_EQ_GT] = ACTIONS(8414),
    [anon_sym_EQ_TILDE] = ACTIONS(8414),
    [anon_sym_BANG_TILDE] = ACTIONS(8414),
    [anon_sym_LT_EQ] = ACTIONS(8416),
    [anon_sym_GT] = ACTIONS(8416),
    [anon_sym_GT_EQ] = ACTIONS(8414),
    [anon_sym_CARET] = ACTIONS(8416),
    [anon_sym_PLUS] = ACTIONS(8416),
    [anon_sym_SLASH] = ACTIONS(8416),
    [anon_sym_PERCENT] = ACTIONS(8416),
    [sym_comment] = ACTIONS(87),
  },
  [6337] = {
    [sym__line_break] = ACTIONS(8923),
    [sym__heredoc_body_start] = ACTIONS(8923),
    [sym__binary_minus] = ACTIONS(8923),
    [sym__binary_star] = ACTIONS(8923),
    [ts_builtin_sym_end] = ACTIONS(8923),
    [anon_sym___END__] = ACTIONS(8923),
    [anon_sym_LBRACE] = ACTIONS(8923),
    [anon_sym_RBRACE] = ACTIONS(8923),
    [anon_sym_RPAREN] = ACTIONS(8923),
    [anon_sym_DOT] = ACTIONS(8925),
    [anon_sym_COMMA] = ACTIONS(8923),
    [anon_sym_PIPE] = ACTIONS(8925),
    [anon_sym_SEMI] = ACTIONS(8923),
    [anon_sym_STAR_STAR] = ACTIONS(8925),
    [anon_sym_AMP] = ACTIONS(8925),
    [anon_sym_EQ] = ACTIONS(8925),
    [anon_sym_LT] = ACTIONS(8925),
    [anon_sym_end] = ACTIONS(8923),
    [anon_sym_if] = ACTIONS(8923),
    [anon_sym_unless] = ACTIONS(8923),
    [anon_sym_while] = ACTIONS(8923),
    [anon_sym_until] = ACTIONS(8923),
    [anon_sym_rescue] = ACTIONS(8923),
    [anon_sym_do] = ACTIONS(8923),
    [anon_sym_when] = ACTIONS(8923),
    [anon_sym_elsif] = ACTIONS(8923),
    [anon_sym_else] = ACTIONS(8923),
    [anon_sym_then] = ACTIONS(8923),
    [anon_sym_ensure] = ACTIONS(8923),
    [anon_sym_EQ_GT] = ACTIONS(8923),
    [anon_sym_LBRACK] = ACTIONS(8923),
    [anon_sym_COLON_COLON2] = ACTIONS(8923),
    [anon_sym_AMP_DOT] = ACTIONS(8923),
    [anon_sym_PLUS_EQ] = ACTIONS(8923),
    [anon_sym_DASH_EQ] = ACTIONS(8923),
    [anon_sym_STAR_EQ] = ACTIONS(8923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8923),
    [anon_sym_SLASH_EQ] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8923),
    [anon_sym_PIPE_EQ] = ACTIONS(8923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8923),
    [anon_sym_AMP_EQ] = ACTIONS(8923),
    [anon_sym_PERCENT_EQ] = ACTIONS(8923),
    [anon_sym_GT_GT_EQ] = ACTIONS(8923),
    [anon_sym_LT_LT_EQ] = ACTIONS(8923),
    [anon_sym_CARET_EQ] = ACTIONS(8923),
    [anon_sym_QMARK] = ACTIONS(8923),
    [anon_sym_DOT_DOT] = ACTIONS(8925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8923),
    [anon_sym_and] = ACTIONS(8923),
    [anon_sym_or] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE] = ACTIONS(8925),
    [anon_sym_AMP_AMP] = ACTIONS(8925),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8925),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8925),
    [anon_sym_GT] = ACTIONS(8925),
    [anon_sym_GT_EQ] = ACTIONS(8923),
    [anon_sym_CARET] = ACTIONS(8925),
    [anon_sym_PLUS] = ACTIONS(8925),
    [anon_sym_SLASH] = ACTIONS(8925),
    [anon_sym_PERCENT] = ACTIONS(8925),
    [sym_comment] = ACTIONS(87),
  },
  [6338] = {
    [anon_sym_end] = ACTIONS(11966),
    [sym_comment] = ACTIONS(87),
  },
  [6339] = {
    [sym_ensure] = STATE(8553),
    [anon_sym_end] = ACTIONS(11966),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [6340] = {
    [sym__line_break] = ACTIONS(10568),
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [ts_builtin_sym_end] = ACTIONS(10568),
    [anon_sym___END__] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10570),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_end] = ACTIONS(10568),
    [anon_sym_if] = ACTIONS(10568),
    [anon_sym_unless] = ACTIONS(10568),
    [anon_sym_while] = ACTIONS(10568),
    [anon_sym_until] = ACTIONS(10568),
    [anon_sym_rescue] = ACTIONS(10568),
    [anon_sym_do] = ACTIONS(10568),
    [anon_sym_when] = ACTIONS(10568),
    [anon_sym_elsif] = ACTIONS(10568),
    [anon_sym_else] = ACTIONS(10568),
    [anon_sym_then] = ACTIONS(10568),
    [anon_sym_ensure] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_PLUS_EQ] = ACTIONS(10568),
    [anon_sym_DASH_EQ] = ACTIONS(10568),
    [anon_sym_STAR_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10568),
    [anon_sym_SLASH_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10568),
    [anon_sym_AMP_EQ] = ACTIONS(10568),
    [anon_sym_PERCENT_EQ] = ACTIONS(10568),
    [anon_sym_GT_GT_EQ] = ACTIONS(10568),
    [anon_sym_LT_LT_EQ] = ACTIONS(10568),
    [anon_sym_CARET_EQ] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10568),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10568),
    [anon_sym_or] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE] = ACTIONS(10570),
    [anon_sym_AMP_AMP] = ACTIONS(10570),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10570),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_SLASH] = ACTIONS(10570),
    [anon_sym_PERCENT] = ACTIONS(10570),
    [sym_comment] = ACTIONS(87),
  },
  [6341] = {
    [sym__line_break] = ACTIONS(9143),
    [sym__heredoc_body_start] = ACTIONS(9143),
    [sym__binary_minus] = ACTIONS(9143),
    [sym__binary_star] = ACTIONS(9143),
    [ts_builtin_sym_end] = ACTIONS(9143),
    [anon_sym___END__] = ACTIONS(9143),
    [anon_sym_LBRACE] = ACTIONS(9143),
    [anon_sym_RBRACE] = ACTIONS(9143),
    [anon_sym_RPAREN] = ACTIONS(9143),
    [anon_sym_DOT] = ACTIONS(9145),
    [anon_sym_COMMA] = ACTIONS(9143),
    [anon_sym_PIPE] = ACTIONS(9145),
    [anon_sym_SEMI] = ACTIONS(9143),
    [anon_sym_STAR_STAR] = ACTIONS(9145),
    [anon_sym_AMP] = ACTIONS(9145),
    [anon_sym_EQ] = ACTIONS(9145),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(9143),
    [anon_sym_if] = ACTIONS(9143),
    [anon_sym_unless] = ACTIONS(9143),
    [anon_sym_while] = ACTIONS(9143),
    [anon_sym_until] = ACTIONS(9143),
    [anon_sym_rescue] = ACTIONS(9143),
    [anon_sym_do] = ACTIONS(9143),
    [anon_sym_when] = ACTIONS(9143),
    [anon_sym_elsif] = ACTIONS(9143),
    [anon_sym_else] = ACTIONS(9143),
    [anon_sym_then] = ACTIONS(9143),
    [anon_sym_ensure] = ACTIONS(9143),
    [anon_sym_EQ_GT] = ACTIONS(9143),
    [anon_sym_LBRACK] = ACTIONS(9143),
    [anon_sym_COLON_COLON2] = ACTIONS(9143),
    [anon_sym_AMP_DOT] = ACTIONS(9143),
    [anon_sym_PLUS_EQ] = ACTIONS(9143),
    [anon_sym_DASH_EQ] = ACTIONS(9143),
    [anon_sym_STAR_EQ] = ACTIONS(9143),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9143),
    [anon_sym_SLASH_EQ] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9143),
    [anon_sym_PIPE_EQ] = ACTIONS(9143),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9143),
    [anon_sym_AMP_EQ] = ACTIONS(9143),
    [anon_sym_PERCENT_EQ] = ACTIONS(9143),
    [anon_sym_GT_GT_EQ] = ACTIONS(9143),
    [anon_sym_LT_LT_EQ] = ACTIONS(9143),
    [anon_sym_CARET_EQ] = ACTIONS(9143),
    [anon_sym_QMARK] = ACTIONS(9143),
    [anon_sym_DOT_DOT] = ACTIONS(9145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9143),
    [anon_sym_and] = ACTIONS(9143),
    [anon_sym_or] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE] = ACTIONS(9145),
    [anon_sym_AMP_AMP] = ACTIONS(9145),
    [anon_sym_LT_LT] = ACTIONS(9145),
    [anon_sym_GT_GT] = ACTIONS(9145),
    [anon_sym_EQ_EQ] = ACTIONS(9145),
    [anon_sym_BANG_EQ] = ACTIONS(9143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9143),
    [anon_sym_LT_EQ_GT] = ACTIONS(9143),
    [anon_sym_EQ_TILDE] = ACTIONS(9143),
    [anon_sym_BANG_TILDE] = ACTIONS(9143),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9143),
    [anon_sym_CARET] = ACTIONS(9145),
    [anon_sym_PLUS] = ACTIONS(9145),
    [anon_sym_SLASH] = ACTIONS(9145),
    [anon_sym_PERCENT] = ACTIONS(9145),
    [sym_comment] = ACTIONS(87),
  },
  [6342] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8554),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_assignment] = STATE(8554),
    [sym_operator_assignment] = STATE(8554),
    [sym_conditional] = STATE(8554),
    [sym_range] = STATE(8554),
    [sym_binary] = STATE(8554),
    [sym_unary] = STATE(8554),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [6343] = {
    [sym__line_break] = ACTIONS(6547),
    [sym__heredoc_body_start] = ACTIONS(6547),
    [sym__binary_minus] = ACTIONS(6547),
    [sym__binary_star] = ACTIONS(6547),
    [ts_builtin_sym_end] = ACTIONS(6547),
    [anon_sym___END__] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_DOT] = ACTIONS(8423),
    [anon_sym_COMMA] = ACTIONS(6547),
    [anon_sym_PIPE] = ACTIONS(8423),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym_STAR_STAR] = ACTIONS(8423),
    [anon_sym_AMP] = ACTIONS(8423),
    [anon_sym_EQ] = ACTIONS(8423),
    [anon_sym_LT] = ACTIONS(8423),
    [anon_sym_end] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(6547),
    [anon_sym_unless] = ACTIONS(6547),
    [anon_sym_while] = ACTIONS(6547),
    [anon_sym_until] = ACTIONS(6547),
    [anon_sym_rescue] = ACTIONS(6547),
    [anon_sym_do] = ACTIONS(6547),
    [anon_sym_when] = ACTIONS(6547),
    [anon_sym_elsif] = ACTIONS(6547),
    [anon_sym_else] = ACTIONS(6547),
    [anon_sym_then] = ACTIONS(6547),
    [anon_sym_ensure] = ACTIONS(6547),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_COLON_COLON2] = ACTIONS(6547),
    [anon_sym_AMP_DOT] = ACTIONS(6547),
    [anon_sym_PLUS_EQ] = ACTIONS(6547),
    [anon_sym_DASH_EQ] = ACTIONS(6547),
    [anon_sym_STAR_EQ] = ACTIONS(6547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6547),
    [anon_sym_SLASH_EQ] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6547),
    [anon_sym_PIPE_EQ] = ACTIONS(6547),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6547),
    [anon_sym_AMP_EQ] = ACTIONS(6547),
    [anon_sym_PERCENT_EQ] = ACTIONS(6547),
    [anon_sym_GT_GT_EQ] = ACTIONS(6547),
    [anon_sym_LT_LT_EQ] = ACTIONS(6547),
    [anon_sym_CARET_EQ] = ACTIONS(6547),
    [anon_sym_QMARK] = ACTIONS(6547),
    [anon_sym_DOT_DOT] = ACTIONS(8423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6547),
    [anon_sym_and] = ACTIONS(6547),
    [anon_sym_or] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8423),
    [anon_sym_AMP_AMP] = ACTIONS(8423),
    [anon_sym_LT_LT] = ACTIONS(8423),
    [anon_sym_GT_GT] = ACTIONS(8423),
    [anon_sym_EQ_EQ] = ACTIONS(8423),
    [anon_sym_BANG_EQ] = ACTIONS(6547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6547),
    [anon_sym_LT_EQ_GT] = ACTIONS(6547),
    [anon_sym_EQ_TILDE] = ACTIONS(6547),
    [anon_sym_BANG_TILDE] = ACTIONS(6547),
    [anon_sym_LT_EQ] = ACTIONS(8423),
    [anon_sym_GT] = ACTIONS(8423),
    [anon_sym_GT_EQ] = ACTIONS(6547),
    [anon_sym_CARET] = ACTIONS(8423),
    [anon_sym_PLUS] = ACTIONS(8423),
    [anon_sym_SLASH] = ACTIONS(8423),
    [anon_sym_PERCENT] = ACTIONS(8423),
    [sym_comment] = ACTIONS(87),
  },
  [6344] = {
    [sym__line_break] = ACTIONS(10596),
    [sym__heredoc_body_start] = ACTIONS(10596),
    [sym__binary_minus] = ACTIONS(10596),
    [sym__binary_star] = ACTIONS(10596),
    [ts_builtin_sym_end] = ACTIONS(10596),
    [anon_sym___END__] = ACTIONS(10596),
    [anon_sym_LBRACE] = ACTIONS(10596),
    [anon_sym_RBRACE] = ACTIONS(10596),
    [anon_sym_RPAREN] = ACTIONS(10596),
    [anon_sym_DOT] = ACTIONS(10598),
    [anon_sym_COMMA] = ACTIONS(10596),
    [anon_sym_PIPE] = ACTIONS(10598),
    [anon_sym_SEMI] = ACTIONS(10596),
    [anon_sym_STAR_STAR] = ACTIONS(10598),
    [anon_sym_AMP] = ACTIONS(10598),
    [anon_sym_EQ] = ACTIONS(10598),
    [anon_sym_LT] = ACTIONS(10598),
    [anon_sym_end] = ACTIONS(10596),
    [anon_sym_if] = ACTIONS(10596),
    [anon_sym_unless] = ACTIONS(10596),
    [anon_sym_while] = ACTIONS(10596),
    [anon_sym_until] = ACTIONS(10596),
    [anon_sym_rescue] = ACTIONS(10596),
    [anon_sym_do] = ACTIONS(10596),
    [anon_sym_when] = ACTIONS(10596),
    [anon_sym_elsif] = ACTIONS(10596),
    [anon_sym_else] = ACTIONS(10596),
    [anon_sym_then] = ACTIONS(10596),
    [anon_sym_ensure] = ACTIONS(10596),
    [anon_sym_LBRACK] = ACTIONS(10596),
    [anon_sym_COLON_COLON2] = ACTIONS(10596),
    [anon_sym_AMP_DOT] = ACTIONS(10596),
    [anon_sym_PLUS_EQ] = ACTIONS(10596),
    [anon_sym_DASH_EQ] = ACTIONS(10596),
    [anon_sym_STAR_EQ] = ACTIONS(10596),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10596),
    [anon_sym_SLASH_EQ] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10596),
    [anon_sym_PIPE_EQ] = ACTIONS(10596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10596),
    [anon_sym_AMP_EQ] = ACTIONS(10596),
    [anon_sym_PERCENT_EQ] = ACTIONS(10596),
    [anon_sym_GT_GT_EQ] = ACTIONS(10596),
    [anon_sym_LT_LT_EQ] = ACTIONS(10596),
    [anon_sym_CARET_EQ] = ACTIONS(10596),
    [anon_sym_QMARK] = ACTIONS(10596),
    [anon_sym_DOT_DOT] = ACTIONS(10598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10596),
    [anon_sym_and] = ACTIONS(10596),
    [anon_sym_or] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE] = ACTIONS(10598),
    [anon_sym_AMP_AMP] = ACTIONS(10598),
    [anon_sym_LT_LT] = ACTIONS(10598),
    [anon_sym_GT_GT] = ACTIONS(10598),
    [anon_sym_EQ_EQ] = ACTIONS(10598),
    [anon_sym_BANG_EQ] = ACTIONS(10596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10596),
    [anon_sym_LT_EQ_GT] = ACTIONS(10596),
    [anon_sym_EQ_TILDE] = ACTIONS(10596),
    [anon_sym_BANG_TILDE] = ACTIONS(10596),
    [anon_sym_LT_EQ] = ACTIONS(10598),
    [anon_sym_GT] = ACTIONS(10598),
    [anon_sym_GT_EQ] = ACTIONS(10596),
    [anon_sym_CARET] = ACTIONS(10598),
    [anon_sym_PLUS] = ACTIONS(10598),
    [anon_sym_SLASH] = ACTIONS(10598),
    [anon_sym_PERCENT] = ACTIONS(10598),
    [sym_comment] = ACTIONS(87),
  },
  [6345] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3724),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(431),
    [sym_scope_resolution] = STATE(425),
    [sym_call] = STATE(425),
    [sym_method_call] = STATE(431),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(3724),
    [sym_operator_assignment] = STATE(3724),
    [sym_conditional] = STATE(3724),
    [sym_range] = STATE(3724),
    [sym_binary] = STATE(3724),
    [sym_unary] = STATE(3724),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(430),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(431),
    [sym__variable] = STATE(425),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(431),
    [sym_false] = STATE(431),
    [sym_nil] = STATE(431),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1501),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(1667),
    [sym__unary_minus] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(787),
    [anon_sym_next] = ACTIONS(789),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_defined_QMARK] = ACTIONS(803),
    [anon_sym_not] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(809),
    [sym_constant] = ACTIONS(817),
    [sym_identifier] = ACTIONS(817),
    [sym_instance_variable] = ACTIONS(813),
    [sym_class_variable] = ACTIONS(813),
    [sym_global_variable] = ACTIONS(813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(817),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [6346] = {
    [aux_sym_exceptions_repeat1] = STATE(8556),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [ts_builtin_sym_end] = ACTIONS(9603),
    [anon_sym___END__] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(11968),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [6347] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [6348] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [6349] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [6350] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [6351] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [6352] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11970),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6353] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(5798),
    [anon_sym___END__] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(6042),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(6046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6048),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(6050),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6050),
    [anon_sym_LT_EQ_GT] = ACTIONS(6050),
    [anon_sym_EQ_TILDE] = ACTIONS(6050),
    [anon_sym_BANG_TILDE] = ACTIONS(6050),
    [anon_sym_LT_EQ] = ACTIONS(6042),
    [anon_sym_GT] = ACTIONS(6042),
    [anon_sym_GT_EQ] = ACTIONS(6056),
    [anon_sym_CARET] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [6354] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(6042),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(6044),
    [anon_sym_DOT_DOT] = ACTIONS(6046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6048),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(6050),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6050),
    [anon_sym_LT_EQ_GT] = ACTIONS(6050),
    [anon_sym_EQ_TILDE] = ACTIONS(6050),
    [anon_sym_BANG_TILDE] = ACTIONS(6050),
    [anon_sym_LT_EQ] = ACTIONS(6042),
    [anon_sym_GT] = ACTIONS(6042),
    [anon_sym_GT_EQ] = ACTIONS(6056),
    [anon_sym_CARET] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [6355] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(6042),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6050),
    [anon_sym_LT_EQ_GT] = ACTIONS(6050),
    [anon_sym_EQ_TILDE] = ACTIONS(6050),
    [anon_sym_BANG_TILDE] = ACTIONS(6050),
    [anon_sym_LT_EQ] = ACTIONS(6042),
    [anon_sym_GT] = ACTIONS(6042),
    [anon_sym_GT_EQ] = ACTIONS(6056),
    [anon_sym_CARET] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [6356] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym___END__] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [6357] = {
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [ts_builtin_sym_end] = ACTIONS(11211),
    [anon_sym___END__] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_when] = ACTIONS(11211),
    [anon_sym_elsif] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [6358] = {
    [aux_sym_exceptions_repeat1] = STATE(6358),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [ts_builtin_sym_end] = ACTIONS(11211),
    [anon_sym___END__] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11974),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [6359] = {
    [aux_sym_exceptions_repeat1] = STATE(3743),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6060),
    [anon_sym___END__] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [6360] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(6074),
    [anon_sym___END__] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(6042),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(6044),
    [anon_sym_DOT_DOT] = ACTIONS(6046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6048),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6050),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6050),
    [anon_sym_LT_EQ_GT] = ACTIONS(6050),
    [anon_sym_EQ_TILDE] = ACTIONS(6050),
    [anon_sym_BANG_TILDE] = ACTIONS(6050),
    [anon_sym_LT_EQ] = ACTIONS(6042),
    [anon_sym_GT] = ACTIONS(6042),
    [anon_sym_GT_EQ] = ACTIONS(6056),
    [anon_sym_CARET] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [6361] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6362] = {
    [sym_heredoc_body] = STATE(8558),
    [aux_sym_call_repeat1] = STATE(8558),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [6363] = {
    [sym_heredoc_body] = STATE(8558),
    [aux_sym_call_repeat1] = STATE(8558),
    [aux_sym_argument_list_repeat1] = STATE(8559),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(6153),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [6364] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9617),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [6365] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8560),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(8560),
    [sym_operator_assignment] = STATE(8560),
    [sym_conditional] = STATE(8560),
    [sym_range] = STATE(8560),
    [sym_binary] = STATE(8560),
    [sym_unary] = STATE(8560),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6366] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8561),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(8561),
    [sym_operator_assignment] = STATE(8561),
    [sym_conditional] = STATE(8561),
    [sym_range] = STATE(8561),
    [sym_binary] = STATE(8561),
    [sym_unary] = STATE(8561),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6367] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8562),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(8562),
    [sym_operator_assignment] = STATE(8562),
    [sym_conditional] = STATE(8562),
    [sym_range] = STATE(8562),
    [sym_binary] = STATE(8562),
    [sym_unary] = STATE(8562),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6368] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8563),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(8563),
    [sym_operator_assignment] = STATE(8563),
    [sym_conditional] = STATE(8563),
    [sym_range] = STATE(8563),
    [sym_binary] = STATE(8563),
    [sym_unary] = STATE(8563),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6369] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8564),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(8564),
    [sym_operator_assignment] = STATE(8564),
    [sym_conditional] = STATE(8564),
    [sym_range] = STATE(8564),
    [sym_binary] = STATE(8564),
    [sym_unary] = STATE(8564),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6370] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8565),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8565),
    [sym_operator_assignment] = STATE(8565),
    [sym_conditional] = STATE(8565),
    [sym_range] = STATE(8565),
    [sym_binary] = STATE(8565),
    [sym_unary] = STATE(8565),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6371] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8566),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(8566),
    [sym_operator_assignment] = STATE(8566),
    [sym_conditional] = STATE(8566),
    [sym_range] = STATE(8566),
    [sym_binary] = STATE(8566),
    [sym_unary] = STATE(8566),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6372] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8567),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(8567),
    [sym_operator_assignment] = STATE(8567),
    [sym_conditional] = STATE(8567),
    [sym_range] = STATE(8567),
    [sym_binary] = STATE(8567),
    [sym_unary] = STATE(8567),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6373] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8568),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(8568),
    [sym_operator_assignment] = STATE(8568),
    [sym_conditional] = STATE(8568),
    [sym_range] = STATE(8568),
    [sym_binary] = STATE(8568),
    [sym_unary] = STATE(8568),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6374] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8569),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(8569),
    [sym_operator_assignment] = STATE(8569),
    [sym_conditional] = STATE(8569),
    [sym_range] = STATE(8569),
    [sym_binary] = STATE(8569),
    [sym_unary] = STATE(8569),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6375] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8570),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_splat_argument] = STATE(8571),
    [sym_assignment] = STATE(8570),
    [sym_operator_assignment] = STATE(8570),
    [sym_conditional] = STATE(8570),
    [sym_range] = STATE(8570),
    [sym_binary] = STATE(8570),
    [sym_unary] = STATE(8570),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(8571),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6376] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8572),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(8572),
    [sym_operator_assignment] = STATE(8572),
    [sym_conditional] = STATE(8572),
    [sym_range] = STATE(8572),
    [sym_binary] = STATE(8572),
    [sym_unary] = STATE(8572),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6377] = {
    [sym_string] = STATE(8573),
    [aux_sym_chained_string_repeat1] = STATE(8573),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [6378] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(9617),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [6379] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6380] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6381] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8574),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(8574),
    [sym_operator_assignment] = STATE(8574),
    [sym_conditional] = STATE(8574),
    [sym_range] = STATE(8574),
    [sym_binary] = STATE(8574),
    [sym_unary] = STATE(8574),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6382] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6383] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8575),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(8575),
    [sym_operator_assignment] = STATE(8575),
    [sym_conditional] = STATE(8575),
    [sym_range] = STATE(8575),
    [sym_binary] = STATE(8575),
    [sym_unary] = STATE(8575),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6384] = {
    [sym_heredoc_body] = STATE(8576),
    [aux_sym_call_repeat1] = STATE(8576),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6385] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3768),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(3768),
    [sym_operator_assignment] = STATE(3768),
    [sym_conditional] = STATE(3768),
    [sym_range] = STATE(3768),
    [sym_binary] = STATE(3768),
    [sym_unary] = STATE(3768),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3771),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(8577),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6109),
    [sym__splat_star] = ACTIONS(6111),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__identifier_hash_key] = ACTIONS(6113),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11977),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(6115),
    [sym_identifier] = ACTIONS(6115),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6386] = {
    [sym_heredoc_body] = STATE(8578),
    [aux_sym_call_repeat1] = STATE(8578),
    [aux_sym_argument_list_repeat1] = STATE(8579),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9643),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6387] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(9617),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [6388] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6389] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [6390] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6391] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6392] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6393] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11979),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6394] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6395] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6396] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6397] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6398] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6399] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6400] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8581),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(8581),
    [sym_operator_assignment] = STATE(8581),
    [sym_conditional] = STATE(8581),
    [sym_range] = STATE(8581),
    [sym_binary] = STATE(8581),
    [sym_unary] = STATE(8581),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6401] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6402] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8582),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(8582),
    [sym_operator_assignment] = STATE(8582),
    [sym_conditional] = STATE(8582),
    [sym_range] = STATE(8582),
    [sym_binary] = STATE(8582),
    [sym_unary] = STATE(8582),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6403] = {
    [sym_heredoc_body] = STATE(8583),
    [aux_sym_call_repeat1] = STATE(8583),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [6404] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3789),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym__argument] = STATE(4285),
    [sym_splat_argument] = STATE(4285),
    [sym_hash_splat_argument] = STATE(4285),
    [sym_block_argument] = STATE(4285),
    [sym_assignment] = STATE(3789),
    [sym_operator_assignment] = STATE(3789),
    [sym_conditional] = STATE(3789),
    [sym_range] = STATE(3789),
    [sym_binary] = STATE(3789),
    [sym_unary] = STATE(3789),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3792),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(8584),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4285),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6145),
    [sym__splat_star] = ACTIONS(6147),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__identifier_hash_key] = ACTIONS(6149),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11981),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(6151),
    [sym_identifier] = ACTIONS(6151),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6405] = {
    [sym_heredoc_body] = STATE(8585),
    [aux_sym_call_repeat1] = STATE(8585),
    [aux_sym_argument_list_repeat1] = STATE(8586),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9651),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [6406] = {
    [sym_heredoc_body] = STATE(6406),
    [aux_sym_call_repeat1] = STATE(6406),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [6407] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1614),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(1614),
    [sym_operator_assignment] = STATE(1614),
    [sym_conditional] = STATE(1614),
    [sym_range] = STATE(1614),
    [sym_binary] = STATE(1614),
    [sym_unary] = STATE(1614),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1620),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(2765),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__identifier_hash_key] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9655),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2789),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6408] = {
    [sym_heredoc_body] = STATE(6406),
    [aux_sym_call_repeat1] = STATE(6406),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [6409] = {
    [aux_sym_argument_list_repeat1] = STATE(6409),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(11983),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [6410] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6411] = {
    [aux_sym_exceptions_repeat1] = STATE(8588),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [6412] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [6413] = {
    [sym_string] = STATE(6413),
    [aux_sym_chained_string_repeat1] = STATE(6413),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [6414] = {
    [anon_sym_RBRACE] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [6415] = {
    [aux_sym_undef_repeat1] = STATE(6415),
    [anon_sym_RBRACE] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(11986),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [6416] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8589),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(456),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(456),
    [sym_assignment] = STATE(8589),
    [sym_operator_assignment] = STATE(8589),
    [sym_conditional] = STATE(8589),
    [sym_range] = STATE(8589),
    [sym_binary] = STATE(8589),
    [sym_unary] = STATE(8589),
    [sym_left_assignment_list] = STATE(455),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(456),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(456),
    [sym_false] = STATE(456),
    [sym_nil] = STATE(456),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(457),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_next] = ACTIONS(855),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_defined_QMARK] = ACTIONS(861),
    [anon_sym_not] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6417] = {
    [sym__simple_symbol] = ACTIONS(4148),
    [sym__string_start] = ACTIONS(4148),
    [sym__symbol_start] = ACTIONS(4148),
    [sym__subshell_start] = ACTIONS(4148),
    [sym__regex_start] = ACTIONS(4148),
    [sym__string_array_start] = ACTIONS(4148),
    [sym__symbol_array_start] = ACTIONS(4148),
    [sym_heredoc_beginning] = ACTIONS(4148),
    [sym__block_ampersand] = ACTIONS(4148),
    [sym__splat_star] = ACTIONS(4148),
    [sym__unary_minus] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [sym__identifier_hash_key] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_def] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(4150),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COLON_COLON] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_STAR_STAR] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_class] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_module] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_yield] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_next] = ACTIONS(4150),
    [sym_redo] = ACTIONS(4150),
    [sym_retry] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_unless] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [anon_sym_until] = ACTIONS(4150),
    [anon_sym_rescue] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_do] = ACTIONS(4150),
    [anon_sym_case] = ACTIONS(4150),
    [anon_sym_begin] = ACTIONS(4150),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_COLON2] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4150),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_defined_QMARK] = ACTIONS(4148),
    [anon_sym_not] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_TILDE] = ACTIONS(4148),
    [sym_constant] = ACTIONS(4150),
    [sym_identifier] = ACTIONS(4150),
    [sym_instance_variable] = ACTIONS(4148),
    [sym_class_variable] = ACTIONS(4148),
    [sym_global_variable] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4150),
    [sym_float] = ACTIONS(4150),
    [sym_complex] = ACTIONS(4148),
    [sym_super] = ACTIONS(4150),
    [anon_sym_true] = ACTIONS(4150),
    [anon_sym_TRUE] = ACTIONS(4150),
    [anon_sym_false] = ACTIONS(4150),
    [anon_sym_FALSE] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [anon_sym_nil] = ACTIONS(4150),
    [anon_sym_NIL] = ACTIONS(4150),
    [sym_character] = ACTIONS(4148),
    [anon_sym_LBRACK2] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4148),
  },
  [6418] = {
    [sym_heredoc_body] = STATE(8591),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(11989),
    [sym_comment] = ACTIONS(87),
  },
  [6419] = {
    [anon_sym_RPAREN] = ACTIONS(11989),
    [sym_comment] = ACTIONS(87),
  },
  [6420] = {
    [sym__simple_symbol] = ACTIONS(9425),
    [sym__string_start] = ACTIONS(9425),
    [sym__symbol_start] = ACTIONS(9425),
    [sym__subshell_start] = ACTIONS(9425),
    [sym__regex_start] = ACTIONS(9425),
    [sym__string_array_start] = ACTIONS(9425),
    [sym__symbol_array_start] = ACTIONS(9425),
    [sym_heredoc_beginning] = ACTIONS(9425),
    [sym__block_ampersand] = ACTIONS(9425),
    [sym__splat_star] = ACTIONS(9425),
    [sym__unary_minus] = ACTIONS(9425),
    [sym__binary_minus] = ACTIONS(9425),
    [sym__binary_star] = ACTIONS(9425),
    [sym__identifier_hash_key] = ACTIONS(9425),
    [anon_sym_LBRACE] = ACTIONS(9425),
    [anon_sym_RBRACE] = ACTIONS(9425),
    [anon_sym_def] = ACTIONS(9427),
    [anon_sym_LPAREN] = ACTIONS(9427),
    [anon_sym_RPAREN] = ACTIONS(9425),
    [anon_sym_DOT] = ACTIONS(9427),
    [anon_sym_COLON_COLON] = ACTIONS(9427),
    [anon_sym_COMMA] = ACTIONS(9425),
    [anon_sym_PIPE] = ACTIONS(9427),
    [anon_sym_SEMI] = ACTIONS(9425),
    [anon_sym_STAR] = ACTIONS(9427),
    [anon_sym_STAR_STAR] = ACTIONS(9427),
    [anon_sym_AMP] = ACTIONS(9427),
    [anon_sym_EQ] = ACTIONS(9427),
    [anon_sym_class] = ACTIONS(9427),
    [anon_sym_LT] = ACTIONS(9427),
    [anon_sym_module] = ACTIONS(9427),
    [anon_sym_return] = ACTIONS(9427),
    [anon_sym_yield] = ACTIONS(9427),
    [anon_sym_break] = ACTIONS(9427),
    [anon_sym_next] = ACTIONS(9427),
    [sym_redo] = ACTIONS(9427),
    [sym_retry] = ACTIONS(9427),
    [anon_sym_if] = ACTIONS(9427),
    [anon_sym_unless] = ACTIONS(9427),
    [anon_sym_while] = ACTIONS(9427),
    [anon_sym_until] = ACTIONS(9427),
    [anon_sym_rescue] = ACTIONS(9427),
    [anon_sym_for] = ACTIONS(9427),
    [anon_sym_do] = ACTIONS(9427),
    [anon_sym_case] = ACTIONS(9427),
    [anon_sym_begin] = ACTIONS(9427),
    [anon_sym_LBRACK] = ACTIONS(9425),
    [anon_sym_COLON_COLON2] = ACTIONS(9425),
    [anon_sym_AMP_DOT] = ACTIONS(9425),
    [anon_sym_LPAREN2] = ACTIONS(9425),
    [anon_sym_PLUS_EQ] = ACTIONS(9425),
    [anon_sym_DASH_EQ] = ACTIONS(9425),
    [anon_sym_STAR_EQ] = ACTIONS(9425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9425),
    [anon_sym_SLASH_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9425),
    [anon_sym_AMP_EQ] = ACTIONS(9425),
    [anon_sym_PERCENT_EQ] = ACTIONS(9425),
    [anon_sym_GT_GT_EQ] = ACTIONS(9425),
    [anon_sym_LT_LT_EQ] = ACTIONS(9425),
    [anon_sym_CARET_EQ] = ACTIONS(9425),
    [anon_sym_QMARK] = ACTIONS(9427),
    [anon_sym_COLON2] = ACTIONS(9427),
    [anon_sym_DOT_DOT] = ACTIONS(9427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9425),
    [anon_sym_and] = ACTIONS(9427),
    [anon_sym_or] = ACTIONS(9427),
    [anon_sym_PIPE_PIPE] = ACTIONS(9427),
    [anon_sym_AMP_AMP] = ACTIONS(9427),
    [anon_sym_LT_LT] = ACTIONS(9427),
    [anon_sym_GT_GT] = ACTIONS(9427),
    [anon_sym_EQ_EQ] = ACTIONS(9427),
    [anon_sym_BANG_EQ] = ACTIONS(9425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9425),
    [anon_sym_LT_EQ_GT] = ACTIONS(9425),
    [anon_sym_EQ_TILDE] = ACTIONS(9425),
    [anon_sym_BANG_TILDE] = ACTIONS(9425),
    [anon_sym_LT_EQ] = ACTIONS(9427),
    [anon_sym_GT] = ACTIONS(9427),
    [anon_sym_GT_EQ] = ACTIONS(9425),
    [anon_sym_CARET] = ACTIONS(9427),
    [anon_sym_PLUS] = ACTIONS(9427),
    [anon_sym_SLASH] = ACTIONS(9427),
    [anon_sym_PERCENT] = ACTIONS(9427),
    [anon_sym_defined_QMARK] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [anon_sym_BANG] = ACTIONS(9427),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_constant] = ACTIONS(9427),
    [sym_identifier] = ACTIONS(9427),
    [sym_instance_variable] = ACTIONS(9425),
    [sym_class_variable] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(9425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9427),
    [sym_float] = ACTIONS(9427),
    [sym_complex] = ACTIONS(9425),
    [sym_super] = ACTIONS(9427),
    [anon_sym_true] = ACTIONS(9427),
    [anon_sym_TRUE] = ACTIONS(9427),
    [anon_sym_false] = ACTIONS(9427),
    [anon_sym_FALSE] = ACTIONS(9427),
    [sym_self] = ACTIONS(9427),
    [anon_sym_nil] = ACTIONS(9427),
    [anon_sym_NIL] = ACTIONS(9427),
    [sym_character] = ACTIONS(9425),
    [anon_sym_LBRACK2] = ACTIONS(9427),
    [anon_sym_DASH_GT] = ACTIONS(9425),
  },
  [6421] = {
    [sym__binary_minus] = ACTIONS(9432),
    [sym__binary_star] = ACTIONS(9432),
    [anon_sym_LBRACE] = ACTIONS(9432),
    [anon_sym_RBRACE] = ACTIONS(9432),
    [anon_sym_RPAREN] = ACTIONS(9432),
    [anon_sym_DOT] = ACTIONS(9434),
    [anon_sym_COMMA] = ACTIONS(9432),
    [anon_sym_PIPE] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(9432),
    [anon_sym_STAR_STAR] = ACTIONS(9434),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_EQ] = ACTIONS(9434),
    [anon_sym_LT] = ACTIONS(9434),
    [anon_sym_if] = ACTIONS(9432),
    [anon_sym_unless] = ACTIONS(9432),
    [anon_sym_while] = ACTIONS(9432),
    [anon_sym_until] = ACTIONS(9432),
    [anon_sym_rescue] = ACTIONS(9432),
    [anon_sym_do] = ACTIONS(9432),
    [anon_sym_LBRACK] = ACTIONS(9432),
    [anon_sym_COLON_COLON2] = ACTIONS(9432),
    [anon_sym_AMP_DOT] = ACTIONS(9432),
    [anon_sym_PLUS_EQ] = ACTIONS(9432),
    [anon_sym_DASH_EQ] = ACTIONS(9432),
    [anon_sym_STAR_EQ] = ACTIONS(9432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9432),
    [anon_sym_SLASH_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9432),
    [anon_sym_AMP_EQ] = ACTIONS(9432),
    [anon_sym_PERCENT_EQ] = ACTIONS(9432),
    [anon_sym_GT_GT_EQ] = ACTIONS(9432),
    [anon_sym_LT_LT_EQ] = ACTIONS(9432),
    [anon_sym_CARET_EQ] = ACTIONS(9432),
    [anon_sym_QMARK] = ACTIONS(9432),
    [anon_sym_COLON2] = ACTIONS(9434),
    [anon_sym_DOT_DOT] = ACTIONS(9434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9432),
    [anon_sym_and] = ACTIONS(9432),
    [anon_sym_or] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE] = ACTIONS(9434),
    [anon_sym_AMP_AMP] = ACTIONS(9434),
    [anon_sym_LT_LT] = ACTIONS(9434),
    [anon_sym_GT_GT] = ACTIONS(9434),
    [anon_sym_EQ_EQ] = ACTIONS(9434),
    [anon_sym_BANG_EQ] = ACTIONS(9432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9432),
    [anon_sym_LT_EQ_GT] = ACTIONS(9432),
    [anon_sym_EQ_TILDE] = ACTIONS(9432),
    [anon_sym_BANG_TILDE] = ACTIONS(9432),
    [anon_sym_LT_EQ] = ACTIONS(9434),
    [anon_sym_GT] = ACTIONS(9434),
    [anon_sym_GT_EQ] = ACTIONS(9432),
    [anon_sym_CARET] = ACTIONS(9434),
    [anon_sym_PLUS] = ACTIONS(9434),
    [anon_sym_SLASH] = ACTIONS(9434),
    [anon_sym_PERCENT] = ACTIONS(9434),
    [sym_comment] = ACTIONS(87),
  },
  [6422] = {
    [anon_sym_RBRACK] = ACTIONS(11991),
    [sym_comment] = ACTIONS(87),
  },
  [6423] = {
    [sym__string_start] = ACTIONS(837),
    [sym__heredoc_body_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_unless] = ACTIONS(837),
    [anon_sym_while] = ACTIONS(837),
    [anon_sym_until] = ACTIONS(837),
    [anon_sym_rescue] = ACTIONS(837),
    [anon_sym_in] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_COLON2] = ACTIONS(839),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [sym_comment] = ACTIONS(87),
  },
  [6424] = {
    [sym__string_end] = ACTIONS(11993),
    [sym_comment] = ACTIONS(87),
  },
  [6425] = {
    [sym__heredoc_body_start] = ACTIONS(887),
    [sym__binary_minus] = ACTIONS(887),
    [sym__binary_star] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(887),
    [anon_sym_RBRACE] = ACTIONS(887),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_DOT] = ACTIONS(889),
    [anon_sym_COMMA] = ACTIONS(887),
    [anon_sym_PIPE] = ACTIONS(889),
    [anon_sym_SEMI] = ACTIONS(887),
    [anon_sym_STAR_STAR] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(889),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_unless] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_until] = ACTIONS(887),
    [anon_sym_rescue] = ACTIONS(887),
    [anon_sym_in] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(887),
    [anon_sym_RBRACK] = ACTIONS(887),
    [anon_sym_COLON_COLON2] = ACTIONS(887),
    [anon_sym_AMP_DOT] = ACTIONS(887),
    [anon_sym_PLUS_EQ] = ACTIONS(887),
    [anon_sym_DASH_EQ] = ACTIONS(887),
    [anon_sym_STAR_EQ] = ACTIONS(887),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(887),
    [anon_sym_SLASH_EQ] = ACTIONS(887),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(887),
    [anon_sym_PIPE_EQ] = ACTIONS(887),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(887),
    [anon_sym_AMP_EQ] = ACTIONS(887),
    [anon_sym_PERCENT_EQ] = ACTIONS(887),
    [anon_sym_GT_GT_EQ] = ACTIONS(887),
    [anon_sym_LT_LT_EQ] = ACTIONS(887),
    [anon_sym_CARET_EQ] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(887),
    [anon_sym_COLON2] = ACTIONS(889),
    [anon_sym_DOT_DOT] = ACTIONS(889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(887),
    [anon_sym_and] = ACTIONS(887),
    [anon_sym_or] = ACTIONS(887),
    [anon_sym_PIPE_PIPE] = ACTIONS(889),
    [anon_sym_AMP_AMP] = ACTIONS(889),
    [anon_sym_LT_LT] = ACTIONS(889),
    [anon_sym_GT_GT] = ACTIONS(889),
    [anon_sym_EQ_EQ] = ACTIONS(889),
    [anon_sym_BANG_EQ] = ACTIONS(887),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(887),
    [anon_sym_LT_EQ_GT] = ACTIONS(887),
    [anon_sym_EQ_TILDE] = ACTIONS(887),
    [anon_sym_BANG_TILDE] = ACTIONS(887),
    [anon_sym_LT_EQ] = ACTIONS(889),
    [anon_sym_GT] = ACTIONS(889),
    [anon_sym_GT_EQ] = ACTIONS(887),
    [anon_sym_CARET] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [sym_comment] = ACTIONS(87),
  },
  [6426] = {
    [sym__string_end] = ACTIONS(11995),
    [sym_comment] = ACTIONS(87),
  },
  [6427] = {
    [sym__heredoc_body_start] = ACTIONS(893),
    [sym__binary_minus] = ACTIONS(893),
    [sym__binary_star] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_RPAREN] = ACTIONS(893),
    [anon_sym_DOT] = ACTIONS(895),
    [anon_sym_COMMA] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(895),
    [anon_sym_EQ] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_in] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(893),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_COLON_COLON2] = ACTIONS(893),
    [anon_sym_AMP_DOT] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [anon_sym_DASH_EQ] = ACTIONS(893),
    [anon_sym_STAR_EQ] = ACTIONS(893),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(893),
    [anon_sym_SLASH_EQ] = ACTIONS(893),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(893),
    [anon_sym_PIPE_EQ] = ACTIONS(893),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(893),
    [anon_sym_AMP_EQ] = ACTIONS(893),
    [anon_sym_PERCENT_EQ] = ACTIONS(893),
    [anon_sym_GT_GT_EQ] = ACTIONS(893),
    [anon_sym_LT_LT_EQ] = ACTIONS(893),
    [anon_sym_CARET_EQ] = ACTIONS(893),
    [anon_sym_QMARK] = ACTIONS(893),
    [anon_sym_COLON2] = ACTIONS(895),
    [anon_sym_DOT_DOT] = ACTIONS(895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(893),
    [anon_sym_and] = ACTIONS(893),
    [anon_sym_or] = ACTIONS(893),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_EQ_EQ] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(893),
    [anon_sym_LT_EQ_GT] = ACTIONS(893),
    [anon_sym_EQ_TILDE] = ACTIONS(893),
    [anon_sym_BANG_TILDE] = ACTIONS(893),
    [anon_sym_LT_EQ] = ACTIONS(895),
    [anon_sym_GT] = ACTIONS(895),
    [anon_sym_GT_EQ] = ACTIONS(893),
    [anon_sym_CARET] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_SLASH] = ACTIONS(895),
    [anon_sym_PERCENT] = ACTIONS(895),
    [sym_comment] = ACTIONS(87),
  },
  [6428] = {
    [sym__string_end] = ACTIONS(11997),
    [sym_comment] = ACTIONS(87),
  },
  [6429] = {
    [sym__heredoc_body_start] = ACTIONS(899),
    [sym__binary_minus] = ACTIONS(899),
    [sym__binary_star] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(899),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_DOT] = ACTIONS(901),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_PIPE] = ACTIONS(901),
    [anon_sym_SEMI] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(901),
    [anon_sym_AMP] = ACTIONS(901),
    [anon_sym_EQ] = ACTIONS(901),
    [anon_sym_LT] = ACTIONS(901),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_unless] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_until] = ACTIONS(899),
    [anon_sym_rescue] = ACTIONS(899),
    [anon_sym_in] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(899),
    [anon_sym_RBRACK] = ACTIONS(899),
    [anon_sym_COLON_COLON2] = ACTIONS(899),
    [anon_sym_AMP_DOT] = ACTIONS(899),
    [anon_sym_PLUS_EQ] = ACTIONS(899),
    [anon_sym_DASH_EQ] = ACTIONS(899),
    [anon_sym_STAR_EQ] = ACTIONS(899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(899),
    [anon_sym_SLASH_EQ] = ACTIONS(899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(899),
    [anon_sym_PIPE_EQ] = ACTIONS(899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(899),
    [anon_sym_AMP_EQ] = ACTIONS(899),
    [anon_sym_PERCENT_EQ] = ACTIONS(899),
    [anon_sym_GT_GT_EQ] = ACTIONS(899),
    [anon_sym_LT_LT_EQ] = ACTIONS(899),
    [anon_sym_CARET_EQ] = ACTIONS(899),
    [anon_sym_QMARK] = ACTIONS(899),
    [anon_sym_COLON2] = ACTIONS(901),
    [anon_sym_DOT_DOT] = ACTIONS(901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(899),
    [anon_sym_and] = ACTIONS(899),
    [anon_sym_or] = ACTIONS(899),
    [anon_sym_PIPE_PIPE] = ACTIONS(901),
    [anon_sym_AMP_AMP] = ACTIONS(901),
    [anon_sym_LT_LT] = ACTIONS(901),
    [anon_sym_GT_GT] = ACTIONS(901),
    [anon_sym_EQ_EQ] = ACTIONS(901),
    [anon_sym_BANG_EQ] = ACTIONS(899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(899),
    [anon_sym_LT_EQ_GT] = ACTIONS(899),
    [anon_sym_EQ_TILDE] = ACTIONS(899),
    [anon_sym_BANG_TILDE] = ACTIONS(899),
    [anon_sym_LT_EQ] = ACTIONS(901),
    [anon_sym_GT] = ACTIONS(901),
    [anon_sym_GT_EQ] = ACTIONS(899),
    [anon_sym_CARET] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_SLASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(901),
    [sym_comment] = ACTIONS(87),
  },
  [6430] = {
    [sym__string_end] = ACTIONS(11999),
    [sym_comment] = ACTIONS(87),
  },
  [6431] = {
    [sym__heredoc_body_start] = ACTIONS(905),
    [sym__binary_minus] = ACTIONS(905),
    [sym__binary_star] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_DOT] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(905),
    [anon_sym_PIPE] = ACTIONS(907),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(907),
    [anon_sym_AMP] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_LT] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(905),
    [anon_sym_unless] = ACTIONS(905),
    [anon_sym_while] = ACTIONS(905),
    [anon_sym_until] = ACTIONS(905),
    [anon_sym_rescue] = ACTIONS(905),
    [anon_sym_in] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(905),
    [anon_sym_RBRACK] = ACTIONS(905),
    [anon_sym_COLON_COLON2] = ACTIONS(905),
    [anon_sym_AMP_DOT] = ACTIONS(905),
    [anon_sym_PLUS_EQ] = ACTIONS(905),
    [anon_sym_DASH_EQ] = ACTIONS(905),
    [anon_sym_STAR_EQ] = ACTIONS(905),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(905),
    [anon_sym_SLASH_EQ] = ACTIONS(905),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(905),
    [anon_sym_PIPE_EQ] = ACTIONS(905),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(905),
    [anon_sym_AMP_EQ] = ACTIONS(905),
    [anon_sym_PERCENT_EQ] = ACTIONS(905),
    [anon_sym_GT_GT_EQ] = ACTIONS(905),
    [anon_sym_LT_LT_EQ] = ACTIONS(905),
    [anon_sym_CARET_EQ] = ACTIONS(905),
    [anon_sym_QMARK] = ACTIONS(905),
    [anon_sym_COLON2] = ACTIONS(907),
    [anon_sym_DOT_DOT] = ACTIONS(907),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(905),
    [anon_sym_and] = ACTIONS(905),
    [anon_sym_or] = ACTIONS(905),
    [anon_sym_PIPE_PIPE] = ACTIONS(907),
    [anon_sym_AMP_AMP] = ACTIONS(907),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_GT_GT] = ACTIONS(907),
    [anon_sym_EQ_EQ] = ACTIONS(907),
    [anon_sym_BANG_EQ] = ACTIONS(905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(905),
    [anon_sym_LT_EQ_GT] = ACTIONS(905),
    [anon_sym_EQ_TILDE] = ACTIONS(905),
    [anon_sym_BANG_TILDE] = ACTIONS(905),
    [anon_sym_LT_EQ] = ACTIONS(907),
    [anon_sym_GT] = ACTIONS(907),
    [anon_sym_GT_EQ] = ACTIONS(905),
    [anon_sym_CARET] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_SLASH] = ACTIONS(907),
    [anon_sym_PERCENT] = ACTIONS(907),
    [sym_comment] = ACTIONS(87),
  },
  [6432] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(8599),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12001),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12003),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [6433] = {
    [aux_sym_string_array_repeat1] = STATE(8602),
    [sym__string_end] = ACTIONS(12005),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12007),
  },
  [6434] = {
    [sym__heredoc_body_start] = ACTIONS(923),
    [sym__binary_minus] = ACTIONS(923),
    [sym__binary_star] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(923),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_DOT] = ACTIONS(925),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_PIPE] = ACTIONS(925),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_STAR_STAR] = ACTIONS(925),
    [anon_sym_AMP] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(925),
    [anon_sym_LT] = ACTIONS(925),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_unless] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_until] = ACTIONS(923),
    [anon_sym_rescue] = ACTIONS(923),
    [anon_sym_in] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(923),
    [anon_sym_COLON_COLON2] = ACTIONS(923),
    [anon_sym_AMP_DOT] = ACTIONS(923),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_STAR_EQ] = ACTIONS(923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(923),
    [anon_sym_SLASH_EQ] = ACTIONS(923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(923),
    [anon_sym_PIPE_EQ] = ACTIONS(923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(923),
    [anon_sym_AMP_EQ] = ACTIONS(923),
    [anon_sym_PERCENT_EQ] = ACTIONS(923),
    [anon_sym_GT_GT_EQ] = ACTIONS(923),
    [anon_sym_LT_LT_EQ] = ACTIONS(923),
    [anon_sym_CARET_EQ] = ACTIONS(923),
    [anon_sym_QMARK] = ACTIONS(923),
    [anon_sym_COLON2] = ACTIONS(925),
    [anon_sym_DOT_DOT] = ACTIONS(925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(923),
    [anon_sym_and] = ACTIONS(923),
    [anon_sym_or] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(925),
    [anon_sym_AMP_AMP] = ACTIONS(925),
    [anon_sym_LT_LT] = ACTIONS(925),
    [anon_sym_GT_GT] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ_GT] = ACTIONS(923),
    [anon_sym_EQ_TILDE] = ACTIONS(923),
    [anon_sym_BANG_TILDE] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(925),
    [anon_sym_GT] = ACTIONS(925),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_CARET] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(925),
    [anon_sym_SLASH] = ACTIONS(925),
    [anon_sym_PERCENT] = ACTIONS(925),
    [sym_comment] = ACTIONS(87),
  },
  [6435] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(8605),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12009),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12011),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [6436] = {
    [aux_sym_symbol_array_repeat1] = STATE(8608),
    [sym__string_end] = ACTIONS(12013),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12015),
  },
  [6437] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6438] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_RPAREN] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_unless] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_until] = ACTIONS(993),
    [anon_sym_rescue] = ACTIONS(993),
    [anon_sym_in] = ACTIONS(993),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_RBRACK] = ACTIONS(993),
    [anon_sym_COLON_COLON2] = ACTIONS(993),
    [anon_sym_AMP_DOT] = ACTIONS(993),
    [anon_sym_PLUS_EQ] = ACTIONS(993),
    [anon_sym_DASH_EQ] = ACTIONS(993),
    [anon_sym_STAR_EQ] = ACTIONS(993),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(993),
    [anon_sym_SLASH_EQ] = ACTIONS(993),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(993),
    [anon_sym_PIPE_EQ] = ACTIONS(993),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(993),
    [anon_sym_AMP_EQ] = ACTIONS(993),
    [anon_sym_PERCENT_EQ] = ACTIONS(993),
    [anon_sym_GT_GT_EQ] = ACTIONS(993),
    [anon_sym_LT_LT_EQ] = ACTIONS(993),
    [anon_sym_CARET_EQ] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_COLON2] = ACTIONS(995),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(995),
    [anon_sym_AMP_AMP] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(995),
    [anon_sym_PERCENT] = ACTIONS(995),
    [sym_comment] = ACTIONS(87),
  },
  [6439] = {
    [anon_sym_RBRACE] = ACTIONS(12017),
    [sym_comment] = ACTIONS(87),
  },
  [6440] = {
    [sym_heredoc_body] = STATE(8610),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(12017),
    [sym_comment] = ACTIONS(87),
  },
  [6441] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8611),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(8611),
    [sym_operator_assignment] = STATE(8611),
    [sym_conditional] = STATE(8611),
    [sym_range] = STATE(8611),
    [sym_binary] = STATE(8611),
    [sym_unary] = STATE(8611),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6442] = {
    [sym__heredoc_body_start] = ACTIONS(1273),
    [sym__binary_minus] = ACTIONS(1273),
    [sym__binary_star] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [anon_sym_in] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1273),
    [anon_sym_or] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [sym_comment] = ACTIONS(87),
  },
  [6443] = {
    [anon_sym_DOT] = ACTIONS(12019),
    [anon_sym_COLON_COLON] = ACTIONS(12019),
    [sym_comment] = ACTIONS(87),
  },
  [6444] = {
    [sym_method_parameters] = STATE(8613),
    [sym__simple_formal_parameter] = STATE(684),
    [sym_splat_parameter] = STATE(684),
    [sym_hash_splat_parameter] = STATE(684),
    [sym_block_parameter] = STATE(684),
    [sym_keyword_parameter] = STATE(684),
    [sym_optional_parameter] = STATE(684),
    [sym_heredoc_body] = STATE(8613),
    [sym__terminator] = STATE(8613),
    [sym__line_break] = ACTIONS(12021),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(12021),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [6445] = {
    [sym__heredoc_body_start] = ACTIONS(1291),
    [sym__binary_minus] = ACTIONS(1291),
    [sym__binary_star] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_unless] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_until] = ACTIONS(1291),
    [anon_sym_rescue] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1291),
    [anon_sym_do] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_RBRACK] = ACTIONS(1291),
    [anon_sym_COLON_COLON2] = ACTIONS(1291),
    [anon_sym_AMP_DOT] = ACTIONS(1291),
    [anon_sym_PLUS_EQ] = ACTIONS(1291),
    [anon_sym_DASH_EQ] = ACTIONS(1291),
    [anon_sym_STAR_EQ] = ACTIONS(1291),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1291),
    [anon_sym_SLASH_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_PIPE_EQ] = ACTIONS(1291),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1291),
    [anon_sym_AMP_EQ] = ACTIONS(1291),
    [anon_sym_PERCENT_EQ] = ACTIONS(1291),
    [anon_sym_GT_GT_EQ] = ACTIONS(1291),
    [anon_sym_LT_LT_EQ] = ACTIONS(1291),
    [anon_sym_CARET_EQ] = ACTIONS(1291),
    [anon_sym_QMARK] = ACTIONS(1291),
    [anon_sym_COLON2] = ACTIONS(1293),
    [anon_sym_DOT_DOT] = ACTIONS(1293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1293),
    [anon_sym_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1291),
    [anon_sym_LT_EQ_GT] = ACTIONS(1291),
    [anon_sym_EQ_TILDE] = ACTIONS(1291),
    [anon_sym_BANG_TILDE] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_GT_EQ] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [sym_comment] = ACTIONS(87),
  },
  [6446] = {
    [anon_sym_RPAREN] = ACTIONS(12023),
    [sym_comment] = ACTIONS(87),
  },
  [6447] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8615),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(269),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(269),
    [sym_assignment] = STATE(8615),
    [sym_operator_assignment] = STATE(8615),
    [sym_conditional] = STATE(8615),
    [sym_range] = STATE(8615),
    [sym_binary] = STATE(8615),
    [sym_unary] = STATE(8615),
    [sym_left_assignment_list] = STATE(268),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(269),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(269),
    [sym_false] = STATE(269),
    [sym_nil] = STATE(269),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(270),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6448] = {
    [sym_superclass] = STATE(8616),
    [sym_heredoc_body] = STATE(8617),
    [sym__terminator] = STATE(8617),
    [sym__line_break] = ACTIONS(12025),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(12025),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6449] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_superclass] = STATE(8616),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(8617),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(8617),
    [sym__line_break] = ACTIONS(12025),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(12025),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6450] = {
    [sym_heredoc_body] = STATE(8619),
    [sym__terminator] = STATE(8619),
    [sym__line_break] = ACTIONS(12027),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(12027),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(12029),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6451] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(858),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_argument_list] = STATE(831),
    [sym__argument_list_with_parens] = STATE(859),
    [sym__argument] = STATE(860),
    [sym_splat_argument] = STATE(860),
    [sym_hash_splat_argument] = STATE(860),
    [sym_block_argument] = STATE(860),
    [sym_do_block] = STATE(834),
    [sym_block] = STATE(834),
    [sym_assignment] = STATE(858),
    [sym_operator_assignment] = STATE(858),
    [sym_conditional] = STATE(858),
    [sym_range] = STATE(858),
    [sym_binary] = STATE(858),
    [sym_unary] = STATE(858),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(863),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(8619),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(860),
    [sym_lambda] = STATE(348),
    [sym__terminator] = STATE(8619),
    [sym__line_break] = ACTIONS(12027),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1523),
    [sym__splat_star] = ACTIONS(1525),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1531),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(745),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(12027),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(12029),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1475),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(1551),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6452] = {
    [sym__heredoc_body_start] = ACTIONS(1679),
    [sym__binary_minus] = ACTIONS(1679),
    [sym__binary_star] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_unless] = ACTIONS(1679),
    [anon_sym_while] = ACTIONS(1679),
    [anon_sym_until] = ACTIONS(1679),
    [anon_sym_rescue] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(1679),
    [anon_sym_do] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_RBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1679),
    [anon_sym_AMP_DOT] = ACTIONS(1679),
    [anon_sym_PLUS_EQ] = ACTIONS(1679),
    [anon_sym_DASH_EQ] = ACTIONS(1679),
    [anon_sym_STAR_EQ] = ACTIONS(1679),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1679),
    [anon_sym_SLASH_EQ] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1679),
    [anon_sym_PIPE_EQ] = ACTIONS(1679),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1679),
    [anon_sym_AMP_EQ] = ACTIONS(1679),
    [anon_sym_PERCENT_EQ] = ACTIONS(1679),
    [anon_sym_GT_GT_EQ] = ACTIONS(1679),
    [anon_sym_LT_LT_EQ] = ACTIONS(1679),
    [anon_sym_CARET_EQ] = ACTIONS(1679),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_COLON2] = ACTIONS(1681),
    [anon_sym_DOT_DOT] = ACTIONS(1681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1679),
    [anon_sym_and] = ACTIONS(1679),
    [anon_sym_or] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_BANG_EQ] = ACTIONS(1679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1679),
    [anon_sym_LT_EQ_GT] = ACTIONS(1679),
    [anon_sym_EQ_TILDE] = ACTIONS(1679),
    [anon_sym_BANG_TILDE] = ACTIONS(1679),
    [anon_sym_LT_EQ] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1679),
    [anon_sym_CARET] = ACTIONS(1681),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(87),
  },
  [6453] = {
    [sym__heredoc_body_start] = ACTIONS(1699),
    [sym__binary_minus] = ACTIONS(1699),
    [sym__binary_star] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_in] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_PLUS_EQ] = ACTIONS(1699),
    [anon_sym_DASH_EQ] = ACTIONS(1699),
    [anon_sym_STAR_EQ] = ACTIONS(1699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1699),
    [anon_sym_SLASH_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1699),
    [anon_sym_AMP_EQ] = ACTIONS(1699),
    [anon_sym_PERCENT_EQ] = ACTIONS(1699),
    [anon_sym_GT_GT_EQ] = ACTIONS(1699),
    [anon_sym_LT_LT_EQ] = ACTIONS(1699),
    [anon_sym_CARET_EQ] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_COLON2] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [6454] = {
    [sym__heredoc_body_start] = ACTIONS(1703),
    [sym__binary_minus] = ACTIONS(1703),
    [sym__binary_star] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1705),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1705),
    [anon_sym_EQ] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1705),
    [anon_sym_DOT_DOT] = ACTIONS(1705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1705),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1705),
    [anon_sym_GT] = ACTIONS(1705),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1705),
    [anon_sym_PLUS] = ACTIONS(1705),
    [anon_sym_SLASH] = ACTIONS(1705),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [sym_comment] = ACTIONS(87),
  },
  [6455] = {
    [sym__heredoc_body_start] = ACTIONS(1707),
    [sym__binary_minus] = ACTIONS(1707),
    [sym__binary_star] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_RPAREN] = ACTIONS(1707),
    [anon_sym_DOT] = ACTIONS(1709),
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1709),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_EQ] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_if] = ACTIONS(1707),
    [anon_sym_unless] = ACTIONS(1707),
    [anon_sym_while] = ACTIONS(1707),
    [anon_sym_until] = ACTIONS(1707),
    [anon_sym_rescue] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1707),
    [anon_sym_COLON_COLON2] = ACTIONS(1707),
    [anon_sym_AMP_DOT] = ACTIONS(1707),
    [anon_sym_PLUS_EQ] = ACTIONS(1707),
    [anon_sym_DASH_EQ] = ACTIONS(1707),
    [anon_sym_STAR_EQ] = ACTIONS(1707),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1707),
    [anon_sym_SLASH_EQ] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1707),
    [anon_sym_PIPE_EQ] = ACTIONS(1707),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1707),
    [anon_sym_AMP_EQ] = ACTIONS(1707),
    [anon_sym_PERCENT_EQ] = ACTIONS(1707),
    [anon_sym_GT_GT_EQ] = ACTIONS(1707),
    [anon_sym_LT_LT_EQ] = ACTIONS(1707),
    [anon_sym_CARET_EQ] = ACTIONS(1707),
    [anon_sym_QMARK] = ACTIONS(1707),
    [anon_sym_COLON2] = ACTIONS(1709),
    [anon_sym_DOT_DOT] = ACTIONS(1709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1707),
    [anon_sym_and] = ACTIONS(1707),
    [anon_sym_or] = ACTIONS(1707),
    [anon_sym_PIPE_PIPE] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(1709),
    [anon_sym_GT_GT] = ACTIONS(1709),
    [anon_sym_EQ_EQ] = ACTIONS(1709),
    [anon_sym_BANG_EQ] = ACTIONS(1707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1707),
    [anon_sym_LT_EQ_GT] = ACTIONS(1707),
    [anon_sym_EQ_TILDE] = ACTIONS(1707),
    [anon_sym_BANG_TILDE] = ACTIONS(1707),
    [anon_sym_LT_EQ] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(1709),
    [anon_sym_GT_EQ] = ACTIONS(1707),
    [anon_sym_CARET] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_SLASH] = ACTIONS(1709),
    [anon_sym_PERCENT] = ACTIONS(1709),
    [sym_comment] = ACTIONS(87),
  },
  [6456] = {
    [sym__then] = STATE(8620),
    [sym_heredoc_body] = STATE(979),
    [sym__terminator] = STATE(979),
    [sym__line_break] = ACTIONS(1743),
    [sym__heredoc_body_start] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(12031),
    [sym_comment] = ACTIONS(87),
  },
  [6457] = {
    [sym__then] = STATE(8621),
    [sym_heredoc_body] = STATE(1013),
    [sym__terminator] = STATE(1013),
    [sym__line_break] = ACTIONS(1823),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_if] = ACTIONS(1747),
    [anon_sym_unless] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_until] = ACTIONS(1753),
    [anon_sym_rescue] = ACTIONS(1755),
    [anon_sym_then] = ACTIONS(12033),
    [sym_comment] = ACTIONS(87),
  },
  [6458] = {
    [sym__do] = STATE(8622),
    [sym_heredoc_body] = STATE(8622),
    [sym__terminator] = STATE(8622),
    [sym__line_break] = ACTIONS(12035),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(12035),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(12035),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [6459] = {
    [sym__do] = STATE(8623),
    [sym_heredoc_body] = STATE(8623),
    [sym__terminator] = STATE(8623),
    [sym__line_break] = ACTIONS(12037),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(12037),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(12037),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(1875),
    [anon_sym_or] = ACTIONS(1875),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [6460] = {
    [sym_in] = STATE(8624),
    [anon_sym_in] = ACTIONS(1969),
    [sym_comment] = ACTIONS(87),
  },
  [6461] = {
    [sym_heredoc_body] = STATE(8625),
    [sym__terminator] = STATE(8625),
    [sym__line_break] = ACTIONS(12039),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(12039),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [6462] = {
    [sym_when] = STATE(8626),
    [aux_sym_case_repeat1] = STATE(8627),
    [anon_sym_SEMI] = ACTIONS(12041),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6463] = {
    [sym_else] = STATE(8629),
    [sym_ensure] = STATE(8630),
    [sym_rescue] = STATE(8631),
    [anon_sym_end] = ACTIONS(12043),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [6464] = {
    [sym_ensure] = STATE(8630),
    [anon_sym_end] = ACTIONS(12043),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [6465] = {
    [anon_sym_end] = ACTIONS(12043),
    [sym_comment] = ACTIONS(87),
  },
  [6466] = {
    [sym_else] = STATE(8629),
    [sym_ensure] = STATE(8630),
    [anon_sym_end] = ACTIONS(12043),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [6467] = {
    [sym__heredoc_body_start] = ACTIONS(2187),
    [sym__binary_minus] = ACTIONS(2187),
    [sym__binary_star] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2189),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_STAR_STAR] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_EQ] = ACTIONS(2189),
    [anon_sym_LT] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_unless] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_until] = ACTIONS(2187),
    [anon_sym_rescue] = ACTIONS(2187),
    [anon_sym_in] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_RBRACK] = ACTIONS(2187),
    [anon_sym_COLON_COLON2] = ACTIONS(2187),
    [anon_sym_AMP_DOT] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_COLON2] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_and] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_LT_LT] = ACTIONS(2189),
    [anon_sym_GT_GT] = ACTIONS(2189),
    [anon_sym_EQ_EQ] = ACTIONS(2189),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_EQ_TILDE] = ACTIONS(2187),
    [anon_sym_BANG_TILDE] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2189),
    [anon_sym_GT] = ACTIONS(2189),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_SLASH] = ACTIONS(2189),
    [anon_sym_PERCENT] = ACTIONS(2189),
    [sym_comment] = ACTIONS(87),
  },
  [6468] = {
    [sym__statements] = STATE(6463),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(6464),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(6465),
    [sym_rescue] = STATE(6466),
    [sym__body_statement] = STATE(8632),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12045),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6469] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9719),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [6470] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(937),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6471] = {
    [sym__heredoc_body_start] = ACTIONS(2267),
    [sym__binary_minus] = ACTIONS(2267),
    [sym__binary_star] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2267),
    [anon_sym_RPAREN] = ACTIONS(2267),
    [anon_sym_DOT] = ACTIONS(2269),
    [anon_sym_COMMA] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(2269),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_STAR_STAR] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2269),
    [anon_sym_EQ] = ACTIONS(2269),
    [anon_sym_LT] = ACTIONS(2269),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_unless] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_until] = ACTIONS(2267),
    [anon_sym_rescue] = ACTIONS(2267),
    [anon_sym_in] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_RBRACK] = ACTIONS(2267),
    [anon_sym_COLON_COLON2] = ACTIONS(2267),
    [anon_sym_AMP_DOT] = ACTIONS(2267),
    [anon_sym_PLUS_EQ] = ACTIONS(2267),
    [anon_sym_DASH_EQ] = ACTIONS(2267),
    [anon_sym_STAR_EQ] = ACTIONS(2267),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2267),
    [anon_sym_SLASH_EQ] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2267),
    [anon_sym_PIPE_EQ] = ACTIONS(2267),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2267),
    [anon_sym_AMP_EQ] = ACTIONS(2267),
    [anon_sym_PERCENT_EQ] = ACTIONS(2267),
    [anon_sym_GT_GT_EQ] = ACTIONS(2267),
    [anon_sym_LT_LT_EQ] = ACTIONS(2267),
    [anon_sym_CARET_EQ] = ACTIONS(2267),
    [anon_sym_QMARK] = ACTIONS(2267),
    [anon_sym_COLON2] = ACTIONS(2269),
    [anon_sym_DOT_DOT] = ACTIONS(2269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2267),
    [anon_sym_and] = ACTIONS(2267),
    [anon_sym_or] = ACTIONS(2267),
    [anon_sym_PIPE_PIPE] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_LT_LT] = ACTIONS(2269),
    [anon_sym_GT_GT] = ACTIONS(2269),
    [anon_sym_EQ_EQ] = ACTIONS(2269),
    [anon_sym_BANG_EQ] = ACTIONS(2267),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2267),
    [anon_sym_LT_EQ_GT] = ACTIONS(2267),
    [anon_sym_EQ_TILDE] = ACTIONS(2267),
    [anon_sym_BANG_TILDE] = ACTIONS(2267),
    [anon_sym_LT_EQ] = ACTIONS(2269),
    [anon_sym_GT] = ACTIONS(2269),
    [anon_sym_GT_EQ] = ACTIONS(2267),
    [anon_sym_CARET] = ACTIONS(2269),
    [anon_sym_PLUS] = ACTIONS(2269),
    [anon_sym_SLASH] = ACTIONS(2269),
    [anon_sym_PERCENT] = ACTIONS(2269),
    [sym_comment] = ACTIONS(87),
  },
  [6472] = {
    [sym__heredoc_body_start] = ACTIONS(2351),
    [sym__binary_minus] = ACTIONS(2351),
    [sym__binary_star] = ACTIONS(2351),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_DOT] = ACTIONS(2353),
    [anon_sym_COMMA] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI] = ACTIONS(2351),
    [anon_sym_STAR_STAR] = ACTIONS(2353),
    [anon_sym_AMP] = ACTIONS(2353),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_if] = ACTIONS(2351),
    [anon_sym_unless] = ACTIONS(2351),
    [anon_sym_while] = ACTIONS(2351),
    [anon_sym_until] = ACTIONS(2351),
    [anon_sym_rescue] = ACTIONS(2351),
    [anon_sym_in] = ACTIONS(2351),
    [anon_sym_do] = ACTIONS(2351),
    [anon_sym_LBRACK] = ACTIONS(2351),
    [anon_sym_RBRACK] = ACTIONS(2351),
    [anon_sym_COLON_COLON2] = ACTIONS(2351),
    [anon_sym_AMP_DOT] = ACTIONS(2351),
    [anon_sym_PLUS_EQ] = ACTIONS(2351),
    [anon_sym_DASH_EQ] = ACTIONS(2351),
    [anon_sym_STAR_EQ] = ACTIONS(2351),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2351),
    [anon_sym_SLASH_EQ] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2351),
    [anon_sym_PIPE_EQ] = ACTIONS(2351),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2351),
    [anon_sym_AMP_EQ] = ACTIONS(2351),
    [anon_sym_PERCENT_EQ] = ACTIONS(2351),
    [anon_sym_GT_GT_EQ] = ACTIONS(2351),
    [anon_sym_LT_LT_EQ] = ACTIONS(2351),
    [anon_sym_CARET_EQ] = ACTIONS(2351),
    [anon_sym_QMARK] = ACTIONS(2351),
    [anon_sym_COLON2] = ACTIONS(2353),
    [anon_sym_DOT_DOT] = ACTIONS(2353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2351),
    [anon_sym_and] = ACTIONS(2351),
    [anon_sym_or] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2353),
    [anon_sym_AMP_AMP] = ACTIONS(2353),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ_GT] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_BANG_TILDE] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_CARET] = ACTIONS(2353),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_SLASH] = ACTIONS(2353),
    [anon_sym_PERCENT] = ACTIONS(2353),
    [sym_comment] = ACTIONS(87),
  },
  [6473] = {
    [sym_heredoc_body] = STATE(8634),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(12047),
    [sym_comment] = ACTIONS(87),
  },
  [6474] = {
    [anon_sym_RBRACK] = ACTIONS(12047),
    [sym_comment] = ACTIONS(87),
  },
  [6475] = {
    [sym_do_block] = STATE(8635),
    [sym_block] = STATE(8635),
    [anon_sym_LBRACE] = ACTIONS(6709),
    [anon_sym_do] = ACTIONS(6711),
    [sym_comment] = ACTIONS(87),
  },
  [6476] = {
    [sym__heredoc_body_start] = ACTIONS(2491),
    [sym__binary_minus] = ACTIONS(2491),
    [sym__binary_star] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_DOT] = ACTIONS(2493),
    [anon_sym_COMMA] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_STAR_STAR] = ACTIONS(2493),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_EQ] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_unless] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_until] = ACTIONS(2491),
    [anon_sym_rescue] = ACTIONS(2491),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2491),
    [anon_sym_RBRACK] = ACTIONS(2491),
    [anon_sym_COLON_COLON2] = ACTIONS(2491),
    [anon_sym_AMP_DOT] = ACTIONS(2491),
    [anon_sym_PLUS_EQ] = ACTIONS(2491),
    [anon_sym_DASH_EQ] = ACTIONS(2491),
    [anon_sym_STAR_EQ] = ACTIONS(2491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2491),
    [anon_sym_SLASH_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_EQ] = ACTIONS(2491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2491),
    [anon_sym_AMP_EQ] = ACTIONS(2491),
    [anon_sym_PERCENT_EQ] = ACTIONS(2491),
    [anon_sym_GT_GT_EQ] = ACTIONS(2491),
    [anon_sym_LT_LT_EQ] = ACTIONS(2491),
    [anon_sym_CARET_EQ] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2491),
    [anon_sym_COLON2] = ACTIONS(2493),
    [anon_sym_DOT_DOT] = ACTIONS(2493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2491),
    [anon_sym_and] = ACTIONS(2491),
    [anon_sym_or] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE] = ACTIONS(2493),
    [anon_sym_AMP_AMP] = ACTIONS(2493),
    [anon_sym_LT_LT] = ACTIONS(2493),
    [anon_sym_GT_GT] = ACTIONS(2493),
    [anon_sym_EQ_EQ] = ACTIONS(2493),
    [anon_sym_BANG_EQ] = ACTIONS(2491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ_GT] = ACTIONS(2491),
    [anon_sym_EQ_TILDE] = ACTIONS(2491),
    [anon_sym_BANG_TILDE] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_GT_EQ] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2493),
    [anon_sym_PLUS] = ACTIONS(2493),
    [anon_sym_SLASH] = ACTIONS(2493),
    [anon_sym_PERCENT] = ACTIONS(2493),
    [sym_comment] = ACTIONS(87),
  },
  [6477] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8636),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(8636),
    [sym_operator_assignment] = STATE(8636),
    [sym_conditional] = STATE(8636),
    [sym_range] = STATE(8636),
    [sym_binary] = STATE(8636),
    [sym_unary] = STATE(8636),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6478] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8637),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(8637),
    [sym_operator_assignment] = STATE(8637),
    [sym_conditional] = STATE(8637),
    [sym_range] = STATE(8637),
    [sym_binary] = STATE(8637),
    [sym_unary] = STATE(8637),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6479] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8638),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(8638),
    [sym_operator_assignment] = STATE(8638),
    [sym_conditional] = STATE(8638),
    [sym_range] = STATE(8638),
    [sym_binary] = STATE(8638),
    [sym_unary] = STATE(8638),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6480] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8639),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(8639),
    [sym_operator_assignment] = STATE(8639),
    [sym_conditional] = STATE(8639),
    [sym_range] = STATE(8639),
    [sym_binary] = STATE(8639),
    [sym_unary] = STATE(8639),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6481] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8640),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(8640),
    [sym_operator_assignment] = STATE(8640),
    [sym_conditional] = STATE(8640),
    [sym_range] = STATE(8640),
    [sym_binary] = STATE(8640),
    [sym_unary] = STATE(8640),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6482] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8641),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8641),
    [sym_operator_assignment] = STATE(8641),
    [sym_conditional] = STATE(8641),
    [sym_range] = STATE(8641),
    [sym_binary] = STATE(8641),
    [sym_unary] = STATE(8641),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6483] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8642),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(8642),
    [sym_operator_assignment] = STATE(8642),
    [sym_conditional] = STATE(8642),
    [sym_range] = STATE(8642),
    [sym_binary] = STATE(8642),
    [sym_unary] = STATE(8642),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6484] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8643),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(8643),
    [sym_operator_assignment] = STATE(8643),
    [sym_conditional] = STATE(8643),
    [sym_range] = STATE(8643),
    [sym_binary] = STATE(8643),
    [sym_unary] = STATE(8643),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6485] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8644),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(8644),
    [sym_operator_assignment] = STATE(8644),
    [sym_conditional] = STATE(8644),
    [sym_range] = STATE(8644),
    [sym_binary] = STATE(8644),
    [sym_unary] = STATE(8644),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6486] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8645),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(8645),
    [sym_operator_assignment] = STATE(8645),
    [sym_conditional] = STATE(8645),
    [sym_range] = STATE(8645),
    [sym_binary] = STATE(8645),
    [sym_unary] = STATE(8645),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6487] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8646),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_splat_argument] = STATE(8648),
    [sym_assignment] = STATE(8646),
    [sym_operator_assignment] = STATE(8646),
    [sym_conditional] = STATE(8646),
    [sym_range] = STATE(8646),
    [sym_binary] = STATE(8646),
    [sym_unary] = STATE(8646),
    [sym_right_assignment_list] = STATE(8647),
    [sym__arg_or_splat_arg] = STATE(8648),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6488] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8649),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(8649),
    [sym_operator_assignment] = STATE(8649),
    [sym_conditional] = STATE(8649),
    [sym_range] = STATE(8649),
    [sym_binary] = STATE(8649),
    [sym_unary] = STATE(8649),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6489] = {
    [sym_string] = STATE(8650),
    [aux_sym_chained_string_repeat1] = STATE(8650),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [6490] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(9719),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [6491] = {
    [sym__binary_minus] = ACTIONS(9172),
    [sym__binary_star] = ACTIONS(9172),
    [anon_sym_LBRACE] = ACTIONS(9172),
    [anon_sym_RBRACE] = ACTIONS(9172),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9174),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9174),
    [anon_sym_SEMI] = ACTIONS(9172),
    [anon_sym_STAR_STAR] = ACTIONS(9174),
    [anon_sym_AMP] = ACTIONS(9174),
    [anon_sym_EQ] = ACTIONS(9174),
    [anon_sym_LT] = ACTIONS(9174),
    [anon_sym_if] = ACTIONS(9172),
    [anon_sym_unless] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(9172),
    [anon_sym_until] = ACTIONS(9172),
    [anon_sym_rescue] = ACTIONS(9172),
    [anon_sym_do] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [anon_sym_PLUS_EQ] = ACTIONS(9172),
    [anon_sym_DASH_EQ] = ACTIONS(9172),
    [anon_sym_STAR_EQ] = ACTIONS(9172),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9172),
    [anon_sym_SLASH_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9172),
    [anon_sym_AMP_EQ] = ACTIONS(9172),
    [anon_sym_PERCENT_EQ] = ACTIONS(9172),
    [anon_sym_GT_GT_EQ] = ACTIONS(9172),
    [anon_sym_LT_LT_EQ] = ACTIONS(9172),
    [anon_sym_CARET_EQ] = ACTIONS(9172),
    [anon_sym_QMARK] = ACTIONS(9172),
    [anon_sym_COLON2] = ACTIONS(9174),
    [anon_sym_DOT_DOT] = ACTIONS(9174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9172),
    [anon_sym_and] = ACTIONS(9172),
    [anon_sym_or] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE] = ACTIONS(9174),
    [anon_sym_AMP_AMP] = ACTIONS(9174),
    [anon_sym_LT_LT] = ACTIONS(9174),
    [anon_sym_GT_GT] = ACTIONS(9174),
    [anon_sym_EQ_EQ] = ACTIONS(9174),
    [anon_sym_BANG_EQ] = ACTIONS(9172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9172),
    [anon_sym_LT_EQ_GT] = ACTIONS(9172),
    [anon_sym_EQ_TILDE] = ACTIONS(9172),
    [anon_sym_BANG_TILDE] = ACTIONS(9172),
    [anon_sym_LT_EQ] = ACTIONS(9174),
    [anon_sym_GT] = ACTIONS(9174),
    [anon_sym_GT_EQ] = ACTIONS(9172),
    [anon_sym_CARET] = ACTIONS(9174),
    [anon_sym_PLUS] = ACTIONS(9174),
    [anon_sym_SLASH] = ACTIONS(9174),
    [anon_sym_PERCENT] = ACTIONS(9174),
    [sym_comment] = ACTIONS(87),
  },
  [6492] = {
    [anon_sym_RBRACE] = ACTIONS(12049),
    [sym_comment] = ACTIONS(87),
  },
  [6493] = {
    [sym__binary_minus] = ACTIONS(9192),
    [sym__binary_star] = ACTIONS(9192),
    [anon_sym_LBRACE] = ACTIONS(9192),
    [anon_sym_RBRACE] = ACTIONS(9192),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9194),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9194),
    [anon_sym_SEMI] = ACTIONS(9192),
    [anon_sym_STAR_STAR] = ACTIONS(9194),
    [anon_sym_AMP] = ACTIONS(9194),
    [anon_sym_EQ] = ACTIONS(9194),
    [anon_sym_LT] = ACTIONS(9194),
    [anon_sym_if] = ACTIONS(9192),
    [anon_sym_unless] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(9192),
    [anon_sym_until] = ACTIONS(9192),
    [anon_sym_rescue] = ACTIONS(9192),
    [anon_sym_do] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [anon_sym_PLUS_EQ] = ACTIONS(9192),
    [anon_sym_DASH_EQ] = ACTIONS(9192),
    [anon_sym_STAR_EQ] = ACTIONS(9192),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9192),
    [anon_sym_SLASH_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9192),
    [anon_sym_AMP_EQ] = ACTIONS(9192),
    [anon_sym_PERCENT_EQ] = ACTIONS(9192),
    [anon_sym_GT_GT_EQ] = ACTIONS(9192),
    [anon_sym_LT_LT_EQ] = ACTIONS(9192),
    [anon_sym_CARET_EQ] = ACTIONS(9192),
    [anon_sym_QMARK] = ACTIONS(9192),
    [anon_sym_COLON2] = ACTIONS(9194),
    [anon_sym_DOT_DOT] = ACTIONS(9194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9192),
    [anon_sym_and] = ACTIONS(9192),
    [anon_sym_or] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE] = ACTIONS(9194),
    [anon_sym_AMP_AMP] = ACTIONS(9194),
    [anon_sym_LT_LT] = ACTIONS(9194),
    [anon_sym_GT_GT] = ACTIONS(9194),
    [anon_sym_EQ_EQ] = ACTIONS(9194),
    [anon_sym_BANG_EQ] = ACTIONS(9192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9192),
    [anon_sym_LT_EQ_GT] = ACTIONS(9192),
    [anon_sym_EQ_TILDE] = ACTIONS(9192),
    [anon_sym_BANG_TILDE] = ACTIONS(9192),
    [anon_sym_LT_EQ] = ACTIONS(9194),
    [anon_sym_GT] = ACTIONS(9194),
    [anon_sym_GT_EQ] = ACTIONS(9192),
    [anon_sym_CARET] = ACTIONS(9194),
    [anon_sym_PLUS] = ACTIONS(9194),
    [anon_sym_SLASH] = ACTIONS(9194),
    [anon_sym_PERCENT] = ACTIONS(9194),
    [sym_comment] = ACTIONS(87),
  },
  [6494] = {
    [anon_sym_end] = ACTIONS(12051),
    [sym_comment] = ACTIONS(87),
  },
  [6495] = {
    [sym__statements] = STATE(8653),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12053),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6496] = {
    [sym__statements] = STATE(8653),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(8654),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(8654),
    [sym__line_break] = ACTIONS(12055),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12053),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6497] = {
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR_STAR] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7608),
    [anon_sym_unless] = ACTIONS(7608),
    [anon_sym_while] = ACTIONS(7608),
    [anon_sym_until] = ACTIONS(7608),
    [anon_sym_rescue] = ACTIONS(7608),
    [anon_sym_in] = ACTIONS(7608),
    [anon_sym_do] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_RBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_PLUS_EQ] = ACTIONS(7608),
    [anon_sym_DASH_EQ] = ACTIONS(7608),
    [anon_sym_STAR_EQ] = ACTIONS(7608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7608),
    [anon_sym_SLASH_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7608),
    [anon_sym_AMP_EQ] = ACTIONS(7608),
    [anon_sym_PERCENT_EQ] = ACTIONS(7608),
    [anon_sym_GT_GT_EQ] = ACTIONS(7608),
    [anon_sym_LT_LT_EQ] = ACTIONS(7608),
    [anon_sym_CARET_EQ] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7608),
    [anon_sym_COLON2] = ACTIONS(7610),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7608),
    [anon_sym_or] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE] = ACTIONS(7610),
    [anon_sym_AMP_AMP] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [sym_comment] = ACTIONS(87),
  },
  [6498] = {
    [anon_sym_RPAREN] = ACTIONS(12057),
    [sym_comment] = ACTIONS(87),
  },
  [6499] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(9719),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [6500] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6501] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [6502] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6503] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6504] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6505] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12059),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6506] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6507] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6508] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6509] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6510] = {
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_COLON2] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [6511] = {
    [sym__heredoc_body_start] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__binary_star] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(4854),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(4854),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_STAR_STAR] = ACTIONS(4854),
    [anon_sym_AMP] = ACTIONS(4854),
    [anon_sym_EQ] = ACTIONS(4854),
    [anon_sym_LT] = ACTIONS(4854),
    [anon_sym_if] = ACTIONS(3102),
    [anon_sym_unless] = ACTIONS(3102),
    [anon_sym_while] = ACTIONS(3102),
    [anon_sym_until] = ACTIONS(3102),
    [anon_sym_rescue] = ACTIONS(3102),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_RBRACK] = ACTIONS(3102),
    [anon_sym_COLON_COLON2] = ACTIONS(3102),
    [anon_sym_AMP_DOT] = ACTIONS(3102),
    [anon_sym_PLUS_EQ] = ACTIONS(3102),
    [anon_sym_DASH_EQ] = ACTIONS(3102),
    [anon_sym_STAR_EQ] = ACTIONS(3102),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3102),
    [anon_sym_SLASH_EQ] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3102),
    [anon_sym_PIPE_EQ] = ACTIONS(3102),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3102),
    [anon_sym_AMP_EQ] = ACTIONS(3102),
    [anon_sym_PERCENT_EQ] = ACTIONS(3102),
    [anon_sym_GT_GT_EQ] = ACTIONS(3102),
    [anon_sym_LT_LT_EQ] = ACTIONS(3102),
    [anon_sym_CARET_EQ] = ACTIONS(3102),
    [anon_sym_QMARK] = ACTIONS(3102),
    [anon_sym_COLON2] = ACTIONS(4854),
    [anon_sym_DOT_DOT] = ACTIONS(4854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_and] = ACTIONS(3102),
    [anon_sym_or] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(4854),
    [anon_sym_AMP_AMP] = ACTIONS(4854),
    [anon_sym_LT_LT] = ACTIONS(4854),
    [anon_sym_GT_GT] = ACTIONS(4854),
    [anon_sym_EQ_EQ] = ACTIONS(4854),
    [anon_sym_BANG_EQ] = ACTIONS(3102),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
    [anon_sym_LT_EQ_GT] = ACTIONS(3102),
    [anon_sym_EQ_TILDE] = ACTIONS(3102),
    [anon_sym_BANG_TILDE] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(4854),
    [anon_sym_GT] = ACTIONS(4854),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(4854),
    [anon_sym_PLUS] = ACTIONS(4854),
    [anon_sym_SLASH] = ACTIONS(4854),
    [anon_sym_PERCENT] = ACTIONS(4854),
    [sym_comment] = ACTIONS(87),
  },
  [6512] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(12061),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [6513] = {
    [sym_heredoc_body] = STATE(6513),
    [aux_sym_call_repeat1] = STATE(6513),
    [sym__heredoc_body_start] = ACTIONS(12063),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [6514] = {
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(7657),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_in] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_RBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_COLON2] = ACTIONS(7659),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [6515] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1660),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(1660),
    [sym_operator_assignment] = STATE(1660),
    [sym_conditional] = STATE(1660),
    [sym_range] = STATE(1660),
    [sym_binary] = STATE(1660),
    [sym_unary] = STATE(1660),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1668),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(2853),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__identifier_hash_key] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9757),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2883),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6516] = {
    [sym_heredoc_body] = STATE(6513),
    [aux_sym_call_repeat1] = STATE(6513),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [6517] = {
    [aux_sym_argument_list_repeat1] = STATE(6517),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12066),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [6518] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6519] = {
    [aux_sym_exceptions_repeat1] = STATE(8660),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [6520] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [6521] = {
    [sym_string] = STATE(6521),
    [aux_sym_chained_string_repeat1] = STATE(6521),
    [sym__string_start] = ACTIONS(10160),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [6522] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9763),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(9765),
    [anon_sym_LT] = ACTIONS(9767),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(9769),
    [anon_sym_DOT_DOT] = ACTIONS(9771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9773),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(9775),
    [anon_sym_AMP_AMP] = ACTIONS(9775),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_BANG_EQ] = ACTIONS(9775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9775),
    [anon_sym_LT_EQ_GT] = ACTIONS(9775),
    [anon_sym_EQ_TILDE] = ACTIONS(9775),
    [anon_sym_BANG_TILDE] = ACTIONS(9775),
    [anon_sym_LT_EQ] = ACTIONS(9767),
    [anon_sym_GT] = ACTIONS(9767),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9783),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [6523] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6524] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9763),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(9765),
    [anon_sym_LT] = ACTIONS(9767),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9769),
    [anon_sym_DOT_DOT] = ACTIONS(9771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9773),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9775),
    [anon_sym_AMP_AMP] = ACTIONS(9775),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_BANG_EQ] = ACTIONS(9775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9775),
    [anon_sym_LT_EQ_GT] = ACTIONS(9775),
    [anon_sym_EQ_TILDE] = ACTIONS(9775),
    [anon_sym_BANG_TILDE] = ACTIONS(9775),
    [anon_sym_LT_EQ] = ACTIONS(9767),
    [anon_sym_GT] = ACTIONS(9767),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9783),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [6525] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8661),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(8661),
    [sym_operator_assignment] = STATE(8661),
    [sym_conditional] = STATE(8661),
    [sym_range] = STATE(8661),
    [sym_binary] = STATE(8661),
    [sym_unary] = STATE(8661),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6526] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8662),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(8662),
    [sym_operator_assignment] = STATE(8662),
    [sym_conditional] = STATE(8662),
    [sym_range] = STATE(8662),
    [sym_binary] = STATE(8662),
    [sym_unary] = STATE(8662),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6527] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8663),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(8663),
    [sym_operator_assignment] = STATE(8663),
    [sym_conditional] = STATE(8663),
    [sym_range] = STATE(8663),
    [sym_binary] = STATE(8663),
    [sym_unary] = STATE(8663),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6528] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8664),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(8664),
    [sym_operator_assignment] = STATE(8664),
    [sym_conditional] = STATE(8664),
    [sym_range] = STATE(8664),
    [sym_binary] = STATE(8664),
    [sym_unary] = STATE(8664),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6529] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8665),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(8665),
    [sym_operator_assignment] = STATE(8665),
    [sym_conditional] = STATE(8665),
    [sym_range] = STATE(8665),
    [sym_binary] = STATE(8665),
    [sym_unary] = STATE(8665),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6530] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8666),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8666),
    [sym_operator_assignment] = STATE(8666),
    [sym_conditional] = STATE(8666),
    [sym_range] = STATE(8666),
    [sym_binary] = STATE(8666),
    [sym_unary] = STATE(8666),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6531] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8667),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(8667),
    [sym_operator_assignment] = STATE(8667),
    [sym_conditional] = STATE(8667),
    [sym_range] = STATE(8667),
    [sym_binary] = STATE(8667),
    [sym_unary] = STATE(8667),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6532] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8668),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(8668),
    [sym_operator_assignment] = STATE(8668),
    [sym_conditional] = STATE(8668),
    [sym_range] = STATE(8668),
    [sym_binary] = STATE(8668),
    [sym_unary] = STATE(8668),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6533] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8669),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(8669),
    [sym_operator_assignment] = STATE(8669),
    [sym_conditional] = STATE(8669),
    [sym_range] = STATE(8669),
    [sym_binary] = STATE(8669),
    [sym_unary] = STATE(8669),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6534] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8670),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(8670),
    [sym_operator_assignment] = STATE(8670),
    [sym_conditional] = STATE(8670),
    [sym_range] = STATE(8670),
    [sym_binary] = STATE(8670),
    [sym_unary] = STATE(8670),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6535] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3906),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_splat_argument] = STATE(6835),
    [sym_assignment] = STATE(3906),
    [sym_operator_assignment] = STATE(3906),
    [sym_conditional] = STATE(3906),
    [sym_range] = STATE(3906),
    [sym_binary] = STATE(3906),
    [sym_unary] = STATE(3906),
    [sym__arg_or_splat_arg] = STATE(6835),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6536] = {
    [aux_sym_exceptions_repeat1] = STATE(8671),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(9785),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [6537] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(3906),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_splat_argument] = STATE(8672),
    [sym_assignment] = STATE(3906),
    [sym_operator_assignment] = STATE(3906),
    [sym_conditional] = STATE(3906),
    [sym_range] = STATE(3906),
    [sym_binary] = STATE(3906),
    [sym_unary] = STATE(3906),
    [sym_right_assignment_list] = STATE(2017),
    [sym__arg_or_splat_arg] = STATE(8672),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(6313),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6538] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8673),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(8673),
    [sym_operator_assignment] = STATE(8673),
    [sym_conditional] = STATE(8673),
    [sym_range] = STATE(8673),
    [sym_binary] = STATE(8673),
    [sym_unary] = STATE(8673),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6539] = {
    [sym_string] = STATE(8674),
    [aux_sym_chained_string_repeat1] = STATE(8674),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [6540] = {
    [sym__line_break] = ACTIONS(12069),
    [sym__heredoc_body_start] = ACTIONS(12069),
    [sym__binary_minus] = ACTIONS(12069),
    [sym__binary_star] = ACTIONS(12069),
    [ts_builtin_sym_end] = ACTIONS(12069),
    [anon_sym___END__] = ACTIONS(12069),
    [anon_sym_LBRACE] = ACTIONS(12069),
    [anon_sym_RBRACE] = ACTIONS(12069),
    [anon_sym_RPAREN] = ACTIONS(12069),
    [anon_sym_DOT] = ACTIONS(12071),
    [anon_sym_COMMA] = ACTIONS(12069),
    [anon_sym_PIPE] = ACTIONS(12071),
    [anon_sym_SEMI] = ACTIONS(12069),
    [anon_sym_STAR_STAR] = ACTIONS(12069),
    [anon_sym_AMP] = ACTIONS(12071),
    [anon_sym_LT] = ACTIONS(12071),
    [anon_sym_end] = ACTIONS(12069),
    [anon_sym_if] = ACTIONS(12069),
    [anon_sym_unless] = ACTIONS(12069),
    [anon_sym_while] = ACTIONS(12069),
    [anon_sym_until] = ACTIONS(12069),
    [anon_sym_rescue] = ACTIONS(12069),
    [anon_sym_do] = ACTIONS(12069),
    [anon_sym_when] = ACTIONS(12069),
    [anon_sym_elsif] = ACTIONS(12069),
    [anon_sym_else] = ACTIONS(12069),
    [anon_sym_then] = ACTIONS(12069),
    [anon_sym_ensure] = ACTIONS(12069),
    [anon_sym_EQ_GT] = ACTIONS(12069),
    [anon_sym_LBRACK] = ACTIONS(12069),
    [anon_sym_COLON_COLON2] = ACTIONS(12069),
    [anon_sym_AMP_DOT] = ACTIONS(12069),
    [anon_sym_QMARK] = ACTIONS(12069),
    [anon_sym_DOT_DOT] = ACTIONS(12071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12069),
    [anon_sym_and] = ACTIONS(12069),
    [anon_sym_or] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE] = ACTIONS(12069),
    [anon_sym_AMP_AMP] = ACTIONS(12069),
    [anon_sym_LT_LT] = ACTIONS(12069),
    [anon_sym_GT_GT] = ACTIONS(12069),
    [anon_sym_EQ_EQ] = ACTIONS(12071),
    [anon_sym_BANG_EQ] = ACTIONS(12069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12069),
    [anon_sym_LT_EQ_GT] = ACTIONS(12069),
    [anon_sym_EQ_TILDE] = ACTIONS(12069),
    [anon_sym_BANG_TILDE] = ACTIONS(12069),
    [anon_sym_LT_EQ] = ACTIONS(12071),
    [anon_sym_GT] = ACTIONS(12071),
    [anon_sym_GT_EQ] = ACTIONS(12069),
    [anon_sym_CARET] = ACTIONS(12069),
    [anon_sym_PLUS] = ACTIONS(12069),
    [anon_sym_SLASH] = ACTIONS(12069),
    [anon_sym_PERCENT] = ACTIONS(12069),
    [sym_comment] = ACTIONS(87),
  },
  [6541] = {
    [sym__line_break] = ACTIONS(12073),
    [sym__heredoc_body_start] = ACTIONS(12073),
    [sym__binary_minus] = ACTIONS(12073),
    [sym__binary_star] = ACTIONS(12073),
    [ts_builtin_sym_end] = ACTIONS(12073),
    [anon_sym___END__] = ACTIONS(12073),
    [anon_sym_LBRACE] = ACTIONS(12073),
    [anon_sym_RBRACE] = ACTIONS(12073),
    [anon_sym_RPAREN] = ACTIONS(12073),
    [anon_sym_DOT] = ACTIONS(12075),
    [anon_sym_COMMA] = ACTIONS(12073),
    [anon_sym_PIPE] = ACTIONS(12075),
    [anon_sym_SEMI] = ACTIONS(12073),
    [anon_sym_STAR_STAR] = ACTIONS(12073),
    [anon_sym_AMP] = ACTIONS(12075),
    [anon_sym_LT] = ACTIONS(12075),
    [anon_sym_end] = ACTIONS(12073),
    [anon_sym_if] = ACTIONS(12073),
    [anon_sym_unless] = ACTIONS(12073),
    [anon_sym_while] = ACTIONS(12073),
    [anon_sym_until] = ACTIONS(12073),
    [anon_sym_rescue] = ACTIONS(12073),
    [anon_sym_do] = ACTIONS(12073),
    [anon_sym_when] = ACTIONS(12073),
    [anon_sym_elsif] = ACTIONS(12073),
    [anon_sym_else] = ACTIONS(12073),
    [anon_sym_then] = ACTIONS(12073),
    [anon_sym_ensure] = ACTIONS(12073),
    [anon_sym_EQ_GT] = ACTIONS(12073),
    [anon_sym_LBRACK] = ACTIONS(12073),
    [anon_sym_COLON_COLON2] = ACTIONS(12073),
    [anon_sym_AMP_DOT] = ACTIONS(12073),
    [anon_sym_QMARK] = ACTIONS(12073),
    [anon_sym_DOT_DOT] = ACTIONS(12075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12073),
    [anon_sym_and] = ACTIONS(12073),
    [anon_sym_or] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE] = ACTIONS(12073),
    [anon_sym_AMP_AMP] = ACTIONS(12073),
    [anon_sym_LT_LT] = ACTIONS(12073),
    [anon_sym_GT_GT] = ACTIONS(12073),
    [anon_sym_EQ_EQ] = ACTIONS(12075),
    [anon_sym_BANG_EQ] = ACTIONS(12073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12073),
    [anon_sym_LT_EQ_GT] = ACTIONS(12073),
    [anon_sym_EQ_TILDE] = ACTIONS(12073),
    [anon_sym_BANG_TILDE] = ACTIONS(12073),
    [anon_sym_LT_EQ] = ACTIONS(12075),
    [anon_sym_GT] = ACTIONS(12075),
    [anon_sym_GT_EQ] = ACTIONS(12073),
    [anon_sym_CARET] = ACTIONS(12073),
    [anon_sym_PLUS] = ACTIONS(12073),
    [anon_sym_SLASH] = ACTIONS(12073),
    [anon_sym_PERCENT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [6542] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6543] = {
    [sym_heredoc_body] = STATE(8675),
    [aux_sym_call_repeat1] = STATE(8675),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [6544] = {
    [sym_heredoc_body] = STATE(8675),
    [aux_sym_call_repeat1] = STATE(8675),
    [aux_sym_argument_list_repeat1] = STATE(8676),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [6545] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9823),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [6546] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8677),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(8677),
    [sym_operator_assignment] = STATE(8677),
    [sym_conditional] = STATE(8677),
    [sym_range] = STATE(8677),
    [sym_binary] = STATE(8677),
    [sym_unary] = STATE(8677),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6547] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8678),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(8678),
    [sym_operator_assignment] = STATE(8678),
    [sym_conditional] = STATE(8678),
    [sym_range] = STATE(8678),
    [sym_binary] = STATE(8678),
    [sym_unary] = STATE(8678),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6548] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8679),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(8679),
    [sym_operator_assignment] = STATE(8679),
    [sym_conditional] = STATE(8679),
    [sym_range] = STATE(8679),
    [sym_binary] = STATE(8679),
    [sym_unary] = STATE(8679),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6549] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8680),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(8680),
    [sym_operator_assignment] = STATE(8680),
    [sym_conditional] = STATE(8680),
    [sym_range] = STATE(8680),
    [sym_binary] = STATE(8680),
    [sym_unary] = STATE(8680),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6550] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8681),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(8681),
    [sym_operator_assignment] = STATE(8681),
    [sym_conditional] = STATE(8681),
    [sym_range] = STATE(8681),
    [sym_binary] = STATE(8681),
    [sym_unary] = STATE(8681),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6551] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8682),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8682),
    [sym_operator_assignment] = STATE(8682),
    [sym_conditional] = STATE(8682),
    [sym_range] = STATE(8682),
    [sym_binary] = STATE(8682),
    [sym_unary] = STATE(8682),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6552] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8683),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(8683),
    [sym_operator_assignment] = STATE(8683),
    [sym_conditional] = STATE(8683),
    [sym_range] = STATE(8683),
    [sym_binary] = STATE(8683),
    [sym_unary] = STATE(8683),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6553] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8684),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(8684),
    [sym_operator_assignment] = STATE(8684),
    [sym_conditional] = STATE(8684),
    [sym_range] = STATE(8684),
    [sym_binary] = STATE(8684),
    [sym_unary] = STATE(8684),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6554] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8685),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(8685),
    [sym_operator_assignment] = STATE(8685),
    [sym_conditional] = STATE(8685),
    [sym_range] = STATE(8685),
    [sym_binary] = STATE(8685),
    [sym_unary] = STATE(8685),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6555] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8686),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(8686),
    [sym_operator_assignment] = STATE(8686),
    [sym_conditional] = STATE(8686),
    [sym_range] = STATE(8686),
    [sym_binary] = STATE(8686),
    [sym_unary] = STATE(8686),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6556] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8687),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_splat_argument] = STATE(8688),
    [sym_assignment] = STATE(8687),
    [sym_operator_assignment] = STATE(8687),
    [sym_conditional] = STATE(8687),
    [sym_range] = STATE(8687),
    [sym_binary] = STATE(8687),
    [sym_unary] = STATE(8687),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(8688),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6557] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8689),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(8689),
    [sym_operator_assignment] = STATE(8689),
    [sym_conditional] = STATE(8689),
    [sym_range] = STATE(8689),
    [sym_binary] = STATE(8689),
    [sym_unary] = STATE(8689),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6558] = {
    [sym_string] = STATE(8690),
    [aux_sym_chained_string_repeat1] = STATE(8690),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [6559] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(9823),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [6560] = {
    [sym_heredoc_body] = STATE(8691),
    [aux_sym_call_repeat1] = STATE(8691),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6561] = {
    [sym_heredoc_body] = STATE(8692),
    [aux_sym_call_repeat1] = STATE(8692),
    [aux_sym_argument_list_repeat1] = STATE(8511),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9520),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6562] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(9823),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [6563] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6564] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [6565] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6566] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6567] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6568] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12077),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6569] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6570] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6571] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6572] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6573] = {
    [sym_heredoc_body] = STATE(6573),
    [aux_sym_call_repeat1] = STATE(6573),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [6574] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(1702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(1702),
    [sym_operator_assignment] = STATE(1702),
    [sym_conditional] = STATE(1702),
    [sym_range] = STATE(1702),
    [sym_binary] = STATE(1702),
    [sym_unary] = STATE(1702),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1707),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(2972),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__identifier_hash_key] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9845),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(2996),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6575] = {
    [sym_heredoc_body] = STATE(6573),
    [aux_sym_call_repeat1] = STATE(6573),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [6576] = {
    [aux_sym_argument_list_repeat1] = STATE(6576),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12079),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [6577] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6578] = {
    [aux_sym_exceptions_repeat1] = STATE(8695),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [6579] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [6580] = {
    [sym_string] = STATE(6580),
    [aux_sym_chained_string_repeat1] = STATE(6580),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [6581] = {
    [aux_sym_undef_repeat1] = STATE(6581),
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [anon_sym_RBRACE] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9006),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [6582] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6583] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8696),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(8696),
    [sym_operator_assignment] = STATE(8696),
    [sym_conditional] = STATE(8696),
    [sym_range] = STATE(8696),
    [sym_binary] = STATE(8696),
    [sym_unary] = STATE(8696),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6584] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6585] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9864),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [6586] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8697),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(8697),
    [sym_operator_assignment] = STATE(8697),
    [sym_conditional] = STATE(8697),
    [sym_range] = STATE(8697),
    [sym_binary] = STATE(8697),
    [sym_unary] = STATE(8697),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6587] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8698),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(8698),
    [sym_operator_assignment] = STATE(8698),
    [sym_conditional] = STATE(8698),
    [sym_range] = STATE(8698),
    [sym_binary] = STATE(8698),
    [sym_unary] = STATE(8698),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6588] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8699),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(8699),
    [sym_operator_assignment] = STATE(8699),
    [sym_conditional] = STATE(8699),
    [sym_range] = STATE(8699),
    [sym_binary] = STATE(8699),
    [sym_unary] = STATE(8699),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6589] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8700),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(8700),
    [sym_operator_assignment] = STATE(8700),
    [sym_conditional] = STATE(8700),
    [sym_range] = STATE(8700),
    [sym_binary] = STATE(8700),
    [sym_unary] = STATE(8700),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6590] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8701),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(8701),
    [sym_operator_assignment] = STATE(8701),
    [sym_conditional] = STATE(8701),
    [sym_range] = STATE(8701),
    [sym_binary] = STATE(8701),
    [sym_unary] = STATE(8701),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6591] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8702),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8702),
    [sym_operator_assignment] = STATE(8702),
    [sym_conditional] = STATE(8702),
    [sym_range] = STATE(8702),
    [sym_binary] = STATE(8702),
    [sym_unary] = STATE(8702),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6592] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8703),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(8703),
    [sym_operator_assignment] = STATE(8703),
    [sym_conditional] = STATE(8703),
    [sym_range] = STATE(8703),
    [sym_binary] = STATE(8703),
    [sym_unary] = STATE(8703),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6593] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8704),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(8704),
    [sym_operator_assignment] = STATE(8704),
    [sym_conditional] = STATE(8704),
    [sym_range] = STATE(8704),
    [sym_binary] = STATE(8704),
    [sym_unary] = STATE(8704),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6594] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8705),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(8705),
    [sym_operator_assignment] = STATE(8705),
    [sym_conditional] = STATE(8705),
    [sym_range] = STATE(8705),
    [sym_binary] = STATE(8705),
    [sym_unary] = STATE(8705),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6595] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8706),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(8706),
    [sym_operator_assignment] = STATE(8706),
    [sym_conditional] = STATE(8706),
    [sym_range] = STATE(8706),
    [sym_binary] = STATE(8706),
    [sym_unary] = STATE(8706),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6596] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8707),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_splat_argument] = STATE(8708),
    [sym_assignment] = STATE(8707),
    [sym_operator_assignment] = STATE(8707),
    [sym_conditional] = STATE(8707),
    [sym_range] = STATE(8707),
    [sym_binary] = STATE(8707),
    [sym_unary] = STATE(8707),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(8708),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(3044),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6597] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8709),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(8709),
    [sym_operator_assignment] = STATE(8709),
    [sym_conditional] = STATE(8709),
    [sym_range] = STATE(8709),
    [sym_binary] = STATE(8709),
    [sym_unary] = STATE(8709),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [6598] = {
    [sym_string] = STATE(8710),
    [aux_sym_chained_string_repeat1] = STATE(8710),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [6599] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(9864),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [6600] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(9864),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [6601] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6602] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [6603] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6604] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6605] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6606] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12082),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6607] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6608] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6609] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6610] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6611] = {
    [sym_heredoc_body] = STATE(6611),
    [aux_sym_call_repeat1] = STATE(6611),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [6612] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(1746),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3042),
    [sym__splat_star] = ACTIONS(3044),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__identifier_hash_key] = ACTIONS(3048),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9886),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3066),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [6613] = {
    [sym_heredoc_body] = STATE(6611),
    [aux_sym_call_repeat1] = STATE(6611),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [6614] = {
    [aux_sym_argument_list_repeat1] = STATE(6614),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12084),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [6615] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6616] = {
    [aux_sym_exceptions_repeat1] = STATE(8713),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [6617] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [6618] = {
    [sym_string] = STATE(6618),
    [aux_sym_chained_string_repeat1] = STATE(6618),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [6619] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9892),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(9894),
    [anon_sym_LT] = ACTIONS(9896),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DOT_DOT] = ACTIONS(9900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9902),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(9904),
    [anon_sym_AMP_AMP] = ACTIONS(9904),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(9908),
    [anon_sym_BANG_EQ] = ACTIONS(9904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9904),
    [anon_sym_LT_EQ_GT] = ACTIONS(9904),
    [anon_sym_EQ_TILDE] = ACTIONS(9904),
    [anon_sym_BANG_TILDE] = ACTIONS(9904),
    [anon_sym_LT_EQ] = ACTIONS(9896),
    [anon_sym_GT] = ACTIONS(9896),
    [anon_sym_GT_EQ] = ACTIONS(9910),
    [anon_sym_CARET] = ACTIONS(9912),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [6620] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6621] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9892),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(9894),
    [anon_sym_LT] = ACTIONS(9896),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DOT_DOT] = ACTIONS(9900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9902),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9904),
    [anon_sym_AMP_AMP] = ACTIONS(9904),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(9908),
    [anon_sym_BANG_EQ] = ACTIONS(9904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9904),
    [anon_sym_LT_EQ_GT] = ACTIONS(9904),
    [anon_sym_EQ_TILDE] = ACTIONS(9904),
    [anon_sym_BANG_TILDE] = ACTIONS(9904),
    [anon_sym_LT_EQ] = ACTIONS(9896),
    [anon_sym_GT] = ACTIONS(9896),
    [anon_sym_GT_EQ] = ACTIONS(9910),
    [anon_sym_CARET] = ACTIONS(9912),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [6622] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8714),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(8714),
    [sym_operator_assignment] = STATE(8714),
    [sym_conditional] = STATE(8714),
    [sym_range] = STATE(8714),
    [sym_binary] = STATE(8714),
    [sym_unary] = STATE(8714),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6623] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8715),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(8715),
    [sym_operator_assignment] = STATE(8715),
    [sym_conditional] = STATE(8715),
    [sym_range] = STATE(8715),
    [sym_binary] = STATE(8715),
    [sym_unary] = STATE(8715),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6624] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8716),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(8716),
    [sym_operator_assignment] = STATE(8716),
    [sym_conditional] = STATE(8716),
    [sym_range] = STATE(8716),
    [sym_binary] = STATE(8716),
    [sym_unary] = STATE(8716),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6625] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8717),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(8717),
    [sym_operator_assignment] = STATE(8717),
    [sym_conditional] = STATE(8717),
    [sym_range] = STATE(8717),
    [sym_binary] = STATE(8717),
    [sym_unary] = STATE(8717),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6626] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8718),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(8718),
    [sym_operator_assignment] = STATE(8718),
    [sym_conditional] = STATE(8718),
    [sym_range] = STATE(8718),
    [sym_binary] = STATE(8718),
    [sym_unary] = STATE(8718),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6627] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8719),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8719),
    [sym_operator_assignment] = STATE(8719),
    [sym_conditional] = STATE(8719),
    [sym_range] = STATE(8719),
    [sym_binary] = STATE(8719),
    [sym_unary] = STATE(8719),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6628] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8720),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(8720),
    [sym_operator_assignment] = STATE(8720),
    [sym_conditional] = STATE(8720),
    [sym_range] = STATE(8720),
    [sym_binary] = STATE(8720),
    [sym_unary] = STATE(8720),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6629] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8721),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(8721),
    [sym_operator_assignment] = STATE(8721),
    [sym_conditional] = STATE(8721),
    [sym_range] = STATE(8721),
    [sym_binary] = STATE(8721),
    [sym_unary] = STATE(8721),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6630] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8722),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(8722),
    [sym_operator_assignment] = STATE(8722),
    [sym_conditional] = STATE(8722),
    [sym_range] = STATE(8722),
    [sym_binary] = STATE(8722),
    [sym_unary] = STATE(8722),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6631] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8723),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(8723),
    [sym_operator_assignment] = STATE(8723),
    [sym_conditional] = STATE(8723),
    [sym_range] = STATE(8723),
    [sym_binary] = STATE(8723),
    [sym_unary] = STATE(8723),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6632] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4014),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(4014),
    [sym_operator_assignment] = STATE(4014),
    [sym_conditional] = STATE(4014),
    [sym_range] = STATE(4014),
    [sym_binary] = STATE(4014),
    [sym_unary] = STATE(4014),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(6513),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6633] = {
    [aux_sym_exceptions_repeat1] = STATE(8724),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [6634] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4014),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_splat_argument] = STATE(8725),
    [sym_assignment] = STATE(4014),
    [sym_operator_assignment] = STATE(4014),
    [sym_conditional] = STATE(4014),
    [sym_range] = STATE(4014),
    [sym_binary] = STATE(4014),
    [sym_unary] = STATE(4014),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(8725),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(6513),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6635] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8726),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(8726),
    [sym_operator_assignment] = STATE(8726),
    [sym_conditional] = STATE(8726),
    [sym_range] = STATE(8726),
    [sym_binary] = STATE(8726),
    [sym_unary] = STATE(8726),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6636] = {
    [sym__binary_minus] = ACTIONS(9793),
    [sym__binary_star] = ACTIONS(9793),
    [anon_sym_LBRACE] = ACTIONS(9793),
    [anon_sym_RBRACE] = ACTIONS(9793),
    [anon_sym_RPAREN] = ACTIONS(9793),
    [anon_sym_DOT] = ACTIONS(9795),
    [anon_sym_COMMA] = ACTIONS(9793),
    [anon_sym_PIPE] = ACTIONS(9795),
    [anon_sym_SEMI] = ACTIONS(9793),
    [anon_sym_STAR_STAR] = ACTIONS(9793),
    [anon_sym_AMP] = ACTIONS(9795),
    [anon_sym_LT] = ACTIONS(9795),
    [anon_sym_if] = ACTIONS(9793),
    [anon_sym_unless] = ACTIONS(9793),
    [anon_sym_while] = ACTIONS(9793),
    [anon_sym_until] = ACTIONS(9793),
    [anon_sym_rescue] = ACTIONS(9793),
    [anon_sym_do] = ACTIONS(9793),
    [anon_sym_EQ_GT] = ACTIONS(9793),
    [anon_sym_LBRACK] = ACTIONS(9793),
    [anon_sym_COLON_COLON2] = ACTIONS(9793),
    [anon_sym_AMP_DOT] = ACTIONS(9793),
    [anon_sym_QMARK] = ACTIONS(9793),
    [anon_sym_COLON2] = ACTIONS(9795),
    [anon_sym_DOT_DOT] = ACTIONS(9795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9793),
    [anon_sym_and] = ACTIONS(9793),
    [anon_sym_or] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE] = ACTIONS(9793),
    [anon_sym_AMP_AMP] = ACTIONS(9793),
    [anon_sym_LT_LT] = ACTIONS(9793),
    [anon_sym_GT_GT] = ACTIONS(9793),
    [anon_sym_EQ_EQ] = ACTIONS(9795),
    [anon_sym_BANG_EQ] = ACTIONS(9793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9793),
    [anon_sym_LT_EQ_GT] = ACTIONS(9793),
    [anon_sym_EQ_TILDE] = ACTIONS(9793),
    [anon_sym_BANG_TILDE] = ACTIONS(9793),
    [anon_sym_LT_EQ] = ACTIONS(9795),
    [anon_sym_GT] = ACTIONS(9795),
    [anon_sym_GT_EQ] = ACTIONS(9793),
    [anon_sym_CARET] = ACTIONS(9793),
    [anon_sym_PLUS] = ACTIONS(9793),
    [anon_sym_SLASH] = ACTIONS(9793),
    [anon_sym_PERCENT] = ACTIONS(9793),
    [sym_comment] = ACTIONS(87),
  },
  [6637] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12087),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6638] = {
    [sym__binary_minus] = ACTIONS(9799),
    [sym__binary_star] = ACTIONS(9799),
    [anon_sym_LBRACE] = ACTIONS(9799),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [anon_sym_RPAREN] = ACTIONS(9799),
    [anon_sym_DOT] = ACTIONS(9801),
    [anon_sym_COMMA] = ACTIONS(9799),
    [anon_sym_PIPE] = ACTIONS(9801),
    [anon_sym_SEMI] = ACTIONS(9799),
    [anon_sym_STAR_STAR] = ACTIONS(9799),
    [anon_sym_AMP] = ACTIONS(9801),
    [anon_sym_LT] = ACTIONS(9801),
    [anon_sym_if] = ACTIONS(9799),
    [anon_sym_unless] = ACTIONS(9799),
    [anon_sym_while] = ACTIONS(9799),
    [anon_sym_until] = ACTIONS(9799),
    [anon_sym_rescue] = ACTIONS(9799),
    [anon_sym_do] = ACTIONS(9799),
    [anon_sym_EQ_GT] = ACTIONS(9799),
    [anon_sym_LBRACK] = ACTIONS(9799),
    [anon_sym_COLON_COLON2] = ACTIONS(9799),
    [anon_sym_AMP_DOT] = ACTIONS(9799),
    [anon_sym_QMARK] = ACTIONS(9799),
    [anon_sym_COLON2] = ACTIONS(9801),
    [anon_sym_DOT_DOT] = ACTIONS(9801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9799),
    [anon_sym_and] = ACTIONS(9799),
    [anon_sym_or] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE] = ACTIONS(9799),
    [anon_sym_AMP_AMP] = ACTIONS(9799),
    [anon_sym_LT_LT] = ACTIONS(9799),
    [anon_sym_GT_GT] = ACTIONS(9799),
    [anon_sym_EQ_EQ] = ACTIONS(9801),
    [anon_sym_BANG_EQ] = ACTIONS(9799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9799),
    [anon_sym_LT_EQ_GT] = ACTIONS(9799),
    [anon_sym_EQ_TILDE] = ACTIONS(9799),
    [anon_sym_BANG_TILDE] = ACTIONS(9799),
    [anon_sym_LT_EQ] = ACTIONS(9801),
    [anon_sym_GT] = ACTIONS(9801),
    [anon_sym_GT_EQ] = ACTIONS(9799),
    [anon_sym_CARET] = ACTIONS(9799),
    [anon_sym_PLUS] = ACTIONS(9799),
    [anon_sym_SLASH] = ACTIONS(9799),
    [anon_sym_PERCENT] = ACTIONS(9799),
    [sym_comment] = ACTIONS(87),
  },
  [6639] = {
    [sym__binary_minus] = ACTIONS(9803),
    [sym__binary_star] = ACTIONS(9803),
    [anon_sym_LBRACE] = ACTIONS(9803),
    [anon_sym_RBRACE] = ACTIONS(9803),
    [anon_sym_RPAREN] = ACTIONS(9803),
    [anon_sym_DOT] = ACTIONS(9805),
    [anon_sym_COMMA] = ACTIONS(9803),
    [anon_sym_PIPE] = ACTIONS(9805),
    [anon_sym_SEMI] = ACTIONS(9803),
    [anon_sym_STAR_STAR] = ACTIONS(9803),
    [anon_sym_AMP] = ACTIONS(9805),
    [anon_sym_LT] = ACTIONS(9805),
    [anon_sym_if] = ACTIONS(9803),
    [anon_sym_unless] = ACTIONS(9803),
    [anon_sym_while] = ACTIONS(9803),
    [anon_sym_until] = ACTIONS(9803),
    [anon_sym_rescue] = ACTIONS(9803),
    [anon_sym_do] = ACTIONS(9803),
    [anon_sym_EQ_GT] = ACTIONS(9803),
    [anon_sym_LBRACK] = ACTIONS(9803),
    [anon_sym_COLON_COLON2] = ACTIONS(9803),
    [anon_sym_AMP_DOT] = ACTIONS(9803),
    [anon_sym_QMARK] = ACTIONS(9803),
    [anon_sym_COLON2] = ACTIONS(9805),
    [anon_sym_DOT_DOT] = ACTIONS(9805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9803),
    [anon_sym_and] = ACTIONS(9803),
    [anon_sym_or] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE] = ACTIONS(9803),
    [anon_sym_AMP_AMP] = ACTIONS(9803),
    [anon_sym_LT_LT] = ACTIONS(9803),
    [anon_sym_GT_GT] = ACTIONS(9803),
    [anon_sym_EQ_EQ] = ACTIONS(9805),
    [anon_sym_BANG_EQ] = ACTIONS(9803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9803),
    [anon_sym_LT_EQ_GT] = ACTIONS(9803),
    [anon_sym_EQ_TILDE] = ACTIONS(9803),
    [anon_sym_BANG_TILDE] = ACTIONS(9803),
    [anon_sym_LT_EQ] = ACTIONS(9805),
    [anon_sym_GT] = ACTIONS(9805),
    [anon_sym_GT_EQ] = ACTIONS(9803),
    [anon_sym_CARET] = ACTIONS(9803),
    [anon_sym_PLUS] = ACTIONS(9803),
    [anon_sym_SLASH] = ACTIONS(9803),
    [anon_sym_PERCENT] = ACTIONS(9803),
    [sym_comment] = ACTIONS(87),
  },
  [6640] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12089),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6641] = {
    [sym__binary_minus] = ACTIONS(9809),
    [sym__binary_star] = ACTIONS(9809),
    [anon_sym_LBRACE] = ACTIONS(9809),
    [anon_sym_RBRACE] = ACTIONS(9809),
    [anon_sym_RPAREN] = ACTIONS(9809),
    [anon_sym_DOT] = ACTIONS(9811),
    [anon_sym_COMMA] = ACTIONS(9809),
    [anon_sym_PIPE] = ACTIONS(9811),
    [anon_sym_SEMI] = ACTIONS(9809),
    [anon_sym_STAR_STAR] = ACTIONS(9809),
    [anon_sym_AMP] = ACTIONS(9811),
    [anon_sym_LT] = ACTIONS(9811),
    [anon_sym_if] = ACTIONS(9809),
    [anon_sym_unless] = ACTIONS(9809),
    [anon_sym_while] = ACTIONS(9809),
    [anon_sym_until] = ACTIONS(9809),
    [anon_sym_rescue] = ACTIONS(9809),
    [anon_sym_do] = ACTIONS(9809),
    [anon_sym_EQ_GT] = ACTIONS(9809),
    [anon_sym_LBRACK] = ACTIONS(9809),
    [anon_sym_COLON_COLON2] = ACTIONS(9809),
    [anon_sym_AMP_DOT] = ACTIONS(9809),
    [anon_sym_QMARK] = ACTIONS(9809),
    [anon_sym_COLON2] = ACTIONS(9811),
    [anon_sym_DOT_DOT] = ACTIONS(9811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9809),
    [anon_sym_and] = ACTIONS(9809),
    [anon_sym_or] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE] = ACTIONS(9809),
    [anon_sym_AMP_AMP] = ACTIONS(9809),
    [anon_sym_LT_LT] = ACTIONS(9809),
    [anon_sym_GT_GT] = ACTIONS(9809),
    [anon_sym_EQ_EQ] = ACTIONS(9811),
    [anon_sym_BANG_EQ] = ACTIONS(9809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9809),
    [anon_sym_LT_EQ_GT] = ACTIONS(9809),
    [anon_sym_EQ_TILDE] = ACTIONS(9809),
    [anon_sym_BANG_TILDE] = ACTIONS(9809),
    [anon_sym_LT_EQ] = ACTIONS(9811),
    [anon_sym_GT] = ACTIONS(9811),
    [anon_sym_GT_EQ] = ACTIONS(9809),
    [anon_sym_CARET] = ACTIONS(9809),
    [anon_sym_PLUS] = ACTIONS(9809),
    [anon_sym_SLASH] = ACTIONS(9809),
    [anon_sym_PERCENT] = ACTIONS(9809),
    [sym_comment] = ACTIONS(87),
  },
  [6642] = {
    [sym__method_rest] = STATE(8729),
    [sym_operator] = STATE(521),
    [sym__method_name] = STATE(521),
    [sym_setter] = STATE(521),
    [sym_symbol] = STATE(521),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(6563),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(6563),
    [sym_class_variable] = ACTIONS(6563),
    [sym_global_variable] = ACTIONS(6563),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [6643] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6644] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(9946),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [6645] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8730),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(8730),
    [sym_operator_assignment] = STATE(8730),
    [sym_conditional] = STATE(8730),
    [sym_range] = STATE(8730),
    [sym_binary] = STATE(8730),
    [sym_unary] = STATE(8730),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6646] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8731),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(8731),
    [sym_operator_assignment] = STATE(8731),
    [sym_conditional] = STATE(8731),
    [sym_range] = STATE(8731),
    [sym_binary] = STATE(8731),
    [sym_unary] = STATE(8731),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6647] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8732),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(8732),
    [sym_operator_assignment] = STATE(8732),
    [sym_conditional] = STATE(8732),
    [sym_range] = STATE(8732),
    [sym_binary] = STATE(8732),
    [sym_unary] = STATE(8732),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6648] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8733),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(8733),
    [sym_operator_assignment] = STATE(8733),
    [sym_conditional] = STATE(8733),
    [sym_range] = STATE(8733),
    [sym_binary] = STATE(8733),
    [sym_unary] = STATE(8733),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6649] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8734),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(8734),
    [sym_operator_assignment] = STATE(8734),
    [sym_conditional] = STATE(8734),
    [sym_range] = STATE(8734),
    [sym_binary] = STATE(8734),
    [sym_unary] = STATE(8734),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6650] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8735),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8735),
    [sym_operator_assignment] = STATE(8735),
    [sym_conditional] = STATE(8735),
    [sym_range] = STATE(8735),
    [sym_binary] = STATE(8735),
    [sym_unary] = STATE(8735),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6651] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8736),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(8736),
    [sym_operator_assignment] = STATE(8736),
    [sym_conditional] = STATE(8736),
    [sym_range] = STATE(8736),
    [sym_binary] = STATE(8736),
    [sym_unary] = STATE(8736),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6652] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8737),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(8737),
    [sym_operator_assignment] = STATE(8737),
    [sym_conditional] = STATE(8737),
    [sym_range] = STATE(8737),
    [sym_binary] = STATE(8737),
    [sym_unary] = STATE(8737),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6653] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8738),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(8738),
    [sym_operator_assignment] = STATE(8738),
    [sym_conditional] = STATE(8738),
    [sym_range] = STATE(8738),
    [sym_binary] = STATE(8738),
    [sym_unary] = STATE(8738),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6654] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8739),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(8739),
    [sym_operator_assignment] = STATE(8739),
    [sym_conditional] = STATE(8739),
    [sym_range] = STATE(8739),
    [sym_binary] = STATE(8739),
    [sym_unary] = STATE(8739),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6655] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8740),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_splat_argument] = STATE(8741),
    [sym_assignment] = STATE(8740),
    [sym_operator_assignment] = STATE(8740),
    [sym_conditional] = STATE(8740),
    [sym_range] = STATE(8740),
    [sym_binary] = STATE(8740),
    [sym_unary] = STATE(8740),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(8741),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(3120),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6656] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8742),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(8742),
    [sym_operator_assignment] = STATE(8742),
    [sym_conditional] = STATE(8742),
    [sym_range] = STATE(8742),
    [sym_binary] = STATE(8742),
    [sym_unary] = STATE(8742),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6657] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(9946),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [6658] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6659] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6660] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8743),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(8743),
    [sym_operator_assignment] = STATE(8743),
    [sym_conditional] = STATE(8743),
    [sym_range] = STATE(8743),
    [sym_binary] = STATE(8743),
    [sym_unary] = STATE(8743),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6661] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6662] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8744),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(8744),
    [sym_operator_assignment] = STATE(8744),
    [sym_conditional] = STATE(8744),
    [sym_range] = STATE(8744),
    [sym_binary] = STATE(8744),
    [sym_unary] = STATE(8744),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6663] = {
    [sym_heredoc_body] = STATE(8745),
    [aux_sym_call_repeat1] = STATE(8745),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6664] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4053),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(4053),
    [sym_operator_assignment] = STATE(4053),
    [sym_conditional] = STATE(4053),
    [sym_range] = STATE(4053),
    [sym_binary] = STATE(4053),
    [sym_unary] = STATE(4053),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4056),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(8746),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6581),
    [sym__splat_star] = ACTIONS(6583),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__identifier_hash_key] = ACTIONS(6585),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12091),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(6587),
    [sym_identifier] = ACTIONS(6587),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6665] = {
    [sym_heredoc_body] = STATE(8747),
    [aux_sym_call_repeat1] = STATE(8747),
    [aux_sym_argument_list_repeat1] = STATE(8748),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9972),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6666] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(9946),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [6667] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6668] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [6669] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6670] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6671] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6672] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12093),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6673] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6674] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6675] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6676] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6677] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6678] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6679] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8750),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(8750),
    [sym_operator_assignment] = STATE(8750),
    [sym_conditional] = STATE(8750),
    [sym_range] = STATE(8750),
    [sym_binary] = STATE(8750),
    [sym_unary] = STATE(8750),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6680] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6681] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8751),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(8751),
    [sym_operator_assignment] = STATE(8751),
    [sym_conditional] = STATE(8751),
    [sym_range] = STATE(8751),
    [sym_binary] = STATE(8751),
    [sym_unary] = STATE(8751),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6682] = {
    [sym_heredoc_body] = STATE(8752),
    [aux_sym_call_repeat1] = STATE(8752),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [6683] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4074),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym__argument] = STATE(4285),
    [sym_splat_argument] = STATE(4285),
    [sym_hash_splat_argument] = STATE(4285),
    [sym_block_argument] = STATE(4285),
    [sym_assignment] = STATE(4074),
    [sym_operator_assignment] = STATE(4074),
    [sym_conditional] = STATE(4074),
    [sym_range] = STATE(4074),
    [sym_binary] = STATE(4074),
    [sym_unary] = STATE(4074),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4077),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(8753),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4285),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6617),
    [sym__splat_star] = ACTIONS(6619),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__identifier_hash_key] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12095),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(6623),
    [sym_identifier] = ACTIONS(6623),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6684] = {
    [sym_heredoc_body] = STATE(8754),
    [aux_sym_call_repeat1] = STATE(8754),
    [aux_sym_argument_list_repeat1] = STATE(8755),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9980),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [6685] = {
    [sym_heredoc_body] = STATE(6685),
    [aux_sym_call_repeat1] = STATE(6685),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [6686] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1790),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(1790),
    [sym_operator_assignment] = STATE(1790),
    [sym_conditional] = STATE(1790),
    [sym_range] = STATE(1790),
    [sym_binary] = STATE(1790),
    [sym_unary] = STATE(1790),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1796),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3118),
    [sym__splat_star] = ACTIONS(3120),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__identifier_hash_key] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9984),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3142),
    [sym_identifier] = ACTIONS(3142),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6687] = {
    [sym_heredoc_body] = STATE(6685),
    [aux_sym_call_repeat1] = STATE(6685),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [6688] = {
    [aux_sym_argument_list_repeat1] = STATE(6688),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12097),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [6689] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6690] = {
    [aux_sym_exceptions_repeat1] = STATE(8757),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [6691] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [6692] = {
    [sym_string] = STATE(6692),
    [aux_sym_chained_string_repeat1] = STATE(6692),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [6693] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8758),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_assignment] = STATE(8758),
    [sym_operator_assignment] = STATE(8758),
    [sym_conditional] = STATE(8758),
    [sym_range] = STATE(8758),
    [sym_binary] = STATE(8758),
    [sym_unary] = STATE(8758),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6694] = {
    [sym__simple_symbol] = ACTIONS(4148),
    [sym__string_start] = ACTIONS(4148),
    [sym__symbol_start] = ACTIONS(4148),
    [sym__subshell_start] = ACTIONS(4148),
    [sym__regex_start] = ACTIONS(4148),
    [sym__string_array_start] = ACTIONS(4148),
    [sym__symbol_array_start] = ACTIONS(4148),
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym_heredoc_beginning] = ACTIONS(4148),
    [sym__block_ampersand] = ACTIONS(4148),
    [sym__splat_star] = ACTIONS(4148),
    [sym__unary_minus] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [sym__identifier_hash_key] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_def] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(4150),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COLON_COLON] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_STAR_STAR] = ACTIONS(4150),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_class] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_module] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_yield] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_next] = ACTIONS(4150),
    [sym_redo] = ACTIONS(4150),
    [sym_retry] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_unless] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [anon_sym_until] = ACTIONS(4150),
    [anon_sym_rescue] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_in] = ACTIONS(4150),
    [anon_sym_do] = ACTIONS(4150),
    [anon_sym_case] = ACTIONS(4150),
    [anon_sym_begin] = ACTIONS(4150),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_PLUS_EQ] = ACTIONS(4148),
    [anon_sym_DASH_EQ] = ACTIONS(4148),
    [anon_sym_STAR_EQ] = ACTIONS(4148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4148),
    [anon_sym_SLASH_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_PIPE_EQ] = ACTIONS(4148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4148),
    [anon_sym_AMP_EQ] = ACTIONS(4148),
    [anon_sym_PERCENT_EQ] = ACTIONS(4148),
    [anon_sym_GT_GT_EQ] = ACTIONS(4148),
    [anon_sym_LT_LT_EQ] = ACTIONS(4148),
    [anon_sym_CARET_EQ] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4150),
    [anon_sym_COLON2] = ACTIONS(4150),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4150),
    [anon_sym_or] = ACTIONS(4150),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_LT_LT] = ACTIONS(4150),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4150),
    [anon_sym_defined_QMARK] = ACTIONS(4148),
    [anon_sym_not] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4150),
    [anon_sym_TILDE] = ACTIONS(4148),
    [sym_constant] = ACTIONS(4150),
    [sym_identifier] = ACTIONS(4150),
    [sym_instance_variable] = ACTIONS(4148),
    [sym_class_variable] = ACTIONS(4148),
    [sym_global_variable] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4150),
    [sym_float] = ACTIONS(4150),
    [sym_complex] = ACTIONS(4148),
    [sym_super] = ACTIONS(4150),
    [anon_sym_true] = ACTIONS(4150),
    [anon_sym_TRUE] = ACTIONS(4150),
    [anon_sym_false] = ACTIONS(4150),
    [anon_sym_FALSE] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [anon_sym_nil] = ACTIONS(4150),
    [anon_sym_NIL] = ACTIONS(4150),
    [sym_character] = ACTIONS(4148),
    [anon_sym_LBRACK2] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4148),
  },
  [6695] = {
    [sym_heredoc_body] = STATE(8760),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(12100),
    [sym_comment] = ACTIONS(87),
  },
  [6696] = {
    [anon_sym_RPAREN] = ACTIONS(12100),
    [sym_comment] = ACTIONS(87),
  },
  [6697] = {
    [sym__simple_symbol] = ACTIONS(9425),
    [sym__string_start] = ACTIONS(9425),
    [sym__symbol_start] = ACTIONS(9425),
    [sym__subshell_start] = ACTIONS(9425),
    [sym__regex_start] = ACTIONS(9425),
    [sym__string_array_start] = ACTIONS(9425),
    [sym__symbol_array_start] = ACTIONS(9425),
    [sym__heredoc_body_start] = ACTIONS(9425),
    [sym_heredoc_beginning] = ACTIONS(9425),
    [sym__block_ampersand] = ACTIONS(9425),
    [sym__splat_star] = ACTIONS(9425),
    [sym__unary_minus] = ACTIONS(9425),
    [sym__binary_minus] = ACTIONS(9425),
    [sym__binary_star] = ACTIONS(9425),
    [sym__identifier_hash_key] = ACTIONS(9425),
    [anon_sym_LBRACE] = ACTIONS(9425),
    [anon_sym_RBRACE] = ACTIONS(9425),
    [anon_sym_def] = ACTIONS(9427),
    [anon_sym_LPAREN] = ACTIONS(9427),
    [anon_sym_RPAREN] = ACTIONS(9425),
    [anon_sym_DOT] = ACTIONS(9427),
    [anon_sym_COLON_COLON] = ACTIONS(9427),
    [anon_sym_COMMA] = ACTIONS(9425),
    [anon_sym_PIPE] = ACTIONS(9427),
    [anon_sym_SEMI] = ACTIONS(9425),
    [anon_sym_STAR] = ACTIONS(9427),
    [anon_sym_STAR_STAR] = ACTIONS(9427),
    [anon_sym_AMP] = ACTIONS(9427),
    [anon_sym_EQ] = ACTIONS(9427),
    [anon_sym_class] = ACTIONS(9427),
    [anon_sym_LT] = ACTIONS(9427),
    [anon_sym_module] = ACTIONS(9427),
    [anon_sym_return] = ACTIONS(9427),
    [anon_sym_yield] = ACTIONS(9427),
    [anon_sym_break] = ACTIONS(9427),
    [anon_sym_next] = ACTIONS(9427),
    [sym_redo] = ACTIONS(9427),
    [sym_retry] = ACTIONS(9427),
    [anon_sym_if] = ACTIONS(9427),
    [anon_sym_unless] = ACTIONS(9427),
    [anon_sym_while] = ACTIONS(9427),
    [anon_sym_until] = ACTIONS(9427),
    [anon_sym_rescue] = ACTIONS(9427),
    [anon_sym_for] = ACTIONS(9427),
    [anon_sym_in] = ACTIONS(9427),
    [anon_sym_do] = ACTIONS(9427),
    [anon_sym_case] = ACTIONS(9427),
    [anon_sym_begin] = ACTIONS(9427),
    [anon_sym_LBRACK] = ACTIONS(9425),
    [anon_sym_RBRACK] = ACTIONS(9425),
    [anon_sym_COLON_COLON2] = ACTIONS(9425),
    [anon_sym_AMP_DOT] = ACTIONS(9425),
    [anon_sym_LPAREN2] = ACTIONS(9425),
    [anon_sym_PLUS_EQ] = ACTIONS(9425),
    [anon_sym_DASH_EQ] = ACTIONS(9425),
    [anon_sym_STAR_EQ] = ACTIONS(9425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9425),
    [anon_sym_SLASH_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_PIPE_EQ] = ACTIONS(9425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9425),
    [anon_sym_AMP_EQ] = ACTIONS(9425),
    [anon_sym_PERCENT_EQ] = ACTIONS(9425),
    [anon_sym_GT_GT_EQ] = ACTIONS(9425),
    [anon_sym_LT_LT_EQ] = ACTIONS(9425),
    [anon_sym_CARET_EQ] = ACTIONS(9425),
    [anon_sym_QMARK] = ACTIONS(9427),
    [anon_sym_COLON2] = ACTIONS(9427),
    [anon_sym_DOT_DOT] = ACTIONS(9427),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9425),
    [anon_sym_and] = ACTIONS(9427),
    [anon_sym_or] = ACTIONS(9427),
    [anon_sym_PIPE_PIPE] = ACTIONS(9427),
    [anon_sym_AMP_AMP] = ACTIONS(9427),
    [anon_sym_LT_LT] = ACTIONS(9427),
    [anon_sym_GT_GT] = ACTIONS(9427),
    [anon_sym_EQ_EQ] = ACTIONS(9427),
    [anon_sym_BANG_EQ] = ACTIONS(9425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9425),
    [anon_sym_LT_EQ_GT] = ACTIONS(9425),
    [anon_sym_EQ_TILDE] = ACTIONS(9425),
    [anon_sym_BANG_TILDE] = ACTIONS(9425),
    [anon_sym_LT_EQ] = ACTIONS(9427),
    [anon_sym_GT] = ACTIONS(9427),
    [anon_sym_GT_EQ] = ACTIONS(9425),
    [anon_sym_CARET] = ACTIONS(9427),
    [anon_sym_PLUS] = ACTIONS(9427),
    [anon_sym_SLASH] = ACTIONS(9427),
    [anon_sym_PERCENT] = ACTIONS(9427),
    [anon_sym_defined_QMARK] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [anon_sym_BANG] = ACTIONS(9427),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_constant] = ACTIONS(9427),
    [sym_identifier] = ACTIONS(9427),
    [sym_instance_variable] = ACTIONS(9425),
    [sym_class_variable] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(9425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9427),
    [sym_float] = ACTIONS(9427),
    [sym_complex] = ACTIONS(9425),
    [sym_super] = ACTIONS(9427),
    [anon_sym_true] = ACTIONS(9427),
    [anon_sym_TRUE] = ACTIONS(9427),
    [anon_sym_false] = ACTIONS(9427),
    [anon_sym_FALSE] = ACTIONS(9427),
    [sym_self] = ACTIONS(9427),
    [anon_sym_nil] = ACTIONS(9427),
    [anon_sym_NIL] = ACTIONS(9427),
    [sym_character] = ACTIONS(9425),
    [anon_sym_LBRACK2] = ACTIONS(9427),
    [anon_sym_DASH_GT] = ACTIONS(9425),
  },
  [6698] = {
    [sym__heredoc_body_start] = ACTIONS(9432),
    [sym__binary_minus] = ACTIONS(9432),
    [sym__binary_star] = ACTIONS(9432),
    [anon_sym_LBRACE] = ACTIONS(9432),
    [anon_sym_RBRACE] = ACTIONS(9432),
    [anon_sym_RPAREN] = ACTIONS(9432),
    [anon_sym_DOT] = ACTIONS(9434),
    [anon_sym_COMMA] = ACTIONS(9432),
    [anon_sym_PIPE] = ACTIONS(9434),
    [anon_sym_SEMI] = ACTIONS(9432),
    [anon_sym_STAR_STAR] = ACTIONS(9434),
    [anon_sym_AMP] = ACTIONS(9434),
    [anon_sym_EQ] = ACTIONS(9434),
    [anon_sym_LT] = ACTIONS(9434),
    [anon_sym_if] = ACTIONS(9432),
    [anon_sym_unless] = ACTIONS(9432),
    [anon_sym_while] = ACTIONS(9432),
    [anon_sym_until] = ACTIONS(9432),
    [anon_sym_rescue] = ACTIONS(9432),
    [anon_sym_in] = ACTIONS(9432),
    [anon_sym_do] = ACTIONS(9432),
    [anon_sym_LBRACK] = ACTIONS(9432),
    [anon_sym_RBRACK] = ACTIONS(9432),
    [anon_sym_COLON_COLON2] = ACTIONS(9432),
    [anon_sym_AMP_DOT] = ACTIONS(9432),
    [anon_sym_PLUS_EQ] = ACTIONS(9432),
    [anon_sym_DASH_EQ] = ACTIONS(9432),
    [anon_sym_STAR_EQ] = ACTIONS(9432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9432),
    [anon_sym_SLASH_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_PIPE_EQ] = ACTIONS(9432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9432),
    [anon_sym_AMP_EQ] = ACTIONS(9432),
    [anon_sym_PERCENT_EQ] = ACTIONS(9432),
    [anon_sym_GT_GT_EQ] = ACTIONS(9432),
    [anon_sym_LT_LT_EQ] = ACTIONS(9432),
    [anon_sym_CARET_EQ] = ACTIONS(9432),
    [anon_sym_QMARK] = ACTIONS(9432),
    [anon_sym_COLON2] = ACTIONS(9434),
    [anon_sym_DOT_DOT] = ACTIONS(9434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9432),
    [anon_sym_and] = ACTIONS(9432),
    [anon_sym_or] = ACTIONS(9432),
    [anon_sym_PIPE_PIPE] = ACTIONS(9434),
    [anon_sym_AMP_AMP] = ACTIONS(9434),
    [anon_sym_LT_LT] = ACTIONS(9434),
    [anon_sym_GT_GT] = ACTIONS(9434),
    [anon_sym_EQ_EQ] = ACTIONS(9434),
    [anon_sym_BANG_EQ] = ACTIONS(9432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9432),
    [anon_sym_LT_EQ_GT] = ACTIONS(9432),
    [anon_sym_EQ_TILDE] = ACTIONS(9432),
    [anon_sym_BANG_TILDE] = ACTIONS(9432),
    [anon_sym_LT_EQ] = ACTIONS(9434),
    [anon_sym_GT] = ACTIONS(9434),
    [anon_sym_GT_EQ] = ACTIONS(9432),
    [anon_sym_CARET] = ACTIONS(9434),
    [anon_sym_PLUS] = ACTIONS(9434),
    [anon_sym_SLASH] = ACTIONS(9434),
    [anon_sym_PERCENT] = ACTIONS(9434),
    [sym_comment] = ACTIONS(87),
  },
  [6699] = {
    [anon_sym_RBRACK] = ACTIONS(12102),
    [sym_comment] = ACTIONS(87),
  },
  [6700] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6701] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [6702] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8762),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(8762),
    [sym_operator_assignment] = STATE(8762),
    [sym_conditional] = STATE(8762),
    [sym_range] = STATE(8762),
    [sym_binary] = STATE(8762),
    [sym_unary] = STATE(8762),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6703] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8763),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(8763),
    [sym_operator_assignment] = STATE(8763),
    [sym_conditional] = STATE(8763),
    [sym_range] = STATE(8763),
    [sym_binary] = STATE(8763),
    [sym_unary] = STATE(8763),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6704] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8764),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(8764),
    [sym_operator_assignment] = STATE(8764),
    [sym_conditional] = STATE(8764),
    [sym_range] = STATE(8764),
    [sym_binary] = STATE(8764),
    [sym_unary] = STATE(8764),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6705] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8765),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(8765),
    [sym_operator_assignment] = STATE(8765),
    [sym_conditional] = STATE(8765),
    [sym_range] = STATE(8765),
    [sym_binary] = STATE(8765),
    [sym_unary] = STATE(8765),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6706] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8766),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(8766),
    [sym_operator_assignment] = STATE(8766),
    [sym_conditional] = STATE(8766),
    [sym_range] = STATE(8766),
    [sym_binary] = STATE(8766),
    [sym_unary] = STATE(8766),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6707] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8767),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8767),
    [sym_operator_assignment] = STATE(8767),
    [sym_conditional] = STATE(8767),
    [sym_range] = STATE(8767),
    [sym_binary] = STATE(8767),
    [sym_unary] = STATE(8767),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6708] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8768),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(8768),
    [sym_operator_assignment] = STATE(8768),
    [sym_conditional] = STATE(8768),
    [sym_range] = STATE(8768),
    [sym_binary] = STATE(8768),
    [sym_unary] = STATE(8768),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6709] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8769),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(8769),
    [sym_operator_assignment] = STATE(8769),
    [sym_conditional] = STATE(8769),
    [sym_range] = STATE(8769),
    [sym_binary] = STATE(8769),
    [sym_unary] = STATE(8769),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6710] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8770),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(8770),
    [sym_operator_assignment] = STATE(8770),
    [sym_conditional] = STATE(8770),
    [sym_range] = STATE(8770),
    [sym_binary] = STATE(8770),
    [sym_unary] = STATE(8770),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6711] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8771),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(8771),
    [sym_operator_assignment] = STATE(8771),
    [sym_conditional] = STATE(8771),
    [sym_range] = STATE(8771),
    [sym_binary] = STATE(8771),
    [sym_unary] = STATE(8771),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6712] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8772),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_splat_argument] = STATE(8773),
    [sym_assignment] = STATE(8772),
    [sym_operator_assignment] = STATE(8772),
    [sym_conditional] = STATE(8772),
    [sym_range] = STATE(8772),
    [sym_binary] = STATE(8772),
    [sym_unary] = STATE(8772),
    [sym_right_assignment_list] = STATE(8647),
    [sym__arg_or_splat_arg] = STATE(8773),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(3188),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6713] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8774),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(8774),
    [sym_operator_assignment] = STATE(8774),
    [sym_conditional] = STATE(8774),
    [sym_range] = STATE(8774),
    [sym_binary] = STATE(8774),
    [sym_unary] = STATE(8774),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6714] = {
    [sym_string] = STATE(8775),
    [aux_sym_chained_string_repeat1] = STATE(8775),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [6715] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [6716] = {
    [sym__heredoc_body_start] = ACTIONS(9172),
    [sym__binary_minus] = ACTIONS(9172),
    [sym__binary_star] = ACTIONS(9172),
    [anon_sym_LBRACE] = ACTIONS(9172),
    [anon_sym_RBRACE] = ACTIONS(9172),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9174),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9174),
    [anon_sym_SEMI] = ACTIONS(9172),
    [anon_sym_STAR_STAR] = ACTIONS(9174),
    [anon_sym_AMP] = ACTIONS(9174),
    [anon_sym_EQ] = ACTIONS(9174),
    [anon_sym_LT] = ACTIONS(9174),
    [anon_sym_if] = ACTIONS(9172),
    [anon_sym_unless] = ACTIONS(9172),
    [anon_sym_while] = ACTIONS(9172),
    [anon_sym_until] = ACTIONS(9172),
    [anon_sym_rescue] = ACTIONS(9172),
    [anon_sym_in] = ACTIONS(9172),
    [anon_sym_do] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_RBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [anon_sym_PLUS_EQ] = ACTIONS(9172),
    [anon_sym_DASH_EQ] = ACTIONS(9172),
    [anon_sym_STAR_EQ] = ACTIONS(9172),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9172),
    [anon_sym_SLASH_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_PIPE_EQ] = ACTIONS(9172),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9172),
    [anon_sym_AMP_EQ] = ACTIONS(9172),
    [anon_sym_PERCENT_EQ] = ACTIONS(9172),
    [anon_sym_GT_GT_EQ] = ACTIONS(9172),
    [anon_sym_LT_LT_EQ] = ACTIONS(9172),
    [anon_sym_CARET_EQ] = ACTIONS(9172),
    [anon_sym_QMARK] = ACTIONS(9172),
    [anon_sym_COLON2] = ACTIONS(9174),
    [anon_sym_DOT_DOT] = ACTIONS(9174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9172),
    [anon_sym_and] = ACTIONS(9172),
    [anon_sym_or] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE] = ACTIONS(9174),
    [anon_sym_AMP_AMP] = ACTIONS(9174),
    [anon_sym_LT_LT] = ACTIONS(9174),
    [anon_sym_GT_GT] = ACTIONS(9174),
    [anon_sym_EQ_EQ] = ACTIONS(9174),
    [anon_sym_BANG_EQ] = ACTIONS(9172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9172),
    [anon_sym_LT_EQ_GT] = ACTIONS(9172),
    [anon_sym_EQ_TILDE] = ACTIONS(9172),
    [anon_sym_BANG_TILDE] = ACTIONS(9172),
    [anon_sym_LT_EQ] = ACTIONS(9174),
    [anon_sym_GT] = ACTIONS(9174),
    [anon_sym_GT_EQ] = ACTIONS(9172),
    [anon_sym_CARET] = ACTIONS(9174),
    [anon_sym_PLUS] = ACTIONS(9174),
    [anon_sym_SLASH] = ACTIONS(9174),
    [anon_sym_PERCENT] = ACTIONS(9174),
    [sym_comment] = ACTIONS(87),
  },
  [6717] = {
    [anon_sym_RBRACE] = ACTIONS(12104),
    [sym_comment] = ACTIONS(87),
  },
  [6718] = {
    [sym__heredoc_body_start] = ACTIONS(9192),
    [sym__binary_minus] = ACTIONS(9192),
    [sym__binary_star] = ACTIONS(9192),
    [anon_sym_LBRACE] = ACTIONS(9192),
    [anon_sym_RBRACE] = ACTIONS(9192),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9194),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9194),
    [anon_sym_SEMI] = ACTIONS(9192),
    [anon_sym_STAR_STAR] = ACTIONS(9194),
    [anon_sym_AMP] = ACTIONS(9194),
    [anon_sym_EQ] = ACTIONS(9194),
    [anon_sym_LT] = ACTIONS(9194),
    [anon_sym_if] = ACTIONS(9192),
    [anon_sym_unless] = ACTIONS(9192),
    [anon_sym_while] = ACTIONS(9192),
    [anon_sym_until] = ACTIONS(9192),
    [anon_sym_rescue] = ACTIONS(9192),
    [anon_sym_in] = ACTIONS(9192),
    [anon_sym_do] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_RBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [anon_sym_PLUS_EQ] = ACTIONS(9192),
    [anon_sym_DASH_EQ] = ACTIONS(9192),
    [anon_sym_STAR_EQ] = ACTIONS(9192),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9192),
    [anon_sym_SLASH_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_PIPE_EQ] = ACTIONS(9192),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9192),
    [anon_sym_AMP_EQ] = ACTIONS(9192),
    [anon_sym_PERCENT_EQ] = ACTIONS(9192),
    [anon_sym_GT_GT_EQ] = ACTIONS(9192),
    [anon_sym_LT_LT_EQ] = ACTIONS(9192),
    [anon_sym_CARET_EQ] = ACTIONS(9192),
    [anon_sym_QMARK] = ACTIONS(9192),
    [anon_sym_COLON2] = ACTIONS(9194),
    [anon_sym_DOT_DOT] = ACTIONS(9194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9192),
    [anon_sym_and] = ACTIONS(9192),
    [anon_sym_or] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE] = ACTIONS(9194),
    [anon_sym_AMP_AMP] = ACTIONS(9194),
    [anon_sym_LT_LT] = ACTIONS(9194),
    [anon_sym_GT_GT] = ACTIONS(9194),
    [anon_sym_EQ_EQ] = ACTIONS(9194),
    [anon_sym_BANG_EQ] = ACTIONS(9192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9192),
    [anon_sym_LT_EQ_GT] = ACTIONS(9192),
    [anon_sym_EQ_TILDE] = ACTIONS(9192),
    [anon_sym_BANG_TILDE] = ACTIONS(9192),
    [anon_sym_LT_EQ] = ACTIONS(9194),
    [anon_sym_GT] = ACTIONS(9194),
    [anon_sym_GT_EQ] = ACTIONS(9192),
    [anon_sym_CARET] = ACTIONS(9194),
    [anon_sym_PLUS] = ACTIONS(9194),
    [anon_sym_SLASH] = ACTIONS(9194),
    [anon_sym_PERCENT] = ACTIONS(9194),
    [sym_comment] = ACTIONS(87),
  },
  [6719] = {
    [anon_sym_end] = ACTIONS(12106),
    [sym_comment] = ACTIONS(87),
  },
  [6720] = {
    [sym__statements] = STATE(8778),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12108),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6721] = {
    [sym__statements] = STATE(8778),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(8779),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(8779),
    [sym__line_break] = ACTIONS(12110),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12108),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6722] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [6723] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6724] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [6725] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6726] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6727] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6728] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12112),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6729] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6730] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6731] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6732] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6733] = {
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_COLON2] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [6734] = {
    [sym_heredoc_body] = STATE(6734),
    [aux_sym_call_repeat1] = STATE(6734),
    [sym__heredoc_body_start] = ACTIONS(12063),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [6735] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1833),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3186),
    [sym__splat_star] = ACTIONS(3188),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__identifier_hash_key] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10038),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6736] = {
    [sym_heredoc_body] = STATE(6734),
    [aux_sym_call_repeat1] = STATE(6734),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [6737] = {
    [aux_sym_argument_list_repeat1] = STATE(6737),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12114),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [6738] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6739] = {
    [aux_sym_exceptions_repeat1] = STATE(8782),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [6740] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [6741] = {
    [sym_string] = STATE(6741),
    [aux_sym_chained_string_repeat1] = STATE(6741),
    [sym__string_start] = ACTIONS(10160),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [6742] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_DOT_DOT] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [6743] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(4148),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(540),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(540),
    [sym_splat_argument] = STATE(8300),
    [sym_assignment] = STATE(4148),
    [sym_operator_assignment] = STATE(4148),
    [sym_conditional] = STATE(4148),
    [sym_range] = STATE(4148),
    [sym_binary] = STATE(4148),
    [sym_unary] = STATE(4148),
    [sym__arg_or_splat_arg] = STATE(8300),
    [sym_left_assignment_list] = STATE(539),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(540),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(540),
    [sym_false] = STATE(540),
    [sym_nil] = STATE(540),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(6723),
    [sym__unary_minus] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_defined_QMARK] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6744] = {
    [aux_sym_exceptions_repeat1] = STATE(8783),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(12117),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [6745] = {
    [sym__binary_minus] = ACTIONS(10532),
    [sym__binary_star] = ACTIONS(10532),
    [anon_sym_LBRACE] = ACTIONS(10532),
    [anon_sym_RBRACE] = ACTIONS(10532),
    [anon_sym_RPAREN] = ACTIONS(10532),
    [anon_sym_DOT] = ACTIONS(10534),
    [anon_sym_COMMA] = ACTIONS(10532),
    [anon_sym_PIPE] = ACTIONS(10534),
    [anon_sym_SEMI] = ACTIONS(10532),
    [anon_sym_STAR_STAR] = ACTIONS(10532),
    [anon_sym_AMP] = ACTIONS(10534),
    [anon_sym_LT] = ACTIONS(10534),
    [anon_sym_if] = ACTIONS(10532),
    [anon_sym_unless] = ACTIONS(10532),
    [anon_sym_while] = ACTIONS(10532),
    [anon_sym_until] = ACTIONS(10532),
    [anon_sym_rescue] = ACTIONS(10532),
    [anon_sym_do] = ACTIONS(10532),
    [anon_sym_EQ_GT] = ACTIONS(10532),
    [anon_sym_LBRACK] = ACTIONS(10532),
    [anon_sym_COLON_COLON2] = ACTIONS(10532),
    [anon_sym_AMP_DOT] = ACTIONS(10532),
    [anon_sym_QMARK] = ACTIONS(10532),
    [anon_sym_COLON2] = ACTIONS(10534),
    [anon_sym_DOT_DOT] = ACTIONS(10534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10532),
    [anon_sym_and] = ACTIONS(10532),
    [anon_sym_or] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE] = ACTIONS(10532),
    [anon_sym_AMP_AMP] = ACTIONS(10532),
    [anon_sym_LT_LT] = ACTIONS(10532),
    [anon_sym_GT_GT] = ACTIONS(10532),
    [anon_sym_EQ_EQ] = ACTIONS(10534),
    [anon_sym_BANG_EQ] = ACTIONS(10532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10532),
    [anon_sym_LT_EQ_GT] = ACTIONS(10532),
    [anon_sym_EQ_TILDE] = ACTIONS(10532),
    [anon_sym_BANG_TILDE] = ACTIONS(10532),
    [anon_sym_LT_EQ] = ACTIONS(10534),
    [anon_sym_GT] = ACTIONS(10534),
    [anon_sym_GT_EQ] = ACTIONS(10532),
    [anon_sym_CARET] = ACTIONS(10532),
    [anon_sym_PLUS] = ACTIONS(10532),
    [anon_sym_SLASH] = ACTIONS(10532),
    [anon_sym_PERCENT] = ACTIONS(10532),
    [sym_comment] = ACTIONS(87),
  },
  [6746] = {
    [sym__binary_minus] = ACTIONS(10536),
    [sym__binary_star] = ACTIONS(10536),
    [anon_sym_LBRACE] = ACTIONS(10536),
    [anon_sym_RBRACE] = ACTIONS(10536),
    [anon_sym_RPAREN] = ACTIONS(10536),
    [anon_sym_DOT] = ACTIONS(10538),
    [anon_sym_COMMA] = ACTIONS(10536),
    [anon_sym_PIPE] = ACTIONS(10538),
    [anon_sym_SEMI] = ACTIONS(10536),
    [anon_sym_STAR_STAR] = ACTIONS(10536),
    [anon_sym_AMP] = ACTIONS(10538),
    [anon_sym_LT] = ACTIONS(10538),
    [anon_sym_if] = ACTIONS(10536),
    [anon_sym_unless] = ACTIONS(10536),
    [anon_sym_while] = ACTIONS(10536),
    [anon_sym_until] = ACTIONS(10536),
    [anon_sym_rescue] = ACTIONS(10536),
    [anon_sym_do] = ACTIONS(10536),
    [anon_sym_EQ_GT] = ACTIONS(10536),
    [anon_sym_LBRACK] = ACTIONS(10536),
    [anon_sym_COLON_COLON2] = ACTIONS(10536),
    [anon_sym_AMP_DOT] = ACTIONS(10536),
    [anon_sym_QMARK] = ACTIONS(10536),
    [anon_sym_COLON2] = ACTIONS(10538),
    [anon_sym_DOT_DOT] = ACTIONS(10538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10536),
    [anon_sym_and] = ACTIONS(10536),
    [anon_sym_or] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE] = ACTIONS(10536),
    [anon_sym_AMP_AMP] = ACTIONS(10536),
    [anon_sym_LT_LT] = ACTIONS(10536),
    [anon_sym_GT_GT] = ACTIONS(10536),
    [anon_sym_EQ_EQ] = ACTIONS(10538),
    [anon_sym_BANG_EQ] = ACTIONS(10536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10536),
    [anon_sym_LT_EQ_GT] = ACTIONS(10536),
    [anon_sym_EQ_TILDE] = ACTIONS(10536),
    [anon_sym_BANG_TILDE] = ACTIONS(10536),
    [anon_sym_LT_EQ] = ACTIONS(10538),
    [anon_sym_GT] = ACTIONS(10538),
    [anon_sym_GT_EQ] = ACTIONS(10536),
    [anon_sym_CARET] = ACTIONS(10536),
    [anon_sym_PLUS] = ACTIONS(10536),
    [anon_sym_SLASH] = ACTIONS(10536),
    [anon_sym_PERCENT] = ACTIONS(10536),
    [sym_comment] = ACTIONS(87),
  },
  [6747] = {
    [sym_heredoc_body] = STATE(6747),
    [aux_sym_call_repeat1] = STATE(6747),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [6748] = {
    [sym_heredoc_body] = STATE(6747),
    [aux_sym_call_repeat1] = STATE(6747),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [6749] = {
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10568),
    [anon_sym_unless] = ACTIONS(10568),
    [anon_sym_while] = ACTIONS(10568),
    [anon_sym_until] = ACTIONS(10568),
    [anon_sym_rescue] = ACTIONS(10568),
    [anon_sym_in] = ACTIONS(10568),
    [anon_sym_do] = ACTIONS(10568),
    [anon_sym_EQ_GT] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_RBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10568),
    [anon_sym_COLON2] = ACTIONS(10570),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10568),
    [anon_sym_or] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10568),
    [anon_sym_GT_GT] = ACTIONS(10568),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10568),
    [anon_sym_PLUS] = ACTIONS(10568),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [6750] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8784),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_assignment] = STATE(8784),
    [sym_operator_assignment] = STATE(8784),
    [sym_conditional] = STATE(8784),
    [sym_range] = STATE(8784),
    [sym_binary] = STATE(8784),
    [sym_unary] = STATE(8784),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6751] = {
    [sym__heredoc_body_start] = ACTIONS(6547),
    [sym__binary_minus] = ACTIONS(6547),
    [sym__binary_star] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_DOT] = ACTIONS(8423),
    [anon_sym_COMMA] = ACTIONS(6547),
    [anon_sym_PIPE] = ACTIONS(8423),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym_STAR_STAR] = ACTIONS(6547),
    [anon_sym_AMP] = ACTIONS(8423),
    [anon_sym_EQ] = ACTIONS(8423),
    [anon_sym_LT] = ACTIONS(8423),
    [anon_sym_if] = ACTIONS(6547),
    [anon_sym_unless] = ACTIONS(6547),
    [anon_sym_while] = ACTIONS(6547),
    [anon_sym_until] = ACTIONS(6547),
    [anon_sym_rescue] = ACTIONS(6547),
    [anon_sym_in] = ACTIONS(6547),
    [anon_sym_do] = ACTIONS(6547),
    [anon_sym_EQ_GT] = ACTIONS(6547),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_RBRACK] = ACTIONS(6547),
    [anon_sym_COLON_COLON2] = ACTIONS(6547),
    [anon_sym_AMP_DOT] = ACTIONS(6547),
    [anon_sym_QMARK] = ACTIONS(6547),
    [anon_sym_COLON2] = ACTIONS(8423),
    [anon_sym_DOT_DOT] = ACTIONS(8423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6547),
    [anon_sym_and] = ACTIONS(6547),
    [anon_sym_or] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE] = ACTIONS(6547),
    [anon_sym_AMP_AMP] = ACTIONS(6547),
    [anon_sym_LT_LT] = ACTIONS(6547),
    [anon_sym_GT_GT] = ACTIONS(6547),
    [anon_sym_EQ_EQ] = ACTIONS(8423),
    [anon_sym_BANG_EQ] = ACTIONS(6547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6547),
    [anon_sym_LT_EQ_GT] = ACTIONS(6547),
    [anon_sym_EQ_TILDE] = ACTIONS(6547),
    [anon_sym_BANG_TILDE] = ACTIONS(6547),
    [anon_sym_LT_EQ] = ACTIONS(8423),
    [anon_sym_GT] = ACTIONS(8423),
    [anon_sym_GT_EQ] = ACTIONS(6547),
    [anon_sym_CARET] = ACTIONS(6547),
    [anon_sym_PLUS] = ACTIONS(6547),
    [anon_sym_SLASH] = ACTIONS(6547),
    [anon_sym_PERCENT] = ACTIONS(6547),
    [sym_comment] = ACTIONS(87),
  },
  [6752] = {
    [sym__heredoc_body_start] = ACTIONS(10596),
    [sym__binary_minus] = ACTIONS(10596),
    [sym__binary_star] = ACTIONS(10596),
    [anon_sym_LBRACE] = ACTIONS(10596),
    [anon_sym_RBRACE] = ACTIONS(10596),
    [anon_sym_RPAREN] = ACTIONS(10596),
    [anon_sym_DOT] = ACTIONS(10598),
    [anon_sym_COMMA] = ACTIONS(10596),
    [anon_sym_PIPE] = ACTIONS(10598),
    [anon_sym_SEMI] = ACTIONS(10596),
    [anon_sym_STAR_STAR] = ACTIONS(10596),
    [anon_sym_AMP] = ACTIONS(10598),
    [anon_sym_EQ] = ACTIONS(10598),
    [anon_sym_LT] = ACTIONS(10598),
    [anon_sym_if] = ACTIONS(10596),
    [anon_sym_unless] = ACTIONS(10596),
    [anon_sym_while] = ACTIONS(10596),
    [anon_sym_until] = ACTIONS(10596),
    [anon_sym_rescue] = ACTIONS(10596),
    [anon_sym_in] = ACTIONS(10596),
    [anon_sym_do] = ACTIONS(10596),
    [anon_sym_EQ_GT] = ACTIONS(10596),
    [anon_sym_LBRACK] = ACTIONS(10596),
    [anon_sym_RBRACK] = ACTIONS(10596),
    [anon_sym_COLON_COLON2] = ACTIONS(10596),
    [anon_sym_AMP_DOT] = ACTIONS(10596),
    [anon_sym_QMARK] = ACTIONS(10596),
    [anon_sym_COLON2] = ACTIONS(10598),
    [anon_sym_DOT_DOT] = ACTIONS(10598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10596),
    [anon_sym_and] = ACTIONS(10596),
    [anon_sym_or] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE] = ACTIONS(10596),
    [anon_sym_AMP_AMP] = ACTIONS(10596),
    [anon_sym_LT_LT] = ACTIONS(10596),
    [anon_sym_GT_GT] = ACTIONS(10596),
    [anon_sym_EQ_EQ] = ACTIONS(10598),
    [anon_sym_BANG_EQ] = ACTIONS(10596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10596),
    [anon_sym_LT_EQ_GT] = ACTIONS(10596),
    [anon_sym_EQ_TILDE] = ACTIONS(10596),
    [anon_sym_BANG_TILDE] = ACTIONS(10596),
    [anon_sym_LT_EQ] = ACTIONS(10598),
    [anon_sym_GT] = ACTIONS(10598),
    [anon_sym_GT_EQ] = ACTIONS(10596),
    [anon_sym_CARET] = ACTIONS(10596),
    [anon_sym_PLUS] = ACTIONS(10596),
    [anon_sym_SLASH] = ACTIONS(10596),
    [anon_sym_PERCENT] = ACTIONS(10596),
    [sym_comment] = ACTIONS(87),
  },
  [6753] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4179),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(4179),
    [sym_operator_assignment] = STATE(4179),
    [sym_conditional] = STATE(4179),
    [sym_range] = STATE(4179),
    [sym_binary] = STATE(4179),
    [sym_unary] = STATE(4179),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1843),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(1047),
    [sym__unary_minus] = ACTIONS(1049),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6754] = {
    [aux_sym_exceptions_repeat1] = STATE(8786),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12119),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [6755] = {
    [sym__binary_minus] = ACTIONS(10689),
    [sym__binary_star] = ACTIONS(10689),
    [anon_sym_LBRACE] = ACTIONS(10689),
    [anon_sym_RBRACE] = ACTIONS(10689),
    [anon_sym_RPAREN] = ACTIONS(10689),
    [anon_sym_DOT] = ACTIONS(10691),
    [anon_sym_COMMA] = ACTIONS(10689),
    [anon_sym_PIPE] = ACTIONS(10691),
    [anon_sym_SEMI] = ACTIONS(10689),
    [anon_sym_STAR_STAR] = ACTIONS(10689),
    [anon_sym_AMP] = ACTIONS(10691),
    [anon_sym_LT] = ACTIONS(10691),
    [anon_sym_if] = ACTIONS(10689),
    [anon_sym_unless] = ACTIONS(10689),
    [anon_sym_while] = ACTIONS(10689),
    [anon_sym_until] = ACTIONS(10689),
    [anon_sym_rescue] = ACTIONS(10689),
    [anon_sym_do] = ACTIONS(10689),
    [anon_sym_EQ_GT] = ACTIONS(10689),
    [anon_sym_LBRACK] = ACTIONS(10689),
    [anon_sym_COLON_COLON2] = ACTIONS(10689),
    [anon_sym_AMP_DOT] = ACTIONS(10689),
    [anon_sym_QMARK] = ACTIONS(10689),
    [anon_sym_COLON2] = ACTIONS(10691),
    [anon_sym_DOT_DOT] = ACTIONS(10691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10689),
    [anon_sym_and] = ACTIONS(10689),
    [anon_sym_or] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10689),
    [anon_sym_LT_LT] = ACTIONS(10689),
    [anon_sym_GT_GT] = ACTIONS(10689),
    [anon_sym_EQ_EQ] = ACTIONS(10691),
    [anon_sym_BANG_EQ] = ACTIONS(10689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10689),
    [anon_sym_LT_EQ_GT] = ACTIONS(10689),
    [anon_sym_EQ_TILDE] = ACTIONS(10689),
    [anon_sym_BANG_TILDE] = ACTIONS(10689),
    [anon_sym_LT_EQ] = ACTIONS(10691),
    [anon_sym_GT] = ACTIONS(10691),
    [anon_sym_GT_EQ] = ACTIONS(10689),
    [anon_sym_CARET] = ACTIONS(10689),
    [anon_sym_PLUS] = ACTIONS(10689),
    [anon_sym_SLASH] = ACTIONS(10689),
    [anon_sym_PERCENT] = ACTIONS(10689),
    [sym_comment] = ACTIONS(87),
  },
  [6756] = {
    [anon_sym_end] = ACTIONS(12121),
    [sym_comment] = ACTIONS(87),
  },
  [6757] = {
    [sym_elsif] = STATE(8788),
    [sym_else] = STATE(8788),
    [sym__if_tail] = STATE(8788),
    [anon_sym_end] = ACTIONS(12121),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [6758] = {
    [sym__binary_minus] = ACTIONS(10856),
    [sym__binary_star] = ACTIONS(10856),
    [anon_sym_LBRACE] = ACTIONS(10856),
    [anon_sym_RBRACE] = ACTIONS(10856),
    [anon_sym_RPAREN] = ACTIONS(10856),
    [anon_sym_DOT] = ACTIONS(10858),
    [anon_sym_COMMA] = ACTIONS(10856),
    [anon_sym_PIPE] = ACTIONS(10858),
    [anon_sym_SEMI] = ACTIONS(10856),
    [anon_sym_STAR_STAR] = ACTIONS(10856),
    [anon_sym_AMP] = ACTIONS(10858),
    [anon_sym_LT] = ACTIONS(10858),
    [anon_sym_if] = ACTIONS(10856),
    [anon_sym_unless] = ACTIONS(10856),
    [anon_sym_while] = ACTIONS(10856),
    [anon_sym_until] = ACTIONS(10856),
    [anon_sym_rescue] = ACTIONS(10856),
    [anon_sym_do] = ACTIONS(10856),
    [anon_sym_EQ_GT] = ACTIONS(10856),
    [anon_sym_LBRACK] = ACTIONS(10856),
    [anon_sym_COLON_COLON2] = ACTIONS(10856),
    [anon_sym_AMP_DOT] = ACTIONS(10856),
    [anon_sym_QMARK] = ACTIONS(10856),
    [anon_sym_COLON2] = ACTIONS(10858),
    [anon_sym_DOT_DOT] = ACTIONS(10858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10856),
    [anon_sym_and] = ACTIONS(10856),
    [anon_sym_or] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE] = ACTIONS(10856),
    [anon_sym_AMP_AMP] = ACTIONS(10856),
    [anon_sym_LT_LT] = ACTIONS(10856),
    [anon_sym_GT_GT] = ACTIONS(10856),
    [anon_sym_EQ_EQ] = ACTIONS(10858),
    [anon_sym_BANG_EQ] = ACTIONS(10856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10856),
    [anon_sym_LT_EQ_GT] = ACTIONS(10856),
    [anon_sym_EQ_TILDE] = ACTIONS(10856),
    [anon_sym_BANG_TILDE] = ACTIONS(10856),
    [anon_sym_LT_EQ] = ACTIONS(10858),
    [anon_sym_GT] = ACTIONS(10858),
    [anon_sym_GT_EQ] = ACTIONS(10856),
    [anon_sym_CARET] = ACTIONS(10856),
    [anon_sym_PLUS] = ACTIONS(10856),
    [anon_sym_SLASH] = ACTIONS(10856),
    [anon_sym_PERCENT] = ACTIONS(10856),
    [sym_comment] = ACTIONS(87),
  },
  [6759] = {
    [anon_sym_end] = ACTIONS(12123),
    [sym_comment] = ACTIONS(87),
  },
  [6760] = {
    [sym__binary_minus] = ACTIONS(10951),
    [sym__binary_star] = ACTIONS(10951),
    [anon_sym_LBRACE] = ACTIONS(10951),
    [anon_sym_RBRACE] = ACTIONS(10951),
    [anon_sym_RPAREN] = ACTIONS(10951),
    [anon_sym_DOT] = ACTIONS(10953),
    [anon_sym_COMMA] = ACTIONS(10951),
    [anon_sym_PIPE] = ACTIONS(10953),
    [anon_sym_SEMI] = ACTIONS(10951),
    [anon_sym_STAR_STAR] = ACTIONS(10951),
    [anon_sym_AMP] = ACTIONS(10953),
    [anon_sym_LT] = ACTIONS(10953),
    [anon_sym_if] = ACTIONS(10951),
    [anon_sym_unless] = ACTIONS(10951),
    [anon_sym_while] = ACTIONS(10951),
    [anon_sym_until] = ACTIONS(10951),
    [anon_sym_rescue] = ACTIONS(10951),
    [anon_sym_do] = ACTIONS(10951),
    [anon_sym_EQ_GT] = ACTIONS(10951),
    [anon_sym_LBRACK] = ACTIONS(10951),
    [anon_sym_COLON_COLON2] = ACTIONS(10951),
    [anon_sym_AMP_DOT] = ACTIONS(10951),
    [anon_sym_QMARK] = ACTIONS(10951),
    [anon_sym_COLON2] = ACTIONS(10953),
    [anon_sym_DOT_DOT] = ACTIONS(10953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10951),
    [anon_sym_and] = ACTIONS(10951),
    [anon_sym_or] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE] = ACTIONS(10951),
    [anon_sym_AMP_AMP] = ACTIONS(10951),
    [anon_sym_LT_LT] = ACTIONS(10951),
    [anon_sym_GT_GT] = ACTIONS(10951),
    [anon_sym_EQ_EQ] = ACTIONS(10953),
    [anon_sym_BANG_EQ] = ACTIONS(10951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10951),
    [anon_sym_LT_EQ_GT] = ACTIONS(10951),
    [anon_sym_EQ_TILDE] = ACTIONS(10951),
    [anon_sym_BANG_TILDE] = ACTIONS(10951),
    [anon_sym_LT_EQ] = ACTIONS(10953),
    [anon_sym_GT] = ACTIONS(10953),
    [anon_sym_GT_EQ] = ACTIONS(10951),
    [anon_sym_CARET] = ACTIONS(10951),
    [anon_sym_PLUS] = ACTIONS(10951),
    [anon_sym_SLASH] = ACTIONS(10951),
    [anon_sym_PERCENT] = ACTIONS(10951),
    [sym_comment] = ACTIONS(87),
  },
  [6761] = {
    [sym__binary_minus] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10960),
    [anon_sym_LBRACE] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10960),
    [anon_sym_RPAREN] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10960),
    [anon_sym_COLON_COLON2] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_COLON2] = ACTIONS(10962),
    [anon_sym_DOT_DOT] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_EQ_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10962),
    [anon_sym_GT] = ACTIONS(10962),
    [anon_sym_GT_EQ] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_SLASH] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_comment] = ACTIONS(87),
  },
  [6762] = {
    [sym__binary_minus] = ACTIONS(11007),
    [sym__binary_star] = ACTIONS(11007),
    [anon_sym_LBRACE] = ACTIONS(11007),
    [anon_sym_RBRACE] = ACTIONS(11007),
    [anon_sym_RPAREN] = ACTIONS(11007),
    [anon_sym_DOT] = ACTIONS(11009),
    [anon_sym_COMMA] = ACTIONS(11007),
    [anon_sym_PIPE] = ACTIONS(11009),
    [anon_sym_SEMI] = ACTIONS(11007),
    [anon_sym_STAR_STAR] = ACTIONS(11007),
    [anon_sym_AMP] = ACTIONS(11009),
    [anon_sym_LT] = ACTIONS(11009),
    [anon_sym_if] = ACTIONS(11007),
    [anon_sym_unless] = ACTIONS(11007),
    [anon_sym_while] = ACTIONS(11007),
    [anon_sym_until] = ACTIONS(11007),
    [anon_sym_rescue] = ACTIONS(11007),
    [anon_sym_do] = ACTIONS(11007),
    [anon_sym_EQ_GT] = ACTIONS(11007),
    [anon_sym_LBRACK] = ACTIONS(11007),
    [anon_sym_COLON_COLON2] = ACTIONS(11007),
    [anon_sym_AMP_DOT] = ACTIONS(11007),
    [anon_sym_QMARK] = ACTIONS(11007),
    [anon_sym_COLON2] = ACTIONS(11009),
    [anon_sym_DOT_DOT] = ACTIONS(11009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11007),
    [anon_sym_and] = ACTIONS(11007),
    [anon_sym_or] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE] = ACTIONS(11007),
    [anon_sym_AMP_AMP] = ACTIONS(11007),
    [anon_sym_LT_LT] = ACTIONS(11007),
    [anon_sym_GT_GT] = ACTIONS(11007),
    [anon_sym_EQ_EQ] = ACTIONS(11009),
    [anon_sym_BANG_EQ] = ACTIONS(11007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11007),
    [anon_sym_LT_EQ_GT] = ACTIONS(11007),
    [anon_sym_EQ_TILDE] = ACTIONS(11007),
    [anon_sym_BANG_TILDE] = ACTIONS(11007),
    [anon_sym_LT_EQ] = ACTIONS(11009),
    [anon_sym_GT] = ACTIONS(11009),
    [anon_sym_GT_EQ] = ACTIONS(11007),
    [anon_sym_CARET] = ACTIONS(11007),
    [anon_sym_PLUS] = ACTIONS(11007),
    [anon_sym_SLASH] = ACTIONS(11007),
    [anon_sym_PERCENT] = ACTIONS(11007),
    [sym_comment] = ACTIONS(87),
  },
  [6763] = {
    [anon_sym_end] = ACTIONS(12125),
    [sym_comment] = ACTIONS(87),
  },
  [6764] = {
    [sym__binary_minus] = ACTIONS(11020),
    [sym__binary_star] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_RBRACE] = ACTIONS(11020),
    [anon_sym_RPAREN] = ACTIONS(11020),
    [anon_sym_DOT] = ACTIONS(11022),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_PIPE] = ACTIONS(11022),
    [anon_sym_SEMI] = ACTIONS(11020),
    [anon_sym_STAR_STAR] = ACTIONS(11020),
    [anon_sym_AMP] = ACTIONS(11022),
    [anon_sym_LT] = ACTIONS(11022),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_unless] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [anon_sym_until] = ACTIONS(11020),
    [anon_sym_rescue] = ACTIONS(11020),
    [anon_sym_do] = ACTIONS(11020),
    [anon_sym_EQ_GT] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_COLON_COLON2] = ACTIONS(11020),
    [anon_sym_AMP_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11022),
    [anon_sym_DOT_DOT] = ACTIONS(11022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_and] = ACTIONS(11020),
    [anon_sym_or] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE] = ACTIONS(11020),
    [anon_sym_AMP_AMP] = ACTIONS(11020),
    [anon_sym_LT_LT] = ACTIONS(11020),
    [anon_sym_GT_GT] = ACTIONS(11020),
    [anon_sym_EQ_EQ] = ACTIONS(11022),
    [anon_sym_BANG_EQ] = ACTIONS(11020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11020),
    [anon_sym_LT_EQ_GT] = ACTIONS(11020),
    [anon_sym_EQ_TILDE] = ACTIONS(11020),
    [anon_sym_BANG_TILDE] = ACTIONS(11020),
    [anon_sym_LT_EQ] = ACTIONS(11022),
    [anon_sym_GT] = ACTIONS(11022),
    [anon_sym_GT_EQ] = ACTIONS(11020),
    [anon_sym_CARET] = ACTIONS(11020),
    [anon_sym_PLUS] = ACTIONS(11020),
    [anon_sym_SLASH] = ACTIONS(11020),
    [anon_sym_PERCENT] = ACTIONS(11020),
    [sym_comment] = ACTIONS(87),
  },
  [6765] = {
    [anon_sym_end] = ACTIONS(12127),
    [sym_comment] = ACTIONS(87),
  },
  [6766] = {
    [sym__binary_minus] = ACTIONS(11466),
    [sym__binary_star] = ACTIONS(11466),
    [anon_sym_LBRACE] = ACTIONS(11466),
    [anon_sym_RBRACE] = ACTIONS(11466),
    [anon_sym_RPAREN] = ACTIONS(11466),
    [anon_sym_DOT] = ACTIONS(11468),
    [anon_sym_COMMA] = ACTIONS(11466),
    [anon_sym_PIPE] = ACTIONS(11468),
    [anon_sym_SEMI] = ACTIONS(11466),
    [anon_sym_STAR_STAR] = ACTIONS(11466),
    [anon_sym_AMP] = ACTIONS(11468),
    [anon_sym_LT] = ACTIONS(11468),
    [anon_sym_if] = ACTIONS(11466),
    [anon_sym_unless] = ACTIONS(11466),
    [anon_sym_while] = ACTIONS(11466),
    [anon_sym_until] = ACTIONS(11466),
    [anon_sym_rescue] = ACTIONS(11466),
    [anon_sym_do] = ACTIONS(11466),
    [anon_sym_EQ_GT] = ACTIONS(11466),
    [anon_sym_LBRACK] = ACTIONS(11466),
    [anon_sym_COLON_COLON2] = ACTIONS(11466),
    [anon_sym_AMP_DOT] = ACTIONS(11466),
    [anon_sym_QMARK] = ACTIONS(11466),
    [anon_sym_COLON2] = ACTIONS(11468),
    [anon_sym_DOT_DOT] = ACTIONS(11468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11466),
    [anon_sym_and] = ACTIONS(11466),
    [anon_sym_or] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE] = ACTIONS(11466),
    [anon_sym_AMP_AMP] = ACTIONS(11466),
    [anon_sym_LT_LT] = ACTIONS(11466),
    [anon_sym_GT_GT] = ACTIONS(11466),
    [anon_sym_EQ_EQ] = ACTIONS(11468),
    [anon_sym_BANG_EQ] = ACTIONS(11466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11466),
    [anon_sym_LT_EQ_GT] = ACTIONS(11466),
    [anon_sym_EQ_TILDE] = ACTIONS(11466),
    [anon_sym_BANG_TILDE] = ACTIONS(11466),
    [anon_sym_LT_EQ] = ACTIONS(11468),
    [anon_sym_GT] = ACTIONS(11468),
    [anon_sym_GT_EQ] = ACTIONS(11466),
    [anon_sym_CARET] = ACTIONS(11466),
    [anon_sym_PLUS] = ACTIONS(11466),
    [anon_sym_SLASH] = ACTIONS(11466),
    [anon_sym_PERCENT] = ACTIONS(11466),
    [sym_comment] = ACTIONS(87),
  },
  [6767] = {
    [anon_sym_end] = ACTIONS(12129),
    [sym_comment] = ACTIONS(87),
  },
  [6768] = {
    [sym__binary_minus] = ACTIONS(11655),
    [sym__binary_star] = ACTIONS(11655),
    [anon_sym_LBRACE] = ACTIONS(11655),
    [anon_sym_RBRACE] = ACTIONS(11655),
    [anon_sym_RPAREN] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11657),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11657),
    [anon_sym_SEMI] = ACTIONS(11655),
    [anon_sym_STAR_STAR] = ACTIONS(11655),
    [anon_sym_AMP] = ACTIONS(11657),
    [anon_sym_LT] = ACTIONS(11657),
    [anon_sym_if] = ACTIONS(11655),
    [anon_sym_unless] = ACTIONS(11655),
    [anon_sym_while] = ACTIONS(11655),
    [anon_sym_until] = ACTIONS(11655),
    [anon_sym_rescue] = ACTIONS(11655),
    [anon_sym_do] = ACTIONS(11655),
    [anon_sym_EQ_GT] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [anon_sym_QMARK] = ACTIONS(11655),
    [anon_sym_COLON2] = ACTIONS(11657),
    [anon_sym_DOT_DOT] = ACTIONS(11657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11655),
    [anon_sym_and] = ACTIONS(11655),
    [anon_sym_or] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE] = ACTIONS(11655),
    [anon_sym_AMP_AMP] = ACTIONS(11655),
    [anon_sym_LT_LT] = ACTIONS(11655),
    [anon_sym_GT_GT] = ACTIONS(11655),
    [anon_sym_EQ_EQ] = ACTIONS(11657),
    [anon_sym_BANG_EQ] = ACTIONS(11655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11655),
    [anon_sym_LT_EQ_GT] = ACTIONS(11655),
    [anon_sym_EQ_TILDE] = ACTIONS(11655),
    [anon_sym_BANG_TILDE] = ACTIONS(11655),
    [anon_sym_LT_EQ] = ACTIONS(11657),
    [anon_sym_GT] = ACTIONS(11657),
    [anon_sym_GT_EQ] = ACTIONS(11655),
    [anon_sym_CARET] = ACTIONS(11655),
    [anon_sym_PLUS] = ACTIONS(11655),
    [anon_sym_SLASH] = ACTIONS(11655),
    [anon_sym_PERCENT] = ACTIONS(11655),
    [sym_comment] = ACTIONS(87),
  },
  [6769] = {
    [sym__binary_minus] = ACTIONS(11680),
    [sym__binary_star] = ACTIONS(11680),
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RBRACE] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11682),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11682),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_STAR_STAR] = ACTIONS(11680),
    [anon_sym_AMP] = ACTIONS(11682),
    [anon_sym_LT] = ACTIONS(11682),
    [anon_sym_if] = ACTIONS(11680),
    [anon_sym_unless] = ACTIONS(11680),
    [anon_sym_while] = ACTIONS(11680),
    [anon_sym_until] = ACTIONS(11680),
    [anon_sym_rescue] = ACTIONS(11680),
    [anon_sym_do] = ACTIONS(11680),
    [anon_sym_EQ_GT] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_COLON2] = ACTIONS(11682),
    [anon_sym_DOT_DOT] = ACTIONS(11682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_and] = ACTIONS(11680),
    [anon_sym_or] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE] = ACTIONS(11680),
    [anon_sym_AMP_AMP] = ACTIONS(11680),
    [anon_sym_LT_LT] = ACTIONS(11680),
    [anon_sym_GT_GT] = ACTIONS(11680),
    [anon_sym_EQ_EQ] = ACTIONS(11682),
    [anon_sym_BANG_EQ] = ACTIONS(11680),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11680),
    [anon_sym_LT_EQ_GT] = ACTIONS(11680),
    [anon_sym_EQ_TILDE] = ACTIONS(11680),
    [anon_sym_BANG_TILDE] = ACTIONS(11680),
    [anon_sym_LT_EQ] = ACTIONS(11682),
    [anon_sym_GT] = ACTIONS(11682),
    [anon_sym_GT_EQ] = ACTIONS(11680),
    [anon_sym_CARET] = ACTIONS(11680),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11680),
    [anon_sym_PERCENT] = ACTIONS(11680),
    [sym_comment] = ACTIONS(87),
  },
  [6770] = {
    [anon_sym_end] = ACTIONS(12131),
    [sym_comment] = ACTIONS(87),
  },
  [6771] = {
    [sym__statements] = STATE(8794),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12133),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6772] = {
    [sym__binary_minus] = ACTIONS(1103),
    [sym__binary_star] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_DOT_DOT] = ACTIONS(1115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1117),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_LT_EQ_GT] = ACTIONS(1121),
    [anon_sym_EQ_TILDE] = ACTIONS(1121),
    [anon_sym_BANG_TILDE] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(87),
  },
  [6773] = {
    [sym__simple_symbol] = ACTIONS(7608),
    [sym__string_start] = ACTIONS(7608),
    [sym__symbol_start] = ACTIONS(7608),
    [sym__subshell_start] = ACTIONS(7608),
    [sym__regex_start] = ACTIONS(7608),
    [sym__string_array_start] = ACTIONS(7608),
    [sym__symbol_array_start] = ACTIONS(7608),
    [sym_heredoc_beginning] = ACTIONS(7608),
    [sym__block_ampersand] = ACTIONS(7608),
    [sym__splat_star] = ACTIONS(7608),
    [sym__unary_minus] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [sym__identifier_hash_key] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_def] = ACTIONS(7610),
    [anon_sym_LPAREN] = ACTIONS(7610),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COLON_COLON] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_STAR] = ACTIONS(7610),
    [anon_sym_STAR_STAR] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_class] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_module] = ACTIONS(7610),
    [anon_sym_return] = ACTIONS(7610),
    [anon_sym_yield] = ACTIONS(7610),
    [anon_sym_break] = ACTIONS(7610),
    [anon_sym_next] = ACTIONS(7610),
    [sym_redo] = ACTIONS(7610),
    [sym_retry] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7610),
    [anon_sym_unless] = ACTIONS(7610),
    [anon_sym_while] = ACTIONS(7610),
    [anon_sym_until] = ACTIONS(7610),
    [anon_sym_for] = ACTIONS(7610),
    [anon_sym_do] = ACTIONS(7610),
    [anon_sym_case] = ACTIONS(7610),
    [anon_sym_begin] = ACTIONS(7610),
    [anon_sym_EQ_GT] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_LPAREN2] = ACTIONS(7608),
    [anon_sym_PLUS_EQ] = ACTIONS(7608),
    [anon_sym_DASH_EQ] = ACTIONS(7608),
    [anon_sym_STAR_EQ] = ACTIONS(7608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7608),
    [anon_sym_SLASH_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7608),
    [anon_sym_AMP_EQ] = ACTIONS(7608),
    [anon_sym_PERCENT_EQ] = ACTIONS(7608),
    [anon_sym_GT_GT_EQ] = ACTIONS(7608),
    [anon_sym_LT_LT_EQ] = ACTIONS(7608),
    [anon_sym_CARET_EQ] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7610),
    [anon_sym_or] = ACTIONS(7610),
    [anon_sym_PIPE_PIPE] = ACTIONS(7610),
    [anon_sym_AMP_AMP] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [anon_sym_defined_QMARK] = ACTIONS(7608),
    [anon_sym_not] = ACTIONS(7610),
    [anon_sym_BANG] = ACTIONS(7610),
    [anon_sym_TILDE] = ACTIONS(7608),
    [sym_constant] = ACTIONS(7610),
    [sym_identifier] = ACTIONS(7610),
    [sym_instance_variable] = ACTIONS(7608),
    [sym_class_variable] = ACTIONS(7608),
    [sym_global_variable] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7610),
    [sym_float] = ACTIONS(7610),
    [sym_complex] = ACTIONS(7608),
    [sym_super] = ACTIONS(7610),
    [anon_sym_true] = ACTIONS(7610),
    [anon_sym_TRUE] = ACTIONS(7610),
    [anon_sym_false] = ACTIONS(7610),
    [anon_sym_FALSE] = ACTIONS(7610),
    [sym_self] = ACTIONS(7610),
    [anon_sym_nil] = ACTIONS(7610),
    [anon_sym_NIL] = ACTIONS(7610),
    [sym_character] = ACTIONS(7608),
    [anon_sym_LBRACK2] = ACTIONS(7610),
    [anon_sym_DASH_GT] = ACTIONS(7608),
  },
  [6774] = {
    [anon_sym_RPAREN] = ACTIONS(12135),
    [sym_comment] = ACTIONS(87),
  },
  [6775] = {
    [sym__binary_minus] = ACTIONS(11825),
    [sym__binary_star] = ACTIONS(11825),
    [anon_sym_DOT] = ACTIONS(11827),
    [anon_sym_COMMA] = ACTIONS(11825),
    [anon_sym_PIPE] = ACTIONS(11827),
    [anon_sym_STAR_STAR] = ACTIONS(11827),
    [anon_sym_AMP] = ACTIONS(11827),
    [anon_sym_EQ] = ACTIONS(11827),
    [anon_sym_LT] = ACTIONS(11827),
    [anon_sym_EQ_GT] = ACTIONS(11825),
    [anon_sym_LBRACK] = ACTIONS(11825),
    [anon_sym_COLON_COLON2] = ACTIONS(11825),
    [anon_sym_AMP_DOT] = ACTIONS(11825),
    [anon_sym_PLUS_EQ] = ACTIONS(11825),
    [anon_sym_DASH_EQ] = ACTIONS(11825),
    [anon_sym_STAR_EQ] = ACTIONS(11825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11825),
    [anon_sym_SLASH_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11825),
    [anon_sym_AMP_EQ] = ACTIONS(11825),
    [anon_sym_PERCENT_EQ] = ACTIONS(11825),
    [anon_sym_GT_GT_EQ] = ACTIONS(11825),
    [anon_sym_LT_LT_EQ] = ACTIONS(11825),
    [anon_sym_CARET_EQ] = ACTIONS(11825),
    [anon_sym_QMARK] = ACTIONS(11825),
    [anon_sym_DOT_DOT] = ACTIONS(11827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11825),
    [anon_sym_and] = ACTIONS(11825),
    [anon_sym_or] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11827),
    [anon_sym_AMP_AMP] = ACTIONS(11827),
    [anon_sym_LT_LT] = ACTIONS(11827),
    [anon_sym_GT_GT] = ACTIONS(11827),
    [anon_sym_EQ_EQ] = ACTIONS(11827),
    [anon_sym_BANG_EQ] = ACTIONS(11825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11825),
    [anon_sym_LT_EQ_GT] = ACTIONS(11825),
    [anon_sym_EQ_TILDE] = ACTIONS(11825),
    [anon_sym_BANG_TILDE] = ACTIONS(11825),
    [anon_sym_LT_EQ] = ACTIONS(11827),
    [anon_sym_GT] = ACTIONS(11827),
    [anon_sym_GT_EQ] = ACTIONS(11825),
    [anon_sym_CARET] = ACTIONS(11827),
    [anon_sym_PLUS] = ACTIONS(11827),
    [anon_sym_SLASH] = ACTIONS(11827),
    [anon_sym_PERCENT] = ACTIONS(11827),
    [sym_comment] = ACTIONS(87),
  },
  [6776] = {
    [sym__heredoc_body_start] = ACTIONS(6333),
    [sym__binary_minus] = ACTIONS(6333),
    [sym__binary_star] = ACTIONS(6333),
    [anon_sym_LBRACE] = ACTIONS(6333),
    [anon_sym_RBRACE] = ACTIONS(6333),
    [anon_sym_RPAREN] = ACTIONS(6333),
    [anon_sym_DOT] = ACTIONS(6335),
    [anon_sym_COMMA] = ACTIONS(6333),
    [anon_sym_PIPE] = ACTIONS(6335),
    [anon_sym_SEMI] = ACTIONS(6333),
    [anon_sym_STAR_STAR] = ACTIONS(6335),
    [anon_sym_AMP] = ACTIONS(6335),
    [anon_sym_EQ] = ACTIONS(6335),
    [anon_sym_LT] = ACTIONS(6335),
    [anon_sym_if] = ACTIONS(6333),
    [anon_sym_unless] = ACTIONS(6333),
    [anon_sym_while] = ACTIONS(6333),
    [anon_sym_until] = ACTIONS(6333),
    [anon_sym_rescue] = ACTIONS(6333),
    [anon_sym_in] = ACTIONS(6333),
    [anon_sym_do] = ACTIONS(6333),
    [anon_sym_EQ_GT] = ACTIONS(6333),
    [anon_sym_LBRACK] = ACTIONS(6333),
    [anon_sym_RBRACK] = ACTIONS(6333),
    [anon_sym_COLON_COLON2] = ACTIONS(6333),
    [anon_sym_AMP_DOT] = ACTIONS(6333),
    [anon_sym_PLUS_EQ] = ACTIONS(6333),
    [anon_sym_DASH_EQ] = ACTIONS(6333),
    [anon_sym_STAR_EQ] = ACTIONS(6333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6333),
    [anon_sym_SLASH_EQ] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6333),
    [anon_sym_PIPE_EQ] = ACTIONS(6333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6333),
    [anon_sym_AMP_EQ] = ACTIONS(6333),
    [anon_sym_PERCENT_EQ] = ACTIONS(6333),
    [anon_sym_GT_GT_EQ] = ACTIONS(6333),
    [anon_sym_LT_LT_EQ] = ACTIONS(6333),
    [anon_sym_CARET_EQ] = ACTIONS(6333),
    [anon_sym_QMARK] = ACTIONS(6333),
    [anon_sym_COLON2] = ACTIONS(6335),
    [anon_sym_DOT_DOT] = ACTIONS(6335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6333),
    [anon_sym_and] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE] = ACTIONS(6335),
    [anon_sym_AMP_AMP] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6335),
    [anon_sym_GT_GT] = ACTIONS(6335),
    [anon_sym_EQ_EQ] = ACTIONS(6335),
    [anon_sym_BANG_EQ] = ACTIONS(6333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6333),
    [anon_sym_LT_EQ_GT] = ACTIONS(6333),
    [anon_sym_EQ_TILDE] = ACTIONS(6333),
    [anon_sym_BANG_TILDE] = ACTIONS(6333),
    [anon_sym_LT_EQ] = ACTIONS(6335),
    [anon_sym_GT] = ACTIONS(6335),
    [anon_sym_GT_EQ] = ACTIONS(6333),
    [anon_sym_CARET] = ACTIONS(6335),
    [anon_sym_PLUS] = ACTIONS(6335),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_PERCENT] = ACTIONS(6335),
    [sym_comment] = ACTIONS(87),
  },
  [6777] = {
    [sym__heredoc_body_start] = ACTIONS(6337),
    [sym__binary_minus] = ACTIONS(6337),
    [sym__binary_star] = ACTIONS(6337),
    [anon_sym_LBRACE] = ACTIONS(6337),
    [anon_sym_RBRACE] = ACTIONS(6337),
    [anon_sym_RPAREN] = ACTIONS(6337),
    [anon_sym_DOT] = ACTIONS(6339),
    [anon_sym_COMMA] = ACTIONS(6337),
    [anon_sym_PIPE] = ACTIONS(6339),
    [anon_sym_SEMI] = ACTIONS(6337),
    [anon_sym_STAR_STAR] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6339),
    [anon_sym_EQ] = ACTIONS(6339),
    [anon_sym_LT] = ACTIONS(6339),
    [anon_sym_if] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6337),
    [anon_sym_while] = ACTIONS(6337),
    [anon_sym_until] = ACTIONS(6337),
    [anon_sym_rescue] = ACTIONS(6337),
    [anon_sym_in] = ACTIONS(6337),
    [anon_sym_do] = ACTIONS(6337),
    [anon_sym_EQ_GT] = ACTIONS(6337),
    [anon_sym_LBRACK] = ACTIONS(6337),
    [anon_sym_RBRACK] = ACTIONS(6337),
    [anon_sym_COLON_COLON2] = ACTIONS(6337),
    [anon_sym_AMP_DOT] = ACTIONS(6337),
    [anon_sym_PLUS_EQ] = ACTIONS(6337),
    [anon_sym_DASH_EQ] = ACTIONS(6337),
    [anon_sym_STAR_EQ] = ACTIONS(6337),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6337),
    [anon_sym_SLASH_EQ] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6337),
    [anon_sym_PIPE_EQ] = ACTIONS(6337),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6337),
    [anon_sym_AMP_EQ] = ACTIONS(6337),
    [anon_sym_PERCENT_EQ] = ACTIONS(6337),
    [anon_sym_GT_GT_EQ] = ACTIONS(6337),
    [anon_sym_LT_LT_EQ] = ACTIONS(6337),
    [anon_sym_CARET_EQ] = ACTIONS(6337),
    [anon_sym_QMARK] = ACTIONS(6337),
    [anon_sym_COLON2] = ACTIONS(6339),
    [anon_sym_DOT_DOT] = ACTIONS(6339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6337),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6339),
    [anon_sym_AMP_AMP] = ACTIONS(6339),
    [anon_sym_LT_LT] = ACTIONS(6339),
    [anon_sym_GT_GT] = ACTIONS(6339),
    [anon_sym_EQ_EQ] = ACTIONS(6339),
    [anon_sym_BANG_EQ] = ACTIONS(6337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6337),
    [anon_sym_LT_EQ_GT] = ACTIONS(6337),
    [anon_sym_EQ_TILDE] = ACTIONS(6337),
    [anon_sym_BANG_TILDE] = ACTIONS(6337),
    [anon_sym_LT_EQ] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6339),
    [anon_sym_GT_EQ] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6339),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_SLASH] = ACTIONS(6339),
    [anon_sym_PERCENT] = ACTIONS(6339),
    [sym_comment] = ACTIONS(87),
  },
  [6778] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12137),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6779] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(12137),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12139),
  },
  [6780] = {
    [sym__heredoc_body_start] = ACTIONS(6345),
    [sym__binary_minus] = ACTIONS(6345),
    [sym__binary_star] = ACTIONS(6345),
    [anon_sym_LBRACE] = ACTIONS(6345),
    [anon_sym_RBRACE] = ACTIONS(6345),
    [anon_sym_RPAREN] = ACTIONS(6345),
    [anon_sym_DOT] = ACTIONS(6347),
    [anon_sym_COMMA] = ACTIONS(6345),
    [anon_sym_PIPE] = ACTIONS(6347),
    [anon_sym_SEMI] = ACTIONS(6345),
    [anon_sym_STAR_STAR] = ACTIONS(6347),
    [anon_sym_AMP] = ACTIONS(6347),
    [anon_sym_EQ] = ACTIONS(6347),
    [anon_sym_LT] = ACTIONS(6347),
    [anon_sym_if] = ACTIONS(6345),
    [anon_sym_unless] = ACTIONS(6345),
    [anon_sym_while] = ACTIONS(6345),
    [anon_sym_until] = ACTIONS(6345),
    [anon_sym_rescue] = ACTIONS(6345),
    [anon_sym_in] = ACTIONS(6345),
    [anon_sym_do] = ACTIONS(6345),
    [anon_sym_EQ_GT] = ACTIONS(6345),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_RBRACK] = ACTIONS(6345),
    [anon_sym_COLON_COLON2] = ACTIONS(6345),
    [anon_sym_AMP_DOT] = ACTIONS(6345),
    [anon_sym_PLUS_EQ] = ACTIONS(6345),
    [anon_sym_DASH_EQ] = ACTIONS(6345),
    [anon_sym_STAR_EQ] = ACTIONS(6345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6345),
    [anon_sym_SLASH_EQ] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6345),
    [anon_sym_PIPE_EQ] = ACTIONS(6345),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6345),
    [anon_sym_AMP_EQ] = ACTIONS(6345),
    [anon_sym_PERCENT_EQ] = ACTIONS(6345),
    [anon_sym_GT_GT_EQ] = ACTIONS(6345),
    [anon_sym_LT_LT_EQ] = ACTIONS(6345),
    [anon_sym_CARET_EQ] = ACTIONS(6345),
    [anon_sym_QMARK] = ACTIONS(6345),
    [anon_sym_COLON2] = ACTIONS(6347),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6345),
    [anon_sym_and] = ACTIONS(6345),
    [anon_sym_or] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6347),
    [anon_sym_LT_LT] = ACTIONS(6347),
    [anon_sym_GT_GT] = ACTIONS(6347),
    [anon_sym_EQ_EQ] = ACTIONS(6347),
    [anon_sym_BANG_EQ] = ACTIONS(6345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6345),
    [anon_sym_LT_EQ_GT] = ACTIONS(6345),
    [anon_sym_EQ_TILDE] = ACTIONS(6345),
    [anon_sym_BANG_TILDE] = ACTIONS(6345),
    [anon_sym_LT_EQ] = ACTIONS(6347),
    [anon_sym_GT] = ACTIONS(6347),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_CARET] = ACTIONS(6347),
    [anon_sym_PLUS] = ACTIONS(6347),
    [anon_sym_SLASH] = ACTIONS(6347),
    [anon_sym_PERCENT] = ACTIONS(6347),
    [sym_comment] = ACTIONS(87),
  },
  [6781] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12141),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6782] = {
    [sym__heredoc_body_start] = ACTIONS(6358),
    [sym__binary_minus] = ACTIONS(6358),
    [sym__binary_star] = ACTIONS(6358),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RBRACE] = ACTIONS(6358),
    [anon_sym_RPAREN] = ACTIONS(6358),
    [anon_sym_DOT] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6360),
    [anon_sym_SEMI] = ACTIONS(6358),
    [anon_sym_STAR_STAR] = ACTIONS(6360),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6360),
    [anon_sym_if] = ACTIONS(6358),
    [anon_sym_unless] = ACTIONS(6358),
    [anon_sym_while] = ACTIONS(6358),
    [anon_sym_until] = ACTIONS(6358),
    [anon_sym_rescue] = ACTIONS(6358),
    [anon_sym_in] = ACTIONS(6358),
    [anon_sym_do] = ACTIONS(6358),
    [anon_sym_EQ_GT] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6358),
    [anon_sym_RBRACK] = ACTIONS(6358),
    [anon_sym_COLON_COLON2] = ACTIONS(6358),
    [anon_sym_AMP_DOT] = ACTIONS(6358),
    [anon_sym_PLUS_EQ] = ACTIONS(6358),
    [anon_sym_DASH_EQ] = ACTIONS(6358),
    [anon_sym_STAR_EQ] = ACTIONS(6358),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6358),
    [anon_sym_SLASH_EQ] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6358),
    [anon_sym_PIPE_EQ] = ACTIONS(6358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6358),
    [anon_sym_AMP_EQ] = ACTIONS(6358),
    [anon_sym_PERCENT_EQ] = ACTIONS(6358),
    [anon_sym_GT_GT_EQ] = ACTIONS(6358),
    [anon_sym_LT_LT_EQ] = ACTIONS(6358),
    [anon_sym_CARET_EQ] = ACTIONS(6358),
    [anon_sym_QMARK] = ACTIONS(6358),
    [anon_sym_COLON2] = ACTIONS(6360),
    [anon_sym_DOT_DOT] = ACTIONS(6360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6358),
    [anon_sym_and] = ACTIONS(6358),
    [anon_sym_or] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE] = ACTIONS(6360),
    [anon_sym_AMP_AMP] = ACTIONS(6360),
    [anon_sym_LT_LT] = ACTIONS(6360),
    [anon_sym_GT_GT] = ACTIONS(6360),
    [anon_sym_EQ_EQ] = ACTIONS(6360),
    [anon_sym_BANG_EQ] = ACTIONS(6358),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6358),
    [anon_sym_LT_EQ_GT] = ACTIONS(6358),
    [anon_sym_EQ_TILDE] = ACTIONS(6358),
    [anon_sym_BANG_TILDE] = ACTIONS(6358),
    [anon_sym_LT_EQ] = ACTIONS(6360),
    [anon_sym_GT] = ACTIONS(6360),
    [anon_sym_GT_EQ] = ACTIONS(6358),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_PERCENT] = ACTIONS(6360),
    [sym_comment] = ACTIONS(87),
  },
  [6783] = {
    [sym__heredoc_body_start] = ACTIONS(6362),
    [sym__binary_minus] = ACTIONS(6362),
    [sym__binary_star] = ACTIONS(6362),
    [anon_sym_LBRACE] = ACTIONS(6362),
    [anon_sym_RBRACE] = ACTIONS(6362),
    [anon_sym_RPAREN] = ACTIONS(6362),
    [anon_sym_DOT] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6364),
    [anon_sym_SEMI] = ACTIONS(6362),
    [anon_sym_STAR_STAR] = ACTIONS(6364),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6364),
    [anon_sym_if] = ACTIONS(6362),
    [anon_sym_unless] = ACTIONS(6362),
    [anon_sym_while] = ACTIONS(6362),
    [anon_sym_until] = ACTIONS(6362),
    [anon_sym_rescue] = ACTIONS(6362),
    [anon_sym_in] = ACTIONS(6362),
    [anon_sym_do] = ACTIONS(6362),
    [anon_sym_EQ_GT] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6362),
    [anon_sym_RBRACK] = ACTIONS(6362),
    [anon_sym_COLON_COLON2] = ACTIONS(6362),
    [anon_sym_AMP_DOT] = ACTIONS(6362),
    [anon_sym_PLUS_EQ] = ACTIONS(6362),
    [anon_sym_DASH_EQ] = ACTIONS(6362),
    [anon_sym_STAR_EQ] = ACTIONS(6362),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6362),
    [anon_sym_SLASH_EQ] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6362),
    [anon_sym_PIPE_EQ] = ACTIONS(6362),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6362),
    [anon_sym_AMP_EQ] = ACTIONS(6362),
    [anon_sym_PERCENT_EQ] = ACTIONS(6362),
    [anon_sym_GT_GT_EQ] = ACTIONS(6362),
    [anon_sym_LT_LT_EQ] = ACTIONS(6362),
    [anon_sym_CARET_EQ] = ACTIONS(6362),
    [anon_sym_QMARK] = ACTIONS(6362),
    [anon_sym_COLON2] = ACTIONS(6364),
    [anon_sym_DOT_DOT] = ACTIONS(6364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6362),
    [anon_sym_and] = ACTIONS(6362),
    [anon_sym_or] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE] = ACTIONS(6364),
    [anon_sym_AMP_AMP] = ACTIONS(6364),
    [anon_sym_LT_LT] = ACTIONS(6364),
    [anon_sym_GT_GT] = ACTIONS(6364),
    [anon_sym_EQ_EQ] = ACTIONS(6364),
    [anon_sym_BANG_EQ] = ACTIONS(6362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6362),
    [anon_sym_LT_EQ_GT] = ACTIONS(6362),
    [anon_sym_EQ_TILDE] = ACTIONS(6362),
    [anon_sym_BANG_TILDE] = ACTIONS(6362),
    [anon_sym_LT_EQ] = ACTIONS(6364),
    [anon_sym_GT] = ACTIONS(6364),
    [anon_sym_GT_EQ] = ACTIONS(6362),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_PERCENT] = ACTIONS(6364),
    [sym_comment] = ACTIONS(87),
  },
  [6784] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12143),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6785] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(12143),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12145),
  },
  [6786] = {
    [sym__heredoc_body_start] = ACTIONS(6370),
    [sym__binary_minus] = ACTIONS(6370),
    [sym__binary_star] = ACTIONS(6370),
    [anon_sym_LBRACE] = ACTIONS(6370),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_RPAREN] = ACTIONS(6370),
    [anon_sym_DOT] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym_STAR_STAR] = ACTIONS(6372),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_if] = ACTIONS(6370),
    [anon_sym_unless] = ACTIONS(6370),
    [anon_sym_while] = ACTIONS(6370),
    [anon_sym_until] = ACTIONS(6370),
    [anon_sym_rescue] = ACTIONS(6370),
    [anon_sym_in] = ACTIONS(6370),
    [anon_sym_do] = ACTIONS(6370),
    [anon_sym_EQ_GT] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6370),
    [anon_sym_RBRACK] = ACTIONS(6370),
    [anon_sym_COLON_COLON2] = ACTIONS(6370),
    [anon_sym_AMP_DOT] = ACTIONS(6370),
    [anon_sym_PLUS_EQ] = ACTIONS(6370),
    [anon_sym_DASH_EQ] = ACTIONS(6370),
    [anon_sym_STAR_EQ] = ACTIONS(6370),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6370),
    [anon_sym_SLASH_EQ] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6370),
    [anon_sym_PIPE_EQ] = ACTIONS(6370),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6370),
    [anon_sym_AMP_EQ] = ACTIONS(6370),
    [anon_sym_PERCENT_EQ] = ACTIONS(6370),
    [anon_sym_GT_GT_EQ] = ACTIONS(6370),
    [anon_sym_LT_LT_EQ] = ACTIONS(6370),
    [anon_sym_CARET_EQ] = ACTIONS(6370),
    [anon_sym_QMARK] = ACTIONS(6370),
    [anon_sym_COLON2] = ACTIONS(6372),
    [anon_sym_DOT_DOT] = ACTIONS(6372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6370),
    [anon_sym_and] = ACTIONS(6370),
    [anon_sym_or] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE] = ACTIONS(6372),
    [anon_sym_AMP_AMP] = ACTIONS(6372),
    [anon_sym_LT_LT] = ACTIONS(6372),
    [anon_sym_GT_GT] = ACTIONS(6372),
    [anon_sym_EQ_EQ] = ACTIONS(6372),
    [anon_sym_BANG_EQ] = ACTIONS(6370),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6370),
    [anon_sym_LT_EQ_GT] = ACTIONS(6370),
    [anon_sym_EQ_TILDE] = ACTIONS(6370),
    [anon_sym_BANG_TILDE] = ACTIONS(6370),
    [anon_sym_LT_EQ] = ACTIONS(6372),
    [anon_sym_GT] = ACTIONS(6372),
    [anon_sym_GT_EQ] = ACTIONS(6370),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_PERCENT] = ACTIONS(6372),
    [sym_comment] = ACTIONS(87),
  },
  [6787] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12147),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6788] = {
    [sym__binary_minus] = ACTIONS(11655),
    [sym__binary_star] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11657),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11657),
    [anon_sym_STAR_STAR] = ACTIONS(11657),
    [anon_sym_AMP] = ACTIONS(11657),
    [anon_sym_EQ] = ACTIONS(11657),
    [anon_sym_LT] = ACTIONS(11657),
    [anon_sym_EQ_GT] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [anon_sym_PLUS_EQ] = ACTIONS(11655),
    [anon_sym_DASH_EQ] = ACTIONS(11655),
    [anon_sym_STAR_EQ] = ACTIONS(11655),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11655),
    [anon_sym_SLASH_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11655),
    [anon_sym_AMP_EQ] = ACTIONS(11655),
    [anon_sym_PERCENT_EQ] = ACTIONS(11655),
    [anon_sym_GT_GT_EQ] = ACTIONS(11655),
    [anon_sym_LT_LT_EQ] = ACTIONS(11655),
    [anon_sym_CARET_EQ] = ACTIONS(11655),
    [anon_sym_QMARK] = ACTIONS(11655),
    [anon_sym_DOT_DOT] = ACTIONS(11657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11655),
    [anon_sym_and] = ACTIONS(11655),
    [anon_sym_or] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE] = ACTIONS(11657),
    [anon_sym_AMP_AMP] = ACTIONS(11657),
    [anon_sym_LT_LT] = ACTIONS(11657),
    [anon_sym_GT_GT] = ACTIONS(11657),
    [anon_sym_EQ_EQ] = ACTIONS(11657),
    [anon_sym_BANG_EQ] = ACTIONS(11655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11655),
    [anon_sym_LT_EQ_GT] = ACTIONS(11655),
    [anon_sym_EQ_TILDE] = ACTIONS(11655),
    [anon_sym_BANG_TILDE] = ACTIONS(11655),
    [anon_sym_LT_EQ] = ACTIONS(11657),
    [anon_sym_GT] = ACTIONS(11657),
    [anon_sym_GT_EQ] = ACTIONS(11655),
    [anon_sym_CARET] = ACTIONS(11657),
    [anon_sym_PLUS] = ACTIONS(11657),
    [anon_sym_SLASH] = ACTIONS(11657),
    [anon_sym_PERCENT] = ACTIONS(11657),
    [sym_comment] = ACTIONS(87),
  },
  [6789] = {
    [sym__heredoc_body_start] = ACTIONS(6894),
    [sym__binary_minus] = ACTIONS(6894),
    [sym__binary_star] = ACTIONS(6894),
    [anon_sym_LBRACE] = ACTIONS(6894),
    [anon_sym_RBRACE] = ACTIONS(6894),
    [anon_sym_RPAREN] = ACTIONS(6894),
    [anon_sym_DOT] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_SEMI] = ACTIONS(6894),
    [anon_sym_STAR_STAR] = ACTIONS(6896),
    [anon_sym_AMP] = ACTIONS(6896),
    [anon_sym_EQ] = ACTIONS(6896),
    [anon_sym_LT] = ACTIONS(6896),
    [anon_sym_if] = ACTIONS(6894),
    [anon_sym_unless] = ACTIONS(6894),
    [anon_sym_while] = ACTIONS(6894),
    [anon_sym_until] = ACTIONS(6894),
    [anon_sym_rescue] = ACTIONS(6894),
    [anon_sym_in] = ACTIONS(6894),
    [anon_sym_do] = ACTIONS(6894),
    [anon_sym_EQ_GT] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6894),
    [anon_sym_RBRACK] = ACTIONS(6894),
    [anon_sym_COLON_COLON2] = ACTIONS(6894),
    [anon_sym_AMP_DOT] = ACTIONS(6894),
    [anon_sym_PLUS_EQ] = ACTIONS(6894),
    [anon_sym_DASH_EQ] = ACTIONS(6894),
    [anon_sym_STAR_EQ] = ACTIONS(6894),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6894),
    [anon_sym_SLASH_EQ] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6894),
    [anon_sym_PIPE_EQ] = ACTIONS(6894),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6894),
    [anon_sym_AMP_EQ] = ACTIONS(6894),
    [anon_sym_PERCENT_EQ] = ACTIONS(6894),
    [anon_sym_GT_GT_EQ] = ACTIONS(6894),
    [anon_sym_LT_LT_EQ] = ACTIONS(6894),
    [anon_sym_CARET_EQ] = ACTIONS(6894),
    [anon_sym_QMARK] = ACTIONS(6894),
    [anon_sym_COLON2] = ACTIONS(6896),
    [anon_sym_DOT_DOT] = ACTIONS(6896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6894),
    [anon_sym_and] = ACTIONS(6894),
    [anon_sym_or] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE] = ACTIONS(6896),
    [anon_sym_AMP_AMP] = ACTIONS(6896),
    [anon_sym_LT_LT] = ACTIONS(6896),
    [anon_sym_GT_GT] = ACTIONS(6896),
    [anon_sym_EQ_EQ] = ACTIONS(6896),
    [anon_sym_BANG_EQ] = ACTIONS(6894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6894),
    [anon_sym_LT_EQ_GT] = ACTIONS(6894),
    [anon_sym_EQ_TILDE] = ACTIONS(6894),
    [anon_sym_BANG_TILDE] = ACTIONS(6894),
    [anon_sym_LT_EQ] = ACTIONS(6896),
    [anon_sym_GT] = ACTIONS(6896),
    [anon_sym_GT_EQ] = ACTIONS(6894),
    [anon_sym_CARET] = ACTIONS(6896),
    [anon_sym_PLUS] = ACTIONS(6896),
    [anon_sym_SLASH] = ACTIONS(6896),
    [anon_sym_PERCENT] = ACTIONS(6896),
    [sym_comment] = ACTIONS(87),
  },
  [6790] = {
    [anon_sym_DOT] = ACTIONS(12149),
    [anon_sym_COLON_COLON] = ACTIONS(12149),
    [sym_comment] = ACTIONS(87),
  },
  [6791] = {
    [sym__heredoc_body_start] = ACTIONS(7046),
    [sym__binary_minus] = ACTIONS(7046),
    [sym__binary_star] = ACTIONS(7046),
    [anon_sym_LBRACE] = ACTIONS(7046),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7046),
    [anon_sym_DOT] = ACTIONS(7048),
    [anon_sym_COMMA] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_STAR_STAR] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7048),
    [anon_sym_if] = ACTIONS(7046),
    [anon_sym_unless] = ACTIONS(7046),
    [anon_sym_while] = ACTIONS(7046),
    [anon_sym_until] = ACTIONS(7046),
    [anon_sym_rescue] = ACTIONS(7046),
    [anon_sym_in] = ACTIONS(7046),
    [anon_sym_do] = ACTIONS(7046),
    [anon_sym_EQ_GT] = ACTIONS(7046),
    [anon_sym_LBRACK] = ACTIONS(7046),
    [anon_sym_RBRACK] = ACTIONS(7046),
    [anon_sym_COLON_COLON2] = ACTIONS(7046),
    [anon_sym_AMP_DOT] = ACTIONS(7046),
    [anon_sym_PLUS_EQ] = ACTIONS(7046),
    [anon_sym_DASH_EQ] = ACTIONS(7046),
    [anon_sym_STAR_EQ] = ACTIONS(7046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7046),
    [anon_sym_SLASH_EQ] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7046),
    [anon_sym_PIPE_EQ] = ACTIONS(7046),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7046),
    [anon_sym_AMP_EQ] = ACTIONS(7046),
    [anon_sym_PERCENT_EQ] = ACTIONS(7046),
    [anon_sym_GT_GT_EQ] = ACTIONS(7046),
    [anon_sym_LT_LT_EQ] = ACTIONS(7046),
    [anon_sym_CARET_EQ] = ACTIONS(7046),
    [anon_sym_QMARK] = ACTIONS(7046),
    [anon_sym_COLON2] = ACTIONS(7048),
    [anon_sym_DOT_DOT] = ACTIONS(7048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7046),
    [anon_sym_and] = ACTIONS(7046),
    [anon_sym_or] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7048),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_BANG_EQ] = ACTIONS(7046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT_EQ_GT] = ACTIONS(7046),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_BANG_TILDE] = ACTIONS(7046),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7046),
    [anon_sym_CARET] = ACTIONS(7048),
    [anon_sym_PLUS] = ACTIONS(7048),
    [anon_sym_SLASH] = ACTIONS(7048),
    [anon_sym_PERCENT] = ACTIONS(7048),
    [sym_comment] = ACTIONS(87),
  },
  [6792] = {
    [sym__heredoc_body_start] = ACTIONS(7062),
    [sym__binary_minus] = ACTIONS(7062),
    [sym__binary_star] = ACTIONS(7062),
    [anon_sym_LBRACE] = ACTIONS(7062),
    [anon_sym_RBRACE] = ACTIONS(7062),
    [anon_sym_RPAREN] = ACTIONS(7062),
    [anon_sym_DOT] = ACTIONS(7064),
    [anon_sym_COMMA] = ACTIONS(7062),
    [anon_sym_PIPE] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(7062),
    [anon_sym_STAR_STAR] = ACTIONS(7064),
    [anon_sym_AMP] = ACTIONS(7064),
    [anon_sym_EQ] = ACTIONS(7064),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_if] = ACTIONS(7062),
    [anon_sym_unless] = ACTIONS(7062),
    [anon_sym_while] = ACTIONS(7062),
    [anon_sym_until] = ACTIONS(7062),
    [anon_sym_rescue] = ACTIONS(7062),
    [anon_sym_in] = ACTIONS(7062),
    [anon_sym_do] = ACTIONS(7062),
    [anon_sym_EQ_GT] = ACTIONS(7062),
    [anon_sym_LBRACK] = ACTIONS(7062),
    [anon_sym_RBRACK] = ACTIONS(7062),
    [anon_sym_COLON_COLON2] = ACTIONS(7062),
    [anon_sym_AMP_DOT] = ACTIONS(7062),
    [anon_sym_PLUS_EQ] = ACTIONS(7062),
    [anon_sym_DASH_EQ] = ACTIONS(7062),
    [anon_sym_STAR_EQ] = ACTIONS(7062),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7062),
    [anon_sym_SLASH_EQ] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7062),
    [anon_sym_PIPE_EQ] = ACTIONS(7062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7062),
    [anon_sym_AMP_EQ] = ACTIONS(7062),
    [anon_sym_PERCENT_EQ] = ACTIONS(7062),
    [anon_sym_GT_GT_EQ] = ACTIONS(7062),
    [anon_sym_LT_LT_EQ] = ACTIONS(7062),
    [anon_sym_CARET_EQ] = ACTIONS(7062),
    [anon_sym_QMARK] = ACTIONS(7062),
    [anon_sym_COLON2] = ACTIONS(7064),
    [anon_sym_DOT_DOT] = ACTIONS(7064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7062),
    [anon_sym_and] = ACTIONS(7062),
    [anon_sym_or] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE] = ACTIONS(7064),
    [anon_sym_AMP_AMP] = ACTIONS(7064),
    [anon_sym_LT_LT] = ACTIONS(7064),
    [anon_sym_GT_GT] = ACTIONS(7064),
    [anon_sym_EQ_EQ] = ACTIONS(7064),
    [anon_sym_BANG_EQ] = ACTIONS(7062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7062),
    [anon_sym_LT_EQ_GT] = ACTIONS(7062),
    [anon_sym_EQ_TILDE] = ACTIONS(7062),
    [anon_sym_BANG_TILDE] = ACTIONS(7062),
    [anon_sym_LT_EQ] = ACTIONS(7064),
    [anon_sym_GT] = ACTIONS(7064),
    [anon_sym_GT_EQ] = ACTIONS(7062),
    [anon_sym_CARET] = ACTIONS(7064),
    [anon_sym_PLUS] = ACTIONS(7064),
    [anon_sym_SLASH] = ACTIONS(7064),
    [anon_sym_PERCENT] = ACTIONS(7064),
    [sym_comment] = ACTIONS(87),
  },
  [6793] = {
    [sym__statements] = STATE(1968),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1969),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1970),
    [sym_rescue] = STATE(1971),
    [sym__body_statement] = STATE(8803),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12151),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6794] = {
    [sym__statements] = STATE(1968),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(1969),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(1970),
    [sym_rescue] = STATE(1971),
    [sym__body_statement] = STATE(8804),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12153),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6795] = {
    [sym__heredoc_body_start] = ACTIONS(7496),
    [sym__binary_minus] = ACTIONS(7496),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_LBRACE] = ACTIONS(7496),
    [anon_sym_RBRACE] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(7496),
    [anon_sym_DOT] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7496),
    [anon_sym_unless] = ACTIONS(7496),
    [anon_sym_while] = ACTIONS(7496),
    [anon_sym_until] = ACTIONS(7496),
    [anon_sym_rescue] = ACTIONS(7496),
    [anon_sym_in] = ACTIONS(7496),
    [anon_sym_do] = ACTIONS(7496),
    [anon_sym_EQ_GT] = ACTIONS(7496),
    [anon_sym_LBRACK] = ACTIONS(7496),
    [anon_sym_RBRACK] = ACTIONS(7496),
    [anon_sym_COLON_COLON2] = ACTIONS(7496),
    [anon_sym_AMP_DOT] = ACTIONS(7496),
    [anon_sym_PLUS_EQ] = ACTIONS(7496),
    [anon_sym_DASH_EQ] = ACTIONS(7496),
    [anon_sym_STAR_EQ] = ACTIONS(7496),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7496),
    [anon_sym_SLASH_EQ] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7496),
    [anon_sym_PIPE_EQ] = ACTIONS(7496),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7496),
    [anon_sym_AMP_EQ] = ACTIONS(7496),
    [anon_sym_PERCENT_EQ] = ACTIONS(7496),
    [anon_sym_GT_GT_EQ] = ACTIONS(7496),
    [anon_sym_LT_LT_EQ] = ACTIONS(7496),
    [anon_sym_CARET_EQ] = ACTIONS(7496),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_COLON2] = ACTIONS(7498),
    [anon_sym_DOT_DOT] = ACTIONS(7498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7496),
    [anon_sym_and] = ACTIONS(7496),
    [anon_sym_or] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE] = ACTIONS(7498),
    [anon_sym_AMP_AMP] = ACTIONS(7498),
    [anon_sym_LT_LT] = ACTIONS(7498),
    [anon_sym_GT_GT] = ACTIONS(7498),
    [anon_sym_EQ_EQ] = ACTIONS(7498),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7496),
    [anon_sym_LT_EQ_GT] = ACTIONS(7496),
    [anon_sym_EQ_TILDE] = ACTIONS(7496),
    [anon_sym_BANG_TILDE] = ACTIONS(7496),
    [anon_sym_LT_EQ] = ACTIONS(7498),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7498),
    [anon_sym_PERCENT] = ACTIONS(7498),
    [sym_comment] = ACTIONS(87),
  },
  [6796] = {
    [sym__heredoc_body_start] = ACTIONS(7550),
    [sym__binary_minus] = ACTIONS(7550),
    [sym__binary_star] = ACTIONS(7550),
    [anon_sym_LBRACE] = ACTIONS(7550),
    [anon_sym_RBRACE] = ACTIONS(7550),
    [anon_sym_RPAREN] = ACTIONS(7550),
    [anon_sym_DOT] = ACTIONS(7552),
    [anon_sym_COMMA] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_SEMI] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7550),
    [anon_sym_unless] = ACTIONS(7550),
    [anon_sym_while] = ACTIONS(7550),
    [anon_sym_until] = ACTIONS(7550),
    [anon_sym_rescue] = ACTIONS(7550),
    [anon_sym_in] = ACTIONS(7550),
    [anon_sym_do] = ACTIONS(7550),
    [anon_sym_EQ_GT] = ACTIONS(7550),
    [anon_sym_LBRACK] = ACTIONS(7550),
    [anon_sym_RBRACK] = ACTIONS(7550),
    [anon_sym_COLON_COLON2] = ACTIONS(7550),
    [anon_sym_AMP_DOT] = ACTIONS(7550),
    [anon_sym_PLUS_EQ] = ACTIONS(7550),
    [anon_sym_DASH_EQ] = ACTIONS(7550),
    [anon_sym_STAR_EQ] = ACTIONS(7550),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7550),
    [anon_sym_SLASH_EQ] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7550),
    [anon_sym_PIPE_EQ] = ACTIONS(7550),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7550),
    [anon_sym_AMP_EQ] = ACTIONS(7550),
    [anon_sym_PERCENT_EQ] = ACTIONS(7550),
    [anon_sym_GT_GT_EQ] = ACTIONS(7550),
    [anon_sym_LT_LT_EQ] = ACTIONS(7550),
    [anon_sym_CARET_EQ] = ACTIONS(7550),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_COLON2] = ACTIONS(7552),
    [anon_sym_DOT_DOT] = ACTIONS(7552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7550),
    [anon_sym_and] = ACTIONS(7550),
    [anon_sym_or] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE] = ACTIONS(7552),
    [anon_sym_AMP_AMP] = ACTIONS(7552),
    [anon_sym_LT_LT] = ACTIONS(7552),
    [anon_sym_GT_GT] = ACTIONS(7552),
    [anon_sym_EQ_EQ] = ACTIONS(7552),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7550),
    [anon_sym_LT_EQ_GT] = ACTIONS(7550),
    [anon_sym_EQ_TILDE] = ACTIONS(7550),
    [anon_sym_BANG_TILDE] = ACTIONS(7550),
    [anon_sym_LT_EQ] = ACTIONS(7552),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7552),
    [anon_sym_PERCENT] = ACTIONS(7552),
    [sym_comment] = ACTIONS(87),
  },
  [6797] = {
    [sym__heredoc_body_start] = ACTIONS(7724),
    [sym__binary_minus] = ACTIONS(7724),
    [sym__binary_star] = ACTIONS(7724),
    [anon_sym_LBRACE] = ACTIONS(7724),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_DOT] = ACTIONS(7726),
    [anon_sym_COMMA] = ACTIONS(7724),
    [anon_sym_PIPE] = ACTIONS(7726),
    [anon_sym_SEMI] = ACTIONS(7724),
    [anon_sym_STAR_STAR] = ACTIONS(7726),
    [anon_sym_AMP] = ACTIONS(7726),
    [anon_sym_EQ] = ACTIONS(7726),
    [anon_sym_LT] = ACTIONS(7726),
    [anon_sym_if] = ACTIONS(7724),
    [anon_sym_unless] = ACTIONS(7724),
    [anon_sym_while] = ACTIONS(7724),
    [anon_sym_until] = ACTIONS(7724),
    [anon_sym_rescue] = ACTIONS(7724),
    [anon_sym_in] = ACTIONS(7724),
    [anon_sym_do] = ACTIONS(7724),
    [anon_sym_EQ_GT] = ACTIONS(7724),
    [anon_sym_LBRACK] = ACTIONS(7724),
    [anon_sym_RBRACK] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(7724),
    [anon_sym_AMP_DOT] = ACTIONS(7724),
    [anon_sym_PLUS_EQ] = ACTIONS(7724),
    [anon_sym_DASH_EQ] = ACTIONS(7724),
    [anon_sym_STAR_EQ] = ACTIONS(7724),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7724),
    [anon_sym_SLASH_EQ] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7724),
    [anon_sym_PIPE_EQ] = ACTIONS(7724),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7724),
    [anon_sym_AMP_EQ] = ACTIONS(7724),
    [anon_sym_PERCENT_EQ] = ACTIONS(7724),
    [anon_sym_GT_GT_EQ] = ACTIONS(7724),
    [anon_sym_LT_LT_EQ] = ACTIONS(7724),
    [anon_sym_CARET_EQ] = ACTIONS(7724),
    [anon_sym_QMARK] = ACTIONS(7724),
    [anon_sym_COLON2] = ACTIONS(7726),
    [anon_sym_DOT_DOT] = ACTIONS(7726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7724),
    [anon_sym_and] = ACTIONS(7724),
    [anon_sym_or] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE] = ACTIONS(7726),
    [anon_sym_AMP_AMP] = ACTIONS(7726),
    [anon_sym_LT_LT] = ACTIONS(7726),
    [anon_sym_GT_GT] = ACTIONS(7726),
    [anon_sym_EQ_EQ] = ACTIONS(7726),
    [anon_sym_BANG_EQ] = ACTIONS(7724),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7724),
    [anon_sym_LT_EQ_GT] = ACTIONS(7724),
    [anon_sym_EQ_TILDE] = ACTIONS(7724),
    [anon_sym_BANG_TILDE] = ACTIONS(7724),
    [anon_sym_LT_EQ] = ACTIONS(7726),
    [anon_sym_GT] = ACTIONS(7726),
    [anon_sym_GT_EQ] = ACTIONS(7724),
    [anon_sym_CARET] = ACTIONS(7726),
    [anon_sym_PLUS] = ACTIONS(7726),
    [anon_sym_SLASH] = ACTIONS(7726),
    [anon_sym_PERCENT] = ACTIONS(7726),
    [sym_comment] = ACTIONS(87),
  },
  [6798] = {
    [sym_elsif] = STATE(8806),
    [sym_else] = STATE(8806),
    [sym__if_tail] = STATE(8806),
    [anon_sym_end] = ACTIONS(12155),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [6799] = {
    [anon_sym_end] = ACTIONS(12155),
    [sym_comment] = ACTIONS(87),
  },
  [6800] = {
    [sym__statements] = STATE(8807),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(8806),
    [sym_else] = STATE(8806),
    [sym__if_tail] = STATE(8806),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12157),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6801] = {
    [sym__heredoc_body_start] = ACTIONS(7922),
    [sym__binary_minus] = ACTIONS(7922),
    [sym__binary_star] = ACTIONS(7922),
    [anon_sym_LBRACE] = ACTIONS(7922),
    [anon_sym_RBRACE] = ACTIONS(7922),
    [anon_sym_RPAREN] = ACTIONS(7922),
    [anon_sym_DOT] = ACTIONS(7924),
    [anon_sym_COMMA] = ACTIONS(7922),
    [anon_sym_PIPE] = ACTIONS(7924),
    [anon_sym_SEMI] = ACTIONS(7922),
    [anon_sym_STAR_STAR] = ACTIONS(7924),
    [anon_sym_AMP] = ACTIONS(7924),
    [anon_sym_EQ] = ACTIONS(7924),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(7922),
    [anon_sym_unless] = ACTIONS(7922),
    [anon_sym_while] = ACTIONS(7922),
    [anon_sym_until] = ACTIONS(7922),
    [anon_sym_rescue] = ACTIONS(7922),
    [anon_sym_in] = ACTIONS(7922),
    [anon_sym_do] = ACTIONS(7922),
    [anon_sym_EQ_GT] = ACTIONS(7922),
    [anon_sym_LBRACK] = ACTIONS(7922),
    [anon_sym_RBRACK] = ACTIONS(7922),
    [anon_sym_COLON_COLON2] = ACTIONS(7922),
    [anon_sym_AMP_DOT] = ACTIONS(7922),
    [anon_sym_PLUS_EQ] = ACTIONS(7922),
    [anon_sym_DASH_EQ] = ACTIONS(7922),
    [anon_sym_STAR_EQ] = ACTIONS(7922),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7922),
    [anon_sym_SLASH_EQ] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7922),
    [anon_sym_PIPE_EQ] = ACTIONS(7922),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7922),
    [anon_sym_AMP_EQ] = ACTIONS(7922),
    [anon_sym_PERCENT_EQ] = ACTIONS(7922),
    [anon_sym_GT_GT_EQ] = ACTIONS(7922),
    [anon_sym_LT_LT_EQ] = ACTIONS(7922),
    [anon_sym_CARET_EQ] = ACTIONS(7922),
    [anon_sym_QMARK] = ACTIONS(7922),
    [anon_sym_COLON2] = ACTIONS(7924),
    [anon_sym_DOT_DOT] = ACTIONS(7924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7922),
    [anon_sym_and] = ACTIONS(7922),
    [anon_sym_or] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE] = ACTIONS(7924),
    [anon_sym_AMP_AMP] = ACTIONS(7924),
    [anon_sym_LT_LT] = ACTIONS(7924),
    [anon_sym_GT_GT] = ACTIONS(7924),
    [anon_sym_EQ_EQ] = ACTIONS(7924),
    [anon_sym_BANG_EQ] = ACTIONS(7922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7922),
    [anon_sym_LT_EQ_GT] = ACTIONS(7922),
    [anon_sym_EQ_TILDE] = ACTIONS(7922),
    [anon_sym_BANG_TILDE] = ACTIONS(7922),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7922),
    [anon_sym_CARET] = ACTIONS(7924),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_SLASH] = ACTIONS(7924),
    [anon_sym_PERCENT] = ACTIONS(7924),
    [sym_comment] = ACTIONS(87),
  },
  [6802] = {
    [sym_else] = STATE(8809),
    [anon_sym_end] = ACTIONS(12159),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [6803] = {
    [anon_sym_end] = ACTIONS(12159),
    [sym_comment] = ACTIONS(87),
  },
  [6804] = {
    [sym__heredoc_body_start] = ACTIONS(8090),
    [sym__binary_minus] = ACTIONS(8090),
    [sym__binary_star] = ACTIONS(8090),
    [anon_sym_LBRACE] = ACTIONS(8090),
    [anon_sym_RBRACE] = ACTIONS(8090),
    [anon_sym_RPAREN] = ACTIONS(8090),
    [anon_sym_DOT] = ACTIONS(8092),
    [anon_sym_COMMA] = ACTIONS(8090),
    [anon_sym_PIPE] = ACTIONS(8092),
    [anon_sym_SEMI] = ACTIONS(8090),
    [anon_sym_STAR_STAR] = ACTIONS(8092),
    [anon_sym_AMP] = ACTIONS(8092),
    [anon_sym_EQ] = ACTIONS(8092),
    [anon_sym_LT] = ACTIONS(8092),
    [anon_sym_if] = ACTIONS(8090),
    [anon_sym_unless] = ACTIONS(8090),
    [anon_sym_while] = ACTIONS(8090),
    [anon_sym_until] = ACTIONS(8090),
    [anon_sym_rescue] = ACTIONS(8090),
    [anon_sym_in] = ACTIONS(8090),
    [anon_sym_do] = ACTIONS(8090),
    [anon_sym_EQ_GT] = ACTIONS(8090),
    [anon_sym_LBRACK] = ACTIONS(8090),
    [anon_sym_RBRACK] = ACTIONS(8090),
    [anon_sym_COLON_COLON2] = ACTIONS(8090),
    [anon_sym_AMP_DOT] = ACTIONS(8090),
    [anon_sym_PLUS_EQ] = ACTIONS(8090),
    [anon_sym_DASH_EQ] = ACTIONS(8090),
    [anon_sym_STAR_EQ] = ACTIONS(8090),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8090),
    [anon_sym_SLASH_EQ] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8090),
    [anon_sym_PIPE_EQ] = ACTIONS(8090),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8090),
    [anon_sym_AMP_EQ] = ACTIONS(8090),
    [anon_sym_PERCENT_EQ] = ACTIONS(8090),
    [anon_sym_GT_GT_EQ] = ACTIONS(8090),
    [anon_sym_LT_LT_EQ] = ACTIONS(8090),
    [anon_sym_CARET_EQ] = ACTIONS(8090),
    [anon_sym_QMARK] = ACTIONS(8090),
    [anon_sym_COLON2] = ACTIONS(8092),
    [anon_sym_DOT_DOT] = ACTIONS(8092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8090),
    [anon_sym_and] = ACTIONS(8090),
    [anon_sym_or] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE] = ACTIONS(8092),
    [anon_sym_AMP_AMP] = ACTIONS(8092),
    [anon_sym_LT_LT] = ACTIONS(8092),
    [anon_sym_GT_GT] = ACTIONS(8092),
    [anon_sym_EQ_EQ] = ACTIONS(8092),
    [anon_sym_BANG_EQ] = ACTIONS(8090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8090),
    [anon_sym_LT_EQ_GT] = ACTIONS(8090),
    [anon_sym_EQ_TILDE] = ACTIONS(8090),
    [anon_sym_BANG_TILDE] = ACTIONS(8090),
    [anon_sym_LT_EQ] = ACTIONS(8092),
    [anon_sym_GT] = ACTIONS(8092),
    [anon_sym_GT_EQ] = ACTIONS(8090),
    [anon_sym_CARET] = ACTIONS(8092),
    [anon_sym_PLUS] = ACTIONS(8092),
    [anon_sym_SLASH] = ACTIONS(8092),
    [anon_sym_PERCENT] = ACTIONS(8092),
    [sym_comment] = ACTIONS(87),
  },
  [6805] = {
    [anon_sym_end] = ACTIONS(12161),
    [sym_comment] = ACTIONS(87),
  },
  [6806] = {
    [sym__heredoc_body_start] = ACTIONS(8166),
    [sym__binary_minus] = ACTIONS(8166),
    [sym__binary_star] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_DOT] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8166),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI] = ACTIONS(8166),
    [anon_sym_STAR_STAR] = ACTIONS(8168),
    [anon_sym_AMP] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_if] = ACTIONS(8166),
    [anon_sym_unless] = ACTIONS(8166),
    [anon_sym_while] = ACTIONS(8166),
    [anon_sym_until] = ACTIONS(8166),
    [anon_sym_rescue] = ACTIONS(8166),
    [anon_sym_in] = ACTIONS(8166),
    [anon_sym_do] = ACTIONS(8166),
    [anon_sym_EQ_GT] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_RBRACK] = ACTIONS(8166),
    [anon_sym_COLON_COLON2] = ACTIONS(8166),
    [anon_sym_AMP_DOT] = ACTIONS(8166),
    [anon_sym_PLUS_EQ] = ACTIONS(8166),
    [anon_sym_DASH_EQ] = ACTIONS(8166),
    [anon_sym_STAR_EQ] = ACTIONS(8166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8166),
    [anon_sym_SLASH_EQ] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8166),
    [anon_sym_PIPE_EQ] = ACTIONS(8166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8166),
    [anon_sym_AMP_EQ] = ACTIONS(8166),
    [anon_sym_PERCENT_EQ] = ACTIONS(8166),
    [anon_sym_GT_GT_EQ] = ACTIONS(8166),
    [anon_sym_LT_LT_EQ] = ACTIONS(8166),
    [anon_sym_CARET_EQ] = ACTIONS(8166),
    [anon_sym_QMARK] = ACTIONS(8166),
    [anon_sym_COLON2] = ACTIONS(8168),
    [anon_sym_DOT_DOT] = ACTIONS(8168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8166),
    [anon_sym_and] = ACTIONS(8166),
    [anon_sym_or] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8168),
    [anon_sym_AMP_AMP] = ACTIONS(8168),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ_GT] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_BANG_TILDE] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8168),
    [anon_sym_SLASH] = ACTIONS(8168),
    [anon_sym_PERCENT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(87),
  },
  [6807] = {
    [anon_sym_end] = ACTIONS(12163),
    [sym_comment] = ACTIONS(87),
  },
  [6808] = {
    [sym__statements] = STATE(8813),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12165),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6809] = {
    [sym__binary_minus] = ACTIONS(11680),
    [sym__binary_star] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11682),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11682),
    [anon_sym_STAR_STAR] = ACTIONS(11682),
    [anon_sym_AMP] = ACTIONS(11682),
    [anon_sym_EQ] = ACTIONS(11682),
    [anon_sym_LT] = ACTIONS(11682),
    [anon_sym_EQ_GT] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [anon_sym_PLUS_EQ] = ACTIONS(11680),
    [anon_sym_DASH_EQ] = ACTIONS(11680),
    [anon_sym_STAR_EQ] = ACTIONS(11680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11680),
    [anon_sym_SLASH_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11680),
    [anon_sym_AMP_EQ] = ACTIONS(11680),
    [anon_sym_PERCENT_EQ] = ACTIONS(11680),
    [anon_sym_GT_GT_EQ] = ACTIONS(11680),
    [anon_sym_LT_LT_EQ] = ACTIONS(11680),
    [anon_sym_CARET_EQ] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_DOT_DOT] = ACTIONS(11682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_and] = ACTIONS(11680),
    [anon_sym_or] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE] = ACTIONS(11682),
    [anon_sym_AMP_AMP] = ACTIONS(11682),
    [anon_sym_LT_LT] = ACTIONS(11682),
    [anon_sym_GT_GT] = ACTIONS(11682),
    [anon_sym_EQ_EQ] = ACTIONS(11682),
    [anon_sym_BANG_EQ] = ACTIONS(11680),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11680),
    [anon_sym_LT_EQ_GT] = ACTIONS(11680),
    [anon_sym_EQ_TILDE] = ACTIONS(11680),
    [anon_sym_BANG_TILDE] = ACTIONS(11680),
    [anon_sym_LT_EQ] = ACTIONS(11682),
    [anon_sym_GT] = ACTIONS(11682),
    [anon_sym_GT_EQ] = ACTIONS(11680),
    [anon_sym_CARET] = ACTIONS(11682),
    [anon_sym_PLUS] = ACTIONS(11682),
    [anon_sym_SLASH] = ACTIONS(11682),
    [anon_sym_PERCENT] = ACTIONS(11682),
    [sym_comment] = ACTIONS(87),
  },
  [6810] = {
    [anon_sym_end] = ACTIONS(12167),
    [sym_comment] = ACTIONS(87),
  },
  [6811] = {
    [sym__statements] = STATE(8815),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12169),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6812] = {
    [anon_sym_end] = ACTIONS(12171),
    [sym_comment] = ACTIONS(87),
  },
  [6813] = {
    [sym_when] = STATE(8817),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [6814] = {
    [sym__heredoc_body_start] = ACTIONS(8414),
    [sym__binary_minus] = ACTIONS(8414),
    [sym__binary_star] = ACTIONS(8414),
    [anon_sym_LBRACE] = ACTIONS(8414),
    [anon_sym_RBRACE] = ACTIONS(8414),
    [anon_sym_RPAREN] = ACTIONS(8414),
    [anon_sym_DOT] = ACTIONS(8416),
    [anon_sym_COMMA] = ACTIONS(8414),
    [anon_sym_PIPE] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8414),
    [anon_sym_STAR_STAR] = ACTIONS(8416),
    [anon_sym_AMP] = ACTIONS(8416),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LT] = ACTIONS(8416),
    [anon_sym_if] = ACTIONS(8414),
    [anon_sym_unless] = ACTIONS(8414),
    [anon_sym_while] = ACTIONS(8414),
    [anon_sym_until] = ACTIONS(8414),
    [anon_sym_rescue] = ACTIONS(8414),
    [anon_sym_in] = ACTIONS(8414),
    [anon_sym_do] = ACTIONS(8414),
    [anon_sym_EQ_GT] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8414),
    [anon_sym_RBRACK] = ACTIONS(8414),
    [anon_sym_COLON_COLON2] = ACTIONS(8414),
    [anon_sym_AMP_DOT] = ACTIONS(8414),
    [anon_sym_PLUS_EQ] = ACTIONS(8414),
    [anon_sym_DASH_EQ] = ACTIONS(8414),
    [anon_sym_STAR_EQ] = ACTIONS(8414),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8414),
    [anon_sym_SLASH_EQ] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8414),
    [anon_sym_PIPE_EQ] = ACTIONS(8414),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8414),
    [anon_sym_AMP_EQ] = ACTIONS(8414),
    [anon_sym_PERCENT_EQ] = ACTIONS(8414),
    [anon_sym_GT_GT_EQ] = ACTIONS(8414),
    [anon_sym_LT_LT_EQ] = ACTIONS(8414),
    [anon_sym_CARET_EQ] = ACTIONS(8414),
    [anon_sym_QMARK] = ACTIONS(8414),
    [anon_sym_COLON2] = ACTIONS(8416),
    [anon_sym_DOT_DOT] = ACTIONS(8416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8414),
    [anon_sym_and] = ACTIONS(8414),
    [anon_sym_or] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE] = ACTIONS(8416),
    [anon_sym_AMP_AMP] = ACTIONS(8416),
    [anon_sym_LT_LT] = ACTIONS(8416),
    [anon_sym_GT_GT] = ACTIONS(8416),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8414),
    [anon_sym_LT_EQ_GT] = ACTIONS(8414),
    [anon_sym_EQ_TILDE] = ACTIONS(8414),
    [anon_sym_BANG_TILDE] = ACTIONS(8414),
    [anon_sym_LT_EQ] = ACTIONS(8416),
    [anon_sym_GT] = ACTIONS(8416),
    [anon_sym_GT_EQ] = ACTIONS(8414),
    [anon_sym_CARET] = ACTIONS(8416),
    [anon_sym_PLUS] = ACTIONS(8416),
    [anon_sym_SLASH] = ACTIONS(8416),
    [anon_sym_PERCENT] = ACTIONS(8416),
    [sym_comment] = ACTIONS(87),
  },
  [6815] = {
    [sym__heredoc_body_start] = ACTIONS(8923),
    [sym__binary_minus] = ACTIONS(8923),
    [sym__binary_star] = ACTIONS(8923),
    [anon_sym_LBRACE] = ACTIONS(8923),
    [anon_sym_RBRACE] = ACTIONS(8923),
    [anon_sym_RPAREN] = ACTIONS(8923),
    [anon_sym_DOT] = ACTIONS(8925),
    [anon_sym_COMMA] = ACTIONS(8923),
    [anon_sym_PIPE] = ACTIONS(8925),
    [anon_sym_SEMI] = ACTIONS(8923),
    [anon_sym_STAR_STAR] = ACTIONS(8925),
    [anon_sym_AMP] = ACTIONS(8925),
    [anon_sym_EQ] = ACTIONS(8925),
    [anon_sym_LT] = ACTIONS(8925),
    [anon_sym_if] = ACTIONS(8923),
    [anon_sym_unless] = ACTIONS(8923),
    [anon_sym_while] = ACTIONS(8923),
    [anon_sym_until] = ACTIONS(8923),
    [anon_sym_rescue] = ACTIONS(8923),
    [anon_sym_in] = ACTIONS(8923),
    [anon_sym_do] = ACTIONS(8923),
    [anon_sym_EQ_GT] = ACTIONS(8923),
    [anon_sym_LBRACK] = ACTIONS(8923),
    [anon_sym_RBRACK] = ACTIONS(8923),
    [anon_sym_COLON_COLON2] = ACTIONS(8923),
    [anon_sym_AMP_DOT] = ACTIONS(8923),
    [anon_sym_PLUS_EQ] = ACTIONS(8923),
    [anon_sym_DASH_EQ] = ACTIONS(8923),
    [anon_sym_STAR_EQ] = ACTIONS(8923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8923),
    [anon_sym_SLASH_EQ] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8923),
    [anon_sym_PIPE_EQ] = ACTIONS(8923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8923),
    [anon_sym_AMP_EQ] = ACTIONS(8923),
    [anon_sym_PERCENT_EQ] = ACTIONS(8923),
    [anon_sym_GT_GT_EQ] = ACTIONS(8923),
    [anon_sym_LT_LT_EQ] = ACTIONS(8923),
    [anon_sym_CARET_EQ] = ACTIONS(8923),
    [anon_sym_QMARK] = ACTIONS(8923),
    [anon_sym_COLON2] = ACTIONS(8925),
    [anon_sym_DOT_DOT] = ACTIONS(8925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8923),
    [anon_sym_and] = ACTIONS(8923),
    [anon_sym_or] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE] = ACTIONS(8925),
    [anon_sym_AMP_AMP] = ACTIONS(8925),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8925),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8925),
    [anon_sym_GT] = ACTIONS(8925),
    [anon_sym_GT_EQ] = ACTIONS(8923),
    [anon_sym_CARET] = ACTIONS(8925),
    [anon_sym_PLUS] = ACTIONS(8925),
    [anon_sym_SLASH] = ACTIONS(8925),
    [anon_sym_PERCENT] = ACTIONS(8925),
    [sym_comment] = ACTIONS(87),
  },
  [6816] = {
    [anon_sym_end] = ACTIONS(12173),
    [sym_comment] = ACTIONS(87),
  },
  [6817] = {
    [sym_ensure] = STATE(8819),
    [anon_sym_end] = ACTIONS(12173),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [6818] = {
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10570),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10568),
    [anon_sym_unless] = ACTIONS(10568),
    [anon_sym_while] = ACTIONS(10568),
    [anon_sym_until] = ACTIONS(10568),
    [anon_sym_rescue] = ACTIONS(10568),
    [anon_sym_in] = ACTIONS(10568),
    [anon_sym_do] = ACTIONS(10568),
    [anon_sym_EQ_GT] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_RBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_PLUS_EQ] = ACTIONS(10568),
    [anon_sym_DASH_EQ] = ACTIONS(10568),
    [anon_sym_STAR_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10568),
    [anon_sym_SLASH_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10568),
    [anon_sym_AMP_EQ] = ACTIONS(10568),
    [anon_sym_PERCENT_EQ] = ACTIONS(10568),
    [anon_sym_GT_GT_EQ] = ACTIONS(10568),
    [anon_sym_LT_LT_EQ] = ACTIONS(10568),
    [anon_sym_CARET_EQ] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10568),
    [anon_sym_COLON2] = ACTIONS(10570),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10568),
    [anon_sym_or] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE] = ACTIONS(10570),
    [anon_sym_AMP_AMP] = ACTIONS(10570),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10570),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_SLASH] = ACTIONS(10570),
    [anon_sym_PERCENT] = ACTIONS(10570),
    [sym_comment] = ACTIONS(87),
  },
  [6819] = {
    [sym__heredoc_body_start] = ACTIONS(9143),
    [sym__binary_minus] = ACTIONS(9143),
    [sym__binary_star] = ACTIONS(9143),
    [anon_sym_LBRACE] = ACTIONS(9143),
    [anon_sym_RBRACE] = ACTIONS(9143),
    [anon_sym_RPAREN] = ACTIONS(9143),
    [anon_sym_DOT] = ACTIONS(9145),
    [anon_sym_COMMA] = ACTIONS(9143),
    [anon_sym_PIPE] = ACTIONS(9145),
    [anon_sym_SEMI] = ACTIONS(9143),
    [anon_sym_STAR_STAR] = ACTIONS(9145),
    [anon_sym_AMP] = ACTIONS(9145),
    [anon_sym_EQ] = ACTIONS(9145),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_if] = ACTIONS(9143),
    [anon_sym_unless] = ACTIONS(9143),
    [anon_sym_while] = ACTIONS(9143),
    [anon_sym_until] = ACTIONS(9143),
    [anon_sym_rescue] = ACTIONS(9143),
    [anon_sym_in] = ACTIONS(9143),
    [anon_sym_do] = ACTIONS(9143),
    [anon_sym_EQ_GT] = ACTIONS(9143),
    [anon_sym_LBRACK] = ACTIONS(9143),
    [anon_sym_RBRACK] = ACTIONS(9143),
    [anon_sym_COLON_COLON2] = ACTIONS(9143),
    [anon_sym_AMP_DOT] = ACTIONS(9143),
    [anon_sym_PLUS_EQ] = ACTIONS(9143),
    [anon_sym_DASH_EQ] = ACTIONS(9143),
    [anon_sym_STAR_EQ] = ACTIONS(9143),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9143),
    [anon_sym_SLASH_EQ] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9143),
    [anon_sym_PIPE_EQ] = ACTIONS(9143),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9143),
    [anon_sym_AMP_EQ] = ACTIONS(9143),
    [anon_sym_PERCENT_EQ] = ACTIONS(9143),
    [anon_sym_GT_GT_EQ] = ACTIONS(9143),
    [anon_sym_LT_LT_EQ] = ACTIONS(9143),
    [anon_sym_CARET_EQ] = ACTIONS(9143),
    [anon_sym_QMARK] = ACTIONS(9143),
    [anon_sym_COLON2] = ACTIONS(9145),
    [anon_sym_DOT_DOT] = ACTIONS(9145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9143),
    [anon_sym_and] = ACTIONS(9143),
    [anon_sym_or] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE] = ACTIONS(9145),
    [anon_sym_AMP_AMP] = ACTIONS(9145),
    [anon_sym_LT_LT] = ACTIONS(9145),
    [anon_sym_GT_GT] = ACTIONS(9145),
    [anon_sym_EQ_EQ] = ACTIONS(9145),
    [anon_sym_BANG_EQ] = ACTIONS(9143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9143),
    [anon_sym_LT_EQ_GT] = ACTIONS(9143),
    [anon_sym_EQ_TILDE] = ACTIONS(9143),
    [anon_sym_BANG_TILDE] = ACTIONS(9143),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9143),
    [anon_sym_CARET] = ACTIONS(9145),
    [anon_sym_PLUS] = ACTIONS(9145),
    [anon_sym_SLASH] = ACTIONS(9145),
    [anon_sym_PERCENT] = ACTIONS(9145),
    [sym_comment] = ACTIONS(87),
  },
  [6820] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8820),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_assignment] = STATE(8820),
    [sym_operator_assignment] = STATE(8820),
    [sym_conditional] = STATE(8820),
    [sym_range] = STATE(8820),
    [sym_binary] = STATE(8820),
    [sym_unary] = STATE(8820),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6821] = {
    [sym__heredoc_body_start] = ACTIONS(6547),
    [sym__binary_minus] = ACTIONS(6547),
    [sym__binary_star] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_DOT] = ACTIONS(8423),
    [anon_sym_COMMA] = ACTIONS(6547),
    [anon_sym_PIPE] = ACTIONS(8423),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym_STAR_STAR] = ACTIONS(8423),
    [anon_sym_AMP] = ACTIONS(8423),
    [anon_sym_EQ] = ACTIONS(8423),
    [anon_sym_LT] = ACTIONS(8423),
    [anon_sym_if] = ACTIONS(6547),
    [anon_sym_unless] = ACTIONS(6547),
    [anon_sym_while] = ACTIONS(6547),
    [anon_sym_until] = ACTIONS(6547),
    [anon_sym_rescue] = ACTIONS(6547),
    [anon_sym_in] = ACTIONS(6547),
    [anon_sym_do] = ACTIONS(6547),
    [anon_sym_EQ_GT] = ACTIONS(6547),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_RBRACK] = ACTIONS(6547),
    [anon_sym_COLON_COLON2] = ACTIONS(6547),
    [anon_sym_AMP_DOT] = ACTIONS(6547),
    [anon_sym_PLUS_EQ] = ACTIONS(6547),
    [anon_sym_DASH_EQ] = ACTIONS(6547),
    [anon_sym_STAR_EQ] = ACTIONS(6547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6547),
    [anon_sym_SLASH_EQ] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6547),
    [anon_sym_PIPE_EQ] = ACTIONS(6547),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6547),
    [anon_sym_AMP_EQ] = ACTIONS(6547),
    [anon_sym_PERCENT_EQ] = ACTIONS(6547),
    [anon_sym_GT_GT_EQ] = ACTIONS(6547),
    [anon_sym_LT_LT_EQ] = ACTIONS(6547),
    [anon_sym_CARET_EQ] = ACTIONS(6547),
    [anon_sym_QMARK] = ACTIONS(6547),
    [anon_sym_COLON2] = ACTIONS(8423),
    [anon_sym_DOT_DOT] = ACTIONS(8423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6547),
    [anon_sym_and] = ACTIONS(6547),
    [anon_sym_or] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8423),
    [anon_sym_AMP_AMP] = ACTIONS(8423),
    [anon_sym_LT_LT] = ACTIONS(8423),
    [anon_sym_GT_GT] = ACTIONS(8423),
    [anon_sym_EQ_EQ] = ACTIONS(8423),
    [anon_sym_BANG_EQ] = ACTIONS(6547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6547),
    [anon_sym_LT_EQ_GT] = ACTIONS(6547),
    [anon_sym_EQ_TILDE] = ACTIONS(6547),
    [anon_sym_BANG_TILDE] = ACTIONS(6547),
    [anon_sym_LT_EQ] = ACTIONS(8423),
    [anon_sym_GT] = ACTIONS(8423),
    [anon_sym_GT_EQ] = ACTIONS(6547),
    [anon_sym_CARET] = ACTIONS(8423),
    [anon_sym_PLUS] = ACTIONS(8423),
    [anon_sym_SLASH] = ACTIONS(8423),
    [anon_sym_PERCENT] = ACTIONS(8423),
    [sym_comment] = ACTIONS(87),
  },
  [6822] = {
    [sym__heredoc_body_start] = ACTIONS(10596),
    [sym__binary_minus] = ACTIONS(10596),
    [sym__binary_star] = ACTIONS(10596),
    [anon_sym_LBRACE] = ACTIONS(10596),
    [anon_sym_RBRACE] = ACTIONS(10596),
    [anon_sym_RPAREN] = ACTIONS(10596),
    [anon_sym_DOT] = ACTIONS(10598),
    [anon_sym_COMMA] = ACTIONS(10596),
    [anon_sym_PIPE] = ACTIONS(10598),
    [anon_sym_SEMI] = ACTIONS(10596),
    [anon_sym_STAR_STAR] = ACTIONS(10598),
    [anon_sym_AMP] = ACTIONS(10598),
    [anon_sym_EQ] = ACTIONS(10598),
    [anon_sym_LT] = ACTIONS(10598),
    [anon_sym_if] = ACTIONS(10596),
    [anon_sym_unless] = ACTIONS(10596),
    [anon_sym_while] = ACTIONS(10596),
    [anon_sym_until] = ACTIONS(10596),
    [anon_sym_rescue] = ACTIONS(10596),
    [anon_sym_in] = ACTIONS(10596),
    [anon_sym_do] = ACTIONS(10596),
    [anon_sym_EQ_GT] = ACTIONS(10596),
    [anon_sym_LBRACK] = ACTIONS(10596),
    [anon_sym_RBRACK] = ACTIONS(10596),
    [anon_sym_COLON_COLON2] = ACTIONS(10596),
    [anon_sym_AMP_DOT] = ACTIONS(10596),
    [anon_sym_PLUS_EQ] = ACTIONS(10596),
    [anon_sym_DASH_EQ] = ACTIONS(10596),
    [anon_sym_STAR_EQ] = ACTIONS(10596),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10596),
    [anon_sym_SLASH_EQ] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10596),
    [anon_sym_PIPE_EQ] = ACTIONS(10596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10596),
    [anon_sym_AMP_EQ] = ACTIONS(10596),
    [anon_sym_PERCENT_EQ] = ACTIONS(10596),
    [anon_sym_GT_GT_EQ] = ACTIONS(10596),
    [anon_sym_LT_LT_EQ] = ACTIONS(10596),
    [anon_sym_CARET_EQ] = ACTIONS(10596),
    [anon_sym_QMARK] = ACTIONS(10596),
    [anon_sym_COLON2] = ACTIONS(10598),
    [anon_sym_DOT_DOT] = ACTIONS(10598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10596),
    [anon_sym_and] = ACTIONS(10596),
    [anon_sym_or] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE] = ACTIONS(10598),
    [anon_sym_AMP_AMP] = ACTIONS(10598),
    [anon_sym_LT_LT] = ACTIONS(10598),
    [anon_sym_GT_GT] = ACTIONS(10598),
    [anon_sym_EQ_EQ] = ACTIONS(10598),
    [anon_sym_BANG_EQ] = ACTIONS(10596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10596),
    [anon_sym_LT_EQ_GT] = ACTIONS(10596),
    [anon_sym_EQ_TILDE] = ACTIONS(10596),
    [anon_sym_BANG_TILDE] = ACTIONS(10596),
    [anon_sym_LT_EQ] = ACTIONS(10598),
    [anon_sym_GT] = ACTIONS(10598),
    [anon_sym_GT_EQ] = ACTIONS(10596),
    [anon_sym_CARET] = ACTIONS(10598),
    [anon_sym_PLUS] = ACTIONS(10598),
    [anon_sym_SLASH] = ACTIONS(10598),
    [anon_sym_PERCENT] = ACTIONS(10598),
    [sym_comment] = ACTIONS(87),
  },
  [6823] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4289),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_splat_argument] = STATE(8821),
    [sym_assignment] = STATE(4289),
    [sym_operator_assignment] = STATE(4289),
    [sym_conditional] = STATE(4289),
    [sym_range] = STATE(4289),
    [sym_binary] = STATE(4289),
    [sym_unary] = STATE(4289),
    [sym__arg_or_splat_arg] = STATE(8821),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(1932),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(1157),
    [sym__unary_minus] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6824] = {
    [aux_sym_exceptions_repeat1] = STATE(8822),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12175),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [6825] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6826] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [6827] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6828] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6829] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6830] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12177),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6831] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6832] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6833] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6834] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6835] = {
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [6836] = {
    [aux_sym_exceptions_repeat1] = STATE(6836),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(12179),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [6837] = {
    [aux_sym_exceptions_repeat1] = STATE(4308),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [6838] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [6839] = {
    [sym_string] = STATE(6839),
    [aux_sym_chained_string_repeat1] = STATE(6839),
    [sym__string_start] = ACTIONS(6891),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [6840] = {
    [sym__simple_symbol] = ACTIONS(6547),
    [sym__string_start] = ACTIONS(6547),
    [sym__symbol_start] = ACTIONS(6547),
    [sym__subshell_start] = ACTIONS(6547),
    [sym__regex_start] = ACTIONS(6547),
    [sym__string_array_start] = ACTIONS(6547),
    [sym__symbol_array_start] = ACTIONS(6547),
    [sym__heredoc_body_start] = ACTIONS(6547),
    [sym_heredoc_beginning] = ACTIONS(6547),
    [sym__unary_minus] = ACTIONS(6547),
    [sym__identifier_hash_key] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_def] = ACTIONS(8423),
    [anon_sym_LPAREN] = ACTIONS(6547),
    [anon_sym_COLON_COLON] = ACTIONS(6547),
    [anon_sym_STAR] = ACTIONS(8423),
    [anon_sym_STAR_STAR] = ACTIONS(6547),
    [anon_sym_class] = ACTIONS(8423),
    [anon_sym_module] = ACTIONS(8423),
    [anon_sym_return] = ACTIONS(8423),
    [anon_sym_yield] = ACTIONS(8423),
    [anon_sym_break] = ACTIONS(8423),
    [anon_sym_next] = ACTIONS(8423),
    [sym_redo] = ACTIONS(8423),
    [sym_retry] = ACTIONS(8423),
    [anon_sym_if] = ACTIONS(8423),
    [anon_sym_unless] = ACTIONS(8423),
    [anon_sym_while] = ACTIONS(8423),
    [anon_sym_until] = ACTIONS(8423),
    [anon_sym_for] = ACTIONS(8423),
    [anon_sym_case] = ACTIONS(8423),
    [anon_sym_begin] = ACTIONS(8423),
    [anon_sym_PLUS] = ACTIONS(8423),
    [anon_sym_defined_QMARK] = ACTIONS(6547),
    [anon_sym_not] = ACTIONS(8423),
    [anon_sym_BANG] = ACTIONS(6547),
    [anon_sym_TILDE] = ACTIONS(6547),
    [sym_constant] = ACTIONS(8423),
    [sym_identifier] = ACTIONS(8423),
    [sym_instance_variable] = ACTIONS(6547),
    [sym_class_variable] = ACTIONS(6547),
    [sym_global_variable] = ACTIONS(6547),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8423),
    [sym_float] = ACTIONS(8423),
    [sym_complex] = ACTIONS(6547),
    [sym_super] = ACTIONS(8423),
    [anon_sym_true] = ACTIONS(8423),
    [anon_sym_TRUE] = ACTIONS(8423),
    [anon_sym_false] = ACTIONS(8423),
    [anon_sym_FALSE] = ACTIONS(8423),
    [sym_self] = ACTIONS(8423),
    [anon_sym_nil] = ACTIONS(8423),
    [anon_sym_NIL] = ACTIONS(8423),
    [sym_character] = ACTIONS(6547),
    [anon_sym_LBRACK2] = ACTIONS(6547),
    [anon_sym_DASH_GT] = ACTIONS(6547),
  },
  [6841] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6842] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10177),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [6843] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8824),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(8824),
    [sym_operator_assignment] = STATE(8824),
    [sym_conditional] = STATE(8824),
    [sym_range] = STATE(8824),
    [sym_binary] = STATE(8824),
    [sym_unary] = STATE(8824),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6844] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8825),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(8825),
    [sym_operator_assignment] = STATE(8825),
    [sym_conditional] = STATE(8825),
    [sym_range] = STATE(8825),
    [sym_binary] = STATE(8825),
    [sym_unary] = STATE(8825),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6845] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8826),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(8826),
    [sym_operator_assignment] = STATE(8826),
    [sym_conditional] = STATE(8826),
    [sym_range] = STATE(8826),
    [sym_binary] = STATE(8826),
    [sym_unary] = STATE(8826),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6846] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8827),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(8827),
    [sym_operator_assignment] = STATE(8827),
    [sym_conditional] = STATE(8827),
    [sym_range] = STATE(8827),
    [sym_binary] = STATE(8827),
    [sym_unary] = STATE(8827),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6847] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8828),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(8828),
    [sym_operator_assignment] = STATE(8828),
    [sym_conditional] = STATE(8828),
    [sym_range] = STATE(8828),
    [sym_binary] = STATE(8828),
    [sym_unary] = STATE(8828),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6848] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8829),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8829),
    [sym_operator_assignment] = STATE(8829),
    [sym_conditional] = STATE(8829),
    [sym_range] = STATE(8829),
    [sym_binary] = STATE(8829),
    [sym_unary] = STATE(8829),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6849] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8830),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(8830),
    [sym_operator_assignment] = STATE(8830),
    [sym_conditional] = STATE(8830),
    [sym_range] = STATE(8830),
    [sym_binary] = STATE(8830),
    [sym_unary] = STATE(8830),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6850] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8831),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(8831),
    [sym_operator_assignment] = STATE(8831),
    [sym_conditional] = STATE(8831),
    [sym_range] = STATE(8831),
    [sym_binary] = STATE(8831),
    [sym_unary] = STATE(8831),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6851] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8832),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(8832),
    [sym_operator_assignment] = STATE(8832),
    [sym_conditional] = STATE(8832),
    [sym_range] = STATE(8832),
    [sym_binary] = STATE(8832),
    [sym_unary] = STATE(8832),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6852] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8833),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(8833),
    [sym_operator_assignment] = STATE(8833),
    [sym_conditional] = STATE(8833),
    [sym_range] = STATE(8833),
    [sym_binary] = STATE(8833),
    [sym_unary] = STATE(8833),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6853] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8834),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_splat_argument] = STATE(8835),
    [sym_assignment] = STATE(8834),
    [sym_operator_assignment] = STATE(8834),
    [sym_conditional] = STATE(8834),
    [sym_range] = STATE(8834),
    [sym_binary] = STATE(8834),
    [sym_unary] = STATE(8834),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(8835),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6854] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8836),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(8836),
    [sym_operator_assignment] = STATE(8836),
    [sym_conditional] = STATE(8836),
    [sym_range] = STATE(8836),
    [sym_binary] = STATE(8836),
    [sym_unary] = STATE(8836),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6855] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(10177),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [6856] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(10177),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [6857] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [6858] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [6859] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [6860] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [6861] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [6862] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12182),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6863] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [6864] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [6865] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [6866] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [6867] = {
    [sym_heredoc_body] = STATE(6867),
    [aux_sym_call_repeat1] = STATE(6867),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [6868] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(2039),
    [sym_operator_assignment] = STATE(2039),
    [sym_conditional] = STATE(2039),
    [sym_range] = STATE(2039),
    [sym_binary] = STATE(2039),
    [sym_unary] = STATE(2039),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2044),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3456),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__identifier_hash_key] = ACTIONS(3462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10199),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(3472),
    [sym_identifier] = ACTIONS(3472),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6869] = {
    [sym_heredoc_body] = STATE(6867),
    [aux_sym_call_repeat1] = STATE(6867),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [6870] = {
    [aux_sym_argument_list_repeat1] = STATE(6870),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12184),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [6871] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [6872] = {
    [aux_sym_exceptions_repeat1] = STATE(8839),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [6873] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [6874] = {
    [sym__line_break] = ACTIONS(12187),
    [sym__heredoc_body_start] = ACTIONS(12187),
    [sym__binary_minus] = ACTIONS(12187),
    [sym__binary_star] = ACTIONS(12187),
    [ts_builtin_sym_end] = ACTIONS(12187),
    [anon_sym___END__] = ACTIONS(12187),
    [anon_sym_LBRACE] = ACTIONS(12187),
    [anon_sym_RBRACE] = ACTIONS(12187),
    [anon_sym_RPAREN] = ACTIONS(12187),
    [anon_sym_DOT] = ACTIONS(12189),
    [anon_sym_COMMA] = ACTIONS(12187),
    [anon_sym_PIPE] = ACTIONS(12189),
    [anon_sym_SEMI] = ACTIONS(12187),
    [anon_sym_STAR_STAR] = ACTIONS(12187),
    [anon_sym_AMP] = ACTIONS(12189),
    [anon_sym_LT] = ACTIONS(12189),
    [anon_sym_end] = ACTIONS(12187),
    [anon_sym_if] = ACTIONS(12187),
    [anon_sym_unless] = ACTIONS(12187),
    [anon_sym_while] = ACTIONS(12187),
    [anon_sym_until] = ACTIONS(12187),
    [anon_sym_rescue] = ACTIONS(12187),
    [anon_sym_do] = ACTIONS(12187),
    [anon_sym_when] = ACTIONS(12187),
    [anon_sym_elsif] = ACTIONS(12187),
    [anon_sym_else] = ACTIONS(12187),
    [anon_sym_then] = ACTIONS(12187),
    [anon_sym_ensure] = ACTIONS(12187),
    [anon_sym_EQ_GT] = ACTIONS(12187),
    [anon_sym_LBRACK] = ACTIONS(12187),
    [anon_sym_COLON_COLON2] = ACTIONS(12187),
    [anon_sym_AMP_DOT] = ACTIONS(12187),
    [anon_sym_QMARK] = ACTIONS(12187),
    [anon_sym_DOT_DOT] = ACTIONS(12189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12187),
    [anon_sym_and] = ACTIONS(12187),
    [anon_sym_or] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE] = ACTIONS(12187),
    [anon_sym_AMP_AMP] = ACTIONS(12187),
    [anon_sym_LT_LT] = ACTIONS(12187),
    [anon_sym_GT_GT] = ACTIONS(12187),
    [anon_sym_EQ_EQ] = ACTIONS(12189),
    [anon_sym_BANG_EQ] = ACTIONS(12187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12187),
    [anon_sym_LT_EQ_GT] = ACTIONS(12187),
    [anon_sym_EQ_TILDE] = ACTIONS(12187),
    [anon_sym_BANG_TILDE] = ACTIONS(12187),
    [anon_sym_LT_EQ] = ACTIONS(12189),
    [anon_sym_GT] = ACTIONS(12189),
    [anon_sym_GT_EQ] = ACTIONS(12187),
    [anon_sym_CARET] = ACTIONS(12187),
    [anon_sym_PLUS] = ACTIONS(12187),
    [anon_sym_SLASH] = ACTIONS(12187),
    [anon_sym_PERCENT] = ACTIONS(12187),
    [sym_comment] = ACTIONS(87),
  },
  [6875] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8840),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(674),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(674),
    [sym_assignment] = STATE(8840),
    [sym_operator_assignment] = STATE(8840),
    [sym_conditional] = STATE(8840),
    [sym_range] = STATE(8840),
    [sym_binary] = STATE(8840),
    [sym_unary] = STATE(8840),
    [sym_left_assignment_list] = STATE(673),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(674),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_nil] = STATE(674),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(675),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1245),
    [anon_sym_break] = ACTIONS(1247),
    [anon_sym_next] = ACTIONS(1249),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_defined_QMARK] = ACTIONS(1253),
    [anon_sym_not] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6876] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [6877] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [6878] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8841),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(8841),
    [sym_operator_assignment] = STATE(8841),
    [sym_conditional] = STATE(8841),
    [sym_range] = STATE(8841),
    [sym_binary] = STATE(8841),
    [sym_unary] = STATE(8841),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6879] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8842),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(8842),
    [sym_operator_assignment] = STATE(8842),
    [sym_conditional] = STATE(8842),
    [sym_range] = STATE(8842),
    [sym_binary] = STATE(8842),
    [sym_unary] = STATE(8842),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6880] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8843),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(8843),
    [sym_operator_assignment] = STATE(8843),
    [sym_conditional] = STATE(8843),
    [sym_range] = STATE(8843),
    [sym_binary] = STATE(8843),
    [sym_unary] = STATE(8843),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6881] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8844),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(8844),
    [sym_operator_assignment] = STATE(8844),
    [sym_conditional] = STATE(8844),
    [sym_range] = STATE(8844),
    [sym_binary] = STATE(8844),
    [sym_unary] = STATE(8844),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6882] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8845),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(8845),
    [sym_operator_assignment] = STATE(8845),
    [sym_conditional] = STATE(8845),
    [sym_range] = STATE(8845),
    [sym_binary] = STATE(8845),
    [sym_unary] = STATE(8845),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6883] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8846),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8846),
    [sym_operator_assignment] = STATE(8846),
    [sym_conditional] = STATE(8846),
    [sym_range] = STATE(8846),
    [sym_binary] = STATE(8846),
    [sym_unary] = STATE(8846),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6884] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8847),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(8847),
    [sym_operator_assignment] = STATE(8847),
    [sym_conditional] = STATE(8847),
    [sym_range] = STATE(8847),
    [sym_binary] = STATE(8847),
    [sym_unary] = STATE(8847),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6885] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8848),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(8848),
    [sym_operator_assignment] = STATE(8848),
    [sym_conditional] = STATE(8848),
    [sym_range] = STATE(8848),
    [sym_binary] = STATE(8848),
    [sym_unary] = STATE(8848),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6886] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8849),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(8849),
    [sym_operator_assignment] = STATE(8849),
    [sym_conditional] = STATE(8849),
    [sym_range] = STATE(8849),
    [sym_binary] = STATE(8849),
    [sym_unary] = STATE(8849),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6887] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8850),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(8850),
    [sym_operator_assignment] = STATE(8850),
    [sym_conditional] = STATE(8850),
    [sym_range] = STATE(8850),
    [sym_binary] = STATE(8850),
    [sym_unary] = STATE(8850),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6888] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8851),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_splat_argument] = STATE(8852),
    [sym_assignment] = STATE(8851),
    [sym_operator_assignment] = STATE(8851),
    [sym_conditional] = STATE(8851),
    [sym_range] = STATE(8851),
    [sym_binary] = STATE(8851),
    [sym_unary] = STATE(8851),
    [sym_right_assignment_list] = STATE(8647),
    [sym__arg_or_splat_arg] = STATE(8852),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6889] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8853),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(8853),
    [sym_operator_assignment] = STATE(8853),
    [sym_conditional] = STATE(8853),
    [sym_range] = STATE(8853),
    [sym_binary] = STATE(8853),
    [sym_unary] = STATE(8853),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [6890] = {
    [sym_string] = STATE(8854),
    [aux_sym_chained_string_repeat1] = STATE(8854),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [6891] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [6892] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [6893] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [6894] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [6895] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [6896] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [6897] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [6898] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12191),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6899] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [6900] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [6901] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [6902] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [6903] = {
    [sym_heredoc_body] = STATE(6903),
    [aux_sym_call_repeat1] = STATE(6903),
    [sym__heredoc_body_start] = ACTIONS(12063),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [6904] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2069),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(2069),
    [sym_operator_assignment] = STATE(2069),
    [sym_conditional] = STATE(2069),
    [sym_range] = STATE(2069),
    [sym_binary] = STATE(2069),
    [sym_unary] = STATE(2069),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2075),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(3504),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__identifier_hash_key] = ACTIONS(3510),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10237),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3528),
    [sym_identifier] = ACTIONS(3528),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [6905] = {
    [sym_heredoc_body] = STATE(6903),
    [aux_sym_call_repeat1] = STATE(6903),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [6906] = {
    [aux_sym_argument_list_repeat1] = STATE(6906),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12193),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [6907] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [6908] = {
    [aux_sym_exceptions_repeat1] = STATE(8857),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [6909] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [6910] = {
    [sym_string] = STATE(6910),
    [aux_sym_chained_string_repeat1] = STATE(6910),
    [sym__string_start] = ACTIONS(10160),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [6911] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(10247),
    [anon_sym_QMARK] = ACTIONS(10249),
    [anon_sym_DOT_DOT] = ACTIONS(10251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10253),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(10255),
    [anon_sym_AMP_AMP] = ACTIONS(10255),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(10259),
    [anon_sym_BANG_EQ] = ACTIONS(10255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10255),
    [anon_sym_LT_EQ_GT] = ACTIONS(10255),
    [anon_sym_EQ_TILDE] = ACTIONS(10255),
    [anon_sym_BANG_TILDE] = ACTIONS(10255),
    [anon_sym_LT_EQ] = ACTIONS(10247),
    [anon_sym_GT] = ACTIONS(10247),
    [anon_sym_GT_EQ] = ACTIONS(10261),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [6912] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6913] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(10247),
    [anon_sym_QMARK] = ACTIONS(10249),
    [anon_sym_DOT_DOT] = ACTIONS(10251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10253),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10255),
    [anon_sym_AMP_AMP] = ACTIONS(10255),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(10259),
    [anon_sym_BANG_EQ] = ACTIONS(10255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10255),
    [anon_sym_LT_EQ_GT] = ACTIONS(10255),
    [anon_sym_EQ_TILDE] = ACTIONS(10255),
    [anon_sym_BANG_TILDE] = ACTIONS(10255),
    [anon_sym_LT_EQ] = ACTIONS(10247),
    [anon_sym_GT] = ACTIONS(10247),
    [anon_sym_GT_EQ] = ACTIONS(10261),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [6914] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8858),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(8858),
    [sym_operator_assignment] = STATE(8858),
    [sym_conditional] = STATE(8858),
    [sym_range] = STATE(8858),
    [sym_binary] = STATE(8858),
    [sym_unary] = STATE(8858),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6915] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8859),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(8859),
    [sym_operator_assignment] = STATE(8859),
    [sym_conditional] = STATE(8859),
    [sym_range] = STATE(8859),
    [sym_binary] = STATE(8859),
    [sym_unary] = STATE(8859),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6916] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8860),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(8860),
    [sym_operator_assignment] = STATE(8860),
    [sym_conditional] = STATE(8860),
    [sym_range] = STATE(8860),
    [sym_binary] = STATE(8860),
    [sym_unary] = STATE(8860),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6917] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8861),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(8861),
    [sym_operator_assignment] = STATE(8861),
    [sym_conditional] = STATE(8861),
    [sym_range] = STATE(8861),
    [sym_binary] = STATE(8861),
    [sym_unary] = STATE(8861),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6918] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8862),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(8862),
    [sym_operator_assignment] = STATE(8862),
    [sym_conditional] = STATE(8862),
    [sym_range] = STATE(8862),
    [sym_binary] = STATE(8862),
    [sym_unary] = STATE(8862),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6919] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8863),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8863),
    [sym_operator_assignment] = STATE(8863),
    [sym_conditional] = STATE(8863),
    [sym_range] = STATE(8863),
    [sym_binary] = STATE(8863),
    [sym_unary] = STATE(8863),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6920] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8864),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(8864),
    [sym_operator_assignment] = STATE(8864),
    [sym_conditional] = STATE(8864),
    [sym_range] = STATE(8864),
    [sym_binary] = STATE(8864),
    [sym_unary] = STATE(8864),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6921] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8865),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(8865),
    [sym_operator_assignment] = STATE(8865),
    [sym_conditional] = STATE(8865),
    [sym_range] = STATE(8865),
    [sym_binary] = STATE(8865),
    [sym_unary] = STATE(8865),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6922] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8866),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(8866),
    [sym_operator_assignment] = STATE(8866),
    [sym_conditional] = STATE(8866),
    [sym_range] = STATE(8866),
    [sym_binary] = STATE(8866),
    [sym_unary] = STATE(8866),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6923] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8867),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(8867),
    [sym_operator_assignment] = STATE(8867),
    [sym_conditional] = STATE(8867),
    [sym_range] = STATE(8867),
    [sym_binary] = STATE(8867),
    [sym_unary] = STATE(8867),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6924] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4396),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_splat_argument] = STATE(6835),
    [sym_assignment] = STATE(4396),
    [sym_operator_assignment] = STATE(4396),
    [sym_conditional] = STATE(4396),
    [sym_range] = STATE(4396),
    [sym_binary] = STATE(4396),
    [sym_unary] = STATE(4396),
    [sym__arg_or_splat_arg] = STATE(6835),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(7026),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6925] = {
    [aux_sym_exceptions_repeat1] = STATE(8868),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(10265),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [6926] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(4396),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_splat_argument] = STATE(8869),
    [sym_assignment] = STATE(4396),
    [sym_operator_assignment] = STATE(4396),
    [sym_conditional] = STATE(4396),
    [sym_range] = STATE(4396),
    [sym_binary] = STATE(4396),
    [sym_unary] = STATE(4396),
    [sym_right_assignment_list] = STATE(2017),
    [sym__arg_or_splat_arg] = STATE(8869),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(7026),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6927] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8870),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(8870),
    [sym_operator_assignment] = STATE(8870),
    [sym_conditional] = STATE(8870),
    [sym_range] = STATE(8870),
    [sym_binary] = STATE(8870),
    [sym_unary] = STATE(8870),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6928] = {
    [sym_string] = STATE(8871),
    [aux_sym_chained_string_repeat1] = STATE(8871),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [6929] = {
    [sym__simple_symbol] = ACTIONS(12196),
    [sym__string_start] = ACTIONS(12196),
    [sym__symbol_start] = ACTIONS(12196),
    [sym__subshell_start] = ACTIONS(12196),
    [sym__regex_start] = ACTIONS(12196),
    [sym__string_array_start] = ACTIONS(12196),
    [sym__symbol_array_start] = ACTIONS(12196),
    [sym_heredoc_beginning] = ACTIONS(12196),
    [sym__unary_minus] = ACTIONS(12196),
    [anon_sym_BEGIN] = ACTIONS(12198),
    [anon_sym_LBRACE] = ACTIONS(12196),
    [anon_sym_END] = ACTIONS(12198),
    [anon_sym_def] = ACTIONS(12198),
    [anon_sym_LPAREN] = ACTIONS(12196),
    [anon_sym_COLON_COLON] = ACTIONS(12196),
    [anon_sym_SEMI] = ACTIONS(12196),
    [anon_sym_STAR] = ACTIONS(12196),
    [anon_sym_class] = ACTIONS(12198),
    [anon_sym_module] = ACTIONS(12198),
    [anon_sym_end] = ACTIONS(12198),
    [anon_sym_return] = ACTIONS(12198),
    [anon_sym_yield] = ACTIONS(12198),
    [anon_sym_break] = ACTIONS(12198),
    [anon_sym_next] = ACTIONS(12198),
    [sym_redo] = ACTIONS(12198),
    [sym_retry] = ACTIONS(12198),
    [anon_sym_if] = ACTIONS(12198),
    [anon_sym_unless] = ACTIONS(12198),
    [anon_sym_while] = ACTIONS(12198),
    [anon_sym_until] = ACTIONS(12198),
    [anon_sym_rescue] = ACTIONS(12198),
    [anon_sym_for] = ACTIONS(12198),
    [anon_sym_case] = ACTIONS(12198),
    [anon_sym_else] = ACTIONS(12198),
    [anon_sym_begin] = ACTIONS(12198),
    [anon_sym_ensure] = ACTIONS(12198),
    [anon_sym_PLUS] = ACTIONS(12198),
    [anon_sym_defined_QMARK] = ACTIONS(12196),
    [anon_sym_not] = ACTIONS(12198),
    [anon_sym_BANG] = ACTIONS(12196),
    [anon_sym_TILDE] = ACTIONS(12196),
    [sym_constant] = ACTIONS(12198),
    [sym_identifier] = ACTIONS(12198),
    [sym_instance_variable] = ACTIONS(12196),
    [sym_class_variable] = ACTIONS(12196),
    [sym_global_variable] = ACTIONS(12196),
    [anon_sym_undef] = ACTIONS(12198),
    [anon_sym_alias] = ACTIONS(12198),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(12198),
    [sym_float] = ACTIONS(12198),
    [sym_complex] = ACTIONS(12196),
    [sym_super] = ACTIONS(12198),
    [anon_sym_true] = ACTIONS(12198),
    [anon_sym_TRUE] = ACTIONS(12198),
    [anon_sym_false] = ACTIONS(12198),
    [anon_sym_FALSE] = ACTIONS(12198),
    [sym_self] = ACTIONS(12198),
    [anon_sym_nil] = ACTIONS(12198),
    [anon_sym_NIL] = ACTIONS(12198),
    [sym_character] = ACTIONS(12196),
    [anon_sym_LBRACK2] = ACTIONS(12196),
    [anon_sym_DASH_GT] = ACTIONS(12196),
  },
  [6930] = {
    [sym_heredoc_body] = STATE(8872),
    [sym__terminator] = STATE(8872),
    [sym__line_break] = ACTIONS(12200),
    [sym__simple_symbol] = ACTIONS(12196),
    [sym__string_start] = ACTIONS(12196),
    [sym__symbol_start] = ACTIONS(12196),
    [sym__subshell_start] = ACTIONS(12196),
    [sym__regex_start] = ACTIONS(12196),
    [sym__string_array_start] = ACTIONS(12196),
    [sym__symbol_array_start] = ACTIONS(12196),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(12196),
    [sym__unary_minus] = ACTIONS(12196),
    [anon_sym_BEGIN] = ACTIONS(12198),
    [anon_sym_LBRACE] = ACTIONS(12196),
    [anon_sym_END] = ACTIONS(12198),
    [anon_sym_def] = ACTIONS(12198),
    [anon_sym_LPAREN] = ACTIONS(12196),
    [anon_sym_COLON_COLON] = ACTIONS(12196),
    [anon_sym_SEMI] = ACTIONS(12200),
    [anon_sym_STAR] = ACTIONS(12196),
    [anon_sym_class] = ACTIONS(12198),
    [anon_sym_module] = ACTIONS(12198),
    [anon_sym_end] = ACTIONS(12198),
    [anon_sym_return] = ACTIONS(12198),
    [anon_sym_yield] = ACTIONS(12198),
    [anon_sym_break] = ACTIONS(12198),
    [anon_sym_next] = ACTIONS(12198),
    [sym_redo] = ACTIONS(12198),
    [sym_retry] = ACTIONS(12198),
    [anon_sym_if] = ACTIONS(12198),
    [anon_sym_unless] = ACTIONS(12198),
    [anon_sym_while] = ACTIONS(12198),
    [anon_sym_until] = ACTIONS(12198),
    [anon_sym_rescue] = ACTIONS(12198),
    [anon_sym_for] = ACTIONS(12198),
    [anon_sym_case] = ACTIONS(12198),
    [anon_sym_else] = ACTIONS(12198),
    [anon_sym_begin] = ACTIONS(12198),
    [anon_sym_ensure] = ACTIONS(12198),
    [anon_sym_PLUS] = ACTIONS(12198),
    [anon_sym_defined_QMARK] = ACTIONS(12196),
    [anon_sym_not] = ACTIONS(12198),
    [anon_sym_BANG] = ACTIONS(12196),
    [anon_sym_TILDE] = ACTIONS(12196),
    [sym_constant] = ACTIONS(12198),
    [sym_identifier] = ACTIONS(12198),
    [sym_instance_variable] = ACTIONS(12196),
    [sym_class_variable] = ACTIONS(12196),
    [sym_global_variable] = ACTIONS(12196),
    [anon_sym_undef] = ACTIONS(12198),
    [anon_sym_alias] = ACTIONS(12198),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(12198),
    [sym_float] = ACTIONS(12198),
    [sym_complex] = ACTIONS(12196),
    [sym_super] = ACTIONS(12198),
    [anon_sym_true] = ACTIONS(12198),
    [anon_sym_TRUE] = ACTIONS(12198),
    [anon_sym_false] = ACTIONS(12198),
    [anon_sym_FALSE] = ACTIONS(12198),
    [sym_self] = ACTIONS(12198),
    [anon_sym_nil] = ACTIONS(12198),
    [anon_sym_NIL] = ACTIONS(12198),
    [sym_character] = ACTIONS(12196),
    [anon_sym_LBRACK2] = ACTIONS(12196),
    [anon_sym_DASH_GT] = ACTIONS(12196),
  },
  [6931] = {
    [sym__line_break] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5594),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_then] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [sym_comment] = ACTIONS(87),
  },
  [6932] = {
    [anon_sym_RBRACE] = ACTIONS(12202),
    [sym_comment] = ACTIONS(87),
  },
  [6933] = {
    [sym__statements] = STATE(8874),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(12202),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6934] = {
    [sym__line_break] = ACTIONS(5630),
    [sym__heredoc_body_start] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_then] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [sym_comment] = ACTIONS(87),
  },
  [6935] = {
    [anon_sym_end] = ACTIONS(12204),
    [sym_comment] = ACTIONS(87),
  },
  [6936] = {
    [sym__statements] = STATE(8876),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(8877),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(8877),
    [sym__line_break] = ACTIONS(12206),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12208),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6937] = {
    [sym__statements] = STATE(8876),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(8878),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12208),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6938] = {
    [sym__line_break] = ACTIONS(5666),
    [sym__heredoc_body_start] = ACTIONS(5666),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_SEMI] = ACTIONS(5666),
    [sym_comment] = ACTIONS(87),
  },
  [6939] = {
    [aux_sym_method_parameters_repeat1] = STATE(8880),
    [anon_sym_RPAREN] = ACTIONS(12210),
    [anon_sym_COMMA] = ACTIONS(5616),
    [sym_comment] = ACTIONS(87),
  },
  [6940] = {
    [sym__formal_parameter] = STATE(8881),
    [sym__simple_formal_parameter] = STATE(8881),
    [sym_destructured_parameter] = STATE(8881),
    [sym_splat_parameter] = STATE(8881),
    [sym_hash_splat_parameter] = STATE(8881),
    [sym_block_parameter] = STATE(8881),
    [sym_keyword_parameter] = STATE(8881),
    [sym_optional_parameter] = STATE(8881),
    [anon_sym_LPAREN] = ACTIONS(7066),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1287),
    [sym_identifier] = ACTIONS(1289),
    [sym_comment] = ACTIONS(87),
  },
  [6941] = {
    [sym_heredoc_body] = STATE(8872),
    [sym__terminator] = STATE(8872),
    [aux_sym_method_parameters_repeat1] = STATE(8882),
    [sym__line_break] = ACTIONS(12200),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(10291),
    [anon_sym_SEMI] = ACTIONS(12200),
    [sym_comment] = ACTIONS(87),
  },
  [6942] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [6943] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8883),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8883),
    [sym_operator_assignment] = STATE(8883),
    [sym_conditional] = STATE(8883),
    [sym_range] = STATE(8883),
    [sym_binary] = STATE(8883),
    [sym_unary] = STATE(8883),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6944] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8884),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8884),
    [sym_operator_assignment] = STATE(8884),
    [sym_conditional] = STATE(8884),
    [sym_range] = STATE(8884),
    [sym_binary] = STATE(8884),
    [sym_unary] = STATE(8884),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6945] = {
    [anon_sym_COLON] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [6946] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8886),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8886),
    [sym_operator_assignment] = STATE(8886),
    [sym_conditional] = STATE(8886),
    [sym_range] = STATE(8886),
    [sym_binary] = STATE(8886),
    [sym_unary] = STATE(8886),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6947] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12214),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [6948] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(12212),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6949] = {
    [sym_heredoc_body] = STATE(8888),
    [aux_sym_call_repeat1] = STATE(8888),
    [sym__heredoc_body_start] = ACTIONS(10491),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [6950] = {
    [sym_heredoc_body] = STATE(8888),
    [aux_sym_call_repeat1] = STATE(8888),
    [aux_sym_argument_list_repeat1] = STATE(8890),
    [sym__heredoc_body_start] = ACTIONS(10491),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(12216),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [6951] = {
    [sym_string] = STATE(4456),
    [aux_sym_chained_string_repeat1] = STATE(4456),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12218),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6952] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [6953] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8891),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8891),
    [sym_operator_assignment] = STATE(8891),
    [sym_conditional] = STATE(8891),
    [sym_range] = STATE(8891),
    [sym_binary] = STATE(8891),
    [sym_unary] = STATE(8891),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6954] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8892),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8892),
    [sym_operator_assignment] = STATE(8892),
    [sym_conditional] = STATE(8892),
    [sym_range] = STATE(8892),
    [sym_binary] = STATE(8892),
    [sym_unary] = STATE(8892),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6955] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8893),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8893),
    [sym_operator_assignment] = STATE(8893),
    [sym_conditional] = STATE(8893),
    [sym_range] = STATE(8893),
    [sym_binary] = STATE(8893),
    [sym_unary] = STATE(8893),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6956] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8894),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8894),
    [sym_operator_assignment] = STATE(8894),
    [sym_conditional] = STATE(8894),
    [sym_range] = STATE(8894),
    [sym_binary] = STATE(8894),
    [sym_unary] = STATE(8894),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6957] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8895),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8895),
    [sym_operator_assignment] = STATE(8895),
    [sym_conditional] = STATE(8895),
    [sym_range] = STATE(8895),
    [sym_binary] = STATE(8895),
    [sym_unary] = STATE(8895),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6958] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8896),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(8896),
    [sym_operator_assignment] = STATE(8896),
    [sym_conditional] = STATE(8896),
    [sym_range] = STATE(8896),
    [sym_binary] = STATE(8896),
    [sym_unary] = STATE(8896),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6959] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8897),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8897),
    [sym_operator_assignment] = STATE(8897),
    [sym_conditional] = STATE(8897),
    [sym_range] = STATE(8897),
    [sym_binary] = STATE(8897),
    [sym_unary] = STATE(8897),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6960] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8898),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8898),
    [sym_operator_assignment] = STATE(8898),
    [sym_conditional] = STATE(8898),
    [sym_range] = STATE(8898),
    [sym_binary] = STATE(8898),
    [sym_unary] = STATE(8898),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6961] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8899),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8899),
    [sym_operator_assignment] = STATE(8899),
    [sym_conditional] = STATE(8899),
    [sym_range] = STATE(8899),
    [sym_binary] = STATE(8899),
    [sym_unary] = STATE(8899),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6962] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8900),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8900),
    [sym_operator_assignment] = STATE(8900),
    [sym_conditional] = STATE(8900),
    [sym_range] = STATE(8900),
    [sym_binary] = STATE(8900),
    [sym_unary] = STATE(8900),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6963] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8901),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_splat_argument] = STATE(8902),
    [sym_assignment] = STATE(8901),
    [sym_operator_assignment] = STATE(8901),
    [sym_conditional] = STATE(8901),
    [sym_range] = STATE(8901),
    [sym_binary] = STATE(8901),
    [sym_unary] = STATE(8901),
    [sym_right_assignment_list] = STATE(7202),
    [sym__arg_or_splat_arg] = STATE(8902),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(10295),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6964] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8903),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(8903),
    [sym_operator_assignment] = STATE(8903),
    [sym_conditional] = STATE(8903),
    [sym_range] = STATE(8903),
    [sym_binary] = STATE(8903),
    [sym_unary] = STATE(8903),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [6965] = {
    [sym_string] = STATE(8904),
    [aux_sym_chained_string_repeat1] = STATE(8904),
    [sym__string_start] = ACTIONS(3870),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_RPAREN] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [6966] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(10317),
    [anon_sym_or] = ACTIONS(10317),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [6967] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6968] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6969] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(8905),
    [sym_operator_assignment] = STATE(8905),
    [sym_conditional] = STATE(8905),
    [sym_range] = STATE(8905),
    [sym_binary] = STATE(8905),
    [sym_unary] = STATE(8905),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6970] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6971] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8906),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(8906),
    [sym_operator_assignment] = STATE(8906),
    [sym_conditional] = STATE(8906),
    [sym_range] = STATE(8906),
    [sym_binary] = STATE(8906),
    [sym_unary] = STATE(8906),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6972] = {
    [sym_heredoc_body] = STATE(8907),
    [aux_sym_call_repeat1] = STATE(8907),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6973] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4435),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(4435),
    [sym_operator_assignment] = STATE(4435),
    [sym_conditional] = STATE(4435),
    [sym_range] = STATE(4435),
    [sym_binary] = STATE(4435),
    [sym_unary] = STATE(4435),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4438),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(8908),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7088),
    [sym__splat_star] = ACTIONS(7090),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__identifier_hash_key] = ACTIONS(7092),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12220),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(7096),
    [sym_identifier] = ACTIONS(7096),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6974] = {
    [sym_heredoc_body] = STATE(8909),
    [aux_sym_call_repeat1] = STATE(8909),
    [aux_sym_argument_list_repeat1] = STATE(8910),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10339),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6975] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(10317),
    [anon_sym_or] = ACTIONS(10317),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [6976] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6977] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [6978] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6979] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6980] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6981] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12222),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [6982] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6983] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6984] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6985] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6986] = {
    [sym_heredoc_body] = STATE(6986),
    [aux_sym_call_repeat1] = STATE(6986),
    [sym__heredoc_body_start] = ACTIONS(10413),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7646),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_EQ] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [6987] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2103),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym__argument] = STATE(7107),
    [sym_splat_argument] = STATE(7107),
    [sym_hash_splat_argument] = STATE(7107),
    [sym_block_argument] = STATE(7107),
    [sym_assignment] = STATE(2103),
    [sym_operator_assignment] = STATE(2103),
    [sym_conditional] = STATE(2103),
    [sym_range] = STATE(2103),
    [sym_binary] = STATE(2103),
    [sym_unary] = STATE(2103),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2108),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(7107),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3566),
    [sym__splat_star] = ACTIONS(3568),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__identifier_hash_key] = ACTIONS(3572),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(3574),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3592),
    [sym_identifier] = ACTIONS(3592),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6988] = {
    [sym_heredoc_body] = STATE(6986),
    [aux_sym_call_repeat1] = STATE(6986),
    [sym__heredoc_body_start] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7661),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_EQ] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [6989] = {
    [aux_sym_argument_list_repeat1] = STATE(6989),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7657),
    [anon_sym_COMMA] = ACTIONS(12224),
    [anon_sym_EQ] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [6990] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6991] = {
    [aux_sym_exceptions_repeat1] = STATE(8913),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [6992] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [6993] = {
    [sym_string] = STATE(6993),
    [aux_sym_chained_string_repeat1] = STATE(6993),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [6994] = {
    [sym_heredoc_body] = STATE(8914),
    [aux_sym_call_repeat1] = STATE(8914),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6995] = {
    [sym_heredoc_body] = STATE(8915),
    [aux_sym_call_repeat1] = STATE(8915),
    [aux_sym_argument_list_repeat1] = STATE(4505),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(3660),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [6996] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [6997] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [6998] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [6999] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [7000] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [7001] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12227),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7002] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [7003] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7148),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [7004] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [7005] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [7006] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7148),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [7007] = {
    [aux_sym_exceptions_repeat1] = STATE(8918),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7008] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7148),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [7009] = {
    [sym_string] = STATE(7009),
    [aux_sym_chained_string_repeat1] = STATE(7009),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7010] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [7011] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [7012] = {
    [sym_heredoc_body] = STATE(7012),
    [aux_sym_call_repeat1] = STATE(7012),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7013] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2130),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(2130),
    [sym_operator_assignment] = STATE(2130),
    [sym_conditional] = STATE(2130),
    [sym_range] = STATE(2130),
    [sym_binary] = STATE(2130),
    [sym_unary] = STATE(2130),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2133),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(3616),
    [sym__splat_star] = ACTIONS(3618),
    [sym__unary_minus] = ACTIONS(1303),
    [sym__identifier_hash_key] = ACTIONS(3620),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10343),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(3622),
    [sym_identifier] = ACTIONS(3622),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7014] = {
    [sym_heredoc_body] = STATE(7012),
    [aux_sym_call_repeat1] = STATE(7012),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7015] = {
    [aux_sym_argument_list_repeat1] = STATE(7015),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12229),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [7016] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8919),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_assignment] = STATE(8919),
    [sym_operator_assignment] = STATE(8919),
    [sym_conditional] = STATE(8919),
    [sym_range] = STATE(8919),
    [sym_binary] = STATE(8919),
    [sym_unary] = STATE(8919),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7017] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [7018] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [7019] = {
    [sym_heredoc_body] = STATE(7019),
    [aux_sym_call_repeat1] = STATE(7019),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [7020] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2151),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(2151),
    [sym_operator_assignment] = STATE(2151),
    [sym_conditional] = STATE(2151),
    [sym_range] = STATE(2151),
    [sym_binary] = STATE(2151),
    [sym_unary] = STATE(2151),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2154),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(3652),
    [sym__splat_star] = ACTIONS(3654),
    [sym__unary_minus] = ACTIONS(1377),
    [sym__identifier_hash_key] = ACTIONS(3656),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10347),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(3658),
    [sym_identifier] = ACTIONS(3658),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7021] = {
    [sym_heredoc_body] = STATE(7019),
    [aux_sym_call_repeat1] = STATE(7019),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [7022] = {
    [aux_sym_argument_list_repeat1] = STATE(7022),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12232),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [7023] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4506),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(704),
    [sym_scope_resolution] = STATE(700),
    [sym_call] = STATE(700),
    [sym_method_call] = STATE(704),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(4506),
    [sym_operator_assignment] = STATE(4506),
    [sym_conditional] = STATE(4506),
    [sym_range] = STATE(4506),
    [sym_binary] = STATE(4506),
    [sym_unary] = STATE(4506),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(703),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(704),
    [sym__variable] = STATE(700),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(704),
    [sym_false] = STATE(704),
    [sym_nil] = STATE(704),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2122),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(3618),
    [sym__unary_minus] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1307),
    [anon_sym_yield] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_next] = ACTIONS(1313),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3612),
    [anon_sym_defined_QMARK] = ACTIONS(1315),
    [anon_sym_not] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(1321),
    [sym_constant] = ACTIONS(1327),
    [sym_identifier] = ACTIONS(1327),
    [sym_instance_variable] = ACTIONS(1325),
    [sym_class_variable] = ACTIONS(1325),
    [sym_global_variable] = ACTIONS(1325),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1327),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7024] = {
    [aux_sym_exceptions_repeat1] = STATE(8920),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12235),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7025] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(1345),
    [sym__binary_star] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(1347),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(1355),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1363),
    [anon_sym_AMP_AMP] = ACTIONS(1363),
    [anon_sym_LT_LT] = ACTIONS(1365),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1363),
    [anon_sym_LT_EQ_GT] = ACTIONS(1363),
    [anon_sym_EQ_TILDE] = ACTIONS(1363),
    [anon_sym_BANG_TILDE] = ACTIONS(1363),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [sym_comment] = ACTIONS(87),
  },
  [7026] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [7027] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [7028] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [7029] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [7030] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [7031] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12237),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7032] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [7033] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [7034] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [7035] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [7036] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [7037] = {
    [aux_sym_exceptions_repeat1] = STATE(8923),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [7038] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [7039] = {
    [sym_string] = STATE(7039),
    [aux_sym_chained_string_repeat1] = STATE(7039),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [7040] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8924),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_assignment] = STATE(8924),
    [sym_operator_assignment] = STATE(8924),
    [sym_conditional] = STATE(8924),
    [sym_range] = STATE(8924),
    [sym_binary] = STATE(8924),
    [sym_unary] = STATE(8924),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7041] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(4544),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(743),
    [sym_scope_resolution] = STATE(739),
    [sym_call] = STATE(739),
    [sym_method_call] = STATE(743),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(4544),
    [sym_operator_assignment] = STATE(4544),
    [sym_conditional] = STATE(4544),
    [sym_range] = STATE(4544),
    [sym_binary] = STATE(4544),
    [sym_unary] = STATE(4544),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(742),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(743),
    [sym__variable] = STATE(739),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(743),
    [sym_false] = STATE(743),
    [sym_nil] = STATE(743),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2193),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(3654),
    [sym__unary_minus] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1381),
    [anon_sym_yield] = ACTIONS(1383),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_next] = ACTIONS(1387),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_defined_QMARK] = ACTIONS(1389),
    [anon_sym_not] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_TILDE] = ACTIONS(1395),
    [sym_constant] = ACTIONS(1401),
    [sym_identifier] = ACTIONS(1401),
    [sym_instance_variable] = ACTIONS(1399),
    [sym_class_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1401),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1401),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7042] = {
    [aux_sym_exceptions_repeat1] = STATE(8925),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12239),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [7043] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [7044] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7045] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(7235),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [7046] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [7047] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7233),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(7235),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7253),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [7048] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12241),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7049] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7233),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(7235),
    [anon_sym_LT] = ACTIONS(7237),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7243),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7245),
    [anon_sym_AMP_AMP] = ACTIONS(7245),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(7249),
    [anon_sym_BANG_EQ] = ACTIONS(7245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7245),
    [anon_sym_LT_EQ_GT] = ACTIONS(7245),
    [anon_sym_EQ_TILDE] = ACTIONS(7245),
    [anon_sym_BANG_TILDE] = ACTIONS(7245),
    [anon_sym_LT_EQ] = ACTIONS(7237),
    [anon_sym_GT] = ACTIONS(7237),
    [anon_sym_GT_EQ] = ACTIONS(7251),
    [anon_sym_CARET] = ACTIONS(7253),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [7050] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7233),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(7235),
    [anon_sym_LT] = ACTIONS(7237),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7239),
    [anon_sym_DOT_DOT] = ACTIONS(7241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7243),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7245),
    [anon_sym_AMP_AMP] = ACTIONS(7245),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(7249),
    [anon_sym_BANG_EQ] = ACTIONS(7245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7245),
    [anon_sym_LT_EQ_GT] = ACTIONS(7245),
    [anon_sym_EQ_TILDE] = ACTIONS(7245),
    [anon_sym_BANG_TILDE] = ACTIONS(7245),
    [anon_sym_LT_EQ] = ACTIONS(7237),
    [anon_sym_GT] = ACTIONS(7237),
    [anon_sym_GT_EQ] = ACTIONS(7251),
    [anon_sym_CARET] = ACTIONS(7253),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [7051] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7233),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(7235),
    [anon_sym_LT] = ACTIONS(7237),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(7249),
    [anon_sym_BANG_EQ] = ACTIONS(7245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7245),
    [anon_sym_LT_EQ_GT] = ACTIONS(7245),
    [anon_sym_EQ_TILDE] = ACTIONS(7245),
    [anon_sym_BANG_TILDE] = ACTIONS(7245),
    [anon_sym_LT_EQ] = ACTIONS(7237),
    [anon_sym_GT] = ACTIONS(7237),
    [anon_sym_GT_EQ] = ACTIONS(7251),
    [anon_sym_CARET] = ACTIONS(7253),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [7052] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [7053] = {
    [aux_sym_exceptions_repeat1] = STATE(7053),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(12243),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [7054] = {
    [aux_sym_exceptions_repeat1] = STATE(4562),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7055] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7233),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(7235),
    [anon_sym_LT] = ACTIONS(7237),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7239),
    [anon_sym_DOT_DOT] = ACTIONS(7241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7243),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7245),
    [anon_sym_AMP_AMP] = ACTIONS(7245),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(7249),
    [anon_sym_BANG_EQ] = ACTIONS(7245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7245),
    [anon_sym_LT_EQ_GT] = ACTIONS(7245),
    [anon_sym_EQ_TILDE] = ACTIONS(7245),
    [anon_sym_BANG_TILDE] = ACTIONS(7245),
    [anon_sym_LT_EQ] = ACTIONS(7237),
    [anon_sym_GT] = ACTIONS(7237),
    [anon_sym_GT_EQ] = ACTIONS(7251),
    [anon_sym_CARET] = ACTIONS(7253),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [7056] = {
    [anon_sym_DOT] = ACTIONS(9793),
    [anon_sym_LBRACK] = ACTIONS(9793),
    [anon_sym_COLON_COLON2] = ACTIONS(9793),
    [anon_sym_AMP_DOT] = ACTIONS(9793),
    [sym_comment] = ACTIONS(87),
  },
  [7057] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12246),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7058] = {
    [anon_sym_DOT] = ACTIONS(9799),
    [anon_sym_LBRACK] = ACTIONS(9799),
    [anon_sym_COLON_COLON2] = ACTIONS(9799),
    [anon_sym_AMP_DOT] = ACTIONS(9799),
    [sym_comment] = ACTIONS(87),
  },
  [7059] = {
    [anon_sym_DOT] = ACTIONS(9803),
    [anon_sym_LBRACK] = ACTIONS(9803),
    [anon_sym_COLON_COLON2] = ACTIONS(9803),
    [anon_sym_AMP_DOT] = ACTIONS(9803),
    [sym_comment] = ACTIONS(87),
  },
  [7060] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12248),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7061] = {
    [anon_sym_DOT] = ACTIONS(9809),
    [anon_sym_LBRACK] = ACTIONS(9809),
    [anon_sym_COLON_COLON2] = ACTIONS(9809),
    [anon_sym_AMP_DOT] = ACTIONS(9809),
    [sym_comment] = ACTIONS(87),
  },
  [7062] = {
    [sym__method_rest] = STATE(8929),
    [sym_operator] = STATE(770),
    [sym__method_name] = STATE(770),
    [sym_setter] = STATE(770),
    [sym_symbol] = STATE(770),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(7287),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(7287),
    [sym_class_variable] = ACTIONS(7287),
    [sym_global_variable] = ACTIONS(7287),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [7063] = {
    [anon_sym_DOT] = ACTIONS(10532),
    [anon_sym_LBRACK] = ACTIONS(10532),
    [anon_sym_COLON_COLON2] = ACTIONS(10532),
    [anon_sym_AMP_DOT] = ACTIONS(10532),
    [sym_comment] = ACTIONS(87),
  },
  [7064] = {
    [anon_sym_DOT] = ACTIONS(10536),
    [anon_sym_LBRACK] = ACTIONS(10536),
    [anon_sym_COLON_COLON2] = ACTIONS(10536),
    [anon_sym_AMP_DOT] = ACTIONS(10536),
    [sym_comment] = ACTIONS(87),
  },
  [7065] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7066] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7067] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8930),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(8930),
    [sym_operator_assignment] = STATE(8930),
    [sym_conditional] = STATE(8930),
    [sym_range] = STATE(8930),
    [sym_binary] = STATE(8930),
    [sym_unary] = STATE(8930),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7068] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7069] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8931),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(8931),
    [sym_operator_assignment] = STATE(8931),
    [sym_conditional] = STATE(8931),
    [sym_range] = STATE(8931),
    [sym_binary] = STATE(8931),
    [sym_unary] = STATE(8931),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7070] = {
    [sym_heredoc_body] = STATE(8932),
    [aux_sym_call_repeat1] = STATE(8932),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7071] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4591),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(4591),
    [sym_operator_assignment] = STATE(4591),
    [sym_conditional] = STATE(4591),
    [sym_range] = STATE(4591),
    [sym_binary] = STATE(4591),
    [sym_unary] = STATE(4591),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4594),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(8933),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7299),
    [sym__splat_star] = ACTIONS(7301),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(7303),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12250),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7305),
    [sym_identifier] = ACTIONS(7305),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7072] = {
    [sym_heredoc_body] = STATE(8934),
    [aux_sym_call_repeat1] = STATE(8934),
    [aux_sym_argument_list_repeat1] = STATE(8935),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10379),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7073] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7074] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7075] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7076] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7077] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7078] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12252),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7079] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7080] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7081] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7082] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7083] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8937),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(8937),
    [sym_operator_assignment] = STATE(8937),
    [sym_conditional] = STATE(8937),
    [sym_range] = STATE(8937),
    [sym_binary] = STATE(8937),
    [sym_unary] = STATE(8937),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [7084] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4611),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(6452),
    [sym__argument_list_with_parens] = STATE(4612),
    [sym__argument] = STATE(4613),
    [sym_splat_argument] = STATE(4613),
    [sym_hash_splat_argument] = STATE(4613),
    [sym_block_argument] = STATE(4613),
    [sym_assignment] = STATE(4611),
    [sym_operator_assignment] = STATE(4611),
    [sym_conditional] = STATE(4611),
    [sym_range] = STATE(4611),
    [sym_binary] = STATE(4611),
    [sym_unary] = STATE(4611),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4614),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4613),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7335),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7339),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7341),
    [sym_identifier] = ACTIONS(7341),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7085] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4611),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(6453),
    [sym__argument_list_with_parens] = STATE(4612),
    [sym__argument] = STATE(4613),
    [sym_splat_argument] = STATE(4613),
    [sym_hash_splat_argument] = STATE(4613),
    [sym_block_argument] = STATE(4613),
    [sym_assignment] = STATE(4611),
    [sym_operator_assignment] = STATE(4611),
    [sym_conditional] = STATE(4611),
    [sym_range] = STATE(4611),
    [sym_binary] = STATE(4611),
    [sym_unary] = STATE(4611),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4614),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4613),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7335),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7339),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7341),
    [sym_identifier] = ACTIONS(7341),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7086] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4611),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(6454),
    [sym__argument_list_with_parens] = STATE(4612),
    [sym__argument] = STATE(4613),
    [sym_splat_argument] = STATE(4613),
    [sym_hash_splat_argument] = STATE(4613),
    [sym_block_argument] = STATE(4613),
    [sym_assignment] = STATE(4611),
    [sym_operator_assignment] = STATE(4611),
    [sym_conditional] = STATE(4611),
    [sym_range] = STATE(4611),
    [sym_binary] = STATE(4611),
    [sym_unary] = STATE(4611),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4614),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4613),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7335),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7339),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7341),
    [sym_identifier] = ACTIONS(7341),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7087] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4611),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym_argument_list] = STATE(6455),
    [sym__argument_list_with_parens] = STATE(4612),
    [sym__argument] = STATE(4613),
    [sym_splat_argument] = STATE(4613),
    [sym_hash_splat_argument] = STATE(4613),
    [sym_block_argument] = STATE(4613),
    [sym_assignment] = STATE(4611),
    [sym_operator_assignment] = STATE(4611),
    [sym_conditional] = STATE(4611),
    [sym_range] = STATE(4611),
    [sym_binary] = STATE(4611),
    [sym_unary] = STATE(4611),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4614),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4613),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7335),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7339),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1205),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7341),
    [sym_identifier] = ACTIONS(7341),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7088] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8938),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(8938),
    [sym_operator_assignment] = STATE(8938),
    [sym_conditional] = STATE(8938),
    [sym_range] = STATE(8938),
    [sym_binary] = STATE(8938),
    [sym_unary] = STATE(8938),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [7089] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6470),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(6470),
    [sym_operator_assignment] = STATE(6470),
    [sym_conditional] = STATE(6470),
    [sym_range] = STATE(6470),
    [sym_binary] = STATE(6470),
    [sym_unary] = STATE(6470),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [7090] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [7091] = {
    [anon_sym_EQ] = ACTIONS(12282),
    [sym_comment] = ACTIONS(87),
  },
  [7092] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12284),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12286),
    [anon_sym_DASH_EQ] = ACTIONS(12286),
    [anon_sym_STAR_EQ] = ACTIONS(12286),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12286),
    [anon_sym_SLASH_EQ] = ACTIONS(12286),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12286),
    [anon_sym_PIPE_EQ] = ACTIONS(12286),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12286),
    [anon_sym_AMP_EQ] = ACTIONS(12286),
    [anon_sym_PERCENT_EQ] = ACTIONS(12286),
    [anon_sym_GT_GT_EQ] = ACTIONS(12286),
    [anon_sym_LT_LT_EQ] = ACTIONS(12286),
    [anon_sym_CARET_EQ] = ACTIONS(12286),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7093] = {
    [sym_string] = STATE(8951),
    [aux_sym_chained_string_repeat1] = STATE(8951),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7094] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [7095] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8952),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(8952),
    [sym_operator_assignment] = STATE(8952),
    [sym_conditional] = STATE(8952),
    [sym_range] = STATE(8952),
    [sym_binary] = STATE(8952),
    [sym_unary] = STATE(8952),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [7096] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [7097] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8953),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(8953),
    [sym_operator_assignment] = STATE(8953),
    [sym_conditional] = STATE(8953),
    [sym_range] = STATE(8953),
    [sym_binary] = STATE(8953),
    [sym_unary] = STATE(8953),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [7098] = {
    [sym_heredoc_body] = STATE(8954),
    [aux_sym_call_repeat1] = STATE(8954),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [7099] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4611),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym__argument] = STATE(6514),
    [sym_splat_argument] = STATE(6514),
    [sym_hash_splat_argument] = STATE(6514),
    [sym_block_argument] = STATE(6514),
    [sym_assignment] = STATE(4611),
    [sym_operator_assignment] = STATE(4611),
    [sym_conditional] = STATE(4611),
    [sym_range] = STATE(4611),
    [sym_binary] = STATE(4611),
    [sym_unary] = STATE(4611),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4614),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(8955),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6514),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7335),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__identifier_hash_key] = ACTIONS(7339),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12288),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7341),
    [sym_identifier] = ACTIONS(7341),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7100] = {
    [sym_heredoc_body] = STATE(8956),
    [aux_sym_call_repeat1] = STATE(8956),
    [aux_sym_argument_list_repeat1] = STATE(8957),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10405),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [7101] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7102] = {
    [aux_sym_exceptions_repeat1] = STATE(8959),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7103] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [7104] = {
    [sym_string] = STATE(7104),
    [aux_sym_chained_string_repeat1] = STATE(7104),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7105] = {
    [sym__heredoc_body_start] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10568),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_EQ] = ACTIONS(10568),
    [anon_sym_in] = ACTIONS(10568),
    [anon_sym_do] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [7106] = {
    [sym__heredoc_body_start] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_DOT] = ACTIONS(6547),
    [anon_sym_COMMA] = ACTIONS(6547),
    [anon_sym_EQ] = ACTIONS(6547),
    [anon_sym_in] = ACTIONS(6547),
    [anon_sym_do] = ACTIONS(6547),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_COLON_COLON2] = ACTIONS(6547),
    [anon_sym_AMP_DOT] = ACTIONS(6547),
    [sym_comment] = ACTIONS(87),
  },
  [7107] = {
    [sym__heredoc_body_start] = ACTIONS(10596),
    [anon_sym_LBRACE] = ACTIONS(10596),
    [anon_sym_RPAREN] = ACTIONS(10596),
    [anon_sym_DOT] = ACTIONS(10596),
    [anon_sym_COMMA] = ACTIONS(10596),
    [anon_sym_EQ] = ACTIONS(10596),
    [anon_sym_in] = ACTIONS(10596),
    [anon_sym_do] = ACTIONS(10596),
    [anon_sym_LBRACK] = ACTIONS(10596),
    [anon_sym_COLON_COLON2] = ACTIONS(10596),
    [anon_sym_AMP_DOT] = ACTIONS(10596),
    [sym_comment] = ACTIONS(87),
  },
  [7108] = {
    [anon_sym_DOT] = ACTIONS(10689),
    [anon_sym_LBRACK] = ACTIONS(10689),
    [anon_sym_COLON_COLON2] = ACTIONS(10689),
    [anon_sym_AMP_DOT] = ACTIONS(10689),
    [sym_comment] = ACTIONS(87),
  },
  [7109] = {
    [anon_sym_end] = ACTIONS(12290),
    [sym_comment] = ACTIONS(87),
  },
  [7110] = {
    [sym_elsif] = STATE(8961),
    [sym_else] = STATE(8961),
    [sym__if_tail] = STATE(8961),
    [anon_sym_end] = ACTIONS(12290),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [7111] = {
    [anon_sym_DOT] = ACTIONS(10856),
    [anon_sym_LBRACK] = ACTIONS(10856),
    [anon_sym_COLON_COLON2] = ACTIONS(10856),
    [anon_sym_AMP_DOT] = ACTIONS(10856),
    [sym_comment] = ACTIONS(87),
  },
  [7112] = {
    [anon_sym_end] = ACTIONS(12292),
    [sym_comment] = ACTIONS(87),
  },
  [7113] = {
    [anon_sym_DOT] = ACTIONS(10951),
    [anon_sym_LBRACK] = ACTIONS(10951),
    [anon_sym_COLON_COLON2] = ACTIONS(10951),
    [anon_sym_AMP_DOT] = ACTIONS(10951),
    [sym_comment] = ACTIONS(87),
  },
  [7114] = {
    [anon_sym_DOT] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10960),
    [anon_sym_COLON_COLON2] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10960),
    [sym_comment] = ACTIONS(87),
  },
  [7115] = {
    [anon_sym_DOT] = ACTIONS(11007),
    [anon_sym_LBRACK] = ACTIONS(11007),
    [anon_sym_COLON_COLON2] = ACTIONS(11007),
    [anon_sym_AMP_DOT] = ACTIONS(11007),
    [sym_comment] = ACTIONS(87),
  },
  [7116] = {
    [anon_sym_end] = ACTIONS(12294),
    [sym_comment] = ACTIONS(87),
  },
  [7117] = {
    [anon_sym_DOT] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_COLON_COLON2] = ACTIONS(11020),
    [anon_sym_AMP_DOT] = ACTIONS(11020),
    [sym_comment] = ACTIONS(87),
  },
  [7118] = {
    [anon_sym_end] = ACTIONS(12296),
    [sym_comment] = ACTIONS(87),
  },
  [7119] = {
    [anon_sym_DOT] = ACTIONS(11466),
    [anon_sym_LBRACK] = ACTIONS(11466),
    [anon_sym_COLON_COLON2] = ACTIONS(11466),
    [anon_sym_AMP_DOT] = ACTIONS(11466),
    [sym_comment] = ACTIONS(87),
  },
  [7120] = {
    [anon_sym_end] = ACTIONS(12298),
    [sym_comment] = ACTIONS(87),
  },
  [7121] = {
    [anon_sym_LBRACE] = ACTIONS(11655),
    [anon_sym_RPAREN] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11655),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11655),
    [anon_sym_SEMI] = ACTIONS(11655),
    [anon_sym_EQ] = ACTIONS(11655),
    [anon_sym_in] = ACTIONS(11655),
    [anon_sym_do] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [sym_comment] = ACTIONS(87),
  },
  [7122] = {
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11680),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11680),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_EQ] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11680),
    [anon_sym_do] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [sym_comment] = ACTIONS(87),
  },
  [7123] = {
    [anon_sym_end] = ACTIONS(12300),
    [sym_comment] = ACTIONS(87),
  },
  [7124] = {
    [sym__statements] = STATE(8967),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12302),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7125] = {
    [sym__simple_symbol] = ACTIONS(7608),
    [sym__string_start] = ACTIONS(7608),
    [sym__symbol_start] = ACTIONS(7608),
    [sym__subshell_start] = ACTIONS(7608),
    [sym__regex_start] = ACTIONS(7608),
    [sym__string_array_start] = ACTIONS(7608),
    [sym__symbol_array_start] = ACTIONS(7608),
    [sym_heredoc_beginning] = ACTIONS(7608),
    [sym__block_ampersand] = ACTIONS(7608),
    [sym__splat_star] = ACTIONS(7608),
    [sym__unary_minus] = ACTIONS(7608),
    [sym__identifier_hash_key] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_def] = ACTIONS(7610),
    [anon_sym_LPAREN] = ACTIONS(7610),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7608),
    [anon_sym_COLON_COLON] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_STAR] = ACTIONS(7610),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_EQ] = ACTIONS(7608),
    [anon_sym_class] = ACTIONS(7610),
    [anon_sym_module] = ACTIONS(7610),
    [anon_sym_return] = ACTIONS(7610),
    [anon_sym_yield] = ACTIONS(7610),
    [anon_sym_break] = ACTIONS(7610),
    [anon_sym_next] = ACTIONS(7610),
    [sym_redo] = ACTIONS(7610),
    [sym_retry] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7610),
    [anon_sym_unless] = ACTIONS(7610),
    [anon_sym_while] = ACTIONS(7610),
    [anon_sym_until] = ACTIONS(7610),
    [anon_sym_for] = ACTIONS(7610),
    [anon_sym_in] = ACTIONS(7610),
    [anon_sym_do] = ACTIONS(7610),
    [anon_sym_case] = ACTIONS(7610),
    [anon_sym_begin] = ACTIONS(7610),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_LPAREN2] = ACTIONS(7608),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_defined_QMARK] = ACTIONS(7608),
    [anon_sym_not] = ACTIONS(7610),
    [anon_sym_BANG] = ACTIONS(7608),
    [anon_sym_TILDE] = ACTIONS(7608),
    [sym_constant] = ACTIONS(7610),
    [sym_identifier] = ACTIONS(7610),
    [sym_instance_variable] = ACTIONS(7608),
    [sym_class_variable] = ACTIONS(7608),
    [sym_global_variable] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7610),
    [sym_float] = ACTIONS(7610),
    [sym_complex] = ACTIONS(7608),
    [sym_super] = ACTIONS(7610),
    [anon_sym_true] = ACTIONS(7610),
    [anon_sym_TRUE] = ACTIONS(7610),
    [anon_sym_false] = ACTIONS(7610),
    [anon_sym_FALSE] = ACTIONS(7610),
    [sym_self] = ACTIONS(7610),
    [anon_sym_nil] = ACTIONS(7610),
    [anon_sym_NIL] = ACTIONS(7610),
    [sym_character] = ACTIONS(7608),
    [anon_sym_LBRACK2] = ACTIONS(7610),
    [anon_sym_DASH_GT] = ACTIONS(7608),
  },
  [7126] = {
    [anon_sym_RPAREN] = ACTIONS(12304),
    [sym_comment] = ACTIONS(87),
  },
  [7127] = {
    [anon_sym_RPAREN] = ACTIONS(11825),
    [anon_sym_DOT] = ACTIONS(11825),
    [anon_sym_COMMA] = ACTIONS(11825),
    [anon_sym_EQ] = ACTIONS(11825),
    [anon_sym_in] = ACTIONS(11825),
    [anon_sym_LBRACK] = ACTIONS(11825),
    [anon_sym_COLON_COLON2] = ACTIONS(11825),
    [anon_sym_AMP_DOT] = ACTIONS(11825),
    [sym_comment] = ACTIONS(87),
  },
  [7128] = {
    [sym__string_start] = ACTIONS(2895),
    [sym__heredoc_body_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_STAR_STAR] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON2] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_LT_LT] = ACTIONS(2895),
    [anon_sym_GT_GT] = ACTIONS(2895),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(87),
  },
  [7129] = {
    [sym__heredoc_body_start] = ACTIONS(2907),
    [sym__binary_minus] = ACTIONS(2907),
    [sym__binary_star] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_STAR_STAR] = ACTIONS(2907),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_COLON_COLON2] = ACTIONS(2907),
    [anon_sym_AMP_DOT] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_and] = ACTIONS(2907),
    [anon_sym_or] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE] = ACTIONS(2907),
    [anon_sym_AMP_AMP] = ACTIONS(2907),
    [anon_sym_LT_LT] = ACTIONS(2907),
    [anon_sym_GT_GT] = ACTIONS(2907),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_CARET] = ACTIONS(2907),
    [anon_sym_PLUS] = ACTIONS(2907),
    [anon_sym_SLASH] = ACTIONS(2907),
    [anon_sym_PERCENT] = ACTIONS(2907),
    [sym_comment] = ACTIONS(87),
  },
  [7130] = {
    [sym__heredoc_body_start] = ACTIONS(2911),
    [sym__binary_minus] = ACTIONS(2911),
    [sym__binary_star] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RPAREN] = ACTIONS(2911),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_STAR_STAR] = ACTIONS(2911),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_COLON_COLON2] = ACTIONS(2911),
    [anon_sym_AMP_DOT] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE] = ACTIONS(2911),
    [anon_sym_AMP_AMP] = ACTIONS(2911),
    [anon_sym_LT_LT] = ACTIONS(2911),
    [anon_sym_GT_GT] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_CARET] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_SLASH] = ACTIONS(2911),
    [anon_sym_PERCENT] = ACTIONS(2911),
    [sym_comment] = ACTIONS(87),
  },
  [7131] = {
    [sym__heredoc_body_start] = ACTIONS(2915),
    [sym__binary_minus] = ACTIONS(2915),
    [sym__binary_star] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_STAR_STAR] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_COLON_COLON2] = ACTIONS(2915),
    [anon_sym_AMP_DOT] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2915),
    [anon_sym_AMP_AMP] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2915),
    [anon_sym_EQ_TILDE] = ACTIONS(2915),
    [anon_sym_BANG_TILDE] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [sym_comment] = ACTIONS(87),
  },
  [7132] = {
    [sym__heredoc_body_start] = ACTIONS(2921),
    [sym__binary_minus] = ACTIONS(2921),
    [sym__binary_star] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_STAR_STAR] = ACTIONS(2921),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_COLON_COLON2] = ACTIONS(2921),
    [anon_sym_AMP_DOT] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_and] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_LT_LT] = ACTIONS(2921),
    [anon_sym_GT_GT] = ACTIONS(2921),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2921),
    [anon_sym_PERCENT] = ACTIONS(2921),
    [sym_comment] = ACTIONS(87),
  },
  [7133] = {
    [sym__string_end] = ACTIONS(12306),
    [sym_comment] = ACTIONS(87),
  },
  [7134] = {
    [aux_sym_string_array_repeat1] = STATE(8972),
    [sym__string_end] = ACTIONS(12308),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12310),
  },
  [7135] = {
    [sym__heredoc_body_start] = ACTIONS(2931),
    [sym__binary_minus] = ACTIONS(2931),
    [sym__binary_star] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_STAR_STAR] = ACTIONS(2931),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_COLON_COLON2] = ACTIONS(2931),
    [anon_sym_AMP_DOT] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2931),
    [anon_sym_DOT_DOT] = ACTIONS(2933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2931),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2931),
    [anon_sym_LT_LT] = ACTIONS(2931),
    [anon_sym_GT_GT] = ACTIONS(2931),
    [anon_sym_EQ_EQ] = ACTIONS(2933),
    [anon_sym_BANG_EQ] = ACTIONS(2931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2931),
    [anon_sym_EQ_TILDE] = ACTIONS(2931),
    [anon_sym_BANG_TILDE] = ACTIONS(2931),
    [anon_sym_LT_EQ] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_GT_EQ] = ACTIONS(2931),
    [anon_sym_CARET] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_SLASH] = ACTIONS(2931),
    [anon_sym_PERCENT] = ACTIONS(2931),
    [sym_comment] = ACTIONS(87),
  },
  [7136] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12312),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7137] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(12312),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12314),
  },
  [7138] = {
    [sym__heredoc_body_start] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym__binary_star] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_STAR_STAR] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_COLON_COLON2] = ACTIONS(2950),
    [anon_sym_AMP_DOT] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2950),
    [anon_sym_AMP_AMP] = ACTIONS(2950),
    [anon_sym_LT_LT] = ACTIONS(2950),
    [anon_sym_GT_GT] = ACTIONS(2950),
    [anon_sym_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ_GT] = ACTIONS(2950),
    [anon_sym_EQ_TILDE] = ACTIONS(2950),
    [anon_sym_BANG_TILDE] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2950),
    [anon_sym_PERCENT] = ACTIONS(2950),
    [sym_comment] = ACTIONS(87),
  },
  [7139] = {
    [sym__string_end] = ACTIONS(12316),
    [sym_comment] = ACTIONS(87),
  },
  [7140] = {
    [aux_sym_symbol_array_repeat1] = STATE(8978),
    [sym__string_end] = ACTIONS(12318),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12320),
  },
  [7141] = {
    [sym__heredoc_body_start] = ACTIONS(2960),
    [sym__binary_minus] = ACTIONS(2960),
    [sym__binary_star] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RPAREN] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_STAR_STAR] = ACTIONS(2960),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_COLON_COLON2] = ACTIONS(2960),
    [anon_sym_AMP_DOT] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2960),
    [anon_sym_DOT_DOT] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE] = ACTIONS(2960),
    [anon_sym_AMP_AMP] = ACTIONS(2960),
    [anon_sym_LT_LT] = ACTIONS(2960),
    [anon_sym_GT_GT] = ACTIONS(2960),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2960),
    [anon_sym_LT_EQ_GT] = ACTIONS(2960),
    [anon_sym_EQ_TILDE] = ACTIONS(2960),
    [anon_sym_BANG_TILDE] = ACTIONS(2960),
    [anon_sym_LT_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_SLASH] = ACTIONS(2960),
    [anon_sym_PERCENT] = ACTIONS(2960),
    [sym_comment] = ACTIONS(87),
  },
  [7142] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(12322),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7143] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(12322),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12324),
  },
  [7144] = {
    [sym__heredoc_body_start] = ACTIONS(3440),
    [sym__binary_minus] = ACTIONS(3440),
    [sym__binary_star] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_do] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3440),
    [anon_sym_COLON_COLON2] = ACTIONS(3440),
    [anon_sym_AMP_DOT] = ACTIONS(3440),
    [anon_sym_QMARK] = ACTIONS(3440),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3440),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3440),
    [anon_sym_AMP_AMP] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_GT_GT] = ACTIONS(3440),
    [anon_sym_EQ_EQ] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3440),
    [anon_sym_BANG_TILDE] = ACTIONS(3440),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3440),
    [anon_sym_CARET] = ACTIONS(3440),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [sym_comment] = ACTIONS(87),
  },
  [7145] = {
    [anon_sym_RBRACE] = ACTIONS(12326),
    [sym_comment] = ACTIONS(87),
  },
  [7146] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(12328),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [7147] = {
    [sym__method_rest] = STATE(8983),
    [sym_operator] = STATE(4681),
    [sym__method_name] = STATE(4681),
    [sym_setter] = STATE(4681),
    [sym_symbol] = STATE(4681),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12330),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12330),
    [sym_class_variable] = ACTIONS(12330),
    [sym_global_variable] = ACTIONS(12330),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [7148] = {
    [sym__statements] = STATE(4710),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(4711),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(4712),
    [sym_rescue] = STATE(4713),
    [sym__body_statement] = STATE(8984),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12332),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7149] = {
    [sym__heredoc_body_start] = ACTIONS(3670),
    [sym__binary_minus] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_LBRACE] = ACTIONS(3670),
    [anon_sym_RPAREN] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_STAR_STAR] = ACTIONS(3670),
    [anon_sym_AMP] = ACTIONS(3672),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3672),
    [anon_sym_do] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3670),
    [anon_sym_COLON_COLON2] = ACTIONS(3670),
    [anon_sym_AMP_DOT] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3670),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE] = ACTIONS(3670),
    [anon_sym_AMP_AMP] = ACTIONS(3670),
    [anon_sym_LT_LT] = ACTIONS(3670),
    [anon_sym_GT_GT] = ACTIONS(3670),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LT_EQ_GT] = ACTIONS(3670),
    [anon_sym_EQ_TILDE] = ACTIONS(3670),
    [anon_sym_BANG_TILDE] = ACTIONS(3670),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3670),
    [anon_sym_PLUS] = ACTIONS(3670),
    [anon_sym_SLASH] = ACTIONS(3670),
    [anon_sym_PERCENT] = ACTIONS(3670),
    [sym_comment] = ACTIONS(87),
  },
  [7150] = {
    [sym_heredoc_body] = STATE(8985),
    [sym__terminator] = STATE(8985),
    [sym__line_break] = ACTIONS(12334),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(12334),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [7151] = {
    [sym_heredoc_body] = STATE(8986),
    [sym__terminator] = STATE(8986),
    [sym__line_break] = ACTIONS(12336),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(12336),
    [sym_comment] = ACTIONS(87),
  },
  [7152] = {
    [sym__statements] = STATE(4710),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(4711),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(4712),
    [sym_rescue] = STATE(4713),
    [sym__body_statement] = STATE(8987),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12338),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7153] = {
    [sym__heredoc_body_start] = ACTIONS(4068),
    [sym__binary_minus] = ACTIONS(4068),
    [sym__binary_star] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_STAR_STAR] = ACTIONS(4068),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_COLON_COLON2] = ACTIONS(4068),
    [anon_sym_AMP_DOT] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4068),
    [anon_sym_DOT_DOT] = ACTIONS(4070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4068),
    [anon_sym_AMP_AMP] = ACTIONS(4068),
    [anon_sym_LT_LT] = ACTIONS(4068),
    [anon_sym_GT_GT] = ACTIONS(4068),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ_GT] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_BANG_TILDE] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4068),
    [anon_sym_PERCENT] = ACTIONS(4068),
    [sym_comment] = ACTIONS(87),
  },
  [7154] = {
    [sym__statements] = STATE(4710),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(4711),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(4712),
    [sym_rescue] = STATE(4713),
    [sym__body_statement] = STATE(8988),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12340),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7155] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7156] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7157] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8989),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(8989),
    [sym_operator_assignment] = STATE(8989),
    [sym_conditional] = STATE(8989),
    [sym_range] = STATE(8989),
    [sym_binary] = STATE(8989),
    [sym_unary] = STATE(8989),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [7158] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7159] = {
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym__binary_minus] = ACTIONS(4148),
    [sym__binary_star] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_STAR_STAR] = ACTIONS(4148),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_EQ] = ACTIONS(4150),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_do] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_DOT_DOT] = ACTIONS(4150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4148),
    [anon_sym_and] = ACTIONS(4148),
    [anon_sym_or] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_LT_EQ_GT] = ACTIONS(4148),
    [anon_sym_EQ_TILDE] = ACTIONS(4148),
    [anon_sym_BANG_TILDE] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4148),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
  },
  [7160] = {
    [sym_heredoc_body] = STATE(8991),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(12342),
    [sym_comment] = ACTIONS(87),
  },
  [7161] = {
    [anon_sym_RPAREN] = ACTIONS(12342),
    [sym_comment] = ACTIONS(87),
  },
  [7162] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8992),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(8992),
    [sym_operator_assignment] = STATE(8992),
    [sym_conditional] = STATE(8992),
    [sym_range] = STATE(8992),
    [sym_binary] = STATE(8992),
    [sym_unary] = STATE(8992),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [7163] = {
    [sym_interpolation] = STATE(8994),
    [aux_sym_heredoc_body_repeat1] = STATE(8994),
    [sym__heredoc_content] = ACTIONS(12344),
    [sym_heredoc_end] = ACTIONS(12346),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(12344),
  },
  [7164] = {
    [sym_heredoc_body] = STATE(8995),
    [aux_sym_call_repeat1] = STATE(8995),
    [sym__heredoc_body_start] = ACTIONS(10491),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7165] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4695),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym__argument] = STATE(8996),
    [sym_splat_argument] = STATE(8996),
    [sym_hash_splat_argument] = STATE(8996),
    [sym_block_argument] = STATE(8996),
    [sym_assignment] = STATE(4695),
    [sym_operator_assignment] = STATE(4695),
    [sym_conditional] = STATE(4695),
    [sym_range] = STATE(4695),
    [sym_binary] = STATE(4695),
    [sym_unary] = STATE(4695),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4699),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(8997),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(8996),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7419),
    [sym__splat_star] = ACTIONS(7421),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__identifier_hash_key] = ACTIONS(7423),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12348),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(7427),
    [sym_identifier] = ACTIONS(7427),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7166] = {
    [sym_heredoc_body] = STATE(8998),
    [aux_sym_call_repeat1] = STATE(8998),
    [aux_sym_argument_list_repeat1] = STATE(8999),
    [sym__heredoc_body_start] = ACTIONS(10491),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10493),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7167] = {
    [sym__statements] = STATE(9001),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(9002),
    [sym_else] = STATE(9002),
    [sym__if_tail] = STATE(9002),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(9003),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__terminator] = STATE(9003),
    [sym__line_break] = ACTIONS(12350),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12352),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7168] = {
    [sym__statements] = STATE(9005),
    [sym__top_level_statement] = STATE(2704),
    [sym_begin_block] = STATE(2704),
    [sym_end_block] = STATE(2704),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(9006),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12354),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7169] = {
    [sym__statements] = STATE(9008),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12356),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7170] = {
    [sym__statements] = STATE(9010),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12358),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7171] = {
    [sym__do] = STATE(9011),
    [sym_heredoc_body] = STATE(9011),
    [sym__terminator] = STATE(9011),
    [sym__line_break] = ACTIONS(12360),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(12360),
    [anon_sym_do] = ACTIONS(12360),
    [sym_comment] = ACTIONS(87),
  },
  [7172] = {
    [sym_when] = STATE(9012),
    [aux_sym_case_repeat1] = STATE(9013),
    [anon_sym_SEMI] = ACTIONS(12362),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [7173] = {
    [anon_sym_end] = ACTIONS(12364),
    [sym_comment] = ACTIONS(87),
  },
  [7174] = {
    [sym_when] = STATE(9012),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [7175] = {
    [sym__heredoc_body_start] = ACTIONS(5264),
    [sym__binary_minus] = ACTIONS(5264),
    [sym__binary_star] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5264),
    [anon_sym_RPAREN] = ACTIONS(5264),
    [anon_sym_DOT] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5264),
    [anon_sym_PIPE] = ACTIONS(5266),
    [anon_sym_STAR_STAR] = ACTIONS(5264),
    [anon_sym_AMP] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5266),
    [anon_sym_do] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5264),
    [anon_sym_COLON_COLON2] = ACTIONS(5264),
    [anon_sym_AMP_DOT] = ACTIONS(5264),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5264),
    [anon_sym_and] = ACTIONS(5264),
    [anon_sym_or] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE] = ACTIONS(5264),
    [anon_sym_AMP_AMP] = ACTIONS(5264),
    [anon_sym_LT_LT] = ACTIONS(5264),
    [anon_sym_GT_GT] = ACTIONS(5264),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5264),
    [anon_sym_LT_EQ_GT] = ACTIONS(5264),
    [anon_sym_EQ_TILDE] = ACTIONS(5264),
    [anon_sym_BANG_TILDE] = ACTIONS(5264),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_GT] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5264),
    [anon_sym_CARET] = ACTIONS(5264),
    [anon_sym_PLUS] = ACTIONS(5264),
    [anon_sym_SLASH] = ACTIONS(5264),
    [anon_sym_PERCENT] = ACTIONS(5264),
    [sym_comment] = ACTIONS(87),
  },
  [7176] = {
    [sym_ensure] = STATE(9016),
    [anon_sym_end] = ACTIONS(12366),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [7177] = {
    [anon_sym_end] = ACTIONS(12366),
    [sym_comment] = ACTIONS(87),
  },
  [7178] = {
    [sym_else] = STATE(9017),
    [sym_ensure] = STATE(9016),
    [anon_sym_end] = ACTIONS(12366),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [7179] = {
    [sym__heredoc_body_start] = ACTIONS(5350),
    [sym__binary_minus] = ACTIONS(5350),
    [sym__binary_star] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_RPAREN] = ACTIONS(5350),
    [anon_sym_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5350),
    [anon_sym_PIPE] = ACTIONS(5352),
    [anon_sym_STAR_STAR] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5352),
    [anon_sym_EQ] = ACTIONS(5352),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_COLON_COLON2] = ACTIONS(5350),
    [anon_sym_AMP_DOT] = ACTIONS(5350),
    [anon_sym_QMARK] = ACTIONS(5350),
    [anon_sym_DOT_DOT] = ACTIONS(5352),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5350),
    [anon_sym_AMP_AMP] = ACTIONS(5350),
    [anon_sym_LT_LT] = ACTIONS(5350),
    [anon_sym_GT_GT] = ACTIONS(5350),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5350),
    [anon_sym_LT_EQ_GT] = ACTIONS(5350),
    [anon_sym_EQ_TILDE] = ACTIONS(5350),
    [anon_sym_BANG_TILDE] = ACTIONS(5350),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5350),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_SLASH] = ACTIONS(5350),
    [anon_sym_PERCENT] = ACTIONS(5350),
    [sym_comment] = ACTIONS(87),
  },
  [7180] = {
    [sym__heredoc_body_start] = ACTIONS(5582),
    [sym__binary_minus] = ACTIONS(5582),
    [sym__binary_star] = ACTIONS(5582),
    [anon_sym_LBRACE] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_STAR_STAR] = ACTIONS(5582),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_EQ] = ACTIONS(5584),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_do] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON_COLON2] = ACTIONS(5582),
    [anon_sym_AMP_DOT] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5584),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ_GT] = ACTIONS(5582),
    [anon_sym_EQ_TILDE] = ACTIONS(5582),
    [anon_sym_BANG_TILDE] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5582),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [sym_comment] = ACTIONS(87),
  },
  [7181] = {
    [anon_sym_RBRACK] = ACTIONS(12368),
    [sym_comment] = ACTIONS(87),
  },
  [7182] = {
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_STAR_STAR] = ACTIONS(5594),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5594),
    [anon_sym_AMP_AMP] = ACTIONS(5594),
    [anon_sym_LT_LT] = ACTIONS(5594),
    [anon_sym_GT_GT] = ACTIONS(5594),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5594),
    [anon_sym_PLUS] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5594),
    [anon_sym_PERCENT] = ACTIONS(5594),
    [sym_comment] = ACTIONS(87),
  },
  [7183] = {
    [anon_sym_RBRACE] = ACTIONS(12370),
    [sym_comment] = ACTIONS(87),
  },
  [7184] = {
    [sym__statements] = STATE(9020),
    [sym__top_level_statement] = STATE(488),
    [sym_begin_block] = STATE(488),
    [sym_end_block] = STATE(488),
    [sym__statement] = STATE(489),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(489),
    [sym_unless_modifier] = STATE(489),
    [sym_while_modifier] = STATE(489),
    [sym_until_modifier] = STATE(489),
    [sym_rescue_modifier] = STATE(489),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(493),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(493),
    [sym_assignment] = STATE(490),
    [sym_operator_assignment] = STATE(490),
    [sym_conditional] = STATE(490),
    [sym_range] = STATE(490),
    [sym_binary] = STATE(490),
    [sym_unary] = STATE(490),
    [sym_left_assignment_list] = STATE(492),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(493),
    [sym__variable] = STATE(491),
    [sym_undef] = STATE(489),
    [sym_alias] = STATE(489),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(493),
    [sym_false] = STATE(493),
    [sym_nil] = STATE(493),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(494),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(489),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(941),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(12370),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(949),
    [anon_sym_next] = ACTIONS(951),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(953),
    [anon_sym_defined_QMARK] = ACTIONS(955),
    [anon_sym_not] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [anon_sym_undef] = ACTIONS(965),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7185] = {
    [sym__heredoc_body_start] = ACTIONS(5630),
    [sym__binary_minus] = ACTIONS(5630),
    [sym__binary_star] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5630),
    [anon_sym_RPAREN] = ACTIONS(5630),
    [anon_sym_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5632),
    [anon_sym_STAR_STAR] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5632),
    [anon_sym_do] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5630),
    [anon_sym_COLON_COLON2] = ACTIONS(5630),
    [anon_sym_AMP_DOT] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5630),
    [anon_sym_AMP_AMP] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5630),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5630),
    [anon_sym_EQ_TILDE] = ACTIONS(5630),
    [anon_sym_BANG_TILDE] = ACTIONS(5630),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5630),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5630),
    [sym_comment] = ACTIONS(87),
  },
  [7186] = {
    [anon_sym_end] = ACTIONS(12372),
    [sym_comment] = ACTIONS(87),
  },
  [7187] = {
    [sym__statements] = STATE(9022),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(9023),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(9023),
    [sym__line_break] = ACTIONS(12374),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12376),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7188] = {
    [sym__statements] = STATE(9022),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_block_parameters] = STATE(9024),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2475),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12376),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7189] = {
    [sym__heredoc_body_start] = ACTIONS(5666),
    [sym__binary_minus] = ACTIONS(5666),
    [sym__binary_star] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_STAR_STAR] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_EQ] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_do] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_COLON_COLON2] = ACTIONS(5666),
    [anon_sym_AMP_DOT] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_and] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5666),
    [anon_sym_LT_LT] = ACTIONS(5666),
    [anon_sym_GT_GT] = ACTIONS(5666),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_EQ_TILDE] = ACTIONS(5666),
    [anon_sym_BANG_TILDE] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_CARET] = ACTIONS(5666),
    [anon_sym_PLUS] = ACTIONS(5666),
    [anon_sym_SLASH] = ACTIONS(5666),
    [anon_sym_PERCENT] = ACTIONS(5666),
    [sym_comment] = ACTIONS(87),
  },
  [7190] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7191] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7192] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7193] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7194] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7195] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12378),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7196] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7197] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7198] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7199] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7200] = {
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_if] = ACTIONS(5594),
    [anon_sym_unless] = ACTIONS(5594),
    [anon_sym_while] = ACTIONS(5594),
    [anon_sym_until] = ACTIONS(5594),
    [anon_sym_rescue] = ACTIONS(5594),
    [anon_sym_in] = ACTIONS(5594),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_COLON2] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [7201] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7202] = {
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7203] = {
    [aux_sym_exceptions_repeat1] = STATE(9027),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7204] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [7205] = {
    [sym_string] = STATE(7205),
    [aux_sym_chained_string_repeat1] = STATE(7205),
    [sym__string_start] = ACTIONS(12380),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7206] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [7207] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [7208] = {
    [sym_heredoc_body] = STATE(7208),
    [aux_sym_call_repeat1] = STATE(7208),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7209] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2351),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(2351),
    [sym_operator_assignment] = STATE(2351),
    [sym_conditional] = STATE(2351),
    [sym_range] = STATE(2351),
    [sym_binary] = STATE(2351),
    [sym_unary] = STATE(2351),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2354),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(3938),
    [sym__splat_star] = ACTIONS(3940),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__identifier_hash_key] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10525),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(3946),
    [sym_identifier] = ACTIONS(3946),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7210] = {
    [sym_heredoc_body] = STATE(7208),
    [aux_sym_call_repeat1] = STATE(7208),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7211] = {
    [aux_sym_argument_list_repeat1] = STATE(7211),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12383),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [7212] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9028),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_assignment] = STATE(9028),
    [sym_operator_assignment] = STATE(9028),
    [sym_conditional] = STATE(9028),
    [sym_range] = STATE(9028),
    [sym_binary] = STATE(9028),
    [sym_unary] = STATE(9028),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7213] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4765),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(4765),
    [sym_operator_assignment] = STATE(4765),
    [sym_conditional] = STATE(4765),
    [sym_range] = STATE(4765),
    [sym_binary] = STATE(4765),
    [sym_unary] = STATE(4765),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2342),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(3940),
    [sym__unary_minus] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7214] = {
    [aux_sym_exceptions_repeat1] = STATE(9029),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12386),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7215] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7216] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7217] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9030),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(9030),
    [sym_operator_assignment] = STATE(9030),
    [sym_conditional] = STATE(9030),
    [sym_range] = STATE(9030),
    [sym_binary] = STATE(9030),
    [sym_unary] = STATE(9030),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7218] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7219] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9031),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(9031),
    [sym_operator_assignment] = STATE(9031),
    [sym_conditional] = STATE(9031),
    [sym_range] = STATE(9031),
    [sym_binary] = STATE(9031),
    [sym_unary] = STATE(9031),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7220] = {
    [sym_heredoc_body] = STATE(9032),
    [aux_sym_call_repeat1] = STATE(9032),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7221] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4780),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(9033),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7500),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12388),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7506),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7222] = {
    [sym_heredoc_body] = STATE(9034),
    [aux_sym_call_repeat1] = STATE(9034),
    [aux_sym_argument_list_repeat1] = STATE(9035),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10544),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7223] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7224] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7225] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7226] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7227] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7228] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12390),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7229] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7230] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7231] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7232] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7233] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7234] = {
    [aux_sym_exceptions_repeat1] = STATE(9038),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7235] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [7236] = {
    [sym_string] = STATE(7236),
    [aux_sym_chained_string_repeat1] = STATE(7236),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7237] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [7238] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [7239] = {
    [sym_heredoc_body] = STATE(7239),
    [aux_sym_call_repeat1] = STATE(7239),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7240] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2402),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(2402),
    [sym_operator_assignment] = STATE(2402),
    [sym_conditional] = STATE(2402),
    [sym_range] = STATE(2402),
    [sym_binary] = STATE(2402),
    [sym_unary] = STATE(2402),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2405),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4018),
    [sym__splat_star] = ACTIONS(4020),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10548),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(4026),
    [sym_identifier] = ACTIONS(4026),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7241] = {
    [sym_heredoc_body] = STATE(7239),
    [aux_sym_call_repeat1] = STATE(7239),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7242] = {
    [aux_sym_argument_list_repeat1] = STATE(7242),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12392),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [7243] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9039),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_assignment] = STATE(9039),
    [sym_operator_assignment] = STATE(9039),
    [sym_conditional] = STATE(9039),
    [sym_range] = STATE(9039),
    [sym_binary] = STATE(9039),
    [sym_unary] = STATE(9039),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7244] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4819),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(4819),
    [sym_operator_assignment] = STATE(4819),
    [sym_conditional] = STATE(4819),
    [sym_range] = STATE(4819),
    [sym_binary] = STATE(4819),
    [sym_unary] = STATE(4819),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2393),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4020),
    [sym__unary_minus] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(1215),
    [sym_identifier] = ACTIONS(1215),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7245] = {
    [aux_sym_exceptions_repeat1] = STATE(9040),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12395),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7246] = {
    [sym_heredoc_body] = STATE(7246),
    [aux_sym_call_repeat1] = STATE(7246),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [ts_builtin_sym_end] = ACTIONS(7646),
    [anon_sym___END__] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7247] = {
    [sym_heredoc_body] = STATE(7246),
    [aux_sym_call_repeat1] = STATE(7246),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [ts_builtin_sym_end] = ACTIONS(7661),
    [anon_sym___END__] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7248] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9041),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_assignment] = STATE(9041),
    [sym_operator_assignment] = STATE(9041),
    [sym_conditional] = STATE(9041),
    [sym_range] = STATE(9041),
    [sym_binary] = STATE(9041),
    [sym_unary] = STATE(9041),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7249] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(4835),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(875),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(875),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(4835),
    [sym_operator_assignment] = STATE(4835),
    [sym_conditional] = STATE(4835),
    [sym_range] = STATE(4835),
    [sym_binary] = STATE(4835),
    [sym_unary] = STATE(4835),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(874),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(875),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_nil] = STATE(875),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(369),
    [sym__unary_minus] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_defined_QMARK] = ACTIONS(1569),
    [anon_sym_not] = ACTIONS(1571),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_TILDE] = ACTIONS(1573),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7250] = {
    [aux_sym_exceptions_repeat1] = STATE(9042),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [ts_builtin_sym_end] = ACTIONS(9603),
    [anon_sym___END__] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12397),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7251] = {
    [sym_heredoc_body] = STATE(9043),
    [aux_sym_call_repeat1] = STATE(9043),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7252] = {
    [sym_heredoc_body] = STATE(9044),
    [aux_sym_call_repeat1] = STATE(9044),
    [aux_sym_argument_list_repeat1] = STATE(6870),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(6948),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7253] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [7254] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7255] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [7256] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [7257] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [7258] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12399),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7259] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [7260] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [7261] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [7262] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [7263] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9046),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(9046),
    [sym_operator_assignment] = STATE(9046),
    [sym_conditional] = STATE(9046),
    [sym_range] = STATE(9046),
    [sym_binary] = STATE(9046),
    [sym_unary] = STATE(9046),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7264] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [7265] = {
    [aux_sym_exceptions_repeat1] = STATE(9048),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7266] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [7267] = {
    [sym_string] = STATE(7267),
    [aux_sym_chained_string_repeat1] = STATE(7267),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7268] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [7269] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [7270] = {
    [sym_heredoc_body] = STATE(7270),
    [aux_sym_call_repeat1] = STATE(7270),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7271] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2473),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2476),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4152),
    [sym__splat_star] = ACTIONS(4154),
    [sym__unary_minus] = ACTIONS(3460),
    [sym__identifier_hash_key] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10562),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(4158),
    [sym_identifier] = ACTIONS(4158),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7272] = {
    [sym_heredoc_body] = STATE(7270),
    [aux_sym_call_repeat1] = STATE(7270),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7273] = {
    [aux_sym_argument_list_repeat1] = STATE(7273),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12401),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [7274] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9049),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_assignment] = STATE(9049),
    [sym_operator_assignment] = STATE(9049),
    [sym_conditional] = STATE(9049),
    [sym_range] = STATE(9049),
    [sym_binary] = STATE(9049),
    [sym_unary] = STATE(9049),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7275] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [7276] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [7277] = {
    [sym_heredoc_body] = STATE(7277),
    [aux_sym_call_repeat1] = STATE(7277),
    [sym__heredoc_body_start] = ACTIONS(10154),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [7278] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2494),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym__argument] = STATE(6822),
    [sym_splat_argument] = STATE(6822),
    [sym_hash_splat_argument] = STATE(6822),
    [sym_block_argument] = STATE(6822),
    [sym_assignment] = STATE(2494),
    [sym_operator_assignment] = STATE(2494),
    [sym_conditional] = STATE(2494),
    [sym_range] = STATE(2494),
    [sym_binary] = STATE(2494),
    [sym_unary] = STATE(2494),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2497),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6822),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4190),
    [sym__splat_star] = ACTIONS(4192),
    [sym__unary_minus] = ACTIONS(3508),
    [sym__identifier_hash_key] = ACTIONS(4194),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10566),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(4196),
    [sym_identifier] = ACTIONS(4196),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7279] = {
    [sym_heredoc_body] = STATE(7277),
    [aux_sym_call_repeat1] = STATE(7277),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [7280] = {
    [aux_sym_argument_list_repeat1] = STATE(7280),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12404),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [7281] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4176),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4180),
    [anon_sym_BANG_TILDE] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [7282] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4893),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym_splat_argument] = STATE(8300),
    [sym_assignment] = STATE(4893),
    [sym_operator_assignment] = STATE(4893),
    [sym_conditional] = STATE(4893),
    [sym_range] = STATE(4893),
    [sym_binary] = STATE(4893),
    [sym_unary] = STATE(4893),
    [sym__arg_or_splat_arg] = STATE(8300),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(7614),
    [sym__unary_minus] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7283] = {
    [aux_sym_exceptions_repeat1] = STATE(9050),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(12407),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7284] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(1629),
    [sym__binary_star] = ACTIONS(1631),
    [ts_builtin_sym_end] = ACTIONS(11746),
    [anon_sym___END__] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1643),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1647),
    [anon_sym_AMP_AMP] = ACTIONS(1647),
    [anon_sym_LT_LT] = ACTIONS(1649),
    [anon_sym_GT_GT] = ACTIONS(1649),
    [anon_sym_EQ_EQ] = ACTIONS(1651),
    [anon_sym_BANG_EQ] = ACTIONS(1647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1647),
    [anon_sym_LT_EQ_GT] = ACTIONS(1647),
    [anon_sym_EQ_TILDE] = ACTIONS(1647),
    [anon_sym_BANG_TILDE] = ACTIONS(1647),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1653),
    [anon_sym_CARET] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1631),
    [sym_comment] = ACTIONS(87),
  },
  [7285] = {
    [sym__line_break] = ACTIONS(7608),
    [sym__simple_symbol] = ACTIONS(7608),
    [sym__string_start] = ACTIONS(7608),
    [sym__symbol_start] = ACTIONS(7608),
    [sym__subshell_start] = ACTIONS(7608),
    [sym__regex_start] = ACTIONS(7608),
    [sym__string_array_start] = ACTIONS(7608),
    [sym__symbol_array_start] = ACTIONS(7608),
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym_heredoc_beginning] = ACTIONS(7608),
    [sym__block_ampersand] = ACTIONS(7608),
    [sym__splat_star] = ACTIONS(7608),
    [sym__unary_minus] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [sym__identifier_hash_key] = ACTIONS(7608),
    [ts_builtin_sym_end] = ACTIONS(7608),
    [anon_sym___END__] = ACTIONS(7610),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_def] = ACTIONS(7610),
    [anon_sym_LPAREN] = ACTIONS(7610),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COLON_COLON] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR] = ACTIONS(7610),
    [anon_sym_STAR_STAR] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_class] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_module] = ACTIONS(7610),
    [anon_sym_end] = ACTIONS(7610),
    [anon_sym_return] = ACTIONS(7610),
    [anon_sym_yield] = ACTIONS(7610),
    [anon_sym_break] = ACTIONS(7610),
    [anon_sym_next] = ACTIONS(7610),
    [sym_redo] = ACTIONS(7610),
    [sym_retry] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7610),
    [anon_sym_unless] = ACTIONS(7610),
    [anon_sym_while] = ACTIONS(7610),
    [anon_sym_until] = ACTIONS(7610),
    [anon_sym_rescue] = ACTIONS(7610),
    [anon_sym_for] = ACTIONS(7610),
    [anon_sym_do] = ACTIONS(7610),
    [anon_sym_case] = ACTIONS(7610),
    [anon_sym_when] = ACTIONS(7610),
    [anon_sym_elsif] = ACTIONS(7610),
    [anon_sym_else] = ACTIONS(7610),
    [anon_sym_then] = ACTIONS(7610),
    [anon_sym_begin] = ACTIONS(7610),
    [anon_sym_ensure] = ACTIONS(7610),
    [anon_sym_EQ_GT] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_LPAREN2] = ACTIONS(7608),
    [anon_sym_PLUS_EQ] = ACTIONS(7608),
    [anon_sym_DASH_EQ] = ACTIONS(7608),
    [anon_sym_STAR_EQ] = ACTIONS(7608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7608),
    [anon_sym_SLASH_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7608),
    [anon_sym_AMP_EQ] = ACTIONS(7608),
    [anon_sym_PERCENT_EQ] = ACTIONS(7608),
    [anon_sym_GT_GT_EQ] = ACTIONS(7608),
    [anon_sym_LT_LT_EQ] = ACTIONS(7608),
    [anon_sym_CARET_EQ] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7610),
    [anon_sym_or] = ACTIONS(7610),
    [anon_sym_PIPE_PIPE] = ACTIONS(7610),
    [anon_sym_AMP_AMP] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [anon_sym_defined_QMARK] = ACTIONS(7608),
    [anon_sym_not] = ACTIONS(7610),
    [anon_sym_BANG] = ACTIONS(7610),
    [anon_sym_TILDE] = ACTIONS(7608),
    [sym_constant] = ACTIONS(7610),
    [sym_identifier] = ACTIONS(7610),
    [sym_instance_variable] = ACTIONS(7608),
    [sym_class_variable] = ACTIONS(7608),
    [sym_global_variable] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7610),
    [sym_float] = ACTIONS(7610),
    [sym_complex] = ACTIONS(7608),
    [sym_super] = ACTIONS(7610),
    [anon_sym_true] = ACTIONS(7610),
    [anon_sym_TRUE] = ACTIONS(7610),
    [anon_sym_false] = ACTIONS(7610),
    [anon_sym_FALSE] = ACTIONS(7610),
    [sym_self] = ACTIONS(7610),
    [anon_sym_nil] = ACTIONS(7610),
    [anon_sym_NIL] = ACTIONS(7610),
    [sym_character] = ACTIONS(7608),
    [anon_sym_LBRACK2] = ACTIONS(7610),
    [anon_sym_DASH_GT] = ACTIONS(7608),
  },
  [7286] = {
    [anon_sym_RPAREN] = ACTIONS(12411),
    [sym_comment] = ACTIONS(87),
  },
  [7287] = {
    [sym__line_break] = ACTIONS(11825),
    [sym__heredoc_body_start] = ACTIONS(11825),
    [sym__binary_minus] = ACTIONS(11825),
    [sym__binary_star] = ACTIONS(11825),
    [ts_builtin_sym_end] = ACTIONS(11825),
    [anon_sym___END__] = ACTIONS(11825),
    [anon_sym_LBRACE] = ACTIONS(11825),
    [anon_sym_RBRACE] = ACTIONS(11825),
    [anon_sym_RPAREN] = ACTIONS(11825),
    [anon_sym_DOT] = ACTIONS(11827),
    [anon_sym_COMMA] = ACTIONS(11825),
    [anon_sym_PIPE] = ACTIONS(11827),
    [anon_sym_SEMI] = ACTIONS(11825),
    [anon_sym_STAR_STAR] = ACTIONS(11827),
    [anon_sym_AMP] = ACTIONS(11827),
    [anon_sym_EQ] = ACTIONS(11827),
    [anon_sym_LT] = ACTIONS(11827),
    [anon_sym_end] = ACTIONS(11825),
    [anon_sym_if] = ACTIONS(11825),
    [anon_sym_unless] = ACTIONS(11825),
    [anon_sym_while] = ACTIONS(11825),
    [anon_sym_until] = ACTIONS(11825),
    [anon_sym_rescue] = ACTIONS(11825),
    [anon_sym_do] = ACTIONS(11825),
    [anon_sym_when] = ACTIONS(11825),
    [anon_sym_elsif] = ACTIONS(11825),
    [anon_sym_else] = ACTIONS(11825),
    [anon_sym_then] = ACTIONS(11825),
    [anon_sym_ensure] = ACTIONS(11825),
    [anon_sym_EQ_GT] = ACTIONS(11825),
    [anon_sym_LBRACK] = ACTIONS(11825),
    [anon_sym_COLON_COLON2] = ACTIONS(11825),
    [anon_sym_AMP_DOT] = ACTIONS(11825),
    [anon_sym_PLUS_EQ] = ACTIONS(11825),
    [anon_sym_DASH_EQ] = ACTIONS(11825),
    [anon_sym_STAR_EQ] = ACTIONS(11825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11825),
    [anon_sym_SLASH_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11825),
    [anon_sym_AMP_EQ] = ACTIONS(11825),
    [anon_sym_PERCENT_EQ] = ACTIONS(11825),
    [anon_sym_GT_GT_EQ] = ACTIONS(11825),
    [anon_sym_LT_LT_EQ] = ACTIONS(11825),
    [anon_sym_CARET_EQ] = ACTIONS(11825),
    [anon_sym_QMARK] = ACTIONS(11825),
    [anon_sym_DOT_DOT] = ACTIONS(11827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11825),
    [anon_sym_and] = ACTIONS(11825),
    [anon_sym_or] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11827),
    [anon_sym_AMP_AMP] = ACTIONS(11827),
    [anon_sym_LT_LT] = ACTIONS(11827),
    [anon_sym_GT_GT] = ACTIONS(11827),
    [anon_sym_EQ_EQ] = ACTIONS(11827),
    [anon_sym_BANG_EQ] = ACTIONS(11825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11825),
    [anon_sym_LT_EQ_GT] = ACTIONS(11825),
    [anon_sym_EQ_TILDE] = ACTIONS(11825),
    [anon_sym_BANG_TILDE] = ACTIONS(11825),
    [anon_sym_LT_EQ] = ACTIONS(11827),
    [anon_sym_GT] = ACTIONS(11827),
    [anon_sym_GT_EQ] = ACTIONS(11825),
    [anon_sym_CARET] = ACTIONS(11827),
    [anon_sym_PLUS] = ACTIONS(11827),
    [anon_sym_SLASH] = ACTIONS(11827),
    [anon_sym_PERCENT] = ACTIONS(11827),
    [sym_comment] = ACTIONS(87),
  },
  [7288] = {
    [sym__line_break] = ACTIONS(11655),
    [sym__heredoc_body_start] = ACTIONS(11655),
    [sym__binary_minus] = ACTIONS(11655),
    [sym__binary_star] = ACTIONS(11655),
    [ts_builtin_sym_end] = ACTIONS(11655),
    [anon_sym___END__] = ACTIONS(11655),
    [anon_sym_LBRACE] = ACTIONS(11655),
    [anon_sym_RBRACE] = ACTIONS(11655),
    [anon_sym_RPAREN] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11657),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11657),
    [anon_sym_SEMI] = ACTIONS(11655),
    [anon_sym_STAR_STAR] = ACTIONS(11657),
    [anon_sym_AMP] = ACTIONS(11657),
    [anon_sym_EQ] = ACTIONS(11657),
    [anon_sym_LT] = ACTIONS(11657),
    [anon_sym_end] = ACTIONS(11655),
    [anon_sym_if] = ACTIONS(11655),
    [anon_sym_unless] = ACTIONS(11655),
    [anon_sym_while] = ACTIONS(11655),
    [anon_sym_until] = ACTIONS(11655),
    [anon_sym_rescue] = ACTIONS(11655),
    [anon_sym_do] = ACTIONS(11655),
    [anon_sym_when] = ACTIONS(11655),
    [anon_sym_elsif] = ACTIONS(11655),
    [anon_sym_else] = ACTIONS(11655),
    [anon_sym_then] = ACTIONS(11655),
    [anon_sym_ensure] = ACTIONS(11655),
    [anon_sym_EQ_GT] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [anon_sym_PLUS_EQ] = ACTIONS(11655),
    [anon_sym_DASH_EQ] = ACTIONS(11655),
    [anon_sym_STAR_EQ] = ACTIONS(11655),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11655),
    [anon_sym_SLASH_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11655),
    [anon_sym_AMP_EQ] = ACTIONS(11655),
    [anon_sym_PERCENT_EQ] = ACTIONS(11655),
    [anon_sym_GT_GT_EQ] = ACTIONS(11655),
    [anon_sym_LT_LT_EQ] = ACTIONS(11655),
    [anon_sym_CARET_EQ] = ACTIONS(11655),
    [anon_sym_QMARK] = ACTIONS(11655),
    [anon_sym_DOT_DOT] = ACTIONS(11657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11655),
    [anon_sym_and] = ACTIONS(11655),
    [anon_sym_or] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE] = ACTIONS(11657),
    [anon_sym_AMP_AMP] = ACTIONS(11657),
    [anon_sym_LT_LT] = ACTIONS(11657),
    [anon_sym_GT_GT] = ACTIONS(11657),
    [anon_sym_EQ_EQ] = ACTIONS(11657),
    [anon_sym_BANG_EQ] = ACTIONS(11655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11655),
    [anon_sym_LT_EQ_GT] = ACTIONS(11655),
    [anon_sym_EQ_TILDE] = ACTIONS(11655),
    [anon_sym_BANG_TILDE] = ACTIONS(11655),
    [anon_sym_LT_EQ] = ACTIONS(11657),
    [anon_sym_GT] = ACTIONS(11657),
    [anon_sym_GT_EQ] = ACTIONS(11655),
    [anon_sym_CARET] = ACTIONS(11657),
    [anon_sym_PLUS] = ACTIONS(11657),
    [anon_sym_SLASH] = ACTIONS(11657),
    [anon_sym_PERCENT] = ACTIONS(11657),
    [sym_comment] = ACTIONS(87),
  },
  [7289] = {
    [sym__line_break] = ACTIONS(11680),
    [sym__heredoc_body_start] = ACTIONS(11680),
    [sym__binary_minus] = ACTIONS(11680),
    [sym__binary_star] = ACTIONS(11680),
    [ts_builtin_sym_end] = ACTIONS(11680),
    [anon_sym___END__] = ACTIONS(11680),
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RBRACE] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11682),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11682),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_STAR_STAR] = ACTIONS(11682),
    [anon_sym_AMP] = ACTIONS(11682),
    [anon_sym_EQ] = ACTIONS(11682),
    [anon_sym_LT] = ACTIONS(11682),
    [anon_sym_end] = ACTIONS(11680),
    [anon_sym_if] = ACTIONS(11680),
    [anon_sym_unless] = ACTIONS(11680),
    [anon_sym_while] = ACTIONS(11680),
    [anon_sym_until] = ACTIONS(11680),
    [anon_sym_rescue] = ACTIONS(11680),
    [anon_sym_do] = ACTIONS(11680),
    [anon_sym_when] = ACTIONS(11680),
    [anon_sym_elsif] = ACTIONS(11680),
    [anon_sym_else] = ACTIONS(11680),
    [anon_sym_then] = ACTIONS(11680),
    [anon_sym_ensure] = ACTIONS(11680),
    [anon_sym_EQ_GT] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [anon_sym_PLUS_EQ] = ACTIONS(11680),
    [anon_sym_DASH_EQ] = ACTIONS(11680),
    [anon_sym_STAR_EQ] = ACTIONS(11680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11680),
    [anon_sym_SLASH_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11680),
    [anon_sym_AMP_EQ] = ACTIONS(11680),
    [anon_sym_PERCENT_EQ] = ACTIONS(11680),
    [anon_sym_GT_GT_EQ] = ACTIONS(11680),
    [anon_sym_LT_LT_EQ] = ACTIONS(11680),
    [anon_sym_CARET_EQ] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_DOT_DOT] = ACTIONS(11682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_and] = ACTIONS(11680),
    [anon_sym_or] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE] = ACTIONS(11682),
    [anon_sym_AMP_AMP] = ACTIONS(11682),
    [anon_sym_LT_LT] = ACTIONS(11682),
    [anon_sym_GT_GT] = ACTIONS(11682),
    [anon_sym_EQ_EQ] = ACTIONS(11682),
    [anon_sym_BANG_EQ] = ACTIONS(11680),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11680),
    [anon_sym_LT_EQ_GT] = ACTIONS(11680),
    [anon_sym_EQ_TILDE] = ACTIONS(11680),
    [anon_sym_BANG_TILDE] = ACTIONS(11680),
    [anon_sym_LT_EQ] = ACTIONS(11682),
    [anon_sym_GT] = ACTIONS(11682),
    [anon_sym_GT_EQ] = ACTIONS(11680),
    [anon_sym_CARET] = ACTIONS(11682),
    [anon_sym_PLUS] = ACTIONS(11682),
    [anon_sym_SLASH] = ACTIONS(11682),
    [anon_sym_PERCENT] = ACTIONS(11682),
    [sym_comment] = ACTIONS(87),
  },
  [7290] = {
    [anon_sym_end] = ACTIONS(12413),
    [sym_comment] = ACTIONS(87),
  },
  [7291] = {
    [sym__statements] = STATE(9053),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12415),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7292] = {
    [sym__line_break] = ACTIONS(10568),
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [ts_builtin_sym_end] = ACTIONS(10568),
    [anon_sym___END__] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10570),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_end] = ACTIONS(10568),
    [anon_sym_if] = ACTIONS(10568),
    [anon_sym_unless] = ACTIONS(10568),
    [anon_sym_while] = ACTIONS(10568),
    [anon_sym_until] = ACTIONS(10568),
    [anon_sym_rescue] = ACTIONS(10568),
    [anon_sym_do] = ACTIONS(10568),
    [anon_sym_when] = ACTIONS(10568),
    [anon_sym_elsif] = ACTIONS(10568),
    [anon_sym_else] = ACTIONS(10568),
    [anon_sym_then] = ACTIONS(10568),
    [anon_sym_ensure] = ACTIONS(10568),
    [anon_sym_EQ_GT] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_PLUS_EQ] = ACTIONS(10568),
    [anon_sym_DASH_EQ] = ACTIONS(10568),
    [anon_sym_STAR_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10568),
    [anon_sym_SLASH_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10568),
    [anon_sym_AMP_EQ] = ACTIONS(10568),
    [anon_sym_PERCENT_EQ] = ACTIONS(10568),
    [anon_sym_GT_GT_EQ] = ACTIONS(10568),
    [anon_sym_LT_LT_EQ] = ACTIONS(10568),
    [anon_sym_CARET_EQ] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10568),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10568),
    [anon_sym_or] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE] = ACTIONS(10570),
    [anon_sym_AMP_AMP] = ACTIONS(10570),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10570),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_SLASH] = ACTIONS(10570),
    [anon_sym_PERCENT] = ACTIONS(10570),
    [sym_comment] = ACTIONS(87),
  },
  [7293] = {
    [sym__line_break] = ACTIONS(6547),
    [sym__heredoc_body_start] = ACTIONS(6547),
    [sym__binary_minus] = ACTIONS(6547),
    [sym__binary_star] = ACTIONS(6547),
    [ts_builtin_sym_end] = ACTIONS(6547),
    [anon_sym___END__] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_DOT] = ACTIONS(8423),
    [anon_sym_COMMA] = ACTIONS(6547),
    [anon_sym_PIPE] = ACTIONS(8423),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym_STAR_STAR] = ACTIONS(8423),
    [anon_sym_AMP] = ACTIONS(8423),
    [anon_sym_EQ] = ACTIONS(8423),
    [anon_sym_LT] = ACTIONS(8423),
    [anon_sym_end] = ACTIONS(6547),
    [anon_sym_if] = ACTIONS(6547),
    [anon_sym_unless] = ACTIONS(6547),
    [anon_sym_while] = ACTIONS(6547),
    [anon_sym_until] = ACTIONS(6547),
    [anon_sym_rescue] = ACTIONS(6547),
    [anon_sym_do] = ACTIONS(6547),
    [anon_sym_when] = ACTIONS(6547),
    [anon_sym_elsif] = ACTIONS(6547),
    [anon_sym_else] = ACTIONS(6547),
    [anon_sym_then] = ACTIONS(6547),
    [anon_sym_ensure] = ACTIONS(6547),
    [anon_sym_EQ_GT] = ACTIONS(6547),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_COLON_COLON2] = ACTIONS(6547),
    [anon_sym_AMP_DOT] = ACTIONS(6547),
    [anon_sym_PLUS_EQ] = ACTIONS(6547),
    [anon_sym_DASH_EQ] = ACTIONS(6547),
    [anon_sym_STAR_EQ] = ACTIONS(6547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6547),
    [anon_sym_SLASH_EQ] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6547),
    [anon_sym_PIPE_EQ] = ACTIONS(6547),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6547),
    [anon_sym_AMP_EQ] = ACTIONS(6547),
    [anon_sym_PERCENT_EQ] = ACTIONS(6547),
    [anon_sym_GT_GT_EQ] = ACTIONS(6547),
    [anon_sym_LT_LT_EQ] = ACTIONS(6547),
    [anon_sym_CARET_EQ] = ACTIONS(6547),
    [anon_sym_QMARK] = ACTIONS(6547),
    [anon_sym_DOT_DOT] = ACTIONS(8423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6547),
    [anon_sym_and] = ACTIONS(6547),
    [anon_sym_or] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8423),
    [anon_sym_AMP_AMP] = ACTIONS(8423),
    [anon_sym_LT_LT] = ACTIONS(8423),
    [anon_sym_GT_GT] = ACTIONS(8423),
    [anon_sym_EQ_EQ] = ACTIONS(8423),
    [anon_sym_BANG_EQ] = ACTIONS(6547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6547),
    [anon_sym_LT_EQ_GT] = ACTIONS(6547),
    [anon_sym_EQ_TILDE] = ACTIONS(6547),
    [anon_sym_BANG_TILDE] = ACTIONS(6547),
    [anon_sym_LT_EQ] = ACTIONS(8423),
    [anon_sym_GT] = ACTIONS(8423),
    [anon_sym_GT_EQ] = ACTIONS(6547),
    [anon_sym_CARET] = ACTIONS(8423),
    [anon_sym_PLUS] = ACTIONS(8423),
    [anon_sym_SLASH] = ACTIONS(8423),
    [anon_sym_PERCENT] = ACTIONS(8423),
    [sym_comment] = ACTIONS(87),
  },
  [7294] = {
    [sym__line_break] = ACTIONS(10596),
    [sym__heredoc_body_start] = ACTIONS(10596),
    [sym__binary_minus] = ACTIONS(10596),
    [sym__binary_star] = ACTIONS(10596),
    [ts_builtin_sym_end] = ACTIONS(10596),
    [anon_sym___END__] = ACTIONS(10596),
    [anon_sym_LBRACE] = ACTIONS(10596),
    [anon_sym_RBRACE] = ACTIONS(10596),
    [anon_sym_RPAREN] = ACTIONS(10596),
    [anon_sym_DOT] = ACTIONS(10598),
    [anon_sym_COMMA] = ACTIONS(10596),
    [anon_sym_PIPE] = ACTIONS(10598),
    [anon_sym_SEMI] = ACTIONS(10596),
    [anon_sym_STAR_STAR] = ACTIONS(10598),
    [anon_sym_AMP] = ACTIONS(10598),
    [anon_sym_EQ] = ACTIONS(10598),
    [anon_sym_LT] = ACTIONS(10598),
    [anon_sym_end] = ACTIONS(10596),
    [anon_sym_if] = ACTIONS(10596),
    [anon_sym_unless] = ACTIONS(10596),
    [anon_sym_while] = ACTIONS(10596),
    [anon_sym_until] = ACTIONS(10596),
    [anon_sym_rescue] = ACTIONS(10596),
    [anon_sym_do] = ACTIONS(10596),
    [anon_sym_when] = ACTIONS(10596),
    [anon_sym_elsif] = ACTIONS(10596),
    [anon_sym_else] = ACTIONS(10596),
    [anon_sym_then] = ACTIONS(10596),
    [anon_sym_ensure] = ACTIONS(10596),
    [anon_sym_EQ_GT] = ACTIONS(10596),
    [anon_sym_LBRACK] = ACTIONS(10596),
    [anon_sym_COLON_COLON2] = ACTIONS(10596),
    [anon_sym_AMP_DOT] = ACTIONS(10596),
    [anon_sym_PLUS_EQ] = ACTIONS(10596),
    [anon_sym_DASH_EQ] = ACTIONS(10596),
    [anon_sym_STAR_EQ] = ACTIONS(10596),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10596),
    [anon_sym_SLASH_EQ] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10596),
    [anon_sym_PIPE_EQ] = ACTIONS(10596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10596),
    [anon_sym_AMP_EQ] = ACTIONS(10596),
    [anon_sym_PERCENT_EQ] = ACTIONS(10596),
    [anon_sym_GT_GT_EQ] = ACTIONS(10596),
    [anon_sym_LT_LT_EQ] = ACTIONS(10596),
    [anon_sym_CARET_EQ] = ACTIONS(10596),
    [anon_sym_QMARK] = ACTIONS(10596),
    [anon_sym_DOT_DOT] = ACTIONS(10598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10596),
    [anon_sym_and] = ACTIONS(10596),
    [anon_sym_or] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE] = ACTIONS(10598),
    [anon_sym_AMP_AMP] = ACTIONS(10598),
    [anon_sym_LT_LT] = ACTIONS(10598),
    [anon_sym_GT_GT] = ACTIONS(10598),
    [anon_sym_EQ_EQ] = ACTIONS(10598),
    [anon_sym_BANG_EQ] = ACTIONS(10596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10596),
    [anon_sym_LT_EQ_GT] = ACTIONS(10596),
    [anon_sym_EQ_TILDE] = ACTIONS(10596),
    [anon_sym_BANG_TILDE] = ACTIONS(10596),
    [anon_sym_LT_EQ] = ACTIONS(10598),
    [anon_sym_GT] = ACTIONS(10598),
    [anon_sym_GT_EQ] = ACTIONS(10596),
    [anon_sym_CARET] = ACTIONS(10598),
    [anon_sym_PLUS] = ACTIONS(10598),
    [anon_sym_SLASH] = ACTIONS(10598),
    [anon_sym_PERCENT] = ACTIONS(10598),
    [sym_comment] = ACTIONS(87),
  },
  [7295] = {
    [sym__simple_symbol] = ACTIONS(6547),
    [sym__string_start] = ACTIONS(6547),
    [sym__symbol_start] = ACTIONS(6547),
    [sym__subshell_start] = ACTIONS(6547),
    [sym__regex_start] = ACTIONS(6547),
    [sym__string_array_start] = ACTIONS(6547),
    [sym__symbol_array_start] = ACTIONS(6547),
    [sym_heredoc_beginning] = ACTIONS(6547),
    [sym__block_ampersand] = ACTIONS(6547),
    [sym__splat_star] = ACTIONS(6547),
    [sym__unary_minus] = ACTIONS(6547),
    [sym__identifier_hash_key] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_def] = ACTIONS(8423),
    [anon_sym_LPAREN] = ACTIONS(6547),
    [anon_sym_COLON_COLON] = ACTIONS(6547),
    [anon_sym_STAR] = ACTIONS(8423),
    [anon_sym_STAR_STAR] = ACTIONS(6547),
    [anon_sym_class] = ACTIONS(8423),
    [anon_sym_module] = ACTIONS(8423),
    [anon_sym_return] = ACTIONS(8423),
    [anon_sym_yield] = ACTIONS(8423),
    [anon_sym_break] = ACTIONS(8423),
    [anon_sym_next] = ACTIONS(8423),
    [sym_redo] = ACTIONS(8423),
    [sym_retry] = ACTIONS(8423),
    [anon_sym_if] = ACTIONS(8423),
    [anon_sym_unless] = ACTIONS(8423),
    [anon_sym_while] = ACTIONS(8423),
    [anon_sym_until] = ACTIONS(8423),
    [anon_sym_for] = ACTIONS(8423),
    [anon_sym_case] = ACTIONS(8423),
    [anon_sym_begin] = ACTIONS(8423),
    [anon_sym_PLUS] = ACTIONS(8423),
    [anon_sym_defined_QMARK] = ACTIONS(6547),
    [anon_sym_not] = ACTIONS(8423),
    [anon_sym_BANG] = ACTIONS(6547),
    [anon_sym_TILDE] = ACTIONS(6547),
    [sym_constant] = ACTIONS(8423),
    [sym_identifier] = ACTIONS(8423),
    [sym_instance_variable] = ACTIONS(6547),
    [sym_class_variable] = ACTIONS(6547),
    [sym_global_variable] = ACTIONS(6547),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8423),
    [sym_float] = ACTIONS(8423),
    [sym_complex] = ACTIONS(6547),
    [sym_super] = ACTIONS(8423),
    [anon_sym_true] = ACTIONS(8423),
    [anon_sym_TRUE] = ACTIONS(8423),
    [anon_sym_false] = ACTIONS(8423),
    [anon_sym_FALSE] = ACTIONS(8423),
    [sym_self] = ACTIONS(8423),
    [anon_sym_nil] = ACTIONS(8423),
    [anon_sym_NIL] = ACTIONS(8423),
    [sym_character] = ACTIONS(6547),
    [anon_sym_LBRACK2] = ACTIONS(6547),
    [anon_sym_DASH_GT] = ACTIONS(6547),
  },
  [7296] = {
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [ts_builtin_sym_end] = ACTIONS(11211),
    [anon_sym___END__] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_when] = ACTIONS(11211),
    [anon_sym_elsif] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [7297] = {
    [aux_sym_exceptions_repeat1] = STATE(7297),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [ts_builtin_sym_end] = ACTIONS(11211),
    [anon_sym___END__] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(12417),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [7298] = {
    [sym_heredoc_body] = STATE(9054),
    [aux_sym_call_repeat1] = STATE(9054),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7299] = {
    [sym_heredoc_body] = STATE(9055),
    [aux_sym_call_repeat1] = STATE(9055),
    [aux_sym_argument_list_repeat1] = STATE(4975),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4320),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7300] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [7301] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7302] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [7303] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [7304] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [7305] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12420),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7306] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [7307] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7682),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [7308] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [7309] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [7310] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7682),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [7311] = {
    [aux_sym_exceptions_repeat1] = STATE(9058),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7312] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7682),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [7313] = {
    [sym_string] = STATE(7313),
    [aux_sym_chained_string_repeat1] = STATE(7313),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7314] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [7315] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [7316] = {
    [sym_heredoc_body] = STATE(7316),
    [aux_sym_call_repeat1] = STATE(7316),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7317] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2578),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(2578),
    [sym_operator_assignment] = STATE(2578),
    [sym_conditional] = STATE(2578),
    [sym_range] = STATE(2578),
    [sym_binary] = STATE(2578),
    [sym_unary] = STATE(2578),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2581),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4276),
    [sym__splat_star] = ACTIONS(4278),
    [sym__unary_minus] = ACTIONS(1715),
    [sym__identifier_hash_key] = ACTIONS(4280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10602),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(4282),
    [sym_identifier] = ACTIONS(4282),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7318] = {
    [sym_heredoc_body] = STATE(7316),
    [aux_sym_call_repeat1] = STATE(7316),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7319] = {
    [aux_sym_argument_list_repeat1] = STATE(7319),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12422),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [7320] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9059),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_assignment] = STATE(9059),
    [sym_operator_assignment] = STATE(9059),
    [sym_conditional] = STATE(9059),
    [sym_range] = STATE(9059),
    [sym_binary] = STATE(9059),
    [sym_unary] = STATE(9059),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7321] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [7322] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [7323] = {
    [sym_heredoc_body] = STATE(7323),
    [aux_sym_call_repeat1] = STATE(7323),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [7324] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2599),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(2599),
    [sym_operator_assignment] = STATE(2599),
    [sym_conditional] = STATE(2599),
    [sym_range] = STATE(2599),
    [sym_binary] = STATE(2599),
    [sym_unary] = STATE(2599),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2602),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4312),
    [sym__splat_star] = ACTIONS(4314),
    [sym__unary_minus] = ACTIONS(1791),
    [sym__identifier_hash_key] = ACTIONS(4316),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10606),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(4318),
    [sym_identifier] = ACTIONS(4318),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7325] = {
    [sym_heredoc_body] = STATE(7323),
    [aux_sym_call_repeat1] = STATE(7323),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [7326] = {
    [aux_sym_argument_list_repeat1] = STATE(7326),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12425),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [7327] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4976),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(968),
    [sym_scope_resolution] = STATE(964),
    [sym_call] = STATE(964),
    [sym_method_call] = STATE(968),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(4976),
    [sym_operator_assignment] = STATE(4976),
    [sym_conditional] = STATE(4976),
    [sym_range] = STATE(4976),
    [sym_binary] = STATE(4976),
    [sym_unary] = STATE(4976),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(968),
    [sym__variable] = STATE(964),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_nil] = STATE(968),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2570),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(4278),
    [sym__unary_minus] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1723),
    [anon_sym_next] = ACTIONS(1725),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4272),
    [anon_sym_defined_QMARK] = ACTIONS(1727),
    [anon_sym_not] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1733),
    [sym_constant] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1739),
    [sym_instance_variable] = ACTIONS(1737),
    [sym_class_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1739),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7328] = {
    [aux_sym_exceptions_repeat1] = STATE(9060),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12428),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7329] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9061),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(9061),
    [sym_operator_assignment] = STATE(9061),
    [sym_conditional] = STATE(9061),
    [sym_range] = STATE(9061),
    [sym_binary] = STATE(9061),
    [sym_unary] = STATE(9061),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7330] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(9062),
    [sym__argument] = STATE(9063),
    [sym_splat_argument] = STATE(9063),
    [sym_hash_splat_argument] = STATE(9063),
    [sym_block_argument] = STATE(9063),
    [sym_assignment] = STATE(4995),
    [sym_operator_assignment] = STATE(4995),
    [sym_conditional] = STATE(4995),
    [sym_range] = STATE(4995),
    [sym_binary] = STATE(4995),
    [sym_unary] = STATE(4995),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5001),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9063),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7728),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7734),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7752),
    [sym_identifier] = ACTIONS(7752),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7331] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(9062),
    [sym__argument] = STATE(9063),
    [sym_splat_argument] = STATE(9063),
    [sym_hash_splat_argument] = STATE(9063),
    [sym_block_argument] = STATE(9063),
    [sym_assignment] = STATE(4995),
    [sym_operator_assignment] = STATE(4995),
    [sym_conditional] = STATE(4995),
    [sym_range] = STATE(4995),
    [sym_binary] = STATE(4995),
    [sym_unary] = STATE(4995),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5001),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9063),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7728),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7734),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7752),
    [sym_identifier] = ACTIONS(7752),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7332] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(9062),
    [sym__argument] = STATE(9063),
    [sym_splat_argument] = STATE(9063),
    [sym_hash_splat_argument] = STATE(9063),
    [sym_block_argument] = STATE(9063),
    [sym_assignment] = STATE(4995),
    [sym_operator_assignment] = STATE(4995),
    [sym_conditional] = STATE(4995),
    [sym_range] = STATE(4995),
    [sym_binary] = STATE(4995),
    [sym_unary] = STATE(4995),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5001),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9063),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7728),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7734),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7752),
    [sym_identifier] = ACTIONS(7752),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7333] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(9062),
    [sym__argument] = STATE(9063),
    [sym_splat_argument] = STATE(9063),
    [sym_hash_splat_argument] = STATE(9063),
    [sym_block_argument] = STATE(9063),
    [sym_assignment] = STATE(4995),
    [sym_operator_assignment] = STATE(4995),
    [sym_conditional] = STATE(4995),
    [sym_range] = STATE(4995),
    [sym_binary] = STATE(4995),
    [sym_unary] = STATE(4995),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5001),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9063),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7728),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7734),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7748),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7752),
    [sym_identifier] = ACTIONS(7752),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7334] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9064),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(9064),
    [sym_operator_assignment] = STATE(9064),
    [sym_conditional] = STATE(9064),
    [sym_range] = STATE(9064),
    [sym_binary] = STATE(9064),
    [sym_unary] = STATE(9064),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7335] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7336] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_elsif] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(12440),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [7337] = {
    [anon_sym_EQ] = ACTIONS(12456),
    [sym_comment] = ACTIONS(87),
  },
  [7338] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12458),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12460),
    [anon_sym_DASH_EQ] = ACTIONS(12460),
    [anon_sym_STAR_EQ] = ACTIONS(12460),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12460),
    [anon_sym_SLASH_EQ] = ACTIONS(12460),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12460),
    [anon_sym_PIPE_EQ] = ACTIONS(12460),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12460),
    [anon_sym_AMP_EQ] = ACTIONS(12460),
    [anon_sym_PERCENT_EQ] = ACTIONS(12460),
    [anon_sym_GT_GT_EQ] = ACTIONS(12460),
    [anon_sym_LT_LT_EQ] = ACTIONS(12460),
    [anon_sym_CARET_EQ] = ACTIONS(12460),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7339] = {
    [sym_string] = STATE(9077),
    [aux_sym_chained_string_repeat1] = STATE(9077),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7340] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_elsif] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(12440),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [7341] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [7342] = {
    [sym_string] = STATE(7380),
    [aux_sym_chained_string_repeat1] = STATE(7380),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7343] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9078),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(9078),
    [sym_operator_assignment] = STATE(9078),
    [sym_conditional] = STATE(9078),
    [sym_range] = STATE(9078),
    [sym_binary] = STATE(9078),
    [sym_unary] = STATE(9078),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7344] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_elsif] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(12440),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [7345] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9079),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9079),
    [sym_operator_assignment] = STATE(9079),
    [sym_conditional] = STATE(9079),
    [sym_range] = STATE(9079),
    [sym_binary] = STATE(9079),
    [sym_unary] = STATE(9079),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7346] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9080),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9080),
    [sym_operator_assignment] = STATE(9080),
    [sym_conditional] = STATE(9080),
    [sym_range] = STATE(9080),
    [sym_binary] = STATE(9080),
    [sym_unary] = STATE(9080),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7347] = {
    [anon_sym_COLON] = ACTIONS(12462),
    [sym_comment] = ACTIONS(87),
  },
  [7348] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9082),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9082),
    [sym_operator_assignment] = STATE(9082),
    [sym_conditional] = STATE(9082),
    [sym_range] = STATE(9082),
    [sym_binary] = STATE(9082),
    [sym_unary] = STATE(9082),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7349] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12464),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_elsif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [7350] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_elsif] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [7351] = {
    [sym_heredoc_body] = STATE(9084),
    [aux_sym_call_repeat1] = STATE(9084),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_elsif] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [7352] = {
    [sym_heredoc_body] = STATE(9084),
    [aux_sym_call_repeat1] = STATE(9084),
    [aux_sym_argument_list_repeat1] = STATE(9086),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(12466),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_elsif] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [7353] = {
    [sym_string] = STATE(7380),
    [aux_sym_chained_string_repeat1] = STATE(7380),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12468),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7354] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [7355] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9087),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(9087),
    [sym_operator_assignment] = STATE(9087),
    [sym_conditional] = STATE(9087),
    [sym_range] = STATE(9087),
    [sym_binary] = STATE(9087),
    [sym_unary] = STATE(9087),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7356] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9088),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9088),
    [sym_operator_assignment] = STATE(9088),
    [sym_conditional] = STATE(9088),
    [sym_range] = STATE(9088),
    [sym_binary] = STATE(9088),
    [sym_unary] = STATE(9088),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7357] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9089),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9089),
    [sym_operator_assignment] = STATE(9089),
    [sym_conditional] = STATE(9089),
    [sym_range] = STATE(9089),
    [sym_binary] = STATE(9089),
    [sym_unary] = STATE(9089),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7358] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9090),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9090),
    [sym_operator_assignment] = STATE(9090),
    [sym_conditional] = STATE(9090),
    [sym_range] = STATE(9090),
    [sym_binary] = STATE(9090),
    [sym_unary] = STATE(9090),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7359] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9091),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9091),
    [sym_operator_assignment] = STATE(9091),
    [sym_conditional] = STATE(9091),
    [sym_range] = STATE(9091),
    [sym_binary] = STATE(9091),
    [sym_unary] = STATE(9091),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7360] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9092),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9092),
    [sym_operator_assignment] = STATE(9092),
    [sym_conditional] = STATE(9092),
    [sym_range] = STATE(9092),
    [sym_binary] = STATE(9092),
    [sym_unary] = STATE(9092),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7361] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9093),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9093),
    [sym_operator_assignment] = STATE(9093),
    [sym_conditional] = STATE(9093),
    [sym_range] = STATE(9093),
    [sym_binary] = STATE(9093),
    [sym_unary] = STATE(9093),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7362] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9094),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9094),
    [sym_operator_assignment] = STATE(9094),
    [sym_conditional] = STATE(9094),
    [sym_range] = STATE(9094),
    [sym_binary] = STATE(9094),
    [sym_unary] = STATE(9094),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7363] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9095),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9095),
    [sym_operator_assignment] = STATE(9095),
    [sym_conditional] = STATE(9095),
    [sym_range] = STATE(9095),
    [sym_binary] = STATE(9095),
    [sym_unary] = STATE(9095),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7364] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9096),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9096),
    [sym_operator_assignment] = STATE(9096),
    [sym_conditional] = STATE(9096),
    [sym_range] = STATE(9096),
    [sym_binary] = STATE(9096),
    [sym_unary] = STATE(9096),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7365] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9097),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9097),
    [sym_operator_assignment] = STATE(9097),
    [sym_conditional] = STATE(9097),
    [sym_range] = STATE(9097),
    [sym_binary] = STATE(9097),
    [sym_unary] = STATE(9097),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7366] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9098),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9098),
    [sym_operator_assignment] = STATE(9098),
    [sym_conditional] = STATE(9098),
    [sym_range] = STATE(9098),
    [sym_binary] = STATE(9098),
    [sym_unary] = STATE(9098),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7367] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9099),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9099),
    [sym_operator_assignment] = STATE(9099),
    [sym_conditional] = STATE(9099),
    [sym_range] = STATE(9099),
    [sym_binary] = STATE(9099),
    [sym_unary] = STATE(9099),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7368] = {
    [anon_sym_COLON] = ACTIONS(12470),
    [sym_comment] = ACTIONS(87),
  },
  [7369] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9101),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9101),
    [sym_operator_assignment] = STATE(9101),
    [sym_conditional] = STATE(9101),
    [sym_range] = STATE(9101),
    [sym_binary] = STATE(9101),
    [sym_unary] = STATE(9101),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7370] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12472),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_elsif] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [7371] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_elsif] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [7372] = {
    [sym_heredoc_body] = STATE(9103),
    [aux_sym_call_repeat1] = STATE(9103),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_elsif] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [7373] = {
    [sym_heredoc_body] = STATE(9103),
    [aux_sym_call_repeat1] = STATE(9103),
    [aux_sym_argument_list_repeat1] = STATE(9105),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(12474),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_elsif] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [7374] = {
    [sym_string] = STATE(7435),
    [aux_sym_chained_string_repeat1] = STATE(7435),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12476),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7375] = {
    [sym_heredoc_body] = STATE(9106),
    [aux_sym_call_repeat1] = STATE(9106),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_elsif] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7376] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(4995),
    [sym_operator_assignment] = STATE(4995),
    [sym_conditional] = STATE(4995),
    [sym_range] = STATE(4995),
    [sym_binary] = STATE(4995),
    [sym_unary] = STATE(4995),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5001),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9107),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7728),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__identifier_hash_key] = ACTIONS(7734),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12478),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7752),
    [sym_identifier] = ACTIONS(7752),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7377] = {
    [sym_heredoc_body] = STATE(9108),
    [aux_sym_call_repeat1] = STATE(9108),
    [aux_sym_argument_list_repeat1] = STATE(9109),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10677),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_elsif] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7378] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9110),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_splat_argument] = STATE(9111),
    [sym_assignment] = STATE(9110),
    [sym_operator_assignment] = STATE(9110),
    [sym_conditional] = STATE(9110),
    [sym_range] = STATE(9110),
    [sym_binary] = STATE(9110),
    [sym_unary] = STATE(9110),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(9111),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(10635),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7379] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9112),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(9112),
    [sym_operator_assignment] = STATE(9112),
    [sym_conditional] = STATE(9112),
    [sym_range] = STATE(9112),
    [sym_binary] = STATE(9112),
    [sym_unary] = STATE(9112),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7380] = {
    [sym_string] = STATE(9113),
    [aux_sym_chained_string_repeat1] = STATE(9113),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_elsif] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [7381] = {
    [sym__statements] = STATE(9114),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(9115),
    [sym_else] = STATE(9115),
    [sym__if_tail] = STATE(9115),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12480),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7382] = {
    [aux_sym_undef_repeat1] = STATE(9116),
    [sym__line_break] = ACTIONS(5356),
    [sym__heredoc_body_start] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym_end] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [anon_sym_elsif] = ACTIONS(5356),
    [anon_sym_else] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [7383] = {
    [sym__line_break] = ACTIONS(12482),
    [sym__heredoc_body_start] = ACTIONS(12482),
    [sym__binary_minus] = ACTIONS(12482),
    [sym__binary_star] = ACTIONS(12482),
    [ts_builtin_sym_end] = ACTIONS(12482),
    [anon_sym___END__] = ACTIONS(12482),
    [anon_sym_LBRACE] = ACTIONS(12482),
    [anon_sym_RBRACE] = ACTIONS(12482),
    [anon_sym_RPAREN] = ACTIONS(12482),
    [anon_sym_DOT] = ACTIONS(12484),
    [anon_sym_COMMA] = ACTIONS(12482),
    [anon_sym_PIPE] = ACTIONS(12484),
    [anon_sym_SEMI] = ACTIONS(12482),
    [anon_sym_STAR_STAR] = ACTIONS(12482),
    [anon_sym_AMP] = ACTIONS(12484),
    [anon_sym_LT] = ACTIONS(12484),
    [anon_sym_end] = ACTIONS(12482),
    [anon_sym_if] = ACTIONS(12482),
    [anon_sym_unless] = ACTIONS(12482),
    [anon_sym_while] = ACTIONS(12482),
    [anon_sym_until] = ACTIONS(12482),
    [anon_sym_rescue] = ACTIONS(12482),
    [anon_sym_do] = ACTIONS(12482),
    [anon_sym_when] = ACTIONS(12482),
    [anon_sym_elsif] = ACTIONS(12482),
    [anon_sym_else] = ACTIONS(12482),
    [anon_sym_then] = ACTIONS(12482),
    [anon_sym_ensure] = ACTIONS(12482),
    [anon_sym_EQ_GT] = ACTIONS(12482),
    [anon_sym_LBRACK] = ACTIONS(12482),
    [anon_sym_COLON_COLON2] = ACTIONS(12482),
    [anon_sym_AMP_DOT] = ACTIONS(12482),
    [anon_sym_QMARK] = ACTIONS(12482),
    [anon_sym_DOT_DOT] = ACTIONS(12484),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12482),
    [anon_sym_and] = ACTIONS(12482),
    [anon_sym_or] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE] = ACTIONS(12482),
    [anon_sym_AMP_AMP] = ACTIONS(12482),
    [anon_sym_LT_LT] = ACTIONS(12482),
    [anon_sym_GT_GT] = ACTIONS(12482),
    [anon_sym_EQ_EQ] = ACTIONS(12484),
    [anon_sym_BANG_EQ] = ACTIONS(12482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12482),
    [anon_sym_LT_EQ_GT] = ACTIONS(12482),
    [anon_sym_EQ_TILDE] = ACTIONS(12482),
    [anon_sym_BANG_TILDE] = ACTIONS(12482),
    [anon_sym_LT_EQ] = ACTIONS(12484),
    [anon_sym_GT] = ACTIONS(12484),
    [anon_sym_GT_EQ] = ACTIONS(12482),
    [anon_sym_CARET] = ACTIONS(12482),
    [anon_sym_PLUS] = ACTIONS(12482),
    [anon_sym_SLASH] = ACTIONS(12482),
    [anon_sym_PERCENT] = ACTIONS(12482),
    [sym_comment] = ACTIONS(87),
  },
  [7384] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5678),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(5678),
    [anon_sym_else] = ACTIONS(5678),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7385] = {
    [sym_heredoc_body] = STATE(9117),
    [sym__terminator] = STATE(9117),
    [aux_sym__statements_repeat1] = STATE(7385),
    [sym__line_break] = ACTIONS(12486),
    [sym__heredoc_body_start] = ACTIONS(5683),
    [anon_sym_SEMI] = ACTIONS(12486),
    [anon_sym_end] = ACTIONS(5674),
    [anon_sym_elsif] = ACTIONS(5674),
    [anon_sym_else] = ACTIONS(5674),
    [sym_comment] = ACTIONS(87),
  },
  [7386] = {
    [sym__line_break] = ACTIONS(5686),
    [sym__heredoc_body_start] = ACTIONS(5686),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(5686),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_elsif] = ACTIONS(5686),
    [anon_sym_else] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(7796),
    [anon_sym_or] = ACTIONS(7796),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7387] = {
    [sym__line_break] = ACTIONS(5688),
    [sym__heredoc_body_start] = ACTIONS(5688),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(5688),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_elsif] = ACTIONS(5688),
    [anon_sym_else] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(7796),
    [anon_sym_or] = ACTIONS(7796),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7388] = {
    [sym__line_break] = ACTIONS(5690),
    [sym__heredoc_body_start] = ACTIONS(5690),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(5690),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_elsif] = ACTIONS(5690),
    [anon_sym_else] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(7796),
    [anon_sym_or] = ACTIONS(7796),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7389] = {
    [sym__line_break] = ACTIONS(5692),
    [sym__heredoc_body_start] = ACTIONS(5692),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(5692),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_elsif] = ACTIONS(5692),
    [anon_sym_else] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(7796),
    [anon_sym_or] = ACTIONS(7796),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7390] = {
    [sym__line_break] = ACTIONS(5694),
    [sym__heredoc_body_start] = ACTIONS(5694),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(5694),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_elsif] = ACTIONS(5694),
    [anon_sym_else] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(7796),
    [anon_sym_or] = ACTIONS(7796),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7391] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7392] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7393] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7394] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7395] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7396] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12489),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7397] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_elsif] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7398] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7399] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7400] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7401] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9119),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(9119),
    [sym_operator_assignment] = STATE(9119),
    [sym_conditional] = STATE(9119),
    [sym_range] = STATE(9119),
    [sym_binary] = STATE(9119),
    [sym_unary] = STATE(9119),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7402] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5037),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(5039),
    [sym__argument] = STATE(5040),
    [sym_splat_argument] = STATE(5040),
    [sym_hash_splat_argument] = STATE(5040),
    [sym_block_argument] = STATE(5040),
    [sym_assignment] = STATE(5037),
    [sym_operator_assignment] = STATE(5037),
    [sym_conditional] = STATE(5037),
    [sym_range] = STATE(5037),
    [sym_binary] = STATE(5037),
    [sym_unary] = STATE(5037),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5043),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5040),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(7808),
    [sym__splat_star] = ACTIONS(7810),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7814),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7832),
    [sym_identifier] = ACTIONS(7832),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7403] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5037),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(5039),
    [sym__argument] = STATE(5040),
    [sym_splat_argument] = STATE(5040),
    [sym_hash_splat_argument] = STATE(5040),
    [sym_block_argument] = STATE(5040),
    [sym_assignment] = STATE(5037),
    [sym_operator_assignment] = STATE(5037),
    [sym_conditional] = STATE(5037),
    [sym_range] = STATE(5037),
    [sym_binary] = STATE(5037),
    [sym_unary] = STATE(5037),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5043),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5040),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(7808),
    [sym__splat_star] = ACTIONS(7810),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7814),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7832),
    [sym_identifier] = ACTIONS(7832),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7404] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5037),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(5039),
    [sym__argument] = STATE(5040),
    [sym_splat_argument] = STATE(5040),
    [sym_hash_splat_argument] = STATE(5040),
    [sym_block_argument] = STATE(5040),
    [sym_assignment] = STATE(5037),
    [sym_operator_assignment] = STATE(5037),
    [sym_conditional] = STATE(5037),
    [sym_range] = STATE(5037),
    [sym_binary] = STATE(5037),
    [sym_unary] = STATE(5037),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5043),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5040),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(7808),
    [sym__splat_star] = ACTIONS(7810),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7814),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7832),
    [sym_identifier] = ACTIONS(7832),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7405] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5037),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(5039),
    [sym__argument] = STATE(5040),
    [sym_splat_argument] = STATE(5040),
    [sym_hash_splat_argument] = STATE(5040),
    [sym_block_argument] = STATE(5040),
    [sym_assignment] = STATE(5037),
    [sym_operator_assignment] = STATE(5037),
    [sym_conditional] = STATE(5037),
    [sym_range] = STATE(5037),
    [sym_binary] = STATE(5037),
    [sym_unary] = STATE(5037),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5043),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5040),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(7808),
    [sym__splat_star] = ACTIONS(7810),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7814),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7832),
    [sym_identifier] = ACTIONS(7832),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7406] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9120),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(9120),
    [sym_operator_assignment] = STATE(9120),
    [sym_conditional] = STATE(9120),
    [sym_range] = STATE(9120),
    [sym_binary] = STATE(9120),
    [sym_unary] = STATE(9120),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7407] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7408] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_elsif] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [7409] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5037),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(5039),
    [sym__argument] = STATE(5040),
    [sym_splat_argument] = STATE(5040),
    [sym_hash_splat_argument] = STATE(5040),
    [sym_block_argument] = STATE(5040),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(5037),
    [sym_operator_assignment] = STATE(5037),
    [sym_conditional] = STATE(5037),
    [sym_range] = STATE(5037),
    [sym_binary] = STATE(5037),
    [sym_unary] = STATE(5037),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5043),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5040),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(7808),
    [sym__splat_star] = ACTIONS(7810),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(7814),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_elsif] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7828),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7832),
    [sym_identifier] = ACTIONS(7832),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7410] = {
    [anon_sym_EQ] = ACTIONS(12519),
    [sym_comment] = ACTIONS(87),
  },
  [7411] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12521),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12523),
    [anon_sym_DASH_EQ] = ACTIONS(12523),
    [anon_sym_STAR_EQ] = ACTIONS(12523),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12523),
    [anon_sym_SLASH_EQ] = ACTIONS(12523),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12523),
    [anon_sym_PIPE_EQ] = ACTIONS(12523),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12523),
    [anon_sym_AMP_EQ] = ACTIONS(12523),
    [anon_sym_PERCENT_EQ] = ACTIONS(12523),
    [anon_sym_GT_GT_EQ] = ACTIONS(12523),
    [anon_sym_LT_LT_EQ] = ACTIONS(12523),
    [anon_sym_CARET_EQ] = ACTIONS(12523),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7412] = {
    [sym_string] = STATE(9133),
    [aux_sym_chained_string_repeat1] = STATE(9133),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7413] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_elsif] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [7414] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [7415] = {
    [sym_string] = STATE(7435),
    [aux_sym_chained_string_repeat1] = STATE(7435),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7416] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9134),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(9134),
    [sym_operator_assignment] = STATE(9134),
    [sym_conditional] = STATE(9134),
    [sym_range] = STATE(9134),
    [sym_binary] = STATE(9134),
    [sym_unary] = STATE(9134),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7417] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_elsif] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [7418] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [7419] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9135),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(9135),
    [sym_operator_assignment] = STATE(9135),
    [sym_conditional] = STATE(9135),
    [sym_range] = STATE(9135),
    [sym_binary] = STATE(9135),
    [sym_unary] = STATE(9135),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7420] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9136),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9136),
    [sym_operator_assignment] = STATE(9136),
    [sym_conditional] = STATE(9136),
    [sym_range] = STATE(9136),
    [sym_binary] = STATE(9136),
    [sym_unary] = STATE(9136),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7421] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9137),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9137),
    [sym_operator_assignment] = STATE(9137),
    [sym_conditional] = STATE(9137),
    [sym_range] = STATE(9137),
    [sym_binary] = STATE(9137),
    [sym_unary] = STATE(9137),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7422] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9138),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9138),
    [sym_operator_assignment] = STATE(9138),
    [sym_conditional] = STATE(9138),
    [sym_range] = STATE(9138),
    [sym_binary] = STATE(9138),
    [sym_unary] = STATE(9138),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7423] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9139),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9139),
    [sym_operator_assignment] = STATE(9139),
    [sym_conditional] = STATE(9139),
    [sym_range] = STATE(9139),
    [sym_binary] = STATE(9139),
    [sym_unary] = STATE(9139),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7424] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9140),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9140),
    [sym_operator_assignment] = STATE(9140),
    [sym_conditional] = STATE(9140),
    [sym_range] = STATE(9140),
    [sym_binary] = STATE(9140),
    [sym_unary] = STATE(9140),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7425] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9141),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9141),
    [sym_operator_assignment] = STATE(9141),
    [sym_conditional] = STATE(9141),
    [sym_range] = STATE(9141),
    [sym_binary] = STATE(9141),
    [sym_unary] = STATE(9141),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7426] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9142),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9142),
    [sym_operator_assignment] = STATE(9142),
    [sym_conditional] = STATE(9142),
    [sym_range] = STATE(9142),
    [sym_binary] = STATE(9142),
    [sym_unary] = STATE(9142),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7427] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9143),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9143),
    [sym_operator_assignment] = STATE(9143),
    [sym_conditional] = STATE(9143),
    [sym_range] = STATE(9143),
    [sym_binary] = STATE(9143),
    [sym_unary] = STATE(9143),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7428] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9144),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9144),
    [sym_operator_assignment] = STATE(9144),
    [sym_conditional] = STATE(9144),
    [sym_range] = STATE(9144),
    [sym_binary] = STATE(9144),
    [sym_unary] = STATE(9144),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7429] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9145),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9145),
    [sym_operator_assignment] = STATE(9145),
    [sym_conditional] = STATE(9145),
    [sym_range] = STATE(9145),
    [sym_binary] = STATE(9145),
    [sym_unary] = STATE(9145),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7430] = {
    [sym_heredoc_body] = STATE(9146),
    [aux_sym_call_repeat1] = STATE(9146),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_elsif] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [7431] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5037),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(5037),
    [sym_operator_assignment] = STATE(5037),
    [sym_conditional] = STATE(5037),
    [sym_range] = STATE(5037),
    [sym_binary] = STATE(5037),
    [sym_unary] = STATE(5037),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5043),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(9147),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(7808),
    [sym__splat_star] = ACTIONS(7810),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__identifier_hash_key] = ACTIONS(7814),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12525),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7832),
    [sym_identifier] = ACTIONS(7832),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7432] = {
    [sym_heredoc_body] = STATE(9148),
    [aux_sym_call_repeat1] = STATE(9148),
    [aux_sym_argument_list_repeat1] = STATE(9149),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10753),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_elsif] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [7433] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9150),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_splat_argument] = STATE(9151),
    [sym_assignment] = STATE(9150),
    [sym_operator_assignment] = STATE(9150),
    [sym_conditional] = STATE(9150),
    [sym_range] = STATE(9150),
    [sym_binary] = STATE(9150),
    [sym_unary] = STATE(9150),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(9151),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(10671),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7434] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9152),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(9152),
    [sym_operator_assignment] = STATE(9152),
    [sym_conditional] = STATE(9152),
    [sym_range] = STATE(9152),
    [sym_binary] = STATE(9152),
    [sym_unary] = STATE(9152),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7435] = {
    [sym_string] = STATE(9153),
    [aux_sym_chained_string_repeat1] = STATE(9153),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_elsif] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [7436] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9154),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(9154),
    [sym_operator_assignment] = STATE(9154),
    [sym_conditional] = STATE(9154),
    [sym_range] = STATE(9154),
    [sym_binary] = STATE(9154),
    [sym_unary] = STATE(9154),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7437] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9155),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(9155),
    [sym_operator_assignment] = STATE(9155),
    [sym_conditional] = STATE(9155),
    [sym_range] = STATE(9155),
    [sym_binary] = STATE(9155),
    [sym_unary] = STATE(9155),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7438] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9156),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(9156),
    [sym_operator_assignment] = STATE(9156),
    [sym_conditional] = STATE(9156),
    [sym_range] = STATE(9156),
    [sym_binary] = STATE(9156),
    [sym_unary] = STATE(9156),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7439] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7440] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(12531),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(12533),
    [anon_sym_LT] = ACTIONS(12535),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_elsif] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(12537),
    [anon_sym_DOT_DOT] = ACTIONS(12539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12541),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(12543),
    [anon_sym_AMP_AMP] = ACTIONS(12543),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(12547),
    [anon_sym_BANG_EQ] = ACTIONS(12543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12543),
    [anon_sym_LT_EQ_GT] = ACTIONS(12543),
    [anon_sym_EQ_TILDE] = ACTIONS(12543),
    [anon_sym_BANG_TILDE] = ACTIONS(12543),
    [anon_sym_LT_EQ] = ACTIONS(12535),
    [anon_sym_GT] = ACTIONS(12535),
    [anon_sym_GT_EQ] = ACTIONS(12549),
    [anon_sym_CARET] = ACTIONS(12551),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [7441] = {
    [aux_sym_exceptions_repeat1] = STATE(9168),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(12553),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_elsif] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7442] = {
    [anon_sym_EQ] = ACTIONS(12555),
    [sym_comment] = ACTIONS(87),
  },
  [7443] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12559),
    [anon_sym_DASH_EQ] = ACTIONS(12559),
    [anon_sym_STAR_EQ] = ACTIONS(12559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12559),
    [anon_sym_SLASH_EQ] = ACTIONS(12559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12559),
    [anon_sym_PIPE_EQ] = ACTIONS(12559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12559),
    [anon_sym_AMP_EQ] = ACTIONS(12559),
    [anon_sym_PERCENT_EQ] = ACTIONS(12559),
    [anon_sym_GT_GT_EQ] = ACTIONS(12559),
    [anon_sym_LT_LT_EQ] = ACTIONS(12559),
    [anon_sym_CARET_EQ] = ACTIONS(12559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7444] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_elsif] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [7445] = {
    [sym_string] = STATE(7445),
    [aux_sym_chained_string_repeat1] = STATE(7445),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_elsif] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7446] = {
    [anon_sym_end] = ACTIONS(12561),
    [sym_comment] = ACTIONS(87),
  },
  [7447] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(1759),
    [sym__binary_star] = ACTIONS(1761),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(1769),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_EQ_EQ] = ACTIONS(1781),
    [anon_sym_BANG_EQ] = ACTIONS(1777),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1777),
    [anon_sym_LT_EQ_GT] = ACTIONS(1777),
    [anon_sym_EQ_TILDE] = ACTIONS(1777),
    [anon_sym_BANG_TILDE] = ACTIONS(1777),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_GT_EQ] = ACTIONS(1783),
    [anon_sym_CARET] = ACTIONS(1785),
    [anon_sym_PLUS] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1761),
    [sym_comment] = ACTIONS(87),
  },
  [7448] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [7449] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [7450] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [7451] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [7452] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [7453] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12563),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7454] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [7455] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7864),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [7456] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [7457] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [7458] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(7864),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [7459] = {
    [aux_sym_exceptions_repeat1] = STATE(9174),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [7460] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7864),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [7461] = {
    [sym_string] = STATE(7461),
    [aux_sym_chained_string_repeat1] = STATE(7461),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [7462] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9175),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_assignment] = STATE(9175),
    [sym_operator_assignment] = STATE(9175),
    [sym_conditional] = STATE(9175),
    [sym_range] = STATE(9175),
    [sym_binary] = STATE(9175),
    [sym_unary] = STATE(9175),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7463] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5080),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1007),
    [sym_scope_resolution] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_method_call] = STATE(1007),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(5080),
    [sym_operator_assignment] = STATE(5080),
    [sym_conditional] = STATE(5080),
    [sym_range] = STATE(5080),
    [sym_binary] = STATE(5080),
    [sym_unary] = STATE(5080),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(1006),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1007),
    [sym__variable] = STATE(1003),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_nil] = STATE(1007),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2663),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(4314),
    [sym__unary_minus] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1795),
    [anon_sym_yield] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_next] = ACTIONS(1801),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4394),
    [anon_sym_defined_QMARK] = ACTIONS(1803),
    [anon_sym_not] = ACTIONS(1805),
    [anon_sym_BANG] = ACTIONS(1809),
    [anon_sym_TILDE] = ACTIONS(1809),
    [sym_constant] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1815),
    [sym_instance_variable] = ACTIONS(1813),
    [sym_class_variable] = ACTIONS(1813),
    [sym_global_variable] = ACTIONS(1813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1815),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7464] = {
    [aux_sym_exceptions_repeat1] = STATE(9176),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12565),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [7465] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [7466] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7467] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(7894),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [7468] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [7469] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7892),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(7894),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7912),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [7470] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12567),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7471] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(7892),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(7894),
    [anon_sym_LT] = ACTIONS(7896),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7902),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7904),
    [anon_sym_AMP_AMP] = ACTIONS(7904),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(7908),
    [anon_sym_BANG_EQ] = ACTIONS(7904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7904),
    [anon_sym_LT_EQ_GT] = ACTIONS(7904),
    [anon_sym_EQ_TILDE] = ACTIONS(7904),
    [anon_sym_BANG_TILDE] = ACTIONS(7904),
    [anon_sym_LT_EQ] = ACTIONS(7896),
    [anon_sym_GT] = ACTIONS(7896),
    [anon_sym_GT_EQ] = ACTIONS(7910),
    [anon_sym_CARET] = ACTIONS(7912),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [7472] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7892),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(7894),
    [anon_sym_LT] = ACTIONS(7896),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7898),
    [anon_sym_DOT_DOT] = ACTIONS(7900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7902),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7904),
    [anon_sym_AMP_AMP] = ACTIONS(7904),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(7908),
    [anon_sym_BANG_EQ] = ACTIONS(7904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7904),
    [anon_sym_LT_EQ_GT] = ACTIONS(7904),
    [anon_sym_EQ_TILDE] = ACTIONS(7904),
    [anon_sym_BANG_TILDE] = ACTIONS(7904),
    [anon_sym_LT_EQ] = ACTIONS(7896),
    [anon_sym_GT] = ACTIONS(7896),
    [anon_sym_GT_EQ] = ACTIONS(7910),
    [anon_sym_CARET] = ACTIONS(7912),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [7473] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(7892),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(7894),
    [anon_sym_LT] = ACTIONS(7896),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(7908),
    [anon_sym_BANG_EQ] = ACTIONS(7904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7904),
    [anon_sym_LT_EQ_GT] = ACTIONS(7904),
    [anon_sym_EQ_TILDE] = ACTIONS(7904),
    [anon_sym_BANG_TILDE] = ACTIONS(7904),
    [anon_sym_LT_EQ] = ACTIONS(7896),
    [anon_sym_GT] = ACTIONS(7896),
    [anon_sym_GT_EQ] = ACTIONS(7910),
    [anon_sym_CARET] = ACTIONS(7912),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [7474] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [7475] = {
    [aux_sym_exceptions_repeat1] = STATE(7475),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(12569),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [7476] = {
    [aux_sym_exceptions_repeat1] = STATE(5098),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7477] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(7892),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(7894),
    [anon_sym_LT] = ACTIONS(7896),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7898),
    [anon_sym_DOT_DOT] = ACTIONS(7900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7902),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7904),
    [anon_sym_AMP_AMP] = ACTIONS(7904),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(7908),
    [anon_sym_BANG_EQ] = ACTIONS(7904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7904),
    [anon_sym_LT_EQ_GT] = ACTIONS(7904),
    [anon_sym_EQ_TILDE] = ACTIONS(7904),
    [anon_sym_BANG_TILDE] = ACTIONS(7904),
    [anon_sym_LT_EQ] = ACTIONS(7896),
    [anon_sym_GT] = ACTIONS(7896),
    [anon_sym_GT_EQ] = ACTIONS(7910),
    [anon_sym_CARET] = ACTIONS(7912),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [7478] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9178),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(9178),
    [sym_operator_assignment] = STATE(9178),
    [sym_conditional] = STATE(9178),
    [sym_range] = STATE(9178),
    [sym_binary] = STATE(9178),
    [sym_unary] = STATE(9178),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7479] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(9179),
    [sym__argument] = STATE(9180),
    [sym_splat_argument] = STATE(9180),
    [sym_hash_splat_argument] = STATE(9180),
    [sym_block_argument] = STATE(9180),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5120),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9180),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7926),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(7932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7950),
    [sym_identifier] = ACTIONS(7950),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7480] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(9179),
    [sym__argument] = STATE(9180),
    [sym_splat_argument] = STATE(9180),
    [sym_hash_splat_argument] = STATE(9180),
    [sym_block_argument] = STATE(9180),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5120),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9180),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7926),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(7932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7950),
    [sym_identifier] = ACTIONS(7950),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7481] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(9179),
    [sym__argument] = STATE(9180),
    [sym_splat_argument] = STATE(9180),
    [sym_hash_splat_argument] = STATE(9180),
    [sym_block_argument] = STATE(9180),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5120),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9180),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7926),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(7932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7950),
    [sym_identifier] = ACTIONS(7950),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7482] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(9179),
    [sym__argument] = STATE(9180),
    [sym_splat_argument] = STATE(9180),
    [sym_hash_splat_argument] = STATE(9180),
    [sym_block_argument] = STATE(9180),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5120),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9180),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7926),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(7932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7946),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7950),
    [sym_identifier] = ACTIONS(7950),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7483] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9181),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(9181),
    [sym_operator_assignment] = STATE(9181),
    [sym_conditional] = STATE(9181),
    [sym_range] = STATE(9181),
    [sym_binary] = STATE(9181),
    [sym_unary] = STATE(9181),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7484] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7485] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(12582),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [7486] = {
    [anon_sym_EQ] = ACTIONS(12598),
    [sym_comment] = ACTIONS(87),
  },
  [7487] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12600),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12602),
    [anon_sym_DASH_EQ] = ACTIONS(12602),
    [anon_sym_STAR_EQ] = ACTIONS(12602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12602),
    [anon_sym_SLASH_EQ] = ACTIONS(12602),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12602),
    [anon_sym_PIPE_EQ] = ACTIONS(12602),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12602),
    [anon_sym_AMP_EQ] = ACTIONS(12602),
    [anon_sym_PERCENT_EQ] = ACTIONS(12602),
    [anon_sym_GT_GT_EQ] = ACTIONS(12602),
    [anon_sym_LT_LT_EQ] = ACTIONS(12602),
    [anon_sym_CARET_EQ] = ACTIONS(12602),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7488] = {
    [sym_string] = STATE(9194),
    [aux_sym_chained_string_repeat1] = STATE(9194),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7489] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(12582),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [7490] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [7491] = {
    [sym_string] = STATE(7529),
    [aux_sym_chained_string_repeat1] = STATE(7529),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7492] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9195),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(9195),
    [sym_operator_assignment] = STATE(9195),
    [sym_conditional] = STATE(9195),
    [sym_range] = STATE(9195),
    [sym_binary] = STATE(9195),
    [sym_unary] = STATE(9195),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7493] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(12582),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [7494] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9196),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9196),
    [sym_operator_assignment] = STATE(9196),
    [sym_conditional] = STATE(9196),
    [sym_range] = STATE(9196),
    [sym_binary] = STATE(9196),
    [sym_unary] = STATE(9196),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7495] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9197),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9197),
    [sym_operator_assignment] = STATE(9197),
    [sym_conditional] = STATE(9197),
    [sym_range] = STATE(9197),
    [sym_binary] = STATE(9197),
    [sym_unary] = STATE(9197),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7496] = {
    [anon_sym_COLON] = ACTIONS(12604),
    [sym_comment] = ACTIONS(87),
  },
  [7497] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9199),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9199),
    [sym_operator_assignment] = STATE(9199),
    [sym_conditional] = STATE(9199),
    [sym_range] = STATE(9199),
    [sym_binary] = STATE(9199),
    [sym_unary] = STATE(9199),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7498] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12606),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [7499] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [7500] = {
    [sym_heredoc_body] = STATE(9201),
    [aux_sym_call_repeat1] = STATE(9201),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [7501] = {
    [sym_heredoc_body] = STATE(9201),
    [aux_sym_call_repeat1] = STATE(9201),
    [aux_sym_argument_list_repeat1] = STATE(9203),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(12608),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [7502] = {
    [sym_string] = STATE(7529),
    [aux_sym_chained_string_repeat1] = STATE(7529),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12610),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7503] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [7504] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9204),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(9204),
    [sym_operator_assignment] = STATE(9204),
    [sym_conditional] = STATE(9204),
    [sym_range] = STATE(9204),
    [sym_binary] = STATE(9204),
    [sym_unary] = STATE(9204),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7505] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9205),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9205),
    [sym_operator_assignment] = STATE(9205),
    [sym_conditional] = STATE(9205),
    [sym_range] = STATE(9205),
    [sym_binary] = STATE(9205),
    [sym_unary] = STATE(9205),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7506] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9206),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9206),
    [sym_operator_assignment] = STATE(9206),
    [sym_conditional] = STATE(9206),
    [sym_range] = STATE(9206),
    [sym_binary] = STATE(9206),
    [sym_unary] = STATE(9206),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7507] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9207),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9207),
    [sym_operator_assignment] = STATE(9207),
    [sym_conditional] = STATE(9207),
    [sym_range] = STATE(9207),
    [sym_binary] = STATE(9207),
    [sym_unary] = STATE(9207),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7508] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9208),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9208),
    [sym_operator_assignment] = STATE(9208),
    [sym_conditional] = STATE(9208),
    [sym_range] = STATE(9208),
    [sym_binary] = STATE(9208),
    [sym_unary] = STATE(9208),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7509] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9209),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9209),
    [sym_operator_assignment] = STATE(9209),
    [sym_conditional] = STATE(9209),
    [sym_range] = STATE(9209),
    [sym_binary] = STATE(9209),
    [sym_unary] = STATE(9209),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7510] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9210),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9210),
    [sym_operator_assignment] = STATE(9210),
    [sym_conditional] = STATE(9210),
    [sym_range] = STATE(9210),
    [sym_binary] = STATE(9210),
    [sym_unary] = STATE(9210),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7511] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9211),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9211),
    [sym_operator_assignment] = STATE(9211),
    [sym_conditional] = STATE(9211),
    [sym_range] = STATE(9211),
    [sym_binary] = STATE(9211),
    [sym_unary] = STATE(9211),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7512] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9212),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9212),
    [sym_operator_assignment] = STATE(9212),
    [sym_conditional] = STATE(9212),
    [sym_range] = STATE(9212),
    [sym_binary] = STATE(9212),
    [sym_unary] = STATE(9212),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7513] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9213),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9213),
    [sym_operator_assignment] = STATE(9213),
    [sym_conditional] = STATE(9213),
    [sym_range] = STATE(9213),
    [sym_binary] = STATE(9213),
    [sym_unary] = STATE(9213),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7514] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9214),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9214),
    [sym_operator_assignment] = STATE(9214),
    [sym_conditional] = STATE(9214),
    [sym_range] = STATE(9214),
    [sym_binary] = STATE(9214),
    [sym_unary] = STATE(9214),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7515] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9215),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9215),
    [sym_operator_assignment] = STATE(9215),
    [sym_conditional] = STATE(9215),
    [sym_range] = STATE(9215),
    [sym_binary] = STATE(9215),
    [sym_unary] = STATE(9215),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7516] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9216),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9216),
    [sym_operator_assignment] = STATE(9216),
    [sym_conditional] = STATE(9216),
    [sym_range] = STATE(9216),
    [sym_binary] = STATE(9216),
    [sym_unary] = STATE(9216),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7517] = {
    [anon_sym_COLON] = ACTIONS(12612),
    [sym_comment] = ACTIONS(87),
  },
  [7518] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9218),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9218),
    [sym_operator_assignment] = STATE(9218),
    [sym_conditional] = STATE(9218),
    [sym_range] = STATE(9218),
    [sym_binary] = STATE(9218),
    [sym_unary] = STATE(9218),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7519] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(12614),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [7520] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [7521] = {
    [sym_heredoc_body] = STATE(9220),
    [aux_sym_call_repeat1] = STATE(9220),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [7522] = {
    [sym_heredoc_body] = STATE(9220),
    [aux_sym_call_repeat1] = STATE(9220),
    [aux_sym_argument_list_repeat1] = STATE(9222),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(12616),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [7523] = {
    [sym_string] = STATE(7583),
    [aux_sym_chained_string_repeat1] = STATE(7583),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12618),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7524] = {
    [sym_heredoc_body] = STATE(9223),
    [aux_sym_call_repeat1] = STATE(9223),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7525] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5120),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9224),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7926),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__identifier_hash_key] = ACTIONS(7932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12620),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7950),
    [sym_identifier] = ACTIONS(7950),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7526] = {
    [sym_heredoc_body] = STATE(9225),
    [aux_sym_call_repeat1] = STATE(9225),
    [aux_sym_argument_list_repeat1] = STATE(9226),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10846),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7527] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9227),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_splat_argument] = STATE(9228),
    [sym_assignment] = STATE(9227),
    [sym_operator_assignment] = STATE(9227),
    [sym_conditional] = STATE(9227),
    [sym_range] = STATE(9227),
    [sym_binary] = STATE(9227),
    [sym_unary] = STATE(9227),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(9228),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(10804),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7528] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9229),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(9229),
    [sym_operator_assignment] = STATE(9229),
    [sym_conditional] = STATE(9229),
    [sym_range] = STATE(9229),
    [sym_binary] = STATE(9229),
    [sym_unary] = STATE(9229),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7529] = {
    [sym_string] = STATE(9230),
    [aux_sym_chained_string_repeat1] = STATE(9230),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [7530] = {
    [aux_sym_undef_repeat1] = STATE(9231),
    [sym__line_break] = ACTIONS(5356),
    [sym__heredoc_body_start] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym_end] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [anon_sym_else] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [7531] = {
    [sym__line_break] = ACTIONS(12622),
    [sym__heredoc_body_start] = ACTIONS(12622),
    [sym__binary_minus] = ACTIONS(12622),
    [sym__binary_star] = ACTIONS(12622),
    [ts_builtin_sym_end] = ACTIONS(12622),
    [anon_sym___END__] = ACTIONS(12622),
    [anon_sym_LBRACE] = ACTIONS(12622),
    [anon_sym_RBRACE] = ACTIONS(12622),
    [anon_sym_RPAREN] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12624),
    [anon_sym_COMMA] = ACTIONS(12622),
    [anon_sym_PIPE] = ACTIONS(12624),
    [anon_sym_SEMI] = ACTIONS(12622),
    [anon_sym_STAR_STAR] = ACTIONS(12622),
    [anon_sym_AMP] = ACTIONS(12624),
    [anon_sym_LT] = ACTIONS(12624),
    [anon_sym_end] = ACTIONS(12622),
    [anon_sym_if] = ACTIONS(12622),
    [anon_sym_unless] = ACTIONS(12622),
    [anon_sym_while] = ACTIONS(12622),
    [anon_sym_until] = ACTIONS(12622),
    [anon_sym_rescue] = ACTIONS(12622),
    [anon_sym_do] = ACTIONS(12622),
    [anon_sym_when] = ACTIONS(12622),
    [anon_sym_elsif] = ACTIONS(12622),
    [anon_sym_else] = ACTIONS(12622),
    [anon_sym_then] = ACTIONS(12622),
    [anon_sym_ensure] = ACTIONS(12622),
    [anon_sym_EQ_GT] = ACTIONS(12622),
    [anon_sym_LBRACK] = ACTIONS(12622),
    [anon_sym_COLON_COLON2] = ACTIONS(12622),
    [anon_sym_AMP_DOT] = ACTIONS(12622),
    [anon_sym_QMARK] = ACTIONS(12622),
    [anon_sym_DOT_DOT] = ACTIONS(12624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12622),
    [anon_sym_and] = ACTIONS(12622),
    [anon_sym_or] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE] = ACTIONS(12622),
    [anon_sym_AMP_AMP] = ACTIONS(12622),
    [anon_sym_LT_LT] = ACTIONS(12622),
    [anon_sym_GT_GT] = ACTIONS(12622),
    [anon_sym_EQ_EQ] = ACTIONS(12624),
    [anon_sym_BANG_EQ] = ACTIONS(12622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12622),
    [anon_sym_LT_EQ_GT] = ACTIONS(12622),
    [anon_sym_EQ_TILDE] = ACTIONS(12622),
    [anon_sym_BANG_TILDE] = ACTIONS(12622),
    [anon_sym_LT_EQ] = ACTIONS(12624),
    [anon_sym_GT] = ACTIONS(12624),
    [anon_sym_GT_EQ] = ACTIONS(12622),
    [anon_sym_CARET] = ACTIONS(12622),
    [anon_sym_PLUS] = ACTIONS(12622),
    [anon_sym_SLASH] = ACTIONS(12622),
    [anon_sym_PERCENT] = ACTIONS(12622),
    [sym_comment] = ACTIONS(87),
  },
  [7532] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5678),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(5678),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7533] = {
    [sym_heredoc_body] = STATE(9232),
    [sym__terminator] = STATE(9232),
    [aux_sym__statements_repeat1] = STATE(7533),
    [sym__line_break] = ACTIONS(12626),
    [sym__heredoc_body_start] = ACTIONS(5683),
    [anon_sym_SEMI] = ACTIONS(12626),
    [anon_sym_end] = ACTIONS(5674),
    [anon_sym_else] = ACTIONS(5674),
    [sym_comment] = ACTIONS(87),
  },
  [7534] = {
    [sym__line_break] = ACTIONS(5686),
    [sym__heredoc_body_start] = ACTIONS(5686),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(5686),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_else] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(7988),
    [anon_sym_or] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7535] = {
    [sym__line_break] = ACTIONS(5688),
    [sym__heredoc_body_start] = ACTIONS(5688),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(5688),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_else] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(7988),
    [anon_sym_or] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7536] = {
    [sym__line_break] = ACTIONS(5690),
    [sym__heredoc_body_start] = ACTIONS(5690),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(5690),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_else] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(7988),
    [anon_sym_or] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7537] = {
    [sym__line_break] = ACTIONS(5692),
    [sym__heredoc_body_start] = ACTIONS(5692),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(5692),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_else] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(7988),
    [anon_sym_or] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7538] = {
    [sym__line_break] = ACTIONS(5694),
    [sym__heredoc_body_start] = ACTIONS(5694),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(5694),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_else] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(7988),
    [anon_sym_or] = ACTIONS(7988),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7539] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7540] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7541] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7542] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7543] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7544] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12629),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7545] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7546] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7547] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7548] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7549] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9234),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(9234),
    [sym_operator_assignment] = STATE(9234),
    [sym_conditional] = STATE(9234),
    [sym_range] = STATE(9234),
    [sym_binary] = STATE(9234),
    [sym_unary] = STATE(9234),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7550] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5154),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(5156),
    [sym__argument] = STATE(5157),
    [sym_splat_argument] = STATE(5157),
    [sym_hash_splat_argument] = STATE(5157),
    [sym_block_argument] = STATE(5157),
    [sym_assignment] = STATE(5154),
    [sym_operator_assignment] = STATE(5154),
    [sym_conditional] = STATE(5154),
    [sym_range] = STATE(5154),
    [sym_binary] = STATE(5154),
    [sym_unary] = STATE(5154),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5160),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5157),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8000),
    [sym__splat_star] = ACTIONS(8002),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(8006),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8024),
    [sym_identifier] = ACTIONS(8024),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7551] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5154),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(5156),
    [sym__argument] = STATE(5157),
    [sym_splat_argument] = STATE(5157),
    [sym_hash_splat_argument] = STATE(5157),
    [sym_block_argument] = STATE(5157),
    [sym_assignment] = STATE(5154),
    [sym_operator_assignment] = STATE(5154),
    [sym_conditional] = STATE(5154),
    [sym_range] = STATE(5154),
    [sym_binary] = STATE(5154),
    [sym_unary] = STATE(5154),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5160),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5157),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8000),
    [sym__splat_star] = ACTIONS(8002),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(8006),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8024),
    [sym_identifier] = ACTIONS(8024),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7552] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5154),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(5156),
    [sym__argument] = STATE(5157),
    [sym_splat_argument] = STATE(5157),
    [sym_hash_splat_argument] = STATE(5157),
    [sym_block_argument] = STATE(5157),
    [sym_assignment] = STATE(5154),
    [sym_operator_assignment] = STATE(5154),
    [sym_conditional] = STATE(5154),
    [sym_range] = STATE(5154),
    [sym_binary] = STATE(5154),
    [sym_unary] = STATE(5154),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5160),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5157),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8000),
    [sym__splat_star] = ACTIONS(8002),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(8006),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8024),
    [sym_identifier] = ACTIONS(8024),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7553] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5154),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(5156),
    [sym__argument] = STATE(5157),
    [sym_splat_argument] = STATE(5157),
    [sym_hash_splat_argument] = STATE(5157),
    [sym_block_argument] = STATE(5157),
    [sym_assignment] = STATE(5154),
    [sym_operator_assignment] = STATE(5154),
    [sym_conditional] = STATE(5154),
    [sym_range] = STATE(5154),
    [sym_binary] = STATE(5154),
    [sym_unary] = STATE(5154),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5160),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5157),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8000),
    [sym__splat_star] = ACTIONS(8002),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(8006),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8024),
    [sym_identifier] = ACTIONS(8024),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7554] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9235),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(9235),
    [sym_operator_assignment] = STATE(9235),
    [sym_conditional] = STATE(9235),
    [sym_range] = STATE(9235),
    [sym_binary] = STATE(9235),
    [sym_unary] = STATE(9235),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7555] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7556] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(12643),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [7557] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5154),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(5156),
    [sym__argument] = STATE(5157),
    [sym_splat_argument] = STATE(5157),
    [sym_hash_splat_argument] = STATE(5157),
    [sym_block_argument] = STATE(5157),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(5154),
    [sym_operator_assignment] = STATE(5154),
    [sym_conditional] = STATE(5154),
    [sym_range] = STATE(5154),
    [sym_binary] = STATE(5154),
    [sym_unary] = STATE(5154),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5160),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5157),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8000),
    [sym__splat_star] = ACTIONS(8002),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(8006),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8020),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8024),
    [sym_identifier] = ACTIONS(8024),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7558] = {
    [anon_sym_EQ] = ACTIONS(12659),
    [sym_comment] = ACTIONS(87),
  },
  [7559] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12661),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12663),
    [anon_sym_DASH_EQ] = ACTIONS(12663),
    [anon_sym_STAR_EQ] = ACTIONS(12663),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12663),
    [anon_sym_SLASH_EQ] = ACTIONS(12663),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12663),
    [anon_sym_PIPE_EQ] = ACTIONS(12663),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12663),
    [anon_sym_AMP_EQ] = ACTIONS(12663),
    [anon_sym_PERCENT_EQ] = ACTIONS(12663),
    [anon_sym_GT_GT_EQ] = ACTIONS(12663),
    [anon_sym_LT_LT_EQ] = ACTIONS(12663),
    [anon_sym_CARET_EQ] = ACTIONS(12663),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7560] = {
    [sym_string] = STATE(9248),
    [aux_sym_chained_string_repeat1] = STATE(9248),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7561] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(12643),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [7562] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [7563] = {
    [sym_string] = STATE(7583),
    [aux_sym_chained_string_repeat1] = STATE(7583),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7564] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9249),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(9249),
    [sym_operator_assignment] = STATE(9249),
    [sym_conditional] = STATE(9249),
    [sym_range] = STATE(9249),
    [sym_binary] = STATE(9249),
    [sym_unary] = STATE(9249),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7565] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(12643),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [7566] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [7567] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9250),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(9250),
    [sym_operator_assignment] = STATE(9250),
    [sym_conditional] = STATE(9250),
    [sym_range] = STATE(9250),
    [sym_binary] = STATE(9250),
    [sym_unary] = STATE(9250),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7568] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9251),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9251),
    [sym_operator_assignment] = STATE(9251),
    [sym_conditional] = STATE(9251),
    [sym_range] = STATE(9251),
    [sym_binary] = STATE(9251),
    [sym_unary] = STATE(9251),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7569] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9252),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9252),
    [sym_operator_assignment] = STATE(9252),
    [sym_conditional] = STATE(9252),
    [sym_range] = STATE(9252),
    [sym_binary] = STATE(9252),
    [sym_unary] = STATE(9252),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7570] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9253),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9253),
    [sym_operator_assignment] = STATE(9253),
    [sym_conditional] = STATE(9253),
    [sym_range] = STATE(9253),
    [sym_binary] = STATE(9253),
    [sym_unary] = STATE(9253),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7571] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9254),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9254),
    [sym_operator_assignment] = STATE(9254),
    [sym_conditional] = STATE(9254),
    [sym_range] = STATE(9254),
    [sym_binary] = STATE(9254),
    [sym_unary] = STATE(9254),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7572] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9255),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9255),
    [sym_operator_assignment] = STATE(9255),
    [sym_conditional] = STATE(9255),
    [sym_range] = STATE(9255),
    [sym_binary] = STATE(9255),
    [sym_unary] = STATE(9255),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7573] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9256),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9256),
    [sym_operator_assignment] = STATE(9256),
    [sym_conditional] = STATE(9256),
    [sym_range] = STATE(9256),
    [sym_binary] = STATE(9256),
    [sym_unary] = STATE(9256),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7574] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9257),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9257),
    [sym_operator_assignment] = STATE(9257),
    [sym_conditional] = STATE(9257),
    [sym_range] = STATE(9257),
    [sym_binary] = STATE(9257),
    [sym_unary] = STATE(9257),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7575] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9258),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9258),
    [sym_operator_assignment] = STATE(9258),
    [sym_conditional] = STATE(9258),
    [sym_range] = STATE(9258),
    [sym_binary] = STATE(9258),
    [sym_unary] = STATE(9258),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7576] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9259),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9259),
    [sym_operator_assignment] = STATE(9259),
    [sym_conditional] = STATE(9259),
    [sym_range] = STATE(9259),
    [sym_binary] = STATE(9259),
    [sym_unary] = STATE(9259),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7577] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9260),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9260),
    [sym_operator_assignment] = STATE(9260),
    [sym_conditional] = STATE(9260),
    [sym_range] = STATE(9260),
    [sym_binary] = STATE(9260),
    [sym_unary] = STATE(9260),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7578] = {
    [sym_heredoc_body] = STATE(9261),
    [aux_sym_call_repeat1] = STATE(9261),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [7579] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5154),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(5154),
    [sym_operator_assignment] = STATE(5154),
    [sym_conditional] = STATE(5154),
    [sym_range] = STATE(5154),
    [sym_binary] = STATE(5154),
    [sym_unary] = STATE(5154),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5160),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(9262),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8000),
    [sym__splat_star] = ACTIONS(8002),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__identifier_hash_key] = ACTIONS(8006),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12665),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8024),
    [sym_identifier] = ACTIONS(8024),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7580] = {
    [sym_heredoc_body] = STATE(9263),
    [aux_sym_call_repeat1] = STATE(9263),
    [aux_sym_argument_list_repeat1] = STATE(9264),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10920),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [7581] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9265),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_splat_argument] = STATE(9266),
    [sym_assignment] = STATE(9265),
    [sym_operator_assignment] = STATE(9265),
    [sym_conditional] = STATE(9265),
    [sym_range] = STATE(9265),
    [sym_binary] = STATE(9265),
    [sym_unary] = STATE(9265),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(9266),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(10840),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7582] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9267),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(9267),
    [sym_operator_assignment] = STATE(9267),
    [sym_conditional] = STATE(9267),
    [sym_range] = STATE(9267),
    [sym_binary] = STATE(9267),
    [sym_unary] = STATE(9267),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7583] = {
    [sym_string] = STATE(9268),
    [aux_sym_chained_string_repeat1] = STATE(9268),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [7584] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9269),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(9269),
    [sym_operator_assignment] = STATE(9269),
    [sym_conditional] = STATE(9269),
    [sym_range] = STATE(9269),
    [sym_binary] = STATE(9269),
    [sym_unary] = STATE(9269),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7585] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9270),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(9270),
    [sym_operator_assignment] = STATE(9270),
    [sym_conditional] = STATE(9270),
    [sym_range] = STATE(9270),
    [sym_binary] = STATE(9270),
    [sym_unary] = STATE(9270),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7586] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9271),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(9271),
    [sym_operator_assignment] = STATE(9271),
    [sym_conditional] = STATE(9271),
    [sym_range] = STATE(9271),
    [sym_binary] = STATE(9271),
    [sym_unary] = STATE(9271),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7587] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7588] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(12671),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(12673),
    [anon_sym_LT] = ACTIONS(12675),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(12677),
    [anon_sym_DOT_DOT] = ACTIONS(12679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12681),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(12683),
    [anon_sym_AMP_AMP] = ACTIONS(12683),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(12687),
    [anon_sym_BANG_EQ] = ACTIONS(12683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12683),
    [anon_sym_LT_EQ_GT] = ACTIONS(12683),
    [anon_sym_EQ_TILDE] = ACTIONS(12683),
    [anon_sym_BANG_TILDE] = ACTIONS(12683),
    [anon_sym_LT_EQ] = ACTIONS(12675),
    [anon_sym_GT] = ACTIONS(12675),
    [anon_sym_GT_EQ] = ACTIONS(12689),
    [anon_sym_CARET] = ACTIONS(12691),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [7589] = {
    [aux_sym_exceptions_repeat1] = STATE(9283),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(12693),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7590] = {
    [anon_sym_EQ] = ACTIONS(12695),
    [sym_comment] = ACTIONS(87),
  },
  [7591] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12697),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12699),
    [anon_sym_DASH_EQ] = ACTIONS(12699),
    [anon_sym_STAR_EQ] = ACTIONS(12699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12699),
    [anon_sym_SLASH_EQ] = ACTIONS(12699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12699),
    [anon_sym_PIPE_EQ] = ACTIONS(12699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12699),
    [anon_sym_AMP_EQ] = ACTIONS(12699),
    [anon_sym_PERCENT_EQ] = ACTIONS(12699),
    [anon_sym_GT_GT_EQ] = ACTIONS(12699),
    [anon_sym_LT_LT_EQ] = ACTIONS(12699),
    [anon_sym_CARET_EQ] = ACTIONS(12699),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7592] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [7593] = {
    [sym_string] = STATE(7593),
    [aux_sym_chained_string_repeat1] = STATE(7593),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7594] = {
    [sym_heredoc_body] = STATE(9286),
    [aux_sym_call_repeat1] = STATE(9286),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7595] = {
    [sym_heredoc_body] = STATE(9287),
    [aux_sym_call_repeat1] = STATE(9287),
    [aux_sym_argument_list_repeat1] = STATE(5213),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4546),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7596] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [7597] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7598] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [7599] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [7600] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [7601] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12701),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7602] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [7603] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8046),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [7604] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [7605] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [7606] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8046),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [7607] = {
    [aux_sym_exceptions_repeat1] = STATE(9290),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7608] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8046),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [7609] = {
    [sym_string] = STATE(7609),
    [aux_sym_chained_string_repeat1] = STATE(7609),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7610] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [7611] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [7612] = {
    [sym_heredoc_body] = STATE(7612),
    [aux_sym_call_repeat1] = STATE(7612),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7613] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2734),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(2734),
    [sym_operator_assignment] = STATE(2734),
    [sym_conditional] = STATE(2734),
    [sym_range] = STATE(2734),
    [sym_binary] = STATE(2734),
    [sym_unary] = STATE(2734),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2737),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4500),
    [sym__splat_star] = ACTIONS(4502),
    [sym__unary_minus] = ACTIONS(1831),
    [sym__identifier_hash_key] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10942),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(4506),
    [sym_identifier] = ACTIONS(4506),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7614] = {
    [sym_heredoc_body] = STATE(7612),
    [aux_sym_call_repeat1] = STATE(7612),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7615] = {
    [aux_sym_argument_list_repeat1] = STATE(7615),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12703),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [7616] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9291),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_assignment] = STATE(9291),
    [sym_operator_assignment] = STATE(9291),
    [sym_conditional] = STATE(9291),
    [sym_range] = STATE(9291),
    [sym_binary] = STATE(9291),
    [sym_unary] = STATE(9291),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7617] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [7618] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [7619] = {
    [sym_heredoc_body] = STATE(7619),
    [aux_sym_call_repeat1] = STATE(7619),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [7620] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(2756),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(2756),
    [sym_operator_assignment] = STATE(2756),
    [sym_conditional] = STATE(2756),
    [sym_range] = STATE(2756),
    [sym_binary] = STATE(2756),
    [sym_unary] = STATE(2756),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2759),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4536),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [sym__identifier_hash_key] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10946),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4544),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7621] = {
    [sym_heredoc_body] = STATE(7619),
    [aux_sym_call_repeat1] = STATE(7619),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [7622] = {
    [aux_sym_argument_list_repeat1] = STATE(7622),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12706),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [7623] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5214),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1032),
    [sym_scope_resolution] = STATE(1028),
    [sym_call] = STATE(1028),
    [sym_method_call] = STATE(1032),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(5214),
    [sym_operator_assignment] = STATE(5214),
    [sym_conditional] = STATE(5214),
    [sym_range] = STATE(5214),
    [sym_binary] = STATE(5214),
    [sym_unary] = STATE(5214),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(1031),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1032),
    [sym__variable] = STATE(1028),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1032),
    [sym_false] = STATE(1032),
    [sym_nil] = STATE(1032),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2726),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(4502),
    [sym__unary_minus] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1835),
    [anon_sym_yield] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_next] = ACTIONS(1841),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_defined_QMARK] = ACTIONS(1843),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_BANG] = ACTIONS(1849),
    [anon_sym_TILDE] = ACTIONS(1849),
    [sym_constant] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1855),
    [sym_instance_variable] = ACTIONS(1853),
    [sym_class_variable] = ACTIONS(1853),
    [sym_global_variable] = ACTIONS(1853),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1855),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7624] = {
    [aux_sym_exceptions_repeat1] = STATE(9292),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12709),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7625] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(1859),
    [sym__binary_star] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(1869),
    [anon_sym_DOT_DOT] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1877),
    [anon_sym_AMP_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_GT_GT] = ACTIONS(1879),
    [anon_sym_EQ_EQ] = ACTIONS(1881),
    [anon_sym_BANG_EQ] = ACTIONS(1877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ_GT] = ACTIONS(1877),
    [anon_sym_EQ_TILDE] = ACTIONS(1877),
    [anon_sym_BANG_TILDE] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [sym_comment] = ACTIONS(87),
  },
  [7626] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [7627] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [7628] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [7629] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [7630] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [7631] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12711),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7632] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [7633] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8108),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [7634] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [7635] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [7636] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8108),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [7637] = {
    [aux_sym_exceptions_repeat1] = STATE(9295),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [7638] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8108),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [7639] = {
    [sym_string] = STATE(7639),
    [aux_sym_chained_string_repeat1] = STATE(7639),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [7640] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9296),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_assignment] = STATE(9296),
    [sym_operator_assignment] = STATE(9296),
    [sym_conditional] = STATE(9296),
    [sym_range] = STATE(9296),
    [sym_binary] = STATE(9296),
    [sym_unary] = STATE(9296),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7641] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5251),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1065),
    [sym_scope_resolution] = STATE(1060),
    [sym_call] = STATE(1060),
    [sym_method_call] = STATE(1065),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(5251),
    [sym_operator_assignment] = STATE(5251),
    [sym_conditional] = STATE(5251),
    [sym_range] = STATE(5251),
    [sym_binary] = STATE(5251),
    [sym_unary] = STATE(5251),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(1064),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1065),
    [sym__variable] = STATE(1060),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1065),
    [sym_false] = STATE(1065),
    [sym_nil] = STATE(1065),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(2792),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(4538),
    [sym__unary_minus] = ACTIONS(1891),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_yield] = ACTIONS(1899),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_next] = ACTIONS(1903),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(4580),
    [anon_sym_defined_QMARK] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1915),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1919),
    [sym_constant] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1925),
    [sym_instance_variable] = ACTIONS(1923),
    [sym_class_variable] = ACTIONS(1923),
    [sym_global_variable] = ACTIONS(1923),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1925),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7642] = {
    [aux_sym_exceptions_repeat1] = STATE(9297),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12713),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [7643] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [7644] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7645] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [7646] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [7647] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8156),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [7648] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12715),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7649] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(8140),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8146),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8152),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ_GT] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_BANG_TILDE] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8140),
    [anon_sym_GT] = ACTIONS(8140),
    [anon_sym_GT_EQ] = ACTIONS(8154),
    [anon_sym_CARET] = ACTIONS(8156),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [7650] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(8140),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8142),
    [anon_sym_DOT_DOT] = ACTIONS(8144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8146),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8152),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ_GT] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_BANG_TILDE] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8140),
    [anon_sym_GT] = ACTIONS(8140),
    [anon_sym_GT_EQ] = ACTIONS(8154),
    [anon_sym_CARET] = ACTIONS(8156),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [7651] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(8140),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8152),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ_GT] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_BANG_TILDE] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8140),
    [anon_sym_GT] = ACTIONS(8140),
    [anon_sym_GT_EQ] = ACTIONS(8154),
    [anon_sym_CARET] = ACTIONS(8156),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [7652] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [7653] = {
    [aux_sym_exceptions_repeat1] = STATE(7653),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(12717),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [7654] = {
    [aux_sym_exceptions_repeat1] = STATE(5269),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7655] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(8140),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8142),
    [anon_sym_DOT_DOT] = ACTIONS(8144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8146),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8152),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ_GT] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_BANG_TILDE] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8140),
    [anon_sym_GT] = ACTIONS(8140),
    [anon_sym_GT_EQ] = ACTIONS(8154),
    [anon_sym_CARET] = ACTIONS(8156),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [7656] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7657] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7658] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9299),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(9299),
    [sym_operator_assignment] = STATE(9299),
    [sym_conditional] = STATE(9299),
    [sym_range] = STATE(9299),
    [sym_binary] = STATE(9299),
    [sym_unary] = STATE(9299),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7659] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7660] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9300),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(9300),
    [sym_operator_assignment] = STATE(9300),
    [sym_conditional] = STATE(9300),
    [sym_range] = STATE(9300),
    [sym_binary] = STATE(9300),
    [sym_unary] = STATE(9300),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7661] = {
    [sym_heredoc_body] = STATE(9301),
    [aux_sym_call_repeat1] = STATE(9301),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7662] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5279),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(5279),
    [sym_operator_assignment] = STATE(5279),
    [sym_conditional] = STATE(5279),
    [sym_range] = STATE(5279),
    [sym_binary] = STATE(5279),
    [sym_unary] = STATE(5279),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(5282),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(9302),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8172),
    [sym__splat_star] = ACTIONS(8174),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__identifier_hash_key] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12720),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(8178),
    [sym_identifier] = ACTIONS(8178),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7663] = {
    [sym_heredoc_body] = STATE(9303),
    [aux_sym_call_repeat1] = STATE(9303),
    [aux_sym_argument_list_repeat1] = STATE(9304),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10968),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7664] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7665] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7666] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7667] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7668] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7669] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12722),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7670] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7671] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7672] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7673] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7674] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9306),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(9306),
    [sym_operator_assignment] = STATE(9306),
    [sym_conditional] = STATE(9306),
    [sym_range] = STATE(9306),
    [sym_binary] = STATE(9306),
    [sym_unary] = STATE(9306),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [7675] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_argument_list] = STATE(6452),
    [sym__argument_list_with_parens] = STATE(5300),
    [sym__argument] = STATE(5301),
    [sym_splat_argument] = STATE(5301),
    [sym_hash_splat_argument] = STATE(5301),
    [sym_block_argument] = STATE(5301),
    [sym_assignment] = STATE(5299),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5302),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(5301),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8208),
    [sym__splat_star] = ACTIONS(8210),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(8212),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4724),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(8214),
    [sym_identifier] = ACTIONS(8214),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7676] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_argument_list] = STATE(6453),
    [sym__argument_list_with_parens] = STATE(5300),
    [sym__argument] = STATE(5301),
    [sym_splat_argument] = STATE(5301),
    [sym_hash_splat_argument] = STATE(5301),
    [sym_block_argument] = STATE(5301),
    [sym_assignment] = STATE(5299),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5302),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(5301),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8208),
    [sym__splat_star] = ACTIONS(8210),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(8212),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4724),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(8214),
    [sym_identifier] = ACTIONS(8214),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7677] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_argument_list] = STATE(6454),
    [sym__argument_list_with_parens] = STATE(5300),
    [sym__argument] = STATE(5301),
    [sym_splat_argument] = STATE(5301),
    [sym_hash_splat_argument] = STATE(5301),
    [sym_block_argument] = STATE(5301),
    [sym_assignment] = STATE(5299),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5302),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(5301),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8208),
    [sym__splat_star] = ACTIONS(8210),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(8212),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4724),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(8214),
    [sym_identifier] = ACTIONS(8214),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7678] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_argument_list] = STATE(6455),
    [sym__argument_list_with_parens] = STATE(5300),
    [sym__argument] = STATE(5301),
    [sym_splat_argument] = STATE(5301),
    [sym_hash_splat_argument] = STATE(5301),
    [sym_block_argument] = STATE(5301),
    [sym_assignment] = STATE(5299),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5302),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(5301),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8208),
    [sym__splat_star] = ACTIONS(8210),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(8212),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4724),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(8214),
    [sym_identifier] = ACTIONS(8214),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7679] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9307),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(9307),
    [sym_operator_assignment] = STATE(9307),
    [sym_conditional] = STATE(9307),
    [sym_range] = STATE(9307),
    [sym_binary] = STATE(9307),
    [sym_unary] = STATE(9307),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [7680] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6470),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(6470),
    [sym_operator_assignment] = STATE(6470),
    [sym_conditional] = STATE(6470),
    [sym_range] = STATE(6470),
    [sym_binary] = STATE(6470),
    [sym_unary] = STATE(6470),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [7681] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(12736),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [7682] = {
    [anon_sym_EQ] = ACTIONS(12752),
    [sym_comment] = ACTIONS(87),
  },
  [7683] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12754),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12756),
    [anon_sym_DASH_EQ] = ACTIONS(12756),
    [anon_sym_STAR_EQ] = ACTIONS(12756),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12756),
    [anon_sym_SLASH_EQ] = ACTIONS(12756),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12756),
    [anon_sym_PIPE_EQ] = ACTIONS(12756),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12756),
    [anon_sym_AMP_EQ] = ACTIONS(12756),
    [anon_sym_PERCENT_EQ] = ACTIONS(12756),
    [anon_sym_GT_GT_EQ] = ACTIONS(12756),
    [anon_sym_LT_LT_EQ] = ACTIONS(12756),
    [anon_sym_CARET_EQ] = ACTIONS(12756),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7684] = {
    [sym_string] = STATE(9320),
    [aux_sym_chained_string_repeat1] = STATE(9320),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7685] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(12736),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [7686] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9321),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(9321),
    [sym_operator_assignment] = STATE(9321),
    [sym_conditional] = STATE(9321),
    [sym_range] = STATE(9321),
    [sym_binary] = STATE(9321),
    [sym_unary] = STATE(9321),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [7687] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(12736),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [7688] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9322),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(9322),
    [sym_operator_assignment] = STATE(9322),
    [sym_conditional] = STATE(9322),
    [sym_range] = STATE(9322),
    [sym_binary] = STATE(9322),
    [sym_unary] = STATE(9322),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [7689] = {
    [sym_heredoc_body] = STATE(9323),
    [aux_sym_call_repeat1] = STATE(9323),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [7690] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym__argument] = STATE(6514),
    [sym_splat_argument] = STATE(6514),
    [sym_hash_splat_argument] = STATE(6514),
    [sym_block_argument] = STATE(6514),
    [sym_assignment] = STATE(5299),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5302),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(9324),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6514),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8208),
    [sym__splat_star] = ACTIONS(8210),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__identifier_hash_key] = ACTIONS(8212),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12758),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(8214),
    [sym_identifier] = ACTIONS(8214),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7691] = {
    [sym_heredoc_body] = STATE(9325),
    [aux_sym_call_repeat1] = STATE(9325),
    [aux_sym_argument_list_repeat1] = STATE(9326),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10994),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_in] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [7692] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7693] = {
    [aux_sym_exceptions_repeat1] = STATE(9328),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_in] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7694] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [7695] = {
    [sym_string] = STATE(7695),
    [aux_sym_chained_string_repeat1] = STATE(7695),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_in] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7696] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [7697] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [7698] = {
    [sym_heredoc_body] = STATE(7698),
    [aux_sym_call_repeat1] = STATE(7698),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_in] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7699] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(2848),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(2848),
    [sym_operator_assignment] = STATE(2848),
    [sym_conditional] = STATE(2848),
    [sym_range] = STATE(2848),
    [sym_binary] = STATE(2848),
    [sym_unary] = STATE(2848),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2851),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(4664),
    [sym__splat_star] = ACTIONS(4666),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__identifier_hash_key] = ACTIONS(4668),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10998),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(4672),
    [sym_identifier] = ACTIONS(4672),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7700] = {
    [sym_heredoc_body] = STATE(7698),
    [aux_sym_call_repeat1] = STATE(7698),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_in] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7701] = {
    [aux_sym_argument_list_repeat1] = STATE(7701),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12760),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_in] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [7702] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9329),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_assignment] = STATE(9329),
    [sym_operator_assignment] = STATE(9329),
    [sym_conditional] = STATE(9329),
    [sym_range] = STATE(9329),
    [sym_binary] = STATE(9329),
    [sym_unary] = STATE(9329),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7703] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7704] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7705] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7706] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [7707] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7708] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7709] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7710] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12763),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7711] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7712] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7713] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7714] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7715] = {
    [sym_heredoc_body] = STATE(7715),
    [aux_sym_call_repeat1] = STATE(7715),
    [sym__heredoc_body_start] = ACTIONS(10154),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_in] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [7716] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(2876),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym__argument] = STATE(6822),
    [sym_splat_argument] = STATE(6822),
    [sym_hash_splat_argument] = STATE(6822),
    [sym_block_argument] = STATE(6822),
    [sym_assignment] = STATE(2876),
    [sym_operator_assignment] = STATE(2876),
    [sym_conditional] = STATE(2876),
    [sym_range] = STATE(2876),
    [sym_binary] = STATE(2876),
    [sym_unary] = STATE(2876),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(2881),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6822),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(4704),
    [sym__splat_star] = ACTIONS(4706),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__identifier_hash_key] = ACTIONS(4710),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11002),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(4728),
    [sym_identifier] = ACTIONS(4728),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [7717] = {
    [sym_heredoc_body] = STATE(7715),
    [aux_sym_call_repeat1] = STATE(7715),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_in] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [7718] = {
    [aux_sym_argument_list_repeat1] = STATE(7718),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12765),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_in] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [7719] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7720] = {
    [aux_sym_exceptions_repeat1] = STATE(9332),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_in] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [7721] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [7722] = {
    [sym_string] = STATE(7722),
    [aux_sym_chained_string_repeat1] = STATE(7722),
    [sym__string_start] = ACTIONS(10160),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_in] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [7723] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5354),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(5354),
    [sym_operator_assignment] = STATE(5354),
    [sym_conditional] = STATE(5354),
    [sym_range] = STATE(5354),
    [sym_binary] = STATE(5354),
    [sym_unary] = STATE(5354),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2840),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4666),
    [sym__unary_minus] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7724] = {
    [aux_sym_exceptions_repeat1] = STATE(9333),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12768),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_in] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7725] = {
    [sym__line_break] = ACTIONS(12770),
    [sym__heredoc_body_start] = ACTIONS(12770),
    [sym__binary_minus] = ACTIONS(12770),
    [sym__binary_star] = ACTIONS(12770),
    [ts_builtin_sym_end] = ACTIONS(12770),
    [anon_sym___END__] = ACTIONS(12770),
    [anon_sym_LBRACE] = ACTIONS(12770),
    [anon_sym_RBRACE] = ACTIONS(12770),
    [anon_sym_RPAREN] = ACTIONS(12770),
    [anon_sym_DOT] = ACTIONS(12772),
    [anon_sym_COMMA] = ACTIONS(12770),
    [anon_sym_PIPE] = ACTIONS(12772),
    [anon_sym_SEMI] = ACTIONS(12770),
    [anon_sym_STAR_STAR] = ACTIONS(12770),
    [anon_sym_AMP] = ACTIONS(12772),
    [anon_sym_LT] = ACTIONS(12772),
    [anon_sym_end] = ACTIONS(12770),
    [anon_sym_if] = ACTIONS(12770),
    [anon_sym_unless] = ACTIONS(12770),
    [anon_sym_while] = ACTIONS(12770),
    [anon_sym_until] = ACTIONS(12770),
    [anon_sym_rescue] = ACTIONS(12770),
    [anon_sym_do] = ACTIONS(12770),
    [anon_sym_when] = ACTIONS(12770),
    [anon_sym_elsif] = ACTIONS(12770),
    [anon_sym_else] = ACTIONS(12770),
    [anon_sym_then] = ACTIONS(12770),
    [anon_sym_ensure] = ACTIONS(12770),
    [anon_sym_EQ_GT] = ACTIONS(12770),
    [anon_sym_LBRACK] = ACTIONS(12770),
    [anon_sym_COLON_COLON2] = ACTIONS(12770),
    [anon_sym_AMP_DOT] = ACTIONS(12770),
    [anon_sym_QMARK] = ACTIONS(12770),
    [anon_sym_DOT_DOT] = ACTIONS(12772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12770),
    [anon_sym_and] = ACTIONS(12770),
    [anon_sym_or] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE] = ACTIONS(12770),
    [anon_sym_AMP_AMP] = ACTIONS(12770),
    [anon_sym_LT_LT] = ACTIONS(12770),
    [anon_sym_GT_GT] = ACTIONS(12770),
    [anon_sym_EQ_EQ] = ACTIONS(12772),
    [anon_sym_BANG_EQ] = ACTIONS(12770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12770),
    [anon_sym_LT_EQ_GT] = ACTIONS(12770),
    [anon_sym_EQ_TILDE] = ACTIONS(12770),
    [anon_sym_BANG_TILDE] = ACTIONS(12770),
    [anon_sym_LT_EQ] = ACTIONS(12772),
    [anon_sym_GT] = ACTIONS(12772),
    [anon_sym_GT_EQ] = ACTIONS(12770),
    [anon_sym_CARET] = ACTIONS(12770),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_SLASH] = ACTIONS(12770),
    [anon_sym_PERCENT] = ACTIONS(12770),
    [sym_comment] = ACTIONS(87),
  },
  [7726] = {
    [sym_heredoc_body] = STATE(9334),
    [aux_sym_call_repeat1] = STATE(9334),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7727] = {
    [sym_heredoc_body] = STATE(9335),
    [aux_sym_call_repeat1] = STATE(9335),
    [aux_sym_argument_list_repeat1] = STATE(5400),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4802),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7728] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [7729] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7730] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [7731] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [7732] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [7733] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12774),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7734] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [7735] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8288),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [7736] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [7737] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [7738] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8288),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [7739] = {
    [aux_sym_exceptions_repeat1] = STATE(9338),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7740] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8288),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [7741] = {
    [sym_string] = STATE(7741),
    [aux_sym_chained_string_repeat1] = STATE(7741),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7742] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [7743] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [7744] = {
    [sym_heredoc_body] = STATE(7744),
    [aux_sym_call_repeat1] = STATE(7744),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7745] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2911),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(2911),
    [sym_operator_assignment] = STATE(2911),
    [sym_conditional] = STATE(2911),
    [sym_range] = STATE(2911),
    [sym_binary] = STATE(2911),
    [sym_unary] = STATE(2911),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2914),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4766),
    [sym__splat_star] = ACTIONS(4768),
    [sym__unary_minus] = ACTIONS(1977),
    [sym__identifier_hash_key] = ACTIONS(4770),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11013),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(4772),
    [sym_identifier] = ACTIONS(4772),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7746] = {
    [sym_heredoc_body] = STATE(7744),
    [aux_sym_call_repeat1] = STATE(7744),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7747] = {
    [aux_sym_argument_list_repeat1] = STATE(7747),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12776),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [7748] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9339),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_assignment] = STATE(9339),
    [sym_operator_assignment] = STATE(9339),
    [sym_conditional] = STATE(9339),
    [sym_range] = STATE(9339),
    [sym_binary] = STATE(9339),
    [sym_unary] = STATE(9339),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7749] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5401),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1111),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1111),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(5401),
    [sym_operator_assignment] = STATE(5401),
    [sym_conditional] = STATE(5401),
    [sym_range] = STATE(5401),
    [sym_binary] = STATE(5401),
    [sym_unary] = STATE(5401),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(1110),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1111),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1111),
    [sym_false] = STATE(1111),
    [sym_nil] = STATE(1111),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2903),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(4768),
    [sym__unary_minus] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1981),
    [anon_sym_yield] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1985),
    [anon_sym_next] = ACTIONS(1987),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4762),
    [anon_sym_defined_QMARK] = ACTIONS(1989),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_BANG] = ACTIONS(1995),
    [anon_sym_TILDE] = ACTIONS(1995),
    [sym_constant] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2001),
    [sym_instance_variable] = ACTIONS(1999),
    [sym_class_variable] = ACTIONS(1999),
    [sym_global_variable] = ACTIONS(1999),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2001),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7750] = {
    [aux_sym_exceptions_repeat1] = STATE(9340),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12779),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7751] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [7752] = {
    [sym__line_break] = ACTIONS(12781),
    [sym__heredoc_body_start] = ACTIONS(12781),
    [sym__binary_minus] = ACTIONS(12781),
    [sym__binary_star] = ACTIONS(12781),
    [ts_builtin_sym_end] = ACTIONS(12781),
    [anon_sym___END__] = ACTIONS(12781),
    [anon_sym_LBRACE] = ACTIONS(12781),
    [anon_sym_RBRACE] = ACTIONS(12781),
    [anon_sym_RPAREN] = ACTIONS(12781),
    [anon_sym_DOT] = ACTIONS(12783),
    [anon_sym_COMMA] = ACTIONS(12781),
    [anon_sym_PIPE] = ACTIONS(12783),
    [anon_sym_SEMI] = ACTIONS(12781),
    [anon_sym_STAR_STAR] = ACTIONS(12781),
    [anon_sym_AMP] = ACTIONS(12783),
    [anon_sym_LT] = ACTIONS(12783),
    [anon_sym_end] = ACTIONS(12781),
    [anon_sym_if] = ACTIONS(12781),
    [anon_sym_unless] = ACTIONS(12781),
    [anon_sym_while] = ACTIONS(12781),
    [anon_sym_until] = ACTIONS(12781),
    [anon_sym_rescue] = ACTIONS(12781),
    [anon_sym_do] = ACTIONS(12781),
    [anon_sym_when] = ACTIONS(12781),
    [anon_sym_elsif] = ACTIONS(12781),
    [anon_sym_else] = ACTIONS(12781),
    [anon_sym_then] = ACTIONS(12781),
    [anon_sym_ensure] = ACTIONS(12781),
    [anon_sym_EQ_GT] = ACTIONS(12781),
    [anon_sym_LBRACK] = ACTIONS(12781),
    [anon_sym_COLON_COLON2] = ACTIONS(12781),
    [anon_sym_AMP_DOT] = ACTIONS(12781),
    [anon_sym_QMARK] = ACTIONS(12781),
    [anon_sym_DOT_DOT] = ACTIONS(12783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12781),
    [anon_sym_and] = ACTIONS(12781),
    [anon_sym_or] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE] = ACTIONS(12781),
    [anon_sym_AMP_AMP] = ACTIONS(12781),
    [anon_sym_LT_LT] = ACTIONS(12781),
    [anon_sym_GT_GT] = ACTIONS(12781),
    [anon_sym_EQ_EQ] = ACTIONS(12783),
    [anon_sym_BANG_EQ] = ACTIONS(12781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12781),
    [anon_sym_LT_EQ_GT] = ACTIONS(12781),
    [anon_sym_EQ_TILDE] = ACTIONS(12781),
    [anon_sym_BANG_TILDE] = ACTIONS(12781),
    [anon_sym_LT_EQ] = ACTIONS(12783),
    [anon_sym_GT] = ACTIONS(12783),
    [anon_sym_GT_EQ] = ACTIONS(12781),
    [anon_sym_CARET] = ACTIONS(12781),
    [anon_sym_PLUS] = ACTIONS(12781),
    [anon_sym_SLASH] = ACTIONS(12781),
    [anon_sym_PERCENT] = ACTIONS(12781),
    [sym_comment] = ACTIONS(87),
  },
  [7753] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [7754] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7755] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [7756] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [7757] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [7758] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12785),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7759] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(8332),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8338),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ_GT] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_BANG_TILDE] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8332),
    [anon_sym_GT] = ACTIONS(8332),
    [anon_sym_GT_EQ] = ACTIONS(8346),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [7760] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(8332),
    [anon_sym_QMARK] = ACTIONS(8334),
    [anon_sym_DOT_DOT] = ACTIONS(8336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8338),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ_GT] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_BANG_TILDE] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8332),
    [anon_sym_GT] = ACTIONS(8332),
    [anon_sym_GT_EQ] = ACTIONS(8346),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [7761] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(8332),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ_GT] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_BANG_TILDE] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8332),
    [anon_sym_GT] = ACTIONS(8332),
    [anon_sym_GT_EQ] = ACTIONS(8346),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [7762] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [7763] = {
    [aux_sym_exceptions_repeat1] = STATE(7763),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(12787),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [7764] = {
    [aux_sym_exceptions_repeat1] = STATE(5422),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7765] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(8332),
    [anon_sym_QMARK] = ACTIONS(8334),
    [anon_sym_DOT_DOT] = ACTIONS(8336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8338),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ_GT] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_BANG_TILDE] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8332),
    [anon_sym_GT] = ACTIONS(8332),
    [anon_sym_GT_EQ] = ACTIONS(8346),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [7766] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9342),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(9342),
    [sym_operator_assignment] = STATE(9342),
    [sym_conditional] = STATE(9342),
    [sym_range] = STATE(9342),
    [sym_binary] = STATE(9342),
    [sym_unary] = STATE(9342),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7767] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9343),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(9343),
    [sym_operator_assignment] = STATE(9343),
    [sym_conditional] = STATE(9343),
    [sym_range] = STATE(9343),
    [sym_binary] = STATE(9343),
    [sym_unary] = STATE(9343),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7768] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7769] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(12800),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [7770] = {
    [anon_sym_EQ] = ACTIONS(12816),
    [sym_comment] = ACTIONS(87),
  },
  [7771] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12818),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12820),
    [anon_sym_DASH_EQ] = ACTIONS(12820),
    [anon_sym_STAR_EQ] = ACTIONS(12820),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12820),
    [anon_sym_SLASH_EQ] = ACTIONS(12820),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12820),
    [anon_sym_PIPE_EQ] = ACTIONS(12820),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12820),
    [anon_sym_AMP_EQ] = ACTIONS(12820),
    [anon_sym_PERCENT_EQ] = ACTIONS(12820),
    [anon_sym_GT_GT_EQ] = ACTIONS(12820),
    [anon_sym_LT_LT_EQ] = ACTIONS(12820),
    [anon_sym_CARET_EQ] = ACTIONS(12820),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7772] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(12800),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [7773] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9356),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(9356),
    [sym_operator_assignment] = STATE(9356),
    [sym_conditional] = STATE(9356),
    [sym_range] = STATE(9356),
    [sym_binary] = STATE(9356),
    [sym_unary] = STATE(9356),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7774] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(12800),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [7775] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9357),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(9357),
    [sym_operator_assignment] = STATE(9357),
    [sym_conditional] = STATE(9357),
    [sym_range] = STATE(9357),
    [sym_binary] = STATE(9357),
    [sym_unary] = STATE(9357),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7776] = {
    [sym_heredoc_body] = STATE(9358),
    [aux_sym_call_repeat1] = STATE(9358),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7777] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5432),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(5432),
    [sym_operator_assignment] = STATE(5432),
    [sym_conditional] = STATE(5432),
    [sym_range] = STATE(5432),
    [sym_binary] = STATE(5432),
    [sym_unary] = STATE(5432),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5435),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9359),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8358),
    [sym__splat_star] = ACTIONS(8360),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__identifier_hash_key] = ACTIONS(8362),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12822),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(8364),
    [sym_identifier] = ACTIONS(8364),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7778] = {
    [sym_heredoc_body] = STATE(9360),
    [aux_sym_call_repeat1] = STATE(9360),
    [aux_sym_argument_list_repeat1] = STATE(9361),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(11040),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7779] = {
    [sym__line_break] = ACTIONS(12824),
    [sym__heredoc_body_start] = ACTIONS(12824),
    [anon_sym_COMMA] = ACTIONS(12824),
    [anon_sym_SEMI] = ACTIONS(12824),
    [anon_sym_then] = ACTIONS(12824),
    [sym_comment] = ACTIONS(87),
  },
  [7780] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9362),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(9362),
    [sym_operator_assignment] = STATE(9362),
    [sym_conditional] = STATE(9362),
    [sym_range] = STATE(9362),
    [sym_binary] = STATE(9362),
    [sym_unary] = STATE(9362),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7781] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(9377),
    [sym__argument] = STATE(9378),
    [sym_splat_argument] = STATE(9378),
    [sym_hash_splat_argument] = STATE(9378),
    [sym_block_argument] = STATE(9378),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9381),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9378),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(12826),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(12832),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12850),
    [sym_identifier] = ACTIONS(12850),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7782] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(9377),
    [sym__argument] = STATE(9378),
    [sym_splat_argument] = STATE(9378),
    [sym_hash_splat_argument] = STATE(9378),
    [sym_block_argument] = STATE(9378),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9381),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9378),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(12826),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(12832),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12850),
    [sym_identifier] = ACTIONS(12850),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7783] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(9377),
    [sym__argument] = STATE(9378),
    [sym_splat_argument] = STATE(9378),
    [sym_hash_splat_argument] = STATE(9378),
    [sym_block_argument] = STATE(9378),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9381),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9378),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(12826),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(12832),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12850),
    [sym_identifier] = ACTIONS(12850),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7784] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(9377),
    [sym__argument] = STATE(9378),
    [sym_splat_argument] = STATE(9378),
    [sym_hash_splat_argument] = STATE(9378),
    [sym_block_argument] = STATE(9378),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9381),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9378),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(12826),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(12832),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12850),
    [sym_identifier] = ACTIONS(12850),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7785] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9382),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(9382),
    [sym_operator_assignment] = STATE(9382),
    [sym_conditional] = STATE(9382),
    [sym_range] = STATE(9382),
    [sym_binary] = STATE(9382),
    [sym_unary] = STATE(9382),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7786] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7787] = {
    [sym_operator] = STATE(9383),
    [sym__method_name] = STATE(9383),
    [sym_setter] = STATE(9383),
    [sym_symbol] = STATE(9383),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12856),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12856),
    [sym_class_variable] = ACTIONS(12856),
    [sym_global_variable] = ACTIONS(12856),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [7788] = {
    [sym_when] = STATE(9384),
    [sym_else] = STATE(9384),
    [anon_sym_end] = ACTIONS(12858),
    [anon_sym_when] = ACTIONS(2041),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [7789] = {
    [sym_heredoc_body] = STATE(9385),
    [sym__terminator] = STATE(9385),
    [aux_sym__statements_repeat1] = STATE(9386),
    [sym__line_break] = ACTIONS(12860),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(12860),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_when] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [7790] = {
    [sym__line_break] = ACTIONS(691),
    [sym__heredoc_body_start] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(12862),
    [anon_sym_unless] = ACTIONS(12864),
    [anon_sym_while] = ACTIONS(12866),
    [anon_sym_until] = ACTIONS(12868),
    [anon_sym_rescue] = ACTIONS(12870),
    [anon_sym_when] = ACTIONS(691),
    [anon_sym_else] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [7791] = {
    [anon_sym_end] = ACTIONS(12858),
    [sym_comment] = ACTIONS(87),
  },
  [7792] = {
    [sym__line_break] = ACTIONS(703),
    [sym__heredoc_body_start] = ACTIONS(703),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_when] = ACTIONS(703),
    [anon_sym_else] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(12888),
    [anon_sym_or] = ACTIONS(12888),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [7793] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9414),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(426),
    [sym__argument_list_with_parens] = STATE(9416),
    [sym__argument] = STATE(9417),
    [sym_splat_argument] = STATE(9417),
    [sym_hash_splat_argument] = STATE(9417),
    [sym_block_argument] = STATE(9417),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(9414),
    [sym_operator_assignment] = STATE(9414),
    [sym_conditional] = STATE(9414),
    [sym_range] = STATE(9414),
    [sym_binary] = STATE(9414),
    [sym_unary] = STATE(9414),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(9420),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(9417),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(12900),
    [sym__splat_star] = ACTIONS(12902),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(12906),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12924),
    [sym_identifier] = ACTIONS(12924),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7794] = {
    [anon_sym_EQ] = ACTIONS(12930),
    [sym_comment] = ACTIONS(87),
  },
  [7795] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12932),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12934),
    [anon_sym_DASH_EQ] = ACTIONS(12934),
    [anon_sym_STAR_EQ] = ACTIONS(12934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12934),
    [anon_sym_SLASH_EQ] = ACTIONS(12934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12934),
    [anon_sym_PIPE_EQ] = ACTIONS(12934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12934),
    [anon_sym_AMP_EQ] = ACTIONS(12934),
    [anon_sym_PERCENT_EQ] = ACTIONS(12934),
    [anon_sym_GT_GT_EQ] = ACTIONS(12934),
    [anon_sym_LT_LT_EQ] = ACTIONS(12934),
    [anon_sym_CARET_EQ] = ACTIONS(12934),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7796] = {
    [sym_string] = STATE(9423),
    [aux_sym_chained_string_repeat1] = STATE(9423),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7797] = {
    [sym__statements] = STATE(9424),
    [sym__top_level_statement] = STATE(7789),
    [sym_begin_block] = STATE(7789),
    [sym_end_block] = STATE(7789),
    [sym__statement] = STATE(7790),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(7790),
    [sym_unless_modifier] = STATE(7790),
    [sym_while_modifier] = STATE(7790),
    [sym_until_modifier] = STATE(7790),
    [sym_rescue_modifier] = STATE(7790),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_when] = STATE(9384),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(9384),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7792),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(7792),
    [sym_operator_assignment] = STATE(7792),
    [sym_conditional] = STATE(7792),
    [sym_range] = STATE(7792),
    [sym_binary] = STATE(7792),
    [sym_unary] = STATE(7792),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_undef] = STATE(7790),
    [sym_alias] = STATE(7790),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(7790),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12936),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(11056),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [anon_sym_undef] = ACTIONS(11070),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7798] = {
    [aux_sym_when_repeat1] = STATE(7798),
    [sym__line_break] = ACTIONS(12824),
    [sym__heredoc_body_start] = ACTIONS(12824),
    [anon_sym_COMMA] = ACTIONS(12938),
    [anon_sym_SEMI] = ACTIONS(12824),
    [anon_sym_then] = ACTIONS(12824),
    [sym_comment] = ACTIONS(87),
  },
  [7799] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [7800] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7801] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [7802] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [7803] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [7804] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12941),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7805] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(8380),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8386),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8390),
    [anon_sym_AMP_AMP] = ACTIONS(8390),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(8394),
    [anon_sym_BANG_EQ] = ACTIONS(8390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8390),
    [anon_sym_LT_EQ_GT] = ACTIONS(8390),
    [anon_sym_EQ_TILDE] = ACTIONS(8390),
    [anon_sym_BANG_TILDE] = ACTIONS(8390),
    [anon_sym_LT_EQ] = ACTIONS(8380),
    [anon_sym_GT] = ACTIONS(8380),
    [anon_sym_GT_EQ] = ACTIONS(8396),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [7806] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(8380),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8382),
    [anon_sym_DOT_DOT] = ACTIONS(8384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8386),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8390),
    [anon_sym_AMP_AMP] = ACTIONS(8390),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(8394),
    [anon_sym_BANG_EQ] = ACTIONS(8390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8390),
    [anon_sym_LT_EQ_GT] = ACTIONS(8390),
    [anon_sym_EQ_TILDE] = ACTIONS(8390),
    [anon_sym_BANG_TILDE] = ACTIONS(8390),
    [anon_sym_LT_EQ] = ACTIONS(8380),
    [anon_sym_GT] = ACTIONS(8380),
    [anon_sym_GT_EQ] = ACTIONS(8396),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [7807] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(8380),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(8394),
    [anon_sym_BANG_EQ] = ACTIONS(8390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8390),
    [anon_sym_LT_EQ_GT] = ACTIONS(8390),
    [anon_sym_EQ_TILDE] = ACTIONS(8390),
    [anon_sym_BANG_TILDE] = ACTIONS(8390),
    [anon_sym_LT_EQ] = ACTIONS(8380),
    [anon_sym_GT] = ACTIONS(8380),
    [anon_sym_GT_EQ] = ACTIONS(8396),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [7808] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [7809] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9426),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(9426),
    [sym_operator_assignment] = STATE(9426),
    [sym_conditional] = STATE(9426),
    [sym_range] = STATE(9426),
    [sym_binary] = STATE(9426),
    [sym_unary] = STATE(9426),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7810] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5455),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(5456),
    [sym__argument] = STATE(5457),
    [sym_splat_argument] = STATE(5457),
    [sym_hash_splat_argument] = STATE(5457),
    [sym_block_argument] = STATE(5457),
    [sym_assignment] = STATE(5455),
    [sym_operator_assignment] = STATE(5455),
    [sym_conditional] = STATE(5455),
    [sym_range] = STATE(5455),
    [sym_binary] = STATE(5455),
    [sym_unary] = STATE(5455),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5458),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5457),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8400),
    [sym__splat_star] = ACTIONS(8402),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(8404),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(8406),
    [sym_identifier] = ACTIONS(8406),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7811] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5455),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(5456),
    [sym__argument] = STATE(5457),
    [sym_splat_argument] = STATE(5457),
    [sym_hash_splat_argument] = STATE(5457),
    [sym_block_argument] = STATE(5457),
    [sym_assignment] = STATE(5455),
    [sym_operator_assignment] = STATE(5455),
    [sym_conditional] = STATE(5455),
    [sym_range] = STATE(5455),
    [sym_binary] = STATE(5455),
    [sym_unary] = STATE(5455),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5458),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5457),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8400),
    [sym__splat_star] = ACTIONS(8402),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(8404),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(8406),
    [sym_identifier] = ACTIONS(8406),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7812] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5455),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(5456),
    [sym__argument] = STATE(5457),
    [sym_splat_argument] = STATE(5457),
    [sym_hash_splat_argument] = STATE(5457),
    [sym_block_argument] = STATE(5457),
    [sym_assignment] = STATE(5455),
    [sym_operator_assignment] = STATE(5455),
    [sym_conditional] = STATE(5455),
    [sym_range] = STATE(5455),
    [sym_binary] = STATE(5455),
    [sym_unary] = STATE(5455),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5458),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5457),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8400),
    [sym__splat_star] = ACTIONS(8402),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(8404),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(8406),
    [sym_identifier] = ACTIONS(8406),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7813] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5455),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(5456),
    [sym__argument] = STATE(5457),
    [sym_splat_argument] = STATE(5457),
    [sym_hash_splat_argument] = STATE(5457),
    [sym_block_argument] = STATE(5457),
    [sym_assignment] = STATE(5455),
    [sym_operator_assignment] = STATE(5455),
    [sym_conditional] = STATE(5455),
    [sym_range] = STATE(5455),
    [sym_binary] = STATE(5455),
    [sym_unary] = STATE(5455),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5458),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5457),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8400),
    [sym__splat_star] = ACTIONS(8402),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(8404),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(8406),
    [sym_identifier] = ACTIONS(8406),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7814] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9427),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(9427),
    [sym_operator_assignment] = STATE(9427),
    [sym_conditional] = STATE(9427),
    [sym_range] = STATE(9427),
    [sym_binary] = STATE(9427),
    [sym_unary] = STATE(9427),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7815] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7816] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(12955),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [7817] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5455),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(5456),
    [sym__argument] = STATE(5457),
    [sym_splat_argument] = STATE(5457),
    [sym_hash_splat_argument] = STATE(5457),
    [sym_block_argument] = STATE(5457),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(5455),
    [sym_operator_assignment] = STATE(5455),
    [sym_conditional] = STATE(5455),
    [sym_range] = STATE(5455),
    [sym_binary] = STATE(5455),
    [sym_unary] = STATE(5455),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5458),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(5457),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8400),
    [sym__splat_star] = ACTIONS(8402),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(8404),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_then] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5020),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(8406),
    [sym_identifier] = ACTIONS(8406),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7818] = {
    [anon_sym_EQ] = ACTIONS(12971),
    [sym_comment] = ACTIONS(87),
  },
  [7819] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12973),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12975),
    [anon_sym_DASH_EQ] = ACTIONS(12975),
    [anon_sym_STAR_EQ] = ACTIONS(12975),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12975),
    [anon_sym_SLASH_EQ] = ACTIONS(12975),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12975),
    [anon_sym_PIPE_EQ] = ACTIONS(12975),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12975),
    [anon_sym_AMP_EQ] = ACTIONS(12975),
    [anon_sym_PERCENT_EQ] = ACTIONS(12975),
    [anon_sym_GT_GT_EQ] = ACTIONS(12975),
    [anon_sym_LT_LT_EQ] = ACTIONS(12975),
    [anon_sym_CARET_EQ] = ACTIONS(12975),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7820] = {
    [sym_string] = STATE(9440),
    [aux_sym_chained_string_repeat1] = STATE(9440),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7821] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(12955),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [7822] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9441),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(9441),
    [sym_operator_assignment] = STATE(9441),
    [sym_conditional] = STATE(9441),
    [sym_range] = STATE(9441),
    [sym_binary] = STATE(9441),
    [sym_unary] = STATE(9441),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7823] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(12955),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [7824] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9442),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(9442),
    [sym_operator_assignment] = STATE(9442),
    [sym_conditional] = STATE(9442),
    [sym_range] = STATE(9442),
    [sym_binary] = STATE(9442),
    [sym_unary] = STATE(9442),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [7825] = {
    [sym_heredoc_body] = STATE(9443),
    [aux_sym_call_repeat1] = STATE(9443),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [7826] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5455),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(5455),
    [sym_operator_assignment] = STATE(5455),
    [sym_conditional] = STATE(5455),
    [sym_range] = STATE(5455),
    [sym_binary] = STATE(5455),
    [sym_unary] = STATE(5455),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5458),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(9444),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8400),
    [sym__splat_star] = ACTIONS(8402),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__identifier_hash_key] = ACTIONS(8404),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12977),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(8406),
    [sym_identifier] = ACTIONS(8406),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7827] = {
    [sym_heredoc_body] = STATE(9445),
    [aux_sym_call_repeat1] = STATE(9445),
    [aux_sym_argument_list_repeat1] = STATE(9446),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(11100),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [7828] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9447),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(9447),
    [sym_operator_assignment] = STATE(9447),
    [sym_conditional] = STATE(9447),
    [sym_range] = STATE(9447),
    [sym_binary] = STATE(9447),
    [sym_unary] = STATE(9447),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7829] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(8380),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8382),
    [anon_sym_DOT_DOT] = ACTIONS(8384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8386),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8390),
    [anon_sym_AMP_AMP] = ACTIONS(8390),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(8394),
    [anon_sym_BANG_EQ] = ACTIONS(8390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8390),
    [anon_sym_LT_EQ_GT] = ACTIONS(8390),
    [anon_sym_EQ_TILDE] = ACTIONS(8390),
    [anon_sym_BANG_TILDE] = ACTIONS(8390),
    [anon_sym_LT_EQ] = ACTIONS(8380),
    [anon_sym_GT] = ACTIONS(8380),
    [anon_sym_GT_EQ] = ACTIONS(8396),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [7830] = {
    [aux_sym_exceptions_repeat1] = STATE(9449),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7831] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(8380),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8382),
    [anon_sym_DOT_DOT] = ACTIONS(8384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8386),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8390),
    [anon_sym_AMP_AMP] = ACTIONS(8390),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(8394),
    [anon_sym_BANG_EQ] = ACTIONS(8390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8390),
    [anon_sym_LT_EQ_GT] = ACTIONS(8390),
    [anon_sym_EQ_TILDE] = ACTIONS(8390),
    [anon_sym_BANG_TILDE] = ACTIONS(8390),
    [anon_sym_LT_EQ] = ACTIONS(8380),
    [anon_sym_GT] = ACTIONS(8380),
    [anon_sym_GT_EQ] = ACTIONS(8396),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [7832] = {
    [sym_string] = STATE(7832),
    [aux_sym_chained_string_repeat1] = STATE(7832),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7833] = {
    [sym_heredoc_body] = STATE(9450),
    [aux_sym_call_repeat1] = STATE(9450),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7834] = {
    [sym_heredoc_body] = STATE(9451),
    [aux_sym_call_repeat1] = STATE(9451),
    [aux_sym_argument_list_repeat1] = STATE(5510),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4924),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7835] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [7836] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7837] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [7838] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [7839] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [7840] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12979),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7841] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [7842] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8435),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [7843] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [7844] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [7845] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_ensure] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8435),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [7846] = {
    [aux_sym_exceptions_repeat1] = STATE(9454),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7847] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8435),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [7848] = {
    [sym_string] = STATE(7848),
    [aux_sym_chained_string_repeat1] = STATE(7848),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_ensure] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [7849] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_ensure] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [7850] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_ensure] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [7851] = {
    [sym_heredoc_body] = STATE(7851),
    [aux_sym_call_repeat1] = STATE(7851),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_ensure] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7852] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(2994),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(2994),
    [sym_operator_assignment] = STATE(2994),
    [sym_conditional] = STATE(2994),
    [sym_range] = STATE(2994),
    [sym_binary] = STATE(2994),
    [sym_unary] = STATE(2994),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2997),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4880),
    [sym__splat_star] = ACTIONS(4882),
    [sym__unary_minus] = ACTIONS(2055),
    [sym__identifier_hash_key] = ACTIONS(4884),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11106),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(4886),
    [sym_identifier] = ACTIONS(4886),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7853] = {
    [sym_heredoc_body] = STATE(7851),
    [aux_sym_call_repeat1] = STATE(7851),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_ensure] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7854] = {
    [aux_sym_argument_list_repeat1] = STATE(7854),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12981),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [7855] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9455),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_assignment] = STATE(9455),
    [sym_operator_assignment] = STATE(9455),
    [sym_conditional] = STATE(9455),
    [sym_range] = STATE(9455),
    [sym_binary] = STATE(9455),
    [sym_unary] = STATE(9455),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7856] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_ensure] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [7857] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_ensure] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [7858] = {
    [sym_heredoc_body] = STATE(7858),
    [aux_sym_call_repeat1] = STATE(7858),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_ensure] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [7859] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3015),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(3015),
    [sym_operator_assignment] = STATE(3015),
    [sym_conditional] = STATE(3015),
    [sym_range] = STATE(3015),
    [sym_binary] = STATE(3015),
    [sym_unary] = STATE(3015),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3018),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(4916),
    [sym__splat_star] = ACTIONS(4918),
    [sym__unary_minus] = ACTIONS(2223),
    [sym__identifier_hash_key] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11110),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(4922),
    [sym_identifier] = ACTIONS(4922),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7860] = {
    [sym_heredoc_body] = STATE(7858),
    [aux_sym_call_repeat1] = STATE(7858),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_ensure] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [7861] = {
    [aux_sym_argument_list_repeat1] = STATE(7861),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12984),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [7862] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5511),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1151),
    [sym_scope_resolution] = STATE(1147),
    [sym_call] = STATE(1147),
    [sym_method_call] = STATE(1151),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(5511),
    [sym_operator_assignment] = STATE(5511),
    [sym_conditional] = STATE(5511),
    [sym_range] = STATE(5511),
    [sym_binary] = STATE(5511),
    [sym_unary] = STATE(5511),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(1150),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1151),
    [sym__variable] = STATE(1147),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1151),
    [sym_false] = STATE(1151),
    [sym_nil] = STATE(1151),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(2986),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(4882),
    [sym__unary_minus] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2059),
    [anon_sym_yield] = ACTIONS(2061),
    [anon_sym_break] = ACTIONS(2063),
    [anon_sym_next] = ACTIONS(2065),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(2067),
    [anon_sym_not] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(2073),
    [sym_constant] = ACTIONS(2079),
    [sym_identifier] = ACTIONS(2079),
    [sym_instance_variable] = ACTIONS(2077),
    [sym_class_variable] = ACTIONS(2077),
    [sym_global_variable] = ACTIONS(2077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2079),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2079),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7863] = {
    [aux_sym_exceptions_repeat1] = STATE(9456),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(12987),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_ensure] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7864] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7865] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7866] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7867] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7868] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7869] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7870] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7871] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(12989),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7872] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7873] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7874] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7875] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7876] = {
    [sym_heredoc_body] = STATE(7876),
    [aux_sym_call_repeat1] = STATE(7876),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [7877] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3035),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(3035),
    [sym_operator_assignment] = STATE(3035),
    [sym_conditional] = STATE(3035),
    [sym_range] = STATE(3035),
    [sym_binary] = STATE(3035),
    [sym_unary] = STATE(3035),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3040),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(4934),
    [sym__splat_star] = ACTIONS(4936),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__identifier_hash_key] = ACTIONS(4940),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11115),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(4950),
    [sym_identifier] = ACTIONS(4950),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7878] = {
    [sym_heredoc_body] = STATE(7876),
    [aux_sym_call_repeat1] = STATE(7876),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [7879] = {
    [aux_sym_argument_list_repeat1] = STATE(7879),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(12991),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [7880] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7881] = {
    [aux_sym_exceptions_repeat1] = STATE(9459),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [7882] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [7883] = {
    [sym__line_break] = ACTIONS(1263),
    [sym__simple_symbol] = ACTIONS(1263),
    [sym__string_start] = ACTIONS(1263),
    [sym__symbol_start] = ACTIONS(1263),
    [sym__subshell_start] = ACTIONS(1263),
    [sym__regex_start] = ACTIONS(1263),
    [sym__string_array_start] = ACTIONS(1263),
    [sym__symbol_array_start] = ACTIONS(1263),
    [sym__heredoc_body_start] = ACTIONS(1263),
    [sym_heredoc_beginning] = ACTIONS(1263),
    [sym__block_ampersand] = ACTIONS(1263),
    [sym__splat_star] = ACTIONS(1263),
    [sym__unary_minus] = ACTIONS(1263),
    [sym__identifier_hash_key] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1263),
    [anon_sym_def] = ACTIONS(1265),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1263),
    [anon_sym_COLON_COLON] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1263),
    [anon_sym_class] = ACTIONS(1265),
    [anon_sym_module] = ACTIONS(1265),
    [anon_sym_return] = ACTIONS(1265),
    [anon_sym_yield] = ACTIONS(1265),
    [anon_sym_break] = ACTIONS(1265),
    [anon_sym_next] = ACTIONS(1265),
    [sym_redo] = ACTIONS(1265),
    [sym_retry] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1265),
    [anon_sym_unless] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1265),
    [anon_sym_until] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1265),
    [anon_sym_do] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1265),
    [anon_sym_then] = ACTIONS(1265),
    [anon_sym_begin] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1263),
    [anon_sym_COLON_COLON2] = ACTIONS(1263),
    [anon_sym_AMP_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1263),
    [sym_constant] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1265),
    [sym_instance_variable] = ACTIONS(1263),
    [sym_class_variable] = ACTIONS(1263),
    [sym_global_variable] = ACTIONS(1263),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1265),
    [sym_float] = ACTIONS(1265),
    [sym_complex] = ACTIONS(1263),
    [sym_super] = ACTIONS(1265),
    [anon_sym_true] = ACTIONS(1265),
    [anon_sym_TRUE] = ACTIONS(1265),
    [anon_sym_false] = ACTIONS(1265),
    [anon_sym_FALSE] = ACTIONS(1265),
    [sym_self] = ACTIONS(1265),
    [anon_sym_nil] = ACTIONS(1265),
    [anon_sym_NIL] = ACTIONS(1265),
    [sym_character] = ACTIONS(1263),
    [anon_sym_LBRACK2] = ACTIONS(1265),
    [anon_sym_DASH_GT] = ACTIONS(1263),
  },
  [7884] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(905),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(910),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(910),
    [sym__argument_list_with_trailing_comma] = STATE(9461),
    [sym__argument] = STATE(908),
    [sym_splat_argument] = STATE(908),
    [sym_hash_splat_argument] = STATE(908),
    [sym_block_argument] = STATE(908),
    [sym_assignment] = STATE(905),
    [sym_operator_assignment] = STATE(905),
    [sym_conditional] = STATE(905),
    [sym_range] = STATE(905),
    [sym_binary] = STATE(905),
    [sym_unary] = STATE(905),
    [sym_left_assignment_list] = STATE(909),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(910),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_nil] = STATE(910),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(911),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(9462),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(908),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(151),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(1591),
    [sym__splat_star] = ACTIONS(1593),
    [sym__unary_minus] = ACTIONS(1595),
    [sym__identifier_hash_key] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(12994),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_defined_QMARK] = ACTIONS(1613),
    [anon_sym_not] = ACTIONS(1615),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1617),
    [sym_constant] = ACTIONS(1619),
    [sym_identifier] = ACTIONS(1619),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7885] = {
    [sym__line_break] = ACTIONS(5806),
    [sym__simple_symbol] = ACTIONS(5806),
    [sym__string_start] = ACTIONS(5806),
    [sym__symbol_start] = ACTIONS(5806),
    [sym__subshell_start] = ACTIONS(5806),
    [sym__regex_start] = ACTIONS(5806),
    [sym__string_array_start] = ACTIONS(5806),
    [sym__symbol_array_start] = ACTIONS(5806),
    [sym__heredoc_body_start] = ACTIONS(5806),
    [sym_heredoc_beginning] = ACTIONS(5806),
    [sym__block_ampersand] = ACTIONS(5806),
    [sym__splat_star] = ACTIONS(5806),
    [sym__unary_minus] = ACTIONS(5806),
    [sym__identifier_hash_key] = ACTIONS(5806),
    [anon_sym_LBRACE] = ACTIONS(5806),
    [anon_sym_def] = ACTIONS(5808),
    [anon_sym_LPAREN] = ACTIONS(5808),
    [anon_sym_DOT] = ACTIONS(5806),
    [anon_sym_COLON_COLON] = ACTIONS(5808),
    [anon_sym_SEMI] = ACTIONS(5806),
    [anon_sym_STAR] = ACTIONS(5808),
    [anon_sym_STAR_STAR] = ACTIONS(5806),
    [anon_sym_class] = ACTIONS(5808),
    [anon_sym_module] = ACTIONS(5808),
    [anon_sym_return] = ACTIONS(5808),
    [anon_sym_yield] = ACTIONS(5808),
    [anon_sym_break] = ACTIONS(5808),
    [anon_sym_next] = ACTIONS(5808),
    [sym_redo] = ACTIONS(5808),
    [sym_retry] = ACTIONS(5808),
    [anon_sym_if] = ACTIONS(5808),
    [anon_sym_unless] = ACTIONS(5808),
    [anon_sym_while] = ACTIONS(5808),
    [anon_sym_until] = ACTIONS(5808),
    [anon_sym_for] = ACTIONS(5808),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(5808),
    [anon_sym_then] = ACTIONS(5808),
    [anon_sym_begin] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5806),
    [anon_sym_COLON_COLON2] = ACTIONS(5806),
    [anon_sym_AMP_DOT] = ACTIONS(5806),
    [anon_sym_LPAREN2] = ACTIONS(5806),
    [anon_sym_PLUS] = ACTIONS(5808),
    [anon_sym_defined_QMARK] = ACTIONS(5806),
    [anon_sym_not] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5806),
    [anon_sym_TILDE] = ACTIONS(5806),
    [sym_constant] = ACTIONS(5808),
    [sym_identifier] = ACTIONS(5808),
    [sym_instance_variable] = ACTIONS(5806),
    [sym_class_variable] = ACTIONS(5806),
    [sym_global_variable] = ACTIONS(5806),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5808),
    [sym_float] = ACTIONS(5808),
    [sym_complex] = ACTIONS(5806),
    [sym_super] = ACTIONS(5808),
    [anon_sym_true] = ACTIONS(5808),
    [anon_sym_TRUE] = ACTIONS(5808),
    [anon_sym_false] = ACTIONS(5808),
    [anon_sym_FALSE] = ACTIONS(5808),
    [sym_self] = ACTIONS(5808),
    [anon_sym_nil] = ACTIONS(5808),
    [anon_sym_NIL] = ACTIONS(5808),
    [sym_character] = ACTIONS(5806),
    [anon_sym_LBRACK2] = ACTIONS(5808),
    [anon_sym_DASH_GT] = ACTIONS(5806),
  },
  [7886] = {
    [sym__line_break] = ACTIONS(5810),
    [sym__simple_symbol] = ACTIONS(5810),
    [sym__string_start] = ACTIONS(5810),
    [sym__symbol_start] = ACTIONS(5810),
    [sym__subshell_start] = ACTIONS(5810),
    [sym__regex_start] = ACTIONS(5810),
    [sym__string_array_start] = ACTIONS(5810),
    [sym__symbol_array_start] = ACTIONS(5810),
    [sym__heredoc_body_start] = ACTIONS(5810),
    [sym_heredoc_beginning] = ACTIONS(5810),
    [sym__block_ampersand] = ACTIONS(5810),
    [sym__splat_star] = ACTIONS(5810),
    [sym__unary_minus] = ACTIONS(5810),
    [sym__identifier_hash_key] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_def] = ACTIONS(5812),
    [anon_sym_LPAREN] = ACTIONS(5812),
    [anon_sym_DOT] = ACTIONS(5810),
    [anon_sym_COLON_COLON] = ACTIONS(5812),
    [anon_sym_SEMI] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_STAR_STAR] = ACTIONS(5810),
    [anon_sym_class] = ACTIONS(5812),
    [anon_sym_module] = ACTIONS(5812),
    [anon_sym_return] = ACTIONS(5812),
    [anon_sym_yield] = ACTIONS(5812),
    [anon_sym_break] = ACTIONS(5812),
    [anon_sym_next] = ACTIONS(5812),
    [sym_redo] = ACTIONS(5812),
    [sym_retry] = ACTIONS(5812),
    [anon_sym_if] = ACTIONS(5812),
    [anon_sym_unless] = ACTIONS(5812),
    [anon_sym_while] = ACTIONS(5812),
    [anon_sym_until] = ACTIONS(5812),
    [anon_sym_for] = ACTIONS(5812),
    [anon_sym_do] = ACTIONS(5812),
    [anon_sym_case] = ACTIONS(5812),
    [anon_sym_then] = ACTIONS(5812),
    [anon_sym_begin] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_COLON_COLON2] = ACTIONS(5810),
    [anon_sym_AMP_DOT] = ACTIONS(5810),
    [anon_sym_LPAREN2] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [anon_sym_defined_QMARK] = ACTIONS(5810),
    [anon_sym_not] = ACTIONS(5812),
    [anon_sym_BANG] = ACTIONS(5810),
    [anon_sym_TILDE] = ACTIONS(5810),
    [sym_constant] = ACTIONS(5812),
    [sym_identifier] = ACTIONS(5812),
    [sym_instance_variable] = ACTIONS(5810),
    [sym_class_variable] = ACTIONS(5810),
    [sym_global_variable] = ACTIONS(5810),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5812),
    [sym_float] = ACTIONS(5812),
    [sym_complex] = ACTIONS(5810),
    [sym_super] = ACTIONS(5812),
    [anon_sym_true] = ACTIONS(5812),
    [anon_sym_TRUE] = ACTIONS(5812),
    [anon_sym_false] = ACTIONS(5812),
    [anon_sym_FALSE] = ACTIONS(5812),
    [sym_self] = ACTIONS(5812),
    [anon_sym_nil] = ACTIONS(5812),
    [anon_sym_NIL] = ACTIONS(5812),
    [sym_character] = ACTIONS(5810),
    [anon_sym_LBRACK2] = ACTIONS(5812),
    [anon_sym_DASH_GT] = ACTIONS(5810),
  },
  [7887] = {
    [sym_argument_list_with_parens] = STATE(9463),
    [sym__argument_list_with_parens] = STATE(7886),
    [sym_operator] = STATE(9463),
    [sym_heredoc_body] = STATE(3546),
    [aux_sym_call_repeat1] = STATE(3546),
    [sym__heredoc_body_start] = ACTIONS(2527),
    [anon_sym_PIPE] = ACTIONS(11117),
    [anon_sym_STAR] = ACTIONS(11119),
    [anon_sym_STAR_STAR] = ACTIONS(11117),
    [anon_sym_AMP] = ACTIONS(11117),
    [anon_sym_LT] = ACTIONS(11119),
    [anon_sym_LPAREN2] = ACTIONS(11121),
    [anon_sym_DOT_DOT] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11117),
    [anon_sym_GT_GT] = ACTIONS(11117),
    [anon_sym_EQ_EQ] = ACTIONS(11119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11117),
    [anon_sym_LT_EQ_GT] = ACTIONS(11117),
    [anon_sym_EQ_TILDE] = ACTIONS(11117),
    [anon_sym_BANG_TILDE] = ACTIONS(11117),
    [anon_sym_LT_EQ] = ACTIONS(11119),
    [anon_sym_GT] = ACTIONS(11119),
    [anon_sym_GT_EQ] = ACTIONS(11117),
    [anon_sym_CARET] = ACTIONS(11117),
    [anon_sym_PLUS] = ACTIONS(11119),
    [anon_sym_SLASH] = ACTIONS(11117),
    [anon_sym_PERCENT] = ACTIONS(11117),
    [anon_sym_BANG] = ACTIONS(11119),
    [anon_sym_TILDE] = ACTIONS(11117),
    [sym_constant] = ACTIONS(12996),
    [sym_identifier] = ACTIONS(12996),
    [anon_sym_DASH] = ACTIONS(11119),
    [anon_sym_PLUS_AT] = ACTIONS(11117),
    [anon_sym_DASH_AT] = ACTIONS(11117),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11119),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11117),
    [anon_sym_BQUOTE] = ACTIONS(11117),
    [sym_comment] = ACTIONS(87),
  },
  [7888] = {
    [sym__line_break] = ACTIONS(5816),
    [sym__heredoc_body_start] = ACTIONS(5816),
    [anon_sym_DOT] = ACTIONS(5816),
    [anon_sym_SEMI] = ACTIONS(5816),
    [anon_sym_then] = ACTIONS(5816),
    [anon_sym_LBRACK] = ACTIONS(5816),
    [anon_sym_COLON_COLON2] = ACTIONS(5816),
    [anon_sym_AMP_DOT] = ACTIONS(5816),
    [sym_comment] = ACTIONS(87),
  },
  [7889] = {
    [sym_heredoc_body] = STATE(9465),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(12998),
    [sym_comment] = ACTIONS(87),
  },
  [7890] = {
    [anon_sym_RBRACK] = ACTIONS(12998),
    [sym_comment] = ACTIONS(87),
  },
  [7891] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9466),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(9466),
    [sym_operator_assignment] = STATE(9466),
    [sym_conditional] = STATE(9466),
    [sym_range] = STATE(9466),
    [sym_binary] = STATE(9466),
    [sym_unary] = STATE(9466),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7892] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9472),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(9473),
    [sym__argument] = STATE(9474),
    [sym_splat_argument] = STATE(9474),
    [sym_hash_splat_argument] = STATE(9474),
    [sym_block_argument] = STATE(9474),
    [sym_assignment] = STATE(9472),
    [sym_operator_assignment] = STATE(9472),
    [sym_conditional] = STATE(9472),
    [sym_range] = STATE(9472),
    [sym_binary] = STATE(9472),
    [sym_unary] = STATE(9472),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9475),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9474),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13000),
    [sym__splat_star] = ACTIONS(13002),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(13004),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(11155),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(13006),
    [sym_identifier] = ACTIONS(13006),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7893] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9472),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(9473),
    [sym__argument] = STATE(9474),
    [sym_splat_argument] = STATE(9474),
    [sym_hash_splat_argument] = STATE(9474),
    [sym_block_argument] = STATE(9474),
    [sym_assignment] = STATE(9472),
    [sym_operator_assignment] = STATE(9472),
    [sym_conditional] = STATE(9472),
    [sym_range] = STATE(9472),
    [sym_binary] = STATE(9472),
    [sym_unary] = STATE(9472),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9475),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9474),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13000),
    [sym__splat_star] = ACTIONS(13002),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(13004),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(11155),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(13006),
    [sym_identifier] = ACTIONS(13006),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7894] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9472),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(9473),
    [sym__argument] = STATE(9474),
    [sym_splat_argument] = STATE(9474),
    [sym_hash_splat_argument] = STATE(9474),
    [sym_block_argument] = STATE(9474),
    [sym_assignment] = STATE(9472),
    [sym_operator_assignment] = STATE(9472),
    [sym_conditional] = STATE(9472),
    [sym_range] = STATE(9472),
    [sym_binary] = STATE(9472),
    [sym_unary] = STATE(9472),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9475),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9474),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13000),
    [sym__splat_star] = ACTIONS(13002),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(13004),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(11155),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(13006),
    [sym_identifier] = ACTIONS(13006),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7895] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9472),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(9473),
    [sym__argument] = STATE(9474),
    [sym_splat_argument] = STATE(9474),
    [sym_hash_splat_argument] = STATE(9474),
    [sym_block_argument] = STATE(9474),
    [sym_assignment] = STATE(9472),
    [sym_operator_assignment] = STATE(9472),
    [sym_conditional] = STATE(9472),
    [sym_range] = STATE(9472),
    [sym_binary] = STATE(9472),
    [sym_unary] = STATE(9472),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9475),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9474),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13000),
    [sym__splat_star] = ACTIONS(13002),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(13004),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(11155),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(13006),
    [sym_identifier] = ACTIONS(13006),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7896] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9476),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(9476),
    [sym_operator_assignment] = STATE(9476),
    [sym_conditional] = STATE(9476),
    [sym_range] = STATE(9476),
    [sym_binary] = STATE(9476),
    [sym_unary] = STATE(9476),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7897] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7898] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(13024),
    [anon_sym_or] = ACTIONS(13024),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [7899] = {
    [anon_sym_EQ] = ACTIONS(13036),
    [sym_comment] = ACTIONS(87),
  },
  [7900] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13038),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13040),
    [anon_sym_DASH_EQ] = ACTIONS(13040),
    [anon_sym_STAR_EQ] = ACTIONS(13040),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13040),
    [anon_sym_SLASH_EQ] = ACTIONS(13040),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13040),
    [anon_sym_PIPE_EQ] = ACTIONS(13040),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13040),
    [anon_sym_AMP_EQ] = ACTIONS(13040),
    [anon_sym_PERCENT_EQ] = ACTIONS(13040),
    [anon_sym_GT_GT_EQ] = ACTIONS(13040),
    [anon_sym_LT_LT_EQ] = ACTIONS(13040),
    [anon_sym_CARET_EQ] = ACTIONS(13040),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7901] = {
    [sym_string] = STATE(9489),
    [aux_sym_chained_string_repeat1] = STATE(9489),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7902] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(13024),
    [anon_sym_or] = ACTIONS(13024),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [7903] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [7904] = {
    [sym_string] = STATE(7939),
    [aux_sym_chained_string_repeat1] = STATE(7939),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7905] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9490),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(9490),
    [sym_operator_assignment] = STATE(9490),
    [sym_conditional] = STATE(9490),
    [sym_range] = STATE(9490),
    [sym_binary] = STATE(9490),
    [sym_unary] = STATE(9490),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7906] = {
    [sym__line_break] = ACTIONS(5594),
    [sym__heredoc_body_start] = ACTIONS(5594),
    [sym__binary_minus] = ACTIONS(993),
    [sym__binary_star] = ACTIONS(993),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_STAR_STAR] = ACTIONS(993),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(993),
    [anon_sym_then] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(993),
    [anon_sym_DOT_DOT] = ACTIONS(995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(993),
    [anon_sym_and] = ACTIONS(993),
    [anon_sym_or] = ACTIONS(993),
    [anon_sym_PIPE_PIPE] = ACTIONS(993),
    [anon_sym_AMP_AMP] = ACTIONS(993),
    [anon_sym_LT_LT] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(993),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(993),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(993),
    [anon_sym_LT_EQ_GT] = ACTIONS(993),
    [anon_sym_EQ_TILDE] = ACTIONS(993),
    [anon_sym_BANG_TILDE] = ACTIONS(993),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(993),
    [anon_sym_CARET] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_SLASH] = ACTIONS(993),
    [anon_sym_PERCENT] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [7907] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(13024),
    [anon_sym_or] = ACTIONS(13024),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [7908] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9491),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9491),
    [sym_operator_assignment] = STATE(9491),
    [sym_conditional] = STATE(9491),
    [sym_range] = STATE(9491),
    [sym_binary] = STATE(9491),
    [sym_unary] = STATE(9491),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7909] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9492),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9492),
    [sym_operator_assignment] = STATE(9492),
    [sym_conditional] = STATE(9492),
    [sym_range] = STATE(9492),
    [sym_binary] = STATE(9492),
    [sym_unary] = STATE(9492),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7910] = {
    [anon_sym_COLON] = ACTIONS(13042),
    [sym_comment] = ACTIONS(87),
  },
  [7911] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9494),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9494),
    [sym_operator_assignment] = STATE(9494),
    [sym_conditional] = STATE(9494),
    [sym_range] = STATE(9494),
    [sym_binary] = STATE(9494),
    [sym_unary] = STATE(9494),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7912] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(13044),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [7913] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [7914] = {
    [sym_heredoc_body] = STATE(9496),
    [aux_sym_call_repeat1] = STATE(9496),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [7915] = {
    [sym_heredoc_body] = STATE(9496),
    [aux_sym_call_repeat1] = STATE(9496),
    [aux_sym_argument_list_repeat1] = STATE(9498),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(13046),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [7916] = {
    [sym_string] = STATE(7939),
    [aux_sym_chained_string_repeat1] = STATE(7939),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(13048),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7917] = {
    [sym__line_break] = ACTIONS(4148),
    [sym__heredoc_body_start] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_DOT] = ACTIONS(4148),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_do] = ACTIONS(4148),
    [anon_sym_then] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
  },
  [7918] = {
    [sym_heredoc_body] = STATE(9500),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(13050),
    [sym_comment] = ACTIONS(87),
  },
  [7919] = {
    [anon_sym_RPAREN] = ACTIONS(13050),
    [sym_comment] = ACTIONS(87),
  },
  [7920] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [7921] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9501),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(9501),
    [sym_operator_assignment] = STATE(9501),
    [sym_conditional] = STATE(9501),
    [sym_range] = STATE(9501),
    [sym_binary] = STATE(9501),
    [sym_unary] = STATE(9501),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7922] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9502),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9502),
    [sym_operator_assignment] = STATE(9502),
    [sym_conditional] = STATE(9502),
    [sym_range] = STATE(9502),
    [sym_binary] = STATE(9502),
    [sym_unary] = STATE(9502),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7923] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9503),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9503),
    [sym_operator_assignment] = STATE(9503),
    [sym_conditional] = STATE(9503),
    [sym_range] = STATE(9503),
    [sym_binary] = STATE(9503),
    [sym_unary] = STATE(9503),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7924] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9504),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9504),
    [sym_operator_assignment] = STATE(9504),
    [sym_conditional] = STATE(9504),
    [sym_range] = STATE(9504),
    [sym_binary] = STATE(9504),
    [sym_unary] = STATE(9504),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7925] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9505),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9505),
    [sym_operator_assignment] = STATE(9505),
    [sym_conditional] = STATE(9505),
    [sym_range] = STATE(9505),
    [sym_binary] = STATE(9505),
    [sym_unary] = STATE(9505),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7926] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9506),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9506),
    [sym_operator_assignment] = STATE(9506),
    [sym_conditional] = STATE(9506),
    [sym_range] = STATE(9506),
    [sym_binary] = STATE(9506),
    [sym_unary] = STATE(9506),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7927] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9507),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9507),
    [sym_operator_assignment] = STATE(9507),
    [sym_conditional] = STATE(9507),
    [sym_range] = STATE(9507),
    [sym_binary] = STATE(9507),
    [sym_unary] = STATE(9507),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7928] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9508),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9508),
    [sym_operator_assignment] = STATE(9508),
    [sym_conditional] = STATE(9508),
    [sym_range] = STATE(9508),
    [sym_binary] = STATE(9508),
    [sym_unary] = STATE(9508),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7929] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9509),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9509),
    [sym_operator_assignment] = STATE(9509),
    [sym_conditional] = STATE(9509),
    [sym_range] = STATE(9509),
    [sym_binary] = STATE(9509),
    [sym_unary] = STATE(9509),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7930] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9510),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9510),
    [sym_operator_assignment] = STATE(9510),
    [sym_conditional] = STATE(9510),
    [sym_range] = STATE(9510),
    [sym_binary] = STATE(9510),
    [sym_unary] = STATE(9510),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7931] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9511),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9511),
    [sym_operator_assignment] = STATE(9511),
    [sym_conditional] = STATE(9511),
    [sym_range] = STATE(9511),
    [sym_binary] = STATE(9511),
    [sym_unary] = STATE(9511),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7932] = {
    [sym__line_break] = ACTIONS(6024),
    [sym__heredoc_body_start] = ACTIONS(6024),
    [anon_sym_DOT] = ACTIONS(6024),
    [anon_sym_SEMI] = ACTIONS(6024),
    [anon_sym_then] = ACTIONS(6024),
    [anon_sym_LBRACK] = ACTIONS(6024),
    [anon_sym_COLON_COLON2] = ACTIONS(6024),
    [anon_sym_AMP_DOT] = ACTIONS(6024),
    [sym_comment] = ACTIONS(87),
  },
  [7933] = {
    [sym_interpolation] = STATE(9513),
    [aux_sym_heredoc_body_repeat1] = STATE(9513),
    [sym__heredoc_content] = ACTIONS(13052),
    [sym_heredoc_end] = ACTIONS(13054),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(13052),
  },
  [7934] = {
    [sym_heredoc_body] = STATE(9514),
    [aux_sym_call_repeat1] = STATE(9514),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(11191),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7935] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5553),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym__argument] = STATE(9515),
    [sym_splat_argument] = STATE(9515),
    [sym_hash_splat_argument] = STATE(9515),
    [sym_block_argument] = STATE(9515),
    [sym_assignment] = STATE(5553),
    [sym_operator_assignment] = STATE(5553),
    [sym_conditional] = STATE(5553),
    [sym_range] = STATE(5553),
    [sym_binary] = STATE(5553),
    [sym_unary] = STATE(5553),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5560),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9516),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(9515),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8521),
    [sym__splat_star] = ACTIONS(8523),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__identifier_hash_key] = ACTIONS(8527),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8531),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(8551),
    [sym_identifier] = ACTIONS(8551),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7936] = {
    [sym_heredoc_body] = STATE(9517),
    [aux_sym_call_repeat1] = STATE(9517),
    [aux_sym_argument_list_repeat1] = STATE(9518),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(11191),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4246),
    [anon_sym_COMMA] = ACTIONS(11193),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7937] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9519),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_splat_argument] = STATE(9520),
    [sym_assignment] = STATE(9519),
    [sym_operator_assignment] = STATE(9519),
    [sym_conditional] = STATE(9519),
    [sym_range] = STATE(9519),
    [sym_binary] = STATE(9519),
    [sym_unary] = STATE(9519),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(9520),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(11151),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7938] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9521),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(9521),
    [sym_operator_assignment] = STATE(9521),
    [sym_conditional] = STATE(9521),
    [sym_range] = STATE(9521),
    [sym_binary] = STATE(9521),
    [sym_unary] = STATE(9521),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7939] = {
    [sym_string] = STATE(9522),
    [aux_sym_chained_string_repeat1] = STATE(9522),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [7940] = {
    [anon_sym_end] = ACTIONS(13056),
    [anon_sym_else] = ACTIONS(13056),
    [anon_sym_ensure] = ACTIONS(13056),
    [sym_comment] = ACTIONS(87),
  },
  [7941] = {
    [sym_rescue] = STATE(9523),
    [anon_sym_end] = ACTIONS(13056),
    [anon_sym_rescue] = ACTIONS(2169),
    [anon_sym_else] = ACTIONS(13056),
    [anon_sym_ensure] = ACTIONS(13056),
    [sym_comment] = ACTIONS(87),
  },
  [7942] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9524),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_assignment] = STATE(9524),
    [sym_operator_assignment] = STATE(9524),
    [sym_conditional] = STATE(9524),
    [sym_range] = STATE(9524),
    [sym_binary] = STATE(9524),
    [sym_unary] = STATE(9524),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7943] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7944] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7945] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7946] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [7947] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7948] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7949] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7950] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13058),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7951] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7952] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7953] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7954] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7955] = {
    [sym_heredoc_body] = STATE(7955),
    [aux_sym_call_repeat1] = STATE(7955),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [7956] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3074),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(3074),
    [sym_operator_assignment] = STATE(3074),
    [sym_conditional] = STATE(3074),
    [sym_range] = STATE(3074),
    [sym_binary] = STATE(3074),
    [sym_unary] = STATE(3074),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3080),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5000),
    [sym__splat_star] = ACTIONS(5002),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__identifier_hash_key] = ACTIONS(5006),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11209),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5024),
    [sym_identifier] = ACTIONS(5024),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [7957] = {
    [sym_heredoc_body] = STATE(7955),
    [aux_sym_call_repeat1] = STATE(7955),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [7958] = {
    [aux_sym_argument_list_repeat1] = STATE(7958),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13060),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [7959] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7960] = {
    [aux_sym_exceptions_repeat1] = STATE(9527),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [7961] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [7962] = {
    [sym_string] = STATE(7962),
    [aux_sym_chained_string_repeat1] = STATE(7962),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [7963] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_EQ_TILDE] = ACTIONS(4990),
    [anon_sym_BANG_TILDE] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [7964] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5601),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1169),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(1169),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(5601),
    [sym_operator_assignment] = STATE(5601),
    [sym_conditional] = STATE(5601),
    [sym_range] = STATE(5601),
    [sym_binary] = STATE(5601),
    [sym_unary] = STATE(5601),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(1168),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1169),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1169),
    [sym_false] = STATE(1169),
    [sym_nil] = STATE(1169),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(8607),
    [sym__unary_minus] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2097),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2103),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7965] = {
    [aux_sym_exceptions_repeat1] = STATE(9528),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(13063),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [7966] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [7967] = {
    [sym_heredoc_body] = STATE(9529),
    [aux_sym_call_repeat1] = STATE(9529),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [7968] = {
    [sym_heredoc_body] = STATE(9529),
    [aux_sym_call_repeat1] = STATE(9529),
    [aux_sym_argument_list_repeat1] = STATE(9530),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8675),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_ensure] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [7969] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11226),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [7970] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9531),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(9531),
    [sym_operator_assignment] = STATE(9531),
    [sym_conditional] = STATE(9531),
    [sym_range] = STATE(9531),
    [sym_binary] = STATE(9531),
    [sym_unary] = STATE(9531),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7971] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9532),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(9532),
    [sym_operator_assignment] = STATE(9532),
    [sym_conditional] = STATE(9532),
    [sym_range] = STATE(9532),
    [sym_binary] = STATE(9532),
    [sym_unary] = STATE(9532),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7972] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9533),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(9533),
    [sym_operator_assignment] = STATE(9533),
    [sym_conditional] = STATE(9533),
    [sym_range] = STATE(9533),
    [sym_binary] = STATE(9533),
    [sym_unary] = STATE(9533),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7973] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9534),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(9534),
    [sym_operator_assignment] = STATE(9534),
    [sym_conditional] = STATE(9534),
    [sym_range] = STATE(9534),
    [sym_binary] = STATE(9534),
    [sym_unary] = STATE(9534),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7974] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9535),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(9535),
    [sym_operator_assignment] = STATE(9535),
    [sym_conditional] = STATE(9535),
    [sym_range] = STATE(9535),
    [sym_binary] = STATE(9535),
    [sym_unary] = STATE(9535),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7975] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9536),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9536),
    [sym_operator_assignment] = STATE(9536),
    [sym_conditional] = STATE(9536),
    [sym_range] = STATE(9536),
    [sym_binary] = STATE(9536),
    [sym_unary] = STATE(9536),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7976] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9537),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(9537),
    [sym_operator_assignment] = STATE(9537),
    [sym_conditional] = STATE(9537),
    [sym_range] = STATE(9537),
    [sym_binary] = STATE(9537),
    [sym_unary] = STATE(9537),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7977] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9538),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(9538),
    [sym_operator_assignment] = STATE(9538),
    [sym_conditional] = STATE(9538),
    [sym_range] = STATE(9538),
    [sym_binary] = STATE(9538),
    [sym_unary] = STATE(9538),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7978] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9539),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(9539),
    [sym_operator_assignment] = STATE(9539),
    [sym_conditional] = STATE(9539),
    [sym_range] = STATE(9539),
    [sym_binary] = STATE(9539),
    [sym_unary] = STATE(9539),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7979] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9540),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(9540),
    [sym_operator_assignment] = STATE(9540),
    [sym_conditional] = STATE(9540),
    [sym_range] = STATE(9540),
    [sym_binary] = STATE(9540),
    [sym_unary] = STATE(9540),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7980] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9541),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_splat_argument] = STATE(9542),
    [sym_assignment] = STATE(9541),
    [sym_operator_assignment] = STATE(9541),
    [sym_conditional] = STATE(9541),
    [sym_range] = STATE(9541),
    [sym_binary] = STATE(9541),
    [sym_unary] = STATE(9541),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(9542),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7981] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9543),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(9543),
    [sym_operator_assignment] = STATE(9543),
    [sym_conditional] = STATE(9543),
    [sym_range] = STATE(9543),
    [sym_binary] = STATE(9543),
    [sym_unary] = STATE(9543),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7982] = {
    [sym_string] = STATE(9544),
    [aux_sym_chained_string_repeat1] = STATE(9544),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_ensure] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [7983] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_ensure] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(11226),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [7984] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_ensure] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [7985] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_ensure] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [7986] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9545),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(9545),
    [sym_operator_assignment] = STATE(9545),
    [sym_conditional] = STATE(9545),
    [sym_range] = STATE(9545),
    [sym_binary] = STATE(9545),
    [sym_unary] = STATE(9545),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7987] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_ensure] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [7988] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9546),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(9546),
    [sym_operator_assignment] = STATE(9546),
    [sym_conditional] = STATE(9546),
    [sym_range] = STATE(9546),
    [sym_binary] = STATE(9546),
    [sym_unary] = STATE(9546),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7989] = {
    [sym_heredoc_body] = STATE(9547),
    [aux_sym_call_repeat1] = STATE(9547),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7990] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5626),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(5626),
    [sym_operator_assignment] = STATE(5626),
    [sym_conditional] = STATE(5626),
    [sym_range] = STATE(5626),
    [sym_binary] = STATE(5626),
    [sym_unary] = STATE(5626),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5629),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9548),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8631),
    [sym__splat_star] = ACTIONS(8633),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__identifier_hash_key] = ACTIONS(8635),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13065),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(8637),
    [sym_identifier] = ACTIONS(8637),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7991] = {
    [sym_heredoc_body] = STATE(9549),
    [aux_sym_call_repeat1] = STATE(9549),
    [aux_sym_argument_list_repeat1] = STATE(9550),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(11252),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [7992] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_ensure] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(11226),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [7993] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [7994] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [7995] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [7996] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [7997] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [7998] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13067),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [7999] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [8000] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [8001] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [8002] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [8003] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_ensure] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8004] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_ensure] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8005] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9552),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(9552),
    [sym_operator_assignment] = STATE(9552),
    [sym_conditional] = STATE(9552),
    [sym_range] = STATE(9552),
    [sym_binary] = STATE(9552),
    [sym_unary] = STATE(9552),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8006] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_ensure] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8007] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9553),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(9553),
    [sym_operator_assignment] = STATE(9553),
    [sym_conditional] = STATE(9553),
    [sym_range] = STATE(9553),
    [sym_binary] = STATE(9553),
    [sym_unary] = STATE(9553),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8008] = {
    [sym_heredoc_body] = STATE(9554),
    [aux_sym_call_repeat1] = STATE(9554),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [8009] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5647),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(5647),
    [sym_operator_assignment] = STATE(5647),
    [sym_conditional] = STATE(5647),
    [sym_range] = STATE(5647),
    [sym_binary] = STATE(5647),
    [sym_unary] = STATE(5647),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5650),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(9555),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8667),
    [sym__splat_star] = ACTIONS(8669),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__identifier_hash_key] = ACTIONS(8671),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13069),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(8673),
    [sym_identifier] = ACTIONS(8673),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8010] = {
    [sym_heredoc_body] = STATE(9556),
    [aux_sym_call_repeat1] = STATE(9556),
    [aux_sym_argument_list_repeat1] = STATE(9557),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(11260),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [8011] = {
    [sym_heredoc_body] = STATE(8011),
    [aux_sym_call_repeat1] = STATE(8011),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_ensure] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8012] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3099),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(3099),
    [sym_operator_assignment] = STATE(3099),
    [sym_conditional] = STATE(3099),
    [sym_range] = STATE(3099),
    [sym_binary] = STATE(3099),
    [sym_unary] = STATE(3099),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3105),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5042),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__identifier_hash_key] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11264),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5066),
    [sym_identifier] = ACTIONS(5066),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8013] = {
    [sym_heredoc_body] = STATE(8011),
    [aux_sym_call_repeat1] = STATE(8011),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_ensure] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8014] = {
    [aux_sym_argument_list_repeat1] = STATE(8014),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13071),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [8015] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_ensure] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [8016] = {
    [aux_sym_exceptions_repeat1] = STATE(9559),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8017] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [8018] = {
    [sym_string] = STATE(8018),
    [aux_sym_chained_string_repeat1] = STATE(8018),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_ensure] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [8019] = {
    [aux_sym_undef_repeat1] = STATE(8019),
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9006),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_end] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [anon_sym_ensure] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [8020] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(1182),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1182),
    [sym_unless_modifier] = STATE(1182),
    [sym_while_modifier] = STATE(1182),
    [sym_until_modifier] = STATE(1182),
    [sym_rescue_modifier] = STATE(1182),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1183),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(1183),
    [sym_operator_assignment] = STATE(1183),
    [sym_conditional] = STATE(1183),
    [sym_range] = STATE(1183),
    [sym_binary] = STATE(1183),
    [sym_unary] = STATE(1183),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_undef] = STATE(1182),
    [sym_alias] = STATE(1182),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1182),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [anon_sym_undef] = ACTIONS(2137),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8021] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9560),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1186),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(1186),
    [sym_assignment] = STATE(9560),
    [sym_operator_assignment] = STATE(9560),
    [sym_conditional] = STATE(9560),
    [sym_range] = STATE(9560),
    [sym_binary] = STATE(9560),
    [sym_unary] = STATE(9560),
    [sym_left_assignment_list] = STATE(1185),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1186),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1186),
    [sym_false] = STATE(1186),
    [sym_nil] = STATE(1186),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1187),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2125),
    [anon_sym_defined_QMARK] = ACTIONS(2127),
    [anon_sym_not] = ACTIONS(2129),
    [anon_sym_BANG] = ACTIONS(2131),
    [anon_sym_TILDE] = ACTIONS(2131),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8022] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [8023] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [8024] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9561),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(9561),
    [sym_operator_assignment] = STATE(9561),
    [sym_conditional] = STATE(9561),
    [sym_range] = STATE(9561),
    [sym_binary] = STATE(9561),
    [sym_unary] = STATE(9561),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8025] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9562),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(9562),
    [sym_operator_assignment] = STATE(9562),
    [sym_conditional] = STATE(9562),
    [sym_range] = STATE(9562),
    [sym_binary] = STATE(9562),
    [sym_unary] = STATE(9562),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8026] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9563),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(9563),
    [sym_operator_assignment] = STATE(9563),
    [sym_conditional] = STATE(9563),
    [sym_range] = STATE(9563),
    [sym_binary] = STATE(9563),
    [sym_unary] = STATE(9563),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8027] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9564),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(9564),
    [sym_operator_assignment] = STATE(9564),
    [sym_conditional] = STATE(9564),
    [sym_range] = STATE(9564),
    [sym_binary] = STATE(9564),
    [sym_unary] = STATE(9564),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8028] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9565),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(9565),
    [sym_operator_assignment] = STATE(9565),
    [sym_conditional] = STATE(9565),
    [sym_range] = STATE(9565),
    [sym_binary] = STATE(9565),
    [sym_unary] = STATE(9565),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8029] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9566),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9566),
    [sym_operator_assignment] = STATE(9566),
    [sym_conditional] = STATE(9566),
    [sym_range] = STATE(9566),
    [sym_binary] = STATE(9566),
    [sym_unary] = STATE(9566),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8030] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9567),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(9567),
    [sym_operator_assignment] = STATE(9567),
    [sym_conditional] = STATE(9567),
    [sym_range] = STATE(9567),
    [sym_binary] = STATE(9567),
    [sym_unary] = STATE(9567),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8031] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9568),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(9568),
    [sym_operator_assignment] = STATE(9568),
    [sym_conditional] = STATE(9568),
    [sym_range] = STATE(9568),
    [sym_binary] = STATE(9568),
    [sym_unary] = STATE(9568),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8032] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9569),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(9569),
    [sym_operator_assignment] = STATE(9569),
    [sym_conditional] = STATE(9569),
    [sym_range] = STATE(9569),
    [sym_binary] = STATE(9569),
    [sym_unary] = STATE(9569),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8033] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9570),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(9570),
    [sym_operator_assignment] = STATE(9570),
    [sym_conditional] = STATE(9570),
    [sym_range] = STATE(9570),
    [sym_binary] = STATE(9570),
    [sym_unary] = STATE(9570),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8034] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9571),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_splat_argument] = STATE(9572),
    [sym_assignment] = STATE(9571),
    [sym_operator_assignment] = STATE(9571),
    [sym_conditional] = STATE(9571),
    [sym_range] = STATE(9571),
    [sym_binary] = STATE(9571),
    [sym_unary] = STATE(9571),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(9572),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(5118),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8035] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9573),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(9573),
    [sym_operator_assignment] = STATE(9573),
    [sym_conditional] = STATE(9573),
    [sym_range] = STATE(9573),
    [sym_binary] = STATE(9573),
    [sym_unary] = STATE(9573),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8036] = {
    [sym_string] = STATE(9574),
    [aux_sym_chained_string_repeat1] = STATE(9574),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_ensure] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [8037] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_ensure] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [8038] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_ensure] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [8039] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8040] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [8041] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8042] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8043] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8044] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13074),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8045] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8046] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8047] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8048] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8049] = {
    [sym_heredoc_body] = STATE(8049),
    [aux_sym_call_repeat1] = STATE(8049),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_ensure] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [8050] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3137),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(3137),
    [sym_operator_assignment] = STATE(3137),
    [sym_conditional] = STATE(3137),
    [sym_range] = STATE(3137),
    [sym_binary] = STATE(3137),
    [sym_unary] = STATE(3137),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3143),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5116),
    [sym__splat_star] = ACTIONS(5118),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__identifier_hash_key] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11305),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5140),
    [sym_identifier] = ACTIONS(5140),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8051] = {
    [sym_heredoc_body] = STATE(8049),
    [aux_sym_call_repeat1] = STATE(8049),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_ensure] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [8052] = {
    [aux_sym_argument_list_repeat1] = STATE(8052),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13076),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [8053] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_ensure] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8054] = {
    [aux_sym_exceptions_repeat1] = STATE(9577),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [8055] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [8056] = {
    [sym_string] = STATE(8056),
    [aux_sym_chained_string_repeat1] = STATE(8056),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_ensure] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [8057] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11311),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(11313),
    [anon_sym_LT] = ACTIONS(11315),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_ensure] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_DOT_DOT] = ACTIONS(11319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11321),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11323),
    [anon_sym_AMP_AMP] = ACTIONS(11323),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(11327),
    [anon_sym_BANG_EQ] = ACTIONS(11323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11323),
    [anon_sym_LT_EQ_GT] = ACTIONS(11323),
    [anon_sym_EQ_TILDE] = ACTIONS(11323),
    [anon_sym_BANG_TILDE] = ACTIONS(11323),
    [anon_sym_LT_EQ] = ACTIONS(11315),
    [anon_sym_GT] = ACTIONS(11315),
    [anon_sym_GT_EQ] = ACTIONS(11329),
    [anon_sym_CARET] = ACTIONS(11331),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [8058] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8059] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11311),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(11313),
    [anon_sym_LT] = ACTIONS(11315),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_ensure] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_DOT_DOT] = ACTIONS(11319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11321),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11323),
    [anon_sym_AMP_AMP] = ACTIONS(11323),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(11327),
    [anon_sym_BANG_EQ] = ACTIONS(11323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11323),
    [anon_sym_LT_EQ_GT] = ACTIONS(11323),
    [anon_sym_EQ_TILDE] = ACTIONS(11323),
    [anon_sym_BANG_TILDE] = ACTIONS(11323),
    [anon_sym_LT_EQ] = ACTIONS(11315),
    [anon_sym_GT] = ACTIONS(11315),
    [anon_sym_GT_EQ] = ACTIONS(11329),
    [anon_sym_CARET] = ACTIONS(11331),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [8060] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9578),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(9578),
    [sym_operator_assignment] = STATE(9578),
    [sym_conditional] = STATE(9578),
    [sym_range] = STATE(9578),
    [sym_binary] = STATE(9578),
    [sym_unary] = STATE(9578),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8061] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9579),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(9579),
    [sym_operator_assignment] = STATE(9579),
    [sym_conditional] = STATE(9579),
    [sym_range] = STATE(9579),
    [sym_binary] = STATE(9579),
    [sym_unary] = STATE(9579),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8062] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9580),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(9580),
    [sym_operator_assignment] = STATE(9580),
    [sym_conditional] = STATE(9580),
    [sym_range] = STATE(9580),
    [sym_binary] = STATE(9580),
    [sym_unary] = STATE(9580),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8063] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9581),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(9581),
    [sym_operator_assignment] = STATE(9581),
    [sym_conditional] = STATE(9581),
    [sym_range] = STATE(9581),
    [sym_binary] = STATE(9581),
    [sym_unary] = STATE(9581),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8064] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9582),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(9582),
    [sym_operator_assignment] = STATE(9582),
    [sym_conditional] = STATE(9582),
    [sym_range] = STATE(9582),
    [sym_binary] = STATE(9582),
    [sym_unary] = STATE(9582),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8065] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9583),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9583),
    [sym_operator_assignment] = STATE(9583),
    [sym_conditional] = STATE(9583),
    [sym_range] = STATE(9583),
    [sym_binary] = STATE(9583),
    [sym_unary] = STATE(9583),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8066] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9584),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(9584),
    [sym_operator_assignment] = STATE(9584),
    [sym_conditional] = STATE(9584),
    [sym_range] = STATE(9584),
    [sym_binary] = STATE(9584),
    [sym_unary] = STATE(9584),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8067] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9585),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(9585),
    [sym_operator_assignment] = STATE(9585),
    [sym_conditional] = STATE(9585),
    [sym_range] = STATE(9585),
    [sym_binary] = STATE(9585),
    [sym_unary] = STATE(9585),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8068] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9586),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(9586),
    [sym_operator_assignment] = STATE(9586),
    [sym_conditional] = STATE(9586),
    [sym_range] = STATE(9586),
    [sym_binary] = STATE(9586),
    [sym_unary] = STATE(9586),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8069] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9587),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(9587),
    [sym_operator_assignment] = STATE(9587),
    [sym_conditional] = STATE(9587),
    [sym_range] = STATE(9587),
    [sym_binary] = STATE(9587),
    [sym_unary] = STATE(9587),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8070] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5714),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(5714),
    [sym_operator_assignment] = STATE(5714),
    [sym_conditional] = STATE(5714),
    [sym_range] = STATE(5714),
    [sym_binary] = STATE(5714),
    [sym_unary] = STATE(5714),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8753),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8071] = {
    [aux_sym_exceptions_repeat1] = STATE(9588),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_ensure] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8072] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5714),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_splat_argument] = STATE(9589),
    [sym_assignment] = STATE(5714),
    [sym_operator_assignment] = STATE(5714),
    [sym_conditional] = STATE(5714),
    [sym_range] = STATE(5714),
    [sym_binary] = STATE(5714),
    [sym_unary] = STATE(5714),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(9589),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8753),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8073] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9590),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(9590),
    [sym_operator_assignment] = STATE(9590),
    [sym_conditional] = STATE(9590),
    [sym_range] = STATE(9590),
    [sym_binary] = STATE(9590),
    [sym_unary] = STATE(9590),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8074] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8075] = {
    [sym_heredoc_body] = STATE(9591),
    [aux_sym_call_repeat1] = STATE(9591),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [8076] = {
    [sym_heredoc_body] = STATE(9591),
    [aux_sym_call_repeat1] = STATE(9591),
    [aux_sym_argument_list_repeat1] = STATE(9592),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(8833),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [8077] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [8078] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9593),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(9593),
    [sym_operator_assignment] = STATE(9593),
    [sym_conditional] = STATE(9593),
    [sym_range] = STATE(9593),
    [sym_binary] = STATE(9593),
    [sym_unary] = STATE(9593),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8079] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9594),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(9594),
    [sym_operator_assignment] = STATE(9594),
    [sym_conditional] = STATE(9594),
    [sym_range] = STATE(9594),
    [sym_binary] = STATE(9594),
    [sym_unary] = STATE(9594),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8080] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9595),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(9595),
    [sym_operator_assignment] = STATE(9595),
    [sym_conditional] = STATE(9595),
    [sym_range] = STATE(9595),
    [sym_binary] = STATE(9595),
    [sym_unary] = STATE(9595),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8081] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9596),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(9596),
    [sym_operator_assignment] = STATE(9596),
    [sym_conditional] = STATE(9596),
    [sym_range] = STATE(9596),
    [sym_binary] = STATE(9596),
    [sym_unary] = STATE(9596),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8082] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9597),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(9597),
    [sym_operator_assignment] = STATE(9597),
    [sym_conditional] = STATE(9597),
    [sym_range] = STATE(9597),
    [sym_binary] = STATE(9597),
    [sym_unary] = STATE(9597),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8083] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9598),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9598),
    [sym_operator_assignment] = STATE(9598),
    [sym_conditional] = STATE(9598),
    [sym_range] = STATE(9598),
    [sym_binary] = STATE(9598),
    [sym_unary] = STATE(9598),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8084] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9599),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(9599),
    [sym_operator_assignment] = STATE(9599),
    [sym_conditional] = STATE(9599),
    [sym_range] = STATE(9599),
    [sym_binary] = STATE(9599),
    [sym_unary] = STATE(9599),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8085] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9600),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(9600),
    [sym_operator_assignment] = STATE(9600),
    [sym_conditional] = STATE(9600),
    [sym_range] = STATE(9600),
    [sym_binary] = STATE(9600),
    [sym_unary] = STATE(9600),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8086] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9601),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(9601),
    [sym_operator_assignment] = STATE(9601),
    [sym_conditional] = STATE(9601),
    [sym_range] = STATE(9601),
    [sym_binary] = STATE(9601),
    [sym_unary] = STATE(9601),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8087] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9602),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(9602),
    [sym_operator_assignment] = STATE(9602),
    [sym_conditional] = STATE(9602),
    [sym_range] = STATE(9602),
    [sym_binary] = STATE(9602),
    [sym_unary] = STATE(9602),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8088] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9603),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_splat_argument] = STATE(9604),
    [sym_assignment] = STATE(9603),
    [sym_operator_assignment] = STATE(9603),
    [sym_conditional] = STATE(9603),
    [sym_range] = STATE(9603),
    [sym_binary] = STATE(9603),
    [sym_unary] = STATE(9603),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(9604),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8089] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9605),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(9605),
    [sym_operator_assignment] = STATE(9605),
    [sym_conditional] = STATE(9605),
    [sym_range] = STATE(9605),
    [sym_binary] = STATE(9605),
    [sym_unary] = STATE(9605),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8090] = {
    [sym_string] = STATE(9606),
    [aux_sym_chained_string_repeat1] = STATE(9606),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [8091] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [8092] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8093] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8094] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9607),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(9607),
    [sym_operator_assignment] = STATE(9607),
    [sym_conditional] = STATE(9607),
    [sym_range] = STATE(9607),
    [sym_binary] = STATE(9607),
    [sym_unary] = STATE(9607),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8095] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8096] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9608),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(9608),
    [sym_operator_assignment] = STATE(9608),
    [sym_conditional] = STATE(9608),
    [sym_range] = STATE(9608),
    [sym_binary] = STATE(9608),
    [sym_unary] = STATE(9608),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8097] = {
    [sym_heredoc_body] = STATE(9609),
    [aux_sym_call_repeat1] = STATE(9609),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [8098] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5741),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(5741),
    [sym_operator_assignment] = STATE(5741),
    [sym_conditional] = STATE(5741),
    [sym_range] = STATE(5741),
    [sym_binary] = STATE(5741),
    [sym_unary] = STATE(5741),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5744),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(9610),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8789),
    [sym__splat_star] = ACTIONS(8791),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__identifier_hash_key] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(8795),
    [sym_identifier] = ACTIONS(8795),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8099] = {
    [sym_heredoc_body] = STATE(9611),
    [aux_sym_call_repeat1] = STATE(9611),
    [aux_sym_argument_list_repeat1] = STATE(9612),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(11377),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [8100] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [8101] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8102] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8103] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8104] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8105] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8106] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13081),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8107] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8108] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8109] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8110] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8111] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8112] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8113] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9614),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(9614),
    [sym_operator_assignment] = STATE(9614),
    [sym_conditional] = STATE(9614),
    [sym_range] = STATE(9614),
    [sym_binary] = STATE(9614),
    [sym_unary] = STATE(9614),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8114] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8115] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9615),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(9615),
    [sym_operator_assignment] = STATE(9615),
    [sym_conditional] = STATE(9615),
    [sym_range] = STATE(9615),
    [sym_binary] = STATE(9615),
    [sym_unary] = STATE(9615),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8116] = {
    [sym_heredoc_body] = STATE(9616),
    [aux_sym_call_repeat1] = STATE(9616),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [8117] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(5762),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5765),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(9617),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8825),
    [sym__splat_star] = ACTIONS(8827),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__identifier_hash_key] = ACTIONS(8829),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13083),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(8831),
    [sym_identifier] = ACTIONS(8831),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8118] = {
    [sym_heredoc_body] = STATE(9618),
    [aux_sym_call_repeat1] = STATE(9618),
    [aux_sym_argument_list_repeat1] = STATE(9619),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(11385),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [8119] = {
    [sym_heredoc_body] = STATE(8119),
    [aux_sym_call_repeat1] = STATE(8119),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8120] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3161),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(3161),
    [sym_operator_assignment] = STATE(3161),
    [sym_conditional] = STATE(3161),
    [sym_range] = STATE(3161),
    [sym_binary] = STATE(3161),
    [sym_unary] = STATE(3161),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3167),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5154),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__identifier_hash_key] = ACTIONS(5160),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11389),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5178),
    [sym_identifier] = ACTIONS(5178),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8121] = {
    [sym_heredoc_body] = STATE(8119),
    [aux_sym_call_repeat1] = STATE(8119),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8122] = {
    [aux_sym_argument_list_repeat1] = STATE(8122),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13085),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [8123] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8124] = {
    [aux_sym_exceptions_repeat1] = STATE(9621),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8125] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [8126] = {
    [sym_string] = STATE(8126),
    [aux_sym_chained_string_repeat1] = STATE(8126),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [8127] = {
    [aux_sym_undef_repeat1] = STATE(8127),
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9006),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_end] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [8128] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8129] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9622),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(9622),
    [sym_operator_assignment] = STATE(9622),
    [sym_conditional] = STATE(9622),
    [sym_range] = STATE(9622),
    [sym_binary] = STATE(9622),
    [sym_unary] = STATE(9622),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8130] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [8131] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [8132] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9623),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(9623),
    [sym_operator_assignment] = STATE(9623),
    [sym_conditional] = STATE(9623),
    [sym_range] = STATE(9623),
    [sym_binary] = STATE(9623),
    [sym_unary] = STATE(9623),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8133] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9624),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(9624),
    [sym_operator_assignment] = STATE(9624),
    [sym_conditional] = STATE(9624),
    [sym_range] = STATE(9624),
    [sym_binary] = STATE(9624),
    [sym_unary] = STATE(9624),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8134] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9625),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(9625),
    [sym_operator_assignment] = STATE(9625),
    [sym_conditional] = STATE(9625),
    [sym_range] = STATE(9625),
    [sym_binary] = STATE(9625),
    [sym_unary] = STATE(9625),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8135] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9626),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(9626),
    [sym_operator_assignment] = STATE(9626),
    [sym_conditional] = STATE(9626),
    [sym_range] = STATE(9626),
    [sym_binary] = STATE(9626),
    [sym_unary] = STATE(9626),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8136] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9627),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(9627),
    [sym_operator_assignment] = STATE(9627),
    [sym_conditional] = STATE(9627),
    [sym_range] = STATE(9627),
    [sym_binary] = STATE(9627),
    [sym_unary] = STATE(9627),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8137] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9628),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9628),
    [sym_operator_assignment] = STATE(9628),
    [sym_conditional] = STATE(9628),
    [sym_range] = STATE(9628),
    [sym_binary] = STATE(9628),
    [sym_unary] = STATE(9628),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8138] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9629),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(9629),
    [sym_operator_assignment] = STATE(9629),
    [sym_conditional] = STATE(9629),
    [sym_range] = STATE(9629),
    [sym_binary] = STATE(9629),
    [sym_unary] = STATE(9629),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8139] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9630),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(9630),
    [sym_operator_assignment] = STATE(9630),
    [sym_conditional] = STATE(9630),
    [sym_range] = STATE(9630),
    [sym_binary] = STATE(9630),
    [sym_unary] = STATE(9630),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8140] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9631),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(9631),
    [sym_operator_assignment] = STATE(9631),
    [sym_conditional] = STATE(9631),
    [sym_range] = STATE(9631),
    [sym_binary] = STATE(9631),
    [sym_unary] = STATE(9631),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8141] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9632),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(9632),
    [sym_operator_assignment] = STATE(9632),
    [sym_conditional] = STATE(9632),
    [sym_range] = STATE(9632),
    [sym_binary] = STATE(9632),
    [sym_unary] = STATE(9632),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8142] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9633),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_splat_argument] = STATE(9634),
    [sym_assignment] = STATE(9633),
    [sym_operator_assignment] = STATE(9633),
    [sym_conditional] = STATE(9633),
    [sym_range] = STATE(9633),
    [sym_binary] = STATE(9633),
    [sym_unary] = STATE(9633),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(9634),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(5230),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8143] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9635),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(9635),
    [sym_operator_assignment] = STATE(9635),
    [sym_conditional] = STATE(9635),
    [sym_range] = STATE(9635),
    [sym_binary] = STATE(9635),
    [sym_unary] = STATE(9635),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8144] = {
    [sym_string] = STATE(9636),
    [aux_sym_chained_string_repeat1] = STATE(9636),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [8145] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [8146] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [8147] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8148] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [8149] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8150] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8151] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8152] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13088),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8153] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8154] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8155] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8156] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8157] = {
    [sym_heredoc_body] = STATE(8157),
    [aux_sym_call_repeat1] = STATE(8157),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [8158] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3199),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(3199),
    [sym_operator_assignment] = STATE(3199),
    [sym_conditional] = STATE(3199),
    [sym_range] = STATE(3199),
    [sym_binary] = STATE(3199),
    [sym_unary] = STATE(3199),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3205),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5228),
    [sym__splat_star] = ACTIONS(5230),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__identifier_hash_key] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11430),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5252),
    [sym_identifier] = ACTIONS(5252),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8159] = {
    [sym_heredoc_body] = STATE(8157),
    [aux_sym_call_repeat1] = STATE(8157),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [8160] = {
    [aux_sym_argument_list_repeat1] = STATE(8160),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13090),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [8161] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8162] = {
    [aux_sym_exceptions_repeat1] = STATE(9639),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [8163] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [8164] = {
    [sym_string] = STATE(8164),
    [aux_sym_chained_string_repeat1] = STATE(8164),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [8165] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11436),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(11438),
    [anon_sym_LT] = ACTIONS(11440),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11442),
    [anon_sym_DOT_DOT] = ACTIONS(11444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11446),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11448),
    [anon_sym_AMP_AMP] = ACTIONS(11448),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(11452),
    [anon_sym_BANG_EQ] = ACTIONS(11448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11448),
    [anon_sym_LT_EQ_GT] = ACTIONS(11448),
    [anon_sym_EQ_TILDE] = ACTIONS(11448),
    [anon_sym_BANG_TILDE] = ACTIONS(11448),
    [anon_sym_LT_EQ] = ACTIONS(11440),
    [anon_sym_GT] = ACTIONS(11440),
    [anon_sym_GT_EQ] = ACTIONS(11454),
    [anon_sym_CARET] = ACTIONS(11456),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [8166] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8167] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11436),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(11438),
    [anon_sym_LT] = ACTIONS(11440),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11442),
    [anon_sym_DOT_DOT] = ACTIONS(11444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11446),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11448),
    [anon_sym_AMP_AMP] = ACTIONS(11448),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(11452),
    [anon_sym_BANG_EQ] = ACTIONS(11448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11448),
    [anon_sym_LT_EQ_GT] = ACTIONS(11448),
    [anon_sym_EQ_TILDE] = ACTIONS(11448),
    [anon_sym_BANG_TILDE] = ACTIONS(11448),
    [anon_sym_LT_EQ] = ACTIONS(11440),
    [anon_sym_GT] = ACTIONS(11440),
    [anon_sym_GT_EQ] = ACTIONS(11454),
    [anon_sym_CARET] = ACTIONS(11456),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [8168] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9640),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(9640),
    [sym_operator_assignment] = STATE(9640),
    [sym_conditional] = STATE(9640),
    [sym_range] = STATE(9640),
    [sym_binary] = STATE(9640),
    [sym_unary] = STATE(9640),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8169] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9641),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(9641),
    [sym_operator_assignment] = STATE(9641),
    [sym_conditional] = STATE(9641),
    [sym_range] = STATE(9641),
    [sym_binary] = STATE(9641),
    [sym_unary] = STATE(9641),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8170] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9642),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(9642),
    [sym_operator_assignment] = STATE(9642),
    [sym_conditional] = STATE(9642),
    [sym_range] = STATE(9642),
    [sym_binary] = STATE(9642),
    [sym_unary] = STATE(9642),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8171] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9643),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(9643),
    [sym_operator_assignment] = STATE(9643),
    [sym_conditional] = STATE(9643),
    [sym_range] = STATE(9643),
    [sym_binary] = STATE(9643),
    [sym_unary] = STATE(9643),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8172] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9644),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(9644),
    [sym_operator_assignment] = STATE(9644),
    [sym_conditional] = STATE(9644),
    [sym_range] = STATE(9644),
    [sym_binary] = STATE(9644),
    [sym_unary] = STATE(9644),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8173] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9645),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9645),
    [sym_operator_assignment] = STATE(9645),
    [sym_conditional] = STATE(9645),
    [sym_range] = STATE(9645),
    [sym_binary] = STATE(9645),
    [sym_unary] = STATE(9645),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8174] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9646),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(9646),
    [sym_operator_assignment] = STATE(9646),
    [sym_conditional] = STATE(9646),
    [sym_range] = STATE(9646),
    [sym_binary] = STATE(9646),
    [sym_unary] = STATE(9646),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8175] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9647),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(9647),
    [sym_operator_assignment] = STATE(9647),
    [sym_conditional] = STATE(9647),
    [sym_range] = STATE(9647),
    [sym_binary] = STATE(9647),
    [sym_unary] = STATE(9647),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8176] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9648),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(9648),
    [sym_operator_assignment] = STATE(9648),
    [sym_conditional] = STATE(9648),
    [sym_range] = STATE(9648),
    [sym_binary] = STATE(9648),
    [sym_unary] = STATE(9648),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8177] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9649),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(9649),
    [sym_operator_assignment] = STATE(9649),
    [sym_conditional] = STATE(9649),
    [sym_range] = STATE(9649),
    [sym_binary] = STATE(9649),
    [sym_unary] = STATE(9649),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8178] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5829),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(5829),
    [sym_operator_assignment] = STATE(5829),
    [sym_conditional] = STATE(5829),
    [sym_range] = STATE(5829),
    [sym_binary] = STATE(5829),
    [sym_unary] = STATE(5829),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8911),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8179] = {
    [aux_sym_exceptions_repeat1] = STATE(9650),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(11458),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8180] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(5829),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_splat_argument] = STATE(9651),
    [sym_assignment] = STATE(5829),
    [sym_operator_assignment] = STATE(5829),
    [sym_conditional] = STATE(5829),
    [sym_range] = STATE(5829),
    [sym_binary] = STATE(5829),
    [sym_unary] = STATE(5829),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(9651),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8911),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8181] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9652),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(9652),
    [sym_operator_assignment] = STATE(9652),
    [sym_conditional] = STATE(9652),
    [sym_range] = STATE(9652),
    [sym_binary] = STATE(9652),
    [sym_unary] = STATE(9652),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8182] = {
    [sym__line_break] = ACTIONS(13093),
    [sym__heredoc_body_start] = ACTIONS(13093),
    [sym__binary_minus] = ACTIONS(13093),
    [sym__binary_star] = ACTIONS(13093),
    [ts_builtin_sym_end] = ACTIONS(13093),
    [anon_sym___END__] = ACTIONS(13093),
    [anon_sym_LBRACE] = ACTIONS(13093),
    [anon_sym_RBRACE] = ACTIONS(13093),
    [anon_sym_RPAREN] = ACTIONS(13093),
    [anon_sym_DOT] = ACTIONS(13095),
    [anon_sym_COMMA] = ACTIONS(13093),
    [anon_sym_PIPE] = ACTIONS(13095),
    [anon_sym_SEMI] = ACTIONS(13093),
    [anon_sym_STAR_STAR] = ACTIONS(13093),
    [anon_sym_AMP] = ACTIONS(13095),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(13093),
    [anon_sym_if] = ACTIONS(13093),
    [anon_sym_unless] = ACTIONS(13093),
    [anon_sym_while] = ACTIONS(13093),
    [anon_sym_until] = ACTIONS(13093),
    [anon_sym_rescue] = ACTIONS(13093),
    [anon_sym_do] = ACTIONS(13093),
    [anon_sym_when] = ACTIONS(13093),
    [anon_sym_elsif] = ACTIONS(13093),
    [anon_sym_else] = ACTIONS(13093),
    [anon_sym_then] = ACTIONS(13093),
    [anon_sym_ensure] = ACTIONS(13093),
    [anon_sym_EQ_GT] = ACTIONS(13093),
    [anon_sym_LBRACK] = ACTIONS(13093),
    [anon_sym_COLON_COLON2] = ACTIONS(13093),
    [anon_sym_AMP_DOT] = ACTIONS(13093),
    [anon_sym_QMARK] = ACTIONS(13093),
    [anon_sym_DOT_DOT] = ACTIONS(13095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13093),
    [anon_sym_and] = ACTIONS(13093),
    [anon_sym_or] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE] = ACTIONS(13093),
    [anon_sym_AMP_AMP] = ACTIONS(13093),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13095),
    [anon_sym_BANG_EQ] = ACTIONS(13093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13093),
    [anon_sym_LT_EQ_GT] = ACTIONS(13093),
    [anon_sym_EQ_TILDE] = ACTIONS(13093),
    [anon_sym_BANG_TILDE] = ACTIONS(13093),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13093),
    [anon_sym_CARET] = ACTIONS(13093),
    [anon_sym_PLUS] = ACTIONS(13093),
    [anon_sym_SLASH] = ACTIONS(13093),
    [anon_sym_PERCENT] = ACTIONS(13093),
    [sym_comment] = ACTIONS(87),
  },
  [8183] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(2191),
    [sym__binary_star] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2199),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2205),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2209),
    [anon_sym_AMP_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ] = ACTIONS(2209),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2209),
    [anon_sym_LT_EQ_GT] = ACTIONS(2209),
    [anon_sym_EQ_TILDE] = ACTIONS(2209),
    [anon_sym_BANG_TILDE] = ACTIONS(2209),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2199),
    [anon_sym_GT_EQ] = ACTIONS(2215),
    [anon_sym_CARET] = ACTIONS(2217),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(2193),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
  },
  [8184] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [8185] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [8186] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [8187] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [8188] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [8189] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13097),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8190] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [8191] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8946),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [8192] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [8193] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [8194] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_ensure] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(8946),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [8195] = {
    [aux_sym_exceptions_repeat1] = STATE(9655),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [8196] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8946),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [8197] = {
    [sym_string] = STATE(8197),
    [aux_sym_chained_string_repeat1] = STATE(8197),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_ensure] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [8198] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9656),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_assignment] = STATE(9656),
    [sym_operator_assignment] = STATE(9656),
    [sym_conditional] = STATE(9656),
    [sym_range] = STATE(9656),
    [sym_binary] = STATE(9656),
    [sym_unary] = STATE(9656),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8199] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5871),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1245),
    [sym_scope_resolution] = STATE(1241),
    [sym_call] = STATE(1241),
    [sym_method_call] = STATE(1245),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(5871),
    [sym_operator_assignment] = STATE(5871),
    [sym_conditional] = STATE(5871),
    [sym_range] = STATE(5871),
    [sym_binary] = STATE(5871),
    [sym_unary] = STATE(5871),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(1244),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1245),
    [sym__variable] = STATE(1241),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1245),
    [sym_false] = STATE(1245),
    [sym_nil] = STATE(1245),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3244),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(4918),
    [sym__unary_minus] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_next] = ACTIONS(2233),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(5294),
    [anon_sym_defined_QMARK] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [sym_constant] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [sym_instance_variable] = ACTIONS(2245),
    [sym_class_variable] = ACTIONS(2245),
    [sym_global_variable] = ACTIONS(2245),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(2247),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2247),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8200] = {
    [aux_sym_exceptions_repeat1] = STATE(9657),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13099),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_ensure] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [8201] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [8202] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8203] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(8976),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [8204] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [8205] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8974),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(8976),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(8994),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [8206] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13101),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8207] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(8974),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(8976),
    [anon_sym_LT] = ACTIONS(8978),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(8982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8984),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(8986),
    [anon_sym_AMP_AMP] = ACTIONS(8986),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(8990),
    [anon_sym_BANG_EQ] = ACTIONS(8986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8986),
    [anon_sym_LT_EQ_GT] = ACTIONS(8986),
    [anon_sym_EQ_TILDE] = ACTIONS(8986),
    [anon_sym_BANG_TILDE] = ACTIONS(8986),
    [anon_sym_LT_EQ] = ACTIONS(8978),
    [anon_sym_GT] = ACTIONS(8978),
    [anon_sym_GT_EQ] = ACTIONS(8992),
    [anon_sym_CARET] = ACTIONS(8994),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [8208] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8974),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(8976),
    [anon_sym_LT] = ACTIONS(8978),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(8980),
    [anon_sym_DOT_DOT] = ACTIONS(8982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8984),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8986),
    [anon_sym_AMP_AMP] = ACTIONS(8986),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(8990),
    [anon_sym_BANG_EQ] = ACTIONS(8986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8986),
    [anon_sym_LT_EQ_GT] = ACTIONS(8986),
    [anon_sym_EQ_TILDE] = ACTIONS(8986),
    [anon_sym_BANG_TILDE] = ACTIONS(8986),
    [anon_sym_LT_EQ] = ACTIONS(8978),
    [anon_sym_GT] = ACTIONS(8978),
    [anon_sym_GT_EQ] = ACTIONS(8992),
    [anon_sym_CARET] = ACTIONS(8994),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [8209] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(8974),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(8976),
    [anon_sym_LT] = ACTIONS(8978),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(8990),
    [anon_sym_BANG_EQ] = ACTIONS(8986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8986),
    [anon_sym_LT_EQ_GT] = ACTIONS(8986),
    [anon_sym_EQ_TILDE] = ACTIONS(8986),
    [anon_sym_BANG_TILDE] = ACTIONS(8986),
    [anon_sym_LT_EQ] = ACTIONS(8978),
    [anon_sym_GT] = ACTIONS(8978),
    [anon_sym_GT_EQ] = ACTIONS(8992),
    [anon_sym_CARET] = ACTIONS(8994),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [8210] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [8211] = {
    [aux_sym_exceptions_repeat1] = STATE(8211),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13103),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [8212] = {
    [aux_sym_exceptions_repeat1] = STATE(5889),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8213] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(8974),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(8976),
    [anon_sym_LT] = ACTIONS(8978),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(8980),
    [anon_sym_DOT_DOT] = ACTIONS(8982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8984),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(8986),
    [anon_sym_AMP_AMP] = ACTIONS(8986),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(8990),
    [anon_sym_BANG_EQ] = ACTIONS(8986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8986),
    [anon_sym_LT_EQ_GT] = ACTIONS(8986),
    [anon_sym_EQ_TILDE] = ACTIONS(8986),
    [anon_sym_BANG_TILDE] = ACTIONS(8986),
    [anon_sym_LT_EQ] = ACTIONS(8978),
    [anon_sym_GT] = ACTIONS(8978),
    [anon_sym_GT_EQ] = ACTIONS(8992),
    [anon_sym_CARET] = ACTIONS(8994),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [8214] = {
    [sym__heredoc_body_start] = ACTIONS(9793),
    [sym__binary_minus] = ACTIONS(9793),
    [sym__binary_star] = ACTIONS(9793),
    [anon_sym_LBRACE] = ACTIONS(9793),
    [anon_sym_RBRACE] = ACTIONS(9793),
    [anon_sym_RPAREN] = ACTIONS(9793),
    [anon_sym_DOT] = ACTIONS(9795),
    [anon_sym_COMMA] = ACTIONS(9793),
    [anon_sym_PIPE] = ACTIONS(9795),
    [anon_sym_SEMI] = ACTIONS(9793),
    [anon_sym_STAR_STAR] = ACTIONS(9793),
    [anon_sym_AMP] = ACTIONS(9795),
    [anon_sym_EQ] = ACTIONS(9795),
    [anon_sym_LT] = ACTIONS(9795),
    [anon_sym_if] = ACTIONS(9793),
    [anon_sym_unless] = ACTIONS(9793),
    [anon_sym_while] = ACTIONS(9793),
    [anon_sym_until] = ACTIONS(9793),
    [anon_sym_rescue] = ACTIONS(9793),
    [anon_sym_in] = ACTIONS(9793),
    [anon_sym_do] = ACTIONS(9793),
    [anon_sym_EQ_GT] = ACTIONS(9793),
    [anon_sym_LBRACK] = ACTIONS(9793),
    [anon_sym_RBRACK] = ACTIONS(9793),
    [anon_sym_COLON_COLON2] = ACTIONS(9793),
    [anon_sym_AMP_DOT] = ACTIONS(9793),
    [anon_sym_QMARK] = ACTIONS(9793),
    [anon_sym_COLON2] = ACTIONS(9795),
    [anon_sym_DOT_DOT] = ACTIONS(9795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9793),
    [anon_sym_and] = ACTIONS(9793),
    [anon_sym_or] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE] = ACTIONS(9793),
    [anon_sym_AMP_AMP] = ACTIONS(9793),
    [anon_sym_LT_LT] = ACTIONS(9793),
    [anon_sym_GT_GT] = ACTIONS(9793),
    [anon_sym_EQ_EQ] = ACTIONS(9795),
    [anon_sym_BANG_EQ] = ACTIONS(9793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9793),
    [anon_sym_LT_EQ_GT] = ACTIONS(9793),
    [anon_sym_EQ_TILDE] = ACTIONS(9793),
    [anon_sym_BANG_TILDE] = ACTIONS(9793),
    [anon_sym_LT_EQ] = ACTIONS(9795),
    [anon_sym_GT] = ACTIONS(9795),
    [anon_sym_GT_EQ] = ACTIONS(9793),
    [anon_sym_CARET] = ACTIONS(9793),
    [anon_sym_PLUS] = ACTIONS(9793),
    [anon_sym_SLASH] = ACTIONS(9793),
    [anon_sym_PERCENT] = ACTIONS(9793),
    [sym_comment] = ACTIONS(87),
  },
  [8215] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13106),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8216] = {
    [sym__heredoc_body_start] = ACTIONS(9799),
    [sym__binary_minus] = ACTIONS(9799),
    [sym__binary_star] = ACTIONS(9799),
    [anon_sym_LBRACE] = ACTIONS(9799),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [anon_sym_RPAREN] = ACTIONS(9799),
    [anon_sym_DOT] = ACTIONS(9801),
    [anon_sym_COMMA] = ACTIONS(9799),
    [anon_sym_PIPE] = ACTIONS(9801),
    [anon_sym_SEMI] = ACTIONS(9799),
    [anon_sym_STAR_STAR] = ACTIONS(9799),
    [anon_sym_AMP] = ACTIONS(9801),
    [anon_sym_EQ] = ACTIONS(9801),
    [anon_sym_LT] = ACTIONS(9801),
    [anon_sym_if] = ACTIONS(9799),
    [anon_sym_unless] = ACTIONS(9799),
    [anon_sym_while] = ACTIONS(9799),
    [anon_sym_until] = ACTIONS(9799),
    [anon_sym_rescue] = ACTIONS(9799),
    [anon_sym_in] = ACTIONS(9799),
    [anon_sym_do] = ACTIONS(9799),
    [anon_sym_EQ_GT] = ACTIONS(9799),
    [anon_sym_LBRACK] = ACTIONS(9799),
    [anon_sym_RBRACK] = ACTIONS(9799),
    [anon_sym_COLON_COLON2] = ACTIONS(9799),
    [anon_sym_AMP_DOT] = ACTIONS(9799),
    [anon_sym_QMARK] = ACTIONS(9799),
    [anon_sym_COLON2] = ACTIONS(9801),
    [anon_sym_DOT_DOT] = ACTIONS(9801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9799),
    [anon_sym_and] = ACTIONS(9799),
    [anon_sym_or] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE] = ACTIONS(9799),
    [anon_sym_AMP_AMP] = ACTIONS(9799),
    [anon_sym_LT_LT] = ACTIONS(9799),
    [anon_sym_GT_GT] = ACTIONS(9799),
    [anon_sym_EQ_EQ] = ACTIONS(9801),
    [anon_sym_BANG_EQ] = ACTIONS(9799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9799),
    [anon_sym_LT_EQ_GT] = ACTIONS(9799),
    [anon_sym_EQ_TILDE] = ACTIONS(9799),
    [anon_sym_BANG_TILDE] = ACTIONS(9799),
    [anon_sym_LT_EQ] = ACTIONS(9801),
    [anon_sym_GT] = ACTIONS(9801),
    [anon_sym_GT_EQ] = ACTIONS(9799),
    [anon_sym_CARET] = ACTIONS(9799),
    [anon_sym_PLUS] = ACTIONS(9799),
    [anon_sym_SLASH] = ACTIONS(9799),
    [anon_sym_PERCENT] = ACTIONS(9799),
    [sym_comment] = ACTIONS(87),
  },
  [8217] = {
    [sym__heredoc_body_start] = ACTIONS(9803),
    [sym__binary_minus] = ACTIONS(9803),
    [sym__binary_star] = ACTIONS(9803),
    [anon_sym_LBRACE] = ACTIONS(9803),
    [anon_sym_RBRACE] = ACTIONS(9803),
    [anon_sym_RPAREN] = ACTIONS(9803),
    [anon_sym_DOT] = ACTIONS(9805),
    [anon_sym_COMMA] = ACTIONS(9803),
    [anon_sym_PIPE] = ACTIONS(9805),
    [anon_sym_SEMI] = ACTIONS(9803),
    [anon_sym_STAR_STAR] = ACTIONS(9803),
    [anon_sym_AMP] = ACTIONS(9805),
    [anon_sym_EQ] = ACTIONS(9805),
    [anon_sym_LT] = ACTIONS(9805),
    [anon_sym_if] = ACTIONS(9803),
    [anon_sym_unless] = ACTIONS(9803),
    [anon_sym_while] = ACTIONS(9803),
    [anon_sym_until] = ACTIONS(9803),
    [anon_sym_rescue] = ACTIONS(9803),
    [anon_sym_in] = ACTIONS(9803),
    [anon_sym_do] = ACTIONS(9803),
    [anon_sym_EQ_GT] = ACTIONS(9803),
    [anon_sym_LBRACK] = ACTIONS(9803),
    [anon_sym_RBRACK] = ACTIONS(9803),
    [anon_sym_COLON_COLON2] = ACTIONS(9803),
    [anon_sym_AMP_DOT] = ACTIONS(9803),
    [anon_sym_QMARK] = ACTIONS(9803),
    [anon_sym_COLON2] = ACTIONS(9805),
    [anon_sym_DOT_DOT] = ACTIONS(9805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9803),
    [anon_sym_and] = ACTIONS(9803),
    [anon_sym_or] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE] = ACTIONS(9803),
    [anon_sym_AMP_AMP] = ACTIONS(9803),
    [anon_sym_LT_LT] = ACTIONS(9803),
    [anon_sym_GT_GT] = ACTIONS(9803),
    [anon_sym_EQ_EQ] = ACTIONS(9805),
    [anon_sym_BANG_EQ] = ACTIONS(9803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9803),
    [anon_sym_LT_EQ_GT] = ACTIONS(9803),
    [anon_sym_EQ_TILDE] = ACTIONS(9803),
    [anon_sym_BANG_TILDE] = ACTIONS(9803),
    [anon_sym_LT_EQ] = ACTIONS(9805),
    [anon_sym_GT] = ACTIONS(9805),
    [anon_sym_GT_EQ] = ACTIONS(9803),
    [anon_sym_CARET] = ACTIONS(9803),
    [anon_sym_PLUS] = ACTIONS(9803),
    [anon_sym_SLASH] = ACTIONS(9803),
    [anon_sym_PERCENT] = ACTIONS(9803),
    [sym_comment] = ACTIONS(87),
  },
  [8218] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13108),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8219] = {
    [sym__heredoc_body_start] = ACTIONS(9809),
    [sym__binary_minus] = ACTIONS(9809),
    [sym__binary_star] = ACTIONS(9809),
    [anon_sym_LBRACE] = ACTIONS(9809),
    [anon_sym_RBRACE] = ACTIONS(9809),
    [anon_sym_RPAREN] = ACTIONS(9809),
    [anon_sym_DOT] = ACTIONS(9811),
    [anon_sym_COMMA] = ACTIONS(9809),
    [anon_sym_PIPE] = ACTIONS(9811),
    [anon_sym_SEMI] = ACTIONS(9809),
    [anon_sym_STAR_STAR] = ACTIONS(9809),
    [anon_sym_AMP] = ACTIONS(9811),
    [anon_sym_EQ] = ACTIONS(9811),
    [anon_sym_LT] = ACTIONS(9811),
    [anon_sym_if] = ACTIONS(9809),
    [anon_sym_unless] = ACTIONS(9809),
    [anon_sym_while] = ACTIONS(9809),
    [anon_sym_until] = ACTIONS(9809),
    [anon_sym_rescue] = ACTIONS(9809),
    [anon_sym_in] = ACTIONS(9809),
    [anon_sym_do] = ACTIONS(9809),
    [anon_sym_EQ_GT] = ACTIONS(9809),
    [anon_sym_LBRACK] = ACTIONS(9809),
    [anon_sym_RBRACK] = ACTIONS(9809),
    [anon_sym_COLON_COLON2] = ACTIONS(9809),
    [anon_sym_AMP_DOT] = ACTIONS(9809),
    [anon_sym_QMARK] = ACTIONS(9809),
    [anon_sym_COLON2] = ACTIONS(9811),
    [anon_sym_DOT_DOT] = ACTIONS(9811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9809),
    [anon_sym_and] = ACTIONS(9809),
    [anon_sym_or] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE] = ACTIONS(9809),
    [anon_sym_AMP_AMP] = ACTIONS(9809),
    [anon_sym_LT_LT] = ACTIONS(9809),
    [anon_sym_GT_GT] = ACTIONS(9809),
    [anon_sym_EQ_EQ] = ACTIONS(9811),
    [anon_sym_BANG_EQ] = ACTIONS(9809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9809),
    [anon_sym_LT_EQ_GT] = ACTIONS(9809),
    [anon_sym_EQ_TILDE] = ACTIONS(9809),
    [anon_sym_BANG_TILDE] = ACTIONS(9809),
    [anon_sym_LT_EQ] = ACTIONS(9811),
    [anon_sym_GT] = ACTIONS(9811),
    [anon_sym_GT_EQ] = ACTIONS(9809),
    [anon_sym_CARET] = ACTIONS(9809),
    [anon_sym_PLUS] = ACTIONS(9809),
    [anon_sym_SLASH] = ACTIONS(9809),
    [anon_sym_PERCENT] = ACTIONS(9809),
    [sym_comment] = ACTIONS(87),
  },
  [8220] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8221] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [8222] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9661),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(9661),
    [sym_operator_assignment] = STATE(9661),
    [sym_conditional] = STATE(9661),
    [sym_range] = STATE(9661),
    [sym_binary] = STATE(9661),
    [sym_unary] = STATE(9661),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8223] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9662),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(9662),
    [sym_operator_assignment] = STATE(9662),
    [sym_conditional] = STATE(9662),
    [sym_range] = STATE(9662),
    [sym_binary] = STATE(9662),
    [sym_unary] = STATE(9662),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8224] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9663),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(9663),
    [sym_operator_assignment] = STATE(9663),
    [sym_conditional] = STATE(9663),
    [sym_range] = STATE(9663),
    [sym_binary] = STATE(9663),
    [sym_unary] = STATE(9663),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8225] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9664),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(9664),
    [sym_operator_assignment] = STATE(9664),
    [sym_conditional] = STATE(9664),
    [sym_range] = STATE(9664),
    [sym_binary] = STATE(9664),
    [sym_unary] = STATE(9664),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8226] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9665),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(9665),
    [sym_operator_assignment] = STATE(9665),
    [sym_conditional] = STATE(9665),
    [sym_range] = STATE(9665),
    [sym_binary] = STATE(9665),
    [sym_unary] = STATE(9665),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8227] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9666),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9666),
    [sym_operator_assignment] = STATE(9666),
    [sym_conditional] = STATE(9666),
    [sym_range] = STATE(9666),
    [sym_binary] = STATE(9666),
    [sym_unary] = STATE(9666),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8228] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9667),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(9667),
    [sym_operator_assignment] = STATE(9667),
    [sym_conditional] = STATE(9667),
    [sym_range] = STATE(9667),
    [sym_binary] = STATE(9667),
    [sym_unary] = STATE(9667),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8229] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9668),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(9668),
    [sym_operator_assignment] = STATE(9668),
    [sym_conditional] = STATE(9668),
    [sym_range] = STATE(9668),
    [sym_binary] = STATE(9668),
    [sym_unary] = STATE(9668),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8230] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9669),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(9669),
    [sym_operator_assignment] = STATE(9669),
    [sym_conditional] = STATE(9669),
    [sym_range] = STATE(9669),
    [sym_binary] = STATE(9669),
    [sym_unary] = STATE(9669),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8231] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9670),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(9670),
    [sym_operator_assignment] = STATE(9670),
    [sym_conditional] = STATE(9670),
    [sym_range] = STATE(9670),
    [sym_binary] = STATE(9670),
    [sym_unary] = STATE(9670),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8232] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9671),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_splat_argument] = STATE(9672),
    [sym_assignment] = STATE(9671),
    [sym_operator_assignment] = STATE(9671),
    [sym_conditional] = STATE(9671),
    [sym_range] = STATE(9671),
    [sym_binary] = STATE(9671),
    [sym_unary] = STATE(9671),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(9672),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(5388),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8233] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9673),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(9673),
    [sym_operator_assignment] = STATE(9673),
    [sym_conditional] = STATE(9673),
    [sym_range] = STATE(9673),
    [sym_binary] = STATE(9673),
    [sym_unary] = STATE(9673),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8234] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_RBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [8235] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_RBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [8236] = {
    [sym_heredoc_body] = STATE(8236),
    [aux_sym_call_repeat1] = STATE(8236),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_RBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8237] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3300),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(3300),
    [sym_operator_assignment] = STATE(3300),
    [sym_conditional] = STATE(3300),
    [sym_range] = STATE(3300),
    [sym_binary] = STATE(3300),
    [sym_unary] = STATE(3300),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3303),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5386),
    [sym__splat_star] = ACTIONS(5388),
    [sym__unary_minus] = ACTIONS(2331),
    [sym__identifier_hash_key] = ACTIONS(5390),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11521),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(5392),
    [sym_identifier] = ACTIONS(5392),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8238] = {
    [sym_heredoc_body] = STATE(8236),
    [aux_sym_call_repeat1] = STATE(8236),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_RBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8239] = {
    [aux_sym_argument_list_repeat1] = STATE(8239),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13110),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_RBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [8240] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9674),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_assignment] = STATE(9674),
    [sym_operator_assignment] = STATE(9674),
    [sym_conditional] = STATE(9674),
    [sym_range] = STATE(9674),
    [sym_binary] = STATE(9674),
    [sym_unary] = STATE(9674),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8241] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [8242] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11537),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [8243] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9675),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(9675),
    [sym_operator_assignment] = STATE(9675),
    [sym_conditional] = STATE(9675),
    [sym_range] = STATE(9675),
    [sym_binary] = STATE(9675),
    [sym_unary] = STATE(9675),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8244] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9676),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(9676),
    [sym_operator_assignment] = STATE(9676),
    [sym_conditional] = STATE(9676),
    [sym_range] = STATE(9676),
    [sym_binary] = STATE(9676),
    [sym_unary] = STATE(9676),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8245] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9677),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(9677),
    [sym_operator_assignment] = STATE(9677),
    [sym_conditional] = STATE(9677),
    [sym_range] = STATE(9677),
    [sym_binary] = STATE(9677),
    [sym_unary] = STATE(9677),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8246] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9678),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(9678),
    [sym_operator_assignment] = STATE(9678),
    [sym_conditional] = STATE(9678),
    [sym_range] = STATE(9678),
    [sym_binary] = STATE(9678),
    [sym_unary] = STATE(9678),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8247] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9679),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(9679),
    [sym_operator_assignment] = STATE(9679),
    [sym_conditional] = STATE(9679),
    [sym_range] = STATE(9679),
    [sym_binary] = STATE(9679),
    [sym_unary] = STATE(9679),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8248] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9680),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9680),
    [sym_operator_assignment] = STATE(9680),
    [sym_conditional] = STATE(9680),
    [sym_range] = STATE(9680),
    [sym_binary] = STATE(9680),
    [sym_unary] = STATE(9680),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8249] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9681),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(9681),
    [sym_operator_assignment] = STATE(9681),
    [sym_conditional] = STATE(9681),
    [sym_range] = STATE(9681),
    [sym_binary] = STATE(9681),
    [sym_unary] = STATE(9681),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8250] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9682),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(9682),
    [sym_operator_assignment] = STATE(9682),
    [sym_conditional] = STATE(9682),
    [sym_range] = STATE(9682),
    [sym_binary] = STATE(9682),
    [sym_unary] = STATE(9682),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8251] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9683),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(9683),
    [sym_operator_assignment] = STATE(9683),
    [sym_conditional] = STATE(9683),
    [sym_range] = STATE(9683),
    [sym_binary] = STATE(9683),
    [sym_unary] = STATE(9683),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8252] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9684),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(9684),
    [sym_operator_assignment] = STATE(9684),
    [sym_conditional] = STATE(9684),
    [sym_range] = STATE(9684),
    [sym_binary] = STATE(9684),
    [sym_unary] = STATE(9684),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8253] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9685),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_splat_argument] = STATE(9686),
    [sym_assignment] = STATE(9685),
    [sym_operator_assignment] = STATE(9685),
    [sym_conditional] = STATE(9685),
    [sym_range] = STATE(9685),
    [sym_binary] = STATE(9685),
    [sym_unary] = STATE(9685),
    [sym_right_assignment_list] = STATE(8647),
    [sym__arg_or_splat_arg] = STATE(9686),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(5424),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8254] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9687),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(9687),
    [sym_operator_assignment] = STATE(9687),
    [sym_conditional] = STATE(9687),
    [sym_range] = STATE(9687),
    [sym_binary] = STATE(9687),
    [sym_unary] = STATE(9687),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8255] = {
    [sym_string] = STATE(9688),
    [aux_sym_chained_string_repeat1] = STATE(9688),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_RBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [8256] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_RBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(11537),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [8257] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_RBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(11537),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [8258] = {
    [sym_heredoc_body] = STATE(8258),
    [aux_sym_call_repeat1] = STATE(8258),
    [sym__heredoc_body_start] = ACTIONS(12063),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_RBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [8259] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3320),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(3320),
    [sym_operator_assignment] = STATE(3320),
    [sym_conditional] = STATE(3320),
    [sym_range] = STATE(3320),
    [sym_binary] = STATE(3320),
    [sym_unary] = STATE(3320),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3323),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5422),
    [sym__splat_star] = ACTIONS(5424),
    [sym__unary_minus] = ACTIONS(2405),
    [sym__identifier_hash_key] = ACTIONS(5426),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(5428),
    [sym_identifier] = ACTIONS(5428),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8260] = {
    [sym_heredoc_body] = STATE(8258),
    [aux_sym_call_repeat1] = STATE(8258),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_RBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [8261] = {
    [aux_sym_argument_list_repeat1] = STATE(8261),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13113),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_RBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [8262] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [8263] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(5947),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(1281),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(1281),
    [sym_splat_argument] = STATE(8300),
    [sym_assignment] = STATE(5947),
    [sym_operator_assignment] = STATE(5947),
    [sym_conditional] = STATE(5947),
    [sym_range] = STATE(5947),
    [sym_binary] = STATE(5947),
    [sym_unary] = STATE(5947),
    [sym__arg_or_splat_arg] = STATE(8300),
    [sym_left_assignment_list] = STATE(1280),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1281),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(1281),
    [sym_false] = STATE(1281),
    [sym_nil] = STATE(1281),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(9077),
    [sym__unary_minus] = ACTIONS(2287),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2297),
    [anon_sym_defined_QMARK] = ACTIONS(2299),
    [anon_sym_not] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2303),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8264] = {
    [aux_sym_exceptions_repeat1] = STATE(9689),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(13116),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_RBRACK] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8265] = {
    [sym__method_rest] = STATE(9690),
    [sym_operator] = STATE(1293),
    [sym__method_name] = STATE(1293),
    [sym_setter] = STATE(1293),
    [sym_symbol] = STATE(1293),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9083),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9083),
    [sym_class_variable] = ACTIONS(9083),
    [sym_global_variable] = ACTIONS(9083),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [8266] = {
    [sym__heredoc_body_start] = ACTIONS(10532),
    [sym__binary_minus] = ACTIONS(10532),
    [sym__binary_star] = ACTIONS(10532),
    [anon_sym_LBRACE] = ACTIONS(10532),
    [anon_sym_RBRACE] = ACTIONS(10532),
    [anon_sym_RPAREN] = ACTIONS(10532),
    [anon_sym_DOT] = ACTIONS(10534),
    [anon_sym_COMMA] = ACTIONS(10532),
    [anon_sym_PIPE] = ACTIONS(10534),
    [anon_sym_SEMI] = ACTIONS(10532),
    [anon_sym_STAR_STAR] = ACTIONS(10532),
    [anon_sym_AMP] = ACTIONS(10534),
    [anon_sym_EQ] = ACTIONS(10534),
    [anon_sym_LT] = ACTIONS(10534),
    [anon_sym_if] = ACTIONS(10532),
    [anon_sym_unless] = ACTIONS(10532),
    [anon_sym_while] = ACTIONS(10532),
    [anon_sym_until] = ACTIONS(10532),
    [anon_sym_rescue] = ACTIONS(10532),
    [anon_sym_in] = ACTIONS(10532),
    [anon_sym_do] = ACTIONS(10532),
    [anon_sym_EQ_GT] = ACTIONS(10532),
    [anon_sym_LBRACK] = ACTIONS(10532),
    [anon_sym_RBRACK] = ACTIONS(10532),
    [anon_sym_COLON_COLON2] = ACTIONS(10532),
    [anon_sym_AMP_DOT] = ACTIONS(10532),
    [anon_sym_QMARK] = ACTIONS(10532),
    [anon_sym_COLON2] = ACTIONS(10534),
    [anon_sym_DOT_DOT] = ACTIONS(10534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10532),
    [anon_sym_and] = ACTIONS(10532),
    [anon_sym_or] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE] = ACTIONS(10532),
    [anon_sym_AMP_AMP] = ACTIONS(10532),
    [anon_sym_LT_LT] = ACTIONS(10532),
    [anon_sym_GT_GT] = ACTIONS(10532),
    [anon_sym_EQ_EQ] = ACTIONS(10534),
    [anon_sym_BANG_EQ] = ACTIONS(10532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10532),
    [anon_sym_LT_EQ_GT] = ACTIONS(10532),
    [anon_sym_EQ_TILDE] = ACTIONS(10532),
    [anon_sym_BANG_TILDE] = ACTIONS(10532),
    [anon_sym_LT_EQ] = ACTIONS(10534),
    [anon_sym_GT] = ACTIONS(10534),
    [anon_sym_GT_EQ] = ACTIONS(10532),
    [anon_sym_CARET] = ACTIONS(10532),
    [anon_sym_PLUS] = ACTIONS(10532),
    [anon_sym_SLASH] = ACTIONS(10532),
    [anon_sym_PERCENT] = ACTIONS(10532),
    [sym_comment] = ACTIONS(87),
  },
  [8267] = {
    [sym__heredoc_body_start] = ACTIONS(10536),
    [sym__binary_minus] = ACTIONS(10536),
    [sym__binary_star] = ACTIONS(10536),
    [anon_sym_LBRACE] = ACTIONS(10536),
    [anon_sym_RBRACE] = ACTIONS(10536),
    [anon_sym_RPAREN] = ACTIONS(10536),
    [anon_sym_DOT] = ACTIONS(10538),
    [anon_sym_COMMA] = ACTIONS(10536),
    [anon_sym_PIPE] = ACTIONS(10538),
    [anon_sym_SEMI] = ACTIONS(10536),
    [anon_sym_STAR_STAR] = ACTIONS(10536),
    [anon_sym_AMP] = ACTIONS(10538),
    [anon_sym_EQ] = ACTIONS(10538),
    [anon_sym_LT] = ACTIONS(10538),
    [anon_sym_if] = ACTIONS(10536),
    [anon_sym_unless] = ACTIONS(10536),
    [anon_sym_while] = ACTIONS(10536),
    [anon_sym_until] = ACTIONS(10536),
    [anon_sym_rescue] = ACTIONS(10536),
    [anon_sym_in] = ACTIONS(10536),
    [anon_sym_do] = ACTIONS(10536),
    [anon_sym_EQ_GT] = ACTIONS(10536),
    [anon_sym_LBRACK] = ACTIONS(10536),
    [anon_sym_RBRACK] = ACTIONS(10536),
    [anon_sym_COLON_COLON2] = ACTIONS(10536),
    [anon_sym_AMP_DOT] = ACTIONS(10536),
    [anon_sym_QMARK] = ACTIONS(10536),
    [anon_sym_COLON2] = ACTIONS(10538),
    [anon_sym_DOT_DOT] = ACTIONS(10538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10536),
    [anon_sym_and] = ACTIONS(10536),
    [anon_sym_or] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE] = ACTIONS(10536),
    [anon_sym_AMP_AMP] = ACTIONS(10536),
    [anon_sym_LT_LT] = ACTIONS(10536),
    [anon_sym_GT_GT] = ACTIONS(10536),
    [anon_sym_EQ_EQ] = ACTIONS(10538),
    [anon_sym_BANG_EQ] = ACTIONS(10536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10536),
    [anon_sym_LT_EQ_GT] = ACTIONS(10536),
    [anon_sym_EQ_TILDE] = ACTIONS(10536),
    [anon_sym_BANG_TILDE] = ACTIONS(10536),
    [anon_sym_LT_EQ] = ACTIONS(10538),
    [anon_sym_GT] = ACTIONS(10538),
    [anon_sym_GT_EQ] = ACTIONS(10536),
    [anon_sym_CARET] = ACTIONS(10536),
    [anon_sym_PLUS] = ACTIONS(10536),
    [anon_sym_SLASH] = ACTIONS(10536),
    [anon_sym_PERCENT] = ACTIONS(10536),
    [sym_comment] = ACTIONS(87),
  },
  [8268] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9691),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_assignment] = STATE(9691),
    [sym_operator_assignment] = STATE(9691),
    [sym_conditional] = STATE(9691),
    [sym_range] = STATE(9691),
    [sym_binary] = STATE(9691),
    [sym_unary] = STATE(9691),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8269] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5975),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1316),
    [sym_scope_resolution] = STATE(349),
    [sym_call] = STATE(349),
    [sym_method_call] = STATE(1316),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(5975),
    [sym_operator_assignment] = STATE(5975),
    [sym_conditional] = STATE(5975),
    [sym_range] = STATE(5975),
    [sym_binary] = STATE(5975),
    [sym_unary] = STATE(5975),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(1315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1316),
    [sym__variable] = STATE(349),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1316),
    [sym_false] = STATE(1316),
    [sym_nil] = STATE(1316),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(1285),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(2329),
    [sym__unary_minus] = ACTIONS(2331),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_defined_QMARK] = ACTIONS(2335),
    [anon_sym_not] = ACTIONS(2337),
    [anon_sym_BANG] = ACTIONS(2341),
    [anon_sym_TILDE] = ACTIONS(2341),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8270] = {
    [aux_sym_exceptions_repeat1] = STATE(9692),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13118),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_RBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8271] = {
    [sym__heredoc_body_start] = ACTIONS(10689),
    [sym__binary_minus] = ACTIONS(10689),
    [sym__binary_star] = ACTIONS(10689),
    [anon_sym_LBRACE] = ACTIONS(10689),
    [anon_sym_RBRACE] = ACTIONS(10689),
    [anon_sym_RPAREN] = ACTIONS(10689),
    [anon_sym_DOT] = ACTIONS(10691),
    [anon_sym_COMMA] = ACTIONS(10689),
    [anon_sym_PIPE] = ACTIONS(10691),
    [anon_sym_SEMI] = ACTIONS(10689),
    [anon_sym_STAR_STAR] = ACTIONS(10689),
    [anon_sym_AMP] = ACTIONS(10691),
    [anon_sym_EQ] = ACTIONS(10691),
    [anon_sym_LT] = ACTIONS(10691),
    [anon_sym_if] = ACTIONS(10689),
    [anon_sym_unless] = ACTIONS(10689),
    [anon_sym_while] = ACTIONS(10689),
    [anon_sym_until] = ACTIONS(10689),
    [anon_sym_rescue] = ACTIONS(10689),
    [anon_sym_in] = ACTIONS(10689),
    [anon_sym_do] = ACTIONS(10689),
    [anon_sym_EQ_GT] = ACTIONS(10689),
    [anon_sym_LBRACK] = ACTIONS(10689),
    [anon_sym_RBRACK] = ACTIONS(10689),
    [anon_sym_COLON_COLON2] = ACTIONS(10689),
    [anon_sym_AMP_DOT] = ACTIONS(10689),
    [anon_sym_QMARK] = ACTIONS(10689),
    [anon_sym_COLON2] = ACTIONS(10691),
    [anon_sym_DOT_DOT] = ACTIONS(10691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10689),
    [anon_sym_and] = ACTIONS(10689),
    [anon_sym_or] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10689),
    [anon_sym_LT_LT] = ACTIONS(10689),
    [anon_sym_GT_GT] = ACTIONS(10689),
    [anon_sym_EQ_EQ] = ACTIONS(10691),
    [anon_sym_BANG_EQ] = ACTIONS(10689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10689),
    [anon_sym_LT_EQ_GT] = ACTIONS(10689),
    [anon_sym_EQ_TILDE] = ACTIONS(10689),
    [anon_sym_BANG_TILDE] = ACTIONS(10689),
    [anon_sym_LT_EQ] = ACTIONS(10691),
    [anon_sym_GT] = ACTIONS(10691),
    [anon_sym_GT_EQ] = ACTIONS(10689),
    [anon_sym_CARET] = ACTIONS(10689),
    [anon_sym_PLUS] = ACTIONS(10689),
    [anon_sym_SLASH] = ACTIONS(10689),
    [anon_sym_PERCENT] = ACTIONS(10689),
    [sym_comment] = ACTIONS(87),
  },
  [8272] = {
    [anon_sym_end] = ACTIONS(13120),
    [sym_comment] = ACTIONS(87),
  },
  [8273] = {
    [sym_elsif] = STATE(9694),
    [sym_else] = STATE(9694),
    [sym__if_tail] = STATE(9694),
    [anon_sym_end] = ACTIONS(13120),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [8274] = {
    [sym__heredoc_body_start] = ACTIONS(10856),
    [sym__binary_minus] = ACTIONS(10856),
    [sym__binary_star] = ACTIONS(10856),
    [anon_sym_LBRACE] = ACTIONS(10856),
    [anon_sym_RBRACE] = ACTIONS(10856),
    [anon_sym_RPAREN] = ACTIONS(10856),
    [anon_sym_DOT] = ACTIONS(10858),
    [anon_sym_COMMA] = ACTIONS(10856),
    [anon_sym_PIPE] = ACTIONS(10858),
    [anon_sym_SEMI] = ACTIONS(10856),
    [anon_sym_STAR_STAR] = ACTIONS(10856),
    [anon_sym_AMP] = ACTIONS(10858),
    [anon_sym_EQ] = ACTIONS(10858),
    [anon_sym_LT] = ACTIONS(10858),
    [anon_sym_if] = ACTIONS(10856),
    [anon_sym_unless] = ACTIONS(10856),
    [anon_sym_while] = ACTIONS(10856),
    [anon_sym_until] = ACTIONS(10856),
    [anon_sym_rescue] = ACTIONS(10856),
    [anon_sym_in] = ACTIONS(10856),
    [anon_sym_do] = ACTIONS(10856),
    [anon_sym_EQ_GT] = ACTIONS(10856),
    [anon_sym_LBRACK] = ACTIONS(10856),
    [anon_sym_RBRACK] = ACTIONS(10856),
    [anon_sym_COLON_COLON2] = ACTIONS(10856),
    [anon_sym_AMP_DOT] = ACTIONS(10856),
    [anon_sym_QMARK] = ACTIONS(10856),
    [anon_sym_COLON2] = ACTIONS(10858),
    [anon_sym_DOT_DOT] = ACTIONS(10858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10856),
    [anon_sym_and] = ACTIONS(10856),
    [anon_sym_or] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE] = ACTIONS(10856),
    [anon_sym_AMP_AMP] = ACTIONS(10856),
    [anon_sym_LT_LT] = ACTIONS(10856),
    [anon_sym_GT_GT] = ACTIONS(10856),
    [anon_sym_EQ_EQ] = ACTIONS(10858),
    [anon_sym_BANG_EQ] = ACTIONS(10856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10856),
    [anon_sym_LT_EQ_GT] = ACTIONS(10856),
    [anon_sym_EQ_TILDE] = ACTIONS(10856),
    [anon_sym_BANG_TILDE] = ACTIONS(10856),
    [anon_sym_LT_EQ] = ACTIONS(10858),
    [anon_sym_GT] = ACTIONS(10858),
    [anon_sym_GT_EQ] = ACTIONS(10856),
    [anon_sym_CARET] = ACTIONS(10856),
    [anon_sym_PLUS] = ACTIONS(10856),
    [anon_sym_SLASH] = ACTIONS(10856),
    [anon_sym_PERCENT] = ACTIONS(10856),
    [sym_comment] = ACTIONS(87),
  },
  [8275] = {
    [anon_sym_end] = ACTIONS(13122),
    [sym_comment] = ACTIONS(87),
  },
  [8276] = {
    [sym__heredoc_body_start] = ACTIONS(10951),
    [sym__binary_minus] = ACTIONS(10951),
    [sym__binary_star] = ACTIONS(10951),
    [anon_sym_LBRACE] = ACTIONS(10951),
    [anon_sym_RBRACE] = ACTIONS(10951),
    [anon_sym_RPAREN] = ACTIONS(10951),
    [anon_sym_DOT] = ACTIONS(10953),
    [anon_sym_COMMA] = ACTIONS(10951),
    [anon_sym_PIPE] = ACTIONS(10953),
    [anon_sym_SEMI] = ACTIONS(10951),
    [anon_sym_STAR_STAR] = ACTIONS(10951),
    [anon_sym_AMP] = ACTIONS(10953),
    [anon_sym_EQ] = ACTIONS(10953),
    [anon_sym_LT] = ACTIONS(10953),
    [anon_sym_if] = ACTIONS(10951),
    [anon_sym_unless] = ACTIONS(10951),
    [anon_sym_while] = ACTIONS(10951),
    [anon_sym_until] = ACTIONS(10951),
    [anon_sym_rescue] = ACTIONS(10951),
    [anon_sym_in] = ACTIONS(10951),
    [anon_sym_do] = ACTIONS(10951),
    [anon_sym_EQ_GT] = ACTIONS(10951),
    [anon_sym_LBRACK] = ACTIONS(10951),
    [anon_sym_RBRACK] = ACTIONS(10951),
    [anon_sym_COLON_COLON2] = ACTIONS(10951),
    [anon_sym_AMP_DOT] = ACTIONS(10951),
    [anon_sym_QMARK] = ACTIONS(10951),
    [anon_sym_COLON2] = ACTIONS(10953),
    [anon_sym_DOT_DOT] = ACTIONS(10953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10951),
    [anon_sym_and] = ACTIONS(10951),
    [anon_sym_or] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE] = ACTIONS(10951),
    [anon_sym_AMP_AMP] = ACTIONS(10951),
    [anon_sym_LT_LT] = ACTIONS(10951),
    [anon_sym_GT_GT] = ACTIONS(10951),
    [anon_sym_EQ_EQ] = ACTIONS(10953),
    [anon_sym_BANG_EQ] = ACTIONS(10951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10951),
    [anon_sym_LT_EQ_GT] = ACTIONS(10951),
    [anon_sym_EQ_TILDE] = ACTIONS(10951),
    [anon_sym_BANG_TILDE] = ACTIONS(10951),
    [anon_sym_LT_EQ] = ACTIONS(10953),
    [anon_sym_GT] = ACTIONS(10953),
    [anon_sym_GT_EQ] = ACTIONS(10951),
    [anon_sym_CARET] = ACTIONS(10951),
    [anon_sym_PLUS] = ACTIONS(10951),
    [anon_sym_SLASH] = ACTIONS(10951),
    [anon_sym_PERCENT] = ACTIONS(10951),
    [sym_comment] = ACTIONS(87),
  },
  [8277] = {
    [sym__heredoc_body_start] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10960),
    [anon_sym_LBRACE] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10960),
    [anon_sym_RPAREN] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [anon_sym_in] = ACTIONS(10960),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10960),
    [anon_sym_RBRACK] = ACTIONS(10960),
    [anon_sym_COLON_COLON2] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_COLON2] = ACTIONS(10962),
    [anon_sym_DOT_DOT] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_EQ_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10962),
    [anon_sym_GT] = ACTIONS(10962),
    [anon_sym_GT_EQ] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_SLASH] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_comment] = ACTIONS(87),
  },
  [8278] = {
    [sym__heredoc_body_start] = ACTIONS(11007),
    [sym__binary_minus] = ACTIONS(11007),
    [sym__binary_star] = ACTIONS(11007),
    [anon_sym_LBRACE] = ACTIONS(11007),
    [anon_sym_RBRACE] = ACTIONS(11007),
    [anon_sym_RPAREN] = ACTIONS(11007),
    [anon_sym_DOT] = ACTIONS(11009),
    [anon_sym_COMMA] = ACTIONS(11007),
    [anon_sym_PIPE] = ACTIONS(11009),
    [anon_sym_SEMI] = ACTIONS(11007),
    [anon_sym_STAR_STAR] = ACTIONS(11007),
    [anon_sym_AMP] = ACTIONS(11009),
    [anon_sym_EQ] = ACTIONS(11009),
    [anon_sym_LT] = ACTIONS(11009),
    [anon_sym_if] = ACTIONS(11007),
    [anon_sym_unless] = ACTIONS(11007),
    [anon_sym_while] = ACTIONS(11007),
    [anon_sym_until] = ACTIONS(11007),
    [anon_sym_rescue] = ACTIONS(11007),
    [anon_sym_in] = ACTIONS(11007),
    [anon_sym_do] = ACTIONS(11007),
    [anon_sym_EQ_GT] = ACTIONS(11007),
    [anon_sym_LBRACK] = ACTIONS(11007),
    [anon_sym_RBRACK] = ACTIONS(11007),
    [anon_sym_COLON_COLON2] = ACTIONS(11007),
    [anon_sym_AMP_DOT] = ACTIONS(11007),
    [anon_sym_QMARK] = ACTIONS(11007),
    [anon_sym_COLON2] = ACTIONS(11009),
    [anon_sym_DOT_DOT] = ACTIONS(11009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11007),
    [anon_sym_and] = ACTIONS(11007),
    [anon_sym_or] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE] = ACTIONS(11007),
    [anon_sym_AMP_AMP] = ACTIONS(11007),
    [anon_sym_LT_LT] = ACTIONS(11007),
    [anon_sym_GT_GT] = ACTIONS(11007),
    [anon_sym_EQ_EQ] = ACTIONS(11009),
    [anon_sym_BANG_EQ] = ACTIONS(11007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11007),
    [anon_sym_LT_EQ_GT] = ACTIONS(11007),
    [anon_sym_EQ_TILDE] = ACTIONS(11007),
    [anon_sym_BANG_TILDE] = ACTIONS(11007),
    [anon_sym_LT_EQ] = ACTIONS(11009),
    [anon_sym_GT] = ACTIONS(11009),
    [anon_sym_GT_EQ] = ACTIONS(11007),
    [anon_sym_CARET] = ACTIONS(11007),
    [anon_sym_PLUS] = ACTIONS(11007),
    [anon_sym_SLASH] = ACTIONS(11007),
    [anon_sym_PERCENT] = ACTIONS(11007),
    [sym_comment] = ACTIONS(87),
  },
  [8279] = {
    [anon_sym_end] = ACTIONS(13124),
    [sym_comment] = ACTIONS(87),
  },
  [8280] = {
    [sym__heredoc_body_start] = ACTIONS(11020),
    [sym__binary_minus] = ACTIONS(11020),
    [sym__binary_star] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_RBRACE] = ACTIONS(11020),
    [anon_sym_RPAREN] = ACTIONS(11020),
    [anon_sym_DOT] = ACTIONS(11022),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_PIPE] = ACTIONS(11022),
    [anon_sym_SEMI] = ACTIONS(11020),
    [anon_sym_STAR_STAR] = ACTIONS(11020),
    [anon_sym_AMP] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(11022),
    [anon_sym_LT] = ACTIONS(11022),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_unless] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [anon_sym_until] = ACTIONS(11020),
    [anon_sym_rescue] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_do] = ACTIONS(11020),
    [anon_sym_EQ_GT] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_RBRACK] = ACTIONS(11020),
    [anon_sym_COLON_COLON2] = ACTIONS(11020),
    [anon_sym_AMP_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11022),
    [anon_sym_DOT_DOT] = ACTIONS(11022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_and] = ACTIONS(11020),
    [anon_sym_or] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE] = ACTIONS(11020),
    [anon_sym_AMP_AMP] = ACTIONS(11020),
    [anon_sym_LT_LT] = ACTIONS(11020),
    [anon_sym_GT_GT] = ACTIONS(11020),
    [anon_sym_EQ_EQ] = ACTIONS(11022),
    [anon_sym_BANG_EQ] = ACTIONS(11020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11020),
    [anon_sym_LT_EQ_GT] = ACTIONS(11020),
    [anon_sym_EQ_TILDE] = ACTIONS(11020),
    [anon_sym_BANG_TILDE] = ACTIONS(11020),
    [anon_sym_LT_EQ] = ACTIONS(11022),
    [anon_sym_GT] = ACTIONS(11022),
    [anon_sym_GT_EQ] = ACTIONS(11020),
    [anon_sym_CARET] = ACTIONS(11020),
    [anon_sym_PLUS] = ACTIONS(11020),
    [anon_sym_SLASH] = ACTIONS(11020),
    [anon_sym_PERCENT] = ACTIONS(11020),
    [sym_comment] = ACTIONS(87),
  },
  [8281] = {
    [anon_sym_end] = ACTIONS(13126),
    [sym_comment] = ACTIONS(87),
  },
  [8282] = {
    [sym__heredoc_body_start] = ACTIONS(11466),
    [sym__binary_minus] = ACTIONS(11466),
    [sym__binary_star] = ACTIONS(11466),
    [anon_sym_LBRACE] = ACTIONS(11466),
    [anon_sym_RBRACE] = ACTIONS(11466),
    [anon_sym_RPAREN] = ACTIONS(11466),
    [anon_sym_DOT] = ACTIONS(11468),
    [anon_sym_COMMA] = ACTIONS(11466),
    [anon_sym_PIPE] = ACTIONS(11468),
    [anon_sym_SEMI] = ACTIONS(11466),
    [anon_sym_STAR_STAR] = ACTIONS(11466),
    [anon_sym_AMP] = ACTIONS(11468),
    [anon_sym_EQ] = ACTIONS(11468),
    [anon_sym_LT] = ACTIONS(11468),
    [anon_sym_if] = ACTIONS(11466),
    [anon_sym_unless] = ACTIONS(11466),
    [anon_sym_while] = ACTIONS(11466),
    [anon_sym_until] = ACTIONS(11466),
    [anon_sym_rescue] = ACTIONS(11466),
    [anon_sym_in] = ACTIONS(11466),
    [anon_sym_do] = ACTIONS(11466),
    [anon_sym_EQ_GT] = ACTIONS(11466),
    [anon_sym_LBRACK] = ACTIONS(11466),
    [anon_sym_RBRACK] = ACTIONS(11466),
    [anon_sym_COLON_COLON2] = ACTIONS(11466),
    [anon_sym_AMP_DOT] = ACTIONS(11466),
    [anon_sym_QMARK] = ACTIONS(11466),
    [anon_sym_COLON2] = ACTIONS(11468),
    [anon_sym_DOT_DOT] = ACTIONS(11468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11466),
    [anon_sym_and] = ACTIONS(11466),
    [anon_sym_or] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE] = ACTIONS(11466),
    [anon_sym_AMP_AMP] = ACTIONS(11466),
    [anon_sym_LT_LT] = ACTIONS(11466),
    [anon_sym_GT_GT] = ACTIONS(11466),
    [anon_sym_EQ_EQ] = ACTIONS(11468),
    [anon_sym_BANG_EQ] = ACTIONS(11466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11466),
    [anon_sym_LT_EQ_GT] = ACTIONS(11466),
    [anon_sym_EQ_TILDE] = ACTIONS(11466),
    [anon_sym_BANG_TILDE] = ACTIONS(11466),
    [anon_sym_LT_EQ] = ACTIONS(11468),
    [anon_sym_GT] = ACTIONS(11468),
    [anon_sym_GT_EQ] = ACTIONS(11466),
    [anon_sym_CARET] = ACTIONS(11466),
    [anon_sym_PLUS] = ACTIONS(11466),
    [anon_sym_SLASH] = ACTIONS(11466),
    [anon_sym_PERCENT] = ACTIONS(11466),
    [sym_comment] = ACTIONS(87),
  },
  [8283] = {
    [anon_sym_end] = ACTIONS(13128),
    [sym_comment] = ACTIONS(87),
  },
  [8284] = {
    [sym__heredoc_body_start] = ACTIONS(11655),
    [sym__binary_minus] = ACTIONS(11655),
    [sym__binary_star] = ACTIONS(11655),
    [anon_sym_LBRACE] = ACTIONS(11655),
    [anon_sym_RBRACE] = ACTIONS(11655),
    [anon_sym_RPAREN] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11657),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11657),
    [anon_sym_SEMI] = ACTIONS(11655),
    [anon_sym_STAR_STAR] = ACTIONS(11655),
    [anon_sym_AMP] = ACTIONS(11657),
    [anon_sym_EQ] = ACTIONS(11657),
    [anon_sym_LT] = ACTIONS(11657),
    [anon_sym_if] = ACTIONS(11655),
    [anon_sym_unless] = ACTIONS(11655),
    [anon_sym_while] = ACTIONS(11655),
    [anon_sym_until] = ACTIONS(11655),
    [anon_sym_rescue] = ACTIONS(11655),
    [anon_sym_in] = ACTIONS(11655),
    [anon_sym_do] = ACTIONS(11655),
    [anon_sym_EQ_GT] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_RBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [anon_sym_QMARK] = ACTIONS(11655),
    [anon_sym_COLON2] = ACTIONS(11657),
    [anon_sym_DOT_DOT] = ACTIONS(11657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11655),
    [anon_sym_and] = ACTIONS(11655),
    [anon_sym_or] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE] = ACTIONS(11655),
    [anon_sym_AMP_AMP] = ACTIONS(11655),
    [anon_sym_LT_LT] = ACTIONS(11655),
    [anon_sym_GT_GT] = ACTIONS(11655),
    [anon_sym_EQ_EQ] = ACTIONS(11657),
    [anon_sym_BANG_EQ] = ACTIONS(11655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11655),
    [anon_sym_LT_EQ_GT] = ACTIONS(11655),
    [anon_sym_EQ_TILDE] = ACTIONS(11655),
    [anon_sym_BANG_TILDE] = ACTIONS(11655),
    [anon_sym_LT_EQ] = ACTIONS(11657),
    [anon_sym_GT] = ACTIONS(11657),
    [anon_sym_GT_EQ] = ACTIONS(11655),
    [anon_sym_CARET] = ACTIONS(11655),
    [anon_sym_PLUS] = ACTIONS(11655),
    [anon_sym_SLASH] = ACTIONS(11655),
    [anon_sym_PERCENT] = ACTIONS(11655),
    [sym_comment] = ACTIONS(87),
  },
  [8285] = {
    [sym__heredoc_body_start] = ACTIONS(11680),
    [sym__binary_minus] = ACTIONS(11680),
    [sym__binary_star] = ACTIONS(11680),
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RBRACE] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11682),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11682),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_STAR_STAR] = ACTIONS(11680),
    [anon_sym_AMP] = ACTIONS(11682),
    [anon_sym_EQ] = ACTIONS(11682),
    [anon_sym_LT] = ACTIONS(11682),
    [anon_sym_if] = ACTIONS(11680),
    [anon_sym_unless] = ACTIONS(11680),
    [anon_sym_while] = ACTIONS(11680),
    [anon_sym_until] = ACTIONS(11680),
    [anon_sym_rescue] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11680),
    [anon_sym_do] = ACTIONS(11680),
    [anon_sym_EQ_GT] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_RBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_COLON2] = ACTIONS(11682),
    [anon_sym_DOT_DOT] = ACTIONS(11682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_and] = ACTIONS(11680),
    [anon_sym_or] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE] = ACTIONS(11680),
    [anon_sym_AMP_AMP] = ACTIONS(11680),
    [anon_sym_LT_LT] = ACTIONS(11680),
    [anon_sym_GT_GT] = ACTIONS(11680),
    [anon_sym_EQ_EQ] = ACTIONS(11682),
    [anon_sym_BANG_EQ] = ACTIONS(11680),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11680),
    [anon_sym_LT_EQ_GT] = ACTIONS(11680),
    [anon_sym_EQ_TILDE] = ACTIONS(11680),
    [anon_sym_BANG_TILDE] = ACTIONS(11680),
    [anon_sym_LT_EQ] = ACTIONS(11682),
    [anon_sym_GT] = ACTIONS(11682),
    [anon_sym_GT_EQ] = ACTIONS(11680),
    [anon_sym_CARET] = ACTIONS(11680),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11680),
    [anon_sym_PERCENT] = ACTIONS(11680),
    [sym_comment] = ACTIONS(87),
  },
  [8286] = {
    [anon_sym_end] = ACTIONS(13130),
    [sym_comment] = ACTIONS(87),
  },
  [8287] = {
    [sym__statements] = STATE(9700),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13132),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8288] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(2365),
    [sym__binary_star] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_STAR_STAR] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2371),
    [anon_sym_LT] = ACTIONS(2373),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_RBRACK] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(2375),
    [anon_sym_DOT_DOT] = ACTIONS(2377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2379),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2383),
    [anon_sym_AMP_AMP] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2385),
    [anon_sym_EQ_EQ] = ACTIONS(2387),
    [anon_sym_BANG_EQ] = ACTIONS(2383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2383),
    [anon_sym_LT_EQ_GT] = ACTIONS(2383),
    [anon_sym_EQ_TILDE] = ACTIONS(2383),
    [anon_sym_BANG_TILDE] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2373),
    [anon_sym_GT_EQ] = ACTIONS(2389),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2367),
    [sym_comment] = ACTIONS(87),
  },
  [8289] = {
    [sym__simple_symbol] = ACTIONS(7608),
    [sym__string_start] = ACTIONS(7608),
    [sym__symbol_start] = ACTIONS(7608),
    [sym__subshell_start] = ACTIONS(7608),
    [sym__regex_start] = ACTIONS(7608),
    [sym__string_array_start] = ACTIONS(7608),
    [sym__symbol_array_start] = ACTIONS(7608),
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym_heredoc_beginning] = ACTIONS(7608),
    [sym__block_ampersand] = ACTIONS(7608),
    [sym__splat_star] = ACTIONS(7608),
    [sym__unary_minus] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [sym__identifier_hash_key] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_def] = ACTIONS(7610),
    [anon_sym_LPAREN] = ACTIONS(7610),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COLON_COLON] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR] = ACTIONS(7610),
    [anon_sym_STAR_STAR] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_class] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_module] = ACTIONS(7610),
    [anon_sym_return] = ACTIONS(7610),
    [anon_sym_yield] = ACTIONS(7610),
    [anon_sym_break] = ACTIONS(7610),
    [anon_sym_next] = ACTIONS(7610),
    [sym_redo] = ACTIONS(7610),
    [sym_retry] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7610),
    [anon_sym_unless] = ACTIONS(7610),
    [anon_sym_while] = ACTIONS(7610),
    [anon_sym_until] = ACTIONS(7610),
    [anon_sym_rescue] = ACTIONS(7610),
    [anon_sym_for] = ACTIONS(7610),
    [anon_sym_in] = ACTIONS(7610),
    [anon_sym_do] = ACTIONS(7610),
    [anon_sym_case] = ACTIONS(7610),
    [anon_sym_begin] = ACTIONS(7610),
    [anon_sym_EQ_GT] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_RBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_LPAREN2] = ACTIONS(7608),
    [anon_sym_PLUS_EQ] = ACTIONS(7608),
    [anon_sym_DASH_EQ] = ACTIONS(7608),
    [anon_sym_STAR_EQ] = ACTIONS(7608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7608),
    [anon_sym_SLASH_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7608),
    [anon_sym_AMP_EQ] = ACTIONS(7608),
    [anon_sym_PERCENT_EQ] = ACTIONS(7608),
    [anon_sym_GT_GT_EQ] = ACTIONS(7608),
    [anon_sym_LT_LT_EQ] = ACTIONS(7608),
    [anon_sym_CARET_EQ] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COLON2] = ACTIONS(7610),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7610),
    [anon_sym_or] = ACTIONS(7610),
    [anon_sym_PIPE_PIPE] = ACTIONS(7610),
    [anon_sym_AMP_AMP] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [anon_sym_defined_QMARK] = ACTIONS(7608),
    [anon_sym_not] = ACTIONS(7610),
    [anon_sym_BANG] = ACTIONS(7610),
    [anon_sym_TILDE] = ACTIONS(7608),
    [sym_constant] = ACTIONS(7610),
    [sym_identifier] = ACTIONS(7610),
    [sym_instance_variable] = ACTIONS(7608),
    [sym_class_variable] = ACTIONS(7608),
    [sym_global_variable] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7610),
    [sym_float] = ACTIONS(7610),
    [sym_complex] = ACTIONS(7608),
    [sym_super] = ACTIONS(7610),
    [anon_sym_true] = ACTIONS(7610),
    [anon_sym_TRUE] = ACTIONS(7610),
    [anon_sym_false] = ACTIONS(7610),
    [anon_sym_FALSE] = ACTIONS(7610),
    [sym_self] = ACTIONS(7610),
    [anon_sym_nil] = ACTIONS(7610),
    [anon_sym_NIL] = ACTIONS(7610),
    [sym_character] = ACTIONS(7608),
    [anon_sym_LBRACK2] = ACTIONS(7610),
    [anon_sym_DASH_GT] = ACTIONS(7608),
  },
  [8290] = {
    [anon_sym_RPAREN] = ACTIONS(13134),
    [sym_comment] = ACTIONS(87),
  },
  [8291] = {
    [sym__heredoc_body_start] = ACTIONS(11825),
    [sym__binary_minus] = ACTIONS(11825),
    [sym__binary_star] = ACTIONS(11825),
    [anon_sym_LBRACE] = ACTIONS(11825),
    [anon_sym_RBRACE] = ACTIONS(11825),
    [anon_sym_RPAREN] = ACTIONS(11825),
    [anon_sym_DOT] = ACTIONS(11827),
    [anon_sym_COMMA] = ACTIONS(11825),
    [anon_sym_PIPE] = ACTIONS(11827),
    [anon_sym_SEMI] = ACTIONS(11825),
    [anon_sym_STAR_STAR] = ACTIONS(11827),
    [anon_sym_AMP] = ACTIONS(11827),
    [anon_sym_EQ] = ACTIONS(11827),
    [anon_sym_LT] = ACTIONS(11827),
    [anon_sym_if] = ACTIONS(11825),
    [anon_sym_unless] = ACTIONS(11825),
    [anon_sym_while] = ACTIONS(11825),
    [anon_sym_until] = ACTIONS(11825),
    [anon_sym_rescue] = ACTIONS(11825),
    [anon_sym_in] = ACTIONS(11825),
    [anon_sym_do] = ACTIONS(11825),
    [anon_sym_EQ_GT] = ACTIONS(11825),
    [anon_sym_LBRACK] = ACTIONS(11825),
    [anon_sym_RBRACK] = ACTIONS(11825),
    [anon_sym_COLON_COLON2] = ACTIONS(11825),
    [anon_sym_AMP_DOT] = ACTIONS(11825),
    [anon_sym_PLUS_EQ] = ACTIONS(11825),
    [anon_sym_DASH_EQ] = ACTIONS(11825),
    [anon_sym_STAR_EQ] = ACTIONS(11825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11825),
    [anon_sym_SLASH_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11825),
    [anon_sym_AMP_EQ] = ACTIONS(11825),
    [anon_sym_PERCENT_EQ] = ACTIONS(11825),
    [anon_sym_GT_GT_EQ] = ACTIONS(11825),
    [anon_sym_LT_LT_EQ] = ACTIONS(11825),
    [anon_sym_CARET_EQ] = ACTIONS(11825),
    [anon_sym_QMARK] = ACTIONS(11825),
    [anon_sym_COLON2] = ACTIONS(11827),
    [anon_sym_DOT_DOT] = ACTIONS(11827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11825),
    [anon_sym_and] = ACTIONS(11825),
    [anon_sym_or] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11827),
    [anon_sym_AMP_AMP] = ACTIONS(11827),
    [anon_sym_LT_LT] = ACTIONS(11827),
    [anon_sym_GT_GT] = ACTIONS(11827),
    [anon_sym_EQ_EQ] = ACTIONS(11827),
    [anon_sym_BANG_EQ] = ACTIONS(11825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11825),
    [anon_sym_LT_EQ_GT] = ACTIONS(11825),
    [anon_sym_EQ_TILDE] = ACTIONS(11825),
    [anon_sym_BANG_TILDE] = ACTIONS(11825),
    [anon_sym_LT_EQ] = ACTIONS(11827),
    [anon_sym_GT] = ACTIONS(11827),
    [anon_sym_GT_EQ] = ACTIONS(11825),
    [anon_sym_CARET] = ACTIONS(11827),
    [anon_sym_PLUS] = ACTIONS(11827),
    [anon_sym_SLASH] = ACTIONS(11827),
    [anon_sym_PERCENT] = ACTIONS(11827),
    [sym_comment] = ACTIONS(87),
  },
  [8292] = {
    [sym__heredoc_body_start] = ACTIONS(11655),
    [sym__binary_minus] = ACTIONS(11655),
    [sym__binary_star] = ACTIONS(11655),
    [anon_sym_LBRACE] = ACTIONS(11655),
    [anon_sym_RBRACE] = ACTIONS(11655),
    [anon_sym_RPAREN] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11657),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11657),
    [anon_sym_SEMI] = ACTIONS(11655),
    [anon_sym_STAR_STAR] = ACTIONS(11657),
    [anon_sym_AMP] = ACTIONS(11657),
    [anon_sym_EQ] = ACTIONS(11657),
    [anon_sym_LT] = ACTIONS(11657),
    [anon_sym_if] = ACTIONS(11655),
    [anon_sym_unless] = ACTIONS(11655),
    [anon_sym_while] = ACTIONS(11655),
    [anon_sym_until] = ACTIONS(11655),
    [anon_sym_rescue] = ACTIONS(11655),
    [anon_sym_in] = ACTIONS(11655),
    [anon_sym_do] = ACTIONS(11655),
    [anon_sym_EQ_GT] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_RBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [anon_sym_PLUS_EQ] = ACTIONS(11655),
    [anon_sym_DASH_EQ] = ACTIONS(11655),
    [anon_sym_STAR_EQ] = ACTIONS(11655),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11655),
    [anon_sym_SLASH_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11655),
    [anon_sym_AMP_EQ] = ACTIONS(11655),
    [anon_sym_PERCENT_EQ] = ACTIONS(11655),
    [anon_sym_GT_GT_EQ] = ACTIONS(11655),
    [anon_sym_LT_LT_EQ] = ACTIONS(11655),
    [anon_sym_CARET_EQ] = ACTIONS(11655),
    [anon_sym_QMARK] = ACTIONS(11655),
    [anon_sym_COLON2] = ACTIONS(11657),
    [anon_sym_DOT_DOT] = ACTIONS(11657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11655),
    [anon_sym_and] = ACTIONS(11655),
    [anon_sym_or] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE] = ACTIONS(11657),
    [anon_sym_AMP_AMP] = ACTIONS(11657),
    [anon_sym_LT_LT] = ACTIONS(11657),
    [anon_sym_GT_GT] = ACTIONS(11657),
    [anon_sym_EQ_EQ] = ACTIONS(11657),
    [anon_sym_BANG_EQ] = ACTIONS(11655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11655),
    [anon_sym_LT_EQ_GT] = ACTIONS(11655),
    [anon_sym_EQ_TILDE] = ACTIONS(11655),
    [anon_sym_BANG_TILDE] = ACTIONS(11655),
    [anon_sym_LT_EQ] = ACTIONS(11657),
    [anon_sym_GT] = ACTIONS(11657),
    [anon_sym_GT_EQ] = ACTIONS(11655),
    [anon_sym_CARET] = ACTIONS(11657),
    [anon_sym_PLUS] = ACTIONS(11657),
    [anon_sym_SLASH] = ACTIONS(11657),
    [anon_sym_PERCENT] = ACTIONS(11657),
    [sym_comment] = ACTIONS(87),
  },
  [8293] = {
    [sym__heredoc_body_start] = ACTIONS(11680),
    [sym__binary_minus] = ACTIONS(11680),
    [sym__binary_star] = ACTIONS(11680),
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RBRACE] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11682),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11682),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_STAR_STAR] = ACTIONS(11682),
    [anon_sym_AMP] = ACTIONS(11682),
    [anon_sym_EQ] = ACTIONS(11682),
    [anon_sym_LT] = ACTIONS(11682),
    [anon_sym_if] = ACTIONS(11680),
    [anon_sym_unless] = ACTIONS(11680),
    [anon_sym_while] = ACTIONS(11680),
    [anon_sym_until] = ACTIONS(11680),
    [anon_sym_rescue] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11680),
    [anon_sym_do] = ACTIONS(11680),
    [anon_sym_EQ_GT] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_RBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [anon_sym_PLUS_EQ] = ACTIONS(11680),
    [anon_sym_DASH_EQ] = ACTIONS(11680),
    [anon_sym_STAR_EQ] = ACTIONS(11680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11680),
    [anon_sym_SLASH_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11680),
    [anon_sym_AMP_EQ] = ACTIONS(11680),
    [anon_sym_PERCENT_EQ] = ACTIONS(11680),
    [anon_sym_GT_GT_EQ] = ACTIONS(11680),
    [anon_sym_LT_LT_EQ] = ACTIONS(11680),
    [anon_sym_CARET_EQ] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_COLON2] = ACTIONS(11682),
    [anon_sym_DOT_DOT] = ACTIONS(11682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_and] = ACTIONS(11680),
    [anon_sym_or] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE] = ACTIONS(11682),
    [anon_sym_AMP_AMP] = ACTIONS(11682),
    [anon_sym_LT_LT] = ACTIONS(11682),
    [anon_sym_GT_GT] = ACTIONS(11682),
    [anon_sym_EQ_EQ] = ACTIONS(11682),
    [anon_sym_BANG_EQ] = ACTIONS(11680),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11680),
    [anon_sym_LT_EQ_GT] = ACTIONS(11680),
    [anon_sym_EQ_TILDE] = ACTIONS(11680),
    [anon_sym_BANG_TILDE] = ACTIONS(11680),
    [anon_sym_LT_EQ] = ACTIONS(11682),
    [anon_sym_GT] = ACTIONS(11682),
    [anon_sym_GT_EQ] = ACTIONS(11680),
    [anon_sym_CARET] = ACTIONS(11682),
    [anon_sym_PLUS] = ACTIONS(11682),
    [anon_sym_SLASH] = ACTIONS(11682),
    [anon_sym_PERCENT] = ACTIONS(11682),
    [sym_comment] = ACTIONS(87),
  },
  [8294] = {
    [anon_sym_end] = ACTIONS(13136),
    [sym_comment] = ACTIONS(87),
  },
  [8295] = {
    [sym__statements] = STATE(9703),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13138),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8296] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9704),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_assignment] = STATE(9704),
    [sym_operator_assignment] = STATE(9704),
    [sym_conditional] = STATE(9704),
    [sym_range] = STATE(9704),
    [sym_binary] = STATE(9704),
    [sym_unary] = STATE(9704),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8297] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1379),
    [sym_scope_resolution] = STATE(1373),
    [sym_call] = STATE(1373),
    [sym_method_call] = STATE(1379),
    [sym_splat_argument] = STATE(8821),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym__arg_or_splat_arg] = STATE(8821),
    [sym_left_assignment_list] = STATE(1378),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1379),
    [sym__variable] = STATE(1373),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1379),
    [sym_false] = STATE(1379),
    [sym_nil] = STATE(1379),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3405),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(2403),
    [sym__unary_minus] = ACTIONS(2405),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2413),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_next] = ACTIONS(2417),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_defined_QMARK] = ACTIONS(2421),
    [anon_sym_not] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [sym_constant] = ACTIONS(2433),
    [sym_identifier] = ACTIONS(2433),
    [sym_instance_variable] = ACTIONS(2431),
    [sym_class_variable] = ACTIONS(2431),
    [sym_global_variable] = ACTIONS(2431),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2433),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2433),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8298] = {
    [aux_sym_exceptions_repeat1] = STATE(9705),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13140),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_RBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [8299] = {
    [sym__simple_symbol] = ACTIONS(6547),
    [sym__string_start] = ACTIONS(6547),
    [sym__symbol_start] = ACTIONS(6547),
    [sym__subshell_start] = ACTIONS(6547),
    [sym__regex_start] = ACTIONS(6547),
    [sym__string_array_start] = ACTIONS(6547),
    [sym__symbol_array_start] = ACTIONS(6547),
    [sym__heredoc_body_start] = ACTIONS(6547),
    [sym_heredoc_beginning] = ACTIONS(6547),
    [sym__block_ampersand] = ACTIONS(6547),
    [sym__splat_star] = ACTIONS(6547),
    [sym__unary_minus] = ACTIONS(6547),
    [sym__identifier_hash_key] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_def] = ACTIONS(8423),
    [anon_sym_LPAREN] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_COLON_COLON] = ACTIONS(6547),
    [anon_sym_STAR] = ACTIONS(8423),
    [anon_sym_STAR_STAR] = ACTIONS(6547),
    [anon_sym_class] = ACTIONS(8423),
    [anon_sym_module] = ACTIONS(8423),
    [anon_sym_return] = ACTIONS(8423),
    [anon_sym_yield] = ACTIONS(8423),
    [anon_sym_break] = ACTIONS(8423),
    [anon_sym_next] = ACTIONS(8423),
    [sym_redo] = ACTIONS(8423),
    [sym_retry] = ACTIONS(8423),
    [anon_sym_if] = ACTIONS(8423),
    [anon_sym_unless] = ACTIONS(8423),
    [anon_sym_while] = ACTIONS(8423),
    [anon_sym_until] = ACTIONS(8423),
    [anon_sym_for] = ACTIONS(8423),
    [anon_sym_case] = ACTIONS(8423),
    [anon_sym_begin] = ACTIONS(8423),
    [anon_sym_RBRACK] = ACTIONS(6547),
    [anon_sym_PLUS] = ACTIONS(8423),
    [anon_sym_defined_QMARK] = ACTIONS(6547),
    [anon_sym_not] = ACTIONS(8423),
    [anon_sym_BANG] = ACTIONS(6547),
    [anon_sym_TILDE] = ACTIONS(6547),
    [sym_constant] = ACTIONS(8423),
    [sym_identifier] = ACTIONS(8423),
    [sym_instance_variable] = ACTIONS(6547),
    [sym_class_variable] = ACTIONS(6547),
    [sym_global_variable] = ACTIONS(6547),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8423),
    [sym_float] = ACTIONS(8423),
    [sym_complex] = ACTIONS(6547),
    [sym_super] = ACTIONS(8423),
    [anon_sym_true] = ACTIONS(8423),
    [anon_sym_TRUE] = ACTIONS(8423),
    [anon_sym_false] = ACTIONS(8423),
    [anon_sym_FALSE] = ACTIONS(8423),
    [sym_self] = ACTIONS(8423),
    [anon_sym_nil] = ACTIONS(8423),
    [anon_sym_NIL] = ACTIONS(8423),
    [sym_character] = ACTIONS(6547),
    [anon_sym_LBRACK2] = ACTIONS(6547),
    [anon_sym_DASH_GT] = ACTIONS(6547),
  },
  [8300] = {
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [8301] = {
    [aux_sym_exceptions_repeat1] = STATE(8301),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13142),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [8302] = {
    [aux_sym_block_parameters_repeat1] = STATE(9707),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(13145),
    [sym_comment] = ACTIONS(87),
  },
  [8303] = {
    [sym_identifier] = ACTIONS(13147),
    [sym_comment] = ACTIONS(87),
  },
  [8304] = {
    [sym__simple_symbol] = ACTIONS(13149),
    [sym__string_start] = ACTIONS(13149),
    [sym__symbol_start] = ACTIONS(13149),
    [sym__subshell_start] = ACTIONS(13149),
    [sym__regex_start] = ACTIONS(13149),
    [sym__string_array_start] = ACTIONS(13149),
    [sym__symbol_array_start] = ACTIONS(13149),
    [sym_heredoc_beginning] = ACTIONS(13149),
    [sym__unary_minus] = ACTIONS(13149),
    [anon_sym_BEGIN] = ACTIONS(13151),
    [anon_sym_LBRACE] = ACTIONS(13149),
    [anon_sym_RBRACE] = ACTIONS(13149),
    [anon_sym_END] = ACTIONS(13151),
    [anon_sym_def] = ACTIONS(13151),
    [anon_sym_LPAREN] = ACTIONS(13149),
    [anon_sym_COLON_COLON] = ACTIONS(13149),
    [anon_sym_SEMI] = ACTIONS(13149),
    [anon_sym_STAR] = ACTIONS(13149),
    [anon_sym_class] = ACTIONS(13151),
    [anon_sym_module] = ACTIONS(13151),
    [anon_sym_return] = ACTIONS(13151),
    [anon_sym_yield] = ACTIONS(13151),
    [anon_sym_break] = ACTIONS(13151),
    [anon_sym_next] = ACTIONS(13151),
    [sym_redo] = ACTIONS(13151),
    [sym_retry] = ACTIONS(13151),
    [anon_sym_if] = ACTIONS(13151),
    [anon_sym_unless] = ACTIONS(13151),
    [anon_sym_while] = ACTIONS(13151),
    [anon_sym_until] = ACTIONS(13151),
    [anon_sym_for] = ACTIONS(13151),
    [anon_sym_case] = ACTIONS(13151),
    [anon_sym_begin] = ACTIONS(13151),
    [anon_sym_PLUS] = ACTIONS(13151),
    [anon_sym_defined_QMARK] = ACTIONS(13149),
    [anon_sym_not] = ACTIONS(13151),
    [anon_sym_BANG] = ACTIONS(13149),
    [anon_sym_TILDE] = ACTIONS(13149),
    [sym_constant] = ACTIONS(13151),
    [sym_identifier] = ACTIONS(13151),
    [sym_instance_variable] = ACTIONS(13149),
    [sym_class_variable] = ACTIONS(13149),
    [sym_global_variable] = ACTIONS(13149),
    [anon_sym_undef] = ACTIONS(13151),
    [anon_sym_alias] = ACTIONS(13151),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13151),
    [sym_float] = ACTIONS(13151),
    [sym_complex] = ACTIONS(13149),
    [sym_super] = ACTIONS(13151),
    [anon_sym_true] = ACTIONS(13151),
    [anon_sym_TRUE] = ACTIONS(13151),
    [anon_sym_false] = ACTIONS(13151),
    [anon_sym_FALSE] = ACTIONS(13151),
    [sym_self] = ACTIONS(13151),
    [anon_sym_nil] = ACTIONS(13151),
    [anon_sym_NIL] = ACTIONS(13151),
    [sym_character] = ACTIONS(13149),
    [anon_sym_LBRACK2] = ACTIONS(13149),
    [anon_sym_DASH_GT] = ACTIONS(13149),
  },
  [8305] = {
    [aux_sym_block_parameters_repeat1] = STATE(9709),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(13145),
    [sym_comment] = ACTIONS(87),
  },
  [8306] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9710),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(9710),
    [sym_operator_assignment] = STATE(9710),
    [sym_conditional] = STATE(9710),
    [sym_range] = STATE(9710),
    [sym_binary] = STATE(9710),
    [sym_unary] = STATE(9710),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8307] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9723),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(562),
    [sym__argument_list_with_parens] = STATE(9725),
    [sym__argument] = STATE(9726),
    [sym_splat_argument] = STATE(9726),
    [sym_hash_splat_argument] = STATE(9726),
    [sym_block_argument] = STATE(9726),
    [sym_assignment] = STATE(9723),
    [sym_operator_assignment] = STATE(9723),
    [sym_conditional] = STATE(9723),
    [sym_range] = STATE(9723),
    [sym_binary] = STATE(9723),
    [sym_unary] = STATE(9723),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(9729),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(9726),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13153),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(13159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13177),
    [sym_identifier] = ACTIONS(13177),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8308] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9723),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(568),
    [sym__argument_list_with_parens] = STATE(9725),
    [sym__argument] = STATE(9726),
    [sym_splat_argument] = STATE(9726),
    [sym_hash_splat_argument] = STATE(9726),
    [sym_block_argument] = STATE(9726),
    [sym_assignment] = STATE(9723),
    [sym_operator_assignment] = STATE(9723),
    [sym_conditional] = STATE(9723),
    [sym_range] = STATE(9723),
    [sym_binary] = STATE(9723),
    [sym_unary] = STATE(9723),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(9729),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(9726),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13153),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(13159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13177),
    [sym_identifier] = ACTIONS(13177),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8309] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9723),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(569),
    [sym__argument_list_with_parens] = STATE(9725),
    [sym__argument] = STATE(9726),
    [sym_splat_argument] = STATE(9726),
    [sym_hash_splat_argument] = STATE(9726),
    [sym_block_argument] = STATE(9726),
    [sym_assignment] = STATE(9723),
    [sym_operator_assignment] = STATE(9723),
    [sym_conditional] = STATE(9723),
    [sym_range] = STATE(9723),
    [sym_binary] = STATE(9723),
    [sym_unary] = STATE(9723),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(9729),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(9726),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13153),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(13159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13177),
    [sym_identifier] = ACTIONS(13177),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8310] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9723),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(570),
    [sym__argument_list_with_parens] = STATE(9725),
    [sym__argument] = STATE(9726),
    [sym_splat_argument] = STATE(9726),
    [sym_hash_splat_argument] = STATE(9726),
    [sym_block_argument] = STATE(9726),
    [sym_assignment] = STATE(9723),
    [sym_operator_assignment] = STATE(9723),
    [sym_conditional] = STATE(9723),
    [sym_range] = STATE(9723),
    [sym_binary] = STATE(9723),
    [sym_unary] = STATE(9723),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(9729),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(9726),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13153),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(13159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13177),
    [sym_identifier] = ACTIONS(13177),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8311] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9730),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(9730),
    [sym_operator_assignment] = STATE(9730),
    [sym_conditional] = STATE(9730),
    [sym_range] = STATE(9730),
    [sym_binary] = STATE(9730),
    [sym_unary] = STATE(9730),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8312] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(585),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(585),
    [sym_operator_assignment] = STATE(585),
    [sym_conditional] = STATE(585),
    [sym_range] = STATE(585),
    [sym_binary] = STATE(585),
    [sym_unary] = STATE(585),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8313] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(9206),
    [anon_sym_PIPE] = ACTIONS(13187),
    [anon_sym_SEMI] = ACTIONS(9206),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(13191),
    [anon_sym_QMARK] = ACTIONS(13193),
    [anon_sym_DOT_DOT] = ACTIONS(13195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13197),
    [anon_sym_and] = ACTIONS(13199),
    [anon_sym_or] = ACTIONS(13199),
    [anon_sym_PIPE_PIPE] = ACTIONS(13201),
    [anon_sym_AMP_AMP] = ACTIONS(13201),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(13205),
    [anon_sym_BANG_EQ] = ACTIONS(13201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13201),
    [anon_sym_LT_EQ_GT] = ACTIONS(13201),
    [anon_sym_EQ_TILDE] = ACTIONS(13201),
    [anon_sym_BANG_TILDE] = ACTIONS(13201),
    [anon_sym_LT_EQ] = ACTIONS(13191),
    [anon_sym_GT] = ACTIONS(13191),
    [anon_sym_GT_EQ] = ACTIONS(13207),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [8314] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(1662),
    [sym__argument_list_with_parens] = STATE(9755),
    [sym__argument] = STATE(9756),
    [sym_splat_argument] = STATE(9756),
    [sym_hash_splat_argument] = STATE(9756),
    [sym_block_argument] = STATE(9756),
    [sym_do_block] = STATE(1665),
    [sym_block] = STATE(1665),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9759),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9756),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13211),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(13217),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13235),
    [sym_identifier] = ACTIONS(13235),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8315] = {
    [anon_sym_EQ] = ACTIONS(13241),
    [sym_comment] = ACTIONS(87),
  },
  [8316] = {
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13243),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13245),
    [anon_sym_DASH_EQ] = ACTIONS(13245),
    [anon_sym_STAR_EQ] = ACTIONS(13245),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13245),
    [anon_sym_SLASH_EQ] = ACTIONS(13245),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13245),
    [anon_sym_PIPE_EQ] = ACTIONS(13245),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13245),
    [anon_sym_AMP_EQ] = ACTIONS(13245),
    [anon_sym_PERCENT_EQ] = ACTIONS(13245),
    [anon_sym_GT_GT_EQ] = ACTIONS(13245),
    [anon_sym_LT_LT_EQ] = ACTIONS(13245),
    [anon_sym_CARET_EQ] = ACTIONS(13245),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8317] = {
    [sym_string] = STATE(9762),
    [aux_sym_chained_string_repeat1] = STATE(9762),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8318] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(9240),
    [anon_sym_PIPE] = ACTIONS(13247),
    [anon_sym_SEMI] = ACTIONS(9240),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(13191),
    [anon_sym_QMARK] = ACTIONS(13193),
    [anon_sym_DOT_DOT] = ACTIONS(13195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13197),
    [anon_sym_and] = ACTIONS(13199),
    [anon_sym_or] = ACTIONS(13199),
    [anon_sym_PIPE_PIPE] = ACTIONS(13201),
    [anon_sym_AMP_AMP] = ACTIONS(13201),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(13205),
    [anon_sym_BANG_EQ] = ACTIONS(13201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13201),
    [anon_sym_LT_EQ_GT] = ACTIONS(13201),
    [anon_sym_EQ_TILDE] = ACTIONS(13201),
    [anon_sym_BANG_TILDE] = ACTIONS(13201),
    [anon_sym_LT_EQ] = ACTIONS(13191),
    [anon_sym_GT] = ACTIONS(13191),
    [anon_sym_GT_EQ] = ACTIONS(13207),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [8319] = {
    [sym_identifier] = ACTIONS(13249),
    [sym_comment] = ACTIONS(87),
  },
  [8320] = {
    [sym__formal_parameter] = STATE(6054),
    [sym__simple_formal_parameter] = STATE(6054),
    [sym_destructured_parameter] = STATE(6054),
    [sym_splat_parameter] = STATE(6054),
    [sym_hash_splat_parameter] = STATE(6054),
    [sym_block_parameter] = STATE(6054),
    [sym_keyword_parameter] = STATE(6054),
    [sym_optional_parameter] = STATE(6054),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(13145),
    [anon_sym_SEMI] = ACTIONS(13251),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5604),
    [sym_comment] = ACTIONS(87),
  },
  [8321] = {
    [aux_sym_method_parameters_repeat1] = STATE(8321),
    [anon_sym_COMMA] = ACTIONS(13253),
    [anon_sym_PIPE] = ACTIONS(11665),
    [anon_sym_SEMI] = ACTIONS(11665),
    [sym_comment] = ACTIONS(87),
  },
  [8322] = {
    [anon_sym_RPAREN] = ACTIONS(13256),
    [anon_sym_COMMA] = ACTIONS(13256),
    [anon_sym_PIPE] = ACTIONS(13256),
    [anon_sym_SEMI] = ACTIONS(13256),
    [sym_comment] = ACTIONS(87),
  },
  [8323] = {
    [aux_sym_block_parameters_repeat1] = STATE(9767),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(13258),
    [sym_comment] = ACTIONS(87),
  },
  [8324] = {
    [sym__line_break] = ACTIONS(13149),
    [sym__simple_symbol] = ACTIONS(13149),
    [sym__string_start] = ACTIONS(13149),
    [sym__symbol_start] = ACTIONS(13149),
    [sym__subshell_start] = ACTIONS(13149),
    [sym__regex_start] = ACTIONS(13149),
    [sym__string_array_start] = ACTIONS(13149),
    [sym__symbol_array_start] = ACTIONS(13149),
    [sym__heredoc_body_start] = ACTIONS(13149),
    [sym_heredoc_beginning] = ACTIONS(13149),
    [sym__unary_minus] = ACTIONS(13149),
    [anon_sym_BEGIN] = ACTIONS(13151),
    [anon_sym_LBRACE] = ACTIONS(13149),
    [anon_sym_END] = ACTIONS(13151),
    [anon_sym_def] = ACTIONS(13151),
    [anon_sym_LPAREN] = ACTIONS(13149),
    [anon_sym_COLON_COLON] = ACTIONS(13149),
    [anon_sym_SEMI] = ACTIONS(13149),
    [anon_sym_STAR] = ACTIONS(13149),
    [anon_sym_class] = ACTIONS(13151),
    [anon_sym_module] = ACTIONS(13151),
    [anon_sym_end] = ACTIONS(13151),
    [anon_sym_return] = ACTIONS(13151),
    [anon_sym_yield] = ACTIONS(13151),
    [anon_sym_break] = ACTIONS(13151),
    [anon_sym_next] = ACTIONS(13151),
    [sym_redo] = ACTIONS(13151),
    [sym_retry] = ACTIONS(13151),
    [anon_sym_if] = ACTIONS(13151),
    [anon_sym_unless] = ACTIONS(13151),
    [anon_sym_while] = ACTIONS(13151),
    [anon_sym_until] = ACTIONS(13151),
    [anon_sym_for] = ACTIONS(13151),
    [anon_sym_case] = ACTIONS(13151),
    [anon_sym_begin] = ACTIONS(13151),
    [anon_sym_PLUS] = ACTIONS(13151),
    [anon_sym_defined_QMARK] = ACTIONS(13149),
    [anon_sym_not] = ACTIONS(13151),
    [anon_sym_BANG] = ACTIONS(13149),
    [anon_sym_TILDE] = ACTIONS(13149),
    [sym_constant] = ACTIONS(13151),
    [sym_identifier] = ACTIONS(13151),
    [sym_instance_variable] = ACTIONS(13149),
    [sym_class_variable] = ACTIONS(13149),
    [sym_global_variable] = ACTIONS(13149),
    [anon_sym_undef] = ACTIONS(13151),
    [anon_sym_alias] = ACTIONS(13151),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13151),
    [sym_float] = ACTIONS(13151),
    [sym_complex] = ACTIONS(13149),
    [sym_super] = ACTIONS(13151),
    [anon_sym_true] = ACTIONS(13151),
    [anon_sym_TRUE] = ACTIONS(13151),
    [anon_sym_false] = ACTIONS(13151),
    [anon_sym_FALSE] = ACTIONS(13151),
    [sym_self] = ACTIONS(13151),
    [anon_sym_nil] = ACTIONS(13151),
    [anon_sym_NIL] = ACTIONS(13151),
    [sym_character] = ACTIONS(13149),
    [anon_sym_LBRACK2] = ACTIONS(13149),
    [anon_sym_DASH_GT] = ACTIONS(13149),
  },
  [8325] = {
    [aux_sym_block_parameters_repeat1] = STATE(9709),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(13258),
    [sym_comment] = ACTIONS(87),
  },
  [8326] = {
    [sym_identifier] = ACTIONS(13260),
    [sym_comment] = ACTIONS(87),
  },
  [8327] = {
    [sym__formal_parameter] = STATE(6054),
    [sym__simple_formal_parameter] = STATE(6054),
    [sym_destructured_parameter] = STATE(6054),
    [sym_splat_parameter] = STATE(6054),
    [sym_hash_splat_parameter] = STATE(6054),
    [sym_block_parameter] = STATE(6054),
    [sym_keyword_parameter] = STATE(6054),
    [sym_optional_parameter] = STATE(6054),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(13258),
    [anon_sym_SEMI] = ACTIONS(13262),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5604),
    [sym_comment] = ACTIONS(87),
  },
  [8328] = {
    [sym__line_break] = ACTIONS(13264),
    [sym__heredoc_body_start] = ACTIONS(13264),
    [sym__binary_minus] = ACTIONS(13264),
    [sym__binary_star] = ACTIONS(13264),
    [ts_builtin_sym_end] = ACTIONS(13264),
    [anon_sym___END__] = ACTIONS(13264),
    [anon_sym_LBRACE] = ACTIONS(13264),
    [anon_sym_RBRACE] = ACTIONS(13264),
    [anon_sym_RPAREN] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13266),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13266),
    [anon_sym_SEMI] = ACTIONS(13264),
    [anon_sym_STAR_STAR] = ACTIONS(13264),
    [anon_sym_AMP] = ACTIONS(13266),
    [anon_sym_LT] = ACTIONS(13266),
    [anon_sym_end] = ACTIONS(13264),
    [anon_sym_if] = ACTIONS(13264),
    [anon_sym_unless] = ACTIONS(13264),
    [anon_sym_while] = ACTIONS(13264),
    [anon_sym_until] = ACTIONS(13264),
    [anon_sym_rescue] = ACTIONS(13264),
    [anon_sym_do] = ACTIONS(13264),
    [anon_sym_when] = ACTIONS(13264),
    [anon_sym_elsif] = ACTIONS(13264),
    [anon_sym_else] = ACTIONS(13264),
    [anon_sym_then] = ACTIONS(13264),
    [anon_sym_ensure] = ACTIONS(13264),
    [anon_sym_EQ_GT] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [anon_sym_QMARK] = ACTIONS(13264),
    [anon_sym_DOT_DOT] = ACTIONS(13266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13264),
    [anon_sym_and] = ACTIONS(13264),
    [anon_sym_or] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE] = ACTIONS(13264),
    [anon_sym_AMP_AMP] = ACTIONS(13264),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13264),
    [anon_sym_LT_EQ_GT] = ACTIONS(13264),
    [anon_sym_EQ_TILDE] = ACTIONS(13264),
    [anon_sym_BANG_TILDE] = ACTIONS(13264),
    [anon_sym_LT_EQ] = ACTIONS(13266),
    [anon_sym_GT] = ACTIONS(13266),
    [anon_sym_GT_EQ] = ACTIONS(13264),
    [anon_sym_CARET] = ACTIONS(13264),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13264),
    [anon_sym_PERCENT] = ACTIONS(13264),
    [sym_comment] = ACTIONS(87),
  },
  [8329] = {
    [anon_sym_end] = ACTIONS(13268),
    [sym_comment] = ACTIONS(87),
  },
  [8330] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [8331] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8332] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [8333] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [8334] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [8335] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13270),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8336] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(9212),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(9216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9218),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(9222),
    [anon_sym_AMP_AMP] = ACTIONS(9222),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(9226),
    [anon_sym_BANG_EQ] = ACTIONS(9222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9222),
    [anon_sym_LT_EQ_GT] = ACTIONS(9222),
    [anon_sym_EQ_TILDE] = ACTIONS(9222),
    [anon_sym_BANG_TILDE] = ACTIONS(9222),
    [anon_sym_LT_EQ] = ACTIONS(9212),
    [anon_sym_GT] = ACTIONS(9212),
    [anon_sym_GT_EQ] = ACTIONS(9228),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [8337] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(9212),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(9214),
    [anon_sym_DOT_DOT] = ACTIONS(9216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9218),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(9222),
    [anon_sym_AMP_AMP] = ACTIONS(9222),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(9226),
    [anon_sym_BANG_EQ] = ACTIONS(9222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9222),
    [anon_sym_LT_EQ_GT] = ACTIONS(9222),
    [anon_sym_EQ_TILDE] = ACTIONS(9222),
    [anon_sym_BANG_TILDE] = ACTIONS(9222),
    [anon_sym_LT_EQ] = ACTIONS(9212),
    [anon_sym_GT] = ACTIONS(9212),
    [anon_sym_GT_EQ] = ACTIONS(9228),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [8338] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(9212),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(9226),
    [anon_sym_BANG_EQ] = ACTIONS(9222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9222),
    [anon_sym_LT_EQ_GT] = ACTIONS(9222),
    [anon_sym_EQ_TILDE] = ACTIONS(9222),
    [anon_sym_BANG_TILDE] = ACTIONS(9222),
    [anon_sym_LT_EQ] = ACTIONS(9212),
    [anon_sym_GT] = ACTIONS(9212),
    [anon_sym_GT_EQ] = ACTIONS(9228),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [8339] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [8340] = {
    [sym__heredoc_body_start] = ACTIONS(993),
    [sym__binary_minus] = ACTIONS(5594),
    [sym__binary_star] = ACTIONS(5594),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_STAR_STAR] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_do] = ACTIONS(5594),
    [anon_sym_EQ_GT] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_COLON_COLON2] = ACTIONS(5594),
    [anon_sym_AMP_DOT] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_and] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_EQ_TILDE] = ACTIONS(5594),
    [anon_sym_BANG_TILDE] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [sym_comment] = ACTIONS(87),
  },
  [8341] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9772),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(9772),
    [sym_operator_assignment] = STATE(9772),
    [sym_conditional] = STATE(9772),
    [sym_range] = STATE(9772),
    [sym_binary] = STATE(9772),
    [sym_unary] = STATE(9772),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8342] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(9212),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(9214),
    [anon_sym_DOT_DOT] = ACTIONS(9216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9218),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(9222),
    [anon_sym_AMP_AMP] = ACTIONS(9222),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(9226),
    [anon_sym_BANG_EQ] = ACTIONS(9222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9222),
    [anon_sym_LT_EQ_GT] = ACTIONS(9222),
    [anon_sym_EQ_TILDE] = ACTIONS(9222),
    [anon_sym_BANG_TILDE] = ACTIONS(9222),
    [anon_sym_LT_EQ] = ACTIONS(9212),
    [anon_sym_GT] = ACTIONS(9212),
    [anon_sym_GT_EQ] = ACTIONS(9228),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [8343] = {
    [aux_sym_exceptions_repeat1] = STATE(9774),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8344] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(9212),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(9214),
    [anon_sym_DOT_DOT] = ACTIONS(9216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9218),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9222),
    [anon_sym_AMP_AMP] = ACTIONS(9222),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(9226),
    [anon_sym_BANG_EQ] = ACTIONS(9222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9222),
    [anon_sym_LT_EQ_GT] = ACTIONS(9222),
    [anon_sym_EQ_TILDE] = ACTIONS(9222),
    [anon_sym_BANG_TILDE] = ACTIONS(9222),
    [anon_sym_LT_EQ] = ACTIONS(9212),
    [anon_sym_GT] = ACTIONS(9212),
    [anon_sym_GT_EQ] = ACTIONS(9228),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [8345] = {
    [sym_string] = STATE(8345),
    [aux_sym_chained_string_repeat1] = STATE(8345),
    [sym__string_start] = ACTIONS(6891),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [8346] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8347] = {
    [sym_heredoc_body] = STATE(9775),
    [aux_sym_call_repeat1] = STATE(9775),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_COLON2] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [8348] = {
    [sym_heredoc_body] = STATE(9775),
    [aux_sym_call_repeat1] = STATE(9775),
    [aux_sym_argument_list_repeat1] = STATE(9776),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(9323),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_COLON2] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [8349] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11702),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [8350] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9777),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(9777),
    [sym_operator_assignment] = STATE(9777),
    [sym_conditional] = STATE(9777),
    [sym_range] = STATE(9777),
    [sym_binary] = STATE(9777),
    [sym_unary] = STATE(9777),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8351] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9778),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(9778),
    [sym_operator_assignment] = STATE(9778),
    [sym_conditional] = STATE(9778),
    [sym_range] = STATE(9778),
    [sym_binary] = STATE(9778),
    [sym_unary] = STATE(9778),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8352] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9779),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(9779),
    [sym_operator_assignment] = STATE(9779),
    [sym_conditional] = STATE(9779),
    [sym_range] = STATE(9779),
    [sym_binary] = STATE(9779),
    [sym_unary] = STATE(9779),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8353] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9780),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(9780),
    [sym_operator_assignment] = STATE(9780),
    [sym_conditional] = STATE(9780),
    [sym_range] = STATE(9780),
    [sym_binary] = STATE(9780),
    [sym_unary] = STATE(9780),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8354] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9781),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(9781),
    [sym_operator_assignment] = STATE(9781),
    [sym_conditional] = STATE(9781),
    [sym_range] = STATE(9781),
    [sym_binary] = STATE(9781),
    [sym_unary] = STATE(9781),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8355] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9782),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9782),
    [sym_operator_assignment] = STATE(9782),
    [sym_conditional] = STATE(9782),
    [sym_range] = STATE(9782),
    [sym_binary] = STATE(9782),
    [sym_unary] = STATE(9782),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8356] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9783),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(9783),
    [sym_operator_assignment] = STATE(9783),
    [sym_conditional] = STATE(9783),
    [sym_range] = STATE(9783),
    [sym_binary] = STATE(9783),
    [sym_unary] = STATE(9783),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8357] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9784),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(9784),
    [sym_operator_assignment] = STATE(9784),
    [sym_conditional] = STATE(9784),
    [sym_range] = STATE(9784),
    [sym_binary] = STATE(9784),
    [sym_unary] = STATE(9784),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8358] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9785),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(9785),
    [sym_operator_assignment] = STATE(9785),
    [sym_conditional] = STATE(9785),
    [sym_range] = STATE(9785),
    [sym_binary] = STATE(9785),
    [sym_unary] = STATE(9785),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8359] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9786),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(9786),
    [sym_operator_assignment] = STATE(9786),
    [sym_conditional] = STATE(9786),
    [sym_range] = STATE(9786),
    [sym_binary] = STATE(9786),
    [sym_unary] = STATE(9786),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8360] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9787),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_splat_argument] = STATE(9788),
    [sym_assignment] = STATE(9787),
    [sym_operator_assignment] = STATE(9787),
    [sym_conditional] = STATE(9787),
    [sym_range] = STATE(9787),
    [sym_binary] = STATE(9787),
    [sym_unary] = STATE(9787),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(9788),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8361] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9789),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(9789),
    [sym_operator_assignment] = STATE(9789),
    [sym_conditional] = STATE(9789),
    [sym_range] = STATE(9789),
    [sym_binary] = STATE(9789),
    [sym_unary] = STATE(9789),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8362] = {
    [sym_string] = STATE(9790),
    [aux_sym_chained_string_repeat1] = STATE(9790),
    [sym__string_start] = ACTIONS(3870),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_COLON2] = ACTIONS(2761),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [8363] = {
    [sym__string_start] = ACTIONS(837),
    [sym__heredoc_body_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_EQ_GT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_COLON2] = ACTIONS(839),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(837),
    [anon_sym_PERCENT] = ACTIONS(837),
    [sym_comment] = ACTIONS(87),
  },
  [8364] = {
    [sym__string_end] = ACTIONS(13272),
    [sym_comment] = ACTIONS(87),
  },
  [8365] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(11702),
    [anon_sym_COLON2] = ACTIONS(7554),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [8366] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(4080),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8367] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(4112),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8368] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9792),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(9792),
    [sym_operator_assignment] = STATE(9792),
    [sym_conditional] = STATE(9792),
    [sym_range] = STATE(9792),
    [sym_binary] = STATE(9792),
    [sym_unary] = STATE(9792),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8369] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(4114),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8370] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9793),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(9793),
    [sym_operator_assignment] = STATE(9793),
    [sym_conditional] = STATE(9793),
    [sym_range] = STATE(9793),
    [sym_binary] = STATE(9793),
    [sym_unary] = STATE(9793),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8371] = {
    [sym_heredoc_body] = STATE(9794),
    [aux_sym_call_repeat1] = STATE(9794),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_COLON2] = ACTIONS(4248),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [8372] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6106),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(6106),
    [sym_operator_assignment] = STATE(6106),
    [sym_conditional] = STATE(6106),
    [sym_range] = STATE(6106),
    [sym_binary] = STATE(6106),
    [sym_unary] = STATE(6106),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6109),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(9795),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9279),
    [sym__splat_star] = ACTIONS(9281),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__identifier_hash_key] = ACTIONS(9283),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13274),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(9285),
    [sym_identifier] = ACTIONS(9285),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8373] = {
    [sym_heredoc_body] = STATE(9796),
    [aux_sym_call_repeat1] = STATE(9796),
    [aux_sym_argument_list_repeat1] = STATE(9797),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(11730),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_COLON2] = ACTIONS(4248),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [8374] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(11702),
    [anon_sym_COLON2] = ACTIONS(7616),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [8375] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8376] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8377] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8378] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8379] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8380] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13276),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8381] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COLON2] = ACTIONS(7620),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8382] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8383] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8384] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8385] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(4080),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8386] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(4112),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8387] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9799),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(9799),
    [sym_operator_assignment] = STATE(9799),
    [sym_conditional] = STATE(9799),
    [sym_range] = STATE(9799),
    [sym_binary] = STATE(9799),
    [sym_unary] = STATE(9799),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8388] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(4114),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8389] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9800),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(9800),
    [sym_operator_assignment] = STATE(9800),
    [sym_conditional] = STATE(9800),
    [sym_range] = STATE(9800),
    [sym_binary] = STATE(9800),
    [sym_unary] = STATE(9800),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8390] = {
    [sym_heredoc_body] = STATE(9801),
    [aux_sym_call_repeat1] = STATE(9801),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_COLON2] = ACTIONS(4248),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [8391] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6127),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym__argument] = STATE(4285),
    [sym_splat_argument] = STATE(4285),
    [sym_hash_splat_argument] = STATE(4285),
    [sym_block_argument] = STATE(4285),
    [sym_assignment] = STATE(6127),
    [sym_operator_assignment] = STATE(6127),
    [sym_conditional] = STATE(6127),
    [sym_range] = STATE(6127),
    [sym_binary] = STATE(6127),
    [sym_unary] = STATE(6127),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6130),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(9802),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4285),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9315),
    [sym__splat_star] = ACTIONS(9317),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__identifier_hash_key] = ACTIONS(9319),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13278),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(9321),
    [sym_identifier] = ACTIONS(9321),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8392] = {
    [sym_heredoc_body] = STATE(9803),
    [aux_sym_call_repeat1] = STATE(9803),
    [aux_sym_argument_list_repeat1] = STATE(9804),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(11738),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_COLON2] = ACTIONS(4248),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [8393] = {
    [sym_heredoc_body] = STATE(8393),
    [aux_sym_call_repeat1] = STATE(8393),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_COLON2] = ACTIONS(7651),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8394] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3499),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(3499),
    [sym_operator_assignment] = STATE(3499),
    [sym_conditional] = STATE(3499),
    [sym_range] = STATE(3499),
    [sym_binary] = STATE(3499),
    [sym_unary] = STATE(3499),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3505),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(5702),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__identifier_hash_key] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11742),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5726),
    [sym_identifier] = ACTIONS(5726),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8395] = {
    [sym_heredoc_body] = STATE(8393),
    [aux_sym_call_repeat1] = STATE(8393),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_COLON2] = ACTIONS(7663),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8396] = {
    [aux_sym_argument_list_repeat1] = STATE(8396),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13280),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_COLON2] = ACTIONS(7659),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [8397] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(7668),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8398] = {
    [aux_sym_exceptions_repeat1] = STATE(9806),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_COLON2] = ACTIONS(6062),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8399] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(7670),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [8400] = {
    [sym_string] = STATE(8400),
    [aux_sym_chained_string_repeat1] = STATE(8400),
    [sym__string_start] = ACTIONS(13283),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_COLON2] = ACTIONS(6081),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [8401] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9807),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9807),
    [sym_operator_assignment] = STATE(9807),
    [sym_conditional] = STATE(9807),
    [sym_range] = STATE(9807),
    [sym_binary] = STATE(9807),
    [sym_unary] = STATE(9807),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8402] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [8403] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11760),
    [anon_sym_COLON2] = ACTIONS(937),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [8404] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9808),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(9808),
    [sym_operator_assignment] = STATE(9808),
    [sym_conditional] = STATE(9808),
    [sym_range] = STATE(9808),
    [sym_binary] = STATE(9808),
    [sym_unary] = STATE(9808),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8405] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9809),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(9809),
    [sym_operator_assignment] = STATE(9809),
    [sym_conditional] = STATE(9809),
    [sym_range] = STATE(9809),
    [sym_binary] = STATE(9809),
    [sym_unary] = STATE(9809),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8406] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9810),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(9810),
    [sym_operator_assignment] = STATE(9810),
    [sym_conditional] = STATE(9810),
    [sym_range] = STATE(9810),
    [sym_binary] = STATE(9810),
    [sym_unary] = STATE(9810),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8407] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9811),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(9811),
    [sym_operator_assignment] = STATE(9811),
    [sym_conditional] = STATE(9811),
    [sym_range] = STATE(9811),
    [sym_binary] = STATE(9811),
    [sym_unary] = STATE(9811),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8408] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9812),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(9812),
    [sym_operator_assignment] = STATE(9812),
    [sym_conditional] = STATE(9812),
    [sym_range] = STATE(9812),
    [sym_binary] = STATE(9812),
    [sym_unary] = STATE(9812),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8409] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9813),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9813),
    [sym_operator_assignment] = STATE(9813),
    [sym_conditional] = STATE(9813),
    [sym_range] = STATE(9813),
    [sym_binary] = STATE(9813),
    [sym_unary] = STATE(9813),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8410] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9814),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(9814),
    [sym_operator_assignment] = STATE(9814),
    [sym_conditional] = STATE(9814),
    [sym_range] = STATE(9814),
    [sym_binary] = STATE(9814),
    [sym_unary] = STATE(9814),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8411] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9815),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(9815),
    [sym_operator_assignment] = STATE(9815),
    [sym_conditional] = STATE(9815),
    [sym_range] = STATE(9815),
    [sym_binary] = STATE(9815),
    [sym_unary] = STATE(9815),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8412] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9816),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(9816),
    [sym_operator_assignment] = STATE(9816),
    [sym_conditional] = STATE(9816),
    [sym_range] = STATE(9816),
    [sym_binary] = STATE(9816),
    [sym_unary] = STATE(9816),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8413] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9817),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(9817),
    [sym_operator_assignment] = STATE(9817),
    [sym_conditional] = STATE(9817),
    [sym_range] = STATE(9817),
    [sym_binary] = STATE(9817),
    [sym_unary] = STATE(9817),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8414] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9818),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_splat_argument] = STATE(9819),
    [sym_assignment] = STATE(9818),
    [sym_operator_assignment] = STATE(9818),
    [sym_conditional] = STATE(9818),
    [sym_range] = STATE(9818),
    [sym_binary] = STATE(9818),
    [sym_unary] = STATE(9818),
    [sym_right_assignment_list] = STATE(8647),
    [sym__arg_or_splat_arg] = STATE(9819),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8415] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9820),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(9820),
    [sym_operator_assignment] = STATE(9820),
    [sym_conditional] = STATE(9820),
    [sym_range] = STATE(9820),
    [sym_binary] = STATE(9820),
    [sym_unary] = STATE(9820),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8416] = {
    [sym_string] = STATE(9821),
    [aux_sym_chained_string_repeat1] = STATE(9821),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_COLON2] = ACTIONS(2761),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [8417] = {
    [sym__string_start] = ACTIONS(837),
    [sym__heredoc_body_start] = ACTIONS(837),
    [sym__binary_minus] = ACTIONS(837),
    [sym__binary_star] = ACTIONS(837),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_do] = ACTIONS(837),
    [anon_sym_EQ_GT] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_COLON_COLON2] = ACTIONS(837),
    [anon_sym_AMP_DOT] = ACTIONS(837),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_COLON2] = ACTIONS(839),
    [anon_sym_DOT_DOT] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(839),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ_GT] = ACTIONS(837),
    [anon_sym_EQ_TILDE] = ACTIONS(837),
    [anon_sym_BANG_TILDE] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [sym_comment] = ACTIONS(87),
  },
  [8418] = {
    [sym__string_end] = ACTIONS(13286),
    [sym_comment] = ACTIONS(87),
  },
  [8419] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(11760),
    [anon_sym_COLON2] = ACTIONS(7554),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [8420] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(11760),
    [anon_sym_COLON2] = ACTIONS(7616),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [8421] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8422] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [8423] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8424] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8425] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8426] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13288),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8427] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COLON2] = ACTIONS(7620),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8428] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8429] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8430] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8431] = {
    [sym_heredoc_body] = STATE(8431),
    [aux_sym_call_repeat1] = STATE(8431),
    [sym__heredoc_body_start] = ACTIONS(12063),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_COLON2] = ACTIONS(7651),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [8432] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3530),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(3530),
    [sym_operator_assignment] = STATE(3530),
    [sym_conditional] = STATE(3530),
    [sym_range] = STATE(3530),
    [sym_binary] = STATE(3530),
    [sym_unary] = STATE(3530),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3536),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(5762),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__identifier_hash_key] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11784),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5786),
    [sym_identifier] = ACTIONS(5786),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8433] = {
    [sym_heredoc_body] = STATE(8431),
    [aux_sym_call_repeat1] = STATE(8431),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_COLON2] = ACTIONS(7663),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [8434] = {
    [aux_sym_argument_list_repeat1] = STATE(8434),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13290),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_COLON2] = ACTIONS(7659),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [8435] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(7668),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8436] = {
    [aux_sym_exceptions_repeat1] = STATE(9825),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_COLON2] = ACTIONS(6062),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [8437] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(7670),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [8438] = {
    [sym_string] = STATE(8438),
    [aux_sym_chained_string_repeat1] = STATE(8438),
    [sym__string_start] = ACTIONS(13293),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_COLON2] = ACTIONS(6081),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [8439] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11790),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(11792),
    [anon_sym_LT] = ACTIONS(11794),
    [anon_sym_QMARK] = ACTIONS(11796),
    [anon_sym_COLON2] = ACTIONS(4110),
    [anon_sym_DOT_DOT] = ACTIONS(11798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11800),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11802),
    [anon_sym_AMP_AMP] = ACTIONS(11802),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(11806),
    [anon_sym_BANG_EQ] = ACTIONS(11802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11802),
    [anon_sym_LT_EQ_GT] = ACTIONS(11802),
    [anon_sym_EQ_TILDE] = ACTIONS(11802),
    [anon_sym_BANG_TILDE] = ACTIONS(11802),
    [anon_sym_LT_EQ] = ACTIONS(11794),
    [anon_sym_GT] = ACTIONS(11794),
    [anon_sym_GT_EQ] = ACTIONS(11808),
    [anon_sym_CARET] = ACTIONS(11810),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [8440] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_COLON2] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8441] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11790),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(11792),
    [anon_sym_LT] = ACTIONS(11794),
    [anon_sym_QMARK] = ACTIONS(11796),
    [anon_sym_COLON2] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(11798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11800),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11802),
    [anon_sym_AMP_AMP] = ACTIONS(11802),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(11806),
    [anon_sym_BANG_EQ] = ACTIONS(11802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11802),
    [anon_sym_LT_EQ_GT] = ACTIONS(11802),
    [anon_sym_EQ_TILDE] = ACTIONS(11802),
    [anon_sym_BANG_TILDE] = ACTIONS(11802),
    [anon_sym_LT_EQ] = ACTIONS(11794),
    [anon_sym_GT] = ACTIONS(11794),
    [anon_sym_GT_EQ] = ACTIONS(11808),
    [anon_sym_CARET] = ACTIONS(11810),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [8442] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9826),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(9826),
    [sym_operator_assignment] = STATE(9826),
    [sym_conditional] = STATE(9826),
    [sym_range] = STATE(9826),
    [sym_binary] = STATE(9826),
    [sym_unary] = STATE(9826),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8443] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9827),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(9827),
    [sym_operator_assignment] = STATE(9827),
    [sym_conditional] = STATE(9827),
    [sym_range] = STATE(9827),
    [sym_binary] = STATE(9827),
    [sym_unary] = STATE(9827),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8444] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9828),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(9828),
    [sym_operator_assignment] = STATE(9828),
    [sym_conditional] = STATE(9828),
    [sym_range] = STATE(9828),
    [sym_binary] = STATE(9828),
    [sym_unary] = STATE(9828),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8445] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9829),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(9829),
    [sym_operator_assignment] = STATE(9829),
    [sym_conditional] = STATE(9829),
    [sym_range] = STATE(9829),
    [sym_binary] = STATE(9829),
    [sym_unary] = STATE(9829),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8446] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9830),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(9830),
    [sym_operator_assignment] = STATE(9830),
    [sym_conditional] = STATE(9830),
    [sym_range] = STATE(9830),
    [sym_binary] = STATE(9830),
    [sym_unary] = STATE(9830),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8447] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9831),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9831),
    [sym_operator_assignment] = STATE(9831),
    [sym_conditional] = STATE(9831),
    [sym_range] = STATE(9831),
    [sym_binary] = STATE(9831),
    [sym_unary] = STATE(9831),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8448] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9832),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(9832),
    [sym_operator_assignment] = STATE(9832),
    [sym_conditional] = STATE(9832),
    [sym_range] = STATE(9832),
    [sym_binary] = STATE(9832),
    [sym_unary] = STATE(9832),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8449] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9833),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(9833),
    [sym_operator_assignment] = STATE(9833),
    [sym_conditional] = STATE(9833),
    [sym_range] = STATE(9833),
    [sym_binary] = STATE(9833),
    [sym_unary] = STATE(9833),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8450] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9834),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(9834),
    [sym_operator_assignment] = STATE(9834),
    [sym_conditional] = STATE(9834),
    [sym_range] = STATE(9834),
    [sym_binary] = STATE(9834),
    [sym_unary] = STATE(9834),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8451] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9835),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(9835),
    [sym_operator_assignment] = STATE(9835),
    [sym_conditional] = STATE(9835),
    [sym_range] = STATE(9835),
    [sym_binary] = STATE(9835),
    [sym_unary] = STATE(9835),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8452] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6192),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_splat_argument] = STATE(6835),
    [sym_assignment] = STATE(6192),
    [sym_operator_assignment] = STATE(6192),
    [sym_conditional] = STATE(6192),
    [sym_range] = STATE(6192),
    [sym_binary] = STATE(6192),
    [sym_unary] = STATE(6192),
    [sym__arg_or_splat_arg] = STATE(6835),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(9401),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8453] = {
    [aux_sym_exceptions_repeat1] = STATE(9836),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(11812),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_COLON2] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8454] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(6192),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_splat_argument] = STATE(9837),
    [sym_assignment] = STATE(6192),
    [sym_operator_assignment] = STATE(6192),
    [sym_conditional] = STATE(6192),
    [sym_range] = STATE(6192),
    [sym_binary] = STATE(6192),
    [sym_unary] = STATE(6192),
    [sym_right_assignment_list] = STATE(2017),
    [sym__arg_or_splat_arg] = STATE(9837),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(9401),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8455] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9838),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(9838),
    [sym_operator_assignment] = STATE(9838),
    [sym_conditional] = STATE(9838),
    [sym_range] = STATE(9838),
    [sym_binary] = STATE(9838),
    [sym_unary] = STATE(9838),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8456] = {
    [sym_string] = STATE(9839),
    [aux_sym_chained_string_repeat1] = STATE(9839),
    [sym__string_start] = ACTIONS(2503),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_COLON2] = ACTIONS(2761),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [8457] = {
    [sym__line_break] = ACTIONS(10568),
    [sym__simple_symbol] = ACTIONS(10568),
    [sym__string_start] = ACTIONS(10568),
    [sym__symbol_start] = ACTIONS(10568),
    [sym__subshell_start] = ACTIONS(10568),
    [sym__regex_start] = ACTIONS(10568),
    [sym__string_array_start] = ACTIONS(10568),
    [sym__symbol_array_start] = ACTIONS(10568),
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym_heredoc_beginning] = ACTIONS(10568),
    [sym__block_ampersand] = ACTIONS(10568),
    [sym__splat_star] = ACTIONS(10568),
    [sym__unary_minus] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [sym__identifier_hash_key] = ACTIONS(10568),
    [ts_builtin_sym_end] = ACTIONS(10568),
    [anon_sym___END__] = ACTIONS(10570),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_def] = ACTIONS(10570),
    [anon_sym_LPAREN] = ACTIONS(10570),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COLON_COLON] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10570),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_class] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_module] = ACTIONS(10570),
    [anon_sym_end] = ACTIONS(10570),
    [anon_sym_return] = ACTIONS(10570),
    [anon_sym_yield] = ACTIONS(10570),
    [anon_sym_break] = ACTIONS(10570),
    [anon_sym_next] = ACTIONS(10570),
    [sym_redo] = ACTIONS(10570),
    [sym_retry] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10570),
    [anon_sym_unless] = ACTIONS(10570),
    [anon_sym_while] = ACTIONS(10570),
    [anon_sym_until] = ACTIONS(10570),
    [anon_sym_rescue] = ACTIONS(10570),
    [anon_sym_for] = ACTIONS(10570),
    [anon_sym_do] = ACTIONS(10570),
    [anon_sym_case] = ACTIONS(10570),
    [anon_sym_when] = ACTIONS(10570),
    [anon_sym_elsif] = ACTIONS(10570),
    [anon_sym_else] = ACTIONS(10570),
    [anon_sym_then] = ACTIONS(10570),
    [anon_sym_begin] = ACTIONS(10570),
    [anon_sym_ensure] = ACTIONS(10570),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_LPAREN2] = ACTIONS(10568),
    [anon_sym_PLUS_EQ] = ACTIONS(10568),
    [anon_sym_DASH_EQ] = ACTIONS(10568),
    [anon_sym_STAR_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10568),
    [anon_sym_SLASH_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10568),
    [anon_sym_AMP_EQ] = ACTIONS(10568),
    [anon_sym_PERCENT_EQ] = ACTIONS(10568),
    [anon_sym_GT_GT_EQ] = ACTIONS(10568),
    [anon_sym_LT_LT_EQ] = ACTIONS(10568),
    [anon_sym_CARET_EQ] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10570),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10570),
    [anon_sym_or] = ACTIONS(10570),
    [anon_sym_PIPE_PIPE] = ACTIONS(10570),
    [anon_sym_AMP_AMP] = ACTIONS(10570),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10570),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_SLASH] = ACTIONS(10570),
    [anon_sym_PERCENT] = ACTIONS(10570),
    [anon_sym_defined_QMARK] = ACTIONS(10568),
    [anon_sym_not] = ACTIONS(10570),
    [anon_sym_BANG] = ACTIONS(10570),
    [anon_sym_TILDE] = ACTIONS(10568),
    [sym_constant] = ACTIONS(10570),
    [sym_identifier] = ACTIONS(10570),
    [sym_instance_variable] = ACTIONS(10568),
    [sym_class_variable] = ACTIONS(10568),
    [sym_global_variable] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10570),
    [sym_float] = ACTIONS(10570),
    [sym_complex] = ACTIONS(10568),
    [sym_super] = ACTIONS(10570),
    [anon_sym_true] = ACTIONS(10570),
    [anon_sym_TRUE] = ACTIONS(10570),
    [anon_sym_false] = ACTIONS(10570),
    [anon_sym_FALSE] = ACTIONS(10570),
    [sym_self] = ACTIONS(10570),
    [anon_sym_nil] = ACTIONS(10570),
    [anon_sym_NIL] = ACTIONS(10570),
    [sym_character] = ACTIONS(10568),
    [anon_sym_LBRACK2] = ACTIONS(10570),
    [anon_sym_DASH_GT] = ACTIONS(10568),
  },
  [8458] = {
    [sym__line_break] = ACTIONS(9793),
    [sym__heredoc_body_start] = ACTIONS(9793),
    [sym__binary_minus] = ACTIONS(9793),
    [sym__binary_star] = ACTIONS(9793),
    [ts_builtin_sym_end] = ACTIONS(9793),
    [anon_sym___END__] = ACTIONS(9793),
    [anon_sym_LBRACE] = ACTIONS(9793),
    [anon_sym_RBRACE] = ACTIONS(9793),
    [anon_sym_RPAREN] = ACTIONS(9793),
    [anon_sym_DOT] = ACTIONS(9795),
    [anon_sym_COMMA] = ACTIONS(9793),
    [anon_sym_PIPE] = ACTIONS(9795),
    [anon_sym_SEMI] = ACTIONS(9793),
    [anon_sym_STAR_STAR] = ACTIONS(9795),
    [anon_sym_AMP] = ACTIONS(9795),
    [anon_sym_EQ] = ACTIONS(9795),
    [anon_sym_LT] = ACTIONS(9795),
    [anon_sym_end] = ACTIONS(9793),
    [anon_sym_if] = ACTIONS(9793),
    [anon_sym_unless] = ACTIONS(9793),
    [anon_sym_while] = ACTIONS(9793),
    [anon_sym_until] = ACTIONS(9793),
    [anon_sym_rescue] = ACTIONS(9793),
    [anon_sym_do] = ACTIONS(9793),
    [anon_sym_when] = ACTIONS(9793),
    [anon_sym_elsif] = ACTIONS(9793),
    [anon_sym_else] = ACTIONS(9793),
    [anon_sym_then] = ACTIONS(9793),
    [anon_sym_ensure] = ACTIONS(9793),
    [anon_sym_EQ_GT] = ACTIONS(9793),
    [anon_sym_LBRACK] = ACTIONS(9793),
    [anon_sym_COLON_COLON2] = ACTIONS(9793),
    [anon_sym_AMP_DOT] = ACTIONS(9793),
    [anon_sym_PLUS_EQ] = ACTIONS(9793),
    [anon_sym_DASH_EQ] = ACTIONS(9793),
    [anon_sym_STAR_EQ] = ACTIONS(9793),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9793),
    [anon_sym_SLASH_EQ] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9793),
    [anon_sym_PIPE_EQ] = ACTIONS(9793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9793),
    [anon_sym_AMP_EQ] = ACTIONS(9793),
    [anon_sym_PERCENT_EQ] = ACTIONS(9793),
    [anon_sym_GT_GT_EQ] = ACTIONS(9793),
    [anon_sym_LT_LT_EQ] = ACTIONS(9793),
    [anon_sym_CARET_EQ] = ACTIONS(9793),
    [anon_sym_QMARK] = ACTIONS(9793),
    [anon_sym_DOT_DOT] = ACTIONS(9795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9793),
    [anon_sym_and] = ACTIONS(9793),
    [anon_sym_or] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE] = ACTIONS(9795),
    [anon_sym_AMP_AMP] = ACTIONS(9795),
    [anon_sym_LT_LT] = ACTIONS(9795),
    [anon_sym_GT_GT] = ACTIONS(9795),
    [anon_sym_EQ_EQ] = ACTIONS(9795),
    [anon_sym_BANG_EQ] = ACTIONS(9793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9793),
    [anon_sym_LT_EQ_GT] = ACTIONS(9793),
    [anon_sym_EQ_TILDE] = ACTIONS(9793),
    [anon_sym_BANG_TILDE] = ACTIONS(9793),
    [anon_sym_LT_EQ] = ACTIONS(9795),
    [anon_sym_GT] = ACTIONS(9795),
    [anon_sym_GT_EQ] = ACTIONS(9793),
    [anon_sym_CARET] = ACTIONS(9795),
    [anon_sym_PLUS] = ACTIONS(9795),
    [anon_sym_SLASH] = ACTIONS(9795),
    [anon_sym_PERCENT] = ACTIONS(9795),
    [sym_comment] = ACTIONS(87),
  },
  [8459] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13296),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8460] = {
    [sym__line_break] = ACTIONS(9799),
    [sym__heredoc_body_start] = ACTIONS(9799),
    [sym__binary_minus] = ACTIONS(9799),
    [sym__binary_star] = ACTIONS(9799),
    [ts_builtin_sym_end] = ACTIONS(9799),
    [anon_sym___END__] = ACTIONS(9799),
    [anon_sym_LBRACE] = ACTIONS(9799),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [anon_sym_RPAREN] = ACTIONS(9799),
    [anon_sym_DOT] = ACTIONS(9801),
    [anon_sym_COMMA] = ACTIONS(9799),
    [anon_sym_PIPE] = ACTIONS(9801),
    [anon_sym_SEMI] = ACTIONS(9799),
    [anon_sym_STAR_STAR] = ACTIONS(9801),
    [anon_sym_AMP] = ACTIONS(9801),
    [anon_sym_EQ] = ACTIONS(9801),
    [anon_sym_LT] = ACTIONS(9801),
    [anon_sym_end] = ACTIONS(9799),
    [anon_sym_if] = ACTIONS(9799),
    [anon_sym_unless] = ACTIONS(9799),
    [anon_sym_while] = ACTIONS(9799),
    [anon_sym_until] = ACTIONS(9799),
    [anon_sym_rescue] = ACTIONS(9799),
    [anon_sym_do] = ACTIONS(9799),
    [anon_sym_when] = ACTIONS(9799),
    [anon_sym_elsif] = ACTIONS(9799),
    [anon_sym_else] = ACTIONS(9799),
    [anon_sym_then] = ACTIONS(9799),
    [anon_sym_ensure] = ACTIONS(9799),
    [anon_sym_EQ_GT] = ACTIONS(9799),
    [anon_sym_LBRACK] = ACTIONS(9799),
    [anon_sym_COLON_COLON2] = ACTIONS(9799),
    [anon_sym_AMP_DOT] = ACTIONS(9799),
    [anon_sym_PLUS_EQ] = ACTIONS(9799),
    [anon_sym_DASH_EQ] = ACTIONS(9799),
    [anon_sym_STAR_EQ] = ACTIONS(9799),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9799),
    [anon_sym_SLASH_EQ] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9799),
    [anon_sym_PIPE_EQ] = ACTIONS(9799),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9799),
    [anon_sym_AMP_EQ] = ACTIONS(9799),
    [anon_sym_PERCENT_EQ] = ACTIONS(9799),
    [anon_sym_GT_GT_EQ] = ACTIONS(9799),
    [anon_sym_LT_LT_EQ] = ACTIONS(9799),
    [anon_sym_CARET_EQ] = ACTIONS(9799),
    [anon_sym_QMARK] = ACTIONS(9799),
    [anon_sym_DOT_DOT] = ACTIONS(9801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9799),
    [anon_sym_and] = ACTIONS(9799),
    [anon_sym_or] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE] = ACTIONS(9801),
    [anon_sym_AMP_AMP] = ACTIONS(9801),
    [anon_sym_LT_LT] = ACTIONS(9801),
    [anon_sym_GT_GT] = ACTIONS(9801),
    [anon_sym_EQ_EQ] = ACTIONS(9801),
    [anon_sym_BANG_EQ] = ACTIONS(9799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9799),
    [anon_sym_LT_EQ_GT] = ACTIONS(9799),
    [anon_sym_EQ_TILDE] = ACTIONS(9799),
    [anon_sym_BANG_TILDE] = ACTIONS(9799),
    [anon_sym_LT_EQ] = ACTIONS(9801),
    [anon_sym_GT] = ACTIONS(9801),
    [anon_sym_GT_EQ] = ACTIONS(9799),
    [anon_sym_CARET] = ACTIONS(9801),
    [anon_sym_PLUS] = ACTIONS(9801),
    [anon_sym_SLASH] = ACTIONS(9801),
    [anon_sym_PERCENT] = ACTIONS(9801),
    [sym_comment] = ACTIONS(87),
  },
  [8461] = {
    [sym__line_break] = ACTIONS(9803),
    [sym__heredoc_body_start] = ACTIONS(9803),
    [sym__binary_minus] = ACTIONS(9803),
    [sym__binary_star] = ACTIONS(9803),
    [ts_builtin_sym_end] = ACTIONS(9803),
    [anon_sym___END__] = ACTIONS(9803),
    [anon_sym_LBRACE] = ACTIONS(9803),
    [anon_sym_RBRACE] = ACTIONS(9803),
    [anon_sym_RPAREN] = ACTIONS(9803),
    [anon_sym_DOT] = ACTIONS(9805),
    [anon_sym_COMMA] = ACTIONS(9803),
    [anon_sym_PIPE] = ACTIONS(9805),
    [anon_sym_SEMI] = ACTIONS(9803),
    [anon_sym_STAR_STAR] = ACTIONS(9805),
    [anon_sym_AMP] = ACTIONS(9805),
    [anon_sym_EQ] = ACTIONS(9805),
    [anon_sym_LT] = ACTIONS(9805),
    [anon_sym_end] = ACTIONS(9803),
    [anon_sym_if] = ACTIONS(9803),
    [anon_sym_unless] = ACTIONS(9803),
    [anon_sym_while] = ACTIONS(9803),
    [anon_sym_until] = ACTIONS(9803),
    [anon_sym_rescue] = ACTIONS(9803),
    [anon_sym_do] = ACTIONS(9803),
    [anon_sym_when] = ACTIONS(9803),
    [anon_sym_elsif] = ACTIONS(9803),
    [anon_sym_else] = ACTIONS(9803),
    [anon_sym_then] = ACTIONS(9803),
    [anon_sym_ensure] = ACTIONS(9803),
    [anon_sym_EQ_GT] = ACTIONS(9803),
    [anon_sym_LBRACK] = ACTIONS(9803),
    [anon_sym_COLON_COLON2] = ACTIONS(9803),
    [anon_sym_AMP_DOT] = ACTIONS(9803),
    [anon_sym_PLUS_EQ] = ACTIONS(9803),
    [anon_sym_DASH_EQ] = ACTIONS(9803),
    [anon_sym_STAR_EQ] = ACTIONS(9803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9803),
    [anon_sym_SLASH_EQ] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9803),
    [anon_sym_PIPE_EQ] = ACTIONS(9803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9803),
    [anon_sym_AMP_EQ] = ACTIONS(9803),
    [anon_sym_PERCENT_EQ] = ACTIONS(9803),
    [anon_sym_GT_GT_EQ] = ACTIONS(9803),
    [anon_sym_LT_LT_EQ] = ACTIONS(9803),
    [anon_sym_CARET_EQ] = ACTIONS(9803),
    [anon_sym_QMARK] = ACTIONS(9803),
    [anon_sym_DOT_DOT] = ACTIONS(9805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9803),
    [anon_sym_and] = ACTIONS(9803),
    [anon_sym_or] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE] = ACTIONS(9805),
    [anon_sym_AMP_AMP] = ACTIONS(9805),
    [anon_sym_LT_LT] = ACTIONS(9805),
    [anon_sym_GT_GT] = ACTIONS(9805),
    [anon_sym_EQ_EQ] = ACTIONS(9805),
    [anon_sym_BANG_EQ] = ACTIONS(9803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9803),
    [anon_sym_LT_EQ_GT] = ACTIONS(9803),
    [anon_sym_EQ_TILDE] = ACTIONS(9803),
    [anon_sym_BANG_TILDE] = ACTIONS(9803),
    [anon_sym_LT_EQ] = ACTIONS(9805),
    [anon_sym_GT] = ACTIONS(9805),
    [anon_sym_GT_EQ] = ACTIONS(9803),
    [anon_sym_CARET] = ACTIONS(9805),
    [anon_sym_PLUS] = ACTIONS(9805),
    [anon_sym_SLASH] = ACTIONS(9805),
    [anon_sym_PERCENT] = ACTIONS(9805),
    [sym_comment] = ACTIONS(87),
  },
  [8462] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13298),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8463] = {
    [sym__line_break] = ACTIONS(9809),
    [sym__heredoc_body_start] = ACTIONS(9809),
    [sym__binary_minus] = ACTIONS(9809),
    [sym__binary_star] = ACTIONS(9809),
    [ts_builtin_sym_end] = ACTIONS(9809),
    [anon_sym___END__] = ACTIONS(9809),
    [anon_sym_LBRACE] = ACTIONS(9809),
    [anon_sym_RBRACE] = ACTIONS(9809),
    [anon_sym_RPAREN] = ACTIONS(9809),
    [anon_sym_DOT] = ACTIONS(9811),
    [anon_sym_COMMA] = ACTIONS(9809),
    [anon_sym_PIPE] = ACTIONS(9811),
    [anon_sym_SEMI] = ACTIONS(9809),
    [anon_sym_STAR_STAR] = ACTIONS(9811),
    [anon_sym_AMP] = ACTIONS(9811),
    [anon_sym_EQ] = ACTIONS(9811),
    [anon_sym_LT] = ACTIONS(9811),
    [anon_sym_end] = ACTIONS(9809),
    [anon_sym_if] = ACTIONS(9809),
    [anon_sym_unless] = ACTIONS(9809),
    [anon_sym_while] = ACTIONS(9809),
    [anon_sym_until] = ACTIONS(9809),
    [anon_sym_rescue] = ACTIONS(9809),
    [anon_sym_do] = ACTIONS(9809),
    [anon_sym_when] = ACTIONS(9809),
    [anon_sym_elsif] = ACTIONS(9809),
    [anon_sym_else] = ACTIONS(9809),
    [anon_sym_then] = ACTIONS(9809),
    [anon_sym_ensure] = ACTIONS(9809),
    [anon_sym_EQ_GT] = ACTIONS(9809),
    [anon_sym_LBRACK] = ACTIONS(9809),
    [anon_sym_COLON_COLON2] = ACTIONS(9809),
    [anon_sym_AMP_DOT] = ACTIONS(9809),
    [anon_sym_PLUS_EQ] = ACTIONS(9809),
    [anon_sym_DASH_EQ] = ACTIONS(9809),
    [anon_sym_STAR_EQ] = ACTIONS(9809),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9809),
    [anon_sym_SLASH_EQ] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9809),
    [anon_sym_PIPE_EQ] = ACTIONS(9809),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9809),
    [anon_sym_AMP_EQ] = ACTIONS(9809),
    [anon_sym_PERCENT_EQ] = ACTIONS(9809),
    [anon_sym_GT_GT_EQ] = ACTIONS(9809),
    [anon_sym_LT_LT_EQ] = ACTIONS(9809),
    [anon_sym_CARET_EQ] = ACTIONS(9809),
    [anon_sym_QMARK] = ACTIONS(9809),
    [anon_sym_DOT_DOT] = ACTIONS(9811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9809),
    [anon_sym_and] = ACTIONS(9809),
    [anon_sym_or] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE] = ACTIONS(9811),
    [anon_sym_AMP_AMP] = ACTIONS(9811),
    [anon_sym_LT_LT] = ACTIONS(9811),
    [anon_sym_GT_GT] = ACTIONS(9811),
    [anon_sym_EQ_EQ] = ACTIONS(9811),
    [anon_sym_BANG_EQ] = ACTIONS(9809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9809),
    [anon_sym_LT_EQ_GT] = ACTIONS(9809),
    [anon_sym_EQ_TILDE] = ACTIONS(9809),
    [anon_sym_BANG_TILDE] = ACTIONS(9809),
    [anon_sym_LT_EQ] = ACTIONS(9811),
    [anon_sym_GT] = ACTIONS(9811),
    [anon_sym_GT_EQ] = ACTIONS(9809),
    [anon_sym_CARET] = ACTIONS(9811),
    [anon_sym_PLUS] = ACTIONS(9811),
    [anon_sym_SLASH] = ACTIONS(9811),
    [anon_sym_PERCENT] = ACTIONS(9811),
    [sym_comment] = ACTIONS(87),
  },
  [8464] = {
    [sym__line_break] = ACTIONS(6333),
    [sym__heredoc_body_start] = ACTIONS(6333),
    [sym__binary_minus] = ACTIONS(6333),
    [sym__binary_star] = ACTIONS(6333),
    [ts_builtin_sym_end] = ACTIONS(6333),
    [anon_sym___END__] = ACTIONS(6333),
    [anon_sym_LBRACE] = ACTIONS(6333),
    [anon_sym_RBRACE] = ACTIONS(6333),
    [anon_sym_RPAREN] = ACTIONS(6333),
    [anon_sym_DOT] = ACTIONS(6335),
    [anon_sym_COMMA] = ACTIONS(6333),
    [anon_sym_PIPE] = ACTIONS(6335),
    [anon_sym_SEMI] = ACTIONS(6333),
    [anon_sym_STAR_STAR] = ACTIONS(6335),
    [anon_sym_AMP] = ACTIONS(6335),
    [anon_sym_EQ] = ACTIONS(6335),
    [anon_sym_LT] = ACTIONS(6335),
    [anon_sym_end] = ACTIONS(6333),
    [anon_sym_if] = ACTIONS(6333),
    [anon_sym_unless] = ACTIONS(6333),
    [anon_sym_while] = ACTIONS(6333),
    [anon_sym_until] = ACTIONS(6333),
    [anon_sym_rescue] = ACTIONS(6333),
    [anon_sym_do] = ACTIONS(6333),
    [anon_sym_when] = ACTIONS(6333),
    [anon_sym_elsif] = ACTIONS(6333),
    [anon_sym_else] = ACTIONS(6333),
    [anon_sym_then] = ACTIONS(6333),
    [anon_sym_ensure] = ACTIONS(6333),
    [anon_sym_LBRACK] = ACTIONS(6333),
    [anon_sym_COLON_COLON2] = ACTIONS(6333),
    [anon_sym_AMP_DOT] = ACTIONS(6333),
    [anon_sym_PLUS_EQ] = ACTIONS(6333),
    [anon_sym_DASH_EQ] = ACTIONS(6333),
    [anon_sym_STAR_EQ] = ACTIONS(6333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6333),
    [anon_sym_SLASH_EQ] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6333),
    [anon_sym_PIPE_EQ] = ACTIONS(6333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6333),
    [anon_sym_AMP_EQ] = ACTIONS(6333),
    [anon_sym_PERCENT_EQ] = ACTIONS(6333),
    [anon_sym_GT_GT_EQ] = ACTIONS(6333),
    [anon_sym_LT_LT_EQ] = ACTIONS(6333),
    [anon_sym_CARET_EQ] = ACTIONS(6333),
    [anon_sym_QMARK] = ACTIONS(6333),
    [anon_sym_DOT_DOT] = ACTIONS(6335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6333),
    [anon_sym_and] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE] = ACTIONS(6335),
    [anon_sym_AMP_AMP] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6335),
    [anon_sym_GT_GT] = ACTIONS(6335),
    [anon_sym_EQ_EQ] = ACTIONS(6335),
    [anon_sym_BANG_EQ] = ACTIONS(6333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6333),
    [anon_sym_LT_EQ_GT] = ACTIONS(6333),
    [anon_sym_EQ_TILDE] = ACTIONS(6333),
    [anon_sym_BANG_TILDE] = ACTIONS(6333),
    [anon_sym_LT_EQ] = ACTIONS(6335),
    [anon_sym_GT] = ACTIONS(6335),
    [anon_sym_GT_EQ] = ACTIONS(6333),
    [anon_sym_CARET] = ACTIONS(6335),
    [anon_sym_PLUS] = ACTIONS(6335),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_PERCENT] = ACTIONS(6335),
    [sym_comment] = ACTIONS(87),
  },
  [8465] = {
    [sym__line_break] = ACTIONS(6337),
    [sym__heredoc_body_start] = ACTIONS(6337),
    [sym__binary_minus] = ACTIONS(6337),
    [sym__binary_star] = ACTIONS(6337),
    [ts_builtin_sym_end] = ACTIONS(6337),
    [anon_sym___END__] = ACTIONS(6337),
    [anon_sym_LBRACE] = ACTIONS(6337),
    [anon_sym_RBRACE] = ACTIONS(6337),
    [anon_sym_RPAREN] = ACTIONS(6337),
    [anon_sym_DOT] = ACTIONS(6339),
    [anon_sym_COMMA] = ACTIONS(6337),
    [anon_sym_PIPE] = ACTIONS(6339),
    [anon_sym_SEMI] = ACTIONS(6337),
    [anon_sym_STAR_STAR] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6339),
    [anon_sym_EQ] = ACTIONS(6339),
    [anon_sym_LT] = ACTIONS(6339),
    [anon_sym_end] = ACTIONS(6337),
    [anon_sym_if] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6337),
    [anon_sym_while] = ACTIONS(6337),
    [anon_sym_until] = ACTIONS(6337),
    [anon_sym_rescue] = ACTIONS(6337),
    [anon_sym_do] = ACTIONS(6337),
    [anon_sym_when] = ACTIONS(6337),
    [anon_sym_elsif] = ACTIONS(6337),
    [anon_sym_else] = ACTIONS(6337),
    [anon_sym_then] = ACTIONS(6337),
    [anon_sym_ensure] = ACTIONS(6337),
    [anon_sym_LBRACK] = ACTIONS(6337),
    [anon_sym_COLON_COLON2] = ACTIONS(6337),
    [anon_sym_AMP_DOT] = ACTIONS(6337),
    [anon_sym_PLUS_EQ] = ACTIONS(6337),
    [anon_sym_DASH_EQ] = ACTIONS(6337),
    [anon_sym_STAR_EQ] = ACTIONS(6337),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6337),
    [anon_sym_SLASH_EQ] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6337),
    [anon_sym_PIPE_EQ] = ACTIONS(6337),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6337),
    [anon_sym_AMP_EQ] = ACTIONS(6337),
    [anon_sym_PERCENT_EQ] = ACTIONS(6337),
    [anon_sym_GT_GT_EQ] = ACTIONS(6337),
    [anon_sym_LT_LT_EQ] = ACTIONS(6337),
    [anon_sym_CARET_EQ] = ACTIONS(6337),
    [anon_sym_QMARK] = ACTIONS(6337),
    [anon_sym_DOT_DOT] = ACTIONS(6339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6337),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6339),
    [anon_sym_AMP_AMP] = ACTIONS(6339),
    [anon_sym_LT_LT] = ACTIONS(6339),
    [anon_sym_GT_GT] = ACTIONS(6339),
    [anon_sym_EQ_EQ] = ACTIONS(6339),
    [anon_sym_BANG_EQ] = ACTIONS(6337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6337),
    [anon_sym_LT_EQ_GT] = ACTIONS(6337),
    [anon_sym_EQ_TILDE] = ACTIONS(6337),
    [anon_sym_BANG_TILDE] = ACTIONS(6337),
    [anon_sym_LT_EQ] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6339),
    [anon_sym_GT_EQ] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6339),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_SLASH] = ACTIONS(6339),
    [anon_sym_PERCENT] = ACTIONS(6339),
    [sym_comment] = ACTIONS(87),
  },
  [8466] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13300),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8467] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(13300),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13302),
  },
  [8468] = {
    [sym__line_break] = ACTIONS(6345),
    [sym__heredoc_body_start] = ACTIONS(6345),
    [sym__binary_minus] = ACTIONS(6345),
    [sym__binary_star] = ACTIONS(6345),
    [ts_builtin_sym_end] = ACTIONS(6345),
    [anon_sym___END__] = ACTIONS(6345),
    [anon_sym_LBRACE] = ACTIONS(6345),
    [anon_sym_RBRACE] = ACTIONS(6345),
    [anon_sym_RPAREN] = ACTIONS(6345),
    [anon_sym_DOT] = ACTIONS(6347),
    [anon_sym_COMMA] = ACTIONS(6345),
    [anon_sym_PIPE] = ACTIONS(6347),
    [anon_sym_SEMI] = ACTIONS(6345),
    [anon_sym_STAR_STAR] = ACTIONS(6347),
    [anon_sym_AMP] = ACTIONS(6347),
    [anon_sym_EQ] = ACTIONS(6347),
    [anon_sym_LT] = ACTIONS(6347),
    [anon_sym_end] = ACTIONS(6345),
    [anon_sym_if] = ACTIONS(6345),
    [anon_sym_unless] = ACTIONS(6345),
    [anon_sym_while] = ACTIONS(6345),
    [anon_sym_until] = ACTIONS(6345),
    [anon_sym_rescue] = ACTIONS(6345),
    [anon_sym_do] = ACTIONS(6345),
    [anon_sym_when] = ACTIONS(6345),
    [anon_sym_elsif] = ACTIONS(6345),
    [anon_sym_else] = ACTIONS(6345),
    [anon_sym_then] = ACTIONS(6345),
    [anon_sym_ensure] = ACTIONS(6345),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_COLON_COLON2] = ACTIONS(6345),
    [anon_sym_AMP_DOT] = ACTIONS(6345),
    [anon_sym_PLUS_EQ] = ACTIONS(6345),
    [anon_sym_DASH_EQ] = ACTIONS(6345),
    [anon_sym_STAR_EQ] = ACTIONS(6345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6345),
    [anon_sym_SLASH_EQ] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6345),
    [anon_sym_PIPE_EQ] = ACTIONS(6345),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6345),
    [anon_sym_AMP_EQ] = ACTIONS(6345),
    [anon_sym_PERCENT_EQ] = ACTIONS(6345),
    [anon_sym_GT_GT_EQ] = ACTIONS(6345),
    [anon_sym_LT_LT_EQ] = ACTIONS(6345),
    [anon_sym_CARET_EQ] = ACTIONS(6345),
    [anon_sym_QMARK] = ACTIONS(6345),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6345),
    [anon_sym_and] = ACTIONS(6345),
    [anon_sym_or] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6347),
    [anon_sym_LT_LT] = ACTIONS(6347),
    [anon_sym_GT_GT] = ACTIONS(6347),
    [anon_sym_EQ_EQ] = ACTIONS(6347),
    [anon_sym_BANG_EQ] = ACTIONS(6345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6345),
    [anon_sym_LT_EQ_GT] = ACTIONS(6345),
    [anon_sym_EQ_TILDE] = ACTIONS(6345),
    [anon_sym_BANG_TILDE] = ACTIONS(6345),
    [anon_sym_LT_EQ] = ACTIONS(6347),
    [anon_sym_GT] = ACTIONS(6347),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_CARET] = ACTIONS(6347),
    [anon_sym_PLUS] = ACTIONS(6347),
    [anon_sym_SLASH] = ACTIONS(6347),
    [anon_sym_PERCENT] = ACTIONS(6347),
    [sym_comment] = ACTIONS(87),
  },
  [8469] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13304),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8470] = {
    [sym__line_break] = ACTIONS(6358),
    [sym__heredoc_body_start] = ACTIONS(6358),
    [sym__binary_minus] = ACTIONS(6358),
    [sym__binary_star] = ACTIONS(6358),
    [ts_builtin_sym_end] = ACTIONS(6358),
    [anon_sym___END__] = ACTIONS(6358),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RBRACE] = ACTIONS(6358),
    [anon_sym_RPAREN] = ACTIONS(6358),
    [anon_sym_DOT] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6360),
    [anon_sym_SEMI] = ACTIONS(6358),
    [anon_sym_STAR_STAR] = ACTIONS(6360),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6360),
    [anon_sym_end] = ACTIONS(6358),
    [anon_sym_if] = ACTIONS(6358),
    [anon_sym_unless] = ACTIONS(6358),
    [anon_sym_while] = ACTIONS(6358),
    [anon_sym_until] = ACTIONS(6358),
    [anon_sym_rescue] = ACTIONS(6358),
    [anon_sym_do] = ACTIONS(6358),
    [anon_sym_when] = ACTIONS(6358),
    [anon_sym_elsif] = ACTIONS(6358),
    [anon_sym_else] = ACTIONS(6358),
    [anon_sym_then] = ACTIONS(6358),
    [anon_sym_ensure] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6358),
    [anon_sym_COLON_COLON2] = ACTIONS(6358),
    [anon_sym_AMP_DOT] = ACTIONS(6358),
    [anon_sym_PLUS_EQ] = ACTIONS(6358),
    [anon_sym_DASH_EQ] = ACTIONS(6358),
    [anon_sym_STAR_EQ] = ACTIONS(6358),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6358),
    [anon_sym_SLASH_EQ] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6358),
    [anon_sym_PIPE_EQ] = ACTIONS(6358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6358),
    [anon_sym_AMP_EQ] = ACTIONS(6358),
    [anon_sym_PERCENT_EQ] = ACTIONS(6358),
    [anon_sym_GT_GT_EQ] = ACTIONS(6358),
    [anon_sym_LT_LT_EQ] = ACTIONS(6358),
    [anon_sym_CARET_EQ] = ACTIONS(6358),
    [anon_sym_QMARK] = ACTIONS(6358),
    [anon_sym_DOT_DOT] = ACTIONS(6360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6358),
    [anon_sym_and] = ACTIONS(6358),
    [anon_sym_or] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE] = ACTIONS(6360),
    [anon_sym_AMP_AMP] = ACTIONS(6360),
    [anon_sym_LT_LT] = ACTIONS(6360),
    [anon_sym_GT_GT] = ACTIONS(6360),
    [anon_sym_EQ_EQ] = ACTIONS(6360),
    [anon_sym_BANG_EQ] = ACTIONS(6358),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6358),
    [anon_sym_LT_EQ_GT] = ACTIONS(6358),
    [anon_sym_EQ_TILDE] = ACTIONS(6358),
    [anon_sym_BANG_TILDE] = ACTIONS(6358),
    [anon_sym_LT_EQ] = ACTIONS(6360),
    [anon_sym_GT] = ACTIONS(6360),
    [anon_sym_GT_EQ] = ACTIONS(6358),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_PERCENT] = ACTIONS(6360),
    [sym_comment] = ACTIONS(87),
  },
  [8471] = {
    [sym__line_break] = ACTIONS(6362),
    [sym__heredoc_body_start] = ACTIONS(6362),
    [sym__binary_minus] = ACTIONS(6362),
    [sym__binary_star] = ACTIONS(6362),
    [ts_builtin_sym_end] = ACTIONS(6362),
    [anon_sym___END__] = ACTIONS(6362),
    [anon_sym_LBRACE] = ACTIONS(6362),
    [anon_sym_RBRACE] = ACTIONS(6362),
    [anon_sym_RPAREN] = ACTIONS(6362),
    [anon_sym_DOT] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6364),
    [anon_sym_SEMI] = ACTIONS(6362),
    [anon_sym_STAR_STAR] = ACTIONS(6364),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6364),
    [anon_sym_end] = ACTIONS(6362),
    [anon_sym_if] = ACTIONS(6362),
    [anon_sym_unless] = ACTIONS(6362),
    [anon_sym_while] = ACTIONS(6362),
    [anon_sym_until] = ACTIONS(6362),
    [anon_sym_rescue] = ACTIONS(6362),
    [anon_sym_do] = ACTIONS(6362),
    [anon_sym_when] = ACTIONS(6362),
    [anon_sym_elsif] = ACTIONS(6362),
    [anon_sym_else] = ACTIONS(6362),
    [anon_sym_then] = ACTIONS(6362),
    [anon_sym_ensure] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6362),
    [anon_sym_COLON_COLON2] = ACTIONS(6362),
    [anon_sym_AMP_DOT] = ACTIONS(6362),
    [anon_sym_PLUS_EQ] = ACTIONS(6362),
    [anon_sym_DASH_EQ] = ACTIONS(6362),
    [anon_sym_STAR_EQ] = ACTIONS(6362),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6362),
    [anon_sym_SLASH_EQ] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6362),
    [anon_sym_PIPE_EQ] = ACTIONS(6362),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6362),
    [anon_sym_AMP_EQ] = ACTIONS(6362),
    [anon_sym_PERCENT_EQ] = ACTIONS(6362),
    [anon_sym_GT_GT_EQ] = ACTIONS(6362),
    [anon_sym_LT_LT_EQ] = ACTIONS(6362),
    [anon_sym_CARET_EQ] = ACTIONS(6362),
    [anon_sym_QMARK] = ACTIONS(6362),
    [anon_sym_DOT_DOT] = ACTIONS(6364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6362),
    [anon_sym_and] = ACTIONS(6362),
    [anon_sym_or] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE] = ACTIONS(6364),
    [anon_sym_AMP_AMP] = ACTIONS(6364),
    [anon_sym_LT_LT] = ACTIONS(6364),
    [anon_sym_GT_GT] = ACTIONS(6364),
    [anon_sym_EQ_EQ] = ACTIONS(6364),
    [anon_sym_BANG_EQ] = ACTIONS(6362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6362),
    [anon_sym_LT_EQ_GT] = ACTIONS(6362),
    [anon_sym_EQ_TILDE] = ACTIONS(6362),
    [anon_sym_BANG_TILDE] = ACTIONS(6362),
    [anon_sym_LT_EQ] = ACTIONS(6364),
    [anon_sym_GT] = ACTIONS(6364),
    [anon_sym_GT_EQ] = ACTIONS(6362),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_PERCENT] = ACTIONS(6364),
    [sym_comment] = ACTIONS(87),
  },
  [8472] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13306),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8473] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(13306),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13308),
  },
  [8474] = {
    [sym__line_break] = ACTIONS(6370),
    [sym__heredoc_body_start] = ACTIONS(6370),
    [sym__binary_minus] = ACTIONS(6370),
    [sym__binary_star] = ACTIONS(6370),
    [ts_builtin_sym_end] = ACTIONS(6370),
    [anon_sym___END__] = ACTIONS(6370),
    [anon_sym_LBRACE] = ACTIONS(6370),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_RPAREN] = ACTIONS(6370),
    [anon_sym_DOT] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym_STAR_STAR] = ACTIONS(6372),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_end] = ACTIONS(6370),
    [anon_sym_if] = ACTIONS(6370),
    [anon_sym_unless] = ACTIONS(6370),
    [anon_sym_while] = ACTIONS(6370),
    [anon_sym_until] = ACTIONS(6370),
    [anon_sym_rescue] = ACTIONS(6370),
    [anon_sym_do] = ACTIONS(6370),
    [anon_sym_when] = ACTIONS(6370),
    [anon_sym_elsif] = ACTIONS(6370),
    [anon_sym_else] = ACTIONS(6370),
    [anon_sym_then] = ACTIONS(6370),
    [anon_sym_ensure] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6370),
    [anon_sym_COLON_COLON2] = ACTIONS(6370),
    [anon_sym_AMP_DOT] = ACTIONS(6370),
    [anon_sym_PLUS_EQ] = ACTIONS(6370),
    [anon_sym_DASH_EQ] = ACTIONS(6370),
    [anon_sym_STAR_EQ] = ACTIONS(6370),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6370),
    [anon_sym_SLASH_EQ] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6370),
    [anon_sym_PIPE_EQ] = ACTIONS(6370),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6370),
    [anon_sym_AMP_EQ] = ACTIONS(6370),
    [anon_sym_PERCENT_EQ] = ACTIONS(6370),
    [anon_sym_GT_GT_EQ] = ACTIONS(6370),
    [anon_sym_LT_LT_EQ] = ACTIONS(6370),
    [anon_sym_CARET_EQ] = ACTIONS(6370),
    [anon_sym_QMARK] = ACTIONS(6370),
    [anon_sym_DOT_DOT] = ACTIONS(6372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6370),
    [anon_sym_and] = ACTIONS(6370),
    [anon_sym_or] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE] = ACTIONS(6372),
    [anon_sym_AMP_AMP] = ACTIONS(6372),
    [anon_sym_LT_LT] = ACTIONS(6372),
    [anon_sym_GT_GT] = ACTIONS(6372),
    [anon_sym_EQ_EQ] = ACTIONS(6372),
    [anon_sym_BANG_EQ] = ACTIONS(6370),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6370),
    [anon_sym_LT_EQ_GT] = ACTIONS(6370),
    [anon_sym_EQ_TILDE] = ACTIONS(6370),
    [anon_sym_BANG_TILDE] = ACTIONS(6370),
    [anon_sym_LT_EQ] = ACTIONS(6372),
    [anon_sym_GT] = ACTIONS(6372),
    [anon_sym_GT_EQ] = ACTIONS(6370),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_PERCENT] = ACTIONS(6372),
    [sym_comment] = ACTIONS(87),
  },
  [8475] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13310),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8476] = {
    [sym__line_break] = ACTIONS(6894),
    [sym__heredoc_body_start] = ACTIONS(6894),
    [sym__binary_minus] = ACTIONS(6894),
    [sym__binary_star] = ACTIONS(6894),
    [ts_builtin_sym_end] = ACTIONS(6894),
    [anon_sym___END__] = ACTIONS(6894),
    [anon_sym_LBRACE] = ACTIONS(6894),
    [anon_sym_RBRACE] = ACTIONS(6894),
    [anon_sym_RPAREN] = ACTIONS(6894),
    [anon_sym_DOT] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_SEMI] = ACTIONS(6894),
    [anon_sym_STAR_STAR] = ACTIONS(6896),
    [anon_sym_AMP] = ACTIONS(6896),
    [anon_sym_EQ] = ACTIONS(6896),
    [anon_sym_LT] = ACTIONS(6896),
    [anon_sym_end] = ACTIONS(6894),
    [anon_sym_if] = ACTIONS(6894),
    [anon_sym_unless] = ACTIONS(6894),
    [anon_sym_while] = ACTIONS(6894),
    [anon_sym_until] = ACTIONS(6894),
    [anon_sym_rescue] = ACTIONS(6894),
    [anon_sym_do] = ACTIONS(6894),
    [anon_sym_when] = ACTIONS(6894),
    [anon_sym_elsif] = ACTIONS(6894),
    [anon_sym_else] = ACTIONS(6894),
    [anon_sym_then] = ACTIONS(6894),
    [anon_sym_ensure] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6894),
    [anon_sym_COLON_COLON2] = ACTIONS(6894),
    [anon_sym_AMP_DOT] = ACTIONS(6894),
    [anon_sym_PLUS_EQ] = ACTIONS(6894),
    [anon_sym_DASH_EQ] = ACTIONS(6894),
    [anon_sym_STAR_EQ] = ACTIONS(6894),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6894),
    [anon_sym_SLASH_EQ] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6894),
    [anon_sym_PIPE_EQ] = ACTIONS(6894),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6894),
    [anon_sym_AMP_EQ] = ACTIONS(6894),
    [anon_sym_PERCENT_EQ] = ACTIONS(6894),
    [anon_sym_GT_GT_EQ] = ACTIONS(6894),
    [anon_sym_LT_LT_EQ] = ACTIONS(6894),
    [anon_sym_CARET_EQ] = ACTIONS(6894),
    [anon_sym_QMARK] = ACTIONS(6894),
    [anon_sym_DOT_DOT] = ACTIONS(6896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6894),
    [anon_sym_and] = ACTIONS(6894),
    [anon_sym_or] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE] = ACTIONS(6896),
    [anon_sym_AMP_AMP] = ACTIONS(6896),
    [anon_sym_LT_LT] = ACTIONS(6896),
    [anon_sym_GT_GT] = ACTIONS(6896),
    [anon_sym_EQ_EQ] = ACTIONS(6896),
    [anon_sym_BANG_EQ] = ACTIONS(6894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6894),
    [anon_sym_LT_EQ_GT] = ACTIONS(6894),
    [anon_sym_EQ_TILDE] = ACTIONS(6894),
    [anon_sym_BANG_TILDE] = ACTIONS(6894),
    [anon_sym_LT_EQ] = ACTIONS(6896),
    [anon_sym_GT] = ACTIONS(6896),
    [anon_sym_GT_EQ] = ACTIONS(6894),
    [anon_sym_CARET] = ACTIONS(6896),
    [anon_sym_PLUS] = ACTIONS(6896),
    [anon_sym_SLASH] = ACTIONS(6896),
    [anon_sym_PERCENT] = ACTIONS(6896),
    [sym_comment] = ACTIONS(87),
  },
  [8477] = {
    [anon_sym_DOT] = ACTIONS(13312),
    [anon_sym_COLON_COLON] = ACTIONS(13312),
    [sym_comment] = ACTIONS(87),
  },
  [8478] = {
    [sym__line_break] = ACTIONS(7046),
    [sym__heredoc_body_start] = ACTIONS(7046),
    [sym__binary_minus] = ACTIONS(7046),
    [sym__binary_star] = ACTIONS(7046),
    [ts_builtin_sym_end] = ACTIONS(7046),
    [anon_sym___END__] = ACTIONS(7046),
    [anon_sym_LBRACE] = ACTIONS(7046),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7046),
    [anon_sym_DOT] = ACTIONS(7048),
    [anon_sym_COMMA] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_STAR_STAR] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7048),
    [anon_sym_end] = ACTIONS(7046),
    [anon_sym_if] = ACTIONS(7046),
    [anon_sym_unless] = ACTIONS(7046),
    [anon_sym_while] = ACTIONS(7046),
    [anon_sym_until] = ACTIONS(7046),
    [anon_sym_rescue] = ACTIONS(7046),
    [anon_sym_do] = ACTIONS(7046),
    [anon_sym_when] = ACTIONS(7046),
    [anon_sym_elsif] = ACTIONS(7046),
    [anon_sym_else] = ACTIONS(7046),
    [anon_sym_then] = ACTIONS(7046),
    [anon_sym_ensure] = ACTIONS(7046),
    [anon_sym_LBRACK] = ACTIONS(7046),
    [anon_sym_COLON_COLON2] = ACTIONS(7046),
    [anon_sym_AMP_DOT] = ACTIONS(7046),
    [anon_sym_PLUS_EQ] = ACTIONS(7046),
    [anon_sym_DASH_EQ] = ACTIONS(7046),
    [anon_sym_STAR_EQ] = ACTIONS(7046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7046),
    [anon_sym_SLASH_EQ] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7046),
    [anon_sym_PIPE_EQ] = ACTIONS(7046),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7046),
    [anon_sym_AMP_EQ] = ACTIONS(7046),
    [anon_sym_PERCENT_EQ] = ACTIONS(7046),
    [anon_sym_GT_GT_EQ] = ACTIONS(7046),
    [anon_sym_LT_LT_EQ] = ACTIONS(7046),
    [anon_sym_CARET_EQ] = ACTIONS(7046),
    [anon_sym_QMARK] = ACTIONS(7046),
    [anon_sym_DOT_DOT] = ACTIONS(7048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7046),
    [anon_sym_and] = ACTIONS(7046),
    [anon_sym_or] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7048),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_BANG_EQ] = ACTIONS(7046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT_EQ_GT] = ACTIONS(7046),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_BANG_TILDE] = ACTIONS(7046),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7046),
    [anon_sym_CARET] = ACTIONS(7048),
    [anon_sym_PLUS] = ACTIONS(7048),
    [anon_sym_SLASH] = ACTIONS(7048),
    [anon_sym_PERCENT] = ACTIONS(7048),
    [sym_comment] = ACTIONS(87),
  },
  [8479] = {
    [sym__line_break] = ACTIONS(7062),
    [sym__heredoc_body_start] = ACTIONS(7062),
    [sym__binary_minus] = ACTIONS(7062),
    [sym__binary_star] = ACTIONS(7062),
    [ts_builtin_sym_end] = ACTIONS(7062),
    [anon_sym___END__] = ACTIONS(7062),
    [anon_sym_LBRACE] = ACTIONS(7062),
    [anon_sym_RBRACE] = ACTIONS(7062),
    [anon_sym_RPAREN] = ACTIONS(7062),
    [anon_sym_DOT] = ACTIONS(7064),
    [anon_sym_COMMA] = ACTIONS(7062),
    [anon_sym_PIPE] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(7062),
    [anon_sym_STAR_STAR] = ACTIONS(7064),
    [anon_sym_AMP] = ACTIONS(7064),
    [anon_sym_EQ] = ACTIONS(7064),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_end] = ACTIONS(7062),
    [anon_sym_if] = ACTIONS(7062),
    [anon_sym_unless] = ACTIONS(7062),
    [anon_sym_while] = ACTIONS(7062),
    [anon_sym_until] = ACTIONS(7062),
    [anon_sym_rescue] = ACTIONS(7062),
    [anon_sym_do] = ACTIONS(7062),
    [anon_sym_when] = ACTIONS(7062),
    [anon_sym_elsif] = ACTIONS(7062),
    [anon_sym_else] = ACTIONS(7062),
    [anon_sym_then] = ACTIONS(7062),
    [anon_sym_ensure] = ACTIONS(7062),
    [anon_sym_LBRACK] = ACTIONS(7062),
    [anon_sym_COLON_COLON2] = ACTIONS(7062),
    [anon_sym_AMP_DOT] = ACTIONS(7062),
    [anon_sym_PLUS_EQ] = ACTIONS(7062),
    [anon_sym_DASH_EQ] = ACTIONS(7062),
    [anon_sym_STAR_EQ] = ACTIONS(7062),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7062),
    [anon_sym_SLASH_EQ] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7062),
    [anon_sym_PIPE_EQ] = ACTIONS(7062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7062),
    [anon_sym_AMP_EQ] = ACTIONS(7062),
    [anon_sym_PERCENT_EQ] = ACTIONS(7062),
    [anon_sym_GT_GT_EQ] = ACTIONS(7062),
    [anon_sym_LT_LT_EQ] = ACTIONS(7062),
    [anon_sym_CARET_EQ] = ACTIONS(7062),
    [anon_sym_QMARK] = ACTIONS(7062),
    [anon_sym_DOT_DOT] = ACTIONS(7064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7062),
    [anon_sym_and] = ACTIONS(7062),
    [anon_sym_or] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE] = ACTIONS(7064),
    [anon_sym_AMP_AMP] = ACTIONS(7064),
    [anon_sym_LT_LT] = ACTIONS(7064),
    [anon_sym_GT_GT] = ACTIONS(7064),
    [anon_sym_EQ_EQ] = ACTIONS(7064),
    [anon_sym_BANG_EQ] = ACTIONS(7062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7062),
    [anon_sym_LT_EQ_GT] = ACTIONS(7062),
    [anon_sym_EQ_TILDE] = ACTIONS(7062),
    [anon_sym_BANG_TILDE] = ACTIONS(7062),
    [anon_sym_LT_EQ] = ACTIONS(7064),
    [anon_sym_GT] = ACTIONS(7064),
    [anon_sym_GT_EQ] = ACTIONS(7062),
    [anon_sym_CARET] = ACTIONS(7064),
    [anon_sym_PLUS] = ACTIONS(7064),
    [anon_sym_SLASH] = ACTIONS(7064),
    [anon_sym_PERCENT] = ACTIONS(7064),
    [sym_comment] = ACTIONS(87),
  },
  [8480] = {
    [sym__statements] = STATE(3605),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(3606),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(3607),
    [sym_rescue] = STATE(3608),
    [sym__body_statement] = STATE(9849),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13314),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8481] = {
    [sym__statements] = STATE(3605),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(3606),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(3607),
    [sym_rescue] = STATE(3608),
    [sym__body_statement] = STATE(9850),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13316),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8482] = {
    [sym__line_break] = ACTIONS(7496),
    [sym__heredoc_body_start] = ACTIONS(7496),
    [sym__binary_minus] = ACTIONS(7496),
    [sym__binary_star] = ACTIONS(7496),
    [ts_builtin_sym_end] = ACTIONS(7496),
    [anon_sym___END__] = ACTIONS(7496),
    [anon_sym_LBRACE] = ACTIONS(7496),
    [anon_sym_RBRACE] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(7496),
    [anon_sym_DOT] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_end] = ACTIONS(7496),
    [anon_sym_if] = ACTIONS(7496),
    [anon_sym_unless] = ACTIONS(7496),
    [anon_sym_while] = ACTIONS(7496),
    [anon_sym_until] = ACTIONS(7496),
    [anon_sym_rescue] = ACTIONS(7496),
    [anon_sym_do] = ACTIONS(7496),
    [anon_sym_when] = ACTIONS(7496),
    [anon_sym_elsif] = ACTIONS(7496),
    [anon_sym_else] = ACTIONS(7496),
    [anon_sym_then] = ACTIONS(7496),
    [anon_sym_ensure] = ACTIONS(7496),
    [anon_sym_LBRACK] = ACTIONS(7496),
    [anon_sym_COLON_COLON2] = ACTIONS(7496),
    [anon_sym_AMP_DOT] = ACTIONS(7496),
    [anon_sym_PLUS_EQ] = ACTIONS(7496),
    [anon_sym_DASH_EQ] = ACTIONS(7496),
    [anon_sym_STAR_EQ] = ACTIONS(7496),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7496),
    [anon_sym_SLASH_EQ] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7496),
    [anon_sym_PIPE_EQ] = ACTIONS(7496),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7496),
    [anon_sym_AMP_EQ] = ACTIONS(7496),
    [anon_sym_PERCENT_EQ] = ACTIONS(7496),
    [anon_sym_GT_GT_EQ] = ACTIONS(7496),
    [anon_sym_LT_LT_EQ] = ACTIONS(7496),
    [anon_sym_CARET_EQ] = ACTIONS(7496),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_DOT_DOT] = ACTIONS(7498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7496),
    [anon_sym_and] = ACTIONS(7496),
    [anon_sym_or] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE] = ACTIONS(7498),
    [anon_sym_AMP_AMP] = ACTIONS(7498),
    [anon_sym_LT_LT] = ACTIONS(7498),
    [anon_sym_GT_GT] = ACTIONS(7498),
    [anon_sym_EQ_EQ] = ACTIONS(7498),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7496),
    [anon_sym_LT_EQ_GT] = ACTIONS(7496),
    [anon_sym_EQ_TILDE] = ACTIONS(7496),
    [anon_sym_BANG_TILDE] = ACTIONS(7496),
    [anon_sym_LT_EQ] = ACTIONS(7498),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7498),
    [anon_sym_PERCENT] = ACTIONS(7498),
    [sym_comment] = ACTIONS(87),
  },
  [8483] = {
    [sym__line_break] = ACTIONS(7550),
    [sym__heredoc_body_start] = ACTIONS(7550),
    [sym__binary_minus] = ACTIONS(7550),
    [sym__binary_star] = ACTIONS(7550),
    [ts_builtin_sym_end] = ACTIONS(7550),
    [anon_sym___END__] = ACTIONS(7550),
    [anon_sym_LBRACE] = ACTIONS(7550),
    [anon_sym_RBRACE] = ACTIONS(7550),
    [anon_sym_RPAREN] = ACTIONS(7550),
    [anon_sym_DOT] = ACTIONS(7552),
    [anon_sym_COMMA] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_SEMI] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_end] = ACTIONS(7550),
    [anon_sym_if] = ACTIONS(7550),
    [anon_sym_unless] = ACTIONS(7550),
    [anon_sym_while] = ACTIONS(7550),
    [anon_sym_until] = ACTIONS(7550),
    [anon_sym_rescue] = ACTIONS(7550),
    [anon_sym_do] = ACTIONS(7550),
    [anon_sym_when] = ACTIONS(7550),
    [anon_sym_elsif] = ACTIONS(7550),
    [anon_sym_else] = ACTIONS(7550),
    [anon_sym_then] = ACTIONS(7550),
    [anon_sym_ensure] = ACTIONS(7550),
    [anon_sym_LBRACK] = ACTIONS(7550),
    [anon_sym_COLON_COLON2] = ACTIONS(7550),
    [anon_sym_AMP_DOT] = ACTIONS(7550),
    [anon_sym_PLUS_EQ] = ACTIONS(7550),
    [anon_sym_DASH_EQ] = ACTIONS(7550),
    [anon_sym_STAR_EQ] = ACTIONS(7550),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7550),
    [anon_sym_SLASH_EQ] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7550),
    [anon_sym_PIPE_EQ] = ACTIONS(7550),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7550),
    [anon_sym_AMP_EQ] = ACTIONS(7550),
    [anon_sym_PERCENT_EQ] = ACTIONS(7550),
    [anon_sym_GT_GT_EQ] = ACTIONS(7550),
    [anon_sym_LT_LT_EQ] = ACTIONS(7550),
    [anon_sym_CARET_EQ] = ACTIONS(7550),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_DOT_DOT] = ACTIONS(7552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7550),
    [anon_sym_and] = ACTIONS(7550),
    [anon_sym_or] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE] = ACTIONS(7552),
    [anon_sym_AMP_AMP] = ACTIONS(7552),
    [anon_sym_LT_LT] = ACTIONS(7552),
    [anon_sym_GT_GT] = ACTIONS(7552),
    [anon_sym_EQ_EQ] = ACTIONS(7552),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7550),
    [anon_sym_LT_EQ_GT] = ACTIONS(7550),
    [anon_sym_EQ_TILDE] = ACTIONS(7550),
    [anon_sym_BANG_TILDE] = ACTIONS(7550),
    [anon_sym_LT_EQ] = ACTIONS(7552),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7552),
    [anon_sym_PERCENT] = ACTIONS(7552),
    [sym_comment] = ACTIONS(87),
  },
  [8484] = {
    [sym__line_break] = ACTIONS(7724),
    [sym__heredoc_body_start] = ACTIONS(7724),
    [sym__binary_minus] = ACTIONS(7724),
    [sym__binary_star] = ACTIONS(7724),
    [ts_builtin_sym_end] = ACTIONS(7724),
    [anon_sym___END__] = ACTIONS(7724),
    [anon_sym_LBRACE] = ACTIONS(7724),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_DOT] = ACTIONS(7726),
    [anon_sym_COMMA] = ACTIONS(7724),
    [anon_sym_PIPE] = ACTIONS(7726),
    [anon_sym_SEMI] = ACTIONS(7724),
    [anon_sym_STAR_STAR] = ACTIONS(7726),
    [anon_sym_AMP] = ACTIONS(7726),
    [anon_sym_EQ] = ACTIONS(7726),
    [anon_sym_LT] = ACTIONS(7726),
    [anon_sym_end] = ACTIONS(7724),
    [anon_sym_if] = ACTIONS(7724),
    [anon_sym_unless] = ACTIONS(7724),
    [anon_sym_while] = ACTIONS(7724),
    [anon_sym_until] = ACTIONS(7724),
    [anon_sym_rescue] = ACTIONS(7724),
    [anon_sym_do] = ACTIONS(7724),
    [anon_sym_when] = ACTIONS(7724),
    [anon_sym_elsif] = ACTIONS(7724),
    [anon_sym_else] = ACTIONS(7724),
    [anon_sym_then] = ACTIONS(7724),
    [anon_sym_ensure] = ACTIONS(7724),
    [anon_sym_LBRACK] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(7724),
    [anon_sym_AMP_DOT] = ACTIONS(7724),
    [anon_sym_PLUS_EQ] = ACTIONS(7724),
    [anon_sym_DASH_EQ] = ACTIONS(7724),
    [anon_sym_STAR_EQ] = ACTIONS(7724),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7724),
    [anon_sym_SLASH_EQ] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7724),
    [anon_sym_PIPE_EQ] = ACTIONS(7724),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7724),
    [anon_sym_AMP_EQ] = ACTIONS(7724),
    [anon_sym_PERCENT_EQ] = ACTIONS(7724),
    [anon_sym_GT_GT_EQ] = ACTIONS(7724),
    [anon_sym_LT_LT_EQ] = ACTIONS(7724),
    [anon_sym_CARET_EQ] = ACTIONS(7724),
    [anon_sym_QMARK] = ACTIONS(7724),
    [anon_sym_DOT_DOT] = ACTIONS(7726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7724),
    [anon_sym_and] = ACTIONS(7724),
    [anon_sym_or] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE] = ACTIONS(7726),
    [anon_sym_AMP_AMP] = ACTIONS(7726),
    [anon_sym_LT_LT] = ACTIONS(7726),
    [anon_sym_GT_GT] = ACTIONS(7726),
    [anon_sym_EQ_EQ] = ACTIONS(7726),
    [anon_sym_BANG_EQ] = ACTIONS(7724),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7724),
    [anon_sym_LT_EQ_GT] = ACTIONS(7724),
    [anon_sym_EQ_TILDE] = ACTIONS(7724),
    [anon_sym_BANG_TILDE] = ACTIONS(7724),
    [anon_sym_LT_EQ] = ACTIONS(7726),
    [anon_sym_GT] = ACTIONS(7726),
    [anon_sym_GT_EQ] = ACTIONS(7724),
    [anon_sym_CARET] = ACTIONS(7726),
    [anon_sym_PLUS] = ACTIONS(7726),
    [anon_sym_SLASH] = ACTIONS(7726),
    [anon_sym_PERCENT] = ACTIONS(7726),
    [sym_comment] = ACTIONS(87),
  },
  [8485] = {
    [sym_elsif] = STATE(9852),
    [sym_else] = STATE(9852),
    [sym__if_tail] = STATE(9852),
    [anon_sym_end] = ACTIONS(13318),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [8486] = {
    [anon_sym_end] = ACTIONS(13318),
    [sym_comment] = ACTIONS(87),
  },
  [8487] = {
    [sym__statements] = STATE(9853),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(9852),
    [sym_else] = STATE(9852),
    [sym__if_tail] = STATE(9852),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13320),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8488] = {
    [sym__line_break] = ACTIONS(7922),
    [sym__heredoc_body_start] = ACTIONS(7922),
    [sym__binary_minus] = ACTIONS(7922),
    [sym__binary_star] = ACTIONS(7922),
    [ts_builtin_sym_end] = ACTIONS(7922),
    [anon_sym___END__] = ACTIONS(7922),
    [anon_sym_LBRACE] = ACTIONS(7922),
    [anon_sym_RBRACE] = ACTIONS(7922),
    [anon_sym_RPAREN] = ACTIONS(7922),
    [anon_sym_DOT] = ACTIONS(7924),
    [anon_sym_COMMA] = ACTIONS(7922),
    [anon_sym_PIPE] = ACTIONS(7924),
    [anon_sym_SEMI] = ACTIONS(7922),
    [anon_sym_STAR_STAR] = ACTIONS(7924),
    [anon_sym_AMP] = ACTIONS(7924),
    [anon_sym_EQ] = ACTIONS(7924),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_end] = ACTIONS(7922),
    [anon_sym_if] = ACTIONS(7922),
    [anon_sym_unless] = ACTIONS(7922),
    [anon_sym_while] = ACTIONS(7922),
    [anon_sym_until] = ACTIONS(7922),
    [anon_sym_rescue] = ACTIONS(7922),
    [anon_sym_do] = ACTIONS(7922),
    [anon_sym_when] = ACTIONS(7922),
    [anon_sym_elsif] = ACTIONS(7922),
    [anon_sym_else] = ACTIONS(7922),
    [anon_sym_then] = ACTIONS(7922),
    [anon_sym_ensure] = ACTIONS(7922),
    [anon_sym_LBRACK] = ACTIONS(7922),
    [anon_sym_COLON_COLON2] = ACTIONS(7922),
    [anon_sym_AMP_DOT] = ACTIONS(7922),
    [anon_sym_PLUS_EQ] = ACTIONS(7922),
    [anon_sym_DASH_EQ] = ACTIONS(7922),
    [anon_sym_STAR_EQ] = ACTIONS(7922),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7922),
    [anon_sym_SLASH_EQ] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7922),
    [anon_sym_PIPE_EQ] = ACTIONS(7922),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7922),
    [anon_sym_AMP_EQ] = ACTIONS(7922),
    [anon_sym_PERCENT_EQ] = ACTIONS(7922),
    [anon_sym_GT_GT_EQ] = ACTIONS(7922),
    [anon_sym_LT_LT_EQ] = ACTIONS(7922),
    [anon_sym_CARET_EQ] = ACTIONS(7922),
    [anon_sym_QMARK] = ACTIONS(7922),
    [anon_sym_DOT_DOT] = ACTIONS(7924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7922),
    [anon_sym_and] = ACTIONS(7922),
    [anon_sym_or] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE] = ACTIONS(7924),
    [anon_sym_AMP_AMP] = ACTIONS(7924),
    [anon_sym_LT_LT] = ACTIONS(7924),
    [anon_sym_GT_GT] = ACTIONS(7924),
    [anon_sym_EQ_EQ] = ACTIONS(7924),
    [anon_sym_BANG_EQ] = ACTIONS(7922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7922),
    [anon_sym_LT_EQ_GT] = ACTIONS(7922),
    [anon_sym_EQ_TILDE] = ACTIONS(7922),
    [anon_sym_BANG_TILDE] = ACTIONS(7922),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7922),
    [anon_sym_CARET] = ACTIONS(7924),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_SLASH] = ACTIONS(7924),
    [anon_sym_PERCENT] = ACTIONS(7924),
    [sym_comment] = ACTIONS(87),
  },
  [8489] = {
    [sym_else] = STATE(9855),
    [anon_sym_end] = ACTIONS(13322),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [8490] = {
    [anon_sym_end] = ACTIONS(13322),
    [sym_comment] = ACTIONS(87),
  },
  [8491] = {
    [sym__line_break] = ACTIONS(8090),
    [sym__heredoc_body_start] = ACTIONS(8090),
    [sym__binary_minus] = ACTIONS(8090),
    [sym__binary_star] = ACTIONS(8090),
    [ts_builtin_sym_end] = ACTIONS(8090),
    [anon_sym___END__] = ACTIONS(8090),
    [anon_sym_LBRACE] = ACTIONS(8090),
    [anon_sym_RBRACE] = ACTIONS(8090),
    [anon_sym_RPAREN] = ACTIONS(8090),
    [anon_sym_DOT] = ACTIONS(8092),
    [anon_sym_COMMA] = ACTIONS(8090),
    [anon_sym_PIPE] = ACTIONS(8092),
    [anon_sym_SEMI] = ACTIONS(8090),
    [anon_sym_STAR_STAR] = ACTIONS(8092),
    [anon_sym_AMP] = ACTIONS(8092),
    [anon_sym_EQ] = ACTIONS(8092),
    [anon_sym_LT] = ACTIONS(8092),
    [anon_sym_end] = ACTIONS(8090),
    [anon_sym_if] = ACTIONS(8090),
    [anon_sym_unless] = ACTIONS(8090),
    [anon_sym_while] = ACTIONS(8090),
    [anon_sym_until] = ACTIONS(8090),
    [anon_sym_rescue] = ACTIONS(8090),
    [anon_sym_do] = ACTIONS(8090),
    [anon_sym_when] = ACTIONS(8090),
    [anon_sym_elsif] = ACTIONS(8090),
    [anon_sym_else] = ACTIONS(8090),
    [anon_sym_then] = ACTIONS(8090),
    [anon_sym_ensure] = ACTIONS(8090),
    [anon_sym_LBRACK] = ACTIONS(8090),
    [anon_sym_COLON_COLON2] = ACTIONS(8090),
    [anon_sym_AMP_DOT] = ACTIONS(8090),
    [anon_sym_PLUS_EQ] = ACTIONS(8090),
    [anon_sym_DASH_EQ] = ACTIONS(8090),
    [anon_sym_STAR_EQ] = ACTIONS(8090),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8090),
    [anon_sym_SLASH_EQ] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8090),
    [anon_sym_PIPE_EQ] = ACTIONS(8090),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8090),
    [anon_sym_AMP_EQ] = ACTIONS(8090),
    [anon_sym_PERCENT_EQ] = ACTIONS(8090),
    [anon_sym_GT_GT_EQ] = ACTIONS(8090),
    [anon_sym_LT_LT_EQ] = ACTIONS(8090),
    [anon_sym_CARET_EQ] = ACTIONS(8090),
    [anon_sym_QMARK] = ACTIONS(8090),
    [anon_sym_DOT_DOT] = ACTIONS(8092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8090),
    [anon_sym_and] = ACTIONS(8090),
    [anon_sym_or] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE] = ACTIONS(8092),
    [anon_sym_AMP_AMP] = ACTIONS(8092),
    [anon_sym_LT_LT] = ACTIONS(8092),
    [anon_sym_GT_GT] = ACTIONS(8092),
    [anon_sym_EQ_EQ] = ACTIONS(8092),
    [anon_sym_BANG_EQ] = ACTIONS(8090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8090),
    [anon_sym_LT_EQ_GT] = ACTIONS(8090),
    [anon_sym_EQ_TILDE] = ACTIONS(8090),
    [anon_sym_BANG_TILDE] = ACTIONS(8090),
    [anon_sym_LT_EQ] = ACTIONS(8092),
    [anon_sym_GT] = ACTIONS(8092),
    [anon_sym_GT_EQ] = ACTIONS(8090),
    [anon_sym_CARET] = ACTIONS(8092),
    [anon_sym_PLUS] = ACTIONS(8092),
    [anon_sym_SLASH] = ACTIONS(8092),
    [anon_sym_PERCENT] = ACTIONS(8092),
    [sym_comment] = ACTIONS(87),
  },
  [8492] = {
    [anon_sym_end] = ACTIONS(13324),
    [sym_comment] = ACTIONS(87),
  },
  [8493] = {
    [sym__line_break] = ACTIONS(8166),
    [sym__heredoc_body_start] = ACTIONS(8166),
    [sym__binary_minus] = ACTIONS(8166),
    [sym__binary_star] = ACTIONS(8166),
    [ts_builtin_sym_end] = ACTIONS(8166),
    [anon_sym___END__] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_DOT] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8166),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI] = ACTIONS(8166),
    [anon_sym_STAR_STAR] = ACTIONS(8168),
    [anon_sym_AMP] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_end] = ACTIONS(8166),
    [anon_sym_if] = ACTIONS(8166),
    [anon_sym_unless] = ACTIONS(8166),
    [anon_sym_while] = ACTIONS(8166),
    [anon_sym_until] = ACTIONS(8166),
    [anon_sym_rescue] = ACTIONS(8166),
    [anon_sym_do] = ACTIONS(8166),
    [anon_sym_when] = ACTIONS(8166),
    [anon_sym_elsif] = ACTIONS(8166),
    [anon_sym_else] = ACTIONS(8166),
    [anon_sym_then] = ACTIONS(8166),
    [anon_sym_ensure] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_COLON_COLON2] = ACTIONS(8166),
    [anon_sym_AMP_DOT] = ACTIONS(8166),
    [anon_sym_PLUS_EQ] = ACTIONS(8166),
    [anon_sym_DASH_EQ] = ACTIONS(8166),
    [anon_sym_STAR_EQ] = ACTIONS(8166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8166),
    [anon_sym_SLASH_EQ] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8166),
    [anon_sym_PIPE_EQ] = ACTIONS(8166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8166),
    [anon_sym_AMP_EQ] = ACTIONS(8166),
    [anon_sym_PERCENT_EQ] = ACTIONS(8166),
    [anon_sym_GT_GT_EQ] = ACTIONS(8166),
    [anon_sym_LT_LT_EQ] = ACTIONS(8166),
    [anon_sym_CARET_EQ] = ACTIONS(8166),
    [anon_sym_QMARK] = ACTIONS(8166),
    [anon_sym_DOT_DOT] = ACTIONS(8168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8166),
    [anon_sym_and] = ACTIONS(8166),
    [anon_sym_or] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8168),
    [anon_sym_AMP_AMP] = ACTIONS(8168),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ_GT] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_BANG_TILDE] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8168),
    [anon_sym_SLASH] = ACTIONS(8168),
    [anon_sym_PERCENT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(87),
  },
  [8494] = {
    [anon_sym_end] = ACTIONS(13326),
    [sym_comment] = ACTIONS(87),
  },
  [8495] = {
    [sym__statements] = STATE(9859),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13328),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8496] = {
    [anon_sym_end] = ACTIONS(13330),
    [sym_comment] = ACTIONS(87),
  },
  [8497] = {
    [sym_when] = STATE(9861),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8498] = {
    [sym__line_break] = ACTIONS(8414),
    [sym__heredoc_body_start] = ACTIONS(8414),
    [sym__binary_minus] = ACTIONS(8414),
    [sym__binary_star] = ACTIONS(8414),
    [ts_builtin_sym_end] = ACTIONS(8414),
    [anon_sym___END__] = ACTIONS(8414),
    [anon_sym_LBRACE] = ACTIONS(8414),
    [anon_sym_RBRACE] = ACTIONS(8414),
    [anon_sym_RPAREN] = ACTIONS(8414),
    [anon_sym_DOT] = ACTIONS(8416),
    [anon_sym_COMMA] = ACTIONS(8414),
    [anon_sym_PIPE] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8414),
    [anon_sym_STAR_STAR] = ACTIONS(8416),
    [anon_sym_AMP] = ACTIONS(8416),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LT] = ACTIONS(8416),
    [anon_sym_end] = ACTIONS(8414),
    [anon_sym_if] = ACTIONS(8414),
    [anon_sym_unless] = ACTIONS(8414),
    [anon_sym_while] = ACTIONS(8414),
    [anon_sym_until] = ACTIONS(8414),
    [anon_sym_rescue] = ACTIONS(8414),
    [anon_sym_do] = ACTIONS(8414),
    [anon_sym_when] = ACTIONS(8414),
    [anon_sym_elsif] = ACTIONS(8414),
    [anon_sym_else] = ACTIONS(8414),
    [anon_sym_then] = ACTIONS(8414),
    [anon_sym_ensure] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8414),
    [anon_sym_COLON_COLON2] = ACTIONS(8414),
    [anon_sym_AMP_DOT] = ACTIONS(8414),
    [anon_sym_PLUS_EQ] = ACTIONS(8414),
    [anon_sym_DASH_EQ] = ACTIONS(8414),
    [anon_sym_STAR_EQ] = ACTIONS(8414),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8414),
    [anon_sym_SLASH_EQ] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8414),
    [anon_sym_PIPE_EQ] = ACTIONS(8414),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8414),
    [anon_sym_AMP_EQ] = ACTIONS(8414),
    [anon_sym_PERCENT_EQ] = ACTIONS(8414),
    [anon_sym_GT_GT_EQ] = ACTIONS(8414),
    [anon_sym_LT_LT_EQ] = ACTIONS(8414),
    [anon_sym_CARET_EQ] = ACTIONS(8414),
    [anon_sym_QMARK] = ACTIONS(8414),
    [anon_sym_DOT_DOT] = ACTIONS(8416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8414),
    [anon_sym_and] = ACTIONS(8414),
    [anon_sym_or] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE] = ACTIONS(8416),
    [anon_sym_AMP_AMP] = ACTIONS(8416),
    [anon_sym_LT_LT] = ACTIONS(8416),
    [anon_sym_GT_GT] = ACTIONS(8416),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8414),
    [anon_sym_LT_EQ_GT] = ACTIONS(8414),
    [anon_sym_EQ_TILDE] = ACTIONS(8414),
    [anon_sym_BANG_TILDE] = ACTIONS(8414),
    [anon_sym_LT_EQ] = ACTIONS(8416),
    [anon_sym_GT] = ACTIONS(8416),
    [anon_sym_GT_EQ] = ACTIONS(8414),
    [anon_sym_CARET] = ACTIONS(8416),
    [anon_sym_PLUS] = ACTIONS(8416),
    [anon_sym_SLASH] = ACTIONS(8416),
    [anon_sym_PERCENT] = ACTIONS(8416),
    [sym_comment] = ACTIONS(87),
  },
  [8499] = {
    [sym__line_break] = ACTIONS(8923),
    [sym__heredoc_body_start] = ACTIONS(8923),
    [sym__binary_minus] = ACTIONS(8923),
    [sym__binary_star] = ACTIONS(8923),
    [ts_builtin_sym_end] = ACTIONS(8923),
    [anon_sym___END__] = ACTIONS(8923),
    [anon_sym_LBRACE] = ACTIONS(8923),
    [anon_sym_RBRACE] = ACTIONS(8923),
    [anon_sym_RPAREN] = ACTIONS(8923),
    [anon_sym_DOT] = ACTIONS(8925),
    [anon_sym_COMMA] = ACTIONS(8923),
    [anon_sym_PIPE] = ACTIONS(8925),
    [anon_sym_SEMI] = ACTIONS(8923),
    [anon_sym_STAR_STAR] = ACTIONS(8925),
    [anon_sym_AMP] = ACTIONS(8925),
    [anon_sym_EQ] = ACTIONS(8925),
    [anon_sym_LT] = ACTIONS(8925),
    [anon_sym_end] = ACTIONS(8923),
    [anon_sym_if] = ACTIONS(8923),
    [anon_sym_unless] = ACTIONS(8923),
    [anon_sym_while] = ACTIONS(8923),
    [anon_sym_until] = ACTIONS(8923),
    [anon_sym_rescue] = ACTIONS(8923),
    [anon_sym_do] = ACTIONS(8923),
    [anon_sym_when] = ACTIONS(8923),
    [anon_sym_elsif] = ACTIONS(8923),
    [anon_sym_else] = ACTIONS(8923),
    [anon_sym_then] = ACTIONS(8923),
    [anon_sym_ensure] = ACTIONS(8923),
    [anon_sym_LBRACK] = ACTIONS(8923),
    [anon_sym_COLON_COLON2] = ACTIONS(8923),
    [anon_sym_AMP_DOT] = ACTIONS(8923),
    [anon_sym_PLUS_EQ] = ACTIONS(8923),
    [anon_sym_DASH_EQ] = ACTIONS(8923),
    [anon_sym_STAR_EQ] = ACTIONS(8923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8923),
    [anon_sym_SLASH_EQ] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8923),
    [anon_sym_PIPE_EQ] = ACTIONS(8923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8923),
    [anon_sym_AMP_EQ] = ACTIONS(8923),
    [anon_sym_PERCENT_EQ] = ACTIONS(8923),
    [anon_sym_GT_GT_EQ] = ACTIONS(8923),
    [anon_sym_LT_LT_EQ] = ACTIONS(8923),
    [anon_sym_CARET_EQ] = ACTIONS(8923),
    [anon_sym_QMARK] = ACTIONS(8923),
    [anon_sym_DOT_DOT] = ACTIONS(8925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8923),
    [anon_sym_and] = ACTIONS(8923),
    [anon_sym_or] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE] = ACTIONS(8925),
    [anon_sym_AMP_AMP] = ACTIONS(8925),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8925),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8925),
    [anon_sym_GT] = ACTIONS(8925),
    [anon_sym_GT_EQ] = ACTIONS(8923),
    [anon_sym_CARET] = ACTIONS(8925),
    [anon_sym_PLUS] = ACTIONS(8925),
    [anon_sym_SLASH] = ACTIONS(8925),
    [anon_sym_PERCENT] = ACTIONS(8925),
    [sym_comment] = ACTIONS(87),
  },
  [8500] = {
    [anon_sym_end] = ACTIONS(13332),
    [sym_comment] = ACTIONS(87),
  },
  [8501] = {
    [sym_ensure] = STATE(9863),
    [anon_sym_end] = ACTIONS(13332),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [8502] = {
    [sym__line_break] = ACTIONS(9143),
    [sym__heredoc_body_start] = ACTIONS(9143),
    [sym__binary_minus] = ACTIONS(9143),
    [sym__binary_star] = ACTIONS(9143),
    [ts_builtin_sym_end] = ACTIONS(9143),
    [anon_sym___END__] = ACTIONS(9143),
    [anon_sym_LBRACE] = ACTIONS(9143),
    [anon_sym_RBRACE] = ACTIONS(9143),
    [anon_sym_RPAREN] = ACTIONS(9143),
    [anon_sym_DOT] = ACTIONS(9145),
    [anon_sym_COMMA] = ACTIONS(9143),
    [anon_sym_PIPE] = ACTIONS(9145),
    [anon_sym_SEMI] = ACTIONS(9143),
    [anon_sym_STAR_STAR] = ACTIONS(9145),
    [anon_sym_AMP] = ACTIONS(9145),
    [anon_sym_EQ] = ACTIONS(9145),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_end] = ACTIONS(9143),
    [anon_sym_if] = ACTIONS(9143),
    [anon_sym_unless] = ACTIONS(9143),
    [anon_sym_while] = ACTIONS(9143),
    [anon_sym_until] = ACTIONS(9143),
    [anon_sym_rescue] = ACTIONS(9143),
    [anon_sym_do] = ACTIONS(9143),
    [anon_sym_when] = ACTIONS(9143),
    [anon_sym_elsif] = ACTIONS(9143),
    [anon_sym_else] = ACTIONS(9143),
    [anon_sym_then] = ACTIONS(9143),
    [anon_sym_ensure] = ACTIONS(9143),
    [anon_sym_LBRACK] = ACTIONS(9143),
    [anon_sym_COLON_COLON2] = ACTIONS(9143),
    [anon_sym_AMP_DOT] = ACTIONS(9143),
    [anon_sym_PLUS_EQ] = ACTIONS(9143),
    [anon_sym_DASH_EQ] = ACTIONS(9143),
    [anon_sym_STAR_EQ] = ACTIONS(9143),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9143),
    [anon_sym_SLASH_EQ] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9143),
    [anon_sym_PIPE_EQ] = ACTIONS(9143),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9143),
    [anon_sym_AMP_EQ] = ACTIONS(9143),
    [anon_sym_PERCENT_EQ] = ACTIONS(9143),
    [anon_sym_GT_GT_EQ] = ACTIONS(9143),
    [anon_sym_LT_LT_EQ] = ACTIONS(9143),
    [anon_sym_CARET_EQ] = ACTIONS(9143),
    [anon_sym_QMARK] = ACTIONS(9143),
    [anon_sym_DOT_DOT] = ACTIONS(9145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9143),
    [anon_sym_and] = ACTIONS(9143),
    [anon_sym_or] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE] = ACTIONS(9145),
    [anon_sym_AMP_AMP] = ACTIONS(9145),
    [anon_sym_LT_LT] = ACTIONS(9145),
    [anon_sym_GT_GT] = ACTIONS(9145),
    [anon_sym_EQ_EQ] = ACTIONS(9145),
    [anon_sym_BANG_EQ] = ACTIONS(9143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9143),
    [anon_sym_LT_EQ_GT] = ACTIONS(9143),
    [anon_sym_EQ_TILDE] = ACTIONS(9143),
    [anon_sym_BANG_TILDE] = ACTIONS(9143),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9143),
    [anon_sym_CARET] = ACTIONS(9145),
    [anon_sym_PLUS] = ACTIONS(9145),
    [anon_sym_SLASH] = ACTIONS(9145),
    [anon_sym_PERCENT] = ACTIONS(9145),
    [sym_comment] = ACTIONS(87),
  },
  [8503] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9864),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_assignment] = STATE(9864),
    [sym_operator_assignment] = STATE(9864),
    [sym_conditional] = STATE(9864),
    [sym_range] = STATE(9864),
    [sym_binary] = STATE(9864),
    [sym_unary] = STATE(9864),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8504] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(6269),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(1496),
    [sym_scope_resolution] = STATE(1494),
    [sym_call] = STATE(1494),
    [sym_method_call] = STATE(1496),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(6269),
    [sym_operator_assignment] = STATE(6269),
    [sym_conditional] = STATE(6269),
    [sym_range] = STATE(6269),
    [sym_binary] = STATE(6269),
    [sym_unary] = STATE(6269),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(1495),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1496),
    [sym__variable] = STATE(1494),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(1496),
    [sym_false] = STATE(1496),
    [sym_nil] = STATE(1496),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(1497),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(765),
    [sym__unary_minus] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2587),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_next] = ACTIONS(2591),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_defined_QMARK] = ACTIONS(2611),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [sym_constant] = ACTIONS(2617),
    [sym_identifier] = ACTIONS(2617),
    [sym_instance_variable] = ACTIONS(2619),
    [sym_class_variable] = ACTIONS(2619),
    [sym_global_variable] = ACTIONS(2619),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(2617),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2617),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8505] = {
    [aux_sym_exceptions_repeat1] = STATE(9866),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [ts_builtin_sym_end] = ACTIONS(9603),
    [anon_sym___END__] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13334),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [8506] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [8507] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [8508] = {
    [sym_heredoc_body] = STATE(8508),
    [aux_sym_call_repeat1] = STATE(8508),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8509] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(3642),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(3642),
    [sym_operator_assignment] = STATE(3642),
    [sym_conditional] = STATE(3642),
    [sym_range] = STATE(3642),
    [sym_binary] = STATE(3642),
    [sym_unary] = STATE(3642),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3645),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(5928),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [sym__identifier_hash_key] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11902),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(5934),
    [sym_identifier] = ACTIONS(5934),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8510] = {
    [sym_heredoc_body] = STATE(8508),
    [aux_sym_call_repeat1] = STATE(8508),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8511] = {
    [aux_sym_argument_list_repeat1] = STATE(8511),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13336),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [8512] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9867),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1517),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1517),
    [sym_assignment] = STATE(9867),
    [sym_operator_assignment] = STATE(9867),
    [sym_conditional] = STATE(9867),
    [sym_range] = STATE(9867),
    [sym_binary] = STATE(9867),
    [sym_unary] = STATE(9867),
    [sym_left_assignment_list] = STATE(1516),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1517),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1517),
    [sym_false] = STATE(1517),
    [sym_nil] = STATE(1517),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3636),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_yield] = ACTIONS(2643),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_next] = ACTIONS(2647),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_defined_QMARK] = ACTIONS(2651),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8513] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [8514] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [8515] = {
    [sym_heredoc_body] = STATE(8515),
    [aux_sym_call_repeat1] = STATE(8515),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [8516] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(3664),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(3664),
    [sym_operator_assignment] = STATE(3664),
    [sym_conditional] = STATE(3664),
    [sym_range] = STATE(3664),
    [sym_binary] = STATE(3664),
    [sym_unary] = STATE(3664),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3667),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(5966),
    [sym__splat_star] = ACTIONS(5968),
    [sym__unary_minus] = ACTIONS(3046),
    [sym__identifier_hash_key] = ACTIONS(5970),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11906),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(5972),
    [sym_identifier] = ACTIONS(5972),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8517] = {
    [sym_heredoc_body] = STATE(8515),
    [aux_sym_call_repeat1] = STATE(8515),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [8518] = {
    [aux_sym_argument_list_repeat1] = STATE(8518),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13339),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [8519] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11912),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(11914),
    [anon_sym_LT] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11918),
    [anon_sym_DOT_DOT] = ACTIONS(11920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11922),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11924),
    [anon_sym_AMP_AMP] = ACTIONS(11924),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(11928),
    [anon_sym_BANG_EQ] = ACTIONS(11924),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11924),
    [anon_sym_LT_EQ_GT] = ACTIONS(11924),
    [anon_sym_EQ_TILDE] = ACTIONS(11924),
    [anon_sym_BANG_TILDE] = ACTIONS(11924),
    [anon_sym_LT_EQ] = ACTIONS(11916),
    [anon_sym_GT] = ACTIONS(11916),
    [anon_sym_GT_EQ] = ACTIONS(11930),
    [anon_sym_CARET] = ACTIONS(11932),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [8520] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [8521] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(11912),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(11914),
    [anon_sym_LT] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(11918),
    [anon_sym_DOT_DOT] = ACTIONS(11920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11922),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(11924),
    [anon_sym_AMP_AMP] = ACTIONS(11924),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(11928),
    [anon_sym_BANG_EQ] = ACTIONS(11924),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11924),
    [anon_sym_LT_EQ_GT] = ACTIONS(11924),
    [anon_sym_EQ_TILDE] = ACTIONS(11924),
    [anon_sym_BANG_TILDE] = ACTIONS(11924),
    [anon_sym_LT_EQ] = ACTIONS(11916),
    [anon_sym_GT] = ACTIONS(11916),
    [anon_sym_GT_EQ] = ACTIONS(11930),
    [anon_sym_CARET] = ACTIONS(11932),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [8522] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9868),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(9868),
    [sym_operator_assignment] = STATE(9868),
    [sym_conditional] = STATE(9868),
    [sym_range] = STATE(9868),
    [sym_binary] = STATE(9868),
    [sym_unary] = STATE(9868),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8523] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9869),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(9869),
    [sym_operator_assignment] = STATE(9869),
    [sym_conditional] = STATE(9869),
    [sym_range] = STATE(9869),
    [sym_binary] = STATE(9869),
    [sym_unary] = STATE(9869),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8524] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9870),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(9870),
    [sym_operator_assignment] = STATE(9870),
    [sym_conditional] = STATE(9870),
    [sym_range] = STATE(9870),
    [sym_binary] = STATE(9870),
    [sym_unary] = STATE(9870),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8525] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9871),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(9871),
    [sym_operator_assignment] = STATE(9871),
    [sym_conditional] = STATE(9871),
    [sym_range] = STATE(9871),
    [sym_binary] = STATE(9871),
    [sym_unary] = STATE(9871),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8526] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9872),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(9872),
    [sym_operator_assignment] = STATE(9872),
    [sym_conditional] = STATE(9872),
    [sym_range] = STATE(9872),
    [sym_binary] = STATE(9872),
    [sym_unary] = STATE(9872),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8527] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(9873),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(9873),
    [sym_operator_assignment] = STATE(9873),
    [sym_conditional] = STATE(9873),
    [sym_range] = STATE(9873),
    [sym_binary] = STATE(9873),
    [sym_unary] = STATE(9873),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8528] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9874),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(9874),
    [sym_operator_assignment] = STATE(9874),
    [sym_conditional] = STATE(9874),
    [sym_range] = STATE(9874),
    [sym_binary] = STATE(9874),
    [sym_unary] = STATE(9874),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8529] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9875),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(9875),
    [sym_operator_assignment] = STATE(9875),
    [sym_conditional] = STATE(9875),
    [sym_range] = STATE(9875),
    [sym_binary] = STATE(9875),
    [sym_unary] = STATE(9875),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8530] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9876),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(9876),
    [sym_operator_assignment] = STATE(9876),
    [sym_conditional] = STATE(9876),
    [sym_range] = STATE(9876),
    [sym_binary] = STATE(9876),
    [sym_unary] = STATE(9876),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8531] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9877),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(9877),
    [sym_operator_assignment] = STATE(9877),
    [sym_conditional] = STATE(9877),
    [sym_range] = STATE(9877),
    [sym_binary] = STATE(9877),
    [sym_unary] = STATE(9877),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8532] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6305),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(6305),
    [sym_operator_assignment] = STATE(6305),
    [sym_conditional] = STATE(6305),
    [sym_range] = STATE(6305),
    [sym_binary] = STATE(6305),
    [sym_unary] = STATE(6305),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(9534),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8533] = {
    [aux_sym_exceptions_repeat1] = STATE(9878),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(11934),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8534] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6305),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_splat_argument] = STATE(9879),
    [sym_assignment] = STATE(6305),
    [sym_operator_assignment] = STATE(6305),
    [sym_conditional] = STATE(6305),
    [sym_range] = STATE(6305),
    [sym_binary] = STATE(6305),
    [sym_unary] = STATE(6305),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(9879),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(9534),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8535] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9880),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(9880),
    [sym_operator_assignment] = STATE(9880),
    [sym_conditional] = STATE(9880),
    [sym_range] = STATE(9880),
    [sym_binary] = STATE(9880),
    [sym_unary] = STATE(9880),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8536] = {
    [sym__method_rest] = STATE(9881),
    [sym_operator] = STATE(1524),
    [sym__method_name] = STATE(1524),
    [sym_setter] = STATE(1524),
    [sym_symbol] = STATE(1524),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9550),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9550),
    [sym_class_variable] = ACTIONS(9550),
    [sym_global_variable] = ACTIONS(9550),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [8537] = {
    [sym__line_break] = ACTIONS(10532),
    [sym__heredoc_body_start] = ACTIONS(10532),
    [sym__binary_minus] = ACTIONS(10532),
    [sym__binary_star] = ACTIONS(10532),
    [ts_builtin_sym_end] = ACTIONS(10532),
    [anon_sym___END__] = ACTIONS(10532),
    [anon_sym_LBRACE] = ACTIONS(10532),
    [anon_sym_RBRACE] = ACTIONS(10532),
    [anon_sym_RPAREN] = ACTIONS(10532),
    [anon_sym_DOT] = ACTIONS(10534),
    [anon_sym_COMMA] = ACTIONS(10532),
    [anon_sym_PIPE] = ACTIONS(10534),
    [anon_sym_SEMI] = ACTIONS(10532),
    [anon_sym_STAR_STAR] = ACTIONS(10534),
    [anon_sym_AMP] = ACTIONS(10534),
    [anon_sym_EQ] = ACTIONS(10534),
    [anon_sym_LT] = ACTIONS(10534),
    [anon_sym_end] = ACTIONS(10532),
    [anon_sym_if] = ACTIONS(10532),
    [anon_sym_unless] = ACTIONS(10532),
    [anon_sym_while] = ACTIONS(10532),
    [anon_sym_until] = ACTIONS(10532),
    [anon_sym_rescue] = ACTIONS(10532),
    [anon_sym_do] = ACTIONS(10532),
    [anon_sym_when] = ACTIONS(10532),
    [anon_sym_elsif] = ACTIONS(10532),
    [anon_sym_else] = ACTIONS(10532),
    [anon_sym_then] = ACTIONS(10532),
    [anon_sym_ensure] = ACTIONS(10532),
    [anon_sym_EQ_GT] = ACTIONS(10532),
    [anon_sym_LBRACK] = ACTIONS(10532),
    [anon_sym_COLON_COLON2] = ACTIONS(10532),
    [anon_sym_AMP_DOT] = ACTIONS(10532),
    [anon_sym_PLUS_EQ] = ACTIONS(10532),
    [anon_sym_DASH_EQ] = ACTIONS(10532),
    [anon_sym_STAR_EQ] = ACTIONS(10532),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10532),
    [anon_sym_SLASH_EQ] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10532),
    [anon_sym_PIPE_EQ] = ACTIONS(10532),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10532),
    [anon_sym_AMP_EQ] = ACTIONS(10532),
    [anon_sym_PERCENT_EQ] = ACTIONS(10532),
    [anon_sym_GT_GT_EQ] = ACTIONS(10532),
    [anon_sym_LT_LT_EQ] = ACTIONS(10532),
    [anon_sym_CARET_EQ] = ACTIONS(10532),
    [anon_sym_QMARK] = ACTIONS(10532),
    [anon_sym_DOT_DOT] = ACTIONS(10534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10532),
    [anon_sym_and] = ACTIONS(10532),
    [anon_sym_or] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE] = ACTIONS(10534),
    [anon_sym_AMP_AMP] = ACTIONS(10534),
    [anon_sym_LT_LT] = ACTIONS(10534),
    [anon_sym_GT_GT] = ACTIONS(10534),
    [anon_sym_EQ_EQ] = ACTIONS(10534),
    [anon_sym_BANG_EQ] = ACTIONS(10532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10532),
    [anon_sym_LT_EQ_GT] = ACTIONS(10532),
    [anon_sym_EQ_TILDE] = ACTIONS(10532),
    [anon_sym_BANG_TILDE] = ACTIONS(10532),
    [anon_sym_LT_EQ] = ACTIONS(10534),
    [anon_sym_GT] = ACTIONS(10534),
    [anon_sym_GT_EQ] = ACTIONS(10532),
    [anon_sym_CARET] = ACTIONS(10534),
    [anon_sym_PLUS] = ACTIONS(10534),
    [anon_sym_SLASH] = ACTIONS(10534),
    [anon_sym_PERCENT] = ACTIONS(10534),
    [sym_comment] = ACTIONS(87),
  },
  [8538] = {
    [sym__line_break] = ACTIONS(10536),
    [sym__heredoc_body_start] = ACTIONS(10536),
    [sym__binary_minus] = ACTIONS(10536),
    [sym__binary_star] = ACTIONS(10536),
    [ts_builtin_sym_end] = ACTIONS(10536),
    [anon_sym___END__] = ACTIONS(10536),
    [anon_sym_LBRACE] = ACTIONS(10536),
    [anon_sym_RBRACE] = ACTIONS(10536),
    [anon_sym_RPAREN] = ACTIONS(10536),
    [anon_sym_DOT] = ACTIONS(10538),
    [anon_sym_COMMA] = ACTIONS(10536),
    [anon_sym_PIPE] = ACTIONS(10538),
    [anon_sym_SEMI] = ACTIONS(10536),
    [anon_sym_STAR_STAR] = ACTIONS(10538),
    [anon_sym_AMP] = ACTIONS(10538),
    [anon_sym_EQ] = ACTIONS(10538),
    [anon_sym_LT] = ACTIONS(10538),
    [anon_sym_end] = ACTIONS(10536),
    [anon_sym_if] = ACTIONS(10536),
    [anon_sym_unless] = ACTIONS(10536),
    [anon_sym_while] = ACTIONS(10536),
    [anon_sym_until] = ACTIONS(10536),
    [anon_sym_rescue] = ACTIONS(10536),
    [anon_sym_do] = ACTIONS(10536),
    [anon_sym_when] = ACTIONS(10536),
    [anon_sym_elsif] = ACTIONS(10536),
    [anon_sym_else] = ACTIONS(10536),
    [anon_sym_then] = ACTIONS(10536),
    [anon_sym_ensure] = ACTIONS(10536),
    [anon_sym_EQ_GT] = ACTIONS(10536),
    [anon_sym_LBRACK] = ACTIONS(10536),
    [anon_sym_COLON_COLON2] = ACTIONS(10536),
    [anon_sym_AMP_DOT] = ACTIONS(10536),
    [anon_sym_PLUS_EQ] = ACTIONS(10536),
    [anon_sym_DASH_EQ] = ACTIONS(10536),
    [anon_sym_STAR_EQ] = ACTIONS(10536),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10536),
    [anon_sym_SLASH_EQ] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10536),
    [anon_sym_PIPE_EQ] = ACTIONS(10536),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10536),
    [anon_sym_AMP_EQ] = ACTIONS(10536),
    [anon_sym_PERCENT_EQ] = ACTIONS(10536),
    [anon_sym_GT_GT_EQ] = ACTIONS(10536),
    [anon_sym_LT_LT_EQ] = ACTIONS(10536),
    [anon_sym_CARET_EQ] = ACTIONS(10536),
    [anon_sym_QMARK] = ACTIONS(10536),
    [anon_sym_DOT_DOT] = ACTIONS(10538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10536),
    [anon_sym_and] = ACTIONS(10536),
    [anon_sym_or] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE] = ACTIONS(10538),
    [anon_sym_AMP_AMP] = ACTIONS(10538),
    [anon_sym_LT_LT] = ACTIONS(10538),
    [anon_sym_GT_GT] = ACTIONS(10538),
    [anon_sym_EQ_EQ] = ACTIONS(10538),
    [anon_sym_BANG_EQ] = ACTIONS(10536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10536),
    [anon_sym_LT_EQ_GT] = ACTIONS(10536),
    [anon_sym_EQ_TILDE] = ACTIONS(10536),
    [anon_sym_BANG_TILDE] = ACTIONS(10536),
    [anon_sym_LT_EQ] = ACTIONS(10538),
    [anon_sym_GT] = ACTIONS(10538),
    [anon_sym_GT_EQ] = ACTIONS(10536),
    [anon_sym_CARET] = ACTIONS(10538),
    [anon_sym_PLUS] = ACTIONS(10538),
    [anon_sym_SLASH] = ACTIONS(10538),
    [anon_sym_PERCENT] = ACTIONS(10538),
    [sym_comment] = ACTIONS(87),
  },
  [8539] = {
    [sym__line_break] = ACTIONS(10689),
    [sym__heredoc_body_start] = ACTIONS(10689),
    [sym__binary_minus] = ACTIONS(10689),
    [sym__binary_star] = ACTIONS(10689),
    [ts_builtin_sym_end] = ACTIONS(10689),
    [anon_sym___END__] = ACTIONS(10689),
    [anon_sym_LBRACE] = ACTIONS(10689),
    [anon_sym_RBRACE] = ACTIONS(10689),
    [anon_sym_RPAREN] = ACTIONS(10689),
    [anon_sym_DOT] = ACTIONS(10691),
    [anon_sym_COMMA] = ACTIONS(10689),
    [anon_sym_PIPE] = ACTIONS(10691),
    [anon_sym_SEMI] = ACTIONS(10689),
    [anon_sym_STAR_STAR] = ACTIONS(10691),
    [anon_sym_AMP] = ACTIONS(10691),
    [anon_sym_EQ] = ACTIONS(10691),
    [anon_sym_LT] = ACTIONS(10691),
    [anon_sym_end] = ACTIONS(10689),
    [anon_sym_if] = ACTIONS(10689),
    [anon_sym_unless] = ACTIONS(10689),
    [anon_sym_while] = ACTIONS(10689),
    [anon_sym_until] = ACTIONS(10689),
    [anon_sym_rescue] = ACTIONS(10689),
    [anon_sym_do] = ACTIONS(10689),
    [anon_sym_when] = ACTIONS(10689),
    [anon_sym_elsif] = ACTIONS(10689),
    [anon_sym_else] = ACTIONS(10689),
    [anon_sym_then] = ACTIONS(10689),
    [anon_sym_ensure] = ACTIONS(10689),
    [anon_sym_EQ_GT] = ACTIONS(10689),
    [anon_sym_LBRACK] = ACTIONS(10689),
    [anon_sym_COLON_COLON2] = ACTIONS(10689),
    [anon_sym_AMP_DOT] = ACTIONS(10689),
    [anon_sym_PLUS_EQ] = ACTIONS(10689),
    [anon_sym_DASH_EQ] = ACTIONS(10689),
    [anon_sym_STAR_EQ] = ACTIONS(10689),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10689),
    [anon_sym_SLASH_EQ] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10689),
    [anon_sym_PIPE_EQ] = ACTIONS(10689),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10689),
    [anon_sym_AMP_EQ] = ACTIONS(10689),
    [anon_sym_PERCENT_EQ] = ACTIONS(10689),
    [anon_sym_GT_GT_EQ] = ACTIONS(10689),
    [anon_sym_LT_LT_EQ] = ACTIONS(10689),
    [anon_sym_CARET_EQ] = ACTIONS(10689),
    [anon_sym_QMARK] = ACTIONS(10689),
    [anon_sym_DOT_DOT] = ACTIONS(10691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10689),
    [anon_sym_and] = ACTIONS(10689),
    [anon_sym_or] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE] = ACTIONS(10691),
    [anon_sym_AMP_AMP] = ACTIONS(10691),
    [anon_sym_LT_LT] = ACTIONS(10691),
    [anon_sym_GT_GT] = ACTIONS(10691),
    [anon_sym_EQ_EQ] = ACTIONS(10691),
    [anon_sym_BANG_EQ] = ACTIONS(10689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10689),
    [anon_sym_LT_EQ_GT] = ACTIONS(10689),
    [anon_sym_EQ_TILDE] = ACTIONS(10689),
    [anon_sym_BANG_TILDE] = ACTIONS(10689),
    [anon_sym_LT_EQ] = ACTIONS(10691),
    [anon_sym_GT] = ACTIONS(10691),
    [anon_sym_GT_EQ] = ACTIONS(10689),
    [anon_sym_CARET] = ACTIONS(10691),
    [anon_sym_PLUS] = ACTIONS(10691),
    [anon_sym_SLASH] = ACTIONS(10691),
    [anon_sym_PERCENT] = ACTIONS(10691),
    [sym_comment] = ACTIONS(87),
  },
  [8540] = {
    [anon_sym_end] = ACTIONS(13342),
    [sym_comment] = ACTIONS(87),
  },
  [8541] = {
    [sym_elsif] = STATE(9883),
    [sym_else] = STATE(9883),
    [sym__if_tail] = STATE(9883),
    [anon_sym_end] = ACTIONS(13342),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [8542] = {
    [sym__line_break] = ACTIONS(10856),
    [sym__heredoc_body_start] = ACTIONS(10856),
    [sym__binary_minus] = ACTIONS(10856),
    [sym__binary_star] = ACTIONS(10856),
    [ts_builtin_sym_end] = ACTIONS(10856),
    [anon_sym___END__] = ACTIONS(10856),
    [anon_sym_LBRACE] = ACTIONS(10856),
    [anon_sym_RBRACE] = ACTIONS(10856),
    [anon_sym_RPAREN] = ACTIONS(10856),
    [anon_sym_DOT] = ACTIONS(10858),
    [anon_sym_COMMA] = ACTIONS(10856),
    [anon_sym_PIPE] = ACTIONS(10858),
    [anon_sym_SEMI] = ACTIONS(10856),
    [anon_sym_STAR_STAR] = ACTIONS(10858),
    [anon_sym_AMP] = ACTIONS(10858),
    [anon_sym_EQ] = ACTIONS(10858),
    [anon_sym_LT] = ACTIONS(10858),
    [anon_sym_end] = ACTIONS(10856),
    [anon_sym_if] = ACTIONS(10856),
    [anon_sym_unless] = ACTIONS(10856),
    [anon_sym_while] = ACTIONS(10856),
    [anon_sym_until] = ACTIONS(10856),
    [anon_sym_rescue] = ACTIONS(10856),
    [anon_sym_do] = ACTIONS(10856),
    [anon_sym_when] = ACTIONS(10856),
    [anon_sym_elsif] = ACTIONS(10856),
    [anon_sym_else] = ACTIONS(10856),
    [anon_sym_then] = ACTIONS(10856),
    [anon_sym_ensure] = ACTIONS(10856),
    [anon_sym_EQ_GT] = ACTIONS(10856),
    [anon_sym_LBRACK] = ACTIONS(10856),
    [anon_sym_COLON_COLON2] = ACTIONS(10856),
    [anon_sym_AMP_DOT] = ACTIONS(10856),
    [anon_sym_PLUS_EQ] = ACTIONS(10856),
    [anon_sym_DASH_EQ] = ACTIONS(10856),
    [anon_sym_STAR_EQ] = ACTIONS(10856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10856),
    [anon_sym_SLASH_EQ] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10856),
    [anon_sym_PIPE_EQ] = ACTIONS(10856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10856),
    [anon_sym_AMP_EQ] = ACTIONS(10856),
    [anon_sym_PERCENT_EQ] = ACTIONS(10856),
    [anon_sym_GT_GT_EQ] = ACTIONS(10856),
    [anon_sym_LT_LT_EQ] = ACTIONS(10856),
    [anon_sym_CARET_EQ] = ACTIONS(10856),
    [anon_sym_QMARK] = ACTIONS(10856),
    [anon_sym_DOT_DOT] = ACTIONS(10858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10856),
    [anon_sym_and] = ACTIONS(10856),
    [anon_sym_or] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE] = ACTIONS(10858),
    [anon_sym_AMP_AMP] = ACTIONS(10858),
    [anon_sym_LT_LT] = ACTIONS(10858),
    [anon_sym_GT_GT] = ACTIONS(10858),
    [anon_sym_EQ_EQ] = ACTIONS(10858),
    [anon_sym_BANG_EQ] = ACTIONS(10856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10856),
    [anon_sym_LT_EQ_GT] = ACTIONS(10856),
    [anon_sym_EQ_TILDE] = ACTIONS(10856),
    [anon_sym_BANG_TILDE] = ACTIONS(10856),
    [anon_sym_LT_EQ] = ACTIONS(10858),
    [anon_sym_GT] = ACTIONS(10858),
    [anon_sym_GT_EQ] = ACTIONS(10856),
    [anon_sym_CARET] = ACTIONS(10858),
    [anon_sym_PLUS] = ACTIONS(10858),
    [anon_sym_SLASH] = ACTIONS(10858),
    [anon_sym_PERCENT] = ACTIONS(10858),
    [sym_comment] = ACTIONS(87),
  },
  [8543] = {
    [anon_sym_end] = ACTIONS(13344),
    [sym_comment] = ACTIONS(87),
  },
  [8544] = {
    [sym__line_break] = ACTIONS(10951),
    [sym__heredoc_body_start] = ACTIONS(10951),
    [sym__binary_minus] = ACTIONS(10951),
    [sym__binary_star] = ACTIONS(10951),
    [ts_builtin_sym_end] = ACTIONS(10951),
    [anon_sym___END__] = ACTIONS(10951),
    [anon_sym_LBRACE] = ACTIONS(10951),
    [anon_sym_RBRACE] = ACTIONS(10951),
    [anon_sym_RPAREN] = ACTIONS(10951),
    [anon_sym_DOT] = ACTIONS(10953),
    [anon_sym_COMMA] = ACTIONS(10951),
    [anon_sym_PIPE] = ACTIONS(10953),
    [anon_sym_SEMI] = ACTIONS(10951),
    [anon_sym_STAR_STAR] = ACTIONS(10953),
    [anon_sym_AMP] = ACTIONS(10953),
    [anon_sym_EQ] = ACTIONS(10953),
    [anon_sym_LT] = ACTIONS(10953),
    [anon_sym_end] = ACTIONS(10951),
    [anon_sym_if] = ACTIONS(10951),
    [anon_sym_unless] = ACTIONS(10951),
    [anon_sym_while] = ACTIONS(10951),
    [anon_sym_until] = ACTIONS(10951),
    [anon_sym_rescue] = ACTIONS(10951),
    [anon_sym_do] = ACTIONS(10951),
    [anon_sym_when] = ACTIONS(10951),
    [anon_sym_elsif] = ACTIONS(10951),
    [anon_sym_else] = ACTIONS(10951),
    [anon_sym_then] = ACTIONS(10951),
    [anon_sym_ensure] = ACTIONS(10951),
    [anon_sym_EQ_GT] = ACTIONS(10951),
    [anon_sym_LBRACK] = ACTIONS(10951),
    [anon_sym_COLON_COLON2] = ACTIONS(10951),
    [anon_sym_AMP_DOT] = ACTIONS(10951),
    [anon_sym_PLUS_EQ] = ACTIONS(10951),
    [anon_sym_DASH_EQ] = ACTIONS(10951),
    [anon_sym_STAR_EQ] = ACTIONS(10951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10951),
    [anon_sym_SLASH_EQ] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10951),
    [anon_sym_PIPE_EQ] = ACTIONS(10951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10951),
    [anon_sym_AMP_EQ] = ACTIONS(10951),
    [anon_sym_PERCENT_EQ] = ACTIONS(10951),
    [anon_sym_GT_GT_EQ] = ACTIONS(10951),
    [anon_sym_LT_LT_EQ] = ACTIONS(10951),
    [anon_sym_CARET_EQ] = ACTIONS(10951),
    [anon_sym_QMARK] = ACTIONS(10951),
    [anon_sym_DOT_DOT] = ACTIONS(10953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10951),
    [anon_sym_and] = ACTIONS(10951),
    [anon_sym_or] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE] = ACTIONS(10953),
    [anon_sym_AMP_AMP] = ACTIONS(10953),
    [anon_sym_LT_LT] = ACTIONS(10953),
    [anon_sym_GT_GT] = ACTIONS(10953),
    [anon_sym_EQ_EQ] = ACTIONS(10953),
    [anon_sym_BANG_EQ] = ACTIONS(10951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10951),
    [anon_sym_LT_EQ_GT] = ACTIONS(10951),
    [anon_sym_EQ_TILDE] = ACTIONS(10951),
    [anon_sym_BANG_TILDE] = ACTIONS(10951),
    [anon_sym_LT_EQ] = ACTIONS(10953),
    [anon_sym_GT] = ACTIONS(10953),
    [anon_sym_GT_EQ] = ACTIONS(10951),
    [anon_sym_CARET] = ACTIONS(10953),
    [anon_sym_PLUS] = ACTIONS(10953),
    [anon_sym_SLASH] = ACTIONS(10953),
    [anon_sym_PERCENT] = ACTIONS(10953),
    [sym_comment] = ACTIONS(87),
  },
  [8545] = {
    [sym__line_break] = ACTIONS(10960),
    [sym__heredoc_body_start] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10960),
    [ts_builtin_sym_end] = ACTIONS(10960),
    [anon_sym___END__] = ACTIONS(10960),
    [anon_sym_LBRACE] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10960),
    [anon_sym_RPAREN] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [anon_sym_AMP] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_when] = ACTIONS(10960),
    [anon_sym_elsif] = ACTIONS(10960),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_then] = ACTIONS(10960),
    [anon_sym_ensure] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10960),
    [anon_sym_COLON_COLON2] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10960),
    [anon_sym_PLUS_EQ] = ACTIONS(10960),
    [anon_sym_DASH_EQ] = ACTIONS(10960),
    [anon_sym_STAR_EQ] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_EQ] = ACTIONS(10960),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10960),
    [anon_sym_PERCENT_EQ] = ACTIONS(10960),
    [anon_sym_GT_GT_EQ] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10960),
    [anon_sym_CARET_EQ] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10962),
    [anon_sym_GT] = ACTIONS(10962),
    [anon_sym_GT_EQ] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10962),
    [anon_sym_PLUS] = ACTIONS(10962),
    [anon_sym_SLASH] = ACTIONS(10962),
    [anon_sym_PERCENT] = ACTIONS(10962),
    [sym_comment] = ACTIONS(87),
  },
  [8546] = {
    [sym__line_break] = ACTIONS(11007),
    [sym__heredoc_body_start] = ACTIONS(11007),
    [sym__binary_minus] = ACTIONS(11007),
    [sym__binary_star] = ACTIONS(11007),
    [ts_builtin_sym_end] = ACTIONS(11007),
    [anon_sym___END__] = ACTIONS(11007),
    [anon_sym_LBRACE] = ACTIONS(11007),
    [anon_sym_RBRACE] = ACTIONS(11007),
    [anon_sym_RPAREN] = ACTIONS(11007),
    [anon_sym_DOT] = ACTIONS(11009),
    [anon_sym_COMMA] = ACTIONS(11007),
    [anon_sym_PIPE] = ACTIONS(11009),
    [anon_sym_SEMI] = ACTIONS(11007),
    [anon_sym_STAR_STAR] = ACTIONS(11009),
    [anon_sym_AMP] = ACTIONS(11009),
    [anon_sym_EQ] = ACTIONS(11009),
    [anon_sym_LT] = ACTIONS(11009),
    [anon_sym_end] = ACTIONS(11007),
    [anon_sym_if] = ACTIONS(11007),
    [anon_sym_unless] = ACTIONS(11007),
    [anon_sym_while] = ACTIONS(11007),
    [anon_sym_until] = ACTIONS(11007),
    [anon_sym_rescue] = ACTIONS(11007),
    [anon_sym_do] = ACTIONS(11007),
    [anon_sym_when] = ACTIONS(11007),
    [anon_sym_elsif] = ACTIONS(11007),
    [anon_sym_else] = ACTIONS(11007),
    [anon_sym_then] = ACTIONS(11007),
    [anon_sym_ensure] = ACTIONS(11007),
    [anon_sym_EQ_GT] = ACTIONS(11007),
    [anon_sym_LBRACK] = ACTIONS(11007),
    [anon_sym_COLON_COLON2] = ACTIONS(11007),
    [anon_sym_AMP_DOT] = ACTIONS(11007),
    [anon_sym_PLUS_EQ] = ACTIONS(11007),
    [anon_sym_DASH_EQ] = ACTIONS(11007),
    [anon_sym_STAR_EQ] = ACTIONS(11007),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11007),
    [anon_sym_SLASH_EQ] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11007),
    [anon_sym_PIPE_EQ] = ACTIONS(11007),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11007),
    [anon_sym_AMP_EQ] = ACTIONS(11007),
    [anon_sym_PERCENT_EQ] = ACTIONS(11007),
    [anon_sym_GT_GT_EQ] = ACTIONS(11007),
    [anon_sym_LT_LT_EQ] = ACTIONS(11007),
    [anon_sym_CARET_EQ] = ACTIONS(11007),
    [anon_sym_QMARK] = ACTIONS(11007),
    [anon_sym_DOT_DOT] = ACTIONS(11009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11007),
    [anon_sym_and] = ACTIONS(11007),
    [anon_sym_or] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE] = ACTIONS(11009),
    [anon_sym_AMP_AMP] = ACTIONS(11009),
    [anon_sym_LT_LT] = ACTIONS(11009),
    [anon_sym_GT_GT] = ACTIONS(11009),
    [anon_sym_EQ_EQ] = ACTIONS(11009),
    [anon_sym_BANG_EQ] = ACTIONS(11007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11007),
    [anon_sym_LT_EQ_GT] = ACTIONS(11007),
    [anon_sym_EQ_TILDE] = ACTIONS(11007),
    [anon_sym_BANG_TILDE] = ACTIONS(11007),
    [anon_sym_LT_EQ] = ACTIONS(11009),
    [anon_sym_GT] = ACTIONS(11009),
    [anon_sym_GT_EQ] = ACTIONS(11007),
    [anon_sym_CARET] = ACTIONS(11009),
    [anon_sym_PLUS] = ACTIONS(11009),
    [anon_sym_SLASH] = ACTIONS(11009),
    [anon_sym_PERCENT] = ACTIONS(11009),
    [sym_comment] = ACTIONS(87),
  },
  [8547] = {
    [anon_sym_end] = ACTIONS(13346),
    [sym_comment] = ACTIONS(87),
  },
  [8548] = {
    [sym__line_break] = ACTIONS(13264),
    [sym__heredoc_body_start] = ACTIONS(13264),
    [sym__binary_minus] = ACTIONS(13264),
    [sym__binary_star] = ACTIONS(13264),
    [ts_builtin_sym_end] = ACTIONS(13264),
    [anon_sym___END__] = ACTIONS(13264),
    [anon_sym_LBRACE] = ACTIONS(13264),
    [anon_sym_RBRACE] = ACTIONS(13264),
    [anon_sym_RPAREN] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13266),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13266),
    [anon_sym_SEMI] = ACTIONS(13264),
    [anon_sym_STAR_STAR] = ACTIONS(13266),
    [anon_sym_AMP] = ACTIONS(13266),
    [anon_sym_EQ] = ACTIONS(13266),
    [anon_sym_LT] = ACTIONS(13266),
    [anon_sym_end] = ACTIONS(13264),
    [anon_sym_if] = ACTIONS(13264),
    [anon_sym_unless] = ACTIONS(13264),
    [anon_sym_while] = ACTIONS(13264),
    [anon_sym_until] = ACTIONS(13264),
    [anon_sym_rescue] = ACTIONS(13264),
    [anon_sym_do] = ACTIONS(13264),
    [anon_sym_when] = ACTIONS(13264),
    [anon_sym_elsif] = ACTIONS(13264),
    [anon_sym_else] = ACTIONS(13264),
    [anon_sym_then] = ACTIONS(13264),
    [anon_sym_ensure] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [anon_sym_PLUS_EQ] = ACTIONS(13264),
    [anon_sym_DASH_EQ] = ACTIONS(13264),
    [anon_sym_STAR_EQ] = ACTIONS(13264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13264),
    [anon_sym_SLASH_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13264),
    [anon_sym_AMP_EQ] = ACTIONS(13264),
    [anon_sym_PERCENT_EQ] = ACTIONS(13264),
    [anon_sym_GT_GT_EQ] = ACTIONS(13264),
    [anon_sym_LT_LT_EQ] = ACTIONS(13264),
    [anon_sym_CARET_EQ] = ACTIONS(13264),
    [anon_sym_QMARK] = ACTIONS(13264),
    [anon_sym_DOT_DOT] = ACTIONS(13266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13264),
    [anon_sym_and] = ACTIONS(13264),
    [anon_sym_or] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE] = ACTIONS(13266),
    [anon_sym_AMP_AMP] = ACTIONS(13266),
    [anon_sym_LT_LT] = ACTIONS(13266),
    [anon_sym_GT_GT] = ACTIONS(13266),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13264),
    [anon_sym_LT_EQ_GT] = ACTIONS(13264),
    [anon_sym_EQ_TILDE] = ACTIONS(13264),
    [anon_sym_BANG_TILDE] = ACTIONS(13264),
    [anon_sym_LT_EQ] = ACTIONS(13266),
    [anon_sym_GT] = ACTIONS(13266),
    [anon_sym_GT_EQ] = ACTIONS(13264),
    [anon_sym_CARET] = ACTIONS(13266),
    [anon_sym_PLUS] = ACTIONS(13266),
    [anon_sym_SLASH] = ACTIONS(13266),
    [anon_sym_PERCENT] = ACTIONS(13266),
    [sym_comment] = ACTIONS(87),
  },
  [8549] = {
    [anon_sym_end] = ACTIONS(13348),
    [sym_comment] = ACTIONS(87),
  },
  [8550] = {
    [sym__line_break] = ACTIONS(11020),
    [sym__heredoc_body_start] = ACTIONS(11020),
    [sym__binary_minus] = ACTIONS(11020),
    [sym__binary_star] = ACTIONS(11020),
    [ts_builtin_sym_end] = ACTIONS(11020),
    [anon_sym___END__] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_RBRACE] = ACTIONS(11020),
    [anon_sym_RPAREN] = ACTIONS(11020),
    [anon_sym_DOT] = ACTIONS(11022),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_PIPE] = ACTIONS(11022),
    [anon_sym_SEMI] = ACTIONS(11020),
    [anon_sym_STAR_STAR] = ACTIONS(11022),
    [anon_sym_AMP] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(11022),
    [anon_sym_LT] = ACTIONS(11022),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_unless] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [anon_sym_until] = ACTIONS(11020),
    [anon_sym_rescue] = ACTIONS(11020),
    [anon_sym_do] = ACTIONS(11020),
    [anon_sym_when] = ACTIONS(11020),
    [anon_sym_elsif] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_then] = ACTIONS(11020),
    [anon_sym_ensure] = ACTIONS(11020),
    [anon_sym_EQ_GT] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_COLON_COLON2] = ACTIONS(11020),
    [anon_sym_AMP_DOT] = ACTIONS(11020),
    [anon_sym_PLUS_EQ] = ACTIONS(11020),
    [anon_sym_DASH_EQ] = ACTIONS(11020),
    [anon_sym_STAR_EQ] = ACTIONS(11020),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11020),
    [anon_sym_SLASH_EQ] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11020),
    [anon_sym_PIPE_EQ] = ACTIONS(11020),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11020),
    [anon_sym_AMP_EQ] = ACTIONS(11020),
    [anon_sym_PERCENT_EQ] = ACTIONS(11020),
    [anon_sym_GT_GT_EQ] = ACTIONS(11020),
    [anon_sym_LT_LT_EQ] = ACTIONS(11020),
    [anon_sym_CARET_EQ] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_DOT_DOT] = ACTIONS(11022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_and] = ACTIONS(11020),
    [anon_sym_or] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE] = ACTIONS(11022),
    [anon_sym_AMP_AMP] = ACTIONS(11022),
    [anon_sym_LT_LT] = ACTIONS(11022),
    [anon_sym_GT_GT] = ACTIONS(11022),
    [anon_sym_EQ_EQ] = ACTIONS(11022),
    [anon_sym_BANG_EQ] = ACTIONS(11020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11020),
    [anon_sym_LT_EQ_GT] = ACTIONS(11020),
    [anon_sym_EQ_TILDE] = ACTIONS(11020),
    [anon_sym_BANG_TILDE] = ACTIONS(11020),
    [anon_sym_LT_EQ] = ACTIONS(11022),
    [anon_sym_GT] = ACTIONS(11022),
    [anon_sym_GT_EQ] = ACTIONS(11020),
    [anon_sym_CARET] = ACTIONS(11022),
    [anon_sym_PLUS] = ACTIONS(11022),
    [anon_sym_SLASH] = ACTIONS(11022),
    [anon_sym_PERCENT] = ACTIONS(11022),
    [sym_comment] = ACTIONS(87),
  },
  [8551] = {
    [anon_sym_end] = ACTIONS(13350),
    [sym_comment] = ACTIONS(87),
  },
  [8552] = {
    [sym__line_break] = ACTIONS(11466),
    [sym__heredoc_body_start] = ACTIONS(11466),
    [sym__binary_minus] = ACTIONS(11466),
    [sym__binary_star] = ACTIONS(11466),
    [ts_builtin_sym_end] = ACTIONS(11466),
    [anon_sym___END__] = ACTIONS(11466),
    [anon_sym_LBRACE] = ACTIONS(11466),
    [anon_sym_RBRACE] = ACTIONS(11466),
    [anon_sym_RPAREN] = ACTIONS(11466),
    [anon_sym_DOT] = ACTIONS(11468),
    [anon_sym_COMMA] = ACTIONS(11466),
    [anon_sym_PIPE] = ACTIONS(11468),
    [anon_sym_SEMI] = ACTIONS(11466),
    [anon_sym_STAR_STAR] = ACTIONS(11468),
    [anon_sym_AMP] = ACTIONS(11468),
    [anon_sym_EQ] = ACTIONS(11468),
    [anon_sym_LT] = ACTIONS(11468),
    [anon_sym_end] = ACTIONS(11466),
    [anon_sym_if] = ACTIONS(11466),
    [anon_sym_unless] = ACTIONS(11466),
    [anon_sym_while] = ACTIONS(11466),
    [anon_sym_until] = ACTIONS(11466),
    [anon_sym_rescue] = ACTIONS(11466),
    [anon_sym_do] = ACTIONS(11466),
    [anon_sym_when] = ACTIONS(11466),
    [anon_sym_elsif] = ACTIONS(11466),
    [anon_sym_else] = ACTIONS(11466),
    [anon_sym_then] = ACTIONS(11466),
    [anon_sym_ensure] = ACTIONS(11466),
    [anon_sym_EQ_GT] = ACTIONS(11466),
    [anon_sym_LBRACK] = ACTIONS(11466),
    [anon_sym_COLON_COLON2] = ACTIONS(11466),
    [anon_sym_AMP_DOT] = ACTIONS(11466),
    [anon_sym_PLUS_EQ] = ACTIONS(11466),
    [anon_sym_DASH_EQ] = ACTIONS(11466),
    [anon_sym_STAR_EQ] = ACTIONS(11466),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11466),
    [anon_sym_SLASH_EQ] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11466),
    [anon_sym_PIPE_EQ] = ACTIONS(11466),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11466),
    [anon_sym_AMP_EQ] = ACTIONS(11466),
    [anon_sym_PERCENT_EQ] = ACTIONS(11466),
    [anon_sym_GT_GT_EQ] = ACTIONS(11466),
    [anon_sym_LT_LT_EQ] = ACTIONS(11466),
    [anon_sym_CARET_EQ] = ACTIONS(11466),
    [anon_sym_QMARK] = ACTIONS(11466),
    [anon_sym_DOT_DOT] = ACTIONS(11468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11466),
    [anon_sym_and] = ACTIONS(11466),
    [anon_sym_or] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE] = ACTIONS(11468),
    [anon_sym_AMP_AMP] = ACTIONS(11468),
    [anon_sym_LT_LT] = ACTIONS(11468),
    [anon_sym_GT_GT] = ACTIONS(11468),
    [anon_sym_EQ_EQ] = ACTIONS(11468),
    [anon_sym_BANG_EQ] = ACTIONS(11466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11466),
    [anon_sym_LT_EQ_GT] = ACTIONS(11466),
    [anon_sym_EQ_TILDE] = ACTIONS(11466),
    [anon_sym_BANG_TILDE] = ACTIONS(11466),
    [anon_sym_LT_EQ] = ACTIONS(11468),
    [anon_sym_GT] = ACTIONS(11468),
    [anon_sym_GT_EQ] = ACTIONS(11466),
    [anon_sym_CARET] = ACTIONS(11468),
    [anon_sym_PLUS] = ACTIONS(11468),
    [anon_sym_SLASH] = ACTIONS(11468),
    [anon_sym_PERCENT] = ACTIONS(11468),
    [sym_comment] = ACTIONS(87),
  },
  [8553] = {
    [anon_sym_end] = ACTIONS(13352),
    [sym_comment] = ACTIONS(87),
  },
  [8554] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(2695),
    [sym__binary_star] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(11746),
    [anon_sym___END__] = ACTIONS(11746),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(2701),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(2707),
    [anon_sym_DOT_DOT] = ACTIONS(2709),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2711),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2713),
    [anon_sym_AMP_AMP] = ACTIONS(2713),
    [anon_sym_LT_LT] = ACTIONS(2715),
    [anon_sym_GT_GT] = ACTIONS(2715),
    [anon_sym_EQ_EQ] = ACTIONS(2713),
    [anon_sym_BANG_EQ] = ACTIONS(2717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2717),
    [anon_sym_EQ_TILDE] = ACTIONS(2717),
    [anon_sym_BANG_TILDE] = ACTIONS(2717),
    [anon_sym_LT_EQ] = ACTIONS(2705),
    [anon_sym_GT] = ACTIONS(2705),
    [anon_sym_GT_EQ] = ACTIONS(2719),
    [anon_sym_CARET] = ACTIONS(2699),
    [anon_sym_PLUS] = ACTIONS(2721),
    [anon_sym_SLASH] = ACTIONS(2701),
    [anon_sym_PERCENT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(87),
  },
  [8555] = {
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [ts_builtin_sym_end] = ACTIONS(11211),
    [anon_sym___END__] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_when] = ACTIONS(11211),
    [anon_sym_elsif] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [8556] = {
    [aux_sym_exceptions_repeat1] = STATE(8556),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [ts_builtin_sym_end] = ACTIONS(11211),
    [anon_sym___END__] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13354),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [8557] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9889),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1596),
    [sym_scope_resolution] = STATE(48),
    [sym_call] = STATE(48),
    [sym_method_call] = STATE(1596),
    [sym_assignment] = STATE(9889),
    [sym_operator_assignment] = STATE(9889),
    [sym_conditional] = STATE(9889),
    [sym_range] = STATE(9889),
    [sym_binary] = STATE(9889),
    [sym_unary] = STATE(9889),
    [sym_left_assignment_list] = STATE(1595),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1596),
    [sym__variable] = STATE(48),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1596),
    [sym_false] = STATE(1596),
    [sym_nil] = STATE(1596),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(876),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(1561),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_next] = ACTIONS(1565),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_defined_QMARK] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8558] = {
    [sym_heredoc_body] = STATE(9890),
    [aux_sym_call_repeat1] = STATE(9890),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [8559] = {
    [sym_heredoc_body] = STATE(9891),
    [aux_sym_call_repeat1] = STATE(9891),
    [aux_sym_argument_list_repeat1] = STATE(6409),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(6153),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [8560] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [8561] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8562] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [8563] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [8564] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [8565] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13357),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8566] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [8567] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(9617),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [8568] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [8569] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [8570] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(9617),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [8571] = {
    [aux_sym_exceptions_repeat1] = STATE(9894),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8572] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(9617),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [8573] = {
    [sym_string] = STATE(8573),
    [aux_sym_chained_string_repeat1] = STATE(8573),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [8574] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [8575] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [8576] = {
    [sym_heredoc_body] = STATE(8576),
    [aux_sym_call_repeat1] = STATE(8576),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8577] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(3768),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(3768),
    [sym_operator_assignment] = STATE(3768),
    [sym_conditional] = STATE(3768),
    [sym_range] = STATE(3768),
    [sym_binary] = STATE(3768),
    [sym_unary] = STATE(3768),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3771),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6109),
    [sym__splat_star] = ACTIONS(6111),
    [sym__unary_minus] = ACTIONS(2769),
    [sym__identifier_hash_key] = ACTIONS(6113),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11977),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(6115),
    [sym_identifier] = ACTIONS(6115),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8578] = {
    [sym_heredoc_body] = STATE(8576),
    [aux_sym_call_repeat1] = STATE(8576),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8579] = {
    [aux_sym_argument_list_repeat1] = STATE(8579),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13359),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [8580] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9895),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_assignment] = STATE(9895),
    [sym_operator_assignment] = STATE(9895),
    [sym_conditional] = STATE(9895),
    [sym_range] = STATE(9895),
    [sym_binary] = STATE(9895),
    [sym_unary] = STATE(9895),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8581] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [8582] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [8583] = {
    [sym_heredoc_body] = STATE(8583),
    [aux_sym_call_repeat1] = STATE(8583),
    [sym__heredoc_body_start] = ACTIONS(10154),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [8584] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(3789),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym__argument] = STATE(6822),
    [sym_splat_argument] = STATE(6822),
    [sym_hash_splat_argument] = STATE(6822),
    [sym_block_argument] = STATE(6822),
    [sym_assignment] = STATE(3789),
    [sym_operator_assignment] = STATE(3789),
    [sym_conditional] = STATE(3789),
    [sym_range] = STATE(3789),
    [sym_binary] = STATE(3789),
    [sym_unary] = STATE(3789),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3792),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6822),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6145),
    [sym__splat_star] = ACTIONS(6147),
    [sym__unary_minus] = ACTIONS(2857),
    [sym__identifier_hash_key] = ACTIONS(6149),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11981),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(6151),
    [sym_identifier] = ACTIONS(6151),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8585] = {
    [sym_heredoc_body] = STATE(8583),
    [aux_sym_call_repeat1] = STATE(8583),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [8586] = {
    [aux_sym_argument_list_repeat1] = STATE(8586),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13362),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [8587] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6410),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1619),
    [sym_scope_resolution] = STATE(1615),
    [sym_call] = STATE(1615),
    [sym_method_call] = STATE(1619),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(6410),
    [sym_operator_assignment] = STATE(6410),
    [sym_conditional] = STATE(6410),
    [sym_range] = STATE(6410),
    [sym_binary] = STATE(6410),
    [sym_unary] = STATE(6410),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(1618),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1619),
    [sym__variable] = STATE(1615),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1619),
    [sym_false] = STATE(1619),
    [sym_nil] = STATE(1619),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(3760),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(6111),
    [sym__unary_minus] = ACTIONS(2769),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2773),
    [anon_sym_yield] = ACTIONS(2775),
    [anon_sym_break] = ACTIONS(2777),
    [anon_sym_next] = ACTIONS(2779),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6105),
    [anon_sym_defined_QMARK] = ACTIONS(2781),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_BANG] = ACTIONS(2787),
    [anon_sym_TILDE] = ACTIONS(2787),
    [sym_constant] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2793),
    [sym_instance_variable] = ACTIONS(2791),
    [sym_class_variable] = ACTIONS(2791),
    [sym_global_variable] = ACTIONS(2791),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2793),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2793),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8588] = {
    [aux_sym_exceptions_repeat1] = STATE(9896),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13365),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8589] = {
    [sym__binary_minus] = ACTIONS(2817),
    [sym__binary_star] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(2821),
    [anon_sym_STAR_STAR] = ACTIONS(2819),
    [anon_sym_AMP] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_LT_LT] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2837),
    [anon_sym_EQ_EQ] = ACTIONS(2839),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ_GT] = ACTIONS(2835),
    [anon_sym_EQ_TILDE] = ACTIONS(2835),
    [anon_sym_BANG_TILDE] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2841),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2819),
    [anon_sym_PERCENT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(87),
  },
  [8590] = {
    [sym__simple_symbol] = ACTIONS(7608),
    [sym__string_start] = ACTIONS(7608),
    [sym__symbol_start] = ACTIONS(7608),
    [sym__subshell_start] = ACTIONS(7608),
    [sym__regex_start] = ACTIONS(7608),
    [sym__string_array_start] = ACTIONS(7608),
    [sym__symbol_array_start] = ACTIONS(7608),
    [sym_heredoc_beginning] = ACTIONS(7608),
    [sym__block_ampersand] = ACTIONS(7608),
    [sym__splat_star] = ACTIONS(7608),
    [sym__unary_minus] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [sym__identifier_hash_key] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_def] = ACTIONS(7610),
    [anon_sym_LPAREN] = ACTIONS(7610),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COLON_COLON] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR] = ACTIONS(7610),
    [anon_sym_STAR_STAR] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_class] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_module] = ACTIONS(7610),
    [anon_sym_return] = ACTIONS(7610),
    [anon_sym_yield] = ACTIONS(7610),
    [anon_sym_break] = ACTIONS(7610),
    [anon_sym_next] = ACTIONS(7610),
    [sym_redo] = ACTIONS(7610),
    [sym_retry] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7610),
    [anon_sym_unless] = ACTIONS(7610),
    [anon_sym_while] = ACTIONS(7610),
    [anon_sym_until] = ACTIONS(7610),
    [anon_sym_rescue] = ACTIONS(7610),
    [anon_sym_for] = ACTIONS(7610),
    [anon_sym_do] = ACTIONS(7610),
    [anon_sym_case] = ACTIONS(7610),
    [anon_sym_begin] = ACTIONS(7610),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_LPAREN2] = ACTIONS(7608),
    [anon_sym_PLUS_EQ] = ACTIONS(7608),
    [anon_sym_DASH_EQ] = ACTIONS(7608),
    [anon_sym_STAR_EQ] = ACTIONS(7608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7608),
    [anon_sym_SLASH_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7608),
    [anon_sym_AMP_EQ] = ACTIONS(7608),
    [anon_sym_PERCENT_EQ] = ACTIONS(7608),
    [anon_sym_GT_GT_EQ] = ACTIONS(7608),
    [anon_sym_LT_LT_EQ] = ACTIONS(7608),
    [anon_sym_CARET_EQ] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COLON2] = ACTIONS(7610),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7610),
    [anon_sym_or] = ACTIONS(7610),
    [anon_sym_PIPE_PIPE] = ACTIONS(7610),
    [anon_sym_AMP_AMP] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [anon_sym_defined_QMARK] = ACTIONS(7608),
    [anon_sym_not] = ACTIONS(7610),
    [anon_sym_BANG] = ACTIONS(7610),
    [anon_sym_TILDE] = ACTIONS(7608),
    [sym_constant] = ACTIONS(7610),
    [sym_identifier] = ACTIONS(7610),
    [sym_instance_variable] = ACTIONS(7608),
    [sym_class_variable] = ACTIONS(7608),
    [sym_global_variable] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7610),
    [sym_float] = ACTIONS(7610),
    [sym_complex] = ACTIONS(7608),
    [sym_super] = ACTIONS(7610),
    [anon_sym_true] = ACTIONS(7610),
    [anon_sym_TRUE] = ACTIONS(7610),
    [anon_sym_false] = ACTIONS(7610),
    [anon_sym_FALSE] = ACTIONS(7610),
    [sym_self] = ACTIONS(7610),
    [anon_sym_nil] = ACTIONS(7610),
    [anon_sym_NIL] = ACTIONS(7610),
    [sym_character] = ACTIONS(7608),
    [anon_sym_LBRACK2] = ACTIONS(7610),
    [anon_sym_DASH_GT] = ACTIONS(7608),
  },
  [8591] = {
    [anon_sym_RPAREN] = ACTIONS(13367),
    [sym_comment] = ACTIONS(87),
  },
  [8592] = {
    [sym__binary_minus] = ACTIONS(11825),
    [sym__binary_star] = ACTIONS(11825),
    [anon_sym_LBRACE] = ACTIONS(11825),
    [anon_sym_RBRACE] = ACTIONS(11825),
    [anon_sym_RPAREN] = ACTIONS(11825),
    [anon_sym_DOT] = ACTIONS(11827),
    [anon_sym_COMMA] = ACTIONS(11825),
    [anon_sym_PIPE] = ACTIONS(11827),
    [anon_sym_SEMI] = ACTIONS(11825),
    [anon_sym_STAR_STAR] = ACTIONS(11827),
    [anon_sym_AMP] = ACTIONS(11827),
    [anon_sym_EQ] = ACTIONS(11827),
    [anon_sym_LT] = ACTIONS(11827),
    [anon_sym_if] = ACTIONS(11825),
    [anon_sym_unless] = ACTIONS(11825),
    [anon_sym_while] = ACTIONS(11825),
    [anon_sym_until] = ACTIONS(11825),
    [anon_sym_rescue] = ACTIONS(11825),
    [anon_sym_do] = ACTIONS(11825),
    [anon_sym_LBRACK] = ACTIONS(11825),
    [anon_sym_COLON_COLON2] = ACTIONS(11825),
    [anon_sym_AMP_DOT] = ACTIONS(11825),
    [anon_sym_PLUS_EQ] = ACTIONS(11825),
    [anon_sym_DASH_EQ] = ACTIONS(11825),
    [anon_sym_STAR_EQ] = ACTIONS(11825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11825),
    [anon_sym_SLASH_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11825),
    [anon_sym_AMP_EQ] = ACTIONS(11825),
    [anon_sym_PERCENT_EQ] = ACTIONS(11825),
    [anon_sym_GT_GT_EQ] = ACTIONS(11825),
    [anon_sym_LT_LT_EQ] = ACTIONS(11825),
    [anon_sym_CARET_EQ] = ACTIONS(11825),
    [anon_sym_QMARK] = ACTIONS(11825),
    [anon_sym_COLON2] = ACTIONS(11827),
    [anon_sym_DOT_DOT] = ACTIONS(11827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11825),
    [anon_sym_and] = ACTIONS(11825),
    [anon_sym_or] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11827),
    [anon_sym_AMP_AMP] = ACTIONS(11827),
    [anon_sym_LT_LT] = ACTIONS(11827),
    [anon_sym_GT_GT] = ACTIONS(11827),
    [anon_sym_EQ_EQ] = ACTIONS(11827),
    [anon_sym_BANG_EQ] = ACTIONS(11825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11825),
    [anon_sym_LT_EQ_GT] = ACTIONS(11825),
    [anon_sym_EQ_TILDE] = ACTIONS(11825),
    [anon_sym_BANG_TILDE] = ACTIONS(11825),
    [anon_sym_LT_EQ] = ACTIONS(11827),
    [anon_sym_GT] = ACTIONS(11827),
    [anon_sym_GT_EQ] = ACTIONS(11825),
    [anon_sym_CARET] = ACTIONS(11827),
    [anon_sym_PLUS] = ACTIONS(11827),
    [anon_sym_SLASH] = ACTIONS(11827),
    [anon_sym_PERCENT] = ACTIONS(11827),
    [sym_comment] = ACTIONS(87),
  },
  [8593] = {
    [sym__string_start] = ACTIONS(2895),
    [sym__heredoc_body_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_unless] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_until] = ACTIONS(2895),
    [anon_sym_rescue] = ACTIONS(2895),
    [anon_sym_in] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_RBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2895),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON2] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [sym_comment] = ACTIONS(87),
  },
  [8594] = {
    [sym__heredoc_body_start] = ACTIONS(2907),
    [sym__binary_minus] = ACTIONS(2907),
    [sym__binary_star] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_RPAREN] = ACTIONS(2907),
    [anon_sym_DOT] = ACTIONS(2909),
    [anon_sym_COMMA] = ACTIONS(2907),
    [anon_sym_PIPE] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_STAR_STAR] = ACTIONS(2909),
    [anon_sym_AMP] = ACTIONS(2909),
    [anon_sym_EQ] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_unless] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_until] = ACTIONS(2907),
    [anon_sym_rescue] = ACTIONS(2907),
    [anon_sym_in] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_RBRACK] = ACTIONS(2907),
    [anon_sym_COLON_COLON2] = ACTIONS(2907),
    [anon_sym_AMP_DOT] = ACTIONS(2907),
    [anon_sym_PLUS_EQ] = ACTIONS(2907),
    [anon_sym_DASH_EQ] = ACTIONS(2907),
    [anon_sym_STAR_EQ] = ACTIONS(2907),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2907),
    [anon_sym_SLASH_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_PIPE_EQ] = ACTIONS(2907),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2907),
    [anon_sym_AMP_EQ] = ACTIONS(2907),
    [anon_sym_PERCENT_EQ] = ACTIONS(2907),
    [anon_sym_GT_GT_EQ] = ACTIONS(2907),
    [anon_sym_LT_LT_EQ] = ACTIONS(2907),
    [anon_sym_CARET_EQ] = ACTIONS(2907),
    [anon_sym_QMARK] = ACTIONS(2907),
    [anon_sym_COLON2] = ACTIONS(2909),
    [anon_sym_DOT_DOT] = ACTIONS(2909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2907),
    [anon_sym_and] = ACTIONS(2907),
    [anon_sym_or] = ACTIONS(2907),
    [anon_sym_PIPE_PIPE] = ACTIONS(2909),
    [anon_sym_AMP_AMP] = ACTIONS(2909),
    [anon_sym_LT_LT] = ACTIONS(2909),
    [anon_sym_GT_GT] = ACTIONS(2909),
    [anon_sym_EQ_EQ] = ACTIONS(2909),
    [anon_sym_BANG_EQ] = ACTIONS(2907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2907),
    [anon_sym_LT_EQ_GT] = ACTIONS(2907),
    [anon_sym_EQ_TILDE] = ACTIONS(2907),
    [anon_sym_BANG_TILDE] = ACTIONS(2907),
    [anon_sym_LT_EQ] = ACTIONS(2909),
    [anon_sym_GT] = ACTIONS(2909),
    [anon_sym_GT_EQ] = ACTIONS(2907),
    [anon_sym_CARET] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_PERCENT] = ACTIONS(2909),
    [sym_comment] = ACTIONS(87),
  },
  [8595] = {
    [sym__heredoc_body_start] = ACTIONS(2911),
    [sym__binary_minus] = ACTIONS(2911),
    [sym__binary_star] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_RPAREN] = ACTIONS(2911),
    [anon_sym_DOT] = ACTIONS(2913),
    [anon_sym_COMMA] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_STAR_STAR] = ACTIONS(2913),
    [anon_sym_AMP] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_unless] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_until] = ACTIONS(2911),
    [anon_sym_rescue] = ACTIONS(2911),
    [anon_sym_in] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_RBRACK] = ACTIONS(2911),
    [anon_sym_COLON_COLON2] = ACTIONS(2911),
    [anon_sym_AMP_DOT] = ACTIONS(2911),
    [anon_sym_PLUS_EQ] = ACTIONS(2911),
    [anon_sym_DASH_EQ] = ACTIONS(2911),
    [anon_sym_STAR_EQ] = ACTIONS(2911),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2911),
    [anon_sym_SLASH_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_PIPE_EQ] = ACTIONS(2911),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2911),
    [anon_sym_AMP_EQ] = ACTIONS(2911),
    [anon_sym_PERCENT_EQ] = ACTIONS(2911),
    [anon_sym_GT_GT_EQ] = ACTIONS(2911),
    [anon_sym_LT_LT_EQ] = ACTIONS(2911),
    [anon_sym_CARET_EQ] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_COLON2] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_LT_LT] = ACTIONS(2913),
    [anon_sym_GT_GT] = ACTIONS(2913),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2911),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2911),
    [anon_sym_LT_EQ_GT] = ACTIONS(2911),
    [anon_sym_EQ_TILDE] = ACTIONS(2911),
    [anon_sym_BANG_TILDE] = ACTIONS(2911),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2911),
    [anon_sym_CARET] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_PERCENT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(87),
  },
  [8596] = {
    [sym__heredoc_body_start] = ACTIONS(2915),
    [sym__binary_minus] = ACTIONS(2915),
    [sym__binary_star] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2915),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_RPAREN] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2917),
    [anon_sym_COMMA] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2915),
    [anon_sym_STAR_STAR] = ACTIONS(2917),
    [anon_sym_AMP] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_unless] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_until] = ACTIONS(2915),
    [anon_sym_rescue] = ACTIONS(2915),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2915),
    [anon_sym_RBRACK] = ACTIONS(2915),
    [anon_sym_COLON_COLON2] = ACTIONS(2915),
    [anon_sym_AMP_DOT] = ACTIONS(2915),
    [anon_sym_PLUS_EQ] = ACTIONS(2915),
    [anon_sym_DASH_EQ] = ACTIONS(2915),
    [anon_sym_STAR_EQ] = ACTIONS(2915),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2915),
    [anon_sym_SLASH_EQ] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2915),
    [anon_sym_PIPE_EQ] = ACTIONS(2915),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2915),
    [anon_sym_AMP_EQ] = ACTIONS(2915),
    [anon_sym_PERCENT_EQ] = ACTIONS(2915),
    [anon_sym_GT_GT_EQ] = ACTIONS(2915),
    [anon_sym_LT_LT_EQ] = ACTIONS(2915),
    [anon_sym_CARET_EQ] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_COLON2] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_LT_LT] = ACTIONS(2917),
    [anon_sym_GT_GT] = ACTIONS(2917),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2915),
    [anon_sym_LT_EQ_GT] = ACTIONS(2915),
    [anon_sym_EQ_TILDE] = ACTIONS(2915),
    [anon_sym_BANG_TILDE] = ACTIONS(2915),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2917),
    [anon_sym_PERCENT] = ACTIONS(2917),
    [sym_comment] = ACTIONS(87),
  },
  [8597] = {
    [sym__heredoc_body_start] = ACTIONS(2921),
    [sym__binary_minus] = ACTIONS(2921),
    [sym__binary_star] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_DOT] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_PIPE] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_STAR_STAR] = ACTIONS(2923),
    [anon_sym_AMP] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_LT] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2921),
    [anon_sym_unless] = ACTIONS(2921),
    [anon_sym_while] = ACTIONS(2921),
    [anon_sym_until] = ACTIONS(2921),
    [anon_sym_rescue] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2921),
    [anon_sym_do] = ACTIONS(2921),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_RBRACK] = ACTIONS(2921),
    [anon_sym_COLON_COLON2] = ACTIONS(2921),
    [anon_sym_AMP_DOT] = ACTIONS(2921),
    [anon_sym_PLUS_EQ] = ACTIONS(2921),
    [anon_sym_DASH_EQ] = ACTIONS(2921),
    [anon_sym_STAR_EQ] = ACTIONS(2921),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2921),
    [anon_sym_SLASH_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_PIPE_EQ] = ACTIONS(2921),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2921),
    [anon_sym_AMP_EQ] = ACTIONS(2921),
    [anon_sym_PERCENT_EQ] = ACTIONS(2921),
    [anon_sym_GT_GT_EQ] = ACTIONS(2921),
    [anon_sym_LT_LT_EQ] = ACTIONS(2921),
    [anon_sym_CARET_EQ] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_COLON2] = ACTIONS(2923),
    [anon_sym_DOT_DOT] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_and] = ACTIONS(2921),
    [anon_sym_or] = ACTIONS(2921),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_LT_LT] = ACTIONS(2923),
    [anon_sym_GT_GT] = ACTIONS(2923),
    [anon_sym_EQ_EQ] = ACTIONS(2923),
    [anon_sym_BANG_EQ] = ACTIONS(2921),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2921),
    [anon_sym_LT_EQ_GT] = ACTIONS(2921),
    [anon_sym_EQ_TILDE] = ACTIONS(2921),
    [anon_sym_BANG_TILDE] = ACTIONS(2921),
    [anon_sym_LT_EQ] = ACTIONS(2923),
    [anon_sym_GT] = ACTIONS(2923),
    [anon_sym_GT_EQ] = ACTIONS(2921),
    [anon_sym_CARET] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [sym_comment] = ACTIONS(87),
  },
  [8598] = {
    [sym__string_end] = ACTIONS(13369),
    [sym_comment] = ACTIONS(87),
  },
  [8599] = {
    [aux_sym_string_array_repeat1] = STATE(9901),
    [sym__string_end] = ACTIONS(13371),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13373),
  },
  [8600] = {
    [sym__heredoc_body_start] = ACTIONS(2931),
    [sym__binary_minus] = ACTIONS(2931),
    [sym__binary_star] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2931),
    [anon_sym_RBRACE] = ACTIONS(2931),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_STAR_STAR] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_unless] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_until] = ACTIONS(2931),
    [anon_sym_rescue] = ACTIONS(2931),
    [anon_sym_in] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2931),
    [anon_sym_RBRACK] = ACTIONS(2931),
    [anon_sym_COLON_COLON2] = ACTIONS(2931),
    [anon_sym_AMP_DOT] = ACTIONS(2931),
    [anon_sym_PLUS_EQ] = ACTIONS(2931),
    [anon_sym_DASH_EQ] = ACTIONS(2931),
    [anon_sym_STAR_EQ] = ACTIONS(2931),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2931),
    [anon_sym_SLASH_EQ] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2931),
    [anon_sym_PIPE_EQ] = ACTIONS(2931),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2931),
    [anon_sym_AMP_EQ] = ACTIONS(2931),
    [anon_sym_PERCENT_EQ] = ACTIONS(2931),
    [anon_sym_GT_GT_EQ] = ACTIONS(2931),
    [anon_sym_LT_LT_EQ] = ACTIONS(2931),
    [anon_sym_CARET_EQ] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2931),
    [anon_sym_COLON2] = ACTIONS(2933),
    [anon_sym_DOT_DOT] = ACTIONS(2933),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2931),
    [anon_sym_and] = ACTIONS(2931),
    [anon_sym_or] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_EQ_EQ] = ACTIONS(2933),
    [anon_sym_BANG_EQ] = ACTIONS(2931),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2931),
    [anon_sym_LT_EQ_GT] = ACTIONS(2931),
    [anon_sym_EQ_TILDE] = ACTIONS(2931),
    [anon_sym_BANG_TILDE] = ACTIONS(2931),
    [anon_sym_LT_EQ] = ACTIONS(2933),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_GT_EQ] = ACTIONS(2931),
    [anon_sym_CARET] = ACTIONS(2933),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2933),
    [sym_comment] = ACTIONS(87),
  },
  [8601] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13375),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8602] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(13375),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13377),
  },
  [8603] = {
    [sym__heredoc_body_start] = ACTIONS(2950),
    [sym__binary_minus] = ACTIONS(2950),
    [sym__binary_star] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2950),
    [anon_sym_RPAREN] = ACTIONS(2950),
    [anon_sym_DOT] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2950),
    [anon_sym_PIPE] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2950),
    [anon_sym_STAR_STAR] = ACTIONS(2952),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_EQ] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2952),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_unless] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_until] = ACTIONS(2950),
    [anon_sym_rescue] = ACTIONS(2950),
    [anon_sym_in] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2950),
    [anon_sym_RBRACK] = ACTIONS(2950),
    [anon_sym_COLON_COLON2] = ACTIONS(2950),
    [anon_sym_AMP_DOT] = ACTIONS(2950),
    [anon_sym_PLUS_EQ] = ACTIONS(2950),
    [anon_sym_DASH_EQ] = ACTIONS(2950),
    [anon_sym_STAR_EQ] = ACTIONS(2950),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2950),
    [anon_sym_SLASH_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_PIPE_EQ] = ACTIONS(2950),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2950),
    [anon_sym_AMP_EQ] = ACTIONS(2950),
    [anon_sym_PERCENT_EQ] = ACTIONS(2950),
    [anon_sym_GT_GT_EQ] = ACTIONS(2950),
    [anon_sym_LT_LT_EQ] = ACTIONS(2950),
    [anon_sym_CARET_EQ] = ACTIONS(2950),
    [anon_sym_QMARK] = ACTIONS(2950),
    [anon_sym_COLON2] = ACTIONS(2952),
    [anon_sym_DOT_DOT] = ACTIONS(2952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2950),
    [anon_sym_and] = ACTIONS(2950),
    [anon_sym_or] = ACTIONS(2950),
    [anon_sym_PIPE_PIPE] = ACTIONS(2952),
    [anon_sym_AMP_AMP] = ACTIONS(2952),
    [anon_sym_LT_LT] = ACTIONS(2952),
    [anon_sym_GT_GT] = ACTIONS(2952),
    [anon_sym_EQ_EQ] = ACTIONS(2952),
    [anon_sym_BANG_EQ] = ACTIONS(2950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2950),
    [anon_sym_LT_EQ_GT] = ACTIONS(2950),
    [anon_sym_EQ_TILDE] = ACTIONS(2950),
    [anon_sym_BANG_TILDE] = ACTIONS(2950),
    [anon_sym_LT_EQ] = ACTIONS(2952),
    [anon_sym_GT] = ACTIONS(2952),
    [anon_sym_GT_EQ] = ACTIONS(2950),
    [anon_sym_CARET] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2952),
    [anon_sym_PERCENT] = ACTIONS(2952),
    [sym_comment] = ACTIONS(87),
  },
  [8604] = {
    [sym__string_end] = ACTIONS(13379),
    [sym_comment] = ACTIONS(87),
  },
  [8605] = {
    [aux_sym_symbol_array_repeat1] = STATE(9907),
    [sym__string_end] = ACTIONS(13381),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13383),
  },
  [8606] = {
    [sym__heredoc_body_start] = ACTIONS(2960),
    [sym__binary_minus] = ACTIONS(2960),
    [sym__binary_star] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_RPAREN] = ACTIONS(2960),
    [anon_sym_DOT] = ACTIONS(2962),
    [anon_sym_COMMA] = ACTIONS(2960),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_STAR_STAR] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2962),
    [anon_sym_EQ] = ACTIONS(2962),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_unless] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_until] = ACTIONS(2960),
    [anon_sym_rescue] = ACTIONS(2960),
    [anon_sym_in] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_RBRACK] = ACTIONS(2960),
    [anon_sym_COLON_COLON2] = ACTIONS(2960),
    [anon_sym_AMP_DOT] = ACTIONS(2960),
    [anon_sym_PLUS_EQ] = ACTIONS(2960),
    [anon_sym_DASH_EQ] = ACTIONS(2960),
    [anon_sym_STAR_EQ] = ACTIONS(2960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2960),
    [anon_sym_SLASH_EQ] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2960),
    [anon_sym_PIPE_EQ] = ACTIONS(2960),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2960),
    [anon_sym_AMP_EQ] = ACTIONS(2960),
    [anon_sym_PERCENT_EQ] = ACTIONS(2960),
    [anon_sym_GT_GT_EQ] = ACTIONS(2960),
    [anon_sym_LT_LT_EQ] = ACTIONS(2960),
    [anon_sym_CARET_EQ] = ACTIONS(2960),
    [anon_sym_QMARK] = ACTIONS(2960),
    [anon_sym_COLON2] = ACTIONS(2962),
    [anon_sym_DOT_DOT] = ACTIONS(2962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2960),
    [anon_sym_and] = ACTIONS(2960),
    [anon_sym_or] = ACTIONS(2960),
    [anon_sym_PIPE_PIPE] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_LT_LT] = ACTIONS(2962),
    [anon_sym_GT_GT] = ACTIONS(2962),
    [anon_sym_EQ_EQ] = ACTIONS(2962),
    [anon_sym_BANG_EQ] = ACTIONS(2960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2960),
    [anon_sym_LT_EQ_GT] = ACTIONS(2960),
    [anon_sym_EQ_TILDE] = ACTIONS(2960),
    [anon_sym_BANG_TILDE] = ACTIONS(2960),
    [anon_sym_LT_EQ] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_GT_EQ] = ACTIONS(2960),
    [anon_sym_CARET] = ACTIONS(2962),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2962),
    [anon_sym_PERCENT] = ACTIONS(2962),
    [sym_comment] = ACTIONS(87),
  },
  [8607] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13385),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8608] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(13385),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13387),
  },
  [8609] = {
    [sym__heredoc_body_start] = ACTIONS(3440),
    [sym__binary_minus] = ACTIONS(3440),
    [sym__binary_star] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3440),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3442),
    [anon_sym_COMMA] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_STAR_STAR] = ACTIONS(3442),
    [anon_sym_AMP] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_LT] = ACTIONS(3442),
    [anon_sym_if] = ACTIONS(3440),
    [anon_sym_unless] = ACTIONS(3440),
    [anon_sym_while] = ACTIONS(3440),
    [anon_sym_until] = ACTIONS(3440),
    [anon_sym_rescue] = ACTIONS(3440),
    [anon_sym_in] = ACTIONS(3440),
    [anon_sym_do] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3440),
    [anon_sym_RBRACK] = ACTIONS(3440),
    [anon_sym_COLON_COLON2] = ACTIONS(3440),
    [anon_sym_AMP_DOT] = ACTIONS(3440),
    [anon_sym_PLUS_EQ] = ACTIONS(3440),
    [anon_sym_DASH_EQ] = ACTIONS(3440),
    [anon_sym_STAR_EQ] = ACTIONS(3440),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3440),
    [anon_sym_SLASH_EQ] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3440),
    [anon_sym_PIPE_EQ] = ACTIONS(3440),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3440),
    [anon_sym_AMP_EQ] = ACTIONS(3440),
    [anon_sym_PERCENT_EQ] = ACTIONS(3440),
    [anon_sym_GT_GT_EQ] = ACTIONS(3440),
    [anon_sym_LT_LT_EQ] = ACTIONS(3440),
    [anon_sym_CARET_EQ] = ACTIONS(3440),
    [anon_sym_QMARK] = ACTIONS(3440),
    [anon_sym_COLON2] = ACTIONS(3442),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3440),
    [anon_sym_and] = ACTIONS(3440),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_LT_LT] = ACTIONS(3442),
    [anon_sym_GT_GT] = ACTIONS(3442),
    [anon_sym_EQ_EQ] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3440),
    [anon_sym_LT_EQ_GT] = ACTIONS(3440),
    [anon_sym_EQ_TILDE] = ACTIONS(3440),
    [anon_sym_BANG_TILDE] = ACTIONS(3440),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3440),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3442),
    [anon_sym_SLASH] = ACTIONS(3442),
    [anon_sym_PERCENT] = ACTIONS(3442),
    [sym_comment] = ACTIONS(87),
  },
  [8610] = {
    [anon_sym_RBRACE] = ACTIONS(13389),
    [sym_comment] = ACTIONS(87),
  },
  [8611] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(13391),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3492),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [8612] = {
    [sym__method_rest] = STATE(9912),
    [sym_operator] = STATE(6444),
    [sym__method_name] = STATE(6444),
    [sym_setter] = STATE(6444),
    [sym_symbol] = STATE(6444),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(13393),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(13393),
    [sym_class_variable] = ACTIONS(13393),
    [sym_global_variable] = ACTIONS(13393),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [8613] = {
    [sym__statements] = STATE(6463),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(6464),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(6465),
    [sym_rescue] = STATE(6466),
    [sym__body_statement] = STATE(9913),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13395),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8614] = {
    [sym__heredoc_body_start] = ACTIONS(3670),
    [sym__binary_minus] = ACTIONS(3670),
    [sym__binary_star] = ACTIONS(3670),
    [anon_sym_LBRACE] = ACTIONS(3670),
    [anon_sym_RBRACE] = ACTIONS(3670),
    [anon_sym_RPAREN] = ACTIONS(3670),
    [anon_sym_DOT] = ACTIONS(3672),
    [anon_sym_COMMA] = ACTIONS(3670),
    [anon_sym_PIPE] = ACTIONS(3672),
    [anon_sym_SEMI] = ACTIONS(3670),
    [anon_sym_STAR_STAR] = ACTIONS(3672),
    [anon_sym_AMP] = ACTIONS(3672),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_LT] = ACTIONS(3672),
    [anon_sym_if] = ACTIONS(3670),
    [anon_sym_unless] = ACTIONS(3670),
    [anon_sym_while] = ACTIONS(3670),
    [anon_sym_until] = ACTIONS(3670),
    [anon_sym_rescue] = ACTIONS(3670),
    [anon_sym_in] = ACTIONS(3670),
    [anon_sym_do] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3670),
    [anon_sym_RBRACK] = ACTIONS(3670),
    [anon_sym_COLON_COLON2] = ACTIONS(3670),
    [anon_sym_AMP_DOT] = ACTIONS(3670),
    [anon_sym_PLUS_EQ] = ACTIONS(3670),
    [anon_sym_DASH_EQ] = ACTIONS(3670),
    [anon_sym_STAR_EQ] = ACTIONS(3670),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3670),
    [anon_sym_SLASH_EQ] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3670),
    [anon_sym_PIPE_EQ] = ACTIONS(3670),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3670),
    [anon_sym_AMP_EQ] = ACTIONS(3670),
    [anon_sym_PERCENT_EQ] = ACTIONS(3670),
    [anon_sym_GT_GT_EQ] = ACTIONS(3670),
    [anon_sym_LT_LT_EQ] = ACTIONS(3670),
    [anon_sym_CARET_EQ] = ACTIONS(3670),
    [anon_sym_QMARK] = ACTIONS(3670),
    [anon_sym_COLON2] = ACTIONS(3672),
    [anon_sym_DOT_DOT] = ACTIONS(3672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3670),
    [anon_sym_and] = ACTIONS(3670),
    [anon_sym_or] = ACTIONS(3670),
    [anon_sym_PIPE_PIPE] = ACTIONS(3672),
    [anon_sym_AMP_AMP] = ACTIONS(3672),
    [anon_sym_LT_LT] = ACTIONS(3672),
    [anon_sym_GT_GT] = ACTIONS(3672),
    [anon_sym_EQ_EQ] = ACTIONS(3672),
    [anon_sym_BANG_EQ] = ACTIONS(3670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3670),
    [anon_sym_LT_EQ_GT] = ACTIONS(3670),
    [anon_sym_EQ_TILDE] = ACTIONS(3670),
    [anon_sym_BANG_TILDE] = ACTIONS(3670),
    [anon_sym_LT_EQ] = ACTIONS(3672),
    [anon_sym_GT] = ACTIONS(3672),
    [anon_sym_GT_EQ] = ACTIONS(3670),
    [anon_sym_CARET] = ACTIONS(3672),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_SLASH] = ACTIONS(3672),
    [anon_sym_PERCENT] = ACTIONS(3672),
    [sym_comment] = ACTIONS(87),
  },
  [8615] = {
    [sym_heredoc_body] = STATE(9914),
    [sym__terminator] = STATE(9914),
    [sym__line_break] = ACTIONS(13397),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym__binary_minus] = ACTIONS(2005),
    [sym__binary_star] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(13397),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_and] = ACTIONS(2021),
    [anon_sym_or] = ACTIONS(2021),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2025),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_EQ_EQ] = ACTIONS(2027),
    [anon_sym_BANG_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_LT_EQ_GT] = ACTIONS(2023),
    [anon_sym_EQ_TILDE] = ACTIONS(2023),
    [anon_sym_BANG_TILDE] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [anon_sym_PERCENT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(87),
  },
  [8616] = {
    [sym_heredoc_body] = STATE(9915),
    [sym__terminator] = STATE(9915),
    [sym__line_break] = ACTIONS(13399),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(13399),
    [sym_comment] = ACTIONS(87),
  },
  [8617] = {
    [sym__statements] = STATE(6463),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(6464),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(6465),
    [sym_rescue] = STATE(6466),
    [sym__body_statement] = STATE(9916),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13401),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8618] = {
    [sym__heredoc_body_start] = ACTIONS(4068),
    [sym__binary_minus] = ACTIONS(4068),
    [sym__binary_star] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4068),
    [anon_sym_RPAREN] = ACTIONS(4068),
    [anon_sym_DOT] = ACTIONS(4070),
    [anon_sym_COMMA] = ACTIONS(4068),
    [anon_sym_PIPE] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_STAR_STAR] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_unless] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_until] = ACTIONS(4068),
    [anon_sym_rescue] = ACTIONS(4068),
    [anon_sym_in] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_RBRACK] = ACTIONS(4068),
    [anon_sym_COLON_COLON2] = ACTIONS(4068),
    [anon_sym_AMP_DOT] = ACTIONS(4068),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(4068),
    [anon_sym_COLON2] = ACTIONS(4070),
    [anon_sym_DOT_DOT] = ACTIONS(4070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4068),
    [anon_sym_and] = ACTIONS(4068),
    [anon_sym_or] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_LT_LT] = ACTIONS(4070),
    [anon_sym_GT_GT] = ACTIONS(4070),
    [anon_sym_EQ_EQ] = ACTIONS(4070),
    [anon_sym_BANG_EQ] = ACTIONS(4068),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4068),
    [anon_sym_LT_EQ_GT] = ACTIONS(4068),
    [anon_sym_EQ_TILDE] = ACTIONS(4068),
    [anon_sym_BANG_TILDE] = ACTIONS(4068),
    [anon_sym_LT_EQ] = ACTIONS(4070),
    [anon_sym_GT] = ACTIONS(4070),
    [anon_sym_GT_EQ] = ACTIONS(4068),
    [anon_sym_CARET] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(4070),
    [anon_sym_PERCENT] = ACTIONS(4070),
    [sym_comment] = ACTIONS(87),
  },
  [8619] = {
    [sym__statements] = STATE(6463),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(6464),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(6465),
    [sym_rescue] = STATE(6466),
    [sym__body_statement] = STATE(9917),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13403),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8620] = {
    [sym__statements] = STATE(9919),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(9920),
    [sym_else] = STATE(9920),
    [sym__if_tail] = STATE(9920),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(9921),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__terminator] = STATE(9921),
    [sym__line_break] = ACTIONS(13405),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13407),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8621] = {
    [sym__statements] = STATE(9923),
    [sym__top_level_statement] = STATE(2704),
    [sym_begin_block] = STATE(2704),
    [sym_end_block] = STATE(2704),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(9924),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13409),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8622] = {
    [sym__statements] = STATE(9926),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13411),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8623] = {
    [sym__statements] = STATE(9928),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13413),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8624] = {
    [sym__do] = STATE(9929),
    [sym_heredoc_body] = STATE(9929),
    [sym__terminator] = STATE(9929),
    [sym__line_break] = ACTIONS(13415),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(13415),
    [anon_sym_do] = ACTIONS(13415),
    [sym_comment] = ACTIONS(87),
  },
  [8625] = {
    [sym_when] = STATE(9930),
    [aux_sym_case_repeat1] = STATE(9931),
    [anon_sym_SEMI] = ACTIONS(13417),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8626] = {
    [anon_sym_end] = ACTIONS(13419),
    [sym_comment] = ACTIONS(87),
  },
  [8627] = {
    [sym_when] = STATE(9930),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [8628] = {
    [sym__heredoc_body_start] = ACTIONS(5264),
    [sym__binary_minus] = ACTIONS(5264),
    [sym__binary_star] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5264),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_RPAREN] = ACTIONS(5264),
    [anon_sym_DOT] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5264),
    [anon_sym_PIPE] = ACTIONS(5266),
    [anon_sym_SEMI] = ACTIONS(5264),
    [anon_sym_STAR_STAR] = ACTIONS(5266),
    [anon_sym_AMP] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5266),
    [anon_sym_if] = ACTIONS(5264),
    [anon_sym_unless] = ACTIONS(5264),
    [anon_sym_while] = ACTIONS(5264),
    [anon_sym_until] = ACTIONS(5264),
    [anon_sym_rescue] = ACTIONS(5264),
    [anon_sym_in] = ACTIONS(5264),
    [anon_sym_do] = ACTIONS(5264),
    [anon_sym_LBRACK] = ACTIONS(5264),
    [anon_sym_RBRACK] = ACTIONS(5264),
    [anon_sym_COLON_COLON2] = ACTIONS(5264),
    [anon_sym_AMP_DOT] = ACTIONS(5264),
    [anon_sym_PLUS_EQ] = ACTIONS(5264),
    [anon_sym_DASH_EQ] = ACTIONS(5264),
    [anon_sym_STAR_EQ] = ACTIONS(5264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5264),
    [anon_sym_SLASH_EQ] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5264),
    [anon_sym_PIPE_EQ] = ACTIONS(5264),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5264),
    [anon_sym_AMP_EQ] = ACTIONS(5264),
    [anon_sym_PERCENT_EQ] = ACTIONS(5264),
    [anon_sym_GT_GT_EQ] = ACTIONS(5264),
    [anon_sym_LT_LT_EQ] = ACTIONS(5264),
    [anon_sym_CARET_EQ] = ACTIONS(5264),
    [anon_sym_QMARK] = ACTIONS(5264),
    [anon_sym_COLON2] = ACTIONS(5266),
    [anon_sym_DOT_DOT] = ACTIONS(5266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5264),
    [anon_sym_and] = ACTIONS(5264),
    [anon_sym_or] = ACTIONS(5264),
    [anon_sym_PIPE_PIPE] = ACTIONS(5266),
    [anon_sym_AMP_AMP] = ACTIONS(5266),
    [anon_sym_LT_LT] = ACTIONS(5266),
    [anon_sym_GT_GT] = ACTIONS(5266),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5264),
    [anon_sym_LT_EQ_GT] = ACTIONS(5264),
    [anon_sym_EQ_TILDE] = ACTIONS(5264),
    [anon_sym_BANG_TILDE] = ACTIONS(5264),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_GT] = ACTIONS(5266),
    [anon_sym_GT_EQ] = ACTIONS(5264),
    [anon_sym_CARET] = ACTIONS(5266),
    [anon_sym_PLUS] = ACTIONS(5266),
    [anon_sym_SLASH] = ACTIONS(5266),
    [anon_sym_PERCENT] = ACTIONS(5266),
    [sym_comment] = ACTIONS(87),
  },
  [8629] = {
    [sym_ensure] = STATE(9934),
    [anon_sym_end] = ACTIONS(13421),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [8630] = {
    [anon_sym_end] = ACTIONS(13421),
    [sym_comment] = ACTIONS(87),
  },
  [8631] = {
    [sym_else] = STATE(9935),
    [sym_ensure] = STATE(9934),
    [anon_sym_end] = ACTIONS(13421),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [8632] = {
    [sym__heredoc_body_start] = ACTIONS(5350),
    [sym__binary_minus] = ACTIONS(5350),
    [sym__binary_star] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5350),
    [anon_sym_RBRACE] = ACTIONS(5350),
    [anon_sym_RPAREN] = ACTIONS(5350),
    [anon_sym_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5350),
    [anon_sym_PIPE] = ACTIONS(5352),
    [anon_sym_SEMI] = ACTIONS(5350),
    [anon_sym_STAR_STAR] = ACTIONS(5352),
    [anon_sym_AMP] = ACTIONS(5352),
    [anon_sym_EQ] = ACTIONS(5352),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_if] = ACTIONS(5350),
    [anon_sym_unless] = ACTIONS(5350),
    [anon_sym_while] = ACTIONS(5350),
    [anon_sym_until] = ACTIONS(5350),
    [anon_sym_rescue] = ACTIONS(5350),
    [anon_sym_in] = ACTIONS(5350),
    [anon_sym_do] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_RBRACK] = ACTIONS(5350),
    [anon_sym_COLON_COLON2] = ACTIONS(5350),
    [anon_sym_AMP_DOT] = ACTIONS(5350),
    [anon_sym_PLUS_EQ] = ACTIONS(5350),
    [anon_sym_DASH_EQ] = ACTIONS(5350),
    [anon_sym_STAR_EQ] = ACTIONS(5350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5350),
    [anon_sym_SLASH_EQ] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5350),
    [anon_sym_PIPE_EQ] = ACTIONS(5350),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5350),
    [anon_sym_AMP_EQ] = ACTIONS(5350),
    [anon_sym_PERCENT_EQ] = ACTIONS(5350),
    [anon_sym_GT_GT_EQ] = ACTIONS(5350),
    [anon_sym_LT_LT_EQ] = ACTIONS(5350),
    [anon_sym_CARET_EQ] = ACTIONS(5350),
    [anon_sym_QMARK] = ACTIONS(5350),
    [anon_sym_COLON2] = ACTIONS(5352),
    [anon_sym_DOT_DOT] = ACTIONS(5352),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5352),
    [anon_sym_AMP_AMP] = ACTIONS(5352),
    [anon_sym_LT_LT] = ACTIONS(5352),
    [anon_sym_GT_GT] = ACTIONS(5352),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5350),
    [anon_sym_LT_EQ_GT] = ACTIONS(5350),
    [anon_sym_EQ_TILDE] = ACTIONS(5350),
    [anon_sym_BANG_TILDE] = ACTIONS(5350),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5352),
    [anon_sym_PLUS] = ACTIONS(5352),
    [anon_sym_SLASH] = ACTIONS(5352),
    [anon_sym_PERCENT] = ACTIONS(5352),
    [sym_comment] = ACTIONS(87),
  },
  [8633] = {
    [sym__heredoc_body_start] = ACTIONS(5582),
    [sym__binary_minus] = ACTIONS(5582),
    [sym__binary_star] = ACTIONS(5582),
    [anon_sym_LBRACE] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_STAR_STAR] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_EQ] = ACTIONS(5584),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_if] = ACTIONS(5582),
    [anon_sym_unless] = ACTIONS(5582),
    [anon_sym_while] = ACTIONS(5582),
    [anon_sym_until] = ACTIONS(5582),
    [anon_sym_rescue] = ACTIONS(5582),
    [anon_sym_in] = ACTIONS(5582),
    [anon_sym_do] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_COLON_COLON2] = ACTIONS(5582),
    [anon_sym_AMP_DOT] = ACTIONS(5582),
    [anon_sym_PLUS_EQ] = ACTIONS(5582),
    [anon_sym_DASH_EQ] = ACTIONS(5582),
    [anon_sym_STAR_EQ] = ACTIONS(5582),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5582),
    [anon_sym_SLASH_EQ] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5582),
    [anon_sym_PIPE_EQ] = ACTIONS(5582),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5582),
    [anon_sym_AMP_EQ] = ACTIONS(5582),
    [anon_sym_PERCENT_EQ] = ACTIONS(5582),
    [anon_sym_GT_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_LT_EQ] = ACTIONS(5582),
    [anon_sym_CARET_EQ] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5582),
    [anon_sym_COLON2] = ACTIONS(5584),
    [anon_sym_DOT_DOT] = ACTIONS(5584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5584),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_EQ_EQ] = ACTIONS(5584),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ_GT] = ACTIONS(5582),
    [anon_sym_EQ_TILDE] = ACTIONS(5582),
    [anon_sym_BANG_TILDE] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5584),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5584),
    [sym_comment] = ACTIONS(87),
  },
  [8634] = {
    [anon_sym_RBRACK] = ACTIONS(13423),
    [sym_comment] = ACTIONS(87),
  },
  [8635] = {
    [sym__heredoc_body_start] = ACTIONS(5666),
    [sym__binary_minus] = ACTIONS(5666),
    [sym__binary_star] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_STAR_STAR] = ACTIONS(5668),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_EQ] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_if] = ACTIONS(5666),
    [anon_sym_unless] = ACTIONS(5666),
    [anon_sym_while] = ACTIONS(5666),
    [anon_sym_until] = ACTIONS(5666),
    [anon_sym_rescue] = ACTIONS(5666),
    [anon_sym_in] = ACTIONS(5666),
    [anon_sym_do] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_RBRACK] = ACTIONS(5666),
    [anon_sym_COLON_COLON2] = ACTIONS(5666),
    [anon_sym_AMP_DOT] = ACTIONS(5666),
    [anon_sym_PLUS_EQ] = ACTIONS(5666),
    [anon_sym_DASH_EQ] = ACTIONS(5666),
    [anon_sym_STAR_EQ] = ACTIONS(5666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5666),
    [anon_sym_SLASH_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5666),
    [anon_sym_AMP_EQ] = ACTIONS(5666),
    [anon_sym_PERCENT_EQ] = ACTIONS(5666),
    [anon_sym_GT_GT_EQ] = ACTIONS(5666),
    [anon_sym_LT_LT_EQ] = ACTIONS(5666),
    [anon_sym_CARET_EQ] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_COLON2] = ACTIONS(5668),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_and] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_LT_LT] = ACTIONS(5668),
    [anon_sym_GT_GT] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_EQ_TILDE] = ACTIONS(5666),
    [anon_sym_BANG_TILDE] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_PLUS] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [sym_comment] = ACTIONS(87),
  },
  [8636] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [8637] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [8638] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [8639] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [8640] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [8641] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13425),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8642] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [8643] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(9719),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [8644] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [8645] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [8646] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(9719),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [8647] = {
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_in] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_COLON2] = ACTIONS(6062),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [8648] = {
    [aux_sym_exceptions_repeat1] = STATE(9939),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [8649] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(9719),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [8650] = {
    [sym_string] = STATE(8650),
    [aux_sym_chained_string_repeat1] = STATE(8650),
    [sym__string_start] = ACTIONS(13427),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [8651] = {
    [sym__binary_minus] = ACTIONS(11655),
    [sym__binary_star] = ACTIONS(11655),
    [anon_sym_LBRACE] = ACTIONS(11655),
    [anon_sym_RBRACE] = ACTIONS(11655),
    [anon_sym_RPAREN] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11657),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11657),
    [anon_sym_SEMI] = ACTIONS(11655),
    [anon_sym_STAR_STAR] = ACTIONS(11657),
    [anon_sym_AMP] = ACTIONS(11657),
    [anon_sym_EQ] = ACTIONS(11657),
    [anon_sym_LT] = ACTIONS(11657),
    [anon_sym_if] = ACTIONS(11655),
    [anon_sym_unless] = ACTIONS(11655),
    [anon_sym_while] = ACTIONS(11655),
    [anon_sym_until] = ACTIONS(11655),
    [anon_sym_rescue] = ACTIONS(11655),
    [anon_sym_do] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [anon_sym_PLUS_EQ] = ACTIONS(11655),
    [anon_sym_DASH_EQ] = ACTIONS(11655),
    [anon_sym_STAR_EQ] = ACTIONS(11655),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11655),
    [anon_sym_SLASH_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11655),
    [anon_sym_AMP_EQ] = ACTIONS(11655),
    [anon_sym_PERCENT_EQ] = ACTIONS(11655),
    [anon_sym_GT_GT_EQ] = ACTIONS(11655),
    [anon_sym_LT_LT_EQ] = ACTIONS(11655),
    [anon_sym_CARET_EQ] = ACTIONS(11655),
    [anon_sym_QMARK] = ACTIONS(11655),
    [anon_sym_COLON2] = ACTIONS(11657),
    [anon_sym_DOT_DOT] = ACTIONS(11657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11655),
    [anon_sym_and] = ACTIONS(11655),
    [anon_sym_or] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE] = ACTIONS(11657),
    [anon_sym_AMP_AMP] = ACTIONS(11657),
    [anon_sym_LT_LT] = ACTIONS(11657),
    [anon_sym_GT_GT] = ACTIONS(11657),
    [anon_sym_EQ_EQ] = ACTIONS(11657),
    [anon_sym_BANG_EQ] = ACTIONS(11655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11655),
    [anon_sym_LT_EQ_GT] = ACTIONS(11655),
    [anon_sym_EQ_TILDE] = ACTIONS(11655),
    [anon_sym_BANG_TILDE] = ACTIONS(11655),
    [anon_sym_LT_EQ] = ACTIONS(11657),
    [anon_sym_GT] = ACTIONS(11657),
    [anon_sym_GT_EQ] = ACTIONS(11655),
    [anon_sym_CARET] = ACTIONS(11657),
    [anon_sym_PLUS] = ACTIONS(11657),
    [anon_sym_SLASH] = ACTIONS(11657),
    [anon_sym_PERCENT] = ACTIONS(11657),
    [sym_comment] = ACTIONS(87),
  },
  [8652] = {
    [sym__binary_minus] = ACTIONS(11680),
    [sym__binary_star] = ACTIONS(11680),
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RBRACE] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11682),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11682),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_STAR_STAR] = ACTIONS(11682),
    [anon_sym_AMP] = ACTIONS(11682),
    [anon_sym_EQ] = ACTIONS(11682),
    [anon_sym_LT] = ACTIONS(11682),
    [anon_sym_if] = ACTIONS(11680),
    [anon_sym_unless] = ACTIONS(11680),
    [anon_sym_while] = ACTIONS(11680),
    [anon_sym_until] = ACTIONS(11680),
    [anon_sym_rescue] = ACTIONS(11680),
    [anon_sym_do] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [anon_sym_PLUS_EQ] = ACTIONS(11680),
    [anon_sym_DASH_EQ] = ACTIONS(11680),
    [anon_sym_STAR_EQ] = ACTIONS(11680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11680),
    [anon_sym_SLASH_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11680),
    [anon_sym_AMP_EQ] = ACTIONS(11680),
    [anon_sym_PERCENT_EQ] = ACTIONS(11680),
    [anon_sym_GT_GT_EQ] = ACTIONS(11680),
    [anon_sym_LT_LT_EQ] = ACTIONS(11680),
    [anon_sym_CARET_EQ] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_COLON2] = ACTIONS(11682),
    [anon_sym_DOT_DOT] = ACTIONS(11682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_and] = ACTIONS(11680),
    [anon_sym_or] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE] = ACTIONS(11682),
    [anon_sym_AMP_AMP] = ACTIONS(11682),
    [anon_sym_LT_LT] = ACTIONS(11682),
    [anon_sym_GT_GT] = ACTIONS(11682),
    [anon_sym_EQ_EQ] = ACTIONS(11682),
    [anon_sym_BANG_EQ] = ACTIONS(11680),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11680),
    [anon_sym_LT_EQ_GT] = ACTIONS(11680),
    [anon_sym_EQ_TILDE] = ACTIONS(11680),
    [anon_sym_BANG_TILDE] = ACTIONS(11680),
    [anon_sym_LT_EQ] = ACTIONS(11682),
    [anon_sym_GT] = ACTIONS(11682),
    [anon_sym_GT_EQ] = ACTIONS(11680),
    [anon_sym_CARET] = ACTIONS(11682),
    [anon_sym_PLUS] = ACTIONS(11682),
    [anon_sym_SLASH] = ACTIONS(11682),
    [anon_sym_PERCENT] = ACTIONS(11682),
    [sym_comment] = ACTIONS(87),
  },
  [8653] = {
    [anon_sym_end] = ACTIONS(13430),
    [sym_comment] = ACTIONS(87),
  },
  [8654] = {
    [sym__statements] = STATE(9941),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13432),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8655] = {
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR_STAR] = ACTIONS(10570),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10568),
    [anon_sym_unless] = ACTIONS(10568),
    [anon_sym_while] = ACTIONS(10568),
    [anon_sym_until] = ACTIONS(10568),
    [anon_sym_rescue] = ACTIONS(10568),
    [anon_sym_in] = ACTIONS(10568),
    [anon_sym_do] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_RBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_PLUS_EQ] = ACTIONS(10568),
    [anon_sym_DASH_EQ] = ACTIONS(10568),
    [anon_sym_STAR_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10568),
    [anon_sym_SLASH_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10568),
    [anon_sym_AMP_EQ] = ACTIONS(10568),
    [anon_sym_PERCENT_EQ] = ACTIONS(10568),
    [anon_sym_GT_GT_EQ] = ACTIONS(10568),
    [anon_sym_LT_LT_EQ] = ACTIONS(10568),
    [anon_sym_CARET_EQ] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10568),
    [anon_sym_COLON2] = ACTIONS(10570),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10568),
    [anon_sym_or] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE] = ACTIONS(10570),
    [anon_sym_AMP_AMP] = ACTIONS(10570),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10570),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_SLASH] = ACTIONS(10570),
    [anon_sym_PERCENT] = ACTIONS(10570),
    [sym_comment] = ACTIONS(87),
  },
  [8656] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9942),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_assignment] = STATE(9942),
    [sym_operator_assignment] = STATE(9942),
    [sym_conditional] = STATE(9942),
    [sym_range] = STATE(9942),
    [sym_binary] = STATE(9942),
    [sym_unary] = STATE(9942),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8657] = {
    [sym__heredoc_body_start] = ACTIONS(6547),
    [sym__binary_minus] = ACTIONS(6547),
    [sym__binary_star] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_DOT] = ACTIONS(8423),
    [anon_sym_COMMA] = ACTIONS(6547),
    [anon_sym_PIPE] = ACTIONS(8423),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym_STAR_STAR] = ACTIONS(8423),
    [anon_sym_AMP] = ACTIONS(8423),
    [anon_sym_EQ] = ACTIONS(8423),
    [anon_sym_LT] = ACTIONS(8423),
    [anon_sym_if] = ACTIONS(6547),
    [anon_sym_unless] = ACTIONS(6547),
    [anon_sym_while] = ACTIONS(6547),
    [anon_sym_until] = ACTIONS(6547),
    [anon_sym_rescue] = ACTIONS(6547),
    [anon_sym_in] = ACTIONS(6547),
    [anon_sym_do] = ACTIONS(6547),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_RBRACK] = ACTIONS(6547),
    [anon_sym_COLON_COLON2] = ACTIONS(6547),
    [anon_sym_AMP_DOT] = ACTIONS(6547),
    [anon_sym_PLUS_EQ] = ACTIONS(6547),
    [anon_sym_DASH_EQ] = ACTIONS(6547),
    [anon_sym_STAR_EQ] = ACTIONS(6547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6547),
    [anon_sym_SLASH_EQ] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6547),
    [anon_sym_PIPE_EQ] = ACTIONS(6547),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6547),
    [anon_sym_AMP_EQ] = ACTIONS(6547),
    [anon_sym_PERCENT_EQ] = ACTIONS(6547),
    [anon_sym_GT_GT_EQ] = ACTIONS(6547),
    [anon_sym_LT_LT_EQ] = ACTIONS(6547),
    [anon_sym_CARET_EQ] = ACTIONS(6547),
    [anon_sym_QMARK] = ACTIONS(6547),
    [anon_sym_COLON2] = ACTIONS(8423),
    [anon_sym_DOT_DOT] = ACTIONS(8423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6547),
    [anon_sym_and] = ACTIONS(6547),
    [anon_sym_or] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE] = ACTIONS(8423),
    [anon_sym_AMP_AMP] = ACTIONS(8423),
    [anon_sym_LT_LT] = ACTIONS(8423),
    [anon_sym_GT_GT] = ACTIONS(8423),
    [anon_sym_EQ_EQ] = ACTIONS(8423),
    [anon_sym_BANG_EQ] = ACTIONS(6547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6547),
    [anon_sym_LT_EQ_GT] = ACTIONS(6547),
    [anon_sym_EQ_TILDE] = ACTIONS(6547),
    [anon_sym_BANG_TILDE] = ACTIONS(6547),
    [anon_sym_LT_EQ] = ACTIONS(8423),
    [anon_sym_GT] = ACTIONS(8423),
    [anon_sym_GT_EQ] = ACTIONS(6547),
    [anon_sym_CARET] = ACTIONS(8423),
    [anon_sym_PLUS] = ACTIONS(8423),
    [anon_sym_SLASH] = ACTIONS(8423),
    [anon_sym_PERCENT] = ACTIONS(8423),
    [sym_comment] = ACTIONS(87),
  },
  [8658] = {
    [sym__heredoc_body_start] = ACTIONS(10596),
    [sym__binary_minus] = ACTIONS(10596),
    [sym__binary_star] = ACTIONS(10596),
    [anon_sym_LBRACE] = ACTIONS(10596),
    [anon_sym_RBRACE] = ACTIONS(10596),
    [anon_sym_RPAREN] = ACTIONS(10596),
    [anon_sym_DOT] = ACTIONS(10598),
    [anon_sym_COMMA] = ACTIONS(10596),
    [anon_sym_PIPE] = ACTIONS(10598),
    [anon_sym_SEMI] = ACTIONS(10596),
    [anon_sym_STAR_STAR] = ACTIONS(10598),
    [anon_sym_AMP] = ACTIONS(10598),
    [anon_sym_EQ] = ACTIONS(10598),
    [anon_sym_LT] = ACTIONS(10598),
    [anon_sym_if] = ACTIONS(10596),
    [anon_sym_unless] = ACTIONS(10596),
    [anon_sym_while] = ACTIONS(10596),
    [anon_sym_until] = ACTIONS(10596),
    [anon_sym_rescue] = ACTIONS(10596),
    [anon_sym_in] = ACTIONS(10596),
    [anon_sym_do] = ACTIONS(10596),
    [anon_sym_LBRACK] = ACTIONS(10596),
    [anon_sym_RBRACK] = ACTIONS(10596),
    [anon_sym_COLON_COLON2] = ACTIONS(10596),
    [anon_sym_AMP_DOT] = ACTIONS(10596),
    [anon_sym_PLUS_EQ] = ACTIONS(10596),
    [anon_sym_DASH_EQ] = ACTIONS(10596),
    [anon_sym_STAR_EQ] = ACTIONS(10596),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10596),
    [anon_sym_SLASH_EQ] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10596),
    [anon_sym_PIPE_EQ] = ACTIONS(10596),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10596),
    [anon_sym_AMP_EQ] = ACTIONS(10596),
    [anon_sym_PERCENT_EQ] = ACTIONS(10596),
    [anon_sym_GT_GT_EQ] = ACTIONS(10596),
    [anon_sym_LT_LT_EQ] = ACTIONS(10596),
    [anon_sym_CARET_EQ] = ACTIONS(10596),
    [anon_sym_QMARK] = ACTIONS(10596),
    [anon_sym_COLON2] = ACTIONS(10598),
    [anon_sym_DOT_DOT] = ACTIONS(10598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10596),
    [anon_sym_and] = ACTIONS(10596),
    [anon_sym_or] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE] = ACTIONS(10598),
    [anon_sym_AMP_AMP] = ACTIONS(10598),
    [anon_sym_LT_LT] = ACTIONS(10598),
    [anon_sym_GT_GT] = ACTIONS(10598),
    [anon_sym_EQ_EQ] = ACTIONS(10598),
    [anon_sym_BANG_EQ] = ACTIONS(10596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10596),
    [anon_sym_LT_EQ_GT] = ACTIONS(10596),
    [anon_sym_EQ_TILDE] = ACTIONS(10596),
    [anon_sym_BANG_TILDE] = ACTIONS(10596),
    [anon_sym_LT_EQ] = ACTIONS(10598),
    [anon_sym_GT] = ACTIONS(10598),
    [anon_sym_GT_EQ] = ACTIONS(10596),
    [anon_sym_CARET] = ACTIONS(10598),
    [anon_sym_PLUS] = ACTIONS(10598),
    [anon_sym_SLASH] = ACTIONS(10598),
    [anon_sym_PERCENT] = ACTIONS(10598),
    [sym_comment] = ACTIONS(87),
  },
  [8659] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6518),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1667),
    [sym_scope_resolution] = STATE(1661),
    [sym_call] = STATE(1661),
    [sym_method_call] = STATE(1667),
    [sym_splat_argument] = STATE(8821),
    [sym_assignment] = STATE(6518),
    [sym_operator_assignment] = STATE(6518),
    [sym_conditional] = STATE(6518),
    [sym_range] = STATE(6518),
    [sym_binary] = STATE(6518),
    [sym_unary] = STATE(6518),
    [sym__arg_or_splat_arg] = STATE(8821),
    [sym_left_assignment_list] = STATE(1666),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1667),
    [sym__variable] = STATE(1661),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1667),
    [sym_false] = STATE(1667),
    [sym_nil] = STATE(1667),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(3864),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(6147),
    [sym__unary_minus] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2865),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_next] = ACTIONS(2869),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6255),
    [anon_sym_defined_QMARK] = ACTIONS(2875),
    [anon_sym_not] = ACTIONS(2877),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [sym_constant] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2887),
    [sym_instance_variable] = ACTIONS(2885),
    [sym_class_variable] = ACTIONS(2885),
    [sym_global_variable] = ACTIONS(2885),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(2887),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2887),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8660] = {
    [aux_sym_exceptions_repeat1] = STATE(9943),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13434),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [8661] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [8662] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8663] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(9765),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [8664] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [8665] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9763),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(9765),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9783),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [8666] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13436),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8667] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9763),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(9765),
    [anon_sym_LT] = ACTIONS(9767),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(9771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9773),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(9775),
    [anon_sym_AMP_AMP] = ACTIONS(9775),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_BANG_EQ] = ACTIONS(9775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9775),
    [anon_sym_LT_EQ_GT] = ACTIONS(9775),
    [anon_sym_EQ_TILDE] = ACTIONS(9775),
    [anon_sym_BANG_TILDE] = ACTIONS(9775),
    [anon_sym_LT_EQ] = ACTIONS(9767),
    [anon_sym_GT] = ACTIONS(9767),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9783),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [8668] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9763),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(9765),
    [anon_sym_LT] = ACTIONS(9767),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(9769),
    [anon_sym_DOT_DOT] = ACTIONS(9771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9773),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(9775),
    [anon_sym_AMP_AMP] = ACTIONS(9775),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_BANG_EQ] = ACTIONS(9775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9775),
    [anon_sym_LT_EQ_GT] = ACTIONS(9775),
    [anon_sym_EQ_TILDE] = ACTIONS(9775),
    [anon_sym_BANG_TILDE] = ACTIONS(9775),
    [anon_sym_LT_EQ] = ACTIONS(9767),
    [anon_sym_GT] = ACTIONS(9767),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9783),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [8669] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9763),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(9765),
    [anon_sym_LT] = ACTIONS(9767),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_BANG_EQ] = ACTIONS(9775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9775),
    [anon_sym_LT_EQ_GT] = ACTIONS(9775),
    [anon_sym_EQ_TILDE] = ACTIONS(9775),
    [anon_sym_BANG_TILDE] = ACTIONS(9775),
    [anon_sym_LT_EQ] = ACTIONS(9767),
    [anon_sym_GT] = ACTIONS(9767),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9783),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [8670] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [8671] = {
    [aux_sym_exceptions_repeat1] = STATE(8671),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13438),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [8672] = {
    [aux_sym_exceptions_repeat1] = STATE(6536),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8673] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9763),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(9765),
    [anon_sym_LT] = ACTIONS(9767),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(9769),
    [anon_sym_DOT_DOT] = ACTIONS(9771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9773),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9775),
    [anon_sym_AMP_AMP] = ACTIONS(9775),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_BANG_EQ] = ACTIONS(9775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9775),
    [anon_sym_LT_EQ_GT] = ACTIONS(9775),
    [anon_sym_EQ_TILDE] = ACTIONS(9775),
    [anon_sym_BANG_TILDE] = ACTIONS(9775),
    [anon_sym_LT_EQ] = ACTIONS(9767),
    [anon_sym_GT] = ACTIONS(9767),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9783),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [8674] = {
    [sym_string] = STATE(8674),
    [aux_sym_chained_string_repeat1] = STATE(8674),
    [sym__string_start] = ACTIONS(6891),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [8675] = {
    [sym_heredoc_body] = STATE(9945),
    [aux_sym_call_repeat1] = STATE(9945),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [8676] = {
    [sym_heredoc_body] = STATE(9946),
    [aux_sym_call_repeat1] = STATE(9946),
    [aux_sym_argument_list_repeat1] = STATE(6576),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [8677] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [8678] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8679] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [8680] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [8681] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [8682] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13441),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8683] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [8684] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(9823),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [8685] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [8686] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [8687] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(9823),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [8688] = {
    [aux_sym_exceptions_repeat1] = STATE(9949),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8689] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(9823),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [8690] = {
    [sym_string] = STATE(8690),
    [aux_sym_chained_string_repeat1] = STATE(8690),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [8691] = {
    [sym_heredoc_body] = STATE(8691),
    [aux_sym_call_repeat1] = STATE(8691),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8692] = {
    [sym_heredoc_body] = STATE(8691),
    [aux_sym_call_repeat1] = STATE(8691),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8693] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9950),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_assignment] = STATE(9950),
    [sym_operator_assignment] = STATE(9950),
    [sym_conditional] = STATE(9950),
    [sym_range] = STATE(9950),
    [sym_binary] = STATE(9950),
    [sym_unary] = STATE(9950),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8694] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(6577),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(1706),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(1706),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(6577),
    [sym_operator_assignment] = STATE(6577),
    [sym_conditional] = STATE(6577),
    [sym_range] = STATE(6577),
    [sym_binary] = STATE(6577),
    [sym_unary] = STATE(6577),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(1705),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1706),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(1706),
    [sym_false] = STATE(1706),
    [sym_nil] = STATE(1706),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(5930),
    [sym__unary_minus] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6401),
    [anon_sym_defined_QMARK] = ACTIONS(2988),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2994),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8695] = {
    [aux_sym_exceptions_repeat1] = STATE(9951),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13443),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8696] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(3014),
    [sym__binary_star] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3028),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_LT_LT] = ACTIONS(3034),
    [anon_sym_GT_GT] = ACTIONS(3034),
    [anon_sym_EQ_EQ] = ACTIONS(3036),
    [anon_sym_BANG_EQ] = ACTIONS(3032),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3032),
    [anon_sym_LT_EQ_GT] = ACTIONS(3032),
    [anon_sym_EQ_TILDE] = ACTIONS(3032),
    [anon_sym_BANG_TILDE] = ACTIONS(3032),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_GT] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3016),
    [sym_comment] = ACTIONS(87),
  },
  [8697] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [8698] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [8699] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [8700] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [8701] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [8702] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13445),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8703] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [8704] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(9864),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [8705] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [8706] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [8707] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(9864),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [8708] = {
    [aux_sym_exceptions_repeat1] = STATE(9954),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [8709] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(9864),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [8710] = {
    [sym_string] = STATE(8710),
    [aux_sym_chained_string_repeat1] = STATE(8710),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [8711] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9955),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_assignment] = STATE(9955),
    [sym_operator_assignment] = STATE(9955),
    [sym_conditional] = STATE(9955),
    [sym_range] = STATE(9955),
    [sym_binary] = STATE(9955),
    [sym_unary] = STATE(9955),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8712] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(6615),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(1745),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1745),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(6615),
    [sym_operator_assignment] = STATE(6615),
    [sym_conditional] = STATE(6615),
    [sym_range] = STATE(6615),
    [sym_binary] = STATE(6615),
    [sym_unary] = STATE(6615),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(1744),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1745),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(1745),
    [sym_false] = STATE(1745),
    [sym_nil] = STATE(1745),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(3989),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(5968),
    [sym__unary_minus] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3052),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_next] = ACTIONS(3056),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(6469),
    [anon_sym_defined_QMARK] = ACTIONS(3058),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_TILDE] = ACTIONS(3064),
    [sym_constant] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3070),
    [sym_instance_variable] = ACTIONS(3068),
    [sym_class_variable] = ACTIONS(3068),
    [sym_global_variable] = ACTIONS(3068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(3070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [8713] = {
    [aux_sym_exceptions_repeat1] = STATE(9956),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13447),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [8714] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [8715] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8716] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(9894),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [8717] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [8718] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9892),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(9894),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9912),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [8719] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13449),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8720] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9892),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(9894),
    [anon_sym_LT] = ACTIONS(9896),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(9900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9902),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(9904),
    [anon_sym_AMP_AMP] = ACTIONS(9904),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(9908),
    [anon_sym_BANG_EQ] = ACTIONS(9904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9904),
    [anon_sym_LT_EQ_GT] = ACTIONS(9904),
    [anon_sym_EQ_TILDE] = ACTIONS(9904),
    [anon_sym_BANG_TILDE] = ACTIONS(9904),
    [anon_sym_LT_EQ] = ACTIONS(9896),
    [anon_sym_GT] = ACTIONS(9896),
    [anon_sym_GT_EQ] = ACTIONS(9910),
    [anon_sym_CARET] = ACTIONS(9912),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [8721] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9892),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(9894),
    [anon_sym_LT] = ACTIONS(9896),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DOT_DOT] = ACTIONS(9900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9902),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(9904),
    [anon_sym_AMP_AMP] = ACTIONS(9904),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(9908),
    [anon_sym_BANG_EQ] = ACTIONS(9904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9904),
    [anon_sym_LT_EQ_GT] = ACTIONS(9904),
    [anon_sym_EQ_TILDE] = ACTIONS(9904),
    [anon_sym_BANG_TILDE] = ACTIONS(9904),
    [anon_sym_LT_EQ] = ACTIONS(9896),
    [anon_sym_GT] = ACTIONS(9896),
    [anon_sym_GT_EQ] = ACTIONS(9910),
    [anon_sym_CARET] = ACTIONS(9912),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [8722] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9892),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(9894),
    [anon_sym_LT] = ACTIONS(9896),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(9908),
    [anon_sym_BANG_EQ] = ACTIONS(9904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9904),
    [anon_sym_LT_EQ_GT] = ACTIONS(9904),
    [anon_sym_EQ_TILDE] = ACTIONS(9904),
    [anon_sym_BANG_TILDE] = ACTIONS(9904),
    [anon_sym_LT_EQ] = ACTIONS(9896),
    [anon_sym_GT] = ACTIONS(9896),
    [anon_sym_GT_EQ] = ACTIONS(9910),
    [anon_sym_CARET] = ACTIONS(9912),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [8723] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [8724] = {
    [aux_sym_exceptions_repeat1] = STATE(8724),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13451),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [8725] = {
    [aux_sym_exceptions_repeat1] = STATE(6633),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8726] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9892),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(9894),
    [anon_sym_LT] = ACTIONS(9896),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DOT_DOT] = ACTIONS(9900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9902),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9904),
    [anon_sym_AMP_AMP] = ACTIONS(9904),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(9908),
    [anon_sym_BANG_EQ] = ACTIONS(9904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9904),
    [anon_sym_LT_EQ_GT] = ACTIONS(9904),
    [anon_sym_EQ_TILDE] = ACTIONS(9904),
    [anon_sym_BANG_TILDE] = ACTIONS(9904),
    [anon_sym_LT_EQ] = ACTIONS(9896),
    [anon_sym_GT] = ACTIONS(9896),
    [anon_sym_GT_EQ] = ACTIONS(9910),
    [anon_sym_CARET] = ACTIONS(9912),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [8727] = {
    [sym__binary_minus] = ACTIONS(12069),
    [sym__binary_star] = ACTIONS(12069),
    [anon_sym_LBRACE] = ACTIONS(12069),
    [anon_sym_RBRACE] = ACTIONS(12069),
    [anon_sym_RPAREN] = ACTIONS(12069),
    [anon_sym_DOT] = ACTIONS(12071),
    [anon_sym_COMMA] = ACTIONS(12069),
    [anon_sym_PIPE] = ACTIONS(12071),
    [anon_sym_SEMI] = ACTIONS(12069),
    [anon_sym_STAR_STAR] = ACTIONS(12069),
    [anon_sym_AMP] = ACTIONS(12071),
    [anon_sym_LT] = ACTIONS(12071),
    [anon_sym_if] = ACTIONS(12069),
    [anon_sym_unless] = ACTIONS(12069),
    [anon_sym_while] = ACTIONS(12069),
    [anon_sym_until] = ACTIONS(12069),
    [anon_sym_rescue] = ACTIONS(12069),
    [anon_sym_do] = ACTIONS(12069),
    [anon_sym_EQ_GT] = ACTIONS(12069),
    [anon_sym_LBRACK] = ACTIONS(12069),
    [anon_sym_COLON_COLON2] = ACTIONS(12069),
    [anon_sym_AMP_DOT] = ACTIONS(12069),
    [anon_sym_QMARK] = ACTIONS(12069),
    [anon_sym_COLON2] = ACTIONS(12071),
    [anon_sym_DOT_DOT] = ACTIONS(12071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12069),
    [anon_sym_and] = ACTIONS(12069),
    [anon_sym_or] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE] = ACTIONS(12069),
    [anon_sym_AMP_AMP] = ACTIONS(12069),
    [anon_sym_LT_LT] = ACTIONS(12069),
    [anon_sym_GT_GT] = ACTIONS(12069),
    [anon_sym_EQ_EQ] = ACTIONS(12071),
    [anon_sym_BANG_EQ] = ACTIONS(12069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12069),
    [anon_sym_LT_EQ_GT] = ACTIONS(12069),
    [anon_sym_EQ_TILDE] = ACTIONS(12069),
    [anon_sym_BANG_TILDE] = ACTIONS(12069),
    [anon_sym_LT_EQ] = ACTIONS(12071),
    [anon_sym_GT] = ACTIONS(12071),
    [anon_sym_GT_EQ] = ACTIONS(12069),
    [anon_sym_CARET] = ACTIONS(12069),
    [anon_sym_PLUS] = ACTIONS(12069),
    [anon_sym_SLASH] = ACTIONS(12069),
    [anon_sym_PERCENT] = ACTIONS(12069),
    [sym_comment] = ACTIONS(87),
  },
  [8728] = {
    [sym__binary_minus] = ACTIONS(12073),
    [sym__binary_star] = ACTIONS(12073),
    [anon_sym_LBRACE] = ACTIONS(12073),
    [anon_sym_RBRACE] = ACTIONS(12073),
    [anon_sym_RPAREN] = ACTIONS(12073),
    [anon_sym_DOT] = ACTIONS(12075),
    [anon_sym_COMMA] = ACTIONS(12073),
    [anon_sym_PIPE] = ACTIONS(12075),
    [anon_sym_SEMI] = ACTIONS(12073),
    [anon_sym_STAR_STAR] = ACTIONS(12073),
    [anon_sym_AMP] = ACTIONS(12075),
    [anon_sym_LT] = ACTIONS(12075),
    [anon_sym_if] = ACTIONS(12073),
    [anon_sym_unless] = ACTIONS(12073),
    [anon_sym_while] = ACTIONS(12073),
    [anon_sym_until] = ACTIONS(12073),
    [anon_sym_rescue] = ACTIONS(12073),
    [anon_sym_do] = ACTIONS(12073),
    [anon_sym_EQ_GT] = ACTIONS(12073),
    [anon_sym_LBRACK] = ACTIONS(12073),
    [anon_sym_COLON_COLON2] = ACTIONS(12073),
    [anon_sym_AMP_DOT] = ACTIONS(12073),
    [anon_sym_QMARK] = ACTIONS(12073),
    [anon_sym_COLON2] = ACTIONS(12075),
    [anon_sym_DOT_DOT] = ACTIONS(12075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12073),
    [anon_sym_and] = ACTIONS(12073),
    [anon_sym_or] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE] = ACTIONS(12073),
    [anon_sym_AMP_AMP] = ACTIONS(12073),
    [anon_sym_LT_LT] = ACTIONS(12073),
    [anon_sym_GT_GT] = ACTIONS(12073),
    [anon_sym_EQ_EQ] = ACTIONS(12075),
    [anon_sym_BANG_EQ] = ACTIONS(12073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12073),
    [anon_sym_LT_EQ_GT] = ACTIONS(12073),
    [anon_sym_EQ_TILDE] = ACTIONS(12073),
    [anon_sym_BANG_TILDE] = ACTIONS(12073),
    [anon_sym_LT_EQ] = ACTIONS(12075),
    [anon_sym_GT] = ACTIONS(12075),
    [anon_sym_GT_EQ] = ACTIONS(12073),
    [anon_sym_CARET] = ACTIONS(12073),
    [anon_sym_PLUS] = ACTIONS(12073),
    [anon_sym_SLASH] = ACTIONS(12073),
    [anon_sym_PERCENT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [8729] = {
    [sym__binary_minus] = ACTIONS(12187),
    [sym__binary_star] = ACTIONS(12187),
    [anon_sym_LBRACE] = ACTIONS(12187),
    [anon_sym_RBRACE] = ACTIONS(12187),
    [anon_sym_RPAREN] = ACTIONS(12187),
    [anon_sym_DOT] = ACTIONS(12189),
    [anon_sym_COMMA] = ACTIONS(12187),
    [anon_sym_PIPE] = ACTIONS(12189),
    [anon_sym_SEMI] = ACTIONS(12187),
    [anon_sym_STAR_STAR] = ACTIONS(12187),
    [anon_sym_AMP] = ACTIONS(12189),
    [anon_sym_LT] = ACTIONS(12189),
    [anon_sym_if] = ACTIONS(12187),
    [anon_sym_unless] = ACTIONS(12187),
    [anon_sym_while] = ACTIONS(12187),
    [anon_sym_until] = ACTIONS(12187),
    [anon_sym_rescue] = ACTIONS(12187),
    [anon_sym_do] = ACTIONS(12187),
    [anon_sym_EQ_GT] = ACTIONS(12187),
    [anon_sym_LBRACK] = ACTIONS(12187),
    [anon_sym_COLON_COLON2] = ACTIONS(12187),
    [anon_sym_AMP_DOT] = ACTIONS(12187),
    [anon_sym_QMARK] = ACTIONS(12187),
    [anon_sym_COLON2] = ACTIONS(12189),
    [anon_sym_DOT_DOT] = ACTIONS(12189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12187),
    [anon_sym_and] = ACTIONS(12187),
    [anon_sym_or] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE] = ACTIONS(12187),
    [anon_sym_AMP_AMP] = ACTIONS(12187),
    [anon_sym_LT_LT] = ACTIONS(12187),
    [anon_sym_GT_GT] = ACTIONS(12187),
    [anon_sym_EQ_EQ] = ACTIONS(12189),
    [anon_sym_BANG_EQ] = ACTIONS(12187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12187),
    [anon_sym_LT_EQ_GT] = ACTIONS(12187),
    [anon_sym_EQ_TILDE] = ACTIONS(12187),
    [anon_sym_BANG_TILDE] = ACTIONS(12187),
    [anon_sym_LT_EQ] = ACTIONS(12189),
    [anon_sym_GT] = ACTIONS(12189),
    [anon_sym_GT_EQ] = ACTIONS(12187),
    [anon_sym_CARET] = ACTIONS(12187),
    [anon_sym_PLUS] = ACTIONS(12187),
    [anon_sym_SLASH] = ACTIONS(12187),
    [anon_sym_PERCENT] = ACTIONS(12187),
    [sym_comment] = ACTIONS(87),
  },
  [8730] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [8731] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8732] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [8733] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [8734] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [8735] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13454),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8736] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [8737] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(9946),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [8738] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [8739] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [8740] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(9946),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [8741] = {
    [aux_sym_exceptions_repeat1] = STATE(9960),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8742] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(9946),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [8743] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [8744] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [8745] = {
    [sym_heredoc_body] = STATE(8745),
    [aux_sym_call_repeat1] = STATE(8745),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8746] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4053),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(4053),
    [sym_operator_assignment] = STATE(4053),
    [sym_conditional] = STATE(4053),
    [sym_range] = STATE(4053),
    [sym_binary] = STATE(4053),
    [sym_unary] = STATE(4053),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4056),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(6581),
    [sym__splat_star] = ACTIONS(6583),
    [sym__unary_minus] = ACTIONS(3122),
    [sym__identifier_hash_key] = ACTIONS(6585),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12091),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(6587),
    [sym_identifier] = ACTIONS(6587),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8747] = {
    [sym_heredoc_body] = STATE(8745),
    [aux_sym_call_repeat1] = STATE(8745),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8748] = {
    [aux_sym_argument_list_repeat1] = STATE(8748),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13456),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [8749] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9961),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_assignment] = STATE(9961),
    [sym_operator_assignment] = STATE(9961),
    [sym_conditional] = STATE(9961),
    [sym_range] = STATE(9961),
    [sym_binary] = STATE(9961),
    [sym_unary] = STATE(9961),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8750] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [8751] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [8752] = {
    [sym_heredoc_body] = STATE(8752),
    [aux_sym_call_repeat1] = STATE(8752),
    [sym__heredoc_body_start] = ACTIONS(10154),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [8753] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4074),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym__argument] = STATE(6822),
    [sym_splat_argument] = STATE(6822),
    [sym_hash_splat_argument] = STATE(6822),
    [sym_block_argument] = STATE(6822),
    [sym_assignment] = STATE(4074),
    [sym_operator_assignment] = STATE(4074),
    [sym_conditional] = STATE(4074),
    [sym_range] = STATE(4074),
    [sym_binary] = STATE(4074),
    [sym_unary] = STATE(4074),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4077),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6822),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(6617),
    [sym__splat_star] = ACTIONS(6619),
    [sym__unary_minus] = ACTIONS(3190),
    [sym__identifier_hash_key] = ACTIONS(6621),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12095),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(6623),
    [sym_identifier] = ACTIONS(6623),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8754] = {
    [sym_heredoc_body] = STATE(8752),
    [aux_sym_call_repeat1] = STATE(8752),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [8755] = {
    [aux_sym_argument_list_repeat1] = STATE(8755),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13459),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [8756] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6689),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1795),
    [sym_scope_resolution] = STATE(1791),
    [sym_call] = STATE(1791),
    [sym_method_call] = STATE(1795),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(6689),
    [sym_operator_assignment] = STATE(6689),
    [sym_conditional] = STATE(6689),
    [sym_range] = STATE(6689),
    [sym_binary] = STATE(6689),
    [sym_unary] = STATE(6689),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(1794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1795),
    [sym__variable] = STATE(1791),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1795),
    [sym_false] = STATE(1795),
    [sym_nil] = STATE(1795),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4045),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(6583),
    [sym__unary_minus] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3126),
    [anon_sym_yield] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3130),
    [anon_sym_next] = ACTIONS(3132),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(3134),
    [anon_sym_not] = ACTIONS(3136),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [sym_constant] = ACTIONS(3146),
    [sym_identifier] = ACTIONS(3146),
    [sym_instance_variable] = ACTIONS(3144),
    [sym_class_variable] = ACTIONS(3144),
    [sym_global_variable] = ACTIONS(3144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3146),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3146),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8757] = {
    [aux_sym_exceptions_repeat1] = STATE(9962),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13462),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8758] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(3150),
    [sym__binary_star] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_DOT_DOT] = ACTIONS(3162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3170),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_LT_EQ_GT] = ACTIONS(3168),
    [anon_sym_EQ_TILDE] = ACTIONS(3168),
    [anon_sym_BANG_TILDE] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3152),
    [sym_comment] = ACTIONS(87),
  },
  [8759] = {
    [sym__simple_symbol] = ACTIONS(7608),
    [sym__string_start] = ACTIONS(7608),
    [sym__symbol_start] = ACTIONS(7608),
    [sym__subshell_start] = ACTIONS(7608),
    [sym__regex_start] = ACTIONS(7608),
    [sym__string_array_start] = ACTIONS(7608),
    [sym__symbol_array_start] = ACTIONS(7608),
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym_heredoc_beginning] = ACTIONS(7608),
    [sym__block_ampersand] = ACTIONS(7608),
    [sym__splat_star] = ACTIONS(7608),
    [sym__unary_minus] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [sym__identifier_hash_key] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RBRACE] = ACTIONS(7608),
    [anon_sym_def] = ACTIONS(7610),
    [anon_sym_LPAREN] = ACTIONS(7610),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COLON_COLON] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR] = ACTIONS(7610),
    [anon_sym_STAR_STAR] = ACTIONS(7610),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_class] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_module] = ACTIONS(7610),
    [anon_sym_return] = ACTIONS(7610),
    [anon_sym_yield] = ACTIONS(7610),
    [anon_sym_break] = ACTIONS(7610),
    [anon_sym_next] = ACTIONS(7610),
    [sym_redo] = ACTIONS(7610),
    [sym_retry] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7610),
    [anon_sym_unless] = ACTIONS(7610),
    [anon_sym_while] = ACTIONS(7610),
    [anon_sym_until] = ACTIONS(7610),
    [anon_sym_rescue] = ACTIONS(7610),
    [anon_sym_for] = ACTIONS(7610),
    [anon_sym_in] = ACTIONS(7610),
    [anon_sym_do] = ACTIONS(7610),
    [anon_sym_case] = ACTIONS(7610),
    [anon_sym_begin] = ACTIONS(7610),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_RBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_LPAREN2] = ACTIONS(7608),
    [anon_sym_PLUS_EQ] = ACTIONS(7608),
    [anon_sym_DASH_EQ] = ACTIONS(7608),
    [anon_sym_STAR_EQ] = ACTIONS(7608),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7608),
    [anon_sym_SLASH_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_PIPE_EQ] = ACTIONS(7608),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7608),
    [anon_sym_AMP_EQ] = ACTIONS(7608),
    [anon_sym_PERCENT_EQ] = ACTIONS(7608),
    [anon_sym_GT_GT_EQ] = ACTIONS(7608),
    [anon_sym_LT_LT_EQ] = ACTIONS(7608),
    [anon_sym_CARET_EQ] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7610),
    [anon_sym_COLON2] = ACTIONS(7610),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7610),
    [anon_sym_or] = ACTIONS(7610),
    [anon_sym_PIPE_PIPE] = ACTIONS(7610),
    [anon_sym_AMP_AMP] = ACTIONS(7610),
    [anon_sym_LT_LT] = ACTIONS(7610),
    [anon_sym_GT_GT] = ACTIONS(7610),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7610),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_SLASH] = ACTIONS(7610),
    [anon_sym_PERCENT] = ACTIONS(7610),
    [anon_sym_defined_QMARK] = ACTIONS(7608),
    [anon_sym_not] = ACTIONS(7610),
    [anon_sym_BANG] = ACTIONS(7610),
    [anon_sym_TILDE] = ACTIONS(7608),
    [sym_constant] = ACTIONS(7610),
    [sym_identifier] = ACTIONS(7610),
    [sym_instance_variable] = ACTIONS(7608),
    [sym_class_variable] = ACTIONS(7608),
    [sym_global_variable] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7610),
    [sym_float] = ACTIONS(7610),
    [sym_complex] = ACTIONS(7608),
    [sym_super] = ACTIONS(7610),
    [anon_sym_true] = ACTIONS(7610),
    [anon_sym_TRUE] = ACTIONS(7610),
    [anon_sym_false] = ACTIONS(7610),
    [anon_sym_FALSE] = ACTIONS(7610),
    [sym_self] = ACTIONS(7610),
    [anon_sym_nil] = ACTIONS(7610),
    [anon_sym_NIL] = ACTIONS(7610),
    [sym_character] = ACTIONS(7608),
    [anon_sym_LBRACK2] = ACTIONS(7610),
    [anon_sym_DASH_GT] = ACTIONS(7608),
  },
  [8760] = {
    [anon_sym_RPAREN] = ACTIONS(13464),
    [sym_comment] = ACTIONS(87),
  },
  [8761] = {
    [sym__heredoc_body_start] = ACTIONS(11825),
    [sym__binary_minus] = ACTIONS(11825),
    [sym__binary_star] = ACTIONS(11825),
    [anon_sym_LBRACE] = ACTIONS(11825),
    [anon_sym_RBRACE] = ACTIONS(11825),
    [anon_sym_RPAREN] = ACTIONS(11825),
    [anon_sym_DOT] = ACTIONS(11827),
    [anon_sym_COMMA] = ACTIONS(11825),
    [anon_sym_PIPE] = ACTIONS(11827),
    [anon_sym_SEMI] = ACTIONS(11825),
    [anon_sym_STAR_STAR] = ACTIONS(11827),
    [anon_sym_AMP] = ACTIONS(11827),
    [anon_sym_EQ] = ACTIONS(11827),
    [anon_sym_LT] = ACTIONS(11827),
    [anon_sym_if] = ACTIONS(11825),
    [anon_sym_unless] = ACTIONS(11825),
    [anon_sym_while] = ACTIONS(11825),
    [anon_sym_until] = ACTIONS(11825),
    [anon_sym_rescue] = ACTIONS(11825),
    [anon_sym_in] = ACTIONS(11825),
    [anon_sym_do] = ACTIONS(11825),
    [anon_sym_LBRACK] = ACTIONS(11825),
    [anon_sym_RBRACK] = ACTIONS(11825),
    [anon_sym_COLON_COLON2] = ACTIONS(11825),
    [anon_sym_AMP_DOT] = ACTIONS(11825),
    [anon_sym_PLUS_EQ] = ACTIONS(11825),
    [anon_sym_DASH_EQ] = ACTIONS(11825),
    [anon_sym_STAR_EQ] = ACTIONS(11825),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11825),
    [anon_sym_SLASH_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_PIPE_EQ] = ACTIONS(11825),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11825),
    [anon_sym_AMP_EQ] = ACTIONS(11825),
    [anon_sym_PERCENT_EQ] = ACTIONS(11825),
    [anon_sym_GT_GT_EQ] = ACTIONS(11825),
    [anon_sym_LT_LT_EQ] = ACTIONS(11825),
    [anon_sym_CARET_EQ] = ACTIONS(11825),
    [anon_sym_QMARK] = ACTIONS(11825),
    [anon_sym_COLON2] = ACTIONS(11827),
    [anon_sym_DOT_DOT] = ACTIONS(11827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11825),
    [anon_sym_and] = ACTIONS(11825),
    [anon_sym_or] = ACTIONS(11825),
    [anon_sym_PIPE_PIPE] = ACTIONS(11827),
    [anon_sym_AMP_AMP] = ACTIONS(11827),
    [anon_sym_LT_LT] = ACTIONS(11827),
    [anon_sym_GT_GT] = ACTIONS(11827),
    [anon_sym_EQ_EQ] = ACTIONS(11827),
    [anon_sym_BANG_EQ] = ACTIONS(11825),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11825),
    [anon_sym_LT_EQ_GT] = ACTIONS(11825),
    [anon_sym_EQ_TILDE] = ACTIONS(11825),
    [anon_sym_BANG_TILDE] = ACTIONS(11825),
    [anon_sym_LT_EQ] = ACTIONS(11827),
    [anon_sym_GT] = ACTIONS(11827),
    [anon_sym_GT_EQ] = ACTIONS(11825),
    [anon_sym_CARET] = ACTIONS(11827),
    [anon_sym_PLUS] = ACTIONS(11827),
    [anon_sym_SLASH] = ACTIONS(11827),
    [anon_sym_PERCENT] = ACTIONS(11827),
    [sym_comment] = ACTIONS(87),
  },
  [8762] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [8763] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [8764] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [8765] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [8766] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [8767] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13466),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8768] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [8769] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [8770] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [8771] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [8772] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [8773] = {
    [aux_sym_exceptions_repeat1] = STATE(9966),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [8774] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [8775] = {
    [sym_string] = STATE(8775),
    [aux_sym_chained_string_repeat1] = STATE(8775),
    [sym__string_start] = ACTIONS(13427),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [8776] = {
    [sym__heredoc_body_start] = ACTIONS(11655),
    [sym__binary_minus] = ACTIONS(11655),
    [sym__binary_star] = ACTIONS(11655),
    [anon_sym_LBRACE] = ACTIONS(11655),
    [anon_sym_RBRACE] = ACTIONS(11655),
    [anon_sym_RPAREN] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11657),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11657),
    [anon_sym_SEMI] = ACTIONS(11655),
    [anon_sym_STAR_STAR] = ACTIONS(11657),
    [anon_sym_AMP] = ACTIONS(11657),
    [anon_sym_EQ] = ACTIONS(11657),
    [anon_sym_LT] = ACTIONS(11657),
    [anon_sym_if] = ACTIONS(11655),
    [anon_sym_unless] = ACTIONS(11655),
    [anon_sym_while] = ACTIONS(11655),
    [anon_sym_until] = ACTIONS(11655),
    [anon_sym_rescue] = ACTIONS(11655),
    [anon_sym_in] = ACTIONS(11655),
    [anon_sym_do] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_RBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [anon_sym_PLUS_EQ] = ACTIONS(11655),
    [anon_sym_DASH_EQ] = ACTIONS(11655),
    [anon_sym_STAR_EQ] = ACTIONS(11655),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11655),
    [anon_sym_SLASH_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_PIPE_EQ] = ACTIONS(11655),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11655),
    [anon_sym_AMP_EQ] = ACTIONS(11655),
    [anon_sym_PERCENT_EQ] = ACTIONS(11655),
    [anon_sym_GT_GT_EQ] = ACTIONS(11655),
    [anon_sym_LT_LT_EQ] = ACTIONS(11655),
    [anon_sym_CARET_EQ] = ACTIONS(11655),
    [anon_sym_QMARK] = ACTIONS(11655),
    [anon_sym_COLON2] = ACTIONS(11657),
    [anon_sym_DOT_DOT] = ACTIONS(11657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11655),
    [anon_sym_and] = ACTIONS(11655),
    [anon_sym_or] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE] = ACTIONS(11657),
    [anon_sym_AMP_AMP] = ACTIONS(11657),
    [anon_sym_LT_LT] = ACTIONS(11657),
    [anon_sym_GT_GT] = ACTIONS(11657),
    [anon_sym_EQ_EQ] = ACTIONS(11657),
    [anon_sym_BANG_EQ] = ACTIONS(11655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11655),
    [anon_sym_LT_EQ_GT] = ACTIONS(11655),
    [anon_sym_EQ_TILDE] = ACTIONS(11655),
    [anon_sym_BANG_TILDE] = ACTIONS(11655),
    [anon_sym_LT_EQ] = ACTIONS(11657),
    [anon_sym_GT] = ACTIONS(11657),
    [anon_sym_GT_EQ] = ACTIONS(11655),
    [anon_sym_CARET] = ACTIONS(11657),
    [anon_sym_PLUS] = ACTIONS(11657),
    [anon_sym_SLASH] = ACTIONS(11657),
    [anon_sym_PERCENT] = ACTIONS(11657),
    [sym_comment] = ACTIONS(87),
  },
  [8777] = {
    [sym__heredoc_body_start] = ACTIONS(11680),
    [sym__binary_minus] = ACTIONS(11680),
    [sym__binary_star] = ACTIONS(11680),
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RBRACE] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11682),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11682),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_STAR_STAR] = ACTIONS(11682),
    [anon_sym_AMP] = ACTIONS(11682),
    [anon_sym_EQ] = ACTIONS(11682),
    [anon_sym_LT] = ACTIONS(11682),
    [anon_sym_if] = ACTIONS(11680),
    [anon_sym_unless] = ACTIONS(11680),
    [anon_sym_while] = ACTIONS(11680),
    [anon_sym_until] = ACTIONS(11680),
    [anon_sym_rescue] = ACTIONS(11680),
    [anon_sym_in] = ACTIONS(11680),
    [anon_sym_do] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_RBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [anon_sym_PLUS_EQ] = ACTIONS(11680),
    [anon_sym_DASH_EQ] = ACTIONS(11680),
    [anon_sym_STAR_EQ] = ACTIONS(11680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11680),
    [anon_sym_SLASH_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_PIPE_EQ] = ACTIONS(11680),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11680),
    [anon_sym_AMP_EQ] = ACTIONS(11680),
    [anon_sym_PERCENT_EQ] = ACTIONS(11680),
    [anon_sym_GT_GT_EQ] = ACTIONS(11680),
    [anon_sym_LT_LT_EQ] = ACTIONS(11680),
    [anon_sym_CARET_EQ] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_COLON2] = ACTIONS(11682),
    [anon_sym_DOT_DOT] = ACTIONS(11682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_and] = ACTIONS(11680),
    [anon_sym_or] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE] = ACTIONS(11682),
    [anon_sym_AMP_AMP] = ACTIONS(11682),
    [anon_sym_LT_LT] = ACTIONS(11682),
    [anon_sym_GT_GT] = ACTIONS(11682),
    [anon_sym_EQ_EQ] = ACTIONS(11682),
    [anon_sym_BANG_EQ] = ACTIONS(11680),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11680),
    [anon_sym_LT_EQ_GT] = ACTIONS(11680),
    [anon_sym_EQ_TILDE] = ACTIONS(11680),
    [anon_sym_BANG_TILDE] = ACTIONS(11680),
    [anon_sym_LT_EQ] = ACTIONS(11682),
    [anon_sym_GT] = ACTIONS(11682),
    [anon_sym_GT_EQ] = ACTIONS(11680),
    [anon_sym_CARET] = ACTIONS(11682),
    [anon_sym_PLUS] = ACTIONS(11682),
    [anon_sym_SLASH] = ACTIONS(11682),
    [anon_sym_PERCENT] = ACTIONS(11682),
    [sym_comment] = ACTIONS(87),
  },
  [8778] = {
    [anon_sym_end] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [8779] = {
    [sym__statements] = STATE(9968),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13470),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8780] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9969),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_assignment] = STATE(9969),
    [sym_operator_assignment] = STATE(9969),
    [sym_conditional] = STATE(9969),
    [sym_range] = STATE(9969),
    [sym_binary] = STATE(9969),
    [sym_unary] = STATE(9969),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8781] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6738),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(1832),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1832),
    [sym_splat_argument] = STATE(8821),
    [sym_assignment] = STATE(6738),
    [sym_operator_assignment] = STATE(6738),
    [sym_conditional] = STATE(6738),
    [sym_range] = STATE(6738),
    [sym_binary] = STATE(6738),
    [sym_unary] = STATE(6738),
    [sym__arg_or_splat_arg] = STATE(8821),
    [sym_left_assignment_list] = STATE(1831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1832),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(1832),
    [sym_false] = STATE(1832),
    [sym_nil] = STATE(1832),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4117),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(6619),
    [sym__unary_minus] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_break] = ACTIONS(3200),
    [anon_sym_next] = ACTIONS(3202),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6669),
    [anon_sym_defined_QMARK] = ACTIONS(3206),
    [anon_sym_not] = ACTIONS(3208),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [sym_constant] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_instance_variable] = ACTIONS(3216),
    [sym_class_variable] = ACTIONS(3216),
    [sym_global_variable] = ACTIONS(3216),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3218),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3218),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8782] = {
    [aux_sym_exceptions_repeat1] = STATE(9970),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13472),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [8783] = {
    [aux_sym_exceptions_repeat1] = STATE(8783),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13474),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [8784] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(3238),
    [sym__binary_star] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3240),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_LT] = ACTIONS(3246),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_DOT_DOT] = ACTIONS(3250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3252),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3256),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_LT_EQ_GT] = ACTIONS(3254),
    [anon_sym_EQ_TILDE] = ACTIONS(3254),
    [anon_sym_BANG_TILDE] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_GT] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3260),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3238),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3240),
    [sym_comment] = ACTIONS(87),
  },
  [8785] = {
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11972),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [8786] = {
    [aux_sym_exceptions_repeat1] = STATE(8786),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13477),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [8787] = {
    [sym__binary_minus] = ACTIONS(12482),
    [sym__binary_star] = ACTIONS(12482),
    [anon_sym_LBRACE] = ACTIONS(12482),
    [anon_sym_RBRACE] = ACTIONS(12482),
    [anon_sym_RPAREN] = ACTIONS(12482),
    [anon_sym_DOT] = ACTIONS(12484),
    [anon_sym_COMMA] = ACTIONS(12482),
    [anon_sym_PIPE] = ACTIONS(12484),
    [anon_sym_SEMI] = ACTIONS(12482),
    [anon_sym_STAR_STAR] = ACTIONS(12482),
    [anon_sym_AMP] = ACTIONS(12484),
    [anon_sym_LT] = ACTIONS(12484),
    [anon_sym_if] = ACTIONS(12482),
    [anon_sym_unless] = ACTIONS(12482),
    [anon_sym_while] = ACTIONS(12482),
    [anon_sym_until] = ACTIONS(12482),
    [anon_sym_rescue] = ACTIONS(12482),
    [anon_sym_do] = ACTIONS(12482),
    [anon_sym_EQ_GT] = ACTIONS(12482),
    [anon_sym_LBRACK] = ACTIONS(12482),
    [anon_sym_COLON_COLON2] = ACTIONS(12482),
    [anon_sym_AMP_DOT] = ACTIONS(12482),
    [anon_sym_QMARK] = ACTIONS(12482),
    [anon_sym_COLON2] = ACTIONS(12484),
    [anon_sym_DOT_DOT] = ACTIONS(12484),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12482),
    [anon_sym_and] = ACTIONS(12482),
    [anon_sym_or] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE] = ACTIONS(12482),
    [anon_sym_AMP_AMP] = ACTIONS(12482),
    [anon_sym_LT_LT] = ACTIONS(12482),
    [anon_sym_GT_GT] = ACTIONS(12482),
    [anon_sym_EQ_EQ] = ACTIONS(12484),
    [anon_sym_BANG_EQ] = ACTIONS(12482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12482),
    [anon_sym_LT_EQ_GT] = ACTIONS(12482),
    [anon_sym_EQ_TILDE] = ACTIONS(12482),
    [anon_sym_BANG_TILDE] = ACTIONS(12482),
    [anon_sym_LT_EQ] = ACTIONS(12484),
    [anon_sym_GT] = ACTIONS(12484),
    [anon_sym_GT_EQ] = ACTIONS(12482),
    [anon_sym_CARET] = ACTIONS(12482),
    [anon_sym_PLUS] = ACTIONS(12482),
    [anon_sym_SLASH] = ACTIONS(12482),
    [anon_sym_PERCENT] = ACTIONS(12482),
    [sym_comment] = ACTIONS(87),
  },
  [8788] = {
    [anon_sym_end] = ACTIONS(13480),
    [sym_comment] = ACTIONS(87),
  },
  [8789] = {
    [sym__binary_minus] = ACTIONS(12622),
    [sym__binary_star] = ACTIONS(12622),
    [anon_sym_LBRACE] = ACTIONS(12622),
    [anon_sym_RBRACE] = ACTIONS(12622),
    [anon_sym_RPAREN] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12624),
    [anon_sym_COMMA] = ACTIONS(12622),
    [anon_sym_PIPE] = ACTIONS(12624),
    [anon_sym_SEMI] = ACTIONS(12622),
    [anon_sym_STAR_STAR] = ACTIONS(12622),
    [anon_sym_AMP] = ACTIONS(12624),
    [anon_sym_LT] = ACTIONS(12624),
    [anon_sym_if] = ACTIONS(12622),
    [anon_sym_unless] = ACTIONS(12622),
    [anon_sym_while] = ACTIONS(12622),
    [anon_sym_until] = ACTIONS(12622),
    [anon_sym_rescue] = ACTIONS(12622),
    [anon_sym_do] = ACTIONS(12622),
    [anon_sym_EQ_GT] = ACTIONS(12622),
    [anon_sym_LBRACK] = ACTIONS(12622),
    [anon_sym_COLON_COLON2] = ACTIONS(12622),
    [anon_sym_AMP_DOT] = ACTIONS(12622),
    [anon_sym_QMARK] = ACTIONS(12622),
    [anon_sym_COLON2] = ACTIONS(12624),
    [anon_sym_DOT_DOT] = ACTIONS(12624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12622),
    [anon_sym_and] = ACTIONS(12622),
    [anon_sym_or] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE] = ACTIONS(12622),
    [anon_sym_AMP_AMP] = ACTIONS(12622),
    [anon_sym_LT_LT] = ACTIONS(12622),
    [anon_sym_GT_GT] = ACTIONS(12622),
    [anon_sym_EQ_EQ] = ACTIONS(12624),
    [anon_sym_BANG_EQ] = ACTIONS(12622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12622),
    [anon_sym_LT_EQ_GT] = ACTIONS(12622),
    [anon_sym_EQ_TILDE] = ACTIONS(12622),
    [anon_sym_BANG_TILDE] = ACTIONS(12622),
    [anon_sym_LT_EQ] = ACTIONS(12624),
    [anon_sym_GT] = ACTIONS(12624),
    [anon_sym_GT_EQ] = ACTIONS(12622),
    [anon_sym_CARET] = ACTIONS(12622),
    [anon_sym_PLUS] = ACTIONS(12622),
    [anon_sym_SLASH] = ACTIONS(12622),
    [anon_sym_PERCENT] = ACTIONS(12622),
    [sym_comment] = ACTIONS(87),
  },
  [8790] = {
    [sym__binary_minus] = ACTIONS(12770),
    [sym__binary_star] = ACTIONS(12770),
    [anon_sym_LBRACE] = ACTIONS(12770),
    [anon_sym_RBRACE] = ACTIONS(12770),
    [anon_sym_RPAREN] = ACTIONS(12770),
    [anon_sym_DOT] = ACTIONS(12772),
    [anon_sym_COMMA] = ACTIONS(12770),
    [anon_sym_PIPE] = ACTIONS(12772),
    [anon_sym_SEMI] = ACTIONS(12770),
    [anon_sym_STAR_STAR] = ACTIONS(12770),
    [anon_sym_AMP] = ACTIONS(12772),
    [anon_sym_LT] = ACTIONS(12772),
    [anon_sym_if] = ACTIONS(12770),
    [anon_sym_unless] = ACTIONS(12770),
    [anon_sym_while] = ACTIONS(12770),
    [anon_sym_until] = ACTIONS(12770),
    [anon_sym_rescue] = ACTIONS(12770),
    [anon_sym_do] = ACTIONS(12770),
    [anon_sym_EQ_GT] = ACTIONS(12770),
    [anon_sym_LBRACK] = ACTIONS(12770),
    [anon_sym_COLON_COLON2] = ACTIONS(12770),
    [anon_sym_AMP_DOT] = ACTIONS(12770),
    [anon_sym_QMARK] = ACTIONS(12770),
    [anon_sym_COLON2] = ACTIONS(12772),
    [anon_sym_DOT_DOT] = ACTIONS(12772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12770),
    [anon_sym_and] = ACTIONS(12770),
    [anon_sym_or] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE] = ACTIONS(12770),
    [anon_sym_AMP_AMP] = ACTIONS(12770),
    [anon_sym_LT_LT] = ACTIONS(12770),
    [anon_sym_GT_GT] = ACTIONS(12770),
    [anon_sym_EQ_EQ] = ACTIONS(12772),
    [anon_sym_BANG_EQ] = ACTIONS(12770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12770),
    [anon_sym_LT_EQ_GT] = ACTIONS(12770),
    [anon_sym_EQ_TILDE] = ACTIONS(12770),
    [anon_sym_BANG_TILDE] = ACTIONS(12770),
    [anon_sym_LT_EQ] = ACTIONS(12772),
    [anon_sym_GT] = ACTIONS(12772),
    [anon_sym_GT_EQ] = ACTIONS(12770),
    [anon_sym_CARET] = ACTIONS(12770),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_SLASH] = ACTIONS(12770),
    [anon_sym_PERCENT] = ACTIONS(12770),
    [sym_comment] = ACTIONS(87),
  },
  [8791] = {
    [sym__binary_minus] = ACTIONS(12781),
    [sym__binary_star] = ACTIONS(12781),
    [anon_sym_LBRACE] = ACTIONS(12781),
    [anon_sym_RBRACE] = ACTIONS(12781),
    [anon_sym_RPAREN] = ACTIONS(12781),
    [anon_sym_DOT] = ACTIONS(12783),
    [anon_sym_COMMA] = ACTIONS(12781),
    [anon_sym_PIPE] = ACTIONS(12783),
    [anon_sym_SEMI] = ACTIONS(12781),
    [anon_sym_STAR_STAR] = ACTIONS(12781),
    [anon_sym_AMP] = ACTIONS(12783),
    [anon_sym_LT] = ACTIONS(12783),
    [anon_sym_if] = ACTIONS(12781),
    [anon_sym_unless] = ACTIONS(12781),
    [anon_sym_while] = ACTIONS(12781),
    [anon_sym_until] = ACTIONS(12781),
    [anon_sym_rescue] = ACTIONS(12781),
    [anon_sym_do] = ACTIONS(12781),
    [anon_sym_EQ_GT] = ACTIONS(12781),
    [anon_sym_LBRACK] = ACTIONS(12781),
    [anon_sym_COLON_COLON2] = ACTIONS(12781),
    [anon_sym_AMP_DOT] = ACTIONS(12781),
    [anon_sym_QMARK] = ACTIONS(12781),
    [anon_sym_COLON2] = ACTIONS(12783),
    [anon_sym_DOT_DOT] = ACTIONS(12783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12781),
    [anon_sym_and] = ACTIONS(12781),
    [anon_sym_or] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE] = ACTIONS(12781),
    [anon_sym_AMP_AMP] = ACTIONS(12781),
    [anon_sym_LT_LT] = ACTIONS(12781),
    [anon_sym_GT_GT] = ACTIONS(12781),
    [anon_sym_EQ_EQ] = ACTIONS(12783),
    [anon_sym_BANG_EQ] = ACTIONS(12781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12781),
    [anon_sym_LT_EQ_GT] = ACTIONS(12781),
    [anon_sym_EQ_TILDE] = ACTIONS(12781),
    [anon_sym_BANG_TILDE] = ACTIONS(12781),
    [anon_sym_LT_EQ] = ACTIONS(12783),
    [anon_sym_GT] = ACTIONS(12783),
    [anon_sym_GT_EQ] = ACTIONS(12781),
    [anon_sym_CARET] = ACTIONS(12781),
    [anon_sym_PLUS] = ACTIONS(12781),
    [anon_sym_SLASH] = ACTIONS(12781),
    [anon_sym_PERCENT] = ACTIONS(12781),
    [sym_comment] = ACTIONS(87),
  },
  [8792] = {
    [sym__binary_minus] = ACTIONS(13093),
    [sym__binary_star] = ACTIONS(13093),
    [anon_sym_LBRACE] = ACTIONS(13093),
    [anon_sym_RBRACE] = ACTIONS(13093),
    [anon_sym_RPAREN] = ACTIONS(13093),
    [anon_sym_DOT] = ACTIONS(13095),
    [anon_sym_COMMA] = ACTIONS(13093),
    [anon_sym_PIPE] = ACTIONS(13095),
    [anon_sym_SEMI] = ACTIONS(13093),
    [anon_sym_STAR_STAR] = ACTIONS(13093),
    [anon_sym_AMP] = ACTIONS(13095),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_if] = ACTIONS(13093),
    [anon_sym_unless] = ACTIONS(13093),
    [anon_sym_while] = ACTIONS(13093),
    [anon_sym_until] = ACTIONS(13093),
    [anon_sym_rescue] = ACTIONS(13093),
    [anon_sym_do] = ACTIONS(13093),
    [anon_sym_EQ_GT] = ACTIONS(13093),
    [anon_sym_LBRACK] = ACTIONS(13093),
    [anon_sym_COLON_COLON2] = ACTIONS(13093),
    [anon_sym_AMP_DOT] = ACTIONS(13093),
    [anon_sym_QMARK] = ACTIONS(13093),
    [anon_sym_COLON2] = ACTIONS(13095),
    [anon_sym_DOT_DOT] = ACTIONS(13095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13093),
    [anon_sym_and] = ACTIONS(13093),
    [anon_sym_or] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE] = ACTIONS(13093),
    [anon_sym_AMP_AMP] = ACTIONS(13093),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13095),
    [anon_sym_BANG_EQ] = ACTIONS(13093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13093),
    [anon_sym_LT_EQ_GT] = ACTIONS(13093),
    [anon_sym_EQ_TILDE] = ACTIONS(13093),
    [anon_sym_BANG_TILDE] = ACTIONS(13093),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13093),
    [anon_sym_CARET] = ACTIONS(13093),
    [anon_sym_PLUS] = ACTIONS(13093),
    [anon_sym_SLASH] = ACTIONS(13093),
    [anon_sym_PERCENT] = ACTIONS(13093),
    [sym_comment] = ACTIONS(87),
  },
  [8793] = {
    [sym__binary_minus] = ACTIONS(13264),
    [sym__binary_star] = ACTIONS(13264),
    [anon_sym_LBRACE] = ACTIONS(13264),
    [anon_sym_RBRACE] = ACTIONS(13264),
    [anon_sym_RPAREN] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13266),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13266),
    [anon_sym_SEMI] = ACTIONS(13264),
    [anon_sym_STAR_STAR] = ACTIONS(13264),
    [anon_sym_AMP] = ACTIONS(13266),
    [anon_sym_LT] = ACTIONS(13266),
    [anon_sym_if] = ACTIONS(13264),
    [anon_sym_unless] = ACTIONS(13264),
    [anon_sym_while] = ACTIONS(13264),
    [anon_sym_until] = ACTIONS(13264),
    [anon_sym_rescue] = ACTIONS(13264),
    [anon_sym_do] = ACTIONS(13264),
    [anon_sym_EQ_GT] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [anon_sym_QMARK] = ACTIONS(13264),
    [anon_sym_COLON2] = ACTIONS(13266),
    [anon_sym_DOT_DOT] = ACTIONS(13266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13264),
    [anon_sym_and] = ACTIONS(13264),
    [anon_sym_or] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE] = ACTIONS(13264),
    [anon_sym_AMP_AMP] = ACTIONS(13264),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13264),
    [anon_sym_LT_EQ_GT] = ACTIONS(13264),
    [anon_sym_EQ_TILDE] = ACTIONS(13264),
    [anon_sym_BANG_TILDE] = ACTIONS(13264),
    [anon_sym_LT_EQ] = ACTIONS(13266),
    [anon_sym_GT] = ACTIONS(13266),
    [anon_sym_GT_EQ] = ACTIONS(13264),
    [anon_sym_CARET] = ACTIONS(13264),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13264),
    [anon_sym_PERCENT] = ACTIONS(13264),
    [sym_comment] = ACTIONS(87),
  },
  [8794] = {
    [anon_sym_end] = ACTIONS(13482),
    [sym_comment] = ACTIONS(87),
  },
  [8795] = {
    [sym__simple_symbol] = ACTIONS(10568),
    [sym__string_start] = ACTIONS(10568),
    [sym__symbol_start] = ACTIONS(10568),
    [sym__subshell_start] = ACTIONS(10568),
    [sym__regex_start] = ACTIONS(10568),
    [sym__string_array_start] = ACTIONS(10568),
    [sym__symbol_array_start] = ACTIONS(10568),
    [sym_heredoc_beginning] = ACTIONS(10568),
    [sym__block_ampersand] = ACTIONS(10568),
    [sym__splat_star] = ACTIONS(10568),
    [sym__unary_minus] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [sym__identifier_hash_key] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_def] = ACTIONS(10570),
    [anon_sym_LPAREN] = ACTIONS(10570),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COLON_COLON] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10570),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_class] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_module] = ACTIONS(10570),
    [anon_sym_return] = ACTIONS(10570),
    [anon_sym_yield] = ACTIONS(10570),
    [anon_sym_break] = ACTIONS(10570),
    [anon_sym_next] = ACTIONS(10570),
    [sym_redo] = ACTIONS(10570),
    [sym_retry] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10570),
    [anon_sym_unless] = ACTIONS(10570),
    [anon_sym_while] = ACTIONS(10570),
    [anon_sym_until] = ACTIONS(10570),
    [anon_sym_for] = ACTIONS(10570),
    [anon_sym_do] = ACTIONS(10570),
    [anon_sym_case] = ACTIONS(10570),
    [anon_sym_begin] = ACTIONS(10570),
    [anon_sym_EQ_GT] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_LPAREN2] = ACTIONS(10568),
    [anon_sym_PLUS_EQ] = ACTIONS(10568),
    [anon_sym_DASH_EQ] = ACTIONS(10568),
    [anon_sym_STAR_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10568),
    [anon_sym_SLASH_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10568),
    [anon_sym_AMP_EQ] = ACTIONS(10568),
    [anon_sym_PERCENT_EQ] = ACTIONS(10568),
    [anon_sym_GT_GT_EQ] = ACTIONS(10568),
    [anon_sym_LT_LT_EQ] = ACTIONS(10568),
    [anon_sym_CARET_EQ] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10570),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10570),
    [anon_sym_or] = ACTIONS(10570),
    [anon_sym_PIPE_PIPE] = ACTIONS(10570),
    [anon_sym_AMP_AMP] = ACTIONS(10570),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10570),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_SLASH] = ACTIONS(10570),
    [anon_sym_PERCENT] = ACTIONS(10570),
    [anon_sym_defined_QMARK] = ACTIONS(10568),
    [anon_sym_not] = ACTIONS(10570),
    [anon_sym_BANG] = ACTIONS(10570),
    [anon_sym_TILDE] = ACTIONS(10568),
    [sym_constant] = ACTIONS(10570),
    [sym_identifier] = ACTIONS(10570),
    [sym_instance_variable] = ACTIONS(10568),
    [sym_class_variable] = ACTIONS(10568),
    [sym_global_variable] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10570),
    [sym_float] = ACTIONS(10570),
    [sym_complex] = ACTIONS(10568),
    [sym_super] = ACTIONS(10570),
    [anon_sym_true] = ACTIONS(10570),
    [anon_sym_TRUE] = ACTIONS(10570),
    [anon_sym_false] = ACTIONS(10570),
    [anon_sym_FALSE] = ACTIONS(10570),
    [sym_self] = ACTIONS(10570),
    [anon_sym_nil] = ACTIONS(10570),
    [anon_sym_NIL] = ACTIONS(10570),
    [sym_character] = ACTIONS(10568),
    [anon_sym_LBRACK2] = ACTIONS(10570),
    [anon_sym_DASH_GT] = ACTIONS(10568),
  },
  [8796] = {
    [sym__heredoc_body_start] = ACTIONS(9793),
    [sym__binary_minus] = ACTIONS(9793),
    [sym__binary_star] = ACTIONS(9793),
    [anon_sym_LBRACE] = ACTIONS(9793),
    [anon_sym_RBRACE] = ACTIONS(9793),
    [anon_sym_RPAREN] = ACTIONS(9793),
    [anon_sym_DOT] = ACTIONS(9795),
    [anon_sym_COMMA] = ACTIONS(9793),
    [anon_sym_PIPE] = ACTIONS(9795),
    [anon_sym_SEMI] = ACTIONS(9793),
    [anon_sym_STAR_STAR] = ACTIONS(9795),
    [anon_sym_AMP] = ACTIONS(9795),
    [anon_sym_EQ] = ACTIONS(9795),
    [anon_sym_LT] = ACTIONS(9795),
    [anon_sym_if] = ACTIONS(9793),
    [anon_sym_unless] = ACTIONS(9793),
    [anon_sym_while] = ACTIONS(9793),
    [anon_sym_until] = ACTIONS(9793),
    [anon_sym_rescue] = ACTIONS(9793),
    [anon_sym_in] = ACTIONS(9793),
    [anon_sym_do] = ACTIONS(9793),
    [anon_sym_EQ_GT] = ACTIONS(9793),
    [anon_sym_LBRACK] = ACTIONS(9793),
    [anon_sym_RBRACK] = ACTIONS(9793),
    [anon_sym_COLON_COLON2] = ACTIONS(9793),
    [anon_sym_AMP_DOT] = ACTIONS(9793),
    [anon_sym_PLUS_EQ] = ACTIONS(9793),
    [anon_sym_DASH_EQ] = ACTIONS(9793),
    [anon_sym_STAR_EQ] = ACTIONS(9793),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9793),
    [anon_sym_SLASH_EQ] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9793),
    [anon_sym_PIPE_EQ] = ACTIONS(9793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9793),
    [anon_sym_AMP_EQ] = ACTIONS(9793),
    [anon_sym_PERCENT_EQ] = ACTIONS(9793),
    [anon_sym_GT_GT_EQ] = ACTIONS(9793),
    [anon_sym_LT_LT_EQ] = ACTIONS(9793),
    [anon_sym_CARET_EQ] = ACTIONS(9793),
    [anon_sym_QMARK] = ACTIONS(9793),
    [anon_sym_COLON2] = ACTIONS(9795),
    [anon_sym_DOT_DOT] = ACTIONS(9795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9793),
    [anon_sym_and] = ACTIONS(9793),
    [anon_sym_or] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE] = ACTIONS(9795),
    [anon_sym_AMP_AMP] = ACTIONS(9795),
    [anon_sym_LT_LT] = ACTIONS(9795),
    [anon_sym_GT_GT] = ACTIONS(9795),
    [anon_sym_EQ_EQ] = ACTIONS(9795),
    [anon_sym_BANG_EQ] = ACTIONS(9793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9793),
    [anon_sym_LT_EQ_GT] = ACTIONS(9793),
    [anon_sym_EQ_TILDE] = ACTIONS(9793),
    [anon_sym_BANG_TILDE] = ACTIONS(9793),
    [anon_sym_LT_EQ] = ACTIONS(9795),
    [anon_sym_GT] = ACTIONS(9795),
    [anon_sym_GT_EQ] = ACTIONS(9793),
    [anon_sym_CARET] = ACTIONS(9795),
    [anon_sym_PLUS] = ACTIONS(9795),
    [anon_sym_SLASH] = ACTIONS(9795),
    [anon_sym_PERCENT] = ACTIONS(9795),
    [sym_comment] = ACTIONS(87),
  },
  [8797] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13484),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8798] = {
    [sym__heredoc_body_start] = ACTIONS(9799),
    [sym__binary_minus] = ACTIONS(9799),
    [sym__binary_star] = ACTIONS(9799),
    [anon_sym_LBRACE] = ACTIONS(9799),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [anon_sym_RPAREN] = ACTIONS(9799),
    [anon_sym_DOT] = ACTIONS(9801),
    [anon_sym_COMMA] = ACTIONS(9799),
    [anon_sym_PIPE] = ACTIONS(9801),
    [anon_sym_SEMI] = ACTIONS(9799),
    [anon_sym_STAR_STAR] = ACTIONS(9801),
    [anon_sym_AMP] = ACTIONS(9801),
    [anon_sym_EQ] = ACTIONS(9801),
    [anon_sym_LT] = ACTIONS(9801),
    [anon_sym_if] = ACTIONS(9799),
    [anon_sym_unless] = ACTIONS(9799),
    [anon_sym_while] = ACTIONS(9799),
    [anon_sym_until] = ACTIONS(9799),
    [anon_sym_rescue] = ACTIONS(9799),
    [anon_sym_in] = ACTIONS(9799),
    [anon_sym_do] = ACTIONS(9799),
    [anon_sym_EQ_GT] = ACTIONS(9799),
    [anon_sym_LBRACK] = ACTIONS(9799),
    [anon_sym_RBRACK] = ACTIONS(9799),
    [anon_sym_COLON_COLON2] = ACTIONS(9799),
    [anon_sym_AMP_DOT] = ACTIONS(9799),
    [anon_sym_PLUS_EQ] = ACTIONS(9799),
    [anon_sym_DASH_EQ] = ACTIONS(9799),
    [anon_sym_STAR_EQ] = ACTIONS(9799),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9799),
    [anon_sym_SLASH_EQ] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9799),
    [anon_sym_PIPE_EQ] = ACTIONS(9799),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9799),
    [anon_sym_AMP_EQ] = ACTIONS(9799),
    [anon_sym_PERCENT_EQ] = ACTIONS(9799),
    [anon_sym_GT_GT_EQ] = ACTIONS(9799),
    [anon_sym_LT_LT_EQ] = ACTIONS(9799),
    [anon_sym_CARET_EQ] = ACTIONS(9799),
    [anon_sym_QMARK] = ACTIONS(9799),
    [anon_sym_COLON2] = ACTIONS(9801),
    [anon_sym_DOT_DOT] = ACTIONS(9801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9799),
    [anon_sym_and] = ACTIONS(9799),
    [anon_sym_or] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE] = ACTIONS(9801),
    [anon_sym_AMP_AMP] = ACTIONS(9801),
    [anon_sym_LT_LT] = ACTIONS(9801),
    [anon_sym_GT_GT] = ACTIONS(9801),
    [anon_sym_EQ_EQ] = ACTIONS(9801),
    [anon_sym_BANG_EQ] = ACTIONS(9799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9799),
    [anon_sym_LT_EQ_GT] = ACTIONS(9799),
    [anon_sym_EQ_TILDE] = ACTIONS(9799),
    [anon_sym_BANG_TILDE] = ACTIONS(9799),
    [anon_sym_LT_EQ] = ACTIONS(9801),
    [anon_sym_GT] = ACTIONS(9801),
    [anon_sym_GT_EQ] = ACTIONS(9799),
    [anon_sym_CARET] = ACTIONS(9801),
    [anon_sym_PLUS] = ACTIONS(9801),
    [anon_sym_SLASH] = ACTIONS(9801),
    [anon_sym_PERCENT] = ACTIONS(9801),
    [sym_comment] = ACTIONS(87),
  },
  [8799] = {
    [sym__heredoc_body_start] = ACTIONS(9803),
    [sym__binary_minus] = ACTIONS(9803),
    [sym__binary_star] = ACTIONS(9803),
    [anon_sym_LBRACE] = ACTIONS(9803),
    [anon_sym_RBRACE] = ACTIONS(9803),
    [anon_sym_RPAREN] = ACTIONS(9803),
    [anon_sym_DOT] = ACTIONS(9805),
    [anon_sym_COMMA] = ACTIONS(9803),
    [anon_sym_PIPE] = ACTIONS(9805),
    [anon_sym_SEMI] = ACTIONS(9803),
    [anon_sym_STAR_STAR] = ACTIONS(9805),
    [anon_sym_AMP] = ACTIONS(9805),
    [anon_sym_EQ] = ACTIONS(9805),
    [anon_sym_LT] = ACTIONS(9805),
    [anon_sym_if] = ACTIONS(9803),
    [anon_sym_unless] = ACTIONS(9803),
    [anon_sym_while] = ACTIONS(9803),
    [anon_sym_until] = ACTIONS(9803),
    [anon_sym_rescue] = ACTIONS(9803),
    [anon_sym_in] = ACTIONS(9803),
    [anon_sym_do] = ACTIONS(9803),
    [anon_sym_EQ_GT] = ACTIONS(9803),
    [anon_sym_LBRACK] = ACTIONS(9803),
    [anon_sym_RBRACK] = ACTIONS(9803),
    [anon_sym_COLON_COLON2] = ACTIONS(9803),
    [anon_sym_AMP_DOT] = ACTIONS(9803),
    [anon_sym_PLUS_EQ] = ACTIONS(9803),
    [anon_sym_DASH_EQ] = ACTIONS(9803),
    [anon_sym_STAR_EQ] = ACTIONS(9803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9803),
    [anon_sym_SLASH_EQ] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9803),
    [anon_sym_PIPE_EQ] = ACTIONS(9803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9803),
    [anon_sym_AMP_EQ] = ACTIONS(9803),
    [anon_sym_PERCENT_EQ] = ACTIONS(9803),
    [anon_sym_GT_GT_EQ] = ACTIONS(9803),
    [anon_sym_LT_LT_EQ] = ACTIONS(9803),
    [anon_sym_CARET_EQ] = ACTIONS(9803),
    [anon_sym_QMARK] = ACTIONS(9803),
    [anon_sym_COLON2] = ACTIONS(9805),
    [anon_sym_DOT_DOT] = ACTIONS(9805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9803),
    [anon_sym_and] = ACTIONS(9803),
    [anon_sym_or] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE] = ACTIONS(9805),
    [anon_sym_AMP_AMP] = ACTIONS(9805),
    [anon_sym_LT_LT] = ACTIONS(9805),
    [anon_sym_GT_GT] = ACTIONS(9805),
    [anon_sym_EQ_EQ] = ACTIONS(9805),
    [anon_sym_BANG_EQ] = ACTIONS(9803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9803),
    [anon_sym_LT_EQ_GT] = ACTIONS(9803),
    [anon_sym_EQ_TILDE] = ACTIONS(9803),
    [anon_sym_BANG_TILDE] = ACTIONS(9803),
    [anon_sym_LT_EQ] = ACTIONS(9805),
    [anon_sym_GT] = ACTIONS(9805),
    [anon_sym_GT_EQ] = ACTIONS(9803),
    [anon_sym_CARET] = ACTIONS(9805),
    [anon_sym_PLUS] = ACTIONS(9805),
    [anon_sym_SLASH] = ACTIONS(9805),
    [anon_sym_PERCENT] = ACTIONS(9805),
    [sym_comment] = ACTIONS(87),
  },
  [8800] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13486),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8801] = {
    [sym__heredoc_body_start] = ACTIONS(9809),
    [sym__binary_minus] = ACTIONS(9809),
    [sym__binary_star] = ACTIONS(9809),
    [anon_sym_LBRACE] = ACTIONS(9809),
    [anon_sym_RBRACE] = ACTIONS(9809),
    [anon_sym_RPAREN] = ACTIONS(9809),
    [anon_sym_DOT] = ACTIONS(9811),
    [anon_sym_COMMA] = ACTIONS(9809),
    [anon_sym_PIPE] = ACTIONS(9811),
    [anon_sym_SEMI] = ACTIONS(9809),
    [anon_sym_STAR_STAR] = ACTIONS(9811),
    [anon_sym_AMP] = ACTIONS(9811),
    [anon_sym_EQ] = ACTIONS(9811),
    [anon_sym_LT] = ACTIONS(9811),
    [anon_sym_if] = ACTIONS(9809),
    [anon_sym_unless] = ACTIONS(9809),
    [anon_sym_while] = ACTIONS(9809),
    [anon_sym_until] = ACTIONS(9809),
    [anon_sym_rescue] = ACTIONS(9809),
    [anon_sym_in] = ACTIONS(9809),
    [anon_sym_do] = ACTIONS(9809),
    [anon_sym_EQ_GT] = ACTIONS(9809),
    [anon_sym_LBRACK] = ACTIONS(9809),
    [anon_sym_RBRACK] = ACTIONS(9809),
    [anon_sym_COLON_COLON2] = ACTIONS(9809),
    [anon_sym_AMP_DOT] = ACTIONS(9809),
    [anon_sym_PLUS_EQ] = ACTIONS(9809),
    [anon_sym_DASH_EQ] = ACTIONS(9809),
    [anon_sym_STAR_EQ] = ACTIONS(9809),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9809),
    [anon_sym_SLASH_EQ] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9809),
    [anon_sym_PIPE_EQ] = ACTIONS(9809),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9809),
    [anon_sym_AMP_EQ] = ACTIONS(9809),
    [anon_sym_PERCENT_EQ] = ACTIONS(9809),
    [anon_sym_GT_GT_EQ] = ACTIONS(9809),
    [anon_sym_LT_LT_EQ] = ACTIONS(9809),
    [anon_sym_CARET_EQ] = ACTIONS(9809),
    [anon_sym_QMARK] = ACTIONS(9809),
    [anon_sym_COLON2] = ACTIONS(9811),
    [anon_sym_DOT_DOT] = ACTIONS(9811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9809),
    [anon_sym_and] = ACTIONS(9809),
    [anon_sym_or] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE] = ACTIONS(9811),
    [anon_sym_AMP_AMP] = ACTIONS(9811),
    [anon_sym_LT_LT] = ACTIONS(9811),
    [anon_sym_GT_GT] = ACTIONS(9811),
    [anon_sym_EQ_EQ] = ACTIONS(9811),
    [anon_sym_BANG_EQ] = ACTIONS(9809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9809),
    [anon_sym_LT_EQ_GT] = ACTIONS(9809),
    [anon_sym_EQ_TILDE] = ACTIONS(9809),
    [anon_sym_BANG_TILDE] = ACTIONS(9809),
    [anon_sym_LT_EQ] = ACTIONS(9811),
    [anon_sym_GT] = ACTIONS(9811),
    [anon_sym_GT_EQ] = ACTIONS(9809),
    [anon_sym_CARET] = ACTIONS(9811),
    [anon_sym_PLUS] = ACTIONS(9811),
    [anon_sym_SLASH] = ACTIONS(9811),
    [anon_sym_PERCENT] = ACTIONS(9811),
    [sym_comment] = ACTIONS(87),
  },
  [8802] = {
    [sym__method_rest] = STATE(9975),
    [sym_operator] = STATE(1944),
    [sym__method_name] = STATE(1944),
    [sym_setter] = STATE(1944),
    [sym_symbol] = STATE(1944),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(10110),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(10110),
    [sym_class_variable] = ACTIONS(10110),
    [sym_global_variable] = ACTIONS(10110),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [8803] = {
    [sym__heredoc_body_start] = ACTIONS(10532),
    [sym__binary_minus] = ACTIONS(10532),
    [sym__binary_star] = ACTIONS(10532),
    [anon_sym_LBRACE] = ACTIONS(10532),
    [anon_sym_RBRACE] = ACTIONS(10532),
    [anon_sym_RPAREN] = ACTIONS(10532),
    [anon_sym_DOT] = ACTIONS(10534),
    [anon_sym_COMMA] = ACTIONS(10532),
    [anon_sym_PIPE] = ACTIONS(10534),
    [anon_sym_SEMI] = ACTIONS(10532),
    [anon_sym_STAR_STAR] = ACTIONS(10534),
    [anon_sym_AMP] = ACTIONS(10534),
    [anon_sym_EQ] = ACTIONS(10534),
    [anon_sym_LT] = ACTIONS(10534),
    [anon_sym_if] = ACTIONS(10532),
    [anon_sym_unless] = ACTIONS(10532),
    [anon_sym_while] = ACTIONS(10532),
    [anon_sym_until] = ACTIONS(10532),
    [anon_sym_rescue] = ACTIONS(10532),
    [anon_sym_in] = ACTIONS(10532),
    [anon_sym_do] = ACTIONS(10532),
    [anon_sym_EQ_GT] = ACTIONS(10532),
    [anon_sym_LBRACK] = ACTIONS(10532),
    [anon_sym_RBRACK] = ACTIONS(10532),
    [anon_sym_COLON_COLON2] = ACTIONS(10532),
    [anon_sym_AMP_DOT] = ACTIONS(10532),
    [anon_sym_PLUS_EQ] = ACTIONS(10532),
    [anon_sym_DASH_EQ] = ACTIONS(10532),
    [anon_sym_STAR_EQ] = ACTIONS(10532),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10532),
    [anon_sym_SLASH_EQ] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10532),
    [anon_sym_PIPE_EQ] = ACTIONS(10532),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10532),
    [anon_sym_AMP_EQ] = ACTIONS(10532),
    [anon_sym_PERCENT_EQ] = ACTIONS(10532),
    [anon_sym_GT_GT_EQ] = ACTIONS(10532),
    [anon_sym_LT_LT_EQ] = ACTIONS(10532),
    [anon_sym_CARET_EQ] = ACTIONS(10532),
    [anon_sym_QMARK] = ACTIONS(10532),
    [anon_sym_COLON2] = ACTIONS(10534),
    [anon_sym_DOT_DOT] = ACTIONS(10534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10532),
    [anon_sym_and] = ACTIONS(10532),
    [anon_sym_or] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE] = ACTIONS(10534),
    [anon_sym_AMP_AMP] = ACTIONS(10534),
    [anon_sym_LT_LT] = ACTIONS(10534),
    [anon_sym_GT_GT] = ACTIONS(10534),
    [anon_sym_EQ_EQ] = ACTIONS(10534),
    [anon_sym_BANG_EQ] = ACTIONS(10532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10532),
    [anon_sym_LT_EQ_GT] = ACTIONS(10532),
    [anon_sym_EQ_TILDE] = ACTIONS(10532),
    [anon_sym_BANG_TILDE] = ACTIONS(10532),
    [anon_sym_LT_EQ] = ACTIONS(10534),
    [anon_sym_GT] = ACTIONS(10534),
    [anon_sym_GT_EQ] = ACTIONS(10532),
    [anon_sym_CARET] = ACTIONS(10534),
    [anon_sym_PLUS] = ACTIONS(10534),
    [anon_sym_SLASH] = ACTIONS(10534),
    [anon_sym_PERCENT] = ACTIONS(10534),
    [sym_comment] = ACTIONS(87),
  },
  [8804] = {
    [sym__heredoc_body_start] = ACTIONS(10536),
    [sym__binary_minus] = ACTIONS(10536),
    [sym__binary_star] = ACTIONS(10536),
    [anon_sym_LBRACE] = ACTIONS(10536),
    [anon_sym_RBRACE] = ACTIONS(10536),
    [anon_sym_RPAREN] = ACTIONS(10536),
    [anon_sym_DOT] = ACTIONS(10538),
    [anon_sym_COMMA] = ACTIONS(10536),
    [anon_sym_PIPE] = ACTIONS(10538),
    [anon_sym_SEMI] = ACTIONS(10536),
    [anon_sym_STAR_STAR] = ACTIONS(10538),
    [anon_sym_AMP] = ACTIONS(10538),
    [anon_sym_EQ] = ACTIONS(10538),
    [anon_sym_LT] = ACTIONS(10538),
    [anon_sym_if] = ACTIONS(10536),
    [anon_sym_unless] = ACTIONS(10536),
    [anon_sym_while] = ACTIONS(10536),
    [anon_sym_until] = ACTIONS(10536),
    [anon_sym_rescue] = ACTIONS(10536),
    [anon_sym_in] = ACTIONS(10536),
    [anon_sym_do] = ACTIONS(10536),
    [anon_sym_EQ_GT] = ACTIONS(10536),
    [anon_sym_LBRACK] = ACTIONS(10536),
    [anon_sym_RBRACK] = ACTIONS(10536),
    [anon_sym_COLON_COLON2] = ACTIONS(10536),
    [anon_sym_AMP_DOT] = ACTIONS(10536),
    [anon_sym_PLUS_EQ] = ACTIONS(10536),
    [anon_sym_DASH_EQ] = ACTIONS(10536),
    [anon_sym_STAR_EQ] = ACTIONS(10536),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10536),
    [anon_sym_SLASH_EQ] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10536),
    [anon_sym_PIPE_EQ] = ACTIONS(10536),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10536),
    [anon_sym_AMP_EQ] = ACTIONS(10536),
    [anon_sym_PERCENT_EQ] = ACTIONS(10536),
    [anon_sym_GT_GT_EQ] = ACTIONS(10536),
    [anon_sym_LT_LT_EQ] = ACTIONS(10536),
    [anon_sym_CARET_EQ] = ACTIONS(10536),
    [anon_sym_QMARK] = ACTIONS(10536),
    [anon_sym_COLON2] = ACTIONS(10538),
    [anon_sym_DOT_DOT] = ACTIONS(10538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10536),
    [anon_sym_and] = ACTIONS(10536),
    [anon_sym_or] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE] = ACTIONS(10538),
    [anon_sym_AMP_AMP] = ACTIONS(10538),
    [anon_sym_LT_LT] = ACTIONS(10538),
    [anon_sym_GT_GT] = ACTIONS(10538),
    [anon_sym_EQ_EQ] = ACTIONS(10538),
    [anon_sym_BANG_EQ] = ACTIONS(10536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10536),
    [anon_sym_LT_EQ_GT] = ACTIONS(10536),
    [anon_sym_EQ_TILDE] = ACTIONS(10536),
    [anon_sym_BANG_TILDE] = ACTIONS(10536),
    [anon_sym_LT_EQ] = ACTIONS(10538),
    [anon_sym_GT] = ACTIONS(10538),
    [anon_sym_GT_EQ] = ACTIONS(10536),
    [anon_sym_CARET] = ACTIONS(10538),
    [anon_sym_PLUS] = ACTIONS(10538),
    [anon_sym_SLASH] = ACTIONS(10538),
    [anon_sym_PERCENT] = ACTIONS(10538),
    [sym_comment] = ACTIONS(87),
  },
  [8805] = {
    [sym__heredoc_body_start] = ACTIONS(10689),
    [sym__binary_minus] = ACTIONS(10689),
    [sym__binary_star] = ACTIONS(10689),
    [anon_sym_LBRACE] = ACTIONS(10689),
    [anon_sym_RBRACE] = ACTIONS(10689),
    [anon_sym_RPAREN] = ACTIONS(10689),
    [anon_sym_DOT] = ACTIONS(10691),
    [anon_sym_COMMA] = ACTIONS(10689),
    [anon_sym_PIPE] = ACTIONS(10691),
    [anon_sym_SEMI] = ACTIONS(10689),
    [anon_sym_STAR_STAR] = ACTIONS(10691),
    [anon_sym_AMP] = ACTIONS(10691),
    [anon_sym_EQ] = ACTIONS(10691),
    [anon_sym_LT] = ACTIONS(10691),
    [anon_sym_if] = ACTIONS(10689),
    [anon_sym_unless] = ACTIONS(10689),
    [anon_sym_while] = ACTIONS(10689),
    [anon_sym_until] = ACTIONS(10689),
    [anon_sym_rescue] = ACTIONS(10689),
    [anon_sym_in] = ACTIONS(10689),
    [anon_sym_do] = ACTIONS(10689),
    [anon_sym_EQ_GT] = ACTIONS(10689),
    [anon_sym_LBRACK] = ACTIONS(10689),
    [anon_sym_RBRACK] = ACTIONS(10689),
    [anon_sym_COLON_COLON2] = ACTIONS(10689),
    [anon_sym_AMP_DOT] = ACTIONS(10689),
    [anon_sym_PLUS_EQ] = ACTIONS(10689),
    [anon_sym_DASH_EQ] = ACTIONS(10689),
    [anon_sym_STAR_EQ] = ACTIONS(10689),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10689),
    [anon_sym_SLASH_EQ] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10689),
    [anon_sym_PIPE_EQ] = ACTIONS(10689),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10689),
    [anon_sym_AMP_EQ] = ACTIONS(10689),
    [anon_sym_PERCENT_EQ] = ACTIONS(10689),
    [anon_sym_GT_GT_EQ] = ACTIONS(10689),
    [anon_sym_LT_LT_EQ] = ACTIONS(10689),
    [anon_sym_CARET_EQ] = ACTIONS(10689),
    [anon_sym_QMARK] = ACTIONS(10689),
    [anon_sym_COLON2] = ACTIONS(10691),
    [anon_sym_DOT_DOT] = ACTIONS(10691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10689),
    [anon_sym_and] = ACTIONS(10689),
    [anon_sym_or] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE] = ACTIONS(10691),
    [anon_sym_AMP_AMP] = ACTIONS(10691),
    [anon_sym_LT_LT] = ACTIONS(10691),
    [anon_sym_GT_GT] = ACTIONS(10691),
    [anon_sym_EQ_EQ] = ACTIONS(10691),
    [anon_sym_BANG_EQ] = ACTIONS(10689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10689),
    [anon_sym_LT_EQ_GT] = ACTIONS(10689),
    [anon_sym_EQ_TILDE] = ACTIONS(10689),
    [anon_sym_BANG_TILDE] = ACTIONS(10689),
    [anon_sym_LT_EQ] = ACTIONS(10691),
    [anon_sym_GT] = ACTIONS(10691),
    [anon_sym_GT_EQ] = ACTIONS(10689),
    [anon_sym_CARET] = ACTIONS(10691),
    [anon_sym_PLUS] = ACTIONS(10691),
    [anon_sym_SLASH] = ACTIONS(10691),
    [anon_sym_PERCENT] = ACTIONS(10691),
    [sym_comment] = ACTIONS(87),
  },
  [8806] = {
    [anon_sym_end] = ACTIONS(13488),
    [sym_comment] = ACTIONS(87),
  },
  [8807] = {
    [sym_elsif] = STATE(9977),
    [sym_else] = STATE(9977),
    [sym__if_tail] = STATE(9977),
    [anon_sym_end] = ACTIONS(13488),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [8808] = {
    [sym__heredoc_body_start] = ACTIONS(10856),
    [sym__binary_minus] = ACTIONS(10856),
    [sym__binary_star] = ACTIONS(10856),
    [anon_sym_LBRACE] = ACTIONS(10856),
    [anon_sym_RBRACE] = ACTIONS(10856),
    [anon_sym_RPAREN] = ACTIONS(10856),
    [anon_sym_DOT] = ACTIONS(10858),
    [anon_sym_COMMA] = ACTIONS(10856),
    [anon_sym_PIPE] = ACTIONS(10858),
    [anon_sym_SEMI] = ACTIONS(10856),
    [anon_sym_STAR_STAR] = ACTIONS(10858),
    [anon_sym_AMP] = ACTIONS(10858),
    [anon_sym_EQ] = ACTIONS(10858),
    [anon_sym_LT] = ACTIONS(10858),
    [anon_sym_if] = ACTIONS(10856),
    [anon_sym_unless] = ACTIONS(10856),
    [anon_sym_while] = ACTIONS(10856),
    [anon_sym_until] = ACTIONS(10856),
    [anon_sym_rescue] = ACTIONS(10856),
    [anon_sym_in] = ACTIONS(10856),
    [anon_sym_do] = ACTIONS(10856),
    [anon_sym_EQ_GT] = ACTIONS(10856),
    [anon_sym_LBRACK] = ACTIONS(10856),
    [anon_sym_RBRACK] = ACTIONS(10856),
    [anon_sym_COLON_COLON2] = ACTIONS(10856),
    [anon_sym_AMP_DOT] = ACTIONS(10856),
    [anon_sym_PLUS_EQ] = ACTIONS(10856),
    [anon_sym_DASH_EQ] = ACTIONS(10856),
    [anon_sym_STAR_EQ] = ACTIONS(10856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10856),
    [anon_sym_SLASH_EQ] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10856),
    [anon_sym_PIPE_EQ] = ACTIONS(10856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10856),
    [anon_sym_AMP_EQ] = ACTIONS(10856),
    [anon_sym_PERCENT_EQ] = ACTIONS(10856),
    [anon_sym_GT_GT_EQ] = ACTIONS(10856),
    [anon_sym_LT_LT_EQ] = ACTIONS(10856),
    [anon_sym_CARET_EQ] = ACTIONS(10856),
    [anon_sym_QMARK] = ACTIONS(10856),
    [anon_sym_COLON2] = ACTIONS(10858),
    [anon_sym_DOT_DOT] = ACTIONS(10858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10856),
    [anon_sym_and] = ACTIONS(10856),
    [anon_sym_or] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE] = ACTIONS(10858),
    [anon_sym_AMP_AMP] = ACTIONS(10858),
    [anon_sym_LT_LT] = ACTIONS(10858),
    [anon_sym_GT_GT] = ACTIONS(10858),
    [anon_sym_EQ_EQ] = ACTIONS(10858),
    [anon_sym_BANG_EQ] = ACTIONS(10856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10856),
    [anon_sym_LT_EQ_GT] = ACTIONS(10856),
    [anon_sym_EQ_TILDE] = ACTIONS(10856),
    [anon_sym_BANG_TILDE] = ACTIONS(10856),
    [anon_sym_LT_EQ] = ACTIONS(10858),
    [anon_sym_GT] = ACTIONS(10858),
    [anon_sym_GT_EQ] = ACTIONS(10856),
    [anon_sym_CARET] = ACTIONS(10858),
    [anon_sym_PLUS] = ACTIONS(10858),
    [anon_sym_SLASH] = ACTIONS(10858),
    [anon_sym_PERCENT] = ACTIONS(10858),
    [sym_comment] = ACTIONS(87),
  },
  [8809] = {
    [anon_sym_end] = ACTIONS(13490),
    [sym_comment] = ACTIONS(87),
  },
  [8810] = {
    [sym__heredoc_body_start] = ACTIONS(10951),
    [sym__binary_minus] = ACTIONS(10951),
    [sym__binary_star] = ACTIONS(10951),
    [anon_sym_LBRACE] = ACTIONS(10951),
    [anon_sym_RBRACE] = ACTIONS(10951),
    [anon_sym_RPAREN] = ACTIONS(10951),
    [anon_sym_DOT] = ACTIONS(10953),
    [anon_sym_COMMA] = ACTIONS(10951),
    [anon_sym_PIPE] = ACTIONS(10953),
    [anon_sym_SEMI] = ACTIONS(10951),
    [anon_sym_STAR_STAR] = ACTIONS(10953),
    [anon_sym_AMP] = ACTIONS(10953),
    [anon_sym_EQ] = ACTIONS(10953),
    [anon_sym_LT] = ACTIONS(10953),
    [anon_sym_if] = ACTIONS(10951),
    [anon_sym_unless] = ACTIONS(10951),
    [anon_sym_while] = ACTIONS(10951),
    [anon_sym_until] = ACTIONS(10951),
    [anon_sym_rescue] = ACTIONS(10951),
    [anon_sym_in] = ACTIONS(10951),
    [anon_sym_do] = ACTIONS(10951),
    [anon_sym_EQ_GT] = ACTIONS(10951),
    [anon_sym_LBRACK] = ACTIONS(10951),
    [anon_sym_RBRACK] = ACTIONS(10951),
    [anon_sym_COLON_COLON2] = ACTIONS(10951),
    [anon_sym_AMP_DOT] = ACTIONS(10951),
    [anon_sym_PLUS_EQ] = ACTIONS(10951),
    [anon_sym_DASH_EQ] = ACTIONS(10951),
    [anon_sym_STAR_EQ] = ACTIONS(10951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10951),
    [anon_sym_SLASH_EQ] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10951),
    [anon_sym_PIPE_EQ] = ACTIONS(10951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10951),
    [anon_sym_AMP_EQ] = ACTIONS(10951),
    [anon_sym_PERCENT_EQ] = ACTIONS(10951),
    [anon_sym_GT_GT_EQ] = ACTIONS(10951),
    [anon_sym_LT_LT_EQ] = ACTIONS(10951),
    [anon_sym_CARET_EQ] = ACTIONS(10951),
    [anon_sym_QMARK] = ACTIONS(10951),
    [anon_sym_COLON2] = ACTIONS(10953),
    [anon_sym_DOT_DOT] = ACTIONS(10953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10951),
    [anon_sym_and] = ACTIONS(10951),
    [anon_sym_or] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE] = ACTIONS(10953),
    [anon_sym_AMP_AMP] = ACTIONS(10953),
    [anon_sym_LT_LT] = ACTIONS(10953),
    [anon_sym_GT_GT] = ACTIONS(10953),
    [anon_sym_EQ_EQ] = ACTIONS(10953),
    [anon_sym_BANG_EQ] = ACTIONS(10951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10951),
    [anon_sym_LT_EQ_GT] = ACTIONS(10951),
    [anon_sym_EQ_TILDE] = ACTIONS(10951),
    [anon_sym_BANG_TILDE] = ACTIONS(10951),
    [anon_sym_LT_EQ] = ACTIONS(10953),
    [anon_sym_GT] = ACTIONS(10953),
    [anon_sym_GT_EQ] = ACTIONS(10951),
    [anon_sym_CARET] = ACTIONS(10953),
    [anon_sym_PLUS] = ACTIONS(10953),
    [anon_sym_SLASH] = ACTIONS(10953),
    [anon_sym_PERCENT] = ACTIONS(10953),
    [sym_comment] = ACTIONS(87),
  },
  [8811] = {
    [sym__heredoc_body_start] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10960),
    [anon_sym_LBRACE] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10960),
    [anon_sym_RPAREN] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [anon_sym_AMP] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [anon_sym_in] = ACTIONS(10960),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_EQ_GT] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10960),
    [anon_sym_RBRACK] = ACTIONS(10960),
    [anon_sym_COLON_COLON2] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10960),
    [anon_sym_PLUS_EQ] = ACTIONS(10960),
    [anon_sym_DASH_EQ] = ACTIONS(10960),
    [anon_sym_STAR_EQ] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_EQ] = ACTIONS(10960),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10960),
    [anon_sym_PERCENT_EQ] = ACTIONS(10960),
    [anon_sym_GT_GT_EQ] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10960),
    [anon_sym_CARET_EQ] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_COLON2] = ACTIONS(10962),
    [anon_sym_DOT_DOT] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10962),
    [anon_sym_GT] = ACTIONS(10962),
    [anon_sym_GT_EQ] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10962),
    [anon_sym_PLUS] = ACTIONS(10962),
    [anon_sym_SLASH] = ACTIONS(10962),
    [anon_sym_PERCENT] = ACTIONS(10962),
    [sym_comment] = ACTIONS(87),
  },
  [8812] = {
    [sym__heredoc_body_start] = ACTIONS(11007),
    [sym__binary_minus] = ACTIONS(11007),
    [sym__binary_star] = ACTIONS(11007),
    [anon_sym_LBRACE] = ACTIONS(11007),
    [anon_sym_RBRACE] = ACTIONS(11007),
    [anon_sym_RPAREN] = ACTIONS(11007),
    [anon_sym_DOT] = ACTIONS(11009),
    [anon_sym_COMMA] = ACTIONS(11007),
    [anon_sym_PIPE] = ACTIONS(11009),
    [anon_sym_SEMI] = ACTIONS(11007),
    [anon_sym_STAR_STAR] = ACTIONS(11009),
    [anon_sym_AMP] = ACTIONS(11009),
    [anon_sym_EQ] = ACTIONS(11009),
    [anon_sym_LT] = ACTIONS(11009),
    [anon_sym_if] = ACTIONS(11007),
    [anon_sym_unless] = ACTIONS(11007),
    [anon_sym_while] = ACTIONS(11007),
    [anon_sym_until] = ACTIONS(11007),
    [anon_sym_rescue] = ACTIONS(11007),
    [anon_sym_in] = ACTIONS(11007),
    [anon_sym_do] = ACTIONS(11007),
    [anon_sym_EQ_GT] = ACTIONS(11007),
    [anon_sym_LBRACK] = ACTIONS(11007),
    [anon_sym_RBRACK] = ACTIONS(11007),
    [anon_sym_COLON_COLON2] = ACTIONS(11007),
    [anon_sym_AMP_DOT] = ACTIONS(11007),
    [anon_sym_PLUS_EQ] = ACTIONS(11007),
    [anon_sym_DASH_EQ] = ACTIONS(11007),
    [anon_sym_STAR_EQ] = ACTIONS(11007),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11007),
    [anon_sym_SLASH_EQ] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11007),
    [anon_sym_PIPE_EQ] = ACTIONS(11007),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11007),
    [anon_sym_AMP_EQ] = ACTIONS(11007),
    [anon_sym_PERCENT_EQ] = ACTIONS(11007),
    [anon_sym_GT_GT_EQ] = ACTIONS(11007),
    [anon_sym_LT_LT_EQ] = ACTIONS(11007),
    [anon_sym_CARET_EQ] = ACTIONS(11007),
    [anon_sym_QMARK] = ACTIONS(11007),
    [anon_sym_COLON2] = ACTIONS(11009),
    [anon_sym_DOT_DOT] = ACTIONS(11009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11007),
    [anon_sym_and] = ACTIONS(11007),
    [anon_sym_or] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE] = ACTIONS(11009),
    [anon_sym_AMP_AMP] = ACTIONS(11009),
    [anon_sym_LT_LT] = ACTIONS(11009),
    [anon_sym_GT_GT] = ACTIONS(11009),
    [anon_sym_EQ_EQ] = ACTIONS(11009),
    [anon_sym_BANG_EQ] = ACTIONS(11007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11007),
    [anon_sym_LT_EQ_GT] = ACTIONS(11007),
    [anon_sym_EQ_TILDE] = ACTIONS(11007),
    [anon_sym_BANG_TILDE] = ACTIONS(11007),
    [anon_sym_LT_EQ] = ACTIONS(11009),
    [anon_sym_GT] = ACTIONS(11009),
    [anon_sym_GT_EQ] = ACTIONS(11007),
    [anon_sym_CARET] = ACTIONS(11009),
    [anon_sym_PLUS] = ACTIONS(11009),
    [anon_sym_SLASH] = ACTIONS(11009),
    [anon_sym_PERCENT] = ACTIONS(11009),
    [sym_comment] = ACTIONS(87),
  },
  [8813] = {
    [anon_sym_end] = ACTIONS(13492),
    [sym_comment] = ACTIONS(87),
  },
  [8814] = {
    [sym__binary_minus] = ACTIONS(13264),
    [sym__binary_star] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13266),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13266),
    [anon_sym_STAR_STAR] = ACTIONS(13266),
    [anon_sym_AMP] = ACTIONS(13266),
    [anon_sym_EQ] = ACTIONS(13266),
    [anon_sym_LT] = ACTIONS(13266),
    [anon_sym_EQ_GT] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [anon_sym_PLUS_EQ] = ACTIONS(13264),
    [anon_sym_DASH_EQ] = ACTIONS(13264),
    [anon_sym_STAR_EQ] = ACTIONS(13264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13264),
    [anon_sym_SLASH_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13264),
    [anon_sym_AMP_EQ] = ACTIONS(13264),
    [anon_sym_PERCENT_EQ] = ACTIONS(13264),
    [anon_sym_GT_GT_EQ] = ACTIONS(13264),
    [anon_sym_LT_LT_EQ] = ACTIONS(13264),
    [anon_sym_CARET_EQ] = ACTIONS(13264),
    [anon_sym_QMARK] = ACTIONS(13264),
    [anon_sym_DOT_DOT] = ACTIONS(13266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13264),
    [anon_sym_and] = ACTIONS(13264),
    [anon_sym_or] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE] = ACTIONS(13266),
    [anon_sym_AMP_AMP] = ACTIONS(13266),
    [anon_sym_LT_LT] = ACTIONS(13266),
    [anon_sym_GT_GT] = ACTIONS(13266),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13264),
    [anon_sym_LT_EQ_GT] = ACTIONS(13264),
    [anon_sym_EQ_TILDE] = ACTIONS(13264),
    [anon_sym_BANG_TILDE] = ACTIONS(13264),
    [anon_sym_LT_EQ] = ACTIONS(13266),
    [anon_sym_GT] = ACTIONS(13266),
    [anon_sym_GT_EQ] = ACTIONS(13264),
    [anon_sym_CARET] = ACTIONS(13266),
    [anon_sym_PLUS] = ACTIONS(13266),
    [anon_sym_SLASH] = ACTIONS(13266),
    [anon_sym_PERCENT] = ACTIONS(13266),
    [sym_comment] = ACTIONS(87),
  },
  [8815] = {
    [anon_sym_end] = ACTIONS(13494),
    [sym_comment] = ACTIONS(87),
  },
  [8816] = {
    [sym__heredoc_body_start] = ACTIONS(11020),
    [sym__binary_minus] = ACTIONS(11020),
    [sym__binary_star] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_RBRACE] = ACTIONS(11020),
    [anon_sym_RPAREN] = ACTIONS(11020),
    [anon_sym_DOT] = ACTIONS(11022),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_PIPE] = ACTIONS(11022),
    [anon_sym_SEMI] = ACTIONS(11020),
    [anon_sym_STAR_STAR] = ACTIONS(11022),
    [anon_sym_AMP] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(11022),
    [anon_sym_LT] = ACTIONS(11022),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_unless] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [anon_sym_until] = ACTIONS(11020),
    [anon_sym_rescue] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_do] = ACTIONS(11020),
    [anon_sym_EQ_GT] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_RBRACK] = ACTIONS(11020),
    [anon_sym_COLON_COLON2] = ACTIONS(11020),
    [anon_sym_AMP_DOT] = ACTIONS(11020),
    [anon_sym_PLUS_EQ] = ACTIONS(11020),
    [anon_sym_DASH_EQ] = ACTIONS(11020),
    [anon_sym_STAR_EQ] = ACTIONS(11020),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11020),
    [anon_sym_SLASH_EQ] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11020),
    [anon_sym_PIPE_EQ] = ACTIONS(11020),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11020),
    [anon_sym_AMP_EQ] = ACTIONS(11020),
    [anon_sym_PERCENT_EQ] = ACTIONS(11020),
    [anon_sym_GT_GT_EQ] = ACTIONS(11020),
    [anon_sym_LT_LT_EQ] = ACTIONS(11020),
    [anon_sym_CARET_EQ] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11022),
    [anon_sym_DOT_DOT] = ACTIONS(11022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_and] = ACTIONS(11020),
    [anon_sym_or] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE] = ACTIONS(11022),
    [anon_sym_AMP_AMP] = ACTIONS(11022),
    [anon_sym_LT_LT] = ACTIONS(11022),
    [anon_sym_GT_GT] = ACTIONS(11022),
    [anon_sym_EQ_EQ] = ACTIONS(11022),
    [anon_sym_BANG_EQ] = ACTIONS(11020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11020),
    [anon_sym_LT_EQ_GT] = ACTIONS(11020),
    [anon_sym_EQ_TILDE] = ACTIONS(11020),
    [anon_sym_BANG_TILDE] = ACTIONS(11020),
    [anon_sym_LT_EQ] = ACTIONS(11022),
    [anon_sym_GT] = ACTIONS(11022),
    [anon_sym_GT_EQ] = ACTIONS(11020),
    [anon_sym_CARET] = ACTIONS(11022),
    [anon_sym_PLUS] = ACTIONS(11022),
    [anon_sym_SLASH] = ACTIONS(11022),
    [anon_sym_PERCENT] = ACTIONS(11022),
    [sym_comment] = ACTIONS(87),
  },
  [8817] = {
    [anon_sym_end] = ACTIONS(13496),
    [sym_comment] = ACTIONS(87),
  },
  [8818] = {
    [sym__heredoc_body_start] = ACTIONS(11466),
    [sym__binary_minus] = ACTIONS(11466),
    [sym__binary_star] = ACTIONS(11466),
    [anon_sym_LBRACE] = ACTIONS(11466),
    [anon_sym_RBRACE] = ACTIONS(11466),
    [anon_sym_RPAREN] = ACTIONS(11466),
    [anon_sym_DOT] = ACTIONS(11468),
    [anon_sym_COMMA] = ACTIONS(11466),
    [anon_sym_PIPE] = ACTIONS(11468),
    [anon_sym_SEMI] = ACTIONS(11466),
    [anon_sym_STAR_STAR] = ACTIONS(11468),
    [anon_sym_AMP] = ACTIONS(11468),
    [anon_sym_EQ] = ACTIONS(11468),
    [anon_sym_LT] = ACTIONS(11468),
    [anon_sym_if] = ACTIONS(11466),
    [anon_sym_unless] = ACTIONS(11466),
    [anon_sym_while] = ACTIONS(11466),
    [anon_sym_until] = ACTIONS(11466),
    [anon_sym_rescue] = ACTIONS(11466),
    [anon_sym_in] = ACTIONS(11466),
    [anon_sym_do] = ACTIONS(11466),
    [anon_sym_EQ_GT] = ACTIONS(11466),
    [anon_sym_LBRACK] = ACTIONS(11466),
    [anon_sym_RBRACK] = ACTIONS(11466),
    [anon_sym_COLON_COLON2] = ACTIONS(11466),
    [anon_sym_AMP_DOT] = ACTIONS(11466),
    [anon_sym_PLUS_EQ] = ACTIONS(11466),
    [anon_sym_DASH_EQ] = ACTIONS(11466),
    [anon_sym_STAR_EQ] = ACTIONS(11466),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11466),
    [anon_sym_SLASH_EQ] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11466),
    [anon_sym_PIPE_EQ] = ACTIONS(11466),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11466),
    [anon_sym_AMP_EQ] = ACTIONS(11466),
    [anon_sym_PERCENT_EQ] = ACTIONS(11466),
    [anon_sym_GT_GT_EQ] = ACTIONS(11466),
    [anon_sym_LT_LT_EQ] = ACTIONS(11466),
    [anon_sym_CARET_EQ] = ACTIONS(11466),
    [anon_sym_QMARK] = ACTIONS(11466),
    [anon_sym_COLON2] = ACTIONS(11468),
    [anon_sym_DOT_DOT] = ACTIONS(11468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11466),
    [anon_sym_and] = ACTIONS(11466),
    [anon_sym_or] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE] = ACTIONS(11468),
    [anon_sym_AMP_AMP] = ACTIONS(11468),
    [anon_sym_LT_LT] = ACTIONS(11468),
    [anon_sym_GT_GT] = ACTIONS(11468),
    [anon_sym_EQ_EQ] = ACTIONS(11468),
    [anon_sym_BANG_EQ] = ACTIONS(11466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11466),
    [anon_sym_LT_EQ_GT] = ACTIONS(11466),
    [anon_sym_EQ_TILDE] = ACTIONS(11466),
    [anon_sym_BANG_TILDE] = ACTIONS(11466),
    [anon_sym_LT_EQ] = ACTIONS(11468),
    [anon_sym_GT] = ACTIONS(11468),
    [anon_sym_GT_EQ] = ACTIONS(11466),
    [anon_sym_CARET] = ACTIONS(11468),
    [anon_sym_PLUS] = ACTIONS(11468),
    [anon_sym_SLASH] = ACTIONS(11468),
    [anon_sym_PERCENT] = ACTIONS(11468),
    [sym_comment] = ACTIONS(87),
  },
  [8819] = {
    [anon_sym_end] = ACTIONS(13498),
    [sym_comment] = ACTIONS(87),
  },
  [8820] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(3374),
    [sym__binary_star] = ACTIONS(3376),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LT_EQ_GT] = ACTIONS(3396),
    [anon_sym_EQ_TILDE] = ACTIONS(3396),
    [anon_sym_BANG_TILDE] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3384),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [sym_comment] = ACTIONS(87),
  },
  [8821] = {
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11972),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [8822] = {
    [aux_sym_exceptions_repeat1] = STATE(8822),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13500),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [8823] = {
    [sym_method] = STATE(114),
    [sym_singleton_method] = STATE(114),
    [sym_class] = STATE(114),
    [sym_singleton_class] = STATE(114),
    [sym_module] = STATE(114),
    [sym_return] = STATE(114),
    [sym_yield] = STATE(114),
    [sym_break] = STATE(114),
    [sym_next] = STATE(114),
    [sym_while] = STATE(114),
    [sym_until] = STATE(114),
    [sym_for] = STATE(114),
    [sym_case] = STATE(114),
    [sym_if] = STATE(114),
    [sym_unless] = STATE(114),
    [sym_begin] = STATE(114),
    [sym__arg] = STATE(9983),
    [sym__primary] = STATE(114),
    [sym_parenthesized_statements] = STATE(114),
    [sym_element_reference] = STATE(2020),
    [sym_scope_resolution] = STATE(115),
    [sym_call] = STATE(115),
    [sym_method_call] = STATE(2020),
    [sym_assignment] = STATE(9983),
    [sym_operator_assignment] = STATE(9983),
    [sym_conditional] = STATE(9983),
    [sym_range] = STATE(9983),
    [sym_binary] = STATE(9983),
    [sym_unary] = STATE(9983),
    [sym_left_assignment_list] = STATE(2019),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2020),
    [sym__variable] = STATE(115),
    [sym_rational] = STATE(114),
    [sym_true] = STATE(2020),
    [sym_false] = STATE(2020),
    [sym_nil] = STATE(2020),
    [sym_chained_string] = STATE(114),
    [sym_string] = STATE(2021),
    [sym_subshell] = STATE(114),
    [sym_string_array] = STATE(114),
    [sym_symbol_array] = STATE(114),
    [sym_symbol] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_array] = STATE(114),
    [sym_hash] = STATE(114),
    [sym_lambda] = STATE(114),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(153),
    [sym__unary_minus] = ACTIONS(3422),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3426),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_next] = ACTIONS(3430),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_defined_QMARK] = ACTIONS(3434),
    [anon_sym_not] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3438),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8824] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [8825] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8826] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [8827] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [8828] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [8829] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13503),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8830] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [8831] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(10177),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [8832] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [8833] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [8834] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(10177),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [8835] = {
    [aux_sym_exceptions_repeat1] = STATE(9986),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8836] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(10177),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [8837] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9987),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_assignment] = STATE(9987),
    [sym_operator_assignment] = STATE(9987),
    [sym_conditional] = STATE(9987),
    [sym_range] = STATE(9987),
    [sym_binary] = STATE(9987),
    [sym_unary] = STATE(9987),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8838] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6871),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2043),
    [sym_scope_resolution] = STATE(906),
    [sym_call] = STATE(906),
    [sym_method_call] = STATE(2043),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(6871),
    [sym_operator_assignment] = STATE(6871),
    [sym_conditional] = STATE(6871),
    [sym_range] = STATE(6871),
    [sym_binary] = STATE(6871),
    [sym_unary] = STATE(6871),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(2042),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2043),
    [sym__variable] = STATE(906),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2043),
    [sym_false] = STATE(2043),
    [sym_nil] = STATE(2043),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(2465),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(4154),
    [sym__unary_minus] = ACTIONS(3460),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_yield] = ACTIONS(1605),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_next] = ACTIONS(1609),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6916),
    [anon_sym_defined_QMARK] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3466),
    [anon_sym_BANG] = ACTIONS(3470),
    [anon_sym_TILDE] = ACTIONS(3470),
    [sym_constant] = ACTIONS(1623),
    [sym_identifier] = ACTIONS(1623),
    [sym_instance_variable] = ACTIONS(1621),
    [sym_class_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1623),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1623),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8839] = {
    [aux_sym_exceptions_repeat1] = STATE(9988),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13505),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8840] = {
    [sym__binary_minus] = ACTIONS(3474),
    [sym__binary_star] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ_GT] = ACTIONS(3494),
    [anon_sym_EQ_TILDE] = ACTIONS(3494),
    [anon_sym_BANG_TILDE] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3484),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_GT_EQ] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3474),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [8841] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8842] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [8843] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8844] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8845] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8846] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13507),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8847] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8848] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8849] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8850] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8851] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8852] = {
    [aux_sym_exceptions_repeat1] = STATE(9991),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [8853] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [8854] = {
    [sym_string] = STATE(8854),
    [aux_sym_chained_string_repeat1] = STATE(8854),
    [sym__string_start] = ACTIONS(13427),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [8855] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9992),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_assignment] = STATE(9992),
    [sym_operator_assignment] = STATE(9992),
    [sym_conditional] = STATE(9992),
    [sym_range] = STATE(9992),
    [sym_binary] = STATE(9992),
    [sym_unary] = STATE(9992),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8856] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6907),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2074),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2074),
    [sym_splat_argument] = STATE(8821),
    [sym_assignment] = STATE(6907),
    [sym_operator_assignment] = STATE(6907),
    [sym_conditional] = STATE(6907),
    [sym_range] = STATE(6907),
    [sym_binary] = STATE(6907),
    [sym_unary] = STATE(6907),
    [sym__arg_or_splat_arg] = STATE(8821),
    [sym_left_assignment_list] = STATE(2073),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2074),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2074),
    [sym_false] = STATE(2074),
    [sym_nil] = STATE(2074),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4367),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(4192),
    [sym__unary_minus] = ACTIONS(3508),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(3512),
    [anon_sym_yield] = ACTIONS(3514),
    [anon_sym_break] = ACTIONS(3516),
    [anon_sym_next] = ACTIONS(3518),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(6982),
    [anon_sym_defined_QMARK] = ACTIONS(3520),
    [anon_sym_not] = ACTIONS(3522),
    [anon_sym_BANG] = ACTIONS(3526),
    [anon_sym_TILDE] = ACTIONS(3526),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8857] = {
    [aux_sym_exceptions_repeat1] = STATE(9993),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13509),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [8858] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [8859] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8860] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [8861] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [8862] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [8863] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13511),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8864] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(10247),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(10251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10253),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(10255),
    [anon_sym_AMP_AMP] = ACTIONS(10255),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(10259),
    [anon_sym_BANG_EQ] = ACTIONS(10255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10255),
    [anon_sym_LT_EQ_GT] = ACTIONS(10255),
    [anon_sym_EQ_TILDE] = ACTIONS(10255),
    [anon_sym_BANG_TILDE] = ACTIONS(10255),
    [anon_sym_LT_EQ] = ACTIONS(10247),
    [anon_sym_GT] = ACTIONS(10247),
    [anon_sym_GT_EQ] = ACTIONS(10261),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [8865] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(10247),
    [anon_sym_QMARK] = ACTIONS(10249),
    [anon_sym_DOT_DOT] = ACTIONS(10251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10253),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(10255),
    [anon_sym_AMP_AMP] = ACTIONS(10255),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(10259),
    [anon_sym_BANG_EQ] = ACTIONS(10255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10255),
    [anon_sym_LT_EQ_GT] = ACTIONS(10255),
    [anon_sym_EQ_TILDE] = ACTIONS(10255),
    [anon_sym_BANG_TILDE] = ACTIONS(10255),
    [anon_sym_LT_EQ] = ACTIONS(10247),
    [anon_sym_GT] = ACTIONS(10247),
    [anon_sym_GT_EQ] = ACTIONS(10261),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [8866] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(10247),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(10259),
    [anon_sym_BANG_EQ] = ACTIONS(10255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10255),
    [anon_sym_LT_EQ_GT] = ACTIONS(10255),
    [anon_sym_EQ_TILDE] = ACTIONS(10255),
    [anon_sym_BANG_TILDE] = ACTIONS(10255),
    [anon_sym_LT_EQ] = ACTIONS(10247),
    [anon_sym_GT] = ACTIONS(10247),
    [anon_sym_GT_EQ] = ACTIONS(10261),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [8867] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [8868] = {
    [aux_sym_exceptions_repeat1] = STATE(8868),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13513),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [8869] = {
    [aux_sym_exceptions_repeat1] = STATE(6925),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8870] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(10247),
    [anon_sym_QMARK] = ACTIONS(10249),
    [anon_sym_DOT_DOT] = ACTIONS(10251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10253),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10255),
    [anon_sym_AMP_AMP] = ACTIONS(10255),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(10259),
    [anon_sym_BANG_EQ] = ACTIONS(10255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10255),
    [anon_sym_LT_EQ_GT] = ACTIONS(10255),
    [anon_sym_EQ_TILDE] = ACTIONS(10255),
    [anon_sym_BANG_TILDE] = ACTIONS(10255),
    [anon_sym_LT_EQ] = ACTIONS(10247),
    [anon_sym_GT] = ACTIONS(10247),
    [anon_sym_GT_EQ] = ACTIONS(10261),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [8871] = {
    [sym_string] = STATE(8871),
    [aux_sym_chained_string_repeat1] = STATE(8871),
    [sym__string_start] = ACTIONS(6891),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [8872] = {
    [sym__simple_symbol] = ACTIONS(13516),
    [sym__string_start] = ACTIONS(13516),
    [sym__symbol_start] = ACTIONS(13516),
    [sym__subshell_start] = ACTIONS(13516),
    [sym__regex_start] = ACTIONS(13516),
    [sym__string_array_start] = ACTIONS(13516),
    [sym__symbol_array_start] = ACTIONS(13516),
    [sym_heredoc_beginning] = ACTIONS(13516),
    [sym__unary_minus] = ACTIONS(13516),
    [anon_sym_BEGIN] = ACTIONS(13518),
    [anon_sym_LBRACE] = ACTIONS(13516),
    [anon_sym_END] = ACTIONS(13518),
    [anon_sym_def] = ACTIONS(13518),
    [anon_sym_LPAREN] = ACTIONS(13516),
    [anon_sym_COLON_COLON] = ACTIONS(13516),
    [anon_sym_SEMI] = ACTIONS(13516),
    [anon_sym_STAR] = ACTIONS(13516),
    [anon_sym_class] = ACTIONS(13518),
    [anon_sym_module] = ACTIONS(13518),
    [anon_sym_end] = ACTIONS(13518),
    [anon_sym_return] = ACTIONS(13518),
    [anon_sym_yield] = ACTIONS(13518),
    [anon_sym_break] = ACTIONS(13518),
    [anon_sym_next] = ACTIONS(13518),
    [sym_redo] = ACTIONS(13518),
    [sym_retry] = ACTIONS(13518),
    [anon_sym_if] = ACTIONS(13518),
    [anon_sym_unless] = ACTIONS(13518),
    [anon_sym_while] = ACTIONS(13518),
    [anon_sym_until] = ACTIONS(13518),
    [anon_sym_rescue] = ACTIONS(13518),
    [anon_sym_for] = ACTIONS(13518),
    [anon_sym_case] = ACTIONS(13518),
    [anon_sym_else] = ACTIONS(13518),
    [anon_sym_begin] = ACTIONS(13518),
    [anon_sym_ensure] = ACTIONS(13518),
    [anon_sym_PLUS] = ACTIONS(13518),
    [anon_sym_defined_QMARK] = ACTIONS(13516),
    [anon_sym_not] = ACTIONS(13518),
    [anon_sym_BANG] = ACTIONS(13516),
    [anon_sym_TILDE] = ACTIONS(13516),
    [sym_constant] = ACTIONS(13518),
    [sym_identifier] = ACTIONS(13518),
    [sym_instance_variable] = ACTIONS(13516),
    [sym_class_variable] = ACTIONS(13516),
    [sym_global_variable] = ACTIONS(13516),
    [anon_sym_undef] = ACTIONS(13518),
    [anon_sym_alias] = ACTIONS(13518),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13518),
    [sym_float] = ACTIONS(13518),
    [sym_complex] = ACTIONS(13516),
    [sym_super] = ACTIONS(13518),
    [anon_sym_true] = ACTIONS(13518),
    [anon_sym_TRUE] = ACTIONS(13518),
    [anon_sym_false] = ACTIONS(13518),
    [anon_sym_FALSE] = ACTIONS(13518),
    [sym_self] = ACTIONS(13518),
    [anon_sym_nil] = ACTIONS(13518),
    [anon_sym_NIL] = ACTIONS(13518),
    [sym_character] = ACTIONS(13516),
    [anon_sym_LBRACK2] = ACTIONS(13516),
    [anon_sym_DASH_GT] = ACTIONS(13516),
  },
  [8873] = {
    [sym__line_break] = ACTIONS(9172),
    [sym__heredoc_body_start] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9172),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_SEMI] = ACTIONS(9172),
    [anon_sym_then] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [sym_comment] = ACTIONS(87),
  },
  [8874] = {
    [anon_sym_RBRACE] = ACTIONS(13520),
    [sym_comment] = ACTIONS(87),
  },
  [8875] = {
    [sym__line_break] = ACTIONS(9192),
    [sym__heredoc_body_start] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9192),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_SEMI] = ACTIONS(9192),
    [anon_sym_then] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [sym_comment] = ACTIONS(87),
  },
  [8876] = {
    [anon_sym_end] = ACTIONS(13522),
    [sym_comment] = ACTIONS(87),
  },
  [8877] = {
    [sym__statements] = STATE(9997),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13524),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8878] = {
    [sym__statements] = STATE(9997),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(9998),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(9998),
    [sym__line_break] = ACTIONS(13526),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13524),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8879] = {
    [sym__line_break] = ACTIONS(11659),
    [sym__heredoc_body_start] = ACTIONS(11659),
    [anon_sym_COMMA] = ACTIONS(11659),
    [anon_sym_SEMI] = ACTIONS(11659),
    [sym_comment] = ACTIONS(87),
  },
  [8880] = {
    [aux_sym_method_parameters_repeat1] = STATE(6056),
    [anon_sym_RPAREN] = ACTIONS(13528),
    [anon_sym_COMMA] = ACTIONS(5616),
    [sym_comment] = ACTIONS(87),
  },
  [8881] = {
    [sym__line_break] = ACTIONS(11665),
    [sym__heredoc_body_start] = ACTIONS(11665),
    [anon_sym_COMMA] = ACTIONS(11665),
    [anon_sym_SEMI] = ACTIONS(11665),
    [sym_comment] = ACTIONS(87),
  },
  [8882] = {
    [aux_sym_method_parameters_repeat1] = STATE(8882),
    [sym__line_break] = ACTIONS(11665),
    [sym__heredoc_body_start] = ACTIONS(11665),
    [anon_sym_COMMA] = ACTIONS(13530),
    [anon_sym_SEMI] = ACTIONS(11665),
    [sym_comment] = ACTIONS(87),
  },
  [8883] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_RPAREN] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8884] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8885] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10000),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(10000),
    [sym_operator_assignment] = STATE(10000),
    [sym_conditional] = STATE(10000),
    [sym_range] = STATE(10000),
    [sym_binary] = STATE(10000),
    [sym_unary] = STATE(10000),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [8886] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8887] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10001),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(10001),
    [sym_operator_assignment] = STATE(10001),
    [sym_conditional] = STATE(10001),
    [sym_range] = STATE(10001),
    [sym_binary] = STATE(10001),
    [sym_unary] = STATE(10001),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [8888] = {
    [sym_heredoc_body] = STATE(10002),
    [aux_sym_call_repeat1] = STATE(10002),
    [sym__heredoc_body_start] = ACTIONS(10491),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [8889] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6948),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym__argument] = STATE(8996),
    [sym_splat_argument] = STATE(8996),
    [sym_hash_splat_argument] = STATE(8996),
    [sym_block_argument] = STATE(8996),
    [sym_assignment] = STATE(6948),
    [sym_operator_assignment] = STATE(6948),
    [sym_conditional] = STATE(6948),
    [sym_range] = STATE(6948),
    [sym_binary] = STATE(6948),
    [sym_unary] = STATE(6948),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6951),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(10003),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(8996),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10293),
    [sym__splat_star] = ACTIONS(10295),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__identifier_hash_key] = ACTIONS(10297),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(10299),
    [sym_identifier] = ACTIONS(10299),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8890] = {
    [sym_heredoc_body] = STATE(10004),
    [aux_sym_call_repeat1] = STATE(10004),
    [aux_sym_argument_list_repeat1] = STATE(10005),
    [sym__heredoc_body_start] = ACTIONS(10491),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_RPAREN] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(12216),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [8891] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8892] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [8893] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8894] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8895] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8896] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13535),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [8897] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8898] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8899] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8900] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RPAREN] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8901] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RPAREN] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8902] = {
    [aux_sym_exceptions_repeat1] = STATE(10008),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_RPAREN] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [8903] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [8904] = {
    [sym_string] = STATE(8904),
    [aux_sym_chained_string_repeat1] = STATE(8904),
    [sym__string_start] = ACTIONS(12380),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [8905] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [8906] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [8907] = {
    [sym_heredoc_body] = STATE(8907),
    [aux_sym_call_repeat1] = STATE(8907),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8908] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4435),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(4435),
    [sym_operator_assignment] = STATE(4435),
    [sym_conditional] = STATE(4435),
    [sym_range] = STATE(4435),
    [sym_binary] = STATE(4435),
    [sym_unary] = STATE(4435),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4438),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7088),
    [sym__splat_star] = ACTIONS(7090),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__identifier_hash_key] = ACTIONS(7092),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12220),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(7096),
    [sym_identifier] = ACTIONS(7096),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8909] = {
    [sym_heredoc_body] = STATE(8907),
    [aux_sym_call_repeat1] = STATE(8907),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8910] = {
    [aux_sym_argument_list_repeat1] = STATE(8910),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13537),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [8911] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10009),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_assignment] = STATE(10009),
    [sym_operator_assignment] = STATE(10009),
    [sym_conditional] = STATE(10009),
    [sym_range] = STATE(10009),
    [sym_binary] = STATE(10009),
    [sym_unary] = STATE(10009),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8912] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6990),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(6990),
    [sym_operator_assignment] = STATE(6990),
    [sym_conditional] = STATE(6990),
    [sym_range] = STATE(6990),
    [sym_binary] = STATE(6990),
    [sym_unary] = STATE(6990),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4427),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(7090),
    [sym__unary_minus] = ACTIONS(3570),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(3532),
    [sym_identifier] = ACTIONS(3532),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8913] = {
    [aux_sym_exceptions_repeat1] = STATE(10010),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13540),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8914] = {
    [sym_heredoc_body] = STATE(8914),
    [aux_sym_call_repeat1] = STATE(8914),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8915] = {
    [sym_heredoc_body] = STATE(8914),
    [aux_sym_call_repeat1] = STATE(8914),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8916] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10011),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_assignment] = STATE(10011),
    [sym_operator_assignment] = STATE(10011),
    [sym_conditional] = STATE(10011),
    [sym_range] = STATE(10011),
    [sym_binary] = STATE(10011),
    [sym_unary] = STATE(10011),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8917] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7006),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2118),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2118),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(7006),
    [sym_operator_assignment] = STATE(7006),
    [sym_conditional] = STATE(7006),
    [sym_range] = STATE(7006),
    [sym_binary] = STATE(7006),
    [sym_unary] = STATE(7006),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(2117),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2118),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2118),
    [sym_false] = STATE(2118),
    [sym_nil] = STATE(2118),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1301),
    [sym__unary_minus] = ACTIONS(3594),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3604),
    [anon_sym_defined_QMARK] = ACTIONS(3606),
    [anon_sym_not] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3610),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8918] = {
    [aux_sym_exceptions_repeat1] = STATE(10012),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13542),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8919] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(3626),
    [sym__binary_star] = ACTIONS(3628),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(3628),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_LT] = ACTIONS(3634),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(3636),
    [anon_sym_DOT_DOT] = ACTIONS(3638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3640),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3642),
    [anon_sym_AMP_AMP] = ACTIONS(3642),
    [anon_sym_LT_LT] = ACTIONS(3644),
    [anon_sym_GT_GT] = ACTIONS(3644),
    [anon_sym_EQ_EQ] = ACTIONS(3646),
    [anon_sym_BANG_EQ] = ACTIONS(3642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3642),
    [anon_sym_LT_EQ_GT] = ACTIONS(3642),
    [anon_sym_EQ_TILDE] = ACTIONS(3642),
    [anon_sym_BANG_TILDE] = ACTIONS(3642),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_GT] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3648),
    [anon_sym_CARET] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3628),
    [anon_sym_PERCENT] = ACTIONS(3628),
    [sym_comment] = ACTIONS(87),
  },
  [8920] = {
    [aux_sym_exceptions_repeat1] = STATE(8920),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13544),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [8921] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10013),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_assignment] = STATE(10013),
    [sym_operator_assignment] = STATE(10013),
    [sym_conditional] = STATE(10013),
    [sym_range] = STATE(10013),
    [sym_binary] = STATE(10013),
    [sym_unary] = STATE(10013),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8922] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7036),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2189),
    [sym_scope_resolution] = STATE(2187),
    [sym_call] = STATE(2187),
    [sym_method_call] = STATE(2189),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(7036),
    [sym_operator_assignment] = STATE(7036),
    [sym_conditional] = STATE(7036),
    [sym_range] = STATE(7036),
    [sym_binary] = STATE(7036),
    [sym_unary] = STATE(7036),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(2188),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2189),
    [sym__variable] = STATE(2187),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2189),
    [sym_false] = STATE(2189),
    [sym_nil] = STATE(2189),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2190),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(1375),
    [sym__unary_minus] = ACTIONS(3676),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(3678),
    [anon_sym_yield] = ACTIONS(3680),
    [anon_sym_break] = ACTIONS(3682),
    [anon_sym_next] = ACTIONS(3684),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(3686),
    [anon_sym_defined_QMARK] = ACTIONS(3688),
    [anon_sym_not] = ACTIONS(3690),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_TILDE] = ACTIONS(3692),
    [sym_constant] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [sym_instance_variable] = ACTIONS(3696),
    [sym_class_variable] = ACTIONS(3696),
    [sym_global_variable] = ACTIONS(3696),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(3694),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3694),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [8923] = {
    [aux_sym_exceptions_repeat1] = STATE(10014),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13547),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [8924] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(3704),
    [sym__binary_star] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(3708),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(3716),
    [anon_sym_DOT_DOT] = ACTIONS(3718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3720),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3722),
    [anon_sym_AMP_AMP] = ACTIONS(3722),
    [anon_sym_LT_LT] = ACTIONS(3724),
    [anon_sym_GT_GT] = ACTIONS(3724),
    [anon_sym_EQ_EQ] = ACTIONS(3722),
    [anon_sym_BANG_EQ] = ACTIONS(3726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3726),
    [anon_sym_LT_EQ_GT] = ACTIONS(3726),
    [anon_sym_EQ_TILDE] = ACTIONS(3726),
    [anon_sym_BANG_TILDE] = ACTIONS(3726),
    [anon_sym_LT_EQ] = ACTIONS(3714),
    [anon_sym_GT] = ACTIONS(3714),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_CARET] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3730),
    [anon_sym_SLASH] = ACTIONS(3710),
    [anon_sym_PERCENT] = ACTIONS(3710),
    [sym_comment] = ACTIONS(87),
  },
  [8925] = {
    [aux_sym_exceptions_repeat1] = STATE(8925),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13549),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [8926] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10015),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2221),
    [sym_scope_resolution] = STATE(147),
    [sym_call] = STATE(147),
    [sym_method_call] = STATE(2221),
    [sym_assignment] = STATE(10015),
    [sym_operator_assignment] = STATE(10015),
    [sym_conditional] = STATE(10015),
    [sym_range] = STATE(10015),
    [sym_binary] = STATE(10015),
    [sym_unary] = STATE(10015),
    [sym_left_assignment_list] = STATE(2220),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2221),
    [sym__variable] = STATE(147),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2221),
    [sym_false] = STATE(2221),
    [sym_nil] = STATE(2221),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2119),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3600),
    [anon_sym_next] = ACTIONS(3602),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_defined_QMARK] = ACTIONS(3748),
    [anon_sym_not] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3752),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8927] = {
    [anon_sym_DOT] = ACTIONS(12069),
    [anon_sym_LBRACK] = ACTIONS(12069),
    [anon_sym_COLON_COLON2] = ACTIONS(12069),
    [anon_sym_AMP_DOT] = ACTIONS(12069),
    [sym_comment] = ACTIONS(87),
  },
  [8928] = {
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_LBRACK] = ACTIONS(12073),
    [anon_sym_COLON_COLON2] = ACTIONS(12073),
    [anon_sym_AMP_DOT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [8929] = {
    [anon_sym_DOT] = ACTIONS(12187),
    [anon_sym_LBRACK] = ACTIONS(12187),
    [anon_sym_COLON_COLON2] = ACTIONS(12187),
    [anon_sym_AMP_DOT] = ACTIONS(12187),
    [sym_comment] = ACTIONS(87),
  },
  [8930] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [8931] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [8932] = {
    [sym_heredoc_body] = STATE(8932),
    [aux_sym_call_repeat1] = STATE(8932),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8933] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4591),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(566),
    [sym_scope_resolution] = STATE(561),
    [sym_call] = STATE(561),
    [sym_method_call] = STATE(566),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(4591),
    [sym_operator_assignment] = STATE(4591),
    [sym_conditional] = STATE(4591),
    [sym_range] = STATE(4591),
    [sym_binary] = STATE(4591),
    [sym_unary] = STATE(4591),
    [sym_left_assignment_list] = STATE(565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(566),
    [sym__variable] = STATE(561),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_nil] = STATE(566),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4594),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7299),
    [sym__splat_star] = ACTIONS(7301),
    [sym__unary_minus] = ACTIONS(1049),
    [sym__identifier_hash_key] = ACTIONS(7303),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12250),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_next] = ACTIONS(1063),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_defined_QMARK] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_TILDE] = ACTIONS(1073),
    [sym_constant] = ACTIONS(7305),
    [sym_identifier] = ACTIONS(7305),
    [sym_instance_variable] = ACTIONS(1077),
    [sym_class_variable] = ACTIONS(1077),
    [sym_global_variable] = ACTIONS(1077),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1079),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8934] = {
    [sym_heredoc_body] = STATE(8932),
    [aux_sym_call_repeat1] = STATE(8932),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8935] = {
    [aux_sym_argument_list_repeat1] = STATE(8935),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13552),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [8936] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10016),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_assignment] = STATE(10016),
    [sym_operator_assignment] = STATE(10016),
    [sym_conditional] = STATE(10016),
    [sym_range] = STATE(10016),
    [sym_binary] = STATE(10016),
    [sym_unary] = STATE(10016),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8937] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [8938] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [8939] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10017),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10017),
    [sym_operator_assignment] = STATE(10017),
    [sym_conditional] = STATE(10017),
    [sym_range] = STATE(10017),
    [sym_binary] = STATE(10017),
    [sym_unary] = STATE(10017),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8940] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10018),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10018),
    [sym_operator_assignment] = STATE(10018),
    [sym_conditional] = STATE(10018),
    [sym_range] = STATE(10018),
    [sym_binary] = STATE(10018),
    [sym_unary] = STATE(10018),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8941] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10019),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10019),
    [sym_operator_assignment] = STATE(10019),
    [sym_conditional] = STATE(10019),
    [sym_range] = STATE(10019),
    [sym_binary] = STATE(10019),
    [sym_unary] = STATE(10019),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8942] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10020),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10020),
    [sym_operator_assignment] = STATE(10020),
    [sym_conditional] = STATE(10020),
    [sym_range] = STATE(10020),
    [sym_binary] = STATE(10020),
    [sym_unary] = STATE(10020),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8943] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10021),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10021),
    [sym_operator_assignment] = STATE(10021),
    [sym_conditional] = STATE(10021),
    [sym_range] = STATE(10021),
    [sym_binary] = STATE(10021),
    [sym_unary] = STATE(10021),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8944] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10022),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10022),
    [sym_operator_assignment] = STATE(10022),
    [sym_conditional] = STATE(10022),
    [sym_range] = STATE(10022),
    [sym_binary] = STATE(10022),
    [sym_unary] = STATE(10022),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8945] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10023),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10023),
    [sym_operator_assignment] = STATE(10023),
    [sym_conditional] = STATE(10023),
    [sym_range] = STATE(10023),
    [sym_binary] = STATE(10023),
    [sym_unary] = STATE(10023),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8946] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10024),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10024),
    [sym_operator_assignment] = STATE(10024),
    [sym_conditional] = STATE(10024),
    [sym_range] = STATE(10024),
    [sym_binary] = STATE(10024),
    [sym_unary] = STATE(10024),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8947] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10025),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10025),
    [sym_operator_assignment] = STATE(10025),
    [sym_conditional] = STATE(10025),
    [sym_range] = STATE(10025),
    [sym_binary] = STATE(10025),
    [sym_unary] = STATE(10025),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8948] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10026),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10026),
    [sym_operator_assignment] = STATE(10026),
    [sym_conditional] = STATE(10026),
    [sym_range] = STATE(10026),
    [sym_binary] = STATE(10026),
    [sym_unary] = STATE(10026),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8949] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10027),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_splat_argument] = STATE(10028),
    [sym_assignment] = STATE(10027),
    [sym_operator_assignment] = STATE(10027),
    [sym_conditional] = STATE(10027),
    [sym_range] = STATE(10027),
    [sym_binary] = STATE(10027),
    [sym_unary] = STATE(10027),
    [sym_right_assignment_list] = STATE(8647),
    [sym__arg_or_splat_arg] = STATE(10028),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8950] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10029),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10029),
    [sym_operator_assignment] = STATE(10029),
    [sym_conditional] = STATE(10029),
    [sym_range] = STATE(10029),
    [sym_binary] = STATE(10029),
    [sym_unary] = STATE(10029),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [8951] = {
    [sym_string] = STATE(10030),
    [aux_sym_chained_string_repeat1] = STATE(10030),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [8952] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [8953] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [8954] = {
    [sym_heredoc_body] = STATE(8954),
    [aux_sym_call_repeat1] = STATE(8954),
    [sym__heredoc_body_start] = ACTIONS(12063),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [8955] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(4611),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(652),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(652),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(4611),
    [sym_operator_assignment] = STATE(4611),
    [sym_conditional] = STATE(4611),
    [sym_range] = STATE(4611),
    [sym_binary] = STATE(4611),
    [sym_unary] = STATE(4611),
    [sym_left_assignment_list] = STATE(651),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(652),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_nil] = STATE(652),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(4614),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(7335),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(1159),
    [sym__identifier_hash_key] = ACTIONS(7339),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12288),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_next] = ACTIONS(1179),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_defined_QMARK] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1207),
    [sym_constant] = ACTIONS(7341),
    [sym_identifier] = ACTIONS(7341),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [8956] = {
    [sym_heredoc_body] = STATE(8954),
    [aux_sym_call_repeat1] = STATE(8954),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [8957] = {
    [aux_sym_argument_list_repeat1] = STATE(8957),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13555),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [8958] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7101),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2261),
    [sym_scope_resolution] = STATE(2259),
    [sym_call] = STATE(2259),
    [sym_method_call] = STATE(2261),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(7101),
    [sym_operator_assignment] = STATE(7101),
    [sym_conditional] = STATE(7101),
    [sym_range] = STATE(7101),
    [sym_binary] = STATE(7101),
    [sym_unary] = STATE(7101),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(2260),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2261),
    [sym__variable] = STATE(2259),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2261),
    [sym_false] = STATE(2261),
    [sym_nil] = STATE(2261),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2262),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7301),
    [sym__unary_minus] = ACTIONS(3794),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3796),
    [anon_sym_yield] = ACTIONS(3798),
    [anon_sym_break] = ACTIONS(3800),
    [anon_sym_next] = ACTIONS(3802),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_defined_QMARK] = ACTIONS(3806),
    [anon_sym_not] = ACTIONS(3808),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [sym_constant] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(3812),
    [sym_instance_variable] = ACTIONS(3814),
    [sym_class_variable] = ACTIONS(3814),
    [sym_global_variable] = ACTIONS(3814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3812),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3812),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8959] = {
    [aux_sym_exceptions_repeat1] = STATE(10031),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13558),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [8960] = {
    [anon_sym_DOT] = ACTIONS(12482),
    [anon_sym_LBRACK] = ACTIONS(12482),
    [anon_sym_COLON_COLON2] = ACTIONS(12482),
    [anon_sym_AMP_DOT] = ACTIONS(12482),
    [sym_comment] = ACTIONS(87),
  },
  [8961] = {
    [anon_sym_end] = ACTIONS(13560),
    [sym_comment] = ACTIONS(87),
  },
  [8962] = {
    [anon_sym_DOT] = ACTIONS(12622),
    [anon_sym_LBRACK] = ACTIONS(12622),
    [anon_sym_COLON_COLON2] = ACTIONS(12622),
    [anon_sym_AMP_DOT] = ACTIONS(12622),
    [sym_comment] = ACTIONS(87),
  },
  [8963] = {
    [anon_sym_DOT] = ACTIONS(12770),
    [anon_sym_LBRACK] = ACTIONS(12770),
    [anon_sym_COLON_COLON2] = ACTIONS(12770),
    [anon_sym_AMP_DOT] = ACTIONS(12770),
    [sym_comment] = ACTIONS(87),
  },
  [8964] = {
    [anon_sym_DOT] = ACTIONS(12781),
    [anon_sym_LBRACK] = ACTIONS(12781),
    [anon_sym_COLON_COLON2] = ACTIONS(12781),
    [anon_sym_AMP_DOT] = ACTIONS(12781),
    [sym_comment] = ACTIONS(87),
  },
  [8965] = {
    [anon_sym_DOT] = ACTIONS(13093),
    [anon_sym_LBRACK] = ACTIONS(13093),
    [anon_sym_COLON_COLON2] = ACTIONS(13093),
    [anon_sym_AMP_DOT] = ACTIONS(13093),
    [sym_comment] = ACTIONS(87),
  },
  [8966] = {
    [anon_sym_LBRACE] = ACTIONS(13264),
    [anon_sym_RPAREN] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13264),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13264),
    [anon_sym_SEMI] = ACTIONS(13264),
    [anon_sym_EQ] = ACTIONS(13264),
    [anon_sym_in] = ACTIONS(13264),
    [anon_sym_do] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [sym_comment] = ACTIONS(87),
  },
  [8967] = {
    [anon_sym_end] = ACTIONS(13562),
    [sym_comment] = ACTIONS(87),
  },
  [8968] = {
    [sym__simple_symbol] = ACTIONS(10568),
    [sym__string_start] = ACTIONS(10568),
    [sym__symbol_start] = ACTIONS(10568),
    [sym__subshell_start] = ACTIONS(10568),
    [sym__regex_start] = ACTIONS(10568),
    [sym__string_array_start] = ACTIONS(10568),
    [sym__symbol_array_start] = ACTIONS(10568),
    [sym_heredoc_beginning] = ACTIONS(10568),
    [sym__block_ampersand] = ACTIONS(10568),
    [sym__splat_star] = ACTIONS(10568),
    [sym__unary_minus] = ACTIONS(10568),
    [sym__identifier_hash_key] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_def] = ACTIONS(10570),
    [anon_sym_LPAREN] = ACTIONS(10570),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10568),
    [anon_sym_COLON_COLON] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_STAR] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_EQ] = ACTIONS(10568),
    [anon_sym_class] = ACTIONS(10570),
    [anon_sym_module] = ACTIONS(10570),
    [anon_sym_return] = ACTIONS(10570),
    [anon_sym_yield] = ACTIONS(10570),
    [anon_sym_break] = ACTIONS(10570),
    [anon_sym_next] = ACTIONS(10570),
    [sym_redo] = ACTIONS(10570),
    [sym_retry] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10570),
    [anon_sym_unless] = ACTIONS(10570),
    [anon_sym_while] = ACTIONS(10570),
    [anon_sym_until] = ACTIONS(10570),
    [anon_sym_for] = ACTIONS(10570),
    [anon_sym_in] = ACTIONS(10570),
    [anon_sym_do] = ACTIONS(10570),
    [anon_sym_case] = ACTIONS(10570),
    [anon_sym_begin] = ACTIONS(10570),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_LPAREN2] = ACTIONS(10568),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_defined_QMARK] = ACTIONS(10568),
    [anon_sym_not] = ACTIONS(10570),
    [anon_sym_BANG] = ACTIONS(10568),
    [anon_sym_TILDE] = ACTIONS(10568),
    [sym_constant] = ACTIONS(10570),
    [sym_identifier] = ACTIONS(10570),
    [sym_instance_variable] = ACTIONS(10568),
    [sym_class_variable] = ACTIONS(10568),
    [sym_global_variable] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10570),
    [sym_float] = ACTIONS(10570),
    [sym_complex] = ACTIONS(10568),
    [sym_super] = ACTIONS(10570),
    [anon_sym_true] = ACTIONS(10570),
    [anon_sym_TRUE] = ACTIONS(10570),
    [anon_sym_false] = ACTIONS(10570),
    [anon_sym_FALSE] = ACTIONS(10570),
    [sym_self] = ACTIONS(10570),
    [anon_sym_nil] = ACTIONS(10570),
    [anon_sym_NIL] = ACTIONS(10570),
    [sym_character] = ACTIONS(10568),
    [anon_sym_LBRACK2] = ACTIONS(10570),
    [anon_sym_DASH_GT] = ACTIONS(10568),
  },
  [8969] = {
    [sym__heredoc_body_start] = ACTIONS(6333),
    [sym__binary_minus] = ACTIONS(6333),
    [sym__binary_star] = ACTIONS(6333),
    [anon_sym_LBRACE] = ACTIONS(6333),
    [anon_sym_RPAREN] = ACTIONS(6333),
    [anon_sym_DOT] = ACTIONS(6335),
    [anon_sym_COMMA] = ACTIONS(6333),
    [anon_sym_PIPE] = ACTIONS(6335),
    [anon_sym_STAR_STAR] = ACTIONS(6333),
    [anon_sym_AMP] = ACTIONS(6335),
    [anon_sym_EQ] = ACTIONS(6335),
    [anon_sym_LT] = ACTIONS(6335),
    [anon_sym_do] = ACTIONS(6333),
    [anon_sym_LBRACK] = ACTIONS(6333),
    [anon_sym_COLON_COLON2] = ACTIONS(6333),
    [anon_sym_AMP_DOT] = ACTIONS(6333),
    [anon_sym_QMARK] = ACTIONS(6333),
    [anon_sym_DOT_DOT] = ACTIONS(6335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6333),
    [anon_sym_and] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE] = ACTIONS(6333),
    [anon_sym_AMP_AMP] = ACTIONS(6333),
    [anon_sym_LT_LT] = ACTIONS(6333),
    [anon_sym_GT_GT] = ACTIONS(6333),
    [anon_sym_EQ_EQ] = ACTIONS(6335),
    [anon_sym_BANG_EQ] = ACTIONS(6333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6333),
    [anon_sym_LT_EQ_GT] = ACTIONS(6333),
    [anon_sym_EQ_TILDE] = ACTIONS(6333),
    [anon_sym_BANG_TILDE] = ACTIONS(6333),
    [anon_sym_LT_EQ] = ACTIONS(6335),
    [anon_sym_GT] = ACTIONS(6335),
    [anon_sym_GT_EQ] = ACTIONS(6333),
    [anon_sym_CARET] = ACTIONS(6333),
    [anon_sym_PLUS] = ACTIONS(6333),
    [anon_sym_SLASH] = ACTIONS(6333),
    [anon_sym_PERCENT] = ACTIONS(6333),
    [sym_comment] = ACTIONS(87),
  },
  [8970] = {
    [sym__heredoc_body_start] = ACTIONS(6337),
    [sym__binary_minus] = ACTIONS(6337),
    [sym__binary_star] = ACTIONS(6337),
    [anon_sym_LBRACE] = ACTIONS(6337),
    [anon_sym_RPAREN] = ACTIONS(6337),
    [anon_sym_DOT] = ACTIONS(6339),
    [anon_sym_COMMA] = ACTIONS(6337),
    [anon_sym_PIPE] = ACTIONS(6339),
    [anon_sym_STAR_STAR] = ACTIONS(6337),
    [anon_sym_AMP] = ACTIONS(6339),
    [anon_sym_EQ] = ACTIONS(6339),
    [anon_sym_LT] = ACTIONS(6339),
    [anon_sym_do] = ACTIONS(6337),
    [anon_sym_LBRACK] = ACTIONS(6337),
    [anon_sym_COLON_COLON2] = ACTIONS(6337),
    [anon_sym_AMP_DOT] = ACTIONS(6337),
    [anon_sym_QMARK] = ACTIONS(6337),
    [anon_sym_DOT_DOT] = ACTIONS(6339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6337),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6337),
    [anon_sym_AMP_AMP] = ACTIONS(6337),
    [anon_sym_LT_LT] = ACTIONS(6337),
    [anon_sym_GT_GT] = ACTIONS(6337),
    [anon_sym_EQ_EQ] = ACTIONS(6339),
    [anon_sym_BANG_EQ] = ACTIONS(6337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6337),
    [anon_sym_LT_EQ_GT] = ACTIONS(6337),
    [anon_sym_EQ_TILDE] = ACTIONS(6337),
    [anon_sym_BANG_TILDE] = ACTIONS(6337),
    [anon_sym_LT_EQ] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6339),
    [anon_sym_GT_EQ] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6337),
    [anon_sym_PLUS] = ACTIONS(6337),
    [anon_sym_SLASH] = ACTIONS(6337),
    [anon_sym_PERCENT] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
  },
  [8971] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13564),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8972] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(13564),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13566),
  },
  [8973] = {
    [sym__heredoc_body_start] = ACTIONS(6345),
    [sym__binary_minus] = ACTIONS(6345),
    [sym__binary_star] = ACTIONS(6345),
    [anon_sym_LBRACE] = ACTIONS(6345),
    [anon_sym_RPAREN] = ACTIONS(6345),
    [anon_sym_DOT] = ACTIONS(6347),
    [anon_sym_COMMA] = ACTIONS(6345),
    [anon_sym_PIPE] = ACTIONS(6347),
    [anon_sym_STAR_STAR] = ACTIONS(6345),
    [anon_sym_AMP] = ACTIONS(6347),
    [anon_sym_EQ] = ACTIONS(6347),
    [anon_sym_LT] = ACTIONS(6347),
    [anon_sym_do] = ACTIONS(6345),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_COLON_COLON2] = ACTIONS(6345),
    [anon_sym_AMP_DOT] = ACTIONS(6345),
    [anon_sym_QMARK] = ACTIONS(6345),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6345),
    [anon_sym_and] = ACTIONS(6345),
    [anon_sym_or] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE] = ACTIONS(6345),
    [anon_sym_AMP_AMP] = ACTIONS(6345),
    [anon_sym_LT_LT] = ACTIONS(6345),
    [anon_sym_GT_GT] = ACTIONS(6345),
    [anon_sym_EQ_EQ] = ACTIONS(6347),
    [anon_sym_BANG_EQ] = ACTIONS(6345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6345),
    [anon_sym_LT_EQ_GT] = ACTIONS(6345),
    [anon_sym_EQ_TILDE] = ACTIONS(6345),
    [anon_sym_BANG_TILDE] = ACTIONS(6345),
    [anon_sym_LT_EQ] = ACTIONS(6347),
    [anon_sym_GT] = ACTIONS(6347),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_CARET] = ACTIONS(6345),
    [anon_sym_PLUS] = ACTIONS(6345),
    [anon_sym_SLASH] = ACTIONS(6345),
    [anon_sym_PERCENT] = ACTIONS(6345),
    [sym_comment] = ACTIONS(87),
  },
  [8974] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13568),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8975] = {
    [sym__heredoc_body_start] = ACTIONS(6358),
    [sym__binary_minus] = ACTIONS(6358),
    [sym__binary_star] = ACTIONS(6358),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RPAREN] = ACTIONS(6358),
    [anon_sym_DOT] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6360),
    [anon_sym_STAR_STAR] = ACTIONS(6358),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6360),
    [anon_sym_do] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6358),
    [anon_sym_COLON_COLON2] = ACTIONS(6358),
    [anon_sym_AMP_DOT] = ACTIONS(6358),
    [anon_sym_QMARK] = ACTIONS(6358),
    [anon_sym_DOT_DOT] = ACTIONS(6360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6358),
    [anon_sym_and] = ACTIONS(6358),
    [anon_sym_or] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE] = ACTIONS(6358),
    [anon_sym_AMP_AMP] = ACTIONS(6358),
    [anon_sym_LT_LT] = ACTIONS(6358),
    [anon_sym_GT_GT] = ACTIONS(6358),
    [anon_sym_EQ_EQ] = ACTIONS(6360),
    [anon_sym_BANG_EQ] = ACTIONS(6358),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6358),
    [anon_sym_LT_EQ_GT] = ACTIONS(6358),
    [anon_sym_EQ_TILDE] = ACTIONS(6358),
    [anon_sym_BANG_TILDE] = ACTIONS(6358),
    [anon_sym_LT_EQ] = ACTIONS(6360),
    [anon_sym_GT] = ACTIONS(6360),
    [anon_sym_GT_EQ] = ACTIONS(6358),
    [anon_sym_CARET] = ACTIONS(6358),
    [anon_sym_PLUS] = ACTIONS(6358),
    [anon_sym_SLASH] = ACTIONS(6358),
    [anon_sym_PERCENT] = ACTIONS(6358),
    [sym_comment] = ACTIONS(87),
  },
  [8976] = {
    [sym__heredoc_body_start] = ACTIONS(6362),
    [sym__binary_minus] = ACTIONS(6362),
    [sym__binary_star] = ACTIONS(6362),
    [anon_sym_LBRACE] = ACTIONS(6362),
    [anon_sym_RPAREN] = ACTIONS(6362),
    [anon_sym_DOT] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6364),
    [anon_sym_STAR_STAR] = ACTIONS(6362),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6364),
    [anon_sym_do] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6362),
    [anon_sym_COLON_COLON2] = ACTIONS(6362),
    [anon_sym_AMP_DOT] = ACTIONS(6362),
    [anon_sym_QMARK] = ACTIONS(6362),
    [anon_sym_DOT_DOT] = ACTIONS(6364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6362),
    [anon_sym_and] = ACTIONS(6362),
    [anon_sym_or] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE] = ACTIONS(6362),
    [anon_sym_AMP_AMP] = ACTIONS(6362),
    [anon_sym_LT_LT] = ACTIONS(6362),
    [anon_sym_GT_GT] = ACTIONS(6362),
    [anon_sym_EQ_EQ] = ACTIONS(6364),
    [anon_sym_BANG_EQ] = ACTIONS(6362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6362),
    [anon_sym_LT_EQ_GT] = ACTIONS(6362),
    [anon_sym_EQ_TILDE] = ACTIONS(6362),
    [anon_sym_BANG_TILDE] = ACTIONS(6362),
    [anon_sym_LT_EQ] = ACTIONS(6364),
    [anon_sym_GT] = ACTIONS(6364),
    [anon_sym_GT_EQ] = ACTIONS(6362),
    [anon_sym_CARET] = ACTIONS(6362),
    [anon_sym_PLUS] = ACTIONS(6362),
    [anon_sym_SLASH] = ACTIONS(6362),
    [anon_sym_PERCENT] = ACTIONS(6362),
    [sym_comment] = ACTIONS(87),
  },
  [8977] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13570),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8978] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(13570),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13572),
  },
  [8979] = {
    [sym__heredoc_body_start] = ACTIONS(6370),
    [sym__binary_minus] = ACTIONS(6370),
    [sym__binary_star] = ACTIONS(6370),
    [anon_sym_LBRACE] = ACTIONS(6370),
    [anon_sym_RPAREN] = ACTIONS(6370),
    [anon_sym_DOT] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6372),
    [anon_sym_STAR_STAR] = ACTIONS(6370),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_do] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6370),
    [anon_sym_COLON_COLON2] = ACTIONS(6370),
    [anon_sym_AMP_DOT] = ACTIONS(6370),
    [anon_sym_QMARK] = ACTIONS(6370),
    [anon_sym_DOT_DOT] = ACTIONS(6372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6370),
    [anon_sym_and] = ACTIONS(6370),
    [anon_sym_or] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE] = ACTIONS(6370),
    [anon_sym_AMP_AMP] = ACTIONS(6370),
    [anon_sym_LT_LT] = ACTIONS(6370),
    [anon_sym_GT_GT] = ACTIONS(6370),
    [anon_sym_EQ_EQ] = ACTIONS(6372),
    [anon_sym_BANG_EQ] = ACTIONS(6370),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6370),
    [anon_sym_LT_EQ_GT] = ACTIONS(6370),
    [anon_sym_EQ_TILDE] = ACTIONS(6370),
    [anon_sym_BANG_TILDE] = ACTIONS(6370),
    [anon_sym_LT_EQ] = ACTIONS(6372),
    [anon_sym_GT] = ACTIONS(6372),
    [anon_sym_GT_EQ] = ACTIONS(6370),
    [anon_sym_CARET] = ACTIONS(6370),
    [anon_sym_PLUS] = ACTIONS(6370),
    [anon_sym_SLASH] = ACTIONS(6370),
    [anon_sym_PERCENT] = ACTIONS(6370),
    [sym_comment] = ACTIONS(87),
  },
  [8980] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(13574),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8981] = {
    [sym__heredoc_body_start] = ACTIONS(6894),
    [sym__binary_minus] = ACTIONS(6894),
    [sym__binary_star] = ACTIONS(6894),
    [anon_sym_LBRACE] = ACTIONS(6894),
    [anon_sym_RPAREN] = ACTIONS(6894),
    [anon_sym_DOT] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_STAR_STAR] = ACTIONS(6894),
    [anon_sym_AMP] = ACTIONS(6896),
    [anon_sym_EQ] = ACTIONS(6896),
    [anon_sym_LT] = ACTIONS(6896),
    [anon_sym_do] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6894),
    [anon_sym_COLON_COLON2] = ACTIONS(6894),
    [anon_sym_AMP_DOT] = ACTIONS(6894),
    [anon_sym_QMARK] = ACTIONS(6894),
    [anon_sym_DOT_DOT] = ACTIONS(6896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6894),
    [anon_sym_and] = ACTIONS(6894),
    [anon_sym_or] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE] = ACTIONS(6894),
    [anon_sym_AMP_AMP] = ACTIONS(6894),
    [anon_sym_LT_LT] = ACTIONS(6894),
    [anon_sym_GT_GT] = ACTIONS(6894),
    [anon_sym_EQ_EQ] = ACTIONS(6896),
    [anon_sym_BANG_EQ] = ACTIONS(6894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6894),
    [anon_sym_LT_EQ_GT] = ACTIONS(6894),
    [anon_sym_EQ_TILDE] = ACTIONS(6894),
    [anon_sym_BANG_TILDE] = ACTIONS(6894),
    [anon_sym_LT_EQ] = ACTIONS(6896),
    [anon_sym_GT] = ACTIONS(6896),
    [anon_sym_GT_EQ] = ACTIONS(6894),
    [anon_sym_CARET] = ACTIONS(6894),
    [anon_sym_PLUS] = ACTIONS(6894),
    [anon_sym_SLASH] = ACTIONS(6894),
    [anon_sym_PERCENT] = ACTIONS(6894),
    [sym_comment] = ACTIONS(87),
  },
  [8982] = {
    [anon_sym_DOT] = ACTIONS(13576),
    [anon_sym_COLON_COLON] = ACTIONS(13576),
    [sym_comment] = ACTIONS(87),
  },
  [8983] = {
    [sym__heredoc_body_start] = ACTIONS(7046),
    [sym__binary_minus] = ACTIONS(7046),
    [sym__binary_star] = ACTIONS(7046),
    [anon_sym_LBRACE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7046),
    [anon_sym_DOT] = ACTIONS(7048),
    [anon_sym_COMMA] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7048),
    [anon_sym_STAR_STAR] = ACTIONS(7046),
    [anon_sym_AMP] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7048),
    [anon_sym_do] = ACTIONS(7046),
    [anon_sym_LBRACK] = ACTIONS(7046),
    [anon_sym_COLON_COLON2] = ACTIONS(7046),
    [anon_sym_AMP_DOT] = ACTIONS(7046),
    [anon_sym_QMARK] = ACTIONS(7046),
    [anon_sym_DOT_DOT] = ACTIONS(7048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7046),
    [anon_sym_and] = ACTIONS(7046),
    [anon_sym_or] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE] = ACTIONS(7046),
    [anon_sym_AMP_AMP] = ACTIONS(7046),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_BANG_EQ] = ACTIONS(7046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT_EQ_GT] = ACTIONS(7046),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_BANG_TILDE] = ACTIONS(7046),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7046),
    [anon_sym_CARET] = ACTIONS(7046),
    [anon_sym_PLUS] = ACTIONS(7046),
    [anon_sym_SLASH] = ACTIONS(7046),
    [anon_sym_PERCENT] = ACTIONS(7046),
    [sym_comment] = ACTIONS(87),
  },
  [8984] = {
    [sym__heredoc_body_start] = ACTIONS(7062),
    [sym__binary_minus] = ACTIONS(7062),
    [sym__binary_star] = ACTIONS(7062),
    [anon_sym_LBRACE] = ACTIONS(7062),
    [anon_sym_RPAREN] = ACTIONS(7062),
    [anon_sym_DOT] = ACTIONS(7064),
    [anon_sym_COMMA] = ACTIONS(7062),
    [anon_sym_PIPE] = ACTIONS(7064),
    [anon_sym_STAR_STAR] = ACTIONS(7062),
    [anon_sym_AMP] = ACTIONS(7064),
    [anon_sym_EQ] = ACTIONS(7064),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_do] = ACTIONS(7062),
    [anon_sym_LBRACK] = ACTIONS(7062),
    [anon_sym_COLON_COLON2] = ACTIONS(7062),
    [anon_sym_AMP_DOT] = ACTIONS(7062),
    [anon_sym_QMARK] = ACTIONS(7062),
    [anon_sym_DOT_DOT] = ACTIONS(7064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7062),
    [anon_sym_and] = ACTIONS(7062),
    [anon_sym_or] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE] = ACTIONS(7062),
    [anon_sym_AMP_AMP] = ACTIONS(7062),
    [anon_sym_LT_LT] = ACTIONS(7062),
    [anon_sym_GT_GT] = ACTIONS(7062),
    [anon_sym_EQ_EQ] = ACTIONS(7064),
    [anon_sym_BANG_EQ] = ACTIONS(7062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7062),
    [anon_sym_LT_EQ_GT] = ACTIONS(7062),
    [anon_sym_EQ_TILDE] = ACTIONS(7062),
    [anon_sym_BANG_TILDE] = ACTIONS(7062),
    [anon_sym_LT_EQ] = ACTIONS(7064),
    [anon_sym_GT] = ACTIONS(7064),
    [anon_sym_GT_EQ] = ACTIONS(7062),
    [anon_sym_CARET] = ACTIONS(7062),
    [anon_sym_PLUS] = ACTIONS(7062),
    [anon_sym_SLASH] = ACTIONS(7062),
    [anon_sym_PERCENT] = ACTIONS(7062),
    [sym_comment] = ACTIONS(87),
  },
  [8985] = {
    [sym__statements] = STATE(4710),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(4711),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(4712),
    [sym_rescue] = STATE(4713),
    [sym__body_statement] = STATE(10041),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13578),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8986] = {
    [sym__statements] = STATE(4710),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(4711),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(4712),
    [sym_rescue] = STATE(4713),
    [sym__body_statement] = STATE(10042),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13580),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8987] = {
    [sym__heredoc_body_start] = ACTIONS(7496),
    [sym__binary_minus] = ACTIONS(7496),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_LBRACE] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(7496),
    [anon_sym_DOT] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_STAR_STAR] = ACTIONS(7496),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_do] = ACTIONS(7496),
    [anon_sym_LBRACK] = ACTIONS(7496),
    [anon_sym_COLON_COLON2] = ACTIONS(7496),
    [anon_sym_AMP_DOT] = ACTIONS(7496),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_DOT_DOT] = ACTIONS(7498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7496),
    [anon_sym_and] = ACTIONS(7496),
    [anon_sym_or] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE] = ACTIONS(7496),
    [anon_sym_AMP_AMP] = ACTIONS(7496),
    [anon_sym_LT_LT] = ACTIONS(7496),
    [anon_sym_GT_GT] = ACTIONS(7496),
    [anon_sym_EQ_EQ] = ACTIONS(7498),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7496),
    [anon_sym_LT_EQ_GT] = ACTIONS(7496),
    [anon_sym_EQ_TILDE] = ACTIONS(7496),
    [anon_sym_BANG_TILDE] = ACTIONS(7496),
    [anon_sym_LT_EQ] = ACTIONS(7498),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7496),
    [anon_sym_PLUS] = ACTIONS(7496),
    [anon_sym_SLASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [sym_comment] = ACTIONS(87),
  },
  [8988] = {
    [sym__heredoc_body_start] = ACTIONS(7550),
    [sym__binary_minus] = ACTIONS(7550),
    [sym__binary_star] = ACTIONS(7550),
    [anon_sym_LBRACE] = ACTIONS(7550),
    [anon_sym_RPAREN] = ACTIONS(7550),
    [anon_sym_DOT] = ACTIONS(7552),
    [anon_sym_COMMA] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_STAR_STAR] = ACTIONS(7550),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_do] = ACTIONS(7550),
    [anon_sym_LBRACK] = ACTIONS(7550),
    [anon_sym_COLON_COLON2] = ACTIONS(7550),
    [anon_sym_AMP_DOT] = ACTIONS(7550),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_DOT_DOT] = ACTIONS(7552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7550),
    [anon_sym_and] = ACTIONS(7550),
    [anon_sym_or] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE] = ACTIONS(7550),
    [anon_sym_AMP_AMP] = ACTIONS(7550),
    [anon_sym_LT_LT] = ACTIONS(7550),
    [anon_sym_GT_GT] = ACTIONS(7550),
    [anon_sym_EQ_EQ] = ACTIONS(7552),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7550),
    [anon_sym_LT_EQ_GT] = ACTIONS(7550),
    [anon_sym_EQ_TILDE] = ACTIONS(7550),
    [anon_sym_BANG_TILDE] = ACTIONS(7550),
    [anon_sym_LT_EQ] = ACTIONS(7552),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7550),
    [anon_sym_PLUS] = ACTIONS(7550),
    [anon_sym_SLASH] = ACTIONS(7550),
    [anon_sym_PERCENT] = ACTIONS(7550),
    [sym_comment] = ACTIONS(87),
  },
  [8989] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [8990] = {
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym__binary_minus] = ACTIONS(7608),
    [sym__binary_star] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7610),
    [anon_sym_COMMA] = ACTIONS(7608),
    [anon_sym_PIPE] = ACTIONS(7610),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_AMP] = ACTIONS(7610),
    [anon_sym_EQ] = ACTIONS(7610),
    [anon_sym_LT] = ACTIONS(7610),
    [anon_sym_do] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_QMARK] = ACTIONS(7608),
    [anon_sym_DOT_DOT] = ACTIONS(7610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7608),
    [anon_sym_and] = ACTIONS(7608),
    [anon_sym_or] = ACTIONS(7608),
    [anon_sym_PIPE_PIPE] = ACTIONS(7608),
    [anon_sym_AMP_AMP] = ACTIONS(7608),
    [anon_sym_LT_LT] = ACTIONS(7608),
    [anon_sym_GT_GT] = ACTIONS(7608),
    [anon_sym_EQ_EQ] = ACTIONS(7610),
    [anon_sym_BANG_EQ] = ACTIONS(7608),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7608),
    [anon_sym_LT_EQ_GT] = ACTIONS(7608),
    [anon_sym_EQ_TILDE] = ACTIONS(7608),
    [anon_sym_BANG_TILDE] = ACTIONS(7608),
    [anon_sym_LT_EQ] = ACTIONS(7610),
    [anon_sym_GT] = ACTIONS(7610),
    [anon_sym_GT_EQ] = ACTIONS(7608),
    [anon_sym_CARET] = ACTIONS(7608),
    [anon_sym_PLUS] = ACTIONS(7608),
    [anon_sym_SLASH] = ACTIONS(7608),
    [anon_sym_PERCENT] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
  },
  [8991] = {
    [anon_sym_RPAREN] = ACTIONS(13582),
    [sym_comment] = ACTIONS(87),
  },
  [8992] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [8993] = {
    [sym__heredoc_body_start] = ACTIONS(3102),
    [sym__binary_minus] = ACTIONS(3102),
    [sym__binary_star] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(4854),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(4854),
    [anon_sym_STAR_STAR] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(4854),
    [anon_sym_EQ] = ACTIONS(4854),
    [anon_sym_LT] = ACTIONS(4854),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_COLON_COLON2] = ACTIONS(3102),
    [anon_sym_AMP_DOT] = ACTIONS(3102),
    [anon_sym_QMARK] = ACTIONS(3102),
    [anon_sym_DOT_DOT] = ACTIONS(4854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3102),
    [anon_sym_and] = ACTIONS(3102),
    [anon_sym_or] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(3102),
    [anon_sym_AMP_AMP] = ACTIONS(3102),
    [anon_sym_LT_LT] = ACTIONS(3102),
    [anon_sym_GT_GT] = ACTIONS(3102),
    [anon_sym_EQ_EQ] = ACTIONS(4854),
    [anon_sym_BANG_EQ] = ACTIONS(3102),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
    [anon_sym_LT_EQ_GT] = ACTIONS(3102),
    [anon_sym_EQ_TILDE] = ACTIONS(3102),
    [anon_sym_BANG_TILDE] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(4854),
    [anon_sym_GT] = ACTIONS(4854),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_PERCENT] = ACTIONS(3102),
    [sym_comment] = ACTIONS(87),
  },
  [8994] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(13584),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [8995] = {
    [sym_heredoc_body] = STATE(8995),
    [aux_sym_call_repeat1] = STATE(8995),
    [sym__heredoc_body_start] = ACTIONS(13586),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [8996] = {
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(7657),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [8997] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4695),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(836),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(836),
    [sym__argument] = STATE(10045),
    [sym_splat_argument] = STATE(10045),
    [sym_hash_splat_argument] = STATE(10045),
    [sym_block_argument] = STATE(10045),
    [sym_assignment] = STATE(4695),
    [sym_operator_assignment] = STATE(4695),
    [sym_conditional] = STATE(4695),
    [sym_range] = STATE(4695),
    [sym_binary] = STATE(4695),
    [sym_unary] = STATE(4695),
    [sym_left_assignment_list] = STATE(835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(836),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_nil] = STATE(836),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4699),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(10045),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7419),
    [sym__splat_star] = ACTIONS(7421),
    [sym__unary_minus] = ACTIONS(1487),
    [sym__identifier_hash_key] = ACTIONS(7423),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12348),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1495),
    [anon_sym_yield] = ACTIONS(1497),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_next] = ACTIONS(1501),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1503),
    [anon_sym_defined_QMARK] = ACTIONS(1505),
    [anon_sym_not] = ACTIONS(1507),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_TILDE] = ACTIONS(1509),
    [sym_constant] = ACTIONS(7427),
    [sym_identifier] = ACTIONS(7427),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8998] = {
    [sym_heredoc_body] = STATE(8995),
    [aux_sym_call_repeat1] = STATE(8995),
    [sym__heredoc_body_start] = ACTIONS(10491),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [8999] = {
    [aux_sym_argument_list_repeat1] = STATE(8999),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13589),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9000] = {
    [sym__heredoc_body_start] = ACTIONS(7724),
    [sym__binary_minus] = ACTIONS(7724),
    [sym__binary_star] = ACTIONS(7724),
    [anon_sym_LBRACE] = ACTIONS(7724),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_DOT] = ACTIONS(7726),
    [anon_sym_COMMA] = ACTIONS(7724),
    [anon_sym_PIPE] = ACTIONS(7726),
    [anon_sym_STAR_STAR] = ACTIONS(7724),
    [anon_sym_AMP] = ACTIONS(7726),
    [anon_sym_EQ] = ACTIONS(7726),
    [anon_sym_LT] = ACTIONS(7726),
    [anon_sym_do] = ACTIONS(7724),
    [anon_sym_LBRACK] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(7724),
    [anon_sym_AMP_DOT] = ACTIONS(7724),
    [anon_sym_QMARK] = ACTIONS(7724),
    [anon_sym_DOT_DOT] = ACTIONS(7726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7724),
    [anon_sym_and] = ACTIONS(7724),
    [anon_sym_or] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE] = ACTIONS(7724),
    [anon_sym_AMP_AMP] = ACTIONS(7724),
    [anon_sym_LT_LT] = ACTIONS(7724),
    [anon_sym_GT_GT] = ACTIONS(7724),
    [anon_sym_EQ_EQ] = ACTIONS(7726),
    [anon_sym_BANG_EQ] = ACTIONS(7724),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7724),
    [anon_sym_LT_EQ_GT] = ACTIONS(7724),
    [anon_sym_EQ_TILDE] = ACTIONS(7724),
    [anon_sym_BANG_TILDE] = ACTIONS(7724),
    [anon_sym_LT_EQ] = ACTIONS(7726),
    [anon_sym_GT] = ACTIONS(7726),
    [anon_sym_GT_EQ] = ACTIONS(7724),
    [anon_sym_CARET] = ACTIONS(7724),
    [anon_sym_PLUS] = ACTIONS(7724),
    [anon_sym_SLASH] = ACTIONS(7724),
    [anon_sym_PERCENT] = ACTIONS(7724),
    [sym_comment] = ACTIONS(87),
  },
  [9001] = {
    [sym_elsif] = STATE(10047),
    [sym_else] = STATE(10047),
    [sym__if_tail] = STATE(10047),
    [anon_sym_end] = ACTIONS(13592),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [9002] = {
    [anon_sym_end] = ACTIONS(13592),
    [sym_comment] = ACTIONS(87),
  },
  [9003] = {
    [sym__statements] = STATE(10048),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(10047),
    [sym_else] = STATE(10047),
    [sym__if_tail] = STATE(10047),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13594),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9004] = {
    [sym__heredoc_body_start] = ACTIONS(7922),
    [sym__binary_minus] = ACTIONS(7922),
    [sym__binary_star] = ACTIONS(7922),
    [anon_sym_LBRACE] = ACTIONS(7922),
    [anon_sym_RPAREN] = ACTIONS(7922),
    [anon_sym_DOT] = ACTIONS(7924),
    [anon_sym_COMMA] = ACTIONS(7922),
    [anon_sym_PIPE] = ACTIONS(7924),
    [anon_sym_STAR_STAR] = ACTIONS(7922),
    [anon_sym_AMP] = ACTIONS(7924),
    [anon_sym_EQ] = ACTIONS(7924),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_do] = ACTIONS(7922),
    [anon_sym_LBRACK] = ACTIONS(7922),
    [anon_sym_COLON_COLON2] = ACTIONS(7922),
    [anon_sym_AMP_DOT] = ACTIONS(7922),
    [anon_sym_QMARK] = ACTIONS(7922),
    [anon_sym_DOT_DOT] = ACTIONS(7924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7922),
    [anon_sym_and] = ACTIONS(7922),
    [anon_sym_or] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE] = ACTIONS(7922),
    [anon_sym_AMP_AMP] = ACTIONS(7922),
    [anon_sym_LT_LT] = ACTIONS(7922),
    [anon_sym_GT_GT] = ACTIONS(7922),
    [anon_sym_EQ_EQ] = ACTIONS(7924),
    [anon_sym_BANG_EQ] = ACTIONS(7922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7922),
    [anon_sym_LT_EQ_GT] = ACTIONS(7922),
    [anon_sym_EQ_TILDE] = ACTIONS(7922),
    [anon_sym_BANG_TILDE] = ACTIONS(7922),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7922),
    [anon_sym_CARET] = ACTIONS(7922),
    [anon_sym_PLUS] = ACTIONS(7922),
    [anon_sym_SLASH] = ACTIONS(7922),
    [anon_sym_PERCENT] = ACTIONS(7922),
    [sym_comment] = ACTIONS(87),
  },
  [9005] = {
    [sym_else] = STATE(10050),
    [anon_sym_end] = ACTIONS(13596),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [9006] = {
    [anon_sym_end] = ACTIONS(13596),
    [sym_comment] = ACTIONS(87),
  },
  [9007] = {
    [sym__heredoc_body_start] = ACTIONS(8090),
    [sym__binary_minus] = ACTIONS(8090),
    [sym__binary_star] = ACTIONS(8090),
    [anon_sym_LBRACE] = ACTIONS(8090),
    [anon_sym_RPAREN] = ACTIONS(8090),
    [anon_sym_DOT] = ACTIONS(8092),
    [anon_sym_COMMA] = ACTIONS(8090),
    [anon_sym_PIPE] = ACTIONS(8092),
    [anon_sym_STAR_STAR] = ACTIONS(8090),
    [anon_sym_AMP] = ACTIONS(8092),
    [anon_sym_EQ] = ACTIONS(8092),
    [anon_sym_LT] = ACTIONS(8092),
    [anon_sym_do] = ACTIONS(8090),
    [anon_sym_LBRACK] = ACTIONS(8090),
    [anon_sym_COLON_COLON2] = ACTIONS(8090),
    [anon_sym_AMP_DOT] = ACTIONS(8090),
    [anon_sym_QMARK] = ACTIONS(8090),
    [anon_sym_DOT_DOT] = ACTIONS(8092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8090),
    [anon_sym_and] = ACTIONS(8090),
    [anon_sym_or] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE] = ACTIONS(8090),
    [anon_sym_AMP_AMP] = ACTIONS(8090),
    [anon_sym_LT_LT] = ACTIONS(8090),
    [anon_sym_GT_GT] = ACTIONS(8090),
    [anon_sym_EQ_EQ] = ACTIONS(8092),
    [anon_sym_BANG_EQ] = ACTIONS(8090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8090),
    [anon_sym_LT_EQ_GT] = ACTIONS(8090),
    [anon_sym_EQ_TILDE] = ACTIONS(8090),
    [anon_sym_BANG_TILDE] = ACTIONS(8090),
    [anon_sym_LT_EQ] = ACTIONS(8092),
    [anon_sym_GT] = ACTIONS(8092),
    [anon_sym_GT_EQ] = ACTIONS(8090),
    [anon_sym_CARET] = ACTIONS(8090),
    [anon_sym_PLUS] = ACTIONS(8090),
    [anon_sym_SLASH] = ACTIONS(8090),
    [anon_sym_PERCENT] = ACTIONS(8090),
    [sym_comment] = ACTIONS(87),
  },
  [9008] = {
    [anon_sym_end] = ACTIONS(13598),
    [sym_comment] = ACTIONS(87),
  },
  [9009] = {
    [sym__heredoc_body_start] = ACTIONS(8166),
    [sym__binary_minus] = ACTIONS(8166),
    [sym__binary_star] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_DOT] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8166),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_STAR_STAR] = ACTIONS(8166),
    [anon_sym_AMP] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_do] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_COLON_COLON2] = ACTIONS(8166),
    [anon_sym_AMP_DOT] = ACTIONS(8166),
    [anon_sym_QMARK] = ACTIONS(8166),
    [anon_sym_DOT_DOT] = ACTIONS(8168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8166),
    [anon_sym_and] = ACTIONS(8166),
    [anon_sym_or] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8166),
    [anon_sym_AMP_AMP] = ACTIONS(8166),
    [anon_sym_LT_LT] = ACTIONS(8166),
    [anon_sym_GT_GT] = ACTIONS(8166),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ_GT] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_BANG_TILDE] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8166),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8166),
    [anon_sym_PERCENT] = ACTIONS(8166),
    [sym_comment] = ACTIONS(87),
  },
  [9010] = {
    [anon_sym_end] = ACTIONS(13600),
    [sym_comment] = ACTIONS(87),
  },
  [9011] = {
    [sym__statements] = STATE(10054),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13602),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9012] = {
    [anon_sym_end] = ACTIONS(13604),
    [sym_comment] = ACTIONS(87),
  },
  [9013] = {
    [sym_when] = STATE(10056),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [9014] = {
    [sym__heredoc_body_start] = ACTIONS(8414),
    [sym__binary_minus] = ACTIONS(8414),
    [sym__binary_star] = ACTIONS(8414),
    [anon_sym_LBRACE] = ACTIONS(8414),
    [anon_sym_RPAREN] = ACTIONS(8414),
    [anon_sym_DOT] = ACTIONS(8416),
    [anon_sym_COMMA] = ACTIONS(8414),
    [anon_sym_PIPE] = ACTIONS(8416),
    [anon_sym_STAR_STAR] = ACTIONS(8414),
    [anon_sym_AMP] = ACTIONS(8416),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LT] = ACTIONS(8416),
    [anon_sym_do] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8414),
    [anon_sym_COLON_COLON2] = ACTIONS(8414),
    [anon_sym_AMP_DOT] = ACTIONS(8414),
    [anon_sym_QMARK] = ACTIONS(8414),
    [anon_sym_DOT_DOT] = ACTIONS(8416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8414),
    [anon_sym_and] = ACTIONS(8414),
    [anon_sym_or] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE] = ACTIONS(8414),
    [anon_sym_AMP_AMP] = ACTIONS(8414),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8414),
    [anon_sym_LT_EQ_GT] = ACTIONS(8414),
    [anon_sym_EQ_TILDE] = ACTIONS(8414),
    [anon_sym_BANG_TILDE] = ACTIONS(8414),
    [anon_sym_LT_EQ] = ACTIONS(8416),
    [anon_sym_GT] = ACTIONS(8416),
    [anon_sym_GT_EQ] = ACTIONS(8414),
    [anon_sym_CARET] = ACTIONS(8414),
    [anon_sym_PLUS] = ACTIONS(8414),
    [anon_sym_SLASH] = ACTIONS(8414),
    [anon_sym_PERCENT] = ACTIONS(8414),
    [sym_comment] = ACTIONS(87),
  },
  [9015] = {
    [sym__heredoc_body_start] = ACTIONS(8923),
    [sym__binary_minus] = ACTIONS(8923),
    [sym__binary_star] = ACTIONS(8923),
    [anon_sym_LBRACE] = ACTIONS(8923),
    [anon_sym_RPAREN] = ACTIONS(8923),
    [anon_sym_DOT] = ACTIONS(8925),
    [anon_sym_COMMA] = ACTIONS(8923),
    [anon_sym_PIPE] = ACTIONS(8925),
    [anon_sym_STAR_STAR] = ACTIONS(8923),
    [anon_sym_AMP] = ACTIONS(8925),
    [anon_sym_EQ] = ACTIONS(8925),
    [anon_sym_LT] = ACTIONS(8925),
    [anon_sym_do] = ACTIONS(8923),
    [anon_sym_LBRACK] = ACTIONS(8923),
    [anon_sym_COLON_COLON2] = ACTIONS(8923),
    [anon_sym_AMP_DOT] = ACTIONS(8923),
    [anon_sym_QMARK] = ACTIONS(8923),
    [anon_sym_DOT_DOT] = ACTIONS(8925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8923),
    [anon_sym_and] = ACTIONS(8923),
    [anon_sym_or] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE] = ACTIONS(8923),
    [anon_sym_AMP_AMP] = ACTIONS(8923),
    [anon_sym_LT_LT] = ACTIONS(8923),
    [anon_sym_GT_GT] = ACTIONS(8923),
    [anon_sym_EQ_EQ] = ACTIONS(8925),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8925),
    [anon_sym_GT] = ACTIONS(8925),
    [anon_sym_GT_EQ] = ACTIONS(8923),
    [anon_sym_CARET] = ACTIONS(8923),
    [anon_sym_PLUS] = ACTIONS(8923),
    [anon_sym_SLASH] = ACTIONS(8923),
    [anon_sym_PERCENT] = ACTIONS(8923),
    [sym_comment] = ACTIONS(87),
  },
  [9016] = {
    [anon_sym_end] = ACTIONS(13606),
    [sym_comment] = ACTIONS(87),
  },
  [9017] = {
    [sym_ensure] = STATE(10058),
    [anon_sym_end] = ACTIONS(13606),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [9018] = {
    [sym__heredoc_body_start] = ACTIONS(9143),
    [sym__binary_minus] = ACTIONS(9143),
    [sym__binary_star] = ACTIONS(9143),
    [anon_sym_LBRACE] = ACTIONS(9143),
    [anon_sym_RPAREN] = ACTIONS(9143),
    [anon_sym_DOT] = ACTIONS(9145),
    [anon_sym_COMMA] = ACTIONS(9143),
    [anon_sym_PIPE] = ACTIONS(9145),
    [anon_sym_STAR_STAR] = ACTIONS(9143),
    [anon_sym_AMP] = ACTIONS(9145),
    [anon_sym_EQ] = ACTIONS(9145),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_do] = ACTIONS(9143),
    [anon_sym_LBRACK] = ACTIONS(9143),
    [anon_sym_COLON_COLON2] = ACTIONS(9143),
    [anon_sym_AMP_DOT] = ACTIONS(9143),
    [anon_sym_QMARK] = ACTIONS(9143),
    [anon_sym_DOT_DOT] = ACTIONS(9145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9143),
    [anon_sym_and] = ACTIONS(9143),
    [anon_sym_or] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE] = ACTIONS(9143),
    [anon_sym_AMP_AMP] = ACTIONS(9143),
    [anon_sym_LT_LT] = ACTIONS(9143),
    [anon_sym_GT_GT] = ACTIONS(9143),
    [anon_sym_EQ_EQ] = ACTIONS(9145),
    [anon_sym_BANG_EQ] = ACTIONS(9143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9143),
    [anon_sym_LT_EQ_GT] = ACTIONS(9143),
    [anon_sym_EQ_TILDE] = ACTIONS(9143),
    [anon_sym_BANG_TILDE] = ACTIONS(9143),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9143),
    [anon_sym_CARET] = ACTIONS(9143),
    [anon_sym_PLUS] = ACTIONS(9143),
    [anon_sym_SLASH] = ACTIONS(9143),
    [anon_sym_PERCENT] = ACTIONS(9143),
    [sym_comment] = ACTIONS(87),
  },
  [9019] = {
    [sym__heredoc_body_start] = ACTIONS(9172),
    [sym__binary_minus] = ACTIONS(9172),
    [sym__binary_star] = ACTIONS(9172),
    [anon_sym_LBRACE] = ACTIONS(9172),
    [anon_sym_RPAREN] = ACTIONS(9172),
    [anon_sym_DOT] = ACTIONS(9174),
    [anon_sym_COMMA] = ACTIONS(9172),
    [anon_sym_PIPE] = ACTIONS(9174),
    [anon_sym_STAR_STAR] = ACTIONS(9172),
    [anon_sym_AMP] = ACTIONS(9174),
    [anon_sym_EQ] = ACTIONS(9174),
    [anon_sym_LT] = ACTIONS(9174),
    [anon_sym_do] = ACTIONS(9172),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_COLON_COLON2] = ACTIONS(9172),
    [anon_sym_AMP_DOT] = ACTIONS(9172),
    [anon_sym_QMARK] = ACTIONS(9172),
    [anon_sym_DOT_DOT] = ACTIONS(9174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9172),
    [anon_sym_and] = ACTIONS(9172),
    [anon_sym_or] = ACTIONS(9172),
    [anon_sym_PIPE_PIPE] = ACTIONS(9172),
    [anon_sym_AMP_AMP] = ACTIONS(9172),
    [anon_sym_LT_LT] = ACTIONS(9172),
    [anon_sym_GT_GT] = ACTIONS(9172),
    [anon_sym_EQ_EQ] = ACTIONS(9174),
    [anon_sym_BANG_EQ] = ACTIONS(9172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9172),
    [anon_sym_LT_EQ_GT] = ACTIONS(9172),
    [anon_sym_EQ_TILDE] = ACTIONS(9172),
    [anon_sym_BANG_TILDE] = ACTIONS(9172),
    [anon_sym_LT_EQ] = ACTIONS(9174),
    [anon_sym_GT] = ACTIONS(9174),
    [anon_sym_GT_EQ] = ACTIONS(9172),
    [anon_sym_CARET] = ACTIONS(9172),
    [anon_sym_PLUS] = ACTIONS(9172),
    [anon_sym_SLASH] = ACTIONS(9172),
    [anon_sym_PERCENT] = ACTIONS(9172),
    [sym_comment] = ACTIONS(87),
  },
  [9020] = {
    [anon_sym_RBRACE] = ACTIONS(13608),
    [sym_comment] = ACTIONS(87),
  },
  [9021] = {
    [sym__heredoc_body_start] = ACTIONS(9192),
    [sym__binary_minus] = ACTIONS(9192),
    [sym__binary_star] = ACTIONS(9192),
    [anon_sym_LBRACE] = ACTIONS(9192),
    [anon_sym_RPAREN] = ACTIONS(9192),
    [anon_sym_DOT] = ACTIONS(9194),
    [anon_sym_COMMA] = ACTIONS(9192),
    [anon_sym_PIPE] = ACTIONS(9194),
    [anon_sym_STAR_STAR] = ACTIONS(9192),
    [anon_sym_AMP] = ACTIONS(9194),
    [anon_sym_EQ] = ACTIONS(9194),
    [anon_sym_LT] = ACTIONS(9194),
    [anon_sym_do] = ACTIONS(9192),
    [anon_sym_LBRACK] = ACTIONS(9192),
    [anon_sym_COLON_COLON2] = ACTIONS(9192),
    [anon_sym_AMP_DOT] = ACTIONS(9192),
    [anon_sym_QMARK] = ACTIONS(9192),
    [anon_sym_DOT_DOT] = ACTIONS(9194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9192),
    [anon_sym_and] = ACTIONS(9192),
    [anon_sym_or] = ACTIONS(9192),
    [anon_sym_PIPE_PIPE] = ACTIONS(9192),
    [anon_sym_AMP_AMP] = ACTIONS(9192),
    [anon_sym_LT_LT] = ACTIONS(9192),
    [anon_sym_GT_GT] = ACTIONS(9192),
    [anon_sym_EQ_EQ] = ACTIONS(9194),
    [anon_sym_BANG_EQ] = ACTIONS(9192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9192),
    [anon_sym_LT_EQ_GT] = ACTIONS(9192),
    [anon_sym_EQ_TILDE] = ACTIONS(9192),
    [anon_sym_BANG_TILDE] = ACTIONS(9192),
    [anon_sym_LT_EQ] = ACTIONS(9194),
    [anon_sym_GT] = ACTIONS(9194),
    [anon_sym_GT_EQ] = ACTIONS(9192),
    [anon_sym_CARET] = ACTIONS(9192),
    [anon_sym_PLUS] = ACTIONS(9192),
    [anon_sym_SLASH] = ACTIONS(9192),
    [anon_sym_PERCENT] = ACTIONS(9192),
    [sym_comment] = ACTIONS(87),
  },
  [9022] = {
    [anon_sym_end] = ACTIONS(13610),
    [sym_comment] = ACTIONS(87),
  },
  [9023] = {
    [sym__statements] = STATE(10061),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13612),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9024] = {
    [sym__statements] = STATE(10061),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_heredoc_body] = STATE(10062),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__terminator] = STATE(10062),
    [sym__line_break] = ACTIONS(13614),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(507),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13612),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9025] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10063),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_assignment] = STATE(10063),
    [sym_operator_assignment] = STATE(10063),
    [sym_conditional] = STATE(10063),
    [sym_range] = STATE(10063),
    [sym_binary] = STATE(10063),
    [sym_unary] = STATE(10063),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [9026] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7201),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2338),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2338),
    [sym_splat_argument] = STATE(10064),
    [sym_assignment] = STATE(7201),
    [sym_operator_assignment] = STATE(7201),
    [sym_conditional] = STATE(7201),
    [sym_range] = STATE(7201),
    [sym_binary] = STATE(7201),
    [sym_unary] = STATE(7201),
    [sym__arg_or_splat_arg] = STATE(10064),
    [sym_left_assignment_list] = STATE(2337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2338),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2338),
    [sym_false] = STATE(2338),
    [sym_nil] = STATE(2338),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2339),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7421),
    [sym__unary_minus] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_break] = ACTIONS(3898),
    [anon_sym_next] = ACTIONS(3900),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_defined_QMARK] = ACTIONS(3918),
    [anon_sym_not] = ACTIONS(3920),
    [anon_sym_BANG] = ACTIONS(3922),
    [anon_sym_TILDE] = ACTIONS(3922),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [9027] = {
    [aux_sym_exceptions_repeat1] = STATE(10065),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13616),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9028] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(3950),
    [sym__binary_star] = ACTIONS(3952),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3952),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(3960),
    [anon_sym_DOT_DOT] = ACTIONS(3962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3964),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3968),
    [anon_sym_AMP_AMP] = ACTIONS(3968),
    [anon_sym_LT_LT] = ACTIONS(3970),
    [anon_sym_GT_GT] = ACTIONS(3970),
    [anon_sym_EQ_EQ] = ACTIONS(3972),
    [anon_sym_BANG_EQ] = ACTIONS(3968),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3968),
    [anon_sym_LT_EQ_GT] = ACTIONS(3968),
    [anon_sym_EQ_TILDE] = ACTIONS(3968),
    [anon_sym_BANG_TILDE] = ACTIONS(3968),
    [anon_sym_LT_EQ] = ACTIONS(3958),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_GT_EQ] = ACTIONS(3974),
    [anon_sym_CARET] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3952),
    [sym_comment] = ACTIONS(87),
  },
  [9029] = {
    [aux_sym_exceptions_repeat1] = STATE(9029),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13618),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9030] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [9031] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [9032] = {
    [sym_heredoc_body] = STATE(9032),
    [aux_sym_call_repeat1] = STATE(9032),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9033] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(862),
    [sym_scope_resolution] = STATE(646),
    [sym_call] = STATE(646),
    [sym_method_call] = STATE(862),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(861),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(862),
    [sym__variable] = STATE(646),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_nil] = STATE(862),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(4780),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(7500),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(1527),
    [sym__identifier_hash_key] = ACTIONS(7504),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12388),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_next] = ACTIONS(1541),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_defined_QMARK] = ACTIONS(1545),
    [anon_sym_not] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1549),
    [sym_constant] = ACTIONS(7506),
    [sym_identifier] = ACTIONS(7506),
    [sym_instance_variable] = ACTIONS(1211),
    [sym_class_variable] = ACTIONS(1211),
    [sym_global_variable] = ACTIONS(1211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1215),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9034] = {
    [sym_heredoc_body] = STATE(9032),
    [aux_sym_call_repeat1] = STATE(9032),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9035] = {
    [aux_sym_argument_list_repeat1] = STATE(9035),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13621),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9036] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10066),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_assignment] = STATE(10066),
    [sym_operator_assignment] = STATE(10066),
    [sym_conditional] = STATE(10066),
    [sym_range] = STATE(10066),
    [sym_binary] = STATE(10066),
    [sym_unary] = STATE(10066),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9037] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7233),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2389),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(2389),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(7233),
    [sym_operator_assignment] = STATE(7233),
    [sym_conditional] = STATE(7233),
    [sym_range] = STATE(7233),
    [sym_binary] = STATE(7233),
    [sym_unary] = STATE(7233),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(2388),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2389),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2389),
    [sym_false] = STATE(2389),
    [sym_nil] = STATE(2389),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2390),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(7502),
    [sym__unary_minus] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3998),
    [anon_sym_yield] = ACTIONS(4000),
    [anon_sym_break] = ACTIONS(4002),
    [anon_sym_next] = ACTIONS(4004),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4006),
    [anon_sym_defined_QMARK] = ACTIONS(4008),
    [anon_sym_not] = ACTIONS(4010),
    [anon_sym_BANG] = ACTIONS(4012),
    [anon_sym_TILDE] = ACTIONS(4012),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9038] = {
    [aux_sym_exceptions_repeat1] = STATE(10067),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13624),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9039] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4030),
    [sym__binary_star] = ACTIONS(4032),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4034),
    [anon_sym_STAR_STAR] = ACTIONS(4032),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4040),
    [anon_sym_DOT_DOT] = ACTIONS(4042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4044),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4048),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_LT_LT] = ACTIONS(4050),
    [anon_sym_GT_GT] = ACTIONS(4050),
    [anon_sym_EQ_EQ] = ACTIONS(4052),
    [anon_sym_BANG_EQ] = ACTIONS(4048),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4048),
    [anon_sym_LT_EQ_GT] = ACTIONS(4048),
    [anon_sym_EQ_TILDE] = ACTIONS(4048),
    [anon_sym_BANG_TILDE] = ACTIONS(4048),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4054),
    [anon_sym_CARET] = ACTIONS(4056),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_SLASH] = ACTIONS(4032),
    [anon_sym_PERCENT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(87),
  },
  [9040] = {
    [aux_sym_exceptions_repeat1] = STATE(9040),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13626),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9041] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4076),
    [sym__binary_star] = ACTIONS(4078),
    [ts_builtin_sym_end] = ACTIONS(11746),
    [anon_sym___END__] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(4078),
    [anon_sym_AMP] = ACTIONS(4084),
    [anon_sym_LT] = ACTIONS(4086),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_DOT_DOT] = ACTIONS(4090),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4092),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4094),
    [anon_sym_AMP_AMP] = ACTIONS(4094),
    [anon_sym_LT_LT] = ACTIONS(4096),
    [anon_sym_GT_GT] = ACTIONS(4096),
    [anon_sym_EQ_EQ] = ACTIONS(4098),
    [anon_sym_BANG_EQ] = ACTIONS(4094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4094),
    [anon_sym_LT_EQ_GT] = ACTIONS(4094),
    [anon_sym_EQ_TILDE] = ACTIONS(4094),
    [anon_sym_BANG_TILDE] = ACTIONS(4094),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_GT] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4100),
    [anon_sym_CARET] = ACTIONS(4102),
    [anon_sym_PLUS] = ACTIONS(4076),
    [anon_sym_SLASH] = ACTIONS(4078),
    [anon_sym_PERCENT] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [9042] = {
    [aux_sym_exceptions_repeat1] = STATE(9042),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [ts_builtin_sym_end] = ACTIONS(11211),
    [anon_sym___END__] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13629),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9043] = {
    [sym_heredoc_body] = STATE(9043),
    [aux_sym_call_repeat1] = STATE(9043),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9044] = {
    [sym_heredoc_body] = STATE(9043),
    [aux_sym_call_repeat1] = STATE(9043),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9045] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10068),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_assignment] = STATE(10068),
    [sym_operator_assignment] = STATE(10068),
    [sym_conditional] = STATE(10068),
    [sym_range] = STATE(10068),
    [sym_binary] = STATE(10068),
    [sym_unary] = STATE(10068),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9046] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [9047] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7264),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2461),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(2461),
    [sym_splat_argument] = STATE(8300),
    [sym_assignment] = STATE(7264),
    [sym_operator_assignment] = STATE(7264),
    [sym_conditional] = STATE(7264),
    [sym_range] = STATE(7264),
    [sym_binary] = STATE(7264),
    [sym_unary] = STATE(7264),
    [sym__arg_or_splat_arg] = STATE(8300),
    [sym_left_assignment_list] = STATE(2460),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2461),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2461),
    [sym_false] = STATE(2461),
    [sym_nil] = STATE(2461),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(10560),
    [sym__unary_minus] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_defined_QMARK] = ACTIONS(4136),
    [anon_sym_not] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4140),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9048] = {
    [aux_sym_exceptions_repeat1] = STATE(10069),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(13632),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9049] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4162),
    [sym__binary_star] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4166),
    [anon_sym_STAR_STAR] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4168),
    [anon_sym_LT] = ACTIONS(4170),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4172),
    [anon_sym_DOT_DOT] = ACTIONS(4174),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4176),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4180),
    [anon_sym_AMP_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4180),
    [anon_sym_LT_EQ_GT] = ACTIONS(4180),
    [anon_sym_EQ_TILDE] = ACTIONS(4180),
    [anon_sym_BANG_TILDE] = ACTIONS(4180),
    [anon_sym_LT_EQ] = ACTIONS(4170),
    [anon_sym_GT] = ACTIONS(4170),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_CARET] = ACTIONS(4188),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [sym_comment] = ACTIONS(87),
  },
  [9050] = {
    [aux_sym_exceptions_repeat1] = STATE(9050),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13634),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9051] = {
    [sym__line_break] = ACTIONS(10568),
    [sym__simple_symbol] = ACTIONS(10568),
    [sym__string_start] = ACTIONS(10568),
    [sym__symbol_start] = ACTIONS(10568),
    [sym__subshell_start] = ACTIONS(10568),
    [sym__regex_start] = ACTIONS(10568),
    [sym__string_array_start] = ACTIONS(10568),
    [sym__symbol_array_start] = ACTIONS(10568),
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym_heredoc_beginning] = ACTIONS(10568),
    [sym__block_ampersand] = ACTIONS(10568),
    [sym__splat_star] = ACTIONS(10568),
    [sym__unary_minus] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [sym__identifier_hash_key] = ACTIONS(10568),
    [ts_builtin_sym_end] = ACTIONS(10568),
    [anon_sym___END__] = ACTIONS(10570),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_def] = ACTIONS(10570),
    [anon_sym_LPAREN] = ACTIONS(10570),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COLON_COLON] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10570),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_class] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_module] = ACTIONS(10570),
    [anon_sym_end] = ACTIONS(10570),
    [anon_sym_return] = ACTIONS(10570),
    [anon_sym_yield] = ACTIONS(10570),
    [anon_sym_break] = ACTIONS(10570),
    [anon_sym_next] = ACTIONS(10570),
    [sym_redo] = ACTIONS(10570),
    [sym_retry] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10570),
    [anon_sym_unless] = ACTIONS(10570),
    [anon_sym_while] = ACTIONS(10570),
    [anon_sym_until] = ACTIONS(10570),
    [anon_sym_rescue] = ACTIONS(10570),
    [anon_sym_for] = ACTIONS(10570),
    [anon_sym_do] = ACTIONS(10570),
    [anon_sym_case] = ACTIONS(10570),
    [anon_sym_when] = ACTIONS(10570),
    [anon_sym_elsif] = ACTIONS(10570),
    [anon_sym_else] = ACTIONS(10570),
    [anon_sym_then] = ACTIONS(10570),
    [anon_sym_begin] = ACTIONS(10570),
    [anon_sym_ensure] = ACTIONS(10570),
    [anon_sym_EQ_GT] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_LPAREN2] = ACTIONS(10568),
    [anon_sym_PLUS_EQ] = ACTIONS(10568),
    [anon_sym_DASH_EQ] = ACTIONS(10568),
    [anon_sym_STAR_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10568),
    [anon_sym_SLASH_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10568),
    [anon_sym_AMP_EQ] = ACTIONS(10568),
    [anon_sym_PERCENT_EQ] = ACTIONS(10568),
    [anon_sym_GT_GT_EQ] = ACTIONS(10568),
    [anon_sym_LT_LT_EQ] = ACTIONS(10568),
    [anon_sym_CARET_EQ] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10570),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10570),
    [anon_sym_or] = ACTIONS(10570),
    [anon_sym_PIPE_PIPE] = ACTIONS(10570),
    [anon_sym_AMP_AMP] = ACTIONS(10570),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10570),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_SLASH] = ACTIONS(10570),
    [anon_sym_PERCENT] = ACTIONS(10570),
    [anon_sym_defined_QMARK] = ACTIONS(10568),
    [anon_sym_not] = ACTIONS(10570),
    [anon_sym_BANG] = ACTIONS(10570),
    [anon_sym_TILDE] = ACTIONS(10568),
    [sym_constant] = ACTIONS(10570),
    [sym_identifier] = ACTIONS(10570),
    [sym_instance_variable] = ACTIONS(10568),
    [sym_class_variable] = ACTIONS(10568),
    [sym_global_variable] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10570),
    [sym_float] = ACTIONS(10570),
    [sym_complex] = ACTIONS(10568),
    [sym_super] = ACTIONS(10570),
    [anon_sym_true] = ACTIONS(10570),
    [anon_sym_TRUE] = ACTIONS(10570),
    [anon_sym_false] = ACTIONS(10570),
    [anon_sym_FALSE] = ACTIONS(10570),
    [sym_self] = ACTIONS(10570),
    [anon_sym_nil] = ACTIONS(10570),
    [anon_sym_NIL] = ACTIONS(10570),
    [sym_character] = ACTIONS(10568),
    [anon_sym_LBRACK2] = ACTIONS(10570),
    [anon_sym_DASH_GT] = ACTIONS(10568),
  },
  [9052] = {
    [sym__line_break] = ACTIONS(13264),
    [sym__heredoc_body_start] = ACTIONS(13264),
    [sym__binary_minus] = ACTIONS(13264),
    [sym__binary_star] = ACTIONS(13264),
    [ts_builtin_sym_end] = ACTIONS(13264),
    [anon_sym___END__] = ACTIONS(13264),
    [anon_sym_LBRACE] = ACTIONS(13264),
    [anon_sym_RBRACE] = ACTIONS(13264),
    [anon_sym_RPAREN] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13266),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13266),
    [anon_sym_SEMI] = ACTIONS(13264),
    [anon_sym_STAR_STAR] = ACTIONS(13266),
    [anon_sym_AMP] = ACTIONS(13266),
    [anon_sym_EQ] = ACTIONS(13266),
    [anon_sym_LT] = ACTIONS(13266),
    [anon_sym_end] = ACTIONS(13264),
    [anon_sym_if] = ACTIONS(13264),
    [anon_sym_unless] = ACTIONS(13264),
    [anon_sym_while] = ACTIONS(13264),
    [anon_sym_until] = ACTIONS(13264),
    [anon_sym_rescue] = ACTIONS(13264),
    [anon_sym_do] = ACTIONS(13264),
    [anon_sym_when] = ACTIONS(13264),
    [anon_sym_elsif] = ACTIONS(13264),
    [anon_sym_else] = ACTIONS(13264),
    [anon_sym_then] = ACTIONS(13264),
    [anon_sym_ensure] = ACTIONS(13264),
    [anon_sym_EQ_GT] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [anon_sym_PLUS_EQ] = ACTIONS(13264),
    [anon_sym_DASH_EQ] = ACTIONS(13264),
    [anon_sym_STAR_EQ] = ACTIONS(13264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13264),
    [anon_sym_SLASH_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13264),
    [anon_sym_AMP_EQ] = ACTIONS(13264),
    [anon_sym_PERCENT_EQ] = ACTIONS(13264),
    [anon_sym_GT_GT_EQ] = ACTIONS(13264),
    [anon_sym_LT_LT_EQ] = ACTIONS(13264),
    [anon_sym_CARET_EQ] = ACTIONS(13264),
    [anon_sym_QMARK] = ACTIONS(13264),
    [anon_sym_DOT_DOT] = ACTIONS(13266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13264),
    [anon_sym_and] = ACTIONS(13264),
    [anon_sym_or] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE] = ACTIONS(13266),
    [anon_sym_AMP_AMP] = ACTIONS(13266),
    [anon_sym_LT_LT] = ACTIONS(13266),
    [anon_sym_GT_GT] = ACTIONS(13266),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13264),
    [anon_sym_LT_EQ_GT] = ACTIONS(13264),
    [anon_sym_EQ_TILDE] = ACTIONS(13264),
    [anon_sym_BANG_TILDE] = ACTIONS(13264),
    [anon_sym_LT_EQ] = ACTIONS(13266),
    [anon_sym_GT] = ACTIONS(13266),
    [anon_sym_GT_EQ] = ACTIONS(13264),
    [anon_sym_CARET] = ACTIONS(13266),
    [anon_sym_PLUS] = ACTIONS(13266),
    [anon_sym_SLASH] = ACTIONS(13266),
    [anon_sym_PERCENT] = ACTIONS(13266),
    [sym_comment] = ACTIONS(87),
  },
  [9053] = {
    [anon_sym_end] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
  },
  [9054] = {
    [sym_heredoc_body] = STATE(9054),
    [aux_sym_call_repeat1] = STATE(9054),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9055] = {
    [sym_heredoc_body] = STATE(9054),
    [aux_sym_call_repeat1] = STATE(9054),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9056] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10071),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_assignment] = STATE(10071),
    [sym_operator_assignment] = STATE(10071),
    [sym_conditional] = STATE(10071),
    [sym_range] = STATE(10071),
    [sym_binary] = STATE(10071),
    [sym_unary] = STATE(10071),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9057] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7310),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2566),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2566),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(7310),
    [sym_operator_assignment] = STATE(7310),
    [sym_conditional] = STATE(7310),
    [sym_range] = STATE(7310),
    [sym_binary] = STATE(7310),
    [sym_unary] = STATE(7310),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(2565),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2566),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2566),
    [sym_false] = STATE(2566),
    [sym_nil] = STATE(2566),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1713),
    [sym__unary_minus] = ACTIONS(4254),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4264),
    [anon_sym_defined_QMARK] = ACTIONS(4266),
    [anon_sym_not] = ACTIONS(4268),
    [anon_sym_BANG] = ACTIONS(4270),
    [anon_sym_TILDE] = ACTIONS(4270),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9058] = {
    [aux_sym_exceptions_repeat1] = STATE(10072),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13639),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9059] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4286),
    [sym__binary_star] = ACTIONS(4288),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4290),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(4288),
    [anon_sym_AMP] = ACTIONS(4292),
    [anon_sym_LT] = ACTIONS(4294),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4296),
    [anon_sym_DOT_DOT] = ACTIONS(4298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4300),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4302),
    [anon_sym_AMP_AMP] = ACTIONS(4302),
    [anon_sym_LT_LT] = ACTIONS(4304),
    [anon_sym_GT_GT] = ACTIONS(4304),
    [anon_sym_EQ_EQ] = ACTIONS(4306),
    [anon_sym_BANG_EQ] = ACTIONS(4302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4302),
    [anon_sym_LT_EQ_GT] = ACTIONS(4302),
    [anon_sym_EQ_TILDE] = ACTIONS(4302),
    [anon_sym_BANG_TILDE] = ACTIONS(4302),
    [anon_sym_LT_EQ] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(4294),
    [anon_sym_GT_EQ] = ACTIONS(4308),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [sym_comment] = ACTIONS(87),
  },
  [9060] = {
    [aux_sym_exceptions_repeat1] = STATE(9060),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13641),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9061] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9062] = {
    [sym_heredoc_body] = STATE(10073),
    [aux_sym_call_repeat1] = STATE(10073),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_elsif] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [9063] = {
    [sym_heredoc_body] = STATE(10073),
    [aux_sym_call_repeat1] = STATE(10073),
    [aux_sym_argument_list_repeat1] = STATE(10074),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10677),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_elsif] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [9064] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12440),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [9065] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10075),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10075),
    [sym_operator_assignment] = STATE(10075),
    [sym_conditional] = STATE(10075),
    [sym_range] = STATE(10075),
    [sym_binary] = STATE(10075),
    [sym_unary] = STATE(10075),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9066] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10076),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10076),
    [sym_operator_assignment] = STATE(10076),
    [sym_conditional] = STATE(10076),
    [sym_range] = STATE(10076),
    [sym_binary] = STATE(10076),
    [sym_unary] = STATE(10076),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9067] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10077),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10077),
    [sym_operator_assignment] = STATE(10077),
    [sym_conditional] = STATE(10077),
    [sym_range] = STATE(10077),
    [sym_binary] = STATE(10077),
    [sym_unary] = STATE(10077),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9068] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10078),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10078),
    [sym_operator_assignment] = STATE(10078),
    [sym_conditional] = STATE(10078),
    [sym_range] = STATE(10078),
    [sym_binary] = STATE(10078),
    [sym_unary] = STATE(10078),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9069] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10079),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10079),
    [sym_operator_assignment] = STATE(10079),
    [sym_conditional] = STATE(10079),
    [sym_range] = STATE(10079),
    [sym_binary] = STATE(10079),
    [sym_unary] = STATE(10079),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9070] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10080),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10080),
    [sym_operator_assignment] = STATE(10080),
    [sym_conditional] = STATE(10080),
    [sym_range] = STATE(10080),
    [sym_binary] = STATE(10080),
    [sym_unary] = STATE(10080),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9071] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10081),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10081),
    [sym_operator_assignment] = STATE(10081),
    [sym_conditional] = STATE(10081),
    [sym_range] = STATE(10081),
    [sym_binary] = STATE(10081),
    [sym_unary] = STATE(10081),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9072] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10082),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10082),
    [sym_operator_assignment] = STATE(10082),
    [sym_conditional] = STATE(10082),
    [sym_range] = STATE(10082),
    [sym_binary] = STATE(10082),
    [sym_unary] = STATE(10082),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9073] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10083),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10083),
    [sym_operator_assignment] = STATE(10083),
    [sym_conditional] = STATE(10083),
    [sym_range] = STATE(10083),
    [sym_binary] = STATE(10083),
    [sym_unary] = STATE(10083),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9074] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10084),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10084),
    [sym_operator_assignment] = STATE(10084),
    [sym_conditional] = STATE(10084),
    [sym_range] = STATE(10084),
    [sym_binary] = STATE(10084),
    [sym_unary] = STATE(10084),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9075] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10085),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_splat_argument] = STATE(10086),
    [sym_assignment] = STATE(10085),
    [sym_operator_assignment] = STATE(10085),
    [sym_conditional] = STATE(10085),
    [sym_range] = STATE(10085),
    [sym_binary] = STATE(10085),
    [sym_unary] = STATE(10085),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(10086),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9076] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10087),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10087),
    [sym_operator_assignment] = STATE(10087),
    [sym_conditional] = STATE(10087),
    [sym_range] = STATE(10087),
    [sym_binary] = STATE(10087),
    [sym_unary] = STATE(10087),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9077] = {
    [sym_string] = STATE(10088),
    [aux_sym_chained_string_repeat1] = STATE(10088),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_elsif] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [9078] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_elsif] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(12440),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [9079] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_elsif] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9080] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_elsif] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9081] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10089),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(10089),
    [sym_operator_assignment] = STATE(10089),
    [sym_conditional] = STATE(10089),
    [sym_range] = STATE(10089),
    [sym_binary] = STATE(10089),
    [sym_unary] = STATE(10089),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9082] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_elsif] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9083] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10090),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(10090),
    [sym_operator_assignment] = STATE(10090),
    [sym_conditional] = STATE(10090),
    [sym_range] = STATE(10090),
    [sym_binary] = STATE(10090),
    [sym_unary] = STATE(10090),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9084] = {
    [sym_heredoc_body] = STATE(10091),
    [aux_sym_call_repeat1] = STATE(10091),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_elsif] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9085] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7350),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(7350),
    [sym_operator_assignment] = STATE(7350),
    [sym_conditional] = STATE(7350),
    [sym_range] = STATE(7350),
    [sym_binary] = STATE(7350),
    [sym_unary] = STATE(7350),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7353),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10092),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10633),
    [sym__splat_star] = ACTIONS(10635),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__identifier_hash_key] = ACTIONS(10637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13644),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(10639),
    [sym_identifier] = ACTIONS(10639),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9086] = {
    [sym_heredoc_body] = STATE(10093),
    [aux_sym_call_repeat1] = STATE(10093),
    [aux_sym_argument_list_repeat1] = STATE(10094),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(12466),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_elsif] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9087] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_elsif] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(12440),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [9088] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9089] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9090] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9091] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9092] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9093] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13646),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9094] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_elsif] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9095] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9096] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9097] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9098] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_elsif] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9099] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_elsif] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9100] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10096),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(10096),
    [sym_operator_assignment] = STATE(10096),
    [sym_conditional] = STATE(10096),
    [sym_range] = STATE(10096),
    [sym_binary] = STATE(10096),
    [sym_unary] = STATE(10096),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9101] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_elsif] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9102] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10097),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(10097),
    [sym_operator_assignment] = STATE(10097),
    [sym_conditional] = STATE(10097),
    [sym_range] = STATE(10097),
    [sym_binary] = STATE(10097),
    [sym_unary] = STATE(10097),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9103] = {
    [sym_heredoc_body] = STATE(10098),
    [aux_sym_call_repeat1] = STATE(10098),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_elsif] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [9104] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7371),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(7371),
    [sym_operator_assignment] = STATE(7371),
    [sym_conditional] = STATE(7371),
    [sym_range] = STATE(7371),
    [sym_binary] = STATE(7371),
    [sym_unary] = STATE(7371),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7374),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(10099),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10669),
    [sym__splat_star] = ACTIONS(10671),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__identifier_hash_key] = ACTIONS(10673),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13648),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(10675),
    [sym_identifier] = ACTIONS(10675),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9105] = {
    [sym_heredoc_body] = STATE(10100),
    [aux_sym_call_repeat1] = STATE(10100),
    [aux_sym_argument_list_repeat1] = STATE(10101),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(12474),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_elsif] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [9106] = {
    [sym_heredoc_body] = STATE(9106),
    [aux_sym_call_repeat1] = STATE(9106),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_elsif] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9107] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(4995),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(4995),
    [sym_operator_assignment] = STATE(4995),
    [sym_conditional] = STATE(4995),
    [sym_range] = STATE(4995),
    [sym_binary] = STATE(4995),
    [sym_unary] = STATE(4995),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5001),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7728),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__identifier_hash_key] = ACTIONS(7734),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12478),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7752),
    [sym_identifier] = ACTIONS(7752),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9108] = {
    [sym_heredoc_body] = STATE(9106),
    [aux_sym_call_repeat1] = STATE(9106),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_elsif] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9109] = {
    [aux_sym_argument_list_repeat1] = STATE(9109),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13650),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_elsif] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9110] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_elsif] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9111] = {
    [aux_sym_exceptions_repeat1] = STATE(10103),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_elsif] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9112] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_elsif] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [9113] = {
    [sym_string] = STATE(9113),
    [aux_sym_chained_string_repeat1] = STATE(9113),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_elsif] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [9114] = {
    [sym_elsif] = STATE(10104),
    [sym_else] = STATE(10104),
    [sym__if_tail] = STATE(10104),
    [anon_sym_end] = ACTIONS(13653),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [9115] = {
    [anon_sym_end] = ACTIONS(13653),
    [sym_comment] = ACTIONS(87),
  },
  [9116] = {
    [aux_sym_undef_repeat1] = STATE(9116),
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9006),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_end] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [anon_sym_elsif] = ACTIONS(9004),
    [anon_sym_else] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [9117] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9118] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10105),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(10105),
    [sym_operator_assignment] = STATE(10105),
    [sym_conditional] = STATE(10105),
    [sym_range] = STATE(10105),
    [sym_binary] = STATE(10105),
    [sym_unary] = STATE(10105),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9119] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [9120] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [9121] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10106),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10106),
    [sym_operator_assignment] = STATE(10106),
    [sym_conditional] = STATE(10106),
    [sym_range] = STATE(10106),
    [sym_binary] = STATE(10106),
    [sym_unary] = STATE(10106),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9122] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10107),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10107),
    [sym_operator_assignment] = STATE(10107),
    [sym_conditional] = STATE(10107),
    [sym_range] = STATE(10107),
    [sym_binary] = STATE(10107),
    [sym_unary] = STATE(10107),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9123] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10108),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10108),
    [sym_operator_assignment] = STATE(10108),
    [sym_conditional] = STATE(10108),
    [sym_range] = STATE(10108),
    [sym_binary] = STATE(10108),
    [sym_unary] = STATE(10108),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9124] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10109),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10109),
    [sym_operator_assignment] = STATE(10109),
    [sym_conditional] = STATE(10109),
    [sym_range] = STATE(10109),
    [sym_binary] = STATE(10109),
    [sym_unary] = STATE(10109),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9125] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10110),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10110),
    [sym_operator_assignment] = STATE(10110),
    [sym_conditional] = STATE(10110),
    [sym_range] = STATE(10110),
    [sym_binary] = STATE(10110),
    [sym_unary] = STATE(10110),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9126] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10111),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10111),
    [sym_operator_assignment] = STATE(10111),
    [sym_conditional] = STATE(10111),
    [sym_range] = STATE(10111),
    [sym_binary] = STATE(10111),
    [sym_unary] = STATE(10111),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9127] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10112),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10112),
    [sym_operator_assignment] = STATE(10112),
    [sym_conditional] = STATE(10112),
    [sym_range] = STATE(10112),
    [sym_binary] = STATE(10112),
    [sym_unary] = STATE(10112),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9128] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10113),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10113),
    [sym_operator_assignment] = STATE(10113),
    [sym_conditional] = STATE(10113),
    [sym_range] = STATE(10113),
    [sym_binary] = STATE(10113),
    [sym_unary] = STATE(10113),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9129] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10114),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10114),
    [sym_operator_assignment] = STATE(10114),
    [sym_conditional] = STATE(10114),
    [sym_range] = STATE(10114),
    [sym_binary] = STATE(10114),
    [sym_unary] = STATE(10114),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9130] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10115),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10115),
    [sym_operator_assignment] = STATE(10115),
    [sym_conditional] = STATE(10115),
    [sym_range] = STATE(10115),
    [sym_binary] = STATE(10115),
    [sym_unary] = STATE(10115),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9131] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10116),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_splat_argument] = STATE(10117),
    [sym_assignment] = STATE(10116),
    [sym_operator_assignment] = STATE(10116),
    [sym_conditional] = STATE(10116),
    [sym_range] = STATE(10116),
    [sym_binary] = STATE(10116),
    [sym_unary] = STATE(10116),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(10117),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(7810),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9132] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10118),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10118),
    [sym_operator_assignment] = STATE(10118),
    [sym_conditional] = STATE(10118),
    [sym_range] = STATE(10118),
    [sym_binary] = STATE(10118),
    [sym_unary] = STATE(10118),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9133] = {
    [sym_string] = STATE(10119),
    [aux_sym_chained_string_repeat1] = STATE(10119),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_elsif] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [9134] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_elsif] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [9135] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_elsif] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [9136] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9137] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [9138] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9139] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9140] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9141] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13655),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9142] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_elsif] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9143] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9144] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9145] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9146] = {
    [sym_heredoc_body] = STATE(9146),
    [aux_sym_call_repeat1] = STATE(9146),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_elsif] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [9147] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5037),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(5037),
    [sym_operator_assignment] = STATE(5037),
    [sym_conditional] = STATE(5037),
    [sym_range] = STATE(5037),
    [sym_binary] = STATE(5037),
    [sym_unary] = STATE(5037),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5043),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(7808),
    [sym__splat_star] = ACTIONS(7810),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__identifier_hash_key] = ACTIONS(7814),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12525),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7832),
    [sym_identifier] = ACTIONS(7832),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9148] = {
    [sym_heredoc_body] = STATE(9146),
    [aux_sym_call_repeat1] = STATE(9146),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_elsif] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [9149] = {
    [aux_sym_argument_list_repeat1] = STATE(9149),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13657),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_elsif] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [9150] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_elsif] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9151] = {
    [aux_sym_exceptions_repeat1] = STATE(10122),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_elsif] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [9152] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_elsif] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [9153] = {
    [sym_string] = STATE(9153),
    [aux_sym_chained_string_repeat1] = STATE(9153),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_elsif] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [9154] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(12531),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(12533),
    [anon_sym_LT] = ACTIONS(12535),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_elsif] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(12537),
    [anon_sym_DOT_DOT] = ACTIONS(12539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12541),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(12543),
    [anon_sym_AMP_AMP] = ACTIONS(12543),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(12547),
    [anon_sym_BANG_EQ] = ACTIONS(12543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12543),
    [anon_sym_LT_EQ_GT] = ACTIONS(12543),
    [anon_sym_EQ_TILDE] = ACTIONS(12543),
    [anon_sym_BANG_TILDE] = ACTIONS(12543),
    [anon_sym_LT_EQ] = ACTIONS(12535),
    [anon_sym_GT] = ACTIONS(12535),
    [anon_sym_GT_EQ] = ACTIONS(12549),
    [anon_sym_CARET] = ACTIONS(12551),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [9155] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9156] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12531),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(12533),
    [anon_sym_LT] = ACTIONS(12535),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_elsif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12537),
    [anon_sym_DOT_DOT] = ACTIONS(12539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12541),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12543),
    [anon_sym_AMP_AMP] = ACTIONS(12543),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(12547),
    [anon_sym_BANG_EQ] = ACTIONS(12543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12543),
    [anon_sym_LT_EQ_GT] = ACTIONS(12543),
    [anon_sym_EQ_TILDE] = ACTIONS(12543),
    [anon_sym_BANG_TILDE] = ACTIONS(12543),
    [anon_sym_LT_EQ] = ACTIONS(12535),
    [anon_sym_GT] = ACTIONS(12535),
    [anon_sym_GT_EQ] = ACTIONS(12549),
    [anon_sym_CARET] = ACTIONS(12551),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [9157] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10123),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10123),
    [sym_operator_assignment] = STATE(10123),
    [sym_conditional] = STATE(10123),
    [sym_range] = STATE(10123),
    [sym_binary] = STATE(10123),
    [sym_unary] = STATE(10123),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9158] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10124),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10124),
    [sym_operator_assignment] = STATE(10124),
    [sym_conditional] = STATE(10124),
    [sym_range] = STATE(10124),
    [sym_binary] = STATE(10124),
    [sym_unary] = STATE(10124),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9159] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10125),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10125),
    [sym_operator_assignment] = STATE(10125),
    [sym_conditional] = STATE(10125),
    [sym_range] = STATE(10125),
    [sym_binary] = STATE(10125),
    [sym_unary] = STATE(10125),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9160] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10126),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10126),
    [sym_operator_assignment] = STATE(10126),
    [sym_conditional] = STATE(10126),
    [sym_range] = STATE(10126),
    [sym_binary] = STATE(10126),
    [sym_unary] = STATE(10126),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9161] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10127),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10127),
    [sym_operator_assignment] = STATE(10127),
    [sym_conditional] = STATE(10127),
    [sym_range] = STATE(10127),
    [sym_binary] = STATE(10127),
    [sym_unary] = STATE(10127),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9162] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10128),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10128),
    [sym_operator_assignment] = STATE(10128),
    [sym_conditional] = STATE(10128),
    [sym_range] = STATE(10128),
    [sym_binary] = STATE(10128),
    [sym_unary] = STATE(10128),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9163] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10129),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10129),
    [sym_operator_assignment] = STATE(10129),
    [sym_conditional] = STATE(10129),
    [sym_range] = STATE(10129),
    [sym_binary] = STATE(10129),
    [sym_unary] = STATE(10129),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9164] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10130),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10130),
    [sym_operator_assignment] = STATE(10130),
    [sym_conditional] = STATE(10130),
    [sym_range] = STATE(10130),
    [sym_binary] = STATE(10130),
    [sym_unary] = STATE(10130),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9165] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10131),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10131),
    [sym_operator_assignment] = STATE(10131),
    [sym_conditional] = STATE(10131),
    [sym_range] = STATE(10131),
    [sym_binary] = STATE(10131),
    [sym_unary] = STATE(10131),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9166] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10132),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10132),
    [sym_operator_assignment] = STATE(10132),
    [sym_conditional] = STATE(10132),
    [sym_range] = STATE(10132),
    [sym_binary] = STATE(10132),
    [sym_unary] = STATE(10132),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9167] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7440),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(7440),
    [sym_operator_assignment] = STATE(7440),
    [sym_conditional] = STATE(7440),
    [sym_range] = STATE(7440),
    [sym_binary] = STATE(7440),
    [sym_unary] = STATE(7440),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(10763),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9168] = {
    [aux_sym_exceptions_repeat1] = STATE(10133),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(12553),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_elsif] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9169] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7440),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_splat_argument] = STATE(10134),
    [sym_assignment] = STATE(7440),
    [sym_operator_assignment] = STATE(7440),
    [sym_conditional] = STATE(7440),
    [sym_range] = STATE(7440),
    [sym_binary] = STATE(7440),
    [sym_unary] = STATE(7440),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(10134),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(10763),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9170] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10135),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10135),
    [sym_operator_assignment] = STATE(10135),
    [sym_conditional] = STATE(10135),
    [sym_range] = STATE(10135),
    [sym_binary] = STATE(10135),
    [sym_unary] = STATE(10135),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9171] = {
    [sym__line_break] = ACTIONS(13660),
    [sym__heredoc_body_start] = ACTIONS(13660),
    [sym__binary_minus] = ACTIONS(13660),
    [sym__binary_star] = ACTIONS(13660),
    [ts_builtin_sym_end] = ACTIONS(13660),
    [anon_sym___END__] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_RBRACE] = ACTIONS(13660),
    [anon_sym_RPAREN] = ACTIONS(13660),
    [anon_sym_DOT] = ACTIONS(13662),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_PIPE] = ACTIONS(13662),
    [anon_sym_SEMI] = ACTIONS(13660),
    [anon_sym_STAR_STAR] = ACTIONS(13660),
    [anon_sym_AMP] = ACTIONS(13662),
    [anon_sym_LT] = ACTIONS(13662),
    [anon_sym_end] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_unless] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [anon_sym_until] = ACTIONS(13660),
    [anon_sym_rescue] = ACTIONS(13660),
    [anon_sym_do] = ACTIONS(13660),
    [anon_sym_when] = ACTIONS(13660),
    [anon_sym_elsif] = ACTIONS(13660),
    [anon_sym_else] = ACTIONS(13660),
    [anon_sym_then] = ACTIONS(13660),
    [anon_sym_ensure] = ACTIONS(13660),
    [anon_sym_EQ_GT] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_COLON_COLON2] = ACTIONS(13660),
    [anon_sym_AMP_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_DOT_DOT] = ACTIONS(13662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_and] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE] = ACTIONS(13660),
    [anon_sym_AMP_AMP] = ACTIONS(13660),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_EQ_EQ] = ACTIONS(13662),
    [anon_sym_BANG_EQ] = ACTIONS(13660),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13660),
    [anon_sym_LT_EQ_GT] = ACTIONS(13660),
    [anon_sym_EQ_TILDE] = ACTIONS(13660),
    [anon_sym_BANG_TILDE] = ACTIONS(13660),
    [anon_sym_LT_EQ] = ACTIONS(13662),
    [anon_sym_GT] = ACTIONS(13662),
    [anon_sym_GT_EQ] = ACTIONS(13660),
    [anon_sym_CARET] = ACTIONS(13660),
    [anon_sym_PLUS] = ACTIONS(13660),
    [anon_sym_SLASH] = ACTIONS(13660),
    [anon_sym_PERCENT] = ACTIONS(13660),
    [sym_comment] = ACTIONS(87),
  },
  [9172] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10136),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_assignment] = STATE(10136),
    [sym_operator_assignment] = STATE(10136),
    [sym_conditional] = STATE(10136),
    [sym_range] = STATE(10136),
    [sym_binary] = STATE(10136),
    [sym_unary] = STATE(10136),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9173] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7458),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2659),
    [sym_scope_resolution] = STATE(2657),
    [sym_call] = STATE(2657),
    [sym_method_call] = STATE(2659),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(7458),
    [sym_operator_assignment] = STATE(7458),
    [sym_conditional] = STATE(7458),
    [sym_range] = STATE(7458),
    [sym_binary] = STATE(7458),
    [sym_unary] = STATE(7458),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(2658),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2659),
    [sym__variable] = STATE(2657),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2659),
    [sym_false] = STATE(2659),
    [sym_nil] = STATE(2659),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2660),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(1789),
    [sym__unary_minus] = ACTIONS(4372),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4374),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_break] = ACTIONS(4378),
    [anon_sym_next] = ACTIONS(4380),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4382),
    [anon_sym_defined_QMARK] = ACTIONS(4384),
    [anon_sym_not] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4388),
    [sym_constant] = ACTIONS(4390),
    [sym_identifier] = ACTIONS(4390),
    [sym_instance_variable] = ACTIONS(4392),
    [sym_class_variable] = ACTIONS(4392),
    [sym_global_variable] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4390),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4390),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9174] = {
    [aux_sym_exceptions_repeat1] = STATE(10137),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13664),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9175] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4400),
    [sym__binary_star] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4404),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4408),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(4410),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4412),
    [anon_sym_DOT_DOT] = ACTIONS(4414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4416),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4418),
    [anon_sym_AMP_AMP] = ACTIONS(4418),
    [anon_sym_LT_LT] = ACTIONS(4420),
    [anon_sym_GT_GT] = ACTIONS(4420),
    [anon_sym_EQ_EQ] = ACTIONS(4418),
    [anon_sym_BANG_EQ] = ACTIONS(4422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4422),
    [anon_sym_LT_EQ_GT] = ACTIONS(4422),
    [anon_sym_EQ_TILDE] = ACTIONS(4422),
    [anon_sym_BANG_TILDE] = ACTIONS(4422),
    [anon_sym_LT_EQ] = ACTIONS(4410),
    [anon_sym_GT] = ACTIONS(4410),
    [anon_sym_GT_EQ] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4404),
    [anon_sym_PLUS] = ACTIONS(4426),
    [anon_sym_SLASH] = ACTIONS(4406),
    [anon_sym_PERCENT] = ACTIONS(4406),
    [sym_comment] = ACTIONS(87),
  },
  [9176] = {
    [aux_sym_exceptions_repeat1] = STATE(9176),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13666),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [9177] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10138),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2691),
    [sym_scope_resolution] = STATE(235),
    [sym_call] = STATE(235),
    [sym_method_call] = STATE(2691),
    [sym_assignment] = STATE(10138),
    [sym_operator_assignment] = STATE(10138),
    [sym_conditional] = STATE(10138),
    [sym_range] = STATE(10138),
    [sym_binary] = STATE(10138),
    [sym_unary] = STATE(10138),
    [sym_left_assignment_list] = STATE(2690),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2691),
    [sym__variable] = STATE(235),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2691),
    [sym_false] = STATE(2691),
    [sym_nil] = STATE(2691),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2567),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4440),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_break] = ACTIONS(4260),
    [anon_sym_next] = ACTIONS(4262),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4442),
    [anon_sym_defined_QMARK] = ACTIONS(4444),
    [anon_sym_not] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4448),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9178] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9179] = {
    [sym_heredoc_body] = STATE(10139),
    [aux_sym_call_repeat1] = STATE(10139),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [9180] = {
    [sym_heredoc_body] = STATE(10139),
    [aux_sym_call_repeat1] = STATE(10139),
    [aux_sym_argument_list_repeat1] = STATE(10140),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(10846),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [9181] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12582),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [9182] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10141),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10141),
    [sym_operator_assignment] = STATE(10141),
    [sym_conditional] = STATE(10141),
    [sym_range] = STATE(10141),
    [sym_binary] = STATE(10141),
    [sym_unary] = STATE(10141),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9183] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10142),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10142),
    [sym_operator_assignment] = STATE(10142),
    [sym_conditional] = STATE(10142),
    [sym_range] = STATE(10142),
    [sym_binary] = STATE(10142),
    [sym_unary] = STATE(10142),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9184] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10143),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10143),
    [sym_operator_assignment] = STATE(10143),
    [sym_conditional] = STATE(10143),
    [sym_range] = STATE(10143),
    [sym_binary] = STATE(10143),
    [sym_unary] = STATE(10143),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9185] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10144),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10144),
    [sym_operator_assignment] = STATE(10144),
    [sym_conditional] = STATE(10144),
    [sym_range] = STATE(10144),
    [sym_binary] = STATE(10144),
    [sym_unary] = STATE(10144),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9186] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10145),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10145),
    [sym_operator_assignment] = STATE(10145),
    [sym_conditional] = STATE(10145),
    [sym_range] = STATE(10145),
    [sym_binary] = STATE(10145),
    [sym_unary] = STATE(10145),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9187] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10146),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10146),
    [sym_operator_assignment] = STATE(10146),
    [sym_conditional] = STATE(10146),
    [sym_range] = STATE(10146),
    [sym_binary] = STATE(10146),
    [sym_unary] = STATE(10146),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9188] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10147),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10147),
    [sym_operator_assignment] = STATE(10147),
    [sym_conditional] = STATE(10147),
    [sym_range] = STATE(10147),
    [sym_binary] = STATE(10147),
    [sym_unary] = STATE(10147),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9189] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10148),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10148),
    [sym_operator_assignment] = STATE(10148),
    [sym_conditional] = STATE(10148),
    [sym_range] = STATE(10148),
    [sym_binary] = STATE(10148),
    [sym_unary] = STATE(10148),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9190] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10149),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10149),
    [sym_operator_assignment] = STATE(10149),
    [sym_conditional] = STATE(10149),
    [sym_range] = STATE(10149),
    [sym_binary] = STATE(10149),
    [sym_unary] = STATE(10149),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9191] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10150),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10150),
    [sym_operator_assignment] = STATE(10150),
    [sym_conditional] = STATE(10150),
    [sym_range] = STATE(10150),
    [sym_binary] = STATE(10150),
    [sym_unary] = STATE(10150),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9192] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10151),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_splat_argument] = STATE(10152),
    [sym_assignment] = STATE(10151),
    [sym_operator_assignment] = STATE(10151),
    [sym_conditional] = STATE(10151),
    [sym_range] = STATE(10151),
    [sym_binary] = STATE(10151),
    [sym_unary] = STATE(10151),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(10152),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9193] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10153),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10153),
    [sym_operator_assignment] = STATE(10153),
    [sym_conditional] = STATE(10153),
    [sym_range] = STATE(10153),
    [sym_binary] = STATE(10153),
    [sym_unary] = STATE(10153),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9194] = {
    [sym_string] = STATE(10154),
    [aux_sym_chained_string_repeat1] = STATE(10154),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [9195] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(12582),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [9196] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9197] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9198] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10155),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(10155),
    [sym_operator_assignment] = STATE(10155),
    [sym_conditional] = STATE(10155),
    [sym_range] = STATE(10155),
    [sym_binary] = STATE(10155),
    [sym_unary] = STATE(10155),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9199] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9200] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10156),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(10156),
    [sym_operator_assignment] = STATE(10156),
    [sym_conditional] = STATE(10156),
    [sym_range] = STATE(10156),
    [sym_binary] = STATE(10156),
    [sym_unary] = STATE(10156),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9201] = {
    [sym_heredoc_body] = STATE(10157),
    [aux_sym_call_repeat1] = STATE(10157),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9202] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7499),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(7499),
    [sym_operator_assignment] = STATE(7499),
    [sym_conditional] = STATE(7499),
    [sym_range] = STATE(7499),
    [sym_binary] = STATE(7499),
    [sym_unary] = STATE(7499),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7502),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10158),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10802),
    [sym__splat_star] = ACTIONS(10804),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__identifier_hash_key] = ACTIONS(10806),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13669),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(10808),
    [sym_identifier] = ACTIONS(10808),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9203] = {
    [sym_heredoc_body] = STATE(10159),
    [aux_sym_call_repeat1] = STATE(10159),
    [aux_sym_argument_list_repeat1] = STATE(10160),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(12608),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9204] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(12582),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [9205] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9206] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9207] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9208] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9209] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9210] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13671),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9211] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9212] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9213] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9214] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9215] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9216] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9217] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10162),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(10162),
    [sym_operator_assignment] = STATE(10162),
    [sym_conditional] = STATE(10162),
    [sym_range] = STATE(10162),
    [sym_binary] = STATE(10162),
    [sym_unary] = STATE(10162),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9218] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9219] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10163),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(10163),
    [sym_operator_assignment] = STATE(10163),
    [sym_conditional] = STATE(10163),
    [sym_range] = STATE(10163),
    [sym_binary] = STATE(10163),
    [sym_unary] = STATE(10163),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9220] = {
    [sym_heredoc_body] = STATE(10164),
    [aux_sym_call_repeat1] = STATE(10164),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [9221] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7520),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(7520),
    [sym_operator_assignment] = STATE(7520),
    [sym_conditional] = STATE(7520),
    [sym_range] = STATE(7520),
    [sym_binary] = STATE(7520),
    [sym_unary] = STATE(7520),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7523),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(10165),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10838),
    [sym__splat_star] = ACTIONS(10840),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__identifier_hash_key] = ACTIONS(10842),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13673),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(10844),
    [sym_identifier] = ACTIONS(10844),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9222] = {
    [sym_heredoc_body] = STATE(10166),
    [aux_sym_call_repeat1] = STATE(10166),
    [aux_sym_argument_list_repeat1] = STATE(10167),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(12616),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [9223] = {
    [sym_heredoc_body] = STATE(9223),
    [aux_sym_call_repeat1] = STATE(9223),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9224] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5120),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(7926),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__identifier_hash_key] = ACTIONS(7932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12620),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7950),
    [sym_identifier] = ACTIONS(7950),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9225] = {
    [sym_heredoc_body] = STATE(9223),
    [aux_sym_call_repeat1] = STATE(9223),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9226] = {
    [aux_sym_argument_list_repeat1] = STATE(9226),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13675),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9227] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9228] = {
    [aux_sym_exceptions_repeat1] = STATE(10169),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9229] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [9230] = {
    [sym_string] = STATE(9230),
    [aux_sym_chained_string_repeat1] = STATE(9230),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [9231] = {
    [aux_sym_undef_repeat1] = STATE(9231),
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9006),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_end] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [anon_sym_else] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [9232] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(2705),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2705),
    [sym_unless_modifier] = STATE(2705),
    [sym_while_modifier] = STATE(2705),
    [sym_until_modifier] = STATE(2705),
    [sym_rescue_modifier] = STATE(2705),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_undef] = STATE(2705),
    [sym_alias] = STATE(2705),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2705),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9233] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10170),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2710),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(2710),
    [sym_assignment] = STATE(10170),
    [sym_operator_assignment] = STATE(10170),
    [sym_conditional] = STATE(10170),
    [sym_range] = STATE(10170),
    [sym_binary] = STATE(10170),
    [sym_unary] = STATE(10170),
    [sym_left_assignment_list] = STATE(2709),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2710),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2710),
    [sym_false] = STATE(2710),
    [sym_nil] = STATE(2710),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2711),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4454),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_break] = ACTIONS(4458),
    [anon_sym_next] = ACTIONS(4460),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4462),
    [anon_sym_defined_QMARK] = ACTIONS(4464),
    [anon_sym_not] = ACTIONS(4466),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9234] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [9235] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12643),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [9236] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10171),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10171),
    [sym_operator_assignment] = STATE(10171),
    [sym_conditional] = STATE(10171),
    [sym_range] = STATE(10171),
    [sym_binary] = STATE(10171),
    [sym_unary] = STATE(10171),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9237] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10172),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10172),
    [sym_operator_assignment] = STATE(10172),
    [sym_conditional] = STATE(10172),
    [sym_range] = STATE(10172),
    [sym_binary] = STATE(10172),
    [sym_unary] = STATE(10172),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9238] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10173),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10173),
    [sym_operator_assignment] = STATE(10173),
    [sym_conditional] = STATE(10173),
    [sym_range] = STATE(10173),
    [sym_binary] = STATE(10173),
    [sym_unary] = STATE(10173),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9239] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10174),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10174),
    [sym_operator_assignment] = STATE(10174),
    [sym_conditional] = STATE(10174),
    [sym_range] = STATE(10174),
    [sym_binary] = STATE(10174),
    [sym_unary] = STATE(10174),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9240] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10175),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10175),
    [sym_operator_assignment] = STATE(10175),
    [sym_conditional] = STATE(10175),
    [sym_range] = STATE(10175),
    [sym_binary] = STATE(10175),
    [sym_unary] = STATE(10175),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9241] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10176),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10176),
    [sym_operator_assignment] = STATE(10176),
    [sym_conditional] = STATE(10176),
    [sym_range] = STATE(10176),
    [sym_binary] = STATE(10176),
    [sym_unary] = STATE(10176),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9242] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10177),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10177),
    [sym_operator_assignment] = STATE(10177),
    [sym_conditional] = STATE(10177),
    [sym_range] = STATE(10177),
    [sym_binary] = STATE(10177),
    [sym_unary] = STATE(10177),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9243] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10178),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10178),
    [sym_operator_assignment] = STATE(10178),
    [sym_conditional] = STATE(10178),
    [sym_range] = STATE(10178),
    [sym_binary] = STATE(10178),
    [sym_unary] = STATE(10178),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9244] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10179),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10179),
    [sym_operator_assignment] = STATE(10179),
    [sym_conditional] = STATE(10179),
    [sym_range] = STATE(10179),
    [sym_binary] = STATE(10179),
    [sym_unary] = STATE(10179),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9245] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10180),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10180),
    [sym_operator_assignment] = STATE(10180),
    [sym_conditional] = STATE(10180),
    [sym_range] = STATE(10180),
    [sym_binary] = STATE(10180),
    [sym_unary] = STATE(10180),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9246] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10181),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_splat_argument] = STATE(10182),
    [sym_assignment] = STATE(10181),
    [sym_operator_assignment] = STATE(10181),
    [sym_conditional] = STATE(10181),
    [sym_range] = STATE(10181),
    [sym_binary] = STATE(10181),
    [sym_unary] = STATE(10181),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(10182),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(8002),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9247] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10183),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10183),
    [sym_operator_assignment] = STATE(10183),
    [sym_conditional] = STATE(10183),
    [sym_range] = STATE(10183),
    [sym_binary] = STATE(10183),
    [sym_unary] = STATE(10183),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9248] = {
    [sym_string] = STATE(10184),
    [aux_sym_chained_string_repeat1] = STATE(10184),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [9249] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(12643),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [9250] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(12643),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [9251] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9252] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [9253] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9254] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9255] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9256] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13678),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9257] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9258] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9259] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9260] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9261] = {
    [sym_heredoc_body] = STATE(9261),
    [aux_sym_call_repeat1] = STATE(9261),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [9262] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5154),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(5154),
    [sym_operator_assignment] = STATE(5154),
    [sym_conditional] = STATE(5154),
    [sym_range] = STATE(5154),
    [sym_binary] = STATE(5154),
    [sym_unary] = STATE(5154),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5160),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8000),
    [sym__splat_star] = ACTIONS(8002),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__identifier_hash_key] = ACTIONS(8006),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12665),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8024),
    [sym_identifier] = ACTIONS(8024),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9263] = {
    [sym_heredoc_body] = STATE(9261),
    [aux_sym_call_repeat1] = STATE(9261),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [9264] = {
    [aux_sym_argument_list_repeat1] = STATE(9264),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13680),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [9265] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9266] = {
    [aux_sym_exceptions_repeat1] = STATE(10187),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [9267] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9268] = {
    [sym_string] = STATE(9268),
    [aux_sym_chained_string_repeat1] = STATE(9268),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [9269] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(12671),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(12673),
    [anon_sym_LT] = ACTIONS(12675),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(12677),
    [anon_sym_DOT_DOT] = ACTIONS(12679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12681),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(12683),
    [anon_sym_AMP_AMP] = ACTIONS(12683),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(12687),
    [anon_sym_BANG_EQ] = ACTIONS(12683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12683),
    [anon_sym_LT_EQ_GT] = ACTIONS(12683),
    [anon_sym_EQ_TILDE] = ACTIONS(12683),
    [anon_sym_BANG_TILDE] = ACTIONS(12683),
    [anon_sym_LT_EQ] = ACTIONS(12675),
    [anon_sym_GT] = ACTIONS(12675),
    [anon_sym_GT_EQ] = ACTIONS(12689),
    [anon_sym_CARET] = ACTIONS(12691),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [9270] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9271] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12671),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(12673),
    [anon_sym_LT] = ACTIONS(12675),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12677),
    [anon_sym_DOT_DOT] = ACTIONS(12679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12681),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12683),
    [anon_sym_AMP_AMP] = ACTIONS(12683),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(12687),
    [anon_sym_BANG_EQ] = ACTIONS(12683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12683),
    [anon_sym_LT_EQ_GT] = ACTIONS(12683),
    [anon_sym_EQ_TILDE] = ACTIONS(12683),
    [anon_sym_BANG_TILDE] = ACTIONS(12683),
    [anon_sym_LT_EQ] = ACTIONS(12675),
    [anon_sym_GT] = ACTIONS(12675),
    [anon_sym_GT_EQ] = ACTIONS(12689),
    [anon_sym_CARET] = ACTIONS(12691),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [9272] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10188),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10188),
    [sym_operator_assignment] = STATE(10188),
    [sym_conditional] = STATE(10188),
    [sym_range] = STATE(10188),
    [sym_binary] = STATE(10188),
    [sym_unary] = STATE(10188),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9273] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10189),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10189),
    [sym_operator_assignment] = STATE(10189),
    [sym_conditional] = STATE(10189),
    [sym_range] = STATE(10189),
    [sym_binary] = STATE(10189),
    [sym_unary] = STATE(10189),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9274] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10190),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10190),
    [sym_operator_assignment] = STATE(10190),
    [sym_conditional] = STATE(10190),
    [sym_range] = STATE(10190),
    [sym_binary] = STATE(10190),
    [sym_unary] = STATE(10190),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9275] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10191),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10191),
    [sym_operator_assignment] = STATE(10191),
    [sym_conditional] = STATE(10191),
    [sym_range] = STATE(10191),
    [sym_binary] = STATE(10191),
    [sym_unary] = STATE(10191),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9276] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10192),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10192),
    [sym_operator_assignment] = STATE(10192),
    [sym_conditional] = STATE(10192),
    [sym_range] = STATE(10192),
    [sym_binary] = STATE(10192),
    [sym_unary] = STATE(10192),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9277] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10193),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10193),
    [sym_operator_assignment] = STATE(10193),
    [sym_conditional] = STATE(10193),
    [sym_range] = STATE(10193),
    [sym_binary] = STATE(10193),
    [sym_unary] = STATE(10193),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9278] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10194),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10194),
    [sym_operator_assignment] = STATE(10194),
    [sym_conditional] = STATE(10194),
    [sym_range] = STATE(10194),
    [sym_binary] = STATE(10194),
    [sym_unary] = STATE(10194),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9279] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10195),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10195),
    [sym_operator_assignment] = STATE(10195),
    [sym_conditional] = STATE(10195),
    [sym_range] = STATE(10195),
    [sym_binary] = STATE(10195),
    [sym_unary] = STATE(10195),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9280] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10196),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10196),
    [sym_operator_assignment] = STATE(10196),
    [sym_conditional] = STATE(10196),
    [sym_range] = STATE(10196),
    [sym_binary] = STATE(10196),
    [sym_unary] = STATE(10196),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9281] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10197),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10197),
    [sym_operator_assignment] = STATE(10197),
    [sym_conditional] = STATE(10197),
    [sym_range] = STATE(10197),
    [sym_binary] = STATE(10197),
    [sym_unary] = STATE(10197),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9282] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7588),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(7588),
    [sym_operator_assignment] = STATE(7588),
    [sym_conditional] = STATE(7588),
    [sym_range] = STATE(7588),
    [sym_binary] = STATE(7588),
    [sym_unary] = STATE(7588),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(10930),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9283] = {
    [aux_sym_exceptions_repeat1] = STATE(10198),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(12693),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9284] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7588),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_splat_argument] = STATE(10199),
    [sym_assignment] = STATE(7588),
    [sym_operator_assignment] = STATE(7588),
    [sym_conditional] = STATE(7588),
    [sym_range] = STATE(7588),
    [sym_binary] = STATE(7588),
    [sym_unary] = STATE(7588),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(10199),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(10930),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9285] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10200),
    [sym_operator_assignment] = STATE(10200),
    [sym_conditional] = STATE(10200),
    [sym_range] = STATE(10200),
    [sym_binary] = STATE(10200),
    [sym_unary] = STATE(10200),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9286] = {
    [sym_heredoc_body] = STATE(9286),
    [aux_sym_call_repeat1] = STATE(9286),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9287] = {
    [sym_heredoc_body] = STATE(9286),
    [aux_sym_call_repeat1] = STATE(9286),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9288] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10201),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_assignment] = STATE(10201),
    [sym_operator_assignment] = STATE(10201),
    [sym_conditional] = STATE(10201),
    [sym_range] = STATE(10201),
    [sym_binary] = STATE(10201),
    [sym_unary] = STATE(10201),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9289] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7606),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2722),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2722),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(7606),
    [sym_operator_assignment] = STATE(7606),
    [sym_conditional] = STATE(7606),
    [sym_range] = STATE(7606),
    [sym_binary] = STATE(7606),
    [sym_unary] = STATE(7606),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(2721),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2722),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2722),
    [sym_false] = STATE(2722),
    [sym_nil] = STATE(2722),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1829),
    [sym__unary_minus] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9290] = {
    [aux_sym_exceptions_repeat1] = STATE(10202),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13683),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9291] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4510),
    [sym__binary_star] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4514),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(4518),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4530),
    [anon_sym_BANG_EQ] = ACTIONS(4526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4526),
    [anon_sym_LT_EQ_GT] = ACTIONS(4526),
    [anon_sym_EQ_TILDE] = ACTIONS(4526),
    [anon_sym_BANG_TILDE] = ACTIONS(4526),
    [anon_sym_LT_EQ] = ACTIONS(4518),
    [anon_sym_GT] = ACTIONS(4518),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [9292] = {
    [aux_sym_exceptions_repeat1] = STATE(9292),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13685),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9293] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10203),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_assignment] = STATE(10203),
    [sym_operator_assignment] = STATE(10203),
    [sym_conditional] = STATE(10203),
    [sym_range] = STATE(10203),
    [sym_binary] = STATE(10203),
    [sym_unary] = STATE(10203),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9294] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(7636),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(2788),
    [sym_scope_resolution] = STATE(2786),
    [sym_call] = STATE(2786),
    [sym_method_call] = STATE(2788),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(7636),
    [sym_operator_assignment] = STATE(7636),
    [sym_conditional] = STATE(7636),
    [sym_range] = STATE(7636),
    [sym_binary] = STATE(7636),
    [sym_unary] = STATE(7636),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(2787),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2788),
    [sym__variable] = STATE(2786),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(2788),
    [sym_false] = STATE(2788),
    [sym_nil] = STATE(2788),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(2789),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(1889),
    [sym__unary_minus] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(4560),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_break] = ACTIONS(4564),
    [anon_sym_next] = ACTIONS(4566),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_defined_QMARK] = ACTIONS(4570),
    [anon_sym_not] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4574),
    [sym_constant] = ACTIONS(4576),
    [sym_identifier] = ACTIONS(4576),
    [sym_instance_variable] = ACTIONS(4578),
    [sym_class_variable] = ACTIONS(4578),
    [sym_global_variable] = ACTIONS(4578),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(4576),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4576),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9295] = {
    [aux_sym_exceptions_repeat1] = STATE(10204),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13688),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9296] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4588),
    [sym__binary_star] = ACTIONS(4590),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(4594),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(4598),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_DOT_DOT] = ACTIONS(4602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4606),
    [anon_sym_AMP_AMP] = ACTIONS(4606),
    [anon_sym_LT_LT] = ACTIONS(4608),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_EQ_EQ] = ACTIONS(4606),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ_GT] = ACTIONS(4610),
    [anon_sym_EQ_TILDE] = ACTIONS(4610),
    [anon_sym_BANG_TILDE] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4598),
    [anon_sym_GT] = ACTIONS(4598),
    [anon_sym_GT_EQ] = ACTIONS(4612),
    [anon_sym_CARET] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_SLASH] = ACTIONS(4594),
    [anon_sym_PERCENT] = ACTIONS(4594),
    [sym_comment] = ACTIONS(87),
  },
  [9297] = {
    [aux_sym_exceptions_repeat1] = STATE(9297),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13690),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [9298] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10205),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2821),
    [sym_scope_resolution] = STATE(248),
    [sym_call] = STATE(248),
    [sym_method_call] = STATE(2821),
    [sym_assignment] = STATE(10205),
    [sym_operator_assignment] = STATE(10205),
    [sym_conditional] = STATE(10205),
    [sym_range] = STATE(10205),
    [sym_binary] = STATE(10205),
    [sym_unary] = STATE(10205),
    [sym_left_assignment_list] = STATE(2820),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2821),
    [sym__variable] = STATE(248),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2821),
    [sym_false] = STATE(2821),
    [sym_nil] = STATE(2821),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2723),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_defined_QMARK] = ACTIONS(4632),
    [anon_sym_not] = ACTIONS(4634),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9299] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [9300] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [9301] = {
    [sym_heredoc_body] = STATE(9301),
    [aux_sym_call_repeat1] = STATE(9301),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_in] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9302] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(5279),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(1088),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(1088),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(5279),
    [sym_operator_assignment] = STATE(5279),
    [sym_conditional] = STATE(5279),
    [sym_range] = STATE(5279),
    [sym_binary] = STATE(5279),
    [sym_unary] = STATE(5279),
    [sym_left_assignment_list] = STATE(1087),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1088),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(1088),
    [sym_false] = STATE(1088),
    [sym_nil] = STATE(1088),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(5282),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(8172),
    [sym__splat_star] = ACTIONS(8174),
    [sym__unary_minus] = ACTIONS(1941),
    [sym__identifier_hash_key] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12720),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_next] = ACTIONS(1953),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1955),
    [anon_sym_defined_QMARK] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_TILDE] = ACTIONS(1961),
    [sym_constant] = ACTIONS(8178),
    [sym_identifier] = ACTIONS(8178),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9303] = {
    [sym_heredoc_body] = STATE(9301),
    [aux_sym_call_repeat1] = STATE(9301),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_in] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9304] = {
    [aux_sym_argument_list_repeat1] = STATE(9304),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13693),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_in] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9305] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10206),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_assignment] = STATE(10206),
    [sym_operator_assignment] = STATE(10206),
    [sym_conditional] = STATE(10206),
    [sym_range] = STATE(10206),
    [sym_binary] = STATE(10206),
    [sym_unary] = STATE(10206),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9306] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [9307] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12736),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [9308] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10207),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10207),
    [sym_operator_assignment] = STATE(10207),
    [sym_conditional] = STATE(10207),
    [sym_range] = STATE(10207),
    [sym_binary] = STATE(10207),
    [sym_unary] = STATE(10207),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9309] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10208),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10208),
    [sym_operator_assignment] = STATE(10208),
    [sym_conditional] = STATE(10208),
    [sym_range] = STATE(10208),
    [sym_binary] = STATE(10208),
    [sym_unary] = STATE(10208),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9310] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10209),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10209),
    [sym_operator_assignment] = STATE(10209),
    [sym_conditional] = STATE(10209),
    [sym_range] = STATE(10209),
    [sym_binary] = STATE(10209),
    [sym_unary] = STATE(10209),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9311] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10210),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10210),
    [sym_operator_assignment] = STATE(10210),
    [sym_conditional] = STATE(10210),
    [sym_range] = STATE(10210),
    [sym_binary] = STATE(10210),
    [sym_unary] = STATE(10210),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9312] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10211),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10211),
    [sym_operator_assignment] = STATE(10211),
    [sym_conditional] = STATE(10211),
    [sym_range] = STATE(10211),
    [sym_binary] = STATE(10211),
    [sym_unary] = STATE(10211),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9313] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10212),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10212),
    [sym_operator_assignment] = STATE(10212),
    [sym_conditional] = STATE(10212),
    [sym_range] = STATE(10212),
    [sym_binary] = STATE(10212),
    [sym_unary] = STATE(10212),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9314] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10213),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10213),
    [sym_operator_assignment] = STATE(10213),
    [sym_conditional] = STATE(10213),
    [sym_range] = STATE(10213),
    [sym_binary] = STATE(10213),
    [sym_unary] = STATE(10213),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9315] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10214),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10214),
    [sym_operator_assignment] = STATE(10214),
    [sym_conditional] = STATE(10214),
    [sym_range] = STATE(10214),
    [sym_binary] = STATE(10214),
    [sym_unary] = STATE(10214),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9316] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10215),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10215),
    [sym_operator_assignment] = STATE(10215),
    [sym_conditional] = STATE(10215),
    [sym_range] = STATE(10215),
    [sym_binary] = STATE(10215),
    [sym_unary] = STATE(10215),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9317] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10216),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10216),
    [sym_operator_assignment] = STATE(10216),
    [sym_conditional] = STATE(10216),
    [sym_range] = STATE(10216),
    [sym_binary] = STATE(10216),
    [sym_unary] = STATE(10216),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9318] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10217),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_splat_argument] = STATE(10218),
    [sym_assignment] = STATE(10217),
    [sym_operator_assignment] = STATE(10217),
    [sym_conditional] = STATE(10217),
    [sym_range] = STATE(10217),
    [sym_binary] = STATE(10217),
    [sym_unary] = STATE(10217),
    [sym_right_assignment_list] = STATE(8647),
    [sym__arg_or_splat_arg] = STATE(10218),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(8210),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9319] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10219),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10219),
    [sym_operator_assignment] = STATE(10219),
    [sym_conditional] = STATE(10219),
    [sym_range] = STATE(10219),
    [sym_binary] = STATE(10219),
    [sym_unary] = STATE(10219),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9320] = {
    [sym_string] = STATE(10220),
    [aux_sym_chained_string_repeat1] = STATE(10220),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_in] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [9321] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(12736),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [9322] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(12736),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [9323] = {
    [sym_heredoc_body] = STATE(9323),
    [aux_sym_call_repeat1] = STATE(9323),
    [sym__heredoc_body_start] = ACTIONS(12063),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_in] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [9324] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(5299),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5302),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(8208),
    [sym__splat_star] = ACTIONS(8210),
    [sym__unary_minus] = ACTIONS(4708),
    [sym__identifier_hash_key] = ACTIONS(8212),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12758),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(8214),
    [sym_identifier] = ACTIONS(8214),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9325] = {
    [sym_heredoc_body] = STATE(9323),
    [aux_sym_call_repeat1] = STATE(9323),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_in] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [9326] = {
    [aux_sym_argument_list_repeat1] = STATE(9326),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13696),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_in] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [9327] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(7692),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(2836),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(2836),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(7692),
    [sym_operator_assignment] = STATE(7692),
    [sym_conditional] = STATE(7692),
    [sym_range] = STATE(7692),
    [sym_binary] = STATE(7692),
    [sym_unary] = STATE(7692),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(2835),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2836),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(2836),
    [sym_false] = STATE(2836),
    [sym_nil] = STATE(2836),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2837),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(8174),
    [sym__unary_minus] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4644),
    [anon_sym_break] = ACTIONS(4646),
    [anon_sym_next] = ACTIONS(4648),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4650),
    [anon_sym_defined_QMARK] = ACTIONS(4652),
    [anon_sym_not] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_TILDE] = ACTIONS(4656),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9328] = {
    [aux_sym_exceptions_repeat1] = STATE(10221),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13699),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_in] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9329] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4676),
    [sym__binary_star] = ACTIONS(4678),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4680),
    [anon_sym_STAR_STAR] = ACTIONS(4678),
    [anon_sym_AMP] = ACTIONS(4682),
    [anon_sym_LT] = ACTIONS(4684),
    [anon_sym_in] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4686),
    [anon_sym_DOT_DOT] = ACTIONS(4688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4694),
    [anon_sym_AMP_AMP] = ACTIONS(4694),
    [anon_sym_LT_LT] = ACTIONS(4696),
    [anon_sym_GT_GT] = ACTIONS(4696),
    [anon_sym_EQ_EQ] = ACTIONS(4698),
    [anon_sym_BANG_EQ] = ACTIONS(4694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4694),
    [anon_sym_LT_EQ_GT] = ACTIONS(4694),
    [anon_sym_EQ_TILDE] = ACTIONS(4694),
    [anon_sym_BANG_TILDE] = ACTIONS(4694),
    [anon_sym_LT_EQ] = ACTIONS(4684),
    [anon_sym_GT] = ACTIONS(4684),
    [anon_sym_GT_EQ] = ACTIONS(4700),
    [anon_sym_CARET] = ACTIONS(4702),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4678),
    [anon_sym_PERCENT] = ACTIONS(4678),
    [sym_comment] = ACTIONS(87),
  },
  [9330] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10222),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_assignment] = STATE(10222),
    [sym_operator_assignment] = STATE(10222),
    [sym_conditional] = STATE(10222),
    [sym_range] = STATE(10222),
    [sym_binary] = STATE(10222),
    [sym_unary] = STATE(10222),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9331] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(7719),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(2880),
    [sym_scope_resolution] = STATE(1084),
    [sym_call] = STATE(1084),
    [sym_method_call] = STATE(2880),
    [sym_splat_argument] = STATE(8821),
    [sym_assignment] = STATE(7719),
    [sym_operator_assignment] = STATE(7719),
    [sym_conditional] = STATE(7719),
    [sym_range] = STATE(7719),
    [sym_binary] = STATE(7719),
    [sym_unary] = STATE(7719),
    [sym__arg_or_splat_arg] = STATE(8821),
    [sym_left_assignment_list] = STATE(2879),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2880),
    [sym__variable] = STATE(1084),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(2880),
    [sym_false] = STATE(2880),
    [sym_nil] = STATE(2880),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(5327),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(4706),
    [sym__unary_minus] = ACTIONS(4708),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_break] = ACTIONS(4716),
    [anon_sym_next] = ACTIONS(4718),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(8230),
    [anon_sym_defined_QMARK] = ACTIONS(4720),
    [anon_sym_not] = ACTIONS(4722),
    [anon_sym_BANG] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4726),
    [sym_constant] = ACTIONS(1967),
    [sym_identifier] = ACTIONS(1967),
    [sym_instance_variable] = ACTIONS(1965),
    [sym_class_variable] = ACTIONS(1965),
    [sym_global_variable] = ACTIONS(1965),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(1967),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1967),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9332] = {
    [aux_sym_exceptions_repeat1] = STATE(10223),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13701),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_in] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9333] = {
    [aux_sym_exceptions_repeat1] = STATE(9333),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13703),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9334] = {
    [sym_heredoc_body] = STATE(9334),
    [aux_sym_call_repeat1] = STATE(9334),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9335] = {
    [sym_heredoc_body] = STATE(9334),
    [aux_sym_call_repeat1] = STATE(9334),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9336] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10224),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_assignment] = STATE(10224),
    [sym_operator_assignment] = STATE(10224),
    [sym_conditional] = STATE(10224),
    [sym_range] = STATE(10224),
    [sym_binary] = STATE(10224),
    [sym_unary] = STATE(10224),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9337] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7738),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2899),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2899),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(7738),
    [sym_operator_assignment] = STATE(7738),
    [sym_conditional] = STATE(7738),
    [sym_range] = STATE(7738),
    [sym_binary] = STATE(7738),
    [sym_unary] = STATE(7738),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(2898),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2899),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2899),
    [sym_false] = STATE(2899),
    [sym_nil] = STATE(2899),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(1975),
    [sym__unary_minus] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4754),
    [anon_sym_defined_QMARK] = ACTIONS(4756),
    [anon_sym_not] = ACTIONS(4758),
    [anon_sym_BANG] = ACTIONS(4760),
    [anon_sym_TILDE] = ACTIONS(4760),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9338] = {
    [aux_sym_exceptions_repeat1] = STATE(10225),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13706),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9339] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4776),
    [sym__binary_star] = ACTIONS(4778),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4780),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(4778),
    [anon_sym_AMP] = ACTIONS(4782),
    [anon_sym_LT] = ACTIONS(4784),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4786),
    [anon_sym_DOT_DOT] = ACTIONS(4788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4790),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4792),
    [anon_sym_AMP_AMP] = ACTIONS(4792),
    [anon_sym_LT_LT] = ACTIONS(4794),
    [anon_sym_GT_GT] = ACTIONS(4794),
    [anon_sym_EQ_EQ] = ACTIONS(4796),
    [anon_sym_BANG_EQ] = ACTIONS(4792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4792),
    [anon_sym_LT_EQ_GT] = ACTIONS(4792),
    [anon_sym_EQ_TILDE] = ACTIONS(4792),
    [anon_sym_BANG_TILDE] = ACTIONS(4792),
    [anon_sym_LT_EQ] = ACTIONS(4784),
    [anon_sym_GT] = ACTIONS(4784),
    [anon_sym_GT_EQ] = ACTIONS(4798),
    [anon_sym_CARET] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4776),
    [anon_sym_SLASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [9340] = {
    [aux_sym_exceptions_repeat1] = STATE(9340),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13708),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9341] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10226),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2952),
    [sym_scope_resolution] = STATE(267),
    [sym_call] = STATE(267),
    [sym_method_call] = STATE(2952),
    [sym_assignment] = STATE(10226),
    [sym_operator_assignment] = STATE(10226),
    [sym_conditional] = STATE(10226),
    [sym_range] = STATE(10226),
    [sym_binary] = STATE(10226),
    [sym_unary] = STATE(10226),
    [sym_left_assignment_list] = STATE(2951),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2952),
    [sym__variable] = STATE(267),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2952),
    [sym_false] = STATE(2952),
    [sym_nil] = STATE(2952),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2900),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4748),
    [anon_sym_break] = ACTIONS(4750),
    [anon_sym_next] = ACTIONS(4752),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_defined_QMARK] = ACTIONS(4820),
    [anon_sym_not] = ACTIONS(4822),
    [anon_sym_BANG] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9342] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9343] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12800),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [9344] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10227),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10227),
    [sym_operator_assignment] = STATE(10227),
    [sym_conditional] = STATE(10227),
    [sym_range] = STATE(10227),
    [sym_binary] = STATE(10227),
    [sym_unary] = STATE(10227),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9345] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10228),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10228),
    [sym_operator_assignment] = STATE(10228),
    [sym_conditional] = STATE(10228),
    [sym_range] = STATE(10228),
    [sym_binary] = STATE(10228),
    [sym_unary] = STATE(10228),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9346] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10229),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10229),
    [sym_operator_assignment] = STATE(10229),
    [sym_conditional] = STATE(10229),
    [sym_range] = STATE(10229),
    [sym_binary] = STATE(10229),
    [sym_unary] = STATE(10229),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9347] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10230),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10230),
    [sym_operator_assignment] = STATE(10230),
    [sym_conditional] = STATE(10230),
    [sym_range] = STATE(10230),
    [sym_binary] = STATE(10230),
    [sym_unary] = STATE(10230),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9348] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10231),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10231),
    [sym_operator_assignment] = STATE(10231),
    [sym_conditional] = STATE(10231),
    [sym_range] = STATE(10231),
    [sym_binary] = STATE(10231),
    [sym_unary] = STATE(10231),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9349] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10232),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10232),
    [sym_operator_assignment] = STATE(10232),
    [sym_conditional] = STATE(10232),
    [sym_range] = STATE(10232),
    [sym_binary] = STATE(10232),
    [sym_unary] = STATE(10232),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9350] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10233),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10233),
    [sym_operator_assignment] = STATE(10233),
    [sym_conditional] = STATE(10233),
    [sym_range] = STATE(10233),
    [sym_binary] = STATE(10233),
    [sym_unary] = STATE(10233),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9351] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10234),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10234),
    [sym_operator_assignment] = STATE(10234),
    [sym_conditional] = STATE(10234),
    [sym_range] = STATE(10234),
    [sym_binary] = STATE(10234),
    [sym_unary] = STATE(10234),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9352] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10235),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10235),
    [sym_operator_assignment] = STATE(10235),
    [sym_conditional] = STATE(10235),
    [sym_range] = STATE(10235),
    [sym_binary] = STATE(10235),
    [sym_unary] = STATE(10235),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9353] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10236),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10236),
    [sym_operator_assignment] = STATE(10236),
    [sym_conditional] = STATE(10236),
    [sym_range] = STATE(10236),
    [sym_binary] = STATE(10236),
    [sym_unary] = STATE(10236),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9354] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10237),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_splat_argument] = STATE(10238),
    [sym_assignment] = STATE(10237),
    [sym_operator_assignment] = STATE(10237),
    [sym_conditional] = STATE(10237),
    [sym_range] = STATE(10237),
    [sym_binary] = STATE(10237),
    [sym_unary] = STATE(10237),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(10238),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8360),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9355] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10239),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10239),
    [sym_operator_assignment] = STATE(10239),
    [sym_conditional] = STATE(10239),
    [sym_range] = STATE(10239),
    [sym_binary] = STATE(10239),
    [sym_unary] = STATE(10239),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9356] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(12800),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [9357] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(12800),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [9358] = {
    [sym_heredoc_body] = STATE(9358),
    [aux_sym_call_repeat1] = STATE(9358),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9359] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5432),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(5432),
    [sym_operator_assignment] = STATE(5432),
    [sym_conditional] = STATE(5432),
    [sym_range] = STATE(5432),
    [sym_binary] = STATE(5432),
    [sym_unary] = STATE(5432),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5435),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8358),
    [sym__splat_star] = ACTIONS(8360),
    [sym__unary_minus] = ACTIONS(4938),
    [sym__identifier_hash_key] = ACTIONS(8362),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12822),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(8364),
    [sym_identifier] = ACTIONS(8364),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9360] = {
    [sym_heredoc_body] = STATE(9358),
    [aux_sym_call_repeat1] = STATE(9358),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9361] = {
    [aux_sym_argument_list_repeat1] = STATE(9361),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13711),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9362] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9363] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10247),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10247),
    [sym_operator_assignment] = STATE(10247),
    [sym_conditional] = STATE(10247),
    [sym_range] = STATE(10247),
    [sym_binary] = STATE(10247),
    [sym_unary] = STATE(10247),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9364] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10251),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10251),
    [sym_operator_assignment] = STATE(10251),
    [sym_conditional] = STATE(10251),
    [sym_range] = STATE(10251),
    [sym_binary] = STATE(10251),
    [sym_unary] = STATE(10251),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9365] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10252),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10252),
    [sym_operator_assignment] = STATE(10252),
    [sym_conditional] = STATE(10252),
    [sym_range] = STATE(10252),
    [sym_binary] = STATE(10252),
    [sym_unary] = STATE(10252),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9366] = {
    [anon_sym_COLON] = ACTIONS(13734),
    [sym_comment] = ACTIONS(87),
  },
  [9367] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10255),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10255),
    [sym_operator_assignment] = STATE(10255),
    [sym_conditional] = STATE(10255),
    [sym_range] = STATE(10255),
    [sym_binary] = STATE(10255),
    [sym_unary] = STATE(10255),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9368] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10261),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(10262),
    [sym__argument] = STATE(10263),
    [sym_splat_argument] = STATE(10263),
    [sym_hash_splat_argument] = STATE(10263),
    [sym_block_argument] = STATE(10263),
    [sym_assignment] = STATE(10261),
    [sym_operator_assignment] = STATE(10261),
    [sym_conditional] = STATE(10261),
    [sym_range] = STATE(10261),
    [sym_binary] = STATE(10261),
    [sym_unary] = STATE(10261),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10264),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10263),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13736),
    [sym__splat_star] = ACTIONS(13738),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(13740),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(13742),
    [sym_identifier] = ACTIONS(13742),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9369] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10261),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(10262),
    [sym__argument] = STATE(10263),
    [sym_splat_argument] = STATE(10263),
    [sym_hash_splat_argument] = STATE(10263),
    [sym_block_argument] = STATE(10263),
    [sym_assignment] = STATE(10261),
    [sym_operator_assignment] = STATE(10261),
    [sym_conditional] = STATE(10261),
    [sym_range] = STATE(10261),
    [sym_binary] = STATE(10261),
    [sym_unary] = STATE(10261),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10264),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10263),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13736),
    [sym__splat_star] = ACTIONS(13738),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(13740),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(13742),
    [sym_identifier] = ACTIONS(13742),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9370] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10261),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(10262),
    [sym__argument] = STATE(10263),
    [sym_splat_argument] = STATE(10263),
    [sym_hash_splat_argument] = STATE(10263),
    [sym_block_argument] = STATE(10263),
    [sym_assignment] = STATE(10261),
    [sym_operator_assignment] = STATE(10261),
    [sym_conditional] = STATE(10261),
    [sym_range] = STATE(10261),
    [sym_binary] = STATE(10261),
    [sym_unary] = STATE(10261),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10264),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10263),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13736),
    [sym__splat_star] = ACTIONS(13738),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(13740),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(13742),
    [sym_identifier] = ACTIONS(13742),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9371] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10261),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(10262),
    [sym__argument] = STATE(10263),
    [sym_splat_argument] = STATE(10263),
    [sym_hash_splat_argument] = STATE(10263),
    [sym_block_argument] = STATE(10263),
    [sym_assignment] = STATE(10261),
    [sym_operator_assignment] = STATE(10261),
    [sym_conditional] = STATE(10261),
    [sym_range] = STATE(10261),
    [sym_binary] = STATE(10261),
    [sym_unary] = STATE(10261),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10264),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10263),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13736),
    [sym__splat_star] = ACTIONS(13738),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(13740),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(13742),
    [sym_identifier] = ACTIONS(13742),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9372] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10265),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10265),
    [sym_operator_assignment] = STATE(10265),
    [sym_conditional] = STATE(10265),
    [sym_range] = STATE(10265),
    [sym_binary] = STATE(10265),
    [sym_unary] = STATE(10265),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9373] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9374] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(13744),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [9375] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_when] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(13734),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [9376] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(938),
    [sym__argument_list_with_parens] = STATE(10283),
    [sym__argument] = STATE(10284),
    [sym_splat_argument] = STATE(10284),
    [sym_hash_splat_argument] = STATE(10284),
    [sym_block_argument] = STATE(10284),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10285),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(10284),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(13772),
    [sym__splat_star] = ACTIONS(13774),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(13776),
    [anon_sym_LBRACE] = ACTIONS(1671),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(1673),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(13778),
    [sym_identifier] = ACTIONS(13778),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9377] = {
    [sym_heredoc_body] = STATE(10286),
    [aux_sym_call_repeat1] = STATE(10286),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_when] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [9378] = {
    [sym_heredoc_body] = STATE(10286),
    [aux_sym_call_repeat1] = STATE(10286),
    [aux_sym_argument_list_repeat1] = STATE(10288),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(13780),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_when] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [9379] = {
    [anon_sym_EQ] = ACTIONS(13782),
    [sym_comment] = ACTIONS(87),
  },
  [9380] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13784),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13786),
    [anon_sym_DASH_EQ] = ACTIONS(13786),
    [anon_sym_STAR_EQ] = ACTIONS(13786),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13786),
    [anon_sym_SLASH_EQ] = ACTIONS(13786),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13786),
    [anon_sym_PIPE_EQ] = ACTIONS(13786),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13786),
    [anon_sym_AMP_EQ] = ACTIONS(13786),
    [anon_sym_PERCENT_EQ] = ACTIONS(13786),
    [anon_sym_GT_GT_EQ] = ACTIONS(13786),
    [anon_sym_LT_LT_EQ] = ACTIONS(13786),
    [anon_sym_CARET_EQ] = ACTIONS(13786),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9381] = {
    [sym_string] = STATE(10291),
    [aux_sym_chained_string_repeat1] = STATE(10291),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(13788),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [9382] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [9383] = {
    [aux_sym_undef_repeat1] = STATE(10292),
    [sym__line_break] = ACTIONS(2257),
    [sym__heredoc_body_start] = ACTIONS(2257),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym_end] = ACTIONS(2257),
    [anon_sym_if] = ACTIONS(2257),
    [anon_sym_unless] = ACTIONS(2257),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_until] = ACTIONS(2257),
    [anon_sym_rescue] = ACTIONS(2257),
    [anon_sym_when] = ACTIONS(2257),
    [anon_sym_else] = ACTIONS(2257),
    [sym_comment] = ACTIONS(87),
  },
  [9384] = {
    [anon_sym_end] = ACTIONS(13790),
    [sym_comment] = ACTIONS(87),
  },
  [9385] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(7790),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(7790),
    [sym_unless_modifier] = STATE(7790),
    [sym_while_modifier] = STATE(7790),
    [sym_until_modifier] = STATE(7790),
    [sym_rescue_modifier] = STATE(7790),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7792),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(7792),
    [sym_operator_assignment] = STATE(7792),
    [sym_conditional] = STATE(7792),
    [sym_range] = STATE(7792),
    [sym_binary] = STATE(7792),
    [sym_unary] = STATE(7792),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_undef] = STATE(7790),
    [sym_alias] = STATE(7790),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(7790),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2499),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(2499),
    [anon_sym_else] = ACTIONS(2499),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [anon_sym_undef] = ACTIONS(11070),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9386] = {
    [sym_heredoc_body] = STATE(10293),
    [sym__terminator] = STATE(10293),
    [aux_sym__statements_repeat1] = STATE(10294),
    [sym__line_break] = ACTIONS(13792),
    [sym__heredoc_body_start] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(13792),
    [anon_sym_end] = ACTIONS(2497),
    [anon_sym_when] = ACTIONS(2497),
    [anon_sym_else] = ACTIONS(2497),
    [sym_comment] = ACTIONS(87),
  },
  [9387] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10295),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10295),
    [sym_operator_assignment] = STATE(10295),
    [sym_conditional] = STATE(10295),
    [sym_range] = STATE(10295),
    [sym_binary] = STATE(10295),
    [sym_unary] = STATE(10295),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9388] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10296),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10296),
    [sym_operator_assignment] = STATE(10296),
    [sym_conditional] = STATE(10296),
    [sym_range] = STATE(10296),
    [sym_binary] = STATE(10296),
    [sym_unary] = STATE(10296),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9389] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10297),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10297),
    [sym_operator_assignment] = STATE(10297),
    [sym_conditional] = STATE(10297),
    [sym_range] = STATE(10297),
    [sym_binary] = STATE(10297),
    [sym_unary] = STATE(10297),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9390] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10298),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10298),
    [sym_operator_assignment] = STATE(10298),
    [sym_conditional] = STATE(10298),
    [sym_range] = STATE(10298),
    [sym_binary] = STATE(10298),
    [sym_unary] = STATE(10298),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9391] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10299),
    [sym_operator_assignment] = STATE(10299),
    [sym_conditional] = STATE(10299),
    [sym_range] = STATE(10299),
    [sym_binary] = STATE(10299),
    [sym_unary] = STATE(10299),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9392] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10300),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10300),
    [sym_operator_assignment] = STATE(10300),
    [sym_conditional] = STATE(10300),
    [sym_range] = STATE(10300),
    [sym_binary] = STATE(10300),
    [sym_unary] = STATE(10300),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9393] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10301),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10301),
    [sym_operator_assignment] = STATE(10301),
    [sym_conditional] = STATE(10301),
    [sym_range] = STATE(10301),
    [sym_binary] = STATE(10301),
    [sym_unary] = STATE(10301),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9394] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10302),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10302),
    [sym_operator_assignment] = STATE(10302),
    [sym_conditional] = STATE(10302),
    [sym_range] = STATE(10302),
    [sym_binary] = STATE(10302),
    [sym_unary] = STATE(10302),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9395] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10303),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10303),
    [sym_operator_assignment] = STATE(10303),
    [sym_conditional] = STATE(10303),
    [sym_range] = STATE(10303),
    [sym_binary] = STATE(10303),
    [sym_unary] = STATE(10303),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9396] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10304),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10304),
    [sym_operator_assignment] = STATE(10304),
    [sym_conditional] = STATE(10304),
    [sym_range] = STATE(10304),
    [sym_binary] = STATE(10304),
    [sym_unary] = STATE(10304),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9397] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10305),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10305),
    [sym_operator_assignment] = STATE(10305),
    [sym_conditional] = STATE(10305),
    [sym_range] = STATE(10305),
    [sym_binary] = STATE(10305),
    [sym_unary] = STATE(10305),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9398] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10306),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10306),
    [sym_operator_assignment] = STATE(10306),
    [sym_conditional] = STATE(10306),
    [sym_range] = STATE(10306),
    [sym_binary] = STATE(10306),
    [sym_unary] = STATE(10306),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9399] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10307),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10307),
    [sym_operator_assignment] = STATE(10307),
    [sym_conditional] = STATE(10307),
    [sym_range] = STATE(10307),
    [sym_binary] = STATE(10307),
    [sym_unary] = STATE(10307),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9400] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10308),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10308),
    [sym_operator_assignment] = STATE(10308),
    [sym_conditional] = STATE(10308),
    [sym_range] = STATE(10308),
    [sym_binary] = STATE(10308),
    [sym_unary] = STATE(10308),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9401] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10309),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10309),
    [sym_operator_assignment] = STATE(10309),
    [sym_conditional] = STATE(10309),
    [sym_range] = STATE(10309),
    [sym_binary] = STATE(10309),
    [sym_unary] = STATE(10309),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9402] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10317),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10317),
    [sym_operator_assignment] = STATE(10317),
    [sym_conditional] = STATE(10317),
    [sym_range] = STATE(10317),
    [sym_binary] = STATE(10317),
    [sym_unary] = STATE(10317),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9403] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10322),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10322),
    [sym_operator_assignment] = STATE(10322),
    [sym_conditional] = STATE(10322),
    [sym_range] = STATE(10322),
    [sym_binary] = STATE(10322),
    [sym_unary] = STATE(10322),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9404] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10323),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10323),
    [sym_operator_assignment] = STATE(10323),
    [sym_conditional] = STATE(10323),
    [sym_range] = STATE(10323),
    [sym_binary] = STATE(10323),
    [sym_unary] = STATE(10323),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9405] = {
    [anon_sym_COLON] = ACTIONS(13818),
    [sym_comment] = ACTIONS(87),
  },
  [9406] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10326),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10326),
    [sym_operator_assignment] = STATE(10326),
    [sym_conditional] = STATE(10326),
    [sym_range] = STATE(10326),
    [sym_binary] = STATE(10326),
    [sym_unary] = STATE(10326),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9407] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(1533),
    [sym__argument_list_with_parens] = STATE(10283),
    [sym__argument] = STATE(10284),
    [sym_splat_argument] = STATE(10284),
    [sym_hash_splat_argument] = STATE(10284),
    [sym_block_argument] = STATE(10284),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10285),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(10284),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(13772),
    [sym__splat_star] = ACTIONS(13774),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(13776),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(13778),
    [sym_identifier] = ACTIONS(13778),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9408] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(1534),
    [sym__argument_list_with_parens] = STATE(10283),
    [sym__argument] = STATE(10284),
    [sym_splat_argument] = STATE(10284),
    [sym_hash_splat_argument] = STATE(10284),
    [sym_block_argument] = STATE(10284),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10285),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(10284),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(13772),
    [sym__splat_star] = ACTIONS(13774),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(13776),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(13778),
    [sym_identifier] = ACTIONS(13778),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9409] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(1535),
    [sym__argument_list_with_parens] = STATE(10283),
    [sym__argument] = STATE(10284),
    [sym_splat_argument] = STATE(10284),
    [sym_hash_splat_argument] = STATE(10284),
    [sym_block_argument] = STATE(10284),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10285),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(10284),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(13772),
    [sym__splat_star] = ACTIONS(13774),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(13776),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(13778),
    [sym_identifier] = ACTIONS(13778),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9410] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(1536),
    [sym__argument_list_with_parens] = STATE(10283),
    [sym__argument] = STATE(10284),
    [sym_splat_argument] = STATE(10284),
    [sym_hash_splat_argument] = STATE(10284),
    [sym_block_argument] = STATE(10284),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10285),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(10284),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(13772),
    [sym__splat_star] = ACTIONS(13774),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(13776),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(13778),
    [sym_identifier] = ACTIONS(13778),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9411] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10327),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10327),
    [sym_operator_assignment] = STATE(10327),
    [sym_conditional] = STATE(10327),
    [sym_range] = STATE(10327),
    [sym_binary] = STATE(10327),
    [sym_unary] = STATE(10327),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9412] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(1558),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(1558),
    [sym_operator_assignment] = STATE(1558),
    [sym_conditional] = STATE(1558),
    [sym_range] = STATE(1558),
    [sym_binary] = STATE(1558),
    [sym_unary] = STATE(1558),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9413] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(13820),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [9414] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_when] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(13818),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [9415] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(1578),
    [sym__argument_list_with_parens] = STATE(10283),
    [sym__argument] = STATE(10284),
    [sym_splat_argument] = STATE(10284),
    [sym_hash_splat_argument] = STATE(10284),
    [sym_block_argument] = STATE(10284),
    [sym_do_block] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10285),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(10284),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(13772),
    [sym__splat_star] = ACTIONS(13774),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(13776),
    [anon_sym_LBRACE] = ACTIONS(2723),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(13778),
    [sym_identifier] = ACTIONS(13778),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9416] = {
    [sym_heredoc_body] = STATE(10339),
    [aux_sym_call_repeat1] = STATE(10339),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_when] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [9417] = {
    [sym_heredoc_body] = STATE(10339),
    [aux_sym_call_repeat1] = STATE(10339),
    [aux_sym_argument_list_repeat1] = STATE(10341),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(13850),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_when] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [9418] = {
    [anon_sym_EQ] = ACTIONS(13852),
    [sym_comment] = ACTIONS(87),
  },
  [9419] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13854),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13856),
    [anon_sym_DASH_EQ] = ACTIONS(13856),
    [anon_sym_STAR_EQ] = ACTIONS(13856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13856),
    [anon_sym_SLASH_EQ] = ACTIONS(13856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13856),
    [anon_sym_PIPE_EQ] = ACTIONS(13856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13856),
    [anon_sym_AMP_EQ] = ACTIONS(13856),
    [anon_sym_PERCENT_EQ] = ACTIONS(13856),
    [anon_sym_GT_GT_EQ] = ACTIONS(13856),
    [anon_sym_LT_LT_EQ] = ACTIONS(13856),
    [anon_sym_CARET_EQ] = ACTIONS(13856),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9420] = {
    [sym_string] = STATE(10344),
    [aux_sym_chained_string_repeat1] = STATE(10344),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(13858),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9421] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10349),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_splat_argument] = STATE(10350),
    [sym_assignment] = STATE(10349),
    [sym_operator_assignment] = STATE(10349),
    [sym_conditional] = STATE(10349),
    [sym_range] = STATE(10349),
    [sym_binary] = STATE(10349),
    [sym_unary] = STATE(10349),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(10350),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(13860),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9422] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10353),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10353),
    [sym_operator_assignment] = STATE(10353),
    [sym_conditional] = STATE(10353),
    [sym_range] = STATE(10353),
    [sym_binary] = STATE(10353),
    [sym_unary] = STATE(10353),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9423] = {
    [sym_string] = STATE(10354),
    [aux_sym_chained_string_repeat1] = STATE(10354),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_when] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [9424] = {
    [sym_when] = STATE(10355),
    [sym_else] = STATE(10355),
    [anon_sym_end] = ACTIONS(13790),
    [anon_sym_when] = ACTIONS(2041),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [9425] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10356),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_assignment] = STATE(10356),
    [sym_operator_assignment] = STATE(10356),
    [sym_conditional] = STATE(10356),
    [sym_range] = STATE(10356),
    [sym_binary] = STATE(10356),
    [sym_unary] = STATE(10356),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9426] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [9427] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(12955),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [9428] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10357),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(10357),
    [sym_operator_assignment] = STATE(10357),
    [sym_conditional] = STATE(10357),
    [sym_range] = STATE(10357),
    [sym_binary] = STATE(10357),
    [sym_unary] = STATE(10357),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9429] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10358),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(10358),
    [sym_operator_assignment] = STATE(10358),
    [sym_conditional] = STATE(10358),
    [sym_range] = STATE(10358),
    [sym_binary] = STATE(10358),
    [sym_unary] = STATE(10358),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9430] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10359),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(10359),
    [sym_operator_assignment] = STATE(10359),
    [sym_conditional] = STATE(10359),
    [sym_range] = STATE(10359),
    [sym_binary] = STATE(10359),
    [sym_unary] = STATE(10359),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9431] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10360),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(10360),
    [sym_operator_assignment] = STATE(10360),
    [sym_conditional] = STATE(10360),
    [sym_range] = STATE(10360),
    [sym_binary] = STATE(10360),
    [sym_unary] = STATE(10360),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9432] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10361),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(10361),
    [sym_operator_assignment] = STATE(10361),
    [sym_conditional] = STATE(10361),
    [sym_range] = STATE(10361),
    [sym_binary] = STATE(10361),
    [sym_unary] = STATE(10361),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9433] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10362),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10362),
    [sym_operator_assignment] = STATE(10362),
    [sym_conditional] = STATE(10362),
    [sym_range] = STATE(10362),
    [sym_binary] = STATE(10362),
    [sym_unary] = STATE(10362),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9434] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10363),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(10363),
    [sym_operator_assignment] = STATE(10363),
    [sym_conditional] = STATE(10363),
    [sym_range] = STATE(10363),
    [sym_binary] = STATE(10363),
    [sym_unary] = STATE(10363),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9435] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10364),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(10364),
    [sym_operator_assignment] = STATE(10364),
    [sym_conditional] = STATE(10364),
    [sym_range] = STATE(10364),
    [sym_binary] = STATE(10364),
    [sym_unary] = STATE(10364),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9436] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10365),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(10365),
    [sym_operator_assignment] = STATE(10365),
    [sym_conditional] = STATE(10365),
    [sym_range] = STATE(10365),
    [sym_binary] = STATE(10365),
    [sym_unary] = STATE(10365),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9437] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10366),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(10366),
    [sym_operator_assignment] = STATE(10366),
    [sym_conditional] = STATE(10366),
    [sym_range] = STATE(10366),
    [sym_binary] = STATE(10366),
    [sym_unary] = STATE(10366),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9438] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10367),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_splat_argument] = STATE(10368),
    [sym_assignment] = STATE(10367),
    [sym_operator_assignment] = STATE(10367),
    [sym_conditional] = STATE(10367),
    [sym_range] = STATE(10367),
    [sym_binary] = STATE(10367),
    [sym_unary] = STATE(10367),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(10368),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(8402),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9439] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10369),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(10369),
    [sym_operator_assignment] = STATE(10369),
    [sym_conditional] = STATE(10369),
    [sym_range] = STATE(10369),
    [sym_binary] = STATE(10369),
    [sym_unary] = STATE(10369),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9440] = {
    [sym_string] = STATE(10370),
    [aux_sym_chained_string_repeat1] = STATE(10370),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [9441] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(12955),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [9442] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(12955),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [9443] = {
    [sym_heredoc_body] = STATE(9443),
    [aux_sym_call_repeat1] = STATE(9443),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [9444] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5455),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(5455),
    [sym_operator_assignment] = STATE(5455),
    [sym_conditional] = STATE(5455),
    [sym_range] = STATE(5455),
    [sym_binary] = STATE(5455),
    [sym_unary] = STATE(5455),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5458),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8400),
    [sym__splat_star] = ACTIONS(8402),
    [sym__unary_minus] = ACTIONS(5004),
    [sym__identifier_hash_key] = ACTIONS(8404),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12977),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(8406),
    [sym_identifier] = ACTIONS(8406),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9445] = {
    [sym_heredoc_body] = STATE(9443),
    [aux_sym_call_repeat1] = STATE(9443),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [9446] = {
    [aux_sym_argument_list_repeat1] = STATE(9446),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13872),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [9447] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(8380),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(8382),
    [anon_sym_DOT_DOT] = ACTIONS(8384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8386),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(8390),
    [anon_sym_AMP_AMP] = ACTIONS(8390),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(8394),
    [anon_sym_BANG_EQ] = ACTIONS(8390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8390),
    [anon_sym_LT_EQ_GT] = ACTIONS(8390),
    [anon_sym_EQ_TILDE] = ACTIONS(8390),
    [anon_sym_BANG_TILDE] = ACTIONS(8390),
    [anon_sym_LT_EQ] = ACTIONS(8380),
    [anon_sym_GT] = ACTIONS(8380),
    [anon_sym_GT_EQ] = ACTIONS(8396),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [9448] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7829),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2968),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(2968),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(7829),
    [sym_operator_assignment] = STATE(7829),
    [sym_conditional] = STATE(7829),
    [sym_range] = STATE(7829),
    [sym_binary] = STATE(7829),
    [sym_unary] = STATE(7829),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(2967),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2968),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2968),
    [sym_false] = STATE(2968),
    [sym_nil] = STATE(2968),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(11104),
    [sym__unary_minus] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_defined_QMARK] = ACTIONS(4840),
    [anon_sym_not] = ACTIONS(4842),
    [anon_sym_BANG] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4844),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9449] = {
    [aux_sym_exceptions_repeat1] = STATE(10371),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(13875),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9450] = {
    [sym_heredoc_body] = STATE(9450),
    [aux_sym_call_repeat1] = STATE(9450),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_ensure] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9451] = {
    [sym_heredoc_body] = STATE(9450),
    [aux_sym_call_repeat1] = STATE(9450),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_ensure] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9452] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10372),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_assignment] = STATE(10372),
    [sym_operator_assignment] = STATE(10372),
    [sym_conditional] = STATE(10372),
    [sym_range] = STATE(10372),
    [sym_binary] = STATE(10372),
    [sym_unary] = STATE(10372),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9453] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7845),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2982),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(2982),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(7845),
    [sym_operator_assignment] = STATE(7845),
    [sym_conditional] = STATE(7845),
    [sym_range] = STATE(7845),
    [sym_binary] = STATE(7845),
    [sym_unary] = STATE(7845),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(2981),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2982),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2982),
    [sym_false] = STATE(2982),
    [sym_nil] = STATE(2982),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2053),
    [sym__unary_minus] = ACTIONS(4858),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4868),
    [anon_sym_defined_QMARK] = ACTIONS(4870),
    [anon_sym_not] = ACTIONS(4872),
    [anon_sym_BANG] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4874),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9454] = {
    [aux_sym_exceptions_repeat1] = STATE(10373),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13877),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_ensure] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9455] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4890),
    [sym__binary_star] = ACTIONS(4892),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4894),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(4892),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym_LT] = ACTIONS(4898),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_DOT_DOT] = ACTIONS(4902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4904),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4906),
    [anon_sym_AMP_AMP] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_EQ_EQ] = ACTIONS(4910),
    [anon_sym_BANG_EQ] = ACTIONS(4906),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4906),
    [anon_sym_EQ_TILDE] = ACTIONS(4906),
    [anon_sym_BANG_TILDE] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4898),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_GT_EQ] = ACTIONS(4912),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_PLUS] = ACTIONS(4890),
    [anon_sym_SLASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(87),
  },
  [9456] = {
    [aux_sym_exceptions_repeat1] = STATE(9456),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13879),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9457] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10374),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_assignment] = STATE(10374),
    [sym_operator_assignment] = STATE(10374),
    [sym_conditional] = STATE(10374),
    [sym_range] = STATE(10374),
    [sym_binary] = STATE(10374),
    [sym_unary] = STATE(10374),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9458] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7880),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3039),
    [sym_scope_resolution] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_method_call] = STATE(3039),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(7880),
    [sym_operator_assignment] = STATE(7880),
    [sym_conditional] = STATE(7880),
    [sym_range] = STATE(7880),
    [sym_binary] = STATE(7880),
    [sym_unary] = STATE(7880),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(3038),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3039),
    [sym__variable] = STATE(1166),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3039),
    [sym_false] = STATE(3039),
    [sym_nil] = STATE(3039),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(1170),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(4936),
    [sym__unary_minus] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(2087),
    [anon_sym_break] = ACTIONS(2089),
    [anon_sym_next] = ACTIONS(2091),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8475),
    [anon_sym_defined_QMARK] = ACTIONS(4942),
    [anon_sym_not] = ACTIONS(4944),
    [anon_sym_BANG] = ACTIONS(4948),
    [anon_sym_TILDE] = ACTIONS(4948),
    [sym_constant] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2105),
    [sym_instance_variable] = ACTIONS(2107),
    [sym_class_variable] = ACTIONS(2107),
    [sym_global_variable] = ACTIONS(2107),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2105),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2105),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9459] = {
    [aux_sym_exceptions_repeat1] = STATE(10375),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13882),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9460] = {
    [sym__line_break] = ACTIONS(4148),
    [sym__simple_symbol] = ACTIONS(4148),
    [sym__string_start] = ACTIONS(4148),
    [sym__symbol_start] = ACTIONS(4148),
    [sym__subshell_start] = ACTIONS(4148),
    [sym__regex_start] = ACTIONS(4148),
    [sym__string_array_start] = ACTIONS(4148),
    [sym__symbol_array_start] = ACTIONS(4148),
    [sym__heredoc_body_start] = ACTIONS(4148),
    [sym_heredoc_beginning] = ACTIONS(4148),
    [sym__block_ampersand] = ACTIONS(4148),
    [sym__splat_star] = ACTIONS(4148),
    [sym__unary_minus] = ACTIONS(4148),
    [sym__identifier_hash_key] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_def] = ACTIONS(4150),
    [anon_sym_LPAREN] = ACTIONS(4150),
    [anon_sym_DOT] = ACTIONS(4148),
    [anon_sym_COLON_COLON] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_STAR] = ACTIONS(4150),
    [anon_sym_STAR_STAR] = ACTIONS(4148),
    [anon_sym_class] = ACTIONS(4150),
    [anon_sym_module] = ACTIONS(4150),
    [anon_sym_return] = ACTIONS(4150),
    [anon_sym_yield] = ACTIONS(4150),
    [anon_sym_break] = ACTIONS(4150),
    [anon_sym_next] = ACTIONS(4150),
    [sym_redo] = ACTIONS(4150),
    [sym_retry] = ACTIONS(4150),
    [anon_sym_if] = ACTIONS(4150),
    [anon_sym_unless] = ACTIONS(4150),
    [anon_sym_while] = ACTIONS(4150),
    [anon_sym_until] = ACTIONS(4150),
    [anon_sym_for] = ACTIONS(4150),
    [anon_sym_do] = ACTIONS(4150),
    [anon_sym_case] = ACTIONS(4150),
    [anon_sym_then] = ACTIONS(4150),
    [anon_sym_begin] = ACTIONS(4150),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_COLON_COLON2] = ACTIONS(4148),
    [anon_sym_AMP_DOT] = ACTIONS(4148),
    [anon_sym_LPAREN2] = ACTIONS(4148),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_defined_QMARK] = ACTIONS(4148),
    [anon_sym_not] = ACTIONS(4150),
    [anon_sym_BANG] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4148),
    [sym_constant] = ACTIONS(4150),
    [sym_identifier] = ACTIONS(4150),
    [sym_instance_variable] = ACTIONS(4148),
    [sym_class_variable] = ACTIONS(4148),
    [sym_global_variable] = ACTIONS(4148),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4150),
    [sym_float] = ACTIONS(4150),
    [sym_complex] = ACTIONS(4148),
    [sym_super] = ACTIONS(4150),
    [anon_sym_true] = ACTIONS(4150),
    [anon_sym_TRUE] = ACTIONS(4150),
    [anon_sym_false] = ACTIONS(4150),
    [anon_sym_FALSE] = ACTIONS(4150),
    [sym_self] = ACTIONS(4150),
    [anon_sym_nil] = ACTIONS(4150),
    [anon_sym_NIL] = ACTIONS(4150),
    [sym_character] = ACTIONS(4148),
    [anon_sym_LBRACK2] = ACTIONS(4150),
    [anon_sym_DASH_GT] = ACTIONS(4148),
  },
  [9461] = {
    [sym_heredoc_body] = STATE(10377),
    [sym__heredoc_body_start] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(13884),
    [sym_comment] = ACTIONS(87),
  },
  [9462] = {
    [anon_sym_RPAREN] = ACTIONS(13884),
    [sym_comment] = ACTIONS(87),
  },
  [9463] = {
    [sym__line_break] = ACTIONS(9425),
    [sym__simple_symbol] = ACTIONS(9425),
    [sym__string_start] = ACTIONS(9425),
    [sym__symbol_start] = ACTIONS(9425),
    [sym__subshell_start] = ACTIONS(9425),
    [sym__regex_start] = ACTIONS(9425),
    [sym__string_array_start] = ACTIONS(9425),
    [sym__symbol_array_start] = ACTIONS(9425),
    [sym__heredoc_body_start] = ACTIONS(9425),
    [sym_heredoc_beginning] = ACTIONS(9425),
    [sym__block_ampersand] = ACTIONS(9425),
    [sym__splat_star] = ACTIONS(9425),
    [sym__unary_minus] = ACTIONS(9425),
    [sym__identifier_hash_key] = ACTIONS(9425),
    [anon_sym_LBRACE] = ACTIONS(9425),
    [anon_sym_def] = ACTIONS(9427),
    [anon_sym_LPAREN] = ACTIONS(9427),
    [anon_sym_DOT] = ACTIONS(9425),
    [anon_sym_COLON_COLON] = ACTIONS(9427),
    [anon_sym_SEMI] = ACTIONS(9425),
    [anon_sym_STAR] = ACTIONS(9427),
    [anon_sym_STAR_STAR] = ACTIONS(9425),
    [anon_sym_class] = ACTIONS(9427),
    [anon_sym_module] = ACTIONS(9427),
    [anon_sym_return] = ACTIONS(9427),
    [anon_sym_yield] = ACTIONS(9427),
    [anon_sym_break] = ACTIONS(9427),
    [anon_sym_next] = ACTIONS(9427),
    [sym_redo] = ACTIONS(9427),
    [sym_retry] = ACTIONS(9427),
    [anon_sym_if] = ACTIONS(9427),
    [anon_sym_unless] = ACTIONS(9427),
    [anon_sym_while] = ACTIONS(9427),
    [anon_sym_until] = ACTIONS(9427),
    [anon_sym_for] = ACTIONS(9427),
    [anon_sym_do] = ACTIONS(9427),
    [anon_sym_case] = ACTIONS(9427),
    [anon_sym_then] = ACTIONS(9427),
    [anon_sym_begin] = ACTIONS(9427),
    [anon_sym_LBRACK] = ACTIONS(9425),
    [anon_sym_COLON_COLON2] = ACTIONS(9425),
    [anon_sym_AMP_DOT] = ACTIONS(9425),
    [anon_sym_LPAREN2] = ACTIONS(9425),
    [anon_sym_PLUS] = ACTIONS(9427),
    [anon_sym_defined_QMARK] = ACTIONS(9425),
    [anon_sym_not] = ACTIONS(9427),
    [anon_sym_BANG] = ACTIONS(9425),
    [anon_sym_TILDE] = ACTIONS(9425),
    [sym_constant] = ACTIONS(9427),
    [sym_identifier] = ACTIONS(9427),
    [sym_instance_variable] = ACTIONS(9425),
    [sym_class_variable] = ACTIONS(9425),
    [sym_global_variable] = ACTIONS(9425),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9427),
    [sym_float] = ACTIONS(9427),
    [sym_complex] = ACTIONS(9425),
    [sym_super] = ACTIONS(9427),
    [anon_sym_true] = ACTIONS(9427),
    [anon_sym_TRUE] = ACTIONS(9427),
    [anon_sym_false] = ACTIONS(9427),
    [anon_sym_FALSE] = ACTIONS(9427),
    [sym_self] = ACTIONS(9427),
    [anon_sym_nil] = ACTIONS(9427),
    [anon_sym_NIL] = ACTIONS(9427),
    [sym_character] = ACTIONS(9425),
    [anon_sym_LBRACK2] = ACTIONS(9427),
    [anon_sym_DASH_GT] = ACTIONS(9425),
  },
  [9464] = {
    [sym__line_break] = ACTIONS(9432),
    [sym__heredoc_body_start] = ACTIONS(9432),
    [anon_sym_DOT] = ACTIONS(9432),
    [anon_sym_SEMI] = ACTIONS(9432),
    [anon_sym_then] = ACTIONS(9432),
    [anon_sym_LBRACK] = ACTIONS(9432),
    [anon_sym_COLON_COLON2] = ACTIONS(9432),
    [anon_sym_AMP_DOT] = ACTIONS(9432),
    [sym_comment] = ACTIONS(87),
  },
  [9465] = {
    [anon_sym_RBRACK] = ACTIONS(13886),
    [sym_comment] = ACTIONS(87),
  },
  [9466] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9467] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10379),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10379),
    [sym_operator_assignment] = STATE(10379),
    [sym_conditional] = STATE(10379),
    [sym_range] = STATE(10379),
    [sym_binary] = STATE(10379),
    [sym_unary] = STATE(10379),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9468] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10380),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10380),
    [sym_operator_assignment] = STATE(10380),
    [sym_conditional] = STATE(10380),
    [sym_range] = STATE(10380),
    [sym_binary] = STATE(10380),
    [sym_unary] = STATE(10380),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9469] = {
    [anon_sym_COLON] = ACTIONS(13888),
    [sym_comment] = ACTIONS(87),
  },
  [9470] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10382),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10382),
    [sym_operator_assignment] = STATE(10382),
    [sym_conditional] = STATE(10382),
    [sym_range] = STATE(10382),
    [sym_binary] = STATE(10382),
    [sym_unary] = STATE(10382),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9471] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(13890),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_then] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [9472] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_then] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(13888),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9473] = {
    [sym_heredoc_body] = STATE(10384),
    [aux_sym_call_repeat1] = STATE(10384),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [9474] = {
    [sym_heredoc_body] = STATE(10384),
    [aux_sym_call_repeat1] = STATE(10384),
    [aux_sym_argument_list_repeat1] = STATE(10386),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(13892),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_then] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [9475] = {
    [sym_string] = STATE(7939),
    [aux_sym_chained_string_repeat1] = STATE(7939),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(13894),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [9476] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_then] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [9477] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10387),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10387),
    [sym_operator_assignment] = STATE(10387),
    [sym_conditional] = STATE(10387),
    [sym_range] = STATE(10387),
    [sym_binary] = STATE(10387),
    [sym_unary] = STATE(10387),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9478] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10388),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10388),
    [sym_operator_assignment] = STATE(10388),
    [sym_conditional] = STATE(10388),
    [sym_range] = STATE(10388),
    [sym_binary] = STATE(10388),
    [sym_unary] = STATE(10388),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9479] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10389),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10389),
    [sym_operator_assignment] = STATE(10389),
    [sym_conditional] = STATE(10389),
    [sym_range] = STATE(10389),
    [sym_binary] = STATE(10389),
    [sym_unary] = STATE(10389),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9480] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10390),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10390),
    [sym_operator_assignment] = STATE(10390),
    [sym_conditional] = STATE(10390),
    [sym_range] = STATE(10390),
    [sym_binary] = STATE(10390),
    [sym_unary] = STATE(10390),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9481] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10391),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10391),
    [sym_operator_assignment] = STATE(10391),
    [sym_conditional] = STATE(10391),
    [sym_range] = STATE(10391),
    [sym_binary] = STATE(10391),
    [sym_unary] = STATE(10391),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9482] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10392),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10392),
    [sym_operator_assignment] = STATE(10392),
    [sym_conditional] = STATE(10392),
    [sym_range] = STATE(10392),
    [sym_binary] = STATE(10392),
    [sym_unary] = STATE(10392),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9483] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10393),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10393),
    [sym_operator_assignment] = STATE(10393),
    [sym_conditional] = STATE(10393),
    [sym_range] = STATE(10393),
    [sym_binary] = STATE(10393),
    [sym_unary] = STATE(10393),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9484] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10394),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10394),
    [sym_operator_assignment] = STATE(10394),
    [sym_conditional] = STATE(10394),
    [sym_range] = STATE(10394),
    [sym_binary] = STATE(10394),
    [sym_unary] = STATE(10394),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9485] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10395),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10395),
    [sym_operator_assignment] = STATE(10395),
    [sym_conditional] = STATE(10395),
    [sym_range] = STATE(10395),
    [sym_binary] = STATE(10395),
    [sym_unary] = STATE(10395),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9486] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10396),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10396),
    [sym_operator_assignment] = STATE(10396),
    [sym_conditional] = STATE(10396),
    [sym_range] = STATE(10396),
    [sym_binary] = STATE(10396),
    [sym_unary] = STATE(10396),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9487] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10397),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_splat_argument] = STATE(10398),
    [sym_assignment] = STATE(10397),
    [sym_operator_assignment] = STATE(10397),
    [sym_conditional] = STATE(10397),
    [sym_range] = STATE(10397),
    [sym_binary] = STATE(10397),
    [sym_unary] = STATE(10397),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(10398),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(13002),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9488] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10399),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10399),
    [sym_operator_assignment] = STATE(10399),
    [sym_conditional] = STATE(10399),
    [sym_range] = STATE(10399),
    [sym_binary] = STATE(10399),
    [sym_unary] = STATE(10399),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9489] = {
    [sym_string] = STATE(10400),
    [aux_sym_chained_string_repeat1] = STATE(10400),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_then] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [9490] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(13024),
    [anon_sym_or] = ACTIONS(13024),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [9491] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9492] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9493] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10401),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(10401),
    [sym_operator_assignment] = STATE(10401),
    [sym_conditional] = STATE(10401),
    [sym_range] = STATE(10401),
    [sym_binary] = STATE(10401),
    [sym_unary] = STATE(10401),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9494] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9495] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10402),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(10402),
    [sym_operator_assignment] = STATE(10402),
    [sym_conditional] = STATE(10402),
    [sym_range] = STATE(10402),
    [sym_binary] = STATE(10402),
    [sym_unary] = STATE(10402),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9496] = {
    [sym_heredoc_body] = STATE(10403),
    [aux_sym_call_repeat1] = STATE(10403),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9497] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7913),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(7913),
    [sym_operator_assignment] = STATE(7913),
    [sym_conditional] = STATE(7913),
    [sym_range] = STATE(7913),
    [sym_binary] = STATE(7913),
    [sym_unary] = STATE(7913),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7916),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10404),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(11149),
    [sym__splat_star] = ACTIONS(11151),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__identifier_hash_key] = ACTIONS(11153),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13896),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(11157),
    [sym_identifier] = ACTIONS(11157),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9498] = {
    [sym_heredoc_body] = STATE(10405),
    [aux_sym_call_repeat1] = STATE(10405),
    [aux_sym_argument_list_repeat1] = STATE(10406),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(13046),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9499] = {
    [sym__line_break] = ACTIONS(7608),
    [sym__heredoc_body_start] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_DOT] = ACTIONS(7608),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_do] = ACTIONS(7608),
    [anon_sym_then] = ACTIONS(7608),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
  },
  [9500] = {
    [anon_sym_RPAREN] = ACTIONS(13898),
    [sym_comment] = ACTIONS(87),
  },
  [9501] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(13024),
    [anon_sym_or] = ACTIONS(13024),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [9502] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9503] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9504] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9505] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9506] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9507] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13900),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9508] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9509] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9510] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9511] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9512] = {
    [sym__line_break] = ACTIONS(3102),
    [sym__heredoc_body_start] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_do] = ACTIONS(3102),
    [anon_sym_then] = ACTIONS(3102),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_COLON_COLON2] = ACTIONS(3102),
    [anon_sym_AMP_DOT] = ACTIONS(3102),
    [sym_comment] = ACTIONS(87),
  },
  [9513] = {
    [sym_interpolation] = STATE(1768),
    [aux_sym_heredoc_body_repeat1] = STATE(1768),
    [sym__heredoc_content] = ACTIONS(3104),
    [sym_heredoc_end] = ACTIONS(13902),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(987),
    [sym_escape_sequence] = ACTIONS(3104),
  },
  [9514] = {
    [sym_heredoc_body] = STATE(9514),
    [aux_sym_call_repeat1] = STATE(9514),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(13904),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7646),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9515] = {
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7657),
    [anon_sym_COMMA] = ACTIONS(7657),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9516] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5553),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym__argument] = STATE(10410),
    [sym_splat_argument] = STATE(10410),
    [sym_hash_splat_argument] = STATE(10410),
    [sym_block_argument] = STATE(10410),
    [sym_assignment] = STATE(5553),
    [sym_operator_assignment] = STATE(5553),
    [sym_conditional] = STATE(5553),
    [sym_range] = STATE(5553),
    [sym_binary] = STATE(5553),
    [sym_unary] = STATE(5553),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5560),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10410),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8521),
    [sym__splat_star] = ACTIONS(8523),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__identifier_hash_key] = ACTIONS(8527),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8531),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(8551),
    [sym_identifier] = ACTIONS(8551),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9517] = {
    [sym_heredoc_body] = STATE(9514),
    [aux_sym_call_repeat1] = STATE(9514),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(11191),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7661),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9518] = {
    [aux_sym_argument_list_repeat1] = STATE(9518),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7657),
    [anon_sym_COMMA] = ACTIONS(13907),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9519] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9520] = {
    [aux_sym_exceptions_repeat1] = STATE(10412),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9521] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [9522] = {
    [sym_string] = STATE(9522),
    [aux_sym_chained_string_repeat1] = STATE(9522),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [9523] = {
    [anon_sym_end] = ACTIONS(13910),
    [anon_sym_else] = ACTIONS(13910),
    [anon_sym_ensure] = ACTIONS(13910),
    [sym_comment] = ACTIONS(87),
  },
  [9524] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(4972),
    [sym__binary_star] = ACTIONS(4974),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(4974),
    [anon_sym_AMP] = ACTIONS(4978),
    [anon_sym_LT] = ACTIONS(4980),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4986),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4992),
    [anon_sym_GT_GT] = ACTIONS(4992),
    [anon_sym_EQ_EQ] = ACTIONS(4994),
    [anon_sym_BANG_EQ] = ACTIONS(4990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4990),
    [anon_sym_LT_EQ_GT] = ACTIONS(4990),
    [anon_sym_EQ_TILDE] = ACTIONS(4990),
    [anon_sym_BANG_TILDE] = ACTIONS(4990),
    [anon_sym_LT_EQ] = ACTIONS(4980),
    [anon_sym_GT] = ACTIONS(4980),
    [anon_sym_GT_EQ] = ACTIONS(4996),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4974),
    [anon_sym_PERCENT] = ACTIONS(4974),
    [sym_comment] = ACTIONS(87),
  },
  [9525] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10413),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_assignment] = STATE(10413),
    [sym_operator_assignment] = STATE(10413),
    [sym_conditional] = STATE(10413),
    [sym_range] = STATE(10413),
    [sym_binary] = STATE(10413),
    [sym_unary] = STATE(10413),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9526] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7959),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3079),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(3079),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(7959),
    [sym_operator_assignment] = STATE(7959),
    [sym_conditional] = STATE(7959),
    [sym_range] = STATE(7959),
    [sym_binary] = STATE(7959),
    [sym_unary] = STATE(7959),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(3078),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3079),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3079),
    [sym_false] = STATE(3079),
    [sym_nil] = STATE(3079),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5575),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(5002),
    [sym__unary_minus] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5008),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_break] = ACTIONS(5012),
    [anon_sym_next] = ACTIONS(5014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8561),
    [anon_sym_defined_QMARK] = ACTIONS(5016),
    [anon_sym_not] = ACTIONS(5018),
    [anon_sym_BANG] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5022),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9527] = {
    [aux_sym_exceptions_repeat1] = STATE(10414),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13912),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9528] = {
    [aux_sym_exceptions_repeat1] = STATE(9528),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13914),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9529] = {
    [sym_heredoc_body] = STATE(10415),
    [aux_sym_call_repeat1] = STATE(10415),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9530] = {
    [sym_heredoc_body] = STATE(10416),
    [aux_sym_call_repeat1] = STATE(10416),
    [aux_sym_argument_list_repeat1] = STATE(8014),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8675),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_ensure] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9531] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [9532] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9533] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [9534] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [9535] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [9536] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13917),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9537] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [9538] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11226),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [9539] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [9540] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [9541] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_ensure] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11226),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [9542] = {
    [aux_sym_exceptions_repeat1] = STATE(10419),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9543] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11226),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [9544] = {
    [sym_string] = STATE(9544),
    [aux_sym_chained_string_repeat1] = STATE(9544),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_ensure] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [9545] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_ensure] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [9546] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_ensure] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [9547] = {
    [sym_heredoc_body] = STATE(9547),
    [aux_sym_call_repeat1] = STATE(9547),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_ensure] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9548] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5626),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(5626),
    [sym_operator_assignment] = STATE(5626),
    [sym_conditional] = STATE(5626),
    [sym_range] = STATE(5626),
    [sym_binary] = STATE(5626),
    [sym_unary] = STATE(5626),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5629),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8631),
    [sym__splat_star] = ACTIONS(8633),
    [sym__unary_minus] = ACTIONS(5046),
    [sym__identifier_hash_key] = ACTIONS(8635),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13065),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(8637),
    [sym_identifier] = ACTIONS(8637),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9549] = {
    [sym_heredoc_body] = STATE(9547),
    [aux_sym_call_repeat1] = STATE(9547),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_ensure] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9550] = {
    [aux_sym_argument_list_repeat1] = STATE(9550),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13919),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9551] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10420),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_assignment] = STATE(10420),
    [sym_operator_assignment] = STATE(10420),
    [sym_conditional] = STATE(10420),
    [sym_range] = STATE(10420),
    [sym_binary] = STATE(10420),
    [sym_unary] = STATE(10420),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9552] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_ensure] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [9553] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_ensure] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [9554] = {
    [sym_heredoc_body] = STATE(9554),
    [aux_sym_call_repeat1] = STATE(9554),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_ensure] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [9555] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5647),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(5647),
    [sym_operator_assignment] = STATE(5647),
    [sym_conditional] = STATE(5647),
    [sym_range] = STATE(5647),
    [sym_binary] = STATE(5647),
    [sym_unary] = STATE(5647),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5650),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8667),
    [sym__splat_star] = ACTIONS(8669),
    [sym__unary_minus] = ACTIONS(5120),
    [sym__identifier_hash_key] = ACTIONS(8671),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13069),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(8673),
    [sym_identifier] = ACTIONS(8673),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9556] = {
    [sym_heredoc_body] = STATE(9554),
    [aux_sym_call_repeat1] = STATE(9554),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_ensure] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [9557] = {
    [aux_sym_argument_list_repeat1] = STATE(9557),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13922),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_ensure] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [9558] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8015),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3104),
    [sym_scope_resolution] = STATE(3100),
    [sym_call] = STATE(3100),
    [sym_method_call] = STATE(3104),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(8015),
    [sym_operator_assignment] = STATE(8015),
    [sym_conditional] = STATE(8015),
    [sym_range] = STATE(8015),
    [sym_binary] = STATE(8015),
    [sym_unary] = STATE(8015),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(3103),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3104),
    [sym__variable] = STATE(3100),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3104),
    [sym_false] = STATE(3104),
    [sym_nil] = STATE(3104),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5618),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(8633),
    [sym__unary_minus] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5052),
    [anon_sym_break] = ACTIONS(5054),
    [anon_sym_next] = ACTIONS(5056),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8627),
    [anon_sym_defined_QMARK] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(5060),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [sym_constant] = ACTIONS(5070),
    [sym_identifier] = ACTIONS(5070),
    [sym_instance_variable] = ACTIONS(5068),
    [sym_class_variable] = ACTIONS(5068),
    [sym_global_variable] = ACTIONS(5068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5070),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5070),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9559] = {
    [aux_sym_exceptions_repeat1] = STATE(10421),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13925),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_ensure] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9560] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(5088),
    [sym__binary_star] = ACTIONS(5090),
    [anon_sym_PIPE] = ACTIONS(5092),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(5090),
    [anon_sym_AMP] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_DOT_DOT] = ACTIONS(5100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5102),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5106),
    [anon_sym_AMP_AMP] = ACTIONS(5106),
    [anon_sym_LT_LT] = ACTIONS(5108),
    [anon_sym_GT_GT] = ACTIONS(5108),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5106),
    [anon_sym_LT_EQ_GT] = ACTIONS(5106),
    [anon_sym_EQ_TILDE] = ACTIONS(5106),
    [anon_sym_BANG_TILDE] = ACTIONS(5106),
    [anon_sym_LT_EQ] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5112),
    [anon_sym_CARET] = ACTIONS(5114),
    [anon_sym_PLUS] = ACTIONS(5088),
    [anon_sym_SLASH] = ACTIONS(5090),
    [anon_sym_PERCENT] = ACTIONS(5090),
    [sym_comment] = ACTIONS(87),
  },
  [9561] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [9562] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [9563] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [9564] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [9565] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [9566] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13927),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9567] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [9568] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [9569] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [9570] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [9571] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_ensure] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [9572] = {
    [aux_sym_exceptions_repeat1] = STATE(10424),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [9573] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [9574] = {
    [sym_string] = STATE(9574),
    [aux_sym_chained_string_repeat1] = STATE(9574),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_ensure] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [9575] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10425),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_assignment] = STATE(10425),
    [sym_operator_assignment] = STATE(10425),
    [sym_conditional] = STATE(10425),
    [sym_range] = STATE(10425),
    [sym_binary] = STATE(10425),
    [sym_unary] = STATE(10425),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9576] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8053),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3142),
    [sym_scope_resolution] = STATE(3138),
    [sym_call] = STATE(3138),
    [sym_method_call] = STATE(3142),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(8053),
    [sym_operator_assignment] = STATE(8053),
    [sym_conditional] = STATE(8053),
    [sym_range] = STATE(8053),
    [sym_binary] = STATE(8053),
    [sym_unary] = STATE(8053),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(3141),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3142),
    [sym__variable] = STATE(3138),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3142),
    [sym_false] = STATE(3142),
    [sym_nil] = STATE(3142),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5689),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(8669),
    [sym__unary_minus] = ACTIONS(5120),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5124),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_break] = ACTIONS(5128),
    [anon_sym_next] = ACTIONS(5130),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8709),
    [anon_sym_defined_QMARK] = ACTIONS(5132),
    [anon_sym_not] = ACTIONS(5134),
    [anon_sym_BANG] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5138),
    [sym_constant] = ACTIONS(5144),
    [sym_identifier] = ACTIONS(5144),
    [sym_instance_variable] = ACTIONS(5142),
    [sym_class_variable] = ACTIONS(5142),
    [sym_global_variable] = ACTIONS(5142),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5144),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5144),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9577] = {
    [aux_sym_exceptions_repeat1] = STATE(10426),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13929),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_ensure] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9578] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [9579] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9580] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(11313),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [9581] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [9582] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11311),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(11313),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11331),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [9583] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13931),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9584] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11311),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(11313),
    [anon_sym_LT] = ACTIONS(11315),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_ensure] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11321),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11323),
    [anon_sym_AMP_AMP] = ACTIONS(11323),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(11327),
    [anon_sym_BANG_EQ] = ACTIONS(11323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11323),
    [anon_sym_LT_EQ_GT] = ACTIONS(11323),
    [anon_sym_EQ_TILDE] = ACTIONS(11323),
    [anon_sym_BANG_TILDE] = ACTIONS(11323),
    [anon_sym_LT_EQ] = ACTIONS(11315),
    [anon_sym_GT] = ACTIONS(11315),
    [anon_sym_GT_EQ] = ACTIONS(11329),
    [anon_sym_CARET] = ACTIONS(11331),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [9585] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11311),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(11313),
    [anon_sym_LT] = ACTIONS(11315),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_DOT_DOT] = ACTIONS(11319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11321),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11323),
    [anon_sym_AMP_AMP] = ACTIONS(11323),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(11327),
    [anon_sym_BANG_EQ] = ACTIONS(11323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11323),
    [anon_sym_LT_EQ_GT] = ACTIONS(11323),
    [anon_sym_EQ_TILDE] = ACTIONS(11323),
    [anon_sym_BANG_TILDE] = ACTIONS(11323),
    [anon_sym_LT_EQ] = ACTIONS(11315),
    [anon_sym_GT] = ACTIONS(11315),
    [anon_sym_GT_EQ] = ACTIONS(11329),
    [anon_sym_CARET] = ACTIONS(11331),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [9586] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11311),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(11313),
    [anon_sym_LT] = ACTIONS(11315),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(11327),
    [anon_sym_BANG_EQ] = ACTIONS(11323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11323),
    [anon_sym_LT_EQ_GT] = ACTIONS(11323),
    [anon_sym_EQ_TILDE] = ACTIONS(11323),
    [anon_sym_BANG_TILDE] = ACTIONS(11323),
    [anon_sym_LT_EQ] = ACTIONS(11315),
    [anon_sym_GT] = ACTIONS(11315),
    [anon_sym_GT_EQ] = ACTIONS(11329),
    [anon_sym_CARET] = ACTIONS(11331),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [9587] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_ensure] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [9588] = {
    [aux_sym_exceptions_repeat1] = STATE(9588),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13933),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9589] = {
    [aux_sym_exceptions_repeat1] = STATE(8071),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_ensure] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9590] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11311),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(11313),
    [anon_sym_LT] = ACTIONS(11315),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_ensure] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_DOT_DOT] = ACTIONS(11319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11321),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11323),
    [anon_sym_AMP_AMP] = ACTIONS(11323),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(11327),
    [anon_sym_BANG_EQ] = ACTIONS(11323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11323),
    [anon_sym_LT_EQ_GT] = ACTIONS(11323),
    [anon_sym_EQ_TILDE] = ACTIONS(11323),
    [anon_sym_BANG_TILDE] = ACTIONS(11323),
    [anon_sym_LT_EQ] = ACTIONS(11315),
    [anon_sym_GT] = ACTIONS(11315),
    [anon_sym_GT_EQ] = ACTIONS(11329),
    [anon_sym_CARET] = ACTIONS(11331),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [9591] = {
    [sym_heredoc_body] = STATE(10428),
    [aux_sym_call_repeat1] = STATE(10428),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9592] = {
    [sym_heredoc_body] = STATE(10429),
    [aux_sym_call_repeat1] = STATE(10429),
    [aux_sym_argument_list_repeat1] = STATE(8122),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(8833),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9593] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [9594] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9595] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [9596] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [9597] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [9598] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13936),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9599] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [9600] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [9601] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [9602] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [9603] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [9604] = {
    [aux_sym_exceptions_repeat1] = STATE(10432),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9605] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [9606] = {
    [sym_string] = STATE(9606),
    [aux_sym_chained_string_repeat1] = STATE(9606),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [9607] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [9608] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [9609] = {
    [sym_heredoc_body] = STATE(9609),
    [aux_sym_call_repeat1] = STATE(9609),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9610] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(5741),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(5741),
    [sym_operator_assignment] = STATE(5741),
    [sym_conditional] = STATE(5741),
    [sym_range] = STATE(5741),
    [sym_binary] = STATE(5741),
    [sym_unary] = STATE(5741),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5744),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(8789),
    [sym__splat_star] = ACTIONS(8791),
    [sym__unary_minus] = ACTIONS(5158),
    [sym__identifier_hash_key] = ACTIONS(8793),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(8795),
    [sym_identifier] = ACTIONS(8795),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9611] = {
    [sym_heredoc_body] = STATE(9609),
    [aux_sym_call_repeat1] = STATE(9609),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9612] = {
    [aux_sym_argument_list_repeat1] = STATE(9612),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13938),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9613] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10433),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_assignment] = STATE(10433),
    [sym_operator_assignment] = STATE(10433),
    [sym_conditional] = STATE(10433),
    [sym_range] = STATE(10433),
    [sym_binary] = STATE(10433),
    [sym_unary] = STATE(10433),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9614] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [9615] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [9616] = {
    [sym_heredoc_body] = STATE(9616),
    [aux_sym_call_repeat1] = STATE(9616),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [9617] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(5762),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5765),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(8825),
    [sym__splat_star] = ACTIONS(8827),
    [sym__unary_minus] = ACTIONS(5232),
    [sym__identifier_hash_key] = ACTIONS(8829),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13083),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(8831),
    [sym_identifier] = ACTIONS(8831),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9618] = {
    [sym_heredoc_body] = STATE(9616),
    [aux_sym_call_repeat1] = STATE(9616),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [9619] = {
    [aux_sym_argument_list_repeat1] = STATE(9619),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(13941),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [9620] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(8123),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(3166),
    [sym_scope_resolution] = STATE(3162),
    [sym_call] = STATE(3162),
    [sym_method_call] = STATE(3166),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(8123),
    [sym_operator_assignment] = STATE(8123),
    [sym_conditional] = STATE(8123),
    [sym_range] = STATE(8123),
    [sym_binary] = STATE(8123),
    [sym_unary] = STATE(8123),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(3165),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3166),
    [sym__variable] = STATE(3162),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(3166),
    [sym_false] = STATE(3166),
    [sym_nil] = STATE(3166),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(5733),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(8791),
    [sym__unary_minus] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5164),
    [anon_sym_break] = ACTIONS(5166),
    [anon_sym_next] = ACTIONS(5168),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8785),
    [anon_sym_defined_QMARK] = ACTIONS(5170),
    [anon_sym_not] = ACTIONS(5172),
    [anon_sym_BANG] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [sym_constant] = ACTIONS(5182),
    [sym_identifier] = ACTIONS(5182),
    [sym_instance_variable] = ACTIONS(5180),
    [sym_class_variable] = ACTIONS(5180),
    [sym_global_variable] = ACTIONS(5180),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5182),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5182),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9621] = {
    [aux_sym_exceptions_repeat1] = STATE(10434),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13944),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9622] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(5200),
    [sym__binary_star] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_LT] = ACTIONS(5208),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_DOT_DOT] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5220),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_EQ_EQ] = ACTIONS(5222),
    [anon_sym_BANG_EQ] = ACTIONS(5218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5218),
    [anon_sym_EQ_TILDE] = ACTIONS(5218),
    [anon_sym_BANG_TILDE] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5208),
    [anon_sym_GT] = ACTIONS(5208),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5200),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [sym_comment] = ACTIONS(87),
  },
  [9623] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [9624] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [9625] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [9626] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [9627] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [9628] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13946),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9629] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [9630] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [9631] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [9632] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [9633] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [9634] = {
    [aux_sym_exceptions_repeat1] = STATE(10437),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [9635] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [9636] = {
    [sym_string] = STATE(9636),
    [aux_sym_chained_string_repeat1] = STATE(9636),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [9637] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10438),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_assignment] = STATE(10438),
    [sym_operator_assignment] = STATE(10438),
    [sym_conditional] = STATE(10438),
    [sym_range] = STATE(10438),
    [sym_binary] = STATE(10438),
    [sym_unary] = STATE(10438),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9638] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(8161),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(3204),
    [sym_scope_resolution] = STATE(3200),
    [sym_call] = STATE(3200),
    [sym_method_call] = STATE(3204),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(8161),
    [sym_operator_assignment] = STATE(8161),
    [sym_conditional] = STATE(8161),
    [sym_range] = STATE(8161),
    [sym_binary] = STATE(8161),
    [sym_unary] = STATE(8161),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(3203),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3204),
    [sym__variable] = STATE(3200),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(3204),
    [sym_false] = STATE(3204),
    [sym_nil] = STATE(3204),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(5804),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(8827),
    [sym__unary_minus] = ACTIONS(5232),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(5236),
    [anon_sym_yield] = ACTIONS(5238),
    [anon_sym_break] = ACTIONS(5240),
    [anon_sym_next] = ACTIONS(5242),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(8867),
    [anon_sym_defined_QMARK] = ACTIONS(5244),
    [anon_sym_not] = ACTIONS(5246),
    [anon_sym_BANG] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5250),
    [sym_constant] = ACTIONS(5256),
    [sym_identifier] = ACTIONS(5256),
    [sym_instance_variable] = ACTIONS(5254),
    [sym_class_variable] = ACTIONS(5254),
    [sym_global_variable] = ACTIONS(5254),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(5256),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5256),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [9639] = {
    [aux_sym_exceptions_repeat1] = STATE(10439),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13948),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9640] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [9641] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9642] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(11438),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [9643] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [9644] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11436),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(11438),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11456),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [9645] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13950),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9646] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11436),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(11438),
    [anon_sym_LT] = ACTIONS(11440),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11446),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11448),
    [anon_sym_AMP_AMP] = ACTIONS(11448),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(11452),
    [anon_sym_BANG_EQ] = ACTIONS(11448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11448),
    [anon_sym_LT_EQ_GT] = ACTIONS(11448),
    [anon_sym_EQ_TILDE] = ACTIONS(11448),
    [anon_sym_BANG_TILDE] = ACTIONS(11448),
    [anon_sym_LT_EQ] = ACTIONS(11440),
    [anon_sym_GT] = ACTIONS(11440),
    [anon_sym_GT_EQ] = ACTIONS(11454),
    [anon_sym_CARET] = ACTIONS(11456),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [9647] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11436),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(11438),
    [anon_sym_LT] = ACTIONS(11440),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11442),
    [anon_sym_DOT_DOT] = ACTIONS(11444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11446),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11448),
    [anon_sym_AMP_AMP] = ACTIONS(11448),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(11452),
    [anon_sym_BANG_EQ] = ACTIONS(11448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11448),
    [anon_sym_LT_EQ_GT] = ACTIONS(11448),
    [anon_sym_EQ_TILDE] = ACTIONS(11448),
    [anon_sym_BANG_TILDE] = ACTIONS(11448),
    [anon_sym_LT_EQ] = ACTIONS(11440),
    [anon_sym_GT] = ACTIONS(11440),
    [anon_sym_GT_EQ] = ACTIONS(11454),
    [anon_sym_CARET] = ACTIONS(11456),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [9648] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11436),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(11438),
    [anon_sym_LT] = ACTIONS(11440),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(11452),
    [anon_sym_BANG_EQ] = ACTIONS(11448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11448),
    [anon_sym_LT_EQ_GT] = ACTIONS(11448),
    [anon_sym_EQ_TILDE] = ACTIONS(11448),
    [anon_sym_BANG_TILDE] = ACTIONS(11448),
    [anon_sym_LT_EQ] = ACTIONS(11440),
    [anon_sym_GT] = ACTIONS(11440),
    [anon_sym_GT_EQ] = ACTIONS(11454),
    [anon_sym_CARET] = ACTIONS(11456),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [9649] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [9650] = {
    [aux_sym_exceptions_repeat1] = STATE(9650),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13952),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9651] = {
    [aux_sym_exceptions_repeat1] = STATE(8179),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9652] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11436),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(11438),
    [anon_sym_LT] = ACTIONS(11440),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11442),
    [anon_sym_DOT_DOT] = ACTIONS(11444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11446),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11448),
    [anon_sym_AMP_AMP] = ACTIONS(11448),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(11452),
    [anon_sym_BANG_EQ] = ACTIONS(11448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11448),
    [anon_sym_LT_EQ_GT] = ACTIONS(11448),
    [anon_sym_EQ_TILDE] = ACTIONS(11448),
    [anon_sym_BANG_TILDE] = ACTIONS(11448),
    [anon_sym_LT_EQ] = ACTIONS(11440),
    [anon_sym_GT] = ACTIONS(11440),
    [anon_sym_GT_EQ] = ACTIONS(11454),
    [anon_sym_CARET] = ACTIONS(11456),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [9653] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10441),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_assignment] = STATE(10441),
    [sym_operator_assignment] = STATE(10441),
    [sym_conditional] = STATE(10441),
    [sym_range] = STATE(10441),
    [sym_binary] = STATE(10441),
    [sym_unary] = STATE(10441),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9654] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8194),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3240),
    [sym_scope_resolution] = STATE(3238),
    [sym_call] = STATE(3238),
    [sym_method_call] = STATE(3240),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(8194),
    [sym_operator_assignment] = STATE(8194),
    [sym_conditional] = STATE(8194),
    [sym_range] = STATE(8194),
    [sym_binary] = STATE(8194),
    [sym_unary] = STATE(8194),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(3239),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3240),
    [sym__variable] = STATE(3238),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3240),
    [sym_false] = STATE(3240),
    [sym_nil] = STATE(3240),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3241),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(2221),
    [sym__unary_minus] = ACTIONS(5272),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(5274),
    [anon_sym_yield] = ACTIONS(5276),
    [anon_sym_break] = ACTIONS(5278),
    [anon_sym_next] = ACTIONS(5280),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(5282),
    [anon_sym_defined_QMARK] = ACTIONS(5284),
    [anon_sym_not] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_TILDE] = ACTIONS(5288),
    [sym_constant] = ACTIONS(5290),
    [sym_identifier] = ACTIONS(5290),
    [sym_instance_variable] = ACTIONS(5292),
    [sym_class_variable] = ACTIONS(5292),
    [sym_global_variable] = ACTIONS(5292),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(5290),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5290),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9655] = {
    [aux_sym_exceptions_repeat1] = STATE(10442),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(13955),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_ensure] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9656] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(5300),
    [sym__binary_star] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(5304),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5308),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(5310),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(5312),
    [anon_sym_DOT_DOT] = ACTIONS(5314),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5316),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5318),
    [anon_sym_AMP_AMP] = ACTIONS(5318),
    [anon_sym_LT_LT] = ACTIONS(5320),
    [anon_sym_GT_GT] = ACTIONS(5320),
    [anon_sym_EQ_EQ] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(5322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5322),
    [anon_sym_LT_EQ_GT] = ACTIONS(5322),
    [anon_sym_EQ_TILDE] = ACTIONS(5322),
    [anon_sym_BANG_TILDE] = ACTIONS(5322),
    [anon_sym_LT_EQ] = ACTIONS(5310),
    [anon_sym_GT] = ACTIONS(5310),
    [anon_sym_GT_EQ] = ACTIONS(5324),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(5306),
    [anon_sym_PERCENT] = ACTIONS(5306),
    [sym_comment] = ACTIONS(87),
  },
  [9657] = {
    [aux_sym_exceptions_repeat1] = STATE(9657),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13957),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [9658] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10443),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3272),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(3272),
    [sym_assignment] = STATE(10443),
    [sym_operator_assignment] = STATE(10443),
    [sym_conditional] = STATE(10443),
    [sym_range] = STATE(10443),
    [sym_binary] = STATE(10443),
    [sym_unary] = STATE(10443),
    [sym_left_assignment_list] = STATE(3271),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3272),
    [sym__variable] = STATE(293),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3272),
    [sym_false] = STATE(3272),
    [sym_nil] = STATE(3272),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2983),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4860),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_break] = ACTIONS(4864),
    [anon_sym_next] = ACTIONS(4866),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_defined_QMARK] = ACTIONS(5344),
    [anon_sym_not] = ACTIONS(5346),
    [anon_sym_BANG] = ACTIONS(5348),
    [anon_sym_TILDE] = ACTIONS(5348),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9659] = {
    [sym__heredoc_body_start] = ACTIONS(12069),
    [sym__binary_minus] = ACTIONS(12069),
    [sym__binary_star] = ACTIONS(12069),
    [anon_sym_LBRACE] = ACTIONS(12069),
    [anon_sym_RBRACE] = ACTIONS(12069),
    [anon_sym_RPAREN] = ACTIONS(12069),
    [anon_sym_DOT] = ACTIONS(12071),
    [anon_sym_COMMA] = ACTIONS(12069),
    [anon_sym_PIPE] = ACTIONS(12071),
    [anon_sym_SEMI] = ACTIONS(12069),
    [anon_sym_STAR_STAR] = ACTIONS(12069),
    [anon_sym_AMP] = ACTIONS(12071),
    [anon_sym_EQ] = ACTIONS(12071),
    [anon_sym_LT] = ACTIONS(12071),
    [anon_sym_if] = ACTIONS(12069),
    [anon_sym_unless] = ACTIONS(12069),
    [anon_sym_while] = ACTIONS(12069),
    [anon_sym_until] = ACTIONS(12069),
    [anon_sym_rescue] = ACTIONS(12069),
    [anon_sym_in] = ACTIONS(12069),
    [anon_sym_do] = ACTIONS(12069),
    [anon_sym_EQ_GT] = ACTIONS(12069),
    [anon_sym_LBRACK] = ACTIONS(12069),
    [anon_sym_RBRACK] = ACTIONS(12069),
    [anon_sym_COLON_COLON2] = ACTIONS(12069),
    [anon_sym_AMP_DOT] = ACTIONS(12069),
    [anon_sym_QMARK] = ACTIONS(12069),
    [anon_sym_COLON2] = ACTIONS(12071),
    [anon_sym_DOT_DOT] = ACTIONS(12071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12069),
    [anon_sym_and] = ACTIONS(12069),
    [anon_sym_or] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE] = ACTIONS(12069),
    [anon_sym_AMP_AMP] = ACTIONS(12069),
    [anon_sym_LT_LT] = ACTIONS(12069),
    [anon_sym_GT_GT] = ACTIONS(12069),
    [anon_sym_EQ_EQ] = ACTIONS(12071),
    [anon_sym_BANG_EQ] = ACTIONS(12069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12069),
    [anon_sym_LT_EQ_GT] = ACTIONS(12069),
    [anon_sym_EQ_TILDE] = ACTIONS(12069),
    [anon_sym_BANG_TILDE] = ACTIONS(12069),
    [anon_sym_LT_EQ] = ACTIONS(12071),
    [anon_sym_GT] = ACTIONS(12071),
    [anon_sym_GT_EQ] = ACTIONS(12069),
    [anon_sym_CARET] = ACTIONS(12069),
    [anon_sym_PLUS] = ACTIONS(12069),
    [anon_sym_SLASH] = ACTIONS(12069),
    [anon_sym_PERCENT] = ACTIONS(12069),
    [sym_comment] = ACTIONS(87),
  },
  [9660] = {
    [sym__heredoc_body_start] = ACTIONS(12073),
    [sym__binary_minus] = ACTIONS(12073),
    [sym__binary_star] = ACTIONS(12073),
    [anon_sym_LBRACE] = ACTIONS(12073),
    [anon_sym_RBRACE] = ACTIONS(12073),
    [anon_sym_RPAREN] = ACTIONS(12073),
    [anon_sym_DOT] = ACTIONS(12075),
    [anon_sym_COMMA] = ACTIONS(12073),
    [anon_sym_PIPE] = ACTIONS(12075),
    [anon_sym_SEMI] = ACTIONS(12073),
    [anon_sym_STAR_STAR] = ACTIONS(12073),
    [anon_sym_AMP] = ACTIONS(12075),
    [anon_sym_EQ] = ACTIONS(12075),
    [anon_sym_LT] = ACTIONS(12075),
    [anon_sym_if] = ACTIONS(12073),
    [anon_sym_unless] = ACTIONS(12073),
    [anon_sym_while] = ACTIONS(12073),
    [anon_sym_until] = ACTIONS(12073),
    [anon_sym_rescue] = ACTIONS(12073),
    [anon_sym_in] = ACTIONS(12073),
    [anon_sym_do] = ACTIONS(12073),
    [anon_sym_EQ_GT] = ACTIONS(12073),
    [anon_sym_LBRACK] = ACTIONS(12073),
    [anon_sym_RBRACK] = ACTIONS(12073),
    [anon_sym_COLON_COLON2] = ACTIONS(12073),
    [anon_sym_AMP_DOT] = ACTIONS(12073),
    [anon_sym_QMARK] = ACTIONS(12073),
    [anon_sym_COLON2] = ACTIONS(12075),
    [anon_sym_DOT_DOT] = ACTIONS(12075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12073),
    [anon_sym_and] = ACTIONS(12073),
    [anon_sym_or] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE] = ACTIONS(12073),
    [anon_sym_AMP_AMP] = ACTIONS(12073),
    [anon_sym_LT_LT] = ACTIONS(12073),
    [anon_sym_GT_GT] = ACTIONS(12073),
    [anon_sym_EQ_EQ] = ACTIONS(12075),
    [anon_sym_BANG_EQ] = ACTIONS(12073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12073),
    [anon_sym_LT_EQ_GT] = ACTIONS(12073),
    [anon_sym_EQ_TILDE] = ACTIONS(12073),
    [anon_sym_BANG_TILDE] = ACTIONS(12073),
    [anon_sym_LT_EQ] = ACTIONS(12075),
    [anon_sym_GT] = ACTIONS(12075),
    [anon_sym_GT_EQ] = ACTIONS(12073),
    [anon_sym_CARET] = ACTIONS(12073),
    [anon_sym_PLUS] = ACTIONS(12073),
    [anon_sym_SLASH] = ACTIONS(12073),
    [anon_sym_PERCENT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [9661] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [9662] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9663] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [9664] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [9665] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [9666] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13960),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9667] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_RBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [9668] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [9669] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [9670] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [9671] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_RBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [9672] = {
    [aux_sym_exceptions_repeat1] = STATE(10446),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9673] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_RBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [9674] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(5394),
    [sym__binary_star] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_STAR_STAR] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_RBRACK] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(5404),
    [anon_sym_DOT_DOT] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ_GT] = ACTIONS(5412),
    [anon_sym_EQ_TILDE] = ACTIONS(5412),
    [anon_sym_BANG_TILDE] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(5394),
    [anon_sym_SLASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [sym_comment] = ACTIONS(87),
  },
  [9675] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [9676] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [9677] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [9678] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [9679] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [9680] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(13962),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9681] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_RBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [9682] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11537),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [9683] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [9684] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_RBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [9685] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_RBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11537),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [9686] = {
    [aux_sym_exceptions_repeat1] = STATE(10449),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [9687] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_RBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11537),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [9688] = {
    [sym_string] = STATE(9688),
    [aux_sym_chained_string_repeat1] = STATE(9688),
    [sym__string_start] = ACTIONS(13427),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_RBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [9689] = {
    [aux_sym_exceptions_repeat1] = STATE(9689),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(13964),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9690] = {
    [sym__heredoc_body_start] = ACTIONS(12187),
    [sym__binary_minus] = ACTIONS(12187),
    [sym__binary_star] = ACTIONS(12187),
    [anon_sym_LBRACE] = ACTIONS(12187),
    [anon_sym_RBRACE] = ACTIONS(12187),
    [anon_sym_RPAREN] = ACTIONS(12187),
    [anon_sym_DOT] = ACTIONS(12189),
    [anon_sym_COMMA] = ACTIONS(12187),
    [anon_sym_PIPE] = ACTIONS(12189),
    [anon_sym_SEMI] = ACTIONS(12187),
    [anon_sym_STAR_STAR] = ACTIONS(12187),
    [anon_sym_AMP] = ACTIONS(12189),
    [anon_sym_EQ] = ACTIONS(12189),
    [anon_sym_LT] = ACTIONS(12189),
    [anon_sym_if] = ACTIONS(12187),
    [anon_sym_unless] = ACTIONS(12187),
    [anon_sym_while] = ACTIONS(12187),
    [anon_sym_until] = ACTIONS(12187),
    [anon_sym_rescue] = ACTIONS(12187),
    [anon_sym_in] = ACTIONS(12187),
    [anon_sym_do] = ACTIONS(12187),
    [anon_sym_EQ_GT] = ACTIONS(12187),
    [anon_sym_LBRACK] = ACTIONS(12187),
    [anon_sym_RBRACK] = ACTIONS(12187),
    [anon_sym_COLON_COLON2] = ACTIONS(12187),
    [anon_sym_AMP_DOT] = ACTIONS(12187),
    [anon_sym_QMARK] = ACTIONS(12187),
    [anon_sym_COLON2] = ACTIONS(12189),
    [anon_sym_DOT_DOT] = ACTIONS(12189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12187),
    [anon_sym_and] = ACTIONS(12187),
    [anon_sym_or] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE] = ACTIONS(12187),
    [anon_sym_AMP_AMP] = ACTIONS(12187),
    [anon_sym_LT_LT] = ACTIONS(12187),
    [anon_sym_GT_GT] = ACTIONS(12187),
    [anon_sym_EQ_EQ] = ACTIONS(12189),
    [anon_sym_BANG_EQ] = ACTIONS(12187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12187),
    [anon_sym_LT_EQ_GT] = ACTIONS(12187),
    [anon_sym_EQ_TILDE] = ACTIONS(12187),
    [anon_sym_BANG_TILDE] = ACTIONS(12187),
    [anon_sym_LT_EQ] = ACTIONS(12189),
    [anon_sym_GT] = ACTIONS(12189),
    [anon_sym_GT_EQ] = ACTIONS(12187),
    [anon_sym_CARET] = ACTIONS(12187),
    [anon_sym_PLUS] = ACTIONS(12187),
    [anon_sym_SLASH] = ACTIONS(12187),
    [anon_sym_PERCENT] = ACTIONS(12187),
    [sym_comment] = ACTIONS(87),
  },
  [9691] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(5456),
    [sym__binary_star] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(5460),
    [anon_sym_STAR_STAR] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5464),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_RBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_EQ_TILDE] = ACTIONS(5472),
    [anon_sym_BANG_TILDE] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5478),
    [anon_sym_CARET] = ACTIONS(5480),
    [anon_sym_PLUS] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [sym_comment] = ACTIONS(87),
  },
  [9692] = {
    [aux_sym_exceptions_repeat1] = STATE(9692),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13967),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9693] = {
    [sym__heredoc_body_start] = ACTIONS(12482),
    [sym__binary_minus] = ACTIONS(12482),
    [sym__binary_star] = ACTIONS(12482),
    [anon_sym_LBRACE] = ACTIONS(12482),
    [anon_sym_RBRACE] = ACTIONS(12482),
    [anon_sym_RPAREN] = ACTIONS(12482),
    [anon_sym_DOT] = ACTIONS(12484),
    [anon_sym_COMMA] = ACTIONS(12482),
    [anon_sym_PIPE] = ACTIONS(12484),
    [anon_sym_SEMI] = ACTIONS(12482),
    [anon_sym_STAR_STAR] = ACTIONS(12482),
    [anon_sym_AMP] = ACTIONS(12484),
    [anon_sym_EQ] = ACTIONS(12484),
    [anon_sym_LT] = ACTIONS(12484),
    [anon_sym_if] = ACTIONS(12482),
    [anon_sym_unless] = ACTIONS(12482),
    [anon_sym_while] = ACTIONS(12482),
    [anon_sym_until] = ACTIONS(12482),
    [anon_sym_rescue] = ACTIONS(12482),
    [anon_sym_in] = ACTIONS(12482),
    [anon_sym_do] = ACTIONS(12482),
    [anon_sym_EQ_GT] = ACTIONS(12482),
    [anon_sym_LBRACK] = ACTIONS(12482),
    [anon_sym_RBRACK] = ACTIONS(12482),
    [anon_sym_COLON_COLON2] = ACTIONS(12482),
    [anon_sym_AMP_DOT] = ACTIONS(12482),
    [anon_sym_QMARK] = ACTIONS(12482),
    [anon_sym_COLON2] = ACTIONS(12484),
    [anon_sym_DOT_DOT] = ACTIONS(12484),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12482),
    [anon_sym_and] = ACTIONS(12482),
    [anon_sym_or] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE] = ACTIONS(12482),
    [anon_sym_AMP_AMP] = ACTIONS(12482),
    [anon_sym_LT_LT] = ACTIONS(12482),
    [anon_sym_GT_GT] = ACTIONS(12482),
    [anon_sym_EQ_EQ] = ACTIONS(12484),
    [anon_sym_BANG_EQ] = ACTIONS(12482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12482),
    [anon_sym_LT_EQ_GT] = ACTIONS(12482),
    [anon_sym_EQ_TILDE] = ACTIONS(12482),
    [anon_sym_BANG_TILDE] = ACTIONS(12482),
    [anon_sym_LT_EQ] = ACTIONS(12484),
    [anon_sym_GT] = ACTIONS(12484),
    [anon_sym_GT_EQ] = ACTIONS(12482),
    [anon_sym_CARET] = ACTIONS(12482),
    [anon_sym_PLUS] = ACTIONS(12482),
    [anon_sym_SLASH] = ACTIONS(12482),
    [anon_sym_PERCENT] = ACTIONS(12482),
    [sym_comment] = ACTIONS(87),
  },
  [9694] = {
    [anon_sym_end] = ACTIONS(13970),
    [sym_comment] = ACTIONS(87),
  },
  [9695] = {
    [sym__heredoc_body_start] = ACTIONS(12622),
    [sym__binary_minus] = ACTIONS(12622),
    [sym__binary_star] = ACTIONS(12622),
    [anon_sym_LBRACE] = ACTIONS(12622),
    [anon_sym_RBRACE] = ACTIONS(12622),
    [anon_sym_RPAREN] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12624),
    [anon_sym_COMMA] = ACTIONS(12622),
    [anon_sym_PIPE] = ACTIONS(12624),
    [anon_sym_SEMI] = ACTIONS(12622),
    [anon_sym_STAR_STAR] = ACTIONS(12622),
    [anon_sym_AMP] = ACTIONS(12624),
    [anon_sym_EQ] = ACTIONS(12624),
    [anon_sym_LT] = ACTIONS(12624),
    [anon_sym_if] = ACTIONS(12622),
    [anon_sym_unless] = ACTIONS(12622),
    [anon_sym_while] = ACTIONS(12622),
    [anon_sym_until] = ACTIONS(12622),
    [anon_sym_rescue] = ACTIONS(12622),
    [anon_sym_in] = ACTIONS(12622),
    [anon_sym_do] = ACTIONS(12622),
    [anon_sym_EQ_GT] = ACTIONS(12622),
    [anon_sym_LBRACK] = ACTIONS(12622),
    [anon_sym_RBRACK] = ACTIONS(12622),
    [anon_sym_COLON_COLON2] = ACTIONS(12622),
    [anon_sym_AMP_DOT] = ACTIONS(12622),
    [anon_sym_QMARK] = ACTIONS(12622),
    [anon_sym_COLON2] = ACTIONS(12624),
    [anon_sym_DOT_DOT] = ACTIONS(12624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12622),
    [anon_sym_and] = ACTIONS(12622),
    [anon_sym_or] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE] = ACTIONS(12622),
    [anon_sym_AMP_AMP] = ACTIONS(12622),
    [anon_sym_LT_LT] = ACTIONS(12622),
    [anon_sym_GT_GT] = ACTIONS(12622),
    [anon_sym_EQ_EQ] = ACTIONS(12624),
    [anon_sym_BANG_EQ] = ACTIONS(12622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12622),
    [anon_sym_LT_EQ_GT] = ACTIONS(12622),
    [anon_sym_EQ_TILDE] = ACTIONS(12622),
    [anon_sym_BANG_TILDE] = ACTIONS(12622),
    [anon_sym_LT_EQ] = ACTIONS(12624),
    [anon_sym_GT] = ACTIONS(12624),
    [anon_sym_GT_EQ] = ACTIONS(12622),
    [anon_sym_CARET] = ACTIONS(12622),
    [anon_sym_PLUS] = ACTIONS(12622),
    [anon_sym_SLASH] = ACTIONS(12622),
    [anon_sym_PERCENT] = ACTIONS(12622),
    [sym_comment] = ACTIONS(87),
  },
  [9696] = {
    [sym__heredoc_body_start] = ACTIONS(12770),
    [sym__binary_minus] = ACTIONS(12770),
    [sym__binary_star] = ACTIONS(12770),
    [anon_sym_LBRACE] = ACTIONS(12770),
    [anon_sym_RBRACE] = ACTIONS(12770),
    [anon_sym_RPAREN] = ACTIONS(12770),
    [anon_sym_DOT] = ACTIONS(12772),
    [anon_sym_COMMA] = ACTIONS(12770),
    [anon_sym_PIPE] = ACTIONS(12772),
    [anon_sym_SEMI] = ACTIONS(12770),
    [anon_sym_STAR_STAR] = ACTIONS(12770),
    [anon_sym_AMP] = ACTIONS(12772),
    [anon_sym_EQ] = ACTIONS(12772),
    [anon_sym_LT] = ACTIONS(12772),
    [anon_sym_if] = ACTIONS(12770),
    [anon_sym_unless] = ACTIONS(12770),
    [anon_sym_while] = ACTIONS(12770),
    [anon_sym_until] = ACTIONS(12770),
    [anon_sym_rescue] = ACTIONS(12770),
    [anon_sym_in] = ACTIONS(12770),
    [anon_sym_do] = ACTIONS(12770),
    [anon_sym_EQ_GT] = ACTIONS(12770),
    [anon_sym_LBRACK] = ACTIONS(12770),
    [anon_sym_RBRACK] = ACTIONS(12770),
    [anon_sym_COLON_COLON2] = ACTIONS(12770),
    [anon_sym_AMP_DOT] = ACTIONS(12770),
    [anon_sym_QMARK] = ACTIONS(12770),
    [anon_sym_COLON2] = ACTIONS(12772),
    [anon_sym_DOT_DOT] = ACTIONS(12772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12770),
    [anon_sym_and] = ACTIONS(12770),
    [anon_sym_or] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE] = ACTIONS(12770),
    [anon_sym_AMP_AMP] = ACTIONS(12770),
    [anon_sym_LT_LT] = ACTIONS(12770),
    [anon_sym_GT_GT] = ACTIONS(12770),
    [anon_sym_EQ_EQ] = ACTIONS(12772),
    [anon_sym_BANG_EQ] = ACTIONS(12770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12770),
    [anon_sym_LT_EQ_GT] = ACTIONS(12770),
    [anon_sym_EQ_TILDE] = ACTIONS(12770),
    [anon_sym_BANG_TILDE] = ACTIONS(12770),
    [anon_sym_LT_EQ] = ACTIONS(12772),
    [anon_sym_GT] = ACTIONS(12772),
    [anon_sym_GT_EQ] = ACTIONS(12770),
    [anon_sym_CARET] = ACTIONS(12770),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_SLASH] = ACTIONS(12770),
    [anon_sym_PERCENT] = ACTIONS(12770),
    [sym_comment] = ACTIONS(87),
  },
  [9697] = {
    [sym__heredoc_body_start] = ACTIONS(12781),
    [sym__binary_minus] = ACTIONS(12781),
    [sym__binary_star] = ACTIONS(12781),
    [anon_sym_LBRACE] = ACTIONS(12781),
    [anon_sym_RBRACE] = ACTIONS(12781),
    [anon_sym_RPAREN] = ACTIONS(12781),
    [anon_sym_DOT] = ACTIONS(12783),
    [anon_sym_COMMA] = ACTIONS(12781),
    [anon_sym_PIPE] = ACTIONS(12783),
    [anon_sym_SEMI] = ACTIONS(12781),
    [anon_sym_STAR_STAR] = ACTIONS(12781),
    [anon_sym_AMP] = ACTIONS(12783),
    [anon_sym_EQ] = ACTIONS(12783),
    [anon_sym_LT] = ACTIONS(12783),
    [anon_sym_if] = ACTIONS(12781),
    [anon_sym_unless] = ACTIONS(12781),
    [anon_sym_while] = ACTIONS(12781),
    [anon_sym_until] = ACTIONS(12781),
    [anon_sym_rescue] = ACTIONS(12781),
    [anon_sym_in] = ACTIONS(12781),
    [anon_sym_do] = ACTIONS(12781),
    [anon_sym_EQ_GT] = ACTIONS(12781),
    [anon_sym_LBRACK] = ACTIONS(12781),
    [anon_sym_RBRACK] = ACTIONS(12781),
    [anon_sym_COLON_COLON2] = ACTIONS(12781),
    [anon_sym_AMP_DOT] = ACTIONS(12781),
    [anon_sym_QMARK] = ACTIONS(12781),
    [anon_sym_COLON2] = ACTIONS(12783),
    [anon_sym_DOT_DOT] = ACTIONS(12783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12781),
    [anon_sym_and] = ACTIONS(12781),
    [anon_sym_or] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE] = ACTIONS(12781),
    [anon_sym_AMP_AMP] = ACTIONS(12781),
    [anon_sym_LT_LT] = ACTIONS(12781),
    [anon_sym_GT_GT] = ACTIONS(12781),
    [anon_sym_EQ_EQ] = ACTIONS(12783),
    [anon_sym_BANG_EQ] = ACTIONS(12781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12781),
    [anon_sym_LT_EQ_GT] = ACTIONS(12781),
    [anon_sym_EQ_TILDE] = ACTIONS(12781),
    [anon_sym_BANG_TILDE] = ACTIONS(12781),
    [anon_sym_LT_EQ] = ACTIONS(12783),
    [anon_sym_GT] = ACTIONS(12783),
    [anon_sym_GT_EQ] = ACTIONS(12781),
    [anon_sym_CARET] = ACTIONS(12781),
    [anon_sym_PLUS] = ACTIONS(12781),
    [anon_sym_SLASH] = ACTIONS(12781),
    [anon_sym_PERCENT] = ACTIONS(12781),
    [sym_comment] = ACTIONS(87),
  },
  [9698] = {
    [sym__heredoc_body_start] = ACTIONS(13093),
    [sym__binary_minus] = ACTIONS(13093),
    [sym__binary_star] = ACTIONS(13093),
    [anon_sym_LBRACE] = ACTIONS(13093),
    [anon_sym_RBRACE] = ACTIONS(13093),
    [anon_sym_RPAREN] = ACTIONS(13093),
    [anon_sym_DOT] = ACTIONS(13095),
    [anon_sym_COMMA] = ACTIONS(13093),
    [anon_sym_PIPE] = ACTIONS(13095),
    [anon_sym_SEMI] = ACTIONS(13093),
    [anon_sym_STAR_STAR] = ACTIONS(13093),
    [anon_sym_AMP] = ACTIONS(13095),
    [anon_sym_EQ] = ACTIONS(13095),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_if] = ACTIONS(13093),
    [anon_sym_unless] = ACTIONS(13093),
    [anon_sym_while] = ACTIONS(13093),
    [anon_sym_until] = ACTIONS(13093),
    [anon_sym_rescue] = ACTIONS(13093),
    [anon_sym_in] = ACTIONS(13093),
    [anon_sym_do] = ACTIONS(13093),
    [anon_sym_EQ_GT] = ACTIONS(13093),
    [anon_sym_LBRACK] = ACTIONS(13093),
    [anon_sym_RBRACK] = ACTIONS(13093),
    [anon_sym_COLON_COLON2] = ACTIONS(13093),
    [anon_sym_AMP_DOT] = ACTIONS(13093),
    [anon_sym_QMARK] = ACTIONS(13093),
    [anon_sym_COLON2] = ACTIONS(13095),
    [anon_sym_DOT_DOT] = ACTIONS(13095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13093),
    [anon_sym_and] = ACTIONS(13093),
    [anon_sym_or] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE] = ACTIONS(13093),
    [anon_sym_AMP_AMP] = ACTIONS(13093),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13095),
    [anon_sym_BANG_EQ] = ACTIONS(13093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13093),
    [anon_sym_LT_EQ_GT] = ACTIONS(13093),
    [anon_sym_EQ_TILDE] = ACTIONS(13093),
    [anon_sym_BANG_TILDE] = ACTIONS(13093),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13093),
    [anon_sym_CARET] = ACTIONS(13093),
    [anon_sym_PLUS] = ACTIONS(13093),
    [anon_sym_SLASH] = ACTIONS(13093),
    [anon_sym_PERCENT] = ACTIONS(13093),
    [sym_comment] = ACTIONS(87),
  },
  [9699] = {
    [sym__heredoc_body_start] = ACTIONS(13264),
    [sym__binary_minus] = ACTIONS(13264),
    [sym__binary_star] = ACTIONS(13264),
    [anon_sym_LBRACE] = ACTIONS(13264),
    [anon_sym_RBRACE] = ACTIONS(13264),
    [anon_sym_RPAREN] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13266),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13266),
    [anon_sym_SEMI] = ACTIONS(13264),
    [anon_sym_STAR_STAR] = ACTIONS(13264),
    [anon_sym_AMP] = ACTIONS(13266),
    [anon_sym_EQ] = ACTIONS(13266),
    [anon_sym_LT] = ACTIONS(13266),
    [anon_sym_if] = ACTIONS(13264),
    [anon_sym_unless] = ACTIONS(13264),
    [anon_sym_while] = ACTIONS(13264),
    [anon_sym_until] = ACTIONS(13264),
    [anon_sym_rescue] = ACTIONS(13264),
    [anon_sym_in] = ACTIONS(13264),
    [anon_sym_do] = ACTIONS(13264),
    [anon_sym_EQ_GT] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_RBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [anon_sym_QMARK] = ACTIONS(13264),
    [anon_sym_COLON2] = ACTIONS(13266),
    [anon_sym_DOT_DOT] = ACTIONS(13266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13264),
    [anon_sym_and] = ACTIONS(13264),
    [anon_sym_or] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE] = ACTIONS(13264),
    [anon_sym_AMP_AMP] = ACTIONS(13264),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13264),
    [anon_sym_LT_EQ_GT] = ACTIONS(13264),
    [anon_sym_EQ_TILDE] = ACTIONS(13264),
    [anon_sym_BANG_TILDE] = ACTIONS(13264),
    [anon_sym_LT_EQ] = ACTIONS(13266),
    [anon_sym_GT] = ACTIONS(13266),
    [anon_sym_GT_EQ] = ACTIONS(13264),
    [anon_sym_CARET] = ACTIONS(13264),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13264),
    [anon_sym_PERCENT] = ACTIONS(13264),
    [sym_comment] = ACTIONS(87),
  },
  [9700] = {
    [anon_sym_end] = ACTIONS(13972),
    [sym_comment] = ACTIONS(87),
  },
  [9701] = {
    [sym__simple_symbol] = ACTIONS(10568),
    [sym__string_start] = ACTIONS(10568),
    [sym__symbol_start] = ACTIONS(10568),
    [sym__subshell_start] = ACTIONS(10568),
    [sym__regex_start] = ACTIONS(10568),
    [sym__string_array_start] = ACTIONS(10568),
    [sym__symbol_array_start] = ACTIONS(10568),
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym_heredoc_beginning] = ACTIONS(10568),
    [sym__block_ampersand] = ACTIONS(10568),
    [sym__splat_star] = ACTIONS(10568),
    [sym__unary_minus] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [sym__identifier_hash_key] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_def] = ACTIONS(10570),
    [anon_sym_LPAREN] = ACTIONS(10570),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COLON_COLON] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10570),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_class] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_module] = ACTIONS(10570),
    [anon_sym_return] = ACTIONS(10570),
    [anon_sym_yield] = ACTIONS(10570),
    [anon_sym_break] = ACTIONS(10570),
    [anon_sym_next] = ACTIONS(10570),
    [sym_redo] = ACTIONS(10570),
    [sym_retry] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10570),
    [anon_sym_unless] = ACTIONS(10570),
    [anon_sym_while] = ACTIONS(10570),
    [anon_sym_until] = ACTIONS(10570),
    [anon_sym_rescue] = ACTIONS(10570),
    [anon_sym_for] = ACTIONS(10570),
    [anon_sym_in] = ACTIONS(10570),
    [anon_sym_do] = ACTIONS(10570),
    [anon_sym_case] = ACTIONS(10570),
    [anon_sym_begin] = ACTIONS(10570),
    [anon_sym_EQ_GT] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_RBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_LPAREN2] = ACTIONS(10568),
    [anon_sym_PLUS_EQ] = ACTIONS(10568),
    [anon_sym_DASH_EQ] = ACTIONS(10568),
    [anon_sym_STAR_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10568),
    [anon_sym_SLASH_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10568),
    [anon_sym_AMP_EQ] = ACTIONS(10568),
    [anon_sym_PERCENT_EQ] = ACTIONS(10568),
    [anon_sym_GT_GT_EQ] = ACTIONS(10568),
    [anon_sym_LT_LT_EQ] = ACTIONS(10568),
    [anon_sym_CARET_EQ] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10570),
    [anon_sym_COLON2] = ACTIONS(10570),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10570),
    [anon_sym_or] = ACTIONS(10570),
    [anon_sym_PIPE_PIPE] = ACTIONS(10570),
    [anon_sym_AMP_AMP] = ACTIONS(10570),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10570),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_SLASH] = ACTIONS(10570),
    [anon_sym_PERCENT] = ACTIONS(10570),
    [anon_sym_defined_QMARK] = ACTIONS(10568),
    [anon_sym_not] = ACTIONS(10570),
    [anon_sym_BANG] = ACTIONS(10570),
    [anon_sym_TILDE] = ACTIONS(10568),
    [sym_constant] = ACTIONS(10570),
    [sym_identifier] = ACTIONS(10570),
    [sym_instance_variable] = ACTIONS(10568),
    [sym_class_variable] = ACTIONS(10568),
    [sym_global_variable] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10570),
    [sym_float] = ACTIONS(10570),
    [sym_complex] = ACTIONS(10568),
    [sym_super] = ACTIONS(10570),
    [anon_sym_true] = ACTIONS(10570),
    [anon_sym_TRUE] = ACTIONS(10570),
    [anon_sym_false] = ACTIONS(10570),
    [anon_sym_FALSE] = ACTIONS(10570),
    [sym_self] = ACTIONS(10570),
    [anon_sym_nil] = ACTIONS(10570),
    [anon_sym_NIL] = ACTIONS(10570),
    [sym_character] = ACTIONS(10568),
    [anon_sym_LBRACK2] = ACTIONS(10570),
    [anon_sym_DASH_GT] = ACTIONS(10568),
  },
  [9702] = {
    [sym__heredoc_body_start] = ACTIONS(13264),
    [sym__binary_minus] = ACTIONS(13264),
    [sym__binary_star] = ACTIONS(13264),
    [anon_sym_LBRACE] = ACTIONS(13264),
    [anon_sym_RBRACE] = ACTIONS(13264),
    [anon_sym_RPAREN] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13266),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13266),
    [anon_sym_SEMI] = ACTIONS(13264),
    [anon_sym_STAR_STAR] = ACTIONS(13266),
    [anon_sym_AMP] = ACTIONS(13266),
    [anon_sym_EQ] = ACTIONS(13266),
    [anon_sym_LT] = ACTIONS(13266),
    [anon_sym_if] = ACTIONS(13264),
    [anon_sym_unless] = ACTIONS(13264),
    [anon_sym_while] = ACTIONS(13264),
    [anon_sym_until] = ACTIONS(13264),
    [anon_sym_rescue] = ACTIONS(13264),
    [anon_sym_in] = ACTIONS(13264),
    [anon_sym_do] = ACTIONS(13264),
    [anon_sym_EQ_GT] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_RBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [anon_sym_PLUS_EQ] = ACTIONS(13264),
    [anon_sym_DASH_EQ] = ACTIONS(13264),
    [anon_sym_STAR_EQ] = ACTIONS(13264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13264),
    [anon_sym_SLASH_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13264),
    [anon_sym_AMP_EQ] = ACTIONS(13264),
    [anon_sym_PERCENT_EQ] = ACTIONS(13264),
    [anon_sym_GT_GT_EQ] = ACTIONS(13264),
    [anon_sym_LT_LT_EQ] = ACTIONS(13264),
    [anon_sym_CARET_EQ] = ACTIONS(13264),
    [anon_sym_QMARK] = ACTIONS(13264),
    [anon_sym_COLON2] = ACTIONS(13266),
    [anon_sym_DOT_DOT] = ACTIONS(13266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13264),
    [anon_sym_and] = ACTIONS(13264),
    [anon_sym_or] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE] = ACTIONS(13266),
    [anon_sym_AMP_AMP] = ACTIONS(13266),
    [anon_sym_LT_LT] = ACTIONS(13266),
    [anon_sym_GT_GT] = ACTIONS(13266),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13264),
    [anon_sym_LT_EQ_GT] = ACTIONS(13264),
    [anon_sym_EQ_TILDE] = ACTIONS(13264),
    [anon_sym_BANG_TILDE] = ACTIONS(13264),
    [anon_sym_LT_EQ] = ACTIONS(13266),
    [anon_sym_GT] = ACTIONS(13266),
    [anon_sym_GT_EQ] = ACTIONS(13264),
    [anon_sym_CARET] = ACTIONS(13266),
    [anon_sym_PLUS] = ACTIONS(13266),
    [anon_sym_SLASH] = ACTIONS(13266),
    [anon_sym_PERCENT] = ACTIONS(13266),
    [sym_comment] = ACTIONS(87),
  },
  [9703] = {
    [anon_sym_end] = ACTIONS(13974),
    [sym_comment] = ACTIONS(87),
  },
  [9704] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(5542),
    [sym__binary_star] = ACTIONS(5544),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_RBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5560),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_BANG_TILDE] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5546),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [9705] = {
    [aux_sym_exceptions_repeat1] = STATE(9705),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(13976),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [9706] = {
    [sym__simple_symbol] = ACTIONS(13979),
    [sym__string_start] = ACTIONS(13979),
    [sym__symbol_start] = ACTIONS(13979),
    [sym__subshell_start] = ACTIONS(13979),
    [sym__regex_start] = ACTIONS(13979),
    [sym__string_array_start] = ACTIONS(13979),
    [sym__symbol_array_start] = ACTIONS(13979),
    [sym_heredoc_beginning] = ACTIONS(13979),
    [sym__unary_minus] = ACTIONS(13979),
    [anon_sym_BEGIN] = ACTIONS(13981),
    [anon_sym_LBRACE] = ACTIONS(13979),
    [anon_sym_RBRACE] = ACTIONS(13979),
    [anon_sym_END] = ACTIONS(13981),
    [anon_sym_def] = ACTIONS(13981),
    [anon_sym_LPAREN] = ACTIONS(13979),
    [anon_sym_COLON_COLON] = ACTIONS(13979),
    [anon_sym_SEMI] = ACTIONS(13979),
    [anon_sym_STAR] = ACTIONS(13979),
    [anon_sym_class] = ACTIONS(13981),
    [anon_sym_module] = ACTIONS(13981),
    [anon_sym_return] = ACTIONS(13981),
    [anon_sym_yield] = ACTIONS(13981),
    [anon_sym_break] = ACTIONS(13981),
    [anon_sym_next] = ACTIONS(13981),
    [sym_redo] = ACTIONS(13981),
    [sym_retry] = ACTIONS(13981),
    [anon_sym_if] = ACTIONS(13981),
    [anon_sym_unless] = ACTIONS(13981),
    [anon_sym_while] = ACTIONS(13981),
    [anon_sym_until] = ACTIONS(13981),
    [anon_sym_for] = ACTIONS(13981),
    [anon_sym_case] = ACTIONS(13981),
    [anon_sym_begin] = ACTIONS(13981),
    [anon_sym_PLUS] = ACTIONS(13981),
    [anon_sym_defined_QMARK] = ACTIONS(13979),
    [anon_sym_not] = ACTIONS(13981),
    [anon_sym_BANG] = ACTIONS(13979),
    [anon_sym_TILDE] = ACTIONS(13979),
    [sym_constant] = ACTIONS(13981),
    [sym_identifier] = ACTIONS(13981),
    [sym_instance_variable] = ACTIONS(13979),
    [sym_class_variable] = ACTIONS(13979),
    [sym_global_variable] = ACTIONS(13979),
    [anon_sym_undef] = ACTIONS(13981),
    [anon_sym_alias] = ACTIONS(13981),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13981),
    [sym_float] = ACTIONS(13981),
    [sym_complex] = ACTIONS(13979),
    [sym_super] = ACTIONS(13981),
    [anon_sym_true] = ACTIONS(13981),
    [anon_sym_TRUE] = ACTIONS(13981),
    [anon_sym_false] = ACTIONS(13981),
    [anon_sym_FALSE] = ACTIONS(13981),
    [sym_self] = ACTIONS(13981),
    [anon_sym_nil] = ACTIONS(13981),
    [anon_sym_NIL] = ACTIONS(13981),
    [sym_character] = ACTIONS(13979),
    [anon_sym_LBRACK2] = ACTIONS(13979),
    [anon_sym_DASH_GT] = ACTIONS(13979),
  },
  [9707] = {
    [aux_sym_block_parameters_repeat1] = STATE(9709),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(13983),
    [sym_comment] = ACTIONS(87),
  },
  [9708] = {
    [anon_sym_COMMA] = ACTIONS(13985),
    [anon_sym_PIPE] = ACTIONS(13985),
    [sym_comment] = ACTIONS(87),
  },
  [9709] = {
    [aux_sym_block_parameters_repeat1] = STATE(9709),
    [anon_sym_COMMA] = ACTIONS(13987),
    [anon_sym_PIPE] = ACTIONS(13985),
    [sym_comment] = ACTIONS(87),
  },
  [9710] = {
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [9711] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10461),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(10461),
    [sym_operator_assignment] = STATE(10461),
    [sym_conditional] = STATE(10461),
    [sym_range] = STATE(10461),
    [sym_binary] = STATE(10461),
    [sym_unary] = STATE(10461),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9712] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10466),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(10466),
    [sym_operator_assignment] = STATE(10466),
    [sym_conditional] = STATE(10466),
    [sym_range] = STATE(10466),
    [sym_binary] = STATE(10466),
    [sym_unary] = STATE(10466),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9713] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10467),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10467),
    [sym_operator_assignment] = STATE(10467),
    [sym_conditional] = STATE(10467),
    [sym_range] = STATE(10467),
    [sym_binary] = STATE(10467),
    [sym_unary] = STATE(10467),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9714] = {
    [anon_sym_COLON] = ACTIONS(14014),
    [sym_comment] = ACTIONS(87),
  },
  [9715] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9716] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10476),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(10477),
    [sym__argument] = STATE(10478),
    [sym_splat_argument] = STATE(10478),
    [sym_hash_splat_argument] = STATE(10478),
    [sym_block_argument] = STATE(10478),
    [sym_assignment] = STATE(10476),
    [sym_operator_assignment] = STATE(10476),
    [sym_conditional] = STATE(10476),
    [sym_range] = STATE(10476),
    [sym_binary] = STATE(10476),
    [sym_unary] = STATE(10476),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10479),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(10478),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14016),
    [sym__splat_star] = ACTIONS(14018),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(14020),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(14022),
    [sym_identifier] = ACTIONS(14022),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9717] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10476),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(10477),
    [sym__argument] = STATE(10478),
    [sym_splat_argument] = STATE(10478),
    [sym_hash_splat_argument] = STATE(10478),
    [sym_block_argument] = STATE(10478),
    [sym_assignment] = STATE(10476),
    [sym_operator_assignment] = STATE(10476),
    [sym_conditional] = STATE(10476),
    [sym_range] = STATE(10476),
    [sym_binary] = STATE(10476),
    [sym_unary] = STATE(10476),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10479),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(10478),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14016),
    [sym__splat_star] = ACTIONS(14018),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(14020),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(14022),
    [sym_identifier] = ACTIONS(14022),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9718] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10476),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(10477),
    [sym__argument] = STATE(10478),
    [sym_splat_argument] = STATE(10478),
    [sym_hash_splat_argument] = STATE(10478),
    [sym_block_argument] = STATE(10478),
    [sym_assignment] = STATE(10476),
    [sym_operator_assignment] = STATE(10476),
    [sym_conditional] = STATE(10476),
    [sym_range] = STATE(10476),
    [sym_binary] = STATE(10476),
    [sym_unary] = STATE(10476),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10479),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(10478),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14016),
    [sym__splat_star] = ACTIONS(14018),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(14020),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(14022),
    [sym_identifier] = ACTIONS(14022),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9719] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10476),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(10477),
    [sym__argument] = STATE(10478),
    [sym_splat_argument] = STATE(10478),
    [sym_hash_splat_argument] = STATE(10478),
    [sym_block_argument] = STATE(10478),
    [sym_assignment] = STATE(10476),
    [sym_operator_assignment] = STATE(10476),
    [sym_conditional] = STATE(10476),
    [sym_range] = STATE(10476),
    [sym_binary] = STATE(10476),
    [sym_unary] = STATE(10476),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10479),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(10478),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14016),
    [sym__splat_star] = ACTIONS(14018),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(14020),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(14022),
    [sym_identifier] = ACTIONS(14022),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9720] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10480),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10480),
    [sym_operator_assignment] = STATE(10480),
    [sym_conditional] = STATE(10480),
    [sym_range] = STATE(10480),
    [sym_binary] = STATE(10480),
    [sym_unary] = STATE(10480),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9721] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9722] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14024),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [9723] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(14014),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [9724] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10497),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(10498),
    [sym__argument] = STATE(10499),
    [sym_splat_argument] = STATE(10499),
    [sym_hash_splat_argument] = STATE(10499),
    [sym_block_argument] = STATE(10499),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(10497),
    [sym_operator_assignment] = STATE(10497),
    [sym_conditional] = STATE(10497),
    [sym_range] = STATE(10497),
    [sym_binary] = STATE(10497),
    [sym_unary] = STATE(10497),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10500),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10499),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14052),
    [sym__splat_star] = ACTIONS(14054),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(14056),
    [anon_sym_LBRACE] = ACTIONS(2409),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(2419),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(14058),
    [sym_identifier] = ACTIONS(14058),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9725] = {
    [sym_heredoc_body] = STATE(10501),
    [aux_sym_call_repeat1] = STATE(10501),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [9726] = {
    [sym_heredoc_body] = STATE(10501),
    [aux_sym_call_repeat1] = STATE(10501),
    [aux_sym_argument_list_repeat1] = STATE(10503),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(14060),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [9727] = {
    [anon_sym_EQ] = ACTIONS(14062),
    [sym_comment] = ACTIONS(87),
  },
  [9728] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14064),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14066),
    [anon_sym_DASH_EQ] = ACTIONS(14066),
    [anon_sym_STAR_EQ] = ACTIONS(14066),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14066),
    [anon_sym_SLASH_EQ] = ACTIONS(14066),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14066),
    [anon_sym_PIPE_EQ] = ACTIONS(14066),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14066),
    [anon_sym_AMP_EQ] = ACTIONS(14066),
    [anon_sym_PERCENT_EQ] = ACTIONS(14066),
    [anon_sym_GT_GT_EQ] = ACTIONS(14066),
    [anon_sym_LT_LT_EQ] = ACTIONS(14066),
    [anon_sym_CARET_EQ] = ACTIONS(14066),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9729] = {
    [sym_string] = STATE(10506),
    [aux_sym_chained_string_repeat1] = STATE(10506),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14068),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [9730] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14070),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(13191),
    [anon_sym_QMARK] = ACTIONS(13193),
    [anon_sym_DOT_DOT] = ACTIONS(13195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13197),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13201),
    [anon_sym_AMP_AMP] = ACTIONS(13201),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(13205),
    [anon_sym_BANG_EQ] = ACTIONS(13201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13201),
    [anon_sym_LT_EQ_GT] = ACTIONS(13201),
    [anon_sym_EQ_TILDE] = ACTIONS(13201),
    [anon_sym_BANG_TILDE] = ACTIONS(13201),
    [anon_sym_LT_EQ] = ACTIONS(13191),
    [anon_sym_GT] = ACTIONS(13191),
    [anon_sym_GT_EQ] = ACTIONS(13207),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [9731] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10507),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10507),
    [sym_operator_assignment] = STATE(10507),
    [sym_conditional] = STATE(10507),
    [sym_range] = STATE(10507),
    [sym_binary] = STATE(10507),
    [sym_unary] = STATE(10507),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9732] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10508),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10508),
    [sym_operator_assignment] = STATE(10508),
    [sym_conditional] = STATE(10508),
    [sym_range] = STATE(10508),
    [sym_binary] = STATE(10508),
    [sym_unary] = STATE(10508),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9733] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10509),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10509),
    [sym_operator_assignment] = STATE(10509),
    [sym_conditional] = STATE(10509),
    [sym_range] = STATE(10509),
    [sym_binary] = STATE(10509),
    [sym_unary] = STATE(10509),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9734] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10510),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10510),
    [sym_operator_assignment] = STATE(10510),
    [sym_conditional] = STATE(10510),
    [sym_range] = STATE(10510),
    [sym_binary] = STATE(10510),
    [sym_unary] = STATE(10510),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9735] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10511),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10511),
    [sym_operator_assignment] = STATE(10511),
    [sym_conditional] = STATE(10511),
    [sym_range] = STATE(10511),
    [sym_binary] = STATE(10511),
    [sym_unary] = STATE(10511),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9736] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10512),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10512),
    [sym_operator_assignment] = STATE(10512),
    [sym_conditional] = STATE(10512),
    [sym_range] = STATE(10512),
    [sym_binary] = STATE(10512),
    [sym_unary] = STATE(10512),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9737] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10513),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10513),
    [sym_operator_assignment] = STATE(10513),
    [sym_conditional] = STATE(10513),
    [sym_range] = STATE(10513),
    [sym_binary] = STATE(10513),
    [sym_unary] = STATE(10513),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9738] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10514),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10514),
    [sym_operator_assignment] = STATE(10514),
    [sym_conditional] = STATE(10514),
    [sym_range] = STATE(10514),
    [sym_binary] = STATE(10514),
    [sym_unary] = STATE(10514),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9739] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10515),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10515),
    [sym_operator_assignment] = STATE(10515),
    [sym_conditional] = STATE(10515),
    [sym_range] = STATE(10515),
    [sym_binary] = STATE(10515),
    [sym_unary] = STATE(10515),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9740] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10516),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10516),
    [sym_operator_assignment] = STATE(10516),
    [sym_conditional] = STATE(10516),
    [sym_range] = STATE(10516),
    [sym_binary] = STATE(10516),
    [sym_unary] = STATE(10516),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9741] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10524),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(10524),
    [sym_operator_assignment] = STATE(10524),
    [sym_conditional] = STATE(10524),
    [sym_range] = STATE(10524),
    [sym_binary] = STATE(10524),
    [sym_unary] = STATE(10524),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9742] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10529),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(10529),
    [sym_operator_assignment] = STATE(10529),
    [sym_conditional] = STATE(10529),
    [sym_range] = STATE(10529),
    [sym_binary] = STATE(10529),
    [sym_unary] = STATE(10529),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9743] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10530),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10530),
    [sym_operator_assignment] = STATE(10530),
    [sym_conditional] = STATE(10530),
    [sym_range] = STATE(10530),
    [sym_binary] = STATE(10530),
    [sym_unary] = STATE(10530),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9744] = {
    [anon_sym_COLON] = ACTIONS(14096),
    [sym_comment] = ACTIONS(87),
  },
  [9745] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10533),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(10533),
    [sym_operator_assignment] = STATE(10533),
    [sym_conditional] = STATE(10533),
    [sym_range] = STATE(10533),
    [sym_binary] = STATE(10533),
    [sym_unary] = STATE(10533),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9746] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10497),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(1953),
    [sym__argument_list_with_parens] = STATE(10498),
    [sym__argument] = STATE(10499),
    [sym_splat_argument] = STATE(10499),
    [sym_hash_splat_argument] = STATE(10499),
    [sym_block_argument] = STATE(10499),
    [sym_assignment] = STATE(10497),
    [sym_operator_assignment] = STATE(10497),
    [sym_conditional] = STATE(10497),
    [sym_range] = STATE(10497),
    [sym_binary] = STATE(10497),
    [sym_unary] = STATE(10497),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10500),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10499),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14052),
    [sym__splat_star] = ACTIONS(14054),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(14056),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(14058),
    [sym_identifier] = ACTIONS(14058),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9747] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10497),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(1954),
    [sym__argument_list_with_parens] = STATE(10498),
    [sym__argument] = STATE(10499),
    [sym_splat_argument] = STATE(10499),
    [sym_hash_splat_argument] = STATE(10499),
    [sym_block_argument] = STATE(10499),
    [sym_assignment] = STATE(10497),
    [sym_operator_assignment] = STATE(10497),
    [sym_conditional] = STATE(10497),
    [sym_range] = STATE(10497),
    [sym_binary] = STATE(10497),
    [sym_unary] = STATE(10497),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10500),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10499),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14052),
    [sym__splat_star] = ACTIONS(14054),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(14056),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(14058),
    [sym_identifier] = ACTIONS(14058),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9748] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10497),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(1955),
    [sym__argument_list_with_parens] = STATE(10498),
    [sym__argument] = STATE(10499),
    [sym_splat_argument] = STATE(10499),
    [sym_hash_splat_argument] = STATE(10499),
    [sym_block_argument] = STATE(10499),
    [sym_assignment] = STATE(10497),
    [sym_operator_assignment] = STATE(10497),
    [sym_conditional] = STATE(10497),
    [sym_range] = STATE(10497),
    [sym_binary] = STATE(10497),
    [sym_unary] = STATE(10497),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10500),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10499),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14052),
    [sym__splat_star] = ACTIONS(14054),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(14056),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(14058),
    [sym_identifier] = ACTIONS(14058),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9749] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10497),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(1956),
    [sym__argument_list_with_parens] = STATE(10498),
    [sym__argument] = STATE(10499),
    [sym_splat_argument] = STATE(10499),
    [sym_hash_splat_argument] = STATE(10499),
    [sym_block_argument] = STATE(10499),
    [sym_assignment] = STATE(10497),
    [sym_operator_assignment] = STATE(10497),
    [sym_conditional] = STATE(10497),
    [sym_range] = STATE(10497),
    [sym_binary] = STATE(10497),
    [sym_unary] = STATE(10497),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10500),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10499),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14052),
    [sym__splat_star] = ACTIONS(14054),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(14056),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(14058),
    [sym_identifier] = ACTIONS(14058),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9750] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10534),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10534),
    [sym_operator_assignment] = STATE(10534),
    [sym_conditional] = STATE(10534),
    [sym_range] = STATE(10534),
    [sym_binary] = STATE(10534),
    [sym_unary] = STATE(10534),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9751] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(1978),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(1978),
    [sym_operator_assignment] = STATE(1978),
    [sym_conditional] = STATE(1978),
    [sym_range] = STATE(1978),
    [sym_binary] = STATE(1978),
    [sym_unary] = STATE(1978),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9752] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14098),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [9753] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(14096),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [9754] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10497),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(1998),
    [sym__argument_list_with_parens] = STATE(10498),
    [sym__argument] = STATE(10499),
    [sym_splat_argument] = STATE(10499),
    [sym_hash_splat_argument] = STATE(10499),
    [sym_block_argument] = STATE(10499),
    [sym_do_block] = STATE(1377),
    [sym_block] = STATE(1377),
    [sym_assignment] = STATE(10497),
    [sym_operator_assignment] = STATE(10497),
    [sym_conditional] = STATE(10497),
    [sym_range] = STATE(10497),
    [sym_binary] = STATE(10497),
    [sym_unary] = STATE(10497),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10500),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(10499),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14052),
    [sym__splat_star] = ACTIONS(14054),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(14056),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_EQ_GT] = ACTIONS(745),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(1199),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(14058),
    [sym_identifier] = ACTIONS(14058),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9755] = {
    [sym_heredoc_body] = STATE(10546),
    [aux_sym_call_repeat1] = STATE(10546),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [9756] = {
    [sym_heredoc_body] = STATE(10546),
    [aux_sym_call_repeat1] = STATE(10546),
    [aux_sym_argument_list_repeat1] = STATE(10548),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(14128),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [9757] = {
    [anon_sym_EQ] = ACTIONS(14130),
    [sym_comment] = ACTIONS(87),
  },
  [9758] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14132),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14134),
    [anon_sym_DASH_EQ] = ACTIONS(14134),
    [anon_sym_STAR_EQ] = ACTIONS(14134),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14134),
    [anon_sym_SLASH_EQ] = ACTIONS(14134),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14134),
    [anon_sym_PIPE_EQ] = ACTIONS(14134),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14134),
    [anon_sym_AMP_EQ] = ACTIONS(14134),
    [anon_sym_PERCENT_EQ] = ACTIONS(14134),
    [anon_sym_GT_GT_EQ] = ACTIONS(14134),
    [anon_sym_LT_LT_EQ] = ACTIONS(14134),
    [anon_sym_CARET_EQ] = ACTIONS(14134),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9759] = {
    [sym_string] = STATE(10551),
    [aux_sym_chained_string_repeat1] = STATE(10551),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14136),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [9760] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10553),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_splat_argument] = STATE(10554),
    [sym_assignment] = STATE(10553),
    [sym_operator_assignment] = STATE(10553),
    [sym_conditional] = STATE(10553),
    [sym_range] = STATE(10553),
    [sym_binary] = STATE(10553),
    [sym_unary] = STATE(10553),
    [sym_right_assignment_list] = STATE(2017),
    [sym__arg_or_splat_arg] = STATE(10554),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(14138),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9761] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10555),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10555),
    [sym_operator_assignment] = STATE(10555),
    [sym_conditional] = STATE(10555),
    [sym_range] = STATE(10555),
    [sym_binary] = STATE(10555),
    [sym_unary] = STATE(10555),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9762] = {
    [sym_string] = STATE(10556),
    [aux_sym_chained_string_repeat1] = STATE(10556),
    [sym__string_start] = ACTIONS(139),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [9763] = {
    [aux_sym_block_parameters_repeat1] = STATE(10557),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(13983),
    [sym_comment] = ACTIONS(87),
  },
  [9764] = {
    [sym_identifier] = ACTIONS(14140),
    [sym_comment] = ACTIONS(87),
  },
  [9765] = {
    [sym__formal_parameter] = STATE(6054),
    [sym__simple_formal_parameter] = STATE(6054),
    [sym_destructured_parameter] = STATE(6054),
    [sym_splat_parameter] = STATE(6054),
    [sym_hash_splat_parameter] = STATE(6054),
    [sym_block_parameter] = STATE(6054),
    [sym_keyword_parameter] = STATE(6054),
    [sym_optional_parameter] = STATE(6054),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5604),
    [sym_comment] = ACTIONS(87),
  },
  [9766] = {
    [sym__line_break] = ACTIONS(13979),
    [sym__simple_symbol] = ACTIONS(13979),
    [sym__string_start] = ACTIONS(13979),
    [sym__symbol_start] = ACTIONS(13979),
    [sym__subshell_start] = ACTIONS(13979),
    [sym__regex_start] = ACTIONS(13979),
    [sym__string_array_start] = ACTIONS(13979),
    [sym__symbol_array_start] = ACTIONS(13979),
    [sym__heredoc_body_start] = ACTIONS(13979),
    [sym_heredoc_beginning] = ACTIONS(13979),
    [sym__unary_minus] = ACTIONS(13979),
    [anon_sym_BEGIN] = ACTIONS(13981),
    [anon_sym_LBRACE] = ACTIONS(13979),
    [anon_sym_END] = ACTIONS(13981),
    [anon_sym_def] = ACTIONS(13981),
    [anon_sym_LPAREN] = ACTIONS(13979),
    [anon_sym_COLON_COLON] = ACTIONS(13979),
    [anon_sym_SEMI] = ACTIONS(13979),
    [anon_sym_STAR] = ACTIONS(13979),
    [anon_sym_class] = ACTIONS(13981),
    [anon_sym_module] = ACTIONS(13981),
    [anon_sym_end] = ACTIONS(13981),
    [anon_sym_return] = ACTIONS(13981),
    [anon_sym_yield] = ACTIONS(13981),
    [anon_sym_break] = ACTIONS(13981),
    [anon_sym_next] = ACTIONS(13981),
    [sym_redo] = ACTIONS(13981),
    [sym_retry] = ACTIONS(13981),
    [anon_sym_if] = ACTIONS(13981),
    [anon_sym_unless] = ACTIONS(13981),
    [anon_sym_while] = ACTIONS(13981),
    [anon_sym_until] = ACTIONS(13981),
    [anon_sym_for] = ACTIONS(13981),
    [anon_sym_case] = ACTIONS(13981),
    [anon_sym_begin] = ACTIONS(13981),
    [anon_sym_PLUS] = ACTIONS(13981),
    [anon_sym_defined_QMARK] = ACTIONS(13979),
    [anon_sym_not] = ACTIONS(13981),
    [anon_sym_BANG] = ACTIONS(13979),
    [anon_sym_TILDE] = ACTIONS(13979),
    [sym_constant] = ACTIONS(13981),
    [sym_identifier] = ACTIONS(13981),
    [sym_instance_variable] = ACTIONS(13979),
    [sym_class_variable] = ACTIONS(13979),
    [sym_global_variable] = ACTIONS(13979),
    [anon_sym_undef] = ACTIONS(13981),
    [anon_sym_alias] = ACTIONS(13981),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13981),
    [sym_float] = ACTIONS(13981),
    [sym_complex] = ACTIONS(13979),
    [sym_super] = ACTIONS(13981),
    [anon_sym_true] = ACTIONS(13981),
    [anon_sym_TRUE] = ACTIONS(13981),
    [anon_sym_false] = ACTIONS(13981),
    [anon_sym_FALSE] = ACTIONS(13981),
    [sym_self] = ACTIONS(13981),
    [anon_sym_nil] = ACTIONS(13981),
    [anon_sym_NIL] = ACTIONS(13981),
    [sym_character] = ACTIONS(13979),
    [anon_sym_LBRACK2] = ACTIONS(13979),
    [anon_sym_DASH_GT] = ACTIONS(13979),
  },
  [9767] = {
    [aux_sym_block_parameters_repeat1] = STATE(9709),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(14142),
    [sym_comment] = ACTIONS(87),
  },
  [9768] = {
    [aux_sym_block_parameters_repeat1] = STATE(10560),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(14142),
    [sym_comment] = ACTIONS(87),
  },
  [9769] = {
    [sym_identifier] = ACTIONS(14144),
    [sym_comment] = ACTIONS(87),
  },
  [9770] = {
    [sym__line_break] = ACTIONS(14146),
    [sym__heredoc_body_start] = ACTIONS(14146),
    [sym__binary_minus] = ACTIONS(14146),
    [sym__binary_star] = ACTIONS(14146),
    [ts_builtin_sym_end] = ACTIONS(14146),
    [anon_sym___END__] = ACTIONS(14146),
    [anon_sym_LBRACE] = ACTIONS(14146),
    [anon_sym_RBRACE] = ACTIONS(14146),
    [anon_sym_RPAREN] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14148),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14148),
    [anon_sym_SEMI] = ACTIONS(14146),
    [anon_sym_STAR_STAR] = ACTIONS(14146),
    [anon_sym_AMP] = ACTIONS(14148),
    [anon_sym_LT] = ACTIONS(14148),
    [anon_sym_end] = ACTIONS(14146),
    [anon_sym_if] = ACTIONS(14146),
    [anon_sym_unless] = ACTIONS(14146),
    [anon_sym_while] = ACTIONS(14146),
    [anon_sym_until] = ACTIONS(14146),
    [anon_sym_rescue] = ACTIONS(14146),
    [anon_sym_do] = ACTIONS(14146),
    [anon_sym_when] = ACTIONS(14146),
    [anon_sym_elsif] = ACTIONS(14146),
    [anon_sym_else] = ACTIONS(14146),
    [anon_sym_then] = ACTIONS(14146),
    [anon_sym_ensure] = ACTIONS(14146),
    [anon_sym_EQ_GT] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [anon_sym_QMARK] = ACTIONS(14146),
    [anon_sym_DOT_DOT] = ACTIONS(14148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14146),
    [anon_sym_and] = ACTIONS(14146),
    [anon_sym_or] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE] = ACTIONS(14146),
    [anon_sym_AMP_AMP] = ACTIONS(14146),
    [anon_sym_LT_LT] = ACTIONS(14146),
    [anon_sym_GT_GT] = ACTIONS(14146),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_BANG_EQ] = ACTIONS(14146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14146),
    [anon_sym_LT_EQ_GT] = ACTIONS(14146),
    [anon_sym_EQ_TILDE] = ACTIONS(14146),
    [anon_sym_BANG_TILDE] = ACTIONS(14146),
    [anon_sym_LT_EQ] = ACTIONS(14148),
    [anon_sym_GT] = ACTIONS(14148),
    [anon_sym_GT_EQ] = ACTIONS(14146),
    [anon_sym_CARET] = ACTIONS(14146),
    [anon_sym_PLUS] = ACTIONS(14146),
    [anon_sym_SLASH] = ACTIONS(14146),
    [anon_sym_PERCENT] = ACTIONS(14146),
    [sym_comment] = ACTIONS(87),
  },
  [9771] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10562),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_assignment] = STATE(10562),
    [sym_operator_assignment] = STATE(10562),
    [sym_conditional] = STATE(10562),
    [sym_range] = STATE(10562),
    [sym_binary] = STATE(10562),
    [sym_unary] = STATE(10562),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9772] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(9212),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(9214),
    [anon_sym_DOT_DOT] = ACTIONS(9216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9218),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(9222),
    [anon_sym_AMP_AMP] = ACTIONS(9222),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(9226),
    [anon_sym_BANG_EQ] = ACTIONS(9222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9222),
    [anon_sym_LT_EQ_GT] = ACTIONS(9222),
    [anon_sym_EQ_TILDE] = ACTIONS(9222),
    [anon_sym_BANG_TILDE] = ACTIONS(9222),
    [anon_sym_LT_EQ] = ACTIONS(9212),
    [anon_sym_GT] = ACTIONS(9212),
    [anon_sym_GT_EQ] = ACTIONS(9228),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [9773] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(8342),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3477),
    [sym_scope_resolution] = STATE(3475),
    [sym_call] = STATE(3475),
    [sym_method_call] = STATE(3477),
    [sym_splat_argument] = STATE(6835),
    [sym_assignment] = STATE(8342),
    [sym_operator_assignment] = STATE(8342),
    [sym_conditional] = STATE(8342),
    [sym_range] = STATE(8342),
    [sym_binary] = STATE(8342),
    [sym_unary] = STATE(8342),
    [sym__arg_or_splat_arg] = STATE(6835),
    [sym_left_assignment_list] = STATE(3476),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3477),
    [sym__variable] = STATE(3475),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3477),
    [sym_false] = STATE(3477),
    [sym_nil] = STATE(3477),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3478),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(11690),
    [sym__unary_minus] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(5646),
    [anon_sym_break] = ACTIONS(5648),
    [anon_sym_next] = ACTIONS(5650),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_defined_QMARK] = ACTIONS(5656),
    [anon_sym_not] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [sym_constant] = ACTIONS(5662),
    [sym_identifier] = ACTIONS(5662),
    [sym_instance_variable] = ACTIONS(5664),
    [sym_class_variable] = ACTIONS(5664),
    [sym_global_variable] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(5662),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(5662),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9774] = {
    [aux_sym_exceptions_repeat1] = STATE(10563),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(14150),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9775] = {
    [sym_heredoc_body] = STATE(10564),
    [aux_sym_call_repeat1] = STATE(10564),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_COLON2] = ACTIONS(4248),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9776] = {
    [sym_heredoc_body] = STATE(10565),
    [aux_sym_call_repeat1] = STATE(10565),
    [aux_sym_argument_list_repeat1] = STATE(8396),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(9323),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_COLON2] = ACTIONS(4248),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [9777] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [9778] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9779] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [9780] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [9781] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [9782] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14152),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9783] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COLON2] = ACTIONS(7620),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [9784] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11702),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [9785] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [9786] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [9787] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11702),
    [anon_sym_COLON2] = ACTIONS(7668),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [9788] = {
    [aux_sym_exceptions_repeat1] = STATE(10568),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_COLON2] = ACTIONS(6062),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9789] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11702),
    [anon_sym_COLON2] = ACTIONS(7670),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [9790] = {
    [sym_string] = STATE(9790),
    [aux_sym_chained_string_repeat1] = STATE(9790),
    [sym__string_start] = ACTIONS(12380),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_COLON2] = ACTIONS(6081),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [9791] = {
    [sym__string_start] = ACTIONS(2895),
    [sym__heredoc_body_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_STAR_STAR] = ACTIONS(2895),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_EQ_GT] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON2] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2895),
    [anon_sym_AMP_AMP] = ACTIONS(2895),
    [anon_sym_LT_LT] = ACTIONS(2895),
    [anon_sym_GT_GT] = ACTIONS(2895),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2895),
    [anon_sym_PERCENT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(87),
  },
  [9792] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(7554),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [9793] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(7616),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [9794] = {
    [sym_heredoc_body] = STATE(9794),
    [aux_sym_call_repeat1] = STATE(9794),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_COLON2] = ACTIONS(7651),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9795] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6106),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(6106),
    [sym_operator_assignment] = STATE(6106),
    [sym_conditional] = STATE(6106),
    [sym_range] = STATE(6106),
    [sym_binary] = STATE(6106),
    [sym_unary] = STATE(6106),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6109),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(9279),
    [sym__splat_star] = ACTIONS(9281),
    [sym__unary_minus] = ACTIONS(5706),
    [sym__identifier_hash_key] = ACTIONS(9283),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13274),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(9285),
    [sym_identifier] = ACTIONS(9285),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9796] = {
    [sym_heredoc_body] = STATE(9794),
    [aux_sym_call_repeat1] = STATE(9794),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_COLON2] = ACTIONS(7663),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9797] = {
    [aux_sym_argument_list_repeat1] = STATE(9797),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14154),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_COLON2] = ACTIONS(7659),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [9798] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10569),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_assignment] = STATE(10569),
    [sym_operator_assignment] = STATE(10569),
    [sym_conditional] = STATE(10569),
    [sym_range] = STATE(10569),
    [sym_binary] = STATE(10569),
    [sym_unary] = STATE(10569),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9799] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(7554),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [9800] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(7616),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [9801] = {
    [sym_heredoc_body] = STATE(9801),
    [aux_sym_call_repeat1] = STATE(9801),
    [sym__heredoc_body_start] = ACTIONS(10154),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_COLON2] = ACTIONS(7651),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [9802] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(6127),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym__argument] = STATE(6822),
    [sym_splat_argument] = STATE(6822),
    [sym_hash_splat_argument] = STATE(6822),
    [sym_block_argument] = STATE(6822),
    [sym_assignment] = STATE(6127),
    [sym_operator_assignment] = STATE(6127),
    [sym_conditional] = STATE(6127),
    [sym_range] = STATE(6127),
    [sym_binary] = STATE(6127),
    [sym_unary] = STATE(6127),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6130),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6822),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(9315),
    [sym__splat_star] = ACTIONS(9317),
    [sym__unary_minus] = ACTIONS(5766),
    [sym__identifier_hash_key] = ACTIONS(9319),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13278),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(9321),
    [sym_identifier] = ACTIONS(9321),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9803] = {
    [sym_heredoc_body] = STATE(9801),
    [aux_sym_call_repeat1] = STATE(9801),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_COLON2] = ACTIONS(7663),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [9804] = {
    [aux_sym_argument_list_repeat1] = STATE(9804),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14157),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_COLON2] = ACTIONS(7659),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [9805] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(8397),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(3504),
    [sym_scope_resolution] = STATE(3500),
    [sym_call] = STATE(3500),
    [sym_method_call] = STATE(3504),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(8397),
    [sym_operator_assignment] = STATE(8397),
    [sym_conditional] = STATE(8397),
    [sym_range] = STATE(8397),
    [sym_binary] = STATE(8397),
    [sym_unary] = STATE(8397),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(3503),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3504),
    [sym__variable] = STATE(3500),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(3504),
    [sym_false] = STATE(3504),
    [sym_nil] = STATE(3504),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6098),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(9273),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(9281),
    [sym__unary_minus] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5710),
    [anon_sym_yield] = ACTIONS(5712),
    [anon_sym_break] = ACTIONS(5714),
    [anon_sym_next] = ACTIONS(5716),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9275),
    [anon_sym_defined_QMARK] = ACTIONS(5718),
    [anon_sym_not] = ACTIONS(5720),
    [anon_sym_BANG] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [sym_constant] = ACTIONS(5730),
    [sym_identifier] = ACTIONS(5730),
    [sym_instance_variable] = ACTIONS(5728),
    [sym_class_variable] = ACTIONS(5728),
    [sym_global_variable] = ACTIONS(5728),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5730),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5730),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9806] = {
    [aux_sym_exceptions_repeat1] = STATE(10570),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14160),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_COLON2] = ACTIONS(9605),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9807] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(11746),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9808] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [9809] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [9810] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [9811] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [9812] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [9813] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14162),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9814] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COLON2] = ACTIONS(7620),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [9815] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11760),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [9816] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [9817] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5698),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [9818] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(11760),
    [anon_sym_COLON2] = ACTIONS(7668),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [9819] = {
    [aux_sym_exceptions_repeat1] = STATE(10573),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_COLON2] = ACTIONS(6062),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [9820] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11760),
    [anon_sym_COLON2] = ACTIONS(7670),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [9821] = {
    [sym_string] = STATE(9821),
    [aux_sym_chained_string_repeat1] = STATE(9821),
    [sym__string_start] = ACTIONS(13427),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_COLON2] = ACTIONS(6081),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [9822] = {
    [sym__string_start] = ACTIONS(2895),
    [sym__heredoc_body_start] = ACTIONS(2895),
    [sym__binary_minus] = ACTIONS(2895),
    [sym__binary_star] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_PIPE] = ACTIONS(2897),
    [anon_sym_STAR_STAR] = ACTIONS(2897),
    [anon_sym_AMP] = ACTIONS(2897),
    [anon_sym_EQ] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_EQ_GT] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_COLON_COLON2] = ACTIONS(2895),
    [anon_sym_AMP_DOT] = ACTIONS(2895),
    [anon_sym_PLUS_EQ] = ACTIONS(2895),
    [anon_sym_DASH_EQ] = ACTIONS(2895),
    [anon_sym_STAR_EQ] = ACTIONS(2895),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2895),
    [anon_sym_SLASH_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_PIPE_EQ] = ACTIONS(2895),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2895),
    [anon_sym_AMP_EQ] = ACTIONS(2895),
    [anon_sym_PERCENT_EQ] = ACTIONS(2895),
    [anon_sym_GT_GT_EQ] = ACTIONS(2895),
    [anon_sym_LT_LT_EQ] = ACTIONS(2895),
    [anon_sym_CARET_EQ] = ACTIONS(2895),
    [anon_sym_QMARK] = ACTIONS(2895),
    [anon_sym_COLON2] = ACTIONS(2897),
    [anon_sym_DOT_DOT] = ACTIONS(2897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2895),
    [anon_sym_and] = ACTIONS(2895),
    [anon_sym_or] = ACTIONS(2895),
    [anon_sym_PIPE_PIPE] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2897),
    [anon_sym_LT_LT] = ACTIONS(2897),
    [anon_sym_GT_GT] = ACTIONS(2897),
    [anon_sym_EQ_EQ] = ACTIONS(2897),
    [anon_sym_BANG_EQ] = ACTIONS(2895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2895),
    [anon_sym_LT_EQ_GT] = ACTIONS(2895),
    [anon_sym_EQ_TILDE] = ACTIONS(2895),
    [anon_sym_BANG_TILDE] = ACTIONS(2895),
    [anon_sym_LT_EQ] = ACTIONS(2897),
    [anon_sym_GT] = ACTIONS(2897),
    [anon_sym_GT_EQ] = ACTIONS(2895),
    [anon_sym_CARET] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_PERCENT] = ACTIONS(2897),
    [sym_comment] = ACTIONS(87),
  },
  [9823] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10574),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_assignment] = STATE(10574),
    [sym_operator_assignment] = STATE(10574),
    [sym_conditional] = STATE(10574),
    [sym_range] = STATE(10574),
    [sym_binary] = STATE(10574),
    [sym_unary] = STATE(10574),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9824] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(8435),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(3535),
    [sym_scope_resolution] = STATE(3531),
    [sym_call] = STATE(3531),
    [sym_method_call] = STATE(3535),
    [sym_splat_argument] = STATE(8821),
    [sym_assignment] = STATE(8435),
    [sym_operator_assignment] = STATE(8435),
    [sym_conditional] = STATE(8435),
    [sym_range] = STATE(8435),
    [sym_binary] = STATE(8435),
    [sym_unary] = STATE(8435),
    [sym__arg_or_splat_arg] = STATE(8821),
    [sym_left_assignment_list] = STATE(3534),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3535),
    [sym__variable] = STATE(3531),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(3535),
    [sym_false] = STATE(3535),
    [sym_nil] = STATE(3535),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(6163),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(9355),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(9317),
    [sym__unary_minus] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(5770),
    [anon_sym_yield] = ACTIONS(5772),
    [anon_sym_break] = ACTIONS(5774),
    [anon_sym_next] = ACTIONS(5776),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(9357),
    [anon_sym_defined_QMARK] = ACTIONS(5778),
    [anon_sym_not] = ACTIONS(5780),
    [anon_sym_BANG] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [sym_constant] = ACTIONS(5790),
    [sym_identifier] = ACTIONS(5790),
    [sym_instance_variable] = ACTIONS(5788),
    [sym_class_variable] = ACTIONS(5788),
    [sym_global_variable] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(5790),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5790),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [9825] = {
    [aux_sym_exceptions_repeat1] = STATE(10575),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14164),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_COLON2] = ACTIONS(9605),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9826] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [9827] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9828] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(11792),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [9829] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [9830] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11790),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(11792),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11810),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [9831] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14166),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9832] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11790),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(11792),
    [anon_sym_LT] = ACTIONS(11794),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_COLON2] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11800),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11802),
    [anon_sym_AMP_AMP] = ACTIONS(11802),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(11806),
    [anon_sym_BANG_EQ] = ACTIONS(11802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11802),
    [anon_sym_LT_EQ_GT] = ACTIONS(11802),
    [anon_sym_EQ_TILDE] = ACTIONS(11802),
    [anon_sym_BANG_TILDE] = ACTIONS(11802),
    [anon_sym_LT_EQ] = ACTIONS(11794),
    [anon_sym_GT] = ACTIONS(11794),
    [anon_sym_GT_EQ] = ACTIONS(11808),
    [anon_sym_CARET] = ACTIONS(11810),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [9833] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11790),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(11792),
    [anon_sym_LT] = ACTIONS(11794),
    [anon_sym_QMARK] = ACTIONS(11796),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(11798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11800),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11802),
    [anon_sym_AMP_AMP] = ACTIONS(11802),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(11806),
    [anon_sym_BANG_EQ] = ACTIONS(11802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11802),
    [anon_sym_LT_EQ_GT] = ACTIONS(11802),
    [anon_sym_EQ_TILDE] = ACTIONS(11802),
    [anon_sym_BANG_TILDE] = ACTIONS(11802),
    [anon_sym_LT_EQ] = ACTIONS(11794),
    [anon_sym_GT] = ACTIONS(11794),
    [anon_sym_GT_EQ] = ACTIONS(11808),
    [anon_sym_CARET] = ACTIONS(11810),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [9834] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11790),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(11792),
    [anon_sym_LT] = ACTIONS(11794),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(11806),
    [anon_sym_BANG_EQ] = ACTIONS(11802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11802),
    [anon_sym_LT_EQ_GT] = ACTIONS(11802),
    [anon_sym_EQ_TILDE] = ACTIONS(11802),
    [anon_sym_BANG_TILDE] = ACTIONS(11802),
    [anon_sym_LT_EQ] = ACTIONS(11794),
    [anon_sym_GT] = ACTIONS(11794),
    [anon_sym_GT_EQ] = ACTIONS(11808),
    [anon_sym_CARET] = ACTIONS(11810),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [9835] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_COLON2] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [9836] = {
    [aux_sym_exceptions_repeat1] = STATE(9836),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(14168),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9837] = {
    [aux_sym_exceptions_repeat1] = STATE(8453),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_COLON2] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9838] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11790),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(11792),
    [anon_sym_LT] = ACTIONS(11794),
    [anon_sym_QMARK] = ACTIONS(11796),
    [anon_sym_COLON2] = ACTIONS(6074),
    [anon_sym_DOT_DOT] = ACTIONS(11798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11800),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11802),
    [anon_sym_AMP_AMP] = ACTIONS(11802),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(11806),
    [anon_sym_BANG_EQ] = ACTIONS(11802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11802),
    [anon_sym_LT_EQ_GT] = ACTIONS(11802),
    [anon_sym_EQ_TILDE] = ACTIONS(11802),
    [anon_sym_BANG_TILDE] = ACTIONS(11802),
    [anon_sym_LT_EQ] = ACTIONS(11794),
    [anon_sym_GT] = ACTIONS(11794),
    [anon_sym_GT_EQ] = ACTIONS(11808),
    [anon_sym_CARET] = ACTIONS(11810),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [9839] = {
    [sym_string] = STATE(9839),
    [aux_sym_chained_string_repeat1] = STATE(9839),
    [sym__string_start] = ACTIONS(11820),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_COLON2] = ACTIONS(6081),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [9840] = {
    [sym__line_break] = ACTIONS(12069),
    [sym__heredoc_body_start] = ACTIONS(12069),
    [sym__binary_minus] = ACTIONS(12069),
    [sym__binary_star] = ACTIONS(12069),
    [ts_builtin_sym_end] = ACTIONS(12069),
    [anon_sym___END__] = ACTIONS(12069),
    [anon_sym_LBRACE] = ACTIONS(12069),
    [anon_sym_RBRACE] = ACTIONS(12069),
    [anon_sym_RPAREN] = ACTIONS(12069),
    [anon_sym_DOT] = ACTIONS(12071),
    [anon_sym_COMMA] = ACTIONS(12069),
    [anon_sym_PIPE] = ACTIONS(12071),
    [anon_sym_SEMI] = ACTIONS(12069),
    [anon_sym_STAR_STAR] = ACTIONS(12071),
    [anon_sym_AMP] = ACTIONS(12071),
    [anon_sym_EQ] = ACTIONS(12071),
    [anon_sym_LT] = ACTIONS(12071),
    [anon_sym_end] = ACTIONS(12069),
    [anon_sym_if] = ACTIONS(12069),
    [anon_sym_unless] = ACTIONS(12069),
    [anon_sym_while] = ACTIONS(12069),
    [anon_sym_until] = ACTIONS(12069),
    [anon_sym_rescue] = ACTIONS(12069),
    [anon_sym_do] = ACTIONS(12069),
    [anon_sym_when] = ACTIONS(12069),
    [anon_sym_elsif] = ACTIONS(12069),
    [anon_sym_else] = ACTIONS(12069),
    [anon_sym_then] = ACTIONS(12069),
    [anon_sym_ensure] = ACTIONS(12069),
    [anon_sym_EQ_GT] = ACTIONS(12069),
    [anon_sym_LBRACK] = ACTIONS(12069),
    [anon_sym_COLON_COLON2] = ACTIONS(12069),
    [anon_sym_AMP_DOT] = ACTIONS(12069),
    [anon_sym_PLUS_EQ] = ACTIONS(12069),
    [anon_sym_DASH_EQ] = ACTIONS(12069),
    [anon_sym_STAR_EQ] = ACTIONS(12069),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12069),
    [anon_sym_SLASH_EQ] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12069),
    [anon_sym_PIPE_EQ] = ACTIONS(12069),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12069),
    [anon_sym_AMP_EQ] = ACTIONS(12069),
    [anon_sym_PERCENT_EQ] = ACTIONS(12069),
    [anon_sym_GT_GT_EQ] = ACTIONS(12069),
    [anon_sym_LT_LT_EQ] = ACTIONS(12069),
    [anon_sym_CARET_EQ] = ACTIONS(12069),
    [anon_sym_QMARK] = ACTIONS(12069),
    [anon_sym_DOT_DOT] = ACTIONS(12071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12069),
    [anon_sym_and] = ACTIONS(12069),
    [anon_sym_or] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE] = ACTIONS(12071),
    [anon_sym_AMP_AMP] = ACTIONS(12071),
    [anon_sym_LT_LT] = ACTIONS(12071),
    [anon_sym_GT_GT] = ACTIONS(12071),
    [anon_sym_EQ_EQ] = ACTIONS(12071),
    [anon_sym_BANG_EQ] = ACTIONS(12069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12069),
    [anon_sym_LT_EQ_GT] = ACTIONS(12069),
    [anon_sym_EQ_TILDE] = ACTIONS(12069),
    [anon_sym_BANG_TILDE] = ACTIONS(12069),
    [anon_sym_LT_EQ] = ACTIONS(12071),
    [anon_sym_GT] = ACTIONS(12071),
    [anon_sym_GT_EQ] = ACTIONS(12069),
    [anon_sym_CARET] = ACTIONS(12071),
    [anon_sym_PLUS] = ACTIONS(12071),
    [anon_sym_SLASH] = ACTIONS(12071),
    [anon_sym_PERCENT] = ACTIONS(12071),
    [sym_comment] = ACTIONS(87),
  },
  [9841] = {
    [sym__line_break] = ACTIONS(12073),
    [sym__heredoc_body_start] = ACTIONS(12073),
    [sym__binary_minus] = ACTIONS(12073),
    [sym__binary_star] = ACTIONS(12073),
    [ts_builtin_sym_end] = ACTIONS(12073),
    [anon_sym___END__] = ACTIONS(12073),
    [anon_sym_LBRACE] = ACTIONS(12073),
    [anon_sym_RBRACE] = ACTIONS(12073),
    [anon_sym_RPAREN] = ACTIONS(12073),
    [anon_sym_DOT] = ACTIONS(12075),
    [anon_sym_COMMA] = ACTIONS(12073),
    [anon_sym_PIPE] = ACTIONS(12075),
    [anon_sym_SEMI] = ACTIONS(12073),
    [anon_sym_STAR_STAR] = ACTIONS(12075),
    [anon_sym_AMP] = ACTIONS(12075),
    [anon_sym_EQ] = ACTIONS(12075),
    [anon_sym_LT] = ACTIONS(12075),
    [anon_sym_end] = ACTIONS(12073),
    [anon_sym_if] = ACTIONS(12073),
    [anon_sym_unless] = ACTIONS(12073),
    [anon_sym_while] = ACTIONS(12073),
    [anon_sym_until] = ACTIONS(12073),
    [anon_sym_rescue] = ACTIONS(12073),
    [anon_sym_do] = ACTIONS(12073),
    [anon_sym_when] = ACTIONS(12073),
    [anon_sym_elsif] = ACTIONS(12073),
    [anon_sym_else] = ACTIONS(12073),
    [anon_sym_then] = ACTIONS(12073),
    [anon_sym_ensure] = ACTIONS(12073),
    [anon_sym_EQ_GT] = ACTIONS(12073),
    [anon_sym_LBRACK] = ACTIONS(12073),
    [anon_sym_COLON_COLON2] = ACTIONS(12073),
    [anon_sym_AMP_DOT] = ACTIONS(12073),
    [anon_sym_PLUS_EQ] = ACTIONS(12073),
    [anon_sym_DASH_EQ] = ACTIONS(12073),
    [anon_sym_STAR_EQ] = ACTIONS(12073),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12073),
    [anon_sym_SLASH_EQ] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12073),
    [anon_sym_PIPE_EQ] = ACTIONS(12073),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12073),
    [anon_sym_AMP_EQ] = ACTIONS(12073),
    [anon_sym_PERCENT_EQ] = ACTIONS(12073),
    [anon_sym_GT_GT_EQ] = ACTIONS(12073),
    [anon_sym_LT_LT_EQ] = ACTIONS(12073),
    [anon_sym_CARET_EQ] = ACTIONS(12073),
    [anon_sym_QMARK] = ACTIONS(12073),
    [anon_sym_DOT_DOT] = ACTIONS(12075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12073),
    [anon_sym_and] = ACTIONS(12073),
    [anon_sym_or] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE] = ACTIONS(12075),
    [anon_sym_AMP_AMP] = ACTIONS(12075),
    [anon_sym_LT_LT] = ACTIONS(12075),
    [anon_sym_GT_GT] = ACTIONS(12075),
    [anon_sym_EQ_EQ] = ACTIONS(12075),
    [anon_sym_BANG_EQ] = ACTIONS(12073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12073),
    [anon_sym_LT_EQ_GT] = ACTIONS(12073),
    [anon_sym_EQ_TILDE] = ACTIONS(12073),
    [anon_sym_BANG_TILDE] = ACTIONS(12073),
    [anon_sym_LT_EQ] = ACTIONS(12075),
    [anon_sym_GT] = ACTIONS(12075),
    [anon_sym_GT_EQ] = ACTIONS(12073),
    [anon_sym_CARET] = ACTIONS(12075),
    [anon_sym_PLUS] = ACTIONS(12075),
    [anon_sym_SLASH] = ACTIONS(12075),
    [anon_sym_PERCENT] = ACTIONS(12075),
    [sym_comment] = ACTIONS(87),
  },
  [9842] = {
    [sym__line_break] = ACTIONS(9793),
    [sym__heredoc_body_start] = ACTIONS(9793),
    [sym__binary_minus] = ACTIONS(9793),
    [sym__binary_star] = ACTIONS(9793),
    [ts_builtin_sym_end] = ACTIONS(9793),
    [anon_sym___END__] = ACTIONS(9793),
    [anon_sym_LBRACE] = ACTIONS(9793),
    [anon_sym_RBRACE] = ACTIONS(9793),
    [anon_sym_RPAREN] = ACTIONS(9793),
    [anon_sym_DOT] = ACTIONS(9795),
    [anon_sym_COMMA] = ACTIONS(9793),
    [anon_sym_PIPE] = ACTIONS(9795),
    [anon_sym_SEMI] = ACTIONS(9793),
    [anon_sym_STAR_STAR] = ACTIONS(9795),
    [anon_sym_AMP] = ACTIONS(9795),
    [anon_sym_EQ] = ACTIONS(9795),
    [anon_sym_LT] = ACTIONS(9795),
    [anon_sym_end] = ACTIONS(9793),
    [anon_sym_if] = ACTIONS(9793),
    [anon_sym_unless] = ACTIONS(9793),
    [anon_sym_while] = ACTIONS(9793),
    [anon_sym_until] = ACTIONS(9793),
    [anon_sym_rescue] = ACTIONS(9793),
    [anon_sym_do] = ACTIONS(9793),
    [anon_sym_when] = ACTIONS(9793),
    [anon_sym_elsif] = ACTIONS(9793),
    [anon_sym_else] = ACTIONS(9793),
    [anon_sym_then] = ACTIONS(9793),
    [anon_sym_ensure] = ACTIONS(9793),
    [anon_sym_LBRACK] = ACTIONS(9793),
    [anon_sym_COLON_COLON2] = ACTIONS(9793),
    [anon_sym_AMP_DOT] = ACTIONS(9793),
    [anon_sym_PLUS_EQ] = ACTIONS(9793),
    [anon_sym_DASH_EQ] = ACTIONS(9793),
    [anon_sym_STAR_EQ] = ACTIONS(9793),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9793),
    [anon_sym_SLASH_EQ] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9793),
    [anon_sym_PIPE_EQ] = ACTIONS(9793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9793),
    [anon_sym_AMP_EQ] = ACTIONS(9793),
    [anon_sym_PERCENT_EQ] = ACTIONS(9793),
    [anon_sym_GT_GT_EQ] = ACTIONS(9793),
    [anon_sym_LT_LT_EQ] = ACTIONS(9793),
    [anon_sym_CARET_EQ] = ACTIONS(9793),
    [anon_sym_QMARK] = ACTIONS(9793),
    [anon_sym_DOT_DOT] = ACTIONS(9795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9793),
    [anon_sym_and] = ACTIONS(9793),
    [anon_sym_or] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE] = ACTIONS(9795),
    [anon_sym_AMP_AMP] = ACTIONS(9795),
    [anon_sym_LT_LT] = ACTIONS(9795),
    [anon_sym_GT_GT] = ACTIONS(9795),
    [anon_sym_EQ_EQ] = ACTIONS(9795),
    [anon_sym_BANG_EQ] = ACTIONS(9793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9793),
    [anon_sym_LT_EQ_GT] = ACTIONS(9793),
    [anon_sym_EQ_TILDE] = ACTIONS(9793),
    [anon_sym_BANG_TILDE] = ACTIONS(9793),
    [anon_sym_LT_EQ] = ACTIONS(9795),
    [anon_sym_GT] = ACTIONS(9795),
    [anon_sym_GT_EQ] = ACTIONS(9793),
    [anon_sym_CARET] = ACTIONS(9795),
    [anon_sym_PLUS] = ACTIONS(9795),
    [anon_sym_SLASH] = ACTIONS(9795),
    [anon_sym_PERCENT] = ACTIONS(9795),
    [sym_comment] = ACTIONS(87),
  },
  [9843] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14171),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9844] = {
    [sym__line_break] = ACTIONS(9799),
    [sym__heredoc_body_start] = ACTIONS(9799),
    [sym__binary_minus] = ACTIONS(9799),
    [sym__binary_star] = ACTIONS(9799),
    [ts_builtin_sym_end] = ACTIONS(9799),
    [anon_sym___END__] = ACTIONS(9799),
    [anon_sym_LBRACE] = ACTIONS(9799),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [anon_sym_RPAREN] = ACTIONS(9799),
    [anon_sym_DOT] = ACTIONS(9801),
    [anon_sym_COMMA] = ACTIONS(9799),
    [anon_sym_PIPE] = ACTIONS(9801),
    [anon_sym_SEMI] = ACTIONS(9799),
    [anon_sym_STAR_STAR] = ACTIONS(9801),
    [anon_sym_AMP] = ACTIONS(9801),
    [anon_sym_EQ] = ACTIONS(9801),
    [anon_sym_LT] = ACTIONS(9801),
    [anon_sym_end] = ACTIONS(9799),
    [anon_sym_if] = ACTIONS(9799),
    [anon_sym_unless] = ACTIONS(9799),
    [anon_sym_while] = ACTIONS(9799),
    [anon_sym_until] = ACTIONS(9799),
    [anon_sym_rescue] = ACTIONS(9799),
    [anon_sym_do] = ACTIONS(9799),
    [anon_sym_when] = ACTIONS(9799),
    [anon_sym_elsif] = ACTIONS(9799),
    [anon_sym_else] = ACTIONS(9799),
    [anon_sym_then] = ACTIONS(9799),
    [anon_sym_ensure] = ACTIONS(9799),
    [anon_sym_LBRACK] = ACTIONS(9799),
    [anon_sym_COLON_COLON2] = ACTIONS(9799),
    [anon_sym_AMP_DOT] = ACTIONS(9799),
    [anon_sym_PLUS_EQ] = ACTIONS(9799),
    [anon_sym_DASH_EQ] = ACTIONS(9799),
    [anon_sym_STAR_EQ] = ACTIONS(9799),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9799),
    [anon_sym_SLASH_EQ] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9799),
    [anon_sym_PIPE_EQ] = ACTIONS(9799),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9799),
    [anon_sym_AMP_EQ] = ACTIONS(9799),
    [anon_sym_PERCENT_EQ] = ACTIONS(9799),
    [anon_sym_GT_GT_EQ] = ACTIONS(9799),
    [anon_sym_LT_LT_EQ] = ACTIONS(9799),
    [anon_sym_CARET_EQ] = ACTIONS(9799),
    [anon_sym_QMARK] = ACTIONS(9799),
    [anon_sym_DOT_DOT] = ACTIONS(9801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9799),
    [anon_sym_and] = ACTIONS(9799),
    [anon_sym_or] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE] = ACTIONS(9801),
    [anon_sym_AMP_AMP] = ACTIONS(9801),
    [anon_sym_LT_LT] = ACTIONS(9801),
    [anon_sym_GT_GT] = ACTIONS(9801),
    [anon_sym_EQ_EQ] = ACTIONS(9801),
    [anon_sym_BANG_EQ] = ACTIONS(9799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9799),
    [anon_sym_LT_EQ_GT] = ACTIONS(9799),
    [anon_sym_EQ_TILDE] = ACTIONS(9799),
    [anon_sym_BANG_TILDE] = ACTIONS(9799),
    [anon_sym_LT_EQ] = ACTIONS(9801),
    [anon_sym_GT] = ACTIONS(9801),
    [anon_sym_GT_EQ] = ACTIONS(9799),
    [anon_sym_CARET] = ACTIONS(9801),
    [anon_sym_PLUS] = ACTIONS(9801),
    [anon_sym_SLASH] = ACTIONS(9801),
    [anon_sym_PERCENT] = ACTIONS(9801),
    [sym_comment] = ACTIONS(87),
  },
  [9845] = {
    [sym__line_break] = ACTIONS(9803),
    [sym__heredoc_body_start] = ACTIONS(9803),
    [sym__binary_minus] = ACTIONS(9803),
    [sym__binary_star] = ACTIONS(9803),
    [ts_builtin_sym_end] = ACTIONS(9803),
    [anon_sym___END__] = ACTIONS(9803),
    [anon_sym_LBRACE] = ACTIONS(9803),
    [anon_sym_RBRACE] = ACTIONS(9803),
    [anon_sym_RPAREN] = ACTIONS(9803),
    [anon_sym_DOT] = ACTIONS(9805),
    [anon_sym_COMMA] = ACTIONS(9803),
    [anon_sym_PIPE] = ACTIONS(9805),
    [anon_sym_SEMI] = ACTIONS(9803),
    [anon_sym_STAR_STAR] = ACTIONS(9805),
    [anon_sym_AMP] = ACTIONS(9805),
    [anon_sym_EQ] = ACTIONS(9805),
    [anon_sym_LT] = ACTIONS(9805),
    [anon_sym_end] = ACTIONS(9803),
    [anon_sym_if] = ACTIONS(9803),
    [anon_sym_unless] = ACTIONS(9803),
    [anon_sym_while] = ACTIONS(9803),
    [anon_sym_until] = ACTIONS(9803),
    [anon_sym_rescue] = ACTIONS(9803),
    [anon_sym_do] = ACTIONS(9803),
    [anon_sym_when] = ACTIONS(9803),
    [anon_sym_elsif] = ACTIONS(9803),
    [anon_sym_else] = ACTIONS(9803),
    [anon_sym_then] = ACTIONS(9803),
    [anon_sym_ensure] = ACTIONS(9803),
    [anon_sym_LBRACK] = ACTIONS(9803),
    [anon_sym_COLON_COLON2] = ACTIONS(9803),
    [anon_sym_AMP_DOT] = ACTIONS(9803),
    [anon_sym_PLUS_EQ] = ACTIONS(9803),
    [anon_sym_DASH_EQ] = ACTIONS(9803),
    [anon_sym_STAR_EQ] = ACTIONS(9803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9803),
    [anon_sym_SLASH_EQ] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9803),
    [anon_sym_PIPE_EQ] = ACTIONS(9803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9803),
    [anon_sym_AMP_EQ] = ACTIONS(9803),
    [anon_sym_PERCENT_EQ] = ACTIONS(9803),
    [anon_sym_GT_GT_EQ] = ACTIONS(9803),
    [anon_sym_LT_LT_EQ] = ACTIONS(9803),
    [anon_sym_CARET_EQ] = ACTIONS(9803),
    [anon_sym_QMARK] = ACTIONS(9803),
    [anon_sym_DOT_DOT] = ACTIONS(9805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9803),
    [anon_sym_and] = ACTIONS(9803),
    [anon_sym_or] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE] = ACTIONS(9805),
    [anon_sym_AMP_AMP] = ACTIONS(9805),
    [anon_sym_LT_LT] = ACTIONS(9805),
    [anon_sym_GT_GT] = ACTIONS(9805),
    [anon_sym_EQ_EQ] = ACTIONS(9805),
    [anon_sym_BANG_EQ] = ACTIONS(9803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9803),
    [anon_sym_LT_EQ_GT] = ACTIONS(9803),
    [anon_sym_EQ_TILDE] = ACTIONS(9803),
    [anon_sym_BANG_TILDE] = ACTIONS(9803),
    [anon_sym_LT_EQ] = ACTIONS(9805),
    [anon_sym_GT] = ACTIONS(9805),
    [anon_sym_GT_EQ] = ACTIONS(9803),
    [anon_sym_CARET] = ACTIONS(9805),
    [anon_sym_PLUS] = ACTIONS(9805),
    [anon_sym_SLASH] = ACTIONS(9805),
    [anon_sym_PERCENT] = ACTIONS(9805),
    [sym_comment] = ACTIONS(87),
  },
  [9846] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14173),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9847] = {
    [sym__line_break] = ACTIONS(9809),
    [sym__heredoc_body_start] = ACTIONS(9809),
    [sym__binary_minus] = ACTIONS(9809),
    [sym__binary_star] = ACTIONS(9809),
    [ts_builtin_sym_end] = ACTIONS(9809),
    [anon_sym___END__] = ACTIONS(9809),
    [anon_sym_LBRACE] = ACTIONS(9809),
    [anon_sym_RBRACE] = ACTIONS(9809),
    [anon_sym_RPAREN] = ACTIONS(9809),
    [anon_sym_DOT] = ACTIONS(9811),
    [anon_sym_COMMA] = ACTIONS(9809),
    [anon_sym_PIPE] = ACTIONS(9811),
    [anon_sym_SEMI] = ACTIONS(9809),
    [anon_sym_STAR_STAR] = ACTIONS(9811),
    [anon_sym_AMP] = ACTIONS(9811),
    [anon_sym_EQ] = ACTIONS(9811),
    [anon_sym_LT] = ACTIONS(9811),
    [anon_sym_end] = ACTIONS(9809),
    [anon_sym_if] = ACTIONS(9809),
    [anon_sym_unless] = ACTIONS(9809),
    [anon_sym_while] = ACTIONS(9809),
    [anon_sym_until] = ACTIONS(9809),
    [anon_sym_rescue] = ACTIONS(9809),
    [anon_sym_do] = ACTIONS(9809),
    [anon_sym_when] = ACTIONS(9809),
    [anon_sym_elsif] = ACTIONS(9809),
    [anon_sym_else] = ACTIONS(9809),
    [anon_sym_then] = ACTIONS(9809),
    [anon_sym_ensure] = ACTIONS(9809),
    [anon_sym_LBRACK] = ACTIONS(9809),
    [anon_sym_COLON_COLON2] = ACTIONS(9809),
    [anon_sym_AMP_DOT] = ACTIONS(9809),
    [anon_sym_PLUS_EQ] = ACTIONS(9809),
    [anon_sym_DASH_EQ] = ACTIONS(9809),
    [anon_sym_STAR_EQ] = ACTIONS(9809),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9809),
    [anon_sym_SLASH_EQ] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9809),
    [anon_sym_PIPE_EQ] = ACTIONS(9809),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9809),
    [anon_sym_AMP_EQ] = ACTIONS(9809),
    [anon_sym_PERCENT_EQ] = ACTIONS(9809),
    [anon_sym_GT_GT_EQ] = ACTIONS(9809),
    [anon_sym_LT_LT_EQ] = ACTIONS(9809),
    [anon_sym_CARET_EQ] = ACTIONS(9809),
    [anon_sym_QMARK] = ACTIONS(9809),
    [anon_sym_DOT_DOT] = ACTIONS(9811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9809),
    [anon_sym_and] = ACTIONS(9809),
    [anon_sym_or] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE] = ACTIONS(9811),
    [anon_sym_AMP_AMP] = ACTIONS(9811),
    [anon_sym_LT_LT] = ACTIONS(9811),
    [anon_sym_GT_GT] = ACTIONS(9811),
    [anon_sym_EQ_EQ] = ACTIONS(9811),
    [anon_sym_BANG_EQ] = ACTIONS(9809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9809),
    [anon_sym_LT_EQ_GT] = ACTIONS(9809),
    [anon_sym_EQ_TILDE] = ACTIONS(9809),
    [anon_sym_BANG_TILDE] = ACTIONS(9809),
    [anon_sym_LT_EQ] = ACTIONS(9811),
    [anon_sym_GT] = ACTIONS(9811),
    [anon_sym_GT_EQ] = ACTIONS(9809),
    [anon_sym_CARET] = ACTIONS(9811),
    [anon_sym_PLUS] = ACTIONS(9811),
    [anon_sym_SLASH] = ACTIONS(9811),
    [anon_sym_PERCENT] = ACTIONS(9811),
    [sym_comment] = ACTIONS(87),
  },
  [9848] = {
    [sym__method_rest] = STATE(10579),
    [sym_operator] = STATE(3586),
    [sym__method_name] = STATE(3586),
    [sym_setter] = STATE(3586),
    [sym_symbol] = STATE(3586),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(11865),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(11865),
    [sym_class_variable] = ACTIONS(11865),
    [sym_global_variable] = ACTIONS(11865),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [9849] = {
    [sym__line_break] = ACTIONS(10532),
    [sym__heredoc_body_start] = ACTIONS(10532),
    [sym__binary_minus] = ACTIONS(10532),
    [sym__binary_star] = ACTIONS(10532),
    [ts_builtin_sym_end] = ACTIONS(10532),
    [anon_sym___END__] = ACTIONS(10532),
    [anon_sym_LBRACE] = ACTIONS(10532),
    [anon_sym_RBRACE] = ACTIONS(10532),
    [anon_sym_RPAREN] = ACTIONS(10532),
    [anon_sym_DOT] = ACTIONS(10534),
    [anon_sym_COMMA] = ACTIONS(10532),
    [anon_sym_PIPE] = ACTIONS(10534),
    [anon_sym_SEMI] = ACTIONS(10532),
    [anon_sym_STAR_STAR] = ACTIONS(10534),
    [anon_sym_AMP] = ACTIONS(10534),
    [anon_sym_EQ] = ACTIONS(10534),
    [anon_sym_LT] = ACTIONS(10534),
    [anon_sym_end] = ACTIONS(10532),
    [anon_sym_if] = ACTIONS(10532),
    [anon_sym_unless] = ACTIONS(10532),
    [anon_sym_while] = ACTIONS(10532),
    [anon_sym_until] = ACTIONS(10532),
    [anon_sym_rescue] = ACTIONS(10532),
    [anon_sym_do] = ACTIONS(10532),
    [anon_sym_when] = ACTIONS(10532),
    [anon_sym_elsif] = ACTIONS(10532),
    [anon_sym_else] = ACTIONS(10532),
    [anon_sym_then] = ACTIONS(10532),
    [anon_sym_ensure] = ACTIONS(10532),
    [anon_sym_LBRACK] = ACTIONS(10532),
    [anon_sym_COLON_COLON2] = ACTIONS(10532),
    [anon_sym_AMP_DOT] = ACTIONS(10532),
    [anon_sym_PLUS_EQ] = ACTIONS(10532),
    [anon_sym_DASH_EQ] = ACTIONS(10532),
    [anon_sym_STAR_EQ] = ACTIONS(10532),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10532),
    [anon_sym_SLASH_EQ] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10532),
    [anon_sym_PIPE_EQ] = ACTIONS(10532),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10532),
    [anon_sym_AMP_EQ] = ACTIONS(10532),
    [anon_sym_PERCENT_EQ] = ACTIONS(10532),
    [anon_sym_GT_GT_EQ] = ACTIONS(10532),
    [anon_sym_LT_LT_EQ] = ACTIONS(10532),
    [anon_sym_CARET_EQ] = ACTIONS(10532),
    [anon_sym_QMARK] = ACTIONS(10532),
    [anon_sym_DOT_DOT] = ACTIONS(10534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10532),
    [anon_sym_and] = ACTIONS(10532),
    [anon_sym_or] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE] = ACTIONS(10534),
    [anon_sym_AMP_AMP] = ACTIONS(10534),
    [anon_sym_LT_LT] = ACTIONS(10534),
    [anon_sym_GT_GT] = ACTIONS(10534),
    [anon_sym_EQ_EQ] = ACTIONS(10534),
    [anon_sym_BANG_EQ] = ACTIONS(10532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10532),
    [anon_sym_LT_EQ_GT] = ACTIONS(10532),
    [anon_sym_EQ_TILDE] = ACTIONS(10532),
    [anon_sym_BANG_TILDE] = ACTIONS(10532),
    [anon_sym_LT_EQ] = ACTIONS(10534),
    [anon_sym_GT] = ACTIONS(10534),
    [anon_sym_GT_EQ] = ACTIONS(10532),
    [anon_sym_CARET] = ACTIONS(10534),
    [anon_sym_PLUS] = ACTIONS(10534),
    [anon_sym_SLASH] = ACTIONS(10534),
    [anon_sym_PERCENT] = ACTIONS(10534),
    [sym_comment] = ACTIONS(87),
  },
  [9850] = {
    [sym__line_break] = ACTIONS(10536),
    [sym__heredoc_body_start] = ACTIONS(10536),
    [sym__binary_minus] = ACTIONS(10536),
    [sym__binary_star] = ACTIONS(10536),
    [ts_builtin_sym_end] = ACTIONS(10536),
    [anon_sym___END__] = ACTIONS(10536),
    [anon_sym_LBRACE] = ACTIONS(10536),
    [anon_sym_RBRACE] = ACTIONS(10536),
    [anon_sym_RPAREN] = ACTIONS(10536),
    [anon_sym_DOT] = ACTIONS(10538),
    [anon_sym_COMMA] = ACTIONS(10536),
    [anon_sym_PIPE] = ACTIONS(10538),
    [anon_sym_SEMI] = ACTIONS(10536),
    [anon_sym_STAR_STAR] = ACTIONS(10538),
    [anon_sym_AMP] = ACTIONS(10538),
    [anon_sym_EQ] = ACTIONS(10538),
    [anon_sym_LT] = ACTIONS(10538),
    [anon_sym_end] = ACTIONS(10536),
    [anon_sym_if] = ACTIONS(10536),
    [anon_sym_unless] = ACTIONS(10536),
    [anon_sym_while] = ACTIONS(10536),
    [anon_sym_until] = ACTIONS(10536),
    [anon_sym_rescue] = ACTIONS(10536),
    [anon_sym_do] = ACTIONS(10536),
    [anon_sym_when] = ACTIONS(10536),
    [anon_sym_elsif] = ACTIONS(10536),
    [anon_sym_else] = ACTIONS(10536),
    [anon_sym_then] = ACTIONS(10536),
    [anon_sym_ensure] = ACTIONS(10536),
    [anon_sym_LBRACK] = ACTIONS(10536),
    [anon_sym_COLON_COLON2] = ACTIONS(10536),
    [anon_sym_AMP_DOT] = ACTIONS(10536),
    [anon_sym_PLUS_EQ] = ACTIONS(10536),
    [anon_sym_DASH_EQ] = ACTIONS(10536),
    [anon_sym_STAR_EQ] = ACTIONS(10536),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10536),
    [anon_sym_SLASH_EQ] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10536),
    [anon_sym_PIPE_EQ] = ACTIONS(10536),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10536),
    [anon_sym_AMP_EQ] = ACTIONS(10536),
    [anon_sym_PERCENT_EQ] = ACTIONS(10536),
    [anon_sym_GT_GT_EQ] = ACTIONS(10536),
    [anon_sym_LT_LT_EQ] = ACTIONS(10536),
    [anon_sym_CARET_EQ] = ACTIONS(10536),
    [anon_sym_QMARK] = ACTIONS(10536),
    [anon_sym_DOT_DOT] = ACTIONS(10538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10536),
    [anon_sym_and] = ACTIONS(10536),
    [anon_sym_or] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE] = ACTIONS(10538),
    [anon_sym_AMP_AMP] = ACTIONS(10538),
    [anon_sym_LT_LT] = ACTIONS(10538),
    [anon_sym_GT_GT] = ACTIONS(10538),
    [anon_sym_EQ_EQ] = ACTIONS(10538),
    [anon_sym_BANG_EQ] = ACTIONS(10536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10536),
    [anon_sym_LT_EQ_GT] = ACTIONS(10536),
    [anon_sym_EQ_TILDE] = ACTIONS(10536),
    [anon_sym_BANG_TILDE] = ACTIONS(10536),
    [anon_sym_LT_EQ] = ACTIONS(10538),
    [anon_sym_GT] = ACTIONS(10538),
    [anon_sym_GT_EQ] = ACTIONS(10536),
    [anon_sym_CARET] = ACTIONS(10538),
    [anon_sym_PLUS] = ACTIONS(10538),
    [anon_sym_SLASH] = ACTIONS(10538),
    [anon_sym_PERCENT] = ACTIONS(10538),
    [sym_comment] = ACTIONS(87),
  },
  [9851] = {
    [sym__line_break] = ACTIONS(10689),
    [sym__heredoc_body_start] = ACTIONS(10689),
    [sym__binary_minus] = ACTIONS(10689),
    [sym__binary_star] = ACTIONS(10689),
    [ts_builtin_sym_end] = ACTIONS(10689),
    [anon_sym___END__] = ACTIONS(10689),
    [anon_sym_LBRACE] = ACTIONS(10689),
    [anon_sym_RBRACE] = ACTIONS(10689),
    [anon_sym_RPAREN] = ACTIONS(10689),
    [anon_sym_DOT] = ACTIONS(10691),
    [anon_sym_COMMA] = ACTIONS(10689),
    [anon_sym_PIPE] = ACTIONS(10691),
    [anon_sym_SEMI] = ACTIONS(10689),
    [anon_sym_STAR_STAR] = ACTIONS(10691),
    [anon_sym_AMP] = ACTIONS(10691),
    [anon_sym_EQ] = ACTIONS(10691),
    [anon_sym_LT] = ACTIONS(10691),
    [anon_sym_end] = ACTIONS(10689),
    [anon_sym_if] = ACTIONS(10689),
    [anon_sym_unless] = ACTIONS(10689),
    [anon_sym_while] = ACTIONS(10689),
    [anon_sym_until] = ACTIONS(10689),
    [anon_sym_rescue] = ACTIONS(10689),
    [anon_sym_do] = ACTIONS(10689),
    [anon_sym_when] = ACTIONS(10689),
    [anon_sym_elsif] = ACTIONS(10689),
    [anon_sym_else] = ACTIONS(10689),
    [anon_sym_then] = ACTIONS(10689),
    [anon_sym_ensure] = ACTIONS(10689),
    [anon_sym_LBRACK] = ACTIONS(10689),
    [anon_sym_COLON_COLON2] = ACTIONS(10689),
    [anon_sym_AMP_DOT] = ACTIONS(10689),
    [anon_sym_PLUS_EQ] = ACTIONS(10689),
    [anon_sym_DASH_EQ] = ACTIONS(10689),
    [anon_sym_STAR_EQ] = ACTIONS(10689),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10689),
    [anon_sym_SLASH_EQ] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10689),
    [anon_sym_PIPE_EQ] = ACTIONS(10689),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10689),
    [anon_sym_AMP_EQ] = ACTIONS(10689),
    [anon_sym_PERCENT_EQ] = ACTIONS(10689),
    [anon_sym_GT_GT_EQ] = ACTIONS(10689),
    [anon_sym_LT_LT_EQ] = ACTIONS(10689),
    [anon_sym_CARET_EQ] = ACTIONS(10689),
    [anon_sym_QMARK] = ACTIONS(10689),
    [anon_sym_DOT_DOT] = ACTIONS(10691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10689),
    [anon_sym_and] = ACTIONS(10689),
    [anon_sym_or] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE] = ACTIONS(10691),
    [anon_sym_AMP_AMP] = ACTIONS(10691),
    [anon_sym_LT_LT] = ACTIONS(10691),
    [anon_sym_GT_GT] = ACTIONS(10691),
    [anon_sym_EQ_EQ] = ACTIONS(10691),
    [anon_sym_BANG_EQ] = ACTIONS(10689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10689),
    [anon_sym_LT_EQ_GT] = ACTIONS(10689),
    [anon_sym_EQ_TILDE] = ACTIONS(10689),
    [anon_sym_BANG_TILDE] = ACTIONS(10689),
    [anon_sym_LT_EQ] = ACTIONS(10691),
    [anon_sym_GT] = ACTIONS(10691),
    [anon_sym_GT_EQ] = ACTIONS(10689),
    [anon_sym_CARET] = ACTIONS(10691),
    [anon_sym_PLUS] = ACTIONS(10691),
    [anon_sym_SLASH] = ACTIONS(10691),
    [anon_sym_PERCENT] = ACTIONS(10691),
    [sym_comment] = ACTIONS(87),
  },
  [9852] = {
    [anon_sym_end] = ACTIONS(14175),
    [sym_comment] = ACTIONS(87),
  },
  [9853] = {
    [sym_elsif] = STATE(10581),
    [sym_else] = STATE(10581),
    [sym__if_tail] = STATE(10581),
    [anon_sym_end] = ACTIONS(14175),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [9854] = {
    [sym__line_break] = ACTIONS(10856),
    [sym__heredoc_body_start] = ACTIONS(10856),
    [sym__binary_minus] = ACTIONS(10856),
    [sym__binary_star] = ACTIONS(10856),
    [ts_builtin_sym_end] = ACTIONS(10856),
    [anon_sym___END__] = ACTIONS(10856),
    [anon_sym_LBRACE] = ACTIONS(10856),
    [anon_sym_RBRACE] = ACTIONS(10856),
    [anon_sym_RPAREN] = ACTIONS(10856),
    [anon_sym_DOT] = ACTIONS(10858),
    [anon_sym_COMMA] = ACTIONS(10856),
    [anon_sym_PIPE] = ACTIONS(10858),
    [anon_sym_SEMI] = ACTIONS(10856),
    [anon_sym_STAR_STAR] = ACTIONS(10858),
    [anon_sym_AMP] = ACTIONS(10858),
    [anon_sym_EQ] = ACTIONS(10858),
    [anon_sym_LT] = ACTIONS(10858),
    [anon_sym_end] = ACTIONS(10856),
    [anon_sym_if] = ACTIONS(10856),
    [anon_sym_unless] = ACTIONS(10856),
    [anon_sym_while] = ACTIONS(10856),
    [anon_sym_until] = ACTIONS(10856),
    [anon_sym_rescue] = ACTIONS(10856),
    [anon_sym_do] = ACTIONS(10856),
    [anon_sym_when] = ACTIONS(10856),
    [anon_sym_elsif] = ACTIONS(10856),
    [anon_sym_else] = ACTIONS(10856),
    [anon_sym_then] = ACTIONS(10856),
    [anon_sym_ensure] = ACTIONS(10856),
    [anon_sym_LBRACK] = ACTIONS(10856),
    [anon_sym_COLON_COLON2] = ACTIONS(10856),
    [anon_sym_AMP_DOT] = ACTIONS(10856),
    [anon_sym_PLUS_EQ] = ACTIONS(10856),
    [anon_sym_DASH_EQ] = ACTIONS(10856),
    [anon_sym_STAR_EQ] = ACTIONS(10856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10856),
    [anon_sym_SLASH_EQ] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10856),
    [anon_sym_PIPE_EQ] = ACTIONS(10856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10856),
    [anon_sym_AMP_EQ] = ACTIONS(10856),
    [anon_sym_PERCENT_EQ] = ACTIONS(10856),
    [anon_sym_GT_GT_EQ] = ACTIONS(10856),
    [anon_sym_LT_LT_EQ] = ACTIONS(10856),
    [anon_sym_CARET_EQ] = ACTIONS(10856),
    [anon_sym_QMARK] = ACTIONS(10856),
    [anon_sym_DOT_DOT] = ACTIONS(10858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10856),
    [anon_sym_and] = ACTIONS(10856),
    [anon_sym_or] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE] = ACTIONS(10858),
    [anon_sym_AMP_AMP] = ACTIONS(10858),
    [anon_sym_LT_LT] = ACTIONS(10858),
    [anon_sym_GT_GT] = ACTIONS(10858),
    [anon_sym_EQ_EQ] = ACTIONS(10858),
    [anon_sym_BANG_EQ] = ACTIONS(10856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10856),
    [anon_sym_LT_EQ_GT] = ACTIONS(10856),
    [anon_sym_EQ_TILDE] = ACTIONS(10856),
    [anon_sym_BANG_TILDE] = ACTIONS(10856),
    [anon_sym_LT_EQ] = ACTIONS(10858),
    [anon_sym_GT] = ACTIONS(10858),
    [anon_sym_GT_EQ] = ACTIONS(10856),
    [anon_sym_CARET] = ACTIONS(10858),
    [anon_sym_PLUS] = ACTIONS(10858),
    [anon_sym_SLASH] = ACTIONS(10858),
    [anon_sym_PERCENT] = ACTIONS(10858),
    [sym_comment] = ACTIONS(87),
  },
  [9855] = {
    [anon_sym_end] = ACTIONS(14177),
    [sym_comment] = ACTIONS(87),
  },
  [9856] = {
    [sym__line_break] = ACTIONS(10951),
    [sym__heredoc_body_start] = ACTIONS(10951),
    [sym__binary_minus] = ACTIONS(10951),
    [sym__binary_star] = ACTIONS(10951),
    [ts_builtin_sym_end] = ACTIONS(10951),
    [anon_sym___END__] = ACTIONS(10951),
    [anon_sym_LBRACE] = ACTIONS(10951),
    [anon_sym_RBRACE] = ACTIONS(10951),
    [anon_sym_RPAREN] = ACTIONS(10951),
    [anon_sym_DOT] = ACTIONS(10953),
    [anon_sym_COMMA] = ACTIONS(10951),
    [anon_sym_PIPE] = ACTIONS(10953),
    [anon_sym_SEMI] = ACTIONS(10951),
    [anon_sym_STAR_STAR] = ACTIONS(10953),
    [anon_sym_AMP] = ACTIONS(10953),
    [anon_sym_EQ] = ACTIONS(10953),
    [anon_sym_LT] = ACTIONS(10953),
    [anon_sym_end] = ACTIONS(10951),
    [anon_sym_if] = ACTIONS(10951),
    [anon_sym_unless] = ACTIONS(10951),
    [anon_sym_while] = ACTIONS(10951),
    [anon_sym_until] = ACTIONS(10951),
    [anon_sym_rescue] = ACTIONS(10951),
    [anon_sym_do] = ACTIONS(10951),
    [anon_sym_when] = ACTIONS(10951),
    [anon_sym_elsif] = ACTIONS(10951),
    [anon_sym_else] = ACTIONS(10951),
    [anon_sym_then] = ACTIONS(10951),
    [anon_sym_ensure] = ACTIONS(10951),
    [anon_sym_LBRACK] = ACTIONS(10951),
    [anon_sym_COLON_COLON2] = ACTIONS(10951),
    [anon_sym_AMP_DOT] = ACTIONS(10951),
    [anon_sym_PLUS_EQ] = ACTIONS(10951),
    [anon_sym_DASH_EQ] = ACTIONS(10951),
    [anon_sym_STAR_EQ] = ACTIONS(10951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10951),
    [anon_sym_SLASH_EQ] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10951),
    [anon_sym_PIPE_EQ] = ACTIONS(10951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10951),
    [anon_sym_AMP_EQ] = ACTIONS(10951),
    [anon_sym_PERCENT_EQ] = ACTIONS(10951),
    [anon_sym_GT_GT_EQ] = ACTIONS(10951),
    [anon_sym_LT_LT_EQ] = ACTIONS(10951),
    [anon_sym_CARET_EQ] = ACTIONS(10951),
    [anon_sym_QMARK] = ACTIONS(10951),
    [anon_sym_DOT_DOT] = ACTIONS(10953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10951),
    [anon_sym_and] = ACTIONS(10951),
    [anon_sym_or] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE] = ACTIONS(10953),
    [anon_sym_AMP_AMP] = ACTIONS(10953),
    [anon_sym_LT_LT] = ACTIONS(10953),
    [anon_sym_GT_GT] = ACTIONS(10953),
    [anon_sym_EQ_EQ] = ACTIONS(10953),
    [anon_sym_BANG_EQ] = ACTIONS(10951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10951),
    [anon_sym_LT_EQ_GT] = ACTIONS(10951),
    [anon_sym_EQ_TILDE] = ACTIONS(10951),
    [anon_sym_BANG_TILDE] = ACTIONS(10951),
    [anon_sym_LT_EQ] = ACTIONS(10953),
    [anon_sym_GT] = ACTIONS(10953),
    [anon_sym_GT_EQ] = ACTIONS(10951),
    [anon_sym_CARET] = ACTIONS(10953),
    [anon_sym_PLUS] = ACTIONS(10953),
    [anon_sym_SLASH] = ACTIONS(10953),
    [anon_sym_PERCENT] = ACTIONS(10953),
    [sym_comment] = ACTIONS(87),
  },
  [9857] = {
    [sym__line_break] = ACTIONS(10960),
    [sym__heredoc_body_start] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10960),
    [ts_builtin_sym_end] = ACTIONS(10960),
    [anon_sym___END__] = ACTIONS(10960),
    [anon_sym_LBRACE] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10960),
    [anon_sym_RPAREN] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [anon_sym_AMP] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10962),
    [anon_sym_end] = ACTIONS(10960),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_when] = ACTIONS(10960),
    [anon_sym_elsif] = ACTIONS(10960),
    [anon_sym_else] = ACTIONS(10960),
    [anon_sym_then] = ACTIONS(10960),
    [anon_sym_ensure] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10960),
    [anon_sym_COLON_COLON2] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10960),
    [anon_sym_PLUS_EQ] = ACTIONS(10960),
    [anon_sym_DASH_EQ] = ACTIONS(10960),
    [anon_sym_STAR_EQ] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_EQ] = ACTIONS(10960),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10960),
    [anon_sym_PERCENT_EQ] = ACTIONS(10960),
    [anon_sym_GT_GT_EQ] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10960),
    [anon_sym_CARET_EQ] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10962),
    [anon_sym_GT] = ACTIONS(10962),
    [anon_sym_GT_EQ] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10962),
    [anon_sym_PLUS] = ACTIONS(10962),
    [anon_sym_SLASH] = ACTIONS(10962),
    [anon_sym_PERCENT] = ACTIONS(10962),
    [sym_comment] = ACTIONS(87),
  },
  [9858] = {
    [sym__line_break] = ACTIONS(11007),
    [sym__heredoc_body_start] = ACTIONS(11007),
    [sym__binary_minus] = ACTIONS(11007),
    [sym__binary_star] = ACTIONS(11007),
    [ts_builtin_sym_end] = ACTIONS(11007),
    [anon_sym___END__] = ACTIONS(11007),
    [anon_sym_LBRACE] = ACTIONS(11007),
    [anon_sym_RBRACE] = ACTIONS(11007),
    [anon_sym_RPAREN] = ACTIONS(11007),
    [anon_sym_DOT] = ACTIONS(11009),
    [anon_sym_COMMA] = ACTIONS(11007),
    [anon_sym_PIPE] = ACTIONS(11009),
    [anon_sym_SEMI] = ACTIONS(11007),
    [anon_sym_STAR_STAR] = ACTIONS(11009),
    [anon_sym_AMP] = ACTIONS(11009),
    [anon_sym_EQ] = ACTIONS(11009),
    [anon_sym_LT] = ACTIONS(11009),
    [anon_sym_end] = ACTIONS(11007),
    [anon_sym_if] = ACTIONS(11007),
    [anon_sym_unless] = ACTIONS(11007),
    [anon_sym_while] = ACTIONS(11007),
    [anon_sym_until] = ACTIONS(11007),
    [anon_sym_rescue] = ACTIONS(11007),
    [anon_sym_do] = ACTIONS(11007),
    [anon_sym_when] = ACTIONS(11007),
    [anon_sym_elsif] = ACTIONS(11007),
    [anon_sym_else] = ACTIONS(11007),
    [anon_sym_then] = ACTIONS(11007),
    [anon_sym_ensure] = ACTIONS(11007),
    [anon_sym_LBRACK] = ACTIONS(11007),
    [anon_sym_COLON_COLON2] = ACTIONS(11007),
    [anon_sym_AMP_DOT] = ACTIONS(11007),
    [anon_sym_PLUS_EQ] = ACTIONS(11007),
    [anon_sym_DASH_EQ] = ACTIONS(11007),
    [anon_sym_STAR_EQ] = ACTIONS(11007),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11007),
    [anon_sym_SLASH_EQ] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11007),
    [anon_sym_PIPE_EQ] = ACTIONS(11007),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11007),
    [anon_sym_AMP_EQ] = ACTIONS(11007),
    [anon_sym_PERCENT_EQ] = ACTIONS(11007),
    [anon_sym_GT_GT_EQ] = ACTIONS(11007),
    [anon_sym_LT_LT_EQ] = ACTIONS(11007),
    [anon_sym_CARET_EQ] = ACTIONS(11007),
    [anon_sym_QMARK] = ACTIONS(11007),
    [anon_sym_DOT_DOT] = ACTIONS(11009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11007),
    [anon_sym_and] = ACTIONS(11007),
    [anon_sym_or] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE] = ACTIONS(11009),
    [anon_sym_AMP_AMP] = ACTIONS(11009),
    [anon_sym_LT_LT] = ACTIONS(11009),
    [anon_sym_GT_GT] = ACTIONS(11009),
    [anon_sym_EQ_EQ] = ACTIONS(11009),
    [anon_sym_BANG_EQ] = ACTIONS(11007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11007),
    [anon_sym_LT_EQ_GT] = ACTIONS(11007),
    [anon_sym_EQ_TILDE] = ACTIONS(11007),
    [anon_sym_BANG_TILDE] = ACTIONS(11007),
    [anon_sym_LT_EQ] = ACTIONS(11009),
    [anon_sym_GT] = ACTIONS(11009),
    [anon_sym_GT_EQ] = ACTIONS(11007),
    [anon_sym_CARET] = ACTIONS(11009),
    [anon_sym_PLUS] = ACTIONS(11009),
    [anon_sym_SLASH] = ACTIONS(11009),
    [anon_sym_PERCENT] = ACTIONS(11009),
    [sym_comment] = ACTIONS(87),
  },
  [9859] = {
    [anon_sym_end] = ACTIONS(14179),
    [sym_comment] = ACTIONS(87),
  },
  [9860] = {
    [sym__line_break] = ACTIONS(11020),
    [sym__heredoc_body_start] = ACTIONS(11020),
    [sym__binary_minus] = ACTIONS(11020),
    [sym__binary_star] = ACTIONS(11020),
    [ts_builtin_sym_end] = ACTIONS(11020),
    [anon_sym___END__] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_RBRACE] = ACTIONS(11020),
    [anon_sym_RPAREN] = ACTIONS(11020),
    [anon_sym_DOT] = ACTIONS(11022),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_PIPE] = ACTIONS(11022),
    [anon_sym_SEMI] = ACTIONS(11020),
    [anon_sym_STAR_STAR] = ACTIONS(11022),
    [anon_sym_AMP] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(11022),
    [anon_sym_LT] = ACTIONS(11022),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_unless] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [anon_sym_until] = ACTIONS(11020),
    [anon_sym_rescue] = ACTIONS(11020),
    [anon_sym_do] = ACTIONS(11020),
    [anon_sym_when] = ACTIONS(11020),
    [anon_sym_elsif] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_then] = ACTIONS(11020),
    [anon_sym_ensure] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_COLON_COLON2] = ACTIONS(11020),
    [anon_sym_AMP_DOT] = ACTIONS(11020),
    [anon_sym_PLUS_EQ] = ACTIONS(11020),
    [anon_sym_DASH_EQ] = ACTIONS(11020),
    [anon_sym_STAR_EQ] = ACTIONS(11020),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11020),
    [anon_sym_SLASH_EQ] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11020),
    [anon_sym_PIPE_EQ] = ACTIONS(11020),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11020),
    [anon_sym_AMP_EQ] = ACTIONS(11020),
    [anon_sym_PERCENT_EQ] = ACTIONS(11020),
    [anon_sym_GT_GT_EQ] = ACTIONS(11020),
    [anon_sym_LT_LT_EQ] = ACTIONS(11020),
    [anon_sym_CARET_EQ] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_DOT_DOT] = ACTIONS(11022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_and] = ACTIONS(11020),
    [anon_sym_or] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE] = ACTIONS(11022),
    [anon_sym_AMP_AMP] = ACTIONS(11022),
    [anon_sym_LT_LT] = ACTIONS(11022),
    [anon_sym_GT_GT] = ACTIONS(11022),
    [anon_sym_EQ_EQ] = ACTIONS(11022),
    [anon_sym_BANG_EQ] = ACTIONS(11020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11020),
    [anon_sym_LT_EQ_GT] = ACTIONS(11020),
    [anon_sym_EQ_TILDE] = ACTIONS(11020),
    [anon_sym_BANG_TILDE] = ACTIONS(11020),
    [anon_sym_LT_EQ] = ACTIONS(11022),
    [anon_sym_GT] = ACTIONS(11022),
    [anon_sym_GT_EQ] = ACTIONS(11020),
    [anon_sym_CARET] = ACTIONS(11022),
    [anon_sym_PLUS] = ACTIONS(11022),
    [anon_sym_SLASH] = ACTIONS(11022),
    [anon_sym_PERCENT] = ACTIONS(11022),
    [sym_comment] = ACTIONS(87),
  },
  [9861] = {
    [anon_sym_end] = ACTIONS(14181),
    [sym_comment] = ACTIONS(87),
  },
  [9862] = {
    [sym__line_break] = ACTIONS(11466),
    [sym__heredoc_body_start] = ACTIONS(11466),
    [sym__binary_minus] = ACTIONS(11466),
    [sym__binary_star] = ACTIONS(11466),
    [ts_builtin_sym_end] = ACTIONS(11466),
    [anon_sym___END__] = ACTIONS(11466),
    [anon_sym_LBRACE] = ACTIONS(11466),
    [anon_sym_RBRACE] = ACTIONS(11466),
    [anon_sym_RPAREN] = ACTIONS(11466),
    [anon_sym_DOT] = ACTIONS(11468),
    [anon_sym_COMMA] = ACTIONS(11466),
    [anon_sym_PIPE] = ACTIONS(11468),
    [anon_sym_SEMI] = ACTIONS(11466),
    [anon_sym_STAR_STAR] = ACTIONS(11468),
    [anon_sym_AMP] = ACTIONS(11468),
    [anon_sym_EQ] = ACTIONS(11468),
    [anon_sym_LT] = ACTIONS(11468),
    [anon_sym_end] = ACTIONS(11466),
    [anon_sym_if] = ACTIONS(11466),
    [anon_sym_unless] = ACTIONS(11466),
    [anon_sym_while] = ACTIONS(11466),
    [anon_sym_until] = ACTIONS(11466),
    [anon_sym_rescue] = ACTIONS(11466),
    [anon_sym_do] = ACTIONS(11466),
    [anon_sym_when] = ACTIONS(11466),
    [anon_sym_elsif] = ACTIONS(11466),
    [anon_sym_else] = ACTIONS(11466),
    [anon_sym_then] = ACTIONS(11466),
    [anon_sym_ensure] = ACTIONS(11466),
    [anon_sym_LBRACK] = ACTIONS(11466),
    [anon_sym_COLON_COLON2] = ACTIONS(11466),
    [anon_sym_AMP_DOT] = ACTIONS(11466),
    [anon_sym_PLUS_EQ] = ACTIONS(11466),
    [anon_sym_DASH_EQ] = ACTIONS(11466),
    [anon_sym_STAR_EQ] = ACTIONS(11466),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11466),
    [anon_sym_SLASH_EQ] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11466),
    [anon_sym_PIPE_EQ] = ACTIONS(11466),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11466),
    [anon_sym_AMP_EQ] = ACTIONS(11466),
    [anon_sym_PERCENT_EQ] = ACTIONS(11466),
    [anon_sym_GT_GT_EQ] = ACTIONS(11466),
    [anon_sym_LT_LT_EQ] = ACTIONS(11466),
    [anon_sym_CARET_EQ] = ACTIONS(11466),
    [anon_sym_QMARK] = ACTIONS(11466),
    [anon_sym_DOT_DOT] = ACTIONS(11468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11466),
    [anon_sym_and] = ACTIONS(11466),
    [anon_sym_or] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE] = ACTIONS(11468),
    [anon_sym_AMP_AMP] = ACTIONS(11468),
    [anon_sym_LT_LT] = ACTIONS(11468),
    [anon_sym_GT_GT] = ACTIONS(11468),
    [anon_sym_EQ_EQ] = ACTIONS(11468),
    [anon_sym_BANG_EQ] = ACTIONS(11466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11466),
    [anon_sym_LT_EQ_GT] = ACTIONS(11466),
    [anon_sym_EQ_TILDE] = ACTIONS(11466),
    [anon_sym_BANG_TILDE] = ACTIONS(11466),
    [anon_sym_LT_EQ] = ACTIONS(11468),
    [anon_sym_GT] = ACTIONS(11468),
    [anon_sym_GT_EQ] = ACTIONS(11466),
    [anon_sym_CARET] = ACTIONS(11468),
    [anon_sym_PLUS] = ACTIONS(11468),
    [anon_sym_SLASH] = ACTIONS(11468),
    [anon_sym_PERCENT] = ACTIONS(11468),
    [sym_comment] = ACTIONS(87),
  },
  [9863] = {
    [anon_sym_end] = ACTIONS(14183),
    [sym_comment] = ACTIONS(87),
  },
  [9864] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(5890),
    [sym__binary_star] = ACTIONS(5892),
    [ts_builtin_sym_end] = ACTIONS(11746),
    [anon_sym___END__] = ACTIONS(11746),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(5894),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(5900),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_DOT_DOT] = ACTIONS(5904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_LT_LT] = ACTIONS(5910),
    [anon_sym_GT_GT] = ACTIONS(5910),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5912),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5912),
    [anon_sym_LT_EQ_GT] = ACTIONS(5912),
    [anon_sym_EQ_TILDE] = ACTIONS(5912),
    [anon_sym_BANG_TILDE] = ACTIONS(5912),
    [anon_sym_LT_EQ] = ACTIONS(5900),
    [anon_sym_GT] = ACTIONS(5900),
    [anon_sym_GT_EQ] = ACTIONS(5914),
    [anon_sym_CARET] = ACTIONS(5894),
    [anon_sym_PLUS] = ACTIONS(5916),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [sym_comment] = ACTIONS(87),
  },
  [9865] = {
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [ts_builtin_sym_end] = ACTIONS(11211),
    [anon_sym___END__] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_when] = ACTIONS(11211),
    [anon_sym_elsif] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [9866] = {
    [aux_sym_exceptions_repeat1] = STATE(9866),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [ts_builtin_sym_end] = ACTIONS(11211),
    [anon_sym___END__] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14185),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [9867] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(5938),
    [sym__binary_star] = ACTIONS(5940),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(5940),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5946),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(5948),
    [anon_sym_DOT_DOT] = ACTIONS(5950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5952),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5956),
    [anon_sym_AMP_AMP] = ACTIONS(5956),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5956),
    [anon_sym_LT_EQ_GT] = ACTIONS(5956),
    [anon_sym_EQ_TILDE] = ACTIONS(5956),
    [anon_sym_BANG_TILDE] = ACTIONS(5956),
    [anon_sym_LT_EQ] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5946),
    [anon_sym_GT_EQ] = ACTIONS(5962),
    [anon_sym_CARET] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [sym_comment] = ACTIONS(87),
  },
  [9868] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [9869] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [9870] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(11914),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [9871] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [9872] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11912),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(11914),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(11932),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [9873] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14188),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [9874] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(11912),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(11914),
    [anon_sym_LT] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(11920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11922),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(11924),
    [anon_sym_AMP_AMP] = ACTIONS(11924),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(11928),
    [anon_sym_BANG_EQ] = ACTIONS(11924),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11924),
    [anon_sym_LT_EQ_GT] = ACTIONS(11924),
    [anon_sym_EQ_TILDE] = ACTIONS(11924),
    [anon_sym_BANG_TILDE] = ACTIONS(11924),
    [anon_sym_LT_EQ] = ACTIONS(11916),
    [anon_sym_GT] = ACTIONS(11916),
    [anon_sym_GT_EQ] = ACTIONS(11930),
    [anon_sym_CARET] = ACTIONS(11932),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [9875] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11912),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(11914),
    [anon_sym_LT] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(11918),
    [anon_sym_DOT_DOT] = ACTIONS(11920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11922),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(11924),
    [anon_sym_AMP_AMP] = ACTIONS(11924),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(11928),
    [anon_sym_BANG_EQ] = ACTIONS(11924),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11924),
    [anon_sym_LT_EQ_GT] = ACTIONS(11924),
    [anon_sym_EQ_TILDE] = ACTIONS(11924),
    [anon_sym_BANG_TILDE] = ACTIONS(11924),
    [anon_sym_LT_EQ] = ACTIONS(11916),
    [anon_sym_GT] = ACTIONS(11916),
    [anon_sym_GT_EQ] = ACTIONS(11930),
    [anon_sym_CARET] = ACTIONS(11932),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [9876] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(11912),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(11914),
    [anon_sym_LT] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(11928),
    [anon_sym_BANG_EQ] = ACTIONS(11924),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11924),
    [anon_sym_LT_EQ_GT] = ACTIONS(11924),
    [anon_sym_EQ_TILDE] = ACTIONS(11924),
    [anon_sym_BANG_TILDE] = ACTIONS(11924),
    [anon_sym_LT_EQ] = ACTIONS(11916),
    [anon_sym_GT] = ACTIONS(11916),
    [anon_sym_GT_EQ] = ACTIONS(11930),
    [anon_sym_CARET] = ACTIONS(11932),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [9877] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [9878] = {
    [aux_sym_exceptions_repeat1] = STATE(9878),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(14190),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9879] = {
    [aux_sym_exceptions_repeat1] = STATE(8533),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_RBRACE] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [9880] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(11912),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(11914),
    [anon_sym_LT] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(11918),
    [anon_sym_DOT_DOT] = ACTIONS(11920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11922),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(11924),
    [anon_sym_AMP_AMP] = ACTIONS(11924),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(11928),
    [anon_sym_BANG_EQ] = ACTIONS(11924),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11924),
    [anon_sym_LT_EQ_GT] = ACTIONS(11924),
    [anon_sym_EQ_TILDE] = ACTIONS(11924),
    [anon_sym_BANG_TILDE] = ACTIONS(11924),
    [anon_sym_LT_EQ] = ACTIONS(11916),
    [anon_sym_GT] = ACTIONS(11916),
    [anon_sym_GT_EQ] = ACTIONS(11930),
    [anon_sym_CARET] = ACTIONS(11932),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [9881] = {
    [sym__line_break] = ACTIONS(12187),
    [sym__heredoc_body_start] = ACTIONS(12187),
    [sym__binary_minus] = ACTIONS(12187),
    [sym__binary_star] = ACTIONS(12187),
    [ts_builtin_sym_end] = ACTIONS(12187),
    [anon_sym___END__] = ACTIONS(12187),
    [anon_sym_LBRACE] = ACTIONS(12187),
    [anon_sym_RBRACE] = ACTIONS(12187),
    [anon_sym_RPAREN] = ACTIONS(12187),
    [anon_sym_DOT] = ACTIONS(12189),
    [anon_sym_COMMA] = ACTIONS(12187),
    [anon_sym_PIPE] = ACTIONS(12189),
    [anon_sym_SEMI] = ACTIONS(12187),
    [anon_sym_STAR_STAR] = ACTIONS(12189),
    [anon_sym_AMP] = ACTIONS(12189),
    [anon_sym_EQ] = ACTIONS(12189),
    [anon_sym_LT] = ACTIONS(12189),
    [anon_sym_end] = ACTIONS(12187),
    [anon_sym_if] = ACTIONS(12187),
    [anon_sym_unless] = ACTIONS(12187),
    [anon_sym_while] = ACTIONS(12187),
    [anon_sym_until] = ACTIONS(12187),
    [anon_sym_rescue] = ACTIONS(12187),
    [anon_sym_do] = ACTIONS(12187),
    [anon_sym_when] = ACTIONS(12187),
    [anon_sym_elsif] = ACTIONS(12187),
    [anon_sym_else] = ACTIONS(12187),
    [anon_sym_then] = ACTIONS(12187),
    [anon_sym_ensure] = ACTIONS(12187),
    [anon_sym_EQ_GT] = ACTIONS(12187),
    [anon_sym_LBRACK] = ACTIONS(12187),
    [anon_sym_COLON_COLON2] = ACTIONS(12187),
    [anon_sym_AMP_DOT] = ACTIONS(12187),
    [anon_sym_PLUS_EQ] = ACTIONS(12187),
    [anon_sym_DASH_EQ] = ACTIONS(12187),
    [anon_sym_STAR_EQ] = ACTIONS(12187),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12187),
    [anon_sym_SLASH_EQ] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12187),
    [anon_sym_PIPE_EQ] = ACTIONS(12187),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12187),
    [anon_sym_AMP_EQ] = ACTIONS(12187),
    [anon_sym_PERCENT_EQ] = ACTIONS(12187),
    [anon_sym_GT_GT_EQ] = ACTIONS(12187),
    [anon_sym_LT_LT_EQ] = ACTIONS(12187),
    [anon_sym_CARET_EQ] = ACTIONS(12187),
    [anon_sym_QMARK] = ACTIONS(12187),
    [anon_sym_DOT_DOT] = ACTIONS(12189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12187),
    [anon_sym_and] = ACTIONS(12187),
    [anon_sym_or] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE] = ACTIONS(12189),
    [anon_sym_AMP_AMP] = ACTIONS(12189),
    [anon_sym_LT_LT] = ACTIONS(12189),
    [anon_sym_GT_GT] = ACTIONS(12189),
    [anon_sym_EQ_EQ] = ACTIONS(12189),
    [anon_sym_BANG_EQ] = ACTIONS(12187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12187),
    [anon_sym_LT_EQ_GT] = ACTIONS(12187),
    [anon_sym_EQ_TILDE] = ACTIONS(12187),
    [anon_sym_BANG_TILDE] = ACTIONS(12187),
    [anon_sym_LT_EQ] = ACTIONS(12189),
    [anon_sym_GT] = ACTIONS(12189),
    [anon_sym_GT_EQ] = ACTIONS(12187),
    [anon_sym_CARET] = ACTIONS(12189),
    [anon_sym_PLUS] = ACTIONS(12189),
    [anon_sym_SLASH] = ACTIONS(12189),
    [anon_sym_PERCENT] = ACTIONS(12189),
    [sym_comment] = ACTIONS(87),
  },
  [9882] = {
    [sym__line_break] = ACTIONS(12482),
    [sym__heredoc_body_start] = ACTIONS(12482),
    [sym__binary_minus] = ACTIONS(12482),
    [sym__binary_star] = ACTIONS(12482),
    [ts_builtin_sym_end] = ACTIONS(12482),
    [anon_sym___END__] = ACTIONS(12482),
    [anon_sym_LBRACE] = ACTIONS(12482),
    [anon_sym_RBRACE] = ACTIONS(12482),
    [anon_sym_RPAREN] = ACTIONS(12482),
    [anon_sym_DOT] = ACTIONS(12484),
    [anon_sym_COMMA] = ACTIONS(12482),
    [anon_sym_PIPE] = ACTIONS(12484),
    [anon_sym_SEMI] = ACTIONS(12482),
    [anon_sym_STAR_STAR] = ACTIONS(12484),
    [anon_sym_AMP] = ACTIONS(12484),
    [anon_sym_EQ] = ACTIONS(12484),
    [anon_sym_LT] = ACTIONS(12484),
    [anon_sym_end] = ACTIONS(12482),
    [anon_sym_if] = ACTIONS(12482),
    [anon_sym_unless] = ACTIONS(12482),
    [anon_sym_while] = ACTIONS(12482),
    [anon_sym_until] = ACTIONS(12482),
    [anon_sym_rescue] = ACTIONS(12482),
    [anon_sym_do] = ACTIONS(12482),
    [anon_sym_when] = ACTIONS(12482),
    [anon_sym_elsif] = ACTIONS(12482),
    [anon_sym_else] = ACTIONS(12482),
    [anon_sym_then] = ACTIONS(12482),
    [anon_sym_ensure] = ACTIONS(12482),
    [anon_sym_EQ_GT] = ACTIONS(12482),
    [anon_sym_LBRACK] = ACTIONS(12482),
    [anon_sym_COLON_COLON2] = ACTIONS(12482),
    [anon_sym_AMP_DOT] = ACTIONS(12482),
    [anon_sym_PLUS_EQ] = ACTIONS(12482),
    [anon_sym_DASH_EQ] = ACTIONS(12482),
    [anon_sym_STAR_EQ] = ACTIONS(12482),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12482),
    [anon_sym_SLASH_EQ] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12482),
    [anon_sym_PIPE_EQ] = ACTIONS(12482),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12482),
    [anon_sym_AMP_EQ] = ACTIONS(12482),
    [anon_sym_PERCENT_EQ] = ACTIONS(12482),
    [anon_sym_GT_GT_EQ] = ACTIONS(12482),
    [anon_sym_LT_LT_EQ] = ACTIONS(12482),
    [anon_sym_CARET_EQ] = ACTIONS(12482),
    [anon_sym_QMARK] = ACTIONS(12482),
    [anon_sym_DOT_DOT] = ACTIONS(12484),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12482),
    [anon_sym_and] = ACTIONS(12482),
    [anon_sym_or] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE] = ACTIONS(12484),
    [anon_sym_AMP_AMP] = ACTIONS(12484),
    [anon_sym_LT_LT] = ACTIONS(12484),
    [anon_sym_GT_GT] = ACTIONS(12484),
    [anon_sym_EQ_EQ] = ACTIONS(12484),
    [anon_sym_BANG_EQ] = ACTIONS(12482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12482),
    [anon_sym_LT_EQ_GT] = ACTIONS(12482),
    [anon_sym_EQ_TILDE] = ACTIONS(12482),
    [anon_sym_BANG_TILDE] = ACTIONS(12482),
    [anon_sym_LT_EQ] = ACTIONS(12484),
    [anon_sym_GT] = ACTIONS(12484),
    [anon_sym_GT_EQ] = ACTIONS(12482),
    [anon_sym_CARET] = ACTIONS(12484),
    [anon_sym_PLUS] = ACTIONS(12484),
    [anon_sym_SLASH] = ACTIONS(12484),
    [anon_sym_PERCENT] = ACTIONS(12484),
    [sym_comment] = ACTIONS(87),
  },
  [9883] = {
    [anon_sym_end] = ACTIONS(14193),
    [sym_comment] = ACTIONS(87),
  },
  [9884] = {
    [sym__line_break] = ACTIONS(12622),
    [sym__heredoc_body_start] = ACTIONS(12622),
    [sym__binary_minus] = ACTIONS(12622),
    [sym__binary_star] = ACTIONS(12622),
    [ts_builtin_sym_end] = ACTIONS(12622),
    [anon_sym___END__] = ACTIONS(12622),
    [anon_sym_LBRACE] = ACTIONS(12622),
    [anon_sym_RBRACE] = ACTIONS(12622),
    [anon_sym_RPAREN] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12624),
    [anon_sym_COMMA] = ACTIONS(12622),
    [anon_sym_PIPE] = ACTIONS(12624),
    [anon_sym_SEMI] = ACTIONS(12622),
    [anon_sym_STAR_STAR] = ACTIONS(12624),
    [anon_sym_AMP] = ACTIONS(12624),
    [anon_sym_EQ] = ACTIONS(12624),
    [anon_sym_LT] = ACTIONS(12624),
    [anon_sym_end] = ACTIONS(12622),
    [anon_sym_if] = ACTIONS(12622),
    [anon_sym_unless] = ACTIONS(12622),
    [anon_sym_while] = ACTIONS(12622),
    [anon_sym_until] = ACTIONS(12622),
    [anon_sym_rescue] = ACTIONS(12622),
    [anon_sym_do] = ACTIONS(12622),
    [anon_sym_when] = ACTIONS(12622),
    [anon_sym_elsif] = ACTIONS(12622),
    [anon_sym_else] = ACTIONS(12622),
    [anon_sym_then] = ACTIONS(12622),
    [anon_sym_ensure] = ACTIONS(12622),
    [anon_sym_EQ_GT] = ACTIONS(12622),
    [anon_sym_LBRACK] = ACTIONS(12622),
    [anon_sym_COLON_COLON2] = ACTIONS(12622),
    [anon_sym_AMP_DOT] = ACTIONS(12622),
    [anon_sym_PLUS_EQ] = ACTIONS(12622),
    [anon_sym_DASH_EQ] = ACTIONS(12622),
    [anon_sym_STAR_EQ] = ACTIONS(12622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12622),
    [anon_sym_SLASH_EQ] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12622),
    [anon_sym_PIPE_EQ] = ACTIONS(12622),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12622),
    [anon_sym_AMP_EQ] = ACTIONS(12622),
    [anon_sym_PERCENT_EQ] = ACTIONS(12622),
    [anon_sym_GT_GT_EQ] = ACTIONS(12622),
    [anon_sym_LT_LT_EQ] = ACTIONS(12622),
    [anon_sym_CARET_EQ] = ACTIONS(12622),
    [anon_sym_QMARK] = ACTIONS(12622),
    [anon_sym_DOT_DOT] = ACTIONS(12624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12622),
    [anon_sym_and] = ACTIONS(12622),
    [anon_sym_or] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE] = ACTIONS(12624),
    [anon_sym_AMP_AMP] = ACTIONS(12624),
    [anon_sym_LT_LT] = ACTIONS(12624),
    [anon_sym_GT_GT] = ACTIONS(12624),
    [anon_sym_EQ_EQ] = ACTIONS(12624),
    [anon_sym_BANG_EQ] = ACTIONS(12622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12622),
    [anon_sym_LT_EQ_GT] = ACTIONS(12622),
    [anon_sym_EQ_TILDE] = ACTIONS(12622),
    [anon_sym_BANG_TILDE] = ACTIONS(12622),
    [anon_sym_LT_EQ] = ACTIONS(12624),
    [anon_sym_GT] = ACTIONS(12624),
    [anon_sym_GT_EQ] = ACTIONS(12622),
    [anon_sym_CARET] = ACTIONS(12624),
    [anon_sym_PLUS] = ACTIONS(12624),
    [anon_sym_SLASH] = ACTIONS(12624),
    [anon_sym_PERCENT] = ACTIONS(12624),
    [sym_comment] = ACTIONS(87),
  },
  [9885] = {
    [sym__line_break] = ACTIONS(12770),
    [sym__heredoc_body_start] = ACTIONS(12770),
    [sym__binary_minus] = ACTIONS(12770),
    [sym__binary_star] = ACTIONS(12770),
    [ts_builtin_sym_end] = ACTIONS(12770),
    [anon_sym___END__] = ACTIONS(12770),
    [anon_sym_LBRACE] = ACTIONS(12770),
    [anon_sym_RBRACE] = ACTIONS(12770),
    [anon_sym_RPAREN] = ACTIONS(12770),
    [anon_sym_DOT] = ACTIONS(12772),
    [anon_sym_COMMA] = ACTIONS(12770),
    [anon_sym_PIPE] = ACTIONS(12772),
    [anon_sym_SEMI] = ACTIONS(12770),
    [anon_sym_STAR_STAR] = ACTIONS(12772),
    [anon_sym_AMP] = ACTIONS(12772),
    [anon_sym_EQ] = ACTIONS(12772),
    [anon_sym_LT] = ACTIONS(12772),
    [anon_sym_end] = ACTIONS(12770),
    [anon_sym_if] = ACTIONS(12770),
    [anon_sym_unless] = ACTIONS(12770),
    [anon_sym_while] = ACTIONS(12770),
    [anon_sym_until] = ACTIONS(12770),
    [anon_sym_rescue] = ACTIONS(12770),
    [anon_sym_do] = ACTIONS(12770),
    [anon_sym_when] = ACTIONS(12770),
    [anon_sym_elsif] = ACTIONS(12770),
    [anon_sym_else] = ACTIONS(12770),
    [anon_sym_then] = ACTIONS(12770),
    [anon_sym_ensure] = ACTIONS(12770),
    [anon_sym_EQ_GT] = ACTIONS(12770),
    [anon_sym_LBRACK] = ACTIONS(12770),
    [anon_sym_COLON_COLON2] = ACTIONS(12770),
    [anon_sym_AMP_DOT] = ACTIONS(12770),
    [anon_sym_PLUS_EQ] = ACTIONS(12770),
    [anon_sym_DASH_EQ] = ACTIONS(12770),
    [anon_sym_STAR_EQ] = ACTIONS(12770),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12770),
    [anon_sym_SLASH_EQ] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12770),
    [anon_sym_PIPE_EQ] = ACTIONS(12770),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12770),
    [anon_sym_AMP_EQ] = ACTIONS(12770),
    [anon_sym_PERCENT_EQ] = ACTIONS(12770),
    [anon_sym_GT_GT_EQ] = ACTIONS(12770),
    [anon_sym_LT_LT_EQ] = ACTIONS(12770),
    [anon_sym_CARET_EQ] = ACTIONS(12770),
    [anon_sym_QMARK] = ACTIONS(12770),
    [anon_sym_DOT_DOT] = ACTIONS(12772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12770),
    [anon_sym_and] = ACTIONS(12770),
    [anon_sym_or] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE] = ACTIONS(12772),
    [anon_sym_AMP_AMP] = ACTIONS(12772),
    [anon_sym_LT_LT] = ACTIONS(12772),
    [anon_sym_GT_GT] = ACTIONS(12772),
    [anon_sym_EQ_EQ] = ACTIONS(12772),
    [anon_sym_BANG_EQ] = ACTIONS(12770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12770),
    [anon_sym_LT_EQ_GT] = ACTIONS(12770),
    [anon_sym_EQ_TILDE] = ACTIONS(12770),
    [anon_sym_BANG_TILDE] = ACTIONS(12770),
    [anon_sym_LT_EQ] = ACTIONS(12772),
    [anon_sym_GT] = ACTIONS(12772),
    [anon_sym_GT_EQ] = ACTIONS(12770),
    [anon_sym_CARET] = ACTIONS(12772),
    [anon_sym_PLUS] = ACTIONS(12772),
    [anon_sym_SLASH] = ACTIONS(12772),
    [anon_sym_PERCENT] = ACTIONS(12772),
    [sym_comment] = ACTIONS(87),
  },
  [9886] = {
    [sym__line_break] = ACTIONS(14146),
    [sym__heredoc_body_start] = ACTIONS(14146),
    [sym__binary_minus] = ACTIONS(14146),
    [sym__binary_star] = ACTIONS(14146),
    [ts_builtin_sym_end] = ACTIONS(14146),
    [anon_sym___END__] = ACTIONS(14146),
    [anon_sym_LBRACE] = ACTIONS(14146),
    [anon_sym_RBRACE] = ACTIONS(14146),
    [anon_sym_RPAREN] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14148),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14148),
    [anon_sym_SEMI] = ACTIONS(14146),
    [anon_sym_STAR_STAR] = ACTIONS(14148),
    [anon_sym_AMP] = ACTIONS(14148),
    [anon_sym_EQ] = ACTIONS(14148),
    [anon_sym_LT] = ACTIONS(14148),
    [anon_sym_end] = ACTIONS(14146),
    [anon_sym_if] = ACTIONS(14146),
    [anon_sym_unless] = ACTIONS(14146),
    [anon_sym_while] = ACTIONS(14146),
    [anon_sym_until] = ACTIONS(14146),
    [anon_sym_rescue] = ACTIONS(14146),
    [anon_sym_do] = ACTIONS(14146),
    [anon_sym_when] = ACTIONS(14146),
    [anon_sym_elsif] = ACTIONS(14146),
    [anon_sym_else] = ACTIONS(14146),
    [anon_sym_then] = ACTIONS(14146),
    [anon_sym_ensure] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [anon_sym_PLUS_EQ] = ACTIONS(14146),
    [anon_sym_DASH_EQ] = ACTIONS(14146),
    [anon_sym_STAR_EQ] = ACTIONS(14146),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14146),
    [anon_sym_SLASH_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14146),
    [anon_sym_AMP_EQ] = ACTIONS(14146),
    [anon_sym_PERCENT_EQ] = ACTIONS(14146),
    [anon_sym_GT_GT_EQ] = ACTIONS(14146),
    [anon_sym_LT_LT_EQ] = ACTIONS(14146),
    [anon_sym_CARET_EQ] = ACTIONS(14146),
    [anon_sym_QMARK] = ACTIONS(14146),
    [anon_sym_DOT_DOT] = ACTIONS(14148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14146),
    [anon_sym_and] = ACTIONS(14146),
    [anon_sym_or] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE] = ACTIONS(14148),
    [anon_sym_AMP_AMP] = ACTIONS(14148),
    [anon_sym_LT_LT] = ACTIONS(14148),
    [anon_sym_GT_GT] = ACTIONS(14148),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_BANG_EQ] = ACTIONS(14146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14146),
    [anon_sym_LT_EQ_GT] = ACTIONS(14146),
    [anon_sym_EQ_TILDE] = ACTIONS(14146),
    [anon_sym_BANG_TILDE] = ACTIONS(14146),
    [anon_sym_LT_EQ] = ACTIONS(14148),
    [anon_sym_GT] = ACTIONS(14148),
    [anon_sym_GT_EQ] = ACTIONS(14146),
    [anon_sym_CARET] = ACTIONS(14148),
    [anon_sym_PLUS] = ACTIONS(14148),
    [anon_sym_SLASH] = ACTIONS(14148),
    [anon_sym_PERCENT] = ACTIONS(14148),
    [sym_comment] = ACTIONS(87),
  },
  [9887] = {
    [sym__line_break] = ACTIONS(12781),
    [sym__heredoc_body_start] = ACTIONS(12781),
    [sym__binary_minus] = ACTIONS(12781),
    [sym__binary_star] = ACTIONS(12781),
    [ts_builtin_sym_end] = ACTIONS(12781),
    [anon_sym___END__] = ACTIONS(12781),
    [anon_sym_LBRACE] = ACTIONS(12781),
    [anon_sym_RBRACE] = ACTIONS(12781),
    [anon_sym_RPAREN] = ACTIONS(12781),
    [anon_sym_DOT] = ACTIONS(12783),
    [anon_sym_COMMA] = ACTIONS(12781),
    [anon_sym_PIPE] = ACTIONS(12783),
    [anon_sym_SEMI] = ACTIONS(12781),
    [anon_sym_STAR_STAR] = ACTIONS(12783),
    [anon_sym_AMP] = ACTIONS(12783),
    [anon_sym_EQ] = ACTIONS(12783),
    [anon_sym_LT] = ACTIONS(12783),
    [anon_sym_end] = ACTIONS(12781),
    [anon_sym_if] = ACTIONS(12781),
    [anon_sym_unless] = ACTIONS(12781),
    [anon_sym_while] = ACTIONS(12781),
    [anon_sym_until] = ACTIONS(12781),
    [anon_sym_rescue] = ACTIONS(12781),
    [anon_sym_do] = ACTIONS(12781),
    [anon_sym_when] = ACTIONS(12781),
    [anon_sym_elsif] = ACTIONS(12781),
    [anon_sym_else] = ACTIONS(12781),
    [anon_sym_then] = ACTIONS(12781),
    [anon_sym_ensure] = ACTIONS(12781),
    [anon_sym_EQ_GT] = ACTIONS(12781),
    [anon_sym_LBRACK] = ACTIONS(12781),
    [anon_sym_COLON_COLON2] = ACTIONS(12781),
    [anon_sym_AMP_DOT] = ACTIONS(12781),
    [anon_sym_PLUS_EQ] = ACTIONS(12781),
    [anon_sym_DASH_EQ] = ACTIONS(12781),
    [anon_sym_STAR_EQ] = ACTIONS(12781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12781),
    [anon_sym_SLASH_EQ] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12781),
    [anon_sym_PIPE_EQ] = ACTIONS(12781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12781),
    [anon_sym_AMP_EQ] = ACTIONS(12781),
    [anon_sym_PERCENT_EQ] = ACTIONS(12781),
    [anon_sym_GT_GT_EQ] = ACTIONS(12781),
    [anon_sym_LT_LT_EQ] = ACTIONS(12781),
    [anon_sym_CARET_EQ] = ACTIONS(12781),
    [anon_sym_QMARK] = ACTIONS(12781),
    [anon_sym_DOT_DOT] = ACTIONS(12783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12781),
    [anon_sym_and] = ACTIONS(12781),
    [anon_sym_or] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE] = ACTIONS(12783),
    [anon_sym_AMP_AMP] = ACTIONS(12783),
    [anon_sym_LT_LT] = ACTIONS(12783),
    [anon_sym_GT_GT] = ACTIONS(12783),
    [anon_sym_EQ_EQ] = ACTIONS(12783),
    [anon_sym_BANG_EQ] = ACTIONS(12781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12781),
    [anon_sym_LT_EQ_GT] = ACTIONS(12781),
    [anon_sym_EQ_TILDE] = ACTIONS(12781),
    [anon_sym_BANG_TILDE] = ACTIONS(12781),
    [anon_sym_LT_EQ] = ACTIONS(12783),
    [anon_sym_GT] = ACTIONS(12783),
    [anon_sym_GT_EQ] = ACTIONS(12781),
    [anon_sym_CARET] = ACTIONS(12783),
    [anon_sym_PLUS] = ACTIONS(12783),
    [anon_sym_SLASH] = ACTIONS(12783),
    [anon_sym_PERCENT] = ACTIONS(12783),
    [sym_comment] = ACTIONS(87),
  },
  [9888] = {
    [sym__line_break] = ACTIONS(13093),
    [sym__heredoc_body_start] = ACTIONS(13093),
    [sym__binary_minus] = ACTIONS(13093),
    [sym__binary_star] = ACTIONS(13093),
    [ts_builtin_sym_end] = ACTIONS(13093),
    [anon_sym___END__] = ACTIONS(13093),
    [anon_sym_LBRACE] = ACTIONS(13093),
    [anon_sym_RBRACE] = ACTIONS(13093),
    [anon_sym_RPAREN] = ACTIONS(13093),
    [anon_sym_DOT] = ACTIONS(13095),
    [anon_sym_COMMA] = ACTIONS(13093),
    [anon_sym_PIPE] = ACTIONS(13095),
    [anon_sym_SEMI] = ACTIONS(13093),
    [anon_sym_STAR_STAR] = ACTIONS(13095),
    [anon_sym_AMP] = ACTIONS(13095),
    [anon_sym_EQ] = ACTIONS(13095),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(13093),
    [anon_sym_if] = ACTIONS(13093),
    [anon_sym_unless] = ACTIONS(13093),
    [anon_sym_while] = ACTIONS(13093),
    [anon_sym_until] = ACTIONS(13093),
    [anon_sym_rescue] = ACTIONS(13093),
    [anon_sym_do] = ACTIONS(13093),
    [anon_sym_when] = ACTIONS(13093),
    [anon_sym_elsif] = ACTIONS(13093),
    [anon_sym_else] = ACTIONS(13093),
    [anon_sym_then] = ACTIONS(13093),
    [anon_sym_ensure] = ACTIONS(13093),
    [anon_sym_EQ_GT] = ACTIONS(13093),
    [anon_sym_LBRACK] = ACTIONS(13093),
    [anon_sym_COLON_COLON2] = ACTIONS(13093),
    [anon_sym_AMP_DOT] = ACTIONS(13093),
    [anon_sym_PLUS_EQ] = ACTIONS(13093),
    [anon_sym_DASH_EQ] = ACTIONS(13093),
    [anon_sym_STAR_EQ] = ACTIONS(13093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13093),
    [anon_sym_SLASH_EQ] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13093),
    [anon_sym_PIPE_EQ] = ACTIONS(13093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13093),
    [anon_sym_AMP_EQ] = ACTIONS(13093),
    [anon_sym_PERCENT_EQ] = ACTIONS(13093),
    [anon_sym_GT_GT_EQ] = ACTIONS(13093),
    [anon_sym_LT_LT_EQ] = ACTIONS(13093),
    [anon_sym_CARET_EQ] = ACTIONS(13093),
    [anon_sym_QMARK] = ACTIONS(13093),
    [anon_sym_DOT_DOT] = ACTIONS(13095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13093),
    [anon_sym_and] = ACTIONS(13093),
    [anon_sym_or] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE] = ACTIONS(13095),
    [anon_sym_AMP_AMP] = ACTIONS(13095),
    [anon_sym_LT_LT] = ACTIONS(13095),
    [anon_sym_GT_GT] = ACTIONS(13095),
    [anon_sym_EQ_EQ] = ACTIONS(13095),
    [anon_sym_BANG_EQ] = ACTIONS(13093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13093),
    [anon_sym_LT_EQ_GT] = ACTIONS(13093),
    [anon_sym_EQ_TILDE] = ACTIONS(13093),
    [anon_sym_BANG_TILDE] = ACTIONS(13093),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13093),
    [anon_sym_CARET] = ACTIONS(13095),
    [anon_sym_PLUS] = ACTIONS(13095),
    [anon_sym_SLASH] = ACTIONS(13095),
    [anon_sym_PERCENT] = ACTIONS(13095),
    [sym_comment] = ACTIONS(87),
  },
  [9889] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(6034),
    [sym__binary_star] = ACTIONS(6036),
    [ts_builtin_sym_end] = ACTIONS(11746),
    [anon_sym___END__] = ACTIONS(11746),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(6036),
    [anon_sym_AMP] = ACTIONS(6040),
    [anon_sym_LT] = ACTIONS(6042),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(6044),
    [anon_sym_DOT_DOT] = ACTIONS(6046),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6048),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(6050),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6050),
    [anon_sym_LT_EQ_GT] = ACTIONS(6050),
    [anon_sym_EQ_TILDE] = ACTIONS(6050),
    [anon_sym_BANG_TILDE] = ACTIONS(6050),
    [anon_sym_LT_EQ] = ACTIONS(6042),
    [anon_sym_GT] = ACTIONS(6042),
    [anon_sym_GT_EQ] = ACTIONS(6056),
    [anon_sym_CARET] = ACTIONS(6058),
    [anon_sym_PLUS] = ACTIONS(6034),
    [anon_sym_SLASH] = ACTIONS(6036),
    [anon_sym_PERCENT] = ACTIONS(6036),
    [sym_comment] = ACTIONS(87),
  },
  [9890] = {
    [sym_heredoc_body] = STATE(9890),
    [aux_sym_call_repeat1] = STATE(9890),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9891] = {
    [sym_heredoc_body] = STATE(9890),
    [aux_sym_call_repeat1] = STATE(9890),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9892] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10588),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_assignment] = STATE(10588),
    [sym_operator_assignment] = STATE(10588),
    [sym_conditional] = STATE(10588),
    [sym_range] = STATE(10588),
    [sym_binary] = STATE(10588),
    [sym_unary] = STATE(10588),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9893] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8570),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(3756),
    [sym_scope_resolution] = STATE(3754),
    [sym_call] = STATE(3754),
    [sym_method_call] = STATE(3756),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(8570),
    [sym_operator_assignment] = STATE(8570),
    [sym_conditional] = STATE(8570),
    [sym_range] = STATE(8570),
    [sym_binary] = STATE(8570),
    [sym_unary] = STATE(8570),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(3755),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3756),
    [sym__variable] = STATE(3754),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(3756),
    [sym_false] = STATE(3756),
    [sym_nil] = STATE(3756),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(3757),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(2767),
    [sym__unary_minus] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6085),
    [anon_sym_yield] = ACTIONS(6087),
    [anon_sym_break] = ACTIONS(6089),
    [anon_sym_next] = ACTIONS(6091),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6093),
    [anon_sym_defined_QMARK] = ACTIONS(6095),
    [anon_sym_not] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6099),
    [anon_sym_TILDE] = ACTIONS(6099),
    [sym_constant] = ACTIONS(6101),
    [sym_identifier] = ACTIONS(6101),
    [sym_instance_variable] = ACTIONS(6103),
    [sym_class_variable] = ACTIONS(6103),
    [sym_global_variable] = ACTIONS(6103),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6101),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6101),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9894] = {
    [aux_sym_exceptions_repeat1] = STATE(10589),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14195),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9895] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(6119),
    [sym__binary_star] = ACTIONS(6121),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_STAR_STAR] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(6129),
    [anon_sym_DOT_DOT] = ACTIONS(6131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_EQ_TILDE] = ACTIONS(6135),
    [anon_sym_BANG_TILDE] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_GT_EQ] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_PLUS] = ACTIONS(6119),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [sym_comment] = ACTIONS(87),
  },
  [9896] = {
    [aux_sym_exceptions_repeat1] = STATE(9896),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14197),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9897] = {
    [sym__simple_symbol] = ACTIONS(10568),
    [sym__string_start] = ACTIONS(10568),
    [sym__symbol_start] = ACTIONS(10568),
    [sym__subshell_start] = ACTIONS(10568),
    [sym__regex_start] = ACTIONS(10568),
    [sym__string_array_start] = ACTIONS(10568),
    [sym__symbol_array_start] = ACTIONS(10568),
    [sym_heredoc_beginning] = ACTIONS(10568),
    [sym__block_ampersand] = ACTIONS(10568),
    [sym__splat_star] = ACTIONS(10568),
    [sym__unary_minus] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [sym__identifier_hash_key] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_def] = ACTIONS(10570),
    [anon_sym_LPAREN] = ACTIONS(10570),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COLON_COLON] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10570),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_class] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_module] = ACTIONS(10570),
    [anon_sym_return] = ACTIONS(10570),
    [anon_sym_yield] = ACTIONS(10570),
    [anon_sym_break] = ACTIONS(10570),
    [anon_sym_next] = ACTIONS(10570),
    [sym_redo] = ACTIONS(10570),
    [sym_retry] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10570),
    [anon_sym_unless] = ACTIONS(10570),
    [anon_sym_while] = ACTIONS(10570),
    [anon_sym_until] = ACTIONS(10570),
    [anon_sym_rescue] = ACTIONS(10570),
    [anon_sym_for] = ACTIONS(10570),
    [anon_sym_do] = ACTIONS(10570),
    [anon_sym_case] = ACTIONS(10570),
    [anon_sym_begin] = ACTIONS(10570),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_LPAREN2] = ACTIONS(10568),
    [anon_sym_PLUS_EQ] = ACTIONS(10568),
    [anon_sym_DASH_EQ] = ACTIONS(10568),
    [anon_sym_STAR_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10568),
    [anon_sym_SLASH_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10568),
    [anon_sym_AMP_EQ] = ACTIONS(10568),
    [anon_sym_PERCENT_EQ] = ACTIONS(10568),
    [anon_sym_GT_GT_EQ] = ACTIONS(10568),
    [anon_sym_LT_LT_EQ] = ACTIONS(10568),
    [anon_sym_CARET_EQ] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10570),
    [anon_sym_COLON2] = ACTIONS(10570),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10570),
    [anon_sym_or] = ACTIONS(10570),
    [anon_sym_PIPE_PIPE] = ACTIONS(10570),
    [anon_sym_AMP_AMP] = ACTIONS(10570),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10570),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_SLASH] = ACTIONS(10570),
    [anon_sym_PERCENT] = ACTIONS(10570),
    [anon_sym_defined_QMARK] = ACTIONS(10568),
    [anon_sym_not] = ACTIONS(10570),
    [anon_sym_BANG] = ACTIONS(10570),
    [anon_sym_TILDE] = ACTIONS(10568),
    [sym_constant] = ACTIONS(10570),
    [sym_identifier] = ACTIONS(10570),
    [sym_instance_variable] = ACTIONS(10568),
    [sym_class_variable] = ACTIONS(10568),
    [sym_global_variable] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10570),
    [sym_float] = ACTIONS(10570),
    [sym_complex] = ACTIONS(10568),
    [sym_super] = ACTIONS(10570),
    [anon_sym_true] = ACTIONS(10570),
    [anon_sym_TRUE] = ACTIONS(10570),
    [anon_sym_false] = ACTIONS(10570),
    [anon_sym_FALSE] = ACTIONS(10570),
    [sym_self] = ACTIONS(10570),
    [anon_sym_nil] = ACTIONS(10570),
    [anon_sym_NIL] = ACTIONS(10570),
    [sym_character] = ACTIONS(10568),
    [anon_sym_LBRACK2] = ACTIONS(10570),
    [anon_sym_DASH_GT] = ACTIONS(10568),
  },
  [9898] = {
    [sym__heredoc_body_start] = ACTIONS(6333),
    [sym__binary_minus] = ACTIONS(6333),
    [sym__binary_star] = ACTIONS(6333),
    [anon_sym_LBRACE] = ACTIONS(6333),
    [anon_sym_RBRACE] = ACTIONS(6333),
    [anon_sym_RPAREN] = ACTIONS(6333),
    [anon_sym_DOT] = ACTIONS(6335),
    [anon_sym_COMMA] = ACTIONS(6333),
    [anon_sym_PIPE] = ACTIONS(6335),
    [anon_sym_SEMI] = ACTIONS(6333),
    [anon_sym_STAR_STAR] = ACTIONS(6335),
    [anon_sym_AMP] = ACTIONS(6335),
    [anon_sym_EQ] = ACTIONS(6335),
    [anon_sym_LT] = ACTIONS(6335),
    [anon_sym_if] = ACTIONS(6333),
    [anon_sym_unless] = ACTIONS(6333),
    [anon_sym_while] = ACTIONS(6333),
    [anon_sym_until] = ACTIONS(6333),
    [anon_sym_rescue] = ACTIONS(6333),
    [anon_sym_in] = ACTIONS(6333),
    [anon_sym_do] = ACTIONS(6333),
    [anon_sym_LBRACK] = ACTIONS(6333),
    [anon_sym_RBRACK] = ACTIONS(6333),
    [anon_sym_COLON_COLON2] = ACTIONS(6333),
    [anon_sym_AMP_DOT] = ACTIONS(6333),
    [anon_sym_PLUS_EQ] = ACTIONS(6333),
    [anon_sym_DASH_EQ] = ACTIONS(6333),
    [anon_sym_STAR_EQ] = ACTIONS(6333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6333),
    [anon_sym_SLASH_EQ] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6333),
    [anon_sym_PIPE_EQ] = ACTIONS(6333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6333),
    [anon_sym_AMP_EQ] = ACTIONS(6333),
    [anon_sym_PERCENT_EQ] = ACTIONS(6333),
    [anon_sym_GT_GT_EQ] = ACTIONS(6333),
    [anon_sym_LT_LT_EQ] = ACTIONS(6333),
    [anon_sym_CARET_EQ] = ACTIONS(6333),
    [anon_sym_QMARK] = ACTIONS(6333),
    [anon_sym_COLON2] = ACTIONS(6335),
    [anon_sym_DOT_DOT] = ACTIONS(6335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6333),
    [anon_sym_and] = ACTIONS(6333),
    [anon_sym_or] = ACTIONS(6333),
    [anon_sym_PIPE_PIPE] = ACTIONS(6335),
    [anon_sym_AMP_AMP] = ACTIONS(6335),
    [anon_sym_LT_LT] = ACTIONS(6335),
    [anon_sym_GT_GT] = ACTIONS(6335),
    [anon_sym_EQ_EQ] = ACTIONS(6335),
    [anon_sym_BANG_EQ] = ACTIONS(6333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6333),
    [anon_sym_LT_EQ_GT] = ACTIONS(6333),
    [anon_sym_EQ_TILDE] = ACTIONS(6333),
    [anon_sym_BANG_TILDE] = ACTIONS(6333),
    [anon_sym_LT_EQ] = ACTIONS(6335),
    [anon_sym_GT] = ACTIONS(6335),
    [anon_sym_GT_EQ] = ACTIONS(6333),
    [anon_sym_CARET] = ACTIONS(6335),
    [anon_sym_PLUS] = ACTIONS(6335),
    [anon_sym_SLASH] = ACTIONS(6335),
    [anon_sym_PERCENT] = ACTIONS(6335),
    [sym_comment] = ACTIONS(87),
  },
  [9899] = {
    [sym__heredoc_body_start] = ACTIONS(6337),
    [sym__binary_minus] = ACTIONS(6337),
    [sym__binary_star] = ACTIONS(6337),
    [anon_sym_LBRACE] = ACTIONS(6337),
    [anon_sym_RBRACE] = ACTIONS(6337),
    [anon_sym_RPAREN] = ACTIONS(6337),
    [anon_sym_DOT] = ACTIONS(6339),
    [anon_sym_COMMA] = ACTIONS(6337),
    [anon_sym_PIPE] = ACTIONS(6339),
    [anon_sym_SEMI] = ACTIONS(6337),
    [anon_sym_STAR_STAR] = ACTIONS(6339),
    [anon_sym_AMP] = ACTIONS(6339),
    [anon_sym_EQ] = ACTIONS(6339),
    [anon_sym_LT] = ACTIONS(6339),
    [anon_sym_if] = ACTIONS(6337),
    [anon_sym_unless] = ACTIONS(6337),
    [anon_sym_while] = ACTIONS(6337),
    [anon_sym_until] = ACTIONS(6337),
    [anon_sym_rescue] = ACTIONS(6337),
    [anon_sym_in] = ACTIONS(6337),
    [anon_sym_do] = ACTIONS(6337),
    [anon_sym_LBRACK] = ACTIONS(6337),
    [anon_sym_RBRACK] = ACTIONS(6337),
    [anon_sym_COLON_COLON2] = ACTIONS(6337),
    [anon_sym_AMP_DOT] = ACTIONS(6337),
    [anon_sym_PLUS_EQ] = ACTIONS(6337),
    [anon_sym_DASH_EQ] = ACTIONS(6337),
    [anon_sym_STAR_EQ] = ACTIONS(6337),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6337),
    [anon_sym_SLASH_EQ] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6337),
    [anon_sym_PIPE_EQ] = ACTIONS(6337),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6337),
    [anon_sym_AMP_EQ] = ACTIONS(6337),
    [anon_sym_PERCENT_EQ] = ACTIONS(6337),
    [anon_sym_GT_GT_EQ] = ACTIONS(6337),
    [anon_sym_LT_LT_EQ] = ACTIONS(6337),
    [anon_sym_CARET_EQ] = ACTIONS(6337),
    [anon_sym_QMARK] = ACTIONS(6337),
    [anon_sym_COLON2] = ACTIONS(6339),
    [anon_sym_DOT_DOT] = ACTIONS(6339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6337),
    [anon_sym_and] = ACTIONS(6337),
    [anon_sym_or] = ACTIONS(6337),
    [anon_sym_PIPE_PIPE] = ACTIONS(6339),
    [anon_sym_AMP_AMP] = ACTIONS(6339),
    [anon_sym_LT_LT] = ACTIONS(6339),
    [anon_sym_GT_GT] = ACTIONS(6339),
    [anon_sym_EQ_EQ] = ACTIONS(6339),
    [anon_sym_BANG_EQ] = ACTIONS(6337),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6337),
    [anon_sym_LT_EQ_GT] = ACTIONS(6337),
    [anon_sym_EQ_TILDE] = ACTIONS(6337),
    [anon_sym_BANG_TILDE] = ACTIONS(6337),
    [anon_sym_LT_EQ] = ACTIONS(6339),
    [anon_sym_GT] = ACTIONS(6339),
    [anon_sym_GT_EQ] = ACTIONS(6337),
    [anon_sym_CARET] = ACTIONS(6339),
    [anon_sym_PLUS] = ACTIONS(6339),
    [anon_sym_SLASH] = ACTIONS(6339),
    [anon_sym_PERCENT] = ACTIONS(6339),
    [sym_comment] = ACTIONS(87),
  },
  [9900] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14200),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9901] = {
    [aux_sym_string_array_repeat1] = STATE(1680),
    [sym__string_end] = ACTIONS(14200),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(14202),
  },
  [9902] = {
    [sym__heredoc_body_start] = ACTIONS(6345),
    [sym__binary_minus] = ACTIONS(6345),
    [sym__binary_star] = ACTIONS(6345),
    [anon_sym_LBRACE] = ACTIONS(6345),
    [anon_sym_RBRACE] = ACTIONS(6345),
    [anon_sym_RPAREN] = ACTIONS(6345),
    [anon_sym_DOT] = ACTIONS(6347),
    [anon_sym_COMMA] = ACTIONS(6345),
    [anon_sym_PIPE] = ACTIONS(6347),
    [anon_sym_SEMI] = ACTIONS(6345),
    [anon_sym_STAR_STAR] = ACTIONS(6347),
    [anon_sym_AMP] = ACTIONS(6347),
    [anon_sym_EQ] = ACTIONS(6347),
    [anon_sym_LT] = ACTIONS(6347),
    [anon_sym_if] = ACTIONS(6345),
    [anon_sym_unless] = ACTIONS(6345),
    [anon_sym_while] = ACTIONS(6345),
    [anon_sym_until] = ACTIONS(6345),
    [anon_sym_rescue] = ACTIONS(6345),
    [anon_sym_in] = ACTIONS(6345),
    [anon_sym_do] = ACTIONS(6345),
    [anon_sym_LBRACK] = ACTIONS(6345),
    [anon_sym_RBRACK] = ACTIONS(6345),
    [anon_sym_COLON_COLON2] = ACTIONS(6345),
    [anon_sym_AMP_DOT] = ACTIONS(6345),
    [anon_sym_PLUS_EQ] = ACTIONS(6345),
    [anon_sym_DASH_EQ] = ACTIONS(6345),
    [anon_sym_STAR_EQ] = ACTIONS(6345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6345),
    [anon_sym_SLASH_EQ] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6345),
    [anon_sym_PIPE_EQ] = ACTIONS(6345),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6345),
    [anon_sym_AMP_EQ] = ACTIONS(6345),
    [anon_sym_PERCENT_EQ] = ACTIONS(6345),
    [anon_sym_GT_GT_EQ] = ACTIONS(6345),
    [anon_sym_LT_LT_EQ] = ACTIONS(6345),
    [anon_sym_CARET_EQ] = ACTIONS(6345),
    [anon_sym_QMARK] = ACTIONS(6345),
    [anon_sym_COLON2] = ACTIONS(6347),
    [anon_sym_DOT_DOT] = ACTIONS(6347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6345),
    [anon_sym_and] = ACTIONS(6345),
    [anon_sym_or] = ACTIONS(6345),
    [anon_sym_PIPE_PIPE] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(6347),
    [anon_sym_LT_LT] = ACTIONS(6347),
    [anon_sym_GT_GT] = ACTIONS(6347),
    [anon_sym_EQ_EQ] = ACTIONS(6347),
    [anon_sym_BANG_EQ] = ACTIONS(6345),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6345),
    [anon_sym_LT_EQ_GT] = ACTIONS(6345),
    [anon_sym_EQ_TILDE] = ACTIONS(6345),
    [anon_sym_BANG_TILDE] = ACTIONS(6345),
    [anon_sym_LT_EQ] = ACTIONS(6347),
    [anon_sym_GT] = ACTIONS(6347),
    [anon_sym_GT_EQ] = ACTIONS(6345),
    [anon_sym_CARET] = ACTIONS(6347),
    [anon_sym_PLUS] = ACTIONS(6347),
    [anon_sym_SLASH] = ACTIONS(6347),
    [anon_sym_PERCENT] = ACTIONS(6347),
    [sym_comment] = ACTIONS(87),
  },
  [9903] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14204),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9904] = {
    [sym__heredoc_body_start] = ACTIONS(6358),
    [sym__binary_minus] = ACTIONS(6358),
    [sym__binary_star] = ACTIONS(6358),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RBRACE] = ACTIONS(6358),
    [anon_sym_RPAREN] = ACTIONS(6358),
    [anon_sym_DOT] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6360),
    [anon_sym_SEMI] = ACTIONS(6358),
    [anon_sym_STAR_STAR] = ACTIONS(6360),
    [anon_sym_AMP] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6360),
    [anon_sym_if] = ACTIONS(6358),
    [anon_sym_unless] = ACTIONS(6358),
    [anon_sym_while] = ACTIONS(6358),
    [anon_sym_until] = ACTIONS(6358),
    [anon_sym_rescue] = ACTIONS(6358),
    [anon_sym_in] = ACTIONS(6358),
    [anon_sym_do] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6358),
    [anon_sym_RBRACK] = ACTIONS(6358),
    [anon_sym_COLON_COLON2] = ACTIONS(6358),
    [anon_sym_AMP_DOT] = ACTIONS(6358),
    [anon_sym_PLUS_EQ] = ACTIONS(6358),
    [anon_sym_DASH_EQ] = ACTIONS(6358),
    [anon_sym_STAR_EQ] = ACTIONS(6358),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6358),
    [anon_sym_SLASH_EQ] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6358),
    [anon_sym_PIPE_EQ] = ACTIONS(6358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6358),
    [anon_sym_AMP_EQ] = ACTIONS(6358),
    [anon_sym_PERCENT_EQ] = ACTIONS(6358),
    [anon_sym_GT_GT_EQ] = ACTIONS(6358),
    [anon_sym_LT_LT_EQ] = ACTIONS(6358),
    [anon_sym_CARET_EQ] = ACTIONS(6358),
    [anon_sym_QMARK] = ACTIONS(6358),
    [anon_sym_COLON2] = ACTIONS(6360),
    [anon_sym_DOT_DOT] = ACTIONS(6360),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6358),
    [anon_sym_and] = ACTIONS(6358),
    [anon_sym_or] = ACTIONS(6358),
    [anon_sym_PIPE_PIPE] = ACTIONS(6360),
    [anon_sym_AMP_AMP] = ACTIONS(6360),
    [anon_sym_LT_LT] = ACTIONS(6360),
    [anon_sym_GT_GT] = ACTIONS(6360),
    [anon_sym_EQ_EQ] = ACTIONS(6360),
    [anon_sym_BANG_EQ] = ACTIONS(6358),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6358),
    [anon_sym_LT_EQ_GT] = ACTIONS(6358),
    [anon_sym_EQ_TILDE] = ACTIONS(6358),
    [anon_sym_BANG_TILDE] = ACTIONS(6358),
    [anon_sym_LT_EQ] = ACTIONS(6360),
    [anon_sym_GT] = ACTIONS(6360),
    [anon_sym_GT_EQ] = ACTIONS(6358),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_PERCENT] = ACTIONS(6360),
    [sym_comment] = ACTIONS(87),
  },
  [9905] = {
    [sym__heredoc_body_start] = ACTIONS(6362),
    [sym__binary_minus] = ACTIONS(6362),
    [sym__binary_star] = ACTIONS(6362),
    [anon_sym_LBRACE] = ACTIONS(6362),
    [anon_sym_RBRACE] = ACTIONS(6362),
    [anon_sym_RPAREN] = ACTIONS(6362),
    [anon_sym_DOT] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6364),
    [anon_sym_SEMI] = ACTIONS(6362),
    [anon_sym_STAR_STAR] = ACTIONS(6364),
    [anon_sym_AMP] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6364),
    [anon_sym_if] = ACTIONS(6362),
    [anon_sym_unless] = ACTIONS(6362),
    [anon_sym_while] = ACTIONS(6362),
    [anon_sym_until] = ACTIONS(6362),
    [anon_sym_rescue] = ACTIONS(6362),
    [anon_sym_in] = ACTIONS(6362),
    [anon_sym_do] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6362),
    [anon_sym_RBRACK] = ACTIONS(6362),
    [anon_sym_COLON_COLON2] = ACTIONS(6362),
    [anon_sym_AMP_DOT] = ACTIONS(6362),
    [anon_sym_PLUS_EQ] = ACTIONS(6362),
    [anon_sym_DASH_EQ] = ACTIONS(6362),
    [anon_sym_STAR_EQ] = ACTIONS(6362),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6362),
    [anon_sym_SLASH_EQ] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6362),
    [anon_sym_PIPE_EQ] = ACTIONS(6362),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6362),
    [anon_sym_AMP_EQ] = ACTIONS(6362),
    [anon_sym_PERCENT_EQ] = ACTIONS(6362),
    [anon_sym_GT_GT_EQ] = ACTIONS(6362),
    [anon_sym_LT_LT_EQ] = ACTIONS(6362),
    [anon_sym_CARET_EQ] = ACTIONS(6362),
    [anon_sym_QMARK] = ACTIONS(6362),
    [anon_sym_COLON2] = ACTIONS(6364),
    [anon_sym_DOT_DOT] = ACTIONS(6364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6362),
    [anon_sym_and] = ACTIONS(6362),
    [anon_sym_or] = ACTIONS(6362),
    [anon_sym_PIPE_PIPE] = ACTIONS(6364),
    [anon_sym_AMP_AMP] = ACTIONS(6364),
    [anon_sym_LT_LT] = ACTIONS(6364),
    [anon_sym_GT_GT] = ACTIONS(6364),
    [anon_sym_EQ_EQ] = ACTIONS(6364),
    [anon_sym_BANG_EQ] = ACTIONS(6362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6362),
    [anon_sym_LT_EQ_GT] = ACTIONS(6362),
    [anon_sym_EQ_TILDE] = ACTIONS(6362),
    [anon_sym_BANG_TILDE] = ACTIONS(6362),
    [anon_sym_LT_EQ] = ACTIONS(6364),
    [anon_sym_GT] = ACTIONS(6364),
    [anon_sym_GT_EQ] = ACTIONS(6362),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_PERCENT] = ACTIONS(6364),
    [sym_comment] = ACTIONS(87),
  },
  [9906] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14206),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9907] = {
    [aux_sym_symbol_array_repeat1] = STATE(1688),
    [sym__string_end] = ACTIONS(14206),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(14208),
  },
  [9908] = {
    [sym__heredoc_body_start] = ACTIONS(6370),
    [sym__binary_minus] = ACTIONS(6370),
    [sym__binary_star] = ACTIONS(6370),
    [anon_sym_LBRACE] = ACTIONS(6370),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_RPAREN] = ACTIONS(6370),
    [anon_sym_DOT] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6372),
    [anon_sym_SEMI] = ACTIONS(6370),
    [anon_sym_STAR_STAR] = ACTIONS(6372),
    [anon_sym_AMP] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6372),
    [anon_sym_if] = ACTIONS(6370),
    [anon_sym_unless] = ACTIONS(6370),
    [anon_sym_while] = ACTIONS(6370),
    [anon_sym_until] = ACTIONS(6370),
    [anon_sym_rescue] = ACTIONS(6370),
    [anon_sym_in] = ACTIONS(6370),
    [anon_sym_do] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6370),
    [anon_sym_RBRACK] = ACTIONS(6370),
    [anon_sym_COLON_COLON2] = ACTIONS(6370),
    [anon_sym_AMP_DOT] = ACTIONS(6370),
    [anon_sym_PLUS_EQ] = ACTIONS(6370),
    [anon_sym_DASH_EQ] = ACTIONS(6370),
    [anon_sym_STAR_EQ] = ACTIONS(6370),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6370),
    [anon_sym_SLASH_EQ] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6370),
    [anon_sym_PIPE_EQ] = ACTIONS(6370),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6370),
    [anon_sym_AMP_EQ] = ACTIONS(6370),
    [anon_sym_PERCENT_EQ] = ACTIONS(6370),
    [anon_sym_GT_GT_EQ] = ACTIONS(6370),
    [anon_sym_LT_LT_EQ] = ACTIONS(6370),
    [anon_sym_CARET_EQ] = ACTIONS(6370),
    [anon_sym_QMARK] = ACTIONS(6370),
    [anon_sym_COLON2] = ACTIONS(6372),
    [anon_sym_DOT_DOT] = ACTIONS(6372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6370),
    [anon_sym_and] = ACTIONS(6370),
    [anon_sym_or] = ACTIONS(6370),
    [anon_sym_PIPE_PIPE] = ACTIONS(6372),
    [anon_sym_AMP_AMP] = ACTIONS(6372),
    [anon_sym_LT_LT] = ACTIONS(6372),
    [anon_sym_GT_GT] = ACTIONS(6372),
    [anon_sym_EQ_EQ] = ACTIONS(6372),
    [anon_sym_BANG_EQ] = ACTIONS(6370),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6370),
    [anon_sym_LT_EQ_GT] = ACTIONS(6370),
    [anon_sym_EQ_TILDE] = ACTIONS(6370),
    [anon_sym_BANG_TILDE] = ACTIONS(6370),
    [anon_sym_LT_EQ] = ACTIONS(6372),
    [anon_sym_GT] = ACTIONS(6372),
    [anon_sym_GT_EQ] = ACTIONS(6370),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_PERCENT] = ACTIONS(6372),
    [sym_comment] = ACTIONS(87),
  },
  [9909] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14210),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9910] = {
    [sym__heredoc_body_start] = ACTIONS(6894),
    [sym__binary_minus] = ACTIONS(6894),
    [sym__binary_star] = ACTIONS(6894),
    [anon_sym_LBRACE] = ACTIONS(6894),
    [anon_sym_RBRACE] = ACTIONS(6894),
    [anon_sym_RPAREN] = ACTIONS(6894),
    [anon_sym_DOT] = ACTIONS(6896),
    [anon_sym_COMMA] = ACTIONS(6894),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_SEMI] = ACTIONS(6894),
    [anon_sym_STAR_STAR] = ACTIONS(6896),
    [anon_sym_AMP] = ACTIONS(6896),
    [anon_sym_EQ] = ACTIONS(6896),
    [anon_sym_LT] = ACTIONS(6896),
    [anon_sym_if] = ACTIONS(6894),
    [anon_sym_unless] = ACTIONS(6894),
    [anon_sym_while] = ACTIONS(6894),
    [anon_sym_until] = ACTIONS(6894),
    [anon_sym_rescue] = ACTIONS(6894),
    [anon_sym_in] = ACTIONS(6894),
    [anon_sym_do] = ACTIONS(6894),
    [anon_sym_LBRACK] = ACTIONS(6894),
    [anon_sym_RBRACK] = ACTIONS(6894),
    [anon_sym_COLON_COLON2] = ACTIONS(6894),
    [anon_sym_AMP_DOT] = ACTIONS(6894),
    [anon_sym_PLUS_EQ] = ACTIONS(6894),
    [anon_sym_DASH_EQ] = ACTIONS(6894),
    [anon_sym_STAR_EQ] = ACTIONS(6894),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6894),
    [anon_sym_SLASH_EQ] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6894),
    [anon_sym_PIPE_EQ] = ACTIONS(6894),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6894),
    [anon_sym_AMP_EQ] = ACTIONS(6894),
    [anon_sym_PERCENT_EQ] = ACTIONS(6894),
    [anon_sym_GT_GT_EQ] = ACTIONS(6894),
    [anon_sym_LT_LT_EQ] = ACTIONS(6894),
    [anon_sym_CARET_EQ] = ACTIONS(6894),
    [anon_sym_QMARK] = ACTIONS(6894),
    [anon_sym_COLON2] = ACTIONS(6896),
    [anon_sym_DOT_DOT] = ACTIONS(6896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6894),
    [anon_sym_and] = ACTIONS(6894),
    [anon_sym_or] = ACTIONS(6894),
    [anon_sym_PIPE_PIPE] = ACTIONS(6896),
    [anon_sym_AMP_AMP] = ACTIONS(6896),
    [anon_sym_LT_LT] = ACTIONS(6896),
    [anon_sym_GT_GT] = ACTIONS(6896),
    [anon_sym_EQ_EQ] = ACTIONS(6896),
    [anon_sym_BANG_EQ] = ACTIONS(6894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6894),
    [anon_sym_LT_EQ_GT] = ACTIONS(6894),
    [anon_sym_EQ_TILDE] = ACTIONS(6894),
    [anon_sym_BANG_TILDE] = ACTIONS(6894),
    [anon_sym_LT_EQ] = ACTIONS(6896),
    [anon_sym_GT] = ACTIONS(6896),
    [anon_sym_GT_EQ] = ACTIONS(6894),
    [anon_sym_CARET] = ACTIONS(6896),
    [anon_sym_PLUS] = ACTIONS(6896),
    [anon_sym_SLASH] = ACTIONS(6896),
    [anon_sym_PERCENT] = ACTIONS(6896),
    [sym_comment] = ACTIONS(87),
  },
  [9911] = {
    [anon_sym_DOT] = ACTIONS(14212),
    [anon_sym_COLON_COLON] = ACTIONS(14212),
    [sym_comment] = ACTIONS(87),
  },
  [9912] = {
    [sym__heredoc_body_start] = ACTIONS(7046),
    [sym__binary_minus] = ACTIONS(7046),
    [sym__binary_star] = ACTIONS(7046),
    [anon_sym_LBRACE] = ACTIONS(7046),
    [anon_sym_RBRACE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7046),
    [anon_sym_DOT] = ACTIONS(7048),
    [anon_sym_COMMA] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_STAR_STAR] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7048),
    [anon_sym_if] = ACTIONS(7046),
    [anon_sym_unless] = ACTIONS(7046),
    [anon_sym_while] = ACTIONS(7046),
    [anon_sym_until] = ACTIONS(7046),
    [anon_sym_rescue] = ACTIONS(7046),
    [anon_sym_in] = ACTIONS(7046),
    [anon_sym_do] = ACTIONS(7046),
    [anon_sym_LBRACK] = ACTIONS(7046),
    [anon_sym_RBRACK] = ACTIONS(7046),
    [anon_sym_COLON_COLON2] = ACTIONS(7046),
    [anon_sym_AMP_DOT] = ACTIONS(7046),
    [anon_sym_PLUS_EQ] = ACTIONS(7046),
    [anon_sym_DASH_EQ] = ACTIONS(7046),
    [anon_sym_STAR_EQ] = ACTIONS(7046),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7046),
    [anon_sym_SLASH_EQ] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7046),
    [anon_sym_PIPE_EQ] = ACTIONS(7046),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7046),
    [anon_sym_AMP_EQ] = ACTIONS(7046),
    [anon_sym_PERCENT_EQ] = ACTIONS(7046),
    [anon_sym_GT_GT_EQ] = ACTIONS(7046),
    [anon_sym_LT_LT_EQ] = ACTIONS(7046),
    [anon_sym_CARET_EQ] = ACTIONS(7046),
    [anon_sym_QMARK] = ACTIONS(7046),
    [anon_sym_COLON2] = ACTIONS(7048),
    [anon_sym_DOT_DOT] = ACTIONS(7048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7046),
    [anon_sym_and] = ACTIONS(7046),
    [anon_sym_or] = ACTIONS(7046),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7048),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_BANG_EQ] = ACTIONS(7046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT_EQ_GT] = ACTIONS(7046),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_BANG_TILDE] = ACTIONS(7046),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7046),
    [anon_sym_CARET] = ACTIONS(7048),
    [anon_sym_PLUS] = ACTIONS(7048),
    [anon_sym_SLASH] = ACTIONS(7048),
    [anon_sym_PERCENT] = ACTIONS(7048),
    [sym_comment] = ACTIONS(87),
  },
  [9913] = {
    [sym__heredoc_body_start] = ACTIONS(7062),
    [sym__binary_minus] = ACTIONS(7062),
    [sym__binary_star] = ACTIONS(7062),
    [anon_sym_LBRACE] = ACTIONS(7062),
    [anon_sym_RBRACE] = ACTIONS(7062),
    [anon_sym_RPAREN] = ACTIONS(7062),
    [anon_sym_DOT] = ACTIONS(7064),
    [anon_sym_COMMA] = ACTIONS(7062),
    [anon_sym_PIPE] = ACTIONS(7064),
    [anon_sym_SEMI] = ACTIONS(7062),
    [anon_sym_STAR_STAR] = ACTIONS(7064),
    [anon_sym_AMP] = ACTIONS(7064),
    [anon_sym_EQ] = ACTIONS(7064),
    [anon_sym_LT] = ACTIONS(7064),
    [anon_sym_if] = ACTIONS(7062),
    [anon_sym_unless] = ACTIONS(7062),
    [anon_sym_while] = ACTIONS(7062),
    [anon_sym_until] = ACTIONS(7062),
    [anon_sym_rescue] = ACTIONS(7062),
    [anon_sym_in] = ACTIONS(7062),
    [anon_sym_do] = ACTIONS(7062),
    [anon_sym_LBRACK] = ACTIONS(7062),
    [anon_sym_RBRACK] = ACTIONS(7062),
    [anon_sym_COLON_COLON2] = ACTIONS(7062),
    [anon_sym_AMP_DOT] = ACTIONS(7062),
    [anon_sym_PLUS_EQ] = ACTIONS(7062),
    [anon_sym_DASH_EQ] = ACTIONS(7062),
    [anon_sym_STAR_EQ] = ACTIONS(7062),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7062),
    [anon_sym_SLASH_EQ] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7062),
    [anon_sym_PIPE_EQ] = ACTIONS(7062),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7062),
    [anon_sym_AMP_EQ] = ACTIONS(7062),
    [anon_sym_PERCENT_EQ] = ACTIONS(7062),
    [anon_sym_GT_GT_EQ] = ACTIONS(7062),
    [anon_sym_LT_LT_EQ] = ACTIONS(7062),
    [anon_sym_CARET_EQ] = ACTIONS(7062),
    [anon_sym_QMARK] = ACTIONS(7062),
    [anon_sym_COLON2] = ACTIONS(7064),
    [anon_sym_DOT_DOT] = ACTIONS(7064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7062),
    [anon_sym_and] = ACTIONS(7062),
    [anon_sym_or] = ACTIONS(7062),
    [anon_sym_PIPE_PIPE] = ACTIONS(7064),
    [anon_sym_AMP_AMP] = ACTIONS(7064),
    [anon_sym_LT_LT] = ACTIONS(7064),
    [anon_sym_GT_GT] = ACTIONS(7064),
    [anon_sym_EQ_EQ] = ACTIONS(7064),
    [anon_sym_BANG_EQ] = ACTIONS(7062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7062),
    [anon_sym_LT_EQ_GT] = ACTIONS(7062),
    [anon_sym_EQ_TILDE] = ACTIONS(7062),
    [anon_sym_BANG_TILDE] = ACTIONS(7062),
    [anon_sym_LT_EQ] = ACTIONS(7064),
    [anon_sym_GT] = ACTIONS(7064),
    [anon_sym_GT_EQ] = ACTIONS(7062),
    [anon_sym_CARET] = ACTIONS(7064),
    [anon_sym_PLUS] = ACTIONS(7064),
    [anon_sym_SLASH] = ACTIONS(7064),
    [anon_sym_PERCENT] = ACTIONS(7064),
    [sym_comment] = ACTIONS(87),
  },
  [9914] = {
    [sym__statements] = STATE(6463),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(6464),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(6465),
    [sym_rescue] = STATE(6466),
    [sym__body_statement] = STATE(10597),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14214),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9915] = {
    [sym__statements] = STATE(6463),
    [sym__top_level_statement] = STATE(286),
    [sym_begin_block] = STATE(286),
    [sym_end_block] = STATE(286),
    [sym__statement] = STATE(287),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(287),
    [sym_unless_modifier] = STATE(287),
    [sym_while_modifier] = STATE(287),
    [sym_until_modifier] = STATE(287),
    [sym_rescue_modifier] = STATE(287),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_else] = STATE(6464),
    [sym_begin] = STATE(47),
    [sym_ensure] = STATE(6465),
    [sym_rescue] = STATE(6466),
    [sym__body_statement] = STATE(10598),
    [sym__arg] = STATE(292),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(295),
    [sym_scope_resolution] = STATE(293),
    [sym_call] = STATE(293),
    [sym_method_call] = STATE(295),
    [sym_assignment] = STATE(292),
    [sym_operator_assignment] = STATE(292),
    [sym_conditional] = STATE(292),
    [sym_range] = STATE(292),
    [sym_binary] = STATE(292),
    [sym_unary] = STATE(292),
    [sym_left_assignment_list] = STATE(294),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(295),
    [sym__variable] = STATE(293),
    [sym_undef] = STATE(287),
    [sym_alias] = STATE(287),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(295),
    [sym_false] = STATE(295),
    [sym_nil] = STATE(295),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(296),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(287),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14216),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9916] = {
    [sym__heredoc_body_start] = ACTIONS(7496),
    [sym__binary_minus] = ACTIONS(7496),
    [sym__binary_star] = ACTIONS(7496),
    [anon_sym_LBRACE] = ACTIONS(7496),
    [anon_sym_RBRACE] = ACTIONS(7496),
    [anon_sym_RPAREN] = ACTIONS(7496),
    [anon_sym_DOT] = ACTIONS(7498),
    [anon_sym_COMMA] = ACTIONS(7496),
    [anon_sym_PIPE] = ACTIONS(7498),
    [anon_sym_SEMI] = ACTIONS(7496),
    [anon_sym_STAR_STAR] = ACTIONS(7498),
    [anon_sym_AMP] = ACTIONS(7498),
    [anon_sym_EQ] = ACTIONS(7498),
    [anon_sym_LT] = ACTIONS(7498),
    [anon_sym_if] = ACTIONS(7496),
    [anon_sym_unless] = ACTIONS(7496),
    [anon_sym_while] = ACTIONS(7496),
    [anon_sym_until] = ACTIONS(7496),
    [anon_sym_rescue] = ACTIONS(7496),
    [anon_sym_in] = ACTIONS(7496),
    [anon_sym_do] = ACTIONS(7496),
    [anon_sym_LBRACK] = ACTIONS(7496),
    [anon_sym_RBRACK] = ACTIONS(7496),
    [anon_sym_COLON_COLON2] = ACTIONS(7496),
    [anon_sym_AMP_DOT] = ACTIONS(7496),
    [anon_sym_PLUS_EQ] = ACTIONS(7496),
    [anon_sym_DASH_EQ] = ACTIONS(7496),
    [anon_sym_STAR_EQ] = ACTIONS(7496),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7496),
    [anon_sym_SLASH_EQ] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7496),
    [anon_sym_PIPE_EQ] = ACTIONS(7496),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7496),
    [anon_sym_AMP_EQ] = ACTIONS(7496),
    [anon_sym_PERCENT_EQ] = ACTIONS(7496),
    [anon_sym_GT_GT_EQ] = ACTIONS(7496),
    [anon_sym_LT_LT_EQ] = ACTIONS(7496),
    [anon_sym_CARET_EQ] = ACTIONS(7496),
    [anon_sym_QMARK] = ACTIONS(7496),
    [anon_sym_COLON2] = ACTIONS(7498),
    [anon_sym_DOT_DOT] = ACTIONS(7498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7496),
    [anon_sym_and] = ACTIONS(7496),
    [anon_sym_or] = ACTIONS(7496),
    [anon_sym_PIPE_PIPE] = ACTIONS(7498),
    [anon_sym_AMP_AMP] = ACTIONS(7498),
    [anon_sym_LT_LT] = ACTIONS(7498),
    [anon_sym_GT_GT] = ACTIONS(7498),
    [anon_sym_EQ_EQ] = ACTIONS(7498),
    [anon_sym_BANG_EQ] = ACTIONS(7496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7496),
    [anon_sym_LT_EQ_GT] = ACTIONS(7496),
    [anon_sym_EQ_TILDE] = ACTIONS(7496),
    [anon_sym_BANG_TILDE] = ACTIONS(7496),
    [anon_sym_LT_EQ] = ACTIONS(7498),
    [anon_sym_GT] = ACTIONS(7498),
    [anon_sym_GT_EQ] = ACTIONS(7496),
    [anon_sym_CARET] = ACTIONS(7498),
    [anon_sym_PLUS] = ACTIONS(7498),
    [anon_sym_SLASH] = ACTIONS(7498),
    [anon_sym_PERCENT] = ACTIONS(7498),
    [sym_comment] = ACTIONS(87),
  },
  [9917] = {
    [sym__heredoc_body_start] = ACTIONS(7550),
    [sym__binary_minus] = ACTIONS(7550),
    [sym__binary_star] = ACTIONS(7550),
    [anon_sym_LBRACE] = ACTIONS(7550),
    [anon_sym_RBRACE] = ACTIONS(7550),
    [anon_sym_RPAREN] = ACTIONS(7550),
    [anon_sym_DOT] = ACTIONS(7552),
    [anon_sym_COMMA] = ACTIONS(7550),
    [anon_sym_PIPE] = ACTIONS(7552),
    [anon_sym_SEMI] = ACTIONS(7550),
    [anon_sym_STAR_STAR] = ACTIONS(7552),
    [anon_sym_AMP] = ACTIONS(7552),
    [anon_sym_EQ] = ACTIONS(7552),
    [anon_sym_LT] = ACTIONS(7552),
    [anon_sym_if] = ACTIONS(7550),
    [anon_sym_unless] = ACTIONS(7550),
    [anon_sym_while] = ACTIONS(7550),
    [anon_sym_until] = ACTIONS(7550),
    [anon_sym_rescue] = ACTIONS(7550),
    [anon_sym_in] = ACTIONS(7550),
    [anon_sym_do] = ACTIONS(7550),
    [anon_sym_LBRACK] = ACTIONS(7550),
    [anon_sym_RBRACK] = ACTIONS(7550),
    [anon_sym_COLON_COLON2] = ACTIONS(7550),
    [anon_sym_AMP_DOT] = ACTIONS(7550),
    [anon_sym_PLUS_EQ] = ACTIONS(7550),
    [anon_sym_DASH_EQ] = ACTIONS(7550),
    [anon_sym_STAR_EQ] = ACTIONS(7550),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7550),
    [anon_sym_SLASH_EQ] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7550),
    [anon_sym_PIPE_EQ] = ACTIONS(7550),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7550),
    [anon_sym_AMP_EQ] = ACTIONS(7550),
    [anon_sym_PERCENT_EQ] = ACTIONS(7550),
    [anon_sym_GT_GT_EQ] = ACTIONS(7550),
    [anon_sym_LT_LT_EQ] = ACTIONS(7550),
    [anon_sym_CARET_EQ] = ACTIONS(7550),
    [anon_sym_QMARK] = ACTIONS(7550),
    [anon_sym_COLON2] = ACTIONS(7552),
    [anon_sym_DOT_DOT] = ACTIONS(7552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7550),
    [anon_sym_and] = ACTIONS(7550),
    [anon_sym_or] = ACTIONS(7550),
    [anon_sym_PIPE_PIPE] = ACTIONS(7552),
    [anon_sym_AMP_AMP] = ACTIONS(7552),
    [anon_sym_LT_LT] = ACTIONS(7552),
    [anon_sym_GT_GT] = ACTIONS(7552),
    [anon_sym_EQ_EQ] = ACTIONS(7552),
    [anon_sym_BANG_EQ] = ACTIONS(7550),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7550),
    [anon_sym_LT_EQ_GT] = ACTIONS(7550),
    [anon_sym_EQ_TILDE] = ACTIONS(7550),
    [anon_sym_BANG_TILDE] = ACTIONS(7550),
    [anon_sym_LT_EQ] = ACTIONS(7552),
    [anon_sym_GT] = ACTIONS(7552),
    [anon_sym_GT_EQ] = ACTIONS(7550),
    [anon_sym_CARET] = ACTIONS(7552),
    [anon_sym_PLUS] = ACTIONS(7552),
    [anon_sym_SLASH] = ACTIONS(7552),
    [anon_sym_PERCENT] = ACTIONS(7552),
    [sym_comment] = ACTIONS(87),
  },
  [9918] = {
    [sym__heredoc_body_start] = ACTIONS(7724),
    [sym__binary_minus] = ACTIONS(7724),
    [sym__binary_star] = ACTIONS(7724),
    [anon_sym_LBRACE] = ACTIONS(7724),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_RPAREN] = ACTIONS(7724),
    [anon_sym_DOT] = ACTIONS(7726),
    [anon_sym_COMMA] = ACTIONS(7724),
    [anon_sym_PIPE] = ACTIONS(7726),
    [anon_sym_SEMI] = ACTIONS(7724),
    [anon_sym_STAR_STAR] = ACTIONS(7726),
    [anon_sym_AMP] = ACTIONS(7726),
    [anon_sym_EQ] = ACTIONS(7726),
    [anon_sym_LT] = ACTIONS(7726),
    [anon_sym_if] = ACTIONS(7724),
    [anon_sym_unless] = ACTIONS(7724),
    [anon_sym_while] = ACTIONS(7724),
    [anon_sym_until] = ACTIONS(7724),
    [anon_sym_rescue] = ACTIONS(7724),
    [anon_sym_in] = ACTIONS(7724),
    [anon_sym_do] = ACTIONS(7724),
    [anon_sym_LBRACK] = ACTIONS(7724),
    [anon_sym_RBRACK] = ACTIONS(7724),
    [anon_sym_COLON_COLON2] = ACTIONS(7724),
    [anon_sym_AMP_DOT] = ACTIONS(7724),
    [anon_sym_PLUS_EQ] = ACTIONS(7724),
    [anon_sym_DASH_EQ] = ACTIONS(7724),
    [anon_sym_STAR_EQ] = ACTIONS(7724),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7724),
    [anon_sym_SLASH_EQ] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7724),
    [anon_sym_PIPE_EQ] = ACTIONS(7724),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7724),
    [anon_sym_AMP_EQ] = ACTIONS(7724),
    [anon_sym_PERCENT_EQ] = ACTIONS(7724),
    [anon_sym_GT_GT_EQ] = ACTIONS(7724),
    [anon_sym_LT_LT_EQ] = ACTIONS(7724),
    [anon_sym_CARET_EQ] = ACTIONS(7724),
    [anon_sym_QMARK] = ACTIONS(7724),
    [anon_sym_COLON2] = ACTIONS(7726),
    [anon_sym_DOT_DOT] = ACTIONS(7726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7724),
    [anon_sym_and] = ACTIONS(7724),
    [anon_sym_or] = ACTIONS(7724),
    [anon_sym_PIPE_PIPE] = ACTIONS(7726),
    [anon_sym_AMP_AMP] = ACTIONS(7726),
    [anon_sym_LT_LT] = ACTIONS(7726),
    [anon_sym_GT_GT] = ACTIONS(7726),
    [anon_sym_EQ_EQ] = ACTIONS(7726),
    [anon_sym_BANG_EQ] = ACTIONS(7724),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7724),
    [anon_sym_LT_EQ_GT] = ACTIONS(7724),
    [anon_sym_EQ_TILDE] = ACTIONS(7724),
    [anon_sym_BANG_TILDE] = ACTIONS(7724),
    [anon_sym_LT_EQ] = ACTIONS(7726),
    [anon_sym_GT] = ACTIONS(7726),
    [anon_sym_GT_EQ] = ACTIONS(7724),
    [anon_sym_CARET] = ACTIONS(7726),
    [anon_sym_PLUS] = ACTIONS(7726),
    [anon_sym_SLASH] = ACTIONS(7726),
    [anon_sym_PERCENT] = ACTIONS(7726),
    [sym_comment] = ACTIONS(87),
  },
  [9919] = {
    [sym_elsif] = STATE(10600),
    [sym_else] = STATE(10600),
    [sym__if_tail] = STATE(10600),
    [anon_sym_end] = ACTIONS(14218),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [9920] = {
    [anon_sym_end] = ACTIONS(14218),
    [sym_comment] = ACTIONS(87),
  },
  [9921] = {
    [sym__statements] = STATE(10601),
    [sym__top_level_statement] = STATE(2629),
    [sym_begin_block] = STATE(2629),
    [sym_end_block] = STATE(2629),
    [sym__statement] = STATE(2630),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(2630),
    [sym_unless_modifier] = STATE(2630),
    [sym_while_modifier] = STATE(2630),
    [sym_until_modifier] = STATE(2630),
    [sym_rescue_modifier] = STATE(2630),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_elsif] = STATE(10600),
    [sym_else] = STATE(10600),
    [sym__if_tail] = STATE(10600),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(2632),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(2635),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(2635),
    [sym_assignment] = STATE(2632),
    [sym_operator_assignment] = STATE(2632),
    [sym_conditional] = STATE(2632),
    [sym_range] = STATE(2632),
    [sym_binary] = STATE(2632),
    [sym_unary] = STATE(2632),
    [sym_left_assignment_list] = STATE(2634),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2635),
    [sym__variable] = STATE(2633),
    [sym_undef] = STATE(2630),
    [sym_alias] = STATE(2630),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(2635),
    [sym_false] = STATE(2635),
    [sym_nil] = STATE(2635),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2636),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(2630),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(4336),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14220),
    [anon_sym_return] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4342),
    [anon_sym_break] = ACTIONS(4344),
    [anon_sym_next] = ACTIONS(4346),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4348),
    [anon_sym_else] = ACTIONS(4350),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4352),
    [anon_sym_defined_QMARK] = ACTIONS(4354),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [anon_sym_undef] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9922] = {
    [sym__heredoc_body_start] = ACTIONS(7922),
    [sym__binary_minus] = ACTIONS(7922),
    [sym__binary_star] = ACTIONS(7922),
    [anon_sym_LBRACE] = ACTIONS(7922),
    [anon_sym_RBRACE] = ACTIONS(7922),
    [anon_sym_RPAREN] = ACTIONS(7922),
    [anon_sym_DOT] = ACTIONS(7924),
    [anon_sym_COMMA] = ACTIONS(7922),
    [anon_sym_PIPE] = ACTIONS(7924),
    [anon_sym_SEMI] = ACTIONS(7922),
    [anon_sym_STAR_STAR] = ACTIONS(7924),
    [anon_sym_AMP] = ACTIONS(7924),
    [anon_sym_EQ] = ACTIONS(7924),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(7922),
    [anon_sym_unless] = ACTIONS(7922),
    [anon_sym_while] = ACTIONS(7922),
    [anon_sym_until] = ACTIONS(7922),
    [anon_sym_rescue] = ACTIONS(7922),
    [anon_sym_in] = ACTIONS(7922),
    [anon_sym_do] = ACTIONS(7922),
    [anon_sym_LBRACK] = ACTIONS(7922),
    [anon_sym_RBRACK] = ACTIONS(7922),
    [anon_sym_COLON_COLON2] = ACTIONS(7922),
    [anon_sym_AMP_DOT] = ACTIONS(7922),
    [anon_sym_PLUS_EQ] = ACTIONS(7922),
    [anon_sym_DASH_EQ] = ACTIONS(7922),
    [anon_sym_STAR_EQ] = ACTIONS(7922),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7922),
    [anon_sym_SLASH_EQ] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7922),
    [anon_sym_PIPE_EQ] = ACTIONS(7922),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7922),
    [anon_sym_AMP_EQ] = ACTIONS(7922),
    [anon_sym_PERCENT_EQ] = ACTIONS(7922),
    [anon_sym_GT_GT_EQ] = ACTIONS(7922),
    [anon_sym_LT_LT_EQ] = ACTIONS(7922),
    [anon_sym_CARET_EQ] = ACTIONS(7922),
    [anon_sym_QMARK] = ACTIONS(7922),
    [anon_sym_COLON2] = ACTIONS(7924),
    [anon_sym_DOT_DOT] = ACTIONS(7924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7922),
    [anon_sym_and] = ACTIONS(7922),
    [anon_sym_or] = ACTIONS(7922),
    [anon_sym_PIPE_PIPE] = ACTIONS(7924),
    [anon_sym_AMP_AMP] = ACTIONS(7924),
    [anon_sym_LT_LT] = ACTIONS(7924),
    [anon_sym_GT_GT] = ACTIONS(7924),
    [anon_sym_EQ_EQ] = ACTIONS(7924),
    [anon_sym_BANG_EQ] = ACTIONS(7922),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7922),
    [anon_sym_LT_EQ_GT] = ACTIONS(7922),
    [anon_sym_EQ_TILDE] = ACTIONS(7922),
    [anon_sym_BANG_TILDE] = ACTIONS(7922),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7922),
    [anon_sym_CARET] = ACTIONS(7924),
    [anon_sym_PLUS] = ACTIONS(7924),
    [anon_sym_SLASH] = ACTIONS(7924),
    [anon_sym_PERCENT] = ACTIONS(7924),
    [sym_comment] = ACTIONS(87),
  },
  [9923] = {
    [sym_else] = STATE(10603),
    [anon_sym_end] = ACTIONS(14222),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [9924] = {
    [anon_sym_end] = ACTIONS(14222),
    [sym_comment] = ACTIONS(87),
  },
  [9925] = {
    [sym__heredoc_body_start] = ACTIONS(8090),
    [sym__binary_minus] = ACTIONS(8090),
    [sym__binary_star] = ACTIONS(8090),
    [anon_sym_LBRACE] = ACTIONS(8090),
    [anon_sym_RBRACE] = ACTIONS(8090),
    [anon_sym_RPAREN] = ACTIONS(8090),
    [anon_sym_DOT] = ACTIONS(8092),
    [anon_sym_COMMA] = ACTIONS(8090),
    [anon_sym_PIPE] = ACTIONS(8092),
    [anon_sym_SEMI] = ACTIONS(8090),
    [anon_sym_STAR_STAR] = ACTIONS(8092),
    [anon_sym_AMP] = ACTIONS(8092),
    [anon_sym_EQ] = ACTIONS(8092),
    [anon_sym_LT] = ACTIONS(8092),
    [anon_sym_if] = ACTIONS(8090),
    [anon_sym_unless] = ACTIONS(8090),
    [anon_sym_while] = ACTIONS(8090),
    [anon_sym_until] = ACTIONS(8090),
    [anon_sym_rescue] = ACTIONS(8090),
    [anon_sym_in] = ACTIONS(8090),
    [anon_sym_do] = ACTIONS(8090),
    [anon_sym_LBRACK] = ACTIONS(8090),
    [anon_sym_RBRACK] = ACTIONS(8090),
    [anon_sym_COLON_COLON2] = ACTIONS(8090),
    [anon_sym_AMP_DOT] = ACTIONS(8090),
    [anon_sym_PLUS_EQ] = ACTIONS(8090),
    [anon_sym_DASH_EQ] = ACTIONS(8090),
    [anon_sym_STAR_EQ] = ACTIONS(8090),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8090),
    [anon_sym_SLASH_EQ] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8090),
    [anon_sym_PIPE_EQ] = ACTIONS(8090),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8090),
    [anon_sym_AMP_EQ] = ACTIONS(8090),
    [anon_sym_PERCENT_EQ] = ACTIONS(8090),
    [anon_sym_GT_GT_EQ] = ACTIONS(8090),
    [anon_sym_LT_LT_EQ] = ACTIONS(8090),
    [anon_sym_CARET_EQ] = ACTIONS(8090),
    [anon_sym_QMARK] = ACTIONS(8090),
    [anon_sym_COLON2] = ACTIONS(8092),
    [anon_sym_DOT_DOT] = ACTIONS(8092),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8090),
    [anon_sym_and] = ACTIONS(8090),
    [anon_sym_or] = ACTIONS(8090),
    [anon_sym_PIPE_PIPE] = ACTIONS(8092),
    [anon_sym_AMP_AMP] = ACTIONS(8092),
    [anon_sym_LT_LT] = ACTIONS(8092),
    [anon_sym_GT_GT] = ACTIONS(8092),
    [anon_sym_EQ_EQ] = ACTIONS(8092),
    [anon_sym_BANG_EQ] = ACTIONS(8090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8090),
    [anon_sym_LT_EQ_GT] = ACTIONS(8090),
    [anon_sym_EQ_TILDE] = ACTIONS(8090),
    [anon_sym_BANG_TILDE] = ACTIONS(8090),
    [anon_sym_LT_EQ] = ACTIONS(8092),
    [anon_sym_GT] = ACTIONS(8092),
    [anon_sym_GT_EQ] = ACTIONS(8090),
    [anon_sym_CARET] = ACTIONS(8092),
    [anon_sym_PLUS] = ACTIONS(8092),
    [anon_sym_SLASH] = ACTIONS(8092),
    [anon_sym_PERCENT] = ACTIONS(8092),
    [sym_comment] = ACTIONS(87),
  },
  [9926] = {
    [anon_sym_end] = ACTIONS(14224),
    [sym_comment] = ACTIONS(87),
  },
  [9927] = {
    [sym__heredoc_body_start] = ACTIONS(8166),
    [sym__binary_minus] = ACTIONS(8166),
    [sym__binary_star] = ACTIONS(8166),
    [anon_sym_LBRACE] = ACTIONS(8166),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_DOT] = ACTIONS(8168),
    [anon_sym_COMMA] = ACTIONS(8166),
    [anon_sym_PIPE] = ACTIONS(8168),
    [anon_sym_SEMI] = ACTIONS(8166),
    [anon_sym_STAR_STAR] = ACTIONS(8168),
    [anon_sym_AMP] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8168),
    [anon_sym_LT] = ACTIONS(8168),
    [anon_sym_if] = ACTIONS(8166),
    [anon_sym_unless] = ACTIONS(8166),
    [anon_sym_while] = ACTIONS(8166),
    [anon_sym_until] = ACTIONS(8166),
    [anon_sym_rescue] = ACTIONS(8166),
    [anon_sym_in] = ACTIONS(8166),
    [anon_sym_do] = ACTIONS(8166),
    [anon_sym_LBRACK] = ACTIONS(8166),
    [anon_sym_RBRACK] = ACTIONS(8166),
    [anon_sym_COLON_COLON2] = ACTIONS(8166),
    [anon_sym_AMP_DOT] = ACTIONS(8166),
    [anon_sym_PLUS_EQ] = ACTIONS(8166),
    [anon_sym_DASH_EQ] = ACTIONS(8166),
    [anon_sym_STAR_EQ] = ACTIONS(8166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8166),
    [anon_sym_SLASH_EQ] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8166),
    [anon_sym_PIPE_EQ] = ACTIONS(8166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8166),
    [anon_sym_AMP_EQ] = ACTIONS(8166),
    [anon_sym_PERCENT_EQ] = ACTIONS(8166),
    [anon_sym_GT_GT_EQ] = ACTIONS(8166),
    [anon_sym_LT_LT_EQ] = ACTIONS(8166),
    [anon_sym_CARET_EQ] = ACTIONS(8166),
    [anon_sym_QMARK] = ACTIONS(8166),
    [anon_sym_COLON2] = ACTIONS(8168),
    [anon_sym_DOT_DOT] = ACTIONS(8168),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8166),
    [anon_sym_and] = ACTIONS(8166),
    [anon_sym_or] = ACTIONS(8166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8168),
    [anon_sym_AMP_AMP] = ACTIONS(8168),
    [anon_sym_LT_LT] = ACTIONS(8168),
    [anon_sym_GT_GT] = ACTIONS(8168),
    [anon_sym_EQ_EQ] = ACTIONS(8168),
    [anon_sym_BANG_EQ] = ACTIONS(8166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8166),
    [anon_sym_LT_EQ_GT] = ACTIONS(8166),
    [anon_sym_EQ_TILDE] = ACTIONS(8166),
    [anon_sym_BANG_TILDE] = ACTIONS(8166),
    [anon_sym_LT_EQ] = ACTIONS(8168),
    [anon_sym_GT] = ACTIONS(8168),
    [anon_sym_GT_EQ] = ACTIONS(8166),
    [anon_sym_CARET] = ACTIONS(8168),
    [anon_sym_PLUS] = ACTIONS(8168),
    [anon_sym_SLASH] = ACTIONS(8168),
    [anon_sym_PERCENT] = ACTIONS(8168),
    [sym_comment] = ACTIONS(87),
  },
  [9928] = {
    [anon_sym_end] = ACTIONS(14226),
    [sym_comment] = ACTIONS(87),
  },
  [9929] = {
    [sym__statements] = STATE(10607),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14228),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9930] = {
    [anon_sym_end] = ACTIONS(14230),
    [sym_comment] = ACTIONS(87),
  },
  [9931] = {
    [sym_when] = STATE(10609),
    [aux_sym_case_repeat1] = STATE(2971),
    [anon_sym_SEMI] = ACTIONS(4852),
    [anon_sym_when] = ACTIONS(2041),
    [sym_comment] = ACTIONS(87),
  },
  [9932] = {
    [sym__heredoc_body_start] = ACTIONS(8414),
    [sym__binary_minus] = ACTIONS(8414),
    [sym__binary_star] = ACTIONS(8414),
    [anon_sym_LBRACE] = ACTIONS(8414),
    [anon_sym_RBRACE] = ACTIONS(8414),
    [anon_sym_RPAREN] = ACTIONS(8414),
    [anon_sym_DOT] = ACTIONS(8416),
    [anon_sym_COMMA] = ACTIONS(8414),
    [anon_sym_PIPE] = ACTIONS(8416),
    [anon_sym_SEMI] = ACTIONS(8414),
    [anon_sym_STAR_STAR] = ACTIONS(8416),
    [anon_sym_AMP] = ACTIONS(8416),
    [anon_sym_EQ] = ACTIONS(8416),
    [anon_sym_LT] = ACTIONS(8416),
    [anon_sym_if] = ACTIONS(8414),
    [anon_sym_unless] = ACTIONS(8414),
    [anon_sym_while] = ACTIONS(8414),
    [anon_sym_until] = ACTIONS(8414),
    [anon_sym_rescue] = ACTIONS(8414),
    [anon_sym_in] = ACTIONS(8414),
    [anon_sym_do] = ACTIONS(8414),
    [anon_sym_LBRACK] = ACTIONS(8414),
    [anon_sym_RBRACK] = ACTIONS(8414),
    [anon_sym_COLON_COLON2] = ACTIONS(8414),
    [anon_sym_AMP_DOT] = ACTIONS(8414),
    [anon_sym_PLUS_EQ] = ACTIONS(8414),
    [anon_sym_DASH_EQ] = ACTIONS(8414),
    [anon_sym_STAR_EQ] = ACTIONS(8414),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8414),
    [anon_sym_SLASH_EQ] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8414),
    [anon_sym_PIPE_EQ] = ACTIONS(8414),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8414),
    [anon_sym_AMP_EQ] = ACTIONS(8414),
    [anon_sym_PERCENT_EQ] = ACTIONS(8414),
    [anon_sym_GT_GT_EQ] = ACTIONS(8414),
    [anon_sym_LT_LT_EQ] = ACTIONS(8414),
    [anon_sym_CARET_EQ] = ACTIONS(8414),
    [anon_sym_QMARK] = ACTIONS(8414),
    [anon_sym_COLON2] = ACTIONS(8416),
    [anon_sym_DOT_DOT] = ACTIONS(8416),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8414),
    [anon_sym_and] = ACTIONS(8414),
    [anon_sym_or] = ACTIONS(8414),
    [anon_sym_PIPE_PIPE] = ACTIONS(8416),
    [anon_sym_AMP_AMP] = ACTIONS(8416),
    [anon_sym_LT_LT] = ACTIONS(8416),
    [anon_sym_GT_GT] = ACTIONS(8416),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8414),
    [anon_sym_LT_EQ_GT] = ACTIONS(8414),
    [anon_sym_EQ_TILDE] = ACTIONS(8414),
    [anon_sym_BANG_TILDE] = ACTIONS(8414),
    [anon_sym_LT_EQ] = ACTIONS(8416),
    [anon_sym_GT] = ACTIONS(8416),
    [anon_sym_GT_EQ] = ACTIONS(8414),
    [anon_sym_CARET] = ACTIONS(8416),
    [anon_sym_PLUS] = ACTIONS(8416),
    [anon_sym_SLASH] = ACTIONS(8416),
    [anon_sym_PERCENT] = ACTIONS(8416),
    [sym_comment] = ACTIONS(87),
  },
  [9933] = {
    [sym__heredoc_body_start] = ACTIONS(8923),
    [sym__binary_minus] = ACTIONS(8923),
    [sym__binary_star] = ACTIONS(8923),
    [anon_sym_LBRACE] = ACTIONS(8923),
    [anon_sym_RBRACE] = ACTIONS(8923),
    [anon_sym_RPAREN] = ACTIONS(8923),
    [anon_sym_DOT] = ACTIONS(8925),
    [anon_sym_COMMA] = ACTIONS(8923),
    [anon_sym_PIPE] = ACTIONS(8925),
    [anon_sym_SEMI] = ACTIONS(8923),
    [anon_sym_STAR_STAR] = ACTIONS(8925),
    [anon_sym_AMP] = ACTIONS(8925),
    [anon_sym_EQ] = ACTIONS(8925),
    [anon_sym_LT] = ACTIONS(8925),
    [anon_sym_if] = ACTIONS(8923),
    [anon_sym_unless] = ACTIONS(8923),
    [anon_sym_while] = ACTIONS(8923),
    [anon_sym_until] = ACTIONS(8923),
    [anon_sym_rescue] = ACTIONS(8923),
    [anon_sym_in] = ACTIONS(8923),
    [anon_sym_do] = ACTIONS(8923),
    [anon_sym_LBRACK] = ACTIONS(8923),
    [anon_sym_RBRACK] = ACTIONS(8923),
    [anon_sym_COLON_COLON2] = ACTIONS(8923),
    [anon_sym_AMP_DOT] = ACTIONS(8923),
    [anon_sym_PLUS_EQ] = ACTIONS(8923),
    [anon_sym_DASH_EQ] = ACTIONS(8923),
    [anon_sym_STAR_EQ] = ACTIONS(8923),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8923),
    [anon_sym_SLASH_EQ] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8923),
    [anon_sym_PIPE_EQ] = ACTIONS(8923),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8923),
    [anon_sym_AMP_EQ] = ACTIONS(8923),
    [anon_sym_PERCENT_EQ] = ACTIONS(8923),
    [anon_sym_GT_GT_EQ] = ACTIONS(8923),
    [anon_sym_LT_LT_EQ] = ACTIONS(8923),
    [anon_sym_CARET_EQ] = ACTIONS(8923),
    [anon_sym_QMARK] = ACTIONS(8923),
    [anon_sym_COLON2] = ACTIONS(8925),
    [anon_sym_DOT_DOT] = ACTIONS(8925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8923),
    [anon_sym_and] = ACTIONS(8923),
    [anon_sym_or] = ACTIONS(8923),
    [anon_sym_PIPE_PIPE] = ACTIONS(8925),
    [anon_sym_AMP_AMP] = ACTIONS(8925),
    [anon_sym_LT_LT] = ACTIONS(8925),
    [anon_sym_GT_GT] = ACTIONS(8925),
    [anon_sym_EQ_EQ] = ACTIONS(8925),
    [anon_sym_BANG_EQ] = ACTIONS(8923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8923),
    [anon_sym_LT_EQ_GT] = ACTIONS(8923),
    [anon_sym_EQ_TILDE] = ACTIONS(8923),
    [anon_sym_BANG_TILDE] = ACTIONS(8923),
    [anon_sym_LT_EQ] = ACTIONS(8925),
    [anon_sym_GT] = ACTIONS(8925),
    [anon_sym_GT_EQ] = ACTIONS(8923),
    [anon_sym_CARET] = ACTIONS(8925),
    [anon_sym_PLUS] = ACTIONS(8925),
    [anon_sym_SLASH] = ACTIONS(8925),
    [anon_sym_PERCENT] = ACTIONS(8925),
    [sym_comment] = ACTIONS(87),
  },
  [9934] = {
    [anon_sym_end] = ACTIONS(14232),
    [sym_comment] = ACTIONS(87),
  },
  [9935] = {
    [sym_ensure] = STATE(10611),
    [anon_sym_end] = ACTIONS(14232),
    [anon_sym_ensure] = ACTIONS(2173),
    [sym_comment] = ACTIONS(87),
  },
  [9936] = {
    [sym__heredoc_body_start] = ACTIONS(9143),
    [sym__binary_minus] = ACTIONS(9143),
    [sym__binary_star] = ACTIONS(9143),
    [anon_sym_LBRACE] = ACTIONS(9143),
    [anon_sym_RBRACE] = ACTIONS(9143),
    [anon_sym_RPAREN] = ACTIONS(9143),
    [anon_sym_DOT] = ACTIONS(9145),
    [anon_sym_COMMA] = ACTIONS(9143),
    [anon_sym_PIPE] = ACTIONS(9145),
    [anon_sym_SEMI] = ACTIONS(9143),
    [anon_sym_STAR_STAR] = ACTIONS(9145),
    [anon_sym_AMP] = ACTIONS(9145),
    [anon_sym_EQ] = ACTIONS(9145),
    [anon_sym_LT] = ACTIONS(9145),
    [anon_sym_if] = ACTIONS(9143),
    [anon_sym_unless] = ACTIONS(9143),
    [anon_sym_while] = ACTIONS(9143),
    [anon_sym_until] = ACTIONS(9143),
    [anon_sym_rescue] = ACTIONS(9143),
    [anon_sym_in] = ACTIONS(9143),
    [anon_sym_do] = ACTIONS(9143),
    [anon_sym_LBRACK] = ACTIONS(9143),
    [anon_sym_RBRACK] = ACTIONS(9143),
    [anon_sym_COLON_COLON2] = ACTIONS(9143),
    [anon_sym_AMP_DOT] = ACTIONS(9143),
    [anon_sym_PLUS_EQ] = ACTIONS(9143),
    [anon_sym_DASH_EQ] = ACTIONS(9143),
    [anon_sym_STAR_EQ] = ACTIONS(9143),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9143),
    [anon_sym_SLASH_EQ] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9143),
    [anon_sym_PIPE_EQ] = ACTIONS(9143),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9143),
    [anon_sym_AMP_EQ] = ACTIONS(9143),
    [anon_sym_PERCENT_EQ] = ACTIONS(9143),
    [anon_sym_GT_GT_EQ] = ACTIONS(9143),
    [anon_sym_LT_LT_EQ] = ACTIONS(9143),
    [anon_sym_CARET_EQ] = ACTIONS(9143),
    [anon_sym_QMARK] = ACTIONS(9143),
    [anon_sym_COLON2] = ACTIONS(9145),
    [anon_sym_DOT_DOT] = ACTIONS(9145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9143),
    [anon_sym_and] = ACTIONS(9143),
    [anon_sym_or] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE] = ACTIONS(9145),
    [anon_sym_AMP_AMP] = ACTIONS(9145),
    [anon_sym_LT_LT] = ACTIONS(9145),
    [anon_sym_GT_GT] = ACTIONS(9145),
    [anon_sym_EQ_EQ] = ACTIONS(9145),
    [anon_sym_BANG_EQ] = ACTIONS(9143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9143),
    [anon_sym_LT_EQ_GT] = ACTIONS(9143),
    [anon_sym_EQ_TILDE] = ACTIONS(9143),
    [anon_sym_BANG_TILDE] = ACTIONS(9143),
    [anon_sym_LT_EQ] = ACTIONS(9145),
    [anon_sym_GT] = ACTIONS(9145),
    [anon_sym_GT_EQ] = ACTIONS(9143),
    [anon_sym_CARET] = ACTIONS(9145),
    [anon_sym_PLUS] = ACTIONS(9145),
    [anon_sym_SLASH] = ACTIONS(9145),
    [anon_sym_PERCENT] = ACTIONS(9145),
    [sym_comment] = ACTIONS(87),
  },
  [9937] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10612),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_assignment] = STATE(10612),
    [sym_operator_assignment] = STATE(10612),
    [sym_conditional] = STATE(10612),
    [sym_range] = STATE(10612),
    [sym_binary] = STATE(10612),
    [sym_unary] = STATE(10612),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9938] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8646),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(3860),
    [sym_scope_resolution] = STATE(3858),
    [sym_call] = STATE(3858),
    [sym_method_call] = STATE(3860),
    [sym_splat_argument] = STATE(10613),
    [sym_assignment] = STATE(8646),
    [sym_operator_assignment] = STATE(8646),
    [sym_conditional] = STATE(8646),
    [sym_range] = STATE(8646),
    [sym_binary] = STATE(8646),
    [sym_unary] = STATE(8646),
    [sym__arg_or_splat_arg] = STATE(10613),
    [sym_left_assignment_list] = STATE(3859),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3860),
    [sym__variable] = STATE(3858),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(3860),
    [sym_false] = STATE(3860),
    [sym_nil] = STATE(3860),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(3861),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(2855),
    [sym__unary_minus] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6213),
    [anon_sym_yield] = ACTIONS(6215),
    [anon_sym_break] = ACTIONS(6217),
    [anon_sym_next] = ACTIONS(6219),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6237),
    [anon_sym_defined_QMARK] = ACTIONS(6239),
    [anon_sym_not] = ACTIONS(6241),
    [anon_sym_BANG] = ACTIONS(6243),
    [anon_sym_TILDE] = ACTIONS(6243),
    [sym_constant] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6245),
    [sym_instance_variable] = ACTIONS(6247),
    [sym_class_variable] = ACTIONS(6247),
    [sym_global_variable] = ACTIONS(6247),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6245),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6245),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9939] = {
    [aux_sym_exceptions_repeat1] = STATE(10614),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14234),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9940] = {
    [sym__binary_minus] = ACTIONS(13264),
    [sym__binary_star] = ACTIONS(13264),
    [anon_sym_LBRACE] = ACTIONS(13264),
    [anon_sym_RBRACE] = ACTIONS(13264),
    [anon_sym_RPAREN] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13266),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13266),
    [anon_sym_SEMI] = ACTIONS(13264),
    [anon_sym_STAR_STAR] = ACTIONS(13266),
    [anon_sym_AMP] = ACTIONS(13266),
    [anon_sym_EQ] = ACTIONS(13266),
    [anon_sym_LT] = ACTIONS(13266),
    [anon_sym_if] = ACTIONS(13264),
    [anon_sym_unless] = ACTIONS(13264),
    [anon_sym_while] = ACTIONS(13264),
    [anon_sym_until] = ACTIONS(13264),
    [anon_sym_rescue] = ACTIONS(13264),
    [anon_sym_do] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [anon_sym_PLUS_EQ] = ACTIONS(13264),
    [anon_sym_DASH_EQ] = ACTIONS(13264),
    [anon_sym_STAR_EQ] = ACTIONS(13264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13264),
    [anon_sym_SLASH_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13264),
    [anon_sym_AMP_EQ] = ACTIONS(13264),
    [anon_sym_PERCENT_EQ] = ACTIONS(13264),
    [anon_sym_GT_GT_EQ] = ACTIONS(13264),
    [anon_sym_LT_LT_EQ] = ACTIONS(13264),
    [anon_sym_CARET_EQ] = ACTIONS(13264),
    [anon_sym_QMARK] = ACTIONS(13264),
    [anon_sym_COLON2] = ACTIONS(13266),
    [anon_sym_DOT_DOT] = ACTIONS(13266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13264),
    [anon_sym_and] = ACTIONS(13264),
    [anon_sym_or] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE] = ACTIONS(13266),
    [anon_sym_AMP_AMP] = ACTIONS(13266),
    [anon_sym_LT_LT] = ACTIONS(13266),
    [anon_sym_GT_GT] = ACTIONS(13266),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13264),
    [anon_sym_LT_EQ_GT] = ACTIONS(13264),
    [anon_sym_EQ_TILDE] = ACTIONS(13264),
    [anon_sym_BANG_TILDE] = ACTIONS(13264),
    [anon_sym_LT_EQ] = ACTIONS(13266),
    [anon_sym_GT] = ACTIONS(13266),
    [anon_sym_GT_EQ] = ACTIONS(13264),
    [anon_sym_CARET] = ACTIONS(13266),
    [anon_sym_PLUS] = ACTIONS(13266),
    [anon_sym_SLASH] = ACTIONS(13266),
    [anon_sym_PERCENT] = ACTIONS(13266),
    [sym_comment] = ACTIONS(87),
  },
  [9941] = {
    [anon_sym_end] = ACTIONS(14236),
    [sym_comment] = ACTIONS(87),
  },
  [9942] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(6269),
    [sym__binary_star] = ACTIONS(6271),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(6273),
    [anon_sym_STAR_STAR] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(6277),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(6279),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_DOT_DOT] = ACTIONS(6283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6285),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(6287),
    [anon_sym_AMP_AMP] = ACTIONS(6287),
    [anon_sym_LT_LT] = ACTIONS(6289),
    [anon_sym_GT_GT] = ACTIONS(6289),
    [anon_sym_EQ_EQ] = ACTIONS(6287),
    [anon_sym_BANG_EQ] = ACTIONS(6291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6291),
    [anon_sym_LT_EQ_GT] = ACTIONS(6291),
    [anon_sym_EQ_TILDE] = ACTIONS(6291),
    [anon_sym_BANG_TILDE] = ACTIONS(6291),
    [anon_sym_LT_EQ] = ACTIONS(6279),
    [anon_sym_GT] = ACTIONS(6279),
    [anon_sym_GT_EQ] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6273),
    [anon_sym_PLUS] = ACTIONS(6295),
    [anon_sym_SLASH] = ACTIONS(6275),
    [anon_sym_PERCENT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(87),
  },
  [9943] = {
    [aux_sym_exceptions_repeat1] = STATE(9943),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14238),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [9944] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10616),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(3909),
    [sym_scope_resolution] = STATE(454),
    [sym_call] = STATE(454),
    [sym_method_call] = STATE(3909),
    [sym_assignment] = STATE(10616),
    [sym_operator_assignment] = STATE(10616),
    [sym_conditional] = STATE(10616),
    [sym_range] = STATE(10616),
    [sym_binary] = STATE(10616),
    [sym_unary] = STATE(10616),
    [sym_left_assignment_list] = STATE(3908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3909),
    [sym__variable] = STATE(454),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(3909),
    [sym_false] = STATE(3909),
    [sym_nil] = STATE(3909),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(3910),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(6315),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6317),
    [anon_sym_yield] = ACTIONS(6319),
    [anon_sym_break] = ACTIONS(6321),
    [anon_sym_next] = ACTIONS(6323),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_defined_QMARK] = ACTIONS(6327),
    [anon_sym_not] = ACTIONS(6329),
    [anon_sym_BANG] = ACTIONS(6331),
    [anon_sym_TILDE] = ACTIONS(6331),
    [sym_constant] = ACTIONS(867),
    [sym_identifier] = ACTIONS(867),
    [sym_instance_variable] = ACTIONS(869),
    [sym_class_variable] = ACTIONS(869),
    [sym_global_variable] = ACTIONS(869),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(867),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9945] = {
    [sym_heredoc_body] = STATE(9945),
    [aux_sym_call_repeat1] = STATE(9945),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_RBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [9946] = {
    [sym_heredoc_body] = STATE(9945),
    [aux_sym_call_repeat1] = STATE(9945),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_RBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [9947] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10617),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_assignment] = STATE(10617),
    [sym_operator_assignment] = STATE(10617),
    [sym_conditional] = STATE(10617),
    [sym_range] = STATE(10617),
    [sym_binary] = STATE(10617),
    [sym_unary] = STATE(10617),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9948] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(8687),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(3930),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(3930),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(8687),
    [sym_operator_assignment] = STATE(8687),
    [sym_conditional] = STATE(8687),
    [sym_range] = STATE(8687),
    [sym_binary] = STATE(8687),
    [sym_unary] = STATE(8687),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(3929),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3930),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(3930),
    [sym_false] = STATE(3930),
    [sym_nil] = STATE(3930),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(2974),
    [sym__unary_minus] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6393),
    [anon_sym_defined_QMARK] = ACTIONS(6395),
    [anon_sym_not] = ACTIONS(6397),
    [anon_sym_BANG] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9949] = {
    [aux_sym_exceptions_repeat1] = STATE(10618),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14241),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9950] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(6407),
    [sym__binary_star] = ACTIONS(6409),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(6411),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(6409),
    [anon_sym_AMP] = ACTIONS(6413),
    [anon_sym_LT] = ACTIONS(6415),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_DOT_DOT] = ACTIONS(6419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6421),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6427),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_EQ_TILDE] = ACTIONS(6423),
    [anon_sym_BANG_TILDE] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6415),
    [anon_sym_GT] = ACTIONS(6415),
    [anon_sym_GT_EQ] = ACTIONS(6429),
    [anon_sym_CARET] = ACTIONS(6431),
    [anon_sym_PLUS] = ACTIONS(6407),
    [anon_sym_SLASH] = ACTIONS(6409),
    [anon_sym_PERCENT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(87),
  },
  [9951] = {
    [aux_sym_exceptions_repeat1] = STATE(9951),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14243),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9952] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10619),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_assignment] = STATE(10619),
    [sym_operator_assignment] = STATE(10619),
    [sym_conditional] = STATE(10619),
    [sym_range] = STATE(10619),
    [sym_binary] = STATE(10619),
    [sym_unary] = STATE(10619),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9953] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(8707),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(3985),
    [sym_scope_resolution] = STATE(3983),
    [sym_call] = STATE(3983),
    [sym_method_call] = STATE(3985),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(8707),
    [sym_operator_assignment] = STATE(8707),
    [sym_conditional] = STATE(8707),
    [sym_range] = STATE(8707),
    [sym_binary] = STATE(8707),
    [sym_unary] = STATE(8707),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(3984),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(3985),
    [sym__variable] = STATE(3983),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(3985),
    [sym_false] = STATE(3985),
    [sym_nil] = STATE(3985),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(3044),
    [sym__unary_minus] = ACTIONS(6447),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(6449),
    [anon_sym_yield] = ACTIONS(6451),
    [anon_sym_break] = ACTIONS(6453),
    [anon_sym_next] = ACTIONS(6455),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(6457),
    [anon_sym_defined_QMARK] = ACTIONS(6459),
    [anon_sym_not] = ACTIONS(6461),
    [anon_sym_BANG] = ACTIONS(6463),
    [anon_sym_TILDE] = ACTIONS(6463),
    [sym_constant] = ACTIONS(6465),
    [sym_identifier] = ACTIONS(6465),
    [sym_instance_variable] = ACTIONS(6467),
    [sym_class_variable] = ACTIONS(6467),
    [sym_global_variable] = ACTIONS(6467),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(6465),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6465),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [9954] = {
    [aux_sym_exceptions_repeat1] = STATE(10620),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14246),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9955] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(6475),
    [sym__binary_star] = ACTIONS(6477),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(6479),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(6481),
    [anon_sym_AMP] = ACTIONS(6483),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(6485),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(6487),
    [anon_sym_DOT_DOT] = ACTIONS(6489),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6491),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(6493),
    [anon_sym_AMP_AMP] = ACTIONS(6493),
    [anon_sym_LT_LT] = ACTIONS(6495),
    [anon_sym_GT_GT] = ACTIONS(6495),
    [anon_sym_EQ_EQ] = ACTIONS(6493),
    [anon_sym_BANG_EQ] = ACTIONS(6497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6497),
    [anon_sym_LT_EQ_GT] = ACTIONS(6497),
    [anon_sym_EQ_TILDE] = ACTIONS(6497),
    [anon_sym_BANG_TILDE] = ACTIONS(6497),
    [anon_sym_LT_EQ] = ACTIONS(6485),
    [anon_sym_GT] = ACTIONS(6485),
    [anon_sym_GT_EQ] = ACTIONS(6499),
    [anon_sym_CARET] = ACTIONS(6479),
    [anon_sym_PLUS] = ACTIONS(6501),
    [anon_sym_SLASH] = ACTIONS(6481),
    [anon_sym_PERCENT] = ACTIONS(6481),
    [sym_comment] = ACTIONS(87),
  },
  [9956] = {
    [aux_sym_exceptions_repeat1] = STATE(9956),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14248),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [9957] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10621),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(4017),
    [sym_scope_resolution] = STATE(491),
    [sym_call] = STATE(491),
    [sym_method_call] = STATE(4017),
    [sym_assignment] = STATE(10621),
    [sym_operator_assignment] = STATE(10621),
    [sym_conditional] = STATE(10621),
    [sym_range] = STATE(10621),
    [sym_binary] = STATE(10621),
    [sym_unary] = STATE(10621),
    [sym_left_assignment_list] = STATE(4016),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4017),
    [sym__variable] = STATE(491),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(4017),
    [sym_false] = STATE(4017),
    [sym_nil] = STATE(4017),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(3931),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(6515),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6385),
    [anon_sym_yield] = ACTIONS(6387),
    [anon_sym_break] = ACTIONS(6389),
    [anon_sym_next] = ACTIONS(6391),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_defined_QMARK] = ACTIONS(6519),
    [anon_sym_not] = ACTIONS(6521),
    [anon_sym_BANG] = ACTIONS(6523),
    [anon_sym_TILDE] = ACTIONS(6523),
    [sym_constant] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_instance_variable] = ACTIONS(963),
    [sym_class_variable] = ACTIONS(963),
    [sym_global_variable] = ACTIONS(963),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(961),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9958] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10622),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_assignment] = STATE(10622),
    [sym_operator_assignment] = STATE(10622),
    [sym_conditional] = STATE(10622),
    [sym_range] = STATE(10622),
    [sym_binary] = STATE(10622),
    [sym_unary] = STATE(10622),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9959] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8740),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4042),
    [sym_scope_resolution] = STATE(538),
    [sym_call] = STATE(538),
    [sym_method_call] = STATE(4042),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(8740),
    [sym_operator_assignment] = STATE(8740),
    [sym_conditional] = STATE(8740),
    [sym_range] = STATE(8740),
    [sym_binary] = STATE(8740),
    [sym_unary] = STATE(8740),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(4041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4042),
    [sym__variable] = STATE(538),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4042),
    [sym_false] = STATE(4042),
    [sym_nil] = STATE(4042),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(541),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(3120),
    [sym__unary_minus] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1015),
    [anon_sym_next] = ACTIONS(1017),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6569),
    [anon_sym_defined_QMARK] = ACTIONS(6571),
    [anon_sym_not] = ACTIONS(6573),
    [anon_sym_BANG] = ACTIONS(6575),
    [anon_sym_TILDE] = ACTIONS(6575),
    [sym_constant] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [sym_instance_variable] = ACTIONS(1031),
    [sym_class_variable] = ACTIONS(1031),
    [sym_global_variable] = ACTIONS(1031),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(1029),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(1029),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9960] = {
    [aux_sym_exceptions_repeat1] = STATE(10623),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14251),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9961] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(6591),
    [sym__binary_star] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_STAR_STAR] = ACTIONS(6593),
    [anon_sym_AMP] = ACTIONS(6597),
    [anon_sym_LT] = ACTIONS(6599),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(6601),
    [anon_sym_DOT_DOT] = ACTIONS(6603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6605),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(6607),
    [anon_sym_AMP_AMP] = ACTIONS(6607),
    [anon_sym_LT_LT] = ACTIONS(6609),
    [anon_sym_GT_GT] = ACTIONS(6609),
    [anon_sym_EQ_EQ] = ACTIONS(6611),
    [anon_sym_BANG_EQ] = ACTIONS(6607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6607),
    [anon_sym_LT_EQ_GT] = ACTIONS(6607),
    [anon_sym_EQ_TILDE] = ACTIONS(6607),
    [anon_sym_BANG_TILDE] = ACTIONS(6607),
    [anon_sym_LT_EQ] = ACTIONS(6599),
    [anon_sym_GT] = ACTIONS(6599),
    [anon_sym_GT_EQ] = ACTIONS(6613),
    [anon_sym_CARET] = ACTIONS(6615),
    [anon_sym_PLUS] = ACTIONS(6591),
    [anon_sym_SLASH] = ACTIONS(6593),
    [anon_sym_PERCENT] = ACTIONS(6593),
    [sym_comment] = ACTIONS(87),
  },
  [9962] = {
    [aux_sym_exceptions_repeat1] = STATE(9962),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14253),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9963] = {
    [sym__simple_symbol] = ACTIONS(10568),
    [sym__string_start] = ACTIONS(10568),
    [sym__symbol_start] = ACTIONS(10568),
    [sym__subshell_start] = ACTIONS(10568),
    [sym__regex_start] = ACTIONS(10568),
    [sym__string_array_start] = ACTIONS(10568),
    [sym__symbol_array_start] = ACTIONS(10568),
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym_heredoc_beginning] = ACTIONS(10568),
    [sym__block_ampersand] = ACTIONS(10568),
    [sym__splat_star] = ACTIONS(10568),
    [sym__unary_minus] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [sym__identifier_hash_key] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RBRACE] = ACTIONS(10568),
    [anon_sym_def] = ACTIONS(10570),
    [anon_sym_LPAREN] = ACTIONS(10570),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COLON_COLON] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10570),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_class] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_module] = ACTIONS(10570),
    [anon_sym_return] = ACTIONS(10570),
    [anon_sym_yield] = ACTIONS(10570),
    [anon_sym_break] = ACTIONS(10570),
    [anon_sym_next] = ACTIONS(10570),
    [sym_redo] = ACTIONS(10570),
    [sym_retry] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10570),
    [anon_sym_unless] = ACTIONS(10570),
    [anon_sym_while] = ACTIONS(10570),
    [anon_sym_until] = ACTIONS(10570),
    [anon_sym_rescue] = ACTIONS(10570),
    [anon_sym_for] = ACTIONS(10570),
    [anon_sym_in] = ACTIONS(10570),
    [anon_sym_do] = ACTIONS(10570),
    [anon_sym_case] = ACTIONS(10570),
    [anon_sym_begin] = ACTIONS(10570),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_RBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_LPAREN2] = ACTIONS(10568),
    [anon_sym_PLUS_EQ] = ACTIONS(10568),
    [anon_sym_DASH_EQ] = ACTIONS(10568),
    [anon_sym_STAR_EQ] = ACTIONS(10568),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10568),
    [anon_sym_SLASH_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_PIPE_EQ] = ACTIONS(10568),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10568),
    [anon_sym_AMP_EQ] = ACTIONS(10568),
    [anon_sym_PERCENT_EQ] = ACTIONS(10568),
    [anon_sym_GT_GT_EQ] = ACTIONS(10568),
    [anon_sym_LT_LT_EQ] = ACTIONS(10568),
    [anon_sym_CARET_EQ] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10570),
    [anon_sym_COLON2] = ACTIONS(10570),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10570),
    [anon_sym_or] = ACTIONS(10570),
    [anon_sym_PIPE_PIPE] = ACTIONS(10570),
    [anon_sym_AMP_AMP] = ACTIONS(10570),
    [anon_sym_LT_LT] = ACTIONS(10570),
    [anon_sym_GT_GT] = ACTIONS(10570),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10570),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_SLASH] = ACTIONS(10570),
    [anon_sym_PERCENT] = ACTIONS(10570),
    [anon_sym_defined_QMARK] = ACTIONS(10568),
    [anon_sym_not] = ACTIONS(10570),
    [anon_sym_BANG] = ACTIONS(10570),
    [anon_sym_TILDE] = ACTIONS(10568),
    [sym_constant] = ACTIONS(10570),
    [sym_identifier] = ACTIONS(10570),
    [sym_instance_variable] = ACTIONS(10568),
    [sym_class_variable] = ACTIONS(10568),
    [sym_global_variable] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10570),
    [sym_float] = ACTIONS(10570),
    [sym_complex] = ACTIONS(10568),
    [sym_super] = ACTIONS(10570),
    [anon_sym_true] = ACTIONS(10570),
    [anon_sym_TRUE] = ACTIONS(10570),
    [anon_sym_false] = ACTIONS(10570),
    [anon_sym_FALSE] = ACTIONS(10570),
    [sym_self] = ACTIONS(10570),
    [anon_sym_nil] = ACTIONS(10570),
    [anon_sym_NIL] = ACTIONS(10570),
    [sym_character] = ACTIONS(10568),
    [anon_sym_LBRACK2] = ACTIONS(10570),
    [anon_sym_DASH_GT] = ACTIONS(10568),
  },
  [9964] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10624),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_assignment] = STATE(10624),
    [sym_operator_assignment] = STATE(10624),
    [sym_conditional] = STATE(10624),
    [sym_range] = STATE(10624),
    [sym_binary] = STATE(10624),
    [sym_unary] = STATE(10624),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9965] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8772),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4113),
    [sym_scope_resolution] = STATE(4111),
    [sym_call] = STATE(4111),
    [sym_method_call] = STATE(4113),
    [sym_splat_argument] = STATE(10613),
    [sym_assignment] = STATE(8772),
    [sym_operator_assignment] = STATE(8772),
    [sym_conditional] = STATE(8772),
    [sym_range] = STATE(8772),
    [sym_binary] = STATE(8772),
    [sym_unary] = STATE(8772),
    [sym__arg_or_splat_arg] = STATE(10613),
    [sym_left_assignment_list] = STATE(4112),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4113),
    [sym__variable] = STATE(4111),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4113),
    [sym_false] = STATE(4113),
    [sym_nil] = STATE(4113),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4114),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(3188),
    [sym__unary_minus] = ACTIONS(6647),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6649),
    [anon_sym_yield] = ACTIONS(6651),
    [anon_sym_break] = ACTIONS(6653),
    [anon_sym_next] = ACTIONS(6655),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6657),
    [anon_sym_defined_QMARK] = ACTIONS(6659),
    [anon_sym_not] = ACTIONS(6661),
    [anon_sym_BANG] = ACTIONS(6663),
    [anon_sym_TILDE] = ACTIONS(6663),
    [sym_constant] = ACTIONS(6665),
    [sym_identifier] = ACTIONS(6665),
    [sym_instance_variable] = ACTIONS(6667),
    [sym_class_variable] = ACTIONS(6667),
    [sym_global_variable] = ACTIONS(6667),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6665),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6665),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9966] = {
    [aux_sym_exceptions_repeat1] = STATE(10625),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14256),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9967] = {
    [sym__heredoc_body_start] = ACTIONS(13264),
    [sym__binary_minus] = ACTIONS(13264),
    [sym__binary_star] = ACTIONS(13264),
    [anon_sym_LBRACE] = ACTIONS(13264),
    [anon_sym_RBRACE] = ACTIONS(13264),
    [anon_sym_RPAREN] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13266),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13266),
    [anon_sym_SEMI] = ACTIONS(13264),
    [anon_sym_STAR_STAR] = ACTIONS(13266),
    [anon_sym_AMP] = ACTIONS(13266),
    [anon_sym_EQ] = ACTIONS(13266),
    [anon_sym_LT] = ACTIONS(13266),
    [anon_sym_if] = ACTIONS(13264),
    [anon_sym_unless] = ACTIONS(13264),
    [anon_sym_while] = ACTIONS(13264),
    [anon_sym_until] = ACTIONS(13264),
    [anon_sym_rescue] = ACTIONS(13264),
    [anon_sym_in] = ACTIONS(13264),
    [anon_sym_do] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_RBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [anon_sym_PLUS_EQ] = ACTIONS(13264),
    [anon_sym_DASH_EQ] = ACTIONS(13264),
    [anon_sym_STAR_EQ] = ACTIONS(13264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13264),
    [anon_sym_SLASH_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_PIPE_EQ] = ACTIONS(13264),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13264),
    [anon_sym_AMP_EQ] = ACTIONS(13264),
    [anon_sym_PERCENT_EQ] = ACTIONS(13264),
    [anon_sym_GT_GT_EQ] = ACTIONS(13264),
    [anon_sym_LT_LT_EQ] = ACTIONS(13264),
    [anon_sym_CARET_EQ] = ACTIONS(13264),
    [anon_sym_QMARK] = ACTIONS(13264),
    [anon_sym_COLON2] = ACTIONS(13266),
    [anon_sym_DOT_DOT] = ACTIONS(13266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13264),
    [anon_sym_and] = ACTIONS(13264),
    [anon_sym_or] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE] = ACTIONS(13266),
    [anon_sym_AMP_AMP] = ACTIONS(13266),
    [anon_sym_LT_LT] = ACTIONS(13266),
    [anon_sym_GT_GT] = ACTIONS(13266),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13264),
    [anon_sym_LT_EQ_GT] = ACTIONS(13264),
    [anon_sym_EQ_TILDE] = ACTIONS(13264),
    [anon_sym_BANG_TILDE] = ACTIONS(13264),
    [anon_sym_LT_EQ] = ACTIONS(13266),
    [anon_sym_GT] = ACTIONS(13266),
    [anon_sym_GT_EQ] = ACTIONS(13264),
    [anon_sym_CARET] = ACTIONS(13266),
    [anon_sym_PLUS] = ACTIONS(13266),
    [anon_sym_SLASH] = ACTIONS(13266),
    [anon_sym_PERCENT] = ACTIONS(13266),
    [sym_comment] = ACTIONS(87),
  },
  [9968] = {
    [anon_sym_end] = ACTIONS(14258),
    [sym_comment] = ACTIONS(87),
  },
  [9969] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(6681),
    [sym__binary_star] = ACTIONS(6683),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(6685),
    [anon_sym_STAR_STAR] = ACTIONS(6687),
    [anon_sym_AMP] = ACTIONS(6689),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(6691),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(6693),
    [anon_sym_DOT_DOT] = ACTIONS(6695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6697),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(6699),
    [anon_sym_AMP_AMP] = ACTIONS(6699),
    [anon_sym_LT_LT] = ACTIONS(6701),
    [anon_sym_GT_GT] = ACTIONS(6701),
    [anon_sym_EQ_EQ] = ACTIONS(6699),
    [anon_sym_BANG_EQ] = ACTIONS(6703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6703),
    [anon_sym_LT_EQ_GT] = ACTIONS(6703),
    [anon_sym_EQ_TILDE] = ACTIONS(6703),
    [anon_sym_BANG_TILDE] = ACTIONS(6703),
    [anon_sym_LT_EQ] = ACTIONS(6691),
    [anon_sym_GT] = ACTIONS(6691),
    [anon_sym_GT_EQ] = ACTIONS(6705),
    [anon_sym_CARET] = ACTIONS(6685),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6687),
    [anon_sym_PERCENT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(87),
  },
  [9970] = {
    [aux_sym_exceptions_repeat1] = STATE(9970),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14260),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [9971] = {
    [sym__binary_minus] = ACTIONS(13660),
    [sym__binary_star] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_RBRACE] = ACTIONS(13660),
    [anon_sym_RPAREN] = ACTIONS(13660),
    [anon_sym_DOT] = ACTIONS(13662),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_PIPE] = ACTIONS(13662),
    [anon_sym_SEMI] = ACTIONS(13660),
    [anon_sym_STAR_STAR] = ACTIONS(13660),
    [anon_sym_AMP] = ACTIONS(13662),
    [anon_sym_LT] = ACTIONS(13662),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_unless] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [anon_sym_until] = ACTIONS(13660),
    [anon_sym_rescue] = ACTIONS(13660),
    [anon_sym_do] = ACTIONS(13660),
    [anon_sym_EQ_GT] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_COLON_COLON2] = ACTIONS(13660),
    [anon_sym_AMP_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13662),
    [anon_sym_DOT_DOT] = ACTIONS(13662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_and] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE] = ACTIONS(13660),
    [anon_sym_AMP_AMP] = ACTIONS(13660),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_EQ_EQ] = ACTIONS(13662),
    [anon_sym_BANG_EQ] = ACTIONS(13660),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13660),
    [anon_sym_LT_EQ_GT] = ACTIONS(13660),
    [anon_sym_EQ_TILDE] = ACTIONS(13660),
    [anon_sym_BANG_TILDE] = ACTIONS(13660),
    [anon_sym_LT_EQ] = ACTIONS(13662),
    [anon_sym_GT] = ACTIONS(13662),
    [anon_sym_GT_EQ] = ACTIONS(13660),
    [anon_sym_CARET] = ACTIONS(13660),
    [anon_sym_PLUS] = ACTIONS(13660),
    [anon_sym_SLASH] = ACTIONS(13660),
    [anon_sym_PERCENT] = ACTIONS(13660),
    [sym_comment] = ACTIONS(87),
  },
  [9972] = {
    [sym__binary_minus] = ACTIONS(14146),
    [sym__binary_star] = ACTIONS(14146),
    [anon_sym_LBRACE] = ACTIONS(14146),
    [anon_sym_RBRACE] = ACTIONS(14146),
    [anon_sym_RPAREN] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14148),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14148),
    [anon_sym_SEMI] = ACTIONS(14146),
    [anon_sym_STAR_STAR] = ACTIONS(14146),
    [anon_sym_AMP] = ACTIONS(14148),
    [anon_sym_LT] = ACTIONS(14148),
    [anon_sym_if] = ACTIONS(14146),
    [anon_sym_unless] = ACTIONS(14146),
    [anon_sym_while] = ACTIONS(14146),
    [anon_sym_until] = ACTIONS(14146),
    [anon_sym_rescue] = ACTIONS(14146),
    [anon_sym_do] = ACTIONS(14146),
    [anon_sym_EQ_GT] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [anon_sym_QMARK] = ACTIONS(14146),
    [anon_sym_COLON2] = ACTIONS(14148),
    [anon_sym_DOT_DOT] = ACTIONS(14148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14146),
    [anon_sym_and] = ACTIONS(14146),
    [anon_sym_or] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE] = ACTIONS(14146),
    [anon_sym_AMP_AMP] = ACTIONS(14146),
    [anon_sym_LT_LT] = ACTIONS(14146),
    [anon_sym_GT_GT] = ACTIONS(14146),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_BANG_EQ] = ACTIONS(14146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14146),
    [anon_sym_LT_EQ_GT] = ACTIONS(14146),
    [anon_sym_EQ_TILDE] = ACTIONS(14146),
    [anon_sym_BANG_TILDE] = ACTIONS(14146),
    [anon_sym_LT_EQ] = ACTIONS(14148),
    [anon_sym_GT] = ACTIONS(14148),
    [anon_sym_GT_EQ] = ACTIONS(14146),
    [anon_sym_CARET] = ACTIONS(14146),
    [anon_sym_PLUS] = ACTIONS(14146),
    [anon_sym_SLASH] = ACTIONS(14146),
    [anon_sym_PERCENT] = ACTIONS(14146),
    [sym_comment] = ACTIONS(87),
  },
  [9973] = {
    [sym__heredoc_body_start] = ACTIONS(12069),
    [sym__binary_minus] = ACTIONS(12069),
    [sym__binary_star] = ACTIONS(12069),
    [anon_sym_LBRACE] = ACTIONS(12069),
    [anon_sym_RBRACE] = ACTIONS(12069),
    [anon_sym_RPAREN] = ACTIONS(12069),
    [anon_sym_DOT] = ACTIONS(12071),
    [anon_sym_COMMA] = ACTIONS(12069),
    [anon_sym_PIPE] = ACTIONS(12071),
    [anon_sym_SEMI] = ACTIONS(12069),
    [anon_sym_STAR_STAR] = ACTIONS(12071),
    [anon_sym_AMP] = ACTIONS(12071),
    [anon_sym_EQ] = ACTIONS(12071),
    [anon_sym_LT] = ACTIONS(12071),
    [anon_sym_if] = ACTIONS(12069),
    [anon_sym_unless] = ACTIONS(12069),
    [anon_sym_while] = ACTIONS(12069),
    [anon_sym_until] = ACTIONS(12069),
    [anon_sym_rescue] = ACTIONS(12069),
    [anon_sym_in] = ACTIONS(12069),
    [anon_sym_do] = ACTIONS(12069),
    [anon_sym_EQ_GT] = ACTIONS(12069),
    [anon_sym_LBRACK] = ACTIONS(12069),
    [anon_sym_RBRACK] = ACTIONS(12069),
    [anon_sym_COLON_COLON2] = ACTIONS(12069),
    [anon_sym_AMP_DOT] = ACTIONS(12069),
    [anon_sym_PLUS_EQ] = ACTIONS(12069),
    [anon_sym_DASH_EQ] = ACTIONS(12069),
    [anon_sym_STAR_EQ] = ACTIONS(12069),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12069),
    [anon_sym_SLASH_EQ] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12069),
    [anon_sym_PIPE_EQ] = ACTIONS(12069),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12069),
    [anon_sym_AMP_EQ] = ACTIONS(12069),
    [anon_sym_PERCENT_EQ] = ACTIONS(12069),
    [anon_sym_GT_GT_EQ] = ACTIONS(12069),
    [anon_sym_LT_LT_EQ] = ACTIONS(12069),
    [anon_sym_CARET_EQ] = ACTIONS(12069),
    [anon_sym_QMARK] = ACTIONS(12069),
    [anon_sym_COLON2] = ACTIONS(12071),
    [anon_sym_DOT_DOT] = ACTIONS(12071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12069),
    [anon_sym_and] = ACTIONS(12069),
    [anon_sym_or] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE] = ACTIONS(12071),
    [anon_sym_AMP_AMP] = ACTIONS(12071),
    [anon_sym_LT_LT] = ACTIONS(12071),
    [anon_sym_GT_GT] = ACTIONS(12071),
    [anon_sym_EQ_EQ] = ACTIONS(12071),
    [anon_sym_BANG_EQ] = ACTIONS(12069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12069),
    [anon_sym_LT_EQ_GT] = ACTIONS(12069),
    [anon_sym_EQ_TILDE] = ACTIONS(12069),
    [anon_sym_BANG_TILDE] = ACTIONS(12069),
    [anon_sym_LT_EQ] = ACTIONS(12071),
    [anon_sym_GT] = ACTIONS(12071),
    [anon_sym_GT_EQ] = ACTIONS(12069),
    [anon_sym_CARET] = ACTIONS(12071),
    [anon_sym_PLUS] = ACTIONS(12071),
    [anon_sym_SLASH] = ACTIONS(12071),
    [anon_sym_PERCENT] = ACTIONS(12071),
    [sym_comment] = ACTIONS(87),
  },
  [9974] = {
    [sym__heredoc_body_start] = ACTIONS(12073),
    [sym__binary_minus] = ACTIONS(12073),
    [sym__binary_star] = ACTIONS(12073),
    [anon_sym_LBRACE] = ACTIONS(12073),
    [anon_sym_RBRACE] = ACTIONS(12073),
    [anon_sym_RPAREN] = ACTIONS(12073),
    [anon_sym_DOT] = ACTIONS(12075),
    [anon_sym_COMMA] = ACTIONS(12073),
    [anon_sym_PIPE] = ACTIONS(12075),
    [anon_sym_SEMI] = ACTIONS(12073),
    [anon_sym_STAR_STAR] = ACTIONS(12075),
    [anon_sym_AMP] = ACTIONS(12075),
    [anon_sym_EQ] = ACTIONS(12075),
    [anon_sym_LT] = ACTIONS(12075),
    [anon_sym_if] = ACTIONS(12073),
    [anon_sym_unless] = ACTIONS(12073),
    [anon_sym_while] = ACTIONS(12073),
    [anon_sym_until] = ACTIONS(12073),
    [anon_sym_rescue] = ACTIONS(12073),
    [anon_sym_in] = ACTIONS(12073),
    [anon_sym_do] = ACTIONS(12073),
    [anon_sym_EQ_GT] = ACTIONS(12073),
    [anon_sym_LBRACK] = ACTIONS(12073),
    [anon_sym_RBRACK] = ACTIONS(12073),
    [anon_sym_COLON_COLON2] = ACTIONS(12073),
    [anon_sym_AMP_DOT] = ACTIONS(12073),
    [anon_sym_PLUS_EQ] = ACTIONS(12073),
    [anon_sym_DASH_EQ] = ACTIONS(12073),
    [anon_sym_STAR_EQ] = ACTIONS(12073),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12073),
    [anon_sym_SLASH_EQ] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12073),
    [anon_sym_PIPE_EQ] = ACTIONS(12073),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12073),
    [anon_sym_AMP_EQ] = ACTIONS(12073),
    [anon_sym_PERCENT_EQ] = ACTIONS(12073),
    [anon_sym_GT_GT_EQ] = ACTIONS(12073),
    [anon_sym_LT_LT_EQ] = ACTIONS(12073),
    [anon_sym_CARET_EQ] = ACTIONS(12073),
    [anon_sym_QMARK] = ACTIONS(12073),
    [anon_sym_COLON2] = ACTIONS(12075),
    [anon_sym_DOT_DOT] = ACTIONS(12075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12073),
    [anon_sym_and] = ACTIONS(12073),
    [anon_sym_or] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE] = ACTIONS(12075),
    [anon_sym_AMP_AMP] = ACTIONS(12075),
    [anon_sym_LT_LT] = ACTIONS(12075),
    [anon_sym_GT_GT] = ACTIONS(12075),
    [anon_sym_EQ_EQ] = ACTIONS(12075),
    [anon_sym_BANG_EQ] = ACTIONS(12073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12073),
    [anon_sym_LT_EQ_GT] = ACTIONS(12073),
    [anon_sym_EQ_TILDE] = ACTIONS(12073),
    [anon_sym_BANG_TILDE] = ACTIONS(12073),
    [anon_sym_LT_EQ] = ACTIONS(12075),
    [anon_sym_GT] = ACTIONS(12075),
    [anon_sym_GT_EQ] = ACTIONS(12073),
    [anon_sym_CARET] = ACTIONS(12075),
    [anon_sym_PLUS] = ACTIONS(12075),
    [anon_sym_SLASH] = ACTIONS(12075),
    [anon_sym_PERCENT] = ACTIONS(12075),
    [sym_comment] = ACTIONS(87),
  },
  [9975] = {
    [sym__heredoc_body_start] = ACTIONS(12187),
    [sym__binary_minus] = ACTIONS(12187),
    [sym__binary_star] = ACTIONS(12187),
    [anon_sym_LBRACE] = ACTIONS(12187),
    [anon_sym_RBRACE] = ACTIONS(12187),
    [anon_sym_RPAREN] = ACTIONS(12187),
    [anon_sym_DOT] = ACTIONS(12189),
    [anon_sym_COMMA] = ACTIONS(12187),
    [anon_sym_PIPE] = ACTIONS(12189),
    [anon_sym_SEMI] = ACTIONS(12187),
    [anon_sym_STAR_STAR] = ACTIONS(12189),
    [anon_sym_AMP] = ACTIONS(12189),
    [anon_sym_EQ] = ACTIONS(12189),
    [anon_sym_LT] = ACTIONS(12189),
    [anon_sym_if] = ACTIONS(12187),
    [anon_sym_unless] = ACTIONS(12187),
    [anon_sym_while] = ACTIONS(12187),
    [anon_sym_until] = ACTIONS(12187),
    [anon_sym_rescue] = ACTIONS(12187),
    [anon_sym_in] = ACTIONS(12187),
    [anon_sym_do] = ACTIONS(12187),
    [anon_sym_EQ_GT] = ACTIONS(12187),
    [anon_sym_LBRACK] = ACTIONS(12187),
    [anon_sym_RBRACK] = ACTIONS(12187),
    [anon_sym_COLON_COLON2] = ACTIONS(12187),
    [anon_sym_AMP_DOT] = ACTIONS(12187),
    [anon_sym_PLUS_EQ] = ACTIONS(12187),
    [anon_sym_DASH_EQ] = ACTIONS(12187),
    [anon_sym_STAR_EQ] = ACTIONS(12187),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12187),
    [anon_sym_SLASH_EQ] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12187),
    [anon_sym_PIPE_EQ] = ACTIONS(12187),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12187),
    [anon_sym_AMP_EQ] = ACTIONS(12187),
    [anon_sym_PERCENT_EQ] = ACTIONS(12187),
    [anon_sym_GT_GT_EQ] = ACTIONS(12187),
    [anon_sym_LT_LT_EQ] = ACTIONS(12187),
    [anon_sym_CARET_EQ] = ACTIONS(12187),
    [anon_sym_QMARK] = ACTIONS(12187),
    [anon_sym_COLON2] = ACTIONS(12189),
    [anon_sym_DOT_DOT] = ACTIONS(12189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12187),
    [anon_sym_and] = ACTIONS(12187),
    [anon_sym_or] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE] = ACTIONS(12189),
    [anon_sym_AMP_AMP] = ACTIONS(12189),
    [anon_sym_LT_LT] = ACTIONS(12189),
    [anon_sym_GT_GT] = ACTIONS(12189),
    [anon_sym_EQ_EQ] = ACTIONS(12189),
    [anon_sym_BANG_EQ] = ACTIONS(12187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12187),
    [anon_sym_LT_EQ_GT] = ACTIONS(12187),
    [anon_sym_EQ_TILDE] = ACTIONS(12187),
    [anon_sym_BANG_TILDE] = ACTIONS(12187),
    [anon_sym_LT_EQ] = ACTIONS(12189),
    [anon_sym_GT] = ACTIONS(12189),
    [anon_sym_GT_EQ] = ACTIONS(12187),
    [anon_sym_CARET] = ACTIONS(12189),
    [anon_sym_PLUS] = ACTIONS(12189),
    [anon_sym_SLASH] = ACTIONS(12189),
    [anon_sym_PERCENT] = ACTIONS(12189),
    [sym_comment] = ACTIONS(87),
  },
  [9976] = {
    [sym__heredoc_body_start] = ACTIONS(12482),
    [sym__binary_minus] = ACTIONS(12482),
    [sym__binary_star] = ACTIONS(12482),
    [anon_sym_LBRACE] = ACTIONS(12482),
    [anon_sym_RBRACE] = ACTIONS(12482),
    [anon_sym_RPAREN] = ACTIONS(12482),
    [anon_sym_DOT] = ACTIONS(12484),
    [anon_sym_COMMA] = ACTIONS(12482),
    [anon_sym_PIPE] = ACTIONS(12484),
    [anon_sym_SEMI] = ACTIONS(12482),
    [anon_sym_STAR_STAR] = ACTIONS(12484),
    [anon_sym_AMP] = ACTIONS(12484),
    [anon_sym_EQ] = ACTIONS(12484),
    [anon_sym_LT] = ACTIONS(12484),
    [anon_sym_if] = ACTIONS(12482),
    [anon_sym_unless] = ACTIONS(12482),
    [anon_sym_while] = ACTIONS(12482),
    [anon_sym_until] = ACTIONS(12482),
    [anon_sym_rescue] = ACTIONS(12482),
    [anon_sym_in] = ACTIONS(12482),
    [anon_sym_do] = ACTIONS(12482),
    [anon_sym_EQ_GT] = ACTIONS(12482),
    [anon_sym_LBRACK] = ACTIONS(12482),
    [anon_sym_RBRACK] = ACTIONS(12482),
    [anon_sym_COLON_COLON2] = ACTIONS(12482),
    [anon_sym_AMP_DOT] = ACTIONS(12482),
    [anon_sym_PLUS_EQ] = ACTIONS(12482),
    [anon_sym_DASH_EQ] = ACTIONS(12482),
    [anon_sym_STAR_EQ] = ACTIONS(12482),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12482),
    [anon_sym_SLASH_EQ] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12482),
    [anon_sym_PIPE_EQ] = ACTIONS(12482),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12482),
    [anon_sym_AMP_EQ] = ACTIONS(12482),
    [anon_sym_PERCENT_EQ] = ACTIONS(12482),
    [anon_sym_GT_GT_EQ] = ACTIONS(12482),
    [anon_sym_LT_LT_EQ] = ACTIONS(12482),
    [anon_sym_CARET_EQ] = ACTIONS(12482),
    [anon_sym_QMARK] = ACTIONS(12482),
    [anon_sym_COLON2] = ACTIONS(12484),
    [anon_sym_DOT_DOT] = ACTIONS(12484),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12482),
    [anon_sym_and] = ACTIONS(12482),
    [anon_sym_or] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE] = ACTIONS(12484),
    [anon_sym_AMP_AMP] = ACTIONS(12484),
    [anon_sym_LT_LT] = ACTIONS(12484),
    [anon_sym_GT_GT] = ACTIONS(12484),
    [anon_sym_EQ_EQ] = ACTIONS(12484),
    [anon_sym_BANG_EQ] = ACTIONS(12482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12482),
    [anon_sym_LT_EQ_GT] = ACTIONS(12482),
    [anon_sym_EQ_TILDE] = ACTIONS(12482),
    [anon_sym_BANG_TILDE] = ACTIONS(12482),
    [anon_sym_LT_EQ] = ACTIONS(12484),
    [anon_sym_GT] = ACTIONS(12484),
    [anon_sym_GT_EQ] = ACTIONS(12482),
    [anon_sym_CARET] = ACTIONS(12484),
    [anon_sym_PLUS] = ACTIONS(12484),
    [anon_sym_SLASH] = ACTIONS(12484),
    [anon_sym_PERCENT] = ACTIONS(12484),
    [sym_comment] = ACTIONS(87),
  },
  [9977] = {
    [anon_sym_end] = ACTIONS(14263),
    [sym_comment] = ACTIONS(87),
  },
  [9978] = {
    [sym__heredoc_body_start] = ACTIONS(12622),
    [sym__binary_minus] = ACTIONS(12622),
    [sym__binary_star] = ACTIONS(12622),
    [anon_sym_LBRACE] = ACTIONS(12622),
    [anon_sym_RBRACE] = ACTIONS(12622),
    [anon_sym_RPAREN] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12624),
    [anon_sym_COMMA] = ACTIONS(12622),
    [anon_sym_PIPE] = ACTIONS(12624),
    [anon_sym_SEMI] = ACTIONS(12622),
    [anon_sym_STAR_STAR] = ACTIONS(12624),
    [anon_sym_AMP] = ACTIONS(12624),
    [anon_sym_EQ] = ACTIONS(12624),
    [anon_sym_LT] = ACTIONS(12624),
    [anon_sym_if] = ACTIONS(12622),
    [anon_sym_unless] = ACTIONS(12622),
    [anon_sym_while] = ACTIONS(12622),
    [anon_sym_until] = ACTIONS(12622),
    [anon_sym_rescue] = ACTIONS(12622),
    [anon_sym_in] = ACTIONS(12622),
    [anon_sym_do] = ACTIONS(12622),
    [anon_sym_EQ_GT] = ACTIONS(12622),
    [anon_sym_LBRACK] = ACTIONS(12622),
    [anon_sym_RBRACK] = ACTIONS(12622),
    [anon_sym_COLON_COLON2] = ACTIONS(12622),
    [anon_sym_AMP_DOT] = ACTIONS(12622),
    [anon_sym_PLUS_EQ] = ACTIONS(12622),
    [anon_sym_DASH_EQ] = ACTIONS(12622),
    [anon_sym_STAR_EQ] = ACTIONS(12622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12622),
    [anon_sym_SLASH_EQ] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12622),
    [anon_sym_PIPE_EQ] = ACTIONS(12622),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12622),
    [anon_sym_AMP_EQ] = ACTIONS(12622),
    [anon_sym_PERCENT_EQ] = ACTIONS(12622),
    [anon_sym_GT_GT_EQ] = ACTIONS(12622),
    [anon_sym_LT_LT_EQ] = ACTIONS(12622),
    [anon_sym_CARET_EQ] = ACTIONS(12622),
    [anon_sym_QMARK] = ACTIONS(12622),
    [anon_sym_COLON2] = ACTIONS(12624),
    [anon_sym_DOT_DOT] = ACTIONS(12624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12622),
    [anon_sym_and] = ACTIONS(12622),
    [anon_sym_or] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE] = ACTIONS(12624),
    [anon_sym_AMP_AMP] = ACTIONS(12624),
    [anon_sym_LT_LT] = ACTIONS(12624),
    [anon_sym_GT_GT] = ACTIONS(12624),
    [anon_sym_EQ_EQ] = ACTIONS(12624),
    [anon_sym_BANG_EQ] = ACTIONS(12622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12622),
    [anon_sym_LT_EQ_GT] = ACTIONS(12622),
    [anon_sym_EQ_TILDE] = ACTIONS(12622),
    [anon_sym_BANG_TILDE] = ACTIONS(12622),
    [anon_sym_LT_EQ] = ACTIONS(12624),
    [anon_sym_GT] = ACTIONS(12624),
    [anon_sym_GT_EQ] = ACTIONS(12622),
    [anon_sym_CARET] = ACTIONS(12624),
    [anon_sym_PLUS] = ACTIONS(12624),
    [anon_sym_SLASH] = ACTIONS(12624),
    [anon_sym_PERCENT] = ACTIONS(12624),
    [sym_comment] = ACTIONS(87),
  },
  [9979] = {
    [sym__heredoc_body_start] = ACTIONS(12770),
    [sym__binary_minus] = ACTIONS(12770),
    [sym__binary_star] = ACTIONS(12770),
    [anon_sym_LBRACE] = ACTIONS(12770),
    [anon_sym_RBRACE] = ACTIONS(12770),
    [anon_sym_RPAREN] = ACTIONS(12770),
    [anon_sym_DOT] = ACTIONS(12772),
    [anon_sym_COMMA] = ACTIONS(12770),
    [anon_sym_PIPE] = ACTIONS(12772),
    [anon_sym_SEMI] = ACTIONS(12770),
    [anon_sym_STAR_STAR] = ACTIONS(12772),
    [anon_sym_AMP] = ACTIONS(12772),
    [anon_sym_EQ] = ACTIONS(12772),
    [anon_sym_LT] = ACTIONS(12772),
    [anon_sym_if] = ACTIONS(12770),
    [anon_sym_unless] = ACTIONS(12770),
    [anon_sym_while] = ACTIONS(12770),
    [anon_sym_until] = ACTIONS(12770),
    [anon_sym_rescue] = ACTIONS(12770),
    [anon_sym_in] = ACTIONS(12770),
    [anon_sym_do] = ACTIONS(12770),
    [anon_sym_EQ_GT] = ACTIONS(12770),
    [anon_sym_LBRACK] = ACTIONS(12770),
    [anon_sym_RBRACK] = ACTIONS(12770),
    [anon_sym_COLON_COLON2] = ACTIONS(12770),
    [anon_sym_AMP_DOT] = ACTIONS(12770),
    [anon_sym_PLUS_EQ] = ACTIONS(12770),
    [anon_sym_DASH_EQ] = ACTIONS(12770),
    [anon_sym_STAR_EQ] = ACTIONS(12770),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12770),
    [anon_sym_SLASH_EQ] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12770),
    [anon_sym_PIPE_EQ] = ACTIONS(12770),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12770),
    [anon_sym_AMP_EQ] = ACTIONS(12770),
    [anon_sym_PERCENT_EQ] = ACTIONS(12770),
    [anon_sym_GT_GT_EQ] = ACTIONS(12770),
    [anon_sym_LT_LT_EQ] = ACTIONS(12770),
    [anon_sym_CARET_EQ] = ACTIONS(12770),
    [anon_sym_QMARK] = ACTIONS(12770),
    [anon_sym_COLON2] = ACTIONS(12772),
    [anon_sym_DOT_DOT] = ACTIONS(12772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12770),
    [anon_sym_and] = ACTIONS(12770),
    [anon_sym_or] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE] = ACTIONS(12772),
    [anon_sym_AMP_AMP] = ACTIONS(12772),
    [anon_sym_LT_LT] = ACTIONS(12772),
    [anon_sym_GT_GT] = ACTIONS(12772),
    [anon_sym_EQ_EQ] = ACTIONS(12772),
    [anon_sym_BANG_EQ] = ACTIONS(12770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12770),
    [anon_sym_LT_EQ_GT] = ACTIONS(12770),
    [anon_sym_EQ_TILDE] = ACTIONS(12770),
    [anon_sym_BANG_TILDE] = ACTIONS(12770),
    [anon_sym_LT_EQ] = ACTIONS(12772),
    [anon_sym_GT] = ACTIONS(12772),
    [anon_sym_GT_EQ] = ACTIONS(12770),
    [anon_sym_CARET] = ACTIONS(12772),
    [anon_sym_PLUS] = ACTIONS(12772),
    [anon_sym_SLASH] = ACTIONS(12772),
    [anon_sym_PERCENT] = ACTIONS(12772),
    [sym_comment] = ACTIONS(87),
  },
  [9980] = {
    [sym__binary_minus] = ACTIONS(14146),
    [sym__binary_star] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14148),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14148),
    [anon_sym_STAR_STAR] = ACTIONS(14148),
    [anon_sym_AMP] = ACTIONS(14148),
    [anon_sym_EQ] = ACTIONS(14148),
    [anon_sym_LT] = ACTIONS(14148),
    [anon_sym_EQ_GT] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [anon_sym_PLUS_EQ] = ACTIONS(14146),
    [anon_sym_DASH_EQ] = ACTIONS(14146),
    [anon_sym_STAR_EQ] = ACTIONS(14146),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14146),
    [anon_sym_SLASH_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14146),
    [anon_sym_AMP_EQ] = ACTIONS(14146),
    [anon_sym_PERCENT_EQ] = ACTIONS(14146),
    [anon_sym_GT_GT_EQ] = ACTIONS(14146),
    [anon_sym_LT_LT_EQ] = ACTIONS(14146),
    [anon_sym_CARET_EQ] = ACTIONS(14146),
    [anon_sym_QMARK] = ACTIONS(14146),
    [anon_sym_DOT_DOT] = ACTIONS(14148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14146),
    [anon_sym_and] = ACTIONS(14146),
    [anon_sym_or] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE] = ACTIONS(14148),
    [anon_sym_AMP_AMP] = ACTIONS(14148),
    [anon_sym_LT_LT] = ACTIONS(14148),
    [anon_sym_GT_GT] = ACTIONS(14148),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_BANG_EQ] = ACTIONS(14146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14146),
    [anon_sym_LT_EQ_GT] = ACTIONS(14146),
    [anon_sym_EQ_TILDE] = ACTIONS(14146),
    [anon_sym_BANG_TILDE] = ACTIONS(14146),
    [anon_sym_LT_EQ] = ACTIONS(14148),
    [anon_sym_GT] = ACTIONS(14148),
    [anon_sym_GT_EQ] = ACTIONS(14146),
    [anon_sym_CARET] = ACTIONS(14148),
    [anon_sym_PLUS] = ACTIONS(14148),
    [anon_sym_SLASH] = ACTIONS(14148),
    [anon_sym_PERCENT] = ACTIONS(14148),
    [sym_comment] = ACTIONS(87),
  },
  [9981] = {
    [sym__heredoc_body_start] = ACTIONS(12781),
    [sym__binary_minus] = ACTIONS(12781),
    [sym__binary_star] = ACTIONS(12781),
    [anon_sym_LBRACE] = ACTIONS(12781),
    [anon_sym_RBRACE] = ACTIONS(12781),
    [anon_sym_RPAREN] = ACTIONS(12781),
    [anon_sym_DOT] = ACTIONS(12783),
    [anon_sym_COMMA] = ACTIONS(12781),
    [anon_sym_PIPE] = ACTIONS(12783),
    [anon_sym_SEMI] = ACTIONS(12781),
    [anon_sym_STAR_STAR] = ACTIONS(12783),
    [anon_sym_AMP] = ACTIONS(12783),
    [anon_sym_EQ] = ACTIONS(12783),
    [anon_sym_LT] = ACTIONS(12783),
    [anon_sym_if] = ACTIONS(12781),
    [anon_sym_unless] = ACTIONS(12781),
    [anon_sym_while] = ACTIONS(12781),
    [anon_sym_until] = ACTIONS(12781),
    [anon_sym_rescue] = ACTIONS(12781),
    [anon_sym_in] = ACTIONS(12781),
    [anon_sym_do] = ACTIONS(12781),
    [anon_sym_EQ_GT] = ACTIONS(12781),
    [anon_sym_LBRACK] = ACTIONS(12781),
    [anon_sym_RBRACK] = ACTIONS(12781),
    [anon_sym_COLON_COLON2] = ACTIONS(12781),
    [anon_sym_AMP_DOT] = ACTIONS(12781),
    [anon_sym_PLUS_EQ] = ACTIONS(12781),
    [anon_sym_DASH_EQ] = ACTIONS(12781),
    [anon_sym_STAR_EQ] = ACTIONS(12781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12781),
    [anon_sym_SLASH_EQ] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12781),
    [anon_sym_PIPE_EQ] = ACTIONS(12781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12781),
    [anon_sym_AMP_EQ] = ACTIONS(12781),
    [anon_sym_PERCENT_EQ] = ACTIONS(12781),
    [anon_sym_GT_GT_EQ] = ACTIONS(12781),
    [anon_sym_LT_LT_EQ] = ACTIONS(12781),
    [anon_sym_CARET_EQ] = ACTIONS(12781),
    [anon_sym_QMARK] = ACTIONS(12781),
    [anon_sym_COLON2] = ACTIONS(12783),
    [anon_sym_DOT_DOT] = ACTIONS(12783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12781),
    [anon_sym_and] = ACTIONS(12781),
    [anon_sym_or] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE] = ACTIONS(12783),
    [anon_sym_AMP_AMP] = ACTIONS(12783),
    [anon_sym_LT_LT] = ACTIONS(12783),
    [anon_sym_GT_GT] = ACTIONS(12783),
    [anon_sym_EQ_EQ] = ACTIONS(12783),
    [anon_sym_BANG_EQ] = ACTIONS(12781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12781),
    [anon_sym_LT_EQ_GT] = ACTIONS(12781),
    [anon_sym_EQ_TILDE] = ACTIONS(12781),
    [anon_sym_BANG_TILDE] = ACTIONS(12781),
    [anon_sym_LT_EQ] = ACTIONS(12783),
    [anon_sym_GT] = ACTIONS(12783),
    [anon_sym_GT_EQ] = ACTIONS(12781),
    [anon_sym_CARET] = ACTIONS(12783),
    [anon_sym_PLUS] = ACTIONS(12783),
    [anon_sym_SLASH] = ACTIONS(12783),
    [anon_sym_PERCENT] = ACTIONS(12783),
    [sym_comment] = ACTIONS(87),
  },
  [9982] = {
    [sym__heredoc_body_start] = ACTIONS(13093),
    [sym__binary_minus] = ACTIONS(13093),
    [sym__binary_star] = ACTIONS(13093),
    [anon_sym_LBRACE] = ACTIONS(13093),
    [anon_sym_RBRACE] = ACTIONS(13093),
    [anon_sym_RPAREN] = ACTIONS(13093),
    [anon_sym_DOT] = ACTIONS(13095),
    [anon_sym_COMMA] = ACTIONS(13093),
    [anon_sym_PIPE] = ACTIONS(13095),
    [anon_sym_SEMI] = ACTIONS(13093),
    [anon_sym_STAR_STAR] = ACTIONS(13095),
    [anon_sym_AMP] = ACTIONS(13095),
    [anon_sym_EQ] = ACTIONS(13095),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_if] = ACTIONS(13093),
    [anon_sym_unless] = ACTIONS(13093),
    [anon_sym_while] = ACTIONS(13093),
    [anon_sym_until] = ACTIONS(13093),
    [anon_sym_rescue] = ACTIONS(13093),
    [anon_sym_in] = ACTIONS(13093),
    [anon_sym_do] = ACTIONS(13093),
    [anon_sym_EQ_GT] = ACTIONS(13093),
    [anon_sym_LBRACK] = ACTIONS(13093),
    [anon_sym_RBRACK] = ACTIONS(13093),
    [anon_sym_COLON_COLON2] = ACTIONS(13093),
    [anon_sym_AMP_DOT] = ACTIONS(13093),
    [anon_sym_PLUS_EQ] = ACTIONS(13093),
    [anon_sym_DASH_EQ] = ACTIONS(13093),
    [anon_sym_STAR_EQ] = ACTIONS(13093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13093),
    [anon_sym_SLASH_EQ] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13093),
    [anon_sym_PIPE_EQ] = ACTIONS(13093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13093),
    [anon_sym_AMP_EQ] = ACTIONS(13093),
    [anon_sym_PERCENT_EQ] = ACTIONS(13093),
    [anon_sym_GT_GT_EQ] = ACTIONS(13093),
    [anon_sym_LT_LT_EQ] = ACTIONS(13093),
    [anon_sym_CARET_EQ] = ACTIONS(13093),
    [anon_sym_QMARK] = ACTIONS(13093),
    [anon_sym_COLON2] = ACTIONS(13095),
    [anon_sym_DOT_DOT] = ACTIONS(13095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13093),
    [anon_sym_and] = ACTIONS(13093),
    [anon_sym_or] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE] = ACTIONS(13095),
    [anon_sym_AMP_AMP] = ACTIONS(13095),
    [anon_sym_LT_LT] = ACTIONS(13095),
    [anon_sym_GT_GT] = ACTIONS(13095),
    [anon_sym_EQ_EQ] = ACTIONS(13095),
    [anon_sym_BANG_EQ] = ACTIONS(13093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13093),
    [anon_sym_LT_EQ_GT] = ACTIONS(13093),
    [anon_sym_EQ_TILDE] = ACTIONS(13093),
    [anon_sym_BANG_TILDE] = ACTIONS(13093),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13093),
    [anon_sym_CARET] = ACTIONS(13095),
    [anon_sym_PLUS] = ACTIONS(13095),
    [anon_sym_SLASH] = ACTIONS(13095),
    [anon_sym_PERCENT] = ACTIONS(13095),
    [sym_comment] = ACTIONS(87),
  },
  [9983] = {
    [sym__binary_minus] = ACTIONS(6857),
    [sym__binary_star] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_STAR_STAR] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6863),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_DOT_DOT] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(6873),
    [anon_sym_AMP_AMP] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6875),
    [anon_sym_EQ_EQ] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6873),
    [anon_sym_EQ_TILDE] = ACTIONS(6873),
    [anon_sym_BANG_TILDE] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_SLASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(87),
  },
  [9984] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10628),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_assignment] = STATE(10628),
    [sym_operator_assignment] = STATE(10628),
    [sym_conditional] = STATE(10628),
    [sym_range] = STATE(10628),
    [sym_binary] = STATE(10628),
    [sym_unary] = STATE(10628),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9985] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8834),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4320),
    [sym_scope_resolution] = STATE(2459),
    [sym_call] = STATE(2459),
    [sym_method_call] = STATE(4320),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(8834),
    [sym_operator_assignment] = STATE(8834),
    [sym_conditional] = STATE(8834),
    [sym_range] = STATE(8834),
    [sym_binary] = STATE(8834),
    [sym_unary] = STATE(8834),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(4319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4320),
    [sym__variable] = STATE(2459),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4320),
    [sym_false] = STATE(4320),
    [sym_nil] = STATE(4320),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(2462),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(3458),
    [sym__unary_minus] = ACTIONS(6906),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_break] = ACTIONS(4130),
    [anon_sym_next] = ACTIONS(4132),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6908),
    [anon_sym_defined_QMARK] = ACTIONS(6910),
    [anon_sym_not] = ACTIONS(6912),
    [anon_sym_BANG] = ACTIONS(6914),
    [anon_sym_TILDE] = ACTIONS(6914),
    [sym_constant] = ACTIONS(4142),
    [sym_identifier] = ACTIONS(4142),
    [sym_instance_variable] = ACTIONS(4144),
    [sym_class_variable] = ACTIONS(4144),
    [sym_global_variable] = ACTIONS(4144),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(4142),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4142),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9986] = {
    [aux_sym_exceptions_repeat1] = STATE(10629),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14265),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [9987] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(6922),
    [sym__binary_star] = ACTIONS(6924),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(6926),
    [anon_sym_STAR_STAR] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6928),
    [anon_sym_LT] = ACTIONS(6930),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(6932),
    [anon_sym_DOT_DOT] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(6938),
    [anon_sym_AMP_AMP] = ACTIONS(6938),
    [anon_sym_LT_LT] = ACTIONS(6940),
    [anon_sym_GT_GT] = ACTIONS(6940),
    [anon_sym_EQ_EQ] = ACTIONS(6942),
    [anon_sym_BANG_EQ] = ACTIONS(6938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6938),
    [anon_sym_LT_EQ_GT] = ACTIONS(6938),
    [anon_sym_EQ_TILDE] = ACTIONS(6938),
    [anon_sym_BANG_TILDE] = ACTIONS(6938),
    [anon_sym_LT_EQ] = ACTIONS(6930),
    [anon_sym_GT] = ACTIONS(6930),
    [anon_sym_GT_EQ] = ACTIONS(6944),
    [anon_sym_CARET] = ACTIONS(6946),
    [anon_sym_PLUS] = ACTIONS(6922),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [sym_comment] = ACTIONS(87),
  },
  [9988] = {
    [aux_sym_exceptions_repeat1] = STATE(9988),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14267),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [9989] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10630),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_assignment] = STATE(10630),
    [sym_operator_assignment] = STATE(10630),
    [sym_conditional] = STATE(10630),
    [sym_range] = STATE(10630),
    [sym_binary] = STATE(10630),
    [sym_unary] = STATE(10630),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9990] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(8851),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(4363),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4363),
    [sym_splat_argument] = STATE(10613),
    [sym_assignment] = STATE(8851),
    [sym_operator_assignment] = STATE(8851),
    [sym_conditional] = STATE(8851),
    [sym_range] = STATE(8851),
    [sym_binary] = STATE(8851),
    [sym_unary] = STATE(8851),
    [sym__arg_or_splat_arg] = STATE(10613),
    [sym_left_assignment_list] = STATE(4362),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4363),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(4363),
    [sym_false] = STATE(4363),
    [sym_nil] = STATE(4363),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(4364),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(3506),
    [sym__unary_minus] = ACTIONS(6960),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(6962),
    [anon_sym_yield] = ACTIONS(6964),
    [anon_sym_break] = ACTIONS(6966),
    [anon_sym_next] = ACTIONS(6968),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6970),
    [anon_sym_defined_QMARK] = ACTIONS(6972),
    [anon_sym_not] = ACTIONS(6974),
    [anon_sym_BANG] = ACTIONS(6976),
    [anon_sym_TILDE] = ACTIONS(6976),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [9991] = {
    [aux_sym_exceptions_repeat1] = STATE(10631),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14270),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [9992] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(6988),
    [sym__binary_star] = ACTIONS(6990),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(6992),
    [anon_sym_STAR_STAR] = ACTIONS(6994),
    [anon_sym_AMP] = ACTIONS(6996),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(6998),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7000),
    [anon_sym_DOT_DOT] = ACTIONS(7002),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7004),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7006),
    [anon_sym_AMP_AMP] = ACTIONS(7006),
    [anon_sym_LT_LT] = ACTIONS(7008),
    [anon_sym_GT_GT] = ACTIONS(7008),
    [anon_sym_EQ_EQ] = ACTIONS(7006),
    [anon_sym_BANG_EQ] = ACTIONS(7010),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7010),
    [anon_sym_LT_EQ_GT] = ACTIONS(7010),
    [anon_sym_EQ_TILDE] = ACTIONS(7010),
    [anon_sym_BANG_TILDE] = ACTIONS(7010),
    [anon_sym_LT_EQ] = ACTIONS(6998),
    [anon_sym_GT] = ACTIONS(6998),
    [anon_sym_GT_EQ] = ACTIONS(7012),
    [anon_sym_CARET] = ACTIONS(6992),
    [anon_sym_PLUS] = ACTIONS(7014),
    [anon_sym_SLASH] = ACTIONS(6994),
    [anon_sym_PERCENT] = ACTIONS(6994),
    [sym_comment] = ACTIONS(87),
  },
  [9993] = {
    [aux_sym_exceptions_repeat1] = STATE(9993),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14272),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [9994] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10632),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(4399),
    [sym_scope_resolution] = STATE(672),
    [sym_call] = STATE(672),
    [sym_method_call] = STATE(4399),
    [sym_assignment] = STATE(10632),
    [sym_operator_assignment] = STATE(10632),
    [sym_conditional] = STATE(10632),
    [sym_range] = STATE(10632),
    [sym_binary] = STATE(10632),
    [sym_unary] = STATE(10632),
    [sym_left_assignment_list] = STATE(4398),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4399),
    [sym__variable] = STATE(672),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(4399),
    [sym_false] = STATE(4399),
    [sym_nil] = STATE(4399),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(4400),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(7028),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7030),
    [anon_sym_yield] = ACTIONS(7032),
    [anon_sym_break] = ACTIONS(7034),
    [anon_sym_next] = ACTIONS(7036),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7038),
    [anon_sym_defined_QMARK] = ACTIONS(7040),
    [anon_sym_not] = ACTIONS(7042),
    [anon_sym_BANG] = ACTIONS(7044),
    [anon_sym_TILDE] = ACTIONS(7044),
    [sym_constant] = ACTIONS(1259),
    [sym_identifier] = ACTIONS(1259),
    [sym_instance_variable] = ACTIONS(1261),
    [sym_class_variable] = ACTIONS(1261),
    [sym_global_variable] = ACTIONS(1261),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(1259),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9995] = {
    [sym__line_break] = ACTIONS(11655),
    [sym__heredoc_body_start] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11655),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_SEMI] = ACTIONS(11655),
    [anon_sym_then] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [sym_comment] = ACTIONS(87),
  },
  [9996] = {
    [sym__line_break] = ACTIONS(11680),
    [sym__heredoc_body_start] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11680),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_SEMI] = ACTIONS(11680),
    [anon_sym_then] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [sym_comment] = ACTIONS(87),
  },
  [9997] = {
    [anon_sym_end] = ACTIONS(14275),
    [sym_comment] = ACTIONS(87),
  },
  [9998] = {
    [sym__statements] = STATE(10634),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14277),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9999] = {
    [sym__line_break] = ACTIONS(13256),
    [sym__heredoc_body_start] = ACTIONS(13256),
    [anon_sym_COMMA] = ACTIONS(13256),
    [anon_sym_SEMI] = ACTIONS(13256),
    [sym_comment] = ACTIONS(87),
  },
  [10000] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_RPAREN] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [10001] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_RPAREN] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [10002] = {
    [sym_heredoc_body] = STATE(10002),
    [aux_sym_call_repeat1] = STATE(10002),
    [sym__heredoc_body_start] = ACTIONS(13586),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10003] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(6948),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(2107),
    [sym_scope_resolution] = STATE(2070),
    [sym_call] = STATE(2070),
    [sym_method_call] = STATE(2107),
    [sym__argument] = STATE(10045),
    [sym_splat_argument] = STATE(10045),
    [sym_hash_splat_argument] = STATE(10045),
    [sym_block_argument] = STATE(10045),
    [sym_assignment] = STATE(6948),
    [sym_operator_assignment] = STATE(6948),
    [sym_conditional] = STATE(6948),
    [sym_range] = STATE(6948),
    [sym_binary] = STATE(6948),
    [sym_unary] = STATE(6948),
    [sym_left_assignment_list] = STATE(2106),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(2107),
    [sym__variable] = STATE(2070),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(2107),
    [sym_false] = STATE(2107),
    [sym_nil] = STATE(2107),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(6951),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(10045),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(10293),
    [sym__splat_star] = ACTIONS(10295),
    [sym__unary_minus] = ACTIONS(3570),
    [sym__identifier_hash_key] = ACTIONS(10297),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13533),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3576),
    [anon_sym_yield] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_next] = ACTIONS(3582),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_defined_QMARK] = ACTIONS(3586),
    [anon_sym_not] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3590),
    [anon_sym_TILDE] = ACTIONS(3590),
    [sym_constant] = ACTIONS(10299),
    [sym_identifier] = ACTIONS(10299),
    [sym_instance_variable] = ACTIONS(3530),
    [sym_class_variable] = ACTIONS(3530),
    [sym_global_variable] = ACTIONS(3530),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3532),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3532),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10004] = {
    [sym_heredoc_body] = STATE(10002),
    [aux_sym_call_repeat1] = STATE(10002),
    [sym__heredoc_body_start] = ACTIONS(10491),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_RPAREN] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10005] = {
    [aux_sym_argument_list_repeat1] = STATE(10005),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14279),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [10006] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10635),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_assignment] = STATE(10635),
    [sym_operator_assignment] = STATE(10635),
    [sym_conditional] = STATE(10635),
    [sym_range] = STATE(10635),
    [sym_binary] = STATE(10635),
    [sym_unary] = STATE(10635),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [10007] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(8901),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(4423),
    [sym_scope_resolution] = STATE(4361),
    [sym_call] = STATE(4361),
    [sym_method_call] = STATE(4423),
    [sym_splat_argument] = STATE(10064),
    [sym_assignment] = STATE(8901),
    [sym_operator_assignment] = STATE(8901),
    [sym_conditional] = STATE(8901),
    [sym_range] = STATE(8901),
    [sym_binary] = STATE(8901),
    [sym_unary] = STATE(8901),
    [sym__arg_or_splat_arg] = STATE(10064),
    [sym_left_assignment_list] = STATE(4422),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(4423),
    [sym__variable] = STATE(4361),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(4423),
    [sym_false] = STATE(4423),
    [sym_nil] = STATE(4423),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(4424),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(3868),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(3872),
    [sym__subshell_start] = ACTIONS(3874),
    [sym__regex_start] = ACTIONS(3876),
    [sym__string_array_start] = ACTIONS(3878),
    [sym__symbol_array_start] = ACTIONS(3880),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(10295),
    [sym__unary_minus] = ACTIONS(7068),
    [anon_sym_LBRACE] = ACTIONS(3884),
    [anon_sym_def] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_module] = ACTIONS(3892),
    [anon_sym_return] = ACTIONS(7070),
    [anon_sym_yield] = ACTIONS(7072),
    [anon_sym_break] = ACTIONS(7074),
    [anon_sym_next] = ACTIONS(7076),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(3902),
    [anon_sym_unless] = ACTIONS(3904),
    [anon_sym_while] = ACTIONS(3906),
    [anon_sym_until] = ACTIONS(3908),
    [anon_sym_for] = ACTIONS(3910),
    [anon_sym_case] = ACTIONS(3912),
    [anon_sym_begin] = ACTIONS(3914),
    [anon_sym_PLUS] = ACTIONS(7078),
    [anon_sym_defined_QMARK] = ACTIONS(7080),
    [anon_sym_not] = ACTIONS(7082),
    [anon_sym_BANG] = ACTIONS(7084),
    [anon_sym_TILDE] = ACTIONS(7084),
    [sym_constant] = ACTIONS(6978),
    [sym_identifier] = ACTIONS(6978),
    [sym_instance_variable] = ACTIONS(6980),
    [sym_class_variable] = ACTIONS(6980),
    [sym_global_variable] = ACTIONS(6980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(3928),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(6978),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(6978),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(3930),
    [anon_sym_DASH_GT] = ACTIONS(3932),
  },
  [10008] = {
    [aux_sym_exceptions_repeat1] = STATE(10636),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_RPAREN] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14282),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10009] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7100),
    [sym__binary_star] = ACTIONS(7102),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7104),
    [anon_sym_STAR_STAR] = ACTIONS(7102),
    [anon_sym_AMP] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(7108),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7110),
    [anon_sym_DOT_DOT] = ACTIONS(7112),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7114),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7118),
    [anon_sym_AMP_AMP] = ACTIONS(7118),
    [anon_sym_LT_LT] = ACTIONS(7120),
    [anon_sym_GT_GT] = ACTIONS(7120),
    [anon_sym_EQ_EQ] = ACTIONS(7122),
    [anon_sym_BANG_EQ] = ACTIONS(7118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7118),
    [anon_sym_LT_EQ_GT] = ACTIONS(7118),
    [anon_sym_EQ_TILDE] = ACTIONS(7118),
    [anon_sym_BANG_TILDE] = ACTIONS(7118),
    [anon_sym_LT_EQ] = ACTIONS(7108),
    [anon_sym_GT] = ACTIONS(7108),
    [anon_sym_GT_EQ] = ACTIONS(7124),
    [anon_sym_CARET] = ACTIONS(7126),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [sym_comment] = ACTIONS(87),
  },
  [10010] = {
    [aux_sym_exceptions_repeat1] = STATE(10010),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14284),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10011] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7138),
    [sym__binary_star] = ACTIONS(7140),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7142),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(7140),
    [anon_sym_AMP] = ACTIONS(7144),
    [anon_sym_LT] = ACTIONS(7146),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7148),
    [anon_sym_DOT_DOT] = ACTIONS(7150),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7152),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7156),
    [anon_sym_EQ_EQ] = ACTIONS(7158),
    [anon_sym_BANG_EQ] = ACTIONS(7154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7154),
    [anon_sym_LT_EQ_GT] = ACTIONS(7154),
    [anon_sym_EQ_TILDE] = ACTIONS(7154),
    [anon_sym_BANG_TILDE] = ACTIONS(7154),
    [anon_sym_LT_EQ] = ACTIONS(7146),
    [anon_sym_GT] = ACTIONS(7146),
    [anon_sym_GT_EQ] = ACTIONS(7160),
    [anon_sym_CARET] = ACTIONS(7162),
    [anon_sym_PLUS] = ACTIONS(7138),
    [anon_sym_SLASH] = ACTIONS(7140),
    [anon_sym_PERCENT] = ACTIONS(7140),
    [sym_comment] = ACTIONS(87),
  },
  [10012] = {
    [aux_sym_exceptions_repeat1] = STATE(10012),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14287),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10013] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7193),
    [sym__binary_star] = ACTIONS(7195),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7197),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(7199),
    [anon_sym_AMP] = ACTIONS(7201),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(7203),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7205),
    [anon_sym_DOT_DOT] = ACTIONS(7207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7209),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7211),
    [anon_sym_AMP_AMP] = ACTIONS(7211),
    [anon_sym_LT_LT] = ACTIONS(7213),
    [anon_sym_GT_GT] = ACTIONS(7213),
    [anon_sym_EQ_EQ] = ACTIONS(7211),
    [anon_sym_BANG_EQ] = ACTIONS(7215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7215),
    [anon_sym_LT_EQ_GT] = ACTIONS(7215),
    [anon_sym_EQ_TILDE] = ACTIONS(7215),
    [anon_sym_BANG_TILDE] = ACTIONS(7215),
    [anon_sym_LT_EQ] = ACTIONS(7203),
    [anon_sym_GT] = ACTIONS(7203),
    [anon_sym_GT_EQ] = ACTIONS(7217),
    [anon_sym_CARET] = ACTIONS(7197),
    [anon_sym_PLUS] = ACTIONS(7219),
    [anon_sym_SLASH] = ACTIONS(7199),
    [anon_sym_PERCENT] = ACTIONS(7199),
    [sym_comment] = ACTIONS(87),
  },
  [10014] = {
    [aux_sym_exceptions_repeat1] = STATE(10014),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14290),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10015] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7229),
    [sym__binary_star] = ACTIONS(7231),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7233),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(7231),
    [anon_sym_AMP] = ACTIONS(7235),
    [anon_sym_LT] = ACTIONS(7237),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7239),
    [anon_sym_DOT_DOT] = ACTIONS(7241),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7243),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7245),
    [anon_sym_AMP_AMP] = ACTIONS(7245),
    [anon_sym_LT_LT] = ACTIONS(7247),
    [anon_sym_GT_GT] = ACTIONS(7247),
    [anon_sym_EQ_EQ] = ACTIONS(7249),
    [anon_sym_BANG_EQ] = ACTIONS(7245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7245),
    [anon_sym_LT_EQ_GT] = ACTIONS(7245),
    [anon_sym_EQ_TILDE] = ACTIONS(7245),
    [anon_sym_BANG_TILDE] = ACTIONS(7245),
    [anon_sym_LT_EQ] = ACTIONS(7237),
    [anon_sym_GT] = ACTIONS(7237),
    [anon_sym_GT_EQ] = ACTIONS(7251),
    [anon_sym_CARET] = ACTIONS(7253),
    [anon_sym_PLUS] = ACTIONS(7229),
    [anon_sym_SLASH] = ACTIONS(7231),
    [anon_sym_PERCENT] = ACTIONS(7231),
    [sym_comment] = ACTIONS(87),
  },
  [10016] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7307),
    [sym__binary_star] = ACTIONS(7309),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7311),
    [anon_sym_STAR_STAR] = ACTIONS(7309),
    [anon_sym_AMP] = ACTIONS(7313),
    [anon_sym_LT] = ACTIONS(7315),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7317),
    [anon_sym_DOT_DOT] = ACTIONS(7319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7321),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7325),
    [anon_sym_AMP_AMP] = ACTIONS(7325),
    [anon_sym_LT_LT] = ACTIONS(7327),
    [anon_sym_GT_GT] = ACTIONS(7327),
    [anon_sym_EQ_EQ] = ACTIONS(7329),
    [anon_sym_BANG_EQ] = ACTIONS(7325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7325),
    [anon_sym_LT_EQ_GT] = ACTIONS(7325),
    [anon_sym_EQ_TILDE] = ACTIONS(7325),
    [anon_sym_BANG_TILDE] = ACTIONS(7325),
    [anon_sym_LT_EQ] = ACTIONS(7315),
    [anon_sym_GT] = ACTIONS(7315),
    [anon_sym_GT_EQ] = ACTIONS(7331),
    [anon_sym_CARET] = ACTIONS(7333),
    [anon_sym_PLUS] = ACTIONS(7307),
    [anon_sym_SLASH] = ACTIONS(7309),
    [anon_sym_PERCENT] = ACTIONS(7309),
    [sym_comment] = ACTIONS(87),
  },
  [10017] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10018] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [10019] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10020] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10021] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10022] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14293),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10023] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10024] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10025] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10026] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10027] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10028] = {
    [aux_sym_exceptions_repeat1] = STATE(10639),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [10029] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10030] = {
    [sym_string] = STATE(10030),
    [aux_sym_chained_string_repeat1] = STATE(10030),
    [sym__string_start] = ACTIONS(13427),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [10031] = {
    [aux_sym_exceptions_repeat1] = STATE(10031),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14295),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10032] = {
    [anon_sym_DOT] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_COLON_COLON2] = ACTIONS(13660),
    [anon_sym_AMP_DOT] = ACTIONS(13660),
    [sym_comment] = ACTIONS(87),
  },
  [10033] = {
    [anon_sym_LBRACE] = ACTIONS(14146),
    [anon_sym_RPAREN] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14146),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14146),
    [anon_sym_SEMI] = ACTIONS(14146),
    [anon_sym_EQ] = ACTIONS(14146),
    [anon_sym_in] = ACTIONS(14146),
    [anon_sym_do] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [sym_comment] = ACTIONS(87),
  },
  [10034] = {
    [sym__heredoc_body_start] = ACTIONS(9793),
    [sym__binary_minus] = ACTIONS(9793),
    [sym__binary_star] = ACTIONS(9793),
    [anon_sym_LBRACE] = ACTIONS(9793),
    [anon_sym_RPAREN] = ACTIONS(9793),
    [anon_sym_DOT] = ACTIONS(9795),
    [anon_sym_COMMA] = ACTIONS(9793),
    [anon_sym_PIPE] = ACTIONS(9795),
    [anon_sym_STAR_STAR] = ACTIONS(9793),
    [anon_sym_AMP] = ACTIONS(9795),
    [anon_sym_EQ] = ACTIONS(9795),
    [anon_sym_LT] = ACTIONS(9795),
    [anon_sym_do] = ACTIONS(9793),
    [anon_sym_LBRACK] = ACTIONS(9793),
    [anon_sym_COLON_COLON2] = ACTIONS(9793),
    [anon_sym_AMP_DOT] = ACTIONS(9793),
    [anon_sym_QMARK] = ACTIONS(9793),
    [anon_sym_DOT_DOT] = ACTIONS(9795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9793),
    [anon_sym_and] = ACTIONS(9793),
    [anon_sym_or] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE] = ACTIONS(9793),
    [anon_sym_AMP_AMP] = ACTIONS(9793),
    [anon_sym_LT_LT] = ACTIONS(9793),
    [anon_sym_GT_GT] = ACTIONS(9793),
    [anon_sym_EQ_EQ] = ACTIONS(9795),
    [anon_sym_BANG_EQ] = ACTIONS(9793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9793),
    [anon_sym_LT_EQ_GT] = ACTIONS(9793),
    [anon_sym_EQ_TILDE] = ACTIONS(9793),
    [anon_sym_BANG_TILDE] = ACTIONS(9793),
    [anon_sym_LT_EQ] = ACTIONS(9795),
    [anon_sym_GT] = ACTIONS(9795),
    [anon_sym_GT_EQ] = ACTIONS(9793),
    [anon_sym_CARET] = ACTIONS(9793),
    [anon_sym_PLUS] = ACTIONS(9793),
    [anon_sym_SLASH] = ACTIONS(9793),
    [anon_sym_PERCENT] = ACTIONS(9793),
    [sym_comment] = ACTIONS(87),
  },
  [10035] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14298),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10036] = {
    [sym__heredoc_body_start] = ACTIONS(9799),
    [sym__binary_minus] = ACTIONS(9799),
    [sym__binary_star] = ACTIONS(9799),
    [anon_sym_LBRACE] = ACTIONS(9799),
    [anon_sym_RPAREN] = ACTIONS(9799),
    [anon_sym_DOT] = ACTIONS(9801),
    [anon_sym_COMMA] = ACTIONS(9799),
    [anon_sym_PIPE] = ACTIONS(9801),
    [anon_sym_STAR_STAR] = ACTIONS(9799),
    [anon_sym_AMP] = ACTIONS(9801),
    [anon_sym_EQ] = ACTIONS(9801),
    [anon_sym_LT] = ACTIONS(9801),
    [anon_sym_do] = ACTIONS(9799),
    [anon_sym_LBRACK] = ACTIONS(9799),
    [anon_sym_COLON_COLON2] = ACTIONS(9799),
    [anon_sym_AMP_DOT] = ACTIONS(9799),
    [anon_sym_QMARK] = ACTIONS(9799),
    [anon_sym_DOT_DOT] = ACTIONS(9801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9799),
    [anon_sym_and] = ACTIONS(9799),
    [anon_sym_or] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE] = ACTIONS(9799),
    [anon_sym_AMP_AMP] = ACTIONS(9799),
    [anon_sym_LT_LT] = ACTIONS(9799),
    [anon_sym_GT_GT] = ACTIONS(9799),
    [anon_sym_EQ_EQ] = ACTIONS(9801),
    [anon_sym_BANG_EQ] = ACTIONS(9799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9799),
    [anon_sym_LT_EQ_GT] = ACTIONS(9799),
    [anon_sym_EQ_TILDE] = ACTIONS(9799),
    [anon_sym_BANG_TILDE] = ACTIONS(9799),
    [anon_sym_LT_EQ] = ACTIONS(9801),
    [anon_sym_GT] = ACTIONS(9801),
    [anon_sym_GT_EQ] = ACTIONS(9799),
    [anon_sym_CARET] = ACTIONS(9799),
    [anon_sym_PLUS] = ACTIONS(9799),
    [anon_sym_SLASH] = ACTIONS(9799),
    [anon_sym_PERCENT] = ACTIONS(9799),
    [sym_comment] = ACTIONS(87),
  },
  [10037] = {
    [sym__heredoc_body_start] = ACTIONS(9803),
    [sym__binary_minus] = ACTIONS(9803),
    [sym__binary_star] = ACTIONS(9803),
    [anon_sym_LBRACE] = ACTIONS(9803),
    [anon_sym_RPAREN] = ACTIONS(9803),
    [anon_sym_DOT] = ACTIONS(9805),
    [anon_sym_COMMA] = ACTIONS(9803),
    [anon_sym_PIPE] = ACTIONS(9805),
    [anon_sym_STAR_STAR] = ACTIONS(9803),
    [anon_sym_AMP] = ACTIONS(9805),
    [anon_sym_EQ] = ACTIONS(9805),
    [anon_sym_LT] = ACTIONS(9805),
    [anon_sym_do] = ACTIONS(9803),
    [anon_sym_LBRACK] = ACTIONS(9803),
    [anon_sym_COLON_COLON2] = ACTIONS(9803),
    [anon_sym_AMP_DOT] = ACTIONS(9803),
    [anon_sym_QMARK] = ACTIONS(9803),
    [anon_sym_DOT_DOT] = ACTIONS(9805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9803),
    [anon_sym_and] = ACTIONS(9803),
    [anon_sym_or] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE] = ACTIONS(9803),
    [anon_sym_AMP_AMP] = ACTIONS(9803),
    [anon_sym_LT_LT] = ACTIONS(9803),
    [anon_sym_GT_GT] = ACTIONS(9803),
    [anon_sym_EQ_EQ] = ACTIONS(9805),
    [anon_sym_BANG_EQ] = ACTIONS(9803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9803),
    [anon_sym_LT_EQ_GT] = ACTIONS(9803),
    [anon_sym_EQ_TILDE] = ACTIONS(9803),
    [anon_sym_BANG_TILDE] = ACTIONS(9803),
    [anon_sym_LT_EQ] = ACTIONS(9805),
    [anon_sym_GT] = ACTIONS(9805),
    [anon_sym_GT_EQ] = ACTIONS(9803),
    [anon_sym_CARET] = ACTIONS(9803),
    [anon_sym_PLUS] = ACTIONS(9803),
    [anon_sym_SLASH] = ACTIONS(9803),
    [anon_sym_PERCENT] = ACTIONS(9803),
    [sym_comment] = ACTIONS(87),
  },
  [10038] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14300),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10039] = {
    [sym__heredoc_body_start] = ACTIONS(9809),
    [sym__binary_minus] = ACTIONS(9809),
    [sym__binary_star] = ACTIONS(9809),
    [anon_sym_LBRACE] = ACTIONS(9809),
    [anon_sym_RPAREN] = ACTIONS(9809),
    [anon_sym_DOT] = ACTIONS(9811),
    [anon_sym_COMMA] = ACTIONS(9809),
    [anon_sym_PIPE] = ACTIONS(9811),
    [anon_sym_STAR_STAR] = ACTIONS(9809),
    [anon_sym_AMP] = ACTIONS(9811),
    [anon_sym_EQ] = ACTIONS(9811),
    [anon_sym_LT] = ACTIONS(9811),
    [anon_sym_do] = ACTIONS(9809),
    [anon_sym_LBRACK] = ACTIONS(9809),
    [anon_sym_COLON_COLON2] = ACTIONS(9809),
    [anon_sym_AMP_DOT] = ACTIONS(9809),
    [anon_sym_QMARK] = ACTIONS(9809),
    [anon_sym_DOT_DOT] = ACTIONS(9811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9809),
    [anon_sym_and] = ACTIONS(9809),
    [anon_sym_or] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE] = ACTIONS(9809),
    [anon_sym_AMP_AMP] = ACTIONS(9809),
    [anon_sym_LT_LT] = ACTIONS(9809),
    [anon_sym_GT_GT] = ACTIONS(9809),
    [anon_sym_EQ_EQ] = ACTIONS(9811),
    [anon_sym_BANG_EQ] = ACTIONS(9809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9809),
    [anon_sym_LT_EQ_GT] = ACTIONS(9809),
    [anon_sym_EQ_TILDE] = ACTIONS(9809),
    [anon_sym_BANG_TILDE] = ACTIONS(9809),
    [anon_sym_LT_EQ] = ACTIONS(9811),
    [anon_sym_GT] = ACTIONS(9811),
    [anon_sym_GT_EQ] = ACTIONS(9809),
    [anon_sym_CARET] = ACTIONS(9809),
    [anon_sym_PLUS] = ACTIONS(9809),
    [anon_sym_SLASH] = ACTIONS(9809),
    [anon_sym_PERCENT] = ACTIONS(9809),
    [sym_comment] = ACTIONS(87),
  },
  [10040] = {
    [sym__method_rest] = STATE(10642),
    [sym_operator] = STATE(4681),
    [sym__method_name] = STATE(4681),
    [sym_setter] = STATE(4681),
    [sym_symbol] = STATE(4681),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12330),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12330),
    [sym_class_variable] = ACTIONS(12330),
    [sym_global_variable] = ACTIONS(12330),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [10041] = {
    [sym__heredoc_body_start] = ACTIONS(10532),
    [sym__binary_minus] = ACTIONS(10532),
    [sym__binary_star] = ACTIONS(10532),
    [anon_sym_LBRACE] = ACTIONS(10532),
    [anon_sym_RPAREN] = ACTIONS(10532),
    [anon_sym_DOT] = ACTIONS(10534),
    [anon_sym_COMMA] = ACTIONS(10532),
    [anon_sym_PIPE] = ACTIONS(10534),
    [anon_sym_STAR_STAR] = ACTIONS(10532),
    [anon_sym_AMP] = ACTIONS(10534),
    [anon_sym_EQ] = ACTIONS(10534),
    [anon_sym_LT] = ACTIONS(10534),
    [anon_sym_do] = ACTIONS(10532),
    [anon_sym_LBRACK] = ACTIONS(10532),
    [anon_sym_COLON_COLON2] = ACTIONS(10532),
    [anon_sym_AMP_DOT] = ACTIONS(10532),
    [anon_sym_QMARK] = ACTIONS(10532),
    [anon_sym_DOT_DOT] = ACTIONS(10534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10532),
    [anon_sym_and] = ACTIONS(10532),
    [anon_sym_or] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE] = ACTIONS(10532),
    [anon_sym_AMP_AMP] = ACTIONS(10532),
    [anon_sym_LT_LT] = ACTIONS(10532),
    [anon_sym_GT_GT] = ACTIONS(10532),
    [anon_sym_EQ_EQ] = ACTIONS(10534),
    [anon_sym_BANG_EQ] = ACTIONS(10532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10532),
    [anon_sym_LT_EQ_GT] = ACTIONS(10532),
    [anon_sym_EQ_TILDE] = ACTIONS(10532),
    [anon_sym_BANG_TILDE] = ACTIONS(10532),
    [anon_sym_LT_EQ] = ACTIONS(10534),
    [anon_sym_GT] = ACTIONS(10534),
    [anon_sym_GT_EQ] = ACTIONS(10532),
    [anon_sym_CARET] = ACTIONS(10532),
    [anon_sym_PLUS] = ACTIONS(10532),
    [anon_sym_SLASH] = ACTIONS(10532),
    [anon_sym_PERCENT] = ACTIONS(10532),
    [sym_comment] = ACTIONS(87),
  },
  [10042] = {
    [sym__heredoc_body_start] = ACTIONS(10536),
    [sym__binary_minus] = ACTIONS(10536),
    [sym__binary_star] = ACTIONS(10536),
    [anon_sym_LBRACE] = ACTIONS(10536),
    [anon_sym_RPAREN] = ACTIONS(10536),
    [anon_sym_DOT] = ACTIONS(10538),
    [anon_sym_COMMA] = ACTIONS(10536),
    [anon_sym_PIPE] = ACTIONS(10538),
    [anon_sym_STAR_STAR] = ACTIONS(10536),
    [anon_sym_AMP] = ACTIONS(10538),
    [anon_sym_EQ] = ACTIONS(10538),
    [anon_sym_LT] = ACTIONS(10538),
    [anon_sym_do] = ACTIONS(10536),
    [anon_sym_LBRACK] = ACTIONS(10536),
    [anon_sym_COLON_COLON2] = ACTIONS(10536),
    [anon_sym_AMP_DOT] = ACTIONS(10536),
    [anon_sym_QMARK] = ACTIONS(10536),
    [anon_sym_DOT_DOT] = ACTIONS(10538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10536),
    [anon_sym_and] = ACTIONS(10536),
    [anon_sym_or] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE] = ACTIONS(10536),
    [anon_sym_AMP_AMP] = ACTIONS(10536),
    [anon_sym_LT_LT] = ACTIONS(10536),
    [anon_sym_GT_GT] = ACTIONS(10536),
    [anon_sym_EQ_EQ] = ACTIONS(10538),
    [anon_sym_BANG_EQ] = ACTIONS(10536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10536),
    [anon_sym_LT_EQ_GT] = ACTIONS(10536),
    [anon_sym_EQ_TILDE] = ACTIONS(10536),
    [anon_sym_BANG_TILDE] = ACTIONS(10536),
    [anon_sym_LT_EQ] = ACTIONS(10538),
    [anon_sym_GT] = ACTIONS(10538),
    [anon_sym_GT_EQ] = ACTIONS(10536),
    [anon_sym_CARET] = ACTIONS(10536),
    [anon_sym_PLUS] = ACTIONS(10536),
    [anon_sym_SLASH] = ACTIONS(10536),
    [anon_sym_PERCENT] = ACTIONS(10536),
    [sym_comment] = ACTIONS(87),
  },
  [10043] = {
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym__binary_minus] = ACTIONS(10568),
    [sym__binary_star] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_RPAREN] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10570),
    [anon_sym_COMMA] = ACTIONS(10568),
    [anon_sym_PIPE] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_AMP] = ACTIONS(10570),
    [anon_sym_EQ] = ACTIONS(10570),
    [anon_sym_LT] = ACTIONS(10570),
    [anon_sym_do] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_QMARK] = ACTIONS(10568),
    [anon_sym_DOT_DOT] = ACTIONS(10570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10568),
    [anon_sym_and] = ACTIONS(10568),
    [anon_sym_or] = ACTIONS(10568),
    [anon_sym_PIPE_PIPE] = ACTIONS(10568),
    [anon_sym_AMP_AMP] = ACTIONS(10568),
    [anon_sym_LT_LT] = ACTIONS(10568),
    [anon_sym_GT_GT] = ACTIONS(10568),
    [anon_sym_EQ_EQ] = ACTIONS(10570),
    [anon_sym_BANG_EQ] = ACTIONS(10568),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10568),
    [anon_sym_LT_EQ_GT] = ACTIONS(10568),
    [anon_sym_EQ_TILDE] = ACTIONS(10568),
    [anon_sym_BANG_TILDE] = ACTIONS(10568),
    [anon_sym_LT_EQ] = ACTIONS(10570),
    [anon_sym_GT] = ACTIONS(10570),
    [anon_sym_GT_EQ] = ACTIONS(10568),
    [anon_sym_CARET] = ACTIONS(10568),
    [anon_sym_PLUS] = ACTIONS(10568),
    [anon_sym_SLASH] = ACTIONS(10568),
    [anon_sym_PERCENT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [10044] = {
    [sym__heredoc_body_start] = ACTIONS(6547),
    [sym__binary_minus] = ACTIONS(6547),
    [sym__binary_star] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [anon_sym_DOT] = ACTIONS(8423),
    [anon_sym_COMMA] = ACTIONS(6547),
    [anon_sym_PIPE] = ACTIONS(8423),
    [anon_sym_STAR_STAR] = ACTIONS(6547),
    [anon_sym_AMP] = ACTIONS(8423),
    [anon_sym_EQ] = ACTIONS(8423),
    [anon_sym_LT] = ACTIONS(8423),
    [anon_sym_do] = ACTIONS(6547),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_COLON_COLON2] = ACTIONS(6547),
    [anon_sym_AMP_DOT] = ACTIONS(6547),
    [anon_sym_QMARK] = ACTIONS(6547),
    [anon_sym_DOT_DOT] = ACTIONS(8423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6547),
    [anon_sym_and] = ACTIONS(6547),
    [anon_sym_or] = ACTIONS(6547),
    [anon_sym_PIPE_PIPE] = ACTIONS(6547),
    [anon_sym_AMP_AMP] = ACTIONS(6547),
    [anon_sym_LT_LT] = ACTIONS(6547),
    [anon_sym_GT_GT] = ACTIONS(6547),
    [anon_sym_EQ_EQ] = ACTIONS(8423),
    [anon_sym_BANG_EQ] = ACTIONS(6547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6547),
    [anon_sym_LT_EQ_GT] = ACTIONS(6547),
    [anon_sym_EQ_TILDE] = ACTIONS(6547),
    [anon_sym_BANG_TILDE] = ACTIONS(6547),
    [anon_sym_LT_EQ] = ACTIONS(8423),
    [anon_sym_GT] = ACTIONS(8423),
    [anon_sym_GT_EQ] = ACTIONS(6547),
    [anon_sym_CARET] = ACTIONS(6547),
    [anon_sym_PLUS] = ACTIONS(6547),
    [anon_sym_SLASH] = ACTIONS(6547),
    [anon_sym_PERCENT] = ACTIONS(6547),
    [sym_comment] = ACTIONS(87),
  },
  [10045] = {
    [sym__heredoc_body_start] = ACTIONS(10596),
    [sym__binary_minus] = ACTIONS(10596),
    [sym__binary_star] = ACTIONS(10596),
    [anon_sym_LBRACE] = ACTIONS(10596),
    [anon_sym_RPAREN] = ACTIONS(10596),
    [anon_sym_DOT] = ACTIONS(10598),
    [anon_sym_COMMA] = ACTIONS(10596),
    [anon_sym_PIPE] = ACTIONS(10598),
    [anon_sym_STAR_STAR] = ACTIONS(10596),
    [anon_sym_AMP] = ACTIONS(10598),
    [anon_sym_EQ] = ACTIONS(10598),
    [anon_sym_LT] = ACTIONS(10598),
    [anon_sym_do] = ACTIONS(10596),
    [anon_sym_LBRACK] = ACTIONS(10596),
    [anon_sym_COLON_COLON2] = ACTIONS(10596),
    [anon_sym_AMP_DOT] = ACTIONS(10596),
    [anon_sym_QMARK] = ACTIONS(10596),
    [anon_sym_DOT_DOT] = ACTIONS(10598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10596),
    [anon_sym_and] = ACTIONS(10596),
    [anon_sym_or] = ACTIONS(10596),
    [anon_sym_PIPE_PIPE] = ACTIONS(10596),
    [anon_sym_AMP_AMP] = ACTIONS(10596),
    [anon_sym_LT_LT] = ACTIONS(10596),
    [anon_sym_GT_GT] = ACTIONS(10596),
    [anon_sym_EQ_EQ] = ACTIONS(10598),
    [anon_sym_BANG_EQ] = ACTIONS(10596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10596),
    [anon_sym_LT_EQ_GT] = ACTIONS(10596),
    [anon_sym_EQ_TILDE] = ACTIONS(10596),
    [anon_sym_BANG_TILDE] = ACTIONS(10596),
    [anon_sym_LT_EQ] = ACTIONS(10598),
    [anon_sym_GT] = ACTIONS(10598),
    [anon_sym_GT_EQ] = ACTIONS(10596),
    [anon_sym_CARET] = ACTIONS(10596),
    [anon_sym_PLUS] = ACTIONS(10596),
    [anon_sym_SLASH] = ACTIONS(10596),
    [anon_sym_PERCENT] = ACTIONS(10596),
    [sym_comment] = ACTIONS(87),
  },
  [10046] = {
    [sym__heredoc_body_start] = ACTIONS(10689),
    [sym__binary_minus] = ACTIONS(10689),
    [sym__binary_star] = ACTIONS(10689),
    [anon_sym_LBRACE] = ACTIONS(10689),
    [anon_sym_RPAREN] = ACTIONS(10689),
    [anon_sym_DOT] = ACTIONS(10691),
    [anon_sym_COMMA] = ACTIONS(10689),
    [anon_sym_PIPE] = ACTIONS(10691),
    [anon_sym_STAR_STAR] = ACTIONS(10689),
    [anon_sym_AMP] = ACTIONS(10691),
    [anon_sym_EQ] = ACTIONS(10691),
    [anon_sym_LT] = ACTIONS(10691),
    [anon_sym_do] = ACTIONS(10689),
    [anon_sym_LBRACK] = ACTIONS(10689),
    [anon_sym_COLON_COLON2] = ACTIONS(10689),
    [anon_sym_AMP_DOT] = ACTIONS(10689),
    [anon_sym_QMARK] = ACTIONS(10689),
    [anon_sym_DOT_DOT] = ACTIONS(10691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10689),
    [anon_sym_and] = ACTIONS(10689),
    [anon_sym_or] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE] = ACTIONS(10689),
    [anon_sym_AMP_AMP] = ACTIONS(10689),
    [anon_sym_LT_LT] = ACTIONS(10689),
    [anon_sym_GT_GT] = ACTIONS(10689),
    [anon_sym_EQ_EQ] = ACTIONS(10691),
    [anon_sym_BANG_EQ] = ACTIONS(10689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10689),
    [anon_sym_LT_EQ_GT] = ACTIONS(10689),
    [anon_sym_EQ_TILDE] = ACTIONS(10689),
    [anon_sym_BANG_TILDE] = ACTIONS(10689),
    [anon_sym_LT_EQ] = ACTIONS(10691),
    [anon_sym_GT] = ACTIONS(10691),
    [anon_sym_GT_EQ] = ACTIONS(10689),
    [anon_sym_CARET] = ACTIONS(10689),
    [anon_sym_PLUS] = ACTIONS(10689),
    [anon_sym_SLASH] = ACTIONS(10689),
    [anon_sym_PERCENT] = ACTIONS(10689),
    [sym_comment] = ACTIONS(87),
  },
  [10047] = {
    [anon_sym_end] = ACTIONS(14302),
    [sym_comment] = ACTIONS(87),
  },
  [10048] = {
    [sym_elsif] = STATE(10644),
    [sym_else] = STATE(10644),
    [sym__if_tail] = STATE(10644),
    [anon_sym_end] = ACTIONS(14302),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [10049] = {
    [sym__heredoc_body_start] = ACTIONS(10856),
    [sym__binary_minus] = ACTIONS(10856),
    [sym__binary_star] = ACTIONS(10856),
    [anon_sym_LBRACE] = ACTIONS(10856),
    [anon_sym_RPAREN] = ACTIONS(10856),
    [anon_sym_DOT] = ACTIONS(10858),
    [anon_sym_COMMA] = ACTIONS(10856),
    [anon_sym_PIPE] = ACTIONS(10858),
    [anon_sym_STAR_STAR] = ACTIONS(10856),
    [anon_sym_AMP] = ACTIONS(10858),
    [anon_sym_EQ] = ACTIONS(10858),
    [anon_sym_LT] = ACTIONS(10858),
    [anon_sym_do] = ACTIONS(10856),
    [anon_sym_LBRACK] = ACTIONS(10856),
    [anon_sym_COLON_COLON2] = ACTIONS(10856),
    [anon_sym_AMP_DOT] = ACTIONS(10856),
    [anon_sym_QMARK] = ACTIONS(10856),
    [anon_sym_DOT_DOT] = ACTIONS(10858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10856),
    [anon_sym_and] = ACTIONS(10856),
    [anon_sym_or] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE] = ACTIONS(10856),
    [anon_sym_AMP_AMP] = ACTIONS(10856),
    [anon_sym_LT_LT] = ACTIONS(10856),
    [anon_sym_GT_GT] = ACTIONS(10856),
    [anon_sym_EQ_EQ] = ACTIONS(10858),
    [anon_sym_BANG_EQ] = ACTIONS(10856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10856),
    [anon_sym_LT_EQ_GT] = ACTIONS(10856),
    [anon_sym_EQ_TILDE] = ACTIONS(10856),
    [anon_sym_BANG_TILDE] = ACTIONS(10856),
    [anon_sym_LT_EQ] = ACTIONS(10858),
    [anon_sym_GT] = ACTIONS(10858),
    [anon_sym_GT_EQ] = ACTIONS(10856),
    [anon_sym_CARET] = ACTIONS(10856),
    [anon_sym_PLUS] = ACTIONS(10856),
    [anon_sym_SLASH] = ACTIONS(10856),
    [anon_sym_PERCENT] = ACTIONS(10856),
    [sym_comment] = ACTIONS(87),
  },
  [10050] = {
    [anon_sym_end] = ACTIONS(14304),
    [sym_comment] = ACTIONS(87),
  },
  [10051] = {
    [sym__heredoc_body_start] = ACTIONS(10951),
    [sym__binary_minus] = ACTIONS(10951),
    [sym__binary_star] = ACTIONS(10951),
    [anon_sym_LBRACE] = ACTIONS(10951),
    [anon_sym_RPAREN] = ACTIONS(10951),
    [anon_sym_DOT] = ACTIONS(10953),
    [anon_sym_COMMA] = ACTIONS(10951),
    [anon_sym_PIPE] = ACTIONS(10953),
    [anon_sym_STAR_STAR] = ACTIONS(10951),
    [anon_sym_AMP] = ACTIONS(10953),
    [anon_sym_EQ] = ACTIONS(10953),
    [anon_sym_LT] = ACTIONS(10953),
    [anon_sym_do] = ACTIONS(10951),
    [anon_sym_LBRACK] = ACTIONS(10951),
    [anon_sym_COLON_COLON2] = ACTIONS(10951),
    [anon_sym_AMP_DOT] = ACTIONS(10951),
    [anon_sym_QMARK] = ACTIONS(10951),
    [anon_sym_DOT_DOT] = ACTIONS(10953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10951),
    [anon_sym_and] = ACTIONS(10951),
    [anon_sym_or] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE] = ACTIONS(10951),
    [anon_sym_AMP_AMP] = ACTIONS(10951),
    [anon_sym_LT_LT] = ACTIONS(10951),
    [anon_sym_GT_GT] = ACTIONS(10951),
    [anon_sym_EQ_EQ] = ACTIONS(10953),
    [anon_sym_BANG_EQ] = ACTIONS(10951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10951),
    [anon_sym_LT_EQ_GT] = ACTIONS(10951),
    [anon_sym_EQ_TILDE] = ACTIONS(10951),
    [anon_sym_BANG_TILDE] = ACTIONS(10951),
    [anon_sym_LT_EQ] = ACTIONS(10953),
    [anon_sym_GT] = ACTIONS(10953),
    [anon_sym_GT_EQ] = ACTIONS(10951),
    [anon_sym_CARET] = ACTIONS(10951),
    [anon_sym_PLUS] = ACTIONS(10951),
    [anon_sym_SLASH] = ACTIONS(10951),
    [anon_sym_PERCENT] = ACTIONS(10951),
    [sym_comment] = ACTIONS(87),
  },
  [10052] = {
    [sym__heredoc_body_start] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10960),
    [anon_sym_LBRACE] = ACTIONS(10960),
    [anon_sym_RPAREN] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10960),
    [anon_sym_AMP] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10962),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10960),
    [anon_sym_COLON_COLON2] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_DOT_DOT] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10960),
    [anon_sym_AMP_AMP] = ACTIONS(10960),
    [anon_sym_LT_LT] = ACTIONS(10960),
    [anon_sym_GT_GT] = ACTIONS(10960),
    [anon_sym_EQ_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10962),
    [anon_sym_GT] = ACTIONS(10962),
    [anon_sym_GT_EQ] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10960),
    [anon_sym_PLUS] = ACTIONS(10960),
    [anon_sym_SLASH] = ACTIONS(10960),
    [anon_sym_PERCENT] = ACTIONS(10960),
    [sym_comment] = ACTIONS(87),
  },
  [10053] = {
    [sym__heredoc_body_start] = ACTIONS(11007),
    [sym__binary_minus] = ACTIONS(11007),
    [sym__binary_star] = ACTIONS(11007),
    [anon_sym_LBRACE] = ACTIONS(11007),
    [anon_sym_RPAREN] = ACTIONS(11007),
    [anon_sym_DOT] = ACTIONS(11009),
    [anon_sym_COMMA] = ACTIONS(11007),
    [anon_sym_PIPE] = ACTIONS(11009),
    [anon_sym_STAR_STAR] = ACTIONS(11007),
    [anon_sym_AMP] = ACTIONS(11009),
    [anon_sym_EQ] = ACTIONS(11009),
    [anon_sym_LT] = ACTIONS(11009),
    [anon_sym_do] = ACTIONS(11007),
    [anon_sym_LBRACK] = ACTIONS(11007),
    [anon_sym_COLON_COLON2] = ACTIONS(11007),
    [anon_sym_AMP_DOT] = ACTIONS(11007),
    [anon_sym_QMARK] = ACTIONS(11007),
    [anon_sym_DOT_DOT] = ACTIONS(11009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11007),
    [anon_sym_and] = ACTIONS(11007),
    [anon_sym_or] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE] = ACTIONS(11007),
    [anon_sym_AMP_AMP] = ACTIONS(11007),
    [anon_sym_LT_LT] = ACTIONS(11007),
    [anon_sym_GT_GT] = ACTIONS(11007),
    [anon_sym_EQ_EQ] = ACTIONS(11009),
    [anon_sym_BANG_EQ] = ACTIONS(11007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11007),
    [anon_sym_LT_EQ_GT] = ACTIONS(11007),
    [anon_sym_EQ_TILDE] = ACTIONS(11007),
    [anon_sym_BANG_TILDE] = ACTIONS(11007),
    [anon_sym_LT_EQ] = ACTIONS(11009),
    [anon_sym_GT] = ACTIONS(11009),
    [anon_sym_GT_EQ] = ACTIONS(11007),
    [anon_sym_CARET] = ACTIONS(11007),
    [anon_sym_PLUS] = ACTIONS(11007),
    [anon_sym_SLASH] = ACTIONS(11007),
    [anon_sym_PERCENT] = ACTIONS(11007),
    [sym_comment] = ACTIONS(87),
  },
  [10054] = {
    [anon_sym_end] = ACTIONS(14306),
    [sym_comment] = ACTIONS(87),
  },
  [10055] = {
    [sym__heredoc_body_start] = ACTIONS(11020),
    [sym__binary_minus] = ACTIONS(11020),
    [sym__binary_star] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_RPAREN] = ACTIONS(11020),
    [anon_sym_DOT] = ACTIONS(11022),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_PIPE] = ACTIONS(11022),
    [anon_sym_STAR_STAR] = ACTIONS(11020),
    [anon_sym_AMP] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(11022),
    [anon_sym_LT] = ACTIONS(11022),
    [anon_sym_do] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_COLON_COLON2] = ACTIONS(11020),
    [anon_sym_AMP_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_DOT_DOT] = ACTIONS(11022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_and] = ACTIONS(11020),
    [anon_sym_or] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE] = ACTIONS(11020),
    [anon_sym_AMP_AMP] = ACTIONS(11020),
    [anon_sym_LT_LT] = ACTIONS(11020),
    [anon_sym_GT_GT] = ACTIONS(11020),
    [anon_sym_EQ_EQ] = ACTIONS(11022),
    [anon_sym_BANG_EQ] = ACTIONS(11020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11020),
    [anon_sym_LT_EQ_GT] = ACTIONS(11020),
    [anon_sym_EQ_TILDE] = ACTIONS(11020),
    [anon_sym_BANG_TILDE] = ACTIONS(11020),
    [anon_sym_LT_EQ] = ACTIONS(11022),
    [anon_sym_GT] = ACTIONS(11022),
    [anon_sym_GT_EQ] = ACTIONS(11020),
    [anon_sym_CARET] = ACTIONS(11020),
    [anon_sym_PLUS] = ACTIONS(11020),
    [anon_sym_SLASH] = ACTIONS(11020),
    [anon_sym_PERCENT] = ACTIONS(11020),
    [sym_comment] = ACTIONS(87),
  },
  [10056] = {
    [anon_sym_end] = ACTIONS(14308),
    [sym_comment] = ACTIONS(87),
  },
  [10057] = {
    [sym__heredoc_body_start] = ACTIONS(11466),
    [sym__binary_minus] = ACTIONS(11466),
    [sym__binary_star] = ACTIONS(11466),
    [anon_sym_LBRACE] = ACTIONS(11466),
    [anon_sym_RPAREN] = ACTIONS(11466),
    [anon_sym_DOT] = ACTIONS(11468),
    [anon_sym_COMMA] = ACTIONS(11466),
    [anon_sym_PIPE] = ACTIONS(11468),
    [anon_sym_STAR_STAR] = ACTIONS(11466),
    [anon_sym_AMP] = ACTIONS(11468),
    [anon_sym_EQ] = ACTIONS(11468),
    [anon_sym_LT] = ACTIONS(11468),
    [anon_sym_do] = ACTIONS(11466),
    [anon_sym_LBRACK] = ACTIONS(11466),
    [anon_sym_COLON_COLON2] = ACTIONS(11466),
    [anon_sym_AMP_DOT] = ACTIONS(11466),
    [anon_sym_QMARK] = ACTIONS(11466),
    [anon_sym_DOT_DOT] = ACTIONS(11468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11466),
    [anon_sym_and] = ACTIONS(11466),
    [anon_sym_or] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE] = ACTIONS(11466),
    [anon_sym_AMP_AMP] = ACTIONS(11466),
    [anon_sym_LT_LT] = ACTIONS(11466),
    [anon_sym_GT_GT] = ACTIONS(11466),
    [anon_sym_EQ_EQ] = ACTIONS(11468),
    [anon_sym_BANG_EQ] = ACTIONS(11466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11466),
    [anon_sym_LT_EQ_GT] = ACTIONS(11466),
    [anon_sym_EQ_TILDE] = ACTIONS(11466),
    [anon_sym_BANG_TILDE] = ACTIONS(11466),
    [anon_sym_LT_EQ] = ACTIONS(11468),
    [anon_sym_GT] = ACTIONS(11468),
    [anon_sym_GT_EQ] = ACTIONS(11466),
    [anon_sym_CARET] = ACTIONS(11466),
    [anon_sym_PLUS] = ACTIONS(11466),
    [anon_sym_SLASH] = ACTIONS(11466),
    [anon_sym_PERCENT] = ACTIONS(11466),
    [sym_comment] = ACTIONS(87),
  },
  [10058] = {
    [anon_sym_end] = ACTIONS(14310),
    [sym_comment] = ACTIONS(87),
  },
  [10059] = {
    [sym__heredoc_body_start] = ACTIONS(11655),
    [sym__binary_minus] = ACTIONS(11655),
    [sym__binary_star] = ACTIONS(11655),
    [anon_sym_LBRACE] = ACTIONS(11655),
    [anon_sym_RPAREN] = ACTIONS(11655),
    [anon_sym_DOT] = ACTIONS(11657),
    [anon_sym_COMMA] = ACTIONS(11655),
    [anon_sym_PIPE] = ACTIONS(11657),
    [anon_sym_STAR_STAR] = ACTIONS(11655),
    [anon_sym_AMP] = ACTIONS(11657),
    [anon_sym_EQ] = ACTIONS(11657),
    [anon_sym_LT] = ACTIONS(11657),
    [anon_sym_do] = ACTIONS(11655),
    [anon_sym_LBRACK] = ACTIONS(11655),
    [anon_sym_COLON_COLON2] = ACTIONS(11655),
    [anon_sym_AMP_DOT] = ACTIONS(11655),
    [anon_sym_QMARK] = ACTIONS(11655),
    [anon_sym_DOT_DOT] = ACTIONS(11657),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11655),
    [anon_sym_and] = ACTIONS(11655),
    [anon_sym_or] = ACTIONS(11655),
    [anon_sym_PIPE_PIPE] = ACTIONS(11655),
    [anon_sym_AMP_AMP] = ACTIONS(11655),
    [anon_sym_LT_LT] = ACTIONS(11655),
    [anon_sym_GT_GT] = ACTIONS(11655),
    [anon_sym_EQ_EQ] = ACTIONS(11657),
    [anon_sym_BANG_EQ] = ACTIONS(11655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11655),
    [anon_sym_LT_EQ_GT] = ACTIONS(11655),
    [anon_sym_EQ_TILDE] = ACTIONS(11655),
    [anon_sym_BANG_TILDE] = ACTIONS(11655),
    [anon_sym_LT_EQ] = ACTIONS(11657),
    [anon_sym_GT] = ACTIONS(11657),
    [anon_sym_GT_EQ] = ACTIONS(11655),
    [anon_sym_CARET] = ACTIONS(11655),
    [anon_sym_PLUS] = ACTIONS(11655),
    [anon_sym_SLASH] = ACTIONS(11655),
    [anon_sym_PERCENT] = ACTIONS(11655),
    [sym_comment] = ACTIONS(87),
  },
  [10060] = {
    [sym__heredoc_body_start] = ACTIONS(11680),
    [sym__binary_minus] = ACTIONS(11680),
    [sym__binary_star] = ACTIONS(11680),
    [anon_sym_LBRACE] = ACTIONS(11680),
    [anon_sym_RPAREN] = ACTIONS(11680),
    [anon_sym_DOT] = ACTIONS(11682),
    [anon_sym_COMMA] = ACTIONS(11680),
    [anon_sym_PIPE] = ACTIONS(11682),
    [anon_sym_STAR_STAR] = ACTIONS(11680),
    [anon_sym_AMP] = ACTIONS(11682),
    [anon_sym_EQ] = ACTIONS(11682),
    [anon_sym_LT] = ACTIONS(11682),
    [anon_sym_do] = ACTIONS(11680),
    [anon_sym_LBRACK] = ACTIONS(11680),
    [anon_sym_COLON_COLON2] = ACTIONS(11680),
    [anon_sym_AMP_DOT] = ACTIONS(11680),
    [anon_sym_QMARK] = ACTIONS(11680),
    [anon_sym_DOT_DOT] = ACTIONS(11682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11680),
    [anon_sym_and] = ACTIONS(11680),
    [anon_sym_or] = ACTIONS(11680),
    [anon_sym_PIPE_PIPE] = ACTIONS(11680),
    [anon_sym_AMP_AMP] = ACTIONS(11680),
    [anon_sym_LT_LT] = ACTIONS(11680),
    [anon_sym_GT_GT] = ACTIONS(11680),
    [anon_sym_EQ_EQ] = ACTIONS(11682),
    [anon_sym_BANG_EQ] = ACTIONS(11680),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11680),
    [anon_sym_LT_EQ_GT] = ACTIONS(11680),
    [anon_sym_EQ_TILDE] = ACTIONS(11680),
    [anon_sym_BANG_TILDE] = ACTIONS(11680),
    [anon_sym_LT_EQ] = ACTIONS(11682),
    [anon_sym_GT] = ACTIONS(11682),
    [anon_sym_GT_EQ] = ACTIONS(11680),
    [anon_sym_CARET] = ACTIONS(11680),
    [anon_sym_PLUS] = ACTIONS(11680),
    [anon_sym_SLASH] = ACTIONS(11680),
    [anon_sym_PERCENT] = ACTIONS(11680),
    [sym_comment] = ACTIONS(87),
  },
  [10061] = {
    [anon_sym_end] = ACTIONS(14312),
    [sym_comment] = ACTIONS(87),
  },
  [10062] = {
    [sym__statements] = STATE(10650),
    [sym__top_level_statement] = STATE(1198),
    [sym_begin_block] = STATE(1198),
    [sym_end_block] = STATE(1198),
    [sym__statement] = STATE(1199),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(1199),
    [sym_unless_modifier] = STATE(1199),
    [sym_while_modifier] = STATE(1199),
    [sym_until_modifier] = STATE(1199),
    [sym_rescue_modifier] = STATE(1199),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(1200),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(1203),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(1203),
    [sym_assignment] = STATE(1200),
    [sym_operator_assignment] = STATE(1200),
    [sym_conditional] = STATE(1200),
    [sym_range] = STATE(1200),
    [sym_binary] = STATE(1200),
    [sym_unary] = STATE(1200),
    [sym_left_assignment_list] = STATE(1202),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1203),
    [sym__variable] = STATE(1201),
    [sym_undef] = STATE(1199),
    [sym_alias] = STATE(1199),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(1203),
    [sym_false] = STATE(1203),
    [sym_nil] = STATE(1203),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(1204),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(1199),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(2139),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14314),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2147),
    [anon_sym_next] = ACTIONS(2149),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_defined_QMARK] = ACTIONS(2153),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [anon_sym_undef] = ACTIONS(2163),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10063] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7443),
    [sym__binary_star] = ACTIONS(7445),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7447),
    [anon_sym_STAR_STAR] = ACTIONS(7445),
    [anon_sym_AMP] = ACTIONS(7449),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(7451),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7453),
    [anon_sym_DOT_DOT] = ACTIONS(7455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7457),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7461),
    [anon_sym_AMP_AMP] = ACTIONS(7461),
    [anon_sym_LT_LT] = ACTIONS(7463),
    [anon_sym_GT_GT] = ACTIONS(7463),
    [anon_sym_EQ_EQ] = ACTIONS(7465),
    [anon_sym_BANG_EQ] = ACTIONS(7461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7461),
    [anon_sym_LT_EQ_GT] = ACTIONS(7461),
    [anon_sym_EQ_TILDE] = ACTIONS(7461),
    [anon_sym_BANG_TILDE] = ACTIONS(7461),
    [anon_sym_LT_EQ] = ACTIONS(7451),
    [anon_sym_GT] = ACTIONS(7451),
    [anon_sym_GT_EQ] = ACTIONS(7467),
    [anon_sym_CARET] = ACTIONS(7469),
    [anon_sym_PLUS] = ACTIONS(7443),
    [anon_sym_SLASH] = ACTIONS(7445),
    [anon_sym_PERCENT] = ACTIONS(7445),
    [sym_comment] = ACTIONS(87),
  },
  [10064] = {
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10065] = {
    [aux_sym_exceptions_repeat1] = STATE(10065),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14316),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10066] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7508),
    [sym__binary_star] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7512),
    [anon_sym_STAR_STAR] = ACTIONS(7510),
    [anon_sym_AMP] = ACTIONS(7514),
    [anon_sym_LT] = ACTIONS(7516),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7518),
    [anon_sym_DOT_DOT] = ACTIONS(7520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7522),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7526),
    [anon_sym_AMP_AMP] = ACTIONS(7526),
    [anon_sym_LT_LT] = ACTIONS(7528),
    [anon_sym_GT_GT] = ACTIONS(7528),
    [anon_sym_EQ_EQ] = ACTIONS(7530),
    [anon_sym_BANG_EQ] = ACTIONS(7526),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7526),
    [anon_sym_LT_EQ_GT] = ACTIONS(7526),
    [anon_sym_EQ_TILDE] = ACTIONS(7526),
    [anon_sym_BANG_TILDE] = ACTIONS(7526),
    [anon_sym_LT_EQ] = ACTIONS(7516),
    [anon_sym_GT] = ACTIONS(7516),
    [anon_sym_GT_EQ] = ACTIONS(7532),
    [anon_sym_CARET] = ACTIONS(7534),
    [anon_sym_PLUS] = ACTIONS(7508),
    [anon_sym_SLASH] = ACTIONS(7510),
    [anon_sym_PERCENT] = ACTIONS(7510),
    [sym_comment] = ACTIONS(87),
  },
  [10067] = {
    [aux_sym_exceptions_repeat1] = STATE(10067),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14319),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10068] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7558),
    [sym__binary_star] = ACTIONS(7560),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7562),
    [anon_sym_STAR_STAR] = ACTIONS(7560),
    [anon_sym_AMP] = ACTIONS(7564),
    [anon_sym_LT] = ACTIONS(7566),
    [anon_sym_QMARK] = ACTIONS(7568),
    [anon_sym_DOT_DOT] = ACTIONS(7570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7572),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7576),
    [anon_sym_AMP_AMP] = ACTIONS(7576),
    [anon_sym_LT_LT] = ACTIONS(7578),
    [anon_sym_GT_GT] = ACTIONS(7578),
    [anon_sym_EQ_EQ] = ACTIONS(7580),
    [anon_sym_BANG_EQ] = ACTIONS(7576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7576),
    [anon_sym_LT_EQ_GT] = ACTIONS(7576),
    [anon_sym_EQ_TILDE] = ACTIONS(7576),
    [anon_sym_BANG_TILDE] = ACTIONS(7576),
    [anon_sym_LT_EQ] = ACTIONS(7566),
    [anon_sym_GT] = ACTIONS(7566),
    [anon_sym_GT_EQ] = ACTIONS(7582),
    [anon_sym_CARET] = ACTIONS(7584),
    [anon_sym_PLUS] = ACTIONS(7558),
    [anon_sym_SLASH] = ACTIONS(7560),
    [anon_sym_PERCENT] = ACTIONS(7560),
    [sym_comment] = ACTIONS(87),
  },
  [10069] = {
    [aux_sym_exceptions_repeat1] = STATE(10069),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(14322),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10070] = {
    [sym__line_break] = ACTIONS(14146),
    [sym__heredoc_body_start] = ACTIONS(14146),
    [sym__binary_minus] = ACTIONS(14146),
    [sym__binary_star] = ACTIONS(14146),
    [ts_builtin_sym_end] = ACTIONS(14146),
    [anon_sym___END__] = ACTIONS(14146),
    [anon_sym_LBRACE] = ACTIONS(14146),
    [anon_sym_RBRACE] = ACTIONS(14146),
    [anon_sym_RPAREN] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14148),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14148),
    [anon_sym_SEMI] = ACTIONS(14146),
    [anon_sym_STAR_STAR] = ACTIONS(14148),
    [anon_sym_AMP] = ACTIONS(14148),
    [anon_sym_EQ] = ACTIONS(14148),
    [anon_sym_LT] = ACTIONS(14148),
    [anon_sym_end] = ACTIONS(14146),
    [anon_sym_if] = ACTIONS(14146),
    [anon_sym_unless] = ACTIONS(14146),
    [anon_sym_while] = ACTIONS(14146),
    [anon_sym_until] = ACTIONS(14146),
    [anon_sym_rescue] = ACTIONS(14146),
    [anon_sym_do] = ACTIONS(14146),
    [anon_sym_when] = ACTIONS(14146),
    [anon_sym_elsif] = ACTIONS(14146),
    [anon_sym_else] = ACTIONS(14146),
    [anon_sym_then] = ACTIONS(14146),
    [anon_sym_ensure] = ACTIONS(14146),
    [anon_sym_EQ_GT] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [anon_sym_PLUS_EQ] = ACTIONS(14146),
    [anon_sym_DASH_EQ] = ACTIONS(14146),
    [anon_sym_STAR_EQ] = ACTIONS(14146),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14146),
    [anon_sym_SLASH_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14146),
    [anon_sym_AMP_EQ] = ACTIONS(14146),
    [anon_sym_PERCENT_EQ] = ACTIONS(14146),
    [anon_sym_GT_GT_EQ] = ACTIONS(14146),
    [anon_sym_LT_LT_EQ] = ACTIONS(14146),
    [anon_sym_CARET_EQ] = ACTIONS(14146),
    [anon_sym_QMARK] = ACTIONS(14146),
    [anon_sym_DOT_DOT] = ACTIONS(14148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14146),
    [anon_sym_and] = ACTIONS(14146),
    [anon_sym_or] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE] = ACTIONS(14148),
    [anon_sym_AMP_AMP] = ACTIONS(14148),
    [anon_sym_LT_LT] = ACTIONS(14148),
    [anon_sym_GT_GT] = ACTIONS(14148),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_BANG_EQ] = ACTIONS(14146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14146),
    [anon_sym_LT_EQ_GT] = ACTIONS(14146),
    [anon_sym_EQ_TILDE] = ACTIONS(14146),
    [anon_sym_BANG_TILDE] = ACTIONS(14146),
    [anon_sym_LT_EQ] = ACTIONS(14148),
    [anon_sym_GT] = ACTIONS(14148),
    [anon_sym_GT_EQ] = ACTIONS(14146),
    [anon_sym_CARET] = ACTIONS(14148),
    [anon_sym_PLUS] = ACTIONS(14148),
    [anon_sym_SLASH] = ACTIONS(14148),
    [anon_sym_PERCENT] = ACTIONS(14148),
    [sym_comment] = ACTIONS(87),
  },
  [10071] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7672),
    [sym__binary_star] = ACTIONS(7674),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7676),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(7674),
    [anon_sym_AMP] = ACTIONS(7678),
    [anon_sym_LT] = ACTIONS(7680),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7682),
    [anon_sym_DOT_DOT] = ACTIONS(7684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7686),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7688),
    [anon_sym_AMP_AMP] = ACTIONS(7688),
    [anon_sym_LT_LT] = ACTIONS(7690),
    [anon_sym_GT_GT] = ACTIONS(7690),
    [anon_sym_EQ_EQ] = ACTIONS(7692),
    [anon_sym_BANG_EQ] = ACTIONS(7688),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7688),
    [anon_sym_LT_EQ_GT] = ACTIONS(7688),
    [anon_sym_EQ_TILDE] = ACTIONS(7688),
    [anon_sym_BANG_TILDE] = ACTIONS(7688),
    [anon_sym_LT_EQ] = ACTIONS(7680),
    [anon_sym_GT] = ACTIONS(7680),
    [anon_sym_GT_EQ] = ACTIONS(7694),
    [anon_sym_CARET] = ACTIONS(7696),
    [anon_sym_PLUS] = ACTIONS(7672),
    [anon_sym_SLASH] = ACTIONS(7674),
    [anon_sym_PERCENT] = ACTIONS(7674),
    [sym_comment] = ACTIONS(87),
  },
  [10072] = {
    [aux_sym_exceptions_repeat1] = STATE(10072),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14325),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10073] = {
    [sym_heredoc_body] = STATE(10651),
    [aux_sym_call_repeat1] = STATE(10651),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_elsif] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10074] = {
    [sym_heredoc_body] = STATE(10652),
    [aux_sym_call_repeat1] = STATE(10652),
    [aux_sym_argument_list_repeat1] = STATE(9109),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10677),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_elsif] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10075] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10076] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10077] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10078] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10079] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10080] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14328),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10081] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_elsif] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10082] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12440),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10083] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10084] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10085] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_elsif] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(12440),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10086] = {
    [aux_sym_exceptions_repeat1] = STATE(10655),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_elsif] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10087] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_elsif] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12440),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10088] = {
    [sym_string] = STATE(10088),
    [aux_sym_chained_string_repeat1] = STATE(10088),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_elsif] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [10089] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_elsif] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [10090] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_elsif] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [10091] = {
    [sym_heredoc_body] = STATE(10091),
    [aux_sym_call_repeat1] = STATE(10091),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_elsif] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10092] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7350),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(7350),
    [sym_operator_assignment] = STATE(7350),
    [sym_conditional] = STATE(7350),
    [sym_range] = STATE(7350),
    [sym_binary] = STATE(7350),
    [sym_unary] = STATE(7350),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7353),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10633),
    [sym__splat_star] = ACTIONS(10635),
    [sym__unary_minus] = ACTIONS(7732),
    [sym__identifier_hash_key] = ACTIONS(10637),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13644),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(10639),
    [sym_identifier] = ACTIONS(10639),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10093] = {
    [sym_heredoc_body] = STATE(10091),
    [aux_sym_call_repeat1] = STATE(10091),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_elsif] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10094] = {
    [aux_sym_argument_list_repeat1] = STATE(10094),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14330),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_elsif] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [10095] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10656),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_assignment] = STATE(10656),
    [sym_operator_assignment] = STATE(10656),
    [sym_conditional] = STATE(10656),
    [sym_range] = STATE(10656),
    [sym_binary] = STATE(10656),
    [sym_unary] = STATE(10656),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10096] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_elsif] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [10097] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_elsif] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [10098] = {
    [sym_heredoc_body] = STATE(10098),
    [aux_sym_call_repeat1] = STATE(10098),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_elsif] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [10099] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7371),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(7371),
    [sym_operator_assignment] = STATE(7371),
    [sym_conditional] = STATE(7371),
    [sym_range] = STATE(7371),
    [sym_binary] = STATE(7371),
    [sym_unary] = STATE(7371),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7374),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10669),
    [sym__splat_star] = ACTIONS(10671),
    [sym__unary_minus] = ACTIONS(7812),
    [sym__identifier_hash_key] = ACTIONS(10673),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13648),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(10675),
    [sym_identifier] = ACTIONS(10675),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10100] = {
    [sym_heredoc_body] = STATE(10098),
    [aux_sym_call_repeat1] = STATE(10098),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_elsif] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [10101] = {
    [aux_sym_argument_list_repeat1] = STATE(10101),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14333),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_elsif] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [10102] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9110),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5000),
    [sym_scope_resolution] = STATE(4996),
    [sym_call] = STATE(4996),
    [sym_method_call] = STATE(5000),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(9110),
    [sym_operator_assignment] = STATE(9110),
    [sym_conditional] = STATE(9110),
    [sym_range] = STATE(9110),
    [sym_binary] = STATE(9110),
    [sym_unary] = STATE(9110),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(4999),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5000),
    [sym__variable] = STATE(4996),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5000),
    [sym_false] = STATE(5000),
    [sym_nil] = STATE(5000),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7342),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(10635),
    [sym__unary_minus] = ACTIONS(7732),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7736),
    [anon_sym_yield] = ACTIONS(7738),
    [anon_sym_break] = ACTIONS(7740),
    [anon_sym_next] = ACTIONS(7742),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(7744),
    [anon_sym_not] = ACTIONS(7746),
    [anon_sym_BANG] = ACTIONS(7750),
    [anon_sym_TILDE] = ACTIONS(7750),
    [sym_constant] = ACTIONS(7756),
    [sym_identifier] = ACTIONS(7756),
    [sym_instance_variable] = ACTIONS(7754),
    [sym_class_variable] = ACTIONS(7754),
    [sym_global_variable] = ACTIONS(7754),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7756),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7756),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10103] = {
    [aux_sym_exceptions_repeat1] = STATE(10657),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14336),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_elsif] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10104] = {
    [anon_sym_end] = ACTIONS(14338),
    [sym_comment] = ACTIONS(87),
  },
  [10105] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7780),
    [sym__binary_star] = ACTIONS(7782),
    [anon_sym_PIPE] = ACTIONS(7784),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(7782),
    [anon_sym_AMP] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(7788),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_elsif] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7792),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7794),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7798),
    [anon_sym_AMP_AMP] = ACTIONS(7798),
    [anon_sym_LT_LT] = ACTIONS(7800),
    [anon_sym_GT_GT] = ACTIONS(7800),
    [anon_sym_EQ_EQ] = ACTIONS(7802),
    [anon_sym_BANG_EQ] = ACTIONS(7798),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7798),
    [anon_sym_LT_EQ_GT] = ACTIONS(7798),
    [anon_sym_EQ_TILDE] = ACTIONS(7798),
    [anon_sym_BANG_TILDE] = ACTIONS(7798),
    [anon_sym_LT_EQ] = ACTIONS(7788),
    [anon_sym_GT] = ACTIONS(7788),
    [anon_sym_GT_EQ] = ACTIONS(7804),
    [anon_sym_CARET] = ACTIONS(7806),
    [anon_sym_PLUS] = ACTIONS(7780),
    [anon_sym_SLASH] = ACTIONS(7782),
    [anon_sym_PERCENT] = ACTIONS(7782),
    [sym_comment] = ACTIONS(87),
  },
  [10106] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10107] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [10108] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10109] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10110] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10111] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14340),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10112] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_elsif] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10113] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10114] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10115] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10116] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_elsif] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10117] = {
    [aux_sym_exceptions_repeat1] = STATE(10660),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_elsif] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [10118] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_elsif] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10119] = {
    [sym_string] = STATE(10119),
    [aux_sym_chained_string_repeat1] = STATE(10119),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_elsif] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [10120] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10661),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_assignment] = STATE(10661),
    [sym_operator_assignment] = STATE(10661),
    [sym_conditional] = STATE(10661),
    [sym_range] = STATE(10661),
    [sym_binary] = STATE(10661),
    [sym_unary] = STATE(10661),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10121] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9150),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5042),
    [sym_scope_resolution] = STATE(5038),
    [sym_call] = STATE(5038),
    [sym_method_call] = STATE(5042),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(9150),
    [sym_operator_assignment] = STATE(9150),
    [sym_conditional] = STATE(9150),
    [sym_range] = STATE(9150),
    [sym_binary] = STATE(9150),
    [sym_unary] = STATE(9150),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(5041),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5042),
    [sym__variable] = STATE(5038),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5042),
    [sym_false] = STATE(5042),
    [sym_nil] = STATE(5042),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7415),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(10671),
    [sym__unary_minus] = ACTIONS(7812),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(7816),
    [anon_sym_yield] = ACTIONS(7818),
    [anon_sym_break] = ACTIONS(7820),
    [anon_sym_next] = ACTIONS(7822),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10719),
    [anon_sym_defined_QMARK] = ACTIONS(7824),
    [anon_sym_not] = ACTIONS(7826),
    [anon_sym_BANG] = ACTIONS(7830),
    [anon_sym_TILDE] = ACTIONS(7830),
    [sym_constant] = ACTIONS(7836),
    [sym_identifier] = ACTIONS(7836),
    [sym_instance_variable] = ACTIONS(7834),
    [sym_class_variable] = ACTIONS(7834),
    [sym_global_variable] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(7836),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7836),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10122] = {
    [aux_sym_exceptions_repeat1] = STATE(10662),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14342),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_elsif] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10123] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [10124] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10125] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(12533),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [10126] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [10127] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12531),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(12533),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12551),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [10128] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14344),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10129] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(12531),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(12533),
    [anon_sym_LT] = ACTIONS(12535),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_elsif] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12541),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12543),
    [anon_sym_AMP_AMP] = ACTIONS(12543),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(12547),
    [anon_sym_BANG_EQ] = ACTIONS(12543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12543),
    [anon_sym_LT_EQ_GT] = ACTIONS(12543),
    [anon_sym_EQ_TILDE] = ACTIONS(12543),
    [anon_sym_BANG_TILDE] = ACTIONS(12543),
    [anon_sym_LT_EQ] = ACTIONS(12535),
    [anon_sym_GT] = ACTIONS(12535),
    [anon_sym_GT_EQ] = ACTIONS(12549),
    [anon_sym_CARET] = ACTIONS(12551),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [10130] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12531),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(12533),
    [anon_sym_LT] = ACTIONS(12535),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12537),
    [anon_sym_DOT_DOT] = ACTIONS(12539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12541),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12543),
    [anon_sym_AMP_AMP] = ACTIONS(12543),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(12547),
    [anon_sym_BANG_EQ] = ACTIONS(12543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12543),
    [anon_sym_LT_EQ_GT] = ACTIONS(12543),
    [anon_sym_EQ_TILDE] = ACTIONS(12543),
    [anon_sym_BANG_TILDE] = ACTIONS(12543),
    [anon_sym_LT_EQ] = ACTIONS(12535),
    [anon_sym_GT] = ACTIONS(12535),
    [anon_sym_GT_EQ] = ACTIONS(12549),
    [anon_sym_CARET] = ACTIONS(12551),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [10131] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12531),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(12533),
    [anon_sym_LT] = ACTIONS(12535),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(12547),
    [anon_sym_BANG_EQ] = ACTIONS(12543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12543),
    [anon_sym_LT_EQ_GT] = ACTIONS(12543),
    [anon_sym_EQ_TILDE] = ACTIONS(12543),
    [anon_sym_BANG_TILDE] = ACTIONS(12543),
    [anon_sym_LT_EQ] = ACTIONS(12535),
    [anon_sym_GT] = ACTIONS(12535),
    [anon_sym_GT_EQ] = ACTIONS(12549),
    [anon_sym_CARET] = ACTIONS(12551),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [10132] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_elsif] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [10133] = {
    [aux_sym_exceptions_repeat1] = STATE(10133),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(14346),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_elsif] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10134] = {
    [aux_sym_exceptions_repeat1] = STATE(9168),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_elsif] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10135] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(12531),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(12533),
    [anon_sym_LT] = ACTIONS(12535),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_elsif] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12537),
    [anon_sym_DOT_DOT] = ACTIONS(12539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12541),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12543),
    [anon_sym_AMP_AMP] = ACTIONS(12543),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(12547),
    [anon_sym_BANG_EQ] = ACTIONS(12543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12543),
    [anon_sym_LT_EQ_GT] = ACTIONS(12543),
    [anon_sym_EQ_TILDE] = ACTIONS(12543),
    [anon_sym_BANG_TILDE] = ACTIONS(12543),
    [anon_sym_LT_EQ] = ACTIONS(12535),
    [anon_sym_GT] = ACTIONS(12535),
    [anon_sym_GT_EQ] = ACTIONS(12549),
    [anon_sym_CARET] = ACTIONS(12551),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [10136] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7852),
    [sym__binary_star] = ACTIONS(7854),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7856),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(7858),
    [anon_sym_AMP] = ACTIONS(7860),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(7862),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7864),
    [anon_sym_DOT_DOT] = ACTIONS(7866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7868),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7870),
    [anon_sym_AMP_AMP] = ACTIONS(7870),
    [anon_sym_LT_LT] = ACTIONS(7872),
    [anon_sym_GT_GT] = ACTIONS(7872),
    [anon_sym_EQ_EQ] = ACTIONS(7870),
    [anon_sym_BANG_EQ] = ACTIONS(7874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7874),
    [anon_sym_LT_EQ_GT] = ACTIONS(7874),
    [anon_sym_EQ_TILDE] = ACTIONS(7874),
    [anon_sym_BANG_TILDE] = ACTIONS(7874),
    [anon_sym_LT_EQ] = ACTIONS(7862),
    [anon_sym_GT] = ACTIONS(7862),
    [anon_sym_GT_EQ] = ACTIONS(7876),
    [anon_sym_CARET] = ACTIONS(7856),
    [anon_sym_PLUS] = ACTIONS(7878),
    [anon_sym_SLASH] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(7858),
    [sym_comment] = ACTIONS(87),
  },
  [10137] = {
    [aux_sym_exceptions_repeat1] = STATE(10137),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14349),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10138] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7888),
    [sym__binary_star] = ACTIONS(7890),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(7892),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(7890),
    [anon_sym_AMP] = ACTIONS(7894),
    [anon_sym_LT] = ACTIONS(7896),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7898),
    [anon_sym_DOT_DOT] = ACTIONS(7900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7902),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7904),
    [anon_sym_AMP_AMP] = ACTIONS(7904),
    [anon_sym_LT_LT] = ACTIONS(7906),
    [anon_sym_GT_GT] = ACTIONS(7906),
    [anon_sym_EQ_EQ] = ACTIONS(7908),
    [anon_sym_BANG_EQ] = ACTIONS(7904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7904),
    [anon_sym_LT_EQ_GT] = ACTIONS(7904),
    [anon_sym_EQ_TILDE] = ACTIONS(7904),
    [anon_sym_BANG_TILDE] = ACTIONS(7904),
    [anon_sym_LT_EQ] = ACTIONS(7896),
    [anon_sym_GT] = ACTIONS(7896),
    [anon_sym_GT_EQ] = ACTIONS(7910),
    [anon_sym_CARET] = ACTIONS(7912),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7890),
    [anon_sym_PERCENT] = ACTIONS(7890),
    [sym_comment] = ACTIONS(87),
  },
  [10139] = {
    [sym_heredoc_body] = STATE(10664),
    [aux_sym_call_repeat1] = STATE(10664),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10140] = {
    [sym_heredoc_body] = STATE(10665),
    [aux_sym_call_repeat1] = STATE(10665),
    [aux_sym_argument_list_repeat1] = STATE(9226),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(10846),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10141] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10142] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10143] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10144] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10145] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10146] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14352),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10147] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10148] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12582),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10149] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10150] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10151] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(12582),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10152] = {
    [aux_sym_exceptions_repeat1] = STATE(10668),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10153] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12582),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10154] = {
    [sym_string] = STATE(10154),
    [aux_sym_chained_string_repeat1] = STATE(10154),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [10155] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [10156] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [10157] = {
    [sym_heredoc_body] = STATE(10157),
    [aux_sym_call_repeat1] = STATE(10157),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10158] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7499),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(7499),
    [sym_operator_assignment] = STATE(7499),
    [sym_conditional] = STATE(7499),
    [sym_range] = STATE(7499),
    [sym_binary] = STATE(7499),
    [sym_unary] = STATE(7499),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7502),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(10802),
    [sym__splat_star] = ACTIONS(10804),
    [sym__unary_minus] = ACTIONS(7930),
    [sym__identifier_hash_key] = ACTIONS(10806),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13669),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(10808),
    [sym_identifier] = ACTIONS(10808),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10159] = {
    [sym_heredoc_body] = STATE(10157),
    [aux_sym_call_repeat1] = STATE(10157),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10160] = {
    [aux_sym_argument_list_repeat1] = STATE(10160),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14354),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [10161] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10669),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_assignment] = STATE(10669),
    [sym_operator_assignment] = STATE(10669),
    [sym_conditional] = STATE(10669),
    [sym_range] = STATE(10669),
    [sym_binary] = STATE(10669),
    [sym_unary] = STATE(10669),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10162] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [10163] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [10164] = {
    [sym_heredoc_body] = STATE(10164),
    [aux_sym_call_repeat1] = STATE(10164),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [10165] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(7520),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(7520),
    [sym_operator_assignment] = STATE(7520),
    [sym_conditional] = STATE(7520),
    [sym_range] = STATE(7520),
    [sym_binary] = STATE(7520),
    [sym_unary] = STATE(7520),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7523),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(10838),
    [sym__splat_star] = ACTIONS(10840),
    [sym__unary_minus] = ACTIONS(8004),
    [sym__identifier_hash_key] = ACTIONS(10842),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13673),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(10844),
    [sym_identifier] = ACTIONS(10844),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10166] = {
    [sym_heredoc_body] = STATE(10164),
    [aux_sym_call_repeat1] = STATE(10164),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [10167] = {
    [aux_sym_argument_list_repeat1] = STATE(10167),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14357),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [10168] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9227),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5119),
    [sym_scope_resolution] = STATE(5115),
    [sym_call] = STATE(5115),
    [sym_method_call] = STATE(5119),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(9227),
    [sym_operator_assignment] = STATE(9227),
    [sym_conditional] = STATE(9227),
    [sym_range] = STATE(9227),
    [sym_binary] = STATE(9227),
    [sym_unary] = STATE(9227),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(5118),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5119),
    [sym__variable] = STATE(5115),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5119),
    [sym_false] = STATE(5119),
    [sym_nil] = STATE(5119),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7491),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(10804),
    [sym__unary_minus] = ACTIONS(7930),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7934),
    [anon_sym_yield] = ACTIONS(7936),
    [anon_sym_break] = ACTIONS(7938),
    [anon_sym_next] = ACTIONS(7940),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10798),
    [anon_sym_defined_QMARK] = ACTIONS(7942),
    [anon_sym_not] = ACTIONS(7944),
    [anon_sym_BANG] = ACTIONS(7948),
    [anon_sym_TILDE] = ACTIONS(7948),
    [sym_constant] = ACTIONS(7954),
    [sym_identifier] = ACTIONS(7954),
    [sym_instance_variable] = ACTIONS(7952),
    [sym_class_variable] = ACTIONS(7952),
    [sym_global_variable] = ACTIONS(7952),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(7954),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(7954),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10169] = {
    [aux_sym_exceptions_repeat1] = STATE(10670),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14360),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10170] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(7972),
    [sym__binary_star] = ACTIONS(7974),
    [anon_sym_PIPE] = ACTIONS(7976),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(7974),
    [anon_sym_AMP] = ACTIONS(7978),
    [anon_sym_LT] = ACTIONS(7980),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(7982),
    [anon_sym_DOT_DOT] = ACTIONS(7984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7986),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(7990),
    [anon_sym_AMP_AMP] = ACTIONS(7990),
    [anon_sym_LT_LT] = ACTIONS(7992),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_EQ_EQ] = ACTIONS(7994),
    [anon_sym_BANG_EQ] = ACTIONS(7990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7990),
    [anon_sym_LT_EQ_GT] = ACTIONS(7990),
    [anon_sym_EQ_TILDE] = ACTIONS(7990),
    [anon_sym_BANG_TILDE] = ACTIONS(7990),
    [anon_sym_LT_EQ] = ACTIONS(7980),
    [anon_sym_GT] = ACTIONS(7980),
    [anon_sym_GT_EQ] = ACTIONS(7996),
    [anon_sym_CARET] = ACTIONS(7998),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7974),
    [anon_sym_PERCENT] = ACTIONS(7974),
    [sym_comment] = ACTIONS(87),
  },
  [10171] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10172] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [10173] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10174] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10175] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10176] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14362),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10177] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10178] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12643),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10179] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10180] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10181] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(12643),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10182] = {
    [aux_sym_exceptions_repeat1] = STATE(10673),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [10183] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12643),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10184] = {
    [sym_string] = STATE(10184),
    [aux_sym_chained_string_repeat1] = STATE(10184),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [10185] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10674),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_assignment] = STATE(10674),
    [sym_operator_assignment] = STATE(10674),
    [sym_conditional] = STATE(10674),
    [sym_range] = STATE(10674),
    [sym_binary] = STATE(10674),
    [sym_unary] = STATE(10674),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10186] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9265),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(5159),
    [sym_scope_resolution] = STATE(5155),
    [sym_call] = STATE(5155),
    [sym_method_call] = STATE(5159),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(9265),
    [sym_operator_assignment] = STATE(9265),
    [sym_conditional] = STATE(9265),
    [sym_range] = STATE(9265),
    [sym_binary] = STATE(9265),
    [sym_unary] = STATE(9265),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(5158),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5159),
    [sym__variable] = STATE(5155),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(5159),
    [sym_false] = STATE(5159),
    [sym_nil] = STATE(5159),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(7563),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(10840),
    [sym__unary_minus] = ACTIONS(8004),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(8008),
    [anon_sym_yield] = ACTIONS(8010),
    [anon_sym_break] = ACTIONS(8012),
    [anon_sym_next] = ACTIONS(8014),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(10886),
    [anon_sym_defined_QMARK] = ACTIONS(8016),
    [anon_sym_not] = ACTIONS(8018),
    [anon_sym_BANG] = ACTIONS(8022),
    [anon_sym_TILDE] = ACTIONS(8022),
    [sym_constant] = ACTIONS(8028),
    [sym_identifier] = ACTIONS(8028),
    [sym_instance_variable] = ACTIONS(8026),
    [sym_class_variable] = ACTIONS(8026),
    [sym_global_variable] = ACTIONS(8026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(8028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10187] = {
    [aux_sym_exceptions_repeat1] = STATE(10675),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14364),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10188] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [10189] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10190] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(12673),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [10191] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [10192] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12671),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(12673),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12691),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [10193] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14366),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10194] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(12671),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(12673),
    [anon_sym_LT] = ACTIONS(12675),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12681),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12683),
    [anon_sym_AMP_AMP] = ACTIONS(12683),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(12687),
    [anon_sym_BANG_EQ] = ACTIONS(12683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12683),
    [anon_sym_LT_EQ_GT] = ACTIONS(12683),
    [anon_sym_EQ_TILDE] = ACTIONS(12683),
    [anon_sym_BANG_TILDE] = ACTIONS(12683),
    [anon_sym_LT_EQ] = ACTIONS(12675),
    [anon_sym_GT] = ACTIONS(12675),
    [anon_sym_GT_EQ] = ACTIONS(12689),
    [anon_sym_CARET] = ACTIONS(12691),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [10195] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12671),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(12673),
    [anon_sym_LT] = ACTIONS(12675),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12677),
    [anon_sym_DOT_DOT] = ACTIONS(12679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12681),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12683),
    [anon_sym_AMP_AMP] = ACTIONS(12683),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(12687),
    [anon_sym_BANG_EQ] = ACTIONS(12683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12683),
    [anon_sym_LT_EQ_GT] = ACTIONS(12683),
    [anon_sym_EQ_TILDE] = ACTIONS(12683),
    [anon_sym_BANG_TILDE] = ACTIONS(12683),
    [anon_sym_LT_EQ] = ACTIONS(12675),
    [anon_sym_GT] = ACTIONS(12675),
    [anon_sym_GT_EQ] = ACTIONS(12689),
    [anon_sym_CARET] = ACTIONS(12691),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [10196] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12671),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(12673),
    [anon_sym_LT] = ACTIONS(12675),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(12687),
    [anon_sym_BANG_EQ] = ACTIONS(12683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12683),
    [anon_sym_LT_EQ_GT] = ACTIONS(12683),
    [anon_sym_EQ_TILDE] = ACTIONS(12683),
    [anon_sym_BANG_TILDE] = ACTIONS(12683),
    [anon_sym_LT_EQ] = ACTIONS(12675),
    [anon_sym_GT] = ACTIONS(12675),
    [anon_sym_GT_EQ] = ACTIONS(12689),
    [anon_sym_CARET] = ACTIONS(12691),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [10197] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [10198] = {
    [aux_sym_exceptions_repeat1] = STATE(10198),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(14368),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10199] = {
    [aux_sym_exceptions_repeat1] = STATE(9283),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10200] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(12671),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(12673),
    [anon_sym_LT] = ACTIONS(12675),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12677),
    [anon_sym_DOT_DOT] = ACTIONS(12679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12681),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12683),
    [anon_sym_AMP_AMP] = ACTIONS(12683),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(12687),
    [anon_sym_BANG_EQ] = ACTIONS(12683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12683),
    [anon_sym_LT_EQ_GT] = ACTIONS(12683),
    [anon_sym_EQ_TILDE] = ACTIONS(12683),
    [anon_sym_BANG_TILDE] = ACTIONS(12683),
    [anon_sym_LT_EQ] = ACTIONS(12675),
    [anon_sym_GT] = ACTIONS(12675),
    [anon_sym_GT_EQ] = ACTIONS(12689),
    [anon_sym_CARET] = ACTIONS(12691),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [10201] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8036),
    [sym__binary_star] = ACTIONS(8038),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8040),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8038),
    [anon_sym_AMP] = ACTIONS(8042),
    [anon_sym_LT] = ACTIONS(8044),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8046),
    [anon_sym_DOT_DOT] = ACTIONS(8048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8050),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8052),
    [anon_sym_AMP_AMP] = ACTIONS(8052),
    [anon_sym_LT_LT] = ACTIONS(8054),
    [anon_sym_GT_GT] = ACTIONS(8054),
    [anon_sym_EQ_EQ] = ACTIONS(8056),
    [anon_sym_BANG_EQ] = ACTIONS(8052),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8052),
    [anon_sym_LT_EQ_GT] = ACTIONS(8052),
    [anon_sym_EQ_TILDE] = ACTIONS(8052),
    [anon_sym_BANG_TILDE] = ACTIONS(8052),
    [anon_sym_LT_EQ] = ACTIONS(8044),
    [anon_sym_GT] = ACTIONS(8044),
    [anon_sym_GT_EQ] = ACTIONS(8058),
    [anon_sym_CARET] = ACTIONS(8060),
    [anon_sym_PLUS] = ACTIONS(8036),
    [anon_sym_SLASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [sym_comment] = ACTIONS(87),
  },
  [10202] = {
    [aux_sym_exceptions_repeat1] = STATE(10202),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14371),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10203] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8096),
    [sym__binary_star] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8100),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8102),
    [anon_sym_AMP] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(8106),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8108),
    [anon_sym_DOT_DOT] = ACTIONS(8110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8112),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8114),
    [anon_sym_AMP_AMP] = ACTIONS(8114),
    [anon_sym_LT_LT] = ACTIONS(8116),
    [anon_sym_GT_GT] = ACTIONS(8116),
    [anon_sym_EQ_EQ] = ACTIONS(8114),
    [anon_sym_BANG_EQ] = ACTIONS(8118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8118),
    [anon_sym_LT_EQ_GT] = ACTIONS(8118),
    [anon_sym_EQ_TILDE] = ACTIONS(8118),
    [anon_sym_BANG_TILDE] = ACTIONS(8118),
    [anon_sym_LT_EQ] = ACTIONS(8106),
    [anon_sym_GT] = ACTIONS(8106),
    [anon_sym_GT_EQ] = ACTIONS(8120),
    [anon_sym_CARET] = ACTIONS(8100),
    [anon_sym_PLUS] = ACTIONS(8122),
    [anon_sym_SLASH] = ACTIONS(8102),
    [anon_sym_PERCENT] = ACTIONS(8102),
    [sym_comment] = ACTIONS(87),
  },
  [10204] = {
    [aux_sym_exceptions_repeat1] = STATE(10204),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14374),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10205] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8132),
    [sym__binary_star] = ACTIONS(8134),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8136),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8134),
    [anon_sym_AMP] = ACTIONS(8138),
    [anon_sym_LT] = ACTIONS(8140),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8142),
    [anon_sym_DOT_DOT] = ACTIONS(8144),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8146),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8152),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ_GT] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_BANG_TILDE] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8140),
    [anon_sym_GT] = ACTIONS(8140),
    [anon_sym_GT_EQ] = ACTIONS(8154),
    [anon_sym_CARET] = ACTIONS(8156),
    [anon_sym_PLUS] = ACTIONS(8132),
    [anon_sym_SLASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [sym_comment] = ACTIONS(87),
  },
  [10206] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8180),
    [sym__binary_star] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8184),
    [anon_sym_STAR_STAR] = ACTIONS(8182),
    [anon_sym_AMP] = ACTIONS(8186),
    [anon_sym_LT] = ACTIONS(8188),
    [anon_sym_in] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8190),
    [anon_sym_DOT_DOT] = ACTIONS(8192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8194),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8198),
    [anon_sym_AMP_AMP] = ACTIONS(8198),
    [anon_sym_LT_LT] = ACTIONS(8200),
    [anon_sym_GT_GT] = ACTIONS(8200),
    [anon_sym_EQ_EQ] = ACTIONS(8202),
    [anon_sym_BANG_EQ] = ACTIONS(8198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8198),
    [anon_sym_LT_EQ_GT] = ACTIONS(8198),
    [anon_sym_EQ_TILDE] = ACTIONS(8198),
    [anon_sym_BANG_TILDE] = ACTIONS(8198),
    [anon_sym_LT_EQ] = ACTIONS(8188),
    [anon_sym_GT] = ACTIONS(8188),
    [anon_sym_GT_EQ] = ACTIONS(8204),
    [anon_sym_CARET] = ACTIONS(8206),
    [anon_sym_PLUS] = ACTIONS(8180),
    [anon_sym_SLASH] = ACTIONS(8182),
    [anon_sym_PERCENT] = ACTIONS(8182),
    [sym_comment] = ACTIONS(87),
  },
  [10207] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10208] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [10209] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10210] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10211] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10212] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14377),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10213] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10214] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12736),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10215] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10216] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10217] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(12736),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10218] = {
    [aux_sym_exceptions_repeat1] = STATE(10679),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_in] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [10219] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12736),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10220] = {
    [sym_string] = STATE(10220),
    [aux_sym_chained_string_repeat1] = STATE(10220),
    [sym__string_start] = ACTIONS(13427),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_in] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [10221] = {
    [aux_sym_exceptions_repeat1] = STATE(10221),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14379),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10222] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8236),
    [sym__binary_star] = ACTIONS(8238),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8240),
    [anon_sym_STAR_STAR] = ACTIONS(8242),
    [anon_sym_AMP] = ACTIONS(8244),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(8246),
    [anon_sym_in] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8248),
    [anon_sym_DOT_DOT] = ACTIONS(8250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8252),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8254),
    [anon_sym_AMP_AMP] = ACTIONS(8254),
    [anon_sym_LT_LT] = ACTIONS(8256),
    [anon_sym_GT_GT] = ACTIONS(8256),
    [anon_sym_EQ_EQ] = ACTIONS(8254),
    [anon_sym_BANG_EQ] = ACTIONS(8258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8258),
    [anon_sym_LT_EQ_GT] = ACTIONS(8258),
    [anon_sym_EQ_TILDE] = ACTIONS(8258),
    [anon_sym_BANG_TILDE] = ACTIONS(8258),
    [anon_sym_LT_EQ] = ACTIONS(8246),
    [anon_sym_GT] = ACTIONS(8246),
    [anon_sym_GT_EQ] = ACTIONS(8260),
    [anon_sym_CARET] = ACTIONS(8240),
    [anon_sym_PLUS] = ACTIONS(8262),
    [anon_sym_SLASH] = ACTIONS(8242),
    [anon_sym_PERCENT] = ACTIONS(8242),
    [sym_comment] = ACTIONS(87),
  },
  [10223] = {
    [aux_sym_exceptions_repeat1] = STATE(10223),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14382),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10224] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8278),
    [sym__binary_star] = ACTIONS(8280),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8282),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8280),
    [anon_sym_AMP] = ACTIONS(8284),
    [anon_sym_LT] = ACTIONS(8286),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8288),
    [anon_sym_DOT_DOT] = ACTIONS(8290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8292),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8294),
    [anon_sym_AMP_AMP] = ACTIONS(8294),
    [anon_sym_LT_LT] = ACTIONS(8296),
    [anon_sym_GT_GT] = ACTIONS(8296),
    [anon_sym_EQ_EQ] = ACTIONS(8298),
    [anon_sym_BANG_EQ] = ACTIONS(8294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8294),
    [anon_sym_LT_EQ_GT] = ACTIONS(8294),
    [anon_sym_EQ_TILDE] = ACTIONS(8294),
    [anon_sym_BANG_TILDE] = ACTIONS(8294),
    [anon_sym_LT_EQ] = ACTIONS(8286),
    [anon_sym_GT] = ACTIONS(8286),
    [anon_sym_GT_EQ] = ACTIONS(8300),
    [anon_sym_CARET] = ACTIONS(8302),
    [anon_sym_PLUS] = ACTIONS(8278),
    [anon_sym_SLASH] = ACTIONS(8280),
    [anon_sym_PERCENT] = ACTIONS(8280),
    [sym_comment] = ACTIONS(87),
  },
  [10225] = {
    [aux_sym_exceptions_repeat1] = STATE(10225),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14385),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10226] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8324),
    [sym__binary_star] = ACTIONS(8326),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8328),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8326),
    [anon_sym_AMP] = ACTIONS(8330),
    [anon_sym_LT] = ACTIONS(8332),
    [anon_sym_QMARK] = ACTIONS(8334),
    [anon_sym_DOT_DOT] = ACTIONS(8336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8338),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8340),
    [anon_sym_AMP_AMP] = ACTIONS(8340),
    [anon_sym_LT_LT] = ACTIONS(8342),
    [anon_sym_GT_GT] = ACTIONS(8342),
    [anon_sym_EQ_EQ] = ACTIONS(8344),
    [anon_sym_BANG_EQ] = ACTIONS(8340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8340),
    [anon_sym_LT_EQ_GT] = ACTIONS(8340),
    [anon_sym_EQ_TILDE] = ACTIONS(8340),
    [anon_sym_BANG_TILDE] = ACTIONS(8340),
    [anon_sym_LT_EQ] = ACTIONS(8332),
    [anon_sym_GT] = ACTIONS(8332),
    [anon_sym_GT_EQ] = ACTIONS(8346),
    [anon_sym_CARET] = ACTIONS(8348),
    [anon_sym_PLUS] = ACTIONS(8324),
    [anon_sym_SLASH] = ACTIONS(8326),
    [anon_sym_PERCENT] = ACTIONS(8326),
    [sym_comment] = ACTIONS(87),
  },
  [10227] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10228] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10229] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10230] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10231] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10232] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14388),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10233] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10234] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12800),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10235] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10236] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10237] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(12800),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10238] = {
    [aux_sym_exceptions_repeat1] = STATE(10682),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10239] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12800),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10240] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10683),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10683),
    [sym_operator_assignment] = STATE(10683),
    [sym_conditional] = STATE(10683),
    [sym_range] = STATE(10683),
    [sym_binary] = STATE(10683),
    [sym_unary] = STATE(10683),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10241] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(216),
    [sym__argument_list_with_parens] = STATE(10684),
    [sym__argument] = STATE(10685),
    [sym_splat_argument] = STATE(10685),
    [sym_hash_splat_argument] = STATE(10685),
    [sym_block_argument] = STATE(10685),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9381),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10685),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(12826),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(12832),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12850),
    [sym_identifier] = ACTIONS(12850),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10242] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(10684),
    [sym__argument] = STATE(10685),
    [sym_splat_argument] = STATE(10685),
    [sym_hash_splat_argument] = STATE(10685),
    [sym_block_argument] = STATE(10685),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9381),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10685),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(12826),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(12832),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12850),
    [sym_identifier] = ACTIONS(12850),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10243] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(223),
    [sym__argument_list_with_parens] = STATE(10684),
    [sym__argument] = STATE(10685),
    [sym_splat_argument] = STATE(10685),
    [sym_hash_splat_argument] = STATE(10685),
    [sym_block_argument] = STATE(10685),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9381),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10685),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(12826),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(12832),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12850),
    [sym_identifier] = ACTIONS(12850),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10244] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_argument_list] = STATE(224),
    [sym__argument_list_with_parens] = STATE(10684),
    [sym__argument] = STATE(10685),
    [sym_splat_argument] = STATE(10685),
    [sym_hash_splat_argument] = STATE(10685),
    [sym_block_argument] = STATE(10685),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9381),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(10685),
    [sym_lambda] = STATE(214),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(12826),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(12832),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12846),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12850),
    [sym_identifier] = ACTIONS(12850),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10245] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10686),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10686),
    [sym_operator_assignment] = STATE(10686),
    [sym_conditional] = STATE(10686),
    [sym_range] = STATE(10686),
    [sym_binary] = STATE(10686),
    [sym_unary] = STATE(10686),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10246] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(914),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(914),
    [sym_operator_assignment] = STATE(914),
    [sym_conditional] = STATE(914),
    [sym_range] = STATE(914),
    [sym_binary] = STATE(914),
    [sym_unary] = STATE(914),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10247] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(14400),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10248] = {
    [anon_sym_EQ] = ACTIONS(14416),
    [sym_comment] = ACTIONS(87),
  },
  [10249] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14418),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14420),
    [anon_sym_DASH_EQ] = ACTIONS(14420),
    [anon_sym_STAR_EQ] = ACTIONS(14420),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14420),
    [anon_sym_SLASH_EQ] = ACTIONS(14420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14420),
    [anon_sym_PIPE_EQ] = ACTIONS(14420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14420),
    [anon_sym_AMP_EQ] = ACTIONS(14420),
    [anon_sym_PERCENT_EQ] = ACTIONS(14420),
    [anon_sym_GT_GT_EQ] = ACTIONS(14420),
    [anon_sym_LT_LT_EQ] = ACTIONS(14420),
    [anon_sym_CARET_EQ] = ACTIONS(14420),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10250] = {
    [sym_string] = STATE(10699),
    [aux_sym_chained_string_repeat1] = STATE(10699),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10251] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_when] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(14400),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10252] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [10253] = {
    [sym_string] = STATE(10291),
    [aux_sym_chained_string_repeat1] = STATE(10291),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10254] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10700),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10700),
    [sym_operator_assignment] = STATE(10700),
    [sym_conditional] = STATE(10700),
    [sym_range] = STATE(10700),
    [sym_binary] = STATE(10700),
    [sym_unary] = STATE(10700),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10255] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_when] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(14400),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10256] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10701),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10701),
    [sym_operator_assignment] = STATE(10701),
    [sym_conditional] = STATE(10701),
    [sym_range] = STATE(10701),
    [sym_binary] = STATE(10701),
    [sym_unary] = STATE(10701),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10257] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10702),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10702),
    [sym_operator_assignment] = STATE(10702),
    [sym_conditional] = STATE(10702),
    [sym_range] = STATE(10702),
    [sym_binary] = STATE(10702),
    [sym_unary] = STATE(10702),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10258] = {
    [anon_sym_COLON] = ACTIONS(14422),
    [sym_comment] = ACTIONS(87),
  },
  [10259] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10704),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10704),
    [sym_operator_assignment] = STATE(10704),
    [sym_conditional] = STATE(10704),
    [sym_range] = STATE(10704),
    [sym_binary] = STATE(10704),
    [sym_unary] = STATE(10704),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10260] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14424),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [10261] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_when] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10262] = {
    [sym_heredoc_body] = STATE(10706),
    [aux_sym_call_repeat1] = STATE(10706),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_when] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [10263] = {
    [sym_heredoc_body] = STATE(10706),
    [aux_sym_call_repeat1] = STATE(10706),
    [aux_sym_argument_list_repeat1] = STATE(10708),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(14426),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_when] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [10264] = {
    [sym_string] = STATE(10291),
    [aux_sym_chained_string_repeat1] = STATE(10291),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14428),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10265] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10266] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10709),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10709),
    [sym_operator_assignment] = STATE(10709),
    [sym_conditional] = STATE(10709),
    [sym_range] = STATE(10709),
    [sym_binary] = STATE(10709),
    [sym_unary] = STATE(10709),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10267] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10710),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10710),
    [sym_operator_assignment] = STATE(10710),
    [sym_conditional] = STATE(10710),
    [sym_range] = STATE(10710),
    [sym_binary] = STATE(10710),
    [sym_unary] = STATE(10710),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10268] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10711),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10711),
    [sym_operator_assignment] = STATE(10711),
    [sym_conditional] = STATE(10711),
    [sym_range] = STATE(10711),
    [sym_binary] = STATE(10711),
    [sym_unary] = STATE(10711),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10269] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10712),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10712),
    [sym_operator_assignment] = STATE(10712),
    [sym_conditional] = STATE(10712),
    [sym_range] = STATE(10712),
    [sym_binary] = STATE(10712),
    [sym_unary] = STATE(10712),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10270] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10713),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10713),
    [sym_operator_assignment] = STATE(10713),
    [sym_conditional] = STATE(10713),
    [sym_range] = STATE(10713),
    [sym_binary] = STATE(10713),
    [sym_unary] = STATE(10713),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10271] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10714),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10714),
    [sym_operator_assignment] = STATE(10714),
    [sym_conditional] = STATE(10714),
    [sym_range] = STATE(10714),
    [sym_binary] = STATE(10714),
    [sym_unary] = STATE(10714),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10272] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10715),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10715),
    [sym_operator_assignment] = STATE(10715),
    [sym_conditional] = STATE(10715),
    [sym_range] = STATE(10715),
    [sym_binary] = STATE(10715),
    [sym_unary] = STATE(10715),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10273] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10716),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10716),
    [sym_operator_assignment] = STATE(10716),
    [sym_conditional] = STATE(10716),
    [sym_range] = STATE(10716),
    [sym_binary] = STATE(10716),
    [sym_unary] = STATE(10716),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10274] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10717),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10717),
    [sym_operator_assignment] = STATE(10717),
    [sym_conditional] = STATE(10717),
    [sym_range] = STATE(10717),
    [sym_binary] = STATE(10717),
    [sym_unary] = STATE(10717),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10275] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10718),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10718),
    [sym_operator_assignment] = STATE(10718),
    [sym_conditional] = STATE(10718),
    [sym_range] = STATE(10718),
    [sym_binary] = STATE(10718),
    [sym_unary] = STATE(10718),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10276] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10719),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10719),
    [sym_operator_assignment] = STATE(10719),
    [sym_conditional] = STATE(10719),
    [sym_range] = STATE(10719),
    [sym_binary] = STATE(10719),
    [sym_unary] = STATE(10719),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10277] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10720),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10720),
    [sym_operator_assignment] = STATE(10720),
    [sym_conditional] = STATE(10720),
    [sym_range] = STATE(10720),
    [sym_binary] = STATE(10720),
    [sym_unary] = STATE(10720),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10278] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10721),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10721),
    [sym_operator_assignment] = STATE(10721),
    [sym_conditional] = STATE(10721),
    [sym_range] = STATE(10721),
    [sym_binary] = STATE(10721),
    [sym_unary] = STATE(10721),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10279] = {
    [anon_sym_COLON] = ACTIONS(14430),
    [sym_comment] = ACTIONS(87),
  },
  [10280] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10723),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10723),
    [sym_operator_assignment] = STATE(10723),
    [sym_conditional] = STATE(10723),
    [sym_range] = STATE(10723),
    [sym_binary] = STATE(10723),
    [sym_unary] = STATE(10723),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10281] = {
    [sym__line_break] = ACTIONS(1089),
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14432),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_rescue] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [10282] = {
    [sym__line_break] = ACTIONS(1627),
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_unless] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_until] = ACTIONS(1627),
    [anon_sym_rescue] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_when] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10283] = {
    [sym_heredoc_body] = STATE(10725),
    [aux_sym_call_repeat1] = STATE(10725),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_when] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [10284] = {
    [sym_heredoc_body] = STATE(10725),
    [aux_sym_call_repeat1] = STATE(10725),
    [aux_sym_argument_list_repeat1] = STATE(10727),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(14434),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_when] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [10285] = {
    [sym_string] = STATE(10344),
    [aux_sym_chained_string_repeat1] = STATE(10344),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14436),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10286] = {
    [sym_heredoc_body] = STATE(10728),
    [aux_sym_call_repeat1] = STATE(10728),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_when] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10287] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9381),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10729),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(12826),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__identifier_hash_key] = ACTIONS(12832),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14438),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12850),
    [sym_identifier] = ACTIONS(12850),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10288] = {
    [sym_heredoc_body] = STATE(10730),
    [aux_sym_call_repeat1] = STATE(10730),
    [aux_sym_argument_list_repeat1] = STATE(10731),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(13780),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_when] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10289] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10732),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_splat_argument] = STATE(10733),
    [sym_assignment] = STATE(10732),
    [sym_operator_assignment] = STATE(10732),
    [sym_conditional] = STATE(10732),
    [sym_range] = STATE(10732),
    [sym_binary] = STATE(10732),
    [sym_unary] = STATE(10732),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(10733),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(13738),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10290] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10734),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10734),
    [sym_operator_assignment] = STATE(10734),
    [sym_conditional] = STATE(10734),
    [sym_range] = STATE(10734),
    [sym_binary] = STATE(10734),
    [sym_unary] = STATE(10734),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10291] = {
    [sym_string] = STATE(10735),
    [aux_sym_chained_string_repeat1] = STATE(10735),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_when] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [10292] = {
    [aux_sym_undef_repeat1] = STATE(10736),
    [sym__line_break] = ACTIONS(5356),
    [sym__heredoc_body_start] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym_end] = ACTIONS(5356),
    [anon_sym_if] = ACTIONS(5356),
    [anon_sym_unless] = ACTIONS(5356),
    [anon_sym_while] = ACTIONS(5356),
    [anon_sym_until] = ACTIONS(5356),
    [anon_sym_rescue] = ACTIONS(5356),
    [anon_sym_when] = ACTIONS(5356),
    [anon_sym_else] = ACTIONS(5356),
    [sym_comment] = ACTIONS(87),
  },
  [10293] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(7790),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(7790),
    [sym_unless_modifier] = STATE(7790),
    [sym_while_modifier] = STATE(7790),
    [sym_until_modifier] = STATE(7790),
    [sym_rescue_modifier] = STATE(7790),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7792),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(7792),
    [sym_operator_assignment] = STATE(7792),
    [sym_conditional] = STATE(7792),
    [sym_range] = STATE(7792),
    [sym_binary] = STATE(7792),
    [sym_unary] = STATE(7792),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_undef] = STATE(7790),
    [sym_alias] = STATE(7790),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(7790),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5678),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(5678),
    [anon_sym_else] = ACTIONS(5678),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [anon_sym_undef] = ACTIONS(11070),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10294] = {
    [sym_heredoc_body] = STATE(10737),
    [sym__terminator] = STATE(10737),
    [aux_sym__statements_repeat1] = STATE(10294),
    [sym__line_break] = ACTIONS(14440),
    [sym__heredoc_body_start] = ACTIONS(5683),
    [anon_sym_SEMI] = ACTIONS(14440),
    [anon_sym_end] = ACTIONS(5674),
    [anon_sym_when] = ACTIONS(5674),
    [anon_sym_else] = ACTIONS(5674),
    [sym_comment] = ACTIONS(87),
  },
  [10295] = {
    [sym__line_break] = ACTIONS(5686),
    [sym__heredoc_body_start] = ACTIONS(5686),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(5686),
    [anon_sym_if] = ACTIONS(5686),
    [anon_sym_unless] = ACTIONS(5686),
    [anon_sym_while] = ACTIONS(5686),
    [anon_sym_until] = ACTIONS(5686),
    [anon_sym_rescue] = ACTIONS(5686),
    [anon_sym_when] = ACTIONS(5686),
    [anon_sym_else] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(12888),
    [anon_sym_or] = ACTIONS(12888),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10296] = {
    [sym__line_break] = ACTIONS(5688),
    [sym__heredoc_body_start] = ACTIONS(5688),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(5688),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_unless] = ACTIONS(5688),
    [anon_sym_while] = ACTIONS(5688),
    [anon_sym_until] = ACTIONS(5688),
    [anon_sym_rescue] = ACTIONS(5688),
    [anon_sym_when] = ACTIONS(5688),
    [anon_sym_else] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(12888),
    [anon_sym_or] = ACTIONS(12888),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10297] = {
    [sym__line_break] = ACTIONS(5690),
    [sym__heredoc_body_start] = ACTIONS(5690),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(5690),
    [anon_sym_if] = ACTIONS(5690),
    [anon_sym_unless] = ACTIONS(5690),
    [anon_sym_while] = ACTIONS(5690),
    [anon_sym_until] = ACTIONS(5690),
    [anon_sym_rescue] = ACTIONS(5690),
    [anon_sym_when] = ACTIONS(5690),
    [anon_sym_else] = ACTIONS(5690),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(12888),
    [anon_sym_or] = ACTIONS(12888),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10298] = {
    [sym__line_break] = ACTIONS(5692),
    [sym__heredoc_body_start] = ACTIONS(5692),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(5692),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_unless] = ACTIONS(5692),
    [anon_sym_while] = ACTIONS(5692),
    [anon_sym_until] = ACTIONS(5692),
    [anon_sym_rescue] = ACTIONS(5692),
    [anon_sym_when] = ACTIONS(5692),
    [anon_sym_else] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(12888),
    [anon_sym_or] = ACTIONS(12888),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10299] = {
    [sym__line_break] = ACTIONS(5694),
    [sym__heredoc_body_start] = ACTIONS(5694),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(5694),
    [anon_sym_if] = ACTIONS(5694),
    [anon_sym_unless] = ACTIONS(5694),
    [anon_sym_while] = ACTIONS(5694),
    [anon_sym_until] = ACTIONS(5694),
    [anon_sym_rescue] = ACTIONS(5694),
    [anon_sym_when] = ACTIONS(5694),
    [anon_sym_else] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(12888),
    [anon_sym_or] = ACTIONS(12888),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10300] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10301] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10302] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10303] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10304] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10305] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14443),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10306] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_when] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10307] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10308] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10309] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10310] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10739),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10739),
    [sym_operator_assignment] = STATE(10739),
    [sym_conditional] = STATE(10739),
    [sym_range] = STATE(10739),
    [sym_binary] = STATE(10739),
    [sym_unary] = STATE(10739),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10311] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9414),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(3594),
    [sym__argument_list_with_parens] = STATE(9416),
    [sym__argument] = STATE(9417),
    [sym_splat_argument] = STATE(9417),
    [sym_hash_splat_argument] = STATE(9417),
    [sym_block_argument] = STATE(9417),
    [sym_assignment] = STATE(9414),
    [sym_operator_assignment] = STATE(9414),
    [sym_conditional] = STATE(9414),
    [sym_range] = STATE(9414),
    [sym_binary] = STATE(9414),
    [sym_unary] = STATE(9414),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(9420),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(9417),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(363),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(12900),
    [sym__splat_star] = ACTIONS(12902),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(12906),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12924),
    [sym_identifier] = ACTIONS(12924),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10312] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9414),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(3595),
    [sym__argument_list_with_parens] = STATE(9416),
    [sym__argument] = STATE(9417),
    [sym_splat_argument] = STATE(9417),
    [sym_hash_splat_argument] = STATE(9417),
    [sym_block_argument] = STATE(9417),
    [sym_assignment] = STATE(9414),
    [sym_operator_assignment] = STATE(9414),
    [sym_conditional] = STATE(9414),
    [sym_range] = STATE(9414),
    [sym_binary] = STATE(9414),
    [sym_unary] = STATE(9414),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(9420),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(9417),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(415),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(12900),
    [sym__splat_star] = ACTIONS(12902),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(12906),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12924),
    [sym_identifier] = ACTIONS(12924),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10313] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9414),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(3596),
    [sym__argument_list_with_parens] = STATE(9416),
    [sym__argument] = STATE(9417),
    [sym_splat_argument] = STATE(9417),
    [sym_hash_splat_argument] = STATE(9417),
    [sym_block_argument] = STATE(9417),
    [sym_assignment] = STATE(9414),
    [sym_operator_assignment] = STATE(9414),
    [sym_conditional] = STATE(9414),
    [sym_range] = STATE(9414),
    [sym_binary] = STATE(9414),
    [sym_unary] = STATE(9414),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(9420),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(9417),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(419),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(12900),
    [sym__splat_star] = ACTIONS(12902),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(12906),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12924),
    [sym_identifier] = ACTIONS(12924),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10314] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9414),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(3597),
    [sym__argument_list_with_parens] = STATE(9416),
    [sym__argument] = STATE(9417),
    [sym_splat_argument] = STATE(9417),
    [sym_hash_splat_argument] = STATE(9417),
    [sym_block_argument] = STATE(9417),
    [sym_assignment] = STATE(9414),
    [sym_operator_assignment] = STATE(9414),
    [sym_conditional] = STATE(9414),
    [sym_range] = STATE(9414),
    [sym_binary] = STATE(9414),
    [sym_unary] = STATE(9414),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(9420),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(9417),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(423),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(12900),
    [sym__splat_star] = ACTIONS(12902),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(12906),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12924),
    [sym_identifier] = ACTIONS(12924),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10315] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10740),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10740),
    [sym_operator_assignment] = STATE(10740),
    [sym_conditional] = STATE(10740),
    [sym_range] = STATE(10740),
    [sym_binary] = STATE(10740),
    [sym_unary] = STATE(10740),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10316] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10317] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(14457),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10318] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9414),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_argument_list] = STATE(1061),
    [sym__argument_list_with_parens] = STATE(9416),
    [sym__argument] = STATE(9417),
    [sym_splat_argument] = STATE(9417),
    [sym_hash_splat_argument] = STATE(9417),
    [sym_block_argument] = STATE(9417),
    [sym_do_block] = STATE(429),
    [sym_block] = STATE(429),
    [sym_assignment] = STATE(9414),
    [sym_operator_assignment] = STATE(9414),
    [sym_conditional] = STATE(9414),
    [sym_range] = STATE(9414),
    [sym_binary] = STATE(9414),
    [sym_unary] = STATE(9414),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(9420),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(9417),
    [sym_lambda] = STATE(424),
    [sym__line_break] = ACTIONS(745),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(12900),
    [sym__splat_star] = ACTIONS(12902),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(12906),
    [anon_sym_LBRACE] = ACTIONS(5918),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_end] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_unless] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_until] = ACTIONS(771),
    [anon_sym_rescue] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12920),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12924),
    [sym_identifier] = ACTIONS(12924),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(819),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10319] = {
    [anon_sym_EQ] = ACTIONS(14473),
    [sym_comment] = ACTIONS(87),
  },
  [10320] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14475),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14477),
    [anon_sym_DASH_EQ] = ACTIONS(14477),
    [anon_sym_STAR_EQ] = ACTIONS(14477),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14477),
    [anon_sym_SLASH_EQ] = ACTIONS(14477),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14477),
    [anon_sym_PIPE_EQ] = ACTIONS(14477),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14477),
    [anon_sym_AMP_EQ] = ACTIONS(14477),
    [anon_sym_PERCENT_EQ] = ACTIONS(14477),
    [anon_sym_GT_GT_EQ] = ACTIONS(14477),
    [anon_sym_LT_LT_EQ] = ACTIONS(14477),
    [anon_sym_CARET_EQ] = ACTIONS(14477),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10321] = {
    [sym_string] = STATE(10753),
    [aux_sym_chained_string_repeat1] = STATE(10753),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10322] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_when] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(14457),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10323] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [10324] = {
    [sym_string] = STATE(10344),
    [aux_sym_chained_string_repeat1] = STATE(10344),
    [sym__line_break] = ACTIONS(559),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10325] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10754),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10754),
    [sym_operator_assignment] = STATE(10754),
    [sym_conditional] = STATE(10754),
    [sym_range] = STATE(10754),
    [sym_binary] = STATE(10754),
    [sym_unary] = STATE(10754),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10326] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_when] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(14457),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10327] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10328] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10755),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10755),
    [sym_operator_assignment] = STATE(10755),
    [sym_conditional] = STATE(10755),
    [sym_range] = STATE(10755),
    [sym_binary] = STATE(10755),
    [sym_unary] = STATE(10755),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10329] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10756),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10756),
    [sym_operator_assignment] = STATE(10756),
    [sym_conditional] = STATE(10756),
    [sym_range] = STATE(10756),
    [sym_binary] = STATE(10756),
    [sym_unary] = STATE(10756),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10330] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10757),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10757),
    [sym_operator_assignment] = STATE(10757),
    [sym_conditional] = STATE(10757),
    [sym_range] = STATE(10757),
    [sym_binary] = STATE(10757),
    [sym_unary] = STATE(10757),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10331] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10758),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10758),
    [sym_operator_assignment] = STATE(10758),
    [sym_conditional] = STATE(10758),
    [sym_range] = STATE(10758),
    [sym_binary] = STATE(10758),
    [sym_unary] = STATE(10758),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10332] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10759),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10759),
    [sym_operator_assignment] = STATE(10759),
    [sym_conditional] = STATE(10759),
    [sym_range] = STATE(10759),
    [sym_binary] = STATE(10759),
    [sym_unary] = STATE(10759),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10333] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10760),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10760),
    [sym_operator_assignment] = STATE(10760),
    [sym_conditional] = STATE(10760),
    [sym_range] = STATE(10760),
    [sym_binary] = STATE(10760),
    [sym_unary] = STATE(10760),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10334] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10761),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10761),
    [sym_operator_assignment] = STATE(10761),
    [sym_conditional] = STATE(10761),
    [sym_range] = STATE(10761),
    [sym_binary] = STATE(10761),
    [sym_unary] = STATE(10761),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10335] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10762),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10762),
    [sym_operator_assignment] = STATE(10762),
    [sym_conditional] = STATE(10762),
    [sym_range] = STATE(10762),
    [sym_binary] = STATE(10762),
    [sym_unary] = STATE(10762),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10336] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10763),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10763),
    [sym_operator_assignment] = STATE(10763),
    [sym_conditional] = STATE(10763),
    [sym_range] = STATE(10763),
    [sym_binary] = STATE(10763),
    [sym_unary] = STATE(10763),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10337] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10764),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10764),
    [sym_operator_assignment] = STATE(10764),
    [sym_conditional] = STATE(10764),
    [sym_range] = STATE(10764),
    [sym_binary] = STATE(10764),
    [sym_unary] = STATE(10764),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10338] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10765),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10765),
    [sym_operator_assignment] = STATE(10765),
    [sym_conditional] = STATE(10765),
    [sym_range] = STATE(10765),
    [sym_binary] = STATE(10765),
    [sym_unary] = STATE(10765),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10339] = {
    [sym_heredoc_body] = STATE(10766),
    [aux_sym_call_repeat1] = STATE(10766),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_when] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [10340] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9414),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym__argument] = STATE(3720),
    [sym_splat_argument] = STATE(3720),
    [sym_hash_splat_argument] = STATE(3720),
    [sym_block_argument] = STATE(3720),
    [sym_assignment] = STATE(9414),
    [sym_operator_assignment] = STATE(9414),
    [sym_conditional] = STATE(9414),
    [sym_range] = STATE(9414),
    [sym_binary] = STATE(9414),
    [sym_unary] = STATE(9414),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(9420),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(10767),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(3720),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(12900),
    [sym__splat_star] = ACTIONS(12902),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__identifier_hash_key] = ACTIONS(12906),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14479),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12924),
    [sym_identifier] = ACTIONS(12924),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10341] = {
    [sym_heredoc_body] = STATE(10768),
    [aux_sym_call_repeat1] = STATE(10768),
    [aux_sym_argument_list_repeat1] = STATE(10769),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(13850),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_when] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [10342] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10770),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_splat_argument] = STATE(10771),
    [sym_assignment] = STATE(10770),
    [sym_operator_assignment] = STATE(10770),
    [sym_conditional] = STATE(10770),
    [sym_range] = STATE(10770),
    [sym_binary] = STATE(10770),
    [sym_unary] = STATE(10770),
    [sym_right_assignment_list] = STATE(3725),
    [sym__arg_or_splat_arg] = STATE(10771),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(13774),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10343] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10772),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10772),
    [sym_operator_assignment] = STATE(10772),
    [sym_conditional] = STATE(10772),
    [sym_range] = STATE(10772),
    [sym_binary] = STATE(10772),
    [sym_unary] = STATE(10772),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10344] = {
    [sym_string] = STATE(10773),
    [aux_sym_chained_string_repeat1] = STATE(10773),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(749),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_when] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [10345] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10774),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(10774),
    [sym_operator_assignment] = STATE(10774),
    [sym_conditional] = STATE(10774),
    [sym_range] = STATE(10774),
    [sym_binary] = STATE(10774),
    [sym_unary] = STATE(10774),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10346] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10775),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(10775),
    [sym_operator_assignment] = STATE(10775),
    [sym_conditional] = STATE(10775),
    [sym_range] = STATE(10775),
    [sym_binary] = STATE(10775),
    [sym_unary] = STATE(10775),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10347] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10776),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(10776),
    [sym_operator_assignment] = STATE(10776),
    [sym_conditional] = STATE(10776),
    [sym_range] = STATE(10776),
    [sym_binary] = STATE(10776),
    [sym_unary] = STATE(10776),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10348] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(299),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(299),
    [sym_operator_assignment] = STATE(299),
    [sym_conditional] = STATE(299),
    [sym_range] = STATE(299),
    [sym_binary] = STATE(299),
    [sym_unary] = STATE(299),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10349] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(14485),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(14487),
    [anon_sym_LT] = ACTIONS(14489),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_when] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_DOT_DOT] = ACTIONS(14493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14495),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(14497),
    [anon_sym_AMP_AMP] = ACTIONS(14497),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(14501),
    [anon_sym_BANG_EQ] = ACTIONS(14497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14497),
    [anon_sym_LT_EQ_GT] = ACTIONS(14497),
    [anon_sym_EQ_TILDE] = ACTIONS(14497),
    [anon_sym_BANG_TILDE] = ACTIONS(14497),
    [anon_sym_LT_EQ] = ACTIONS(14489),
    [anon_sym_GT] = ACTIONS(14489),
    [anon_sym_GT_EQ] = ACTIONS(14503),
    [anon_sym_CARET] = ACTIONS(14505),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [10350] = {
    [aux_sym_exceptions_repeat1] = STATE(10788),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(14507),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10351] = {
    [anon_sym_EQ] = ACTIONS(14509),
    [sym_comment] = ACTIONS(87),
  },
  [10352] = {
    [sym__line_break] = ACTIONS(559),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14511),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14513),
    [anon_sym_DASH_EQ] = ACTIONS(14513),
    [anon_sym_STAR_EQ] = ACTIONS(14513),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14513),
    [anon_sym_SLASH_EQ] = ACTIONS(14513),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14513),
    [anon_sym_PIPE_EQ] = ACTIONS(14513),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14513),
    [anon_sym_AMP_EQ] = ACTIONS(14513),
    [anon_sym_PERCENT_EQ] = ACTIONS(14513),
    [anon_sym_GT_GT_EQ] = ACTIONS(14513),
    [anon_sym_LT_LT_EQ] = ACTIONS(14513),
    [anon_sym_CARET_EQ] = ACTIONS(14513),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10353] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_when] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10354] = {
    [sym_string] = STATE(10354),
    [aux_sym_chained_string_repeat1] = STATE(10354),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_when] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [10355] = {
    [anon_sym_end] = ACTIONS(14515),
    [sym_comment] = ACTIONS(87),
  },
  [10356] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8372),
    [sym__binary_star] = ACTIONS(8374),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8376),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8374),
    [anon_sym_AMP] = ACTIONS(8378),
    [anon_sym_LT] = ACTIONS(8380),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8382),
    [anon_sym_DOT_DOT] = ACTIONS(8384),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8386),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8390),
    [anon_sym_AMP_AMP] = ACTIONS(8390),
    [anon_sym_LT_LT] = ACTIONS(8392),
    [anon_sym_GT_GT] = ACTIONS(8392),
    [anon_sym_EQ_EQ] = ACTIONS(8394),
    [anon_sym_BANG_EQ] = ACTIONS(8390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8390),
    [anon_sym_LT_EQ_GT] = ACTIONS(8390),
    [anon_sym_EQ_TILDE] = ACTIONS(8390),
    [anon_sym_BANG_TILDE] = ACTIONS(8390),
    [anon_sym_LT_EQ] = ACTIONS(8380),
    [anon_sym_GT] = ACTIONS(8380),
    [anon_sym_GT_EQ] = ACTIONS(8396),
    [anon_sym_CARET] = ACTIONS(8398),
    [anon_sym_PLUS] = ACTIONS(8372),
    [anon_sym_SLASH] = ACTIONS(8374),
    [anon_sym_PERCENT] = ACTIONS(8374),
    [sym_comment] = ACTIONS(87),
  },
  [10357] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [10358] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [10359] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [10360] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [10361] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [10362] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14517),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10363] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [10364] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(12955),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [10365] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [10366] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [10367] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(12955),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [10368] = {
    [aux_sym_exceptions_repeat1] = STATE(10793),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [10369] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(12955),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [10370] = {
    [sym_string] = STATE(10370),
    [aux_sym_chained_string_repeat1] = STATE(10370),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [10371] = {
    [aux_sym_exceptions_repeat1] = STATE(10371),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(14519),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10372] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8425),
    [sym__binary_star] = ACTIONS(8427),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8429),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8427),
    [anon_sym_AMP] = ACTIONS(8431),
    [anon_sym_LT] = ACTIONS(8433),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8435),
    [anon_sym_DOT_DOT] = ACTIONS(8437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8439),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8441),
    [anon_sym_AMP_AMP] = ACTIONS(8441),
    [anon_sym_LT_LT] = ACTIONS(8443),
    [anon_sym_GT_GT] = ACTIONS(8443),
    [anon_sym_EQ_EQ] = ACTIONS(8445),
    [anon_sym_BANG_EQ] = ACTIONS(8441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8441),
    [anon_sym_LT_EQ_GT] = ACTIONS(8441),
    [anon_sym_EQ_TILDE] = ACTIONS(8441),
    [anon_sym_BANG_TILDE] = ACTIONS(8441),
    [anon_sym_LT_EQ] = ACTIONS(8433),
    [anon_sym_GT] = ACTIONS(8433),
    [anon_sym_GT_EQ] = ACTIONS(8447),
    [anon_sym_CARET] = ACTIONS(8449),
    [anon_sym_PLUS] = ACTIONS(8425),
    [anon_sym_SLASH] = ACTIONS(8427),
    [anon_sym_PERCENT] = ACTIONS(8427),
    [sym_comment] = ACTIONS(87),
  },
  [10373] = {
    [aux_sym_exceptions_repeat1] = STATE(10373),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14522),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10374] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8481),
    [sym__binary_star] = ACTIONS(8483),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8485),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8483),
    [anon_sym_AMP] = ACTIONS(8487),
    [anon_sym_LT] = ACTIONS(8489),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8491),
    [anon_sym_DOT_DOT] = ACTIONS(8493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8495),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8497),
    [anon_sym_AMP_AMP] = ACTIONS(8497),
    [anon_sym_LT_LT] = ACTIONS(8499),
    [anon_sym_GT_GT] = ACTIONS(8499),
    [anon_sym_EQ_EQ] = ACTIONS(8501),
    [anon_sym_BANG_EQ] = ACTIONS(8497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8497),
    [anon_sym_LT_EQ_GT] = ACTIONS(8497),
    [anon_sym_EQ_TILDE] = ACTIONS(8497),
    [anon_sym_BANG_TILDE] = ACTIONS(8497),
    [anon_sym_LT_EQ] = ACTIONS(8489),
    [anon_sym_GT] = ACTIONS(8489),
    [anon_sym_GT_EQ] = ACTIONS(8503),
    [anon_sym_CARET] = ACTIONS(8505),
    [anon_sym_PLUS] = ACTIONS(8481),
    [anon_sym_SLASH] = ACTIONS(8483),
    [anon_sym_PERCENT] = ACTIONS(8483),
    [sym_comment] = ACTIONS(87),
  },
  [10375] = {
    [aux_sym_exceptions_repeat1] = STATE(10375),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14525),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10376] = {
    [sym__line_break] = ACTIONS(7608),
    [sym__simple_symbol] = ACTIONS(7608),
    [sym__string_start] = ACTIONS(7608),
    [sym__symbol_start] = ACTIONS(7608),
    [sym__subshell_start] = ACTIONS(7608),
    [sym__regex_start] = ACTIONS(7608),
    [sym__string_array_start] = ACTIONS(7608),
    [sym__symbol_array_start] = ACTIONS(7608),
    [sym__heredoc_body_start] = ACTIONS(7608),
    [sym_heredoc_beginning] = ACTIONS(7608),
    [sym__block_ampersand] = ACTIONS(7608),
    [sym__splat_star] = ACTIONS(7608),
    [sym__unary_minus] = ACTIONS(7608),
    [sym__identifier_hash_key] = ACTIONS(7608),
    [anon_sym_LBRACE] = ACTIONS(7608),
    [anon_sym_def] = ACTIONS(7610),
    [anon_sym_LPAREN] = ACTIONS(7610),
    [anon_sym_DOT] = ACTIONS(7608),
    [anon_sym_COLON_COLON] = ACTIONS(7610),
    [anon_sym_SEMI] = ACTIONS(7608),
    [anon_sym_STAR] = ACTIONS(7610),
    [anon_sym_STAR_STAR] = ACTIONS(7608),
    [anon_sym_class] = ACTIONS(7610),
    [anon_sym_module] = ACTIONS(7610),
    [anon_sym_return] = ACTIONS(7610),
    [anon_sym_yield] = ACTIONS(7610),
    [anon_sym_break] = ACTIONS(7610),
    [anon_sym_next] = ACTIONS(7610),
    [sym_redo] = ACTIONS(7610),
    [sym_retry] = ACTIONS(7610),
    [anon_sym_if] = ACTIONS(7610),
    [anon_sym_unless] = ACTIONS(7610),
    [anon_sym_while] = ACTIONS(7610),
    [anon_sym_until] = ACTIONS(7610),
    [anon_sym_for] = ACTIONS(7610),
    [anon_sym_do] = ACTIONS(7610),
    [anon_sym_case] = ACTIONS(7610),
    [anon_sym_then] = ACTIONS(7610),
    [anon_sym_begin] = ACTIONS(7610),
    [anon_sym_LBRACK] = ACTIONS(7608),
    [anon_sym_COLON_COLON2] = ACTIONS(7608),
    [anon_sym_AMP_DOT] = ACTIONS(7608),
    [anon_sym_LPAREN2] = ACTIONS(7608),
    [anon_sym_PLUS] = ACTIONS(7610),
    [anon_sym_defined_QMARK] = ACTIONS(7608),
    [anon_sym_not] = ACTIONS(7610),
    [anon_sym_BANG] = ACTIONS(7608),
    [anon_sym_TILDE] = ACTIONS(7608),
    [sym_constant] = ACTIONS(7610),
    [sym_identifier] = ACTIONS(7610),
    [sym_instance_variable] = ACTIONS(7608),
    [sym_class_variable] = ACTIONS(7608),
    [sym_global_variable] = ACTIONS(7608),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7610),
    [sym_float] = ACTIONS(7610),
    [sym_complex] = ACTIONS(7608),
    [sym_super] = ACTIONS(7610),
    [anon_sym_true] = ACTIONS(7610),
    [anon_sym_TRUE] = ACTIONS(7610),
    [anon_sym_false] = ACTIONS(7610),
    [anon_sym_FALSE] = ACTIONS(7610),
    [sym_self] = ACTIONS(7610),
    [anon_sym_nil] = ACTIONS(7610),
    [anon_sym_NIL] = ACTIONS(7610),
    [sym_character] = ACTIONS(7608),
    [anon_sym_LBRACK2] = ACTIONS(7610),
    [anon_sym_DASH_GT] = ACTIONS(7608),
  },
  [10377] = {
    [anon_sym_RPAREN] = ACTIONS(14528),
    [sym_comment] = ACTIONS(87),
  },
  [10378] = {
    [sym__line_break] = ACTIONS(11825),
    [sym__heredoc_body_start] = ACTIONS(11825),
    [anon_sym_DOT] = ACTIONS(11825),
    [anon_sym_SEMI] = ACTIONS(11825),
    [anon_sym_then] = ACTIONS(11825),
    [anon_sym_LBRACK] = ACTIONS(11825),
    [anon_sym_COLON_COLON2] = ACTIONS(11825),
    [anon_sym_AMP_DOT] = ACTIONS(11825),
    [sym_comment] = ACTIONS(87),
  },
  [10379] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_then] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10380] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_then] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10381] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10795),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10795),
    [sym_operator_assignment] = STATE(10795),
    [sym_conditional] = STATE(10795),
    [sym_range] = STATE(10795),
    [sym_binary] = STATE(10795),
    [sym_unary] = STATE(10795),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10382] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_then] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10383] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10796),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(10796),
    [sym_operator_assignment] = STATE(10796),
    [sym_conditional] = STATE(10796),
    [sym_range] = STATE(10796),
    [sym_binary] = STATE(10796),
    [sym_unary] = STATE(10796),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10384] = {
    [sym_heredoc_body] = STATE(10797),
    [aux_sym_call_repeat1] = STATE(10797),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10385] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9472),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(9472),
    [sym_operator_assignment] = STATE(9472),
    [sym_conditional] = STATE(9472),
    [sym_range] = STATE(9472),
    [sym_binary] = STATE(9472),
    [sym_unary] = STATE(9472),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9475),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10798),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13000),
    [sym__splat_star] = ACTIONS(13002),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__identifier_hash_key] = ACTIONS(13004),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14530),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(13006),
    [sym_identifier] = ACTIONS(13006),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10386] = {
    [sym_heredoc_body] = STATE(10799),
    [aux_sym_call_repeat1] = STATE(10799),
    [aux_sym_argument_list_repeat1] = STATE(10800),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(13892),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_then] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10387] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10388] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10389] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10390] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10391] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10392] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14532),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10393] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_then] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10394] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10395] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10396] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_then] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10397] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_then] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10398] = {
    [aux_sym_exceptions_repeat1] = STATE(10803),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_then] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10399] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_then] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10400] = {
    [sym_string] = STATE(10400),
    [aux_sym_chained_string_repeat1] = STATE(10400),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_then] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [10401] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [10402] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [10403] = {
    [sym_heredoc_body] = STATE(10403),
    [aux_sym_call_repeat1] = STATE(10403),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10404] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(7913),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(7913),
    [sym_operator_assignment] = STATE(7913),
    [sym_conditional] = STATE(7913),
    [sym_range] = STATE(7913),
    [sym_binary] = STATE(7913),
    [sym_unary] = STATE(7913),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7916),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(11149),
    [sym__splat_star] = ACTIONS(11151),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__identifier_hash_key] = ACTIONS(11153),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13896),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(11157),
    [sym_identifier] = ACTIONS(11157),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10405] = {
    [sym_heredoc_body] = STATE(10403),
    [aux_sym_call_repeat1] = STATE(10403),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10406] = {
    [aux_sym_argument_list_repeat1] = STATE(10406),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14534),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [10407] = {
    [sym__line_break] = ACTIONS(10568),
    [sym__heredoc_body_start] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_DOT] = ACTIONS(10568),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_do] = ACTIONS(10568),
    [anon_sym_then] = ACTIONS(10568),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
  },
  [10408] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10804),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_assignment] = STATE(10804),
    [sym_operator_assignment] = STATE(10804),
    [sym_conditional] = STATE(10804),
    [sym_range] = STATE(10804),
    [sym_binary] = STATE(10804),
    [sym_unary] = STATE(10804),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10409] = {
    [sym__line_break] = ACTIONS(6547),
    [sym__heredoc_body_start] = ACTIONS(6547),
    [anon_sym_LBRACE] = ACTIONS(6547),
    [anon_sym_DOT] = ACTIONS(6547),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym_do] = ACTIONS(6547),
    [anon_sym_then] = ACTIONS(6547),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_COLON_COLON2] = ACTIONS(6547),
    [anon_sym_AMP_DOT] = ACTIONS(6547),
    [sym_comment] = ACTIONS(87),
  },
  [10410] = {
    [sym__line_break] = ACTIONS(10596),
    [sym__heredoc_body_start] = ACTIONS(10596),
    [anon_sym_LBRACE] = ACTIONS(10596),
    [anon_sym_DOT] = ACTIONS(10596),
    [anon_sym_COMMA] = ACTIONS(10596),
    [anon_sym_SEMI] = ACTIONS(10596),
    [anon_sym_do] = ACTIONS(10596),
    [anon_sym_then] = ACTIONS(10596),
    [anon_sym_LBRACK] = ACTIONS(10596),
    [anon_sym_COLON_COLON2] = ACTIONS(10596),
    [anon_sym_AMP_DOT] = ACTIONS(10596),
    [sym_comment] = ACTIONS(87),
  },
  [10411] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9519),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(9519),
    [sym_operator_assignment] = STATE(9519),
    [sym_conditional] = STATE(9519),
    [sym_range] = STATE(9519),
    [sym_binary] = STATE(9519),
    [sym_unary] = STATE(9519),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(7904),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(11151),
    [sym__unary_minus] = ACTIONS(8525),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(5028),
    [sym_identifier] = ACTIONS(5028),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10412] = {
    [aux_sym_exceptions_repeat1] = STATE(10805),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14537),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10413] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8567),
    [sym__binary_star] = ACTIONS(8569),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8571),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8573),
    [anon_sym_AMP] = ACTIONS(8575),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(8577),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8579),
    [anon_sym_DOT_DOT] = ACTIONS(8581),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8583),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8585),
    [anon_sym_AMP_AMP] = ACTIONS(8585),
    [anon_sym_LT_LT] = ACTIONS(8587),
    [anon_sym_GT_GT] = ACTIONS(8587),
    [anon_sym_EQ_EQ] = ACTIONS(8585),
    [anon_sym_BANG_EQ] = ACTIONS(8589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8589),
    [anon_sym_LT_EQ_GT] = ACTIONS(8589),
    [anon_sym_EQ_TILDE] = ACTIONS(8589),
    [anon_sym_BANG_TILDE] = ACTIONS(8589),
    [anon_sym_LT_EQ] = ACTIONS(8577),
    [anon_sym_GT] = ACTIONS(8577),
    [anon_sym_GT_EQ] = ACTIONS(8591),
    [anon_sym_CARET] = ACTIONS(8571),
    [anon_sym_PLUS] = ACTIONS(8593),
    [anon_sym_SLASH] = ACTIONS(8573),
    [anon_sym_PERCENT] = ACTIONS(8573),
    [sym_comment] = ACTIONS(87),
  },
  [10414] = {
    [aux_sym_exceptions_repeat1] = STATE(10414),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14539),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10415] = {
    [sym_heredoc_body] = STATE(10415),
    [aux_sym_call_repeat1] = STATE(10415),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_ensure] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10416] = {
    [sym_heredoc_body] = STATE(10415),
    [aux_sym_call_repeat1] = STATE(10415),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_ensure] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10417] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10806),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_assignment] = STATE(10806),
    [sym_operator_assignment] = STATE(10806),
    [sym_conditional] = STATE(10806),
    [sym_range] = STATE(10806),
    [sym_binary] = STATE(10806),
    [sym_unary] = STATE(10806),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10418] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9541),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5614),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5614),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(9541),
    [sym_operator_assignment] = STATE(9541),
    [sym_conditional] = STATE(9541),
    [sym_range] = STATE(9541),
    [sym_binary] = STATE(9541),
    [sym_unary] = STATE(9541),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(5613),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5614),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5614),
    [sym_false] = STATE(5614),
    [sym_nil] = STATE(5614),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5044),
    [sym__unary_minus] = ACTIONS(8609),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8619),
    [anon_sym_defined_QMARK] = ACTIONS(8621),
    [anon_sym_not] = ACTIONS(8623),
    [anon_sym_BANG] = ACTIONS(8625),
    [anon_sym_TILDE] = ACTIONS(8625),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10419] = {
    [aux_sym_exceptions_repeat1] = STATE(10807),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14542),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_ensure] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10420] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8641),
    [sym__binary_star] = ACTIONS(8643),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8645),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8643),
    [anon_sym_AMP] = ACTIONS(8647),
    [anon_sym_LT] = ACTIONS(8649),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8651),
    [anon_sym_DOT_DOT] = ACTIONS(8653),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8655),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8657),
    [anon_sym_AMP_AMP] = ACTIONS(8657),
    [anon_sym_LT_LT] = ACTIONS(8659),
    [anon_sym_GT_GT] = ACTIONS(8659),
    [anon_sym_EQ_EQ] = ACTIONS(8661),
    [anon_sym_BANG_EQ] = ACTIONS(8657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8657),
    [anon_sym_LT_EQ_GT] = ACTIONS(8657),
    [anon_sym_EQ_TILDE] = ACTIONS(8657),
    [anon_sym_BANG_TILDE] = ACTIONS(8657),
    [anon_sym_LT_EQ] = ACTIONS(8649),
    [anon_sym_GT] = ACTIONS(8649),
    [anon_sym_GT_EQ] = ACTIONS(8663),
    [anon_sym_CARET] = ACTIONS(8665),
    [anon_sym_PLUS] = ACTIONS(8641),
    [anon_sym_SLASH] = ACTIONS(8643),
    [anon_sym_PERCENT] = ACTIONS(8643),
    [sym_comment] = ACTIONS(87),
  },
  [10421] = {
    [aux_sym_exceptions_repeat1] = STATE(10421),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14544),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10422] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10808),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_assignment] = STATE(10808),
    [sym_operator_assignment] = STATE(10808),
    [sym_conditional] = STATE(10808),
    [sym_range] = STATE(10808),
    [sym_binary] = STATE(10808),
    [sym_unary] = STATE(10808),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10423] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9571),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5685),
    [sym_scope_resolution] = STATE(5683),
    [sym_call] = STATE(5683),
    [sym_method_call] = STATE(5685),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(9571),
    [sym_operator_assignment] = STATE(9571),
    [sym_conditional] = STATE(9571),
    [sym_range] = STATE(9571),
    [sym_binary] = STATE(9571),
    [sym_unary] = STATE(9571),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(5684),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5685),
    [sym__variable] = STATE(5683),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5685),
    [sym_false] = STATE(5685),
    [sym_nil] = STATE(5685),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5686),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(5118),
    [sym__unary_minus] = ACTIONS(8687),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8689),
    [anon_sym_yield] = ACTIONS(8691),
    [anon_sym_break] = ACTIONS(8693),
    [anon_sym_next] = ACTIONS(8695),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8697),
    [anon_sym_defined_QMARK] = ACTIONS(8699),
    [anon_sym_not] = ACTIONS(8701),
    [anon_sym_BANG] = ACTIONS(8703),
    [anon_sym_TILDE] = ACTIONS(8703),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(8707),
    [sym_class_variable] = ACTIONS(8707),
    [sym_global_variable] = ACTIONS(8707),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10424] = {
    [aux_sym_exceptions_repeat1] = STATE(10809),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14547),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_ensure] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10425] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8715),
    [sym__binary_star] = ACTIONS(8717),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8719),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8721),
    [anon_sym_AMP] = ACTIONS(8723),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(8725),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8727),
    [anon_sym_DOT_DOT] = ACTIONS(8729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8731),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8733),
    [anon_sym_AMP_AMP] = ACTIONS(8733),
    [anon_sym_LT_LT] = ACTIONS(8735),
    [anon_sym_GT_GT] = ACTIONS(8735),
    [anon_sym_EQ_EQ] = ACTIONS(8733),
    [anon_sym_BANG_EQ] = ACTIONS(8737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8737),
    [anon_sym_LT_EQ_GT] = ACTIONS(8737),
    [anon_sym_EQ_TILDE] = ACTIONS(8737),
    [anon_sym_BANG_TILDE] = ACTIONS(8737),
    [anon_sym_LT_EQ] = ACTIONS(8725),
    [anon_sym_GT] = ACTIONS(8725),
    [anon_sym_GT_EQ] = ACTIONS(8739),
    [anon_sym_CARET] = ACTIONS(8719),
    [anon_sym_PLUS] = ACTIONS(8741),
    [anon_sym_SLASH] = ACTIONS(8721),
    [anon_sym_PERCENT] = ACTIONS(8721),
    [sym_comment] = ACTIONS(87),
  },
  [10426] = {
    [aux_sym_exceptions_repeat1] = STATE(10426),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14549),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10427] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10810),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5717),
    [sym_scope_resolution] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_method_call] = STATE(5717),
    [sym_assignment] = STATE(10810),
    [sym_operator_assignment] = STATE(10810),
    [sym_conditional] = STATE(10810),
    [sym_range] = STATE(10810),
    [sym_binary] = STATE(10810),
    [sym_unary] = STATE(10810),
    [sym_left_assignment_list] = STATE(5716),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5717),
    [sym__variable] = STATE(1184),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5717),
    [sym_false] = STATE(5717),
    [sym_nil] = STATE(5717),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5615),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8755),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8611),
    [anon_sym_yield] = ACTIONS(8613),
    [anon_sym_break] = ACTIONS(8615),
    [anon_sym_next] = ACTIONS(8617),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8757),
    [anon_sym_defined_QMARK] = ACTIONS(8759),
    [anon_sym_not] = ACTIONS(8761),
    [anon_sym_BANG] = ACTIONS(8763),
    [anon_sym_TILDE] = ACTIONS(8763),
    [sym_constant] = ACTIONS(2133),
    [sym_identifier] = ACTIONS(2133),
    [sym_instance_variable] = ACTIONS(2135),
    [sym_class_variable] = ACTIONS(2135),
    [sym_global_variable] = ACTIONS(2135),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2133),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2133),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10428] = {
    [sym_heredoc_body] = STATE(10428),
    [aux_sym_call_repeat1] = STATE(10428),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10429] = {
    [sym_heredoc_body] = STATE(10428),
    [aux_sym_call_repeat1] = STATE(10428),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10430] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10811),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_assignment] = STATE(10811),
    [sym_operator_assignment] = STATE(10811),
    [sym_conditional] = STATE(10811),
    [sym_range] = STATE(10811),
    [sym_binary] = STATE(10811),
    [sym_unary] = STATE(10811),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10431] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(9603),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5729),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5729),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(9603),
    [sym_operator_assignment] = STATE(9603),
    [sym_conditional] = STATE(9603),
    [sym_range] = STATE(9603),
    [sym_binary] = STATE(9603),
    [sym_unary] = STATE(9603),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(5728),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5729),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5729),
    [sym_false] = STATE(5729),
    [sym_nil] = STATE(5729),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(5156),
    [sym__unary_minus] = ACTIONS(8767),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8777),
    [anon_sym_defined_QMARK] = ACTIONS(8779),
    [anon_sym_not] = ACTIONS(8781),
    [anon_sym_BANG] = ACTIONS(8783),
    [anon_sym_TILDE] = ACTIONS(8783),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10432] = {
    [aux_sym_exceptions_repeat1] = STATE(10812),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14552),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10433] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8799),
    [sym__binary_star] = ACTIONS(8801),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8803),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8801),
    [anon_sym_AMP] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(8807),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8809),
    [anon_sym_DOT_DOT] = ACTIONS(8811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8813),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8815),
    [anon_sym_AMP_AMP] = ACTIONS(8815),
    [anon_sym_LT_LT] = ACTIONS(8817),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_EQ_EQ] = ACTIONS(8819),
    [anon_sym_BANG_EQ] = ACTIONS(8815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8815),
    [anon_sym_LT_EQ_GT] = ACTIONS(8815),
    [anon_sym_EQ_TILDE] = ACTIONS(8815),
    [anon_sym_BANG_TILDE] = ACTIONS(8815),
    [anon_sym_LT_EQ] = ACTIONS(8807),
    [anon_sym_GT] = ACTIONS(8807),
    [anon_sym_GT_EQ] = ACTIONS(8821),
    [anon_sym_CARET] = ACTIONS(8823),
    [anon_sym_PLUS] = ACTIONS(8799),
    [anon_sym_SLASH] = ACTIONS(8801),
    [anon_sym_PERCENT] = ACTIONS(8801),
    [sym_comment] = ACTIONS(87),
  },
  [10434] = {
    [aux_sym_exceptions_repeat1] = STATE(10434),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14554),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10435] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10813),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_assignment] = STATE(10813),
    [sym_operator_assignment] = STATE(10813),
    [sym_conditional] = STATE(10813),
    [sym_range] = STATE(10813),
    [sym_binary] = STATE(10813),
    [sym_unary] = STATE(10813),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10436] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(9633),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(5800),
    [sym_scope_resolution] = STATE(5798),
    [sym_call] = STATE(5798),
    [sym_method_call] = STATE(5800),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(9633),
    [sym_operator_assignment] = STATE(9633),
    [sym_conditional] = STATE(9633),
    [sym_range] = STATE(9633),
    [sym_binary] = STATE(9633),
    [sym_unary] = STATE(9633),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(5799),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5800),
    [sym__variable] = STATE(5798),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(5800),
    [sym_false] = STATE(5800),
    [sym_nil] = STATE(5800),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(5801),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(5230),
    [sym__unary_minus] = ACTIONS(8845),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(8847),
    [anon_sym_yield] = ACTIONS(8849),
    [anon_sym_break] = ACTIONS(8851),
    [anon_sym_next] = ACTIONS(8853),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(8855),
    [anon_sym_defined_QMARK] = ACTIONS(8857),
    [anon_sym_not] = ACTIONS(8859),
    [anon_sym_BANG] = ACTIONS(8861),
    [anon_sym_TILDE] = ACTIONS(8861),
    [sym_constant] = ACTIONS(8863),
    [sym_identifier] = ACTIONS(8863),
    [sym_instance_variable] = ACTIONS(8865),
    [sym_class_variable] = ACTIONS(8865),
    [sym_global_variable] = ACTIONS(8865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(8863),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(8863),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10437] = {
    [aux_sym_exceptions_repeat1] = STATE(10814),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14557),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10438] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8873),
    [sym__binary_star] = ACTIONS(8875),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8877),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8879),
    [anon_sym_AMP] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(8883),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8885),
    [anon_sym_DOT_DOT] = ACTIONS(8887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8889),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8891),
    [anon_sym_AMP_AMP] = ACTIONS(8891),
    [anon_sym_LT_LT] = ACTIONS(8893),
    [anon_sym_GT_GT] = ACTIONS(8893),
    [anon_sym_EQ_EQ] = ACTIONS(8891),
    [anon_sym_BANG_EQ] = ACTIONS(8895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8895),
    [anon_sym_LT_EQ_GT] = ACTIONS(8895),
    [anon_sym_EQ_TILDE] = ACTIONS(8895),
    [anon_sym_BANG_TILDE] = ACTIONS(8895),
    [anon_sym_LT_EQ] = ACTIONS(8883),
    [anon_sym_GT] = ACTIONS(8883),
    [anon_sym_GT_EQ] = ACTIONS(8897),
    [anon_sym_CARET] = ACTIONS(8877),
    [anon_sym_PLUS] = ACTIONS(8899),
    [anon_sym_SLASH] = ACTIONS(8879),
    [anon_sym_PERCENT] = ACTIONS(8879),
    [sym_comment] = ACTIONS(87),
  },
  [10439] = {
    [aux_sym_exceptions_repeat1] = STATE(10439),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14559),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10440] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10815),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(5832),
    [sym_scope_resolution] = STATE(1201),
    [sym_call] = STATE(1201),
    [sym_method_call] = STATE(5832),
    [sym_assignment] = STATE(10815),
    [sym_operator_assignment] = STATE(10815),
    [sym_conditional] = STATE(10815),
    [sym_range] = STATE(10815),
    [sym_binary] = STATE(10815),
    [sym_unary] = STATE(10815),
    [sym_left_assignment_list] = STATE(5831),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5832),
    [sym__variable] = STATE(1201),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(5832),
    [sym_false] = STATE(5832),
    [sym_nil] = STATE(5832),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(5730),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(8913),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8769),
    [anon_sym_yield] = ACTIONS(8771),
    [anon_sym_break] = ACTIONS(8773),
    [anon_sym_next] = ACTIONS(8775),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8915),
    [anon_sym_defined_QMARK] = ACTIONS(8917),
    [anon_sym_not] = ACTIONS(8919),
    [anon_sym_BANG] = ACTIONS(8921),
    [anon_sym_TILDE] = ACTIONS(8921),
    [sym_constant] = ACTIONS(2159),
    [sym_identifier] = ACTIONS(2159),
    [sym_instance_variable] = ACTIONS(2161),
    [sym_class_variable] = ACTIONS(2161),
    [sym_global_variable] = ACTIONS(2161),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2159),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2159),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10441] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8934),
    [sym__binary_star] = ACTIONS(8936),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8938),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8940),
    [anon_sym_AMP] = ACTIONS(8942),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(8944),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8946),
    [anon_sym_DOT_DOT] = ACTIONS(8948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8950),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8952),
    [anon_sym_AMP_AMP] = ACTIONS(8952),
    [anon_sym_LT_LT] = ACTIONS(8954),
    [anon_sym_GT_GT] = ACTIONS(8954),
    [anon_sym_EQ_EQ] = ACTIONS(8952),
    [anon_sym_BANG_EQ] = ACTIONS(8956),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8956),
    [anon_sym_LT_EQ_GT] = ACTIONS(8956),
    [anon_sym_EQ_TILDE] = ACTIONS(8956),
    [anon_sym_BANG_TILDE] = ACTIONS(8956),
    [anon_sym_LT_EQ] = ACTIONS(8944),
    [anon_sym_GT] = ACTIONS(8944),
    [anon_sym_GT_EQ] = ACTIONS(8958),
    [anon_sym_CARET] = ACTIONS(8938),
    [anon_sym_PLUS] = ACTIONS(8960),
    [anon_sym_SLASH] = ACTIONS(8940),
    [anon_sym_PERCENT] = ACTIONS(8940),
    [sym_comment] = ACTIONS(87),
  },
  [10442] = {
    [aux_sym_exceptions_repeat1] = STATE(10442),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14562),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10443] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(8970),
    [sym__binary_star] = ACTIONS(8972),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(8974),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(8972),
    [anon_sym_AMP] = ACTIONS(8976),
    [anon_sym_LT] = ACTIONS(8978),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(8980),
    [anon_sym_DOT_DOT] = ACTIONS(8982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8984),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(8986),
    [anon_sym_AMP_AMP] = ACTIONS(8986),
    [anon_sym_LT_LT] = ACTIONS(8988),
    [anon_sym_GT_GT] = ACTIONS(8988),
    [anon_sym_EQ_EQ] = ACTIONS(8990),
    [anon_sym_BANG_EQ] = ACTIONS(8986),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8986),
    [anon_sym_LT_EQ_GT] = ACTIONS(8986),
    [anon_sym_EQ_TILDE] = ACTIONS(8986),
    [anon_sym_BANG_TILDE] = ACTIONS(8986),
    [anon_sym_LT_EQ] = ACTIONS(8978),
    [anon_sym_GT] = ACTIONS(8978),
    [anon_sym_GT_EQ] = ACTIONS(8992),
    [anon_sym_CARET] = ACTIONS(8994),
    [anon_sym_PLUS] = ACTIONS(8970),
    [anon_sym_SLASH] = ACTIONS(8972),
    [anon_sym_PERCENT] = ACTIONS(8972),
    [sym_comment] = ACTIONS(87),
  },
  [10444] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10816),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_assignment] = STATE(10816),
    [sym_operator_assignment] = STATE(10816),
    [sym_conditional] = STATE(10816),
    [sym_range] = STATE(10816),
    [sym_binary] = STATE(10816),
    [sym_unary] = STATE(10816),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10445] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9671),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(5909),
    [sym_scope_resolution] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_method_call] = STATE(5909),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(9671),
    [sym_operator_assignment] = STATE(9671),
    [sym_conditional] = STATE(9671),
    [sym_range] = STATE(9671),
    [sym_binary] = STATE(9671),
    [sym_unary] = STATE(9671),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(5908),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5909),
    [sym__variable] = STATE(1279),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(5909),
    [sym_false] = STATE(5909),
    [sym_nil] = STATE(5909),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(1282),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(5388),
    [sym__unary_minus] = ACTIONS(9029),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2289),
    [anon_sym_yield] = ACTIONS(2291),
    [anon_sym_break] = ACTIONS(2293),
    [anon_sym_next] = ACTIONS(2295),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9031),
    [anon_sym_defined_QMARK] = ACTIONS(9033),
    [anon_sym_not] = ACTIONS(9035),
    [anon_sym_BANG] = ACTIONS(9037),
    [anon_sym_TILDE] = ACTIONS(9037),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(2305),
    [sym_instance_variable] = ACTIONS(2307),
    [sym_class_variable] = ACTIONS(2307),
    [sym_global_variable] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(2305),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(2305),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10446] = {
    [aux_sym_exceptions_repeat1] = STATE(10817),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14565),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_RBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10447] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10818),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_assignment] = STATE(10818),
    [sym_operator_assignment] = STATE(10818),
    [sym_conditional] = STATE(10818),
    [sym_range] = STATE(10818),
    [sym_binary] = STATE(10818),
    [sym_unary] = STATE(10818),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10448] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9685),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(5937),
    [sym_scope_resolution] = STATE(5935),
    [sym_call] = STATE(5935),
    [sym_method_call] = STATE(5937),
    [sym_splat_argument] = STATE(10613),
    [sym_assignment] = STATE(9685),
    [sym_operator_assignment] = STATE(9685),
    [sym_conditional] = STATE(9685),
    [sym_range] = STATE(9685),
    [sym_binary] = STATE(9685),
    [sym_unary] = STATE(9685),
    [sym__arg_or_splat_arg] = STATE(10613),
    [sym_left_assignment_list] = STATE(5936),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5937),
    [sym__variable] = STATE(5935),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(5937),
    [sym_false] = STATE(5937),
    [sym_nil] = STATE(5937),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(5938),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(5424),
    [sym__unary_minus] = ACTIONS(9047),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9049),
    [anon_sym_yield] = ACTIONS(9051),
    [anon_sym_break] = ACTIONS(9053),
    [anon_sym_next] = ACTIONS(9055),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9057),
    [anon_sym_defined_QMARK] = ACTIONS(9059),
    [anon_sym_not] = ACTIONS(9061),
    [anon_sym_BANG] = ACTIONS(9063),
    [anon_sym_TILDE] = ACTIONS(9063),
    [sym_constant] = ACTIONS(9065),
    [sym_identifier] = ACTIONS(9065),
    [sym_instance_variable] = ACTIONS(9067),
    [sym_class_variable] = ACTIONS(9067),
    [sym_global_variable] = ACTIONS(9067),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9065),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9065),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10449] = {
    [aux_sym_exceptions_repeat1] = STATE(10819),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14567),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_RBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10450] = {
    [sym__heredoc_body_start] = ACTIONS(13660),
    [sym__binary_minus] = ACTIONS(13660),
    [sym__binary_star] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_RBRACE] = ACTIONS(13660),
    [anon_sym_RPAREN] = ACTIONS(13660),
    [anon_sym_DOT] = ACTIONS(13662),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_PIPE] = ACTIONS(13662),
    [anon_sym_SEMI] = ACTIONS(13660),
    [anon_sym_STAR_STAR] = ACTIONS(13660),
    [anon_sym_AMP] = ACTIONS(13662),
    [anon_sym_EQ] = ACTIONS(13662),
    [anon_sym_LT] = ACTIONS(13662),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_unless] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [anon_sym_until] = ACTIONS(13660),
    [anon_sym_rescue] = ACTIONS(13660),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_do] = ACTIONS(13660),
    [anon_sym_EQ_GT] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_RBRACK] = ACTIONS(13660),
    [anon_sym_COLON_COLON2] = ACTIONS(13660),
    [anon_sym_AMP_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13662),
    [anon_sym_DOT_DOT] = ACTIONS(13662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_and] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE] = ACTIONS(13660),
    [anon_sym_AMP_AMP] = ACTIONS(13660),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_EQ_EQ] = ACTIONS(13662),
    [anon_sym_BANG_EQ] = ACTIONS(13660),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13660),
    [anon_sym_LT_EQ_GT] = ACTIONS(13660),
    [anon_sym_EQ_TILDE] = ACTIONS(13660),
    [anon_sym_BANG_TILDE] = ACTIONS(13660),
    [anon_sym_LT_EQ] = ACTIONS(13662),
    [anon_sym_GT] = ACTIONS(13662),
    [anon_sym_GT_EQ] = ACTIONS(13660),
    [anon_sym_CARET] = ACTIONS(13660),
    [anon_sym_PLUS] = ACTIONS(13660),
    [anon_sym_SLASH] = ACTIONS(13660),
    [anon_sym_PERCENT] = ACTIONS(13660),
    [sym_comment] = ACTIONS(87),
  },
  [10451] = {
    [sym__heredoc_body_start] = ACTIONS(14146),
    [sym__binary_minus] = ACTIONS(14146),
    [sym__binary_star] = ACTIONS(14146),
    [anon_sym_LBRACE] = ACTIONS(14146),
    [anon_sym_RBRACE] = ACTIONS(14146),
    [anon_sym_RPAREN] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14148),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14148),
    [anon_sym_SEMI] = ACTIONS(14146),
    [anon_sym_STAR_STAR] = ACTIONS(14146),
    [anon_sym_AMP] = ACTIONS(14148),
    [anon_sym_EQ] = ACTIONS(14148),
    [anon_sym_LT] = ACTIONS(14148),
    [anon_sym_if] = ACTIONS(14146),
    [anon_sym_unless] = ACTIONS(14146),
    [anon_sym_while] = ACTIONS(14146),
    [anon_sym_until] = ACTIONS(14146),
    [anon_sym_rescue] = ACTIONS(14146),
    [anon_sym_in] = ACTIONS(14146),
    [anon_sym_do] = ACTIONS(14146),
    [anon_sym_EQ_GT] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_RBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [anon_sym_QMARK] = ACTIONS(14146),
    [anon_sym_COLON2] = ACTIONS(14148),
    [anon_sym_DOT_DOT] = ACTIONS(14148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14146),
    [anon_sym_and] = ACTIONS(14146),
    [anon_sym_or] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE] = ACTIONS(14146),
    [anon_sym_AMP_AMP] = ACTIONS(14146),
    [anon_sym_LT_LT] = ACTIONS(14146),
    [anon_sym_GT_GT] = ACTIONS(14146),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_BANG_EQ] = ACTIONS(14146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14146),
    [anon_sym_LT_EQ_GT] = ACTIONS(14146),
    [anon_sym_EQ_TILDE] = ACTIONS(14146),
    [anon_sym_BANG_TILDE] = ACTIONS(14146),
    [anon_sym_LT_EQ] = ACTIONS(14148),
    [anon_sym_GT] = ACTIONS(14148),
    [anon_sym_GT_EQ] = ACTIONS(14146),
    [anon_sym_CARET] = ACTIONS(14146),
    [anon_sym_PLUS] = ACTIONS(14146),
    [anon_sym_SLASH] = ACTIONS(14146),
    [anon_sym_PERCENT] = ACTIONS(14146),
    [sym_comment] = ACTIONS(87),
  },
  [10452] = {
    [sym__heredoc_body_start] = ACTIONS(14146),
    [sym__binary_minus] = ACTIONS(14146),
    [sym__binary_star] = ACTIONS(14146),
    [anon_sym_LBRACE] = ACTIONS(14146),
    [anon_sym_RBRACE] = ACTIONS(14146),
    [anon_sym_RPAREN] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14148),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14148),
    [anon_sym_SEMI] = ACTIONS(14146),
    [anon_sym_STAR_STAR] = ACTIONS(14148),
    [anon_sym_AMP] = ACTIONS(14148),
    [anon_sym_EQ] = ACTIONS(14148),
    [anon_sym_LT] = ACTIONS(14148),
    [anon_sym_if] = ACTIONS(14146),
    [anon_sym_unless] = ACTIONS(14146),
    [anon_sym_while] = ACTIONS(14146),
    [anon_sym_until] = ACTIONS(14146),
    [anon_sym_rescue] = ACTIONS(14146),
    [anon_sym_in] = ACTIONS(14146),
    [anon_sym_do] = ACTIONS(14146),
    [anon_sym_EQ_GT] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_RBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [anon_sym_PLUS_EQ] = ACTIONS(14146),
    [anon_sym_DASH_EQ] = ACTIONS(14146),
    [anon_sym_STAR_EQ] = ACTIONS(14146),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14146),
    [anon_sym_SLASH_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14146),
    [anon_sym_AMP_EQ] = ACTIONS(14146),
    [anon_sym_PERCENT_EQ] = ACTIONS(14146),
    [anon_sym_GT_GT_EQ] = ACTIONS(14146),
    [anon_sym_LT_LT_EQ] = ACTIONS(14146),
    [anon_sym_CARET_EQ] = ACTIONS(14146),
    [anon_sym_QMARK] = ACTIONS(14146),
    [anon_sym_COLON2] = ACTIONS(14148),
    [anon_sym_DOT_DOT] = ACTIONS(14148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14146),
    [anon_sym_and] = ACTIONS(14146),
    [anon_sym_or] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE] = ACTIONS(14148),
    [anon_sym_AMP_AMP] = ACTIONS(14148),
    [anon_sym_LT_LT] = ACTIONS(14148),
    [anon_sym_GT_GT] = ACTIONS(14148),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_BANG_EQ] = ACTIONS(14146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14146),
    [anon_sym_LT_EQ_GT] = ACTIONS(14146),
    [anon_sym_EQ_TILDE] = ACTIONS(14146),
    [anon_sym_BANG_TILDE] = ACTIONS(14146),
    [anon_sym_LT_EQ] = ACTIONS(14148),
    [anon_sym_GT] = ACTIONS(14148),
    [anon_sym_GT_EQ] = ACTIONS(14146),
    [anon_sym_CARET] = ACTIONS(14148),
    [anon_sym_PLUS] = ACTIONS(14148),
    [anon_sym_SLASH] = ACTIONS(14148),
    [anon_sym_PERCENT] = ACTIONS(14148),
    [sym_comment] = ACTIONS(87),
  },
  [10453] = {
    [sym__simple_symbol] = ACTIONS(14569),
    [sym__string_start] = ACTIONS(14569),
    [sym__symbol_start] = ACTIONS(14569),
    [sym__subshell_start] = ACTIONS(14569),
    [sym__regex_start] = ACTIONS(14569),
    [sym__string_array_start] = ACTIONS(14569),
    [sym__symbol_array_start] = ACTIONS(14569),
    [sym_heredoc_beginning] = ACTIONS(14569),
    [sym__unary_minus] = ACTIONS(14569),
    [anon_sym_BEGIN] = ACTIONS(14571),
    [anon_sym_LBRACE] = ACTIONS(14569),
    [anon_sym_RBRACE] = ACTIONS(14569),
    [anon_sym_END] = ACTIONS(14571),
    [anon_sym_def] = ACTIONS(14571),
    [anon_sym_LPAREN] = ACTIONS(14569),
    [anon_sym_COLON_COLON] = ACTIONS(14569),
    [anon_sym_SEMI] = ACTIONS(14569),
    [anon_sym_STAR] = ACTIONS(14569),
    [anon_sym_class] = ACTIONS(14571),
    [anon_sym_module] = ACTIONS(14571),
    [anon_sym_return] = ACTIONS(14571),
    [anon_sym_yield] = ACTIONS(14571),
    [anon_sym_break] = ACTIONS(14571),
    [anon_sym_next] = ACTIONS(14571),
    [sym_redo] = ACTIONS(14571),
    [sym_retry] = ACTIONS(14571),
    [anon_sym_if] = ACTIONS(14571),
    [anon_sym_unless] = ACTIONS(14571),
    [anon_sym_while] = ACTIONS(14571),
    [anon_sym_until] = ACTIONS(14571),
    [anon_sym_for] = ACTIONS(14571),
    [anon_sym_case] = ACTIONS(14571),
    [anon_sym_begin] = ACTIONS(14571),
    [anon_sym_PLUS] = ACTIONS(14571),
    [anon_sym_defined_QMARK] = ACTIONS(14569),
    [anon_sym_not] = ACTIONS(14571),
    [anon_sym_BANG] = ACTIONS(14569),
    [anon_sym_TILDE] = ACTIONS(14569),
    [sym_constant] = ACTIONS(14571),
    [sym_identifier] = ACTIONS(14571),
    [sym_instance_variable] = ACTIONS(14569),
    [sym_class_variable] = ACTIONS(14569),
    [sym_global_variable] = ACTIONS(14569),
    [anon_sym_undef] = ACTIONS(14571),
    [anon_sym_alias] = ACTIONS(14571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(14571),
    [sym_float] = ACTIONS(14571),
    [sym_complex] = ACTIONS(14569),
    [sym_super] = ACTIONS(14571),
    [anon_sym_true] = ACTIONS(14571),
    [anon_sym_TRUE] = ACTIONS(14571),
    [anon_sym_false] = ACTIONS(14571),
    [anon_sym_FALSE] = ACTIONS(14571),
    [sym_self] = ACTIONS(14571),
    [anon_sym_nil] = ACTIONS(14571),
    [anon_sym_NIL] = ACTIONS(14571),
    [sym_character] = ACTIONS(14569),
    [anon_sym_LBRACK2] = ACTIONS(14569),
    [anon_sym_DASH_GT] = ACTIONS(14569),
  },
  [10454] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10820),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(10820),
    [sym_operator_assignment] = STATE(10820),
    [sym_conditional] = STATE(10820),
    [sym_range] = STATE(10820),
    [sym_binary] = STATE(10820),
    [sym_unary] = STATE(10820),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10455] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9723),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(1312),
    [sym__argument_list_with_parens] = STATE(9725),
    [sym__argument] = STATE(9726),
    [sym_splat_argument] = STATE(9726),
    [sym_hash_splat_argument] = STATE(9726),
    [sym_block_argument] = STATE(9726),
    [sym_assignment] = STATE(9723),
    [sym_operator_assignment] = STATE(9723),
    [sym_conditional] = STATE(9723),
    [sym_range] = STATE(9723),
    [sym_binary] = STATE(9723),
    [sym_unary] = STATE(9723),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(9729),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(9726),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13153),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(13159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13177),
    [sym_identifier] = ACTIONS(13177),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10456] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9723),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(1318),
    [sym__argument_list_with_parens] = STATE(9725),
    [sym__argument] = STATE(9726),
    [sym_splat_argument] = STATE(9726),
    [sym_hash_splat_argument] = STATE(9726),
    [sym_block_argument] = STATE(9726),
    [sym_assignment] = STATE(9723),
    [sym_operator_assignment] = STATE(9723),
    [sym_conditional] = STATE(9723),
    [sym_range] = STATE(9723),
    [sym_binary] = STATE(9723),
    [sym_unary] = STATE(9723),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(9729),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(9726),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13153),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(13159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13177),
    [sym_identifier] = ACTIONS(13177),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10457] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9723),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(1319),
    [sym__argument_list_with_parens] = STATE(9725),
    [sym__argument] = STATE(9726),
    [sym_splat_argument] = STATE(9726),
    [sym_hash_splat_argument] = STATE(9726),
    [sym_block_argument] = STATE(9726),
    [sym_assignment] = STATE(9723),
    [sym_operator_assignment] = STATE(9723),
    [sym_conditional] = STATE(9723),
    [sym_range] = STATE(9723),
    [sym_binary] = STATE(9723),
    [sym_unary] = STATE(9723),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(9729),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(9726),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13153),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(13159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13177),
    [sym_identifier] = ACTIONS(13177),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10458] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9723),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_argument_list] = STATE(1320),
    [sym__argument_list_with_parens] = STATE(9725),
    [sym__argument] = STATE(9726),
    [sym_splat_argument] = STATE(9726),
    [sym_hash_splat_argument] = STATE(9726),
    [sym_block_argument] = STATE(9726),
    [sym_assignment] = STATE(9723),
    [sym_operator_assignment] = STATE(9723),
    [sym_conditional] = STATE(9723),
    [sym_range] = STATE(9723),
    [sym_binary] = STATE(9723),
    [sym_unary] = STATE(9723),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(9729),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(9726),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13153),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(13159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13173),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13177),
    [sym_identifier] = ACTIONS(13177),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1081),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10459] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10821),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(10821),
    [sym_operator_assignment] = STATE(10821),
    [sym_conditional] = STATE(10821),
    [sym_range] = STATE(10821),
    [sym_binary] = STATE(10821),
    [sym_unary] = STATE(10821),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10460] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10461] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(14583),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [10462] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(1827),
    [sym__argument_list_with_parens] = STATE(9755),
    [sym__argument] = STATE(9756),
    [sym_splat_argument] = STATE(9756),
    [sym_hash_splat_argument] = STATE(9756),
    [sym_block_argument] = STATE(9756),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9759),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9756),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13211),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(13217),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13235),
    [sym_identifier] = ACTIONS(13235),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10463] = {
    [anon_sym_EQ] = ACTIONS(14599),
    [sym_comment] = ACTIONS(87),
  },
  [10464] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14601),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14603),
    [anon_sym_DASH_EQ] = ACTIONS(14603),
    [anon_sym_STAR_EQ] = ACTIONS(14603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14603),
    [anon_sym_SLASH_EQ] = ACTIONS(14603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14603),
    [anon_sym_PIPE_EQ] = ACTIONS(14603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14603),
    [anon_sym_AMP_EQ] = ACTIONS(14603),
    [anon_sym_PERCENT_EQ] = ACTIONS(14603),
    [anon_sym_GT_GT_EQ] = ACTIONS(14603),
    [anon_sym_LT_LT_EQ] = ACTIONS(14603),
    [anon_sym_CARET_EQ] = ACTIONS(14603),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10465] = {
    [sym_string] = STATE(10834),
    [aux_sym_chained_string_repeat1] = STATE(10834),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10466] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(14583),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [10467] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [10468] = {
    [sym_string] = STATE(10506),
    [aux_sym_chained_string_repeat1] = STATE(10506),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10469] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10835),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(10835),
    [sym_operator_assignment] = STATE(10835),
    [sym_conditional] = STATE(10835),
    [sym_range] = STATE(10835),
    [sym_binary] = STATE(10835),
    [sym_unary] = STATE(10835),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10470] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(14583),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [10471] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10836),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10836),
    [sym_operator_assignment] = STATE(10836),
    [sym_conditional] = STATE(10836),
    [sym_range] = STATE(10836),
    [sym_binary] = STATE(10836),
    [sym_unary] = STATE(10836),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10472] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10837),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10837),
    [sym_operator_assignment] = STATE(10837),
    [sym_conditional] = STATE(10837),
    [sym_range] = STATE(10837),
    [sym_binary] = STATE(10837),
    [sym_unary] = STATE(10837),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10473] = {
    [anon_sym_COLON] = ACTIONS(14605),
    [sym_comment] = ACTIONS(87),
  },
  [10474] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10839),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10839),
    [sym_operator_assignment] = STATE(10839),
    [sym_conditional] = STATE(10839),
    [sym_range] = STATE(10839),
    [sym_binary] = STATE(10839),
    [sym_unary] = STATE(10839),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10475] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14607),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [10476] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10477] = {
    [sym_heredoc_body] = STATE(10841),
    [aux_sym_call_repeat1] = STATE(10841),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [10478] = {
    [sym_heredoc_body] = STATE(10841),
    [aux_sym_call_repeat1] = STATE(10841),
    [aux_sym_argument_list_repeat1] = STATE(10843),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(14609),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [10479] = {
    [sym_string] = STATE(10506),
    [aux_sym_chained_string_repeat1] = STATE(10506),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14611),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10480] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10481] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10844),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(10844),
    [sym_operator_assignment] = STATE(10844),
    [sym_conditional] = STATE(10844),
    [sym_range] = STATE(10844),
    [sym_binary] = STATE(10844),
    [sym_unary] = STATE(10844),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10482] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10845),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10845),
    [sym_operator_assignment] = STATE(10845),
    [sym_conditional] = STATE(10845),
    [sym_range] = STATE(10845),
    [sym_binary] = STATE(10845),
    [sym_unary] = STATE(10845),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10483] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10846),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10846),
    [sym_operator_assignment] = STATE(10846),
    [sym_conditional] = STATE(10846),
    [sym_range] = STATE(10846),
    [sym_binary] = STATE(10846),
    [sym_unary] = STATE(10846),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10484] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10847),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10847),
    [sym_operator_assignment] = STATE(10847),
    [sym_conditional] = STATE(10847),
    [sym_range] = STATE(10847),
    [sym_binary] = STATE(10847),
    [sym_unary] = STATE(10847),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10485] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10848),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10848),
    [sym_operator_assignment] = STATE(10848),
    [sym_conditional] = STATE(10848),
    [sym_range] = STATE(10848),
    [sym_binary] = STATE(10848),
    [sym_unary] = STATE(10848),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10486] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10849),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10849),
    [sym_operator_assignment] = STATE(10849),
    [sym_conditional] = STATE(10849),
    [sym_range] = STATE(10849),
    [sym_binary] = STATE(10849),
    [sym_unary] = STATE(10849),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10487] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10850),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10850),
    [sym_operator_assignment] = STATE(10850),
    [sym_conditional] = STATE(10850),
    [sym_range] = STATE(10850),
    [sym_binary] = STATE(10850),
    [sym_unary] = STATE(10850),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10488] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10851),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10851),
    [sym_operator_assignment] = STATE(10851),
    [sym_conditional] = STATE(10851),
    [sym_range] = STATE(10851),
    [sym_binary] = STATE(10851),
    [sym_unary] = STATE(10851),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10489] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10852),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10852),
    [sym_operator_assignment] = STATE(10852),
    [sym_conditional] = STATE(10852),
    [sym_range] = STATE(10852),
    [sym_binary] = STATE(10852),
    [sym_unary] = STATE(10852),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10490] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10853),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10853),
    [sym_operator_assignment] = STATE(10853),
    [sym_conditional] = STATE(10853),
    [sym_range] = STATE(10853),
    [sym_binary] = STATE(10853),
    [sym_unary] = STATE(10853),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10491] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10854),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10854),
    [sym_operator_assignment] = STATE(10854),
    [sym_conditional] = STATE(10854),
    [sym_range] = STATE(10854),
    [sym_binary] = STATE(10854),
    [sym_unary] = STATE(10854),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10492] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10855),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10855),
    [sym_operator_assignment] = STATE(10855),
    [sym_conditional] = STATE(10855),
    [sym_range] = STATE(10855),
    [sym_binary] = STATE(10855),
    [sym_unary] = STATE(10855),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10493] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10856),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10856),
    [sym_operator_assignment] = STATE(10856),
    [sym_conditional] = STATE(10856),
    [sym_range] = STATE(10856),
    [sym_binary] = STATE(10856),
    [sym_unary] = STATE(10856),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10494] = {
    [anon_sym_COLON] = ACTIONS(14613),
    [sym_comment] = ACTIONS(87),
  },
  [10495] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10858),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10858),
    [sym_operator_assignment] = STATE(10858),
    [sym_conditional] = STATE(10858),
    [sym_range] = STATE(10858),
    [sym_binary] = STATE(10858),
    [sym_unary] = STATE(10858),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10496] = {
    [sym__simple_symbol] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
    [sym__symbol_start] = ACTIONS(1089),
    [sym__subshell_start] = ACTIONS(1089),
    [sym__regex_start] = ACTIONS(1089),
    [sym__string_array_start] = ACTIONS(1089),
    [sym__symbol_array_start] = ACTIONS(1089),
    [sym__heredoc_body_start] = ACTIONS(1089),
    [sym_heredoc_beginning] = ACTIONS(1089),
    [sym__block_ampersand] = ACTIONS(1089),
    [sym__splat_star] = ACTIONS(1089),
    [sym__unary_minus] = ACTIONS(1089),
    [sym__binary_minus] = ACTIONS(1089),
    [sym__binary_star] = ACTIONS(1089),
    [sym__identifier_hash_key] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_COLON_COLON] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(14615),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_next] = ACTIONS(1091),
    [sym_redo] = ACTIONS(1091),
    [sym_retry] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_unless] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_until] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_begin] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_COLON_COLON2] = ACTIONS(1089),
    [anon_sym_AMP_DOT] = ACTIONS(1089),
    [anon_sym_LPAREN2] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1091),
    [anon_sym_DOT_DOT] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1091),
    [anon_sym_AMP_AMP] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_LT_EQ_GT] = ACTIONS(1089),
    [anon_sym_EQ_TILDE] = ACTIONS(1089),
    [anon_sym_BANG_TILDE] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_defined_QMARK] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [sym_constant] = ACTIONS(1091),
    [sym_identifier] = ACTIONS(1091),
    [sym_instance_variable] = ACTIONS(1089),
    [sym_class_variable] = ACTIONS(1089),
    [sym_global_variable] = ACTIONS(1089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1091),
    [sym_complex] = ACTIONS(1089),
    [sym_super] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_TRUE] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_FALSE] = ACTIONS(1091),
    [sym_self] = ACTIONS(1091),
    [anon_sym_nil] = ACTIONS(1091),
    [anon_sym_NIL] = ACTIONS(1091),
    [sym_character] = ACTIONS(1089),
    [anon_sym_LBRACK2] = ACTIONS(1091),
    [anon_sym_DASH_GT] = ACTIONS(1089),
  },
  [10497] = {
    [sym__heredoc_body_start] = ACTIONS(1627),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_EQ_GT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_COLON_COLON2] = ACTIONS(1627),
    [anon_sym_AMP_DOT] = ACTIONS(1627),
    [anon_sym_PLUS_EQ] = ACTIONS(1627),
    [anon_sym_DASH_EQ] = ACTIONS(1627),
    [anon_sym_STAR_EQ] = ACTIONS(1627),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1627),
    [anon_sym_SLASH_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_PIPE_EQ] = ACTIONS(1627),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1627),
    [anon_sym_AMP_EQ] = ACTIONS(1627),
    [anon_sym_PERCENT_EQ] = ACTIONS(1627),
    [anon_sym_GT_GT_EQ] = ACTIONS(1627),
    [anon_sym_LT_LT_EQ] = ACTIONS(1627),
    [anon_sym_CARET_EQ] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(1627),
    [anon_sym_or] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10498] = {
    [sym_heredoc_body] = STATE(10860),
    [aux_sym_call_repeat1] = STATE(10860),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [10499] = {
    [sym_heredoc_body] = STATE(10860),
    [aux_sym_call_repeat1] = STATE(10860),
    [aux_sym_argument_list_repeat1] = STATE(10862),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(14617),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_EQ] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_do] = ACTIONS(1683),
    [anon_sym_EQ_GT] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_STAR_EQ] = ACTIONS(1683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1683),
    [anon_sym_SLASH_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1683),
    [anon_sym_AMP_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT_EQ] = ACTIONS(1683),
    [anon_sym_GT_GT_EQ] = ACTIONS(1683),
    [anon_sym_LT_LT_EQ] = ACTIONS(1683),
    [anon_sym_CARET_EQ] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1687),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(1687),
    [sym_comment] = ACTIONS(87),
  },
  [10500] = {
    [sym_string] = STATE(10551),
    [aux_sym_chained_string_repeat1] = STATE(10551),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14619),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10501] = {
    [sym_heredoc_body] = STATE(10863),
    [aux_sym_call_repeat1] = STATE(10863),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10502] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9723),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(9723),
    [sym_operator_assignment] = STATE(9723),
    [sym_conditional] = STATE(9723),
    [sym_range] = STATE(9723),
    [sym_binary] = STATE(9723),
    [sym_unary] = STATE(9723),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(9729),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(10864),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13153),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__identifier_hash_key] = ACTIONS(13159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14621),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13177),
    [sym_identifier] = ACTIONS(13177),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10503] = {
    [sym_heredoc_body] = STATE(10865),
    [aux_sym_call_repeat1] = STATE(10865),
    [aux_sym_argument_list_repeat1] = STATE(10866),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(14060),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10504] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10867),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_splat_argument] = STATE(10868),
    [sym_assignment] = STATE(10867),
    [sym_operator_assignment] = STATE(10867),
    [sym_conditional] = STATE(10867),
    [sym_range] = STATE(10867),
    [sym_binary] = STATE(10867),
    [sym_unary] = STATE(10867),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(10868),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(14018),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10505] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10869),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(10869),
    [sym_operator_assignment] = STATE(10869),
    [sym_conditional] = STATE(10869),
    [sym_range] = STATE(10869),
    [sym_binary] = STATE(10869),
    [sym_unary] = STATE(10869),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10506] = {
    [sym_string] = STATE(10870),
    [aux_sym_chained_string_repeat1] = STATE(10870),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [10507] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10508] = {
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10509] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10510] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10511] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14070),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10512] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14623),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10513] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(14070),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(13191),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(13195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13197),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(13201),
    [anon_sym_AMP_AMP] = ACTIONS(13201),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(13205),
    [anon_sym_BANG_EQ] = ACTIONS(13201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13201),
    [anon_sym_LT_EQ_GT] = ACTIONS(13201),
    [anon_sym_EQ_TILDE] = ACTIONS(13201),
    [anon_sym_BANG_TILDE] = ACTIONS(13201),
    [anon_sym_LT_EQ] = ACTIONS(13191),
    [anon_sym_GT] = ACTIONS(13191),
    [anon_sym_GT_EQ] = ACTIONS(13207),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10514] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14070),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(13191),
    [anon_sym_QMARK] = ACTIONS(13193),
    [anon_sym_DOT_DOT] = ACTIONS(13195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13197),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(13201),
    [anon_sym_AMP_AMP] = ACTIONS(13201),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(13205),
    [anon_sym_BANG_EQ] = ACTIONS(13201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13201),
    [anon_sym_LT_EQ_GT] = ACTIONS(13201),
    [anon_sym_EQ_TILDE] = ACTIONS(13201),
    [anon_sym_BANG_TILDE] = ACTIONS(13201),
    [anon_sym_LT_EQ] = ACTIONS(13191),
    [anon_sym_GT] = ACTIONS(13191),
    [anon_sym_GT_EQ] = ACTIONS(13207),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10515] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14070),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(13191),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(13205),
    [anon_sym_BANG_EQ] = ACTIONS(13201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13201),
    [anon_sym_LT_EQ_GT] = ACTIONS(13201),
    [anon_sym_EQ_TILDE] = ACTIONS(13201),
    [anon_sym_BANG_TILDE] = ACTIONS(13201),
    [anon_sym_LT_EQ] = ACTIONS(13191),
    [anon_sym_GT] = ACTIONS(13191),
    [anon_sym_GT_EQ] = ACTIONS(13207),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10516] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10517] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10872),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(10872),
    [sym_operator_assignment] = STATE(10872),
    [sym_conditional] = STATE(10872),
    [sym_range] = STATE(10872),
    [sym_binary] = STATE(10872),
    [sym_unary] = STATE(10872),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10518] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(6452),
    [sym__argument_list_with_parens] = STATE(9755),
    [sym__argument] = STATE(9756),
    [sym_splat_argument] = STATE(9756),
    [sym_hash_splat_argument] = STATE(9756),
    [sym_block_argument] = STATE(9756),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9759),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9756),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(363),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13211),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(363),
    [sym__binary_star] = ACTIONS(363),
    [sym__identifier_hash_key] = ACTIONS(13217),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13235),
    [sym_identifier] = ACTIONS(13235),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10519] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(6453),
    [sym__argument_list_with_parens] = STATE(9755),
    [sym__argument] = STATE(9756),
    [sym_splat_argument] = STATE(9756),
    [sym_hash_splat_argument] = STATE(9756),
    [sym_block_argument] = STATE(9756),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9759),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9756),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(415),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13211),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(415),
    [sym__binary_star] = ACTIONS(415),
    [sym__identifier_hash_key] = ACTIONS(13217),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13235),
    [sym_identifier] = ACTIONS(13235),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10520] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(6454),
    [sym__argument_list_with_parens] = STATE(9755),
    [sym__argument] = STATE(9756),
    [sym_splat_argument] = STATE(9756),
    [sym_hash_splat_argument] = STATE(9756),
    [sym_block_argument] = STATE(9756),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9759),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9756),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(419),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13211),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(419),
    [sym__binary_star] = ACTIONS(419),
    [sym__identifier_hash_key] = ACTIONS(13217),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13235),
    [sym_identifier] = ACTIONS(13235),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10521] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(6455),
    [sym__argument_list_with_parens] = STATE(9755),
    [sym__argument] = STATE(9756),
    [sym_splat_argument] = STATE(9756),
    [sym_hash_splat_argument] = STATE(9756),
    [sym_block_argument] = STATE(9756),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9759),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9756),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(423),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13211),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(423),
    [sym__binary_star] = ACTIONS(423),
    [sym__identifier_hash_key] = ACTIONS(13217),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13235),
    [sym_identifier] = ACTIONS(13235),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10522] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10873),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(10873),
    [sym_operator_assignment] = STATE(10873),
    [sym_conditional] = STATE(10873),
    [sym_range] = STATE(10873),
    [sym_binary] = STATE(10873),
    [sym_unary] = STATE(10873),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10523] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(6470),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(6470),
    [sym_operator_assignment] = STATE(6470),
    [sym_conditional] = STATE(6470),
    [sym_range] = STATE(6470),
    [sym_binary] = STATE(6470),
    [sym_unary] = STATE(6470),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10524] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(14637),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [10525] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_argument_list] = STATE(4737),
    [sym__argument_list_with_parens] = STATE(9755),
    [sym__argument] = STATE(9756),
    [sym_splat_argument] = STATE(9756),
    [sym_hash_splat_argument] = STATE(9756),
    [sym_block_argument] = STATE(9756),
    [sym_do_block] = STATE(1830),
    [sym_block] = STATE(1830),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9759),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(9756),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(745),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13211),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__binary_minus] = ACTIONS(745),
    [sym__binary_star] = ACTIONS(745),
    [sym__identifier_hash_key] = ACTIONS(13217),
    [anon_sym_LBRACE] = ACTIONS(7471),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(771),
    [anon_sym_COLON_COLON] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_PIPE] = ACTIONS(771),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(771),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(745),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(745),
    [anon_sym_LPAREN2] = ACTIONS(2873),
    [anon_sym_PLUS_EQ] = ACTIONS(745),
    [anon_sym_DASH_EQ] = ACTIONS(745),
    [anon_sym_STAR_EQ] = ACTIONS(745),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(745),
    [anon_sym_SLASH_EQ] = ACTIONS(745),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(745),
    [anon_sym_PIPE_EQ] = ACTIONS(745),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(745),
    [anon_sym_AMP_EQ] = ACTIONS(745),
    [anon_sym_PERCENT_EQ] = ACTIONS(745),
    [anon_sym_GT_GT_EQ] = ACTIONS(745),
    [anon_sym_LT_LT_EQ] = ACTIONS(745),
    [anon_sym_CARET_EQ] = ACTIONS(745),
    [anon_sym_QMARK] = ACTIONS(771),
    [anon_sym_DOT_DOT] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(745),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_PIPE_PIPE] = ACTIONS(771),
    [anon_sym_AMP_AMP] = ACTIONS(771),
    [anon_sym_LT_LT] = ACTIONS(771),
    [anon_sym_GT_GT] = ACTIONS(771),
    [anon_sym_EQ_EQ] = ACTIONS(771),
    [anon_sym_BANG_EQ] = ACTIONS(745),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(745),
    [anon_sym_LT_EQ_GT] = ACTIONS(745),
    [anon_sym_EQ_TILDE] = ACTIONS(745),
    [anon_sym_BANG_TILDE] = ACTIONS(745),
    [anon_sym_LT_EQ] = ACTIONS(771),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_GT_EQ] = ACTIONS(745),
    [anon_sym_CARET] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(771),
    [anon_sym_PERCENT] = ACTIONS(771),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13231),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13235),
    [sym_identifier] = ACTIONS(13235),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(1217),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10526] = {
    [anon_sym_EQ] = ACTIONS(14653),
    [sym_comment] = ACTIONS(87),
  },
  [10527] = {
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14655),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14657),
    [anon_sym_DASH_EQ] = ACTIONS(14657),
    [anon_sym_STAR_EQ] = ACTIONS(14657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14657),
    [anon_sym_SLASH_EQ] = ACTIONS(14657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14657),
    [anon_sym_PIPE_EQ] = ACTIONS(14657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14657),
    [anon_sym_AMP_EQ] = ACTIONS(14657),
    [anon_sym_PERCENT_EQ] = ACTIONS(14657),
    [anon_sym_GT_GT_EQ] = ACTIONS(14657),
    [anon_sym_LT_LT_EQ] = ACTIONS(14657),
    [anon_sym_CARET_EQ] = ACTIONS(14657),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10528] = {
    [sym_string] = STATE(10886),
    [aux_sym_chained_string_repeat1] = STATE(10886),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10529] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(14637),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [10530] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [10531] = {
    [sym_string] = STATE(10551),
    [aux_sym_chained_string_repeat1] = STATE(10551),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(559),
    [sym__binary_minus] = ACTIONS(559),
    [sym__binary_star] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10532] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10887),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(10887),
    [sym_operator_assignment] = STATE(10887),
    [sym_conditional] = STATE(10887),
    [sym_range] = STATE(10887),
    [sym_binary] = STATE(10887),
    [sym_unary] = STATE(10887),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10533] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(14637),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [10534] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_EQ_GT] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10535] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10888),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(10888),
    [sym_operator_assignment] = STATE(10888),
    [sym_conditional] = STATE(10888),
    [sym_range] = STATE(10888),
    [sym_binary] = STATE(10888),
    [sym_unary] = STATE(10888),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10536] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10889),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10889),
    [sym_operator_assignment] = STATE(10889),
    [sym_conditional] = STATE(10889),
    [sym_range] = STATE(10889),
    [sym_binary] = STATE(10889),
    [sym_unary] = STATE(10889),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10537] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10890),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10890),
    [sym_operator_assignment] = STATE(10890),
    [sym_conditional] = STATE(10890),
    [sym_range] = STATE(10890),
    [sym_binary] = STATE(10890),
    [sym_unary] = STATE(10890),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10538] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10891),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10891),
    [sym_operator_assignment] = STATE(10891),
    [sym_conditional] = STATE(10891),
    [sym_range] = STATE(10891),
    [sym_binary] = STATE(10891),
    [sym_unary] = STATE(10891),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10539] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10892),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10892),
    [sym_operator_assignment] = STATE(10892),
    [sym_conditional] = STATE(10892),
    [sym_range] = STATE(10892),
    [sym_binary] = STATE(10892),
    [sym_unary] = STATE(10892),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10540] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10893),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10893),
    [sym_operator_assignment] = STATE(10893),
    [sym_conditional] = STATE(10893),
    [sym_range] = STATE(10893),
    [sym_binary] = STATE(10893),
    [sym_unary] = STATE(10893),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10541] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10894),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10894),
    [sym_operator_assignment] = STATE(10894),
    [sym_conditional] = STATE(10894),
    [sym_range] = STATE(10894),
    [sym_binary] = STATE(10894),
    [sym_unary] = STATE(10894),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10542] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10895),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10895),
    [sym_operator_assignment] = STATE(10895),
    [sym_conditional] = STATE(10895),
    [sym_range] = STATE(10895),
    [sym_binary] = STATE(10895),
    [sym_unary] = STATE(10895),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10543] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10896),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10896),
    [sym_operator_assignment] = STATE(10896),
    [sym_conditional] = STATE(10896),
    [sym_range] = STATE(10896),
    [sym_binary] = STATE(10896),
    [sym_unary] = STATE(10896),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10544] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10897),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10897),
    [sym_operator_assignment] = STATE(10897),
    [sym_conditional] = STATE(10897),
    [sym_range] = STATE(10897),
    [sym_binary] = STATE(10897),
    [sym_unary] = STATE(10897),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10545] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10898),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10898),
    [sym_operator_assignment] = STATE(10898),
    [sym_conditional] = STATE(10898),
    [sym_range] = STATE(10898),
    [sym_binary] = STATE(10898),
    [sym_unary] = STATE(10898),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10546] = {
    [sym_heredoc_body] = STATE(10899),
    [aux_sym_call_repeat1] = STATE(10899),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [10547] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym__argument] = STATE(6514),
    [sym_splat_argument] = STATE(6514),
    [sym_hash_splat_argument] = STATE(6514),
    [sym_block_argument] = STATE(6514),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9759),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(10900),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6514),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13211),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__identifier_hash_key] = ACTIONS(13217),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14659),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13235),
    [sym_identifier] = ACTIONS(13235),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10548] = {
    [sym_heredoc_body] = STATE(10901),
    [aux_sym_call_repeat1] = STATE(10901),
    [aux_sym_argument_list_repeat1] = STATE(10902),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(14128),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [10549] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10903),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_splat_argument] = STATE(10904),
    [sym_assignment] = STATE(10903),
    [sym_operator_assignment] = STATE(10903),
    [sym_conditional] = STATE(10903),
    [sym_range] = STATE(10903),
    [sym_binary] = STATE(10903),
    [sym_unary] = STATE(10903),
    [sym_right_assignment_list] = STATE(4290),
    [sym__arg_or_splat_arg] = STATE(10904),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(14054),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10550] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10905),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(10905),
    [sym_operator_assignment] = STATE(10905),
    [sym_conditional] = STATE(10905),
    [sym_range] = STATE(10905),
    [sym_binary] = STATE(10905),
    [sym_unary] = STATE(10905),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10551] = {
    [sym_string] = STATE(10906),
    [aux_sym_chained_string_repeat1] = STATE(10906),
    [sym__string_start] = ACTIONS(1141),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_EQ_GT] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [10552] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10907),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(10907),
    [sym_operator_assignment] = STATE(10907),
    [sym_conditional] = STATE(10907),
    [sym_range] = STATE(10907),
    [sym_binary] = STATE(10907),
    [sym_unary] = STATE(10907),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10553] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(14070),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(13191),
    [anon_sym_QMARK] = ACTIONS(13193),
    [anon_sym_DOT_DOT] = ACTIONS(13195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13197),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(13201),
    [anon_sym_AMP_AMP] = ACTIONS(13201),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(13205),
    [anon_sym_BANG_EQ] = ACTIONS(13201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13201),
    [anon_sym_LT_EQ_GT] = ACTIONS(13201),
    [anon_sym_EQ_TILDE] = ACTIONS(13201),
    [anon_sym_BANG_TILDE] = ACTIONS(13201),
    [anon_sym_LT_EQ] = ACTIONS(13191),
    [anon_sym_GT] = ACTIONS(13191),
    [anon_sym_GT_EQ] = ACTIONS(13207),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10554] = {
    [aux_sym_exceptions_repeat1] = STATE(10909),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10555] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(14070),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(13191),
    [anon_sym_QMARK] = ACTIONS(13193),
    [anon_sym_DOT_DOT] = ACTIONS(13195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13197),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(13201),
    [anon_sym_AMP_AMP] = ACTIONS(13201),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(13205),
    [anon_sym_BANG_EQ] = ACTIONS(13201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13201),
    [anon_sym_LT_EQ_GT] = ACTIONS(13201),
    [anon_sym_EQ_TILDE] = ACTIONS(13201),
    [anon_sym_BANG_TILDE] = ACTIONS(13201),
    [anon_sym_LT_EQ] = ACTIONS(13191),
    [anon_sym_GT] = ACTIONS(13191),
    [anon_sym_GT_EQ] = ACTIONS(13207),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10556] = {
    [sym_string] = STATE(10556),
    [aux_sym_chained_string_repeat1] = STATE(10556),
    [sym__string_start] = ACTIONS(6891),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [10557] = {
    [aux_sym_block_parameters_repeat1] = STATE(9709),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(14661),
    [sym_comment] = ACTIONS(87),
  },
  [10558] = {
    [aux_sym_block_parameters_repeat1] = STATE(10911),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(14661),
    [sym_comment] = ACTIONS(87),
  },
  [10559] = {
    [sym__line_break] = ACTIONS(14569),
    [sym__simple_symbol] = ACTIONS(14569),
    [sym__string_start] = ACTIONS(14569),
    [sym__symbol_start] = ACTIONS(14569),
    [sym__subshell_start] = ACTIONS(14569),
    [sym__regex_start] = ACTIONS(14569),
    [sym__string_array_start] = ACTIONS(14569),
    [sym__symbol_array_start] = ACTIONS(14569),
    [sym__heredoc_body_start] = ACTIONS(14569),
    [sym_heredoc_beginning] = ACTIONS(14569),
    [sym__unary_minus] = ACTIONS(14569),
    [anon_sym_BEGIN] = ACTIONS(14571),
    [anon_sym_LBRACE] = ACTIONS(14569),
    [anon_sym_END] = ACTIONS(14571),
    [anon_sym_def] = ACTIONS(14571),
    [anon_sym_LPAREN] = ACTIONS(14569),
    [anon_sym_COLON_COLON] = ACTIONS(14569),
    [anon_sym_SEMI] = ACTIONS(14569),
    [anon_sym_STAR] = ACTIONS(14569),
    [anon_sym_class] = ACTIONS(14571),
    [anon_sym_module] = ACTIONS(14571),
    [anon_sym_end] = ACTIONS(14571),
    [anon_sym_return] = ACTIONS(14571),
    [anon_sym_yield] = ACTIONS(14571),
    [anon_sym_break] = ACTIONS(14571),
    [anon_sym_next] = ACTIONS(14571),
    [sym_redo] = ACTIONS(14571),
    [sym_retry] = ACTIONS(14571),
    [anon_sym_if] = ACTIONS(14571),
    [anon_sym_unless] = ACTIONS(14571),
    [anon_sym_while] = ACTIONS(14571),
    [anon_sym_until] = ACTIONS(14571),
    [anon_sym_for] = ACTIONS(14571),
    [anon_sym_case] = ACTIONS(14571),
    [anon_sym_begin] = ACTIONS(14571),
    [anon_sym_PLUS] = ACTIONS(14571),
    [anon_sym_defined_QMARK] = ACTIONS(14569),
    [anon_sym_not] = ACTIONS(14571),
    [anon_sym_BANG] = ACTIONS(14569),
    [anon_sym_TILDE] = ACTIONS(14569),
    [sym_constant] = ACTIONS(14571),
    [sym_identifier] = ACTIONS(14571),
    [sym_instance_variable] = ACTIONS(14569),
    [sym_class_variable] = ACTIONS(14569),
    [sym_global_variable] = ACTIONS(14569),
    [anon_sym_undef] = ACTIONS(14571),
    [anon_sym_alias] = ACTIONS(14571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(14571),
    [sym_float] = ACTIONS(14571),
    [sym_complex] = ACTIONS(14569),
    [sym_super] = ACTIONS(14571),
    [anon_sym_true] = ACTIONS(14571),
    [anon_sym_TRUE] = ACTIONS(14571),
    [anon_sym_false] = ACTIONS(14571),
    [anon_sym_FALSE] = ACTIONS(14571),
    [sym_self] = ACTIONS(14571),
    [anon_sym_nil] = ACTIONS(14571),
    [anon_sym_NIL] = ACTIONS(14571),
    [sym_character] = ACTIONS(14569),
    [anon_sym_LBRACK2] = ACTIONS(14569),
    [anon_sym_DASH_GT] = ACTIONS(14569),
  },
  [10560] = {
    [aux_sym_block_parameters_repeat1] = STATE(9709),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(14663),
    [sym_comment] = ACTIONS(87),
  },
  [10561] = {
    [aux_sym_block_parameters_repeat1] = STATE(10913),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(14663),
    [sym_comment] = ACTIONS(87),
  },
  [10562] = {
    [sym__binary_minus] = ACTIONS(9202),
    [sym__binary_star] = ACTIONS(9204),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9208),
    [anon_sym_STAR_STAR] = ACTIONS(9204),
    [anon_sym_AMP] = ACTIONS(9210),
    [anon_sym_LT] = ACTIONS(9212),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(9214),
    [anon_sym_DOT_DOT] = ACTIONS(9216),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9218),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(9222),
    [anon_sym_AMP_AMP] = ACTIONS(9222),
    [anon_sym_LT_LT] = ACTIONS(9224),
    [anon_sym_GT_GT] = ACTIONS(9224),
    [anon_sym_EQ_EQ] = ACTIONS(9226),
    [anon_sym_BANG_EQ] = ACTIONS(9222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9222),
    [anon_sym_LT_EQ_GT] = ACTIONS(9222),
    [anon_sym_EQ_TILDE] = ACTIONS(9222),
    [anon_sym_BANG_TILDE] = ACTIONS(9222),
    [anon_sym_LT_EQ] = ACTIONS(9212),
    [anon_sym_GT] = ACTIONS(9212),
    [anon_sym_GT_EQ] = ACTIONS(9228),
    [anon_sym_CARET] = ACTIONS(9230),
    [anon_sym_PLUS] = ACTIONS(9202),
    [anon_sym_SLASH] = ACTIONS(9204),
    [anon_sym_PERCENT] = ACTIONS(9204),
    [sym_comment] = ACTIONS(87),
  },
  [10563] = {
    [aux_sym_exceptions_repeat1] = STATE(10563),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(14665),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10564] = {
    [sym_heredoc_body] = STATE(10564),
    [aux_sym_call_repeat1] = STATE(10564),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_COLON2] = ACTIONS(7651),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10565] = {
    [sym_heredoc_body] = STATE(10564),
    [aux_sym_call_repeat1] = STATE(10564),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_COLON2] = ACTIONS(7663),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10566] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(10914),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_assignment] = STATE(10914),
    [sym_operator_assignment] = STATE(10914),
    [sym_conditional] = STATE(10914),
    [sym_range] = STATE(10914),
    [sym_binary] = STATE(10914),
    [sym_unary] = STATE(10914),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10567] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(9787),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(6093),
    [sym_scope_resolution] = STATE(6091),
    [sym_call] = STATE(6091),
    [sym_method_call] = STATE(6093),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(9787),
    [sym_operator_assignment] = STATE(9787),
    [sym_conditional] = STATE(9787),
    [sym_range] = STATE(9787),
    [sym_binary] = STATE(9787),
    [sym_unary] = STATE(9787),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(6092),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6093),
    [sym__variable] = STATE(6091),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(6093),
    [sym_false] = STATE(6093),
    [sym_nil] = STATE(6093),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(6094),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(3870),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(5704),
    [sym__unary_minus] = ACTIONS(9251),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9253),
    [anon_sym_yield] = ACTIONS(9255),
    [anon_sym_break] = ACTIONS(9257),
    [anon_sym_next] = ACTIONS(9259),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9261),
    [anon_sym_defined_QMARK] = ACTIONS(9263),
    [anon_sym_not] = ACTIONS(9265),
    [anon_sym_BANG] = ACTIONS(9267),
    [anon_sym_TILDE] = ACTIONS(9267),
    [sym_constant] = ACTIONS(9269),
    [sym_identifier] = ACTIONS(9269),
    [sym_instance_variable] = ACTIONS(9271),
    [sym_class_variable] = ACTIONS(9271),
    [sym_global_variable] = ACTIONS(9271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(9269),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9269),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10568] = {
    [aux_sym_exceptions_repeat1] = STATE(10915),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14668),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_COLON2] = ACTIONS(9605),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10569] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(9289),
    [sym__binary_star] = ACTIONS(9291),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9293),
    [anon_sym_STAR_STAR] = ACTIONS(9291),
    [anon_sym_AMP] = ACTIONS(9295),
    [anon_sym_LT] = ACTIONS(9297),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(9299),
    [anon_sym_COLON2] = ACTIONS(12409),
    [anon_sym_DOT_DOT] = ACTIONS(9301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9303),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(9305),
    [anon_sym_AMP_AMP] = ACTIONS(9305),
    [anon_sym_LT_LT] = ACTIONS(9307),
    [anon_sym_GT_GT] = ACTIONS(9307),
    [anon_sym_EQ_EQ] = ACTIONS(9309),
    [anon_sym_BANG_EQ] = ACTIONS(9305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9305),
    [anon_sym_LT_EQ_GT] = ACTIONS(9305),
    [anon_sym_EQ_TILDE] = ACTIONS(9305),
    [anon_sym_BANG_TILDE] = ACTIONS(9305),
    [anon_sym_LT_EQ] = ACTIONS(9297),
    [anon_sym_GT] = ACTIONS(9297),
    [anon_sym_GT_EQ] = ACTIONS(9311),
    [anon_sym_CARET] = ACTIONS(9313),
    [anon_sym_PLUS] = ACTIONS(9289),
    [anon_sym_SLASH] = ACTIONS(9291),
    [anon_sym_PERCENT] = ACTIONS(9291),
    [sym_comment] = ACTIONS(87),
  },
  [10570] = {
    [aux_sym_exceptions_repeat1] = STATE(10570),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14670),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11972),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10571] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10916),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_assignment] = STATE(10916),
    [sym_operator_assignment] = STATE(10916),
    [sym_conditional] = STATE(10916),
    [sym_range] = STATE(10916),
    [sym_binary] = STATE(10916),
    [sym_unary] = STATE(10916),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10572] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(9818),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(6158),
    [sym_scope_resolution] = STATE(6156),
    [sym_call] = STATE(6156),
    [sym_method_call] = STATE(6158),
    [sym_splat_argument] = STATE(10613),
    [sym_assignment] = STATE(9818),
    [sym_operator_assignment] = STATE(9818),
    [sym_conditional] = STATE(9818),
    [sym_range] = STATE(9818),
    [sym_binary] = STATE(9818),
    [sym_unary] = STATE(9818),
    [sym__arg_or_splat_arg] = STATE(10613),
    [sym_left_assignment_list] = STATE(6157),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6158),
    [sym__variable] = STATE(6156),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(6158),
    [sym_false] = STATE(6158),
    [sym_nil] = STATE(6158),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(6159),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(5764),
    [sym__unary_minus] = ACTIONS(9333),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(9335),
    [anon_sym_yield] = ACTIONS(9337),
    [anon_sym_break] = ACTIONS(9339),
    [anon_sym_next] = ACTIONS(9341),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(9343),
    [anon_sym_defined_QMARK] = ACTIONS(9345),
    [anon_sym_not] = ACTIONS(9347),
    [anon_sym_BANG] = ACTIONS(9349),
    [anon_sym_TILDE] = ACTIONS(9349),
    [sym_constant] = ACTIONS(9351),
    [sym_identifier] = ACTIONS(9351),
    [sym_instance_variable] = ACTIONS(9353),
    [sym_class_variable] = ACTIONS(9353),
    [sym_global_variable] = ACTIONS(9353),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(9351),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(9351),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10573] = {
    [aux_sym_exceptions_repeat1] = STATE(10917),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14673),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_COLON2] = ACTIONS(9605),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10574] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(9363),
    [sym__binary_star] = ACTIONS(9365),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9367),
    [anon_sym_STAR_STAR] = ACTIONS(9369),
    [anon_sym_AMP] = ACTIONS(9371),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(9373),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(9375),
    [anon_sym_COLON2] = ACTIONS(12409),
    [anon_sym_DOT_DOT] = ACTIONS(9377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9379),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(9381),
    [anon_sym_AMP_AMP] = ACTIONS(9381),
    [anon_sym_LT_LT] = ACTIONS(9383),
    [anon_sym_GT_GT] = ACTIONS(9383),
    [anon_sym_EQ_EQ] = ACTIONS(9381),
    [anon_sym_BANG_EQ] = ACTIONS(9385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9385),
    [anon_sym_LT_EQ_GT] = ACTIONS(9385),
    [anon_sym_EQ_TILDE] = ACTIONS(9385),
    [anon_sym_BANG_TILDE] = ACTIONS(9385),
    [anon_sym_LT_EQ] = ACTIONS(9373),
    [anon_sym_GT] = ACTIONS(9373),
    [anon_sym_GT_EQ] = ACTIONS(9387),
    [anon_sym_CARET] = ACTIONS(9367),
    [anon_sym_PLUS] = ACTIONS(9389),
    [anon_sym_SLASH] = ACTIONS(9369),
    [anon_sym_PERCENT] = ACTIONS(9369),
    [sym_comment] = ACTIONS(87),
  },
  [10575] = {
    [aux_sym_exceptions_repeat1] = STATE(10575),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14675),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11972),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10576] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10918),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(6195),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(6195),
    [sym_assignment] = STATE(10918),
    [sym_operator_assignment] = STATE(10918),
    [sym_conditional] = STATE(10918),
    [sym_range] = STATE(10918),
    [sym_binary] = STATE(10918),
    [sym_unary] = STATE(10918),
    [sym_left_assignment_list] = STATE(6194),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6195),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(6195),
    [sym_false] = STATE(6195),
    [sym_nil] = STATE(6195),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(6196),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(9403),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9405),
    [anon_sym_yield] = ACTIONS(9407),
    [anon_sym_break] = ACTIONS(9409),
    [anon_sym_next] = ACTIONS(9411),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9413),
    [anon_sym_defined_QMARK] = ACTIONS(9415),
    [anon_sym_not] = ACTIONS(9417),
    [anon_sym_BANG] = ACTIONS(9419),
    [anon_sym_TILDE] = ACTIONS(9419),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10577] = {
    [sym__line_break] = ACTIONS(12069),
    [sym__heredoc_body_start] = ACTIONS(12069),
    [sym__binary_minus] = ACTIONS(12069),
    [sym__binary_star] = ACTIONS(12069),
    [ts_builtin_sym_end] = ACTIONS(12069),
    [anon_sym___END__] = ACTIONS(12069),
    [anon_sym_LBRACE] = ACTIONS(12069),
    [anon_sym_RBRACE] = ACTIONS(12069),
    [anon_sym_RPAREN] = ACTIONS(12069),
    [anon_sym_DOT] = ACTIONS(12071),
    [anon_sym_COMMA] = ACTIONS(12069),
    [anon_sym_PIPE] = ACTIONS(12071),
    [anon_sym_SEMI] = ACTIONS(12069),
    [anon_sym_STAR_STAR] = ACTIONS(12071),
    [anon_sym_AMP] = ACTIONS(12071),
    [anon_sym_EQ] = ACTIONS(12071),
    [anon_sym_LT] = ACTIONS(12071),
    [anon_sym_end] = ACTIONS(12069),
    [anon_sym_if] = ACTIONS(12069),
    [anon_sym_unless] = ACTIONS(12069),
    [anon_sym_while] = ACTIONS(12069),
    [anon_sym_until] = ACTIONS(12069),
    [anon_sym_rescue] = ACTIONS(12069),
    [anon_sym_do] = ACTIONS(12069),
    [anon_sym_when] = ACTIONS(12069),
    [anon_sym_elsif] = ACTIONS(12069),
    [anon_sym_else] = ACTIONS(12069),
    [anon_sym_then] = ACTIONS(12069),
    [anon_sym_ensure] = ACTIONS(12069),
    [anon_sym_LBRACK] = ACTIONS(12069),
    [anon_sym_COLON_COLON2] = ACTIONS(12069),
    [anon_sym_AMP_DOT] = ACTIONS(12069),
    [anon_sym_PLUS_EQ] = ACTIONS(12069),
    [anon_sym_DASH_EQ] = ACTIONS(12069),
    [anon_sym_STAR_EQ] = ACTIONS(12069),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12069),
    [anon_sym_SLASH_EQ] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12069),
    [anon_sym_PIPE_EQ] = ACTIONS(12069),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12069),
    [anon_sym_AMP_EQ] = ACTIONS(12069),
    [anon_sym_PERCENT_EQ] = ACTIONS(12069),
    [anon_sym_GT_GT_EQ] = ACTIONS(12069),
    [anon_sym_LT_LT_EQ] = ACTIONS(12069),
    [anon_sym_CARET_EQ] = ACTIONS(12069),
    [anon_sym_QMARK] = ACTIONS(12069),
    [anon_sym_DOT_DOT] = ACTIONS(12071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12069),
    [anon_sym_and] = ACTIONS(12069),
    [anon_sym_or] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE] = ACTIONS(12071),
    [anon_sym_AMP_AMP] = ACTIONS(12071),
    [anon_sym_LT_LT] = ACTIONS(12071),
    [anon_sym_GT_GT] = ACTIONS(12071),
    [anon_sym_EQ_EQ] = ACTIONS(12071),
    [anon_sym_BANG_EQ] = ACTIONS(12069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12069),
    [anon_sym_LT_EQ_GT] = ACTIONS(12069),
    [anon_sym_EQ_TILDE] = ACTIONS(12069),
    [anon_sym_BANG_TILDE] = ACTIONS(12069),
    [anon_sym_LT_EQ] = ACTIONS(12071),
    [anon_sym_GT] = ACTIONS(12071),
    [anon_sym_GT_EQ] = ACTIONS(12069),
    [anon_sym_CARET] = ACTIONS(12071),
    [anon_sym_PLUS] = ACTIONS(12071),
    [anon_sym_SLASH] = ACTIONS(12071),
    [anon_sym_PERCENT] = ACTIONS(12071),
    [sym_comment] = ACTIONS(87),
  },
  [10578] = {
    [sym__line_break] = ACTIONS(12073),
    [sym__heredoc_body_start] = ACTIONS(12073),
    [sym__binary_minus] = ACTIONS(12073),
    [sym__binary_star] = ACTIONS(12073),
    [ts_builtin_sym_end] = ACTIONS(12073),
    [anon_sym___END__] = ACTIONS(12073),
    [anon_sym_LBRACE] = ACTIONS(12073),
    [anon_sym_RBRACE] = ACTIONS(12073),
    [anon_sym_RPAREN] = ACTIONS(12073),
    [anon_sym_DOT] = ACTIONS(12075),
    [anon_sym_COMMA] = ACTIONS(12073),
    [anon_sym_PIPE] = ACTIONS(12075),
    [anon_sym_SEMI] = ACTIONS(12073),
    [anon_sym_STAR_STAR] = ACTIONS(12075),
    [anon_sym_AMP] = ACTIONS(12075),
    [anon_sym_EQ] = ACTIONS(12075),
    [anon_sym_LT] = ACTIONS(12075),
    [anon_sym_end] = ACTIONS(12073),
    [anon_sym_if] = ACTIONS(12073),
    [anon_sym_unless] = ACTIONS(12073),
    [anon_sym_while] = ACTIONS(12073),
    [anon_sym_until] = ACTIONS(12073),
    [anon_sym_rescue] = ACTIONS(12073),
    [anon_sym_do] = ACTIONS(12073),
    [anon_sym_when] = ACTIONS(12073),
    [anon_sym_elsif] = ACTIONS(12073),
    [anon_sym_else] = ACTIONS(12073),
    [anon_sym_then] = ACTIONS(12073),
    [anon_sym_ensure] = ACTIONS(12073),
    [anon_sym_LBRACK] = ACTIONS(12073),
    [anon_sym_COLON_COLON2] = ACTIONS(12073),
    [anon_sym_AMP_DOT] = ACTIONS(12073),
    [anon_sym_PLUS_EQ] = ACTIONS(12073),
    [anon_sym_DASH_EQ] = ACTIONS(12073),
    [anon_sym_STAR_EQ] = ACTIONS(12073),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12073),
    [anon_sym_SLASH_EQ] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12073),
    [anon_sym_PIPE_EQ] = ACTIONS(12073),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12073),
    [anon_sym_AMP_EQ] = ACTIONS(12073),
    [anon_sym_PERCENT_EQ] = ACTIONS(12073),
    [anon_sym_GT_GT_EQ] = ACTIONS(12073),
    [anon_sym_LT_LT_EQ] = ACTIONS(12073),
    [anon_sym_CARET_EQ] = ACTIONS(12073),
    [anon_sym_QMARK] = ACTIONS(12073),
    [anon_sym_DOT_DOT] = ACTIONS(12075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12073),
    [anon_sym_and] = ACTIONS(12073),
    [anon_sym_or] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE] = ACTIONS(12075),
    [anon_sym_AMP_AMP] = ACTIONS(12075),
    [anon_sym_LT_LT] = ACTIONS(12075),
    [anon_sym_GT_GT] = ACTIONS(12075),
    [anon_sym_EQ_EQ] = ACTIONS(12075),
    [anon_sym_BANG_EQ] = ACTIONS(12073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12073),
    [anon_sym_LT_EQ_GT] = ACTIONS(12073),
    [anon_sym_EQ_TILDE] = ACTIONS(12073),
    [anon_sym_BANG_TILDE] = ACTIONS(12073),
    [anon_sym_LT_EQ] = ACTIONS(12075),
    [anon_sym_GT] = ACTIONS(12075),
    [anon_sym_GT_EQ] = ACTIONS(12073),
    [anon_sym_CARET] = ACTIONS(12075),
    [anon_sym_PLUS] = ACTIONS(12075),
    [anon_sym_SLASH] = ACTIONS(12075),
    [anon_sym_PERCENT] = ACTIONS(12075),
    [sym_comment] = ACTIONS(87),
  },
  [10579] = {
    [sym__line_break] = ACTIONS(12187),
    [sym__heredoc_body_start] = ACTIONS(12187),
    [sym__binary_minus] = ACTIONS(12187),
    [sym__binary_star] = ACTIONS(12187),
    [ts_builtin_sym_end] = ACTIONS(12187),
    [anon_sym___END__] = ACTIONS(12187),
    [anon_sym_LBRACE] = ACTIONS(12187),
    [anon_sym_RBRACE] = ACTIONS(12187),
    [anon_sym_RPAREN] = ACTIONS(12187),
    [anon_sym_DOT] = ACTIONS(12189),
    [anon_sym_COMMA] = ACTIONS(12187),
    [anon_sym_PIPE] = ACTIONS(12189),
    [anon_sym_SEMI] = ACTIONS(12187),
    [anon_sym_STAR_STAR] = ACTIONS(12189),
    [anon_sym_AMP] = ACTIONS(12189),
    [anon_sym_EQ] = ACTIONS(12189),
    [anon_sym_LT] = ACTIONS(12189),
    [anon_sym_end] = ACTIONS(12187),
    [anon_sym_if] = ACTIONS(12187),
    [anon_sym_unless] = ACTIONS(12187),
    [anon_sym_while] = ACTIONS(12187),
    [anon_sym_until] = ACTIONS(12187),
    [anon_sym_rescue] = ACTIONS(12187),
    [anon_sym_do] = ACTIONS(12187),
    [anon_sym_when] = ACTIONS(12187),
    [anon_sym_elsif] = ACTIONS(12187),
    [anon_sym_else] = ACTIONS(12187),
    [anon_sym_then] = ACTIONS(12187),
    [anon_sym_ensure] = ACTIONS(12187),
    [anon_sym_LBRACK] = ACTIONS(12187),
    [anon_sym_COLON_COLON2] = ACTIONS(12187),
    [anon_sym_AMP_DOT] = ACTIONS(12187),
    [anon_sym_PLUS_EQ] = ACTIONS(12187),
    [anon_sym_DASH_EQ] = ACTIONS(12187),
    [anon_sym_STAR_EQ] = ACTIONS(12187),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12187),
    [anon_sym_SLASH_EQ] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12187),
    [anon_sym_PIPE_EQ] = ACTIONS(12187),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12187),
    [anon_sym_AMP_EQ] = ACTIONS(12187),
    [anon_sym_PERCENT_EQ] = ACTIONS(12187),
    [anon_sym_GT_GT_EQ] = ACTIONS(12187),
    [anon_sym_LT_LT_EQ] = ACTIONS(12187),
    [anon_sym_CARET_EQ] = ACTIONS(12187),
    [anon_sym_QMARK] = ACTIONS(12187),
    [anon_sym_DOT_DOT] = ACTIONS(12189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12187),
    [anon_sym_and] = ACTIONS(12187),
    [anon_sym_or] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE] = ACTIONS(12189),
    [anon_sym_AMP_AMP] = ACTIONS(12189),
    [anon_sym_LT_LT] = ACTIONS(12189),
    [anon_sym_GT_GT] = ACTIONS(12189),
    [anon_sym_EQ_EQ] = ACTIONS(12189),
    [anon_sym_BANG_EQ] = ACTIONS(12187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12187),
    [anon_sym_LT_EQ_GT] = ACTIONS(12187),
    [anon_sym_EQ_TILDE] = ACTIONS(12187),
    [anon_sym_BANG_TILDE] = ACTIONS(12187),
    [anon_sym_LT_EQ] = ACTIONS(12189),
    [anon_sym_GT] = ACTIONS(12189),
    [anon_sym_GT_EQ] = ACTIONS(12187),
    [anon_sym_CARET] = ACTIONS(12189),
    [anon_sym_PLUS] = ACTIONS(12189),
    [anon_sym_SLASH] = ACTIONS(12189),
    [anon_sym_PERCENT] = ACTIONS(12189),
    [sym_comment] = ACTIONS(87),
  },
  [10580] = {
    [sym__line_break] = ACTIONS(12482),
    [sym__heredoc_body_start] = ACTIONS(12482),
    [sym__binary_minus] = ACTIONS(12482),
    [sym__binary_star] = ACTIONS(12482),
    [ts_builtin_sym_end] = ACTIONS(12482),
    [anon_sym___END__] = ACTIONS(12482),
    [anon_sym_LBRACE] = ACTIONS(12482),
    [anon_sym_RBRACE] = ACTIONS(12482),
    [anon_sym_RPAREN] = ACTIONS(12482),
    [anon_sym_DOT] = ACTIONS(12484),
    [anon_sym_COMMA] = ACTIONS(12482),
    [anon_sym_PIPE] = ACTIONS(12484),
    [anon_sym_SEMI] = ACTIONS(12482),
    [anon_sym_STAR_STAR] = ACTIONS(12484),
    [anon_sym_AMP] = ACTIONS(12484),
    [anon_sym_EQ] = ACTIONS(12484),
    [anon_sym_LT] = ACTIONS(12484),
    [anon_sym_end] = ACTIONS(12482),
    [anon_sym_if] = ACTIONS(12482),
    [anon_sym_unless] = ACTIONS(12482),
    [anon_sym_while] = ACTIONS(12482),
    [anon_sym_until] = ACTIONS(12482),
    [anon_sym_rescue] = ACTIONS(12482),
    [anon_sym_do] = ACTIONS(12482),
    [anon_sym_when] = ACTIONS(12482),
    [anon_sym_elsif] = ACTIONS(12482),
    [anon_sym_else] = ACTIONS(12482),
    [anon_sym_then] = ACTIONS(12482),
    [anon_sym_ensure] = ACTIONS(12482),
    [anon_sym_LBRACK] = ACTIONS(12482),
    [anon_sym_COLON_COLON2] = ACTIONS(12482),
    [anon_sym_AMP_DOT] = ACTIONS(12482),
    [anon_sym_PLUS_EQ] = ACTIONS(12482),
    [anon_sym_DASH_EQ] = ACTIONS(12482),
    [anon_sym_STAR_EQ] = ACTIONS(12482),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12482),
    [anon_sym_SLASH_EQ] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12482),
    [anon_sym_PIPE_EQ] = ACTIONS(12482),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12482),
    [anon_sym_AMP_EQ] = ACTIONS(12482),
    [anon_sym_PERCENT_EQ] = ACTIONS(12482),
    [anon_sym_GT_GT_EQ] = ACTIONS(12482),
    [anon_sym_LT_LT_EQ] = ACTIONS(12482),
    [anon_sym_CARET_EQ] = ACTIONS(12482),
    [anon_sym_QMARK] = ACTIONS(12482),
    [anon_sym_DOT_DOT] = ACTIONS(12484),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12482),
    [anon_sym_and] = ACTIONS(12482),
    [anon_sym_or] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE] = ACTIONS(12484),
    [anon_sym_AMP_AMP] = ACTIONS(12484),
    [anon_sym_LT_LT] = ACTIONS(12484),
    [anon_sym_GT_GT] = ACTIONS(12484),
    [anon_sym_EQ_EQ] = ACTIONS(12484),
    [anon_sym_BANG_EQ] = ACTIONS(12482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12482),
    [anon_sym_LT_EQ_GT] = ACTIONS(12482),
    [anon_sym_EQ_TILDE] = ACTIONS(12482),
    [anon_sym_BANG_TILDE] = ACTIONS(12482),
    [anon_sym_LT_EQ] = ACTIONS(12484),
    [anon_sym_GT] = ACTIONS(12484),
    [anon_sym_GT_EQ] = ACTIONS(12482),
    [anon_sym_CARET] = ACTIONS(12484),
    [anon_sym_PLUS] = ACTIONS(12484),
    [anon_sym_SLASH] = ACTIONS(12484),
    [anon_sym_PERCENT] = ACTIONS(12484),
    [sym_comment] = ACTIONS(87),
  },
  [10581] = {
    [anon_sym_end] = ACTIONS(14678),
    [sym_comment] = ACTIONS(87),
  },
  [10582] = {
    [sym__line_break] = ACTIONS(12622),
    [sym__heredoc_body_start] = ACTIONS(12622),
    [sym__binary_minus] = ACTIONS(12622),
    [sym__binary_star] = ACTIONS(12622),
    [ts_builtin_sym_end] = ACTIONS(12622),
    [anon_sym___END__] = ACTIONS(12622),
    [anon_sym_LBRACE] = ACTIONS(12622),
    [anon_sym_RBRACE] = ACTIONS(12622),
    [anon_sym_RPAREN] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12624),
    [anon_sym_COMMA] = ACTIONS(12622),
    [anon_sym_PIPE] = ACTIONS(12624),
    [anon_sym_SEMI] = ACTIONS(12622),
    [anon_sym_STAR_STAR] = ACTIONS(12624),
    [anon_sym_AMP] = ACTIONS(12624),
    [anon_sym_EQ] = ACTIONS(12624),
    [anon_sym_LT] = ACTIONS(12624),
    [anon_sym_end] = ACTIONS(12622),
    [anon_sym_if] = ACTIONS(12622),
    [anon_sym_unless] = ACTIONS(12622),
    [anon_sym_while] = ACTIONS(12622),
    [anon_sym_until] = ACTIONS(12622),
    [anon_sym_rescue] = ACTIONS(12622),
    [anon_sym_do] = ACTIONS(12622),
    [anon_sym_when] = ACTIONS(12622),
    [anon_sym_elsif] = ACTIONS(12622),
    [anon_sym_else] = ACTIONS(12622),
    [anon_sym_then] = ACTIONS(12622),
    [anon_sym_ensure] = ACTIONS(12622),
    [anon_sym_LBRACK] = ACTIONS(12622),
    [anon_sym_COLON_COLON2] = ACTIONS(12622),
    [anon_sym_AMP_DOT] = ACTIONS(12622),
    [anon_sym_PLUS_EQ] = ACTIONS(12622),
    [anon_sym_DASH_EQ] = ACTIONS(12622),
    [anon_sym_STAR_EQ] = ACTIONS(12622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12622),
    [anon_sym_SLASH_EQ] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12622),
    [anon_sym_PIPE_EQ] = ACTIONS(12622),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12622),
    [anon_sym_AMP_EQ] = ACTIONS(12622),
    [anon_sym_PERCENT_EQ] = ACTIONS(12622),
    [anon_sym_GT_GT_EQ] = ACTIONS(12622),
    [anon_sym_LT_LT_EQ] = ACTIONS(12622),
    [anon_sym_CARET_EQ] = ACTIONS(12622),
    [anon_sym_QMARK] = ACTIONS(12622),
    [anon_sym_DOT_DOT] = ACTIONS(12624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12622),
    [anon_sym_and] = ACTIONS(12622),
    [anon_sym_or] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE] = ACTIONS(12624),
    [anon_sym_AMP_AMP] = ACTIONS(12624),
    [anon_sym_LT_LT] = ACTIONS(12624),
    [anon_sym_GT_GT] = ACTIONS(12624),
    [anon_sym_EQ_EQ] = ACTIONS(12624),
    [anon_sym_BANG_EQ] = ACTIONS(12622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12622),
    [anon_sym_LT_EQ_GT] = ACTIONS(12622),
    [anon_sym_EQ_TILDE] = ACTIONS(12622),
    [anon_sym_BANG_TILDE] = ACTIONS(12622),
    [anon_sym_LT_EQ] = ACTIONS(12624),
    [anon_sym_GT] = ACTIONS(12624),
    [anon_sym_GT_EQ] = ACTIONS(12622),
    [anon_sym_CARET] = ACTIONS(12624),
    [anon_sym_PLUS] = ACTIONS(12624),
    [anon_sym_SLASH] = ACTIONS(12624),
    [anon_sym_PERCENT] = ACTIONS(12624),
    [sym_comment] = ACTIONS(87),
  },
  [10583] = {
    [sym__line_break] = ACTIONS(12770),
    [sym__heredoc_body_start] = ACTIONS(12770),
    [sym__binary_minus] = ACTIONS(12770),
    [sym__binary_star] = ACTIONS(12770),
    [ts_builtin_sym_end] = ACTIONS(12770),
    [anon_sym___END__] = ACTIONS(12770),
    [anon_sym_LBRACE] = ACTIONS(12770),
    [anon_sym_RBRACE] = ACTIONS(12770),
    [anon_sym_RPAREN] = ACTIONS(12770),
    [anon_sym_DOT] = ACTIONS(12772),
    [anon_sym_COMMA] = ACTIONS(12770),
    [anon_sym_PIPE] = ACTIONS(12772),
    [anon_sym_SEMI] = ACTIONS(12770),
    [anon_sym_STAR_STAR] = ACTIONS(12772),
    [anon_sym_AMP] = ACTIONS(12772),
    [anon_sym_EQ] = ACTIONS(12772),
    [anon_sym_LT] = ACTIONS(12772),
    [anon_sym_end] = ACTIONS(12770),
    [anon_sym_if] = ACTIONS(12770),
    [anon_sym_unless] = ACTIONS(12770),
    [anon_sym_while] = ACTIONS(12770),
    [anon_sym_until] = ACTIONS(12770),
    [anon_sym_rescue] = ACTIONS(12770),
    [anon_sym_do] = ACTIONS(12770),
    [anon_sym_when] = ACTIONS(12770),
    [anon_sym_elsif] = ACTIONS(12770),
    [anon_sym_else] = ACTIONS(12770),
    [anon_sym_then] = ACTIONS(12770),
    [anon_sym_ensure] = ACTIONS(12770),
    [anon_sym_LBRACK] = ACTIONS(12770),
    [anon_sym_COLON_COLON2] = ACTIONS(12770),
    [anon_sym_AMP_DOT] = ACTIONS(12770),
    [anon_sym_PLUS_EQ] = ACTIONS(12770),
    [anon_sym_DASH_EQ] = ACTIONS(12770),
    [anon_sym_STAR_EQ] = ACTIONS(12770),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12770),
    [anon_sym_SLASH_EQ] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12770),
    [anon_sym_PIPE_EQ] = ACTIONS(12770),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12770),
    [anon_sym_AMP_EQ] = ACTIONS(12770),
    [anon_sym_PERCENT_EQ] = ACTIONS(12770),
    [anon_sym_GT_GT_EQ] = ACTIONS(12770),
    [anon_sym_LT_LT_EQ] = ACTIONS(12770),
    [anon_sym_CARET_EQ] = ACTIONS(12770),
    [anon_sym_QMARK] = ACTIONS(12770),
    [anon_sym_DOT_DOT] = ACTIONS(12772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12770),
    [anon_sym_and] = ACTIONS(12770),
    [anon_sym_or] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE] = ACTIONS(12772),
    [anon_sym_AMP_AMP] = ACTIONS(12772),
    [anon_sym_LT_LT] = ACTIONS(12772),
    [anon_sym_GT_GT] = ACTIONS(12772),
    [anon_sym_EQ_EQ] = ACTIONS(12772),
    [anon_sym_BANG_EQ] = ACTIONS(12770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12770),
    [anon_sym_LT_EQ_GT] = ACTIONS(12770),
    [anon_sym_EQ_TILDE] = ACTIONS(12770),
    [anon_sym_BANG_TILDE] = ACTIONS(12770),
    [anon_sym_LT_EQ] = ACTIONS(12772),
    [anon_sym_GT] = ACTIONS(12772),
    [anon_sym_GT_EQ] = ACTIONS(12770),
    [anon_sym_CARET] = ACTIONS(12772),
    [anon_sym_PLUS] = ACTIONS(12772),
    [anon_sym_SLASH] = ACTIONS(12772),
    [anon_sym_PERCENT] = ACTIONS(12772),
    [sym_comment] = ACTIONS(87),
  },
  [10584] = {
    [sym__line_break] = ACTIONS(12781),
    [sym__heredoc_body_start] = ACTIONS(12781),
    [sym__binary_minus] = ACTIONS(12781),
    [sym__binary_star] = ACTIONS(12781),
    [ts_builtin_sym_end] = ACTIONS(12781),
    [anon_sym___END__] = ACTIONS(12781),
    [anon_sym_LBRACE] = ACTIONS(12781),
    [anon_sym_RBRACE] = ACTIONS(12781),
    [anon_sym_RPAREN] = ACTIONS(12781),
    [anon_sym_DOT] = ACTIONS(12783),
    [anon_sym_COMMA] = ACTIONS(12781),
    [anon_sym_PIPE] = ACTIONS(12783),
    [anon_sym_SEMI] = ACTIONS(12781),
    [anon_sym_STAR_STAR] = ACTIONS(12783),
    [anon_sym_AMP] = ACTIONS(12783),
    [anon_sym_EQ] = ACTIONS(12783),
    [anon_sym_LT] = ACTIONS(12783),
    [anon_sym_end] = ACTIONS(12781),
    [anon_sym_if] = ACTIONS(12781),
    [anon_sym_unless] = ACTIONS(12781),
    [anon_sym_while] = ACTIONS(12781),
    [anon_sym_until] = ACTIONS(12781),
    [anon_sym_rescue] = ACTIONS(12781),
    [anon_sym_do] = ACTIONS(12781),
    [anon_sym_when] = ACTIONS(12781),
    [anon_sym_elsif] = ACTIONS(12781),
    [anon_sym_else] = ACTIONS(12781),
    [anon_sym_then] = ACTIONS(12781),
    [anon_sym_ensure] = ACTIONS(12781),
    [anon_sym_LBRACK] = ACTIONS(12781),
    [anon_sym_COLON_COLON2] = ACTIONS(12781),
    [anon_sym_AMP_DOT] = ACTIONS(12781),
    [anon_sym_PLUS_EQ] = ACTIONS(12781),
    [anon_sym_DASH_EQ] = ACTIONS(12781),
    [anon_sym_STAR_EQ] = ACTIONS(12781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12781),
    [anon_sym_SLASH_EQ] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12781),
    [anon_sym_PIPE_EQ] = ACTIONS(12781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12781),
    [anon_sym_AMP_EQ] = ACTIONS(12781),
    [anon_sym_PERCENT_EQ] = ACTIONS(12781),
    [anon_sym_GT_GT_EQ] = ACTIONS(12781),
    [anon_sym_LT_LT_EQ] = ACTIONS(12781),
    [anon_sym_CARET_EQ] = ACTIONS(12781),
    [anon_sym_QMARK] = ACTIONS(12781),
    [anon_sym_DOT_DOT] = ACTIONS(12783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12781),
    [anon_sym_and] = ACTIONS(12781),
    [anon_sym_or] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE] = ACTIONS(12783),
    [anon_sym_AMP_AMP] = ACTIONS(12783),
    [anon_sym_LT_LT] = ACTIONS(12783),
    [anon_sym_GT_GT] = ACTIONS(12783),
    [anon_sym_EQ_EQ] = ACTIONS(12783),
    [anon_sym_BANG_EQ] = ACTIONS(12781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12781),
    [anon_sym_LT_EQ_GT] = ACTIONS(12781),
    [anon_sym_EQ_TILDE] = ACTIONS(12781),
    [anon_sym_BANG_TILDE] = ACTIONS(12781),
    [anon_sym_LT_EQ] = ACTIONS(12783),
    [anon_sym_GT] = ACTIONS(12783),
    [anon_sym_GT_EQ] = ACTIONS(12781),
    [anon_sym_CARET] = ACTIONS(12783),
    [anon_sym_PLUS] = ACTIONS(12783),
    [anon_sym_SLASH] = ACTIONS(12783),
    [anon_sym_PERCENT] = ACTIONS(12783),
    [sym_comment] = ACTIONS(87),
  },
  [10585] = {
    [sym__line_break] = ACTIONS(13093),
    [sym__heredoc_body_start] = ACTIONS(13093),
    [sym__binary_minus] = ACTIONS(13093),
    [sym__binary_star] = ACTIONS(13093),
    [ts_builtin_sym_end] = ACTIONS(13093),
    [anon_sym___END__] = ACTIONS(13093),
    [anon_sym_LBRACE] = ACTIONS(13093),
    [anon_sym_RBRACE] = ACTIONS(13093),
    [anon_sym_RPAREN] = ACTIONS(13093),
    [anon_sym_DOT] = ACTIONS(13095),
    [anon_sym_COMMA] = ACTIONS(13093),
    [anon_sym_PIPE] = ACTIONS(13095),
    [anon_sym_SEMI] = ACTIONS(13093),
    [anon_sym_STAR_STAR] = ACTIONS(13095),
    [anon_sym_AMP] = ACTIONS(13095),
    [anon_sym_EQ] = ACTIONS(13095),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_end] = ACTIONS(13093),
    [anon_sym_if] = ACTIONS(13093),
    [anon_sym_unless] = ACTIONS(13093),
    [anon_sym_while] = ACTIONS(13093),
    [anon_sym_until] = ACTIONS(13093),
    [anon_sym_rescue] = ACTIONS(13093),
    [anon_sym_do] = ACTIONS(13093),
    [anon_sym_when] = ACTIONS(13093),
    [anon_sym_elsif] = ACTIONS(13093),
    [anon_sym_else] = ACTIONS(13093),
    [anon_sym_then] = ACTIONS(13093),
    [anon_sym_ensure] = ACTIONS(13093),
    [anon_sym_LBRACK] = ACTIONS(13093),
    [anon_sym_COLON_COLON2] = ACTIONS(13093),
    [anon_sym_AMP_DOT] = ACTIONS(13093),
    [anon_sym_PLUS_EQ] = ACTIONS(13093),
    [anon_sym_DASH_EQ] = ACTIONS(13093),
    [anon_sym_STAR_EQ] = ACTIONS(13093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13093),
    [anon_sym_SLASH_EQ] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13093),
    [anon_sym_PIPE_EQ] = ACTIONS(13093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13093),
    [anon_sym_AMP_EQ] = ACTIONS(13093),
    [anon_sym_PERCENT_EQ] = ACTIONS(13093),
    [anon_sym_GT_GT_EQ] = ACTIONS(13093),
    [anon_sym_LT_LT_EQ] = ACTIONS(13093),
    [anon_sym_CARET_EQ] = ACTIONS(13093),
    [anon_sym_QMARK] = ACTIONS(13093),
    [anon_sym_DOT_DOT] = ACTIONS(13095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13093),
    [anon_sym_and] = ACTIONS(13093),
    [anon_sym_or] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE] = ACTIONS(13095),
    [anon_sym_AMP_AMP] = ACTIONS(13095),
    [anon_sym_LT_LT] = ACTIONS(13095),
    [anon_sym_GT_GT] = ACTIONS(13095),
    [anon_sym_EQ_EQ] = ACTIONS(13095),
    [anon_sym_BANG_EQ] = ACTIONS(13093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13093),
    [anon_sym_LT_EQ_GT] = ACTIONS(13093),
    [anon_sym_EQ_TILDE] = ACTIONS(13093),
    [anon_sym_BANG_TILDE] = ACTIONS(13093),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13093),
    [anon_sym_CARET] = ACTIONS(13095),
    [anon_sym_PLUS] = ACTIONS(13095),
    [anon_sym_SLASH] = ACTIONS(13095),
    [anon_sym_PERCENT] = ACTIONS(13095),
    [sym_comment] = ACTIONS(87),
  },
  [10586] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10920),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(6308),
    [sym_scope_resolution] = STATE(1515),
    [sym_call] = STATE(1515),
    [sym_method_call] = STATE(6308),
    [sym_assignment] = STATE(10920),
    [sym_operator_assignment] = STATE(10920),
    [sym_conditional] = STATE(10920),
    [sym_range] = STATE(10920),
    [sym_binary] = STATE(10920),
    [sym_unary] = STATE(10920),
    [sym_left_assignment_list] = STATE(6307),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(6308),
    [sym__variable] = STATE(1515),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(6308),
    [sym_false] = STATE(6308),
    [sym_nil] = STATE(6308),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(3934),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(9536),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2982),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_next] = ACTIONS(2986),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9538),
    [anon_sym_defined_QMARK] = ACTIONS(9540),
    [anon_sym_not] = ACTIONS(9542),
    [anon_sym_BANG] = ACTIONS(9544),
    [anon_sym_TILDE] = ACTIONS(9544),
    [sym_constant] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_instance_variable] = ACTIONS(2659),
    [sym_class_variable] = ACTIONS(2659),
    [sym_global_variable] = ACTIONS(2659),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2661),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2661),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10587] = {
    [sym__line_break] = ACTIONS(13660),
    [sym__heredoc_body_start] = ACTIONS(13660),
    [sym__binary_minus] = ACTIONS(13660),
    [sym__binary_star] = ACTIONS(13660),
    [ts_builtin_sym_end] = ACTIONS(13660),
    [anon_sym___END__] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_RBRACE] = ACTIONS(13660),
    [anon_sym_RPAREN] = ACTIONS(13660),
    [anon_sym_DOT] = ACTIONS(13662),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_PIPE] = ACTIONS(13662),
    [anon_sym_SEMI] = ACTIONS(13660),
    [anon_sym_STAR_STAR] = ACTIONS(13662),
    [anon_sym_AMP] = ACTIONS(13662),
    [anon_sym_EQ] = ACTIONS(13662),
    [anon_sym_LT] = ACTIONS(13662),
    [anon_sym_end] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_unless] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [anon_sym_until] = ACTIONS(13660),
    [anon_sym_rescue] = ACTIONS(13660),
    [anon_sym_do] = ACTIONS(13660),
    [anon_sym_when] = ACTIONS(13660),
    [anon_sym_elsif] = ACTIONS(13660),
    [anon_sym_else] = ACTIONS(13660),
    [anon_sym_then] = ACTIONS(13660),
    [anon_sym_ensure] = ACTIONS(13660),
    [anon_sym_EQ_GT] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_COLON_COLON2] = ACTIONS(13660),
    [anon_sym_AMP_DOT] = ACTIONS(13660),
    [anon_sym_PLUS_EQ] = ACTIONS(13660),
    [anon_sym_DASH_EQ] = ACTIONS(13660),
    [anon_sym_STAR_EQ] = ACTIONS(13660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13660),
    [anon_sym_SLASH_EQ] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13660),
    [anon_sym_PIPE_EQ] = ACTIONS(13660),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13660),
    [anon_sym_AMP_EQ] = ACTIONS(13660),
    [anon_sym_PERCENT_EQ] = ACTIONS(13660),
    [anon_sym_GT_GT_EQ] = ACTIONS(13660),
    [anon_sym_LT_LT_EQ] = ACTIONS(13660),
    [anon_sym_CARET_EQ] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_DOT_DOT] = ACTIONS(13662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_and] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE] = ACTIONS(13662),
    [anon_sym_AMP_AMP] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13662),
    [anon_sym_GT_GT] = ACTIONS(13662),
    [anon_sym_EQ_EQ] = ACTIONS(13662),
    [anon_sym_BANG_EQ] = ACTIONS(13660),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13660),
    [anon_sym_LT_EQ_GT] = ACTIONS(13660),
    [anon_sym_EQ_TILDE] = ACTIONS(13660),
    [anon_sym_BANG_TILDE] = ACTIONS(13660),
    [anon_sym_LT_EQ] = ACTIONS(13662),
    [anon_sym_GT] = ACTIONS(13662),
    [anon_sym_GT_EQ] = ACTIONS(13660),
    [anon_sym_CARET] = ACTIONS(13662),
    [anon_sym_PLUS] = ACTIONS(13662),
    [anon_sym_SLASH] = ACTIONS(13662),
    [anon_sym_PERCENT] = ACTIONS(13662),
    [sym_comment] = ACTIONS(87),
  },
  [10588] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(9607),
    [sym__binary_star] = ACTIONS(9609),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9609),
    [anon_sym_AMP] = ACTIONS(9613),
    [anon_sym_LT] = ACTIONS(9615),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(9617),
    [anon_sym_DOT_DOT] = ACTIONS(9619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9621),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(9623),
    [anon_sym_AMP_AMP] = ACTIONS(9623),
    [anon_sym_LT_LT] = ACTIONS(9625),
    [anon_sym_GT_GT] = ACTIONS(9625),
    [anon_sym_EQ_EQ] = ACTIONS(9627),
    [anon_sym_BANG_EQ] = ACTIONS(9623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9623),
    [anon_sym_LT_EQ_GT] = ACTIONS(9623),
    [anon_sym_EQ_TILDE] = ACTIONS(9623),
    [anon_sym_BANG_TILDE] = ACTIONS(9623),
    [anon_sym_LT_EQ] = ACTIONS(9615),
    [anon_sym_GT] = ACTIONS(9615),
    [anon_sym_GT_EQ] = ACTIONS(9629),
    [anon_sym_CARET] = ACTIONS(9631),
    [anon_sym_PLUS] = ACTIONS(9607),
    [anon_sym_SLASH] = ACTIONS(9609),
    [anon_sym_PERCENT] = ACTIONS(9609),
    [sym_comment] = ACTIONS(87),
  },
  [10589] = {
    [aux_sym_exceptions_repeat1] = STATE(10589),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14680),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10590] = {
    [sym__heredoc_body_start] = ACTIONS(9793),
    [sym__binary_minus] = ACTIONS(9793),
    [sym__binary_star] = ACTIONS(9793),
    [anon_sym_LBRACE] = ACTIONS(9793),
    [anon_sym_RBRACE] = ACTIONS(9793),
    [anon_sym_RPAREN] = ACTIONS(9793),
    [anon_sym_DOT] = ACTIONS(9795),
    [anon_sym_COMMA] = ACTIONS(9793),
    [anon_sym_PIPE] = ACTIONS(9795),
    [anon_sym_SEMI] = ACTIONS(9793),
    [anon_sym_STAR_STAR] = ACTIONS(9795),
    [anon_sym_AMP] = ACTIONS(9795),
    [anon_sym_EQ] = ACTIONS(9795),
    [anon_sym_LT] = ACTIONS(9795),
    [anon_sym_if] = ACTIONS(9793),
    [anon_sym_unless] = ACTIONS(9793),
    [anon_sym_while] = ACTIONS(9793),
    [anon_sym_until] = ACTIONS(9793),
    [anon_sym_rescue] = ACTIONS(9793),
    [anon_sym_in] = ACTIONS(9793),
    [anon_sym_do] = ACTIONS(9793),
    [anon_sym_LBRACK] = ACTIONS(9793),
    [anon_sym_RBRACK] = ACTIONS(9793),
    [anon_sym_COLON_COLON2] = ACTIONS(9793),
    [anon_sym_AMP_DOT] = ACTIONS(9793),
    [anon_sym_PLUS_EQ] = ACTIONS(9793),
    [anon_sym_DASH_EQ] = ACTIONS(9793),
    [anon_sym_STAR_EQ] = ACTIONS(9793),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9793),
    [anon_sym_SLASH_EQ] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9793),
    [anon_sym_PIPE_EQ] = ACTIONS(9793),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9793),
    [anon_sym_AMP_EQ] = ACTIONS(9793),
    [anon_sym_PERCENT_EQ] = ACTIONS(9793),
    [anon_sym_GT_GT_EQ] = ACTIONS(9793),
    [anon_sym_LT_LT_EQ] = ACTIONS(9793),
    [anon_sym_CARET_EQ] = ACTIONS(9793),
    [anon_sym_QMARK] = ACTIONS(9793),
    [anon_sym_COLON2] = ACTIONS(9795),
    [anon_sym_DOT_DOT] = ACTIONS(9795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9793),
    [anon_sym_and] = ACTIONS(9793),
    [anon_sym_or] = ACTIONS(9793),
    [anon_sym_PIPE_PIPE] = ACTIONS(9795),
    [anon_sym_AMP_AMP] = ACTIONS(9795),
    [anon_sym_LT_LT] = ACTIONS(9795),
    [anon_sym_GT_GT] = ACTIONS(9795),
    [anon_sym_EQ_EQ] = ACTIONS(9795),
    [anon_sym_BANG_EQ] = ACTIONS(9793),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9793),
    [anon_sym_LT_EQ_GT] = ACTIONS(9793),
    [anon_sym_EQ_TILDE] = ACTIONS(9793),
    [anon_sym_BANG_TILDE] = ACTIONS(9793),
    [anon_sym_LT_EQ] = ACTIONS(9795),
    [anon_sym_GT] = ACTIONS(9795),
    [anon_sym_GT_EQ] = ACTIONS(9793),
    [anon_sym_CARET] = ACTIONS(9795),
    [anon_sym_PLUS] = ACTIONS(9795),
    [anon_sym_SLASH] = ACTIONS(9795),
    [anon_sym_PERCENT] = ACTIONS(9795),
    [sym_comment] = ACTIONS(87),
  },
  [10591] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1678),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14683),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10592] = {
    [sym__heredoc_body_start] = ACTIONS(9799),
    [sym__binary_minus] = ACTIONS(9799),
    [sym__binary_star] = ACTIONS(9799),
    [anon_sym_LBRACE] = ACTIONS(9799),
    [anon_sym_RBRACE] = ACTIONS(9799),
    [anon_sym_RPAREN] = ACTIONS(9799),
    [anon_sym_DOT] = ACTIONS(9801),
    [anon_sym_COMMA] = ACTIONS(9799),
    [anon_sym_PIPE] = ACTIONS(9801),
    [anon_sym_SEMI] = ACTIONS(9799),
    [anon_sym_STAR_STAR] = ACTIONS(9801),
    [anon_sym_AMP] = ACTIONS(9801),
    [anon_sym_EQ] = ACTIONS(9801),
    [anon_sym_LT] = ACTIONS(9801),
    [anon_sym_if] = ACTIONS(9799),
    [anon_sym_unless] = ACTIONS(9799),
    [anon_sym_while] = ACTIONS(9799),
    [anon_sym_until] = ACTIONS(9799),
    [anon_sym_rescue] = ACTIONS(9799),
    [anon_sym_in] = ACTIONS(9799),
    [anon_sym_do] = ACTIONS(9799),
    [anon_sym_LBRACK] = ACTIONS(9799),
    [anon_sym_RBRACK] = ACTIONS(9799),
    [anon_sym_COLON_COLON2] = ACTIONS(9799),
    [anon_sym_AMP_DOT] = ACTIONS(9799),
    [anon_sym_PLUS_EQ] = ACTIONS(9799),
    [anon_sym_DASH_EQ] = ACTIONS(9799),
    [anon_sym_STAR_EQ] = ACTIONS(9799),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9799),
    [anon_sym_SLASH_EQ] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9799),
    [anon_sym_PIPE_EQ] = ACTIONS(9799),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9799),
    [anon_sym_AMP_EQ] = ACTIONS(9799),
    [anon_sym_PERCENT_EQ] = ACTIONS(9799),
    [anon_sym_GT_GT_EQ] = ACTIONS(9799),
    [anon_sym_LT_LT_EQ] = ACTIONS(9799),
    [anon_sym_CARET_EQ] = ACTIONS(9799),
    [anon_sym_QMARK] = ACTIONS(9799),
    [anon_sym_COLON2] = ACTIONS(9801),
    [anon_sym_DOT_DOT] = ACTIONS(9801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9799),
    [anon_sym_and] = ACTIONS(9799),
    [anon_sym_or] = ACTIONS(9799),
    [anon_sym_PIPE_PIPE] = ACTIONS(9801),
    [anon_sym_AMP_AMP] = ACTIONS(9801),
    [anon_sym_LT_LT] = ACTIONS(9801),
    [anon_sym_GT_GT] = ACTIONS(9801),
    [anon_sym_EQ_EQ] = ACTIONS(9801),
    [anon_sym_BANG_EQ] = ACTIONS(9799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9799),
    [anon_sym_LT_EQ_GT] = ACTIONS(9799),
    [anon_sym_EQ_TILDE] = ACTIONS(9799),
    [anon_sym_BANG_TILDE] = ACTIONS(9799),
    [anon_sym_LT_EQ] = ACTIONS(9801),
    [anon_sym_GT] = ACTIONS(9801),
    [anon_sym_GT_EQ] = ACTIONS(9799),
    [anon_sym_CARET] = ACTIONS(9801),
    [anon_sym_PLUS] = ACTIONS(9801),
    [anon_sym_SLASH] = ACTIONS(9801),
    [anon_sym_PERCENT] = ACTIONS(9801),
    [sym_comment] = ACTIONS(87),
  },
  [10593] = {
    [sym__heredoc_body_start] = ACTIONS(9803),
    [sym__binary_minus] = ACTIONS(9803),
    [sym__binary_star] = ACTIONS(9803),
    [anon_sym_LBRACE] = ACTIONS(9803),
    [anon_sym_RBRACE] = ACTIONS(9803),
    [anon_sym_RPAREN] = ACTIONS(9803),
    [anon_sym_DOT] = ACTIONS(9805),
    [anon_sym_COMMA] = ACTIONS(9803),
    [anon_sym_PIPE] = ACTIONS(9805),
    [anon_sym_SEMI] = ACTIONS(9803),
    [anon_sym_STAR_STAR] = ACTIONS(9805),
    [anon_sym_AMP] = ACTIONS(9805),
    [anon_sym_EQ] = ACTIONS(9805),
    [anon_sym_LT] = ACTIONS(9805),
    [anon_sym_if] = ACTIONS(9803),
    [anon_sym_unless] = ACTIONS(9803),
    [anon_sym_while] = ACTIONS(9803),
    [anon_sym_until] = ACTIONS(9803),
    [anon_sym_rescue] = ACTIONS(9803),
    [anon_sym_in] = ACTIONS(9803),
    [anon_sym_do] = ACTIONS(9803),
    [anon_sym_LBRACK] = ACTIONS(9803),
    [anon_sym_RBRACK] = ACTIONS(9803),
    [anon_sym_COLON_COLON2] = ACTIONS(9803),
    [anon_sym_AMP_DOT] = ACTIONS(9803),
    [anon_sym_PLUS_EQ] = ACTIONS(9803),
    [anon_sym_DASH_EQ] = ACTIONS(9803),
    [anon_sym_STAR_EQ] = ACTIONS(9803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9803),
    [anon_sym_SLASH_EQ] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9803),
    [anon_sym_PIPE_EQ] = ACTIONS(9803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9803),
    [anon_sym_AMP_EQ] = ACTIONS(9803),
    [anon_sym_PERCENT_EQ] = ACTIONS(9803),
    [anon_sym_GT_GT_EQ] = ACTIONS(9803),
    [anon_sym_LT_LT_EQ] = ACTIONS(9803),
    [anon_sym_CARET_EQ] = ACTIONS(9803),
    [anon_sym_QMARK] = ACTIONS(9803),
    [anon_sym_COLON2] = ACTIONS(9805),
    [anon_sym_DOT_DOT] = ACTIONS(9805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9803),
    [anon_sym_and] = ACTIONS(9803),
    [anon_sym_or] = ACTIONS(9803),
    [anon_sym_PIPE_PIPE] = ACTIONS(9805),
    [anon_sym_AMP_AMP] = ACTIONS(9805),
    [anon_sym_LT_LT] = ACTIONS(9805),
    [anon_sym_GT_GT] = ACTIONS(9805),
    [anon_sym_EQ_EQ] = ACTIONS(9805),
    [anon_sym_BANG_EQ] = ACTIONS(9803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9803),
    [anon_sym_LT_EQ_GT] = ACTIONS(9803),
    [anon_sym_EQ_TILDE] = ACTIONS(9803),
    [anon_sym_BANG_TILDE] = ACTIONS(9803),
    [anon_sym_LT_EQ] = ACTIONS(9805),
    [anon_sym_GT] = ACTIONS(9805),
    [anon_sym_GT_EQ] = ACTIONS(9803),
    [anon_sym_CARET] = ACTIONS(9805),
    [anon_sym_PLUS] = ACTIONS(9805),
    [anon_sym_SLASH] = ACTIONS(9805),
    [anon_sym_PERCENT] = ACTIONS(9805),
    [sym_comment] = ACTIONS(87),
  },
  [10594] = {
    [sym_interpolation] = STATE(68),
    [sym__literal_contents] = STATE(1686),
    [aux_sym__literal_contents_repeat1] = STATE(68),
    [sym__string_content] = ACTIONS(119),
    [sym__string_end] = ACTIONS(14685),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10595] = {
    [sym__heredoc_body_start] = ACTIONS(9809),
    [sym__binary_minus] = ACTIONS(9809),
    [sym__binary_star] = ACTIONS(9809),
    [anon_sym_LBRACE] = ACTIONS(9809),
    [anon_sym_RBRACE] = ACTIONS(9809),
    [anon_sym_RPAREN] = ACTIONS(9809),
    [anon_sym_DOT] = ACTIONS(9811),
    [anon_sym_COMMA] = ACTIONS(9809),
    [anon_sym_PIPE] = ACTIONS(9811),
    [anon_sym_SEMI] = ACTIONS(9809),
    [anon_sym_STAR_STAR] = ACTIONS(9811),
    [anon_sym_AMP] = ACTIONS(9811),
    [anon_sym_EQ] = ACTIONS(9811),
    [anon_sym_LT] = ACTIONS(9811),
    [anon_sym_if] = ACTIONS(9809),
    [anon_sym_unless] = ACTIONS(9809),
    [anon_sym_while] = ACTIONS(9809),
    [anon_sym_until] = ACTIONS(9809),
    [anon_sym_rescue] = ACTIONS(9809),
    [anon_sym_in] = ACTIONS(9809),
    [anon_sym_do] = ACTIONS(9809),
    [anon_sym_LBRACK] = ACTIONS(9809),
    [anon_sym_RBRACK] = ACTIONS(9809),
    [anon_sym_COLON_COLON2] = ACTIONS(9809),
    [anon_sym_AMP_DOT] = ACTIONS(9809),
    [anon_sym_PLUS_EQ] = ACTIONS(9809),
    [anon_sym_DASH_EQ] = ACTIONS(9809),
    [anon_sym_STAR_EQ] = ACTIONS(9809),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9809),
    [anon_sym_SLASH_EQ] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9809),
    [anon_sym_PIPE_EQ] = ACTIONS(9809),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9809),
    [anon_sym_AMP_EQ] = ACTIONS(9809),
    [anon_sym_PERCENT_EQ] = ACTIONS(9809),
    [anon_sym_GT_GT_EQ] = ACTIONS(9809),
    [anon_sym_LT_LT_EQ] = ACTIONS(9809),
    [anon_sym_CARET_EQ] = ACTIONS(9809),
    [anon_sym_QMARK] = ACTIONS(9809),
    [anon_sym_COLON2] = ACTIONS(9811),
    [anon_sym_DOT_DOT] = ACTIONS(9811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9809),
    [anon_sym_and] = ACTIONS(9809),
    [anon_sym_or] = ACTIONS(9809),
    [anon_sym_PIPE_PIPE] = ACTIONS(9811),
    [anon_sym_AMP_AMP] = ACTIONS(9811),
    [anon_sym_LT_LT] = ACTIONS(9811),
    [anon_sym_GT_GT] = ACTIONS(9811),
    [anon_sym_EQ_EQ] = ACTIONS(9811),
    [anon_sym_BANG_EQ] = ACTIONS(9809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9809),
    [anon_sym_LT_EQ_GT] = ACTIONS(9809),
    [anon_sym_EQ_TILDE] = ACTIONS(9809),
    [anon_sym_BANG_TILDE] = ACTIONS(9809),
    [anon_sym_LT_EQ] = ACTIONS(9811),
    [anon_sym_GT] = ACTIONS(9811),
    [anon_sym_GT_EQ] = ACTIONS(9809),
    [anon_sym_CARET] = ACTIONS(9811),
    [anon_sym_PLUS] = ACTIONS(9811),
    [anon_sym_SLASH] = ACTIONS(9811),
    [anon_sym_PERCENT] = ACTIONS(9811),
    [sym_comment] = ACTIONS(87),
  },
  [10596] = {
    [sym__method_rest] = STATE(10923),
    [sym_operator] = STATE(6444),
    [sym__method_name] = STATE(6444),
    [sym_setter] = STATE(6444),
    [sym_symbol] = STATE(6444),
    [sym__simple_symbol] = ACTIONS(229),
    [sym__symbol_start] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(13393),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(13393),
    [sym_class_variable] = ACTIONS(13393),
    [sym_global_variable] = ACTIONS(13393),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [10597] = {
    [sym__heredoc_body_start] = ACTIONS(10532),
    [sym__binary_minus] = ACTIONS(10532),
    [sym__binary_star] = ACTIONS(10532),
    [anon_sym_LBRACE] = ACTIONS(10532),
    [anon_sym_RBRACE] = ACTIONS(10532),
    [anon_sym_RPAREN] = ACTIONS(10532),
    [anon_sym_DOT] = ACTIONS(10534),
    [anon_sym_COMMA] = ACTIONS(10532),
    [anon_sym_PIPE] = ACTIONS(10534),
    [anon_sym_SEMI] = ACTIONS(10532),
    [anon_sym_STAR_STAR] = ACTIONS(10534),
    [anon_sym_AMP] = ACTIONS(10534),
    [anon_sym_EQ] = ACTIONS(10534),
    [anon_sym_LT] = ACTIONS(10534),
    [anon_sym_if] = ACTIONS(10532),
    [anon_sym_unless] = ACTIONS(10532),
    [anon_sym_while] = ACTIONS(10532),
    [anon_sym_until] = ACTIONS(10532),
    [anon_sym_rescue] = ACTIONS(10532),
    [anon_sym_in] = ACTIONS(10532),
    [anon_sym_do] = ACTIONS(10532),
    [anon_sym_LBRACK] = ACTIONS(10532),
    [anon_sym_RBRACK] = ACTIONS(10532),
    [anon_sym_COLON_COLON2] = ACTIONS(10532),
    [anon_sym_AMP_DOT] = ACTIONS(10532),
    [anon_sym_PLUS_EQ] = ACTIONS(10532),
    [anon_sym_DASH_EQ] = ACTIONS(10532),
    [anon_sym_STAR_EQ] = ACTIONS(10532),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10532),
    [anon_sym_SLASH_EQ] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10532),
    [anon_sym_PIPE_EQ] = ACTIONS(10532),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10532),
    [anon_sym_AMP_EQ] = ACTIONS(10532),
    [anon_sym_PERCENT_EQ] = ACTIONS(10532),
    [anon_sym_GT_GT_EQ] = ACTIONS(10532),
    [anon_sym_LT_LT_EQ] = ACTIONS(10532),
    [anon_sym_CARET_EQ] = ACTIONS(10532),
    [anon_sym_QMARK] = ACTIONS(10532),
    [anon_sym_COLON2] = ACTIONS(10534),
    [anon_sym_DOT_DOT] = ACTIONS(10534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10532),
    [anon_sym_and] = ACTIONS(10532),
    [anon_sym_or] = ACTIONS(10532),
    [anon_sym_PIPE_PIPE] = ACTIONS(10534),
    [anon_sym_AMP_AMP] = ACTIONS(10534),
    [anon_sym_LT_LT] = ACTIONS(10534),
    [anon_sym_GT_GT] = ACTIONS(10534),
    [anon_sym_EQ_EQ] = ACTIONS(10534),
    [anon_sym_BANG_EQ] = ACTIONS(10532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10532),
    [anon_sym_LT_EQ_GT] = ACTIONS(10532),
    [anon_sym_EQ_TILDE] = ACTIONS(10532),
    [anon_sym_BANG_TILDE] = ACTIONS(10532),
    [anon_sym_LT_EQ] = ACTIONS(10534),
    [anon_sym_GT] = ACTIONS(10534),
    [anon_sym_GT_EQ] = ACTIONS(10532),
    [anon_sym_CARET] = ACTIONS(10534),
    [anon_sym_PLUS] = ACTIONS(10534),
    [anon_sym_SLASH] = ACTIONS(10534),
    [anon_sym_PERCENT] = ACTIONS(10534),
    [sym_comment] = ACTIONS(87),
  },
  [10598] = {
    [sym__heredoc_body_start] = ACTIONS(10536),
    [sym__binary_minus] = ACTIONS(10536),
    [sym__binary_star] = ACTIONS(10536),
    [anon_sym_LBRACE] = ACTIONS(10536),
    [anon_sym_RBRACE] = ACTIONS(10536),
    [anon_sym_RPAREN] = ACTIONS(10536),
    [anon_sym_DOT] = ACTIONS(10538),
    [anon_sym_COMMA] = ACTIONS(10536),
    [anon_sym_PIPE] = ACTIONS(10538),
    [anon_sym_SEMI] = ACTIONS(10536),
    [anon_sym_STAR_STAR] = ACTIONS(10538),
    [anon_sym_AMP] = ACTIONS(10538),
    [anon_sym_EQ] = ACTIONS(10538),
    [anon_sym_LT] = ACTIONS(10538),
    [anon_sym_if] = ACTIONS(10536),
    [anon_sym_unless] = ACTIONS(10536),
    [anon_sym_while] = ACTIONS(10536),
    [anon_sym_until] = ACTIONS(10536),
    [anon_sym_rescue] = ACTIONS(10536),
    [anon_sym_in] = ACTIONS(10536),
    [anon_sym_do] = ACTIONS(10536),
    [anon_sym_LBRACK] = ACTIONS(10536),
    [anon_sym_RBRACK] = ACTIONS(10536),
    [anon_sym_COLON_COLON2] = ACTIONS(10536),
    [anon_sym_AMP_DOT] = ACTIONS(10536),
    [anon_sym_PLUS_EQ] = ACTIONS(10536),
    [anon_sym_DASH_EQ] = ACTIONS(10536),
    [anon_sym_STAR_EQ] = ACTIONS(10536),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10536),
    [anon_sym_SLASH_EQ] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10536),
    [anon_sym_PIPE_EQ] = ACTIONS(10536),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10536),
    [anon_sym_AMP_EQ] = ACTIONS(10536),
    [anon_sym_PERCENT_EQ] = ACTIONS(10536),
    [anon_sym_GT_GT_EQ] = ACTIONS(10536),
    [anon_sym_LT_LT_EQ] = ACTIONS(10536),
    [anon_sym_CARET_EQ] = ACTIONS(10536),
    [anon_sym_QMARK] = ACTIONS(10536),
    [anon_sym_COLON2] = ACTIONS(10538),
    [anon_sym_DOT_DOT] = ACTIONS(10538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10536),
    [anon_sym_and] = ACTIONS(10536),
    [anon_sym_or] = ACTIONS(10536),
    [anon_sym_PIPE_PIPE] = ACTIONS(10538),
    [anon_sym_AMP_AMP] = ACTIONS(10538),
    [anon_sym_LT_LT] = ACTIONS(10538),
    [anon_sym_GT_GT] = ACTIONS(10538),
    [anon_sym_EQ_EQ] = ACTIONS(10538),
    [anon_sym_BANG_EQ] = ACTIONS(10536),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10536),
    [anon_sym_LT_EQ_GT] = ACTIONS(10536),
    [anon_sym_EQ_TILDE] = ACTIONS(10536),
    [anon_sym_BANG_TILDE] = ACTIONS(10536),
    [anon_sym_LT_EQ] = ACTIONS(10538),
    [anon_sym_GT] = ACTIONS(10538),
    [anon_sym_GT_EQ] = ACTIONS(10536),
    [anon_sym_CARET] = ACTIONS(10538),
    [anon_sym_PLUS] = ACTIONS(10538),
    [anon_sym_SLASH] = ACTIONS(10538),
    [anon_sym_PERCENT] = ACTIONS(10538),
    [sym_comment] = ACTIONS(87),
  },
  [10599] = {
    [sym__heredoc_body_start] = ACTIONS(10689),
    [sym__binary_minus] = ACTIONS(10689),
    [sym__binary_star] = ACTIONS(10689),
    [anon_sym_LBRACE] = ACTIONS(10689),
    [anon_sym_RBRACE] = ACTIONS(10689),
    [anon_sym_RPAREN] = ACTIONS(10689),
    [anon_sym_DOT] = ACTIONS(10691),
    [anon_sym_COMMA] = ACTIONS(10689),
    [anon_sym_PIPE] = ACTIONS(10691),
    [anon_sym_SEMI] = ACTIONS(10689),
    [anon_sym_STAR_STAR] = ACTIONS(10691),
    [anon_sym_AMP] = ACTIONS(10691),
    [anon_sym_EQ] = ACTIONS(10691),
    [anon_sym_LT] = ACTIONS(10691),
    [anon_sym_if] = ACTIONS(10689),
    [anon_sym_unless] = ACTIONS(10689),
    [anon_sym_while] = ACTIONS(10689),
    [anon_sym_until] = ACTIONS(10689),
    [anon_sym_rescue] = ACTIONS(10689),
    [anon_sym_in] = ACTIONS(10689),
    [anon_sym_do] = ACTIONS(10689),
    [anon_sym_LBRACK] = ACTIONS(10689),
    [anon_sym_RBRACK] = ACTIONS(10689),
    [anon_sym_COLON_COLON2] = ACTIONS(10689),
    [anon_sym_AMP_DOT] = ACTIONS(10689),
    [anon_sym_PLUS_EQ] = ACTIONS(10689),
    [anon_sym_DASH_EQ] = ACTIONS(10689),
    [anon_sym_STAR_EQ] = ACTIONS(10689),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10689),
    [anon_sym_SLASH_EQ] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10689),
    [anon_sym_PIPE_EQ] = ACTIONS(10689),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10689),
    [anon_sym_AMP_EQ] = ACTIONS(10689),
    [anon_sym_PERCENT_EQ] = ACTIONS(10689),
    [anon_sym_GT_GT_EQ] = ACTIONS(10689),
    [anon_sym_LT_LT_EQ] = ACTIONS(10689),
    [anon_sym_CARET_EQ] = ACTIONS(10689),
    [anon_sym_QMARK] = ACTIONS(10689),
    [anon_sym_COLON2] = ACTIONS(10691),
    [anon_sym_DOT_DOT] = ACTIONS(10691),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10689),
    [anon_sym_and] = ACTIONS(10689),
    [anon_sym_or] = ACTIONS(10689),
    [anon_sym_PIPE_PIPE] = ACTIONS(10691),
    [anon_sym_AMP_AMP] = ACTIONS(10691),
    [anon_sym_LT_LT] = ACTIONS(10691),
    [anon_sym_GT_GT] = ACTIONS(10691),
    [anon_sym_EQ_EQ] = ACTIONS(10691),
    [anon_sym_BANG_EQ] = ACTIONS(10689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10689),
    [anon_sym_LT_EQ_GT] = ACTIONS(10689),
    [anon_sym_EQ_TILDE] = ACTIONS(10689),
    [anon_sym_BANG_TILDE] = ACTIONS(10689),
    [anon_sym_LT_EQ] = ACTIONS(10691),
    [anon_sym_GT] = ACTIONS(10691),
    [anon_sym_GT_EQ] = ACTIONS(10689),
    [anon_sym_CARET] = ACTIONS(10691),
    [anon_sym_PLUS] = ACTIONS(10691),
    [anon_sym_SLASH] = ACTIONS(10691),
    [anon_sym_PERCENT] = ACTIONS(10691),
    [sym_comment] = ACTIONS(87),
  },
  [10600] = {
    [anon_sym_end] = ACTIONS(14687),
    [sym_comment] = ACTIONS(87),
  },
  [10601] = {
    [sym_elsif] = STATE(10925),
    [sym_else] = STATE(10925),
    [sym__if_tail] = STATE(10925),
    [anon_sym_end] = ACTIONS(14687),
    [anon_sym_elsif] = ACTIONS(7764),
    [anon_sym_else] = ACTIONS(7766),
    [sym_comment] = ACTIONS(87),
  },
  [10602] = {
    [sym__heredoc_body_start] = ACTIONS(10856),
    [sym__binary_minus] = ACTIONS(10856),
    [sym__binary_star] = ACTIONS(10856),
    [anon_sym_LBRACE] = ACTIONS(10856),
    [anon_sym_RBRACE] = ACTIONS(10856),
    [anon_sym_RPAREN] = ACTIONS(10856),
    [anon_sym_DOT] = ACTIONS(10858),
    [anon_sym_COMMA] = ACTIONS(10856),
    [anon_sym_PIPE] = ACTIONS(10858),
    [anon_sym_SEMI] = ACTIONS(10856),
    [anon_sym_STAR_STAR] = ACTIONS(10858),
    [anon_sym_AMP] = ACTIONS(10858),
    [anon_sym_EQ] = ACTIONS(10858),
    [anon_sym_LT] = ACTIONS(10858),
    [anon_sym_if] = ACTIONS(10856),
    [anon_sym_unless] = ACTIONS(10856),
    [anon_sym_while] = ACTIONS(10856),
    [anon_sym_until] = ACTIONS(10856),
    [anon_sym_rescue] = ACTIONS(10856),
    [anon_sym_in] = ACTIONS(10856),
    [anon_sym_do] = ACTIONS(10856),
    [anon_sym_LBRACK] = ACTIONS(10856),
    [anon_sym_RBRACK] = ACTIONS(10856),
    [anon_sym_COLON_COLON2] = ACTIONS(10856),
    [anon_sym_AMP_DOT] = ACTIONS(10856),
    [anon_sym_PLUS_EQ] = ACTIONS(10856),
    [anon_sym_DASH_EQ] = ACTIONS(10856),
    [anon_sym_STAR_EQ] = ACTIONS(10856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10856),
    [anon_sym_SLASH_EQ] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10856),
    [anon_sym_PIPE_EQ] = ACTIONS(10856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10856),
    [anon_sym_AMP_EQ] = ACTIONS(10856),
    [anon_sym_PERCENT_EQ] = ACTIONS(10856),
    [anon_sym_GT_GT_EQ] = ACTIONS(10856),
    [anon_sym_LT_LT_EQ] = ACTIONS(10856),
    [anon_sym_CARET_EQ] = ACTIONS(10856),
    [anon_sym_QMARK] = ACTIONS(10856),
    [anon_sym_COLON2] = ACTIONS(10858),
    [anon_sym_DOT_DOT] = ACTIONS(10858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10856),
    [anon_sym_and] = ACTIONS(10856),
    [anon_sym_or] = ACTIONS(10856),
    [anon_sym_PIPE_PIPE] = ACTIONS(10858),
    [anon_sym_AMP_AMP] = ACTIONS(10858),
    [anon_sym_LT_LT] = ACTIONS(10858),
    [anon_sym_GT_GT] = ACTIONS(10858),
    [anon_sym_EQ_EQ] = ACTIONS(10858),
    [anon_sym_BANG_EQ] = ACTIONS(10856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10856),
    [anon_sym_LT_EQ_GT] = ACTIONS(10856),
    [anon_sym_EQ_TILDE] = ACTIONS(10856),
    [anon_sym_BANG_TILDE] = ACTIONS(10856),
    [anon_sym_LT_EQ] = ACTIONS(10858),
    [anon_sym_GT] = ACTIONS(10858),
    [anon_sym_GT_EQ] = ACTIONS(10856),
    [anon_sym_CARET] = ACTIONS(10858),
    [anon_sym_PLUS] = ACTIONS(10858),
    [anon_sym_SLASH] = ACTIONS(10858),
    [anon_sym_PERCENT] = ACTIONS(10858),
    [sym_comment] = ACTIONS(87),
  },
  [10603] = {
    [anon_sym_end] = ACTIONS(14689),
    [sym_comment] = ACTIONS(87),
  },
  [10604] = {
    [sym__heredoc_body_start] = ACTIONS(10951),
    [sym__binary_minus] = ACTIONS(10951),
    [sym__binary_star] = ACTIONS(10951),
    [anon_sym_LBRACE] = ACTIONS(10951),
    [anon_sym_RBRACE] = ACTIONS(10951),
    [anon_sym_RPAREN] = ACTIONS(10951),
    [anon_sym_DOT] = ACTIONS(10953),
    [anon_sym_COMMA] = ACTIONS(10951),
    [anon_sym_PIPE] = ACTIONS(10953),
    [anon_sym_SEMI] = ACTIONS(10951),
    [anon_sym_STAR_STAR] = ACTIONS(10953),
    [anon_sym_AMP] = ACTIONS(10953),
    [anon_sym_EQ] = ACTIONS(10953),
    [anon_sym_LT] = ACTIONS(10953),
    [anon_sym_if] = ACTIONS(10951),
    [anon_sym_unless] = ACTIONS(10951),
    [anon_sym_while] = ACTIONS(10951),
    [anon_sym_until] = ACTIONS(10951),
    [anon_sym_rescue] = ACTIONS(10951),
    [anon_sym_in] = ACTIONS(10951),
    [anon_sym_do] = ACTIONS(10951),
    [anon_sym_LBRACK] = ACTIONS(10951),
    [anon_sym_RBRACK] = ACTIONS(10951),
    [anon_sym_COLON_COLON2] = ACTIONS(10951),
    [anon_sym_AMP_DOT] = ACTIONS(10951),
    [anon_sym_PLUS_EQ] = ACTIONS(10951),
    [anon_sym_DASH_EQ] = ACTIONS(10951),
    [anon_sym_STAR_EQ] = ACTIONS(10951),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10951),
    [anon_sym_SLASH_EQ] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10951),
    [anon_sym_PIPE_EQ] = ACTIONS(10951),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10951),
    [anon_sym_AMP_EQ] = ACTIONS(10951),
    [anon_sym_PERCENT_EQ] = ACTIONS(10951),
    [anon_sym_GT_GT_EQ] = ACTIONS(10951),
    [anon_sym_LT_LT_EQ] = ACTIONS(10951),
    [anon_sym_CARET_EQ] = ACTIONS(10951),
    [anon_sym_QMARK] = ACTIONS(10951),
    [anon_sym_COLON2] = ACTIONS(10953),
    [anon_sym_DOT_DOT] = ACTIONS(10953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10951),
    [anon_sym_and] = ACTIONS(10951),
    [anon_sym_or] = ACTIONS(10951),
    [anon_sym_PIPE_PIPE] = ACTIONS(10953),
    [anon_sym_AMP_AMP] = ACTIONS(10953),
    [anon_sym_LT_LT] = ACTIONS(10953),
    [anon_sym_GT_GT] = ACTIONS(10953),
    [anon_sym_EQ_EQ] = ACTIONS(10953),
    [anon_sym_BANG_EQ] = ACTIONS(10951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10951),
    [anon_sym_LT_EQ_GT] = ACTIONS(10951),
    [anon_sym_EQ_TILDE] = ACTIONS(10951),
    [anon_sym_BANG_TILDE] = ACTIONS(10951),
    [anon_sym_LT_EQ] = ACTIONS(10953),
    [anon_sym_GT] = ACTIONS(10953),
    [anon_sym_GT_EQ] = ACTIONS(10951),
    [anon_sym_CARET] = ACTIONS(10953),
    [anon_sym_PLUS] = ACTIONS(10953),
    [anon_sym_SLASH] = ACTIONS(10953),
    [anon_sym_PERCENT] = ACTIONS(10953),
    [sym_comment] = ACTIONS(87),
  },
  [10605] = {
    [sym__heredoc_body_start] = ACTIONS(10960),
    [sym__binary_minus] = ACTIONS(10960),
    [sym__binary_star] = ACTIONS(10960),
    [anon_sym_LBRACE] = ACTIONS(10960),
    [anon_sym_RBRACE] = ACTIONS(10960),
    [anon_sym_RPAREN] = ACTIONS(10960),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10960),
    [anon_sym_PIPE] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10960),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [anon_sym_AMP] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10962),
    [anon_sym_LT] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10960),
    [anon_sym_unless] = ACTIONS(10960),
    [anon_sym_while] = ACTIONS(10960),
    [anon_sym_until] = ACTIONS(10960),
    [anon_sym_rescue] = ACTIONS(10960),
    [anon_sym_in] = ACTIONS(10960),
    [anon_sym_do] = ACTIONS(10960),
    [anon_sym_LBRACK] = ACTIONS(10960),
    [anon_sym_RBRACK] = ACTIONS(10960),
    [anon_sym_COLON_COLON2] = ACTIONS(10960),
    [anon_sym_AMP_DOT] = ACTIONS(10960),
    [anon_sym_PLUS_EQ] = ACTIONS(10960),
    [anon_sym_DASH_EQ] = ACTIONS(10960),
    [anon_sym_STAR_EQ] = ACTIONS(10960),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10960),
    [anon_sym_SLASH_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10960),
    [anon_sym_PIPE_EQ] = ACTIONS(10960),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10960),
    [anon_sym_AMP_EQ] = ACTIONS(10960),
    [anon_sym_PERCENT_EQ] = ACTIONS(10960),
    [anon_sym_GT_GT_EQ] = ACTIONS(10960),
    [anon_sym_LT_LT_EQ] = ACTIONS(10960),
    [anon_sym_CARET_EQ] = ACTIONS(10960),
    [anon_sym_QMARK] = ACTIONS(10960),
    [anon_sym_COLON2] = ACTIONS(10962),
    [anon_sym_DOT_DOT] = ACTIONS(10962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10960),
    [anon_sym_and] = ACTIONS(10960),
    [anon_sym_or] = ACTIONS(10960),
    [anon_sym_PIPE_PIPE] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10962),
    [anon_sym_BANG_EQ] = ACTIONS(10960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10960),
    [anon_sym_LT_EQ_GT] = ACTIONS(10960),
    [anon_sym_EQ_TILDE] = ACTIONS(10960),
    [anon_sym_BANG_TILDE] = ACTIONS(10960),
    [anon_sym_LT_EQ] = ACTIONS(10962),
    [anon_sym_GT] = ACTIONS(10962),
    [anon_sym_GT_EQ] = ACTIONS(10960),
    [anon_sym_CARET] = ACTIONS(10962),
    [anon_sym_PLUS] = ACTIONS(10962),
    [anon_sym_SLASH] = ACTIONS(10962),
    [anon_sym_PERCENT] = ACTIONS(10962),
    [sym_comment] = ACTIONS(87),
  },
  [10606] = {
    [sym__heredoc_body_start] = ACTIONS(11007),
    [sym__binary_minus] = ACTIONS(11007),
    [sym__binary_star] = ACTIONS(11007),
    [anon_sym_LBRACE] = ACTIONS(11007),
    [anon_sym_RBRACE] = ACTIONS(11007),
    [anon_sym_RPAREN] = ACTIONS(11007),
    [anon_sym_DOT] = ACTIONS(11009),
    [anon_sym_COMMA] = ACTIONS(11007),
    [anon_sym_PIPE] = ACTIONS(11009),
    [anon_sym_SEMI] = ACTIONS(11007),
    [anon_sym_STAR_STAR] = ACTIONS(11009),
    [anon_sym_AMP] = ACTIONS(11009),
    [anon_sym_EQ] = ACTIONS(11009),
    [anon_sym_LT] = ACTIONS(11009),
    [anon_sym_if] = ACTIONS(11007),
    [anon_sym_unless] = ACTIONS(11007),
    [anon_sym_while] = ACTIONS(11007),
    [anon_sym_until] = ACTIONS(11007),
    [anon_sym_rescue] = ACTIONS(11007),
    [anon_sym_in] = ACTIONS(11007),
    [anon_sym_do] = ACTIONS(11007),
    [anon_sym_LBRACK] = ACTIONS(11007),
    [anon_sym_RBRACK] = ACTIONS(11007),
    [anon_sym_COLON_COLON2] = ACTIONS(11007),
    [anon_sym_AMP_DOT] = ACTIONS(11007),
    [anon_sym_PLUS_EQ] = ACTIONS(11007),
    [anon_sym_DASH_EQ] = ACTIONS(11007),
    [anon_sym_STAR_EQ] = ACTIONS(11007),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11007),
    [anon_sym_SLASH_EQ] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11007),
    [anon_sym_PIPE_EQ] = ACTIONS(11007),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11007),
    [anon_sym_AMP_EQ] = ACTIONS(11007),
    [anon_sym_PERCENT_EQ] = ACTIONS(11007),
    [anon_sym_GT_GT_EQ] = ACTIONS(11007),
    [anon_sym_LT_LT_EQ] = ACTIONS(11007),
    [anon_sym_CARET_EQ] = ACTIONS(11007),
    [anon_sym_QMARK] = ACTIONS(11007),
    [anon_sym_COLON2] = ACTIONS(11009),
    [anon_sym_DOT_DOT] = ACTIONS(11009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11007),
    [anon_sym_and] = ACTIONS(11007),
    [anon_sym_or] = ACTIONS(11007),
    [anon_sym_PIPE_PIPE] = ACTIONS(11009),
    [anon_sym_AMP_AMP] = ACTIONS(11009),
    [anon_sym_LT_LT] = ACTIONS(11009),
    [anon_sym_GT_GT] = ACTIONS(11009),
    [anon_sym_EQ_EQ] = ACTIONS(11009),
    [anon_sym_BANG_EQ] = ACTIONS(11007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11007),
    [anon_sym_LT_EQ_GT] = ACTIONS(11007),
    [anon_sym_EQ_TILDE] = ACTIONS(11007),
    [anon_sym_BANG_TILDE] = ACTIONS(11007),
    [anon_sym_LT_EQ] = ACTIONS(11009),
    [anon_sym_GT] = ACTIONS(11009),
    [anon_sym_GT_EQ] = ACTIONS(11007),
    [anon_sym_CARET] = ACTIONS(11009),
    [anon_sym_PLUS] = ACTIONS(11009),
    [anon_sym_SLASH] = ACTIONS(11009),
    [anon_sym_PERCENT] = ACTIONS(11009),
    [sym_comment] = ACTIONS(87),
  },
  [10607] = {
    [anon_sym_end] = ACTIONS(14691),
    [sym_comment] = ACTIONS(87),
  },
  [10608] = {
    [sym__heredoc_body_start] = ACTIONS(11020),
    [sym__binary_minus] = ACTIONS(11020),
    [sym__binary_star] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_RBRACE] = ACTIONS(11020),
    [anon_sym_RPAREN] = ACTIONS(11020),
    [anon_sym_DOT] = ACTIONS(11022),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_PIPE] = ACTIONS(11022),
    [anon_sym_SEMI] = ACTIONS(11020),
    [anon_sym_STAR_STAR] = ACTIONS(11022),
    [anon_sym_AMP] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(11022),
    [anon_sym_LT] = ACTIONS(11022),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_unless] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [anon_sym_until] = ACTIONS(11020),
    [anon_sym_rescue] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_do] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_RBRACK] = ACTIONS(11020),
    [anon_sym_COLON_COLON2] = ACTIONS(11020),
    [anon_sym_AMP_DOT] = ACTIONS(11020),
    [anon_sym_PLUS_EQ] = ACTIONS(11020),
    [anon_sym_DASH_EQ] = ACTIONS(11020),
    [anon_sym_STAR_EQ] = ACTIONS(11020),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11020),
    [anon_sym_SLASH_EQ] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11020),
    [anon_sym_PIPE_EQ] = ACTIONS(11020),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11020),
    [anon_sym_AMP_EQ] = ACTIONS(11020),
    [anon_sym_PERCENT_EQ] = ACTIONS(11020),
    [anon_sym_GT_GT_EQ] = ACTIONS(11020),
    [anon_sym_LT_LT_EQ] = ACTIONS(11020),
    [anon_sym_CARET_EQ] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11022),
    [anon_sym_DOT_DOT] = ACTIONS(11022),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_and] = ACTIONS(11020),
    [anon_sym_or] = ACTIONS(11020),
    [anon_sym_PIPE_PIPE] = ACTIONS(11022),
    [anon_sym_AMP_AMP] = ACTIONS(11022),
    [anon_sym_LT_LT] = ACTIONS(11022),
    [anon_sym_GT_GT] = ACTIONS(11022),
    [anon_sym_EQ_EQ] = ACTIONS(11022),
    [anon_sym_BANG_EQ] = ACTIONS(11020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11020),
    [anon_sym_LT_EQ_GT] = ACTIONS(11020),
    [anon_sym_EQ_TILDE] = ACTIONS(11020),
    [anon_sym_BANG_TILDE] = ACTIONS(11020),
    [anon_sym_LT_EQ] = ACTIONS(11022),
    [anon_sym_GT] = ACTIONS(11022),
    [anon_sym_GT_EQ] = ACTIONS(11020),
    [anon_sym_CARET] = ACTIONS(11022),
    [anon_sym_PLUS] = ACTIONS(11022),
    [anon_sym_SLASH] = ACTIONS(11022),
    [anon_sym_PERCENT] = ACTIONS(11022),
    [sym_comment] = ACTIONS(87),
  },
  [10609] = {
    [anon_sym_end] = ACTIONS(14693),
    [sym_comment] = ACTIONS(87),
  },
  [10610] = {
    [sym__heredoc_body_start] = ACTIONS(11466),
    [sym__binary_minus] = ACTIONS(11466),
    [sym__binary_star] = ACTIONS(11466),
    [anon_sym_LBRACE] = ACTIONS(11466),
    [anon_sym_RBRACE] = ACTIONS(11466),
    [anon_sym_RPAREN] = ACTIONS(11466),
    [anon_sym_DOT] = ACTIONS(11468),
    [anon_sym_COMMA] = ACTIONS(11466),
    [anon_sym_PIPE] = ACTIONS(11468),
    [anon_sym_SEMI] = ACTIONS(11466),
    [anon_sym_STAR_STAR] = ACTIONS(11468),
    [anon_sym_AMP] = ACTIONS(11468),
    [anon_sym_EQ] = ACTIONS(11468),
    [anon_sym_LT] = ACTIONS(11468),
    [anon_sym_if] = ACTIONS(11466),
    [anon_sym_unless] = ACTIONS(11466),
    [anon_sym_while] = ACTIONS(11466),
    [anon_sym_until] = ACTIONS(11466),
    [anon_sym_rescue] = ACTIONS(11466),
    [anon_sym_in] = ACTIONS(11466),
    [anon_sym_do] = ACTIONS(11466),
    [anon_sym_LBRACK] = ACTIONS(11466),
    [anon_sym_RBRACK] = ACTIONS(11466),
    [anon_sym_COLON_COLON2] = ACTIONS(11466),
    [anon_sym_AMP_DOT] = ACTIONS(11466),
    [anon_sym_PLUS_EQ] = ACTIONS(11466),
    [anon_sym_DASH_EQ] = ACTIONS(11466),
    [anon_sym_STAR_EQ] = ACTIONS(11466),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11466),
    [anon_sym_SLASH_EQ] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11466),
    [anon_sym_PIPE_EQ] = ACTIONS(11466),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11466),
    [anon_sym_AMP_EQ] = ACTIONS(11466),
    [anon_sym_PERCENT_EQ] = ACTIONS(11466),
    [anon_sym_GT_GT_EQ] = ACTIONS(11466),
    [anon_sym_LT_LT_EQ] = ACTIONS(11466),
    [anon_sym_CARET_EQ] = ACTIONS(11466),
    [anon_sym_QMARK] = ACTIONS(11466),
    [anon_sym_COLON2] = ACTIONS(11468),
    [anon_sym_DOT_DOT] = ACTIONS(11468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11466),
    [anon_sym_and] = ACTIONS(11466),
    [anon_sym_or] = ACTIONS(11466),
    [anon_sym_PIPE_PIPE] = ACTIONS(11468),
    [anon_sym_AMP_AMP] = ACTIONS(11468),
    [anon_sym_LT_LT] = ACTIONS(11468),
    [anon_sym_GT_GT] = ACTIONS(11468),
    [anon_sym_EQ_EQ] = ACTIONS(11468),
    [anon_sym_BANG_EQ] = ACTIONS(11466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11466),
    [anon_sym_LT_EQ_GT] = ACTIONS(11466),
    [anon_sym_EQ_TILDE] = ACTIONS(11466),
    [anon_sym_BANG_TILDE] = ACTIONS(11466),
    [anon_sym_LT_EQ] = ACTIONS(11468),
    [anon_sym_GT] = ACTIONS(11468),
    [anon_sym_GT_EQ] = ACTIONS(11466),
    [anon_sym_CARET] = ACTIONS(11468),
    [anon_sym_PLUS] = ACTIONS(11468),
    [anon_sym_SLASH] = ACTIONS(11468),
    [anon_sym_PERCENT] = ACTIONS(11468),
    [sym_comment] = ACTIONS(87),
  },
  [10611] = {
    [anon_sym_end] = ACTIONS(14695),
    [sym_comment] = ACTIONS(87),
  },
  [10612] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(9707),
    [sym__binary_star] = ACTIONS(9709),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9711),
    [anon_sym_STAR_STAR] = ACTIONS(9713),
    [anon_sym_AMP] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(9717),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(9719),
    [anon_sym_DOT_DOT] = ACTIONS(9721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9723),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(9725),
    [anon_sym_AMP_AMP] = ACTIONS(9725),
    [anon_sym_LT_LT] = ACTIONS(9727),
    [anon_sym_GT_GT] = ACTIONS(9727),
    [anon_sym_EQ_EQ] = ACTIONS(9725),
    [anon_sym_BANG_EQ] = ACTIONS(9729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9729),
    [anon_sym_LT_EQ_GT] = ACTIONS(9729),
    [anon_sym_EQ_TILDE] = ACTIONS(9729),
    [anon_sym_BANG_TILDE] = ACTIONS(9729),
    [anon_sym_LT_EQ] = ACTIONS(9717),
    [anon_sym_GT] = ACTIONS(9717),
    [anon_sym_GT_EQ] = ACTIONS(9731),
    [anon_sym_CARET] = ACTIONS(9711),
    [anon_sym_PLUS] = ACTIONS(9733),
    [anon_sym_SLASH] = ACTIONS(9713),
    [anon_sym_PERCENT] = ACTIONS(9713),
    [sym_comment] = ACTIONS(87),
  },
  [10613] = {
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11972),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10614] = {
    [aux_sym_exceptions_repeat1] = STATE(10614),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14697),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10615] = {
    [sym__binary_minus] = ACTIONS(14146),
    [sym__binary_star] = ACTIONS(14146),
    [anon_sym_LBRACE] = ACTIONS(14146),
    [anon_sym_RBRACE] = ACTIONS(14146),
    [anon_sym_RPAREN] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14148),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14148),
    [anon_sym_SEMI] = ACTIONS(14146),
    [anon_sym_STAR_STAR] = ACTIONS(14148),
    [anon_sym_AMP] = ACTIONS(14148),
    [anon_sym_EQ] = ACTIONS(14148),
    [anon_sym_LT] = ACTIONS(14148),
    [anon_sym_if] = ACTIONS(14146),
    [anon_sym_unless] = ACTIONS(14146),
    [anon_sym_while] = ACTIONS(14146),
    [anon_sym_until] = ACTIONS(14146),
    [anon_sym_rescue] = ACTIONS(14146),
    [anon_sym_do] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [anon_sym_PLUS_EQ] = ACTIONS(14146),
    [anon_sym_DASH_EQ] = ACTIONS(14146),
    [anon_sym_STAR_EQ] = ACTIONS(14146),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14146),
    [anon_sym_SLASH_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14146),
    [anon_sym_AMP_EQ] = ACTIONS(14146),
    [anon_sym_PERCENT_EQ] = ACTIONS(14146),
    [anon_sym_GT_GT_EQ] = ACTIONS(14146),
    [anon_sym_LT_LT_EQ] = ACTIONS(14146),
    [anon_sym_CARET_EQ] = ACTIONS(14146),
    [anon_sym_QMARK] = ACTIONS(14146),
    [anon_sym_COLON2] = ACTIONS(14148),
    [anon_sym_DOT_DOT] = ACTIONS(14148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14146),
    [anon_sym_and] = ACTIONS(14146),
    [anon_sym_or] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE] = ACTIONS(14148),
    [anon_sym_AMP_AMP] = ACTIONS(14148),
    [anon_sym_LT_LT] = ACTIONS(14148),
    [anon_sym_GT_GT] = ACTIONS(14148),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_BANG_EQ] = ACTIONS(14146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14146),
    [anon_sym_LT_EQ_GT] = ACTIONS(14146),
    [anon_sym_EQ_TILDE] = ACTIONS(14146),
    [anon_sym_BANG_TILDE] = ACTIONS(14146),
    [anon_sym_LT_EQ] = ACTIONS(14148),
    [anon_sym_GT] = ACTIONS(14148),
    [anon_sym_GT_EQ] = ACTIONS(14146),
    [anon_sym_CARET] = ACTIONS(14148),
    [anon_sym_PLUS] = ACTIONS(14148),
    [anon_sym_SLASH] = ACTIONS(14148),
    [anon_sym_PERCENT] = ACTIONS(14148),
    [sym_comment] = ACTIONS(87),
  },
  [10616] = {
    [sym__binary_minus] = ACTIONS(9759),
    [sym__binary_star] = ACTIONS(9761),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9763),
    [anon_sym_STAR_STAR] = ACTIONS(9761),
    [anon_sym_AMP] = ACTIONS(9765),
    [anon_sym_LT] = ACTIONS(9767),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(9769),
    [anon_sym_DOT_DOT] = ACTIONS(9771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9773),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(9775),
    [anon_sym_AMP_AMP] = ACTIONS(9775),
    [anon_sym_LT_LT] = ACTIONS(9777),
    [anon_sym_GT_GT] = ACTIONS(9777),
    [anon_sym_EQ_EQ] = ACTIONS(9779),
    [anon_sym_BANG_EQ] = ACTIONS(9775),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9775),
    [anon_sym_LT_EQ_GT] = ACTIONS(9775),
    [anon_sym_EQ_TILDE] = ACTIONS(9775),
    [anon_sym_BANG_TILDE] = ACTIONS(9775),
    [anon_sym_LT_EQ] = ACTIONS(9767),
    [anon_sym_GT] = ACTIONS(9767),
    [anon_sym_GT_EQ] = ACTIONS(9781),
    [anon_sym_CARET] = ACTIONS(9783),
    [anon_sym_PLUS] = ACTIONS(9759),
    [anon_sym_SLASH] = ACTIONS(9761),
    [anon_sym_PERCENT] = ACTIONS(9761),
    [sym_comment] = ACTIONS(87),
  },
  [10617] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(9813),
    [sym__binary_star] = ACTIONS(9815),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9817),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(9815),
    [anon_sym_AMP] = ACTIONS(9819),
    [anon_sym_LT] = ACTIONS(9821),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(9823),
    [anon_sym_DOT_DOT] = ACTIONS(9825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9827),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(9829),
    [anon_sym_AMP_AMP] = ACTIONS(9829),
    [anon_sym_LT_LT] = ACTIONS(9831),
    [anon_sym_GT_GT] = ACTIONS(9831),
    [anon_sym_EQ_EQ] = ACTIONS(9833),
    [anon_sym_BANG_EQ] = ACTIONS(9829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9829),
    [anon_sym_LT_EQ_GT] = ACTIONS(9829),
    [anon_sym_EQ_TILDE] = ACTIONS(9829),
    [anon_sym_BANG_TILDE] = ACTIONS(9829),
    [anon_sym_LT_EQ] = ACTIONS(9821),
    [anon_sym_GT] = ACTIONS(9821),
    [anon_sym_GT_EQ] = ACTIONS(9835),
    [anon_sym_CARET] = ACTIONS(9837),
    [anon_sym_PLUS] = ACTIONS(9813),
    [anon_sym_SLASH] = ACTIONS(9815),
    [anon_sym_PERCENT] = ACTIONS(9815),
    [sym_comment] = ACTIONS(87),
  },
  [10618] = {
    [aux_sym_exceptions_repeat1] = STATE(10618),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14700),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10619] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(9852),
    [sym__binary_star] = ACTIONS(9854),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9856),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(9858),
    [anon_sym_AMP] = ACTIONS(9860),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(9862),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(9864),
    [anon_sym_DOT_DOT] = ACTIONS(9866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9868),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(9870),
    [anon_sym_AMP_AMP] = ACTIONS(9870),
    [anon_sym_LT_LT] = ACTIONS(9872),
    [anon_sym_GT_GT] = ACTIONS(9872),
    [anon_sym_EQ_EQ] = ACTIONS(9870),
    [anon_sym_BANG_EQ] = ACTIONS(9874),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9874),
    [anon_sym_LT_EQ_GT] = ACTIONS(9874),
    [anon_sym_EQ_TILDE] = ACTIONS(9874),
    [anon_sym_BANG_TILDE] = ACTIONS(9874),
    [anon_sym_LT_EQ] = ACTIONS(9862),
    [anon_sym_GT] = ACTIONS(9862),
    [anon_sym_GT_EQ] = ACTIONS(9876),
    [anon_sym_CARET] = ACTIONS(9856),
    [anon_sym_PLUS] = ACTIONS(9878),
    [anon_sym_SLASH] = ACTIONS(9858),
    [anon_sym_PERCENT] = ACTIONS(9858),
    [sym_comment] = ACTIONS(87),
  },
  [10620] = {
    [aux_sym_exceptions_repeat1] = STATE(10620),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14703),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10621] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(9888),
    [sym__binary_star] = ACTIONS(9890),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9892),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(9890),
    [anon_sym_AMP] = ACTIONS(9894),
    [anon_sym_LT] = ACTIONS(9896),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DOT_DOT] = ACTIONS(9900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9902),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(9904),
    [anon_sym_AMP_AMP] = ACTIONS(9904),
    [anon_sym_LT_LT] = ACTIONS(9906),
    [anon_sym_GT_GT] = ACTIONS(9906),
    [anon_sym_EQ_EQ] = ACTIONS(9908),
    [anon_sym_BANG_EQ] = ACTIONS(9904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9904),
    [anon_sym_LT_EQ_GT] = ACTIONS(9904),
    [anon_sym_EQ_TILDE] = ACTIONS(9904),
    [anon_sym_BANG_TILDE] = ACTIONS(9904),
    [anon_sym_LT_EQ] = ACTIONS(9896),
    [anon_sym_GT] = ACTIONS(9896),
    [anon_sym_GT_EQ] = ACTIONS(9910),
    [anon_sym_CARET] = ACTIONS(9912),
    [anon_sym_PLUS] = ACTIONS(9888),
    [anon_sym_SLASH] = ACTIONS(9890),
    [anon_sym_PERCENT] = ACTIONS(9890),
    [sym_comment] = ACTIONS(87),
  },
  [10622] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(9936),
    [sym__binary_star] = ACTIONS(9938),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9940),
    [anon_sym_STAR_STAR] = ACTIONS(9938),
    [anon_sym_AMP] = ACTIONS(9942),
    [anon_sym_LT] = ACTIONS(9944),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(9946),
    [anon_sym_DOT_DOT] = ACTIONS(9948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9950),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(9952),
    [anon_sym_AMP_AMP] = ACTIONS(9952),
    [anon_sym_LT_LT] = ACTIONS(9954),
    [anon_sym_GT_GT] = ACTIONS(9954),
    [anon_sym_EQ_EQ] = ACTIONS(9956),
    [anon_sym_BANG_EQ] = ACTIONS(9952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9952),
    [anon_sym_LT_EQ_GT] = ACTIONS(9952),
    [anon_sym_EQ_TILDE] = ACTIONS(9952),
    [anon_sym_BANG_TILDE] = ACTIONS(9952),
    [anon_sym_LT_EQ] = ACTIONS(9944),
    [anon_sym_GT] = ACTIONS(9944),
    [anon_sym_GT_EQ] = ACTIONS(9958),
    [anon_sym_CARET] = ACTIONS(9960),
    [anon_sym_PLUS] = ACTIONS(9936),
    [anon_sym_SLASH] = ACTIONS(9938),
    [anon_sym_PERCENT] = ACTIONS(9938),
    [sym_comment] = ACTIONS(87),
  },
  [10623] = {
    [aux_sym_exceptions_repeat1] = STATE(10623),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14706),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10624] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(9994),
    [sym__binary_star] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(9998),
    [anon_sym_STAR_STAR] = ACTIONS(10000),
    [anon_sym_AMP] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(10004),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DOT_DOT] = ACTIONS(10008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(10012),
    [anon_sym_AMP_AMP] = ACTIONS(10012),
    [anon_sym_LT_LT] = ACTIONS(10014),
    [anon_sym_GT_GT] = ACTIONS(10014),
    [anon_sym_EQ_EQ] = ACTIONS(10012),
    [anon_sym_BANG_EQ] = ACTIONS(10016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10016),
    [anon_sym_LT_EQ_GT] = ACTIONS(10016),
    [anon_sym_EQ_TILDE] = ACTIONS(10016),
    [anon_sym_BANG_TILDE] = ACTIONS(10016),
    [anon_sym_LT_EQ] = ACTIONS(10004),
    [anon_sym_GT] = ACTIONS(10004),
    [anon_sym_GT_EQ] = ACTIONS(10018),
    [anon_sym_CARET] = ACTIONS(9998),
    [anon_sym_PLUS] = ACTIONS(10020),
    [anon_sym_SLASH] = ACTIONS(10000),
    [anon_sym_PERCENT] = ACTIONS(10000),
    [sym_comment] = ACTIONS(87),
  },
  [10625] = {
    [aux_sym_exceptions_repeat1] = STATE(10625),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14709),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10626] = {
    [sym__heredoc_body_start] = ACTIONS(14146),
    [sym__binary_minus] = ACTIONS(14146),
    [sym__binary_star] = ACTIONS(14146),
    [anon_sym_LBRACE] = ACTIONS(14146),
    [anon_sym_RBRACE] = ACTIONS(14146),
    [anon_sym_RPAREN] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14148),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14148),
    [anon_sym_SEMI] = ACTIONS(14146),
    [anon_sym_STAR_STAR] = ACTIONS(14148),
    [anon_sym_AMP] = ACTIONS(14148),
    [anon_sym_EQ] = ACTIONS(14148),
    [anon_sym_LT] = ACTIONS(14148),
    [anon_sym_if] = ACTIONS(14146),
    [anon_sym_unless] = ACTIONS(14146),
    [anon_sym_while] = ACTIONS(14146),
    [anon_sym_until] = ACTIONS(14146),
    [anon_sym_rescue] = ACTIONS(14146),
    [anon_sym_in] = ACTIONS(14146),
    [anon_sym_do] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_RBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [anon_sym_PLUS_EQ] = ACTIONS(14146),
    [anon_sym_DASH_EQ] = ACTIONS(14146),
    [anon_sym_STAR_EQ] = ACTIONS(14146),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14146),
    [anon_sym_SLASH_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_PIPE_EQ] = ACTIONS(14146),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14146),
    [anon_sym_AMP_EQ] = ACTIONS(14146),
    [anon_sym_PERCENT_EQ] = ACTIONS(14146),
    [anon_sym_GT_GT_EQ] = ACTIONS(14146),
    [anon_sym_LT_LT_EQ] = ACTIONS(14146),
    [anon_sym_CARET_EQ] = ACTIONS(14146),
    [anon_sym_QMARK] = ACTIONS(14146),
    [anon_sym_COLON2] = ACTIONS(14148),
    [anon_sym_DOT_DOT] = ACTIONS(14148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14146),
    [anon_sym_and] = ACTIONS(14146),
    [anon_sym_or] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE] = ACTIONS(14148),
    [anon_sym_AMP_AMP] = ACTIONS(14148),
    [anon_sym_LT_LT] = ACTIONS(14148),
    [anon_sym_GT_GT] = ACTIONS(14148),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_BANG_EQ] = ACTIONS(14146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14146),
    [anon_sym_LT_EQ_GT] = ACTIONS(14146),
    [anon_sym_EQ_TILDE] = ACTIONS(14146),
    [anon_sym_BANG_TILDE] = ACTIONS(14146),
    [anon_sym_LT_EQ] = ACTIONS(14148),
    [anon_sym_GT] = ACTIONS(14148),
    [anon_sym_GT_EQ] = ACTIONS(14146),
    [anon_sym_CARET] = ACTIONS(14148),
    [anon_sym_PLUS] = ACTIONS(14148),
    [anon_sym_SLASH] = ACTIONS(14148),
    [anon_sym_PERCENT] = ACTIONS(14148),
    [sym_comment] = ACTIONS(87),
  },
  [10627] = {
    [sym__heredoc_body_start] = ACTIONS(13660),
    [sym__binary_minus] = ACTIONS(13660),
    [sym__binary_star] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_RBRACE] = ACTIONS(13660),
    [anon_sym_RPAREN] = ACTIONS(13660),
    [anon_sym_DOT] = ACTIONS(13662),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_PIPE] = ACTIONS(13662),
    [anon_sym_SEMI] = ACTIONS(13660),
    [anon_sym_STAR_STAR] = ACTIONS(13662),
    [anon_sym_AMP] = ACTIONS(13662),
    [anon_sym_EQ] = ACTIONS(13662),
    [anon_sym_LT] = ACTIONS(13662),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_unless] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [anon_sym_until] = ACTIONS(13660),
    [anon_sym_rescue] = ACTIONS(13660),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_do] = ACTIONS(13660),
    [anon_sym_EQ_GT] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_RBRACK] = ACTIONS(13660),
    [anon_sym_COLON_COLON2] = ACTIONS(13660),
    [anon_sym_AMP_DOT] = ACTIONS(13660),
    [anon_sym_PLUS_EQ] = ACTIONS(13660),
    [anon_sym_DASH_EQ] = ACTIONS(13660),
    [anon_sym_STAR_EQ] = ACTIONS(13660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13660),
    [anon_sym_SLASH_EQ] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13660),
    [anon_sym_PIPE_EQ] = ACTIONS(13660),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13660),
    [anon_sym_AMP_EQ] = ACTIONS(13660),
    [anon_sym_PERCENT_EQ] = ACTIONS(13660),
    [anon_sym_GT_GT_EQ] = ACTIONS(13660),
    [anon_sym_LT_LT_EQ] = ACTIONS(13660),
    [anon_sym_CARET_EQ] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13662),
    [anon_sym_DOT_DOT] = ACTIONS(13662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_and] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE] = ACTIONS(13662),
    [anon_sym_AMP_AMP] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13662),
    [anon_sym_GT_GT] = ACTIONS(13662),
    [anon_sym_EQ_EQ] = ACTIONS(13662),
    [anon_sym_BANG_EQ] = ACTIONS(13660),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13660),
    [anon_sym_LT_EQ_GT] = ACTIONS(13660),
    [anon_sym_EQ_TILDE] = ACTIONS(13660),
    [anon_sym_BANG_TILDE] = ACTIONS(13660),
    [anon_sym_LT_EQ] = ACTIONS(13662),
    [anon_sym_GT] = ACTIONS(13662),
    [anon_sym_GT_EQ] = ACTIONS(13660),
    [anon_sym_CARET] = ACTIONS(13662),
    [anon_sym_PLUS] = ACTIONS(13662),
    [anon_sym_SLASH] = ACTIONS(13662),
    [anon_sym_PERCENT] = ACTIONS(13662),
    [sym_comment] = ACTIONS(87),
  },
  [10628] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(10167),
    [sym__binary_star] = ACTIONS(10169),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(10171),
    [anon_sym_STAR_STAR] = ACTIONS(10169),
    [anon_sym_AMP] = ACTIONS(10173),
    [anon_sym_LT] = ACTIONS(10175),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(10177),
    [anon_sym_DOT_DOT] = ACTIONS(10179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10181),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(10183),
    [anon_sym_AMP_AMP] = ACTIONS(10183),
    [anon_sym_LT_LT] = ACTIONS(10185),
    [anon_sym_GT_GT] = ACTIONS(10185),
    [anon_sym_EQ_EQ] = ACTIONS(10187),
    [anon_sym_BANG_EQ] = ACTIONS(10183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10183),
    [anon_sym_LT_EQ_GT] = ACTIONS(10183),
    [anon_sym_EQ_TILDE] = ACTIONS(10183),
    [anon_sym_BANG_TILDE] = ACTIONS(10183),
    [anon_sym_LT_EQ] = ACTIONS(10175),
    [anon_sym_GT] = ACTIONS(10175),
    [anon_sym_GT_EQ] = ACTIONS(10189),
    [anon_sym_CARET] = ACTIONS(10191),
    [anon_sym_PLUS] = ACTIONS(10167),
    [anon_sym_SLASH] = ACTIONS(10169),
    [anon_sym_PERCENT] = ACTIONS(10169),
    [sym_comment] = ACTIONS(87),
  },
  [10629] = {
    [aux_sym_exceptions_repeat1] = STATE(10629),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14712),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10630] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(10203),
    [sym__binary_star] = ACTIONS(10205),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(10207),
    [anon_sym_STAR_STAR] = ACTIONS(10209),
    [anon_sym_AMP] = ACTIONS(10211),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(10213),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(10215),
    [anon_sym_DOT_DOT] = ACTIONS(10217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10219),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(10221),
    [anon_sym_AMP_AMP] = ACTIONS(10221),
    [anon_sym_LT_LT] = ACTIONS(10223),
    [anon_sym_GT_GT] = ACTIONS(10223),
    [anon_sym_EQ_EQ] = ACTIONS(10221),
    [anon_sym_BANG_EQ] = ACTIONS(10225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10225),
    [anon_sym_LT_EQ_GT] = ACTIONS(10225),
    [anon_sym_EQ_TILDE] = ACTIONS(10225),
    [anon_sym_BANG_TILDE] = ACTIONS(10225),
    [anon_sym_LT_EQ] = ACTIONS(10213),
    [anon_sym_GT] = ACTIONS(10213),
    [anon_sym_GT_EQ] = ACTIONS(10227),
    [anon_sym_CARET] = ACTIONS(10207),
    [anon_sym_PLUS] = ACTIONS(10229),
    [anon_sym_SLASH] = ACTIONS(10209),
    [anon_sym_PERCENT] = ACTIONS(10209),
    [sym_comment] = ACTIONS(87),
  },
  [10631] = {
    [aux_sym_exceptions_repeat1] = STATE(10631),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14715),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10632] = {
    [sym__binary_minus] = ACTIONS(10239),
    [sym__binary_star] = ACTIONS(10241),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(10243),
    [anon_sym_STAR_STAR] = ACTIONS(10241),
    [anon_sym_AMP] = ACTIONS(10245),
    [anon_sym_LT] = ACTIONS(10247),
    [anon_sym_QMARK] = ACTIONS(10249),
    [anon_sym_DOT_DOT] = ACTIONS(10251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10253),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(10255),
    [anon_sym_AMP_AMP] = ACTIONS(10255),
    [anon_sym_LT_LT] = ACTIONS(10257),
    [anon_sym_GT_GT] = ACTIONS(10257),
    [anon_sym_EQ_EQ] = ACTIONS(10259),
    [anon_sym_BANG_EQ] = ACTIONS(10255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10255),
    [anon_sym_LT_EQ_GT] = ACTIONS(10255),
    [anon_sym_EQ_TILDE] = ACTIONS(10255),
    [anon_sym_BANG_TILDE] = ACTIONS(10255),
    [anon_sym_LT_EQ] = ACTIONS(10247),
    [anon_sym_GT] = ACTIONS(10247),
    [anon_sym_GT_EQ] = ACTIONS(10261),
    [anon_sym_CARET] = ACTIONS(10263),
    [anon_sym_PLUS] = ACTIONS(10239),
    [anon_sym_SLASH] = ACTIONS(10241),
    [anon_sym_PERCENT] = ACTIONS(10241),
    [sym_comment] = ACTIONS(87),
  },
  [10633] = {
    [sym__line_break] = ACTIONS(13264),
    [sym__heredoc_body_start] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13264),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_SEMI] = ACTIONS(13264),
    [anon_sym_then] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [sym_comment] = ACTIONS(87),
  },
  [10634] = {
    [anon_sym_end] = ACTIONS(14718),
    [sym_comment] = ACTIONS(87),
  },
  [10635] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(10301),
    [sym__binary_star] = ACTIONS(10303),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_RPAREN] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(10305),
    [anon_sym_STAR_STAR] = ACTIONS(10303),
    [anon_sym_AMP] = ACTIONS(10307),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(10309),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(10311),
    [anon_sym_DOT_DOT] = ACTIONS(10313),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10315),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(10319),
    [anon_sym_AMP_AMP] = ACTIONS(10319),
    [anon_sym_LT_LT] = ACTIONS(10321),
    [anon_sym_GT_GT] = ACTIONS(10321),
    [anon_sym_EQ_EQ] = ACTIONS(10323),
    [anon_sym_BANG_EQ] = ACTIONS(10319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10319),
    [anon_sym_LT_EQ_GT] = ACTIONS(10319),
    [anon_sym_EQ_TILDE] = ACTIONS(10319),
    [anon_sym_BANG_TILDE] = ACTIONS(10319),
    [anon_sym_LT_EQ] = ACTIONS(10309),
    [anon_sym_GT] = ACTIONS(10309),
    [anon_sym_GT_EQ] = ACTIONS(10325),
    [anon_sym_CARET] = ACTIONS(10327),
    [anon_sym_PLUS] = ACTIONS(10301),
    [anon_sym_SLASH] = ACTIONS(10303),
    [anon_sym_PERCENT] = ACTIONS(10303),
    [sym_comment] = ACTIONS(87),
  },
  [10636] = {
    [aux_sym_exceptions_repeat1] = STATE(10636),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_RPAREN] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14720),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10637] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10931),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_assignment] = STATE(10931),
    [sym_operator_assignment] = STATE(10931),
    [sym_conditional] = STATE(10931),
    [sym_range] = STATE(10931),
    [sym_binary] = STATE(10931),
    [sym_unary] = STATE(10931),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10638] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10027),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7092),
    [sym_scope_resolution] = STATE(2336),
    [sym_call] = STATE(2336),
    [sym_method_call] = STATE(7092),
    [sym_splat_argument] = STATE(10613),
    [sym_assignment] = STATE(10027),
    [sym_operator_assignment] = STATE(10027),
    [sym_conditional] = STATE(10027),
    [sym_range] = STATE(10027),
    [sym_binary] = STATE(10027),
    [sym_unary] = STATE(10027),
    [sym__arg_or_splat_arg] = STATE(10613),
    [sym_left_assignment_list] = STATE(7091),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7092),
    [sym__variable] = STATE(2336),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7092),
    [sym_false] = STATE(7092),
    [sym_nil] = STATE(7092),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7093),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(7337),
    [sym__unary_minus] = ACTIONS(10383),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10385),
    [anon_sym_yield] = ACTIONS(10387),
    [anon_sym_break] = ACTIONS(10389),
    [anon_sym_next] = ACTIONS(10391),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10393),
    [anon_sym_defined_QMARK] = ACTIONS(10395),
    [anon_sym_not] = ACTIONS(10397),
    [anon_sym_BANG] = ACTIONS(10399),
    [anon_sym_TILDE] = ACTIONS(10399),
    [sym_constant] = ACTIONS(3924),
    [sym_identifier] = ACTIONS(3924),
    [sym_instance_variable] = ACTIONS(3926),
    [sym_class_variable] = ACTIONS(3926),
    [sym_global_variable] = ACTIONS(3926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(3924),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(3924),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10639] = {
    [aux_sym_exceptions_repeat1] = STATE(10932),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14723),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10640] = {
    [sym__heredoc_body_start] = ACTIONS(12069),
    [sym__binary_minus] = ACTIONS(12069),
    [sym__binary_star] = ACTIONS(12069),
    [anon_sym_LBRACE] = ACTIONS(12069),
    [anon_sym_RPAREN] = ACTIONS(12069),
    [anon_sym_DOT] = ACTIONS(12071),
    [anon_sym_COMMA] = ACTIONS(12069),
    [anon_sym_PIPE] = ACTIONS(12071),
    [anon_sym_STAR_STAR] = ACTIONS(12069),
    [anon_sym_AMP] = ACTIONS(12071),
    [anon_sym_EQ] = ACTIONS(12071),
    [anon_sym_LT] = ACTIONS(12071),
    [anon_sym_do] = ACTIONS(12069),
    [anon_sym_LBRACK] = ACTIONS(12069),
    [anon_sym_COLON_COLON2] = ACTIONS(12069),
    [anon_sym_AMP_DOT] = ACTIONS(12069),
    [anon_sym_QMARK] = ACTIONS(12069),
    [anon_sym_DOT_DOT] = ACTIONS(12071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12069),
    [anon_sym_and] = ACTIONS(12069),
    [anon_sym_or] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE] = ACTIONS(12069),
    [anon_sym_AMP_AMP] = ACTIONS(12069),
    [anon_sym_LT_LT] = ACTIONS(12069),
    [anon_sym_GT_GT] = ACTIONS(12069),
    [anon_sym_EQ_EQ] = ACTIONS(12071),
    [anon_sym_BANG_EQ] = ACTIONS(12069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12069),
    [anon_sym_LT_EQ_GT] = ACTIONS(12069),
    [anon_sym_EQ_TILDE] = ACTIONS(12069),
    [anon_sym_BANG_TILDE] = ACTIONS(12069),
    [anon_sym_LT_EQ] = ACTIONS(12071),
    [anon_sym_GT] = ACTIONS(12071),
    [anon_sym_GT_EQ] = ACTIONS(12069),
    [anon_sym_CARET] = ACTIONS(12069),
    [anon_sym_PLUS] = ACTIONS(12069),
    [anon_sym_SLASH] = ACTIONS(12069),
    [anon_sym_PERCENT] = ACTIONS(12069),
    [sym_comment] = ACTIONS(87),
  },
  [10641] = {
    [sym__heredoc_body_start] = ACTIONS(12073),
    [sym__binary_minus] = ACTIONS(12073),
    [sym__binary_star] = ACTIONS(12073),
    [anon_sym_LBRACE] = ACTIONS(12073),
    [anon_sym_RPAREN] = ACTIONS(12073),
    [anon_sym_DOT] = ACTIONS(12075),
    [anon_sym_COMMA] = ACTIONS(12073),
    [anon_sym_PIPE] = ACTIONS(12075),
    [anon_sym_STAR_STAR] = ACTIONS(12073),
    [anon_sym_AMP] = ACTIONS(12075),
    [anon_sym_EQ] = ACTIONS(12075),
    [anon_sym_LT] = ACTIONS(12075),
    [anon_sym_do] = ACTIONS(12073),
    [anon_sym_LBRACK] = ACTIONS(12073),
    [anon_sym_COLON_COLON2] = ACTIONS(12073),
    [anon_sym_AMP_DOT] = ACTIONS(12073),
    [anon_sym_QMARK] = ACTIONS(12073),
    [anon_sym_DOT_DOT] = ACTIONS(12075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12073),
    [anon_sym_and] = ACTIONS(12073),
    [anon_sym_or] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE] = ACTIONS(12073),
    [anon_sym_AMP_AMP] = ACTIONS(12073),
    [anon_sym_LT_LT] = ACTIONS(12073),
    [anon_sym_GT_GT] = ACTIONS(12073),
    [anon_sym_EQ_EQ] = ACTIONS(12075),
    [anon_sym_BANG_EQ] = ACTIONS(12073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12073),
    [anon_sym_LT_EQ_GT] = ACTIONS(12073),
    [anon_sym_EQ_TILDE] = ACTIONS(12073),
    [anon_sym_BANG_TILDE] = ACTIONS(12073),
    [anon_sym_LT_EQ] = ACTIONS(12075),
    [anon_sym_GT] = ACTIONS(12075),
    [anon_sym_GT_EQ] = ACTIONS(12073),
    [anon_sym_CARET] = ACTIONS(12073),
    [anon_sym_PLUS] = ACTIONS(12073),
    [anon_sym_SLASH] = ACTIONS(12073),
    [anon_sym_PERCENT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [10642] = {
    [sym__heredoc_body_start] = ACTIONS(12187),
    [sym__binary_minus] = ACTIONS(12187),
    [sym__binary_star] = ACTIONS(12187),
    [anon_sym_LBRACE] = ACTIONS(12187),
    [anon_sym_RPAREN] = ACTIONS(12187),
    [anon_sym_DOT] = ACTIONS(12189),
    [anon_sym_COMMA] = ACTIONS(12187),
    [anon_sym_PIPE] = ACTIONS(12189),
    [anon_sym_STAR_STAR] = ACTIONS(12187),
    [anon_sym_AMP] = ACTIONS(12189),
    [anon_sym_EQ] = ACTIONS(12189),
    [anon_sym_LT] = ACTIONS(12189),
    [anon_sym_do] = ACTIONS(12187),
    [anon_sym_LBRACK] = ACTIONS(12187),
    [anon_sym_COLON_COLON2] = ACTIONS(12187),
    [anon_sym_AMP_DOT] = ACTIONS(12187),
    [anon_sym_QMARK] = ACTIONS(12187),
    [anon_sym_DOT_DOT] = ACTIONS(12189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12187),
    [anon_sym_and] = ACTIONS(12187),
    [anon_sym_or] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE] = ACTIONS(12187),
    [anon_sym_AMP_AMP] = ACTIONS(12187),
    [anon_sym_LT_LT] = ACTIONS(12187),
    [anon_sym_GT_GT] = ACTIONS(12187),
    [anon_sym_EQ_EQ] = ACTIONS(12189),
    [anon_sym_BANG_EQ] = ACTIONS(12187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12187),
    [anon_sym_LT_EQ_GT] = ACTIONS(12187),
    [anon_sym_EQ_TILDE] = ACTIONS(12187),
    [anon_sym_BANG_TILDE] = ACTIONS(12187),
    [anon_sym_LT_EQ] = ACTIONS(12189),
    [anon_sym_GT] = ACTIONS(12189),
    [anon_sym_GT_EQ] = ACTIONS(12187),
    [anon_sym_CARET] = ACTIONS(12187),
    [anon_sym_PLUS] = ACTIONS(12187),
    [anon_sym_SLASH] = ACTIONS(12187),
    [anon_sym_PERCENT] = ACTIONS(12187),
    [sym_comment] = ACTIONS(87),
  },
  [10643] = {
    [sym__heredoc_body_start] = ACTIONS(12482),
    [sym__binary_minus] = ACTIONS(12482),
    [sym__binary_star] = ACTIONS(12482),
    [anon_sym_LBRACE] = ACTIONS(12482),
    [anon_sym_RPAREN] = ACTIONS(12482),
    [anon_sym_DOT] = ACTIONS(12484),
    [anon_sym_COMMA] = ACTIONS(12482),
    [anon_sym_PIPE] = ACTIONS(12484),
    [anon_sym_STAR_STAR] = ACTIONS(12482),
    [anon_sym_AMP] = ACTIONS(12484),
    [anon_sym_EQ] = ACTIONS(12484),
    [anon_sym_LT] = ACTIONS(12484),
    [anon_sym_do] = ACTIONS(12482),
    [anon_sym_LBRACK] = ACTIONS(12482),
    [anon_sym_COLON_COLON2] = ACTIONS(12482),
    [anon_sym_AMP_DOT] = ACTIONS(12482),
    [anon_sym_QMARK] = ACTIONS(12482),
    [anon_sym_DOT_DOT] = ACTIONS(12484),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12482),
    [anon_sym_and] = ACTIONS(12482),
    [anon_sym_or] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE] = ACTIONS(12482),
    [anon_sym_AMP_AMP] = ACTIONS(12482),
    [anon_sym_LT_LT] = ACTIONS(12482),
    [anon_sym_GT_GT] = ACTIONS(12482),
    [anon_sym_EQ_EQ] = ACTIONS(12484),
    [anon_sym_BANG_EQ] = ACTIONS(12482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12482),
    [anon_sym_LT_EQ_GT] = ACTIONS(12482),
    [anon_sym_EQ_TILDE] = ACTIONS(12482),
    [anon_sym_BANG_TILDE] = ACTIONS(12482),
    [anon_sym_LT_EQ] = ACTIONS(12484),
    [anon_sym_GT] = ACTIONS(12484),
    [anon_sym_GT_EQ] = ACTIONS(12482),
    [anon_sym_CARET] = ACTIONS(12482),
    [anon_sym_PLUS] = ACTIONS(12482),
    [anon_sym_SLASH] = ACTIONS(12482),
    [anon_sym_PERCENT] = ACTIONS(12482),
    [sym_comment] = ACTIONS(87),
  },
  [10644] = {
    [anon_sym_end] = ACTIONS(14725),
    [sym_comment] = ACTIONS(87),
  },
  [10645] = {
    [sym__heredoc_body_start] = ACTIONS(12622),
    [sym__binary_minus] = ACTIONS(12622),
    [sym__binary_star] = ACTIONS(12622),
    [anon_sym_LBRACE] = ACTIONS(12622),
    [anon_sym_RPAREN] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12624),
    [anon_sym_COMMA] = ACTIONS(12622),
    [anon_sym_PIPE] = ACTIONS(12624),
    [anon_sym_STAR_STAR] = ACTIONS(12622),
    [anon_sym_AMP] = ACTIONS(12624),
    [anon_sym_EQ] = ACTIONS(12624),
    [anon_sym_LT] = ACTIONS(12624),
    [anon_sym_do] = ACTIONS(12622),
    [anon_sym_LBRACK] = ACTIONS(12622),
    [anon_sym_COLON_COLON2] = ACTIONS(12622),
    [anon_sym_AMP_DOT] = ACTIONS(12622),
    [anon_sym_QMARK] = ACTIONS(12622),
    [anon_sym_DOT_DOT] = ACTIONS(12624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12622),
    [anon_sym_and] = ACTIONS(12622),
    [anon_sym_or] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE] = ACTIONS(12622),
    [anon_sym_AMP_AMP] = ACTIONS(12622),
    [anon_sym_LT_LT] = ACTIONS(12622),
    [anon_sym_GT_GT] = ACTIONS(12622),
    [anon_sym_EQ_EQ] = ACTIONS(12624),
    [anon_sym_BANG_EQ] = ACTIONS(12622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12622),
    [anon_sym_LT_EQ_GT] = ACTIONS(12622),
    [anon_sym_EQ_TILDE] = ACTIONS(12622),
    [anon_sym_BANG_TILDE] = ACTIONS(12622),
    [anon_sym_LT_EQ] = ACTIONS(12624),
    [anon_sym_GT] = ACTIONS(12624),
    [anon_sym_GT_EQ] = ACTIONS(12622),
    [anon_sym_CARET] = ACTIONS(12622),
    [anon_sym_PLUS] = ACTIONS(12622),
    [anon_sym_SLASH] = ACTIONS(12622),
    [anon_sym_PERCENT] = ACTIONS(12622),
    [sym_comment] = ACTIONS(87),
  },
  [10646] = {
    [sym__heredoc_body_start] = ACTIONS(12770),
    [sym__binary_minus] = ACTIONS(12770),
    [sym__binary_star] = ACTIONS(12770),
    [anon_sym_LBRACE] = ACTIONS(12770),
    [anon_sym_RPAREN] = ACTIONS(12770),
    [anon_sym_DOT] = ACTIONS(12772),
    [anon_sym_COMMA] = ACTIONS(12770),
    [anon_sym_PIPE] = ACTIONS(12772),
    [anon_sym_STAR_STAR] = ACTIONS(12770),
    [anon_sym_AMP] = ACTIONS(12772),
    [anon_sym_EQ] = ACTIONS(12772),
    [anon_sym_LT] = ACTIONS(12772),
    [anon_sym_do] = ACTIONS(12770),
    [anon_sym_LBRACK] = ACTIONS(12770),
    [anon_sym_COLON_COLON2] = ACTIONS(12770),
    [anon_sym_AMP_DOT] = ACTIONS(12770),
    [anon_sym_QMARK] = ACTIONS(12770),
    [anon_sym_DOT_DOT] = ACTIONS(12772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12770),
    [anon_sym_and] = ACTIONS(12770),
    [anon_sym_or] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE] = ACTIONS(12770),
    [anon_sym_AMP_AMP] = ACTIONS(12770),
    [anon_sym_LT_LT] = ACTIONS(12770),
    [anon_sym_GT_GT] = ACTIONS(12770),
    [anon_sym_EQ_EQ] = ACTIONS(12772),
    [anon_sym_BANG_EQ] = ACTIONS(12770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12770),
    [anon_sym_LT_EQ_GT] = ACTIONS(12770),
    [anon_sym_EQ_TILDE] = ACTIONS(12770),
    [anon_sym_BANG_TILDE] = ACTIONS(12770),
    [anon_sym_LT_EQ] = ACTIONS(12772),
    [anon_sym_GT] = ACTIONS(12772),
    [anon_sym_GT_EQ] = ACTIONS(12770),
    [anon_sym_CARET] = ACTIONS(12770),
    [anon_sym_PLUS] = ACTIONS(12770),
    [anon_sym_SLASH] = ACTIONS(12770),
    [anon_sym_PERCENT] = ACTIONS(12770),
    [sym_comment] = ACTIONS(87),
  },
  [10647] = {
    [sym__heredoc_body_start] = ACTIONS(12781),
    [sym__binary_minus] = ACTIONS(12781),
    [sym__binary_star] = ACTIONS(12781),
    [anon_sym_LBRACE] = ACTIONS(12781),
    [anon_sym_RPAREN] = ACTIONS(12781),
    [anon_sym_DOT] = ACTIONS(12783),
    [anon_sym_COMMA] = ACTIONS(12781),
    [anon_sym_PIPE] = ACTIONS(12783),
    [anon_sym_STAR_STAR] = ACTIONS(12781),
    [anon_sym_AMP] = ACTIONS(12783),
    [anon_sym_EQ] = ACTIONS(12783),
    [anon_sym_LT] = ACTIONS(12783),
    [anon_sym_do] = ACTIONS(12781),
    [anon_sym_LBRACK] = ACTIONS(12781),
    [anon_sym_COLON_COLON2] = ACTIONS(12781),
    [anon_sym_AMP_DOT] = ACTIONS(12781),
    [anon_sym_QMARK] = ACTIONS(12781),
    [anon_sym_DOT_DOT] = ACTIONS(12783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12781),
    [anon_sym_and] = ACTIONS(12781),
    [anon_sym_or] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE] = ACTIONS(12781),
    [anon_sym_AMP_AMP] = ACTIONS(12781),
    [anon_sym_LT_LT] = ACTIONS(12781),
    [anon_sym_GT_GT] = ACTIONS(12781),
    [anon_sym_EQ_EQ] = ACTIONS(12783),
    [anon_sym_BANG_EQ] = ACTIONS(12781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12781),
    [anon_sym_LT_EQ_GT] = ACTIONS(12781),
    [anon_sym_EQ_TILDE] = ACTIONS(12781),
    [anon_sym_BANG_TILDE] = ACTIONS(12781),
    [anon_sym_LT_EQ] = ACTIONS(12783),
    [anon_sym_GT] = ACTIONS(12783),
    [anon_sym_GT_EQ] = ACTIONS(12781),
    [anon_sym_CARET] = ACTIONS(12781),
    [anon_sym_PLUS] = ACTIONS(12781),
    [anon_sym_SLASH] = ACTIONS(12781),
    [anon_sym_PERCENT] = ACTIONS(12781),
    [sym_comment] = ACTIONS(87),
  },
  [10648] = {
    [sym__heredoc_body_start] = ACTIONS(13093),
    [sym__binary_minus] = ACTIONS(13093),
    [sym__binary_star] = ACTIONS(13093),
    [anon_sym_LBRACE] = ACTIONS(13093),
    [anon_sym_RPAREN] = ACTIONS(13093),
    [anon_sym_DOT] = ACTIONS(13095),
    [anon_sym_COMMA] = ACTIONS(13093),
    [anon_sym_PIPE] = ACTIONS(13095),
    [anon_sym_STAR_STAR] = ACTIONS(13093),
    [anon_sym_AMP] = ACTIONS(13095),
    [anon_sym_EQ] = ACTIONS(13095),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_do] = ACTIONS(13093),
    [anon_sym_LBRACK] = ACTIONS(13093),
    [anon_sym_COLON_COLON2] = ACTIONS(13093),
    [anon_sym_AMP_DOT] = ACTIONS(13093),
    [anon_sym_QMARK] = ACTIONS(13093),
    [anon_sym_DOT_DOT] = ACTIONS(13095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13093),
    [anon_sym_and] = ACTIONS(13093),
    [anon_sym_or] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE] = ACTIONS(13093),
    [anon_sym_AMP_AMP] = ACTIONS(13093),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13095),
    [anon_sym_BANG_EQ] = ACTIONS(13093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13093),
    [anon_sym_LT_EQ_GT] = ACTIONS(13093),
    [anon_sym_EQ_TILDE] = ACTIONS(13093),
    [anon_sym_BANG_TILDE] = ACTIONS(13093),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13093),
    [anon_sym_CARET] = ACTIONS(13093),
    [anon_sym_PLUS] = ACTIONS(13093),
    [anon_sym_SLASH] = ACTIONS(13093),
    [anon_sym_PERCENT] = ACTIONS(13093),
    [sym_comment] = ACTIONS(87),
  },
  [10649] = {
    [sym__heredoc_body_start] = ACTIONS(13264),
    [sym__binary_minus] = ACTIONS(13264),
    [sym__binary_star] = ACTIONS(13264),
    [anon_sym_LBRACE] = ACTIONS(13264),
    [anon_sym_RPAREN] = ACTIONS(13264),
    [anon_sym_DOT] = ACTIONS(13266),
    [anon_sym_COMMA] = ACTIONS(13264),
    [anon_sym_PIPE] = ACTIONS(13266),
    [anon_sym_STAR_STAR] = ACTIONS(13264),
    [anon_sym_AMP] = ACTIONS(13266),
    [anon_sym_EQ] = ACTIONS(13266),
    [anon_sym_LT] = ACTIONS(13266),
    [anon_sym_do] = ACTIONS(13264),
    [anon_sym_LBRACK] = ACTIONS(13264),
    [anon_sym_COLON_COLON2] = ACTIONS(13264),
    [anon_sym_AMP_DOT] = ACTIONS(13264),
    [anon_sym_QMARK] = ACTIONS(13264),
    [anon_sym_DOT_DOT] = ACTIONS(13266),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13264),
    [anon_sym_and] = ACTIONS(13264),
    [anon_sym_or] = ACTIONS(13264),
    [anon_sym_PIPE_PIPE] = ACTIONS(13264),
    [anon_sym_AMP_AMP] = ACTIONS(13264),
    [anon_sym_LT_LT] = ACTIONS(13264),
    [anon_sym_GT_GT] = ACTIONS(13264),
    [anon_sym_EQ_EQ] = ACTIONS(13266),
    [anon_sym_BANG_EQ] = ACTIONS(13264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13264),
    [anon_sym_LT_EQ_GT] = ACTIONS(13264),
    [anon_sym_EQ_TILDE] = ACTIONS(13264),
    [anon_sym_BANG_TILDE] = ACTIONS(13264),
    [anon_sym_LT_EQ] = ACTIONS(13266),
    [anon_sym_GT] = ACTIONS(13266),
    [anon_sym_GT_EQ] = ACTIONS(13264),
    [anon_sym_CARET] = ACTIONS(13264),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13264),
    [anon_sym_PERCENT] = ACTIONS(13264),
    [sym_comment] = ACTIONS(87),
  },
  [10650] = {
    [anon_sym_end] = ACTIONS(14727),
    [sym_comment] = ACTIONS(87),
  },
  [10651] = {
    [sym_heredoc_body] = STATE(10651),
    [aux_sym_call_repeat1] = STATE(10651),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_elsif] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10652] = {
    [sym_heredoc_body] = STATE(10651),
    [aux_sym_call_repeat1] = STATE(10651),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_elsif] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10653] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10935),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_assignment] = STATE(10935),
    [sym_operator_assignment] = STATE(10935),
    [sym_conditional] = STATE(10935),
    [sym_range] = STATE(10935),
    [sym_binary] = STATE(10935),
    [sym_unary] = STATE(10935),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10654] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10085),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7338),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7338),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(10085),
    [sym_operator_assignment] = STATE(10085),
    [sym_conditional] = STATE(10085),
    [sym_range] = STATE(10085),
    [sym_binary] = STATE(10085),
    [sym_unary] = STATE(10085),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(7337),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7338),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7338),
    [sym_false] = STATE(7338),
    [sym_nil] = STATE(7338),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(7730),
    [sym__unary_minus] = ACTIONS(10611),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10621),
    [anon_sym_defined_QMARK] = ACTIONS(10623),
    [anon_sym_not] = ACTIONS(10625),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10655] = {
    [aux_sym_exceptions_repeat1] = STATE(10936),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14729),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_elsif] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10656] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(10643),
    [sym__binary_star] = ACTIONS(10645),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(10647),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(10645),
    [anon_sym_AMP] = ACTIONS(10649),
    [anon_sym_LT] = ACTIONS(10651),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_elsif] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(10653),
    [anon_sym_DOT_DOT] = ACTIONS(10655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10657),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(10659),
    [anon_sym_AMP_AMP] = ACTIONS(10659),
    [anon_sym_LT_LT] = ACTIONS(10661),
    [anon_sym_GT_GT] = ACTIONS(10661),
    [anon_sym_EQ_EQ] = ACTIONS(10663),
    [anon_sym_BANG_EQ] = ACTIONS(10659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10659),
    [anon_sym_LT_EQ_GT] = ACTIONS(10659),
    [anon_sym_EQ_TILDE] = ACTIONS(10659),
    [anon_sym_BANG_TILDE] = ACTIONS(10659),
    [anon_sym_LT_EQ] = ACTIONS(10651),
    [anon_sym_GT] = ACTIONS(10651),
    [anon_sym_GT_EQ] = ACTIONS(10665),
    [anon_sym_CARET] = ACTIONS(10667),
    [anon_sym_PLUS] = ACTIONS(10643),
    [anon_sym_SLASH] = ACTIONS(10645),
    [anon_sym_PERCENT] = ACTIONS(10645),
    [sym_comment] = ACTIONS(87),
  },
  [10657] = {
    [aux_sym_exceptions_repeat1] = STATE(10657),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14731),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_elsif] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10658] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10937),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_assignment] = STATE(10937),
    [sym_operator_assignment] = STATE(10937),
    [sym_conditional] = STATE(10937),
    [sym_range] = STATE(10937),
    [sym_binary] = STATE(10937),
    [sym_unary] = STATE(10937),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10659] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10116),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7411),
    [sym_scope_resolution] = STATE(7409),
    [sym_call] = STATE(7409),
    [sym_method_call] = STATE(7411),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(10116),
    [sym_operator_assignment] = STATE(10116),
    [sym_conditional] = STATE(10116),
    [sym_range] = STATE(10116),
    [sym_binary] = STATE(10116),
    [sym_unary] = STATE(10116),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(7410),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7411),
    [sym__variable] = STATE(7409),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7411),
    [sym_false] = STATE(7411),
    [sym_nil] = STATE(7411),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7412),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(7810),
    [sym__unary_minus] = ACTIONS(10697),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10699),
    [anon_sym_yield] = ACTIONS(10701),
    [anon_sym_break] = ACTIONS(10703),
    [anon_sym_next] = ACTIONS(10705),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10707),
    [anon_sym_defined_QMARK] = ACTIONS(10709),
    [anon_sym_not] = ACTIONS(10711),
    [anon_sym_BANG] = ACTIONS(10713),
    [anon_sym_TILDE] = ACTIONS(10713),
    [sym_constant] = ACTIONS(10715),
    [sym_identifier] = ACTIONS(10715),
    [sym_instance_variable] = ACTIONS(10717),
    [sym_class_variable] = ACTIONS(10717),
    [sym_global_variable] = ACTIONS(10717),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10715),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10715),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10660] = {
    [aux_sym_exceptions_repeat1] = STATE(10938),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14734),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_elsif] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10661] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(10725),
    [sym__binary_star] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(10729),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(10731),
    [anon_sym_AMP] = ACTIONS(10733),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(10735),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_elsif] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(10737),
    [anon_sym_DOT_DOT] = ACTIONS(10739),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10741),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(10743),
    [anon_sym_AMP_AMP] = ACTIONS(10743),
    [anon_sym_LT_LT] = ACTIONS(10745),
    [anon_sym_GT_GT] = ACTIONS(10745),
    [anon_sym_EQ_EQ] = ACTIONS(10743),
    [anon_sym_BANG_EQ] = ACTIONS(10747),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10747),
    [anon_sym_LT_EQ_GT] = ACTIONS(10747),
    [anon_sym_EQ_TILDE] = ACTIONS(10747),
    [anon_sym_BANG_TILDE] = ACTIONS(10747),
    [anon_sym_LT_EQ] = ACTIONS(10735),
    [anon_sym_GT] = ACTIONS(10735),
    [anon_sym_GT_EQ] = ACTIONS(10749),
    [anon_sym_CARET] = ACTIONS(10729),
    [anon_sym_PLUS] = ACTIONS(10751),
    [anon_sym_SLASH] = ACTIONS(10731),
    [anon_sym_PERCENT] = ACTIONS(10731),
    [sym_comment] = ACTIONS(87),
  },
  [10662] = {
    [aux_sym_exceptions_repeat1] = STATE(10662),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14736),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_elsif] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10663] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10939),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7443),
    [sym_scope_resolution] = STATE(2633),
    [sym_call] = STATE(2633),
    [sym_method_call] = STATE(7443),
    [sym_assignment] = STATE(10939),
    [sym_operator_assignment] = STATE(10939),
    [sym_conditional] = STATE(10939),
    [sym_range] = STATE(10939),
    [sym_binary] = STATE(10939),
    [sym_unary] = STATE(10939),
    [sym_left_assignment_list] = STATE(7442),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7443),
    [sym__variable] = STATE(2633),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7443),
    [sym_false] = STATE(7443),
    [sym_nil] = STATE(7443),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7339),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10765),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10613),
    [anon_sym_yield] = ACTIONS(10615),
    [anon_sym_break] = ACTIONS(10617),
    [anon_sym_next] = ACTIONS(10619),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10767),
    [anon_sym_defined_QMARK] = ACTIONS(10769),
    [anon_sym_not] = ACTIONS(10771),
    [anon_sym_BANG] = ACTIONS(10773),
    [anon_sym_TILDE] = ACTIONS(10773),
    [sym_constant] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4360),
    [sym_instance_variable] = ACTIONS(4362),
    [sym_class_variable] = ACTIONS(4362),
    [sym_global_variable] = ACTIONS(4362),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4360),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4360),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10664] = {
    [sym_heredoc_body] = STATE(10664),
    [aux_sym_call_repeat1] = STATE(10664),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10665] = {
    [sym_heredoc_body] = STATE(10664),
    [aux_sym_call_repeat1] = STATE(10664),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10666] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10940),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_assignment] = STATE(10940),
    [sym_operator_assignment] = STATE(10940),
    [sym_conditional] = STATE(10940),
    [sym_range] = STATE(10940),
    [sym_binary] = STATE(10940),
    [sym_unary] = STATE(10940),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10667] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10151),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7487),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7487),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(10151),
    [sym_operator_assignment] = STATE(10151),
    [sym_conditional] = STATE(10151),
    [sym_range] = STATE(10151),
    [sym_binary] = STATE(10151),
    [sym_unary] = STATE(10151),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(7486),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7487),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7487),
    [sym_false] = STATE(7487),
    [sym_nil] = STATE(7487),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(7928),
    [sym__unary_minus] = ACTIONS(10780),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10790),
    [anon_sym_defined_QMARK] = ACTIONS(10792),
    [anon_sym_not] = ACTIONS(10794),
    [anon_sym_BANG] = ACTIONS(10796),
    [anon_sym_TILDE] = ACTIONS(10796),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10668] = {
    [aux_sym_exceptions_repeat1] = STATE(10941),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14739),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10669] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(10812),
    [sym__binary_star] = ACTIONS(10814),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(10816),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(10814),
    [anon_sym_AMP] = ACTIONS(10818),
    [anon_sym_LT] = ACTIONS(10820),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(10822),
    [anon_sym_DOT_DOT] = ACTIONS(10824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10826),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(10828),
    [anon_sym_AMP_AMP] = ACTIONS(10828),
    [anon_sym_LT_LT] = ACTIONS(10830),
    [anon_sym_GT_GT] = ACTIONS(10830),
    [anon_sym_EQ_EQ] = ACTIONS(10832),
    [anon_sym_BANG_EQ] = ACTIONS(10828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10828),
    [anon_sym_LT_EQ_GT] = ACTIONS(10828),
    [anon_sym_EQ_TILDE] = ACTIONS(10828),
    [anon_sym_BANG_TILDE] = ACTIONS(10828),
    [anon_sym_LT_EQ] = ACTIONS(10820),
    [anon_sym_GT] = ACTIONS(10820),
    [anon_sym_GT_EQ] = ACTIONS(10834),
    [anon_sym_CARET] = ACTIONS(10836),
    [anon_sym_PLUS] = ACTIONS(10812),
    [anon_sym_SLASH] = ACTIONS(10814),
    [anon_sym_PERCENT] = ACTIONS(10814),
    [sym_comment] = ACTIONS(87),
  },
  [10670] = {
    [aux_sym_exceptions_repeat1] = STATE(10670),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14741),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10671] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10942),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_assignment] = STATE(10942),
    [sym_operator_assignment] = STATE(10942),
    [sym_conditional] = STATE(10942),
    [sym_range] = STATE(10942),
    [sym_binary] = STATE(10942),
    [sym_unary] = STATE(10942),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10672] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10181),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7559),
    [sym_scope_resolution] = STATE(7557),
    [sym_call] = STATE(7557),
    [sym_method_call] = STATE(7559),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(10181),
    [sym_operator_assignment] = STATE(10181),
    [sym_conditional] = STATE(10181),
    [sym_range] = STATE(10181),
    [sym_binary] = STATE(10181),
    [sym_unary] = STATE(10181),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(7558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7559),
    [sym__variable] = STATE(7557),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7559),
    [sym_false] = STATE(7559),
    [sym_nil] = STATE(7559),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7560),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(8002),
    [sym__unary_minus] = ACTIONS(10864),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(10866),
    [anon_sym_yield] = ACTIONS(10868),
    [anon_sym_break] = ACTIONS(10870),
    [anon_sym_next] = ACTIONS(10872),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(10874),
    [anon_sym_defined_QMARK] = ACTIONS(10876),
    [anon_sym_not] = ACTIONS(10878),
    [anon_sym_BANG] = ACTIONS(10880),
    [anon_sym_TILDE] = ACTIONS(10880),
    [sym_constant] = ACTIONS(10882),
    [sym_identifier] = ACTIONS(10882),
    [sym_instance_variable] = ACTIONS(10884),
    [sym_class_variable] = ACTIONS(10884),
    [sym_global_variable] = ACTIONS(10884),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(10882),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10673] = {
    [aux_sym_exceptions_repeat1] = STATE(10943),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14744),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10674] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(10892),
    [sym__binary_star] = ACTIONS(10894),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(10896),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10900),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(10904),
    [anon_sym_DOT_DOT] = ACTIONS(10906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(10910),
    [anon_sym_AMP_AMP] = ACTIONS(10910),
    [anon_sym_LT_LT] = ACTIONS(10912),
    [anon_sym_GT_GT] = ACTIONS(10912),
    [anon_sym_EQ_EQ] = ACTIONS(10910),
    [anon_sym_BANG_EQ] = ACTIONS(10914),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10914),
    [anon_sym_LT_EQ_GT] = ACTIONS(10914),
    [anon_sym_EQ_TILDE] = ACTIONS(10914),
    [anon_sym_BANG_TILDE] = ACTIONS(10914),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10916),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10918),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [10675] = {
    [aux_sym_exceptions_repeat1] = STATE(10675),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14746),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10676] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10944),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7591),
    [sym_scope_resolution] = STATE(2708),
    [sym_call] = STATE(2708),
    [sym_method_call] = STATE(7591),
    [sym_assignment] = STATE(10944),
    [sym_operator_assignment] = STATE(10944),
    [sym_conditional] = STATE(10944),
    [sym_range] = STATE(10944),
    [sym_binary] = STATE(10944),
    [sym_unary] = STATE(10944),
    [sym_left_assignment_list] = STATE(7590),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7591),
    [sym__variable] = STATE(2708),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7591),
    [sym_false] = STATE(7591),
    [sym_nil] = STATE(7591),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7488),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10782),
    [anon_sym_yield] = ACTIONS(10784),
    [anon_sym_break] = ACTIONS(10786),
    [anon_sym_next] = ACTIONS(10788),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_defined_QMARK] = ACTIONS(10936),
    [anon_sym_not] = ACTIONS(10938),
    [anon_sym_BANG] = ACTIONS(10940),
    [anon_sym_TILDE] = ACTIONS(10940),
    [sym_constant] = ACTIONS(4470),
    [sym_identifier] = ACTIONS(4470),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4470),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4470),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10677] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10945),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_assignment] = STATE(10945),
    [sym_operator_assignment] = STATE(10945),
    [sym_conditional] = STATE(10945),
    [sym_range] = STATE(10945),
    [sym_binary] = STATE(10945),
    [sym_unary] = STATE(10945),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10678] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(10217),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(7683),
    [sym_scope_resolution] = STATE(2834),
    [sym_call] = STATE(2834),
    [sym_method_call] = STATE(7683),
    [sym_splat_argument] = STATE(10613),
    [sym_assignment] = STATE(10217),
    [sym_operator_assignment] = STATE(10217),
    [sym_conditional] = STATE(10217),
    [sym_range] = STATE(10217),
    [sym_binary] = STATE(10217),
    [sym_unary] = STATE(10217),
    [sym__arg_or_splat_arg] = STATE(10613),
    [sym_left_assignment_list] = STATE(7682),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7683),
    [sym__variable] = STATE(2834),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(7683),
    [sym_false] = STATE(7683),
    [sym_nil] = STATE(7683),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(7684),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(8210),
    [sym__unary_minus] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_yield] = ACTIONS(10976),
    [anon_sym_break] = ACTIONS(10978),
    [anon_sym_next] = ACTIONS(10980),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(10982),
    [anon_sym_defined_QMARK] = ACTIONS(10984),
    [anon_sym_not] = ACTIONS(10986),
    [anon_sym_BANG] = ACTIONS(10988),
    [anon_sym_TILDE] = ACTIONS(10988),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(4660),
    [sym_class_variable] = ACTIONS(4660),
    [sym_global_variable] = ACTIONS(4660),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(4658),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(4658),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10679] = {
    [aux_sym_exceptions_repeat1] = STATE(10946),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14749),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_in] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10680] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10947),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_assignment] = STATE(10947),
    [sym_operator_assignment] = STATE(10947),
    [sym_conditional] = STATE(10947),
    [sym_range] = STATE(10947),
    [sym_binary] = STATE(10947),
    [sym_unary] = STATE(10947),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10681] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10237),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7771),
    [sym_scope_resolution] = STATE(2965),
    [sym_call] = STATE(2965),
    [sym_method_call] = STATE(7771),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(10237),
    [sym_operator_assignment] = STATE(10237),
    [sym_conditional] = STATE(10237),
    [sym_range] = STATE(10237),
    [sym_binary] = STATE(10237),
    [sym_unary] = STATE(10237),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(7770),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7771),
    [sym__variable] = STATE(2965),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7771),
    [sym_false] = STATE(7771),
    [sym_nil] = STATE(7771),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(2969),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(8360),
    [sym__unary_minus] = ACTIONS(11026),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(4834),
    [anon_sym_next] = ACTIONS(4836),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11028),
    [anon_sym_defined_QMARK] = ACTIONS(11030),
    [anon_sym_not] = ACTIONS(11032),
    [anon_sym_BANG] = ACTIONS(11034),
    [anon_sym_TILDE] = ACTIONS(11034),
    [sym_constant] = ACTIONS(4846),
    [sym_identifier] = ACTIONS(4846),
    [sym_instance_variable] = ACTIONS(4848),
    [sym_class_variable] = ACTIONS(4848),
    [sym_global_variable] = ACTIONS(4848),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4846),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4846),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10682] = {
    [aux_sym_exceptions_repeat1] = STATE(10948),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14751),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10683] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [10684] = {
    [sym_heredoc_body] = STATE(10949),
    [aux_sym_call_repeat1] = STATE(10949),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_when] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [10685] = {
    [sym_heredoc_body] = STATE(10949),
    [aux_sym_call_repeat1] = STATE(10949),
    [aux_sym_argument_list_repeat1] = STATE(10950),
    [sym__line_break] = ACTIONS(1683),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(1683),
    [sym__binary_star] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(1687),
    [anon_sym_COMMA] = ACTIONS(13780),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_end] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(1683),
    [anon_sym_unless] = ACTIONS(1683),
    [anon_sym_while] = ACTIONS(1683),
    [anon_sym_until] = ACTIONS(1683),
    [anon_sym_rescue] = ACTIONS(1683),
    [anon_sym_when] = ACTIONS(1683),
    [anon_sym_else] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_COLON_COLON2] = ACTIONS(1683),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1683),
    [anon_sym_and] = ACTIONS(1683),
    [anon_sym_or] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1687),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LT_EQ_GT] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_BANG_TILDE] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1687),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [sym_comment] = ACTIONS(87),
  },
  [10686] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14400),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10687] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10951),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10951),
    [sym_operator_assignment] = STATE(10951),
    [sym_conditional] = STATE(10951),
    [sym_range] = STATE(10951),
    [sym_binary] = STATE(10951),
    [sym_unary] = STATE(10951),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10688] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10952),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10952),
    [sym_operator_assignment] = STATE(10952),
    [sym_conditional] = STATE(10952),
    [sym_range] = STATE(10952),
    [sym_binary] = STATE(10952),
    [sym_unary] = STATE(10952),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10689] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10953),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10953),
    [sym_operator_assignment] = STATE(10953),
    [sym_conditional] = STATE(10953),
    [sym_range] = STATE(10953),
    [sym_binary] = STATE(10953),
    [sym_unary] = STATE(10953),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10690] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10954),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10954),
    [sym_operator_assignment] = STATE(10954),
    [sym_conditional] = STATE(10954),
    [sym_range] = STATE(10954),
    [sym_binary] = STATE(10954),
    [sym_unary] = STATE(10954),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10691] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10955),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10955),
    [sym_operator_assignment] = STATE(10955),
    [sym_conditional] = STATE(10955),
    [sym_range] = STATE(10955),
    [sym_binary] = STATE(10955),
    [sym_unary] = STATE(10955),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10692] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10956),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10956),
    [sym_operator_assignment] = STATE(10956),
    [sym_conditional] = STATE(10956),
    [sym_range] = STATE(10956),
    [sym_binary] = STATE(10956),
    [sym_unary] = STATE(10956),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10693] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10957),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10957),
    [sym_operator_assignment] = STATE(10957),
    [sym_conditional] = STATE(10957),
    [sym_range] = STATE(10957),
    [sym_binary] = STATE(10957),
    [sym_unary] = STATE(10957),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10694] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10958),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10958),
    [sym_operator_assignment] = STATE(10958),
    [sym_conditional] = STATE(10958),
    [sym_range] = STATE(10958),
    [sym_binary] = STATE(10958),
    [sym_unary] = STATE(10958),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10695] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10959),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10959),
    [sym_operator_assignment] = STATE(10959),
    [sym_conditional] = STATE(10959),
    [sym_range] = STATE(10959),
    [sym_binary] = STATE(10959),
    [sym_unary] = STATE(10959),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10696] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10960),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10960),
    [sym_operator_assignment] = STATE(10960),
    [sym_conditional] = STATE(10960),
    [sym_range] = STATE(10960),
    [sym_binary] = STATE(10960),
    [sym_unary] = STATE(10960),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10697] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10961),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_splat_argument] = STATE(10962),
    [sym_assignment] = STATE(10961),
    [sym_operator_assignment] = STATE(10961),
    [sym_conditional] = STATE(10961),
    [sym_range] = STATE(10961),
    [sym_binary] = STATE(10961),
    [sym_unary] = STATE(10961),
    [sym_right_assignment_list] = STATE(2553),
    [sym__arg_or_splat_arg] = STATE(10962),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10698] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10963),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(10963),
    [sym_operator_assignment] = STATE(10963),
    [sym_conditional] = STATE(10963),
    [sym_range] = STATE(10963),
    [sym_binary] = STATE(10963),
    [sym_unary] = STATE(10963),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10699] = {
    [sym_string] = STATE(10964),
    [aux_sym_chained_string_repeat1] = STATE(10964),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(7),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_when] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [10700] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_when] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(14400),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10701] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10702] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_when] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10703] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10965),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10965),
    [sym_operator_assignment] = STATE(10965),
    [sym_conditional] = STATE(10965),
    [sym_range] = STATE(10965),
    [sym_binary] = STATE(10965),
    [sym_unary] = STATE(10965),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10704] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_when] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10705] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10966),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(10966),
    [sym_operator_assignment] = STATE(10966),
    [sym_conditional] = STATE(10966),
    [sym_range] = STATE(10966),
    [sym_binary] = STATE(10966),
    [sym_unary] = STATE(10966),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10706] = {
    [sym_heredoc_body] = STATE(10967),
    [aux_sym_call_repeat1] = STATE(10967),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_when] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10707] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10261),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym__argument] = STATE(2548),
    [sym_splat_argument] = STATE(2548),
    [sym_hash_splat_argument] = STATE(2548),
    [sym_block_argument] = STATE(2548),
    [sym_assignment] = STATE(10261),
    [sym_operator_assignment] = STATE(10261),
    [sym_conditional] = STATE(10261),
    [sym_range] = STATE(10261),
    [sym_binary] = STATE(10261),
    [sym_unary] = STATE(10261),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10264),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_heredoc_body] = STATE(10968),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(2548),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13736),
    [sym__splat_star] = ACTIONS(13738),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__identifier_hash_key] = ACTIONS(13740),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14753),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(13742),
    [sym_identifier] = ACTIONS(13742),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10708] = {
    [sym_heredoc_body] = STATE(10969),
    [aux_sym_call_repeat1] = STATE(10969),
    [aux_sym_argument_list_repeat1] = STATE(10970),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(14426),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_when] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10709] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_when] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(14400),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10710] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10711] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10712] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10713] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10714] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10715] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14755),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10716] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_when] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10717] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10718] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10719] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10720] = {
    [sym__line_break] = ACTIONS(4074),
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(4074),
    [anon_sym_if] = ACTIONS(4074),
    [anon_sym_unless] = ACTIONS(4074),
    [anon_sym_while] = ACTIONS(4074),
    [anon_sym_until] = ACTIONS(4074),
    [anon_sym_rescue] = ACTIONS(4074),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_else] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10721] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_when] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10722] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10972),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10972),
    [sym_operator_assignment] = STATE(10972),
    [sym_conditional] = STATE(10972),
    [sym_range] = STATE(10972),
    [sym_binary] = STATE(10972),
    [sym_unary] = STATE(10972),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10723] = {
    [sym__line_break] = ACTIONS(3148),
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(3148),
    [anon_sym_if] = ACTIONS(3148),
    [anon_sym_unless] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_until] = ACTIONS(3148),
    [anon_sym_rescue] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_when] = ACTIONS(3148),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10724] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10973),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(10973),
    [sym_operator_assignment] = STATE(10973),
    [sym_conditional] = STATE(10973),
    [sym_range] = STATE(10973),
    [sym_binary] = STATE(10973),
    [sym_unary] = STATE(10973),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10725] = {
    [sym_heredoc_body] = STATE(10974),
    [aux_sym_call_repeat1] = STATE(10974),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_when] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [10726] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym__argument] = STATE(4917),
    [sym_splat_argument] = STATE(4917),
    [sym_hash_splat_argument] = STATE(4917),
    [sym_block_argument] = STATE(4917),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10285),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_heredoc_body] = STATE(10975),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(4917),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(13772),
    [sym__splat_star] = ACTIONS(13774),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__identifier_hash_key] = ACTIONS(13776),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14757),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(13778),
    [sym_identifier] = ACTIONS(13778),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10727] = {
    [sym_heredoc_body] = STATE(10976),
    [aux_sym_call_repeat1] = STATE(10976),
    [aux_sym_argument_list_repeat1] = STATE(10977),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(14434),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_when] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [10728] = {
    [sym_heredoc_body] = STATE(10728),
    [aux_sym_call_repeat1] = STATE(10728),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_when] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10729] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9381),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(12826),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__identifier_hash_key] = ACTIONS(12832),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14438),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12850),
    [sym_identifier] = ACTIONS(12850),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10730] = {
    [sym_heredoc_body] = STATE(10728),
    [aux_sym_call_repeat1] = STATE(10728),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_when] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10731] = {
    [aux_sym_argument_list_repeat1] = STATE(10731),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14759),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_when] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [10732] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_when] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10733] = {
    [aux_sym_exceptions_repeat1] = STATE(10979),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10734] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_when] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10735] = {
    [sym_string] = STATE(10735),
    [aux_sym_chained_string_repeat1] = STATE(10735),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_when] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [10736] = {
    [aux_sym_undef_repeat1] = STATE(10736),
    [sym__line_break] = ACTIONS(9004),
    [sym__heredoc_body_start] = ACTIONS(9004),
    [anon_sym_COMMA] = ACTIONS(9006),
    [anon_sym_SEMI] = ACTIONS(9004),
    [anon_sym_end] = ACTIONS(9004),
    [anon_sym_if] = ACTIONS(9004),
    [anon_sym_unless] = ACTIONS(9004),
    [anon_sym_while] = ACTIONS(9004),
    [anon_sym_until] = ACTIONS(9004),
    [anon_sym_rescue] = ACTIONS(9004),
    [anon_sym_when] = ACTIONS(9004),
    [anon_sym_else] = ACTIONS(9004),
    [sym_comment] = ACTIONS(87),
  },
  [10737] = {
    [sym__top_level_statement] = STATE(1409),
    [sym_begin_block] = STATE(1409),
    [sym_end_block] = STATE(1409),
    [sym__statement] = STATE(7790),
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_if_modifier] = STATE(7790),
    [sym_unless_modifier] = STATE(7790),
    [sym_while_modifier] = STATE(7790),
    [sym_until_modifier] = STATE(7790),
    [sym_rescue_modifier] = STATE(7790),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(7792),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(7792),
    [sym_operator_assignment] = STATE(7792),
    [sym_conditional] = STATE(7792),
    [sym_range] = STATE(7792),
    [sym_binary] = STATE(7792),
    [sym_unary] = STATE(7792),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_undef] = STATE(7790),
    [sym_alias] = STATE(7790),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym_empty_statement] = STATE(7790),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [anon_sym_undef] = ACTIONS(11070),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10738] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10980),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7795),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(7795),
    [sym_assignment] = STATE(10980),
    [sym_operator_assignment] = STATE(10980),
    [sym_conditional] = STATE(10980),
    [sym_range] = STATE(10980),
    [sym_binary] = STATE(10980),
    [sym_unary] = STATE(10980),
    [sym_left_assignment_list] = STATE(7794),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7795),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7795),
    [sym_false] = STATE(7795),
    [sym_nil] = STATE(7795),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7796),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11044),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11048),
    [anon_sym_yield] = ACTIONS(11050),
    [anon_sym_break] = ACTIONS(11052),
    [anon_sym_next] = ACTIONS(11054),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11058),
    [anon_sym_defined_QMARK] = ACTIONS(11060),
    [anon_sym_not] = ACTIONS(11062),
    [anon_sym_BANG] = ACTIONS(11064),
    [anon_sym_TILDE] = ACTIONS(11064),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10739] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [10740] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14457),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10741] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10981),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10981),
    [sym_operator_assignment] = STATE(10981),
    [sym_conditional] = STATE(10981),
    [sym_range] = STATE(10981),
    [sym_binary] = STATE(10981),
    [sym_unary] = STATE(10981),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10742] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10982),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10982),
    [sym_operator_assignment] = STATE(10982),
    [sym_conditional] = STATE(10982),
    [sym_range] = STATE(10982),
    [sym_binary] = STATE(10982),
    [sym_unary] = STATE(10982),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10743] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10983),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10983),
    [sym_operator_assignment] = STATE(10983),
    [sym_conditional] = STATE(10983),
    [sym_range] = STATE(10983),
    [sym_binary] = STATE(10983),
    [sym_unary] = STATE(10983),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10744] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10984),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10984),
    [sym_operator_assignment] = STATE(10984),
    [sym_conditional] = STATE(10984),
    [sym_range] = STATE(10984),
    [sym_binary] = STATE(10984),
    [sym_unary] = STATE(10984),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10745] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10985),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10985),
    [sym_operator_assignment] = STATE(10985),
    [sym_conditional] = STATE(10985),
    [sym_range] = STATE(10985),
    [sym_binary] = STATE(10985),
    [sym_unary] = STATE(10985),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10746] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10986),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(10986),
    [sym_operator_assignment] = STATE(10986),
    [sym_conditional] = STATE(10986),
    [sym_range] = STATE(10986),
    [sym_binary] = STATE(10986),
    [sym_unary] = STATE(10986),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10747] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10987),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10987),
    [sym_operator_assignment] = STATE(10987),
    [sym_conditional] = STATE(10987),
    [sym_range] = STATE(10987),
    [sym_binary] = STATE(10987),
    [sym_unary] = STATE(10987),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10748] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10988),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10988),
    [sym_operator_assignment] = STATE(10988),
    [sym_conditional] = STATE(10988),
    [sym_range] = STATE(10988),
    [sym_binary] = STATE(10988),
    [sym_unary] = STATE(10988),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10749] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10989),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10989),
    [sym_operator_assignment] = STATE(10989),
    [sym_conditional] = STATE(10989),
    [sym_range] = STATE(10989),
    [sym_binary] = STATE(10989),
    [sym_unary] = STATE(10989),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10750] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10990),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10990),
    [sym_operator_assignment] = STATE(10990),
    [sym_conditional] = STATE(10990),
    [sym_range] = STATE(10990),
    [sym_binary] = STATE(10990),
    [sym_unary] = STATE(10990),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10751] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10991),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_splat_argument] = STATE(10992),
    [sym_assignment] = STATE(10991),
    [sym_operator_assignment] = STATE(10991),
    [sym_conditional] = STATE(10991),
    [sym_range] = STATE(10991),
    [sym_binary] = STATE(10991),
    [sym_unary] = STATE(10991),
    [sym_right_assignment_list] = STATE(6270),
    [sym__arg_or_splat_arg] = STATE(10992),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(12902),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10752] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10993),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(10993),
    [sym_operator_assignment] = STATE(10993),
    [sym_conditional] = STATE(10993),
    [sym_range] = STATE(10993),
    [sym_binary] = STATE(10993),
    [sym_unary] = STATE(10993),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10753] = {
    [sym_string] = STATE(10994),
    [aux_sym_chained_string_repeat1] = STATE(10994),
    [sym__line_break] = ACTIONS(2759),
    [sym__string_start] = ACTIONS(2559),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_end] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_unless] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_until] = ACTIONS(2759),
    [anon_sym_rescue] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_when] = ACTIONS(2759),
    [anon_sym_else] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [10754] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_when] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(14457),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10755] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_when] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(14457),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10756] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10757] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [10758] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10759] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10760] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10761] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14762),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10762] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_when] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10763] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10764] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10765] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10766] = {
    [sym_heredoc_body] = STATE(10766),
    [aux_sym_call_repeat1] = STATE(10766),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(9594),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_when] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [10767] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(9414),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym__argument] = STATE(6344),
    [sym_splat_argument] = STATE(6344),
    [sym_hash_splat_argument] = STATE(6344),
    [sym_block_argument] = STATE(6344),
    [sym_assignment] = STATE(9414),
    [sym_operator_assignment] = STATE(9414),
    [sym_conditional] = STATE(9414),
    [sym_range] = STATE(9414),
    [sym_binary] = STATE(9414),
    [sym_unary] = STATE(9414),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(9420),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(6344),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(12900),
    [sym__splat_star] = ACTIONS(12902),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__identifier_hash_key] = ACTIONS(12906),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14479),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12924),
    [sym_identifier] = ACTIONS(12924),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10768] = {
    [sym_heredoc_body] = STATE(10766),
    [aux_sym_call_repeat1] = STATE(10766),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(2733),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_when] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [10769] = {
    [aux_sym_argument_list_repeat1] = STATE(10769),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14764),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_when] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [10770] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_when] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10771] = {
    [aux_sym_exceptions_repeat1] = STATE(10997),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [10772] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_when] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10773] = {
    [sym_string] = STATE(10773),
    [aux_sym_chained_string_repeat1] = STATE(10773),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(9600),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_when] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [10774] = {
    [sym__line_break] = ACTIONS(4110),
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(14485),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(14487),
    [anon_sym_LT] = ACTIONS(14489),
    [anon_sym_end] = ACTIONS(4110),
    [anon_sym_if] = ACTIONS(4110),
    [anon_sym_unless] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_until] = ACTIONS(4110),
    [anon_sym_rescue] = ACTIONS(4110),
    [anon_sym_when] = ACTIONS(4110),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_DOT_DOT] = ACTIONS(14493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14495),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(14497),
    [anon_sym_AMP_AMP] = ACTIONS(14497),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(14501),
    [anon_sym_BANG_EQ] = ACTIONS(14497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14497),
    [anon_sym_LT_EQ_GT] = ACTIONS(14497),
    [anon_sym_EQ_TILDE] = ACTIONS(14497),
    [anon_sym_BANG_TILDE] = ACTIONS(14497),
    [anon_sym_LT_EQ] = ACTIONS(14489),
    [anon_sym_GT] = ACTIONS(14489),
    [anon_sym_GT_EQ] = ACTIONS(14503),
    [anon_sym_CARET] = ACTIONS(14505),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [10775] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [10776] = {
    [sym__line_break] = ACTIONS(935),
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14485),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(14487),
    [anon_sym_LT] = ACTIONS(14489),
    [anon_sym_end] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_unless] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_until] = ACTIONS(935),
    [anon_sym_rescue] = ACTIONS(935),
    [anon_sym_when] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_DOT_DOT] = ACTIONS(14493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14495),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14497),
    [anon_sym_AMP_AMP] = ACTIONS(14497),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(14501),
    [anon_sym_BANG_EQ] = ACTIONS(14497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14497),
    [anon_sym_LT_EQ_GT] = ACTIONS(14497),
    [anon_sym_EQ_TILDE] = ACTIONS(14497),
    [anon_sym_BANG_TILDE] = ACTIONS(14497),
    [anon_sym_LT_EQ] = ACTIONS(14489),
    [anon_sym_GT] = ACTIONS(14489),
    [anon_sym_GT_EQ] = ACTIONS(14503),
    [anon_sym_CARET] = ACTIONS(14505),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [10777] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10998),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(10998),
    [sym_operator_assignment] = STATE(10998),
    [sym_conditional] = STATE(10998),
    [sym_range] = STATE(10998),
    [sym_binary] = STATE(10998),
    [sym_unary] = STATE(10998),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10778] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10999),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(10999),
    [sym_operator_assignment] = STATE(10999),
    [sym_conditional] = STATE(10999),
    [sym_range] = STATE(10999),
    [sym_binary] = STATE(10999),
    [sym_unary] = STATE(10999),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10779] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11000),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(11000),
    [sym_operator_assignment] = STATE(11000),
    [sym_conditional] = STATE(11000),
    [sym_range] = STATE(11000),
    [sym_binary] = STATE(11000),
    [sym_unary] = STATE(11000),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10780] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11001),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(11001),
    [sym_operator_assignment] = STATE(11001),
    [sym_conditional] = STATE(11001),
    [sym_range] = STATE(11001),
    [sym_binary] = STATE(11001),
    [sym_unary] = STATE(11001),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10781] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11002),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(11002),
    [sym_operator_assignment] = STATE(11002),
    [sym_conditional] = STATE(11002),
    [sym_range] = STATE(11002),
    [sym_binary] = STATE(11002),
    [sym_unary] = STATE(11002),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10782] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(11003),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(11003),
    [sym_operator_assignment] = STATE(11003),
    [sym_conditional] = STATE(11003),
    [sym_range] = STATE(11003),
    [sym_binary] = STATE(11003),
    [sym_unary] = STATE(11003),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10783] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11004),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(11004),
    [sym_operator_assignment] = STATE(11004),
    [sym_conditional] = STATE(11004),
    [sym_range] = STATE(11004),
    [sym_binary] = STATE(11004),
    [sym_unary] = STATE(11004),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10784] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11005),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(11005),
    [sym_operator_assignment] = STATE(11005),
    [sym_conditional] = STATE(11005),
    [sym_range] = STATE(11005),
    [sym_binary] = STATE(11005),
    [sym_unary] = STATE(11005),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10785] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11006),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(11006),
    [sym_operator_assignment] = STATE(11006),
    [sym_conditional] = STATE(11006),
    [sym_range] = STATE(11006),
    [sym_binary] = STATE(11006),
    [sym_unary] = STATE(11006),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10786] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11007),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(11007),
    [sym_operator_assignment] = STATE(11007),
    [sym_conditional] = STATE(11007),
    [sym_range] = STATE(11007),
    [sym_binary] = STATE(11007),
    [sym_unary] = STATE(11007),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10787] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10349),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_splat_argument] = STATE(6357),
    [sym_assignment] = STATE(10349),
    [sym_operator_assignment] = STATE(10349),
    [sym_conditional] = STATE(10349),
    [sym_range] = STATE(10349),
    [sym_binary] = STATE(10349),
    [sym_unary] = STATE(10349),
    [sym__arg_or_splat_arg] = STATE(6357),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(13860),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10788] = {
    [aux_sym_exceptions_repeat1] = STATE(11008),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(14507),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_when] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10789] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10349),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_splat_argument] = STATE(11009),
    [sym_assignment] = STATE(10349),
    [sym_operator_assignment] = STATE(10349),
    [sym_conditional] = STATE(10349),
    [sym_range] = STATE(10349),
    [sym_binary] = STATE(10349),
    [sym_unary] = STATE(10349),
    [sym_right_assignment_list] = STATE(1593),
    [sym__arg_or_splat_arg] = STATE(11009),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(13860),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10790] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11010),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(11010),
    [sym_operator_assignment] = STATE(11010),
    [sym_conditional] = STATE(11010),
    [sym_range] = STATE(11010),
    [sym_binary] = STATE(11010),
    [sym_unary] = STATE(11010),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10791] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(11011),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_assignment] = STATE(11011),
    [sym_operator_assignment] = STATE(11011),
    [sym_conditional] = STATE(11011),
    [sym_range] = STATE(11011),
    [sym_binary] = STATE(11011),
    [sym_unary] = STATE(11011),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10792] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10367),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(7819),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7819),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(10367),
    [sym_operator_assignment] = STATE(10367),
    [sym_conditional] = STATE(10367),
    [sym_range] = STATE(10367),
    [sym_binary] = STATE(10367),
    [sym_unary] = STATE(10367),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(7818),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7819),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(7819),
    [sym_false] = STATE(7819),
    [sym_nil] = STATE(7819),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(7820),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(8402),
    [sym__unary_minus] = ACTIONS(11074),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(11076),
    [anon_sym_yield] = ACTIONS(11078),
    [anon_sym_break] = ACTIONS(11080),
    [anon_sym_next] = ACTIONS(11082),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(11084),
    [anon_sym_defined_QMARK] = ACTIONS(11086),
    [anon_sym_not] = ACTIONS(11088),
    [anon_sym_BANG] = ACTIONS(11090),
    [anon_sym_TILDE] = ACTIONS(11090),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [10793] = {
    [aux_sym_exceptions_repeat1] = STATE(11012),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14767),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10794] = {
    [sym__line_break] = ACTIONS(10568),
    [sym__simple_symbol] = ACTIONS(10568),
    [sym__string_start] = ACTIONS(10568),
    [sym__symbol_start] = ACTIONS(10568),
    [sym__subshell_start] = ACTIONS(10568),
    [sym__regex_start] = ACTIONS(10568),
    [sym__string_array_start] = ACTIONS(10568),
    [sym__symbol_array_start] = ACTIONS(10568),
    [sym__heredoc_body_start] = ACTIONS(10568),
    [sym_heredoc_beginning] = ACTIONS(10568),
    [sym__block_ampersand] = ACTIONS(10568),
    [sym__splat_star] = ACTIONS(10568),
    [sym__unary_minus] = ACTIONS(10568),
    [sym__identifier_hash_key] = ACTIONS(10568),
    [anon_sym_LBRACE] = ACTIONS(10568),
    [anon_sym_def] = ACTIONS(10570),
    [anon_sym_LPAREN] = ACTIONS(10570),
    [anon_sym_DOT] = ACTIONS(10568),
    [anon_sym_COLON_COLON] = ACTIONS(10570),
    [anon_sym_SEMI] = ACTIONS(10568),
    [anon_sym_STAR] = ACTIONS(10570),
    [anon_sym_STAR_STAR] = ACTIONS(10568),
    [anon_sym_class] = ACTIONS(10570),
    [anon_sym_module] = ACTIONS(10570),
    [anon_sym_return] = ACTIONS(10570),
    [anon_sym_yield] = ACTIONS(10570),
    [anon_sym_break] = ACTIONS(10570),
    [anon_sym_next] = ACTIONS(10570),
    [sym_redo] = ACTIONS(10570),
    [sym_retry] = ACTIONS(10570),
    [anon_sym_if] = ACTIONS(10570),
    [anon_sym_unless] = ACTIONS(10570),
    [anon_sym_while] = ACTIONS(10570),
    [anon_sym_until] = ACTIONS(10570),
    [anon_sym_for] = ACTIONS(10570),
    [anon_sym_do] = ACTIONS(10570),
    [anon_sym_case] = ACTIONS(10570),
    [anon_sym_then] = ACTIONS(10570),
    [anon_sym_begin] = ACTIONS(10570),
    [anon_sym_LBRACK] = ACTIONS(10568),
    [anon_sym_COLON_COLON2] = ACTIONS(10568),
    [anon_sym_AMP_DOT] = ACTIONS(10568),
    [anon_sym_LPAREN2] = ACTIONS(10568),
    [anon_sym_PLUS] = ACTIONS(10570),
    [anon_sym_defined_QMARK] = ACTIONS(10568),
    [anon_sym_not] = ACTIONS(10570),
    [anon_sym_BANG] = ACTIONS(10568),
    [anon_sym_TILDE] = ACTIONS(10568),
    [sym_constant] = ACTIONS(10570),
    [sym_identifier] = ACTIONS(10570),
    [sym_instance_variable] = ACTIONS(10568),
    [sym_class_variable] = ACTIONS(10568),
    [sym_global_variable] = ACTIONS(10568),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10570),
    [sym_float] = ACTIONS(10570),
    [sym_complex] = ACTIONS(10568),
    [sym_super] = ACTIONS(10570),
    [anon_sym_true] = ACTIONS(10570),
    [anon_sym_TRUE] = ACTIONS(10570),
    [anon_sym_false] = ACTIONS(10570),
    [anon_sym_FALSE] = ACTIONS(10570),
    [sym_self] = ACTIONS(10570),
    [anon_sym_nil] = ACTIONS(10570),
    [anon_sym_NIL] = ACTIONS(10570),
    [sym_character] = ACTIONS(10568),
    [anon_sym_LBRACK2] = ACTIONS(10570),
    [anon_sym_DASH_GT] = ACTIONS(10568),
  },
  [10795] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_then] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10796] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_then] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [10797] = {
    [sym_heredoc_body] = STATE(10797),
    [aux_sym_call_repeat1] = STATE(10797),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_then] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10798] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(9472),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(5559),
    [sym_scope_resolution] = STATE(3075),
    [sym_call] = STATE(3075),
    [sym_method_call] = STATE(5559),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(9472),
    [sym_operator_assignment] = STATE(9472),
    [sym_conditional] = STATE(9472),
    [sym_range] = STATE(9472),
    [sym_binary] = STATE(9472),
    [sym_unary] = STATE(9472),
    [sym_left_assignment_list] = STATE(5558),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(5559),
    [sym__variable] = STATE(3075),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(5559),
    [sym_false] = STATE(5559),
    [sym_nil] = STATE(5559),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(9475),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13000),
    [sym__splat_star] = ACTIONS(13002),
    [sym__unary_minus] = ACTIONS(8525),
    [sym__identifier_hash_key] = ACTIONS(13004),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14530),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8533),
    [anon_sym_yield] = ACTIONS(8535),
    [anon_sym_break] = ACTIONS(8537),
    [anon_sym_next] = ACTIONS(8539),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8543),
    [anon_sym_defined_QMARK] = ACTIONS(8545),
    [anon_sym_not] = ACTIONS(8547),
    [anon_sym_BANG] = ACTIONS(8549),
    [anon_sym_TILDE] = ACTIONS(8549),
    [sym_constant] = ACTIONS(13006),
    [sym_identifier] = ACTIONS(13006),
    [sym_instance_variable] = ACTIONS(5026),
    [sym_class_variable] = ACTIONS(5026),
    [sym_global_variable] = ACTIONS(5026),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5028),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5028),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10799] = {
    [sym_heredoc_body] = STATE(10797),
    [aux_sym_call_repeat1] = STATE(10797),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_then] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10800] = {
    [aux_sym_argument_list_repeat1] = STATE(10800),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14769),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_then] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [10801] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11013),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_assignment] = STATE(11013),
    [sym_operator_assignment] = STATE(11013),
    [sym_conditional] = STATE(11013),
    [sym_range] = STATE(11013),
    [sym_binary] = STATE(11013),
    [sym_unary] = STATE(11013),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10802] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10397),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(7900),
    [sym_scope_resolution] = STATE(7817),
    [sym_call] = STATE(7817),
    [sym_method_call] = STATE(7900),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(10397),
    [sym_operator_assignment] = STATE(10397),
    [sym_conditional] = STATE(10397),
    [sym_range] = STATE(10397),
    [sym_binary] = STATE(10397),
    [sym_unary] = STATE(10397),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(7899),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(7900),
    [sym__variable] = STATE(7817),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(7900),
    [sym_false] = STATE(7900),
    [sym_nil] = STATE(7900),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(7901),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(13002),
    [sym__unary_minus] = ACTIONS(11127),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11129),
    [anon_sym_yield] = ACTIONS(11131),
    [anon_sym_break] = ACTIONS(11133),
    [anon_sym_next] = ACTIONS(11135),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11137),
    [anon_sym_defined_QMARK] = ACTIONS(11139),
    [anon_sym_not] = ACTIONS(11141),
    [anon_sym_BANG] = ACTIONS(11143),
    [anon_sym_TILDE] = ACTIONS(11143),
    [sym_constant] = ACTIONS(11092),
    [sym_identifier] = ACTIONS(11092),
    [sym_instance_variable] = ACTIONS(11094),
    [sym_class_variable] = ACTIONS(11094),
    [sym_global_variable] = ACTIONS(11094),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11092),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11092),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10803] = {
    [aux_sym_exceptions_repeat1] = STATE(11014),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14772),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_then] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10804] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11163),
    [sym__binary_star] = ACTIONS(11165),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11167),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(11165),
    [anon_sym_AMP] = ACTIONS(11169),
    [anon_sym_LT] = ACTIONS(11171),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_DOT_DOT] = ACTIONS(11175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11177),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11181),
    [anon_sym_AMP_AMP] = ACTIONS(11181),
    [anon_sym_LT_LT] = ACTIONS(11183),
    [anon_sym_GT_GT] = ACTIONS(11183),
    [anon_sym_EQ_EQ] = ACTIONS(11185),
    [anon_sym_BANG_EQ] = ACTIONS(11181),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11181),
    [anon_sym_LT_EQ_GT] = ACTIONS(11181),
    [anon_sym_EQ_TILDE] = ACTIONS(11181),
    [anon_sym_BANG_TILDE] = ACTIONS(11181),
    [anon_sym_LT_EQ] = ACTIONS(11171),
    [anon_sym_GT] = ACTIONS(11171),
    [anon_sym_GT_EQ] = ACTIONS(11187),
    [anon_sym_CARET] = ACTIONS(11189),
    [anon_sym_PLUS] = ACTIONS(11163),
    [anon_sym_SLASH] = ACTIONS(11165),
    [anon_sym_PERCENT] = ACTIONS(11165),
    [sym_comment] = ACTIONS(87),
  },
  [10805] = {
    [aux_sym_exceptions_repeat1] = STATE(10805),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14774),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10806] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11216),
    [sym__binary_star] = ACTIONS(11218),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11220),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(11218),
    [anon_sym_AMP] = ACTIONS(11222),
    [anon_sym_LT] = ACTIONS(11224),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11226),
    [anon_sym_DOT_DOT] = ACTIONS(11228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11230),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11232),
    [anon_sym_AMP_AMP] = ACTIONS(11232),
    [anon_sym_LT_LT] = ACTIONS(11234),
    [anon_sym_GT_GT] = ACTIONS(11234),
    [anon_sym_EQ_EQ] = ACTIONS(11236),
    [anon_sym_BANG_EQ] = ACTIONS(11232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11232),
    [anon_sym_LT_EQ_GT] = ACTIONS(11232),
    [anon_sym_EQ_TILDE] = ACTIONS(11232),
    [anon_sym_BANG_TILDE] = ACTIONS(11232),
    [anon_sym_LT_EQ] = ACTIONS(11224),
    [anon_sym_GT] = ACTIONS(11224),
    [anon_sym_GT_EQ] = ACTIONS(11238),
    [anon_sym_CARET] = ACTIONS(11240),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11218),
    [anon_sym_PERCENT] = ACTIONS(11218),
    [sym_comment] = ACTIONS(87),
  },
  [10807] = {
    [aux_sym_exceptions_repeat1] = STATE(10807),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14777),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10808] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11271),
    [sym__binary_star] = ACTIONS(11273),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(11277),
    [anon_sym_AMP] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(11281),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_DOT_DOT] = ACTIONS(11285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11289),
    [anon_sym_AMP_AMP] = ACTIONS(11289),
    [anon_sym_LT_LT] = ACTIONS(11291),
    [anon_sym_GT_GT] = ACTIONS(11291),
    [anon_sym_EQ_EQ] = ACTIONS(11289),
    [anon_sym_BANG_EQ] = ACTIONS(11293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11293),
    [anon_sym_LT_EQ_GT] = ACTIONS(11293),
    [anon_sym_EQ_TILDE] = ACTIONS(11293),
    [anon_sym_BANG_TILDE] = ACTIONS(11293),
    [anon_sym_LT_EQ] = ACTIONS(11281),
    [anon_sym_GT] = ACTIONS(11281),
    [anon_sym_GT_EQ] = ACTIONS(11295),
    [anon_sym_CARET] = ACTIONS(11275),
    [anon_sym_PLUS] = ACTIONS(11297),
    [anon_sym_SLASH] = ACTIONS(11277),
    [anon_sym_PERCENT] = ACTIONS(11277),
    [sym_comment] = ACTIONS(87),
  },
  [10809] = {
    [aux_sym_exceptions_repeat1] = STATE(10809),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14780),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_ensure] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10810] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11307),
    [sym__binary_star] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11311),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(11309),
    [anon_sym_AMP] = ACTIONS(11313),
    [anon_sym_LT] = ACTIONS(11315),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_ensure] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_DOT_DOT] = ACTIONS(11319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11321),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11323),
    [anon_sym_AMP_AMP] = ACTIONS(11323),
    [anon_sym_LT_LT] = ACTIONS(11325),
    [anon_sym_GT_GT] = ACTIONS(11325),
    [anon_sym_EQ_EQ] = ACTIONS(11327),
    [anon_sym_BANG_EQ] = ACTIONS(11323),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11323),
    [anon_sym_LT_EQ_GT] = ACTIONS(11323),
    [anon_sym_EQ_TILDE] = ACTIONS(11323),
    [anon_sym_BANG_TILDE] = ACTIONS(11323),
    [anon_sym_LT_EQ] = ACTIONS(11315),
    [anon_sym_GT] = ACTIONS(11315),
    [anon_sym_GT_EQ] = ACTIONS(11329),
    [anon_sym_CARET] = ACTIONS(11331),
    [anon_sym_PLUS] = ACTIONS(11307),
    [anon_sym_SLASH] = ACTIONS(11309),
    [anon_sym_PERCENT] = ACTIONS(11309),
    [sym_comment] = ACTIONS(87),
  },
  [10811] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11341),
    [sym__binary_star] = ACTIONS(11343),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11345),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(11343),
    [anon_sym_AMP] = ACTIONS(11347),
    [anon_sym_LT] = ACTIONS(11349),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_DOT_DOT] = ACTIONS(11353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11357),
    [anon_sym_AMP_AMP] = ACTIONS(11357),
    [anon_sym_LT_LT] = ACTIONS(11359),
    [anon_sym_GT_GT] = ACTIONS(11359),
    [anon_sym_EQ_EQ] = ACTIONS(11361),
    [anon_sym_BANG_EQ] = ACTIONS(11357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11357),
    [anon_sym_LT_EQ_GT] = ACTIONS(11357),
    [anon_sym_EQ_TILDE] = ACTIONS(11357),
    [anon_sym_BANG_TILDE] = ACTIONS(11357),
    [anon_sym_LT_EQ] = ACTIONS(11349),
    [anon_sym_GT] = ACTIONS(11349),
    [anon_sym_GT_EQ] = ACTIONS(11363),
    [anon_sym_CARET] = ACTIONS(11365),
    [anon_sym_PLUS] = ACTIONS(11341),
    [anon_sym_SLASH] = ACTIONS(11343),
    [anon_sym_PERCENT] = ACTIONS(11343),
    [sym_comment] = ACTIONS(87),
  },
  [10812] = {
    [aux_sym_exceptions_repeat1] = STATE(10812),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14783),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10813] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11396),
    [sym__binary_star] = ACTIONS(11398),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11400),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(11402),
    [anon_sym_AMP] = ACTIONS(11404),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(11406),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11412),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11414),
    [anon_sym_AMP_AMP] = ACTIONS(11414),
    [anon_sym_LT_LT] = ACTIONS(11416),
    [anon_sym_GT_GT] = ACTIONS(11416),
    [anon_sym_EQ_EQ] = ACTIONS(11414),
    [anon_sym_BANG_EQ] = ACTIONS(11418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11418),
    [anon_sym_LT_EQ_GT] = ACTIONS(11418),
    [anon_sym_EQ_TILDE] = ACTIONS(11418),
    [anon_sym_BANG_TILDE] = ACTIONS(11418),
    [anon_sym_LT_EQ] = ACTIONS(11406),
    [anon_sym_GT] = ACTIONS(11406),
    [anon_sym_GT_EQ] = ACTIONS(11420),
    [anon_sym_CARET] = ACTIONS(11400),
    [anon_sym_PLUS] = ACTIONS(11422),
    [anon_sym_SLASH] = ACTIONS(11402),
    [anon_sym_PERCENT] = ACTIONS(11402),
    [sym_comment] = ACTIONS(87),
  },
  [10814] = {
    [aux_sym_exceptions_repeat1] = STATE(10814),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14786),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10815] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11432),
    [sym__binary_star] = ACTIONS(11434),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11436),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(11434),
    [anon_sym_AMP] = ACTIONS(11438),
    [anon_sym_LT] = ACTIONS(11440),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11442),
    [anon_sym_DOT_DOT] = ACTIONS(11444),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11446),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11448),
    [anon_sym_AMP_AMP] = ACTIONS(11448),
    [anon_sym_LT_LT] = ACTIONS(11450),
    [anon_sym_GT_GT] = ACTIONS(11450),
    [anon_sym_EQ_EQ] = ACTIONS(11452),
    [anon_sym_BANG_EQ] = ACTIONS(11448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11448),
    [anon_sym_LT_EQ_GT] = ACTIONS(11448),
    [anon_sym_EQ_TILDE] = ACTIONS(11448),
    [anon_sym_BANG_TILDE] = ACTIONS(11448),
    [anon_sym_LT_EQ] = ACTIONS(11440),
    [anon_sym_GT] = ACTIONS(11440),
    [anon_sym_GT_EQ] = ACTIONS(11454),
    [anon_sym_CARET] = ACTIONS(11456),
    [anon_sym_PLUS] = ACTIONS(11432),
    [anon_sym_SLASH] = ACTIONS(11434),
    [anon_sym_PERCENT] = ACTIONS(11434),
    [sym_comment] = ACTIONS(87),
  },
  [10816] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11489),
    [sym__binary_star] = ACTIONS(11491),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11493),
    [anon_sym_STAR_STAR] = ACTIONS(11491),
    [anon_sym_AMP] = ACTIONS(11495),
    [anon_sym_LT] = ACTIONS(11497),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_RBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_DOT_DOT] = ACTIONS(11501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11503),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11505),
    [anon_sym_AMP_AMP] = ACTIONS(11505),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_BANG_EQ] = ACTIONS(11505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11505),
    [anon_sym_LT_EQ_GT] = ACTIONS(11505),
    [anon_sym_EQ_TILDE] = ACTIONS(11505),
    [anon_sym_BANG_TILDE] = ACTIONS(11505),
    [anon_sym_LT_EQ] = ACTIONS(11497),
    [anon_sym_GT] = ACTIONS(11497),
    [anon_sym_GT_EQ] = ACTIONS(11511),
    [anon_sym_CARET] = ACTIONS(11513),
    [anon_sym_PLUS] = ACTIONS(11489),
    [anon_sym_SLASH] = ACTIONS(11491),
    [anon_sym_PERCENT] = ACTIONS(11491),
    [sym_comment] = ACTIONS(87),
  },
  [10817] = {
    [aux_sym_exceptions_repeat1] = STATE(10817),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14789),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10818] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11525),
    [sym__binary_star] = ACTIONS(11527),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11529),
    [anon_sym_STAR_STAR] = ACTIONS(11531),
    [anon_sym_AMP] = ACTIONS(11533),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(11535),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_RBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11537),
    [anon_sym_DOT_DOT] = ACTIONS(11539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11541),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11543),
    [anon_sym_AMP_AMP] = ACTIONS(11543),
    [anon_sym_LT_LT] = ACTIONS(11545),
    [anon_sym_GT_GT] = ACTIONS(11545),
    [anon_sym_EQ_EQ] = ACTIONS(11543),
    [anon_sym_BANG_EQ] = ACTIONS(11547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11547),
    [anon_sym_LT_EQ_GT] = ACTIONS(11547),
    [anon_sym_EQ_TILDE] = ACTIONS(11547),
    [anon_sym_BANG_TILDE] = ACTIONS(11547),
    [anon_sym_LT_EQ] = ACTIONS(11535),
    [anon_sym_GT] = ACTIONS(11535),
    [anon_sym_GT_EQ] = ACTIONS(11549),
    [anon_sym_CARET] = ACTIONS(11529),
    [anon_sym_PLUS] = ACTIONS(11551),
    [anon_sym_SLASH] = ACTIONS(11531),
    [anon_sym_PERCENT] = ACTIONS(11531),
    [sym_comment] = ACTIONS(87),
  },
  [10819] = {
    [aux_sym_exceptions_repeat1] = STATE(10819),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14792),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10820] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(935),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_SLASH] = ACTIONS(935),
    [anon_sym_PERCENT] = ACTIONS(935),
    [sym_comment] = ACTIONS(87),
  },
  [10821] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14583),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [10822] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11015),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11015),
    [sym_operator_assignment] = STATE(11015),
    [sym_conditional] = STATE(11015),
    [sym_range] = STATE(11015),
    [sym_binary] = STATE(11015),
    [sym_unary] = STATE(11015),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10823] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11016),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11016),
    [sym_operator_assignment] = STATE(11016),
    [sym_conditional] = STATE(11016),
    [sym_range] = STATE(11016),
    [sym_binary] = STATE(11016),
    [sym_unary] = STATE(11016),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10824] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11017),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11017),
    [sym_operator_assignment] = STATE(11017),
    [sym_conditional] = STATE(11017),
    [sym_range] = STATE(11017),
    [sym_binary] = STATE(11017),
    [sym_unary] = STATE(11017),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10825] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11018),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11018),
    [sym_operator_assignment] = STATE(11018),
    [sym_conditional] = STATE(11018),
    [sym_range] = STATE(11018),
    [sym_binary] = STATE(11018),
    [sym_unary] = STATE(11018),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10826] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11019),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11019),
    [sym_operator_assignment] = STATE(11019),
    [sym_conditional] = STATE(11019),
    [sym_range] = STATE(11019),
    [sym_binary] = STATE(11019),
    [sym_unary] = STATE(11019),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10827] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(11020),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(11020),
    [sym_operator_assignment] = STATE(11020),
    [sym_conditional] = STATE(11020),
    [sym_range] = STATE(11020),
    [sym_binary] = STATE(11020),
    [sym_unary] = STATE(11020),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10828] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11021),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11021),
    [sym_operator_assignment] = STATE(11021),
    [sym_conditional] = STATE(11021),
    [sym_range] = STATE(11021),
    [sym_binary] = STATE(11021),
    [sym_unary] = STATE(11021),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10829] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11022),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11022),
    [sym_operator_assignment] = STATE(11022),
    [sym_conditional] = STATE(11022),
    [sym_range] = STATE(11022),
    [sym_binary] = STATE(11022),
    [sym_unary] = STATE(11022),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10830] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11023),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11023),
    [sym_operator_assignment] = STATE(11023),
    [sym_conditional] = STATE(11023),
    [sym_range] = STATE(11023),
    [sym_binary] = STATE(11023),
    [sym_unary] = STATE(11023),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10831] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11024),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11024),
    [sym_operator_assignment] = STATE(11024),
    [sym_conditional] = STATE(11024),
    [sym_range] = STATE(11024),
    [sym_binary] = STATE(11024),
    [sym_unary] = STATE(11024),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10832] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11025),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_splat_argument] = STATE(11026),
    [sym_assignment] = STATE(11025),
    [sym_operator_assignment] = STATE(11025),
    [sym_conditional] = STATE(11025),
    [sym_range] = STATE(11025),
    [sym_binary] = STATE(11025),
    [sym_unary] = STATE(11025),
    [sym_right_assignment_list] = STATE(4180),
    [sym__arg_or_splat_arg] = STATE(11026),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10833] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11027),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11027),
    [sym_operator_assignment] = STATE(11027),
    [sym_conditional] = STATE(11027),
    [sym_range] = STATE(11027),
    [sym_binary] = STATE(11027),
    [sym_unary] = STATE(11027),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10834] = {
    [sym_string] = STATE(11028),
    [aux_sym_chained_string_repeat1] = STATE(11028),
    [sym__string_start] = ACTIONS(579),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2759),
    [anon_sym_AMP_AMP] = ACTIONS(2759),
    [anon_sym_LT_LT] = ACTIONS(2759),
    [anon_sym_GT_GT] = ACTIONS(2759),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_PERCENT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(87),
  },
  [10835] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(14583),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [10836] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10837] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10838] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(11029),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(11029),
    [sym_operator_assignment] = STATE(11029),
    [sym_conditional] = STATE(11029),
    [sym_range] = STATE(11029),
    [sym_binary] = STATE(11029),
    [sym_unary] = STATE(11029),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10839] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10840] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(11030),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(11030),
    [sym_operator_assignment] = STATE(11030),
    [sym_conditional] = STATE(11030),
    [sym_range] = STATE(11030),
    [sym_binary] = STATE(11030),
    [sym_unary] = STATE(11030),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10841] = {
    [sym_heredoc_body] = STATE(11031),
    [aux_sym_call_repeat1] = STATE(11031),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10842] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10476),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(10476),
    [sym_operator_assignment] = STATE(10476),
    [sym_conditional] = STATE(10476),
    [sym_range] = STATE(10476),
    [sym_binary] = STATE(10476),
    [sym_unary] = STATE(10476),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10479),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_heredoc_body] = STATE(11032),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14016),
    [sym__splat_star] = ACTIONS(14018),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__identifier_hash_key] = ACTIONS(14020),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14795),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(14022),
    [sym_identifier] = ACTIONS(14022),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10843] = {
    [sym_heredoc_body] = STATE(11033),
    [aux_sym_call_repeat1] = STATE(11033),
    [aux_sym_argument_list_repeat1] = STATE(11034),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(14609),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10844] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(14583),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [10845] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10846] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10847] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10848] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10849] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10850] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14797),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10851] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10852] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10853] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10854] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10855] = {
    [sym__heredoc_body_start] = ACTIONS(4074),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(4074),
    [anon_sym_DOT] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4074),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(4080),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(4074),
    [anon_sym_EQ_GT] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4074),
    [anon_sym_COLON_COLON2] = ACTIONS(4074),
    [anon_sym_AMP_DOT] = ACTIONS(4074),
    [anon_sym_PLUS_EQ] = ACTIONS(4074),
    [anon_sym_DASH_EQ] = ACTIONS(4074),
    [anon_sym_STAR_EQ] = ACTIONS(4074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4074),
    [anon_sym_SLASH_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_PIPE_EQ] = ACTIONS(4074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4074),
    [anon_sym_AMP_EQ] = ACTIONS(4074),
    [anon_sym_PERCENT_EQ] = ACTIONS(4074),
    [anon_sym_GT_GT_EQ] = ACTIONS(4074),
    [anon_sym_LT_LT_EQ] = ACTIONS(4074),
    [anon_sym_CARET_EQ] = ACTIONS(4074),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(4074),
    [anon_sym_or] = ACTIONS(4074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10856] = {
    [sym__heredoc_body_start] = ACTIONS(4110),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(4110),
    [anon_sym_DOT] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_EQ_GT] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_COLON_COLON2] = ACTIONS(4110),
    [anon_sym_AMP_DOT] = ACTIONS(4110),
    [anon_sym_PLUS_EQ] = ACTIONS(4110),
    [anon_sym_DASH_EQ] = ACTIONS(4110),
    [anon_sym_STAR_EQ] = ACTIONS(4110),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4110),
    [anon_sym_SLASH_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_PIPE_EQ] = ACTIONS(4110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4110),
    [anon_sym_AMP_EQ] = ACTIONS(4110),
    [anon_sym_PERCENT_EQ] = ACTIONS(4110),
    [anon_sym_GT_GT_EQ] = ACTIONS(4110),
    [anon_sym_LT_LT_EQ] = ACTIONS(4110),
    [anon_sym_CARET_EQ] = ACTIONS(4110),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10857] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11036),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(11036),
    [sym_operator_assignment] = STATE(11036),
    [sym_conditional] = STATE(11036),
    [sym_range] = STATE(11036),
    [sym_binary] = STATE(11036),
    [sym_unary] = STATE(11036),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10858] = {
    [sym__heredoc_body_start] = ACTIONS(3148),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(4114),
    [anon_sym_COMMA] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_EQ_GT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_COLON_COLON2] = ACTIONS(3148),
    [anon_sym_AMP_DOT] = ACTIONS(3148),
    [anon_sym_PLUS_EQ] = ACTIONS(3148),
    [anon_sym_DASH_EQ] = ACTIONS(3148),
    [anon_sym_STAR_EQ] = ACTIONS(3148),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3148),
    [anon_sym_SLASH_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_PIPE_EQ] = ACTIONS(3148),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3148),
    [anon_sym_AMP_EQ] = ACTIONS(3148),
    [anon_sym_PERCENT_EQ] = ACTIONS(3148),
    [anon_sym_GT_GT_EQ] = ACTIONS(3148),
    [anon_sym_LT_LT_EQ] = ACTIONS(3148),
    [anon_sym_CARET_EQ] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(3148),
    [anon_sym_or] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10859] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11037),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(11037),
    [sym_operator_assignment] = STATE(11037),
    [sym_conditional] = STATE(11037),
    [sym_range] = STATE(11037),
    [sym_binary] = STATE(11037),
    [sym_unary] = STATE(11037),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10860] = {
    [sym_heredoc_body] = STATE(11038),
    [aux_sym_call_repeat1] = STATE(11038),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [10861] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10497),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym__argument] = STATE(4285),
    [sym_splat_argument] = STATE(4285),
    [sym_hash_splat_argument] = STATE(4285),
    [sym_block_argument] = STATE(4285),
    [sym_assignment] = STATE(10497),
    [sym_operator_assignment] = STATE(10497),
    [sym_conditional] = STATE(10497),
    [sym_range] = STATE(10497),
    [sym_binary] = STATE(10497),
    [sym_unary] = STATE(10497),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10500),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_heredoc_body] = STATE(11039),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(4285),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym__heredoc_body_start] = ACTIONS(4250),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14052),
    [sym__splat_star] = ACTIONS(14054),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__identifier_hash_key] = ACTIONS(14056),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14799),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(14058),
    [sym_identifier] = ACTIONS(14058),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10862] = {
    [sym_heredoc_body] = STATE(11040),
    [aux_sym_call_repeat1] = STATE(11040),
    [aux_sym_argument_list_repeat1] = STATE(11041),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(14617),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_do] = ACTIONS(4246),
    [anon_sym_EQ_GT] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_PLUS_EQ] = ACTIONS(4246),
    [anon_sym_DASH_EQ] = ACTIONS(4246),
    [anon_sym_STAR_EQ] = ACTIONS(4246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4246),
    [anon_sym_SLASH_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_PIPE_EQ] = ACTIONS(4246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4246),
    [anon_sym_AMP_EQ] = ACTIONS(4246),
    [anon_sym_PERCENT_EQ] = ACTIONS(4246),
    [anon_sym_GT_GT_EQ] = ACTIONS(4246),
    [anon_sym_LT_LT_EQ] = ACTIONS(4246),
    [anon_sym_CARET_EQ] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4248),
    [anon_sym_LT_LT] = ACTIONS(4248),
    [anon_sym_GT_GT] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4248),
    [anon_sym_PLUS] = ACTIONS(4248),
    [anon_sym_SLASH] = ACTIONS(4248),
    [anon_sym_PERCENT] = ACTIONS(4248),
    [sym_comment] = ACTIONS(87),
  },
  [10863] = {
    [sym_heredoc_body] = STATE(10863),
    [aux_sym_call_repeat1] = STATE(10863),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10864] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(9723),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(9723),
    [sym_operator_assignment] = STATE(9723),
    [sym_conditional] = STATE(9723),
    [sym_range] = STATE(9723),
    [sym_binary] = STATE(9723),
    [sym_unary] = STATE(9723),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(9729),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(13153),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__identifier_hash_key] = ACTIONS(13159),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14621),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13177),
    [sym_identifier] = ACTIONS(13177),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10865] = {
    [sym_heredoc_body] = STATE(10863),
    [aux_sym_call_repeat1] = STATE(10863),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10866] = {
    [aux_sym_argument_list_repeat1] = STATE(10866),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14801),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [10867] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10868] = {
    [aux_sym_exceptions_repeat1] = STATE(11043),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10869] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [10870] = {
    [sym_string] = STATE(10870),
    [aux_sym_chained_string_repeat1] = STATE(10870),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [10871] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(11044),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_assignment] = STATE(11044),
    [sym_operator_assignment] = STATE(11044),
    [sym_conditional] = STATE(11044),
    [sym_range] = STATE(11044),
    [sym_binary] = STATE(11044),
    [sym_unary] = STATE(11044),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10872] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(935),
    [sym__binary_star] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(937),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(935),
    [anon_sym_DOT_DOT] = ACTIONS(937),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(935),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(937),
    [anon_sym_AMP_AMP] = ACTIONS(937),
    [anon_sym_LT_LT] = ACTIONS(937),
    [anon_sym_GT_GT] = ACTIONS(937),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(935),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(935),
    [anon_sym_LT_EQ_GT] = ACTIONS(935),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_BANG_TILDE] = ACTIONS(935),
    [anon_sym_LT_EQ] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_GT_EQ] = ACTIONS(935),
    [anon_sym_CARET] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(937),
    [anon_sym_PERCENT] = ACTIONS(937),
    [sym_comment] = ACTIONS(87),
  },
  [10873] = {
    [sym__heredoc_body_start] = ACTIONS(935),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(935),
    [anon_sym_DOT] = ACTIONS(937),
    [anon_sym_COMMA] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(935),
    [anon_sym_COLON_COLON2] = ACTIONS(935),
    [anon_sym_AMP_DOT] = ACTIONS(935),
    [anon_sym_PLUS_EQ] = ACTIONS(935),
    [anon_sym_DASH_EQ] = ACTIONS(935),
    [anon_sym_STAR_EQ] = ACTIONS(935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(935),
    [anon_sym_SLASH_EQ] = ACTIONS(935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(935),
    [anon_sym_PIPE_EQ] = ACTIONS(935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(935),
    [anon_sym_AMP_EQ] = ACTIONS(935),
    [anon_sym_PERCENT_EQ] = ACTIONS(935),
    [anon_sym_GT_GT_EQ] = ACTIONS(935),
    [anon_sym_LT_LT_EQ] = ACTIONS(935),
    [anon_sym_CARET_EQ] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(14637),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(935),
    [anon_sym_or] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [10874] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11045),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11045),
    [sym_operator_assignment] = STATE(11045),
    [sym_conditional] = STATE(11045),
    [sym_range] = STATE(11045),
    [sym_binary] = STATE(11045),
    [sym_unary] = STATE(11045),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10875] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11046),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11046),
    [sym_operator_assignment] = STATE(11046),
    [sym_conditional] = STATE(11046),
    [sym_range] = STATE(11046),
    [sym_binary] = STATE(11046),
    [sym_unary] = STATE(11046),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10876] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11047),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11047),
    [sym_operator_assignment] = STATE(11047),
    [sym_conditional] = STATE(11047),
    [sym_range] = STATE(11047),
    [sym_binary] = STATE(11047),
    [sym_unary] = STATE(11047),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10877] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11048),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11048),
    [sym_operator_assignment] = STATE(11048),
    [sym_conditional] = STATE(11048),
    [sym_range] = STATE(11048),
    [sym_binary] = STATE(11048),
    [sym_unary] = STATE(11048),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10878] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11049),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11049),
    [sym_operator_assignment] = STATE(11049),
    [sym_conditional] = STATE(11049),
    [sym_range] = STATE(11049),
    [sym_binary] = STATE(11049),
    [sym_unary] = STATE(11049),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10879] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(11050),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(1433),
    [sym_scope_resolution] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_method_call] = STATE(1433),
    [sym_assignment] = STATE(11050),
    [sym_operator_assignment] = STATE(11050),
    [sym_conditional] = STATE(11050),
    [sym_range] = STATE(11050),
    [sym_binary] = STATE(11050),
    [sym_unary] = STATE(11050),
    [sym_left_assignment_list] = STATE(1432),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(1433),
    [sym__variable] = STATE(1431),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(1433),
    [sym_false] = STATE(1433),
    [sym_nil] = STATE(1433),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(1434),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(2503),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__unary_minus] = ACTIONS(2505),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_yield] = ACTIONS(2509),
    [anon_sym_break] = ACTIONS(2511),
    [anon_sym_next] = ACTIONS(2513),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2515),
    [anon_sym_defined_QMARK] = ACTIONS(2517),
    [anon_sym_not] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2521),
    [anon_sym_TILDE] = ACTIONS(2521),
    [sym_constant] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2523),
    [sym_instance_variable] = ACTIONS(2525),
    [sym_class_variable] = ACTIONS(2525),
    [sym_global_variable] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(2523),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(2523),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10880] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11051),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11051),
    [sym_operator_assignment] = STATE(11051),
    [sym_conditional] = STATE(11051),
    [sym_range] = STATE(11051),
    [sym_binary] = STATE(11051),
    [sym_unary] = STATE(11051),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10881] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11052),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11052),
    [sym_operator_assignment] = STATE(11052),
    [sym_conditional] = STATE(11052),
    [sym_range] = STATE(11052),
    [sym_binary] = STATE(11052),
    [sym_unary] = STATE(11052),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10882] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11053),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11053),
    [sym_operator_assignment] = STATE(11053),
    [sym_conditional] = STATE(11053),
    [sym_range] = STATE(11053),
    [sym_binary] = STATE(11053),
    [sym_unary] = STATE(11053),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10883] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11054),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11054),
    [sym_operator_assignment] = STATE(11054),
    [sym_conditional] = STATE(11054),
    [sym_range] = STATE(11054),
    [sym_binary] = STATE(11054),
    [sym_unary] = STATE(11054),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10884] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11055),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_splat_argument] = STATE(11056),
    [sym_assignment] = STATE(11055),
    [sym_operator_assignment] = STATE(11055),
    [sym_conditional] = STATE(11055),
    [sym_range] = STATE(11055),
    [sym_binary] = STATE(11055),
    [sym_unary] = STATE(11055),
    [sym_right_assignment_list] = STATE(8647),
    [sym__arg_or_splat_arg] = STATE(11056),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10885] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11057),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11057),
    [sym_operator_assignment] = STATE(11057),
    [sym_conditional] = STATE(11057),
    [sym_range] = STATE(11057),
    [sym_binary] = STATE(11057),
    [sym_unary] = STATE(11057),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [10886] = {
    [sym_string] = STATE(11058),
    [aux_sym_chained_string_repeat1] = STATE(11058),
    [sym__string_start] = ACTIONS(6187),
    [sym__heredoc_body_start] = ACTIONS(2759),
    [sym__binary_minus] = ACTIONS(2759),
    [sym__binary_star] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_DOT] = ACTIONS(2761),
    [anon_sym_COMMA] = ACTIONS(2759),
    [anon_sym_PIPE] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_STAR_STAR] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2761),
    [anon_sym_LT] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_COLON_COLON2] = ACTIONS(2759),
    [anon_sym_AMP_DOT] = ACTIONS(2759),
    [anon_sym_PLUS_EQ] = ACTIONS(2759),
    [anon_sym_DASH_EQ] = ACTIONS(2759),
    [anon_sym_STAR_EQ] = ACTIONS(2759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2759),
    [anon_sym_SLASH_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_PIPE_EQ] = ACTIONS(2759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2759),
    [anon_sym_AMP_EQ] = ACTIONS(2759),
    [anon_sym_PERCENT_EQ] = ACTIONS(2759),
    [anon_sym_GT_GT_EQ] = ACTIONS(2759),
    [anon_sym_LT_LT_EQ] = ACTIONS(2759),
    [anon_sym_CARET_EQ] = ACTIONS(2759),
    [anon_sym_QMARK] = ACTIONS(2759),
    [anon_sym_DOT_DOT] = ACTIONS(2761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2759),
    [anon_sym_or] = ACTIONS(2759),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2761),
    [anon_sym_GT_GT] = ACTIONS(2761),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2759),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2759),
    [anon_sym_LT_EQ_GT] = ACTIONS(2759),
    [anon_sym_EQ_TILDE] = ACTIONS(2759),
    [anon_sym_BANG_TILDE] = ACTIONS(2759),
    [anon_sym_LT_EQ] = ACTIONS(2761),
    [anon_sym_GT] = ACTIONS(2761),
    [anon_sym_GT_EQ] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_SLASH] = ACTIONS(2761),
    [anon_sym_PERCENT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(87),
  },
  [10887] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(14637),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [10888] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(14637),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [10889] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10890] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [10891] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10892] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10893] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10894] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14804),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10895] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_EQ_GT] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10896] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10897] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10898] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_EQ_GT] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10899] = {
    [sym_heredoc_body] = STATE(10899),
    [aux_sym_call_repeat1] = STATE(10899),
    [sym__heredoc_body_start] = ACTIONS(12063),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [10900] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(9759),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(13211),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__identifier_hash_key] = ACTIONS(13217),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14659),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13235),
    [sym_identifier] = ACTIONS(13235),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [10901] = {
    [sym_heredoc_body] = STATE(10899),
    [aux_sym_call_repeat1] = STATE(10899),
    [sym__heredoc_body_start] = ACTIONS(6301),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [10902] = {
    [aux_sym_argument_list_repeat1] = STATE(10902),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14806),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [10903] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10904] = {
    [aux_sym_exceptions_repeat1] = STATE(11061),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_EQ_GT] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [10905] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_EQ_GT] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [10906] = {
    [sym_string] = STATE(10906),
    [aux_sym_chained_string_repeat1] = STATE(10906),
    [sym__string_start] = ACTIONS(10160),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_EQ_GT] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [10907] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(4110),
    [anon_sym_PIPE] = ACTIONS(14070),
    [anon_sym_SEMI] = ACTIONS(4110),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(13191),
    [anon_sym_QMARK] = ACTIONS(13193),
    [anon_sym_DOT_DOT] = ACTIONS(13195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13197),
    [anon_sym_and] = ACTIONS(4110),
    [anon_sym_or] = ACTIONS(4110),
    [anon_sym_PIPE_PIPE] = ACTIONS(13201),
    [anon_sym_AMP_AMP] = ACTIONS(13201),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(13205),
    [anon_sym_BANG_EQ] = ACTIONS(13201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13201),
    [anon_sym_LT_EQ_GT] = ACTIONS(13201),
    [anon_sym_EQ_TILDE] = ACTIONS(13201),
    [anon_sym_BANG_TILDE] = ACTIONS(13201),
    [anon_sym_LT_EQ] = ACTIONS(13191),
    [anon_sym_GT] = ACTIONS(13191),
    [anon_sym_GT_EQ] = ACTIONS(13207),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [10908] = {
    [sym_method] = STATE(453),
    [sym_singleton_method] = STATE(453),
    [sym_class] = STATE(453),
    [sym_singleton_class] = STATE(453),
    [sym_module] = STATE(453),
    [sym_return] = STATE(453),
    [sym_yield] = STATE(453),
    [sym_break] = STATE(453),
    [sym_next] = STATE(453),
    [sym_while] = STATE(453),
    [sym_until] = STATE(453),
    [sym_for] = STATE(453),
    [sym_case] = STATE(453),
    [sym_if] = STATE(453),
    [sym_unless] = STATE(453),
    [sym_begin] = STATE(453),
    [sym__arg] = STATE(10553),
    [sym__primary] = STATE(453),
    [sym_parenthesized_statements] = STATE(453),
    [sym_element_reference] = STATE(8316),
    [sym_scope_resolution] = STATE(8314),
    [sym_call] = STATE(8314),
    [sym_method_call] = STATE(8316),
    [sym_splat_argument] = STATE(6835),
    [sym_assignment] = STATE(10553),
    [sym_operator_assignment] = STATE(10553),
    [sym_conditional] = STATE(10553),
    [sym_range] = STATE(10553),
    [sym_binary] = STATE(10553),
    [sym_unary] = STATE(10553),
    [sym__arg_or_splat_arg] = STATE(6835),
    [sym_left_assignment_list] = STATE(8315),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(8316),
    [sym__variable] = STATE(8314),
    [sym_rational] = STATE(453),
    [sym_true] = STATE(8316),
    [sym_false] = STATE(8316),
    [sym_nil] = STATE(8316),
    [sym_chained_string] = STATE(453),
    [sym_string] = STATE(8317),
    [sym_subshell] = STATE(453),
    [sym_string_array] = STATE(453),
    [sym_symbol_array] = STATE(453),
    [sym_symbol] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_array] = STATE(453),
    [sym_hash] = STATE(453),
    [sym_lambda] = STATE(453),
    [sym__simple_symbol] = ACTIONS(137),
    [sym__string_start] = ACTIONS(139),
    [sym__symbol_start] = ACTIONS(141),
    [sym__subshell_start] = ACTIONS(143),
    [sym__regex_start] = ACTIONS(145),
    [sym__string_array_start] = ACTIONS(147),
    [sym__symbol_array_start] = ACTIONS(149),
    [sym_heredoc_beginning] = ACTIONS(841),
    [sym__splat_star] = ACTIONS(14138),
    [sym__unary_minus] = ACTIONS(11629),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(11631),
    [anon_sym_yield] = ACTIONS(11633),
    [anon_sym_break] = ACTIONS(11635),
    [anon_sym_next] = ACTIONS(11637),
    [sym_redo] = ACTIONS(857),
    [sym_retry] = ACTIONS(857),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(11639),
    [anon_sym_defined_QMARK] = ACTIONS(11641),
    [anon_sym_not] = ACTIONS(11643),
    [anon_sym_BANG] = ACTIONS(11645),
    [anon_sym_TILDE] = ACTIONS(11645),
    [sym_constant] = ACTIONS(11647),
    [sym_identifier] = ACTIONS(11647),
    [sym_instance_variable] = ACTIONS(11649),
    [sym_class_variable] = ACTIONS(11649),
    [sym_global_variable] = ACTIONS(11649),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(857),
    [sym_complex] = ACTIONS(841),
    [sym_super] = ACTIONS(11647),
    [anon_sym_true] = ACTIONS(875),
    [anon_sym_TRUE] = ACTIONS(875),
    [anon_sym_false] = ACTIONS(877),
    [anon_sym_FALSE] = ACTIONS(877),
    [sym_self] = ACTIONS(11647),
    [anon_sym_nil] = ACTIONS(879),
    [anon_sym_NIL] = ACTIONS(879),
    [sym_character] = ACTIONS(841),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10909] = {
    [aux_sym_exceptions_repeat1] = STATE(11062),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_COMMA] = ACTIONS(14809),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10910] = {
    [sym__simple_symbol] = ACTIONS(14811),
    [sym__string_start] = ACTIONS(14811),
    [sym__symbol_start] = ACTIONS(14811),
    [sym__subshell_start] = ACTIONS(14811),
    [sym__regex_start] = ACTIONS(14811),
    [sym__string_array_start] = ACTIONS(14811),
    [sym__symbol_array_start] = ACTIONS(14811),
    [sym_heredoc_beginning] = ACTIONS(14811),
    [sym__unary_minus] = ACTIONS(14811),
    [anon_sym_BEGIN] = ACTIONS(14813),
    [anon_sym_LBRACE] = ACTIONS(14811),
    [anon_sym_RBRACE] = ACTIONS(14811),
    [anon_sym_END] = ACTIONS(14813),
    [anon_sym_def] = ACTIONS(14813),
    [anon_sym_LPAREN] = ACTIONS(14811),
    [anon_sym_COLON_COLON] = ACTIONS(14811),
    [anon_sym_SEMI] = ACTIONS(14811),
    [anon_sym_STAR] = ACTIONS(14811),
    [anon_sym_class] = ACTIONS(14813),
    [anon_sym_module] = ACTIONS(14813),
    [anon_sym_return] = ACTIONS(14813),
    [anon_sym_yield] = ACTIONS(14813),
    [anon_sym_break] = ACTIONS(14813),
    [anon_sym_next] = ACTIONS(14813),
    [sym_redo] = ACTIONS(14813),
    [sym_retry] = ACTIONS(14813),
    [anon_sym_if] = ACTIONS(14813),
    [anon_sym_unless] = ACTIONS(14813),
    [anon_sym_while] = ACTIONS(14813),
    [anon_sym_until] = ACTIONS(14813),
    [anon_sym_for] = ACTIONS(14813),
    [anon_sym_case] = ACTIONS(14813),
    [anon_sym_begin] = ACTIONS(14813),
    [anon_sym_PLUS] = ACTIONS(14813),
    [anon_sym_defined_QMARK] = ACTIONS(14811),
    [anon_sym_not] = ACTIONS(14813),
    [anon_sym_BANG] = ACTIONS(14811),
    [anon_sym_TILDE] = ACTIONS(14811),
    [sym_constant] = ACTIONS(14813),
    [sym_identifier] = ACTIONS(14813),
    [sym_instance_variable] = ACTIONS(14811),
    [sym_class_variable] = ACTIONS(14811),
    [sym_global_variable] = ACTIONS(14811),
    [anon_sym_undef] = ACTIONS(14813),
    [anon_sym_alias] = ACTIONS(14813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(14813),
    [sym_float] = ACTIONS(14813),
    [sym_complex] = ACTIONS(14811),
    [sym_super] = ACTIONS(14813),
    [anon_sym_true] = ACTIONS(14813),
    [anon_sym_TRUE] = ACTIONS(14813),
    [anon_sym_false] = ACTIONS(14813),
    [anon_sym_FALSE] = ACTIONS(14813),
    [sym_self] = ACTIONS(14813),
    [anon_sym_nil] = ACTIONS(14813),
    [anon_sym_NIL] = ACTIONS(14813),
    [sym_character] = ACTIONS(14811),
    [anon_sym_LBRACK2] = ACTIONS(14811),
    [anon_sym_DASH_GT] = ACTIONS(14811),
  },
  [10911] = {
    [aux_sym_block_parameters_repeat1] = STATE(9709),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(14815),
    [sym_comment] = ACTIONS(87),
  },
  [10912] = {
    [sym__line_break] = ACTIONS(14811),
    [sym__simple_symbol] = ACTIONS(14811),
    [sym__string_start] = ACTIONS(14811),
    [sym__symbol_start] = ACTIONS(14811),
    [sym__subshell_start] = ACTIONS(14811),
    [sym__regex_start] = ACTIONS(14811),
    [sym__string_array_start] = ACTIONS(14811),
    [sym__symbol_array_start] = ACTIONS(14811),
    [sym__heredoc_body_start] = ACTIONS(14811),
    [sym_heredoc_beginning] = ACTIONS(14811),
    [sym__unary_minus] = ACTIONS(14811),
    [anon_sym_BEGIN] = ACTIONS(14813),
    [anon_sym_LBRACE] = ACTIONS(14811),
    [anon_sym_END] = ACTIONS(14813),
    [anon_sym_def] = ACTIONS(14813),
    [anon_sym_LPAREN] = ACTIONS(14811),
    [anon_sym_COLON_COLON] = ACTIONS(14811),
    [anon_sym_SEMI] = ACTIONS(14811),
    [anon_sym_STAR] = ACTIONS(14811),
    [anon_sym_class] = ACTIONS(14813),
    [anon_sym_module] = ACTIONS(14813),
    [anon_sym_end] = ACTIONS(14813),
    [anon_sym_return] = ACTIONS(14813),
    [anon_sym_yield] = ACTIONS(14813),
    [anon_sym_break] = ACTIONS(14813),
    [anon_sym_next] = ACTIONS(14813),
    [sym_redo] = ACTIONS(14813),
    [sym_retry] = ACTIONS(14813),
    [anon_sym_if] = ACTIONS(14813),
    [anon_sym_unless] = ACTIONS(14813),
    [anon_sym_while] = ACTIONS(14813),
    [anon_sym_until] = ACTIONS(14813),
    [anon_sym_for] = ACTIONS(14813),
    [anon_sym_case] = ACTIONS(14813),
    [anon_sym_begin] = ACTIONS(14813),
    [anon_sym_PLUS] = ACTIONS(14813),
    [anon_sym_defined_QMARK] = ACTIONS(14811),
    [anon_sym_not] = ACTIONS(14813),
    [anon_sym_BANG] = ACTIONS(14811),
    [anon_sym_TILDE] = ACTIONS(14811),
    [sym_constant] = ACTIONS(14813),
    [sym_identifier] = ACTIONS(14813),
    [sym_instance_variable] = ACTIONS(14811),
    [sym_class_variable] = ACTIONS(14811),
    [sym_global_variable] = ACTIONS(14811),
    [anon_sym_undef] = ACTIONS(14813),
    [anon_sym_alias] = ACTIONS(14813),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(14813),
    [sym_float] = ACTIONS(14813),
    [sym_complex] = ACTIONS(14811),
    [sym_super] = ACTIONS(14813),
    [anon_sym_true] = ACTIONS(14813),
    [anon_sym_TRUE] = ACTIONS(14813),
    [anon_sym_false] = ACTIONS(14813),
    [anon_sym_FALSE] = ACTIONS(14813),
    [sym_self] = ACTIONS(14813),
    [anon_sym_nil] = ACTIONS(14813),
    [anon_sym_NIL] = ACTIONS(14813),
    [sym_character] = ACTIONS(14811),
    [anon_sym_LBRACK2] = ACTIONS(14811),
    [anon_sym_DASH_GT] = ACTIONS(14811),
  },
  [10913] = {
    [aux_sym_block_parameters_repeat1] = STATE(9709),
    [anon_sym_COMMA] = ACTIONS(11625),
    [anon_sym_PIPE] = ACTIONS(14817),
    [sym_comment] = ACTIONS(87),
  },
  [10914] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11692),
    [sym__binary_star] = ACTIONS(11694),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11696),
    [anon_sym_STAR_STAR] = ACTIONS(11694),
    [anon_sym_AMP] = ACTIONS(11698),
    [anon_sym_LT] = ACTIONS(11700),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11702),
    [anon_sym_COLON2] = ACTIONS(12409),
    [anon_sym_DOT_DOT] = ACTIONS(11704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11706),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11708),
    [anon_sym_AMP_AMP] = ACTIONS(11708),
    [anon_sym_LT_LT] = ACTIONS(11710),
    [anon_sym_GT_GT] = ACTIONS(11710),
    [anon_sym_EQ_EQ] = ACTIONS(11712),
    [anon_sym_BANG_EQ] = ACTIONS(11708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11708),
    [anon_sym_LT_EQ_GT] = ACTIONS(11708),
    [anon_sym_EQ_TILDE] = ACTIONS(11708),
    [anon_sym_BANG_TILDE] = ACTIONS(11708),
    [anon_sym_LT_EQ] = ACTIONS(11700),
    [anon_sym_GT] = ACTIONS(11700),
    [anon_sym_GT_EQ] = ACTIONS(11714),
    [anon_sym_CARET] = ACTIONS(11716),
    [anon_sym_PLUS] = ACTIONS(11692),
    [anon_sym_SLASH] = ACTIONS(11694),
    [anon_sym_PERCENT] = ACTIONS(11694),
    [sym_comment] = ACTIONS(87),
  },
  [10915] = {
    [aux_sym_exceptions_repeat1] = STATE(10915),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14819),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11972),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10916] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11748),
    [sym__binary_star] = ACTIONS(11750),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11752),
    [anon_sym_STAR_STAR] = ACTIONS(11754),
    [anon_sym_AMP] = ACTIONS(11756),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(11758),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11760),
    [anon_sym_COLON2] = ACTIONS(12409),
    [anon_sym_DOT_DOT] = ACTIONS(11762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11764),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11766),
    [anon_sym_AMP_AMP] = ACTIONS(11766),
    [anon_sym_LT_LT] = ACTIONS(11768),
    [anon_sym_GT_GT] = ACTIONS(11768),
    [anon_sym_EQ_EQ] = ACTIONS(11766),
    [anon_sym_BANG_EQ] = ACTIONS(11770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11770),
    [anon_sym_LT_EQ_GT] = ACTIONS(11770),
    [anon_sym_EQ_TILDE] = ACTIONS(11770),
    [anon_sym_BANG_TILDE] = ACTIONS(11770),
    [anon_sym_LT_EQ] = ACTIONS(11758),
    [anon_sym_GT] = ACTIONS(11758),
    [anon_sym_GT_EQ] = ACTIONS(11772),
    [anon_sym_CARET] = ACTIONS(11752),
    [anon_sym_PLUS] = ACTIONS(11774),
    [anon_sym_SLASH] = ACTIONS(11754),
    [anon_sym_PERCENT] = ACTIONS(11754),
    [sym_comment] = ACTIONS(87),
  },
  [10917] = {
    [aux_sym_exceptions_repeat1] = STATE(10917),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14822),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11972),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10918] = {
    [sym__binary_minus] = ACTIONS(11786),
    [sym__binary_star] = ACTIONS(11788),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11790),
    [anon_sym_STAR_STAR] = ACTIONS(11788),
    [anon_sym_AMP] = ACTIONS(11792),
    [anon_sym_LT] = ACTIONS(11794),
    [anon_sym_QMARK] = ACTIONS(11796),
    [anon_sym_COLON2] = ACTIONS(11746),
    [anon_sym_DOT_DOT] = ACTIONS(11798),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11800),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11802),
    [anon_sym_AMP_AMP] = ACTIONS(11802),
    [anon_sym_LT_LT] = ACTIONS(11804),
    [anon_sym_GT_GT] = ACTIONS(11804),
    [anon_sym_EQ_EQ] = ACTIONS(11806),
    [anon_sym_BANG_EQ] = ACTIONS(11802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11802),
    [anon_sym_LT_EQ_GT] = ACTIONS(11802),
    [anon_sym_EQ_TILDE] = ACTIONS(11802),
    [anon_sym_BANG_TILDE] = ACTIONS(11802),
    [anon_sym_LT_EQ] = ACTIONS(11794),
    [anon_sym_GT] = ACTIONS(11794),
    [anon_sym_GT_EQ] = ACTIONS(11808),
    [anon_sym_CARET] = ACTIONS(11810),
    [anon_sym_PLUS] = ACTIONS(11786),
    [anon_sym_SLASH] = ACTIONS(11788),
    [anon_sym_PERCENT] = ACTIONS(11788),
    [sym_comment] = ACTIONS(87),
  },
  [10919] = {
    [sym__line_break] = ACTIONS(13660),
    [sym__heredoc_body_start] = ACTIONS(13660),
    [sym__binary_minus] = ACTIONS(13660),
    [sym__binary_star] = ACTIONS(13660),
    [ts_builtin_sym_end] = ACTIONS(13660),
    [anon_sym___END__] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_RBRACE] = ACTIONS(13660),
    [anon_sym_RPAREN] = ACTIONS(13660),
    [anon_sym_DOT] = ACTIONS(13662),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_PIPE] = ACTIONS(13662),
    [anon_sym_SEMI] = ACTIONS(13660),
    [anon_sym_STAR_STAR] = ACTIONS(13662),
    [anon_sym_AMP] = ACTIONS(13662),
    [anon_sym_EQ] = ACTIONS(13662),
    [anon_sym_LT] = ACTIONS(13662),
    [anon_sym_end] = ACTIONS(13660),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_unless] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [anon_sym_until] = ACTIONS(13660),
    [anon_sym_rescue] = ACTIONS(13660),
    [anon_sym_do] = ACTIONS(13660),
    [anon_sym_when] = ACTIONS(13660),
    [anon_sym_elsif] = ACTIONS(13660),
    [anon_sym_else] = ACTIONS(13660),
    [anon_sym_then] = ACTIONS(13660),
    [anon_sym_ensure] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_COLON_COLON2] = ACTIONS(13660),
    [anon_sym_AMP_DOT] = ACTIONS(13660),
    [anon_sym_PLUS_EQ] = ACTIONS(13660),
    [anon_sym_DASH_EQ] = ACTIONS(13660),
    [anon_sym_STAR_EQ] = ACTIONS(13660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13660),
    [anon_sym_SLASH_EQ] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13660),
    [anon_sym_PIPE_EQ] = ACTIONS(13660),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13660),
    [anon_sym_AMP_EQ] = ACTIONS(13660),
    [anon_sym_PERCENT_EQ] = ACTIONS(13660),
    [anon_sym_GT_GT_EQ] = ACTIONS(13660),
    [anon_sym_LT_LT_EQ] = ACTIONS(13660),
    [anon_sym_CARET_EQ] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_DOT_DOT] = ACTIONS(13662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_and] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE] = ACTIONS(13662),
    [anon_sym_AMP_AMP] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13662),
    [anon_sym_GT_GT] = ACTIONS(13662),
    [anon_sym_EQ_EQ] = ACTIONS(13662),
    [anon_sym_BANG_EQ] = ACTIONS(13660),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13660),
    [anon_sym_LT_EQ_GT] = ACTIONS(13660),
    [anon_sym_EQ_TILDE] = ACTIONS(13660),
    [anon_sym_BANG_TILDE] = ACTIONS(13660),
    [anon_sym_LT_EQ] = ACTIONS(13662),
    [anon_sym_GT] = ACTIONS(13662),
    [anon_sym_GT_EQ] = ACTIONS(13660),
    [anon_sym_CARET] = ACTIONS(13662),
    [anon_sym_PLUS] = ACTIONS(13662),
    [anon_sym_SLASH] = ACTIONS(13662),
    [anon_sym_PERCENT] = ACTIONS(13662),
    [sym_comment] = ACTIONS(87),
  },
  [10920] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(11908),
    [sym__binary_star] = ACTIONS(11910),
    [anon_sym_RBRACE] = ACTIONS(11746),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(11912),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(11910),
    [anon_sym_AMP] = ACTIONS(11914),
    [anon_sym_LT] = ACTIONS(11916),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(11918),
    [anon_sym_DOT_DOT] = ACTIONS(11920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11922),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(11924),
    [anon_sym_AMP_AMP] = ACTIONS(11924),
    [anon_sym_LT_LT] = ACTIONS(11926),
    [anon_sym_GT_GT] = ACTIONS(11926),
    [anon_sym_EQ_EQ] = ACTIONS(11928),
    [anon_sym_BANG_EQ] = ACTIONS(11924),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11924),
    [anon_sym_LT_EQ_GT] = ACTIONS(11924),
    [anon_sym_EQ_TILDE] = ACTIONS(11924),
    [anon_sym_BANG_TILDE] = ACTIONS(11924),
    [anon_sym_LT_EQ] = ACTIONS(11916),
    [anon_sym_GT] = ACTIONS(11916),
    [anon_sym_GT_EQ] = ACTIONS(11930),
    [anon_sym_CARET] = ACTIONS(11932),
    [anon_sym_PLUS] = ACTIONS(11908),
    [anon_sym_SLASH] = ACTIONS(11910),
    [anon_sym_PERCENT] = ACTIONS(11910),
    [sym_comment] = ACTIONS(87),
  },
  [10921] = {
    [sym__heredoc_body_start] = ACTIONS(12069),
    [sym__binary_minus] = ACTIONS(12069),
    [sym__binary_star] = ACTIONS(12069),
    [anon_sym_LBRACE] = ACTIONS(12069),
    [anon_sym_RBRACE] = ACTIONS(12069),
    [anon_sym_RPAREN] = ACTIONS(12069),
    [anon_sym_DOT] = ACTIONS(12071),
    [anon_sym_COMMA] = ACTIONS(12069),
    [anon_sym_PIPE] = ACTIONS(12071),
    [anon_sym_SEMI] = ACTIONS(12069),
    [anon_sym_STAR_STAR] = ACTIONS(12071),
    [anon_sym_AMP] = ACTIONS(12071),
    [anon_sym_EQ] = ACTIONS(12071),
    [anon_sym_LT] = ACTIONS(12071),
    [anon_sym_if] = ACTIONS(12069),
    [anon_sym_unless] = ACTIONS(12069),
    [anon_sym_while] = ACTIONS(12069),
    [anon_sym_until] = ACTIONS(12069),
    [anon_sym_rescue] = ACTIONS(12069),
    [anon_sym_in] = ACTIONS(12069),
    [anon_sym_do] = ACTIONS(12069),
    [anon_sym_LBRACK] = ACTIONS(12069),
    [anon_sym_RBRACK] = ACTIONS(12069),
    [anon_sym_COLON_COLON2] = ACTIONS(12069),
    [anon_sym_AMP_DOT] = ACTIONS(12069),
    [anon_sym_PLUS_EQ] = ACTIONS(12069),
    [anon_sym_DASH_EQ] = ACTIONS(12069),
    [anon_sym_STAR_EQ] = ACTIONS(12069),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12069),
    [anon_sym_SLASH_EQ] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12069),
    [anon_sym_PIPE_EQ] = ACTIONS(12069),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12069),
    [anon_sym_AMP_EQ] = ACTIONS(12069),
    [anon_sym_PERCENT_EQ] = ACTIONS(12069),
    [anon_sym_GT_GT_EQ] = ACTIONS(12069),
    [anon_sym_LT_LT_EQ] = ACTIONS(12069),
    [anon_sym_CARET_EQ] = ACTIONS(12069),
    [anon_sym_QMARK] = ACTIONS(12069),
    [anon_sym_COLON2] = ACTIONS(12071),
    [anon_sym_DOT_DOT] = ACTIONS(12071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12069),
    [anon_sym_and] = ACTIONS(12069),
    [anon_sym_or] = ACTIONS(12069),
    [anon_sym_PIPE_PIPE] = ACTIONS(12071),
    [anon_sym_AMP_AMP] = ACTIONS(12071),
    [anon_sym_LT_LT] = ACTIONS(12071),
    [anon_sym_GT_GT] = ACTIONS(12071),
    [anon_sym_EQ_EQ] = ACTIONS(12071),
    [anon_sym_BANG_EQ] = ACTIONS(12069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12069),
    [anon_sym_LT_EQ_GT] = ACTIONS(12069),
    [anon_sym_EQ_TILDE] = ACTIONS(12069),
    [anon_sym_BANG_TILDE] = ACTIONS(12069),
    [anon_sym_LT_EQ] = ACTIONS(12071),
    [anon_sym_GT] = ACTIONS(12071),
    [anon_sym_GT_EQ] = ACTIONS(12069),
    [anon_sym_CARET] = ACTIONS(12071),
    [anon_sym_PLUS] = ACTIONS(12071),
    [anon_sym_SLASH] = ACTIONS(12071),
    [anon_sym_PERCENT] = ACTIONS(12071),
    [sym_comment] = ACTIONS(87),
  },
  [10922] = {
    [sym__heredoc_body_start] = ACTIONS(12073),
    [sym__binary_minus] = ACTIONS(12073),
    [sym__binary_star] = ACTIONS(12073),
    [anon_sym_LBRACE] = ACTIONS(12073),
    [anon_sym_RBRACE] = ACTIONS(12073),
    [anon_sym_RPAREN] = ACTIONS(12073),
    [anon_sym_DOT] = ACTIONS(12075),
    [anon_sym_COMMA] = ACTIONS(12073),
    [anon_sym_PIPE] = ACTIONS(12075),
    [anon_sym_SEMI] = ACTIONS(12073),
    [anon_sym_STAR_STAR] = ACTIONS(12075),
    [anon_sym_AMP] = ACTIONS(12075),
    [anon_sym_EQ] = ACTIONS(12075),
    [anon_sym_LT] = ACTIONS(12075),
    [anon_sym_if] = ACTIONS(12073),
    [anon_sym_unless] = ACTIONS(12073),
    [anon_sym_while] = ACTIONS(12073),
    [anon_sym_until] = ACTIONS(12073),
    [anon_sym_rescue] = ACTIONS(12073),
    [anon_sym_in] = ACTIONS(12073),
    [anon_sym_do] = ACTIONS(12073),
    [anon_sym_LBRACK] = ACTIONS(12073),
    [anon_sym_RBRACK] = ACTIONS(12073),
    [anon_sym_COLON_COLON2] = ACTIONS(12073),
    [anon_sym_AMP_DOT] = ACTIONS(12073),
    [anon_sym_PLUS_EQ] = ACTIONS(12073),
    [anon_sym_DASH_EQ] = ACTIONS(12073),
    [anon_sym_STAR_EQ] = ACTIONS(12073),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12073),
    [anon_sym_SLASH_EQ] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12073),
    [anon_sym_PIPE_EQ] = ACTIONS(12073),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12073),
    [anon_sym_AMP_EQ] = ACTIONS(12073),
    [anon_sym_PERCENT_EQ] = ACTIONS(12073),
    [anon_sym_GT_GT_EQ] = ACTIONS(12073),
    [anon_sym_LT_LT_EQ] = ACTIONS(12073),
    [anon_sym_CARET_EQ] = ACTIONS(12073),
    [anon_sym_QMARK] = ACTIONS(12073),
    [anon_sym_COLON2] = ACTIONS(12075),
    [anon_sym_DOT_DOT] = ACTIONS(12075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12073),
    [anon_sym_and] = ACTIONS(12073),
    [anon_sym_or] = ACTIONS(12073),
    [anon_sym_PIPE_PIPE] = ACTIONS(12075),
    [anon_sym_AMP_AMP] = ACTIONS(12075),
    [anon_sym_LT_LT] = ACTIONS(12075),
    [anon_sym_GT_GT] = ACTIONS(12075),
    [anon_sym_EQ_EQ] = ACTIONS(12075),
    [anon_sym_BANG_EQ] = ACTIONS(12073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12073),
    [anon_sym_LT_EQ_GT] = ACTIONS(12073),
    [anon_sym_EQ_TILDE] = ACTIONS(12073),
    [anon_sym_BANG_TILDE] = ACTIONS(12073),
    [anon_sym_LT_EQ] = ACTIONS(12075),
    [anon_sym_GT] = ACTIONS(12075),
    [anon_sym_GT_EQ] = ACTIONS(12073),
    [anon_sym_CARET] = ACTIONS(12075),
    [anon_sym_PLUS] = ACTIONS(12075),
    [anon_sym_SLASH] = ACTIONS(12075),
    [anon_sym_PERCENT] = ACTIONS(12075),
    [sym_comment] = ACTIONS(87),
  },
  [10923] = {
    [sym__heredoc_body_start] = ACTIONS(12187),
    [sym__binary_minus] = ACTIONS(12187),
    [sym__binary_star] = ACTIONS(12187),
    [anon_sym_LBRACE] = ACTIONS(12187),
    [anon_sym_RBRACE] = ACTIONS(12187),
    [anon_sym_RPAREN] = ACTIONS(12187),
    [anon_sym_DOT] = ACTIONS(12189),
    [anon_sym_COMMA] = ACTIONS(12187),
    [anon_sym_PIPE] = ACTIONS(12189),
    [anon_sym_SEMI] = ACTIONS(12187),
    [anon_sym_STAR_STAR] = ACTIONS(12189),
    [anon_sym_AMP] = ACTIONS(12189),
    [anon_sym_EQ] = ACTIONS(12189),
    [anon_sym_LT] = ACTIONS(12189),
    [anon_sym_if] = ACTIONS(12187),
    [anon_sym_unless] = ACTIONS(12187),
    [anon_sym_while] = ACTIONS(12187),
    [anon_sym_until] = ACTIONS(12187),
    [anon_sym_rescue] = ACTIONS(12187),
    [anon_sym_in] = ACTIONS(12187),
    [anon_sym_do] = ACTIONS(12187),
    [anon_sym_LBRACK] = ACTIONS(12187),
    [anon_sym_RBRACK] = ACTIONS(12187),
    [anon_sym_COLON_COLON2] = ACTIONS(12187),
    [anon_sym_AMP_DOT] = ACTIONS(12187),
    [anon_sym_PLUS_EQ] = ACTIONS(12187),
    [anon_sym_DASH_EQ] = ACTIONS(12187),
    [anon_sym_STAR_EQ] = ACTIONS(12187),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12187),
    [anon_sym_SLASH_EQ] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12187),
    [anon_sym_PIPE_EQ] = ACTIONS(12187),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12187),
    [anon_sym_AMP_EQ] = ACTIONS(12187),
    [anon_sym_PERCENT_EQ] = ACTIONS(12187),
    [anon_sym_GT_GT_EQ] = ACTIONS(12187),
    [anon_sym_LT_LT_EQ] = ACTIONS(12187),
    [anon_sym_CARET_EQ] = ACTIONS(12187),
    [anon_sym_QMARK] = ACTIONS(12187),
    [anon_sym_COLON2] = ACTIONS(12189),
    [anon_sym_DOT_DOT] = ACTIONS(12189),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12187),
    [anon_sym_and] = ACTIONS(12187),
    [anon_sym_or] = ACTIONS(12187),
    [anon_sym_PIPE_PIPE] = ACTIONS(12189),
    [anon_sym_AMP_AMP] = ACTIONS(12189),
    [anon_sym_LT_LT] = ACTIONS(12189),
    [anon_sym_GT_GT] = ACTIONS(12189),
    [anon_sym_EQ_EQ] = ACTIONS(12189),
    [anon_sym_BANG_EQ] = ACTIONS(12187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12187),
    [anon_sym_LT_EQ_GT] = ACTIONS(12187),
    [anon_sym_EQ_TILDE] = ACTIONS(12187),
    [anon_sym_BANG_TILDE] = ACTIONS(12187),
    [anon_sym_LT_EQ] = ACTIONS(12189),
    [anon_sym_GT] = ACTIONS(12189),
    [anon_sym_GT_EQ] = ACTIONS(12187),
    [anon_sym_CARET] = ACTIONS(12189),
    [anon_sym_PLUS] = ACTIONS(12189),
    [anon_sym_SLASH] = ACTIONS(12189),
    [anon_sym_PERCENT] = ACTIONS(12189),
    [sym_comment] = ACTIONS(87),
  },
  [10924] = {
    [sym__heredoc_body_start] = ACTIONS(12482),
    [sym__binary_minus] = ACTIONS(12482),
    [sym__binary_star] = ACTIONS(12482),
    [anon_sym_LBRACE] = ACTIONS(12482),
    [anon_sym_RBRACE] = ACTIONS(12482),
    [anon_sym_RPAREN] = ACTIONS(12482),
    [anon_sym_DOT] = ACTIONS(12484),
    [anon_sym_COMMA] = ACTIONS(12482),
    [anon_sym_PIPE] = ACTIONS(12484),
    [anon_sym_SEMI] = ACTIONS(12482),
    [anon_sym_STAR_STAR] = ACTIONS(12484),
    [anon_sym_AMP] = ACTIONS(12484),
    [anon_sym_EQ] = ACTIONS(12484),
    [anon_sym_LT] = ACTIONS(12484),
    [anon_sym_if] = ACTIONS(12482),
    [anon_sym_unless] = ACTIONS(12482),
    [anon_sym_while] = ACTIONS(12482),
    [anon_sym_until] = ACTIONS(12482),
    [anon_sym_rescue] = ACTIONS(12482),
    [anon_sym_in] = ACTIONS(12482),
    [anon_sym_do] = ACTIONS(12482),
    [anon_sym_LBRACK] = ACTIONS(12482),
    [anon_sym_RBRACK] = ACTIONS(12482),
    [anon_sym_COLON_COLON2] = ACTIONS(12482),
    [anon_sym_AMP_DOT] = ACTIONS(12482),
    [anon_sym_PLUS_EQ] = ACTIONS(12482),
    [anon_sym_DASH_EQ] = ACTIONS(12482),
    [anon_sym_STAR_EQ] = ACTIONS(12482),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12482),
    [anon_sym_SLASH_EQ] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12482),
    [anon_sym_PIPE_EQ] = ACTIONS(12482),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12482),
    [anon_sym_AMP_EQ] = ACTIONS(12482),
    [anon_sym_PERCENT_EQ] = ACTIONS(12482),
    [anon_sym_GT_GT_EQ] = ACTIONS(12482),
    [anon_sym_LT_LT_EQ] = ACTIONS(12482),
    [anon_sym_CARET_EQ] = ACTIONS(12482),
    [anon_sym_QMARK] = ACTIONS(12482),
    [anon_sym_COLON2] = ACTIONS(12484),
    [anon_sym_DOT_DOT] = ACTIONS(12484),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12482),
    [anon_sym_and] = ACTIONS(12482),
    [anon_sym_or] = ACTIONS(12482),
    [anon_sym_PIPE_PIPE] = ACTIONS(12484),
    [anon_sym_AMP_AMP] = ACTIONS(12484),
    [anon_sym_LT_LT] = ACTIONS(12484),
    [anon_sym_GT_GT] = ACTIONS(12484),
    [anon_sym_EQ_EQ] = ACTIONS(12484),
    [anon_sym_BANG_EQ] = ACTIONS(12482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12482),
    [anon_sym_LT_EQ_GT] = ACTIONS(12482),
    [anon_sym_EQ_TILDE] = ACTIONS(12482),
    [anon_sym_BANG_TILDE] = ACTIONS(12482),
    [anon_sym_LT_EQ] = ACTIONS(12484),
    [anon_sym_GT] = ACTIONS(12484),
    [anon_sym_GT_EQ] = ACTIONS(12482),
    [anon_sym_CARET] = ACTIONS(12484),
    [anon_sym_PLUS] = ACTIONS(12484),
    [anon_sym_SLASH] = ACTIONS(12484),
    [anon_sym_PERCENT] = ACTIONS(12484),
    [sym_comment] = ACTIONS(87),
  },
  [10925] = {
    [anon_sym_end] = ACTIONS(14825),
    [sym_comment] = ACTIONS(87),
  },
  [10926] = {
    [sym__heredoc_body_start] = ACTIONS(12622),
    [sym__binary_minus] = ACTIONS(12622),
    [sym__binary_star] = ACTIONS(12622),
    [anon_sym_LBRACE] = ACTIONS(12622),
    [anon_sym_RBRACE] = ACTIONS(12622),
    [anon_sym_RPAREN] = ACTIONS(12622),
    [anon_sym_DOT] = ACTIONS(12624),
    [anon_sym_COMMA] = ACTIONS(12622),
    [anon_sym_PIPE] = ACTIONS(12624),
    [anon_sym_SEMI] = ACTIONS(12622),
    [anon_sym_STAR_STAR] = ACTIONS(12624),
    [anon_sym_AMP] = ACTIONS(12624),
    [anon_sym_EQ] = ACTIONS(12624),
    [anon_sym_LT] = ACTIONS(12624),
    [anon_sym_if] = ACTIONS(12622),
    [anon_sym_unless] = ACTIONS(12622),
    [anon_sym_while] = ACTIONS(12622),
    [anon_sym_until] = ACTIONS(12622),
    [anon_sym_rescue] = ACTIONS(12622),
    [anon_sym_in] = ACTIONS(12622),
    [anon_sym_do] = ACTIONS(12622),
    [anon_sym_LBRACK] = ACTIONS(12622),
    [anon_sym_RBRACK] = ACTIONS(12622),
    [anon_sym_COLON_COLON2] = ACTIONS(12622),
    [anon_sym_AMP_DOT] = ACTIONS(12622),
    [anon_sym_PLUS_EQ] = ACTIONS(12622),
    [anon_sym_DASH_EQ] = ACTIONS(12622),
    [anon_sym_STAR_EQ] = ACTIONS(12622),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12622),
    [anon_sym_SLASH_EQ] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12622),
    [anon_sym_PIPE_EQ] = ACTIONS(12622),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12622),
    [anon_sym_AMP_EQ] = ACTIONS(12622),
    [anon_sym_PERCENT_EQ] = ACTIONS(12622),
    [anon_sym_GT_GT_EQ] = ACTIONS(12622),
    [anon_sym_LT_LT_EQ] = ACTIONS(12622),
    [anon_sym_CARET_EQ] = ACTIONS(12622),
    [anon_sym_QMARK] = ACTIONS(12622),
    [anon_sym_COLON2] = ACTIONS(12624),
    [anon_sym_DOT_DOT] = ACTIONS(12624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12622),
    [anon_sym_and] = ACTIONS(12622),
    [anon_sym_or] = ACTIONS(12622),
    [anon_sym_PIPE_PIPE] = ACTIONS(12624),
    [anon_sym_AMP_AMP] = ACTIONS(12624),
    [anon_sym_LT_LT] = ACTIONS(12624),
    [anon_sym_GT_GT] = ACTIONS(12624),
    [anon_sym_EQ_EQ] = ACTIONS(12624),
    [anon_sym_BANG_EQ] = ACTIONS(12622),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12622),
    [anon_sym_LT_EQ_GT] = ACTIONS(12622),
    [anon_sym_EQ_TILDE] = ACTIONS(12622),
    [anon_sym_BANG_TILDE] = ACTIONS(12622),
    [anon_sym_LT_EQ] = ACTIONS(12624),
    [anon_sym_GT] = ACTIONS(12624),
    [anon_sym_GT_EQ] = ACTIONS(12622),
    [anon_sym_CARET] = ACTIONS(12624),
    [anon_sym_PLUS] = ACTIONS(12624),
    [anon_sym_SLASH] = ACTIONS(12624),
    [anon_sym_PERCENT] = ACTIONS(12624),
    [sym_comment] = ACTIONS(87),
  },
  [10927] = {
    [sym__heredoc_body_start] = ACTIONS(12770),
    [sym__binary_minus] = ACTIONS(12770),
    [sym__binary_star] = ACTIONS(12770),
    [anon_sym_LBRACE] = ACTIONS(12770),
    [anon_sym_RBRACE] = ACTIONS(12770),
    [anon_sym_RPAREN] = ACTIONS(12770),
    [anon_sym_DOT] = ACTIONS(12772),
    [anon_sym_COMMA] = ACTIONS(12770),
    [anon_sym_PIPE] = ACTIONS(12772),
    [anon_sym_SEMI] = ACTIONS(12770),
    [anon_sym_STAR_STAR] = ACTIONS(12772),
    [anon_sym_AMP] = ACTIONS(12772),
    [anon_sym_EQ] = ACTIONS(12772),
    [anon_sym_LT] = ACTIONS(12772),
    [anon_sym_if] = ACTIONS(12770),
    [anon_sym_unless] = ACTIONS(12770),
    [anon_sym_while] = ACTIONS(12770),
    [anon_sym_until] = ACTIONS(12770),
    [anon_sym_rescue] = ACTIONS(12770),
    [anon_sym_in] = ACTIONS(12770),
    [anon_sym_do] = ACTIONS(12770),
    [anon_sym_LBRACK] = ACTIONS(12770),
    [anon_sym_RBRACK] = ACTIONS(12770),
    [anon_sym_COLON_COLON2] = ACTIONS(12770),
    [anon_sym_AMP_DOT] = ACTIONS(12770),
    [anon_sym_PLUS_EQ] = ACTIONS(12770),
    [anon_sym_DASH_EQ] = ACTIONS(12770),
    [anon_sym_STAR_EQ] = ACTIONS(12770),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12770),
    [anon_sym_SLASH_EQ] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12770),
    [anon_sym_PIPE_EQ] = ACTIONS(12770),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12770),
    [anon_sym_AMP_EQ] = ACTIONS(12770),
    [anon_sym_PERCENT_EQ] = ACTIONS(12770),
    [anon_sym_GT_GT_EQ] = ACTIONS(12770),
    [anon_sym_LT_LT_EQ] = ACTIONS(12770),
    [anon_sym_CARET_EQ] = ACTIONS(12770),
    [anon_sym_QMARK] = ACTIONS(12770),
    [anon_sym_COLON2] = ACTIONS(12772),
    [anon_sym_DOT_DOT] = ACTIONS(12772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12770),
    [anon_sym_and] = ACTIONS(12770),
    [anon_sym_or] = ACTIONS(12770),
    [anon_sym_PIPE_PIPE] = ACTIONS(12772),
    [anon_sym_AMP_AMP] = ACTIONS(12772),
    [anon_sym_LT_LT] = ACTIONS(12772),
    [anon_sym_GT_GT] = ACTIONS(12772),
    [anon_sym_EQ_EQ] = ACTIONS(12772),
    [anon_sym_BANG_EQ] = ACTIONS(12770),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12770),
    [anon_sym_LT_EQ_GT] = ACTIONS(12770),
    [anon_sym_EQ_TILDE] = ACTIONS(12770),
    [anon_sym_BANG_TILDE] = ACTIONS(12770),
    [anon_sym_LT_EQ] = ACTIONS(12772),
    [anon_sym_GT] = ACTIONS(12772),
    [anon_sym_GT_EQ] = ACTIONS(12770),
    [anon_sym_CARET] = ACTIONS(12772),
    [anon_sym_PLUS] = ACTIONS(12772),
    [anon_sym_SLASH] = ACTIONS(12772),
    [anon_sym_PERCENT] = ACTIONS(12772),
    [sym_comment] = ACTIONS(87),
  },
  [10928] = {
    [sym__heredoc_body_start] = ACTIONS(12781),
    [sym__binary_minus] = ACTIONS(12781),
    [sym__binary_star] = ACTIONS(12781),
    [anon_sym_LBRACE] = ACTIONS(12781),
    [anon_sym_RBRACE] = ACTIONS(12781),
    [anon_sym_RPAREN] = ACTIONS(12781),
    [anon_sym_DOT] = ACTIONS(12783),
    [anon_sym_COMMA] = ACTIONS(12781),
    [anon_sym_PIPE] = ACTIONS(12783),
    [anon_sym_SEMI] = ACTIONS(12781),
    [anon_sym_STAR_STAR] = ACTIONS(12783),
    [anon_sym_AMP] = ACTIONS(12783),
    [anon_sym_EQ] = ACTIONS(12783),
    [anon_sym_LT] = ACTIONS(12783),
    [anon_sym_if] = ACTIONS(12781),
    [anon_sym_unless] = ACTIONS(12781),
    [anon_sym_while] = ACTIONS(12781),
    [anon_sym_until] = ACTIONS(12781),
    [anon_sym_rescue] = ACTIONS(12781),
    [anon_sym_in] = ACTIONS(12781),
    [anon_sym_do] = ACTIONS(12781),
    [anon_sym_LBRACK] = ACTIONS(12781),
    [anon_sym_RBRACK] = ACTIONS(12781),
    [anon_sym_COLON_COLON2] = ACTIONS(12781),
    [anon_sym_AMP_DOT] = ACTIONS(12781),
    [anon_sym_PLUS_EQ] = ACTIONS(12781),
    [anon_sym_DASH_EQ] = ACTIONS(12781),
    [anon_sym_STAR_EQ] = ACTIONS(12781),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12781),
    [anon_sym_SLASH_EQ] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12781),
    [anon_sym_PIPE_EQ] = ACTIONS(12781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12781),
    [anon_sym_AMP_EQ] = ACTIONS(12781),
    [anon_sym_PERCENT_EQ] = ACTIONS(12781),
    [anon_sym_GT_GT_EQ] = ACTIONS(12781),
    [anon_sym_LT_LT_EQ] = ACTIONS(12781),
    [anon_sym_CARET_EQ] = ACTIONS(12781),
    [anon_sym_QMARK] = ACTIONS(12781),
    [anon_sym_COLON2] = ACTIONS(12783),
    [anon_sym_DOT_DOT] = ACTIONS(12783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12781),
    [anon_sym_and] = ACTIONS(12781),
    [anon_sym_or] = ACTIONS(12781),
    [anon_sym_PIPE_PIPE] = ACTIONS(12783),
    [anon_sym_AMP_AMP] = ACTIONS(12783),
    [anon_sym_LT_LT] = ACTIONS(12783),
    [anon_sym_GT_GT] = ACTIONS(12783),
    [anon_sym_EQ_EQ] = ACTIONS(12783),
    [anon_sym_BANG_EQ] = ACTIONS(12781),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12781),
    [anon_sym_LT_EQ_GT] = ACTIONS(12781),
    [anon_sym_EQ_TILDE] = ACTIONS(12781),
    [anon_sym_BANG_TILDE] = ACTIONS(12781),
    [anon_sym_LT_EQ] = ACTIONS(12783),
    [anon_sym_GT] = ACTIONS(12783),
    [anon_sym_GT_EQ] = ACTIONS(12781),
    [anon_sym_CARET] = ACTIONS(12783),
    [anon_sym_PLUS] = ACTIONS(12783),
    [anon_sym_SLASH] = ACTIONS(12783),
    [anon_sym_PERCENT] = ACTIONS(12783),
    [sym_comment] = ACTIONS(87),
  },
  [10929] = {
    [sym__heredoc_body_start] = ACTIONS(13093),
    [sym__binary_minus] = ACTIONS(13093),
    [sym__binary_star] = ACTIONS(13093),
    [anon_sym_LBRACE] = ACTIONS(13093),
    [anon_sym_RBRACE] = ACTIONS(13093),
    [anon_sym_RPAREN] = ACTIONS(13093),
    [anon_sym_DOT] = ACTIONS(13095),
    [anon_sym_COMMA] = ACTIONS(13093),
    [anon_sym_PIPE] = ACTIONS(13095),
    [anon_sym_SEMI] = ACTIONS(13093),
    [anon_sym_STAR_STAR] = ACTIONS(13095),
    [anon_sym_AMP] = ACTIONS(13095),
    [anon_sym_EQ] = ACTIONS(13095),
    [anon_sym_LT] = ACTIONS(13095),
    [anon_sym_if] = ACTIONS(13093),
    [anon_sym_unless] = ACTIONS(13093),
    [anon_sym_while] = ACTIONS(13093),
    [anon_sym_until] = ACTIONS(13093),
    [anon_sym_rescue] = ACTIONS(13093),
    [anon_sym_in] = ACTIONS(13093),
    [anon_sym_do] = ACTIONS(13093),
    [anon_sym_LBRACK] = ACTIONS(13093),
    [anon_sym_RBRACK] = ACTIONS(13093),
    [anon_sym_COLON_COLON2] = ACTIONS(13093),
    [anon_sym_AMP_DOT] = ACTIONS(13093),
    [anon_sym_PLUS_EQ] = ACTIONS(13093),
    [anon_sym_DASH_EQ] = ACTIONS(13093),
    [anon_sym_STAR_EQ] = ACTIONS(13093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13093),
    [anon_sym_SLASH_EQ] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13093),
    [anon_sym_PIPE_EQ] = ACTIONS(13093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13093),
    [anon_sym_AMP_EQ] = ACTIONS(13093),
    [anon_sym_PERCENT_EQ] = ACTIONS(13093),
    [anon_sym_GT_GT_EQ] = ACTIONS(13093),
    [anon_sym_LT_LT_EQ] = ACTIONS(13093),
    [anon_sym_CARET_EQ] = ACTIONS(13093),
    [anon_sym_QMARK] = ACTIONS(13093),
    [anon_sym_COLON2] = ACTIONS(13095),
    [anon_sym_DOT_DOT] = ACTIONS(13095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13093),
    [anon_sym_and] = ACTIONS(13093),
    [anon_sym_or] = ACTIONS(13093),
    [anon_sym_PIPE_PIPE] = ACTIONS(13095),
    [anon_sym_AMP_AMP] = ACTIONS(13095),
    [anon_sym_LT_LT] = ACTIONS(13095),
    [anon_sym_GT_GT] = ACTIONS(13095),
    [anon_sym_EQ_EQ] = ACTIONS(13095),
    [anon_sym_BANG_EQ] = ACTIONS(13093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13093),
    [anon_sym_LT_EQ_GT] = ACTIONS(13093),
    [anon_sym_EQ_TILDE] = ACTIONS(13093),
    [anon_sym_BANG_TILDE] = ACTIONS(13093),
    [anon_sym_LT_EQ] = ACTIONS(13095),
    [anon_sym_GT] = ACTIONS(13095),
    [anon_sym_GT_EQ] = ACTIONS(13093),
    [anon_sym_CARET] = ACTIONS(13095),
    [anon_sym_PLUS] = ACTIONS(13095),
    [anon_sym_SLASH] = ACTIONS(13095),
    [anon_sym_PERCENT] = ACTIONS(13095),
    [sym_comment] = ACTIONS(87),
  },
  [10930] = {
    [sym__line_break] = ACTIONS(14146),
    [sym__heredoc_body_start] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14146),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_SEMI] = ACTIONS(14146),
    [anon_sym_then] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [sym_comment] = ACTIONS(87),
  },
  [10931] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12254),
    [sym__binary_star] = ACTIONS(12256),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(12258),
    [anon_sym_STAR_STAR] = ACTIONS(12260),
    [anon_sym_AMP] = ACTIONS(12262),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(12264),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12266),
    [anon_sym_DOT_DOT] = ACTIONS(12268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12270),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12272),
    [anon_sym_AMP_AMP] = ACTIONS(12272),
    [anon_sym_LT_LT] = ACTIONS(12274),
    [anon_sym_GT_GT] = ACTIONS(12274),
    [anon_sym_EQ_EQ] = ACTIONS(12272),
    [anon_sym_BANG_EQ] = ACTIONS(12276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12276),
    [anon_sym_LT_EQ_GT] = ACTIONS(12276),
    [anon_sym_EQ_TILDE] = ACTIONS(12276),
    [anon_sym_BANG_TILDE] = ACTIONS(12276),
    [anon_sym_LT_EQ] = ACTIONS(12264),
    [anon_sym_GT] = ACTIONS(12264),
    [anon_sym_GT_EQ] = ACTIONS(12278),
    [anon_sym_CARET] = ACTIONS(12258),
    [anon_sym_PLUS] = ACTIONS(12280),
    [anon_sym_SLASH] = ACTIONS(12260),
    [anon_sym_PERCENT] = ACTIONS(12260),
    [sym_comment] = ACTIONS(87),
  },
  [10932] = {
    [aux_sym_exceptions_repeat1] = STATE(10932),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14827),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10933] = {
    [sym__heredoc_body_start] = ACTIONS(13660),
    [sym__binary_minus] = ACTIONS(13660),
    [sym__binary_star] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_RPAREN] = ACTIONS(13660),
    [anon_sym_DOT] = ACTIONS(13662),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_PIPE] = ACTIONS(13662),
    [anon_sym_STAR_STAR] = ACTIONS(13660),
    [anon_sym_AMP] = ACTIONS(13662),
    [anon_sym_EQ] = ACTIONS(13662),
    [anon_sym_LT] = ACTIONS(13662),
    [anon_sym_do] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_COLON_COLON2] = ACTIONS(13660),
    [anon_sym_AMP_DOT] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_DOT_DOT] = ACTIONS(13662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_and] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE] = ACTIONS(13660),
    [anon_sym_AMP_AMP] = ACTIONS(13660),
    [anon_sym_LT_LT] = ACTIONS(13660),
    [anon_sym_GT_GT] = ACTIONS(13660),
    [anon_sym_EQ_EQ] = ACTIONS(13662),
    [anon_sym_BANG_EQ] = ACTIONS(13660),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13660),
    [anon_sym_LT_EQ_GT] = ACTIONS(13660),
    [anon_sym_EQ_TILDE] = ACTIONS(13660),
    [anon_sym_BANG_TILDE] = ACTIONS(13660),
    [anon_sym_LT_EQ] = ACTIONS(13662),
    [anon_sym_GT] = ACTIONS(13662),
    [anon_sym_GT_EQ] = ACTIONS(13660),
    [anon_sym_CARET] = ACTIONS(13660),
    [anon_sym_PLUS] = ACTIONS(13660),
    [anon_sym_SLASH] = ACTIONS(13660),
    [anon_sym_PERCENT] = ACTIONS(13660),
    [sym_comment] = ACTIONS(87),
  },
  [10934] = {
    [sym__heredoc_body_start] = ACTIONS(14146),
    [sym__binary_minus] = ACTIONS(14146),
    [sym__binary_star] = ACTIONS(14146),
    [anon_sym_LBRACE] = ACTIONS(14146),
    [anon_sym_RPAREN] = ACTIONS(14146),
    [anon_sym_DOT] = ACTIONS(14148),
    [anon_sym_COMMA] = ACTIONS(14146),
    [anon_sym_PIPE] = ACTIONS(14148),
    [anon_sym_STAR_STAR] = ACTIONS(14146),
    [anon_sym_AMP] = ACTIONS(14148),
    [anon_sym_EQ] = ACTIONS(14148),
    [anon_sym_LT] = ACTIONS(14148),
    [anon_sym_do] = ACTIONS(14146),
    [anon_sym_LBRACK] = ACTIONS(14146),
    [anon_sym_COLON_COLON2] = ACTIONS(14146),
    [anon_sym_AMP_DOT] = ACTIONS(14146),
    [anon_sym_QMARK] = ACTIONS(14146),
    [anon_sym_DOT_DOT] = ACTIONS(14148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14146),
    [anon_sym_and] = ACTIONS(14146),
    [anon_sym_or] = ACTIONS(14146),
    [anon_sym_PIPE_PIPE] = ACTIONS(14146),
    [anon_sym_AMP_AMP] = ACTIONS(14146),
    [anon_sym_LT_LT] = ACTIONS(14146),
    [anon_sym_GT_GT] = ACTIONS(14146),
    [anon_sym_EQ_EQ] = ACTIONS(14148),
    [anon_sym_BANG_EQ] = ACTIONS(14146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14146),
    [anon_sym_LT_EQ_GT] = ACTIONS(14146),
    [anon_sym_EQ_TILDE] = ACTIONS(14146),
    [anon_sym_BANG_TILDE] = ACTIONS(14146),
    [anon_sym_LT_EQ] = ACTIONS(14148),
    [anon_sym_GT] = ACTIONS(14148),
    [anon_sym_GT_EQ] = ACTIONS(14146),
    [anon_sym_CARET] = ACTIONS(14146),
    [anon_sym_PLUS] = ACTIONS(14146),
    [anon_sym_SLASH] = ACTIONS(14146),
    [anon_sym_PERCENT] = ACTIONS(14146),
    [sym_comment] = ACTIONS(87),
  },
  [10935] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12430),
    [sym__binary_star] = ACTIONS(12432),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(12434),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(12432),
    [anon_sym_AMP] = ACTIONS(12436),
    [anon_sym_LT] = ACTIONS(12438),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_elsif] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12440),
    [anon_sym_DOT_DOT] = ACTIONS(12442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12444),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12446),
    [anon_sym_AMP_AMP] = ACTIONS(12446),
    [anon_sym_LT_LT] = ACTIONS(12448),
    [anon_sym_GT_GT] = ACTIONS(12448),
    [anon_sym_EQ_EQ] = ACTIONS(12450),
    [anon_sym_BANG_EQ] = ACTIONS(12446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12446),
    [anon_sym_LT_EQ_GT] = ACTIONS(12446),
    [anon_sym_EQ_TILDE] = ACTIONS(12446),
    [anon_sym_BANG_TILDE] = ACTIONS(12446),
    [anon_sym_LT_EQ] = ACTIONS(12438),
    [anon_sym_GT] = ACTIONS(12438),
    [anon_sym_GT_EQ] = ACTIONS(12452),
    [anon_sym_CARET] = ACTIONS(12454),
    [anon_sym_PLUS] = ACTIONS(12430),
    [anon_sym_SLASH] = ACTIONS(12432),
    [anon_sym_PERCENT] = ACTIONS(12432),
    [sym_comment] = ACTIONS(87),
  },
  [10936] = {
    [aux_sym_exceptions_repeat1] = STATE(10936),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14830),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_elsif] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10937] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12491),
    [sym__binary_star] = ACTIONS(12493),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(12495),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(12501),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_elsif] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12505),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12507),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12509),
    [anon_sym_AMP_AMP] = ACTIONS(12509),
    [anon_sym_LT_LT] = ACTIONS(12511),
    [anon_sym_GT_GT] = ACTIONS(12511),
    [anon_sym_EQ_EQ] = ACTIONS(12509),
    [anon_sym_BANG_EQ] = ACTIONS(12513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12513),
    [anon_sym_LT_EQ_GT] = ACTIONS(12513),
    [anon_sym_EQ_TILDE] = ACTIONS(12513),
    [anon_sym_BANG_TILDE] = ACTIONS(12513),
    [anon_sym_LT_EQ] = ACTIONS(12501),
    [anon_sym_GT] = ACTIONS(12501),
    [anon_sym_GT_EQ] = ACTIONS(12515),
    [anon_sym_CARET] = ACTIONS(12495),
    [anon_sym_PLUS] = ACTIONS(12517),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10938] = {
    [aux_sym_exceptions_repeat1] = STATE(10938),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14833),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_elsif] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10939] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12527),
    [sym__binary_star] = ACTIONS(12529),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(12531),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(12529),
    [anon_sym_AMP] = ACTIONS(12533),
    [anon_sym_LT] = ACTIONS(12535),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_elsif] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12537),
    [anon_sym_DOT_DOT] = ACTIONS(12539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12541),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12543),
    [anon_sym_AMP_AMP] = ACTIONS(12543),
    [anon_sym_LT_LT] = ACTIONS(12545),
    [anon_sym_GT_GT] = ACTIONS(12545),
    [anon_sym_EQ_EQ] = ACTIONS(12547),
    [anon_sym_BANG_EQ] = ACTIONS(12543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12543),
    [anon_sym_LT_EQ_GT] = ACTIONS(12543),
    [anon_sym_EQ_TILDE] = ACTIONS(12543),
    [anon_sym_BANG_TILDE] = ACTIONS(12543),
    [anon_sym_LT_EQ] = ACTIONS(12535),
    [anon_sym_GT] = ACTIONS(12535),
    [anon_sym_GT_EQ] = ACTIONS(12549),
    [anon_sym_CARET] = ACTIONS(12551),
    [anon_sym_PLUS] = ACTIONS(12527),
    [anon_sym_SLASH] = ACTIONS(12529),
    [anon_sym_PERCENT] = ACTIONS(12529),
    [sym_comment] = ACTIONS(87),
  },
  [10940] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12572),
    [sym__binary_star] = ACTIONS(12574),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(12576),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(12574),
    [anon_sym_AMP] = ACTIONS(12578),
    [anon_sym_LT] = ACTIONS(12580),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12582),
    [anon_sym_DOT_DOT] = ACTIONS(12584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12586),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12588),
    [anon_sym_AMP_AMP] = ACTIONS(12588),
    [anon_sym_LT_LT] = ACTIONS(12590),
    [anon_sym_GT_GT] = ACTIONS(12590),
    [anon_sym_EQ_EQ] = ACTIONS(12592),
    [anon_sym_BANG_EQ] = ACTIONS(12588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12588),
    [anon_sym_LT_EQ_GT] = ACTIONS(12588),
    [anon_sym_EQ_TILDE] = ACTIONS(12588),
    [anon_sym_BANG_TILDE] = ACTIONS(12588),
    [anon_sym_LT_EQ] = ACTIONS(12580),
    [anon_sym_GT] = ACTIONS(12580),
    [anon_sym_GT_EQ] = ACTIONS(12594),
    [anon_sym_CARET] = ACTIONS(12596),
    [anon_sym_PLUS] = ACTIONS(12572),
    [anon_sym_SLASH] = ACTIONS(12574),
    [anon_sym_PERCENT] = ACTIONS(12574),
    [sym_comment] = ACTIONS(87),
  },
  [10941] = {
    [aux_sym_exceptions_repeat1] = STATE(10941),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14836),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10942] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12631),
    [sym__binary_star] = ACTIONS(12633),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(12635),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(12637),
    [anon_sym_AMP] = ACTIONS(12639),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(12641),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12643),
    [anon_sym_DOT_DOT] = ACTIONS(12645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12647),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12649),
    [anon_sym_AMP_AMP] = ACTIONS(12649),
    [anon_sym_LT_LT] = ACTIONS(12651),
    [anon_sym_GT_GT] = ACTIONS(12651),
    [anon_sym_EQ_EQ] = ACTIONS(12649),
    [anon_sym_BANG_EQ] = ACTIONS(12653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12653),
    [anon_sym_LT_EQ_GT] = ACTIONS(12653),
    [anon_sym_EQ_TILDE] = ACTIONS(12653),
    [anon_sym_BANG_TILDE] = ACTIONS(12653),
    [anon_sym_LT_EQ] = ACTIONS(12641),
    [anon_sym_GT] = ACTIONS(12641),
    [anon_sym_GT_EQ] = ACTIONS(12655),
    [anon_sym_CARET] = ACTIONS(12635),
    [anon_sym_PLUS] = ACTIONS(12657),
    [anon_sym_SLASH] = ACTIONS(12637),
    [anon_sym_PERCENT] = ACTIONS(12637),
    [sym_comment] = ACTIONS(87),
  },
  [10943] = {
    [aux_sym_exceptions_repeat1] = STATE(10943),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14839),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10944] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12667),
    [sym__binary_star] = ACTIONS(12669),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(12671),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(12669),
    [anon_sym_AMP] = ACTIONS(12673),
    [anon_sym_LT] = ACTIONS(12675),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12677),
    [anon_sym_DOT_DOT] = ACTIONS(12679),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12681),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12683),
    [anon_sym_AMP_AMP] = ACTIONS(12683),
    [anon_sym_LT_LT] = ACTIONS(12685),
    [anon_sym_GT_GT] = ACTIONS(12685),
    [anon_sym_EQ_EQ] = ACTIONS(12687),
    [anon_sym_BANG_EQ] = ACTIONS(12683),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12683),
    [anon_sym_LT_EQ_GT] = ACTIONS(12683),
    [anon_sym_EQ_TILDE] = ACTIONS(12683),
    [anon_sym_BANG_TILDE] = ACTIONS(12683),
    [anon_sym_LT_EQ] = ACTIONS(12675),
    [anon_sym_GT] = ACTIONS(12675),
    [anon_sym_GT_EQ] = ACTIONS(12689),
    [anon_sym_CARET] = ACTIONS(12691),
    [anon_sym_PLUS] = ACTIONS(12667),
    [anon_sym_SLASH] = ACTIONS(12669),
    [anon_sym_PERCENT] = ACTIONS(12669),
    [sym_comment] = ACTIONS(87),
  },
  [10945] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12724),
    [sym__binary_star] = ACTIONS(12726),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(12728),
    [anon_sym_STAR_STAR] = ACTIONS(12730),
    [anon_sym_AMP] = ACTIONS(12732),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(12734),
    [anon_sym_in] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12736),
    [anon_sym_DOT_DOT] = ACTIONS(12738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12740),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12742),
    [anon_sym_AMP_AMP] = ACTIONS(12742),
    [anon_sym_LT_LT] = ACTIONS(12744),
    [anon_sym_GT_GT] = ACTIONS(12744),
    [anon_sym_EQ_EQ] = ACTIONS(12742),
    [anon_sym_BANG_EQ] = ACTIONS(12746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12746),
    [anon_sym_LT_EQ_GT] = ACTIONS(12746),
    [anon_sym_EQ_TILDE] = ACTIONS(12746),
    [anon_sym_BANG_TILDE] = ACTIONS(12746),
    [anon_sym_LT_EQ] = ACTIONS(12734),
    [anon_sym_GT] = ACTIONS(12734),
    [anon_sym_GT_EQ] = ACTIONS(12748),
    [anon_sym_CARET] = ACTIONS(12728),
    [anon_sym_PLUS] = ACTIONS(12750),
    [anon_sym_SLASH] = ACTIONS(12730),
    [anon_sym_PERCENT] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [10946] = {
    [aux_sym_exceptions_repeat1] = STATE(10946),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14842),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [10947] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12790),
    [sym__binary_star] = ACTIONS(12792),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(12794),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(12792),
    [anon_sym_AMP] = ACTIONS(12796),
    [anon_sym_LT] = ACTIONS(12798),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12800),
    [anon_sym_DOT_DOT] = ACTIONS(12802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12804),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12806),
    [anon_sym_AMP_AMP] = ACTIONS(12806),
    [anon_sym_LT_LT] = ACTIONS(12808),
    [anon_sym_GT_GT] = ACTIONS(12808),
    [anon_sym_EQ_EQ] = ACTIONS(12810),
    [anon_sym_BANG_EQ] = ACTIONS(12806),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12806),
    [anon_sym_LT_EQ_GT] = ACTIONS(12806),
    [anon_sym_EQ_TILDE] = ACTIONS(12806),
    [anon_sym_BANG_TILDE] = ACTIONS(12806),
    [anon_sym_LT_EQ] = ACTIONS(12798),
    [anon_sym_GT] = ACTIONS(12798),
    [anon_sym_GT_EQ] = ACTIONS(12812),
    [anon_sym_CARET] = ACTIONS(12814),
    [anon_sym_PLUS] = ACTIONS(12790),
    [anon_sym_SLASH] = ACTIONS(12792),
    [anon_sym_PERCENT] = ACTIONS(12792),
    [sym_comment] = ACTIONS(87),
  },
  [10948] = {
    [aux_sym_exceptions_repeat1] = STATE(10948),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14845),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [10949] = {
    [sym_heredoc_body] = STATE(11066),
    [aux_sym_call_repeat1] = STATE(11066),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(4246),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_when] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10950] = {
    [sym_heredoc_body] = STATE(11067),
    [aux_sym_call_repeat1] = STATE(11067),
    [aux_sym_argument_list_repeat1] = STATE(10731),
    [sym__line_break] = ACTIONS(4246),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(4246),
    [sym__binary_star] = ACTIONS(4246),
    [anon_sym_DOT] = ACTIONS(4248),
    [anon_sym_COMMA] = ACTIONS(13780),
    [anon_sym_PIPE] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4246),
    [anon_sym_STAR_STAR] = ACTIONS(4246),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(4248),
    [anon_sym_end] = ACTIONS(4246),
    [anon_sym_if] = ACTIONS(4246),
    [anon_sym_unless] = ACTIONS(4246),
    [anon_sym_while] = ACTIONS(4246),
    [anon_sym_until] = ACTIONS(4246),
    [anon_sym_rescue] = ACTIONS(4246),
    [anon_sym_when] = ACTIONS(4246),
    [anon_sym_else] = ACTIONS(4246),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_COLON_COLON2] = ACTIONS(4246),
    [anon_sym_AMP_DOT] = ACTIONS(4246),
    [anon_sym_QMARK] = ACTIONS(4246),
    [anon_sym_DOT_DOT] = ACTIONS(4248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4246),
    [anon_sym_and] = ACTIONS(4246),
    [anon_sym_or] = ACTIONS(4246),
    [anon_sym_PIPE_PIPE] = ACTIONS(4246),
    [anon_sym_AMP_AMP] = ACTIONS(4246),
    [anon_sym_LT_LT] = ACTIONS(4246),
    [anon_sym_GT_GT] = ACTIONS(4246),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_BANG_EQ] = ACTIONS(4246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4246),
    [anon_sym_LT_EQ_GT] = ACTIONS(4246),
    [anon_sym_EQ_TILDE] = ACTIONS(4246),
    [anon_sym_BANG_TILDE] = ACTIONS(4246),
    [anon_sym_LT_EQ] = ACTIONS(4248),
    [anon_sym_GT] = ACTIONS(4248),
    [anon_sym_GT_EQ] = ACTIONS(4246),
    [anon_sym_CARET] = ACTIONS(4246),
    [anon_sym_PLUS] = ACTIONS(4246),
    [anon_sym_SLASH] = ACTIONS(4246),
    [anon_sym_PERCENT] = ACTIONS(4246),
    [sym_comment] = ACTIONS(87),
  },
  [10951] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10952] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [10953] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10954] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10955] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10956] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14848),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10957] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_when] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10958] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(14400),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10959] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10960] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10961] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_when] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(14400),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10962] = {
    [aux_sym_exceptions_repeat1] = STATE(11070),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [10963] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_when] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(14400),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [10964] = {
    [sym_string] = STATE(10964),
    [aux_sym_chained_string_repeat1] = STATE(10964),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(6078),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_when] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [10965] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_when] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10966] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_when] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [10967] = {
    [sym_heredoc_body] = STATE(10967),
    [aux_sym_call_repeat1] = STATE(10967),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_when] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [10968] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10261),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym__argument] = STATE(4924),
    [sym_splat_argument] = STATE(4924),
    [sym_hash_splat_argument] = STATE(4924),
    [sym_block_argument] = STATE(4924),
    [sym_assignment] = STATE(10261),
    [sym_operator_assignment] = STATE(10261),
    [sym_conditional] = STATE(10261),
    [sym_range] = STATE(10261),
    [sym_binary] = STATE(10261),
    [sym_unary] = STATE(10261),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10264),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_pair] = STATE(4924),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__block_ampersand] = ACTIONS(13736),
    [sym__splat_star] = ACTIONS(13738),
    [sym__unary_minus] = ACTIONS(12830),
    [sym__identifier_hash_key] = ACTIONS(13740),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14753),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(13742),
    [sym_identifier] = ACTIONS(13742),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10969] = {
    [sym_heredoc_body] = STATE(10967),
    [aux_sym_call_repeat1] = STATE(10967),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_when] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [10970] = {
    [aux_sym_argument_list_repeat1] = STATE(10970),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14850),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_when] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [10971] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(11071),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_assignment] = STATE(11071),
    [sym_operator_assignment] = STATE(11071),
    [sym_conditional] = STATE(11071),
    [sym_range] = STATE(11071),
    [sym_binary] = STATE(11071),
    [sym_unary] = STATE(11071),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10972] = {
    [sym__line_break] = ACTIONS(6557),
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(6557),
    [anon_sym_if] = ACTIONS(6557),
    [anon_sym_unless] = ACTIONS(6557),
    [anon_sym_while] = ACTIONS(6557),
    [anon_sym_until] = ACTIONS(6557),
    [anon_sym_rescue] = ACTIONS(6557),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_when] = ACTIONS(6557),
    [anon_sym_else] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10973] = {
    [sym__line_break] = ACTIONS(6759),
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(6759),
    [anon_sym_if] = ACTIONS(6759),
    [anon_sym_unless] = ACTIONS(6759),
    [anon_sym_while] = ACTIONS(6759),
    [anon_sym_until] = ACTIONS(6759),
    [anon_sym_rescue] = ACTIONS(6759),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_when] = ACTIONS(6759),
    [anon_sym_else] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [10974] = {
    [sym_heredoc_body] = STATE(10974),
    [aux_sym_call_repeat1] = STATE(10974),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(10588),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_when] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [10975] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym__argument] = STATE(7294),
    [sym_splat_argument] = STATE(7294),
    [sym_hash_splat_argument] = STATE(7294),
    [sym_block_argument] = STATE(7294),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10285),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_pair] = STATE(7294),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__block_ampersand] = ACTIONS(13772),
    [sym__splat_star] = ACTIONS(13774),
    [sym__unary_minus] = ACTIONS(12904),
    [sym__identifier_hash_key] = ACTIONS(13776),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14757),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(13778),
    [sym_identifier] = ACTIONS(13778),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10976] = {
    [sym_heredoc_body] = STATE(10974),
    [aux_sym_call_repeat1] = STATE(10974),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(4236),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_when] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [10977] = {
    [aux_sym_argument_list_repeat1] = STATE(10977),
    [sym__line_break] = ACTIONS(7657),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14853),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_end] = ACTIONS(7657),
    [anon_sym_if] = ACTIONS(7657),
    [anon_sym_unless] = ACTIONS(7657),
    [anon_sym_while] = ACTIONS(7657),
    [anon_sym_until] = ACTIONS(7657),
    [anon_sym_rescue] = ACTIONS(7657),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_when] = ACTIONS(7657),
    [anon_sym_else] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [10978] = {
    [sym_method] = STATE(214),
    [sym_singleton_method] = STATE(214),
    [sym_class] = STATE(214),
    [sym_singleton_class] = STATE(214),
    [sym_module] = STATE(214),
    [sym_return] = STATE(214),
    [sym_yield] = STATE(214),
    [sym_break] = STATE(214),
    [sym_next] = STATE(214),
    [sym_while] = STATE(214),
    [sym_until] = STATE(214),
    [sym_for] = STATE(214),
    [sym_case] = STATE(214),
    [sym_if] = STATE(214),
    [sym_unless] = STATE(214),
    [sym_begin] = STATE(214),
    [sym__arg] = STATE(10732),
    [sym__primary] = STATE(214),
    [sym_parenthesized_statements] = STATE(214),
    [sym_element_reference] = STATE(9380),
    [sym_scope_resolution] = STATE(9376),
    [sym_call] = STATE(9376),
    [sym_method_call] = STATE(9380),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(10732),
    [sym_operator_assignment] = STATE(10732),
    [sym_conditional] = STATE(10732),
    [sym_range] = STATE(10732),
    [sym_binary] = STATE(10732),
    [sym_unary] = STATE(10732),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(9379),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9380),
    [sym__variable] = STATE(9376),
    [sym_rational] = STATE(214),
    [sym_true] = STATE(9380),
    [sym_false] = STATE(9380),
    [sym_nil] = STATE(9380),
    [sym_chained_string] = STATE(214),
    [sym_string] = STATE(10253),
    [sym_subshell] = STATE(214),
    [sym_string_array] = STATE(214),
    [sym_symbol_array] = STATE(214),
    [sym_symbol] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_array] = STATE(214),
    [sym_hash] = STATE(214),
    [sym_lambda] = STATE(214),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(365),
    [sym__splat_star] = ACTIONS(13738),
    [sym__unary_minus] = ACTIONS(12830),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(12834),
    [anon_sym_yield] = ACTIONS(12836),
    [anon_sym_break] = ACTIONS(12838),
    [anon_sym_next] = ACTIONS(12840),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13732),
    [anon_sym_defined_QMARK] = ACTIONS(12842),
    [anon_sym_not] = ACTIONS(12844),
    [anon_sym_BANG] = ACTIONS(12848),
    [anon_sym_TILDE] = ACTIONS(12848),
    [sym_constant] = ACTIONS(12854),
    [sym_identifier] = ACTIONS(12854),
    [sym_instance_variable] = ACTIONS(12852),
    [sym_class_variable] = ACTIONS(12852),
    [sym_global_variable] = ACTIONS(12852),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(12854),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12854),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10979] = {
    [aux_sym_exceptions_repeat1] = STATE(11072),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14856),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_when] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [10980] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12872),
    [sym__binary_star] = ACTIONS(12874),
    [anon_sym_PIPE] = ACTIONS(12876),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(12874),
    [anon_sym_AMP] = ACTIONS(12878),
    [anon_sym_LT] = ACTIONS(12880),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_when] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12882),
    [anon_sym_DOT_DOT] = ACTIONS(12884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12886),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12890),
    [anon_sym_AMP_AMP] = ACTIONS(12890),
    [anon_sym_LT_LT] = ACTIONS(12892),
    [anon_sym_GT_GT] = ACTIONS(12892),
    [anon_sym_EQ_EQ] = ACTIONS(12894),
    [anon_sym_BANG_EQ] = ACTIONS(12890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12890),
    [anon_sym_LT_EQ_GT] = ACTIONS(12890),
    [anon_sym_EQ_TILDE] = ACTIONS(12890),
    [anon_sym_BANG_TILDE] = ACTIONS(12890),
    [anon_sym_LT_EQ] = ACTIONS(12880),
    [anon_sym_GT] = ACTIONS(12880),
    [anon_sym_GT_EQ] = ACTIONS(12896),
    [anon_sym_CARET] = ACTIONS(12898),
    [anon_sym_PLUS] = ACTIONS(12872),
    [anon_sym_SLASH] = ACTIONS(12874),
    [anon_sym_PERCENT] = ACTIONS(12874),
    [sym_comment] = ACTIONS(87),
  },
  [10981] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10982] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [10983] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10984] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10985] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10986] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14858),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [10987] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_when] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10988] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(14457),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10989] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10990] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10991] = {
    [sym__line_break] = ACTIONS(4970),
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_unless] = ACTIONS(4970),
    [anon_sym_while] = ACTIONS(4970),
    [anon_sym_until] = ACTIONS(4970),
    [anon_sym_rescue] = ACTIONS(4970),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_when] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(14457),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10992] = {
    [aux_sym_exceptions_repeat1] = STATE(11075),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [10993] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_when] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(14457),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [10994] = {
    [sym_string] = STATE(10994),
    [aux_sym_chained_string_repeat1] = STATE(10994),
    [sym__line_break] = ACTIONS(6076),
    [sym__string_start] = ACTIONS(11899),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_end] = ACTIONS(6076),
    [anon_sym_if] = ACTIONS(6076),
    [anon_sym_unless] = ACTIONS(6076),
    [anon_sym_while] = ACTIONS(6076),
    [anon_sym_until] = ACTIONS(6076),
    [anon_sym_rescue] = ACTIONS(6076),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_when] = ACTIONS(6076),
    [anon_sym_else] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [10995] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(11076),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_assignment] = STATE(11076),
    [sym_operator_assignment] = STATE(11076),
    [sym_conditional] = STATE(11076),
    [sym_range] = STATE(11076),
    [sym_binary] = STATE(11076),
    [sym_unary] = STATE(11076),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10996] = {
    [sym_method] = STATE(424),
    [sym_singleton_method] = STATE(424),
    [sym_class] = STATE(424),
    [sym_singleton_class] = STATE(424),
    [sym_module] = STATE(424),
    [sym_return] = STATE(424),
    [sym_yield] = STATE(424),
    [sym_break] = STATE(424),
    [sym_next] = STATE(424),
    [sym_while] = STATE(424),
    [sym_until] = STATE(424),
    [sym_for] = STATE(424),
    [sym_case] = STATE(424),
    [sym_if] = STATE(424),
    [sym_unless] = STATE(424),
    [sym_begin] = STATE(424),
    [sym__arg] = STATE(10770),
    [sym__primary] = STATE(424),
    [sym_parenthesized_statements] = STATE(424),
    [sym_element_reference] = STATE(9419),
    [sym_scope_resolution] = STATE(9415),
    [sym_call] = STATE(9415),
    [sym_method_call] = STATE(9419),
    [sym_splat_argument] = STATE(8555),
    [sym_assignment] = STATE(10770),
    [sym_operator_assignment] = STATE(10770),
    [sym_conditional] = STATE(10770),
    [sym_range] = STATE(10770),
    [sym_binary] = STATE(10770),
    [sym_unary] = STATE(10770),
    [sym__arg_or_splat_arg] = STATE(8555),
    [sym_left_assignment_list] = STATE(9418),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9419),
    [sym__variable] = STATE(9415),
    [sym_rational] = STATE(424),
    [sym_true] = STATE(9419),
    [sym_false] = STATE(9419),
    [sym_nil] = STATE(9419),
    [sym_chained_string] = STATE(424),
    [sym_string] = STATE(10324),
    [sym_subshell] = STATE(424),
    [sym_string_array] = STATE(424),
    [sym_symbol_array] = STATE(424),
    [sym_symbol] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_array] = STATE(424),
    [sym_hash] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym__simple_symbol] = ACTIONS(747),
    [sym__string_start] = ACTIONS(749),
    [sym__symbol_start] = ACTIONS(751),
    [sym__subshell_start] = ACTIONS(753),
    [sym__regex_start] = ACTIONS(755),
    [sym__string_array_start] = ACTIONS(757),
    [sym__symbol_array_start] = ACTIONS(759),
    [sym_heredoc_beginning] = ACTIONS(761),
    [sym__splat_star] = ACTIONS(13774),
    [sym__unary_minus] = ACTIONS(12904),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_def] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(12908),
    [anon_sym_yield] = ACTIONS(12910),
    [anon_sym_break] = ACTIONS(12912),
    [anon_sym_next] = ACTIONS(12914),
    [sym_redo] = ACTIONS(791),
    [sym_retry] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(1905),
    [anon_sym_unless] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_until] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_case] = ACTIONS(797),
    [anon_sym_begin] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(13816),
    [anon_sym_defined_QMARK] = ACTIONS(12916),
    [anon_sym_not] = ACTIONS(12918),
    [anon_sym_BANG] = ACTIONS(12922),
    [anon_sym_TILDE] = ACTIONS(12922),
    [sym_constant] = ACTIONS(12928),
    [sym_identifier] = ACTIONS(12928),
    [sym_instance_variable] = ACTIONS(12926),
    [sym_class_variable] = ACTIONS(12926),
    [sym_global_variable] = ACTIONS(12926),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(815),
    [sym_float] = ACTIONS(791),
    [sym_complex] = ACTIONS(761),
    [sym_super] = ACTIONS(12928),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(12928),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(761),
    [anon_sym_LBRACK2] = ACTIONS(2633),
    [anon_sym_DASH_GT] = ACTIONS(821),
  },
  [10997] = {
    [aux_sym_exceptions_repeat1] = STATE(11077),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14860),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_when] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [10998] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [10999] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [11000] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(14487),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [11001] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [11002] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14485),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(14487),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(14505),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [11003] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14862),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [11004] = {
    [sym__line_break] = ACTIONS(5798),
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(14485),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(14487),
    [anon_sym_LT] = ACTIONS(14489),
    [anon_sym_end] = ACTIONS(5798),
    [anon_sym_if] = ACTIONS(5798),
    [anon_sym_unless] = ACTIONS(5798),
    [anon_sym_while] = ACTIONS(5798),
    [anon_sym_until] = ACTIONS(5798),
    [anon_sym_rescue] = ACTIONS(5798),
    [anon_sym_when] = ACTIONS(5798),
    [anon_sym_else] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(14493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14495),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(14497),
    [anon_sym_AMP_AMP] = ACTIONS(14497),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(14501),
    [anon_sym_BANG_EQ] = ACTIONS(14497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14497),
    [anon_sym_LT_EQ_GT] = ACTIONS(14497),
    [anon_sym_EQ_TILDE] = ACTIONS(14497),
    [anon_sym_BANG_TILDE] = ACTIONS(14497),
    [anon_sym_LT_EQ] = ACTIONS(14489),
    [anon_sym_GT] = ACTIONS(14489),
    [anon_sym_GT_EQ] = ACTIONS(14503),
    [anon_sym_CARET] = ACTIONS(14505),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [11005] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14485),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(14487),
    [anon_sym_LT] = ACTIONS(14489),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_DOT_DOT] = ACTIONS(14493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14495),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(14497),
    [anon_sym_AMP_AMP] = ACTIONS(14497),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(14501),
    [anon_sym_BANG_EQ] = ACTIONS(14497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14497),
    [anon_sym_LT_EQ_GT] = ACTIONS(14497),
    [anon_sym_EQ_TILDE] = ACTIONS(14497),
    [anon_sym_BANG_TILDE] = ACTIONS(14497),
    [anon_sym_LT_EQ] = ACTIONS(14489),
    [anon_sym_GT] = ACTIONS(14489),
    [anon_sym_GT_EQ] = ACTIONS(14503),
    [anon_sym_CARET] = ACTIONS(14505),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [11006] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14485),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(14487),
    [anon_sym_LT] = ACTIONS(14489),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(14501),
    [anon_sym_BANG_EQ] = ACTIONS(14497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14497),
    [anon_sym_LT_EQ_GT] = ACTIONS(14497),
    [anon_sym_EQ_TILDE] = ACTIONS(14497),
    [anon_sym_BANG_TILDE] = ACTIONS(14497),
    [anon_sym_LT_EQ] = ACTIONS(14489),
    [anon_sym_GT] = ACTIONS(14489),
    [anon_sym_GT_EQ] = ACTIONS(14503),
    [anon_sym_CARET] = ACTIONS(14505),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [11007] = {
    [sym__line_break] = ACTIONS(5696),
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_unless] = ACTIONS(5696),
    [anon_sym_while] = ACTIONS(5696),
    [anon_sym_until] = ACTIONS(5696),
    [anon_sym_rescue] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [11008] = {
    [aux_sym_exceptions_repeat1] = STATE(11008),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(14864),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_when] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [11009] = {
    [aux_sym_exceptions_repeat1] = STATE(10788),
    [sym__line_break] = ACTIONS(6060),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_end] = ACTIONS(6060),
    [anon_sym_if] = ACTIONS(6060),
    [anon_sym_unless] = ACTIONS(6060),
    [anon_sym_while] = ACTIONS(6060),
    [anon_sym_until] = ACTIONS(6060),
    [anon_sym_rescue] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_else] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [11010] = {
    [sym__line_break] = ACTIONS(6074),
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(14485),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(14487),
    [anon_sym_LT] = ACTIONS(14489),
    [anon_sym_end] = ACTIONS(6074),
    [anon_sym_if] = ACTIONS(6074),
    [anon_sym_unless] = ACTIONS(6074),
    [anon_sym_while] = ACTIONS(6074),
    [anon_sym_until] = ACTIONS(6074),
    [anon_sym_rescue] = ACTIONS(6074),
    [anon_sym_when] = ACTIONS(6074),
    [anon_sym_else] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_DOT_DOT] = ACTIONS(14493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14495),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14497),
    [anon_sym_AMP_AMP] = ACTIONS(14497),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(14501),
    [anon_sym_BANG_EQ] = ACTIONS(14497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14497),
    [anon_sym_LT_EQ_GT] = ACTIONS(14497),
    [anon_sym_EQ_TILDE] = ACTIONS(14497),
    [anon_sym_BANG_TILDE] = ACTIONS(14497),
    [anon_sym_LT_EQ] = ACTIONS(14489),
    [anon_sym_GT] = ACTIONS(14489),
    [anon_sym_GT_EQ] = ACTIONS(14503),
    [anon_sym_CARET] = ACTIONS(14505),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [11011] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(12943),
    [sym__binary_star] = ACTIONS(12945),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(12947),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(12949),
    [anon_sym_AMP] = ACTIONS(12951),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(12953),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(12955),
    [anon_sym_DOT_DOT] = ACTIONS(12957),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12959),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(12961),
    [anon_sym_AMP_AMP] = ACTIONS(12961),
    [anon_sym_LT_LT] = ACTIONS(12963),
    [anon_sym_GT_GT] = ACTIONS(12963),
    [anon_sym_EQ_EQ] = ACTIONS(12961),
    [anon_sym_BANG_EQ] = ACTIONS(12965),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12965),
    [anon_sym_LT_EQ_GT] = ACTIONS(12965),
    [anon_sym_EQ_TILDE] = ACTIONS(12965),
    [anon_sym_BANG_TILDE] = ACTIONS(12965),
    [anon_sym_LT_EQ] = ACTIONS(12953),
    [anon_sym_GT] = ACTIONS(12953),
    [anon_sym_GT_EQ] = ACTIONS(12967),
    [anon_sym_CARET] = ACTIONS(12947),
    [anon_sym_PLUS] = ACTIONS(12969),
    [anon_sym_SLASH] = ACTIONS(12949),
    [anon_sym_PERCENT] = ACTIONS(12949),
    [sym_comment] = ACTIONS(87),
  },
  [11012] = {
    [aux_sym_exceptions_repeat1] = STATE(11012),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14867),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [11013] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(13008),
    [sym__binary_star] = ACTIONS(13010),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(13012),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(13010),
    [anon_sym_AMP] = ACTIONS(13014),
    [anon_sym_LT] = ACTIONS(13016),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_then] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(13018),
    [anon_sym_DOT_DOT] = ACTIONS(13020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13022),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(13026),
    [anon_sym_AMP_AMP] = ACTIONS(13026),
    [anon_sym_LT_LT] = ACTIONS(13028),
    [anon_sym_GT_GT] = ACTIONS(13028),
    [anon_sym_EQ_EQ] = ACTIONS(13030),
    [anon_sym_BANG_EQ] = ACTIONS(13026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13026),
    [anon_sym_LT_EQ_GT] = ACTIONS(13026),
    [anon_sym_EQ_TILDE] = ACTIONS(13026),
    [anon_sym_BANG_TILDE] = ACTIONS(13026),
    [anon_sym_LT_EQ] = ACTIONS(13016),
    [anon_sym_GT] = ACTIONS(13016),
    [anon_sym_GT_EQ] = ACTIONS(13032),
    [anon_sym_CARET] = ACTIONS(13034),
    [anon_sym_PLUS] = ACTIONS(13008),
    [anon_sym_SLASH] = ACTIONS(13010),
    [anon_sym_PERCENT] = ACTIONS(13010),
    [sym_comment] = ACTIONS(87),
  },
  [11014] = {
    [aux_sym_exceptions_repeat1] = STATE(11014),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14870),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_then] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [11015] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11016] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [sym_comment] = ACTIONS(87),
  },
  [11017] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11018] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11019] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11020] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14873),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [11021] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11022] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(14583),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11023] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11024] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11025] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(14583),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11026] = {
    [aux_sym_exceptions_repeat1] = STATE(11081),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6060),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6060),
    [anon_sym_AMP_AMP] = ACTIONS(6060),
    [anon_sym_LT_LT] = ACTIONS(6060),
    [anon_sym_GT_GT] = ACTIONS(6060),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6060),
    [anon_sym_PLUS] = ACTIONS(6060),
    [anon_sym_SLASH] = ACTIONS(6060),
    [anon_sym_PERCENT] = ACTIONS(6060),
    [sym_comment] = ACTIONS(87),
  },
  [11027] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(14583),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11028] = {
    [sym_string] = STATE(11028),
    [aux_sym_chained_string_repeat1] = STATE(11028),
    [sym__string_start] = ACTIONS(9153),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6076),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6076),
    [anon_sym_GT_GT] = ACTIONS(6076),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6076),
    [anon_sym_PLUS] = ACTIONS(6076),
    [anon_sym_SLASH] = ACTIONS(6076),
    [anon_sym_PERCENT] = ACTIONS(6076),
    [sym_comment] = ACTIONS(87),
  },
  [11029] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [11030] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [11031] = {
    [sym_heredoc_body] = STATE(11031),
    [aux_sym_call_repeat1] = STATE(11031),
    [sym__heredoc_body_start] = ACTIONS(10050),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [11032] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10476),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym__argument] = STATE(6752),
    [sym_splat_argument] = STATE(6752),
    [sym_hash_splat_argument] = STATE(6752),
    [sym_block_argument] = STATE(6752),
    [sym_assignment] = STATE(10476),
    [sym_operator_assignment] = STATE(10476),
    [sym_conditional] = STATE(10476),
    [sym_range] = STATE(10476),
    [sym_binary] = STATE(10476),
    [sym_unary] = STATE(10476),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10479),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_pair] = STATE(6752),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__block_ampersand] = ACTIONS(14016),
    [sym__splat_star] = ACTIONS(14018),
    [sym__unary_minus] = ACTIONS(13157),
    [sym__identifier_hash_key] = ACTIONS(14020),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14795),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(14022),
    [sym_identifier] = ACTIONS(14022),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11033] = {
    [sym_heredoc_body] = STATE(11031),
    [aux_sym_call_repeat1] = STATE(11031),
    [sym__heredoc_body_start] = ACTIONS(3264),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [11034] = {
    [aux_sym_argument_list_repeat1] = STATE(11034),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14875),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7657),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7657),
    [anon_sym_AMP_AMP] = ACTIONS(7657),
    [anon_sym_LT_LT] = ACTIONS(7657),
    [anon_sym_GT_GT] = ACTIONS(7657),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7657),
    [anon_sym_PLUS] = ACTIONS(7657),
    [anon_sym_SLASH] = ACTIONS(7657),
    [anon_sym_PERCENT] = ACTIONS(7657),
    [sym_comment] = ACTIONS(87),
  },
  [11035] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(11082),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_assignment] = STATE(11082),
    [sym_operator_assignment] = STATE(11082),
    [sym_conditional] = STATE(11082),
    [sym_range] = STATE(11082),
    [sym_binary] = STATE(11082),
    [sym_unary] = STATE(11082),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11036] = {
    [sym__heredoc_body_start] = ACTIONS(6557),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(6557),
    [anon_sym_DOT] = ACTIONS(7554),
    [anon_sym_COMMA] = ACTIONS(6557),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(6557),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(7554),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(6557),
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [anon_sym_LBRACK] = ACTIONS(6557),
    [anon_sym_COLON_COLON2] = ACTIONS(6557),
    [anon_sym_AMP_DOT] = ACTIONS(6557),
    [anon_sym_PLUS_EQ] = ACTIONS(6557),
    [anon_sym_DASH_EQ] = ACTIONS(6557),
    [anon_sym_STAR_EQ] = ACTIONS(6557),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6557),
    [anon_sym_SLASH_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_PIPE_EQ] = ACTIONS(6557),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6557),
    [anon_sym_AMP_EQ] = ACTIONS(6557),
    [anon_sym_PERCENT_EQ] = ACTIONS(6557),
    [anon_sym_GT_GT_EQ] = ACTIONS(6557),
    [anon_sym_LT_LT_EQ] = ACTIONS(6557),
    [anon_sym_CARET_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [11037] = {
    [sym__heredoc_body_start] = ACTIONS(6759),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(6759),
    [anon_sym_DOT] = ACTIONS(7616),
    [anon_sym_COMMA] = ACTIONS(6759),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(6759),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(7616),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(6759),
    [anon_sym_EQ_GT] = ACTIONS(6759),
    [anon_sym_LBRACK] = ACTIONS(6759),
    [anon_sym_COLON_COLON2] = ACTIONS(6759),
    [anon_sym_AMP_DOT] = ACTIONS(6759),
    [anon_sym_PLUS_EQ] = ACTIONS(6759),
    [anon_sym_DASH_EQ] = ACTIONS(6759),
    [anon_sym_STAR_EQ] = ACTIONS(6759),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6759),
    [anon_sym_SLASH_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_PIPE_EQ] = ACTIONS(6759),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6759),
    [anon_sym_AMP_EQ] = ACTIONS(6759),
    [anon_sym_PERCENT_EQ] = ACTIONS(6759),
    [anon_sym_GT_GT_EQ] = ACTIONS(6759),
    [anon_sym_LT_LT_EQ] = ACTIONS(6759),
    [anon_sym_CARET_EQ] = ACTIONS(6759),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(6759),
    [anon_sym_or] = ACTIONS(6759),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [11038] = {
    [sym_heredoc_body] = STATE(11038),
    [aux_sym_call_repeat1] = STATE(11038),
    [sym__heredoc_body_start] = ACTIONS(10154),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_LBRACE] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7651),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_do] = ACTIONS(7646),
    [anon_sym_EQ_GT] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_PLUS_EQ] = ACTIONS(7646),
    [anon_sym_DASH_EQ] = ACTIONS(7646),
    [anon_sym_STAR_EQ] = ACTIONS(7646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7646),
    [anon_sym_SLASH_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_PIPE_EQ] = ACTIONS(7646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7646),
    [anon_sym_AMP_EQ] = ACTIONS(7646),
    [anon_sym_PERCENT_EQ] = ACTIONS(7646),
    [anon_sym_GT_GT_EQ] = ACTIONS(7646),
    [anon_sym_LT_LT_EQ] = ACTIONS(7646),
    [anon_sym_CARET_EQ] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7651),
    [anon_sym_AMP_AMP] = ACTIONS(7651),
    [anon_sym_LT_LT] = ACTIONS(7651),
    [anon_sym_GT_GT] = ACTIONS(7651),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7651),
    [anon_sym_PLUS] = ACTIONS(7651),
    [anon_sym_SLASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [sym_comment] = ACTIONS(87),
  },
  [11039] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10497),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym__argument] = STATE(6822),
    [sym_splat_argument] = STATE(6822),
    [sym_hash_splat_argument] = STATE(6822),
    [sym_block_argument] = STATE(6822),
    [sym_assignment] = STATE(10497),
    [sym_operator_assignment] = STATE(10497),
    [sym_conditional] = STATE(10497),
    [sym_range] = STATE(10497),
    [sym_binary] = STATE(10497),
    [sym_unary] = STATE(10497),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10500),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_pair] = STATE(6822),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__block_ampersand] = ACTIONS(14052),
    [sym__splat_star] = ACTIONS(14054),
    [sym__unary_minus] = ACTIONS(13215),
    [sym__identifier_hash_key] = ACTIONS(14056),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14799),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(14058),
    [sym_identifier] = ACTIONS(14058),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [11040] = {
    [sym_heredoc_body] = STATE(11038),
    [aux_sym_call_repeat1] = STATE(11038),
    [sym__heredoc_body_start] = ACTIONS(3408),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_LBRACE] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7663),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_EQ] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_do] = ACTIONS(7661),
    [anon_sym_EQ_GT] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_PLUS_EQ] = ACTIONS(7661),
    [anon_sym_DASH_EQ] = ACTIONS(7661),
    [anon_sym_STAR_EQ] = ACTIONS(7661),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7661),
    [anon_sym_SLASH_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_PIPE_EQ] = ACTIONS(7661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7661),
    [anon_sym_AMP_EQ] = ACTIONS(7661),
    [anon_sym_PERCENT_EQ] = ACTIONS(7661),
    [anon_sym_GT_GT_EQ] = ACTIONS(7661),
    [anon_sym_LT_LT_EQ] = ACTIONS(7661),
    [anon_sym_CARET_EQ] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7663),
    [anon_sym_AMP_AMP] = ACTIONS(7663),
    [anon_sym_LT_LT] = ACTIONS(7663),
    [anon_sym_GT_GT] = ACTIONS(7663),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7663),
    [anon_sym_PLUS] = ACTIONS(7663),
    [anon_sym_SLASH] = ACTIONS(7663),
    [anon_sym_PERCENT] = ACTIONS(7663),
    [sym_comment] = ACTIONS(87),
  },
  [11041] = {
    [aux_sym_argument_list_repeat1] = STATE(11041),
    [sym__heredoc_body_start] = ACTIONS(7657),
    [sym__binary_minus] = ACTIONS(7657),
    [sym__binary_star] = ACTIONS(7657),
    [anon_sym_LBRACE] = ACTIONS(7657),
    [anon_sym_DOT] = ACTIONS(7659),
    [anon_sym_COMMA] = ACTIONS(14878),
    [anon_sym_PIPE] = ACTIONS(7659),
    [anon_sym_SEMI] = ACTIONS(7657),
    [anon_sym_STAR_STAR] = ACTIONS(7659),
    [anon_sym_AMP] = ACTIONS(7659),
    [anon_sym_EQ] = ACTIONS(7659),
    [anon_sym_LT] = ACTIONS(7659),
    [anon_sym_do] = ACTIONS(7657),
    [anon_sym_EQ_GT] = ACTIONS(7657),
    [anon_sym_LBRACK] = ACTIONS(7657),
    [anon_sym_COLON_COLON2] = ACTIONS(7657),
    [anon_sym_AMP_DOT] = ACTIONS(7657),
    [anon_sym_PLUS_EQ] = ACTIONS(7657),
    [anon_sym_DASH_EQ] = ACTIONS(7657),
    [anon_sym_STAR_EQ] = ACTIONS(7657),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7657),
    [anon_sym_SLASH_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_PIPE_EQ] = ACTIONS(7657),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7657),
    [anon_sym_AMP_EQ] = ACTIONS(7657),
    [anon_sym_PERCENT_EQ] = ACTIONS(7657),
    [anon_sym_GT_GT_EQ] = ACTIONS(7657),
    [anon_sym_LT_LT_EQ] = ACTIONS(7657),
    [anon_sym_CARET_EQ] = ACTIONS(7657),
    [anon_sym_QMARK] = ACTIONS(7657),
    [anon_sym_DOT_DOT] = ACTIONS(7659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7657),
    [anon_sym_and] = ACTIONS(7657),
    [anon_sym_or] = ACTIONS(7657),
    [anon_sym_PIPE_PIPE] = ACTIONS(7659),
    [anon_sym_AMP_AMP] = ACTIONS(7659),
    [anon_sym_LT_LT] = ACTIONS(7659),
    [anon_sym_GT_GT] = ACTIONS(7659),
    [anon_sym_EQ_EQ] = ACTIONS(7659),
    [anon_sym_BANG_EQ] = ACTIONS(7657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7657),
    [anon_sym_LT_EQ_GT] = ACTIONS(7657),
    [anon_sym_EQ_TILDE] = ACTIONS(7657),
    [anon_sym_BANG_TILDE] = ACTIONS(7657),
    [anon_sym_LT_EQ] = ACTIONS(7659),
    [anon_sym_GT] = ACTIONS(7659),
    [anon_sym_GT_EQ] = ACTIONS(7657),
    [anon_sym_CARET] = ACTIONS(7659),
    [anon_sym_PLUS] = ACTIONS(7659),
    [anon_sym_SLASH] = ACTIONS(7659),
    [anon_sym_PERCENT] = ACTIONS(7659),
    [sym_comment] = ACTIONS(87),
  },
  [11042] = {
    [sym_method] = STATE(348),
    [sym_singleton_method] = STATE(348),
    [sym_class] = STATE(348),
    [sym_singleton_class] = STATE(348),
    [sym_module] = STATE(348),
    [sym_return] = STATE(348),
    [sym_yield] = STATE(348),
    [sym_break] = STATE(348),
    [sym_next] = STATE(348),
    [sym_while] = STATE(348),
    [sym_until] = STATE(348),
    [sym_for] = STATE(348),
    [sym_case] = STATE(348),
    [sym_if] = STATE(348),
    [sym_unless] = STATE(348),
    [sym_begin] = STATE(348),
    [sym__arg] = STATE(10867),
    [sym__primary] = STATE(348),
    [sym_parenthesized_statements] = STATE(348),
    [sym_element_reference] = STATE(9728),
    [sym_scope_resolution] = STATE(9724),
    [sym_call] = STATE(9724),
    [sym_method_call] = STATE(9728),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(10867),
    [sym_operator_assignment] = STATE(10867),
    [sym_conditional] = STATE(10867),
    [sym_range] = STATE(10867),
    [sym_binary] = STATE(10867),
    [sym_unary] = STATE(10867),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(9727),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9728),
    [sym__variable] = STATE(9724),
    [sym_rational] = STATE(348),
    [sym_true] = STATE(9728),
    [sym_false] = STATE(9728),
    [sym_nil] = STATE(9728),
    [sym_chained_string] = STATE(348),
    [sym_string] = STATE(10468),
    [sym_subshell] = STATE(348),
    [sym_string_array] = STATE(348),
    [sym_symbol_array] = STATE(348),
    [sym_symbol] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_array] = STATE(348),
    [sym_hash] = STATE(348),
    [sym_lambda] = STATE(348),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(591),
    [sym__splat_star] = ACTIONS(14018),
    [sym__unary_minus] = ACTIONS(13157),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13161),
    [anon_sym_yield] = ACTIONS(13163),
    [anon_sym_break] = ACTIONS(13165),
    [anon_sym_next] = ACTIONS(13167),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14012),
    [anon_sym_defined_QMARK] = ACTIONS(13169),
    [anon_sym_not] = ACTIONS(13171),
    [anon_sym_BANG] = ACTIONS(13175),
    [anon_sym_TILDE] = ACTIONS(13175),
    [sym_constant] = ACTIONS(13181),
    [sym_identifier] = ACTIONS(13181),
    [sym_instance_variable] = ACTIONS(13179),
    [sym_class_variable] = ACTIONS(13179),
    [sym_global_variable] = ACTIONS(13179),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13181),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13181),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11043] = {
    [aux_sym_exceptions_repeat1] = STATE(11083),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14881),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [11044] = {
    [sym__binary_minus] = ACTIONS(13183),
    [sym__binary_star] = ACTIONS(13185),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(14070),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(13185),
    [anon_sym_AMP] = ACTIONS(13189),
    [anon_sym_LT] = ACTIONS(13191),
    [anon_sym_QMARK] = ACTIONS(13193),
    [anon_sym_DOT_DOT] = ACTIONS(13195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13197),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(13201),
    [anon_sym_AMP_AMP] = ACTIONS(13201),
    [anon_sym_LT_LT] = ACTIONS(13203),
    [anon_sym_GT_GT] = ACTIONS(13203),
    [anon_sym_EQ_EQ] = ACTIONS(13205),
    [anon_sym_BANG_EQ] = ACTIONS(13201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13201),
    [anon_sym_LT_EQ_GT] = ACTIONS(13201),
    [anon_sym_EQ_TILDE] = ACTIONS(13201),
    [anon_sym_BANG_TILDE] = ACTIONS(13201),
    [anon_sym_LT_EQ] = ACTIONS(13191),
    [anon_sym_GT] = ACTIONS(13191),
    [anon_sym_GT_EQ] = ACTIONS(13207),
    [anon_sym_CARET] = ACTIONS(13209),
    [anon_sym_PLUS] = ACTIONS(13183),
    [anon_sym_SLASH] = ACTIONS(13185),
    [anon_sym_PERCENT] = ACTIONS(13185),
    [sym_comment] = ACTIONS(87),
  },
  [11045] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11046] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(5696),
    [sym__binary_star] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(87),
  },
  [11047] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11048] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11049] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11050] = {
    [sym__binary_minus] = ACTIONS(5732),
    [sym__binary_star] = ACTIONS(5734),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_STAR_STAR] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5738),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5742),
    [anon_sym_COLON2] = ACTIONS(14883),
    [anon_sym_DOT_DOT] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5748),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5752),
    [anon_sym_EQ_TILDE] = ACTIONS(5752),
    [anon_sym_BANG_TILDE] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [sym_comment] = ACTIONS(87),
  },
  [11051] = {
    [sym__heredoc_body_start] = ACTIONS(5798),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(5798),
    [anon_sym_DOT] = ACTIONS(7620),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(7620),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(5798),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON_COLON2] = ACTIONS(5798),
    [anon_sym_AMP_DOT] = ACTIONS(5798),
    [anon_sym_PLUS_EQ] = ACTIONS(5798),
    [anon_sym_DASH_EQ] = ACTIONS(5798),
    [anon_sym_STAR_EQ] = ACTIONS(5798),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5798),
    [anon_sym_SLASH_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_PIPE_EQ] = ACTIONS(5798),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5798),
    [anon_sym_AMP_EQ] = ACTIONS(5798),
    [anon_sym_PERCENT_EQ] = ACTIONS(5798),
    [anon_sym_GT_GT_EQ] = ACTIONS(5798),
    [anon_sym_LT_LT_EQ] = ACTIONS(5798),
    [anon_sym_CARET_EQ] = ACTIONS(5798),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(5798),
    [anon_sym_or] = ACTIONS(5798),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11052] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(14637),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11053] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11054] = {
    [sym__heredoc_body_start] = ACTIONS(5696),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_do] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_COLON_COLON2] = ACTIONS(5696),
    [anon_sym_AMP_DOT] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_DOT_DOT] = ACTIONS(5698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5696),
    [anon_sym_EQ_TILDE] = ACTIONS(5696),
    [anon_sym_BANG_TILDE] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11055] = {
    [sym__heredoc_body_start] = ACTIONS(4970),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(7668),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(7668),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_COLON_COLON2] = ACTIONS(4970),
    [anon_sym_AMP_DOT] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(14637),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(4970),
    [anon_sym_or] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11056] = {
    [aux_sym_exceptions_repeat1] = STATE(11086),
    [sym__heredoc_body_start] = ACTIONS(6060),
    [sym__binary_minus] = ACTIONS(6060),
    [sym__binary_star] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(6060),
    [anon_sym_DOT] = ACTIONS(6062),
    [anon_sym_COMMA] = ACTIONS(6060),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6060),
    [anon_sym_STAR_STAR] = ACTIONS(6062),
    [anon_sym_AMP] = ACTIONS(6062),
    [anon_sym_EQ] = ACTIONS(6062),
    [anon_sym_LT] = ACTIONS(6062),
    [anon_sym_do] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6060),
    [anon_sym_COLON_COLON2] = ACTIONS(6060),
    [anon_sym_AMP_DOT] = ACTIONS(6060),
    [anon_sym_PLUS_EQ] = ACTIONS(6060),
    [anon_sym_DASH_EQ] = ACTIONS(6060),
    [anon_sym_STAR_EQ] = ACTIONS(6060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6060),
    [anon_sym_SLASH_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_PIPE_EQ] = ACTIONS(6060),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6060),
    [anon_sym_AMP_EQ] = ACTIONS(6060),
    [anon_sym_PERCENT_EQ] = ACTIONS(6060),
    [anon_sym_GT_GT_EQ] = ACTIONS(6060),
    [anon_sym_LT_LT_EQ] = ACTIONS(6060),
    [anon_sym_CARET_EQ] = ACTIONS(6060),
    [anon_sym_QMARK] = ACTIONS(6060),
    [anon_sym_DOT_DOT] = ACTIONS(6062),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6060),
    [anon_sym_and] = ACTIONS(6060),
    [anon_sym_or] = ACTIONS(6060),
    [anon_sym_PIPE_PIPE] = ACTIONS(6062),
    [anon_sym_AMP_AMP] = ACTIONS(6062),
    [anon_sym_LT_LT] = ACTIONS(6062),
    [anon_sym_GT_GT] = ACTIONS(6062),
    [anon_sym_EQ_EQ] = ACTIONS(6062),
    [anon_sym_BANG_EQ] = ACTIONS(6060),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6060),
    [anon_sym_LT_EQ_GT] = ACTIONS(6060),
    [anon_sym_EQ_TILDE] = ACTIONS(6060),
    [anon_sym_BANG_TILDE] = ACTIONS(6060),
    [anon_sym_LT_EQ] = ACTIONS(6062),
    [anon_sym_GT] = ACTIONS(6062),
    [anon_sym_GT_EQ] = ACTIONS(6060),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6062),
    [anon_sym_SLASH] = ACTIONS(6062),
    [anon_sym_PERCENT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(87),
  },
  [11057] = {
    [sym__heredoc_body_start] = ACTIONS(6074),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(7670),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(7670),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_COLON_COLON2] = ACTIONS(6074),
    [anon_sym_AMP_DOT] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_QMARK] = ACTIONS(14637),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6074),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11058] = {
    [sym_string] = STATE(11058),
    [aux_sym_chained_string_repeat1] = STATE(11058),
    [sym__string_start] = ACTIONS(13427),
    [sym__heredoc_body_start] = ACTIONS(6076),
    [sym__binary_minus] = ACTIONS(6076),
    [sym__binary_star] = ACTIONS(6076),
    [anon_sym_LBRACE] = ACTIONS(6076),
    [anon_sym_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6076),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6076),
    [anon_sym_STAR_STAR] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_do] = ACTIONS(6076),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_COLON_COLON2] = ACTIONS(6076),
    [anon_sym_AMP_DOT] = ACTIONS(6076),
    [anon_sym_PLUS_EQ] = ACTIONS(6076),
    [anon_sym_DASH_EQ] = ACTIONS(6076),
    [anon_sym_STAR_EQ] = ACTIONS(6076),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6076),
    [anon_sym_SLASH_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_PIPE_EQ] = ACTIONS(6076),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6076),
    [anon_sym_AMP_EQ] = ACTIONS(6076),
    [anon_sym_PERCENT_EQ] = ACTIONS(6076),
    [anon_sym_GT_GT_EQ] = ACTIONS(6076),
    [anon_sym_LT_LT_EQ] = ACTIONS(6076),
    [anon_sym_CARET_EQ] = ACTIONS(6076),
    [anon_sym_QMARK] = ACTIONS(6076),
    [anon_sym_DOT_DOT] = ACTIONS(6081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6076),
    [anon_sym_and] = ACTIONS(6076),
    [anon_sym_or] = ACTIONS(6076),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6076),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6076),
    [anon_sym_LT_EQ_GT] = ACTIONS(6076),
    [anon_sym_EQ_TILDE] = ACTIONS(6076),
    [anon_sym_BANG_TILDE] = ACTIONS(6076),
    [anon_sym_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_GT_EQ] = ACTIONS(6076),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_PLUS] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6081),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(87),
  },
  [11059] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(11087),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_assignment] = STATE(11087),
    [sym_operator_assignment] = STATE(11087),
    [sym_conditional] = STATE(11087),
    [sym_range] = STATE(11087),
    [sym_binary] = STATE(11087),
    [sym_unary] = STATE(11087),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [11060] = {
    [sym_method] = STATE(645),
    [sym_singleton_method] = STATE(645),
    [sym_class] = STATE(645),
    [sym_singleton_class] = STATE(645),
    [sym_module] = STATE(645),
    [sym_return] = STATE(645),
    [sym_yield] = STATE(645),
    [sym_break] = STATE(645),
    [sym_next] = STATE(645),
    [sym_while] = STATE(645),
    [sym_until] = STATE(645),
    [sym_for] = STATE(645),
    [sym_case] = STATE(645),
    [sym_if] = STATE(645),
    [sym_unless] = STATE(645),
    [sym_begin] = STATE(645),
    [sym__arg] = STATE(10903),
    [sym__primary] = STATE(645),
    [sym_parenthesized_statements] = STATE(645),
    [sym_element_reference] = STATE(9758),
    [sym_scope_resolution] = STATE(9754),
    [sym_call] = STATE(9754),
    [sym_method_call] = STATE(9758),
    [sym_splat_argument] = STATE(8821),
    [sym_assignment] = STATE(10903),
    [sym_operator_assignment] = STATE(10903),
    [sym_conditional] = STATE(10903),
    [sym_range] = STATE(10903),
    [sym_binary] = STATE(10903),
    [sym_unary] = STATE(10903),
    [sym__arg_or_splat_arg] = STATE(8821),
    [sym_left_assignment_list] = STATE(9757),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(9758),
    [sym__variable] = STATE(9754),
    [sym_rational] = STATE(645),
    [sym_true] = STATE(9758),
    [sym_false] = STATE(9758),
    [sym_nil] = STATE(9758),
    [sym_chained_string] = STATE(645),
    [sym_string] = STATE(10531),
    [sym_subshell] = STATE(645),
    [sym_string_array] = STATE(645),
    [sym_symbol_array] = STATE(645),
    [sym_symbol] = STATE(645),
    [sym_regex] = STATE(645),
    [sym_array] = STATE(645),
    [sym_hash] = STATE(645),
    [sym_lambda] = STATE(645),
    [sym__simple_symbol] = ACTIONS(1139),
    [sym__string_start] = ACTIONS(1141),
    [sym__symbol_start] = ACTIONS(1143),
    [sym__subshell_start] = ACTIONS(1145),
    [sym__regex_start] = ACTIONS(1147),
    [sym__string_array_start] = ACTIONS(1149),
    [sym__symbol_array_start] = ACTIONS(1151),
    [sym_heredoc_beginning] = ACTIONS(1153),
    [sym__splat_star] = ACTIONS(14054),
    [sym__unary_minus] = ACTIONS(13215),
    [anon_sym_LBRACE] = ACTIONS(3330),
    [anon_sym_def] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(13219),
    [anon_sym_yield] = ACTIONS(13221),
    [anon_sym_break] = ACTIONS(13223),
    [anon_sym_next] = ACTIONS(13225),
    [sym_redo] = ACTIONS(1181),
    [sym_retry] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_unless] = ACTIONS(1185),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_until] = ACTIONS(1189),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_case] = ACTIONS(1195),
    [anon_sym_begin] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(14094),
    [anon_sym_defined_QMARK] = ACTIONS(13227),
    [anon_sym_not] = ACTIONS(13229),
    [anon_sym_BANG] = ACTIONS(13233),
    [anon_sym_TILDE] = ACTIONS(13233),
    [sym_constant] = ACTIONS(13239),
    [sym_identifier] = ACTIONS(13239),
    [sym_instance_variable] = ACTIONS(13237),
    [sym_class_variable] = ACTIONS(13237),
    [sym_global_variable] = ACTIONS(13237),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1213),
    [sym_float] = ACTIONS(1181),
    [sym_complex] = ACTIONS(1153),
    [sym_super] = ACTIONS(13239),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13239),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1153),
    [anon_sym_LBRACK2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(1219),
  },
  [11061] = {
    [aux_sym_exceptions_repeat1] = STATE(11088),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14885),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_EQ_GT] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [11062] = {
    [aux_sym_exceptions_repeat1] = STATE(11062),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(14887),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [11063] = {
    [sym__simple_symbol] = ACTIONS(14890),
    [sym__string_start] = ACTIONS(14890),
    [sym__symbol_start] = ACTIONS(14890),
    [sym__subshell_start] = ACTIONS(14890),
    [sym__regex_start] = ACTIONS(14890),
    [sym__string_array_start] = ACTIONS(14890),
    [sym__symbol_array_start] = ACTIONS(14890),
    [sym_heredoc_beginning] = ACTIONS(14890),
    [sym__unary_minus] = ACTIONS(14890),
    [anon_sym_BEGIN] = ACTIONS(14892),
    [anon_sym_LBRACE] = ACTIONS(14890),
    [anon_sym_RBRACE] = ACTIONS(14890),
    [anon_sym_END] = ACTIONS(14892),
    [anon_sym_def] = ACTIONS(14892),
    [anon_sym_LPAREN] = ACTIONS(14890),
    [anon_sym_COLON_COLON] = ACTIONS(14890),
    [anon_sym_SEMI] = ACTIONS(14890),
    [anon_sym_STAR] = ACTIONS(14890),
    [anon_sym_class] = ACTIONS(14892),
    [anon_sym_module] = ACTIONS(14892),
    [anon_sym_return] = ACTIONS(14892),
    [anon_sym_yield] = ACTIONS(14892),
    [anon_sym_break] = ACTIONS(14892),
    [anon_sym_next] = ACTIONS(14892),
    [sym_redo] = ACTIONS(14892),
    [sym_retry] = ACTIONS(14892),
    [anon_sym_if] = ACTIONS(14892),
    [anon_sym_unless] = ACTIONS(14892),
    [anon_sym_while] = ACTIONS(14892),
    [anon_sym_until] = ACTIONS(14892),
    [anon_sym_for] = ACTIONS(14892),
    [anon_sym_case] = ACTIONS(14892),
    [anon_sym_begin] = ACTIONS(14892),
    [anon_sym_PLUS] = ACTIONS(14892),
    [anon_sym_defined_QMARK] = ACTIONS(14890),
    [anon_sym_not] = ACTIONS(14892),
    [anon_sym_BANG] = ACTIONS(14890),
    [anon_sym_TILDE] = ACTIONS(14890),
    [sym_constant] = ACTIONS(14892),
    [sym_identifier] = ACTIONS(14892),
    [sym_instance_variable] = ACTIONS(14890),
    [sym_class_variable] = ACTIONS(14890),
    [sym_global_variable] = ACTIONS(14890),
    [anon_sym_undef] = ACTIONS(14892),
    [anon_sym_alias] = ACTIONS(14892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(14892),
    [sym_float] = ACTIONS(14892),
    [sym_complex] = ACTIONS(14890),
    [sym_super] = ACTIONS(14892),
    [anon_sym_true] = ACTIONS(14892),
    [anon_sym_TRUE] = ACTIONS(14892),
    [anon_sym_false] = ACTIONS(14892),
    [anon_sym_FALSE] = ACTIONS(14892),
    [sym_self] = ACTIONS(14892),
    [anon_sym_nil] = ACTIONS(14892),
    [anon_sym_NIL] = ACTIONS(14892),
    [sym_character] = ACTIONS(14890),
    [anon_sym_LBRACK2] = ACTIONS(14890),
    [anon_sym_DASH_GT] = ACTIONS(14890),
  },
  [11064] = {
    [sym__line_break] = ACTIONS(14890),
    [sym__simple_symbol] = ACTIONS(14890),
    [sym__string_start] = ACTIONS(14890),
    [sym__symbol_start] = ACTIONS(14890),
    [sym__subshell_start] = ACTIONS(14890),
    [sym__regex_start] = ACTIONS(14890),
    [sym__string_array_start] = ACTIONS(14890),
    [sym__symbol_array_start] = ACTIONS(14890),
    [sym__heredoc_body_start] = ACTIONS(14890),
    [sym_heredoc_beginning] = ACTIONS(14890),
    [sym__unary_minus] = ACTIONS(14890),
    [anon_sym_BEGIN] = ACTIONS(14892),
    [anon_sym_LBRACE] = ACTIONS(14890),
    [anon_sym_END] = ACTIONS(14892),
    [anon_sym_def] = ACTIONS(14892),
    [anon_sym_LPAREN] = ACTIONS(14890),
    [anon_sym_COLON_COLON] = ACTIONS(14890),
    [anon_sym_SEMI] = ACTIONS(14890),
    [anon_sym_STAR] = ACTIONS(14890),
    [anon_sym_class] = ACTIONS(14892),
    [anon_sym_module] = ACTIONS(14892),
    [anon_sym_end] = ACTIONS(14892),
    [anon_sym_return] = ACTIONS(14892),
    [anon_sym_yield] = ACTIONS(14892),
    [anon_sym_break] = ACTIONS(14892),
    [anon_sym_next] = ACTIONS(14892),
    [sym_redo] = ACTIONS(14892),
    [sym_retry] = ACTIONS(14892),
    [anon_sym_if] = ACTIONS(14892),
    [anon_sym_unless] = ACTIONS(14892),
    [anon_sym_while] = ACTIONS(14892),
    [anon_sym_until] = ACTIONS(14892),
    [anon_sym_for] = ACTIONS(14892),
    [anon_sym_case] = ACTIONS(14892),
    [anon_sym_begin] = ACTIONS(14892),
    [anon_sym_PLUS] = ACTIONS(14892),
    [anon_sym_defined_QMARK] = ACTIONS(14890),
    [anon_sym_not] = ACTIONS(14892),
    [anon_sym_BANG] = ACTIONS(14890),
    [anon_sym_TILDE] = ACTIONS(14890),
    [sym_constant] = ACTIONS(14892),
    [sym_identifier] = ACTIONS(14892),
    [sym_instance_variable] = ACTIONS(14890),
    [sym_class_variable] = ACTIONS(14890),
    [sym_global_variable] = ACTIONS(14890),
    [anon_sym_undef] = ACTIONS(14892),
    [anon_sym_alias] = ACTIONS(14892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(14892),
    [sym_float] = ACTIONS(14892),
    [sym_complex] = ACTIONS(14890),
    [sym_super] = ACTIONS(14892),
    [anon_sym_true] = ACTIONS(14892),
    [anon_sym_TRUE] = ACTIONS(14892),
    [anon_sym_false] = ACTIONS(14892),
    [anon_sym_FALSE] = ACTIONS(14892),
    [sym_self] = ACTIONS(14892),
    [anon_sym_nil] = ACTIONS(14892),
    [anon_sym_NIL] = ACTIONS(14892),
    [sym_character] = ACTIONS(14890),
    [anon_sym_LBRACK2] = ACTIONS(14890),
    [anon_sym_DASH_GT] = ACTIONS(14890),
  },
  [11065] = {
    [sym__heredoc_body_start] = ACTIONS(13660),
    [sym__binary_minus] = ACTIONS(13660),
    [sym__binary_star] = ACTIONS(13660),
    [anon_sym_LBRACE] = ACTIONS(13660),
    [anon_sym_RBRACE] = ACTIONS(13660),
    [anon_sym_RPAREN] = ACTIONS(13660),
    [anon_sym_DOT] = ACTIONS(13662),
    [anon_sym_COMMA] = ACTIONS(13660),
    [anon_sym_PIPE] = ACTIONS(13662),
    [anon_sym_SEMI] = ACTIONS(13660),
    [anon_sym_STAR_STAR] = ACTIONS(13662),
    [anon_sym_AMP] = ACTIONS(13662),
    [anon_sym_EQ] = ACTIONS(13662),
    [anon_sym_LT] = ACTIONS(13662),
    [anon_sym_if] = ACTIONS(13660),
    [anon_sym_unless] = ACTIONS(13660),
    [anon_sym_while] = ACTIONS(13660),
    [anon_sym_until] = ACTIONS(13660),
    [anon_sym_rescue] = ACTIONS(13660),
    [anon_sym_in] = ACTIONS(13660),
    [anon_sym_do] = ACTIONS(13660),
    [anon_sym_LBRACK] = ACTIONS(13660),
    [anon_sym_RBRACK] = ACTIONS(13660),
    [anon_sym_COLON_COLON2] = ACTIONS(13660),
    [anon_sym_AMP_DOT] = ACTIONS(13660),
    [anon_sym_PLUS_EQ] = ACTIONS(13660),
    [anon_sym_DASH_EQ] = ACTIONS(13660),
    [anon_sym_STAR_EQ] = ACTIONS(13660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13660),
    [anon_sym_SLASH_EQ] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13660),
    [anon_sym_PIPE_EQ] = ACTIONS(13660),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13660),
    [anon_sym_AMP_EQ] = ACTIONS(13660),
    [anon_sym_PERCENT_EQ] = ACTIONS(13660),
    [anon_sym_GT_GT_EQ] = ACTIONS(13660),
    [anon_sym_LT_LT_EQ] = ACTIONS(13660),
    [anon_sym_CARET_EQ] = ACTIONS(13660),
    [anon_sym_QMARK] = ACTIONS(13660),
    [anon_sym_COLON2] = ACTIONS(13662),
    [anon_sym_DOT_DOT] = ACTIONS(13662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13660),
    [anon_sym_and] = ACTIONS(13660),
    [anon_sym_or] = ACTIONS(13660),
    [anon_sym_PIPE_PIPE] = ACTIONS(13662),
    [anon_sym_AMP_AMP] = ACTIONS(13662),
    [anon_sym_LT_LT] = ACTIONS(13662),
    [anon_sym_GT_GT] = ACTIONS(13662),
    [anon_sym_EQ_EQ] = ACTIONS(13662),
    [anon_sym_BANG_EQ] = ACTIONS(13660),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13660),
    [anon_sym_LT_EQ_GT] = ACTIONS(13660),
    [anon_sym_EQ_TILDE] = ACTIONS(13660),
    [anon_sym_BANG_TILDE] = ACTIONS(13660),
    [anon_sym_LT_EQ] = ACTIONS(13662),
    [anon_sym_GT] = ACTIONS(13662),
    [anon_sym_GT_EQ] = ACTIONS(13660),
    [anon_sym_CARET] = ACTIONS(13662),
    [anon_sym_PLUS] = ACTIONS(13662),
    [anon_sym_SLASH] = ACTIONS(13662),
    [anon_sym_PERCENT] = ACTIONS(13662),
    [sym_comment] = ACTIONS(87),
  },
  [11066] = {
    [sym_heredoc_body] = STATE(11066),
    [aux_sym_call_repeat1] = STATE(11066),
    [sym__line_break] = ACTIONS(7646),
    [sym__heredoc_body_start] = ACTIONS(7648),
    [sym__binary_minus] = ACTIONS(7646),
    [sym__binary_star] = ACTIONS(7646),
    [anon_sym_DOT] = ACTIONS(7651),
    [anon_sym_COMMA] = ACTIONS(7646),
    [anon_sym_PIPE] = ACTIONS(7651),
    [anon_sym_SEMI] = ACTIONS(7646),
    [anon_sym_STAR_STAR] = ACTIONS(7646),
    [anon_sym_AMP] = ACTIONS(7651),
    [anon_sym_LT] = ACTIONS(7651),
    [anon_sym_end] = ACTIONS(7646),
    [anon_sym_if] = ACTIONS(7646),
    [anon_sym_unless] = ACTIONS(7646),
    [anon_sym_while] = ACTIONS(7646),
    [anon_sym_until] = ACTIONS(7646),
    [anon_sym_rescue] = ACTIONS(7646),
    [anon_sym_when] = ACTIONS(7646),
    [anon_sym_else] = ACTIONS(7646),
    [anon_sym_LBRACK] = ACTIONS(7646),
    [anon_sym_COLON_COLON2] = ACTIONS(7646),
    [anon_sym_AMP_DOT] = ACTIONS(7646),
    [anon_sym_QMARK] = ACTIONS(7646),
    [anon_sym_DOT_DOT] = ACTIONS(7651),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7646),
    [anon_sym_and] = ACTIONS(7646),
    [anon_sym_or] = ACTIONS(7646),
    [anon_sym_PIPE_PIPE] = ACTIONS(7646),
    [anon_sym_AMP_AMP] = ACTIONS(7646),
    [anon_sym_LT_LT] = ACTIONS(7646),
    [anon_sym_GT_GT] = ACTIONS(7646),
    [anon_sym_EQ_EQ] = ACTIONS(7651),
    [anon_sym_BANG_EQ] = ACTIONS(7646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7646),
    [anon_sym_LT_EQ_GT] = ACTIONS(7646),
    [anon_sym_EQ_TILDE] = ACTIONS(7646),
    [anon_sym_BANG_TILDE] = ACTIONS(7646),
    [anon_sym_LT_EQ] = ACTIONS(7651),
    [anon_sym_GT] = ACTIONS(7651),
    [anon_sym_GT_EQ] = ACTIONS(7646),
    [anon_sym_CARET] = ACTIONS(7646),
    [anon_sym_PLUS] = ACTIONS(7646),
    [anon_sym_SLASH] = ACTIONS(7646),
    [anon_sym_PERCENT] = ACTIONS(7646),
    [sym_comment] = ACTIONS(87),
  },
  [11067] = {
    [sym_heredoc_body] = STATE(11066),
    [aux_sym_call_repeat1] = STATE(11066),
    [sym__line_break] = ACTIONS(7661),
    [sym__heredoc_body_start] = ACTIONS(1685),
    [sym__binary_minus] = ACTIONS(7661),
    [sym__binary_star] = ACTIONS(7661),
    [anon_sym_DOT] = ACTIONS(7663),
    [anon_sym_COMMA] = ACTIONS(7661),
    [anon_sym_PIPE] = ACTIONS(7663),
    [anon_sym_SEMI] = ACTIONS(7661),
    [anon_sym_STAR_STAR] = ACTIONS(7661),
    [anon_sym_AMP] = ACTIONS(7663),
    [anon_sym_LT] = ACTIONS(7663),
    [anon_sym_end] = ACTIONS(7661),
    [anon_sym_if] = ACTIONS(7661),
    [anon_sym_unless] = ACTIONS(7661),
    [anon_sym_while] = ACTIONS(7661),
    [anon_sym_until] = ACTIONS(7661),
    [anon_sym_rescue] = ACTIONS(7661),
    [anon_sym_when] = ACTIONS(7661),
    [anon_sym_else] = ACTIONS(7661),
    [anon_sym_LBRACK] = ACTIONS(7661),
    [anon_sym_COLON_COLON2] = ACTIONS(7661),
    [anon_sym_AMP_DOT] = ACTIONS(7661),
    [anon_sym_QMARK] = ACTIONS(7661),
    [anon_sym_DOT_DOT] = ACTIONS(7663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7661),
    [anon_sym_and] = ACTIONS(7661),
    [anon_sym_or] = ACTIONS(7661),
    [anon_sym_PIPE_PIPE] = ACTIONS(7661),
    [anon_sym_AMP_AMP] = ACTIONS(7661),
    [anon_sym_LT_LT] = ACTIONS(7661),
    [anon_sym_GT_GT] = ACTIONS(7661),
    [anon_sym_EQ_EQ] = ACTIONS(7663),
    [anon_sym_BANG_EQ] = ACTIONS(7661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7661),
    [anon_sym_LT_EQ_GT] = ACTIONS(7661),
    [anon_sym_EQ_TILDE] = ACTIONS(7661),
    [anon_sym_BANG_TILDE] = ACTIONS(7661),
    [anon_sym_LT_EQ] = ACTIONS(7663),
    [anon_sym_GT] = ACTIONS(7663),
    [anon_sym_GT_EQ] = ACTIONS(7661),
    [anon_sym_CARET] = ACTIONS(7661),
    [anon_sym_PLUS] = ACTIONS(7661),
    [anon_sym_SLASH] = ACTIONS(7661),
    [anon_sym_PERCENT] = ACTIONS(7661),
    [sym_comment] = ACTIONS(87),
  },
  [11068] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11089),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_assignment] = STATE(11089),
    [sym_operator_assignment] = STATE(11089),
    [sym_conditional] = STATE(11089),
    [sym_range] = STATE(11089),
    [sym_binary] = STATE(11089),
    [sym_unary] = STATE(11089),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11069] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(10961),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10249),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10249),
    [sym_splat_argument] = STATE(7296),
    [sym_assignment] = STATE(10961),
    [sym_operator_assignment] = STATE(10961),
    [sym_conditional] = STATE(10961),
    [sym_range] = STATE(10961),
    [sym_binary] = STATE(10961),
    [sym_unary] = STATE(10961),
    [sym__arg_or_splat_arg] = STATE(7296),
    [sym_left_assignment_list] = STATE(10248),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10249),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10249),
    [sym_false] = STATE(10249),
    [sym_nil] = STATE(10249),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__splat_star] = ACTIONS(12828),
    [sym__unary_minus] = ACTIONS(13714),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13724),
    [anon_sym_defined_QMARK] = ACTIONS(13726),
    [anon_sym_not] = ACTIONS(13728),
    [anon_sym_BANG] = ACTIONS(13730),
    [anon_sym_TILDE] = ACTIONS(13730),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11070] = {
    [aux_sym_exceptions_repeat1] = STATE(11090),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14894),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_when] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [11071] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(13746),
    [sym__binary_star] = ACTIONS(13748),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(13750),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(13748),
    [anon_sym_AMP] = ACTIONS(13752),
    [anon_sym_LT] = ACTIONS(13754),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_when] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(13756),
    [anon_sym_DOT_DOT] = ACTIONS(13758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13760),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(13762),
    [anon_sym_AMP_AMP] = ACTIONS(13762),
    [anon_sym_LT_LT] = ACTIONS(13764),
    [anon_sym_GT_GT] = ACTIONS(13764),
    [anon_sym_EQ_EQ] = ACTIONS(13766),
    [anon_sym_BANG_EQ] = ACTIONS(13762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13762),
    [anon_sym_LT_EQ_GT] = ACTIONS(13762),
    [anon_sym_EQ_TILDE] = ACTIONS(13762),
    [anon_sym_BANG_TILDE] = ACTIONS(13762),
    [anon_sym_LT_EQ] = ACTIONS(13754),
    [anon_sym_GT] = ACTIONS(13754),
    [anon_sym_GT_EQ] = ACTIONS(13768),
    [anon_sym_CARET] = ACTIONS(13770),
    [anon_sym_PLUS] = ACTIONS(13746),
    [anon_sym_SLASH] = ACTIONS(13748),
    [anon_sym_PERCENT] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [11072] = {
    [aux_sym_exceptions_repeat1] = STATE(11072),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14896),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_when] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [11073] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(11091),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_assignment] = STATE(11091),
    [sym_operator_assignment] = STATE(11091),
    [sym_conditional] = STATE(11091),
    [sym_range] = STATE(11091),
    [sym_binary] = STATE(11091),
    [sym_unary] = STATE(11091),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [11074] = {
    [sym_method] = STATE(1493),
    [sym_singleton_method] = STATE(1493),
    [sym_class] = STATE(1493),
    [sym_singleton_class] = STATE(1493),
    [sym_module] = STATE(1493),
    [sym_return] = STATE(1493),
    [sym_yield] = STATE(1493),
    [sym_break] = STATE(1493),
    [sym_next] = STATE(1493),
    [sym_while] = STATE(1493),
    [sym_until] = STATE(1493),
    [sym_for] = STATE(1493),
    [sym_case] = STATE(1493),
    [sym_if] = STATE(1493),
    [sym_unless] = STATE(1493),
    [sym_begin] = STATE(1493),
    [sym__arg] = STATE(10991),
    [sym__primary] = STATE(1493),
    [sym_parenthesized_statements] = STATE(1493),
    [sym_element_reference] = STATE(10320),
    [sym_scope_resolution] = STATE(10318),
    [sym_call] = STATE(10318),
    [sym_method_call] = STATE(10320),
    [sym_splat_argument] = STATE(9865),
    [sym_assignment] = STATE(10991),
    [sym_operator_assignment] = STATE(10991),
    [sym_conditional] = STATE(10991),
    [sym_range] = STATE(10991),
    [sym_binary] = STATE(10991),
    [sym_unary] = STATE(10991),
    [sym__arg_or_splat_arg] = STATE(9865),
    [sym_left_assignment_list] = STATE(10319),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10320),
    [sym__variable] = STATE(10318),
    [sym_rational] = STATE(1493),
    [sym_true] = STATE(10320),
    [sym_false] = STATE(10320),
    [sym_nil] = STATE(10320),
    [sym_chained_string] = STATE(1493),
    [sym_string] = STATE(10321),
    [sym_subshell] = STATE(1493),
    [sym_string_array] = STATE(1493),
    [sym_symbol_array] = STATE(1493),
    [sym_symbol] = STATE(1493),
    [sym_regex] = STATE(1493),
    [sym_array] = STATE(1493),
    [sym_hash] = STATE(1493),
    [sym_lambda] = STATE(1493),
    [sym__simple_symbol] = ACTIONS(2557),
    [sym__string_start] = ACTIONS(2559),
    [sym__symbol_start] = ACTIONS(2561),
    [sym__subshell_start] = ACTIONS(2563),
    [sym__regex_start] = ACTIONS(2565),
    [sym__string_array_start] = ACTIONS(2567),
    [sym__symbol_array_start] = ACTIONS(2569),
    [sym_heredoc_beginning] = ACTIONS(2571),
    [sym__splat_star] = ACTIONS(12902),
    [sym__unary_minus] = ACTIONS(13794),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_def] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_module] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(13796),
    [anon_sym_yield] = ACTIONS(13798),
    [anon_sym_break] = ACTIONS(13800),
    [anon_sym_next] = ACTIONS(13802),
    [sym_redo] = ACTIONS(2593),
    [sym_retry] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2595),
    [anon_sym_unless] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2599),
    [anon_sym_until] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2603),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_begin] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(13804),
    [anon_sym_defined_QMARK] = ACTIONS(13806),
    [anon_sym_not] = ACTIONS(13808),
    [anon_sym_BANG] = ACTIONS(13810),
    [anon_sym_TILDE] = ACTIONS(13810),
    [sym_constant] = ACTIONS(13812),
    [sym_identifier] = ACTIONS(13812),
    [sym_instance_variable] = ACTIONS(13814),
    [sym_class_variable] = ACTIONS(13814),
    [sym_global_variable] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2621),
    [sym_float] = ACTIONS(2593),
    [sym_complex] = ACTIONS(2571),
    [sym_super] = ACTIONS(13812),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(13812),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2571),
    [anon_sym_LBRACK2] = ACTIONS(2623),
    [anon_sym_DASH_GT] = ACTIONS(2625),
  },
  [11075] = {
    [aux_sym_exceptions_repeat1] = STATE(11092),
    [sym__line_break] = ACTIONS(9603),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14899),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_end] = ACTIONS(9603),
    [anon_sym_if] = ACTIONS(9603),
    [anon_sym_unless] = ACTIONS(9603),
    [anon_sym_while] = ACTIONS(9603),
    [anon_sym_until] = ACTIONS(9603),
    [anon_sym_rescue] = ACTIONS(9603),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_when] = ACTIONS(9603),
    [anon_sym_else] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [11076] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(13822),
    [sym__binary_star] = ACTIONS(13824),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(13826),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(13828),
    [anon_sym_AMP] = ACTIONS(13830),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(13832),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_when] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(13834),
    [anon_sym_DOT_DOT] = ACTIONS(13836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13838),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(13840),
    [anon_sym_AMP_AMP] = ACTIONS(13840),
    [anon_sym_LT_LT] = ACTIONS(13842),
    [anon_sym_GT_GT] = ACTIONS(13842),
    [anon_sym_EQ_EQ] = ACTIONS(13840),
    [anon_sym_BANG_EQ] = ACTIONS(13844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13844),
    [anon_sym_LT_EQ_GT] = ACTIONS(13844),
    [anon_sym_EQ_TILDE] = ACTIONS(13844),
    [anon_sym_BANG_TILDE] = ACTIONS(13844),
    [anon_sym_LT_EQ] = ACTIONS(13832),
    [anon_sym_GT] = ACTIONS(13832),
    [anon_sym_GT_EQ] = ACTIONS(13846),
    [anon_sym_CARET] = ACTIONS(13826),
    [anon_sym_PLUS] = ACTIONS(13848),
    [anon_sym_SLASH] = ACTIONS(13828),
    [anon_sym_PERCENT] = ACTIONS(13828),
    [sym_comment] = ACTIONS(87),
  },
  [11077] = {
    [aux_sym_exceptions_repeat1] = STATE(11077),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14901),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_when] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [11078] = {
    [sym_method] = STATE(47),
    [sym_singleton_method] = STATE(47),
    [sym_class] = STATE(47),
    [sym_singleton_class] = STATE(47),
    [sym_module] = STATE(47),
    [sym_return] = STATE(47),
    [sym_yield] = STATE(47),
    [sym_break] = STATE(47),
    [sym_next] = STATE(47),
    [sym_while] = STATE(47),
    [sym_until] = STATE(47),
    [sym_for] = STATE(47),
    [sym_case] = STATE(47),
    [sym_if] = STATE(47),
    [sym_unless] = STATE(47),
    [sym_begin] = STATE(47),
    [sym__arg] = STATE(11093),
    [sym__primary] = STATE(47),
    [sym_parenthesized_statements] = STATE(47),
    [sym_element_reference] = STATE(10352),
    [sym_scope_resolution] = STATE(7793),
    [sym_call] = STATE(7793),
    [sym_method_call] = STATE(10352),
    [sym_assignment] = STATE(11093),
    [sym_operator_assignment] = STATE(11093),
    [sym_conditional] = STATE(11093),
    [sym_range] = STATE(11093),
    [sym_binary] = STATE(11093),
    [sym_unary] = STATE(11093),
    [sym_left_assignment_list] = STATE(10351),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10352),
    [sym__variable] = STATE(7793),
    [sym_rational] = STATE(47),
    [sym_true] = STATE(10352),
    [sym_false] = STATE(10352),
    [sym_nil] = STATE(10352),
    [sym_chained_string] = STATE(47),
    [sym_string] = STATE(10250),
    [sym_subshell] = STATE(47),
    [sym_string_array] = STATE(47),
    [sym_symbol_array] = STATE(47),
    [sym_symbol] = STATE(47),
    [sym_regex] = STATE(47),
    [sym_array] = STATE(47),
    [sym_hash] = STATE(47),
    [sym_lambda] = STATE(47),
    [sym__simple_symbol] = ACTIONS(5),
    [sym__string_start] = ACTIONS(7),
    [sym__symbol_start] = ACTIONS(9),
    [sym__subshell_start] = ACTIONS(11),
    [sym__regex_start] = ACTIONS(13),
    [sym__string_array_start] = ACTIONS(15),
    [sym__symbol_array_start] = ACTIONS(17),
    [sym_heredoc_beginning] = ACTIONS(19),
    [sym__unary_minus] = ACTIONS(13862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13716),
    [anon_sym_yield] = ACTIONS(13718),
    [anon_sym_break] = ACTIONS(13720),
    [anon_sym_next] = ACTIONS(13722),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(13864),
    [anon_sym_defined_QMARK] = ACTIONS(13866),
    [anon_sym_not] = ACTIONS(13868),
    [anon_sym_BANG] = ACTIONS(13870),
    [anon_sym_TILDE] = ACTIONS(13870),
    [sym_constant] = ACTIONS(11066),
    [sym_identifier] = ACTIONS(11066),
    [sym_instance_variable] = ACTIONS(11068),
    [sym_class_variable] = ACTIONS(11068),
    [sym_global_variable] = ACTIONS(11068),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11066),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11066),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11079] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11094),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_assignment] = STATE(11094),
    [sym_operator_assignment] = STATE(11094),
    [sym_conditional] = STATE(11094),
    [sym_range] = STATE(11094),
    [sym_binary] = STATE(11094),
    [sym_unary] = STATE(11094),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11080] = {
    [sym_method] = STATE(537),
    [sym_singleton_method] = STATE(537),
    [sym_class] = STATE(537),
    [sym_singleton_class] = STATE(537),
    [sym_module] = STATE(537),
    [sym_return] = STATE(537),
    [sym_yield] = STATE(537),
    [sym_break] = STATE(537),
    [sym_next] = STATE(537),
    [sym_while] = STATE(537),
    [sym_until] = STATE(537),
    [sym_for] = STATE(537),
    [sym_case] = STATE(537),
    [sym_if] = STATE(537),
    [sym_unless] = STATE(537),
    [sym_begin] = STATE(537),
    [sym__arg] = STATE(11025),
    [sym__primary] = STATE(537),
    [sym_parenthesized_statements] = STATE(537),
    [sym_element_reference] = STATE(10464),
    [sym_scope_resolution] = STATE(10462),
    [sym_call] = STATE(10462),
    [sym_method_call] = STATE(10464),
    [sym_splat_argument] = STATE(8785),
    [sym_assignment] = STATE(11025),
    [sym_operator_assignment] = STATE(11025),
    [sym_conditional] = STATE(11025),
    [sym_range] = STATE(11025),
    [sym_binary] = STATE(11025),
    [sym_unary] = STATE(11025),
    [sym__arg_or_splat_arg] = STATE(8785),
    [sym_left_assignment_list] = STATE(10463),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10464),
    [sym__variable] = STATE(10462),
    [sym_rational] = STATE(537),
    [sym_true] = STATE(10464),
    [sym_false] = STATE(10464),
    [sym_nil] = STATE(10464),
    [sym_chained_string] = STATE(537),
    [sym_string] = STATE(10465),
    [sym_subshell] = STATE(537),
    [sym_string_array] = STATE(537),
    [sym_symbol_array] = STATE(537),
    [sym_symbol] = STATE(537),
    [sym_regex] = STATE(537),
    [sym_array] = STATE(537),
    [sym_hash] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym__simple_symbol] = ACTIONS(577),
    [sym__string_start] = ACTIONS(579),
    [sym__symbol_start] = ACTIONS(581),
    [sym__subshell_start] = ACTIONS(583),
    [sym__regex_start] = ACTIONS(585),
    [sym__string_array_start] = ACTIONS(587),
    [sym__symbol_array_start] = ACTIONS(589),
    [sym_heredoc_beginning] = ACTIONS(1005),
    [sym__splat_star] = ACTIONS(13155),
    [sym__unary_minus] = ACTIONS(13990),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13992),
    [anon_sym_yield] = ACTIONS(13994),
    [anon_sym_break] = ACTIONS(13996),
    [anon_sym_next] = ACTIONS(13998),
    [sym_redo] = ACTIONS(1019),
    [sym_retry] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14000),
    [anon_sym_defined_QMARK] = ACTIONS(14002),
    [anon_sym_not] = ACTIONS(14004),
    [anon_sym_BANG] = ACTIONS(14006),
    [anon_sym_TILDE] = ACTIONS(14006),
    [sym_constant] = ACTIONS(14008),
    [sym_identifier] = ACTIONS(14008),
    [sym_instance_variable] = ACTIONS(14010),
    [sym_class_variable] = ACTIONS(14010),
    [sym_global_variable] = ACTIONS(14010),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1019),
    [sym_complex] = ACTIONS(1005),
    [sym_super] = ACTIONS(14008),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14008),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(1005),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11081] = {
    [aux_sym_exceptions_repeat1] = STATE(11095),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14904),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9603),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9603),
    [anon_sym_AMP_AMP] = ACTIONS(9603),
    [anon_sym_LT_LT] = ACTIONS(9603),
    [anon_sym_GT_GT] = ACTIONS(9603),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9603),
    [anon_sym_PLUS] = ACTIONS(9603),
    [anon_sym_SLASH] = ACTIONS(9603),
    [anon_sym_PERCENT] = ACTIONS(9603),
    [sym_comment] = ACTIONS(87),
  },
  [11082] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(14026),
    [sym__binary_star] = ACTIONS(14028),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(14030),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(14028),
    [anon_sym_AMP] = ACTIONS(14032),
    [anon_sym_LT] = ACTIONS(14034),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(14036),
    [anon_sym_DOT_DOT] = ACTIONS(14038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14040),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(14042),
    [anon_sym_AMP_AMP] = ACTIONS(14042),
    [anon_sym_LT_LT] = ACTIONS(14044),
    [anon_sym_GT_GT] = ACTIONS(14044),
    [anon_sym_EQ_EQ] = ACTIONS(14046),
    [anon_sym_BANG_EQ] = ACTIONS(14042),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14042),
    [anon_sym_LT_EQ_GT] = ACTIONS(14042),
    [anon_sym_EQ_TILDE] = ACTIONS(14042),
    [anon_sym_BANG_TILDE] = ACTIONS(14042),
    [anon_sym_LT_EQ] = ACTIONS(14034),
    [anon_sym_GT] = ACTIONS(14034),
    [anon_sym_GT_EQ] = ACTIONS(14048),
    [anon_sym_CARET] = ACTIONS(14050),
    [anon_sym_PLUS] = ACTIONS(14026),
    [anon_sym_SLASH] = ACTIONS(14028),
    [anon_sym_PERCENT] = ACTIONS(14028),
    [sym_comment] = ACTIONS(87),
  },
  [11083] = {
    [aux_sym_exceptions_repeat1] = STATE(11083),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14906),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [11084] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11096),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_assignment] = STATE(11096),
    [sym_operator_assignment] = STATE(11096),
    [sym_conditional] = STATE(11096),
    [sym_range] = STATE(11096),
    [sym_binary] = STATE(11096),
    [sym_unary] = STATE(11096),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [11085] = {
    [sym_method] = STATE(3857),
    [sym_singleton_method] = STATE(3857),
    [sym_class] = STATE(3857),
    [sym_singleton_class] = STATE(3857),
    [sym_module] = STATE(3857),
    [sym_return] = STATE(3857),
    [sym_yield] = STATE(3857),
    [sym_break] = STATE(3857),
    [sym_next] = STATE(3857),
    [sym_while] = STATE(3857),
    [sym_until] = STATE(3857),
    [sym_for] = STATE(3857),
    [sym_case] = STATE(3857),
    [sym_if] = STATE(3857),
    [sym_unless] = STATE(3857),
    [sym_begin] = STATE(3857),
    [sym__arg] = STATE(11055),
    [sym__primary] = STATE(3857),
    [sym_parenthesized_statements] = STATE(3857),
    [sym_element_reference] = STATE(10527),
    [sym_scope_resolution] = STATE(10525),
    [sym_call] = STATE(10525),
    [sym_method_call] = STATE(10527),
    [sym_splat_argument] = STATE(10613),
    [sym_assignment] = STATE(11055),
    [sym_operator_assignment] = STATE(11055),
    [sym_conditional] = STATE(11055),
    [sym_range] = STATE(11055),
    [sym_binary] = STATE(11055),
    [sym_unary] = STATE(11055),
    [sym__arg_or_splat_arg] = STATE(10613),
    [sym_left_assignment_list] = STATE(10526),
    [sym__mlhs] = STATE(50),
    [sym__simple_mlhs] = STATE(51),
    [sym_destructured_left_assignment] = STATE(51),
    [sym_rest_assignment] = STATE(51),
    [sym__lhs] = STATE(10527),
    [sym__variable] = STATE(10525),
    [sym_rational] = STATE(3857),
    [sym_true] = STATE(10527),
    [sym_false] = STATE(10527),
    [sym_nil] = STATE(10527),
    [sym_chained_string] = STATE(3857),
    [sym_string] = STATE(10528),
    [sym_subshell] = STATE(3857),
    [sym_string_array] = STATE(3857),
    [sym_symbol_array] = STATE(3857),
    [sym_symbol] = STATE(3857),
    [sym_regex] = STATE(3857),
    [sym_array] = STATE(3857),
    [sym_hash] = STATE(3857),
    [sym_lambda] = STATE(3857),
    [sym__simple_symbol] = ACTIONS(6185),
    [sym__string_start] = ACTIONS(6187),
    [sym__symbol_start] = ACTIONS(6189),
    [sym__subshell_start] = ACTIONS(6191),
    [sym__regex_start] = ACTIONS(6193),
    [sym__string_array_start] = ACTIONS(6195),
    [sym__symbol_array_start] = ACTIONS(6197),
    [sym_heredoc_beginning] = ACTIONS(6199),
    [sym__splat_star] = ACTIONS(13213),
    [sym__unary_minus] = ACTIONS(14072),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_def] = ACTIONS(6205),
    [anon_sym_LPAREN] = ACTIONS(6207),
    [anon_sym_COLON_COLON] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6209),
    [anon_sym_module] = ACTIONS(6211),
    [anon_sym_return] = ACTIONS(14074),
    [anon_sym_yield] = ACTIONS(14076),
    [anon_sym_break] = ACTIONS(14078),
    [anon_sym_next] = ACTIONS(14080),
    [sym_redo] = ACTIONS(6221),
    [sym_retry] = ACTIONS(6221),
    [anon_sym_if] = ACTIONS(6223),
    [anon_sym_unless] = ACTIONS(6225),
    [anon_sym_while] = ACTIONS(6227),
    [anon_sym_until] = ACTIONS(6229),
    [anon_sym_for] = ACTIONS(6231),
    [anon_sym_case] = ACTIONS(6233),
    [anon_sym_begin] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(14082),
    [anon_sym_defined_QMARK] = ACTIONS(14084),
    [anon_sym_not] = ACTIONS(14086),
    [anon_sym_BANG] = ACTIONS(14088),
    [anon_sym_TILDE] = ACTIONS(14088),
    [sym_constant] = ACTIONS(14090),
    [sym_identifier] = ACTIONS(14090),
    [sym_instance_variable] = ACTIONS(14092),
    [sym_class_variable] = ACTIONS(14092),
    [sym_global_variable] = ACTIONS(14092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6249),
    [sym_float] = ACTIONS(6221),
    [sym_complex] = ACTIONS(6199),
    [sym_super] = ACTIONS(14090),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_TRUE] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1035),
    [anon_sym_FALSE] = ACTIONS(1035),
    [sym_self] = ACTIONS(14090),
    [anon_sym_nil] = ACTIONS(1037),
    [anon_sym_NIL] = ACTIONS(1037),
    [sym_character] = ACTIONS(6199),
    [anon_sym_LBRACK2] = ACTIONS(6251),
    [anon_sym_DASH_GT] = ACTIONS(6253),
  },
  [11086] = {
    [aux_sym_exceptions_repeat1] = STATE(11097),
    [sym__heredoc_body_start] = ACTIONS(9603),
    [sym__binary_minus] = ACTIONS(9603),
    [sym__binary_star] = ACTIONS(9603),
    [anon_sym_LBRACE] = ACTIONS(9603),
    [anon_sym_DOT] = ACTIONS(9605),
    [anon_sym_COMMA] = ACTIONS(14909),
    [anon_sym_PIPE] = ACTIONS(9605),
    [anon_sym_SEMI] = ACTIONS(9603),
    [anon_sym_STAR_STAR] = ACTIONS(9605),
    [anon_sym_AMP] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(9605),
    [anon_sym_LT] = ACTIONS(9605),
    [anon_sym_do] = ACTIONS(9603),
    [anon_sym_LBRACK] = ACTIONS(9603),
    [anon_sym_COLON_COLON2] = ACTIONS(9603),
    [anon_sym_AMP_DOT] = ACTIONS(9603),
    [anon_sym_PLUS_EQ] = ACTIONS(9603),
    [anon_sym_DASH_EQ] = ACTIONS(9603),
    [anon_sym_STAR_EQ] = ACTIONS(9603),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9603),
    [anon_sym_SLASH_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_PIPE_EQ] = ACTIONS(9603),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9603),
    [anon_sym_AMP_EQ] = ACTIONS(9603),
    [anon_sym_PERCENT_EQ] = ACTIONS(9603),
    [anon_sym_GT_GT_EQ] = ACTIONS(9603),
    [anon_sym_LT_LT_EQ] = ACTIONS(9603),
    [anon_sym_CARET_EQ] = ACTIONS(9603),
    [anon_sym_QMARK] = ACTIONS(9603),
    [anon_sym_DOT_DOT] = ACTIONS(9605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9603),
    [anon_sym_and] = ACTIONS(9603),
    [anon_sym_or] = ACTIONS(9603),
    [anon_sym_PIPE_PIPE] = ACTIONS(9605),
    [anon_sym_AMP_AMP] = ACTIONS(9605),
    [anon_sym_LT_LT] = ACTIONS(9605),
    [anon_sym_GT_GT] = ACTIONS(9605),
    [anon_sym_EQ_EQ] = ACTIONS(9605),
    [anon_sym_BANG_EQ] = ACTIONS(9603),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9603),
    [anon_sym_LT_EQ_GT] = ACTIONS(9603),
    [anon_sym_EQ_TILDE] = ACTIONS(9603),
    [anon_sym_BANG_TILDE] = ACTIONS(9603),
    [anon_sym_LT_EQ] = ACTIONS(9605),
    [anon_sym_GT] = ACTIONS(9605),
    [anon_sym_GT_EQ] = ACTIONS(9603),
    [anon_sym_CARET] = ACTIONS(9605),
    [anon_sym_PLUS] = ACTIONS(9605),
    [anon_sym_SLASH] = ACTIONS(9605),
    [anon_sym_PERCENT] = ACTIONS(9605),
    [sym_comment] = ACTIONS(87),
  },
  [11087] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(14100),
    [sym__binary_star] = ACTIONS(14102),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(14104),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_AMP] = ACTIONS(14108),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(14110),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_EQ_GT] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(14112),
    [anon_sym_DOT_DOT] = ACTIONS(14114),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14116),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(14118),
    [anon_sym_AMP_AMP] = ACTIONS(14118),
    [anon_sym_LT_LT] = ACTIONS(14120),
    [anon_sym_GT_GT] = ACTIONS(14120),
    [anon_sym_EQ_EQ] = ACTIONS(14118),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14110),
    [anon_sym_GT] = ACTIONS(14110),
    [anon_sym_GT_EQ] = ACTIONS(14124),
    [anon_sym_CARET] = ACTIONS(14104),
    [anon_sym_PLUS] = ACTIONS(14126),
    [anon_sym_SLASH] = ACTIONS(14106),
    [anon_sym_PERCENT] = ACTIONS(14106),
    [sym_comment] = ACTIONS(87),
  },
  [11088] = {
    [aux_sym_exceptions_repeat1] = STATE(11088),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14911),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_EQ_GT] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [11089] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(14390),
    [sym__binary_star] = ACTIONS(14392),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(14394),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(14392),
    [anon_sym_AMP] = ACTIONS(14396),
    [anon_sym_LT] = ACTIONS(14398),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_when] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(14400),
    [anon_sym_DOT_DOT] = ACTIONS(14402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14404),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(14406),
    [anon_sym_AMP_AMP] = ACTIONS(14406),
    [anon_sym_LT_LT] = ACTIONS(14408),
    [anon_sym_GT_GT] = ACTIONS(14408),
    [anon_sym_EQ_EQ] = ACTIONS(14410),
    [anon_sym_BANG_EQ] = ACTIONS(14406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14406),
    [anon_sym_LT_EQ_GT] = ACTIONS(14406),
    [anon_sym_EQ_TILDE] = ACTIONS(14406),
    [anon_sym_BANG_TILDE] = ACTIONS(14406),
    [anon_sym_LT_EQ] = ACTIONS(14398),
    [anon_sym_GT] = ACTIONS(14398),
    [anon_sym_GT_EQ] = ACTIONS(14412),
    [anon_sym_CARET] = ACTIONS(14414),
    [anon_sym_PLUS] = ACTIONS(14390),
    [anon_sym_SLASH] = ACTIONS(14392),
    [anon_sym_PERCENT] = ACTIONS(14392),
    [sym_comment] = ACTIONS(87),
  },
  [11090] = {
    [aux_sym_exceptions_repeat1] = STATE(11090),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14914),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_when] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [11091] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(14445),
    [sym__binary_star] = ACTIONS(14447),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(14449),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(14451),
    [anon_sym_AMP] = ACTIONS(14453),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(14455),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_when] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(14457),
    [anon_sym_DOT_DOT] = ACTIONS(14459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14461),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(14463),
    [anon_sym_AMP_AMP] = ACTIONS(14463),
    [anon_sym_LT_LT] = ACTIONS(14465),
    [anon_sym_GT_GT] = ACTIONS(14465),
    [anon_sym_EQ_EQ] = ACTIONS(14463),
    [anon_sym_BANG_EQ] = ACTIONS(14467),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14467),
    [anon_sym_LT_EQ_GT] = ACTIONS(14467),
    [anon_sym_EQ_TILDE] = ACTIONS(14467),
    [anon_sym_BANG_TILDE] = ACTIONS(14467),
    [anon_sym_LT_EQ] = ACTIONS(14455),
    [anon_sym_GT] = ACTIONS(14455),
    [anon_sym_GT_EQ] = ACTIONS(14469),
    [anon_sym_CARET] = ACTIONS(14449),
    [anon_sym_PLUS] = ACTIONS(14471),
    [anon_sym_SLASH] = ACTIONS(14451),
    [anon_sym_PERCENT] = ACTIONS(14451),
    [sym_comment] = ACTIONS(87),
  },
  [11092] = {
    [aux_sym_exceptions_repeat1] = STATE(11092),
    [sym__line_break] = ACTIONS(11211),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14917),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_unless] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [anon_sym_until] = ACTIONS(11211),
    [anon_sym_rescue] = ACTIONS(11211),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_when] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
  [11093] = {
    [sym__line_break] = ACTIONS(11746),
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(14481),
    [sym__binary_star] = ACTIONS(14483),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(14485),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(14483),
    [anon_sym_AMP] = ACTIONS(14487),
    [anon_sym_LT] = ACTIONS(14489),
    [anon_sym_end] = ACTIONS(11746),
    [anon_sym_if] = ACTIONS(11746),
    [anon_sym_unless] = ACTIONS(11746),
    [anon_sym_while] = ACTIONS(11746),
    [anon_sym_until] = ACTIONS(11746),
    [anon_sym_rescue] = ACTIONS(11746),
    [anon_sym_when] = ACTIONS(11746),
    [anon_sym_else] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(14491),
    [anon_sym_DOT_DOT] = ACTIONS(14493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14495),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(14497),
    [anon_sym_AMP_AMP] = ACTIONS(14497),
    [anon_sym_LT_LT] = ACTIONS(14499),
    [anon_sym_GT_GT] = ACTIONS(14499),
    [anon_sym_EQ_EQ] = ACTIONS(14501),
    [anon_sym_BANG_EQ] = ACTIONS(14497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14497),
    [anon_sym_LT_EQ_GT] = ACTIONS(14497),
    [anon_sym_EQ_TILDE] = ACTIONS(14497),
    [anon_sym_BANG_TILDE] = ACTIONS(14497),
    [anon_sym_LT_EQ] = ACTIONS(14489),
    [anon_sym_GT] = ACTIONS(14489),
    [anon_sym_GT_EQ] = ACTIONS(14503),
    [anon_sym_CARET] = ACTIONS(14505),
    [anon_sym_PLUS] = ACTIONS(14481),
    [anon_sym_SLASH] = ACTIONS(14483),
    [anon_sym_PERCENT] = ACTIONS(14483),
    [sym_comment] = ACTIONS(87),
  },
  [11094] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(14573),
    [sym__binary_star] = ACTIONS(14575),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(14577),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(14575),
    [anon_sym_AMP] = ACTIONS(14579),
    [anon_sym_LT] = ACTIONS(14581),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(14583),
    [anon_sym_DOT_DOT] = ACTIONS(14585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14587),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(14589),
    [anon_sym_AMP_AMP] = ACTIONS(14589),
    [anon_sym_LT_LT] = ACTIONS(14591),
    [anon_sym_GT_GT] = ACTIONS(14591),
    [anon_sym_EQ_EQ] = ACTIONS(14593),
    [anon_sym_BANG_EQ] = ACTIONS(14589),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14589),
    [anon_sym_LT_EQ_GT] = ACTIONS(14589),
    [anon_sym_EQ_TILDE] = ACTIONS(14589),
    [anon_sym_BANG_TILDE] = ACTIONS(14589),
    [anon_sym_LT_EQ] = ACTIONS(14581),
    [anon_sym_GT] = ACTIONS(14581),
    [anon_sym_GT_EQ] = ACTIONS(14595),
    [anon_sym_CARET] = ACTIONS(14597),
    [anon_sym_PLUS] = ACTIONS(14573),
    [anon_sym_SLASH] = ACTIONS(14575),
    [anon_sym_PERCENT] = ACTIONS(14575),
    [sym_comment] = ACTIONS(87),
  },
  [11095] = {
    [aux_sym_exceptions_repeat1] = STATE(11095),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14920),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11211),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11211),
    [anon_sym_AMP_AMP] = ACTIONS(11211),
    [anon_sym_LT_LT] = ACTIONS(11211),
    [anon_sym_GT_GT] = ACTIONS(11211),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11211),
    [anon_sym_PLUS] = ACTIONS(11211),
    [anon_sym_SLASH] = ACTIONS(11211),
    [anon_sym_PERCENT] = ACTIONS(11211),
    [sym_comment] = ACTIONS(87),
  },
  [11096] = {
    [sym__heredoc_body_start] = ACTIONS(11746),
    [sym__binary_minus] = ACTIONS(14625),
    [sym__binary_star] = ACTIONS(14627),
    [anon_sym_LBRACE] = ACTIONS(11746),
    [anon_sym_DOT] = ACTIONS(12409),
    [anon_sym_COMMA] = ACTIONS(11746),
    [anon_sym_PIPE] = ACTIONS(14629),
    [anon_sym_SEMI] = ACTIONS(11746),
    [anon_sym_STAR_STAR] = ACTIONS(14631),
    [anon_sym_AMP] = ACTIONS(14633),
    [anon_sym_EQ] = ACTIONS(12409),
    [anon_sym_LT] = ACTIONS(14635),
    [anon_sym_do] = ACTIONS(11746),
    [anon_sym_LBRACK] = ACTIONS(11746),
    [anon_sym_COLON_COLON2] = ACTIONS(11746),
    [anon_sym_AMP_DOT] = ACTIONS(11746),
    [anon_sym_PLUS_EQ] = ACTIONS(11746),
    [anon_sym_DASH_EQ] = ACTIONS(11746),
    [anon_sym_STAR_EQ] = ACTIONS(11746),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11746),
    [anon_sym_SLASH_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_PIPE_EQ] = ACTIONS(11746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11746),
    [anon_sym_AMP_EQ] = ACTIONS(11746),
    [anon_sym_PERCENT_EQ] = ACTIONS(11746),
    [anon_sym_GT_GT_EQ] = ACTIONS(11746),
    [anon_sym_LT_LT_EQ] = ACTIONS(11746),
    [anon_sym_CARET_EQ] = ACTIONS(11746),
    [anon_sym_QMARK] = ACTIONS(14637),
    [anon_sym_DOT_DOT] = ACTIONS(14639),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14641),
    [anon_sym_and] = ACTIONS(11746),
    [anon_sym_or] = ACTIONS(11746),
    [anon_sym_PIPE_PIPE] = ACTIONS(14643),
    [anon_sym_AMP_AMP] = ACTIONS(14643),
    [anon_sym_LT_LT] = ACTIONS(14645),
    [anon_sym_GT_GT] = ACTIONS(14645),
    [anon_sym_EQ_EQ] = ACTIONS(14643),
    [anon_sym_BANG_EQ] = ACTIONS(14647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14647),
    [anon_sym_LT_EQ_GT] = ACTIONS(14647),
    [anon_sym_EQ_TILDE] = ACTIONS(14647),
    [anon_sym_BANG_TILDE] = ACTIONS(14647),
    [anon_sym_LT_EQ] = ACTIONS(14635),
    [anon_sym_GT] = ACTIONS(14635),
    [anon_sym_GT_EQ] = ACTIONS(14649),
    [anon_sym_CARET] = ACTIONS(14629),
    [anon_sym_PLUS] = ACTIONS(14651),
    [anon_sym_SLASH] = ACTIONS(14631),
    [anon_sym_PERCENT] = ACTIONS(14631),
    [sym_comment] = ACTIONS(87),
  },
  [11097] = {
    [aux_sym_exceptions_repeat1] = STATE(11097),
    [sym__heredoc_body_start] = ACTIONS(11211),
    [sym__binary_minus] = ACTIONS(11211),
    [sym__binary_star] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOT] = ACTIONS(11972),
    [anon_sym_COMMA] = ACTIONS(14923),
    [anon_sym_PIPE] = ACTIONS(11972),
    [anon_sym_SEMI] = ACTIONS(11211),
    [anon_sym_STAR_STAR] = ACTIONS(11972),
    [anon_sym_AMP] = ACTIONS(11972),
    [anon_sym_EQ] = ACTIONS(11972),
    [anon_sym_LT] = ACTIONS(11972),
    [anon_sym_do] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_COLON_COLON2] = ACTIONS(11211),
    [anon_sym_AMP_DOT] = ACTIONS(11211),
    [anon_sym_PLUS_EQ] = ACTIONS(11211),
    [anon_sym_DASH_EQ] = ACTIONS(11211),
    [anon_sym_STAR_EQ] = ACTIONS(11211),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11211),
    [anon_sym_SLASH_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_PIPE_EQ] = ACTIONS(11211),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11211),
    [anon_sym_AMP_EQ] = ACTIONS(11211),
    [anon_sym_PERCENT_EQ] = ACTIONS(11211),
    [anon_sym_GT_GT_EQ] = ACTIONS(11211),
    [anon_sym_LT_LT_EQ] = ACTIONS(11211),
    [anon_sym_CARET_EQ] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_DOT_DOT] = ACTIONS(11972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_and] = ACTIONS(11211),
    [anon_sym_or] = ACTIONS(11211),
    [anon_sym_PIPE_PIPE] = ACTIONS(11972),
    [anon_sym_AMP_AMP] = ACTIONS(11972),
    [anon_sym_LT_LT] = ACTIONS(11972),
    [anon_sym_GT_GT] = ACTIONS(11972),
    [anon_sym_EQ_EQ] = ACTIONS(11972),
    [anon_sym_BANG_EQ] = ACTIONS(11211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11211),
    [anon_sym_LT_EQ_GT] = ACTIONS(11211),
    [anon_sym_EQ_TILDE] = ACTIONS(11211),
    [anon_sym_BANG_TILDE] = ACTIONS(11211),
    [anon_sym_LT_EQ] = ACTIONS(11972),
    [anon_sym_GT] = ACTIONS(11972),
    [anon_sym_GT_EQ] = ACTIONS(11211),
    [anon_sym_CARET] = ACTIONS(11972),
    [anon_sym_PLUS] = ACTIONS(11972),
    [anon_sym_SLASH] = ACTIONS(11972),
    [anon_sym_PERCENT] = ACTIONS(11972),
    [sym_comment] = ACTIONS(87),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, SHIFT(4),
  [11] = {.count = 1, .reusable = true}, SHIFT(5),
  [13] = {.count = 1, .reusable = true}, SHIFT(6),
  [15] = {.count = 1, .reusable = true}, SHIFT(7),
  [17] = {.count = 1, .reusable = true}, SHIFT(8),
  [19] = {.count = 1, .reusable = true}, SHIFT(47),
  [21] = {.count = 1, .reusable = true}, SHIFT(9),
  [23] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [25] = {.count = 1, .reusable = false}, SHIFT(10),
  [27] = {.count = 1, .reusable = false}, SHIFT(11),
  [29] = {.count = 1, .reusable = true}, SHIFT(12),
  [31] = {.count = 1, .reusable = false}, SHIFT(13),
  [33] = {.count = 1, .reusable = false}, SHIFT(14),
  [35] = {.count = 1, .reusable = true}, SHIFT(15),
  [37] = {.count = 1, .reusable = true}, SHIFT(16),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = true}, SHIFT(18),
  [43] = {.count = 1, .reusable = false}, SHIFT(19),
  [45] = {.count = 1, .reusable = false}, SHIFT(20),
  [47] = {.count = 1, .reusable = false}, SHIFT(21),
  [49] = {.count = 1, .reusable = false}, SHIFT(22),
  [51] = {.count = 1, .reusable = false}, SHIFT(23),
  [53] = {.count = 1, .reusable = false}, SHIFT(24),
  [55] = {.count = 1, .reusable = false}, SHIFT(47),
  [57] = {.count = 1, .reusable = false}, SHIFT(25),
  [59] = {.count = 1, .reusable = false}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(27),
  [63] = {.count = 1, .reusable = false}, SHIFT(28),
  [65] = {.count = 1, .reusable = false}, SHIFT(29),
  [67] = {.count = 1, .reusable = false}, SHIFT(30),
  [69] = {.count = 1, .reusable = false}, SHIFT(31),
  [71] = {.count = 1, .reusable = false}, SHIFT(9),
  [73] = {.count = 1, .reusable = true}, SHIFT(32),
  [75] = {.count = 1, .reusable = false}, SHIFT(32),
  [77] = {.count = 1, .reusable = true}, SHIFT(33),
  [79] = {.count = 1, .reusable = false}, SHIFT(48),
  [81] = {.count = 1, .reusable = true}, SHIFT(48),
  [83] = {.count = 1, .reusable = false}, SHIFT(34),
  [85] = {.count = 1, .reusable = false}, SHIFT(35),
  [87] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [89] = {.count = 1, .reusable = false}, SHIFT(36),
  [91] = {.count = 1, .reusable = false}, SHIFT(37),
  [93] = {.count = 1, .reusable = false}, SHIFT(38),
  [95] = {.count = 1, .reusable = false}, SHIFT(39),
  [97] = {.count = 1, .reusable = true}, SHIFT(40),
  [99] = {.count = 1, .reusable = true}, SHIFT(41),
  [101] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 1),
  [103] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 1),
  [105] = {.count = 1, .reusable = true}, SHIFT(57),
  [107] = {.count = 1, .reusable = true}, SHIFT(54),
  [109] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [111] = {.count = 1, .reusable = false}, SHIFT(55),
  [113] = {.count = 1, .reusable = true}, SHIFT(58),
  [115] = {.count = 1, .reusable = true}, SHIFT(60),
  [117] = {.count = 1, .reusable = true}, SHIFT(62),
  [119] = {.count = 1, .reusable = true}, SHIFT(68),
  [121] = {.count = 1, .reusable = true}, SHIFT(64),
  [123] = {.count = 1, .reusable = false}, SHIFT(65),
  [125] = {.count = 1, .reusable = false}, SHIFT(66),
  [127] = {.count = 1, .reusable = false}, SHIFT(68),
  [129] = {.count = 1, .reusable = true}, SHIFT(69),
  [131] = {.count = 1, .reusable = false}, SHIFT(70),
  [133] = {.count = 1, .reusable = true}, SHIFT(73),
  [135] = {.count = 1, .reusable = true}, SHIFT(74),
  [137] = {.count = 1, .reusable = true}, SHIFT(75),
  [139] = {.count = 1, .reusable = true}, SHIFT(76),
  [141] = {.count = 1, .reusable = true}, SHIFT(77),
  [143] = {.count = 1, .reusable = true}, SHIFT(78),
  [145] = {.count = 1, .reusable = true}, SHIFT(79),
  [147] = {.count = 1, .reusable = true}, SHIFT(80),
  [149] = {.count = 1, .reusable = true}, SHIFT(81),
  [151] = {.count = 1, .reusable = true}, SHIFT(82),
  [153] = {.count = 1, .reusable = true}, SHIFT(114),
  [155] = {.count = 1, .reusable = true}, SHIFT(83),
  [157] = {.count = 1, .reusable = true}, SHIFT(84),
  [159] = {.count = 1, .reusable = true}, SHIFT(85),
  [161] = {.count = 1, .reusable = true}, SHIFT(86),
  [163] = {.count = 1, .reusable = false}, SHIFT(87),
  [165] = {.count = 1, .reusable = true}, SHIFT(88),
  [167] = {.count = 1, .reusable = true}, SHIFT(89),
  [169] = {.count = 1, .reusable = false}, SHIFT(18),
  [171] = {.count = 1, .reusable = true}, SHIFT(90),
  [173] = {.count = 1, .reusable = false}, SHIFT(91),
  [175] = {.count = 1, .reusable = false}, SHIFT(92),
  [177] = {.count = 1, .reusable = false}, SHIFT(93),
  [179] = {.count = 1, .reusable = false}, SHIFT(94),
  [181] = {.count = 1, .reusable = false}, SHIFT(95),
  [183] = {.count = 1, .reusable = false}, SHIFT(96),
  [185] = {.count = 1, .reusable = false}, SHIFT(114),
  [187] = {.count = 1, .reusable = false}, SHIFT(97),
  [189] = {.count = 1, .reusable = false}, SHIFT(98),
  [191] = {.count = 1, .reusable = false}, SHIFT(99),
  [193] = {.count = 1, .reusable = false}, SHIFT(100),
  [195] = {.count = 1, .reusable = false}, SHIFT(101),
  [197] = {.count = 1, .reusable = false}, SHIFT(102),
  [199] = {.count = 1, .reusable = false}, SHIFT(103),
  [201] = {.count = 1, .reusable = false}, SHIFT(83),
  [203] = {.count = 1, .reusable = true}, SHIFT(104),
  [205] = {.count = 1, .reusable = false}, SHIFT(104),
  [207] = {.count = 1, .reusable = true}, SHIFT(105),
  [209] = {.count = 1, .reusable = false}, SHIFT(106),
  [211] = {.count = 1, .reusable = true}, SHIFT(115),
  [213] = {.count = 1, .reusable = false}, SHIFT(107),
  [215] = {.count = 1, .reusable = false}, SHIFT(115),
  [217] = {.count = 1, .reusable = false}, SHIFT(108),
  [219] = {.count = 1, .reusable = false}, SHIFT(109),
  [221] = {.count = 1, .reusable = false}, SHIFT(110),
  [223] = {.count = 1, .reusable = true}, SHIFT(111),
  [225] = {.count = 1, .reusable = true}, SHIFT(112),
  [227] = {.count = 1, .reusable = true}, SHIFT(123),
  [229] = {.count = 1, .reusable = true}, SHIFT(124),
  [231] = {.count = 1, .reusable = true}, SHIFT(125),
  [233] = {.count = 1, .reusable = true}, SHIFT(126),
  [235] = {.count = 1, .reusable = true}, SHIFT(127),
  [237] = {.count = 1, .reusable = false}, SHIFT(127),
  [239] = {.count = 1, .reusable = true}, SHIFT(128),
  [241] = {.count = 1, .reusable = false}, SHIFT(129),
  [243] = {.count = 1, .reusable = false}, SHIFT(131),
  [245] = {.count = 1, .reusable = true}, SHIFT(133),
  [247] = {.count = 1, .reusable = true}, SHIFT(134),
  [249] = {.count = 1, .reusable = true}, SHIFT(135),
  [251] = {.count = 1, .reusable = false}, SHIFT(136),
  [253] = {.count = 1, .reusable = false}, SHIFT(137),
  [255] = {.count = 1, .reusable = false}, SHIFT(138),
  [257] = {.count = 1, .reusable = false}, SHIFT(139),
  [259] = {.count = 1, .reusable = false}, SHIFT(133),
  [261] = {.count = 1, .reusable = true}, SHIFT(140),
  [263] = {.count = 1, .reusable = false}, SHIFT(140),
  [265] = {.count = 1, .reusable = true}, SHIFT(141),
  [267] = {.count = 1, .reusable = false}, SHIFT(147),
  [269] = {.count = 1, .reusable = true}, SHIFT(147),
  [271] = {.count = 1, .reusable = false}, SHIFT(142),
  [273] = {.count = 1, .reusable = true}, SHIFT(153),
  [275] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [277] = {.count = 1, .reusable = true}, SHIFT(154),
  [279] = {.count = 1, .reusable = true}, SHIFT(155),
  [281] = {.count = 1, .reusable = true}, SHIFT(156),
  [283] = {.count = 1, .reusable = true}, SHIFT(157),
  [285] = {.count = 1, .reusable = true}, SHIFT(158),
  [287] = {.count = 1, .reusable = true}, SHIFT(159),
  [289] = {.count = 1, .reusable = true}, SHIFT(160),
  [291] = {.count = 1, .reusable = true}, SHIFT(184),
  [293] = {.count = 1, .reusable = true}, SHIFT(161),
  [295] = {.count = 1, .reusable = false}, SHIFT(162),
  [297] = {.count = 1, .reusable = true}, SHIFT(163),
  [299] = {.count = 1, .reusable = true}, SHIFT(164),
  [301] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 1),
  [303] = {.count = 1, .reusable = false}, SHIFT(165),
  [305] = {.count = 1, .reusable = false}, SHIFT(166),
  [307] = {.count = 1, .reusable = false}, SHIFT(167),
  [309] = {.count = 1, .reusable = false}, SHIFT(168),
  [311] = {.count = 1, .reusable = false}, SHIFT(169),
  [313] = {.count = 1, .reusable = false}, SHIFT(170),
  [315] = {.count = 1, .reusable = false}, SHIFT(184),
  [317] = {.count = 1, .reusable = false}, SHIFT(171),
  [319] = {.count = 1, .reusable = false}, SHIFT(172),
  [321] = {.count = 1, .reusable = false}, SHIFT(173),
  [323] = {.count = 1, .reusable = false}, SHIFT(174),
  [325] = {.count = 1, .reusable = false}, SHIFT(175),
  [327] = {.count = 1, .reusable = false}, SHIFT(176),
  [329] = {.count = 1, .reusable = false}, SHIFT(177),
  [331] = {.count = 1, .reusable = false}, SHIFT(185),
  [333] = {.count = 1, .reusable = true}, SHIFT(185),
  [335] = {.count = 1, .reusable = false}, SHIFT(178),
  [337] = {.count = 1, .reusable = false}, SHIFT(179),
  [339] = {.count = 1, .reusable = false}, SHIFT(180),
  [341] = {.count = 1, .reusable = false}, SHIFT(181),
  [343] = {.count = 1, .reusable = true}, SHIFT(182),
  [345] = {.count = 1, .reusable = true}, SHIFT(183),
  [347] = {.count = 1, .reusable = true}, SHIFT(191),
  [349] = {.count = 1, .reusable = true}, SHIFT(188),
  [351] = {.count = 1, .reusable = true}, SHIFT(189),
  [353] = {.count = 1, .reusable = false}, SHIFT(191),
  [355] = {.count = 1, .reusable = false}, SHIFT(190),
  [357] = {.count = 1, .reusable = false}, SHIFT(193),
  [359] = {.count = 1, .reusable = true}, SHIFT(193),
  [361] = {.count = 1, .reusable = false}, SHIFT(194),
  [363] = {.count = 1, .reusable = true}, REDUCE(sym_return, 1),
  [365] = {.count = 1, .reusable = true}, SHIFT(214),
  [367] = {.count = 1, .reusable = true}, SHIFT(196),
  [369] = {.count = 1, .reusable = true}, SHIFT(197),
  [371] = {.count = 1, .reusable = true}, SHIFT(198),
  [373] = {.count = 1, .reusable = true}, SHIFT(199),
  [375] = {.count = 1, .reusable = false}, REDUCE(sym_return, 1),
  [377] = {.count = 1, .reusable = false}, SHIFT(15),
  [379] = {.count = 1, .reusable = false}, SHIFT(200),
  [381] = {.count = 1, .reusable = false}, SHIFT(202),
  [383] = {.count = 1, .reusable = false}, SHIFT(203),
  [385] = {.count = 1, .reusable = false}, SHIFT(204),
  [387] = {.count = 1, .reusable = false}, SHIFT(205),
  [389] = {.count = 1, .reusable = false}, SHIFT(214),
  [391] = {.count = 1, .reusable = true}, SHIFT(206),
  [393] = {.count = 1, .reusable = true}, SHIFT(207),
  [395] = {.count = 1, .reusable = false}, SHIFT(207),
  [397] = {.count = 1, .reusable = false}, SHIFT(208),
  [399] = {.count = 1, .reusable = true}, SHIFT(208),
  [401] = {.count = 1, .reusable = false}, SHIFT(209),
  [403] = {.count = 1, .reusable = true}, SHIFT(215),
  [405] = {.count = 1, .reusable = false}, SHIFT(215),
  [407] = {.count = 1, .reusable = false}, SHIFT(210),
  [409] = {.count = 1, .reusable = false}, SHIFT(211),
  [411] = {.count = 1, .reusable = false}, SHIFT(212),
  [413] = {.count = 1, .reusable = false}, SHIFT(40),
  [415] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [417] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 1),
  [419] = {.count = 1, .reusable = true}, REDUCE(sym_break, 1),
  [421] = {.count = 1, .reusable = false}, REDUCE(sym_break, 1),
  [423] = {.count = 1, .reusable = true}, REDUCE(sym_next, 1),
  [425] = {.count = 1, .reusable = false}, REDUCE(sym_next, 1),
  [427] = {.count = 1, .reusable = true}, SHIFT(225),
  [429] = {.count = 1, .reusable = false}, SHIFT(226),
  [431] = {.count = 1, .reusable = false}, SHIFT(227),
  [433] = {.count = 1, .reusable = false}, SHIFT(228),
  [435] = {.count = 1, .reusable = false}, SHIFT(229),
  [437] = {.count = 1, .reusable = false}, SHIFT(225),
  [439] = {.count = 1, .reusable = true}, SHIFT(230),
  [441] = {.count = 1, .reusable = false}, SHIFT(230),
  [443] = {.count = 1, .reusable = true}, SHIFT(231),
  [445] = {.count = 1, .reusable = false}, SHIFT(235),
  [447] = {.count = 1, .reusable = true}, SHIFT(235),
  [449] = {.count = 1, .reusable = false}, SHIFT(232),
  [451] = {.count = 1, .reusable = true}, SHIFT(240),
  [453] = {.count = 1, .reusable = false}, SHIFT(241),
  [455] = {.count = 1, .reusable = false}, SHIFT(242),
  [457] = {.count = 1, .reusable = false}, SHIFT(243),
  [459] = {.count = 1, .reusable = false}, SHIFT(244),
  [461] = {.count = 1, .reusable = false}, SHIFT(240),
  [463] = {.count = 1, .reusable = true}, SHIFT(245),
  [465] = {.count = 1, .reusable = false}, SHIFT(245),
  [467] = {.count = 1, .reusable = true}, SHIFT(246),
  [469] = {.count = 1, .reusable = false}, SHIFT(248),
  [471] = {.count = 1, .reusable = true}, SHIFT(248),
  [473] = {.count = 1, .reusable = true}, SHIFT(253),
  [475] = {.count = 1, .reusable = true}, SHIFT(254),
  [477] = {.count = 1, .reusable = false}, SHIFT(255),
  [479] = {.count = 1, .reusable = true}, SHIFT(255),
  [481] = {.count = 1, .reusable = true}, SHIFT(271),
  [483] = {.count = 1, .reusable = true}, SHIFT(259),
  [485] = {.count = 1, .reusable = false}, SHIFT(260),
  [487] = {.count = 1, .reusable = false}, SHIFT(261),
  [489] = {.count = 1, .reusable = false}, SHIFT(262),
  [491] = {.count = 1, .reusable = false}, SHIFT(263),
  [493] = {.count = 1, .reusable = false}, SHIFT(259),
  [495] = {.count = 1, .reusable = true}, SHIFT(264),
  [497] = {.count = 1, .reusable = false}, SHIFT(264),
  [499] = {.count = 1, .reusable = true}, SHIFT(265),
  [501] = {.count = 1, .reusable = false}, SHIFT(267),
  [503] = {.count = 1, .reusable = true}, SHIFT(267),
  [505] = {.count = 1, .reusable = true}, SHIFT(297),
  [507] = {.count = 1, .reusable = true}, SHIFT(272),
  [509] = {.count = 1, .reusable = true}, SHIFT(273),
  [511] = {.count = 1, .reusable = true}, SHIFT(274),
  [513] = {.count = 1, .reusable = false}, SHIFT(291),
  [515] = {.count = 1, .reusable = false}, SHIFT(275),
  [517] = {.count = 1, .reusable = false}, SHIFT(276),
  [519] = {.count = 1, .reusable = false}, SHIFT(277),
  [521] = {.count = 1, .reusable = false}, SHIFT(278),
  [523] = {.count = 1, .reusable = false}, SHIFT(279),
  [525] = {.count = 1, .reusable = false}, SHIFT(280),
  [527] = {.count = 1, .reusable = false}, SHIFT(281),
  [529] = {.count = 1, .reusable = false}, SHIFT(273),
  [531] = {.count = 1, .reusable = true}, SHIFT(282),
  [533] = {.count = 1, .reusable = false}, SHIFT(282),
  [535] = {.count = 1, .reusable = true}, SHIFT(283),
  [537] = {.count = 1, .reusable = false}, SHIFT(293),
  [539] = {.count = 1, .reusable = true}, SHIFT(293),
  [541] = {.count = 1, .reusable = false}, SHIFT(284),
  [543] = {.count = 1, .reusable = true}, SHIFT(301),
  [545] = {.count = 1, .reusable = true}, SHIFT(300),
  [547] = {.count = 1, .reusable = true}, SHIFT(302),
  [549] = {.count = 1, .reusable = true}, SHIFT(303),
  [551] = {.count = 1, .reusable = true}, SHIFT(304),
  [553] = {.count = 1, .reusable = false}, SHIFT(304),
  [555] = {.count = 1, .reusable = true}, SHIFT(306),
  [557] = {.count = 1, .reusable = true}, SHIFT(305),
  [559] = {.count = 1, .reusable = true}, REDUCE(sym__primary, 1),
  [561] = {.count = 1, .reusable = false}, REDUCE(sym__primary, 1),
  [563] = {.count = 1, .reusable = false}, SHIFT(307),
  [565] = {.count = 1, .reusable = true}, REDUCE(sym_true, 1),
  [567] = {.count = 1, .reusable = false}, REDUCE(sym_true, 1),
  [569] = {.count = 1, .reusable = true}, REDUCE(sym_false, 1),
  [571] = {.count = 1, .reusable = false}, REDUCE(sym_false, 1),
  [573] = {.count = 1, .reusable = true}, REDUCE(sym_nil, 1),
  [575] = {.count = 1, .reusable = false}, REDUCE(sym_nil, 1),
  [577] = {.count = 1, .reusable = true}, SHIFT(308),
  [579] = {.count = 1, .reusable = true}, SHIFT(309),
  [581] = {.count = 1, .reusable = true}, SHIFT(310),
  [583] = {.count = 1, .reusable = true}, SHIFT(311),
  [585] = {.count = 1, .reusable = true}, SHIFT(312),
  [587] = {.count = 1, .reusable = true}, SHIFT(313),
  [589] = {.count = 1, .reusable = true}, SHIFT(314),
  [591] = {.count = 1, .reusable = true}, SHIFT(348),
  [593] = {.count = 1, .reusable = true}, SHIFT(315),
  [595] = {.count = 1, .reusable = true}, SHIFT(316),
  [597] = {.count = 1, .reusable = true}, SHIFT(317),
  [599] = {.count = 1, .reusable = true}, SHIFT(318),
  [601] = {.count = 1, .reusable = true}, SHIFT(319),
  [603] = {.count = 1, .reusable = false}, SHIFT(320),
  [605] = {.count = 1, .reusable = true}, SHIFT(321),
  [607] = {.count = 1, .reusable = true}, SHIFT(322),
  [609] = {.count = 1, .reusable = true}, SHIFT(323),
  [611] = {.count = 1, .reusable = false}, SHIFT(324),
  [613] = {.count = 1, .reusable = false}, SHIFT(325),
  [615] = {.count = 1, .reusable = false}, SHIFT(326),
  [617] = {.count = 1, .reusable = false}, SHIFT(327),
  [619] = {.count = 1, .reusable = false}, SHIFT(328),
  [621] = {.count = 1, .reusable = false}, SHIFT(329),
  [623] = {.count = 1, .reusable = false}, SHIFT(348),
  [625] = {.count = 1, .reusable = false}, SHIFT(330),
  [627] = {.count = 1, .reusable = false}, SHIFT(331),
  [629] = {.count = 1, .reusable = false}, SHIFT(332),
  [631] = {.count = 1, .reusable = false}, SHIFT(333),
  [633] = {.count = 1, .reusable = false}, SHIFT(334),
  [635] = {.count = 1, .reusable = false}, SHIFT(335),
  [637] = {.count = 1, .reusable = false}, SHIFT(336),
  [639] = {.count = 1, .reusable = true}, SHIFT(337),
  [641] = {.count = 1, .reusable = false}, SHIFT(317),
  [643] = {.count = 1, .reusable = true}, SHIFT(338),
  [645] = {.count = 1, .reusable = false}, SHIFT(338),
  [647] = {.count = 1, .reusable = true}, SHIFT(339),
  [649] = {.count = 1, .reusable = false}, SHIFT(340),
  [651] = {.count = 1, .reusable = true}, SHIFT(349),
  [653] = {.count = 1, .reusable = false}, SHIFT(341),
  [655] = {.count = 1, .reusable = false}, SHIFT(349),
  [657] = {.count = 1, .reusable = false}, SHIFT(342),
  [659] = {.count = 1, .reusable = false}, SHIFT(343),
  [661] = {.count = 1, .reusable = false}, SHIFT(344),
  [663] = {.count = 1, .reusable = true}, SHIFT(345),
  [665] = {.count = 1, .reusable = true}, SHIFT(346),
  [667] = {.count = 1, .reusable = true}, SHIFT(356),
  [669] = {.count = 1, .reusable = true}, SHIFT(357),
  [671] = {.count = 1, .reusable = false}, SHIFT(358),
  [673] = {.count = 1, .reusable = true}, SHIFT(359),
  [675] = {.count = 1, .reusable = true}, SHIFT(360),
  [677] = {.count = 1, .reusable = false}, SHIFT(361),
  [679] = {.count = 1, .reusable = false}, SHIFT(362),
  [681] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [683] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [685] = {.count = 1, .reusable = true}, SHIFT(366),
  [687] = {.count = 1, .reusable = true}, SHIFT(367),
  [689] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [691] = {.count = 1, .reusable = true}, REDUCE(sym__top_level_statement, 1),
  [693] = {.count = 1, .reusable = true}, SHIFT(369),
  [695] = {.count = 1, .reusable = true}, SHIFT(370),
  [697] = {.count = 1, .reusable = true}, SHIFT(371),
  [699] = {.count = 1, .reusable = true}, SHIFT(372),
  [701] = {.count = 1, .reusable = true}, SHIFT(373),
  [703] = {.count = 1, .reusable = true}, REDUCE(sym__statement, 1),
  [705] = {.count = 1, .reusable = true}, SHIFT(374),
  [707] = {.count = 1, .reusable = true}, SHIFT(375),
  [709] = {.count = 1, .reusable = false}, SHIFT(376),
  [711] = {.count = 1, .reusable = false}, SHIFT(377),
  [713] = {.count = 1, .reusable = false}, SHIFT(378),
  [715] = {.count = 1, .reusable = true}, SHIFT(379),
  [717] = {.count = 1, .reusable = false}, SHIFT(380),
  [719] = {.count = 1, .reusable = true}, SHIFT(380),
  [721] = {.count = 1, .reusable = true}, SHIFT(381),
  [723] = {.count = 1, .reusable = true}, SHIFT(382),
  [725] = {.count = 1, .reusable = true}, SHIFT(383),
  [727] = {.count = 1, .reusable = false}, SHIFT(382),
  [729] = {.count = 1, .reusable = true}, SHIFT(378),
  [731] = {.count = 1, .reusable = true}, SHIFT(376),
  [733] = {.count = 1, .reusable = true}, REDUCE(sym__arg, 1),
  [735] = {.count = 1, .reusable = false}, SHIFT(384),
  [737] = {.count = 1, .reusable = false}, REDUCE(sym__arg, 1),
  [739] = {.count = 1, .reusable = true}, SHIFT(385),
  [741] = {.count = 1, .reusable = true}, SHIFT(386),
  [743] = {.count = 1, .reusable = true}, SHIFT(384),
  [745] = {.count = 1, .reusable = true}, REDUCE(sym__lhs, 1),
  [747] = {.count = 1, .reusable = true}, SHIFT(387),
  [749] = {.count = 1, .reusable = true}, SHIFT(388),
  [751] = {.count = 1, .reusable = true}, SHIFT(389),
  [753] = {.count = 1, .reusable = true}, SHIFT(390),
  [755] = {.count = 1, .reusable = true}, SHIFT(391),
  [757] = {.count = 1, .reusable = true}, SHIFT(392),
  [759] = {.count = 1, .reusable = true}, SHIFT(393),
  [761] = {.count = 1, .reusable = true}, SHIFT(424),
  [763] = {.count = 1, .reusable = true}, SHIFT(394),
  [765] = {.count = 1, .reusable = true}, SHIFT(395),
  [767] = {.count = 1, .reusable = true}, SHIFT(396),
  [769] = {.count = 1, .reusable = true}, SHIFT(397),
  [771] = {.count = 1, .reusable = false}, REDUCE(sym__lhs, 1),
  [773] = {.count = 1, .reusable = true}, SHIFT(398),
  [775] = {.count = 1, .reusable = false}, SHIFT(399),
  [777] = {.count = 1, .reusable = false}, SHIFT(400),
  [779] = {.count = 1, .reusable = false}, SHIFT(402),
  [781] = {.count = 1, .reusable = false}, SHIFT(403),
  [783] = {.count = 1, .reusable = false}, SHIFT(404),
  [785] = {.count = 1, .reusable = false}, SHIFT(405),
  [787] = {.count = 1, .reusable = false}, SHIFT(406),
  [789] = {.count = 1, .reusable = false}, SHIFT(407),
  [791] = {.count = 1, .reusable = false}, SHIFT(424),
  [793] = {.count = 1, .reusable = false}, SHIFT(412),
  [795] = {.count = 1, .reusable = false}, SHIFT(413),
  [797] = {.count = 1, .reusable = false}, SHIFT(414),
  [799] = {.count = 1, .reusable = false}, SHIFT(415),
  [801] = {.count = 1, .reusable = true}, SHIFT(416),
  [803] = {.count = 1, .reusable = true}, SHIFT(417),
  [805] = {.count = 1, .reusable = false}, SHIFT(417),
  [807] = {.count = 1, .reusable = false}, SHIFT(418),
  [809] = {.count = 1, .reusable = true}, SHIFT(418),
  [811] = {.count = 1, .reusable = false}, SHIFT(419),
  [813] = {.count = 1, .reusable = true}, SHIFT(425),
  [815] = {.count = 1, .reusable = false}, SHIFT(420),
  [817] = {.count = 1, .reusable = false}, SHIFT(425),
  [819] = {.count = 1, .reusable = false}, SHIFT(421),
  [821] = {.count = 1, .reusable = true}, SHIFT(422),
  [823] = {.count = 1, .reusable = true}, SHIFT(433),
  [825] = {.count = 1, .reusable = true}, REDUCE(sym_left_assignment_list, 1),
  [827] = {.count = 1, .reusable = true}, SHIFT(434),
  [829] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 1),
  [831] = {.count = 1, .reusable = true}, REDUCE(sym__simple_mlhs, 1),
  [833] = {.count = 1, .reusable = false}, SHIFT(433),
  [835] = {.count = 1, .reusable = true}, SHIFT(435),
  [837] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2, .alias_sequence_id = 1),
  [839] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2, .alias_sequence_id = 1),
  [841] = {.count = 1, .reusable = true}, SHIFT(453),
  [843] = {.count = 1, .reusable = true}, SHIFT(437),
  [845] = {.count = 1, .reusable = true}, SHIFT(438),
  [847] = {.count = 1, .reusable = true}, SHIFT(439),
  [849] = {.count = 1, .reusable = false}, SHIFT(440),
  [851] = {.count = 1, .reusable = false}, SHIFT(441),
  [853] = {.count = 1, .reusable = false}, SHIFT(442),
  [855] = {.count = 1, .reusable = false}, SHIFT(443),
  [857] = {.count = 1, .reusable = false}, SHIFT(453),
  [859] = {.count = 1, .reusable = false}, SHIFT(437),
  [861] = {.count = 1, .reusable = true}, SHIFT(444),
  [863] = {.count = 1, .reusable = false}, SHIFT(444),
  [865] = {.count = 1, .reusable = true}, SHIFT(445),
  [867] = {.count = 1, .reusable = false}, SHIFT(454),
  [869] = {.count = 1, .reusable = true}, SHIFT(454),
  [871] = {.count = 1, .reusable = false}, SHIFT(446),
  [873] = {.count = 1, .reusable = false}, SHIFT(447),
  [875] = {.count = 1, .reusable = false}, SHIFT(448),
  [877] = {.count = 1, .reusable = false}, SHIFT(449),
  [879] = {.count = 1, .reusable = false}, SHIFT(450),
  [881] = {.count = 1, .reusable = true}, SHIFT(458),
  [883] = {.count = 1, .reusable = true}, SHIFT(459),
  [885] = {.count = 1, .reusable = true}, REDUCE(sym__literal_contents, 1),
  [887] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 2, .alias_sequence_id = 1),
  [889] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 2, .alias_sequence_id = 1),
  [891] = {.count = 1, .reusable = true}, SHIFT(460),
  [893] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 2, .alias_sequence_id = 2),
  [895] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 2, .alias_sequence_id = 2),
  [897] = {.count = 1, .reusable = true}, SHIFT(461),
  [899] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 2, .alias_sequence_id = 3),
  [901] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 2, .alias_sequence_id = 3),
  [903] = {.count = 1, .reusable = true}, SHIFT(462),
  [905] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 2, .alias_sequence_id = 4),
  [907] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 2, .alias_sequence_id = 4),
  [909] = {.count = 1, .reusable = true}, SHIFT(464),
  [911] = {.count = 1, .reusable = false}, SHIFT(465),
  [913] = {.count = 1, .reusable = true}, SHIFT(467),
  [915] = {.count = 1, .reusable = true}, SHIFT(468),
  [917] = {.count = 1, .reusable = true}, SHIFT(470),
  [919] = {.count = 1, .reusable = false}, REDUCE(sym__literal_contents, 1),
  [921] = {.count = 1, .reusable = false}, SHIFT(470),
  [923] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 2, .alias_sequence_id = 4),
  [925] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 2, .alias_sequence_id = 4),
  [927] = {.count = 1, .reusable = true}, SHIFT(471),
  [929] = {.count = 1, .reusable = false}, SHIFT(472),
  [931] = {.count = 1, .reusable = true}, SHIFT(474),
  [933] = {.count = 1, .reusable = true}, SHIFT(475),
  [935] = {.count = 1, .reusable = true}, REDUCE(sym_unary, 2),
  [937] = {.count = 1, .reusable = false}, REDUCE(sym_unary, 2),
  [939] = {.count = 1, .reusable = false}, SHIFT(477),
  [941] = {.count = 1, .reusable = true}, SHIFT(478),
  [943] = {.count = 1, .reusable = true}, SHIFT(479),
  [945] = {.count = 1, .reusable = false}, SHIFT(480),
  [947] = {.count = 1, .reusable = false}, SHIFT(481),
  [949] = {.count = 1, .reusable = false}, SHIFT(482),
  [951] = {.count = 1, .reusable = false}, SHIFT(483),
  [953] = {.count = 1, .reusable = false}, SHIFT(478),
  [955] = {.count = 1, .reusable = true}, SHIFT(484),
  [957] = {.count = 1, .reusable = false}, SHIFT(484),
  [959] = {.count = 1, .reusable = true}, SHIFT(485),
  [961] = {.count = 1, .reusable = false}, SHIFT(491),
  [963] = {.count = 1, .reusable = true}, SHIFT(491),
  [965] = {.count = 1, .reusable = false}, SHIFT(486),
  [967] = {.count = 1, .reusable = true}, SHIFT(495),
  [969] = {.count = 1, .reusable = true}, SHIFT(497),
  [971] = {.count = 1, .reusable = true}, SHIFT(499),
  [973] = {.count = 1, .reusable = true}, SHIFT(501),
  [975] = {.count = 1, .reusable = true}, SHIFT(503),
  [977] = {.count = 1, .reusable = false}, SHIFT(504),
  [979] = {.count = 1, .reusable = true}, SHIFT(506),
  [981] = {.count = 1, .reusable = false}, SHIFT(507),
  [983] = {.count = 1, .reusable = true}, SHIFT(511),
  [985] = {.count = 1, .reusable = true}, SHIFT(509),
  [987] = {.count = 1, .reusable = false}, SHIFT(510),
  [989] = {.count = 1, .reusable = true}, SHIFT(514),
  [991] = {.count = 1, .reusable = true}, SHIFT(515),
  [993] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 2),
  [995] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 2),
  [997] = {.count = 1, .reusable = true}, SHIFT(518),
  [999] = {.count = 1, .reusable = false}, SHIFT(520),
  [1001] = {.count = 1, .reusable = true}, SHIFT(522),
  [1003] = {.count = 1, .reusable = true}, SHIFT(524),
  [1005] = {.count = 1, .reusable = true}, SHIFT(537),
  [1007] = {.count = 1, .reusable = true}, SHIFT(525),
  [1009] = {.count = 1, .reusable = true}, SHIFT(526),
  [1011] = {.count = 1, .reusable = false}, SHIFT(527),
  [1013] = {.count = 1, .reusable = false}, SHIFT(528),
  [1015] = {.count = 1, .reusable = false}, SHIFT(529),
  [1017] = {.count = 1, .reusable = false}, SHIFT(530),
  [1019] = {.count = 1, .reusable = false}, SHIFT(537),
  [1021] = {.count = 1, .reusable = false}, SHIFT(525),
  [1023] = {.count = 1, .reusable = true}, SHIFT(531),
  [1025] = {.count = 1, .reusable = false}, SHIFT(531),
  [1027] = {.count = 1, .reusable = true}, SHIFT(532),
  [1029] = {.count = 1, .reusable = false}, SHIFT(538),
  [1031] = {.count = 1, .reusable = true}, SHIFT(538),
  [1033] = {.count = 1, .reusable = false}, SHIFT(533),
  [1035] = {.count = 1, .reusable = false}, SHIFT(534),
  [1037] = {.count = 1, .reusable = false}, SHIFT(535),
  [1039] = {.count = 1, .reusable = true}, SHIFT(542),
  [1041] = {.count = 1, .reusable = false}, SHIFT(543),
  [1043] = {.count = 1, .reusable = false}, SHIFT(545),
  [1045] = {.count = 1, .reusable = true}, SHIFT(547),
  [1047] = {.count = 1, .reusable = true}, SHIFT(548),
  [1049] = {.count = 1, .reusable = true}, SHIFT(549),
  [1051] = {.count = 1, .reusable = true}, SHIFT(550),
  [1053] = {.count = 1, .reusable = false}, SHIFT(321),
  [1055] = {.count = 1, .reusable = false}, SHIFT(322),
  [1057] = {.count = 1, .reusable = false}, SHIFT(552),
  [1059] = {.count = 1, .reusable = false}, SHIFT(553),
  [1061] = {.count = 1, .reusable = false}, SHIFT(554),
  [1063] = {.count = 1, .reusable = false}, SHIFT(555),
  [1065] = {.count = 1, .reusable = true}, SHIFT(556),
  [1067] = {.count = 1, .reusable = true}, SHIFT(557),
  [1069] = {.count = 1, .reusable = false}, SHIFT(557),
  [1071] = {.count = 1, .reusable = false}, SHIFT(558),
  [1073] = {.count = 1, .reusable = true}, SHIFT(558),
  [1075] = {.count = 1, .reusable = false}, SHIFT(559),
  [1077] = {.count = 1, .reusable = true}, SHIFT(561),
  [1079] = {.count = 1, .reusable = false}, SHIFT(561),
  [1081] = {.count = 1, .reusable = false}, SHIFT(345),
  [1083] = {.count = 1, .reusable = true}, SHIFT(577),
  [1085] = {.count = 1, .reusable = true}, SHIFT(583),
  [1087] = {.count = 1, .reusable = false}, SHIFT(582),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym__variable, 1),
  [1091] = {.count = 1, .reusable = false}, REDUCE(sym__variable, 1),
  [1093] = {.count = 1, .reusable = false}, SHIFT(586),
  [1095] = {.count = 1, .reusable = false}, SHIFT(587),
  [1097] = {.count = 1, .reusable = true}, SHIFT(588),
  [1099] = {.count = 1, .reusable = true}, SHIFT(591),
  [1101] = {.count = 1, .reusable = false}, SHIFT(592),
  [1103] = {.count = 1, .reusable = true}, SHIFT(595),
  [1105] = {.count = 1, .reusable = true}, SHIFT(596),
  [1107] = {.count = 1, .reusable = false}, SHIFT(597),
  [1109] = {.count = 1, .reusable = false}, SHIFT(598),
  [1111] = {.count = 1, .reusable = false}, SHIFT(599),
  [1113] = {.count = 1, .reusable = true}, SHIFT(600),
  [1115] = {.count = 1, .reusable = false}, SHIFT(601),
  [1117] = {.count = 1, .reusable = true}, SHIFT(601),
  [1119] = {.count = 1, .reusable = true}, SHIFT(602),
  [1121] = {.count = 1, .reusable = true}, SHIFT(603),
  [1123] = {.count = 1, .reusable = true}, SHIFT(604),
  [1125] = {.count = 1, .reusable = false}, SHIFT(603),
  [1127] = {.count = 1, .reusable = true}, SHIFT(599),
  [1129] = {.count = 1, .reusable = true}, SHIFT(597),
  [1131] = {.count = 1, .reusable = false}, SHIFT(605),
  [1133] = {.count = 1, .reusable = true}, SHIFT(606),
  [1135] = {.count = 1, .reusable = true}, SHIFT(607),
  [1137] = {.count = 1, .reusable = true}, SHIFT(605),
  [1139] = {.count = 1, .reusable = true}, SHIFT(608),
  [1141] = {.count = 1, .reusable = true}, SHIFT(609),
  [1143] = {.count = 1, .reusable = true}, SHIFT(610),
  [1145] = {.count = 1, .reusable = true}, SHIFT(611),
  [1147] = {.count = 1, .reusable = true}, SHIFT(612),
  [1149] = {.count = 1, .reusable = true}, SHIFT(613),
  [1151] = {.count = 1, .reusable = true}, SHIFT(614),
  [1153] = {.count = 1, .reusable = true}, SHIFT(645),
  [1155] = {.count = 1, .reusable = true}, SHIFT(615),
  [1157] = {.count = 1, .reusable = true}, SHIFT(616),
  [1159] = {.count = 1, .reusable = true}, SHIFT(617),
  [1161] = {.count = 1, .reusable = true}, SHIFT(618),
  [1163] = {.count = 1, .reusable = true}, SHIFT(619),
  [1165] = {.count = 1, .reusable = false}, SHIFT(620),
  [1167] = {.count = 1, .reusable = false}, SHIFT(621),
  [1169] = {.count = 1, .reusable = false}, SHIFT(623),
  [1171] = {.count = 1, .reusable = false}, SHIFT(624),
  [1173] = {.count = 1, .reusable = false}, SHIFT(625),
  [1175] = {.count = 1, .reusable = false}, SHIFT(626),
  [1177] = {.count = 1, .reusable = false}, SHIFT(627),
  [1179] = {.count = 1, .reusable = false}, SHIFT(628),
  [1181] = {.count = 1, .reusable = false}, SHIFT(645),
  [1183] = {.count = 1, .reusable = false}, SHIFT(629),
  [1185] = {.count = 1, .reusable = false}, SHIFT(630),
  [1187] = {.count = 1, .reusable = false}, SHIFT(631),
  [1189] = {.count = 1, .reusable = false}, SHIFT(632),
  [1191] = {.count = 1, .reusable = false}, SHIFT(633),
  [1193] = {.count = 1, .reusable = false}, SHIFT(634),
  [1195] = {.count = 1, .reusable = false}, SHIFT(635),
  [1197] = {.count = 1, .reusable = false}, SHIFT(636),
  [1199] = {.count = 1, .reusable = true}, SHIFT(637),
  [1201] = {.count = 1, .reusable = true}, SHIFT(638),
  [1203] = {.count = 1, .reusable = false}, SHIFT(638),
  [1205] = {.count = 1, .reusable = false}, SHIFT(639),
  [1207] = {.count = 1, .reusable = true}, SHIFT(639),
  [1209] = {.count = 1, .reusable = false}, SHIFT(640),
  [1211] = {.count = 1, .reusable = true}, SHIFT(646),
  [1213] = {.count = 1, .reusable = false}, SHIFT(641),
  [1215] = {.count = 1, .reusable = false}, SHIFT(646),
  [1217] = {.count = 1, .reusable = false}, SHIFT(642),
  [1219] = {.count = 1, .reusable = true}, SHIFT(643),
  [1221] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 1),
  [1223] = {.count = 1, .reusable = true}, SHIFT(654),
  [1225] = {.count = 1, .reusable = false}, SHIFT(654),
  [1227] = {.count = 1, .reusable = true}, SHIFT(655),
  [1229] = {.count = 1, .reusable = false}, SHIFT(514),
  [1231] = {.count = 1, .reusable = true}, SHIFT(657),
  [1233] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 1),
  [1235] = {.count = 1, .reusable = true}, SHIFT(659),
  [1237] = {.count = 1, .reusable = true}, SHIFT(660),
  [1239] = {.count = 1, .reusable = true}, SHIFT(662),
  [1241] = {.count = 1, .reusable = true}, SHIFT(664),
  [1243] = {.count = 1, .reusable = false}, SHIFT(665),
  [1245] = {.count = 1, .reusable = false}, SHIFT(666),
  [1247] = {.count = 1, .reusable = false}, SHIFT(667),
  [1249] = {.count = 1, .reusable = false}, SHIFT(668),
  [1251] = {.count = 1, .reusable = false}, SHIFT(664),
  [1253] = {.count = 1, .reusable = true}, SHIFT(669),
  [1255] = {.count = 1, .reusable = false}, SHIFT(669),
  [1257] = {.count = 1, .reusable = true}, SHIFT(670),
  [1259] = {.count = 1, .reusable = false}, SHIFT(672),
  [1261] = {.count = 1, .reusable = true}, SHIFT(672),
  [1263] = {.count = 1, .reusable = true}, REDUCE(sym_operator, 1),
  [1265] = {.count = 1, .reusable = false}, REDUCE(sym_operator, 1),
  [1267] = {.count = 1, .reusable = true}, REDUCE(sym__method_name, 1),
  [1269] = {.count = 1, .reusable = false}, REDUCE(sym__method_name, 1),
  [1271] = {.count = 1, .reusable = true}, SHIFT(676),
  [1273] = {.count = 1, .reusable = true}, REDUCE(sym_method, 2),
  [1275] = {.count = 1, .reusable = false}, REDUCE(sym_method, 2),
  [1277] = {.count = 1, .reusable = true}, SHIFT(677),
  [1279] = {.count = 1, .reusable = true}, SHIFT(683),
  [1281] = {.count = 1, .reusable = true}, SHIFT(678),
  [1283] = {.count = 1, .reusable = false}, SHIFT(679),
  [1285] = {.count = 1, .reusable = true}, SHIFT(680),
  [1287] = {.count = 1, .reusable = true}, SHIFT(681),
  [1289] = {.count = 1, .reusable = true}, SHIFT(682),
  [1291] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 2),
  [1293] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 2),
  [1295] = {.count = 1, .reusable = false}, SHIFT(686),
  [1297] = {.count = 1, .reusable = true}, SHIFT(686),
  [1299] = {.count = 1, .reusable = true}, SHIFT(687),
  [1301] = {.count = 1, .reusable = true}, SHIFT(688),
  [1303] = {.count = 1, .reusable = true}, SHIFT(689),
  [1305] = {.count = 1, .reusable = true}, SHIFT(690),
  [1307] = {.count = 1, .reusable = false}, SHIFT(692),
  [1309] = {.count = 1, .reusable = false}, SHIFT(693),
  [1311] = {.count = 1, .reusable = false}, SHIFT(694),
  [1313] = {.count = 1, .reusable = false}, SHIFT(695),
  [1315] = {.count = 1, .reusable = true}, SHIFT(696),
  [1317] = {.count = 1, .reusable = false}, SHIFT(696),
  [1319] = {.count = 1, .reusable = false}, SHIFT(697),
  [1321] = {.count = 1, .reusable = true}, SHIFT(697),
  [1323] = {.count = 1, .reusable = false}, SHIFT(698),
  [1325] = {.count = 1, .reusable = true}, SHIFT(700),
  [1327] = {.count = 1, .reusable = false}, SHIFT(700),
  [1329] = {.count = 1, .reusable = true}, SHIFT(707),
  [1331] = {.count = 1, .reusable = true}, SHIFT(708),
  [1333] = {.count = 1, .reusable = true}, SHIFT(709),
  [1335] = {.count = 1, .reusable = true}, SHIFT(711),
  [1337] = {.count = 1, .reusable = true}, SHIFT(712),
  [1339] = {.count = 1, .reusable = true}, SHIFT(713),
  [1341] = {.count = 1, .reusable = true}, SHIFT(714),
  [1343] = {.count = 1, .reusable = true}, SHIFT(715),
  [1345] = {.count = 1, .reusable = true}, SHIFT(716),
  [1347] = {.count = 1, .reusable = true}, SHIFT(717),
  [1349] = {.count = 1, .reusable = false}, SHIFT(718),
  [1351] = {.count = 1, .reusable = false}, SHIFT(719),
  [1353] = {.count = 1, .reusable = false}, SHIFT(720),
  [1355] = {.count = 1, .reusable = true}, SHIFT(721),
  [1357] = {.count = 1, .reusable = false}, SHIFT(722),
  [1359] = {.count = 1, .reusable = true}, SHIFT(722),
  [1361] = {.count = 1, .reusable = true}, SHIFT(723),
  [1363] = {.count = 1, .reusable = true}, SHIFT(724),
  [1365] = {.count = 1, .reusable = true}, SHIFT(725),
  [1367] = {.count = 1, .reusable = false}, SHIFT(724),
  [1369] = {.count = 1, .reusable = true}, SHIFT(720),
  [1371] = {.count = 1, .reusable = true}, SHIFT(718),
  [1373] = {.count = 1, .reusable = true}, SHIFT(726),
  [1375] = {.count = 1, .reusable = true}, SHIFT(727),
  [1377] = {.count = 1, .reusable = true}, SHIFT(728),
  [1379] = {.count = 1, .reusable = true}, SHIFT(729),
  [1381] = {.count = 1, .reusable = false}, SHIFT(731),
  [1383] = {.count = 1, .reusable = false}, SHIFT(732),
  [1385] = {.count = 1, .reusable = false}, SHIFT(733),
  [1387] = {.count = 1, .reusable = false}, SHIFT(734),
  [1389] = {.count = 1, .reusable = true}, SHIFT(735),
  [1391] = {.count = 1, .reusable = false}, SHIFT(735),
  [1393] = {.count = 1, .reusable = false}, SHIFT(736),
  [1395] = {.count = 1, .reusable = true}, SHIFT(736),
  [1397] = {.count = 1, .reusable = false}, SHIFT(737),
  [1399] = {.count = 1, .reusable = true}, SHIFT(739),
  [1401] = {.count = 1, .reusable = false}, SHIFT(739),
  [1403] = {.count = 1, .reusable = true}, SHIFT(745),
  [1405] = {.count = 1, .reusable = true}, SHIFT(746),
  [1407] = {.count = 1, .reusable = true}, SHIFT(747),
  [1409] = {.count = 1, .reusable = false}, SHIFT(745),
  [1411] = {.count = 1, .reusable = true}, SHIFT(748),
  [1413] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 2),
  [1415] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 2),
  [1417] = {.count = 1, .reusable = true}, SHIFT(750),
  [1419] = {.count = 1, .reusable = true}, SHIFT(752),
  [1421] = {.count = 1, .reusable = true}, SHIFT(754),
  [1423] = {.count = 1, .reusable = true}, SHIFT(756),
  [1425] = {.count = 1, .reusable = true}, SHIFT(758),
  [1427] = {.count = 1, .reusable = false}, SHIFT(759),
  [1429] = {.count = 1, .reusable = true}, SHIFT(761),
  [1431] = {.count = 1, .reusable = false}, SHIFT(762),
  [1433] = {.count = 1, .reusable = true}, SHIFT(764),
  [1435] = {.count = 1, .reusable = true}, SHIFT(767),
  [1437] = {.count = 1, .reusable = false}, SHIFT(769),
  [1439] = {.count = 1, .reusable = true}, SHIFT(771),
  [1441] = {.count = 1, .reusable = true}, SHIFT(773),
  [1443] = {.count = 1, .reusable = true}, SHIFT(774),
  [1445] = {.count = 1, .reusable = false}, SHIFT(775),
  [1447] = {.count = 1, .reusable = false}, SHIFT(777),
  [1449] = {.count = 1, .reusable = true}, SHIFT(779),
  [1451] = {.count = 1, .reusable = true}, SHIFT(780),
  [1453] = {.count = 1, .reusable = true}, SHIFT(781),
  [1455] = {.count = 1, .reusable = true}, SHIFT(782),
  [1457] = {.count = 1, .reusable = true}, SHIFT(783),
  [1459] = {.count = 1, .reusable = false}, SHIFT(549),
  [1461] = {.count = 1, .reusable = false}, SHIFT(784),
  [1463] = {.count = 1, .reusable = true}, SHIFT(799),
  [1465] = {.count = 1, .reusable = true}, SHIFT(805),
  [1467] = {.count = 1, .reusable = false}, SHIFT(804),
  [1469] = {.count = 1, .reusable = true}, SHIFT(806),
  [1471] = {.count = 1, .reusable = true}, SHIFT(807),
  [1473] = {.count = 1, .reusable = true}, SHIFT(810),
  [1475] = {.count = 1, .reusable = false}, SHIFT(811),
  [1477] = {.count = 1, .reusable = true}, SHIFT(814),
  [1479] = {.count = 1, .reusable = true}, SHIFT(815),
  [1481] = {.count = 1, .reusable = true}, SHIFT(816),
  [1483] = {.count = 1, .reusable = true}, SHIFT(817),
  [1485] = {.count = 1, .reusable = true}, SHIFT(818),
  [1487] = {.count = 1, .reusable = true}, SHIFT(819),
  [1489] = {.count = 1, .reusable = true}, SHIFT(820),
  [1491] = {.count = 1, .reusable = true}, SHIFT(821),
  [1493] = {.count = 1, .reusable = true}, SHIFT(822),
  [1495] = {.count = 1, .reusable = false}, SHIFT(823),
  [1497] = {.count = 1, .reusable = false}, SHIFT(824),
  [1499] = {.count = 1, .reusable = false}, SHIFT(825),
  [1501] = {.count = 1, .reusable = false}, SHIFT(826),
  [1503] = {.count = 1, .reusable = false}, SHIFT(819),
  [1505] = {.count = 1, .reusable = true}, SHIFT(827),
  [1507] = {.count = 1, .reusable = false}, SHIFT(827),
  [1509] = {.count = 1, .reusable = true}, SHIFT(828),
  [1511] = {.count = 1, .reusable = false}, SHIFT(829),
  [1513] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 2),
  [1515] = {.count = 1, .reusable = true}, SHIFT(840),
  [1517] = {.count = 1, .reusable = true}, SHIFT(843),
  [1519] = {.count = 1, .reusable = true}, SHIFT(841),
  [1521] = {.count = 1, .reusable = true}, SHIFT(844),
  [1523] = {.count = 1, .reusable = true}, SHIFT(845),
  [1525] = {.count = 1, .reusable = true}, SHIFT(846),
  [1527] = {.count = 1, .reusable = true}, SHIFT(847),
  [1529] = {.count = 1, .reusable = true}, SHIFT(848),
  [1531] = {.count = 1, .reusable = true}, SHIFT(849),
  [1533] = {.count = 1, .reusable = true}, SHIFT(850),
  [1535] = {.count = 1, .reusable = false}, SHIFT(851),
  [1537] = {.count = 1, .reusable = false}, SHIFT(852),
  [1539] = {.count = 1, .reusable = false}, SHIFT(853),
  [1541] = {.count = 1, .reusable = false}, SHIFT(854),
  [1543] = {.count = 1, .reusable = false}, SHIFT(847),
  [1545] = {.count = 1, .reusable = true}, SHIFT(855),
  [1547] = {.count = 1, .reusable = false}, SHIFT(855),
  [1549] = {.count = 1, .reusable = true}, SHIFT(856),
  [1551] = {.count = 1, .reusable = false}, SHIFT(857),
  [1553] = {.count = 1, .reusable = true}, SHIFT(865),
  [1555] = {.count = 1, .reusable = false}, SHIFT(864),
  [1557] = {.count = 1, .reusable = true}, SHIFT(866),
  [1559] = {.count = 1, .reusable = false}, SHIFT(867),
  [1561] = {.count = 1, .reusable = false}, SHIFT(868),
  [1563] = {.count = 1, .reusable = false}, SHIFT(869),
  [1565] = {.count = 1, .reusable = false}, SHIFT(870),
  [1567] = {.count = 1, .reusable = false}, SHIFT(866),
  [1569] = {.count = 1, .reusable = true}, SHIFT(871),
  [1571] = {.count = 1, .reusable = false}, SHIFT(871),
  [1573] = {.count = 1, .reusable = true}, SHIFT(872),
  [1575] = {.count = 1, .reusable = true}, SHIFT(200),
  [1577] = {.count = 1, .reusable = false}, SHIFT(198),
  [1579] = {.count = 1, .reusable = true}, SHIFT(880),
  [1581] = {.count = 1, .reusable = true}, SHIFT(881),
  [1583] = {.count = 1, .reusable = true}, SHIFT(883),
  [1585] = {.count = 1, .reusable = true}, SHIFT(884),
  [1587] = {.count = 1, .reusable = true}, SHIFT(885),
  [1589] = {.count = 1, .reusable = false}, SHIFT(887),
  [1591] = {.count = 1, .reusable = true}, SHIFT(892),
  [1593] = {.count = 1, .reusable = true}, SHIFT(893),
  [1595] = {.count = 1, .reusable = true}, SHIFT(894),
  [1597] = {.count = 1, .reusable = true}, SHIFT(895),
  [1599] = {.count = 1, .reusable = true}, SHIFT(896),
  [1601] = {.count = 1, .reusable = true}, SHIFT(897),
  [1603] = {.count = 1, .reusable = false}, SHIFT(898),
  [1605] = {.count = 1, .reusable = false}, SHIFT(899),
  [1607] = {.count = 1, .reusable = false}, SHIFT(900),
  [1609] = {.count = 1, .reusable = false}, SHIFT(901),
  [1611] = {.count = 1, .reusable = false}, SHIFT(894),
  [1613] = {.count = 1, .reusable = true}, SHIFT(902),
  [1615] = {.count = 1, .reusable = false}, SHIFT(902),
  [1617] = {.count = 1, .reusable = true}, SHIFT(903),
  [1619] = {.count = 1, .reusable = false}, SHIFT(904),
  [1621] = {.count = 1, .reusable = true}, SHIFT(906),
  [1623] = {.count = 1, .reusable = false}, SHIFT(906),
  [1625] = {.count = 1, .reusable = false}, SHIFT(915),
  [1627] = {.count = 1, .reusable = true}, REDUCE(sym__argument, 1),
  [1629] = {.count = 1, .reusable = true}, SHIFT(916),
  [1631] = {.count = 1, .reusable = true}, SHIFT(917),
  [1633] = {.count = 1, .reusable = false}, REDUCE(sym__argument, 1),
  [1635] = {.count = 1, .reusable = false}, SHIFT(918),
  [1637] = {.count = 1, .reusable = false}, SHIFT(919),
  [1639] = {.count = 1, .reusable = false}, SHIFT(920),
  [1641] = {.count = 1, .reusable = true}, SHIFT(921),
  [1643] = {.count = 1, .reusable = false}, SHIFT(922),
  [1645] = {.count = 1, .reusable = true}, SHIFT(922),
  [1647] = {.count = 1, .reusable = true}, SHIFT(924),
  [1649] = {.count = 1, .reusable = true}, SHIFT(925),
  [1651] = {.count = 1, .reusable = false}, SHIFT(924),
  [1653] = {.count = 1, .reusable = true}, SHIFT(920),
  [1655] = {.count = 1, .reusable = true}, SHIFT(918),
  [1657] = {.count = 1, .reusable = false}, SHIFT(926),
  [1659] = {.count = 1, .reusable = true}, SHIFT(927),
  [1661] = {.count = 1, .reusable = true}, SHIFT(928),
  [1663] = {.count = 1, .reusable = true}, SHIFT(926),
  [1665] = {.count = 1, .reusable = true}, SHIFT(929),
  [1667] = {.count = 1, .reusable = true}, SHIFT(930),
  [1669] = {.count = 1, .reusable = true}, SHIFT(931),
  [1671] = {.count = 1, .reusable = true}, SHIFT(932),
  [1673] = {.count = 1, .reusable = false}, SHIFT(934),
  [1675] = {.count = 1, .reusable = true}, SHIFT(935),
  [1677] = {.count = 1, .reusable = false}, SHIFT(936),
  [1679] = {.count = 1, .reusable = true}, REDUCE(sym_return, 2),
  [1681] = {.count = 1, .reusable = false}, REDUCE(sym_return, 2),
  [1683] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 1),
  [1685] = {.count = 1, .reusable = true}, SHIFT(943),
  [1687] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 1),
  [1689] = {.count = 1, .reusable = true}, SHIFT(945),
  [1691] = {.count = 1, .reusable = true}, SHIFT(947),
  [1693] = {.count = 1, .reusable = false}, SHIFT(947),
  [1695] = {.count = 1, .reusable = true}, SHIFT(948),
  [1697] = {.count = 1, .reusable = false}, SHIFT(880),
  [1699] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [1701] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 2),
  [1703] = {.count = 1, .reusable = true}, REDUCE(sym_break, 2),
  [1705] = {.count = 1, .reusable = false}, REDUCE(sym_break, 2),
  [1707] = {.count = 1, .reusable = true}, REDUCE(sym_next, 2),
  [1709] = {.count = 1, .reusable = false}, REDUCE(sym_next, 2),
  [1711] = {.count = 1, .reusable = true}, SHIFT(951),
  [1713] = {.count = 1, .reusable = true}, SHIFT(952),
  [1715] = {.count = 1, .reusable = true}, SHIFT(953),
  [1717] = {.count = 1, .reusable = true}, SHIFT(954),
  [1719] = {.count = 1, .reusable = false}, SHIFT(956),
  [1721] = {.count = 1, .reusable = false}, SHIFT(957),
  [1723] = {.count = 1, .reusable = false}, SHIFT(958),
  [1725] = {.count = 1, .reusable = false}, SHIFT(959),
  [1727] = {.count = 1, .reusable = true}, SHIFT(960),
  [1729] = {.count = 1, .reusable = false}, SHIFT(960),
  [1731] = {.count = 1, .reusable = false}, SHIFT(961),
  [1733] = {.count = 1, .reusable = true}, SHIFT(961),
  [1735] = {.count = 1, .reusable = false}, SHIFT(962),
  [1737] = {.count = 1, .reusable = true}, SHIFT(964),
  [1739] = {.count = 1, .reusable = false}, SHIFT(964),
  [1741] = {.count = 1, .reusable = true}, SHIFT(971),
  [1743] = {.count = 1, .reusable = true}, SHIFT(979),
  [1745] = {.count = 1, .reusable = true}, SHIFT(972),
  [1747] = {.count = 1, .reusable = true}, SHIFT(973),
  [1749] = {.count = 1, .reusable = true}, SHIFT(974),
  [1751] = {.count = 1, .reusable = true}, SHIFT(975),
  [1753] = {.count = 1, .reusable = true}, SHIFT(976),
  [1755] = {.count = 1, .reusable = true}, SHIFT(977),
  [1757] = {.count = 1, .reusable = true}, SHIFT(978),
  [1759] = {.count = 1, .reusable = true}, SHIFT(980),
  [1761] = {.count = 1, .reusable = true}, SHIFT(981),
  [1763] = {.count = 1, .reusable = false}, SHIFT(982),
  [1765] = {.count = 1, .reusable = false}, SHIFT(983),
  [1767] = {.count = 1, .reusable = false}, SHIFT(984),
  [1769] = {.count = 1, .reusable = true}, SHIFT(985),
  [1771] = {.count = 1, .reusable = false}, SHIFT(986),
  [1773] = {.count = 1, .reusable = true}, SHIFT(986),
  [1775] = {.count = 1, .reusable = true}, SHIFT(987),
  [1777] = {.count = 1, .reusable = true}, SHIFT(988),
  [1779] = {.count = 1, .reusable = true}, SHIFT(989),
  [1781] = {.count = 1, .reusable = false}, SHIFT(988),
  [1783] = {.count = 1, .reusable = true}, SHIFT(984),
  [1785] = {.count = 1, .reusable = true}, SHIFT(982),
  [1787] = {.count = 1, .reusable = true}, SHIFT(990),
  [1789] = {.count = 1, .reusable = true}, SHIFT(991),
  [1791] = {.count = 1, .reusable = true}, SHIFT(992),
  [1793] = {.count = 1, .reusable = true}, SHIFT(993),
  [1795] = {.count = 1, .reusable = false}, SHIFT(995),
  [1797] = {.count = 1, .reusable = false}, SHIFT(996),
  [1799] = {.count = 1, .reusable = false}, SHIFT(997),
  [1801] = {.count = 1, .reusable = false}, SHIFT(998),
  [1803] = {.count = 1, .reusable = true}, SHIFT(999),
  [1805] = {.count = 1, .reusable = false}, SHIFT(999),
  [1807] = {.count = 1, .reusable = false}, SHIFT(1000),
  [1809] = {.count = 1, .reusable = true}, SHIFT(1000),
  [1811] = {.count = 1, .reusable = false}, SHIFT(1001),
  [1813] = {.count = 1, .reusable = true}, SHIFT(1003),
  [1815] = {.count = 1, .reusable = false}, SHIFT(1003),
  [1817] = {.count = 1, .reusable = true}, SHIFT(1009),
  [1819] = {.count = 1, .reusable = false}, SHIFT(1009),
  [1821] = {.count = 1, .reusable = true}, SHIFT(1010),
  [1823] = {.count = 1, .reusable = true}, SHIFT(1013),
  [1825] = {.count = 1, .reusable = true}, SHIFT(1012),
  [1827] = {.count = 1, .reusable = true}, SHIFT(1015),
  [1829] = {.count = 1, .reusable = true}, SHIFT(1016),
  [1831] = {.count = 1, .reusable = true}, SHIFT(1017),
  [1833] = {.count = 1, .reusable = true}, SHIFT(1018),
  [1835] = {.count = 1, .reusable = false}, SHIFT(1020),
  [1837] = {.count = 1, .reusable = false}, SHIFT(1021),
  [1839] = {.count = 1, .reusable = false}, SHIFT(1022),
  [1841] = {.count = 1, .reusable = false}, SHIFT(1023),
  [1843] = {.count = 1, .reusable = true}, SHIFT(1024),
  [1845] = {.count = 1, .reusable = false}, SHIFT(1024),
  [1847] = {.count = 1, .reusable = false}, SHIFT(1025),
  [1849] = {.count = 1, .reusable = true}, SHIFT(1025),
  [1851] = {.count = 1, .reusable = false}, SHIFT(1026),
  [1853] = {.count = 1, .reusable = true}, SHIFT(1028),
  [1855] = {.count = 1, .reusable = false}, SHIFT(1028),
  [1857] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1859] = {.count = 1, .reusable = true}, SHIFT(1035),
  [1861] = {.count = 1, .reusable = true}, SHIFT(1036),
  [1863] = {.count = 1, .reusable = false}, SHIFT(1037),
  [1865] = {.count = 1, .reusable = false}, SHIFT(1038),
  [1867] = {.count = 1, .reusable = false}, SHIFT(1039),
  [1869] = {.count = 1, .reusable = true}, SHIFT(1040),
  [1871] = {.count = 1, .reusable = false}, SHIFT(1041),
  [1873] = {.count = 1, .reusable = true}, SHIFT(1041),
  [1875] = {.count = 1, .reusable = true}, SHIFT(1042),
  [1877] = {.count = 1, .reusable = true}, SHIFT(1043),
  [1879] = {.count = 1, .reusable = true}, SHIFT(1044),
  [1881] = {.count = 1, .reusable = false}, SHIFT(1043),
  [1883] = {.count = 1, .reusable = true}, SHIFT(1039),
  [1885] = {.count = 1, .reusable = true}, SHIFT(1037),
  [1887] = {.count = 1, .reusable = true}, SHIFT(1046),
  [1889] = {.count = 1, .reusable = true}, SHIFT(1047),
  [1891] = {.count = 1, .reusable = true}, SHIFT(1048),
  [1893] = {.count = 1, .reusable = true}, SHIFT(1049),
  [1895] = {.count = 1, .reusable = true}, SHIFT(1050),
  [1897] = {.count = 1, .reusable = false}, SHIFT(1052),
  [1899] = {.count = 1, .reusable = false}, SHIFT(1053),
  [1901] = {.count = 1, .reusable = false}, SHIFT(1054),
  [1903] = {.count = 1, .reusable = false}, SHIFT(1055),
  [1905] = {.count = 1, .reusable = false}, SHIFT(408),
  [1907] = {.count = 1, .reusable = false}, SHIFT(409),
  [1909] = {.count = 1, .reusable = false}, SHIFT(410),
  [1911] = {.count = 1, .reusable = false}, SHIFT(411),
  [1913] = {.count = 1, .reusable = true}, SHIFT(1056),
  [1915] = {.count = 1, .reusable = false}, SHIFT(1056),
  [1917] = {.count = 1, .reusable = false}, SHIFT(1057),
  [1919] = {.count = 1, .reusable = true}, SHIFT(1057),
  [1921] = {.count = 1, .reusable = false}, SHIFT(1058),
  [1923] = {.count = 1, .reusable = true}, SHIFT(1060),
  [1925] = {.count = 1, .reusable = false}, SHIFT(1060),
  [1927] = {.count = 1, .reusable = true}, SHIFT(1067),
  [1929] = {.count = 1, .reusable = false}, SHIFT(1067),
  [1931] = {.count = 1, .reusable = true}, SHIFT(1068),
  [1933] = {.count = 1, .reusable = true}, SHIFT(1070),
  [1935] = {.count = 1, .reusable = false}, REDUCE(sym_rest_assignment, 1),
  [1937] = {.count = 1, .reusable = true}, SHIFT(1071),
  [1939] = {.count = 1, .reusable = true}, SHIFT(1072),
  [1941] = {.count = 1, .reusable = true}, SHIFT(1073),
  [1943] = {.count = 1, .reusable = true}, SHIFT(1074),
  [1945] = {.count = 1, .reusable = true}, SHIFT(1075),
  [1947] = {.count = 1, .reusable = false}, SHIFT(1076),
  [1949] = {.count = 1, .reusable = false}, SHIFT(1077),
  [1951] = {.count = 1, .reusable = false}, SHIFT(1078),
  [1953] = {.count = 1, .reusable = false}, SHIFT(1079),
  [1955] = {.count = 1, .reusable = false}, SHIFT(1073),
  [1957] = {.count = 1, .reusable = true}, SHIFT(1080),
  [1959] = {.count = 1, .reusable = false}, SHIFT(1080),
  [1961] = {.count = 1, .reusable = true}, SHIFT(1081),
  [1963] = {.count = 1, .reusable = false}, SHIFT(1082),
  [1965] = {.count = 1, .reusable = true}, SHIFT(1084),
  [1967] = {.count = 1, .reusable = false}, SHIFT(1084),
  [1969] = {.count = 1, .reusable = true}, SHIFT(1090),
  [1971] = {.count = 1, .reusable = true}, SHIFT(1092),
  [1973] = {.count = 1, .reusable = true}, SHIFT(1094),
  [1975] = {.count = 1, .reusable = true}, SHIFT(1095),
  [1977] = {.count = 1, .reusable = true}, SHIFT(1096),
  [1979] = {.count = 1, .reusable = true}, SHIFT(1097),
  [1981] = {.count = 1, .reusable = false}, SHIFT(1099),
  [1983] = {.count = 1, .reusable = false}, SHIFT(1100),
  [1985] = {.count = 1, .reusable = false}, SHIFT(1101),
  [1987] = {.count = 1, .reusable = false}, SHIFT(1102),
  [1989] = {.count = 1, .reusable = true}, SHIFT(1103),
  [1991] = {.count = 1, .reusable = false}, SHIFT(1103),
  [1993] = {.count = 1, .reusable = false}, SHIFT(1104),
  [1995] = {.count = 1, .reusable = true}, SHIFT(1104),
  [1997] = {.count = 1, .reusable = false}, SHIFT(1105),
  [1999] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2001] = {.count = 1, .reusable = false}, SHIFT(1107),
  [2003] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2005] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2007] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2009] = {.count = 1, .reusable = false}, SHIFT(1116),
  [2011] = {.count = 1, .reusable = false}, SHIFT(1117),
  [2013] = {.count = 1, .reusable = false}, SHIFT(1118),
  [2015] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2017] = {.count = 1, .reusable = false}, SHIFT(1120),
  [2019] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2021] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2023] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2025] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2027] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2029] = {.count = 1, .reusable = true}, SHIFT(1118),
  [2031] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2035] = {.count = 1, .reusable = false}, SHIFT(1125),
  [2037] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2039] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2041] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2043] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2045] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2047] = {.count = 1, .reusable = true}, REDUCE(sym__terminator, 1),
  [2049] = {.count = 1, .reusable = false}, REDUCE(sym__terminator, 1),
  [2051] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2053] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2055] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2057] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2059] = {.count = 1, .reusable = false}, SHIFT(1139),
  [2061] = {.count = 1, .reusable = false}, SHIFT(1140),
  [2063] = {.count = 1, .reusable = false}, SHIFT(1141),
  [2065] = {.count = 1, .reusable = false}, SHIFT(1142),
  [2067] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2069] = {.count = 1, .reusable = false}, SHIFT(1143),
  [2071] = {.count = 1, .reusable = false}, SHIFT(1144),
  [2073] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2075] = {.count = 1, .reusable = false}, SHIFT(1145),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2079] = {.count = 1, .reusable = false}, SHIFT(1147),
  [2081] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2083] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2085] = {.count = 1, .reusable = false}, SHIFT(1155),
  [2087] = {.count = 1, .reusable = false}, SHIFT(1156),
  [2089] = {.count = 1, .reusable = false}, SHIFT(1157),
  [2091] = {.count = 1, .reusable = false}, SHIFT(1158),
  [2093] = {.count = 1, .reusable = false}, SHIFT(1162),
  [2095] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2097] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2099] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2101] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2103] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2105] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2107] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2109] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2111] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2113] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2115] = {.count = 1, .reusable = false}, REDUCE(sym_else, 1),
  [2117] = {.count = 1, .reusable = false}, SHIFT(1173),
  [2119] = {.count = 1, .reusable = false}, SHIFT(1174),
  [2121] = {.count = 1, .reusable = false}, SHIFT(1175),
  [2123] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2125] = {.count = 1, .reusable = false}, SHIFT(1171),
  [2127] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2129] = {.count = 1, .reusable = false}, SHIFT(1177),
  [2131] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2133] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2135] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2137] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2139] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2141] = {.count = 1, .reusable = false}, REDUCE(sym_ensure, 1),
  [2143] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2145] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2147] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2149] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2151] = {.count = 1, .reusable = false}, SHIFT(1189),
  [2153] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2155] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2157] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2159] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2161] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2163] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2165] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2167] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2169] = {.count = 1, .reusable = true}, SHIFT(279),
  [2171] = {.count = 1, .reusable = true}, SHIFT(280),
  [2173] = {.count = 1, .reusable = true}, SHIFT(281),
  [2175] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2177] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2179] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2181] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2183] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2187] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 2),
  [2189] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 2),
  [2191] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2193] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2195] = {.count = 1, .reusable = false}, SHIFT(1220),
  [2197] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2199] = {.count = 1, .reusable = false}, SHIFT(1222),
  [2201] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2203] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2205] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2207] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2209] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2211] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2213] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2215] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2217] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2219] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2221] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2223] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2225] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2227] = {.count = 1, .reusable = false}, SHIFT(1233),
  [2229] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2231] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2233] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2235] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2237] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2239] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2241] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2243] = {.count = 1, .reusable = false}, SHIFT(1239),
  [2245] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2247] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2249] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2251] = {.count = 1, .reusable = false}, SHIFT(1247),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2255] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2257] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 2),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2261] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2263] = {.count = 1, .reusable = false}, SHIFT(1255),
  [2265] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2267] = {.count = 1, .reusable = true}, REDUCE(sym_rational, 2),
  [2269] = {.count = 1, .reusable = false}, REDUCE(sym_rational, 2),
  [2271] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2273] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2275] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2277] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2279] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2281] = {.count = 1, .reusable = false}, SHIFT(1266),
  [2283] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2285] = {.count = 1, .reusable = false}, SHIFT(1269),
  [2287] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2289] = {.count = 1, .reusable = false}, SHIFT(1272),
  [2291] = {.count = 1, .reusable = false}, SHIFT(1273),
  [2293] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2295] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2297] = {.count = 1, .reusable = false}, SHIFT(1271),
  [2299] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2301] = {.count = 1, .reusable = false}, SHIFT(1276),
  [2303] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2305] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2307] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2309] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2311] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2315] = {.count = 1, .reusable = false}, SHIFT(1292),
  [2317] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2319] = {.count = 1, .reusable = true}, SHIFT(1296),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2323] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2325] = {.count = 1, .reusable = false}, SHIFT(1301),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2331] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2333] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2335] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2337] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2339] = {.count = 1, .reusable = false}, SHIFT(1309),
  [2341] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2343] = {.count = 1, .reusable = false}, SHIFT(1310),
  [2345] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2349] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2351] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2353] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2355] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2357] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2359] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1341),
  [2363] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2365] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2367] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2369] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2371] = {.count = 1, .reusable = false}, SHIFT(1348),
  [2373] = {.count = 1, .reusable = false}, SHIFT(1349),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2377] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2379] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2381] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2383] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2387] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2389] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2391] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2393] = {.count = 1, .reusable = false}, SHIFT(1355),
  [2395] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2397] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2399] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2401] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2403] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2405] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2407] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2409] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2411] = {.count = 1, .reusable = false}, SHIFT(1364),
  [2413] = {.count = 1, .reusable = false}, SHIFT(1365),
  [2415] = {.count = 1, .reusable = false}, SHIFT(1366),
  [2417] = {.count = 1, .reusable = false}, SHIFT(1367),
  [2419] = {.count = 1, .reusable = false}, SHIFT(1368),
  [2421] = {.count = 1, .reusable = true}, SHIFT(1369),
  [2423] = {.count = 1, .reusable = false}, SHIFT(1369),
  [2425] = {.count = 1, .reusable = false}, SHIFT(1370),
  [2427] = {.count = 1, .reusable = true}, SHIFT(1370),
  [2429] = {.count = 1, .reusable = false}, SHIFT(1371),
  [2431] = {.count = 1, .reusable = true}, SHIFT(1373),
  [2433] = {.count = 1, .reusable = false}, SHIFT(1373),
  [2435] = {.count = 1, .reusable = true}, SHIFT(1381),
  [2437] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 1),
  [2439] = {.count = 1, .reusable = true}, SHIFT(1383),
  [2441] = {.count = 1, .reusable = true}, SHIFT(1384),
  [2443] = {.count = 1, .reusable = false}, SHIFT(1384),
  [2445] = {.count = 1, .reusable = true}, SHIFT(1385),
  [2447] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2449] = {.count = 1, .reusable = true}, SHIFT(1387),
  [2451] = {.count = 1, .reusable = true}, SHIFT(1388),
  [2453] = {.count = 1, .reusable = true}, SHIFT(1391),
  [2455] = {.count = 1, .reusable = true}, SHIFT(1392),
  [2457] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2459] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 1),
  [2461] = {.count = 1, .reusable = false}, REDUCE(sym_splat_parameter, 1),
  [2463] = {.count = 1, .reusable = false}, SHIFT(1395),
  [2465] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 1),
  [2467] = {.count = 1, .reusable = false}, REDUCE(sym_hash_splat_parameter, 1),
  [2469] = {.count = 1, .reusable = false}, SHIFT(1396),
  [2471] = {.count = 1, .reusable = true}, SHIFT(1397),
  [2473] = {.count = 1, .reusable = true}, SHIFT(1402),
  [2475] = {.count = 1, .reusable = true}, SHIFT(1398),
  [2477] = {.count = 1, .reusable = false}, SHIFT(1399),
  [2479] = {.count = 1, .reusable = true}, REDUCE(sym__simple_formal_parameter, 1),
  [2481] = {.count = 1, .reusable = true}, SHIFT(1403),
  [2483] = {.count = 1, .reusable = true}, SHIFT(1404),
  [2485] = {.count = 1, .reusable = true}, SHIFT(361),
  [2487] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 1),
  [2489] = {.count = 1, .reusable = true}, SHIFT(1406),
  [2491] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 2),
  [2493] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 2),
  [2495] = {.count = 1, .reusable = true}, SHIFT(1408),
  [2497] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [2499] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 2),
  [2501] = {.count = 1, .reusable = true}, SHIFT(1410),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1422),
  [2505] = {.count = 1, .reusable = true}, SHIFT(1423),
  [2507] = {.count = 1, .reusable = false}, SHIFT(1424),
  [2509] = {.count = 1, .reusable = false}, SHIFT(1425),
  [2511] = {.count = 1, .reusable = false}, SHIFT(1426),
  [2513] = {.count = 1, .reusable = false}, SHIFT(1427),
  [2515] = {.count = 1, .reusable = false}, SHIFT(1423),
  [2517] = {.count = 1, .reusable = true}, SHIFT(1428),
  [2519] = {.count = 1, .reusable = false}, SHIFT(1428),
  [2521] = {.count = 1, .reusable = true}, SHIFT(1429),
  [2523] = {.count = 1, .reusable = false}, SHIFT(1431),
  [2525] = {.count = 1, .reusable = true}, SHIFT(1431),
  [2527] = {.count = 1, .reusable = true}, SHIFT(1439),
  [2529] = {.count = 1, .reusable = true}, SHIFT(1440),
  [2531] = {.count = 1, .reusable = false}, SHIFT(1440),
  [2533] = {.count = 1, .reusable = true}, SHIFT(1441),
  [2535] = {.count = 1, .reusable = true}, SHIFT(1442),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1445),
  [2539] = {.count = 1, .reusable = true}, SHIFT(1448),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1449),
  [2543] = {.count = 1, .reusable = true}, SHIFT(1451),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1453),
  [2547] = {.count = 1, .reusable = true}, SHIFT(1455),
  [2549] = {.count = 1, .reusable = true}, SHIFT(1457),
  [2551] = {.count = 1, .reusable = false}, SHIFT(1458),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1460),
  [2555] = {.count = 1, .reusable = false}, SHIFT(1461),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1463),
  [2559] = {.count = 1, .reusable = true}, SHIFT(1464),
  [2561] = {.count = 1, .reusable = true}, SHIFT(1465),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1466),
  [2565] = {.count = 1, .reusable = true}, SHIFT(1467),
  [2567] = {.count = 1, .reusable = true}, SHIFT(1468),
  [2569] = {.count = 1, .reusable = true}, SHIFT(1469),
  [2571] = {.count = 1, .reusable = true}, SHIFT(1493),
  [2573] = {.count = 1, .reusable = true}, SHIFT(1470),
  [2575] = {.count = 1, .reusable = true}, SHIFT(1471),
  [2577] = {.count = 1, .reusable = false}, SHIFT(1472),
  [2579] = {.count = 1, .reusable = true}, SHIFT(1473),
  [2581] = {.count = 1, .reusable = false}, SHIFT(1474),
  [2583] = {.count = 1, .reusable = false}, SHIFT(1475),
  [2585] = {.count = 1, .reusable = false}, SHIFT(1476),
  [2587] = {.count = 1, .reusable = false}, SHIFT(1477),
  [2589] = {.count = 1, .reusable = false}, SHIFT(1478),
  [2591] = {.count = 1, .reusable = false}, SHIFT(1479),
  [2593] = {.count = 1, .reusable = false}, SHIFT(1493),
  [2595] = {.count = 1, .reusable = false}, SHIFT(1480),
  [2597] = {.count = 1, .reusable = false}, SHIFT(1481),
  [2599] = {.count = 1, .reusable = false}, SHIFT(1482),
  [2601] = {.count = 1, .reusable = false}, SHIFT(1483),
  [2603] = {.count = 1, .reusable = false}, SHIFT(1484),
  [2605] = {.count = 1, .reusable = false}, SHIFT(1485),
  [2607] = {.count = 1, .reusable = false}, SHIFT(1486),
  [2609] = {.count = 1, .reusable = false}, SHIFT(1470),
  [2611] = {.count = 1, .reusable = true}, SHIFT(1487),
  [2613] = {.count = 1, .reusable = false}, SHIFT(1487),
  [2615] = {.count = 1, .reusable = true}, SHIFT(1488),
  [2617] = {.count = 1, .reusable = false}, SHIFT(1494),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1494),
  [2621] = {.count = 1, .reusable = false}, SHIFT(1489),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1490),
  [2625] = {.count = 1, .reusable = true}, SHIFT(1491),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1499),
  [2629] = {.count = 1, .reusable = true}, SHIFT(400),
  [2631] = {.count = 1, .reusable = false}, SHIFT(396),
  [2633] = {.count = 1, .reusable = true}, SHIFT(421),
  [2635] = {.count = 1, .reusable = true}, SHIFT(1502),
  [2637] = {.count = 1, .reusable = true}, SHIFT(1503),
  [2639] = {.count = 1, .reusable = true}, SHIFT(1504),
  [2641] = {.count = 1, .reusable = false}, SHIFT(1505),
  [2643] = {.count = 1, .reusable = false}, SHIFT(1506),
  [2645] = {.count = 1, .reusable = false}, SHIFT(1507),
  [2647] = {.count = 1, .reusable = false}, SHIFT(1508),
  [2649] = {.count = 1, .reusable = false}, SHIFT(1503),
  [2651] = {.count = 1, .reusable = true}, SHIFT(1509),
  [2653] = {.count = 1, .reusable = false}, SHIFT(1509),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1510),
  [2657] = {.count = 1, .reusable = false}, SHIFT(1511),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1515),
  [2661] = {.count = 1, .reusable = false}, SHIFT(1515),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1521),
  [2665] = {.count = 1, .reusable = false}, SHIFT(1523),
  [2667] = {.count = 1, .reusable = true}, SHIFT(1525),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1528),
  [2671] = {.count = 1, .reusable = false}, SHIFT(1529),
  [2673] = {.count = 1, .reusable = false}, SHIFT(1531),
  [2675] = {.count = 1, .reusable = true}, SHIFT(1545),
  [2677] = {.count = 1, .reusable = false}, SHIFT(1542),
  [2679] = {.count = 1, .reusable = true}, SHIFT(1547),
  [2681] = {.count = 1, .reusable = true}, SHIFT(1553),
  [2683] = {.count = 1, .reusable = false}, SHIFT(1552),
  [2685] = {.count = 1, .reusable = true}, SHIFT(1554),
  [2687] = {.count = 1, .reusable = false}, SHIFT(1559),
  [2689] = {.count = 1, .reusable = false}, SHIFT(1560),
  [2691] = {.count = 1, .reusable = true}, SHIFT(1561),
  [2693] = {.count = 1, .reusable = true}, SHIFT(1564),
  [2695] = {.count = 1, .reusable = true}, SHIFT(1567),
  [2697] = {.count = 1, .reusable = true}, SHIFT(1568),
  [2699] = {.count = 1, .reusable = false}, SHIFT(1569),
  [2701] = {.count = 1, .reusable = false}, SHIFT(1568),
  [2703] = {.count = 1, .reusable = false}, SHIFT(1570),
  [2705] = {.count = 1, .reusable = false}, SHIFT(1571),
  [2707] = {.count = 1, .reusable = true}, SHIFT(1572),
  [2709] = {.count = 1, .reusable = false}, SHIFT(1573),
  [2711] = {.count = 1, .reusable = true}, SHIFT(1573),
  [2713] = {.count = 1, .reusable = false}, SHIFT(1575),
  [2715] = {.count = 1, .reusable = false}, SHIFT(1576),
  [2717] = {.count = 1, .reusable = true}, SHIFT(1575),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1571),
  [2721] = {.count = 1, .reusable = false}, SHIFT(1567),
  [2723] = {.count = 1, .reusable = true}, SHIFT(1577),
  [2725] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 2),
  [2727] = {.count = 1, .reusable = true}, SHIFT(1579),
  [2729] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 2),
  [2731] = {.count = 1, .reusable = true}, SHIFT(413),
  [2733] = {.count = 1, .reusable = true}, SHIFT(1581),
  [2735] = {.count = 1, .reusable = true}, SHIFT(1583),
  [2737] = {.count = 1, .reusable = true}, SHIFT(1585),
  [2739] = {.count = 1, .reusable = false}, SHIFT(1585),
  [2741] = {.count = 1, .reusable = true}, SHIFT(1586),
  [2743] = {.count = 1, .reusable = false}, SHIFT(1502),
  [2745] = {.count = 1, .reusable = true}, SHIFT(1588),
  [2747] = {.count = 1, .reusable = true}, SHIFT(1589),
  [2749] = {.count = 1, .reusable = false}, SHIFT(1589),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1590),
  [2753] = {.count = 1, .reusable = false}, SHIFT(1590),
  [2755] = {.count = 1, .reusable = true}, SHIFT(1591),
  [2757] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 2),
  [2759] = {.count = 1, .reusable = true}, REDUCE(sym_chained_string, 2),
  [2761] = {.count = 1, .reusable = false}, REDUCE(sym_chained_string, 2),
  [2763] = {.count = 1, .reusable = true}, SHIFT(1601),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1602),
  [2767] = {.count = 1, .reusable = true}, SHIFT(1603),
  [2769] = {.count = 1, .reusable = true}, SHIFT(1604),
  [2771] = {.count = 1, .reusable = true}, SHIFT(1605),
  [2773] = {.count = 1, .reusable = false}, SHIFT(1607),
  [2775] = {.count = 1, .reusable = false}, SHIFT(1608),
  [2777] = {.count = 1, .reusable = false}, SHIFT(1609),
  [2779] = {.count = 1, .reusable = false}, SHIFT(1610),
  [2781] = {.count = 1, .reusable = true}, SHIFT(1611),
  [2783] = {.count = 1, .reusable = false}, SHIFT(1611),
  [2785] = {.count = 1, .reusable = false}, SHIFT(1612),
  [2787] = {.count = 1, .reusable = true}, SHIFT(1612),
  [2789] = {.count = 1, .reusable = false}, SHIFT(1613),
  [2791] = {.count = 1, .reusable = true}, SHIFT(1615),
  [2793] = {.count = 1, .reusable = false}, SHIFT(1615),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1622),
  [2797] = {.count = 1, .reusable = false}, SHIFT(1622),
  [2799] = {.count = 1, .reusable = true}, SHIFT(1624),
  [2801] = {.count = 1, .reusable = true}, SHIFT(1623),
  [2803] = {.count = 1, .reusable = true}, SHIFT(1625),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1626),
  [2807] = {.count = 1, .reusable = true}, SHIFT(1627),
  [2809] = {.count = 1, .reusable = true}, SHIFT(1628),
  [2811] = {.count = 1, .reusable = true}, SHIFT(1629),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1630),
  [2815] = {.count = 1, .reusable = true}, SHIFT(1631),
  [2817] = {.count = 1, .reusable = true}, SHIFT(1632),
  [2819] = {.count = 1, .reusable = true}, SHIFT(1633),
  [2821] = {.count = 1, .reusable = false}, SHIFT(1634),
  [2823] = {.count = 1, .reusable = false}, SHIFT(1635),
  [2825] = {.count = 1, .reusable = false}, SHIFT(1636),
  [2827] = {.count = 1, .reusable = true}, SHIFT(1637),
  [2829] = {.count = 1, .reusable = false}, SHIFT(1638),
  [2831] = {.count = 1, .reusable = true}, SHIFT(1638),
  [2833] = {.count = 1, .reusable = true}, SHIFT(1639),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1640),
  [2837] = {.count = 1, .reusable = true}, SHIFT(1641),
  [2839] = {.count = 1, .reusable = false}, SHIFT(1640),
  [2841] = {.count = 1, .reusable = true}, SHIFT(1636),
  [2843] = {.count = 1, .reusable = true}, SHIFT(1634),
  [2845] = {.count = 1, .reusable = false}, SHIFT(1642),
  [2847] = {.count = 1, .reusable = true}, SHIFT(1643),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1644),
  [2851] = {.count = 1, .reusable = true}, SHIFT(1642),
  [2853] = {.count = 1, .reusable = true}, SHIFT(1645),
  [2855] = {.count = 1, .reusable = true}, SHIFT(1646),
  [2857] = {.count = 1, .reusable = true}, SHIFT(1647),
  [2859] = {.count = 1, .reusable = true}, SHIFT(1648),
  [2861] = {.count = 1, .reusable = true}, SHIFT(1649),
  [2863] = {.count = 1, .reusable = false}, SHIFT(1651),
  [2865] = {.count = 1, .reusable = false}, SHIFT(1652),
  [2867] = {.count = 1, .reusable = false}, SHIFT(1653),
  [2869] = {.count = 1, .reusable = false}, SHIFT(1654),
  [2871] = {.count = 1, .reusable = false}, SHIFT(1655),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1656),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1657),
  [2877] = {.count = 1, .reusable = false}, SHIFT(1657),
  [2879] = {.count = 1, .reusable = false}, SHIFT(1658),
  [2881] = {.count = 1, .reusable = true}, SHIFT(1658),
  [2883] = {.count = 1, .reusable = false}, SHIFT(1659),
  [2885] = {.count = 1, .reusable = true}, SHIFT(1661),
  [2887] = {.count = 1, .reusable = false}, SHIFT(1661),
  [2889] = {.count = 1, .reusable = true}, SHIFT(1669),
  [2891] = {.count = 1, .reusable = false}, SHIFT(1669),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1670),
  [2895] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3, .alias_sequence_id = 5),
  [2897] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3, .alias_sequence_id = 5),
  [2899] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(459),
  [2902] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2),
  [2904] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(55),
  [2907] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 3, .alias_sequence_id = 5),
  [2909] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 3, .alias_sequence_id = 5),
  [2911] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3, .alias_sequence_id = 6),
  [2913] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3, .alias_sequence_id = 6),
  [2915] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .alias_sequence_id = 7),
  [2917] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .alias_sequence_id = 7),
  [2919] = {.count = 1, .reusable = true}, SHIFT(1672),
  [2921] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .alias_sequence_id = 8),
  [2923] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .alias_sequence_id = 8),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1673),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1674),
  [2929] = {.count = 1, .reusable = true}, SHIFT(1675),
  [2931] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .alias_sequence_id = 9),
  [2933] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .alias_sequence_id = 9),
  [2935] = {.count = 1, .reusable = true}, SHIFT(1677),
  [2937] = {.count = 1, .reusable = true}, SHIFT(1679),
  [2939] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(470),
  [2942] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(65),
  [2945] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2),
  [2947] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(470),
  [2950] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 8),
  [2952] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 8),
  [2954] = {.count = 1, .reusable = true}, SHIFT(1681),
  [2956] = {.count = 1, .reusable = true}, SHIFT(1682),
  [2958] = {.count = 1, .reusable = true}, SHIFT(1683),
  [2960] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 10),
  [2962] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 10),
  [2964] = {.count = 1, .reusable = true}, SHIFT(1685),
  [2966] = {.count = 1, .reusable = true}, SHIFT(1687),
  [2968] = {.count = 1, .reusable = true}, REDUCE(sym_program, 3),
  [2970] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 3),
  [2972] = {.count = 1, .reusable = true}, SHIFT(1690),
  [2974] = {.count = 1, .reusable = true}, SHIFT(1691),
  [2976] = {.count = 1, .reusable = true}, SHIFT(1692),
  [2978] = {.count = 1, .reusable = true}, SHIFT(1693),
  [2980] = {.count = 1, .reusable = false}, SHIFT(1695),
  [2982] = {.count = 1, .reusable = false}, SHIFT(1696),
  [2984] = {.count = 1, .reusable = false}, SHIFT(1697),
  [2986] = {.count = 1, .reusable = false}, SHIFT(1698),
  [2988] = {.count = 1, .reusable = true}, SHIFT(1699),
  [2990] = {.count = 1, .reusable = false}, SHIFT(1699),
  [2992] = {.count = 1, .reusable = false}, SHIFT(1700),
  [2994] = {.count = 1, .reusable = true}, SHIFT(1700),
  [2996] = {.count = 1, .reusable = false}, SHIFT(1701),
  [2998] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3000] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3002] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3004] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3006] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3008] = {.count = 1, .reusable = true}, SHIFT(1715),
  [3010] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3012] = {.count = 1, .reusable = true}, SHIFT(1717),
  [3014] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3016] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3018] = {.count = 1, .reusable = false}, SHIFT(1720),
  [3020] = {.count = 1, .reusable = false}, SHIFT(1721),
  [3022] = {.count = 1, .reusable = false}, SHIFT(1722),
  [3024] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3026] = {.count = 1, .reusable = false}, SHIFT(1724),
  [3028] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3030] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3032] = {.count = 1, .reusable = true}, SHIFT(1726),
  [3034] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3036] = {.count = 1, .reusable = false}, SHIFT(1726),
  [3038] = {.count = 1, .reusable = true}, SHIFT(1722),
  [3040] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3042] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3044] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3046] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3048] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3050] = {.count = 1, .reusable = false}, SHIFT(1733),
  [3052] = {.count = 1, .reusable = false}, SHIFT(1734),
  [3054] = {.count = 1, .reusable = false}, SHIFT(1735),
  [3056] = {.count = 1, .reusable = false}, SHIFT(1736),
  [3058] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3060] = {.count = 1, .reusable = false}, SHIFT(1737),
  [3062] = {.count = 1, .reusable = false}, SHIFT(1738),
  [3064] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3066] = {.count = 1, .reusable = false}, SHIFT(1739),
  [3068] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3070] = {.count = 1, .reusable = false}, SHIFT(1741),
  [3072] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3074] = {.count = 1, .reusable = false}, SHIFT(1747),
  [3076] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3078] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3080] = {.count = 1, .reusable = true}, SHIFT(1751),
  [3082] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3084] = {.count = 1, .reusable = true}, SHIFT(1753),
  [3086] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3088] = {.count = 1, .reusable = false}, SHIFT(1755),
  [3090] = {.count = 1, .reusable = true}, SHIFT(1757),
  [3092] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3094] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3096] = {.count = 1, .reusable = false}, SHIFT(1761),
  [3098] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3100] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3102] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [3104] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3106] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3108] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3110] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3112] = {.count = 1, .reusable = true}, SHIFT(1774),
  [3114] = {.count = 1, .reusable = true}, SHIFT(1775),
  [3116] = {.count = 1, .reusable = true}, SHIFT(1777),
  [3118] = {.count = 1, .reusable = true}, SHIFT(1778),
  [3120] = {.count = 1, .reusable = true}, SHIFT(1779),
  [3122] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3124] = {.count = 1, .reusable = true}, SHIFT(1781),
  [3126] = {.count = 1, .reusable = false}, SHIFT(1783),
  [3128] = {.count = 1, .reusable = false}, SHIFT(1784),
  [3130] = {.count = 1, .reusable = false}, SHIFT(1785),
  [3132] = {.count = 1, .reusable = false}, SHIFT(1786),
  [3134] = {.count = 1, .reusable = true}, SHIFT(1787),
  [3136] = {.count = 1, .reusable = false}, SHIFT(1787),
  [3138] = {.count = 1, .reusable = false}, SHIFT(1788),
  [3140] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3142] = {.count = 1, .reusable = false}, SHIFT(1789),
  [3144] = {.count = 1, .reusable = true}, SHIFT(1791),
  [3146] = {.count = 1, .reusable = false}, SHIFT(1791),
  [3148] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_argument, 2),
  [3150] = {.count = 1, .reusable = true}, SHIFT(1798),
  [3152] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3154] = {.count = 1, .reusable = false}, SHIFT(1800),
  [3156] = {.count = 1, .reusable = false}, SHIFT(1801),
  [3158] = {.count = 1, .reusable = false}, SHIFT(1802),
  [3160] = {.count = 1, .reusable = true}, SHIFT(1803),
  [3162] = {.count = 1, .reusable = false}, SHIFT(1804),
  [3164] = {.count = 1, .reusable = true}, SHIFT(1804),
  [3166] = {.count = 1, .reusable = true}, SHIFT(1805),
  [3168] = {.count = 1, .reusable = true}, SHIFT(1806),
  [3170] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3172] = {.count = 1, .reusable = false}, SHIFT(1806),
  [3174] = {.count = 1, .reusable = true}, SHIFT(1802),
  [3176] = {.count = 1, .reusable = true}, SHIFT(1800),
  [3178] = {.count = 1, .reusable = false}, SHIFT(1808),
  [3180] = {.count = 1, .reusable = true}, SHIFT(1809),
  [3182] = {.count = 1, .reusable = true}, SHIFT(1810),
  [3184] = {.count = 1, .reusable = true}, SHIFT(1808),
  [3186] = {.count = 1, .reusable = true}, SHIFT(1811),
  [3188] = {.count = 1, .reusable = true}, SHIFT(1812),
  [3190] = {.count = 1, .reusable = true}, SHIFT(1813),
  [3192] = {.count = 1, .reusable = true}, SHIFT(1814),
  [3194] = {.count = 1, .reusable = true}, SHIFT(1815),
  [3196] = {.count = 1, .reusable = false}, SHIFT(1817),
  [3198] = {.count = 1, .reusable = false}, SHIFT(1818),
  [3200] = {.count = 1, .reusable = false}, SHIFT(1819),
  [3202] = {.count = 1, .reusable = false}, SHIFT(1820),
  [3204] = {.count = 1, .reusable = false}, SHIFT(1821),
  [3206] = {.count = 1, .reusable = true}, SHIFT(1822),
  [3208] = {.count = 1, .reusable = false}, SHIFT(1822),
  [3210] = {.count = 1, .reusable = false}, SHIFT(1823),
  [3212] = {.count = 1, .reusable = true}, SHIFT(1823),
  [3214] = {.count = 1, .reusable = false}, SHIFT(1824),
  [3216] = {.count = 1, .reusable = true}, SHIFT(1826),
  [3218] = {.count = 1, .reusable = false}, SHIFT(1826),
  [3220] = {.count = 1, .reusable = true}, SHIFT(1834),
  [3222] = {.count = 1, .reusable = false}, SHIFT(1834),
  [3224] = {.count = 1, .reusable = true}, SHIFT(1835),
  [3226] = {.count = 1, .reusable = true}, SHIFT(1839),
  [3228] = {.count = 1, .reusable = true}, SHIFT(1841),
  [3230] = {.count = 1, .reusable = false}, SHIFT(1840),
  [3232] = {.count = 1, .reusable = true}, SHIFT(1846),
  [3234] = {.count = 1, .reusable = true}, SHIFT(1850),
  [3236] = {.count = 1, .reusable = false}, SHIFT(1855),
  [3238] = {.count = 1, .reusable = true}, SHIFT(1856),
  [3240] = {.count = 1, .reusable = true}, SHIFT(1857),
  [3242] = {.count = 1, .reusable = false}, SHIFT(1858),
  [3244] = {.count = 1, .reusable = false}, SHIFT(1859),
  [3246] = {.count = 1, .reusable = false}, SHIFT(1860),
  [3248] = {.count = 1, .reusable = true}, SHIFT(1861),
  [3250] = {.count = 1, .reusable = false}, SHIFT(1862),
  [3252] = {.count = 1, .reusable = true}, SHIFT(1862),
  [3254] = {.count = 1, .reusable = true}, SHIFT(1864),
  [3256] = {.count = 1, .reusable = true}, SHIFT(1865),
  [3258] = {.count = 1, .reusable = false}, SHIFT(1864),
  [3260] = {.count = 1, .reusable = true}, SHIFT(1860),
  [3262] = {.count = 1, .reusable = true}, SHIFT(1858),
  [3264] = {.count = 1, .reusable = true}, SHIFT(1866),
  [3266] = {.count = 1, .reusable = true}, SHIFT(1868),
  [3268] = {.count = 1, .reusable = true}, SHIFT(1870),
  [3270] = {.count = 1, .reusable = false}, SHIFT(1870),
  [3272] = {.count = 1, .reusable = true}, SHIFT(1871),
  [3274] = {.count = 1, .reusable = false}, SHIFT(1846),
  [3276] = {.count = 1, .reusable = true}, SHIFT(1873),
  [3278] = {.count = 1, .reusable = true}, SHIFT(1874),
  [3280] = {.count = 1, .reusable = true}, SHIFT(1875),
  [3282] = {.count = 1, .reusable = true}, SHIFT(1876),
  [3284] = {.count = 1, .reusable = true}, SHIFT(1878),
  [3286] = {.count = 1, .reusable = true}, SHIFT(1880),
  [3288] = {.count = 1, .reusable = true}, SHIFT(1881),
  [3290] = {.count = 1, .reusable = false}, SHIFT(1885),
  [3292] = {.count = 1, .reusable = true}, SHIFT(1887),
  [3294] = {.count = 1, .reusable = true}, SHIFT(1889),
  [3296] = {.count = 1, .reusable = true}, SHIFT(1895),
  [3298] = {.count = 1, .reusable = false}, SHIFT(1892),
  [3300] = {.count = 1, .reusable = true}, SHIFT(592),
  [3302] = {.count = 1, .reusable = true}, SHIFT(1907),
  [3304] = {.count = 1, .reusable = false}, SHIFT(1907),
  [3306] = {.count = 1, .reusable = true}, SHIFT(1908),
  [3308] = {.count = 1, .reusable = true}, SHIFT(1909),
  [3310] = {.count = 1, .reusable = true}, SHIFT(1912),
  [3312] = {.count = 1, .reusable = true}, SHIFT(1915),
  [3314] = {.count = 1, .reusable = true}, SHIFT(1916),
  [3316] = {.count = 1, .reusable = true}, SHIFT(1918),
  [3318] = {.count = 1, .reusable = true}, SHIFT(1920),
  [3320] = {.count = 1, .reusable = true}, SHIFT(1922),
  [3322] = {.count = 1, .reusable = true}, SHIFT(1924),
  [3324] = {.count = 1, .reusable = false}, SHIFT(1925),
  [3326] = {.count = 1, .reusable = true}, SHIFT(1927),
  [3328] = {.count = 1, .reusable = false}, SHIFT(1928),
  [3330] = {.count = 1, .reusable = true}, SHIFT(1930),
  [3332] = {.count = 1, .reusable = true}, SHIFT(621),
  [3334] = {.count = 1, .reusable = false}, SHIFT(617),
  [3336] = {.count = 1, .reusable = true}, SHIFT(642),
  [3338] = {.count = 1, .reusable = true}, SHIFT(1935),
  [3340] = {.count = 1, .reusable = true}, SHIFT(1936),
  [3342] = {.count = 1, .reusable = true}, SHIFT(1941),
  [3344] = {.count = 1, .reusable = false}, SHIFT(1943),
  [3346] = {.count = 1, .reusable = true}, SHIFT(1945),
  [3348] = {.count = 1, .reusable = true}, SHIFT(1948),
  [3350] = {.count = 1, .reusable = false}, SHIFT(1949),
  [3352] = {.count = 1, .reusable = false}, SHIFT(1951),
  [3354] = {.count = 1, .reusable = true}, SHIFT(1965),
  [3356] = {.count = 1, .reusable = false}, SHIFT(1962),
  [3358] = {.count = 1, .reusable = true}, SHIFT(1967),
  [3360] = {.count = 1, .reusable = true}, SHIFT(1973),
  [3362] = {.count = 1, .reusable = false}, SHIFT(1972),
  [3364] = {.count = 1, .reusable = true}, SHIFT(1974),
  [3366] = {.count = 1, .reusable = false}, SHIFT(1979),
  [3368] = {.count = 1, .reusable = false}, SHIFT(1980),
  [3370] = {.count = 1, .reusable = true}, SHIFT(1981),
  [3372] = {.count = 1, .reusable = true}, SHIFT(1984),
  [3374] = {.count = 1, .reusable = true}, SHIFT(1987),
  [3376] = {.count = 1, .reusable = true}, SHIFT(1988),
  [3378] = {.count = 1, .reusable = false}, SHIFT(1989),
  [3380] = {.count = 1, .reusable = false}, SHIFT(1988),
  [3382] = {.count = 1, .reusable = false}, SHIFT(1990),
  [3384] = {.count = 1, .reusable = false}, SHIFT(1991),
  [3386] = {.count = 1, .reusable = true}, SHIFT(1992),
  [3388] = {.count = 1, .reusable = false}, SHIFT(1993),
  [3390] = {.count = 1, .reusable = true}, SHIFT(1993),
  [3392] = {.count = 1, .reusable = false}, SHIFT(1995),
  [3394] = {.count = 1, .reusable = false}, SHIFT(1996),
  [3396] = {.count = 1, .reusable = true}, SHIFT(1995),
  [3398] = {.count = 1, .reusable = true}, SHIFT(1991),
  [3400] = {.count = 1, .reusable = false}, SHIFT(1987),
  [3402] = {.count = 1, .reusable = true}, SHIFT(1997),
  [3404] = {.count = 1, .reusable = true}, SHIFT(1999),
  [3406] = {.count = 1, .reusable = true}, SHIFT(634),
  [3408] = {.count = 1, .reusable = true}, SHIFT(2001),
  [3410] = {.count = 1, .reusable = true}, SHIFT(2003),
  [3412] = {.count = 1, .reusable = true}, SHIFT(2005),
  [3414] = {.count = 1, .reusable = false}, SHIFT(2005),
  [3416] = {.count = 1, .reusable = true}, SHIFT(2006),
  [3418] = {.count = 1, .reusable = false}, SHIFT(1935),
  [3420] = {.count = 1, .reusable = true}, SHIFT(2008),
  [3422] = {.count = 1, .reusable = true}, SHIFT(2009),
  [3424] = {.count = 1, .reusable = false}, SHIFT(2010),
  [3426] = {.count = 1, .reusable = false}, SHIFT(2011),
  [3428] = {.count = 1, .reusable = false}, SHIFT(2012),
  [3430] = {.count = 1, .reusable = false}, SHIFT(2013),
  [3432] = {.count = 1, .reusable = false}, SHIFT(2009),
  [3434] = {.count = 1, .reusable = true}, SHIFT(2014),
  [3436] = {.count = 1, .reusable = false}, SHIFT(2014),
  [3438] = {.count = 1, .reusable = true}, SHIFT(2015),
  [3440] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 3),
  [3442] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 3),
  [3444] = {.count = 1, .reusable = true}, SHIFT(2024),
  [3446] = {.count = 1, .reusable = true}, SHIFT(2025),
  [3448] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 2),
  [3450] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 3),
  [3452] = {.count = 1, .reusable = true}, SHIFT(2028),
  [3454] = {.count = 1, .reusable = true}, SHIFT(2029),
  [3456] = {.count = 1, .reusable = true}, SHIFT(2031),
  [3458] = {.count = 1, .reusable = true}, SHIFT(2032),
  [3460] = {.count = 1, .reusable = true}, SHIFT(2033),
  [3462] = {.count = 1, .reusable = true}, SHIFT(2034),
  [3464] = {.count = 1, .reusable = true}, SHIFT(2036),
  [3466] = {.count = 1, .reusable = false}, SHIFT(2036),
  [3468] = {.count = 1, .reusable = false}, SHIFT(2037),
  [3470] = {.count = 1, .reusable = true}, SHIFT(2037),
  [3472] = {.count = 1, .reusable = false}, SHIFT(2038),
  [3474] = {.count = 1, .reusable = true}, SHIFT(2046),
  [3476] = {.count = 1, .reusable = true}, SHIFT(2047),
  [3478] = {.count = 1, .reusable = true}, SHIFT(2048),
  [3480] = {.count = 1, .reusable = false}, SHIFT(2049),
  [3482] = {.count = 1, .reusable = false}, SHIFT(2050),
  [3484] = {.count = 1, .reusable = false}, SHIFT(2051),
  [3486] = {.count = 1, .reusable = true}, SHIFT(2052),
  [3488] = {.count = 1, .reusable = false}, SHIFT(2053),
  [3490] = {.count = 1, .reusable = true}, SHIFT(2053),
  [3492] = {.count = 1, .reusable = true}, SHIFT(2054),
  [3494] = {.count = 1, .reusable = true}, SHIFT(2055),
  [3496] = {.count = 1, .reusable = true}, SHIFT(2056),
  [3498] = {.count = 1, .reusable = false}, SHIFT(2055),
  [3500] = {.count = 1, .reusable = true}, SHIFT(2051),
  [3502] = {.count = 1, .reusable = true}, SHIFT(2049),
  [3504] = {.count = 1, .reusable = true}, SHIFT(2057),
  [3506] = {.count = 1, .reusable = true}, SHIFT(2058),
  [3508] = {.count = 1, .reusable = true}, SHIFT(2059),
  [3510] = {.count = 1, .reusable = true}, SHIFT(2060),
  [3512] = {.count = 1, .reusable = false}, SHIFT(2062),
  [3514] = {.count = 1, .reusable = false}, SHIFT(2063),
  [3516] = {.count = 1, .reusable = false}, SHIFT(2064),
  [3518] = {.count = 1, .reusable = false}, SHIFT(2065),
  [3520] = {.count = 1, .reusable = true}, SHIFT(2066),
  [3522] = {.count = 1, .reusable = false}, SHIFT(2066),
  [3524] = {.count = 1, .reusable = false}, SHIFT(2067),
  [3526] = {.count = 1, .reusable = true}, SHIFT(2067),
  [3528] = {.count = 1, .reusable = false}, SHIFT(2068),
  [3530] = {.count = 1, .reusable = true}, SHIFT(2070),
  [3532] = {.count = 1, .reusable = false}, SHIFT(2070),
  [3534] = {.count = 1, .reusable = true}, SHIFT(2076),
  [3536] = {.count = 1, .reusable = false}, SHIFT(2076),
  [3538] = {.count = 1, .reusable = true}, SHIFT(2077),
  [3540] = {.count = 1, .reusable = true}, REDUCE(sym_setter, 2),
  [3542] = {.count = 1, .reusable = false}, REDUCE(sym_setter, 2),
  [3544] = {.count = 1, .reusable = true}, SHIFT(132),
  [3546] = {.count = 1, .reusable = true}, SHIFT(2080),
  [3548] = {.count = 1, .reusable = true}, SHIFT(2082),
  [3550] = {.count = 1, .reusable = true}, SHIFT(2083),
  [3552] = {.count = 1, .reusable = true}, SHIFT(2084),
  [3554] = {.count = 1, .reusable = true}, SHIFT(2085),
  [3556] = {.count = 1, .reusable = true}, SHIFT(2086),
  [3558] = {.count = 1, .reusable = true}, SHIFT(2087),
  [3560] = {.count = 1, .reusable = false}, SHIFT(2088),
  [3562] = {.count = 1, .reusable = true}, SHIFT(2090),
  [3564] = {.count = 1, .reusable = true}, SHIFT(2089),
  [3566] = {.count = 1, .reusable = true}, SHIFT(2091),
  [3568] = {.count = 1, .reusable = true}, SHIFT(2092),
  [3570] = {.count = 1, .reusable = true}, SHIFT(2093),
  [3572] = {.count = 1, .reusable = true}, SHIFT(2094),
  [3574] = {.count = 1, .reusable = true}, SHIFT(2095),
  [3576] = {.count = 1, .reusable = false}, SHIFT(2096),
  [3578] = {.count = 1, .reusable = false}, SHIFT(2097),
  [3580] = {.count = 1, .reusable = false}, SHIFT(2098),
  [3582] = {.count = 1, .reusable = false}, SHIFT(2099),
  [3584] = {.count = 1, .reusable = false}, SHIFT(2093),
  [3586] = {.count = 1, .reusable = true}, SHIFT(2100),
  [3588] = {.count = 1, .reusable = false}, SHIFT(2100),
  [3590] = {.count = 1, .reusable = true}, SHIFT(2101),
  [3592] = {.count = 1, .reusable = false}, SHIFT(2102),
  [3594] = {.count = 1, .reusable = true}, SHIFT(2109),
  [3596] = {.count = 1, .reusable = false}, SHIFT(2110),
  [3598] = {.count = 1, .reusable = false}, SHIFT(2111),
  [3600] = {.count = 1, .reusable = false}, SHIFT(2112),
  [3602] = {.count = 1, .reusable = false}, SHIFT(2113),
  [3604] = {.count = 1, .reusable = false}, SHIFT(2109),
  [3606] = {.count = 1, .reusable = true}, SHIFT(2114),
  [3608] = {.count = 1, .reusable = false}, SHIFT(2114),
  [3610] = {.count = 1, .reusable = true}, SHIFT(2115),
  [3612] = {.count = 1, .reusable = false}, SHIFT(689),
  [3614] = {.count = 1, .reusable = true}, SHIFT(2123),
  [3616] = {.count = 1, .reusable = true}, SHIFT(2125),
  [3618] = {.count = 1, .reusable = true}, SHIFT(2126),
  [3620] = {.count = 1, .reusable = true}, SHIFT(2127),
  [3622] = {.count = 1, .reusable = false}, SHIFT(2129),
  [3624] = {.count = 1, .reusable = false}, SHIFT(2135),
  [3626] = {.count = 1, .reusable = true}, SHIFT(2136),
  [3628] = {.count = 1, .reusable = true}, SHIFT(2137),
  [3630] = {.count = 1, .reusable = false}, SHIFT(2138),
  [3632] = {.count = 1, .reusable = false}, SHIFT(2139),
  [3634] = {.count = 1, .reusable = false}, SHIFT(2140),
  [3636] = {.count = 1, .reusable = true}, SHIFT(2141),
  [3638] = {.count = 1, .reusable = false}, SHIFT(2142),
  [3640] = {.count = 1, .reusable = true}, SHIFT(2142),
  [3642] = {.count = 1, .reusable = true}, SHIFT(2144),
  [3644] = {.count = 1, .reusable = true}, SHIFT(2145),
  [3646] = {.count = 1, .reusable = false}, SHIFT(2144),
  [3648] = {.count = 1, .reusable = true}, SHIFT(2140),
  [3650] = {.count = 1, .reusable = true}, SHIFT(2138),
  [3652] = {.count = 1, .reusable = true}, SHIFT(2146),
  [3654] = {.count = 1, .reusable = true}, SHIFT(2147),
  [3656] = {.count = 1, .reusable = true}, SHIFT(2148),
  [3658] = {.count = 1, .reusable = false}, SHIFT(2150),
  [3660] = {.count = 1, .reusable = true}, SHIFT(2156),
  [3662] = {.count = 1, .reusable = true}, SHIFT(2158),
  [3664] = {.count = 1, .reusable = false}, SHIFT(2158),
  [3666] = {.count = 1, .reusable = true}, SHIFT(2159),
  [3668] = {.count = 1, .reusable = false}, SHIFT(2123),
  [3670] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 3),
  [3672] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 3),
  [3674] = {.count = 1, .reusable = true}, SHIFT(2162),
  [3676] = {.count = 1, .reusable = true}, SHIFT(2179),
  [3678] = {.count = 1, .reusable = false}, SHIFT(2180),
  [3680] = {.count = 1, .reusable = false}, SHIFT(2181),
  [3682] = {.count = 1, .reusable = false}, SHIFT(2182),
  [3684] = {.count = 1, .reusable = false}, SHIFT(2183),
  [3686] = {.count = 1, .reusable = false}, SHIFT(2179),
  [3688] = {.count = 1, .reusable = true}, SHIFT(2184),
  [3690] = {.count = 1, .reusable = false}, SHIFT(2184),
  [3692] = {.count = 1, .reusable = true}, SHIFT(2185),
  [3694] = {.count = 1, .reusable = false}, SHIFT(2187),
  [3696] = {.count = 1, .reusable = true}, SHIFT(2187),
  [3698] = {.count = 1, .reusable = false}, SHIFT(728),
  [3700] = {.count = 1, .reusable = true}, SHIFT(2194),
  [3702] = {.count = 1, .reusable = false}, SHIFT(2197),
  [3704] = {.count = 1, .reusable = true}, SHIFT(2198),
  [3706] = {.count = 1, .reusable = true}, SHIFT(2199),
  [3708] = {.count = 1, .reusable = false}, SHIFT(2200),
  [3710] = {.count = 1, .reusable = false}, SHIFT(2199),
  [3712] = {.count = 1, .reusable = false}, SHIFT(2201),
  [3714] = {.count = 1, .reusable = false}, SHIFT(2202),
  [3716] = {.count = 1, .reusable = true}, SHIFT(2203),
  [3718] = {.count = 1, .reusable = false}, SHIFT(2204),
  [3720] = {.count = 1, .reusable = true}, SHIFT(2204),
  [3722] = {.count = 1, .reusable = false}, SHIFT(2206),
  [3724] = {.count = 1, .reusable = false}, SHIFT(2207),
  [3726] = {.count = 1, .reusable = true}, SHIFT(2206),
  [3728] = {.count = 1, .reusable = true}, SHIFT(2202),
  [3730] = {.count = 1, .reusable = false}, SHIFT(2198),
  [3732] = {.count = 1, .reusable = true}, SHIFT(2209),
  [3734] = {.count = 1, .reusable = true}, SHIFT(2211),
  [3736] = {.count = 1, .reusable = false}, SHIFT(2211),
  [3738] = {.count = 1, .reusable = true}, SHIFT(2212),
  [3740] = {.count = 1, .reusable = false}, SHIFT(2194),
  [3742] = {.count = 1, .reusable = true}, SHIFT(2214),
  [3744] = {.count = 1, .reusable = true}, SHIFT(2215),
  [3746] = {.count = 1, .reusable = false}, SHIFT(2215),
  [3748] = {.count = 1, .reusable = true}, SHIFT(2216),
  [3750] = {.count = 1, .reusable = false}, SHIFT(2216),
  [3752] = {.count = 1, .reusable = true}, SHIFT(2217),
  [3754] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_left_assignment, 3),
  [3756] = {.count = 1, .reusable = true}, SHIFT(2224),
  [3758] = {.count = 1, .reusable = true}, SHIFT(2225),
  [3760] = {.count = 1, .reusable = true}, SHIFT(2226),
  [3762] = {.count = 1, .reusable = true}, SHIFT(2227),
  [3764] = {.count = 1, .reusable = true}, SHIFT(2228),
  [3766] = {.count = 1, .reusable = false}, SHIFT(2229),
  [3768] = {.count = 1, .reusable = true}, SHIFT(2231),
  [3770] = {.count = 1, .reusable = true}, SHIFT(2232),
  [3772] = {.count = 1, .reusable = true}, SHIFT(2234),
  [3774] = {.count = 1, .reusable = false}, SHIFT(2235),
  [3776] = {.count = 1, .reusable = true}, SHIFT(2237),
  [3778] = {.count = 1, .reusable = true}, SHIFT(2238),
  [3780] = {.count = 1, .reusable = true}, SHIFT(2240),
  [3782] = {.count = 1, .reusable = true}, SHIFT(2243),
  [3784] = {.count = 1, .reusable = true}, SHIFT(2244),
  [3786] = {.count = 1, .reusable = true}, SHIFT(2245),
  [3788] = {.count = 1, .reusable = true}, SHIFT(2248),
  [3790] = {.count = 1, .reusable = true}, SHIFT(2250),
  [3792] = {.count = 1, .reusable = false}, SHIFT(2249),
  [3794] = {.count = 1, .reusable = true}, SHIFT(2251),
  [3796] = {.count = 1, .reusable = false}, SHIFT(2252),
  [3798] = {.count = 1, .reusable = false}, SHIFT(2253),
  [3800] = {.count = 1, .reusable = false}, SHIFT(2254),
  [3802] = {.count = 1, .reusable = false}, SHIFT(2255),
  [3804] = {.count = 1, .reusable = false}, SHIFT(2251),
  [3806] = {.count = 1, .reusable = true}, SHIFT(2256),
  [3808] = {.count = 1, .reusable = false}, SHIFT(2256),
  [3810] = {.count = 1, .reusable = true}, SHIFT(2257),
  [3812] = {.count = 1, .reusable = false}, SHIFT(2259),
  [3814] = {.count = 1, .reusable = true}, SHIFT(2259),
  [3816] = {.count = 1, .reusable = true}, SHIFT(2264),
  [3818] = {.count = 1, .reusable = true}, SHIFT(2266),
  [3820] = {.count = 1, .reusable = false}, SHIFT(2269),
  [3822] = {.count = 1, .reusable = true}, SHIFT(1863),
  [3824] = {.count = 1, .reusable = true}, SHIFT(2270),
  [3826] = {.count = 1, .reusable = true}, SHIFT(2272),
  [3828] = {.count = 1, .reusable = false}, SHIFT(2264),
  [3830] = {.count = 1, .reusable = true}, SHIFT(2274),
  [3832] = {.count = 1, .reusable = true}, SHIFT(2275),
  [3834] = {.count = 1, .reusable = true}, SHIFT(2276),
  [3836] = {.count = 1, .reusable = true}, SHIFT(2277),
  [3838] = {.count = 1, .reusable = true}, SHIFT(2279),
  [3840] = {.count = 1, .reusable = true}, SHIFT(2281),
  [3842] = {.count = 1, .reusable = true}, SHIFT(2282),
  [3844] = {.count = 1, .reusable = false}, SHIFT(2286),
  [3846] = {.count = 1, .reusable = true}, SHIFT(2287),
  [3848] = {.count = 1, .reusable = true}, SHIFT(2289),
  [3850] = {.count = 1, .reusable = true}, SHIFT(2295),
  [3852] = {.count = 1, .reusable = false}, SHIFT(2292),
  [3854] = {.count = 1, .reusable = true}, SHIFT(811),
  [3856] = {.count = 1, .reusable = true}, SHIFT(2297),
  [3858] = {.count = 1, .reusable = false}, SHIFT(2297),
  [3860] = {.count = 1, .reusable = true}, SHIFT(2298),
  [3862] = {.count = 1, .reusable = true}, SHIFT(2299),
  [3864] = {.count = 1, .reusable = true}, SHIFT(2302),
  [3866] = {.count = 1, .reusable = true}, SHIFT(2305),
  [3868] = {.count = 1, .reusable = true}, SHIFT(2306),
  [3870] = {.count = 1, .reusable = true}, SHIFT(2307),
  [3872] = {.count = 1, .reusable = true}, SHIFT(2308),
  [3874] = {.count = 1, .reusable = true}, SHIFT(2309),
  [3876] = {.count = 1, .reusable = true}, SHIFT(2310),
  [3878] = {.count = 1, .reusable = true}, SHIFT(2311),
  [3880] = {.count = 1, .reusable = true}, SHIFT(2312),
  [3882] = {.count = 1, .reusable = true}, SHIFT(2313),
  [3884] = {.count = 1, .reusable = true}, SHIFT(2314),
  [3886] = {.count = 1, .reusable = false}, SHIFT(2315),
  [3888] = {.count = 1, .reusable = true}, SHIFT(2316),
  [3890] = {.count = 1, .reusable = false}, SHIFT(2317),
  [3892] = {.count = 1, .reusable = false}, SHIFT(2318),
  [3894] = {.count = 1, .reusable = false}, SHIFT(2319),
  [3896] = {.count = 1, .reusable = false}, SHIFT(2320),
  [3898] = {.count = 1, .reusable = false}, SHIFT(2321),
  [3900] = {.count = 1, .reusable = false}, SHIFT(2322),
  [3902] = {.count = 1, .reusable = false}, SHIFT(2323),
  [3904] = {.count = 1, .reusable = false}, SHIFT(2324),
  [3906] = {.count = 1, .reusable = false}, SHIFT(2325),
  [3908] = {.count = 1, .reusable = false}, SHIFT(2326),
  [3910] = {.count = 1, .reusable = false}, SHIFT(2327),
  [3912] = {.count = 1, .reusable = false}, SHIFT(2328),
  [3914] = {.count = 1, .reusable = false}, SHIFT(2329),
  [3916] = {.count = 1, .reusable = false}, SHIFT(2313),
  [3918] = {.count = 1, .reusable = true}, SHIFT(2330),
  [3920] = {.count = 1, .reusable = false}, SHIFT(2330),
  [3922] = {.count = 1, .reusable = true}, SHIFT(2331),
  [3924] = {.count = 1, .reusable = false}, SHIFT(2336),
  [3926] = {.count = 1, .reusable = true}, SHIFT(2336),
  [3928] = {.count = 1, .reusable = false}, SHIFT(2332),
  [3930] = {.count = 1, .reusable = true}, SHIFT(2333),
  [3932] = {.count = 1, .reusable = true}, SHIFT(2334),
  [3934] = {.count = 1, .reusable = true}, SHIFT(2343),
  [3936] = {.count = 1, .reusable = true}, SHIFT(2344),
  [3938] = {.count = 1, .reusable = true}, SHIFT(2346),
  [3940] = {.count = 1, .reusable = true}, SHIFT(2347),
  [3942] = {.count = 1, .reusable = true}, SHIFT(2348),
  [3944] = {.count = 1, .reusable = false}, SHIFT(828),
  [3946] = {.count = 1, .reusable = false}, SHIFT(2350),
  [3948] = {.count = 1, .reusable = false}, SHIFT(2356),
  [3950] = {.count = 1, .reusable = true}, SHIFT(2357),
  [3952] = {.count = 1, .reusable = true}, SHIFT(2358),
  [3954] = {.count = 1, .reusable = false}, SHIFT(2359),
  [3956] = {.count = 1, .reusable = false}, SHIFT(2360),
  [3958] = {.count = 1, .reusable = false}, SHIFT(2361),
  [3960] = {.count = 1, .reusable = true}, SHIFT(2362),
  [3962] = {.count = 1, .reusable = false}, SHIFT(2363),
  [3964] = {.count = 1, .reusable = true}, SHIFT(2363),
  [3966] = {.count = 1, .reusable = true}, SHIFT(2364),
  [3968] = {.count = 1, .reusable = true}, SHIFT(2365),
  [3970] = {.count = 1, .reusable = true}, SHIFT(2366),
  [3972] = {.count = 1, .reusable = false}, SHIFT(2365),
  [3974] = {.count = 1, .reusable = true}, SHIFT(2361),
  [3976] = {.count = 1, .reusable = true}, SHIFT(2359),
  [3978] = {.count = 1, .reusable = true}, SHIFT(2369),
  [3980] = {.count = 1, .reusable = true}, SHIFT(2371),
  [3982] = {.count = 1, .reusable = false}, SHIFT(2371),
  [3984] = {.count = 1, .reusable = true}, SHIFT(2372),
  [3986] = {.count = 1, .reusable = false}, SHIFT(2343),
  [3988] = {.count = 1, .reusable = true}, SHIFT(2375),
  [3990] = {.count = 1, .reusable = true}, SHIFT(2377),
  [3992] = {.count = 1, .reusable = false}, SHIFT(2378),
  [3994] = {.count = 1, .reusable = true}, SHIFT(2379),
  [3996] = {.count = 1, .reusable = true}, SHIFT(2380),
  [3998] = {.count = 1, .reusable = false}, SHIFT(2381),
  [4000] = {.count = 1, .reusable = false}, SHIFT(2382),
  [4002] = {.count = 1, .reusable = false}, SHIFT(2383),
  [4004] = {.count = 1, .reusable = false}, SHIFT(2384),
  [4006] = {.count = 1, .reusable = false}, SHIFT(2380),
  [4008] = {.count = 1, .reusable = true}, SHIFT(2385),
  [4010] = {.count = 1, .reusable = false}, SHIFT(2385),
  [4012] = {.count = 1, .reusable = true}, SHIFT(2386),
  [4014] = {.count = 1, .reusable = true}, SHIFT(2394),
  [4016] = {.count = 1, .reusable = true}, SHIFT(2395),
  [4018] = {.count = 1, .reusable = true}, SHIFT(2397),
  [4020] = {.count = 1, .reusable = true}, SHIFT(2398),
  [4022] = {.count = 1, .reusable = true}, SHIFT(2399),
  [4024] = {.count = 1, .reusable = false}, SHIFT(856),
  [4026] = {.count = 1, .reusable = false}, SHIFT(2401),
  [4028] = {.count = 1, .reusable = false}, SHIFT(2407),
  [4030] = {.count = 1, .reusable = true}, SHIFT(2408),
  [4032] = {.count = 1, .reusable = true}, SHIFT(2409),
  [4034] = {.count = 1, .reusable = false}, SHIFT(2410),
  [4036] = {.count = 1, .reusable = false}, SHIFT(2411),
  [4038] = {.count = 1, .reusable = false}, SHIFT(2412),
  [4040] = {.count = 1, .reusable = true}, SHIFT(2413),
  [4042] = {.count = 1, .reusable = false}, SHIFT(2414),
  [4044] = {.count = 1, .reusable = true}, SHIFT(2414),
  [4046] = {.count = 1, .reusable = true}, SHIFT(2415),
  [4048] = {.count = 1, .reusable = true}, SHIFT(2416),
  [4050] = {.count = 1, .reusable = true}, SHIFT(2417),
  [4052] = {.count = 1, .reusable = false}, SHIFT(2416),
  [4054] = {.count = 1, .reusable = true}, SHIFT(2412),
  [4056] = {.count = 1, .reusable = true}, SHIFT(2410),
  [4058] = {.count = 1, .reusable = true}, SHIFT(2419),
  [4060] = {.count = 1, .reusable = true}, SHIFT(2421),
  [4062] = {.count = 1, .reusable = false}, SHIFT(2421),
  [4064] = {.count = 1, .reusable = true}, SHIFT(2422),
  [4066] = {.count = 1, .reusable = false}, SHIFT(2394),
  [4068] = {.count = 1, .reusable = true}, REDUCE(sym_module, 3),
  [4070] = {.count = 1, .reusable = false}, REDUCE(sym_module, 3),
  [4072] = {.count = 1, .reusable = false}, SHIFT(2424),
  [4074] = {.count = 1, .reusable = true}, REDUCE(sym_block_argument, 2),
  [4076] = {.count = 1, .reusable = true}, SHIFT(2429),
  [4078] = {.count = 1, .reusable = true}, SHIFT(2430),
  [4080] = {.count = 1, .reusable = false}, REDUCE(sym_block_argument, 2),
  [4082] = {.count = 1, .reusable = false}, SHIFT(2431),
  [4084] = {.count = 1, .reusable = false}, SHIFT(2432),
  [4086] = {.count = 1, .reusable = false}, SHIFT(2433),
  [4088] = {.count = 1, .reusable = true}, SHIFT(2434),
  [4090] = {.count = 1, .reusable = false}, SHIFT(2435),
  [4092] = {.count = 1, .reusable = true}, SHIFT(2435),
  [4094] = {.count = 1, .reusable = true}, SHIFT(2437),
  [4096] = {.count = 1, .reusable = true}, SHIFT(2438),
  [4098] = {.count = 1, .reusable = false}, SHIFT(2437),
  [4100] = {.count = 1, .reusable = true}, SHIFT(2433),
  [4102] = {.count = 1, .reusable = true}, SHIFT(2431),
  [4104] = {.count = 1, .reusable = true}, SHIFT(2439),
  [4106] = {.count = 1, .reusable = false}, SHIFT(2439),
  [4108] = {.count = 1, .reusable = true}, SHIFT(2440),
  [4110] = {.count = 1, .reusable = true}, REDUCE(sym_splat_argument, 2),
  [4112] = {.count = 1, .reusable = false}, REDUCE(sym_splat_argument, 2),
  [4114] = {.count = 1, .reusable = false}, REDUCE(sym_hash_splat_argument, 2),
  [4116] = {.count = 1, .reusable = true}, SHIFT(2445),
  [4118] = {.count = 1, .reusable = false}, SHIFT(2447),
  [4120] = {.count = 1, .reusable = true}, SHIFT(2449),
  [4122] = {.count = 1, .reusable = false}, SHIFT(2445),
  [4124] = {.count = 1, .reusable = true}, SHIFT(2451),
  [4126] = {.count = 1, .reusable = false}, SHIFT(2452),
  [4128] = {.count = 1, .reusable = false}, SHIFT(2453),
  [4130] = {.count = 1, .reusable = false}, SHIFT(2454),
  [4132] = {.count = 1, .reusable = false}, SHIFT(2455),
  [4134] = {.count = 1, .reusable = false}, SHIFT(2451),
  [4136] = {.count = 1, .reusable = true}, SHIFT(2456),
  [4138] = {.count = 1, .reusable = false}, SHIFT(2456),
  [4140] = {.count = 1, .reusable = true}, SHIFT(2457),
  [4142] = {.count = 1, .reusable = false}, SHIFT(2459),
  [4144] = {.count = 1, .reusable = true}, SHIFT(2459),
  [4146] = {.count = 1, .reusable = true}, SHIFT(2466),
  [4148] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_parens, 2),
  [4150] = {.count = 1, .reusable = false}, REDUCE(sym__argument_list_with_parens, 2),
  [4152] = {.count = 1, .reusable = true}, SHIFT(2468),
  [4154] = {.count = 1, .reusable = true}, SHIFT(2469),
  [4156] = {.count = 1, .reusable = true}, SHIFT(2470),
  [4158] = {.count = 1, .reusable = false}, SHIFT(2472),
  [4160] = {.count = 1, .reusable = false}, SHIFT(2478),
  [4162] = {.count = 1, .reusable = true}, SHIFT(2479),
  [4164] = {.count = 1, .reusable = true}, SHIFT(2480),
  [4166] = {.count = 1, .reusable = false}, SHIFT(2481),
  [4168] = {.count = 1, .reusable = false}, SHIFT(2482),
  [4170] = {.count = 1, .reusable = false}, SHIFT(2483),
  [4172] = {.count = 1, .reusable = true}, SHIFT(2484),
  [4174] = {.count = 1, .reusable = false}, SHIFT(2485),
  [4176] = {.count = 1, .reusable = true}, SHIFT(2485),
  [4178] = {.count = 1, .reusable = true}, SHIFT(2486),
  [4180] = {.count = 1, .reusable = true}, SHIFT(2487),
  [4182] = {.count = 1, .reusable = true}, SHIFT(2488),
  [4184] = {.count = 1, .reusable = false}, SHIFT(2487),
  [4186] = {.count = 1, .reusable = true}, SHIFT(2483),
  [4188] = {.count = 1, .reusable = true}, SHIFT(2481),
  [4190] = {.count = 1, .reusable = true}, SHIFT(2489),
  [4192] = {.count = 1, .reusable = true}, SHIFT(2490),
  [4194] = {.count = 1, .reusable = true}, SHIFT(2491),
  [4196] = {.count = 1, .reusable = false}, SHIFT(2493),
  [4198] = {.count = 1, .reusable = true}, SHIFT(2498),
  [4200] = {.count = 1, .reusable = true}, SHIFT(2500),
  [4202] = {.count = 1, .reusable = true}, SHIFT(2501),
  [4204] = {.count = 1, .reusable = false}, SHIFT(2501),
  [4206] = {.count = 1, .reusable = true}, SHIFT(2502),
  [4208] = {.count = 1, .reusable = false}, SHIFT(2466),
  [4210] = {.count = 1, .reusable = true}, SHIFT(2515),
  [4212] = {.count = 1, .reusable = false}, SHIFT(2515),
  [4214] = {.count = 1, .reusable = true}, SHIFT(2516),
  [4216] = {.count = 1, .reusable = true}, SHIFT(2517),
  [4218] = {.count = 1, .reusable = true}, SHIFT(2520),
  [4220] = {.count = 1, .reusable = true}, SHIFT(2523),
  [4222] = {.count = 1, .reusable = true}, SHIFT(2526),
  [4224] = {.count = 1, .reusable = true}, SHIFT(2527),
  [4226] = {.count = 1, .reusable = true}, SHIFT(2534),
  [4228] = {.count = 1, .reusable = false}, SHIFT(2531),
  [4230] = {.count = 1, .reusable = true}, SHIFT(2535),
  [4232] = {.count = 1, .reusable = false}, SHIFT(2538),
  [4234] = {.count = 1, .reusable = true}, SHIFT(934),
  [4236] = {.count = 1, .reusable = true}, SHIFT(2540),
  [4238] = {.count = 1, .reusable = true}, SHIFT(2542),
  [4240] = {.count = 1, .reusable = false}, SHIFT(2526),
  [4242] = {.count = 1, .reusable = true}, SHIFT(2545),
  [4244] = {.count = 1, .reusable = true}, SHIFT(2544),
  [4246] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [4248] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [4250] = {.count = 1, .reusable = true}, SHIFT(2547),
  [4252] = {.count = 1, .reusable = true}, SHIFT(201),
  [4254] = {.count = 1, .reusable = true}, SHIFT(2557),
  [4256] = {.count = 1, .reusable = false}, SHIFT(2558),
  [4258] = {.count = 1, .reusable = false}, SHIFT(2559),
  [4260] = {.count = 1, .reusable = false}, SHIFT(2560),
  [4262] = {.count = 1, .reusable = false}, SHIFT(2561),
  [4264] = {.count = 1, .reusable = false}, SHIFT(2557),
  [4266] = {.count = 1, .reusable = true}, SHIFT(2562),
  [4268] = {.count = 1, .reusable = false}, SHIFT(2562),
  [4270] = {.count = 1, .reusable = true}, SHIFT(2563),
  [4272] = {.count = 1, .reusable = false}, SHIFT(953),
  [4274] = {.count = 1, .reusable = true}, SHIFT(2571),
  [4276] = {.count = 1, .reusable = true}, SHIFT(2573),
  [4278] = {.count = 1, .reusable = true}, SHIFT(2574),
  [4280] = {.count = 1, .reusable = true}, SHIFT(2575),
  [4282] = {.count = 1, .reusable = false}, SHIFT(2577),
  [4284] = {.count = 1, .reusable = false}, SHIFT(2583),
  [4286] = {.count = 1, .reusable = true}, SHIFT(2584),
  [4288] = {.count = 1, .reusable = true}, SHIFT(2585),
  [4290] = {.count = 1, .reusable = false}, SHIFT(2586),
  [4292] = {.count = 1, .reusable = false}, SHIFT(2587),
  [4294] = {.count = 1, .reusable = false}, SHIFT(2588),
  [4296] = {.count = 1, .reusable = true}, SHIFT(2589),
  [4298] = {.count = 1, .reusable = false}, SHIFT(2590),
  [4300] = {.count = 1, .reusable = true}, SHIFT(2590),
  [4302] = {.count = 1, .reusable = true}, SHIFT(2592),
  [4304] = {.count = 1, .reusable = true}, SHIFT(2593),
  [4306] = {.count = 1, .reusable = false}, SHIFT(2592),
  [4308] = {.count = 1, .reusable = true}, SHIFT(2588),
  [4310] = {.count = 1, .reusable = true}, SHIFT(2586),
  [4312] = {.count = 1, .reusable = true}, SHIFT(2594),
  [4314] = {.count = 1, .reusable = true}, SHIFT(2595),
  [4316] = {.count = 1, .reusable = true}, SHIFT(2596),
  [4318] = {.count = 1, .reusable = false}, SHIFT(2598),
  [4320] = {.count = 1, .reusable = true}, SHIFT(2604),
  [4322] = {.count = 1, .reusable = true}, SHIFT(2606),
  [4324] = {.count = 1, .reusable = false}, SHIFT(2606),
  [4326] = {.count = 1, .reusable = true}, SHIFT(2607),
  [4328] = {.count = 1, .reusable = false}, SHIFT(2571),
  [4330] = {.count = 1, .reusable = true}, SHIFT(2611),
  [4332] = {.count = 1, .reusable = true}, SHIFT(2610),
  [4334] = {.count = 1, .reusable = true}, SHIFT(2637),
  [4336] = {.count = 1, .reusable = true}, SHIFT(2617),
  [4338] = {.count = 1, .reusable = false}, SHIFT(2618),
  [4340] = {.count = 1, .reusable = false}, SHIFT(2619),
  [4342] = {.count = 1, .reusable = false}, SHIFT(2620),
  [4344] = {.count = 1, .reusable = false}, SHIFT(2621),
  [4346] = {.count = 1, .reusable = false}, SHIFT(2622),
  [4348] = {.count = 1, .reusable = false}, SHIFT(2623),
  [4350] = {.count = 1, .reusable = false}, SHIFT(2624),
  [4352] = {.count = 1, .reusable = false}, SHIFT(2617),
  [4354] = {.count = 1, .reusable = true}, SHIFT(2625),
  [4356] = {.count = 1, .reusable = false}, SHIFT(2625),
  [4358] = {.count = 1, .reusable = true}, SHIFT(2626),
  [4360] = {.count = 1, .reusable = false}, SHIFT(2633),
  [4362] = {.count = 1, .reusable = true}, SHIFT(2633),
  [4364] = {.count = 1, .reusable = false}, SHIFT(2627),
  [4366] = {.count = 1, .reusable = true}, REDUCE(sym__then, 1),
  [4368] = {.count = 1, .reusable = false}, REDUCE(sym__then, 1),
  [4370] = {.count = 1, .reusable = false}, SHIFT(2638),
  [4372] = {.count = 1, .reusable = true}, SHIFT(2649),
  [4374] = {.count = 1, .reusable = false}, SHIFT(2650),
  [4376] = {.count = 1, .reusable = false}, SHIFT(2651),
  [4378] = {.count = 1, .reusable = false}, SHIFT(2652),
  [4380] = {.count = 1, .reusable = false}, SHIFT(2653),
  [4382] = {.count = 1, .reusable = false}, SHIFT(2649),
  [4384] = {.count = 1, .reusable = true}, SHIFT(2654),
  [4386] = {.count = 1, .reusable = false}, SHIFT(2654),
  [4388] = {.count = 1, .reusable = true}, SHIFT(2655),
  [4390] = {.count = 1, .reusable = false}, SHIFT(2657),
  [4392] = {.count = 1, .reusable = true}, SHIFT(2657),
  [4394] = {.count = 1, .reusable = false}, SHIFT(992),
  [4396] = {.count = 1, .reusable = true}, SHIFT(2664),
  [4398] = {.count = 1, .reusable = false}, SHIFT(2667),
  [4400] = {.count = 1, .reusable = true}, SHIFT(2668),
  [4402] = {.count = 1, .reusable = true}, SHIFT(2669),
  [4404] = {.count = 1, .reusable = false}, SHIFT(2670),
  [4406] = {.count = 1, .reusable = false}, SHIFT(2669),
  [4408] = {.count = 1, .reusable = false}, SHIFT(2671),
  [4410] = {.count = 1, .reusable = false}, SHIFT(2672),
  [4412] = {.count = 1, .reusable = true}, SHIFT(2673),
  [4414] = {.count = 1, .reusable = false}, SHIFT(2674),
  [4416] = {.count = 1, .reusable = true}, SHIFT(2674),
  [4418] = {.count = 1, .reusable = false}, SHIFT(2676),
  [4420] = {.count = 1, .reusable = false}, SHIFT(2677),
  [4422] = {.count = 1, .reusable = true}, SHIFT(2676),
  [4424] = {.count = 1, .reusable = true}, SHIFT(2672),
  [4426] = {.count = 1, .reusable = false}, SHIFT(2668),
  [4428] = {.count = 1, .reusable = true}, SHIFT(2679),
  [4430] = {.count = 1, .reusable = true}, SHIFT(2681),
  [4432] = {.count = 1, .reusable = false}, SHIFT(2681),
  [4434] = {.count = 1, .reusable = true}, SHIFT(2682),
  [4436] = {.count = 1, .reusable = false}, SHIFT(2664),
  [4438] = {.count = 1, .reusable = true}, SHIFT(2684),
  [4440] = {.count = 1, .reusable = true}, SHIFT(2685),
  [4442] = {.count = 1, .reusable = false}, SHIFT(2685),
  [4444] = {.count = 1, .reusable = true}, SHIFT(2686),
  [4446] = {.count = 1, .reusable = false}, SHIFT(2686),
  [4448] = {.count = 1, .reusable = true}, SHIFT(2687),
  [4450] = {.count = 1, .reusable = true}, SHIFT(2694),
  [4452] = {.count = 1, .reusable = false}, SHIFT(2695),
  [4454] = {.count = 1, .reusable = false}, SHIFT(2696),
  [4456] = {.count = 1, .reusable = false}, SHIFT(2697),
  [4458] = {.count = 1, .reusable = false}, SHIFT(2698),
  [4460] = {.count = 1, .reusable = false}, SHIFT(2699),
  [4462] = {.count = 1, .reusable = false}, SHIFT(2694),
  [4464] = {.count = 1, .reusable = true}, SHIFT(2700),
  [4466] = {.count = 1, .reusable = false}, SHIFT(2700),
  [4468] = {.count = 1, .reusable = true}, SHIFT(2701),
  [4470] = {.count = 1, .reusable = false}, SHIFT(2708),
  [4472] = {.count = 1, .reusable = true}, SHIFT(2708),
  [4474] = {.count = 1, .reusable = false}, SHIFT(2702),
  [4476] = {.count = 1, .reusable = false}, SHIFT(2712),
  [4478] = {.count = 1, .reusable = true}, SHIFT(2713),
  [4480] = {.count = 1, .reusable = false}, SHIFT(2714),
  [4482] = {.count = 1, .reusable = false}, SHIFT(2715),
  [4484] = {.count = 1, .reusable = false}, SHIFT(2716),
  [4486] = {.count = 1, .reusable = false}, SHIFT(2717),
  [4488] = {.count = 1, .reusable = false}, SHIFT(2713),
  [4490] = {.count = 1, .reusable = true}, SHIFT(2718),
  [4492] = {.count = 1, .reusable = false}, SHIFT(2718),
  [4494] = {.count = 1, .reusable = true}, SHIFT(2719),
  [4496] = {.count = 1, .reusable = false}, SHIFT(1017),
  [4498] = {.count = 1, .reusable = true}, SHIFT(2727),
  [4500] = {.count = 1, .reusable = true}, SHIFT(2729),
  [4502] = {.count = 1, .reusable = true}, SHIFT(2730),
  [4504] = {.count = 1, .reusable = true}, SHIFT(2731),
  [4506] = {.count = 1, .reusable = false}, SHIFT(2733),
  [4508] = {.count = 1, .reusable = false}, SHIFT(2739),
  [4510] = {.count = 1, .reusable = true}, SHIFT(2740),
  [4512] = {.count = 1, .reusable = true}, SHIFT(2741),
  [4514] = {.count = 1, .reusable = false}, SHIFT(2742),
  [4516] = {.count = 1, .reusable = false}, SHIFT(2743),
  [4518] = {.count = 1, .reusable = false}, SHIFT(2744),
  [4520] = {.count = 1, .reusable = true}, SHIFT(2745),
  [4522] = {.count = 1, .reusable = false}, SHIFT(2746),
  [4524] = {.count = 1, .reusable = true}, SHIFT(2746),
  [4526] = {.count = 1, .reusable = true}, SHIFT(2748),
  [4528] = {.count = 1, .reusable = true}, SHIFT(2749),
  [4530] = {.count = 1, .reusable = false}, SHIFT(2748),
  [4532] = {.count = 1, .reusable = true}, SHIFT(2744),
  [4534] = {.count = 1, .reusable = true}, SHIFT(2742),
  [4536] = {.count = 1, .reusable = true}, SHIFT(2750),
  [4538] = {.count = 1, .reusable = true}, SHIFT(2751),
  [4540] = {.count = 1, .reusable = true}, SHIFT(2752),
  [4542] = {.count = 1, .reusable = true}, SHIFT(2753),
  [4544] = {.count = 1, .reusable = false}, SHIFT(2755),
  [4546] = {.count = 1, .reusable = true}, SHIFT(2761),
  [4548] = {.count = 1, .reusable = true}, SHIFT(2763),
  [4550] = {.count = 1, .reusable = false}, SHIFT(2763),
  [4552] = {.count = 1, .reusable = true}, SHIFT(2764),
  [4554] = {.count = 1, .reusable = false}, SHIFT(2727),
  [4556] = {.count = 1, .reusable = false}, SHIFT(2776),
  [4558] = {.count = 1, .reusable = true}, SHIFT(2778),
  [4560] = {.count = 1, .reusable = false}, SHIFT(2779),
  [4562] = {.count = 1, .reusable = false}, SHIFT(2780),
  [4564] = {.count = 1, .reusable = false}, SHIFT(2781),
  [4566] = {.count = 1, .reusable = false}, SHIFT(2782),
  [4568] = {.count = 1, .reusable = false}, SHIFT(2778),
  [4570] = {.count = 1, .reusable = true}, SHIFT(2783),
  [4572] = {.count = 1, .reusable = false}, SHIFT(2783),
  [4574] = {.count = 1, .reusable = true}, SHIFT(2784),
  [4576] = {.count = 1, .reusable = false}, SHIFT(2786),
  [4578] = {.count = 1, .reusable = true}, SHIFT(2786),
  [4580] = {.count = 1, .reusable = false}, SHIFT(1048),
  [4582] = {.count = 1, .reusable = true}, SHIFT(2793),
  [4584] = {.count = 1, .reusable = true}, SHIFT(2794),
  [4586] = {.count = 1, .reusable = false}, SHIFT(2797),
  [4588] = {.count = 1, .reusable = true}, SHIFT(2798),
  [4590] = {.count = 1, .reusable = true}, SHIFT(2799),
  [4592] = {.count = 1, .reusable = false}, SHIFT(2800),
  [4594] = {.count = 1, .reusable = false}, SHIFT(2799),
  [4596] = {.count = 1, .reusable = false}, SHIFT(2801),
  [4598] = {.count = 1, .reusable = false}, SHIFT(2802),
  [4600] = {.count = 1, .reusable = true}, SHIFT(2803),
  [4602] = {.count = 1, .reusable = false}, SHIFT(2804),
  [4604] = {.count = 1, .reusable = true}, SHIFT(2804),
  [4606] = {.count = 1, .reusable = false}, SHIFT(2806),
  [4608] = {.count = 1, .reusable = false}, SHIFT(2807),
  [4610] = {.count = 1, .reusable = true}, SHIFT(2806),
  [4612] = {.count = 1, .reusable = true}, SHIFT(2802),
  [4614] = {.count = 1, .reusable = false}, SHIFT(2798),
  [4616] = {.count = 1, .reusable = true}, SHIFT(2809),
  [4618] = {.count = 1, .reusable = true}, SHIFT(2811),
  [4620] = {.count = 1, .reusable = false}, SHIFT(2811),
  [4622] = {.count = 1, .reusable = true}, SHIFT(2812),
  [4624] = {.count = 1, .reusable = false}, SHIFT(2793),
  [4626] = {.count = 1, .reusable = true}, SHIFT(2814),
  [4628] = {.count = 1, .reusable = true}, SHIFT(2815),
  [4630] = {.count = 1, .reusable = false}, SHIFT(2815),
  [4632] = {.count = 1, .reusable = true}, SHIFT(2816),
  [4634] = {.count = 1, .reusable = false}, SHIFT(2816),
  [4636] = {.count = 1, .reusable = true}, SHIFT(2817),
  [4638] = {.count = 1, .reusable = false}, SHIFT(2824),
  [4640] = {.count = 1, .reusable = true}, SHIFT(2826),
  [4642] = {.count = 1, .reusable = false}, SHIFT(2827),
  [4644] = {.count = 1, .reusable = false}, SHIFT(2828),
  [4646] = {.count = 1, .reusable = false}, SHIFT(2829),
  [4648] = {.count = 1, .reusable = false}, SHIFT(2830),
  [4650] = {.count = 1, .reusable = false}, SHIFT(2826),
  [4652] = {.count = 1, .reusable = true}, SHIFT(2831),
  [4654] = {.count = 1, .reusable = false}, SHIFT(2831),
  [4656] = {.count = 1, .reusable = true}, SHIFT(2832),
  [4658] = {.count = 1, .reusable = false}, SHIFT(2834),
  [4660] = {.count = 1, .reusable = true}, SHIFT(2834),
  [4662] = {.count = 1, .reusable = true}, SHIFT(2841),
  [4664] = {.count = 1, .reusable = true}, SHIFT(2843),
  [4666] = {.count = 1, .reusable = true}, SHIFT(2844),
  [4668] = {.count = 1, .reusable = true}, SHIFT(2845),
  [4670] = {.count = 1, .reusable = false}, SHIFT(1081),
  [4672] = {.count = 1, .reusable = false}, SHIFT(2847),
  [4674] = {.count = 1, .reusable = false}, SHIFT(2853),
  [4676] = {.count = 1, .reusable = true}, SHIFT(2854),
  [4678] = {.count = 1, .reusable = true}, SHIFT(2855),
  [4680] = {.count = 1, .reusable = false}, SHIFT(2856),
  [4682] = {.count = 1, .reusable = false}, SHIFT(2857),
  [4684] = {.count = 1, .reusable = false}, SHIFT(2858),
  [4686] = {.count = 1, .reusable = true}, SHIFT(2859),
  [4688] = {.count = 1, .reusable = false}, SHIFT(2860),
  [4690] = {.count = 1, .reusable = true}, SHIFT(2860),
  [4692] = {.count = 1, .reusable = true}, SHIFT(2861),
  [4694] = {.count = 1, .reusable = true}, SHIFT(2862),
  [4696] = {.count = 1, .reusable = true}, SHIFT(2863),
  [4698] = {.count = 1, .reusable = false}, SHIFT(2862),
  [4700] = {.count = 1, .reusable = true}, SHIFT(2858),
  [4702] = {.count = 1, .reusable = true}, SHIFT(2856),
  [4704] = {.count = 1, .reusable = true}, SHIFT(2864),
  [4706] = {.count = 1, .reusable = true}, SHIFT(2865),
  [4708] = {.count = 1, .reusable = true}, SHIFT(2866),
  [4710] = {.count = 1, .reusable = true}, SHIFT(2867),
  [4712] = {.count = 1, .reusable = false}, SHIFT(2869),
  [4714] = {.count = 1, .reusable = false}, SHIFT(2870),
  [4716] = {.count = 1, .reusable = false}, SHIFT(2871),
  [4718] = {.count = 1, .reusable = false}, SHIFT(2872),
  [4720] = {.count = 1, .reusable = true}, SHIFT(2873),
  [4722] = {.count = 1, .reusable = false}, SHIFT(2873),
  [4724] = {.count = 1, .reusable = false}, SHIFT(2874),
  [4726] = {.count = 1, .reusable = true}, SHIFT(2874),
  [4728] = {.count = 1, .reusable = false}, SHIFT(2875),
  [4730] = {.count = 1, .reusable = true}, SHIFT(2883),
  [4732] = {.count = 1, .reusable = true}, SHIFT(2885),
  [4734] = {.count = 1, .reusable = false}, SHIFT(2885),
  [4736] = {.count = 1, .reusable = true}, SHIFT(2886),
  [4738] = {.count = 1, .reusable = false}, SHIFT(2841),
  [4740] = {.count = 1, .reusable = true}, SHIFT(2889),
  [4742] = {.count = 1, .reusable = false}, REDUCE(sym__mlhs, 2),
  [4744] = {.count = 1, .reusable = true}, SHIFT(2890),
  [4746] = {.count = 1, .reusable = false}, SHIFT(2891),
  [4748] = {.count = 1, .reusable = false}, SHIFT(2892),
  [4750] = {.count = 1, .reusable = false}, SHIFT(2893),
  [4752] = {.count = 1, .reusable = false}, SHIFT(2894),
  [4754] = {.count = 1, .reusable = false}, SHIFT(2890),
  [4756] = {.count = 1, .reusable = true}, SHIFT(2895),
  [4758] = {.count = 1, .reusable = false}, SHIFT(2895),
  [4760] = {.count = 1, .reusable = true}, SHIFT(2896),
  [4762] = {.count = 1, .reusable = false}, SHIFT(1096),
  [4764] = {.count = 1, .reusable = true}, SHIFT(2904),
  [4766] = {.count = 1, .reusable = true}, SHIFT(2906),
  [4768] = {.count = 1, .reusable = true}, SHIFT(2907),
  [4770] = {.count = 1, .reusable = true}, SHIFT(2908),
  [4772] = {.count = 1, .reusable = false}, SHIFT(2910),
  [4774] = {.count = 1, .reusable = false}, SHIFT(2916),
  [4776] = {.count = 1, .reusable = true}, SHIFT(2917),
  [4778] = {.count = 1, .reusable = true}, SHIFT(2918),
  [4780] = {.count = 1, .reusable = false}, SHIFT(2919),
  [4782] = {.count = 1, .reusable = false}, SHIFT(2920),
  [4784] = {.count = 1, .reusable = false}, SHIFT(2921),
  [4786] = {.count = 1, .reusable = true}, SHIFT(2922),
  [4788] = {.count = 1, .reusable = false}, SHIFT(2923),
  [4790] = {.count = 1, .reusable = true}, SHIFT(2923),
  [4792] = {.count = 1, .reusable = true}, SHIFT(2925),
  [4794] = {.count = 1, .reusable = true}, SHIFT(2926),
  [4796] = {.count = 1, .reusable = false}, SHIFT(2925),
  [4798] = {.count = 1, .reusable = true}, SHIFT(2921),
  [4800] = {.count = 1, .reusable = true}, SHIFT(2919),
  [4802] = {.count = 1, .reusable = true}, SHIFT(2928),
  [4804] = {.count = 1, .reusable = true}, SHIFT(2930),
  [4806] = {.count = 1, .reusable = false}, SHIFT(2930),
  [4808] = {.count = 1, .reusable = true}, SHIFT(2931),
  [4810] = {.count = 1, .reusable = false}, SHIFT(2904),
  [4812] = {.count = 1, .reusable = true}, SHIFT(2944),
  [4814] = {.count = 1, .reusable = true}, SHIFT(2945),
  [4816] = {.count = 1, .reusable = true}, SHIFT(2946),
  [4818] = {.count = 1, .reusable = false}, SHIFT(2946),
  [4820] = {.count = 1, .reusable = true}, SHIFT(2947),
  [4822] = {.count = 1, .reusable = false}, SHIFT(2947),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2948),
  [4826] = {.count = 1, .reusable = true}, SHIFT(2955),
  [4828] = {.count = 1, .reusable = true}, SHIFT(2956),
  [4830] = {.count = 1, .reusable = false}, SHIFT(2957),
  [4832] = {.count = 1, .reusable = false}, SHIFT(2958),
  [4834] = {.count = 1, .reusable = false}, SHIFT(2959),
  [4836] = {.count = 1, .reusable = false}, SHIFT(2960),
  [4838] = {.count = 1, .reusable = false}, SHIFT(2956),
  [4840] = {.count = 1, .reusable = true}, SHIFT(2961),
  [4842] = {.count = 1, .reusable = false}, SHIFT(2961),
  [4844] = {.count = 1, .reusable = true}, SHIFT(2962),
  [4846] = {.count = 1, .reusable = false}, SHIFT(2965),
  [4848] = {.count = 1, .reusable = true}, SHIFT(2965),
  [4850] = {.count = 1, .reusable = true}, SHIFT(2970),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2971),
  [4854] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2972),
  [4858] = {.count = 1, .reusable = true}, SHIFT(2973),
  [4860] = {.count = 1, .reusable = false}, SHIFT(2974),
  [4862] = {.count = 1, .reusable = false}, SHIFT(2975),
  [4864] = {.count = 1, .reusable = false}, SHIFT(2976),
  [4866] = {.count = 1, .reusable = false}, SHIFT(2977),
  [4868] = {.count = 1, .reusable = false}, SHIFT(2973),
  [4870] = {.count = 1, .reusable = true}, SHIFT(2978),
  [4872] = {.count = 1, .reusable = false}, SHIFT(2978),
  [4874] = {.count = 1, .reusable = true}, SHIFT(2979),
  [4876] = {.count = 1, .reusable = false}, SHIFT(1136),
  [4878] = {.count = 1, .reusable = true}, SHIFT(2987),
  [4880] = {.count = 1, .reusable = true}, SHIFT(2989),
  [4882] = {.count = 1, .reusable = true}, SHIFT(2990),
  [4884] = {.count = 1, .reusable = true}, SHIFT(2991),
  [4886] = {.count = 1, .reusable = false}, SHIFT(2993),
  [4888] = {.count = 1, .reusable = false}, SHIFT(2999),
  [4890] = {.count = 1, .reusable = true}, SHIFT(3000),
  [4892] = {.count = 1, .reusable = true}, SHIFT(3001),
  [4894] = {.count = 1, .reusable = false}, SHIFT(3002),
  [4896] = {.count = 1, .reusable = false}, SHIFT(3003),
  [4898] = {.count = 1, .reusable = false}, SHIFT(3004),
  [4900] = {.count = 1, .reusable = true}, SHIFT(3005),
  [4902] = {.count = 1, .reusable = false}, SHIFT(3006),
  [4904] = {.count = 1, .reusable = true}, SHIFT(3006),
  [4906] = {.count = 1, .reusable = true}, SHIFT(3008),
  [4908] = {.count = 1, .reusable = true}, SHIFT(3009),
  [4910] = {.count = 1, .reusable = false}, SHIFT(3008),
  [4912] = {.count = 1, .reusable = true}, SHIFT(3004),
  [4914] = {.count = 1, .reusable = true}, SHIFT(3002),
  [4916] = {.count = 1, .reusable = true}, SHIFT(3010),
  [4918] = {.count = 1, .reusable = true}, SHIFT(3011),
  [4920] = {.count = 1, .reusable = true}, SHIFT(3012),
  [4922] = {.count = 1, .reusable = false}, SHIFT(3014),
  [4924] = {.count = 1, .reusable = true}, SHIFT(3020),
  [4926] = {.count = 1, .reusable = true}, SHIFT(3022),
  [4928] = {.count = 1, .reusable = false}, SHIFT(3022),
  [4930] = {.count = 1, .reusable = true}, SHIFT(3023),
  [4932] = {.count = 1, .reusable = false}, SHIFT(2987),
  [4934] = {.count = 1, .reusable = true}, SHIFT(3027),
  [4936] = {.count = 1, .reusable = true}, SHIFT(3028),
  [4938] = {.count = 1, .reusable = true}, SHIFT(3029),
  [4940] = {.count = 1, .reusable = true}, SHIFT(3030),
  [4942] = {.count = 1, .reusable = true}, SHIFT(3032),
  [4944] = {.count = 1, .reusable = false}, SHIFT(3032),
  [4946] = {.count = 1, .reusable = false}, SHIFT(3033),
  [4948] = {.count = 1, .reusable = true}, SHIFT(3033),
  [4950] = {.count = 1, .reusable = false}, SHIFT(3034),
  [4952] = {.count = 1, .reusable = true}, SHIFT(3044),
  [4954] = {.count = 1, .reusable = false}, SHIFT(3044),
  [4956] = {.count = 1, .reusable = false}, SHIFT(3045),
  [4958] = {.count = 1, .reusable = true}, SHIFT(3045),
  [4960] = {.count = 1, .reusable = false}, SHIFT(3041),
  [4962] = {.count = 1, .reusable = false}, SHIFT(3042),
  [4964] = {.count = 1, .reusable = false}, SHIFT(3043),
  [4966] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 2),
  [4968] = {.count = 1, .reusable = true}, SHIFT(3050),
  [4970] = {.count = 1, .reusable = true}, REDUCE(sym__arg_or_splat_arg, 1),
  [4972] = {.count = 1, .reusable = true}, SHIFT(3052),
  [4974] = {.count = 1, .reusable = true}, SHIFT(3053),
  [4976] = {.count = 1, .reusable = false}, SHIFT(3054),
  [4978] = {.count = 1, .reusable = false}, SHIFT(3055),
  [4980] = {.count = 1, .reusable = false}, SHIFT(3056),
  [4982] = {.count = 1, .reusable = true}, SHIFT(3057),
  [4984] = {.count = 1, .reusable = false}, SHIFT(3058),
  [4986] = {.count = 1, .reusable = true}, SHIFT(3058),
  [4988] = {.count = 1, .reusable = true}, SHIFT(3059),
  [4990] = {.count = 1, .reusable = true}, SHIFT(3060),
  [4992] = {.count = 1, .reusable = true}, SHIFT(3061),
  [4994] = {.count = 1, .reusable = false}, SHIFT(3060),
  [4996] = {.count = 1, .reusable = true}, SHIFT(3056),
  [4998] = {.count = 1, .reusable = true}, SHIFT(3054),
  [5000] = {.count = 1, .reusable = true}, SHIFT(3062),
  [5002] = {.count = 1, .reusable = true}, SHIFT(3063),
  [5004] = {.count = 1, .reusable = true}, SHIFT(3064),
  [5006] = {.count = 1, .reusable = true}, SHIFT(3065),
  [5008] = {.count = 1, .reusable = false}, SHIFT(3067),
  [5010] = {.count = 1, .reusable = false}, SHIFT(3068),
  [5012] = {.count = 1, .reusable = false}, SHIFT(3069),
  [5014] = {.count = 1, .reusable = false}, SHIFT(3070),
  [5016] = {.count = 1, .reusable = true}, SHIFT(3071),
  [5018] = {.count = 1, .reusable = false}, SHIFT(3071),
  [5020] = {.count = 1, .reusable = false}, SHIFT(3072),
  [5022] = {.count = 1, .reusable = true}, SHIFT(3072),
  [5024] = {.count = 1, .reusable = false}, SHIFT(3073),
  [5026] = {.count = 1, .reusable = true}, SHIFT(3075),
  [5028] = {.count = 1, .reusable = false}, SHIFT(3075),
  [5030] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 1),
  [5032] = {.count = 1, .reusable = true}, SHIFT(3081),
  [5034] = {.count = 1, .reusable = true}, SHIFT(3083),
  [5036] = {.count = 1, .reusable = false}, SHIFT(3083),
  [5038] = {.count = 1, .reusable = true}, SHIFT(3084),
  [5040] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [5042] = {.count = 1, .reusable = true}, SHIFT(3087),
  [5044] = {.count = 1, .reusable = true}, SHIFT(3088),
  [5046] = {.count = 1, .reusable = true}, SHIFT(3089),
  [5048] = {.count = 1, .reusable = true}, SHIFT(3090),
  [5050] = {.count = 1, .reusable = false}, SHIFT(3092),
  [5052] = {.count = 1, .reusable = false}, SHIFT(3093),
  [5054] = {.count = 1, .reusable = false}, SHIFT(3094),
  [5056] = {.count = 1, .reusable = false}, SHIFT(3095),
  [5058] = {.count = 1, .reusable = true}, SHIFT(3096),
  [5060] = {.count = 1, .reusable = false}, SHIFT(3096),
  [5062] = {.count = 1, .reusable = false}, SHIFT(3097),
  [5064] = {.count = 1, .reusable = true}, SHIFT(3097),
  [5066] = {.count = 1, .reusable = false}, SHIFT(3098),
  [5068] = {.count = 1, .reusable = true}, SHIFT(3100),
  [5070] = {.count = 1, .reusable = false}, SHIFT(3100),
  [5072] = {.count = 1, .reusable = true}, SHIFT(3107),
  [5074] = {.count = 1, .reusable = true}, REDUCE(sym_else, 2),
  [5076] = {.count = 1, .reusable = true}, SHIFT(3108),
  [5078] = {.count = 1, .reusable = true}, SHIFT(3110),
  [5080] = {.count = 1, .reusable = true}, SHIFT(3111),
  [5082] = {.count = 1, .reusable = true}, SHIFT(3112),
  [5084] = {.count = 1, .reusable = true}, SHIFT(3113),
  [5086] = {.count = 1, .reusable = true}, SHIFT(3114),
  [5088] = {.count = 1, .reusable = true}, SHIFT(3115),
  [5090] = {.count = 1, .reusable = true}, SHIFT(3116),
  [5092] = {.count = 1, .reusable = false}, SHIFT(3117),
  [5094] = {.count = 1, .reusable = false}, SHIFT(3118),
  [5096] = {.count = 1, .reusable = false}, SHIFT(3119),
  [5098] = {.count = 1, .reusable = true}, SHIFT(3120),
  [5100] = {.count = 1, .reusable = false}, SHIFT(3121),
  [5102] = {.count = 1, .reusable = true}, SHIFT(3121),
  [5104] = {.count = 1, .reusable = true}, SHIFT(3122),
  [5106] = {.count = 1, .reusable = true}, SHIFT(3123),
  [5108] = {.count = 1, .reusable = true}, SHIFT(3124),
  [5110] = {.count = 1, .reusable = false}, SHIFT(3123),
  [5112] = {.count = 1, .reusable = true}, SHIFT(3119),
  [5114] = {.count = 1, .reusable = true}, SHIFT(3117),
  [5116] = {.count = 1, .reusable = true}, SHIFT(3125),
  [5118] = {.count = 1, .reusable = true}, SHIFT(3126),
  [5120] = {.count = 1, .reusable = true}, SHIFT(3127),
  [5122] = {.count = 1, .reusable = true}, SHIFT(3128),
  [5124] = {.count = 1, .reusable = false}, SHIFT(3130),
  [5126] = {.count = 1, .reusable = false}, SHIFT(3131),
  [5128] = {.count = 1, .reusable = false}, SHIFT(3132),
  [5130] = {.count = 1, .reusable = false}, SHIFT(3133),
  [5132] = {.count = 1, .reusable = true}, SHIFT(3134),
  [5134] = {.count = 1, .reusable = false}, SHIFT(3134),
  [5136] = {.count = 1, .reusable = false}, SHIFT(3135),
  [5138] = {.count = 1, .reusable = true}, SHIFT(3135),
  [5140] = {.count = 1, .reusable = false}, SHIFT(3136),
  [5142] = {.count = 1, .reusable = true}, SHIFT(3138),
  [5144] = {.count = 1, .reusable = false}, SHIFT(3138),
  [5146] = {.count = 1, .reusable = true}, SHIFT(3144),
  [5148] = {.count = 1, .reusable = false}, SHIFT(3144),
  [5150] = {.count = 1, .reusable = true}, SHIFT(3145),
  [5152] = {.count = 1, .reusable = false}, REDUCE(sym_else, 2),
  [5154] = {.count = 1, .reusable = true}, SHIFT(3149),
  [5156] = {.count = 1, .reusable = true}, SHIFT(3150),
  [5158] = {.count = 1, .reusable = true}, SHIFT(3151),
  [5160] = {.count = 1, .reusable = true}, SHIFT(3152),
  [5162] = {.count = 1, .reusable = false}, SHIFT(3154),
  [5164] = {.count = 1, .reusable = false}, SHIFT(3155),
  [5166] = {.count = 1, .reusable = false}, SHIFT(3156),
  [5168] = {.count = 1, .reusable = false}, SHIFT(3157),
  [5170] = {.count = 1, .reusable = true}, SHIFT(3158),
  [5172] = {.count = 1, .reusable = false}, SHIFT(3158),
  [5174] = {.count = 1, .reusable = false}, SHIFT(3159),
  [5176] = {.count = 1, .reusable = true}, SHIFT(3159),
  [5178] = {.count = 1, .reusable = false}, SHIFT(3160),
  [5180] = {.count = 1, .reusable = true}, SHIFT(3162),
  [5182] = {.count = 1, .reusable = false}, SHIFT(3162),
  [5184] = {.count = 1, .reusable = true}, SHIFT(3169),
  [5186] = {.count = 1, .reusable = true}, REDUCE(sym_ensure, 2),
  [5188] = {.count = 1, .reusable = true}, SHIFT(3170),
  [5190] = {.count = 1, .reusable = true}, SHIFT(3172),
  [5192] = {.count = 1, .reusable = true}, SHIFT(3173),
  [5194] = {.count = 1, .reusable = true}, SHIFT(3174),
  [5196] = {.count = 1, .reusable = true}, SHIFT(3175),
  [5198] = {.count = 1, .reusable = true}, SHIFT(3176),
  [5200] = {.count = 1, .reusable = true}, SHIFT(3177),
  [5202] = {.count = 1, .reusable = true}, SHIFT(3178),
  [5204] = {.count = 1, .reusable = false}, SHIFT(3179),
  [5206] = {.count = 1, .reusable = false}, SHIFT(3180),
  [5208] = {.count = 1, .reusable = false}, SHIFT(3181),
  [5210] = {.count = 1, .reusable = true}, SHIFT(3182),
  [5212] = {.count = 1, .reusable = false}, SHIFT(3183),
  [5214] = {.count = 1, .reusable = true}, SHIFT(3183),
  [5216] = {.count = 1, .reusable = true}, SHIFT(3184),
  [5218] = {.count = 1, .reusable = true}, SHIFT(3185),
  [5220] = {.count = 1, .reusable = true}, SHIFT(3186),
  [5222] = {.count = 1, .reusable = false}, SHIFT(3185),
  [5224] = {.count = 1, .reusable = true}, SHIFT(3181),
  [5226] = {.count = 1, .reusable = true}, SHIFT(3179),
  [5228] = {.count = 1, .reusable = true}, SHIFT(3187),
  [5230] = {.count = 1, .reusable = true}, SHIFT(3188),
  [5232] = {.count = 1, .reusable = true}, SHIFT(3189),
  [5234] = {.count = 1, .reusable = true}, SHIFT(3190),
  [5236] = {.count = 1, .reusable = false}, SHIFT(3192),
  [5238] = {.count = 1, .reusable = false}, SHIFT(3193),
  [5240] = {.count = 1, .reusable = false}, SHIFT(3194),
  [5242] = {.count = 1, .reusable = false}, SHIFT(3195),
  [5244] = {.count = 1, .reusable = true}, SHIFT(3196),
  [5246] = {.count = 1, .reusable = false}, SHIFT(3196),
  [5248] = {.count = 1, .reusable = false}, SHIFT(3197),
  [5250] = {.count = 1, .reusable = true}, SHIFT(3197),
  [5252] = {.count = 1, .reusable = false}, SHIFT(3198),
  [5254] = {.count = 1, .reusable = true}, SHIFT(3200),
  [5256] = {.count = 1, .reusable = false}, SHIFT(3200),
  [5258] = {.count = 1, .reusable = true}, SHIFT(3206),
  [5260] = {.count = 1, .reusable = false}, SHIFT(3206),
  [5262] = {.count = 1, .reusable = true}, SHIFT(3207),
  [5264] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 2),
  [5266] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 2),
  [5268] = {.count = 1, .reusable = true}, SHIFT(3210),
  [5270] = {.count = 1, .reusable = true}, SHIFT(3213),
  [5272] = {.count = 1, .reusable = true}, SHIFT(3230),
  [5274] = {.count = 1, .reusable = false}, SHIFT(3231),
  [5276] = {.count = 1, .reusable = false}, SHIFT(3232),
  [5278] = {.count = 1, .reusable = false}, SHIFT(3233),
  [5280] = {.count = 1, .reusable = false}, SHIFT(3234),
  [5282] = {.count = 1, .reusable = false}, SHIFT(3230),
  [5284] = {.count = 1, .reusable = true}, SHIFT(3235),
  [5286] = {.count = 1, .reusable = false}, SHIFT(3235),
  [5288] = {.count = 1, .reusable = true}, SHIFT(3236),
  [5290] = {.count = 1, .reusable = false}, SHIFT(3238),
  [5292] = {.count = 1, .reusable = true}, SHIFT(3238),
  [5294] = {.count = 1, .reusable = false}, SHIFT(1230),
  [5296] = {.count = 1, .reusable = true}, SHIFT(3245),
  [5298] = {.count = 1, .reusable = false}, SHIFT(3248),
  [5300] = {.count = 1, .reusable = true}, SHIFT(3249),
  [5302] = {.count = 1, .reusable = true}, SHIFT(3250),
  [5304] = {.count = 1, .reusable = false}, SHIFT(3251),
  [5306] = {.count = 1, .reusable = false}, SHIFT(3250),
  [5308] = {.count = 1, .reusable = false}, SHIFT(3252),
  [5310] = {.count = 1, .reusable = false}, SHIFT(3253),
  [5312] = {.count = 1, .reusable = true}, SHIFT(3254),
  [5314] = {.count = 1, .reusable = false}, SHIFT(3255),
  [5316] = {.count = 1, .reusable = true}, SHIFT(3255),
  [5318] = {.count = 1, .reusable = false}, SHIFT(3257),
  [5320] = {.count = 1, .reusable = false}, SHIFT(3258),
  [5322] = {.count = 1, .reusable = true}, SHIFT(3257),
  [5324] = {.count = 1, .reusable = true}, SHIFT(3253),
  [5326] = {.count = 1, .reusable = false}, SHIFT(3249),
  [5328] = {.count = 1, .reusable = true}, SHIFT(3260),
  [5330] = {.count = 1, .reusable = true}, SHIFT(3262),
  [5332] = {.count = 1, .reusable = false}, SHIFT(3262),
  [5334] = {.count = 1, .reusable = true}, SHIFT(3263),
  [5336] = {.count = 1, .reusable = false}, SHIFT(3245),
  [5338] = {.count = 1, .reusable = true}, SHIFT(3265),
  [5340] = {.count = 1, .reusable = true}, SHIFT(3266),
  [5342] = {.count = 1, .reusable = false}, SHIFT(3266),
  [5344] = {.count = 1, .reusable = true}, SHIFT(3267),
  [5346] = {.count = 1, .reusable = false}, SHIFT(3267),
  [5348] = {.count = 1, .reusable = true}, SHIFT(3268),
  [5350] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 3),
  [5352] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 3),
  [5354] = {.count = 1, .reusable = true}, SHIFT(3275),
  [5356] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 3),
  [5358] = {.count = 1, .reusable = true}, SHIFT(3277),
  [5360] = {.count = 1, .reusable = true}, REDUCE(sym_alias, 3),
  [5362] = {.count = 1, .reusable = true}, SHIFT(3278),
  [5364] = {.count = 1, .reusable = true}, SHIFT(3279),
  [5366] = {.count = 1, .reusable = true}, SHIFT(3280),
  [5368] = {.count = 1, .reusable = true}, SHIFT(3281),
  [5370] = {.count = 1, .reusable = true}, SHIFT(3282),
  [5372] = {.count = 1, .reusable = false}, SHIFT(3283),
  [5374] = {.count = 1, .reusable = true}, SHIFT(3285),
  [5376] = {.count = 1, .reusable = true}, SHIFT(3286),
  [5378] = {.count = 1, .reusable = true}, SHIFT(3288),
  [5380] = {.count = 1, .reusable = false}, SHIFT(3289),
  [5382] = {.count = 1, .reusable = true}, SHIFT(3291),
  [5384] = {.count = 1, .reusable = true}, SHIFT(3292),
  [5386] = {.count = 1, .reusable = true}, SHIFT(3295),
  [5388] = {.count = 1, .reusable = true}, SHIFT(3296),
  [5390] = {.count = 1, .reusable = true}, SHIFT(3297),
  [5392] = {.count = 1, .reusable = false}, SHIFT(3299),
  [5394] = {.count = 1, .reusable = true}, SHIFT(3305),
  [5396] = {.count = 1, .reusable = true}, SHIFT(3306),
  [5398] = {.count = 1, .reusable = false}, SHIFT(3307),
  [5400] = {.count = 1, .reusable = false}, SHIFT(3308),
  [5402] = {.count = 1, .reusable = false}, SHIFT(3309),
  [5404] = {.count = 1, .reusable = true}, SHIFT(3310),
  [5406] = {.count = 1, .reusable = false}, SHIFT(3311),
  [5408] = {.count = 1, .reusable = true}, SHIFT(3311),
  [5410] = {.count = 1, .reusable = true}, SHIFT(3312),
  [5412] = {.count = 1, .reusable = true}, SHIFT(3313),
  [5414] = {.count = 1, .reusable = true}, SHIFT(3314),
  [5416] = {.count = 1, .reusable = false}, SHIFT(3313),
  [5418] = {.count = 1, .reusable = true}, SHIFT(3309),
  [5420] = {.count = 1, .reusable = true}, SHIFT(3307),
  [5422] = {.count = 1, .reusable = true}, SHIFT(3315),
  [5424] = {.count = 1, .reusable = true}, SHIFT(3316),
  [5426] = {.count = 1, .reusable = true}, SHIFT(3317),
  [5428] = {.count = 1, .reusable = false}, SHIFT(3319),
  [5430] = {.count = 1, .reusable = true}, SHIFT(3324),
  [5432] = {.count = 1, .reusable = false}, SHIFT(3324),
  [5434] = {.count = 1, .reusable = true}, SHIFT(3325),
  [5436] = {.count = 1, .reusable = true}, SHIFT(3328),
  [5438] = {.count = 1, .reusable = true}, SHIFT(3331),
  [5440] = {.count = 1, .reusable = true}, SHIFT(3332),
  [5442] = {.count = 1, .reusable = true}, SHIFT(3333),
  [5444] = {.count = 1, .reusable = true}, SHIFT(3336),
  [5446] = {.count = 1, .reusable = true}, SHIFT(3338),
  [5448] = {.count = 1, .reusable = false}, SHIFT(3337),
  [5450] = {.count = 1, .reusable = false}, SHIFT(1305),
  [5452] = {.count = 1, .reusable = true}, SHIFT(3342),
  [5454] = {.count = 1, .reusable = false}, SHIFT(3345),
  [5456] = {.count = 1, .reusable = true}, SHIFT(3346),
  [5458] = {.count = 1, .reusable = true}, SHIFT(3347),
  [5460] = {.count = 1, .reusable = false}, SHIFT(3348),
  [5462] = {.count = 1, .reusable = false}, SHIFT(3349),
  [5464] = {.count = 1, .reusable = false}, SHIFT(3350),
  [5466] = {.count = 1, .reusable = true}, SHIFT(3351),
  [5468] = {.count = 1, .reusable = false}, SHIFT(3352),
  [5470] = {.count = 1, .reusable = true}, SHIFT(3352),
  [5472] = {.count = 1, .reusable = true}, SHIFT(3354),
  [5474] = {.count = 1, .reusable = true}, SHIFT(3355),
  [5476] = {.count = 1, .reusable = false}, SHIFT(3354),
  [5478] = {.count = 1, .reusable = true}, SHIFT(3350),
  [5480] = {.count = 1, .reusable = true}, SHIFT(3348),
  [5482] = {.count = 1, .reusable = true}, SHIFT(3357),
  [5484] = {.count = 1, .reusable = true}, SHIFT(3359),
  [5486] = {.count = 1, .reusable = false}, SHIFT(3359),
  [5488] = {.count = 1, .reusable = true}, SHIFT(3360),
  [5490] = {.count = 1, .reusable = false}, SHIFT(3342),
  [5492] = {.count = 1, .reusable = true}, SHIFT(3361),
  [5494] = {.count = 1, .reusable = true}, SHIFT(3362),
  [5496] = {.count = 1, .reusable = true}, SHIFT(3363),
  [5498] = {.count = 1, .reusable = true}, SHIFT(3364),
  [5500] = {.count = 1, .reusable = true}, SHIFT(3366),
  [5502] = {.count = 1, .reusable = true}, SHIFT(3368),
  [5504] = {.count = 1, .reusable = true}, SHIFT(3369),
  [5506] = {.count = 1, .reusable = false}, SHIFT(3373),
  [5508] = {.count = 1, .reusable = true}, SHIFT(3375),
  [5510] = {.count = 1, .reusable = true}, SHIFT(3377),
  [5512] = {.count = 1, .reusable = true}, SHIFT(3383),
  [5514] = {.count = 1, .reusable = false}, SHIFT(3380),
  [5516] = {.count = 1, .reusable = true}, SHIFT(1342),
  [5518] = {.count = 1, .reusable = true}, SHIFT(3395),
  [5520] = {.count = 1, .reusable = false}, SHIFT(3395),
  [5522] = {.count = 1, .reusable = true}, SHIFT(3396),
  [5524] = {.count = 1, .reusable = true}, SHIFT(3397),
  [5526] = {.count = 1, .reusable = true}, SHIFT(3400),
  [5528] = {.count = 1, .reusable = true}, SHIFT(3403),
  [5530] = {.count = 1, .reusable = false}, SHIFT(1360),
  [5532] = {.count = 1, .reusable = true}, SHIFT(3408),
  [5534] = {.count = 1, .reusable = true}, SHIFT(3409),
  [5536] = {.count = 1, .reusable = true}, SHIFT(3416),
  [5538] = {.count = 1, .reusable = false}, SHIFT(3413),
  [5540] = {.count = 1, .reusable = false}, SHIFT(3418),
  [5542] = {.count = 1, .reusable = true}, SHIFT(3419),
  [5544] = {.count = 1, .reusable = true}, SHIFT(3420),
  [5546] = {.count = 1, .reusable = false}, SHIFT(3421),
  [5548] = {.count = 1, .reusable = false}, SHIFT(3420),
  [5550] = {.count = 1, .reusable = false}, SHIFT(3422),
  [5552] = {.count = 1, .reusable = false}, SHIFT(3423),
  [5554] = {.count = 1, .reusable = true}, SHIFT(3424),
  [5556] = {.count = 1, .reusable = false}, SHIFT(3425),
  [5558] = {.count = 1, .reusable = true}, SHIFT(3425),
  [5560] = {.count = 1, .reusable = false}, SHIFT(3427),
  [5562] = {.count = 1, .reusable = false}, SHIFT(3428),
  [5564] = {.count = 1, .reusable = true}, SHIFT(3427),
  [5566] = {.count = 1, .reusable = true}, SHIFT(3423),
  [5568] = {.count = 1, .reusable = false}, SHIFT(3419),
  [5570] = {.count = 1, .reusable = true}, SHIFT(1368),
  [5572] = {.count = 1, .reusable = true}, SHIFT(3431),
  [5574] = {.count = 1, .reusable = true}, SHIFT(3433),
  [5576] = {.count = 1, .reusable = false}, SHIFT(3433),
  [5578] = {.count = 1, .reusable = true}, SHIFT(3434),
  [5580] = {.count = 1, .reusable = false}, SHIFT(3408),
  [5582] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [5584] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [5586] = {.count = 1, .reusable = true}, SHIFT(3436),
  [5588] = {.count = 1, .reusable = true}, SHIFT(3437),
  [5590] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 2),
  [5592] = {.count = 1, .reusable = true}, SHIFT(3440),
  [5594] = {.count = 1, .reusable = true}, REDUCE(sym_block, 2),
  [5596] = {.count = 1, .reusable = false}, REDUCE(sym_block, 2),
  [5598] = {.count = 1, .reusable = true}, SHIFT(3446),
  [5600] = {.count = 1, .reusable = true}, SHIFT(3447),
  [5602] = {.count = 1, .reusable = true}, SHIFT(3448),
  [5604] = {.count = 1, .reusable = true}, SHIFT(3449),
  [5606] = {.count = 1, .reusable = true}, SHIFT(3451),
  [5608] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 2),
  [5610] = {.count = 1, .reusable = true}, SHIFT(3454),
  [5612] = {.count = 1, .reusable = true}, SHIFT(3455),
  [5614] = {.count = 1, .reusable = true}, SHIFT(3456),
  [5616] = {.count = 1, .reusable = true}, SHIFT(3457),
  [5618] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 2),
  [5620] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 2),
  [5622] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameter, 2),
  [5624] = {.count = 1, .reusable = true}, SHIFT(3459),
  [5626] = {.count = 1, .reusable = true}, SHIFT(3460),
  [5628] = {.count = 1, .reusable = true}, SHIFT(3461),
  [5630] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 2),
  [5632] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 2),
  [5634] = {.count = 1, .reusable = true}, SHIFT(3463),
  [5636] = {.count = 1, .reusable = true}, SHIFT(3465),
  [5638] = {.count = 1, .reusable = false}, SHIFT(3463),
  [5640] = {.count = 1, .reusable = true}, SHIFT(3467),
  [5642] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 2),
  [5644] = {.count = 1, .reusable = false}, SHIFT(3468),
  [5646] = {.count = 1, .reusable = false}, SHIFT(3469),
  [5648] = {.count = 1, .reusable = false}, SHIFT(3470),
  [5650] = {.count = 1, .reusable = false}, SHIFT(3471),
  [5652] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 2),
  [5654] = {.count = 1, .reusable = false}, SHIFT(3467),
  [5656] = {.count = 1, .reusable = true}, SHIFT(3472),
  [5658] = {.count = 1, .reusable = false}, SHIFT(3472),
  [5660] = {.count = 1, .reusable = true}, SHIFT(3473),
  [5662] = {.count = 1, .reusable = false}, SHIFT(3475),
  [5664] = {.count = 1, .reusable = true}, SHIFT(3475),
  [5666] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3),
  [5668] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 3),
  [5670] = {.count = 1, .reusable = true}, SHIFT(362),
  [5672] = {.count = 1, .reusable = false}, SHIFT(3482),
  [5674] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [5676] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 3),
  [5678] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 3),
  [5680] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3483),
  [5683] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(272),
  [5686] = {.count = 1, .reusable = true}, REDUCE(sym_if_modifier, 3),
  [5688] = {.count = 1, .reusable = true}, REDUCE(sym_unless_modifier, 3),
  [5690] = {.count = 1, .reusable = true}, REDUCE(sym_while_modifier, 3),
  [5692] = {.count = 1, .reusable = true}, REDUCE(sym_until_modifier, 3),
  [5694] = {.count = 1, .reusable = true}, REDUCE(sym_rescue_modifier, 3),
  [5696] = {.count = 1, .reusable = true}, REDUCE(sym_binary, 3),
  [5698] = {.count = 1, .reusable = false}, REDUCE(sym_binary, 3),
  [5700] = {.count = 1, .reusable = true}, SHIFT(3484),
  [5702] = {.count = 1, .reusable = true}, SHIFT(3487),
  [5704] = {.count = 1, .reusable = true}, SHIFT(3488),
  [5706] = {.count = 1, .reusable = true}, SHIFT(3489),
  [5708] = {.count = 1, .reusable = true}, SHIFT(3490),
  [5710] = {.count = 1, .reusable = false}, SHIFT(3492),
  [5712] = {.count = 1, .reusable = false}, SHIFT(3493),
  [5714] = {.count = 1, .reusable = false}, SHIFT(3494),
  [5716] = {.count = 1, .reusable = false}, SHIFT(3495),
  [5718] = {.count = 1, .reusable = true}, SHIFT(3496),
  [5720] = {.count = 1, .reusable = false}, SHIFT(3496),
  [5722] = {.count = 1, .reusable = false}, SHIFT(3497),
  [5724] = {.count = 1, .reusable = true}, SHIFT(3497),
  [5726] = {.count = 1, .reusable = false}, SHIFT(3498),
  [5728] = {.count = 1, .reusable = true}, SHIFT(3500),
  [5730] = {.count = 1, .reusable = false}, SHIFT(3500),
  [5732] = {.count = 1, .reusable = true}, SHIFT(3507),
  [5734] = {.count = 1, .reusable = true}, SHIFT(3508),
  [5736] = {.count = 1, .reusable = false}, SHIFT(3509),
  [5738] = {.count = 1, .reusable = false}, SHIFT(3510),
  [5740] = {.count = 1, .reusable = false}, SHIFT(3511),
  [5742] = {.count = 1, .reusable = true}, SHIFT(3512),
  [5744] = {.count = 1, .reusable = true}, SHIFT(3513),
  [5746] = {.count = 1, .reusable = false}, SHIFT(3514),
  [5748] = {.count = 1, .reusable = true}, SHIFT(3514),
  [5750] = {.count = 1, .reusable = true}, SHIFT(3515),
  [5752] = {.count = 1, .reusable = true}, SHIFT(3516),
  [5754] = {.count = 1, .reusable = true}, SHIFT(3517),
  [5756] = {.count = 1, .reusable = false}, SHIFT(3516),
  [5758] = {.count = 1, .reusable = true}, SHIFT(3511),
  [5760] = {.count = 1, .reusable = true}, SHIFT(3509),
  [5762] = {.count = 1, .reusable = true}, SHIFT(3518),
  [5764] = {.count = 1, .reusable = true}, SHIFT(3519),
  [5766] = {.count = 1, .reusable = true}, SHIFT(3520),
  [5768] = {.count = 1, .reusable = true}, SHIFT(3521),
  [5770] = {.count = 1, .reusable = false}, SHIFT(3523),
  [5772] = {.count = 1, .reusable = false}, SHIFT(3524),
  [5774] = {.count = 1, .reusable = false}, SHIFT(3525),
  [5776] = {.count = 1, .reusable = false}, SHIFT(3526),
  [5778] = {.count = 1, .reusable = true}, SHIFT(3527),
  [5780] = {.count = 1, .reusable = false}, SHIFT(3527),
  [5782] = {.count = 1, .reusable = false}, SHIFT(3528),
  [5784] = {.count = 1, .reusable = true}, SHIFT(3528),
  [5786] = {.count = 1, .reusable = false}, SHIFT(3529),
  [5788] = {.count = 1, .reusable = true}, SHIFT(3531),
  [5790] = {.count = 1, .reusable = false}, SHIFT(3531),
  [5792] = {.count = 1, .reusable = true}, SHIFT(3537),
  [5794] = {.count = 1, .reusable = false}, SHIFT(3537),
  [5796] = {.count = 1, .reusable = true}, SHIFT(3538),
  [5798] = {.count = 1, .reusable = true}, REDUCE(sym_range, 3),
  [5800] = {.count = 1, .reusable = true}, SHIFT(3541),
  [5802] = {.count = 1, .reusable = true}, SHIFT(3540),
  [5804] = {.count = 1, .reusable = true}, SHIFT(3542),
  [5806] = {.count = 1, .reusable = true}, REDUCE(sym_call, 3),
  [5808] = {.count = 1, .reusable = false}, REDUCE(sym_call, 3),
  [5810] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list_with_parens, 1),
  [5812] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list_with_parens, 1),
  [5814] = {.count = 1, .reusable = true}, SHIFT(3545),
  [5816] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 3),
  [5818] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 3),
  [5820] = {.count = 1, .reusable = true}, SHIFT(3547),
  [5822] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 3),
  [5824] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 3),
  [5826] = {.count = 1, .reusable = true}, SHIFT(3549),
  [5828] = {.count = 1, .reusable = true}, SHIFT(3550),
  [5830] = {.count = 1, .reusable = true}, SHIFT(3551),
  [5832] = {.count = 1, .reusable = true}, SHIFT(3552),
  [5834] = {.count = 1, .reusable = true}, SHIFT(3553),
  [5836] = {.count = 1, .reusable = false}, SHIFT(3554),
  [5838] = {.count = 1, .reusable = true}, SHIFT(3556),
  [5840] = {.count = 1, .reusable = true}, SHIFT(3557),
  [5842] = {.count = 1, .reusable = true}, SHIFT(3559),
  [5844] = {.count = 1, .reusable = false}, SHIFT(3560),
  [5846] = {.count = 1, .reusable = true}, SHIFT(3562),
  [5848] = {.count = 1, .reusable = true}, SHIFT(3563),
  [5850] = {.count = 1, .reusable = true}, SHIFT(3565),
  [5852] = {.count = 1, .reusable = true}, SHIFT(3567),
  [5854] = {.count = 1, .reusable = true}, SHIFT(3569),
  [5856] = {.count = 1, .reusable = true}, SHIFT(3571),
  [5858] = {.count = 1, .reusable = true}, SHIFT(3573),
  [5860] = {.count = 1, .reusable = false}, SHIFT(3574),
  [5862] = {.count = 1, .reusable = true}, SHIFT(3576),
  [5864] = {.count = 1, .reusable = false}, SHIFT(3577),
  [5866] = {.count = 1, .reusable = true}, SHIFT(3580),
  [5868] = {.count = 1, .reusable = true}, SHIFT(3583),
  [5870] = {.count = 1, .reusable = false}, SHIFT(3585),
  [5872] = {.count = 1, .reusable = true}, SHIFT(3587),
  [5874] = {.count = 1, .reusable = true}, SHIFT(3589),
  [5876] = {.count = 1, .reusable = false}, SHIFT(3590),
  [5878] = {.count = 1, .reusable = false}, SHIFT(3592),
  [5880] = {.count = 1, .reusable = true}, SHIFT(3604),
  [5882] = {.count = 1, .reusable = true}, SHIFT(3610),
  [5884] = {.count = 1, .reusable = false}, SHIFT(3609),
  [5886] = {.count = 1, .reusable = false}, SHIFT(3613),
  [5888] = {.count = 1, .reusable = true}, SHIFT(3614),
  [5890] = {.count = 1, .reusable = true}, SHIFT(3619),
  [5892] = {.count = 1, .reusable = true}, SHIFT(3620),
  [5894] = {.count = 1, .reusable = false}, SHIFT(3621),
  [5896] = {.count = 1, .reusable = false}, SHIFT(3620),
  [5898] = {.count = 1, .reusable = false}, SHIFT(3622),
  [5900] = {.count = 1, .reusable = false}, SHIFT(3623),
  [5902] = {.count = 1, .reusable = true}, SHIFT(3624),
  [5904] = {.count = 1, .reusable = false}, SHIFT(3625),
  [5906] = {.count = 1, .reusable = true}, SHIFT(3625),
  [5908] = {.count = 1, .reusable = false}, SHIFT(3627),
  [5910] = {.count = 1, .reusable = false}, SHIFT(3628),
  [5912] = {.count = 1, .reusable = true}, SHIFT(3627),
  [5914] = {.count = 1, .reusable = true}, SHIFT(3623),
  [5916] = {.count = 1, .reusable = false}, SHIFT(3619),
  [5918] = {.count = 1, .reusable = true}, SHIFT(3629),
  [5920] = {.count = 1, .reusable = true}, SHIFT(3630),
  [5922] = {.count = 1, .reusable = false}, SHIFT(3630),
  [5924] = {.count = 1, .reusable = true}, SHIFT(3631),
  [5926] = {.count = 1, .reusable = true}, SHIFT(3633),
  [5928] = {.count = 1, .reusable = true}, SHIFT(3637),
  [5930] = {.count = 1, .reusable = true}, SHIFT(3638),
  [5932] = {.count = 1, .reusable = true}, SHIFT(3639),
  [5934] = {.count = 1, .reusable = false}, SHIFT(3641),
  [5936] = {.count = 1, .reusable = true}, SHIFT(3647),
  [5938] = {.count = 1, .reusable = true}, SHIFT(3649),
  [5940] = {.count = 1, .reusable = true}, SHIFT(3650),
  [5942] = {.count = 1, .reusable = false}, SHIFT(3651),
  [5944] = {.count = 1, .reusable = false}, SHIFT(3652),
  [5946] = {.count = 1, .reusable = false}, SHIFT(3653),
  [5948] = {.count = 1, .reusable = true}, SHIFT(3654),
  [5950] = {.count = 1, .reusable = false}, SHIFT(3655),
  [5952] = {.count = 1, .reusable = true}, SHIFT(3655),
  [5954] = {.count = 1, .reusable = true}, SHIFT(3656),
  [5956] = {.count = 1, .reusable = true}, SHIFT(3657),
  [5958] = {.count = 1, .reusable = true}, SHIFT(3658),
  [5960] = {.count = 1, .reusable = false}, SHIFT(3657),
  [5962] = {.count = 1, .reusable = true}, SHIFT(3653),
  [5964] = {.count = 1, .reusable = true}, SHIFT(3651),
  [5966] = {.count = 1, .reusable = true}, SHIFT(3659),
  [5968] = {.count = 1, .reusable = true}, SHIFT(3660),
  [5970] = {.count = 1, .reusable = true}, SHIFT(3661),
  [5972] = {.count = 1, .reusable = false}, SHIFT(3663),
  [5974] = {.count = 1, .reusable = true}, SHIFT(3668),
  [5976] = {.count = 1, .reusable = false}, SHIFT(3668),
  [5978] = {.count = 1, .reusable = true}, SHIFT(3669),
  [5980] = {.count = 1, .reusable = true}, SHIFT(3671),
  [5982] = {.count = 1, .reusable = true}, SHIFT(3674),
  [5984] = {.count = 1, .reusable = true}, SHIFT(3675),
  [5986] = {.count = 1, .reusable = true}, SHIFT(3676),
  [5988] = {.count = 1, .reusable = true}, SHIFT(3679),
  [5990] = {.count = 1, .reusable = true}, SHIFT(3681),
  [5992] = {.count = 1, .reusable = false}, SHIFT(3680),
  [5994] = {.count = 1, .reusable = true}, SHIFT(3682),
  [5996] = {.count = 1, .reusable = true}, SHIFT(3683),
  [5998] = {.count = 1, .reusable = true}, SHIFT(3684),
  [6000] = {.count = 1, .reusable = true}, SHIFT(3685),
  [6002] = {.count = 1, .reusable = true}, SHIFT(3687),
  [6004] = {.count = 1, .reusable = true}, SHIFT(3689),
  [6006] = {.count = 1, .reusable = false}, SHIFT(3687),
  [6008] = {.count = 1, .reusable = true}, SHIFT(3691),
  [6010] = {.count = 1, .reusable = true}, SHIFT(3693),
  [6012] = {.count = 1, .reusable = true}, SHIFT(3694),
  [6014] = {.count = 1, .reusable = false}, SHIFT(3698),
  [6016] = {.count = 1, .reusable = true}, SHIFT(3699),
  [6018] = {.count = 1, .reusable = true}, SHIFT(3702),
  [6020] = {.count = 1, .reusable = true}, SHIFT(3704),
  [6022] = {.count = 1, .reusable = true}, SHIFT(3716),
  [6024] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 3),
  [6026] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 3),
  [6028] = {.count = 1, .reusable = true}, SHIFT(3718),
  [6030] = {.count = 1, .reusable = true}, SHIFT(3717),
  [6032] = {.count = 1, .reusable = true}, SHIFT(401),
  [6034] = {.count = 1, .reusable = true}, SHIFT(3732),
  [6036] = {.count = 1, .reusable = true}, SHIFT(3733),
  [6038] = {.count = 1, .reusable = false}, SHIFT(3734),
  [6040] = {.count = 1, .reusable = false}, SHIFT(3735),
  [6042] = {.count = 1, .reusable = false}, SHIFT(3736),
  [6044] = {.count = 1, .reusable = true}, SHIFT(3737),
  [6046] = {.count = 1, .reusable = false}, SHIFT(3738),
  [6048] = {.count = 1, .reusable = true}, SHIFT(3738),
  [6050] = {.count = 1, .reusable = true}, SHIFT(3740),
  [6052] = {.count = 1, .reusable = true}, SHIFT(3741),
  [6054] = {.count = 1, .reusable = false}, SHIFT(3740),
  [6056] = {.count = 1, .reusable = true}, SHIFT(3736),
  [6058] = {.count = 1, .reusable = true}, SHIFT(3734),
  [6060] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3),
  [6062] = {.count = 1, .reusable = false}, REDUCE(sym_assignment, 3),
  [6064] = {.count = 1, .reusable = true}, SHIFT(3742),
  [6066] = {.count = 1, .reusable = true}, SHIFT(3744),
  [6068] = {.count = 1, .reusable = false}, SHIFT(3744),
  [6070] = {.count = 1, .reusable = true}, SHIFT(3745),
  [6072] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 3),
  [6074] = {.count = 1, .reusable = true}, REDUCE(sym_operator_assignment, 3),
  [6076] = {.count = 1, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [6078] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(3),
  [6081] = {.count = 1, .reusable = false}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [6083] = {.count = 1, .reusable = true}, SHIFT(3746),
  [6085] = {.count = 1, .reusable = false}, SHIFT(3747),
  [6087] = {.count = 1, .reusable = false}, SHIFT(3748),
  [6089] = {.count = 1, .reusable = false}, SHIFT(3749),
  [6091] = {.count = 1, .reusable = false}, SHIFT(3750),
  [6093] = {.count = 1, .reusable = false}, SHIFT(3746),
  [6095] = {.count = 1, .reusable = true}, SHIFT(3751),
  [6097] = {.count = 1, .reusable = false}, SHIFT(3751),
  [6099] = {.count = 1, .reusable = true}, SHIFT(3752),
  [6101] = {.count = 1, .reusable = false}, SHIFT(3754),
  [6103] = {.count = 1, .reusable = true}, SHIFT(3754),
  [6105] = {.count = 1, .reusable = false}, SHIFT(1604),
  [6107] = {.count = 1, .reusable = true}, SHIFT(3761),
  [6109] = {.count = 1, .reusable = true}, SHIFT(3763),
  [6111] = {.count = 1, .reusable = true}, SHIFT(3764),
  [6113] = {.count = 1, .reusable = true}, SHIFT(3765),
  [6115] = {.count = 1, .reusable = false}, SHIFT(3767),
  [6117] = {.count = 1, .reusable = false}, SHIFT(3773),
  [6119] = {.count = 1, .reusable = true}, SHIFT(3774),
  [6121] = {.count = 1, .reusable = true}, SHIFT(3775),
  [6123] = {.count = 1, .reusable = false}, SHIFT(3776),
  [6125] = {.count = 1, .reusable = false}, SHIFT(3777),
  [6127] = {.count = 1, .reusable = false}, SHIFT(3778),
  [6129] = {.count = 1, .reusable = true}, SHIFT(3779),
  [6131] = {.count = 1, .reusable = false}, SHIFT(3780),
  [6133] = {.count = 1, .reusable = true}, SHIFT(3780),
  [6135] = {.count = 1, .reusable = true}, SHIFT(3782),
  [6137] = {.count = 1, .reusable = true}, SHIFT(3783),
  [6139] = {.count = 1, .reusable = false}, SHIFT(3782),
  [6141] = {.count = 1, .reusable = true}, SHIFT(3778),
  [6143] = {.count = 1, .reusable = true}, SHIFT(3776),
  [6145] = {.count = 1, .reusable = true}, SHIFT(3784),
  [6147] = {.count = 1, .reusable = true}, SHIFT(3785),
  [6149] = {.count = 1, .reusable = true}, SHIFT(3786),
  [6151] = {.count = 1, .reusable = false}, SHIFT(3788),
  [6153] = {.count = 1, .reusable = true}, SHIFT(3794),
  [6155] = {.count = 1, .reusable = true}, SHIFT(3796),
  [6157] = {.count = 1, .reusable = false}, SHIFT(3796),
  [6159] = {.count = 1, .reusable = true}, SHIFT(3797),
  [6161] = {.count = 1, .reusable = false}, SHIFT(3761),
  [6163] = {.count = 1, .reusable = true}, SHIFT(3799),
  [6165] = {.count = 1, .reusable = true}, SHIFT(3800),
  [6167] = {.count = 1, .reusable = true}, SHIFT(3802),
  [6169] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 3),
  [6171] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 3),
  [6173] = {.count = 1, .reusable = true}, SHIFT(3818),
  [6175] = {.count = 1, .reusable = false}, SHIFT(3818),
  [6177] = {.count = 1, .reusable = true}, SHIFT(3819),
  [6179] = {.count = 1, .reusable = true}, SHIFT(3820),
  [6181] = {.count = 1, .reusable = true}, SHIFT(3823),
  [6183] = {.count = 1, .reusable = true}, SHIFT(3826),
  [6185] = {.count = 1, .reusable = true}, SHIFT(3827),
  [6187] = {.count = 1, .reusable = true}, SHIFT(3828),
  [6189] = {.count = 1, .reusable = true}, SHIFT(3829),
  [6191] = {.count = 1, .reusable = true}, SHIFT(3830),
  [6193] = {.count = 1, .reusable = true}, SHIFT(3831),
  [6195] = {.count = 1, .reusable = true}, SHIFT(3832),
  [6197] = {.count = 1, .reusable = true}, SHIFT(3833),
  [6199] = {.count = 1, .reusable = true}, SHIFT(3857),
  [6201] = {.count = 1, .reusable = true}, SHIFT(3834),
  [6203] = {.count = 1, .reusable = true}, SHIFT(3835),
  [6205] = {.count = 1, .reusable = false}, SHIFT(3836),
  [6207] = {.count = 1, .reusable = true}, SHIFT(3837),
  [6209] = {.count = 1, .reusable = false}, SHIFT(3838),
  [6211] = {.count = 1, .reusable = false}, SHIFT(3839),
  [6213] = {.count = 1, .reusable = false}, SHIFT(3840),
  [6215] = {.count = 1, .reusable = false}, SHIFT(3841),
  [6217] = {.count = 1, .reusable = false}, SHIFT(3842),
  [6219] = {.count = 1, .reusable = false}, SHIFT(3843),
  [6221] = {.count = 1, .reusable = false}, SHIFT(3857),
  [6223] = {.count = 1, .reusable = false}, SHIFT(3844),
  [6225] = {.count = 1, .reusable = false}, SHIFT(3845),
  [6227] = {.count = 1, .reusable = false}, SHIFT(3846),
  [6229] = {.count = 1, .reusable = false}, SHIFT(3847),
  [6231] = {.count = 1, .reusable = false}, SHIFT(3848),
  [6233] = {.count = 1, .reusable = false}, SHIFT(3849),
  [6235] = {.count = 1, .reusable = false}, SHIFT(3850),
  [6237] = {.count = 1, .reusable = false}, SHIFT(3834),
  [6239] = {.count = 1, .reusable = true}, SHIFT(3851),
  [6241] = {.count = 1, .reusable = false}, SHIFT(3851),
  [6243] = {.count = 1, .reusable = true}, SHIFT(3852),
  [6245] = {.count = 1, .reusable = false}, SHIFT(3858),
  [6247] = {.count = 1, .reusable = true}, SHIFT(3858),
  [6249] = {.count = 1, .reusable = false}, SHIFT(3853),
  [6251] = {.count = 1, .reusable = true}, SHIFT(3854),
  [6253] = {.count = 1, .reusable = true}, SHIFT(3855),
  [6255] = {.count = 1, .reusable = false}, SHIFT(1647),
  [6257] = {.count = 1, .reusable = true}, SHIFT(3865),
  [6259] = {.count = 1, .reusable = true}, SHIFT(3866),
  [6261] = {.count = 1, .reusable = true}, SHIFT(3873),
  [6263] = {.count = 1, .reusable = false}, SHIFT(3870),
  [6265] = {.count = 1, .reusable = true}, SHIFT(3874),
  [6267] = {.count = 1, .reusable = false}, SHIFT(3878),
  [6269] = {.count = 1, .reusable = true}, SHIFT(3879),
  [6271] = {.count = 1, .reusable = true}, SHIFT(3880),
  [6273] = {.count = 1, .reusable = false}, SHIFT(3881),
  [6275] = {.count = 1, .reusable = false}, SHIFT(3880),
  [6277] = {.count = 1, .reusable = false}, SHIFT(3882),
  [6279] = {.count = 1, .reusable = false}, SHIFT(3883),
  [6281] = {.count = 1, .reusable = true}, SHIFT(3884),
  [6283] = {.count = 1, .reusable = false}, SHIFT(3885),
  [6285] = {.count = 1, .reusable = true}, SHIFT(3885),
  [6287] = {.count = 1, .reusable = false}, SHIFT(3887),
  [6289] = {.count = 1, .reusable = false}, SHIFT(3888),
  [6291] = {.count = 1, .reusable = true}, SHIFT(3887),
  [6293] = {.count = 1, .reusable = true}, SHIFT(3883),
  [6295] = {.count = 1, .reusable = false}, SHIFT(3879),
  [6297] = {.count = 1, .reusable = true}, SHIFT(3889),
  [6299] = {.count = 1, .reusable = true}, SHIFT(1655),
  [6301] = {.count = 1, .reusable = true}, SHIFT(3891),
  [6303] = {.count = 1, .reusable = true}, SHIFT(3893),
  [6305] = {.count = 1, .reusable = true}, SHIFT(3895),
  [6307] = {.count = 1, .reusable = false}, SHIFT(3895),
  [6309] = {.count = 1, .reusable = true}, SHIFT(3896),
  [6311] = {.count = 1, .reusable = false}, SHIFT(3865),
  [6313] = {.count = 1, .reusable = true}, SHIFT(3898),
  [6315] = {.count = 1, .reusable = true}, SHIFT(3899),
  [6317] = {.count = 1, .reusable = false}, SHIFT(3900),
  [6319] = {.count = 1, .reusable = false}, SHIFT(3901),
  [6321] = {.count = 1, .reusable = false}, SHIFT(3902),
  [6323] = {.count = 1, .reusable = false}, SHIFT(3903),
  [6325] = {.count = 1, .reusable = false}, SHIFT(3899),
  [6327] = {.count = 1, .reusable = true}, SHIFT(3904),
  [6329] = {.count = 1, .reusable = false}, SHIFT(3904),
  [6331] = {.count = 1, .reusable = true}, SHIFT(3905),
  [6333] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 11),
  [6335] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 11),
  [6337] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 12),
  [6339] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 12),
  [6341] = {.count = 1, .reusable = true}, SHIFT(3913),
  [6343] = {.count = 1, .reusable = true}, SHIFT(3914),
  [6345] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 13),
  [6347] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 13),
  [6349] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2, .alias_sequence_id = 14),
  [6351] = {.count = 1, .reusable = true}, SHIFT(3915),
  [6353] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2),
  [6355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2), SHIFT_REPEAT(3916),
  [6358] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 11),
  [6360] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 11),
  [6362] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 15),
  [6364] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 15),
  [6366] = {.count = 1, .reusable = true}, SHIFT(3917),
  [6368] = {.count = 1, .reusable = true}, SHIFT(3918),
  [6370] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 16),
  [6372] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 16),
  [6374] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2, .alias_sequence_id = 17),
  [6376] = {.count = 1, .reusable = true}, SHIFT(3919),
  [6378] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2),
  [6380] = {.count = 2, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2), SHIFT_REPEAT(3920),
  [6383] = {.count = 1, .reusable = true}, SHIFT(3921),
  [6385] = {.count = 1, .reusable = false}, SHIFT(3922),
  [6387] = {.count = 1, .reusable = false}, SHIFT(3923),
  [6389] = {.count = 1, .reusable = false}, SHIFT(3924),
  [6391] = {.count = 1, .reusable = false}, SHIFT(3925),
  [6393] = {.count = 1, .reusable = false}, SHIFT(3921),
  [6395] = {.count = 1, .reusable = true}, SHIFT(3926),
  [6397] = {.count = 1, .reusable = false}, SHIFT(3926),
  [6399] = {.count = 1, .reusable = true}, SHIFT(3927),
  [6401] = {.count = 1, .reusable = false}, SHIFT(1692),
  [6403] = {.count = 1, .reusable = true}, SHIFT(3935),
  [6405] = {.count = 1, .reusable = false}, SHIFT(3940),
  [6407] = {.count = 1, .reusable = true}, SHIFT(3941),
  [6409] = {.count = 1, .reusable = true}, SHIFT(3942),
  [6411] = {.count = 1, .reusable = false}, SHIFT(3943),
  [6413] = {.count = 1, .reusable = false}, SHIFT(3944),
  [6415] = {.count = 1, .reusable = false}, SHIFT(3945),
  [6417] = {.count = 1, .reusable = true}, SHIFT(3946),
  [6419] = {.count = 1, .reusable = false}, SHIFT(3947),
  [6421] = {.count = 1, .reusable = true}, SHIFT(3947),
  [6423] = {.count = 1, .reusable = true}, SHIFT(3949),
  [6425] = {.count = 1, .reusable = true}, SHIFT(3950),
  [6427] = {.count = 1, .reusable = false}, SHIFT(3949),
  [6429] = {.count = 1, .reusable = true}, SHIFT(3945),
  [6431] = {.count = 1, .reusable = true}, SHIFT(3943),
  [6433] = {.count = 1, .reusable = true}, SHIFT(3952),
  [6435] = {.count = 1, .reusable = true}, SHIFT(3954),
  [6437] = {.count = 1, .reusable = false}, SHIFT(3954),
  [6439] = {.count = 1, .reusable = true}, SHIFT(3955),
  [6441] = {.count = 1, .reusable = false}, SHIFT(3935),
  [6443] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 4),
  [6445] = {.count = 1, .reusable = true}, SHIFT(3958),
  [6447] = {.count = 1, .reusable = true}, SHIFT(3975),
  [6449] = {.count = 1, .reusable = false}, SHIFT(3976),
  [6451] = {.count = 1, .reusable = false}, SHIFT(3977),
  [6453] = {.count = 1, .reusable = false}, SHIFT(3978),
  [6455] = {.count = 1, .reusable = false}, SHIFT(3979),
  [6457] = {.count = 1, .reusable = false}, SHIFT(3975),
  [6459] = {.count = 1, .reusable = true}, SHIFT(3980),
  [6461] = {.count = 1, .reusable = false}, SHIFT(3980),
  [6463] = {.count = 1, .reusable = true}, SHIFT(3981),
  [6465] = {.count = 1, .reusable = false}, SHIFT(3983),
  [6467] = {.count = 1, .reusable = true}, SHIFT(3983),
  [6469] = {.count = 1, .reusable = false}, SHIFT(1730),
  [6471] = {.count = 1, .reusable = true}, SHIFT(3990),
  [6473] = {.count = 1, .reusable = false}, SHIFT(3993),
  [6475] = {.count = 1, .reusable = true}, SHIFT(3994),
  [6477] = {.count = 1, .reusable = true}, SHIFT(3995),
  [6479] = {.count = 1, .reusable = false}, SHIFT(3996),
  [6481] = {.count = 1, .reusable = false}, SHIFT(3995),
  [6483] = {.count = 1, .reusable = false}, SHIFT(3997),
  [6485] = {.count = 1, .reusable = false}, SHIFT(3998),
  [6487] = {.count = 1, .reusable = true}, SHIFT(3999),
  [6489] = {.count = 1, .reusable = false}, SHIFT(4000),
  [6491] = {.count = 1, .reusable = true}, SHIFT(4000),
  [6493] = {.count = 1, .reusable = false}, SHIFT(4002),
  [6495] = {.count = 1, .reusable = false}, SHIFT(4003),
  [6497] = {.count = 1, .reusable = true}, SHIFT(4002),
  [6499] = {.count = 1, .reusable = true}, SHIFT(3998),
  [6501] = {.count = 1, .reusable = false}, SHIFT(3994),
  [6503] = {.count = 1, .reusable = true}, SHIFT(4005),
  [6505] = {.count = 1, .reusable = true}, SHIFT(4007),
  [6507] = {.count = 1, .reusable = false}, SHIFT(4007),
  [6509] = {.count = 1, .reusable = true}, SHIFT(4008),
  [6511] = {.count = 1, .reusable = false}, SHIFT(3990),
  [6513] = {.count = 1, .reusable = true}, SHIFT(4010),
  [6515] = {.count = 1, .reusable = true}, SHIFT(4011),
  [6517] = {.count = 1, .reusable = false}, SHIFT(4011),
  [6519] = {.count = 1, .reusable = true}, SHIFT(4012),
  [6521] = {.count = 1, .reusable = false}, SHIFT(4012),
  [6523] = {.count = 1, .reusable = true}, SHIFT(4013),
  [6525] = {.count = 1, .reusable = true}, SHIFT(4020),
  [6527] = {.count = 1, .reusable = true}, SHIFT(4021),
  [6529] = {.count = 1, .reusable = true}, SHIFT(4022),
  [6531] = {.count = 1, .reusable = true}, SHIFT(4024),
  [6533] = {.count = 1, .reusable = true}, SHIFT(4025),
  [6535] = {.count = 1, .reusable = true}, SHIFT(4026),
  [6537] = {.count = 1, .reusable = true}, SHIFT(4027),
  [6539] = {.count = 1, .reusable = true}, SHIFT(4028),
  [6541] = {.count = 1, .reusable = true}, SHIFT(4030),
  [6543] = {.count = 1, .reusable = true}, SHIFT(4031),
  [6545] = {.count = 1, .reusable = true}, SHIFT(4032),
  [6547] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [6549] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1768),
  [6552] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [6554] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(510),
  [6557] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [6559] = {.count = 1, .reusable = true}, SHIFT(4033),
  [6561] = {.count = 1, .reusable = true}, SHIFT(4034),
  [6563] = {.count = 1, .reusable = true}, SHIFT(521),
  [6565] = {.count = 1, .reusable = false}, SHIFT(4036),
  [6567] = {.count = 1, .reusable = true}, SHIFT(4037),
  [6569] = {.count = 1, .reusable = false}, SHIFT(4037),
  [6571] = {.count = 1, .reusable = true}, SHIFT(4038),
  [6573] = {.count = 1, .reusable = false}, SHIFT(4038),
  [6575] = {.count = 1, .reusable = true}, SHIFT(4039),
  [6577] = {.count = 1, .reusable = false}, SHIFT(1780),
  [6579] = {.count = 1, .reusable = true}, SHIFT(4046),
  [6581] = {.count = 1, .reusable = true}, SHIFT(4048),
  [6583] = {.count = 1, .reusable = true}, SHIFT(4049),
  [6585] = {.count = 1, .reusable = true}, SHIFT(4050),
  [6587] = {.count = 1, .reusable = false}, SHIFT(4052),
  [6589] = {.count = 1, .reusable = false}, SHIFT(4058),
  [6591] = {.count = 1, .reusable = true}, SHIFT(4059),
  [6593] = {.count = 1, .reusable = true}, SHIFT(4060),
  [6595] = {.count = 1, .reusable = false}, SHIFT(4061),
  [6597] = {.count = 1, .reusable = false}, SHIFT(4062),
  [6599] = {.count = 1, .reusable = false}, SHIFT(4063),
  [6601] = {.count = 1, .reusable = true}, SHIFT(4064),
  [6603] = {.count = 1, .reusable = false}, SHIFT(4065),
  [6605] = {.count = 1, .reusable = true}, SHIFT(4065),
  [6607] = {.count = 1, .reusable = true}, SHIFT(4067),
  [6609] = {.count = 1, .reusable = true}, SHIFT(4068),
  [6611] = {.count = 1, .reusable = false}, SHIFT(4067),
  [6613] = {.count = 1, .reusable = true}, SHIFT(4063),
  [6615] = {.count = 1, .reusable = true}, SHIFT(4061),
  [6617] = {.count = 1, .reusable = true}, SHIFT(4069),
  [6619] = {.count = 1, .reusable = true}, SHIFT(4070),
  [6621] = {.count = 1, .reusable = true}, SHIFT(4071),
  [6623] = {.count = 1, .reusable = false}, SHIFT(4073),
  [6625] = {.count = 1, .reusable = true}, SHIFT(4079),
  [6627] = {.count = 1, .reusable = true}, SHIFT(4081),
  [6629] = {.count = 1, .reusable = false}, SHIFT(4081),
  [6631] = {.count = 1, .reusable = true}, SHIFT(4082),
  [6633] = {.count = 1, .reusable = false}, SHIFT(4046),
  [6635] = {.count = 1, .reusable = true}, SHIFT(4094),
  [6637] = {.count = 1, .reusable = false}, SHIFT(4094),
  [6639] = {.count = 1, .reusable = true}, SHIFT(4095),
  [6641] = {.count = 1, .reusable = true}, SHIFT(4096),
  [6643] = {.count = 1, .reusable = true}, SHIFT(4099),
  [6645] = {.count = 1, .reusable = true}, SHIFT(4102),
  [6647] = {.count = 1, .reusable = true}, SHIFT(4103),
  [6649] = {.count = 1, .reusable = false}, SHIFT(4104),
  [6651] = {.count = 1, .reusable = false}, SHIFT(4105),
  [6653] = {.count = 1, .reusable = false}, SHIFT(4106),
  [6655] = {.count = 1, .reusable = false}, SHIFT(4107),
  [6657] = {.count = 1, .reusable = false}, SHIFT(4103),
  [6659] = {.count = 1, .reusable = true}, SHIFT(4108),
  [6661] = {.count = 1, .reusable = false}, SHIFT(4108),
  [6663] = {.count = 1, .reusable = true}, SHIFT(4109),
  [6665] = {.count = 1, .reusable = false}, SHIFT(4111),
  [6667] = {.count = 1, .reusable = true}, SHIFT(4111),
  [6669] = {.count = 1, .reusable = false}, SHIFT(1813),
  [6671] = {.count = 1, .reusable = true}, SHIFT(4118),
  [6673] = {.count = 1, .reusable = true}, SHIFT(4119),
  [6675] = {.count = 1, .reusable = true}, SHIFT(4126),
  [6677] = {.count = 1, .reusable = false}, SHIFT(4123),
  [6679] = {.count = 1, .reusable = false}, SHIFT(4128),
  [6681] = {.count = 1, .reusable = true}, SHIFT(4129),
  [6683] = {.count = 1, .reusable = true}, SHIFT(4130),
  [6685] = {.count = 1, .reusable = false}, SHIFT(4131),
  [6687] = {.count = 1, .reusable = false}, SHIFT(4130),
  [6689] = {.count = 1, .reusable = false}, SHIFT(4132),
  [6691] = {.count = 1, .reusable = false}, SHIFT(4133),
  [6693] = {.count = 1, .reusable = true}, SHIFT(4134),
  [6695] = {.count = 1, .reusable = false}, SHIFT(4135),
  [6697] = {.count = 1, .reusable = true}, SHIFT(4135),
  [6699] = {.count = 1, .reusable = false}, SHIFT(4137),
  [6701] = {.count = 1, .reusable = false}, SHIFT(4138),
  [6703] = {.count = 1, .reusable = true}, SHIFT(4137),
  [6705] = {.count = 1, .reusable = true}, SHIFT(4133),
  [6707] = {.count = 1, .reusable = false}, SHIFT(4129),
  [6709] = {.count = 1, .reusable = true}, SHIFT(4139),
  [6711] = {.count = 1, .reusable = true}, SHIFT(1821),
  [6713] = {.count = 1, .reusable = true}, SHIFT(4142),
  [6715] = {.count = 1, .reusable = true}, SHIFT(4144),
  [6717] = {.count = 1, .reusable = false}, SHIFT(4144),
  [6719] = {.count = 1, .reusable = true}, SHIFT(4145),
  [6721] = {.count = 1, .reusable = false}, SHIFT(4118),
  [6723] = {.count = 1, .reusable = true}, SHIFT(4147),
  [6725] = {.count = 1, .reusable = true}, SHIFT(4152),
  [6727] = {.count = 1, .reusable = true}, SHIFT(4153),
  [6729] = {.count = 1, .reusable = false}, SHIFT(4154),
  [6731] = {.count = 1, .reusable = false}, SHIFT(4155),
  [6733] = {.count = 1, .reusable = true}, SHIFT(4159),
  [6735] = {.count = 1, .reusable = true}, SHIFT(4173),
  [6737] = {.count = 1, .reusable = true}, SHIFT(4172),
  [6739] = {.count = 1, .reusable = true}, SHIFT(551),
  [6741] = {.count = 1, .reusable = true}, SHIFT(4187),
  [6743] = {.count = 1, .reusable = false}, SHIFT(4184),
  [6745] = {.count = 1, .reusable = false}, SHIFT(4188),
  [6747] = {.count = 1, .reusable = false}, SHIFT(4191),
  [6749] = {.count = 1, .reusable = false}, SHIFT(4193),
  [6751] = {.count = 1, .reusable = true}, SHIFT(4195),
  [6753] = {.count = 1, .reusable = true}, SHIFT(4197),
  [6755] = {.count = 1, .reusable = true}, SHIFT(4198),
  [6757] = {.count = 1, .reusable = true}, SHIFT(4199),
  [6759] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .alias_sequence_id = 18),
  [6761] = {.count = 1, .reusable = true}, SHIFT(4202),
  [6763] = {.count = 1, .reusable = true}, SHIFT(4203),
  [6765] = {.count = 1, .reusable = true}, SHIFT(4205),
  [6767] = {.count = 1, .reusable = true}, SHIFT(4207),
  [6769] = {.count = 1, .reusable = false}, SHIFT(4205),
  [6771] = {.count = 1, .reusable = true}, SHIFT(4209),
  [6773] = {.count = 1, .reusable = true}, SHIFT(4210),
  [6775] = {.count = 1, .reusable = true}, SHIFT(4213),
  [6777] = {.count = 1, .reusable = true}, SHIFT(4214),
  [6779] = {.count = 1, .reusable = true}, SHIFT(4216),
  [6781] = {.count = 1, .reusable = true}, SHIFT(4217),
  [6783] = {.count = 1, .reusable = true}, SHIFT(4218),
  [6785] = {.count = 1, .reusable = true}, SHIFT(4219),
  [6787] = {.count = 1, .reusable = true}, SHIFT(4220),
  [6789] = {.count = 1, .reusable = false}, SHIFT(4221),
  [6791] = {.count = 1, .reusable = true}, SHIFT(4223),
  [6793] = {.count = 1, .reusable = true}, SHIFT(4224),
  [6795] = {.count = 1, .reusable = true}, SHIFT(4226),
  [6797] = {.count = 1, .reusable = false}, SHIFT(4227),
  [6799] = {.count = 1, .reusable = true}, SHIFT(4229),
  [6801] = {.count = 1, .reusable = true}, SHIFT(4230),
  [6803] = {.count = 1, .reusable = true}, SHIFT(4232),
  [6805] = {.count = 1, .reusable = true}, SHIFT(4234),
  [6807] = {.count = 1, .reusable = true}, SHIFT(4236),
  [6809] = {.count = 1, .reusable = true}, SHIFT(4239),
  [6811] = {.count = 1, .reusable = true}, SHIFT(4240),
  [6813] = {.count = 1, .reusable = true}, SHIFT(4241),
  [6815] = {.count = 1, .reusable = true}, SHIFT(4244),
  [6817] = {.count = 1, .reusable = true}, SHIFT(4246),
  [6819] = {.count = 1, .reusable = false}, SHIFT(4245),
  [6821] = {.count = 1, .reusable = true}, SHIFT(4247),
  [6823] = {.count = 1, .reusable = true}, SHIFT(4248),
  [6825] = {.count = 1, .reusable = true}, SHIFT(4249),
  [6827] = {.count = 1, .reusable = true}, SHIFT(4250),
  [6829] = {.count = 1, .reusable = true}, SHIFT(4252),
  [6831] = {.count = 1, .reusable = true}, SHIFT(4254),
  [6833] = {.count = 1, .reusable = false}, SHIFT(4252),
  [6835] = {.count = 1, .reusable = true}, SHIFT(4256),
  [6837] = {.count = 1, .reusable = true}, SHIFT(4258),
  [6839] = {.count = 1, .reusable = true}, SHIFT(4259),
  [6841] = {.count = 1, .reusable = false}, SHIFT(4263),
  [6843] = {.count = 1, .reusable = true}, SHIFT(4264),
  [6845] = {.count = 1, .reusable = true}, SHIFT(4267),
  [6847] = {.count = 1, .reusable = true}, SHIFT(4269),
  [6849] = {.count = 1, .reusable = true}, SHIFT(4281),
  [6851] = {.count = 1, .reusable = true}, SHIFT(4283),
  [6853] = {.count = 1, .reusable = true}, SHIFT(4282),
  [6855] = {.count = 1, .reusable = true}, SHIFT(622),
  [6857] = {.count = 1, .reusable = true}, SHIFT(4297),
  [6859] = {.count = 1, .reusable = true}, SHIFT(4298),
  [6861] = {.count = 1, .reusable = false}, SHIFT(4299),
  [6863] = {.count = 1, .reusable = false}, SHIFT(4300),
  [6865] = {.count = 1, .reusable = false}, SHIFT(4301),
  [6867] = {.count = 1, .reusable = true}, SHIFT(4302),
  [6869] = {.count = 1, .reusable = false}, SHIFT(4303),
  [6871] = {.count = 1, .reusable = true}, SHIFT(4303),
  [6873] = {.count = 1, .reusable = true}, SHIFT(4305),
  [6875] = {.count = 1, .reusable = true}, SHIFT(4306),
  [6877] = {.count = 1, .reusable = false}, SHIFT(4305),
  [6879] = {.count = 1, .reusable = true}, SHIFT(4301),
  [6881] = {.count = 1, .reusable = true}, SHIFT(4299),
  [6883] = {.count = 1, .reusable = true}, SHIFT(4307),
  [6885] = {.count = 1, .reusable = true}, SHIFT(4309),
  [6887] = {.count = 1, .reusable = false}, SHIFT(4309),
  [6889] = {.count = 1, .reusable = true}, SHIFT(4310),
  [6891] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(76),
  [6894] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 4),
  [6896] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 4),
  [6898] = {.count = 1, .reusable = true}, SHIFT(4313),
  [6900] = {.count = 1, .reusable = true}, SHIFT(4312),
  [6902] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 3),
  [6904] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 4),
  [6906] = {.count = 1, .reusable = true}, SHIFT(4315),
  [6908] = {.count = 1, .reusable = false}, SHIFT(4315),
  [6910] = {.count = 1, .reusable = true}, SHIFT(4316),
  [6912] = {.count = 1, .reusable = false}, SHIFT(4316),
  [6914] = {.count = 1, .reusable = true}, SHIFT(4317),
  [6916] = {.count = 1, .reusable = false}, SHIFT(2033),
  [6918] = {.count = 1, .reusable = true}, SHIFT(4323),
  [6920] = {.count = 1, .reusable = false}, SHIFT(4326),
  [6922] = {.count = 1, .reusable = true}, SHIFT(4327),
  [6924] = {.count = 1, .reusable = true}, SHIFT(4328),
  [6926] = {.count = 1, .reusable = false}, SHIFT(4329),
  [6928] = {.count = 1, .reusable = false}, SHIFT(4330),
  [6930] = {.count = 1, .reusable = false}, SHIFT(4331),
  [6932] = {.count = 1, .reusable = true}, SHIFT(4332),
  [6934] = {.count = 1, .reusable = false}, SHIFT(4333),
  [6936] = {.count = 1, .reusable = true}, SHIFT(4333),
  [6938] = {.count = 1, .reusable = true}, SHIFT(4335),
  [6940] = {.count = 1, .reusable = true}, SHIFT(4336),
  [6942] = {.count = 1, .reusable = false}, SHIFT(4335),
  [6944] = {.count = 1, .reusable = true}, SHIFT(4331),
  [6946] = {.count = 1, .reusable = true}, SHIFT(4329),
  [6948] = {.count = 1, .reusable = true}, SHIFT(4338),
  [6950] = {.count = 1, .reusable = true}, SHIFT(4340),
  [6952] = {.count = 1, .reusable = false}, SHIFT(4340),
  [6954] = {.count = 1, .reusable = true}, SHIFT(4341),
  [6956] = {.count = 1, .reusable = false}, SHIFT(4323),
  [6958] = {.count = 1, .reusable = true}, SHIFT(4344),
  [6960] = {.count = 1, .reusable = true}, SHIFT(4353),
  [6962] = {.count = 1, .reusable = false}, SHIFT(4354),
  [6964] = {.count = 1, .reusable = false}, SHIFT(4355),
  [6966] = {.count = 1, .reusable = false}, SHIFT(4356),
  [6968] = {.count = 1, .reusable = false}, SHIFT(4357),
  [6970] = {.count = 1, .reusable = false}, SHIFT(4353),
  [6972] = {.count = 1, .reusable = true}, SHIFT(4358),
  [6974] = {.count = 1, .reusable = false}, SHIFT(4358),
  [6976] = {.count = 1, .reusable = true}, SHIFT(4359),
  [6978] = {.count = 1, .reusable = false}, SHIFT(4361),
  [6980] = {.count = 1, .reusable = true}, SHIFT(4361),
  [6982] = {.count = 1, .reusable = false}, SHIFT(2059),
  [6984] = {.count = 1, .reusable = true}, SHIFT(4368),
  [6986] = {.count = 1, .reusable = false}, SHIFT(4371),
  [6988] = {.count = 1, .reusable = true}, SHIFT(4372),
  [6990] = {.count = 1, .reusable = true}, SHIFT(4373),
  [6992] = {.count = 1, .reusable = false}, SHIFT(4374),
  [6994] = {.count = 1, .reusable = false}, SHIFT(4373),
  [6996] = {.count = 1, .reusable = false}, SHIFT(4375),
  [6998] = {.count = 1, .reusable = false}, SHIFT(4376),
  [7000] = {.count = 1, .reusable = true}, SHIFT(4377),
  [7002] = {.count = 1, .reusable = false}, SHIFT(4378),
  [7004] = {.count = 1, .reusable = true}, SHIFT(4378),
  [7006] = {.count = 1, .reusable = false}, SHIFT(4380),
  [7008] = {.count = 1, .reusable = false}, SHIFT(4381),
  [7010] = {.count = 1, .reusable = true}, SHIFT(4380),
  [7012] = {.count = 1, .reusable = true}, SHIFT(4376),
  [7014] = {.count = 1, .reusable = false}, SHIFT(4372),
  [7016] = {.count = 1, .reusable = true}, SHIFT(4383),
  [7018] = {.count = 1, .reusable = true}, SHIFT(4385),
  [7020] = {.count = 1, .reusable = false}, SHIFT(4385),
  [7022] = {.count = 1, .reusable = true}, SHIFT(4386),
  [7024] = {.count = 1, .reusable = false}, SHIFT(4368),
  [7026] = {.count = 1, .reusable = true}, SHIFT(4388),
  [7028] = {.count = 1, .reusable = true}, SHIFT(4389),
  [7030] = {.count = 1, .reusable = false}, SHIFT(4390),
  [7032] = {.count = 1, .reusable = false}, SHIFT(4391),
  [7034] = {.count = 1, .reusable = false}, SHIFT(4392),
  [7036] = {.count = 1, .reusable = false}, SHIFT(4393),
  [7038] = {.count = 1, .reusable = false}, SHIFT(4389),
  [7040] = {.count = 1, .reusable = true}, SHIFT(4394),
  [7042] = {.count = 1, .reusable = false}, SHIFT(4394),
  [7044] = {.count = 1, .reusable = true}, SHIFT(4395),
  [7046] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 4),
  [7048] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 4),
  [7050] = {.count = 1, .reusable = true}, SHIFT(4403),
  [7052] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 2),
  [7054] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 2),
  [7056] = {.count = 1, .reusable = true}, SHIFT(4404),
  [7058] = {.count = 1, .reusable = true}, SHIFT(4406),
  [7060] = {.count = 1, .reusable = false}, SHIFT(4407),
  [7062] = {.count = 1, .reusable = true}, REDUCE(sym__method_rest, 3),
  [7064] = {.count = 1, .reusable = false}, REDUCE(sym__method_rest, 3),
  [7066] = {.count = 1, .reusable = true}, SHIFT(4412),
  [7068] = {.count = 1, .reusable = true}, SHIFT(4414),
  [7070] = {.count = 1, .reusable = false}, SHIFT(4415),
  [7072] = {.count = 1, .reusable = false}, SHIFT(4416),
  [7074] = {.count = 1, .reusable = false}, SHIFT(4417),
  [7076] = {.count = 1, .reusable = false}, SHIFT(4418),
  [7078] = {.count = 1, .reusable = false}, SHIFT(4414),
  [7080] = {.count = 1, .reusable = true}, SHIFT(4419),
  [7082] = {.count = 1, .reusable = false}, SHIFT(4419),
  [7084] = {.count = 1, .reusable = true}, SHIFT(4420),
  [7086] = {.count = 1, .reusable = true}, SHIFT(4428),
  [7088] = {.count = 1, .reusable = true}, SHIFT(4430),
  [7090] = {.count = 1, .reusable = true}, SHIFT(4431),
  [7092] = {.count = 1, .reusable = true}, SHIFT(4432),
  [7094] = {.count = 1, .reusable = false}, SHIFT(2101),
  [7096] = {.count = 1, .reusable = false}, SHIFT(4434),
  [7098] = {.count = 1, .reusable = false}, SHIFT(4440),
  [7100] = {.count = 1, .reusable = true}, SHIFT(4441),
  [7102] = {.count = 1, .reusable = true}, SHIFT(4442),
  [7104] = {.count = 1, .reusable = false}, SHIFT(4443),
  [7106] = {.count = 1, .reusable = false}, SHIFT(4444),
  [7108] = {.count = 1, .reusable = false}, SHIFT(4445),
  [7110] = {.count = 1, .reusable = true}, SHIFT(4446),
  [7112] = {.count = 1, .reusable = false}, SHIFT(4447),
  [7114] = {.count = 1, .reusable = true}, SHIFT(4447),
  [7116] = {.count = 1, .reusable = true}, SHIFT(4448),
  [7118] = {.count = 1, .reusable = true}, SHIFT(4449),
  [7120] = {.count = 1, .reusable = true}, SHIFT(4450),
  [7122] = {.count = 1, .reusable = false}, SHIFT(4449),
  [7124] = {.count = 1, .reusable = true}, SHIFT(4445),
  [7126] = {.count = 1, .reusable = true}, SHIFT(4443),
  [7128] = {.count = 1, .reusable = true}, SHIFT(4452),
  [7130] = {.count = 1, .reusable = true}, SHIFT(4454),
  [7132] = {.count = 1, .reusable = false}, SHIFT(4454),
  [7134] = {.count = 1, .reusable = true}, SHIFT(4455),
  [7136] = {.count = 1, .reusable = false}, SHIFT(4428),
  [7138] = {.count = 1, .reusable = true}, SHIFT(4461),
  [7140] = {.count = 1, .reusable = true}, SHIFT(4462),
  [7142] = {.count = 1, .reusable = false}, SHIFT(4463),
  [7144] = {.count = 1, .reusable = false}, SHIFT(4464),
  [7146] = {.count = 1, .reusable = false}, SHIFT(4465),
  [7148] = {.count = 1, .reusable = true}, SHIFT(4466),
  [7150] = {.count = 1, .reusable = false}, SHIFT(4467),
  [7152] = {.count = 1, .reusable = true}, SHIFT(4467),
  [7154] = {.count = 1, .reusable = true}, SHIFT(4469),
  [7156] = {.count = 1, .reusable = true}, SHIFT(4470),
  [7158] = {.count = 1, .reusable = false}, SHIFT(4469),
  [7160] = {.count = 1, .reusable = true}, SHIFT(4465),
  [7162] = {.count = 1, .reusable = true}, SHIFT(4463),
  [7164] = {.count = 1, .reusable = true}, SHIFT(4471),
  [7166] = {.count = 1, .reusable = false}, SHIFT(4471),
  [7168] = {.count = 1, .reusable = true}, SHIFT(4472),
  [7170] = {.count = 1, .reusable = true}, SHIFT(4477),
  [7172] = {.count = 1, .reusable = false}, SHIFT(4479),
  [7174] = {.count = 1, .reusable = true}, SHIFT(4481),
  [7176] = {.count = 1, .reusable = false}, SHIFT(4477),
  [7178] = {.count = 1, .reusable = true}, SHIFT(4496),
  [7180] = {.count = 1, .reusable = false}, SHIFT(4498),
  [7182] = {.count = 1, .reusable = true}, SHIFT(4500),
  [7184] = {.count = 1, .reusable = false}, SHIFT(4496),
  [7186] = {.count = 1, .reusable = true}, SHIFT(691),
  [7188] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(4511),
  [7191] = {.count = 1, .reusable = true}, SHIFT(4512),
  [7193] = {.count = 1, .reusable = true}, SHIFT(4515),
  [7195] = {.count = 1, .reusable = true}, SHIFT(4516),
  [7197] = {.count = 1, .reusable = false}, SHIFT(4517),
  [7199] = {.count = 1, .reusable = false}, SHIFT(4516),
  [7201] = {.count = 1, .reusable = false}, SHIFT(4518),
  [7203] = {.count = 1, .reusable = false}, SHIFT(4519),
  [7205] = {.count = 1, .reusable = true}, SHIFT(4520),
  [7207] = {.count = 1, .reusable = false}, SHIFT(4521),
  [7209] = {.count = 1, .reusable = true}, SHIFT(4521),
  [7211] = {.count = 1, .reusable = false}, SHIFT(4523),
  [7213] = {.count = 1, .reusable = false}, SHIFT(4524),
  [7215] = {.count = 1, .reusable = true}, SHIFT(4523),
  [7217] = {.count = 1, .reusable = true}, SHIFT(4519),
  [7219] = {.count = 1, .reusable = false}, SHIFT(4515),
  [7221] = {.count = 1, .reusable = true}, SHIFT(4525),
  [7223] = {.count = 1, .reusable = false}, SHIFT(4525),
  [7225] = {.count = 1, .reusable = true}, SHIFT(4526),
  [7227] = {.count = 1, .reusable = true}, SHIFT(730),
  [7229] = {.count = 1, .reusable = true}, SHIFT(4551),
  [7231] = {.count = 1, .reusable = true}, SHIFT(4552),
  [7233] = {.count = 1, .reusable = false}, SHIFT(4553),
  [7235] = {.count = 1, .reusable = false}, SHIFT(4554),
  [7237] = {.count = 1, .reusable = false}, SHIFT(4555),
  [7239] = {.count = 1, .reusable = true}, SHIFT(4556),
  [7241] = {.count = 1, .reusable = false}, SHIFT(4557),
  [7243] = {.count = 1, .reusable = true}, SHIFT(4557),
  [7245] = {.count = 1, .reusable = true}, SHIFT(4559),
  [7247] = {.count = 1, .reusable = true}, SHIFT(4560),
  [7249] = {.count = 1, .reusable = false}, SHIFT(4559),
  [7251] = {.count = 1, .reusable = true}, SHIFT(4555),
  [7253] = {.count = 1, .reusable = true}, SHIFT(4553),
  [7255] = {.count = 1, .reusable = true}, SHIFT(4561),
  [7257] = {.count = 1, .reusable = true}, SHIFT(4563),
  [7259] = {.count = 1, .reusable = false}, SHIFT(4563),
  [7261] = {.count = 1, .reusable = true}, SHIFT(4564),
  [7263] = {.count = 1, .reusable = true}, SHIFT(4565),
  [7265] = {.count = 1, .reusable = true}, SHIFT(4566),
  [7267] = {.count = 1, .reusable = true}, SHIFT(4567),
  [7269] = {.count = 1, .reusable = true}, SHIFT(4569),
  [7271] = {.count = 1, .reusable = true}, SHIFT(4570),
  [7273] = {.count = 1, .reusable = true}, SHIFT(4571),
  [7275] = {.count = 1, .reusable = true}, SHIFT(4572),
  [7277] = {.count = 1, .reusable = true}, SHIFT(4573),
  [7279] = {.count = 1, .reusable = true}, SHIFT(4575),
  [7281] = {.count = 1, .reusable = true}, SHIFT(4576),
  [7283] = {.count = 1, .reusable = true}, SHIFT(4577),
  [7285] = {.count = 1, .reusable = true}, SHIFT(4578),
  [7287] = {.count = 1, .reusable = true}, SHIFT(770),
  [7289] = {.count = 1, .reusable = false}, SHIFT(4580),
  [7291] = {.count = 1, .reusable = true}, SHIFT(4581),
  [7293] = {.count = 1, .reusable = true}, SHIFT(4582),
  [7295] = {.count = 1, .reusable = false}, SHIFT(4583),
  [7297] = {.count = 1, .reusable = false}, SHIFT(4584),
  [7299] = {.count = 1, .reusable = true}, SHIFT(4586),
  [7301] = {.count = 1, .reusable = true}, SHIFT(4587),
  [7303] = {.count = 1, .reusable = true}, SHIFT(4588),
  [7305] = {.count = 1, .reusable = false}, SHIFT(4590),
  [7307] = {.count = 1, .reusable = true}, SHIFT(4596),
  [7309] = {.count = 1, .reusable = true}, SHIFT(4597),
  [7311] = {.count = 1, .reusable = false}, SHIFT(4598),
  [7313] = {.count = 1, .reusable = false}, SHIFT(4599),
  [7315] = {.count = 1, .reusable = false}, SHIFT(4600),
  [7317] = {.count = 1, .reusable = true}, SHIFT(4601),
  [7319] = {.count = 1, .reusable = false}, SHIFT(4602),
  [7321] = {.count = 1, .reusable = true}, SHIFT(4602),
  [7323] = {.count = 1, .reusable = true}, SHIFT(4603),
  [7325] = {.count = 1, .reusable = true}, SHIFT(4604),
  [7327] = {.count = 1, .reusable = true}, SHIFT(4605),
  [7329] = {.count = 1, .reusable = false}, SHIFT(4604),
  [7331] = {.count = 1, .reusable = true}, SHIFT(4600),
  [7333] = {.count = 1, .reusable = true}, SHIFT(4598),
  [7335] = {.count = 1, .reusable = true}, SHIFT(4606),
  [7337] = {.count = 1, .reusable = true}, SHIFT(4607),
  [7339] = {.count = 1, .reusable = true}, SHIFT(4608),
  [7341] = {.count = 1, .reusable = false}, SHIFT(4610),
  [7343] = {.count = 1, .reusable = true}, SHIFT(4615),
  [7345] = {.count = 1, .reusable = false}, SHIFT(4615),
  [7347] = {.count = 1, .reusable = true}, SHIFT(4616),
  [7349] = {.count = 1, .reusable = true}, SHIFT(4619),
  [7351] = {.count = 1, .reusable = true}, SHIFT(4623),
  [7353] = {.count = 1, .reusable = true}, SHIFT(4622),
  [7355] = {.count = 1, .reusable = true}, SHIFT(4632),
  [7357] = {.count = 1, .reusable = false}, SHIFT(4629),
  [7359] = {.count = 1, .reusable = false}, SHIFT(4633),
  [7361] = {.count = 1, .reusable = false}, SHIFT(4636),
  [7363] = {.count = 1, .reusable = false}, SHIFT(4638),
  [7365] = {.count = 1, .reusable = true}, SHIFT(4640),
  [7367] = {.count = 1, .reusable = true}, SHIFT(4642),
  [7369] = {.count = 1, .reusable = true}, SHIFT(4643),
  [7371] = {.count = 1, .reusable = true}, SHIFT(4644),
  [7373] = {.count = 1, .reusable = true}, SHIFT(4647),
  [7375] = {.count = 1, .reusable = true}, SHIFT(4648),
  [7377] = {.count = 1, .reusable = true}, SHIFT(4650),
  [7379] = {.count = 1, .reusable = true}, SHIFT(4652),
  [7381] = {.count = 1, .reusable = false}, SHIFT(4650),
  [7383] = {.count = 1, .reusable = true}, SHIFT(4654),
  [7385] = {.count = 1, .reusable = true}, SHIFT(4657),
  [7387] = {.count = 1, .reusable = true}, SHIFT(4658),
  [7389] = {.count = 1, .reusable = true}, SHIFT(4660),
  [7391] = {.count = 1, .reusable = true}, SHIFT(4662),
  [7393] = {.count = 1, .reusable = true}, SHIFT(4664),
  [7395] = {.count = 1, .reusable = true}, SHIFT(4666),
  [7397] = {.count = 1, .reusable = true}, SHIFT(4668),
  [7399] = {.count = 1, .reusable = false}, SHIFT(4669),
  [7401] = {.count = 1, .reusable = true}, SHIFT(4671),
  [7403] = {.count = 1, .reusable = false}, SHIFT(4672),
  [7405] = {.count = 1, .reusable = true}, SHIFT(4675),
  [7407] = {.count = 1, .reusable = true}, SHIFT(4678),
  [7409] = {.count = 1, .reusable = false}, SHIFT(4680),
  [7411] = {.count = 1, .reusable = true}, SHIFT(4682),
  [7413] = {.count = 1, .reusable = true}, SHIFT(4684),
  [7415] = {.count = 1, .reusable = false}, SHIFT(4685),
  [7417] = {.count = 1, .reusable = false}, SHIFT(4687),
  [7419] = {.count = 1, .reusable = true}, SHIFT(4689),
  [7421] = {.count = 1, .reusable = true}, SHIFT(4690),
  [7423] = {.count = 1, .reusable = true}, SHIFT(4691),
  [7425] = {.count = 1, .reusable = true}, SHIFT(4693),
  [7427] = {.count = 1, .reusable = false}, SHIFT(4694),
  [7429] = {.count = 1, .reusable = true}, SHIFT(4709),
  [7431] = {.count = 1, .reusable = true}, SHIFT(4715),
  [7433] = {.count = 1, .reusable = false}, SHIFT(4714),
  [7435] = {.count = 1, .reusable = true}, SHIFT(4718),
  [7437] = {.count = 1, .reusable = true}, SHIFT(4719),
  [7439] = {.count = 1, .reusable = true}, SHIFT(4722),
  [7441] = {.count = 1, .reusable = false}, SHIFT(4723),
  [7443] = {.count = 1, .reusable = true}, SHIFT(4726),
  [7445] = {.count = 1, .reusable = true}, SHIFT(4727),
  [7447] = {.count = 1, .reusable = false}, SHIFT(4728),
  [7449] = {.count = 1, .reusable = false}, SHIFT(4729),
  [7451] = {.count = 1, .reusable = false}, SHIFT(4730),
  [7453] = {.count = 1, .reusable = true}, SHIFT(4731),
  [7455] = {.count = 1, .reusable = false}, SHIFT(4732),
  [7457] = {.count = 1, .reusable = true}, SHIFT(4732),
  [7459] = {.count = 1, .reusable = true}, SHIFT(4733),
  [7461] = {.count = 1, .reusable = true}, SHIFT(4734),
  [7463] = {.count = 1, .reusable = true}, SHIFT(4735),
  [7465] = {.count = 1, .reusable = false}, SHIFT(4734),
  [7467] = {.count = 1, .reusable = true}, SHIFT(4730),
  [7469] = {.count = 1, .reusable = true}, SHIFT(4728),
  [7471] = {.count = 1, .reusable = true}, SHIFT(4736),
  [7473] = {.count = 1, .reusable = true}, SHIFT(4738),
  [7475] = {.count = 1, .reusable = false}, SHIFT(4738),
  [7477] = {.count = 1, .reusable = true}, SHIFT(4739),
  [7479] = {.count = 1, .reusable = true}, SHIFT(4744),
  [7481] = {.count = 1, .reusable = false}, SHIFT(4746),
  [7483] = {.count = 1, .reusable = true}, SHIFT(4748),
  [7485] = {.count = 1, .reusable = false}, SHIFT(4744),
  [7487] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(155),
  [7490] = {.count = 1, .reusable = false}, SHIFT(4769),
  [7492] = {.count = 1, .reusable = true}, REDUCE(sym_superclass, 2),
  [7494] = {.count = 1, .reusable = false}, SHIFT(4770),
  [7496] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4),
  [7498] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4),
  [7500] = {.count = 1, .reusable = true}, SHIFT(4772),
  [7502] = {.count = 1, .reusable = true}, SHIFT(4773),
  [7504] = {.count = 1, .reusable = true}, SHIFT(4774),
  [7506] = {.count = 1, .reusable = false}, SHIFT(4776),
  [7508] = {.count = 1, .reusable = true}, SHIFT(4782),
  [7510] = {.count = 1, .reusable = true}, SHIFT(4783),
  [7512] = {.count = 1, .reusable = false}, SHIFT(4784),
  [7514] = {.count = 1, .reusable = false}, SHIFT(4785),
  [7516] = {.count = 1, .reusable = false}, SHIFT(4786),
  [7518] = {.count = 1, .reusable = true}, SHIFT(4787),
  [7520] = {.count = 1, .reusable = false}, SHIFT(4788),
  [7522] = {.count = 1, .reusable = true}, SHIFT(4788),
  [7524] = {.count = 1, .reusable = true}, SHIFT(4789),
  [7526] = {.count = 1, .reusable = true}, SHIFT(4790),
  [7528] = {.count = 1, .reusable = true}, SHIFT(4791),
  [7530] = {.count = 1, .reusable = false}, SHIFT(4790),
  [7532] = {.count = 1, .reusable = true}, SHIFT(4786),
  [7534] = {.count = 1, .reusable = true}, SHIFT(4784),
  [7536] = {.count = 1, .reusable = true}, SHIFT(4792),
  [7538] = {.count = 1, .reusable = false}, SHIFT(4792),
  [7540] = {.count = 1, .reusable = true}, SHIFT(4793),
  [7542] = {.count = 1, .reusable = true}, SHIFT(4798),
  [7544] = {.count = 1, .reusable = false}, SHIFT(4800),
  [7546] = {.count = 1, .reusable = true}, SHIFT(4802),
  [7548] = {.count = 1, .reusable = false}, SHIFT(4798),
  [7550] = {.count = 1, .reusable = true}, REDUCE(sym_module, 4),
  [7552] = {.count = 1, .reusable = false}, REDUCE(sym_module, 4),
  [7554] = {.count = 1, .reusable = false}, REDUCE(sym_pair, 3),
  [7556] = {.count = 1, .reusable = true}, SHIFT(886),
  [7558] = {.count = 1, .reusable = true}, SHIFT(4849),
  [7560] = {.count = 1, .reusable = true}, SHIFT(4850),
  [7562] = {.count = 1, .reusable = false}, SHIFT(4851),
  [7564] = {.count = 1, .reusable = false}, SHIFT(4852),
  [7566] = {.count = 1, .reusable = false}, SHIFT(4853),
  [7568] = {.count = 1, .reusable = true}, SHIFT(4854),
  [7570] = {.count = 1, .reusable = false}, SHIFT(4855),
  [7572] = {.count = 1, .reusable = true}, SHIFT(4855),
  [7574] = {.count = 1, .reusable = true}, SHIFT(4856),
  [7576] = {.count = 1, .reusable = true}, SHIFT(4857),
  [7578] = {.count = 1, .reusable = true}, SHIFT(4858),
  [7580] = {.count = 1, .reusable = false}, SHIFT(4857),
  [7582] = {.count = 1, .reusable = true}, SHIFT(4853),
  [7584] = {.count = 1, .reusable = true}, SHIFT(4851),
  [7586] = {.count = 1, .reusable = true}, SHIFT(4859),
  [7588] = {.count = 1, .reusable = false}, SHIFT(4859),
  [7590] = {.count = 1, .reusable = true}, SHIFT(4860),
  [7592] = {.count = 1, .reusable = true}, SHIFT(4865),
  [7594] = {.count = 1, .reusable = false}, SHIFT(4867),
  [7596] = {.count = 1, .reusable = true}, SHIFT(4869),
  [7598] = {.count = 1, .reusable = false}, SHIFT(4865),
  [7600] = {.count = 1, .reusable = true}, SHIFT(4884),
  [7602] = {.count = 1, .reusable = false}, SHIFT(4886),
  [7604] = {.count = 1, .reusable = true}, SHIFT(4888),
  [7606] = {.count = 1, .reusable = false}, SHIFT(4884),
  [7608] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_parens, 3),
  [7610] = {.count = 1, .reusable = false}, REDUCE(sym__argument_list_with_parens, 3),
  [7612] = {.count = 1, .reusable = true}, SHIFT(4890),
  [7614] = {.count = 1, .reusable = true}, SHIFT(4892),
  [7616] = {.count = 1, .reusable = false}, REDUCE(sym_pair, 3, .alias_sequence_id = 18),
  [7618] = {.count = 1, .reusable = true}, SHIFT(4897),
  [7620] = {.count = 1, .reusable = false}, REDUCE(sym_range, 3),
  [7622] = {.count = 1, .reusable = true}, SHIFT(4898),
  [7624] = {.count = 1, .reusable = true}, SHIFT(4901),
  [7626] = {.count = 1, .reusable = true}, SHIFT(4902),
  [7628] = {.count = 1, .reusable = true}, SHIFT(4905),
  [7630] = {.count = 1, .reusable = true}, SHIFT(4907),
  [7632] = {.count = 1, .reusable = true}, SHIFT(4909),
  [7634] = {.count = 1, .reusable = false}, SHIFT(4907),
  [7636] = {.count = 1, .reusable = true}, SHIFT(4911),
  [7638] = {.count = 1, .reusable = true}, SHIFT(4915),
  [7640] = {.count = 1, .reusable = true}, SHIFT(4914),
  [7642] = {.count = 1, .reusable = true}, SHIFT(933),
  [7644] = {.count = 1, .reusable = true}, SHIFT(4921),
  [7646] = {.count = 1, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2),
  [7648] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(943),
  [7651] = {.count = 1, .reusable = false}, REDUCE(aux_sym_call_repeat1, 2),
  [7653] = {.count = 1, .reusable = true}, SHIFT(4923),
  [7655] = {.count = 1, .reusable = true}, SHIFT(4922),
  [7657] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [7659] = {.count = 1, .reusable = false}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [7661] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [7663] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [7665] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(945),
  [7668] = {.count = 1, .reusable = false}, REDUCE(sym__arg_or_splat_arg, 1),
  [7670] = {.count = 1, .reusable = false}, REDUCE(sym_operator_assignment, 3),
  [7672] = {.count = 1, .reusable = true}, SHIFT(4931),
  [7674] = {.count = 1, .reusable = true}, SHIFT(4932),
  [7676] = {.count = 1, .reusable = false}, SHIFT(4933),
  [7678] = {.count = 1, .reusable = false}, SHIFT(4934),
  [7680] = {.count = 1, .reusable = false}, SHIFT(4935),
  [7682] = {.count = 1, .reusable = true}, SHIFT(4936),
  [7684] = {.count = 1, .reusable = false}, SHIFT(4937),
  [7686] = {.count = 1, .reusable = true}, SHIFT(4937),
  [7688] = {.count = 1, .reusable = true}, SHIFT(4939),
  [7690] = {.count = 1, .reusable = true}, SHIFT(4940),
  [7692] = {.count = 1, .reusable = false}, SHIFT(4939),
  [7694] = {.count = 1, .reusable = true}, SHIFT(4935),
  [7696] = {.count = 1, .reusable = true}, SHIFT(4933),
  [7698] = {.count = 1, .reusable = true}, SHIFT(4941),
  [7700] = {.count = 1, .reusable = false}, SHIFT(4941),
  [7702] = {.count = 1, .reusable = true}, SHIFT(4942),
  [7704] = {.count = 1, .reusable = true}, SHIFT(4947),
  [7706] = {.count = 1, .reusable = false}, SHIFT(4949),
  [7708] = {.count = 1, .reusable = true}, SHIFT(4951),
  [7710] = {.count = 1, .reusable = false}, SHIFT(4947),
  [7712] = {.count = 1, .reusable = true}, SHIFT(4966),
  [7714] = {.count = 1, .reusable = false}, SHIFT(4968),
  [7716] = {.count = 1, .reusable = true}, SHIFT(4970),
  [7718] = {.count = 1, .reusable = false}, SHIFT(4966),
  [7720] = {.count = 1, .reusable = true}, SHIFT(955),
  [7722] = {.count = 1, .reusable = true}, SHIFT(4981),
  [7724] = {.count = 1, .reusable = true}, REDUCE(sym_if, 4),
  [7726] = {.count = 1, .reusable = false}, REDUCE(sym_if, 4),
  [7728] = {.count = 1, .reusable = true}, SHIFT(4983),
  [7730] = {.count = 1, .reusable = true}, SHIFT(4984),
  [7732] = {.count = 1, .reusable = true}, SHIFT(4985),
  [7734] = {.count = 1, .reusable = true}, SHIFT(4986),
  [7736] = {.count = 1, .reusable = false}, SHIFT(4988),
  [7738] = {.count = 1, .reusable = false}, SHIFT(4989),
  [7740] = {.count = 1, .reusable = false}, SHIFT(4990),
  [7742] = {.count = 1, .reusable = false}, SHIFT(4991),
  [7744] = {.count = 1, .reusable = true}, SHIFT(4992),
  [7746] = {.count = 1, .reusable = false}, SHIFT(4992),
  [7748] = {.count = 1, .reusable = false}, SHIFT(4993),
  [7750] = {.count = 1, .reusable = true}, SHIFT(4993),
  [7752] = {.count = 1, .reusable = false}, SHIFT(4994),
  [7754] = {.count = 1, .reusable = true}, SHIFT(4996),
  [7756] = {.count = 1, .reusable = false}, SHIFT(4996),
  [7758] = {.count = 1, .reusable = true}, SHIFT(5003),
  [7760] = {.count = 1, .reusable = true}, SHIFT(5005),
  [7762] = {.count = 1, .reusable = true}, SHIFT(5006),
  [7764] = {.count = 1, .reusable = true}, SHIFT(2623),
  [7766] = {.count = 1, .reusable = true}, SHIFT(2624),
  [7768] = {.count = 1, .reusable = true}, SHIFT(5008),
  [7770] = {.count = 1, .reusable = true}, SHIFT(5010),
  [7772] = {.count = 1, .reusable = true}, SHIFT(5011),
  [7774] = {.count = 1, .reusable = true}, SHIFT(5012),
  [7776] = {.count = 1, .reusable = true}, SHIFT(5013),
  [7778] = {.count = 1, .reusable = true}, SHIFT(5014),
  [7780] = {.count = 1, .reusable = true}, SHIFT(5015),
  [7782] = {.count = 1, .reusable = true}, SHIFT(5016),
  [7784] = {.count = 1, .reusable = false}, SHIFT(5017),
  [7786] = {.count = 1, .reusable = false}, SHIFT(5018),
  [7788] = {.count = 1, .reusable = false}, SHIFT(5019),
  [7790] = {.count = 1, .reusable = true}, SHIFT(5020),
  [7792] = {.count = 1, .reusable = false}, SHIFT(5021),
  [7794] = {.count = 1, .reusable = true}, SHIFT(5021),
  [7796] = {.count = 1, .reusable = true}, SHIFT(5022),
  [7798] = {.count = 1, .reusable = true}, SHIFT(5023),
  [7800] = {.count = 1, .reusable = true}, SHIFT(5024),
  [7802] = {.count = 1, .reusable = false}, SHIFT(5023),
  [7804] = {.count = 1, .reusable = true}, SHIFT(5019),
  [7806] = {.count = 1, .reusable = true}, SHIFT(5017),
  [7808] = {.count = 1, .reusable = true}, SHIFT(5025),
  [7810] = {.count = 1, .reusable = true}, SHIFT(5026),
  [7812] = {.count = 1, .reusable = true}, SHIFT(5027),
  [7814] = {.count = 1, .reusable = true}, SHIFT(5028),
  [7816] = {.count = 1, .reusable = false}, SHIFT(5030),
  [7818] = {.count = 1, .reusable = false}, SHIFT(5031),
  [7820] = {.count = 1, .reusable = false}, SHIFT(5032),
  [7822] = {.count = 1, .reusable = false}, SHIFT(5033),
  [7824] = {.count = 1, .reusable = true}, SHIFT(5034),
  [7826] = {.count = 1, .reusable = false}, SHIFT(5034),
  [7828] = {.count = 1, .reusable = false}, SHIFT(5035),
  [7830] = {.count = 1, .reusable = true}, SHIFT(5035),
  [7832] = {.count = 1, .reusable = false}, SHIFT(5036),
  [7834] = {.count = 1, .reusable = true}, SHIFT(5038),
  [7836] = {.count = 1, .reusable = false}, SHIFT(5038),
  [7838] = {.count = 1, .reusable = true}, SHIFT(5044),
  [7840] = {.count = 1, .reusable = false}, SHIFT(5044),
  [7842] = {.count = 1, .reusable = true}, SHIFT(5045),
  [7844] = {.count = 1, .reusable = false}, SHIFT(5006),
  [7846] = {.count = 1, .reusable = true}, REDUCE(sym__then, 2),
  [7848] = {.count = 1, .reusable = false}, REDUCE(sym__then, 2),
  [7850] = {.count = 1, .reusable = true}, SHIFT(5048),
  [7852] = {.count = 1, .reusable = true}, SHIFT(5051),
  [7854] = {.count = 1, .reusable = true}, SHIFT(5052),
  [7856] = {.count = 1, .reusable = false}, SHIFT(5053),
  [7858] = {.count = 1, .reusable = false}, SHIFT(5052),
  [7860] = {.count = 1, .reusable = false}, SHIFT(5054),
  [7862] = {.count = 1, .reusable = false}, SHIFT(5055),
  [7864] = {.count = 1, .reusable = true}, SHIFT(5056),
  [7866] = {.count = 1, .reusable = false}, SHIFT(5057),
  [7868] = {.count = 1, .reusable = true}, SHIFT(5057),
  [7870] = {.count = 1, .reusable = false}, SHIFT(5059),
  [7872] = {.count = 1, .reusable = false}, SHIFT(5060),
  [7874] = {.count = 1, .reusable = true}, SHIFT(5059),
  [7876] = {.count = 1, .reusable = true}, SHIFT(5055),
  [7878] = {.count = 1, .reusable = false}, SHIFT(5051),
  [7880] = {.count = 1, .reusable = true}, SHIFT(5061),
  [7882] = {.count = 1, .reusable = false}, SHIFT(5061),
  [7884] = {.count = 1, .reusable = true}, SHIFT(5062),
  [7886] = {.count = 1, .reusable = true}, SHIFT(994),
  [7888] = {.count = 1, .reusable = true}, SHIFT(5087),
  [7890] = {.count = 1, .reusable = true}, SHIFT(5088),
  [7892] = {.count = 1, .reusable = false}, SHIFT(5089),
  [7894] = {.count = 1, .reusable = false}, SHIFT(5090),
  [7896] = {.count = 1, .reusable = false}, SHIFT(5091),
  [7898] = {.count = 1, .reusable = true}, SHIFT(5092),
  [7900] = {.count = 1, .reusable = false}, SHIFT(5093),
  [7902] = {.count = 1, .reusable = true}, SHIFT(5093),
  [7904] = {.count = 1, .reusable = true}, SHIFT(5095),
  [7906] = {.count = 1, .reusable = true}, SHIFT(5096),
  [7908] = {.count = 1, .reusable = false}, SHIFT(5095),
  [7910] = {.count = 1, .reusable = true}, SHIFT(5091),
  [7912] = {.count = 1, .reusable = true}, SHIFT(5089),
  [7914] = {.count = 1, .reusable = true}, SHIFT(5097),
  [7916] = {.count = 1, .reusable = true}, SHIFT(5099),
  [7918] = {.count = 1, .reusable = false}, SHIFT(5099),
  [7920] = {.count = 1, .reusable = true}, SHIFT(5100),
  [7922] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 4),
  [7924] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 4),
  [7926] = {.count = 1, .reusable = true}, SHIFT(5102),
  [7928] = {.count = 1, .reusable = true}, SHIFT(5103),
  [7930] = {.count = 1, .reusable = true}, SHIFT(5104),
  [7932] = {.count = 1, .reusable = true}, SHIFT(5105),
  [7934] = {.count = 1, .reusable = false}, SHIFT(5107),
  [7936] = {.count = 1, .reusable = false}, SHIFT(5108),
  [7938] = {.count = 1, .reusable = false}, SHIFT(5109),
  [7940] = {.count = 1, .reusable = false}, SHIFT(5110),
  [7942] = {.count = 1, .reusable = true}, SHIFT(5111),
  [7944] = {.count = 1, .reusable = false}, SHIFT(5111),
  [7946] = {.count = 1, .reusable = false}, SHIFT(5112),
  [7948] = {.count = 1, .reusable = true}, SHIFT(5112),
  [7950] = {.count = 1, .reusable = false}, SHIFT(5113),
  [7952] = {.count = 1, .reusable = true}, SHIFT(5115),
  [7954] = {.count = 1, .reusable = false}, SHIFT(5115),
  [7956] = {.count = 1, .reusable = true}, SHIFT(5122),
  [7958] = {.count = 1, .reusable = true}, SHIFT(5123),
  [7960] = {.count = 1, .reusable = true}, SHIFT(5125),
  [7962] = {.count = 1, .reusable = true}, SHIFT(5127),
  [7964] = {.count = 1, .reusable = true}, SHIFT(5128),
  [7966] = {.count = 1, .reusable = true}, SHIFT(5129),
  [7968] = {.count = 1, .reusable = true}, SHIFT(5130),
  [7970] = {.count = 1, .reusable = true}, SHIFT(5131),
  [7972] = {.count = 1, .reusable = true}, SHIFT(5132),
  [7974] = {.count = 1, .reusable = true}, SHIFT(5133),
  [7976] = {.count = 1, .reusable = false}, SHIFT(5134),
  [7978] = {.count = 1, .reusable = false}, SHIFT(5135),
  [7980] = {.count = 1, .reusable = false}, SHIFT(5136),
  [7982] = {.count = 1, .reusable = true}, SHIFT(5137),
  [7984] = {.count = 1, .reusable = false}, SHIFT(5138),
  [7986] = {.count = 1, .reusable = true}, SHIFT(5138),
  [7988] = {.count = 1, .reusable = true}, SHIFT(5139),
  [7990] = {.count = 1, .reusable = true}, SHIFT(5140),
  [7992] = {.count = 1, .reusable = true}, SHIFT(5141),
  [7994] = {.count = 1, .reusable = false}, SHIFT(5140),
  [7996] = {.count = 1, .reusable = true}, SHIFT(5136),
  [7998] = {.count = 1, .reusable = true}, SHIFT(5134),
  [8000] = {.count = 1, .reusable = true}, SHIFT(5142),
  [8002] = {.count = 1, .reusable = true}, SHIFT(5143),
  [8004] = {.count = 1, .reusable = true}, SHIFT(5144),
  [8006] = {.count = 1, .reusable = true}, SHIFT(5145),
  [8008] = {.count = 1, .reusable = false}, SHIFT(5147),
  [8010] = {.count = 1, .reusable = false}, SHIFT(5148),
  [8012] = {.count = 1, .reusable = false}, SHIFT(5149),
  [8014] = {.count = 1, .reusable = false}, SHIFT(5150),
  [8016] = {.count = 1, .reusable = true}, SHIFT(5151),
  [8018] = {.count = 1, .reusable = false}, SHIFT(5151),
  [8020] = {.count = 1, .reusable = false}, SHIFT(5152),
  [8022] = {.count = 1, .reusable = true}, SHIFT(5152),
  [8024] = {.count = 1, .reusable = false}, SHIFT(5153),
  [8026] = {.count = 1, .reusable = true}, SHIFT(5155),
  [8028] = {.count = 1, .reusable = false}, SHIFT(5155),
  [8030] = {.count = 1, .reusable = true}, SHIFT(5161),
  [8032] = {.count = 1, .reusable = false}, SHIFT(5161),
  [8034] = {.count = 1, .reusable = true}, SHIFT(5162),
  [8036] = {.count = 1, .reusable = true}, SHIFT(5168),
  [8038] = {.count = 1, .reusable = true}, SHIFT(5169),
  [8040] = {.count = 1, .reusable = false}, SHIFT(5170),
  [8042] = {.count = 1, .reusable = false}, SHIFT(5171),
  [8044] = {.count = 1, .reusable = false}, SHIFT(5172),
  [8046] = {.count = 1, .reusable = true}, SHIFT(5173),
  [8048] = {.count = 1, .reusable = false}, SHIFT(5174),
  [8050] = {.count = 1, .reusable = true}, SHIFT(5174),
  [8052] = {.count = 1, .reusable = true}, SHIFT(5176),
  [8054] = {.count = 1, .reusable = true}, SHIFT(5177),
  [8056] = {.count = 1, .reusable = false}, SHIFT(5176),
  [8058] = {.count = 1, .reusable = true}, SHIFT(5172),
  [8060] = {.count = 1, .reusable = true}, SHIFT(5170),
  [8062] = {.count = 1, .reusable = true}, SHIFT(5178),
  [8064] = {.count = 1, .reusable = false}, SHIFT(5178),
  [8066] = {.count = 1, .reusable = true}, SHIFT(5179),
  [8068] = {.count = 1, .reusable = true}, SHIFT(5184),
  [8070] = {.count = 1, .reusable = false}, SHIFT(5186),
  [8072] = {.count = 1, .reusable = true}, SHIFT(5188),
  [8074] = {.count = 1, .reusable = false}, SHIFT(5184),
  [8076] = {.count = 1, .reusable = true}, SHIFT(5203),
  [8078] = {.count = 1, .reusable = true}, SHIFT(5204),
  [8080] = {.count = 1, .reusable = false}, SHIFT(5206),
  [8082] = {.count = 1, .reusable = true}, SHIFT(5208),
  [8084] = {.count = 1, .reusable = false}, SHIFT(5203),
  [8086] = {.count = 1, .reusable = true}, SHIFT(1019),
  [8088] = {.count = 1, .reusable = true}, SHIFT(5218),
  [8090] = {.count = 1, .reusable = true}, REDUCE(sym_while, 4),
  [8092] = {.count = 1, .reusable = false}, REDUCE(sym_while, 4),
  [8094] = {.count = 1, .reusable = true}, SHIFT(5219),
  [8096] = {.count = 1, .reusable = true}, SHIFT(5222),
  [8098] = {.count = 1, .reusable = true}, SHIFT(5223),
  [8100] = {.count = 1, .reusable = false}, SHIFT(5224),
  [8102] = {.count = 1, .reusable = false}, SHIFT(5223),
  [8104] = {.count = 1, .reusable = false}, SHIFT(5225),
  [8106] = {.count = 1, .reusable = false}, SHIFT(5226),
  [8108] = {.count = 1, .reusable = true}, SHIFT(5227),
  [8110] = {.count = 1, .reusable = false}, SHIFT(5228),
  [8112] = {.count = 1, .reusable = true}, SHIFT(5228),
  [8114] = {.count = 1, .reusable = false}, SHIFT(5230),
  [8116] = {.count = 1, .reusable = false}, SHIFT(5231),
  [8118] = {.count = 1, .reusable = true}, SHIFT(5230),
  [8120] = {.count = 1, .reusable = true}, SHIFT(5226),
  [8122] = {.count = 1, .reusable = false}, SHIFT(5222),
  [8124] = {.count = 1, .reusable = true}, SHIFT(5232),
  [8126] = {.count = 1, .reusable = false}, SHIFT(5232),
  [8128] = {.count = 1, .reusable = true}, SHIFT(5233),
  [8130] = {.count = 1, .reusable = true}, SHIFT(1051),
  [8132] = {.count = 1, .reusable = true}, SHIFT(5258),
  [8134] = {.count = 1, .reusable = true}, SHIFT(5259),
  [8136] = {.count = 1, .reusable = false}, SHIFT(5260),
  [8138] = {.count = 1, .reusable = false}, SHIFT(5261),
  [8140] = {.count = 1, .reusable = false}, SHIFT(5262),
  [8142] = {.count = 1, .reusable = true}, SHIFT(5263),
  [8144] = {.count = 1, .reusable = false}, SHIFT(5264),
  [8146] = {.count = 1, .reusable = true}, SHIFT(5264),
  [8148] = {.count = 1, .reusable = true}, SHIFT(5266),
  [8150] = {.count = 1, .reusable = true}, SHIFT(5267),
  [8152] = {.count = 1, .reusable = false}, SHIFT(5266),
  [8154] = {.count = 1, .reusable = true}, SHIFT(5262),
  [8156] = {.count = 1, .reusable = true}, SHIFT(5260),
  [8158] = {.count = 1, .reusable = true}, SHIFT(5268),
  [8160] = {.count = 1, .reusable = true}, SHIFT(5270),
  [8162] = {.count = 1, .reusable = false}, SHIFT(5270),
  [8164] = {.count = 1, .reusable = true}, SHIFT(5271),
  [8166] = {.count = 1, .reusable = true}, REDUCE(sym_until, 4),
  [8168] = {.count = 1, .reusable = false}, REDUCE(sym_until, 4),
  [8170] = {.count = 1, .reusable = true}, SHIFT(5272),
  [8172] = {.count = 1, .reusable = true}, SHIFT(5274),
  [8174] = {.count = 1, .reusable = true}, SHIFT(5275),
  [8176] = {.count = 1, .reusable = true}, SHIFT(5276),
  [8178] = {.count = 1, .reusable = false}, SHIFT(5278),
  [8180] = {.count = 1, .reusable = true}, SHIFT(5284),
  [8182] = {.count = 1, .reusable = true}, SHIFT(5285),
  [8184] = {.count = 1, .reusable = false}, SHIFT(5286),
  [8186] = {.count = 1, .reusable = false}, SHIFT(5287),
  [8188] = {.count = 1, .reusable = false}, SHIFT(5288),
  [8190] = {.count = 1, .reusable = true}, SHIFT(5289),
  [8192] = {.count = 1, .reusable = false}, SHIFT(5290),
  [8194] = {.count = 1, .reusable = true}, SHIFT(5290),
  [8196] = {.count = 1, .reusable = true}, SHIFT(5291),
  [8198] = {.count = 1, .reusable = true}, SHIFT(5292),
  [8200] = {.count = 1, .reusable = true}, SHIFT(5293),
  [8202] = {.count = 1, .reusable = false}, SHIFT(5292),
  [8204] = {.count = 1, .reusable = true}, SHIFT(5288),
  [8206] = {.count = 1, .reusable = true}, SHIFT(5286),
  [8208] = {.count = 1, .reusable = true}, SHIFT(5294),
  [8210] = {.count = 1, .reusable = true}, SHIFT(5295),
  [8212] = {.count = 1, .reusable = true}, SHIFT(5296),
  [8214] = {.count = 1, .reusable = false}, SHIFT(5298),
  [8216] = {.count = 1, .reusable = true}, SHIFT(5303),
  [8218] = {.count = 1, .reusable = false}, SHIFT(5303),
  [8220] = {.count = 1, .reusable = true}, SHIFT(5304),
  [8222] = {.count = 1, .reusable = true}, SHIFT(5309),
  [8224] = {.count = 1, .reusable = false}, SHIFT(5311),
  [8226] = {.count = 1, .reusable = true}, SHIFT(5313),
  [8228] = {.count = 1, .reusable = false}, SHIFT(5309),
  [8230] = {.count = 1, .reusable = false}, SHIFT(2866),
  [8232] = {.count = 1, .reusable = true}, SHIFT(5330),
  [8234] = {.count = 1, .reusable = false}, SHIFT(5333),
  [8236] = {.count = 1, .reusable = true}, SHIFT(5334),
  [8238] = {.count = 1, .reusable = true}, SHIFT(5335),
  [8240] = {.count = 1, .reusable = false}, SHIFT(5336),
  [8242] = {.count = 1, .reusable = false}, SHIFT(5335),
  [8244] = {.count = 1, .reusable = false}, SHIFT(5337),
  [8246] = {.count = 1, .reusable = false}, SHIFT(5338),
  [8248] = {.count = 1, .reusable = true}, SHIFT(5339),
  [8250] = {.count = 1, .reusable = false}, SHIFT(5340),
  [8252] = {.count = 1, .reusable = true}, SHIFT(5340),
  [8254] = {.count = 1, .reusable = false}, SHIFT(5342),
  [8256] = {.count = 1, .reusable = false}, SHIFT(5343),
  [8258] = {.count = 1, .reusable = true}, SHIFT(5342),
  [8260] = {.count = 1, .reusable = true}, SHIFT(5338),
  [8262] = {.count = 1, .reusable = false}, SHIFT(5334),
  [8264] = {.count = 1, .reusable = true}, SHIFT(5345),
  [8266] = {.count = 1, .reusable = true}, SHIFT(5347),
  [8268] = {.count = 1, .reusable = false}, SHIFT(5347),
  [8270] = {.count = 1, .reusable = true}, SHIFT(5348),
  [8272] = {.count = 1, .reusable = false}, SHIFT(5330),
  [8274] = {.count = 1, .reusable = true}, REDUCE(sym_in, 2),
  [8276] = {.count = 1, .reusable = false}, SHIFT(5358),
  [8278] = {.count = 1, .reusable = true}, SHIFT(5364),
  [8280] = {.count = 1, .reusable = true}, SHIFT(5365),
  [8282] = {.count = 1, .reusable = false}, SHIFT(5366),
  [8284] = {.count = 1, .reusable = false}, SHIFT(5367),
  [8286] = {.count = 1, .reusable = false}, SHIFT(5368),
  [8288] = {.count = 1, .reusable = true}, SHIFT(5369),
  [8290] = {.count = 1, .reusable = false}, SHIFT(5370),
  [8292] = {.count = 1, .reusable = true}, SHIFT(5370),
  [8294] = {.count = 1, .reusable = true}, SHIFT(5372),
  [8296] = {.count = 1, .reusable = true}, SHIFT(5373),
  [8298] = {.count = 1, .reusable = false}, SHIFT(5372),
  [8300] = {.count = 1, .reusable = true}, SHIFT(5368),
  [8302] = {.count = 1, .reusable = true}, SHIFT(5366),
  [8304] = {.count = 1, .reusable = true}, SHIFT(5374),
  [8306] = {.count = 1, .reusable = false}, SHIFT(5374),
  [8308] = {.count = 1, .reusable = true}, SHIFT(5375),
  [8310] = {.count = 1, .reusable = true}, SHIFT(5380),
  [8312] = {.count = 1, .reusable = false}, SHIFT(5382),
  [8314] = {.count = 1, .reusable = true}, SHIFT(5384),
  [8316] = {.count = 1, .reusable = false}, SHIFT(5380),
  [8318] = {.count = 1, .reusable = true}, SHIFT(1098),
  [8320] = {.count = 1, .reusable = true}, SHIFT(5405),
  [8322] = {.count = 1, .reusable = true}, SHIFT(5406),
  [8324] = {.count = 1, .reusable = true}, SHIFT(5411),
  [8326] = {.count = 1, .reusable = true}, SHIFT(5412),
  [8328] = {.count = 1, .reusable = false}, SHIFT(5413),
  [8330] = {.count = 1, .reusable = false}, SHIFT(5414),
  [8332] = {.count = 1, .reusable = false}, SHIFT(5415),
  [8334] = {.count = 1, .reusable = true}, SHIFT(5416),
  [8336] = {.count = 1, .reusable = false}, SHIFT(5417),
  [8338] = {.count = 1, .reusable = true}, SHIFT(5417),
  [8340] = {.count = 1, .reusable = true}, SHIFT(5419),
  [8342] = {.count = 1, .reusable = true}, SHIFT(5420),
  [8344] = {.count = 1, .reusable = false}, SHIFT(5419),
  [8346] = {.count = 1, .reusable = true}, SHIFT(5415),
  [8348] = {.count = 1, .reusable = true}, SHIFT(5413),
  [8350] = {.count = 1, .reusable = true}, SHIFT(5421),
  [8352] = {.count = 1, .reusable = true}, SHIFT(5423),
  [8354] = {.count = 1, .reusable = false}, SHIFT(5423),
  [8356] = {.count = 1, .reusable = true}, SHIFT(5424),
  [8358] = {.count = 1, .reusable = true}, SHIFT(5427),
  [8360] = {.count = 1, .reusable = true}, SHIFT(5428),
  [8362] = {.count = 1, .reusable = true}, SHIFT(5429),
  [8364] = {.count = 1, .reusable = false}, SHIFT(5431),
  [8366] = {.count = 1, .reusable = true}, SHIFT(5437),
  [8368] = {.count = 1, .reusable = true}, SHIFT(5438),
  [8370] = {.count = 1, .reusable = true}, REDUCE(sym_pattern, 1),
  [8372] = {.count = 1, .reusable = true}, SHIFT(5440),
  [8374] = {.count = 1, .reusable = true}, SHIFT(5441),
  [8376] = {.count = 1, .reusable = false}, SHIFT(5442),
  [8378] = {.count = 1, .reusable = false}, SHIFT(5443),
  [8380] = {.count = 1, .reusable = false}, SHIFT(5444),
  [8382] = {.count = 1, .reusable = true}, SHIFT(5445),
  [8384] = {.count = 1, .reusable = false}, SHIFT(5446),
  [8386] = {.count = 1, .reusable = true}, SHIFT(5446),
  [8388] = {.count = 1, .reusable = true}, SHIFT(5447),
  [8390] = {.count = 1, .reusable = true}, SHIFT(5448),
  [8392] = {.count = 1, .reusable = true}, SHIFT(5449),
  [8394] = {.count = 1, .reusable = false}, SHIFT(5448),
  [8396] = {.count = 1, .reusable = true}, SHIFT(5444),
  [8398] = {.count = 1, .reusable = true}, SHIFT(5442),
  [8400] = {.count = 1, .reusable = true}, SHIFT(5450),
  [8402] = {.count = 1, .reusable = true}, SHIFT(5451),
  [8404] = {.count = 1, .reusable = true}, SHIFT(5452),
  [8406] = {.count = 1, .reusable = false}, SHIFT(5454),
  [8408] = {.count = 1, .reusable = true}, SHIFT(5459),
  [8410] = {.count = 1, .reusable = false}, SHIFT(5459),
  [8412] = {.count = 1, .reusable = true}, SHIFT(5460),
  [8414] = {.count = 1, .reusable = true}, REDUCE(sym_case, 4),
  [8416] = {.count = 1, .reusable = false}, REDUCE(sym_case, 4),
  [8418] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(2971),
  [8421] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2),
  [8423] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [8425] = {.count = 1, .reusable = true}, SHIFT(5466),
  [8427] = {.count = 1, .reusable = true}, SHIFT(5467),
  [8429] = {.count = 1, .reusable = false}, SHIFT(5468),
  [8431] = {.count = 1, .reusable = false}, SHIFT(5469),
  [8433] = {.count = 1, .reusable = false}, SHIFT(5470),
  [8435] = {.count = 1, .reusable = true}, SHIFT(5471),
  [8437] = {.count = 1, .reusable = false}, SHIFT(5472),
  [8439] = {.count = 1, .reusable = true}, SHIFT(5472),
  [8441] = {.count = 1, .reusable = true}, SHIFT(5474),
  [8443] = {.count = 1, .reusable = true}, SHIFT(5475),
  [8445] = {.count = 1, .reusable = false}, SHIFT(5474),
  [8447] = {.count = 1, .reusable = true}, SHIFT(5470),
  [8449] = {.count = 1, .reusable = true}, SHIFT(5468),
  [8451] = {.count = 1, .reusable = true}, SHIFT(5476),
  [8453] = {.count = 1, .reusable = false}, SHIFT(5476),
  [8455] = {.count = 1, .reusable = true}, SHIFT(5477),
  [8457] = {.count = 1, .reusable = true}, SHIFT(5482),
  [8459] = {.count = 1, .reusable = false}, SHIFT(5484),
  [8461] = {.count = 1, .reusable = true}, SHIFT(5486),
  [8463] = {.count = 1, .reusable = false}, SHIFT(5482),
  [8465] = {.count = 1, .reusable = true}, SHIFT(5501),
  [8467] = {.count = 1, .reusable = false}, SHIFT(5503),
  [8469] = {.count = 1, .reusable = true}, SHIFT(5505),
  [8471] = {.count = 1, .reusable = false}, SHIFT(5501),
  [8473] = {.count = 1, .reusable = true}, SHIFT(1138),
  [8475] = {.count = 1, .reusable = false}, SHIFT(3029),
  [8477] = {.count = 1, .reusable = true}, SHIFT(5518),
  [8479] = {.count = 1, .reusable = false}, SHIFT(5521),
  [8481] = {.count = 1, .reusable = true}, SHIFT(5522),
  [8483] = {.count = 1, .reusable = true}, SHIFT(5523),
  [8485] = {.count = 1, .reusable = false}, SHIFT(5524),
  [8487] = {.count = 1, .reusable = false}, SHIFT(5525),
  [8489] = {.count = 1, .reusable = false}, SHIFT(5526),
  [8491] = {.count = 1, .reusable = true}, SHIFT(5527),
  [8493] = {.count = 1, .reusable = false}, SHIFT(5528),
  [8495] = {.count = 1, .reusable = true}, SHIFT(5528),
  [8497] = {.count = 1, .reusable = true}, SHIFT(5530),
  [8499] = {.count = 1, .reusable = true}, SHIFT(5531),
  [8501] = {.count = 1, .reusable = false}, SHIFT(5530),
  [8503] = {.count = 1, .reusable = true}, SHIFT(5526),
  [8505] = {.count = 1, .reusable = true}, SHIFT(5524),
  [8507] = {.count = 1, .reusable = true}, SHIFT(5533),
  [8509] = {.count = 1, .reusable = true}, SHIFT(5535),
  [8511] = {.count = 1, .reusable = false}, SHIFT(5535),
  [8513] = {.count = 1, .reusable = true}, SHIFT(5536),
  [8515] = {.count = 1, .reusable = false}, SHIFT(5518),
  [8517] = {.count = 1, .reusable = true}, SHIFT(5537),
  [8519] = {.count = 1, .reusable = true}, SHIFT(5538),
  [8521] = {.count = 1, .reusable = true}, SHIFT(5539),
  [8523] = {.count = 1, .reusable = true}, SHIFT(5540),
  [8525] = {.count = 1, .reusable = true}, SHIFT(5541),
  [8527] = {.count = 1, .reusable = true}, SHIFT(5542),
  [8529] = {.count = 1, .reusable = true}, SHIFT(5543),
  [8531] = {.count = 1, .reusable = true}, SHIFT(5544),
  [8533] = {.count = 1, .reusable = false}, SHIFT(5545),
  [8535] = {.count = 1, .reusable = false}, SHIFT(5546),
  [8537] = {.count = 1, .reusable = false}, SHIFT(5547),
  [8539] = {.count = 1, .reusable = false}, SHIFT(5548),
  [8541] = {.count = 1, .reusable = true}, SHIFT(5549),
  [8543] = {.count = 1, .reusable = false}, SHIFT(5541),
  [8545] = {.count = 1, .reusable = true}, SHIFT(5550),
  [8547] = {.count = 1, .reusable = false}, SHIFT(5550),
  [8549] = {.count = 1, .reusable = true}, SHIFT(5551),
  [8551] = {.count = 1, .reusable = false}, SHIFT(5552),
  [8553] = {.count = 1, .reusable = true}, REDUCE(sym_exception_variable, 2),
  [8555] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 3),
  [8557] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 3),
  [8559] = {.count = 1, .reusable = true}, SHIFT(5563),
  [8561] = {.count = 1, .reusable = false}, SHIFT(3064),
  [8563] = {.count = 1, .reusable = true}, SHIFT(5578),
  [8565] = {.count = 1, .reusable = false}, SHIFT(5581),
  [8567] = {.count = 1, .reusable = true}, SHIFT(5582),
  [8569] = {.count = 1, .reusable = true}, SHIFT(5583),
  [8571] = {.count = 1, .reusable = false}, SHIFT(5584),
  [8573] = {.count = 1, .reusable = false}, SHIFT(5583),
  [8575] = {.count = 1, .reusable = false}, SHIFT(5585),
  [8577] = {.count = 1, .reusable = false}, SHIFT(5586),
  [8579] = {.count = 1, .reusable = true}, SHIFT(5587),
  [8581] = {.count = 1, .reusable = false}, SHIFT(5588),
  [8583] = {.count = 1, .reusable = true}, SHIFT(5588),
  [8585] = {.count = 1, .reusable = false}, SHIFT(5590),
  [8587] = {.count = 1, .reusable = false}, SHIFT(5591),
  [8589] = {.count = 1, .reusable = true}, SHIFT(5590),
  [8591] = {.count = 1, .reusable = true}, SHIFT(5586),
  [8593] = {.count = 1, .reusable = false}, SHIFT(5582),
  [8595] = {.count = 1, .reusable = true}, SHIFT(5593),
  [8597] = {.count = 1, .reusable = true}, SHIFT(5595),
  [8599] = {.count = 1, .reusable = false}, SHIFT(5595),
  [8601] = {.count = 1, .reusable = true}, SHIFT(5596),
  [8603] = {.count = 1, .reusable = false}, SHIFT(5578),
  [8605] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 2),
  [8607] = {.count = 1, .reusable = true}, SHIFT(5600),
  [8609] = {.count = 1, .reusable = true}, SHIFT(5605),
  [8611] = {.count = 1, .reusable = false}, SHIFT(5606),
  [8613] = {.count = 1, .reusable = false}, SHIFT(5607),
  [8615] = {.count = 1, .reusable = false}, SHIFT(5608),
  [8617] = {.count = 1, .reusable = false}, SHIFT(5609),
  [8619] = {.count = 1, .reusable = false}, SHIFT(5605),
  [8621] = {.count = 1, .reusable = true}, SHIFT(5610),
  [8623] = {.count = 1, .reusable = false}, SHIFT(5610),
  [8625] = {.count = 1, .reusable = true}, SHIFT(5611),
  [8627] = {.count = 1, .reusable = false}, SHIFT(3089),
  [8629] = {.count = 1, .reusable = true}, SHIFT(5619),
  [8631] = {.count = 1, .reusable = true}, SHIFT(5621),
  [8633] = {.count = 1, .reusable = true}, SHIFT(5622),
  [8635] = {.count = 1, .reusable = true}, SHIFT(5623),
  [8637] = {.count = 1, .reusable = false}, SHIFT(5625),
  [8639] = {.count = 1, .reusable = false}, SHIFT(5631),
  [8641] = {.count = 1, .reusable = true}, SHIFT(5632),
  [8643] = {.count = 1, .reusable = true}, SHIFT(5633),
  [8645] = {.count = 1, .reusable = false}, SHIFT(5634),
  [8647] = {.count = 1, .reusable = false}, SHIFT(5635),
  [8649] = {.count = 1, .reusable = false}, SHIFT(5636),
  [8651] = {.count = 1, .reusable = true}, SHIFT(5637),
  [8653] = {.count = 1, .reusable = false}, SHIFT(5638),
  [8655] = {.count = 1, .reusable = true}, SHIFT(5638),
  [8657] = {.count = 1, .reusable = true}, SHIFT(5640),
  [8659] = {.count = 1, .reusable = true}, SHIFT(5641),
  [8661] = {.count = 1, .reusable = false}, SHIFT(5640),
  [8663] = {.count = 1, .reusable = true}, SHIFT(5636),
  [8665] = {.count = 1, .reusable = true}, SHIFT(5634),
  [8667] = {.count = 1, .reusable = true}, SHIFT(5642),
  [8669] = {.count = 1, .reusable = true}, SHIFT(5643),
  [8671] = {.count = 1, .reusable = true}, SHIFT(5644),
  [8673] = {.count = 1, .reusable = false}, SHIFT(5646),
  [8675] = {.count = 1, .reusable = true}, SHIFT(5652),
  [8677] = {.count = 1, .reusable = true}, SHIFT(5654),
  [8679] = {.count = 1, .reusable = false}, SHIFT(5654),
  [8681] = {.count = 1, .reusable = true}, SHIFT(5655),
  [8683] = {.count = 1, .reusable = false}, SHIFT(5619),
  [8685] = {.count = 1, .reusable = true}, SHIFT(5658),
  [8687] = {.count = 1, .reusable = true}, SHIFT(5675),
  [8689] = {.count = 1, .reusable = false}, SHIFT(5676),
  [8691] = {.count = 1, .reusable = false}, SHIFT(5677),
  [8693] = {.count = 1, .reusable = false}, SHIFT(5678),
  [8695] = {.count = 1, .reusable = false}, SHIFT(5679),
  [8697] = {.count = 1, .reusable = false}, SHIFT(5675),
  [8699] = {.count = 1, .reusable = true}, SHIFT(5680),
  [8701] = {.count = 1, .reusable = false}, SHIFT(5680),
  [8703] = {.count = 1, .reusable = true}, SHIFT(5681),
  [8705] = {.count = 1, .reusable = false}, SHIFT(5683),
  [8707] = {.count = 1, .reusable = true}, SHIFT(5683),
  [8709] = {.count = 1, .reusable = false}, SHIFT(3127),
  [8711] = {.count = 1, .reusable = true}, SHIFT(5690),
  [8713] = {.count = 1, .reusable = false}, SHIFT(5693),
  [8715] = {.count = 1, .reusable = true}, SHIFT(5694),
  [8717] = {.count = 1, .reusable = true}, SHIFT(5695),
  [8719] = {.count = 1, .reusable = false}, SHIFT(5696),
  [8721] = {.count = 1, .reusable = false}, SHIFT(5695),
  [8723] = {.count = 1, .reusable = false}, SHIFT(5697),
  [8725] = {.count = 1, .reusable = false}, SHIFT(5698),
  [8727] = {.count = 1, .reusable = true}, SHIFT(5699),
  [8729] = {.count = 1, .reusable = false}, SHIFT(5700),
  [8731] = {.count = 1, .reusable = true}, SHIFT(5700),
  [8733] = {.count = 1, .reusable = false}, SHIFT(5702),
  [8735] = {.count = 1, .reusable = false}, SHIFT(5703),
  [8737] = {.count = 1, .reusable = true}, SHIFT(5702),
  [8739] = {.count = 1, .reusable = true}, SHIFT(5698),
  [8741] = {.count = 1, .reusable = false}, SHIFT(5694),
  [8743] = {.count = 1, .reusable = true}, SHIFT(5705),
  [8745] = {.count = 1, .reusable = true}, SHIFT(5707),
  [8747] = {.count = 1, .reusable = false}, SHIFT(5707),
  [8749] = {.count = 1, .reusable = true}, SHIFT(5708),
  [8751] = {.count = 1, .reusable = false}, SHIFT(5690),
  [8753] = {.count = 1, .reusable = true}, SHIFT(5710),
  [8755] = {.count = 1, .reusable = true}, SHIFT(5711),
  [8757] = {.count = 1, .reusable = false}, SHIFT(5711),
  [8759] = {.count = 1, .reusable = true}, SHIFT(5712),
  [8761] = {.count = 1, .reusable = false}, SHIFT(5712),
  [8763] = {.count = 1, .reusable = true}, SHIFT(5713),
  [8765] = {.count = 1, .reusable = true}, REDUCE(sym_else, 3),
  [8767] = {.count = 1, .reusable = true}, SHIFT(5720),
  [8769] = {.count = 1, .reusable = false}, SHIFT(5721),
  [8771] = {.count = 1, .reusable = false}, SHIFT(5722),
  [8773] = {.count = 1, .reusable = false}, SHIFT(5723),
  [8775] = {.count = 1, .reusable = false}, SHIFT(5724),
  [8777] = {.count = 1, .reusable = false}, SHIFT(5720),
  [8779] = {.count = 1, .reusable = true}, SHIFT(5725),
  [8781] = {.count = 1, .reusable = false}, SHIFT(5725),
  [8783] = {.count = 1, .reusable = true}, SHIFT(5726),
  [8785] = {.count = 1, .reusable = false}, SHIFT(3151),
  [8787] = {.count = 1, .reusable = true}, SHIFT(5734),
  [8789] = {.count = 1, .reusable = true}, SHIFT(5736),
  [8791] = {.count = 1, .reusable = true}, SHIFT(5737),
  [8793] = {.count = 1, .reusable = true}, SHIFT(5738),
  [8795] = {.count = 1, .reusable = false}, SHIFT(5740),
  [8797] = {.count = 1, .reusable = false}, SHIFT(5746),
  [8799] = {.count = 1, .reusable = true}, SHIFT(5747),
  [8801] = {.count = 1, .reusable = true}, SHIFT(5748),
  [8803] = {.count = 1, .reusable = false}, SHIFT(5749),
  [8805] = {.count = 1, .reusable = false}, SHIFT(5750),
  [8807] = {.count = 1, .reusable = false}, SHIFT(5751),
  [8809] = {.count = 1, .reusable = true}, SHIFT(5752),
  [8811] = {.count = 1, .reusable = false}, SHIFT(5753),
  [8813] = {.count = 1, .reusable = true}, SHIFT(5753),
  [8815] = {.count = 1, .reusable = true}, SHIFT(5755),
  [8817] = {.count = 1, .reusable = true}, SHIFT(5756),
  [8819] = {.count = 1, .reusable = false}, SHIFT(5755),
  [8821] = {.count = 1, .reusable = true}, SHIFT(5751),
  [8823] = {.count = 1, .reusable = true}, SHIFT(5749),
  [8825] = {.count = 1, .reusable = true}, SHIFT(5757),
  [8827] = {.count = 1, .reusable = true}, SHIFT(5758),
  [8829] = {.count = 1, .reusable = true}, SHIFT(5759),
  [8831] = {.count = 1, .reusable = false}, SHIFT(5761),
  [8833] = {.count = 1, .reusable = true}, SHIFT(5767),
  [8835] = {.count = 1, .reusable = true}, SHIFT(5769),
  [8837] = {.count = 1, .reusable = false}, SHIFT(5769),
  [8839] = {.count = 1, .reusable = true}, SHIFT(5770),
  [8841] = {.count = 1, .reusable = false}, SHIFT(5734),
  [8843] = {.count = 1, .reusable = true}, SHIFT(5773),
  [8845] = {.count = 1, .reusable = true}, SHIFT(5790),
  [8847] = {.count = 1, .reusable = false}, SHIFT(5791),
  [8849] = {.count = 1, .reusable = false}, SHIFT(5792),
  [8851] = {.count = 1, .reusable = false}, SHIFT(5793),
  [8853] = {.count = 1, .reusable = false}, SHIFT(5794),
  [8855] = {.count = 1, .reusable = false}, SHIFT(5790),
  [8857] = {.count = 1, .reusable = true}, SHIFT(5795),
  [8859] = {.count = 1, .reusable = false}, SHIFT(5795),
  [8861] = {.count = 1, .reusable = true}, SHIFT(5796),
  [8863] = {.count = 1, .reusable = false}, SHIFT(5798),
  [8865] = {.count = 1, .reusable = true}, SHIFT(5798),
  [8867] = {.count = 1, .reusable = false}, SHIFT(3189),
  [8869] = {.count = 1, .reusable = true}, SHIFT(5805),
  [8871] = {.count = 1, .reusable = false}, SHIFT(5808),
  [8873] = {.count = 1, .reusable = true}, SHIFT(5809),
  [8875] = {.count = 1, .reusable = true}, SHIFT(5810),
  [8877] = {.count = 1, .reusable = false}, SHIFT(5811),
  [8879] = {.count = 1, .reusable = false}, SHIFT(5810),
  [8881] = {.count = 1, .reusable = false}, SHIFT(5812),
  [8883] = {.count = 1, .reusable = false}, SHIFT(5813),
  [8885] = {.count = 1, .reusable = true}, SHIFT(5814),
  [8887] = {.count = 1, .reusable = false}, SHIFT(5815),
  [8889] = {.count = 1, .reusable = true}, SHIFT(5815),
  [8891] = {.count = 1, .reusable = false}, SHIFT(5817),
  [8893] = {.count = 1, .reusable = false}, SHIFT(5818),
  [8895] = {.count = 1, .reusable = true}, SHIFT(5817),
  [8897] = {.count = 1, .reusable = true}, SHIFT(5813),
  [8899] = {.count = 1, .reusable = false}, SHIFT(5809),
  [8901] = {.count = 1, .reusable = true}, SHIFT(5820),
  [8903] = {.count = 1, .reusable = true}, SHIFT(5822),
  [8905] = {.count = 1, .reusable = false}, SHIFT(5822),
  [8907] = {.count = 1, .reusable = true}, SHIFT(5823),
  [8909] = {.count = 1, .reusable = false}, SHIFT(5805),
  [8911] = {.count = 1, .reusable = true}, SHIFT(5825),
  [8913] = {.count = 1, .reusable = true}, SHIFT(5826),
  [8915] = {.count = 1, .reusable = false}, SHIFT(5826),
  [8917] = {.count = 1, .reusable = true}, SHIFT(5827),
  [8919] = {.count = 1, .reusable = false}, SHIFT(5827),
  [8921] = {.count = 1, .reusable = true}, SHIFT(5828),
  [8923] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 3),
  [8925] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 3),
  [8927] = {.count = 1, .reusable = true}, SHIFT(5836),
  [8929] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(5838),
  [8932] = {.count = 1, .reusable = true}, SHIFT(5839),
  [8934] = {.count = 1, .reusable = true}, SHIFT(5842),
  [8936] = {.count = 1, .reusable = true}, SHIFT(5843),
  [8938] = {.count = 1, .reusable = false}, SHIFT(5844),
  [8940] = {.count = 1, .reusable = false}, SHIFT(5843),
  [8942] = {.count = 1, .reusable = false}, SHIFT(5845),
  [8944] = {.count = 1, .reusable = false}, SHIFT(5846),
  [8946] = {.count = 1, .reusable = true}, SHIFT(5847),
  [8948] = {.count = 1, .reusable = false}, SHIFT(5848),
  [8950] = {.count = 1, .reusable = true}, SHIFT(5848),
  [8952] = {.count = 1, .reusable = false}, SHIFT(5850),
  [8954] = {.count = 1, .reusable = false}, SHIFT(5851),
  [8956] = {.count = 1, .reusable = true}, SHIFT(5850),
  [8958] = {.count = 1, .reusable = true}, SHIFT(5846),
  [8960] = {.count = 1, .reusable = false}, SHIFT(5842),
  [8962] = {.count = 1, .reusable = true}, SHIFT(5852),
  [8964] = {.count = 1, .reusable = false}, SHIFT(5852),
  [8966] = {.count = 1, .reusable = true}, SHIFT(5853),
  [8968] = {.count = 1, .reusable = true}, SHIFT(1232),
  [8970] = {.count = 1, .reusable = true}, SHIFT(5878),
  [8972] = {.count = 1, .reusable = true}, SHIFT(5879),
  [8974] = {.count = 1, .reusable = false}, SHIFT(5880),
  [8976] = {.count = 1, .reusable = false}, SHIFT(5881),
  [8978] = {.count = 1, .reusable = false}, SHIFT(5882),
  [8980] = {.count = 1, .reusable = true}, SHIFT(5883),
  [8982] = {.count = 1, .reusable = false}, SHIFT(5884),
  [8984] = {.count = 1, .reusable = true}, SHIFT(5884),
  [8986] = {.count = 1, .reusable = true}, SHIFT(5886),
  [8988] = {.count = 1, .reusable = true}, SHIFT(5887),
  [8990] = {.count = 1, .reusable = false}, SHIFT(5886),
  [8992] = {.count = 1, .reusable = true}, SHIFT(5882),
  [8994] = {.count = 1, .reusable = true}, SHIFT(5880),
  [8996] = {.count = 1, .reusable = true}, SHIFT(5888),
  [8998] = {.count = 1, .reusable = true}, SHIFT(5890),
  [9000] = {.count = 1, .reusable = false}, SHIFT(5890),
  [9002] = {.count = 1, .reusable = true}, SHIFT(5891),
  [9004] = {.count = 1, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2),
  [9006] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(1251),
  [9009] = {.count = 1, .reusable = true}, SHIFT(5892),
  [9011] = {.count = 1, .reusable = true}, SHIFT(5893),
  [9013] = {.count = 1, .reusable = true}, SHIFT(5894),
  [9015] = {.count = 1, .reusable = true}, SHIFT(5896),
  [9017] = {.count = 1, .reusable = true}, SHIFT(5897),
  [9019] = {.count = 1, .reusable = true}, SHIFT(5898),
  [9021] = {.count = 1, .reusable = true}, SHIFT(5899),
  [9023] = {.count = 1, .reusable = true}, SHIFT(5900),
  [9025] = {.count = 1, .reusable = true}, SHIFT(5902),
  [9027] = {.count = 1, .reusable = true}, SHIFT(5903),
  [9029] = {.count = 1, .reusable = true}, SHIFT(5904),
  [9031] = {.count = 1, .reusable = false}, SHIFT(5904),
  [9033] = {.count = 1, .reusable = true}, SHIFT(5905),
  [9035] = {.count = 1, .reusable = false}, SHIFT(5905),
  [9037] = {.count = 1, .reusable = true}, SHIFT(5906),
  [9039] = {.count = 1, .reusable = true}, SHIFT(5911),
  [9041] = {.count = 1, .reusable = false}, SHIFT(5913),
  [9043] = {.count = 1, .reusable = true}, SHIFT(5915),
  [9045] = {.count = 1, .reusable = false}, SHIFT(5911),
  [9047] = {.count = 1, .reusable = true}, SHIFT(5927),
  [9049] = {.count = 1, .reusable = false}, SHIFT(5928),
  [9051] = {.count = 1, .reusable = false}, SHIFT(5929),
  [9053] = {.count = 1, .reusable = false}, SHIFT(5930),
  [9055] = {.count = 1, .reusable = false}, SHIFT(5931),
  [9057] = {.count = 1, .reusable = false}, SHIFT(5927),
  [9059] = {.count = 1, .reusable = true}, SHIFT(5932),
  [9061] = {.count = 1, .reusable = false}, SHIFT(5932),
  [9063] = {.count = 1, .reusable = true}, SHIFT(5933),
  [9065] = {.count = 1, .reusable = false}, SHIFT(5935),
  [9067] = {.count = 1, .reusable = true}, SHIFT(5935),
  [9069] = {.count = 1, .reusable = true}, SHIFT(5940),
  [9071] = {.count = 1, .reusable = false}, SHIFT(5942),
  [9073] = {.count = 1, .reusable = true}, SHIFT(5944),
  [9075] = {.count = 1, .reusable = false}, SHIFT(5940),
  [9077] = {.count = 1, .reusable = true}, SHIFT(5946),
  [9079] = {.count = 1, .reusable = true}, SHIFT(5951),
  [9081] = {.count = 1, .reusable = true}, SHIFT(5952),
  [9083] = {.count = 1, .reusable = true}, SHIFT(1293),
  [9085] = {.count = 1, .reusable = false}, SHIFT(5954),
  [9087] = {.count = 1, .reusable = true}, SHIFT(5955),
  [9089] = {.count = 1, .reusable = true}, SHIFT(5956),
  [9091] = {.count = 1, .reusable = false}, SHIFT(5957),
  [9093] = {.count = 1, .reusable = false}, SHIFT(5958),
  [9095] = {.count = 1, .reusable = true}, SHIFT(1307),
  [9097] = {.count = 1, .reusable = true}, SHIFT(5981),
  [9099] = {.count = 1, .reusable = false}, SHIFT(5978),
  [9101] = {.count = 1, .reusable = false}, SHIFT(5982),
  [9103] = {.count = 1, .reusable = false}, SHIFT(5985),
  [9105] = {.count = 1, .reusable = false}, SHIFT(5987),
  [9107] = {.count = 1, .reusable = true}, SHIFT(5989),
  [9109] = {.count = 1, .reusable = true}, SHIFT(5991),
  [9111] = {.count = 1, .reusable = true}, SHIFT(5992),
  [9113] = {.count = 1, .reusable = true}, SHIFT(5993),
  [9115] = {.count = 1, .reusable = true}, SHIFT(5996),
  [9117] = {.count = 1, .reusable = true}, SHIFT(5997),
  [9119] = {.count = 1, .reusable = true}, SHIFT(5999),
  [9121] = {.count = 1, .reusable = true}, SHIFT(6001),
  [9123] = {.count = 1, .reusable = false}, SHIFT(5999),
  [9125] = {.count = 1, .reusable = true}, SHIFT(6003),
  [9127] = {.count = 1, .reusable = true}, SHIFT(6004),
  [9129] = {.count = 1, .reusable = true}, SHIFT(6007),
  [9131] = {.count = 1, .reusable = true}, SHIFT(6008),
  [9133] = {.count = 1, .reusable = true}, SHIFT(6011),
  [9135] = {.count = 1, .reusable = true}, SHIFT(6013),
  [9137] = {.count = 1, .reusable = true}, SHIFT(6015),
  [9139] = {.count = 1, .reusable = false}, SHIFT(6013),
  [9141] = {.count = 1, .reusable = true}, SHIFT(1363),
  [9143] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [9145] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [9147] = {.count = 1, .reusable = true}, SHIFT(6037),
  [9149] = {.count = 1, .reusable = true}, SHIFT(6036),
  [9151] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 3),
  [9153] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(309),
  [9156] = {.count = 1, .reusable = true}, SHIFT(6042),
  [9158] = {.count = 1, .reusable = true}, SHIFT(6043),
  [9160] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 2),
  [9162] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 2),
  [9164] = {.count = 1, .reusable = true}, SHIFT(6044),
  [9166] = {.count = 1, .reusable = true}, SHIFT(6045),
  [9168] = {.count = 1, .reusable = true}, SHIFT(6046),
  [9170] = {.count = 1, .reusable = true}, SHIFT(6047),
  [9172] = {.count = 1, .reusable = true}, REDUCE(sym_block, 3),
  [9174] = {.count = 1, .reusable = false}, REDUCE(sym_block, 3),
  [9176] = {.count = 1, .reusable = true}, SHIFT(6049),
  [9178] = {.count = 1, .reusable = true}, SHIFT(6050),
  [9180] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 3),
  [9182] = {.count = 1, .reusable = true}, SHIFT(6055),
  [9184] = {.count = 1, .reusable = true}, SHIFT(6057),
  [9186] = {.count = 1, .reusable = true}, SHIFT(6058),
  [9188] = {.count = 1, .reusable = true}, SHIFT(6059),
  [9190] = {.count = 1, .reusable = true}, SHIFT(6060),
  [9192] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 3),
  [9194] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 3),
  [9196] = {.count = 1, .reusable = true}, SHIFT(6062),
  [9198] = {.count = 1, .reusable = false}, SHIFT(6062),
  [9200] = {.count = 1, .reusable = true}, SHIFT(6064),
  [9202] = {.count = 1, .reusable = true}, SHIFT(6067),
  [9204] = {.count = 1, .reusable = true}, SHIFT(6068),
  [9206] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 3),
  [9208] = {.count = 1, .reusable = false}, SHIFT(6069),
  [9210] = {.count = 1, .reusable = false}, SHIFT(6070),
  [9212] = {.count = 1, .reusable = false}, SHIFT(6071),
  [9214] = {.count = 1, .reusable = true}, SHIFT(6072),
  [9216] = {.count = 1, .reusable = false}, SHIFT(6073),
  [9218] = {.count = 1, .reusable = true}, SHIFT(6073),
  [9220] = {.count = 1, .reusable = true}, SHIFT(6074),
  [9222] = {.count = 1, .reusable = true}, SHIFT(6075),
  [9224] = {.count = 1, .reusable = true}, SHIFT(6076),
  [9226] = {.count = 1, .reusable = false}, SHIFT(6075),
  [9228] = {.count = 1, .reusable = true}, SHIFT(6071),
  [9230] = {.count = 1, .reusable = true}, SHIFT(6069),
  [9232] = {.count = 1, .reusable = true}, SHIFT(6077),
  [9234] = {.count = 1, .reusable = true}, SHIFT(6079),
  [9236] = {.count = 1, .reusable = false}, SHIFT(6079),
  [9238] = {.count = 1, .reusable = true}, SHIFT(6080),
  [9240] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [9242] = {.count = 1, .reusable = true}, REDUCE(aux_sym_lambda_parameters_repeat1, 2),
  [9244] = {.count = 2, .reusable = true}, REDUCE(aux_sym_lambda_parameters_repeat1, 2), SHIFT_REPEAT(1406),
  [9247] = {.count = 1, .reusable = true}, REDUCE(sym_program, 4),
  [9249] = {.count = 1, .reusable = true}, SHIFT(6082),
  [9251] = {.count = 1, .reusable = true}, SHIFT(6083),
  [9253] = {.count = 1, .reusable = false}, SHIFT(6084),
  [9255] = {.count = 1, .reusable = false}, SHIFT(6085),
  [9257] = {.count = 1, .reusable = false}, SHIFT(6086),
  [9259] = {.count = 1, .reusable = false}, SHIFT(6087),
  [9261] = {.count = 1, .reusable = false}, SHIFT(6083),
  [9263] = {.count = 1, .reusable = true}, SHIFT(6088),
  [9265] = {.count = 1, .reusable = false}, SHIFT(6088),
  [9267] = {.count = 1, .reusable = true}, SHIFT(6089),
  [9269] = {.count = 1, .reusable = false}, SHIFT(6091),
  [9271] = {.count = 1, .reusable = true}, SHIFT(6091),
  [9273] = {.count = 1, .reusable = true}, SHIFT(6096),
  [9275] = {.count = 1, .reusable = false}, SHIFT(3489),
  [9277] = {.count = 1, .reusable = true}, SHIFT(6099),
  [9279] = {.count = 1, .reusable = true}, SHIFT(6101),
  [9281] = {.count = 1, .reusable = true}, SHIFT(6102),
  [9283] = {.count = 1, .reusable = true}, SHIFT(6103),
  [9285] = {.count = 1, .reusable = false}, SHIFT(6105),
  [9287] = {.count = 1, .reusable = false}, SHIFT(6111),
  [9289] = {.count = 1, .reusable = true}, SHIFT(6112),
  [9291] = {.count = 1, .reusable = true}, SHIFT(6113),
  [9293] = {.count = 1, .reusable = false}, SHIFT(6114),
  [9295] = {.count = 1, .reusable = false}, SHIFT(6115),
  [9297] = {.count = 1, .reusable = false}, SHIFT(6116),
  [9299] = {.count = 1, .reusable = true}, SHIFT(6117),
  [9301] = {.count = 1, .reusable = false}, SHIFT(6118),
  [9303] = {.count = 1, .reusable = true}, SHIFT(6118),
  [9305] = {.count = 1, .reusable = true}, SHIFT(6120),
  [9307] = {.count = 1, .reusable = true}, SHIFT(6121),
  [9309] = {.count = 1, .reusable = false}, SHIFT(6120),
  [9311] = {.count = 1, .reusable = true}, SHIFT(6116),
  [9313] = {.count = 1, .reusable = true}, SHIFT(6114),
  [9315] = {.count = 1, .reusable = true}, SHIFT(6122),
  [9317] = {.count = 1, .reusable = true}, SHIFT(6123),
  [9319] = {.count = 1, .reusable = true}, SHIFT(6124),
  [9321] = {.count = 1, .reusable = false}, SHIFT(6126),
  [9323] = {.count = 1, .reusable = true}, SHIFT(6132),
  [9325] = {.count = 1, .reusable = true}, SHIFT(6134),
  [9327] = {.count = 1, .reusable = false}, SHIFT(6134),
  [9329] = {.count = 1, .reusable = true}, SHIFT(6135),
  [9331] = {.count = 1, .reusable = false}, SHIFT(6099),
  [9333] = {.count = 1, .reusable = true}, SHIFT(6148),
  [9335] = {.count = 1, .reusable = false}, SHIFT(6149),
  [9337] = {.count = 1, .reusable = false}, SHIFT(6150),
  [9339] = {.count = 1, .reusable = false}, SHIFT(6151),
  [9341] = {.count = 1, .reusable = false}, SHIFT(6152),
  [9343] = {.count = 1, .reusable = false}, SHIFT(6148),
  [9345] = {.count = 1, .reusable = true}, SHIFT(6153),
  [9347] = {.count = 1, .reusable = false}, SHIFT(6153),
  [9349] = {.count = 1, .reusable = true}, SHIFT(6154),
  [9351] = {.count = 1, .reusable = false}, SHIFT(6156),
  [9353] = {.count = 1, .reusable = true}, SHIFT(6156),
  [9355] = {.count = 1, .reusable = true}, SHIFT(6161),
  [9357] = {.count = 1, .reusable = false}, SHIFT(3520),
  [9359] = {.count = 1, .reusable = true}, SHIFT(6164),
  [9361] = {.count = 1, .reusable = false}, SHIFT(6167),
  [9363] = {.count = 1, .reusable = true}, SHIFT(6168),
  [9365] = {.count = 1, .reusable = true}, SHIFT(6169),
  [9367] = {.count = 1, .reusable = false}, SHIFT(6170),
  [9369] = {.count = 1, .reusable = false}, SHIFT(6169),
  [9371] = {.count = 1, .reusable = false}, SHIFT(6171),
  [9373] = {.count = 1, .reusable = false}, SHIFT(6172),
  [9375] = {.count = 1, .reusable = true}, SHIFT(6173),
  [9377] = {.count = 1, .reusable = false}, SHIFT(6174),
  [9379] = {.count = 1, .reusable = true}, SHIFT(6174),
  [9381] = {.count = 1, .reusable = false}, SHIFT(6176),
  [9383] = {.count = 1, .reusable = false}, SHIFT(6177),
  [9385] = {.count = 1, .reusable = true}, SHIFT(6176),
  [9387] = {.count = 1, .reusable = true}, SHIFT(6172),
  [9389] = {.count = 1, .reusable = false}, SHIFT(6168),
  [9391] = {.count = 1, .reusable = true}, SHIFT(6179),
  [9393] = {.count = 1, .reusable = true}, SHIFT(6181),
  [9395] = {.count = 1, .reusable = false}, SHIFT(6181),
  [9397] = {.count = 1, .reusable = true}, SHIFT(6182),
  [9399] = {.count = 1, .reusable = false}, SHIFT(6164),
  [9401] = {.count = 1, .reusable = true}, SHIFT(6184),
  [9403] = {.count = 1, .reusable = true}, SHIFT(6185),
  [9405] = {.count = 1, .reusable = false}, SHIFT(6186),
  [9407] = {.count = 1, .reusable = false}, SHIFT(6187),
  [9409] = {.count = 1, .reusable = false}, SHIFT(6188),
  [9411] = {.count = 1, .reusable = false}, SHIFT(6189),
  [9413] = {.count = 1, .reusable = false}, SHIFT(6185),
  [9415] = {.count = 1, .reusable = true}, SHIFT(6190),
  [9417] = {.count = 1, .reusable = false}, SHIFT(6190),
  [9419] = {.count = 1, .reusable = true}, SHIFT(6191),
  [9421] = {.count = 1, .reusable = true}, SHIFT(6199),
  [9423] = {.count = 1, .reusable = true}, SHIFT(6200),
  [9425] = {.count = 1, .reusable = true}, REDUCE(sym_call, 4),
  [9427] = {.count = 1, .reusable = false}, REDUCE(sym_call, 4),
  [9429] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1439),
  [9432] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 4),
  [9434] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 4),
  [9436] = {.count = 1, .reusable = true}, SHIFT(6202),
  [9438] = {.count = 1, .reusable = true}, SHIFT(6203),
  [9440] = {.count = 1, .reusable = true}, SHIFT(6204),
  [9442] = {.count = 1, .reusable = true}, SHIFT(6205),
  [9444] = {.count = 1, .reusable = true}, SHIFT(6207),
  [9446] = {.count = 1, .reusable = true}, SHIFT(6208),
  [9448] = {.count = 1, .reusable = true}, SHIFT(6209),
  [9450] = {.count = 1, .reusable = true}, SHIFT(6210),
  [9452] = {.count = 1, .reusable = true}, SHIFT(6211),
  [9454] = {.count = 1, .reusable = true}, SHIFT(6213),
  [9456] = {.count = 1, .reusable = true}, SHIFT(6214),
  [9458] = {.count = 1, .reusable = true}, SHIFT(6215),
  [9460] = {.count = 1, .reusable = true}, SHIFT(6216),
  [9462] = {.count = 1, .reusable = true}, SHIFT(6217),
  [9464] = {.count = 1, .reusable = true}, SHIFT(6218),
  [9466] = {.count = 1, .reusable = true}, SHIFT(6219),
  [9468] = {.count = 1, .reusable = false}, SHIFT(6220),
  [9470] = {.count = 1, .reusable = true}, SHIFT(6222),
  [9472] = {.count = 1, .reusable = true}, SHIFT(6223),
  [9474] = {.count = 1, .reusable = true}, SHIFT(6225),
  [9476] = {.count = 1, .reusable = false}, SHIFT(6226),
  [9478] = {.count = 1, .reusable = true}, SHIFT(6228),
  [9480] = {.count = 1, .reusable = true}, SHIFT(6229),
  [9482] = {.count = 1, .reusable = true}, SHIFT(6231),
  [9484] = {.count = 1, .reusable = true}, SHIFT(6234),
  [9486] = {.count = 1, .reusable = true}, SHIFT(6235),
  [9488] = {.count = 1, .reusable = true}, SHIFT(6236),
  [9490] = {.count = 1, .reusable = true}, SHIFT(6239),
  [9492] = {.count = 1, .reusable = true}, SHIFT(6241),
  [9494] = {.count = 1, .reusable = false}, SHIFT(6240),
  [9496] = {.count = 1, .reusable = true}, SHIFT(6242),
  [9498] = {.count = 1, .reusable = true}, SHIFT(6243),
  [9500] = {.count = 1, .reusable = true}, SHIFT(6244),
  [9502] = {.count = 1, .reusable = true}, SHIFT(6245),
  [9504] = {.count = 1, .reusable = true}, SHIFT(6247),
  [9506] = {.count = 1, .reusable = true}, SHIFT(6249),
  [9508] = {.count = 1, .reusable = true}, SHIFT(6250),
  [9510] = {.count = 1, .reusable = false}, SHIFT(6254),
  [9512] = {.count = 1, .reusable = true}, SHIFT(6255),
  [9514] = {.count = 1, .reusable = true}, SHIFT(6268),
  [9516] = {.count = 1, .reusable = true}, SHIFT(6276),
  [9518] = {.count = 1, .reusable = false}, SHIFT(6278),
  [9520] = {.count = 1, .reusable = true}, SHIFT(6280),
  [9522] = {.count = 1, .reusable = false}, SHIFT(6276),
  [9524] = {.count = 1, .reusable = true}, SHIFT(6282),
  [9526] = {.count = 1, .reusable = true}, SHIFT(6295),
  [9528] = {.count = 1, .reusable = false}, SHIFT(6297),
  [9530] = {.count = 1, .reusable = true}, SHIFT(6299),
  [9532] = {.count = 1, .reusable = false}, SHIFT(6295),
  [9534] = {.count = 1, .reusable = true}, SHIFT(6301),
  [9536] = {.count = 1, .reusable = true}, SHIFT(6302),
  [9538] = {.count = 1, .reusable = false}, SHIFT(6302),
  [9540] = {.count = 1, .reusable = true}, SHIFT(6303),
  [9542] = {.count = 1, .reusable = false}, SHIFT(6303),
  [9544] = {.count = 1, .reusable = true}, SHIFT(6304),
  [9546] = {.count = 1, .reusable = true}, SHIFT(6311),
  [9548] = {.count = 1, .reusable = true}, SHIFT(6312),
  [9550] = {.count = 1, .reusable = true}, SHIFT(1524),
  [9552] = {.count = 1, .reusable = false}, SHIFT(6314),
  [9554] = {.count = 1, .reusable = true}, SHIFT(6315),
  [9556] = {.count = 1, .reusable = true}, SHIFT(6316),
  [9558] = {.count = 1, .reusable = false}, SHIFT(6317),
  [9560] = {.count = 1, .reusable = false}, SHIFT(6318),
  [9562] = {.count = 1, .reusable = true}, SHIFT(6322),
  [9564] = {.count = 1, .reusable = false}, SHIFT(6319),
  [9566] = {.count = 1, .reusable = false}, SHIFT(6323),
  [9568] = {.count = 1, .reusable = false}, SHIFT(6326),
  [9570] = {.count = 1, .reusable = false}, SHIFT(6328),
  [9572] = {.count = 1, .reusable = true}, SHIFT(6330),
  [9574] = {.count = 1, .reusable = true}, SHIFT(6331),
  [9576] = {.count = 1, .reusable = false}, SHIFT(6331),
  [9578] = {.count = 1, .reusable = true}, SHIFT(6333),
  [9580] = {.count = 1, .reusable = true}, SHIFT(6335),
  [9582] = {.count = 1, .reusable = true}, SHIFT(6336),
  [9584] = {.count = 1, .reusable = true}, SHIFT(6337),
  [9586] = {.count = 1, .reusable = true}, SHIFT(6340),
  [9588] = {.count = 1, .reusable = true}, SHIFT(6341),
  [9590] = {.count = 1, .reusable = true}, SHIFT(6342),
  [9592] = {.count = 1, .reusable = true}, SHIFT(6343),
  [9594] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1581),
  [9597] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1583),
  [9600] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(388),
  [9603] = {.count = 1, .reusable = true}, REDUCE(sym_right_assignment_list, 2),
  [9605] = {.count = 1, .reusable = false}, REDUCE(sym_right_assignment_list, 2),
  [9607] = {.count = 1, .reusable = true}, SHIFT(6365),
  [9609] = {.count = 1, .reusable = true}, SHIFT(6366),
  [9611] = {.count = 1, .reusable = false}, SHIFT(6367),
  [9613] = {.count = 1, .reusable = false}, SHIFT(6368),
  [9615] = {.count = 1, .reusable = false}, SHIFT(6369),
  [9617] = {.count = 1, .reusable = true}, SHIFT(6370),
  [9619] = {.count = 1, .reusable = false}, SHIFT(6371),
  [9621] = {.count = 1, .reusable = true}, SHIFT(6371),
  [9623] = {.count = 1, .reusable = true}, SHIFT(6373),
  [9625] = {.count = 1, .reusable = true}, SHIFT(6374),
  [9627] = {.count = 1, .reusable = false}, SHIFT(6373),
  [9629] = {.count = 1, .reusable = true}, SHIFT(6369),
  [9631] = {.count = 1, .reusable = true}, SHIFT(6367),
  [9633] = {.count = 1, .reusable = true}, SHIFT(6375),
  [9635] = {.count = 1, .reusable = false}, SHIFT(6375),
  [9637] = {.count = 1, .reusable = true}, SHIFT(6376),
  [9639] = {.count = 1, .reusable = true}, SHIFT(6381),
  [9641] = {.count = 1, .reusable = false}, SHIFT(6383),
  [9643] = {.count = 1, .reusable = true}, SHIFT(6385),
  [9645] = {.count = 1, .reusable = false}, SHIFT(6381),
  [9647] = {.count = 1, .reusable = true}, SHIFT(6400),
  [9649] = {.count = 1, .reusable = false}, SHIFT(6402),
  [9651] = {.count = 1, .reusable = true}, SHIFT(6404),
  [9653] = {.count = 1, .reusable = false}, SHIFT(6400),
  [9655] = {.count = 1, .reusable = true}, SHIFT(1606),
  [9657] = {.count = 1, .reusable = true}, SHIFT(6414),
  [9659] = {.count = 1, .reusable = true}, SHIFT(6416),
  [9661] = {.count = 1, .reusable = true}, SHIFT(6417),
  [9663] = {.count = 1, .reusable = true}, SHIFT(6420),
  [9665] = {.count = 1, .reusable = true}, SHIFT(6421),
  [9667] = {.count = 1, .reusable = true}, SHIFT(6423),
  [9669] = {.count = 1, .reusable = true}, SHIFT(6425),
  [9671] = {.count = 1, .reusable = true}, SHIFT(6427),
  [9673] = {.count = 1, .reusable = true}, SHIFT(6429),
  [9675] = {.count = 1, .reusable = true}, SHIFT(6431),
  [9677] = {.count = 1, .reusable = false}, SHIFT(6432),
  [9679] = {.count = 1, .reusable = true}, SHIFT(6434),
  [9681] = {.count = 1, .reusable = false}, SHIFT(6435),
  [9683] = {.count = 1, .reusable = true}, SHIFT(6438),
  [9685] = {.count = 1, .reusable = true}, SHIFT(6441),
  [9687] = {.count = 1, .reusable = false}, SHIFT(6443),
  [9689] = {.count = 1, .reusable = true}, SHIFT(6445),
  [9691] = {.count = 1, .reusable = true}, SHIFT(6447),
  [9693] = {.count = 1, .reusable = false}, SHIFT(6448),
  [9695] = {.count = 1, .reusable = false}, SHIFT(6450),
  [9697] = {.count = 1, .reusable = true}, SHIFT(6462),
  [9699] = {.count = 1, .reusable = true}, SHIFT(6468),
  [9701] = {.count = 1, .reusable = false}, SHIFT(6467),
  [9703] = {.count = 1, .reusable = false}, SHIFT(6471),
  [9705] = {.count = 1, .reusable = true}, SHIFT(6472),
  [9707] = {.count = 1, .reusable = true}, SHIFT(6477),
  [9709] = {.count = 1, .reusable = true}, SHIFT(6478),
  [9711] = {.count = 1, .reusable = false}, SHIFT(6479),
  [9713] = {.count = 1, .reusable = false}, SHIFT(6478),
  [9715] = {.count = 1, .reusable = false}, SHIFT(6480),
  [9717] = {.count = 1, .reusable = false}, SHIFT(6481),
  [9719] = {.count = 1, .reusable = true}, SHIFT(6482),
  [9721] = {.count = 1, .reusable = false}, SHIFT(6483),
  [9723] = {.count = 1, .reusable = true}, SHIFT(6483),
  [9725] = {.count = 1, .reusable = false}, SHIFT(6485),
  [9727] = {.count = 1, .reusable = false}, SHIFT(6486),
  [9729] = {.count = 1, .reusable = true}, SHIFT(6485),
  [9731] = {.count = 1, .reusable = true}, SHIFT(6481),
  [9733] = {.count = 1, .reusable = false}, SHIFT(6477),
  [9735] = {.count = 1, .reusable = true}, SHIFT(6487),
  [9737] = {.count = 1, .reusable = false}, SHIFT(6487),
  [9739] = {.count = 1, .reusable = true}, SHIFT(6488),
  [9741] = {.count = 1, .reusable = true}, SHIFT(6491),
  [9743] = {.count = 1, .reusable = true}, SHIFT(6493),
  [9745] = {.count = 1, .reusable = true}, SHIFT(6495),
  [9747] = {.count = 1, .reusable = false}, SHIFT(6493),
  [9749] = {.count = 1, .reusable = true}, SHIFT(6497),
  [9751] = {.count = 1, .reusable = true}, SHIFT(6510),
  [9753] = {.count = 1, .reusable = true}, SHIFT(6512),
  [9755] = {.count = 1, .reusable = true}, SHIFT(6511),
  [9757] = {.count = 1, .reusable = true}, SHIFT(1650),
  [9759] = {.count = 1, .reusable = true}, SHIFT(6525),
  [9761] = {.count = 1, .reusable = true}, SHIFT(6526),
  [9763] = {.count = 1, .reusable = false}, SHIFT(6527),
  [9765] = {.count = 1, .reusable = false}, SHIFT(6528),
  [9767] = {.count = 1, .reusable = false}, SHIFT(6529),
  [9769] = {.count = 1, .reusable = true}, SHIFT(6530),
  [9771] = {.count = 1, .reusable = false}, SHIFT(6531),
  [9773] = {.count = 1, .reusable = true}, SHIFT(6531),
  [9775] = {.count = 1, .reusable = true}, SHIFT(6533),
  [9777] = {.count = 1, .reusable = true}, SHIFT(6534),
  [9779] = {.count = 1, .reusable = false}, SHIFT(6533),
  [9781] = {.count = 1, .reusable = true}, SHIFT(6529),
  [9783] = {.count = 1, .reusable = true}, SHIFT(6527),
  [9785] = {.count = 1, .reusable = true}, SHIFT(6535),
  [9787] = {.count = 1, .reusable = true}, SHIFT(6537),
  [9789] = {.count = 1, .reusable = false}, SHIFT(6537),
  [9791] = {.count = 1, .reusable = true}, SHIFT(6538),
  [9793] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .alias_sequence_id = 19),
  [9795] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .alias_sequence_id = 19),
  [9797] = {.count = 1, .reusable = true}, SHIFT(6540),
  [9799] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .alias_sequence_id = 20),
  [9801] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .alias_sequence_id = 20),
  [9803] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 21),
  [9805] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 21),
  [9807] = {.count = 1, .reusable = true}, SHIFT(6541),
  [9809] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 22),
  [9811] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 22),
  [9813] = {.count = 1, .reusable = true}, SHIFT(6546),
  [9815] = {.count = 1, .reusable = true}, SHIFT(6547),
  [9817] = {.count = 1, .reusable = false}, SHIFT(6548),
  [9819] = {.count = 1, .reusable = false}, SHIFT(6549),
  [9821] = {.count = 1, .reusable = false}, SHIFT(6550),
  [9823] = {.count = 1, .reusable = true}, SHIFT(6551),
  [9825] = {.count = 1, .reusable = false}, SHIFT(6552),
  [9827] = {.count = 1, .reusable = true}, SHIFT(6552),
  [9829] = {.count = 1, .reusable = true}, SHIFT(6554),
  [9831] = {.count = 1, .reusable = true}, SHIFT(6555),
  [9833] = {.count = 1, .reusable = false}, SHIFT(6554),
  [9835] = {.count = 1, .reusable = true}, SHIFT(6550),
  [9837] = {.count = 1, .reusable = true}, SHIFT(6548),
  [9839] = {.count = 1, .reusable = true}, SHIFT(6556),
  [9841] = {.count = 1, .reusable = false}, SHIFT(6556),
  [9843] = {.count = 1, .reusable = true}, SHIFT(6557),
  [9845] = {.count = 1, .reusable = true}, SHIFT(1694),
  [9847] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(6582),
  [9850] = {.count = 1, .reusable = true}, SHIFT(6583),
  [9852] = {.count = 1, .reusable = true}, SHIFT(6586),
  [9854] = {.count = 1, .reusable = true}, SHIFT(6587),
  [9856] = {.count = 1, .reusable = false}, SHIFT(6588),
  [9858] = {.count = 1, .reusable = false}, SHIFT(6587),
  [9860] = {.count = 1, .reusable = false}, SHIFT(6589),
  [9862] = {.count = 1, .reusable = false}, SHIFT(6590),
  [9864] = {.count = 1, .reusable = true}, SHIFT(6591),
  [9866] = {.count = 1, .reusable = false}, SHIFT(6592),
  [9868] = {.count = 1, .reusable = true}, SHIFT(6592),
  [9870] = {.count = 1, .reusable = false}, SHIFT(6594),
  [9872] = {.count = 1, .reusable = false}, SHIFT(6595),
  [9874] = {.count = 1, .reusable = true}, SHIFT(6594),
  [9876] = {.count = 1, .reusable = true}, SHIFT(6590),
  [9878] = {.count = 1, .reusable = false}, SHIFT(6586),
  [9880] = {.count = 1, .reusable = true}, SHIFT(6596),
  [9882] = {.count = 1, .reusable = false}, SHIFT(6596),
  [9884] = {.count = 1, .reusable = true}, SHIFT(6597),
  [9886] = {.count = 1, .reusable = true}, SHIFT(1732),
  [9888] = {.count = 1, .reusable = true}, SHIFT(6622),
  [9890] = {.count = 1, .reusable = true}, SHIFT(6623),
  [9892] = {.count = 1, .reusable = false}, SHIFT(6624),
  [9894] = {.count = 1, .reusable = false}, SHIFT(6625),
  [9896] = {.count = 1, .reusable = false}, SHIFT(6626),
  [9898] = {.count = 1, .reusable = true}, SHIFT(6627),
  [9900] = {.count = 1, .reusable = false}, SHIFT(6628),
  [9902] = {.count = 1, .reusable = true}, SHIFT(6628),
  [9904] = {.count = 1, .reusable = true}, SHIFT(6630),
  [9906] = {.count = 1, .reusable = true}, SHIFT(6631),
  [9908] = {.count = 1, .reusable = false}, SHIFT(6630),
  [9910] = {.count = 1, .reusable = true}, SHIFT(6626),
  [9912] = {.count = 1, .reusable = true}, SHIFT(6624),
  [9914] = {.count = 1, .reusable = true}, SHIFT(6632),
  [9916] = {.count = 1, .reusable = true}, SHIFT(6634),
  [9918] = {.count = 1, .reusable = false}, SHIFT(6634),
  [9920] = {.count = 1, .reusable = true}, SHIFT(6635),
  [9922] = {.count = 1, .reusable = true}, SHIFT(6636),
  [9924] = {.count = 1, .reusable = true}, SHIFT(6637),
  [9926] = {.count = 1, .reusable = true}, SHIFT(6638),
  [9928] = {.count = 1, .reusable = true}, SHIFT(6639),
  [9930] = {.count = 1, .reusable = true}, SHIFT(6640),
  [9932] = {.count = 1, .reusable = true}, SHIFT(6641),
  [9934] = {.count = 1, .reusable = true}, SHIFT(6642),
  [9936] = {.count = 1, .reusable = true}, SHIFT(6645),
  [9938] = {.count = 1, .reusable = true}, SHIFT(6646),
  [9940] = {.count = 1, .reusable = false}, SHIFT(6647),
  [9942] = {.count = 1, .reusable = false}, SHIFT(6648),
  [9944] = {.count = 1, .reusable = false}, SHIFT(6649),
  [9946] = {.count = 1, .reusable = true}, SHIFT(6650),
  [9948] = {.count = 1, .reusable = false}, SHIFT(6651),
  [9950] = {.count = 1, .reusable = true}, SHIFT(6651),
  [9952] = {.count = 1, .reusable = true}, SHIFT(6653),
  [9954] = {.count = 1, .reusable = true}, SHIFT(6654),
  [9956] = {.count = 1, .reusable = false}, SHIFT(6653),
  [9958] = {.count = 1, .reusable = true}, SHIFT(6649),
  [9960] = {.count = 1, .reusable = true}, SHIFT(6647),
  [9962] = {.count = 1, .reusable = true}, SHIFT(6655),
  [9964] = {.count = 1, .reusable = false}, SHIFT(6655),
  [9966] = {.count = 1, .reusable = true}, SHIFT(6656),
  [9968] = {.count = 1, .reusable = true}, SHIFT(6660),
  [9970] = {.count = 1, .reusable = false}, SHIFT(6662),
  [9972] = {.count = 1, .reusable = true}, SHIFT(6664),
  [9974] = {.count = 1, .reusable = false}, SHIFT(6660),
  [9976] = {.count = 1, .reusable = true}, SHIFT(6679),
  [9978] = {.count = 1, .reusable = false}, SHIFT(6681),
  [9980] = {.count = 1, .reusable = true}, SHIFT(6683),
  [9982] = {.count = 1, .reusable = false}, SHIFT(6679),
  [9984] = {.count = 1, .reusable = true}, SHIFT(1782),
  [9986] = {.count = 1, .reusable = true}, SHIFT(6693),
  [9988] = {.count = 1, .reusable = true}, SHIFT(6694),
  [9990] = {.count = 1, .reusable = true}, SHIFT(6697),
  [9992] = {.count = 1, .reusable = true}, SHIFT(6698),
  [9994] = {.count = 1, .reusable = true}, SHIFT(6702),
  [9996] = {.count = 1, .reusable = true}, SHIFT(6703),
  [9998] = {.count = 1, .reusable = false}, SHIFT(6704),
  [10000] = {.count = 1, .reusable = false}, SHIFT(6703),
  [10002] = {.count = 1, .reusable = false}, SHIFT(6705),
  [10004] = {.count = 1, .reusable = false}, SHIFT(6706),
  [10006] = {.count = 1, .reusable = true}, SHIFT(6707),
  [10008] = {.count = 1, .reusable = false}, SHIFT(6708),
  [10010] = {.count = 1, .reusable = true}, SHIFT(6708),
  [10012] = {.count = 1, .reusable = false}, SHIFT(6710),
  [10014] = {.count = 1, .reusable = false}, SHIFT(6711),
  [10016] = {.count = 1, .reusable = true}, SHIFT(6710),
  [10018] = {.count = 1, .reusable = true}, SHIFT(6706),
  [10020] = {.count = 1, .reusable = false}, SHIFT(6702),
  [10022] = {.count = 1, .reusable = true}, SHIFT(6712),
  [10024] = {.count = 1, .reusable = false}, SHIFT(6712),
  [10026] = {.count = 1, .reusable = true}, SHIFT(6713),
  [10028] = {.count = 1, .reusable = true}, SHIFT(6716),
  [10030] = {.count = 1, .reusable = true}, SHIFT(6718),
  [10032] = {.count = 1, .reusable = true}, SHIFT(6720),
  [10034] = {.count = 1, .reusable = false}, SHIFT(6718),
  [10036] = {.count = 1, .reusable = true}, SHIFT(6733),
  [10038] = {.count = 1, .reusable = true}, SHIFT(1816),
  [10040] = {.count = 1, .reusable = false}, SHIFT(6745),
  [10042] = {.count = 1, .reusable = false}, SHIFT(6746),
  [10044] = {.count = 1, .reusable = true}, SHIFT(6749),
  [10046] = {.count = 1, .reusable = true}, SHIFT(6750),
  [10048] = {.count = 1, .reusable = true}, SHIFT(6751),
  [10050] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1866),
  [10053] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1868),
  [10056] = {.count = 1, .reusable = true}, SHIFT(6755),
  [10058] = {.count = 1, .reusable = false}, SHIFT(6755),
  [10060] = {.count = 1, .reusable = true}, SHIFT(6758),
  [10062] = {.count = 1, .reusable = true}, SHIFT(6760),
  [10064] = {.count = 1, .reusable = true}, SHIFT(6761),
  [10066] = {.count = 1, .reusable = false}, SHIFT(6762),
  [10068] = {.count = 1, .reusable = true}, SHIFT(6764),
  [10070] = {.count = 1, .reusable = true}, SHIFT(6766),
  [10072] = {.count = 1, .reusable = true}, SHIFT(6768),
  [10074] = {.count = 1, .reusable = true}, SHIFT(6769),
  [10076] = {.count = 1, .reusable = false}, SHIFT(6769),
  [10078] = {.count = 1, .reusable = true}, SHIFT(6771),
  [10080] = {.count = 1, .reusable = true}, SHIFT(6773),
  [10082] = {.count = 1, .reusable = true}, SHIFT(6775),
  [10084] = {.count = 1, .reusable = true}, SHIFT(6776),
  [10086] = {.count = 1, .reusable = true}, SHIFT(6777),
  [10088] = {.count = 1, .reusable = true}, SHIFT(6778),
  [10090] = {.count = 1, .reusable = true}, SHIFT(6780),
  [10092] = {.count = 1, .reusable = true}, SHIFT(6781),
  [10094] = {.count = 1, .reusable = true}, SHIFT(6782),
  [10096] = {.count = 1, .reusable = true}, SHIFT(6783),
  [10098] = {.count = 1, .reusable = true}, SHIFT(6784),
  [10100] = {.count = 1, .reusable = true}, SHIFT(6786),
  [10102] = {.count = 1, .reusable = true}, SHIFT(6787),
  [10104] = {.count = 1, .reusable = true}, SHIFT(6788),
  [10106] = {.count = 1, .reusable = true}, SHIFT(6789),
  [10108] = {.count = 1, .reusable = true}, SHIFT(6790),
  [10110] = {.count = 1, .reusable = true}, SHIFT(1944),
  [10112] = {.count = 1, .reusable = false}, SHIFT(6792),
  [10114] = {.count = 1, .reusable = true}, SHIFT(6793),
  [10116] = {.count = 1, .reusable = true}, SHIFT(6794),
  [10118] = {.count = 1, .reusable = false}, SHIFT(6795),
  [10120] = {.count = 1, .reusable = false}, SHIFT(6796),
  [10122] = {.count = 1, .reusable = true}, SHIFT(6800),
  [10124] = {.count = 1, .reusable = false}, SHIFT(6797),
  [10126] = {.count = 1, .reusable = false}, SHIFT(6801),
  [10128] = {.count = 1, .reusable = false}, SHIFT(6804),
  [10130] = {.count = 1, .reusable = false}, SHIFT(6806),
  [10132] = {.count = 1, .reusable = true}, SHIFT(6808),
  [10134] = {.count = 1, .reusable = true}, SHIFT(6809),
  [10136] = {.count = 1, .reusable = false}, SHIFT(6809),
  [10138] = {.count = 1, .reusable = true}, SHIFT(6811),
  [10140] = {.count = 1, .reusable = true}, SHIFT(6813),
  [10142] = {.count = 1, .reusable = true}, SHIFT(6814),
  [10144] = {.count = 1, .reusable = true}, SHIFT(6815),
  [10146] = {.count = 1, .reusable = true}, SHIFT(6818),
  [10148] = {.count = 1, .reusable = true}, SHIFT(6819),
  [10150] = {.count = 1, .reusable = true}, SHIFT(6820),
  [10152] = {.count = 1, .reusable = true}, SHIFT(6821),
  [10154] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2001),
  [10157] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2003),
  [10160] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(609),
  [10163] = {.count = 1, .reusable = true}, SHIFT(6840),
  [10165] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 4),
  [10167] = {.count = 1, .reusable = true}, SHIFT(6843),
  [10169] = {.count = 1, .reusable = true}, SHIFT(6844),
  [10171] = {.count = 1, .reusable = false}, SHIFT(6845),
  [10173] = {.count = 1, .reusable = false}, SHIFT(6846),
  [10175] = {.count = 1, .reusable = false}, SHIFT(6847),
  [10177] = {.count = 1, .reusable = true}, SHIFT(6848),
  [10179] = {.count = 1, .reusable = false}, SHIFT(6849),
  [10181] = {.count = 1, .reusable = true}, SHIFT(6849),
  [10183] = {.count = 1, .reusable = true}, SHIFT(6851),
  [10185] = {.count = 1, .reusable = true}, SHIFT(6852),
  [10187] = {.count = 1, .reusable = false}, SHIFT(6851),
  [10189] = {.count = 1, .reusable = true}, SHIFT(6847),
  [10191] = {.count = 1, .reusable = true}, SHIFT(6845),
  [10193] = {.count = 1, .reusable = true}, SHIFT(6853),
  [10195] = {.count = 1, .reusable = false}, SHIFT(6853),
  [10197] = {.count = 1, .reusable = true}, SHIFT(6854),
  [10199] = {.count = 1, .reusable = true}, SHIFT(2035),
  [10201] = {.count = 1, .reusable = true}, SHIFT(6875),
  [10203] = {.count = 1, .reusable = true}, SHIFT(6878),
  [10205] = {.count = 1, .reusable = true}, SHIFT(6879),
  [10207] = {.count = 1, .reusable = false}, SHIFT(6880),
  [10209] = {.count = 1, .reusable = false}, SHIFT(6879),
  [10211] = {.count = 1, .reusable = false}, SHIFT(6881),
  [10213] = {.count = 1, .reusable = false}, SHIFT(6882),
  [10215] = {.count = 1, .reusable = true}, SHIFT(6883),
  [10217] = {.count = 1, .reusable = false}, SHIFT(6884),
  [10219] = {.count = 1, .reusable = true}, SHIFT(6884),
  [10221] = {.count = 1, .reusable = false}, SHIFT(6886),
  [10223] = {.count = 1, .reusable = false}, SHIFT(6887),
  [10225] = {.count = 1, .reusable = true}, SHIFT(6886),
  [10227] = {.count = 1, .reusable = true}, SHIFT(6882),
  [10229] = {.count = 1, .reusable = false}, SHIFT(6878),
  [10231] = {.count = 1, .reusable = true}, SHIFT(6888),
  [10233] = {.count = 1, .reusable = false}, SHIFT(6888),
  [10235] = {.count = 1, .reusable = true}, SHIFT(6889),
  [10237] = {.count = 1, .reusable = true}, SHIFT(2061),
  [10239] = {.count = 1, .reusable = true}, SHIFT(6914),
  [10241] = {.count = 1, .reusable = true}, SHIFT(6915),
  [10243] = {.count = 1, .reusable = false}, SHIFT(6916),
  [10245] = {.count = 1, .reusable = false}, SHIFT(6917),
  [10247] = {.count = 1, .reusable = false}, SHIFT(6918),
  [10249] = {.count = 1, .reusable = true}, SHIFT(6919),
  [10251] = {.count = 1, .reusable = false}, SHIFT(6920),
  [10253] = {.count = 1, .reusable = true}, SHIFT(6920),
  [10255] = {.count = 1, .reusable = true}, SHIFT(6922),
  [10257] = {.count = 1, .reusable = true}, SHIFT(6923),
  [10259] = {.count = 1, .reusable = false}, SHIFT(6922),
  [10261] = {.count = 1, .reusable = true}, SHIFT(6918),
  [10263] = {.count = 1, .reusable = true}, SHIFT(6916),
  [10265] = {.count = 1, .reusable = true}, SHIFT(6924),
  [10267] = {.count = 1, .reusable = true}, SHIFT(6926),
  [10269] = {.count = 1, .reusable = false}, SHIFT(6926),
  [10271] = {.count = 1, .reusable = true}, SHIFT(6927),
  [10273] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 3),
  [10275] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 3),
  [10277] = {.count = 1, .reusable = true}, SHIFT(6929),
  [10279] = {.count = 1, .reusable = true}, SHIFT(6930),
  [10281] = {.count = 1, .reusable = true}, SHIFT(6931),
  [10283] = {.count = 1, .reusable = true}, SHIFT(6937),
  [10285] = {.count = 1, .reusable = false}, SHIFT(6934),
  [10287] = {.count = 1, .reusable = true}, SHIFT(4407),
  [10289] = {.count = 1, .reusable = true}, SHIFT(5418),
  [10291] = {.count = 1, .reusable = true}, SHIFT(6940),
  [10293] = {.count = 1, .reusable = true}, SHIFT(6943),
  [10295] = {.count = 1, .reusable = true}, SHIFT(6944),
  [10297] = {.count = 1, .reusable = true}, SHIFT(6945),
  [10299] = {.count = 1, .reusable = false}, SHIFT(6947),
  [10301] = {.count = 1, .reusable = true}, SHIFT(6953),
  [10303] = {.count = 1, .reusable = true}, SHIFT(6954),
  [10305] = {.count = 1, .reusable = false}, SHIFT(6955),
  [10307] = {.count = 1, .reusable = false}, SHIFT(6956),
  [10309] = {.count = 1, .reusable = false}, SHIFT(6957),
  [10311] = {.count = 1, .reusable = true}, SHIFT(6958),
  [10313] = {.count = 1, .reusable = false}, SHIFT(6959),
  [10315] = {.count = 1, .reusable = true}, SHIFT(6959),
  [10317] = {.count = 1, .reusable = true}, SHIFT(6960),
  [10319] = {.count = 1, .reusable = true}, SHIFT(6961),
  [10321] = {.count = 1, .reusable = true}, SHIFT(6962),
  [10323] = {.count = 1, .reusable = false}, SHIFT(6961),
  [10325] = {.count = 1, .reusable = true}, SHIFT(6957),
  [10327] = {.count = 1, .reusable = true}, SHIFT(6955),
  [10329] = {.count = 1, .reusable = true}, SHIFT(6963),
  [10331] = {.count = 1, .reusable = false}, SHIFT(6963),
  [10333] = {.count = 1, .reusable = true}, SHIFT(6964),
  [10335] = {.count = 1, .reusable = true}, SHIFT(6969),
  [10337] = {.count = 1, .reusable = false}, SHIFT(6971),
  [10339] = {.count = 1, .reusable = true}, SHIFT(6973),
  [10341] = {.count = 1, .reusable = false}, SHIFT(6969),
  [10343] = {.count = 1, .reusable = true}, SHIFT(2128),
  [10345] = {.count = 1, .reusable = true}, SHIFT(7016),
  [10347] = {.count = 1, .reusable = true}, SHIFT(2149),
  [10349] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2156),
  [10352] = {.count = 1, .reusable = true}, SHIFT(7040),
  [10354] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2209),
  [10357] = {.count = 1, .reusable = true}, SHIFT(7056),
  [10359] = {.count = 1, .reusable = true}, SHIFT(7057),
  [10361] = {.count = 1, .reusable = true}, SHIFT(7058),
  [10363] = {.count = 1, .reusable = true}, SHIFT(7059),
  [10365] = {.count = 1, .reusable = true}, SHIFT(7060),
  [10367] = {.count = 1, .reusable = true}, SHIFT(7061),
  [10369] = {.count = 1, .reusable = true}, SHIFT(7062),
  [10371] = {.count = 1, .reusable = false}, SHIFT(7063),
  [10373] = {.count = 1, .reusable = false}, SHIFT(7064),
  [10375] = {.count = 1, .reusable = true}, SHIFT(7067),
  [10377] = {.count = 1, .reusable = false}, SHIFT(7069),
  [10379] = {.count = 1, .reusable = true}, SHIFT(7071),
  [10381] = {.count = 1, .reusable = false}, SHIFT(7067),
  [10383] = {.count = 1, .reusable = true}, SHIFT(7083),
  [10385] = {.count = 1, .reusable = false}, SHIFT(7084),
  [10387] = {.count = 1, .reusable = false}, SHIFT(7085),
  [10389] = {.count = 1, .reusable = false}, SHIFT(7086),
  [10391] = {.count = 1, .reusable = false}, SHIFT(7087),
  [10393] = {.count = 1, .reusable = false}, SHIFT(7083),
  [10395] = {.count = 1, .reusable = true}, SHIFT(7088),
  [10397] = {.count = 1, .reusable = false}, SHIFT(7088),
  [10399] = {.count = 1, .reusable = true}, SHIFT(7089),
  [10401] = {.count = 1, .reusable = true}, SHIFT(7095),
  [10403] = {.count = 1, .reusable = false}, SHIFT(7097),
  [10405] = {.count = 1, .reusable = true}, SHIFT(7099),
  [10407] = {.count = 1, .reusable = false}, SHIFT(7095),
  [10409] = {.count = 1, .reusable = true}, SHIFT(7105),
  [10411] = {.count = 1, .reusable = true}, SHIFT(7106),
  [10413] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2270),
  [10416] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2272),
  [10419] = {.count = 1, .reusable = true}, SHIFT(7108),
  [10421] = {.count = 1, .reusable = false}, SHIFT(7108),
  [10423] = {.count = 1, .reusable = true}, SHIFT(7111),
  [10425] = {.count = 1, .reusable = true}, SHIFT(7113),
  [10427] = {.count = 1, .reusable = true}, SHIFT(7114),
  [10429] = {.count = 1, .reusable = false}, SHIFT(7115),
  [10431] = {.count = 1, .reusable = true}, SHIFT(7117),
  [10433] = {.count = 1, .reusable = true}, SHIFT(7119),
  [10435] = {.count = 1, .reusable = true}, SHIFT(7121),
  [10437] = {.count = 1, .reusable = true}, SHIFT(7122),
  [10439] = {.count = 1, .reusable = false}, SHIFT(7122),
  [10441] = {.count = 1, .reusable = true}, SHIFT(7124),
  [10443] = {.count = 1, .reusable = true}, SHIFT(7125),
  [10445] = {.count = 1, .reusable = true}, SHIFT(7127),
  [10447] = {.count = 1, .reusable = true}, SHIFT(7128),
  [10449] = {.count = 1, .reusable = true}, SHIFT(7129),
  [10451] = {.count = 1, .reusable = true}, SHIFT(7130),
  [10453] = {.count = 1, .reusable = true}, SHIFT(7131),
  [10455] = {.count = 1, .reusable = true}, SHIFT(7132),
  [10457] = {.count = 1, .reusable = false}, SHIFT(7133),
  [10459] = {.count = 1, .reusable = true}, SHIFT(7135),
  [10461] = {.count = 1, .reusable = true}, SHIFT(7136),
  [10463] = {.count = 1, .reusable = true}, SHIFT(7138),
  [10465] = {.count = 1, .reusable = false}, SHIFT(7139),
  [10467] = {.count = 1, .reusable = true}, SHIFT(7141),
  [10469] = {.count = 1, .reusable = true}, SHIFT(7142),
  [10471] = {.count = 1, .reusable = true}, SHIFT(7144),
  [10473] = {.count = 1, .reusable = true}, SHIFT(7147),
  [10475] = {.count = 1, .reusable = true}, SHIFT(7148),
  [10477] = {.count = 1, .reusable = true}, SHIFT(7149),
  [10479] = {.count = 1, .reusable = true}, SHIFT(7152),
  [10481] = {.count = 1, .reusable = true}, SHIFT(7154),
  [10483] = {.count = 1, .reusable = false}, SHIFT(7153),
  [10485] = {.count = 1, .reusable = true}, SHIFT(7157),
  [10487] = {.count = 1, .reusable = true}, SHIFT(7159),
  [10489] = {.count = 1, .reusable = false}, SHIFT(7162),
  [10491] = {.count = 1, .reusable = true}, SHIFT(7163),
  [10493] = {.count = 1, .reusable = true}, SHIFT(7165),
  [10495] = {.count = 1, .reusable = false}, SHIFT(7157),
  [10497] = {.count = 1, .reusable = true}, SHIFT(7167),
  [10499] = {.count = 1, .reusable = true}, SHIFT(7168),
  [10501] = {.count = 1, .reusable = true}, SHIFT(7169),
  [10503] = {.count = 1, .reusable = true}, SHIFT(7170),
  [10505] = {.count = 1, .reusable = true}, SHIFT(7172),
  [10507] = {.count = 1, .reusable = true}, SHIFT(7174),
  [10509] = {.count = 1, .reusable = true}, SHIFT(7175),
  [10511] = {.count = 1, .reusable = false}, SHIFT(7179),
  [10513] = {.count = 1, .reusable = true}, SHIFT(7180),
  [10515] = {.count = 1, .reusable = true}, SHIFT(7182),
  [10517] = {.count = 1, .reusable = true}, SHIFT(7188),
  [10519] = {.count = 1, .reusable = false}, SHIFT(7185),
  [10521] = {.count = 1, .reusable = true}, SHIFT(4723),
  [10523] = {.count = 1, .reusable = true}, SHIFT(7200),
  [10525] = {.count = 1, .reusable = true}, SHIFT(2349),
  [10527] = {.count = 1, .reusable = true}, SHIFT(7212),
  [10529] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2369),
  [10532] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_class, 5),
  [10534] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_class, 5),
  [10536] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5),
  [10538] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5),
  [10540] = {.count = 1, .reusable = true}, SHIFT(7217),
  [10542] = {.count = 1, .reusable = false}, SHIFT(7219),
  [10544] = {.count = 1, .reusable = true}, SHIFT(7221),
  [10546] = {.count = 1, .reusable = false}, SHIFT(7217),
  [10548] = {.count = 1, .reusable = true}, SHIFT(2400),
  [10550] = {.count = 1, .reusable = true}, SHIFT(7243),
  [10552] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2419),
  [10555] = {.count = 1, .reusable = true}, SHIFT(7248),
  [10557] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2449),
  [10560] = {.count = 1, .reusable = true}, SHIFT(7263),
  [10562] = {.count = 1, .reusable = true}, SHIFT(2471),
  [10564] = {.count = 1, .reusable = true}, SHIFT(7274),
  [10566] = {.count = 1, .reusable = true}, SHIFT(2492),
  [10568] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_parens, 4),
  [10570] = {.count = 1, .reusable = false}, REDUCE(sym__argument_list_with_parens, 4),
  [10572] = {.count = 1, .reusable = true}, SHIFT(7285),
  [10574] = {.count = 1, .reusable = true}, SHIFT(7287),
  [10576] = {.count = 1, .reusable = true}, SHIFT(7288),
  [10578] = {.count = 1, .reusable = true}, SHIFT(7289),
  [10580] = {.count = 1, .reusable = false}, SHIFT(7289),
  [10582] = {.count = 1, .reusable = true}, SHIFT(7291),
  [10584] = {.count = 1, .reusable = true}, SHIFT(7292),
  [10586] = {.count = 1, .reusable = true}, SHIFT(7293),
  [10588] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2540),
  [10591] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2542),
  [10594] = {.count = 1, .reusable = true}, SHIFT(7295),
  [10596] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [10598] = {.count = 1, .reusable = false}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [10600] = {.count = 1, .reusable = true}, SHIFT(4925),
  [10602] = {.count = 1, .reusable = true}, SHIFT(2576),
  [10604] = {.count = 1, .reusable = true}, SHIFT(7320),
  [10606] = {.count = 1, .reusable = true}, SHIFT(2597),
  [10608] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2604),
  [10611] = {.count = 1, .reusable = true}, SHIFT(7329),
  [10613] = {.count = 1, .reusable = false}, SHIFT(7330),
  [10615] = {.count = 1, .reusable = false}, SHIFT(7331),
  [10617] = {.count = 1, .reusable = false}, SHIFT(7332),
  [10619] = {.count = 1, .reusable = false}, SHIFT(7333),
  [10621] = {.count = 1, .reusable = false}, SHIFT(7329),
  [10623] = {.count = 1, .reusable = true}, SHIFT(7334),
  [10625] = {.count = 1, .reusable = false}, SHIFT(7334),
  [10627] = {.count = 1, .reusable = true}, SHIFT(7335),
  [10629] = {.count = 1, .reusable = false}, SHIFT(4985),
  [10631] = {.count = 1, .reusable = true}, SHIFT(7343),
  [10633] = {.count = 1, .reusable = true}, SHIFT(7345),
  [10635] = {.count = 1, .reusable = true}, SHIFT(7346),
  [10637] = {.count = 1, .reusable = true}, SHIFT(7347),
  [10639] = {.count = 1, .reusable = false}, SHIFT(7349),
  [10641] = {.count = 1, .reusable = false}, SHIFT(7355),
  [10643] = {.count = 1, .reusable = true}, SHIFT(7356),
  [10645] = {.count = 1, .reusable = true}, SHIFT(7357),
  [10647] = {.count = 1, .reusable = false}, SHIFT(7358),
  [10649] = {.count = 1, .reusable = false}, SHIFT(7359),
  [10651] = {.count = 1, .reusable = false}, SHIFT(7360),
  [10653] = {.count = 1, .reusable = true}, SHIFT(7361),
  [10655] = {.count = 1, .reusable = false}, SHIFT(7362),
  [10657] = {.count = 1, .reusable = true}, SHIFT(7362),
  [10659] = {.count = 1, .reusable = true}, SHIFT(7364),
  [10661] = {.count = 1, .reusable = true}, SHIFT(7365),
  [10663] = {.count = 1, .reusable = false}, SHIFT(7364),
  [10665] = {.count = 1, .reusable = true}, SHIFT(7360),
  [10667] = {.count = 1, .reusable = true}, SHIFT(7358),
  [10669] = {.count = 1, .reusable = true}, SHIFT(7366),
  [10671] = {.count = 1, .reusable = true}, SHIFT(7367),
  [10673] = {.count = 1, .reusable = true}, SHIFT(7368),
  [10675] = {.count = 1, .reusable = false}, SHIFT(7370),
  [10677] = {.count = 1, .reusable = true}, SHIFT(7376),
  [10679] = {.count = 1, .reusable = true}, SHIFT(7378),
  [10681] = {.count = 1, .reusable = false}, SHIFT(7378),
  [10683] = {.count = 1, .reusable = true}, SHIFT(7379),
  [10685] = {.count = 1, .reusable = false}, SHIFT(7343),
  [10687] = {.count = 1, .reusable = true}, SHIFT(7381),
  [10689] = {.count = 1, .reusable = true}, REDUCE(sym_if, 5),
  [10691] = {.count = 1, .reusable = false}, REDUCE(sym_if, 5),
  [10693] = {.count = 1, .reusable = true}, SHIFT(7383),
  [10695] = {.count = 1, .reusable = true}, SHIFT(7384),
  [10697] = {.count = 1, .reusable = true}, SHIFT(7401),
  [10699] = {.count = 1, .reusable = false}, SHIFT(7402),
  [10701] = {.count = 1, .reusable = false}, SHIFT(7403),
  [10703] = {.count = 1, .reusable = false}, SHIFT(7404),
  [10705] = {.count = 1, .reusable = false}, SHIFT(7405),
  [10707] = {.count = 1, .reusable = false}, SHIFT(7401),
  [10709] = {.count = 1, .reusable = true}, SHIFT(7406),
  [10711] = {.count = 1, .reusable = false}, SHIFT(7406),
  [10713] = {.count = 1, .reusable = true}, SHIFT(7407),
  [10715] = {.count = 1, .reusable = false}, SHIFT(7409),
  [10717] = {.count = 1, .reusable = true}, SHIFT(7409),
  [10719] = {.count = 1, .reusable = false}, SHIFT(5027),
  [10721] = {.count = 1, .reusable = true}, SHIFT(7416),
  [10723] = {.count = 1, .reusable = false}, SHIFT(7419),
  [10725] = {.count = 1, .reusable = true}, SHIFT(7420),
  [10727] = {.count = 1, .reusable = true}, SHIFT(7421),
  [10729] = {.count = 1, .reusable = false}, SHIFT(7422),
  [10731] = {.count = 1, .reusable = false}, SHIFT(7421),
  [10733] = {.count = 1, .reusable = false}, SHIFT(7423),
  [10735] = {.count = 1, .reusable = false}, SHIFT(7424),
  [10737] = {.count = 1, .reusable = true}, SHIFT(7425),
  [10739] = {.count = 1, .reusable = false}, SHIFT(7426),
  [10741] = {.count = 1, .reusable = true}, SHIFT(7426),
  [10743] = {.count = 1, .reusable = false}, SHIFT(7428),
  [10745] = {.count = 1, .reusable = false}, SHIFT(7429),
  [10747] = {.count = 1, .reusable = true}, SHIFT(7428),
  [10749] = {.count = 1, .reusable = true}, SHIFT(7424),
  [10751] = {.count = 1, .reusable = false}, SHIFT(7420),
  [10753] = {.count = 1, .reusable = true}, SHIFT(7431),
  [10755] = {.count = 1, .reusable = true}, SHIFT(7433),
  [10757] = {.count = 1, .reusable = false}, SHIFT(7433),
  [10759] = {.count = 1, .reusable = true}, SHIFT(7434),
  [10761] = {.count = 1, .reusable = false}, SHIFT(7416),
  [10763] = {.count = 1, .reusable = true}, SHIFT(7436),
  [10765] = {.count = 1, .reusable = true}, SHIFT(7437),
  [10767] = {.count = 1, .reusable = false}, SHIFT(7437),
  [10769] = {.count = 1, .reusable = true}, SHIFT(7438),
  [10771] = {.count = 1, .reusable = false}, SHIFT(7438),
  [10773] = {.count = 1, .reusable = true}, SHIFT(7439),
  [10775] = {.count = 1, .reusable = true}, SHIFT(7462),
  [10777] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2679),
  [10780] = {.count = 1, .reusable = true}, SHIFT(7478),
  [10782] = {.count = 1, .reusable = false}, SHIFT(7479),
  [10784] = {.count = 1, .reusable = false}, SHIFT(7480),
  [10786] = {.count = 1, .reusable = false}, SHIFT(7481),
  [10788] = {.count = 1, .reusable = false}, SHIFT(7482),
  [10790] = {.count = 1, .reusable = false}, SHIFT(7478),
  [10792] = {.count = 1, .reusable = true}, SHIFT(7483),
  [10794] = {.count = 1, .reusable = false}, SHIFT(7483),
  [10796] = {.count = 1, .reusable = true}, SHIFT(7484),
  [10798] = {.count = 1, .reusable = false}, SHIFT(5104),
  [10800] = {.count = 1, .reusable = true}, SHIFT(7492),
  [10802] = {.count = 1, .reusable = true}, SHIFT(7494),
  [10804] = {.count = 1, .reusable = true}, SHIFT(7495),
  [10806] = {.count = 1, .reusable = true}, SHIFT(7496),
  [10808] = {.count = 1, .reusable = false}, SHIFT(7498),
  [10810] = {.count = 1, .reusable = false}, SHIFT(7504),
  [10812] = {.count = 1, .reusable = true}, SHIFT(7505),
  [10814] = {.count = 1, .reusable = true}, SHIFT(7506),
  [10816] = {.count = 1, .reusable = false}, SHIFT(7507),
  [10818] = {.count = 1, .reusable = false}, SHIFT(7508),
  [10820] = {.count = 1, .reusable = false}, SHIFT(7509),
  [10822] = {.count = 1, .reusable = true}, SHIFT(7510),
  [10824] = {.count = 1, .reusable = false}, SHIFT(7511),
  [10826] = {.count = 1, .reusable = true}, SHIFT(7511),
  [10828] = {.count = 1, .reusable = true}, SHIFT(7513),
  [10830] = {.count = 1, .reusable = true}, SHIFT(7514),
  [10832] = {.count = 1, .reusable = false}, SHIFT(7513),
  [10834] = {.count = 1, .reusable = true}, SHIFT(7509),
  [10836] = {.count = 1, .reusable = true}, SHIFT(7507),
  [10838] = {.count = 1, .reusable = true}, SHIFT(7515),
  [10840] = {.count = 1, .reusable = true}, SHIFT(7516),
  [10842] = {.count = 1, .reusable = true}, SHIFT(7517),
  [10844] = {.count = 1, .reusable = false}, SHIFT(7519),
  [10846] = {.count = 1, .reusable = true}, SHIFT(7525),
  [10848] = {.count = 1, .reusable = true}, SHIFT(7527),
  [10850] = {.count = 1, .reusable = false}, SHIFT(7527),
  [10852] = {.count = 1, .reusable = true}, SHIFT(7528),
  [10854] = {.count = 1, .reusable = false}, SHIFT(7492),
  [10856] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 5),
  [10858] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 5),
  [10860] = {.count = 1, .reusable = true}, SHIFT(7531),
  [10862] = {.count = 1, .reusable = true}, SHIFT(7532),
  [10864] = {.count = 1, .reusable = true}, SHIFT(7549),
  [10866] = {.count = 1, .reusable = false}, SHIFT(7550),
  [10868] = {.count = 1, .reusable = false}, SHIFT(7551),
  [10870] = {.count = 1, .reusable = false}, SHIFT(7552),
  [10872] = {.count = 1, .reusable = false}, SHIFT(7553),
  [10874] = {.count = 1, .reusable = false}, SHIFT(7549),
  [10876] = {.count = 1, .reusable = true}, SHIFT(7554),
  [10878] = {.count = 1, .reusable = false}, SHIFT(7554),
  [10880] = {.count = 1, .reusable = true}, SHIFT(7555),
  [10882] = {.count = 1, .reusable = false}, SHIFT(7557),
  [10884] = {.count = 1, .reusable = true}, SHIFT(7557),
  [10886] = {.count = 1, .reusable = false}, SHIFT(5144),
  [10888] = {.count = 1, .reusable = true}, SHIFT(7564),
  [10890] = {.count = 1, .reusable = false}, SHIFT(7567),
  [10892] = {.count = 1, .reusable = true}, SHIFT(7568),
  [10894] = {.count = 1, .reusable = true}, SHIFT(7569),
  [10896] = {.count = 1, .reusable = false}, SHIFT(7570),
  [10898] = {.count = 1, .reusable = false}, SHIFT(7569),
  [10900] = {.count = 1, .reusable = false}, SHIFT(7571),
  [10902] = {.count = 1, .reusable = false}, SHIFT(7572),
  [10904] = {.count = 1, .reusable = true}, SHIFT(7573),
  [10906] = {.count = 1, .reusable = false}, SHIFT(7574),
  [10908] = {.count = 1, .reusable = true}, SHIFT(7574),
  [10910] = {.count = 1, .reusable = false}, SHIFT(7576),
  [10912] = {.count = 1, .reusable = false}, SHIFT(7577),
  [10914] = {.count = 1, .reusable = true}, SHIFT(7576),
  [10916] = {.count = 1, .reusable = true}, SHIFT(7572),
  [10918] = {.count = 1, .reusable = false}, SHIFT(7568),
  [10920] = {.count = 1, .reusable = true}, SHIFT(7579),
  [10922] = {.count = 1, .reusable = true}, SHIFT(7581),
  [10924] = {.count = 1, .reusable = false}, SHIFT(7581),
  [10926] = {.count = 1, .reusable = true}, SHIFT(7582),
  [10928] = {.count = 1, .reusable = false}, SHIFT(7564),
  [10930] = {.count = 1, .reusable = true}, SHIFT(7584),
  [10932] = {.count = 1, .reusable = true}, SHIFT(7585),
  [10934] = {.count = 1, .reusable = false}, SHIFT(7585),
  [10936] = {.count = 1, .reusable = true}, SHIFT(7586),
  [10938] = {.count = 1, .reusable = false}, SHIFT(7586),
  [10940] = {.count = 1, .reusable = true}, SHIFT(7587),
  [10942] = {.count = 1, .reusable = true}, SHIFT(2732),
  [10944] = {.count = 1, .reusable = true}, SHIFT(7616),
  [10946] = {.count = 1, .reusable = true}, SHIFT(2754),
  [10948] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2761),
  [10951] = {.count = 1, .reusable = true}, REDUCE(sym_while, 5),
  [10953] = {.count = 1, .reusable = false}, REDUCE(sym_while, 5),
  [10955] = {.count = 1, .reusable = true}, SHIFT(7640),
  [10957] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2809),
  [10960] = {.count = 1, .reusable = true}, REDUCE(sym_until, 5),
  [10962] = {.count = 1, .reusable = false}, REDUCE(sym_until, 5),
  [10964] = {.count = 1, .reusable = true}, SHIFT(7658),
  [10966] = {.count = 1, .reusable = false}, SHIFT(7660),
  [10968] = {.count = 1, .reusable = true}, SHIFT(7662),
  [10970] = {.count = 1, .reusable = false}, SHIFT(7658),
  [10972] = {.count = 1, .reusable = true}, SHIFT(7674),
  [10974] = {.count = 1, .reusable = false}, SHIFT(7675),
  [10976] = {.count = 1, .reusable = false}, SHIFT(7676),
  [10978] = {.count = 1, .reusable = false}, SHIFT(7677),
  [10980] = {.count = 1, .reusable = false}, SHIFT(7678),
  [10982] = {.count = 1, .reusable = false}, SHIFT(7674),
  [10984] = {.count = 1, .reusable = true}, SHIFT(7679),
  [10986] = {.count = 1, .reusable = false}, SHIFT(7679),
  [10988] = {.count = 1, .reusable = true}, SHIFT(7680),
  [10990] = {.count = 1, .reusable = true}, SHIFT(7686),
  [10992] = {.count = 1, .reusable = false}, SHIFT(7688),
  [10994] = {.count = 1, .reusable = true}, SHIFT(7690),
  [10996] = {.count = 1, .reusable = false}, SHIFT(7686),
  [10998] = {.count = 1, .reusable = true}, SHIFT(2846),
  [11000] = {.count = 1, .reusable = true}, SHIFT(7702),
  [11002] = {.count = 1, .reusable = true}, SHIFT(2868),
  [11004] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2883),
  [11007] = {.count = 1, .reusable = true}, REDUCE(sym_for, 5),
  [11009] = {.count = 1, .reusable = false}, REDUCE(sym_for, 5),
  [11011] = {.count = 1, .reusable = true}, SHIFT(7725),
  [11013] = {.count = 1, .reusable = true}, SHIFT(2909),
  [11015] = {.count = 1, .reusable = true}, SHIFT(7748),
  [11017] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2928),
  [11020] = {.count = 1, .reusable = true}, REDUCE(sym_case, 5),
  [11022] = {.count = 1, .reusable = false}, REDUCE(sym_case, 5),
  [11024] = {.count = 1, .reusable = true}, SHIFT(7752),
  [11026] = {.count = 1, .reusable = true}, SHIFT(7766),
  [11028] = {.count = 1, .reusable = false}, SHIFT(7766),
  [11030] = {.count = 1, .reusable = true}, SHIFT(7767),
  [11032] = {.count = 1, .reusable = false}, SHIFT(7767),
  [11034] = {.count = 1, .reusable = true}, SHIFT(7768),
  [11036] = {.count = 1, .reusable = true}, SHIFT(7773),
  [11038] = {.count = 1, .reusable = false}, SHIFT(7775),
  [11040] = {.count = 1, .reusable = true}, SHIFT(7777),
  [11042] = {.count = 1, .reusable = false}, SHIFT(7773),
  [11044] = {.count = 1, .reusable = true}, SHIFT(7780),
  [11046] = {.count = 1, .reusable = false}, REDUCE(sym_when, 3),
  [11048] = {.count = 1, .reusable = false}, SHIFT(7781),
  [11050] = {.count = 1, .reusable = false}, SHIFT(7782),
  [11052] = {.count = 1, .reusable = false}, SHIFT(7783),
  [11054] = {.count = 1, .reusable = false}, SHIFT(7784),
  [11056] = {.count = 1, .reusable = false}, SHIFT(1128),
  [11058] = {.count = 1, .reusable = false}, SHIFT(7780),
  [11060] = {.count = 1, .reusable = true}, SHIFT(7785),
  [11062] = {.count = 1, .reusable = false}, SHIFT(7785),
  [11064] = {.count = 1, .reusable = true}, SHIFT(7786),
  [11066] = {.count = 1, .reusable = false}, SHIFT(7793),
  [11068] = {.count = 1, .reusable = true}, SHIFT(7793),
  [11070] = {.count = 1, .reusable = false}, SHIFT(7787),
  [11072] = {.count = 1, .reusable = true}, SHIFT(7797),
  [11074] = {.count = 1, .reusable = true}, SHIFT(7809),
  [11076] = {.count = 1, .reusable = false}, SHIFT(7810),
  [11078] = {.count = 1, .reusable = false}, SHIFT(7811),
  [11080] = {.count = 1, .reusable = false}, SHIFT(7812),
  [11082] = {.count = 1, .reusable = false}, SHIFT(7813),
  [11084] = {.count = 1, .reusable = false}, SHIFT(7809),
  [11086] = {.count = 1, .reusable = true}, SHIFT(7814),
  [11088] = {.count = 1, .reusable = false}, SHIFT(7814),
  [11090] = {.count = 1, .reusable = true}, SHIFT(7815),
  [11092] = {.count = 1, .reusable = false}, SHIFT(7817),
  [11094] = {.count = 1, .reusable = true}, SHIFT(7817),
  [11096] = {.count = 1, .reusable = true}, SHIFT(7822),
  [11098] = {.count = 1, .reusable = false}, SHIFT(7824),
  [11100] = {.count = 1, .reusable = true}, SHIFT(7826),
  [11102] = {.count = 1, .reusable = false}, SHIFT(7822),
  [11104] = {.count = 1, .reusable = true}, SHIFT(7828),
  [11106] = {.count = 1, .reusable = true}, SHIFT(2992),
  [11108] = {.count = 1, .reusable = true}, SHIFT(7855),
  [11110] = {.count = 1, .reusable = true}, SHIFT(3013),
  [11112] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3020),
  [11115] = {.count = 1, .reusable = true}, SHIFT(3031),
  [11117] = {.count = 1, .reusable = true}, SHIFT(7883),
  [11119] = {.count = 1, .reusable = false}, SHIFT(7883),
  [11121] = {.count = 1, .reusable = true}, SHIFT(7884),
  [11123] = {.count = 1, .reusable = true}, SHIFT(7885),
  [11125] = {.count = 1, .reusable = true}, SHIFT(7888),
  [11127] = {.count = 1, .reusable = true}, SHIFT(7891),
  [11129] = {.count = 1, .reusable = false}, SHIFT(7892),
  [11131] = {.count = 1, .reusable = false}, SHIFT(7893),
  [11133] = {.count = 1, .reusable = false}, SHIFT(7894),
  [11135] = {.count = 1, .reusable = false}, SHIFT(7895),
  [11137] = {.count = 1, .reusable = false}, SHIFT(7891),
  [11139] = {.count = 1, .reusable = true}, SHIFT(7896),
  [11141] = {.count = 1, .reusable = false}, SHIFT(7896),
  [11143] = {.count = 1, .reusable = true}, SHIFT(7897),
  [11145] = {.count = 1, .reusable = true}, SHIFT(7905),
  [11147] = {.count = 1, .reusable = true}, SHIFT(7906),
  [11149] = {.count = 1, .reusable = true}, SHIFT(7908),
  [11151] = {.count = 1, .reusable = true}, SHIFT(7909),
  [11153] = {.count = 1, .reusable = true}, SHIFT(7910),
  [11155] = {.count = 1, .reusable = false}, SHIFT(5551),
  [11157] = {.count = 1, .reusable = false}, SHIFT(7912),
  [11159] = {.count = 1, .reusable = true}, SHIFT(7917),
  [11161] = {.count = 1, .reusable = false}, SHIFT(7921),
  [11163] = {.count = 1, .reusable = true}, SHIFT(7922),
  [11165] = {.count = 1, .reusable = true}, SHIFT(7923),
  [11167] = {.count = 1, .reusable = false}, SHIFT(7924),
  [11169] = {.count = 1, .reusable = false}, SHIFT(7925),
  [11171] = {.count = 1, .reusable = false}, SHIFT(7926),
  [11173] = {.count = 1, .reusable = true}, SHIFT(7927),
  [11175] = {.count = 1, .reusable = false}, SHIFT(7928),
  [11177] = {.count = 1, .reusable = true}, SHIFT(7928),
  [11179] = {.count = 1, .reusable = true}, SHIFT(7929),
  [11181] = {.count = 1, .reusable = true}, SHIFT(7930),
  [11183] = {.count = 1, .reusable = true}, SHIFT(7931),
  [11185] = {.count = 1, .reusable = false}, SHIFT(7930),
  [11187] = {.count = 1, .reusable = true}, SHIFT(7926),
  [11189] = {.count = 1, .reusable = true}, SHIFT(7924),
  [11191] = {.count = 1, .reusable = true}, SHIFT(7933),
  [11193] = {.count = 1, .reusable = true}, SHIFT(7935),
  [11195] = {.count = 1, .reusable = true}, SHIFT(7937),
  [11197] = {.count = 1, .reusable = false}, SHIFT(7937),
  [11199] = {.count = 1, .reusable = true}, SHIFT(7938),
  [11201] = {.count = 1, .reusable = false}, SHIFT(7905),
  [11203] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 4),
  [11205] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 4),
  [11207] = {.count = 1, .reusable = true}, SHIFT(7942),
  [11209] = {.count = 1, .reusable = true}, SHIFT(3066),
  [11211] = {.count = 1, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [11213] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(3081),
  [11216] = {.count = 1, .reusable = true}, SHIFT(7970),
  [11218] = {.count = 1, .reusable = true}, SHIFT(7971),
  [11220] = {.count = 1, .reusable = false}, SHIFT(7972),
  [11222] = {.count = 1, .reusable = false}, SHIFT(7973),
  [11224] = {.count = 1, .reusable = false}, SHIFT(7974),
  [11226] = {.count = 1, .reusable = true}, SHIFT(7975),
  [11228] = {.count = 1, .reusable = false}, SHIFT(7976),
  [11230] = {.count = 1, .reusable = true}, SHIFT(7976),
  [11232] = {.count = 1, .reusable = true}, SHIFT(7978),
  [11234] = {.count = 1, .reusable = true}, SHIFT(7979),
  [11236] = {.count = 1, .reusable = false}, SHIFT(7978),
  [11238] = {.count = 1, .reusable = true}, SHIFT(7974),
  [11240] = {.count = 1, .reusable = true}, SHIFT(7972),
  [11242] = {.count = 1, .reusable = true}, SHIFT(7980),
  [11244] = {.count = 1, .reusable = false}, SHIFT(7980),
  [11246] = {.count = 1, .reusable = true}, SHIFT(7981),
  [11248] = {.count = 1, .reusable = true}, SHIFT(7986),
  [11250] = {.count = 1, .reusable = false}, SHIFT(7988),
  [11252] = {.count = 1, .reusable = true}, SHIFT(7990),
  [11254] = {.count = 1, .reusable = false}, SHIFT(7986),
  [11256] = {.count = 1, .reusable = true}, SHIFT(8005),
  [11258] = {.count = 1, .reusable = false}, SHIFT(8007),
  [11260] = {.count = 1, .reusable = true}, SHIFT(8009),
  [11262] = {.count = 1, .reusable = false}, SHIFT(8005),
  [11264] = {.count = 1, .reusable = true}, SHIFT(3091),
  [11266] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8020),
  [11269] = {.count = 1, .reusable = true}, SHIFT(8021),
  [11271] = {.count = 1, .reusable = true}, SHIFT(8024),
  [11273] = {.count = 1, .reusable = true}, SHIFT(8025),
  [11275] = {.count = 1, .reusable = false}, SHIFT(8026),
  [11277] = {.count = 1, .reusable = false}, SHIFT(8025),
  [11279] = {.count = 1, .reusable = false}, SHIFT(8027),
  [11281] = {.count = 1, .reusable = false}, SHIFT(8028),
  [11283] = {.count = 1, .reusable = true}, SHIFT(8029),
  [11285] = {.count = 1, .reusable = false}, SHIFT(8030),
  [11287] = {.count = 1, .reusable = true}, SHIFT(8030),
  [11289] = {.count = 1, .reusable = false}, SHIFT(8032),
  [11291] = {.count = 1, .reusable = false}, SHIFT(8033),
  [11293] = {.count = 1, .reusable = true}, SHIFT(8032),
  [11295] = {.count = 1, .reusable = true}, SHIFT(8028),
  [11297] = {.count = 1, .reusable = false}, SHIFT(8024),
  [11299] = {.count = 1, .reusable = true}, SHIFT(8034),
  [11301] = {.count = 1, .reusable = false}, SHIFT(8034),
  [11303] = {.count = 1, .reusable = true}, SHIFT(8035),
  [11305] = {.count = 1, .reusable = true}, SHIFT(3129),
  [11307] = {.count = 1, .reusable = true}, SHIFT(8060),
  [11309] = {.count = 1, .reusable = true}, SHIFT(8061),
  [11311] = {.count = 1, .reusable = false}, SHIFT(8062),
  [11313] = {.count = 1, .reusable = false}, SHIFT(8063),
  [11315] = {.count = 1, .reusable = false}, SHIFT(8064),
  [11317] = {.count = 1, .reusable = true}, SHIFT(8065),
  [11319] = {.count = 1, .reusable = false}, SHIFT(8066),
  [11321] = {.count = 1, .reusable = true}, SHIFT(8066),
  [11323] = {.count = 1, .reusable = true}, SHIFT(8068),
  [11325] = {.count = 1, .reusable = true}, SHIFT(8069),
  [11327] = {.count = 1, .reusable = false}, SHIFT(8068),
  [11329] = {.count = 1, .reusable = true}, SHIFT(8064),
  [11331] = {.count = 1, .reusable = true}, SHIFT(8062),
  [11333] = {.count = 1, .reusable = true}, SHIFT(8070),
  [11335] = {.count = 1, .reusable = true}, SHIFT(8072),
  [11337] = {.count = 1, .reusable = false}, SHIFT(8072),
  [11339] = {.count = 1, .reusable = true}, SHIFT(8073),
  [11341] = {.count = 1, .reusable = true}, SHIFT(8078),
  [11343] = {.count = 1, .reusable = true}, SHIFT(8079),
  [11345] = {.count = 1, .reusable = false}, SHIFT(8080),
  [11347] = {.count = 1, .reusable = false}, SHIFT(8081),
  [11349] = {.count = 1, .reusable = false}, SHIFT(8082),
  [11351] = {.count = 1, .reusable = true}, SHIFT(8083),
  [11353] = {.count = 1, .reusable = false}, SHIFT(8084),
  [11355] = {.count = 1, .reusable = true}, SHIFT(8084),
  [11357] = {.count = 1, .reusable = true}, SHIFT(8086),
  [11359] = {.count = 1, .reusable = true}, SHIFT(8087),
  [11361] = {.count = 1, .reusable = false}, SHIFT(8086),
  [11363] = {.count = 1, .reusable = true}, SHIFT(8082),
  [11365] = {.count = 1, .reusable = true}, SHIFT(8080),
  [11367] = {.count = 1, .reusable = true}, SHIFT(8088),
  [11369] = {.count = 1, .reusable = false}, SHIFT(8088),
  [11371] = {.count = 1, .reusable = true}, SHIFT(8089),
  [11373] = {.count = 1, .reusable = true}, SHIFT(8094),
  [11375] = {.count = 1, .reusable = false}, SHIFT(8096),
  [11377] = {.count = 1, .reusable = true}, SHIFT(8098),
  [11379] = {.count = 1, .reusable = false}, SHIFT(8094),
  [11381] = {.count = 1, .reusable = true}, SHIFT(8113),
  [11383] = {.count = 1, .reusable = false}, SHIFT(8115),
  [11385] = {.count = 1, .reusable = true}, SHIFT(8117),
  [11387] = {.count = 1, .reusable = false}, SHIFT(8113),
  [11389] = {.count = 1, .reusable = true}, SHIFT(3153),
  [11391] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8128),
  [11394] = {.count = 1, .reusable = true}, SHIFT(8129),
  [11396] = {.count = 1, .reusable = true}, SHIFT(8132),
  [11398] = {.count = 1, .reusable = true}, SHIFT(8133),
  [11400] = {.count = 1, .reusable = false}, SHIFT(8134),
  [11402] = {.count = 1, .reusable = false}, SHIFT(8133),
  [11404] = {.count = 1, .reusable = false}, SHIFT(8135),
  [11406] = {.count = 1, .reusable = false}, SHIFT(8136),
  [11408] = {.count = 1, .reusable = true}, SHIFT(8137),
  [11410] = {.count = 1, .reusable = false}, SHIFT(8138),
  [11412] = {.count = 1, .reusable = true}, SHIFT(8138),
  [11414] = {.count = 1, .reusable = false}, SHIFT(8140),
  [11416] = {.count = 1, .reusable = false}, SHIFT(8141),
  [11418] = {.count = 1, .reusable = true}, SHIFT(8140),
  [11420] = {.count = 1, .reusable = true}, SHIFT(8136),
  [11422] = {.count = 1, .reusable = false}, SHIFT(8132),
  [11424] = {.count = 1, .reusable = true}, SHIFT(8142),
  [11426] = {.count = 1, .reusable = false}, SHIFT(8142),
  [11428] = {.count = 1, .reusable = true}, SHIFT(8143),
  [11430] = {.count = 1, .reusable = true}, SHIFT(3191),
  [11432] = {.count = 1, .reusable = true}, SHIFT(8168),
  [11434] = {.count = 1, .reusable = true}, SHIFT(8169),
  [11436] = {.count = 1, .reusable = false}, SHIFT(8170),
  [11438] = {.count = 1, .reusable = false}, SHIFT(8171),
  [11440] = {.count = 1, .reusable = false}, SHIFT(8172),
  [11442] = {.count = 1, .reusable = true}, SHIFT(8173),
  [11444] = {.count = 1, .reusable = false}, SHIFT(8174),
  [11446] = {.count = 1, .reusable = true}, SHIFT(8174),
  [11448] = {.count = 1, .reusable = true}, SHIFT(8176),
  [11450] = {.count = 1, .reusable = true}, SHIFT(8177),
  [11452] = {.count = 1, .reusable = false}, SHIFT(8176),
  [11454] = {.count = 1, .reusable = true}, SHIFT(8172),
  [11456] = {.count = 1, .reusable = true}, SHIFT(8170),
  [11458] = {.count = 1, .reusable = true}, SHIFT(8178),
  [11460] = {.count = 1, .reusable = true}, SHIFT(8180),
  [11462] = {.count = 1, .reusable = false}, SHIFT(8180),
  [11464] = {.count = 1, .reusable = true}, SHIFT(8181),
  [11466] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 4),
  [11468] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 4),
  [11470] = {.count = 1, .reusable = true}, SHIFT(8182),
  [11472] = {.count = 1, .reusable = true}, SHIFT(8198),
  [11474] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3260),
  [11477] = {.count = 1, .reusable = true}, SHIFT(8214),
  [11479] = {.count = 1, .reusable = true}, SHIFT(8215),
  [11481] = {.count = 1, .reusable = true}, SHIFT(8216),
  [11483] = {.count = 1, .reusable = true}, SHIFT(8217),
  [11485] = {.count = 1, .reusable = true}, SHIFT(8218),
  [11487] = {.count = 1, .reusable = true}, SHIFT(8219),
  [11489] = {.count = 1, .reusable = true}, SHIFT(8222),
  [11491] = {.count = 1, .reusable = true}, SHIFT(8223),
  [11493] = {.count = 1, .reusable = false}, SHIFT(8224),
  [11495] = {.count = 1, .reusable = false}, SHIFT(8225),
  [11497] = {.count = 1, .reusable = false}, SHIFT(8226),
  [11499] = {.count = 1, .reusable = true}, SHIFT(8227),
  [11501] = {.count = 1, .reusable = false}, SHIFT(8228),
  [11503] = {.count = 1, .reusable = true}, SHIFT(8228),
  [11505] = {.count = 1, .reusable = true}, SHIFT(8230),
  [11507] = {.count = 1, .reusable = true}, SHIFT(8231),
  [11509] = {.count = 1, .reusable = false}, SHIFT(8230),
  [11511] = {.count = 1, .reusable = true}, SHIFT(8226),
  [11513] = {.count = 1, .reusable = true}, SHIFT(8224),
  [11515] = {.count = 1, .reusable = true}, SHIFT(8232),
  [11517] = {.count = 1, .reusable = false}, SHIFT(8232),
  [11519] = {.count = 1, .reusable = true}, SHIFT(8233),
  [11521] = {.count = 1, .reusable = true}, SHIFT(3298),
  [11523] = {.count = 1, .reusable = true}, SHIFT(8240),
  [11525] = {.count = 1, .reusable = true}, SHIFT(8243),
  [11527] = {.count = 1, .reusable = true}, SHIFT(8244),
  [11529] = {.count = 1, .reusable = false}, SHIFT(8245),
  [11531] = {.count = 1, .reusable = false}, SHIFT(8244),
  [11533] = {.count = 1, .reusable = false}, SHIFT(8246),
  [11535] = {.count = 1, .reusable = false}, SHIFT(8247),
  [11537] = {.count = 1, .reusable = true}, SHIFT(8248),
  [11539] = {.count = 1, .reusable = false}, SHIFT(8249),
  [11541] = {.count = 1, .reusable = true}, SHIFT(8249),
  [11543] = {.count = 1, .reusable = false}, SHIFT(8251),
  [11545] = {.count = 1, .reusable = false}, SHIFT(8252),
  [11547] = {.count = 1, .reusable = true}, SHIFT(8251),
  [11549] = {.count = 1, .reusable = true}, SHIFT(8247),
  [11551] = {.count = 1, .reusable = false}, SHIFT(8243),
  [11553] = {.count = 1, .reusable = true}, SHIFT(8253),
  [11555] = {.count = 1, .reusable = false}, SHIFT(8253),
  [11557] = {.count = 1, .reusable = true}, SHIFT(8254),
  [11559] = {.count = 1, .reusable = true}, SHIFT(3318),
  [11561] = {.count = 1, .reusable = true}, SHIFT(8265),
  [11563] = {.count = 1, .reusable = false}, SHIFT(8266),
  [11565] = {.count = 1, .reusable = false}, SHIFT(8267),
  [11567] = {.count = 1, .reusable = true}, SHIFT(8268),
  [11569] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3357),
  [11572] = {.count = 1, .reusable = true}, SHIFT(8271),
  [11574] = {.count = 1, .reusable = false}, SHIFT(8271),
  [11576] = {.count = 1, .reusable = true}, SHIFT(8274),
  [11578] = {.count = 1, .reusable = true}, SHIFT(8276),
  [11580] = {.count = 1, .reusable = true}, SHIFT(8277),
  [11582] = {.count = 1, .reusable = false}, SHIFT(8278),
  [11584] = {.count = 1, .reusable = true}, SHIFT(8280),
  [11586] = {.count = 1, .reusable = true}, SHIFT(8282),
  [11588] = {.count = 1, .reusable = true}, SHIFT(8284),
  [11590] = {.count = 1, .reusable = true}, SHIFT(8285),
  [11592] = {.count = 1, .reusable = false}, SHIFT(8285),
  [11594] = {.count = 1, .reusable = true}, SHIFT(8287),
  [11596] = {.count = 1, .reusable = true}, SHIFT(8289),
  [11598] = {.count = 1, .reusable = true}, SHIFT(8291),
  [11600] = {.count = 1, .reusable = true}, SHIFT(8292),
  [11602] = {.count = 1, .reusable = true}, SHIFT(8293),
  [11604] = {.count = 1, .reusable = false}, SHIFT(8293),
  [11606] = {.count = 1, .reusable = true}, SHIFT(8295),
  [11608] = {.count = 1, .reusable = true}, SHIFT(8296),
  [11610] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3431),
  [11613] = {.count = 1, .reusable = true}, SHIFT(8299),
  [11615] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 4),
  [11617] = {.count = 1, .reusable = true}, SHIFT(6040),
  [11619] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 3),
  [11621] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 3),
  [11623] = {.count = 1, .reusable = true}, SHIFT(8302),
  [11625] = {.count = 1, .reusable = true}, SHIFT(8303),
  [11627] = {.count = 1, .reusable = true}, SHIFT(8304),
  [11629] = {.count = 1, .reusable = true}, SHIFT(8306),
  [11631] = {.count = 1, .reusable = false}, SHIFT(8307),
  [11633] = {.count = 1, .reusable = false}, SHIFT(8308),
  [11635] = {.count = 1, .reusable = false}, SHIFT(8309),
  [11637] = {.count = 1, .reusable = false}, SHIFT(8310),
  [11639] = {.count = 1, .reusable = false}, SHIFT(8306),
  [11641] = {.count = 1, .reusable = true}, SHIFT(8311),
  [11643] = {.count = 1, .reusable = false}, SHIFT(8311),
  [11645] = {.count = 1, .reusable = true}, SHIFT(8312),
  [11647] = {.count = 1, .reusable = false}, SHIFT(8314),
  [11649] = {.count = 1, .reusable = true}, SHIFT(8314),
  [11651] = {.count = 1, .reusable = true}, SHIFT(8319),
  [11653] = {.count = 1, .reusable = true}, SHIFT(8320),
  [11655] = {.count = 1, .reusable = true}, REDUCE(sym_block, 4),
  [11657] = {.count = 1, .reusable = false}, REDUCE(sym_block, 4),
  [11659] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_parameter, 3),
  [11661] = {.count = 1, .reusable = true}, SHIFT(8322),
  [11663] = {.count = 1, .reusable = true}, SHIFT(6921),
  [11665] = {.count = 1, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2),
  [11667] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 4),
  [11669] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(3457),
  [11672] = {.count = 1, .reusable = true}, SHIFT(8323),
  [11674] = {.count = 1, .reusable = true}, SHIFT(8324),
  [11676] = {.count = 1, .reusable = true}, SHIFT(8326),
  [11678] = {.count = 1, .reusable = true}, SHIFT(8327),
  [11680] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 4),
  [11682] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 4),
  [11684] = {.count = 1, .reusable = true}, SHIFT(8328),
  [11686] = {.count = 1, .reusable = false}, SHIFT(8328),
  [11688] = {.count = 1, .reusable = true}, SHIFT(8340),
  [11690] = {.count = 1, .reusable = true}, SHIFT(8341),
  [11692] = {.count = 1, .reusable = true}, SHIFT(8350),
  [11694] = {.count = 1, .reusable = true}, SHIFT(8351),
  [11696] = {.count = 1, .reusable = false}, SHIFT(8352),
  [11698] = {.count = 1, .reusable = false}, SHIFT(8353),
  [11700] = {.count = 1, .reusable = false}, SHIFT(8354),
  [11702] = {.count = 1, .reusable = true}, SHIFT(8355),
  [11704] = {.count = 1, .reusable = false}, SHIFT(8356),
  [11706] = {.count = 1, .reusable = true}, SHIFT(8356),
  [11708] = {.count = 1, .reusable = true}, SHIFT(8358),
  [11710] = {.count = 1, .reusable = true}, SHIFT(8359),
  [11712] = {.count = 1, .reusable = false}, SHIFT(8358),
  [11714] = {.count = 1, .reusable = true}, SHIFT(8354),
  [11716] = {.count = 1, .reusable = true}, SHIFT(8352),
  [11718] = {.count = 1, .reusable = true}, SHIFT(8360),
  [11720] = {.count = 1, .reusable = false}, SHIFT(8360),
  [11722] = {.count = 1, .reusable = true}, SHIFT(8361),
  [11724] = {.count = 1, .reusable = true}, SHIFT(8363),
  [11726] = {.count = 1, .reusable = true}, SHIFT(8368),
  [11728] = {.count = 1, .reusable = false}, SHIFT(8370),
  [11730] = {.count = 1, .reusable = true}, SHIFT(8372),
  [11732] = {.count = 1, .reusable = false}, SHIFT(8368),
  [11734] = {.count = 1, .reusable = true}, SHIFT(8387),
  [11736] = {.count = 1, .reusable = false}, SHIFT(8389),
  [11738] = {.count = 1, .reusable = true}, SHIFT(8391),
  [11740] = {.count = 1, .reusable = false}, SHIFT(8387),
  [11742] = {.count = 1, .reusable = true}, SHIFT(3491),
  [11744] = {.count = 1, .reusable = true}, SHIFT(8401),
  [11746] = {.count = 1, .reusable = true}, REDUCE(sym_conditional, 5),
  [11748] = {.count = 1, .reusable = true}, SHIFT(8404),
  [11750] = {.count = 1, .reusable = true}, SHIFT(8405),
  [11752] = {.count = 1, .reusable = false}, SHIFT(8406),
  [11754] = {.count = 1, .reusable = false}, SHIFT(8405),
  [11756] = {.count = 1, .reusable = false}, SHIFT(8407),
  [11758] = {.count = 1, .reusable = false}, SHIFT(8408),
  [11760] = {.count = 1, .reusable = true}, SHIFT(8409),
  [11762] = {.count = 1, .reusable = false}, SHIFT(8410),
  [11764] = {.count = 1, .reusable = true}, SHIFT(8410),
  [11766] = {.count = 1, .reusable = false}, SHIFT(8412),
  [11768] = {.count = 1, .reusable = false}, SHIFT(8413),
  [11770] = {.count = 1, .reusable = true}, SHIFT(8412),
  [11772] = {.count = 1, .reusable = true}, SHIFT(8408),
  [11774] = {.count = 1, .reusable = false}, SHIFT(8404),
  [11776] = {.count = 1, .reusable = true}, SHIFT(8414),
  [11778] = {.count = 1, .reusable = false}, SHIFT(8414),
  [11780] = {.count = 1, .reusable = true}, SHIFT(8415),
  [11782] = {.count = 1, .reusable = true}, SHIFT(8417),
  [11784] = {.count = 1, .reusable = true}, SHIFT(3522),
  [11786] = {.count = 1, .reusable = true}, SHIFT(8442),
  [11788] = {.count = 1, .reusable = true}, SHIFT(8443),
  [11790] = {.count = 1, .reusable = false}, SHIFT(8444),
  [11792] = {.count = 1, .reusable = false}, SHIFT(8445),
  [11794] = {.count = 1, .reusable = false}, SHIFT(8446),
  [11796] = {.count = 1, .reusable = true}, SHIFT(8447),
  [11798] = {.count = 1, .reusable = false}, SHIFT(8448),
  [11800] = {.count = 1, .reusable = true}, SHIFT(8448),
  [11802] = {.count = 1, .reusable = true}, SHIFT(8450),
  [11804] = {.count = 1, .reusable = true}, SHIFT(8451),
  [11806] = {.count = 1, .reusable = false}, SHIFT(8450),
  [11808] = {.count = 1, .reusable = true}, SHIFT(8446),
  [11810] = {.count = 1, .reusable = true}, SHIFT(8444),
  [11812] = {.count = 1, .reusable = true}, SHIFT(8452),
  [11814] = {.count = 1, .reusable = true}, SHIFT(8454),
  [11816] = {.count = 1, .reusable = false}, SHIFT(8454),
  [11818] = {.count = 1, .reusable = true}, SHIFT(8455),
  [11820] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(1422),
  [11823] = {.count = 1, .reusable = true}, SHIFT(8457),
  [11825] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 5),
  [11827] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 5),
  [11829] = {.count = 1, .reusable = true}, SHIFT(8458),
  [11831] = {.count = 1, .reusable = true}, SHIFT(8459),
  [11833] = {.count = 1, .reusable = true}, SHIFT(8460),
  [11835] = {.count = 1, .reusable = true}, SHIFT(8461),
  [11837] = {.count = 1, .reusable = true}, SHIFT(8462),
  [11839] = {.count = 1, .reusable = true}, SHIFT(8463),
  [11841] = {.count = 1, .reusable = true}, SHIFT(8464),
  [11843] = {.count = 1, .reusable = true}, SHIFT(8465),
  [11845] = {.count = 1, .reusable = true}, SHIFT(8466),
  [11847] = {.count = 1, .reusable = true}, SHIFT(8468),
  [11849] = {.count = 1, .reusable = true}, SHIFT(8469),
  [11851] = {.count = 1, .reusable = true}, SHIFT(8470),
  [11853] = {.count = 1, .reusable = true}, SHIFT(8471),
  [11855] = {.count = 1, .reusable = true}, SHIFT(8472),
  [11857] = {.count = 1, .reusable = true}, SHIFT(8474),
  [11859] = {.count = 1, .reusable = true}, SHIFT(8475),
  [11861] = {.count = 1, .reusable = true}, SHIFT(8476),
  [11863] = {.count = 1, .reusable = true}, SHIFT(8477),
  [11865] = {.count = 1, .reusable = true}, SHIFT(3586),
  [11867] = {.count = 1, .reusable = false}, SHIFT(8479),
  [11869] = {.count = 1, .reusable = true}, SHIFT(8480),
  [11871] = {.count = 1, .reusable = true}, SHIFT(8481),
  [11873] = {.count = 1, .reusable = false}, SHIFT(8482),
  [11875] = {.count = 1, .reusable = false}, SHIFT(8483),
  [11877] = {.count = 1, .reusable = true}, SHIFT(8487),
  [11879] = {.count = 1, .reusable = false}, SHIFT(8484),
  [11881] = {.count = 1, .reusable = false}, SHIFT(8488),
  [11883] = {.count = 1, .reusable = false}, SHIFT(8491),
  [11885] = {.count = 1, .reusable = false}, SHIFT(8493),
  [11887] = {.count = 1, .reusable = true}, SHIFT(8495),
  [11889] = {.count = 1, .reusable = true}, SHIFT(8497),
  [11891] = {.count = 1, .reusable = true}, SHIFT(8498),
  [11893] = {.count = 1, .reusable = true}, SHIFT(8499),
  [11895] = {.count = 1, .reusable = true}, SHIFT(8502),
  [11897] = {.count = 1, .reusable = true}, SHIFT(8503),
  [11899] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(1464),
  [11902] = {.count = 1, .reusable = true}, SHIFT(3640),
  [11904] = {.count = 1, .reusable = true}, SHIFT(8512),
  [11906] = {.count = 1, .reusable = true}, SHIFT(3662),
  [11908] = {.count = 1, .reusable = true}, SHIFT(8522),
  [11910] = {.count = 1, .reusable = true}, SHIFT(8523),
  [11912] = {.count = 1, .reusable = false}, SHIFT(8524),
  [11914] = {.count = 1, .reusable = false}, SHIFT(8525),
  [11916] = {.count = 1, .reusable = false}, SHIFT(8526),
  [11918] = {.count = 1, .reusable = true}, SHIFT(8527),
  [11920] = {.count = 1, .reusable = false}, SHIFT(8528),
  [11922] = {.count = 1, .reusable = true}, SHIFT(8528),
  [11924] = {.count = 1, .reusable = true}, SHIFT(8530),
  [11926] = {.count = 1, .reusable = true}, SHIFT(8531),
  [11928] = {.count = 1, .reusable = false}, SHIFT(8530),
  [11930] = {.count = 1, .reusable = true}, SHIFT(8526),
  [11932] = {.count = 1, .reusable = true}, SHIFT(8524),
  [11934] = {.count = 1, .reusable = true}, SHIFT(8532),
  [11936] = {.count = 1, .reusable = true}, SHIFT(8534),
  [11938] = {.count = 1, .reusable = false}, SHIFT(8534),
  [11940] = {.count = 1, .reusable = true}, SHIFT(8535),
  [11942] = {.count = 1, .reusable = true}, SHIFT(8536),
  [11944] = {.count = 1, .reusable = false}, SHIFT(8537),
  [11946] = {.count = 1, .reusable = false}, SHIFT(8538),
  [11948] = {.count = 1, .reusable = true}, SHIFT(8539),
  [11950] = {.count = 1, .reusable = false}, SHIFT(8539),
  [11952] = {.count = 1, .reusable = true}, SHIFT(8542),
  [11954] = {.count = 1, .reusable = true}, SHIFT(8544),
  [11956] = {.count = 1, .reusable = true}, SHIFT(8545),
  [11958] = {.count = 1, .reusable = false}, SHIFT(8546),
  [11960] = {.count = 1, .reusable = true}, SHIFT(8548),
  [11962] = {.count = 1, .reusable = false}, SHIFT(8548),
  [11964] = {.count = 1, .reusable = true}, SHIFT(8550),
  [11966] = {.count = 1, .reusable = true}, SHIFT(8552),
  [11968] = {.count = 1, .reusable = true}, SHIFT(6345),
  [11970] = {.count = 1, .reusable = true}, SHIFT(8557),
  [11972] = {.count = 1, .reusable = false}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [11974] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(3742),
  [11977] = {.count = 1, .reusable = true}, SHIFT(3766),
  [11979] = {.count = 1, .reusable = true}, SHIFT(8580),
  [11981] = {.count = 1, .reusable = true}, SHIFT(3787),
  [11983] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3794),
  [11986] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(3800),
  [11989] = {.count = 1, .reusable = true}, SHIFT(8590),
  [11991] = {.count = 1, .reusable = true}, SHIFT(8592),
  [11993] = {.count = 1, .reusable = true}, SHIFT(8593),
  [11995] = {.count = 1, .reusable = true}, SHIFT(8594),
  [11997] = {.count = 1, .reusable = true}, SHIFT(8595),
  [11999] = {.count = 1, .reusable = true}, SHIFT(8596),
  [12001] = {.count = 1, .reusable = true}, SHIFT(8597),
  [12003] = {.count = 1, .reusable = false}, SHIFT(8598),
  [12005] = {.count = 1, .reusable = true}, SHIFT(8600),
  [12007] = {.count = 1, .reusable = true}, SHIFT(8601),
  [12009] = {.count = 1, .reusable = true}, SHIFT(8603),
  [12011] = {.count = 1, .reusable = false}, SHIFT(8604),
  [12013] = {.count = 1, .reusable = true}, SHIFT(8606),
  [12015] = {.count = 1, .reusable = true}, SHIFT(8607),
  [12017] = {.count = 1, .reusable = true}, SHIFT(8609),
  [12019] = {.count = 1, .reusable = true}, SHIFT(8612),
  [12021] = {.count = 1, .reusable = true}, SHIFT(8613),
  [12023] = {.count = 1, .reusable = true}, SHIFT(8614),
  [12025] = {.count = 1, .reusable = true}, SHIFT(8617),
  [12027] = {.count = 1, .reusable = true}, SHIFT(8619),
  [12029] = {.count = 1, .reusable = false}, SHIFT(8618),
  [12031] = {.count = 1, .reusable = true}, SHIFT(8620),
  [12033] = {.count = 1, .reusable = true}, SHIFT(8621),
  [12035] = {.count = 1, .reusable = true}, SHIFT(8622),
  [12037] = {.count = 1, .reusable = true}, SHIFT(8623),
  [12039] = {.count = 1, .reusable = true}, SHIFT(8625),
  [12041] = {.count = 1, .reusable = true}, SHIFT(8627),
  [12043] = {.count = 1, .reusable = true}, SHIFT(8628),
  [12045] = {.count = 1, .reusable = false}, SHIFT(8632),
  [12047] = {.count = 1, .reusable = true}, SHIFT(8633),
  [12049] = {.count = 1, .reusable = true}, SHIFT(8651),
  [12051] = {.count = 1, .reusable = true}, SHIFT(8652),
  [12053] = {.count = 1, .reusable = false}, SHIFT(8652),
  [12055] = {.count = 1, .reusable = true}, SHIFT(8654),
  [12057] = {.count = 1, .reusable = true}, SHIFT(8655),
  [12059] = {.count = 1, .reusable = true}, SHIFT(8656),
  [12061] = {.count = 1, .reusable = true}, SHIFT(8657),
  [12063] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(3891),
  [12066] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3893),
  [12069] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 6, .alias_sequence_id = 23),
  [12071] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 6, .alias_sequence_id = 23),
  [12073] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 6, .alias_sequence_id = 24),
  [12075] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 6, .alias_sequence_id = 24),
  [12077] = {.count = 1, .reusable = true}, SHIFT(8693),
  [12079] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3952),
  [12082] = {.count = 1, .reusable = true}, SHIFT(8711),
  [12084] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4005),
  [12087] = {.count = 1, .reusable = true}, SHIFT(8727),
  [12089] = {.count = 1, .reusable = true}, SHIFT(8728),
  [12091] = {.count = 1, .reusable = true}, SHIFT(4051),
  [12093] = {.count = 1, .reusable = true}, SHIFT(8749),
  [12095] = {.count = 1, .reusable = true}, SHIFT(4072),
  [12097] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4079),
  [12100] = {.count = 1, .reusable = true}, SHIFT(8759),
  [12102] = {.count = 1, .reusable = true}, SHIFT(8761),
  [12104] = {.count = 1, .reusable = true}, SHIFT(8776),
  [12106] = {.count = 1, .reusable = true}, SHIFT(8777),
  [12108] = {.count = 1, .reusable = false}, SHIFT(8777),
  [12110] = {.count = 1, .reusable = true}, SHIFT(8779),
  [12112] = {.count = 1, .reusable = true}, SHIFT(8780),
  [12114] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4142),
  [12117] = {.count = 1, .reusable = true}, SHIFT(6743),
  [12119] = {.count = 1, .reusable = true}, SHIFT(6753),
  [12121] = {.count = 1, .reusable = true}, SHIFT(8787),
  [12123] = {.count = 1, .reusable = true}, SHIFT(8789),
  [12125] = {.count = 1, .reusable = true}, SHIFT(8790),
  [12127] = {.count = 1, .reusable = true}, SHIFT(8791),
  [12129] = {.count = 1, .reusable = true}, SHIFT(8792),
  [12131] = {.count = 1, .reusable = true}, SHIFT(8793),
  [12133] = {.count = 1, .reusable = false}, SHIFT(8793),
  [12135] = {.count = 1, .reusable = true}, SHIFT(8795),
  [12137] = {.count = 1, .reusable = true}, SHIFT(8796),
  [12139] = {.count = 1, .reusable = true}, SHIFT(8797),
  [12141] = {.count = 1, .reusable = true}, SHIFT(8798),
  [12143] = {.count = 1, .reusable = true}, SHIFT(8799),
  [12145] = {.count = 1, .reusable = true}, SHIFT(8800),
  [12147] = {.count = 1, .reusable = true}, SHIFT(8801),
  [12149] = {.count = 1, .reusable = true}, SHIFT(8802),
  [12151] = {.count = 1, .reusable = false}, SHIFT(8803),
  [12153] = {.count = 1, .reusable = false}, SHIFT(8804),
  [12155] = {.count = 1, .reusable = true}, SHIFT(8805),
  [12157] = {.count = 1, .reusable = false}, SHIFT(8805),
  [12159] = {.count = 1, .reusable = true}, SHIFT(8808),
  [12161] = {.count = 1, .reusable = true}, SHIFT(8810),
  [12163] = {.count = 1, .reusable = true}, SHIFT(8811),
  [12165] = {.count = 1, .reusable = false}, SHIFT(8812),
  [12167] = {.count = 1, .reusable = true}, SHIFT(8814),
  [12169] = {.count = 1, .reusable = false}, SHIFT(8814),
  [12171] = {.count = 1, .reusable = true}, SHIFT(8816),
  [12173] = {.count = 1, .reusable = true}, SHIFT(8818),
  [12175] = {.count = 1, .reusable = true}, SHIFT(6823),
  [12177] = {.count = 1, .reusable = true}, SHIFT(8823),
  [12179] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(4307),
  [12182] = {.count = 1, .reusable = true}, SHIFT(8837),
  [12184] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4338),
  [12187] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 6),
  [12189] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 6),
  [12191] = {.count = 1, .reusable = true}, SHIFT(8855),
  [12193] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4383),
  [12196] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 4),
  [12198] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 4),
  [12200] = {.count = 1, .reusable = true}, SHIFT(8872),
  [12202] = {.count = 1, .reusable = true}, SHIFT(8873),
  [12204] = {.count = 1, .reusable = true}, SHIFT(8875),
  [12206] = {.count = 1, .reusable = true}, SHIFT(8877),
  [12208] = {.count = 1, .reusable = false}, SHIFT(8875),
  [12210] = {.count = 1, .reusable = true}, SHIFT(8879),
  [12212] = {.count = 1, .reusable = true}, SHIFT(8885),
  [12214] = {.count = 1, .reusable = false}, SHIFT(8887),
  [12216] = {.count = 1, .reusable = true}, SHIFT(8889),
  [12218] = {.count = 1, .reusable = false}, SHIFT(8885),
  [12220] = {.count = 1, .reusable = true}, SHIFT(4433),
  [12222] = {.count = 1, .reusable = true}, SHIFT(8911),
  [12224] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4452),
  [12227] = {.count = 1, .reusable = true}, SHIFT(8916),
  [12229] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4481),
  [12232] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4500),
  [12235] = {.count = 1, .reusable = true}, SHIFT(7023),
  [12237] = {.count = 1, .reusable = true}, SHIFT(8921),
  [12239] = {.count = 1, .reusable = true}, SHIFT(7041),
  [12241] = {.count = 1, .reusable = true}, SHIFT(8926),
  [12243] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(4561),
  [12246] = {.count = 1, .reusable = true}, SHIFT(8927),
  [12248] = {.count = 1, .reusable = true}, SHIFT(8928),
  [12250] = {.count = 1, .reusable = true}, SHIFT(4589),
  [12252] = {.count = 1, .reusable = true}, SHIFT(8936),
  [12254] = {.count = 1, .reusable = true}, SHIFT(8939),
  [12256] = {.count = 1, .reusable = true}, SHIFT(8940),
  [12258] = {.count = 1, .reusable = false}, SHIFT(8941),
  [12260] = {.count = 1, .reusable = false}, SHIFT(8940),
  [12262] = {.count = 1, .reusable = false}, SHIFT(8942),
  [12264] = {.count = 1, .reusable = false}, SHIFT(8943),
  [12266] = {.count = 1, .reusable = true}, SHIFT(8944),
  [12268] = {.count = 1, .reusable = false}, SHIFT(8945),
  [12270] = {.count = 1, .reusable = true}, SHIFT(8945),
  [12272] = {.count = 1, .reusable = false}, SHIFT(8947),
  [12274] = {.count = 1, .reusable = false}, SHIFT(8948),
  [12276] = {.count = 1, .reusable = true}, SHIFT(8947),
  [12278] = {.count = 1, .reusable = true}, SHIFT(8943),
  [12280] = {.count = 1, .reusable = false}, SHIFT(8939),
  [12282] = {.count = 1, .reusable = true}, SHIFT(8949),
  [12284] = {.count = 1, .reusable = false}, SHIFT(8949),
  [12286] = {.count = 1, .reusable = true}, SHIFT(8950),
  [12288] = {.count = 1, .reusable = true}, SHIFT(4609),
  [12290] = {.count = 1, .reusable = true}, SHIFT(8960),
  [12292] = {.count = 1, .reusable = true}, SHIFT(8962),
  [12294] = {.count = 1, .reusable = true}, SHIFT(8963),
  [12296] = {.count = 1, .reusable = true}, SHIFT(8964),
  [12298] = {.count = 1, .reusable = true}, SHIFT(8965),
  [12300] = {.count = 1, .reusable = true}, SHIFT(8966),
  [12302] = {.count = 1, .reusable = false}, SHIFT(8966),
  [12304] = {.count = 1, .reusable = true}, SHIFT(8968),
  [12306] = {.count = 1, .reusable = true}, SHIFT(8969),
  [12308] = {.count = 1, .reusable = true}, SHIFT(8970),
  [12310] = {.count = 1, .reusable = true}, SHIFT(8971),
  [12312] = {.count = 1, .reusable = true}, SHIFT(8973),
  [12314] = {.count = 1, .reusable = true}, SHIFT(8974),
  [12316] = {.count = 1, .reusable = true}, SHIFT(8975),
  [12318] = {.count = 1, .reusable = true}, SHIFT(8976),
  [12320] = {.count = 1, .reusable = true}, SHIFT(8977),
  [12322] = {.count = 1, .reusable = true}, SHIFT(8979),
  [12324] = {.count = 1, .reusable = true}, SHIFT(8980),
  [12326] = {.count = 1, .reusable = true}, SHIFT(8981),
  [12328] = {.count = 1, .reusable = true}, SHIFT(8982),
  [12330] = {.count = 1, .reusable = true}, SHIFT(4681),
  [12332] = {.count = 1, .reusable = false}, SHIFT(8984),
  [12334] = {.count = 1, .reusable = true}, SHIFT(8985),
  [12336] = {.count = 1, .reusable = true}, SHIFT(8986),
  [12338] = {.count = 1, .reusable = false}, SHIFT(8987),
  [12340] = {.count = 1, .reusable = false}, SHIFT(8988),
  [12342] = {.count = 1, .reusable = true}, SHIFT(8990),
  [12344] = {.count = 1, .reusable = true}, SHIFT(8994),
  [12346] = {.count = 1, .reusable = true}, SHIFT(8993),
  [12348] = {.count = 1, .reusable = true}, SHIFT(4692),
  [12350] = {.count = 1, .reusable = true}, SHIFT(9003),
  [12352] = {.count = 1, .reusable = false}, SHIFT(9000),
  [12354] = {.count = 1, .reusable = false}, SHIFT(9004),
  [12356] = {.count = 1, .reusable = false}, SHIFT(9007),
  [12358] = {.count = 1, .reusable = false}, SHIFT(9009),
  [12360] = {.count = 1, .reusable = true}, SHIFT(9011),
  [12362] = {.count = 1, .reusable = true}, SHIFT(9013),
  [12364] = {.count = 1, .reusable = true}, SHIFT(9014),
  [12366] = {.count = 1, .reusable = true}, SHIFT(9015),
  [12368] = {.count = 1, .reusable = true}, SHIFT(9018),
  [12370] = {.count = 1, .reusable = true}, SHIFT(9019),
  [12372] = {.count = 1, .reusable = true}, SHIFT(9021),
  [12374] = {.count = 1, .reusable = true}, SHIFT(9023),
  [12376] = {.count = 1, .reusable = false}, SHIFT(9021),
  [12378] = {.count = 1, .reusable = true}, SHIFT(9025),
  [12380] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2307),
  [12383] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4748),
  [12386] = {.count = 1, .reusable = true}, SHIFT(7213),
  [12388] = {.count = 1, .reusable = true}, SHIFT(4775),
  [12390] = {.count = 1, .reusable = true}, SHIFT(9036),
  [12392] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4802),
  [12395] = {.count = 1, .reusable = true}, SHIFT(7244),
  [12397] = {.count = 1, .reusable = true}, SHIFT(7249),
  [12399] = {.count = 1, .reusable = true}, SHIFT(9045),
  [12401] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4869),
  [12404] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4888),
  [12407] = {.count = 1, .reusable = true}, SHIFT(7282),
  [12409] = {.count = 1, .reusable = false}, REDUCE(sym_conditional, 5),
  [12411] = {.count = 1, .reusable = true}, SHIFT(9051),
  [12413] = {.count = 1, .reusable = true}, SHIFT(9052),
  [12415] = {.count = 1, .reusable = false}, SHIFT(9052),
  [12417] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(4925),
  [12420] = {.count = 1, .reusable = true}, SHIFT(9056),
  [12422] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4951),
  [12425] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4970),
  [12428] = {.count = 1, .reusable = true}, SHIFT(7327),
  [12430] = {.count = 1, .reusable = true}, SHIFT(9065),
  [12432] = {.count = 1, .reusable = true}, SHIFT(9066),
  [12434] = {.count = 1, .reusable = false}, SHIFT(9067),
  [12436] = {.count = 1, .reusable = false}, SHIFT(9068),
  [12438] = {.count = 1, .reusable = false}, SHIFT(9069),
  [12440] = {.count = 1, .reusable = true}, SHIFT(9070),
  [12442] = {.count = 1, .reusable = false}, SHIFT(9071),
  [12444] = {.count = 1, .reusable = true}, SHIFT(9071),
  [12446] = {.count = 1, .reusable = true}, SHIFT(9073),
  [12448] = {.count = 1, .reusable = true}, SHIFT(9074),
  [12450] = {.count = 1, .reusable = false}, SHIFT(9073),
  [12452] = {.count = 1, .reusable = true}, SHIFT(9069),
  [12454] = {.count = 1, .reusable = true}, SHIFT(9067),
  [12456] = {.count = 1, .reusable = true}, SHIFT(9075),
  [12458] = {.count = 1, .reusable = false}, SHIFT(9075),
  [12460] = {.count = 1, .reusable = true}, SHIFT(9076),
  [12462] = {.count = 1, .reusable = true}, SHIFT(9081),
  [12464] = {.count = 1, .reusable = false}, SHIFT(9083),
  [12466] = {.count = 1, .reusable = true}, SHIFT(9085),
  [12468] = {.count = 1, .reusable = false}, SHIFT(9081),
  [12470] = {.count = 1, .reusable = true}, SHIFT(9100),
  [12472] = {.count = 1, .reusable = false}, SHIFT(9102),
  [12474] = {.count = 1, .reusable = true}, SHIFT(9104),
  [12476] = {.count = 1, .reusable = false}, SHIFT(9100),
  [12478] = {.count = 1, .reusable = true}, SHIFT(4987),
  [12480] = {.count = 1, .reusable = false}, REDUCE(sym_elsif, 3),
  [12482] = {.count = 1, .reusable = true}, REDUCE(sym_if, 6),
  [12484] = {.count = 1, .reusable = false}, REDUCE(sym_if, 6),
  [12486] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9117),
  [12489] = {.count = 1, .reusable = true}, SHIFT(9118),
  [12491] = {.count = 1, .reusable = true}, SHIFT(9121),
  [12493] = {.count = 1, .reusable = true}, SHIFT(9122),
  [12495] = {.count = 1, .reusable = false}, SHIFT(9123),
  [12497] = {.count = 1, .reusable = false}, SHIFT(9122),
  [12499] = {.count = 1, .reusable = false}, SHIFT(9124),
  [12501] = {.count = 1, .reusable = false}, SHIFT(9125),
  [12503] = {.count = 1, .reusable = true}, SHIFT(9126),
  [12505] = {.count = 1, .reusable = false}, SHIFT(9127),
  [12507] = {.count = 1, .reusable = true}, SHIFT(9127),
  [12509] = {.count = 1, .reusable = false}, SHIFT(9129),
  [12511] = {.count = 1, .reusable = false}, SHIFT(9130),
  [12513] = {.count = 1, .reusable = true}, SHIFT(9129),
  [12515] = {.count = 1, .reusable = true}, SHIFT(9125),
  [12517] = {.count = 1, .reusable = false}, SHIFT(9121),
  [12519] = {.count = 1, .reusable = true}, SHIFT(9131),
  [12521] = {.count = 1, .reusable = false}, SHIFT(9131),
  [12523] = {.count = 1, .reusable = true}, SHIFT(9132),
  [12525] = {.count = 1, .reusable = true}, SHIFT(5029),
  [12527] = {.count = 1, .reusable = true}, SHIFT(9157),
  [12529] = {.count = 1, .reusable = true}, SHIFT(9158),
  [12531] = {.count = 1, .reusable = false}, SHIFT(9159),
  [12533] = {.count = 1, .reusable = false}, SHIFT(9160),
  [12535] = {.count = 1, .reusable = false}, SHIFT(9161),
  [12537] = {.count = 1, .reusable = true}, SHIFT(9162),
  [12539] = {.count = 1, .reusable = false}, SHIFT(9163),
  [12541] = {.count = 1, .reusable = true}, SHIFT(9163),
  [12543] = {.count = 1, .reusable = true}, SHIFT(9165),
  [12545] = {.count = 1, .reusable = true}, SHIFT(9166),
  [12547] = {.count = 1, .reusable = false}, SHIFT(9165),
  [12549] = {.count = 1, .reusable = true}, SHIFT(9161),
  [12551] = {.count = 1, .reusable = true}, SHIFT(9159),
  [12553] = {.count = 1, .reusable = true}, SHIFT(9167),
  [12555] = {.count = 1, .reusable = true}, SHIFT(9169),
  [12557] = {.count = 1, .reusable = false}, SHIFT(9169),
  [12559] = {.count = 1, .reusable = true}, SHIFT(9170),
  [12561] = {.count = 1, .reusable = true}, SHIFT(9171),
  [12563] = {.count = 1, .reusable = true}, SHIFT(9172),
  [12565] = {.count = 1, .reusable = true}, SHIFT(7463),
  [12567] = {.count = 1, .reusable = true}, SHIFT(9177),
  [12569] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5097),
  [12572] = {.count = 1, .reusable = true}, SHIFT(9182),
  [12574] = {.count = 1, .reusable = true}, SHIFT(9183),
  [12576] = {.count = 1, .reusable = false}, SHIFT(9184),
  [12578] = {.count = 1, .reusable = false}, SHIFT(9185),
  [12580] = {.count = 1, .reusable = false}, SHIFT(9186),
  [12582] = {.count = 1, .reusable = true}, SHIFT(9187),
  [12584] = {.count = 1, .reusable = false}, SHIFT(9188),
  [12586] = {.count = 1, .reusable = true}, SHIFT(9188),
  [12588] = {.count = 1, .reusable = true}, SHIFT(9190),
  [12590] = {.count = 1, .reusable = true}, SHIFT(9191),
  [12592] = {.count = 1, .reusable = false}, SHIFT(9190),
  [12594] = {.count = 1, .reusable = true}, SHIFT(9186),
  [12596] = {.count = 1, .reusable = true}, SHIFT(9184),
  [12598] = {.count = 1, .reusable = true}, SHIFT(9192),
  [12600] = {.count = 1, .reusable = false}, SHIFT(9192),
  [12602] = {.count = 1, .reusable = true}, SHIFT(9193),
  [12604] = {.count = 1, .reusable = true}, SHIFT(9198),
  [12606] = {.count = 1, .reusable = false}, SHIFT(9200),
  [12608] = {.count = 1, .reusable = true}, SHIFT(9202),
  [12610] = {.count = 1, .reusable = false}, SHIFT(9198),
  [12612] = {.count = 1, .reusable = true}, SHIFT(9217),
  [12614] = {.count = 1, .reusable = false}, SHIFT(9219),
  [12616] = {.count = 1, .reusable = true}, SHIFT(9221),
  [12618] = {.count = 1, .reusable = false}, SHIFT(9217),
  [12620] = {.count = 1, .reusable = true}, SHIFT(5106),
  [12622] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 6),
  [12624] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 6),
  [12626] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9232),
  [12629] = {.count = 1, .reusable = true}, SHIFT(9233),
  [12631] = {.count = 1, .reusable = true}, SHIFT(9236),
  [12633] = {.count = 1, .reusable = true}, SHIFT(9237),
  [12635] = {.count = 1, .reusable = false}, SHIFT(9238),
  [12637] = {.count = 1, .reusable = false}, SHIFT(9237),
  [12639] = {.count = 1, .reusable = false}, SHIFT(9239),
  [12641] = {.count = 1, .reusable = false}, SHIFT(9240),
  [12643] = {.count = 1, .reusable = true}, SHIFT(9241),
  [12645] = {.count = 1, .reusable = false}, SHIFT(9242),
  [12647] = {.count = 1, .reusable = true}, SHIFT(9242),
  [12649] = {.count = 1, .reusable = false}, SHIFT(9244),
  [12651] = {.count = 1, .reusable = false}, SHIFT(9245),
  [12653] = {.count = 1, .reusable = true}, SHIFT(9244),
  [12655] = {.count = 1, .reusable = true}, SHIFT(9240),
  [12657] = {.count = 1, .reusable = false}, SHIFT(9236),
  [12659] = {.count = 1, .reusable = true}, SHIFT(9246),
  [12661] = {.count = 1, .reusable = false}, SHIFT(9246),
  [12663] = {.count = 1, .reusable = true}, SHIFT(9247),
  [12665] = {.count = 1, .reusable = true}, SHIFT(5146),
  [12667] = {.count = 1, .reusable = true}, SHIFT(9272),
  [12669] = {.count = 1, .reusable = true}, SHIFT(9273),
  [12671] = {.count = 1, .reusable = false}, SHIFT(9274),
  [12673] = {.count = 1, .reusable = false}, SHIFT(9275),
  [12675] = {.count = 1, .reusable = false}, SHIFT(9276),
  [12677] = {.count = 1, .reusable = true}, SHIFT(9277),
  [12679] = {.count = 1, .reusable = false}, SHIFT(9278),
  [12681] = {.count = 1, .reusable = true}, SHIFT(9278),
  [12683] = {.count = 1, .reusable = true}, SHIFT(9280),
  [12685] = {.count = 1, .reusable = true}, SHIFT(9281),
  [12687] = {.count = 1, .reusable = false}, SHIFT(9280),
  [12689] = {.count = 1, .reusable = true}, SHIFT(9276),
  [12691] = {.count = 1, .reusable = true}, SHIFT(9274),
  [12693] = {.count = 1, .reusable = true}, SHIFT(9282),
  [12695] = {.count = 1, .reusable = true}, SHIFT(9284),
  [12697] = {.count = 1, .reusable = false}, SHIFT(9284),
  [12699] = {.count = 1, .reusable = true}, SHIFT(9285),
  [12701] = {.count = 1, .reusable = true}, SHIFT(9288),
  [12703] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5188),
  [12706] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5208),
  [12709] = {.count = 1, .reusable = true}, SHIFT(7623),
  [12711] = {.count = 1, .reusable = true}, SHIFT(9293),
  [12713] = {.count = 1, .reusable = true}, SHIFT(7641),
  [12715] = {.count = 1, .reusable = true}, SHIFT(9298),
  [12717] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5268),
  [12720] = {.count = 1, .reusable = true}, SHIFT(5277),
  [12722] = {.count = 1, .reusable = true}, SHIFT(9305),
  [12724] = {.count = 1, .reusable = true}, SHIFT(9308),
  [12726] = {.count = 1, .reusable = true}, SHIFT(9309),
  [12728] = {.count = 1, .reusable = false}, SHIFT(9310),
  [12730] = {.count = 1, .reusable = false}, SHIFT(9309),
  [12732] = {.count = 1, .reusable = false}, SHIFT(9311),
  [12734] = {.count = 1, .reusable = false}, SHIFT(9312),
  [12736] = {.count = 1, .reusable = true}, SHIFT(9313),
  [12738] = {.count = 1, .reusable = false}, SHIFT(9314),
  [12740] = {.count = 1, .reusable = true}, SHIFT(9314),
  [12742] = {.count = 1, .reusable = false}, SHIFT(9316),
  [12744] = {.count = 1, .reusable = false}, SHIFT(9317),
  [12746] = {.count = 1, .reusable = true}, SHIFT(9316),
  [12748] = {.count = 1, .reusable = true}, SHIFT(9312),
  [12750] = {.count = 1, .reusable = false}, SHIFT(9308),
  [12752] = {.count = 1, .reusable = true}, SHIFT(9318),
  [12754] = {.count = 1, .reusable = false}, SHIFT(9318),
  [12756] = {.count = 1, .reusable = true}, SHIFT(9319),
  [12758] = {.count = 1, .reusable = true}, SHIFT(5297),
  [12760] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5313),
  [12763] = {.count = 1, .reusable = true}, SHIFT(9330),
  [12765] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5345),
  [12768] = {.count = 1, .reusable = true}, SHIFT(7723),
  [12770] = {.count = 1, .reusable = true}, REDUCE(sym_for, 6),
  [12772] = {.count = 1, .reusable = false}, REDUCE(sym_for, 6),
  [12774] = {.count = 1, .reusable = true}, SHIFT(9336),
  [12776] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5384),
  [12779] = {.count = 1, .reusable = true}, SHIFT(7749),
  [12781] = {.count = 1, .reusable = true}, REDUCE(sym_case, 6),
  [12783] = {.count = 1, .reusable = false}, REDUCE(sym_case, 6),
  [12785] = {.count = 1, .reusable = true}, SHIFT(9341),
  [12787] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5421),
  [12790] = {.count = 1, .reusable = true}, SHIFT(9344),
  [12792] = {.count = 1, .reusable = true}, SHIFT(9345),
  [12794] = {.count = 1, .reusable = false}, SHIFT(9346),
  [12796] = {.count = 1, .reusable = false}, SHIFT(9347),
  [12798] = {.count = 1, .reusable = false}, SHIFT(9348),
  [12800] = {.count = 1, .reusable = true}, SHIFT(9349),
  [12802] = {.count = 1, .reusable = false}, SHIFT(9350),
  [12804] = {.count = 1, .reusable = true}, SHIFT(9350),
  [12806] = {.count = 1, .reusable = true}, SHIFT(9352),
  [12808] = {.count = 1, .reusable = true}, SHIFT(9353),
  [12810] = {.count = 1, .reusable = false}, SHIFT(9352),
  [12812] = {.count = 1, .reusable = true}, SHIFT(9348),
  [12814] = {.count = 1, .reusable = true}, SHIFT(9346),
  [12816] = {.count = 1, .reusable = true}, SHIFT(9354),
  [12818] = {.count = 1, .reusable = false}, SHIFT(9354),
  [12820] = {.count = 1, .reusable = true}, SHIFT(9355),
  [12822] = {.count = 1, .reusable = true}, SHIFT(5430),
  [12824] = {.count = 1, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2),
  [12826] = {.count = 1, .reusable = true}, SHIFT(9363),
  [12828] = {.count = 1, .reusable = true}, SHIFT(9364),
  [12830] = {.count = 1, .reusable = true}, SHIFT(9365),
  [12832] = {.count = 1, .reusable = true}, SHIFT(9366),
  [12834] = {.count = 1, .reusable = false}, SHIFT(9368),
  [12836] = {.count = 1, .reusable = false}, SHIFT(9369),
  [12838] = {.count = 1, .reusable = false}, SHIFT(9370),
  [12840] = {.count = 1, .reusable = false}, SHIFT(9371),
  [12842] = {.count = 1, .reusable = true}, SHIFT(9372),
  [12844] = {.count = 1, .reusable = false}, SHIFT(9372),
  [12846] = {.count = 1, .reusable = false}, SHIFT(9373),
  [12848] = {.count = 1, .reusable = true}, SHIFT(9373),
  [12850] = {.count = 1, .reusable = false}, SHIFT(9374),
  [12852] = {.count = 1, .reusable = true}, SHIFT(9376),
  [12854] = {.count = 1, .reusable = false}, SHIFT(9376),
  [12856] = {.count = 1, .reusable = true}, SHIFT(9383),
  [12858] = {.count = 1, .reusable = true}, REDUCE(sym_when, 4),
  [12860] = {.count = 1, .reusable = true}, SHIFT(9385),
  [12862] = {.count = 1, .reusable = true}, SHIFT(9387),
  [12864] = {.count = 1, .reusable = true}, SHIFT(9388),
  [12866] = {.count = 1, .reusable = true}, SHIFT(9389),
  [12868] = {.count = 1, .reusable = true}, SHIFT(9390),
  [12870] = {.count = 1, .reusable = true}, SHIFT(9391),
  [12872] = {.count = 1, .reusable = true}, SHIFT(9392),
  [12874] = {.count = 1, .reusable = true}, SHIFT(9393),
  [12876] = {.count = 1, .reusable = false}, SHIFT(9394),
  [12878] = {.count = 1, .reusable = false}, SHIFT(9395),
  [12880] = {.count = 1, .reusable = false}, SHIFT(9396),
  [12882] = {.count = 1, .reusable = true}, SHIFT(9397),
  [12884] = {.count = 1, .reusable = false}, SHIFT(9398),
  [12886] = {.count = 1, .reusable = true}, SHIFT(9398),
  [12888] = {.count = 1, .reusable = true}, SHIFT(9399),
  [12890] = {.count = 1, .reusable = true}, SHIFT(9400),
  [12892] = {.count = 1, .reusable = true}, SHIFT(9401),
  [12894] = {.count = 1, .reusable = false}, SHIFT(9400),
  [12896] = {.count = 1, .reusable = true}, SHIFT(9396),
  [12898] = {.count = 1, .reusable = true}, SHIFT(9394),
  [12900] = {.count = 1, .reusable = true}, SHIFT(9402),
  [12902] = {.count = 1, .reusable = true}, SHIFT(9403),
  [12904] = {.count = 1, .reusable = true}, SHIFT(9404),
  [12906] = {.count = 1, .reusable = true}, SHIFT(9405),
  [12908] = {.count = 1, .reusable = false}, SHIFT(9407),
  [12910] = {.count = 1, .reusable = false}, SHIFT(9408),
  [12912] = {.count = 1, .reusable = false}, SHIFT(9409),
  [12914] = {.count = 1, .reusable = false}, SHIFT(9410),
  [12916] = {.count = 1, .reusable = true}, SHIFT(9411),
  [12918] = {.count = 1, .reusable = false}, SHIFT(9411),
  [12920] = {.count = 1, .reusable = false}, SHIFT(9412),
  [12922] = {.count = 1, .reusable = true}, SHIFT(9412),
  [12924] = {.count = 1, .reusable = false}, SHIFT(9413),
  [12926] = {.count = 1, .reusable = true}, SHIFT(9415),
  [12928] = {.count = 1, .reusable = false}, SHIFT(9415),
  [12930] = {.count = 1, .reusable = true}, SHIFT(9421),
  [12932] = {.count = 1, .reusable = false}, SHIFT(9421),
  [12934] = {.count = 1, .reusable = true}, SHIFT(9422),
  [12936] = {.count = 1, .reusable = false}, REDUCE(sym_when, 4),
  [12938] = {.count = 2, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2), SHIFT_REPEAT(5437),
  [12941] = {.count = 1, .reusable = true}, SHIFT(9425),
  [12943] = {.count = 1, .reusable = true}, SHIFT(9428),
  [12945] = {.count = 1, .reusable = true}, SHIFT(9429),
  [12947] = {.count = 1, .reusable = false}, SHIFT(9430),
  [12949] = {.count = 1, .reusable = false}, SHIFT(9429),
  [12951] = {.count = 1, .reusable = false}, SHIFT(9431),
  [12953] = {.count = 1, .reusable = false}, SHIFT(9432),
  [12955] = {.count = 1, .reusable = true}, SHIFT(9433),
  [12957] = {.count = 1, .reusable = false}, SHIFT(9434),
  [12959] = {.count = 1, .reusable = true}, SHIFT(9434),
  [12961] = {.count = 1, .reusable = false}, SHIFT(9436),
  [12963] = {.count = 1, .reusable = false}, SHIFT(9437),
  [12965] = {.count = 1, .reusable = true}, SHIFT(9436),
  [12967] = {.count = 1, .reusable = true}, SHIFT(9432),
  [12969] = {.count = 1, .reusable = false}, SHIFT(9428),
  [12971] = {.count = 1, .reusable = true}, SHIFT(9438),
  [12973] = {.count = 1, .reusable = false}, SHIFT(9438),
  [12975] = {.count = 1, .reusable = true}, SHIFT(9439),
  [12977] = {.count = 1, .reusable = true}, SHIFT(5453),
  [12979] = {.count = 1, .reusable = true}, SHIFT(9452),
  [12981] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5486),
  [12984] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5505),
  [12987] = {.count = 1, .reusable = true}, SHIFT(7862),
  [12989] = {.count = 1, .reusable = true}, SHIFT(9457),
  [12991] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5533),
  [12994] = {.count = 1, .reusable = true}, SHIFT(9460),
  [12996] = {.count = 1, .reusable = true}, SHIFT(9463),
  [12998] = {.count = 1, .reusable = true}, SHIFT(9464),
  [13000] = {.count = 1, .reusable = true}, SHIFT(9467),
  [13002] = {.count = 1, .reusable = true}, SHIFT(9468),
  [13004] = {.count = 1, .reusable = true}, SHIFT(9469),
  [13006] = {.count = 1, .reusable = false}, SHIFT(9471),
  [13008] = {.count = 1, .reusable = true}, SHIFT(9477),
  [13010] = {.count = 1, .reusable = true}, SHIFT(9478),
  [13012] = {.count = 1, .reusable = false}, SHIFT(9479),
  [13014] = {.count = 1, .reusable = false}, SHIFT(9480),
  [13016] = {.count = 1, .reusable = false}, SHIFT(9481),
  [13018] = {.count = 1, .reusable = true}, SHIFT(9482),
  [13020] = {.count = 1, .reusable = false}, SHIFT(9483),
  [13022] = {.count = 1, .reusable = true}, SHIFT(9483),
  [13024] = {.count = 1, .reusable = true}, SHIFT(9484),
  [13026] = {.count = 1, .reusable = true}, SHIFT(9485),
  [13028] = {.count = 1, .reusable = true}, SHIFT(9486),
  [13030] = {.count = 1, .reusable = false}, SHIFT(9485),
  [13032] = {.count = 1, .reusable = true}, SHIFT(9481),
  [13034] = {.count = 1, .reusable = true}, SHIFT(9479),
  [13036] = {.count = 1, .reusable = true}, SHIFT(9487),
  [13038] = {.count = 1, .reusable = false}, SHIFT(9487),
  [13040] = {.count = 1, .reusable = true}, SHIFT(9488),
  [13042] = {.count = 1, .reusable = true}, SHIFT(9493),
  [13044] = {.count = 1, .reusable = false}, SHIFT(9495),
  [13046] = {.count = 1, .reusable = true}, SHIFT(9497),
  [13048] = {.count = 1, .reusable = false}, SHIFT(9493),
  [13050] = {.count = 1, .reusable = true}, SHIFT(9499),
  [13052] = {.count = 1, .reusable = true}, SHIFT(9513),
  [13054] = {.count = 1, .reusable = true}, SHIFT(9512),
  [13056] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 5),
  [13058] = {.count = 1, .reusable = true}, SHIFT(9525),
  [13060] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5593),
  [13063] = {.count = 1, .reusable = true}, SHIFT(7964),
  [13065] = {.count = 1, .reusable = true}, SHIFT(5624),
  [13067] = {.count = 1, .reusable = true}, SHIFT(9551),
  [13069] = {.count = 1, .reusable = true}, SHIFT(5645),
  [13071] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5652),
  [13074] = {.count = 1, .reusable = true}, SHIFT(9575),
  [13076] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5705),
  [13079] = {.count = 1, .reusable = true}, SHIFT(5739),
  [13081] = {.count = 1, .reusable = true}, SHIFT(9613),
  [13083] = {.count = 1, .reusable = true}, SHIFT(5760),
  [13085] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5767),
  [13088] = {.count = 1, .reusable = true}, SHIFT(9637),
  [13090] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5820),
  [13093] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 5),
  [13095] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 5),
  [13097] = {.count = 1, .reusable = true}, SHIFT(9653),
  [13099] = {.count = 1, .reusable = true}, SHIFT(8199),
  [13101] = {.count = 1, .reusable = true}, SHIFT(9658),
  [13103] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5888),
  [13106] = {.count = 1, .reusable = true}, SHIFT(9659),
  [13108] = {.count = 1, .reusable = true}, SHIFT(9660),
  [13110] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5915),
  [13113] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5944),
  [13116] = {.count = 1, .reusable = true}, SHIFT(8263),
  [13118] = {.count = 1, .reusable = true}, SHIFT(8269),
  [13120] = {.count = 1, .reusable = true}, SHIFT(9693),
  [13122] = {.count = 1, .reusable = true}, SHIFT(9695),
  [13124] = {.count = 1, .reusable = true}, SHIFT(9696),
  [13126] = {.count = 1, .reusable = true}, SHIFT(9697),
  [13128] = {.count = 1, .reusable = true}, SHIFT(9698),
  [13130] = {.count = 1, .reusable = true}, SHIFT(9699),
  [13132] = {.count = 1, .reusable = false}, SHIFT(9699),
  [13134] = {.count = 1, .reusable = true}, SHIFT(9701),
  [13136] = {.count = 1, .reusable = true}, SHIFT(9702),
  [13138] = {.count = 1, .reusable = false}, SHIFT(9702),
  [13140] = {.count = 1, .reusable = true}, SHIFT(8297),
  [13142] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6040),
  [13145] = {.count = 1, .reusable = true}, SHIFT(9706),
  [13147] = {.count = 1, .reusable = true}, SHIFT(9708),
  [13149] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 4),
  [13151] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 4),
  [13153] = {.count = 1, .reusable = true}, SHIFT(9711),
  [13155] = {.count = 1, .reusable = true}, SHIFT(9712),
  [13157] = {.count = 1, .reusable = true}, SHIFT(9713),
  [13159] = {.count = 1, .reusable = true}, SHIFT(9714),
  [13161] = {.count = 1, .reusable = false}, SHIFT(9716),
  [13163] = {.count = 1, .reusable = false}, SHIFT(9717),
  [13165] = {.count = 1, .reusable = false}, SHIFT(9718),
  [13167] = {.count = 1, .reusable = false}, SHIFT(9719),
  [13169] = {.count = 1, .reusable = true}, SHIFT(9720),
  [13171] = {.count = 1, .reusable = false}, SHIFT(9720),
  [13173] = {.count = 1, .reusable = false}, SHIFT(9721),
  [13175] = {.count = 1, .reusable = true}, SHIFT(9721),
  [13177] = {.count = 1, .reusable = false}, SHIFT(9722),
  [13179] = {.count = 1, .reusable = true}, SHIFT(9724),
  [13181] = {.count = 1, .reusable = false}, SHIFT(9724),
  [13183] = {.count = 1, .reusable = true}, SHIFT(9731),
  [13185] = {.count = 1, .reusable = true}, SHIFT(9732),
  [13187] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 3),
  [13189] = {.count = 1, .reusable = false}, SHIFT(9734),
  [13191] = {.count = 1, .reusable = false}, SHIFT(9735),
  [13193] = {.count = 1, .reusable = true}, SHIFT(9736),
  [13195] = {.count = 1, .reusable = false}, SHIFT(9737),
  [13197] = {.count = 1, .reusable = true}, SHIFT(9737),
  [13199] = {.count = 1, .reusable = true}, SHIFT(9738),
  [13201] = {.count = 1, .reusable = true}, SHIFT(9739),
  [13203] = {.count = 1, .reusable = true}, SHIFT(9740),
  [13205] = {.count = 1, .reusable = false}, SHIFT(9739),
  [13207] = {.count = 1, .reusable = true}, SHIFT(9735),
  [13209] = {.count = 1, .reusable = true}, SHIFT(9733),
  [13211] = {.count = 1, .reusable = true}, SHIFT(9741),
  [13213] = {.count = 1, .reusable = true}, SHIFT(9742),
  [13215] = {.count = 1, .reusable = true}, SHIFT(9743),
  [13217] = {.count = 1, .reusable = true}, SHIFT(9744),
  [13219] = {.count = 1, .reusable = false}, SHIFT(9746),
  [13221] = {.count = 1, .reusable = false}, SHIFT(9747),
  [13223] = {.count = 1, .reusable = false}, SHIFT(9748),
  [13225] = {.count = 1, .reusable = false}, SHIFT(9749),
  [13227] = {.count = 1, .reusable = true}, SHIFT(9750),
  [13229] = {.count = 1, .reusable = false}, SHIFT(9750),
  [13231] = {.count = 1, .reusable = false}, SHIFT(9751),
  [13233] = {.count = 1, .reusable = true}, SHIFT(9751),
  [13235] = {.count = 1, .reusable = false}, SHIFT(9752),
  [13237] = {.count = 1, .reusable = true}, SHIFT(9754),
  [13239] = {.count = 1, .reusable = false}, SHIFT(9754),
  [13241] = {.count = 1, .reusable = true}, SHIFT(9760),
  [13243] = {.count = 1, .reusable = false}, SHIFT(9760),
  [13245] = {.count = 1, .reusable = true}, SHIFT(9761),
  [13247] = {.count = 1, .reusable = false}, REDUCE(sym_optional_parameter, 3),
  [13249] = {.count = 1, .reusable = true}, SHIFT(9763),
  [13251] = {.count = 1, .reusable = true}, SHIFT(9764),
  [13253] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(9765),
  [13256] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_parameter, 4),
  [13258] = {.count = 1, .reusable = true}, SHIFT(9766),
  [13260] = {.count = 1, .reusable = true}, SHIFT(9768),
  [13262] = {.count = 1, .reusable = true}, SHIFT(9769),
  [13264] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 5),
  [13266] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 5),
  [13268] = {.count = 1, .reusable = true}, SHIFT(9770),
  [13270] = {.count = 1, .reusable = true}, SHIFT(9771),
  [13272] = {.count = 1, .reusable = true}, SHIFT(9791),
  [13274] = {.count = 1, .reusable = true}, SHIFT(6104),
  [13276] = {.count = 1, .reusable = true}, SHIFT(9798),
  [13278] = {.count = 1, .reusable = true}, SHIFT(6125),
  [13280] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6132),
  [13283] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(6096),
  [13286] = {.count = 1, .reusable = true}, SHIFT(9822),
  [13288] = {.count = 1, .reusable = true}, SHIFT(9823),
  [13290] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6179),
  [13293] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(6161),
  [13296] = {.count = 1, .reusable = true}, SHIFT(9840),
  [13298] = {.count = 1, .reusable = true}, SHIFT(9841),
  [13300] = {.count = 1, .reusable = true}, SHIFT(9842),
  [13302] = {.count = 1, .reusable = true}, SHIFT(9843),
  [13304] = {.count = 1, .reusable = true}, SHIFT(9844),
  [13306] = {.count = 1, .reusable = true}, SHIFT(9845),
  [13308] = {.count = 1, .reusable = true}, SHIFT(9846),
  [13310] = {.count = 1, .reusable = true}, SHIFT(9847),
  [13312] = {.count = 1, .reusable = true}, SHIFT(9848),
  [13314] = {.count = 1, .reusable = false}, SHIFT(9849),
  [13316] = {.count = 1, .reusable = false}, SHIFT(9850),
  [13318] = {.count = 1, .reusable = true}, SHIFT(9851),
  [13320] = {.count = 1, .reusable = false}, SHIFT(9851),
  [13322] = {.count = 1, .reusable = true}, SHIFT(9854),
  [13324] = {.count = 1, .reusable = true}, SHIFT(9856),
  [13326] = {.count = 1, .reusable = true}, SHIFT(9857),
  [13328] = {.count = 1, .reusable = false}, SHIFT(9858),
  [13330] = {.count = 1, .reusable = true}, SHIFT(9860),
  [13332] = {.count = 1, .reusable = true}, SHIFT(9862),
  [13334] = {.count = 1, .reusable = true}, SHIFT(8504),
  [13336] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6280),
  [13339] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6299),
  [13342] = {.count = 1, .reusable = true}, SHIFT(9882),
  [13344] = {.count = 1, .reusable = true}, SHIFT(9884),
  [13346] = {.count = 1, .reusable = true}, SHIFT(9885),
  [13348] = {.count = 1, .reusable = true}, SHIFT(9886),
  [13350] = {.count = 1, .reusable = true}, SHIFT(9887),
  [13352] = {.count = 1, .reusable = true}, SHIFT(9888),
  [13354] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6345),
  [13357] = {.count = 1, .reusable = true}, SHIFT(9892),
  [13359] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6385),
  [13362] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6404),
  [13365] = {.count = 1, .reusable = true}, SHIFT(8587),
  [13367] = {.count = 1, .reusable = true}, SHIFT(9897),
  [13369] = {.count = 1, .reusable = true}, SHIFT(9898),
  [13371] = {.count = 1, .reusable = true}, SHIFT(9899),
  [13373] = {.count = 1, .reusable = true}, SHIFT(9900),
  [13375] = {.count = 1, .reusable = true}, SHIFT(9902),
  [13377] = {.count = 1, .reusable = true}, SHIFT(9903),
  [13379] = {.count = 1, .reusable = true}, SHIFT(9904),
  [13381] = {.count = 1, .reusable = true}, SHIFT(9905),
  [13383] = {.count = 1, .reusable = true}, SHIFT(9906),
  [13385] = {.count = 1, .reusable = true}, SHIFT(9908),
  [13387] = {.count = 1, .reusable = true}, SHIFT(9909),
  [13389] = {.count = 1, .reusable = true}, SHIFT(9910),
  [13391] = {.count = 1, .reusable = true}, SHIFT(9911),
  [13393] = {.count = 1, .reusable = true}, SHIFT(6444),
  [13395] = {.count = 1, .reusable = false}, SHIFT(9913),
  [13397] = {.count = 1, .reusable = true}, SHIFT(9914),
  [13399] = {.count = 1, .reusable = true}, SHIFT(9915),
  [13401] = {.count = 1, .reusable = false}, SHIFT(9916),
  [13403] = {.count = 1, .reusable = false}, SHIFT(9917),
  [13405] = {.count = 1, .reusable = true}, SHIFT(9921),
  [13407] = {.count = 1, .reusable = false}, SHIFT(9918),
  [13409] = {.count = 1, .reusable = false}, SHIFT(9922),
  [13411] = {.count = 1, .reusable = false}, SHIFT(9925),
  [13413] = {.count = 1, .reusable = false}, SHIFT(9927),
  [13415] = {.count = 1, .reusable = true}, SHIFT(9929),
  [13417] = {.count = 1, .reusable = true}, SHIFT(9931),
  [13419] = {.count = 1, .reusable = true}, SHIFT(9932),
  [13421] = {.count = 1, .reusable = true}, SHIFT(9933),
  [13423] = {.count = 1, .reusable = true}, SHIFT(9936),
  [13425] = {.count = 1, .reusable = true}, SHIFT(9937),
  [13427] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(3828),
  [13430] = {.count = 1, .reusable = true}, SHIFT(9940),
  [13432] = {.count = 1, .reusable = false}, SHIFT(9940),
  [13434] = {.count = 1, .reusable = true}, SHIFT(8659),
  [13436] = {.count = 1, .reusable = true}, SHIFT(9944),
  [13438] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6535),
  [13441] = {.count = 1, .reusable = true}, SHIFT(9947),
  [13443] = {.count = 1, .reusable = true}, SHIFT(8694),
  [13445] = {.count = 1, .reusable = true}, SHIFT(9952),
  [13447] = {.count = 1, .reusable = true}, SHIFT(8712),
  [13449] = {.count = 1, .reusable = true}, SHIFT(9957),
  [13451] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6632),
  [13454] = {.count = 1, .reusable = true}, SHIFT(9958),
  [13456] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6664),
  [13459] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6683),
  [13462] = {.count = 1, .reusable = true}, SHIFT(8756),
  [13464] = {.count = 1, .reusable = true}, SHIFT(9963),
  [13466] = {.count = 1, .reusable = true}, SHIFT(9964),
  [13468] = {.count = 1, .reusable = true}, SHIFT(9967),
  [13470] = {.count = 1, .reusable = false}, SHIFT(9967),
  [13472] = {.count = 1, .reusable = true}, SHIFT(8781),
  [13474] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6743),
  [13477] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6753),
  [13480] = {.count = 1, .reusable = true}, SHIFT(9971),
  [13482] = {.count = 1, .reusable = true}, SHIFT(9972),
  [13484] = {.count = 1, .reusable = true}, SHIFT(9973),
  [13486] = {.count = 1, .reusable = true}, SHIFT(9974),
  [13488] = {.count = 1, .reusable = true}, SHIFT(9976),
  [13490] = {.count = 1, .reusable = true}, SHIFT(9978),
  [13492] = {.count = 1, .reusable = true}, SHIFT(9979),
  [13494] = {.count = 1, .reusable = true}, SHIFT(9980),
  [13496] = {.count = 1, .reusable = true}, SHIFT(9981),
  [13498] = {.count = 1, .reusable = true}, SHIFT(9982),
  [13500] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6823),
  [13503] = {.count = 1, .reusable = true}, SHIFT(9984),
  [13505] = {.count = 1, .reusable = true}, SHIFT(8838),
  [13507] = {.count = 1, .reusable = true}, SHIFT(9989),
  [13509] = {.count = 1, .reusable = true}, SHIFT(8856),
  [13511] = {.count = 1, .reusable = true}, SHIFT(9994),
  [13513] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6924),
  [13516] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 5),
  [13518] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 5),
  [13520] = {.count = 1, .reusable = true}, SHIFT(9995),
  [13522] = {.count = 1, .reusable = true}, SHIFT(9996),
  [13524] = {.count = 1, .reusable = false}, SHIFT(9996),
  [13526] = {.count = 1, .reusable = true}, SHIFT(9998),
  [13528] = {.count = 1, .reusable = true}, SHIFT(9999),
  [13530] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(6940),
  [13533] = {.count = 1, .reusable = true}, SHIFT(6946),
  [13535] = {.count = 1, .reusable = true}, SHIFT(10006),
  [13537] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6973),
  [13540] = {.count = 1, .reusable = true}, SHIFT(8912),
  [13542] = {.count = 1, .reusable = true}, SHIFT(8917),
  [13544] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7023),
  [13547] = {.count = 1, .reusable = true}, SHIFT(8922),
  [13549] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7041),
  [13552] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7071),
  [13555] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7099),
  [13558] = {.count = 1, .reusable = true}, SHIFT(8958),
  [13560] = {.count = 1, .reusable = true}, SHIFT(10032),
  [13562] = {.count = 1, .reusable = true}, SHIFT(10033),
  [13564] = {.count = 1, .reusable = true}, SHIFT(10034),
  [13566] = {.count = 1, .reusable = true}, SHIFT(10035),
  [13568] = {.count = 1, .reusable = true}, SHIFT(10036),
  [13570] = {.count = 1, .reusable = true}, SHIFT(10037),
  [13572] = {.count = 1, .reusable = true}, SHIFT(10038),
  [13574] = {.count = 1, .reusable = true}, SHIFT(10039),
  [13576] = {.count = 1, .reusable = true}, SHIFT(10040),
  [13578] = {.count = 1, .reusable = false}, SHIFT(10041),
  [13580] = {.count = 1, .reusable = false}, SHIFT(10042),
  [13582] = {.count = 1, .reusable = true}, SHIFT(10043),
  [13584] = {.count = 1, .reusable = true}, SHIFT(10044),
  [13586] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(7163),
  [13589] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7165),
  [13592] = {.count = 1, .reusable = true}, SHIFT(10046),
  [13594] = {.count = 1, .reusable = false}, SHIFT(10046),
  [13596] = {.count = 1, .reusable = true}, SHIFT(10049),
  [13598] = {.count = 1, .reusable = true}, SHIFT(10051),
  [13600] = {.count = 1, .reusable = true}, SHIFT(10052),
  [13602] = {.count = 1, .reusable = false}, SHIFT(10053),
  [13604] = {.count = 1, .reusable = true}, SHIFT(10055),
  [13606] = {.count = 1, .reusable = true}, SHIFT(10057),
  [13608] = {.count = 1, .reusable = true}, SHIFT(10059),
  [13610] = {.count = 1, .reusable = true}, SHIFT(10060),
  [13612] = {.count = 1, .reusable = false}, SHIFT(10060),
  [13614] = {.count = 1, .reusable = true}, SHIFT(10062),
  [13616] = {.count = 1, .reusable = true}, SHIFT(9026),
  [13618] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7213),
  [13621] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7221),
  [13624] = {.count = 1, .reusable = true}, SHIFT(9037),
  [13626] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7244),
  [13629] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7249),
  [13632] = {.count = 1, .reusable = true}, SHIFT(9047),
  [13634] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7282),
  [13637] = {.count = 1, .reusable = true}, SHIFT(10070),
  [13639] = {.count = 1, .reusable = true}, SHIFT(9057),
  [13641] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7327),
  [13644] = {.count = 1, .reusable = true}, SHIFT(7348),
  [13646] = {.count = 1, .reusable = true}, SHIFT(10095),
  [13648] = {.count = 1, .reusable = true}, SHIFT(7369),
  [13650] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7376),
  [13653] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 4),
  [13655] = {.count = 1, .reusable = true}, SHIFT(10120),
  [13657] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7431),
  [13660] = {.count = 1, .reusable = true}, REDUCE(sym_if, 7),
  [13662] = {.count = 1, .reusable = false}, REDUCE(sym_if, 7),
  [13664] = {.count = 1, .reusable = true}, SHIFT(9173),
  [13666] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7463),
  [13669] = {.count = 1, .reusable = true}, SHIFT(7497),
  [13671] = {.count = 1, .reusable = true}, SHIFT(10161),
  [13673] = {.count = 1, .reusable = true}, SHIFT(7518),
  [13675] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7525),
  [13678] = {.count = 1, .reusable = true}, SHIFT(10185),
  [13680] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7579),
  [13683] = {.count = 1, .reusable = true}, SHIFT(9289),
  [13685] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7623),
  [13688] = {.count = 1, .reusable = true}, SHIFT(9294),
  [13690] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7641),
  [13693] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7662),
  [13696] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7690),
  [13699] = {.count = 1, .reusable = true}, SHIFT(9327),
  [13701] = {.count = 1, .reusable = true}, SHIFT(9331),
  [13703] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7723),
  [13706] = {.count = 1, .reusable = true}, SHIFT(9337),
  [13708] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7749),
  [13711] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7777),
  [13714] = {.count = 1, .reusable = true}, SHIFT(10240),
  [13716] = {.count = 1, .reusable = false}, SHIFT(10241),
  [13718] = {.count = 1, .reusable = false}, SHIFT(10242),
  [13720] = {.count = 1, .reusable = false}, SHIFT(10243),
  [13722] = {.count = 1, .reusable = false}, SHIFT(10244),
  [13724] = {.count = 1, .reusable = false}, SHIFT(10240),
  [13726] = {.count = 1, .reusable = true}, SHIFT(10245),
  [13728] = {.count = 1, .reusable = false}, SHIFT(10245),
  [13730] = {.count = 1, .reusable = true}, SHIFT(10246),
  [13732] = {.count = 1, .reusable = false}, SHIFT(9365),
  [13734] = {.count = 1, .reusable = true}, SHIFT(10254),
  [13736] = {.count = 1, .reusable = true}, SHIFT(10256),
  [13738] = {.count = 1, .reusable = true}, SHIFT(10257),
  [13740] = {.count = 1, .reusable = true}, SHIFT(10258),
  [13742] = {.count = 1, .reusable = false}, SHIFT(10260),
  [13744] = {.count = 1, .reusable = false}, SHIFT(10266),
  [13746] = {.count = 1, .reusable = true}, SHIFT(10267),
  [13748] = {.count = 1, .reusable = true}, SHIFT(10268),
  [13750] = {.count = 1, .reusable = false}, SHIFT(10269),
  [13752] = {.count = 1, .reusable = false}, SHIFT(10270),
  [13754] = {.count = 1, .reusable = false}, SHIFT(10271),
  [13756] = {.count = 1, .reusable = true}, SHIFT(10272),
  [13758] = {.count = 1, .reusable = false}, SHIFT(10273),
  [13760] = {.count = 1, .reusable = true}, SHIFT(10273),
  [13762] = {.count = 1, .reusable = true}, SHIFT(10275),
  [13764] = {.count = 1, .reusable = true}, SHIFT(10276),
  [13766] = {.count = 1, .reusable = false}, SHIFT(10275),
  [13768] = {.count = 1, .reusable = true}, SHIFT(10271),
  [13770] = {.count = 1, .reusable = true}, SHIFT(10269),
  [13772] = {.count = 1, .reusable = true}, SHIFT(10277),
  [13774] = {.count = 1, .reusable = true}, SHIFT(10278),
  [13776] = {.count = 1, .reusable = true}, SHIFT(10279),
  [13778] = {.count = 1, .reusable = false}, SHIFT(10281),
  [13780] = {.count = 1, .reusable = true}, SHIFT(10287),
  [13782] = {.count = 1, .reusable = true}, SHIFT(10289),
  [13784] = {.count = 1, .reusable = false}, SHIFT(10289),
  [13786] = {.count = 1, .reusable = true}, SHIFT(10290),
  [13788] = {.count = 1, .reusable = false}, SHIFT(10254),
  [13790] = {.count = 1, .reusable = true}, REDUCE(sym_when, 5),
  [13792] = {.count = 1, .reusable = true}, SHIFT(10293),
  [13794] = {.count = 1, .reusable = true}, SHIFT(10310),
  [13796] = {.count = 1, .reusable = false}, SHIFT(10311),
  [13798] = {.count = 1, .reusable = false}, SHIFT(10312),
  [13800] = {.count = 1, .reusable = false}, SHIFT(10313),
  [13802] = {.count = 1, .reusable = false}, SHIFT(10314),
  [13804] = {.count = 1, .reusable = false}, SHIFT(10310),
  [13806] = {.count = 1, .reusable = true}, SHIFT(10315),
  [13808] = {.count = 1, .reusable = false}, SHIFT(10315),
  [13810] = {.count = 1, .reusable = true}, SHIFT(10316),
  [13812] = {.count = 1, .reusable = false}, SHIFT(10318),
  [13814] = {.count = 1, .reusable = true}, SHIFT(10318),
  [13816] = {.count = 1, .reusable = false}, SHIFT(9404),
  [13818] = {.count = 1, .reusable = true}, SHIFT(10325),
  [13820] = {.count = 1, .reusable = false}, SHIFT(10328),
  [13822] = {.count = 1, .reusable = true}, SHIFT(10329),
  [13824] = {.count = 1, .reusable = true}, SHIFT(10330),
  [13826] = {.count = 1, .reusable = false}, SHIFT(10331),
  [13828] = {.count = 1, .reusable = false}, SHIFT(10330),
  [13830] = {.count = 1, .reusable = false}, SHIFT(10332),
  [13832] = {.count = 1, .reusable = false}, SHIFT(10333),
  [13834] = {.count = 1, .reusable = true}, SHIFT(10334),
  [13836] = {.count = 1, .reusable = false}, SHIFT(10335),
  [13838] = {.count = 1, .reusable = true}, SHIFT(10335),
  [13840] = {.count = 1, .reusable = false}, SHIFT(10337),
  [13842] = {.count = 1, .reusable = false}, SHIFT(10338),
  [13844] = {.count = 1, .reusable = true}, SHIFT(10337),
  [13846] = {.count = 1, .reusable = true}, SHIFT(10333),
  [13848] = {.count = 1, .reusable = false}, SHIFT(10329),
  [13850] = {.count = 1, .reusable = true}, SHIFT(10340),
  [13852] = {.count = 1, .reusable = true}, SHIFT(10342),
  [13854] = {.count = 1, .reusable = false}, SHIFT(10342),
  [13856] = {.count = 1, .reusable = true}, SHIFT(10343),
  [13858] = {.count = 1, .reusable = false}, SHIFT(10325),
  [13860] = {.count = 1, .reusable = true}, SHIFT(10345),
  [13862] = {.count = 1, .reusable = true}, SHIFT(10346),
  [13864] = {.count = 1, .reusable = false}, SHIFT(10346),
  [13866] = {.count = 1, .reusable = true}, SHIFT(10347),
  [13868] = {.count = 1, .reusable = false}, SHIFT(10347),
  [13870] = {.count = 1, .reusable = true}, SHIFT(10348),
  [13872] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7826),
  [13875] = {.count = 1, .reusable = true}, SHIFT(9448),
  [13877] = {.count = 1, .reusable = true}, SHIFT(9453),
  [13879] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7862),
  [13882] = {.count = 1, .reusable = true}, SHIFT(9458),
  [13884] = {.count = 1, .reusable = true}, SHIFT(10376),
  [13886] = {.count = 1, .reusable = true}, SHIFT(10378),
  [13888] = {.count = 1, .reusable = true}, SHIFT(10381),
  [13890] = {.count = 1, .reusable = false}, SHIFT(10383),
  [13892] = {.count = 1, .reusable = true}, SHIFT(10385),
  [13894] = {.count = 1, .reusable = false}, SHIFT(10381),
  [13896] = {.count = 1, .reusable = true}, SHIFT(7911),
  [13898] = {.count = 1, .reusable = true}, SHIFT(10407),
  [13900] = {.count = 1, .reusable = true}, SHIFT(10408),
  [13902] = {.count = 1, .reusable = true}, SHIFT(10409),
  [13904] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(7933),
  [13907] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7935),
  [13910] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 6),
  [13912] = {.count = 1, .reusable = true}, SHIFT(9526),
  [13914] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7964),
  [13917] = {.count = 1, .reusable = true}, SHIFT(10417),
  [13919] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7990),
  [13922] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8009),
  [13925] = {.count = 1, .reusable = true}, SHIFT(9558),
  [13927] = {.count = 1, .reusable = true}, SHIFT(10422),
  [13929] = {.count = 1, .reusable = true}, SHIFT(9576),
  [13931] = {.count = 1, .reusable = true}, SHIFT(10427),
  [13933] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8070),
  [13936] = {.count = 1, .reusable = true}, SHIFT(10430),
  [13938] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8098),
  [13941] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8117),
  [13944] = {.count = 1, .reusable = true}, SHIFT(9620),
  [13946] = {.count = 1, .reusable = true}, SHIFT(10435),
  [13948] = {.count = 1, .reusable = true}, SHIFT(9638),
  [13950] = {.count = 1, .reusable = true}, SHIFT(10440),
  [13952] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8178),
  [13955] = {.count = 1, .reusable = true}, SHIFT(9654),
  [13957] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8199),
  [13960] = {.count = 1, .reusable = true}, SHIFT(10444),
  [13962] = {.count = 1, .reusable = true}, SHIFT(10447),
  [13964] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8263),
  [13967] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8269),
  [13970] = {.count = 1, .reusable = true}, SHIFT(10450),
  [13972] = {.count = 1, .reusable = true}, SHIFT(10451),
  [13974] = {.count = 1, .reusable = true}, SHIFT(10452),
  [13976] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8297),
  [13979] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 5),
  [13981] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 5),
  [13983] = {.count = 1, .reusable = true}, SHIFT(10453),
  [13985] = {.count = 1, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2),
  [13987] = {.count = 2, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2), SHIFT_REPEAT(8303),
  [13990] = {.count = 1, .reusable = true}, SHIFT(10454),
  [13992] = {.count = 1, .reusable = false}, SHIFT(10455),
  [13994] = {.count = 1, .reusable = false}, SHIFT(10456),
  [13996] = {.count = 1, .reusable = false}, SHIFT(10457),
  [13998] = {.count = 1, .reusable = false}, SHIFT(10458),
  [14000] = {.count = 1, .reusable = false}, SHIFT(10454),
  [14002] = {.count = 1, .reusable = true}, SHIFT(10459),
  [14004] = {.count = 1, .reusable = false}, SHIFT(10459),
  [14006] = {.count = 1, .reusable = true}, SHIFT(10460),
  [14008] = {.count = 1, .reusable = false}, SHIFT(10462),
  [14010] = {.count = 1, .reusable = true}, SHIFT(10462),
  [14012] = {.count = 1, .reusable = false}, SHIFT(9713),
  [14014] = {.count = 1, .reusable = true}, SHIFT(10469),
  [14016] = {.count = 1, .reusable = true}, SHIFT(10471),
  [14018] = {.count = 1, .reusable = true}, SHIFT(10472),
  [14020] = {.count = 1, .reusable = true}, SHIFT(10473),
  [14022] = {.count = 1, .reusable = false}, SHIFT(10475),
  [14024] = {.count = 1, .reusable = false}, SHIFT(10481),
  [14026] = {.count = 1, .reusable = true}, SHIFT(10482),
  [14028] = {.count = 1, .reusable = true}, SHIFT(10483),
  [14030] = {.count = 1, .reusable = false}, SHIFT(10484),
  [14032] = {.count = 1, .reusable = false}, SHIFT(10485),
  [14034] = {.count = 1, .reusable = false}, SHIFT(10486),
  [14036] = {.count = 1, .reusable = true}, SHIFT(10487),
  [14038] = {.count = 1, .reusable = false}, SHIFT(10488),
  [14040] = {.count = 1, .reusable = true}, SHIFT(10488),
  [14042] = {.count = 1, .reusable = true}, SHIFT(10490),
  [14044] = {.count = 1, .reusable = true}, SHIFT(10491),
  [14046] = {.count = 1, .reusable = false}, SHIFT(10490),
  [14048] = {.count = 1, .reusable = true}, SHIFT(10486),
  [14050] = {.count = 1, .reusable = true}, SHIFT(10484),
  [14052] = {.count = 1, .reusable = true}, SHIFT(10492),
  [14054] = {.count = 1, .reusable = true}, SHIFT(10493),
  [14056] = {.count = 1, .reusable = true}, SHIFT(10494),
  [14058] = {.count = 1, .reusable = false}, SHIFT(10496),
  [14060] = {.count = 1, .reusable = true}, SHIFT(10502),
  [14062] = {.count = 1, .reusable = true}, SHIFT(10504),
  [14064] = {.count = 1, .reusable = false}, SHIFT(10504),
  [14066] = {.count = 1, .reusable = true}, SHIFT(10505),
  [14068] = {.count = 1, .reusable = false}, SHIFT(10469),
  [14070] = {.count = 1, .reusable = false}, SHIFT(9733),
  [14072] = {.count = 1, .reusable = true}, SHIFT(10517),
  [14074] = {.count = 1, .reusable = false}, SHIFT(10518),
  [14076] = {.count = 1, .reusable = false}, SHIFT(10519),
  [14078] = {.count = 1, .reusable = false}, SHIFT(10520),
  [14080] = {.count = 1, .reusable = false}, SHIFT(10521),
  [14082] = {.count = 1, .reusable = false}, SHIFT(10517),
  [14084] = {.count = 1, .reusable = true}, SHIFT(10522),
  [14086] = {.count = 1, .reusable = false}, SHIFT(10522),
  [14088] = {.count = 1, .reusable = true}, SHIFT(10523),
  [14090] = {.count = 1, .reusable = false}, SHIFT(10525),
  [14092] = {.count = 1, .reusable = true}, SHIFT(10525),
  [14094] = {.count = 1, .reusable = false}, SHIFT(9743),
  [14096] = {.count = 1, .reusable = true}, SHIFT(10532),
  [14098] = {.count = 1, .reusable = false}, SHIFT(10535),
  [14100] = {.count = 1, .reusable = true}, SHIFT(10536),
  [14102] = {.count = 1, .reusable = true}, SHIFT(10537),
  [14104] = {.count = 1, .reusable = false}, SHIFT(10538),
  [14106] = {.count = 1, .reusable = false}, SHIFT(10537),
  [14108] = {.count = 1, .reusable = false}, SHIFT(10539),
  [14110] = {.count = 1, .reusable = false}, SHIFT(10540),
  [14112] = {.count = 1, .reusable = true}, SHIFT(10541),
  [14114] = {.count = 1, .reusable = false}, SHIFT(10542),
  [14116] = {.count = 1, .reusable = true}, SHIFT(10542),
  [14118] = {.count = 1, .reusable = false}, SHIFT(10544),
  [14120] = {.count = 1, .reusable = false}, SHIFT(10545),
  [14122] = {.count = 1, .reusable = true}, SHIFT(10544),
  [14124] = {.count = 1, .reusable = true}, SHIFT(10540),
  [14126] = {.count = 1, .reusable = false}, SHIFT(10536),
  [14128] = {.count = 1, .reusable = true}, SHIFT(10547),
  [14130] = {.count = 1, .reusable = true}, SHIFT(10549),
  [14132] = {.count = 1, .reusable = false}, SHIFT(10549),
  [14134] = {.count = 1, .reusable = true}, SHIFT(10550),
  [14136] = {.count = 1, .reusable = false}, SHIFT(10532),
  [14138] = {.count = 1, .reusable = true}, SHIFT(10552),
  [14140] = {.count = 1, .reusable = true}, SHIFT(10558),
  [14142] = {.count = 1, .reusable = true}, SHIFT(10559),
  [14144] = {.count = 1, .reusable = true}, SHIFT(10561),
  [14146] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 6),
  [14148] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 6),
  [14150] = {.count = 1, .reusable = true}, SHIFT(9773),
  [14152] = {.count = 1, .reusable = true}, SHIFT(10566),
  [14154] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8372),
  [14157] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8391),
  [14160] = {.count = 1, .reusable = true}, SHIFT(9805),
  [14162] = {.count = 1, .reusable = true}, SHIFT(10571),
  [14164] = {.count = 1, .reusable = true}, SHIFT(9824),
  [14166] = {.count = 1, .reusable = true}, SHIFT(10576),
  [14168] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8452),
  [14171] = {.count = 1, .reusable = true}, SHIFT(10577),
  [14173] = {.count = 1, .reusable = true}, SHIFT(10578),
  [14175] = {.count = 1, .reusable = true}, SHIFT(10580),
  [14177] = {.count = 1, .reusable = true}, SHIFT(10582),
  [14179] = {.count = 1, .reusable = true}, SHIFT(10583),
  [14181] = {.count = 1, .reusable = true}, SHIFT(10584),
  [14183] = {.count = 1, .reusable = true}, SHIFT(10585),
  [14185] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8504),
  [14188] = {.count = 1, .reusable = true}, SHIFT(10586),
  [14190] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8532),
  [14193] = {.count = 1, .reusable = true}, SHIFT(10587),
  [14195] = {.count = 1, .reusable = true}, SHIFT(9893),
  [14197] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8587),
  [14200] = {.count = 1, .reusable = true}, SHIFT(10590),
  [14202] = {.count = 1, .reusable = true}, SHIFT(10591),
  [14204] = {.count = 1, .reusable = true}, SHIFT(10592),
  [14206] = {.count = 1, .reusable = true}, SHIFT(10593),
  [14208] = {.count = 1, .reusable = true}, SHIFT(10594),
  [14210] = {.count = 1, .reusable = true}, SHIFT(10595),
  [14212] = {.count = 1, .reusable = true}, SHIFT(10596),
  [14214] = {.count = 1, .reusable = false}, SHIFT(10597),
  [14216] = {.count = 1, .reusable = false}, SHIFT(10598),
  [14218] = {.count = 1, .reusable = true}, SHIFT(10599),
  [14220] = {.count = 1, .reusable = false}, SHIFT(10599),
  [14222] = {.count = 1, .reusable = true}, SHIFT(10602),
  [14224] = {.count = 1, .reusable = true}, SHIFT(10604),
  [14226] = {.count = 1, .reusable = true}, SHIFT(10605),
  [14228] = {.count = 1, .reusable = false}, SHIFT(10606),
  [14230] = {.count = 1, .reusable = true}, SHIFT(10608),
  [14232] = {.count = 1, .reusable = true}, SHIFT(10610),
  [14234] = {.count = 1, .reusable = true}, SHIFT(9938),
  [14236] = {.count = 1, .reusable = true}, SHIFT(10615),
  [14238] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8659),
  [14241] = {.count = 1, .reusable = true}, SHIFT(9948),
  [14243] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8694),
  [14246] = {.count = 1, .reusable = true}, SHIFT(9953),
  [14248] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8712),
  [14251] = {.count = 1, .reusable = true}, SHIFT(9959),
  [14253] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8756),
  [14256] = {.count = 1, .reusable = true}, SHIFT(9965),
  [14258] = {.count = 1, .reusable = true}, SHIFT(10626),
  [14260] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8781),
  [14263] = {.count = 1, .reusable = true}, SHIFT(10627),
  [14265] = {.count = 1, .reusable = true}, SHIFT(9985),
  [14267] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8838),
  [14270] = {.count = 1, .reusable = true}, SHIFT(9990),
  [14272] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8856),
  [14275] = {.count = 1, .reusable = true}, SHIFT(10633),
  [14277] = {.count = 1, .reusable = false}, SHIFT(10633),
  [14279] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8889),
  [14282] = {.count = 1, .reusable = true}, SHIFT(10007),
  [14284] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8912),
  [14287] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8917),
  [14290] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8922),
  [14293] = {.count = 1, .reusable = true}, SHIFT(10637),
  [14295] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8958),
  [14298] = {.count = 1, .reusable = true}, SHIFT(10640),
  [14300] = {.count = 1, .reusable = true}, SHIFT(10641),
  [14302] = {.count = 1, .reusable = true}, SHIFT(10643),
  [14304] = {.count = 1, .reusable = true}, SHIFT(10645),
  [14306] = {.count = 1, .reusable = true}, SHIFT(10646),
  [14308] = {.count = 1, .reusable = true}, SHIFT(10647),
  [14310] = {.count = 1, .reusable = true}, SHIFT(10648),
  [14312] = {.count = 1, .reusable = true}, SHIFT(10649),
  [14314] = {.count = 1, .reusable = false}, SHIFT(10649),
  [14316] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9026),
  [14319] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9037),
  [14322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9047),
  [14325] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9057),
  [14328] = {.count = 1, .reusable = true}, SHIFT(10653),
  [14330] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9085),
  [14333] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9104),
  [14336] = {.count = 1, .reusable = true}, SHIFT(10102),
  [14338] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 5),
  [14340] = {.count = 1, .reusable = true}, SHIFT(10658),
  [14342] = {.count = 1, .reusable = true}, SHIFT(10121),
  [14344] = {.count = 1, .reusable = true}, SHIFT(10663),
  [14346] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9167),
  [14349] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9173),
  [14352] = {.count = 1, .reusable = true}, SHIFT(10666),
  [14354] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9202),
  [14357] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9221),
  [14360] = {.count = 1, .reusable = true}, SHIFT(10168),
  [14362] = {.count = 1, .reusable = true}, SHIFT(10671),
  [14364] = {.count = 1, .reusable = true}, SHIFT(10186),
  [14366] = {.count = 1, .reusable = true}, SHIFT(10676),
  [14368] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9282),
  [14371] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9289),
  [14374] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9294),
  [14377] = {.count = 1, .reusable = true}, SHIFT(10677),
  [14379] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9327),
  [14382] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9331),
  [14385] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9337),
  [14388] = {.count = 1, .reusable = true}, SHIFT(10680),
  [14390] = {.count = 1, .reusable = true}, SHIFT(10687),
  [14392] = {.count = 1, .reusable = true}, SHIFT(10688),
  [14394] = {.count = 1, .reusable = false}, SHIFT(10689),
  [14396] = {.count = 1, .reusable = false}, SHIFT(10690),
  [14398] = {.count = 1, .reusable = false}, SHIFT(10691),
  [14400] = {.count = 1, .reusable = true}, SHIFT(10692),
  [14402] = {.count = 1, .reusable = false}, SHIFT(10693),
  [14404] = {.count = 1, .reusable = true}, SHIFT(10693),
  [14406] = {.count = 1, .reusable = true}, SHIFT(10695),
  [14408] = {.count = 1, .reusable = true}, SHIFT(10696),
  [14410] = {.count = 1, .reusable = false}, SHIFT(10695),
  [14412] = {.count = 1, .reusable = true}, SHIFT(10691),
  [14414] = {.count = 1, .reusable = true}, SHIFT(10689),
  [14416] = {.count = 1, .reusable = true}, SHIFT(10697),
  [14418] = {.count = 1, .reusable = false}, SHIFT(10697),
  [14420] = {.count = 1, .reusable = true}, SHIFT(10698),
  [14422] = {.count = 1, .reusable = true}, SHIFT(10703),
  [14424] = {.count = 1, .reusable = false}, SHIFT(10705),
  [14426] = {.count = 1, .reusable = true}, SHIFT(10707),
  [14428] = {.count = 1, .reusable = false}, SHIFT(10703),
  [14430] = {.count = 1, .reusable = true}, SHIFT(10722),
  [14432] = {.count = 1, .reusable = false}, SHIFT(10724),
  [14434] = {.count = 1, .reusable = true}, SHIFT(10726),
  [14436] = {.count = 1, .reusable = false}, SHIFT(10722),
  [14438] = {.count = 1, .reusable = true}, SHIFT(9367),
  [14440] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(10737),
  [14443] = {.count = 1, .reusable = true}, SHIFT(10738),
  [14445] = {.count = 1, .reusable = true}, SHIFT(10741),
  [14447] = {.count = 1, .reusable = true}, SHIFT(10742),
  [14449] = {.count = 1, .reusable = false}, SHIFT(10743),
  [14451] = {.count = 1, .reusable = false}, SHIFT(10742),
  [14453] = {.count = 1, .reusable = false}, SHIFT(10744),
  [14455] = {.count = 1, .reusable = false}, SHIFT(10745),
  [14457] = {.count = 1, .reusable = true}, SHIFT(10746),
  [14459] = {.count = 1, .reusable = false}, SHIFT(10747),
  [14461] = {.count = 1, .reusable = true}, SHIFT(10747),
  [14463] = {.count = 1, .reusable = false}, SHIFT(10749),
  [14465] = {.count = 1, .reusable = false}, SHIFT(10750),
  [14467] = {.count = 1, .reusable = true}, SHIFT(10749),
  [14469] = {.count = 1, .reusable = true}, SHIFT(10745),
  [14471] = {.count = 1, .reusable = false}, SHIFT(10741),
  [14473] = {.count = 1, .reusable = true}, SHIFT(10751),
  [14475] = {.count = 1, .reusable = false}, SHIFT(10751),
  [14477] = {.count = 1, .reusable = true}, SHIFT(10752),
  [14479] = {.count = 1, .reusable = true}, SHIFT(9406),
  [14481] = {.count = 1, .reusable = true}, SHIFT(10777),
  [14483] = {.count = 1, .reusable = true}, SHIFT(10778),
  [14485] = {.count = 1, .reusable = false}, SHIFT(10779),
  [14487] = {.count = 1, .reusable = false}, SHIFT(10780),
  [14489] = {.count = 1, .reusable = false}, SHIFT(10781),
  [14491] = {.count = 1, .reusable = true}, SHIFT(10782),
  [14493] = {.count = 1, .reusable = false}, SHIFT(10783),
  [14495] = {.count = 1, .reusable = true}, SHIFT(10783),
  [14497] = {.count = 1, .reusable = true}, SHIFT(10785),
  [14499] = {.count = 1, .reusable = true}, SHIFT(10786),
  [14501] = {.count = 1, .reusable = false}, SHIFT(10785),
  [14503] = {.count = 1, .reusable = true}, SHIFT(10781),
  [14505] = {.count = 1, .reusable = true}, SHIFT(10779),
  [14507] = {.count = 1, .reusable = true}, SHIFT(10787),
  [14509] = {.count = 1, .reusable = true}, SHIFT(10789),
  [14511] = {.count = 1, .reusable = false}, SHIFT(10789),
  [14513] = {.count = 1, .reusable = true}, SHIFT(10790),
  [14515] = {.count = 1, .reusable = true}, REDUCE(sym_when, 6),
  [14517] = {.count = 1, .reusable = true}, SHIFT(10791),
  [14519] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9448),
  [14522] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9453),
  [14525] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9458),
  [14528] = {.count = 1, .reusable = true}, SHIFT(10794),
  [14530] = {.count = 1, .reusable = true}, SHIFT(9470),
  [14532] = {.count = 1, .reusable = true}, SHIFT(10801),
  [14534] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9497),
  [14537] = {.count = 1, .reusable = true}, SHIFT(10411),
  [14539] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9526),
  [14542] = {.count = 1, .reusable = true}, SHIFT(10418),
  [14544] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9558),
  [14547] = {.count = 1, .reusable = true}, SHIFT(10423),
  [14549] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9576),
  [14552] = {.count = 1, .reusable = true}, SHIFT(10431),
  [14554] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9620),
  [14557] = {.count = 1, .reusable = true}, SHIFT(10436),
  [14559] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9638),
  [14562] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9654),
  [14565] = {.count = 1, .reusable = true}, SHIFT(10445),
  [14567] = {.count = 1, .reusable = true}, SHIFT(10448),
  [14569] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 6),
  [14571] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 6),
  [14573] = {.count = 1, .reusable = true}, SHIFT(10822),
  [14575] = {.count = 1, .reusable = true}, SHIFT(10823),
  [14577] = {.count = 1, .reusable = false}, SHIFT(10824),
  [14579] = {.count = 1, .reusable = false}, SHIFT(10825),
  [14581] = {.count = 1, .reusable = false}, SHIFT(10826),
  [14583] = {.count = 1, .reusable = true}, SHIFT(10827),
  [14585] = {.count = 1, .reusable = false}, SHIFT(10828),
  [14587] = {.count = 1, .reusable = true}, SHIFT(10828),
  [14589] = {.count = 1, .reusable = true}, SHIFT(10830),
  [14591] = {.count = 1, .reusable = true}, SHIFT(10831),
  [14593] = {.count = 1, .reusable = false}, SHIFT(10830),
  [14595] = {.count = 1, .reusable = true}, SHIFT(10826),
  [14597] = {.count = 1, .reusable = true}, SHIFT(10824),
  [14599] = {.count = 1, .reusable = true}, SHIFT(10832),
  [14601] = {.count = 1, .reusable = false}, SHIFT(10832),
  [14603] = {.count = 1, .reusable = true}, SHIFT(10833),
  [14605] = {.count = 1, .reusable = true}, SHIFT(10838),
  [14607] = {.count = 1, .reusable = false}, SHIFT(10840),
  [14609] = {.count = 1, .reusable = true}, SHIFT(10842),
  [14611] = {.count = 1, .reusable = false}, SHIFT(10838),
  [14613] = {.count = 1, .reusable = true}, SHIFT(10857),
  [14615] = {.count = 1, .reusable = false}, SHIFT(10859),
  [14617] = {.count = 1, .reusable = true}, SHIFT(10861),
  [14619] = {.count = 1, .reusable = false}, SHIFT(10857),
  [14621] = {.count = 1, .reusable = true}, SHIFT(9715),
  [14623] = {.count = 1, .reusable = true}, SHIFT(10871),
  [14625] = {.count = 1, .reusable = true}, SHIFT(10874),
  [14627] = {.count = 1, .reusable = true}, SHIFT(10875),
  [14629] = {.count = 1, .reusable = false}, SHIFT(10876),
  [14631] = {.count = 1, .reusable = false}, SHIFT(10875),
  [14633] = {.count = 1, .reusable = false}, SHIFT(10877),
  [14635] = {.count = 1, .reusable = false}, SHIFT(10878),
  [14637] = {.count = 1, .reusable = true}, SHIFT(10879),
  [14639] = {.count = 1, .reusable = false}, SHIFT(10880),
  [14641] = {.count = 1, .reusable = true}, SHIFT(10880),
  [14643] = {.count = 1, .reusable = false}, SHIFT(10882),
  [14645] = {.count = 1, .reusable = false}, SHIFT(10883),
  [14647] = {.count = 1, .reusable = true}, SHIFT(10882),
  [14649] = {.count = 1, .reusable = true}, SHIFT(10878),
  [14651] = {.count = 1, .reusable = false}, SHIFT(10874),
  [14653] = {.count = 1, .reusable = true}, SHIFT(10884),
  [14655] = {.count = 1, .reusable = false}, SHIFT(10884),
  [14657] = {.count = 1, .reusable = true}, SHIFT(10885),
  [14659] = {.count = 1, .reusable = true}, SHIFT(9745),
  [14661] = {.count = 1, .reusable = true}, SHIFT(10910),
  [14663] = {.count = 1, .reusable = true}, SHIFT(10912),
  [14665] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9773),
  [14668] = {.count = 1, .reusable = true}, SHIFT(10567),
  [14670] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9805),
  [14673] = {.count = 1, .reusable = true}, SHIFT(10572),
  [14675] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9824),
  [14678] = {.count = 1, .reusable = true}, SHIFT(10919),
  [14680] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9893),
  [14683] = {.count = 1, .reusable = true}, SHIFT(10921),
  [14685] = {.count = 1, .reusable = true}, SHIFT(10922),
  [14687] = {.count = 1, .reusable = true}, SHIFT(10924),
  [14689] = {.count = 1, .reusable = true}, SHIFT(10926),
  [14691] = {.count = 1, .reusable = true}, SHIFT(10927),
  [14693] = {.count = 1, .reusable = true}, SHIFT(10928),
  [14695] = {.count = 1, .reusable = true}, SHIFT(10929),
  [14697] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9938),
  [14700] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9948),
  [14703] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9953),
  [14706] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9959),
  [14709] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9965),
  [14712] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9985),
  [14715] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9990),
  [14718] = {.count = 1, .reusable = true}, SHIFT(10930),
  [14720] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10007),
  [14723] = {.count = 1, .reusable = true}, SHIFT(10638),
  [14725] = {.count = 1, .reusable = true}, SHIFT(10933),
  [14727] = {.count = 1, .reusable = true}, SHIFT(10934),
  [14729] = {.count = 1, .reusable = true}, SHIFT(10654),
  [14731] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10102),
  [14734] = {.count = 1, .reusable = true}, SHIFT(10659),
  [14736] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10121),
  [14739] = {.count = 1, .reusable = true}, SHIFT(10667),
  [14741] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10168),
  [14744] = {.count = 1, .reusable = true}, SHIFT(10672),
  [14746] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10186),
  [14749] = {.count = 1, .reusable = true}, SHIFT(10678),
  [14751] = {.count = 1, .reusable = true}, SHIFT(10681),
  [14753] = {.count = 1, .reusable = true}, SHIFT(10259),
  [14755] = {.count = 1, .reusable = true}, SHIFT(10971),
  [14757] = {.count = 1, .reusable = true}, SHIFT(10280),
  [14759] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10287),
  [14762] = {.count = 1, .reusable = true}, SHIFT(10995),
  [14764] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10340),
  [14767] = {.count = 1, .reusable = true}, SHIFT(10792),
  [14769] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10385),
  [14772] = {.count = 1, .reusable = true}, SHIFT(10802),
  [14774] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10411),
  [14777] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10418),
  [14780] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10423),
  [14783] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10431),
  [14786] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10436),
  [14789] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10445),
  [14792] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10448),
  [14795] = {.count = 1, .reusable = true}, SHIFT(10474),
  [14797] = {.count = 1, .reusable = true}, SHIFT(11035),
  [14799] = {.count = 1, .reusable = true}, SHIFT(10495),
  [14801] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10502),
  [14804] = {.count = 1, .reusable = true}, SHIFT(11059),
  [14806] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10547),
  [14809] = {.count = 1, .reusable = true}, SHIFT(10908),
  [14811] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 7),
  [14813] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 7),
  [14815] = {.count = 1, .reusable = true}, SHIFT(11063),
  [14817] = {.count = 1, .reusable = true}, SHIFT(11064),
  [14819] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10567),
  [14822] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10572),
  [14825] = {.count = 1, .reusable = true}, SHIFT(11065),
  [14827] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10638),
  [14830] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10654),
  [14833] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10659),
  [14836] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10667),
  [14839] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10672),
  [14842] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10678),
  [14845] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10681),
  [14848] = {.count = 1, .reusable = true}, SHIFT(11068),
  [14850] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10707),
  [14853] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10726),
  [14856] = {.count = 1, .reusable = true}, SHIFT(10978),
  [14858] = {.count = 1, .reusable = true}, SHIFT(11073),
  [14860] = {.count = 1, .reusable = true}, SHIFT(10996),
  [14862] = {.count = 1, .reusable = true}, SHIFT(11078),
  [14864] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10787),
  [14867] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10792),
  [14870] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10802),
  [14873] = {.count = 1, .reusable = true}, SHIFT(11079),
  [14875] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10842),
  [14878] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10861),
  [14881] = {.count = 1, .reusable = true}, SHIFT(11042),
  [14883] = {.count = 1, .reusable = true}, SHIFT(11084),
  [14885] = {.count = 1, .reusable = true}, SHIFT(11060),
  [14887] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10908),
  [14890] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 8),
  [14892] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 8),
  [14894] = {.count = 1, .reusable = true}, SHIFT(11069),
  [14896] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10978),
  [14899] = {.count = 1, .reusable = true}, SHIFT(11074),
  [14901] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10996),
  [14904] = {.count = 1, .reusable = true}, SHIFT(11080),
  [14906] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11042),
  [14909] = {.count = 1, .reusable = true}, SHIFT(11085),
  [14911] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11060),
  [14914] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11069),
  [14917] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11074),
  [14920] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11080),
  [14923] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11085),
};

void *tree_sitter_ruby_external_scanner_create();
void tree_sitter_ruby_external_scanner_destroy(void *);
bool tree_sitter_ruby_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ruby_external_scanner_serialize(void *, char *);
void tree_sitter_ruby_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ruby() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_ruby_external_scanner_create,
      tree_sitter_ruby_external_scanner_destroy,
      tree_sitter_ruby_external_scanner_scan,
      tree_sitter_ruby_external_scanner_serialize,
      tree_sitter_ruby_external_scanner_deserialize,
    },
  };
  return &language;
}
